#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 8
#define STATE_COUNT 3206
#define SYMBOL_COUNT 144
#define ALIAS_COUNT 5
#define TOKEN_COUNT 90
#define EXTERNAL_TOKEN_COUNT 12
#define MAX_ALIAS_SEQUENCE_LENGTH 8

enum {
  sym_heredoc_start = 1,
  sym__simple_heredoc_body = 2,
  sym__heredoc_body_beginning = 3,
  sym__heredoc_body_middle = 4,
  sym__heredoc_body_end = 5,
  sym_file_descriptor = 6,
  sym__empty_value = 7,
  sym__concat = 8,
  sym_variable_name = 9,
  anon_sym_for = 10,
  anon_sym_in = 11,
  anon_sym_while = 12,
  anon_sym_do = 13,
  anon_sym_done = 14,
  anon_sym_if = 15,
  anon_sym_then = 16,
  anon_sym_fi = 17,
  anon_sym_elif = 18,
  anon_sym_else = 19,
  anon_sym_case = 20,
  anon_sym_esac = 21,
  anon_sym_PIPE = 22,
  anon_sym_RPAREN = 23,
  anon_sym_SEMI_SEMI = 24,
  anon_sym_function = 25,
  anon_sym_LPAREN = 26,
  anon_sym_LBRACE = 27,
  anon_sym_RBRACE = 28,
  anon_sym_PIPE_AMP = 29,
  anon_sym_AMP_AMP = 30,
  anon_sym_PIPE_PIPE = 31,
  anon_sym_BANG = 32,
  anon_sym_LBRACK = 33,
  anon_sym_RBRACK = 34,
  anon_sym_LBRACK_LBRACK = 35,
  anon_sym_RBRACK_RBRACK = 36,
  anon_sym_declare = 37,
  anon_sym_typeset = 38,
  anon_sym_export = 39,
  anon_sym_readonly = 40,
  anon_sym_local = 41,
  anon_sym_unset = 42,
  anon_sym_unsetenv = 43,
  anon_sym_EQ_TILDE = 44,
  anon_sym_EQ_EQ = 45,
  anon_sym_EQ = 46,
  anon_sym_PLUS_EQ = 47,
  anon_sym_LT = 48,
  anon_sym_GT = 49,
  anon_sym_GT_GT = 50,
  anon_sym_AMP_GT = 51,
  anon_sym_AMP_GT_GT = 52,
  anon_sym_LT_AMP = 53,
  anon_sym_GT_AMP = 54,
  anon_sym_LT_LT = 55,
  anon_sym_LT_LT_DASH = 56,
  anon_sym_LT_LT_LT = 57,
  anon_sym_BANG_EQ = 58,
  sym__special_characters = 59,
  anon_sym_DQUOTE = 60,
  anon_sym_DOLLAR = 61,
  sym__string_content = 62,
  sym_raw_string = 63,
  anon_sym_POUND = 64,
  anon_sym_DOLLAR_LBRACE = 65,
  aux_sym_SLASH = 66,
  anon_sym_COLON = 67,
  anon_sym_COLON_QMARK = 68,
  anon_sym_COLON_DASH = 69,
  anon_sym_PERCENT = 70,
  anon_sym_DASH = 71,
  anon_sym_DOLLAR_LPAREN = 72,
  anon_sym_BQUOTE = 73,
  anon_sym_LT_LPAREN = 74,
  anon_sym_GT_LPAREN = 75,
  sym_comment = 76,
  aux_sym_SLASH_BSLASHw_PLUS_SLASH = 77,
  anon_sym_STAR = 78,
  anon_sym_AT = 79,
  anon_sym_QMARK = 80,
  anon_sym_0 = 81,
  anon_sym__ = 82,
  sym_word = 83,
  sym_test_operator = 84,
  sym_regex = 85,
  sym_regex_without_right_brace = 86,
  anon_sym_SEMI = 87,
  anon_sym_LF = 88,
  anon_sym_AMP = 89,
  sym_program = 90,
  sym__terminated_statement = 91,
  sym_for_statement = 92,
  sym_while_statement = 93,
  sym_do_group = 94,
  sym_if_statement = 95,
  sym_elif_clause = 96,
  sym_else_clause = 97,
  sym_case_statement = 98,
  sym_case_item = 99,
  sym_last_case_item = 100,
  sym_function_definition = 101,
  sym_compound_statement = 102,
  sym_subshell = 103,
  sym_pipeline = 104,
  sym_list = 105,
  sym_negated_command = 106,
  sym_test_command = 107,
  sym_declaration_command = 108,
  sym_unset_command = 109,
  sym_command = 110,
  sym_command_name = 111,
  sym_variable_assignment = 112,
  sym_subscript = 113,
  sym_file_redirect = 114,
  sym_heredoc_redirect = 115,
  sym_heredoc_body = 116,
  sym_herestring_redirect = 117,
  sym__expression = 118,
  sym_binary_expression = 119,
  sym_unary_expression = 120,
  sym_parenthesized_expression = 121,
  sym_concatenation = 122,
  sym_string = 123,
  sym_array = 124,
  sym_simple_expansion = 125,
  sym_string_expansion = 126,
  sym_expansion = 127,
  sym_command_substitution = 128,
  sym_process_substitution = 129,
  aux_sym_program_repeat1 = 130,
  aux_sym_for_statement_repeat1 = 131,
  aux_sym_while_statement_repeat1 = 132,
  aux_sym_if_statement_repeat1 = 133,
  aux_sym_case_statement_repeat1 = 134,
  aux_sym_case_item_repeat1 = 135,
  aux_sym_declaration_command_repeat1 = 136,
  aux_sym_unset_command_repeat1 = 137,
  aux_sym_command_repeat1 = 138,
  aux_sym_command_repeat2 = 139,
  aux_sym_heredoc_body_repeat1 = 140,
  aux_sym_concatenation_repeat1 = 141,
  aux_sym_string_repeat1 = 142,
  aux_sym_expansion_repeat1 = 143,
  alias_sym_case_item = 144,
  alias_sym_regex = 145,
  alias_sym_special_variable_name = 146,
  alias_sym_variable_name = 147,
  alias_sym_word = 148,
};

static const char *ts_symbol_names[] = {
  [sym_heredoc_start] = "heredoc_start",
  [sym__simple_heredoc_body] = "_simple_heredoc_body",
  [sym__heredoc_body_beginning] = "_heredoc_body_beginning",
  [sym__heredoc_body_middle] = "_heredoc_body_middle",
  [sym__heredoc_body_end] = "_heredoc_body_end",
  [sym_file_descriptor] = "file_descriptor",
  [sym__empty_value] = "_empty_value",
  [sym__concat] = "_concat",
  [sym_variable_name] = "variable_name",
  [ts_builtin_sym_end] = "END",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_done] = "done",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_fi] = "fi",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_case] = "case",
  [anon_sym_esac] = "esac",
  [anon_sym_PIPE] = "|",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SEMI_SEMI] = ";;",
  [anon_sym_function] = "function",
  [anon_sym_LPAREN] = "(",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_PIPE_AMP] = "|&",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_BANG] = "!",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym_declare] = "declare",
  [anon_sym_typeset] = "typeset",
  [anon_sym_export] = "export",
  [anon_sym_readonly] = "readonly",
  [anon_sym_local] = "local",
  [anon_sym_unset] = "unset",
  [anon_sym_unsetenv] = "unsetenv",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_GT] = "&>",
  [anon_sym_AMP_GT_GT] = "&>>",
  [anon_sym_LT_AMP] = "<&",
  [anon_sym_GT_AMP] = ">&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_LT_LT_DASH] = "<<-",
  [anon_sym_LT_LT_LT] = "<<<",
  [anon_sym_BANG_EQ] = "!=",
  [sym__special_characters] = "_special_characters",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_DOLLAR] = "$",
  [sym__string_content] = "_string_content",
  [sym_raw_string] = "raw_string",
  [anon_sym_POUND] = "#",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [aux_sym_SLASH] = "/",
  [anon_sym_COLON] = ":",
  [anon_sym_COLON_QMARK] = ":?",
  [anon_sym_COLON_DASH] = ":-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DASH] = "-",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_LT_LPAREN] = "<(",
  [anon_sym_GT_LPAREN] = ">(",
  [sym_comment] = "comment",
  [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = "/\\w+/",
  [anon_sym_STAR] = "*",
  [anon_sym_AT] = "@",
  [anon_sym_QMARK] = "?",
  [anon_sym_0] = "0",
  [anon_sym__] = "_",
  [sym_word] = "word",
  [sym_test_operator] = "test_operator",
  [sym_regex] = "regex",
  [sym_regex_without_right_brace] = "regex_without_right_brace",
  [anon_sym_SEMI] = ";",
  [anon_sym_LF] = "\n",
  [anon_sym_AMP] = "&",
  [sym_program] = "program",
  [sym__terminated_statement] = "_terminated_statement",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_group] = "do_group",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_case_statement] = "case_statement",
  [sym_case_item] = "case_item",
  [sym_last_case_item] = "last_case_item",
  [sym_function_definition] = "function_definition",
  [sym_compound_statement] = "compound_statement",
  [sym_subshell] = "subshell",
  [sym_pipeline] = "pipeline",
  [sym_list] = "list",
  [sym_negated_command] = "negated_command",
  [sym_test_command] = "test_command",
  [sym_declaration_command] = "declaration_command",
  [sym_unset_command] = "unset_command",
  [sym_command] = "command",
  [sym_command_name] = "command_name",
  [sym_variable_assignment] = "variable_assignment",
  [sym_subscript] = "subscript",
  [sym_file_redirect] = "file_redirect",
  [sym_heredoc_redirect] = "heredoc_redirect",
  [sym_heredoc_body] = "heredoc_body",
  [sym_herestring_redirect] = "herestring_redirect",
  [sym__expression] = "_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_concatenation] = "concatenation",
  [sym_string] = "string",
  [sym_array] = "array",
  [sym_simple_expansion] = "simple_expansion",
  [sym_string_expansion] = "string_expansion",
  [sym_expansion] = "expansion",
  [sym_command_substitution] = "command_substitution",
  [sym_process_substitution] = "process_substitution",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_while_statement_repeat1] = "while_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_case_item_repeat1] = "case_item_repeat1",
  [aux_sym_declaration_command_repeat1] = "declaration_command_repeat1",
  [aux_sym_unset_command_repeat1] = "unset_command_repeat1",
  [aux_sym_command_repeat1] = "command_repeat1",
  [aux_sym_command_repeat2] = "command_repeat2",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_expansion_repeat1] = "expansion_repeat1",
  [alias_sym_case_item] = "case_item",
  [alias_sym_regex] = "regex",
  [alias_sym_special_variable_name] = "special_variable_name",
  [alias_sym_variable_name] = "variable_name",
  [alias_sym_word] = "word",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym_heredoc_start] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_heredoc_body] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_beginning] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_middle] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_end] = {
    .visible = false,
    .named = true,
  },
  [sym_file_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_value] = {
    .visible = false,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_done] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_esac] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsetenv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [sym__special_characters] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_raw_string] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [sym_word] = {
    .visible = true,
    .named = true,
  },
  [sym_test_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_without_right_brace] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__terminated_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_group] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_last_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_pipeline] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_negated_command] = {
    .visible = true,
    .named = true,
  },
  [sym_test_command] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_command] = {
    .visible = true,
    .named = true,
  },
  [sym_unset_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command_name] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_file_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [sym_herestring_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_string_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_command_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_process_substitution] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_while_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_item_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unset_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expansion_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_regex] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_special_variable_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_word] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[23][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_word,
  },
  [2] = {
    [0] = alias_sym_variable_name,
  },
  [3] = {
    [1] = alias_sym_word,
  },
  [4] = {
    [1] = alias_sym_special_variable_name,
  },
  [5] = {
    [1] = alias_sym_variable_name,
  },
  [6] = {
    [2] = alias_sym_word,
  },
  [7] = {
    [2] = alias_sym_special_variable_name,
  },
  [8] = {
    [2] = alias_sym_variable_name,
  },
  [9] = {
    [3] = alias_sym_word,
  },
  [10] = {
    [1] = alias_sym_special_variable_name,
    [3] = alias_sym_regex,
  },
  [11] = {
    [1] = alias_sym_variable_name,
    [3] = alias_sym_regex,
  },
  [12] = {
    [3] = alias_sym_regex,
  },
  [13] = {
    [1] = alias_sym_word,
    [4] = alias_sym_case_item,
  },
  [14] = {
    [4] = alias_sym_case_item,
  },
  [15] = {
    [4] = alias_sym_word,
  },
  [16] = {
    [2] = alias_sym_special_variable_name,
    [4] = alias_sym_regex,
  },
  [17] = {
    [2] = alias_sym_variable_name,
    [4] = alias_sym_regex,
  },
  [18] = {
    [4] = alias_sym_regex,
  },
  [19] = {
    [1] = alias_sym_word,
    [5] = alias_sym_case_item,
  },
  [20] = {
    [5] = alias_sym_case_item,
  },
  [21] = {
    [1] = alias_sym_word,
    [6] = alias_sym_case_item,
  },
  [22] = {
    [6] = alias_sym_case_item,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '%')
        ADVANCE(9);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '*')
        ADVANCE(18);
      if (lookahead == '+')
        ADVANCE(19);
      if (lookahead == '-')
        ADVANCE(21);
      if (lookahead == '/')
        ADVANCE(22);
      if (lookahead == '0')
        ADVANCE(23);
      if (lookahead == ':')
        ADVANCE(25);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(36);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '?')
        ADVANCE(43);
      if (lookahead == '@')
        ADVANCE(44);
      if (lookahead == '[')
        ADVANCE(45);
      if (lookahead == '\\')
        SKIP(47);
      if (lookahead == ']')
        ADVANCE(48);
      if (lookahead == '_')
        ADVANCE(50);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'c')
        ADVANCE(52);
      if (lookahead == 'd')
        ADVANCE(56);
      if (lookahead == 'e')
        ADVANCE(66);
      if (lookahead == 'f')
        ADVANCE(80);
      if (lookahead == 'i')
        ADVANCE(91);
      if (lookahead == 'l')
        ADVANCE(94);
      if (lookahead == 'r')
        ADVANCE(99);
      if (lookahead == 't')
        ADVANCE(107);
      if (lookahead == 'u')
        ADVANCE(117);
      if (lookahead == 'w')
        ADVANCE(125);
      if (lookahead == '{')
        ADVANCE(130);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '}')
        ADVANCE(134);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      if (('1' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=')
        ADVANCE(3);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(7);
      if (lookahead == '{')
        ADVANCE(8);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(11);
      if (lookahead == '>')
        ADVANCE(12);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_AMP_GT);
      if (lookahead == '>')
        ADVANCE(13);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_AMP_GT_GT);
      END_STATE();
    case 14:
      if (lookahead == '\'')
        ADVANCE(15);
      if (lookahead != 0)
        ADVANCE(14);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(sym_raw_string);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 19:
      if (lookahead == '=')
        ADVANCE(20);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(aux_sym_SLASH);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(26);
      if (lookahead == '?')
        ADVANCE(27);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == ';')
        ADVANCE(29);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_SEMI_SEMI);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(31);
      if (lookahead == '(')
        ADVANCE(32);
      if (lookahead == '<')
        ADVANCE(33);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_LT_AMP);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '-')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(35);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_LT_LT_LT);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(37);
      if (lookahead == '~')
        ADVANCE(38);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '(')
        ADVANCE(41);
      if (lookahead == '>')
        ADVANCE(42);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_GT_AMP);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[')
        ADVANCE(46);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 47:
      if (lookahead == '\n')
        SKIP(0);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == ']')
        ADVANCE(49);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'a')
        ADVANCE(53);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 's')
        ADVANCE(54);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_case);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(57);
      if (lookahead == 'o')
        ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'c')
        ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'l')
        ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'a')
        ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'r')
        ADVANCE(61);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_declare);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'n')
        ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(65);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_done);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'l')
        ADVANCE(67);
      if (lookahead == 's')
        ADVANCE(72);
      if (lookahead == 'x')
        ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'i')
        ADVANCE(68);
      if (lookahead == 's')
        ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'f')
        ADVANCE(69);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_elif);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_else);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'a')
        ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'c')
        ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_esac);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'p')
        ADVANCE(76);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'o')
        ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'r')
        ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 't')
        ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_export);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'i')
        ADVANCE(81);
      if (lookahead == 'o')
        ADVANCE(82);
      if (lookahead == 'u')
        ADVANCE(84);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_fi);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'r')
        ADVANCE(83);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_for);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'n')
        ADVANCE(85);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'c')
        ADVANCE(86);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 't')
        ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'i')
        ADVANCE(88);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'o')
        ADVANCE(89);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'n')
        ADVANCE(90);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_function);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'f')
        ADVANCE(92);
      if (lookahead == 'n')
        ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_if);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_in);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'o')
        ADVANCE(95);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'c')
        ADVANCE(96);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'a')
        ADVANCE(97);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'l')
        ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_local);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(100);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'a')
        ADVANCE(101);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'd')
        ADVANCE(102);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'o')
        ADVANCE(103);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'n')
        ADVANCE(104);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'l')
        ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'y')
        ADVANCE(106);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_readonly);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'h')
        ADVANCE(108);
      if (lookahead == 'y')
        ADVANCE(111);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(109);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'n')
        ADVANCE(110);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_then);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'p')
        ADVANCE(112);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(113);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 's')
        ADVANCE(114);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(115);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 't')
        ADVANCE(116);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_typeset);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'n')
        ADVANCE(118);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 's')
        ADVANCE(119);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(120);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 't')
        ADVANCE(121);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_unset);
      if (lookahead == 'e')
        ADVANCE(122);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'n')
        ADVANCE(123);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'v')
        ADVANCE(124);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_unsetenv);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'h')
        ADVANCE(126);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'i')
        ADVANCE(127);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'l')
        ADVANCE(128);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(129);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_while);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(132);
      if (lookahead == '|')
        ADVANCE(133);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_PIPE_AMP);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 135:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(140);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(141);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(45);
      if (lookahead == '\\')
        ADVANCE(142);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'c')
        ADVANCE(144);
      if (lookahead == 'd')
        ADVANCE(148);
      if (lookahead == 'e')
        ADVANCE(155);
      if (lookahead == 'f')
        ADVANCE(161);
      if (lookahead == 'i')
        ADVANCE(171);
      if (lookahead == 'l')
        ADVANCE(173);
      if (lookahead == 'r')
        ADVANCE(178);
      if (lookahead == 't')
        ADVANCE(186);
      if (lookahead == 'u')
        ADVANCE(193);
      if (lookahead == 'w')
        ADVANCE(201);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(135);
      if ((lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 137:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(139);
      END_STATE();
    case 140:
      if (lookahead == '>')
        ADVANCE(12);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(31);
      if (lookahead == '(')
        ADVANCE(32);
      END_STATE();
    case 142:
      if (lookahead == '\n')
        SKIP(135);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym__special_characters);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '}')
        ADVANCE(143);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'a')
        ADVANCE(145);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 's')
        ADVANCE(146);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'e')
        ADVANCE(147);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_case);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'e')
        ADVANCE(149);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'c')
        ADVANCE(150);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'l')
        ADVANCE(151);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'a')
        ADVANCE(152);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'r')
        ADVANCE(153);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'e')
        ADVANCE(154);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_declare);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'x')
        ADVANCE(156);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'p')
        ADVANCE(157);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'o')
        ADVANCE(158);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'r')
        ADVANCE(159);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 't')
        ADVANCE(160);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_export);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'o')
        ADVANCE(162);
      if (lookahead == 'u')
        ADVANCE(164);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'r')
        ADVANCE(163);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'n')
        ADVANCE(165);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'c')
        ADVANCE(166);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 't')
        ADVANCE(167);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'i')
        ADVANCE(168);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'o')
        ADVANCE(169);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'n')
        ADVANCE(170);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_function);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'f')
        ADVANCE(172);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_if);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'o')
        ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'c')
        ADVANCE(175);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'a')
        ADVANCE(176);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'l')
        ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_local);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'e')
        ADVANCE(179);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'a')
        ADVANCE(180);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'd')
        ADVANCE(181);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'o')
        ADVANCE(182);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'n')
        ADVANCE(183);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'l')
        ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'y')
        ADVANCE(185);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_readonly);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'y')
        ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'p')
        ADVANCE(188);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'e')
        ADVANCE(189);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 's')
        ADVANCE(190);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'e')
        ADVANCE(191);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 't')
        ADVANCE(192);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_typeset);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'n')
        ADVANCE(194);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 's')
        ADVANCE(195);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'e')
        ADVANCE(196);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 't')
        ADVANCE(197);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_unset);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'e')
        ADVANCE(198);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'n')
        ADVANCE(199);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'v')
        ADVANCE(200);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_unsetenv);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'h')
        ADVANCE(202);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'i')
        ADVANCE(203);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'l')
        ADVANCE(204);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'e')
        ADVANCE(205);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_while);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 206:
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(207);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '+')
        ADVANCE(19);
      if (lookahead == '=')
        ADVANCE(208);
      if (lookahead == '[')
        ADVANCE(209);
      if (lookahead == '\\')
        SKIP(210);
      if (lookahead == ']')
        ADVANCE(211);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'd')
        ADVANCE(212);
      if (lookahead == 'e')
        ADVANCE(214);
      if (lookahead == 'f')
        ADVANCE(223);
      if (lookahead == 'i')
        ADVANCE(225);
      if (lookahead == 't')
        ADVANCE(227);
      if (lookahead == '{')
        ADVANCE(130);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '}')
        ADVANCE(134);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(206);
      END_STATE();
    case 207:
      if (lookahead == '&')
        ADVANCE(11);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 210:
      if (lookahead == '\n')
        SKIP(206);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 212:
      if (lookahead == 'o')
        ADVANCE(213);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 214:
      if (lookahead == 'l')
        ADVANCE(215);
      if (lookahead == 's')
        ADVANCE(220);
      END_STATE();
    case 215:
      if (lookahead == 'i')
        ADVANCE(216);
      if (lookahead == 's')
        ADVANCE(218);
      END_STATE();
    case 216:
      if (lookahead == 'f')
        ADVANCE(217);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 218:
      if (lookahead == 'e')
        ADVANCE(219);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 220:
      if (lookahead == 'a')
        ADVANCE(221);
      END_STATE();
    case 221:
      if (lookahead == 'c')
        ADVANCE(222);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_esac);
      END_STATE();
    case 223:
      if (lookahead == 'i')
        ADVANCE(224);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_fi);
      END_STATE();
    case 225:
      if (lookahead == 'n')
        ADVANCE(226);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 227:
      if (lookahead == 'h')
        ADVANCE(228);
      END_STATE();
    case 228:
      if (lookahead == 'e')
        ADVANCE(229);
      END_STATE();
    case 229:
      if (lookahead == 'n')
        ADVANCE(230);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 231:
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '\\')
        SKIP(232);
      if (lookahead == '|')
        ADVANCE(233);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(231);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 232:
      if (lookahead == '\n')
        SKIP(231);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 234:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(140);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(141);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(235);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(234);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 235:
      if (lookahead == '\n')
        SKIP(234);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 236:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(140);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(141);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(45);
      if (lookahead == '\\')
        ADVANCE(237);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(236);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 237:
      if (lookahead == '\n')
        SKIP(236);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 238:
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == '-')
        ADVANCE(239);
      if (lookahead == '<')
        ADVANCE(241);
      if (lookahead == '>')
        ADVANCE(242);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(243);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(238);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(240);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '`' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_test_operator);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(240);
      END_STATE();
    case 241:
      if (lookahead == '(')
        ADVANCE(32);
      END_STATE();
    case 242:
      if (lookahead == '(')
        ADVANCE(41);
      END_STATE();
    case 243:
      if (lookahead == '\n')
        SKIP(238);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 244:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(246);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(241);
      if (lookahead == '>')
        ADVANCE(242);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(247);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(244);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(248);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(138);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(11);
      END_STATE();
    case 247:
      if (lookahead == '\n')
        SKIP(244);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(137);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(248);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 249:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(250);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(253);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(249);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(138);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '=')
        ADVANCE(251);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == '~')
        ADVANCE(252);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(138);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 253:
      if (lookahead == '\n')
        SKIP(249);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 254:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(255);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '\\')
        ADVANCE(259);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(260);
      if (lookahead != 0)
        ADVANCE(256);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(256);
      if (lookahead == '\\')
        ADVANCE(258);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(255);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\\')
        ADVANCE(257);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(256);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(256);
      if (lookahead == '\\')
        ADVANCE(257);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(256);
      if (lookahead != 0)
        ADVANCE(256);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(256);
      if (lookahead == '\\')
        ADVANCE(258);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(255);
      if (lookahead != 0)
        ADVANCE(255);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(260);
      if (lookahead == '\\')
        ADVANCE(257);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(256);
      if (lookahead != 0)
        ADVANCE(256);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '#')
        ADVANCE(255);
      if (lookahead == '\\')
        ADVANCE(259);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(260);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(256);
      END_STATE();
    case 261:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(262);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '*')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(21);
      if (lookahead == '0')
        ADVANCE(23);
      if (lookahead == '?')
        ADVANCE(43);
      if (lookahead == '@')
        ADVANCE(44);
      if (lookahead == '\\')
        SKIP(263);
      if (lookahead == '_')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(261);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 263:
      if (lookahead == '\n')
        SKIP(261);
      END_STATE();
    case 264:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(262);
      if (lookahead == '*')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(21);
      if (lookahead == '0')
        ADVANCE(23);
      if (lookahead == '?')
        ADVANCE(43);
      if (lookahead == '@')
        ADVANCE(44);
      if (lookahead == '\\')
        SKIP(265);
      if (lookahead == '_')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(264);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 265:
      if (lookahead == '\n')
        SKIP(264);
      END_STATE();
    case 266:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(250);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(267);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(266);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(138);
      END_STATE();
    case 267:
      if (lookahead == '\n')
        SKIP(266);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 268:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(141);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(269);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(268);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(138);
      END_STATE();
    case 269:
      if (lookahead == '\n')
        SKIP(268);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 270:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(250);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(271);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(270);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(138);
      END_STATE();
    case 271:
      if (lookahead == '\n')
        SKIP(270);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 272:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(241);
      if (lookahead == '>')
        ADVANCE(242);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(273);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(272);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 273:
      if (lookahead == '\n')
        SKIP(272);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 274:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(275);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(276);
      if (lookahead == 'i')
        ADVANCE(225);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(274);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 276:
      if (lookahead == '\n')
        SKIP(274);
      END_STATE();
    case 277:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(246);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(241);
      if (lookahead == '>')
        ADVANCE(242);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(278);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(277);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(248);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(138);
      END_STATE();
    case 278:
      if (lookahead == '\n')
        SKIP(277);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 279:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(250);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(280);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(279);
      if (lookahead != 0)
        ADVANCE(138);
      END_STATE();
    case 280:
      if (lookahead == '\n')
        SKIP(279);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 281:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(141);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(282);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(281);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(138);
      END_STATE();
    case 282:
      if (lookahead == '\n')
        SKIP(281);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 283:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(246);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(284);
      if (lookahead == 'e')
        ADVANCE(285);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(283);
      END_STATE();
    case 284:
      if (lookahead == '\n')
        SKIP(283);
      END_STATE();
    case 285:
      if (lookahead == 's')
        ADVANCE(220);
      END_STATE();
    case 286:
      if (lookahead == '!')
        ADVANCE(287);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(207);
      if (lookahead == '-')
        ADVANCE(288);
      if (lookahead == '<')
        ADVANCE(290);
      if (lookahead == '=')
        ADVANCE(36);
      if (lookahead == '>')
        ADVANCE(291);
      if (lookahead == '\\')
        SKIP(292);
      if (lookahead == ']')
        ADVANCE(211);
      if (lookahead == '|')
        ADVANCE(293);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(286);
      END_STATE();
    case 287:
      if (lookahead == '=')
        ADVANCE(3);
      END_STATE();
    case 288:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(289);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(sym_test_operator);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(289);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 292:
      if (lookahead == '\n')
        SKIP(286);
      END_STATE();
    case 293:
      if (lookahead == '|')
        ADVANCE(133);
      END_STATE();
    case 294:
      if (lookahead == '!')
        ADVANCE(287);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(207);
      if (lookahead == '-')
        ADVANCE(288);
      if (lookahead == '<')
        ADVANCE(290);
      if (lookahead == '=')
        ADVANCE(36);
      if (lookahead == '>')
        ADVANCE(291);
      if (lookahead == '\\')
        SKIP(295);
      if (lookahead == ']')
        ADVANCE(296);
      if (lookahead == '|')
        ADVANCE(293);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(294);
      END_STATE();
    case 295:
      if (lookahead == '\n')
        SKIP(294);
      END_STATE();
    case 296:
      if (lookahead == ']')
        ADVANCE(49);
      END_STATE();
    case 297:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(262);
      if (lookahead == '*')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(21);
      if (lookahead == '0')
        ADVANCE(298);
      if (lookahead == '?')
        ADVANCE(43);
      if (lookahead == '@')
        ADVANCE(44);
      if (lookahead == '\\')
        ADVANCE(300);
      if (lookahead == '_')
        ADVANCE(302);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(301);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(299);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '_' || lookahead > 'z'))
        ADVANCE(256);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(299);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(299);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(301);
      if (lookahead == '\\')
        ADVANCE(257);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(256);
      if (lookahead != 0)
        ADVANCE(256);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '*')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(21);
      if (lookahead == '0')
        ADVANCE(298);
      if (lookahead == '?')
        ADVANCE(43);
      if (lookahead == '@')
        ADVANCE(44);
      if (lookahead == '\\')
        ADVANCE(300);
      if (lookahead == '_')
        ADVANCE(302);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(301);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(299);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '_' || lookahead > 'z'))
        ADVANCE(256);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(299);
      END_STATE();
    case 303:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '%')
        ADVANCE(304);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '-')
        ADVANCE(305);
      if (lookahead == '/')
        ADVANCE(22);
      if (lookahead == ':')
        ADVANCE(306);
      if (lookahead == '<')
        ADVANCE(241);
      if (lookahead == '=')
        ADVANCE(309);
      if (lookahead == '>')
        ADVANCE(242);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(310);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '}')
        ADVANCE(134);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(303);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(307);
      if (lookahead == '?')
        ADVANCE(308);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '?' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 310:
      if (lookahead == '\n')
        SKIP(303);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 311:
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(262);
      if (lookahead == '*')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(21);
      if (lookahead == '0')
        ADVANCE(23);
      if (lookahead == '?')
        ADVANCE(43);
      if (lookahead == '@')
        ADVANCE(44);
      if (lookahead == '\\')
        SKIP(312);
      if (lookahead == '_')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(311);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(24);
      END_STATE();
    case 312:
      if (lookahead == '\n')
        SKIP(311);
      END_STATE();
    case 313:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(207);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(241);
      if (lookahead == '>')
        ADVANCE(242);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(314);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(313);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(248);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(138);
      END_STATE();
    case 314:
      if (lookahead == '\n')
        SKIP(313);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 315:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(316);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(250);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(317);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(315);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>'))
        ADVANCE(138);
      END_STATE();
    case 316:
      if (lookahead == '&')
        ADVANCE(11);
      if (lookahead == '>')
        ADVANCE(12);
      END_STATE();
    case 317:
      if (lookahead == '\n')
        SKIP(315);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 318:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(316);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(250);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(319);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(318);
      if (lookahead != 0 &&
          (lookahead < ';' || lookahead > '>'))
        ADVANCE(138);
      END_STATE();
    case 319:
      if (lookahead == '\n')
        SKIP(318);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 320:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(316);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(141);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(321);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(320);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(138);
      END_STATE();
    case 321:
      if (lookahead == '\n')
        SKIP(320);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 322:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(207);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(241);
      if (lookahead == '>')
        ADVANCE(242);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(323);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(322);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(248);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(138);
      END_STATE();
    case 323:
      if (lookahead == '\n')
        SKIP(322);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 324:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(316);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(250);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(325);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(324);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>'))
        ADVANCE(138);
      END_STATE();
    case 325:
      if (lookahead == '\n')
        SKIP(324);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 326:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(316);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(250);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(327);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(326);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>'))
        ADVANCE(138);
      END_STATE();
    case 327:
      if (lookahead == '\n')
        SKIP(326);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 328:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(316);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(141);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(329);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(328);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(138);
      END_STATE();
    case 329:
      if (lookahead == '\n')
        SKIP(328);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 330:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(140);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(331);
      if (lookahead == '<')
        ADVANCE(141);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(45);
      if (lookahead == '\\')
        ADVANCE(332);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'c')
        ADVANCE(144);
      if (lookahead == 'd')
        ADVANCE(148);
      if (lookahead == 'e')
        ADVANCE(155);
      if (lookahead == 'f')
        ADVANCE(161);
      if (lookahead == 'i')
        ADVANCE(171);
      if (lookahead == 'l')
        ADVANCE(173);
      if (lookahead == 'r')
        ADVANCE(178);
      if (lookahead == 't')
        ADVANCE(186);
      if (lookahead == 'u')
        ADVANCE(193);
      if (lookahead == 'w')
        ADVANCE(201);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(330);
      if ((lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 331:
      if (lookahead == ';')
        ADVANCE(29);
      END_STATE();
    case 332:
      if (lookahead == '\n')
        SKIP(330);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 333:
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(334);
      if (lookahead == '\\')
        SKIP(335);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(333);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '{')
        ADVANCE(8);
      END_STATE();
    case 335:
      if (lookahead == '\n')
        SKIP(333);
      END_STATE();
    case 336:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(337);
      if (lookahead == '$')
        ADVANCE(339);
      if (lookahead == '\'')
        ADVANCE(344);
      if (lookahead == '<')
        ADVANCE(347);
      if (lookahead == '>')
        ADVANCE(349);
      if (lookahead == '[')
        ADVANCE(351);
      if (lookahead == '\\')
        ADVANCE(352);
      if (lookahead == ']')
        ADVANCE(351);
      if (lookahead == '`')
        ADVANCE(355);
      if (lookahead == '{')
        ADVANCE(351);
      if (lookahead == '}')
        ADVANCE(351);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(336);
      if (('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '|')
        ADVANCE(342);
      if (lookahead != 0)
        ADVANCE(354);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(338);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(337);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(338);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(337);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(337);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(340);
      if (lookahead == '\\')
        ADVANCE(341);
      if (lookahead == '{')
        ADVANCE(343);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(342);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      if (lookahead == '\\')
        ADVANCE(341);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(342);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(341);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(342);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(342);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(341);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(342);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      if (lookahead == '\\')
        ADVANCE(341);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(342);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\'')
        ADVANCE(345);
      if (lookahead == '\\')
        ADVANCE(346);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(14);
      if (lookahead != 0)
        ADVANCE(344);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(sym_raw_string);
      if (lookahead == '\\')
        ADVANCE(341);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(342);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\n')
        ADVANCE(14);
      if (lookahead == '\'')
        ADVANCE(345);
      if (lookahead == '\\')
        ADVANCE(346);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(344);
      if (lookahead != 0)
        ADVANCE(344);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '(')
        ADVANCE(348);
      if (lookahead == '\\')
        ADVANCE(341);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(342);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      if (lookahead == '\\')
        ADVANCE(341);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(342);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '(')
        ADVANCE(350);
      if (lookahead == '\\')
        ADVANCE(341);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(342);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      if (lookahead == '\\')
        ADVANCE(341);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(342);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '[')
        ADVANCE(351);
      if (lookahead == '\\')
        ADVANCE(341);
      if (lookahead == ']')
        ADVANCE(351);
      if (lookahead == '{')
        ADVANCE(351);
      if (lookahead == '}')
        ADVANCE(351);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(342);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(353);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(342);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(354);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(352);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(342);
      if (('\"' <= lookahead && lookahead <= '$') ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          ('[' <= lookahead && lookahead <= ']') ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(342);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(354);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(352);
      if (('\"' <= lookahead && lookahead <= '$') ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          ('[' <= lookahead && lookahead <= ']') ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(342);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(354);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      if (lookahead == '\\')
        ADVANCE(341);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(342);
      END_STATE();
    case 356:
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '\\')
        SKIP(357);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(356);
      END_STATE();
    case 357:
      if (lookahead == '\n')
        SKIP(356);
      END_STATE();
    case 358:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(359);
      if (lookahead == '>')
        ADVANCE(360);
      if (lookahead == '\\')
        SKIP(361);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(358);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(31);
      if (lookahead == '<')
        ADVANCE(33);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(40);
      if (lookahead == '>')
        ADVANCE(42);
      END_STATE();
    case 361:
      if (lookahead == '\n')
        SKIP(358);
      END_STATE();
    case 362:
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '\\')
        SKIP(363);
      if (lookahead == ']')
        ADVANCE(211);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(362);
      END_STATE();
    case 363:
      if (lookahead == '\n')
        SKIP(362);
      END_STATE();
    case 364:
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(140);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(141);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(45);
      if (lookahead == '\\')
        ADVANCE(365);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'c')
        ADVANCE(144);
      if (lookahead == 'd')
        ADVANCE(366);
      if (lookahead == 'e')
        ADVANCE(155);
      if (lookahead == 'f')
        ADVANCE(161);
      if (lookahead == 'i')
        ADVANCE(171);
      if (lookahead == 'l')
        ADVANCE(173);
      if (lookahead == 'r')
        ADVANCE(178);
      if (lookahead == 't')
        ADVANCE(186);
      if (lookahead == 'u')
        ADVANCE(193);
      if (lookahead == 'w')
        ADVANCE(201);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(364);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 365:
      if (lookahead == '\n')
        SKIP(364);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'e')
        ADVANCE(149);
      if (lookahead == 'o')
        ADVANCE(367);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'n')
        ADVANCE(368);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'e')
        ADVANCE(369);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(anon_sym_done);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 370:
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(140);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(141);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(45);
      if (lookahead == '\\')
        ADVANCE(371);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'c')
        ADVANCE(144);
      if (lookahead == 'd')
        ADVANCE(148);
      if (lookahead == 'e')
        ADVANCE(372);
      if (lookahead == 'f')
        ADVANCE(378);
      if (lookahead == 'i')
        ADVANCE(171);
      if (lookahead == 'l')
        ADVANCE(173);
      if (lookahead == 'r')
        ADVANCE(178);
      if (lookahead == 't')
        ADVANCE(186);
      if (lookahead == 'u')
        ADVANCE(193);
      if (lookahead == 'w')
        ADVANCE(201);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(370);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 371:
      if (lookahead == '\n')
        SKIP(370);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'l')
        ADVANCE(373);
      if (lookahead == 'x')
        ADVANCE(156);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'i')
        ADVANCE(374);
      if (lookahead == 's')
        ADVANCE(376);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'f')
        ADVANCE(375);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(anon_sym_elif);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'e')
        ADVANCE(377);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'i')
        ADVANCE(379);
      if (lookahead == 'o')
        ADVANCE(162);
      if (lookahead == 'u')
        ADVANCE(164);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(anon_sym_fi);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 380:
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(140);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(141);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(45);
      if (lookahead == '\\')
        ADVANCE(381);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'c')
        ADVANCE(144);
      if (lookahead == 'd')
        ADVANCE(148);
      if (lookahead == 'e')
        ADVANCE(155);
      if (lookahead == 'f')
        ADVANCE(161);
      if (lookahead == 'i')
        ADVANCE(171);
      if (lookahead == 'l')
        ADVANCE(173);
      if (lookahead == 'r')
        ADVANCE(178);
      if (lookahead == 't')
        ADVANCE(186);
      if (lookahead == 'u')
        ADVANCE(193);
      if (lookahead == 'w')
        ADVANCE(201);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '}')
        ADVANCE(134);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(380);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 381:
      if (lookahead == '\n')
        SKIP(380);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 382:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(383);
      if (lookahead == '>')
        ADVANCE(360);
      if (lookahead == '\\')
        SKIP(384);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(382);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(31);
      END_STATE();
    case 384:
      if (lookahead == '\n')
        SKIP(382);
      END_STATE();
    case 385:
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(140);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(141);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(45);
      if (lookahead == '\\')
        ADVANCE(386);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'c')
        ADVANCE(144);
      if (lookahead == 'd')
        ADVANCE(148);
      if (lookahead == 'e')
        ADVANCE(155);
      if (lookahead == 'f')
        ADVANCE(161);
      if (lookahead == 'i')
        ADVANCE(171);
      if (lookahead == 'l')
        ADVANCE(173);
      if (lookahead == 'r')
        ADVANCE(178);
      if (lookahead == 't')
        ADVANCE(186);
      if (lookahead == 'u')
        ADVANCE(193);
      if (lookahead == 'w')
        ADVANCE(201);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(385);
      if (lookahead != 0 &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 386:
      if (lookahead == '\n')
        SKIP(385);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 387:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(359);
      if (lookahead == '>')
        ADVANCE(360);
      if (lookahead == '\\')
        SKIP(388);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(387);
      END_STATE();
    case 388:
      if (lookahead == '\n')
        SKIP(387);
      END_STATE();
    case 389:
      if (lookahead == '!')
        ADVANCE(287);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(207);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '-')
        ADVANCE(288);
      if (lookahead == '<')
        ADVANCE(290);
      if (lookahead == '=')
        ADVANCE(36);
      if (lookahead == '>')
        ADVANCE(291);
      if (lookahead == '\\')
        SKIP(390);
      if (lookahead == '|')
        ADVANCE(293);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(389);
      END_STATE();
    case 390:
      if (lookahead == '\n')
        SKIP(389);
      END_STATE();
    case 391:
      if (lookahead == '!')
        ADVANCE(392);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(337);
      if (lookahead == '$')
        ADVANCE(339);
      if (lookahead == '\'')
        ADVANCE(344);
      if (lookahead == '(')
        ADVANCE(393);
      if (lookahead == '-')
        ADVANCE(394);
      if (lookahead == '<')
        ADVANCE(347);
      if (lookahead == '>')
        ADVANCE(349);
      if (lookahead == '[')
        ADVANCE(351);
      if (lookahead == '\\')
        ADVANCE(352);
      if (lookahead == ']')
        ADVANCE(351);
      if (lookahead == '`')
        ADVANCE(355);
      if (lookahead == '{')
        ADVANCE(351);
      if (lookahead == '}')
        ADVANCE(351);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(391);
      if (('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '|')
        ADVANCE(342);
      if (lookahead != 0)
        ADVANCE(354);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '\\')
        ADVANCE(352);
      if (('\"' <= lookahead && lookahead <= '$') ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          ('[' <= lookahead && lookahead <= ']') ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(342);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(354);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '\\')
        ADVANCE(341);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(342);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(352);
      if (('\"' <= lookahead && lookahead <= '$') ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          ('[' <= lookahead && lookahead <= ']') ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(342);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(395);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(354);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(sym_test_operator);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(395);
      END_STATE();
    case 396:
      if (lookahead == '!')
        ADVANCE(287);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(207);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '-')
        ADVANCE(288);
      if (lookahead == '<')
        ADVANCE(290);
      if (lookahead == '=')
        ADVANCE(36);
      if (lookahead == '>')
        ADVANCE(291);
      if (lookahead == '\\')
        SKIP(397);
      if (lookahead == ']')
        ADVANCE(296);
      if (lookahead == '|')
        ADVANCE(398);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(396);
      END_STATE();
    case 397:
      if (lookahead == '\n')
        SKIP(396);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(133);
      END_STATE();
    case 399:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(241);
      if (lookahead == '>')
        ADVANCE(242);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(400);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '}')
        ADVANCE(134);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(399);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 400:
      if (lookahead == '\n')
        SKIP(399);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 401:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '%')
        ADVANCE(304);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '-')
        ADVANCE(305);
      if (lookahead == ':')
        ADVANCE(306);
      if (lookahead == '<')
        ADVANCE(241);
      if (lookahead == '=')
        ADVANCE(309);
      if (lookahead == '>')
        ADVANCE(242);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(402);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '}')
        ADVANCE(134);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(401);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 402:
      if (lookahead == '\n')
        SKIP(401);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 403:
      if (lookahead == '#')
        ADVANCE(404);
      if (lookahead == '\\')
        ADVANCE(406);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(403);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '}')
        ADVANCE(407);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\\')
        ADVANCE(405);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '}')
        ADVANCE(404);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\\')
        ADVANCE(405);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '}')
        ADVANCE(404);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(404);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\\')
        ADVANCE(406);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '}')
        ADVANCE(407);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(407);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\\')
        ADVANCE(406);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '}')
        ADVANCE(407);
      END_STATE();
    case 408:
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(316);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(359);
      if (lookahead == '>')
        ADVANCE(360);
      if (lookahead == '\\')
        SKIP(409);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(408);
      END_STATE();
    case 409:
      if (lookahead == '\n')
        SKIP(408);
      END_STATE();
    case 410:
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(316);
      if (lookahead == '<')
        ADVANCE(359);
      if (lookahead == '>')
        ADVANCE(360);
      if (lookahead == '\\')
        SKIP(411);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(410);
      END_STATE();
    case 411:
      if (lookahead == '\n')
        SKIP(410);
      END_STATE();
    case 412:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(359);
      if (lookahead == '>')
        ADVANCE(360);
      if (lookahead == '\\')
        SKIP(413);
      if (lookahead == 'e')
        ADVANCE(285);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(412);
      END_STATE();
    case 413:
      if (lookahead == '\n')
        SKIP(412);
      END_STATE();
    case 414:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(241);
      if (lookahead == '>')
        ADVANCE(242);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(415);
      if (lookahead == ']')
        ADVANCE(211);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(414);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 415:
      if (lookahead == '\n')
        SKIP(414);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 416:
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '+')
        ADVANCE(19);
      if (lookahead == '=')
        ADVANCE(208);
      if (lookahead == '\\')
        SKIP(417);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(416);
      END_STATE();
    case 417:
      if (lookahead == '\n')
        SKIP(416);
      END_STATE();
    case 418:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(241);
      if (lookahead == '>')
        ADVANCE(242);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(419);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(418);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 419:
      if (lookahead == '\n')
        SKIP(418);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 420:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(275);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(241);
      if (lookahead == '>')
        ADVANCE(242);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(421);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(420);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 421:
      if (lookahead == '\n')
        SKIP(420);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 422:
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(140);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(141);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(45);
      if (lookahead == '\\')
        ADVANCE(423);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'c')
        ADVANCE(144);
      if (lookahead == 'd')
        ADVANCE(148);
      if (lookahead == 'e')
        ADVANCE(155);
      if (lookahead == 'f')
        ADVANCE(378);
      if (lookahead == 'i')
        ADVANCE(171);
      if (lookahead == 'l')
        ADVANCE(173);
      if (lookahead == 'r')
        ADVANCE(178);
      if (lookahead == 't')
        ADVANCE(186);
      if (lookahead == 'u')
        ADVANCE(193);
      if (lookahead == 'w')
        ADVANCE(201);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(422);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 423:
      if (lookahead == '\n')
        SKIP(422);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 424:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(241);
      if (lookahead == '>')
        ADVANCE(242);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(425);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'e')
        ADVANCE(426);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(424);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 425:
      if (lookahead == '\n')
        SKIP(424);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 's')
        ADVANCE(427);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'a')
        ADVANCE(428);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'c')
        ADVANCE(429);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 430:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(383);
      if (lookahead == '>')
        ADVANCE(360);
      if (lookahead == '\\')
        SKIP(431);
      if (lookahead == 'e')
        ADVANCE(285);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(430);
      END_STATE();
    case 431:
      if (lookahead == '\n')
        SKIP(430);
      END_STATE();
    case 432:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(383);
      if (lookahead == '>')
        ADVANCE(360);
      if (lookahead == '\\')
        SKIP(433);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(432);
      END_STATE();
    case 433:
      if (lookahead == '\n')
        SKIP(432);
      END_STATE();
    case 434:
      if (lookahead == '!')
        ADVANCE(287);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(207);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '-')
        ADVANCE(288);
      if (lookahead == '<')
        ADVANCE(290);
      if (lookahead == '=')
        ADVANCE(36);
      if (lookahead == '>')
        ADVANCE(291);
      if (lookahead == '\\')
        SKIP(435);
      if (lookahead == ']')
        ADVANCE(296);
      if (lookahead == '|')
        ADVANCE(293);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(434);
      END_STATE();
    case 435:
      if (lookahead == '\n')
        SKIP(434);
      END_STATE();
    case 436:
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '\\')
        SKIP(437);
      if (lookahead == '}')
        ADVANCE(134);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(436);
      END_STATE();
    case 437:
      if (lookahead == '\n')
        SKIP(436);
      END_STATE();
    case 438:
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(316);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(383);
      if (lookahead == '>')
        ADVANCE(360);
      if (lookahead == '\\')
        SKIP(439);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(438);
      END_STATE();
    case 439:
      if (lookahead == '\n')
        SKIP(438);
      END_STATE();
    case 440:
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(316);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(359);
      if (lookahead == '>')
        ADVANCE(360);
      if (lookahead == '\\')
        SKIP(441);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(440);
      END_STATE();
    case 441:
      if (lookahead == '\n')
        SKIP(440);
      END_STATE();
    case 442:
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(316);
      if (lookahead == '<')
        ADVANCE(383);
      if (lookahead == '>')
        ADVANCE(360);
      if (lookahead == '\\')
        SKIP(443);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(442);
      END_STATE();
    case 443:
      if (lookahead == '\n')
        SKIP(442);
      END_STATE();
    case 444:
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '\\')
        SKIP(445);
      if (lookahead == '|')
        ADVANCE(233);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(444);
      END_STATE();
    case 445:
      if (lookahead == '\n')
        SKIP(444);
      END_STATE();
    case 446:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(246);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(447);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(446);
      END_STATE();
    case 447:
      if (lookahead == '\n')
        SKIP(446);
      END_STATE();
    case 448:
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(316);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(383);
      if (lookahead == '>')
        ADVANCE(360);
      if (lookahead == '\\')
        SKIP(449);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(448);
      END_STATE();
    case 449:
      if (lookahead == '\n')
        SKIP(448);
      END_STATE();
    case 450:
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(140);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(331);
      if (lookahead == '<')
        ADVANCE(141);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(45);
      if (lookahead == '\\')
        ADVANCE(451);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'c')
        ADVANCE(144);
      if (lookahead == 'd')
        ADVANCE(148);
      if (lookahead == 'e')
        ADVANCE(452);
      if (lookahead == 'f')
        ADVANCE(161);
      if (lookahead == 'i')
        ADVANCE(171);
      if (lookahead == 'l')
        ADVANCE(173);
      if (lookahead == 'r')
        ADVANCE(178);
      if (lookahead == 't')
        ADVANCE(186);
      if (lookahead == 'u')
        ADVANCE(193);
      if (lookahead == 'w')
        ADVANCE(201);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(450);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 451:
      if (lookahead == '\n')
        SKIP(450);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 's')
        ADVANCE(427);
      if (lookahead == 'x')
        ADVANCE(156);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 453:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(246);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(454);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(453);
      END_STATE();
    case 454:
      if (lookahead == '\n')
        SKIP(453);
      END_STATE();
    case 455:
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(207);
      if (lookahead == ')')
        ADVANCE(17);
      if (lookahead == '\\')
        SKIP(456);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(455);
      END_STATE();
    case 456:
      if (lookahead == '\n')
        SKIP(455);
      END_STATE();
    case 457:
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(207);
      if (lookahead == '\\')
        SKIP(458);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(457);
      END_STATE();
    case 458:
      if (lookahead == '\n')
        SKIP(457);
      END_STATE();
    case 459:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(246);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(241);
      if (lookahead == '>')
        ADVANCE(242);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(460);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'e')
        ADVANCE(461);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(459);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(248);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(138);
      END_STATE();
    case 460:
      if (lookahead == '\n')
        SKIP(459);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 's')
        ADVANCE(462);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(248);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'a')
        ADVANCE(463);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(248);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(137);
      if (lookahead == 'c')
        ADVANCE(464);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(248);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(137);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(248);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(138);
      END_STATE();
    case 465:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(250);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(466);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'e')
        ADVANCE(426);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(465);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(138);
      END_STATE();
    case 466:
      if (lookahead == '\n')
        SKIP(465);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 467:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '(')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(250);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(468);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'e')
        ADVANCE(426);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(467);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(138);
      END_STATE();
    case 468:
      if (lookahead == '\n')
        SKIP(467);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 469:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(141);
      if (lookahead == '>')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(470);
      if (lookahead == ']')
        ADVANCE(143);
      if (lookahead == '`')
        ADVANCE(51);
      if (lookahead == 'e')
        ADVANCE(426);
      if (lookahead == '{')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '}')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(469);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(138);
      END_STATE();
    case 470:
      if (lookahead == '\n')
        SKIP(469);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(138);
      END_STATE();
    case 471:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(359);
      if (lookahead == '>')
        ADVANCE(360);
      if (lookahead == '\\')
        SKIP(472);
      if (lookahead == 'e')
        ADVANCE(285);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(471);
      END_STATE();
    case 472:
      if (lookahead == '\n')
        SKIP(471);
      END_STATE();
    case 473:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '<')
        ADVANCE(383);
      if (lookahead == '>')
        ADVANCE(360);
      if (lookahead == '\\')
        SKIP(474);
      if (lookahead == 'e')
        ADVANCE(285);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(473);
      END_STATE();
    case 474:
      if (lookahead == '\n')
        SKIP(473);
      END_STATE();
    case 475:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '#')
        ADVANCE(139);
      if (lookahead == '&')
        ADVANCE(246);
      if (lookahead == ';')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(476);
      if (lookahead == 'e')
        ADVANCE(285);
      if (lookahead == '|')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(475);
      END_STATE();
    case 476:
      if (lookahead == '\n')
        SKIP(475);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 135, .external_lex_state = 2},
  [2] = {.lex_state = 135},
  [3] = {.lex_state = 206},
  [4] = {.lex_state = 231},
  [5] = {.lex_state = 135, .external_lex_state = 2},
  [6] = {.lex_state = 135, .external_lex_state = 2},
  [7] = {.lex_state = 234},
  [8] = {.lex_state = 234},
  [9] = {.lex_state = 135, .external_lex_state = 2},
  [10] = {.lex_state = 236, .external_lex_state = 2},
  [11] = {.lex_state = 238},
  [12] = {.lex_state = 238},
  [13] = {.lex_state = 244, .external_lex_state = 3},
  [14] = {.lex_state = 244, .external_lex_state = 4},
  [15] = {.lex_state = 234},
  [16] = {.lex_state = 249, .external_lex_state = 5},
  [17] = {.lex_state = 254},
  [18] = {.lex_state = 261},
  [19] = {.lex_state = 249, .external_lex_state = 5},
  [20] = {.lex_state = 264, .external_lex_state = 6},
  [21] = {.lex_state = 135, .external_lex_state = 2},
  [22] = {.lex_state = 135, .external_lex_state = 2},
  [23] = {.lex_state = 135, .external_lex_state = 2},
  [24] = {.lex_state = 266, .external_lex_state = 5},
  [25] = {.lex_state = 135},
  [26] = {.lex_state = 244, .external_lex_state = 4},
  [27] = {.lex_state = 249, .external_lex_state = 7},
  [28] = {.lex_state = 268, .external_lex_state = 8},
  [29] = {.lex_state = 206},
  [30] = {.lex_state = 234, .external_lex_state = 2},
  [31] = {.lex_state = 270, .external_lex_state = 7},
  [32] = {.lex_state = 135, .external_lex_state = 2},
  [33] = {.lex_state = 234, .external_lex_state = 2},
  [34] = {.lex_state = 234},
  [35] = {.lex_state = 234},
  [36] = {.lex_state = 272, .external_lex_state = 9},
  [37] = {.lex_state = 274, .external_lex_state = 4},
  [38] = {.lex_state = 206},
  [39] = {.lex_state = 244, .external_lex_state = 4},
  [40] = {.lex_state = 268, .external_lex_state = 8},
  [41] = {.lex_state = 206},
  [42] = {.lex_state = 274, .external_lex_state = 10},
  [43] = {.lex_state = 254},
  [44] = {.lex_state = 261},
  [45] = {.lex_state = 274, .external_lex_state = 10},
  [46] = {.lex_state = 264, .external_lex_state = 6},
  [47] = {.lex_state = 135, .external_lex_state = 2},
  [48] = {.lex_state = 135, .external_lex_state = 2},
  [49] = {.lex_state = 135, .external_lex_state = 2},
  [50] = {.lex_state = 274, .external_lex_state = 4},
  [51] = {.lex_state = 206},
  [52] = {.lex_state = 206},
  [53] = {.lex_state = 135, .external_lex_state = 2},
  [54] = {.lex_state = 234},
  [55] = {.lex_state = 236, .external_lex_state = 2},
  [56] = {.lex_state = 238},
  [57] = {.lex_state = 238},
  [58] = {.lex_state = 277, .external_lex_state = 3},
  [59] = {.lex_state = 277, .external_lex_state = 4},
  [60] = {.lex_state = 270, .external_lex_state = 5},
  [61] = {.lex_state = 270, .external_lex_state = 5},
  [62] = {.lex_state = 279, .external_lex_state = 5},
  [63] = {.lex_state = 277, .external_lex_state = 4},
  [64] = {.lex_state = 270, .external_lex_state = 7},
  [65] = {.lex_state = 281, .external_lex_state = 8},
  [66] = {.lex_state = 206},
  [67] = {.lex_state = 135, .external_lex_state = 2},
  [68] = {.lex_state = 234, .external_lex_state = 2},
  [69] = {.lex_state = 206},
  [70] = {.lex_state = 283, .external_lex_state = 4},
  [71] = {.lex_state = 206},
  [72] = {.lex_state = 238},
  [73] = {.lex_state = 238},
  [74] = {.lex_state = 286, .external_lex_state = 11},
  [75] = {.lex_state = 254},
  [76] = {.lex_state = 261},
  [77] = {.lex_state = 286, .external_lex_state = 11},
  [78] = {.lex_state = 264, .external_lex_state = 6},
  [79] = {.lex_state = 135, .external_lex_state = 2},
  [80] = {.lex_state = 135, .external_lex_state = 2},
  [81] = {.lex_state = 135, .external_lex_state = 2},
  [82] = {.lex_state = 286, .external_lex_state = 12},
  [83] = {.lex_state = 238},
  [84] = {.lex_state = 238},
  [85] = {.lex_state = 294, .external_lex_state = 13},
  [86] = {.lex_state = 254},
  [87] = {.lex_state = 261},
  [88] = {.lex_state = 294, .external_lex_state = 13},
  [89] = {.lex_state = 264, .external_lex_state = 6},
  [90] = {.lex_state = 135, .external_lex_state = 2},
  [91] = {.lex_state = 135, .external_lex_state = 2},
  [92] = {.lex_state = 135, .external_lex_state = 2},
  [93] = {.lex_state = 294},
  [94] = {.lex_state = 206},
  [95] = {.lex_state = 244, .external_lex_state = 14},
  [96] = {.lex_state = 254},
  [97] = {.lex_state = 261},
  [98] = {.lex_state = 244, .external_lex_state = 14},
  [99] = {.lex_state = 264, .external_lex_state = 6},
  [100] = {.lex_state = 135, .external_lex_state = 2},
  [101] = {.lex_state = 135, .external_lex_state = 2},
  [102] = {.lex_state = 135, .external_lex_state = 2},
  [103] = {.lex_state = 277, .external_lex_state = 3},
  [104] = {.lex_state = 206},
  [105] = {.lex_state = 244, .external_lex_state = 3},
  [106] = {.lex_state = 244, .external_lex_state = 10},
  [107] = {.lex_state = 254},
  [108] = {.lex_state = 261},
  [109] = {.lex_state = 244, .external_lex_state = 10},
  [110] = {.lex_state = 264, .external_lex_state = 6},
  [111] = {.lex_state = 135, .external_lex_state = 2},
  [112] = {.lex_state = 135, .external_lex_state = 2},
  [113] = {.lex_state = 135, .external_lex_state = 2},
  [114] = {.lex_state = 277, .external_lex_state = 4},
  [115] = {.lex_state = 244, .external_lex_state = 4},
  [116] = {.lex_state = 234, .external_lex_state = 15},
  [117] = {.lex_state = 254},
  [118] = {.lex_state = 261},
  [119] = {.lex_state = 234, .external_lex_state = 15},
  [120] = {.lex_state = 264, .external_lex_state = 6},
  [121] = {.lex_state = 135, .external_lex_state = 2},
  [122] = {.lex_state = 135, .external_lex_state = 2},
  [123] = {.lex_state = 135, .external_lex_state = 2},
  [124] = {.lex_state = 234, .external_lex_state = 2},
  [125] = {.lex_state = 234},
  [126] = {.lex_state = 249, .external_lex_state = 5},
  [127] = {.lex_state = 270, .external_lex_state = 5},
  [128] = {.lex_state = 297},
  [129] = {.lex_state = 254, .external_lex_state = 13},
  [130] = {.lex_state = 264, .external_lex_state = 6},
  [131] = {.lex_state = 135, .external_lex_state = 2},
  [132] = {.lex_state = 135, .external_lex_state = 2},
  [133] = {.lex_state = 254},
  [134] = {.lex_state = 270, .external_lex_state = 5},
  [135] = {.lex_state = 270, .external_lex_state = 5},
  [136] = {.lex_state = 270, .external_lex_state = 5},
  [137] = {.lex_state = 206},
  [138] = {.lex_state = 303, .external_lex_state = 16},
  [139] = {.lex_state = 311, .external_lex_state = 6},
  [140] = {.lex_state = 303, .external_lex_state = 16},
  [141] = {.lex_state = 303, .external_lex_state = 16},
  [142] = {.lex_state = 206},
  [143] = {.lex_state = 231},
  [144] = {.lex_state = 135, .external_lex_state = 2},
  [145] = {.lex_state = 135, .external_lex_state = 2},
  [146] = {.lex_state = 234},
  [147] = {.lex_state = 234},
  [148] = {.lex_state = 135, .external_lex_state = 2},
  [149] = {.lex_state = 236, .external_lex_state = 2},
  [150] = {.lex_state = 238},
  [151] = {.lex_state = 238},
  [152] = {.lex_state = 313, .external_lex_state = 6},
  [153] = {.lex_state = 313},
  [154] = {.lex_state = 315, .external_lex_state = 17},
  [155] = {.lex_state = 254},
  [156] = {.lex_state = 261},
  [157] = {.lex_state = 315, .external_lex_state = 17},
  [158] = {.lex_state = 264, .external_lex_state = 6},
  [159] = {.lex_state = 135, .external_lex_state = 2},
  [160] = {.lex_state = 135, .external_lex_state = 2},
  [161] = {.lex_state = 135, .external_lex_state = 2},
  [162] = {.lex_state = 318, .external_lex_state = 17},
  [163] = {.lex_state = 206},
  [164] = {.lex_state = 315, .external_lex_state = 18},
  [165] = {.lex_state = 320, .external_lex_state = 2},
  [166] = {.lex_state = 206},
  [167] = {.lex_state = 315, .external_lex_state = 18},
  [168] = {.lex_state = 234, .external_lex_state = 2},
  [169] = {.lex_state = 206},
  [170] = {.lex_state = 135, .external_lex_state = 2},
  [171] = {.lex_state = 234},
  [172] = {.lex_state = 236, .external_lex_state = 2},
  [173] = {.lex_state = 238},
  [174] = {.lex_state = 238},
  [175] = {.lex_state = 322, .external_lex_state = 6},
  [176] = {.lex_state = 313},
  [177] = {.lex_state = 324, .external_lex_state = 17},
  [178] = {.lex_state = 324, .external_lex_state = 17},
  [179] = {.lex_state = 326, .external_lex_state = 17},
  [180] = {.lex_state = 206},
  [181] = {.lex_state = 324, .external_lex_state = 18},
  [182] = {.lex_state = 328, .external_lex_state = 2},
  [183] = {.lex_state = 206},
  [184] = {.lex_state = 234, .external_lex_state = 2},
  [185] = {.lex_state = 206},
  [186] = {.lex_state = 320, .external_lex_state = 2},
  [187] = {.lex_state = 206},
  [188] = {.lex_state = 135, .external_lex_state = 2},
  [189] = {.lex_state = 330, .external_lex_state = 2},
  [190] = {.lex_state = 135, .external_lex_state = 2},
  [191] = {.lex_state = 283, .external_lex_state = 4},
  [192] = {.lex_state = 333, .external_lex_state = 19},
  [193] = {.lex_state = 135},
  [194] = {.lex_state = 336},
  [195] = {.lex_state = 234},
  [196] = {.lex_state = 356, .external_lex_state = 20},
  [197] = {.lex_state = 234},
  [198] = {.lex_state = 249, .external_lex_state = 5},
  [199] = {.lex_state = 249, .external_lex_state = 5},
  [200] = {.lex_state = 283, .external_lex_state = 4},
  [201] = {.lex_state = 358, .external_lex_state = 7},
  [202] = {.lex_state = 249, .external_lex_state = 7},
  [203] = {.lex_state = 135, .external_lex_state = 2},
  [204] = {.lex_state = 249, .external_lex_state = 7},
  [205] = {.lex_state = 234, .external_lex_state = 2},
  [206] = {.lex_state = 234, .external_lex_state = 15},
  [207] = {.lex_state = 234, .external_lex_state = 15},
  [208] = {.lex_state = 234, .external_lex_state = 2},
  [209] = {.lex_state = 362, .external_lex_state = 11},
  [210] = {.lex_state = 362, .external_lex_state = 11},
  [211] = {.lex_state = 362, .external_lex_state = 11},
  [212] = {.lex_state = 281, .external_lex_state = 8},
  [213] = {.lex_state = 320},
  [214] = {.lex_state = 268, .external_lex_state = 21},
  [215] = {.lex_state = 254},
  [216] = {.lex_state = 261},
  [217] = {.lex_state = 268, .external_lex_state = 21},
  [218] = {.lex_state = 264, .external_lex_state = 6},
  [219] = {.lex_state = 135, .external_lex_state = 2},
  [220] = {.lex_state = 135, .external_lex_state = 2},
  [221] = {.lex_state = 135, .external_lex_state = 2},
  [222] = {.lex_state = 234},
  [223] = {.lex_state = 206},
  [224] = {.lex_state = 364, .external_lex_state = 2},
  [225] = {.lex_state = 358, .external_lex_state = 7},
  [226] = {.lex_state = 206},
  [227] = {.lex_state = 370, .external_lex_state = 2},
  [228] = {.lex_state = 234},
  [229] = {.lex_state = 274, .external_lex_state = 4},
  [230] = {.lex_state = 206},
  [231] = {.lex_state = 274, .external_lex_state = 10},
  [232] = {.lex_state = 274, .external_lex_state = 10},
  [233] = {.lex_state = 254},
  [234] = {.lex_state = 274, .external_lex_state = 10},
  [235] = {.lex_state = 274, .external_lex_state = 10},
  [236] = {.lex_state = 274, .external_lex_state = 10},
  [237] = {.lex_state = 274, .external_lex_state = 4},
  [238] = {.lex_state = 206},
  [239] = {.lex_state = 206},
  [240] = {.lex_state = 303, .external_lex_state = 16},
  [241] = {.lex_state = 311, .external_lex_state = 6},
  [242] = {.lex_state = 303, .external_lex_state = 16},
  [243] = {.lex_state = 303, .external_lex_state = 16},
  [244] = {.lex_state = 206},
  [245] = {.lex_state = 320, .external_lex_state = 2},
  [246] = {.lex_state = 206},
  [247] = {.lex_state = 328, .external_lex_state = 2},
  [248] = {.lex_state = 206},
  [249] = {.lex_state = 320, .external_lex_state = 2},
  [250] = {.lex_state = 206},
  [251] = {.lex_state = 380, .external_lex_state = 22},
  [252] = {.lex_state = 382, .external_lex_state = 23},
  [253] = {.lex_state = 272, .external_lex_state = 9},
  [254] = {.lex_state = 206},
  [255] = {.lex_state = 206},
  [256] = {.lex_state = 286, .external_lex_state = 12},
  [257] = {.lex_state = 294},
  [258] = {.lex_state = 206},
  [259] = {.lex_state = 277, .external_lex_state = 14},
  [260] = {.lex_state = 277, .external_lex_state = 14},
  [261] = {.lex_state = 206},
  [262] = {.lex_state = 277, .external_lex_state = 3},
  [263] = {.lex_state = 277, .external_lex_state = 10},
  [264] = {.lex_state = 277, .external_lex_state = 10},
  [265] = {.lex_state = 277, .external_lex_state = 4},
  [266] = {.lex_state = 270, .external_lex_state = 5},
  [267] = {.lex_state = 206},
  [268] = {.lex_state = 135, .external_lex_state = 2},
  [269] = {.lex_state = 283, .external_lex_state = 4},
  [270] = {.lex_state = 385, .external_lex_state = 2},
  [271] = {.lex_state = 135, .external_lex_state = 2},
  [272] = {.lex_state = 135},
  [273] = {.lex_state = 336},
  [274] = {.lex_state = 234},
  [275] = {.lex_state = 234},
  [276] = {.lex_state = 270, .external_lex_state = 5},
  [277] = {.lex_state = 270, .external_lex_state = 5},
  [278] = {.lex_state = 387, .external_lex_state = 7},
  [279] = {.lex_state = 270, .external_lex_state = 7},
  [280] = {.lex_state = 277, .external_lex_state = 4},
  [281] = {.lex_state = 281, .external_lex_state = 8},
  [282] = {.lex_state = 135, .external_lex_state = 2},
  [283] = {.lex_state = 270, .external_lex_state = 7},
  [284] = {.lex_state = 272, .external_lex_state = 9},
  [285] = {.lex_state = 238},
  [286] = {.lex_state = 389, .external_lex_state = 13},
  [287] = {.lex_state = 389, .external_lex_state = 13},
  [288] = {.lex_state = 389},
  [289] = {.lex_state = 286, .external_lex_state = 12},
  [290] = {.lex_state = 234},
  [291] = {.lex_state = 286, .external_lex_state = 11},
  [292] = {.lex_state = 286, .external_lex_state = 11},
  [293] = {.lex_state = 254},
  [294] = {.lex_state = 286, .external_lex_state = 11},
  [295] = {.lex_state = 286, .external_lex_state = 11},
  [296] = {.lex_state = 286, .external_lex_state = 11},
  [297] = {.lex_state = 206},
  [298] = {.lex_state = 303, .external_lex_state = 16},
  [299] = {.lex_state = 311, .external_lex_state = 6},
  [300] = {.lex_state = 303, .external_lex_state = 16},
  [301] = {.lex_state = 303, .external_lex_state = 16},
  [302] = {.lex_state = 206},
  [303] = {.lex_state = 320, .external_lex_state = 2},
  [304] = {.lex_state = 206},
  [305] = {.lex_state = 328, .external_lex_state = 2},
  [306] = {.lex_state = 206},
  [307] = {.lex_state = 320, .external_lex_state = 2},
  [308] = {.lex_state = 238},
  [309] = {.lex_state = 358, .external_lex_state = 23},
  [310] = {.lex_state = 391},
  [311] = {.lex_state = 389},
  [312] = {.lex_state = 294},
  [313] = {.lex_state = 234},
  [314] = {.lex_state = 294, .external_lex_state = 13},
  [315] = {.lex_state = 396, .external_lex_state = 13},
  [316] = {.lex_state = 254},
  [317] = {.lex_state = 396, .external_lex_state = 13},
  [318] = {.lex_state = 396, .external_lex_state = 13},
  [319] = {.lex_state = 396, .external_lex_state = 13},
  [320] = {.lex_state = 206},
  [321] = {.lex_state = 303, .external_lex_state = 16},
  [322] = {.lex_state = 311, .external_lex_state = 6},
  [323] = {.lex_state = 303, .external_lex_state = 16},
  [324] = {.lex_state = 303, .external_lex_state = 16},
  [325] = {.lex_state = 206},
  [326] = {.lex_state = 320, .external_lex_state = 2},
  [327] = {.lex_state = 206},
  [328] = {.lex_state = 328, .external_lex_state = 2},
  [329] = {.lex_state = 206},
  [330] = {.lex_state = 320, .external_lex_state = 2},
  [331] = {.lex_state = 238},
  [332] = {.lex_state = 391},
  [333] = {.lex_state = 272, .external_lex_state = 9},
  [334] = {.lex_state = 234},
  [335] = {.lex_state = 244, .external_lex_state = 14},
  [336] = {.lex_state = 277, .external_lex_state = 14},
  [337] = {.lex_state = 254},
  [338] = {.lex_state = 277, .external_lex_state = 14},
  [339] = {.lex_state = 277, .external_lex_state = 14},
  [340] = {.lex_state = 277, .external_lex_state = 14},
  [341] = {.lex_state = 206},
  [342] = {.lex_state = 303, .external_lex_state = 16},
  [343] = {.lex_state = 311, .external_lex_state = 6},
  [344] = {.lex_state = 303, .external_lex_state = 16},
  [345] = {.lex_state = 303, .external_lex_state = 16},
  [346] = {.lex_state = 206},
  [347] = {.lex_state = 320, .external_lex_state = 2},
  [348] = {.lex_state = 206},
  [349] = {.lex_state = 328, .external_lex_state = 2},
  [350] = {.lex_state = 206},
  [351] = {.lex_state = 320, .external_lex_state = 2},
  [352] = {.lex_state = 244, .external_lex_state = 3},
  [353] = {.lex_state = 234},
  [354] = {.lex_state = 244, .external_lex_state = 10},
  [355] = {.lex_state = 277, .external_lex_state = 10},
  [356] = {.lex_state = 254},
  [357] = {.lex_state = 277, .external_lex_state = 10},
  [358] = {.lex_state = 277, .external_lex_state = 10},
  [359] = {.lex_state = 277, .external_lex_state = 10},
  [360] = {.lex_state = 206},
  [361] = {.lex_state = 303, .external_lex_state = 16},
  [362] = {.lex_state = 311, .external_lex_state = 6},
  [363] = {.lex_state = 303, .external_lex_state = 16},
  [364] = {.lex_state = 303, .external_lex_state = 16},
  [365] = {.lex_state = 206},
  [366] = {.lex_state = 320, .external_lex_state = 2},
  [367] = {.lex_state = 206},
  [368] = {.lex_state = 328, .external_lex_state = 2},
  [369] = {.lex_state = 206},
  [370] = {.lex_state = 320, .external_lex_state = 2},
  [371] = {.lex_state = 244, .external_lex_state = 4},
  [372] = {.lex_state = 234},
  [373] = {.lex_state = 234, .external_lex_state = 15},
  [374] = {.lex_state = 320, .external_lex_state = 15},
  [375] = {.lex_state = 254},
  [376] = {.lex_state = 320, .external_lex_state = 15},
  [377] = {.lex_state = 320, .external_lex_state = 15},
  [378] = {.lex_state = 320, .external_lex_state = 15},
  [379] = {.lex_state = 206},
  [380] = {.lex_state = 303, .external_lex_state = 16},
  [381] = {.lex_state = 311, .external_lex_state = 6},
  [382] = {.lex_state = 303, .external_lex_state = 16},
  [383] = {.lex_state = 303, .external_lex_state = 16},
  [384] = {.lex_state = 206},
  [385] = {.lex_state = 320, .external_lex_state = 2},
  [386] = {.lex_state = 206},
  [387] = {.lex_state = 328, .external_lex_state = 2},
  [388] = {.lex_state = 206},
  [389] = {.lex_state = 320, .external_lex_state = 2},
  [390] = {.lex_state = 270, .external_lex_state = 5},
  [391] = {.lex_state = 249, .external_lex_state = 5},
  [392] = {.lex_state = 254, .external_lex_state = 13},
  [393] = {.lex_state = 254, .external_lex_state = 13},
  [394] = {.lex_state = 254, .external_lex_state = 13},
  [395] = {.lex_state = 254},
  [396] = {.lex_state = 206},
  [397] = {.lex_state = 303, .external_lex_state = 16},
  [398] = {.lex_state = 311, .external_lex_state = 6},
  [399] = {.lex_state = 303, .external_lex_state = 16},
  [400] = {.lex_state = 303, .external_lex_state = 16},
  [401] = {.lex_state = 206},
  [402] = {.lex_state = 320, .external_lex_state = 2},
  [403] = {.lex_state = 206},
  [404] = {.lex_state = 328, .external_lex_state = 2},
  [405] = {.lex_state = 270, .external_lex_state = 5},
  [406] = {.lex_state = 254},
  [407] = {.lex_state = 234},
  [408] = {.lex_state = 399, .external_lex_state = 16},
  [409] = {.lex_state = 270, .external_lex_state = 5},
  [410] = {.lex_state = 401, .external_lex_state = 24},
  [411] = {.lex_state = 254},
  [412] = {.lex_state = 261},
  [413] = {.lex_state = 401, .external_lex_state = 24},
  [414] = {.lex_state = 264, .external_lex_state = 6},
  [415] = {.lex_state = 403},
  [416] = {.lex_state = 135, .external_lex_state = 2},
  [417] = {.lex_state = 135, .external_lex_state = 2},
  [418] = {.lex_state = 135, .external_lex_state = 2},
  [419] = {.lex_state = 401, .external_lex_state = 16},
  [420] = {.lex_state = 206},
  [421] = {.lex_state = 303, .external_lex_state = 16},
  [422] = {.lex_state = 303, .external_lex_state = 16},
  [423] = {.lex_state = 303, .external_lex_state = 16},
  [424] = {.lex_state = 270, .external_lex_state = 5},
  [425] = {.lex_state = 403},
  [426] = {.lex_state = 401, .external_lex_state = 16},
  [427] = {.lex_state = 270, .external_lex_state = 5},
  [428] = {.lex_state = 403},
  [429] = {.lex_state = 401, .external_lex_state = 16},
  [430] = {.lex_state = 272, .external_lex_state = 9},
  [431] = {.lex_state = 274, .external_lex_state = 4},
  [432] = {.lex_state = 206},
  [433] = {.lex_state = 206},
  [434] = {.lex_state = 274, .external_lex_state = 10},
  [435] = {.lex_state = 274, .external_lex_state = 10},
  [436] = {.lex_state = 274, .external_lex_state = 4},
  [437] = {.lex_state = 206},
  [438] = {.lex_state = 277, .external_lex_state = 4},
  [439] = {.lex_state = 281, .external_lex_state = 8},
  [440] = {.lex_state = 135, .external_lex_state = 2},
  [441] = {.lex_state = 206},
  [442] = {.lex_state = 286, .external_lex_state = 12},
  [443] = {.lex_state = 294},
  [444] = {.lex_state = 206},
  [445] = {.lex_state = 313, .external_lex_state = 25},
  [446] = {.lex_state = 254},
  [447] = {.lex_state = 261},
  [448] = {.lex_state = 313, .external_lex_state = 25},
  [449] = {.lex_state = 264, .external_lex_state = 6},
  [450] = {.lex_state = 135, .external_lex_state = 2},
  [451] = {.lex_state = 135, .external_lex_state = 2},
  [452] = {.lex_state = 135, .external_lex_state = 2},
  [453] = {.lex_state = 313, .external_lex_state = 6},
  [454] = {.lex_state = 206},
  [455] = {.lex_state = 313, .external_lex_state = 6},
  [456] = {.lex_state = 313, .external_lex_state = 13},
  [457] = {.lex_state = 254},
  [458] = {.lex_state = 261},
  [459] = {.lex_state = 313, .external_lex_state = 13},
  [460] = {.lex_state = 264, .external_lex_state = 6},
  [461] = {.lex_state = 135, .external_lex_state = 2},
  [462] = {.lex_state = 135, .external_lex_state = 2},
  [463] = {.lex_state = 135, .external_lex_state = 2},
  [464] = {.lex_state = 313},
  [465] = {.lex_state = 313},
  [466] = {.lex_state = 234},
  [467] = {.lex_state = 315, .external_lex_state = 17},
  [468] = {.lex_state = 315, .external_lex_state = 17},
  [469] = {.lex_state = 254},
  [470] = {.lex_state = 315, .external_lex_state = 17},
  [471] = {.lex_state = 315, .external_lex_state = 17},
  [472] = {.lex_state = 315, .external_lex_state = 17},
  [473] = {.lex_state = 206},
  [474] = {.lex_state = 303, .external_lex_state = 16},
  [475] = {.lex_state = 311, .external_lex_state = 6},
  [476] = {.lex_state = 303, .external_lex_state = 16},
  [477] = {.lex_state = 303, .external_lex_state = 16},
  [478] = {.lex_state = 206},
  [479] = {.lex_state = 320, .external_lex_state = 2},
  [480] = {.lex_state = 206},
  [481] = {.lex_state = 328, .external_lex_state = 2},
  [482] = {.lex_state = 206},
  [483] = {.lex_state = 320, .external_lex_state = 2},
  [484] = {.lex_state = 206},
  [485] = {.lex_state = 135, .external_lex_state = 2},
  [486] = {.lex_state = 270, .external_lex_state = 5},
  [487] = {.lex_state = 135, .external_lex_state = 2},
  [488] = {.lex_state = 206},
  [489] = {.lex_state = 333, .external_lex_state = 19},
  [490] = {.lex_state = 135},
  [491] = {.lex_state = 336},
  [492] = {.lex_state = 234},
  [493] = {.lex_state = 356, .external_lex_state = 20},
  [494] = {.lex_state = 234},
  [495] = {.lex_state = 315, .external_lex_state = 17},
  [496] = {.lex_state = 315, .external_lex_state = 17},
  [497] = {.lex_state = 206},
  [498] = {.lex_state = 408, .external_lex_state = 18},
  [499] = {.lex_state = 315, .external_lex_state = 18},
  [500] = {.lex_state = 315, .external_lex_state = 18},
  [501] = {.lex_state = 272, .external_lex_state = 9},
  [502] = {.lex_state = 206},
  [503] = {.lex_state = 206},
  [504] = {.lex_state = 286, .external_lex_state = 12},
  [505] = {.lex_state = 294},
  [506] = {.lex_state = 206},
  [507] = {.lex_state = 322, .external_lex_state = 25},
  [508] = {.lex_state = 322, .external_lex_state = 25},
  [509] = {.lex_state = 206},
  [510] = {.lex_state = 322, .external_lex_state = 6},
  [511] = {.lex_state = 322, .external_lex_state = 13},
  [512] = {.lex_state = 322, .external_lex_state = 13},
  [513] = {.lex_state = 313},
  [514] = {.lex_state = 324, .external_lex_state = 17},
  [515] = {.lex_state = 206},
  [516] = {.lex_state = 135, .external_lex_state = 2},
  [517] = {.lex_state = 135, .external_lex_state = 2},
  [518] = {.lex_state = 135},
  [519] = {.lex_state = 336},
  [520] = {.lex_state = 234},
  [521] = {.lex_state = 234},
  [522] = {.lex_state = 324, .external_lex_state = 17},
  [523] = {.lex_state = 324, .external_lex_state = 17},
  [524] = {.lex_state = 410, .external_lex_state = 18},
  [525] = {.lex_state = 324, .external_lex_state = 18},
  [526] = {.lex_state = 324, .external_lex_state = 18},
  [527] = {.lex_state = 270, .external_lex_state = 5},
  [528] = {.lex_state = 206},
  [529] = {.lex_state = 283, .external_lex_state = 4},
  [530] = {.lex_state = 281, .external_lex_state = 8},
  [531] = {.lex_state = 244, .external_lex_state = 4},
  [532] = {.lex_state = 268, .external_lex_state = 8},
  [533] = {.lex_state = 283, .external_lex_state = 4},
  [534] = {.lex_state = 261},
  [535] = {.lex_state = 264, .external_lex_state = 6},
  [536] = {.lex_state = 333, .external_lex_state = 19},
  [537] = {.lex_state = 234},
  [538] = {.lex_state = 249, .external_lex_state = 5},
  [539] = {.lex_state = 249, .external_lex_state = 5},
  [540] = {.lex_state = 270, .external_lex_state = 7},
  [541] = {.lex_state = 358, .external_lex_state = 5},
  [542] = {.lex_state = 358, .external_lex_state = 5},
  [543] = {.lex_state = 412, .external_lex_state = 7},
  [544] = {.lex_state = 412, .external_lex_state = 7},
  [545] = {.lex_state = 358, .external_lex_state = 5},
  [546] = {.lex_state = 358, .external_lex_state = 5},
  [547] = {.lex_state = 412, .external_lex_state = 7},
  [548] = {.lex_state = 283, .external_lex_state = 4},
  [549] = {.lex_state = 358, .external_lex_state = 7},
  [550] = {.lex_state = 358, .external_lex_state = 7},
  [551] = {.lex_state = 249, .external_lex_state = 7},
  [552] = {.lex_state = 249, .external_lex_state = 7},
  [553] = {.lex_state = 414, .external_lex_state = 12},
  [554] = {.lex_state = 416, .external_lex_state = 13},
  [555] = {.lex_state = 362, .external_lex_state = 11},
  [556] = {.lex_state = 414, .external_lex_state = 12},
  [557] = {.lex_state = 416, .external_lex_state = 13},
  [558] = {.lex_state = 206, .external_lex_state = 12},
  [559] = {.lex_state = 281, .external_lex_state = 8},
  [560] = {.lex_state = 418, .external_lex_state = 13},
  [561] = {.lex_state = 254},
  [562] = {.lex_state = 261},
  [563] = {.lex_state = 418, .external_lex_state = 13},
  [564] = {.lex_state = 264, .external_lex_state = 6},
  [565] = {.lex_state = 135, .external_lex_state = 2},
  [566] = {.lex_state = 135, .external_lex_state = 2},
  [567] = {.lex_state = 135, .external_lex_state = 2},
  [568] = {.lex_state = 320},
  [569] = {.lex_state = 234},
  [570] = {.lex_state = 268, .external_lex_state = 21},
  [571] = {.lex_state = 281, .external_lex_state = 21},
  [572] = {.lex_state = 254},
  [573] = {.lex_state = 281, .external_lex_state = 21},
  [574] = {.lex_state = 281, .external_lex_state = 21},
  [575] = {.lex_state = 281, .external_lex_state = 21},
  [576] = {.lex_state = 206},
  [577] = {.lex_state = 303, .external_lex_state = 16},
  [578] = {.lex_state = 311, .external_lex_state = 6},
  [579] = {.lex_state = 303, .external_lex_state = 16},
  [580] = {.lex_state = 303, .external_lex_state = 16},
  [581] = {.lex_state = 206},
  [582] = {.lex_state = 320, .external_lex_state = 2},
  [583] = {.lex_state = 206},
  [584] = {.lex_state = 328, .external_lex_state = 2},
  [585] = {.lex_state = 206},
  [586] = {.lex_state = 320, .external_lex_state = 2},
  [587] = {.lex_state = 420, .external_lex_state = 10},
  [588] = {.lex_state = 254},
  [589] = {.lex_state = 261},
  [590] = {.lex_state = 420, .external_lex_state = 10},
  [591] = {.lex_state = 264, .external_lex_state = 6},
  [592] = {.lex_state = 135, .external_lex_state = 2},
  [593] = {.lex_state = 135, .external_lex_state = 2},
  [594] = {.lex_state = 135, .external_lex_state = 2},
  [595] = {.lex_state = 420, .external_lex_state = 4},
  [596] = {.lex_state = 364, .external_lex_state = 2},
  [597] = {.lex_state = 283, .external_lex_state = 4},
  [598] = {.lex_state = 412, .external_lex_state = 7},
  [599] = {.lex_state = 244, .external_lex_state = 4},
  [600] = {.lex_state = 268, .external_lex_state = 8},
  [601] = {.lex_state = 364, .external_lex_state = 2},
  [602] = {.lex_state = 283, .external_lex_state = 4},
  [603] = {.lex_state = 358, .external_lex_state = 7},
  [604] = {.lex_state = 283, .external_lex_state = 4},
  [605] = {.lex_state = 135, .external_lex_state = 2},
  [606] = {.lex_state = 422, .external_lex_state = 2},
  [607] = {.lex_state = 244, .external_lex_state = 4},
  [608] = {.lex_state = 206},
  [609] = {.lex_state = 206},
  [610] = {.lex_state = 268, .external_lex_state = 8},
  [611] = {.lex_state = 370, .external_lex_state = 2},
  [612] = {.lex_state = 206},
  [613] = {.lex_state = 274, .external_lex_state = 10},
  [614] = {.lex_state = 424},
  [615] = {.lex_state = 274, .external_lex_state = 4},
  [616] = {.lex_state = 274, .external_lex_state = 10},
  [617] = {.lex_state = 274, .external_lex_state = 10},
  [618] = {.lex_state = 424},
  [619] = {.lex_state = 274, .external_lex_state = 4},
  [620] = {.lex_state = 399, .external_lex_state = 16},
  [621] = {.lex_state = 274, .external_lex_state = 10},
  [622] = {.lex_state = 403},
  [623] = {.lex_state = 401, .external_lex_state = 16},
  [624] = {.lex_state = 206},
  [625] = {.lex_state = 303, .external_lex_state = 16},
  [626] = {.lex_state = 303, .external_lex_state = 16},
  [627] = {.lex_state = 303, .external_lex_state = 16},
  [628] = {.lex_state = 274, .external_lex_state = 10},
  [629] = {.lex_state = 403},
  [630] = {.lex_state = 401, .external_lex_state = 16},
  [631] = {.lex_state = 274, .external_lex_state = 10},
  [632] = {.lex_state = 403},
  [633] = {.lex_state = 401, .external_lex_state = 16},
  [634] = {.lex_state = 274, .external_lex_state = 10},
  [635] = {.lex_state = 274, .external_lex_state = 10},
  [636] = {.lex_state = 206},
  [637] = {.lex_state = 430, .external_lex_state = 23},
  [638] = {.lex_state = 244, .external_lex_state = 4},
  [639] = {.lex_state = 268, .external_lex_state = 8},
  [640] = {.lex_state = 380, .external_lex_state = 22},
  [641] = {.lex_state = 135},
  [642] = {.lex_state = 234},
  [643] = {.lex_state = 283, .external_lex_state = 4},
  [644] = {.lex_state = 281, .external_lex_state = 21},
  [645] = {.lex_state = 281, .external_lex_state = 21},
  [646] = {.lex_state = 387, .external_lex_state = 7},
  [647] = {.lex_state = 206},
  [648] = {.lex_state = 432, .external_lex_state = 23},
  [649] = {.lex_state = 387, .external_lex_state = 23},
  [650] = {.lex_state = 272, .external_lex_state = 9},
  [651] = {.lex_state = 277, .external_lex_state = 14},
  [652] = {.lex_state = 277, .external_lex_state = 3},
  [653] = {.lex_state = 277, .external_lex_state = 10},
  [654] = {.lex_state = 277, .external_lex_state = 4},
  [655] = {.lex_state = 270, .external_lex_state = 5},
  [656] = {.lex_state = 206},
  [657] = {.lex_state = 283, .external_lex_state = 4},
  [658] = {.lex_state = 277, .external_lex_state = 4},
  [659] = {.lex_state = 281, .external_lex_state = 8},
  [660] = {.lex_state = 234},
  [661] = {.lex_state = 270, .external_lex_state = 5},
  [662] = {.lex_state = 270, .external_lex_state = 5},
  [663] = {.lex_state = 387, .external_lex_state = 5},
  [664] = {.lex_state = 387, .external_lex_state = 5},
  [665] = {.lex_state = 387, .external_lex_state = 5},
  [666] = {.lex_state = 387, .external_lex_state = 5},
  [667] = {.lex_state = 387, .external_lex_state = 7},
  [668] = {.lex_state = 387, .external_lex_state = 7},
  [669] = {.lex_state = 270, .external_lex_state = 7},
  [670] = {.lex_state = 385, .external_lex_state = 2},
  [671] = {.lex_state = 270, .external_lex_state = 7},
  [672] = {.lex_state = 320, .external_lex_state = 2},
  [673] = {.lex_state = 320},
  [674] = {.lex_state = 234, .external_lex_state = 15},
  [675] = {.lex_state = 234, .external_lex_state = 15},
  [676] = {.lex_state = 389},
  [677] = {.lex_state = 389, .external_lex_state = 13},
  [678] = {.lex_state = 286, .external_lex_state = 12},
  [679] = {.lex_state = 238},
  [680] = {.lex_state = 391},
  [681] = {.lex_state = 286, .external_lex_state = 11},
  [682] = {.lex_state = 286, .external_lex_state = 11},
  [683] = {.lex_state = 286, .external_lex_state = 11},
  [684] = {.lex_state = 399, .external_lex_state = 16},
  [685] = {.lex_state = 286, .external_lex_state = 11},
  [686] = {.lex_state = 403},
  [687] = {.lex_state = 401, .external_lex_state = 16},
  [688] = {.lex_state = 206},
  [689] = {.lex_state = 303, .external_lex_state = 16},
  [690] = {.lex_state = 303, .external_lex_state = 16},
  [691] = {.lex_state = 303, .external_lex_state = 16},
  [692] = {.lex_state = 286, .external_lex_state = 11},
  [693] = {.lex_state = 403},
  [694] = {.lex_state = 401, .external_lex_state = 16},
  [695] = {.lex_state = 286, .external_lex_state = 11},
  [696] = {.lex_state = 403},
  [697] = {.lex_state = 401, .external_lex_state = 16},
  [698] = {.lex_state = 286, .external_lex_state = 11},
  [699] = {.lex_state = 286, .external_lex_state = 11},
  [700] = {.lex_state = 286, .external_lex_state = 12},
  [701] = {.lex_state = 135},
  [702] = {.lex_state = 234},
  [703] = {.lex_state = 356, .external_lex_state = 20},
  [704] = {.lex_state = 234},
  [705] = {.lex_state = 358, .external_lex_state = 23},
  [706] = {.lex_state = 286, .external_lex_state = 12},
  [707] = {.lex_state = 434},
  [708] = {.lex_state = 396, .external_lex_state = 13},
  [709] = {.lex_state = 294, .external_lex_state = 13},
  [710] = {.lex_state = 396, .external_lex_state = 13},
  [711] = {.lex_state = 399, .external_lex_state = 16},
  [712] = {.lex_state = 396, .external_lex_state = 13},
  [713] = {.lex_state = 403},
  [714] = {.lex_state = 401, .external_lex_state = 16},
  [715] = {.lex_state = 206},
  [716] = {.lex_state = 303, .external_lex_state = 16},
  [717] = {.lex_state = 303, .external_lex_state = 16},
  [718] = {.lex_state = 303, .external_lex_state = 16},
  [719] = {.lex_state = 396, .external_lex_state = 13},
  [720] = {.lex_state = 403},
  [721] = {.lex_state = 401, .external_lex_state = 16},
  [722] = {.lex_state = 396, .external_lex_state = 13},
  [723] = {.lex_state = 403},
  [724] = {.lex_state = 401, .external_lex_state = 16},
  [725] = {.lex_state = 396, .external_lex_state = 13},
  [726] = {.lex_state = 396, .external_lex_state = 13},
  [727] = {.lex_state = 434},
  [728] = {.lex_state = 434},
  [729] = {.lex_state = 277, .external_lex_state = 3},
  [730] = {.lex_state = 320},
  [731] = {.lex_state = 244, .external_lex_state = 14},
  [732] = {.lex_state = 244, .external_lex_state = 14},
  [733] = {.lex_state = 277, .external_lex_state = 14},
  [734] = {.lex_state = 244, .external_lex_state = 14},
  [735] = {.lex_state = 277, .external_lex_state = 14},
  [736] = {.lex_state = 399, .external_lex_state = 16},
  [737] = {.lex_state = 277, .external_lex_state = 14},
  [738] = {.lex_state = 403},
  [739] = {.lex_state = 401, .external_lex_state = 16},
  [740] = {.lex_state = 206},
  [741] = {.lex_state = 303, .external_lex_state = 16},
  [742] = {.lex_state = 303, .external_lex_state = 16},
  [743] = {.lex_state = 303, .external_lex_state = 16},
  [744] = {.lex_state = 277, .external_lex_state = 14},
  [745] = {.lex_state = 403},
  [746] = {.lex_state = 401, .external_lex_state = 16},
  [747] = {.lex_state = 277, .external_lex_state = 14},
  [748] = {.lex_state = 403},
  [749] = {.lex_state = 401, .external_lex_state = 16},
  [750] = {.lex_state = 277, .external_lex_state = 14},
  [751] = {.lex_state = 277, .external_lex_state = 14},
  [752] = {.lex_state = 277, .external_lex_state = 10},
  [753] = {.lex_state = 244, .external_lex_state = 10},
  [754] = {.lex_state = 277, .external_lex_state = 10},
  [755] = {.lex_state = 399, .external_lex_state = 16},
  [756] = {.lex_state = 277, .external_lex_state = 10},
  [757] = {.lex_state = 403},
  [758] = {.lex_state = 401, .external_lex_state = 16},
  [759] = {.lex_state = 206},
  [760] = {.lex_state = 303, .external_lex_state = 16},
  [761] = {.lex_state = 303, .external_lex_state = 16},
  [762] = {.lex_state = 303, .external_lex_state = 16},
  [763] = {.lex_state = 277, .external_lex_state = 10},
  [764] = {.lex_state = 403},
  [765] = {.lex_state = 401, .external_lex_state = 16},
  [766] = {.lex_state = 277, .external_lex_state = 10},
  [767] = {.lex_state = 403},
  [768] = {.lex_state = 401, .external_lex_state = 16},
  [769] = {.lex_state = 277, .external_lex_state = 10},
  [770] = {.lex_state = 277, .external_lex_state = 10},
  [771] = {.lex_state = 320, .external_lex_state = 15},
  [772] = {.lex_state = 234, .external_lex_state = 15},
  [773] = {.lex_state = 320, .external_lex_state = 15},
  [774] = {.lex_state = 399, .external_lex_state = 16},
  [775] = {.lex_state = 320, .external_lex_state = 15},
  [776] = {.lex_state = 403},
  [777] = {.lex_state = 401, .external_lex_state = 16},
  [778] = {.lex_state = 206},
  [779] = {.lex_state = 303, .external_lex_state = 16},
  [780] = {.lex_state = 303, .external_lex_state = 16},
  [781] = {.lex_state = 303, .external_lex_state = 16},
  [782] = {.lex_state = 320, .external_lex_state = 15},
  [783] = {.lex_state = 403},
  [784] = {.lex_state = 401, .external_lex_state = 16},
  [785] = {.lex_state = 320, .external_lex_state = 15},
  [786] = {.lex_state = 403},
  [787] = {.lex_state = 401, .external_lex_state = 16},
  [788] = {.lex_state = 320, .external_lex_state = 15},
  [789] = {.lex_state = 320, .external_lex_state = 15},
  [790] = {.lex_state = 254},
  [791] = {.lex_state = 399, .external_lex_state = 16},
  [792] = {.lex_state = 254, .external_lex_state = 13},
  [793] = {.lex_state = 403},
  [794] = {.lex_state = 401, .external_lex_state = 16},
  [795] = {.lex_state = 206},
  [796] = {.lex_state = 303, .external_lex_state = 16},
  [797] = {.lex_state = 303, .external_lex_state = 16},
  [798] = {.lex_state = 303, .external_lex_state = 16},
  [799] = {.lex_state = 254, .external_lex_state = 13},
  [800] = {.lex_state = 403},
  [801] = {.lex_state = 401, .external_lex_state = 16},
  [802] = {.lex_state = 254, .external_lex_state = 13},
  [803] = {.lex_state = 403},
  [804] = {.lex_state = 401, .external_lex_state = 16},
  [805] = {.lex_state = 254, .external_lex_state = 13},
  [806] = {.lex_state = 362, .external_lex_state = 11},
  [807] = {.lex_state = 362, .external_lex_state = 11},
  [808] = {.lex_state = 362, .external_lex_state = 11},
  [809] = {.lex_state = 270, .external_lex_state = 5},
  [810] = {.lex_state = 436, .external_lex_state = 24},
  [811] = {.lex_state = 254},
  [812] = {.lex_state = 261},
  [813] = {.lex_state = 436, .external_lex_state = 24},
  [814] = {.lex_state = 264, .external_lex_state = 6},
  [815] = {.lex_state = 135, .external_lex_state = 2},
  [816] = {.lex_state = 135, .external_lex_state = 2},
  [817] = {.lex_state = 135, .external_lex_state = 2},
  [818] = {.lex_state = 206, .external_lex_state = 16},
  [819] = {.lex_state = 234},
  [820] = {.lex_state = 401, .external_lex_state = 24},
  [821] = {.lex_state = 401, .external_lex_state = 24},
  [822] = {.lex_state = 254},
  [823] = {.lex_state = 401, .external_lex_state = 24},
  [824] = {.lex_state = 401, .external_lex_state = 24},
  [825] = {.lex_state = 401, .external_lex_state = 24},
  [826] = {.lex_state = 206},
  [827] = {.lex_state = 303, .external_lex_state = 16},
  [828] = {.lex_state = 311, .external_lex_state = 6},
  [829] = {.lex_state = 303, .external_lex_state = 16},
  [830] = {.lex_state = 303, .external_lex_state = 16},
  [831] = {.lex_state = 401, .external_lex_state = 16},
  [832] = {.lex_state = 206},
  [833] = {.lex_state = 320, .external_lex_state = 2},
  [834] = {.lex_state = 206},
  [835] = {.lex_state = 328, .external_lex_state = 2},
  [836] = {.lex_state = 206},
  [837] = {.lex_state = 320, .external_lex_state = 2},
  [838] = {.lex_state = 270, .external_lex_state = 5},
  [839] = {.lex_state = 401, .external_lex_state = 16},
  [840] = {.lex_state = 399, .external_lex_state = 16},
  [841] = {.lex_state = 270, .external_lex_state = 5},
  [842] = {.lex_state = 403},
  [843] = {.lex_state = 401, .external_lex_state = 16},
  [844] = {.lex_state = 270, .external_lex_state = 5},
  [845] = {.lex_state = 403},
  [846] = {.lex_state = 401, .external_lex_state = 16},
  [847] = {.lex_state = 403},
  [848] = {.lex_state = 401, .external_lex_state = 16},
  [849] = {.lex_state = 401, .external_lex_state = 16},
  [850] = {.lex_state = 270, .external_lex_state = 5},
  [851] = {.lex_state = 401, .external_lex_state = 16},
  [852] = {.lex_state = 320, .external_lex_state = 15},
  [853] = {.lex_state = 320, .external_lex_state = 15},
  [854] = {.lex_state = 234},
  [855] = {.lex_state = 206},
  [856] = {.lex_state = 364, .external_lex_state = 2},
  [857] = {.lex_state = 408, .external_lex_state = 18},
  [858] = {.lex_state = 370, .external_lex_state = 2},
  [859] = {.lex_state = 274, .external_lex_state = 4},
  [860] = {.lex_state = 206},
  [861] = {.lex_state = 274, .external_lex_state = 4},
  [862] = {.lex_state = 206},
  [863] = {.lex_state = 206},
  [864] = {.lex_state = 380, .external_lex_state = 22},
  [865] = {.lex_state = 438, .external_lex_state = 26},
  [866] = {.lex_state = 206},
  [867] = {.lex_state = 385, .external_lex_state = 2},
  [868] = {.lex_state = 277, .external_lex_state = 4},
  [869] = {.lex_state = 281, .external_lex_state = 8},
  [870] = {.lex_state = 408, .external_lex_state = 26},
  [871] = {.lex_state = 272, .external_lex_state = 9},
  [872] = {.lex_state = 234},
  [873] = {.lex_state = 313, .external_lex_state = 25},
  [874] = {.lex_state = 313, .external_lex_state = 25},
  [875] = {.lex_state = 254},
  [876] = {.lex_state = 313, .external_lex_state = 25},
  [877] = {.lex_state = 313, .external_lex_state = 25},
  [878] = {.lex_state = 313, .external_lex_state = 25},
  [879] = {.lex_state = 206},
  [880] = {.lex_state = 303, .external_lex_state = 16},
  [881] = {.lex_state = 311, .external_lex_state = 6},
  [882] = {.lex_state = 303, .external_lex_state = 16},
  [883] = {.lex_state = 303, .external_lex_state = 16},
  [884] = {.lex_state = 206},
  [885] = {.lex_state = 320, .external_lex_state = 2},
  [886] = {.lex_state = 206},
  [887] = {.lex_state = 328, .external_lex_state = 2},
  [888] = {.lex_state = 206},
  [889] = {.lex_state = 320, .external_lex_state = 2},
  [890] = {.lex_state = 313, .external_lex_state = 6},
  [891] = {.lex_state = 234},
  [892] = {.lex_state = 313, .external_lex_state = 13},
  [893] = {.lex_state = 313, .external_lex_state = 13},
  [894] = {.lex_state = 254},
  [895] = {.lex_state = 313, .external_lex_state = 13},
  [896] = {.lex_state = 313, .external_lex_state = 13},
  [897] = {.lex_state = 313, .external_lex_state = 13},
  [898] = {.lex_state = 206},
  [899] = {.lex_state = 303, .external_lex_state = 16},
  [900] = {.lex_state = 311, .external_lex_state = 6},
  [901] = {.lex_state = 303, .external_lex_state = 16},
  [902] = {.lex_state = 303, .external_lex_state = 16},
  [903] = {.lex_state = 206},
  [904] = {.lex_state = 320, .external_lex_state = 2},
  [905] = {.lex_state = 206},
  [906] = {.lex_state = 328, .external_lex_state = 2},
  [907] = {.lex_state = 206},
  [908] = {.lex_state = 320, .external_lex_state = 2},
  [909] = {.lex_state = 313},
  [910] = {.lex_state = 315, .external_lex_state = 17},
  [911] = {.lex_state = 315, .external_lex_state = 17},
  [912] = {.lex_state = 315, .external_lex_state = 17},
  [913] = {.lex_state = 399, .external_lex_state = 16},
  [914] = {.lex_state = 315, .external_lex_state = 17},
  [915] = {.lex_state = 403},
  [916] = {.lex_state = 401, .external_lex_state = 16},
  [917] = {.lex_state = 206},
  [918] = {.lex_state = 303, .external_lex_state = 16},
  [919] = {.lex_state = 303, .external_lex_state = 16},
  [920] = {.lex_state = 303, .external_lex_state = 16},
  [921] = {.lex_state = 315, .external_lex_state = 17},
  [922] = {.lex_state = 403},
  [923] = {.lex_state = 401, .external_lex_state = 16},
  [924] = {.lex_state = 315, .external_lex_state = 17},
  [925] = {.lex_state = 403},
  [926] = {.lex_state = 401, .external_lex_state = 16},
  [927] = {.lex_state = 315, .external_lex_state = 17},
  [928] = {.lex_state = 315, .external_lex_state = 17},
  [929] = {.lex_state = 206},
  [930] = {.lex_state = 206},
  [931] = {.lex_state = 320, .external_lex_state = 2},
  [932] = {.lex_state = 206},
  [933] = {.lex_state = 320, .external_lex_state = 2},
  [934] = {.lex_state = 206},
  [935] = {.lex_state = 333, .external_lex_state = 19},
  [936] = {.lex_state = 234},
  [937] = {.lex_state = 315, .external_lex_state = 17},
  [938] = {.lex_state = 315, .external_lex_state = 17},
  [939] = {.lex_state = 315, .external_lex_state = 18},
  [940] = {.lex_state = 408, .external_lex_state = 17},
  [941] = {.lex_state = 408, .external_lex_state = 17},
  [942] = {.lex_state = 440, .external_lex_state = 18},
  [943] = {.lex_state = 440, .external_lex_state = 18},
  [944] = {.lex_state = 408, .external_lex_state = 17},
  [945] = {.lex_state = 408, .external_lex_state = 17},
  [946] = {.lex_state = 440, .external_lex_state = 18},
  [947] = {.lex_state = 206},
  [948] = {.lex_state = 408, .external_lex_state = 18},
  [949] = {.lex_state = 408, .external_lex_state = 18},
  [950] = {.lex_state = 315, .external_lex_state = 18},
  [951] = {.lex_state = 315, .external_lex_state = 18},
  [952] = {.lex_state = 328, .external_lex_state = 15},
  [953] = {.lex_state = 328, .external_lex_state = 15},
  [954] = {.lex_state = 410, .external_lex_state = 18},
  [955] = {.lex_state = 206},
  [956] = {.lex_state = 442, .external_lex_state = 26},
  [957] = {.lex_state = 410, .external_lex_state = 26},
  [958] = {.lex_state = 272, .external_lex_state = 9},
  [959] = {.lex_state = 322, .external_lex_state = 25},
  [960] = {.lex_state = 322, .external_lex_state = 6},
  [961] = {.lex_state = 322, .external_lex_state = 13},
  [962] = {.lex_state = 313},
  [963] = {.lex_state = 324, .external_lex_state = 17},
  [964] = {.lex_state = 206},
  [965] = {.lex_state = 328, .external_lex_state = 2},
  [966] = {.lex_state = 206},
  [967] = {.lex_state = 328, .external_lex_state = 2},
  [968] = {.lex_state = 234},
  [969] = {.lex_state = 324, .external_lex_state = 17},
  [970] = {.lex_state = 324, .external_lex_state = 17},
  [971] = {.lex_state = 410, .external_lex_state = 17},
  [972] = {.lex_state = 410, .external_lex_state = 17},
  [973] = {.lex_state = 410, .external_lex_state = 17},
  [974] = {.lex_state = 410, .external_lex_state = 17},
  [975] = {.lex_state = 410, .external_lex_state = 18},
  [976] = {.lex_state = 410, .external_lex_state = 18},
  [977] = {.lex_state = 324, .external_lex_state = 18},
  [978] = {.lex_state = 324, .external_lex_state = 18},
  [979] = {.lex_state = 382, .external_lex_state = 23},
  [980] = {.lex_state = 333, .external_lex_state = 19},
  [981] = {.lex_state = 333, .external_lex_state = 19},
  [982] = {.lex_state = 206},
  [983] = {.lex_state = 303, .external_lex_state = 16},
  [984] = {.lex_state = 311, .external_lex_state = 6},
  [985] = {.lex_state = 303, .external_lex_state = 16},
  [986] = {.lex_state = 303, .external_lex_state = 16},
  [987] = {.lex_state = 283, .external_lex_state = 4},
  [988] = {.lex_state = 333, .external_lex_state = 19},
  [989] = {.lex_state = 358, .external_lex_state = 5},
  [990] = {.lex_state = 358, .external_lex_state = 5},
  [991] = {.lex_state = 412, .external_lex_state = 7},
  [992] = {.lex_state = 358, .external_lex_state = 5},
  [993] = {.lex_state = 283, .external_lex_state = 4},
  [994] = {.lex_state = 358, .external_lex_state = 7},
  [995] = {.lex_state = 416, .external_lex_state = 13},
  [996] = {.lex_state = 206},
  [997] = {.lex_state = 362, .external_lex_state = 11},
  [998] = {.lex_state = 416, .external_lex_state = 13},
  [999] = {.lex_state = 206},
  [1000] = {.lex_state = 234},
  [1001] = {.lex_state = 418, .external_lex_state = 13},
  [1002] = {.lex_state = 418, .external_lex_state = 13},
  [1003] = {.lex_state = 254},
  [1004] = {.lex_state = 418, .external_lex_state = 13},
  [1005] = {.lex_state = 418, .external_lex_state = 13},
  [1006] = {.lex_state = 418, .external_lex_state = 13},
  [1007] = {.lex_state = 206},
  [1008] = {.lex_state = 303, .external_lex_state = 16},
  [1009] = {.lex_state = 311, .external_lex_state = 6},
  [1010] = {.lex_state = 303, .external_lex_state = 16},
  [1011] = {.lex_state = 303, .external_lex_state = 16},
  [1012] = {.lex_state = 206},
  [1013] = {.lex_state = 320, .external_lex_state = 2},
  [1014] = {.lex_state = 206},
  [1015] = {.lex_state = 328, .external_lex_state = 2},
  [1016] = {.lex_state = 206},
  [1017] = {.lex_state = 320, .external_lex_state = 2},
  [1018] = {.lex_state = 281, .external_lex_state = 8},
  [1019] = {.lex_state = 320},
  [1020] = {.lex_state = 281, .external_lex_state = 21},
  [1021] = {.lex_state = 268, .external_lex_state = 21},
  [1022] = {.lex_state = 281, .external_lex_state = 21},
  [1023] = {.lex_state = 399, .external_lex_state = 16},
  [1024] = {.lex_state = 281, .external_lex_state = 21},
  [1025] = {.lex_state = 403},
  [1026] = {.lex_state = 401, .external_lex_state = 16},
  [1027] = {.lex_state = 206},
  [1028] = {.lex_state = 303, .external_lex_state = 16},
  [1029] = {.lex_state = 303, .external_lex_state = 16},
  [1030] = {.lex_state = 303, .external_lex_state = 16},
  [1031] = {.lex_state = 281, .external_lex_state = 21},
  [1032] = {.lex_state = 403},
  [1033] = {.lex_state = 401, .external_lex_state = 16},
  [1034] = {.lex_state = 281, .external_lex_state = 21},
  [1035] = {.lex_state = 403},
  [1036] = {.lex_state = 401, .external_lex_state = 16},
  [1037] = {.lex_state = 281, .external_lex_state = 21},
  [1038] = {.lex_state = 281, .external_lex_state = 21},
  [1039] = {.lex_state = 234},
  [1040] = {.lex_state = 420, .external_lex_state = 10},
  [1041] = {.lex_state = 420, .external_lex_state = 10},
  [1042] = {.lex_state = 254},
  [1043] = {.lex_state = 420, .external_lex_state = 10},
  [1044] = {.lex_state = 420, .external_lex_state = 10},
  [1045] = {.lex_state = 420, .external_lex_state = 10},
  [1046] = {.lex_state = 206},
  [1047] = {.lex_state = 303, .external_lex_state = 16},
  [1048] = {.lex_state = 311, .external_lex_state = 6},
  [1049] = {.lex_state = 303, .external_lex_state = 16},
  [1050] = {.lex_state = 303, .external_lex_state = 16},
  [1051] = {.lex_state = 206},
  [1052] = {.lex_state = 320, .external_lex_state = 2},
  [1053] = {.lex_state = 206},
  [1054] = {.lex_state = 328, .external_lex_state = 2},
  [1055] = {.lex_state = 206},
  [1056] = {.lex_state = 320, .external_lex_state = 2},
  [1057] = {.lex_state = 206},
  [1058] = {.lex_state = 420, .external_lex_state = 4},
  [1059] = {.lex_state = 283, .external_lex_state = 4},
  [1060] = {.lex_state = 364, .external_lex_state = 2},
  [1061] = {.lex_state = 364, .external_lex_state = 2},
  [1062] = {.lex_state = 412, .external_lex_state = 7},
  [1063] = {.lex_state = 364, .external_lex_state = 2},
  [1064] = {.lex_state = 283, .external_lex_state = 4},
  [1065] = {.lex_state = 206},
  [1066] = {.lex_state = 244, .external_lex_state = 4},
  [1067] = {.lex_state = 268, .external_lex_state = 8},
  [1068] = {.lex_state = 422, .external_lex_state = 2},
  [1069] = {.lex_state = 370, .external_lex_state = 2},
  [1070] = {.lex_state = 283, .external_lex_state = 4},
  [1071] = {.lex_state = 206},
  [1072] = {.lex_state = 370, .external_lex_state = 2},
  [1073] = {.lex_state = 206},
  [1074] = {.lex_state = 206},
  [1075] = {.lex_state = 283, .external_lex_state = 4},
  [1076] = {.lex_state = 444, .external_lex_state = 13},
  [1077] = {.lex_state = 444, .external_lex_state = 13},
  [1078] = {.lex_state = 206},
  [1079] = {.lex_state = 231},
  [1080] = {.lex_state = 234},
  [1081] = {.lex_state = 424},
  [1082] = {.lex_state = 283, .external_lex_state = 4},
  [1083] = {.lex_state = 206},
  [1084] = {.lex_state = 234},
  [1085] = {.lex_state = 424},
  [1086] = {.lex_state = 274, .external_lex_state = 10},
  [1087] = {.lex_state = 436, .external_lex_state = 24},
  [1088] = {.lex_state = 436, .external_lex_state = 24},
  [1089] = {.lex_state = 206, .external_lex_state = 16},
  [1090] = {.lex_state = 401, .external_lex_state = 16},
  [1091] = {.lex_state = 274, .external_lex_state = 10},
  [1092] = {.lex_state = 399, .external_lex_state = 16},
  [1093] = {.lex_state = 274, .external_lex_state = 10},
  [1094] = {.lex_state = 403},
  [1095] = {.lex_state = 401, .external_lex_state = 16},
  [1096] = {.lex_state = 274, .external_lex_state = 10},
  [1097] = {.lex_state = 403},
  [1098] = {.lex_state = 401, .external_lex_state = 16},
  [1099] = {.lex_state = 403},
  [1100] = {.lex_state = 401, .external_lex_state = 16},
  [1101] = {.lex_state = 401, .external_lex_state = 16},
  [1102] = {.lex_state = 274, .external_lex_state = 10},
  [1103] = {.lex_state = 401, .external_lex_state = 16},
  [1104] = {.lex_state = 382, .external_lex_state = 23},
  [1105] = {.lex_state = 380, .external_lex_state = 22},
  [1106] = {.lex_state = 430, .external_lex_state = 23},
  [1107] = {.lex_state = 380, .external_lex_state = 22},
  [1108] = {.lex_state = 234},
  [1109] = {.lex_state = 446, .external_lex_state = 10},
  [1110] = {.lex_state = 446, .external_lex_state = 10},
  [1111] = {.lex_state = 283, .external_lex_state = 4},
  [1112] = {.lex_state = 281, .external_lex_state = 21},
  [1113] = {.lex_state = 387, .external_lex_state = 7},
  [1114] = {.lex_state = 206},
  [1115] = {.lex_state = 135},
  [1116] = {.lex_state = 234},
  [1117] = {.lex_state = 135},
  [1118] = {.lex_state = 234},
  [1119] = {.lex_state = 234},
  [1120] = {.lex_state = 387, .external_lex_state = 23},
  [1121] = {.lex_state = 277, .external_lex_state = 14},
  [1122] = {.lex_state = 277, .external_lex_state = 14},
  [1123] = {.lex_state = 277, .external_lex_state = 14},
  [1124] = {.lex_state = 277, .external_lex_state = 10},
  [1125] = {.lex_state = 432, .external_lex_state = 23},
  [1126] = {.lex_state = 387, .external_lex_state = 5},
  [1127] = {.lex_state = 387, .external_lex_state = 5},
  [1128] = {.lex_state = 387, .external_lex_state = 5},
  [1129] = {.lex_state = 283, .external_lex_state = 4},
  [1130] = {.lex_state = 387, .external_lex_state = 7},
  [1131] = {.lex_state = 320, .external_lex_state = 2},
  [1132] = {.lex_state = 320},
  [1133] = {.lex_state = 389, .external_lex_state = 13},
  [1134] = {.lex_state = 286, .external_lex_state = 11},
  [1135] = {.lex_state = 436, .external_lex_state = 24},
  [1136] = {.lex_state = 436, .external_lex_state = 24},
  [1137] = {.lex_state = 206, .external_lex_state = 16},
  [1138] = {.lex_state = 401, .external_lex_state = 16},
  [1139] = {.lex_state = 286, .external_lex_state = 11},
  [1140] = {.lex_state = 399, .external_lex_state = 16},
  [1141] = {.lex_state = 286, .external_lex_state = 11},
  [1142] = {.lex_state = 403},
  [1143] = {.lex_state = 401, .external_lex_state = 16},
  [1144] = {.lex_state = 286, .external_lex_state = 11},
  [1145] = {.lex_state = 403},
  [1146] = {.lex_state = 401, .external_lex_state = 16},
  [1147] = {.lex_state = 403},
  [1148] = {.lex_state = 401, .external_lex_state = 16},
  [1149] = {.lex_state = 401, .external_lex_state = 16},
  [1150] = {.lex_state = 286, .external_lex_state = 11},
  [1151] = {.lex_state = 401, .external_lex_state = 16},
  [1152] = {.lex_state = 234},
  [1153] = {.lex_state = 358, .external_lex_state = 27},
  [1154] = {.lex_state = 254},
  [1155] = {.lex_state = 261},
  [1156] = {.lex_state = 358, .external_lex_state = 27},
  [1157] = {.lex_state = 264, .external_lex_state = 6},
  [1158] = {.lex_state = 135, .external_lex_state = 2},
  [1159] = {.lex_state = 135, .external_lex_state = 2},
  [1160] = {.lex_state = 135, .external_lex_state = 2},
  [1161] = {.lex_state = 412, .external_lex_state = 23},
  [1162] = {.lex_state = 412, .external_lex_state = 23},
  [1163] = {.lex_state = 358, .external_lex_state = 27},
  [1164] = {.lex_state = 358, .external_lex_state = 27},
  [1165] = {.lex_state = 412, .external_lex_state = 23},
  [1166] = {.lex_state = 358, .external_lex_state = 23},
  [1167] = {.lex_state = 396, .external_lex_state = 13},
  [1168] = {.lex_state = 436, .external_lex_state = 24},
  [1169] = {.lex_state = 436, .external_lex_state = 24},
  [1170] = {.lex_state = 206, .external_lex_state = 16},
  [1171] = {.lex_state = 401, .external_lex_state = 16},
  [1172] = {.lex_state = 396, .external_lex_state = 13},
  [1173] = {.lex_state = 399, .external_lex_state = 16},
  [1174] = {.lex_state = 396, .external_lex_state = 13},
  [1175] = {.lex_state = 403},
  [1176] = {.lex_state = 401, .external_lex_state = 16},
  [1177] = {.lex_state = 396, .external_lex_state = 13},
  [1178] = {.lex_state = 403},
  [1179] = {.lex_state = 401, .external_lex_state = 16},
  [1180] = {.lex_state = 403},
  [1181] = {.lex_state = 401, .external_lex_state = 16},
  [1182] = {.lex_state = 401, .external_lex_state = 16},
  [1183] = {.lex_state = 396, .external_lex_state = 13},
  [1184] = {.lex_state = 401, .external_lex_state = 16},
  [1185] = {.lex_state = 277, .external_lex_state = 3},
  [1186] = {.lex_state = 320},
  [1187] = {.lex_state = 277, .external_lex_state = 14},
  [1188] = {.lex_state = 436, .external_lex_state = 24},
  [1189] = {.lex_state = 436, .external_lex_state = 24},
  [1190] = {.lex_state = 206, .external_lex_state = 16},
  [1191] = {.lex_state = 401, .external_lex_state = 16},
  [1192] = {.lex_state = 277, .external_lex_state = 14},
  [1193] = {.lex_state = 399, .external_lex_state = 16},
  [1194] = {.lex_state = 277, .external_lex_state = 14},
  [1195] = {.lex_state = 403},
  [1196] = {.lex_state = 401, .external_lex_state = 16},
  [1197] = {.lex_state = 277, .external_lex_state = 14},
  [1198] = {.lex_state = 403},
  [1199] = {.lex_state = 401, .external_lex_state = 16},
  [1200] = {.lex_state = 403},
  [1201] = {.lex_state = 401, .external_lex_state = 16},
  [1202] = {.lex_state = 401, .external_lex_state = 16},
  [1203] = {.lex_state = 277, .external_lex_state = 14},
  [1204] = {.lex_state = 401, .external_lex_state = 16},
  [1205] = {.lex_state = 277, .external_lex_state = 10},
  [1206] = {.lex_state = 436, .external_lex_state = 24},
  [1207] = {.lex_state = 436, .external_lex_state = 24},
  [1208] = {.lex_state = 206, .external_lex_state = 16},
  [1209] = {.lex_state = 401, .external_lex_state = 16},
  [1210] = {.lex_state = 277, .external_lex_state = 10},
  [1211] = {.lex_state = 399, .external_lex_state = 16},
  [1212] = {.lex_state = 277, .external_lex_state = 10},
  [1213] = {.lex_state = 403},
  [1214] = {.lex_state = 401, .external_lex_state = 16},
  [1215] = {.lex_state = 277, .external_lex_state = 10},
  [1216] = {.lex_state = 403},
  [1217] = {.lex_state = 401, .external_lex_state = 16},
  [1218] = {.lex_state = 403},
  [1219] = {.lex_state = 401, .external_lex_state = 16},
  [1220] = {.lex_state = 401, .external_lex_state = 16},
  [1221] = {.lex_state = 277, .external_lex_state = 10},
  [1222] = {.lex_state = 401, .external_lex_state = 16},
  [1223] = {.lex_state = 320, .external_lex_state = 15},
  [1224] = {.lex_state = 436, .external_lex_state = 24},
  [1225] = {.lex_state = 436, .external_lex_state = 24},
  [1226] = {.lex_state = 206, .external_lex_state = 16},
  [1227] = {.lex_state = 401, .external_lex_state = 16},
  [1228] = {.lex_state = 320, .external_lex_state = 15},
  [1229] = {.lex_state = 399, .external_lex_state = 16},
  [1230] = {.lex_state = 320, .external_lex_state = 15},
  [1231] = {.lex_state = 403},
  [1232] = {.lex_state = 401, .external_lex_state = 16},
  [1233] = {.lex_state = 320, .external_lex_state = 15},
  [1234] = {.lex_state = 403},
  [1235] = {.lex_state = 401, .external_lex_state = 16},
  [1236] = {.lex_state = 403},
  [1237] = {.lex_state = 401, .external_lex_state = 16},
  [1238] = {.lex_state = 401, .external_lex_state = 16},
  [1239] = {.lex_state = 320, .external_lex_state = 15},
  [1240] = {.lex_state = 401, .external_lex_state = 16},
  [1241] = {.lex_state = 254, .external_lex_state = 13},
  [1242] = {.lex_state = 436, .external_lex_state = 24},
  [1243] = {.lex_state = 436, .external_lex_state = 24},
  [1244] = {.lex_state = 206, .external_lex_state = 16},
  [1245] = {.lex_state = 401, .external_lex_state = 16},
  [1246] = {.lex_state = 254, .external_lex_state = 13},
  [1247] = {.lex_state = 399, .external_lex_state = 16},
  [1248] = {.lex_state = 254, .external_lex_state = 13},
  [1249] = {.lex_state = 403},
  [1250] = {.lex_state = 401, .external_lex_state = 16},
  [1251] = {.lex_state = 254, .external_lex_state = 13},
  [1252] = {.lex_state = 403},
  [1253] = {.lex_state = 401, .external_lex_state = 16},
  [1254] = {.lex_state = 403},
  [1255] = {.lex_state = 401, .external_lex_state = 16},
  [1256] = {.lex_state = 401, .external_lex_state = 16},
  [1257] = {.lex_state = 254, .external_lex_state = 13},
  [1258] = {.lex_state = 401, .external_lex_state = 16},
  [1259] = {.lex_state = 414, .external_lex_state = 12},
  [1260] = {.lex_state = 303, .external_lex_state = 24},
  [1261] = {.lex_state = 414, .external_lex_state = 12},
  [1262] = {.lex_state = 303, .external_lex_state = 24},
  [1263] = {.lex_state = 206, .external_lex_state = 12},
  [1264] = {.lex_state = 234},
  [1265] = {.lex_state = 270, .external_lex_state = 5},
  [1266] = {.lex_state = 436, .external_lex_state = 24},
  [1267] = {.lex_state = 436, .external_lex_state = 24},
  [1268] = {.lex_state = 254},
  [1269] = {.lex_state = 436, .external_lex_state = 24},
  [1270] = {.lex_state = 436, .external_lex_state = 24},
  [1271] = {.lex_state = 436, .external_lex_state = 24},
  [1272] = {.lex_state = 270, .external_lex_state = 5},
  [1273] = {.lex_state = 206},
  [1274] = {.lex_state = 303, .external_lex_state = 16},
  [1275] = {.lex_state = 311, .external_lex_state = 6},
  [1276] = {.lex_state = 303, .external_lex_state = 16},
  [1277] = {.lex_state = 303, .external_lex_state = 16},
  [1278] = {.lex_state = 206},
  [1279] = {.lex_state = 320, .external_lex_state = 2},
  [1280] = {.lex_state = 206},
  [1281] = {.lex_state = 328, .external_lex_state = 2},
  [1282] = {.lex_state = 206},
  [1283] = {.lex_state = 320, .external_lex_state = 2},
  [1284] = {.lex_state = 401, .external_lex_state = 24},
  [1285] = {.lex_state = 401, .external_lex_state = 24},
  [1286] = {.lex_state = 401, .external_lex_state = 24},
  [1287] = {.lex_state = 399, .external_lex_state = 16},
  [1288] = {.lex_state = 401, .external_lex_state = 24},
  [1289] = {.lex_state = 403},
  [1290] = {.lex_state = 401, .external_lex_state = 16},
  [1291] = {.lex_state = 206},
  [1292] = {.lex_state = 303, .external_lex_state = 16},
  [1293] = {.lex_state = 303, .external_lex_state = 16},
  [1294] = {.lex_state = 303, .external_lex_state = 16},
  [1295] = {.lex_state = 401, .external_lex_state = 24},
  [1296] = {.lex_state = 403},
  [1297] = {.lex_state = 401, .external_lex_state = 16},
  [1298] = {.lex_state = 401, .external_lex_state = 24},
  [1299] = {.lex_state = 403},
  [1300] = {.lex_state = 401, .external_lex_state = 16},
  [1301] = {.lex_state = 270, .external_lex_state = 5},
  [1302] = {.lex_state = 401, .external_lex_state = 16},
  [1303] = {.lex_state = 401, .external_lex_state = 24},
  [1304] = {.lex_state = 401, .external_lex_state = 24},
  [1305] = {.lex_state = 436, .external_lex_state = 24},
  [1306] = {.lex_state = 436, .external_lex_state = 24},
  [1307] = {.lex_state = 206, .external_lex_state = 16},
  [1308] = {.lex_state = 401, .external_lex_state = 16},
  [1309] = {.lex_state = 270, .external_lex_state = 5},
  [1310] = {.lex_state = 401, .external_lex_state = 16},
  [1311] = {.lex_state = 270, .external_lex_state = 5},
  [1312] = {.lex_state = 401, .external_lex_state = 16},
  [1313] = {.lex_state = 270, .external_lex_state = 5},
  [1314] = {.lex_state = 401, .external_lex_state = 16},
  [1315] = {.lex_state = 270, .external_lex_state = 5},
  [1316] = {.lex_state = 401, .external_lex_state = 16},
  [1317] = {.lex_state = 320, .external_lex_state = 15},
  [1318] = {.lex_state = 420, .external_lex_state = 4},
  [1319] = {.lex_state = 364, .external_lex_state = 2},
  [1320] = {.lex_state = 206},
  [1321] = {.lex_state = 440, .external_lex_state = 18},
  [1322] = {.lex_state = 364, .external_lex_state = 2},
  [1323] = {.lex_state = 206},
  [1324] = {.lex_state = 408, .external_lex_state = 18},
  [1325] = {.lex_state = 206},
  [1326] = {.lex_state = 206},
  [1327] = {.lex_state = 370, .external_lex_state = 2},
  [1328] = {.lex_state = 206},
  [1329] = {.lex_state = 424},
  [1330] = {.lex_state = 274, .external_lex_state = 4},
  [1331] = {.lex_state = 424},
  [1332] = {.lex_state = 274, .external_lex_state = 4},
  [1333] = {.lex_state = 206},
  [1334] = {.lex_state = 448, .external_lex_state = 26},
  [1335] = {.lex_state = 380, .external_lex_state = 22},
  [1336] = {.lex_state = 135},
  [1337] = {.lex_state = 234},
  [1338] = {.lex_state = 206},
  [1339] = {.lex_state = 206},
  [1340] = {.lex_state = 385, .external_lex_state = 2},
  [1341] = {.lex_state = 135},
  [1342] = {.lex_state = 234},
  [1343] = {.lex_state = 356, .external_lex_state = 20},
  [1344] = {.lex_state = 234},
  [1345] = {.lex_state = 408, .external_lex_state = 26},
  [1346] = {.lex_state = 313, .external_lex_state = 6},
  [1347] = {.lex_state = 320},
  [1348] = {.lex_state = 313, .external_lex_state = 25},
  [1349] = {.lex_state = 313, .external_lex_state = 25},
  [1350] = {.lex_state = 313, .external_lex_state = 25},
  [1351] = {.lex_state = 313, .external_lex_state = 25},
  [1352] = {.lex_state = 313, .external_lex_state = 25},
  [1353] = {.lex_state = 399, .external_lex_state = 16},
  [1354] = {.lex_state = 313, .external_lex_state = 25},
  [1355] = {.lex_state = 403},
  [1356] = {.lex_state = 401, .external_lex_state = 16},
  [1357] = {.lex_state = 206},
  [1358] = {.lex_state = 303, .external_lex_state = 16},
  [1359] = {.lex_state = 303, .external_lex_state = 16},
  [1360] = {.lex_state = 303, .external_lex_state = 16},
  [1361] = {.lex_state = 313, .external_lex_state = 25},
  [1362] = {.lex_state = 403},
  [1363] = {.lex_state = 401, .external_lex_state = 16},
  [1364] = {.lex_state = 313, .external_lex_state = 25},
  [1365] = {.lex_state = 403},
  [1366] = {.lex_state = 401, .external_lex_state = 16},
  [1367] = {.lex_state = 313, .external_lex_state = 25},
  [1368] = {.lex_state = 313, .external_lex_state = 25},
  [1369] = {.lex_state = 313, .external_lex_state = 13},
  [1370] = {.lex_state = 313, .external_lex_state = 13},
  [1371] = {.lex_state = 313, .external_lex_state = 13},
  [1372] = {.lex_state = 399, .external_lex_state = 16},
  [1373] = {.lex_state = 313, .external_lex_state = 13},
  [1374] = {.lex_state = 403},
  [1375] = {.lex_state = 401, .external_lex_state = 16},
  [1376] = {.lex_state = 206},
  [1377] = {.lex_state = 303, .external_lex_state = 16},
  [1378] = {.lex_state = 303, .external_lex_state = 16},
  [1379] = {.lex_state = 303, .external_lex_state = 16},
  [1380] = {.lex_state = 313, .external_lex_state = 13},
  [1381] = {.lex_state = 403},
  [1382] = {.lex_state = 401, .external_lex_state = 16},
  [1383] = {.lex_state = 313, .external_lex_state = 13},
  [1384] = {.lex_state = 403},
  [1385] = {.lex_state = 401, .external_lex_state = 16},
  [1386] = {.lex_state = 313, .external_lex_state = 13},
  [1387] = {.lex_state = 313, .external_lex_state = 13},
  [1388] = {.lex_state = 315, .external_lex_state = 17},
  [1389] = {.lex_state = 436, .external_lex_state = 24},
  [1390] = {.lex_state = 436, .external_lex_state = 24},
  [1391] = {.lex_state = 206, .external_lex_state = 16},
  [1392] = {.lex_state = 401, .external_lex_state = 16},
  [1393] = {.lex_state = 315, .external_lex_state = 17},
  [1394] = {.lex_state = 399, .external_lex_state = 16},
  [1395] = {.lex_state = 315, .external_lex_state = 17},
  [1396] = {.lex_state = 403},
  [1397] = {.lex_state = 401, .external_lex_state = 16},
  [1398] = {.lex_state = 315, .external_lex_state = 17},
  [1399] = {.lex_state = 403},
  [1400] = {.lex_state = 401, .external_lex_state = 16},
  [1401] = {.lex_state = 403},
  [1402] = {.lex_state = 401, .external_lex_state = 16},
  [1403] = {.lex_state = 401, .external_lex_state = 16},
  [1404] = {.lex_state = 315, .external_lex_state = 17},
  [1405] = {.lex_state = 401, .external_lex_state = 16},
  [1406] = {.lex_state = 438, .external_lex_state = 26},
  [1407] = {.lex_state = 206},
  [1408] = {.lex_state = 408, .external_lex_state = 17},
  [1409] = {.lex_state = 408, .external_lex_state = 17},
  [1410] = {.lex_state = 440, .external_lex_state = 18},
  [1411] = {.lex_state = 408, .external_lex_state = 17},
  [1412] = {.lex_state = 206},
  [1413] = {.lex_state = 408, .external_lex_state = 18},
  [1414] = {.lex_state = 328, .external_lex_state = 15},
  [1415] = {.lex_state = 410, .external_lex_state = 18},
  [1416] = {.lex_state = 206},
  [1417] = {.lex_state = 135},
  [1418] = {.lex_state = 234},
  [1419] = {.lex_state = 135},
  [1420] = {.lex_state = 234},
  [1421] = {.lex_state = 234},
  [1422] = {.lex_state = 410, .external_lex_state = 26},
  [1423] = {.lex_state = 322, .external_lex_state = 25},
  [1424] = {.lex_state = 322, .external_lex_state = 25},
  [1425] = {.lex_state = 322, .external_lex_state = 25},
  [1426] = {.lex_state = 322, .external_lex_state = 13},
  [1427] = {.lex_state = 442, .external_lex_state = 26},
  [1428] = {.lex_state = 410, .external_lex_state = 17},
  [1429] = {.lex_state = 410, .external_lex_state = 17},
  [1430] = {.lex_state = 410, .external_lex_state = 17},
  [1431] = {.lex_state = 410, .external_lex_state = 18},
  [1432] = {.lex_state = 283, .external_lex_state = 4},
  [1433] = {.lex_state = 399, .external_lex_state = 16},
  [1434] = {.lex_state = 333, .external_lex_state = 19},
  [1435] = {.lex_state = 403},
  [1436] = {.lex_state = 401, .external_lex_state = 16},
  [1437] = {.lex_state = 206},
  [1438] = {.lex_state = 303, .external_lex_state = 16},
  [1439] = {.lex_state = 303, .external_lex_state = 16},
  [1440] = {.lex_state = 303, .external_lex_state = 16},
  [1441] = {.lex_state = 333, .external_lex_state = 19},
  [1442] = {.lex_state = 403},
  [1443] = {.lex_state = 401, .external_lex_state = 16},
  [1444] = {.lex_state = 333, .external_lex_state = 19},
  [1445] = {.lex_state = 403},
  [1446] = {.lex_state = 401, .external_lex_state = 16},
  [1447] = {.lex_state = 358, .external_lex_state = 5},
  [1448] = {.lex_state = 283, .external_lex_state = 4},
  [1449] = {.lex_state = 206},
  [1450] = {.lex_state = 206},
  [1451] = {.lex_state = 418, .external_lex_state = 13},
  [1452] = {.lex_state = 418, .external_lex_state = 13},
  [1453] = {.lex_state = 418, .external_lex_state = 13},
  [1454] = {.lex_state = 399, .external_lex_state = 16},
  [1455] = {.lex_state = 418, .external_lex_state = 13},
  [1456] = {.lex_state = 403},
  [1457] = {.lex_state = 401, .external_lex_state = 16},
  [1458] = {.lex_state = 206},
  [1459] = {.lex_state = 303, .external_lex_state = 16},
  [1460] = {.lex_state = 303, .external_lex_state = 16},
  [1461] = {.lex_state = 303, .external_lex_state = 16},
  [1462] = {.lex_state = 418, .external_lex_state = 13},
  [1463] = {.lex_state = 403},
  [1464] = {.lex_state = 401, .external_lex_state = 16},
  [1465] = {.lex_state = 418, .external_lex_state = 13},
  [1466] = {.lex_state = 403},
  [1467] = {.lex_state = 401, .external_lex_state = 16},
  [1468] = {.lex_state = 418, .external_lex_state = 13},
  [1469] = {.lex_state = 418, .external_lex_state = 13},
  [1470] = {.lex_state = 281, .external_lex_state = 21},
  [1471] = {.lex_state = 436, .external_lex_state = 24},
  [1472] = {.lex_state = 436, .external_lex_state = 24},
  [1473] = {.lex_state = 206, .external_lex_state = 16},
  [1474] = {.lex_state = 401, .external_lex_state = 16},
  [1475] = {.lex_state = 281, .external_lex_state = 21},
  [1476] = {.lex_state = 399, .external_lex_state = 16},
  [1477] = {.lex_state = 281, .external_lex_state = 21},
  [1478] = {.lex_state = 403},
  [1479] = {.lex_state = 401, .external_lex_state = 16},
  [1480] = {.lex_state = 281, .external_lex_state = 21},
  [1481] = {.lex_state = 403},
  [1482] = {.lex_state = 401, .external_lex_state = 16},
  [1483] = {.lex_state = 403},
  [1484] = {.lex_state = 401, .external_lex_state = 16},
  [1485] = {.lex_state = 401, .external_lex_state = 16},
  [1486] = {.lex_state = 281, .external_lex_state = 21},
  [1487] = {.lex_state = 401, .external_lex_state = 16},
  [1488] = {.lex_state = 420, .external_lex_state = 10},
  [1489] = {.lex_state = 420, .external_lex_state = 10},
  [1490] = {.lex_state = 420, .external_lex_state = 10},
  [1491] = {.lex_state = 399, .external_lex_state = 16},
  [1492] = {.lex_state = 420, .external_lex_state = 10},
  [1493] = {.lex_state = 403},
  [1494] = {.lex_state = 401, .external_lex_state = 16},
  [1495] = {.lex_state = 206},
  [1496] = {.lex_state = 303, .external_lex_state = 16},
  [1497] = {.lex_state = 303, .external_lex_state = 16},
  [1498] = {.lex_state = 303, .external_lex_state = 16},
  [1499] = {.lex_state = 420, .external_lex_state = 10},
  [1500] = {.lex_state = 403},
  [1501] = {.lex_state = 401, .external_lex_state = 16},
  [1502] = {.lex_state = 420, .external_lex_state = 10},
  [1503] = {.lex_state = 403},
  [1504] = {.lex_state = 401, .external_lex_state = 16},
  [1505] = {.lex_state = 420, .external_lex_state = 10},
  [1506] = {.lex_state = 420, .external_lex_state = 10},
  [1507] = {.lex_state = 283, .external_lex_state = 4},
  [1508] = {.lex_state = 283, .external_lex_state = 4},
  [1509] = {.lex_state = 370, .external_lex_state = 2},
  [1510] = {.lex_state = 422, .external_lex_state = 2},
  [1511] = {.lex_state = 422, .external_lex_state = 2},
  [1512] = {.lex_state = 283, .external_lex_state = 4},
  [1513] = {.lex_state = 206},
  [1514] = {.lex_state = 234},
  [1515] = {.lex_state = 450, .external_lex_state = 2},
  [1516] = {.lex_state = 231},
  [1517] = {.lex_state = 444, .external_lex_state = 13},
  [1518] = {.lex_state = 450, .external_lex_state = 2},
  [1519] = {.lex_state = 231},
  [1520] = {.lex_state = 283, .external_lex_state = 4},
  [1521] = {.lex_state = 206},
  [1522] = {.lex_state = 234},
  [1523] = {.lex_state = 283, .external_lex_state = 4},
  [1524] = {.lex_state = 234},
  [1525] = {.lex_state = 283, .external_lex_state = 4},
  [1526] = {.lex_state = 206},
  [1527] = {.lex_state = 283, .external_lex_state = 4},
  [1528] = {.lex_state = 234},
  [1529] = {.lex_state = 274, .external_lex_state = 10},
  [1530] = {.lex_state = 274, .external_lex_state = 10},
  [1531] = {.lex_state = 274, .external_lex_state = 10},
  [1532] = {.lex_state = 401, .external_lex_state = 16},
  [1533] = {.lex_state = 436, .external_lex_state = 24},
  [1534] = {.lex_state = 436, .external_lex_state = 24},
  [1535] = {.lex_state = 206, .external_lex_state = 16},
  [1536] = {.lex_state = 401, .external_lex_state = 16},
  [1537] = {.lex_state = 274, .external_lex_state = 10},
  [1538] = {.lex_state = 401, .external_lex_state = 16},
  [1539] = {.lex_state = 274, .external_lex_state = 10},
  [1540] = {.lex_state = 401, .external_lex_state = 16},
  [1541] = {.lex_state = 274, .external_lex_state = 10},
  [1542] = {.lex_state = 401, .external_lex_state = 16},
  [1543] = {.lex_state = 274, .external_lex_state = 10},
  [1544] = {.lex_state = 401, .external_lex_state = 16},
  [1545] = {.lex_state = 283, .external_lex_state = 4},
  [1546] = {.lex_state = 446, .external_lex_state = 10},
  [1547] = {.lex_state = 446, .external_lex_state = 10},
  [1548] = {.lex_state = 283, .external_lex_state = 4},
  [1549] = {.lex_state = 446, .external_lex_state = 10},
  [1550] = {.lex_state = 281, .external_lex_state = 21},
  [1551] = {.lex_state = 432, .external_lex_state = 23},
  [1552] = {.lex_state = 234},
  [1553] = {.lex_state = 453, .external_lex_state = 10},
  [1554] = {.lex_state = 453, .external_lex_state = 10},
  [1555] = {.lex_state = 234},
  [1556] = {.lex_state = 387, .external_lex_state = 27},
  [1557] = {.lex_state = 387, .external_lex_state = 27},
  [1558] = {.lex_state = 387, .external_lex_state = 27},
  [1559] = {.lex_state = 387, .external_lex_state = 27},
  [1560] = {.lex_state = 387, .external_lex_state = 23},
  [1561] = {.lex_state = 387, .external_lex_state = 5},
  [1562] = {.lex_state = 320, .external_lex_state = 2},
  [1563] = {.lex_state = 286, .external_lex_state = 11},
  [1564] = {.lex_state = 286, .external_lex_state = 11},
  [1565] = {.lex_state = 286, .external_lex_state = 11},
  [1566] = {.lex_state = 401, .external_lex_state = 16},
  [1567] = {.lex_state = 436, .external_lex_state = 24},
  [1568] = {.lex_state = 436, .external_lex_state = 24},
  [1569] = {.lex_state = 206, .external_lex_state = 16},
  [1570] = {.lex_state = 401, .external_lex_state = 16},
  [1571] = {.lex_state = 286, .external_lex_state = 11},
  [1572] = {.lex_state = 401, .external_lex_state = 16},
  [1573] = {.lex_state = 286, .external_lex_state = 11},
  [1574] = {.lex_state = 401, .external_lex_state = 16},
  [1575] = {.lex_state = 286, .external_lex_state = 11},
  [1576] = {.lex_state = 401, .external_lex_state = 16},
  [1577] = {.lex_state = 286, .external_lex_state = 11},
  [1578] = {.lex_state = 401, .external_lex_state = 16},
  [1579] = {.lex_state = 358, .external_lex_state = 27},
  [1580] = {.lex_state = 358, .external_lex_state = 27},
  [1581] = {.lex_state = 412, .external_lex_state = 23},
  [1582] = {.lex_state = 234},
  [1583] = {.lex_state = 358, .external_lex_state = 27},
  [1584] = {.lex_state = 412, .external_lex_state = 27},
  [1585] = {.lex_state = 254},
  [1586] = {.lex_state = 412, .external_lex_state = 27},
  [1587] = {.lex_state = 412, .external_lex_state = 27},
  [1588] = {.lex_state = 412, .external_lex_state = 27},
  [1589] = {.lex_state = 206},
  [1590] = {.lex_state = 303, .external_lex_state = 16},
  [1591] = {.lex_state = 311, .external_lex_state = 6},
  [1592] = {.lex_state = 303, .external_lex_state = 16},
  [1593] = {.lex_state = 303, .external_lex_state = 16},
  [1594] = {.lex_state = 206},
  [1595] = {.lex_state = 320, .external_lex_state = 2},
  [1596] = {.lex_state = 206},
  [1597] = {.lex_state = 328, .external_lex_state = 2},
  [1598] = {.lex_state = 206},
  [1599] = {.lex_state = 320, .external_lex_state = 2},
  [1600] = {.lex_state = 396, .external_lex_state = 13},
  [1601] = {.lex_state = 396, .external_lex_state = 13},
  [1602] = {.lex_state = 396, .external_lex_state = 13},
  [1603] = {.lex_state = 401, .external_lex_state = 16},
  [1604] = {.lex_state = 436, .external_lex_state = 24},
  [1605] = {.lex_state = 436, .external_lex_state = 24},
  [1606] = {.lex_state = 206, .external_lex_state = 16},
  [1607] = {.lex_state = 401, .external_lex_state = 16},
  [1608] = {.lex_state = 396, .external_lex_state = 13},
  [1609] = {.lex_state = 401, .external_lex_state = 16},
  [1610] = {.lex_state = 396, .external_lex_state = 13},
  [1611] = {.lex_state = 401, .external_lex_state = 16},
  [1612] = {.lex_state = 396, .external_lex_state = 13},
  [1613] = {.lex_state = 401, .external_lex_state = 16},
  [1614] = {.lex_state = 396, .external_lex_state = 13},
  [1615] = {.lex_state = 401, .external_lex_state = 16},
  [1616] = {.lex_state = 277, .external_lex_state = 3},
  [1617] = {.lex_state = 277, .external_lex_state = 14},
  [1618] = {.lex_state = 277, .external_lex_state = 14},
  [1619] = {.lex_state = 277, .external_lex_state = 14},
  [1620] = {.lex_state = 401, .external_lex_state = 16},
  [1621] = {.lex_state = 436, .external_lex_state = 24},
  [1622] = {.lex_state = 436, .external_lex_state = 24},
  [1623] = {.lex_state = 206, .external_lex_state = 16},
  [1624] = {.lex_state = 401, .external_lex_state = 16},
  [1625] = {.lex_state = 277, .external_lex_state = 14},
  [1626] = {.lex_state = 401, .external_lex_state = 16},
  [1627] = {.lex_state = 277, .external_lex_state = 14},
  [1628] = {.lex_state = 401, .external_lex_state = 16},
  [1629] = {.lex_state = 277, .external_lex_state = 14},
  [1630] = {.lex_state = 401, .external_lex_state = 16},
  [1631] = {.lex_state = 277, .external_lex_state = 14},
  [1632] = {.lex_state = 401, .external_lex_state = 16},
  [1633] = {.lex_state = 277, .external_lex_state = 10},
  [1634] = {.lex_state = 277, .external_lex_state = 10},
  [1635] = {.lex_state = 277, .external_lex_state = 10},
  [1636] = {.lex_state = 401, .external_lex_state = 16},
  [1637] = {.lex_state = 436, .external_lex_state = 24},
  [1638] = {.lex_state = 436, .external_lex_state = 24},
  [1639] = {.lex_state = 206, .external_lex_state = 16},
  [1640] = {.lex_state = 401, .external_lex_state = 16},
  [1641] = {.lex_state = 277, .external_lex_state = 10},
  [1642] = {.lex_state = 401, .external_lex_state = 16},
  [1643] = {.lex_state = 277, .external_lex_state = 10},
  [1644] = {.lex_state = 401, .external_lex_state = 16},
  [1645] = {.lex_state = 277, .external_lex_state = 10},
  [1646] = {.lex_state = 401, .external_lex_state = 16},
  [1647] = {.lex_state = 277, .external_lex_state = 10},
  [1648] = {.lex_state = 401, .external_lex_state = 16},
  [1649] = {.lex_state = 320, .external_lex_state = 15},
  [1650] = {.lex_state = 320, .external_lex_state = 15},
  [1651] = {.lex_state = 320, .external_lex_state = 15},
  [1652] = {.lex_state = 401, .external_lex_state = 16},
  [1653] = {.lex_state = 436, .external_lex_state = 24},
  [1654] = {.lex_state = 436, .external_lex_state = 24},
  [1655] = {.lex_state = 206, .external_lex_state = 16},
  [1656] = {.lex_state = 401, .external_lex_state = 16},
  [1657] = {.lex_state = 320, .external_lex_state = 15},
  [1658] = {.lex_state = 401, .external_lex_state = 16},
  [1659] = {.lex_state = 320, .external_lex_state = 15},
  [1660] = {.lex_state = 401, .external_lex_state = 16},
  [1661] = {.lex_state = 320, .external_lex_state = 15},
  [1662] = {.lex_state = 401, .external_lex_state = 16},
  [1663] = {.lex_state = 320, .external_lex_state = 15},
  [1664] = {.lex_state = 401, .external_lex_state = 16},
  [1665] = {.lex_state = 254, .external_lex_state = 13},
  [1666] = {.lex_state = 254, .external_lex_state = 13},
  [1667] = {.lex_state = 254, .external_lex_state = 13},
  [1668] = {.lex_state = 401, .external_lex_state = 16},
  [1669] = {.lex_state = 436, .external_lex_state = 24},
  [1670] = {.lex_state = 436, .external_lex_state = 24},
  [1671] = {.lex_state = 206, .external_lex_state = 16},
  [1672] = {.lex_state = 401, .external_lex_state = 16},
  [1673] = {.lex_state = 254, .external_lex_state = 13},
  [1674] = {.lex_state = 401, .external_lex_state = 16},
  [1675] = {.lex_state = 254, .external_lex_state = 13},
  [1676] = {.lex_state = 401, .external_lex_state = 16},
  [1677] = {.lex_state = 254, .external_lex_state = 13},
  [1678] = {.lex_state = 401, .external_lex_state = 16},
  [1679] = {.lex_state = 254, .external_lex_state = 13},
  [1680] = {.lex_state = 401, .external_lex_state = 16},
  [1681] = {.lex_state = 303, .external_lex_state = 24},
  [1682] = {.lex_state = 303, .external_lex_state = 16},
  [1683] = {.lex_state = 303, .external_lex_state = 24},
  [1684] = {.lex_state = 303, .external_lex_state = 16},
  [1685] = {.lex_state = 436, .external_lex_state = 24},
  [1686] = {.lex_state = 436, .external_lex_state = 24},
  [1687] = {.lex_state = 436, .external_lex_state = 24},
  [1688] = {.lex_state = 399, .external_lex_state = 16},
  [1689] = {.lex_state = 436, .external_lex_state = 24},
  [1690] = {.lex_state = 403},
  [1691] = {.lex_state = 401, .external_lex_state = 16},
  [1692] = {.lex_state = 206},
  [1693] = {.lex_state = 303, .external_lex_state = 16},
  [1694] = {.lex_state = 303, .external_lex_state = 16},
  [1695] = {.lex_state = 303, .external_lex_state = 16},
  [1696] = {.lex_state = 436, .external_lex_state = 24},
  [1697] = {.lex_state = 403},
  [1698] = {.lex_state = 401, .external_lex_state = 16},
  [1699] = {.lex_state = 436, .external_lex_state = 24},
  [1700] = {.lex_state = 403},
  [1701] = {.lex_state = 401, .external_lex_state = 16},
  [1702] = {.lex_state = 436, .external_lex_state = 24},
  [1703] = {.lex_state = 436, .external_lex_state = 24},
  [1704] = {.lex_state = 401, .external_lex_state = 24},
  [1705] = {.lex_state = 436, .external_lex_state = 24},
  [1706] = {.lex_state = 436, .external_lex_state = 24},
  [1707] = {.lex_state = 206, .external_lex_state = 16},
  [1708] = {.lex_state = 401, .external_lex_state = 16},
  [1709] = {.lex_state = 401, .external_lex_state = 24},
  [1710] = {.lex_state = 399, .external_lex_state = 16},
  [1711] = {.lex_state = 401, .external_lex_state = 24},
  [1712] = {.lex_state = 403},
  [1713] = {.lex_state = 401, .external_lex_state = 16},
  [1714] = {.lex_state = 401, .external_lex_state = 24},
  [1715] = {.lex_state = 403},
  [1716] = {.lex_state = 401, .external_lex_state = 16},
  [1717] = {.lex_state = 403},
  [1718] = {.lex_state = 401, .external_lex_state = 16},
  [1719] = {.lex_state = 401, .external_lex_state = 16},
  [1720] = {.lex_state = 401, .external_lex_state = 24},
  [1721] = {.lex_state = 401, .external_lex_state = 16},
  [1722] = {.lex_state = 270, .external_lex_state = 5},
  [1723] = {.lex_state = 270, .external_lex_state = 5},
  [1724] = {.lex_state = 270, .external_lex_state = 5},
  [1725] = {.lex_state = 270, .external_lex_state = 5},
  [1726] = {.lex_state = 401, .external_lex_state = 16},
  [1727] = {.lex_state = 270, .external_lex_state = 5},
  [1728] = {.lex_state = 401, .external_lex_state = 16},
  [1729] = {.lex_state = 270, .external_lex_state = 5},
  [1730] = {.lex_state = 401, .external_lex_state = 16},
  [1731] = {.lex_state = 270, .external_lex_state = 5},
  [1732] = {.lex_state = 270, .external_lex_state = 5},
  [1733] = {.lex_state = 320, .external_lex_state = 15},
  [1734] = {.lex_state = 206},
  [1735] = {.lex_state = 206},
  [1736] = {.lex_state = 364, .external_lex_state = 2},
  [1737] = {.lex_state = 440, .external_lex_state = 18},
  [1738] = {.lex_state = 206},
  [1739] = {.lex_state = 206},
  [1740] = {.lex_state = 206},
  [1741] = {.lex_state = 206},
  [1742] = {.lex_state = 206},
  [1743] = {.lex_state = 206},
  [1744] = {.lex_state = 234},
  [1745] = {.lex_state = 424},
  [1746] = {.lex_state = 206},
  [1747] = {.lex_state = 206},
  [1748] = {.lex_state = 234},
  [1749] = {.lex_state = 424},
  [1750] = {.lex_state = 438, .external_lex_state = 26},
  [1751] = {.lex_state = 448, .external_lex_state = 26},
  [1752] = {.lex_state = 234},
  [1753] = {.lex_state = 455, .external_lex_state = 13},
  [1754] = {.lex_state = 455, .external_lex_state = 13},
  [1755] = {.lex_state = 206},
  [1756] = {.lex_state = 206},
  [1757] = {.lex_state = 234},
  [1758] = {.lex_state = 408, .external_lex_state = 28},
  [1759] = {.lex_state = 254},
  [1760] = {.lex_state = 261},
  [1761] = {.lex_state = 408, .external_lex_state = 28},
  [1762] = {.lex_state = 264, .external_lex_state = 6},
  [1763] = {.lex_state = 135, .external_lex_state = 2},
  [1764] = {.lex_state = 135, .external_lex_state = 2},
  [1765] = {.lex_state = 135, .external_lex_state = 2},
  [1766] = {.lex_state = 440, .external_lex_state = 26},
  [1767] = {.lex_state = 440, .external_lex_state = 26},
  [1768] = {.lex_state = 408, .external_lex_state = 28},
  [1769] = {.lex_state = 408, .external_lex_state = 28},
  [1770] = {.lex_state = 440, .external_lex_state = 26},
  [1771] = {.lex_state = 408, .external_lex_state = 26},
  [1772] = {.lex_state = 313, .external_lex_state = 6},
  [1773] = {.lex_state = 320},
  [1774] = {.lex_state = 313, .external_lex_state = 25},
  [1775] = {.lex_state = 436, .external_lex_state = 24},
  [1776] = {.lex_state = 436, .external_lex_state = 24},
  [1777] = {.lex_state = 206, .external_lex_state = 16},
  [1778] = {.lex_state = 401, .external_lex_state = 16},
  [1779] = {.lex_state = 313, .external_lex_state = 25},
  [1780] = {.lex_state = 399, .external_lex_state = 16},
  [1781] = {.lex_state = 313, .external_lex_state = 25},
  [1782] = {.lex_state = 403},
  [1783] = {.lex_state = 401, .external_lex_state = 16},
  [1784] = {.lex_state = 313, .external_lex_state = 25},
  [1785] = {.lex_state = 403},
  [1786] = {.lex_state = 401, .external_lex_state = 16},
  [1787] = {.lex_state = 403},
  [1788] = {.lex_state = 401, .external_lex_state = 16},
  [1789] = {.lex_state = 401, .external_lex_state = 16},
  [1790] = {.lex_state = 313, .external_lex_state = 25},
  [1791] = {.lex_state = 401, .external_lex_state = 16},
  [1792] = {.lex_state = 313, .external_lex_state = 13},
  [1793] = {.lex_state = 436, .external_lex_state = 24},
  [1794] = {.lex_state = 436, .external_lex_state = 24},
  [1795] = {.lex_state = 206, .external_lex_state = 16},
  [1796] = {.lex_state = 401, .external_lex_state = 16},
  [1797] = {.lex_state = 313, .external_lex_state = 13},
  [1798] = {.lex_state = 399, .external_lex_state = 16},
  [1799] = {.lex_state = 313, .external_lex_state = 13},
  [1800] = {.lex_state = 403},
  [1801] = {.lex_state = 401, .external_lex_state = 16},
  [1802] = {.lex_state = 313, .external_lex_state = 13},
  [1803] = {.lex_state = 403},
  [1804] = {.lex_state = 401, .external_lex_state = 16},
  [1805] = {.lex_state = 403},
  [1806] = {.lex_state = 401, .external_lex_state = 16},
  [1807] = {.lex_state = 401, .external_lex_state = 16},
  [1808] = {.lex_state = 313, .external_lex_state = 13},
  [1809] = {.lex_state = 401, .external_lex_state = 16},
  [1810] = {.lex_state = 315, .external_lex_state = 17},
  [1811] = {.lex_state = 315, .external_lex_state = 17},
  [1812] = {.lex_state = 315, .external_lex_state = 17},
  [1813] = {.lex_state = 401, .external_lex_state = 16},
  [1814] = {.lex_state = 436, .external_lex_state = 24},
  [1815] = {.lex_state = 436, .external_lex_state = 24},
  [1816] = {.lex_state = 206, .external_lex_state = 16},
  [1817] = {.lex_state = 401, .external_lex_state = 16},
  [1818] = {.lex_state = 315, .external_lex_state = 17},
  [1819] = {.lex_state = 401, .external_lex_state = 16},
  [1820] = {.lex_state = 315, .external_lex_state = 17},
  [1821] = {.lex_state = 401, .external_lex_state = 16},
  [1822] = {.lex_state = 315, .external_lex_state = 17},
  [1823] = {.lex_state = 401, .external_lex_state = 16},
  [1824] = {.lex_state = 315, .external_lex_state = 17},
  [1825] = {.lex_state = 401, .external_lex_state = 16},
  [1826] = {.lex_state = 206},
  [1827] = {.lex_state = 408, .external_lex_state = 17},
  [1828] = {.lex_state = 206},
  [1829] = {.lex_state = 328, .external_lex_state = 15},
  [1830] = {.lex_state = 442, .external_lex_state = 26},
  [1831] = {.lex_state = 234},
  [1832] = {.lex_state = 457, .external_lex_state = 13},
  [1833] = {.lex_state = 457, .external_lex_state = 13},
  [1834] = {.lex_state = 234},
  [1835] = {.lex_state = 410, .external_lex_state = 28},
  [1836] = {.lex_state = 410, .external_lex_state = 28},
  [1837] = {.lex_state = 410, .external_lex_state = 28},
  [1838] = {.lex_state = 410, .external_lex_state = 28},
  [1839] = {.lex_state = 410, .external_lex_state = 26},
  [1840] = {.lex_state = 410, .external_lex_state = 17},
  [1841] = {.lex_state = 333, .external_lex_state = 19},
  [1842] = {.lex_state = 436, .external_lex_state = 24},
  [1843] = {.lex_state = 436, .external_lex_state = 24},
  [1844] = {.lex_state = 206, .external_lex_state = 16},
  [1845] = {.lex_state = 401, .external_lex_state = 16},
  [1846] = {.lex_state = 333, .external_lex_state = 19},
  [1847] = {.lex_state = 399, .external_lex_state = 16},
  [1848] = {.lex_state = 333, .external_lex_state = 19},
  [1849] = {.lex_state = 403},
  [1850] = {.lex_state = 401, .external_lex_state = 16},
  [1851] = {.lex_state = 333, .external_lex_state = 19},
  [1852] = {.lex_state = 403},
  [1853] = {.lex_state = 401, .external_lex_state = 16},
  [1854] = {.lex_state = 403},
  [1855] = {.lex_state = 401, .external_lex_state = 16},
  [1856] = {.lex_state = 401, .external_lex_state = 16},
  [1857] = {.lex_state = 333, .external_lex_state = 19},
  [1858] = {.lex_state = 401, .external_lex_state = 16},
  [1859] = {.lex_state = 418, .external_lex_state = 13},
  [1860] = {.lex_state = 436, .external_lex_state = 24},
  [1861] = {.lex_state = 436, .external_lex_state = 24},
  [1862] = {.lex_state = 206, .external_lex_state = 16},
  [1863] = {.lex_state = 401, .external_lex_state = 16},
  [1864] = {.lex_state = 418, .external_lex_state = 13},
  [1865] = {.lex_state = 399, .external_lex_state = 16},
  [1866] = {.lex_state = 418, .external_lex_state = 13},
  [1867] = {.lex_state = 403},
  [1868] = {.lex_state = 401, .external_lex_state = 16},
  [1869] = {.lex_state = 418, .external_lex_state = 13},
  [1870] = {.lex_state = 403},
  [1871] = {.lex_state = 401, .external_lex_state = 16},
  [1872] = {.lex_state = 403},
  [1873] = {.lex_state = 401, .external_lex_state = 16},
  [1874] = {.lex_state = 401, .external_lex_state = 16},
  [1875] = {.lex_state = 418, .external_lex_state = 13},
  [1876] = {.lex_state = 401, .external_lex_state = 16},
  [1877] = {.lex_state = 281, .external_lex_state = 21},
  [1878] = {.lex_state = 281, .external_lex_state = 21},
  [1879] = {.lex_state = 281, .external_lex_state = 21},
  [1880] = {.lex_state = 401, .external_lex_state = 16},
  [1881] = {.lex_state = 436, .external_lex_state = 24},
  [1882] = {.lex_state = 436, .external_lex_state = 24},
  [1883] = {.lex_state = 206, .external_lex_state = 16},
  [1884] = {.lex_state = 401, .external_lex_state = 16},
  [1885] = {.lex_state = 281, .external_lex_state = 21},
  [1886] = {.lex_state = 401, .external_lex_state = 16},
  [1887] = {.lex_state = 281, .external_lex_state = 21},
  [1888] = {.lex_state = 401, .external_lex_state = 16},
  [1889] = {.lex_state = 281, .external_lex_state = 21},
  [1890] = {.lex_state = 401, .external_lex_state = 16},
  [1891] = {.lex_state = 281, .external_lex_state = 21},
  [1892] = {.lex_state = 401, .external_lex_state = 16},
  [1893] = {.lex_state = 420, .external_lex_state = 10},
  [1894] = {.lex_state = 436, .external_lex_state = 24},
  [1895] = {.lex_state = 436, .external_lex_state = 24},
  [1896] = {.lex_state = 206, .external_lex_state = 16},
  [1897] = {.lex_state = 401, .external_lex_state = 16},
  [1898] = {.lex_state = 420, .external_lex_state = 10},
  [1899] = {.lex_state = 399, .external_lex_state = 16},
  [1900] = {.lex_state = 420, .external_lex_state = 10},
  [1901] = {.lex_state = 403},
  [1902] = {.lex_state = 401, .external_lex_state = 16},
  [1903] = {.lex_state = 420, .external_lex_state = 10},
  [1904] = {.lex_state = 403},
  [1905] = {.lex_state = 401, .external_lex_state = 16},
  [1906] = {.lex_state = 403},
  [1907] = {.lex_state = 401, .external_lex_state = 16},
  [1908] = {.lex_state = 401, .external_lex_state = 16},
  [1909] = {.lex_state = 420, .external_lex_state = 10},
  [1910] = {.lex_state = 401, .external_lex_state = 16},
  [1911] = {.lex_state = 370, .external_lex_state = 2},
  [1912] = {.lex_state = 283, .external_lex_state = 4},
  [1913] = {.lex_state = 444, .external_lex_state = 13},
  [1914] = {.lex_state = 444, .external_lex_state = 13},
  [1915] = {.lex_state = 231},
  [1916] = {.lex_state = 206},
  [1917] = {.lex_state = 135, .external_lex_state = 2},
  [1918] = {.lex_state = 424},
  [1919] = {.lex_state = 234},
  [1920] = {.lex_state = 236, .external_lex_state = 2},
  [1921] = {.lex_state = 238},
  [1922] = {.lex_state = 238},
  [1923] = {.lex_state = 459, .external_lex_state = 3},
  [1924] = {.lex_state = 459, .external_lex_state = 4},
  [1925] = {.lex_state = 465, .external_lex_state = 5},
  [1926] = {.lex_state = 254},
  [1927] = {.lex_state = 261},
  [1928] = {.lex_state = 465, .external_lex_state = 5},
  [1929] = {.lex_state = 264, .external_lex_state = 6},
  [1930] = {.lex_state = 135, .external_lex_state = 2},
  [1931] = {.lex_state = 135, .external_lex_state = 2},
  [1932] = {.lex_state = 135, .external_lex_state = 2},
  [1933] = {.lex_state = 467, .external_lex_state = 5},
  [1934] = {.lex_state = 283, .external_lex_state = 4},
  [1935] = {.lex_state = 465, .external_lex_state = 7},
  [1936] = {.lex_state = 469, .external_lex_state = 8},
  [1937] = {.lex_state = 206},
  [1938] = {.lex_state = 465, .external_lex_state = 7},
  [1939] = {.lex_state = 450, .external_lex_state = 2},
  [1940] = {.lex_state = 234, .external_lex_state = 2},
  [1941] = {.lex_state = 450, .external_lex_state = 2},
  [1942] = {.lex_state = 231},
  [1943] = {.lex_state = 444, .external_lex_state = 13},
  [1944] = {.lex_state = 424},
  [1945] = {.lex_state = 283, .external_lex_state = 4},
  [1946] = {.lex_state = 469, .external_lex_state = 8},
  [1947] = {.lex_state = 450, .external_lex_state = 2},
  [1948] = {.lex_state = 450, .external_lex_state = 2},
  [1949] = {.lex_state = 283, .external_lex_state = 4},
  [1950] = {.lex_state = 444, .external_lex_state = 13},
  [1951] = {.lex_state = 444, .external_lex_state = 13},
  [1952] = {.lex_state = 231},
  [1953] = {.lex_state = 206},
  [1954] = {.lex_state = 283, .external_lex_state = 4},
  [1955] = {.lex_state = 206},
  [1956] = {.lex_state = 274, .external_lex_state = 10},
  [1957] = {.lex_state = 274, .external_lex_state = 10},
  [1958] = {.lex_state = 274, .external_lex_state = 10},
  [1959] = {.lex_state = 274, .external_lex_state = 10},
  [1960] = {.lex_state = 401, .external_lex_state = 16},
  [1961] = {.lex_state = 274, .external_lex_state = 10},
  [1962] = {.lex_state = 401, .external_lex_state = 16},
  [1963] = {.lex_state = 274, .external_lex_state = 10},
  [1964] = {.lex_state = 401, .external_lex_state = 16},
  [1965] = {.lex_state = 274, .external_lex_state = 10},
  [1966] = {.lex_state = 274, .external_lex_state = 10},
  [1967] = {.lex_state = 446, .external_lex_state = 10},
  [1968] = {.lex_state = 453, .external_lex_state = 10},
  [1969] = {.lex_state = 453, .external_lex_state = 10},
  [1970] = {.lex_state = 453, .external_lex_state = 10},
  [1971] = {.lex_state = 387, .external_lex_state = 27},
  [1972] = {.lex_state = 387, .external_lex_state = 27},
  [1973] = {.lex_state = 387, .external_lex_state = 27},
  [1974] = {.lex_state = 286, .external_lex_state = 11},
  [1975] = {.lex_state = 286, .external_lex_state = 11},
  [1976] = {.lex_state = 286, .external_lex_state = 11},
  [1977] = {.lex_state = 286, .external_lex_state = 11},
  [1978] = {.lex_state = 401, .external_lex_state = 16},
  [1979] = {.lex_state = 286, .external_lex_state = 11},
  [1980] = {.lex_state = 401, .external_lex_state = 16},
  [1981] = {.lex_state = 286, .external_lex_state = 11},
  [1982] = {.lex_state = 401, .external_lex_state = 16},
  [1983] = {.lex_state = 286, .external_lex_state = 11},
  [1984] = {.lex_state = 286, .external_lex_state = 11},
  [1985] = {.lex_state = 412, .external_lex_state = 27},
  [1986] = {.lex_state = 358, .external_lex_state = 27},
  [1987] = {.lex_state = 412, .external_lex_state = 27},
  [1988] = {.lex_state = 399, .external_lex_state = 16},
  [1989] = {.lex_state = 412, .external_lex_state = 27},
  [1990] = {.lex_state = 403},
  [1991] = {.lex_state = 401, .external_lex_state = 16},
  [1992] = {.lex_state = 206},
  [1993] = {.lex_state = 303, .external_lex_state = 16},
  [1994] = {.lex_state = 303, .external_lex_state = 16},
  [1995] = {.lex_state = 303, .external_lex_state = 16},
  [1996] = {.lex_state = 412, .external_lex_state = 27},
  [1997] = {.lex_state = 403},
  [1998] = {.lex_state = 401, .external_lex_state = 16},
  [1999] = {.lex_state = 412, .external_lex_state = 27},
  [2000] = {.lex_state = 403},
  [2001] = {.lex_state = 401, .external_lex_state = 16},
  [2002] = {.lex_state = 412, .external_lex_state = 27},
  [2003] = {.lex_state = 412, .external_lex_state = 27},
  [2004] = {.lex_state = 396, .external_lex_state = 13},
  [2005] = {.lex_state = 396, .external_lex_state = 13},
  [2006] = {.lex_state = 396, .external_lex_state = 13},
  [2007] = {.lex_state = 396, .external_lex_state = 13},
  [2008] = {.lex_state = 401, .external_lex_state = 16},
  [2009] = {.lex_state = 396, .external_lex_state = 13},
  [2010] = {.lex_state = 401, .external_lex_state = 16},
  [2011] = {.lex_state = 396, .external_lex_state = 13},
  [2012] = {.lex_state = 401, .external_lex_state = 16},
  [2013] = {.lex_state = 396, .external_lex_state = 13},
  [2014] = {.lex_state = 396, .external_lex_state = 13},
  [2015] = {.lex_state = 277, .external_lex_state = 14},
  [2016] = {.lex_state = 277, .external_lex_state = 14},
  [2017] = {.lex_state = 277, .external_lex_state = 14},
  [2018] = {.lex_state = 277, .external_lex_state = 14},
  [2019] = {.lex_state = 401, .external_lex_state = 16},
  [2020] = {.lex_state = 277, .external_lex_state = 14},
  [2021] = {.lex_state = 401, .external_lex_state = 16},
  [2022] = {.lex_state = 277, .external_lex_state = 14},
  [2023] = {.lex_state = 401, .external_lex_state = 16},
  [2024] = {.lex_state = 277, .external_lex_state = 14},
  [2025] = {.lex_state = 277, .external_lex_state = 14},
  [2026] = {.lex_state = 277, .external_lex_state = 10},
  [2027] = {.lex_state = 277, .external_lex_state = 10},
  [2028] = {.lex_state = 277, .external_lex_state = 10},
  [2029] = {.lex_state = 277, .external_lex_state = 10},
  [2030] = {.lex_state = 401, .external_lex_state = 16},
  [2031] = {.lex_state = 277, .external_lex_state = 10},
  [2032] = {.lex_state = 401, .external_lex_state = 16},
  [2033] = {.lex_state = 277, .external_lex_state = 10},
  [2034] = {.lex_state = 401, .external_lex_state = 16},
  [2035] = {.lex_state = 277, .external_lex_state = 10},
  [2036] = {.lex_state = 277, .external_lex_state = 10},
  [2037] = {.lex_state = 320, .external_lex_state = 15},
  [2038] = {.lex_state = 320, .external_lex_state = 15},
  [2039] = {.lex_state = 320, .external_lex_state = 15},
  [2040] = {.lex_state = 320, .external_lex_state = 15},
  [2041] = {.lex_state = 401, .external_lex_state = 16},
  [2042] = {.lex_state = 320, .external_lex_state = 15},
  [2043] = {.lex_state = 401, .external_lex_state = 16},
  [2044] = {.lex_state = 320, .external_lex_state = 15},
  [2045] = {.lex_state = 401, .external_lex_state = 16},
  [2046] = {.lex_state = 320, .external_lex_state = 15},
  [2047] = {.lex_state = 320, .external_lex_state = 15},
  [2048] = {.lex_state = 254, .external_lex_state = 13},
  [2049] = {.lex_state = 254, .external_lex_state = 13},
  [2050] = {.lex_state = 254, .external_lex_state = 13},
  [2051] = {.lex_state = 254, .external_lex_state = 13},
  [2052] = {.lex_state = 401, .external_lex_state = 16},
  [2053] = {.lex_state = 254, .external_lex_state = 13},
  [2054] = {.lex_state = 401, .external_lex_state = 16},
  [2055] = {.lex_state = 254, .external_lex_state = 13},
  [2056] = {.lex_state = 401, .external_lex_state = 16},
  [2057] = {.lex_state = 254, .external_lex_state = 13},
  [2058] = {.lex_state = 254, .external_lex_state = 13},
  [2059] = {.lex_state = 303, .external_lex_state = 16},
  [2060] = {.lex_state = 303, .external_lex_state = 16},
  [2061] = {.lex_state = 436, .external_lex_state = 24},
  [2062] = {.lex_state = 436, .external_lex_state = 24},
  [2063] = {.lex_state = 436, .external_lex_state = 24},
  [2064] = {.lex_state = 206, .external_lex_state = 16},
  [2065] = {.lex_state = 401, .external_lex_state = 16},
  [2066] = {.lex_state = 436, .external_lex_state = 24},
  [2067] = {.lex_state = 399, .external_lex_state = 16},
  [2068] = {.lex_state = 436, .external_lex_state = 24},
  [2069] = {.lex_state = 403},
  [2070] = {.lex_state = 401, .external_lex_state = 16},
  [2071] = {.lex_state = 436, .external_lex_state = 24},
  [2072] = {.lex_state = 403},
  [2073] = {.lex_state = 401, .external_lex_state = 16},
  [2074] = {.lex_state = 403},
  [2075] = {.lex_state = 401, .external_lex_state = 16},
  [2076] = {.lex_state = 401, .external_lex_state = 16},
  [2077] = {.lex_state = 436, .external_lex_state = 24},
  [2078] = {.lex_state = 401, .external_lex_state = 16},
  [2079] = {.lex_state = 401, .external_lex_state = 24},
  [2080] = {.lex_state = 401, .external_lex_state = 24},
  [2081] = {.lex_state = 401, .external_lex_state = 24},
  [2082] = {.lex_state = 401, .external_lex_state = 16},
  [2083] = {.lex_state = 436, .external_lex_state = 24},
  [2084] = {.lex_state = 436, .external_lex_state = 24},
  [2085] = {.lex_state = 206, .external_lex_state = 16},
  [2086] = {.lex_state = 401, .external_lex_state = 16},
  [2087] = {.lex_state = 401, .external_lex_state = 24},
  [2088] = {.lex_state = 401, .external_lex_state = 16},
  [2089] = {.lex_state = 401, .external_lex_state = 24},
  [2090] = {.lex_state = 401, .external_lex_state = 16},
  [2091] = {.lex_state = 401, .external_lex_state = 24},
  [2092] = {.lex_state = 401, .external_lex_state = 16},
  [2093] = {.lex_state = 401, .external_lex_state = 24},
  [2094] = {.lex_state = 401, .external_lex_state = 16},
  [2095] = {.lex_state = 270, .external_lex_state = 5},
  [2096] = {.lex_state = 270, .external_lex_state = 5},
  [2097] = {.lex_state = 270, .external_lex_state = 5},
  [2098] = {.lex_state = 206},
  [2099] = {.lex_state = 206},
  [2100] = {.lex_state = 206},
  [2101] = {.lex_state = 206},
  [2102] = {.lex_state = 206},
  [2103] = {.lex_state = 206},
  [2104] = {.lex_state = 206},
  [2105] = {.lex_state = 234},
  [2106] = {.lex_state = 206},
  [2107] = {.lex_state = 206},
  [2108] = {.lex_state = 206},
  [2109] = {.lex_state = 234},
  [2110] = {.lex_state = 206},
  [2111] = {.lex_state = 455, .external_lex_state = 13},
  [2112] = {.lex_state = 455, .external_lex_state = 13},
  [2113] = {.lex_state = 206},
  [2114] = {.lex_state = 455, .external_lex_state = 13},
  [2115] = {.lex_state = 408, .external_lex_state = 28},
  [2116] = {.lex_state = 408, .external_lex_state = 28},
  [2117] = {.lex_state = 440, .external_lex_state = 26},
  [2118] = {.lex_state = 234},
  [2119] = {.lex_state = 408, .external_lex_state = 28},
  [2120] = {.lex_state = 440, .external_lex_state = 28},
  [2121] = {.lex_state = 254},
  [2122] = {.lex_state = 440, .external_lex_state = 28},
  [2123] = {.lex_state = 440, .external_lex_state = 28},
  [2124] = {.lex_state = 440, .external_lex_state = 28},
  [2125] = {.lex_state = 206},
  [2126] = {.lex_state = 303, .external_lex_state = 16},
  [2127] = {.lex_state = 311, .external_lex_state = 6},
  [2128] = {.lex_state = 303, .external_lex_state = 16},
  [2129] = {.lex_state = 303, .external_lex_state = 16},
  [2130] = {.lex_state = 206},
  [2131] = {.lex_state = 320, .external_lex_state = 2},
  [2132] = {.lex_state = 206},
  [2133] = {.lex_state = 328, .external_lex_state = 2},
  [2134] = {.lex_state = 206},
  [2135] = {.lex_state = 320, .external_lex_state = 2},
  [2136] = {.lex_state = 313, .external_lex_state = 6},
  [2137] = {.lex_state = 313, .external_lex_state = 25},
  [2138] = {.lex_state = 313, .external_lex_state = 25},
  [2139] = {.lex_state = 313, .external_lex_state = 25},
  [2140] = {.lex_state = 401, .external_lex_state = 16},
  [2141] = {.lex_state = 436, .external_lex_state = 24},
  [2142] = {.lex_state = 436, .external_lex_state = 24},
  [2143] = {.lex_state = 206, .external_lex_state = 16},
  [2144] = {.lex_state = 401, .external_lex_state = 16},
  [2145] = {.lex_state = 313, .external_lex_state = 25},
  [2146] = {.lex_state = 401, .external_lex_state = 16},
  [2147] = {.lex_state = 313, .external_lex_state = 25},
  [2148] = {.lex_state = 401, .external_lex_state = 16},
  [2149] = {.lex_state = 313, .external_lex_state = 25},
  [2150] = {.lex_state = 401, .external_lex_state = 16},
  [2151] = {.lex_state = 313, .external_lex_state = 25},
  [2152] = {.lex_state = 401, .external_lex_state = 16},
  [2153] = {.lex_state = 313, .external_lex_state = 13},
  [2154] = {.lex_state = 313, .external_lex_state = 13},
  [2155] = {.lex_state = 313, .external_lex_state = 13},
  [2156] = {.lex_state = 401, .external_lex_state = 16},
  [2157] = {.lex_state = 436, .external_lex_state = 24},
  [2158] = {.lex_state = 436, .external_lex_state = 24},
  [2159] = {.lex_state = 206, .external_lex_state = 16},
  [2160] = {.lex_state = 401, .external_lex_state = 16},
  [2161] = {.lex_state = 313, .external_lex_state = 13},
  [2162] = {.lex_state = 401, .external_lex_state = 16},
  [2163] = {.lex_state = 313, .external_lex_state = 13},
  [2164] = {.lex_state = 401, .external_lex_state = 16},
  [2165] = {.lex_state = 313, .external_lex_state = 13},
  [2166] = {.lex_state = 401, .external_lex_state = 16},
  [2167] = {.lex_state = 313, .external_lex_state = 13},
  [2168] = {.lex_state = 401, .external_lex_state = 16},
  [2169] = {.lex_state = 315, .external_lex_state = 17},
  [2170] = {.lex_state = 315, .external_lex_state = 17},
  [2171] = {.lex_state = 315, .external_lex_state = 17},
  [2172] = {.lex_state = 315, .external_lex_state = 17},
  [2173] = {.lex_state = 401, .external_lex_state = 16},
  [2174] = {.lex_state = 315, .external_lex_state = 17},
  [2175] = {.lex_state = 401, .external_lex_state = 16},
  [2176] = {.lex_state = 315, .external_lex_state = 17},
  [2177] = {.lex_state = 401, .external_lex_state = 16},
  [2178] = {.lex_state = 315, .external_lex_state = 17},
  [2179] = {.lex_state = 315, .external_lex_state = 17},
  [2180] = {.lex_state = 457, .external_lex_state = 13},
  [2181] = {.lex_state = 457, .external_lex_state = 13},
  [2182] = {.lex_state = 457, .external_lex_state = 13},
  [2183] = {.lex_state = 410, .external_lex_state = 28},
  [2184] = {.lex_state = 410, .external_lex_state = 28},
  [2185] = {.lex_state = 410, .external_lex_state = 28},
  [2186] = {.lex_state = 333, .external_lex_state = 19},
  [2187] = {.lex_state = 333, .external_lex_state = 19},
  [2188] = {.lex_state = 333, .external_lex_state = 19},
  [2189] = {.lex_state = 401, .external_lex_state = 16},
  [2190] = {.lex_state = 436, .external_lex_state = 24},
  [2191] = {.lex_state = 436, .external_lex_state = 24},
  [2192] = {.lex_state = 206, .external_lex_state = 16},
  [2193] = {.lex_state = 401, .external_lex_state = 16},
  [2194] = {.lex_state = 333, .external_lex_state = 19},
  [2195] = {.lex_state = 401, .external_lex_state = 16},
  [2196] = {.lex_state = 333, .external_lex_state = 19},
  [2197] = {.lex_state = 401, .external_lex_state = 16},
  [2198] = {.lex_state = 333, .external_lex_state = 19},
  [2199] = {.lex_state = 401, .external_lex_state = 16},
  [2200] = {.lex_state = 333, .external_lex_state = 19},
  [2201] = {.lex_state = 401, .external_lex_state = 16},
  [2202] = {.lex_state = 418, .external_lex_state = 13},
  [2203] = {.lex_state = 418, .external_lex_state = 13},
  [2204] = {.lex_state = 418, .external_lex_state = 13},
  [2205] = {.lex_state = 401, .external_lex_state = 16},
  [2206] = {.lex_state = 436, .external_lex_state = 24},
  [2207] = {.lex_state = 436, .external_lex_state = 24},
  [2208] = {.lex_state = 206, .external_lex_state = 16},
  [2209] = {.lex_state = 401, .external_lex_state = 16},
  [2210] = {.lex_state = 418, .external_lex_state = 13},
  [2211] = {.lex_state = 401, .external_lex_state = 16},
  [2212] = {.lex_state = 418, .external_lex_state = 13},
  [2213] = {.lex_state = 401, .external_lex_state = 16},
  [2214] = {.lex_state = 418, .external_lex_state = 13},
  [2215] = {.lex_state = 401, .external_lex_state = 16},
  [2216] = {.lex_state = 418, .external_lex_state = 13},
  [2217] = {.lex_state = 401, .external_lex_state = 16},
  [2218] = {.lex_state = 281, .external_lex_state = 21},
  [2219] = {.lex_state = 281, .external_lex_state = 21},
  [2220] = {.lex_state = 281, .external_lex_state = 21},
  [2221] = {.lex_state = 281, .external_lex_state = 21},
  [2222] = {.lex_state = 401, .external_lex_state = 16},
  [2223] = {.lex_state = 281, .external_lex_state = 21},
  [2224] = {.lex_state = 401, .external_lex_state = 16},
  [2225] = {.lex_state = 281, .external_lex_state = 21},
  [2226] = {.lex_state = 401, .external_lex_state = 16},
  [2227] = {.lex_state = 281, .external_lex_state = 21},
  [2228] = {.lex_state = 281, .external_lex_state = 21},
  [2229] = {.lex_state = 420, .external_lex_state = 10},
  [2230] = {.lex_state = 420, .external_lex_state = 10},
  [2231] = {.lex_state = 420, .external_lex_state = 10},
  [2232] = {.lex_state = 401, .external_lex_state = 16},
  [2233] = {.lex_state = 436, .external_lex_state = 24},
  [2234] = {.lex_state = 436, .external_lex_state = 24},
  [2235] = {.lex_state = 206, .external_lex_state = 16},
  [2236] = {.lex_state = 401, .external_lex_state = 16},
  [2237] = {.lex_state = 420, .external_lex_state = 10},
  [2238] = {.lex_state = 401, .external_lex_state = 16},
  [2239] = {.lex_state = 420, .external_lex_state = 10},
  [2240] = {.lex_state = 401, .external_lex_state = 16},
  [2241] = {.lex_state = 420, .external_lex_state = 10},
  [2242] = {.lex_state = 401, .external_lex_state = 16},
  [2243] = {.lex_state = 420, .external_lex_state = 10},
  [2244] = {.lex_state = 401, .external_lex_state = 16},
  [2245] = {.lex_state = 272, .external_lex_state = 9},
  [2246] = {.lex_state = 206},
  [2247] = {.lex_state = 206},
  [2248] = {.lex_state = 286, .external_lex_state = 12},
  [2249] = {.lex_state = 294},
  [2250] = {.lex_state = 206},
  [2251] = {.lex_state = 459, .external_lex_state = 14},
  [2252] = {.lex_state = 254},
  [2253] = {.lex_state = 261},
  [2254] = {.lex_state = 459, .external_lex_state = 14},
  [2255] = {.lex_state = 264, .external_lex_state = 6},
  [2256] = {.lex_state = 135, .external_lex_state = 2},
  [2257] = {.lex_state = 135, .external_lex_state = 2},
  [2258] = {.lex_state = 135, .external_lex_state = 2},
  [2259] = {.lex_state = 459, .external_lex_state = 3},
  [2260] = {.lex_state = 206},
  [2261] = {.lex_state = 459, .external_lex_state = 3},
  [2262] = {.lex_state = 459, .external_lex_state = 10},
  [2263] = {.lex_state = 254},
  [2264] = {.lex_state = 261},
  [2265] = {.lex_state = 459, .external_lex_state = 10},
  [2266] = {.lex_state = 264, .external_lex_state = 6},
  [2267] = {.lex_state = 135, .external_lex_state = 2},
  [2268] = {.lex_state = 135, .external_lex_state = 2},
  [2269] = {.lex_state = 135, .external_lex_state = 2},
  [2270] = {.lex_state = 459, .external_lex_state = 4},
  [2271] = {.lex_state = 459, .external_lex_state = 4},
  [2272] = {.lex_state = 234},
  [2273] = {.lex_state = 465, .external_lex_state = 5},
  [2274] = {.lex_state = 465, .external_lex_state = 5},
  [2275] = {.lex_state = 254},
  [2276] = {.lex_state = 465, .external_lex_state = 5},
  [2277] = {.lex_state = 465, .external_lex_state = 5},
  [2278] = {.lex_state = 465, .external_lex_state = 5},
  [2279] = {.lex_state = 206},
  [2280] = {.lex_state = 303, .external_lex_state = 16},
  [2281] = {.lex_state = 311, .external_lex_state = 6},
  [2282] = {.lex_state = 303, .external_lex_state = 16},
  [2283] = {.lex_state = 303, .external_lex_state = 16},
  [2284] = {.lex_state = 206},
  [2285] = {.lex_state = 320, .external_lex_state = 2},
  [2286] = {.lex_state = 206},
  [2287] = {.lex_state = 328, .external_lex_state = 2},
  [2288] = {.lex_state = 206},
  [2289] = {.lex_state = 320, .external_lex_state = 2},
  [2290] = {.lex_state = 206},
  [2291] = {.lex_state = 135, .external_lex_state = 2},
  [2292] = {.lex_state = 450, .external_lex_state = 2},
  [2293] = {.lex_state = 135, .external_lex_state = 2},
  [2294] = {.lex_state = 450, .external_lex_state = 2},
  [2295] = {.lex_state = 135},
  [2296] = {.lex_state = 336},
  [2297] = {.lex_state = 234},
  [2298] = {.lex_state = 234},
  [2299] = {.lex_state = 465, .external_lex_state = 5},
  [2300] = {.lex_state = 465, .external_lex_state = 5},
  [2301] = {.lex_state = 471, .external_lex_state = 7},
  [2302] = {.lex_state = 465, .external_lex_state = 7},
  [2303] = {.lex_state = 424},
  [2304] = {.lex_state = 283, .external_lex_state = 4},
  [2305] = {.lex_state = 469, .external_lex_state = 8},
  [2306] = {.lex_state = 450, .external_lex_state = 2},
  [2307] = {.lex_state = 465, .external_lex_state = 7},
  [2308] = {.lex_state = 450, .external_lex_state = 2},
  [2309] = {.lex_state = 450, .external_lex_state = 2},
  [2310] = {.lex_state = 424},
  [2311] = {.lex_state = 283, .external_lex_state = 4},
  [2312] = {.lex_state = 469, .external_lex_state = 8},
  [2313] = {.lex_state = 450, .external_lex_state = 2},
  [2314] = {.lex_state = 330, .external_lex_state = 2},
  [2315] = {.lex_state = 231},
  [2316] = {.lex_state = 330, .external_lex_state = 2},
  [2317] = {.lex_state = 231},
  [2318] = {.lex_state = 283, .external_lex_state = 4},
  [2319] = {.lex_state = 283, .external_lex_state = 4},
  [2320] = {.lex_state = 274, .external_lex_state = 10},
  [2321] = {.lex_state = 274, .external_lex_state = 10},
  [2322] = {.lex_state = 274, .external_lex_state = 10},
  [2323] = {.lex_state = 453, .external_lex_state = 10},
  [2324] = {.lex_state = 387, .external_lex_state = 27},
  [2325] = {.lex_state = 286, .external_lex_state = 11},
  [2326] = {.lex_state = 286, .external_lex_state = 11},
  [2327] = {.lex_state = 286, .external_lex_state = 11},
  [2328] = {.lex_state = 412, .external_lex_state = 27},
  [2329] = {.lex_state = 436, .external_lex_state = 24},
  [2330] = {.lex_state = 436, .external_lex_state = 24},
  [2331] = {.lex_state = 206, .external_lex_state = 16},
  [2332] = {.lex_state = 401, .external_lex_state = 16},
  [2333] = {.lex_state = 412, .external_lex_state = 27},
  [2334] = {.lex_state = 399, .external_lex_state = 16},
  [2335] = {.lex_state = 412, .external_lex_state = 27},
  [2336] = {.lex_state = 403},
  [2337] = {.lex_state = 401, .external_lex_state = 16},
  [2338] = {.lex_state = 412, .external_lex_state = 27},
  [2339] = {.lex_state = 403},
  [2340] = {.lex_state = 401, .external_lex_state = 16},
  [2341] = {.lex_state = 403},
  [2342] = {.lex_state = 401, .external_lex_state = 16},
  [2343] = {.lex_state = 401, .external_lex_state = 16},
  [2344] = {.lex_state = 412, .external_lex_state = 27},
  [2345] = {.lex_state = 401, .external_lex_state = 16},
  [2346] = {.lex_state = 396, .external_lex_state = 13},
  [2347] = {.lex_state = 396, .external_lex_state = 13},
  [2348] = {.lex_state = 396, .external_lex_state = 13},
  [2349] = {.lex_state = 277, .external_lex_state = 14},
  [2350] = {.lex_state = 277, .external_lex_state = 14},
  [2351] = {.lex_state = 277, .external_lex_state = 14},
  [2352] = {.lex_state = 277, .external_lex_state = 10},
  [2353] = {.lex_state = 277, .external_lex_state = 10},
  [2354] = {.lex_state = 277, .external_lex_state = 10},
  [2355] = {.lex_state = 320, .external_lex_state = 15},
  [2356] = {.lex_state = 320, .external_lex_state = 15},
  [2357] = {.lex_state = 320, .external_lex_state = 15},
  [2358] = {.lex_state = 254, .external_lex_state = 13},
  [2359] = {.lex_state = 254, .external_lex_state = 13},
  [2360] = {.lex_state = 254, .external_lex_state = 13},
  [2361] = {.lex_state = 436, .external_lex_state = 24},
  [2362] = {.lex_state = 436, .external_lex_state = 24},
  [2363] = {.lex_state = 436, .external_lex_state = 24},
  [2364] = {.lex_state = 401, .external_lex_state = 16},
  [2365] = {.lex_state = 436, .external_lex_state = 24},
  [2366] = {.lex_state = 436, .external_lex_state = 24},
  [2367] = {.lex_state = 206, .external_lex_state = 16},
  [2368] = {.lex_state = 401, .external_lex_state = 16},
  [2369] = {.lex_state = 436, .external_lex_state = 24},
  [2370] = {.lex_state = 401, .external_lex_state = 16},
  [2371] = {.lex_state = 436, .external_lex_state = 24},
  [2372] = {.lex_state = 401, .external_lex_state = 16},
  [2373] = {.lex_state = 436, .external_lex_state = 24},
  [2374] = {.lex_state = 401, .external_lex_state = 16},
  [2375] = {.lex_state = 436, .external_lex_state = 24},
  [2376] = {.lex_state = 401, .external_lex_state = 16},
  [2377] = {.lex_state = 401, .external_lex_state = 24},
  [2378] = {.lex_state = 401, .external_lex_state = 24},
  [2379] = {.lex_state = 401, .external_lex_state = 24},
  [2380] = {.lex_state = 401, .external_lex_state = 24},
  [2381] = {.lex_state = 401, .external_lex_state = 16},
  [2382] = {.lex_state = 401, .external_lex_state = 24},
  [2383] = {.lex_state = 401, .external_lex_state = 16},
  [2384] = {.lex_state = 401, .external_lex_state = 24},
  [2385] = {.lex_state = 401, .external_lex_state = 16},
  [2386] = {.lex_state = 401, .external_lex_state = 24},
  [2387] = {.lex_state = 401, .external_lex_state = 24},
  [2388] = {.lex_state = 206},
  [2389] = {.lex_state = 206},
  [2390] = {.lex_state = 206},
  [2391] = {.lex_state = 206},
  [2392] = {.lex_state = 206},
  [2393] = {.lex_state = 455, .external_lex_state = 13},
  [2394] = {.lex_state = 440, .external_lex_state = 28},
  [2395] = {.lex_state = 408, .external_lex_state = 28},
  [2396] = {.lex_state = 440, .external_lex_state = 28},
  [2397] = {.lex_state = 399, .external_lex_state = 16},
  [2398] = {.lex_state = 440, .external_lex_state = 28},
  [2399] = {.lex_state = 403},
  [2400] = {.lex_state = 401, .external_lex_state = 16},
  [2401] = {.lex_state = 206},
  [2402] = {.lex_state = 303, .external_lex_state = 16},
  [2403] = {.lex_state = 303, .external_lex_state = 16},
  [2404] = {.lex_state = 303, .external_lex_state = 16},
  [2405] = {.lex_state = 440, .external_lex_state = 28},
  [2406] = {.lex_state = 403},
  [2407] = {.lex_state = 401, .external_lex_state = 16},
  [2408] = {.lex_state = 440, .external_lex_state = 28},
  [2409] = {.lex_state = 403},
  [2410] = {.lex_state = 401, .external_lex_state = 16},
  [2411] = {.lex_state = 440, .external_lex_state = 28},
  [2412] = {.lex_state = 440, .external_lex_state = 28},
  [2413] = {.lex_state = 313, .external_lex_state = 25},
  [2414] = {.lex_state = 313, .external_lex_state = 25},
  [2415] = {.lex_state = 313, .external_lex_state = 25},
  [2416] = {.lex_state = 313, .external_lex_state = 25},
  [2417] = {.lex_state = 401, .external_lex_state = 16},
  [2418] = {.lex_state = 313, .external_lex_state = 25},
  [2419] = {.lex_state = 401, .external_lex_state = 16},
  [2420] = {.lex_state = 313, .external_lex_state = 25},
  [2421] = {.lex_state = 401, .external_lex_state = 16},
  [2422] = {.lex_state = 313, .external_lex_state = 25},
  [2423] = {.lex_state = 313, .external_lex_state = 25},
  [2424] = {.lex_state = 313, .external_lex_state = 13},
  [2425] = {.lex_state = 313, .external_lex_state = 13},
  [2426] = {.lex_state = 313, .external_lex_state = 13},
  [2427] = {.lex_state = 313, .external_lex_state = 13},
  [2428] = {.lex_state = 401, .external_lex_state = 16},
  [2429] = {.lex_state = 313, .external_lex_state = 13},
  [2430] = {.lex_state = 401, .external_lex_state = 16},
  [2431] = {.lex_state = 313, .external_lex_state = 13},
  [2432] = {.lex_state = 401, .external_lex_state = 16},
  [2433] = {.lex_state = 313, .external_lex_state = 13},
  [2434] = {.lex_state = 313, .external_lex_state = 13},
  [2435] = {.lex_state = 315, .external_lex_state = 17},
  [2436] = {.lex_state = 315, .external_lex_state = 17},
  [2437] = {.lex_state = 315, .external_lex_state = 17},
  [2438] = {.lex_state = 457, .external_lex_state = 13},
  [2439] = {.lex_state = 410, .external_lex_state = 28},
  [2440] = {.lex_state = 333, .external_lex_state = 19},
  [2441] = {.lex_state = 333, .external_lex_state = 19},
  [2442] = {.lex_state = 333, .external_lex_state = 19},
  [2443] = {.lex_state = 333, .external_lex_state = 19},
  [2444] = {.lex_state = 401, .external_lex_state = 16},
  [2445] = {.lex_state = 333, .external_lex_state = 19},
  [2446] = {.lex_state = 401, .external_lex_state = 16},
  [2447] = {.lex_state = 333, .external_lex_state = 19},
  [2448] = {.lex_state = 401, .external_lex_state = 16},
  [2449] = {.lex_state = 333, .external_lex_state = 19},
  [2450] = {.lex_state = 333, .external_lex_state = 19},
  [2451] = {.lex_state = 418, .external_lex_state = 13},
  [2452] = {.lex_state = 418, .external_lex_state = 13},
  [2453] = {.lex_state = 418, .external_lex_state = 13},
  [2454] = {.lex_state = 418, .external_lex_state = 13},
  [2455] = {.lex_state = 401, .external_lex_state = 16},
  [2456] = {.lex_state = 418, .external_lex_state = 13},
  [2457] = {.lex_state = 401, .external_lex_state = 16},
  [2458] = {.lex_state = 418, .external_lex_state = 13},
  [2459] = {.lex_state = 401, .external_lex_state = 16},
  [2460] = {.lex_state = 418, .external_lex_state = 13},
  [2461] = {.lex_state = 418, .external_lex_state = 13},
  [2462] = {.lex_state = 281, .external_lex_state = 21},
  [2463] = {.lex_state = 281, .external_lex_state = 21},
  [2464] = {.lex_state = 281, .external_lex_state = 21},
  [2465] = {.lex_state = 420, .external_lex_state = 10},
  [2466] = {.lex_state = 420, .external_lex_state = 10},
  [2467] = {.lex_state = 420, .external_lex_state = 10},
  [2468] = {.lex_state = 420, .external_lex_state = 10},
  [2469] = {.lex_state = 401, .external_lex_state = 16},
  [2470] = {.lex_state = 420, .external_lex_state = 10},
  [2471] = {.lex_state = 401, .external_lex_state = 16},
  [2472] = {.lex_state = 420, .external_lex_state = 10},
  [2473] = {.lex_state = 401, .external_lex_state = 16},
  [2474] = {.lex_state = 420, .external_lex_state = 10},
  [2475] = {.lex_state = 420, .external_lex_state = 10},
  [2476] = {.lex_state = 469, .external_lex_state = 8},
  [2477] = {.lex_state = 320},
  [2478] = {.lex_state = 469, .external_lex_state = 21},
  [2479] = {.lex_state = 254},
  [2480] = {.lex_state = 261},
  [2481] = {.lex_state = 469, .external_lex_state = 21},
  [2482] = {.lex_state = 264, .external_lex_state = 6},
  [2483] = {.lex_state = 135, .external_lex_state = 2},
  [2484] = {.lex_state = 135, .external_lex_state = 2},
  [2485] = {.lex_state = 135, .external_lex_state = 2},
  [2486] = {.lex_state = 471, .external_lex_state = 7},
  [2487] = {.lex_state = 206},
  [2488] = {.lex_state = 473, .external_lex_state = 23},
  [2489] = {.lex_state = 471, .external_lex_state = 23},
  [2490] = {.lex_state = 272, .external_lex_state = 9},
  [2491] = {.lex_state = 234},
  [2492] = {.lex_state = 459, .external_lex_state = 14},
  [2493] = {.lex_state = 459, .external_lex_state = 14},
  [2494] = {.lex_state = 254},
  [2495] = {.lex_state = 459, .external_lex_state = 14},
  [2496] = {.lex_state = 459, .external_lex_state = 14},
  [2497] = {.lex_state = 459, .external_lex_state = 14},
  [2498] = {.lex_state = 206},
  [2499] = {.lex_state = 303, .external_lex_state = 16},
  [2500] = {.lex_state = 311, .external_lex_state = 6},
  [2501] = {.lex_state = 303, .external_lex_state = 16},
  [2502] = {.lex_state = 303, .external_lex_state = 16},
  [2503] = {.lex_state = 206},
  [2504] = {.lex_state = 320, .external_lex_state = 2},
  [2505] = {.lex_state = 206},
  [2506] = {.lex_state = 328, .external_lex_state = 2},
  [2507] = {.lex_state = 206},
  [2508] = {.lex_state = 320, .external_lex_state = 2},
  [2509] = {.lex_state = 459, .external_lex_state = 3},
  [2510] = {.lex_state = 234},
  [2511] = {.lex_state = 459, .external_lex_state = 10},
  [2512] = {.lex_state = 459, .external_lex_state = 10},
  [2513] = {.lex_state = 254},
  [2514] = {.lex_state = 459, .external_lex_state = 10},
  [2515] = {.lex_state = 459, .external_lex_state = 10},
  [2516] = {.lex_state = 459, .external_lex_state = 10},
  [2517] = {.lex_state = 206},
  [2518] = {.lex_state = 303, .external_lex_state = 16},
  [2519] = {.lex_state = 311, .external_lex_state = 6},
  [2520] = {.lex_state = 303, .external_lex_state = 16},
  [2521] = {.lex_state = 303, .external_lex_state = 16},
  [2522] = {.lex_state = 206},
  [2523] = {.lex_state = 320, .external_lex_state = 2},
  [2524] = {.lex_state = 206},
  [2525] = {.lex_state = 328, .external_lex_state = 2},
  [2526] = {.lex_state = 206},
  [2527] = {.lex_state = 320, .external_lex_state = 2},
  [2528] = {.lex_state = 459, .external_lex_state = 4},
  [2529] = {.lex_state = 465, .external_lex_state = 5},
  [2530] = {.lex_state = 465, .external_lex_state = 5},
  [2531] = {.lex_state = 465, .external_lex_state = 5},
  [2532] = {.lex_state = 399, .external_lex_state = 16},
  [2533] = {.lex_state = 465, .external_lex_state = 5},
  [2534] = {.lex_state = 403},
  [2535] = {.lex_state = 401, .external_lex_state = 16},
  [2536] = {.lex_state = 206},
  [2537] = {.lex_state = 303, .external_lex_state = 16},
  [2538] = {.lex_state = 303, .external_lex_state = 16},
  [2539] = {.lex_state = 303, .external_lex_state = 16},
  [2540] = {.lex_state = 465, .external_lex_state = 5},
  [2541] = {.lex_state = 403},
  [2542] = {.lex_state = 401, .external_lex_state = 16},
  [2543] = {.lex_state = 465, .external_lex_state = 5},
  [2544] = {.lex_state = 403},
  [2545] = {.lex_state = 401, .external_lex_state = 16},
  [2546] = {.lex_state = 465, .external_lex_state = 5},
  [2547] = {.lex_state = 465, .external_lex_state = 5},
  [2548] = {.lex_state = 206},
  [2549] = {.lex_state = 469, .external_lex_state = 8},
  [2550] = {.lex_state = 283, .external_lex_state = 4},
  [2551] = {.lex_state = 469, .external_lex_state = 8},
  [2552] = {.lex_state = 234},
  [2553] = {.lex_state = 465, .external_lex_state = 5},
  [2554] = {.lex_state = 465, .external_lex_state = 5},
  [2555] = {.lex_state = 465, .external_lex_state = 7},
  [2556] = {.lex_state = 471, .external_lex_state = 5},
  [2557] = {.lex_state = 254},
  [2558] = {.lex_state = 261},
  [2559] = {.lex_state = 471, .external_lex_state = 5},
  [2560] = {.lex_state = 264, .external_lex_state = 6},
  [2561] = {.lex_state = 135, .external_lex_state = 2},
  [2562] = {.lex_state = 135, .external_lex_state = 2},
  [2563] = {.lex_state = 135, .external_lex_state = 2},
  [2564] = {.lex_state = 471, .external_lex_state = 5},
  [2565] = {.lex_state = 471, .external_lex_state = 5},
  [2566] = {.lex_state = 471, .external_lex_state = 7},
  [2567] = {.lex_state = 471, .external_lex_state = 7},
  [2568] = {.lex_state = 465, .external_lex_state = 7},
  [2569] = {.lex_state = 450, .external_lex_state = 2},
  [2570] = {.lex_state = 244, .external_lex_state = 4},
  [2571] = {.lex_state = 268, .external_lex_state = 8},
  [2572] = {.lex_state = 465, .external_lex_state = 7},
  [2573] = {.lex_state = 424},
  [2574] = {.lex_state = 283, .external_lex_state = 4},
  [2575] = {.lex_state = 469, .external_lex_state = 8},
  [2576] = {.lex_state = 450, .external_lex_state = 2},
  [2577] = {.lex_state = 424},
  [2578] = {.lex_state = 283, .external_lex_state = 4},
  [2579] = {.lex_state = 469, .external_lex_state = 8},
  [2580] = {.lex_state = 234},
  [2581] = {.lex_state = 244, .external_lex_state = 4},
  [2582] = {.lex_state = 268, .external_lex_state = 8},
  [2583] = {.lex_state = 330, .external_lex_state = 2},
  [2584] = {.lex_state = 330, .external_lex_state = 2},
  [2585] = {.lex_state = 234},
  [2586] = {.lex_state = 244, .external_lex_state = 4},
  [2587] = {.lex_state = 268, .external_lex_state = 8},
  [2588] = {.lex_state = 330, .external_lex_state = 2},
  [2589] = {.lex_state = 330, .external_lex_state = 2},
  [2590] = {.lex_state = 412, .external_lex_state = 27},
  [2591] = {.lex_state = 412, .external_lex_state = 27},
  [2592] = {.lex_state = 412, .external_lex_state = 27},
  [2593] = {.lex_state = 401, .external_lex_state = 16},
  [2594] = {.lex_state = 436, .external_lex_state = 24},
  [2595] = {.lex_state = 436, .external_lex_state = 24},
  [2596] = {.lex_state = 206, .external_lex_state = 16},
  [2597] = {.lex_state = 401, .external_lex_state = 16},
  [2598] = {.lex_state = 412, .external_lex_state = 27},
  [2599] = {.lex_state = 401, .external_lex_state = 16},
  [2600] = {.lex_state = 412, .external_lex_state = 27},
  [2601] = {.lex_state = 401, .external_lex_state = 16},
  [2602] = {.lex_state = 412, .external_lex_state = 27},
  [2603] = {.lex_state = 401, .external_lex_state = 16},
  [2604] = {.lex_state = 412, .external_lex_state = 27},
  [2605] = {.lex_state = 401, .external_lex_state = 16},
  [2606] = {.lex_state = 436, .external_lex_state = 24},
  [2607] = {.lex_state = 436, .external_lex_state = 24},
  [2608] = {.lex_state = 436, .external_lex_state = 24},
  [2609] = {.lex_state = 436, .external_lex_state = 24},
  [2610] = {.lex_state = 401, .external_lex_state = 16},
  [2611] = {.lex_state = 436, .external_lex_state = 24},
  [2612] = {.lex_state = 401, .external_lex_state = 16},
  [2613] = {.lex_state = 436, .external_lex_state = 24},
  [2614] = {.lex_state = 401, .external_lex_state = 16},
  [2615] = {.lex_state = 436, .external_lex_state = 24},
  [2616] = {.lex_state = 436, .external_lex_state = 24},
  [2617] = {.lex_state = 401, .external_lex_state = 24},
  [2618] = {.lex_state = 401, .external_lex_state = 24},
  [2619] = {.lex_state = 401, .external_lex_state = 24},
  [2620] = {.lex_state = 206},
  [2621] = {.lex_state = 206},
  [2622] = {.lex_state = 440, .external_lex_state = 28},
  [2623] = {.lex_state = 436, .external_lex_state = 24},
  [2624] = {.lex_state = 436, .external_lex_state = 24},
  [2625] = {.lex_state = 206, .external_lex_state = 16},
  [2626] = {.lex_state = 401, .external_lex_state = 16},
  [2627] = {.lex_state = 440, .external_lex_state = 28},
  [2628] = {.lex_state = 399, .external_lex_state = 16},
  [2629] = {.lex_state = 440, .external_lex_state = 28},
  [2630] = {.lex_state = 403},
  [2631] = {.lex_state = 401, .external_lex_state = 16},
  [2632] = {.lex_state = 440, .external_lex_state = 28},
  [2633] = {.lex_state = 403},
  [2634] = {.lex_state = 401, .external_lex_state = 16},
  [2635] = {.lex_state = 403},
  [2636] = {.lex_state = 401, .external_lex_state = 16},
  [2637] = {.lex_state = 401, .external_lex_state = 16},
  [2638] = {.lex_state = 440, .external_lex_state = 28},
  [2639] = {.lex_state = 401, .external_lex_state = 16},
  [2640] = {.lex_state = 313, .external_lex_state = 25},
  [2641] = {.lex_state = 313, .external_lex_state = 25},
  [2642] = {.lex_state = 313, .external_lex_state = 25},
  [2643] = {.lex_state = 313, .external_lex_state = 13},
  [2644] = {.lex_state = 313, .external_lex_state = 13},
  [2645] = {.lex_state = 313, .external_lex_state = 13},
  [2646] = {.lex_state = 333, .external_lex_state = 19},
  [2647] = {.lex_state = 333, .external_lex_state = 19},
  [2648] = {.lex_state = 333, .external_lex_state = 19},
  [2649] = {.lex_state = 418, .external_lex_state = 13},
  [2650] = {.lex_state = 418, .external_lex_state = 13},
  [2651] = {.lex_state = 418, .external_lex_state = 13},
  [2652] = {.lex_state = 420, .external_lex_state = 10},
  [2653] = {.lex_state = 420, .external_lex_state = 10},
  [2654] = {.lex_state = 420, .external_lex_state = 10},
  [2655] = {.lex_state = 469, .external_lex_state = 8},
  [2656] = {.lex_state = 320},
  [2657] = {.lex_state = 234},
  [2658] = {.lex_state = 469, .external_lex_state = 21},
  [2659] = {.lex_state = 469, .external_lex_state = 21},
  [2660] = {.lex_state = 254},
  [2661] = {.lex_state = 469, .external_lex_state = 21},
  [2662] = {.lex_state = 469, .external_lex_state = 21},
  [2663] = {.lex_state = 469, .external_lex_state = 21},
  [2664] = {.lex_state = 206},
  [2665] = {.lex_state = 303, .external_lex_state = 16},
  [2666] = {.lex_state = 311, .external_lex_state = 6},
  [2667] = {.lex_state = 303, .external_lex_state = 16},
  [2668] = {.lex_state = 303, .external_lex_state = 16},
  [2669] = {.lex_state = 206},
  [2670] = {.lex_state = 320, .external_lex_state = 2},
  [2671] = {.lex_state = 206},
  [2672] = {.lex_state = 328, .external_lex_state = 2},
  [2673] = {.lex_state = 206},
  [2674] = {.lex_state = 320, .external_lex_state = 2},
  [2675] = {.lex_state = 471, .external_lex_state = 7},
  [2676] = {.lex_state = 206},
  [2677] = {.lex_state = 135},
  [2678] = {.lex_state = 234},
  [2679] = {.lex_state = 135},
  [2680] = {.lex_state = 234},
  [2681] = {.lex_state = 234},
  [2682] = {.lex_state = 471, .external_lex_state = 23},
  [2683] = {.lex_state = 459, .external_lex_state = 3},
  [2684] = {.lex_state = 320},
  [2685] = {.lex_state = 459, .external_lex_state = 14},
  [2686] = {.lex_state = 459, .external_lex_state = 14},
  [2687] = {.lex_state = 459, .external_lex_state = 14},
  [2688] = {.lex_state = 459, .external_lex_state = 14},
  [2689] = {.lex_state = 459, .external_lex_state = 14},
  [2690] = {.lex_state = 399, .external_lex_state = 16},
  [2691] = {.lex_state = 459, .external_lex_state = 14},
  [2692] = {.lex_state = 403},
  [2693] = {.lex_state = 401, .external_lex_state = 16},
  [2694] = {.lex_state = 206},
  [2695] = {.lex_state = 303, .external_lex_state = 16},
  [2696] = {.lex_state = 303, .external_lex_state = 16},
  [2697] = {.lex_state = 303, .external_lex_state = 16},
  [2698] = {.lex_state = 459, .external_lex_state = 14},
  [2699] = {.lex_state = 403},
  [2700] = {.lex_state = 401, .external_lex_state = 16},
  [2701] = {.lex_state = 459, .external_lex_state = 14},
  [2702] = {.lex_state = 403},
  [2703] = {.lex_state = 401, .external_lex_state = 16},
  [2704] = {.lex_state = 459, .external_lex_state = 14},
  [2705] = {.lex_state = 459, .external_lex_state = 14},
  [2706] = {.lex_state = 459, .external_lex_state = 10},
  [2707] = {.lex_state = 459, .external_lex_state = 10},
  [2708] = {.lex_state = 459, .external_lex_state = 10},
  [2709] = {.lex_state = 399, .external_lex_state = 16},
  [2710] = {.lex_state = 459, .external_lex_state = 10},
  [2711] = {.lex_state = 403},
  [2712] = {.lex_state = 401, .external_lex_state = 16},
  [2713] = {.lex_state = 206},
  [2714] = {.lex_state = 303, .external_lex_state = 16},
  [2715] = {.lex_state = 303, .external_lex_state = 16},
  [2716] = {.lex_state = 303, .external_lex_state = 16},
  [2717] = {.lex_state = 459, .external_lex_state = 10},
  [2718] = {.lex_state = 403},
  [2719] = {.lex_state = 401, .external_lex_state = 16},
  [2720] = {.lex_state = 459, .external_lex_state = 10},
  [2721] = {.lex_state = 403},
  [2722] = {.lex_state = 401, .external_lex_state = 16},
  [2723] = {.lex_state = 459, .external_lex_state = 10},
  [2724] = {.lex_state = 459, .external_lex_state = 10},
  [2725] = {.lex_state = 465, .external_lex_state = 5},
  [2726] = {.lex_state = 436, .external_lex_state = 24},
  [2727] = {.lex_state = 436, .external_lex_state = 24},
  [2728] = {.lex_state = 206, .external_lex_state = 16},
  [2729] = {.lex_state = 401, .external_lex_state = 16},
  [2730] = {.lex_state = 465, .external_lex_state = 5},
  [2731] = {.lex_state = 399, .external_lex_state = 16},
  [2732] = {.lex_state = 465, .external_lex_state = 5},
  [2733] = {.lex_state = 403},
  [2734] = {.lex_state = 401, .external_lex_state = 16},
  [2735] = {.lex_state = 465, .external_lex_state = 5},
  [2736] = {.lex_state = 403},
  [2737] = {.lex_state = 401, .external_lex_state = 16},
  [2738] = {.lex_state = 403},
  [2739] = {.lex_state = 401, .external_lex_state = 16},
  [2740] = {.lex_state = 401, .external_lex_state = 16},
  [2741] = {.lex_state = 465, .external_lex_state = 5},
  [2742] = {.lex_state = 401, .external_lex_state = 16},
  [2743] = {.lex_state = 473, .external_lex_state = 23},
  [2744] = {.lex_state = 471, .external_lex_state = 5},
  [2745] = {.lex_state = 471, .external_lex_state = 5},
  [2746] = {.lex_state = 234},
  [2747] = {.lex_state = 471, .external_lex_state = 5},
  [2748] = {.lex_state = 471, .external_lex_state = 5},
  [2749] = {.lex_state = 254},
  [2750] = {.lex_state = 471, .external_lex_state = 5},
  [2751] = {.lex_state = 471, .external_lex_state = 5},
  [2752] = {.lex_state = 471, .external_lex_state = 5},
  [2753] = {.lex_state = 206},
  [2754] = {.lex_state = 303, .external_lex_state = 16},
  [2755] = {.lex_state = 311, .external_lex_state = 6},
  [2756] = {.lex_state = 303, .external_lex_state = 16},
  [2757] = {.lex_state = 303, .external_lex_state = 16},
  [2758] = {.lex_state = 206},
  [2759] = {.lex_state = 320, .external_lex_state = 2},
  [2760] = {.lex_state = 206},
  [2761] = {.lex_state = 328, .external_lex_state = 2},
  [2762] = {.lex_state = 206},
  [2763] = {.lex_state = 320, .external_lex_state = 2},
  [2764] = {.lex_state = 471, .external_lex_state = 7},
  [2765] = {.lex_state = 450, .external_lex_state = 2},
  [2766] = {.lex_state = 450, .external_lex_state = 2},
  [2767] = {.lex_state = 330, .external_lex_state = 2},
  [2768] = {.lex_state = 234},
  [2769] = {.lex_state = 244, .external_lex_state = 4},
  [2770] = {.lex_state = 268, .external_lex_state = 8},
  [2771] = {.lex_state = 330, .external_lex_state = 2},
  [2772] = {.lex_state = 330, .external_lex_state = 2},
  [2773] = {.lex_state = 330, .external_lex_state = 2},
  [2774] = {.lex_state = 234},
  [2775] = {.lex_state = 244, .external_lex_state = 4},
  [2776] = {.lex_state = 268, .external_lex_state = 8},
  [2777] = {.lex_state = 330, .external_lex_state = 2},
  [2778] = {.lex_state = 412, .external_lex_state = 27},
  [2779] = {.lex_state = 412, .external_lex_state = 27},
  [2780] = {.lex_state = 412, .external_lex_state = 27},
  [2781] = {.lex_state = 412, .external_lex_state = 27},
  [2782] = {.lex_state = 401, .external_lex_state = 16},
  [2783] = {.lex_state = 412, .external_lex_state = 27},
  [2784] = {.lex_state = 401, .external_lex_state = 16},
  [2785] = {.lex_state = 412, .external_lex_state = 27},
  [2786] = {.lex_state = 401, .external_lex_state = 16},
  [2787] = {.lex_state = 412, .external_lex_state = 27},
  [2788] = {.lex_state = 412, .external_lex_state = 27},
  [2789] = {.lex_state = 436, .external_lex_state = 24},
  [2790] = {.lex_state = 436, .external_lex_state = 24},
  [2791] = {.lex_state = 436, .external_lex_state = 24},
  [2792] = {.lex_state = 440, .external_lex_state = 28},
  [2793] = {.lex_state = 440, .external_lex_state = 28},
  [2794] = {.lex_state = 440, .external_lex_state = 28},
  [2795] = {.lex_state = 401, .external_lex_state = 16},
  [2796] = {.lex_state = 436, .external_lex_state = 24},
  [2797] = {.lex_state = 436, .external_lex_state = 24},
  [2798] = {.lex_state = 206, .external_lex_state = 16},
  [2799] = {.lex_state = 401, .external_lex_state = 16},
  [2800] = {.lex_state = 440, .external_lex_state = 28},
  [2801] = {.lex_state = 401, .external_lex_state = 16},
  [2802] = {.lex_state = 440, .external_lex_state = 28},
  [2803] = {.lex_state = 401, .external_lex_state = 16},
  [2804] = {.lex_state = 440, .external_lex_state = 28},
  [2805] = {.lex_state = 401, .external_lex_state = 16},
  [2806] = {.lex_state = 440, .external_lex_state = 28},
  [2807] = {.lex_state = 401, .external_lex_state = 16},
  [2808] = {.lex_state = 469, .external_lex_state = 8},
  [2809] = {.lex_state = 469, .external_lex_state = 21},
  [2810] = {.lex_state = 469, .external_lex_state = 21},
  [2811] = {.lex_state = 469, .external_lex_state = 21},
  [2812] = {.lex_state = 399, .external_lex_state = 16},
  [2813] = {.lex_state = 469, .external_lex_state = 21},
  [2814] = {.lex_state = 403},
  [2815] = {.lex_state = 401, .external_lex_state = 16},
  [2816] = {.lex_state = 206},
  [2817] = {.lex_state = 303, .external_lex_state = 16},
  [2818] = {.lex_state = 303, .external_lex_state = 16},
  [2819] = {.lex_state = 303, .external_lex_state = 16},
  [2820] = {.lex_state = 469, .external_lex_state = 21},
  [2821] = {.lex_state = 403},
  [2822] = {.lex_state = 401, .external_lex_state = 16},
  [2823] = {.lex_state = 469, .external_lex_state = 21},
  [2824] = {.lex_state = 403},
  [2825] = {.lex_state = 401, .external_lex_state = 16},
  [2826] = {.lex_state = 469, .external_lex_state = 21},
  [2827] = {.lex_state = 469, .external_lex_state = 21},
  [2828] = {.lex_state = 473, .external_lex_state = 23},
  [2829] = {.lex_state = 234},
  [2830] = {.lex_state = 475, .external_lex_state = 10},
  [2831] = {.lex_state = 254},
  [2832] = {.lex_state = 261},
  [2833] = {.lex_state = 475, .external_lex_state = 10},
  [2834] = {.lex_state = 264, .external_lex_state = 6},
  [2835] = {.lex_state = 135, .external_lex_state = 2},
  [2836] = {.lex_state = 135, .external_lex_state = 2},
  [2837] = {.lex_state = 135, .external_lex_state = 2},
  [2838] = {.lex_state = 234},
  [2839] = {.lex_state = 471, .external_lex_state = 27},
  [2840] = {.lex_state = 471, .external_lex_state = 27},
  [2841] = {.lex_state = 471, .external_lex_state = 27},
  [2842] = {.lex_state = 471, .external_lex_state = 27},
  [2843] = {.lex_state = 471, .external_lex_state = 23},
  [2844] = {.lex_state = 459, .external_lex_state = 3},
  [2845] = {.lex_state = 320},
  [2846] = {.lex_state = 459, .external_lex_state = 14},
  [2847] = {.lex_state = 436, .external_lex_state = 24},
  [2848] = {.lex_state = 436, .external_lex_state = 24},
  [2849] = {.lex_state = 206, .external_lex_state = 16},
  [2850] = {.lex_state = 401, .external_lex_state = 16},
  [2851] = {.lex_state = 459, .external_lex_state = 14},
  [2852] = {.lex_state = 399, .external_lex_state = 16},
  [2853] = {.lex_state = 459, .external_lex_state = 14},
  [2854] = {.lex_state = 403},
  [2855] = {.lex_state = 401, .external_lex_state = 16},
  [2856] = {.lex_state = 459, .external_lex_state = 14},
  [2857] = {.lex_state = 403},
  [2858] = {.lex_state = 401, .external_lex_state = 16},
  [2859] = {.lex_state = 403},
  [2860] = {.lex_state = 401, .external_lex_state = 16},
  [2861] = {.lex_state = 401, .external_lex_state = 16},
  [2862] = {.lex_state = 459, .external_lex_state = 14},
  [2863] = {.lex_state = 401, .external_lex_state = 16},
  [2864] = {.lex_state = 459, .external_lex_state = 10},
  [2865] = {.lex_state = 436, .external_lex_state = 24},
  [2866] = {.lex_state = 436, .external_lex_state = 24},
  [2867] = {.lex_state = 206, .external_lex_state = 16},
  [2868] = {.lex_state = 401, .external_lex_state = 16},
  [2869] = {.lex_state = 459, .external_lex_state = 10},
  [2870] = {.lex_state = 399, .external_lex_state = 16},
  [2871] = {.lex_state = 459, .external_lex_state = 10},
  [2872] = {.lex_state = 403},
  [2873] = {.lex_state = 401, .external_lex_state = 16},
  [2874] = {.lex_state = 459, .external_lex_state = 10},
  [2875] = {.lex_state = 403},
  [2876] = {.lex_state = 401, .external_lex_state = 16},
  [2877] = {.lex_state = 403},
  [2878] = {.lex_state = 401, .external_lex_state = 16},
  [2879] = {.lex_state = 401, .external_lex_state = 16},
  [2880] = {.lex_state = 459, .external_lex_state = 10},
  [2881] = {.lex_state = 401, .external_lex_state = 16},
  [2882] = {.lex_state = 465, .external_lex_state = 5},
  [2883] = {.lex_state = 465, .external_lex_state = 5},
  [2884] = {.lex_state = 465, .external_lex_state = 5},
  [2885] = {.lex_state = 401, .external_lex_state = 16},
  [2886] = {.lex_state = 436, .external_lex_state = 24},
  [2887] = {.lex_state = 436, .external_lex_state = 24},
  [2888] = {.lex_state = 206, .external_lex_state = 16},
  [2889] = {.lex_state = 401, .external_lex_state = 16},
  [2890] = {.lex_state = 465, .external_lex_state = 5},
  [2891] = {.lex_state = 401, .external_lex_state = 16},
  [2892] = {.lex_state = 465, .external_lex_state = 5},
  [2893] = {.lex_state = 401, .external_lex_state = 16},
  [2894] = {.lex_state = 465, .external_lex_state = 5},
  [2895] = {.lex_state = 401, .external_lex_state = 16},
  [2896] = {.lex_state = 465, .external_lex_state = 5},
  [2897] = {.lex_state = 401, .external_lex_state = 16},
  [2898] = {.lex_state = 471, .external_lex_state = 5},
  [2899] = {.lex_state = 471, .external_lex_state = 5},
  [2900] = {.lex_state = 471, .external_lex_state = 5},
  [2901] = {.lex_state = 399, .external_lex_state = 16},
  [2902] = {.lex_state = 471, .external_lex_state = 5},
  [2903] = {.lex_state = 403},
  [2904] = {.lex_state = 401, .external_lex_state = 16},
  [2905] = {.lex_state = 206},
  [2906] = {.lex_state = 303, .external_lex_state = 16},
  [2907] = {.lex_state = 303, .external_lex_state = 16},
  [2908] = {.lex_state = 303, .external_lex_state = 16},
  [2909] = {.lex_state = 471, .external_lex_state = 5},
  [2910] = {.lex_state = 403},
  [2911] = {.lex_state = 401, .external_lex_state = 16},
  [2912] = {.lex_state = 471, .external_lex_state = 5},
  [2913] = {.lex_state = 403},
  [2914] = {.lex_state = 401, .external_lex_state = 16},
  [2915] = {.lex_state = 471, .external_lex_state = 5},
  [2916] = {.lex_state = 471, .external_lex_state = 5},
  [2917] = {.lex_state = 330, .external_lex_state = 2},
  [2918] = {.lex_state = 234},
  [2919] = {.lex_state = 244, .external_lex_state = 4},
  [2920] = {.lex_state = 268, .external_lex_state = 8},
  [2921] = {.lex_state = 330, .external_lex_state = 2},
  [2922] = {.lex_state = 234},
  [2923] = {.lex_state = 244, .external_lex_state = 4},
  [2924] = {.lex_state = 268, .external_lex_state = 8},
  [2925] = {.lex_state = 412, .external_lex_state = 27},
  [2926] = {.lex_state = 412, .external_lex_state = 27},
  [2927] = {.lex_state = 412, .external_lex_state = 27},
  [2928] = {.lex_state = 440, .external_lex_state = 28},
  [2929] = {.lex_state = 440, .external_lex_state = 28},
  [2930] = {.lex_state = 440, .external_lex_state = 28},
  [2931] = {.lex_state = 440, .external_lex_state = 28},
  [2932] = {.lex_state = 401, .external_lex_state = 16},
  [2933] = {.lex_state = 440, .external_lex_state = 28},
  [2934] = {.lex_state = 401, .external_lex_state = 16},
  [2935] = {.lex_state = 440, .external_lex_state = 28},
  [2936] = {.lex_state = 401, .external_lex_state = 16},
  [2937] = {.lex_state = 440, .external_lex_state = 28},
  [2938] = {.lex_state = 440, .external_lex_state = 28},
  [2939] = {.lex_state = 469, .external_lex_state = 21},
  [2940] = {.lex_state = 436, .external_lex_state = 24},
  [2941] = {.lex_state = 436, .external_lex_state = 24},
  [2942] = {.lex_state = 206, .external_lex_state = 16},
  [2943] = {.lex_state = 401, .external_lex_state = 16},
  [2944] = {.lex_state = 469, .external_lex_state = 21},
  [2945] = {.lex_state = 399, .external_lex_state = 16},
  [2946] = {.lex_state = 469, .external_lex_state = 21},
  [2947] = {.lex_state = 403},
  [2948] = {.lex_state = 401, .external_lex_state = 16},
  [2949] = {.lex_state = 469, .external_lex_state = 21},
  [2950] = {.lex_state = 403},
  [2951] = {.lex_state = 401, .external_lex_state = 16},
  [2952] = {.lex_state = 403},
  [2953] = {.lex_state = 401, .external_lex_state = 16},
  [2954] = {.lex_state = 401, .external_lex_state = 16},
  [2955] = {.lex_state = 469, .external_lex_state = 21},
  [2956] = {.lex_state = 401, .external_lex_state = 16},
  [2957] = {.lex_state = 475, .external_lex_state = 10},
  [2958] = {.lex_state = 475, .external_lex_state = 10},
  [2959] = {.lex_state = 234},
  [2960] = {.lex_state = 475, .external_lex_state = 10},
  [2961] = {.lex_state = 475, .external_lex_state = 10},
  [2962] = {.lex_state = 254},
  [2963] = {.lex_state = 475, .external_lex_state = 10},
  [2964] = {.lex_state = 475, .external_lex_state = 10},
  [2965] = {.lex_state = 475, .external_lex_state = 10},
  [2966] = {.lex_state = 206},
  [2967] = {.lex_state = 303, .external_lex_state = 16},
  [2968] = {.lex_state = 311, .external_lex_state = 6},
  [2969] = {.lex_state = 303, .external_lex_state = 16},
  [2970] = {.lex_state = 303, .external_lex_state = 16},
  [2971] = {.lex_state = 206},
  [2972] = {.lex_state = 320, .external_lex_state = 2},
  [2973] = {.lex_state = 206},
  [2974] = {.lex_state = 328, .external_lex_state = 2},
  [2975] = {.lex_state = 206},
  [2976] = {.lex_state = 320, .external_lex_state = 2},
  [2977] = {.lex_state = 471, .external_lex_state = 27},
  [2978] = {.lex_state = 471, .external_lex_state = 27},
  [2979] = {.lex_state = 471, .external_lex_state = 27},
  [2980] = {.lex_state = 459, .external_lex_state = 3},
  [2981] = {.lex_state = 459, .external_lex_state = 14},
  [2982] = {.lex_state = 459, .external_lex_state = 14},
  [2983] = {.lex_state = 459, .external_lex_state = 14},
  [2984] = {.lex_state = 401, .external_lex_state = 16},
  [2985] = {.lex_state = 436, .external_lex_state = 24},
  [2986] = {.lex_state = 436, .external_lex_state = 24},
  [2987] = {.lex_state = 206, .external_lex_state = 16},
  [2988] = {.lex_state = 401, .external_lex_state = 16},
  [2989] = {.lex_state = 459, .external_lex_state = 14},
  [2990] = {.lex_state = 401, .external_lex_state = 16},
  [2991] = {.lex_state = 459, .external_lex_state = 14},
  [2992] = {.lex_state = 401, .external_lex_state = 16},
  [2993] = {.lex_state = 459, .external_lex_state = 14},
  [2994] = {.lex_state = 401, .external_lex_state = 16},
  [2995] = {.lex_state = 459, .external_lex_state = 14},
  [2996] = {.lex_state = 401, .external_lex_state = 16},
  [2997] = {.lex_state = 459, .external_lex_state = 10},
  [2998] = {.lex_state = 459, .external_lex_state = 10},
  [2999] = {.lex_state = 459, .external_lex_state = 10},
  [3000] = {.lex_state = 401, .external_lex_state = 16},
  [3001] = {.lex_state = 436, .external_lex_state = 24},
  [3002] = {.lex_state = 436, .external_lex_state = 24},
  [3003] = {.lex_state = 206, .external_lex_state = 16},
  [3004] = {.lex_state = 401, .external_lex_state = 16},
  [3005] = {.lex_state = 459, .external_lex_state = 10},
  [3006] = {.lex_state = 401, .external_lex_state = 16},
  [3007] = {.lex_state = 459, .external_lex_state = 10},
  [3008] = {.lex_state = 401, .external_lex_state = 16},
  [3009] = {.lex_state = 459, .external_lex_state = 10},
  [3010] = {.lex_state = 401, .external_lex_state = 16},
  [3011] = {.lex_state = 459, .external_lex_state = 10},
  [3012] = {.lex_state = 401, .external_lex_state = 16},
  [3013] = {.lex_state = 465, .external_lex_state = 5},
  [3014] = {.lex_state = 465, .external_lex_state = 5},
  [3015] = {.lex_state = 465, .external_lex_state = 5},
  [3016] = {.lex_state = 465, .external_lex_state = 5},
  [3017] = {.lex_state = 401, .external_lex_state = 16},
  [3018] = {.lex_state = 465, .external_lex_state = 5},
  [3019] = {.lex_state = 401, .external_lex_state = 16},
  [3020] = {.lex_state = 465, .external_lex_state = 5},
  [3021] = {.lex_state = 401, .external_lex_state = 16},
  [3022] = {.lex_state = 465, .external_lex_state = 5},
  [3023] = {.lex_state = 465, .external_lex_state = 5},
  [3024] = {.lex_state = 471, .external_lex_state = 5},
  [3025] = {.lex_state = 436, .external_lex_state = 24},
  [3026] = {.lex_state = 436, .external_lex_state = 24},
  [3027] = {.lex_state = 206, .external_lex_state = 16},
  [3028] = {.lex_state = 401, .external_lex_state = 16},
  [3029] = {.lex_state = 471, .external_lex_state = 5},
  [3030] = {.lex_state = 399, .external_lex_state = 16},
  [3031] = {.lex_state = 471, .external_lex_state = 5},
  [3032] = {.lex_state = 403},
  [3033] = {.lex_state = 401, .external_lex_state = 16},
  [3034] = {.lex_state = 471, .external_lex_state = 5},
  [3035] = {.lex_state = 403},
  [3036] = {.lex_state = 401, .external_lex_state = 16},
  [3037] = {.lex_state = 403},
  [3038] = {.lex_state = 401, .external_lex_state = 16},
  [3039] = {.lex_state = 401, .external_lex_state = 16},
  [3040] = {.lex_state = 471, .external_lex_state = 5},
  [3041] = {.lex_state = 401, .external_lex_state = 16},
  [3042] = {.lex_state = 330, .external_lex_state = 2},
  [3043] = {.lex_state = 330, .external_lex_state = 2},
  [3044] = {.lex_state = 440, .external_lex_state = 28},
  [3045] = {.lex_state = 440, .external_lex_state = 28},
  [3046] = {.lex_state = 440, .external_lex_state = 28},
  [3047] = {.lex_state = 469, .external_lex_state = 21},
  [3048] = {.lex_state = 469, .external_lex_state = 21},
  [3049] = {.lex_state = 469, .external_lex_state = 21},
  [3050] = {.lex_state = 401, .external_lex_state = 16},
  [3051] = {.lex_state = 436, .external_lex_state = 24},
  [3052] = {.lex_state = 436, .external_lex_state = 24},
  [3053] = {.lex_state = 206, .external_lex_state = 16},
  [3054] = {.lex_state = 401, .external_lex_state = 16},
  [3055] = {.lex_state = 469, .external_lex_state = 21},
  [3056] = {.lex_state = 401, .external_lex_state = 16},
  [3057] = {.lex_state = 469, .external_lex_state = 21},
  [3058] = {.lex_state = 401, .external_lex_state = 16},
  [3059] = {.lex_state = 469, .external_lex_state = 21},
  [3060] = {.lex_state = 401, .external_lex_state = 16},
  [3061] = {.lex_state = 469, .external_lex_state = 21},
  [3062] = {.lex_state = 401, .external_lex_state = 16},
  [3063] = {.lex_state = 475, .external_lex_state = 10},
  [3064] = {.lex_state = 475, .external_lex_state = 10},
  [3065] = {.lex_state = 475, .external_lex_state = 10},
  [3066] = {.lex_state = 399, .external_lex_state = 16},
  [3067] = {.lex_state = 475, .external_lex_state = 10},
  [3068] = {.lex_state = 403},
  [3069] = {.lex_state = 401, .external_lex_state = 16},
  [3070] = {.lex_state = 206},
  [3071] = {.lex_state = 303, .external_lex_state = 16},
  [3072] = {.lex_state = 303, .external_lex_state = 16},
  [3073] = {.lex_state = 303, .external_lex_state = 16},
  [3074] = {.lex_state = 475, .external_lex_state = 10},
  [3075] = {.lex_state = 403},
  [3076] = {.lex_state = 401, .external_lex_state = 16},
  [3077] = {.lex_state = 475, .external_lex_state = 10},
  [3078] = {.lex_state = 403},
  [3079] = {.lex_state = 401, .external_lex_state = 16},
  [3080] = {.lex_state = 475, .external_lex_state = 10},
  [3081] = {.lex_state = 475, .external_lex_state = 10},
  [3082] = {.lex_state = 471, .external_lex_state = 27},
  [3083] = {.lex_state = 459, .external_lex_state = 14},
  [3084] = {.lex_state = 459, .external_lex_state = 14},
  [3085] = {.lex_state = 459, .external_lex_state = 14},
  [3086] = {.lex_state = 459, .external_lex_state = 14},
  [3087] = {.lex_state = 401, .external_lex_state = 16},
  [3088] = {.lex_state = 459, .external_lex_state = 14},
  [3089] = {.lex_state = 401, .external_lex_state = 16},
  [3090] = {.lex_state = 459, .external_lex_state = 14},
  [3091] = {.lex_state = 401, .external_lex_state = 16},
  [3092] = {.lex_state = 459, .external_lex_state = 14},
  [3093] = {.lex_state = 459, .external_lex_state = 14},
  [3094] = {.lex_state = 459, .external_lex_state = 10},
  [3095] = {.lex_state = 459, .external_lex_state = 10},
  [3096] = {.lex_state = 459, .external_lex_state = 10},
  [3097] = {.lex_state = 459, .external_lex_state = 10},
  [3098] = {.lex_state = 401, .external_lex_state = 16},
  [3099] = {.lex_state = 459, .external_lex_state = 10},
  [3100] = {.lex_state = 401, .external_lex_state = 16},
  [3101] = {.lex_state = 459, .external_lex_state = 10},
  [3102] = {.lex_state = 401, .external_lex_state = 16},
  [3103] = {.lex_state = 459, .external_lex_state = 10},
  [3104] = {.lex_state = 459, .external_lex_state = 10},
  [3105] = {.lex_state = 465, .external_lex_state = 5},
  [3106] = {.lex_state = 465, .external_lex_state = 5},
  [3107] = {.lex_state = 465, .external_lex_state = 5},
  [3108] = {.lex_state = 471, .external_lex_state = 5},
  [3109] = {.lex_state = 471, .external_lex_state = 5},
  [3110] = {.lex_state = 471, .external_lex_state = 5},
  [3111] = {.lex_state = 401, .external_lex_state = 16},
  [3112] = {.lex_state = 436, .external_lex_state = 24},
  [3113] = {.lex_state = 436, .external_lex_state = 24},
  [3114] = {.lex_state = 206, .external_lex_state = 16},
  [3115] = {.lex_state = 401, .external_lex_state = 16},
  [3116] = {.lex_state = 471, .external_lex_state = 5},
  [3117] = {.lex_state = 401, .external_lex_state = 16},
  [3118] = {.lex_state = 471, .external_lex_state = 5},
  [3119] = {.lex_state = 401, .external_lex_state = 16},
  [3120] = {.lex_state = 471, .external_lex_state = 5},
  [3121] = {.lex_state = 401, .external_lex_state = 16},
  [3122] = {.lex_state = 471, .external_lex_state = 5},
  [3123] = {.lex_state = 401, .external_lex_state = 16},
  [3124] = {.lex_state = 469, .external_lex_state = 21},
  [3125] = {.lex_state = 469, .external_lex_state = 21},
  [3126] = {.lex_state = 469, .external_lex_state = 21},
  [3127] = {.lex_state = 469, .external_lex_state = 21},
  [3128] = {.lex_state = 401, .external_lex_state = 16},
  [3129] = {.lex_state = 469, .external_lex_state = 21},
  [3130] = {.lex_state = 401, .external_lex_state = 16},
  [3131] = {.lex_state = 469, .external_lex_state = 21},
  [3132] = {.lex_state = 401, .external_lex_state = 16},
  [3133] = {.lex_state = 469, .external_lex_state = 21},
  [3134] = {.lex_state = 469, .external_lex_state = 21},
  [3135] = {.lex_state = 475, .external_lex_state = 10},
  [3136] = {.lex_state = 436, .external_lex_state = 24},
  [3137] = {.lex_state = 436, .external_lex_state = 24},
  [3138] = {.lex_state = 206, .external_lex_state = 16},
  [3139] = {.lex_state = 401, .external_lex_state = 16},
  [3140] = {.lex_state = 475, .external_lex_state = 10},
  [3141] = {.lex_state = 399, .external_lex_state = 16},
  [3142] = {.lex_state = 475, .external_lex_state = 10},
  [3143] = {.lex_state = 403},
  [3144] = {.lex_state = 401, .external_lex_state = 16},
  [3145] = {.lex_state = 475, .external_lex_state = 10},
  [3146] = {.lex_state = 403},
  [3147] = {.lex_state = 401, .external_lex_state = 16},
  [3148] = {.lex_state = 403},
  [3149] = {.lex_state = 401, .external_lex_state = 16},
  [3150] = {.lex_state = 401, .external_lex_state = 16},
  [3151] = {.lex_state = 475, .external_lex_state = 10},
  [3152] = {.lex_state = 401, .external_lex_state = 16},
  [3153] = {.lex_state = 459, .external_lex_state = 14},
  [3154] = {.lex_state = 459, .external_lex_state = 14},
  [3155] = {.lex_state = 459, .external_lex_state = 14},
  [3156] = {.lex_state = 459, .external_lex_state = 10},
  [3157] = {.lex_state = 459, .external_lex_state = 10},
  [3158] = {.lex_state = 459, .external_lex_state = 10},
  [3159] = {.lex_state = 471, .external_lex_state = 5},
  [3160] = {.lex_state = 471, .external_lex_state = 5},
  [3161] = {.lex_state = 471, .external_lex_state = 5},
  [3162] = {.lex_state = 471, .external_lex_state = 5},
  [3163] = {.lex_state = 401, .external_lex_state = 16},
  [3164] = {.lex_state = 471, .external_lex_state = 5},
  [3165] = {.lex_state = 401, .external_lex_state = 16},
  [3166] = {.lex_state = 471, .external_lex_state = 5},
  [3167] = {.lex_state = 401, .external_lex_state = 16},
  [3168] = {.lex_state = 471, .external_lex_state = 5},
  [3169] = {.lex_state = 471, .external_lex_state = 5},
  [3170] = {.lex_state = 469, .external_lex_state = 21},
  [3171] = {.lex_state = 469, .external_lex_state = 21},
  [3172] = {.lex_state = 469, .external_lex_state = 21},
  [3173] = {.lex_state = 475, .external_lex_state = 10},
  [3174] = {.lex_state = 475, .external_lex_state = 10},
  [3175] = {.lex_state = 475, .external_lex_state = 10},
  [3176] = {.lex_state = 401, .external_lex_state = 16},
  [3177] = {.lex_state = 436, .external_lex_state = 24},
  [3178] = {.lex_state = 436, .external_lex_state = 24},
  [3179] = {.lex_state = 206, .external_lex_state = 16},
  [3180] = {.lex_state = 401, .external_lex_state = 16},
  [3181] = {.lex_state = 475, .external_lex_state = 10},
  [3182] = {.lex_state = 401, .external_lex_state = 16},
  [3183] = {.lex_state = 475, .external_lex_state = 10},
  [3184] = {.lex_state = 401, .external_lex_state = 16},
  [3185] = {.lex_state = 475, .external_lex_state = 10},
  [3186] = {.lex_state = 401, .external_lex_state = 16},
  [3187] = {.lex_state = 475, .external_lex_state = 10},
  [3188] = {.lex_state = 401, .external_lex_state = 16},
  [3189] = {.lex_state = 471, .external_lex_state = 5},
  [3190] = {.lex_state = 471, .external_lex_state = 5},
  [3191] = {.lex_state = 471, .external_lex_state = 5},
  [3192] = {.lex_state = 475, .external_lex_state = 10},
  [3193] = {.lex_state = 475, .external_lex_state = 10},
  [3194] = {.lex_state = 475, .external_lex_state = 10},
  [3195] = {.lex_state = 475, .external_lex_state = 10},
  [3196] = {.lex_state = 401, .external_lex_state = 16},
  [3197] = {.lex_state = 475, .external_lex_state = 10},
  [3198] = {.lex_state = 401, .external_lex_state = 16},
  [3199] = {.lex_state = 475, .external_lex_state = 10},
  [3200] = {.lex_state = 401, .external_lex_state = 16},
  [3201] = {.lex_state = 475, .external_lex_state = 10},
  [3202] = {.lex_state = 475, .external_lex_state = 10},
  [3203] = {.lex_state = 475, .external_lex_state = 10},
  [3204] = {.lex_state = 475, .external_lex_state = 10},
  [3205] = {.lex_state = 475, .external_lex_state = 10},
};

enum {
  ts_external_token_heredoc_start,
  ts_external_token__simple_heredoc_body,
  ts_external_token__heredoc_body_beginning,
  ts_external_token__heredoc_body_middle,
  ts_external_token__heredoc_body_end,
  ts_external_token_file_descriptor,
  ts_external_token__empty_value,
  ts_external_token__concat,
  ts_external_token_variable_name,
  ts_external_token_RBRACE,
  ts_external_token_RBRACK,
  ts_external_token_LF,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_heredoc_start] = sym_heredoc_start,
  [ts_external_token__simple_heredoc_body] = sym__simple_heredoc_body,
  [ts_external_token__heredoc_body_beginning] = sym__heredoc_body_beginning,
  [ts_external_token__heredoc_body_middle] = sym__heredoc_body_middle,
  [ts_external_token__heredoc_body_end] = sym__heredoc_body_end,
  [ts_external_token_file_descriptor] = sym_file_descriptor,
  [ts_external_token__empty_value] = sym__empty_value,
  [ts_external_token__concat] = sym__concat,
  [ts_external_token_variable_name] = sym_variable_name,
  [ts_external_token_RBRACE] = anon_sym_RBRACE,
  [ts_external_token_RBRACK] = anon_sym_RBRACK,
  [ts_external_token_LF] = anon_sym_LF,
};

static bool ts_external_scanner_states[29][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_heredoc_start] = true,
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token__heredoc_body_middle] = true,
    [ts_external_token__heredoc_body_end] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__empty_value] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_RBRACK] = true,
  },
  [2] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
  },
  [3] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [4] = {
    [ts_external_token_LF] = true,
  },
  [5] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [6] = {
    [ts_external_token_variable_name] = true,
  },
  [7] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LF] = true,
  },
  [8] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [9] = {
    [ts_external_token__empty_value] = true,
  },
  [10] = {
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [11] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACK] = true,
  },
  [12] = {
    [ts_external_token_RBRACK] = true,
  },
  [13] = {
    [ts_external_token__concat] = true,
  },
  [14] = {
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [15] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
  [16] = {
    [ts_external_token_RBRACE] = true,
  },
  [17] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
  },
  [18] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
  },
  [19] = {
    [ts_external_token__heredoc_body_middle] = true,
    [ts_external_token__heredoc_body_end] = true,
  },
  [20] = {
    [ts_external_token_heredoc_start] = true,
  },
  [21] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [22] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
  },
  [23] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LF] = true,
  },
  [24] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACE] = true,
  },
  [25] = {
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
  [26] = {
    [ts_external_token_file_descriptor] = true,
  },
  [27] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [28] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_heredoc_start] = ACTIONS(1),
    [sym__simple_heredoc_body] = ACTIONS(1),
    [sym__heredoc_body_beginning] = ACTIONS(1),
    [sym__heredoc_body_middle] = ACTIONS(1),
    [sym__heredoc_body_end] = ACTIONS(1),
    [sym_file_descriptor] = ACTIONS(1),
    [sym__empty_value] = ACTIONS(1),
    [sym__concat] = ACTIONS(1),
    [sym_variable_name] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3),
    [anon_sym_done] = ACTIONS(3),
    [anon_sym_if] = ACTIONS(3),
    [anon_sym_then] = ACTIONS(3),
    [anon_sym_fi] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(3),
    [anon_sym_else] = ACTIONS(3),
    [anon_sym_case] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(3),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_SEMI_SEMI] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_PIPE_AMP] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(3),
    [anon_sym_RBRACK] = ACTIONS(3),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(3),
    [anon_sym_typeset] = ACTIONS(3),
    [anon_sym_export] = ACTIONS(3),
    [anon_sym_readonly] = ACTIONS(3),
    [anon_sym_local] = ACTIONS(3),
    [anon_sym_unset] = ACTIONS(3),
    [anon_sym_unsetenv] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_AMP_GT] = ACTIONS(3),
    [anon_sym_AMP_GT_GT] = ACTIONS(1),
    [anon_sym_LT_AMP] = ACTIONS(1),
    [anon_sym_GT_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_LT_LT_DASH] = ACTIONS(1),
    [anon_sym_LT_LT_LT] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [sym__special_characters] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(3),
    [sym_raw_string] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [aux_sym_SLASH] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(3),
    [anon_sym_COLON_QMARK] = ACTIONS(1),
    [anon_sym_COLON_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_LT_LPAREN] = ACTIONS(1),
    [anon_sym_GT_LPAREN] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_0] = ACTIONS(3),
    [anon_sym__] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(3),
  },
  [1] = {
    [sym_program] = STATE(25),
    [sym__terminated_statement] = STATE(32),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(32),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(9),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2] = {
    [anon_sym_LT] = ACTIONS(57),
    [anon_sym_GT] = ACTIONS(57),
    [anon_sym_GT_GT] = ACTIONS(59),
    [anon_sym_AMP_GT] = ACTIONS(57),
    [anon_sym_AMP_GT_GT] = ACTIONS(59),
    [anon_sym_LT_AMP] = ACTIONS(59),
    [anon_sym_GT_AMP] = ACTIONS(59),
    [sym_comment] = ACTIONS(53),
  },
  [3] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(63),
    [anon_sym_PLUS_EQ] = ACTIONS(63),
    [sym_comment] = ACTIONS(53),
  },
  [4] = {
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(65),
  },
  [5] = {
    [sym__terminated_statement] = STATE(38),
    [sym_for_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_subshell] = STATE(39),
    [sym_pipeline] = STATE(39),
    [sym_list] = STATE(39),
    [sym_negated_command] = STATE(39),
    [sym_test_command] = STATE(39),
    [sym_declaration_command] = STATE(39),
    [sym_unset_command] = STATE(39),
    [sym_command] = STATE(39),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(40),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [6] = {
    [sym__terminated_statement] = STATE(41),
    [sym_for_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_subshell] = STATE(39),
    [sym_pipeline] = STATE(39),
    [sym_list] = STATE(39),
    [sym_negated_command] = STATE(39),
    [sym_test_command] = STATE(39),
    [sym_declaration_command] = STATE(39),
    [sym_unset_command] = STATE(39),
    [sym_command] = STATE(39),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(40),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [7] = {
    [sym_concatenation] = STATE(50),
    [sym_string] = STATE(45),
    [sym_simple_expansion] = STATE(45),
    [sym_string_expansion] = STATE(45),
    [sym_expansion] = STATE(45),
    [sym_command_substitution] = STATE(45),
    [sym_process_substitution] = STATE(45),
    [sym__special_characters] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [anon_sym_DOLLAR] = ACTIONS(71),
    [sym_raw_string] = ACTIONS(73),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(75),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(77),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [anon_sym_LT_LPAREN] = ACTIONS(81),
    [anon_sym_GT_LPAREN] = ACTIONS(81),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(73),
  },
  [8] = {
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(83),
  },
  [9] = {
    [sym__terminated_statement] = STATE(67),
    [sym_for_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_if_statement] = STATE(63),
    [sym_case_statement] = STATE(63),
    [sym_function_definition] = STATE(63),
    [sym_subshell] = STATE(63),
    [sym_pipeline] = STATE(63),
    [sym_list] = STATE(63),
    [sym_negated_command] = STATE(63),
    [sym_test_command] = STATE(63),
    [sym_declaration_command] = STATE(63),
    [sym_unset_command] = STATE(63),
    [sym_command] = STATE(63),
    [sym_command_name] = STATE(64),
    [sym_variable_assignment] = STATE(65),
    [sym_subscript] = STATE(66),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(61),
    [sym_simple_expansion] = STATE(61),
    [sym_string_expansion] = STATE(61),
    [sym_expansion] = STATE(61),
    [sym_command_substitution] = STATE(61),
    [sym_process_substitution] = STATE(61),
    [aux_sym_program_repeat1] = STATE(67),
    [aux_sym_command_repeat1] = STATE(68),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(93),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_typeset] = ACTIONS(97),
    [anon_sym_export] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_local] = ACTIONS(97),
    [anon_sym_unset] = ACTIONS(99),
    [anon_sym_unsetenv] = ACTIONS(99),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(105),
  },
  [10] = {
    [sym_test_command] = STATE(70),
    [sym_command] = STATE(70),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(71),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(43),
  },
  [11] = {
    [sym__expression] = STATE(82),
    [sym_binary_expression] = STATE(82),
    [sym_unary_expression] = STATE(82),
    [sym_parenthesized_expression] = STATE(82),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(77),
    [sym_simple_expansion] = STATE(77),
    [sym_string_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [sym_process_substitution] = STATE(77),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(111),
    [sym__special_characters] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
    [sym_test_operator] = ACTIONS(131),
  },
  [12] = {
    [sym__expression] = STATE(93),
    [sym_binary_expression] = STATE(93),
    [sym_unary_expression] = STATE(93),
    [sym_parenthesized_expression] = STATE(93),
    [sym_concatenation] = STATE(93),
    [sym_string] = STATE(88),
    [sym_simple_expansion] = STATE(88),
    [sym_string_expansion] = STATE(88),
    [sym_expansion] = STATE(88),
    [sym_command_substitution] = STATE(88),
    [sym_process_substitution] = STATE(88),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(155),
  },
  [13] = {
    [sym_variable_assignment] = STATE(105),
    [sym_subscript] = STATE(104),
    [sym_concatenation] = STATE(105),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym_declaration_command_repeat1] = STATE(105),
    [sym_variable_name] = ACTIONS(157),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(159),
    [anon_sym_PIPE_AMP] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(159),
    [anon_sym_PIPE_PIPE] = ACTIONS(159),
    [sym__special_characters] = ACTIONS(161),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(179),
    [sym_word] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_LF] = ACTIONS(181),
    [anon_sym_AMP] = ACTIONS(159),
  },
  [14] = {
    [sym_concatenation] = STATE(115),
    [sym_string] = STATE(109),
    [sym_simple_expansion] = STATE(109),
    [sym_string_expansion] = STATE(109),
    [sym_expansion] = STATE(109),
    [sym_command_substitution] = STATE(109),
    [sym_process_substitution] = STATE(109),
    [aux_sym_unset_command_repeat1] = STATE(115),
    [anon_sym_PIPE] = ACTIONS(183),
    [anon_sym_SEMI_SEMI] = ACTIONS(183),
    [anon_sym_PIPE_AMP] = ACTIONS(183),
    [anon_sym_AMP_AMP] = ACTIONS(183),
    [anon_sym_PIPE_PIPE] = ACTIONS(183),
    [sym__special_characters] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(191),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(193),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(195),
    [anon_sym_BQUOTE] = ACTIONS(197),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(201),
    [sym_word] = ACTIONS(191),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_LF] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(183),
  },
  [15] = {
    [sym_concatenation] = STATE(124),
    [sym_string] = STATE(119),
    [sym_simple_expansion] = STATE(119),
    [sym_string_expansion] = STATE(119),
    [sym_expansion] = STATE(119),
    [sym_command_substitution] = STATE(119),
    [sym_process_substitution] = STATE(119),
    [sym__special_characters] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(211),
  },
  [16] = {
    [aux_sym_concatenation_repeat1] = STATE(126),
    [sym__simple_heredoc_body] = ACTIONS(221),
    [sym__heredoc_body_beginning] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(225),
    [anon_sym_SEMI_SEMI] = ACTIONS(225),
    [anon_sym_PIPE_AMP] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_EQ_TILDE] = ACTIONS(225),
    [anon_sym_EQ_EQ] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(225),
    [anon_sym_GT] = ACTIONS(225),
    [anon_sym_GT_GT] = ACTIONS(225),
    [anon_sym_AMP_GT] = ACTIONS(225),
    [anon_sym_AMP_GT_GT] = ACTIONS(225),
    [anon_sym_LT_AMP] = ACTIONS(225),
    [anon_sym_GT_AMP] = ACTIONS(225),
    [anon_sym_LT_LT] = ACTIONS(225),
    [anon_sym_LT_LT_DASH] = ACTIONS(225),
    [anon_sym_LT_LT_LT] = ACTIONS(225),
    [sym__special_characters] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [sym_raw_string] = ACTIONS(225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(225),
    [anon_sym_SEMI] = ACTIONS(225),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_AMP] = ACTIONS(225),
  },
  [17] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(133),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [18] = {
    [sym_string] = STATE(135),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(239),
    [sym_raw_string] = ACTIONS(241),
    [anon_sym_POUND] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(243),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(239),
    [anon_sym_0] = ACTIONS(245),
    [anon_sym__] = ACTIONS(245),
  },
  [19] = {
    [aux_sym_concatenation_repeat1] = STATE(126),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_SEMI_SEMI] = ACTIONS(249),
    [anon_sym_PIPE_AMP] = ACTIONS(249),
    [anon_sym_AMP_AMP] = ACTIONS(249),
    [anon_sym_PIPE_PIPE] = ACTIONS(249),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(249),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(249),
    [anon_sym_LT_AMP] = ACTIONS(249),
    [anon_sym_GT_AMP] = ACTIONS(249),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(249),
    [anon_sym_LT_LT_LT] = ACTIONS(249),
    [sym__special_characters] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(249),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(249),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(249),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_LT_LPAREN] = ACTIONS(249),
    [anon_sym_GT_LPAREN] = ACTIONS(249),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_LF] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(249),
  },
  [20] = {
    [sym_subscript] = STATE(141),
    [sym_variable_name] = ACTIONS(251),
    [anon_sym_DOLLAR] = ACTIONS(253),
    [anon_sym_POUND] = ACTIONS(255),
    [anon_sym_DASH] = ACTIONS(253),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(257),
    [anon_sym_STAR] = ACTIONS(253),
    [anon_sym_AT] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(253),
    [anon_sym_0] = ACTIONS(259),
    [anon_sym__] = ACTIONS(259),
  },
  [21] = {
    [sym_for_statement] = STATE(163),
    [sym_while_statement] = STATE(163),
    [sym_if_statement] = STATE(163),
    [sym_case_statement] = STATE(163),
    [sym_function_definition] = STATE(163),
    [sym_subshell] = STATE(163),
    [sym_pipeline] = STATE(163),
    [sym_list] = STATE(163),
    [sym_negated_command] = STATE(163),
    [sym_test_command] = STATE(163),
    [sym_declaration_command] = STATE(163),
    [sym_unset_command] = STATE(163),
    [sym_command] = STATE(163),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(165),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [22] = {
    [sym_for_statement] = STATE(180),
    [sym_while_statement] = STATE(180),
    [sym_if_statement] = STATE(180),
    [sym_case_statement] = STATE(180),
    [sym_function_definition] = STATE(180),
    [sym_subshell] = STATE(180),
    [sym_pipeline] = STATE(180),
    [sym_list] = STATE(180),
    [sym_negated_command] = STATE(180),
    [sym_test_command] = STATE(180),
    [sym_declaration_command] = STATE(180),
    [sym_unset_command] = STATE(180),
    [sym_command] = STATE(180),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(182),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [23] = {
    [sym_for_statement] = STATE(185),
    [sym_while_statement] = STATE(185),
    [sym_if_statement] = STATE(185),
    [sym_case_statement] = STATE(185),
    [sym_function_definition] = STATE(185),
    [sym_subshell] = STATE(185),
    [sym_pipeline] = STATE(185),
    [sym_list] = STATE(185),
    [sym_negated_command] = STATE(185),
    [sym_test_command] = STATE(185),
    [sym_declaration_command] = STATE(185),
    [sym_unset_command] = STATE(185),
    [sym_command] = STATE(185),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(186),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [24] = {
    [aux_sym_concatenation_repeat1] = STATE(126),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_SEMI_SEMI] = ACTIONS(249),
    [anon_sym_LPAREN] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(249),
    [anon_sym_AMP_AMP] = ACTIONS(249),
    [anon_sym_PIPE_PIPE] = ACTIONS(249),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(249),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(249),
    [anon_sym_LT_AMP] = ACTIONS(249),
    [anon_sym_GT_AMP] = ACTIONS(249),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(249),
    [anon_sym_LT_LT_LT] = ACTIONS(249),
    [sym__special_characters] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(249),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(249),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(249),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_LT_LPAREN] = ACTIONS(249),
    [anon_sym_GT_LPAREN] = ACTIONS(249),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_LF] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(249),
  },
  [25] = {
    [ts_builtin_sym_end] = ACTIONS(327),
    [sym_comment] = ACTIONS(53),
  },
  [26] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(331),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [27] = {
    [sym_file_redirect] = STATE(201),
    [sym_heredoc_redirect] = STATE(201),
    [sym_heredoc_body] = STATE(200),
    [sym_herestring_redirect] = STATE(201),
    [sym_concatenation] = STATE(202),
    [sym_string] = STATE(199),
    [sym_simple_expansion] = STATE(199),
    [sym_string_expansion] = STATE(199),
    [sym_expansion] = STATE(199),
    [sym_command_substitution] = STATE(199),
    [sym_process_substitution] = STATE(199),
    [aux_sym_while_statement_repeat1] = STATE(201),
    [aux_sym_command_repeat2] = STATE(202),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_SEMI_SEMI] = ACTIONS(343),
    [anon_sym_PIPE_AMP] = ACTIONS(343),
    [anon_sym_AMP_AMP] = ACTIONS(343),
    [anon_sym_PIPE_PIPE] = ACTIONS(343),
    [anon_sym_EQ_TILDE] = ACTIONS(345),
    [anon_sym_EQ_EQ] = ACTIONS(345),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(347),
    [anon_sym_AMP_GT] = ACTIONS(347),
    [anon_sym_AMP_GT_GT] = ACTIONS(347),
    [anon_sym_LT_AMP] = ACTIONS(347),
    [anon_sym_GT_AMP] = ACTIONS(347),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(351),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(357),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(357),
    [anon_sym_SEMI] = ACTIONS(343),
    [anon_sym_LF] = ACTIONS(367),
    [anon_sym_AMP] = ACTIONS(343),
  },
  [28] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(331),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [29] = {
    [anon_sym_EQ] = ACTIONS(63),
    [anon_sym_PLUS_EQ] = ACTIONS(63),
    [sym_comment] = ACTIONS(53),
  },
  [30] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [31] = {
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_RPAREN] = ACTIONS(249),
    [anon_sym_SEMI_SEMI] = ACTIONS(249),
    [anon_sym_PIPE_AMP] = ACTIONS(249),
    [anon_sym_AMP_AMP] = ACTIONS(249),
    [anon_sym_PIPE_PIPE] = ACTIONS(249),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(249),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(249),
    [anon_sym_LT_AMP] = ACTIONS(249),
    [anon_sym_GT_AMP] = ACTIONS(249),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(249),
    [anon_sym_LT_LT_LT] = ACTIONS(249),
    [sym__special_characters] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(249),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(249),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(249),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_LT_LPAREN] = ACTIONS(249),
    [anon_sym_GT_LPAREN] = ACTIONS(249),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_LF] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(249),
  },
  [32] = {
    [sym__terminated_statement] = STATE(203),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(203),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [33] = {
    [sym_command_name] = STATE(204),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(71),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(205),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(107),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(375),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(43),
  },
  [34] = {
    [sym_concatenation] = STATE(208),
    [sym_string] = STATE(207),
    [sym_simple_expansion] = STATE(207),
    [sym_string_expansion] = STATE(207),
    [sym_expansion] = STATE(207),
    [sym_command_substitution] = STATE(207),
    [sym_process_substitution] = STATE(207),
    [sym__special_characters] = ACTIONS(377),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(379),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(379),
  },
  [35] = {
    [sym_concatenation] = STATE(211),
    [sym_string] = STATE(210),
    [sym_simple_expansion] = STATE(210),
    [sym_string_expansion] = STATE(210),
    [sym_expansion] = STATE(210),
    [sym_command_substitution] = STATE(210),
    [sym_process_substitution] = STATE(210),
    [sym__special_characters] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(383),
  },
  [36] = {
    [sym_concatenation] = STATE(212),
    [sym_string] = STATE(217),
    [sym_array] = STATE(212),
    [sym_simple_expansion] = STATE(217),
    [sym_string_expansion] = STATE(217),
    [sym_expansion] = STATE(217),
    [sym_command_substitution] = STATE(217),
    [sym_process_substitution] = STATE(217),
    [sym__empty_value] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(387),
    [sym__special_characters] = ACTIONS(389),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [sym_raw_string] = ACTIONS(395),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(397),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(399),
    [anon_sym_BQUOTE] = ACTIONS(401),
    [anon_sym_LT_LPAREN] = ACTIONS(403),
    [anon_sym_GT_LPAREN] = ACTIONS(403),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(395),
  },
  [37] = {
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_SEMI_SEMI] = ACTIONS(407),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(407),
    [anon_sym_LF] = ACTIONS(409),
    [anon_sym_AMP] = ACTIONS(407),
  },
  [38] = {
    [sym_do_group] = STATE(225),
    [anon_sym_do] = ACTIONS(411),
    [sym_comment] = ACTIONS(53),
  },
  [39] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(413),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(413),
    [anon_sym_LF] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(413),
  },
  [40] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(413),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(413),
    [anon_sym_LF] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(413),
  },
  [41] = {
    [anon_sym_then] = ACTIONS(417),
    [sym_comment] = ACTIONS(53),
  },
  [42] = {
    [aux_sym_concatenation_repeat1] = STATE(231),
    [sym__concat] = ACTIONS(419),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_SEMI_SEMI] = ACTIONS(423),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_LF] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [43] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(233),
    [anon_sym_DQUOTE] = ACTIONS(427),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [44] = {
    [sym_string] = STATE(235),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [anon_sym_DOLLAR] = ACTIONS(429),
    [sym_raw_string] = ACTIONS(431),
    [anon_sym_POUND] = ACTIONS(429),
    [anon_sym_DASH] = ACTIONS(429),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(433),
    [anon_sym_STAR] = ACTIONS(429),
    [anon_sym_AT] = ACTIONS(429),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_0] = ACTIONS(435),
    [anon_sym__] = ACTIONS(435),
  },
  [45] = {
    [aux_sym_concatenation_repeat1] = STATE(231),
    [sym__concat] = ACTIONS(419),
    [anon_sym_in] = ACTIONS(437),
    [anon_sym_SEMI_SEMI] = ACTIONS(439),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_LF] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(439),
  },
  [46] = {
    [sym_subscript] = STATE(243),
    [sym_variable_name] = ACTIONS(443),
    [anon_sym_DOLLAR] = ACTIONS(445),
    [anon_sym_POUND] = ACTIONS(447),
    [anon_sym_DASH] = ACTIONS(445),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_AT] = ACTIONS(445),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_0] = ACTIONS(451),
    [anon_sym__] = ACTIONS(451),
  },
  [47] = {
    [sym_for_statement] = STATE(244),
    [sym_while_statement] = STATE(244),
    [sym_if_statement] = STATE(244),
    [sym_case_statement] = STATE(244),
    [sym_function_definition] = STATE(244),
    [sym_subshell] = STATE(244),
    [sym_pipeline] = STATE(244),
    [sym_list] = STATE(244),
    [sym_negated_command] = STATE(244),
    [sym_test_command] = STATE(244),
    [sym_declaration_command] = STATE(244),
    [sym_unset_command] = STATE(244),
    [sym_command] = STATE(244),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(245),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [48] = {
    [sym_for_statement] = STATE(246),
    [sym_while_statement] = STATE(246),
    [sym_if_statement] = STATE(246),
    [sym_case_statement] = STATE(246),
    [sym_function_definition] = STATE(246),
    [sym_subshell] = STATE(246),
    [sym_pipeline] = STATE(246),
    [sym_list] = STATE(246),
    [sym_negated_command] = STATE(246),
    [sym_test_command] = STATE(246),
    [sym_declaration_command] = STATE(246),
    [sym_unset_command] = STATE(246),
    [sym_command] = STATE(246),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(247),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [49] = {
    [sym_for_statement] = STATE(248),
    [sym_while_statement] = STATE(248),
    [sym_if_statement] = STATE(248),
    [sym_case_statement] = STATE(248),
    [sym_function_definition] = STATE(248),
    [sym_subshell] = STATE(248),
    [sym_pipeline] = STATE(248),
    [sym_list] = STATE(248),
    [sym_negated_command] = STATE(248),
    [sym_test_command] = STATE(248),
    [sym_declaration_command] = STATE(248),
    [sym_unset_command] = STATE(248),
    [sym_command] = STATE(248),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(249),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [50] = {
    [anon_sym_in] = ACTIONS(437),
    [anon_sym_SEMI_SEMI] = ACTIONS(439),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_LF] = ACTIONS(441),
    [anon_sym_AMP] = ACTIONS(439),
  },
  [51] = {
    [sym_compound_statement] = STATE(252),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(455),
    [sym_comment] = ACTIONS(53),
  },
  [52] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(457),
    [anon_sym_PLUS_EQ] = ACTIONS(457),
    [sym_comment] = ACTIONS(53),
  },
  [53] = {
    [sym__terminated_statement] = STATE(254),
    [sym_for_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_subshell] = STATE(39),
    [sym_pipeline] = STATE(39),
    [sym_list] = STATE(39),
    [sym_negated_command] = STATE(39),
    [sym_test_command] = STATE(39),
    [sym_declaration_command] = STATE(39),
    [sym_unset_command] = STATE(39),
    [sym_command] = STATE(39),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(40),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [54] = {
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(459),
  },
  [55] = {
    [sym_test_command] = STATE(70),
    [sym_command] = STATE(70),
    [sym_command_name] = STATE(64),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(71),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(61),
    [sym_simple_expansion] = STATE(61),
    [sym_string_expansion] = STATE(61),
    [sym_expansion] = STATE(61),
    [sym_command_substitution] = STATE(61),
    [sym_process_substitution] = STATE(61),
    [aux_sym_command_repeat1] = STATE(68),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(93),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(103),
  },
  [56] = {
    [sym__expression] = STATE(256),
    [sym_binary_expression] = STATE(256),
    [sym_unary_expression] = STATE(256),
    [sym_parenthesized_expression] = STATE(256),
    [sym_concatenation] = STATE(256),
    [sym_string] = STATE(77),
    [sym_simple_expansion] = STATE(77),
    [sym_string_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [sym_process_substitution] = STATE(77),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(111),
    [sym__special_characters] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
    [sym_test_operator] = ACTIONS(131),
  },
  [57] = {
    [sym__expression] = STATE(257),
    [sym_binary_expression] = STATE(257),
    [sym_unary_expression] = STATE(257),
    [sym_parenthesized_expression] = STATE(257),
    [sym_concatenation] = STATE(257),
    [sym_string] = STATE(88),
    [sym_simple_expansion] = STATE(88),
    [sym_string_expansion] = STATE(88),
    [sym_expansion] = STATE(88),
    [sym_command_substitution] = STATE(88),
    [sym_process_substitution] = STATE(88),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(155),
  },
  [58] = {
    [sym_variable_assignment] = STATE(262),
    [sym_subscript] = STATE(261),
    [sym_concatenation] = STATE(262),
    [sym_string] = STATE(260),
    [sym_simple_expansion] = STATE(260),
    [sym_string_expansion] = STATE(260),
    [sym_expansion] = STATE(260),
    [sym_command_substitution] = STATE(260),
    [sym_process_substitution] = STATE(260),
    [aux_sym_declaration_command_repeat1] = STATE(262),
    [sym_variable_name] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_RPAREN] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(159),
    [anon_sym_PIPE_AMP] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(159),
    [anon_sym_PIPE_PIPE] = ACTIONS(159),
    [sym__special_characters] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(179),
    [sym_word] = ACTIONS(465),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_LF] = ACTIONS(181),
    [anon_sym_AMP] = ACTIONS(159),
  },
  [59] = {
    [sym_concatenation] = STATE(265),
    [sym_string] = STATE(264),
    [sym_simple_expansion] = STATE(264),
    [sym_string_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [sym_command_substitution] = STATE(264),
    [sym_process_substitution] = STATE(264),
    [aux_sym_unset_command_repeat1] = STATE(265),
    [anon_sym_PIPE] = ACTIONS(183),
    [anon_sym_RPAREN] = ACTIONS(183),
    [anon_sym_SEMI_SEMI] = ACTIONS(183),
    [anon_sym_PIPE_AMP] = ACTIONS(183),
    [anon_sym_AMP_AMP] = ACTIONS(183),
    [anon_sym_PIPE_PIPE] = ACTIONS(183),
    [sym__special_characters] = ACTIONS(467),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(193),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(195),
    [anon_sym_BQUOTE] = ACTIONS(197),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(201),
    [sym_word] = ACTIONS(469),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_LF] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(183),
  },
  [60] = {
    [aux_sym_concatenation_repeat1] = STATE(266),
    [sym__simple_heredoc_body] = ACTIONS(221),
    [sym__heredoc_body_beginning] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(225),
    [anon_sym_RPAREN] = ACTIONS(225),
    [anon_sym_SEMI_SEMI] = ACTIONS(225),
    [anon_sym_PIPE_AMP] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_EQ_TILDE] = ACTIONS(225),
    [anon_sym_EQ_EQ] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(225),
    [anon_sym_GT] = ACTIONS(225),
    [anon_sym_GT_GT] = ACTIONS(225),
    [anon_sym_AMP_GT] = ACTIONS(225),
    [anon_sym_AMP_GT_GT] = ACTIONS(225),
    [anon_sym_LT_AMP] = ACTIONS(225),
    [anon_sym_GT_AMP] = ACTIONS(225),
    [anon_sym_LT_LT] = ACTIONS(225),
    [anon_sym_LT_LT_DASH] = ACTIONS(225),
    [anon_sym_LT_LT_LT] = ACTIONS(225),
    [sym__special_characters] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [sym_raw_string] = ACTIONS(225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(225),
    [anon_sym_SEMI] = ACTIONS(225),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_AMP] = ACTIONS(225),
  },
  [61] = {
    [aux_sym_concatenation_repeat1] = STATE(266),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_RPAREN] = ACTIONS(249),
    [anon_sym_SEMI_SEMI] = ACTIONS(249),
    [anon_sym_PIPE_AMP] = ACTIONS(249),
    [anon_sym_AMP_AMP] = ACTIONS(249),
    [anon_sym_PIPE_PIPE] = ACTIONS(249),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(249),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(249),
    [anon_sym_LT_AMP] = ACTIONS(249),
    [anon_sym_GT_AMP] = ACTIONS(249),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(249),
    [anon_sym_LT_LT_LT] = ACTIONS(249),
    [sym__special_characters] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(249),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(249),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(249),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_LT_LPAREN] = ACTIONS(249),
    [anon_sym_GT_LPAREN] = ACTIONS(249),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_LF] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(249),
  },
  [62] = {
    [aux_sym_concatenation_repeat1] = STATE(266),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_RPAREN] = ACTIONS(249),
    [anon_sym_SEMI_SEMI] = ACTIONS(249),
    [anon_sym_LPAREN] = ACTIONS(471),
    [anon_sym_PIPE_AMP] = ACTIONS(249),
    [anon_sym_AMP_AMP] = ACTIONS(249),
    [anon_sym_PIPE_PIPE] = ACTIONS(249),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(249),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(249),
    [anon_sym_LT_AMP] = ACTIONS(249),
    [anon_sym_GT_AMP] = ACTIONS(249),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(249),
    [anon_sym_LT_LT_LT] = ACTIONS(249),
    [sym__special_characters] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(249),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(249),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(249),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_LT_LPAREN] = ACTIONS(249),
    [anon_sym_GT_LPAREN] = ACTIONS(249),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_LF] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(249),
  },
  [63] = {
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(475),
    [anon_sym_SEMI_SEMI] = ACTIONS(477),
    [anon_sym_PIPE_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(477),
    [anon_sym_LF] = ACTIONS(481),
    [anon_sym_AMP] = ACTIONS(477),
  },
  [64] = {
    [sym_file_redirect] = STATE(278),
    [sym_heredoc_redirect] = STATE(278),
    [sym_heredoc_body] = STATE(200),
    [sym_herestring_redirect] = STATE(278),
    [sym_concatenation] = STATE(279),
    [sym_string] = STATE(277),
    [sym_simple_expansion] = STATE(277),
    [sym_string_expansion] = STATE(277),
    [sym_expansion] = STATE(277),
    [sym_command_substitution] = STATE(277),
    [sym_process_substitution] = STATE(277),
    [aux_sym_while_statement_repeat1] = STATE(278),
    [aux_sym_command_repeat2] = STATE(279),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(343),
    [anon_sym_SEMI_SEMI] = ACTIONS(343),
    [anon_sym_PIPE_AMP] = ACTIONS(343),
    [anon_sym_AMP_AMP] = ACTIONS(343),
    [anon_sym_PIPE_PIPE] = ACTIONS(343),
    [anon_sym_EQ_TILDE] = ACTIONS(485),
    [anon_sym_EQ_EQ] = ACTIONS(485),
    [anon_sym_LT] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(487),
    [anon_sym_GT_GT] = ACTIONS(487),
    [anon_sym_AMP_GT] = ACTIONS(487),
    [anon_sym_AMP_GT_GT] = ACTIONS(487),
    [anon_sym_LT_AMP] = ACTIONS(487),
    [anon_sym_GT_AMP] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(489),
    [sym__special_characters] = ACTIONS(491),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(493),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(343),
    [anon_sym_LF] = ACTIONS(367),
    [anon_sym_AMP] = ACTIONS(343),
  },
  [65] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(475),
    [anon_sym_SEMI_SEMI] = ACTIONS(477),
    [anon_sym_PIPE_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(477),
    [anon_sym_LF] = ACTIONS(481),
    [anon_sym_AMP] = ACTIONS(477),
  },
  [66] = {
    [anon_sym_EQ] = ACTIONS(457),
    [anon_sym_PLUS_EQ] = ACTIONS(457),
    [sym_comment] = ACTIONS(53),
  },
  [67] = {
    [sym__terminated_statement] = STATE(282),
    [sym_for_statement] = STATE(280),
    [sym_while_statement] = STATE(280),
    [sym_if_statement] = STATE(280),
    [sym_case_statement] = STATE(280),
    [sym_function_definition] = STATE(280),
    [sym_subshell] = STATE(280),
    [sym_pipeline] = STATE(280),
    [sym_list] = STATE(280),
    [sym_negated_command] = STATE(280),
    [sym_test_command] = STATE(280),
    [sym_declaration_command] = STATE(280),
    [sym_unset_command] = STATE(280),
    [sym_command] = STATE(280),
    [sym_command_name] = STATE(64),
    [sym_variable_assignment] = STATE(281),
    [sym_subscript] = STATE(66),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(61),
    [sym_simple_expansion] = STATE(61),
    [sym_string_expansion] = STATE(61),
    [sym_expansion] = STATE(61),
    [sym_command_substitution] = STATE(61),
    [sym_process_substitution] = STATE(61),
    [aux_sym_program_repeat1] = STATE(282),
    [aux_sym_command_repeat1] = STATE(68),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(93),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_typeset] = ACTIONS(97),
    [anon_sym_export] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_local] = ACTIONS(97),
    [anon_sym_unset] = ACTIONS(99),
    [anon_sym_unsetenv] = ACTIONS(99),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(105),
  },
  [68] = {
    [sym_command_name] = STATE(283),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(71),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(61),
    [sym_simple_expansion] = STATE(61),
    [sym_string_expansion] = STATE(61),
    [sym_expansion] = STATE(61),
    [sym_command_substitution] = STATE(61),
    [sym_process_substitution] = STATE(61),
    [aux_sym_command_repeat1] = STATE(205),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(107),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(495),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(103),
  },
  [69] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_PLUS_EQ] = ACTIONS(497),
    [sym_comment] = ACTIONS(53),
  },
  [70] = {
    [anon_sym_esac] = ACTIONS(499),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_RPAREN] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(499),
    [anon_sym_PIPE_AMP] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(499),
    [anon_sym_LF] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(499),
  },
  [71] = {
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_PLUS_EQ] = ACTIONS(497),
    [sym_comment] = ACTIONS(53),
  },
  [72] = {
    [sym__expression] = STATE(288),
    [sym_binary_expression] = STATE(288),
    [sym_unary_expression] = STATE(288),
    [sym_parenthesized_expression] = STATE(288),
    [sym_concatenation] = STATE(288),
    [sym_string] = STATE(287),
    [sym_simple_expansion] = STATE(287),
    [sym_string_expansion] = STATE(287),
    [sym_expansion] = STATE(287),
    [sym_command_substitution] = STATE(287),
    [sym_process_substitution] = STATE(287),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(503),
    [sym__special_characters] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(507),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(509),
    [sym_test_operator] = ACTIONS(511),
  },
  [73] = {
    [sym__expression] = STATE(289),
    [sym_binary_expression] = STATE(289),
    [sym_unary_expression] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_concatenation] = STATE(289),
    [sym_string] = STATE(77),
    [sym_simple_expansion] = STATE(77),
    [sym_string_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [sym_process_substitution] = STATE(77),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(111),
    [sym__special_characters] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
    [sym_test_operator] = ACTIONS(131),
  },
  [74] = {
    [aux_sym_concatenation_repeat1] = STATE(291),
    [sym__concat] = ACTIONS(513),
    [anon_sym_AMP_AMP] = ACTIONS(515),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_RBRACK] = ACTIONS(515),
    [anon_sym_EQ_TILDE] = ACTIONS(515),
    [anon_sym_EQ_EQ] = ACTIONS(515),
    [anon_sym_EQ] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(515),
    [anon_sym_GT] = ACTIONS(515),
    [anon_sym_BANG_EQ] = ACTIONS(515),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(515),
  },
  [75] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(293),
    [anon_sym_DQUOTE] = ACTIONS(519),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [76] = {
    [sym_string] = STATE(295),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(521),
    [sym_raw_string] = ACTIONS(523),
    [anon_sym_POUND] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(525),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_AT] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(521),
    [anon_sym_0] = ACTIONS(527),
    [anon_sym__] = ACTIONS(527),
  },
  [77] = {
    [aux_sym_concatenation_repeat1] = STATE(291),
    [sym__concat] = ACTIONS(513),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_RBRACK] = ACTIONS(529),
    [anon_sym_EQ_TILDE] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(529),
    [anon_sym_EQ] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(529),
    [anon_sym_GT] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(529),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(529),
  },
  [78] = {
    [sym_subscript] = STATE(301),
    [sym_variable_name] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(535),
    [anon_sym_POUND] = ACTIONS(537),
    [anon_sym_DASH] = ACTIONS(535),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(539),
    [anon_sym_STAR] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(535),
    [anon_sym_QMARK] = ACTIONS(535),
    [anon_sym_0] = ACTIONS(541),
    [anon_sym__] = ACTIONS(541),
  },
  [79] = {
    [sym_for_statement] = STATE(302),
    [sym_while_statement] = STATE(302),
    [sym_if_statement] = STATE(302),
    [sym_case_statement] = STATE(302),
    [sym_function_definition] = STATE(302),
    [sym_subshell] = STATE(302),
    [sym_pipeline] = STATE(302),
    [sym_list] = STATE(302),
    [sym_negated_command] = STATE(302),
    [sym_test_command] = STATE(302),
    [sym_declaration_command] = STATE(302),
    [sym_unset_command] = STATE(302),
    [sym_command] = STATE(302),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(303),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [80] = {
    [sym_for_statement] = STATE(304),
    [sym_while_statement] = STATE(304),
    [sym_if_statement] = STATE(304),
    [sym_case_statement] = STATE(304),
    [sym_function_definition] = STATE(304),
    [sym_subshell] = STATE(304),
    [sym_pipeline] = STATE(304),
    [sym_list] = STATE(304),
    [sym_negated_command] = STATE(304),
    [sym_test_command] = STATE(304),
    [sym_declaration_command] = STATE(304),
    [sym_unset_command] = STATE(304),
    [sym_command] = STATE(304),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(305),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [81] = {
    [sym_for_statement] = STATE(306),
    [sym_while_statement] = STATE(306),
    [sym_if_statement] = STATE(306),
    [sym_case_statement] = STATE(306),
    [sym_function_definition] = STATE(306),
    [sym_subshell] = STATE(306),
    [sym_pipeline] = STATE(306),
    [sym_list] = STATE(306),
    [sym_negated_command] = STATE(306),
    [sym_test_command] = STATE(306),
    [sym_declaration_command] = STATE(306),
    [sym_unset_command] = STATE(306),
    [sym_command] = STATE(306),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(307),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [82] = {
    [anon_sym_AMP_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(543),
    [anon_sym_RBRACK] = ACTIONS(545),
    [anon_sym_EQ_TILDE] = ACTIONS(547),
    [anon_sym_EQ_EQ] = ACTIONS(547),
    [anon_sym_EQ] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_BANG_EQ] = ACTIONS(543),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(543),
  },
  [83] = {
    [sym__expression] = STATE(311),
    [sym_binary_expression] = STATE(311),
    [sym_unary_expression] = STATE(311),
    [sym_parenthesized_expression] = STATE(311),
    [sym_concatenation] = STATE(311),
    [sym_string] = STATE(287),
    [sym_simple_expansion] = STATE(287),
    [sym_string_expansion] = STATE(287),
    [sym_expansion] = STATE(287),
    [sym_command_substitution] = STATE(287),
    [sym_process_substitution] = STATE(287),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(503),
    [sym__special_characters] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(507),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(509),
    [sym_test_operator] = ACTIONS(511),
  },
  [84] = {
    [sym__expression] = STATE(312),
    [sym_binary_expression] = STATE(312),
    [sym_unary_expression] = STATE(312),
    [sym_parenthesized_expression] = STATE(312),
    [sym_concatenation] = STATE(312),
    [sym_string] = STATE(88),
    [sym_simple_expansion] = STATE(88),
    [sym_string_expansion] = STATE(88),
    [sym_expansion] = STATE(88),
    [sym_command_substitution] = STATE(88),
    [sym_process_substitution] = STATE(88),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(155),
  },
  [85] = {
    [aux_sym_concatenation_repeat1] = STATE(314),
    [sym__concat] = ACTIONS(551),
    [anon_sym_AMP_AMP] = ACTIONS(515),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(515),
    [anon_sym_EQ_TILDE] = ACTIONS(515),
    [anon_sym_EQ_EQ] = ACTIONS(515),
    [anon_sym_EQ] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(515),
    [anon_sym_GT] = ACTIONS(515),
    [anon_sym_BANG_EQ] = ACTIONS(515),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(515),
  },
  [86] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(316),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [87] = {
    [sym_string] = STATE(318),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(557),
    [anon_sym_POUND] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(555),
    [anon_sym_AT] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_0] = ACTIONS(561),
    [anon_sym__] = ACTIONS(561),
  },
  [88] = {
    [aux_sym_concatenation_repeat1] = STATE(314),
    [sym__concat] = ACTIONS(551),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(529),
    [anon_sym_EQ_TILDE] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(529),
    [anon_sym_EQ] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(529),
    [anon_sym_GT] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(529),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(529),
  },
  [89] = {
    [sym_subscript] = STATE(324),
    [sym_variable_name] = ACTIONS(563),
    [anon_sym_DOLLAR] = ACTIONS(565),
    [anon_sym_POUND] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(565),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(565),
    [anon_sym_AT] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(565),
    [anon_sym_0] = ACTIONS(571),
    [anon_sym__] = ACTIONS(571),
  },
  [90] = {
    [sym_for_statement] = STATE(325),
    [sym_while_statement] = STATE(325),
    [sym_if_statement] = STATE(325),
    [sym_case_statement] = STATE(325),
    [sym_function_definition] = STATE(325),
    [sym_subshell] = STATE(325),
    [sym_pipeline] = STATE(325),
    [sym_list] = STATE(325),
    [sym_negated_command] = STATE(325),
    [sym_test_command] = STATE(325),
    [sym_declaration_command] = STATE(325),
    [sym_unset_command] = STATE(325),
    [sym_command] = STATE(325),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(326),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [91] = {
    [sym_for_statement] = STATE(327),
    [sym_while_statement] = STATE(327),
    [sym_if_statement] = STATE(327),
    [sym_case_statement] = STATE(327),
    [sym_function_definition] = STATE(327),
    [sym_subshell] = STATE(327),
    [sym_pipeline] = STATE(327),
    [sym_list] = STATE(327),
    [sym_negated_command] = STATE(327),
    [sym_test_command] = STATE(327),
    [sym_declaration_command] = STATE(327),
    [sym_unset_command] = STATE(327),
    [sym_command] = STATE(327),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(328),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [92] = {
    [sym_for_statement] = STATE(329),
    [sym_while_statement] = STATE(329),
    [sym_if_statement] = STATE(329),
    [sym_case_statement] = STATE(329),
    [sym_function_definition] = STATE(329),
    [sym_subshell] = STATE(329),
    [sym_pipeline] = STATE(329),
    [sym_list] = STATE(329),
    [sym_negated_command] = STATE(329),
    [sym_test_command] = STATE(329),
    [sym_declaration_command] = STATE(329),
    [sym_unset_command] = STATE(329),
    [sym_command] = STATE(329),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(330),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [93] = {
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(545),
    [anon_sym_EQ_TILDE] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(577),
    [anon_sym_LT] = ACTIONS(573),
    [anon_sym_GT] = ACTIONS(573),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(573),
  },
  [94] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(579),
    [anon_sym_PLUS_EQ] = ACTIONS(579),
    [sym_comment] = ACTIONS(53),
  },
  [95] = {
    [aux_sym_concatenation_repeat1] = STATE(335),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(585),
    [anon_sym_SEMI_SEMI] = ACTIONS(585),
    [anon_sym_PIPE_AMP] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(585),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [sym__special_characters] = ACTIONS(585),
    [anon_sym_DQUOTE] = ACTIONS(585),
    [anon_sym_DOLLAR] = ACTIONS(585),
    [sym_raw_string] = ACTIONS(585),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(585),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_LT_LPAREN] = ACTIONS(585),
    [anon_sym_GT_LPAREN] = ACTIONS(585),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(585),
    [sym_word] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(585),
    [anon_sym_LF] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(585),
  },
  [96] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(337),
    [anon_sym_DQUOTE] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [97] = {
    [sym_string] = STATE(339),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [anon_sym_DOLLAR] = ACTIONS(591),
    [sym_raw_string] = ACTIONS(593),
    [anon_sym_POUND] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(591),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(595),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_AT] = ACTIONS(591),
    [anon_sym_QMARK] = ACTIONS(591),
    [anon_sym_0] = ACTIONS(597),
    [anon_sym__] = ACTIONS(597),
  },
  [98] = {
    [aux_sym_concatenation_repeat1] = STATE(335),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(599),
    [anon_sym_PIPE] = ACTIONS(601),
    [anon_sym_SEMI_SEMI] = ACTIONS(601),
    [anon_sym_PIPE_AMP] = ACTIONS(601),
    [anon_sym_AMP_AMP] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [anon_sym_DOLLAR] = ACTIONS(601),
    [sym_raw_string] = ACTIONS(601),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(601),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(601),
    [anon_sym_BQUOTE] = ACTIONS(601),
    [anon_sym_LT_LPAREN] = ACTIONS(601),
    [anon_sym_GT_LPAREN] = ACTIONS(601),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(601),
    [sym_word] = ACTIONS(601),
    [anon_sym_SEMI] = ACTIONS(601),
    [anon_sym_LF] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(601),
  },
  [99] = {
    [sym_subscript] = STATE(345),
    [sym_variable_name] = ACTIONS(603),
    [anon_sym_DOLLAR] = ACTIONS(605),
    [anon_sym_POUND] = ACTIONS(607),
    [anon_sym_DASH] = ACTIONS(605),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(609),
    [anon_sym_STAR] = ACTIONS(605),
    [anon_sym_AT] = ACTIONS(605),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_0] = ACTIONS(611),
    [anon_sym__] = ACTIONS(611),
  },
  [100] = {
    [sym_for_statement] = STATE(346),
    [sym_while_statement] = STATE(346),
    [sym_if_statement] = STATE(346),
    [sym_case_statement] = STATE(346),
    [sym_function_definition] = STATE(346),
    [sym_subshell] = STATE(346),
    [sym_pipeline] = STATE(346),
    [sym_list] = STATE(346),
    [sym_negated_command] = STATE(346),
    [sym_test_command] = STATE(346),
    [sym_declaration_command] = STATE(346),
    [sym_unset_command] = STATE(346),
    [sym_command] = STATE(346),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(347),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [101] = {
    [sym_for_statement] = STATE(348),
    [sym_while_statement] = STATE(348),
    [sym_if_statement] = STATE(348),
    [sym_case_statement] = STATE(348),
    [sym_function_definition] = STATE(348),
    [sym_subshell] = STATE(348),
    [sym_pipeline] = STATE(348),
    [sym_list] = STATE(348),
    [sym_negated_command] = STATE(348),
    [sym_test_command] = STATE(348),
    [sym_declaration_command] = STATE(348),
    [sym_unset_command] = STATE(348),
    [sym_command] = STATE(348),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(349),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [102] = {
    [sym_for_statement] = STATE(350),
    [sym_while_statement] = STATE(350),
    [sym_if_statement] = STATE(350),
    [sym_case_statement] = STATE(350),
    [sym_function_definition] = STATE(350),
    [sym_subshell] = STATE(350),
    [sym_pipeline] = STATE(350),
    [sym_list] = STATE(350),
    [sym_negated_command] = STATE(350),
    [sym_test_command] = STATE(350),
    [sym_declaration_command] = STATE(350),
    [sym_unset_command] = STATE(350),
    [sym_command] = STATE(350),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(351),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [103] = {
    [sym_variable_name] = ACTIONS(613),
    [anon_sym_PIPE] = ACTIONS(615),
    [anon_sym_RPAREN] = ACTIONS(615),
    [anon_sym_SEMI_SEMI] = ACTIONS(615),
    [anon_sym_PIPE_AMP] = ACTIONS(615),
    [anon_sym_AMP_AMP] = ACTIONS(615),
    [anon_sym_PIPE_PIPE] = ACTIONS(615),
    [sym__special_characters] = ACTIONS(615),
    [anon_sym_DQUOTE] = ACTIONS(615),
    [anon_sym_DOLLAR] = ACTIONS(615),
    [sym_raw_string] = ACTIONS(615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(615),
    [anon_sym_BQUOTE] = ACTIONS(615),
    [anon_sym_LT_LPAREN] = ACTIONS(615),
    [anon_sym_GT_LPAREN] = ACTIONS(615),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(615),
    [sym_word] = ACTIONS(615),
    [anon_sym_SEMI] = ACTIONS(615),
    [anon_sym_LF] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(615),
  },
  [104] = {
    [anon_sym_EQ] = ACTIONS(579),
    [anon_sym_PLUS_EQ] = ACTIONS(579),
    [sym_comment] = ACTIONS(53),
  },
  [105] = {
    [sym_variable_assignment] = STATE(352),
    [sym_subscript] = STATE(104),
    [sym_concatenation] = STATE(352),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym_declaration_command_repeat1] = STATE(352),
    [sym_variable_name] = ACTIONS(157),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_SEMI_SEMI] = ACTIONS(617),
    [anon_sym_PIPE_AMP] = ACTIONS(617),
    [anon_sym_AMP_AMP] = ACTIONS(617),
    [anon_sym_PIPE_PIPE] = ACTIONS(617),
    [sym__special_characters] = ACTIONS(161),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(179),
    [sym_word] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_LF] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(617),
  },
  [106] = {
    [aux_sym_concatenation_repeat1] = STATE(354),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(623),
    [anon_sym_SEMI_SEMI] = ACTIONS(623),
    [anon_sym_PIPE_AMP] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(623),
    [sym__special_characters] = ACTIONS(623),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [sym_raw_string] = ACTIONS(623),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(623),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(623),
    [anon_sym_BQUOTE] = ACTIONS(623),
    [anon_sym_LT_LPAREN] = ACTIONS(623),
    [anon_sym_GT_LPAREN] = ACTIONS(623),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(623),
    [sym_word] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(623),
    [anon_sym_LF] = ACTIONS(625),
    [anon_sym_AMP] = ACTIONS(623),
  },
  [107] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(356),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [108] = {
    [sym_string] = STATE(358),
    [anon_sym_DQUOTE] = ACTIONS(629),
    [anon_sym_DOLLAR] = ACTIONS(631),
    [sym_raw_string] = ACTIONS(633),
    [anon_sym_POUND] = ACTIONS(631),
    [anon_sym_DASH] = ACTIONS(631),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(635),
    [anon_sym_STAR] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(631),
    [anon_sym_QMARK] = ACTIONS(631),
    [anon_sym_0] = ACTIONS(637),
    [anon_sym__] = ACTIONS(637),
  },
  [109] = {
    [aux_sym_concatenation_repeat1] = STATE(354),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(639),
    [anon_sym_SEMI_SEMI] = ACTIONS(639),
    [anon_sym_PIPE_AMP] = ACTIONS(639),
    [anon_sym_AMP_AMP] = ACTIONS(639),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [sym__special_characters] = ACTIONS(639),
    [anon_sym_DQUOTE] = ACTIONS(639),
    [anon_sym_DOLLAR] = ACTIONS(639),
    [sym_raw_string] = ACTIONS(639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(639),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(639),
    [anon_sym_BQUOTE] = ACTIONS(639),
    [anon_sym_LT_LPAREN] = ACTIONS(639),
    [anon_sym_GT_LPAREN] = ACTIONS(639),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(639),
    [sym_word] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(639),
    [anon_sym_LF] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(639),
  },
  [110] = {
    [sym_subscript] = STATE(364),
    [sym_variable_name] = ACTIONS(643),
    [anon_sym_DOLLAR] = ACTIONS(645),
    [anon_sym_POUND] = ACTIONS(647),
    [anon_sym_DASH] = ACTIONS(645),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(645),
    [anon_sym_AT] = ACTIONS(645),
    [anon_sym_QMARK] = ACTIONS(645),
    [anon_sym_0] = ACTIONS(651),
    [anon_sym__] = ACTIONS(651),
  },
  [111] = {
    [sym_for_statement] = STATE(365),
    [sym_while_statement] = STATE(365),
    [sym_if_statement] = STATE(365),
    [sym_case_statement] = STATE(365),
    [sym_function_definition] = STATE(365),
    [sym_subshell] = STATE(365),
    [sym_pipeline] = STATE(365),
    [sym_list] = STATE(365),
    [sym_negated_command] = STATE(365),
    [sym_test_command] = STATE(365),
    [sym_declaration_command] = STATE(365),
    [sym_unset_command] = STATE(365),
    [sym_command] = STATE(365),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(366),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [112] = {
    [sym_for_statement] = STATE(367),
    [sym_while_statement] = STATE(367),
    [sym_if_statement] = STATE(367),
    [sym_case_statement] = STATE(367),
    [sym_function_definition] = STATE(367),
    [sym_subshell] = STATE(367),
    [sym_pipeline] = STATE(367),
    [sym_list] = STATE(367),
    [sym_negated_command] = STATE(367),
    [sym_test_command] = STATE(367),
    [sym_declaration_command] = STATE(367),
    [sym_unset_command] = STATE(367),
    [sym_command] = STATE(367),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(368),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [113] = {
    [sym_for_statement] = STATE(369),
    [sym_while_statement] = STATE(369),
    [sym_if_statement] = STATE(369),
    [sym_case_statement] = STATE(369),
    [sym_function_definition] = STATE(369),
    [sym_subshell] = STATE(369),
    [sym_pipeline] = STATE(369),
    [sym_list] = STATE(369),
    [sym_negated_command] = STATE(369),
    [sym_test_command] = STATE(369),
    [sym_declaration_command] = STATE(369),
    [sym_unset_command] = STATE(369),
    [sym_command] = STATE(369),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(370),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [114] = {
    [anon_sym_PIPE] = ACTIONS(653),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_SEMI_SEMI] = ACTIONS(653),
    [anon_sym_PIPE_AMP] = ACTIONS(653),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_PIPE_PIPE] = ACTIONS(653),
    [sym__special_characters] = ACTIONS(653),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_DOLLAR] = ACTIONS(653),
    [sym_raw_string] = ACTIONS(653),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(653),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(653),
    [anon_sym_LT_LPAREN] = ACTIONS(653),
    [anon_sym_GT_LPAREN] = ACTIONS(653),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(653),
    [sym_word] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_LF] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(653),
  },
  [115] = {
    [sym_concatenation] = STATE(371),
    [sym_string] = STATE(109),
    [sym_simple_expansion] = STATE(109),
    [sym_string_expansion] = STATE(109),
    [sym_expansion] = STATE(109),
    [sym_command_substitution] = STATE(109),
    [sym_process_substitution] = STATE(109),
    [aux_sym_unset_command_repeat1] = STATE(371),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_SEMI_SEMI] = ACTIONS(657),
    [anon_sym_PIPE_AMP] = ACTIONS(657),
    [anon_sym_AMP_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(657),
    [sym__special_characters] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(191),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(193),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(195),
    [anon_sym_BQUOTE] = ACTIONS(197),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(201),
    [sym_word] = ACTIONS(191),
    [anon_sym_SEMI] = ACTIONS(657),
    [anon_sym_LF] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(657),
  },
  [116] = {
    [aux_sym_concatenation_repeat1] = STATE(373),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(661),
    [anon_sym_LT_AMP] = ACTIONS(661),
    [anon_sym_GT_AMP] = ACTIONS(661),
    [sym__special_characters] = ACTIONS(661),
    [anon_sym_DQUOTE] = ACTIONS(661),
    [anon_sym_DOLLAR] = ACTIONS(665),
    [sym_raw_string] = ACTIONS(661),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(661),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(661),
    [anon_sym_BQUOTE] = ACTIONS(661),
    [anon_sym_LT_LPAREN] = ACTIONS(661),
    [anon_sym_GT_LPAREN] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(661),
  },
  [117] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(375),
    [anon_sym_DQUOTE] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [118] = {
    [sym_string] = STATE(377),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(669),
    [sym_raw_string] = ACTIONS(671),
    [anon_sym_POUND] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(669),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_QMARK] = ACTIONS(669),
    [anon_sym_0] = ACTIONS(675),
    [anon_sym__] = ACTIONS(675),
  },
  [119] = {
    [aux_sym_concatenation_repeat1] = STATE(373),
    [sym_file_descriptor] = ACTIONS(677),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [sym__special_characters] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(679),
    [sym_raw_string] = ACTIONS(677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [anon_sym_LT_LPAREN] = ACTIONS(677),
    [anon_sym_GT_LPAREN] = ACTIONS(677),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(677),
  },
  [120] = {
    [sym_subscript] = STATE(383),
    [sym_variable_name] = ACTIONS(681),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(685),
    [anon_sym_DASH] = ACTIONS(683),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_0] = ACTIONS(689),
    [anon_sym__] = ACTIONS(689),
  },
  [121] = {
    [sym_for_statement] = STATE(384),
    [sym_while_statement] = STATE(384),
    [sym_if_statement] = STATE(384),
    [sym_case_statement] = STATE(384),
    [sym_function_definition] = STATE(384),
    [sym_subshell] = STATE(384),
    [sym_pipeline] = STATE(384),
    [sym_list] = STATE(384),
    [sym_negated_command] = STATE(384),
    [sym_test_command] = STATE(384),
    [sym_declaration_command] = STATE(384),
    [sym_unset_command] = STATE(384),
    [sym_command] = STATE(384),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(385),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [122] = {
    [sym_for_statement] = STATE(386),
    [sym_while_statement] = STATE(386),
    [sym_if_statement] = STATE(386),
    [sym_case_statement] = STATE(386),
    [sym_function_definition] = STATE(386),
    [sym_subshell] = STATE(386),
    [sym_pipeline] = STATE(386),
    [sym_list] = STATE(386),
    [sym_negated_command] = STATE(386),
    [sym_test_command] = STATE(386),
    [sym_declaration_command] = STATE(386),
    [sym_unset_command] = STATE(386),
    [sym_command] = STATE(386),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(387),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [123] = {
    [sym_for_statement] = STATE(388),
    [sym_while_statement] = STATE(388),
    [sym_if_statement] = STATE(388),
    [sym_case_statement] = STATE(388),
    [sym_function_definition] = STATE(388),
    [sym_subshell] = STATE(388),
    [sym_pipeline] = STATE(388),
    [sym_list] = STATE(388),
    [sym_negated_command] = STATE(388),
    [sym_test_command] = STATE(388),
    [sym_declaration_command] = STATE(388),
    [sym_unset_command] = STATE(388),
    [sym_command] = STATE(388),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(389),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [124] = {
    [sym_file_descriptor] = ACTIONS(677),
    [sym_variable_name] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [sym__special_characters] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(679),
    [sym_raw_string] = ACTIONS(677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [anon_sym_LT_LPAREN] = ACTIONS(677),
    [anon_sym_GT_LPAREN] = ACTIONS(677),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(677),
  },
  [125] = {
    [sym_string] = STATE(390),
    [sym_simple_expansion] = STATE(390),
    [sym_string_expansion] = STATE(390),
    [sym_expansion] = STATE(390),
    [sym_command_substitution] = STATE(390),
    [sym_process_substitution] = STATE(390),
    [sym__special_characters] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(691),
  },
  [126] = {
    [aux_sym_concatenation_repeat1] = STATE(391),
    [sym__simple_heredoc_body] = ACTIONS(693),
    [sym__heredoc_body_beginning] = ACTIONS(693),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_EQ_TILDE] = ACTIONS(695),
    [anon_sym_EQ_EQ] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [127] = {
    [sym__simple_heredoc_body] = ACTIONS(697),
    [sym__heredoc_body_beginning] = ACTIONS(697),
    [sym_file_descriptor] = ACTIONS(697),
    [sym__concat] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_EQ_TILDE] = ACTIONS(699),
    [anon_sym_EQ_EQ] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_GT] = ACTIONS(699),
    [anon_sym_AMP_GT_GT] = ACTIONS(699),
    [anon_sym_LT_AMP] = ACTIONS(699),
    [anon_sym_GT_AMP] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_LT_LT_DASH] = ACTIONS(699),
    [anon_sym_LT_LT_LT] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_LF] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [128] = {
    [anon_sym_DOLLAR] = ACTIONS(701),
    [sym__string_content] = ACTIONS(703),
    [anon_sym_POUND] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(707),
    [anon_sym_STAR] = ACTIONS(705),
    [anon_sym_AT] = ACTIONS(705),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_0] = ACTIONS(701),
    [anon_sym__] = ACTIONS(701),
  },
  [129] = {
    [sym__concat] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_DOLLAR] = ACTIONS(711),
    [sym__string_content] = ACTIONS(713),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(711),
    [anon_sym_BQUOTE] = ACTIONS(711),
    [sym_comment] = ACTIONS(177),
  },
  [130] = {
    [sym_subscript] = STATE(400),
    [sym_variable_name] = ACTIONS(715),
    [anon_sym_DOLLAR] = ACTIONS(717),
    [anon_sym_POUND] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(717),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(721),
    [anon_sym_STAR] = ACTIONS(717),
    [anon_sym_AT] = ACTIONS(717),
    [anon_sym_QMARK] = ACTIONS(717),
    [anon_sym_0] = ACTIONS(723),
    [anon_sym__] = ACTIONS(723),
  },
  [131] = {
    [sym_for_statement] = STATE(401),
    [sym_while_statement] = STATE(401),
    [sym_if_statement] = STATE(401),
    [sym_case_statement] = STATE(401),
    [sym_function_definition] = STATE(401),
    [sym_subshell] = STATE(401),
    [sym_pipeline] = STATE(401),
    [sym_list] = STATE(401),
    [sym_negated_command] = STATE(401),
    [sym_test_command] = STATE(401),
    [sym_declaration_command] = STATE(401),
    [sym_unset_command] = STATE(401),
    [sym_command] = STATE(401),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(402),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [132] = {
    [sym_for_statement] = STATE(403),
    [sym_while_statement] = STATE(403),
    [sym_if_statement] = STATE(403),
    [sym_case_statement] = STATE(403),
    [sym_function_definition] = STATE(403),
    [sym_subshell] = STATE(403),
    [sym_pipeline] = STATE(403),
    [sym_list] = STATE(403),
    [sym_negated_command] = STATE(403),
    [sym_test_command] = STATE(403),
    [sym_declaration_command] = STATE(403),
    [sym_unset_command] = STATE(403),
    [sym_command] = STATE(403),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(404),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [133] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [134] = {
    [sym__simple_heredoc_body] = ACTIONS(727),
    [sym__heredoc_body_beginning] = ACTIONS(727),
    [sym_file_descriptor] = ACTIONS(727),
    [sym__concat] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(729),
    [anon_sym_PIPE_AMP] = ACTIONS(729),
    [anon_sym_AMP_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(729),
    [anon_sym_EQ_TILDE] = ACTIONS(729),
    [anon_sym_EQ_EQ] = ACTIONS(729),
    [anon_sym_LT] = ACTIONS(729),
    [anon_sym_GT] = ACTIONS(729),
    [anon_sym_GT_GT] = ACTIONS(729),
    [anon_sym_AMP_GT] = ACTIONS(729),
    [anon_sym_AMP_GT_GT] = ACTIONS(729),
    [anon_sym_LT_AMP] = ACTIONS(729),
    [anon_sym_GT_AMP] = ACTIONS(729),
    [anon_sym_LT_LT] = ACTIONS(729),
    [anon_sym_LT_LT_DASH] = ACTIONS(729),
    [anon_sym_LT_LT_LT] = ACTIONS(729),
    [sym__special_characters] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(729),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(729),
    [anon_sym_BQUOTE] = ACTIONS(729),
    [anon_sym_LT_LPAREN] = ACTIONS(729),
    [anon_sym_GT_LPAREN] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(729),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_LF] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
  },
  [135] = {
    [sym__simple_heredoc_body] = ACTIONS(731),
    [sym__heredoc_body_beginning] = ACTIONS(731),
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_EQ_TILDE] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(733),
    [anon_sym_LT_LT_LT] = ACTIONS(733),
    [sym__special_characters] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [anon_sym_LT_LPAREN] = ACTIONS(733),
    [anon_sym_GT_LPAREN] = ACTIONS(733),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [136] = {
    [sym__simple_heredoc_body] = ACTIONS(735),
    [sym__heredoc_body_beginning] = ACTIONS(735),
    [sym_file_descriptor] = ACTIONS(735),
    [sym__concat] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(737),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_EQ_TILDE] = ACTIONS(737),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(737),
    [anon_sym_LT_AMP] = ACTIONS(737),
    [anon_sym_GT_AMP] = ACTIONS(737),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_LT_LT_DASH] = ACTIONS(737),
    [anon_sym_LT_LT_LT] = ACTIONS(737),
    [sym__special_characters] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [anon_sym_LT_LPAREN] = ACTIONS(737),
    [anon_sym_GT_LPAREN] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [137] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(741),
    [sym_comment] = ACTIONS(53),
  },
  [138] = {
    [sym_concatenation] = STATE(419),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(419),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(745),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(759),
    [anon_sym_COLON] = ACTIONS(745),
    [anon_sym_COLON_QMARK] = ACTIONS(745),
    [anon_sym_COLON_DASH] = ACTIONS(745),
    [anon_sym_PERCENT] = ACTIONS(745),
    [anon_sym_DASH] = ACTIONS(745),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [139] = {
    [sym_subscript] = STATE(423),
    [sym_variable_name] = ACTIONS(769),
    [anon_sym_DOLLAR] = ACTIONS(771),
    [anon_sym_DASH] = ACTIONS(771),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(773),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_AT] = ACTIONS(771),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_0] = ACTIONS(775),
    [anon_sym__] = ACTIONS(775),
  },
  [140] = {
    [sym_concatenation] = STATE(426),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(426),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(779),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(783),
    [anon_sym_COLON] = ACTIONS(779),
    [anon_sym_COLON_QMARK] = ACTIONS(779),
    [anon_sym_COLON_DASH] = ACTIONS(779),
    [anon_sym_PERCENT] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [141] = {
    [sym_concatenation] = STATE(429),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(429),
    [anon_sym_RBRACE] = ACTIONS(785),
    [anon_sym_EQ] = ACTIONS(787),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(789),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(791),
    [anon_sym_COLON] = ACTIONS(787),
    [anon_sym_COLON_QMARK] = ACTIONS(787),
    [anon_sym_COLON_DASH] = ACTIONS(787),
    [anon_sym_PERCENT] = ACTIONS(787),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [142] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [sym_comment] = ACTIONS(53),
  },
  [143] = {
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(795),
  },
  [144] = {
    [sym__terminated_statement] = STATE(432),
    [sym_for_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_subshell] = STATE(39),
    [sym_pipeline] = STATE(39),
    [sym_list] = STATE(39),
    [sym_negated_command] = STATE(39),
    [sym_test_command] = STATE(39),
    [sym_declaration_command] = STATE(39),
    [sym_unset_command] = STATE(39),
    [sym_command] = STATE(39),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(40),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [145] = {
    [sym__terminated_statement] = STATE(433),
    [sym_for_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_subshell] = STATE(39),
    [sym_pipeline] = STATE(39),
    [sym_list] = STATE(39),
    [sym_negated_command] = STATE(39),
    [sym_test_command] = STATE(39),
    [sym_declaration_command] = STATE(39),
    [sym_unset_command] = STATE(39),
    [sym_command] = STATE(39),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(40),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [146] = {
    [sym_concatenation] = STATE(436),
    [sym_string] = STATE(435),
    [sym_simple_expansion] = STATE(435),
    [sym_string_expansion] = STATE(435),
    [sym_expansion] = STATE(435),
    [sym_command_substitution] = STATE(435),
    [sym_process_substitution] = STATE(435),
    [sym__special_characters] = ACTIONS(797),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [anon_sym_DOLLAR] = ACTIONS(71),
    [sym_raw_string] = ACTIONS(799),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(75),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(77),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [anon_sym_LT_LPAREN] = ACTIONS(81),
    [anon_sym_GT_LPAREN] = ACTIONS(81),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(799),
  },
  [147] = {
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(801),
  },
  [148] = {
    [sym__terminated_statement] = STATE(440),
    [sym_for_statement] = STATE(438),
    [sym_while_statement] = STATE(438),
    [sym_if_statement] = STATE(438),
    [sym_case_statement] = STATE(438),
    [sym_function_definition] = STATE(438),
    [sym_subshell] = STATE(438),
    [sym_pipeline] = STATE(438),
    [sym_list] = STATE(438),
    [sym_negated_command] = STATE(438),
    [sym_test_command] = STATE(438),
    [sym_declaration_command] = STATE(438),
    [sym_unset_command] = STATE(438),
    [sym_command] = STATE(438),
    [sym_command_name] = STATE(64),
    [sym_variable_assignment] = STATE(439),
    [sym_subscript] = STATE(66),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(61),
    [sym_simple_expansion] = STATE(61),
    [sym_string_expansion] = STATE(61),
    [sym_expansion] = STATE(61),
    [sym_command_substitution] = STATE(61),
    [sym_process_substitution] = STATE(61),
    [aux_sym_program_repeat1] = STATE(440),
    [aux_sym_command_repeat1] = STATE(68),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(93),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_typeset] = ACTIONS(97),
    [anon_sym_export] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_local] = ACTIONS(97),
    [anon_sym_unset] = ACTIONS(99),
    [anon_sym_unsetenv] = ACTIONS(99),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(105),
  },
  [149] = {
    [sym_test_command] = STATE(441),
    [sym_command] = STATE(441),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(71),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(291),
  },
  [150] = {
    [sym__expression] = STATE(442),
    [sym_binary_expression] = STATE(442),
    [sym_unary_expression] = STATE(442),
    [sym_parenthesized_expression] = STATE(442),
    [sym_concatenation] = STATE(442),
    [sym_string] = STATE(77),
    [sym_simple_expansion] = STATE(77),
    [sym_string_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [sym_process_substitution] = STATE(77),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(111),
    [sym__special_characters] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
    [sym_test_operator] = ACTIONS(131),
  },
  [151] = {
    [sym__expression] = STATE(443),
    [sym_binary_expression] = STATE(443),
    [sym_unary_expression] = STATE(443),
    [sym_parenthesized_expression] = STATE(443),
    [sym_concatenation] = STATE(443),
    [sym_string] = STATE(88),
    [sym_simple_expansion] = STATE(88),
    [sym_string_expansion] = STATE(88),
    [sym_expansion] = STATE(88),
    [sym_command_substitution] = STATE(88),
    [sym_process_substitution] = STATE(88),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(155),
  },
  [152] = {
    [sym_variable_assignment] = STATE(455),
    [sym_subscript] = STATE(454),
    [sym_concatenation] = STATE(455),
    [sym_string] = STATE(448),
    [sym_simple_expansion] = STATE(448),
    [sym_string_expansion] = STATE(448),
    [sym_expansion] = STATE(448),
    [sym_command_substitution] = STATE(448),
    [sym_process_substitution] = STATE(448),
    [aux_sym_declaration_command_repeat1] = STATE(455),
    [sym_variable_name] = ACTIONS(803),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_RPAREN] = ACTIONS(181),
    [anon_sym_PIPE_AMP] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [sym__special_characters] = ACTIONS(805),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(811),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(815),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LT_LPAREN] = ACTIONS(819),
    [anon_sym_GT_LPAREN] = ACTIONS(819),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(821),
    [sym_word] = ACTIONS(823),
  },
  [153] = {
    [sym_concatenation] = STATE(465),
    [sym_string] = STATE(459),
    [sym_simple_expansion] = STATE(459),
    [sym_string_expansion] = STATE(459),
    [sym_expansion] = STATE(459),
    [sym_command_substitution] = STATE(459),
    [sym_process_substitution] = STATE(459),
    [aux_sym_unset_command_repeat1] = STATE(465),
    [anon_sym_PIPE] = ACTIONS(183),
    [anon_sym_RPAREN] = ACTIONS(203),
    [anon_sym_PIPE_AMP] = ACTIONS(203),
    [anon_sym_AMP_AMP] = ACTIONS(203),
    [anon_sym_PIPE_PIPE] = ACTIONS(203),
    [sym__special_characters] = ACTIONS(825),
    [anon_sym_DQUOTE] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [sym_raw_string] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [anon_sym_LT_LPAREN] = ACTIONS(839),
    [anon_sym_GT_LPAREN] = ACTIONS(839),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(841),
    [sym_word] = ACTIONS(843),
  },
  [154] = {
    [aux_sym_concatenation_repeat1] = STATE(467),
    [sym__simple_heredoc_body] = ACTIONS(221),
    [sym__heredoc_body_beginning] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(225),
    [anon_sym_RPAREN] = ACTIONS(221),
    [anon_sym_PIPE_AMP] = ACTIONS(221),
    [anon_sym_AMP_AMP] = ACTIONS(221),
    [anon_sym_PIPE_PIPE] = ACTIONS(221),
    [anon_sym_EQ_TILDE] = ACTIONS(225),
    [anon_sym_EQ_EQ] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(225),
    [anon_sym_GT] = ACTIONS(225),
    [anon_sym_GT_GT] = ACTIONS(221),
    [anon_sym_AMP_GT] = ACTIONS(225),
    [anon_sym_AMP_GT_GT] = ACTIONS(221),
    [anon_sym_LT_AMP] = ACTIONS(221),
    [anon_sym_GT_AMP] = ACTIONS(221),
    [anon_sym_LT_LT] = ACTIONS(225),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_LT] = ACTIONS(221),
    [sym__special_characters] = ACTIONS(221),
    [anon_sym_DQUOTE] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [sym_raw_string] = ACTIONS(221),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(221),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(225),
  },
  [155] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(469),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [156] = {
    [sym_string] = STATE(471),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(853),
    [anon_sym_STAR] = ACTIONS(849),
    [anon_sym_AT] = ACTIONS(849),
    [anon_sym_QMARK] = ACTIONS(849),
    [anon_sym_0] = ACTIONS(855),
    [anon_sym__] = ACTIONS(855),
  },
  [157] = {
    [aux_sym_concatenation_repeat1] = STATE(467),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_RPAREN] = ACTIONS(247),
    [anon_sym_PIPE_AMP] = ACTIONS(247),
    [anon_sym_AMP_AMP] = ACTIONS(247),
    [anon_sym_PIPE_PIPE] = ACTIONS(247),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(247),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(247),
    [anon_sym_LT_AMP] = ACTIONS(247),
    [anon_sym_GT_AMP] = ACTIONS(247),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(247),
    [anon_sym_LT_LT_LT] = ACTIONS(247),
    [sym__special_characters] = ACTIONS(247),
    [anon_sym_DQUOTE] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(247),
    [anon_sym_BQUOTE] = ACTIONS(247),
    [anon_sym_LT_LPAREN] = ACTIONS(247),
    [anon_sym_GT_LPAREN] = ACTIONS(247),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(249),
  },
  [158] = {
    [sym_subscript] = STATE(477),
    [sym_variable_name] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(859),
    [anon_sym_POUND] = ACTIONS(861),
    [anon_sym_DASH] = ACTIONS(859),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(863),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_AT] = ACTIONS(859),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_0] = ACTIONS(865),
    [anon_sym__] = ACTIONS(865),
  },
  [159] = {
    [sym_for_statement] = STATE(478),
    [sym_while_statement] = STATE(478),
    [sym_if_statement] = STATE(478),
    [sym_case_statement] = STATE(478),
    [sym_function_definition] = STATE(478),
    [sym_subshell] = STATE(478),
    [sym_pipeline] = STATE(478),
    [sym_list] = STATE(478),
    [sym_negated_command] = STATE(478),
    [sym_test_command] = STATE(478),
    [sym_declaration_command] = STATE(478),
    [sym_unset_command] = STATE(478),
    [sym_command] = STATE(478),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(479),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [160] = {
    [sym_for_statement] = STATE(480),
    [sym_while_statement] = STATE(480),
    [sym_if_statement] = STATE(480),
    [sym_case_statement] = STATE(480),
    [sym_function_definition] = STATE(480),
    [sym_subshell] = STATE(480),
    [sym_pipeline] = STATE(480),
    [sym_list] = STATE(480),
    [sym_negated_command] = STATE(480),
    [sym_test_command] = STATE(480),
    [sym_declaration_command] = STATE(480),
    [sym_unset_command] = STATE(480),
    [sym_command] = STATE(480),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(481),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [161] = {
    [sym_for_statement] = STATE(482),
    [sym_while_statement] = STATE(482),
    [sym_if_statement] = STATE(482),
    [sym_case_statement] = STATE(482),
    [sym_function_definition] = STATE(482),
    [sym_subshell] = STATE(482),
    [sym_pipeline] = STATE(482),
    [sym_list] = STATE(482),
    [sym_negated_command] = STATE(482),
    [sym_test_command] = STATE(482),
    [sym_declaration_command] = STATE(482),
    [sym_unset_command] = STATE(482),
    [sym_command] = STATE(482),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(483),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [162] = {
    [aux_sym_concatenation_repeat1] = STATE(467),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_RPAREN] = ACTIONS(247),
    [anon_sym_LPAREN] = ACTIONS(867),
    [anon_sym_PIPE_AMP] = ACTIONS(247),
    [anon_sym_AMP_AMP] = ACTIONS(247),
    [anon_sym_PIPE_PIPE] = ACTIONS(247),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(247),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(247),
    [anon_sym_LT_AMP] = ACTIONS(247),
    [anon_sym_GT_AMP] = ACTIONS(247),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(247),
    [anon_sym_LT_LT_LT] = ACTIONS(247),
    [sym__special_characters] = ACTIONS(247),
    [anon_sym_DQUOTE] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(247),
    [anon_sym_BQUOTE] = ACTIONS(247),
    [anon_sym_LT_LPAREN] = ACTIONS(247),
    [anon_sym_GT_LPAREN] = ACTIONS(247),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(249),
  },
  [163] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(871),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [164] = {
    [sym_file_redirect] = STATE(498),
    [sym_heredoc_redirect] = STATE(498),
    [sym_heredoc_body] = STATE(497),
    [sym_herestring_redirect] = STATE(498),
    [sym_concatenation] = STATE(499),
    [sym_string] = STATE(496),
    [sym_simple_expansion] = STATE(496),
    [sym_string_expansion] = STATE(496),
    [sym_expansion] = STATE(496),
    [sym_command_substitution] = STATE(496),
    [sym_process_substitution] = STATE(496),
    [aux_sym_while_statement_repeat1] = STATE(498),
    [aux_sym_command_repeat2] = STATE(499),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(367),
    [anon_sym_PIPE_AMP] = ACTIONS(367),
    [anon_sym_AMP_AMP] = ACTIONS(367),
    [anon_sym_PIPE_PIPE] = ACTIONS(367),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(887),
    [anon_sym_LT_AMP] = ACTIONS(887),
    [anon_sym_GT_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(893),
    [sym__special_characters] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(897),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(899),
  },
  [165] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(871),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [166] = {
    [anon_sym_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [sym_comment] = ACTIONS(53),
  },
  [167] = {
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_RPAREN] = ACTIONS(247),
    [anon_sym_PIPE_AMP] = ACTIONS(247),
    [anon_sym_AMP_AMP] = ACTIONS(247),
    [anon_sym_PIPE_PIPE] = ACTIONS(247),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(247),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(247),
    [anon_sym_LT_AMP] = ACTIONS(247),
    [anon_sym_GT_AMP] = ACTIONS(247),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(247),
    [anon_sym_LT_LT_LT] = ACTIONS(247),
    [sym__special_characters] = ACTIONS(247),
    [anon_sym_DQUOTE] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(247),
    [anon_sym_BQUOTE] = ACTIONS(247),
    [anon_sym_LT_LPAREN] = ACTIONS(247),
    [anon_sym_GT_LPAREN] = ACTIONS(247),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(249),
  },
  [168] = {
    [sym_command_name] = STATE(500),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(71),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(205),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(107),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(901),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(291),
  },
  [169] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(903),
    [anon_sym_PLUS_EQ] = ACTIONS(903),
    [sym_comment] = ACTIONS(53),
  },
  [170] = {
    [sym__terminated_statement] = STATE(502),
    [sym_for_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_subshell] = STATE(39),
    [sym_pipeline] = STATE(39),
    [sym_list] = STATE(39),
    [sym_negated_command] = STATE(39),
    [sym_test_command] = STATE(39),
    [sym_declaration_command] = STATE(39),
    [sym_unset_command] = STATE(39),
    [sym_command] = STATE(39),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(40),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [171] = {
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [172] = {
    [sym_test_command] = STATE(441),
    [sym_command] = STATE(441),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(71),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(321),
  },
  [173] = {
    [sym__expression] = STATE(504),
    [sym_binary_expression] = STATE(504),
    [sym_unary_expression] = STATE(504),
    [sym_parenthesized_expression] = STATE(504),
    [sym_concatenation] = STATE(504),
    [sym_string] = STATE(77),
    [sym_simple_expansion] = STATE(77),
    [sym_string_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [sym_process_substitution] = STATE(77),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(111),
    [sym__special_characters] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
    [sym_test_operator] = ACTIONS(131),
  },
  [174] = {
    [sym__expression] = STATE(505),
    [sym_binary_expression] = STATE(505),
    [sym_unary_expression] = STATE(505),
    [sym_parenthesized_expression] = STATE(505),
    [sym_concatenation] = STATE(505),
    [sym_string] = STATE(88),
    [sym_simple_expansion] = STATE(88),
    [sym_string_expansion] = STATE(88),
    [sym_expansion] = STATE(88),
    [sym_command_substitution] = STATE(88),
    [sym_process_substitution] = STATE(88),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(155),
  },
  [175] = {
    [sym_variable_assignment] = STATE(510),
    [sym_subscript] = STATE(509),
    [sym_concatenation] = STATE(510),
    [sym_string] = STATE(508),
    [sym_simple_expansion] = STATE(508),
    [sym_string_expansion] = STATE(508),
    [sym_expansion] = STATE(508),
    [sym_command_substitution] = STATE(508),
    [sym_process_substitution] = STATE(508),
    [aux_sym_declaration_command_repeat1] = STATE(510),
    [sym_variable_name] = ACTIONS(907),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_PIPE_AMP] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [sym__special_characters] = ACTIONS(909),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(815),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [anon_sym_LT_LPAREN] = ACTIONS(819),
    [anon_sym_GT_LPAREN] = ACTIONS(819),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(821),
    [sym_word] = ACTIONS(913),
  },
  [176] = {
    [sym_concatenation] = STATE(513),
    [sym_string] = STATE(512),
    [sym_simple_expansion] = STATE(512),
    [sym_string_expansion] = STATE(512),
    [sym_expansion] = STATE(512),
    [sym_command_substitution] = STATE(512),
    [sym_process_substitution] = STATE(512),
    [aux_sym_unset_command_repeat1] = STATE(513),
    [anon_sym_PIPE] = ACTIONS(183),
    [anon_sym_PIPE_AMP] = ACTIONS(203),
    [anon_sym_AMP_AMP] = ACTIONS(203),
    [anon_sym_PIPE_PIPE] = ACTIONS(203),
    [sym__special_characters] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [sym_raw_string] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(203),
    [anon_sym_LT_LPAREN] = ACTIONS(839),
    [anon_sym_GT_LPAREN] = ACTIONS(839),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(841),
    [sym_word] = ACTIONS(919),
  },
  [177] = {
    [aux_sym_concatenation_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(221),
    [sym__heredoc_body_beginning] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(225),
    [anon_sym_PIPE_AMP] = ACTIONS(221),
    [anon_sym_AMP_AMP] = ACTIONS(221),
    [anon_sym_PIPE_PIPE] = ACTIONS(221),
    [anon_sym_EQ_TILDE] = ACTIONS(225),
    [anon_sym_EQ_EQ] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(225),
    [anon_sym_GT] = ACTIONS(225),
    [anon_sym_GT_GT] = ACTIONS(221),
    [anon_sym_AMP_GT] = ACTIONS(225),
    [anon_sym_AMP_GT_GT] = ACTIONS(221),
    [anon_sym_LT_AMP] = ACTIONS(221),
    [anon_sym_GT_AMP] = ACTIONS(221),
    [anon_sym_LT_LT] = ACTIONS(225),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_LT] = ACTIONS(221),
    [sym__special_characters] = ACTIONS(221),
    [anon_sym_DQUOTE] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [sym_raw_string] = ACTIONS(221),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(221),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(225),
  },
  [178] = {
    [aux_sym_concatenation_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_PIPE_AMP] = ACTIONS(247),
    [anon_sym_AMP_AMP] = ACTIONS(247),
    [anon_sym_PIPE_PIPE] = ACTIONS(247),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(247),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(247),
    [anon_sym_LT_AMP] = ACTIONS(247),
    [anon_sym_GT_AMP] = ACTIONS(247),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(247),
    [anon_sym_LT_LT_LT] = ACTIONS(247),
    [sym__special_characters] = ACTIONS(247),
    [anon_sym_DQUOTE] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(247),
    [anon_sym_BQUOTE] = ACTIONS(247),
    [anon_sym_LT_LPAREN] = ACTIONS(247),
    [anon_sym_GT_LPAREN] = ACTIONS(247),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(249),
  },
  [179] = {
    [aux_sym_concatenation_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_LPAREN] = ACTIONS(921),
    [anon_sym_PIPE_AMP] = ACTIONS(247),
    [anon_sym_AMP_AMP] = ACTIONS(247),
    [anon_sym_PIPE_PIPE] = ACTIONS(247),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(247),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(247),
    [anon_sym_LT_AMP] = ACTIONS(247),
    [anon_sym_GT_AMP] = ACTIONS(247),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(247),
    [anon_sym_LT_LT_LT] = ACTIONS(247),
    [sym__special_characters] = ACTIONS(247),
    [anon_sym_DQUOTE] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(247),
    [anon_sym_BQUOTE] = ACTIONS(247),
    [anon_sym_LT_LPAREN] = ACTIONS(247),
    [anon_sym_GT_LPAREN] = ACTIONS(247),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(249),
  },
  [180] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(871),
    [sym_comment] = ACTIONS(53),
  },
  [181] = {
    [sym_file_redirect] = STATE(524),
    [sym_heredoc_redirect] = STATE(524),
    [sym_heredoc_body] = STATE(497),
    [sym_herestring_redirect] = STATE(524),
    [sym_concatenation] = STATE(525),
    [sym_string] = STATE(523),
    [sym_simple_expansion] = STATE(523),
    [sym_string_expansion] = STATE(523),
    [sym_expansion] = STATE(523),
    [sym_command_substitution] = STATE(523),
    [sym_process_substitution] = STATE(523),
    [aux_sym_while_statement_repeat1] = STATE(524),
    [aux_sym_command_repeat2] = STATE(525),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_PIPE_AMP] = ACTIONS(367),
    [anon_sym_AMP_AMP] = ACTIONS(367),
    [anon_sym_PIPE_PIPE] = ACTIONS(367),
    [anon_sym_EQ_TILDE] = ACTIONS(931),
    [anon_sym_EQ_EQ] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(933),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(937),
    [sym__special_characters] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(941),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(943),
  },
  [182] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(871),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [183] = {
    [anon_sym_EQ] = ACTIONS(903),
    [anon_sym_PLUS_EQ] = ACTIONS(903),
    [sym_comment] = ACTIONS(53),
  },
  [184] = {
    [sym_command_name] = STATE(526),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(71),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(205),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(107),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(945),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(321),
  },
  [185] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [186] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [187] = {
    [anon_sym_RPAREN] = ACTIONS(949),
    [sym_comment] = ACTIONS(53),
  },
  [188] = {
    [sym_for_statement] = STATE(529),
    [sym_while_statement] = STATE(529),
    [sym_if_statement] = STATE(529),
    [sym_case_statement] = STATE(529),
    [sym_function_definition] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_pipeline] = STATE(529),
    [sym_list] = STATE(529),
    [sym_negated_command] = STATE(529),
    [sym_test_command] = STATE(529),
    [sym_declaration_command] = STATE(529),
    [sym_unset_command] = STATE(529),
    [sym_command] = STATE(529),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(530),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [189] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [ts_builtin_sym_end] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(953),
    [anon_sym_DQUOTE] = ACTIONS(951),
    [anon_sym_DOLLAR] = ACTIONS(953),
    [sym_raw_string] = ACTIONS(951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(951),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(951),
    [anon_sym_BQUOTE] = ACTIONS(951),
    [anon_sym_LT_LPAREN] = ACTIONS(951),
    [anon_sym_GT_LPAREN] = ACTIONS(951),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(953),
  },
  [190] = {
    [sym_for_statement] = STATE(531),
    [sym_while_statement] = STATE(531),
    [sym_if_statement] = STATE(531),
    [sym_case_statement] = STATE(531),
    [sym_function_definition] = STATE(531),
    [sym_subshell] = STATE(531),
    [sym_pipeline] = STATE(531),
    [sym_list] = STATE(531),
    [sym_negated_command] = STATE(531),
    [sym_test_command] = STATE(531),
    [sym_declaration_command] = STATE(531),
    [sym_unset_command] = STATE(531),
    [sym_command] = STATE(531),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(532),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [191] = {
    [anon_sym_esac] = ACTIONS(955),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_RPAREN] = ACTIONS(955),
    [anon_sym_SEMI_SEMI] = ACTIONS(955),
    [anon_sym_PIPE_AMP] = ACTIONS(955),
    [anon_sym_AMP_AMP] = ACTIONS(955),
    [anon_sym_PIPE_PIPE] = ACTIONS(955),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(955),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(955),
  },
  [192] = {
    [sym_simple_expansion] = STATE(536),
    [sym_expansion] = STATE(536),
    [aux_sym_heredoc_body_repeat1] = STATE(536),
    [sym__heredoc_body_middle] = ACTIONS(959),
    [sym__heredoc_body_end] = ACTIONS(961),
    [anon_sym_DOLLAR] = ACTIONS(963),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(965),
    [sym_comment] = ACTIONS(53),
  },
  [193] = {
    [anon_sym_LT] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(967),
    [anon_sym_GT_GT] = ACTIONS(969),
    [anon_sym_AMP_GT] = ACTIONS(967),
    [anon_sym_AMP_GT_GT] = ACTIONS(969),
    [anon_sym_LT_AMP] = ACTIONS(969),
    [anon_sym_GT_AMP] = ACTIONS(969),
    [sym_comment] = ACTIONS(53),
  },
  [194] = {
    [sym_concatenation] = STATE(540),
    [sym_string] = STATE(539),
    [sym_simple_expansion] = STATE(539),
    [sym_string_expansion] = STATE(539),
    [sym_expansion] = STATE(539),
    [sym_command_substitution] = STATE(539),
    [sym_process_substitution] = STATE(539),
    [sym__special_characters] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(973),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(973),
    [sym_regex] = ACTIONS(975),
  },
  [195] = {
    [sym_concatenation] = STATE(543),
    [sym_string] = STATE(542),
    [sym_simple_expansion] = STATE(542),
    [sym_string_expansion] = STATE(542),
    [sym_expansion] = STATE(542),
    [sym_command_substitution] = STATE(542),
    [sym_process_substitution] = STATE(542),
    [sym__special_characters] = ACTIONS(977),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(979),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(979),
  },
  [196] = {
    [sym_heredoc_start] = ACTIONS(981),
    [sym_comment] = ACTIONS(53),
  },
  [197] = {
    [sym_concatenation] = STATE(547),
    [sym_string] = STATE(546),
    [sym_simple_expansion] = STATE(546),
    [sym_string_expansion] = STATE(546),
    [sym_expansion] = STATE(546),
    [sym_command_substitution] = STATE(546),
    [sym_process_substitution] = STATE(546),
    [sym__special_characters] = ACTIONS(983),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(985),
  },
  [198] = {
    [aux_sym_concatenation_repeat1] = STATE(126),
    [sym__simple_heredoc_body] = ACTIONS(987),
    [sym__heredoc_body_beginning] = ACTIONS(987),
    [sym_file_descriptor] = ACTIONS(987),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(989),
    [anon_sym_SEMI_SEMI] = ACTIONS(989),
    [anon_sym_PIPE_AMP] = ACTIONS(989),
    [anon_sym_AMP_AMP] = ACTIONS(989),
    [anon_sym_PIPE_PIPE] = ACTIONS(989),
    [anon_sym_EQ_TILDE] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(989),
    [anon_sym_LT] = ACTIONS(989),
    [anon_sym_GT] = ACTIONS(989),
    [anon_sym_GT_GT] = ACTIONS(989),
    [anon_sym_AMP_GT] = ACTIONS(989),
    [anon_sym_AMP_GT_GT] = ACTIONS(989),
    [anon_sym_LT_AMP] = ACTIONS(989),
    [anon_sym_GT_AMP] = ACTIONS(989),
    [anon_sym_LT_LT] = ACTIONS(989),
    [anon_sym_LT_LT_DASH] = ACTIONS(989),
    [anon_sym_LT_LT_LT] = ACTIONS(989),
    [sym__special_characters] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(989),
    [anon_sym_DOLLAR] = ACTIONS(989),
    [sym_raw_string] = ACTIONS(989),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(989),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(989),
    [anon_sym_BQUOTE] = ACTIONS(989),
    [anon_sym_LT_LPAREN] = ACTIONS(989),
    [anon_sym_GT_LPAREN] = ACTIONS(989),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(989),
    [anon_sym_SEMI] = ACTIONS(989),
    [anon_sym_LF] = ACTIONS(987),
    [anon_sym_AMP] = ACTIONS(989),
  },
  [199] = {
    [aux_sym_concatenation_repeat1] = STATE(126),
    [sym__simple_heredoc_body] = ACTIONS(991),
    [sym__heredoc_body_beginning] = ACTIONS(991),
    [sym_file_descriptor] = ACTIONS(991),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_SEMI_SEMI] = ACTIONS(993),
    [anon_sym_PIPE_AMP] = ACTIONS(993),
    [anon_sym_AMP_AMP] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT] = ACTIONS(993),
    [anon_sym_GT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(993),
    [anon_sym_AMP_GT] = ACTIONS(993),
    [anon_sym_AMP_GT_GT] = ACTIONS(993),
    [anon_sym_LT_AMP] = ACTIONS(993),
    [anon_sym_GT_AMP] = ACTIONS(993),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_LT_LT_DASH] = ACTIONS(993),
    [anon_sym_LT_LT_LT] = ACTIONS(993),
    [sym__special_characters] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(993),
    [anon_sym_DOLLAR] = ACTIONS(993),
    [sym_raw_string] = ACTIONS(993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(993),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(993),
    [anon_sym_LT_LPAREN] = ACTIONS(993),
    [anon_sym_GT_LPAREN] = ACTIONS(993),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(993),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_LF] = ACTIONS(991),
    [anon_sym_AMP] = ACTIONS(993),
  },
  [200] = {
    [anon_sym_esac] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(995),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(995),
  },
  [201] = {
    [sym_file_redirect] = STATE(549),
    [sym_heredoc_redirect] = STATE(549),
    [sym_heredoc_body] = STATE(548),
    [sym_herestring_redirect] = STATE(549),
    [aux_sym_while_statement_repeat1] = STATE(549),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(347),
    [anon_sym_AMP_GT] = ACTIONS(347),
    [anon_sym_AMP_GT_GT] = ACTIONS(347),
    [anon_sym_LT_AMP] = ACTIONS(347),
    [anon_sym_GT_AMP] = ACTIONS(347),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(351),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(995),
  },
  [202] = {
    [sym_file_redirect] = STATE(550),
    [sym_heredoc_redirect] = STATE(550),
    [sym_heredoc_body] = STATE(548),
    [sym_herestring_redirect] = STATE(550),
    [sym_concatenation] = STATE(551),
    [sym_string] = STATE(199),
    [sym_simple_expansion] = STATE(199),
    [sym_string_expansion] = STATE(199),
    [sym_expansion] = STATE(199),
    [sym_command_substitution] = STATE(199),
    [sym_process_substitution] = STATE(199),
    [aux_sym_while_statement_repeat1] = STATE(550),
    [aux_sym_command_repeat2] = STATE(551),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_EQ_TILDE] = ACTIONS(345),
    [anon_sym_EQ_EQ] = ACTIONS(345),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(347),
    [anon_sym_AMP_GT] = ACTIONS(347),
    [anon_sym_AMP_GT_GT] = ACTIONS(347),
    [anon_sym_LT_AMP] = ACTIONS(347),
    [anon_sym_GT_AMP] = ACTIONS(347),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(351),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(357),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(357),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(995),
  },
  [203] = {
    [sym__terminated_statement] = STATE(203),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(203),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(999),
    [sym_variable_name] = ACTIONS(1002),
    [ts_builtin_sym_end] = ACTIONS(1005),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1010),
    [anon_sym_if] = ACTIONS(1013),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1031),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_typeset] = ACTIONS(1034),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_local] = ACTIONS(1034),
    [anon_sym_unset] = ACTIONS(1037),
    [anon_sym_unsetenv] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_GT_GT] = ACTIONS(1043),
    [anon_sym_AMP_GT] = ACTIONS(1040),
    [anon_sym_AMP_GT_GT] = ACTIONS(1043),
    [anon_sym_LT_AMP] = ACTIONS(1043),
    [anon_sym_GT_AMP] = ACTIONS(1043),
    [sym__special_characters] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [sym_raw_string] = ACTIONS(1055),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1064),
    [anon_sym_LT_LPAREN] = ACTIONS(1067),
    [anon_sym_GT_LPAREN] = ACTIONS(1067),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1070),
  },
  [204] = {
    [sym_file_redirect] = STATE(550),
    [sym_heredoc_redirect] = STATE(550),
    [sym_heredoc_body] = STATE(548),
    [sym_herestring_redirect] = STATE(550),
    [sym_concatenation] = STATE(552),
    [sym_string] = STATE(199),
    [sym_simple_expansion] = STATE(199),
    [sym_string_expansion] = STATE(199),
    [sym_expansion] = STATE(199),
    [sym_command_substitution] = STATE(199),
    [sym_process_substitution] = STATE(199),
    [aux_sym_while_statement_repeat1] = STATE(550),
    [aux_sym_command_repeat2] = STATE(552),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_EQ_TILDE] = ACTIONS(345),
    [anon_sym_EQ_EQ] = ACTIONS(345),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(347),
    [anon_sym_AMP_GT] = ACTIONS(347),
    [anon_sym_AMP_GT_GT] = ACTIONS(347),
    [anon_sym_LT_AMP] = ACTIONS(347),
    [anon_sym_GT_AMP] = ACTIONS(347),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(351),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(357),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(357),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(995),
  },
  [205] = {
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(71),
    [sym_file_redirect] = STATE(30),
    [aux_sym_command_repeat1] = STATE(205),
    [sym_file_descriptor] = ACTIONS(1073),
    [sym_variable_name] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_GT_GT] = ACTIONS(1082),
    [anon_sym_AMP_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT_GT] = ACTIONS(1082),
    [anon_sym_LT_AMP] = ACTIONS(1082),
    [anon_sym_GT_AMP] = ACTIONS(1082),
    [sym__special_characters] = ACTIONS(1085),
    [anon_sym_DQUOTE] = ACTIONS(1085),
    [anon_sym_DOLLAR] = ACTIONS(1087),
    [sym_raw_string] = ACTIONS(1085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1085),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [anon_sym_LT_LPAREN] = ACTIONS(1085),
    [anon_sym_GT_LPAREN] = ACTIONS(1085),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1085),
  },
  [206] = {
    [aux_sym_concatenation_repeat1] = STATE(373),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [sym__special_characters] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1089),
  },
  [207] = {
    [aux_sym_concatenation_repeat1] = STATE(373),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [sym__special_characters] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1095),
    [sym_raw_string] = ACTIONS(1093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [anon_sym_LT_LPAREN] = ACTIONS(1093),
    [anon_sym_GT_LPAREN] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1093),
  },
  [208] = {
    [sym_file_descriptor] = ACTIONS(1093),
    [sym_variable_name] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [sym__special_characters] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1095),
    [sym_raw_string] = ACTIONS(1093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [anon_sym_LT_LPAREN] = ACTIONS(1093),
    [anon_sym_GT_LPAREN] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1093),
  },
  [209] = {
    [aux_sym_concatenation_repeat1] = STATE(555),
    [sym__concat] = ACTIONS(1097),
    [anon_sym_RBRACK] = ACTIONS(1099),
    [sym_comment] = ACTIONS(53),
  },
  [210] = {
    [aux_sym_concatenation_repeat1] = STATE(555),
    [sym__concat] = ACTIONS(1101),
    [anon_sym_RBRACK] = ACTIONS(1103),
    [sym_comment] = ACTIONS(53),
  },
  [211] = {
    [sym__concat] = ACTIONS(1105),
    [anon_sym_RBRACK] = ACTIONS(1103),
    [sym_comment] = ACTIONS(53),
  },
  [212] = {
    [sym_file_descriptor] = ACTIONS(1107),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1109),
    [anon_sym_GT] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_AMP] = ACTIONS(1109),
    [anon_sym_GT_AMP] = ACTIONS(1109),
    [sym__special_characters] = ACTIONS(1109),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1109),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_LT_LPAREN] = ACTIONS(1109),
    [anon_sym_GT_LPAREN] = ACTIONS(1109),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1109),
  },
  [213] = {
    [sym_concatenation] = STATE(568),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(568),
    [anon_sym_RPAREN] = ACTIONS(1111),
    [sym__special_characters] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1119),
  },
  [214] = {
    [aux_sym_concatenation_repeat1] = STATE(570),
    [sym_file_descriptor] = ACTIONS(1129),
    [sym__concat] = ACTIONS(1131),
    [sym_variable_name] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_SEMI_SEMI] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1133),
    [anon_sym_AMP_GT] = ACTIONS(1133),
    [anon_sym_AMP_GT_GT] = ACTIONS(1133),
    [anon_sym_LT_AMP] = ACTIONS(1133),
    [anon_sym_GT_AMP] = ACTIONS(1133),
    [sym__special_characters] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1133),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1133),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_LF] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1133),
  },
  [215] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(572),
    [anon_sym_DQUOTE] = ACTIONS(1135),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [216] = {
    [sym_string] = STATE(574),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(1137),
    [sym_raw_string] = ACTIONS(1139),
    [anon_sym_POUND] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(1137),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1141),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(1137),
    [anon_sym_QMARK] = ACTIONS(1137),
    [anon_sym_0] = ACTIONS(1143),
    [anon_sym__] = ACTIONS(1143),
  },
  [217] = {
    [aux_sym_concatenation_repeat1] = STATE(570),
    [sym_file_descriptor] = ACTIONS(1107),
    [sym__concat] = ACTIONS(1131),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1109),
    [anon_sym_GT] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_AMP] = ACTIONS(1109),
    [anon_sym_GT_AMP] = ACTIONS(1109),
    [sym__special_characters] = ACTIONS(1109),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1109),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_LT_LPAREN] = ACTIONS(1109),
    [anon_sym_GT_LPAREN] = ACTIONS(1109),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1109),
  },
  [218] = {
    [sym_subscript] = STATE(580),
    [sym_variable_name] = ACTIONS(1145),
    [anon_sym_DOLLAR] = ACTIONS(1147),
    [anon_sym_POUND] = ACTIONS(1149),
    [anon_sym_DASH] = ACTIONS(1147),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1147),
    [anon_sym_AT] = ACTIONS(1147),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_0] = ACTIONS(1153),
    [anon_sym__] = ACTIONS(1153),
  },
  [219] = {
    [sym_for_statement] = STATE(581),
    [sym_while_statement] = STATE(581),
    [sym_if_statement] = STATE(581),
    [sym_case_statement] = STATE(581),
    [sym_function_definition] = STATE(581),
    [sym_subshell] = STATE(581),
    [sym_pipeline] = STATE(581),
    [sym_list] = STATE(581),
    [sym_negated_command] = STATE(581),
    [sym_test_command] = STATE(581),
    [sym_declaration_command] = STATE(581),
    [sym_unset_command] = STATE(581),
    [sym_command] = STATE(581),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(582),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [220] = {
    [sym_for_statement] = STATE(583),
    [sym_while_statement] = STATE(583),
    [sym_if_statement] = STATE(583),
    [sym_case_statement] = STATE(583),
    [sym_function_definition] = STATE(583),
    [sym_subshell] = STATE(583),
    [sym_pipeline] = STATE(583),
    [sym_list] = STATE(583),
    [sym_negated_command] = STATE(583),
    [sym_test_command] = STATE(583),
    [sym_declaration_command] = STATE(583),
    [sym_unset_command] = STATE(583),
    [sym_command] = STATE(583),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(584),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [221] = {
    [sym_for_statement] = STATE(585),
    [sym_while_statement] = STATE(585),
    [sym_if_statement] = STATE(585),
    [sym_case_statement] = STATE(585),
    [sym_function_definition] = STATE(585),
    [sym_subshell] = STATE(585),
    [sym_pipeline] = STATE(585),
    [sym_list] = STATE(585),
    [sym_negated_command] = STATE(585),
    [sym_test_command] = STATE(585),
    [sym_declaration_command] = STATE(585),
    [sym_unset_command] = STATE(585),
    [sym_command] = STATE(585),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(586),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [222] = {
    [sym_concatenation] = STATE(595),
    [sym_string] = STATE(590),
    [sym_simple_expansion] = STATE(590),
    [sym_string_expansion] = STATE(590),
    [sym_expansion] = STATE(590),
    [sym_command_substitution] = STATE(590),
    [sym_process_substitution] = STATE(590),
    [aux_sym_for_statement_repeat1] = STATE(595),
    [sym__special_characters] = ACTIONS(1155),
    [anon_sym_DQUOTE] = ACTIONS(1157),
    [anon_sym_DOLLAR] = ACTIONS(1159),
    [sym_raw_string] = ACTIONS(1161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1163),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1165),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [anon_sym_LT_LPAREN] = ACTIONS(1169),
    [anon_sym_GT_LPAREN] = ACTIONS(1169),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1161),
  },
  [223] = {
    [sym_do_group] = STATE(597),
    [anon_sym_do] = ACTIONS(1171),
    [sym_comment] = ACTIONS(53),
  },
  [224] = {
    [sym__terminated_statement] = STATE(601),
    [sym_for_statement] = STATE(599),
    [sym_while_statement] = STATE(599),
    [sym_if_statement] = STATE(599),
    [sym_case_statement] = STATE(599),
    [sym_function_definition] = STATE(599),
    [sym_subshell] = STATE(599),
    [sym_pipeline] = STATE(599),
    [sym_list] = STATE(599),
    [sym_negated_command] = STATE(599),
    [sym_test_command] = STATE(599),
    [sym_declaration_command] = STATE(599),
    [sym_unset_command] = STATE(599),
    [sym_command] = STATE(599),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(600),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(601),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_done] = ACTIONS(1173),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [225] = {
    [sym_file_redirect] = STATE(603),
    [sym_heredoc_redirect] = STATE(603),
    [sym_heredoc_body] = STATE(602),
    [sym_herestring_redirect] = STATE(603),
    [aux_sym_while_statement_repeat1] = STATE(603),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(1175),
    [anon_sym_SEMI_SEMI] = ACTIONS(1175),
    [anon_sym_PIPE_AMP] = ACTIONS(1175),
    [anon_sym_AMP_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1175),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(347),
    [anon_sym_AMP_GT] = ACTIONS(347),
    [anon_sym_AMP_GT_GT] = ACTIONS(347),
    [anon_sym_LT_AMP] = ACTIONS(347),
    [anon_sym_GT_AMP] = ACTIONS(347),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(351),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1175),
    [anon_sym_LF] = ACTIONS(1177),
    [anon_sym_AMP] = ACTIONS(1175),
  },
  [226] = {
    [anon_sym_do] = ACTIONS(951),
    [anon_sym_then] = ACTIONS(951),
    [sym_comment] = ACTIONS(53),
  },
  [227] = {
    [sym__terminated_statement] = STATE(611),
    [sym_for_statement] = STATE(607),
    [sym_while_statement] = STATE(607),
    [sym_if_statement] = STATE(607),
    [sym_elif_clause] = STATE(608),
    [sym_else_clause] = STATE(609),
    [sym_case_statement] = STATE(607),
    [sym_function_definition] = STATE(607),
    [sym_subshell] = STATE(607),
    [sym_pipeline] = STATE(607),
    [sym_list] = STATE(607),
    [sym_negated_command] = STATE(607),
    [sym_test_command] = STATE(607),
    [sym_declaration_command] = STATE(607),
    [sym_unset_command] = STATE(607),
    [sym_command] = STATE(607),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(610),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(611),
    [aux_sym_if_statement_repeat1] = STATE(612),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(1179),
    [anon_sym_elif] = ACTIONS(1181),
    [anon_sym_else] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [228] = {
    [sym_string] = STATE(613),
    [sym_simple_expansion] = STATE(613),
    [sym_string_expansion] = STATE(613),
    [sym_expansion] = STATE(613),
    [sym_command_substitution] = STATE(613),
    [sym_process_substitution] = STATE(613),
    [sym__special_characters] = ACTIONS(1185),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [anon_sym_DOLLAR] = ACTIONS(71),
    [sym_raw_string] = ACTIONS(1185),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(75),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(77),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [anon_sym_LT_LPAREN] = ACTIONS(81),
    [anon_sym_GT_LPAREN] = ACTIONS(81),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1185),
  },
  [229] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1189),
    [anon_sym_AMP] = ACTIONS(1187),
  },
  [230] = {
    [anon_sym_in] = ACTIONS(1191),
    [sym_comment] = ACTIONS(53),
  },
  [231] = {
    [aux_sym_concatenation_repeat1] = STATE(616),
    [sym__concat] = ACTIONS(419),
    [anon_sym_in] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [232] = {
    [sym__concat] = ACTIONS(697),
    [anon_sym_in] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_LF] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [233] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(1193),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [234] = {
    [sym__concat] = ACTIONS(727),
    [anon_sym_in] = ACTIONS(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_LF] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
  },
  [235] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [236] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_in] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [237] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1195),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1195),
    [anon_sym_LF] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1195),
  },
  [238] = {
    [anon_sym_in] = ACTIONS(1199),
    [sym_comment] = ACTIONS(53),
  },
  [239] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(1201),
    [sym_comment] = ACTIONS(53),
  },
  [240] = {
    [sym_concatenation] = STATE(623),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(623),
    [anon_sym_RBRACE] = ACTIONS(1203),
    [anon_sym_EQ] = ACTIONS(1205),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1209),
    [anon_sym_COLON] = ACTIONS(1205),
    [anon_sym_COLON_QMARK] = ACTIONS(1205),
    [anon_sym_COLON_DASH] = ACTIONS(1205),
    [anon_sym_PERCENT] = ACTIONS(1205),
    [anon_sym_DASH] = ACTIONS(1205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [241] = {
    [sym_subscript] = STATE(627),
    [sym_variable_name] = ACTIONS(1211),
    [anon_sym_DOLLAR] = ACTIONS(1213),
    [anon_sym_DASH] = ACTIONS(1213),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1215),
    [anon_sym_STAR] = ACTIONS(1213),
    [anon_sym_AT] = ACTIONS(1213),
    [anon_sym_QMARK] = ACTIONS(1213),
    [anon_sym_0] = ACTIONS(1217),
    [anon_sym__] = ACTIONS(1217),
  },
  [242] = {
    [sym_concatenation] = STATE(630),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(630),
    [anon_sym_RBRACE] = ACTIONS(1219),
    [anon_sym_EQ] = ACTIONS(1221),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1223),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1225),
    [anon_sym_COLON] = ACTIONS(1221),
    [anon_sym_COLON_QMARK] = ACTIONS(1221),
    [anon_sym_COLON_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [243] = {
    [sym_concatenation] = STATE(633),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(633),
    [anon_sym_RBRACE] = ACTIONS(1227),
    [anon_sym_EQ] = ACTIONS(1229),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1233),
    [anon_sym_COLON] = ACTIONS(1229),
    [anon_sym_COLON_QMARK] = ACTIONS(1229),
    [anon_sym_COLON_DASH] = ACTIONS(1229),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_DASH] = ACTIONS(1229),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [244] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1235),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [245] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1235),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [246] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [sym_comment] = ACTIONS(53),
  },
  [247] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [248] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1237),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [249] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1237),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [250] = {
    [anon_sym_RPAREN] = ACTIONS(1239),
    [sym_comment] = ACTIONS(53),
  },
  [251] = {
    [sym__terminated_statement] = STATE(640),
    [sym_for_statement] = STATE(638),
    [sym_while_statement] = STATE(638),
    [sym_if_statement] = STATE(638),
    [sym_case_statement] = STATE(638),
    [sym_function_definition] = STATE(638),
    [sym_subshell] = STATE(638),
    [sym_pipeline] = STATE(638),
    [sym_list] = STATE(638),
    [sym_negated_command] = STATE(638),
    [sym_test_command] = STATE(638),
    [sym_declaration_command] = STATE(638),
    [sym_unset_command] = STATE(638),
    [sym_command] = STATE(638),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(639),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(640),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [252] = {
    [sym_file_redirect] = STATE(643),
    [sym_file_descriptor] = ACTIONS(1243),
    [anon_sym_PIPE] = ACTIONS(1245),
    [anon_sym_SEMI_SEMI] = ACTIONS(1245),
    [anon_sym_PIPE_AMP] = ACTIONS(1245),
    [anon_sym_AMP_AMP] = ACTIONS(1245),
    [anon_sym_PIPE_PIPE] = ACTIONS(1245),
    [anon_sym_LT] = ACTIONS(1247),
    [anon_sym_GT] = ACTIONS(1247),
    [anon_sym_GT_GT] = ACTIONS(1247),
    [anon_sym_AMP_GT] = ACTIONS(1247),
    [anon_sym_AMP_GT_GT] = ACTIONS(1247),
    [anon_sym_LT_AMP] = ACTIONS(1247),
    [anon_sym_GT_AMP] = ACTIONS(1247),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1245),
    [anon_sym_LF] = ACTIONS(1249),
    [anon_sym_AMP] = ACTIONS(1245),
  },
  [253] = {
    [sym_concatenation] = STATE(212),
    [sym_string] = STATE(645),
    [sym_array] = STATE(212),
    [sym_simple_expansion] = STATE(645),
    [sym_string_expansion] = STATE(645),
    [sym_expansion] = STATE(645),
    [sym_command_substitution] = STATE(645),
    [sym_process_substitution] = STATE(645),
    [sym__empty_value] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(387),
    [sym__special_characters] = ACTIONS(1251),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [sym_raw_string] = ACTIONS(1253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(397),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(399),
    [anon_sym_BQUOTE] = ACTIONS(401),
    [anon_sym_LT_LPAREN] = ACTIONS(403),
    [anon_sym_GT_LPAREN] = ACTIONS(403),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1253),
  },
  [254] = {
    [sym_do_group] = STATE(646),
    [anon_sym_do] = ACTIONS(411),
    [sym_comment] = ACTIONS(53),
  },
  [255] = {
    [sym_compound_statement] = STATE(648),
    [anon_sym_LPAREN] = ACTIONS(1255),
    [anon_sym_LBRACE] = ACTIONS(455),
    [sym_comment] = ACTIONS(53),
  },
  [256] = {
    [anon_sym_AMP_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(543),
    [anon_sym_RBRACK] = ACTIONS(1257),
    [anon_sym_EQ_TILDE] = ACTIONS(547),
    [anon_sym_EQ_EQ] = ACTIONS(547),
    [anon_sym_EQ] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_BANG_EQ] = ACTIONS(543),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(543),
  },
  [257] = {
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1257),
    [anon_sym_EQ_TILDE] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(577),
    [anon_sym_LT] = ACTIONS(573),
    [anon_sym_GT] = ACTIONS(573),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(573),
  },
  [258] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(1259),
    [anon_sym_PLUS_EQ] = ACTIONS(1259),
    [sym_comment] = ACTIONS(53),
  },
  [259] = {
    [aux_sym_concatenation_repeat1] = STATE(651),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(585),
    [anon_sym_RPAREN] = ACTIONS(585),
    [anon_sym_SEMI_SEMI] = ACTIONS(585),
    [anon_sym_PIPE_AMP] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(585),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [sym__special_characters] = ACTIONS(585),
    [anon_sym_DQUOTE] = ACTIONS(585),
    [anon_sym_DOLLAR] = ACTIONS(585),
    [sym_raw_string] = ACTIONS(585),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(585),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_LT_LPAREN] = ACTIONS(585),
    [anon_sym_GT_LPAREN] = ACTIONS(585),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(585),
    [sym_word] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(585),
    [anon_sym_LF] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(585),
  },
  [260] = {
    [aux_sym_concatenation_repeat1] = STATE(651),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(599),
    [anon_sym_PIPE] = ACTIONS(601),
    [anon_sym_RPAREN] = ACTIONS(601),
    [anon_sym_SEMI_SEMI] = ACTIONS(601),
    [anon_sym_PIPE_AMP] = ACTIONS(601),
    [anon_sym_AMP_AMP] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [anon_sym_DOLLAR] = ACTIONS(601),
    [sym_raw_string] = ACTIONS(601),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(601),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(601),
    [anon_sym_BQUOTE] = ACTIONS(601),
    [anon_sym_LT_LPAREN] = ACTIONS(601),
    [anon_sym_GT_LPAREN] = ACTIONS(601),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(601),
    [sym_word] = ACTIONS(601),
    [anon_sym_SEMI] = ACTIONS(601),
    [anon_sym_LF] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(601),
  },
  [261] = {
    [anon_sym_EQ] = ACTIONS(1259),
    [anon_sym_PLUS_EQ] = ACTIONS(1259),
    [sym_comment] = ACTIONS(53),
  },
  [262] = {
    [sym_variable_assignment] = STATE(652),
    [sym_subscript] = STATE(261),
    [sym_concatenation] = STATE(652),
    [sym_string] = STATE(260),
    [sym_simple_expansion] = STATE(260),
    [sym_string_expansion] = STATE(260),
    [sym_expansion] = STATE(260),
    [sym_command_substitution] = STATE(260),
    [sym_process_substitution] = STATE(260),
    [aux_sym_declaration_command_repeat1] = STATE(652),
    [sym_variable_name] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_RPAREN] = ACTIONS(617),
    [anon_sym_SEMI_SEMI] = ACTIONS(617),
    [anon_sym_PIPE_AMP] = ACTIONS(617),
    [anon_sym_AMP_AMP] = ACTIONS(617),
    [anon_sym_PIPE_PIPE] = ACTIONS(617),
    [sym__special_characters] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(179),
    [sym_word] = ACTIONS(465),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_LF] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(617),
  },
  [263] = {
    [aux_sym_concatenation_repeat1] = STATE(653),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(623),
    [anon_sym_RPAREN] = ACTIONS(623),
    [anon_sym_SEMI_SEMI] = ACTIONS(623),
    [anon_sym_PIPE_AMP] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(623),
    [sym__special_characters] = ACTIONS(623),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [sym_raw_string] = ACTIONS(623),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(623),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(623),
    [anon_sym_BQUOTE] = ACTIONS(623),
    [anon_sym_LT_LPAREN] = ACTIONS(623),
    [anon_sym_GT_LPAREN] = ACTIONS(623),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(623),
    [sym_word] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(623),
    [anon_sym_LF] = ACTIONS(625),
    [anon_sym_AMP] = ACTIONS(623),
  },
  [264] = {
    [aux_sym_concatenation_repeat1] = STATE(653),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(639),
    [anon_sym_RPAREN] = ACTIONS(639),
    [anon_sym_SEMI_SEMI] = ACTIONS(639),
    [anon_sym_PIPE_AMP] = ACTIONS(639),
    [anon_sym_AMP_AMP] = ACTIONS(639),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [sym__special_characters] = ACTIONS(639),
    [anon_sym_DQUOTE] = ACTIONS(639),
    [anon_sym_DOLLAR] = ACTIONS(639),
    [sym_raw_string] = ACTIONS(639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(639),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(639),
    [anon_sym_BQUOTE] = ACTIONS(639),
    [anon_sym_LT_LPAREN] = ACTIONS(639),
    [anon_sym_GT_LPAREN] = ACTIONS(639),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(639),
    [sym_word] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(639),
    [anon_sym_LF] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(639),
  },
  [265] = {
    [sym_concatenation] = STATE(654),
    [sym_string] = STATE(264),
    [sym_simple_expansion] = STATE(264),
    [sym_string_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [sym_command_substitution] = STATE(264),
    [sym_process_substitution] = STATE(264),
    [aux_sym_unset_command_repeat1] = STATE(654),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_RPAREN] = ACTIONS(657),
    [anon_sym_SEMI_SEMI] = ACTIONS(657),
    [anon_sym_PIPE_AMP] = ACTIONS(657),
    [anon_sym_AMP_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(657),
    [sym__special_characters] = ACTIONS(467),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(193),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(195),
    [anon_sym_BQUOTE] = ACTIONS(197),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(201),
    [sym_word] = ACTIONS(469),
    [anon_sym_SEMI] = ACTIONS(657),
    [anon_sym_LF] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(657),
  },
  [266] = {
    [aux_sym_concatenation_repeat1] = STATE(655),
    [sym__simple_heredoc_body] = ACTIONS(693),
    [sym__heredoc_body_beginning] = ACTIONS(693),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_EQ_TILDE] = ACTIONS(695),
    [anon_sym_EQ_EQ] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [267] = {
    [anon_sym_RPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(53),
  },
  [268] = {
    [sym_for_statement] = STATE(529),
    [sym_while_statement] = STATE(529),
    [sym_if_statement] = STATE(529),
    [sym_case_statement] = STATE(529),
    [sym_function_definition] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_pipeline] = STATE(529),
    [sym_list] = STATE(529),
    [sym_negated_command] = STATE(529),
    [sym_test_command] = STATE(529),
    [sym_declaration_command] = STATE(529),
    [sym_unset_command] = STATE(529),
    [sym_command] = STATE(529),
    [sym_command_name] = STATE(64),
    [sym_variable_assignment] = STATE(530),
    [sym_subscript] = STATE(66),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(61),
    [sym_simple_expansion] = STATE(61),
    [sym_string_expansion] = STATE(61),
    [sym_expansion] = STATE(61),
    [sym_command_substitution] = STATE(61),
    [sym_process_substitution] = STATE(61),
    [aux_sym_command_repeat1] = STATE(68),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(93),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_typeset] = ACTIONS(97),
    [anon_sym_export] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_local] = ACTIONS(97),
    [anon_sym_unset] = ACTIONS(99),
    [anon_sym_unsetenv] = ACTIONS(99),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(105),
  },
  [269] = {
    [anon_sym_esac] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE_AMP] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [270] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_RPAREN] = ACTIONS(1267),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(953),
    [anon_sym_DQUOTE] = ACTIONS(951),
    [anon_sym_DOLLAR] = ACTIONS(953),
    [sym_raw_string] = ACTIONS(951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(951),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(951),
    [anon_sym_BQUOTE] = ACTIONS(951),
    [anon_sym_LT_LPAREN] = ACTIONS(951),
    [anon_sym_GT_LPAREN] = ACTIONS(951),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(953),
  },
  [271] = {
    [sym_for_statement] = STATE(658),
    [sym_while_statement] = STATE(658),
    [sym_if_statement] = STATE(658),
    [sym_case_statement] = STATE(658),
    [sym_function_definition] = STATE(658),
    [sym_subshell] = STATE(658),
    [sym_pipeline] = STATE(658),
    [sym_list] = STATE(658),
    [sym_negated_command] = STATE(658),
    [sym_test_command] = STATE(658),
    [sym_declaration_command] = STATE(658),
    [sym_unset_command] = STATE(658),
    [sym_command] = STATE(658),
    [sym_command_name] = STATE(64),
    [sym_variable_assignment] = STATE(659),
    [sym_subscript] = STATE(66),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(61),
    [sym_simple_expansion] = STATE(61),
    [sym_string_expansion] = STATE(61),
    [sym_expansion] = STATE(61),
    [sym_command_substitution] = STATE(61),
    [sym_process_substitution] = STATE(61),
    [aux_sym_command_repeat1] = STATE(68),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(93),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_typeset] = ACTIONS(97),
    [anon_sym_export] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_local] = ACTIONS(97),
    [anon_sym_unset] = ACTIONS(99),
    [anon_sym_unsetenv] = ACTIONS(99),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(105),
  },
  [272] = {
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [sym_comment] = ACTIONS(53),
  },
  [273] = {
    [sym_concatenation] = STATE(540),
    [sym_string] = STATE(662),
    [sym_simple_expansion] = STATE(662),
    [sym_string_expansion] = STATE(662),
    [sym_expansion] = STATE(662),
    [sym_command_substitution] = STATE(662),
    [sym_process_substitution] = STATE(662),
    [sym__special_characters] = ACTIONS(1273),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(1275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1275),
    [sym_regex] = ACTIONS(975),
  },
  [274] = {
    [sym_concatenation] = STATE(543),
    [sym_string] = STATE(664),
    [sym_simple_expansion] = STATE(664),
    [sym_string_expansion] = STATE(664),
    [sym_expansion] = STATE(664),
    [sym_command_substitution] = STATE(664),
    [sym_process_substitution] = STATE(664),
    [sym__special_characters] = ACTIONS(1277),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(1279),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1279),
  },
  [275] = {
    [sym_concatenation] = STATE(547),
    [sym_string] = STATE(666),
    [sym_simple_expansion] = STATE(666),
    [sym_string_expansion] = STATE(666),
    [sym_expansion] = STATE(666),
    [sym_command_substitution] = STATE(666),
    [sym_process_substitution] = STATE(666),
    [sym__special_characters] = ACTIONS(1281),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(1283),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1283),
  },
  [276] = {
    [aux_sym_concatenation_repeat1] = STATE(266),
    [sym__simple_heredoc_body] = ACTIONS(987),
    [sym__heredoc_body_beginning] = ACTIONS(987),
    [sym_file_descriptor] = ACTIONS(987),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(989),
    [anon_sym_RPAREN] = ACTIONS(989),
    [anon_sym_SEMI_SEMI] = ACTIONS(989),
    [anon_sym_PIPE_AMP] = ACTIONS(989),
    [anon_sym_AMP_AMP] = ACTIONS(989),
    [anon_sym_PIPE_PIPE] = ACTIONS(989),
    [anon_sym_EQ_TILDE] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(989),
    [anon_sym_LT] = ACTIONS(989),
    [anon_sym_GT] = ACTIONS(989),
    [anon_sym_GT_GT] = ACTIONS(989),
    [anon_sym_AMP_GT] = ACTIONS(989),
    [anon_sym_AMP_GT_GT] = ACTIONS(989),
    [anon_sym_LT_AMP] = ACTIONS(989),
    [anon_sym_GT_AMP] = ACTIONS(989),
    [anon_sym_LT_LT] = ACTIONS(989),
    [anon_sym_LT_LT_DASH] = ACTIONS(989),
    [anon_sym_LT_LT_LT] = ACTIONS(989),
    [sym__special_characters] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(989),
    [anon_sym_DOLLAR] = ACTIONS(989),
    [sym_raw_string] = ACTIONS(989),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(989),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(989),
    [anon_sym_BQUOTE] = ACTIONS(989),
    [anon_sym_LT_LPAREN] = ACTIONS(989),
    [anon_sym_GT_LPAREN] = ACTIONS(989),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(989),
    [anon_sym_SEMI] = ACTIONS(989),
    [anon_sym_LF] = ACTIONS(987),
    [anon_sym_AMP] = ACTIONS(989),
  },
  [277] = {
    [aux_sym_concatenation_repeat1] = STATE(266),
    [sym__simple_heredoc_body] = ACTIONS(991),
    [sym__heredoc_body_beginning] = ACTIONS(991),
    [sym_file_descriptor] = ACTIONS(991),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_RPAREN] = ACTIONS(993),
    [anon_sym_SEMI_SEMI] = ACTIONS(993),
    [anon_sym_PIPE_AMP] = ACTIONS(993),
    [anon_sym_AMP_AMP] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT] = ACTIONS(993),
    [anon_sym_GT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(993),
    [anon_sym_AMP_GT] = ACTIONS(993),
    [anon_sym_AMP_GT_GT] = ACTIONS(993),
    [anon_sym_LT_AMP] = ACTIONS(993),
    [anon_sym_GT_AMP] = ACTIONS(993),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_LT_LT_DASH] = ACTIONS(993),
    [anon_sym_LT_LT_LT] = ACTIONS(993),
    [sym__special_characters] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(993),
    [anon_sym_DOLLAR] = ACTIONS(993),
    [sym_raw_string] = ACTIONS(993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(993),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(993),
    [anon_sym_LT_LPAREN] = ACTIONS(993),
    [anon_sym_GT_LPAREN] = ACTIONS(993),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(993),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_LF] = ACTIONS(991),
    [anon_sym_AMP] = ACTIONS(993),
  },
  [278] = {
    [sym_file_redirect] = STATE(667),
    [sym_heredoc_redirect] = STATE(667),
    [sym_heredoc_body] = STATE(548),
    [sym_herestring_redirect] = STATE(667),
    [aux_sym_while_statement_repeat1] = STATE(667),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(995),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(487),
    [anon_sym_GT_GT] = ACTIONS(487),
    [anon_sym_AMP_GT] = ACTIONS(487),
    [anon_sym_AMP_GT_GT] = ACTIONS(487),
    [anon_sym_LT_AMP] = ACTIONS(487),
    [anon_sym_GT_AMP] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(489),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(995),
  },
  [279] = {
    [sym_file_redirect] = STATE(668),
    [sym_heredoc_redirect] = STATE(668),
    [sym_heredoc_body] = STATE(548),
    [sym_herestring_redirect] = STATE(668),
    [sym_concatenation] = STATE(669),
    [sym_string] = STATE(277),
    [sym_simple_expansion] = STATE(277),
    [sym_string_expansion] = STATE(277),
    [sym_expansion] = STATE(277),
    [sym_command_substitution] = STATE(277),
    [sym_process_substitution] = STATE(277),
    [aux_sym_while_statement_repeat1] = STATE(668),
    [aux_sym_command_repeat2] = STATE(669),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(995),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_EQ_TILDE] = ACTIONS(485),
    [anon_sym_EQ_EQ] = ACTIONS(485),
    [anon_sym_LT] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(487),
    [anon_sym_GT_GT] = ACTIONS(487),
    [anon_sym_AMP_GT] = ACTIONS(487),
    [anon_sym_AMP_GT_GT] = ACTIONS(487),
    [anon_sym_LT_AMP] = ACTIONS(487),
    [anon_sym_GT_AMP] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(489),
    [sym__special_characters] = ACTIONS(491),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(493),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(995),
  },
  [280] = {
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1287),
    [anon_sym_PIPE_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1287),
    [anon_sym_LF] = ACTIONS(1289),
    [anon_sym_AMP] = ACTIONS(1287),
  },
  [281] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1287),
    [anon_sym_PIPE_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(1287),
    [anon_sym_LF] = ACTIONS(1289),
    [anon_sym_AMP] = ACTIONS(1287),
  },
  [282] = {
    [sym__terminated_statement] = STATE(282),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(282),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(999),
    [sym_variable_name] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1010),
    [anon_sym_if] = ACTIONS(1013),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1031),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_typeset] = ACTIONS(1034),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_local] = ACTIONS(1034),
    [anon_sym_unset] = ACTIONS(1037),
    [anon_sym_unsetenv] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_GT_GT] = ACTIONS(1043),
    [anon_sym_AMP_GT] = ACTIONS(1040),
    [anon_sym_AMP_GT_GT] = ACTIONS(1043),
    [anon_sym_LT_AMP] = ACTIONS(1043),
    [anon_sym_GT_AMP] = ACTIONS(1043),
    [sym__special_characters] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [sym_raw_string] = ACTIONS(1055),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1064),
    [anon_sym_LT_LPAREN] = ACTIONS(1067),
    [anon_sym_GT_LPAREN] = ACTIONS(1067),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1070),
  },
  [283] = {
    [sym_file_redirect] = STATE(668),
    [sym_heredoc_redirect] = STATE(668),
    [sym_heredoc_body] = STATE(548),
    [sym_herestring_redirect] = STATE(668),
    [sym_concatenation] = STATE(671),
    [sym_string] = STATE(277),
    [sym_simple_expansion] = STATE(277),
    [sym_string_expansion] = STATE(277),
    [sym_expansion] = STATE(277),
    [sym_command_substitution] = STATE(277),
    [sym_process_substitution] = STATE(277),
    [aux_sym_while_statement_repeat1] = STATE(668),
    [aux_sym_command_repeat2] = STATE(671),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(995),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_EQ_TILDE] = ACTIONS(485),
    [anon_sym_EQ_EQ] = ACTIONS(485),
    [anon_sym_LT] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(487),
    [anon_sym_GT_GT] = ACTIONS(487),
    [anon_sym_AMP_GT] = ACTIONS(487),
    [anon_sym_AMP_GT_GT] = ACTIONS(487),
    [anon_sym_LT_AMP] = ACTIONS(487),
    [anon_sym_GT_AMP] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(489),
    [sym__special_characters] = ACTIONS(491),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(493),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(995),
  },
  [284] = {
    [sym_concatenation] = STATE(672),
    [sym_string] = STATE(675),
    [sym_array] = STATE(672),
    [sym_simple_expansion] = STATE(675),
    [sym_string_expansion] = STATE(675),
    [sym_expansion] = STATE(675),
    [sym_command_substitution] = STATE(675),
    [sym_process_substitution] = STATE(675),
    [sym__empty_value] = ACTIONS(1291),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [sym__special_characters] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(1297),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1297),
  },
  [285] = {
    [sym__expression] = STATE(676),
    [sym_binary_expression] = STATE(676),
    [sym_unary_expression] = STATE(676),
    [sym_parenthesized_expression] = STATE(676),
    [sym_concatenation] = STATE(676),
    [sym_string] = STATE(287),
    [sym_simple_expansion] = STATE(287),
    [sym_string_expansion] = STATE(287),
    [sym_expansion] = STATE(287),
    [sym_command_substitution] = STATE(287),
    [sym_process_substitution] = STATE(287),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(503),
    [sym__special_characters] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(507),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(509),
    [sym_test_operator] = ACTIONS(511),
  },
  [286] = {
    [aux_sym_concatenation_repeat1] = STATE(677),
    [sym__concat] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(515),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_EQ_TILDE] = ACTIONS(515),
    [anon_sym_EQ_EQ] = ACTIONS(515),
    [anon_sym_EQ] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(515),
    [anon_sym_GT] = ACTIONS(515),
    [anon_sym_BANG_EQ] = ACTIONS(515),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(515),
  },
  [287] = {
    [aux_sym_concatenation_repeat1] = STATE(677),
    [sym__concat] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_EQ_TILDE] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(529),
    [anon_sym_EQ] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(529),
    [anon_sym_GT] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(529),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(529),
  },
  [288] = {
    [anon_sym_RPAREN] = ACTIONS(1299),
    [anon_sym_AMP_AMP] = ACTIONS(1301),
    [anon_sym_PIPE_PIPE] = ACTIONS(1301),
    [anon_sym_EQ_TILDE] = ACTIONS(1303),
    [anon_sym_EQ_EQ] = ACTIONS(1303),
    [anon_sym_EQ] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1301),
    [anon_sym_GT] = ACTIONS(1301),
    [anon_sym_BANG_EQ] = ACTIONS(1301),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1301),
  },
  [289] = {
    [anon_sym_AMP_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(543),
    [anon_sym_RBRACK] = ACTIONS(1307),
    [anon_sym_EQ_TILDE] = ACTIONS(547),
    [anon_sym_EQ_EQ] = ACTIONS(547),
    [anon_sym_EQ] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_BANG_EQ] = ACTIONS(543),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(543),
  },
  [290] = {
    [sym_string] = STATE(681),
    [sym_simple_expansion] = STATE(681),
    [sym_string_expansion] = STATE(681),
    [sym_expansion] = STATE(681),
    [sym_command_substitution] = STATE(681),
    [sym_process_substitution] = STATE(681),
    [sym__special_characters] = ACTIONS(1309),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(1309),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1309),
  },
  [291] = {
    [aux_sym_concatenation_repeat1] = STATE(682),
    [sym__concat] = ACTIONS(513),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_RBRACK] = ACTIONS(693),
    [anon_sym_EQ_TILDE] = ACTIONS(693),
    [anon_sym_EQ_EQ] = ACTIONS(693),
    [anon_sym_EQ] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(693),
    [anon_sym_GT] = ACTIONS(693),
    [anon_sym_BANG_EQ] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(693),
  },
  [292] = {
    [sym__concat] = ACTIONS(697),
    [anon_sym_AMP_AMP] = ACTIONS(697),
    [anon_sym_PIPE_PIPE] = ACTIONS(697),
    [anon_sym_RBRACK] = ACTIONS(697),
    [anon_sym_EQ_TILDE] = ACTIONS(697),
    [anon_sym_EQ_EQ] = ACTIONS(697),
    [anon_sym_EQ] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_BANG_EQ] = ACTIONS(697),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(697),
  },
  [293] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(1311),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [294] = {
    [sym__concat] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(727),
    [anon_sym_PIPE_PIPE] = ACTIONS(727),
    [anon_sym_RBRACK] = ACTIONS(727),
    [anon_sym_EQ_TILDE] = ACTIONS(727),
    [anon_sym_EQ_EQ] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(729),
    [anon_sym_LT] = ACTIONS(727),
    [anon_sym_GT] = ACTIONS(727),
    [anon_sym_BANG_EQ] = ACTIONS(727),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(727),
  },
  [295] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_RBRACK] = ACTIONS(731),
    [anon_sym_EQ_TILDE] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(731),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_BANG_EQ] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(731),
  },
  [296] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_RBRACK] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(735),
  },
  [297] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(1313),
    [sym_comment] = ACTIONS(53),
  },
  [298] = {
    [sym_concatenation] = STATE(687),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(687),
    [anon_sym_RBRACE] = ACTIONS(1315),
    [anon_sym_EQ] = ACTIONS(1317),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1321),
    [anon_sym_COLON] = ACTIONS(1317),
    [anon_sym_COLON_QMARK] = ACTIONS(1317),
    [anon_sym_COLON_DASH] = ACTIONS(1317),
    [anon_sym_PERCENT] = ACTIONS(1317),
    [anon_sym_DASH] = ACTIONS(1317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [299] = {
    [sym_subscript] = STATE(691),
    [sym_variable_name] = ACTIONS(1323),
    [anon_sym_DOLLAR] = ACTIONS(1325),
    [anon_sym_DASH] = ACTIONS(1325),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_AT] = ACTIONS(1325),
    [anon_sym_QMARK] = ACTIONS(1325),
    [anon_sym_0] = ACTIONS(1329),
    [anon_sym__] = ACTIONS(1329),
  },
  [300] = {
    [sym_concatenation] = STATE(694),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(694),
    [anon_sym_RBRACE] = ACTIONS(1331),
    [anon_sym_EQ] = ACTIONS(1333),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1337),
    [anon_sym_COLON] = ACTIONS(1333),
    [anon_sym_COLON_QMARK] = ACTIONS(1333),
    [anon_sym_COLON_DASH] = ACTIONS(1333),
    [anon_sym_PERCENT] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [301] = {
    [sym_concatenation] = STATE(697),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(697),
    [anon_sym_RBRACE] = ACTIONS(1339),
    [anon_sym_EQ] = ACTIONS(1341),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1343),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1345),
    [anon_sym_COLON] = ACTIONS(1341),
    [anon_sym_COLON_QMARK] = ACTIONS(1341),
    [anon_sym_COLON_DASH] = ACTIONS(1341),
    [anon_sym_PERCENT] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [302] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1347),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [303] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1347),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [304] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(1347),
    [sym_comment] = ACTIONS(53),
  },
  [305] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(1347),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [306] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1349),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [307] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1349),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [308] = {
    [sym__expression] = STATE(700),
    [sym_binary_expression] = STATE(700),
    [sym_unary_expression] = STATE(700),
    [sym_parenthesized_expression] = STATE(700),
    [sym_concatenation] = STATE(700),
    [sym_string] = STATE(77),
    [sym_simple_expansion] = STATE(77),
    [sym_string_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [sym_process_substitution] = STATE(77),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(111),
    [sym__special_characters] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
    [sym_test_operator] = ACTIONS(131),
  },
  [309] = {
    [sym_file_redirect] = STATE(705),
    [sym_heredoc_redirect] = STATE(705),
    [sym_herestring_redirect] = STATE(705),
    [aux_sym_while_statement_repeat1] = STATE(705),
    [sym_file_descriptor] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1353),
    [anon_sym_SEMI_SEMI] = ACTIONS(1353),
    [anon_sym_PIPE_AMP] = ACTIONS(1353),
    [anon_sym_AMP_AMP] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1353),
    [anon_sym_LT] = ACTIONS(1355),
    [anon_sym_GT] = ACTIONS(1355),
    [anon_sym_GT_GT] = ACTIONS(1355),
    [anon_sym_AMP_GT] = ACTIONS(1355),
    [anon_sym_AMP_GT_GT] = ACTIONS(1355),
    [anon_sym_LT_AMP] = ACTIONS(1355),
    [anon_sym_GT_AMP] = ACTIONS(1355),
    [anon_sym_LT_LT] = ACTIONS(1357),
    [anon_sym_LT_LT_DASH] = ACTIONS(1357),
    [anon_sym_LT_LT_LT] = ACTIONS(1359),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1353),
    [anon_sym_LF] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1353),
  },
  [310] = {
    [sym__expression] = STATE(700),
    [sym_binary_expression] = STATE(700),
    [sym_unary_expression] = STATE(700),
    [sym_parenthesized_expression] = STATE(700),
    [sym_concatenation] = STATE(700),
    [sym_string] = STATE(77),
    [sym_simple_expansion] = STATE(77),
    [sym_string_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [sym_process_substitution] = STATE(77),
    [anon_sym_LPAREN] = ACTIONS(1363),
    [anon_sym_BANG] = ACTIONS(111),
    [sym__special_characters] = ACTIONS(1365),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1375),
    [anon_sym_GT_LPAREN] = ACTIONS(1375),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(129),
    [sym_test_operator] = ACTIONS(111),
    [sym_regex] = ACTIONS(1377),
  },
  [311] = {
    [anon_sym_RPAREN] = ACTIONS(1379),
    [anon_sym_AMP_AMP] = ACTIONS(1301),
    [anon_sym_PIPE_PIPE] = ACTIONS(1301),
    [anon_sym_EQ_TILDE] = ACTIONS(1303),
    [anon_sym_EQ_EQ] = ACTIONS(1303),
    [anon_sym_EQ] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1301),
    [anon_sym_GT] = ACTIONS(1301),
    [anon_sym_BANG_EQ] = ACTIONS(1301),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1301),
  },
  [312] = {
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1307),
    [anon_sym_EQ_TILDE] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(577),
    [anon_sym_LT] = ACTIONS(573),
    [anon_sym_GT] = ACTIONS(573),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(573),
  },
  [313] = {
    [sym_string] = STATE(708),
    [sym_simple_expansion] = STATE(708),
    [sym_string_expansion] = STATE(708),
    [sym_expansion] = STATE(708),
    [sym_command_substitution] = STATE(708),
    [sym_process_substitution] = STATE(708),
    [sym__special_characters] = ACTIONS(1381),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(1381),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1381),
  },
  [314] = {
    [aux_sym_concatenation_repeat1] = STATE(709),
    [sym__concat] = ACTIONS(551),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(693),
    [anon_sym_EQ_TILDE] = ACTIONS(693),
    [anon_sym_EQ_EQ] = ACTIONS(693),
    [anon_sym_EQ] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(693),
    [anon_sym_GT] = ACTIONS(693),
    [anon_sym_BANG_EQ] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(693),
  },
  [315] = {
    [sym__concat] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(697),
    [anon_sym_AMP_AMP] = ACTIONS(697),
    [anon_sym_PIPE_PIPE] = ACTIONS(697),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(697),
    [anon_sym_EQ_TILDE] = ACTIONS(697),
    [anon_sym_EQ_EQ] = ACTIONS(697),
    [anon_sym_EQ] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_BANG_EQ] = ACTIONS(697),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(697),
  },
  [316] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(1383),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [317] = {
    [sym__concat] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(727),
    [anon_sym_PIPE_PIPE] = ACTIONS(727),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(727),
    [anon_sym_EQ_TILDE] = ACTIONS(727),
    [anon_sym_EQ_EQ] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(729),
    [anon_sym_LT] = ACTIONS(727),
    [anon_sym_GT] = ACTIONS(727),
    [anon_sym_BANG_EQ] = ACTIONS(727),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(727),
  },
  [318] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(731),
    [anon_sym_EQ_TILDE] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(731),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_BANG_EQ] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(731),
  },
  [319] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(735),
  },
  [320] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(1385),
    [sym_comment] = ACTIONS(53),
  },
  [321] = {
    [sym_concatenation] = STATE(714),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(714),
    [anon_sym_RBRACE] = ACTIONS(1387),
    [anon_sym_EQ] = ACTIONS(1389),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1391),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1393),
    [anon_sym_COLON] = ACTIONS(1389),
    [anon_sym_COLON_QMARK] = ACTIONS(1389),
    [anon_sym_COLON_DASH] = ACTIONS(1389),
    [anon_sym_PERCENT] = ACTIONS(1389),
    [anon_sym_DASH] = ACTIONS(1389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [322] = {
    [sym_subscript] = STATE(718),
    [sym_variable_name] = ACTIONS(1395),
    [anon_sym_DOLLAR] = ACTIONS(1397),
    [anon_sym_DASH] = ACTIONS(1397),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1399),
    [anon_sym_STAR] = ACTIONS(1397),
    [anon_sym_AT] = ACTIONS(1397),
    [anon_sym_QMARK] = ACTIONS(1397),
    [anon_sym_0] = ACTIONS(1401),
    [anon_sym__] = ACTIONS(1401),
  },
  [323] = {
    [sym_concatenation] = STATE(721),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(721),
    [anon_sym_RBRACE] = ACTIONS(1403),
    [anon_sym_EQ] = ACTIONS(1405),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(1405),
    [anon_sym_COLON_QMARK] = ACTIONS(1405),
    [anon_sym_COLON_DASH] = ACTIONS(1405),
    [anon_sym_PERCENT] = ACTIONS(1405),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [324] = {
    [sym_concatenation] = STATE(724),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(724),
    [anon_sym_RBRACE] = ACTIONS(1411),
    [anon_sym_EQ] = ACTIONS(1413),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1415),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1417),
    [anon_sym_COLON] = ACTIONS(1413),
    [anon_sym_COLON_QMARK] = ACTIONS(1413),
    [anon_sym_COLON_DASH] = ACTIONS(1413),
    [anon_sym_PERCENT] = ACTIONS(1413),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [325] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1419),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [326] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1419),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [327] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [sym_comment] = ACTIONS(53),
  },
  [328] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [329] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1421),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [330] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1421),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [331] = {
    [sym__expression] = STATE(727),
    [sym_binary_expression] = STATE(727),
    [sym_unary_expression] = STATE(727),
    [sym_parenthesized_expression] = STATE(727),
    [sym_concatenation] = STATE(727),
    [sym_string] = STATE(88),
    [sym_simple_expansion] = STATE(88),
    [sym_string_expansion] = STATE(88),
    [sym_expansion] = STATE(88),
    [sym_command_substitution] = STATE(88),
    [sym_process_substitution] = STATE(88),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(155),
  },
  [332] = {
    [sym__expression] = STATE(727),
    [sym_binary_expression] = STATE(727),
    [sym_unary_expression] = STATE(727),
    [sym_parenthesized_expression] = STATE(727),
    [sym_concatenation] = STATE(727),
    [sym_string] = STATE(88),
    [sym_simple_expansion] = STATE(88),
    [sym_string_expansion] = STATE(88),
    [sym_expansion] = STATE(88),
    [sym_command_substitution] = STATE(88),
    [sym_process_substitution] = STATE(88),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(1425),
    [anon_sym_DQUOTE] = ACTIONS(1427),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(153),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1431),
    [anon_sym_BQUOTE] = ACTIONS(1433),
    [anon_sym_LT_LPAREN] = ACTIONS(1435),
    [anon_sym_GT_LPAREN] = ACTIONS(1435),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(135),
    [sym_regex] = ACTIONS(1437),
  },
  [333] = {
    [sym_concatenation] = STATE(729),
    [sym_string] = STATE(732),
    [sym_array] = STATE(729),
    [sym_simple_expansion] = STATE(732),
    [sym_string_expansion] = STATE(732),
    [sym_expansion] = STATE(732),
    [sym_command_substitution] = STATE(732),
    [sym_process_substitution] = STATE(732),
    [sym__empty_value] = ACTIONS(1439),
    [anon_sym_LPAREN] = ACTIONS(1441),
    [sym__special_characters] = ACTIONS(1443),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(1445),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1447),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1449),
    [anon_sym_BQUOTE] = ACTIONS(1451),
    [anon_sym_LT_LPAREN] = ACTIONS(1453),
    [anon_sym_GT_LPAREN] = ACTIONS(1453),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1445),
  },
  [334] = {
    [sym_string] = STATE(733),
    [sym_simple_expansion] = STATE(733),
    [sym_string_expansion] = STATE(733),
    [sym_expansion] = STATE(733),
    [sym_command_substitution] = STATE(733),
    [sym_process_substitution] = STATE(733),
    [sym__special_characters] = ACTIONS(1455),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(1455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1447),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1449),
    [anon_sym_BQUOTE] = ACTIONS(1451),
    [anon_sym_LT_LPAREN] = ACTIONS(1453),
    [anon_sym_GT_LPAREN] = ACTIONS(1453),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1455),
  },
  [335] = {
    [aux_sym_concatenation_repeat1] = STATE(734),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(695),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [336] = {
    [sym__concat] = ACTIONS(697),
    [sym_variable_name] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(699),
    [sym_word] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_LF] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [337] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(1457),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [338] = {
    [sym__concat] = ACTIONS(727),
    [sym_variable_name] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(729),
    [anon_sym_PIPE_AMP] = ACTIONS(729),
    [anon_sym_AMP_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(729),
    [sym__special_characters] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(729),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(729),
    [anon_sym_BQUOTE] = ACTIONS(729),
    [anon_sym_LT_LPAREN] = ACTIONS(729),
    [anon_sym_GT_LPAREN] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(729),
    [sym_word] = ACTIONS(729),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_LF] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
  },
  [339] = {
    [sym__concat] = ACTIONS(731),
    [sym_variable_name] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [sym__special_characters] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [anon_sym_LT_LPAREN] = ACTIONS(733),
    [anon_sym_GT_LPAREN] = ACTIONS(733),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(733),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [340] = {
    [sym__concat] = ACTIONS(735),
    [sym_variable_name] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(737),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__special_characters] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [anon_sym_LT_LPAREN] = ACTIONS(737),
    [anon_sym_GT_LPAREN] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(737),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [341] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(1459),
    [sym_comment] = ACTIONS(53),
  },
  [342] = {
    [sym_concatenation] = STATE(739),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(739),
    [anon_sym_RBRACE] = ACTIONS(1461),
    [anon_sym_EQ] = ACTIONS(1463),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1467),
    [anon_sym_COLON] = ACTIONS(1463),
    [anon_sym_COLON_QMARK] = ACTIONS(1463),
    [anon_sym_COLON_DASH] = ACTIONS(1463),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_DASH] = ACTIONS(1463),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [343] = {
    [sym_subscript] = STATE(743),
    [sym_variable_name] = ACTIONS(1469),
    [anon_sym_DOLLAR] = ACTIONS(1471),
    [anon_sym_DASH] = ACTIONS(1471),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_AT] = ACTIONS(1471),
    [anon_sym_QMARK] = ACTIONS(1471),
    [anon_sym_0] = ACTIONS(1475),
    [anon_sym__] = ACTIONS(1475),
  },
  [344] = {
    [sym_concatenation] = STATE(746),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(746),
    [anon_sym_RBRACE] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1479),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1483),
    [anon_sym_COLON] = ACTIONS(1479),
    [anon_sym_COLON_QMARK] = ACTIONS(1479),
    [anon_sym_COLON_DASH] = ACTIONS(1479),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [345] = {
    [sym_concatenation] = STATE(749),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(749),
    [anon_sym_RBRACE] = ACTIONS(1485),
    [anon_sym_EQ] = ACTIONS(1487),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1489),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1491),
    [anon_sym_COLON] = ACTIONS(1487),
    [anon_sym_COLON_QMARK] = ACTIONS(1487),
    [anon_sym_COLON_DASH] = ACTIONS(1487),
    [anon_sym_PERCENT] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [346] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1493),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [347] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1493),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [348] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(53),
  },
  [349] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(1493),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [350] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1495),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [351] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1495),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [352] = {
    [sym_variable_assignment] = STATE(352),
    [sym_subscript] = STATE(104),
    [sym_concatenation] = STATE(352),
    [sym_string] = STATE(98),
    [sym_simple_expansion] = STATE(98),
    [sym_string_expansion] = STATE(98),
    [sym_expansion] = STATE(98),
    [sym_command_substitution] = STATE(98),
    [sym_process_substitution] = STATE(98),
    [aux_sym_declaration_command_repeat1] = STATE(352),
    [sym_variable_name] = ACTIONS(1497),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_SEMI_SEMI] = ACTIONS(1500),
    [anon_sym_PIPE_AMP] = ACTIONS(1500),
    [anon_sym_AMP_AMP] = ACTIONS(1500),
    [anon_sym_PIPE_PIPE] = ACTIONS(1500),
    [sym__special_characters] = ACTIONS(1502),
    [anon_sym_DQUOTE] = ACTIONS(1505),
    [anon_sym_DOLLAR] = ACTIONS(1508),
    [sym_raw_string] = ACTIONS(1511),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1514),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1517),
    [anon_sym_BQUOTE] = ACTIONS(1520),
    [anon_sym_LT_LPAREN] = ACTIONS(1523),
    [anon_sym_GT_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1526),
    [sym_word] = ACTIONS(1511),
    [anon_sym_SEMI] = ACTIONS(1500),
    [anon_sym_LF] = ACTIONS(1529),
    [anon_sym_AMP] = ACTIONS(1500),
  },
  [353] = {
    [sym_string] = STATE(752),
    [sym_simple_expansion] = STATE(752),
    [sym_string_expansion] = STATE(752),
    [sym_expansion] = STATE(752),
    [sym_command_substitution] = STATE(752),
    [sym_process_substitution] = STATE(752),
    [sym__special_characters] = ACTIONS(1531),
    [anon_sym_DQUOTE] = ACTIONS(629),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(1531),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1533),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1535),
    [anon_sym_BQUOTE] = ACTIONS(1537),
    [anon_sym_LT_LPAREN] = ACTIONS(1539),
    [anon_sym_GT_LPAREN] = ACTIONS(1539),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1531),
  },
  [354] = {
    [aux_sym_concatenation_repeat1] = STATE(753),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(695),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [355] = {
    [sym__concat] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(699),
    [sym_word] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_LF] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [356] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(1541),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [357] = {
    [sym__concat] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(729),
    [anon_sym_PIPE_AMP] = ACTIONS(729),
    [anon_sym_AMP_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(729),
    [sym__special_characters] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(729),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(729),
    [anon_sym_BQUOTE] = ACTIONS(729),
    [anon_sym_LT_LPAREN] = ACTIONS(729),
    [anon_sym_GT_LPAREN] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(729),
    [sym_word] = ACTIONS(729),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_LF] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
  },
  [358] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [sym__special_characters] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [anon_sym_LT_LPAREN] = ACTIONS(733),
    [anon_sym_GT_LPAREN] = ACTIONS(733),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(733),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [359] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(737),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__special_characters] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [anon_sym_LT_LPAREN] = ACTIONS(737),
    [anon_sym_GT_LPAREN] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(737),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [360] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(1543),
    [sym_comment] = ACTIONS(53),
  },
  [361] = {
    [sym_concatenation] = STATE(758),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(758),
    [anon_sym_RBRACE] = ACTIONS(1545),
    [anon_sym_EQ] = ACTIONS(1547),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1549),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1551),
    [anon_sym_COLON] = ACTIONS(1547),
    [anon_sym_COLON_QMARK] = ACTIONS(1547),
    [anon_sym_COLON_DASH] = ACTIONS(1547),
    [anon_sym_PERCENT] = ACTIONS(1547),
    [anon_sym_DASH] = ACTIONS(1547),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [362] = {
    [sym_subscript] = STATE(762),
    [sym_variable_name] = ACTIONS(1553),
    [anon_sym_DOLLAR] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1555),
    [anon_sym_AT] = ACTIONS(1555),
    [anon_sym_QMARK] = ACTIONS(1555),
    [anon_sym_0] = ACTIONS(1559),
    [anon_sym__] = ACTIONS(1559),
  },
  [363] = {
    [sym_concatenation] = STATE(765),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(765),
    [anon_sym_RBRACE] = ACTIONS(1561),
    [anon_sym_EQ] = ACTIONS(1563),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1565),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1567),
    [anon_sym_COLON] = ACTIONS(1563),
    [anon_sym_COLON_QMARK] = ACTIONS(1563),
    [anon_sym_COLON_DASH] = ACTIONS(1563),
    [anon_sym_PERCENT] = ACTIONS(1563),
    [anon_sym_DASH] = ACTIONS(1563),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [364] = {
    [sym_concatenation] = STATE(768),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(768),
    [anon_sym_RBRACE] = ACTIONS(1569),
    [anon_sym_EQ] = ACTIONS(1571),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1573),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1575),
    [anon_sym_COLON] = ACTIONS(1571),
    [anon_sym_COLON_QMARK] = ACTIONS(1571),
    [anon_sym_COLON_DASH] = ACTIONS(1571),
    [anon_sym_PERCENT] = ACTIONS(1571),
    [anon_sym_DASH] = ACTIONS(1571),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [365] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1577),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [366] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1577),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [367] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [sym_comment] = ACTIONS(53),
  },
  [368] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [369] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1579),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [370] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1579),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [371] = {
    [sym_concatenation] = STATE(371),
    [sym_string] = STATE(109),
    [sym_simple_expansion] = STATE(109),
    [sym_string_expansion] = STATE(109),
    [sym_expansion] = STATE(109),
    [sym_command_substitution] = STATE(109),
    [sym_process_substitution] = STATE(109),
    [aux_sym_unset_command_repeat1] = STATE(371),
    [anon_sym_PIPE] = ACTIONS(1581),
    [anon_sym_SEMI_SEMI] = ACTIONS(1581),
    [anon_sym_PIPE_AMP] = ACTIONS(1581),
    [anon_sym_AMP_AMP] = ACTIONS(1581),
    [anon_sym_PIPE_PIPE] = ACTIONS(1581),
    [sym__special_characters] = ACTIONS(1583),
    [anon_sym_DQUOTE] = ACTIONS(1586),
    [anon_sym_DOLLAR] = ACTIONS(1589),
    [sym_raw_string] = ACTIONS(1592),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1598),
    [anon_sym_BQUOTE] = ACTIONS(1601),
    [anon_sym_LT_LPAREN] = ACTIONS(1604),
    [anon_sym_GT_LPAREN] = ACTIONS(1604),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1607),
    [sym_word] = ACTIONS(1592),
    [anon_sym_SEMI] = ACTIONS(1581),
    [anon_sym_LF] = ACTIONS(1610),
    [anon_sym_AMP] = ACTIONS(1581),
  },
  [372] = {
    [sym_string] = STATE(771),
    [sym_simple_expansion] = STATE(771),
    [sym_string_expansion] = STATE(771),
    [sym_expansion] = STATE(771),
    [sym_command_substitution] = STATE(771),
    [sym_process_substitution] = STATE(771),
    [sym__special_characters] = ACTIONS(1612),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(1612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1612),
  },
  [373] = {
    [aux_sym_concatenation_repeat1] = STATE(772),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(693),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(693),
    [anon_sym_LT_AMP] = ACTIONS(693),
    [anon_sym_GT_AMP] = ACTIONS(693),
    [sym__special_characters] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(693),
  },
  [374] = {
    [sym_file_descriptor] = ACTIONS(697),
    [sym__concat] = ACTIONS(697),
    [sym_variable_name] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(697),
    [anon_sym_PIPE_AMP] = ACTIONS(697),
    [anon_sym_AMP_AMP] = ACTIONS(697),
    [anon_sym_PIPE_PIPE] = ACTIONS(697),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_GT_GT] = ACTIONS(697),
    [anon_sym_AMP_GT] = ACTIONS(699),
    [anon_sym_AMP_GT_GT] = ACTIONS(697),
    [anon_sym_LT_AMP] = ACTIONS(697),
    [anon_sym_GT_AMP] = ACTIONS(697),
    [sym__special_characters] = ACTIONS(697),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [anon_sym_LT_LPAREN] = ACTIONS(697),
    [anon_sym_GT_LPAREN] = ACTIONS(697),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(697),
  },
  [375] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(1614),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [376] = {
    [sym_file_descriptor] = ACTIONS(727),
    [sym__concat] = ACTIONS(727),
    [sym_variable_name] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(727),
    [anon_sym_PIPE_AMP] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(727),
    [anon_sym_PIPE_PIPE] = ACTIONS(727),
    [anon_sym_LT] = ACTIONS(729),
    [anon_sym_GT] = ACTIONS(729),
    [anon_sym_GT_GT] = ACTIONS(727),
    [anon_sym_AMP_GT] = ACTIONS(729),
    [anon_sym_AMP_GT_GT] = ACTIONS(727),
    [anon_sym_LT_AMP] = ACTIONS(727),
    [anon_sym_GT_AMP] = ACTIONS(727),
    [sym__special_characters] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(727),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(727),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(727),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(727),
    [anon_sym_BQUOTE] = ACTIONS(727),
    [anon_sym_LT_LPAREN] = ACTIONS(727),
    [anon_sym_GT_LPAREN] = ACTIONS(727),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(727),
  },
  [377] = {
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(731),
    [sym_variable_name] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [sym__special_characters] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(731),
  },
  [378] = {
    [sym_file_descriptor] = ACTIONS(735),
    [sym__concat] = ACTIONS(735),
    [sym_variable_name] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_PIPE_AMP] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(735),
    [anon_sym_LT_AMP] = ACTIONS(735),
    [anon_sym_GT_AMP] = ACTIONS(735),
    [sym__special_characters] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(735),
  },
  [379] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(1616),
    [sym_comment] = ACTIONS(53),
  },
  [380] = {
    [sym_concatenation] = STATE(777),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(777),
    [anon_sym_RBRACE] = ACTIONS(1618),
    [anon_sym_EQ] = ACTIONS(1620),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1622),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1624),
    [anon_sym_COLON] = ACTIONS(1620),
    [anon_sym_COLON_QMARK] = ACTIONS(1620),
    [anon_sym_COLON_DASH] = ACTIONS(1620),
    [anon_sym_PERCENT] = ACTIONS(1620),
    [anon_sym_DASH] = ACTIONS(1620),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [381] = {
    [sym_subscript] = STATE(781),
    [sym_variable_name] = ACTIONS(1626),
    [anon_sym_DOLLAR] = ACTIONS(1628),
    [anon_sym_DASH] = ACTIONS(1628),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1630),
    [anon_sym_STAR] = ACTIONS(1628),
    [anon_sym_AT] = ACTIONS(1628),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_0] = ACTIONS(1632),
    [anon_sym__] = ACTIONS(1632),
  },
  [382] = {
    [sym_concatenation] = STATE(784),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(784),
    [anon_sym_RBRACE] = ACTIONS(1634),
    [anon_sym_EQ] = ACTIONS(1636),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1638),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1640),
    [anon_sym_COLON] = ACTIONS(1636),
    [anon_sym_COLON_QMARK] = ACTIONS(1636),
    [anon_sym_COLON_DASH] = ACTIONS(1636),
    [anon_sym_PERCENT] = ACTIONS(1636),
    [anon_sym_DASH] = ACTIONS(1636),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [383] = {
    [sym_concatenation] = STATE(787),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(787),
    [anon_sym_RBRACE] = ACTIONS(1642),
    [anon_sym_EQ] = ACTIONS(1644),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1646),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1648),
    [anon_sym_COLON] = ACTIONS(1644),
    [anon_sym_COLON_QMARK] = ACTIONS(1644),
    [anon_sym_COLON_DASH] = ACTIONS(1644),
    [anon_sym_PERCENT] = ACTIONS(1644),
    [anon_sym_DASH] = ACTIONS(1644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [384] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1650),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [385] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1650),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [386] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(1650),
    [sym_comment] = ACTIONS(53),
  },
  [387] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(1650),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [388] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1652),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [389] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1652),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [390] = {
    [sym__simple_heredoc_body] = ACTIONS(1654),
    [sym__heredoc_body_beginning] = ACTIONS(1654),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(1654),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [anon_sym_EQ_TILDE] = ACTIONS(1656),
    [anon_sym_EQ_EQ] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1656),
    [anon_sym_LT_AMP] = ACTIONS(1656),
    [anon_sym_GT_AMP] = ACTIONS(1656),
    [anon_sym_LT_LT] = ACTIONS(1656),
    [anon_sym_LT_LT_DASH] = ACTIONS(1656),
    [anon_sym_LT_LT_LT] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LT_LPAREN] = ACTIONS(1656),
    [anon_sym_GT_LPAREN] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [391] = {
    [aux_sym_concatenation_repeat1] = STATE(391),
    [sym__simple_heredoc_body] = ACTIONS(1654),
    [sym__heredoc_body_beginning] = ACTIONS(1654),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(1658),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [anon_sym_EQ_TILDE] = ACTIONS(1656),
    [anon_sym_EQ_EQ] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1656),
    [anon_sym_LT_AMP] = ACTIONS(1656),
    [anon_sym_GT_AMP] = ACTIONS(1656),
    [anon_sym_LT_LT] = ACTIONS(1656),
    [anon_sym_LT_LT_DASH] = ACTIONS(1656),
    [anon_sym_LT_LT_LT] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LT_LPAREN] = ACTIONS(1656),
    [anon_sym_GT_LPAREN] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [392] = {
    [sym__concat] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(729),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym__string_content] = ACTIONS(727),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(729),
    [anon_sym_BQUOTE] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
  },
  [393] = {
    [sym__concat] = ACTIONS(1661),
    [anon_sym_DQUOTE] = ACTIONS(1663),
    [anon_sym_DOLLAR] = ACTIONS(1663),
    [sym__string_content] = ACTIONS(1665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1663),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1663),
    [anon_sym_BQUOTE] = ACTIONS(1663),
    [sym_comment] = ACTIONS(177),
  },
  [394] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym__string_content] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
  },
  [395] = {
    [anon_sym_DQUOTE] = ACTIONS(1663),
    [anon_sym_DOLLAR] = ACTIONS(1663),
    [sym__string_content] = ACTIONS(1665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1663),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1663),
    [anon_sym_BQUOTE] = ACTIONS(1663),
    [sym_comment] = ACTIONS(177),
  },
  [396] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(1667),
    [sym_comment] = ACTIONS(53),
  },
  [397] = {
    [sym_concatenation] = STATE(794),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(794),
    [anon_sym_RBRACE] = ACTIONS(1669),
    [anon_sym_EQ] = ACTIONS(1671),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1673),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1675),
    [anon_sym_COLON] = ACTIONS(1671),
    [anon_sym_COLON_QMARK] = ACTIONS(1671),
    [anon_sym_COLON_DASH] = ACTIONS(1671),
    [anon_sym_PERCENT] = ACTIONS(1671),
    [anon_sym_DASH] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [398] = {
    [sym_subscript] = STATE(798),
    [sym_variable_name] = ACTIONS(1677),
    [anon_sym_DOLLAR] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1679),
    [anon_sym_AT] = ACTIONS(1679),
    [anon_sym_QMARK] = ACTIONS(1679),
    [anon_sym_0] = ACTIONS(1683),
    [anon_sym__] = ACTIONS(1683),
  },
  [399] = {
    [sym_concatenation] = STATE(801),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(801),
    [anon_sym_RBRACE] = ACTIONS(1685),
    [anon_sym_EQ] = ACTIONS(1687),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1689),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1691),
    [anon_sym_COLON] = ACTIONS(1687),
    [anon_sym_COLON_QMARK] = ACTIONS(1687),
    [anon_sym_COLON_DASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [anon_sym_DASH] = ACTIONS(1687),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [400] = {
    [sym_concatenation] = STATE(804),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(804),
    [anon_sym_RBRACE] = ACTIONS(1693),
    [anon_sym_EQ] = ACTIONS(1695),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1699),
    [anon_sym_COLON] = ACTIONS(1695),
    [anon_sym_COLON_QMARK] = ACTIONS(1695),
    [anon_sym_COLON_DASH] = ACTIONS(1695),
    [anon_sym_PERCENT] = ACTIONS(1695),
    [anon_sym_DASH] = ACTIONS(1695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [401] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1701),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [402] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1701),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [403] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(1701),
    [sym_comment] = ACTIONS(53),
  },
  [404] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(1701),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [405] = {
    [sym__simple_heredoc_body] = ACTIONS(1703),
    [sym__heredoc_body_beginning] = ACTIONS(1703),
    [sym_file_descriptor] = ACTIONS(1703),
    [sym__concat] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_RPAREN] = ACTIONS(1705),
    [anon_sym_SEMI_SEMI] = ACTIONS(1705),
    [anon_sym_PIPE_AMP] = ACTIONS(1705),
    [anon_sym_AMP_AMP] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE] = ACTIONS(1705),
    [anon_sym_EQ_TILDE] = ACTIONS(1705),
    [anon_sym_EQ_EQ] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1705),
    [anon_sym_GT] = ACTIONS(1705),
    [anon_sym_GT_GT] = ACTIONS(1705),
    [anon_sym_AMP_GT] = ACTIONS(1705),
    [anon_sym_AMP_GT_GT] = ACTIONS(1705),
    [anon_sym_LT_AMP] = ACTIONS(1705),
    [anon_sym_GT_AMP] = ACTIONS(1705),
    [anon_sym_LT_LT] = ACTIONS(1705),
    [anon_sym_LT_LT_DASH] = ACTIONS(1705),
    [anon_sym_LT_LT_LT] = ACTIONS(1705),
    [sym__special_characters] = ACTIONS(1705),
    [anon_sym_DQUOTE] = ACTIONS(1705),
    [anon_sym_DOLLAR] = ACTIONS(1705),
    [sym_raw_string] = ACTIONS(1705),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1705),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1705),
    [anon_sym_BQUOTE] = ACTIONS(1705),
    [anon_sym_LT_LPAREN] = ACTIONS(1705),
    [anon_sym_GT_LPAREN] = ACTIONS(1705),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1705),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_LF] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1705),
  },
  [406] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(1663),
    [anon_sym_DOLLAR] = ACTIONS(1707),
    [sym__string_content] = ACTIONS(1710),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1713),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1716),
    [anon_sym_BQUOTE] = ACTIONS(1719),
    [sym_comment] = ACTIONS(177),
  },
  [407] = {
    [sym_concatenation] = STATE(808),
    [sym_string] = STATE(807),
    [sym_simple_expansion] = STATE(807),
    [sym_string_expansion] = STATE(807),
    [sym_expansion] = STATE(807),
    [sym_command_substitution] = STATE(807),
    [sym_process_substitution] = STATE(807),
    [sym__special_characters] = ACTIONS(1722),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1724),
  },
  [408] = {
    [sym_concatenation] = STATE(818),
    [sym_string] = STATE(813),
    [sym_simple_expansion] = STATE(813),
    [sym_string_expansion] = STATE(813),
    [sym_expansion] = STATE(813),
    [sym_command_substitution] = STATE(813),
    [sym_process_substitution] = STATE(813),
    [anon_sym_RBRACE] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1728),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(1734),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1734),
  },
  [409] = {
    [sym__simple_heredoc_body] = ACTIONS(1744),
    [sym__heredoc_body_beginning] = ACTIONS(1744),
    [sym_file_descriptor] = ACTIONS(1744),
    [sym__concat] = ACTIONS(1744),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_RPAREN] = ACTIONS(1746),
    [anon_sym_SEMI_SEMI] = ACTIONS(1746),
    [anon_sym_PIPE_AMP] = ACTIONS(1746),
    [anon_sym_AMP_AMP] = ACTIONS(1746),
    [anon_sym_PIPE_PIPE] = ACTIONS(1746),
    [anon_sym_EQ_TILDE] = ACTIONS(1746),
    [anon_sym_EQ_EQ] = ACTIONS(1746),
    [anon_sym_LT] = ACTIONS(1746),
    [anon_sym_GT] = ACTIONS(1746),
    [anon_sym_GT_GT] = ACTIONS(1746),
    [anon_sym_AMP_GT] = ACTIONS(1746),
    [anon_sym_AMP_GT_GT] = ACTIONS(1746),
    [anon_sym_LT_AMP] = ACTIONS(1746),
    [anon_sym_GT_AMP] = ACTIONS(1746),
    [anon_sym_LT_LT] = ACTIONS(1746),
    [anon_sym_LT_LT_DASH] = ACTIONS(1746),
    [anon_sym_LT_LT_LT] = ACTIONS(1746),
    [sym__special_characters] = ACTIONS(1746),
    [anon_sym_DQUOTE] = ACTIONS(1746),
    [anon_sym_DOLLAR] = ACTIONS(1746),
    [sym_raw_string] = ACTIONS(1746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1746),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1746),
    [anon_sym_GT_LPAREN] = ACTIONS(1746),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1746),
    [anon_sym_SEMI] = ACTIONS(1746),
    [anon_sym_LF] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(1746),
  },
  [410] = {
    [aux_sym_concatenation_repeat1] = STATE(820),
    [sym__concat] = ACTIONS(1748),
    [anon_sym_RBRACE] = ACTIONS(1750),
    [anon_sym_EQ] = ACTIONS(1752),
    [sym__special_characters] = ACTIONS(1752),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [sym_raw_string] = ACTIONS(1750),
    [anon_sym_POUND] = ACTIONS(1750),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1750),
    [anon_sym_COLON] = ACTIONS(1752),
    [anon_sym_COLON_QMARK] = ACTIONS(1752),
    [anon_sym_COLON_DASH] = ACTIONS(1752),
    [anon_sym_PERCENT] = ACTIONS(1752),
    [anon_sym_DASH] = ACTIONS(1752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1750),
    [anon_sym_BQUOTE] = ACTIONS(1750),
    [anon_sym_LT_LPAREN] = ACTIONS(1750),
    [anon_sym_GT_LPAREN] = ACTIONS(1750),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1752),
  },
  [411] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(822),
    [anon_sym_DQUOTE] = ACTIONS(1754),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [412] = {
    [sym_string] = STATE(824),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(1756),
    [sym_raw_string] = ACTIONS(1758),
    [anon_sym_POUND] = ACTIONS(1756),
    [anon_sym_DASH] = ACTIONS(1756),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1760),
    [anon_sym_STAR] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(1756),
    [anon_sym_QMARK] = ACTIONS(1756),
    [anon_sym_0] = ACTIONS(1762),
    [anon_sym__] = ACTIONS(1762),
  },
  [413] = {
    [aux_sym_concatenation_repeat1] = STATE(820),
    [sym__concat] = ACTIONS(1748),
    [anon_sym_RBRACE] = ACTIONS(1764),
    [anon_sym_EQ] = ACTIONS(1766),
    [sym__special_characters] = ACTIONS(1766),
    [anon_sym_DQUOTE] = ACTIONS(1764),
    [anon_sym_DOLLAR] = ACTIONS(1766),
    [sym_raw_string] = ACTIONS(1764),
    [anon_sym_POUND] = ACTIONS(1764),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1764),
    [anon_sym_COLON] = ACTIONS(1766),
    [anon_sym_COLON_QMARK] = ACTIONS(1766),
    [anon_sym_COLON_DASH] = ACTIONS(1766),
    [anon_sym_PERCENT] = ACTIONS(1766),
    [anon_sym_DASH] = ACTIONS(1766),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1764),
    [anon_sym_BQUOTE] = ACTIONS(1764),
    [anon_sym_LT_LPAREN] = ACTIONS(1764),
    [anon_sym_GT_LPAREN] = ACTIONS(1764),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1766),
  },
  [414] = {
    [sym_subscript] = STATE(830),
    [sym_variable_name] = ACTIONS(1768),
    [anon_sym_DOLLAR] = ACTIONS(1770),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DASH] = ACTIONS(1770),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1774),
    [anon_sym_STAR] = ACTIONS(1770),
    [anon_sym_AT] = ACTIONS(1770),
    [anon_sym_QMARK] = ACTIONS(1770),
    [anon_sym_0] = ACTIONS(1776),
    [anon_sym__] = ACTIONS(1776),
  },
  [415] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(1778),
  },
  [416] = {
    [sym_for_statement] = STATE(832),
    [sym_while_statement] = STATE(832),
    [sym_if_statement] = STATE(832),
    [sym_case_statement] = STATE(832),
    [sym_function_definition] = STATE(832),
    [sym_subshell] = STATE(832),
    [sym_pipeline] = STATE(832),
    [sym_list] = STATE(832),
    [sym_negated_command] = STATE(832),
    [sym_test_command] = STATE(832),
    [sym_declaration_command] = STATE(832),
    [sym_unset_command] = STATE(832),
    [sym_command] = STATE(832),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(833),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [417] = {
    [sym_for_statement] = STATE(834),
    [sym_while_statement] = STATE(834),
    [sym_if_statement] = STATE(834),
    [sym_case_statement] = STATE(834),
    [sym_function_definition] = STATE(834),
    [sym_subshell] = STATE(834),
    [sym_pipeline] = STATE(834),
    [sym_list] = STATE(834),
    [sym_negated_command] = STATE(834),
    [sym_test_command] = STATE(834),
    [sym_declaration_command] = STATE(834),
    [sym_unset_command] = STATE(834),
    [sym_command] = STATE(834),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(835),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [418] = {
    [sym_for_statement] = STATE(836),
    [sym_while_statement] = STATE(836),
    [sym_if_statement] = STATE(836),
    [sym_case_statement] = STATE(836),
    [sym_function_definition] = STATE(836),
    [sym_subshell] = STATE(836),
    [sym_pipeline] = STATE(836),
    [sym_list] = STATE(836),
    [sym_negated_command] = STATE(836),
    [sym_test_command] = STATE(836),
    [sym_declaration_command] = STATE(836),
    [sym_unset_command] = STATE(836),
    [sym_command] = STATE(836),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(837),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [419] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(1780),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [420] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(1786),
    [sym_comment] = ACTIONS(53),
  },
  [421] = {
    [sym_concatenation] = STATE(843),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(843),
    [anon_sym_RBRACE] = ACTIONS(1788),
    [anon_sym_EQ] = ACTIONS(1790),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1792),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1794),
    [anon_sym_COLON] = ACTIONS(1790),
    [anon_sym_COLON_QMARK] = ACTIONS(1790),
    [anon_sym_COLON_DASH] = ACTIONS(1790),
    [anon_sym_PERCENT] = ACTIONS(1790),
    [anon_sym_DASH] = ACTIONS(1790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [422] = {
    [sym_concatenation] = STATE(846),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(846),
    [anon_sym_RBRACE] = ACTIONS(1796),
    [anon_sym_EQ] = ACTIONS(1798),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1800),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1802),
    [anon_sym_COLON] = ACTIONS(1798),
    [anon_sym_COLON_QMARK] = ACTIONS(1798),
    [anon_sym_COLON_DASH] = ACTIONS(1798),
    [anon_sym_PERCENT] = ACTIONS(1798),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [423] = {
    [sym_concatenation] = STATE(848),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(848),
    [anon_sym_RBRACE] = ACTIONS(1726),
    [anon_sym_EQ] = ACTIONS(1804),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1806),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1808),
    [anon_sym_COLON] = ACTIONS(1804),
    [anon_sym_COLON_QMARK] = ACTIONS(1804),
    [anon_sym_COLON_DASH] = ACTIONS(1804),
    [anon_sym_PERCENT] = ACTIONS(1804),
    [anon_sym_DASH] = ACTIONS(1804),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [424] = {
    [sym__simple_heredoc_body] = ACTIONS(1810),
    [sym__heredoc_body_beginning] = ACTIONS(1810),
    [sym_file_descriptor] = ACTIONS(1810),
    [sym__concat] = ACTIONS(1810),
    [anon_sym_PIPE] = ACTIONS(1812),
    [anon_sym_RPAREN] = ACTIONS(1812),
    [anon_sym_SEMI_SEMI] = ACTIONS(1812),
    [anon_sym_PIPE_AMP] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1812),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [anon_sym_EQ_TILDE] = ACTIONS(1812),
    [anon_sym_EQ_EQ] = ACTIONS(1812),
    [anon_sym_LT] = ACTIONS(1812),
    [anon_sym_GT] = ACTIONS(1812),
    [anon_sym_GT_GT] = ACTIONS(1812),
    [anon_sym_AMP_GT] = ACTIONS(1812),
    [anon_sym_AMP_GT_GT] = ACTIONS(1812),
    [anon_sym_LT_AMP] = ACTIONS(1812),
    [anon_sym_GT_AMP] = ACTIONS(1812),
    [anon_sym_LT_LT] = ACTIONS(1812),
    [anon_sym_LT_LT_DASH] = ACTIONS(1812),
    [anon_sym_LT_LT_LT] = ACTIONS(1812),
    [sym__special_characters] = ACTIONS(1812),
    [anon_sym_DQUOTE] = ACTIONS(1812),
    [anon_sym_DOLLAR] = ACTIONS(1812),
    [sym_raw_string] = ACTIONS(1812),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1812),
    [anon_sym_GT_LPAREN] = ACTIONS(1812),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1812),
    [anon_sym_SEMI] = ACTIONS(1812),
    [anon_sym_LF] = ACTIONS(1810),
    [anon_sym_AMP] = ACTIONS(1812),
  },
  [425] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(1814),
  },
  [426] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(1816),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [427] = {
    [sym__simple_heredoc_body] = ACTIONS(1818),
    [sym__heredoc_body_beginning] = ACTIONS(1818),
    [sym_file_descriptor] = ACTIONS(1818),
    [sym__concat] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1820),
    [anon_sym_RPAREN] = ACTIONS(1820),
    [anon_sym_SEMI_SEMI] = ACTIONS(1820),
    [anon_sym_PIPE_AMP] = ACTIONS(1820),
    [anon_sym_AMP_AMP] = ACTIONS(1820),
    [anon_sym_PIPE_PIPE] = ACTIONS(1820),
    [anon_sym_EQ_TILDE] = ACTIONS(1820),
    [anon_sym_EQ_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1820),
    [anon_sym_GT] = ACTIONS(1820),
    [anon_sym_GT_GT] = ACTIONS(1820),
    [anon_sym_AMP_GT] = ACTIONS(1820),
    [anon_sym_AMP_GT_GT] = ACTIONS(1820),
    [anon_sym_LT_AMP] = ACTIONS(1820),
    [anon_sym_GT_AMP] = ACTIONS(1820),
    [anon_sym_LT_LT] = ACTIONS(1820),
    [anon_sym_LT_LT_DASH] = ACTIONS(1820),
    [anon_sym_LT_LT_LT] = ACTIONS(1820),
    [sym__special_characters] = ACTIONS(1820),
    [anon_sym_DQUOTE] = ACTIONS(1820),
    [anon_sym_DOLLAR] = ACTIONS(1820),
    [sym_raw_string] = ACTIONS(1820),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1820),
    [anon_sym_BQUOTE] = ACTIONS(1820),
    [anon_sym_LT_LPAREN] = ACTIONS(1820),
    [anon_sym_GT_LPAREN] = ACTIONS(1820),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1820),
    [anon_sym_LF] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1820),
  },
  [428] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(1822),
  },
  [429] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(1726),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [430] = {
    [sym_concatenation] = STATE(672),
    [sym_string] = STATE(853),
    [sym_array] = STATE(672),
    [sym_simple_expansion] = STATE(853),
    [sym_string_expansion] = STATE(853),
    [sym_expansion] = STATE(853),
    [sym_command_substitution] = STATE(853),
    [sym_process_substitution] = STATE(853),
    [sym__empty_value] = ACTIONS(1291),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [sym__special_characters] = ACTIONS(1824),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(1826),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1826),
  },
  [431] = {
    [anon_sym_in] = ACTIONS(1828),
    [anon_sym_SEMI_SEMI] = ACTIONS(1830),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1830),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1830),
  },
  [432] = {
    [sym_do_group] = STATE(857),
    [anon_sym_do] = ACTIONS(1834),
    [sym_comment] = ACTIONS(53),
  },
  [433] = {
    [anon_sym_then] = ACTIONS(1836),
    [sym_comment] = ACTIONS(53),
  },
  [434] = {
    [aux_sym_concatenation_repeat1] = STATE(231),
    [sym__concat] = ACTIONS(419),
    [anon_sym_in] = ACTIONS(1838),
    [anon_sym_SEMI_SEMI] = ACTIONS(1840),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1840),
    [anon_sym_LF] = ACTIONS(1842),
    [anon_sym_AMP] = ACTIONS(1840),
  },
  [435] = {
    [aux_sym_concatenation_repeat1] = STATE(231),
    [sym__concat] = ACTIONS(419),
    [anon_sym_in] = ACTIONS(1844),
    [anon_sym_SEMI_SEMI] = ACTIONS(1846),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1846),
    [anon_sym_LF] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1846),
  },
  [436] = {
    [anon_sym_in] = ACTIONS(1844),
    [anon_sym_SEMI_SEMI] = ACTIONS(1846),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1846),
    [anon_sym_LF] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1846),
  },
  [437] = {
    [sym_compound_statement] = STATE(865),
    [anon_sym_LPAREN] = ACTIONS(1850),
    [anon_sym_LBRACE] = ACTIONS(1852),
    [sym_comment] = ACTIONS(53),
  },
  [438] = {
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(1854),
    [anon_sym_SEMI_SEMI] = ACTIONS(1856),
    [anon_sym_PIPE_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1856),
    [anon_sym_LF] = ACTIONS(1858),
    [anon_sym_AMP] = ACTIONS(1856),
  },
  [439] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(1854),
    [anon_sym_SEMI_SEMI] = ACTIONS(1856),
    [anon_sym_PIPE_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(1856),
    [anon_sym_LF] = ACTIONS(1858),
    [anon_sym_AMP] = ACTIONS(1856),
  },
  [440] = {
    [sym__terminated_statement] = STATE(282),
    [sym_for_statement] = STATE(868),
    [sym_while_statement] = STATE(868),
    [sym_if_statement] = STATE(868),
    [sym_case_statement] = STATE(868),
    [sym_function_definition] = STATE(868),
    [sym_subshell] = STATE(868),
    [sym_pipeline] = STATE(868),
    [sym_list] = STATE(868),
    [sym_negated_command] = STATE(868),
    [sym_test_command] = STATE(868),
    [sym_declaration_command] = STATE(868),
    [sym_unset_command] = STATE(868),
    [sym_command] = STATE(868),
    [sym_command_name] = STATE(64),
    [sym_variable_assignment] = STATE(869),
    [sym_subscript] = STATE(66),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(61),
    [sym_simple_expansion] = STATE(61),
    [sym_string_expansion] = STATE(61),
    [sym_expansion] = STATE(61),
    [sym_command_substitution] = STATE(61),
    [sym_process_substitution] = STATE(61),
    [aux_sym_program_repeat1] = STATE(282),
    [aux_sym_command_repeat1] = STATE(68),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(93),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(95),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_typeset] = ACTIONS(97),
    [anon_sym_export] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_local] = ACTIONS(97),
    [anon_sym_unset] = ACTIONS(99),
    [anon_sym_unsetenv] = ACTIONS(99),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(105),
  },
  [441] = {
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_RPAREN] = ACTIONS(501),
    [anon_sym_PIPE_AMP] = ACTIONS(501),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [sym_comment] = ACTIONS(53),
  },
  [442] = {
    [anon_sym_AMP_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(543),
    [anon_sym_RBRACK] = ACTIONS(1860),
    [anon_sym_EQ_TILDE] = ACTIONS(547),
    [anon_sym_EQ_EQ] = ACTIONS(547),
    [anon_sym_EQ] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_BANG_EQ] = ACTIONS(543),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(543),
  },
  [443] = {
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1860),
    [anon_sym_EQ_TILDE] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(577),
    [anon_sym_LT] = ACTIONS(573),
    [anon_sym_GT] = ACTIONS(573),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(573),
  },
  [444] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(1862),
    [anon_sym_PLUS_EQ] = ACTIONS(1862),
    [sym_comment] = ACTIONS(53),
  },
  [445] = {
    [aux_sym_concatenation_repeat1] = STATE(873),
    [sym__concat] = ACTIONS(1864),
    [sym_variable_name] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(585),
    [anon_sym_RPAREN] = ACTIONS(583),
    [anon_sym_PIPE_AMP] = ACTIONS(583),
    [anon_sym_AMP_AMP] = ACTIONS(583),
    [anon_sym_PIPE_PIPE] = ACTIONS(583),
    [sym__special_characters] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_DOLLAR] = ACTIONS(585),
    [sym_raw_string] = ACTIONS(583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LT_LPAREN] = ACTIONS(583),
    [anon_sym_GT_LPAREN] = ACTIONS(583),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(585),
    [sym_word] = ACTIONS(585),
  },
  [446] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(875),
    [anon_sym_DQUOTE] = ACTIONS(1866),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [447] = {
    [sym_string] = STATE(877),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(1868),
    [sym_raw_string] = ACTIONS(1870),
    [anon_sym_POUND] = ACTIONS(1868),
    [anon_sym_DASH] = ACTIONS(1868),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1868),
    [anon_sym_AT] = ACTIONS(1868),
    [anon_sym_QMARK] = ACTIONS(1868),
    [anon_sym_0] = ACTIONS(1874),
    [anon_sym__] = ACTIONS(1874),
  },
  [448] = {
    [aux_sym_concatenation_repeat1] = STATE(873),
    [sym__concat] = ACTIONS(1864),
    [sym_variable_name] = ACTIONS(599),
    [anon_sym_PIPE] = ACTIONS(601),
    [anon_sym_RPAREN] = ACTIONS(599),
    [anon_sym_PIPE_AMP] = ACTIONS(599),
    [anon_sym_AMP_AMP] = ACTIONS(599),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [sym__special_characters] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(599),
    [anon_sym_DOLLAR] = ACTIONS(601),
    [sym_raw_string] = ACTIONS(599),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(599),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(599),
    [anon_sym_BQUOTE] = ACTIONS(599),
    [anon_sym_LT_LPAREN] = ACTIONS(599),
    [anon_sym_GT_LPAREN] = ACTIONS(599),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(601),
    [sym_word] = ACTIONS(601),
  },
  [449] = {
    [sym_subscript] = STATE(883),
    [sym_variable_name] = ACTIONS(1876),
    [anon_sym_DOLLAR] = ACTIONS(1878),
    [anon_sym_POUND] = ACTIONS(1880),
    [anon_sym_DASH] = ACTIONS(1878),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1882),
    [anon_sym_STAR] = ACTIONS(1878),
    [anon_sym_AT] = ACTIONS(1878),
    [anon_sym_QMARK] = ACTIONS(1878),
    [anon_sym_0] = ACTIONS(1884),
    [anon_sym__] = ACTIONS(1884),
  },
  [450] = {
    [sym_for_statement] = STATE(884),
    [sym_while_statement] = STATE(884),
    [sym_if_statement] = STATE(884),
    [sym_case_statement] = STATE(884),
    [sym_function_definition] = STATE(884),
    [sym_subshell] = STATE(884),
    [sym_pipeline] = STATE(884),
    [sym_list] = STATE(884),
    [sym_negated_command] = STATE(884),
    [sym_test_command] = STATE(884),
    [sym_declaration_command] = STATE(884),
    [sym_unset_command] = STATE(884),
    [sym_command] = STATE(884),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(885),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [451] = {
    [sym_for_statement] = STATE(886),
    [sym_while_statement] = STATE(886),
    [sym_if_statement] = STATE(886),
    [sym_case_statement] = STATE(886),
    [sym_function_definition] = STATE(886),
    [sym_subshell] = STATE(886),
    [sym_pipeline] = STATE(886),
    [sym_list] = STATE(886),
    [sym_negated_command] = STATE(886),
    [sym_test_command] = STATE(886),
    [sym_declaration_command] = STATE(886),
    [sym_unset_command] = STATE(886),
    [sym_command] = STATE(886),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(887),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [452] = {
    [sym_for_statement] = STATE(888),
    [sym_while_statement] = STATE(888),
    [sym_if_statement] = STATE(888),
    [sym_case_statement] = STATE(888),
    [sym_function_definition] = STATE(888),
    [sym_subshell] = STATE(888),
    [sym_pipeline] = STATE(888),
    [sym_list] = STATE(888),
    [sym_negated_command] = STATE(888),
    [sym_test_command] = STATE(888),
    [sym_declaration_command] = STATE(888),
    [sym_unset_command] = STATE(888),
    [sym_command] = STATE(888),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(889),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [453] = {
    [sym_variable_name] = ACTIONS(613),
    [anon_sym_PIPE] = ACTIONS(615),
    [anon_sym_RPAREN] = ACTIONS(613),
    [anon_sym_PIPE_AMP] = ACTIONS(613),
    [anon_sym_AMP_AMP] = ACTIONS(613),
    [anon_sym_PIPE_PIPE] = ACTIONS(613),
    [sym__special_characters] = ACTIONS(613),
    [anon_sym_DQUOTE] = ACTIONS(613),
    [anon_sym_DOLLAR] = ACTIONS(615),
    [sym_raw_string] = ACTIONS(613),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(613),
    [anon_sym_BQUOTE] = ACTIONS(613),
    [anon_sym_LT_LPAREN] = ACTIONS(613),
    [anon_sym_GT_LPAREN] = ACTIONS(613),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(615),
    [sym_word] = ACTIONS(615),
  },
  [454] = {
    [anon_sym_EQ] = ACTIONS(1862),
    [anon_sym_PLUS_EQ] = ACTIONS(1862),
    [sym_comment] = ACTIONS(53),
  },
  [455] = {
    [sym_variable_assignment] = STATE(890),
    [sym_subscript] = STATE(454),
    [sym_concatenation] = STATE(890),
    [sym_string] = STATE(448),
    [sym_simple_expansion] = STATE(448),
    [sym_string_expansion] = STATE(448),
    [sym_expansion] = STATE(448),
    [sym_command_substitution] = STATE(448),
    [sym_process_substitution] = STATE(448),
    [aux_sym_declaration_command_repeat1] = STATE(890),
    [sym_variable_name] = ACTIONS(803),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_RPAREN] = ACTIONS(619),
    [anon_sym_PIPE_AMP] = ACTIONS(619),
    [anon_sym_AMP_AMP] = ACTIONS(619),
    [anon_sym_PIPE_PIPE] = ACTIONS(619),
    [sym__special_characters] = ACTIONS(805),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(811),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(815),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LT_LPAREN] = ACTIONS(819),
    [anon_sym_GT_LPAREN] = ACTIONS(819),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(821),
    [sym_word] = ACTIONS(823),
  },
  [456] = {
    [aux_sym_concatenation_repeat1] = STATE(892),
    [sym__concat] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(623),
    [anon_sym_RPAREN] = ACTIONS(625),
    [anon_sym_PIPE_AMP] = ACTIONS(625),
    [anon_sym_AMP_AMP] = ACTIONS(625),
    [anon_sym_PIPE_PIPE] = ACTIONS(625),
    [sym__special_characters] = ACTIONS(625),
    [anon_sym_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [sym_raw_string] = ACTIONS(625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(625),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(625),
    [anon_sym_BQUOTE] = ACTIONS(625),
    [anon_sym_LT_LPAREN] = ACTIONS(625),
    [anon_sym_GT_LPAREN] = ACTIONS(625),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(623),
    [sym_word] = ACTIONS(623),
  },
  [457] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(894),
    [anon_sym_DQUOTE] = ACTIONS(1888),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [458] = {
    [sym_string] = STATE(896),
    [anon_sym_DQUOTE] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(1890),
    [sym_raw_string] = ACTIONS(1892),
    [anon_sym_POUND] = ACTIONS(1890),
    [anon_sym_DASH] = ACTIONS(1890),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1894),
    [anon_sym_STAR] = ACTIONS(1890),
    [anon_sym_AT] = ACTIONS(1890),
    [anon_sym_QMARK] = ACTIONS(1890),
    [anon_sym_0] = ACTIONS(1896),
    [anon_sym__] = ACTIONS(1896),
  },
  [459] = {
    [aux_sym_concatenation_repeat1] = STATE(892),
    [sym__concat] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(639),
    [anon_sym_RPAREN] = ACTIONS(641),
    [anon_sym_PIPE_AMP] = ACTIONS(641),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [anon_sym_PIPE_PIPE] = ACTIONS(641),
    [sym__special_characters] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [anon_sym_DOLLAR] = ACTIONS(639),
    [sym_raw_string] = ACTIONS(641),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(641),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(641),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [anon_sym_LT_LPAREN] = ACTIONS(641),
    [anon_sym_GT_LPAREN] = ACTIONS(641),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(639),
    [sym_word] = ACTIONS(639),
  },
  [460] = {
    [sym_subscript] = STATE(902),
    [sym_variable_name] = ACTIONS(1898),
    [anon_sym_DOLLAR] = ACTIONS(1900),
    [anon_sym_POUND] = ACTIONS(1902),
    [anon_sym_DASH] = ACTIONS(1900),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1904),
    [anon_sym_STAR] = ACTIONS(1900),
    [anon_sym_AT] = ACTIONS(1900),
    [anon_sym_QMARK] = ACTIONS(1900),
    [anon_sym_0] = ACTIONS(1906),
    [anon_sym__] = ACTIONS(1906),
  },
  [461] = {
    [sym_for_statement] = STATE(903),
    [sym_while_statement] = STATE(903),
    [sym_if_statement] = STATE(903),
    [sym_case_statement] = STATE(903),
    [sym_function_definition] = STATE(903),
    [sym_subshell] = STATE(903),
    [sym_pipeline] = STATE(903),
    [sym_list] = STATE(903),
    [sym_negated_command] = STATE(903),
    [sym_test_command] = STATE(903),
    [sym_declaration_command] = STATE(903),
    [sym_unset_command] = STATE(903),
    [sym_command] = STATE(903),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(904),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [462] = {
    [sym_for_statement] = STATE(905),
    [sym_while_statement] = STATE(905),
    [sym_if_statement] = STATE(905),
    [sym_case_statement] = STATE(905),
    [sym_function_definition] = STATE(905),
    [sym_subshell] = STATE(905),
    [sym_pipeline] = STATE(905),
    [sym_list] = STATE(905),
    [sym_negated_command] = STATE(905),
    [sym_test_command] = STATE(905),
    [sym_declaration_command] = STATE(905),
    [sym_unset_command] = STATE(905),
    [sym_command] = STATE(905),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(906),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [463] = {
    [sym_for_statement] = STATE(907),
    [sym_while_statement] = STATE(907),
    [sym_if_statement] = STATE(907),
    [sym_case_statement] = STATE(907),
    [sym_function_definition] = STATE(907),
    [sym_subshell] = STATE(907),
    [sym_pipeline] = STATE(907),
    [sym_list] = STATE(907),
    [sym_negated_command] = STATE(907),
    [sym_test_command] = STATE(907),
    [sym_declaration_command] = STATE(907),
    [sym_unset_command] = STATE(907),
    [sym_command] = STATE(907),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(908),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [464] = {
    [anon_sym_PIPE] = ACTIONS(653),
    [anon_sym_RPAREN] = ACTIONS(655),
    [anon_sym_PIPE_AMP] = ACTIONS(655),
    [anon_sym_AMP_AMP] = ACTIONS(655),
    [anon_sym_PIPE_PIPE] = ACTIONS(655),
    [sym__special_characters] = ACTIONS(655),
    [anon_sym_DQUOTE] = ACTIONS(655),
    [anon_sym_DOLLAR] = ACTIONS(653),
    [sym_raw_string] = ACTIONS(655),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(655),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(655),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_LT_LPAREN] = ACTIONS(655),
    [anon_sym_GT_LPAREN] = ACTIONS(655),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(653),
    [sym_word] = ACTIONS(653),
  },
  [465] = {
    [sym_concatenation] = STATE(909),
    [sym_string] = STATE(459),
    [sym_simple_expansion] = STATE(459),
    [sym_string_expansion] = STATE(459),
    [sym_expansion] = STATE(459),
    [sym_command_substitution] = STATE(459),
    [sym_process_substitution] = STATE(459),
    [aux_sym_unset_command_repeat1] = STATE(909),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_RPAREN] = ACTIONS(659),
    [anon_sym_PIPE_AMP] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(659),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [sym__special_characters] = ACTIONS(825),
    [anon_sym_DQUOTE] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [sym_raw_string] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [anon_sym_LT_LPAREN] = ACTIONS(839),
    [anon_sym_GT_LPAREN] = ACTIONS(839),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(841),
    [sym_word] = ACTIONS(843),
  },
  [466] = {
    [sym_string] = STATE(910),
    [sym_simple_expansion] = STATE(910),
    [sym_string_expansion] = STATE(910),
    [sym_expansion] = STATE(910),
    [sym_command_substitution] = STATE(910),
    [sym_process_substitution] = STATE(910),
    [sym__special_characters] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(1908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1908),
  },
  [467] = {
    [aux_sym_concatenation_repeat1] = STATE(911),
    [sym__simple_heredoc_body] = ACTIONS(693),
    [sym__heredoc_body_beginning] = ACTIONS(693),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(693),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_EQ_TILDE] = ACTIONS(695),
    [anon_sym_EQ_EQ] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(693),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(693),
    [anon_sym_LT_AMP] = ACTIONS(693),
    [anon_sym_GT_AMP] = ACTIONS(693),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(693),
    [anon_sym_LT_LT_LT] = ACTIONS(693),
    [sym__special_characters] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(695),
  },
  [468] = {
    [sym__simple_heredoc_body] = ACTIONS(697),
    [sym__heredoc_body_beginning] = ACTIONS(697),
    [sym_file_descriptor] = ACTIONS(697),
    [sym__concat] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(697),
    [anon_sym_PIPE_AMP] = ACTIONS(697),
    [anon_sym_AMP_AMP] = ACTIONS(697),
    [anon_sym_PIPE_PIPE] = ACTIONS(697),
    [anon_sym_EQ_TILDE] = ACTIONS(699),
    [anon_sym_EQ_EQ] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_GT_GT] = ACTIONS(697),
    [anon_sym_AMP_GT] = ACTIONS(699),
    [anon_sym_AMP_GT_GT] = ACTIONS(697),
    [anon_sym_LT_AMP] = ACTIONS(697),
    [anon_sym_GT_AMP] = ACTIONS(697),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_LT] = ACTIONS(697),
    [sym__special_characters] = ACTIONS(697),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [anon_sym_LT_LPAREN] = ACTIONS(697),
    [anon_sym_GT_LPAREN] = ACTIONS(697),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(699),
  },
  [469] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(1910),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [470] = {
    [sym__simple_heredoc_body] = ACTIONS(727),
    [sym__heredoc_body_beginning] = ACTIONS(727),
    [sym_file_descriptor] = ACTIONS(727),
    [sym__concat] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(727),
    [anon_sym_PIPE_AMP] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(727),
    [anon_sym_PIPE_PIPE] = ACTIONS(727),
    [anon_sym_EQ_TILDE] = ACTIONS(729),
    [anon_sym_EQ_EQ] = ACTIONS(729),
    [anon_sym_LT] = ACTIONS(729),
    [anon_sym_GT] = ACTIONS(729),
    [anon_sym_GT_GT] = ACTIONS(727),
    [anon_sym_AMP_GT] = ACTIONS(729),
    [anon_sym_AMP_GT_GT] = ACTIONS(727),
    [anon_sym_LT_AMP] = ACTIONS(727),
    [anon_sym_GT_AMP] = ACTIONS(727),
    [anon_sym_LT_LT] = ACTIONS(729),
    [anon_sym_LT_LT_DASH] = ACTIONS(727),
    [anon_sym_LT_LT_LT] = ACTIONS(727),
    [sym__special_characters] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(727),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(727),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(727),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(727),
    [anon_sym_BQUOTE] = ACTIONS(727),
    [anon_sym_LT_LPAREN] = ACTIONS(727),
    [anon_sym_GT_LPAREN] = ACTIONS(727),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(729),
  },
  [471] = {
    [sym__simple_heredoc_body] = ACTIONS(731),
    [sym__heredoc_body_beginning] = ACTIONS(731),
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_EQ_TILDE] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(731),
    [anon_sym_LT_LT_LT] = ACTIONS(731),
    [sym__special_characters] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(733),
  },
  [472] = {
    [sym__simple_heredoc_body] = ACTIONS(735),
    [sym__heredoc_body_beginning] = ACTIONS(735),
    [sym_file_descriptor] = ACTIONS(735),
    [sym__concat] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_PIPE_AMP] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(737),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(735),
    [anon_sym_LT_AMP] = ACTIONS(735),
    [anon_sym_GT_AMP] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_LT_LT_DASH] = ACTIONS(735),
    [anon_sym_LT_LT_LT] = ACTIONS(735),
    [sym__special_characters] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(737),
  },
  [473] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(1912),
    [sym_comment] = ACTIONS(53),
  },
  [474] = {
    [sym_concatenation] = STATE(916),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(916),
    [anon_sym_RBRACE] = ACTIONS(1914),
    [anon_sym_EQ] = ACTIONS(1916),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1918),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1920),
    [anon_sym_COLON] = ACTIONS(1916),
    [anon_sym_COLON_QMARK] = ACTIONS(1916),
    [anon_sym_COLON_DASH] = ACTIONS(1916),
    [anon_sym_PERCENT] = ACTIONS(1916),
    [anon_sym_DASH] = ACTIONS(1916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [475] = {
    [sym_subscript] = STATE(920),
    [sym_variable_name] = ACTIONS(1922),
    [anon_sym_DOLLAR] = ACTIONS(1924),
    [anon_sym_DASH] = ACTIONS(1924),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1926),
    [anon_sym_STAR] = ACTIONS(1924),
    [anon_sym_AT] = ACTIONS(1924),
    [anon_sym_QMARK] = ACTIONS(1924),
    [anon_sym_0] = ACTIONS(1928),
    [anon_sym__] = ACTIONS(1928),
  },
  [476] = {
    [sym_concatenation] = STATE(923),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(923),
    [anon_sym_RBRACE] = ACTIONS(1930),
    [anon_sym_EQ] = ACTIONS(1932),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1934),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1936),
    [anon_sym_COLON] = ACTIONS(1932),
    [anon_sym_COLON_QMARK] = ACTIONS(1932),
    [anon_sym_COLON_DASH] = ACTIONS(1932),
    [anon_sym_PERCENT] = ACTIONS(1932),
    [anon_sym_DASH] = ACTIONS(1932),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [477] = {
    [sym_concatenation] = STATE(926),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(926),
    [anon_sym_RBRACE] = ACTIONS(1938),
    [anon_sym_EQ] = ACTIONS(1940),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1942),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(1944),
    [anon_sym_COLON] = ACTIONS(1940),
    [anon_sym_COLON_QMARK] = ACTIONS(1940),
    [anon_sym_COLON_DASH] = ACTIONS(1940),
    [anon_sym_PERCENT] = ACTIONS(1940),
    [anon_sym_DASH] = ACTIONS(1940),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [478] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1946),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [479] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1946),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [480] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(1946),
    [sym_comment] = ACTIONS(53),
  },
  [481] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(1946),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [482] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1948),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [483] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1948),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [484] = {
    [anon_sym_RPAREN] = ACTIONS(1950),
    [sym_comment] = ACTIONS(53),
  },
  [485] = {
    [sym_for_statement] = STATE(930),
    [sym_while_statement] = STATE(930),
    [sym_if_statement] = STATE(930),
    [sym_case_statement] = STATE(930),
    [sym_function_definition] = STATE(930),
    [sym_subshell] = STATE(930),
    [sym_pipeline] = STATE(930),
    [sym_list] = STATE(930),
    [sym_negated_command] = STATE(930),
    [sym_test_command] = STATE(930),
    [sym_declaration_command] = STATE(930),
    [sym_unset_command] = STATE(930),
    [sym_command] = STATE(930),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(931),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [486] = {
    [sym__simple_heredoc_body] = ACTIONS(1952),
    [sym__heredoc_body_beginning] = ACTIONS(1952),
    [sym_file_descriptor] = ACTIONS(1952),
    [sym__concat] = ACTIONS(1952),
    [anon_sym_PIPE] = ACTIONS(1954),
    [anon_sym_RPAREN] = ACTIONS(1954),
    [anon_sym_SEMI_SEMI] = ACTIONS(1954),
    [anon_sym_PIPE_AMP] = ACTIONS(1954),
    [anon_sym_AMP_AMP] = ACTIONS(1954),
    [anon_sym_PIPE_PIPE] = ACTIONS(1954),
    [anon_sym_EQ_TILDE] = ACTIONS(1954),
    [anon_sym_EQ_EQ] = ACTIONS(1954),
    [anon_sym_LT] = ACTIONS(1954),
    [anon_sym_GT] = ACTIONS(1954),
    [anon_sym_GT_GT] = ACTIONS(1954),
    [anon_sym_AMP_GT] = ACTIONS(1954),
    [anon_sym_AMP_GT_GT] = ACTIONS(1954),
    [anon_sym_LT_AMP] = ACTIONS(1954),
    [anon_sym_GT_AMP] = ACTIONS(1954),
    [anon_sym_LT_LT] = ACTIONS(1954),
    [anon_sym_LT_LT_DASH] = ACTIONS(1954),
    [anon_sym_LT_LT_LT] = ACTIONS(1954),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1954),
    [anon_sym_DOLLAR] = ACTIONS(1954),
    [sym_raw_string] = ACTIONS(1954),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1954),
    [anon_sym_BQUOTE] = ACTIONS(1954),
    [anon_sym_LT_LPAREN] = ACTIONS(1954),
    [anon_sym_GT_LPAREN] = ACTIONS(1954),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1954),
    [anon_sym_SEMI] = ACTIONS(1954),
    [anon_sym_LF] = ACTIONS(1952),
    [anon_sym_AMP] = ACTIONS(1954),
  },
  [487] = {
    [sym_for_statement] = STATE(932),
    [sym_while_statement] = STATE(932),
    [sym_if_statement] = STATE(932),
    [sym_case_statement] = STATE(932),
    [sym_function_definition] = STATE(932),
    [sym_subshell] = STATE(932),
    [sym_pipeline] = STATE(932),
    [sym_list] = STATE(932),
    [sym_negated_command] = STATE(932),
    [sym_test_command] = STATE(932),
    [sym_declaration_command] = STATE(932),
    [sym_unset_command] = STATE(932),
    [sym_command] = STATE(932),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(933),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [488] = {
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_RPAREN] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [sym_comment] = ACTIONS(53),
  },
  [489] = {
    [sym_simple_expansion] = STATE(935),
    [sym_expansion] = STATE(935),
    [aux_sym_heredoc_body_repeat1] = STATE(935),
    [sym__heredoc_body_middle] = ACTIONS(1956),
    [sym__heredoc_body_end] = ACTIONS(1958),
    [anon_sym_DOLLAR] = ACTIONS(963),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(965),
    [sym_comment] = ACTIONS(53),
  },
  [490] = {
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1962),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT_GT] = ACTIONS(1962),
    [anon_sym_LT_AMP] = ACTIONS(1962),
    [anon_sym_GT_AMP] = ACTIONS(1962),
    [sym_comment] = ACTIONS(53),
  },
  [491] = {
    [sym_concatenation] = STATE(939),
    [sym_string] = STATE(938),
    [sym_simple_expansion] = STATE(938),
    [sym_string_expansion] = STATE(938),
    [sym_expansion] = STATE(938),
    [sym_command_substitution] = STATE(938),
    [sym_process_substitution] = STATE(938),
    [sym__special_characters] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(1966),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(1968),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1970),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1972),
    [anon_sym_BQUOTE] = ACTIONS(1974),
    [anon_sym_LT_LPAREN] = ACTIONS(1976),
    [anon_sym_GT_LPAREN] = ACTIONS(1976),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1968),
    [sym_regex] = ACTIONS(1978),
  },
  [492] = {
    [sym_concatenation] = STATE(942),
    [sym_string] = STATE(941),
    [sym_simple_expansion] = STATE(941),
    [sym_string_expansion] = STATE(941),
    [sym_expansion] = STATE(941),
    [sym_command_substitution] = STATE(941),
    [sym_process_substitution] = STATE(941),
    [sym__special_characters] = ACTIONS(1980),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(1982),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1982),
  },
  [493] = {
    [sym_heredoc_start] = ACTIONS(1984),
    [sym_comment] = ACTIONS(53),
  },
  [494] = {
    [sym_concatenation] = STATE(946),
    [sym_string] = STATE(945),
    [sym_simple_expansion] = STATE(945),
    [sym_string_expansion] = STATE(945),
    [sym_expansion] = STATE(945),
    [sym_command_substitution] = STATE(945),
    [sym_process_substitution] = STATE(945),
    [sym__special_characters] = ACTIONS(1986),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(1988),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1988),
  },
  [495] = {
    [aux_sym_concatenation_repeat1] = STATE(467),
    [sym__simple_heredoc_body] = ACTIONS(987),
    [sym__heredoc_body_beginning] = ACTIONS(987),
    [sym_file_descriptor] = ACTIONS(987),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(989),
    [anon_sym_RPAREN] = ACTIONS(987),
    [anon_sym_PIPE_AMP] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(987),
    [anon_sym_PIPE_PIPE] = ACTIONS(987),
    [anon_sym_EQ_TILDE] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(989),
    [anon_sym_LT] = ACTIONS(989),
    [anon_sym_GT] = ACTIONS(989),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_AMP_GT] = ACTIONS(989),
    [anon_sym_AMP_GT_GT] = ACTIONS(987),
    [anon_sym_LT_AMP] = ACTIONS(987),
    [anon_sym_GT_AMP] = ACTIONS(987),
    [anon_sym_LT_LT] = ACTIONS(989),
    [anon_sym_LT_LT_DASH] = ACTIONS(987),
    [anon_sym_LT_LT_LT] = ACTIONS(987),
    [sym__special_characters] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [anon_sym_DOLLAR] = ACTIONS(989),
    [sym_raw_string] = ACTIONS(987),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(987),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(987),
    [anon_sym_BQUOTE] = ACTIONS(987),
    [anon_sym_LT_LPAREN] = ACTIONS(987),
    [anon_sym_GT_LPAREN] = ACTIONS(987),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(989),
  },
  [496] = {
    [aux_sym_concatenation_repeat1] = STATE(467),
    [sym__simple_heredoc_body] = ACTIONS(991),
    [sym__heredoc_body_beginning] = ACTIONS(991),
    [sym_file_descriptor] = ACTIONS(991),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_RPAREN] = ACTIONS(991),
    [anon_sym_PIPE_AMP] = ACTIONS(991),
    [anon_sym_AMP_AMP] = ACTIONS(991),
    [anon_sym_PIPE_PIPE] = ACTIONS(991),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT] = ACTIONS(993),
    [anon_sym_GT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(991),
    [anon_sym_AMP_GT] = ACTIONS(993),
    [anon_sym_AMP_GT_GT] = ACTIONS(991),
    [anon_sym_LT_AMP] = ACTIONS(991),
    [anon_sym_GT_AMP] = ACTIONS(991),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_LT_LT_DASH] = ACTIONS(991),
    [anon_sym_LT_LT_LT] = ACTIONS(991),
    [sym__special_characters] = ACTIONS(991),
    [anon_sym_DQUOTE] = ACTIONS(991),
    [anon_sym_DOLLAR] = ACTIONS(993),
    [sym_raw_string] = ACTIONS(991),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(991),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(991),
    [anon_sym_BQUOTE] = ACTIONS(991),
    [anon_sym_LT_LPAREN] = ACTIONS(991),
    [anon_sym_GT_LPAREN] = ACTIONS(991),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(993),
  },
  [497] = {
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [sym_comment] = ACTIONS(53),
  },
  [498] = {
    [sym_file_redirect] = STATE(948),
    [sym_heredoc_redirect] = STATE(948),
    [sym_heredoc_body] = STATE(947),
    [sym_herestring_redirect] = STATE(948),
    [aux_sym_while_statement_repeat1] = STATE(948),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(887),
    [anon_sym_LT_AMP] = ACTIONS(887),
    [anon_sym_GT_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(893),
    [sym_comment] = ACTIONS(53),
  },
  [499] = {
    [sym_file_redirect] = STATE(949),
    [sym_heredoc_redirect] = STATE(949),
    [sym_heredoc_body] = STATE(947),
    [sym_herestring_redirect] = STATE(949),
    [sym_concatenation] = STATE(950),
    [sym_string] = STATE(496),
    [sym_simple_expansion] = STATE(496),
    [sym_string_expansion] = STATE(496),
    [sym_expansion] = STATE(496),
    [sym_command_substitution] = STATE(496),
    [sym_process_substitution] = STATE(496),
    [aux_sym_while_statement_repeat1] = STATE(949),
    [aux_sym_command_repeat2] = STATE(950),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(887),
    [anon_sym_LT_AMP] = ACTIONS(887),
    [anon_sym_GT_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(893),
    [sym__special_characters] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(897),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(899),
  },
  [500] = {
    [sym_file_redirect] = STATE(949),
    [sym_heredoc_redirect] = STATE(949),
    [sym_heredoc_body] = STATE(947),
    [sym_herestring_redirect] = STATE(949),
    [sym_concatenation] = STATE(951),
    [sym_string] = STATE(496),
    [sym_simple_expansion] = STATE(496),
    [sym_string_expansion] = STATE(496),
    [sym_expansion] = STATE(496),
    [sym_command_substitution] = STATE(496),
    [sym_process_substitution] = STATE(496),
    [aux_sym_while_statement_repeat1] = STATE(949),
    [aux_sym_command_repeat2] = STATE(951),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(887),
    [anon_sym_LT_AMP] = ACTIONS(887),
    [anon_sym_GT_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(893),
    [sym__special_characters] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(897),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(899),
  },
  [501] = {
    [sym_concatenation] = STATE(672),
    [sym_string] = STATE(953),
    [sym_array] = STATE(672),
    [sym_simple_expansion] = STATE(953),
    [sym_string_expansion] = STATE(953),
    [sym_expansion] = STATE(953),
    [sym_command_substitution] = STATE(953),
    [sym_process_substitution] = STATE(953),
    [sym__empty_value] = ACTIONS(1291),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [sym__special_characters] = ACTIONS(1990),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(1992),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1992),
  },
  [502] = {
    [sym_do_group] = STATE(954),
    [anon_sym_do] = ACTIONS(1834),
    [sym_comment] = ACTIONS(53),
  },
  [503] = {
    [sym_compound_statement] = STATE(956),
    [anon_sym_LPAREN] = ACTIONS(1994),
    [anon_sym_LBRACE] = ACTIONS(1852),
    [sym_comment] = ACTIONS(53),
  },
  [504] = {
    [anon_sym_AMP_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(543),
    [anon_sym_RBRACK] = ACTIONS(1996),
    [anon_sym_EQ_TILDE] = ACTIONS(547),
    [anon_sym_EQ_EQ] = ACTIONS(547),
    [anon_sym_EQ] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_BANG_EQ] = ACTIONS(543),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(543),
  },
  [505] = {
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1996),
    [anon_sym_EQ_TILDE] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(577),
    [anon_sym_LT] = ACTIONS(573),
    [anon_sym_GT] = ACTIONS(573),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(573),
  },
  [506] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(1998),
    [anon_sym_PLUS_EQ] = ACTIONS(1998),
    [sym_comment] = ACTIONS(53),
  },
  [507] = {
    [aux_sym_concatenation_repeat1] = STATE(959),
    [sym__concat] = ACTIONS(1864),
    [sym_variable_name] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(585),
    [anon_sym_PIPE_AMP] = ACTIONS(583),
    [anon_sym_AMP_AMP] = ACTIONS(583),
    [anon_sym_PIPE_PIPE] = ACTIONS(583),
    [sym__special_characters] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_DOLLAR] = ACTIONS(585),
    [sym_raw_string] = ACTIONS(583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LT_LPAREN] = ACTIONS(583),
    [anon_sym_GT_LPAREN] = ACTIONS(583),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(585),
    [sym_word] = ACTIONS(585),
  },
  [508] = {
    [aux_sym_concatenation_repeat1] = STATE(959),
    [sym__concat] = ACTIONS(1864),
    [sym_variable_name] = ACTIONS(599),
    [anon_sym_PIPE] = ACTIONS(601),
    [anon_sym_PIPE_AMP] = ACTIONS(599),
    [anon_sym_AMP_AMP] = ACTIONS(599),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [sym__special_characters] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(599),
    [anon_sym_DOLLAR] = ACTIONS(601),
    [sym_raw_string] = ACTIONS(599),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(599),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(599),
    [anon_sym_BQUOTE] = ACTIONS(599),
    [anon_sym_LT_LPAREN] = ACTIONS(599),
    [anon_sym_GT_LPAREN] = ACTIONS(599),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(601),
    [sym_word] = ACTIONS(601),
  },
  [509] = {
    [anon_sym_EQ] = ACTIONS(1998),
    [anon_sym_PLUS_EQ] = ACTIONS(1998),
    [sym_comment] = ACTIONS(53),
  },
  [510] = {
    [sym_variable_assignment] = STATE(960),
    [sym_subscript] = STATE(509),
    [sym_concatenation] = STATE(960),
    [sym_string] = STATE(508),
    [sym_simple_expansion] = STATE(508),
    [sym_string_expansion] = STATE(508),
    [sym_expansion] = STATE(508),
    [sym_command_substitution] = STATE(508),
    [sym_process_substitution] = STATE(508),
    [aux_sym_declaration_command_repeat1] = STATE(960),
    [sym_variable_name] = ACTIONS(907),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_PIPE_AMP] = ACTIONS(619),
    [anon_sym_AMP_AMP] = ACTIONS(619),
    [anon_sym_PIPE_PIPE] = ACTIONS(619),
    [sym__special_characters] = ACTIONS(909),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(815),
    [anon_sym_BQUOTE] = ACTIONS(619),
    [anon_sym_LT_LPAREN] = ACTIONS(819),
    [anon_sym_GT_LPAREN] = ACTIONS(819),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(821),
    [sym_word] = ACTIONS(913),
  },
  [511] = {
    [aux_sym_concatenation_repeat1] = STATE(961),
    [sym__concat] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(623),
    [anon_sym_PIPE_AMP] = ACTIONS(625),
    [anon_sym_AMP_AMP] = ACTIONS(625),
    [anon_sym_PIPE_PIPE] = ACTIONS(625),
    [sym__special_characters] = ACTIONS(625),
    [anon_sym_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [sym_raw_string] = ACTIONS(625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(625),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(625),
    [anon_sym_BQUOTE] = ACTIONS(625),
    [anon_sym_LT_LPAREN] = ACTIONS(625),
    [anon_sym_GT_LPAREN] = ACTIONS(625),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(623),
    [sym_word] = ACTIONS(623),
  },
  [512] = {
    [aux_sym_concatenation_repeat1] = STATE(961),
    [sym__concat] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(639),
    [anon_sym_PIPE_AMP] = ACTIONS(641),
    [anon_sym_AMP_AMP] = ACTIONS(641),
    [anon_sym_PIPE_PIPE] = ACTIONS(641),
    [sym__special_characters] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [anon_sym_DOLLAR] = ACTIONS(639),
    [sym_raw_string] = ACTIONS(641),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(641),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(641),
    [anon_sym_BQUOTE] = ACTIONS(641),
    [anon_sym_LT_LPAREN] = ACTIONS(641),
    [anon_sym_GT_LPAREN] = ACTIONS(641),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(639),
    [sym_word] = ACTIONS(639),
  },
  [513] = {
    [sym_concatenation] = STATE(962),
    [sym_string] = STATE(512),
    [sym_simple_expansion] = STATE(512),
    [sym_string_expansion] = STATE(512),
    [sym_expansion] = STATE(512),
    [sym_command_substitution] = STATE(512),
    [sym_process_substitution] = STATE(512),
    [aux_sym_unset_command_repeat1] = STATE(962),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_PIPE_AMP] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(659),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [sym__special_characters] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [sym_raw_string] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(659),
    [anon_sym_LT_LPAREN] = ACTIONS(839),
    [anon_sym_GT_LPAREN] = ACTIONS(839),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(841),
    [sym_word] = ACTIONS(919),
  },
  [514] = {
    [aux_sym_concatenation_repeat1] = STATE(963),
    [sym__simple_heredoc_body] = ACTIONS(693),
    [sym__heredoc_body_beginning] = ACTIONS(693),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_EQ_TILDE] = ACTIONS(695),
    [anon_sym_EQ_EQ] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(693),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(693),
    [anon_sym_LT_AMP] = ACTIONS(693),
    [anon_sym_GT_AMP] = ACTIONS(693),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(693),
    [anon_sym_LT_LT_LT] = ACTIONS(693),
    [sym__special_characters] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(695),
  },
  [515] = {
    [anon_sym_RPAREN] = ACTIONS(2000),
    [sym_comment] = ACTIONS(53),
  },
  [516] = {
    [sym_for_statement] = STATE(930),
    [sym_while_statement] = STATE(930),
    [sym_if_statement] = STATE(930),
    [sym_case_statement] = STATE(930),
    [sym_function_definition] = STATE(930),
    [sym_subshell] = STATE(930),
    [sym_pipeline] = STATE(930),
    [sym_list] = STATE(930),
    [sym_negated_command] = STATE(930),
    [sym_test_command] = STATE(930),
    [sym_declaration_command] = STATE(930),
    [sym_unset_command] = STATE(930),
    [sym_command] = STATE(930),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(965),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [517] = {
    [sym_for_statement] = STATE(966),
    [sym_while_statement] = STATE(966),
    [sym_if_statement] = STATE(966),
    [sym_case_statement] = STATE(966),
    [sym_function_definition] = STATE(966),
    [sym_subshell] = STATE(966),
    [sym_pipeline] = STATE(966),
    [sym_list] = STATE(966),
    [sym_negated_command] = STATE(966),
    [sym_test_command] = STATE(966),
    [sym_declaration_command] = STATE(966),
    [sym_unset_command] = STATE(966),
    [sym_command] = STATE(966),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(967),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [518] = {
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_GT] = ACTIONS(2002),
    [anon_sym_GT_GT] = ACTIONS(2004),
    [anon_sym_AMP_GT] = ACTIONS(2002),
    [anon_sym_AMP_GT_GT] = ACTIONS(2004),
    [anon_sym_LT_AMP] = ACTIONS(2004),
    [anon_sym_GT_AMP] = ACTIONS(2004),
    [sym_comment] = ACTIONS(53),
  },
  [519] = {
    [sym_concatenation] = STATE(939),
    [sym_string] = STATE(970),
    [sym_simple_expansion] = STATE(970),
    [sym_string_expansion] = STATE(970),
    [sym_expansion] = STATE(970),
    [sym_command_substitution] = STATE(970),
    [sym_process_substitution] = STATE(970),
    [sym__special_characters] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(1966),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(2008),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1970),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1972),
    [anon_sym_BQUOTE] = ACTIONS(1974),
    [anon_sym_LT_LPAREN] = ACTIONS(1976),
    [anon_sym_GT_LPAREN] = ACTIONS(1976),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2008),
    [sym_regex] = ACTIONS(1978),
  },
  [520] = {
    [sym_concatenation] = STATE(942),
    [sym_string] = STATE(972),
    [sym_simple_expansion] = STATE(972),
    [sym_string_expansion] = STATE(972),
    [sym_expansion] = STATE(972),
    [sym_command_substitution] = STATE(972),
    [sym_process_substitution] = STATE(972),
    [sym__special_characters] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(2012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2012),
  },
  [521] = {
    [sym_concatenation] = STATE(946),
    [sym_string] = STATE(974),
    [sym_simple_expansion] = STATE(974),
    [sym_string_expansion] = STATE(974),
    [sym_expansion] = STATE(974),
    [sym_command_substitution] = STATE(974),
    [sym_process_substitution] = STATE(974),
    [sym__special_characters] = ACTIONS(2014),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(2016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2016),
  },
  [522] = {
    [aux_sym_concatenation_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(987),
    [sym__heredoc_body_beginning] = ACTIONS(987),
    [sym_file_descriptor] = ACTIONS(987),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(989),
    [anon_sym_PIPE_AMP] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(987),
    [anon_sym_PIPE_PIPE] = ACTIONS(987),
    [anon_sym_EQ_TILDE] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(989),
    [anon_sym_LT] = ACTIONS(989),
    [anon_sym_GT] = ACTIONS(989),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_AMP_GT] = ACTIONS(989),
    [anon_sym_AMP_GT_GT] = ACTIONS(987),
    [anon_sym_LT_AMP] = ACTIONS(987),
    [anon_sym_GT_AMP] = ACTIONS(987),
    [anon_sym_LT_LT] = ACTIONS(989),
    [anon_sym_LT_LT_DASH] = ACTIONS(987),
    [anon_sym_LT_LT_LT] = ACTIONS(987),
    [sym__special_characters] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [anon_sym_DOLLAR] = ACTIONS(989),
    [sym_raw_string] = ACTIONS(987),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(987),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(987),
    [anon_sym_BQUOTE] = ACTIONS(987),
    [anon_sym_LT_LPAREN] = ACTIONS(987),
    [anon_sym_GT_LPAREN] = ACTIONS(987),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(989),
  },
  [523] = {
    [aux_sym_concatenation_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(991),
    [sym__heredoc_body_beginning] = ACTIONS(991),
    [sym_file_descriptor] = ACTIONS(991),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_PIPE_AMP] = ACTIONS(991),
    [anon_sym_AMP_AMP] = ACTIONS(991),
    [anon_sym_PIPE_PIPE] = ACTIONS(991),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT] = ACTIONS(993),
    [anon_sym_GT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(991),
    [anon_sym_AMP_GT] = ACTIONS(993),
    [anon_sym_AMP_GT_GT] = ACTIONS(991),
    [anon_sym_LT_AMP] = ACTIONS(991),
    [anon_sym_GT_AMP] = ACTIONS(991),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_LT_LT_DASH] = ACTIONS(991),
    [anon_sym_LT_LT_LT] = ACTIONS(991),
    [sym__special_characters] = ACTIONS(991),
    [anon_sym_DQUOTE] = ACTIONS(991),
    [anon_sym_DOLLAR] = ACTIONS(993),
    [sym_raw_string] = ACTIONS(991),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(991),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(991),
    [anon_sym_BQUOTE] = ACTIONS(991),
    [anon_sym_LT_LPAREN] = ACTIONS(991),
    [anon_sym_GT_LPAREN] = ACTIONS(991),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(993),
  },
  [524] = {
    [sym_file_redirect] = STATE(975),
    [sym_heredoc_redirect] = STATE(975),
    [sym_heredoc_body] = STATE(947),
    [sym_herestring_redirect] = STATE(975),
    [aux_sym_while_statement_repeat1] = STATE(975),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(933),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(937),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [sym_comment] = ACTIONS(53),
  },
  [525] = {
    [sym_file_redirect] = STATE(976),
    [sym_heredoc_redirect] = STATE(976),
    [sym_heredoc_body] = STATE(947),
    [sym_herestring_redirect] = STATE(976),
    [sym_concatenation] = STATE(977),
    [sym_string] = STATE(523),
    [sym_simple_expansion] = STATE(523),
    [sym_string_expansion] = STATE(523),
    [sym_expansion] = STATE(523),
    [sym_command_substitution] = STATE(523),
    [sym_process_substitution] = STATE(523),
    [aux_sym_while_statement_repeat1] = STATE(976),
    [aux_sym_command_repeat2] = STATE(977),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(931),
    [anon_sym_EQ_EQ] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(933),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(937),
    [sym__special_characters] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(941),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(943),
  },
  [526] = {
    [sym_file_redirect] = STATE(976),
    [sym_heredoc_redirect] = STATE(976),
    [sym_heredoc_body] = STATE(947),
    [sym_herestring_redirect] = STATE(976),
    [sym_concatenation] = STATE(978),
    [sym_string] = STATE(523),
    [sym_simple_expansion] = STATE(523),
    [sym_string_expansion] = STATE(523),
    [sym_expansion] = STATE(523),
    [sym_command_substitution] = STATE(523),
    [sym_process_substitution] = STATE(523),
    [aux_sym_while_statement_repeat1] = STATE(976),
    [aux_sym_command_repeat2] = STATE(978),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(931),
    [anon_sym_EQ_EQ] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(933),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(937),
    [sym__special_characters] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(941),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(943),
  },
  [527] = {
    [sym__simple_heredoc_body] = ACTIONS(2018),
    [sym__heredoc_body_beginning] = ACTIONS(2018),
    [sym_file_descriptor] = ACTIONS(2018),
    [sym__concat] = ACTIONS(2018),
    [anon_sym_PIPE] = ACTIONS(2020),
    [anon_sym_RPAREN] = ACTIONS(2020),
    [anon_sym_SEMI_SEMI] = ACTIONS(2020),
    [anon_sym_PIPE_AMP] = ACTIONS(2020),
    [anon_sym_AMP_AMP] = ACTIONS(2020),
    [anon_sym_PIPE_PIPE] = ACTIONS(2020),
    [anon_sym_EQ_TILDE] = ACTIONS(2020),
    [anon_sym_EQ_EQ] = ACTIONS(2020),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(2020),
    [anon_sym_GT_GT] = ACTIONS(2020),
    [anon_sym_AMP_GT] = ACTIONS(2020),
    [anon_sym_AMP_GT_GT] = ACTIONS(2020),
    [anon_sym_LT_AMP] = ACTIONS(2020),
    [anon_sym_GT_AMP] = ACTIONS(2020),
    [anon_sym_LT_LT] = ACTIONS(2020),
    [anon_sym_LT_LT_DASH] = ACTIONS(2020),
    [anon_sym_LT_LT_LT] = ACTIONS(2020),
    [sym__special_characters] = ACTIONS(2020),
    [anon_sym_DQUOTE] = ACTIONS(2020),
    [anon_sym_DOLLAR] = ACTIONS(2020),
    [sym_raw_string] = ACTIONS(2020),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2020),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2020),
    [anon_sym_BQUOTE] = ACTIONS(2020),
    [anon_sym_LT_LPAREN] = ACTIONS(2020),
    [anon_sym_GT_LPAREN] = ACTIONS(2020),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2020),
    [anon_sym_SEMI] = ACTIONS(2020),
    [anon_sym_LF] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2020),
  },
  [528] = {
    [sym_compound_statement] = STATE(979),
    [anon_sym_LBRACE] = ACTIONS(455),
    [sym_comment] = ACTIONS(53),
  },
  [529] = {
    [anon_sym_esac] = ACTIONS(2022),
    [anon_sym_PIPE] = ACTIONS(2022),
    [anon_sym_RPAREN] = ACTIONS(2022),
    [anon_sym_SEMI_SEMI] = ACTIONS(2022),
    [anon_sym_PIPE_AMP] = ACTIONS(2022),
    [anon_sym_AMP_AMP] = ACTIONS(2022),
    [anon_sym_PIPE_PIPE] = ACTIONS(2022),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2022),
    [anon_sym_LF] = ACTIONS(2024),
    [anon_sym_AMP] = ACTIONS(2022),
  },
  [530] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(2022),
    [anon_sym_RPAREN] = ACTIONS(2022),
    [anon_sym_SEMI_SEMI] = ACTIONS(2022),
    [anon_sym_PIPE_AMP] = ACTIONS(2022),
    [anon_sym_AMP_AMP] = ACTIONS(2022),
    [anon_sym_PIPE_PIPE] = ACTIONS(2022),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(2022),
    [anon_sym_LF] = ACTIONS(2024),
    [anon_sym_AMP] = ACTIONS(2022),
  },
  [531] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(2026),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(2026),
    [anon_sym_PIPE_PIPE] = ACTIONS(2026),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2026),
    [anon_sym_LF] = ACTIONS(2028),
    [anon_sym_AMP] = ACTIONS(2026),
  },
  [532] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(2026),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(2026),
    [anon_sym_PIPE_PIPE] = ACTIONS(2026),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(2026),
    [anon_sym_LF] = ACTIONS(2028),
    [anon_sym_AMP] = ACTIONS(2026),
  },
  [533] = {
    [anon_sym_esac] = ACTIONS(2030),
    [anon_sym_PIPE] = ACTIONS(2030),
    [anon_sym_RPAREN] = ACTIONS(2030),
    [anon_sym_SEMI_SEMI] = ACTIONS(2030),
    [anon_sym_PIPE_AMP] = ACTIONS(2030),
    [anon_sym_AMP_AMP] = ACTIONS(2030),
    [anon_sym_PIPE_PIPE] = ACTIONS(2030),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2030),
    [anon_sym_LF] = ACTIONS(2032),
    [anon_sym_AMP] = ACTIONS(2030),
  },
  [534] = {
    [anon_sym_DOLLAR] = ACTIONS(2034),
    [anon_sym_POUND] = ACTIONS(2034),
    [anon_sym_DASH] = ACTIONS(2034),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(2034),
    [anon_sym_AT] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(2034),
    [anon_sym_0] = ACTIONS(2038),
    [anon_sym__] = ACTIONS(2038),
  },
  [535] = {
    [sym_subscript] = STATE(986),
    [sym_variable_name] = ACTIONS(2040),
    [anon_sym_DOLLAR] = ACTIONS(2042),
    [anon_sym_POUND] = ACTIONS(2044),
    [anon_sym_DASH] = ACTIONS(2042),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(2042),
    [anon_sym_AT] = ACTIONS(2042),
    [anon_sym_QMARK] = ACTIONS(2042),
    [anon_sym_0] = ACTIONS(2048),
    [anon_sym__] = ACTIONS(2048),
  },
  [536] = {
    [sym_simple_expansion] = STATE(988),
    [sym_expansion] = STATE(988),
    [aux_sym_heredoc_body_repeat1] = STATE(988),
    [sym__heredoc_body_middle] = ACTIONS(2050),
    [sym__heredoc_body_end] = ACTIONS(2052),
    [anon_sym_DOLLAR] = ACTIONS(963),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(965),
    [sym_comment] = ACTIONS(53),
  },
  [537] = {
    [sym_concatenation] = STATE(991),
    [sym_string] = STATE(990),
    [sym_simple_expansion] = STATE(990),
    [sym_string_expansion] = STATE(990),
    [sym_expansion] = STATE(990),
    [sym_command_substitution] = STATE(990),
    [sym_process_substitution] = STATE(990),
    [sym__special_characters] = ACTIONS(2054),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(2056),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2056),
  },
  [538] = {
    [aux_sym_concatenation_repeat1] = STATE(126),
    [sym__simple_heredoc_body] = ACTIONS(2058),
    [sym__heredoc_body_beginning] = ACTIONS(2058),
    [sym_file_descriptor] = ACTIONS(2058),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(2060),
    [anon_sym_SEMI_SEMI] = ACTIONS(2060),
    [anon_sym_PIPE_AMP] = ACTIONS(2060),
    [anon_sym_AMP_AMP] = ACTIONS(2060),
    [anon_sym_PIPE_PIPE] = ACTIONS(2060),
    [anon_sym_EQ_TILDE] = ACTIONS(2060),
    [anon_sym_EQ_EQ] = ACTIONS(2060),
    [anon_sym_LT] = ACTIONS(2060),
    [anon_sym_GT] = ACTIONS(2060),
    [anon_sym_GT_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT_GT] = ACTIONS(2060),
    [anon_sym_LT_AMP] = ACTIONS(2060),
    [anon_sym_GT_AMP] = ACTIONS(2060),
    [anon_sym_LT_LT] = ACTIONS(2060),
    [anon_sym_LT_LT_DASH] = ACTIONS(2060),
    [anon_sym_LT_LT_LT] = ACTIONS(2060),
    [sym__special_characters] = ACTIONS(2060),
    [anon_sym_DQUOTE] = ACTIONS(2060),
    [anon_sym_DOLLAR] = ACTIONS(2060),
    [sym_raw_string] = ACTIONS(2060),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2060),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2060),
    [anon_sym_BQUOTE] = ACTIONS(2060),
    [anon_sym_LT_LPAREN] = ACTIONS(2060),
    [anon_sym_GT_LPAREN] = ACTIONS(2060),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2060),
    [anon_sym_LF] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2060),
  },
  [539] = {
    [aux_sym_concatenation_repeat1] = STATE(126),
    [sym__simple_heredoc_body] = ACTIONS(2062),
    [sym__heredoc_body_beginning] = ACTIONS(2062),
    [sym_file_descriptor] = ACTIONS(2062),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_SEMI_SEMI] = ACTIONS(2064),
    [anon_sym_PIPE_AMP] = ACTIONS(2064),
    [anon_sym_AMP_AMP] = ACTIONS(2064),
    [anon_sym_PIPE_PIPE] = ACTIONS(2064),
    [anon_sym_EQ_TILDE] = ACTIONS(2064),
    [anon_sym_EQ_EQ] = ACTIONS(2064),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2064),
    [anon_sym_LT_AMP] = ACTIONS(2064),
    [anon_sym_GT_AMP] = ACTIONS(2064),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2064),
    [anon_sym_LT_LT_LT] = ACTIONS(2064),
    [sym__special_characters] = ACTIONS(2064),
    [anon_sym_DQUOTE] = ACTIONS(2064),
    [anon_sym_DOLLAR] = ACTIONS(2064),
    [sym_raw_string] = ACTIONS(2064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2064),
    [anon_sym_BQUOTE] = ACTIONS(2064),
    [anon_sym_LT_LPAREN] = ACTIONS(2064),
    [anon_sym_GT_LPAREN] = ACTIONS(2064),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2064),
    [anon_sym_SEMI] = ACTIONS(2064),
    [anon_sym_LF] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2064),
  },
  [540] = {
    [sym__simple_heredoc_body] = ACTIONS(2062),
    [sym__heredoc_body_beginning] = ACTIONS(2062),
    [sym_file_descriptor] = ACTIONS(2062),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_RPAREN] = ACTIONS(2064),
    [anon_sym_SEMI_SEMI] = ACTIONS(2064),
    [anon_sym_PIPE_AMP] = ACTIONS(2064),
    [anon_sym_AMP_AMP] = ACTIONS(2064),
    [anon_sym_PIPE_PIPE] = ACTIONS(2064),
    [anon_sym_EQ_TILDE] = ACTIONS(2064),
    [anon_sym_EQ_EQ] = ACTIONS(2064),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2064),
    [anon_sym_LT_AMP] = ACTIONS(2064),
    [anon_sym_GT_AMP] = ACTIONS(2064),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2064),
    [anon_sym_LT_LT_LT] = ACTIONS(2064),
    [sym__special_characters] = ACTIONS(2064),
    [anon_sym_DQUOTE] = ACTIONS(2064),
    [anon_sym_DOLLAR] = ACTIONS(2064),
    [sym_raw_string] = ACTIONS(2064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2064),
    [anon_sym_BQUOTE] = ACTIONS(2064),
    [anon_sym_LT_LPAREN] = ACTIONS(2064),
    [anon_sym_GT_LPAREN] = ACTIONS(2064),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2064),
    [anon_sym_SEMI] = ACTIONS(2064),
    [anon_sym_LF] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2064),
  },
  [541] = {
    [aux_sym_concatenation_repeat1] = STATE(992),
    [sym__simple_heredoc_body] = ACTIONS(661),
    [sym__heredoc_body_beginning] = ACTIONS(661),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(665),
    [anon_sym_AMP_AMP] = ACTIONS(665),
    [anon_sym_PIPE_PIPE] = ACTIONS(665),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(665),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(665),
    [anon_sym_LT_AMP] = ACTIONS(665),
    [anon_sym_GT_AMP] = ACTIONS(665),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(665),
    [anon_sym_LT_LT_LT] = ACTIONS(665),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [542] = {
    [aux_sym_concatenation_repeat1] = STATE(992),
    [sym__simple_heredoc_body] = ACTIONS(677),
    [sym__heredoc_body_beginning] = ACTIONS(677),
    [sym_file_descriptor] = ACTIONS(677),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [543] = {
    [sym__simple_heredoc_body] = ACTIONS(677),
    [sym__heredoc_body_beginning] = ACTIONS(677),
    [sym_file_descriptor] = ACTIONS(677),
    [anon_sym_esac] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [544] = {
    [sym__simple_heredoc_body] = ACTIONS(2066),
    [sym__heredoc_body_beginning] = ACTIONS(2066),
    [sym_file_descriptor] = ACTIONS(2066),
    [anon_sym_esac] = ACTIONS(2068),
    [anon_sym_PIPE] = ACTIONS(2068),
    [anon_sym_RPAREN] = ACTIONS(2068),
    [anon_sym_SEMI_SEMI] = ACTIONS(2068),
    [anon_sym_PIPE_AMP] = ACTIONS(2068),
    [anon_sym_AMP_AMP] = ACTIONS(2068),
    [anon_sym_PIPE_PIPE] = ACTIONS(2068),
    [anon_sym_LT] = ACTIONS(2068),
    [anon_sym_GT] = ACTIONS(2068),
    [anon_sym_GT_GT] = ACTIONS(2068),
    [anon_sym_AMP_GT] = ACTIONS(2068),
    [anon_sym_AMP_GT_GT] = ACTIONS(2068),
    [anon_sym_LT_AMP] = ACTIONS(2068),
    [anon_sym_GT_AMP] = ACTIONS(2068),
    [anon_sym_LT_LT] = ACTIONS(2068),
    [anon_sym_LT_LT_DASH] = ACTIONS(2068),
    [anon_sym_LT_LT_LT] = ACTIONS(2068),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2068),
    [anon_sym_LF] = ACTIONS(2066),
    [anon_sym_AMP] = ACTIONS(2068),
  },
  [545] = {
    [aux_sym_concatenation_repeat1] = STATE(992),
    [sym__simple_heredoc_body] = ACTIONS(2070),
    [sym__heredoc_body_beginning] = ACTIONS(2070),
    [sym_file_descriptor] = ACTIONS(2070),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(2072),
    [anon_sym_SEMI_SEMI] = ACTIONS(2072),
    [anon_sym_PIPE_AMP] = ACTIONS(2072),
    [anon_sym_AMP_AMP] = ACTIONS(2072),
    [anon_sym_PIPE_PIPE] = ACTIONS(2072),
    [anon_sym_LT] = ACTIONS(2072),
    [anon_sym_GT] = ACTIONS(2072),
    [anon_sym_GT_GT] = ACTIONS(2072),
    [anon_sym_AMP_GT] = ACTIONS(2072),
    [anon_sym_AMP_GT_GT] = ACTIONS(2072),
    [anon_sym_LT_AMP] = ACTIONS(2072),
    [anon_sym_GT_AMP] = ACTIONS(2072),
    [anon_sym_LT_LT] = ACTIONS(2072),
    [anon_sym_LT_LT_DASH] = ACTIONS(2072),
    [anon_sym_LT_LT_LT] = ACTIONS(2072),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2072),
    [anon_sym_LF] = ACTIONS(2070),
    [anon_sym_AMP] = ACTIONS(2072),
  },
  [546] = {
    [aux_sym_concatenation_repeat1] = STATE(992),
    [sym__simple_heredoc_body] = ACTIONS(2074),
    [sym__heredoc_body_beginning] = ACTIONS(2074),
    [sym_file_descriptor] = ACTIONS(2074),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(2076),
    [anon_sym_SEMI_SEMI] = ACTIONS(2076),
    [anon_sym_PIPE_AMP] = ACTIONS(2076),
    [anon_sym_AMP_AMP] = ACTIONS(2076),
    [anon_sym_PIPE_PIPE] = ACTIONS(2076),
    [anon_sym_LT] = ACTIONS(2076),
    [anon_sym_GT] = ACTIONS(2076),
    [anon_sym_GT_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT_GT] = ACTIONS(2076),
    [anon_sym_LT_AMP] = ACTIONS(2076),
    [anon_sym_GT_AMP] = ACTIONS(2076),
    [anon_sym_LT_LT] = ACTIONS(2076),
    [anon_sym_LT_LT_DASH] = ACTIONS(2076),
    [anon_sym_LT_LT_LT] = ACTIONS(2076),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2076),
    [anon_sym_LF] = ACTIONS(2074),
    [anon_sym_AMP] = ACTIONS(2076),
  },
  [547] = {
    [sym__simple_heredoc_body] = ACTIONS(2074),
    [sym__heredoc_body_beginning] = ACTIONS(2074),
    [sym_file_descriptor] = ACTIONS(2074),
    [anon_sym_esac] = ACTIONS(2076),
    [anon_sym_PIPE] = ACTIONS(2076),
    [anon_sym_RPAREN] = ACTIONS(2076),
    [anon_sym_SEMI_SEMI] = ACTIONS(2076),
    [anon_sym_PIPE_AMP] = ACTIONS(2076),
    [anon_sym_AMP_AMP] = ACTIONS(2076),
    [anon_sym_PIPE_PIPE] = ACTIONS(2076),
    [anon_sym_LT] = ACTIONS(2076),
    [anon_sym_GT] = ACTIONS(2076),
    [anon_sym_GT_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT_GT] = ACTIONS(2076),
    [anon_sym_LT_AMP] = ACTIONS(2076),
    [anon_sym_GT_AMP] = ACTIONS(2076),
    [anon_sym_LT_LT] = ACTIONS(2076),
    [anon_sym_LT_LT_DASH] = ACTIONS(2076),
    [anon_sym_LT_LT_LT] = ACTIONS(2076),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2076),
    [anon_sym_LF] = ACTIONS(2074),
    [anon_sym_AMP] = ACTIONS(2076),
  },
  [548] = {
    [anon_sym_esac] = ACTIONS(2078),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_RPAREN] = ACTIONS(2078),
    [anon_sym_SEMI_SEMI] = ACTIONS(2078),
    [anon_sym_PIPE_AMP] = ACTIONS(2078),
    [anon_sym_AMP_AMP] = ACTIONS(2078),
    [anon_sym_PIPE_PIPE] = ACTIONS(2078),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_LF] = ACTIONS(2080),
    [anon_sym_AMP] = ACTIONS(2078),
  },
  [549] = {
    [sym_file_redirect] = STATE(549),
    [sym_heredoc_redirect] = STATE(549),
    [sym_herestring_redirect] = STATE(549),
    [aux_sym_while_statement_repeat1] = STATE(549),
    [sym__simple_heredoc_body] = ACTIONS(2082),
    [sym__heredoc_body_beginning] = ACTIONS(2082),
    [sym_file_descriptor] = ACTIONS(2084),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_SEMI_SEMI] = ACTIONS(2087),
    [anon_sym_PIPE_AMP] = ACTIONS(2087),
    [anon_sym_AMP_AMP] = ACTIONS(2087),
    [anon_sym_PIPE_PIPE] = ACTIONS(2087),
    [anon_sym_LT] = ACTIONS(2089),
    [anon_sym_GT] = ACTIONS(2089),
    [anon_sym_GT_GT] = ACTIONS(2089),
    [anon_sym_AMP_GT] = ACTIONS(2089),
    [anon_sym_AMP_GT_GT] = ACTIONS(2089),
    [anon_sym_LT_AMP] = ACTIONS(2089),
    [anon_sym_GT_AMP] = ACTIONS(2089),
    [anon_sym_LT_LT] = ACTIONS(2092),
    [anon_sym_LT_LT_DASH] = ACTIONS(2092),
    [anon_sym_LT_LT_LT] = ACTIONS(2095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2087),
    [anon_sym_LF] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2087),
  },
  [550] = {
    [sym_file_redirect] = STATE(549),
    [sym_heredoc_redirect] = STATE(549),
    [sym_heredoc_body] = STATE(993),
    [sym_herestring_redirect] = STATE(549),
    [aux_sym_while_statement_repeat1] = STATE(549),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_SEMI_SEMI] = ACTIONS(2078),
    [anon_sym_PIPE_AMP] = ACTIONS(2078),
    [anon_sym_AMP_AMP] = ACTIONS(2078),
    [anon_sym_PIPE_PIPE] = ACTIONS(2078),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(347),
    [anon_sym_AMP_GT] = ACTIONS(347),
    [anon_sym_AMP_GT_GT] = ACTIONS(347),
    [anon_sym_LT_AMP] = ACTIONS(347),
    [anon_sym_GT_AMP] = ACTIONS(347),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(351),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_LF] = ACTIONS(2080),
    [anon_sym_AMP] = ACTIONS(2078),
  },
  [551] = {
    [sym_concatenation] = STATE(551),
    [sym_string] = STATE(199),
    [sym_simple_expansion] = STATE(199),
    [sym_string_expansion] = STATE(199),
    [sym_expansion] = STATE(199),
    [sym_command_substitution] = STATE(199),
    [sym_process_substitution] = STATE(199),
    [aux_sym_command_repeat2] = STATE(551),
    [sym__simple_heredoc_body] = ACTIONS(2062),
    [sym__heredoc_body_beginning] = ACTIONS(2062),
    [sym_file_descriptor] = ACTIONS(2062),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_SEMI_SEMI] = ACTIONS(2064),
    [anon_sym_PIPE_AMP] = ACTIONS(2064),
    [anon_sym_AMP_AMP] = ACTIONS(2064),
    [anon_sym_PIPE_PIPE] = ACTIONS(2064),
    [anon_sym_EQ_TILDE] = ACTIONS(2098),
    [anon_sym_EQ_EQ] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2064),
    [anon_sym_LT_AMP] = ACTIONS(2064),
    [anon_sym_GT_AMP] = ACTIONS(2064),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2064),
    [anon_sym_LT_LT_LT] = ACTIONS(2064),
    [sym__special_characters] = ACTIONS(2101),
    [anon_sym_DQUOTE] = ACTIONS(2104),
    [anon_sym_DOLLAR] = ACTIONS(2107),
    [sym_raw_string] = ACTIONS(2110),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2113),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2116),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [anon_sym_LT_LPAREN] = ACTIONS(2122),
    [anon_sym_GT_LPAREN] = ACTIONS(2122),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2110),
    [anon_sym_SEMI] = ACTIONS(2064),
    [anon_sym_LF] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2064),
  },
  [552] = {
    [sym_file_redirect] = STATE(994),
    [sym_heredoc_redirect] = STATE(994),
    [sym_heredoc_body] = STATE(993),
    [sym_herestring_redirect] = STATE(994),
    [sym_concatenation] = STATE(551),
    [sym_string] = STATE(199),
    [sym_simple_expansion] = STATE(199),
    [sym_string_expansion] = STATE(199),
    [sym_expansion] = STATE(199),
    [sym_command_substitution] = STATE(199),
    [sym_process_substitution] = STATE(199),
    [aux_sym_while_statement_repeat1] = STATE(994),
    [aux_sym_command_repeat2] = STATE(551),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_SEMI_SEMI] = ACTIONS(2078),
    [anon_sym_PIPE_AMP] = ACTIONS(2078),
    [anon_sym_AMP_AMP] = ACTIONS(2078),
    [anon_sym_PIPE_PIPE] = ACTIONS(2078),
    [anon_sym_EQ_TILDE] = ACTIONS(345),
    [anon_sym_EQ_EQ] = ACTIONS(345),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(347),
    [anon_sym_AMP_GT] = ACTIONS(347),
    [anon_sym_AMP_GT_GT] = ACTIONS(347),
    [anon_sym_LT_AMP] = ACTIONS(347),
    [anon_sym_GT_AMP] = ACTIONS(347),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(351),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(357),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(357),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_LF] = ACTIONS(2080),
    [anon_sym_AMP] = ACTIONS(2078),
  },
  [553] = {
    [sym_string] = STATE(681),
    [sym_simple_expansion] = STATE(681),
    [sym_string_expansion] = STATE(681),
    [sym_expansion] = STATE(681),
    [sym_command_substitution] = STATE(681),
    [sym_process_substitution] = STATE(681),
    [anon_sym_RBRACK] = ACTIONS(2125),
    [sym__special_characters] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(1309),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1309),
  },
  [554] = {
    [sym__concat] = ACTIONS(2129),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_PLUS_EQ] = ACTIONS(2131),
    [sym_comment] = ACTIONS(53),
  },
  [555] = {
    [aux_sym_concatenation_repeat1] = STATE(997),
    [sym__concat] = ACTIONS(513),
    [anon_sym_RBRACK] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
  },
  [556] = {
    [sym_string] = STATE(681),
    [sym_simple_expansion] = STATE(681),
    [sym_string_expansion] = STATE(681),
    [sym_expansion] = STATE(681),
    [sym_command_substitution] = STATE(681),
    [sym_process_substitution] = STATE(681),
    [anon_sym_RBRACK] = ACTIONS(2133),
    [sym__special_characters] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(1309),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1309),
  },
  [557] = {
    [sym__concat] = ACTIONS(2135),
    [anon_sym_EQ] = ACTIONS(2137),
    [anon_sym_PLUS_EQ] = ACTIONS(2137),
    [sym_comment] = ACTIONS(53),
  },
  [558] = {
    [anon_sym_RBRACK] = ACTIONS(2133),
    [sym_comment] = ACTIONS(53),
  },
  [559] = {
    [sym_file_descriptor] = ACTIONS(2139),
    [sym_variable_name] = ACTIONS(2139),
    [anon_sym_PIPE] = ACTIONS(2141),
    [anon_sym_RPAREN] = ACTIONS(2141),
    [anon_sym_SEMI_SEMI] = ACTIONS(2141),
    [anon_sym_PIPE_AMP] = ACTIONS(2141),
    [anon_sym_AMP_AMP] = ACTIONS(2141),
    [anon_sym_PIPE_PIPE] = ACTIONS(2141),
    [anon_sym_LT] = ACTIONS(2141),
    [anon_sym_GT] = ACTIONS(2141),
    [anon_sym_GT_GT] = ACTIONS(2141),
    [anon_sym_AMP_GT] = ACTIONS(2141),
    [anon_sym_AMP_GT_GT] = ACTIONS(2141),
    [anon_sym_LT_AMP] = ACTIONS(2141),
    [anon_sym_GT_AMP] = ACTIONS(2141),
    [sym__special_characters] = ACTIONS(2141),
    [anon_sym_DQUOTE] = ACTIONS(2141),
    [anon_sym_DOLLAR] = ACTIONS(2141),
    [sym_raw_string] = ACTIONS(2141),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2141),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2141),
    [anon_sym_BQUOTE] = ACTIONS(2141),
    [anon_sym_LT_LPAREN] = ACTIONS(2141),
    [anon_sym_GT_LPAREN] = ACTIONS(2141),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2141),
    [anon_sym_SEMI] = ACTIONS(2141),
    [anon_sym_LF] = ACTIONS(2139),
    [anon_sym_AMP] = ACTIONS(2141),
  },
  [560] = {
    [aux_sym_concatenation_repeat1] = STATE(1001),
    [sym__concat] = ACTIONS(2143),
    [anon_sym_RPAREN] = ACTIONS(2145),
    [sym__special_characters] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2145),
    [anon_sym_DOLLAR] = ACTIONS(2147),
    [sym_raw_string] = ACTIONS(2145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2145),
    [anon_sym_BQUOTE] = ACTIONS(2145),
    [anon_sym_LT_LPAREN] = ACTIONS(2145),
    [anon_sym_GT_LPAREN] = ACTIONS(2145),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2145),
  },
  [561] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(1003),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [562] = {
    [sym_string] = STATE(1005),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(2151),
    [sym_raw_string] = ACTIONS(2153),
    [anon_sym_POUND] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2151),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2151),
    [anon_sym_AT] = ACTIONS(2151),
    [anon_sym_QMARK] = ACTIONS(2151),
    [anon_sym_0] = ACTIONS(2157),
    [anon_sym__] = ACTIONS(2157),
  },
  [563] = {
    [aux_sym_concatenation_repeat1] = STATE(1001),
    [sym__concat] = ACTIONS(2143),
    [anon_sym_RPAREN] = ACTIONS(2159),
    [sym__special_characters] = ACTIONS(2159),
    [anon_sym_DQUOTE] = ACTIONS(2159),
    [anon_sym_DOLLAR] = ACTIONS(2161),
    [sym_raw_string] = ACTIONS(2159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2159),
    [anon_sym_BQUOTE] = ACTIONS(2159),
    [anon_sym_LT_LPAREN] = ACTIONS(2159),
    [anon_sym_GT_LPAREN] = ACTIONS(2159),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2159),
  },
  [564] = {
    [sym_subscript] = STATE(1011),
    [sym_variable_name] = ACTIONS(2163),
    [anon_sym_DOLLAR] = ACTIONS(2165),
    [anon_sym_POUND] = ACTIONS(2167),
    [anon_sym_DASH] = ACTIONS(2165),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2165),
    [anon_sym_AT] = ACTIONS(2165),
    [anon_sym_QMARK] = ACTIONS(2165),
    [anon_sym_0] = ACTIONS(2171),
    [anon_sym__] = ACTIONS(2171),
  },
  [565] = {
    [sym_for_statement] = STATE(1012),
    [sym_while_statement] = STATE(1012),
    [sym_if_statement] = STATE(1012),
    [sym_case_statement] = STATE(1012),
    [sym_function_definition] = STATE(1012),
    [sym_subshell] = STATE(1012),
    [sym_pipeline] = STATE(1012),
    [sym_list] = STATE(1012),
    [sym_negated_command] = STATE(1012),
    [sym_test_command] = STATE(1012),
    [sym_declaration_command] = STATE(1012),
    [sym_unset_command] = STATE(1012),
    [sym_command] = STATE(1012),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(1013),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [566] = {
    [sym_for_statement] = STATE(1014),
    [sym_while_statement] = STATE(1014),
    [sym_if_statement] = STATE(1014),
    [sym_case_statement] = STATE(1014),
    [sym_function_definition] = STATE(1014),
    [sym_subshell] = STATE(1014),
    [sym_pipeline] = STATE(1014),
    [sym_list] = STATE(1014),
    [sym_negated_command] = STATE(1014),
    [sym_test_command] = STATE(1014),
    [sym_declaration_command] = STATE(1014),
    [sym_unset_command] = STATE(1014),
    [sym_command] = STATE(1014),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(1015),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [567] = {
    [sym_for_statement] = STATE(1016),
    [sym_while_statement] = STATE(1016),
    [sym_if_statement] = STATE(1016),
    [sym_case_statement] = STATE(1016),
    [sym_function_definition] = STATE(1016),
    [sym_subshell] = STATE(1016),
    [sym_pipeline] = STATE(1016),
    [sym_list] = STATE(1016),
    [sym_negated_command] = STATE(1016),
    [sym_test_command] = STATE(1016),
    [sym_declaration_command] = STATE(1016),
    [sym_unset_command] = STATE(1016),
    [sym_command] = STATE(1016),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(1017),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [568] = {
    [sym_concatenation] = STATE(1019),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(1019),
    [anon_sym_RPAREN] = ACTIONS(2173),
    [sym__special_characters] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1119),
  },
  [569] = {
    [sym_string] = STATE(1020),
    [sym_simple_expansion] = STATE(1020),
    [sym_string_expansion] = STATE(1020),
    [sym_expansion] = STATE(1020),
    [sym_command_substitution] = STATE(1020),
    [sym_process_substitution] = STATE(1020),
    [sym__special_characters] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [sym_raw_string] = ACTIONS(2175),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(397),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(399),
    [anon_sym_BQUOTE] = ACTIONS(401),
    [anon_sym_LT_LPAREN] = ACTIONS(403),
    [anon_sym_GT_LPAREN] = ACTIONS(403),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2175),
  },
  [570] = {
    [aux_sym_concatenation_repeat1] = STATE(1021),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(1131),
    [sym_variable_name] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [571] = {
    [sym_file_descriptor] = ACTIONS(697),
    [sym__concat] = ACTIONS(697),
    [sym_variable_name] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_GT] = ACTIONS(699),
    [anon_sym_AMP_GT_GT] = ACTIONS(699),
    [anon_sym_LT_AMP] = ACTIONS(699),
    [anon_sym_GT_AMP] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_LF] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [572] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [573] = {
    [sym_file_descriptor] = ACTIONS(727),
    [sym__concat] = ACTIONS(727),
    [sym_variable_name] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(729),
    [anon_sym_PIPE_AMP] = ACTIONS(729),
    [anon_sym_AMP_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(729),
    [anon_sym_LT] = ACTIONS(729),
    [anon_sym_GT] = ACTIONS(729),
    [anon_sym_GT_GT] = ACTIONS(729),
    [anon_sym_AMP_GT] = ACTIONS(729),
    [anon_sym_AMP_GT_GT] = ACTIONS(729),
    [anon_sym_LT_AMP] = ACTIONS(729),
    [anon_sym_GT_AMP] = ACTIONS(729),
    [sym__special_characters] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(729),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(729),
    [anon_sym_BQUOTE] = ACTIONS(729),
    [anon_sym_LT_LPAREN] = ACTIONS(729),
    [anon_sym_GT_LPAREN] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(729),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_LF] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
  },
  [574] = {
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(731),
    [sym_variable_name] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [sym__special_characters] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [anon_sym_LT_LPAREN] = ACTIONS(733),
    [anon_sym_GT_LPAREN] = ACTIONS(733),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [575] = {
    [sym_file_descriptor] = ACTIONS(735),
    [sym__concat] = ACTIONS(735),
    [sym_variable_name] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(737),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(737),
    [anon_sym_LT_AMP] = ACTIONS(737),
    [anon_sym_GT_AMP] = ACTIONS(737),
    [sym__special_characters] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [anon_sym_LT_LPAREN] = ACTIONS(737),
    [anon_sym_GT_LPAREN] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [576] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(2179),
    [sym_comment] = ACTIONS(53),
  },
  [577] = {
    [sym_concatenation] = STATE(1026),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1026),
    [anon_sym_RBRACE] = ACTIONS(2181),
    [anon_sym_EQ] = ACTIONS(2183),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2185),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2187),
    [anon_sym_COLON] = ACTIONS(2183),
    [anon_sym_COLON_QMARK] = ACTIONS(2183),
    [anon_sym_COLON_DASH] = ACTIONS(2183),
    [anon_sym_PERCENT] = ACTIONS(2183),
    [anon_sym_DASH] = ACTIONS(2183),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [578] = {
    [sym_subscript] = STATE(1030),
    [sym_variable_name] = ACTIONS(2189),
    [anon_sym_DOLLAR] = ACTIONS(2191),
    [anon_sym_DASH] = ACTIONS(2191),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2193),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_AT] = ACTIONS(2191),
    [anon_sym_QMARK] = ACTIONS(2191),
    [anon_sym_0] = ACTIONS(2195),
    [anon_sym__] = ACTIONS(2195),
  },
  [579] = {
    [sym_concatenation] = STATE(1033),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1033),
    [anon_sym_RBRACE] = ACTIONS(2197),
    [anon_sym_EQ] = ACTIONS(2199),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2203),
    [anon_sym_COLON] = ACTIONS(2199),
    [anon_sym_COLON_QMARK] = ACTIONS(2199),
    [anon_sym_COLON_DASH] = ACTIONS(2199),
    [anon_sym_PERCENT] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [580] = {
    [sym_concatenation] = STATE(1036),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1036),
    [anon_sym_RBRACE] = ACTIONS(2205),
    [anon_sym_EQ] = ACTIONS(2207),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2209),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2211),
    [anon_sym_COLON] = ACTIONS(2207),
    [anon_sym_COLON_QMARK] = ACTIONS(2207),
    [anon_sym_COLON_DASH] = ACTIONS(2207),
    [anon_sym_PERCENT] = ACTIONS(2207),
    [anon_sym_DASH] = ACTIONS(2207),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [581] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2213),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [582] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2213),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [583] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(2213),
    [sym_comment] = ACTIONS(53),
  },
  [584] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(2213),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [585] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2215),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [586] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2215),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [587] = {
    [aux_sym_concatenation_repeat1] = STATE(1040),
    [sym__concat] = ACTIONS(2217),
    [anon_sym_SEMI_SEMI] = ACTIONS(2147),
    [sym__special_characters] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [anon_sym_DOLLAR] = ACTIONS(2147),
    [sym_raw_string] = ACTIONS(2147),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2147),
    [anon_sym_BQUOTE] = ACTIONS(2147),
    [anon_sym_LT_LPAREN] = ACTIONS(2147),
    [anon_sym_GT_LPAREN] = ACTIONS(2147),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2147),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2147),
  },
  [588] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(1042),
    [anon_sym_DQUOTE] = ACTIONS(2219),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [589] = {
    [sym_string] = STATE(1044),
    [anon_sym_DQUOTE] = ACTIONS(1157),
    [anon_sym_DOLLAR] = ACTIONS(2221),
    [sym_raw_string] = ACTIONS(2223),
    [anon_sym_POUND] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2221),
    [anon_sym_QMARK] = ACTIONS(2221),
    [anon_sym_0] = ACTIONS(2227),
    [anon_sym__] = ACTIONS(2227),
  },
  [590] = {
    [aux_sym_concatenation_repeat1] = STATE(1040),
    [sym__concat] = ACTIONS(2217),
    [anon_sym_SEMI_SEMI] = ACTIONS(2161),
    [sym__special_characters] = ACTIONS(2161),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [anon_sym_DOLLAR] = ACTIONS(2161),
    [sym_raw_string] = ACTIONS(2161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2161),
    [anon_sym_BQUOTE] = ACTIONS(2161),
    [anon_sym_LT_LPAREN] = ACTIONS(2161),
    [anon_sym_GT_LPAREN] = ACTIONS(2161),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2161),
    [anon_sym_SEMI] = ACTIONS(2161),
    [anon_sym_LF] = ACTIONS(2159),
    [anon_sym_AMP] = ACTIONS(2161),
  },
  [591] = {
    [sym_subscript] = STATE(1050),
    [sym_variable_name] = ACTIONS(2229),
    [anon_sym_DOLLAR] = ACTIONS(2231),
    [anon_sym_POUND] = ACTIONS(2233),
    [anon_sym_DASH] = ACTIONS(2231),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2235),
    [anon_sym_STAR] = ACTIONS(2231),
    [anon_sym_AT] = ACTIONS(2231),
    [anon_sym_QMARK] = ACTIONS(2231),
    [anon_sym_0] = ACTIONS(2237),
    [anon_sym__] = ACTIONS(2237),
  },
  [592] = {
    [sym_for_statement] = STATE(1051),
    [sym_while_statement] = STATE(1051),
    [sym_if_statement] = STATE(1051),
    [sym_case_statement] = STATE(1051),
    [sym_function_definition] = STATE(1051),
    [sym_subshell] = STATE(1051),
    [sym_pipeline] = STATE(1051),
    [sym_list] = STATE(1051),
    [sym_negated_command] = STATE(1051),
    [sym_test_command] = STATE(1051),
    [sym_declaration_command] = STATE(1051),
    [sym_unset_command] = STATE(1051),
    [sym_command] = STATE(1051),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(1052),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [593] = {
    [sym_for_statement] = STATE(1053),
    [sym_while_statement] = STATE(1053),
    [sym_if_statement] = STATE(1053),
    [sym_case_statement] = STATE(1053),
    [sym_function_definition] = STATE(1053),
    [sym_subshell] = STATE(1053),
    [sym_pipeline] = STATE(1053),
    [sym_list] = STATE(1053),
    [sym_negated_command] = STATE(1053),
    [sym_test_command] = STATE(1053),
    [sym_declaration_command] = STATE(1053),
    [sym_unset_command] = STATE(1053),
    [sym_command] = STATE(1053),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(1054),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [594] = {
    [sym_for_statement] = STATE(1055),
    [sym_while_statement] = STATE(1055),
    [sym_if_statement] = STATE(1055),
    [sym_case_statement] = STATE(1055),
    [sym_function_definition] = STATE(1055),
    [sym_subshell] = STATE(1055),
    [sym_pipeline] = STATE(1055),
    [sym_list] = STATE(1055),
    [sym_negated_command] = STATE(1055),
    [sym_test_command] = STATE(1055),
    [sym_declaration_command] = STATE(1055),
    [sym_unset_command] = STATE(1055),
    [sym_command] = STATE(1055),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(1056),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [595] = {
    [sym_concatenation] = STATE(1058),
    [sym_string] = STATE(590),
    [sym_simple_expansion] = STATE(590),
    [sym_string_expansion] = STATE(590),
    [sym_expansion] = STATE(590),
    [sym_command_substitution] = STATE(590),
    [sym_process_substitution] = STATE(590),
    [aux_sym_for_statement_repeat1] = STATE(1058),
    [anon_sym_SEMI_SEMI] = ACTIONS(2239),
    [sym__special_characters] = ACTIONS(2241),
    [anon_sym_DQUOTE] = ACTIONS(2243),
    [anon_sym_DOLLAR] = ACTIONS(1159),
    [sym_raw_string] = ACTIONS(2245),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2249),
    [anon_sym_BQUOTE] = ACTIONS(2251),
    [anon_sym_LT_LPAREN] = ACTIONS(2253),
    [anon_sym_GT_LPAREN] = ACTIONS(2253),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2245),
    [anon_sym_SEMI] = ACTIONS(2239),
    [anon_sym_LF] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2239),
  },
  [596] = {
    [sym__terminated_statement] = STATE(1060),
    [sym_for_statement] = STATE(599),
    [sym_while_statement] = STATE(599),
    [sym_if_statement] = STATE(599),
    [sym_case_statement] = STATE(599),
    [sym_function_definition] = STATE(599),
    [sym_subshell] = STATE(599),
    [sym_pipeline] = STATE(599),
    [sym_list] = STATE(599),
    [sym_negated_command] = STATE(599),
    [sym_test_command] = STATE(599),
    [sym_declaration_command] = STATE(599),
    [sym_unset_command] = STATE(599),
    [sym_command] = STATE(599),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(600),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1060),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_done] = ACTIONS(2257),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [597] = {
    [anon_sym_esac] = ACTIONS(2259),
    [anon_sym_PIPE] = ACTIONS(2259),
    [anon_sym_RPAREN] = ACTIONS(2259),
    [anon_sym_SEMI_SEMI] = ACTIONS(2259),
    [anon_sym_PIPE_AMP] = ACTIONS(2259),
    [anon_sym_AMP_AMP] = ACTIONS(2259),
    [anon_sym_PIPE_PIPE] = ACTIONS(2259),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2259),
    [anon_sym_LF] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(2259),
  },
  [598] = {
    [sym__simple_heredoc_body] = ACTIONS(2263),
    [sym__heredoc_body_beginning] = ACTIONS(2263),
    [sym_file_descriptor] = ACTIONS(2263),
    [anon_sym_esac] = ACTIONS(2265),
    [anon_sym_PIPE] = ACTIONS(2265),
    [anon_sym_RPAREN] = ACTIONS(2265),
    [anon_sym_SEMI_SEMI] = ACTIONS(2265),
    [anon_sym_PIPE_AMP] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_PIPE_PIPE] = ACTIONS(2265),
    [anon_sym_LT] = ACTIONS(2265),
    [anon_sym_GT] = ACTIONS(2265),
    [anon_sym_GT_GT] = ACTIONS(2265),
    [anon_sym_AMP_GT] = ACTIONS(2265),
    [anon_sym_AMP_GT_GT] = ACTIONS(2265),
    [anon_sym_LT_AMP] = ACTIONS(2265),
    [anon_sym_GT_AMP] = ACTIONS(2265),
    [anon_sym_LT_LT] = ACTIONS(2265),
    [anon_sym_LT_LT_DASH] = ACTIONS(2265),
    [anon_sym_LT_LT_LT] = ACTIONS(2265),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym_LF] = ACTIONS(2263),
    [anon_sym_AMP] = ACTIONS(2265),
  },
  [599] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(2267),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2267),
    [anon_sym_LF] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2267),
  },
  [600] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(2267),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(2267),
    [anon_sym_LF] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2267),
  },
  [601] = {
    [sym__terminated_statement] = STATE(1063),
    [sym_for_statement] = STATE(599),
    [sym_while_statement] = STATE(599),
    [sym_if_statement] = STATE(599),
    [sym_case_statement] = STATE(599),
    [sym_function_definition] = STATE(599),
    [sym_subshell] = STATE(599),
    [sym_pipeline] = STATE(599),
    [sym_list] = STATE(599),
    [sym_negated_command] = STATE(599),
    [sym_test_command] = STATE(599),
    [sym_declaration_command] = STATE(599),
    [sym_unset_command] = STATE(599),
    [sym_command] = STATE(599),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(600),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1063),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_done] = ACTIONS(2271),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [602] = {
    [anon_sym_esac] = ACTIONS(2273),
    [anon_sym_PIPE] = ACTIONS(2273),
    [anon_sym_RPAREN] = ACTIONS(2273),
    [anon_sym_SEMI_SEMI] = ACTIONS(2273),
    [anon_sym_PIPE_AMP] = ACTIONS(2273),
    [anon_sym_AMP_AMP] = ACTIONS(2273),
    [anon_sym_PIPE_PIPE] = ACTIONS(2273),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2273),
    [anon_sym_LF] = ACTIONS(2275),
    [anon_sym_AMP] = ACTIONS(2273),
  },
  [603] = {
    [sym_file_redirect] = STATE(549),
    [sym_heredoc_redirect] = STATE(549),
    [sym_heredoc_body] = STATE(1064),
    [sym_herestring_redirect] = STATE(549),
    [aux_sym_while_statement_repeat1] = STATE(549),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(2273),
    [anon_sym_SEMI_SEMI] = ACTIONS(2273),
    [anon_sym_PIPE_AMP] = ACTIONS(2273),
    [anon_sym_AMP_AMP] = ACTIONS(2273),
    [anon_sym_PIPE_PIPE] = ACTIONS(2273),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(347),
    [anon_sym_AMP_GT] = ACTIONS(347),
    [anon_sym_AMP_GT_GT] = ACTIONS(347),
    [anon_sym_LT_AMP] = ACTIONS(347),
    [anon_sym_GT_AMP] = ACTIONS(347),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(351),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2273),
    [anon_sym_LF] = ACTIONS(2275),
    [anon_sym_AMP] = ACTIONS(2273),
  },
  [604] = {
    [anon_sym_esac] = ACTIONS(2277),
    [anon_sym_PIPE] = ACTIONS(2277),
    [anon_sym_RPAREN] = ACTIONS(2277),
    [anon_sym_SEMI_SEMI] = ACTIONS(2277),
    [anon_sym_PIPE_AMP] = ACTIONS(2277),
    [anon_sym_AMP_AMP] = ACTIONS(2277),
    [anon_sym_PIPE_PIPE] = ACTIONS(2277),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2277),
    [anon_sym_LF] = ACTIONS(2279),
    [anon_sym_AMP] = ACTIONS(2277),
  },
  [605] = {
    [sym__terminated_statement] = STATE(1065),
    [sym_for_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_subshell] = STATE(39),
    [sym_pipeline] = STATE(39),
    [sym_list] = STATE(39),
    [sym_negated_command] = STATE(39),
    [sym_test_command] = STATE(39),
    [sym_declaration_command] = STATE(39),
    [sym_unset_command] = STATE(39),
    [sym_command] = STATE(39),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(40),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [606] = {
    [sym__terminated_statement] = STATE(1068),
    [sym_for_statement] = STATE(1066),
    [sym_while_statement] = STATE(1066),
    [sym_if_statement] = STATE(1066),
    [sym_case_statement] = STATE(1066),
    [sym_function_definition] = STATE(1066),
    [sym_subshell] = STATE(1066),
    [sym_pipeline] = STATE(1066),
    [sym_list] = STATE(1066),
    [sym_negated_command] = STATE(1066),
    [sym_test_command] = STATE(1066),
    [sym_declaration_command] = STATE(1066),
    [sym_unset_command] = STATE(1066),
    [sym_command] = STATE(1066),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(1067),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1068),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(2281),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [607] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(2283),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2283),
    [anon_sym_LF] = ACTIONS(2285),
    [anon_sym_AMP] = ACTIONS(2283),
  },
  [608] = {
    [anon_sym_fi] = ACTIONS(2287),
    [anon_sym_elif] = ACTIONS(2287),
    [anon_sym_else] = ACTIONS(2287),
    [sym_comment] = ACTIONS(53),
  },
  [609] = {
    [anon_sym_fi] = ACTIONS(2289),
    [sym_comment] = ACTIONS(53),
  },
  [610] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(2283),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(2283),
    [anon_sym_LF] = ACTIONS(2285),
    [anon_sym_AMP] = ACTIONS(2283),
  },
  [611] = {
    [sym__terminated_statement] = STATE(1072),
    [sym_for_statement] = STATE(607),
    [sym_while_statement] = STATE(607),
    [sym_if_statement] = STATE(607),
    [sym_elif_clause] = STATE(608),
    [sym_else_clause] = STATE(1071),
    [sym_case_statement] = STATE(607),
    [sym_function_definition] = STATE(607),
    [sym_subshell] = STATE(607),
    [sym_pipeline] = STATE(607),
    [sym_list] = STATE(607),
    [sym_negated_command] = STATE(607),
    [sym_test_command] = STATE(607),
    [sym_declaration_command] = STATE(607),
    [sym_unset_command] = STATE(607),
    [sym_command] = STATE(607),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(610),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1072),
    [aux_sym_if_statement_repeat1] = STATE(1073),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(2291),
    [anon_sym_elif] = ACTIONS(1181),
    [anon_sym_else] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [612] = {
    [sym_elif_clause] = STATE(608),
    [sym_else_clause] = STATE(1071),
    [aux_sym_if_statement_repeat1] = STATE(1074),
    [anon_sym_fi] = ACTIONS(2289),
    [anon_sym_elif] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2295),
    [sym_comment] = ACTIONS(53),
  },
  [613] = {
    [sym__concat] = ACTIONS(1654),
    [anon_sym_in] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [614] = {
    [sym_case_item] = STATE(1080),
    [sym_last_case_item] = STATE(1078),
    [sym_concatenation] = STATE(1079),
    [sym_string] = STATE(1077),
    [sym_simple_expansion] = STATE(1077),
    [sym_string_expansion] = STATE(1077),
    [sym_expansion] = STATE(1077),
    [sym_command_substitution] = STATE(1077),
    [sym_process_substitution] = STATE(1077),
    [aux_sym_case_statement_repeat1] = STATE(1080),
    [anon_sym_esac] = ACTIONS(2297),
    [sym__special_characters] = ACTIONS(2299),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2303),
  },
  [615] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2305),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2305),
    [anon_sym_LF] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2305),
  },
  [616] = {
    [aux_sym_concatenation_repeat1] = STATE(616),
    [sym__concat] = ACTIONS(2309),
    [anon_sym_in] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [617] = {
    [sym__concat] = ACTIONS(1703),
    [anon_sym_in] = ACTIONS(1705),
    [anon_sym_SEMI_SEMI] = ACTIONS(1705),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_LF] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1705),
  },
  [618] = {
    [sym_case_item] = STATE(1084),
    [sym_last_case_item] = STATE(1083),
    [sym_concatenation] = STATE(1079),
    [sym_string] = STATE(1077),
    [sym_simple_expansion] = STATE(1077),
    [sym_string_expansion] = STATE(1077),
    [sym_expansion] = STATE(1077),
    [sym_command_substitution] = STATE(1077),
    [sym_process_substitution] = STATE(1077),
    [aux_sym_case_statement_repeat1] = STATE(1084),
    [anon_sym_esac] = ACTIONS(2312),
    [sym__special_characters] = ACTIONS(2299),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2303),
  },
  [619] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2314),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym_LF] = ACTIONS(2316),
    [anon_sym_AMP] = ACTIONS(2314),
  },
  [620] = {
    [sym_concatenation] = STATE(1089),
    [sym_string] = STATE(1088),
    [sym_simple_expansion] = STATE(1088),
    [sym_string_expansion] = STATE(1088),
    [sym_expansion] = STATE(1088),
    [sym_command_substitution] = STATE(1088),
    [sym_process_substitution] = STATE(1088),
    [anon_sym_RBRACE] = ACTIONS(2318),
    [sym__special_characters] = ACTIONS(2320),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(2322),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2322),
  },
  [621] = {
    [sym__concat] = ACTIONS(1744),
    [anon_sym_in] = ACTIONS(1746),
    [anon_sym_SEMI_SEMI] = ACTIONS(1746),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1746),
    [anon_sym_LF] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(1746),
  },
  [622] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2324),
  },
  [623] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2326),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [624] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(2328),
    [sym_comment] = ACTIONS(53),
  },
  [625] = {
    [sym_concatenation] = STATE(1095),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1095),
    [anon_sym_RBRACE] = ACTIONS(2330),
    [anon_sym_EQ] = ACTIONS(2332),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2334),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2336),
    [anon_sym_COLON] = ACTIONS(2332),
    [anon_sym_COLON_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_DASH] = ACTIONS(2332),
    [anon_sym_PERCENT] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [626] = {
    [sym_concatenation] = STATE(1098),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1098),
    [anon_sym_RBRACE] = ACTIONS(2338),
    [anon_sym_EQ] = ACTIONS(2340),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2342),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2344),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_COLON_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_DASH] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [627] = {
    [sym_concatenation] = STATE(1100),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1100),
    [anon_sym_RBRACE] = ACTIONS(2318),
    [anon_sym_EQ] = ACTIONS(2346),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2348),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2350),
    [anon_sym_COLON] = ACTIONS(2346),
    [anon_sym_COLON_QMARK] = ACTIONS(2346),
    [anon_sym_COLON_DASH] = ACTIONS(2346),
    [anon_sym_PERCENT] = ACTIONS(2346),
    [anon_sym_DASH] = ACTIONS(2346),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [628] = {
    [sym__concat] = ACTIONS(1810),
    [anon_sym_in] = ACTIONS(1812),
    [anon_sym_SEMI_SEMI] = ACTIONS(1812),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1812),
    [anon_sym_LF] = ACTIONS(1810),
    [anon_sym_AMP] = ACTIONS(1812),
  },
  [629] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2352),
  },
  [630] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [631] = {
    [sym__concat] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(1820),
    [anon_sym_SEMI_SEMI] = ACTIONS(1820),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1820),
    [anon_sym_LF] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1820),
  },
  [632] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2356),
  },
  [633] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2318),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [634] = {
    [sym__concat] = ACTIONS(1952),
    [anon_sym_in] = ACTIONS(1954),
    [anon_sym_SEMI_SEMI] = ACTIONS(1954),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1954),
    [anon_sym_LF] = ACTIONS(1952),
    [anon_sym_AMP] = ACTIONS(1954),
  },
  [635] = {
    [sym__concat] = ACTIONS(2018),
    [anon_sym_in] = ACTIONS(2020),
    [anon_sym_SEMI_SEMI] = ACTIONS(2020),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2020),
    [anon_sym_LF] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2020),
  },
  [636] = {
    [sym_compound_statement] = STATE(1104),
    [anon_sym_LBRACE] = ACTIONS(455),
    [sym_comment] = ACTIONS(53),
  },
  [637] = {
    [sym_file_descriptor] = ACTIONS(2358),
    [anon_sym_esac] = ACTIONS(2360),
    [anon_sym_PIPE] = ACTIONS(2360),
    [anon_sym_RPAREN] = ACTIONS(2360),
    [anon_sym_SEMI_SEMI] = ACTIONS(2360),
    [anon_sym_PIPE_AMP] = ACTIONS(2360),
    [anon_sym_AMP_AMP] = ACTIONS(2360),
    [anon_sym_PIPE_PIPE] = ACTIONS(2360),
    [anon_sym_LT] = ACTIONS(2360),
    [anon_sym_GT] = ACTIONS(2360),
    [anon_sym_GT_GT] = ACTIONS(2360),
    [anon_sym_AMP_GT] = ACTIONS(2360),
    [anon_sym_AMP_GT_GT] = ACTIONS(2360),
    [anon_sym_LT_AMP] = ACTIONS(2360),
    [anon_sym_GT_AMP] = ACTIONS(2360),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2360),
    [anon_sym_LF] = ACTIONS(2358),
    [anon_sym_AMP] = ACTIONS(2360),
  },
  [638] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2362),
    [anon_sym_LF] = ACTIONS(2364),
    [anon_sym_AMP] = ACTIONS(2362),
  },
  [639] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(2362),
    [anon_sym_LF] = ACTIONS(2364),
    [anon_sym_AMP] = ACTIONS(2362),
  },
  [640] = {
    [sym__terminated_statement] = STATE(1107),
    [sym_for_statement] = STATE(638),
    [sym_while_statement] = STATE(638),
    [sym_if_statement] = STATE(638),
    [sym_case_statement] = STATE(638),
    [sym_function_definition] = STATE(638),
    [sym_subshell] = STATE(638),
    [sym_pipeline] = STATE(638),
    [sym_list] = STATE(638),
    [sym_negated_command] = STATE(638),
    [sym_test_command] = STATE(638),
    [sym_declaration_command] = STATE(638),
    [sym_unset_command] = STATE(638),
    [sym_command] = STATE(638),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(639),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1107),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RBRACE] = ACTIONS(2366),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [641] = {
    [anon_sym_LT] = ACTIONS(2368),
    [anon_sym_GT] = ACTIONS(2368),
    [anon_sym_GT_GT] = ACTIONS(2370),
    [anon_sym_AMP_GT] = ACTIONS(2368),
    [anon_sym_AMP_GT_GT] = ACTIONS(2370),
    [anon_sym_LT_AMP] = ACTIONS(2370),
    [anon_sym_GT_AMP] = ACTIONS(2370),
    [sym_comment] = ACTIONS(53),
  },
  [642] = {
    [sym_concatenation] = STATE(1111),
    [sym_string] = STATE(1110),
    [sym_simple_expansion] = STATE(1110),
    [sym_string_expansion] = STATE(1110),
    [sym_expansion] = STATE(1110),
    [sym_command_substitution] = STATE(1110),
    [sym_process_substitution] = STATE(1110),
    [sym__special_characters] = ACTIONS(2372),
    [anon_sym_DQUOTE] = ACTIONS(629),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(2374),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1533),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1535),
    [anon_sym_BQUOTE] = ACTIONS(1537),
    [anon_sym_LT_LPAREN] = ACTIONS(1539),
    [anon_sym_GT_LPAREN] = ACTIONS(1539),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2374),
  },
  [643] = {
    [anon_sym_esac] = ACTIONS(2376),
    [anon_sym_PIPE] = ACTIONS(2376),
    [anon_sym_RPAREN] = ACTIONS(2376),
    [anon_sym_SEMI_SEMI] = ACTIONS(2376),
    [anon_sym_PIPE_AMP] = ACTIONS(2376),
    [anon_sym_AMP_AMP] = ACTIONS(2376),
    [anon_sym_PIPE_PIPE] = ACTIONS(2376),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2376),
    [anon_sym_LF] = ACTIONS(2378),
    [anon_sym_AMP] = ACTIONS(2376),
  },
  [644] = {
    [aux_sym_concatenation_repeat1] = STATE(1112),
    [sym_file_descriptor] = ACTIONS(1129),
    [sym__concat] = ACTIONS(1131),
    [sym_variable_name] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(1133),
    [anon_sym_SEMI_SEMI] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1133),
    [anon_sym_AMP_GT] = ACTIONS(1133),
    [anon_sym_AMP_GT_GT] = ACTIONS(1133),
    [anon_sym_LT_AMP] = ACTIONS(1133),
    [anon_sym_GT_AMP] = ACTIONS(1133),
    [sym__special_characters] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1133),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1133),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_LF] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1133),
  },
  [645] = {
    [aux_sym_concatenation_repeat1] = STATE(1112),
    [sym_file_descriptor] = ACTIONS(1107),
    [sym__concat] = ACTIONS(1131),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1109),
    [anon_sym_GT] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_AMP] = ACTIONS(1109),
    [anon_sym_GT_AMP] = ACTIONS(1109),
    [sym__special_characters] = ACTIONS(1109),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1109),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_LT_LPAREN] = ACTIONS(1109),
    [anon_sym_GT_LPAREN] = ACTIONS(1109),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1109),
  },
  [646] = {
    [sym_file_redirect] = STATE(1113),
    [sym_heredoc_redirect] = STATE(1113),
    [sym_heredoc_body] = STATE(602),
    [sym_herestring_redirect] = STATE(1113),
    [aux_sym_while_statement_repeat1] = STATE(1113),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(1175),
    [anon_sym_RPAREN] = ACTIONS(1175),
    [anon_sym_SEMI_SEMI] = ACTIONS(1175),
    [anon_sym_PIPE_AMP] = ACTIONS(1175),
    [anon_sym_AMP_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1175),
    [anon_sym_LT] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(487),
    [anon_sym_GT_GT] = ACTIONS(487),
    [anon_sym_AMP_GT] = ACTIONS(487),
    [anon_sym_AMP_GT_GT] = ACTIONS(487),
    [anon_sym_LT_AMP] = ACTIONS(487),
    [anon_sym_GT_AMP] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(489),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1175),
    [anon_sym_LF] = ACTIONS(1177),
    [anon_sym_AMP] = ACTIONS(1175),
  },
  [647] = {
    [anon_sym_RPAREN] = ACTIONS(2380),
    [sym_comment] = ACTIONS(53),
  },
  [648] = {
    [sym_file_redirect] = STATE(643),
    [sym_file_descriptor] = ACTIONS(2382),
    [anon_sym_PIPE] = ACTIONS(1245),
    [anon_sym_RPAREN] = ACTIONS(1245),
    [anon_sym_SEMI_SEMI] = ACTIONS(1245),
    [anon_sym_PIPE_AMP] = ACTIONS(1245),
    [anon_sym_AMP_AMP] = ACTIONS(1245),
    [anon_sym_PIPE_PIPE] = ACTIONS(1245),
    [anon_sym_LT] = ACTIONS(2384),
    [anon_sym_GT] = ACTIONS(2384),
    [anon_sym_GT_GT] = ACTIONS(2384),
    [anon_sym_AMP_GT] = ACTIONS(2384),
    [anon_sym_AMP_GT_GT] = ACTIONS(2384),
    [anon_sym_LT_AMP] = ACTIONS(2384),
    [anon_sym_GT_AMP] = ACTIONS(2384),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1245),
    [anon_sym_LF] = ACTIONS(1249),
    [anon_sym_AMP] = ACTIONS(1245),
  },
  [649] = {
    [sym_file_redirect] = STATE(1120),
    [sym_heredoc_redirect] = STATE(1120),
    [sym_herestring_redirect] = STATE(1120),
    [aux_sym_while_statement_repeat1] = STATE(1120),
    [sym_file_descriptor] = ACTIONS(2386),
    [anon_sym_PIPE] = ACTIONS(1353),
    [anon_sym_RPAREN] = ACTIONS(1353),
    [anon_sym_SEMI_SEMI] = ACTIONS(1353),
    [anon_sym_PIPE_AMP] = ACTIONS(1353),
    [anon_sym_AMP_AMP] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1353),
    [anon_sym_LT] = ACTIONS(2388),
    [anon_sym_GT] = ACTIONS(2388),
    [anon_sym_GT_GT] = ACTIONS(2388),
    [anon_sym_AMP_GT] = ACTIONS(2388),
    [anon_sym_AMP_GT_GT] = ACTIONS(2388),
    [anon_sym_LT_AMP] = ACTIONS(2388),
    [anon_sym_GT_AMP] = ACTIONS(2388),
    [anon_sym_LT_LT] = ACTIONS(1357),
    [anon_sym_LT_LT_DASH] = ACTIONS(1357),
    [anon_sym_LT_LT_LT] = ACTIONS(2390),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1353),
    [anon_sym_LF] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1353),
  },
  [650] = {
    [sym_concatenation] = STATE(729),
    [sym_string] = STATE(1122),
    [sym_array] = STATE(729),
    [sym_simple_expansion] = STATE(1122),
    [sym_string_expansion] = STATE(1122),
    [sym_expansion] = STATE(1122),
    [sym_command_substitution] = STATE(1122),
    [sym_process_substitution] = STATE(1122),
    [sym__empty_value] = ACTIONS(1439),
    [anon_sym_LPAREN] = ACTIONS(1441),
    [sym__special_characters] = ACTIONS(2392),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(2394),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1447),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1449),
    [anon_sym_BQUOTE] = ACTIONS(1451),
    [anon_sym_LT_LPAREN] = ACTIONS(1453),
    [anon_sym_GT_LPAREN] = ACTIONS(1453),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2394),
  },
  [651] = {
    [aux_sym_concatenation_repeat1] = STATE(1123),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(695),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [652] = {
    [sym_variable_assignment] = STATE(652),
    [sym_subscript] = STATE(261),
    [sym_concatenation] = STATE(652),
    [sym_string] = STATE(260),
    [sym_simple_expansion] = STATE(260),
    [sym_string_expansion] = STATE(260),
    [sym_expansion] = STATE(260),
    [sym_command_substitution] = STATE(260),
    [sym_process_substitution] = STATE(260),
    [aux_sym_declaration_command_repeat1] = STATE(652),
    [sym_variable_name] = ACTIONS(2396),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_RPAREN] = ACTIONS(1500),
    [anon_sym_SEMI_SEMI] = ACTIONS(1500),
    [anon_sym_PIPE_AMP] = ACTIONS(1500),
    [anon_sym_AMP_AMP] = ACTIONS(1500),
    [anon_sym_PIPE_PIPE] = ACTIONS(1500),
    [sym__special_characters] = ACTIONS(2399),
    [anon_sym_DQUOTE] = ACTIONS(1505),
    [anon_sym_DOLLAR] = ACTIONS(1508),
    [sym_raw_string] = ACTIONS(2402),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1514),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1517),
    [anon_sym_BQUOTE] = ACTIONS(1520),
    [anon_sym_LT_LPAREN] = ACTIONS(1523),
    [anon_sym_GT_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1526),
    [sym_word] = ACTIONS(2402),
    [anon_sym_SEMI] = ACTIONS(1500),
    [anon_sym_LF] = ACTIONS(1529),
    [anon_sym_AMP] = ACTIONS(1500),
  },
  [653] = {
    [aux_sym_concatenation_repeat1] = STATE(1124),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(695),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [654] = {
    [sym_concatenation] = STATE(654),
    [sym_string] = STATE(264),
    [sym_simple_expansion] = STATE(264),
    [sym_string_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [sym_command_substitution] = STATE(264),
    [sym_process_substitution] = STATE(264),
    [aux_sym_unset_command_repeat1] = STATE(654),
    [anon_sym_PIPE] = ACTIONS(1581),
    [anon_sym_RPAREN] = ACTIONS(1581),
    [anon_sym_SEMI_SEMI] = ACTIONS(1581),
    [anon_sym_PIPE_AMP] = ACTIONS(1581),
    [anon_sym_AMP_AMP] = ACTIONS(1581),
    [anon_sym_PIPE_PIPE] = ACTIONS(1581),
    [sym__special_characters] = ACTIONS(2405),
    [anon_sym_DQUOTE] = ACTIONS(1586),
    [anon_sym_DOLLAR] = ACTIONS(1589),
    [sym_raw_string] = ACTIONS(2408),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1598),
    [anon_sym_BQUOTE] = ACTIONS(1601),
    [anon_sym_LT_LPAREN] = ACTIONS(1604),
    [anon_sym_GT_LPAREN] = ACTIONS(1604),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1607),
    [sym_word] = ACTIONS(2408),
    [anon_sym_SEMI] = ACTIONS(1581),
    [anon_sym_LF] = ACTIONS(1610),
    [anon_sym_AMP] = ACTIONS(1581),
  },
  [655] = {
    [aux_sym_concatenation_repeat1] = STATE(655),
    [sym__simple_heredoc_body] = ACTIONS(1654),
    [sym__heredoc_body_beginning] = ACTIONS(1654),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(1658),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [anon_sym_EQ_TILDE] = ACTIONS(1656),
    [anon_sym_EQ_EQ] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1656),
    [anon_sym_LT_AMP] = ACTIONS(1656),
    [anon_sym_GT_AMP] = ACTIONS(1656),
    [anon_sym_LT_LT] = ACTIONS(1656),
    [anon_sym_LT_LT_DASH] = ACTIONS(1656),
    [anon_sym_LT_LT_LT] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LT_LPAREN] = ACTIONS(1656),
    [anon_sym_GT_LPAREN] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [656] = {
    [sym_compound_statement] = STATE(1125),
    [anon_sym_LBRACE] = ACTIONS(455),
    [sym_comment] = ACTIONS(53),
  },
  [657] = {
    [anon_sym_esac] = ACTIONS(2411),
    [anon_sym_PIPE] = ACTIONS(2411),
    [anon_sym_RPAREN] = ACTIONS(2411),
    [anon_sym_SEMI_SEMI] = ACTIONS(2411),
    [anon_sym_PIPE_AMP] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2411),
    [anon_sym_LF] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
  },
  [658] = {
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(2026),
    [anon_sym_SEMI_SEMI] = ACTIONS(2026),
    [anon_sym_PIPE_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(2026),
    [anon_sym_PIPE_PIPE] = ACTIONS(2026),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2026),
    [anon_sym_LF] = ACTIONS(2028),
    [anon_sym_AMP] = ACTIONS(2026),
  },
  [659] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(2026),
    [anon_sym_SEMI_SEMI] = ACTIONS(2026),
    [anon_sym_PIPE_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(2026),
    [anon_sym_PIPE_PIPE] = ACTIONS(2026),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(2026),
    [anon_sym_LF] = ACTIONS(2028),
    [anon_sym_AMP] = ACTIONS(2026),
  },
  [660] = {
    [sym_concatenation] = STATE(991),
    [sym_string] = STATE(1127),
    [sym_simple_expansion] = STATE(1127),
    [sym_string_expansion] = STATE(1127),
    [sym_expansion] = STATE(1127),
    [sym_command_substitution] = STATE(1127),
    [sym_process_substitution] = STATE(1127),
    [sym__special_characters] = ACTIONS(2415),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(2417),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2417),
  },
  [661] = {
    [aux_sym_concatenation_repeat1] = STATE(266),
    [sym__simple_heredoc_body] = ACTIONS(2058),
    [sym__heredoc_body_beginning] = ACTIONS(2058),
    [sym_file_descriptor] = ACTIONS(2058),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(2060),
    [anon_sym_RPAREN] = ACTIONS(2060),
    [anon_sym_SEMI_SEMI] = ACTIONS(2060),
    [anon_sym_PIPE_AMP] = ACTIONS(2060),
    [anon_sym_AMP_AMP] = ACTIONS(2060),
    [anon_sym_PIPE_PIPE] = ACTIONS(2060),
    [anon_sym_EQ_TILDE] = ACTIONS(2060),
    [anon_sym_EQ_EQ] = ACTIONS(2060),
    [anon_sym_LT] = ACTIONS(2060),
    [anon_sym_GT] = ACTIONS(2060),
    [anon_sym_GT_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT_GT] = ACTIONS(2060),
    [anon_sym_LT_AMP] = ACTIONS(2060),
    [anon_sym_GT_AMP] = ACTIONS(2060),
    [anon_sym_LT_LT] = ACTIONS(2060),
    [anon_sym_LT_LT_DASH] = ACTIONS(2060),
    [anon_sym_LT_LT_LT] = ACTIONS(2060),
    [sym__special_characters] = ACTIONS(2060),
    [anon_sym_DQUOTE] = ACTIONS(2060),
    [anon_sym_DOLLAR] = ACTIONS(2060),
    [sym_raw_string] = ACTIONS(2060),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2060),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2060),
    [anon_sym_BQUOTE] = ACTIONS(2060),
    [anon_sym_LT_LPAREN] = ACTIONS(2060),
    [anon_sym_GT_LPAREN] = ACTIONS(2060),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2060),
    [anon_sym_LF] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2060),
  },
  [662] = {
    [aux_sym_concatenation_repeat1] = STATE(266),
    [sym__simple_heredoc_body] = ACTIONS(2062),
    [sym__heredoc_body_beginning] = ACTIONS(2062),
    [sym_file_descriptor] = ACTIONS(2062),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_RPAREN] = ACTIONS(2064),
    [anon_sym_SEMI_SEMI] = ACTIONS(2064),
    [anon_sym_PIPE_AMP] = ACTIONS(2064),
    [anon_sym_AMP_AMP] = ACTIONS(2064),
    [anon_sym_PIPE_PIPE] = ACTIONS(2064),
    [anon_sym_EQ_TILDE] = ACTIONS(2064),
    [anon_sym_EQ_EQ] = ACTIONS(2064),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2064),
    [anon_sym_LT_AMP] = ACTIONS(2064),
    [anon_sym_GT_AMP] = ACTIONS(2064),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2064),
    [anon_sym_LT_LT_LT] = ACTIONS(2064),
    [sym__special_characters] = ACTIONS(2064),
    [anon_sym_DQUOTE] = ACTIONS(2064),
    [anon_sym_DOLLAR] = ACTIONS(2064),
    [sym_raw_string] = ACTIONS(2064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2064),
    [anon_sym_BQUOTE] = ACTIONS(2064),
    [anon_sym_LT_LPAREN] = ACTIONS(2064),
    [anon_sym_GT_LPAREN] = ACTIONS(2064),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2064),
    [anon_sym_SEMI] = ACTIONS(2064),
    [anon_sym_LF] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2064),
  },
  [663] = {
    [aux_sym_concatenation_repeat1] = STATE(1128),
    [sym__simple_heredoc_body] = ACTIONS(661),
    [sym__heredoc_body_beginning] = ACTIONS(661),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(665),
    [anon_sym_AMP_AMP] = ACTIONS(665),
    [anon_sym_PIPE_PIPE] = ACTIONS(665),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(665),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(665),
    [anon_sym_LT_AMP] = ACTIONS(665),
    [anon_sym_GT_AMP] = ACTIONS(665),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(665),
    [anon_sym_LT_LT_LT] = ACTIONS(665),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [664] = {
    [aux_sym_concatenation_repeat1] = STATE(1128),
    [sym__simple_heredoc_body] = ACTIONS(677),
    [sym__heredoc_body_beginning] = ACTIONS(677),
    [sym_file_descriptor] = ACTIONS(677),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [665] = {
    [aux_sym_concatenation_repeat1] = STATE(1128),
    [sym__simple_heredoc_body] = ACTIONS(2070),
    [sym__heredoc_body_beginning] = ACTIONS(2070),
    [sym_file_descriptor] = ACTIONS(2070),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(2072),
    [anon_sym_RPAREN] = ACTIONS(2072),
    [anon_sym_SEMI_SEMI] = ACTIONS(2072),
    [anon_sym_PIPE_AMP] = ACTIONS(2072),
    [anon_sym_AMP_AMP] = ACTIONS(2072),
    [anon_sym_PIPE_PIPE] = ACTIONS(2072),
    [anon_sym_LT] = ACTIONS(2072),
    [anon_sym_GT] = ACTIONS(2072),
    [anon_sym_GT_GT] = ACTIONS(2072),
    [anon_sym_AMP_GT] = ACTIONS(2072),
    [anon_sym_AMP_GT_GT] = ACTIONS(2072),
    [anon_sym_LT_AMP] = ACTIONS(2072),
    [anon_sym_GT_AMP] = ACTIONS(2072),
    [anon_sym_LT_LT] = ACTIONS(2072),
    [anon_sym_LT_LT_DASH] = ACTIONS(2072),
    [anon_sym_LT_LT_LT] = ACTIONS(2072),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2072),
    [anon_sym_LF] = ACTIONS(2070),
    [anon_sym_AMP] = ACTIONS(2072),
  },
  [666] = {
    [aux_sym_concatenation_repeat1] = STATE(1128),
    [sym__simple_heredoc_body] = ACTIONS(2074),
    [sym__heredoc_body_beginning] = ACTIONS(2074),
    [sym_file_descriptor] = ACTIONS(2074),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(2076),
    [anon_sym_RPAREN] = ACTIONS(2076),
    [anon_sym_SEMI_SEMI] = ACTIONS(2076),
    [anon_sym_PIPE_AMP] = ACTIONS(2076),
    [anon_sym_AMP_AMP] = ACTIONS(2076),
    [anon_sym_PIPE_PIPE] = ACTIONS(2076),
    [anon_sym_LT] = ACTIONS(2076),
    [anon_sym_GT] = ACTIONS(2076),
    [anon_sym_GT_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT_GT] = ACTIONS(2076),
    [anon_sym_LT_AMP] = ACTIONS(2076),
    [anon_sym_GT_AMP] = ACTIONS(2076),
    [anon_sym_LT_LT] = ACTIONS(2076),
    [anon_sym_LT_LT_DASH] = ACTIONS(2076),
    [anon_sym_LT_LT_LT] = ACTIONS(2076),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2076),
    [anon_sym_LF] = ACTIONS(2074),
    [anon_sym_AMP] = ACTIONS(2076),
  },
  [667] = {
    [sym_file_redirect] = STATE(667),
    [sym_heredoc_redirect] = STATE(667),
    [sym_herestring_redirect] = STATE(667),
    [aux_sym_while_statement_repeat1] = STATE(667),
    [sym__simple_heredoc_body] = ACTIONS(2082),
    [sym__heredoc_body_beginning] = ACTIONS(2082),
    [sym_file_descriptor] = ACTIONS(2419),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_RPAREN] = ACTIONS(2087),
    [anon_sym_SEMI_SEMI] = ACTIONS(2087),
    [anon_sym_PIPE_AMP] = ACTIONS(2087),
    [anon_sym_AMP_AMP] = ACTIONS(2087),
    [anon_sym_PIPE_PIPE] = ACTIONS(2087),
    [anon_sym_LT] = ACTIONS(2422),
    [anon_sym_GT] = ACTIONS(2422),
    [anon_sym_GT_GT] = ACTIONS(2422),
    [anon_sym_AMP_GT] = ACTIONS(2422),
    [anon_sym_AMP_GT_GT] = ACTIONS(2422),
    [anon_sym_LT_AMP] = ACTIONS(2422),
    [anon_sym_GT_AMP] = ACTIONS(2422),
    [anon_sym_LT_LT] = ACTIONS(2092),
    [anon_sym_LT_LT_DASH] = ACTIONS(2092),
    [anon_sym_LT_LT_LT] = ACTIONS(2425),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2087),
    [anon_sym_LF] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2087),
  },
  [668] = {
    [sym_file_redirect] = STATE(667),
    [sym_heredoc_redirect] = STATE(667),
    [sym_heredoc_body] = STATE(993),
    [sym_herestring_redirect] = STATE(667),
    [aux_sym_while_statement_repeat1] = STATE(667),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_RPAREN] = ACTIONS(2078),
    [anon_sym_SEMI_SEMI] = ACTIONS(2078),
    [anon_sym_PIPE_AMP] = ACTIONS(2078),
    [anon_sym_AMP_AMP] = ACTIONS(2078),
    [anon_sym_PIPE_PIPE] = ACTIONS(2078),
    [anon_sym_LT] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(487),
    [anon_sym_GT_GT] = ACTIONS(487),
    [anon_sym_AMP_GT] = ACTIONS(487),
    [anon_sym_AMP_GT_GT] = ACTIONS(487),
    [anon_sym_LT_AMP] = ACTIONS(487),
    [anon_sym_GT_AMP] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(489),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_LF] = ACTIONS(2080),
    [anon_sym_AMP] = ACTIONS(2078),
  },
  [669] = {
    [sym_concatenation] = STATE(669),
    [sym_string] = STATE(277),
    [sym_simple_expansion] = STATE(277),
    [sym_string_expansion] = STATE(277),
    [sym_expansion] = STATE(277),
    [sym_command_substitution] = STATE(277),
    [sym_process_substitution] = STATE(277),
    [aux_sym_command_repeat2] = STATE(669),
    [sym__simple_heredoc_body] = ACTIONS(2062),
    [sym__heredoc_body_beginning] = ACTIONS(2062),
    [sym_file_descriptor] = ACTIONS(2062),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_RPAREN] = ACTIONS(2064),
    [anon_sym_SEMI_SEMI] = ACTIONS(2064),
    [anon_sym_PIPE_AMP] = ACTIONS(2064),
    [anon_sym_AMP_AMP] = ACTIONS(2064),
    [anon_sym_PIPE_PIPE] = ACTIONS(2064),
    [anon_sym_EQ_TILDE] = ACTIONS(2428),
    [anon_sym_EQ_EQ] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2064),
    [anon_sym_LT_AMP] = ACTIONS(2064),
    [anon_sym_GT_AMP] = ACTIONS(2064),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2064),
    [anon_sym_LT_LT_LT] = ACTIONS(2064),
    [sym__special_characters] = ACTIONS(2431),
    [anon_sym_DQUOTE] = ACTIONS(2104),
    [anon_sym_DOLLAR] = ACTIONS(2107),
    [sym_raw_string] = ACTIONS(2434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2113),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2116),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [anon_sym_LT_LPAREN] = ACTIONS(2122),
    [anon_sym_GT_LPAREN] = ACTIONS(2122),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2434),
    [anon_sym_SEMI] = ACTIONS(2064),
    [anon_sym_LF] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2064),
  },
  [670] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_RPAREN] = ACTIONS(2437),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(953),
    [anon_sym_DQUOTE] = ACTIONS(951),
    [anon_sym_DOLLAR] = ACTIONS(953),
    [sym_raw_string] = ACTIONS(951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(951),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(951),
    [anon_sym_BQUOTE] = ACTIONS(951),
    [anon_sym_LT_LPAREN] = ACTIONS(951),
    [anon_sym_GT_LPAREN] = ACTIONS(951),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(953),
  },
  [671] = {
    [sym_file_redirect] = STATE(1130),
    [sym_heredoc_redirect] = STATE(1130),
    [sym_heredoc_body] = STATE(993),
    [sym_herestring_redirect] = STATE(1130),
    [sym_concatenation] = STATE(669),
    [sym_string] = STATE(277),
    [sym_simple_expansion] = STATE(277),
    [sym_string_expansion] = STATE(277),
    [sym_expansion] = STATE(277),
    [sym_command_substitution] = STATE(277),
    [sym_process_substitution] = STATE(277),
    [aux_sym_while_statement_repeat1] = STATE(1130),
    [aux_sym_command_repeat2] = STATE(669),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_RPAREN] = ACTIONS(2078),
    [anon_sym_SEMI_SEMI] = ACTIONS(2078),
    [anon_sym_PIPE_AMP] = ACTIONS(2078),
    [anon_sym_AMP_AMP] = ACTIONS(2078),
    [anon_sym_PIPE_PIPE] = ACTIONS(2078),
    [anon_sym_EQ_TILDE] = ACTIONS(485),
    [anon_sym_EQ_EQ] = ACTIONS(485),
    [anon_sym_LT] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(487),
    [anon_sym_GT_GT] = ACTIONS(487),
    [anon_sym_AMP_GT] = ACTIONS(487),
    [anon_sym_AMP_GT_GT] = ACTIONS(487),
    [anon_sym_LT_AMP] = ACTIONS(487),
    [anon_sym_GT_AMP] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(489),
    [sym__special_characters] = ACTIONS(491),
    [anon_sym_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(493),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(363),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_LF] = ACTIONS(2080),
    [anon_sym_AMP] = ACTIONS(2078),
  },
  [672] = {
    [sym_file_descriptor] = ACTIONS(1107),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_RPAREN] = ACTIONS(1107),
    [anon_sym_PIPE_AMP] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1109),
    [anon_sym_GT] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_AMP] = ACTIONS(1107),
    [anon_sym_GT_AMP] = ACTIONS(1107),
    [sym__special_characters] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LT_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_LPAREN] = ACTIONS(1107),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1107),
  },
  [673] = {
    [sym_concatenation] = STATE(1132),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(1132),
    [anon_sym_RPAREN] = ACTIONS(2439),
    [sym__special_characters] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1119),
  },
  [674] = {
    [aux_sym_concatenation_repeat1] = STATE(373),
    [sym_file_descriptor] = ACTIONS(1129),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_AMP_GT] = ACTIONS(1133),
    [anon_sym_AMP_GT_GT] = ACTIONS(1129),
    [anon_sym_LT_AMP] = ACTIONS(1129),
    [anon_sym_GT_AMP] = ACTIONS(1129),
    [sym__special_characters] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1129),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [sym_raw_string] = ACTIONS(1129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1129),
    [anon_sym_LT_LPAREN] = ACTIONS(1129),
    [anon_sym_GT_LPAREN] = ACTIONS(1129),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1129),
  },
  [675] = {
    [aux_sym_concatenation_repeat1] = STATE(373),
    [sym_file_descriptor] = ACTIONS(1107),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1109),
    [anon_sym_GT] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_AMP] = ACTIONS(1107),
    [anon_sym_GT_AMP] = ACTIONS(1107),
    [sym__special_characters] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LT_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_LPAREN] = ACTIONS(1107),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1107),
  },
  [676] = {
    [anon_sym_RPAREN] = ACTIONS(1307),
    [anon_sym_AMP_AMP] = ACTIONS(1301),
    [anon_sym_PIPE_PIPE] = ACTIONS(1301),
    [anon_sym_EQ_TILDE] = ACTIONS(1303),
    [anon_sym_EQ_EQ] = ACTIONS(1303),
    [anon_sym_EQ] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1301),
    [anon_sym_GT] = ACTIONS(1301),
    [anon_sym_BANG_EQ] = ACTIONS(1301),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1301),
  },
  [677] = {
    [aux_sym_concatenation_repeat1] = STATE(1133),
    [sym__concat] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_EQ_TILDE] = ACTIONS(693),
    [anon_sym_EQ_EQ] = ACTIONS(693),
    [anon_sym_EQ] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(693),
    [anon_sym_GT] = ACTIONS(693),
    [anon_sym_BANG_EQ] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(693),
  },
  [678] = {
    [anon_sym_AMP_AMP] = ACTIONS(2441),
    [anon_sym_PIPE_PIPE] = ACTIONS(2441),
    [anon_sym_RBRACK] = ACTIONS(2441),
    [anon_sym_EQ_TILDE] = ACTIONS(2441),
    [anon_sym_EQ_EQ] = ACTIONS(2441),
    [anon_sym_EQ] = ACTIONS(2443),
    [anon_sym_LT] = ACTIONS(2441),
    [anon_sym_GT] = ACTIONS(2441),
    [anon_sym_BANG_EQ] = ACTIONS(2441),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2441),
  },
  [679] = {
    [sym__expression] = STATE(727),
    [sym_binary_expression] = STATE(727),
    [sym_unary_expression] = STATE(727),
    [sym_parenthesized_expression] = STATE(727),
    [sym_concatenation] = STATE(727),
    [sym_string] = STATE(287),
    [sym_simple_expansion] = STATE(287),
    [sym_string_expansion] = STATE(287),
    [sym_expansion] = STATE(287),
    [sym_command_substitution] = STATE(287),
    [sym_process_substitution] = STATE(287),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(503),
    [sym__special_characters] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(507),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(509),
    [sym_test_operator] = ACTIONS(511),
  },
  [680] = {
    [sym__expression] = STATE(727),
    [sym_binary_expression] = STATE(727),
    [sym_unary_expression] = STATE(727),
    [sym_parenthesized_expression] = STATE(727),
    [sym_concatenation] = STATE(727),
    [sym_string] = STATE(287),
    [sym_simple_expansion] = STATE(287),
    [sym_string_expansion] = STATE(287),
    [sym_expansion] = STATE(287),
    [sym_command_substitution] = STATE(287),
    [sym_process_substitution] = STATE(287),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_BANG] = ACTIONS(503),
    [sym__special_characters] = ACTIONS(2445),
    [anon_sym_DQUOTE] = ACTIONS(1427),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(509),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1431),
    [anon_sym_BQUOTE] = ACTIONS(1433),
    [anon_sym_LT_LPAREN] = ACTIONS(1435),
    [anon_sym_GT_LPAREN] = ACTIONS(1435),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(509),
    [sym_test_operator] = ACTIONS(503),
    [sym_regex] = ACTIONS(1437),
  },
  [681] = {
    [sym__concat] = ACTIONS(1654),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [anon_sym_RBRACK] = ACTIONS(1654),
    [anon_sym_EQ_TILDE] = ACTIONS(1654),
    [anon_sym_EQ_EQ] = ACTIONS(1654),
    [anon_sym_EQ] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1654),
    [anon_sym_GT] = ACTIONS(1654),
    [anon_sym_BANG_EQ] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1654),
  },
  [682] = {
    [aux_sym_concatenation_repeat1] = STATE(682),
    [sym__concat] = ACTIONS(2447),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [anon_sym_RBRACK] = ACTIONS(1654),
    [anon_sym_EQ_TILDE] = ACTIONS(1654),
    [anon_sym_EQ_EQ] = ACTIONS(1654),
    [anon_sym_EQ] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1654),
    [anon_sym_GT] = ACTIONS(1654),
    [anon_sym_BANG_EQ] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1654),
  },
  [683] = {
    [sym__concat] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_RBRACK] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1703),
    [anon_sym_EQ] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1703),
    [anon_sym_GT] = ACTIONS(1703),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1703),
  },
  [684] = {
    [sym_concatenation] = STATE(1137),
    [sym_string] = STATE(1136),
    [sym_simple_expansion] = STATE(1136),
    [sym_string_expansion] = STATE(1136),
    [sym_expansion] = STATE(1136),
    [sym_command_substitution] = STATE(1136),
    [sym_process_substitution] = STATE(1136),
    [anon_sym_RBRACE] = ACTIONS(2450),
    [sym__special_characters] = ACTIONS(2452),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2454),
  },
  [685] = {
    [sym__concat] = ACTIONS(1744),
    [anon_sym_AMP_AMP] = ACTIONS(1744),
    [anon_sym_PIPE_PIPE] = ACTIONS(1744),
    [anon_sym_RBRACK] = ACTIONS(1744),
    [anon_sym_EQ_TILDE] = ACTIONS(1744),
    [anon_sym_EQ_EQ] = ACTIONS(1744),
    [anon_sym_EQ] = ACTIONS(1746),
    [anon_sym_LT] = ACTIONS(1744),
    [anon_sym_GT] = ACTIONS(1744),
    [anon_sym_BANG_EQ] = ACTIONS(1744),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1744),
  },
  [686] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2456),
  },
  [687] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2458),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [688] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(2460),
    [sym_comment] = ACTIONS(53),
  },
  [689] = {
    [sym_concatenation] = STATE(1143),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1143),
    [anon_sym_RBRACE] = ACTIONS(2462),
    [anon_sym_EQ] = ACTIONS(2464),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2466),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2468),
    [anon_sym_COLON] = ACTIONS(2464),
    [anon_sym_COLON_QMARK] = ACTIONS(2464),
    [anon_sym_COLON_DASH] = ACTIONS(2464),
    [anon_sym_PERCENT] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [690] = {
    [sym_concatenation] = STATE(1146),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1146),
    [anon_sym_RBRACE] = ACTIONS(2470),
    [anon_sym_EQ] = ACTIONS(2472),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2476),
    [anon_sym_COLON] = ACTIONS(2472),
    [anon_sym_COLON_QMARK] = ACTIONS(2472),
    [anon_sym_COLON_DASH] = ACTIONS(2472),
    [anon_sym_PERCENT] = ACTIONS(2472),
    [anon_sym_DASH] = ACTIONS(2472),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [691] = {
    [sym_concatenation] = STATE(1148),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1148),
    [anon_sym_RBRACE] = ACTIONS(2450),
    [anon_sym_EQ] = ACTIONS(2478),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2480),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2482),
    [anon_sym_COLON] = ACTIONS(2478),
    [anon_sym_COLON_QMARK] = ACTIONS(2478),
    [anon_sym_COLON_DASH] = ACTIONS(2478),
    [anon_sym_PERCENT] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [692] = {
    [sym__concat] = ACTIONS(1810),
    [anon_sym_AMP_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1810),
    [anon_sym_RBRACK] = ACTIONS(1810),
    [anon_sym_EQ_TILDE] = ACTIONS(1810),
    [anon_sym_EQ_EQ] = ACTIONS(1810),
    [anon_sym_EQ] = ACTIONS(1812),
    [anon_sym_LT] = ACTIONS(1810),
    [anon_sym_GT] = ACTIONS(1810),
    [anon_sym_BANG_EQ] = ACTIONS(1810),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1810),
  },
  [693] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2484),
  },
  [694] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2486),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [695] = {
    [sym__concat] = ACTIONS(1818),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [anon_sym_RBRACK] = ACTIONS(1818),
    [anon_sym_EQ_TILDE] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1818),
    [anon_sym_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_BANG_EQ] = ACTIONS(1818),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1818),
  },
  [696] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2488),
  },
  [697] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2450),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [698] = {
    [sym__concat] = ACTIONS(1952),
    [anon_sym_AMP_AMP] = ACTIONS(1952),
    [anon_sym_PIPE_PIPE] = ACTIONS(1952),
    [anon_sym_RBRACK] = ACTIONS(1952),
    [anon_sym_EQ_TILDE] = ACTIONS(1952),
    [anon_sym_EQ_EQ] = ACTIONS(1952),
    [anon_sym_EQ] = ACTIONS(1954),
    [anon_sym_LT] = ACTIONS(1952),
    [anon_sym_GT] = ACTIONS(1952),
    [anon_sym_BANG_EQ] = ACTIONS(1952),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1952),
  },
  [699] = {
    [sym__concat] = ACTIONS(2018),
    [anon_sym_AMP_AMP] = ACTIONS(2018),
    [anon_sym_PIPE_PIPE] = ACTIONS(2018),
    [anon_sym_RBRACK] = ACTIONS(2018),
    [anon_sym_EQ_TILDE] = ACTIONS(2018),
    [anon_sym_EQ_EQ] = ACTIONS(2018),
    [anon_sym_EQ] = ACTIONS(2020),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(2018),
    [anon_sym_BANG_EQ] = ACTIONS(2018),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2018),
  },
  [700] = {
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_PIPE_PIPE] = ACTIONS(2490),
    [anon_sym_RBRACK] = ACTIONS(2490),
    [anon_sym_EQ_TILDE] = ACTIONS(2490),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_EQ] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2490),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2490),
  },
  [701] = {
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2496),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2496),
    [anon_sym_LT_AMP] = ACTIONS(2496),
    [anon_sym_GT_AMP] = ACTIONS(2496),
    [sym_comment] = ACTIONS(53),
  },
  [702] = {
    [sym_concatenation] = STATE(1161),
    [sym_string] = STATE(1156),
    [sym_simple_expansion] = STATE(1156),
    [sym_string_expansion] = STATE(1156),
    [sym_expansion] = STATE(1156),
    [sym_command_substitution] = STATE(1156),
    [sym_process_substitution] = STATE(1156),
    [sym__special_characters] = ACTIONS(2498),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2504),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2508),
    [anon_sym_BQUOTE] = ACTIONS(2510),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2504),
  },
  [703] = {
    [sym_heredoc_start] = ACTIONS(2514),
    [sym_comment] = ACTIONS(53),
  },
  [704] = {
    [sym_concatenation] = STATE(1165),
    [sym_string] = STATE(1164),
    [sym_simple_expansion] = STATE(1164),
    [sym_string_expansion] = STATE(1164),
    [sym_expansion] = STATE(1164),
    [sym_command_substitution] = STATE(1164),
    [sym_process_substitution] = STATE(1164),
    [sym__special_characters] = ACTIONS(2516),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2508),
    [anon_sym_BQUOTE] = ACTIONS(2510),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2518),
  },
  [705] = {
    [sym_file_redirect] = STATE(1166),
    [sym_heredoc_redirect] = STATE(1166),
    [sym_herestring_redirect] = STATE(1166),
    [aux_sym_while_statement_repeat1] = STATE(1166),
    [sym_file_descriptor] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(2520),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(1355),
    [anon_sym_GT] = ACTIONS(1355),
    [anon_sym_GT_GT] = ACTIONS(1355),
    [anon_sym_AMP_GT] = ACTIONS(1355),
    [anon_sym_AMP_GT_GT] = ACTIONS(1355),
    [anon_sym_LT_AMP] = ACTIONS(1355),
    [anon_sym_GT_AMP] = ACTIONS(1355),
    [anon_sym_LT_LT] = ACTIONS(1357),
    [anon_sym_LT_LT_DASH] = ACTIONS(1357),
    [anon_sym_LT_LT_LT] = ACTIONS(1359),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2520),
    [anon_sym_LF] = ACTIONS(2522),
    [anon_sym_AMP] = ACTIONS(2520),
  },
  [706] = {
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_PIPE_PIPE] = ACTIONS(2490),
    [anon_sym_RBRACK] = ACTIONS(2490),
    [anon_sym_EQ_TILDE] = ACTIONS(2490),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_EQ] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2490),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2490),
  },
  [707] = {
    [anon_sym_RPAREN] = ACTIONS(2441),
    [anon_sym_AMP_AMP] = ACTIONS(2441),
    [anon_sym_PIPE_PIPE] = ACTIONS(2441),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2441),
    [anon_sym_EQ_TILDE] = ACTIONS(2441),
    [anon_sym_EQ_EQ] = ACTIONS(2441),
    [anon_sym_EQ] = ACTIONS(2443),
    [anon_sym_LT] = ACTIONS(2441),
    [anon_sym_GT] = ACTIONS(2441),
    [anon_sym_BANG_EQ] = ACTIONS(2441),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2441),
  },
  [708] = {
    [sym__concat] = ACTIONS(1654),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1654),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1654),
    [anon_sym_EQ_TILDE] = ACTIONS(1654),
    [anon_sym_EQ_EQ] = ACTIONS(1654),
    [anon_sym_EQ] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1654),
    [anon_sym_GT] = ACTIONS(1654),
    [anon_sym_BANG_EQ] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1654),
  },
  [709] = {
    [aux_sym_concatenation_repeat1] = STATE(709),
    [sym__concat] = ACTIONS(2524),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1654),
    [anon_sym_EQ_TILDE] = ACTIONS(1654),
    [anon_sym_EQ_EQ] = ACTIONS(1654),
    [anon_sym_EQ] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1654),
    [anon_sym_GT] = ACTIONS(1654),
    [anon_sym_BANG_EQ] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1654),
  },
  [710] = {
    [sym__concat] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1703),
    [anon_sym_EQ] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1703),
    [anon_sym_GT] = ACTIONS(1703),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1703),
  },
  [711] = {
    [sym_concatenation] = STATE(1170),
    [sym_string] = STATE(1169),
    [sym_simple_expansion] = STATE(1169),
    [sym_string_expansion] = STATE(1169),
    [sym_expansion] = STATE(1169),
    [sym_command_substitution] = STATE(1169),
    [sym_process_substitution] = STATE(1169),
    [anon_sym_RBRACE] = ACTIONS(2527),
    [sym__special_characters] = ACTIONS(2529),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(2531),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2531),
  },
  [712] = {
    [sym__concat] = ACTIONS(1744),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_RPAREN] = ACTIONS(1744),
    [anon_sym_AMP_AMP] = ACTIONS(1744),
    [anon_sym_PIPE_PIPE] = ACTIONS(1744),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1744),
    [anon_sym_EQ_TILDE] = ACTIONS(1744),
    [anon_sym_EQ_EQ] = ACTIONS(1744),
    [anon_sym_EQ] = ACTIONS(1746),
    [anon_sym_LT] = ACTIONS(1744),
    [anon_sym_GT] = ACTIONS(1744),
    [anon_sym_BANG_EQ] = ACTIONS(1744),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1744),
  },
  [713] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2533),
  },
  [714] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2535),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [715] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(2537),
    [sym_comment] = ACTIONS(53),
  },
  [716] = {
    [sym_concatenation] = STATE(1176),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1176),
    [anon_sym_RBRACE] = ACTIONS(2539),
    [anon_sym_EQ] = ACTIONS(2541),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2545),
    [anon_sym_COLON] = ACTIONS(2541),
    [anon_sym_COLON_QMARK] = ACTIONS(2541),
    [anon_sym_COLON_DASH] = ACTIONS(2541),
    [anon_sym_PERCENT] = ACTIONS(2541),
    [anon_sym_DASH] = ACTIONS(2541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [717] = {
    [sym_concatenation] = STATE(1179),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1179),
    [anon_sym_RBRACE] = ACTIONS(2547),
    [anon_sym_EQ] = ACTIONS(2549),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2553),
    [anon_sym_COLON] = ACTIONS(2549),
    [anon_sym_COLON_QMARK] = ACTIONS(2549),
    [anon_sym_COLON_DASH] = ACTIONS(2549),
    [anon_sym_PERCENT] = ACTIONS(2549),
    [anon_sym_DASH] = ACTIONS(2549),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [718] = {
    [sym_concatenation] = STATE(1181),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1181),
    [anon_sym_RBRACE] = ACTIONS(2527),
    [anon_sym_EQ] = ACTIONS(2555),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2559),
    [anon_sym_COLON] = ACTIONS(2555),
    [anon_sym_COLON_QMARK] = ACTIONS(2555),
    [anon_sym_COLON_DASH] = ACTIONS(2555),
    [anon_sym_PERCENT] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [719] = {
    [sym__concat] = ACTIONS(1810),
    [anon_sym_PIPE] = ACTIONS(1812),
    [anon_sym_RPAREN] = ACTIONS(1810),
    [anon_sym_AMP_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1810),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1810),
    [anon_sym_EQ_TILDE] = ACTIONS(1810),
    [anon_sym_EQ_EQ] = ACTIONS(1810),
    [anon_sym_EQ] = ACTIONS(1812),
    [anon_sym_LT] = ACTIONS(1810),
    [anon_sym_GT] = ACTIONS(1810),
    [anon_sym_BANG_EQ] = ACTIONS(1810),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1810),
  },
  [720] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2561),
  },
  [721] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2563),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [722] = {
    [sym__concat] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1820),
    [anon_sym_RPAREN] = ACTIONS(1818),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1818),
    [anon_sym_EQ_TILDE] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1818),
    [anon_sym_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_BANG_EQ] = ACTIONS(1818),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1818),
  },
  [723] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2565),
  },
  [724] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2527),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [725] = {
    [sym__concat] = ACTIONS(1952),
    [anon_sym_PIPE] = ACTIONS(1954),
    [anon_sym_RPAREN] = ACTIONS(1952),
    [anon_sym_AMP_AMP] = ACTIONS(1952),
    [anon_sym_PIPE_PIPE] = ACTIONS(1952),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1952),
    [anon_sym_EQ_TILDE] = ACTIONS(1952),
    [anon_sym_EQ_EQ] = ACTIONS(1952),
    [anon_sym_EQ] = ACTIONS(1954),
    [anon_sym_LT] = ACTIONS(1952),
    [anon_sym_GT] = ACTIONS(1952),
    [anon_sym_BANG_EQ] = ACTIONS(1952),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1952),
  },
  [726] = {
    [sym__concat] = ACTIONS(2018),
    [anon_sym_PIPE] = ACTIONS(2020),
    [anon_sym_RPAREN] = ACTIONS(2018),
    [anon_sym_AMP_AMP] = ACTIONS(2018),
    [anon_sym_PIPE_PIPE] = ACTIONS(2018),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2018),
    [anon_sym_EQ_TILDE] = ACTIONS(2018),
    [anon_sym_EQ_EQ] = ACTIONS(2018),
    [anon_sym_EQ] = ACTIONS(2020),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(2018),
    [anon_sym_BANG_EQ] = ACTIONS(2018),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2018),
  },
  [727] = {
    [anon_sym_RPAREN] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_PIPE_PIPE] = ACTIONS(2490),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2490),
    [anon_sym_EQ_TILDE] = ACTIONS(2490),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_EQ] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2490),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2490),
  },
  [728] = {
    [anon_sym_RPAREN] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_PIPE_PIPE] = ACTIONS(2490),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2490),
    [anon_sym_EQ_TILDE] = ACTIONS(2490),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_EQ] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2490),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2490),
  },
  [729] = {
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [sym__special_characters] = ACTIONS(1109),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1109),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_LT_LPAREN] = ACTIONS(1109),
    [anon_sym_GT_LPAREN] = ACTIONS(1109),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1109),
    [sym_word] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1109),
  },
  [730] = {
    [sym_concatenation] = STATE(1186),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(1186),
    [anon_sym_RPAREN] = ACTIONS(2567),
    [sym__special_characters] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1119),
  },
  [731] = {
    [aux_sym_concatenation_repeat1] = STATE(335),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_SEMI_SEMI] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [sym__special_characters] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1133),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1133),
    [sym_word] = ACTIONS(1133),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_LF] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1133),
  },
  [732] = {
    [aux_sym_concatenation_repeat1] = STATE(335),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [sym__special_characters] = ACTIONS(1109),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1109),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_LT_LPAREN] = ACTIONS(1109),
    [anon_sym_GT_LPAREN] = ACTIONS(1109),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1109),
    [sym_word] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1109),
  },
  [733] = {
    [sym__concat] = ACTIONS(1654),
    [sym_variable_name] = ACTIONS(1654),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LT_LPAREN] = ACTIONS(1656),
    [anon_sym_GT_LPAREN] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1656),
    [sym_word] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [734] = {
    [aux_sym_concatenation_repeat1] = STATE(734),
    [sym__concat] = ACTIONS(2569),
    [sym_variable_name] = ACTIONS(1654),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LT_LPAREN] = ACTIONS(1656),
    [anon_sym_GT_LPAREN] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1656),
    [sym_word] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [735] = {
    [sym__concat] = ACTIONS(1703),
    [sym_variable_name] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_RPAREN] = ACTIONS(1705),
    [anon_sym_SEMI_SEMI] = ACTIONS(1705),
    [anon_sym_PIPE_AMP] = ACTIONS(1705),
    [anon_sym_AMP_AMP] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE] = ACTIONS(1705),
    [sym__special_characters] = ACTIONS(1705),
    [anon_sym_DQUOTE] = ACTIONS(1705),
    [anon_sym_DOLLAR] = ACTIONS(1705),
    [sym_raw_string] = ACTIONS(1705),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1705),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1705),
    [anon_sym_BQUOTE] = ACTIONS(1705),
    [anon_sym_LT_LPAREN] = ACTIONS(1705),
    [anon_sym_GT_LPAREN] = ACTIONS(1705),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1705),
    [sym_word] = ACTIONS(1705),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_LF] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1705),
  },
  [736] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(1189),
    [sym_simple_expansion] = STATE(1189),
    [sym_string_expansion] = STATE(1189),
    [sym_expansion] = STATE(1189),
    [sym_command_substitution] = STATE(1189),
    [sym_process_substitution] = STATE(1189),
    [anon_sym_RBRACE] = ACTIONS(2572),
    [sym__special_characters] = ACTIONS(2574),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(2576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2576),
  },
  [737] = {
    [sym__concat] = ACTIONS(1744),
    [sym_variable_name] = ACTIONS(1744),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_RPAREN] = ACTIONS(1746),
    [anon_sym_SEMI_SEMI] = ACTIONS(1746),
    [anon_sym_PIPE_AMP] = ACTIONS(1746),
    [anon_sym_AMP_AMP] = ACTIONS(1746),
    [anon_sym_PIPE_PIPE] = ACTIONS(1746),
    [sym__special_characters] = ACTIONS(1746),
    [anon_sym_DQUOTE] = ACTIONS(1746),
    [anon_sym_DOLLAR] = ACTIONS(1746),
    [sym_raw_string] = ACTIONS(1746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1746),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1746),
    [anon_sym_GT_LPAREN] = ACTIONS(1746),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1746),
    [sym_word] = ACTIONS(1746),
    [anon_sym_SEMI] = ACTIONS(1746),
    [anon_sym_LF] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(1746),
  },
  [738] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2578),
  },
  [739] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2580),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [740] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(2582),
    [sym_comment] = ACTIONS(53),
  },
  [741] = {
    [sym_concatenation] = STATE(1196),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1196),
    [anon_sym_RBRACE] = ACTIONS(2584),
    [anon_sym_EQ] = ACTIONS(2586),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2588),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2590),
    [anon_sym_COLON] = ACTIONS(2586),
    [anon_sym_COLON_QMARK] = ACTIONS(2586),
    [anon_sym_COLON_DASH] = ACTIONS(2586),
    [anon_sym_PERCENT] = ACTIONS(2586),
    [anon_sym_DASH] = ACTIONS(2586),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [742] = {
    [sym_concatenation] = STATE(1199),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1199),
    [anon_sym_RBRACE] = ACTIONS(2592),
    [anon_sym_EQ] = ACTIONS(2594),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2596),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2598),
    [anon_sym_COLON] = ACTIONS(2594),
    [anon_sym_COLON_QMARK] = ACTIONS(2594),
    [anon_sym_COLON_DASH] = ACTIONS(2594),
    [anon_sym_PERCENT] = ACTIONS(2594),
    [anon_sym_DASH] = ACTIONS(2594),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [743] = {
    [sym_concatenation] = STATE(1201),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1201),
    [anon_sym_RBRACE] = ACTIONS(2572),
    [anon_sym_EQ] = ACTIONS(2600),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2604),
    [anon_sym_COLON] = ACTIONS(2600),
    [anon_sym_COLON_QMARK] = ACTIONS(2600),
    [anon_sym_COLON_DASH] = ACTIONS(2600),
    [anon_sym_PERCENT] = ACTIONS(2600),
    [anon_sym_DASH] = ACTIONS(2600),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [744] = {
    [sym__concat] = ACTIONS(1810),
    [sym_variable_name] = ACTIONS(1810),
    [anon_sym_PIPE] = ACTIONS(1812),
    [anon_sym_RPAREN] = ACTIONS(1812),
    [anon_sym_SEMI_SEMI] = ACTIONS(1812),
    [anon_sym_PIPE_AMP] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1812),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [sym__special_characters] = ACTIONS(1812),
    [anon_sym_DQUOTE] = ACTIONS(1812),
    [anon_sym_DOLLAR] = ACTIONS(1812),
    [sym_raw_string] = ACTIONS(1812),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1812),
    [anon_sym_GT_LPAREN] = ACTIONS(1812),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1812),
    [sym_word] = ACTIONS(1812),
    [anon_sym_SEMI] = ACTIONS(1812),
    [anon_sym_LF] = ACTIONS(1810),
    [anon_sym_AMP] = ACTIONS(1812),
  },
  [745] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2606),
  },
  [746] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2608),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [747] = {
    [sym__concat] = ACTIONS(1818),
    [sym_variable_name] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1820),
    [anon_sym_RPAREN] = ACTIONS(1820),
    [anon_sym_SEMI_SEMI] = ACTIONS(1820),
    [anon_sym_PIPE_AMP] = ACTIONS(1820),
    [anon_sym_AMP_AMP] = ACTIONS(1820),
    [anon_sym_PIPE_PIPE] = ACTIONS(1820),
    [sym__special_characters] = ACTIONS(1820),
    [anon_sym_DQUOTE] = ACTIONS(1820),
    [anon_sym_DOLLAR] = ACTIONS(1820),
    [sym_raw_string] = ACTIONS(1820),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1820),
    [anon_sym_BQUOTE] = ACTIONS(1820),
    [anon_sym_LT_LPAREN] = ACTIONS(1820),
    [anon_sym_GT_LPAREN] = ACTIONS(1820),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1820),
    [sym_word] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1820),
    [anon_sym_LF] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1820),
  },
  [748] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2610),
  },
  [749] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2572),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [750] = {
    [sym__concat] = ACTIONS(1952),
    [sym_variable_name] = ACTIONS(1952),
    [anon_sym_PIPE] = ACTIONS(1954),
    [anon_sym_RPAREN] = ACTIONS(1954),
    [anon_sym_SEMI_SEMI] = ACTIONS(1954),
    [anon_sym_PIPE_AMP] = ACTIONS(1954),
    [anon_sym_AMP_AMP] = ACTIONS(1954),
    [anon_sym_PIPE_PIPE] = ACTIONS(1954),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1954),
    [anon_sym_DOLLAR] = ACTIONS(1954),
    [sym_raw_string] = ACTIONS(1954),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1954),
    [anon_sym_BQUOTE] = ACTIONS(1954),
    [anon_sym_LT_LPAREN] = ACTIONS(1954),
    [anon_sym_GT_LPAREN] = ACTIONS(1954),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1954),
    [sym_word] = ACTIONS(1954),
    [anon_sym_SEMI] = ACTIONS(1954),
    [anon_sym_LF] = ACTIONS(1952),
    [anon_sym_AMP] = ACTIONS(1954),
  },
  [751] = {
    [sym__concat] = ACTIONS(2018),
    [sym_variable_name] = ACTIONS(2018),
    [anon_sym_PIPE] = ACTIONS(2020),
    [anon_sym_RPAREN] = ACTIONS(2020),
    [anon_sym_SEMI_SEMI] = ACTIONS(2020),
    [anon_sym_PIPE_AMP] = ACTIONS(2020),
    [anon_sym_AMP_AMP] = ACTIONS(2020),
    [anon_sym_PIPE_PIPE] = ACTIONS(2020),
    [sym__special_characters] = ACTIONS(2020),
    [anon_sym_DQUOTE] = ACTIONS(2020),
    [anon_sym_DOLLAR] = ACTIONS(2020),
    [sym_raw_string] = ACTIONS(2020),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2020),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2020),
    [anon_sym_BQUOTE] = ACTIONS(2020),
    [anon_sym_LT_LPAREN] = ACTIONS(2020),
    [anon_sym_GT_LPAREN] = ACTIONS(2020),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2020),
    [sym_word] = ACTIONS(2020),
    [anon_sym_SEMI] = ACTIONS(2020),
    [anon_sym_LF] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2020),
  },
  [752] = {
    [sym__concat] = ACTIONS(1654),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LT_LPAREN] = ACTIONS(1656),
    [anon_sym_GT_LPAREN] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1656),
    [sym_word] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [753] = {
    [aux_sym_concatenation_repeat1] = STATE(753),
    [sym__concat] = ACTIONS(2612),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LT_LPAREN] = ACTIONS(1656),
    [anon_sym_GT_LPAREN] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1656),
    [sym_word] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [754] = {
    [sym__concat] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_RPAREN] = ACTIONS(1705),
    [anon_sym_SEMI_SEMI] = ACTIONS(1705),
    [anon_sym_PIPE_AMP] = ACTIONS(1705),
    [anon_sym_AMP_AMP] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE] = ACTIONS(1705),
    [sym__special_characters] = ACTIONS(1705),
    [anon_sym_DQUOTE] = ACTIONS(1705),
    [anon_sym_DOLLAR] = ACTIONS(1705),
    [sym_raw_string] = ACTIONS(1705),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1705),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1705),
    [anon_sym_BQUOTE] = ACTIONS(1705),
    [anon_sym_LT_LPAREN] = ACTIONS(1705),
    [anon_sym_GT_LPAREN] = ACTIONS(1705),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1705),
    [sym_word] = ACTIONS(1705),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_LF] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1705),
  },
  [755] = {
    [sym_concatenation] = STATE(1208),
    [sym_string] = STATE(1207),
    [sym_simple_expansion] = STATE(1207),
    [sym_string_expansion] = STATE(1207),
    [sym_expansion] = STATE(1207),
    [sym_command_substitution] = STATE(1207),
    [sym_process_substitution] = STATE(1207),
    [anon_sym_RBRACE] = ACTIONS(2615),
    [sym__special_characters] = ACTIONS(2617),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(2619),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2619),
  },
  [756] = {
    [sym__concat] = ACTIONS(1744),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_RPAREN] = ACTIONS(1746),
    [anon_sym_SEMI_SEMI] = ACTIONS(1746),
    [anon_sym_PIPE_AMP] = ACTIONS(1746),
    [anon_sym_AMP_AMP] = ACTIONS(1746),
    [anon_sym_PIPE_PIPE] = ACTIONS(1746),
    [sym__special_characters] = ACTIONS(1746),
    [anon_sym_DQUOTE] = ACTIONS(1746),
    [anon_sym_DOLLAR] = ACTIONS(1746),
    [sym_raw_string] = ACTIONS(1746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1746),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1746),
    [anon_sym_GT_LPAREN] = ACTIONS(1746),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1746),
    [sym_word] = ACTIONS(1746),
    [anon_sym_SEMI] = ACTIONS(1746),
    [anon_sym_LF] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(1746),
  },
  [757] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2621),
  },
  [758] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2623),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [759] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(2625),
    [sym_comment] = ACTIONS(53),
  },
  [760] = {
    [sym_concatenation] = STATE(1214),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1214),
    [anon_sym_RBRACE] = ACTIONS(2627),
    [anon_sym_EQ] = ACTIONS(2629),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2631),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2633),
    [anon_sym_COLON] = ACTIONS(2629),
    [anon_sym_COLON_QMARK] = ACTIONS(2629),
    [anon_sym_COLON_DASH] = ACTIONS(2629),
    [anon_sym_PERCENT] = ACTIONS(2629),
    [anon_sym_DASH] = ACTIONS(2629),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [761] = {
    [sym_concatenation] = STATE(1217),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1217),
    [anon_sym_RBRACE] = ACTIONS(2635),
    [anon_sym_EQ] = ACTIONS(2637),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2641),
    [anon_sym_COLON] = ACTIONS(2637),
    [anon_sym_COLON_QMARK] = ACTIONS(2637),
    [anon_sym_COLON_DASH] = ACTIONS(2637),
    [anon_sym_PERCENT] = ACTIONS(2637),
    [anon_sym_DASH] = ACTIONS(2637),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [762] = {
    [sym_concatenation] = STATE(1219),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1219),
    [anon_sym_RBRACE] = ACTIONS(2615),
    [anon_sym_EQ] = ACTIONS(2643),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2645),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2647),
    [anon_sym_COLON] = ACTIONS(2643),
    [anon_sym_COLON_QMARK] = ACTIONS(2643),
    [anon_sym_COLON_DASH] = ACTIONS(2643),
    [anon_sym_PERCENT] = ACTIONS(2643),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [763] = {
    [sym__concat] = ACTIONS(1810),
    [anon_sym_PIPE] = ACTIONS(1812),
    [anon_sym_RPAREN] = ACTIONS(1812),
    [anon_sym_SEMI_SEMI] = ACTIONS(1812),
    [anon_sym_PIPE_AMP] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1812),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [sym__special_characters] = ACTIONS(1812),
    [anon_sym_DQUOTE] = ACTIONS(1812),
    [anon_sym_DOLLAR] = ACTIONS(1812),
    [sym_raw_string] = ACTIONS(1812),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1812),
    [anon_sym_GT_LPAREN] = ACTIONS(1812),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1812),
    [sym_word] = ACTIONS(1812),
    [anon_sym_SEMI] = ACTIONS(1812),
    [anon_sym_LF] = ACTIONS(1810),
    [anon_sym_AMP] = ACTIONS(1812),
  },
  [764] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2649),
  },
  [765] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2651),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [766] = {
    [sym__concat] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1820),
    [anon_sym_RPAREN] = ACTIONS(1820),
    [anon_sym_SEMI_SEMI] = ACTIONS(1820),
    [anon_sym_PIPE_AMP] = ACTIONS(1820),
    [anon_sym_AMP_AMP] = ACTIONS(1820),
    [anon_sym_PIPE_PIPE] = ACTIONS(1820),
    [sym__special_characters] = ACTIONS(1820),
    [anon_sym_DQUOTE] = ACTIONS(1820),
    [anon_sym_DOLLAR] = ACTIONS(1820),
    [sym_raw_string] = ACTIONS(1820),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1820),
    [anon_sym_BQUOTE] = ACTIONS(1820),
    [anon_sym_LT_LPAREN] = ACTIONS(1820),
    [anon_sym_GT_LPAREN] = ACTIONS(1820),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1820),
    [sym_word] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1820),
    [anon_sym_LF] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1820),
  },
  [767] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2653),
  },
  [768] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2615),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [769] = {
    [sym__concat] = ACTIONS(1952),
    [anon_sym_PIPE] = ACTIONS(1954),
    [anon_sym_RPAREN] = ACTIONS(1954),
    [anon_sym_SEMI_SEMI] = ACTIONS(1954),
    [anon_sym_PIPE_AMP] = ACTIONS(1954),
    [anon_sym_AMP_AMP] = ACTIONS(1954),
    [anon_sym_PIPE_PIPE] = ACTIONS(1954),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1954),
    [anon_sym_DOLLAR] = ACTIONS(1954),
    [sym_raw_string] = ACTIONS(1954),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1954),
    [anon_sym_BQUOTE] = ACTIONS(1954),
    [anon_sym_LT_LPAREN] = ACTIONS(1954),
    [anon_sym_GT_LPAREN] = ACTIONS(1954),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1954),
    [sym_word] = ACTIONS(1954),
    [anon_sym_SEMI] = ACTIONS(1954),
    [anon_sym_LF] = ACTIONS(1952),
    [anon_sym_AMP] = ACTIONS(1954),
  },
  [770] = {
    [sym__concat] = ACTIONS(2018),
    [anon_sym_PIPE] = ACTIONS(2020),
    [anon_sym_RPAREN] = ACTIONS(2020),
    [anon_sym_SEMI_SEMI] = ACTIONS(2020),
    [anon_sym_PIPE_AMP] = ACTIONS(2020),
    [anon_sym_AMP_AMP] = ACTIONS(2020),
    [anon_sym_PIPE_PIPE] = ACTIONS(2020),
    [sym__special_characters] = ACTIONS(2020),
    [anon_sym_DQUOTE] = ACTIONS(2020),
    [anon_sym_DOLLAR] = ACTIONS(2020),
    [sym_raw_string] = ACTIONS(2020),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2020),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2020),
    [anon_sym_BQUOTE] = ACTIONS(2020),
    [anon_sym_LT_LPAREN] = ACTIONS(2020),
    [anon_sym_GT_LPAREN] = ACTIONS(2020),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2020),
    [sym_word] = ACTIONS(2020),
    [anon_sym_SEMI] = ACTIONS(2020),
    [anon_sym_LF] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2020),
  },
  [771] = {
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(1654),
    [sym_variable_name] = ACTIONS(1654),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1654),
    [anon_sym_PIPE_AMP] = ACTIONS(1654),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1654),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1654),
    [anon_sym_LT_AMP] = ACTIONS(1654),
    [anon_sym_GT_AMP] = ACTIONS(1654),
    [sym__special_characters] = ACTIONS(1654),
    [anon_sym_DQUOTE] = ACTIONS(1654),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1654),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1654),
    [anon_sym_BQUOTE] = ACTIONS(1654),
    [anon_sym_LT_LPAREN] = ACTIONS(1654),
    [anon_sym_GT_LPAREN] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1654),
  },
  [772] = {
    [aux_sym_concatenation_repeat1] = STATE(772),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(2655),
    [sym_variable_name] = ACTIONS(1654),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1654),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1654),
    [anon_sym_LT_AMP] = ACTIONS(1654),
    [anon_sym_GT_AMP] = ACTIONS(1654),
    [sym__special_characters] = ACTIONS(1654),
    [anon_sym_DQUOTE] = ACTIONS(1654),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1654),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1654),
    [anon_sym_BQUOTE] = ACTIONS(1654),
    [anon_sym_LT_LPAREN] = ACTIONS(1654),
    [anon_sym_GT_LPAREN] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1654),
  },
  [773] = {
    [sym_file_descriptor] = ACTIONS(1703),
    [sym__concat] = ACTIONS(1703),
    [sym_variable_name] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_PIPE_AMP] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_LT] = ACTIONS(1705),
    [anon_sym_GT] = ACTIONS(1705),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_AMP_GT] = ACTIONS(1705),
    [anon_sym_AMP_GT_GT] = ACTIONS(1703),
    [anon_sym_LT_AMP] = ACTIONS(1703),
    [anon_sym_GT_AMP] = ACTIONS(1703),
    [sym__special_characters] = ACTIONS(1703),
    [anon_sym_DQUOTE] = ACTIONS(1703),
    [anon_sym_DOLLAR] = ACTIONS(1705),
    [sym_raw_string] = ACTIONS(1703),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1703),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1703),
    [anon_sym_BQUOTE] = ACTIONS(1703),
    [anon_sym_LT_LPAREN] = ACTIONS(1703),
    [anon_sym_GT_LPAREN] = ACTIONS(1703),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1703),
  },
  [774] = {
    [sym_concatenation] = STATE(1226),
    [sym_string] = STATE(1225),
    [sym_simple_expansion] = STATE(1225),
    [sym_string_expansion] = STATE(1225),
    [sym_expansion] = STATE(1225),
    [sym_command_substitution] = STATE(1225),
    [sym_process_substitution] = STATE(1225),
    [anon_sym_RBRACE] = ACTIONS(2658),
    [sym__special_characters] = ACTIONS(2660),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(2662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2662),
  },
  [775] = {
    [sym_file_descriptor] = ACTIONS(1744),
    [sym__concat] = ACTIONS(1744),
    [sym_variable_name] = ACTIONS(1744),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_RPAREN] = ACTIONS(1744),
    [anon_sym_PIPE_AMP] = ACTIONS(1744),
    [anon_sym_AMP_AMP] = ACTIONS(1744),
    [anon_sym_PIPE_PIPE] = ACTIONS(1744),
    [anon_sym_LT] = ACTIONS(1746),
    [anon_sym_GT] = ACTIONS(1746),
    [anon_sym_GT_GT] = ACTIONS(1744),
    [anon_sym_AMP_GT] = ACTIONS(1746),
    [anon_sym_AMP_GT_GT] = ACTIONS(1744),
    [anon_sym_LT_AMP] = ACTIONS(1744),
    [anon_sym_GT_AMP] = ACTIONS(1744),
    [sym__special_characters] = ACTIONS(1744),
    [anon_sym_DQUOTE] = ACTIONS(1744),
    [anon_sym_DOLLAR] = ACTIONS(1746),
    [sym_raw_string] = ACTIONS(1744),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1744),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1744),
    [anon_sym_LT_LPAREN] = ACTIONS(1744),
    [anon_sym_GT_LPAREN] = ACTIONS(1744),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1744),
  },
  [776] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2664),
  },
  [777] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2666),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [778] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(2668),
    [sym_comment] = ACTIONS(53),
  },
  [779] = {
    [sym_concatenation] = STATE(1232),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1232),
    [anon_sym_RBRACE] = ACTIONS(2670),
    [anon_sym_EQ] = ACTIONS(2672),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2676),
    [anon_sym_COLON] = ACTIONS(2672),
    [anon_sym_COLON_QMARK] = ACTIONS(2672),
    [anon_sym_COLON_DASH] = ACTIONS(2672),
    [anon_sym_PERCENT] = ACTIONS(2672),
    [anon_sym_DASH] = ACTIONS(2672),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [780] = {
    [sym_concatenation] = STATE(1235),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1235),
    [anon_sym_RBRACE] = ACTIONS(2678),
    [anon_sym_EQ] = ACTIONS(2680),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2682),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2684),
    [anon_sym_COLON] = ACTIONS(2680),
    [anon_sym_COLON_QMARK] = ACTIONS(2680),
    [anon_sym_COLON_DASH] = ACTIONS(2680),
    [anon_sym_PERCENT] = ACTIONS(2680),
    [anon_sym_DASH] = ACTIONS(2680),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [781] = {
    [sym_concatenation] = STATE(1237),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1237),
    [anon_sym_RBRACE] = ACTIONS(2658),
    [anon_sym_EQ] = ACTIONS(2686),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2688),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2690),
    [anon_sym_COLON] = ACTIONS(2686),
    [anon_sym_COLON_QMARK] = ACTIONS(2686),
    [anon_sym_COLON_DASH] = ACTIONS(2686),
    [anon_sym_PERCENT] = ACTIONS(2686),
    [anon_sym_DASH] = ACTIONS(2686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [782] = {
    [sym_file_descriptor] = ACTIONS(1810),
    [sym__concat] = ACTIONS(1810),
    [sym_variable_name] = ACTIONS(1810),
    [anon_sym_PIPE] = ACTIONS(1812),
    [anon_sym_RPAREN] = ACTIONS(1810),
    [anon_sym_PIPE_AMP] = ACTIONS(1810),
    [anon_sym_AMP_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1810),
    [anon_sym_LT] = ACTIONS(1812),
    [anon_sym_GT] = ACTIONS(1812),
    [anon_sym_GT_GT] = ACTIONS(1810),
    [anon_sym_AMP_GT] = ACTIONS(1812),
    [anon_sym_AMP_GT_GT] = ACTIONS(1810),
    [anon_sym_LT_AMP] = ACTIONS(1810),
    [anon_sym_GT_AMP] = ACTIONS(1810),
    [sym__special_characters] = ACTIONS(1810),
    [anon_sym_DQUOTE] = ACTIONS(1810),
    [anon_sym_DOLLAR] = ACTIONS(1812),
    [sym_raw_string] = ACTIONS(1810),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1810),
    [anon_sym_LT_LPAREN] = ACTIONS(1810),
    [anon_sym_GT_LPAREN] = ACTIONS(1810),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1810),
  },
  [783] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2692),
  },
  [784] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2694),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [785] = {
    [sym_file_descriptor] = ACTIONS(1818),
    [sym__concat] = ACTIONS(1818),
    [sym_variable_name] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1820),
    [anon_sym_RPAREN] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1820),
    [anon_sym_GT] = ACTIONS(1820),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT] = ACTIONS(1820),
    [anon_sym_AMP_GT_GT] = ACTIONS(1818),
    [anon_sym_LT_AMP] = ACTIONS(1818),
    [anon_sym_GT_AMP] = ACTIONS(1818),
    [sym__special_characters] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(1818),
    [anon_sym_DOLLAR] = ACTIONS(1820),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(1818),
    [anon_sym_LT_LPAREN] = ACTIONS(1818),
    [anon_sym_GT_LPAREN] = ACTIONS(1818),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1818),
  },
  [786] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2696),
  },
  [787] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2658),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [788] = {
    [sym_file_descriptor] = ACTIONS(1952),
    [sym__concat] = ACTIONS(1952),
    [sym_variable_name] = ACTIONS(1952),
    [anon_sym_PIPE] = ACTIONS(1954),
    [anon_sym_RPAREN] = ACTIONS(1952),
    [anon_sym_PIPE_AMP] = ACTIONS(1952),
    [anon_sym_AMP_AMP] = ACTIONS(1952),
    [anon_sym_PIPE_PIPE] = ACTIONS(1952),
    [anon_sym_LT] = ACTIONS(1954),
    [anon_sym_GT] = ACTIONS(1954),
    [anon_sym_GT_GT] = ACTIONS(1952),
    [anon_sym_AMP_GT] = ACTIONS(1954),
    [anon_sym_AMP_GT_GT] = ACTIONS(1952),
    [anon_sym_LT_AMP] = ACTIONS(1952),
    [anon_sym_GT_AMP] = ACTIONS(1952),
    [sym__special_characters] = ACTIONS(1952),
    [anon_sym_DQUOTE] = ACTIONS(1952),
    [anon_sym_DOLLAR] = ACTIONS(1954),
    [sym_raw_string] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1952),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1952),
    [anon_sym_BQUOTE] = ACTIONS(1952),
    [anon_sym_LT_LPAREN] = ACTIONS(1952),
    [anon_sym_GT_LPAREN] = ACTIONS(1952),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1952),
  },
  [789] = {
    [sym_file_descriptor] = ACTIONS(2018),
    [sym__concat] = ACTIONS(2018),
    [sym_variable_name] = ACTIONS(2018),
    [anon_sym_PIPE] = ACTIONS(2020),
    [anon_sym_RPAREN] = ACTIONS(2018),
    [anon_sym_PIPE_AMP] = ACTIONS(2018),
    [anon_sym_AMP_AMP] = ACTIONS(2018),
    [anon_sym_PIPE_PIPE] = ACTIONS(2018),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(2020),
    [anon_sym_GT_GT] = ACTIONS(2018),
    [anon_sym_AMP_GT] = ACTIONS(2020),
    [anon_sym_AMP_GT_GT] = ACTIONS(2018),
    [anon_sym_LT_AMP] = ACTIONS(2018),
    [anon_sym_GT_AMP] = ACTIONS(2018),
    [sym__special_characters] = ACTIONS(2018),
    [anon_sym_DQUOTE] = ACTIONS(2018),
    [anon_sym_DOLLAR] = ACTIONS(2020),
    [sym_raw_string] = ACTIONS(2018),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2018),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2018),
    [anon_sym_BQUOTE] = ACTIONS(2018),
    [anon_sym_LT_LPAREN] = ACTIONS(2018),
    [anon_sym_GT_LPAREN] = ACTIONS(2018),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2018),
  },
  [790] = {
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [sym__string_content] = ACTIONS(2700),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2698),
    [anon_sym_BQUOTE] = ACTIONS(2698),
    [sym_comment] = ACTIONS(177),
  },
  [791] = {
    [sym_concatenation] = STATE(1244),
    [sym_string] = STATE(1243),
    [sym_simple_expansion] = STATE(1243),
    [sym_string_expansion] = STATE(1243),
    [sym_expansion] = STATE(1243),
    [sym_command_substitution] = STATE(1243),
    [sym_process_substitution] = STATE(1243),
    [anon_sym_RBRACE] = ACTIONS(2702),
    [sym__special_characters] = ACTIONS(2704),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(2706),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2706),
  },
  [792] = {
    [sym__concat] = ACTIONS(1744),
    [anon_sym_DQUOTE] = ACTIONS(1746),
    [anon_sym_DOLLAR] = ACTIONS(1746),
    [sym__string_content] = ACTIONS(1744),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1746),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [sym_comment] = ACTIONS(177),
  },
  [793] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2708),
  },
  [794] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2710),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [795] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(2712),
    [sym_comment] = ACTIONS(53),
  },
  [796] = {
    [sym_concatenation] = STATE(1250),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1250),
    [anon_sym_RBRACE] = ACTIONS(2714),
    [anon_sym_EQ] = ACTIONS(2716),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2718),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2720),
    [anon_sym_COLON] = ACTIONS(2716),
    [anon_sym_COLON_QMARK] = ACTIONS(2716),
    [anon_sym_COLON_DASH] = ACTIONS(2716),
    [anon_sym_PERCENT] = ACTIONS(2716),
    [anon_sym_DASH] = ACTIONS(2716),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [797] = {
    [sym_concatenation] = STATE(1253),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1253),
    [anon_sym_RBRACE] = ACTIONS(2722),
    [anon_sym_EQ] = ACTIONS(2724),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2728),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_COLON_QMARK] = ACTIONS(2724),
    [anon_sym_COLON_DASH] = ACTIONS(2724),
    [anon_sym_PERCENT] = ACTIONS(2724),
    [anon_sym_DASH] = ACTIONS(2724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [798] = {
    [sym_concatenation] = STATE(1255),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1255),
    [anon_sym_RBRACE] = ACTIONS(2702),
    [anon_sym_EQ] = ACTIONS(2730),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2734),
    [anon_sym_COLON] = ACTIONS(2730),
    [anon_sym_COLON_QMARK] = ACTIONS(2730),
    [anon_sym_COLON_DASH] = ACTIONS(2730),
    [anon_sym_PERCENT] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [799] = {
    [sym__concat] = ACTIONS(1810),
    [anon_sym_DQUOTE] = ACTIONS(1812),
    [anon_sym_DOLLAR] = ACTIONS(1812),
    [sym__string_content] = ACTIONS(1810),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [sym_comment] = ACTIONS(177),
  },
  [800] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2736),
  },
  [801] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2738),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [802] = {
    [sym__concat] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(1820),
    [anon_sym_DOLLAR] = ACTIONS(1820),
    [sym__string_content] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1820),
    [anon_sym_BQUOTE] = ACTIONS(1820),
    [sym_comment] = ACTIONS(177),
  },
  [803] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2740),
  },
  [804] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2702),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [805] = {
    [sym__concat] = ACTIONS(1952),
    [anon_sym_DQUOTE] = ACTIONS(1954),
    [anon_sym_DOLLAR] = ACTIONS(1954),
    [sym__string_content] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1954),
    [anon_sym_BQUOTE] = ACTIONS(1954),
    [sym_comment] = ACTIONS(177),
  },
  [806] = {
    [aux_sym_concatenation_repeat1] = STATE(555),
    [sym__concat] = ACTIONS(2742),
    [anon_sym_RBRACK] = ACTIONS(2744),
    [sym_comment] = ACTIONS(53),
  },
  [807] = {
    [aux_sym_concatenation_repeat1] = STATE(555),
    [sym__concat] = ACTIONS(2746),
    [anon_sym_RBRACK] = ACTIONS(2748),
    [sym_comment] = ACTIONS(53),
  },
  [808] = {
    [sym__concat] = ACTIONS(2750),
    [anon_sym_RBRACK] = ACTIONS(2748),
    [sym_comment] = ACTIONS(53),
  },
  [809] = {
    [sym__simple_heredoc_body] = ACTIONS(2752),
    [sym__heredoc_body_beginning] = ACTIONS(2752),
    [sym_file_descriptor] = ACTIONS(2752),
    [sym__concat] = ACTIONS(2752),
    [anon_sym_PIPE] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(2754),
    [anon_sym_SEMI_SEMI] = ACTIONS(2754),
    [anon_sym_PIPE_AMP] = ACTIONS(2754),
    [anon_sym_AMP_AMP] = ACTIONS(2754),
    [anon_sym_PIPE_PIPE] = ACTIONS(2754),
    [anon_sym_EQ_TILDE] = ACTIONS(2754),
    [anon_sym_EQ_EQ] = ACTIONS(2754),
    [anon_sym_LT] = ACTIONS(2754),
    [anon_sym_GT] = ACTIONS(2754),
    [anon_sym_GT_GT] = ACTIONS(2754),
    [anon_sym_AMP_GT] = ACTIONS(2754),
    [anon_sym_AMP_GT_GT] = ACTIONS(2754),
    [anon_sym_LT_AMP] = ACTIONS(2754),
    [anon_sym_GT_AMP] = ACTIONS(2754),
    [anon_sym_LT_LT] = ACTIONS(2754),
    [anon_sym_LT_LT_DASH] = ACTIONS(2754),
    [anon_sym_LT_LT_LT] = ACTIONS(2754),
    [sym__special_characters] = ACTIONS(2754),
    [anon_sym_DQUOTE] = ACTIONS(2754),
    [anon_sym_DOLLAR] = ACTIONS(2754),
    [sym_raw_string] = ACTIONS(2754),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2754),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2754),
    [anon_sym_BQUOTE] = ACTIONS(2754),
    [anon_sym_LT_LPAREN] = ACTIONS(2754),
    [anon_sym_GT_LPAREN] = ACTIONS(2754),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2754),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_LF] = ACTIONS(2752),
    [anon_sym_AMP] = ACTIONS(2754),
  },
  [810] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(2758),
    [sym_comment] = ACTIONS(53),
  },
  [811] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(1268),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [812] = {
    [sym_string] = STATE(1270),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(2762),
    [sym_raw_string] = ACTIONS(2764),
    [anon_sym_POUND] = ACTIONS(2762),
    [anon_sym_DASH] = ACTIONS(2762),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2766),
    [anon_sym_STAR] = ACTIONS(2762),
    [anon_sym_AT] = ACTIONS(2762),
    [anon_sym_QMARK] = ACTIONS(2762),
    [anon_sym_0] = ACTIONS(2768),
    [anon_sym__] = ACTIONS(2768),
  },
  [813] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [sym_comment] = ACTIONS(53),
  },
  [814] = {
    [sym_subscript] = STATE(1277),
    [sym_variable_name] = ACTIONS(2772),
    [anon_sym_DOLLAR] = ACTIONS(2774),
    [anon_sym_POUND] = ACTIONS(2776),
    [anon_sym_DASH] = ACTIONS(2774),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2778),
    [anon_sym_STAR] = ACTIONS(2774),
    [anon_sym_AT] = ACTIONS(2774),
    [anon_sym_QMARK] = ACTIONS(2774),
    [anon_sym_0] = ACTIONS(2780),
    [anon_sym__] = ACTIONS(2780),
  },
  [815] = {
    [sym_for_statement] = STATE(1278),
    [sym_while_statement] = STATE(1278),
    [sym_if_statement] = STATE(1278),
    [sym_case_statement] = STATE(1278),
    [sym_function_definition] = STATE(1278),
    [sym_subshell] = STATE(1278),
    [sym_pipeline] = STATE(1278),
    [sym_list] = STATE(1278),
    [sym_negated_command] = STATE(1278),
    [sym_test_command] = STATE(1278),
    [sym_declaration_command] = STATE(1278),
    [sym_unset_command] = STATE(1278),
    [sym_command] = STATE(1278),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(1279),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [816] = {
    [sym_for_statement] = STATE(1280),
    [sym_while_statement] = STATE(1280),
    [sym_if_statement] = STATE(1280),
    [sym_case_statement] = STATE(1280),
    [sym_function_definition] = STATE(1280),
    [sym_subshell] = STATE(1280),
    [sym_pipeline] = STATE(1280),
    [sym_list] = STATE(1280),
    [sym_negated_command] = STATE(1280),
    [sym_test_command] = STATE(1280),
    [sym_declaration_command] = STATE(1280),
    [sym_unset_command] = STATE(1280),
    [sym_command] = STATE(1280),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(1281),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [817] = {
    [sym_for_statement] = STATE(1282),
    [sym_while_statement] = STATE(1282),
    [sym_if_statement] = STATE(1282),
    [sym_case_statement] = STATE(1282),
    [sym_function_definition] = STATE(1282),
    [sym_subshell] = STATE(1282),
    [sym_pipeline] = STATE(1282),
    [sym_list] = STATE(1282),
    [sym_negated_command] = STATE(1282),
    [sym_test_command] = STATE(1282),
    [sym_declaration_command] = STATE(1282),
    [sym_unset_command] = STATE(1282),
    [sym_command] = STATE(1282),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(1283),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [818] = {
    [anon_sym_RBRACE] = ACTIONS(2770),
    [sym_comment] = ACTIONS(53),
  },
  [819] = {
    [sym_string] = STATE(1284),
    [sym_simple_expansion] = STATE(1284),
    [sym_string_expansion] = STATE(1284),
    [sym_expansion] = STATE(1284),
    [sym_command_substitution] = STATE(1284),
    [sym_process_substitution] = STATE(1284),
    [sym__special_characters] = ACTIONS(2782),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(2782),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2782),
  },
  [820] = {
    [aux_sym_concatenation_repeat1] = STATE(1285),
    [sym__concat] = ACTIONS(1748),
    [anon_sym_RBRACE] = ACTIONS(693),
    [anon_sym_EQ] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(693),
    [anon_sym_POUND] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(693),
    [anon_sym_COLON] = ACTIONS(695),
    [anon_sym_COLON_QMARK] = ACTIONS(695),
    [anon_sym_COLON_DASH] = ACTIONS(695),
    [anon_sym_PERCENT] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(695),
  },
  [821] = {
    [sym__concat] = ACTIONS(697),
    [anon_sym_RBRACE] = ACTIONS(697),
    [anon_sym_EQ] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(697),
    [anon_sym_POUND] = ACTIONS(697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(697),
    [anon_sym_COLON] = ACTIONS(699),
    [anon_sym_COLON_QMARK] = ACTIONS(699),
    [anon_sym_COLON_DASH] = ACTIONS(699),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [anon_sym_LT_LPAREN] = ACTIONS(697),
    [anon_sym_GT_LPAREN] = ACTIONS(697),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(699),
  },
  [822] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(2784),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [823] = {
    [sym__concat] = ACTIONS(727),
    [anon_sym_RBRACE] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(729),
    [sym__special_characters] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(727),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(727),
    [anon_sym_POUND] = ACTIONS(727),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(727),
    [anon_sym_COLON] = ACTIONS(729),
    [anon_sym_COLON_QMARK] = ACTIONS(729),
    [anon_sym_COLON_DASH] = ACTIONS(729),
    [anon_sym_PERCENT] = ACTIONS(729),
    [anon_sym_DASH] = ACTIONS(729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(727),
    [anon_sym_BQUOTE] = ACTIONS(727),
    [anon_sym_LT_LPAREN] = ACTIONS(727),
    [anon_sym_GT_LPAREN] = ACTIONS(727),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(729),
  },
  [824] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_RBRACE] = ACTIONS(731),
    [anon_sym_EQ] = ACTIONS(733),
    [sym__special_characters] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_POUND] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_COLON] = ACTIONS(733),
    [anon_sym_COLON_QMARK] = ACTIONS(733),
    [anon_sym_COLON_DASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(733),
  },
  [825] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_RBRACE] = ACTIONS(735),
    [anon_sym_EQ] = ACTIONS(737),
    [sym__special_characters] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_POUND] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_COLON] = ACTIONS(737),
    [anon_sym_COLON_QMARK] = ACTIONS(737),
    [anon_sym_COLON_DASH] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_DASH] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(737),
  },
  [826] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(2786),
    [sym_comment] = ACTIONS(53),
  },
  [827] = {
    [sym_concatenation] = STATE(1290),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1290),
    [anon_sym_RBRACE] = ACTIONS(2788),
    [anon_sym_EQ] = ACTIONS(2790),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2792),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2794),
    [anon_sym_COLON] = ACTIONS(2790),
    [anon_sym_COLON_QMARK] = ACTIONS(2790),
    [anon_sym_COLON_DASH] = ACTIONS(2790),
    [anon_sym_PERCENT] = ACTIONS(2790),
    [anon_sym_DASH] = ACTIONS(2790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [828] = {
    [sym_subscript] = STATE(1294),
    [sym_variable_name] = ACTIONS(2796),
    [anon_sym_DOLLAR] = ACTIONS(2798),
    [anon_sym_DASH] = ACTIONS(2798),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2800),
    [anon_sym_STAR] = ACTIONS(2798),
    [anon_sym_AT] = ACTIONS(2798),
    [anon_sym_QMARK] = ACTIONS(2798),
    [anon_sym_0] = ACTIONS(2802),
    [anon_sym__] = ACTIONS(2802),
  },
  [829] = {
    [sym_concatenation] = STATE(1297),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1297),
    [anon_sym_RBRACE] = ACTIONS(2804),
    [anon_sym_EQ] = ACTIONS(2806),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2808),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2810),
    [anon_sym_COLON] = ACTIONS(2806),
    [anon_sym_COLON_QMARK] = ACTIONS(2806),
    [anon_sym_COLON_DASH] = ACTIONS(2806),
    [anon_sym_PERCENT] = ACTIONS(2806),
    [anon_sym_DASH] = ACTIONS(2806),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [830] = {
    [sym_concatenation] = STATE(1300),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1300),
    [anon_sym_RBRACE] = ACTIONS(2812),
    [anon_sym_EQ] = ACTIONS(2814),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2816),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2818),
    [anon_sym_COLON] = ACTIONS(2814),
    [anon_sym_COLON_QMARK] = ACTIONS(2814),
    [anon_sym_COLON_DASH] = ACTIONS(2814),
    [anon_sym_PERCENT] = ACTIONS(2814),
    [anon_sym_DASH] = ACTIONS(2814),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [831] = {
    [sym_concatenation] = STATE(1302),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1302),
    [anon_sym_RBRACE] = ACTIONS(2820),
    [anon_sym_EQ] = ACTIONS(2822),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(2822),
    [anon_sym_COLON_QMARK] = ACTIONS(2822),
    [anon_sym_COLON_DASH] = ACTIONS(2822),
    [anon_sym_PERCENT] = ACTIONS(2822),
    [anon_sym_DASH] = ACTIONS(2822),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [832] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2826),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [833] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2826),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [834] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(2826),
    [sym_comment] = ACTIONS(53),
  },
  [835] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(2826),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [836] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2828),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [837] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2828),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [838] = {
    [sym__simple_heredoc_body] = ACTIONS(2830),
    [sym__heredoc_body_beginning] = ACTIONS(2830),
    [sym_file_descriptor] = ACTIONS(2830),
    [sym__concat] = ACTIONS(2830),
    [anon_sym_PIPE] = ACTIONS(2832),
    [anon_sym_RPAREN] = ACTIONS(2832),
    [anon_sym_SEMI_SEMI] = ACTIONS(2832),
    [anon_sym_PIPE_AMP] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_PIPE_PIPE] = ACTIONS(2832),
    [anon_sym_EQ_TILDE] = ACTIONS(2832),
    [anon_sym_EQ_EQ] = ACTIONS(2832),
    [anon_sym_LT] = ACTIONS(2832),
    [anon_sym_GT] = ACTIONS(2832),
    [anon_sym_GT_GT] = ACTIONS(2832),
    [anon_sym_AMP_GT] = ACTIONS(2832),
    [anon_sym_AMP_GT_GT] = ACTIONS(2832),
    [anon_sym_LT_AMP] = ACTIONS(2832),
    [anon_sym_GT_AMP] = ACTIONS(2832),
    [anon_sym_LT_LT] = ACTIONS(2832),
    [anon_sym_LT_LT_DASH] = ACTIONS(2832),
    [anon_sym_LT_LT_LT] = ACTIONS(2832),
    [sym__special_characters] = ACTIONS(2832),
    [anon_sym_DQUOTE] = ACTIONS(2832),
    [anon_sym_DOLLAR] = ACTIONS(2832),
    [sym_raw_string] = ACTIONS(2832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2832),
    [anon_sym_BQUOTE] = ACTIONS(2832),
    [anon_sym_LT_LPAREN] = ACTIONS(2832),
    [anon_sym_GT_LPAREN] = ACTIONS(2832),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2832),
    [anon_sym_SEMI] = ACTIONS(2832),
    [anon_sym_LF] = ACTIONS(2830),
    [anon_sym_AMP] = ACTIONS(2832),
  },
  [839] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2834),
    [anon_sym_EQ] = ACTIONS(2836),
    [sym__special_characters] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2842),
    [anon_sym_DOLLAR] = ACTIONS(2845),
    [sym_raw_string] = ACTIONS(2848),
    [anon_sym_POUND] = ACTIONS(2851),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2854),
    [anon_sym_COLON] = ACTIONS(2836),
    [anon_sym_COLON_QMARK] = ACTIONS(2836),
    [anon_sym_COLON_DASH] = ACTIONS(2836),
    [anon_sym_PERCENT] = ACTIONS(2836),
    [anon_sym_DASH] = ACTIONS(2836),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2857),
    [anon_sym_BQUOTE] = ACTIONS(2860),
    [anon_sym_LT_LPAREN] = ACTIONS(2863),
    [anon_sym_GT_LPAREN] = ACTIONS(2863),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2866),
  },
  [840] = {
    [sym_concatenation] = STATE(1307),
    [sym_string] = STATE(1306),
    [sym_simple_expansion] = STATE(1306),
    [sym_string_expansion] = STATE(1306),
    [sym_expansion] = STATE(1306),
    [sym_command_substitution] = STATE(1306),
    [sym_process_substitution] = STATE(1306),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [sym__special_characters] = ACTIONS(2869),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(2871),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2871),
  },
  [841] = {
    [sym__simple_heredoc_body] = ACTIONS(2873),
    [sym__heredoc_body_beginning] = ACTIONS(2873),
    [sym_file_descriptor] = ACTIONS(2873),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [anon_sym_PIPE_AMP] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [anon_sym_EQ_TILDE] = ACTIONS(2875),
    [anon_sym_EQ_EQ] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT_GT] = ACTIONS(2875),
    [anon_sym_LT_AMP] = ACTIONS(2875),
    [anon_sym_GT_AMP] = ACTIONS(2875),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_LT_LT_DASH] = ACTIONS(2875),
    [anon_sym_LT_LT_LT] = ACTIONS(2875),
    [sym__special_characters] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2875),
    [anon_sym_BQUOTE] = ACTIONS(2875),
    [anon_sym_LT_LPAREN] = ACTIONS(2875),
    [anon_sym_GT_LPAREN] = ACTIONS(2875),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [842] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2877),
  },
  [843] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2879),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [844] = {
    [sym__simple_heredoc_body] = ACTIONS(2881),
    [sym__heredoc_body_beginning] = ACTIONS(2881),
    [sym_file_descriptor] = ACTIONS(2881),
    [sym__concat] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_RPAREN] = ACTIONS(2883),
    [anon_sym_SEMI_SEMI] = ACTIONS(2883),
    [anon_sym_PIPE_AMP] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_EQ_TILDE] = ACTIONS(2883),
    [anon_sym_EQ_EQ] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_GT_GT] = ACTIONS(2883),
    [anon_sym_AMP_GT] = ACTIONS(2883),
    [anon_sym_AMP_GT_GT] = ACTIONS(2883),
    [anon_sym_LT_AMP] = ACTIONS(2883),
    [anon_sym_GT_AMP] = ACTIONS(2883),
    [anon_sym_LT_LT] = ACTIONS(2883),
    [anon_sym_LT_LT_DASH] = ACTIONS(2883),
    [anon_sym_LT_LT_LT] = ACTIONS(2883),
    [sym__special_characters] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [sym_raw_string] = ACTIONS(2883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2883),
    [anon_sym_BQUOTE] = ACTIONS(2883),
    [anon_sym_LT_LPAREN] = ACTIONS(2883),
    [anon_sym_GT_LPAREN] = ACTIONS(2883),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_LF] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
  },
  [845] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2885),
  },
  [846] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2887),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [847] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(2889),
  },
  [848] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [849] = {
    [sym_concatenation] = STATE(1314),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1314),
    [anon_sym_RBRACE] = ACTIONS(2891),
    [anon_sym_EQ] = ACTIONS(2893),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2895),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(2893),
    [anon_sym_COLON_QMARK] = ACTIONS(2893),
    [anon_sym_COLON_DASH] = ACTIONS(2893),
    [anon_sym_PERCENT] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [850] = {
    [sym__simple_heredoc_body] = ACTIONS(2897),
    [sym__heredoc_body_beginning] = ACTIONS(2897),
    [sym_file_descriptor] = ACTIONS(2897),
    [sym__concat] = ACTIONS(2897),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_RPAREN] = ACTIONS(2899),
    [anon_sym_SEMI_SEMI] = ACTIONS(2899),
    [anon_sym_PIPE_AMP] = ACTIONS(2899),
    [anon_sym_AMP_AMP] = ACTIONS(2899),
    [anon_sym_PIPE_PIPE] = ACTIONS(2899),
    [anon_sym_EQ_TILDE] = ACTIONS(2899),
    [anon_sym_EQ_EQ] = ACTIONS(2899),
    [anon_sym_LT] = ACTIONS(2899),
    [anon_sym_GT] = ACTIONS(2899),
    [anon_sym_GT_GT] = ACTIONS(2899),
    [anon_sym_AMP_GT] = ACTIONS(2899),
    [anon_sym_AMP_GT_GT] = ACTIONS(2899),
    [anon_sym_LT_AMP] = ACTIONS(2899),
    [anon_sym_GT_AMP] = ACTIONS(2899),
    [anon_sym_LT_LT] = ACTIONS(2899),
    [anon_sym_LT_LT_DASH] = ACTIONS(2899),
    [anon_sym_LT_LT_LT] = ACTIONS(2899),
    [sym__special_characters] = ACTIONS(2899),
    [anon_sym_DQUOTE] = ACTIONS(2899),
    [anon_sym_DOLLAR] = ACTIONS(2899),
    [sym_raw_string] = ACTIONS(2899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2899),
    [anon_sym_BQUOTE] = ACTIONS(2899),
    [anon_sym_LT_LPAREN] = ACTIONS(2899),
    [anon_sym_GT_LPAREN] = ACTIONS(2899),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2899),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LF] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2899),
  },
  [851] = {
    [sym_concatenation] = STATE(1316),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1316),
    [anon_sym_RBRACE] = ACTIONS(2901),
    [anon_sym_EQ] = ACTIONS(2903),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(2903),
    [anon_sym_COLON_QMARK] = ACTIONS(2903),
    [anon_sym_COLON_DASH] = ACTIONS(2903),
    [anon_sym_PERCENT] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [852] = {
    [aux_sym_concatenation_repeat1] = STATE(1317),
    [sym_file_descriptor] = ACTIONS(1129),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(1129),
    [anon_sym_PIPE_AMP] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_AMP_GT] = ACTIONS(1133),
    [anon_sym_AMP_GT_GT] = ACTIONS(1129),
    [anon_sym_LT_AMP] = ACTIONS(1129),
    [anon_sym_GT_AMP] = ACTIONS(1129),
    [sym__special_characters] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1129),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [sym_raw_string] = ACTIONS(1129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1129),
    [anon_sym_LT_LPAREN] = ACTIONS(1129),
    [anon_sym_GT_LPAREN] = ACTIONS(1129),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1129),
  },
  [853] = {
    [aux_sym_concatenation_repeat1] = STATE(1317),
    [sym_file_descriptor] = ACTIONS(1107),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_RPAREN] = ACTIONS(1107),
    [anon_sym_PIPE_AMP] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1109),
    [anon_sym_GT] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_AMP] = ACTIONS(1107),
    [anon_sym_GT_AMP] = ACTIONS(1107),
    [sym__special_characters] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LT_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_LPAREN] = ACTIONS(1107),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1107),
  },
  [854] = {
    [sym_concatenation] = STATE(1318),
    [sym_string] = STATE(590),
    [sym_simple_expansion] = STATE(590),
    [sym_string_expansion] = STATE(590),
    [sym_expansion] = STATE(590),
    [sym_command_substitution] = STATE(590),
    [sym_process_substitution] = STATE(590),
    [aux_sym_for_statement_repeat1] = STATE(1318),
    [sym__special_characters] = ACTIONS(1155),
    [anon_sym_DQUOTE] = ACTIONS(1157),
    [anon_sym_DOLLAR] = ACTIONS(1159),
    [sym_raw_string] = ACTIONS(1161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1163),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1165),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [anon_sym_LT_LPAREN] = ACTIONS(1169),
    [anon_sym_GT_LPAREN] = ACTIONS(1169),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1161),
  },
  [855] = {
    [sym_do_group] = STATE(1320),
    [anon_sym_do] = ACTIONS(2907),
    [sym_comment] = ACTIONS(53),
  },
  [856] = {
    [sym__terminated_statement] = STATE(1322),
    [sym_for_statement] = STATE(599),
    [sym_while_statement] = STATE(599),
    [sym_if_statement] = STATE(599),
    [sym_case_statement] = STATE(599),
    [sym_function_definition] = STATE(599),
    [sym_subshell] = STATE(599),
    [sym_pipeline] = STATE(599),
    [sym_list] = STATE(599),
    [sym_negated_command] = STATE(599),
    [sym_test_command] = STATE(599),
    [sym_declaration_command] = STATE(599),
    [sym_unset_command] = STATE(599),
    [sym_command] = STATE(599),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(600),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1322),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_done] = ACTIONS(2909),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [857] = {
    [sym_file_redirect] = STATE(1324),
    [sym_heredoc_redirect] = STATE(1324),
    [sym_heredoc_body] = STATE(1323),
    [sym_herestring_redirect] = STATE(1324),
    [aux_sym_while_statement_repeat1] = STATE(1324),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(1175),
    [anon_sym_RPAREN] = ACTIONS(1177),
    [anon_sym_PIPE_AMP] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1177),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(887),
    [anon_sym_LT_AMP] = ACTIONS(887),
    [anon_sym_GT_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(893),
    [sym_comment] = ACTIONS(53),
  },
  [858] = {
    [sym__terminated_statement] = STATE(1327),
    [sym_for_statement] = STATE(607),
    [sym_while_statement] = STATE(607),
    [sym_if_statement] = STATE(607),
    [sym_elif_clause] = STATE(608),
    [sym_else_clause] = STATE(1326),
    [sym_case_statement] = STATE(607),
    [sym_function_definition] = STATE(607),
    [sym_subshell] = STATE(607),
    [sym_pipeline] = STATE(607),
    [sym_list] = STATE(607),
    [sym_negated_command] = STATE(607),
    [sym_test_command] = STATE(607),
    [sym_declaration_command] = STATE(607),
    [sym_unset_command] = STATE(607),
    [sym_command] = STATE(607),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(610),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1327),
    [aux_sym_if_statement_repeat1] = STATE(1328),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(2911),
    [anon_sym_elif] = ACTIONS(1181),
    [anon_sym_else] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [859] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2913),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym_LF] = ACTIONS(2915),
    [anon_sym_AMP] = ACTIONS(2913),
  },
  [860] = {
    [anon_sym_in] = ACTIONS(2917),
    [sym_comment] = ACTIONS(53),
  },
  [861] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2919),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2919),
    [anon_sym_LF] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2919),
  },
  [862] = {
    [anon_sym_in] = ACTIONS(2923),
    [sym_comment] = ACTIONS(53),
  },
  [863] = {
    [anon_sym_RPAREN] = ACTIONS(2925),
    [sym_comment] = ACTIONS(53),
  },
  [864] = {
    [sym__terminated_statement] = STATE(1335),
    [sym_for_statement] = STATE(638),
    [sym_while_statement] = STATE(638),
    [sym_if_statement] = STATE(638),
    [sym_case_statement] = STATE(638),
    [sym_function_definition] = STATE(638),
    [sym_subshell] = STATE(638),
    [sym_pipeline] = STATE(638),
    [sym_list] = STATE(638),
    [sym_negated_command] = STATE(638),
    [sym_test_command] = STATE(638),
    [sym_declaration_command] = STATE(638),
    [sym_unset_command] = STATE(638),
    [sym_command] = STATE(638),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(639),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1335),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RBRACE] = ACTIONS(2927),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [865] = {
    [sym_file_redirect] = STATE(1338),
    [sym_file_descriptor] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(1245),
    [anon_sym_RPAREN] = ACTIONS(1249),
    [anon_sym_PIPE_AMP] = ACTIONS(1249),
    [anon_sym_AMP_AMP] = ACTIONS(1249),
    [anon_sym_PIPE_PIPE] = ACTIONS(1249),
    [anon_sym_LT] = ACTIONS(2931),
    [anon_sym_GT] = ACTIONS(2931),
    [anon_sym_GT_GT] = ACTIONS(2933),
    [anon_sym_AMP_GT] = ACTIONS(2931),
    [anon_sym_AMP_GT_GT] = ACTIONS(2933),
    [anon_sym_LT_AMP] = ACTIONS(2933),
    [anon_sym_GT_AMP] = ACTIONS(2933),
    [sym_comment] = ACTIONS(53),
  },
  [866] = {
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_RPAREN] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_BQUOTE] = ACTIONS(1265),
    [sym_comment] = ACTIONS(53),
  },
  [867] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_RPAREN] = ACTIONS(2935),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(953),
    [anon_sym_DQUOTE] = ACTIONS(951),
    [anon_sym_DOLLAR] = ACTIONS(953),
    [sym_raw_string] = ACTIONS(951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(951),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(951),
    [anon_sym_BQUOTE] = ACTIONS(951),
    [anon_sym_LT_LPAREN] = ACTIONS(951),
    [anon_sym_GT_LPAREN] = ACTIONS(951),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(953),
  },
  [868] = {
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(2937),
    [anon_sym_SEMI_SEMI] = ACTIONS(2939),
    [anon_sym_PIPE_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2939),
    [anon_sym_LF] = ACTIONS(2941),
    [anon_sym_AMP] = ACTIONS(2939),
  },
  [869] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(2937),
    [anon_sym_SEMI_SEMI] = ACTIONS(2939),
    [anon_sym_PIPE_AMP] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(2939),
    [anon_sym_LF] = ACTIONS(2941),
    [anon_sym_AMP] = ACTIONS(2939),
  },
  [870] = {
    [sym_file_redirect] = STATE(1345),
    [sym_heredoc_redirect] = STATE(1345),
    [sym_herestring_redirect] = STATE(1345),
    [aux_sym_while_statement_repeat1] = STATE(1345),
    [sym_file_descriptor] = ACTIONS(2943),
    [anon_sym_PIPE] = ACTIONS(1353),
    [anon_sym_RPAREN] = ACTIONS(1361),
    [anon_sym_PIPE_AMP] = ACTIONS(1361),
    [anon_sym_AMP_AMP] = ACTIONS(1361),
    [anon_sym_PIPE_PIPE] = ACTIONS(1361),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_GT] = ACTIONS(2945),
    [anon_sym_GT_GT] = ACTIONS(2947),
    [anon_sym_AMP_GT] = ACTIONS(2945),
    [anon_sym_AMP_GT_GT] = ACTIONS(2947),
    [anon_sym_LT_AMP] = ACTIONS(2947),
    [anon_sym_GT_AMP] = ACTIONS(2947),
    [anon_sym_LT_LT] = ACTIONS(2949),
    [anon_sym_LT_LT_DASH] = ACTIONS(2951),
    [anon_sym_LT_LT_LT] = ACTIONS(2953),
    [sym_comment] = ACTIONS(53),
  },
  [871] = {
    [sym_concatenation] = STATE(1346),
    [sym_string] = STATE(1349),
    [sym_array] = STATE(1346),
    [sym_simple_expansion] = STATE(1349),
    [sym_string_expansion] = STATE(1349),
    [sym_expansion] = STATE(1349),
    [sym_command_substitution] = STATE(1349),
    [sym_process_substitution] = STATE(1349),
    [sym__empty_value] = ACTIONS(2955),
    [anon_sym_LPAREN] = ACTIONS(2957),
    [sym__special_characters] = ACTIONS(2959),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(2961),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(815),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LT_LPAREN] = ACTIONS(819),
    [anon_sym_GT_LPAREN] = ACTIONS(819),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2961),
  },
  [872] = {
    [sym_string] = STATE(1350),
    [sym_simple_expansion] = STATE(1350),
    [sym_string_expansion] = STATE(1350),
    [sym_expansion] = STATE(1350),
    [sym_command_substitution] = STATE(1350),
    [sym_process_substitution] = STATE(1350),
    [sym__special_characters] = ACTIONS(2963),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(2963),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(815),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LT_LPAREN] = ACTIONS(819),
    [anon_sym_GT_LPAREN] = ACTIONS(819),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2963),
  },
  [873] = {
    [aux_sym_concatenation_repeat1] = STATE(1351),
    [sym__concat] = ACTIONS(1864),
    [sym_variable_name] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(693),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [sym__special_characters] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(695),
    [sym_word] = ACTIONS(695),
  },
  [874] = {
    [sym__concat] = ACTIONS(697),
    [sym_variable_name] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(697),
    [anon_sym_PIPE_AMP] = ACTIONS(697),
    [anon_sym_AMP_AMP] = ACTIONS(697),
    [anon_sym_PIPE_PIPE] = ACTIONS(697),
    [sym__special_characters] = ACTIONS(697),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [anon_sym_LT_LPAREN] = ACTIONS(697),
    [anon_sym_GT_LPAREN] = ACTIONS(697),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(699),
    [sym_word] = ACTIONS(699),
  },
  [875] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(2965),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [876] = {
    [sym__concat] = ACTIONS(727),
    [sym_variable_name] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(727),
    [anon_sym_PIPE_AMP] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(727),
    [anon_sym_PIPE_PIPE] = ACTIONS(727),
    [sym__special_characters] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(727),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(727),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(727),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(727),
    [anon_sym_BQUOTE] = ACTIONS(727),
    [anon_sym_LT_LPAREN] = ACTIONS(727),
    [anon_sym_GT_LPAREN] = ACTIONS(727),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(729),
    [sym_word] = ACTIONS(729),
  },
  [877] = {
    [sym__concat] = ACTIONS(731),
    [sym_variable_name] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [sym__special_characters] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(733),
    [sym_word] = ACTIONS(733),
  },
  [878] = {
    [sym__concat] = ACTIONS(735),
    [sym_variable_name] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_PIPE_AMP] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__special_characters] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(737),
    [sym_word] = ACTIONS(737),
  },
  [879] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(2967),
    [sym_comment] = ACTIONS(53),
  },
  [880] = {
    [sym_concatenation] = STATE(1356),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1356),
    [anon_sym_RBRACE] = ACTIONS(2969),
    [anon_sym_EQ] = ACTIONS(2971),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2973),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2975),
    [anon_sym_COLON] = ACTIONS(2971),
    [anon_sym_COLON_QMARK] = ACTIONS(2971),
    [anon_sym_COLON_DASH] = ACTIONS(2971),
    [anon_sym_PERCENT] = ACTIONS(2971),
    [anon_sym_DASH] = ACTIONS(2971),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [881] = {
    [sym_subscript] = STATE(1360),
    [sym_variable_name] = ACTIONS(2977),
    [anon_sym_DOLLAR] = ACTIONS(2979),
    [anon_sym_DASH] = ACTIONS(2979),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2981),
    [anon_sym_STAR] = ACTIONS(2979),
    [anon_sym_AT] = ACTIONS(2979),
    [anon_sym_QMARK] = ACTIONS(2979),
    [anon_sym_0] = ACTIONS(2983),
    [anon_sym__] = ACTIONS(2983),
  },
  [882] = {
    [sym_concatenation] = STATE(1363),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1363),
    [anon_sym_RBRACE] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2987),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2989),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2991),
    [anon_sym_COLON] = ACTIONS(2987),
    [anon_sym_COLON_QMARK] = ACTIONS(2987),
    [anon_sym_COLON_DASH] = ACTIONS(2987),
    [anon_sym_PERCENT] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(2987),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [883] = {
    [sym_concatenation] = STATE(1366),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1366),
    [anon_sym_RBRACE] = ACTIONS(2993),
    [anon_sym_EQ] = ACTIONS(2995),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(2997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(2999),
    [anon_sym_COLON] = ACTIONS(2995),
    [anon_sym_COLON_QMARK] = ACTIONS(2995),
    [anon_sym_COLON_DASH] = ACTIONS(2995),
    [anon_sym_PERCENT] = ACTIONS(2995),
    [anon_sym_DASH] = ACTIONS(2995),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [884] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3001),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [885] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3001),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [886] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(3001),
    [sym_comment] = ACTIONS(53),
  },
  [887] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(3001),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [888] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3003),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [889] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3003),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [890] = {
    [sym_variable_assignment] = STATE(890),
    [sym_subscript] = STATE(454),
    [sym_concatenation] = STATE(890),
    [sym_string] = STATE(448),
    [sym_simple_expansion] = STATE(448),
    [sym_string_expansion] = STATE(448),
    [sym_expansion] = STATE(448),
    [sym_command_substitution] = STATE(448),
    [sym_process_substitution] = STATE(448),
    [aux_sym_declaration_command_repeat1] = STATE(890),
    [sym_variable_name] = ACTIONS(3005),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_RPAREN] = ACTIONS(1529),
    [anon_sym_PIPE_AMP] = ACTIONS(1529),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [sym__special_characters] = ACTIONS(3008),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [anon_sym_DOLLAR] = ACTIONS(3014),
    [sym_raw_string] = ACTIONS(3017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3020),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3023),
    [anon_sym_BQUOTE] = ACTIONS(3026),
    [anon_sym_LT_LPAREN] = ACTIONS(3029),
    [anon_sym_GT_LPAREN] = ACTIONS(3029),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3032),
    [sym_word] = ACTIONS(3035),
  },
  [891] = {
    [sym_string] = STATE(1369),
    [sym_simple_expansion] = STATE(1369),
    [sym_string_expansion] = STATE(1369),
    [sym_expansion] = STATE(1369),
    [sym_command_substitution] = STATE(1369),
    [sym_process_substitution] = STATE(1369),
    [sym__special_characters] = ACTIONS(3038),
    [anon_sym_DQUOTE] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [sym_raw_string] = ACTIONS(3038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [anon_sym_LT_LPAREN] = ACTIONS(839),
    [anon_sym_GT_LPAREN] = ACTIONS(839),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3038),
  },
  [892] = {
    [aux_sym_concatenation_repeat1] = STATE(1370),
    [sym__concat] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(693),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [sym__special_characters] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(695),
    [sym_word] = ACTIONS(695),
  },
  [893] = {
    [sym__concat] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(697),
    [anon_sym_PIPE_AMP] = ACTIONS(697),
    [anon_sym_AMP_AMP] = ACTIONS(697),
    [anon_sym_PIPE_PIPE] = ACTIONS(697),
    [sym__special_characters] = ACTIONS(697),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [anon_sym_LT_LPAREN] = ACTIONS(697),
    [anon_sym_GT_LPAREN] = ACTIONS(697),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(699),
    [sym_word] = ACTIONS(699),
  },
  [894] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [895] = {
    [sym__concat] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(727),
    [anon_sym_PIPE_AMP] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(727),
    [anon_sym_PIPE_PIPE] = ACTIONS(727),
    [sym__special_characters] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(727),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(727),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(727),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(727),
    [anon_sym_BQUOTE] = ACTIONS(727),
    [anon_sym_LT_LPAREN] = ACTIONS(727),
    [anon_sym_GT_LPAREN] = ACTIONS(727),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(729),
    [sym_word] = ACTIONS(729),
  },
  [896] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [sym__special_characters] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(733),
    [sym_word] = ACTIONS(733),
  },
  [897] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_PIPE_AMP] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__special_characters] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(737),
    [sym_word] = ACTIONS(737),
  },
  [898] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(3042),
    [sym_comment] = ACTIONS(53),
  },
  [899] = {
    [sym_concatenation] = STATE(1375),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1375),
    [anon_sym_RBRACE] = ACTIONS(3044),
    [anon_sym_EQ] = ACTIONS(3046),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3050),
    [anon_sym_COLON] = ACTIONS(3046),
    [anon_sym_COLON_QMARK] = ACTIONS(3046),
    [anon_sym_COLON_DASH] = ACTIONS(3046),
    [anon_sym_PERCENT] = ACTIONS(3046),
    [anon_sym_DASH] = ACTIONS(3046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [900] = {
    [sym_subscript] = STATE(1379),
    [sym_variable_name] = ACTIONS(3052),
    [anon_sym_DOLLAR] = ACTIONS(3054),
    [anon_sym_DASH] = ACTIONS(3054),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3056),
    [anon_sym_STAR] = ACTIONS(3054),
    [anon_sym_AT] = ACTIONS(3054),
    [anon_sym_QMARK] = ACTIONS(3054),
    [anon_sym_0] = ACTIONS(3058),
    [anon_sym__] = ACTIONS(3058),
  },
  [901] = {
    [sym_concatenation] = STATE(1382),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1382),
    [anon_sym_RBRACE] = ACTIONS(3060),
    [anon_sym_EQ] = ACTIONS(3062),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3066),
    [anon_sym_COLON] = ACTIONS(3062),
    [anon_sym_COLON_QMARK] = ACTIONS(3062),
    [anon_sym_COLON_DASH] = ACTIONS(3062),
    [anon_sym_PERCENT] = ACTIONS(3062),
    [anon_sym_DASH] = ACTIONS(3062),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [902] = {
    [sym_concatenation] = STATE(1385),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1385),
    [anon_sym_RBRACE] = ACTIONS(3068),
    [anon_sym_EQ] = ACTIONS(3070),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3072),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3074),
    [anon_sym_COLON] = ACTIONS(3070),
    [anon_sym_COLON_QMARK] = ACTIONS(3070),
    [anon_sym_COLON_DASH] = ACTIONS(3070),
    [anon_sym_PERCENT] = ACTIONS(3070),
    [anon_sym_DASH] = ACTIONS(3070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [903] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3076),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [904] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3076),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [905] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(3076),
    [sym_comment] = ACTIONS(53),
  },
  [906] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(3076),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [907] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3078),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [908] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3078),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [909] = {
    [sym_concatenation] = STATE(909),
    [sym_string] = STATE(459),
    [sym_simple_expansion] = STATE(459),
    [sym_string_expansion] = STATE(459),
    [sym_expansion] = STATE(459),
    [sym_command_substitution] = STATE(459),
    [sym_process_substitution] = STATE(459),
    [aux_sym_unset_command_repeat1] = STATE(909),
    [anon_sym_PIPE] = ACTIONS(1581),
    [anon_sym_RPAREN] = ACTIONS(1610),
    [anon_sym_PIPE_AMP] = ACTIONS(1610),
    [anon_sym_AMP_AMP] = ACTIONS(1610),
    [anon_sym_PIPE_PIPE] = ACTIONS(1610),
    [sym__special_characters] = ACTIONS(3080),
    [anon_sym_DQUOTE] = ACTIONS(3083),
    [anon_sym_DOLLAR] = ACTIONS(3086),
    [sym_raw_string] = ACTIONS(3089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3092),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3095),
    [anon_sym_BQUOTE] = ACTIONS(3098),
    [anon_sym_LT_LPAREN] = ACTIONS(3101),
    [anon_sym_GT_LPAREN] = ACTIONS(3101),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3104),
    [sym_word] = ACTIONS(3107),
  },
  [910] = {
    [sym__simple_heredoc_body] = ACTIONS(1654),
    [sym__heredoc_body_beginning] = ACTIONS(1654),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(1654),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1654),
    [anon_sym_PIPE_AMP] = ACTIONS(1654),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [anon_sym_EQ_TILDE] = ACTIONS(1656),
    [anon_sym_EQ_EQ] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1654),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1654),
    [anon_sym_LT_AMP] = ACTIONS(1654),
    [anon_sym_GT_AMP] = ACTIONS(1654),
    [anon_sym_LT_LT] = ACTIONS(1656),
    [anon_sym_LT_LT_DASH] = ACTIONS(1654),
    [anon_sym_LT_LT_LT] = ACTIONS(1654),
    [sym__special_characters] = ACTIONS(1654),
    [anon_sym_DQUOTE] = ACTIONS(1654),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1654),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1654),
    [anon_sym_BQUOTE] = ACTIONS(1654),
    [anon_sym_LT_LPAREN] = ACTIONS(1654),
    [anon_sym_GT_LPAREN] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1656),
  },
  [911] = {
    [aux_sym_concatenation_repeat1] = STATE(911),
    [sym__simple_heredoc_body] = ACTIONS(1654),
    [sym__heredoc_body_beginning] = ACTIONS(1654),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(3110),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1654),
    [anon_sym_PIPE_AMP] = ACTIONS(1654),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [anon_sym_EQ_TILDE] = ACTIONS(1656),
    [anon_sym_EQ_EQ] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1654),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1654),
    [anon_sym_LT_AMP] = ACTIONS(1654),
    [anon_sym_GT_AMP] = ACTIONS(1654),
    [anon_sym_LT_LT] = ACTIONS(1656),
    [anon_sym_LT_LT_DASH] = ACTIONS(1654),
    [anon_sym_LT_LT_LT] = ACTIONS(1654),
    [sym__special_characters] = ACTIONS(1654),
    [anon_sym_DQUOTE] = ACTIONS(1654),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1654),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1654),
    [anon_sym_BQUOTE] = ACTIONS(1654),
    [anon_sym_LT_LPAREN] = ACTIONS(1654),
    [anon_sym_GT_LPAREN] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1656),
  },
  [912] = {
    [sym__simple_heredoc_body] = ACTIONS(1703),
    [sym__heredoc_body_beginning] = ACTIONS(1703),
    [sym_file_descriptor] = ACTIONS(1703),
    [sym__concat] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_PIPE_AMP] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1705),
    [anon_sym_EQ_EQ] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1705),
    [anon_sym_GT] = ACTIONS(1705),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_AMP_GT] = ACTIONS(1705),
    [anon_sym_AMP_GT_GT] = ACTIONS(1703),
    [anon_sym_LT_AMP] = ACTIONS(1703),
    [anon_sym_GT_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1705),
    [anon_sym_LT_LT_DASH] = ACTIONS(1703),
    [anon_sym_LT_LT_LT] = ACTIONS(1703),
    [sym__special_characters] = ACTIONS(1703),
    [anon_sym_DQUOTE] = ACTIONS(1703),
    [anon_sym_DOLLAR] = ACTIONS(1705),
    [sym_raw_string] = ACTIONS(1703),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1703),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1703),
    [anon_sym_BQUOTE] = ACTIONS(1703),
    [anon_sym_LT_LPAREN] = ACTIONS(1703),
    [anon_sym_GT_LPAREN] = ACTIONS(1703),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1705),
  },
  [913] = {
    [sym_concatenation] = STATE(1391),
    [sym_string] = STATE(1390),
    [sym_simple_expansion] = STATE(1390),
    [sym_string_expansion] = STATE(1390),
    [sym_expansion] = STATE(1390),
    [sym_command_substitution] = STATE(1390),
    [sym_process_substitution] = STATE(1390),
    [anon_sym_RBRACE] = ACTIONS(3113),
    [sym__special_characters] = ACTIONS(3115),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(3117),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3117),
  },
  [914] = {
    [sym__simple_heredoc_body] = ACTIONS(1744),
    [sym__heredoc_body_beginning] = ACTIONS(1744),
    [sym_file_descriptor] = ACTIONS(1744),
    [sym__concat] = ACTIONS(1744),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_RPAREN] = ACTIONS(1744),
    [anon_sym_PIPE_AMP] = ACTIONS(1744),
    [anon_sym_AMP_AMP] = ACTIONS(1744),
    [anon_sym_PIPE_PIPE] = ACTIONS(1744),
    [anon_sym_EQ_TILDE] = ACTIONS(1746),
    [anon_sym_EQ_EQ] = ACTIONS(1746),
    [anon_sym_LT] = ACTIONS(1746),
    [anon_sym_GT] = ACTIONS(1746),
    [anon_sym_GT_GT] = ACTIONS(1744),
    [anon_sym_AMP_GT] = ACTIONS(1746),
    [anon_sym_AMP_GT_GT] = ACTIONS(1744),
    [anon_sym_LT_AMP] = ACTIONS(1744),
    [anon_sym_GT_AMP] = ACTIONS(1744),
    [anon_sym_LT_LT] = ACTIONS(1746),
    [anon_sym_LT_LT_DASH] = ACTIONS(1744),
    [anon_sym_LT_LT_LT] = ACTIONS(1744),
    [sym__special_characters] = ACTIONS(1744),
    [anon_sym_DQUOTE] = ACTIONS(1744),
    [anon_sym_DOLLAR] = ACTIONS(1746),
    [sym_raw_string] = ACTIONS(1744),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1744),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1744),
    [anon_sym_LT_LPAREN] = ACTIONS(1744),
    [anon_sym_GT_LPAREN] = ACTIONS(1744),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1746),
  },
  [915] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3119),
  },
  [916] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [917] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(3123),
    [sym_comment] = ACTIONS(53),
  },
  [918] = {
    [sym_concatenation] = STATE(1397),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1397),
    [anon_sym_RBRACE] = ACTIONS(3125),
    [anon_sym_EQ] = ACTIONS(3127),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3131),
    [anon_sym_COLON] = ACTIONS(3127),
    [anon_sym_COLON_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_DASH] = ACTIONS(3127),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_DASH] = ACTIONS(3127),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [919] = {
    [sym_concatenation] = STATE(1400),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1400),
    [anon_sym_RBRACE] = ACTIONS(3133),
    [anon_sym_EQ] = ACTIONS(3135),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3137),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3139),
    [anon_sym_COLON] = ACTIONS(3135),
    [anon_sym_COLON_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_DASH] = ACTIONS(3135),
    [anon_sym_PERCENT] = ACTIONS(3135),
    [anon_sym_DASH] = ACTIONS(3135),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [920] = {
    [sym_concatenation] = STATE(1402),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1402),
    [anon_sym_RBRACE] = ACTIONS(3113),
    [anon_sym_EQ] = ACTIONS(3141),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3145),
    [anon_sym_COLON] = ACTIONS(3141),
    [anon_sym_COLON_QMARK] = ACTIONS(3141),
    [anon_sym_COLON_DASH] = ACTIONS(3141),
    [anon_sym_PERCENT] = ACTIONS(3141),
    [anon_sym_DASH] = ACTIONS(3141),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [921] = {
    [sym__simple_heredoc_body] = ACTIONS(1810),
    [sym__heredoc_body_beginning] = ACTIONS(1810),
    [sym_file_descriptor] = ACTIONS(1810),
    [sym__concat] = ACTIONS(1810),
    [anon_sym_PIPE] = ACTIONS(1812),
    [anon_sym_RPAREN] = ACTIONS(1810),
    [anon_sym_PIPE_AMP] = ACTIONS(1810),
    [anon_sym_AMP_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1810),
    [anon_sym_EQ_TILDE] = ACTIONS(1812),
    [anon_sym_EQ_EQ] = ACTIONS(1812),
    [anon_sym_LT] = ACTIONS(1812),
    [anon_sym_GT] = ACTIONS(1812),
    [anon_sym_GT_GT] = ACTIONS(1810),
    [anon_sym_AMP_GT] = ACTIONS(1812),
    [anon_sym_AMP_GT_GT] = ACTIONS(1810),
    [anon_sym_LT_AMP] = ACTIONS(1810),
    [anon_sym_GT_AMP] = ACTIONS(1810),
    [anon_sym_LT_LT] = ACTIONS(1812),
    [anon_sym_LT_LT_DASH] = ACTIONS(1810),
    [anon_sym_LT_LT_LT] = ACTIONS(1810),
    [sym__special_characters] = ACTIONS(1810),
    [anon_sym_DQUOTE] = ACTIONS(1810),
    [anon_sym_DOLLAR] = ACTIONS(1812),
    [sym_raw_string] = ACTIONS(1810),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1810),
    [anon_sym_LT_LPAREN] = ACTIONS(1810),
    [anon_sym_GT_LPAREN] = ACTIONS(1810),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1812),
  },
  [922] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3147),
  },
  [923] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3149),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [924] = {
    [sym__simple_heredoc_body] = ACTIONS(1818),
    [sym__heredoc_body_beginning] = ACTIONS(1818),
    [sym_file_descriptor] = ACTIONS(1818),
    [sym__concat] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1820),
    [anon_sym_RPAREN] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [anon_sym_EQ_TILDE] = ACTIONS(1820),
    [anon_sym_EQ_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1820),
    [anon_sym_GT] = ACTIONS(1820),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT] = ACTIONS(1820),
    [anon_sym_AMP_GT_GT] = ACTIONS(1818),
    [anon_sym_LT_AMP] = ACTIONS(1818),
    [anon_sym_GT_AMP] = ACTIONS(1818),
    [anon_sym_LT_LT] = ACTIONS(1820),
    [anon_sym_LT_LT_DASH] = ACTIONS(1818),
    [anon_sym_LT_LT_LT] = ACTIONS(1818),
    [sym__special_characters] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(1818),
    [anon_sym_DOLLAR] = ACTIONS(1820),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(1818),
    [anon_sym_LT_LPAREN] = ACTIONS(1818),
    [anon_sym_GT_LPAREN] = ACTIONS(1818),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1820),
  },
  [925] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3151),
  },
  [926] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3113),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [927] = {
    [sym__simple_heredoc_body] = ACTIONS(1952),
    [sym__heredoc_body_beginning] = ACTIONS(1952),
    [sym_file_descriptor] = ACTIONS(1952),
    [sym__concat] = ACTIONS(1952),
    [anon_sym_PIPE] = ACTIONS(1954),
    [anon_sym_RPAREN] = ACTIONS(1952),
    [anon_sym_PIPE_AMP] = ACTIONS(1952),
    [anon_sym_AMP_AMP] = ACTIONS(1952),
    [anon_sym_PIPE_PIPE] = ACTIONS(1952),
    [anon_sym_EQ_TILDE] = ACTIONS(1954),
    [anon_sym_EQ_EQ] = ACTIONS(1954),
    [anon_sym_LT] = ACTIONS(1954),
    [anon_sym_GT] = ACTIONS(1954),
    [anon_sym_GT_GT] = ACTIONS(1952),
    [anon_sym_AMP_GT] = ACTIONS(1954),
    [anon_sym_AMP_GT_GT] = ACTIONS(1952),
    [anon_sym_LT_AMP] = ACTIONS(1952),
    [anon_sym_GT_AMP] = ACTIONS(1952),
    [anon_sym_LT_LT] = ACTIONS(1954),
    [anon_sym_LT_LT_DASH] = ACTIONS(1952),
    [anon_sym_LT_LT_LT] = ACTIONS(1952),
    [sym__special_characters] = ACTIONS(1952),
    [anon_sym_DQUOTE] = ACTIONS(1952),
    [anon_sym_DOLLAR] = ACTIONS(1954),
    [sym_raw_string] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1952),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1952),
    [anon_sym_BQUOTE] = ACTIONS(1952),
    [anon_sym_LT_LPAREN] = ACTIONS(1952),
    [anon_sym_GT_LPAREN] = ACTIONS(1952),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1954),
  },
  [928] = {
    [sym__simple_heredoc_body] = ACTIONS(2018),
    [sym__heredoc_body_beginning] = ACTIONS(2018),
    [sym_file_descriptor] = ACTIONS(2018),
    [sym__concat] = ACTIONS(2018),
    [anon_sym_PIPE] = ACTIONS(2020),
    [anon_sym_RPAREN] = ACTIONS(2018),
    [anon_sym_PIPE_AMP] = ACTIONS(2018),
    [anon_sym_AMP_AMP] = ACTIONS(2018),
    [anon_sym_PIPE_PIPE] = ACTIONS(2018),
    [anon_sym_EQ_TILDE] = ACTIONS(2020),
    [anon_sym_EQ_EQ] = ACTIONS(2020),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(2020),
    [anon_sym_GT_GT] = ACTIONS(2018),
    [anon_sym_AMP_GT] = ACTIONS(2020),
    [anon_sym_AMP_GT_GT] = ACTIONS(2018),
    [anon_sym_LT_AMP] = ACTIONS(2018),
    [anon_sym_GT_AMP] = ACTIONS(2018),
    [anon_sym_LT_LT] = ACTIONS(2020),
    [anon_sym_LT_LT_DASH] = ACTIONS(2018),
    [anon_sym_LT_LT_LT] = ACTIONS(2018),
    [sym__special_characters] = ACTIONS(2018),
    [anon_sym_DQUOTE] = ACTIONS(2018),
    [anon_sym_DOLLAR] = ACTIONS(2020),
    [sym_raw_string] = ACTIONS(2018),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2018),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2018),
    [anon_sym_BQUOTE] = ACTIONS(2018),
    [anon_sym_LT_LPAREN] = ACTIONS(2018),
    [anon_sym_GT_LPAREN] = ACTIONS(2018),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2020),
  },
  [929] = {
    [sym_compound_statement] = STATE(1406),
    [anon_sym_LBRACE] = ACTIONS(1852),
    [sym_comment] = ACTIONS(53),
  },
  [930] = {
    [anon_sym_PIPE] = ACTIONS(2022),
    [anon_sym_RPAREN] = ACTIONS(2024),
    [anon_sym_PIPE_AMP] = ACTIONS(2024),
    [anon_sym_AMP_AMP] = ACTIONS(2024),
    [anon_sym_PIPE_PIPE] = ACTIONS(2024),
    [anon_sym_BQUOTE] = ACTIONS(2024),
    [sym_comment] = ACTIONS(53),
  },
  [931] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(2022),
    [anon_sym_RPAREN] = ACTIONS(2024),
    [anon_sym_PIPE_AMP] = ACTIONS(2024),
    [anon_sym_AMP_AMP] = ACTIONS(2024),
    [anon_sym_PIPE_PIPE] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [932] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2028),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(2028),
    [anon_sym_PIPE_PIPE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(53),
  },
  [933] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(2028),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(2028),
    [anon_sym_PIPE_PIPE] = ACTIONS(2028),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [934] = {
    [anon_sym_PIPE] = ACTIONS(2030),
    [anon_sym_RPAREN] = ACTIONS(2032),
    [anon_sym_PIPE_AMP] = ACTIONS(2032),
    [anon_sym_AMP_AMP] = ACTIONS(2032),
    [anon_sym_PIPE_PIPE] = ACTIONS(2032),
    [anon_sym_BQUOTE] = ACTIONS(2032),
    [sym_comment] = ACTIONS(53),
  },
  [935] = {
    [sym_simple_expansion] = STATE(988),
    [sym_expansion] = STATE(988),
    [aux_sym_heredoc_body_repeat1] = STATE(988),
    [sym__heredoc_body_middle] = ACTIONS(2050),
    [sym__heredoc_body_end] = ACTIONS(3153),
    [anon_sym_DOLLAR] = ACTIONS(963),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(965),
    [sym_comment] = ACTIONS(53),
  },
  [936] = {
    [sym_concatenation] = STATE(1410),
    [sym_string] = STATE(1409),
    [sym_simple_expansion] = STATE(1409),
    [sym_string_expansion] = STATE(1409),
    [sym_expansion] = STATE(1409),
    [sym_command_substitution] = STATE(1409),
    [sym_process_substitution] = STATE(1409),
    [sym__special_characters] = ACTIONS(3155),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(3157),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3157),
  },
  [937] = {
    [aux_sym_concatenation_repeat1] = STATE(467),
    [sym__simple_heredoc_body] = ACTIONS(2058),
    [sym__heredoc_body_beginning] = ACTIONS(2058),
    [sym_file_descriptor] = ACTIONS(2058),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(2060),
    [anon_sym_RPAREN] = ACTIONS(2058),
    [anon_sym_PIPE_AMP] = ACTIONS(2058),
    [anon_sym_AMP_AMP] = ACTIONS(2058),
    [anon_sym_PIPE_PIPE] = ACTIONS(2058),
    [anon_sym_EQ_TILDE] = ACTIONS(2060),
    [anon_sym_EQ_EQ] = ACTIONS(2060),
    [anon_sym_LT] = ACTIONS(2060),
    [anon_sym_GT] = ACTIONS(2060),
    [anon_sym_GT_GT] = ACTIONS(2058),
    [anon_sym_AMP_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT_GT] = ACTIONS(2058),
    [anon_sym_LT_AMP] = ACTIONS(2058),
    [anon_sym_GT_AMP] = ACTIONS(2058),
    [anon_sym_LT_LT] = ACTIONS(2060),
    [anon_sym_LT_LT_DASH] = ACTIONS(2058),
    [anon_sym_LT_LT_LT] = ACTIONS(2058),
    [sym__special_characters] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_DOLLAR] = ACTIONS(2060),
    [sym_raw_string] = ACTIONS(2058),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2058),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [anon_sym_LT_LPAREN] = ACTIONS(2058),
    [anon_sym_GT_LPAREN] = ACTIONS(2058),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2060),
  },
  [938] = {
    [aux_sym_concatenation_repeat1] = STATE(467),
    [sym__simple_heredoc_body] = ACTIONS(2062),
    [sym__heredoc_body_beginning] = ACTIONS(2062),
    [sym_file_descriptor] = ACTIONS(2062),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_RPAREN] = ACTIONS(2062),
    [anon_sym_PIPE_AMP] = ACTIONS(2062),
    [anon_sym_AMP_AMP] = ACTIONS(2062),
    [anon_sym_PIPE_PIPE] = ACTIONS(2062),
    [anon_sym_EQ_TILDE] = ACTIONS(2064),
    [anon_sym_EQ_EQ] = ACTIONS(2064),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2062),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2062),
    [anon_sym_LT_AMP] = ACTIONS(2062),
    [anon_sym_GT_AMP] = ACTIONS(2062),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2062),
    [anon_sym_LT_LT_LT] = ACTIONS(2062),
    [sym__special_characters] = ACTIONS(2062),
    [anon_sym_DQUOTE] = ACTIONS(2062),
    [anon_sym_DOLLAR] = ACTIONS(2064),
    [sym_raw_string] = ACTIONS(2062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2062),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2062),
    [anon_sym_BQUOTE] = ACTIONS(2062),
    [anon_sym_LT_LPAREN] = ACTIONS(2062),
    [anon_sym_GT_LPAREN] = ACTIONS(2062),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2064),
  },
  [939] = {
    [sym__simple_heredoc_body] = ACTIONS(2062),
    [sym__heredoc_body_beginning] = ACTIONS(2062),
    [sym_file_descriptor] = ACTIONS(2062),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_RPAREN] = ACTIONS(2062),
    [anon_sym_PIPE_AMP] = ACTIONS(2062),
    [anon_sym_AMP_AMP] = ACTIONS(2062),
    [anon_sym_PIPE_PIPE] = ACTIONS(2062),
    [anon_sym_EQ_TILDE] = ACTIONS(2064),
    [anon_sym_EQ_EQ] = ACTIONS(2064),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2062),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2062),
    [anon_sym_LT_AMP] = ACTIONS(2062),
    [anon_sym_GT_AMP] = ACTIONS(2062),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2062),
    [anon_sym_LT_LT_LT] = ACTIONS(2062),
    [sym__special_characters] = ACTIONS(2062),
    [anon_sym_DQUOTE] = ACTIONS(2062),
    [anon_sym_DOLLAR] = ACTIONS(2064),
    [sym_raw_string] = ACTIONS(2062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2062),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2062),
    [anon_sym_BQUOTE] = ACTIONS(2062),
    [anon_sym_LT_LPAREN] = ACTIONS(2062),
    [anon_sym_GT_LPAREN] = ACTIONS(2062),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2064),
  },
  [940] = {
    [aux_sym_concatenation_repeat1] = STATE(1411),
    [sym__simple_heredoc_body] = ACTIONS(661),
    [sym__heredoc_body_beginning] = ACTIONS(661),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(661),
    [anon_sym_LT_AMP] = ACTIONS(661),
    [anon_sym_GT_AMP] = ACTIONS(661),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(661),
    [anon_sym_LT_LT_LT] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
  },
  [941] = {
    [aux_sym_concatenation_repeat1] = STATE(1411),
    [sym__simple_heredoc_body] = ACTIONS(677),
    [sym__heredoc_body_beginning] = ACTIONS(677),
    [sym_file_descriptor] = ACTIONS(677),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(677),
    [anon_sym_LT_LT_LT] = ACTIONS(677),
    [sym_comment] = ACTIONS(53),
  },
  [942] = {
    [sym__simple_heredoc_body] = ACTIONS(677),
    [sym__heredoc_body_beginning] = ACTIONS(677),
    [sym_file_descriptor] = ACTIONS(677),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(677),
    [anon_sym_LT_LT_LT] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [sym_comment] = ACTIONS(53),
  },
  [943] = {
    [sym__simple_heredoc_body] = ACTIONS(2066),
    [sym__heredoc_body_beginning] = ACTIONS(2066),
    [sym_file_descriptor] = ACTIONS(2066),
    [anon_sym_PIPE] = ACTIONS(2068),
    [anon_sym_RPAREN] = ACTIONS(2066),
    [anon_sym_PIPE_AMP] = ACTIONS(2066),
    [anon_sym_AMP_AMP] = ACTIONS(2066),
    [anon_sym_PIPE_PIPE] = ACTIONS(2066),
    [anon_sym_LT] = ACTIONS(2068),
    [anon_sym_GT] = ACTIONS(2068),
    [anon_sym_GT_GT] = ACTIONS(2066),
    [anon_sym_AMP_GT] = ACTIONS(2068),
    [anon_sym_AMP_GT_GT] = ACTIONS(2066),
    [anon_sym_LT_AMP] = ACTIONS(2066),
    [anon_sym_GT_AMP] = ACTIONS(2066),
    [anon_sym_LT_LT] = ACTIONS(2068),
    [anon_sym_LT_LT_DASH] = ACTIONS(2066),
    [anon_sym_LT_LT_LT] = ACTIONS(2066),
    [anon_sym_BQUOTE] = ACTIONS(2066),
    [sym_comment] = ACTIONS(53),
  },
  [944] = {
    [aux_sym_concatenation_repeat1] = STATE(1411),
    [sym__simple_heredoc_body] = ACTIONS(2070),
    [sym__heredoc_body_beginning] = ACTIONS(2070),
    [sym_file_descriptor] = ACTIONS(2070),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(2072),
    [anon_sym_RPAREN] = ACTIONS(2070),
    [anon_sym_PIPE_AMP] = ACTIONS(2070),
    [anon_sym_AMP_AMP] = ACTIONS(2070),
    [anon_sym_PIPE_PIPE] = ACTIONS(2070),
    [anon_sym_LT] = ACTIONS(2072),
    [anon_sym_GT] = ACTIONS(2072),
    [anon_sym_GT_GT] = ACTIONS(2070),
    [anon_sym_AMP_GT] = ACTIONS(2072),
    [anon_sym_AMP_GT_GT] = ACTIONS(2070),
    [anon_sym_LT_AMP] = ACTIONS(2070),
    [anon_sym_GT_AMP] = ACTIONS(2070),
    [anon_sym_LT_LT] = ACTIONS(2072),
    [anon_sym_LT_LT_DASH] = ACTIONS(2070),
    [anon_sym_LT_LT_LT] = ACTIONS(2070),
    [sym_comment] = ACTIONS(53),
  },
  [945] = {
    [aux_sym_concatenation_repeat1] = STATE(1411),
    [sym__simple_heredoc_body] = ACTIONS(2074),
    [sym__heredoc_body_beginning] = ACTIONS(2074),
    [sym_file_descriptor] = ACTIONS(2074),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(2076),
    [anon_sym_RPAREN] = ACTIONS(2074),
    [anon_sym_PIPE_AMP] = ACTIONS(2074),
    [anon_sym_AMP_AMP] = ACTIONS(2074),
    [anon_sym_PIPE_PIPE] = ACTIONS(2074),
    [anon_sym_LT] = ACTIONS(2076),
    [anon_sym_GT] = ACTIONS(2076),
    [anon_sym_GT_GT] = ACTIONS(2074),
    [anon_sym_AMP_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT_GT] = ACTIONS(2074),
    [anon_sym_LT_AMP] = ACTIONS(2074),
    [anon_sym_GT_AMP] = ACTIONS(2074),
    [anon_sym_LT_LT] = ACTIONS(2076),
    [anon_sym_LT_LT_DASH] = ACTIONS(2074),
    [anon_sym_LT_LT_LT] = ACTIONS(2074),
    [sym_comment] = ACTIONS(53),
  },
  [946] = {
    [sym__simple_heredoc_body] = ACTIONS(2074),
    [sym__heredoc_body_beginning] = ACTIONS(2074),
    [sym_file_descriptor] = ACTIONS(2074),
    [anon_sym_PIPE] = ACTIONS(2076),
    [anon_sym_RPAREN] = ACTIONS(2074),
    [anon_sym_PIPE_AMP] = ACTIONS(2074),
    [anon_sym_AMP_AMP] = ACTIONS(2074),
    [anon_sym_PIPE_PIPE] = ACTIONS(2074),
    [anon_sym_LT] = ACTIONS(2076),
    [anon_sym_GT] = ACTIONS(2076),
    [anon_sym_GT_GT] = ACTIONS(2074),
    [anon_sym_AMP_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT_GT] = ACTIONS(2074),
    [anon_sym_LT_AMP] = ACTIONS(2074),
    [anon_sym_GT_AMP] = ACTIONS(2074),
    [anon_sym_LT_LT] = ACTIONS(2076),
    [anon_sym_LT_LT_DASH] = ACTIONS(2074),
    [anon_sym_LT_LT_LT] = ACTIONS(2074),
    [anon_sym_BQUOTE] = ACTIONS(2074),
    [sym_comment] = ACTIONS(53),
  },
  [947] = {
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_RPAREN] = ACTIONS(2080),
    [anon_sym_PIPE_AMP] = ACTIONS(2080),
    [anon_sym_AMP_AMP] = ACTIONS(2080),
    [anon_sym_PIPE_PIPE] = ACTIONS(2080),
    [anon_sym_BQUOTE] = ACTIONS(2080),
    [sym_comment] = ACTIONS(53),
  },
  [948] = {
    [sym_file_redirect] = STATE(948),
    [sym_heredoc_redirect] = STATE(948),
    [sym_herestring_redirect] = STATE(948),
    [aux_sym_while_statement_repeat1] = STATE(948),
    [sym__simple_heredoc_body] = ACTIONS(2082),
    [sym__heredoc_body_beginning] = ACTIONS(2082),
    [sym_file_descriptor] = ACTIONS(3159),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_RPAREN] = ACTIONS(2082),
    [anon_sym_PIPE_AMP] = ACTIONS(2082),
    [anon_sym_AMP_AMP] = ACTIONS(2082),
    [anon_sym_PIPE_PIPE] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(3162),
    [anon_sym_GT] = ACTIONS(3162),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_AMP_GT] = ACTIONS(3162),
    [anon_sym_AMP_GT_GT] = ACTIONS(3165),
    [anon_sym_LT_AMP] = ACTIONS(3165),
    [anon_sym_GT_AMP] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3168),
    [anon_sym_LT_LT_DASH] = ACTIONS(3171),
    [anon_sym_LT_LT_LT] = ACTIONS(3174),
    [sym_comment] = ACTIONS(53),
  },
  [949] = {
    [sym_file_redirect] = STATE(948),
    [sym_heredoc_redirect] = STATE(948),
    [sym_heredoc_body] = STATE(1412),
    [sym_herestring_redirect] = STATE(948),
    [aux_sym_while_statement_repeat1] = STATE(948),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_RPAREN] = ACTIONS(2080),
    [anon_sym_PIPE_AMP] = ACTIONS(2080),
    [anon_sym_AMP_AMP] = ACTIONS(2080),
    [anon_sym_PIPE_PIPE] = ACTIONS(2080),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(887),
    [anon_sym_LT_AMP] = ACTIONS(887),
    [anon_sym_GT_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(893),
    [sym_comment] = ACTIONS(53),
  },
  [950] = {
    [sym_concatenation] = STATE(950),
    [sym_string] = STATE(496),
    [sym_simple_expansion] = STATE(496),
    [sym_string_expansion] = STATE(496),
    [sym_expansion] = STATE(496),
    [sym_command_substitution] = STATE(496),
    [sym_process_substitution] = STATE(496),
    [aux_sym_command_repeat2] = STATE(950),
    [sym__simple_heredoc_body] = ACTIONS(2062),
    [sym__heredoc_body_beginning] = ACTIONS(2062),
    [sym_file_descriptor] = ACTIONS(2062),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_RPAREN] = ACTIONS(2062),
    [anon_sym_PIPE_AMP] = ACTIONS(2062),
    [anon_sym_AMP_AMP] = ACTIONS(2062),
    [anon_sym_PIPE_PIPE] = ACTIONS(2062),
    [anon_sym_EQ_TILDE] = ACTIONS(3177),
    [anon_sym_EQ_EQ] = ACTIONS(3177),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2062),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2062),
    [anon_sym_LT_AMP] = ACTIONS(2062),
    [anon_sym_GT_AMP] = ACTIONS(2062),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2062),
    [anon_sym_LT_LT_LT] = ACTIONS(2062),
    [sym__special_characters] = ACTIONS(3180),
    [anon_sym_DQUOTE] = ACTIONS(3183),
    [anon_sym_DOLLAR] = ACTIONS(3186),
    [sym_raw_string] = ACTIONS(3189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3192),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3195),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [anon_sym_LT_LPAREN] = ACTIONS(3201),
    [anon_sym_GT_LPAREN] = ACTIONS(3201),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3204),
  },
  [951] = {
    [sym_file_redirect] = STATE(1413),
    [sym_heredoc_redirect] = STATE(1413),
    [sym_heredoc_body] = STATE(1412),
    [sym_herestring_redirect] = STATE(1413),
    [sym_concatenation] = STATE(950),
    [sym_string] = STATE(496),
    [sym_simple_expansion] = STATE(496),
    [sym_string_expansion] = STATE(496),
    [sym_expansion] = STATE(496),
    [sym_command_substitution] = STATE(496),
    [sym_process_substitution] = STATE(496),
    [aux_sym_while_statement_repeat1] = STATE(1413),
    [aux_sym_command_repeat2] = STATE(950),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_RPAREN] = ACTIONS(2080),
    [anon_sym_PIPE_AMP] = ACTIONS(2080),
    [anon_sym_AMP_AMP] = ACTIONS(2080),
    [anon_sym_PIPE_PIPE] = ACTIONS(2080),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(887),
    [anon_sym_LT_AMP] = ACTIONS(887),
    [anon_sym_GT_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(893),
    [sym__special_characters] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(897),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(899),
  },
  [952] = {
    [aux_sym_concatenation_repeat1] = STATE(1414),
    [sym_file_descriptor] = ACTIONS(1129),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_AMP_GT] = ACTIONS(1133),
    [anon_sym_AMP_GT_GT] = ACTIONS(1129),
    [anon_sym_LT_AMP] = ACTIONS(1129),
    [anon_sym_GT_AMP] = ACTIONS(1129),
    [sym__special_characters] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1129),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [sym_raw_string] = ACTIONS(1129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1129),
    [anon_sym_LT_LPAREN] = ACTIONS(1129),
    [anon_sym_GT_LPAREN] = ACTIONS(1129),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1129),
  },
  [953] = {
    [aux_sym_concatenation_repeat1] = STATE(1414),
    [sym_file_descriptor] = ACTIONS(1107),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1109),
    [anon_sym_GT] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_AMP] = ACTIONS(1107),
    [anon_sym_GT_AMP] = ACTIONS(1107),
    [sym__special_characters] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LT_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_LPAREN] = ACTIONS(1107),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1107),
  },
  [954] = {
    [sym_file_redirect] = STATE(1415),
    [sym_heredoc_redirect] = STATE(1415),
    [sym_heredoc_body] = STATE(1323),
    [sym_herestring_redirect] = STATE(1415),
    [aux_sym_while_statement_repeat1] = STATE(1415),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(1175),
    [anon_sym_PIPE_AMP] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1177),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(933),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(937),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_comment] = ACTIONS(53),
  },
  [955] = {
    [anon_sym_RPAREN] = ACTIONS(3207),
    [sym_comment] = ACTIONS(53),
  },
  [956] = {
    [sym_file_redirect] = STATE(1338),
    [sym_file_descriptor] = ACTIONS(3209),
    [anon_sym_PIPE] = ACTIONS(1245),
    [anon_sym_PIPE_AMP] = ACTIONS(1249),
    [anon_sym_AMP_AMP] = ACTIONS(1249),
    [anon_sym_PIPE_PIPE] = ACTIONS(1249),
    [anon_sym_LT] = ACTIONS(3211),
    [anon_sym_GT] = ACTIONS(3211),
    [anon_sym_GT_GT] = ACTIONS(3213),
    [anon_sym_AMP_GT] = ACTIONS(3211),
    [anon_sym_AMP_GT_GT] = ACTIONS(3213),
    [anon_sym_LT_AMP] = ACTIONS(3213),
    [anon_sym_GT_AMP] = ACTIONS(3213),
    [anon_sym_BQUOTE] = ACTIONS(1249),
    [sym_comment] = ACTIONS(53),
  },
  [957] = {
    [sym_file_redirect] = STATE(1422),
    [sym_heredoc_redirect] = STATE(1422),
    [sym_herestring_redirect] = STATE(1422),
    [aux_sym_while_statement_repeat1] = STATE(1422),
    [sym_file_descriptor] = ACTIONS(3215),
    [anon_sym_PIPE] = ACTIONS(1353),
    [anon_sym_PIPE_AMP] = ACTIONS(1361),
    [anon_sym_AMP_AMP] = ACTIONS(1361),
    [anon_sym_PIPE_PIPE] = ACTIONS(1361),
    [anon_sym_LT] = ACTIONS(3217),
    [anon_sym_GT] = ACTIONS(3217),
    [anon_sym_GT_GT] = ACTIONS(3219),
    [anon_sym_AMP_GT] = ACTIONS(3217),
    [anon_sym_AMP_GT_GT] = ACTIONS(3219),
    [anon_sym_LT_AMP] = ACTIONS(3219),
    [anon_sym_GT_AMP] = ACTIONS(3219),
    [anon_sym_LT_LT] = ACTIONS(2949),
    [anon_sym_LT_LT_DASH] = ACTIONS(2951),
    [anon_sym_LT_LT_LT] = ACTIONS(3221),
    [anon_sym_BQUOTE] = ACTIONS(1361),
    [sym_comment] = ACTIONS(53),
  },
  [958] = {
    [sym_concatenation] = STATE(1346),
    [sym_string] = STATE(1424),
    [sym_array] = STATE(1346),
    [sym_simple_expansion] = STATE(1424),
    [sym_string_expansion] = STATE(1424),
    [sym_expansion] = STATE(1424),
    [sym_command_substitution] = STATE(1424),
    [sym_process_substitution] = STATE(1424),
    [sym__empty_value] = ACTIONS(2955),
    [anon_sym_LPAREN] = ACTIONS(2957),
    [sym__special_characters] = ACTIONS(3223),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(3225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(815),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LT_LPAREN] = ACTIONS(819),
    [anon_sym_GT_LPAREN] = ACTIONS(819),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3225),
  },
  [959] = {
    [aux_sym_concatenation_repeat1] = STATE(1425),
    [sym__concat] = ACTIONS(1864),
    [sym_variable_name] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [sym__special_characters] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(695),
    [sym_word] = ACTIONS(695),
  },
  [960] = {
    [sym_variable_assignment] = STATE(960),
    [sym_subscript] = STATE(509),
    [sym_concatenation] = STATE(960),
    [sym_string] = STATE(508),
    [sym_simple_expansion] = STATE(508),
    [sym_string_expansion] = STATE(508),
    [sym_expansion] = STATE(508),
    [sym_command_substitution] = STATE(508),
    [sym_process_substitution] = STATE(508),
    [aux_sym_declaration_command_repeat1] = STATE(960),
    [sym_variable_name] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_PIPE_AMP] = ACTIONS(1529),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [sym__special_characters] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [anon_sym_DOLLAR] = ACTIONS(3014),
    [sym_raw_string] = ACTIONS(3233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3020),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3023),
    [anon_sym_BQUOTE] = ACTIONS(3026),
    [anon_sym_LT_LPAREN] = ACTIONS(3029),
    [anon_sym_GT_LPAREN] = ACTIONS(3029),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3032),
    [sym_word] = ACTIONS(3236),
  },
  [961] = {
    [aux_sym_concatenation_repeat1] = STATE(1426),
    [sym__concat] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [sym__special_characters] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(695),
    [sym_word] = ACTIONS(695),
  },
  [962] = {
    [sym_concatenation] = STATE(962),
    [sym_string] = STATE(512),
    [sym_simple_expansion] = STATE(512),
    [sym_string_expansion] = STATE(512),
    [sym_expansion] = STATE(512),
    [sym_command_substitution] = STATE(512),
    [sym_process_substitution] = STATE(512),
    [aux_sym_unset_command_repeat1] = STATE(962),
    [anon_sym_PIPE] = ACTIONS(1581),
    [anon_sym_PIPE_AMP] = ACTIONS(1610),
    [anon_sym_AMP_AMP] = ACTIONS(1610),
    [anon_sym_PIPE_PIPE] = ACTIONS(1610),
    [sym__special_characters] = ACTIONS(3239),
    [anon_sym_DQUOTE] = ACTIONS(3083),
    [anon_sym_DOLLAR] = ACTIONS(3086),
    [sym_raw_string] = ACTIONS(3242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3092),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3095),
    [anon_sym_BQUOTE] = ACTIONS(3098),
    [anon_sym_LT_LPAREN] = ACTIONS(3101),
    [anon_sym_GT_LPAREN] = ACTIONS(3101),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3104),
    [sym_word] = ACTIONS(3245),
  },
  [963] = {
    [aux_sym_concatenation_repeat1] = STATE(963),
    [sym__simple_heredoc_body] = ACTIONS(1654),
    [sym__heredoc_body_beginning] = ACTIONS(1654),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(3110),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1654),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [anon_sym_EQ_TILDE] = ACTIONS(1656),
    [anon_sym_EQ_EQ] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1654),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1654),
    [anon_sym_LT_AMP] = ACTIONS(1654),
    [anon_sym_GT_AMP] = ACTIONS(1654),
    [anon_sym_LT_LT] = ACTIONS(1656),
    [anon_sym_LT_LT_DASH] = ACTIONS(1654),
    [anon_sym_LT_LT_LT] = ACTIONS(1654),
    [sym__special_characters] = ACTIONS(1654),
    [anon_sym_DQUOTE] = ACTIONS(1654),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1654),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1654),
    [anon_sym_BQUOTE] = ACTIONS(1654),
    [anon_sym_LT_LPAREN] = ACTIONS(1654),
    [anon_sym_GT_LPAREN] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1656),
  },
  [964] = {
    [sym_compound_statement] = STATE(1427),
    [anon_sym_LBRACE] = ACTIONS(1852),
    [sym_comment] = ACTIONS(53),
  },
  [965] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(2022),
    [anon_sym_PIPE_AMP] = ACTIONS(2024),
    [anon_sym_AMP_AMP] = ACTIONS(2024),
    [anon_sym_PIPE_PIPE] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(2024),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [966] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(2028),
    [anon_sym_PIPE_PIPE] = ACTIONS(2028),
    [anon_sym_BQUOTE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(53),
  },
  [967] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(2028),
    [anon_sym_PIPE_PIPE] = ACTIONS(2028),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [968] = {
    [sym_concatenation] = STATE(1410),
    [sym_string] = STATE(1429),
    [sym_simple_expansion] = STATE(1429),
    [sym_string_expansion] = STATE(1429),
    [sym_expansion] = STATE(1429),
    [sym_command_substitution] = STATE(1429),
    [sym_process_substitution] = STATE(1429),
    [sym__special_characters] = ACTIONS(3248),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(3250),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3250),
  },
  [969] = {
    [aux_sym_concatenation_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(2058),
    [sym__heredoc_body_beginning] = ACTIONS(2058),
    [sym_file_descriptor] = ACTIONS(2058),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(2060),
    [anon_sym_PIPE_AMP] = ACTIONS(2058),
    [anon_sym_AMP_AMP] = ACTIONS(2058),
    [anon_sym_PIPE_PIPE] = ACTIONS(2058),
    [anon_sym_EQ_TILDE] = ACTIONS(2060),
    [anon_sym_EQ_EQ] = ACTIONS(2060),
    [anon_sym_LT] = ACTIONS(2060),
    [anon_sym_GT] = ACTIONS(2060),
    [anon_sym_GT_GT] = ACTIONS(2058),
    [anon_sym_AMP_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT_GT] = ACTIONS(2058),
    [anon_sym_LT_AMP] = ACTIONS(2058),
    [anon_sym_GT_AMP] = ACTIONS(2058),
    [anon_sym_LT_LT] = ACTIONS(2060),
    [anon_sym_LT_LT_DASH] = ACTIONS(2058),
    [anon_sym_LT_LT_LT] = ACTIONS(2058),
    [sym__special_characters] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_DOLLAR] = ACTIONS(2060),
    [sym_raw_string] = ACTIONS(2058),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2058),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [anon_sym_LT_LPAREN] = ACTIONS(2058),
    [anon_sym_GT_LPAREN] = ACTIONS(2058),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2060),
  },
  [970] = {
    [aux_sym_concatenation_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(2062),
    [sym__heredoc_body_beginning] = ACTIONS(2062),
    [sym_file_descriptor] = ACTIONS(2062),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_PIPE_AMP] = ACTIONS(2062),
    [anon_sym_AMP_AMP] = ACTIONS(2062),
    [anon_sym_PIPE_PIPE] = ACTIONS(2062),
    [anon_sym_EQ_TILDE] = ACTIONS(2064),
    [anon_sym_EQ_EQ] = ACTIONS(2064),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2062),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2062),
    [anon_sym_LT_AMP] = ACTIONS(2062),
    [anon_sym_GT_AMP] = ACTIONS(2062),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2062),
    [anon_sym_LT_LT_LT] = ACTIONS(2062),
    [sym__special_characters] = ACTIONS(2062),
    [anon_sym_DQUOTE] = ACTIONS(2062),
    [anon_sym_DOLLAR] = ACTIONS(2064),
    [sym_raw_string] = ACTIONS(2062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2062),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2062),
    [anon_sym_BQUOTE] = ACTIONS(2062),
    [anon_sym_LT_LPAREN] = ACTIONS(2062),
    [anon_sym_GT_LPAREN] = ACTIONS(2062),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2064),
  },
  [971] = {
    [aux_sym_concatenation_repeat1] = STATE(1430),
    [sym__simple_heredoc_body] = ACTIONS(661),
    [sym__heredoc_body_beginning] = ACTIONS(661),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(661),
    [anon_sym_LT_AMP] = ACTIONS(661),
    [anon_sym_GT_AMP] = ACTIONS(661),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(661),
    [anon_sym_LT_LT_LT] = ACTIONS(661),
    [anon_sym_BQUOTE] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
  },
  [972] = {
    [aux_sym_concatenation_repeat1] = STATE(1430),
    [sym__simple_heredoc_body] = ACTIONS(677),
    [sym__heredoc_body_beginning] = ACTIONS(677),
    [sym_file_descriptor] = ACTIONS(677),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(677),
    [anon_sym_LT_LT_LT] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [sym_comment] = ACTIONS(53),
  },
  [973] = {
    [aux_sym_concatenation_repeat1] = STATE(1430),
    [sym__simple_heredoc_body] = ACTIONS(2070),
    [sym__heredoc_body_beginning] = ACTIONS(2070),
    [sym_file_descriptor] = ACTIONS(2070),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(2072),
    [anon_sym_PIPE_AMP] = ACTIONS(2070),
    [anon_sym_AMP_AMP] = ACTIONS(2070),
    [anon_sym_PIPE_PIPE] = ACTIONS(2070),
    [anon_sym_LT] = ACTIONS(2072),
    [anon_sym_GT] = ACTIONS(2072),
    [anon_sym_GT_GT] = ACTIONS(2070),
    [anon_sym_AMP_GT] = ACTIONS(2072),
    [anon_sym_AMP_GT_GT] = ACTIONS(2070),
    [anon_sym_LT_AMP] = ACTIONS(2070),
    [anon_sym_GT_AMP] = ACTIONS(2070),
    [anon_sym_LT_LT] = ACTIONS(2072),
    [anon_sym_LT_LT_DASH] = ACTIONS(2070),
    [anon_sym_LT_LT_LT] = ACTIONS(2070),
    [anon_sym_BQUOTE] = ACTIONS(2070),
    [sym_comment] = ACTIONS(53),
  },
  [974] = {
    [aux_sym_concatenation_repeat1] = STATE(1430),
    [sym__simple_heredoc_body] = ACTIONS(2074),
    [sym__heredoc_body_beginning] = ACTIONS(2074),
    [sym_file_descriptor] = ACTIONS(2074),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(2076),
    [anon_sym_PIPE_AMP] = ACTIONS(2074),
    [anon_sym_AMP_AMP] = ACTIONS(2074),
    [anon_sym_PIPE_PIPE] = ACTIONS(2074),
    [anon_sym_LT] = ACTIONS(2076),
    [anon_sym_GT] = ACTIONS(2076),
    [anon_sym_GT_GT] = ACTIONS(2074),
    [anon_sym_AMP_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT_GT] = ACTIONS(2074),
    [anon_sym_LT_AMP] = ACTIONS(2074),
    [anon_sym_GT_AMP] = ACTIONS(2074),
    [anon_sym_LT_LT] = ACTIONS(2076),
    [anon_sym_LT_LT_DASH] = ACTIONS(2074),
    [anon_sym_LT_LT_LT] = ACTIONS(2074),
    [anon_sym_BQUOTE] = ACTIONS(2074),
    [sym_comment] = ACTIONS(53),
  },
  [975] = {
    [sym_file_redirect] = STATE(975),
    [sym_heredoc_redirect] = STATE(975),
    [sym_herestring_redirect] = STATE(975),
    [aux_sym_while_statement_repeat1] = STATE(975),
    [sym__simple_heredoc_body] = ACTIONS(2082),
    [sym__heredoc_body_beginning] = ACTIONS(2082),
    [sym_file_descriptor] = ACTIONS(3252),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_PIPE_AMP] = ACTIONS(2082),
    [anon_sym_AMP_AMP] = ACTIONS(2082),
    [anon_sym_PIPE_PIPE] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_GT] = ACTIONS(3255),
    [anon_sym_GT_GT] = ACTIONS(3258),
    [anon_sym_AMP_GT] = ACTIONS(3255),
    [anon_sym_AMP_GT_GT] = ACTIONS(3258),
    [anon_sym_LT_AMP] = ACTIONS(3258),
    [anon_sym_GT_AMP] = ACTIONS(3258),
    [anon_sym_LT_LT] = ACTIONS(3168),
    [anon_sym_LT_LT_DASH] = ACTIONS(3171),
    [anon_sym_LT_LT_LT] = ACTIONS(3261),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(53),
  },
  [976] = {
    [sym_file_redirect] = STATE(975),
    [sym_heredoc_redirect] = STATE(975),
    [sym_heredoc_body] = STATE(1412),
    [sym_herestring_redirect] = STATE(975),
    [aux_sym_while_statement_repeat1] = STATE(975),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_PIPE_AMP] = ACTIONS(2080),
    [anon_sym_AMP_AMP] = ACTIONS(2080),
    [anon_sym_PIPE_PIPE] = ACTIONS(2080),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(933),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(937),
    [anon_sym_BQUOTE] = ACTIONS(2080),
    [sym_comment] = ACTIONS(53),
  },
  [977] = {
    [sym_concatenation] = STATE(977),
    [sym_string] = STATE(523),
    [sym_simple_expansion] = STATE(523),
    [sym_string_expansion] = STATE(523),
    [sym_expansion] = STATE(523),
    [sym_command_substitution] = STATE(523),
    [sym_process_substitution] = STATE(523),
    [aux_sym_command_repeat2] = STATE(977),
    [sym__simple_heredoc_body] = ACTIONS(2062),
    [sym__heredoc_body_beginning] = ACTIONS(2062),
    [sym_file_descriptor] = ACTIONS(2062),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_PIPE_AMP] = ACTIONS(2062),
    [anon_sym_AMP_AMP] = ACTIONS(2062),
    [anon_sym_PIPE_PIPE] = ACTIONS(2062),
    [anon_sym_EQ_TILDE] = ACTIONS(3264),
    [anon_sym_EQ_EQ] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2062),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2062),
    [anon_sym_LT_AMP] = ACTIONS(2062),
    [anon_sym_GT_AMP] = ACTIONS(2062),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2062),
    [anon_sym_LT_LT_LT] = ACTIONS(2062),
    [sym__special_characters] = ACTIONS(3267),
    [anon_sym_DQUOTE] = ACTIONS(3183),
    [anon_sym_DOLLAR] = ACTIONS(3186),
    [sym_raw_string] = ACTIONS(3270),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3192),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3195),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [anon_sym_LT_LPAREN] = ACTIONS(3201),
    [anon_sym_GT_LPAREN] = ACTIONS(3201),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3273),
  },
  [978] = {
    [sym_file_redirect] = STATE(1431),
    [sym_heredoc_redirect] = STATE(1431),
    [sym_heredoc_body] = STATE(1412),
    [sym_herestring_redirect] = STATE(1431),
    [sym_concatenation] = STATE(977),
    [sym_string] = STATE(523),
    [sym_simple_expansion] = STATE(523),
    [sym_string_expansion] = STATE(523),
    [sym_expansion] = STATE(523),
    [sym_command_substitution] = STATE(523),
    [sym_process_substitution] = STATE(523),
    [aux_sym_while_statement_repeat1] = STATE(1431),
    [aux_sym_command_repeat2] = STATE(977),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_PIPE_AMP] = ACTIONS(2080),
    [anon_sym_AMP_AMP] = ACTIONS(2080),
    [anon_sym_PIPE_PIPE] = ACTIONS(2080),
    [anon_sym_EQ_TILDE] = ACTIONS(931),
    [anon_sym_EQ_EQ] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(933),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(937),
    [sym__special_characters] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(941),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(2080),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(943),
  },
  [979] = {
    [sym_file_redirect] = STATE(1432),
    [sym_file_descriptor] = ACTIONS(1243),
    [anon_sym_PIPE] = ACTIONS(2376),
    [anon_sym_SEMI_SEMI] = ACTIONS(2376),
    [anon_sym_PIPE_AMP] = ACTIONS(2376),
    [anon_sym_AMP_AMP] = ACTIONS(2376),
    [anon_sym_PIPE_PIPE] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(1247),
    [anon_sym_GT] = ACTIONS(1247),
    [anon_sym_GT_GT] = ACTIONS(1247),
    [anon_sym_AMP_GT] = ACTIONS(1247),
    [anon_sym_AMP_GT_GT] = ACTIONS(1247),
    [anon_sym_LT_AMP] = ACTIONS(1247),
    [anon_sym_GT_AMP] = ACTIONS(1247),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2376),
    [anon_sym_LF] = ACTIONS(2378),
    [anon_sym_AMP] = ACTIONS(2376),
  },
  [980] = {
    [sym__heredoc_body_middle] = ACTIONS(727),
    [sym__heredoc_body_end] = ACTIONS(727),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(727),
    [sym_comment] = ACTIONS(53),
  },
  [981] = {
    [sym__heredoc_body_middle] = ACTIONS(735),
    [sym__heredoc_body_end] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
  },
  [982] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(3276),
    [sym_comment] = ACTIONS(53),
  },
  [983] = {
    [sym_concatenation] = STATE(1436),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1436),
    [anon_sym_RBRACE] = ACTIONS(3278),
    [anon_sym_EQ] = ACTIONS(3280),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3284),
    [anon_sym_COLON] = ACTIONS(3280),
    [anon_sym_COLON_QMARK] = ACTIONS(3280),
    [anon_sym_COLON_DASH] = ACTIONS(3280),
    [anon_sym_PERCENT] = ACTIONS(3280),
    [anon_sym_DASH] = ACTIONS(3280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [984] = {
    [sym_subscript] = STATE(1440),
    [sym_variable_name] = ACTIONS(3286),
    [anon_sym_DOLLAR] = ACTIONS(3288),
    [anon_sym_DASH] = ACTIONS(3288),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3290),
    [anon_sym_STAR] = ACTIONS(3288),
    [anon_sym_AT] = ACTIONS(3288),
    [anon_sym_QMARK] = ACTIONS(3288),
    [anon_sym_0] = ACTIONS(3292),
    [anon_sym__] = ACTIONS(3292),
  },
  [985] = {
    [sym_concatenation] = STATE(1443),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1443),
    [anon_sym_RBRACE] = ACTIONS(3294),
    [anon_sym_EQ] = ACTIONS(3296),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3298),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3300),
    [anon_sym_COLON] = ACTIONS(3296),
    [anon_sym_COLON_QMARK] = ACTIONS(3296),
    [anon_sym_COLON_DASH] = ACTIONS(3296),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [986] = {
    [sym_concatenation] = STATE(1446),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1446),
    [anon_sym_RBRACE] = ACTIONS(3302),
    [anon_sym_EQ] = ACTIONS(3304),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3308),
    [anon_sym_COLON] = ACTIONS(3304),
    [anon_sym_COLON_QMARK] = ACTIONS(3304),
    [anon_sym_COLON_DASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [987] = {
    [anon_sym_esac] = ACTIONS(3310),
    [anon_sym_PIPE] = ACTIONS(3310),
    [anon_sym_RPAREN] = ACTIONS(3310),
    [anon_sym_SEMI_SEMI] = ACTIONS(3310),
    [anon_sym_PIPE_AMP] = ACTIONS(3310),
    [anon_sym_AMP_AMP] = ACTIONS(3310),
    [anon_sym_PIPE_PIPE] = ACTIONS(3310),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3310),
    [anon_sym_LF] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3310),
  },
  [988] = {
    [sym_simple_expansion] = STATE(988),
    [sym_expansion] = STATE(988),
    [aux_sym_heredoc_body_repeat1] = STATE(988),
    [sym__heredoc_body_middle] = ACTIONS(3314),
    [sym__heredoc_body_end] = ACTIONS(3317),
    [anon_sym_DOLLAR] = ACTIONS(3319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3322),
    [sym_comment] = ACTIONS(53),
  },
  [989] = {
    [aux_sym_concatenation_repeat1] = STATE(992),
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [990] = {
    [aux_sym_concatenation_repeat1] = STATE(992),
    [sym__simple_heredoc_body] = ACTIONS(1093),
    [sym__heredoc_body_beginning] = ACTIONS(1093),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [991] = {
    [sym__simple_heredoc_body] = ACTIONS(1093),
    [sym__heredoc_body_beginning] = ACTIONS(1093),
    [sym_file_descriptor] = ACTIONS(1093),
    [anon_sym_esac] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [992] = {
    [aux_sym_concatenation_repeat1] = STATE(1447),
    [sym__simple_heredoc_body] = ACTIONS(693),
    [sym__heredoc_body_beginning] = ACTIONS(693),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [993] = {
    [anon_sym_esac] = ACTIONS(3325),
    [anon_sym_PIPE] = ACTIONS(3325),
    [anon_sym_RPAREN] = ACTIONS(3325),
    [anon_sym_SEMI_SEMI] = ACTIONS(3325),
    [anon_sym_PIPE_AMP] = ACTIONS(3325),
    [anon_sym_AMP_AMP] = ACTIONS(3325),
    [anon_sym_PIPE_PIPE] = ACTIONS(3325),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3325),
    [anon_sym_LF] = ACTIONS(3327),
    [anon_sym_AMP] = ACTIONS(3325),
  },
  [994] = {
    [sym_file_redirect] = STATE(549),
    [sym_heredoc_redirect] = STATE(549),
    [sym_heredoc_body] = STATE(1448),
    [sym_herestring_redirect] = STATE(549),
    [aux_sym_while_statement_repeat1] = STATE(549),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(3325),
    [anon_sym_SEMI_SEMI] = ACTIONS(3325),
    [anon_sym_PIPE_AMP] = ACTIONS(3325),
    [anon_sym_AMP_AMP] = ACTIONS(3325),
    [anon_sym_PIPE_PIPE] = ACTIONS(3325),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(347),
    [anon_sym_AMP_GT] = ACTIONS(347),
    [anon_sym_AMP_GT_GT] = ACTIONS(347),
    [anon_sym_LT_AMP] = ACTIONS(347),
    [anon_sym_GT_AMP] = ACTIONS(347),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(351),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3325),
    [anon_sym_LF] = ACTIONS(3327),
    [anon_sym_AMP] = ACTIONS(3325),
  },
  [995] = {
    [sym__concat] = ACTIONS(3329),
    [anon_sym_EQ] = ACTIONS(3331),
    [anon_sym_PLUS_EQ] = ACTIONS(3331),
    [sym_comment] = ACTIONS(53),
  },
  [996] = {
    [anon_sym_EQ] = ACTIONS(3331),
    [anon_sym_PLUS_EQ] = ACTIONS(3331),
    [sym_comment] = ACTIONS(53),
  },
  [997] = {
    [aux_sym_concatenation_repeat1] = STATE(997),
    [sym__concat] = ACTIONS(2447),
    [anon_sym_RBRACK] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
  },
  [998] = {
    [sym__concat] = ACTIONS(3333),
    [anon_sym_EQ] = ACTIONS(3335),
    [anon_sym_PLUS_EQ] = ACTIONS(3335),
    [sym_comment] = ACTIONS(53),
  },
  [999] = {
    [anon_sym_EQ] = ACTIONS(3335),
    [anon_sym_PLUS_EQ] = ACTIONS(3335),
    [sym_comment] = ACTIONS(53),
  },
  [1000] = {
    [sym_string] = STATE(1451),
    [sym_simple_expansion] = STATE(1451),
    [sym_string_expansion] = STATE(1451),
    [sym_expansion] = STATE(1451),
    [sym_command_substitution] = STATE(1451),
    [sym_process_substitution] = STATE(1451),
    [sym__special_characters] = ACTIONS(3337),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(3337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3337),
  },
  [1001] = {
    [aux_sym_concatenation_repeat1] = STATE(1452),
    [sym__concat] = ACTIONS(2143),
    [anon_sym_RPAREN] = ACTIONS(693),
    [sym__special_characters] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(693),
  },
  [1002] = {
    [sym__concat] = ACTIONS(697),
    [anon_sym_RPAREN] = ACTIONS(697),
    [sym__special_characters] = ACTIONS(697),
    [anon_sym_DQUOTE] = ACTIONS(697),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [anon_sym_LT_LPAREN] = ACTIONS(697),
    [anon_sym_GT_LPAREN] = ACTIONS(697),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(697),
  },
  [1003] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(3339),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [1004] = {
    [sym__concat] = ACTIONS(727),
    [anon_sym_RPAREN] = ACTIONS(727),
    [sym__special_characters] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(727),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(727),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(727),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(727),
    [anon_sym_BQUOTE] = ACTIONS(727),
    [anon_sym_LT_LPAREN] = ACTIONS(727),
    [anon_sym_GT_LPAREN] = ACTIONS(727),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(727),
  },
  [1005] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(731),
    [sym__special_characters] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(731),
  },
  [1006] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(735),
    [sym__special_characters] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(735),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [anon_sym_LT_LPAREN] = ACTIONS(735),
    [anon_sym_GT_LPAREN] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(735),
  },
  [1007] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(3341),
    [sym_comment] = ACTIONS(53),
  },
  [1008] = {
    [sym_concatenation] = STATE(1457),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1457),
    [anon_sym_RBRACE] = ACTIONS(3343),
    [anon_sym_EQ] = ACTIONS(3345),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3347),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3349),
    [anon_sym_COLON] = ACTIONS(3345),
    [anon_sym_COLON_QMARK] = ACTIONS(3345),
    [anon_sym_COLON_DASH] = ACTIONS(3345),
    [anon_sym_PERCENT] = ACTIONS(3345),
    [anon_sym_DASH] = ACTIONS(3345),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1009] = {
    [sym_subscript] = STATE(1461),
    [sym_variable_name] = ACTIONS(3351),
    [anon_sym_DOLLAR] = ACTIONS(3353),
    [anon_sym_DASH] = ACTIONS(3353),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3355),
    [anon_sym_STAR] = ACTIONS(3353),
    [anon_sym_AT] = ACTIONS(3353),
    [anon_sym_QMARK] = ACTIONS(3353),
    [anon_sym_0] = ACTIONS(3357),
    [anon_sym__] = ACTIONS(3357),
  },
  [1010] = {
    [sym_concatenation] = STATE(1464),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1464),
    [anon_sym_RBRACE] = ACTIONS(3359),
    [anon_sym_EQ] = ACTIONS(3361),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3363),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3365),
    [anon_sym_COLON] = ACTIONS(3361),
    [anon_sym_COLON_QMARK] = ACTIONS(3361),
    [anon_sym_COLON_DASH] = ACTIONS(3361),
    [anon_sym_PERCENT] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1011] = {
    [sym_concatenation] = STATE(1467),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1467),
    [anon_sym_RBRACE] = ACTIONS(3367),
    [anon_sym_EQ] = ACTIONS(3369),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3373),
    [anon_sym_COLON] = ACTIONS(3369),
    [anon_sym_COLON_QMARK] = ACTIONS(3369),
    [anon_sym_COLON_DASH] = ACTIONS(3369),
    [anon_sym_PERCENT] = ACTIONS(3369),
    [anon_sym_DASH] = ACTIONS(3369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1012] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3375),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [1013] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3375),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [1014] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(3375),
    [sym_comment] = ACTIONS(53),
  },
  [1015] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(3375),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [1016] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3377),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [1017] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3377),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [1018] = {
    [sym_file_descriptor] = ACTIONS(3379),
    [sym_variable_name] = ACTIONS(3379),
    [anon_sym_PIPE] = ACTIONS(3381),
    [anon_sym_RPAREN] = ACTIONS(3381),
    [anon_sym_SEMI_SEMI] = ACTIONS(3381),
    [anon_sym_PIPE_AMP] = ACTIONS(3381),
    [anon_sym_AMP_AMP] = ACTIONS(3381),
    [anon_sym_PIPE_PIPE] = ACTIONS(3381),
    [anon_sym_LT] = ACTIONS(3381),
    [anon_sym_GT] = ACTIONS(3381),
    [anon_sym_GT_GT] = ACTIONS(3381),
    [anon_sym_AMP_GT] = ACTIONS(3381),
    [anon_sym_AMP_GT_GT] = ACTIONS(3381),
    [anon_sym_LT_AMP] = ACTIONS(3381),
    [anon_sym_GT_AMP] = ACTIONS(3381),
    [sym__special_characters] = ACTIONS(3381),
    [anon_sym_DQUOTE] = ACTIONS(3381),
    [anon_sym_DOLLAR] = ACTIONS(3381),
    [sym_raw_string] = ACTIONS(3381),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3381),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3381),
    [anon_sym_BQUOTE] = ACTIONS(3381),
    [anon_sym_LT_LPAREN] = ACTIONS(3381),
    [anon_sym_GT_LPAREN] = ACTIONS(3381),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3381),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym_LF] = ACTIONS(3379),
    [anon_sym_AMP] = ACTIONS(3381),
  },
  [1019] = {
    [sym_concatenation] = STATE(1019),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(1019),
    [anon_sym_RPAREN] = ACTIONS(3383),
    [sym__special_characters] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(3388),
    [anon_sym_DOLLAR] = ACTIONS(3391),
    [sym_raw_string] = ACTIONS(3394),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3397),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3400),
    [anon_sym_BQUOTE] = ACTIONS(3403),
    [anon_sym_LT_LPAREN] = ACTIONS(3406),
    [anon_sym_GT_LPAREN] = ACTIONS(3406),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3394),
  },
  [1020] = {
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(1654),
    [sym_variable_name] = ACTIONS(1654),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1656),
    [anon_sym_LT_AMP] = ACTIONS(1656),
    [anon_sym_GT_AMP] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LT_LPAREN] = ACTIONS(1656),
    [anon_sym_GT_LPAREN] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [1021] = {
    [aux_sym_concatenation_repeat1] = STATE(1021),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(3409),
    [sym_variable_name] = ACTIONS(1654),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1656),
    [anon_sym_LT_AMP] = ACTIONS(1656),
    [anon_sym_GT_AMP] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LT_LPAREN] = ACTIONS(1656),
    [anon_sym_GT_LPAREN] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [1022] = {
    [sym_file_descriptor] = ACTIONS(1703),
    [sym__concat] = ACTIONS(1703),
    [sym_variable_name] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_RPAREN] = ACTIONS(1705),
    [anon_sym_SEMI_SEMI] = ACTIONS(1705),
    [anon_sym_PIPE_AMP] = ACTIONS(1705),
    [anon_sym_AMP_AMP] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1705),
    [anon_sym_GT] = ACTIONS(1705),
    [anon_sym_GT_GT] = ACTIONS(1705),
    [anon_sym_AMP_GT] = ACTIONS(1705),
    [anon_sym_AMP_GT_GT] = ACTIONS(1705),
    [anon_sym_LT_AMP] = ACTIONS(1705),
    [anon_sym_GT_AMP] = ACTIONS(1705),
    [sym__special_characters] = ACTIONS(1705),
    [anon_sym_DQUOTE] = ACTIONS(1705),
    [anon_sym_DOLLAR] = ACTIONS(1705),
    [sym_raw_string] = ACTIONS(1705),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1705),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1705),
    [anon_sym_BQUOTE] = ACTIONS(1705),
    [anon_sym_LT_LPAREN] = ACTIONS(1705),
    [anon_sym_GT_LPAREN] = ACTIONS(1705),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1705),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_LF] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1705),
  },
  [1023] = {
    [sym_concatenation] = STATE(1473),
    [sym_string] = STATE(1472),
    [sym_simple_expansion] = STATE(1472),
    [sym_string_expansion] = STATE(1472),
    [sym_expansion] = STATE(1472),
    [sym_command_substitution] = STATE(1472),
    [sym_process_substitution] = STATE(1472),
    [anon_sym_RBRACE] = ACTIONS(3412),
    [sym__special_characters] = ACTIONS(3414),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(3416),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3416),
  },
  [1024] = {
    [sym_file_descriptor] = ACTIONS(1744),
    [sym__concat] = ACTIONS(1744),
    [sym_variable_name] = ACTIONS(1744),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_RPAREN] = ACTIONS(1746),
    [anon_sym_SEMI_SEMI] = ACTIONS(1746),
    [anon_sym_PIPE_AMP] = ACTIONS(1746),
    [anon_sym_AMP_AMP] = ACTIONS(1746),
    [anon_sym_PIPE_PIPE] = ACTIONS(1746),
    [anon_sym_LT] = ACTIONS(1746),
    [anon_sym_GT] = ACTIONS(1746),
    [anon_sym_GT_GT] = ACTIONS(1746),
    [anon_sym_AMP_GT] = ACTIONS(1746),
    [anon_sym_AMP_GT_GT] = ACTIONS(1746),
    [anon_sym_LT_AMP] = ACTIONS(1746),
    [anon_sym_GT_AMP] = ACTIONS(1746),
    [sym__special_characters] = ACTIONS(1746),
    [anon_sym_DQUOTE] = ACTIONS(1746),
    [anon_sym_DOLLAR] = ACTIONS(1746),
    [sym_raw_string] = ACTIONS(1746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1746),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1746),
    [anon_sym_GT_LPAREN] = ACTIONS(1746),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1746),
    [anon_sym_SEMI] = ACTIONS(1746),
    [anon_sym_LF] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(1746),
  },
  [1025] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3418),
  },
  [1026] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3420),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1027] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(3422),
    [sym_comment] = ACTIONS(53),
  },
  [1028] = {
    [sym_concatenation] = STATE(1479),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1479),
    [anon_sym_RBRACE] = ACTIONS(3424),
    [anon_sym_EQ] = ACTIONS(3426),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3428),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3430),
    [anon_sym_COLON] = ACTIONS(3426),
    [anon_sym_COLON_QMARK] = ACTIONS(3426),
    [anon_sym_COLON_DASH] = ACTIONS(3426),
    [anon_sym_PERCENT] = ACTIONS(3426),
    [anon_sym_DASH] = ACTIONS(3426),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1029] = {
    [sym_concatenation] = STATE(1482),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1482),
    [anon_sym_RBRACE] = ACTIONS(3432),
    [anon_sym_EQ] = ACTIONS(3434),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3436),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3438),
    [anon_sym_COLON] = ACTIONS(3434),
    [anon_sym_COLON_QMARK] = ACTIONS(3434),
    [anon_sym_COLON_DASH] = ACTIONS(3434),
    [anon_sym_PERCENT] = ACTIONS(3434),
    [anon_sym_DASH] = ACTIONS(3434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1030] = {
    [sym_concatenation] = STATE(1484),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1484),
    [anon_sym_RBRACE] = ACTIONS(3412),
    [anon_sym_EQ] = ACTIONS(3440),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(3440),
    [anon_sym_COLON_QMARK] = ACTIONS(3440),
    [anon_sym_COLON_DASH] = ACTIONS(3440),
    [anon_sym_PERCENT] = ACTIONS(3440),
    [anon_sym_DASH] = ACTIONS(3440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1031] = {
    [sym_file_descriptor] = ACTIONS(1810),
    [sym__concat] = ACTIONS(1810),
    [sym_variable_name] = ACTIONS(1810),
    [anon_sym_PIPE] = ACTIONS(1812),
    [anon_sym_RPAREN] = ACTIONS(1812),
    [anon_sym_SEMI_SEMI] = ACTIONS(1812),
    [anon_sym_PIPE_AMP] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1812),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [anon_sym_LT] = ACTIONS(1812),
    [anon_sym_GT] = ACTIONS(1812),
    [anon_sym_GT_GT] = ACTIONS(1812),
    [anon_sym_AMP_GT] = ACTIONS(1812),
    [anon_sym_AMP_GT_GT] = ACTIONS(1812),
    [anon_sym_LT_AMP] = ACTIONS(1812),
    [anon_sym_GT_AMP] = ACTIONS(1812),
    [sym__special_characters] = ACTIONS(1812),
    [anon_sym_DQUOTE] = ACTIONS(1812),
    [anon_sym_DOLLAR] = ACTIONS(1812),
    [sym_raw_string] = ACTIONS(1812),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1812),
    [anon_sym_GT_LPAREN] = ACTIONS(1812),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1812),
    [anon_sym_SEMI] = ACTIONS(1812),
    [anon_sym_LF] = ACTIONS(1810),
    [anon_sym_AMP] = ACTIONS(1812),
  },
  [1032] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3446),
  },
  [1033] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3448),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1034] = {
    [sym_file_descriptor] = ACTIONS(1818),
    [sym__concat] = ACTIONS(1818),
    [sym_variable_name] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1820),
    [anon_sym_RPAREN] = ACTIONS(1820),
    [anon_sym_SEMI_SEMI] = ACTIONS(1820),
    [anon_sym_PIPE_AMP] = ACTIONS(1820),
    [anon_sym_AMP_AMP] = ACTIONS(1820),
    [anon_sym_PIPE_PIPE] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1820),
    [anon_sym_GT] = ACTIONS(1820),
    [anon_sym_GT_GT] = ACTIONS(1820),
    [anon_sym_AMP_GT] = ACTIONS(1820),
    [anon_sym_AMP_GT_GT] = ACTIONS(1820),
    [anon_sym_LT_AMP] = ACTIONS(1820),
    [anon_sym_GT_AMP] = ACTIONS(1820),
    [sym__special_characters] = ACTIONS(1820),
    [anon_sym_DQUOTE] = ACTIONS(1820),
    [anon_sym_DOLLAR] = ACTIONS(1820),
    [sym_raw_string] = ACTIONS(1820),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1820),
    [anon_sym_BQUOTE] = ACTIONS(1820),
    [anon_sym_LT_LPAREN] = ACTIONS(1820),
    [anon_sym_GT_LPAREN] = ACTIONS(1820),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1820),
    [anon_sym_LF] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1820),
  },
  [1035] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3450),
  },
  [1036] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3412),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1037] = {
    [sym_file_descriptor] = ACTIONS(1952),
    [sym__concat] = ACTIONS(1952),
    [sym_variable_name] = ACTIONS(1952),
    [anon_sym_PIPE] = ACTIONS(1954),
    [anon_sym_RPAREN] = ACTIONS(1954),
    [anon_sym_SEMI_SEMI] = ACTIONS(1954),
    [anon_sym_PIPE_AMP] = ACTIONS(1954),
    [anon_sym_AMP_AMP] = ACTIONS(1954),
    [anon_sym_PIPE_PIPE] = ACTIONS(1954),
    [anon_sym_LT] = ACTIONS(1954),
    [anon_sym_GT] = ACTIONS(1954),
    [anon_sym_GT_GT] = ACTIONS(1954),
    [anon_sym_AMP_GT] = ACTIONS(1954),
    [anon_sym_AMP_GT_GT] = ACTIONS(1954),
    [anon_sym_LT_AMP] = ACTIONS(1954),
    [anon_sym_GT_AMP] = ACTIONS(1954),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1954),
    [anon_sym_DOLLAR] = ACTIONS(1954),
    [sym_raw_string] = ACTIONS(1954),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1954),
    [anon_sym_BQUOTE] = ACTIONS(1954),
    [anon_sym_LT_LPAREN] = ACTIONS(1954),
    [anon_sym_GT_LPAREN] = ACTIONS(1954),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1954),
    [anon_sym_SEMI] = ACTIONS(1954),
    [anon_sym_LF] = ACTIONS(1952),
    [anon_sym_AMP] = ACTIONS(1954),
  },
  [1038] = {
    [sym_file_descriptor] = ACTIONS(2018),
    [sym__concat] = ACTIONS(2018),
    [sym_variable_name] = ACTIONS(2018),
    [anon_sym_PIPE] = ACTIONS(2020),
    [anon_sym_RPAREN] = ACTIONS(2020),
    [anon_sym_SEMI_SEMI] = ACTIONS(2020),
    [anon_sym_PIPE_AMP] = ACTIONS(2020),
    [anon_sym_AMP_AMP] = ACTIONS(2020),
    [anon_sym_PIPE_PIPE] = ACTIONS(2020),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(2020),
    [anon_sym_GT_GT] = ACTIONS(2020),
    [anon_sym_AMP_GT] = ACTIONS(2020),
    [anon_sym_AMP_GT_GT] = ACTIONS(2020),
    [anon_sym_LT_AMP] = ACTIONS(2020),
    [anon_sym_GT_AMP] = ACTIONS(2020),
    [sym__special_characters] = ACTIONS(2020),
    [anon_sym_DQUOTE] = ACTIONS(2020),
    [anon_sym_DOLLAR] = ACTIONS(2020),
    [sym_raw_string] = ACTIONS(2020),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2020),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2020),
    [anon_sym_BQUOTE] = ACTIONS(2020),
    [anon_sym_LT_LPAREN] = ACTIONS(2020),
    [anon_sym_GT_LPAREN] = ACTIONS(2020),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2020),
    [anon_sym_SEMI] = ACTIONS(2020),
    [anon_sym_LF] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2020),
  },
  [1039] = {
    [sym_string] = STATE(1488),
    [sym_simple_expansion] = STATE(1488),
    [sym_string_expansion] = STATE(1488),
    [sym_expansion] = STATE(1488),
    [sym_command_substitution] = STATE(1488),
    [sym_process_substitution] = STATE(1488),
    [sym__special_characters] = ACTIONS(3452),
    [anon_sym_DQUOTE] = ACTIONS(1157),
    [anon_sym_DOLLAR] = ACTIONS(1159),
    [sym_raw_string] = ACTIONS(3452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1163),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1165),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [anon_sym_LT_LPAREN] = ACTIONS(1169),
    [anon_sym_GT_LPAREN] = ACTIONS(1169),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3452),
  },
  [1040] = {
    [aux_sym_concatenation_repeat1] = STATE(1489),
    [sym__concat] = ACTIONS(2217),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [1041] = {
    [sym__concat] = ACTIONS(697),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_LF] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [1042] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(3454),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [1043] = {
    [sym__concat] = ACTIONS(727),
    [anon_sym_SEMI_SEMI] = ACTIONS(729),
    [sym__special_characters] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(729),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(729),
    [anon_sym_BQUOTE] = ACTIONS(729),
    [anon_sym_LT_LPAREN] = ACTIONS(729),
    [anon_sym_GT_LPAREN] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(729),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_LF] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
  },
  [1044] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [sym__special_characters] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [anon_sym_LT_LPAREN] = ACTIONS(733),
    [anon_sym_GT_LPAREN] = ACTIONS(733),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [1045] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_SEMI_SEMI] = ACTIONS(737),
    [sym__special_characters] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [anon_sym_LT_LPAREN] = ACTIONS(737),
    [anon_sym_GT_LPAREN] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [1046] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(3456),
    [sym_comment] = ACTIONS(53),
  },
  [1047] = {
    [sym_concatenation] = STATE(1494),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1494),
    [anon_sym_RBRACE] = ACTIONS(3458),
    [anon_sym_EQ] = ACTIONS(3460),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3464),
    [anon_sym_COLON] = ACTIONS(3460),
    [anon_sym_COLON_QMARK] = ACTIONS(3460),
    [anon_sym_COLON_DASH] = ACTIONS(3460),
    [anon_sym_PERCENT] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3460),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1048] = {
    [sym_subscript] = STATE(1498),
    [sym_variable_name] = ACTIONS(3466),
    [anon_sym_DOLLAR] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3468),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3470),
    [anon_sym_STAR] = ACTIONS(3468),
    [anon_sym_AT] = ACTIONS(3468),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_0] = ACTIONS(3472),
    [anon_sym__] = ACTIONS(3472),
  },
  [1049] = {
    [sym_concatenation] = STATE(1501),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1501),
    [anon_sym_RBRACE] = ACTIONS(3474),
    [anon_sym_EQ] = ACTIONS(3476),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3478),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3480),
    [anon_sym_COLON] = ACTIONS(3476),
    [anon_sym_COLON_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_DASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1050] = {
    [sym_concatenation] = STATE(1504),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1504),
    [anon_sym_RBRACE] = ACTIONS(3482),
    [anon_sym_EQ] = ACTIONS(3484),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3486),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3488),
    [anon_sym_COLON] = ACTIONS(3484),
    [anon_sym_COLON_QMARK] = ACTIONS(3484),
    [anon_sym_COLON_DASH] = ACTIONS(3484),
    [anon_sym_PERCENT] = ACTIONS(3484),
    [anon_sym_DASH] = ACTIONS(3484),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1051] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3490),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [1052] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3490),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [1053] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(3490),
    [sym_comment] = ACTIONS(53),
  },
  [1054] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(3490),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [1055] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3492),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [1056] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3492),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [1057] = {
    [sym_do_group] = STATE(1507),
    [anon_sym_do] = ACTIONS(1171),
    [sym_comment] = ACTIONS(53),
  },
  [1058] = {
    [sym_concatenation] = STATE(1058),
    [sym_string] = STATE(590),
    [sym_simple_expansion] = STATE(590),
    [sym_string_expansion] = STATE(590),
    [sym_expansion] = STATE(590),
    [sym_command_substitution] = STATE(590),
    [sym_process_substitution] = STATE(590),
    [aux_sym_for_statement_repeat1] = STATE(1058),
    [anon_sym_SEMI_SEMI] = ACTIONS(3494),
    [sym__special_characters] = ACTIONS(3496),
    [anon_sym_DQUOTE] = ACTIONS(3499),
    [anon_sym_DOLLAR] = ACTIONS(3502),
    [sym_raw_string] = ACTIONS(3505),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3511),
    [anon_sym_BQUOTE] = ACTIONS(3514),
    [anon_sym_LT_LPAREN] = ACTIONS(3517),
    [anon_sym_GT_LPAREN] = ACTIONS(3517),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3494),
    [anon_sym_LF] = ACTIONS(3383),
    [anon_sym_AMP] = ACTIONS(3494),
  },
  [1059] = {
    [anon_sym_esac] = ACTIONS(2265),
    [anon_sym_PIPE] = ACTIONS(2265),
    [anon_sym_RPAREN] = ACTIONS(2265),
    [anon_sym_SEMI_SEMI] = ACTIONS(2265),
    [anon_sym_PIPE_AMP] = ACTIONS(2265),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym_PIPE_PIPE] = ACTIONS(2265),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2265),
    [anon_sym_LF] = ACTIONS(2263),
    [anon_sym_AMP] = ACTIONS(2265),
  },
  [1060] = {
    [sym__terminated_statement] = STATE(1063),
    [sym_for_statement] = STATE(599),
    [sym_while_statement] = STATE(599),
    [sym_if_statement] = STATE(599),
    [sym_case_statement] = STATE(599),
    [sym_function_definition] = STATE(599),
    [sym_subshell] = STATE(599),
    [sym_pipeline] = STATE(599),
    [sym_list] = STATE(599),
    [sym_negated_command] = STATE(599),
    [sym_test_command] = STATE(599),
    [sym_declaration_command] = STATE(599),
    [sym_unset_command] = STATE(599),
    [sym_command] = STATE(599),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(600),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1063),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_done] = ACTIONS(3520),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1061] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_done] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(953),
    [anon_sym_DQUOTE] = ACTIONS(951),
    [anon_sym_DOLLAR] = ACTIONS(953),
    [sym_raw_string] = ACTIONS(951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(951),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(951),
    [anon_sym_BQUOTE] = ACTIONS(951),
    [anon_sym_LT_LPAREN] = ACTIONS(951),
    [anon_sym_GT_LPAREN] = ACTIONS(951),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(953),
  },
  [1062] = {
    [sym__simple_heredoc_body] = ACTIONS(3522),
    [sym__heredoc_body_beginning] = ACTIONS(3522),
    [sym_file_descriptor] = ACTIONS(3522),
    [anon_sym_esac] = ACTIONS(3524),
    [anon_sym_PIPE] = ACTIONS(3524),
    [anon_sym_RPAREN] = ACTIONS(3524),
    [anon_sym_SEMI_SEMI] = ACTIONS(3524),
    [anon_sym_PIPE_AMP] = ACTIONS(3524),
    [anon_sym_AMP_AMP] = ACTIONS(3524),
    [anon_sym_PIPE_PIPE] = ACTIONS(3524),
    [anon_sym_LT] = ACTIONS(3524),
    [anon_sym_GT] = ACTIONS(3524),
    [anon_sym_GT_GT] = ACTIONS(3524),
    [anon_sym_AMP_GT] = ACTIONS(3524),
    [anon_sym_AMP_GT_GT] = ACTIONS(3524),
    [anon_sym_LT_AMP] = ACTIONS(3524),
    [anon_sym_GT_AMP] = ACTIONS(3524),
    [anon_sym_LT_LT] = ACTIONS(3524),
    [anon_sym_LT_LT_DASH] = ACTIONS(3524),
    [anon_sym_LT_LT_LT] = ACTIONS(3524),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3524),
    [anon_sym_LF] = ACTIONS(3522),
    [anon_sym_AMP] = ACTIONS(3524),
  },
  [1063] = {
    [sym__terminated_statement] = STATE(1063),
    [sym_for_statement] = STATE(599),
    [sym_while_statement] = STATE(599),
    [sym_if_statement] = STATE(599),
    [sym_case_statement] = STATE(599),
    [sym_function_definition] = STATE(599),
    [sym_subshell] = STATE(599),
    [sym_pipeline] = STATE(599),
    [sym_list] = STATE(599),
    [sym_negated_command] = STATE(599),
    [sym_test_command] = STATE(599),
    [sym_declaration_command] = STATE(599),
    [sym_unset_command] = STATE(599),
    [sym_command] = STATE(599),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(600),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1063),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(999),
    [sym_variable_name] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1010),
    [anon_sym_done] = ACTIONS(3526),
    [anon_sym_if] = ACTIONS(1013),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1031),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_typeset] = ACTIONS(1034),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_local] = ACTIONS(1034),
    [anon_sym_unset] = ACTIONS(1037),
    [anon_sym_unsetenv] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_GT_GT] = ACTIONS(1043),
    [anon_sym_AMP_GT] = ACTIONS(1040),
    [anon_sym_AMP_GT_GT] = ACTIONS(1043),
    [anon_sym_LT_AMP] = ACTIONS(1043),
    [anon_sym_GT_AMP] = ACTIONS(1043),
    [sym__special_characters] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [sym_raw_string] = ACTIONS(1055),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1064),
    [anon_sym_LT_LPAREN] = ACTIONS(1067),
    [anon_sym_GT_LPAREN] = ACTIONS(1067),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1070),
  },
  [1064] = {
    [anon_sym_esac] = ACTIONS(3528),
    [anon_sym_PIPE] = ACTIONS(3528),
    [anon_sym_RPAREN] = ACTIONS(3528),
    [anon_sym_SEMI_SEMI] = ACTIONS(3528),
    [anon_sym_PIPE_AMP] = ACTIONS(3528),
    [anon_sym_AMP_AMP] = ACTIONS(3528),
    [anon_sym_PIPE_PIPE] = ACTIONS(3528),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3528),
    [anon_sym_LF] = ACTIONS(3530),
    [anon_sym_AMP] = ACTIONS(3528),
  },
  [1065] = {
    [anon_sym_then] = ACTIONS(3532),
    [sym_comment] = ACTIONS(53),
  },
  [1066] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(3534),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3534),
    [anon_sym_LF] = ACTIONS(3536),
    [anon_sym_AMP] = ACTIONS(3534),
  },
  [1067] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(3534),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(3534),
    [anon_sym_LF] = ACTIONS(3536),
    [anon_sym_AMP] = ACTIONS(3534),
  },
  [1068] = {
    [sym__terminated_statement] = STATE(1511),
    [sym_for_statement] = STATE(1066),
    [sym_while_statement] = STATE(1066),
    [sym_if_statement] = STATE(1066),
    [sym_case_statement] = STATE(1066),
    [sym_function_definition] = STATE(1066),
    [sym_subshell] = STATE(1066),
    [sym_pipeline] = STATE(1066),
    [sym_list] = STATE(1066),
    [sym_negated_command] = STATE(1066),
    [sym_test_command] = STATE(1066),
    [sym_declaration_command] = STATE(1066),
    [sym_unset_command] = STATE(1066),
    [sym_command] = STATE(1066),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(1067),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1511),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(3538),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1069] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_fi] = ACTIONS(953),
    [anon_sym_elif] = ACTIONS(953),
    [anon_sym_else] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(953),
    [anon_sym_DQUOTE] = ACTIONS(951),
    [anon_sym_DOLLAR] = ACTIONS(953),
    [sym_raw_string] = ACTIONS(951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(951),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(951),
    [anon_sym_BQUOTE] = ACTIONS(951),
    [anon_sym_LT_LPAREN] = ACTIONS(951),
    [anon_sym_GT_LPAREN] = ACTIONS(951),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(953),
  },
  [1070] = {
    [anon_sym_esac] = ACTIONS(3540),
    [anon_sym_PIPE] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(3540),
    [anon_sym_SEMI_SEMI] = ACTIONS(3540),
    [anon_sym_PIPE_AMP] = ACTIONS(3540),
    [anon_sym_AMP_AMP] = ACTIONS(3540),
    [anon_sym_PIPE_PIPE] = ACTIONS(3540),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3540),
    [anon_sym_LF] = ACTIONS(3542),
    [anon_sym_AMP] = ACTIONS(3540),
  },
  [1071] = {
    [anon_sym_fi] = ACTIONS(3544),
    [sym_comment] = ACTIONS(53),
  },
  [1072] = {
    [sym__terminated_statement] = STATE(1072),
    [sym_for_statement] = STATE(607),
    [sym_while_statement] = STATE(607),
    [sym_if_statement] = STATE(607),
    [sym_case_statement] = STATE(607),
    [sym_function_definition] = STATE(607),
    [sym_subshell] = STATE(607),
    [sym_pipeline] = STATE(607),
    [sym_list] = STATE(607),
    [sym_negated_command] = STATE(607),
    [sym_test_command] = STATE(607),
    [sym_declaration_command] = STATE(607),
    [sym_unset_command] = STATE(607),
    [sym_command] = STATE(607),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(610),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1072),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(999),
    [sym_variable_name] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1010),
    [anon_sym_if] = ACTIONS(1013),
    [anon_sym_fi] = ACTIONS(3526),
    [anon_sym_elif] = ACTIONS(3526),
    [anon_sym_else] = ACTIONS(3526),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1031),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_typeset] = ACTIONS(1034),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_local] = ACTIONS(1034),
    [anon_sym_unset] = ACTIONS(1037),
    [anon_sym_unsetenv] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_GT_GT] = ACTIONS(1043),
    [anon_sym_AMP_GT] = ACTIONS(1040),
    [anon_sym_AMP_GT_GT] = ACTIONS(1043),
    [anon_sym_LT_AMP] = ACTIONS(1043),
    [anon_sym_GT_AMP] = ACTIONS(1043),
    [sym__special_characters] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [sym_raw_string] = ACTIONS(1055),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1064),
    [anon_sym_LT_LPAREN] = ACTIONS(1067),
    [anon_sym_GT_LPAREN] = ACTIONS(1067),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1070),
  },
  [1073] = {
    [sym_elif_clause] = STATE(608),
    [sym_else_clause] = STATE(1513),
    [aux_sym_if_statement_repeat1] = STATE(1074),
    [anon_sym_fi] = ACTIONS(3544),
    [anon_sym_elif] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2295),
    [sym_comment] = ACTIONS(53),
  },
  [1074] = {
    [sym_elif_clause] = STATE(608),
    [aux_sym_if_statement_repeat1] = STATE(1074),
    [anon_sym_fi] = ACTIONS(3546),
    [anon_sym_elif] = ACTIONS(3548),
    [anon_sym_else] = ACTIONS(3546),
    [sym_comment] = ACTIONS(53),
  },
  [1075] = {
    [anon_sym_esac] = ACTIONS(3551),
    [anon_sym_PIPE] = ACTIONS(3551),
    [anon_sym_RPAREN] = ACTIONS(3551),
    [anon_sym_SEMI_SEMI] = ACTIONS(3551),
    [anon_sym_PIPE_AMP] = ACTIONS(3551),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3551),
    [anon_sym_LF] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3551),
  },
  [1076] = {
    [aux_sym_case_item_repeat1] = STATE(1516),
    [aux_sym_concatenation_repeat1] = STATE(1517),
    [sym__concat] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(3555),
    [anon_sym_RPAREN] = ACTIONS(3557),
    [sym_comment] = ACTIONS(53),
  },
  [1077] = {
    [aux_sym_case_item_repeat1] = STATE(1519),
    [aux_sym_concatenation_repeat1] = STATE(1517),
    [sym__concat] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(3555),
    [anon_sym_RPAREN] = ACTIONS(3559),
    [sym_comment] = ACTIONS(53),
  },
  [1078] = {
    [anon_sym_esac] = ACTIONS(3561),
    [sym_comment] = ACTIONS(53),
  },
  [1079] = {
    [aux_sym_case_item_repeat1] = STATE(1519),
    [anon_sym_PIPE] = ACTIONS(3555),
    [anon_sym_RPAREN] = ACTIONS(3559),
    [sym_comment] = ACTIONS(53),
  },
  [1080] = {
    [sym_case_item] = STATE(1522),
    [sym_last_case_item] = STATE(1521),
    [sym_concatenation] = STATE(1079),
    [sym_string] = STATE(1077),
    [sym_simple_expansion] = STATE(1077),
    [sym_string_expansion] = STATE(1077),
    [sym_expansion] = STATE(1077),
    [sym_command_substitution] = STATE(1077),
    [sym_process_substitution] = STATE(1077),
    [aux_sym_case_statement_repeat1] = STATE(1522),
    [sym__special_characters] = ACTIONS(2299),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2301),
  },
  [1081] = {
    [sym_case_item] = STATE(1524),
    [sym_last_case_item] = STATE(1521),
    [sym_concatenation] = STATE(1079),
    [sym_string] = STATE(1077),
    [sym_simple_expansion] = STATE(1077),
    [sym_string_expansion] = STATE(1077),
    [sym_expansion] = STATE(1077),
    [sym_command_substitution] = STATE(1077),
    [sym_process_substitution] = STATE(1077),
    [aux_sym_case_statement_repeat1] = STATE(1524),
    [anon_sym_esac] = ACTIONS(3563),
    [sym__special_characters] = ACTIONS(2299),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2303),
  },
  [1082] = {
    [anon_sym_esac] = ACTIONS(3565),
    [anon_sym_PIPE] = ACTIONS(3565),
    [anon_sym_RPAREN] = ACTIONS(3565),
    [anon_sym_SEMI_SEMI] = ACTIONS(3565),
    [anon_sym_PIPE_AMP] = ACTIONS(3565),
    [anon_sym_AMP_AMP] = ACTIONS(3565),
    [anon_sym_PIPE_PIPE] = ACTIONS(3565),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3565),
    [anon_sym_LF] = ACTIONS(3567),
    [anon_sym_AMP] = ACTIONS(3565),
  },
  [1083] = {
    [anon_sym_esac] = ACTIONS(3569),
    [sym_comment] = ACTIONS(53),
  },
  [1084] = {
    [sym_case_item] = STATE(1522),
    [sym_last_case_item] = STATE(1526),
    [sym_concatenation] = STATE(1079),
    [sym_string] = STATE(1077),
    [sym_simple_expansion] = STATE(1077),
    [sym_string_expansion] = STATE(1077),
    [sym_expansion] = STATE(1077),
    [sym_command_substitution] = STATE(1077),
    [sym_process_substitution] = STATE(1077),
    [aux_sym_case_statement_repeat1] = STATE(1522),
    [sym__special_characters] = ACTIONS(2299),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2301),
  },
  [1085] = {
    [sym_case_item] = STATE(1528),
    [sym_last_case_item] = STATE(1526),
    [sym_concatenation] = STATE(1079),
    [sym_string] = STATE(1077),
    [sym_simple_expansion] = STATE(1077),
    [sym_string_expansion] = STATE(1077),
    [sym_expansion] = STATE(1077),
    [sym_command_substitution] = STATE(1077),
    [sym_process_substitution] = STATE(1077),
    [aux_sym_case_statement_repeat1] = STATE(1528),
    [anon_sym_esac] = ACTIONS(3571),
    [sym__special_characters] = ACTIONS(2299),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2303),
  },
  [1086] = {
    [sym__concat] = ACTIONS(2752),
    [anon_sym_in] = ACTIONS(2754),
    [anon_sym_SEMI_SEMI] = ACTIONS(2754),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_LF] = ACTIONS(2752),
    [anon_sym_AMP] = ACTIONS(2754),
  },
  [1087] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(3573),
    [sym_comment] = ACTIONS(53),
  },
  [1088] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(3575),
    [sym_comment] = ACTIONS(53),
  },
  [1089] = {
    [anon_sym_RBRACE] = ACTIONS(3575),
    [sym_comment] = ACTIONS(53),
  },
  [1090] = {
    [sym_concatenation] = STATE(1532),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1532),
    [anon_sym_RBRACE] = ACTIONS(3577),
    [anon_sym_EQ] = ACTIONS(3579),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3579),
    [anon_sym_COLON_QMARK] = ACTIONS(3579),
    [anon_sym_COLON_DASH] = ACTIONS(3579),
    [anon_sym_PERCENT] = ACTIONS(3579),
    [anon_sym_DASH] = ACTIONS(3579),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1091] = {
    [sym__concat] = ACTIONS(2830),
    [anon_sym_in] = ACTIONS(2832),
    [anon_sym_SEMI_SEMI] = ACTIONS(2832),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2832),
    [anon_sym_LF] = ACTIONS(2830),
    [anon_sym_AMP] = ACTIONS(2832),
  },
  [1092] = {
    [sym_concatenation] = STATE(1535),
    [sym_string] = STATE(1534),
    [sym_simple_expansion] = STATE(1534),
    [sym_string_expansion] = STATE(1534),
    [sym_expansion] = STATE(1534),
    [sym_command_substitution] = STATE(1534),
    [sym_process_substitution] = STATE(1534),
    [anon_sym_RBRACE] = ACTIONS(3575),
    [sym__special_characters] = ACTIONS(3583),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(3585),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3585),
  },
  [1093] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_in] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [1094] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3587),
  },
  [1095] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3589),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1096] = {
    [sym__concat] = ACTIONS(2881),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_SEMI_SEMI] = ACTIONS(2883),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_LF] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
  },
  [1097] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3591),
  },
  [1098] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3593),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1099] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3595),
  },
  [1100] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3575),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1101] = {
    [sym_concatenation] = STATE(1542),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1542),
    [anon_sym_RBRACE] = ACTIONS(3597),
    [anon_sym_EQ] = ACTIONS(3599),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3601),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3599),
    [anon_sym_COLON_QMARK] = ACTIONS(3599),
    [anon_sym_COLON_DASH] = ACTIONS(3599),
    [anon_sym_PERCENT] = ACTIONS(3599),
    [anon_sym_DASH] = ACTIONS(3599),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1102] = {
    [sym__concat] = ACTIONS(2897),
    [anon_sym_in] = ACTIONS(2899),
    [anon_sym_SEMI_SEMI] = ACTIONS(2899),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LF] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2899),
  },
  [1103] = {
    [sym_concatenation] = STATE(1544),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1544),
    [anon_sym_RBRACE] = ACTIONS(3603),
    [anon_sym_EQ] = ACTIONS(3605),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3607),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3605),
    [anon_sym_COLON_QMARK] = ACTIONS(3605),
    [anon_sym_COLON_DASH] = ACTIONS(3605),
    [anon_sym_PERCENT] = ACTIONS(3605),
    [anon_sym_DASH] = ACTIONS(3605),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1104] = {
    [sym_file_redirect] = STATE(1545),
    [sym_file_descriptor] = ACTIONS(1243),
    [anon_sym_PIPE] = ACTIONS(3609),
    [anon_sym_SEMI_SEMI] = ACTIONS(3609),
    [anon_sym_PIPE_AMP] = ACTIONS(3609),
    [anon_sym_AMP_AMP] = ACTIONS(3609),
    [anon_sym_PIPE_PIPE] = ACTIONS(3609),
    [anon_sym_LT] = ACTIONS(1247),
    [anon_sym_GT] = ACTIONS(1247),
    [anon_sym_GT_GT] = ACTIONS(1247),
    [anon_sym_AMP_GT] = ACTIONS(1247),
    [anon_sym_AMP_GT_GT] = ACTIONS(1247),
    [anon_sym_LT_AMP] = ACTIONS(1247),
    [anon_sym_GT_AMP] = ACTIONS(1247),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3609),
    [anon_sym_LF] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3609),
  },
  [1105] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_RBRACE] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(953),
    [anon_sym_DQUOTE] = ACTIONS(951),
    [anon_sym_DOLLAR] = ACTIONS(953),
    [sym_raw_string] = ACTIONS(951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(951),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(951),
    [anon_sym_BQUOTE] = ACTIONS(951),
    [anon_sym_LT_LPAREN] = ACTIONS(951),
    [anon_sym_GT_LPAREN] = ACTIONS(951),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(953),
  },
  [1106] = {
    [sym_file_descriptor] = ACTIONS(3613),
    [anon_sym_esac] = ACTIONS(3615),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_RPAREN] = ACTIONS(3615),
    [anon_sym_SEMI_SEMI] = ACTIONS(3615),
    [anon_sym_PIPE_AMP] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(3615),
    [anon_sym_PIPE_PIPE] = ACTIONS(3615),
    [anon_sym_LT] = ACTIONS(3615),
    [anon_sym_GT] = ACTIONS(3615),
    [anon_sym_GT_GT] = ACTIONS(3615),
    [anon_sym_AMP_GT] = ACTIONS(3615),
    [anon_sym_AMP_GT_GT] = ACTIONS(3615),
    [anon_sym_LT_AMP] = ACTIONS(3615),
    [anon_sym_GT_AMP] = ACTIONS(3615),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3615),
    [anon_sym_LF] = ACTIONS(3613),
    [anon_sym_AMP] = ACTIONS(3615),
  },
  [1107] = {
    [sym__terminated_statement] = STATE(1107),
    [sym_for_statement] = STATE(638),
    [sym_while_statement] = STATE(638),
    [sym_if_statement] = STATE(638),
    [sym_case_statement] = STATE(638),
    [sym_function_definition] = STATE(638),
    [sym_subshell] = STATE(638),
    [sym_pipeline] = STATE(638),
    [sym_list] = STATE(638),
    [sym_negated_command] = STATE(638),
    [sym_test_command] = STATE(638),
    [sym_declaration_command] = STATE(638),
    [sym_unset_command] = STATE(638),
    [sym_command] = STATE(638),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(639),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1107),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(999),
    [sym_variable_name] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1010),
    [anon_sym_if] = ACTIONS(1013),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [anon_sym_RBRACE] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1031),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_typeset] = ACTIONS(1034),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_local] = ACTIONS(1034),
    [anon_sym_unset] = ACTIONS(1037),
    [anon_sym_unsetenv] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_GT_GT] = ACTIONS(1043),
    [anon_sym_AMP_GT] = ACTIONS(1040),
    [anon_sym_AMP_GT_GT] = ACTIONS(1043),
    [anon_sym_LT_AMP] = ACTIONS(1043),
    [anon_sym_GT_AMP] = ACTIONS(1043),
    [sym__special_characters] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [sym_raw_string] = ACTIONS(1055),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1064),
    [anon_sym_LT_LPAREN] = ACTIONS(1067),
    [anon_sym_GT_LPAREN] = ACTIONS(1067),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1070),
  },
  [1108] = {
    [sym_concatenation] = STATE(1548),
    [sym_string] = STATE(1547),
    [sym_simple_expansion] = STATE(1547),
    [sym_string_expansion] = STATE(1547),
    [sym_expansion] = STATE(1547),
    [sym_command_substitution] = STATE(1547),
    [sym_process_substitution] = STATE(1547),
    [sym__special_characters] = ACTIONS(3617),
    [anon_sym_DQUOTE] = ACTIONS(629),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(3619),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1533),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1535),
    [anon_sym_BQUOTE] = ACTIONS(1537),
    [anon_sym_LT_LPAREN] = ACTIONS(1539),
    [anon_sym_GT_LPAREN] = ACTIONS(1539),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3619),
  },
  [1109] = {
    [aux_sym_concatenation_repeat1] = STATE(1549),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(665),
    [anon_sym_AMP_AMP] = ACTIONS(665),
    [anon_sym_PIPE_PIPE] = ACTIONS(665),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [1110] = {
    [aux_sym_concatenation_repeat1] = STATE(1549),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [1111] = {
    [anon_sym_esac] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [1112] = {
    [aux_sym_concatenation_repeat1] = STATE(1550),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(1131),
    [sym_variable_name] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [1113] = {
    [sym_file_redirect] = STATE(667),
    [sym_heredoc_redirect] = STATE(667),
    [sym_heredoc_body] = STATE(1064),
    [sym_herestring_redirect] = STATE(667),
    [aux_sym_while_statement_repeat1] = STATE(667),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(2273),
    [anon_sym_RPAREN] = ACTIONS(2273),
    [anon_sym_SEMI_SEMI] = ACTIONS(2273),
    [anon_sym_PIPE_AMP] = ACTIONS(2273),
    [anon_sym_AMP_AMP] = ACTIONS(2273),
    [anon_sym_PIPE_PIPE] = ACTIONS(2273),
    [anon_sym_LT] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(487),
    [anon_sym_GT_GT] = ACTIONS(487),
    [anon_sym_AMP_GT] = ACTIONS(487),
    [anon_sym_AMP_GT_GT] = ACTIONS(487),
    [anon_sym_LT_AMP] = ACTIONS(487),
    [anon_sym_GT_AMP] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(489),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2273),
    [anon_sym_LF] = ACTIONS(2275),
    [anon_sym_AMP] = ACTIONS(2273),
  },
  [1114] = {
    [sym_compound_statement] = STATE(1551),
    [anon_sym_LBRACE] = ACTIONS(455),
    [sym_comment] = ACTIONS(53),
  },
  [1115] = {
    [anon_sym_LT] = ACTIONS(3621),
    [anon_sym_GT] = ACTIONS(3621),
    [anon_sym_GT_GT] = ACTIONS(3623),
    [anon_sym_AMP_GT] = ACTIONS(3621),
    [anon_sym_AMP_GT_GT] = ACTIONS(3623),
    [anon_sym_LT_AMP] = ACTIONS(3623),
    [anon_sym_GT_AMP] = ACTIONS(3623),
    [sym_comment] = ACTIONS(53),
  },
  [1116] = {
    [sym_concatenation] = STATE(1111),
    [sym_string] = STATE(1554),
    [sym_simple_expansion] = STATE(1554),
    [sym_string_expansion] = STATE(1554),
    [sym_expansion] = STATE(1554),
    [sym_command_substitution] = STATE(1554),
    [sym_process_substitution] = STATE(1554),
    [sym__special_characters] = ACTIONS(3625),
    [anon_sym_DQUOTE] = ACTIONS(629),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(3627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1533),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1535),
    [anon_sym_BQUOTE] = ACTIONS(1537),
    [anon_sym_LT_LPAREN] = ACTIONS(1539),
    [anon_sym_GT_LPAREN] = ACTIONS(1539),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3627),
  },
  [1117] = {
    [anon_sym_LT] = ACTIONS(3629),
    [anon_sym_GT] = ACTIONS(3629),
    [anon_sym_GT_GT] = ACTIONS(3631),
    [anon_sym_AMP_GT] = ACTIONS(3629),
    [anon_sym_AMP_GT_GT] = ACTIONS(3631),
    [anon_sym_LT_AMP] = ACTIONS(3631),
    [anon_sym_GT_AMP] = ACTIONS(3631),
    [sym_comment] = ACTIONS(53),
  },
  [1118] = {
    [sym_concatenation] = STATE(1161),
    [sym_string] = STATE(1557),
    [sym_simple_expansion] = STATE(1557),
    [sym_string_expansion] = STATE(1557),
    [sym_expansion] = STATE(1557),
    [sym_command_substitution] = STATE(1557),
    [sym_process_substitution] = STATE(1557),
    [sym__special_characters] = ACTIONS(3633),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(3635),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2508),
    [anon_sym_BQUOTE] = ACTIONS(2510),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3635),
  },
  [1119] = {
    [sym_concatenation] = STATE(1165),
    [sym_string] = STATE(1559),
    [sym_simple_expansion] = STATE(1559),
    [sym_string_expansion] = STATE(1559),
    [sym_expansion] = STATE(1559),
    [sym_command_substitution] = STATE(1559),
    [sym_process_substitution] = STATE(1559),
    [sym__special_characters] = ACTIONS(3637),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(3639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2508),
    [anon_sym_BQUOTE] = ACTIONS(2510),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3639),
  },
  [1120] = {
    [sym_file_redirect] = STATE(1560),
    [sym_heredoc_redirect] = STATE(1560),
    [sym_herestring_redirect] = STATE(1560),
    [aux_sym_while_statement_repeat1] = STATE(1560),
    [sym_file_descriptor] = ACTIONS(2386),
    [anon_sym_PIPE] = ACTIONS(2520),
    [anon_sym_RPAREN] = ACTIONS(2520),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2388),
    [anon_sym_GT] = ACTIONS(2388),
    [anon_sym_GT_GT] = ACTIONS(2388),
    [anon_sym_AMP_GT] = ACTIONS(2388),
    [anon_sym_AMP_GT_GT] = ACTIONS(2388),
    [anon_sym_LT_AMP] = ACTIONS(2388),
    [anon_sym_GT_AMP] = ACTIONS(2388),
    [anon_sym_LT_LT] = ACTIONS(1357),
    [anon_sym_LT_LT_DASH] = ACTIONS(1357),
    [anon_sym_LT_LT_LT] = ACTIONS(2390),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2520),
    [anon_sym_LF] = ACTIONS(2522),
    [anon_sym_AMP] = ACTIONS(2520),
  },
  [1121] = {
    [aux_sym_concatenation_repeat1] = STATE(651),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(1133),
    [anon_sym_SEMI_SEMI] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [sym__special_characters] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1133),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1133),
    [sym_word] = ACTIONS(1133),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_LF] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1133),
  },
  [1122] = {
    [aux_sym_concatenation_repeat1] = STATE(651),
    [sym__concat] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [sym__special_characters] = ACTIONS(1109),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1109),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_LT_LPAREN] = ACTIONS(1109),
    [anon_sym_GT_LPAREN] = ACTIONS(1109),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1109),
    [sym_word] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1109),
  },
  [1123] = {
    [aux_sym_concatenation_repeat1] = STATE(1123),
    [sym__concat] = ACTIONS(2569),
    [sym_variable_name] = ACTIONS(1654),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LT_LPAREN] = ACTIONS(1656),
    [anon_sym_GT_LPAREN] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1656),
    [sym_word] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [1124] = {
    [aux_sym_concatenation_repeat1] = STATE(1124),
    [sym__concat] = ACTIONS(2612),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LT_LPAREN] = ACTIONS(1656),
    [anon_sym_GT_LPAREN] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1656),
    [sym_word] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [1125] = {
    [sym_file_redirect] = STATE(1432),
    [sym_file_descriptor] = ACTIONS(2382),
    [anon_sym_PIPE] = ACTIONS(2376),
    [anon_sym_RPAREN] = ACTIONS(2376),
    [anon_sym_SEMI_SEMI] = ACTIONS(2376),
    [anon_sym_PIPE_AMP] = ACTIONS(2376),
    [anon_sym_AMP_AMP] = ACTIONS(2376),
    [anon_sym_PIPE_PIPE] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(2384),
    [anon_sym_GT] = ACTIONS(2384),
    [anon_sym_GT_GT] = ACTIONS(2384),
    [anon_sym_AMP_GT] = ACTIONS(2384),
    [anon_sym_AMP_GT_GT] = ACTIONS(2384),
    [anon_sym_LT_AMP] = ACTIONS(2384),
    [anon_sym_GT_AMP] = ACTIONS(2384),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2376),
    [anon_sym_LF] = ACTIONS(2378),
    [anon_sym_AMP] = ACTIONS(2376),
  },
  [1126] = {
    [aux_sym_concatenation_repeat1] = STATE(1128),
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [1127] = {
    [aux_sym_concatenation_repeat1] = STATE(1128),
    [sym__simple_heredoc_body] = ACTIONS(1093),
    [sym__heredoc_body_beginning] = ACTIONS(1093),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [1128] = {
    [aux_sym_concatenation_repeat1] = STATE(1561),
    [sym__simple_heredoc_body] = ACTIONS(693),
    [sym__heredoc_body_beginning] = ACTIONS(693),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(223),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [1129] = {
    [anon_sym_esac] = ACTIONS(3641),
    [anon_sym_PIPE] = ACTIONS(3641),
    [anon_sym_RPAREN] = ACTIONS(3641),
    [anon_sym_SEMI_SEMI] = ACTIONS(3641),
    [anon_sym_PIPE_AMP] = ACTIONS(3641),
    [anon_sym_AMP_AMP] = ACTIONS(3641),
    [anon_sym_PIPE_PIPE] = ACTIONS(3641),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3641),
    [anon_sym_LF] = ACTIONS(3643),
    [anon_sym_AMP] = ACTIONS(3641),
  },
  [1130] = {
    [sym_file_redirect] = STATE(667),
    [sym_heredoc_redirect] = STATE(667),
    [sym_heredoc_body] = STATE(1448),
    [sym_herestring_redirect] = STATE(667),
    [aux_sym_while_statement_repeat1] = STATE(667),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(3325),
    [anon_sym_RPAREN] = ACTIONS(3325),
    [anon_sym_SEMI_SEMI] = ACTIONS(3325),
    [anon_sym_PIPE_AMP] = ACTIONS(3325),
    [anon_sym_AMP_AMP] = ACTIONS(3325),
    [anon_sym_PIPE_PIPE] = ACTIONS(3325),
    [anon_sym_LT] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(487),
    [anon_sym_GT_GT] = ACTIONS(487),
    [anon_sym_AMP_GT] = ACTIONS(487),
    [anon_sym_AMP_GT_GT] = ACTIONS(487),
    [anon_sym_LT_AMP] = ACTIONS(487),
    [anon_sym_GT_AMP] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(489),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3325),
    [anon_sym_LF] = ACTIONS(3327),
    [anon_sym_AMP] = ACTIONS(3325),
  },
  [1131] = {
    [sym_file_descriptor] = ACTIONS(2139),
    [sym_variable_name] = ACTIONS(2139),
    [anon_sym_PIPE] = ACTIONS(2141),
    [anon_sym_RPAREN] = ACTIONS(2139),
    [anon_sym_PIPE_AMP] = ACTIONS(2139),
    [anon_sym_AMP_AMP] = ACTIONS(2139),
    [anon_sym_PIPE_PIPE] = ACTIONS(2139),
    [anon_sym_LT] = ACTIONS(2141),
    [anon_sym_GT] = ACTIONS(2141),
    [anon_sym_GT_GT] = ACTIONS(2139),
    [anon_sym_AMP_GT] = ACTIONS(2141),
    [anon_sym_AMP_GT_GT] = ACTIONS(2139),
    [anon_sym_LT_AMP] = ACTIONS(2139),
    [anon_sym_GT_AMP] = ACTIONS(2139),
    [sym__special_characters] = ACTIONS(2139),
    [anon_sym_DQUOTE] = ACTIONS(2139),
    [anon_sym_DOLLAR] = ACTIONS(2141),
    [sym_raw_string] = ACTIONS(2139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2139),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2139),
    [anon_sym_BQUOTE] = ACTIONS(2139),
    [anon_sym_LT_LPAREN] = ACTIONS(2139),
    [anon_sym_GT_LPAREN] = ACTIONS(2139),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2139),
  },
  [1132] = {
    [sym_concatenation] = STATE(1019),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(1019),
    [anon_sym_RPAREN] = ACTIONS(3645),
    [sym__special_characters] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1119),
  },
  [1133] = {
    [aux_sym_concatenation_repeat1] = STATE(1133),
    [sym__concat] = ACTIONS(2524),
    [anon_sym_RPAREN] = ACTIONS(1654),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [anon_sym_EQ_TILDE] = ACTIONS(1654),
    [anon_sym_EQ_EQ] = ACTIONS(1654),
    [anon_sym_EQ] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1654),
    [anon_sym_GT] = ACTIONS(1654),
    [anon_sym_BANG_EQ] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1654),
  },
  [1134] = {
    [sym__concat] = ACTIONS(2752),
    [anon_sym_AMP_AMP] = ACTIONS(2752),
    [anon_sym_PIPE_PIPE] = ACTIONS(2752),
    [anon_sym_RBRACK] = ACTIONS(2752),
    [anon_sym_EQ_TILDE] = ACTIONS(2752),
    [anon_sym_EQ_EQ] = ACTIONS(2752),
    [anon_sym_EQ] = ACTIONS(2754),
    [anon_sym_LT] = ACTIONS(2752),
    [anon_sym_GT] = ACTIONS(2752),
    [anon_sym_BANG_EQ] = ACTIONS(2752),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2752),
  },
  [1135] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(3647),
    [sym_comment] = ACTIONS(53),
  },
  [1136] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(3649),
    [sym_comment] = ACTIONS(53),
  },
  [1137] = {
    [anon_sym_RBRACE] = ACTIONS(3649),
    [sym_comment] = ACTIONS(53),
  },
  [1138] = {
    [sym_concatenation] = STATE(1566),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1566),
    [anon_sym_RBRACE] = ACTIONS(3651),
    [anon_sym_EQ] = ACTIONS(3653),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3655),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3653),
    [anon_sym_COLON_QMARK] = ACTIONS(3653),
    [anon_sym_COLON_DASH] = ACTIONS(3653),
    [anon_sym_PERCENT] = ACTIONS(3653),
    [anon_sym_DASH] = ACTIONS(3653),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1139] = {
    [sym__concat] = ACTIONS(2830),
    [anon_sym_AMP_AMP] = ACTIONS(2830),
    [anon_sym_PIPE_PIPE] = ACTIONS(2830),
    [anon_sym_RBRACK] = ACTIONS(2830),
    [anon_sym_EQ_TILDE] = ACTIONS(2830),
    [anon_sym_EQ_EQ] = ACTIONS(2830),
    [anon_sym_EQ] = ACTIONS(2832),
    [anon_sym_LT] = ACTIONS(2830),
    [anon_sym_GT] = ACTIONS(2830),
    [anon_sym_BANG_EQ] = ACTIONS(2830),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2830),
  },
  [1140] = {
    [sym_concatenation] = STATE(1569),
    [sym_string] = STATE(1568),
    [sym_simple_expansion] = STATE(1568),
    [sym_string_expansion] = STATE(1568),
    [sym_expansion] = STATE(1568),
    [sym_command_substitution] = STATE(1568),
    [sym_process_substitution] = STATE(1568),
    [anon_sym_RBRACE] = ACTIONS(3649),
    [sym__special_characters] = ACTIONS(3657),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(3659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3659),
  },
  [1141] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_RBRACK] = ACTIONS(2873),
    [anon_sym_EQ_TILDE] = ACTIONS(2873),
    [anon_sym_EQ_EQ] = ACTIONS(2873),
    [anon_sym_EQ] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2873),
    [anon_sym_GT] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2873),
  },
  [1142] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3661),
  },
  [1143] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3663),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1144] = {
    [sym__concat] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_RBRACK] = ACTIONS(2881),
    [anon_sym_EQ_TILDE] = ACTIONS(2881),
    [anon_sym_EQ_EQ] = ACTIONS(2881),
    [anon_sym_EQ] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2881),
    [anon_sym_GT] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2881),
  },
  [1145] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3665),
  },
  [1146] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3667),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1147] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3669),
  },
  [1148] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3649),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1149] = {
    [sym_concatenation] = STATE(1576),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1576),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_EQ] = ACTIONS(3673),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3673),
    [anon_sym_COLON_QMARK] = ACTIONS(3673),
    [anon_sym_COLON_DASH] = ACTIONS(3673),
    [anon_sym_PERCENT] = ACTIONS(3673),
    [anon_sym_DASH] = ACTIONS(3673),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1150] = {
    [sym__concat] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2897),
    [anon_sym_PIPE_PIPE] = ACTIONS(2897),
    [anon_sym_RBRACK] = ACTIONS(2897),
    [anon_sym_EQ_TILDE] = ACTIONS(2897),
    [anon_sym_EQ_EQ] = ACTIONS(2897),
    [anon_sym_EQ] = ACTIONS(2899),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_GT] = ACTIONS(2897),
    [anon_sym_BANG_EQ] = ACTIONS(2897),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2897),
  },
  [1151] = {
    [sym_concatenation] = STATE(1578),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1578),
    [anon_sym_RBRACE] = ACTIONS(3677),
    [anon_sym_EQ] = ACTIONS(3679),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3679),
    [anon_sym_COLON_QMARK] = ACTIONS(3679),
    [anon_sym_COLON_DASH] = ACTIONS(3679),
    [anon_sym_PERCENT] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3679),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1152] = {
    [sym_concatenation] = STATE(1581),
    [sym_string] = STATE(1580),
    [sym_simple_expansion] = STATE(1580),
    [sym_string_expansion] = STATE(1580),
    [sym_expansion] = STATE(1580),
    [sym_command_substitution] = STATE(1580),
    [sym_process_substitution] = STATE(1580),
    [sym__special_characters] = ACTIONS(3683),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(3685),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2508),
    [anon_sym_BQUOTE] = ACTIONS(2510),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3685),
  },
  [1153] = {
    [aux_sym_concatenation_repeat1] = STATE(1583),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(3687),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(665),
    [anon_sym_AMP_AMP] = ACTIONS(665),
    [anon_sym_PIPE_PIPE] = ACTIONS(665),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(665),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(665),
    [anon_sym_LT_AMP] = ACTIONS(665),
    [anon_sym_GT_AMP] = ACTIONS(665),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(665),
    [anon_sym_LT_LT_LT] = ACTIONS(665),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [1154] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(1585),
    [anon_sym_DQUOTE] = ACTIONS(3689),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [1155] = {
    [sym_string] = STATE(1587),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(3691),
    [sym_raw_string] = ACTIONS(3693),
    [anon_sym_POUND] = ACTIONS(3691),
    [anon_sym_DASH] = ACTIONS(3691),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3695),
    [anon_sym_STAR] = ACTIONS(3691),
    [anon_sym_AT] = ACTIONS(3691),
    [anon_sym_QMARK] = ACTIONS(3691),
    [anon_sym_0] = ACTIONS(3697),
    [anon_sym__] = ACTIONS(3697),
  },
  [1156] = {
    [aux_sym_concatenation_repeat1] = STATE(1583),
    [sym_file_descriptor] = ACTIONS(677),
    [sym__concat] = ACTIONS(3687),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [1157] = {
    [sym_subscript] = STATE(1593),
    [sym_variable_name] = ACTIONS(3699),
    [anon_sym_DOLLAR] = ACTIONS(3701),
    [anon_sym_POUND] = ACTIONS(3703),
    [anon_sym_DASH] = ACTIONS(3701),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3705),
    [anon_sym_STAR] = ACTIONS(3701),
    [anon_sym_AT] = ACTIONS(3701),
    [anon_sym_QMARK] = ACTIONS(3701),
    [anon_sym_0] = ACTIONS(3707),
    [anon_sym__] = ACTIONS(3707),
  },
  [1158] = {
    [sym_for_statement] = STATE(1594),
    [sym_while_statement] = STATE(1594),
    [sym_if_statement] = STATE(1594),
    [sym_case_statement] = STATE(1594),
    [sym_function_definition] = STATE(1594),
    [sym_subshell] = STATE(1594),
    [sym_pipeline] = STATE(1594),
    [sym_list] = STATE(1594),
    [sym_negated_command] = STATE(1594),
    [sym_test_command] = STATE(1594),
    [sym_declaration_command] = STATE(1594),
    [sym_unset_command] = STATE(1594),
    [sym_command] = STATE(1594),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(1595),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [1159] = {
    [sym_for_statement] = STATE(1596),
    [sym_while_statement] = STATE(1596),
    [sym_if_statement] = STATE(1596),
    [sym_case_statement] = STATE(1596),
    [sym_function_definition] = STATE(1596),
    [sym_subshell] = STATE(1596),
    [sym_pipeline] = STATE(1596),
    [sym_list] = STATE(1596),
    [sym_negated_command] = STATE(1596),
    [sym_test_command] = STATE(1596),
    [sym_declaration_command] = STATE(1596),
    [sym_unset_command] = STATE(1596),
    [sym_command] = STATE(1596),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(1597),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [1160] = {
    [sym_for_statement] = STATE(1598),
    [sym_while_statement] = STATE(1598),
    [sym_if_statement] = STATE(1598),
    [sym_case_statement] = STATE(1598),
    [sym_function_definition] = STATE(1598),
    [sym_subshell] = STATE(1598),
    [sym_pipeline] = STATE(1598),
    [sym_list] = STATE(1598),
    [sym_negated_command] = STATE(1598),
    [sym_test_command] = STATE(1598),
    [sym_declaration_command] = STATE(1598),
    [sym_unset_command] = STATE(1598),
    [sym_command] = STATE(1598),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(1599),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [1161] = {
    [sym_file_descriptor] = ACTIONS(677),
    [anon_sym_esac] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [1162] = {
    [sym_file_descriptor] = ACTIONS(2066),
    [anon_sym_esac] = ACTIONS(2068),
    [anon_sym_PIPE] = ACTIONS(2068),
    [anon_sym_RPAREN] = ACTIONS(2068),
    [anon_sym_SEMI_SEMI] = ACTIONS(2068),
    [anon_sym_PIPE_AMP] = ACTIONS(2068),
    [anon_sym_AMP_AMP] = ACTIONS(2068),
    [anon_sym_PIPE_PIPE] = ACTIONS(2068),
    [anon_sym_LT] = ACTIONS(2068),
    [anon_sym_GT] = ACTIONS(2068),
    [anon_sym_GT_GT] = ACTIONS(2068),
    [anon_sym_AMP_GT] = ACTIONS(2068),
    [anon_sym_AMP_GT_GT] = ACTIONS(2068),
    [anon_sym_LT_AMP] = ACTIONS(2068),
    [anon_sym_GT_AMP] = ACTIONS(2068),
    [anon_sym_LT_LT] = ACTIONS(2068),
    [anon_sym_LT_LT_DASH] = ACTIONS(2068),
    [anon_sym_LT_LT_LT] = ACTIONS(2068),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2068),
    [anon_sym_LF] = ACTIONS(2066),
    [anon_sym_AMP] = ACTIONS(2068),
  },
  [1163] = {
    [aux_sym_concatenation_repeat1] = STATE(1583),
    [sym_file_descriptor] = ACTIONS(2070),
    [sym__concat] = ACTIONS(3687),
    [anon_sym_PIPE] = ACTIONS(2072),
    [anon_sym_SEMI_SEMI] = ACTIONS(2072),
    [anon_sym_PIPE_AMP] = ACTIONS(2072),
    [anon_sym_AMP_AMP] = ACTIONS(2072),
    [anon_sym_PIPE_PIPE] = ACTIONS(2072),
    [anon_sym_LT] = ACTIONS(2072),
    [anon_sym_GT] = ACTIONS(2072),
    [anon_sym_GT_GT] = ACTIONS(2072),
    [anon_sym_AMP_GT] = ACTIONS(2072),
    [anon_sym_AMP_GT_GT] = ACTIONS(2072),
    [anon_sym_LT_AMP] = ACTIONS(2072),
    [anon_sym_GT_AMP] = ACTIONS(2072),
    [anon_sym_LT_LT] = ACTIONS(2072),
    [anon_sym_LT_LT_DASH] = ACTIONS(2072),
    [anon_sym_LT_LT_LT] = ACTIONS(2072),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2072),
    [anon_sym_LF] = ACTIONS(2070),
    [anon_sym_AMP] = ACTIONS(2072),
  },
  [1164] = {
    [aux_sym_concatenation_repeat1] = STATE(1583),
    [sym_file_descriptor] = ACTIONS(2074),
    [sym__concat] = ACTIONS(3687),
    [anon_sym_PIPE] = ACTIONS(2076),
    [anon_sym_SEMI_SEMI] = ACTIONS(2076),
    [anon_sym_PIPE_AMP] = ACTIONS(2076),
    [anon_sym_AMP_AMP] = ACTIONS(2076),
    [anon_sym_PIPE_PIPE] = ACTIONS(2076),
    [anon_sym_LT] = ACTIONS(2076),
    [anon_sym_GT] = ACTIONS(2076),
    [anon_sym_GT_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT_GT] = ACTIONS(2076),
    [anon_sym_LT_AMP] = ACTIONS(2076),
    [anon_sym_GT_AMP] = ACTIONS(2076),
    [anon_sym_LT_LT] = ACTIONS(2076),
    [anon_sym_LT_LT_DASH] = ACTIONS(2076),
    [anon_sym_LT_LT_LT] = ACTIONS(2076),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2076),
    [anon_sym_LF] = ACTIONS(2074),
    [anon_sym_AMP] = ACTIONS(2076),
  },
  [1165] = {
    [sym_file_descriptor] = ACTIONS(2074),
    [anon_sym_esac] = ACTIONS(2076),
    [anon_sym_PIPE] = ACTIONS(2076),
    [anon_sym_RPAREN] = ACTIONS(2076),
    [anon_sym_SEMI_SEMI] = ACTIONS(2076),
    [anon_sym_PIPE_AMP] = ACTIONS(2076),
    [anon_sym_AMP_AMP] = ACTIONS(2076),
    [anon_sym_PIPE_PIPE] = ACTIONS(2076),
    [anon_sym_LT] = ACTIONS(2076),
    [anon_sym_GT] = ACTIONS(2076),
    [anon_sym_GT_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT_GT] = ACTIONS(2076),
    [anon_sym_LT_AMP] = ACTIONS(2076),
    [anon_sym_GT_AMP] = ACTIONS(2076),
    [anon_sym_LT_LT] = ACTIONS(2076),
    [anon_sym_LT_LT_DASH] = ACTIONS(2076),
    [anon_sym_LT_LT_LT] = ACTIONS(2076),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2076),
    [anon_sym_LF] = ACTIONS(2074),
    [anon_sym_AMP] = ACTIONS(2076),
  },
  [1166] = {
    [sym_file_redirect] = STATE(1166),
    [sym_heredoc_redirect] = STATE(1166),
    [sym_herestring_redirect] = STATE(1166),
    [aux_sym_while_statement_repeat1] = STATE(1166),
    [sym_file_descriptor] = ACTIONS(3709),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_SEMI_SEMI] = ACTIONS(2087),
    [anon_sym_PIPE_AMP] = ACTIONS(2087),
    [anon_sym_AMP_AMP] = ACTIONS(2087),
    [anon_sym_PIPE_PIPE] = ACTIONS(2087),
    [anon_sym_LT] = ACTIONS(3712),
    [anon_sym_GT] = ACTIONS(3712),
    [anon_sym_GT_GT] = ACTIONS(3712),
    [anon_sym_AMP_GT] = ACTIONS(3712),
    [anon_sym_AMP_GT_GT] = ACTIONS(3712),
    [anon_sym_LT_AMP] = ACTIONS(3712),
    [anon_sym_GT_AMP] = ACTIONS(3712),
    [anon_sym_LT_LT] = ACTIONS(3715),
    [anon_sym_LT_LT_DASH] = ACTIONS(3715),
    [anon_sym_LT_LT_LT] = ACTIONS(3718),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2087),
    [anon_sym_LF] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2087),
  },
  [1167] = {
    [sym__concat] = ACTIONS(2752),
    [anon_sym_PIPE] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(2752),
    [anon_sym_AMP_AMP] = ACTIONS(2752),
    [anon_sym_PIPE_PIPE] = ACTIONS(2752),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2752),
    [anon_sym_EQ_TILDE] = ACTIONS(2752),
    [anon_sym_EQ_EQ] = ACTIONS(2752),
    [anon_sym_EQ] = ACTIONS(2754),
    [anon_sym_LT] = ACTIONS(2752),
    [anon_sym_GT] = ACTIONS(2752),
    [anon_sym_BANG_EQ] = ACTIONS(2752),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2752),
  },
  [1168] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(3721),
    [sym_comment] = ACTIONS(53),
  },
  [1169] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(3723),
    [sym_comment] = ACTIONS(53),
  },
  [1170] = {
    [anon_sym_RBRACE] = ACTIONS(3723),
    [sym_comment] = ACTIONS(53),
  },
  [1171] = {
    [sym_concatenation] = STATE(1603),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1603),
    [anon_sym_RBRACE] = ACTIONS(3725),
    [anon_sym_EQ] = ACTIONS(3727),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3727),
    [anon_sym_COLON_QMARK] = ACTIONS(3727),
    [anon_sym_COLON_DASH] = ACTIONS(3727),
    [anon_sym_PERCENT] = ACTIONS(3727),
    [anon_sym_DASH] = ACTIONS(3727),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1172] = {
    [sym__concat] = ACTIONS(2830),
    [anon_sym_PIPE] = ACTIONS(2832),
    [anon_sym_RPAREN] = ACTIONS(2830),
    [anon_sym_AMP_AMP] = ACTIONS(2830),
    [anon_sym_PIPE_PIPE] = ACTIONS(2830),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2830),
    [anon_sym_EQ_TILDE] = ACTIONS(2830),
    [anon_sym_EQ_EQ] = ACTIONS(2830),
    [anon_sym_EQ] = ACTIONS(2832),
    [anon_sym_LT] = ACTIONS(2830),
    [anon_sym_GT] = ACTIONS(2830),
    [anon_sym_BANG_EQ] = ACTIONS(2830),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2830),
  },
  [1173] = {
    [sym_concatenation] = STATE(1606),
    [sym_string] = STATE(1605),
    [sym_simple_expansion] = STATE(1605),
    [sym_string_expansion] = STATE(1605),
    [sym_expansion] = STATE(1605),
    [sym_command_substitution] = STATE(1605),
    [sym_process_substitution] = STATE(1605),
    [anon_sym_RBRACE] = ACTIONS(3723),
    [sym__special_characters] = ACTIONS(3731),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(3733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3733),
  },
  [1174] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2873),
    [anon_sym_EQ_TILDE] = ACTIONS(2873),
    [anon_sym_EQ_EQ] = ACTIONS(2873),
    [anon_sym_EQ] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2873),
    [anon_sym_GT] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2873),
  },
  [1175] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3735),
  },
  [1176] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3737),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1177] = {
    [sym__concat] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2881),
    [anon_sym_EQ_TILDE] = ACTIONS(2881),
    [anon_sym_EQ_EQ] = ACTIONS(2881),
    [anon_sym_EQ] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2881),
    [anon_sym_GT] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2881),
  },
  [1178] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3739),
  },
  [1179] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3741),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1180] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3743),
  },
  [1181] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3723),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1182] = {
    [sym_concatenation] = STATE(1613),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1613),
    [anon_sym_RBRACE] = ACTIONS(3745),
    [anon_sym_EQ] = ACTIONS(3747),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3749),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3747),
    [anon_sym_COLON_QMARK] = ACTIONS(3747),
    [anon_sym_COLON_DASH] = ACTIONS(3747),
    [anon_sym_PERCENT] = ACTIONS(3747),
    [anon_sym_DASH] = ACTIONS(3747),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1183] = {
    [sym__concat] = ACTIONS(2897),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_RPAREN] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2897),
    [anon_sym_PIPE_PIPE] = ACTIONS(2897),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2897),
    [anon_sym_EQ_TILDE] = ACTIONS(2897),
    [anon_sym_EQ_EQ] = ACTIONS(2897),
    [anon_sym_EQ] = ACTIONS(2899),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_GT] = ACTIONS(2897),
    [anon_sym_BANG_EQ] = ACTIONS(2897),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2897),
  },
  [1184] = {
    [sym_concatenation] = STATE(1615),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1615),
    [anon_sym_RBRACE] = ACTIONS(3751),
    [anon_sym_EQ] = ACTIONS(3753),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3753),
    [anon_sym_COLON_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_DASH] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1185] = {
    [sym_variable_name] = ACTIONS(2139),
    [anon_sym_PIPE] = ACTIONS(2141),
    [anon_sym_RPAREN] = ACTIONS(2141),
    [anon_sym_SEMI_SEMI] = ACTIONS(2141),
    [anon_sym_PIPE_AMP] = ACTIONS(2141),
    [anon_sym_AMP_AMP] = ACTIONS(2141),
    [anon_sym_PIPE_PIPE] = ACTIONS(2141),
    [sym__special_characters] = ACTIONS(2141),
    [anon_sym_DQUOTE] = ACTIONS(2141),
    [anon_sym_DOLLAR] = ACTIONS(2141),
    [sym_raw_string] = ACTIONS(2141),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2141),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2141),
    [anon_sym_BQUOTE] = ACTIONS(2141),
    [anon_sym_LT_LPAREN] = ACTIONS(2141),
    [anon_sym_GT_LPAREN] = ACTIONS(2141),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2141),
    [sym_word] = ACTIONS(2141),
    [anon_sym_SEMI] = ACTIONS(2141),
    [anon_sym_LF] = ACTIONS(2139),
    [anon_sym_AMP] = ACTIONS(2141),
  },
  [1186] = {
    [sym_concatenation] = STATE(1019),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(1019),
    [anon_sym_RPAREN] = ACTIONS(3757),
    [sym__special_characters] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1119),
  },
  [1187] = {
    [sym__concat] = ACTIONS(2752),
    [sym_variable_name] = ACTIONS(2752),
    [anon_sym_PIPE] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(2754),
    [anon_sym_SEMI_SEMI] = ACTIONS(2754),
    [anon_sym_PIPE_AMP] = ACTIONS(2754),
    [anon_sym_AMP_AMP] = ACTIONS(2754),
    [anon_sym_PIPE_PIPE] = ACTIONS(2754),
    [sym__special_characters] = ACTIONS(2754),
    [anon_sym_DQUOTE] = ACTIONS(2754),
    [anon_sym_DOLLAR] = ACTIONS(2754),
    [sym_raw_string] = ACTIONS(2754),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2754),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2754),
    [anon_sym_BQUOTE] = ACTIONS(2754),
    [anon_sym_LT_LPAREN] = ACTIONS(2754),
    [anon_sym_GT_LPAREN] = ACTIONS(2754),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2754),
    [sym_word] = ACTIONS(2754),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_LF] = ACTIONS(2752),
    [anon_sym_AMP] = ACTIONS(2754),
  },
  [1188] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(3759),
    [sym_comment] = ACTIONS(53),
  },
  [1189] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(3761),
    [sym_comment] = ACTIONS(53),
  },
  [1190] = {
    [anon_sym_RBRACE] = ACTIONS(3761),
    [sym_comment] = ACTIONS(53),
  },
  [1191] = {
    [sym_concatenation] = STATE(1620),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1620),
    [anon_sym_RBRACE] = ACTIONS(3763),
    [anon_sym_EQ] = ACTIONS(3765),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3765),
    [anon_sym_COLON_QMARK] = ACTIONS(3765),
    [anon_sym_COLON_DASH] = ACTIONS(3765),
    [anon_sym_PERCENT] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1192] = {
    [sym__concat] = ACTIONS(2830),
    [sym_variable_name] = ACTIONS(2830),
    [anon_sym_PIPE] = ACTIONS(2832),
    [anon_sym_RPAREN] = ACTIONS(2832),
    [anon_sym_SEMI_SEMI] = ACTIONS(2832),
    [anon_sym_PIPE_AMP] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_PIPE_PIPE] = ACTIONS(2832),
    [sym__special_characters] = ACTIONS(2832),
    [anon_sym_DQUOTE] = ACTIONS(2832),
    [anon_sym_DOLLAR] = ACTIONS(2832),
    [sym_raw_string] = ACTIONS(2832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2832),
    [anon_sym_BQUOTE] = ACTIONS(2832),
    [anon_sym_LT_LPAREN] = ACTIONS(2832),
    [anon_sym_GT_LPAREN] = ACTIONS(2832),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2832),
    [sym_word] = ACTIONS(2832),
    [anon_sym_SEMI] = ACTIONS(2832),
    [anon_sym_LF] = ACTIONS(2830),
    [anon_sym_AMP] = ACTIONS(2832),
  },
  [1193] = {
    [sym_concatenation] = STATE(1623),
    [sym_string] = STATE(1622),
    [sym_simple_expansion] = STATE(1622),
    [sym_string_expansion] = STATE(1622),
    [sym_expansion] = STATE(1622),
    [sym_command_substitution] = STATE(1622),
    [sym_process_substitution] = STATE(1622),
    [anon_sym_RBRACE] = ACTIONS(3761),
    [sym__special_characters] = ACTIONS(3769),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(3771),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3771),
  },
  [1194] = {
    [sym__concat] = ACTIONS(2873),
    [sym_variable_name] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [anon_sym_PIPE_AMP] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [sym__special_characters] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2875),
    [anon_sym_BQUOTE] = ACTIONS(2875),
    [anon_sym_LT_LPAREN] = ACTIONS(2875),
    [anon_sym_GT_LPAREN] = ACTIONS(2875),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2875),
    [sym_word] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [1195] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3773),
  },
  [1196] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3775),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1197] = {
    [sym__concat] = ACTIONS(2881),
    [sym_variable_name] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_RPAREN] = ACTIONS(2883),
    [anon_sym_SEMI_SEMI] = ACTIONS(2883),
    [anon_sym_PIPE_AMP] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [sym__special_characters] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [sym_raw_string] = ACTIONS(2883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2883),
    [anon_sym_BQUOTE] = ACTIONS(2883),
    [anon_sym_LT_LPAREN] = ACTIONS(2883),
    [anon_sym_GT_LPAREN] = ACTIONS(2883),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2883),
    [sym_word] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_LF] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
  },
  [1198] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3777),
  },
  [1199] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3779),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1200] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3781),
  },
  [1201] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1202] = {
    [sym_concatenation] = STATE(1630),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1630),
    [anon_sym_RBRACE] = ACTIONS(3783),
    [anon_sym_EQ] = ACTIONS(3785),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3787),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3785),
    [anon_sym_COLON_QMARK] = ACTIONS(3785),
    [anon_sym_COLON_DASH] = ACTIONS(3785),
    [anon_sym_PERCENT] = ACTIONS(3785),
    [anon_sym_DASH] = ACTIONS(3785),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1203] = {
    [sym__concat] = ACTIONS(2897),
    [sym_variable_name] = ACTIONS(2897),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_RPAREN] = ACTIONS(2899),
    [anon_sym_SEMI_SEMI] = ACTIONS(2899),
    [anon_sym_PIPE_AMP] = ACTIONS(2899),
    [anon_sym_AMP_AMP] = ACTIONS(2899),
    [anon_sym_PIPE_PIPE] = ACTIONS(2899),
    [sym__special_characters] = ACTIONS(2899),
    [anon_sym_DQUOTE] = ACTIONS(2899),
    [anon_sym_DOLLAR] = ACTIONS(2899),
    [sym_raw_string] = ACTIONS(2899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2899),
    [anon_sym_BQUOTE] = ACTIONS(2899),
    [anon_sym_LT_LPAREN] = ACTIONS(2899),
    [anon_sym_GT_LPAREN] = ACTIONS(2899),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2899),
    [sym_word] = ACTIONS(2899),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LF] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2899),
  },
  [1204] = {
    [sym_concatenation] = STATE(1632),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1632),
    [anon_sym_RBRACE] = ACTIONS(3789),
    [anon_sym_EQ] = ACTIONS(3791),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3791),
    [anon_sym_COLON_QMARK] = ACTIONS(3791),
    [anon_sym_COLON_DASH] = ACTIONS(3791),
    [anon_sym_PERCENT] = ACTIONS(3791),
    [anon_sym_DASH] = ACTIONS(3791),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1205] = {
    [sym__concat] = ACTIONS(2752),
    [anon_sym_PIPE] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(2754),
    [anon_sym_SEMI_SEMI] = ACTIONS(2754),
    [anon_sym_PIPE_AMP] = ACTIONS(2754),
    [anon_sym_AMP_AMP] = ACTIONS(2754),
    [anon_sym_PIPE_PIPE] = ACTIONS(2754),
    [sym__special_characters] = ACTIONS(2754),
    [anon_sym_DQUOTE] = ACTIONS(2754),
    [anon_sym_DOLLAR] = ACTIONS(2754),
    [sym_raw_string] = ACTIONS(2754),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2754),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2754),
    [anon_sym_BQUOTE] = ACTIONS(2754),
    [anon_sym_LT_LPAREN] = ACTIONS(2754),
    [anon_sym_GT_LPAREN] = ACTIONS(2754),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2754),
    [sym_word] = ACTIONS(2754),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_LF] = ACTIONS(2752),
    [anon_sym_AMP] = ACTIONS(2754),
  },
  [1206] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(3795),
    [sym_comment] = ACTIONS(53),
  },
  [1207] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(3797),
    [sym_comment] = ACTIONS(53),
  },
  [1208] = {
    [anon_sym_RBRACE] = ACTIONS(3797),
    [sym_comment] = ACTIONS(53),
  },
  [1209] = {
    [sym_concatenation] = STATE(1636),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1636),
    [anon_sym_RBRACE] = ACTIONS(3799),
    [anon_sym_EQ] = ACTIONS(3801),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3801),
    [anon_sym_COLON_QMARK] = ACTIONS(3801),
    [anon_sym_COLON_DASH] = ACTIONS(3801),
    [anon_sym_PERCENT] = ACTIONS(3801),
    [anon_sym_DASH] = ACTIONS(3801),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1210] = {
    [sym__concat] = ACTIONS(2830),
    [anon_sym_PIPE] = ACTIONS(2832),
    [anon_sym_RPAREN] = ACTIONS(2832),
    [anon_sym_SEMI_SEMI] = ACTIONS(2832),
    [anon_sym_PIPE_AMP] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_PIPE_PIPE] = ACTIONS(2832),
    [sym__special_characters] = ACTIONS(2832),
    [anon_sym_DQUOTE] = ACTIONS(2832),
    [anon_sym_DOLLAR] = ACTIONS(2832),
    [sym_raw_string] = ACTIONS(2832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2832),
    [anon_sym_BQUOTE] = ACTIONS(2832),
    [anon_sym_LT_LPAREN] = ACTIONS(2832),
    [anon_sym_GT_LPAREN] = ACTIONS(2832),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2832),
    [sym_word] = ACTIONS(2832),
    [anon_sym_SEMI] = ACTIONS(2832),
    [anon_sym_LF] = ACTIONS(2830),
    [anon_sym_AMP] = ACTIONS(2832),
  },
  [1211] = {
    [sym_concatenation] = STATE(1639),
    [sym_string] = STATE(1638),
    [sym_simple_expansion] = STATE(1638),
    [sym_string_expansion] = STATE(1638),
    [sym_expansion] = STATE(1638),
    [sym_command_substitution] = STATE(1638),
    [sym_process_substitution] = STATE(1638),
    [anon_sym_RBRACE] = ACTIONS(3797),
    [sym__special_characters] = ACTIONS(3805),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(3807),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3807),
  },
  [1212] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [anon_sym_PIPE_AMP] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [sym__special_characters] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2875),
    [anon_sym_BQUOTE] = ACTIONS(2875),
    [anon_sym_LT_LPAREN] = ACTIONS(2875),
    [anon_sym_GT_LPAREN] = ACTIONS(2875),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2875),
    [sym_word] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [1213] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3809),
  },
  [1214] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3811),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1215] = {
    [sym__concat] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_RPAREN] = ACTIONS(2883),
    [anon_sym_SEMI_SEMI] = ACTIONS(2883),
    [anon_sym_PIPE_AMP] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [sym__special_characters] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [sym_raw_string] = ACTIONS(2883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2883),
    [anon_sym_BQUOTE] = ACTIONS(2883),
    [anon_sym_LT_LPAREN] = ACTIONS(2883),
    [anon_sym_GT_LPAREN] = ACTIONS(2883),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2883),
    [sym_word] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_LF] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
  },
  [1216] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3813),
  },
  [1217] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3815),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1218] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3817),
  },
  [1219] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3797),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1220] = {
    [sym_concatenation] = STATE(1646),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1646),
    [anon_sym_RBRACE] = ACTIONS(3819),
    [anon_sym_EQ] = ACTIONS(3821),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3823),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3821),
    [anon_sym_COLON_QMARK] = ACTIONS(3821),
    [anon_sym_COLON_DASH] = ACTIONS(3821),
    [anon_sym_PERCENT] = ACTIONS(3821),
    [anon_sym_DASH] = ACTIONS(3821),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1221] = {
    [sym__concat] = ACTIONS(2897),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_RPAREN] = ACTIONS(2899),
    [anon_sym_SEMI_SEMI] = ACTIONS(2899),
    [anon_sym_PIPE_AMP] = ACTIONS(2899),
    [anon_sym_AMP_AMP] = ACTIONS(2899),
    [anon_sym_PIPE_PIPE] = ACTIONS(2899),
    [sym__special_characters] = ACTIONS(2899),
    [anon_sym_DQUOTE] = ACTIONS(2899),
    [anon_sym_DOLLAR] = ACTIONS(2899),
    [sym_raw_string] = ACTIONS(2899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2899),
    [anon_sym_BQUOTE] = ACTIONS(2899),
    [anon_sym_LT_LPAREN] = ACTIONS(2899),
    [anon_sym_GT_LPAREN] = ACTIONS(2899),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2899),
    [sym_word] = ACTIONS(2899),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LF] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2899),
  },
  [1222] = {
    [sym_concatenation] = STATE(1648),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1648),
    [anon_sym_RBRACE] = ACTIONS(3825),
    [anon_sym_EQ] = ACTIONS(3827),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3829),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3827),
    [anon_sym_COLON_QMARK] = ACTIONS(3827),
    [anon_sym_COLON_DASH] = ACTIONS(3827),
    [anon_sym_PERCENT] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3827),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1223] = {
    [sym_file_descriptor] = ACTIONS(2752),
    [sym__concat] = ACTIONS(2752),
    [sym_variable_name] = ACTIONS(2752),
    [anon_sym_PIPE] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(2752),
    [anon_sym_PIPE_AMP] = ACTIONS(2752),
    [anon_sym_AMP_AMP] = ACTIONS(2752),
    [anon_sym_PIPE_PIPE] = ACTIONS(2752),
    [anon_sym_LT] = ACTIONS(2754),
    [anon_sym_GT] = ACTIONS(2754),
    [anon_sym_GT_GT] = ACTIONS(2752),
    [anon_sym_AMP_GT] = ACTIONS(2754),
    [anon_sym_AMP_GT_GT] = ACTIONS(2752),
    [anon_sym_LT_AMP] = ACTIONS(2752),
    [anon_sym_GT_AMP] = ACTIONS(2752),
    [sym__special_characters] = ACTIONS(2752),
    [anon_sym_DQUOTE] = ACTIONS(2752),
    [anon_sym_DOLLAR] = ACTIONS(2754),
    [sym_raw_string] = ACTIONS(2752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2752),
    [anon_sym_BQUOTE] = ACTIONS(2752),
    [anon_sym_LT_LPAREN] = ACTIONS(2752),
    [anon_sym_GT_LPAREN] = ACTIONS(2752),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2752),
  },
  [1224] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(3831),
    [sym_comment] = ACTIONS(53),
  },
  [1225] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(3833),
    [sym_comment] = ACTIONS(53),
  },
  [1226] = {
    [anon_sym_RBRACE] = ACTIONS(3833),
    [sym_comment] = ACTIONS(53),
  },
  [1227] = {
    [sym_concatenation] = STATE(1652),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1652),
    [anon_sym_RBRACE] = ACTIONS(3835),
    [anon_sym_EQ] = ACTIONS(3837),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3839),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3837),
    [anon_sym_COLON_QMARK] = ACTIONS(3837),
    [anon_sym_COLON_DASH] = ACTIONS(3837),
    [anon_sym_PERCENT] = ACTIONS(3837),
    [anon_sym_DASH] = ACTIONS(3837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1228] = {
    [sym_file_descriptor] = ACTIONS(2830),
    [sym__concat] = ACTIONS(2830),
    [sym_variable_name] = ACTIONS(2830),
    [anon_sym_PIPE] = ACTIONS(2832),
    [anon_sym_RPAREN] = ACTIONS(2830),
    [anon_sym_PIPE_AMP] = ACTIONS(2830),
    [anon_sym_AMP_AMP] = ACTIONS(2830),
    [anon_sym_PIPE_PIPE] = ACTIONS(2830),
    [anon_sym_LT] = ACTIONS(2832),
    [anon_sym_GT] = ACTIONS(2832),
    [anon_sym_GT_GT] = ACTIONS(2830),
    [anon_sym_AMP_GT] = ACTIONS(2832),
    [anon_sym_AMP_GT_GT] = ACTIONS(2830),
    [anon_sym_LT_AMP] = ACTIONS(2830),
    [anon_sym_GT_AMP] = ACTIONS(2830),
    [sym__special_characters] = ACTIONS(2830),
    [anon_sym_DQUOTE] = ACTIONS(2830),
    [anon_sym_DOLLAR] = ACTIONS(2832),
    [sym_raw_string] = ACTIONS(2830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2830),
    [anon_sym_BQUOTE] = ACTIONS(2830),
    [anon_sym_LT_LPAREN] = ACTIONS(2830),
    [anon_sym_GT_LPAREN] = ACTIONS(2830),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2830),
  },
  [1229] = {
    [sym_concatenation] = STATE(1655),
    [sym_string] = STATE(1654),
    [sym_simple_expansion] = STATE(1654),
    [sym_string_expansion] = STATE(1654),
    [sym_expansion] = STATE(1654),
    [sym_command_substitution] = STATE(1654),
    [sym_process_substitution] = STATE(1654),
    [anon_sym_RBRACE] = ACTIONS(3833),
    [sym__special_characters] = ACTIONS(3841),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(3843),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3843),
  },
  [1230] = {
    [sym_file_descriptor] = ACTIONS(2873),
    [sym__concat] = ACTIONS(2873),
    [sym_variable_name] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_PIPE_AMP] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_GT] = ACTIONS(2873),
    [anon_sym_AMP_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT_GT] = ACTIONS(2873),
    [anon_sym_LT_AMP] = ACTIONS(2873),
    [anon_sym_GT_AMP] = ACTIONS(2873),
    [sym__special_characters] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2873),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2873),
    [anon_sym_BQUOTE] = ACTIONS(2873),
    [anon_sym_LT_LPAREN] = ACTIONS(2873),
    [anon_sym_GT_LPAREN] = ACTIONS(2873),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2873),
  },
  [1231] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3845),
  },
  [1232] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3847),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1233] = {
    [sym_file_descriptor] = ACTIONS(2881),
    [sym__concat] = ACTIONS(2881),
    [sym_variable_name] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [anon_sym_PIPE_AMP] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_GT_GT] = ACTIONS(2881),
    [anon_sym_AMP_GT] = ACTIONS(2883),
    [anon_sym_AMP_GT_GT] = ACTIONS(2881),
    [anon_sym_LT_AMP] = ACTIONS(2881),
    [anon_sym_GT_AMP] = ACTIONS(2881),
    [sym__special_characters] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [sym_raw_string] = ACTIONS(2881),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2881),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2881),
    [anon_sym_BQUOTE] = ACTIONS(2881),
    [anon_sym_LT_LPAREN] = ACTIONS(2881),
    [anon_sym_GT_LPAREN] = ACTIONS(2881),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2881),
  },
  [1234] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3849),
  },
  [1235] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3851),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1236] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3853),
  },
  [1237] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3833),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1238] = {
    [sym_concatenation] = STATE(1662),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1662),
    [anon_sym_RBRACE] = ACTIONS(3855),
    [anon_sym_EQ] = ACTIONS(3857),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3859),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3857),
    [anon_sym_COLON_QMARK] = ACTIONS(3857),
    [anon_sym_COLON_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1239] = {
    [sym_file_descriptor] = ACTIONS(2897),
    [sym__concat] = ACTIONS(2897),
    [sym_variable_name] = ACTIONS(2897),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_RPAREN] = ACTIONS(2897),
    [anon_sym_PIPE_AMP] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2897),
    [anon_sym_PIPE_PIPE] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2899),
    [anon_sym_GT] = ACTIONS(2899),
    [anon_sym_GT_GT] = ACTIONS(2897),
    [anon_sym_AMP_GT] = ACTIONS(2899),
    [anon_sym_AMP_GT_GT] = ACTIONS(2897),
    [anon_sym_LT_AMP] = ACTIONS(2897),
    [anon_sym_GT_AMP] = ACTIONS(2897),
    [sym__special_characters] = ACTIONS(2897),
    [anon_sym_DQUOTE] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2899),
    [sym_raw_string] = ACTIONS(2897),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2897),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2897),
    [anon_sym_BQUOTE] = ACTIONS(2897),
    [anon_sym_LT_LPAREN] = ACTIONS(2897),
    [anon_sym_GT_LPAREN] = ACTIONS(2897),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2897),
  },
  [1240] = {
    [sym_concatenation] = STATE(1664),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1664),
    [anon_sym_RBRACE] = ACTIONS(3861),
    [anon_sym_EQ] = ACTIONS(3863),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_DASH] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1241] = {
    [sym__concat] = ACTIONS(2752),
    [anon_sym_DQUOTE] = ACTIONS(2754),
    [anon_sym_DOLLAR] = ACTIONS(2754),
    [sym__string_content] = ACTIONS(2752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2754),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2754),
    [anon_sym_BQUOTE] = ACTIONS(2754),
    [sym_comment] = ACTIONS(177),
  },
  [1242] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(3867),
    [sym_comment] = ACTIONS(53),
  },
  [1243] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(3869),
    [sym_comment] = ACTIONS(53),
  },
  [1244] = {
    [anon_sym_RBRACE] = ACTIONS(3869),
    [sym_comment] = ACTIONS(53),
  },
  [1245] = {
    [sym_concatenation] = STATE(1668),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1668),
    [anon_sym_RBRACE] = ACTIONS(3871),
    [anon_sym_EQ] = ACTIONS(3873),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3873),
    [anon_sym_COLON_QMARK] = ACTIONS(3873),
    [anon_sym_COLON_DASH] = ACTIONS(3873),
    [anon_sym_PERCENT] = ACTIONS(3873),
    [anon_sym_DASH] = ACTIONS(3873),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1246] = {
    [sym__concat] = ACTIONS(2830),
    [anon_sym_DQUOTE] = ACTIONS(2832),
    [anon_sym_DOLLAR] = ACTIONS(2832),
    [sym__string_content] = ACTIONS(2830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2832),
    [anon_sym_BQUOTE] = ACTIONS(2832),
    [sym_comment] = ACTIONS(177),
  },
  [1247] = {
    [sym_concatenation] = STATE(1671),
    [sym_string] = STATE(1670),
    [sym_simple_expansion] = STATE(1670),
    [sym_string_expansion] = STATE(1670),
    [sym_expansion] = STATE(1670),
    [sym_command_substitution] = STATE(1670),
    [sym_process_substitution] = STATE(1670),
    [anon_sym_RBRACE] = ACTIONS(3869),
    [sym__special_characters] = ACTIONS(3877),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3879),
  },
  [1248] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym__string_content] = ACTIONS(2873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2875),
    [anon_sym_BQUOTE] = ACTIONS(2875),
    [sym_comment] = ACTIONS(177),
  },
  [1249] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3881),
  },
  [1250] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3883),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1251] = {
    [sym__concat] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [sym__string_content] = ACTIONS(2881),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2883),
    [anon_sym_BQUOTE] = ACTIONS(2883),
    [sym_comment] = ACTIONS(177),
  },
  [1252] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3885),
  },
  [1253] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3887),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1254] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3889),
  },
  [1255] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3869),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1256] = {
    [sym_concatenation] = STATE(1678),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1678),
    [anon_sym_RBRACE] = ACTIONS(3891),
    [anon_sym_EQ] = ACTIONS(3893),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3895),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_COLON_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_DASH] = ACTIONS(3893),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_DASH] = ACTIONS(3893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1257] = {
    [sym__concat] = ACTIONS(2897),
    [anon_sym_DQUOTE] = ACTIONS(2899),
    [anon_sym_DOLLAR] = ACTIONS(2899),
    [sym__string_content] = ACTIONS(2897),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2899),
    [anon_sym_BQUOTE] = ACTIONS(2899),
    [sym_comment] = ACTIONS(177),
  },
  [1258] = {
    [sym_concatenation] = STATE(1680),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1680),
    [anon_sym_RBRACE] = ACTIONS(3897),
    [anon_sym_EQ] = ACTIONS(3899),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(3899),
    [anon_sym_COLON_QMARK] = ACTIONS(3899),
    [anon_sym_COLON_DASH] = ACTIONS(3899),
    [anon_sym_PERCENT] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1259] = {
    [sym_string] = STATE(681),
    [sym_simple_expansion] = STATE(681),
    [sym_string_expansion] = STATE(681),
    [sym_expansion] = STATE(681),
    [sym_command_substitution] = STATE(681),
    [sym_process_substitution] = STATE(681),
    [anon_sym_RBRACK] = ACTIONS(3903),
    [sym__special_characters] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(1309),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1309),
  },
  [1260] = {
    [sym__concat] = ACTIONS(3905),
    [anon_sym_RBRACE] = ACTIONS(2131),
    [anon_sym_EQ] = ACTIONS(3907),
    [sym__special_characters] = ACTIONS(3907),
    [anon_sym_DQUOTE] = ACTIONS(2131),
    [anon_sym_DOLLAR] = ACTIONS(3907),
    [sym_raw_string] = ACTIONS(2131),
    [anon_sym_POUND] = ACTIONS(2131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2131),
    [aux_sym_SLASH] = ACTIONS(2131),
    [anon_sym_COLON] = ACTIONS(3907),
    [anon_sym_COLON_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_DASH] = ACTIONS(3907),
    [anon_sym_PERCENT] = ACTIONS(3907),
    [anon_sym_DASH] = ACTIONS(3907),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2131),
    [anon_sym_LT_LPAREN] = ACTIONS(2131),
    [anon_sym_GT_LPAREN] = ACTIONS(2131),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3907),
  },
  [1261] = {
    [sym_string] = STATE(681),
    [sym_simple_expansion] = STATE(681),
    [sym_string_expansion] = STATE(681),
    [sym_expansion] = STATE(681),
    [sym_command_substitution] = STATE(681),
    [sym_process_substitution] = STATE(681),
    [anon_sym_RBRACK] = ACTIONS(3909),
    [sym__special_characters] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(1309),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1309),
  },
  [1262] = {
    [sym__concat] = ACTIONS(3911),
    [anon_sym_RBRACE] = ACTIONS(2137),
    [anon_sym_EQ] = ACTIONS(3913),
    [sym__special_characters] = ACTIONS(3913),
    [anon_sym_DQUOTE] = ACTIONS(2137),
    [anon_sym_DOLLAR] = ACTIONS(3913),
    [sym_raw_string] = ACTIONS(2137),
    [anon_sym_POUND] = ACTIONS(2137),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2137),
    [aux_sym_SLASH] = ACTIONS(2137),
    [anon_sym_COLON] = ACTIONS(3913),
    [anon_sym_COLON_QMARK] = ACTIONS(3913),
    [anon_sym_COLON_DASH] = ACTIONS(3913),
    [anon_sym_PERCENT] = ACTIONS(3913),
    [anon_sym_DASH] = ACTIONS(3913),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2137),
    [anon_sym_BQUOTE] = ACTIONS(2137),
    [anon_sym_LT_LPAREN] = ACTIONS(2137),
    [anon_sym_GT_LPAREN] = ACTIONS(2137),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3913),
  },
  [1263] = {
    [anon_sym_RBRACK] = ACTIONS(3909),
    [sym_comment] = ACTIONS(53),
  },
  [1264] = {
    [sym_string] = STATE(1685),
    [sym_simple_expansion] = STATE(1685),
    [sym_string_expansion] = STATE(1685),
    [sym_expansion] = STATE(1685),
    [sym_command_substitution] = STATE(1685),
    [sym_process_substitution] = STATE(1685),
    [sym__special_characters] = ACTIONS(3915),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(3915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3915),
  },
  [1265] = {
    [sym__simple_heredoc_body] = ACTIONS(3917),
    [sym__heredoc_body_beginning] = ACTIONS(3917),
    [sym_file_descriptor] = ACTIONS(3917),
    [sym__concat] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3919),
    [anon_sym_RPAREN] = ACTIONS(3919),
    [anon_sym_SEMI_SEMI] = ACTIONS(3919),
    [anon_sym_PIPE_AMP] = ACTIONS(3919),
    [anon_sym_AMP_AMP] = ACTIONS(3919),
    [anon_sym_PIPE_PIPE] = ACTIONS(3919),
    [anon_sym_EQ_TILDE] = ACTIONS(3919),
    [anon_sym_EQ_EQ] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_GT] = ACTIONS(3919),
    [anon_sym_GT_GT] = ACTIONS(3919),
    [anon_sym_AMP_GT] = ACTIONS(3919),
    [anon_sym_AMP_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_AMP] = ACTIONS(3919),
    [anon_sym_GT_AMP] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_LT_LT_DASH] = ACTIONS(3919),
    [anon_sym_LT_LT_LT] = ACTIONS(3919),
    [sym__special_characters] = ACTIONS(3919),
    [anon_sym_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3919),
    [sym_raw_string] = ACTIONS(3919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3919),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3919),
    [anon_sym_BQUOTE] = ACTIONS(3919),
    [anon_sym_LT_LPAREN] = ACTIONS(3919),
    [anon_sym_GT_LPAREN] = ACTIONS(3919),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3919),
    [anon_sym_SEMI] = ACTIONS(3919),
    [anon_sym_LF] = ACTIONS(3917),
    [anon_sym_AMP] = ACTIONS(3919),
  },
  [1266] = {
    [aux_sym_concatenation_repeat1] = STATE(1686),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
  },
  [1267] = {
    [sym__concat] = ACTIONS(697),
    [anon_sym_RBRACE] = ACTIONS(697),
    [sym_comment] = ACTIONS(53),
  },
  [1268] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [1269] = {
    [sym__concat] = ACTIONS(727),
    [anon_sym_RBRACE] = ACTIONS(727),
    [sym_comment] = ACTIONS(53),
  },
  [1270] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_RBRACE] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
  },
  [1271] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_RBRACE] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
  },
  [1272] = {
    [sym__simple_heredoc_body] = ACTIONS(3923),
    [sym__heredoc_body_beginning] = ACTIONS(3923),
    [sym_file_descriptor] = ACTIONS(3923),
    [sym__concat] = ACTIONS(3923),
    [anon_sym_PIPE] = ACTIONS(3925),
    [anon_sym_RPAREN] = ACTIONS(3925),
    [anon_sym_SEMI_SEMI] = ACTIONS(3925),
    [anon_sym_PIPE_AMP] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [anon_sym_EQ_TILDE] = ACTIONS(3925),
    [anon_sym_EQ_EQ] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_GT] = ACTIONS(3925),
    [anon_sym_GT_GT] = ACTIONS(3925),
    [anon_sym_AMP_GT] = ACTIONS(3925),
    [anon_sym_AMP_GT_GT] = ACTIONS(3925),
    [anon_sym_LT_AMP] = ACTIONS(3925),
    [anon_sym_GT_AMP] = ACTIONS(3925),
    [anon_sym_LT_LT] = ACTIONS(3925),
    [anon_sym_LT_LT_DASH] = ACTIONS(3925),
    [anon_sym_LT_LT_LT] = ACTIONS(3925),
    [sym__special_characters] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [sym_raw_string] = ACTIONS(3925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3925),
    [anon_sym_BQUOTE] = ACTIONS(3925),
    [anon_sym_LT_LPAREN] = ACTIONS(3925),
    [anon_sym_GT_LPAREN] = ACTIONS(3925),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3925),
    [anon_sym_SEMI] = ACTIONS(3925),
    [anon_sym_LF] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3925),
  },
  [1273] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(3927),
    [sym_comment] = ACTIONS(53),
  },
  [1274] = {
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1691),
    [anon_sym_RBRACE] = ACTIONS(3929),
    [anon_sym_EQ] = ACTIONS(3931),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3933),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3935),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_COLON_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_DASH] = ACTIONS(3931),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1275] = {
    [sym_subscript] = STATE(1695),
    [sym_variable_name] = ACTIONS(3937),
    [anon_sym_DOLLAR] = ACTIONS(3939),
    [anon_sym_DASH] = ACTIONS(3939),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3941),
    [anon_sym_STAR] = ACTIONS(3939),
    [anon_sym_AT] = ACTIONS(3939),
    [anon_sym_QMARK] = ACTIONS(3939),
    [anon_sym_0] = ACTIONS(3943),
    [anon_sym__] = ACTIONS(3943),
  },
  [1276] = {
    [sym_concatenation] = STATE(1698),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1698),
    [anon_sym_RBRACE] = ACTIONS(3945),
    [anon_sym_EQ] = ACTIONS(3947),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3949),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3951),
    [anon_sym_COLON] = ACTIONS(3947),
    [anon_sym_COLON_QMARK] = ACTIONS(3947),
    [anon_sym_COLON_DASH] = ACTIONS(3947),
    [anon_sym_PERCENT] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1277] = {
    [sym_concatenation] = STATE(1701),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1701),
    [anon_sym_RBRACE] = ACTIONS(3953),
    [anon_sym_EQ] = ACTIONS(3955),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3959),
    [anon_sym_COLON] = ACTIONS(3955),
    [anon_sym_COLON_QMARK] = ACTIONS(3955),
    [anon_sym_COLON_DASH] = ACTIONS(3955),
    [anon_sym_PERCENT] = ACTIONS(3955),
    [anon_sym_DASH] = ACTIONS(3955),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1278] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3961),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [1279] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3961),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [1280] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(3961),
    [sym_comment] = ACTIONS(53),
  },
  [1281] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(3961),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [1282] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3963),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [1283] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(3963),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [1284] = {
    [sym__concat] = ACTIONS(1654),
    [anon_sym_RBRACE] = ACTIONS(1654),
    [anon_sym_EQ] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1654),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1654),
    [anon_sym_POUND] = ACTIONS(1654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1654),
    [anon_sym_COLON] = ACTIONS(1656),
    [anon_sym_COLON_QMARK] = ACTIONS(1656),
    [anon_sym_COLON_DASH] = ACTIONS(1656),
    [anon_sym_PERCENT] = ACTIONS(1656),
    [anon_sym_DASH] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1654),
    [anon_sym_BQUOTE] = ACTIONS(1654),
    [anon_sym_LT_LPAREN] = ACTIONS(1654),
    [anon_sym_GT_LPAREN] = ACTIONS(1654),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1656),
  },
  [1285] = {
    [aux_sym_concatenation_repeat1] = STATE(1285),
    [sym__concat] = ACTIONS(3965),
    [anon_sym_RBRACE] = ACTIONS(1654),
    [anon_sym_EQ] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1654),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1654),
    [anon_sym_POUND] = ACTIONS(1654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1654),
    [anon_sym_COLON] = ACTIONS(1656),
    [anon_sym_COLON_QMARK] = ACTIONS(1656),
    [anon_sym_COLON_DASH] = ACTIONS(1656),
    [anon_sym_PERCENT] = ACTIONS(1656),
    [anon_sym_DASH] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1654),
    [anon_sym_BQUOTE] = ACTIONS(1654),
    [anon_sym_LT_LPAREN] = ACTIONS(1654),
    [anon_sym_GT_LPAREN] = ACTIONS(1654),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1656),
  },
  [1286] = {
    [sym__concat] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_EQ] = ACTIONS(1705),
    [sym__special_characters] = ACTIONS(1705),
    [anon_sym_DQUOTE] = ACTIONS(1703),
    [anon_sym_DOLLAR] = ACTIONS(1705),
    [sym_raw_string] = ACTIONS(1703),
    [anon_sym_POUND] = ACTIONS(1703),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1703),
    [anon_sym_COLON] = ACTIONS(1705),
    [anon_sym_COLON_QMARK] = ACTIONS(1705),
    [anon_sym_COLON_DASH] = ACTIONS(1705),
    [anon_sym_PERCENT] = ACTIONS(1705),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1703),
    [anon_sym_BQUOTE] = ACTIONS(1703),
    [anon_sym_LT_LPAREN] = ACTIONS(1703),
    [anon_sym_GT_LPAREN] = ACTIONS(1703),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1705),
  },
  [1287] = {
    [sym_concatenation] = STATE(1707),
    [sym_string] = STATE(1706),
    [sym_simple_expansion] = STATE(1706),
    [sym_string_expansion] = STATE(1706),
    [sym_expansion] = STATE(1706),
    [sym_command_substitution] = STATE(1706),
    [sym_process_substitution] = STATE(1706),
    [anon_sym_RBRACE] = ACTIONS(3968),
    [sym__special_characters] = ACTIONS(3970),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(3972),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3972),
  },
  [1288] = {
    [sym__concat] = ACTIONS(1744),
    [anon_sym_RBRACE] = ACTIONS(1744),
    [anon_sym_EQ] = ACTIONS(1746),
    [sym__special_characters] = ACTIONS(1746),
    [anon_sym_DQUOTE] = ACTIONS(1744),
    [anon_sym_DOLLAR] = ACTIONS(1746),
    [sym_raw_string] = ACTIONS(1744),
    [anon_sym_POUND] = ACTIONS(1744),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1744),
    [anon_sym_COLON] = ACTIONS(1746),
    [anon_sym_COLON_QMARK] = ACTIONS(1746),
    [anon_sym_COLON_DASH] = ACTIONS(1746),
    [anon_sym_PERCENT] = ACTIONS(1746),
    [anon_sym_DASH] = ACTIONS(1746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1744),
    [anon_sym_LT_LPAREN] = ACTIONS(1744),
    [anon_sym_GT_LPAREN] = ACTIONS(1744),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1746),
  },
  [1289] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(3974),
  },
  [1290] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3976),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1291] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(3978),
    [sym_comment] = ACTIONS(53),
  },
  [1292] = {
    [sym_concatenation] = STATE(1713),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1713),
    [anon_sym_RBRACE] = ACTIONS(3980),
    [anon_sym_EQ] = ACTIONS(3982),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3986),
    [anon_sym_COLON] = ACTIONS(3982),
    [anon_sym_COLON_QMARK] = ACTIONS(3982),
    [anon_sym_COLON_DASH] = ACTIONS(3982),
    [anon_sym_PERCENT] = ACTIONS(3982),
    [anon_sym_DASH] = ACTIONS(3982),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1293] = {
    [sym_concatenation] = STATE(1716),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1716),
    [anon_sym_RBRACE] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3990),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3992),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(3994),
    [anon_sym_COLON] = ACTIONS(3990),
    [anon_sym_COLON_QMARK] = ACTIONS(3990),
    [anon_sym_COLON_DASH] = ACTIONS(3990),
    [anon_sym_PERCENT] = ACTIONS(3990),
    [anon_sym_DASH] = ACTIONS(3990),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1294] = {
    [sym_concatenation] = STATE(1718),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1718),
    [anon_sym_RBRACE] = ACTIONS(3968),
    [anon_sym_EQ] = ACTIONS(3996),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(3998),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4000),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_COLON_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_DASH] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3996),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1295] = {
    [sym__concat] = ACTIONS(1810),
    [anon_sym_RBRACE] = ACTIONS(1810),
    [anon_sym_EQ] = ACTIONS(1812),
    [sym__special_characters] = ACTIONS(1812),
    [anon_sym_DQUOTE] = ACTIONS(1810),
    [anon_sym_DOLLAR] = ACTIONS(1812),
    [sym_raw_string] = ACTIONS(1810),
    [anon_sym_POUND] = ACTIONS(1810),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_COLON] = ACTIONS(1812),
    [anon_sym_COLON_QMARK] = ACTIONS(1812),
    [anon_sym_COLON_DASH] = ACTIONS(1812),
    [anon_sym_PERCENT] = ACTIONS(1812),
    [anon_sym_DASH] = ACTIONS(1812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1810),
    [anon_sym_LT_LPAREN] = ACTIONS(1810),
    [anon_sym_GT_LPAREN] = ACTIONS(1810),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1812),
  },
  [1296] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4002),
  },
  [1297] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4004),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1298] = {
    [sym__concat] = ACTIONS(1818),
    [anon_sym_RBRACE] = ACTIONS(1818),
    [anon_sym_EQ] = ACTIONS(1820),
    [sym__special_characters] = ACTIONS(1820),
    [anon_sym_DQUOTE] = ACTIONS(1818),
    [anon_sym_DOLLAR] = ACTIONS(1820),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_POUND] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1818),
    [anon_sym_COLON] = ACTIONS(1820),
    [anon_sym_COLON_QMARK] = ACTIONS(1820),
    [anon_sym_COLON_DASH] = ACTIONS(1820),
    [anon_sym_PERCENT] = ACTIONS(1820),
    [anon_sym_DASH] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(1818),
    [anon_sym_LT_LPAREN] = ACTIONS(1818),
    [anon_sym_GT_LPAREN] = ACTIONS(1818),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1820),
  },
  [1299] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4006),
  },
  [1300] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(3968),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1301] = {
    [sym__simple_heredoc_body] = ACTIONS(4008),
    [sym__heredoc_body_beginning] = ACTIONS(4008),
    [sym_file_descriptor] = ACTIONS(4008),
    [sym__concat] = ACTIONS(4008),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_RPAREN] = ACTIONS(4010),
    [anon_sym_SEMI_SEMI] = ACTIONS(4010),
    [anon_sym_PIPE_AMP] = ACTIONS(4010),
    [anon_sym_AMP_AMP] = ACTIONS(4010),
    [anon_sym_PIPE_PIPE] = ACTIONS(4010),
    [anon_sym_EQ_TILDE] = ACTIONS(4010),
    [anon_sym_EQ_EQ] = ACTIONS(4010),
    [anon_sym_LT] = ACTIONS(4010),
    [anon_sym_GT] = ACTIONS(4010),
    [anon_sym_GT_GT] = ACTIONS(4010),
    [anon_sym_AMP_GT] = ACTIONS(4010),
    [anon_sym_AMP_GT_GT] = ACTIONS(4010),
    [anon_sym_LT_AMP] = ACTIONS(4010),
    [anon_sym_GT_AMP] = ACTIONS(4010),
    [anon_sym_LT_LT] = ACTIONS(4010),
    [anon_sym_LT_LT_DASH] = ACTIONS(4010),
    [anon_sym_LT_LT_LT] = ACTIONS(4010),
    [sym__special_characters] = ACTIONS(4010),
    [anon_sym_DQUOTE] = ACTIONS(4010),
    [anon_sym_DOLLAR] = ACTIONS(4010),
    [sym_raw_string] = ACTIONS(4010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4010),
    [anon_sym_BQUOTE] = ACTIONS(4010),
    [anon_sym_LT_LPAREN] = ACTIONS(4010),
    [anon_sym_GT_LPAREN] = ACTIONS(4010),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4010),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LF] = ACTIONS(4008),
    [anon_sym_AMP] = ACTIONS(4010),
  },
  [1302] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4012),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1303] = {
    [sym__concat] = ACTIONS(1952),
    [anon_sym_RBRACE] = ACTIONS(1952),
    [anon_sym_EQ] = ACTIONS(1954),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1952),
    [anon_sym_DOLLAR] = ACTIONS(1954),
    [sym_raw_string] = ACTIONS(1952),
    [anon_sym_POUND] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1952),
    [anon_sym_COLON] = ACTIONS(1954),
    [anon_sym_COLON_QMARK] = ACTIONS(1954),
    [anon_sym_COLON_DASH] = ACTIONS(1954),
    [anon_sym_PERCENT] = ACTIONS(1954),
    [anon_sym_DASH] = ACTIONS(1954),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1952),
    [anon_sym_BQUOTE] = ACTIONS(1952),
    [anon_sym_LT_LPAREN] = ACTIONS(1952),
    [anon_sym_GT_LPAREN] = ACTIONS(1952),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1954),
  },
  [1304] = {
    [sym__concat] = ACTIONS(2018),
    [anon_sym_RBRACE] = ACTIONS(2018),
    [anon_sym_EQ] = ACTIONS(2020),
    [sym__special_characters] = ACTIONS(2020),
    [anon_sym_DQUOTE] = ACTIONS(2018),
    [anon_sym_DOLLAR] = ACTIONS(2020),
    [sym_raw_string] = ACTIONS(2018),
    [anon_sym_POUND] = ACTIONS(2018),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2018),
    [anon_sym_COLON] = ACTIONS(2020),
    [anon_sym_COLON_QMARK] = ACTIONS(2020),
    [anon_sym_COLON_DASH] = ACTIONS(2020),
    [anon_sym_PERCENT] = ACTIONS(2020),
    [anon_sym_DASH] = ACTIONS(2020),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2018),
    [anon_sym_BQUOTE] = ACTIONS(2018),
    [anon_sym_LT_LPAREN] = ACTIONS(2018),
    [anon_sym_GT_LPAREN] = ACTIONS(2018),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2020),
  },
  [1305] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4014),
    [sym_comment] = ACTIONS(53),
  },
  [1306] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4016),
    [sym_comment] = ACTIONS(53),
  },
  [1307] = {
    [anon_sym_RBRACE] = ACTIONS(4016),
    [sym_comment] = ACTIONS(53),
  },
  [1308] = {
    [sym_concatenation] = STATE(1726),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1726),
    [anon_sym_RBRACE] = ACTIONS(4018),
    [anon_sym_EQ] = ACTIONS(4020),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4022),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4020),
    [anon_sym_COLON_QMARK] = ACTIONS(4020),
    [anon_sym_COLON_DASH] = ACTIONS(4020),
    [anon_sym_PERCENT] = ACTIONS(4020),
    [anon_sym_DASH] = ACTIONS(4020),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1309] = {
    [sym__simple_heredoc_body] = ACTIONS(4024),
    [sym__heredoc_body_beginning] = ACTIONS(4024),
    [sym_file_descriptor] = ACTIONS(4024),
    [sym__concat] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_RPAREN] = ACTIONS(4026),
    [anon_sym_SEMI_SEMI] = ACTIONS(4026),
    [anon_sym_PIPE_AMP] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4026),
    [anon_sym_PIPE_PIPE] = ACTIONS(4026),
    [anon_sym_EQ_TILDE] = ACTIONS(4026),
    [anon_sym_EQ_EQ] = ACTIONS(4026),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_AMP_GT] = ACTIONS(4026),
    [anon_sym_AMP_GT_GT] = ACTIONS(4026),
    [anon_sym_LT_AMP] = ACTIONS(4026),
    [anon_sym_GT_AMP] = ACTIONS(4026),
    [anon_sym_LT_LT] = ACTIONS(4026),
    [anon_sym_LT_LT_DASH] = ACTIONS(4026),
    [anon_sym_LT_LT_LT] = ACTIONS(4026),
    [sym__special_characters] = ACTIONS(4026),
    [anon_sym_DQUOTE] = ACTIONS(4026),
    [anon_sym_DOLLAR] = ACTIONS(4026),
    [sym_raw_string] = ACTIONS(4026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4026),
    [anon_sym_BQUOTE] = ACTIONS(4026),
    [anon_sym_LT_LPAREN] = ACTIONS(4026),
    [anon_sym_GT_LPAREN] = ACTIONS(4026),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4026),
    [anon_sym_SEMI] = ACTIONS(4026),
    [anon_sym_LF] = ACTIONS(4024),
    [anon_sym_AMP] = ACTIONS(4026),
  },
  [1310] = {
    [sym_concatenation] = STATE(1728),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1728),
    [anon_sym_RBRACE] = ACTIONS(4028),
    [anon_sym_EQ] = ACTIONS(4030),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4032),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4030),
    [anon_sym_COLON_QMARK] = ACTIONS(4030),
    [anon_sym_COLON_DASH] = ACTIONS(4030),
    [anon_sym_PERCENT] = ACTIONS(4030),
    [anon_sym_DASH] = ACTIONS(4030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1311] = {
    [sym__simple_heredoc_body] = ACTIONS(4034),
    [sym__heredoc_body_beginning] = ACTIONS(4034),
    [sym_file_descriptor] = ACTIONS(4034),
    [sym__concat] = ACTIONS(4034),
    [anon_sym_PIPE] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_SEMI_SEMI] = ACTIONS(4036),
    [anon_sym_PIPE_AMP] = ACTIONS(4036),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [anon_sym_EQ_TILDE] = ACTIONS(4036),
    [anon_sym_EQ_EQ] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4036),
    [anon_sym_GT] = ACTIONS(4036),
    [anon_sym_GT_GT] = ACTIONS(4036),
    [anon_sym_AMP_GT] = ACTIONS(4036),
    [anon_sym_AMP_GT_GT] = ACTIONS(4036),
    [anon_sym_LT_AMP] = ACTIONS(4036),
    [anon_sym_GT_AMP] = ACTIONS(4036),
    [anon_sym_LT_LT] = ACTIONS(4036),
    [anon_sym_LT_LT_DASH] = ACTIONS(4036),
    [anon_sym_LT_LT_LT] = ACTIONS(4036),
    [sym__special_characters] = ACTIONS(4036),
    [anon_sym_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR] = ACTIONS(4036),
    [sym_raw_string] = ACTIONS(4036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4036),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4036),
    [anon_sym_GT_LPAREN] = ACTIONS(4036),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4036),
    [anon_sym_SEMI] = ACTIONS(4036),
    [anon_sym_LF] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
  },
  [1312] = {
    [sym_concatenation] = STATE(1730),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1730),
    [anon_sym_RBRACE] = ACTIONS(4038),
    [anon_sym_EQ] = ACTIONS(4040),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4040),
    [anon_sym_COLON_QMARK] = ACTIONS(4040),
    [anon_sym_COLON_DASH] = ACTIONS(4040),
    [anon_sym_PERCENT] = ACTIONS(4040),
    [anon_sym_DASH] = ACTIONS(4040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1313] = {
    [sym__simple_heredoc_body] = ACTIONS(4044),
    [sym__heredoc_body_beginning] = ACTIONS(4044),
    [sym_file_descriptor] = ACTIONS(4044),
    [sym__concat] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_RPAREN] = ACTIONS(4046),
    [anon_sym_SEMI_SEMI] = ACTIONS(4046),
    [anon_sym_PIPE_AMP] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4046),
    [anon_sym_PIPE_PIPE] = ACTIONS(4046),
    [anon_sym_EQ_TILDE] = ACTIONS(4046),
    [anon_sym_EQ_EQ] = ACTIONS(4046),
    [anon_sym_LT] = ACTIONS(4046),
    [anon_sym_GT] = ACTIONS(4046),
    [anon_sym_GT_GT] = ACTIONS(4046),
    [anon_sym_AMP_GT] = ACTIONS(4046),
    [anon_sym_AMP_GT_GT] = ACTIONS(4046),
    [anon_sym_LT_AMP] = ACTIONS(4046),
    [anon_sym_GT_AMP] = ACTIONS(4046),
    [anon_sym_LT_LT] = ACTIONS(4046),
    [anon_sym_LT_LT_DASH] = ACTIONS(4046),
    [anon_sym_LT_LT_LT] = ACTIONS(4046),
    [sym__special_characters] = ACTIONS(4046),
    [anon_sym_DQUOTE] = ACTIONS(4046),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [sym_raw_string] = ACTIONS(4046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4046),
    [anon_sym_BQUOTE] = ACTIONS(4046),
    [anon_sym_LT_LPAREN] = ACTIONS(4046),
    [anon_sym_GT_LPAREN] = ACTIONS(4046),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4046),
    [anon_sym_SEMI] = ACTIONS(4046),
    [anon_sym_LF] = ACTIONS(4044),
    [anon_sym_AMP] = ACTIONS(4046),
  },
  [1314] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4048),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1315] = {
    [sym__simple_heredoc_body] = ACTIONS(4050),
    [sym__heredoc_body_beginning] = ACTIONS(4050),
    [sym_file_descriptor] = ACTIONS(4050),
    [sym__concat] = ACTIONS(4050),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_RPAREN] = ACTIONS(4052),
    [anon_sym_SEMI_SEMI] = ACTIONS(4052),
    [anon_sym_PIPE_AMP] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4052),
    [anon_sym_PIPE_PIPE] = ACTIONS(4052),
    [anon_sym_EQ_TILDE] = ACTIONS(4052),
    [anon_sym_EQ_EQ] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_AMP_GT] = ACTIONS(4052),
    [anon_sym_AMP_GT_GT] = ACTIONS(4052),
    [anon_sym_LT_AMP] = ACTIONS(4052),
    [anon_sym_GT_AMP] = ACTIONS(4052),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_LT_LT_DASH] = ACTIONS(4052),
    [anon_sym_LT_LT_LT] = ACTIONS(4052),
    [sym__special_characters] = ACTIONS(4052),
    [anon_sym_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [sym_raw_string] = ACTIONS(4052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4052),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4052),
    [anon_sym_BQUOTE] = ACTIONS(4052),
    [anon_sym_LT_LPAREN] = ACTIONS(4052),
    [anon_sym_GT_LPAREN] = ACTIONS(4052),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4052),
    [anon_sym_SEMI] = ACTIONS(4052),
    [anon_sym_LF] = ACTIONS(4050),
    [anon_sym_AMP] = ACTIONS(4052),
  },
  [1316] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4054),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1317] = {
    [aux_sym_concatenation_repeat1] = STATE(1733),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(693),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(693),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(693),
    [anon_sym_LT_AMP] = ACTIONS(693),
    [anon_sym_GT_AMP] = ACTIONS(693),
    [sym__special_characters] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(693),
  },
  [1318] = {
    [sym_concatenation] = STATE(1058),
    [sym_string] = STATE(590),
    [sym_simple_expansion] = STATE(590),
    [sym_string_expansion] = STATE(590),
    [sym_expansion] = STATE(590),
    [sym_command_substitution] = STATE(590),
    [sym_process_substitution] = STATE(590),
    [aux_sym_for_statement_repeat1] = STATE(1058),
    [anon_sym_SEMI_SEMI] = ACTIONS(4056),
    [sym__special_characters] = ACTIONS(2241),
    [anon_sym_DQUOTE] = ACTIONS(2243),
    [anon_sym_DOLLAR] = ACTIONS(1159),
    [sym_raw_string] = ACTIONS(2245),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2249),
    [anon_sym_BQUOTE] = ACTIONS(2251),
    [anon_sym_LT_LPAREN] = ACTIONS(2253),
    [anon_sym_GT_LPAREN] = ACTIONS(2253),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2245),
    [anon_sym_SEMI] = ACTIONS(4056),
    [anon_sym_LF] = ACTIONS(4058),
    [anon_sym_AMP] = ACTIONS(4056),
  },
  [1319] = {
    [sym__terminated_statement] = STATE(1736),
    [sym_for_statement] = STATE(599),
    [sym_while_statement] = STATE(599),
    [sym_if_statement] = STATE(599),
    [sym_case_statement] = STATE(599),
    [sym_function_definition] = STATE(599),
    [sym_subshell] = STATE(599),
    [sym_pipeline] = STATE(599),
    [sym_list] = STATE(599),
    [sym_negated_command] = STATE(599),
    [sym_test_command] = STATE(599),
    [sym_declaration_command] = STATE(599),
    [sym_unset_command] = STATE(599),
    [sym_command] = STATE(599),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(600),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1736),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_done] = ACTIONS(4060),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1320] = {
    [anon_sym_PIPE] = ACTIONS(2259),
    [anon_sym_RPAREN] = ACTIONS(2261),
    [anon_sym_PIPE_AMP] = ACTIONS(2261),
    [anon_sym_AMP_AMP] = ACTIONS(2261),
    [anon_sym_PIPE_PIPE] = ACTIONS(2261),
    [anon_sym_BQUOTE] = ACTIONS(2261),
    [sym_comment] = ACTIONS(53),
  },
  [1321] = {
    [sym__simple_heredoc_body] = ACTIONS(2263),
    [sym__heredoc_body_beginning] = ACTIONS(2263),
    [sym_file_descriptor] = ACTIONS(2263),
    [anon_sym_PIPE] = ACTIONS(2265),
    [anon_sym_RPAREN] = ACTIONS(2263),
    [anon_sym_PIPE_AMP] = ACTIONS(2263),
    [anon_sym_AMP_AMP] = ACTIONS(2263),
    [anon_sym_PIPE_PIPE] = ACTIONS(2263),
    [anon_sym_LT] = ACTIONS(2265),
    [anon_sym_GT] = ACTIONS(2265),
    [anon_sym_GT_GT] = ACTIONS(2263),
    [anon_sym_AMP_GT] = ACTIONS(2265),
    [anon_sym_AMP_GT_GT] = ACTIONS(2263),
    [anon_sym_LT_AMP] = ACTIONS(2263),
    [anon_sym_GT_AMP] = ACTIONS(2263),
    [anon_sym_LT_LT] = ACTIONS(2265),
    [anon_sym_LT_LT_DASH] = ACTIONS(2263),
    [anon_sym_LT_LT_LT] = ACTIONS(2263),
    [anon_sym_BQUOTE] = ACTIONS(2263),
    [sym_comment] = ACTIONS(53),
  },
  [1322] = {
    [sym__terminated_statement] = STATE(1063),
    [sym_for_statement] = STATE(599),
    [sym_while_statement] = STATE(599),
    [sym_if_statement] = STATE(599),
    [sym_case_statement] = STATE(599),
    [sym_function_definition] = STATE(599),
    [sym_subshell] = STATE(599),
    [sym_pipeline] = STATE(599),
    [sym_list] = STATE(599),
    [sym_negated_command] = STATE(599),
    [sym_test_command] = STATE(599),
    [sym_declaration_command] = STATE(599),
    [sym_unset_command] = STATE(599),
    [sym_command] = STATE(599),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(600),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1063),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_done] = ACTIONS(4062),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1323] = {
    [anon_sym_PIPE] = ACTIONS(2273),
    [anon_sym_RPAREN] = ACTIONS(2275),
    [anon_sym_PIPE_AMP] = ACTIONS(2275),
    [anon_sym_AMP_AMP] = ACTIONS(2275),
    [anon_sym_PIPE_PIPE] = ACTIONS(2275),
    [anon_sym_BQUOTE] = ACTIONS(2275),
    [sym_comment] = ACTIONS(53),
  },
  [1324] = {
    [sym_file_redirect] = STATE(948),
    [sym_heredoc_redirect] = STATE(948),
    [sym_heredoc_body] = STATE(1738),
    [sym_herestring_redirect] = STATE(948),
    [aux_sym_while_statement_repeat1] = STATE(948),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(2273),
    [anon_sym_RPAREN] = ACTIONS(2275),
    [anon_sym_PIPE_AMP] = ACTIONS(2275),
    [anon_sym_AMP_AMP] = ACTIONS(2275),
    [anon_sym_PIPE_PIPE] = ACTIONS(2275),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(887),
    [anon_sym_LT_AMP] = ACTIONS(887),
    [anon_sym_GT_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(893),
    [sym_comment] = ACTIONS(53),
  },
  [1325] = {
    [anon_sym_PIPE] = ACTIONS(2277),
    [anon_sym_RPAREN] = ACTIONS(2279),
    [anon_sym_PIPE_AMP] = ACTIONS(2279),
    [anon_sym_AMP_AMP] = ACTIONS(2279),
    [anon_sym_PIPE_PIPE] = ACTIONS(2279),
    [anon_sym_BQUOTE] = ACTIONS(2279),
    [sym_comment] = ACTIONS(53),
  },
  [1326] = {
    [anon_sym_fi] = ACTIONS(4064),
    [sym_comment] = ACTIONS(53),
  },
  [1327] = {
    [sym__terminated_statement] = STATE(1072),
    [sym_for_statement] = STATE(607),
    [sym_while_statement] = STATE(607),
    [sym_if_statement] = STATE(607),
    [sym_elif_clause] = STATE(608),
    [sym_else_clause] = STATE(1740),
    [sym_case_statement] = STATE(607),
    [sym_function_definition] = STATE(607),
    [sym_subshell] = STATE(607),
    [sym_pipeline] = STATE(607),
    [sym_list] = STATE(607),
    [sym_negated_command] = STATE(607),
    [sym_test_command] = STATE(607),
    [sym_declaration_command] = STATE(607),
    [sym_unset_command] = STATE(607),
    [sym_command] = STATE(607),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(610),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1072),
    [aux_sym_if_statement_repeat1] = STATE(1741),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(4066),
    [anon_sym_elif] = ACTIONS(1181),
    [anon_sym_else] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1328] = {
    [sym_elif_clause] = STATE(608),
    [sym_else_clause] = STATE(1740),
    [aux_sym_if_statement_repeat1] = STATE(1074),
    [anon_sym_fi] = ACTIONS(4064),
    [anon_sym_elif] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2295),
    [sym_comment] = ACTIONS(53),
  },
  [1329] = {
    [sym_case_item] = STATE(1744),
    [sym_last_case_item] = STATE(1743),
    [sym_concatenation] = STATE(1079),
    [sym_string] = STATE(1077),
    [sym_simple_expansion] = STATE(1077),
    [sym_string_expansion] = STATE(1077),
    [sym_expansion] = STATE(1077),
    [sym_command_substitution] = STATE(1077),
    [sym_process_substitution] = STATE(1077),
    [aux_sym_case_statement_repeat1] = STATE(1744),
    [anon_sym_esac] = ACTIONS(4068),
    [sym__special_characters] = ACTIONS(2299),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2303),
  },
  [1330] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(4070),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4070),
    [anon_sym_LF] = ACTIONS(4072),
    [anon_sym_AMP] = ACTIONS(4070),
  },
  [1331] = {
    [sym_case_item] = STATE(1748),
    [sym_last_case_item] = STATE(1747),
    [sym_concatenation] = STATE(1079),
    [sym_string] = STATE(1077),
    [sym_simple_expansion] = STATE(1077),
    [sym_string_expansion] = STATE(1077),
    [sym_expansion] = STATE(1077),
    [sym_command_substitution] = STATE(1077),
    [sym_process_substitution] = STATE(1077),
    [aux_sym_case_statement_repeat1] = STATE(1748),
    [anon_sym_esac] = ACTIONS(4074),
    [sym__special_characters] = ACTIONS(2299),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2303),
  },
  [1332] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(4076),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_LF] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(4076),
  },
  [1333] = {
    [sym_compound_statement] = STATE(1750),
    [anon_sym_LBRACE] = ACTIONS(1852),
    [sym_comment] = ACTIONS(53),
  },
  [1334] = {
    [sym_file_descriptor] = ACTIONS(2358),
    [anon_sym_PIPE] = ACTIONS(2360),
    [anon_sym_RPAREN] = ACTIONS(2358),
    [anon_sym_PIPE_AMP] = ACTIONS(2358),
    [anon_sym_AMP_AMP] = ACTIONS(2358),
    [anon_sym_PIPE_PIPE] = ACTIONS(2358),
    [anon_sym_LT] = ACTIONS(2360),
    [anon_sym_GT] = ACTIONS(2360),
    [anon_sym_GT_GT] = ACTIONS(2358),
    [anon_sym_AMP_GT] = ACTIONS(2360),
    [anon_sym_AMP_GT_GT] = ACTIONS(2358),
    [anon_sym_LT_AMP] = ACTIONS(2358),
    [anon_sym_GT_AMP] = ACTIONS(2358),
    [anon_sym_BQUOTE] = ACTIONS(2358),
    [sym_comment] = ACTIONS(53),
  },
  [1335] = {
    [sym__terminated_statement] = STATE(1107),
    [sym_for_statement] = STATE(638),
    [sym_while_statement] = STATE(638),
    [sym_if_statement] = STATE(638),
    [sym_case_statement] = STATE(638),
    [sym_function_definition] = STATE(638),
    [sym_subshell] = STATE(638),
    [sym_pipeline] = STATE(638),
    [sym_list] = STATE(638),
    [sym_negated_command] = STATE(638),
    [sym_test_command] = STATE(638),
    [sym_declaration_command] = STATE(638),
    [sym_unset_command] = STATE(638),
    [sym_command] = STATE(638),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(639),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1107),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RBRACE] = ACTIONS(4080),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1336] = {
    [anon_sym_LT] = ACTIONS(4082),
    [anon_sym_GT] = ACTIONS(4082),
    [anon_sym_GT_GT] = ACTIONS(4084),
    [anon_sym_AMP_GT] = ACTIONS(4082),
    [anon_sym_AMP_GT_GT] = ACTIONS(4084),
    [anon_sym_LT_AMP] = ACTIONS(4084),
    [anon_sym_GT_AMP] = ACTIONS(4084),
    [sym_comment] = ACTIONS(53),
  },
  [1337] = {
    [sym_concatenation] = STATE(1755),
    [sym_string] = STATE(1754),
    [sym_simple_expansion] = STATE(1754),
    [sym_string_expansion] = STATE(1754),
    [sym_expansion] = STATE(1754),
    [sym_command_substitution] = STATE(1754),
    [sym_process_substitution] = STATE(1754),
    [sym__special_characters] = ACTIONS(4086),
    [anon_sym_DQUOTE] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [sym_raw_string] = ACTIONS(4088),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [anon_sym_LT_LPAREN] = ACTIONS(839),
    [anon_sym_GT_LPAREN] = ACTIONS(839),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4088),
  },
  [1338] = {
    [anon_sym_PIPE] = ACTIONS(2376),
    [anon_sym_RPAREN] = ACTIONS(2378),
    [anon_sym_PIPE_AMP] = ACTIONS(2378),
    [anon_sym_AMP_AMP] = ACTIONS(2378),
    [anon_sym_PIPE_PIPE] = ACTIONS(2378),
    [anon_sym_BQUOTE] = ACTIONS(2378),
    [sym_comment] = ACTIONS(53),
  },
  [1339] = {
    [anon_sym_PIPE] = ACTIONS(2411),
    [anon_sym_RPAREN] = ACTIONS(2413),
    [anon_sym_PIPE_AMP] = ACTIONS(2413),
    [anon_sym_AMP_AMP] = ACTIONS(2413),
    [anon_sym_PIPE_PIPE] = ACTIONS(2413),
    [anon_sym_BQUOTE] = ACTIONS(2413),
    [sym_comment] = ACTIONS(53),
  },
  [1340] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_RPAREN] = ACTIONS(4090),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(953),
    [anon_sym_DQUOTE] = ACTIONS(951),
    [anon_sym_DOLLAR] = ACTIONS(953),
    [sym_raw_string] = ACTIONS(951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(951),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(951),
    [anon_sym_BQUOTE] = ACTIONS(951),
    [anon_sym_LT_LPAREN] = ACTIONS(951),
    [anon_sym_GT_LPAREN] = ACTIONS(951),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(953),
  },
  [1341] = {
    [anon_sym_LT] = ACTIONS(4092),
    [anon_sym_GT] = ACTIONS(4092),
    [anon_sym_GT_GT] = ACTIONS(4094),
    [anon_sym_AMP_GT] = ACTIONS(4092),
    [anon_sym_AMP_GT_GT] = ACTIONS(4094),
    [anon_sym_LT_AMP] = ACTIONS(4094),
    [anon_sym_GT_AMP] = ACTIONS(4094),
    [sym_comment] = ACTIONS(53),
  },
  [1342] = {
    [sym_concatenation] = STATE(1766),
    [sym_string] = STATE(1761),
    [sym_simple_expansion] = STATE(1761),
    [sym_string_expansion] = STATE(1761),
    [sym_expansion] = STATE(1761),
    [sym_command_substitution] = STATE(1761),
    [sym_process_substitution] = STATE(1761),
    [sym__special_characters] = ACTIONS(4096),
    [anon_sym_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [sym_raw_string] = ACTIONS(4102),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4104),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4106),
    [anon_sym_BQUOTE] = ACTIONS(4108),
    [anon_sym_LT_LPAREN] = ACTIONS(4110),
    [anon_sym_GT_LPAREN] = ACTIONS(4110),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4102),
  },
  [1343] = {
    [sym_heredoc_start] = ACTIONS(4112),
    [sym_comment] = ACTIONS(53),
  },
  [1344] = {
    [sym_concatenation] = STATE(1770),
    [sym_string] = STATE(1769),
    [sym_simple_expansion] = STATE(1769),
    [sym_string_expansion] = STATE(1769),
    [sym_expansion] = STATE(1769),
    [sym_command_substitution] = STATE(1769),
    [sym_process_substitution] = STATE(1769),
    [sym__special_characters] = ACTIONS(4114),
    [anon_sym_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [sym_raw_string] = ACTIONS(4116),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4104),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4106),
    [anon_sym_BQUOTE] = ACTIONS(4108),
    [anon_sym_LT_LPAREN] = ACTIONS(4110),
    [anon_sym_GT_LPAREN] = ACTIONS(4110),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4116),
  },
  [1345] = {
    [sym_file_redirect] = STATE(1771),
    [sym_heredoc_redirect] = STATE(1771),
    [sym_herestring_redirect] = STATE(1771),
    [aux_sym_while_statement_repeat1] = STATE(1771),
    [sym_file_descriptor] = ACTIONS(2943),
    [anon_sym_PIPE] = ACTIONS(2520),
    [anon_sym_RPAREN] = ACTIONS(2522),
    [anon_sym_PIPE_AMP] = ACTIONS(2522),
    [anon_sym_AMP_AMP] = ACTIONS(2522),
    [anon_sym_PIPE_PIPE] = ACTIONS(2522),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_GT] = ACTIONS(2945),
    [anon_sym_GT_GT] = ACTIONS(2947),
    [anon_sym_AMP_GT] = ACTIONS(2945),
    [anon_sym_AMP_GT_GT] = ACTIONS(2947),
    [anon_sym_LT_AMP] = ACTIONS(2947),
    [anon_sym_GT_AMP] = ACTIONS(2947),
    [anon_sym_LT_LT] = ACTIONS(2949),
    [anon_sym_LT_LT_DASH] = ACTIONS(2951),
    [anon_sym_LT_LT_LT] = ACTIONS(2953),
    [sym_comment] = ACTIONS(53),
  },
  [1346] = {
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_RPAREN] = ACTIONS(1107),
    [anon_sym_PIPE_AMP] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [sym__special_characters] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LT_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_LPAREN] = ACTIONS(1107),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1109),
    [sym_word] = ACTIONS(1109),
  },
  [1347] = {
    [sym_concatenation] = STATE(1773),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(1773),
    [anon_sym_RPAREN] = ACTIONS(4118),
    [sym__special_characters] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1119),
  },
  [1348] = {
    [aux_sym_concatenation_repeat1] = STATE(873),
    [sym__concat] = ACTIONS(1864),
    [sym_variable_name] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(1129),
    [anon_sym_PIPE_AMP] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1129),
    [sym__special_characters] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1129),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [sym_raw_string] = ACTIONS(1129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1129),
    [anon_sym_LT_LPAREN] = ACTIONS(1129),
    [anon_sym_GT_LPAREN] = ACTIONS(1129),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1133),
    [sym_word] = ACTIONS(1133),
  },
  [1349] = {
    [aux_sym_concatenation_repeat1] = STATE(873),
    [sym__concat] = ACTIONS(1864),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_RPAREN] = ACTIONS(1107),
    [anon_sym_PIPE_AMP] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [sym__special_characters] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LT_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_LPAREN] = ACTIONS(1107),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1109),
    [sym_word] = ACTIONS(1109),
  },
  [1350] = {
    [sym__concat] = ACTIONS(1654),
    [sym_variable_name] = ACTIONS(1654),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1654),
    [anon_sym_PIPE_AMP] = ACTIONS(1654),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [sym__special_characters] = ACTIONS(1654),
    [anon_sym_DQUOTE] = ACTIONS(1654),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1654),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1654),
    [anon_sym_BQUOTE] = ACTIONS(1654),
    [anon_sym_LT_LPAREN] = ACTIONS(1654),
    [anon_sym_GT_LPAREN] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1656),
    [sym_word] = ACTIONS(1656),
  },
  [1351] = {
    [aux_sym_concatenation_repeat1] = STATE(1351),
    [sym__concat] = ACTIONS(4120),
    [sym_variable_name] = ACTIONS(1654),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1654),
    [anon_sym_PIPE_AMP] = ACTIONS(1654),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [sym__special_characters] = ACTIONS(1654),
    [anon_sym_DQUOTE] = ACTIONS(1654),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1654),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1654),
    [anon_sym_BQUOTE] = ACTIONS(1654),
    [anon_sym_LT_LPAREN] = ACTIONS(1654),
    [anon_sym_GT_LPAREN] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1656),
    [sym_word] = ACTIONS(1656),
  },
  [1352] = {
    [sym__concat] = ACTIONS(1703),
    [sym_variable_name] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_PIPE_AMP] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [sym__special_characters] = ACTIONS(1703),
    [anon_sym_DQUOTE] = ACTIONS(1703),
    [anon_sym_DOLLAR] = ACTIONS(1705),
    [sym_raw_string] = ACTIONS(1703),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1703),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1703),
    [anon_sym_BQUOTE] = ACTIONS(1703),
    [anon_sym_LT_LPAREN] = ACTIONS(1703),
    [anon_sym_GT_LPAREN] = ACTIONS(1703),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1705),
    [sym_word] = ACTIONS(1705),
  },
  [1353] = {
    [sym_concatenation] = STATE(1777),
    [sym_string] = STATE(1776),
    [sym_simple_expansion] = STATE(1776),
    [sym_string_expansion] = STATE(1776),
    [sym_expansion] = STATE(1776),
    [sym_command_substitution] = STATE(1776),
    [sym_process_substitution] = STATE(1776),
    [anon_sym_RBRACE] = ACTIONS(4123),
    [sym__special_characters] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(4127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4127),
  },
  [1354] = {
    [sym__concat] = ACTIONS(1744),
    [sym_variable_name] = ACTIONS(1744),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_RPAREN] = ACTIONS(1744),
    [anon_sym_PIPE_AMP] = ACTIONS(1744),
    [anon_sym_AMP_AMP] = ACTIONS(1744),
    [anon_sym_PIPE_PIPE] = ACTIONS(1744),
    [sym__special_characters] = ACTIONS(1744),
    [anon_sym_DQUOTE] = ACTIONS(1744),
    [anon_sym_DOLLAR] = ACTIONS(1746),
    [sym_raw_string] = ACTIONS(1744),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1744),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1744),
    [anon_sym_LT_LPAREN] = ACTIONS(1744),
    [anon_sym_GT_LPAREN] = ACTIONS(1744),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1746),
    [sym_word] = ACTIONS(1746),
  },
  [1355] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4129),
  },
  [1356] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4131),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1357] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(4133),
    [sym_comment] = ACTIONS(53),
  },
  [1358] = {
    [sym_concatenation] = STATE(1783),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1783),
    [anon_sym_RBRACE] = ACTIONS(4135),
    [anon_sym_EQ] = ACTIONS(4137),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4141),
    [anon_sym_COLON] = ACTIONS(4137),
    [anon_sym_COLON_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_DASH] = ACTIONS(4137),
    [anon_sym_PERCENT] = ACTIONS(4137),
    [anon_sym_DASH] = ACTIONS(4137),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1359] = {
    [sym_concatenation] = STATE(1786),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1786),
    [anon_sym_RBRACE] = ACTIONS(4143),
    [anon_sym_EQ] = ACTIONS(4145),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4147),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4149),
    [anon_sym_COLON] = ACTIONS(4145),
    [anon_sym_COLON_QMARK] = ACTIONS(4145),
    [anon_sym_COLON_DASH] = ACTIONS(4145),
    [anon_sym_PERCENT] = ACTIONS(4145),
    [anon_sym_DASH] = ACTIONS(4145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1360] = {
    [sym_concatenation] = STATE(1788),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1788),
    [anon_sym_RBRACE] = ACTIONS(4123),
    [anon_sym_EQ] = ACTIONS(4151),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4153),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4155),
    [anon_sym_COLON] = ACTIONS(4151),
    [anon_sym_COLON_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_DASH] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1361] = {
    [sym__concat] = ACTIONS(1810),
    [sym_variable_name] = ACTIONS(1810),
    [anon_sym_PIPE] = ACTIONS(1812),
    [anon_sym_RPAREN] = ACTIONS(1810),
    [anon_sym_PIPE_AMP] = ACTIONS(1810),
    [anon_sym_AMP_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1810),
    [sym__special_characters] = ACTIONS(1810),
    [anon_sym_DQUOTE] = ACTIONS(1810),
    [anon_sym_DOLLAR] = ACTIONS(1812),
    [sym_raw_string] = ACTIONS(1810),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1810),
    [anon_sym_LT_LPAREN] = ACTIONS(1810),
    [anon_sym_GT_LPAREN] = ACTIONS(1810),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1812),
    [sym_word] = ACTIONS(1812),
  },
  [1362] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4157),
  },
  [1363] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4159),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1364] = {
    [sym__concat] = ACTIONS(1818),
    [sym_variable_name] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1820),
    [anon_sym_RPAREN] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [sym__special_characters] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(1818),
    [anon_sym_DOLLAR] = ACTIONS(1820),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(1818),
    [anon_sym_LT_LPAREN] = ACTIONS(1818),
    [anon_sym_GT_LPAREN] = ACTIONS(1818),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1820),
    [sym_word] = ACTIONS(1820),
  },
  [1365] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4161),
  },
  [1366] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4123),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1367] = {
    [sym__concat] = ACTIONS(1952),
    [sym_variable_name] = ACTIONS(1952),
    [anon_sym_PIPE] = ACTIONS(1954),
    [anon_sym_RPAREN] = ACTIONS(1952),
    [anon_sym_PIPE_AMP] = ACTIONS(1952),
    [anon_sym_AMP_AMP] = ACTIONS(1952),
    [anon_sym_PIPE_PIPE] = ACTIONS(1952),
    [sym__special_characters] = ACTIONS(1952),
    [anon_sym_DQUOTE] = ACTIONS(1952),
    [anon_sym_DOLLAR] = ACTIONS(1954),
    [sym_raw_string] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1952),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1952),
    [anon_sym_BQUOTE] = ACTIONS(1952),
    [anon_sym_LT_LPAREN] = ACTIONS(1952),
    [anon_sym_GT_LPAREN] = ACTIONS(1952),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1954),
    [sym_word] = ACTIONS(1954),
  },
  [1368] = {
    [sym__concat] = ACTIONS(2018),
    [sym_variable_name] = ACTIONS(2018),
    [anon_sym_PIPE] = ACTIONS(2020),
    [anon_sym_RPAREN] = ACTIONS(2018),
    [anon_sym_PIPE_AMP] = ACTIONS(2018),
    [anon_sym_AMP_AMP] = ACTIONS(2018),
    [anon_sym_PIPE_PIPE] = ACTIONS(2018),
    [sym__special_characters] = ACTIONS(2018),
    [anon_sym_DQUOTE] = ACTIONS(2018),
    [anon_sym_DOLLAR] = ACTIONS(2020),
    [sym_raw_string] = ACTIONS(2018),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2018),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2018),
    [anon_sym_BQUOTE] = ACTIONS(2018),
    [anon_sym_LT_LPAREN] = ACTIONS(2018),
    [anon_sym_GT_LPAREN] = ACTIONS(2018),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2020),
    [sym_word] = ACTIONS(2020),
  },
  [1369] = {
    [sym__concat] = ACTIONS(1654),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1654),
    [anon_sym_PIPE_AMP] = ACTIONS(1654),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [sym__special_characters] = ACTIONS(1654),
    [anon_sym_DQUOTE] = ACTIONS(1654),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1654),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1654),
    [anon_sym_BQUOTE] = ACTIONS(1654),
    [anon_sym_LT_LPAREN] = ACTIONS(1654),
    [anon_sym_GT_LPAREN] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1656),
    [sym_word] = ACTIONS(1656),
  },
  [1370] = {
    [aux_sym_concatenation_repeat1] = STATE(1370),
    [sym__concat] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1654),
    [anon_sym_PIPE_AMP] = ACTIONS(1654),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [sym__special_characters] = ACTIONS(1654),
    [anon_sym_DQUOTE] = ACTIONS(1654),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1654),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1654),
    [anon_sym_BQUOTE] = ACTIONS(1654),
    [anon_sym_LT_LPAREN] = ACTIONS(1654),
    [anon_sym_GT_LPAREN] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1656),
    [sym_word] = ACTIONS(1656),
  },
  [1371] = {
    [sym__concat] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_PIPE_AMP] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [sym__special_characters] = ACTIONS(1703),
    [anon_sym_DQUOTE] = ACTIONS(1703),
    [anon_sym_DOLLAR] = ACTIONS(1705),
    [sym_raw_string] = ACTIONS(1703),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1703),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1703),
    [anon_sym_BQUOTE] = ACTIONS(1703),
    [anon_sym_LT_LPAREN] = ACTIONS(1703),
    [anon_sym_GT_LPAREN] = ACTIONS(1703),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1705),
    [sym_word] = ACTIONS(1705),
  },
  [1372] = {
    [sym_concatenation] = STATE(1795),
    [sym_string] = STATE(1794),
    [sym_simple_expansion] = STATE(1794),
    [sym_string_expansion] = STATE(1794),
    [sym_expansion] = STATE(1794),
    [sym_command_substitution] = STATE(1794),
    [sym_process_substitution] = STATE(1794),
    [anon_sym_RBRACE] = ACTIONS(4166),
    [sym__special_characters] = ACTIONS(4168),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(4170),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4170),
  },
  [1373] = {
    [sym__concat] = ACTIONS(1744),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_RPAREN] = ACTIONS(1744),
    [anon_sym_PIPE_AMP] = ACTIONS(1744),
    [anon_sym_AMP_AMP] = ACTIONS(1744),
    [anon_sym_PIPE_PIPE] = ACTIONS(1744),
    [sym__special_characters] = ACTIONS(1744),
    [anon_sym_DQUOTE] = ACTIONS(1744),
    [anon_sym_DOLLAR] = ACTIONS(1746),
    [sym_raw_string] = ACTIONS(1744),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1744),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1744),
    [anon_sym_LT_LPAREN] = ACTIONS(1744),
    [anon_sym_GT_LPAREN] = ACTIONS(1744),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1746),
    [sym_word] = ACTIONS(1746),
  },
  [1374] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4172),
  },
  [1375] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4174),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1376] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(4176),
    [sym_comment] = ACTIONS(53),
  },
  [1377] = {
    [sym_concatenation] = STATE(1801),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1801),
    [anon_sym_RBRACE] = ACTIONS(4178),
    [anon_sym_EQ] = ACTIONS(4180),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4184),
    [anon_sym_COLON] = ACTIONS(4180),
    [anon_sym_COLON_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_DASH] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1378] = {
    [sym_concatenation] = STATE(1804),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1804),
    [anon_sym_RBRACE] = ACTIONS(4186),
    [anon_sym_EQ] = ACTIONS(4188),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4190),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4192),
    [anon_sym_COLON] = ACTIONS(4188),
    [anon_sym_COLON_QMARK] = ACTIONS(4188),
    [anon_sym_COLON_DASH] = ACTIONS(4188),
    [anon_sym_PERCENT] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4188),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1379] = {
    [sym_concatenation] = STATE(1806),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1806),
    [anon_sym_RBRACE] = ACTIONS(4166),
    [anon_sym_EQ] = ACTIONS(4194),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4196),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4198),
    [anon_sym_COLON] = ACTIONS(4194),
    [anon_sym_COLON_QMARK] = ACTIONS(4194),
    [anon_sym_COLON_DASH] = ACTIONS(4194),
    [anon_sym_PERCENT] = ACTIONS(4194),
    [anon_sym_DASH] = ACTIONS(4194),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1380] = {
    [sym__concat] = ACTIONS(1810),
    [anon_sym_PIPE] = ACTIONS(1812),
    [anon_sym_RPAREN] = ACTIONS(1810),
    [anon_sym_PIPE_AMP] = ACTIONS(1810),
    [anon_sym_AMP_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1810),
    [sym__special_characters] = ACTIONS(1810),
    [anon_sym_DQUOTE] = ACTIONS(1810),
    [anon_sym_DOLLAR] = ACTIONS(1812),
    [sym_raw_string] = ACTIONS(1810),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1810),
    [anon_sym_LT_LPAREN] = ACTIONS(1810),
    [anon_sym_GT_LPAREN] = ACTIONS(1810),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1812),
    [sym_word] = ACTIONS(1812),
  },
  [1381] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4200),
  },
  [1382] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4202),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1383] = {
    [sym__concat] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1820),
    [anon_sym_RPAREN] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [sym__special_characters] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(1818),
    [anon_sym_DOLLAR] = ACTIONS(1820),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(1818),
    [anon_sym_LT_LPAREN] = ACTIONS(1818),
    [anon_sym_GT_LPAREN] = ACTIONS(1818),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1820),
    [sym_word] = ACTIONS(1820),
  },
  [1384] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4204),
  },
  [1385] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4166),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1386] = {
    [sym__concat] = ACTIONS(1952),
    [anon_sym_PIPE] = ACTIONS(1954),
    [anon_sym_RPAREN] = ACTIONS(1952),
    [anon_sym_PIPE_AMP] = ACTIONS(1952),
    [anon_sym_AMP_AMP] = ACTIONS(1952),
    [anon_sym_PIPE_PIPE] = ACTIONS(1952),
    [sym__special_characters] = ACTIONS(1952),
    [anon_sym_DQUOTE] = ACTIONS(1952),
    [anon_sym_DOLLAR] = ACTIONS(1954),
    [sym_raw_string] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1952),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1952),
    [anon_sym_BQUOTE] = ACTIONS(1952),
    [anon_sym_LT_LPAREN] = ACTIONS(1952),
    [anon_sym_GT_LPAREN] = ACTIONS(1952),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1954),
    [sym_word] = ACTIONS(1954),
  },
  [1387] = {
    [sym__concat] = ACTIONS(2018),
    [anon_sym_PIPE] = ACTIONS(2020),
    [anon_sym_RPAREN] = ACTIONS(2018),
    [anon_sym_PIPE_AMP] = ACTIONS(2018),
    [anon_sym_AMP_AMP] = ACTIONS(2018),
    [anon_sym_PIPE_PIPE] = ACTIONS(2018),
    [sym__special_characters] = ACTIONS(2018),
    [anon_sym_DQUOTE] = ACTIONS(2018),
    [anon_sym_DOLLAR] = ACTIONS(2020),
    [sym_raw_string] = ACTIONS(2018),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2018),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2018),
    [anon_sym_BQUOTE] = ACTIONS(2018),
    [anon_sym_LT_LPAREN] = ACTIONS(2018),
    [anon_sym_GT_LPAREN] = ACTIONS(2018),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2020),
    [sym_word] = ACTIONS(2020),
  },
  [1388] = {
    [sym__simple_heredoc_body] = ACTIONS(2752),
    [sym__heredoc_body_beginning] = ACTIONS(2752),
    [sym_file_descriptor] = ACTIONS(2752),
    [sym__concat] = ACTIONS(2752),
    [anon_sym_PIPE] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(2752),
    [anon_sym_PIPE_AMP] = ACTIONS(2752),
    [anon_sym_AMP_AMP] = ACTIONS(2752),
    [anon_sym_PIPE_PIPE] = ACTIONS(2752),
    [anon_sym_EQ_TILDE] = ACTIONS(2754),
    [anon_sym_EQ_EQ] = ACTIONS(2754),
    [anon_sym_LT] = ACTIONS(2754),
    [anon_sym_GT] = ACTIONS(2754),
    [anon_sym_GT_GT] = ACTIONS(2752),
    [anon_sym_AMP_GT] = ACTIONS(2754),
    [anon_sym_AMP_GT_GT] = ACTIONS(2752),
    [anon_sym_LT_AMP] = ACTIONS(2752),
    [anon_sym_GT_AMP] = ACTIONS(2752),
    [anon_sym_LT_LT] = ACTIONS(2754),
    [anon_sym_LT_LT_DASH] = ACTIONS(2752),
    [anon_sym_LT_LT_LT] = ACTIONS(2752),
    [sym__special_characters] = ACTIONS(2752),
    [anon_sym_DQUOTE] = ACTIONS(2752),
    [anon_sym_DOLLAR] = ACTIONS(2754),
    [sym_raw_string] = ACTIONS(2752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2752),
    [anon_sym_BQUOTE] = ACTIONS(2752),
    [anon_sym_LT_LPAREN] = ACTIONS(2752),
    [anon_sym_GT_LPAREN] = ACTIONS(2752),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2754),
  },
  [1389] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4206),
    [sym_comment] = ACTIONS(53),
  },
  [1390] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4208),
    [sym_comment] = ACTIONS(53),
  },
  [1391] = {
    [anon_sym_RBRACE] = ACTIONS(4208),
    [sym_comment] = ACTIONS(53),
  },
  [1392] = {
    [sym_concatenation] = STATE(1813),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1813),
    [anon_sym_RBRACE] = ACTIONS(4210),
    [anon_sym_EQ] = ACTIONS(4212),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4214),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4212),
    [anon_sym_COLON_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_DASH] = ACTIONS(4212),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_DASH] = ACTIONS(4212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1393] = {
    [sym__simple_heredoc_body] = ACTIONS(2830),
    [sym__heredoc_body_beginning] = ACTIONS(2830),
    [sym_file_descriptor] = ACTIONS(2830),
    [sym__concat] = ACTIONS(2830),
    [anon_sym_PIPE] = ACTIONS(2832),
    [anon_sym_RPAREN] = ACTIONS(2830),
    [anon_sym_PIPE_AMP] = ACTIONS(2830),
    [anon_sym_AMP_AMP] = ACTIONS(2830),
    [anon_sym_PIPE_PIPE] = ACTIONS(2830),
    [anon_sym_EQ_TILDE] = ACTIONS(2832),
    [anon_sym_EQ_EQ] = ACTIONS(2832),
    [anon_sym_LT] = ACTIONS(2832),
    [anon_sym_GT] = ACTIONS(2832),
    [anon_sym_GT_GT] = ACTIONS(2830),
    [anon_sym_AMP_GT] = ACTIONS(2832),
    [anon_sym_AMP_GT_GT] = ACTIONS(2830),
    [anon_sym_LT_AMP] = ACTIONS(2830),
    [anon_sym_GT_AMP] = ACTIONS(2830),
    [anon_sym_LT_LT] = ACTIONS(2832),
    [anon_sym_LT_LT_DASH] = ACTIONS(2830),
    [anon_sym_LT_LT_LT] = ACTIONS(2830),
    [sym__special_characters] = ACTIONS(2830),
    [anon_sym_DQUOTE] = ACTIONS(2830),
    [anon_sym_DOLLAR] = ACTIONS(2832),
    [sym_raw_string] = ACTIONS(2830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2830),
    [anon_sym_BQUOTE] = ACTIONS(2830),
    [anon_sym_LT_LPAREN] = ACTIONS(2830),
    [anon_sym_GT_LPAREN] = ACTIONS(2830),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2832),
  },
  [1394] = {
    [sym_concatenation] = STATE(1816),
    [sym_string] = STATE(1815),
    [sym_simple_expansion] = STATE(1815),
    [sym_string_expansion] = STATE(1815),
    [sym_expansion] = STATE(1815),
    [sym_command_substitution] = STATE(1815),
    [sym_process_substitution] = STATE(1815),
    [anon_sym_RBRACE] = ACTIONS(4208),
    [sym__special_characters] = ACTIONS(4216),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(4218),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4218),
  },
  [1395] = {
    [sym__simple_heredoc_body] = ACTIONS(2873),
    [sym__heredoc_body_beginning] = ACTIONS(2873),
    [sym_file_descriptor] = ACTIONS(2873),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_PIPE_AMP] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_EQ_TILDE] = ACTIONS(2875),
    [anon_sym_EQ_EQ] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_GT] = ACTIONS(2873),
    [anon_sym_AMP_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT_GT] = ACTIONS(2873),
    [anon_sym_LT_AMP] = ACTIONS(2873),
    [anon_sym_GT_AMP] = ACTIONS(2873),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_LT_LT_DASH] = ACTIONS(2873),
    [anon_sym_LT_LT_LT] = ACTIONS(2873),
    [sym__special_characters] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2873),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2873),
    [anon_sym_BQUOTE] = ACTIONS(2873),
    [anon_sym_LT_LPAREN] = ACTIONS(2873),
    [anon_sym_GT_LPAREN] = ACTIONS(2873),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2875),
  },
  [1396] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4220),
  },
  [1397] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4222),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1398] = {
    [sym__simple_heredoc_body] = ACTIONS(2881),
    [sym__heredoc_body_beginning] = ACTIONS(2881),
    [sym_file_descriptor] = ACTIONS(2881),
    [sym__concat] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [anon_sym_PIPE_AMP] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_EQ_TILDE] = ACTIONS(2883),
    [anon_sym_EQ_EQ] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_GT_GT] = ACTIONS(2881),
    [anon_sym_AMP_GT] = ACTIONS(2883),
    [anon_sym_AMP_GT_GT] = ACTIONS(2881),
    [anon_sym_LT_AMP] = ACTIONS(2881),
    [anon_sym_GT_AMP] = ACTIONS(2881),
    [anon_sym_LT_LT] = ACTIONS(2883),
    [anon_sym_LT_LT_DASH] = ACTIONS(2881),
    [anon_sym_LT_LT_LT] = ACTIONS(2881),
    [sym__special_characters] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [sym_raw_string] = ACTIONS(2881),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2881),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2881),
    [anon_sym_BQUOTE] = ACTIONS(2881),
    [anon_sym_LT_LPAREN] = ACTIONS(2881),
    [anon_sym_GT_LPAREN] = ACTIONS(2881),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2883),
  },
  [1399] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4224),
  },
  [1400] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4226),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1401] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4228),
  },
  [1402] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4208),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1403] = {
    [sym_concatenation] = STATE(1823),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1823),
    [anon_sym_RBRACE] = ACTIONS(4230),
    [anon_sym_EQ] = ACTIONS(4232),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4234),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4232),
    [anon_sym_COLON_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_DASH] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1404] = {
    [sym__simple_heredoc_body] = ACTIONS(2897),
    [sym__heredoc_body_beginning] = ACTIONS(2897),
    [sym_file_descriptor] = ACTIONS(2897),
    [sym__concat] = ACTIONS(2897),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_RPAREN] = ACTIONS(2897),
    [anon_sym_PIPE_AMP] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2897),
    [anon_sym_PIPE_PIPE] = ACTIONS(2897),
    [anon_sym_EQ_TILDE] = ACTIONS(2899),
    [anon_sym_EQ_EQ] = ACTIONS(2899),
    [anon_sym_LT] = ACTIONS(2899),
    [anon_sym_GT] = ACTIONS(2899),
    [anon_sym_GT_GT] = ACTIONS(2897),
    [anon_sym_AMP_GT] = ACTIONS(2899),
    [anon_sym_AMP_GT_GT] = ACTIONS(2897),
    [anon_sym_LT_AMP] = ACTIONS(2897),
    [anon_sym_GT_AMP] = ACTIONS(2897),
    [anon_sym_LT_LT] = ACTIONS(2899),
    [anon_sym_LT_LT_DASH] = ACTIONS(2897),
    [anon_sym_LT_LT_LT] = ACTIONS(2897),
    [sym__special_characters] = ACTIONS(2897),
    [anon_sym_DQUOTE] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2899),
    [sym_raw_string] = ACTIONS(2897),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2897),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2897),
    [anon_sym_BQUOTE] = ACTIONS(2897),
    [anon_sym_LT_LPAREN] = ACTIONS(2897),
    [anon_sym_GT_LPAREN] = ACTIONS(2897),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2899),
  },
  [1405] = {
    [sym_concatenation] = STATE(1825),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1825),
    [anon_sym_RBRACE] = ACTIONS(4236),
    [anon_sym_EQ] = ACTIONS(4238),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4240),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4238),
    [anon_sym_COLON_QMARK] = ACTIONS(4238),
    [anon_sym_COLON_DASH] = ACTIONS(4238),
    [anon_sym_PERCENT] = ACTIONS(4238),
    [anon_sym_DASH] = ACTIONS(4238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1406] = {
    [sym_file_redirect] = STATE(1826),
    [sym_file_descriptor] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(2376),
    [anon_sym_RPAREN] = ACTIONS(2378),
    [anon_sym_PIPE_AMP] = ACTIONS(2378),
    [anon_sym_AMP_AMP] = ACTIONS(2378),
    [anon_sym_PIPE_PIPE] = ACTIONS(2378),
    [anon_sym_LT] = ACTIONS(2931),
    [anon_sym_GT] = ACTIONS(2931),
    [anon_sym_GT_GT] = ACTIONS(2933),
    [anon_sym_AMP_GT] = ACTIONS(2931),
    [anon_sym_AMP_GT_GT] = ACTIONS(2933),
    [anon_sym_LT_AMP] = ACTIONS(2933),
    [anon_sym_GT_AMP] = ACTIONS(2933),
    [sym_comment] = ACTIONS(53),
  },
  [1407] = {
    [anon_sym_PIPE] = ACTIONS(3310),
    [anon_sym_RPAREN] = ACTIONS(3312),
    [anon_sym_PIPE_AMP] = ACTIONS(3312),
    [anon_sym_AMP_AMP] = ACTIONS(3312),
    [anon_sym_PIPE_PIPE] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3312),
    [sym_comment] = ACTIONS(53),
  },
  [1408] = {
    [aux_sym_concatenation_repeat1] = STATE(1411),
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [sym_comment] = ACTIONS(53),
  },
  [1409] = {
    [aux_sym_concatenation_repeat1] = STATE(1411),
    [sym__simple_heredoc_body] = ACTIONS(1093),
    [sym__heredoc_body_beginning] = ACTIONS(1093),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1093),
    [anon_sym_LT_LT_LT] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
  },
  [1410] = {
    [sym__simple_heredoc_body] = ACTIONS(1093),
    [sym__heredoc_body_beginning] = ACTIONS(1093),
    [sym_file_descriptor] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1093),
    [anon_sym_LT_LT_LT] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
  },
  [1411] = {
    [aux_sym_concatenation_repeat1] = STATE(1827),
    [sym__simple_heredoc_body] = ACTIONS(693),
    [sym__heredoc_body_beginning] = ACTIONS(693),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(693),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(693),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(693),
    [anon_sym_LT_AMP] = ACTIONS(693),
    [anon_sym_GT_AMP] = ACTIONS(693),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(693),
    [anon_sym_LT_LT_LT] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
  },
  [1412] = {
    [anon_sym_PIPE] = ACTIONS(3325),
    [anon_sym_RPAREN] = ACTIONS(3327),
    [anon_sym_PIPE_AMP] = ACTIONS(3327),
    [anon_sym_AMP_AMP] = ACTIONS(3327),
    [anon_sym_PIPE_PIPE] = ACTIONS(3327),
    [anon_sym_BQUOTE] = ACTIONS(3327),
    [sym_comment] = ACTIONS(53),
  },
  [1413] = {
    [sym_file_redirect] = STATE(948),
    [sym_heredoc_redirect] = STATE(948),
    [sym_heredoc_body] = STATE(1828),
    [sym_herestring_redirect] = STATE(948),
    [aux_sym_while_statement_repeat1] = STATE(948),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(3325),
    [anon_sym_RPAREN] = ACTIONS(3327),
    [anon_sym_PIPE_AMP] = ACTIONS(3327),
    [anon_sym_AMP_AMP] = ACTIONS(3327),
    [anon_sym_PIPE_PIPE] = ACTIONS(3327),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_AMP_GT_GT] = ACTIONS(887),
    [anon_sym_LT_AMP] = ACTIONS(887),
    [anon_sym_GT_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(893),
    [sym_comment] = ACTIONS(53),
  },
  [1414] = {
    [aux_sym_concatenation_repeat1] = STATE(1829),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(663),
    [sym_variable_name] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(693),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(693),
    [anon_sym_LT_AMP] = ACTIONS(693),
    [anon_sym_GT_AMP] = ACTIONS(693),
    [sym__special_characters] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(693),
  },
  [1415] = {
    [sym_file_redirect] = STATE(975),
    [sym_heredoc_redirect] = STATE(975),
    [sym_heredoc_body] = STATE(1738),
    [sym_herestring_redirect] = STATE(975),
    [aux_sym_while_statement_repeat1] = STATE(975),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(2273),
    [anon_sym_PIPE_AMP] = ACTIONS(2275),
    [anon_sym_AMP_AMP] = ACTIONS(2275),
    [anon_sym_PIPE_PIPE] = ACTIONS(2275),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(933),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(937),
    [anon_sym_BQUOTE] = ACTIONS(2275),
    [sym_comment] = ACTIONS(53),
  },
  [1416] = {
    [sym_compound_statement] = STATE(1830),
    [anon_sym_LBRACE] = ACTIONS(1852),
    [sym_comment] = ACTIONS(53),
  },
  [1417] = {
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_GT] = ACTIONS(4242),
    [anon_sym_GT_GT] = ACTIONS(4244),
    [anon_sym_AMP_GT] = ACTIONS(4242),
    [anon_sym_AMP_GT_GT] = ACTIONS(4244),
    [anon_sym_LT_AMP] = ACTIONS(4244),
    [anon_sym_GT_AMP] = ACTIONS(4244),
    [sym_comment] = ACTIONS(53),
  },
  [1418] = {
    [sym_concatenation] = STATE(1755),
    [sym_string] = STATE(1833),
    [sym_simple_expansion] = STATE(1833),
    [sym_string_expansion] = STATE(1833),
    [sym_expansion] = STATE(1833),
    [sym_command_substitution] = STATE(1833),
    [sym_process_substitution] = STATE(1833),
    [sym__special_characters] = ACTIONS(4246),
    [anon_sym_DQUOTE] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [sym_raw_string] = ACTIONS(4248),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [anon_sym_LT_LPAREN] = ACTIONS(839),
    [anon_sym_GT_LPAREN] = ACTIONS(839),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4248),
  },
  [1419] = {
    [anon_sym_LT] = ACTIONS(4250),
    [anon_sym_GT] = ACTIONS(4250),
    [anon_sym_GT_GT] = ACTIONS(4252),
    [anon_sym_AMP_GT] = ACTIONS(4250),
    [anon_sym_AMP_GT_GT] = ACTIONS(4252),
    [anon_sym_LT_AMP] = ACTIONS(4252),
    [anon_sym_GT_AMP] = ACTIONS(4252),
    [sym_comment] = ACTIONS(53),
  },
  [1420] = {
    [sym_concatenation] = STATE(1766),
    [sym_string] = STATE(1836),
    [sym_simple_expansion] = STATE(1836),
    [sym_string_expansion] = STATE(1836),
    [sym_expansion] = STATE(1836),
    [sym_command_substitution] = STATE(1836),
    [sym_process_substitution] = STATE(1836),
    [sym__special_characters] = ACTIONS(4254),
    [anon_sym_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [sym_raw_string] = ACTIONS(4256),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4104),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4106),
    [anon_sym_BQUOTE] = ACTIONS(4108),
    [anon_sym_LT_LPAREN] = ACTIONS(4110),
    [anon_sym_GT_LPAREN] = ACTIONS(4110),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4256),
  },
  [1421] = {
    [sym_concatenation] = STATE(1770),
    [sym_string] = STATE(1838),
    [sym_simple_expansion] = STATE(1838),
    [sym_string_expansion] = STATE(1838),
    [sym_expansion] = STATE(1838),
    [sym_command_substitution] = STATE(1838),
    [sym_process_substitution] = STATE(1838),
    [sym__special_characters] = ACTIONS(4258),
    [anon_sym_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [sym_raw_string] = ACTIONS(4260),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4104),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4106),
    [anon_sym_BQUOTE] = ACTIONS(4108),
    [anon_sym_LT_LPAREN] = ACTIONS(4110),
    [anon_sym_GT_LPAREN] = ACTIONS(4110),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4260),
  },
  [1422] = {
    [sym_file_redirect] = STATE(1839),
    [sym_heredoc_redirect] = STATE(1839),
    [sym_herestring_redirect] = STATE(1839),
    [aux_sym_while_statement_repeat1] = STATE(1839),
    [sym_file_descriptor] = ACTIONS(3215),
    [anon_sym_PIPE] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2522),
    [anon_sym_AMP_AMP] = ACTIONS(2522),
    [anon_sym_PIPE_PIPE] = ACTIONS(2522),
    [anon_sym_LT] = ACTIONS(3217),
    [anon_sym_GT] = ACTIONS(3217),
    [anon_sym_GT_GT] = ACTIONS(3219),
    [anon_sym_AMP_GT] = ACTIONS(3217),
    [anon_sym_AMP_GT_GT] = ACTIONS(3219),
    [anon_sym_LT_AMP] = ACTIONS(3219),
    [anon_sym_GT_AMP] = ACTIONS(3219),
    [anon_sym_LT_LT] = ACTIONS(2949),
    [anon_sym_LT_LT_DASH] = ACTIONS(2951),
    [anon_sym_LT_LT_LT] = ACTIONS(3221),
    [anon_sym_BQUOTE] = ACTIONS(2522),
    [sym_comment] = ACTIONS(53),
  },
  [1423] = {
    [aux_sym_concatenation_repeat1] = STATE(959),
    [sym__concat] = ACTIONS(1864),
    [sym_variable_name] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1129),
    [sym__special_characters] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1129),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [sym_raw_string] = ACTIONS(1129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1129),
    [anon_sym_LT_LPAREN] = ACTIONS(1129),
    [anon_sym_GT_LPAREN] = ACTIONS(1129),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1133),
    [sym_word] = ACTIONS(1133),
  },
  [1424] = {
    [aux_sym_concatenation_repeat1] = STATE(959),
    [sym__concat] = ACTIONS(1864),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [sym__special_characters] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [anon_sym_LT_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_LPAREN] = ACTIONS(1107),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1109),
    [sym_word] = ACTIONS(1109),
  },
  [1425] = {
    [aux_sym_concatenation_repeat1] = STATE(1425),
    [sym__concat] = ACTIONS(4120),
    [sym_variable_name] = ACTIONS(1654),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1654),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [sym__special_characters] = ACTIONS(1654),
    [anon_sym_DQUOTE] = ACTIONS(1654),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1654),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1654),
    [anon_sym_BQUOTE] = ACTIONS(1654),
    [anon_sym_LT_LPAREN] = ACTIONS(1654),
    [anon_sym_GT_LPAREN] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1656),
    [sym_word] = ACTIONS(1656),
  },
  [1426] = {
    [aux_sym_concatenation_repeat1] = STATE(1426),
    [sym__concat] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1654),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [sym__special_characters] = ACTIONS(1654),
    [anon_sym_DQUOTE] = ACTIONS(1654),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1654),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1654),
    [anon_sym_BQUOTE] = ACTIONS(1654),
    [anon_sym_LT_LPAREN] = ACTIONS(1654),
    [anon_sym_GT_LPAREN] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1656),
    [sym_word] = ACTIONS(1656),
  },
  [1427] = {
    [sym_file_redirect] = STATE(1826),
    [sym_file_descriptor] = ACTIONS(3209),
    [anon_sym_PIPE] = ACTIONS(2376),
    [anon_sym_PIPE_AMP] = ACTIONS(2378),
    [anon_sym_AMP_AMP] = ACTIONS(2378),
    [anon_sym_PIPE_PIPE] = ACTIONS(2378),
    [anon_sym_LT] = ACTIONS(3211),
    [anon_sym_GT] = ACTIONS(3211),
    [anon_sym_GT_GT] = ACTIONS(3213),
    [anon_sym_AMP_GT] = ACTIONS(3211),
    [anon_sym_AMP_GT_GT] = ACTIONS(3213),
    [anon_sym_LT_AMP] = ACTIONS(3213),
    [anon_sym_GT_AMP] = ACTIONS(3213),
    [anon_sym_BQUOTE] = ACTIONS(2378),
    [sym_comment] = ACTIONS(53),
  },
  [1428] = {
    [aux_sym_concatenation_repeat1] = STATE(1430),
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [sym_comment] = ACTIONS(53),
  },
  [1429] = {
    [aux_sym_concatenation_repeat1] = STATE(1430),
    [sym__simple_heredoc_body] = ACTIONS(1093),
    [sym__heredoc_body_beginning] = ACTIONS(1093),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1093),
    [anon_sym_LT_LT_LT] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
  },
  [1430] = {
    [aux_sym_concatenation_repeat1] = STATE(1840),
    [sym__simple_heredoc_body] = ACTIONS(693),
    [sym__heredoc_body_beginning] = ACTIONS(693),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(693),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(693),
    [anon_sym_LT_AMP] = ACTIONS(693),
    [anon_sym_GT_AMP] = ACTIONS(693),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(693),
    [anon_sym_LT_LT_LT] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
  },
  [1431] = {
    [sym_file_redirect] = STATE(975),
    [sym_heredoc_redirect] = STATE(975),
    [sym_heredoc_body] = STATE(1828),
    [sym_herestring_redirect] = STATE(975),
    [aux_sym_while_statement_repeat1] = STATE(975),
    [sym__simple_heredoc_body] = ACTIONS(877),
    [sym__heredoc_body_beginning] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(3325),
    [anon_sym_PIPE_AMP] = ACTIONS(3327),
    [anon_sym_AMP_AMP] = ACTIONS(3327),
    [anon_sym_PIPE_PIPE] = ACTIONS(3327),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(933),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_LT_LT_DASH] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(937),
    [anon_sym_BQUOTE] = ACTIONS(3327),
    [sym_comment] = ACTIONS(53),
  },
  [1432] = {
    [anon_sym_esac] = ACTIONS(3609),
    [anon_sym_PIPE] = ACTIONS(3609),
    [anon_sym_RPAREN] = ACTIONS(3609),
    [anon_sym_SEMI_SEMI] = ACTIONS(3609),
    [anon_sym_PIPE_AMP] = ACTIONS(3609),
    [anon_sym_AMP_AMP] = ACTIONS(3609),
    [anon_sym_PIPE_PIPE] = ACTIONS(3609),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3609),
    [anon_sym_LF] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3609),
  },
  [1433] = {
    [sym_concatenation] = STATE(1844),
    [sym_string] = STATE(1843),
    [sym_simple_expansion] = STATE(1843),
    [sym_string_expansion] = STATE(1843),
    [sym_expansion] = STATE(1843),
    [sym_command_substitution] = STATE(1843),
    [sym_process_substitution] = STATE(1843),
    [anon_sym_RBRACE] = ACTIONS(4262),
    [sym__special_characters] = ACTIONS(4264),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(4266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4266),
  },
  [1434] = {
    [sym__heredoc_body_middle] = ACTIONS(1744),
    [sym__heredoc_body_end] = ACTIONS(1744),
    [anon_sym_DOLLAR] = ACTIONS(1746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1744),
    [sym_comment] = ACTIONS(53),
  },
  [1435] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4268),
  },
  [1436] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4270),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1437] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(4272),
    [sym_comment] = ACTIONS(53),
  },
  [1438] = {
    [sym_concatenation] = STATE(1850),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1850),
    [anon_sym_RBRACE] = ACTIONS(4274),
    [anon_sym_EQ] = ACTIONS(4276),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4280),
    [anon_sym_COLON] = ACTIONS(4276),
    [anon_sym_COLON_QMARK] = ACTIONS(4276),
    [anon_sym_COLON_DASH] = ACTIONS(4276),
    [anon_sym_PERCENT] = ACTIONS(4276),
    [anon_sym_DASH] = ACTIONS(4276),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1439] = {
    [sym_concatenation] = STATE(1853),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1853),
    [anon_sym_RBRACE] = ACTIONS(4282),
    [anon_sym_EQ] = ACTIONS(4284),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4286),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4288),
    [anon_sym_COLON] = ACTIONS(4284),
    [anon_sym_COLON_QMARK] = ACTIONS(4284),
    [anon_sym_COLON_DASH] = ACTIONS(4284),
    [anon_sym_PERCENT] = ACTIONS(4284),
    [anon_sym_DASH] = ACTIONS(4284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1440] = {
    [sym_concatenation] = STATE(1855),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1855),
    [anon_sym_RBRACE] = ACTIONS(4262),
    [anon_sym_EQ] = ACTIONS(4290),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4294),
    [anon_sym_COLON] = ACTIONS(4290),
    [anon_sym_COLON_QMARK] = ACTIONS(4290),
    [anon_sym_COLON_DASH] = ACTIONS(4290),
    [anon_sym_PERCENT] = ACTIONS(4290),
    [anon_sym_DASH] = ACTIONS(4290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1441] = {
    [sym__heredoc_body_middle] = ACTIONS(1810),
    [sym__heredoc_body_end] = ACTIONS(1810),
    [anon_sym_DOLLAR] = ACTIONS(1812),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(53),
  },
  [1442] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4296),
  },
  [1443] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4298),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1444] = {
    [sym__heredoc_body_middle] = ACTIONS(1818),
    [sym__heredoc_body_end] = ACTIONS(1818),
    [anon_sym_DOLLAR] = ACTIONS(1820),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1818),
    [sym_comment] = ACTIONS(53),
  },
  [1445] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4300),
  },
  [1446] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4262),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1447] = {
    [aux_sym_concatenation_repeat1] = STATE(1447),
    [sym__simple_heredoc_body] = ACTIONS(1654),
    [sym__heredoc_body_beginning] = ACTIONS(1654),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(1658),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1656),
    [anon_sym_LT_AMP] = ACTIONS(1656),
    [anon_sym_GT_AMP] = ACTIONS(1656),
    [anon_sym_LT_LT] = ACTIONS(1656),
    [anon_sym_LT_LT_DASH] = ACTIONS(1656),
    [anon_sym_LT_LT_LT] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [1448] = {
    [anon_sym_esac] = ACTIONS(4302),
    [anon_sym_PIPE] = ACTIONS(4302),
    [anon_sym_RPAREN] = ACTIONS(4302),
    [anon_sym_SEMI_SEMI] = ACTIONS(4302),
    [anon_sym_PIPE_AMP] = ACTIONS(4302),
    [anon_sym_AMP_AMP] = ACTIONS(4302),
    [anon_sym_PIPE_PIPE] = ACTIONS(4302),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4302),
    [anon_sym_LF] = ACTIONS(4304),
    [anon_sym_AMP] = ACTIONS(4302),
  },
  [1449] = {
    [anon_sym_EQ] = ACTIONS(4306),
    [anon_sym_PLUS_EQ] = ACTIONS(4306),
    [sym_comment] = ACTIONS(53),
  },
  [1450] = {
    [anon_sym_EQ] = ACTIONS(4308),
    [anon_sym_PLUS_EQ] = ACTIONS(4308),
    [sym_comment] = ACTIONS(53),
  },
  [1451] = {
    [sym__concat] = ACTIONS(1654),
    [anon_sym_RPAREN] = ACTIONS(1654),
    [sym__special_characters] = ACTIONS(1654),
    [anon_sym_DQUOTE] = ACTIONS(1654),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1654),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1654),
    [anon_sym_BQUOTE] = ACTIONS(1654),
    [anon_sym_LT_LPAREN] = ACTIONS(1654),
    [anon_sym_GT_LPAREN] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1654),
  },
  [1452] = {
    [aux_sym_concatenation_repeat1] = STATE(1452),
    [sym__concat] = ACTIONS(4310),
    [anon_sym_RPAREN] = ACTIONS(1654),
    [sym__special_characters] = ACTIONS(1654),
    [anon_sym_DQUOTE] = ACTIONS(1654),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1654),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1654),
    [anon_sym_BQUOTE] = ACTIONS(1654),
    [anon_sym_LT_LPAREN] = ACTIONS(1654),
    [anon_sym_GT_LPAREN] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1654),
  },
  [1453] = {
    [sym__concat] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [sym__special_characters] = ACTIONS(1703),
    [anon_sym_DQUOTE] = ACTIONS(1703),
    [anon_sym_DOLLAR] = ACTIONS(1705),
    [sym_raw_string] = ACTIONS(1703),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1703),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1703),
    [anon_sym_BQUOTE] = ACTIONS(1703),
    [anon_sym_LT_LPAREN] = ACTIONS(1703),
    [anon_sym_GT_LPAREN] = ACTIONS(1703),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1703),
  },
  [1454] = {
    [sym_concatenation] = STATE(1862),
    [sym_string] = STATE(1861),
    [sym_simple_expansion] = STATE(1861),
    [sym_string_expansion] = STATE(1861),
    [sym_expansion] = STATE(1861),
    [sym_command_substitution] = STATE(1861),
    [sym_process_substitution] = STATE(1861),
    [anon_sym_RBRACE] = ACTIONS(4313),
    [sym__special_characters] = ACTIONS(4315),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(4317),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4317),
  },
  [1455] = {
    [sym__concat] = ACTIONS(1744),
    [anon_sym_RPAREN] = ACTIONS(1744),
    [sym__special_characters] = ACTIONS(1744),
    [anon_sym_DQUOTE] = ACTIONS(1744),
    [anon_sym_DOLLAR] = ACTIONS(1746),
    [sym_raw_string] = ACTIONS(1744),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1744),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1744),
    [anon_sym_LT_LPAREN] = ACTIONS(1744),
    [anon_sym_GT_LPAREN] = ACTIONS(1744),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1744),
  },
  [1456] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4319),
  },
  [1457] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4321),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1458] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(4323),
    [sym_comment] = ACTIONS(53),
  },
  [1459] = {
    [sym_concatenation] = STATE(1868),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1868),
    [anon_sym_RBRACE] = ACTIONS(4325),
    [anon_sym_EQ] = ACTIONS(4327),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4329),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4331),
    [anon_sym_COLON] = ACTIONS(4327),
    [anon_sym_COLON_QMARK] = ACTIONS(4327),
    [anon_sym_COLON_DASH] = ACTIONS(4327),
    [anon_sym_PERCENT] = ACTIONS(4327),
    [anon_sym_DASH] = ACTIONS(4327),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1460] = {
    [sym_concatenation] = STATE(1871),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1871),
    [anon_sym_RBRACE] = ACTIONS(4333),
    [anon_sym_EQ] = ACTIONS(4335),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4339),
    [anon_sym_COLON] = ACTIONS(4335),
    [anon_sym_COLON_QMARK] = ACTIONS(4335),
    [anon_sym_COLON_DASH] = ACTIONS(4335),
    [anon_sym_PERCENT] = ACTIONS(4335),
    [anon_sym_DASH] = ACTIONS(4335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1461] = {
    [sym_concatenation] = STATE(1873),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1873),
    [anon_sym_RBRACE] = ACTIONS(4313),
    [anon_sym_EQ] = ACTIONS(4341),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4343),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4345),
    [anon_sym_COLON] = ACTIONS(4341),
    [anon_sym_COLON_QMARK] = ACTIONS(4341),
    [anon_sym_COLON_DASH] = ACTIONS(4341),
    [anon_sym_PERCENT] = ACTIONS(4341),
    [anon_sym_DASH] = ACTIONS(4341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1462] = {
    [sym__concat] = ACTIONS(1810),
    [anon_sym_RPAREN] = ACTIONS(1810),
    [sym__special_characters] = ACTIONS(1810),
    [anon_sym_DQUOTE] = ACTIONS(1810),
    [anon_sym_DOLLAR] = ACTIONS(1812),
    [sym_raw_string] = ACTIONS(1810),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1810),
    [anon_sym_LT_LPAREN] = ACTIONS(1810),
    [anon_sym_GT_LPAREN] = ACTIONS(1810),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1810),
  },
  [1463] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4347),
  },
  [1464] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4349),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1465] = {
    [sym__concat] = ACTIONS(1818),
    [anon_sym_RPAREN] = ACTIONS(1818),
    [sym__special_characters] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(1818),
    [anon_sym_DOLLAR] = ACTIONS(1820),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(1818),
    [anon_sym_LT_LPAREN] = ACTIONS(1818),
    [anon_sym_GT_LPAREN] = ACTIONS(1818),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1818),
  },
  [1466] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4351),
  },
  [1467] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4313),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1468] = {
    [sym__concat] = ACTIONS(1952),
    [anon_sym_RPAREN] = ACTIONS(1952),
    [sym__special_characters] = ACTIONS(1952),
    [anon_sym_DQUOTE] = ACTIONS(1952),
    [anon_sym_DOLLAR] = ACTIONS(1954),
    [sym_raw_string] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1952),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1952),
    [anon_sym_BQUOTE] = ACTIONS(1952),
    [anon_sym_LT_LPAREN] = ACTIONS(1952),
    [anon_sym_GT_LPAREN] = ACTIONS(1952),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1952),
  },
  [1469] = {
    [sym__concat] = ACTIONS(2018),
    [anon_sym_RPAREN] = ACTIONS(2018),
    [sym__special_characters] = ACTIONS(2018),
    [anon_sym_DQUOTE] = ACTIONS(2018),
    [anon_sym_DOLLAR] = ACTIONS(2020),
    [sym_raw_string] = ACTIONS(2018),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2018),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2018),
    [anon_sym_BQUOTE] = ACTIONS(2018),
    [anon_sym_LT_LPAREN] = ACTIONS(2018),
    [anon_sym_GT_LPAREN] = ACTIONS(2018),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2018),
  },
  [1470] = {
    [sym_file_descriptor] = ACTIONS(2752),
    [sym__concat] = ACTIONS(2752),
    [sym_variable_name] = ACTIONS(2752),
    [anon_sym_PIPE] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(2754),
    [anon_sym_SEMI_SEMI] = ACTIONS(2754),
    [anon_sym_PIPE_AMP] = ACTIONS(2754),
    [anon_sym_AMP_AMP] = ACTIONS(2754),
    [anon_sym_PIPE_PIPE] = ACTIONS(2754),
    [anon_sym_LT] = ACTIONS(2754),
    [anon_sym_GT] = ACTIONS(2754),
    [anon_sym_GT_GT] = ACTIONS(2754),
    [anon_sym_AMP_GT] = ACTIONS(2754),
    [anon_sym_AMP_GT_GT] = ACTIONS(2754),
    [anon_sym_LT_AMP] = ACTIONS(2754),
    [anon_sym_GT_AMP] = ACTIONS(2754),
    [sym__special_characters] = ACTIONS(2754),
    [anon_sym_DQUOTE] = ACTIONS(2754),
    [anon_sym_DOLLAR] = ACTIONS(2754),
    [sym_raw_string] = ACTIONS(2754),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2754),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2754),
    [anon_sym_BQUOTE] = ACTIONS(2754),
    [anon_sym_LT_LPAREN] = ACTIONS(2754),
    [anon_sym_GT_LPAREN] = ACTIONS(2754),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2754),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_LF] = ACTIONS(2752),
    [anon_sym_AMP] = ACTIONS(2754),
  },
  [1471] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4353),
    [sym_comment] = ACTIONS(53),
  },
  [1472] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4355),
    [sym_comment] = ACTIONS(53),
  },
  [1473] = {
    [anon_sym_RBRACE] = ACTIONS(4355),
    [sym_comment] = ACTIONS(53),
  },
  [1474] = {
    [sym_concatenation] = STATE(1880),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1880),
    [anon_sym_RBRACE] = ACTIONS(4357),
    [anon_sym_EQ] = ACTIONS(4359),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4361),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4359),
    [anon_sym_COLON_QMARK] = ACTIONS(4359),
    [anon_sym_COLON_DASH] = ACTIONS(4359),
    [anon_sym_PERCENT] = ACTIONS(4359),
    [anon_sym_DASH] = ACTIONS(4359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1475] = {
    [sym_file_descriptor] = ACTIONS(2830),
    [sym__concat] = ACTIONS(2830),
    [sym_variable_name] = ACTIONS(2830),
    [anon_sym_PIPE] = ACTIONS(2832),
    [anon_sym_RPAREN] = ACTIONS(2832),
    [anon_sym_SEMI_SEMI] = ACTIONS(2832),
    [anon_sym_PIPE_AMP] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_PIPE_PIPE] = ACTIONS(2832),
    [anon_sym_LT] = ACTIONS(2832),
    [anon_sym_GT] = ACTIONS(2832),
    [anon_sym_GT_GT] = ACTIONS(2832),
    [anon_sym_AMP_GT] = ACTIONS(2832),
    [anon_sym_AMP_GT_GT] = ACTIONS(2832),
    [anon_sym_LT_AMP] = ACTIONS(2832),
    [anon_sym_GT_AMP] = ACTIONS(2832),
    [sym__special_characters] = ACTIONS(2832),
    [anon_sym_DQUOTE] = ACTIONS(2832),
    [anon_sym_DOLLAR] = ACTIONS(2832),
    [sym_raw_string] = ACTIONS(2832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2832),
    [anon_sym_BQUOTE] = ACTIONS(2832),
    [anon_sym_LT_LPAREN] = ACTIONS(2832),
    [anon_sym_GT_LPAREN] = ACTIONS(2832),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2832),
    [anon_sym_SEMI] = ACTIONS(2832),
    [anon_sym_LF] = ACTIONS(2830),
    [anon_sym_AMP] = ACTIONS(2832),
  },
  [1476] = {
    [sym_concatenation] = STATE(1883),
    [sym_string] = STATE(1882),
    [sym_simple_expansion] = STATE(1882),
    [sym_string_expansion] = STATE(1882),
    [sym_expansion] = STATE(1882),
    [sym_command_substitution] = STATE(1882),
    [sym_process_substitution] = STATE(1882),
    [anon_sym_RBRACE] = ACTIONS(4355),
    [sym__special_characters] = ACTIONS(4363),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(4365),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4365),
  },
  [1477] = {
    [sym_file_descriptor] = ACTIONS(2873),
    [sym__concat] = ACTIONS(2873),
    [sym_variable_name] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [anon_sym_PIPE_AMP] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT_GT] = ACTIONS(2875),
    [anon_sym_LT_AMP] = ACTIONS(2875),
    [anon_sym_GT_AMP] = ACTIONS(2875),
    [sym__special_characters] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2875),
    [anon_sym_BQUOTE] = ACTIONS(2875),
    [anon_sym_LT_LPAREN] = ACTIONS(2875),
    [anon_sym_GT_LPAREN] = ACTIONS(2875),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [1478] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4367),
  },
  [1479] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4369),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1480] = {
    [sym_file_descriptor] = ACTIONS(2881),
    [sym__concat] = ACTIONS(2881),
    [sym_variable_name] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_RPAREN] = ACTIONS(2883),
    [anon_sym_SEMI_SEMI] = ACTIONS(2883),
    [anon_sym_PIPE_AMP] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_GT_GT] = ACTIONS(2883),
    [anon_sym_AMP_GT] = ACTIONS(2883),
    [anon_sym_AMP_GT_GT] = ACTIONS(2883),
    [anon_sym_LT_AMP] = ACTIONS(2883),
    [anon_sym_GT_AMP] = ACTIONS(2883),
    [sym__special_characters] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [sym_raw_string] = ACTIONS(2883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2883),
    [anon_sym_BQUOTE] = ACTIONS(2883),
    [anon_sym_LT_LPAREN] = ACTIONS(2883),
    [anon_sym_GT_LPAREN] = ACTIONS(2883),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_LF] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
  },
  [1481] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4371),
  },
  [1482] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4373),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1483] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4375),
  },
  [1484] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4355),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1485] = {
    [sym_concatenation] = STATE(1890),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1890),
    [anon_sym_RBRACE] = ACTIONS(4377),
    [anon_sym_EQ] = ACTIONS(4379),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4381),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4379),
    [anon_sym_COLON_QMARK] = ACTIONS(4379),
    [anon_sym_COLON_DASH] = ACTIONS(4379),
    [anon_sym_PERCENT] = ACTIONS(4379),
    [anon_sym_DASH] = ACTIONS(4379),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1486] = {
    [sym_file_descriptor] = ACTIONS(2897),
    [sym__concat] = ACTIONS(2897),
    [sym_variable_name] = ACTIONS(2897),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_RPAREN] = ACTIONS(2899),
    [anon_sym_SEMI_SEMI] = ACTIONS(2899),
    [anon_sym_PIPE_AMP] = ACTIONS(2899),
    [anon_sym_AMP_AMP] = ACTIONS(2899),
    [anon_sym_PIPE_PIPE] = ACTIONS(2899),
    [anon_sym_LT] = ACTIONS(2899),
    [anon_sym_GT] = ACTIONS(2899),
    [anon_sym_GT_GT] = ACTIONS(2899),
    [anon_sym_AMP_GT] = ACTIONS(2899),
    [anon_sym_AMP_GT_GT] = ACTIONS(2899),
    [anon_sym_LT_AMP] = ACTIONS(2899),
    [anon_sym_GT_AMP] = ACTIONS(2899),
    [sym__special_characters] = ACTIONS(2899),
    [anon_sym_DQUOTE] = ACTIONS(2899),
    [anon_sym_DOLLAR] = ACTIONS(2899),
    [sym_raw_string] = ACTIONS(2899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2899),
    [anon_sym_BQUOTE] = ACTIONS(2899),
    [anon_sym_LT_LPAREN] = ACTIONS(2899),
    [anon_sym_GT_LPAREN] = ACTIONS(2899),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2899),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LF] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2899),
  },
  [1487] = {
    [sym_concatenation] = STATE(1892),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1892),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_EQ] = ACTIONS(4385),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4387),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4385),
    [anon_sym_COLON_QMARK] = ACTIONS(4385),
    [anon_sym_COLON_DASH] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1488] = {
    [sym__concat] = ACTIONS(1654),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LT_LPAREN] = ACTIONS(1656),
    [anon_sym_GT_LPAREN] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [1489] = {
    [aux_sym_concatenation_repeat1] = STATE(1489),
    [sym__concat] = ACTIONS(4389),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LT_LPAREN] = ACTIONS(1656),
    [anon_sym_GT_LPAREN] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [1490] = {
    [sym__concat] = ACTIONS(1703),
    [anon_sym_SEMI_SEMI] = ACTIONS(1705),
    [sym__special_characters] = ACTIONS(1705),
    [anon_sym_DQUOTE] = ACTIONS(1705),
    [anon_sym_DOLLAR] = ACTIONS(1705),
    [sym_raw_string] = ACTIONS(1705),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1705),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1705),
    [anon_sym_BQUOTE] = ACTIONS(1705),
    [anon_sym_LT_LPAREN] = ACTIONS(1705),
    [anon_sym_GT_LPAREN] = ACTIONS(1705),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1705),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_LF] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1705),
  },
  [1491] = {
    [sym_concatenation] = STATE(1896),
    [sym_string] = STATE(1895),
    [sym_simple_expansion] = STATE(1895),
    [sym_string_expansion] = STATE(1895),
    [sym_expansion] = STATE(1895),
    [sym_command_substitution] = STATE(1895),
    [sym_process_substitution] = STATE(1895),
    [anon_sym_RBRACE] = ACTIONS(4392),
    [sym__special_characters] = ACTIONS(4394),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(4396),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4396),
  },
  [1492] = {
    [sym__concat] = ACTIONS(1744),
    [anon_sym_SEMI_SEMI] = ACTIONS(1746),
    [sym__special_characters] = ACTIONS(1746),
    [anon_sym_DQUOTE] = ACTIONS(1746),
    [anon_sym_DOLLAR] = ACTIONS(1746),
    [sym_raw_string] = ACTIONS(1746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1746),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1746),
    [anon_sym_GT_LPAREN] = ACTIONS(1746),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1746),
    [anon_sym_SEMI] = ACTIONS(1746),
    [anon_sym_LF] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(1746),
  },
  [1493] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4398),
  },
  [1494] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4400),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1495] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(4402),
    [sym_comment] = ACTIONS(53),
  },
  [1496] = {
    [sym_concatenation] = STATE(1902),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1902),
    [anon_sym_RBRACE] = ACTIONS(4404),
    [anon_sym_EQ] = ACTIONS(4406),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4408),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4410),
    [anon_sym_COLON] = ACTIONS(4406),
    [anon_sym_COLON_QMARK] = ACTIONS(4406),
    [anon_sym_COLON_DASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4406),
    [anon_sym_DASH] = ACTIONS(4406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1497] = {
    [sym_concatenation] = STATE(1905),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1905),
    [anon_sym_RBRACE] = ACTIONS(4412),
    [anon_sym_EQ] = ACTIONS(4414),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4416),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4418),
    [anon_sym_COLON] = ACTIONS(4414),
    [anon_sym_COLON_QMARK] = ACTIONS(4414),
    [anon_sym_COLON_DASH] = ACTIONS(4414),
    [anon_sym_PERCENT] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1498] = {
    [sym_concatenation] = STATE(1907),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1907),
    [anon_sym_RBRACE] = ACTIONS(4392),
    [anon_sym_EQ] = ACTIONS(4420),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4422),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4424),
    [anon_sym_COLON] = ACTIONS(4420),
    [anon_sym_COLON_QMARK] = ACTIONS(4420),
    [anon_sym_COLON_DASH] = ACTIONS(4420),
    [anon_sym_PERCENT] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1499] = {
    [sym__concat] = ACTIONS(1810),
    [anon_sym_SEMI_SEMI] = ACTIONS(1812),
    [sym__special_characters] = ACTIONS(1812),
    [anon_sym_DQUOTE] = ACTIONS(1812),
    [anon_sym_DOLLAR] = ACTIONS(1812),
    [sym_raw_string] = ACTIONS(1812),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1812),
    [anon_sym_GT_LPAREN] = ACTIONS(1812),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1812),
    [anon_sym_SEMI] = ACTIONS(1812),
    [anon_sym_LF] = ACTIONS(1810),
    [anon_sym_AMP] = ACTIONS(1812),
  },
  [1500] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4426),
  },
  [1501] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4428),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1502] = {
    [sym__concat] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1820),
    [sym__special_characters] = ACTIONS(1820),
    [anon_sym_DQUOTE] = ACTIONS(1820),
    [anon_sym_DOLLAR] = ACTIONS(1820),
    [sym_raw_string] = ACTIONS(1820),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1820),
    [anon_sym_BQUOTE] = ACTIONS(1820),
    [anon_sym_LT_LPAREN] = ACTIONS(1820),
    [anon_sym_GT_LPAREN] = ACTIONS(1820),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1820),
    [anon_sym_LF] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1820),
  },
  [1503] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4430),
  },
  [1504] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4392),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1505] = {
    [sym__concat] = ACTIONS(1952),
    [anon_sym_SEMI_SEMI] = ACTIONS(1954),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1954),
    [anon_sym_DOLLAR] = ACTIONS(1954),
    [sym_raw_string] = ACTIONS(1954),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1954),
    [anon_sym_BQUOTE] = ACTIONS(1954),
    [anon_sym_LT_LPAREN] = ACTIONS(1954),
    [anon_sym_GT_LPAREN] = ACTIONS(1954),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1954),
    [anon_sym_SEMI] = ACTIONS(1954),
    [anon_sym_LF] = ACTIONS(1952),
    [anon_sym_AMP] = ACTIONS(1954),
  },
  [1506] = {
    [sym__concat] = ACTIONS(2018),
    [anon_sym_SEMI_SEMI] = ACTIONS(2020),
    [sym__special_characters] = ACTIONS(2020),
    [anon_sym_DQUOTE] = ACTIONS(2020),
    [anon_sym_DOLLAR] = ACTIONS(2020),
    [sym_raw_string] = ACTIONS(2020),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2020),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2020),
    [anon_sym_BQUOTE] = ACTIONS(2020),
    [anon_sym_LT_LPAREN] = ACTIONS(2020),
    [anon_sym_GT_LPAREN] = ACTIONS(2020),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2020),
    [anon_sym_SEMI] = ACTIONS(2020),
    [anon_sym_LF] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2020),
  },
  [1507] = {
    [anon_sym_esac] = ACTIONS(4432),
    [anon_sym_PIPE] = ACTIONS(4432),
    [anon_sym_RPAREN] = ACTIONS(4432),
    [anon_sym_SEMI_SEMI] = ACTIONS(4432),
    [anon_sym_PIPE_AMP] = ACTIONS(4432),
    [anon_sym_AMP_AMP] = ACTIONS(4432),
    [anon_sym_PIPE_PIPE] = ACTIONS(4432),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4432),
    [anon_sym_LF] = ACTIONS(4434),
    [anon_sym_AMP] = ACTIONS(4432),
  },
  [1508] = {
    [anon_sym_esac] = ACTIONS(3524),
    [anon_sym_PIPE] = ACTIONS(3524),
    [anon_sym_RPAREN] = ACTIONS(3524),
    [anon_sym_SEMI_SEMI] = ACTIONS(3524),
    [anon_sym_PIPE_AMP] = ACTIONS(3524),
    [anon_sym_AMP_AMP] = ACTIONS(3524),
    [anon_sym_PIPE_PIPE] = ACTIONS(3524),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3524),
    [anon_sym_LF] = ACTIONS(3522),
    [anon_sym_AMP] = ACTIONS(3524),
  },
  [1509] = {
    [sym__terminated_statement] = STATE(1911),
    [sym_for_statement] = STATE(607),
    [sym_while_statement] = STATE(607),
    [sym_if_statement] = STATE(607),
    [sym_case_statement] = STATE(607),
    [sym_function_definition] = STATE(607),
    [sym_subshell] = STATE(607),
    [sym_pipeline] = STATE(607),
    [sym_list] = STATE(607),
    [sym_negated_command] = STATE(607),
    [sym_test_command] = STATE(607),
    [sym_declaration_command] = STATE(607),
    [sym_unset_command] = STATE(607),
    [sym_command] = STATE(607),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(610),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1911),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(4436),
    [anon_sym_elif] = ACTIONS(4436),
    [anon_sym_else] = ACTIONS(4436),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1510] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_fi] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(953),
    [anon_sym_DQUOTE] = ACTIONS(951),
    [anon_sym_DOLLAR] = ACTIONS(953),
    [sym_raw_string] = ACTIONS(951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(951),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(951),
    [anon_sym_BQUOTE] = ACTIONS(951),
    [anon_sym_LT_LPAREN] = ACTIONS(951),
    [anon_sym_GT_LPAREN] = ACTIONS(951),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(953),
  },
  [1511] = {
    [sym__terminated_statement] = STATE(1511),
    [sym_for_statement] = STATE(1066),
    [sym_while_statement] = STATE(1066),
    [sym_if_statement] = STATE(1066),
    [sym_case_statement] = STATE(1066),
    [sym_function_definition] = STATE(1066),
    [sym_subshell] = STATE(1066),
    [sym_pipeline] = STATE(1066),
    [sym_list] = STATE(1066),
    [sym_negated_command] = STATE(1066),
    [sym_test_command] = STATE(1066),
    [sym_declaration_command] = STATE(1066),
    [sym_unset_command] = STATE(1066),
    [sym_command] = STATE(1066),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(1067),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1511),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(999),
    [sym_variable_name] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1010),
    [anon_sym_if] = ACTIONS(1013),
    [anon_sym_fi] = ACTIONS(3526),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1031),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_typeset] = ACTIONS(1034),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_local] = ACTIONS(1034),
    [anon_sym_unset] = ACTIONS(1037),
    [anon_sym_unsetenv] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_GT_GT] = ACTIONS(1043),
    [anon_sym_AMP_GT] = ACTIONS(1040),
    [anon_sym_AMP_GT_GT] = ACTIONS(1043),
    [anon_sym_LT_AMP] = ACTIONS(1043),
    [anon_sym_GT_AMP] = ACTIONS(1043),
    [sym__special_characters] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [sym_raw_string] = ACTIONS(1055),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1064),
    [anon_sym_LT_LPAREN] = ACTIONS(1067),
    [anon_sym_GT_LPAREN] = ACTIONS(1067),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1070),
  },
  [1512] = {
    [anon_sym_esac] = ACTIONS(4438),
    [anon_sym_PIPE] = ACTIONS(4438),
    [anon_sym_RPAREN] = ACTIONS(4438),
    [anon_sym_SEMI_SEMI] = ACTIONS(4438),
    [anon_sym_PIPE_AMP] = ACTIONS(4438),
    [anon_sym_AMP_AMP] = ACTIONS(4438),
    [anon_sym_PIPE_PIPE] = ACTIONS(4438),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4438),
    [anon_sym_LF] = ACTIONS(4440),
    [anon_sym_AMP] = ACTIONS(4438),
  },
  [1513] = {
    [anon_sym_fi] = ACTIONS(4442),
    [sym_comment] = ACTIONS(53),
  },
  [1514] = {
    [sym_concatenation] = STATE(1915),
    [sym_string] = STATE(1914),
    [sym_simple_expansion] = STATE(1914),
    [sym_string_expansion] = STATE(1914),
    [sym_expansion] = STATE(1914),
    [sym_command_substitution] = STATE(1914),
    [sym_process_substitution] = STATE(1914),
    [sym__special_characters] = ACTIONS(4444),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(4446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4446),
  },
  [1515] = {
    [sym__terminated_statement] = STATE(1939),
    [sym_for_statement] = STATE(1934),
    [sym_while_statement] = STATE(1934),
    [sym_if_statement] = STATE(1934),
    [sym_case_statement] = STATE(1934),
    [sym_function_definition] = STATE(1934),
    [sym_subshell] = STATE(1934),
    [sym_pipeline] = STATE(1934),
    [sym_list] = STATE(1934),
    [sym_negated_command] = STATE(1934),
    [sym_test_command] = STATE(1934),
    [sym_declaration_command] = STATE(1934),
    [sym_unset_command] = STATE(1934),
    [sym_command] = STATE(1934),
    [sym_command_name] = STATE(1935),
    [sym_variable_assignment] = STATE(1936),
    [sym_subscript] = STATE(1937),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1938),
    [sym_string] = STATE(1928),
    [sym_simple_expansion] = STATE(1928),
    [sym_string_expansion] = STATE(1928),
    [sym_expansion] = STATE(1928),
    [sym_command_substitution] = STATE(1928),
    [sym_process_substitution] = STATE(1928),
    [aux_sym_program_repeat1] = STATE(1939),
    [aux_sym_command_repeat1] = STATE(1940),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4448),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4450),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(4452),
    [anon_sym_SEMI_SEMI] = ACTIONS(4454),
    [anon_sym_function] = ACTIONS(4456),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4458),
    [anon_sym_LBRACK] = ACTIONS(4460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4462),
    [anon_sym_declare] = ACTIONS(4464),
    [anon_sym_typeset] = ACTIONS(4464),
    [anon_sym_export] = ACTIONS(4464),
    [anon_sym_readonly] = ACTIONS(4464),
    [anon_sym_local] = ACTIONS(4464),
    [anon_sym_unset] = ACTIONS(4466),
    [anon_sym_unsetenv] = ACTIONS(4466),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4468),
    [anon_sym_DQUOTE] = ACTIONS(4470),
    [anon_sym_DOLLAR] = ACTIONS(4472),
    [sym_raw_string] = ACTIONS(4474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4478),
    [anon_sym_BQUOTE] = ACTIONS(4480),
    [anon_sym_LT_LPAREN] = ACTIONS(4482),
    [anon_sym_GT_LPAREN] = ACTIONS(4482),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4484),
  },
  [1516] = {
    [aux_sym_case_item_repeat1] = STATE(1942),
    [anon_sym_PIPE] = ACTIONS(3555),
    [anon_sym_RPAREN] = ACTIONS(4486),
    [sym_comment] = ACTIONS(53),
  },
  [1517] = {
    [aux_sym_concatenation_repeat1] = STATE(1943),
    [sym__concat] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(693),
    [anon_sym_RPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
  },
  [1518] = {
    [sym__terminated_statement] = STATE(1947),
    [sym_for_statement] = STATE(1945),
    [sym_while_statement] = STATE(1945),
    [sym_if_statement] = STATE(1945),
    [sym_case_statement] = STATE(1945),
    [sym_function_definition] = STATE(1945),
    [sym_subshell] = STATE(1945),
    [sym_pipeline] = STATE(1945),
    [sym_list] = STATE(1945),
    [sym_negated_command] = STATE(1945),
    [sym_test_command] = STATE(1945),
    [sym_declaration_command] = STATE(1945),
    [sym_unset_command] = STATE(1945),
    [sym_command] = STATE(1945),
    [sym_command_name] = STATE(1935),
    [sym_variable_assignment] = STATE(1946),
    [sym_subscript] = STATE(1937),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1938),
    [sym_string] = STATE(1928),
    [sym_simple_expansion] = STATE(1928),
    [sym_string_expansion] = STATE(1928),
    [sym_expansion] = STATE(1928),
    [sym_command_substitution] = STATE(1928),
    [sym_process_substitution] = STATE(1928),
    [aux_sym_program_repeat1] = STATE(1947),
    [aux_sym_command_repeat1] = STATE(1940),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4448),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4450),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(4488),
    [anon_sym_SEMI_SEMI] = ACTIONS(4490),
    [anon_sym_function] = ACTIONS(4456),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4458),
    [anon_sym_LBRACK] = ACTIONS(4460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4462),
    [anon_sym_declare] = ACTIONS(4464),
    [anon_sym_typeset] = ACTIONS(4464),
    [anon_sym_export] = ACTIONS(4464),
    [anon_sym_readonly] = ACTIONS(4464),
    [anon_sym_local] = ACTIONS(4464),
    [anon_sym_unset] = ACTIONS(4466),
    [anon_sym_unsetenv] = ACTIONS(4466),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4468),
    [anon_sym_DQUOTE] = ACTIONS(4470),
    [anon_sym_DOLLAR] = ACTIONS(4472),
    [sym_raw_string] = ACTIONS(4474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4478),
    [anon_sym_BQUOTE] = ACTIONS(4480),
    [anon_sym_LT_LPAREN] = ACTIONS(4482),
    [anon_sym_GT_LPAREN] = ACTIONS(4482),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4484),
  },
  [1519] = {
    [aux_sym_case_item_repeat1] = STATE(1942),
    [anon_sym_PIPE] = ACTIONS(3555),
    [anon_sym_RPAREN] = ACTIONS(4492),
    [sym_comment] = ACTIONS(53),
  },
  [1520] = {
    [anon_sym_esac] = ACTIONS(4494),
    [anon_sym_PIPE] = ACTIONS(4494),
    [anon_sym_RPAREN] = ACTIONS(4494),
    [anon_sym_SEMI_SEMI] = ACTIONS(4494),
    [anon_sym_PIPE_AMP] = ACTIONS(4494),
    [anon_sym_AMP_AMP] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE] = ACTIONS(4494),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4494),
    [anon_sym_LF] = ACTIONS(4496),
    [anon_sym_AMP] = ACTIONS(4494),
  },
  [1521] = {
    [anon_sym_esac] = ACTIONS(4498),
    [sym_comment] = ACTIONS(53),
  },
  [1522] = {
    [sym_case_item] = STATE(1522),
    [sym_concatenation] = STATE(1952),
    [sym_string] = STATE(1951),
    [sym_simple_expansion] = STATE(1951),
    [sym_string_expansion] = STATE(1951),
    [sym_expansion] = STATE(1951),
    [sym_command_substitution] = STATE(1951),
    [sym_process_substitution] = STATE(1951),
    [aux_sym_case_statement_repeat1] = STATE(1522),
    [sym__special_characters] = ACTIONS(4500),
    [anon_sym_DQUOTE] = ACTIONS(4503),
    [anon_sym_DOLLAR] = ACTIONS(4506),
    [sym_raw_string] = ACTIONS(4509),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4515),
    [anon_sym_BQUOTE] = ACTIONS(4518),
    [anon_sym_LT_LPAREN] = ACTIONS(4521),
    [anon_sym_GT_LPAREN] = ACTIONS(4521),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4509),
  },
  [1523] = {
    [anon_sym_esac] = ACTIONS(4524),
    [anon_sym_PIPE] = ACTIONS(4524),
    [anon_sym_RPAREN] = ACTIONS(4524),
    [anon_sym_SEMI_SEMI] = ACTIONS(4524),
    [anon_sym_PIPE_AMP] = ACTIONS(4524),
    [anon_sym_AMP_AMP] = ACTIONS(4524),
    [anon_sym_PIPE_PIPE] = ACTIONS(4524),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4524),
    [anon_sym_LF] = ACTIONS(4526),
    [anon_sym_AMP] = ACTIONS(4524),
  },
  [1524] = {
    [sym_case_item] = STATE(1522),
    [sym_last_case_item] = STATE(1953),
    [sym_concatenation] = STATE(1079),
    [sym_string] = STATE(1077),
    [sym_simple_expansion] = STATE(1077),
    [sym_string_expansion] = STATE(1077),
    [sym_expansion] = STATE(1077),
    [sym_command_substitution] = STATE(1077),
    [sym_process_substitution] = STATE(1077),
    [aux_sym_case_statement_repeat1] = STATE(1522),
    [sym__special_characters] = ACTIONS(2299),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2301),
  },
  [1525] = {
    [anon_sym_esac] = ACTIONS(4528),
    [anon_sym_PIPE] = ACTIONS(4528),
    [anon_sym_RPAREN] = ACTIONS(4528),
    [anon_sym_SEMI_SEMI] = ACTIONS(4528),
    [anon_sym_PIPE_AMP] = ACTIONS(4528),
    [anon_sym_AMP_AMP] = ACTIONS(4528),
    [anon_sym_PIPE_PIPE] = ACTIONS(4528),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4528),
    [anon_sym_LF] = ACTIONS(4530),
    [anon_sym_AMP] = ACTIONS(4528),
  },
  [1526] = {
    [anon_sym_esac] = ACTIONS(4532),
    [sym_comment] = ACTIONS(53),
  },
  [1527] = {
    [anon_sym_esac] = ACTIONS(4534),
    [anon_sym_PIPE] = ACTIONS(4534),
    [anon_sym_RPAREN] = ACTIONS(4534),
    [anon_sym_SEMI_SEMI] = ACTIONS(4534),
    [anon_sym_PIPE_AMP] = ACTIONS(4534),
    [anon_sym_AMP_AMP] = ACTIONS(4534),
    [anon_sym_PIPE_PIPE] = ACTIONS(4534),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4534),
    [anon_sym_LF] = ACTIONS(4536),
    [anon_sym_AMP] = ACTIONS(4534),
  },
  [1528] = {
    [sym_case_item] = STATE(1522),
    [sym_last_case_item] = STATE(1955),
    [sym_concatenation] = STATE(1079),
    [sym_string] = STATE(1077),
    [sym_simple_expansion] = STATE(1077),
    [sym_string_expansion] = STATE(1077),
    [sym_expansion] = STATE(1077),
    [sym_command_substitution] = STATE(1077),
    [sym_process_substitution] = STATE(1077),
    [aux_sym_case_statement_repeat1] = STATE(1522),
    [sym__special_characters] = ACTIONS(2299),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2301),
  },
  [1529] = {
    [sym__concat] = ACTIONS(3917),
    [anon_sym_in] = ACTIONS(3919),
    [anon_sym_SEMI_SEMI] = ACTIONS(3919),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3919),
    [anon_sym_LF] = ACTIONS(3917),
    [anon_sym_AMP] = ACTIONS(3919),
  },
  [1530] = {
    [sym__concat] = ACTIONS(3923),
    [anon_sym_in] = ACTIONS(3925),
    [anon_sym_SEMI_SEMI] = ACTIONS(3925),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3925),
    [anon_sym_LF] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3925),
  },
  [1531] = {
    [sym__concat] = ACTIONS(4008),
    [anon_sym_in] = ACTIONS(4010),
    [anon_sym_SEMI_SEMI] = ACTIONS(4010),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LF] = ACTIONS(4008),
    [anon_sym_AMP] = ACTIONS(4010),
  },
  [1532] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4538),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1533] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4540),
    [sym_comment] = ACTIONS(53),
  },
  [1534] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4542),
    [sym_comment] = ACTIONS(53),
  },
  [1535] = {
    [anon_sym_RBRACE] = ACTIONS(4542),
    [sym_comment] = ACTIONS(53),
  },
  [1536] = {
    [sym_concatenation] = STATE(1960),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1960),
    [anon_sym_RBRACE] = ACTIONS(4544),
    [anon_sym_EQ] = ACTIONS(4546),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4546),
    [anon_sym_COLON_QMARK] = ACTIONS(4546),
    [anon_sym_COLON_DASH] = ACTIONS(4546),
    [anon_sym_PERCENT] = ACTIONS(4546),
    [anon_sym_DASH] = ACTIONS(4546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1537] = {
    [sym__concat] = ACTIONS(4024),
    [anon_sym_in] = ACTIONS(4026),
    [anon_sym_SEMI_SEMI] = ACTIONS(4026),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4026),
    [anon_sym_LF] = ACTIONS(4024),
    [anon_sym_AMP] = ACTIONS(4026),
  },
  [1538] = {
    [sym_concatenation] = STATE(1962),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1962),
    [anon_sym_RBRACE] = ACTIONS(4550),
    [anon_sym_EQ] = ACTIONS(4552),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4552),
    [anon_sym_COLON_QMARK] = ACTIONS(4552),
    [anon_sym_COLON_DASH] = ACTIONS(4552),
    [anon_sym_PERCENT] = ACTIONS(4552),
    [anon_sym_DASH] = ACTIONS(4552),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1539] = {
    [sym__concat] = ACTIONS(4034),
    [anon_sym_in] = ACTIONS(4036),
    [anon_sym_SEMI_SEMI] = ACTIONS(4036),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4036),
    [anon_sym_LF] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
  },
  [1540] = {
    [sym_concatenation] = STATE(1964),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1964),
    [anon_sym_RBRACE] = ACTIONS(4556),
    [anon_sym_EQ] = ACTIONS(4558),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4560),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4558),
    [anon_sym_COLON_QMARK] = ACTIONS(4558),
    [anon_sym_COLON_DASH] = ACTIONS(4558),
    [anon_sym_PERCENT] = ACTIONS(4558),
    [anon_sym_DASH] = ACTIONS(4558),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1541] = {
    [sym__concat] = ACTIONS(4044),
    [anon_sym_in] = ACTIONS(4046),
    [anon_sym_SEMI_SEMI] = ACTIONS(4046),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4046),
    [anon_sym_LF] = ACTIONS(4044),
    [anon_sym_AMP] = ACTIONS(4046),
  },
  [1542] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4562),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1543] = {
    [sym__concat] = ACTIONS(4050),
    [anon_sym_in] = ACTIONS(4052),
    [anon_sym_SEMI_SEMI] = ACTIONS(4052),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4052),
    [anon_sym_LF] = ACTIONS(4050),
    [anon_sym_AMP] = ACTIONS(4052),
  },
  [1544] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4564),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1545] = {
    [anon_sym_esac] = ACTIONS(4566),
    [anon_sym_PIPE] = ACTIONS(4566),
    [anon_sym_RPAREN] = ACTIONS(4566),
    [anon_sym_SEMI_SEMI] = ACTIONS(4566),
    [anon_sym_PIPE_AMP] = ACTIONS(4566),
    [anon_sym_AMP_AMP] = ACTIONS(4566),
    [anon_sym_PIPE_PIPE] = ACTIONS(4566),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4566),
    [anon_sym_LF] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4566),
  },
  [1546] = {
    [aux_sym_concatenation_repeat1] = STATE(1549),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [1547] = {
    [aux_sym_concatenation_repeat1] = STATE(1549),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [1548] = {
    [anon_sym_esac] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [1549] = {
    [aux_sym_concatenation_repeat1] = STATE(1967),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [1550] = {
    [aux_sym_concatenation_repeat1] = STATE(1550),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(3409),
    [sym_variable_name] = ACTIONS(1654),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1656),
    [anon_sym_LT_AMP] = ACTIONS(1656),
    [anon_sym_GT_AMP] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LT_LPAREN] = ACTIONS(1656),
    [anon_sym_GT_LPAREN] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [1551] = {
    [sym_file_redirect] = STATE(1545),
    [sym_file_descriptor] = ACTIONS(2382),
    [anon_sym_PIPE] = ACTIONS(3609),
    [anon_sym_RPAREN] = ACTIONS(3609),
    [anon_sym_SEMI_SEMI] = ACTIONS(3609),
    [anon_sym_PIPE_AMP] = ACTIONS(3609),
    [anon_sym_AMP_AMP] = ACTIONS(3609),
    [anon_sym_PIPE_PIPE] = ACTIONS(3609),
    [anon_sym_LT] = ACTIONS(2384),
    [anon_sym_GT] = ACTIONS(2384),
    [anon_sym_GT_GT] = ACTIONS(2384),
    [anon_sym_AMP_GT] = ACTIONS(2384),
    [anon_sym_AMP_GT_GT] = ACTIONS(2384),
    [anon_sym_LT_AMP] = ACTIONS(2384),
    [anon_sym_GT_AMP] = ACTIONS(2384),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3609),
    [anon_sym_LF] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3609),
  },
  [1552] = {
    [sym_concatenation] = STATE(1548),
    [sym_string] = STATE(1969),
    [sym_simple_expansion] = STATE(1969),
    [sym_string_expansion] = STATE(1969),
    [sym_expansion] = STATE(1969),
    [sym_command_substitution] = STATE(1969),
    [sym_process_substitution] = STATE(1969),
    [sym__special_characters] = ACTIONS(4570),
    [anon_sym_DQUOTE] = ACTIONS(629),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(4572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1533),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1535),
    [anon_sym_BQUOTE] = ACTIONS(1537),
    [anon_sym_LT_LPAREN] = ACTIONS(1539),
    [anon_sym_GT_LPAREN] = ACTIONS(1539),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4572),
  },
  [1553] = {
    [aux_sym_concatenation_repeat1] = STATE(1970),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(665),
    [anon_sym_AMP_AMP] = ACTIONS(665),
    [anon_sym_PIPE_PIPE] = ACTIONS(665),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [1554] = {
    [aux_sym_concatenation_repeat1] = STATE(1970),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [1555] = {
    [sym_concatenation] = STATE(1581),
    [sym_string] = STATE(1972),
    [sym_simple_expansion] = STATE(1972),
    [sym_string_expansion] = STATE(1972),
    [sym_expansion] = STATE(1972),
    [sym_command_substitution] = STATE(1972),
    [sym_process_substitution] = STATE(1972),
    [sym__special_characters] = ACTIONS(4574),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(4576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2508),
    [anon_sym_BQUOTE] = ACTIONS(2510),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4576),
  },
  [1556] = {
    [aux_sym_concatenation_repeat1] = STATE(1973),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(3687),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(665),
    [anon_sym_AMP_AMP] = ACTIONS(665),
    [anon_sym_PIPE_PIPE] = ACTIONS(665),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(665),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(665),
    [anon_sym_LT_AMP] = ACTIONS(665),
    [anon_sym_GT_AMP] = ACTIONS(665),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(665),
    [anon_sym_LT_LT_LT] = ACTIONS(665),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [1557] = {
    [aux_sym_concatenation_repeat1] = STATE(1973),
    [sym_file_descriptor] = ACTIONS(677),
    [sym__concat] = ACTIONS(3687),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [1558] = {
    [aux_sym_concatenation_repeat1] = STATE(1973),
    [sym_file_descriptor] = ACTIONS(2070),
    [sym__concat] = ACTIONS(3687),
    [anon_sym_PIPE] = ACTIONS(2072),
    [anon_sym_RPAREN] = ACTIONS(2072),
    [anon_sym_SEMI_SEMI] = ACTIONS(2072),
    [anon_sym_PIPE_AMP] = ACTIONS(2072),
    [anon_sym_AMP_AMP] = ACTIONS(2072),
    [anon_sym_PIPE_PIPE] = ACTIONS(2072),
    [anon_sym_LT] = ACTIONS(2072),
    [anon_sym_GT] = ACTIONS(2072),
    [anon_sym_GT_GT] = ACTIONS(2072),
    [anon_sym_AMP_GT] = ACTIONS(2072),
    [anon_sym_AMP_GT_GT] = ACTIONS(2072),
    [anon_sym_LT_AMP] = ACTIONS(2072),
    [anon_sym_GT_AMP] = ACTIONS(2072),
    [anon_sym_LT_LT] = ACTIONS(2072),
    [anon_sym_LT_LT_DASH] = ACTIONS(2072),
    [anon_sym_LT_LT_LT] = ACTIONS(2072),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2072),
    [anon_sym_LF] = ACTIONS(2070),
    [anon_sym_AMP] = ACTIONS(2072),
  },
  [1559] = {
    [aux_sym_concatenation_repeat1] = STATE(1973),
    [sym_file_descriptor] = ACTIONS(2074),
    [sym__concat] = ACTIONS(3687),
    [anon_sym_PIPE] = ACTIONS(2076),
    [anon_sym_RPAREN] = ACTIONS(2076),
    [anon_sym_SEMI_SEMI] = ACTIONS(2076),
    [anon_sym_PIPE_AMP] = ACTIONS(2076),
    [anon_sym_AMP_AMP] = ACTIONS(2076),
    [anon_sym_PIPE_PIPE] = ACTIONS(2076),
    [anon_sym_LT] = ACTIONS(2076),
    [anon_sym_GT] = ACTIONS(2076),
    [anon_sym_GT_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT_GT] = ACTIONS(2076),
    [anon_sym_LT_AMP] = ACTIONS(2076),
    [anon_sym_GT_AMP] = ACTIONS(2076),
    [anon_sym_LT_LT] = ACTIONS(2076),
    [anon_sym_LT_LT_DASH] = ACTIONS(2076),
    [anon_sym_LT_LT_LT] = ACTIONS(2076),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2076),
    [anon_sym_LF] = ACTIONS(2074),
    [anon_sym_AMP] = ACTIONS(2076),
  },
  [1560] = {
    [sym_file_redirect] = STATE(1560),
    [sym_heredoc_redirect] = STATE(1560),
    [sym_herestring_redirect] = STATE(1560),
    [aux_sym_while_statement_repeat1] = STATE(1560),
    [sym_file_descriptor] = ACTIONS(4578),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_RPAREN] = ACTIONS(2087),
    [anon_sym_SEMI_SEMI] = ACTIONS(2087),
    [anon_sym_PIPE_AMP] = ACTIONS(2087),
    [anon_sym_AMP_AMP] = ACTIONS(2087),
    [anon_sym_PIPE_PIPE] = ACTIONS(2087),
    [anon_sym_LT] = ACTIONS(4581),
    [anon_sym_GT] = ACTIONS(4581),
    [anon_sym_GT_GT] = ACTIONS(4581),
    [anon_sym_AMP_GT] = ACTIONS(4581),
    [anon_sym_AMP_GT_GT] = ACTIONS(4581),
    [anon_sym_LT_AMP] = ACTIONS(4581),
    [anon_sym_GT_AMP] = ACTIONS(4581),
    [anon_sym_LT_LT] = ACTIONS(3715),
    [anon_sym_LT_LT_DASH] = ACTIONS(3715),
    [anon_sym_LT_LT_LT] = ACTIONS(4584),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2087),
    [anon_sym_LF] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2087),
  },
  [1561] = {
    [aux_sym_concatenation_repeat1] = STATE(1561),
    [sym__simple_heredoc_body] = ACTIONS(1654),
    [sym__heredoc_body_beginning] = ACTIONS(1654),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(1658),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1656),
    [anon_sym_LT_AMP] = ACTIONS(1656),
    [anon_sym_GT_AMP] = ACTIONS(1656),
    [anon_sym_LT_LT] = ACTIONS(1656),
    [anon_sym_LT_LT_DASH] = ACTIONS(1656),
    [anon_sym_LT_LT_LT] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [1562] = {
    [sym_file_descriptor] = ACTIONS(3379),
    [sym_variable_name] = ACTIONS(3379),
    [anon_sym_PIPE] = ACTIONS(3381),
    [anon_sym_RPAREN] = ACTIONS(3379),
    [anon_sym_PIPE_AMP] = ACTIONS(3379),
    [anon_sym_AMP_AMP] = ACTIONS(3379),
    [anon_sym_PIPE_PIPE] = ACTIONS(3379),
    [anon_sym_LT] = ACTIONS(3381),
    [anon_sym_GT] = ACTIONS(3381),
    [anon_sym_GT_GT] = ACTIONS(3379),
    [anon_sym_AMP_GT] = ACTIONS(3381),
    [anon_sym_AMP_GT_GT] = ACTIONS(3379),
    [anon_sym_LT_AMP] = ACTIONS(3379),
    [anon_sym_GT_AMP] = ACTIONS(3379),
    [sym__special_characters] = ACTIONS(3379),
    [anon_sym_DQUOTE] = ACTIONS(3379),
    [anon_sym_DOLLAR] = ACTIONS(3381),
    [sym_raw_string] = ACTIONS(3379),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3379),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3379),
    [anon_sym_BQUOTE] = ACTIONS(3379),
    [anon_sym_LT_LPAREN] = ACTIONS(3379),
    [anon_sym_GT_LPAREN] = ACTIONS(3379),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3379),
  },
  [1563] = {
    [sym__concat] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_RBRACK] = ACTIONS(3917),
    [anon_sym_EQ_TILDE] = ACTIONS(3917),
    [anon_sym_EQ_EQ] = ACTIONS(3917),
    [anon_sym_EQ] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3917),
    [anon_sym_GT] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3917),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3917),
  },
  [1564] = {
    [sym__concat] = ACTIONS(3923),
    [anon_sym_AMP_AMP] = ACTIONS(3923),
    [anon_sym_PIPE_PIPE] = ACTIONS(3923),
    [anon_sym_RBRACK] = ACTIONS(3923),
    [anon_sym_EQ_TILDE] = ACTIONS(3923),
    [anon_sym_EQ_EQ] = ACTIONS(3923),
    [anon_sym_EQ] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_GT] = ACTIONS(3923),
    [anon_sym_BANG_EQ] = ACTIONS(3923),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3923),
  },
  [1565] = {
    [sym__concat] = ACTIONS(4008),
    [anon_sym_AMP_AMP] = ACTIONS(4008),
    [anon_sym_PIPE_PIPE] = ACTIONS(4008),
    [anon_sym_RBRACK] = ACTIONS(4008),
    [anon_sym_EQ_TILDE] = ACTIONS(4008),
    [anon_sym_EQ_EQ] = ACTIONS(4008),
    [anon_sym_EQ] = ACTIONS(4010),
    [anon_sym_LT] = ACTIONS(4008),
    [anon_sym_GT] = ACTIONS(4008),
    [anon_sym_BANG_EQ] = ACTIONS(4008),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4008),
  },
  [1566] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4587),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1567] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4589),
    [sym_comment] = ACTIONS(53),
  },
  [1568] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4591),
    [sym_comment] = ACTIONS(53),
  },
  [1569] = {
    [anon_sym_RBRACE] = ACTIONS(4591),
    [sym_comment] = ACTIONS(53),
  },
  [1570] = {
    [sym_concatenation] = STATE(1978),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1978),
    [anon_sym_RBRACE] = ACTIONS(4593),
    [anon_sym_EQ] = ACTIONS(4595),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4597),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4595),
    [anon_sym_COLON_QMARK] = ACTIONS(4595),
    [anon_sym_COLON_DASH] = ACTIONS(4595),
    [anon_sym_PERCENT] = ACTIONS(4595),
    [anon_sym_DASH] = ACTIONS(4595),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1571] = {
    [sym__concat] = ACTIONS(4024),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_EQ_TILDE] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_EQ] = ACTIONS(4026),
    [anon_sym_LT] = ACTIONS(4024),
    [anon_sym_GT] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4024),
  },
  [1572] = {
    [sym_concatenation] = STATE(1980),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1980),
    [anon_sym_RBRACE] = ACTIONS(4599),
    [anon_sym_EQ] = ACTIONS(4601),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4603),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4601),
    [anon_sym_COLON_QMARK] = ACTIONS(4601),
    [anon_sym_COLON_DASH] = ACTIONS(4601),
    [anon_sym_PERCENT] = ACTIONS(4601),
    [anon_sym_DASH] = ACTIONS(4601),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1573] = {
    [sym__concat] = ACTIONS(4034),
    [anon_sym_AMP_AMP] = ACTIONS(4034),
    [anon_sym_PIPE_PIPE] = ACTIONS(4034),
    [anon_sym_RBRACK] = ACTIONS(4034),
    [anon_sym_EQ_TILDE] = ACTIONS(4034),
    [anon_sym_EQ_EQ] = ACTIONS(4034),
    [anon_sym_EQ] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_BANG_EQ] = ACTIONS(4034),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4034),
  },
  [1574] = {
    [sym_concatenation] = STATE(1982),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1982),
    [anon_sym_RBRACE] = ACTIONS(4605),
    [anon_sym_EQ] = ACTIONS(4607),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4609),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4607),
    [anon_sym_COLON_QMARK] = ACTIONS(4607),
    [anon_sym_COLON_DASH] = ACTIONS(4607),
    [anon_sym_PERCENT] = ACTIONS(4607),
    [anon_sym_DASH] = ACTIONS(4607),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1575] = {
    [sym__concat] = ACTIONS(4044),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [anon_sym_RBRACK] = ACTIONS(4044),
    [anon_sym_EQ_TILDE] = ACTIONS(4044),
    [anon_sym_EQ_EQ] = ACTIONS(4044),
    [anon_sym_EQ] = ACTIONS(4046),
    [anon_sym_LT] = ACTIONS(4044),
    [anon_sym_GT] = ACTIONS(4044),
    [anon_sym_BANG_EQ] = ACTIONS(4044),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4044),
  },
  [1576] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4611),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1577] = {
    [sym__concat] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_RBRACK] = ACTIONS(4050),
    [anon_sym_EQ_TILDE] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4050),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4050),
    [anon_sym_GT] = ACTIONS(4050),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4050),
  },
  [1578] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4613),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1579] = {
    [aux_sym_concatenation_repeat1] = STATE(1583),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(3687),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [1580] = {
    [aux_sym_concatenation_repeat1] = STATE(1583),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(3687),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [1581] = {
    [sym_file_descriptor] = ACTIONS(1093),
    [anon_sym_esac] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [1582] = {
    [sym_string] = STATE(1985),
    [sym_simple_expansion] = STATE(1985),
    [sym_string_expansion] = STATE(1985),
    [sym_expansion] = STATE(1985),
    [sym_command_substitution] = STATE(1985),
    [sym_process_substitution] = STATE(1985),
    [sym__special_characters] = ACTIONS(4615),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(4615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2508),
    [anon_sym_BQUOTE] = ACTIONS(2510),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4615),
  },
  [1583] = {
    [aux_sym_concatenation_repeat1] = STATE(1986),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(3687),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [1584] = {
    [sym_file_descriptor] = ACTIONS(697),
    [sym__concat] = ACTIONS(697),
    [anon_sym_esac] = ACTIONS(699),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_GT] = ACTIONS(699),
    [anon_sym_AMP_GT_GT] = ACTIONS(699),
    [anon_sym_LT_AMP] = ACTIONS(699),
    [anon_sym_GT_AMP] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_LT_LT_DASH] = ACTIONS(699),
    [anon_sym_LT_LT_LT] = ACTIONS(699),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_LF] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [1585] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(4617),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [1586] = {
    [sym_file_descriptor] = ACTIONS(727),
    [sym__concat] = ACTIONS(727),
    [anon_sym_esac] = ACTIONS(729),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(729),
    [anon_sym_PIPE_AMP] = ACTIONS(729),
    [anon_sym_AMP_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(729),
    [anon_sym_LT] = ACTIONS(729),
    [anon_sym_GT] = ACTIONS(729),
    [anon_sym_GT_GT] = ACTIONS(729),
    [anon_sym_AMP_GT] = ACTIONS(729),
    [anon_sym_AMP_GT_GT] = ACTIONS(729),
    [anon_sym_LT_AMP] = ACTIONS(729),
    [anon_sym_GT_AMP] = ACTIONS(729),
    [anon_sym_LT_LT] = ACTIONS(729),
    [anon_sym_LT_LT_DASH] = ACTIONS(729),
    [anon_sym_LT_LT_LT] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_LF] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
  },
  [1587] = {
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(731),
    [anon_sym_esac] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(733),
    [anon_sym_LT_LT_LT] = ACTIONS(733),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [1588] = {
    [sym_file_descriptor] = ACTIONS(735),
    [sym__concat] = ACTIONS(735),
    [anon_sym_esac] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(737),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(737),
    [anon_sym_LT_AMP] = ACTIONS(737),
    [anon_sym_GT_AMP] = ACTIONS(737),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_LT_LT_DASH] = ACTIONS(737),
    [anon_sym_LT_LT_LT] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [1589] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(4619),
    [sym_comment] = ACTIONS(53),
  },
  [1590] = {
    [sym_concatenation] = STATE(1991),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1991),
    [anon_sym_RBRACE] = ACTIONS(4621),
    [anon_sym_EQ] = ACTIONS(4623),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4627),
    [anon_sym_COLON] = ACTIONS(4623),
    [anon_sym_COLON_QMARK] = ACTIONS(4623),
    [anon_sym_COLON_DASH] = ACTIONS(4623),
    [anon_sym_PERCENT] = ACTIONS(4623),
    [anon_sym_DASH] = ACTIONS(4623),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1591] = {
    [sym_subscript] = STATE(1995),
    [sym_variable_name] = ACTIONS(4629),
    [anon_sym_DOLLAR] = ACTIONS(4631),
    [anon_sym_DASH] = ACTIONS(4631),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4633),
    [anon_sym_STAR] = ACTIONS(4631),
    [anon_sym_AT] = ACTIONS(4631),
    [anon_sym_QMARK] = ACTIONS(4631),
    [anon_sym_0] = ACTIONS(4635),
    [anon_sym__] = ACTIONS(4635),
  },
  [1592] = {
    [sym_concatenation] = STATE(1998),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(1998),
    [anon_sym_RBRACE] = ACTIONS(4637),
    [anon_sym_EQ] = ACTIONS(4639),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4641),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4643),
    [anon_sym_COLON] = ACTIONS(4639),
    [anon_sym_COLON_QMARK] = ACTIONS(4639),
    [anon_sym_COLON_DASH] = ACTIONS(4639),
    [anon_sym_PERCENT] = ACTIONS(4639),
    [anon_sym_DASH] = ACTIONS(4639),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1593] = {
    [sym_concatenation] = STATE(2001),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2001),
    [anon_sym_RBRACE] = ACTIONS(4645),
    [anon_sym_EQ] = ACTIONS(4647),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4649),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4651),
    [anon_sym_COLON] = ACTIONS(4647),
    [anon_sym_COLON_QMARK] = ACTIONS(4647),
    [anon_sym_COLON_DASH] = ACTIONS(4647),
    [anon_sym_PERCENT] = ACTIONS(4647),
    [anon_sym_DASH] = ACTIONS(4647),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1594] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(4653),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [1595] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(4653),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [1596] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(4653),
    [sym_comment] = ACTIONS(53),
  },
  [1597] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(4653),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [1598] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(4655),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [1599] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(4655),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [1600] = {
    [sym__concat] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3919),
    [anon_sym_RPAREN] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3917),
    [anon_sym_EQ_TILDE] = ACTIONS(3917),
    [anon_sym_EQ_EQ] = ACTIONS(3917),
    [anon_sym_EQ] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3917),
    [anon_sym_GT] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3917),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3917),
  },
  [1601] = {
    [sym__concat] = ACTIONS(3923),
    [anon_sym_PIPE] = ACTIONS(3925),
    [anon_sym_RPAREN] = ACTIONS(3923),
    [anon_sym_AMP_AMP] = ACTIONS(3923),
    [anon_sym_PIPE_PIPE] = ACTIONS(3923),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3923),
    [anon_sym_EQ_TILDE] = ACTIONS(3923),
    [anon_sym_EQ_EQ] = ACTIONS(3923),
    [anon_sym_EQ] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_GT] = ACTIONS(3923),
    [anon_sym_BANG_EQ] = ACTIONS(3923),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3923),
  },
  [1602] = {
    [sym__concat] = ACTIONS(4008),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_RPAREN] = ACTIONS(4008),
    [anon_sym_AMP_AMP] = ACTIONS(4008),
    [anon_sym_PIPE_PIPE] = ACTIONS(4008),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4008),
    [anon_sym_EQ_TILDE] = ACTIONS(4008),
    [anon_sym_EQ_EQ] = ACTIONS(4008),
    [anon_sym_EQ] = ACTIONS(4010),
    [anon_sym_LT] = ACTIONS(4008),
    [anon_sym_GT] = ACTIONS(4008),
    [anon_sym_BANG_EQ] = ACTIONS(4008),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4008),
  },
  [1603] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4657),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1604] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4659),
    [sym_comment] = ACTIONS(53),
  },
  [1605] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4661),
    [sym_comment] = ACTIONS(53),
  },
  [1606] = {
    [anon_sym_RBRACE] = ACTIONS(4661),
    [sym_comment] = ACTIONS(53),
  },
  [1607] = {
    [sym_concatenation] = STATE(2008),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2008),
    [anon_sym_RBRACE] = ACTIONS(4663),
    [anon_sym_EQ] = ACTIONS(4665),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4665),
    [anon_sym_COLON_QMARK] = ACTIONS(4665),
    [anon_sym_COLON_DASH] = ACTIONS(4665),
    [anon_sym_PERCENT] = ACTIONS(4665),
    [anon_sym_DASH] = ACTIONS(4665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1608] = {
    [sym__concat] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4024),
    [anon_sym_EQ_TILDE] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4024),
    [anon_sym_EQ] = ACTIONS(4026),
    [anon_sym_LT] = ACTIONS(4024),
    [anon_sym_GT] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4024),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4024),
  },
  [1609] = {
    [sym_concatenation] = STATE(2010),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2010),
    [anon_sym_RBRACE] = ACTIONS(4669),
    [anon_sym_EQ] = ACTIONS(4671),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4673),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4671),
    [anon_sym_COLON_QMARK] = ACTIONS(4671),
    [anon_sym_COLON_DASH] = ACTIONS(4671),
    [anon_sym_PERCENT] = ACTIONS(4671),
    [anon_sym_DASH] = ACTIONS(4671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1610] = {
    [sym__concat] = ACTIONS(4034),
    [anon_sym_PIPE] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4034),
    [anon_sym_AMP_AMP] = ACTIONS(4034),
    [anon_sym_PIPE_PIPE] = ACTIONS(4034),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4034),
    [anon_sym_EQ_TILDE] = ACTIONS(4034),
    [anon_sym_EQ_EQ] = ACTIONS(4034),
    [anon_sym_EQ] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_BANG_EQ] = ACTIONS(4034),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4034),
  },
  [1611] = {
    [sym_concatenation] = STATE(2012),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2012),
    [anon_sym_RBRACE] = ACTIONS(4675),
    [anon_sym_EQ] = ACTIONS(4677),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4679),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4677),
    [anon_sym_COLON_QMARK] = ACTIONS(4677),
    [anon_sym_COLON_DASH] = ACTIONS(4677),
    [anon_sym_PERCENT] = ACTIONS(4677),
    [anon_sym_DASH] = ACTIONS(4677),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1612] = {
    [sym__concat] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_RPAREN] = ACTIONS(4044),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4044),
    [anon_sym_EQ_TILDE] = ACTIONS(4044),
    [anon_sym_EQ_EQ] = ACTIONS(4044),
    [anon_sym_EQ] = ACTIONS(4046),
    [anon_sym_LT] = ACTIONS(4044),
    [anon_sym_GT] = ACTIONS(4044),
    [anon_sym_BANG_EQ] = ACTIONS(4044),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4044),
  },
  [1613] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4681),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1614] = {
    [sym__concat] = ACTIONS(4050),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_RPAREN] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4050),
    [anon_sym_EQ_TILDE] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4050),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4050),
    [anon_sym_GT] = ACTIONS(4050),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4050),
  },
  [1615] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4683),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1616] = {
    [sym_variable_name] = ACTIONS(3379),
    [anon_sym_PIPE] = ACTIONS(3381),
    [anon_sym_RPAREN] = ACTIONS(3381),
    [anon_sym_SEMI_SEMI] = ACTIONS(3381),
    [anon_sym_PIPE_AMP] = ACTIONS(3381),
    [anon_sym_AMP_AMP] = ACTIONS(3381),
    [anon_sym_PIPE_PIPE] = ACTIONS(3381),
    [sym__special_characters] = ACTIONS(3381),
    [anon_sym_DQUOTE] = ACTIONS(3381),
    [anon_sym_DOLLAR] = ACTIONS(3381),
    [sym_raw_string] = ACTIONS(3381),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3381),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3381),
    [anon_sym_BQUOTE] = ACTIONS(3381),
    [anon_sym_LT_LPAREN] = ACTIONS(3381),
    [anon_sym_GT_LPAREN] = ACTIONS(3381),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3381),
    [sym_word] = ACTIONS(3381),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym_LF] = ACTIONS(3379),
    [anon_sym_AMP] = ACTIONS(3381),
  },
  [1617] = {
    [sym__concat] = ACTIONS(3917),
    [sym_variable_name] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3919),
    [anon_sym_RPAREN] = ACTIONS(3919),
    [anon_sym_SEMI_SEMI] = ACTIONS(3919),
    [anon_sym_PIPE_AMP] = ACTIONS(3919),
    [anon_sym_AMP_AMP] = ACTIONS(3919),
    [anon_sym_PIPE_PIPE] = ACTIONS(3919),
    [sym__special_characters] = ACTIONS(3919),
    [anon_sym_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3919),
    [sym_raw_string] = ACTIONS(3919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3919),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3919),
    [anon_sym_BQUOTE] = ACTIONS(3919),
    [anon_sym_LT_LPAREN] = ACTIONS(3919),
    [anon_sym_GT_LPAREN] = ACTIONS(3919),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3919),
    [sym_word] = ACTIONS(3919),
    [anon_sym_SEMI] = ACTIONS(3919),
    [anon_sym_LF] = ACTIONS(3917),
    [anon_sym_AMP] = ACTIONS(3919),
  },
  [1618] = {
    [sym__concat] = ACTIONS(3923),
    [sym_variable_name] = ACTIONS(3923),
    [anon_sym_PIPE] = ACTIONS(3925),
    [anon_sym_RPAREN] = ACTIONS(3925),
    [anon_sym_SEMI_SEMI] = ACTIONS(3925),
    [anon_sym_PIPE_AMP] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [sym__special_characters] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [sym_raw_string] = ACTIONS(3925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3925),
    [anon_sym_BQUOTE] = ACTIONS(3925),
    [anon_sym_LT_LPAREN] = ACTIONS(3925),
    [anon_sym_GT_LPAREN] = ACTIONS(3925),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3925),
    [sym_word] = ACTIONS(3925),
    [anon_sym_SEMI] = ACTIONS(3925),
    [anon_sym_LF] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3925),
  },
  [1619] = {
    [sym__concat] = ACTIONS(4008),
    [sym_variable_name] = ACTIONS(4008),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_RPAREN] = ACTIONS(4010),
    [anon_sym_SEMI_SEMI] = ACTIONS(4010),
    [anon_sym_PIPE_AMP] = ACTIONS(4010),
    [anon_sym_AMP_AMP] = ACTIONS(4010),
    [anon_sym_PIPE_PIPE] = ACTIONS(4010),
    [sym__special_characters] = ACTIONS(4010),
    [anon_sym_DQUOTE] = ACTIONS(4010),
    [anon_sym_DOLLAR] = ACTIONS(4010),
    [sym_raw_string] = ACTIONS(4010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4010),
    [anon_sym_BQUOTE] = ACTIONS(4010),
    [anon_sym_LT_LPAREN] = ACTIONS(4010),
    [anon_sym_GT_LPAREN] = ACTIONS(4010),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4010),
    [sym_word] = ACTIONS(4010),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LF] = ACTIONS(4008),
    [anon_sym_AMP] = ACTIONS(4010),
  },
  [1620] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4685),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1621] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4687),
    [sym_comment] = ACTIONS(53),
  },
  [1622] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4689),
    [sym_comment] = ACTIONS(53),
  },
  [1623] = {
    [anon_sym_RBRACE] = ACTIONS(4689),
    [sym_comment] = ACTIONS(53),
  },
  [1624] = {
    [sym_concatenation] = STATE(2019),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2019),
    [anon_sym_RBRACE] = ACTIONS(4691),
    [anon_sym_EQ] = ACTIONS(4693),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4693),
    [anon_sym_COLON_QMARK] = ACTIONS(4693),
    [anon_sym_COLON_DASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_DASH] = ACTIONS(4693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1625] = {
    [sym__concat] = ACTIONS(4024),
    [sym_variable_name] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_RPAREN] = ACTIONS(4026),
    [anon_sym_SEMI_SEMI] = ACTIONS(4026),
    [anon_sym_PIPE_AMP] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4026),
    [anon_sym_PIPE_PIPE] = ACTIONS(4026),
    [sym__special_characters] = ACTIONS(4026),
    [anon_sym_DQUOTE] = ACTIONS(4026),
    [anon_sym_DOLLAR] = ACTIONS(4026),
    [sym_raw_string] = ACTIONS(4026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4026),
    [anon_sym_BQUOTE] = ACTIONS(4026),
    [anon_sym_LT_LPAREN] = ACTIONS(4026),
    [anon_sym_GT_LPAREN] = ACTIONS(4026),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4026),
    [sym_word] = ACTIONS(4026),
    [anon_sym_SEMI] = ACTIONS(4026),
    [anon_sym_LF] = ACTIONS(4024),
    [anon_sym_AMP] = ACTIONS(4026),
  },
  [1626] = {
    [sym_concatenation] = STATE(2021),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2021),
    [anon_sym_RBRACE] = ACTIONS(4697),
    [anon_sym_EQ] = ACTIONS(4699),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4701),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4699),
    [anon_sym_COLON_QMARK] = ACTIONS(4699),
    [anon_sym_COLON_DASH] = ACTIONS(4699),
    [anon_sym_PERCENT] = ACTIONS(4699),
    [anon_sym_DASH] = ACTIONS(4699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1627] = {
    [sym__concat] = ACTIONS(4034),
    [sym_variable_name] = ACTIONS(4034),
    [anon_sym_PIPE] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_SEMI_SEMI] = ACTIONS(4036),
    [anon_sym_PIPE_AMP] = ACTIONS(4036),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [sym__special_characters] = ACTIONS(4036),
    [anon_sym_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR] = ACTIONS(4036),
    [sym_raw_string] = ACTIONS(4036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4036),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4036),
    [anon_sym_GT_LPAREN] = ACTIONS(4036),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4036),
    [sym_word] = ACTIONS(4036),
    [anon_sym_SEMI] = ACTIONS(4036),
    [anon_sym_LF] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
  },
  [1628] = {
    [sym_concatenation] = STATE(2023),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2023),
    [anon_sym_RBRACE] = ACTIONS(4703),
    [anon_sym_EQ] = ACTIONS(4705),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4707),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4705),
    [anon_sym_COLON_QMARK] = ACTIONS(4705),
    [anon_sym_COLON_DASH] = ACTIONS(4705),
    [anon_sym_PERCENT] = ACTIONS(4705),
    [anon_sym_DASH] = ACTIONS(4705),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1629] = {
    [sym__concat] = ACTIONS(4044),
    [sym_variable_name] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_RPAREN] = ACTIONS(4046),
    [anon_sym_SEMI_SEMI] = ACTIONS(4046),
    [anon_sym_PIPE_AMP] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4046),
    [anon_sym_PIPE_PIPE] = ACTIONS(4046),
    [sym__special_characters] = ACTIONS(4046),
    [anon_sym_DQUOTE] = ACTIONS(4046),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [sym_raw_string] = ACTIONS(4046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4046),
    [anon_sym_BQUOTE] = ACTIONS(4046),
    [anon_sym_LT_LPAREN] = ACTIONS(4046),
    [anon_sym_GT_LPAREN] = ACTIONS(4046),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4046),
    [sym_word] = ACTIONS(4046),
    [anon_sym_SEMI] = ACTIONS(4046),
    [anon_sym_LF] = ACTIONS(4044),
    [anon_sym_AMP] = ACTIONS(4046),
  },
  [1630] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4709),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1631] = {
    [sym__concat] = ACTIONS(4050),
    [sym_variable_name] = ACTIONS(4050),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_RPAREN] = ACTIONS(4052),
    [anon_sym_SEMI_SEMI] = ACTIONS(4052),
    [anon_sym_PIPE_AMP] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4052),
    [anon_sym_PIPE_PIPE] = ACTIONS(4052),
    [sym__special_characters] = ACTIONS(4052),
    [anon_sym_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [sym_raw_string] = ACTIONS(4052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4052),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4052),
    [anon_sym_BQUOTE] = ACTIONS(4052),
    [anon_sym_LT_LPAREN] = ACTIONS(4052),
    [anon_sym_GT_LPAREN] = ACTIONS(4052),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4052),
    [sym_word] = ACTIONS(4052),
    [anon_sym_SEMI] = ACTIONS(4052),
    [anon_sym_LF] = ACTIONS(4050),
    [anon_sym_AMP] = ACTIONS(4052),
  },
  [1632] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4711),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1633] = {
    [sym__concat] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3919),
    [anon_sym_RPAREN] = ACTIONS(3919),
    [anon_sym_SEMI_SEMI] = ACTIONS(3919),
    [anon_sym_PIPE_AMP] = ACTIONS(3919),
    [anon_sym_AMP_AMP] = ACTIONS(3919),
    [anon_sym_PIPE_PIPE] = ACTIONS(3919),
    [sym__special_characters] = ACTIONS(3919),
    [anon_sym_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3919),
    [sym_raw_string] = ACTIONS(3919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3919),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3919),
    [anon_sym_BQUOTE] = ACTIONS(3919),
    [anon_sym_LT_LPAREN] = ACTIONS(3919),
    [anon_sym_GT_LPAREN] = ACTIONS(3919),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3919),
    [sym_word] = ACTIONS(3919),
    [anon_sym_SEMI] = ACTIONS(3919),
    [anon_sym_LF] = ACTIONS(3917),
    [anon_sym_AMP] = ACTIONS(3919),
  },
  [1634] = {
    [sym__concat] = ACTIONS(3923),
    [anon_sym_PIPE] = ACTIONS(3925),
    [anon_sym_RPAREN] = ACTIONS(3925),
    [anon_sym_SEMI_SEMI] = ACTIONS(3925),
    [anon_sym_PIPE_AMP] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [sym__special_characters] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [sym_raw_string] = ACTIONS(3925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3925),
    [anon_sym_BQUOTE] = ACTIONS(3925),
    [anon_sym_LT_LPAREN] = ACTIONS(3925),
    [anon_sym_GT_LPAREN] = ACTIONS(3925),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3925),
    [sym_word] = ACTIONS(3925),
    [anon_sym_SEMI] = ACTIONS(3925),
    [anon_sym_LF] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3925),
  },
  [1635] = {
    [sym__concat] = ACTIONS(4008),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_RPAREN] = ACTIONS(4010),
    [anon_sym_SEMI_SEMI] = ACTIONS(4010),
    [anon_sym_PIPE_AMP] = ACTIONS(4010),
    [anon_sym_AMP_AMP] = ACTIONS(4010),
    [anon_sym_PIPE_PIPE] = ACTIONS(4010),
    [sym__special_characters] = ACTIONS(4010),
    [anon_sym_DQUOTE] = ACTIONS(4010),
    [anon_sym_DOLLAR] = ACTIONS(4010),
    [sym_raw_string] = ACTIONS(4010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4010),
    [anon_sym_BQUOTE] = ACTIONS(4010),
    [anon_sym_LT_LPAREN] = ACTIONS(4010),
    [anon_sym_GT_LPAREN] = ACTIONS(4010),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4010),
    [sym_word] = ACTIONS(4010),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LF] = ACTIONS(4008),
    [anon_sym_AMP] = ACTIONS(4010),
  },
  [1636] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4713),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1637] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4715),
    [sym_comment] = ACTIONS(53),
  },
  [1638] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4717),
    [sym_comment] = ACTIONS(53),
  },
  [1639] = {
    [anon_sym_RBRACE] = ACTIONS(4717),
    [sym_comment] = ACTIONS(53),
  },
  [1640] = {
    [sym_concatenation] = STATE(2030),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2030),
    [anon_sym_RBRACE] = ACTIONS(4719),
    [anon_sym_EQ] = ACTIONS(4721),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4723),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4721),
    [anon_sym_COLON_QMARK] = ACTIONS(4721),
    [anon_sym_COLON_DASH] = ACTIONS(4721),
    [anon_sym_PERCENT] = ACTIONS(4721),
    [anon_sym_DASH] = ACTIONS(4721),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1641] = {
    [sym__concat] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_RPAREN] = ACTIONS(4026),
    [anon_sym_SEMI_SEMI] = ACTIONS(4026),
    [anon_sym_PIPE_AMP] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4026),
    [anon_sym_PIPE_PIPE] = ACTIONS(4026),
    [sym__special_characters] = ACTIONS(4026),
    [anon_sym_DQUOTE] = ACTIONS(4026),
    [anon_sym_DOLLAR] = ACTIONS(4026),
    [sym_raw_string] = ACTIONS(4026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4026),
    [anon_sym_BQUOTE] = ACTIONS(4026),
    [anon_sym_LT_LPAREN] = ACTIONS(4026),
    [anon_sym_GT_LPAREN] = ACTIONS(4026),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4026),
    [sym_word] = ACTIONS(4026),
    [anon_sym_SEMI] = ACTIONS(4026),
    [anon_sym_LF] = ACTIONS(4024),
    [anon_sym_AMP] = ACTIONS(4026),
  },
  [1642] = {
    [sym_concatenation] = STATE(2032),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2032),
    [anon_sym_RBRACE] = ACTIONS(4725),
    [anon_sym_EQ] = ACTIONS(4727),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4727),
    [anon_sym_COLON_QMARK] = ACTIONS(4727),
    [anon_sym_COLON_DASH] = ACTIONS(4727),
    [anon_sym_PERCENT] = ACTIONS(4727),
    [anon_sym_DASH] = ACTIONS(4727),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1643] = {
    [sym__concat] = ACTIONS(4034),
    [anon_sym_PIPE] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_SEMI_SEMI] = ACTIONS(4036),
    [anon_sym_PIPE_AMP] = ACTIONS(4036),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [sym__special_characters] = ACTIONS(4036),
    [anon_sym_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR] = ACTIONS(4036),
    [sym_raw_string] = ACTIONS(4036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4036),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4036),
    [anon_sym_GT_LPAREN] = ACTIONS(4036),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4036),
    [sym_word] = ACTIONS(4036),
    [anon_sym_SEMI] = ACTIONS(4036),
    [anon_sym_LF] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
  },
  [1644] = {
    [sym_concatenation] = STATE(2034),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2034),
    [anon_sym_RBRACE] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(4733),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4733),
    [anon_sym_COLON_QMARK] = ACTIONS(4733),
    [anon_sym_COLON_DASH] = ACTIONS(4733),
    [anon_sym_PERCENT] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1645] = {
    [sym__concat] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_RPAREN] = ACTIONS(4046),
    [anon_sym_SEMI_SEMI] = ACTIONS(4046),
    [anon_sym_PIPE_AMP] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4046),
    [anon_sym_PIPE_PIPE] = ACTIONS(4046),
    [sym__special_characters] = ACTIONS(4046),
    [anon_sym_DQUOTE] = ACTIONS(4046),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [sym_raw_string] = ACTIONS(4046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4046),
    [anon_sym_BQUOTE] = ACTIONS(4046),
    [anon_sym_LT_LPAREN] = ACTIONS(4046),
    [anon_sym_GT_LPAREN] = ACTIONS(4046),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4046),
    [sym_word] = ACTIONS(4046),
    [anon_sym_SEMI] = ACTIONS(4046),
    [anon_sym_LF] = ACTIONS(4044),
    [anon_sym_AMP] = ACTIONS(4046),
  },
  [1646] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4737),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1647] = {
    [sym__concat] = ACTIONS(4050),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_RPAREN] = ACTIONS(4052),
    [anon_sym_SEMI_SEMI] = ACTIONS(4052),
    [anon_sym_PIPE_AMP] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4052),
    [anon_sym_PIPE_PIPE] = ACTIONS(4052),
    [sym__special_characters] = ACTIONS(4052),
    [anon_sym_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [sym_raw_string] = ACTIONS(4052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4052),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4052),
    [anon_sym_BQUOTE] = ACTIONS(4052),
    [anon_sym_LT_LPAREN] = ACTIONS(4052),
    [anon_sym_GT_LPAREN] = ACTIONS(4052),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4052),
    [sym_word] = ACTIONS(4052),
    [anon_sym_SEMI] = ACTIONS(4052),
    [anon_sym_LF] = ACTIONS(4050),
    [anon_sym_AMP] = ACTIONS(4052),
  },
  [1648] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4739),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1649] = {
    [sym_file_descriptor] = ACTIONS(3917),
    [sym__concat] = ACTIONS(3917),
    [sym_variable_name] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3919),
    [anon_sym_RPAREN] = ACTIONS(3917),
    [anon_sym_PIPE_AMP] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_GT] = ACTIONS(3919),
    [anon_sym_GT_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT] = ACTIONS(3919),
    [anon_sym_AMP_GT_GT] = ACTIONS(3917),
    [anon_sym_LT_AMP] = ACTIONS(3917),
    [anon_sym_GT_AMP] = ACTIONS(3917),
    [sym__special_characters] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_DOLLAR] = ACTIONS(3919),
    [sym_raw_string] = ACTIONS(3917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3917),
    [anon_sym_BQUOTE] = ACTIONS(3917),
    [anon_sym_LT_LPAREN] = ACTIONS(3917),
    [anon_sym_GT_LPAREN] = ACTIONS(3917),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3917),
  },
  [1650] = {
    [sym_file_descriptor] = ACTIONS(3923),
    [sym__concat] = ACTIONS(3923),
    [sym_variable_name] = ACTIONS(3923),
    [anon_sym_PIPE] = ACTIONS(3925),
    [anon_sym_RPAREN] = ACTIONS(3923),
    [anon_sym_PIPE_AMP] = ACTIONS(3923),
    [anon_sym_AMP_AMP] = ACTIONS(3923),
    [anon_sym_PIPE_PIPE] = ACTIONS(3923),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_GT] = ACTIONS(3925),
    [anon_sym_GT_GT] = ACTIONS(3923),
    [anon_sym_AMP_GT] = ACTIONS(3925),
    [anon_sym_AMP_GT_GT] = ACTIONS(3923),
    [anon_sym_LT_AMP] = ACTIONS(3923),
    [anon_sym_GT_AMP] = ACTIONS(3923),
    [sym__special_characters] = ACTIONS(3923),
    [anon_sym_DQUOTE] = ACTIONS(3923),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [sym_raw_string] = ACTIONS(3923),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3923),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3923),
    [anon_sym_BQUOTE] = ACTIONS(3923),
    [anon_sym_LT_LPAREN] = ACTIONS(3923),
    [anon_sym_GT_LPAREN] = ACTIONS(3923),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3923),
  },
  [1651] = {
    [sym_file_descriptor] = ACTIONS(4008),
    [sym__concat] = ACTIONS(4008),
    [sym_variable_name] = ACTIONS(4008),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_RPAREN] = ACTIONS(4008),
    [anon_sym_PIPE_AMP] = ACTIONS(4008),
    [anon_sym_AMP_AMP] = ACTIONS(4008),
    [anon_sym_PIPE_PIPE] = ACTIONS(4008),
    [anon_sym_LT] = ACTIONS(4010),
    [anon_sym_GT] = ACTIONS(4010),
    [anon_sym_GT_GT] = ACTIONS(4008),
    [anon_sym_AMP_GT] = ACTIONS(4010),
    [anon_sym_AMP_GT_GT] = ACTIONS(4008),
    [anon_sym_LT_AMP] = ACTIONS(4008),
    [anon_sym_GT_AMP] = ACTIONS(4008),
    [sym__special_characters] = ACTIONS(4008),
    [anon_sym_DQUOTE] = ACTIONS(4008),
    [anon_sym_DOLLAR] = ACTIONS(4010),
    [sym_raw_string] = ACTIONS(4008),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4008),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4008),
    [anon_sym_BQUOTE] = ACTIONS(4008),
    [anon_sym_LT_LPAREN] = ACTIONS(4008),
    [anon_sym_GT_LPAREN] = ACTIONS(4008),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4008),
  },
  [1652] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4741),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1653] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4743),
    [sym_comment] = ACTIONS(53),
  },
  [1654] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4745),
    [sym_comment] = ACTIONS(53),
  },
  [1655] = {
    [anon_sym_RBRACE] = ACTIONS(4745),
    [sym_comment] = ACTIONS(53),
  },
  [1656] = {
    [sym_concatenation] = STATE(2041),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2041),
    [anon_sym_RBRACE] = ACTIONS(4747),
    [anon_sym_EQ] = ACTIONS(4749),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4749),
    [anon_sym_COLON_QMARK] = ACTIONS(4749),
    [anon_sym_COLON_DASH] = ACTIONS(4749),
    [anon_sym_PERCENT] = ACTIONS(4749),
    [anon_sym_DASH] = ACTIONS(4749),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1657] = {
    [sym_file_descriptor] = ACTIONS(4024),
    [sym__concat] = ACTIONS(4024),
    [sym_variable_name] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_PIPE_AMP] = ACTIONS(4024),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_GT_GT] = ACTIONS(4024),
    [anon_sym_AMP_GT] = ACTIONS(4026),
    [anon_sym_AMP_GT_GT] = ACTIONS(4024),
    [anon_sym_LT_AMP] = ACTIONS(4024),
    [anon_sym_GT_AMP] = ACTIONS(4024),
    [sym__special_characters] = ACTIONS(4024),
    [anon_sym_DQUOTE] = ACTIONS(4024),
    [anon_sym_DOLLAR] = ACTIONS(4026),
    [sym_raw_string] = ACTIONS(4024),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4024),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4024),
    [anon_sym_BQUOTE] = ACTIONS(4024),
    [anon_sym_LT_LPAREN] = ACTIONS(4024),
    [anon_sym_GT_LPAREN] = ACTIONS(4024),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4024),
  },
  [1658] = {
    [sym_concatenation] = STATE(2043),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2043),
    [anon_sym_RBRACE] = ACTIONS(4753),
    [anon_sym_EQ] = ACTIONS(4755),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4757),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4755),
    [anon_sym_COLON_QMARK] = ACTIONS(4755),
    [anon_sym_COLON_DASH] = ACTIONS(4755),
    [anon_sym_PERCENT] = ACTIONS(4755),
    [anon_sym_DASH] = ACTIONS(4755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1659] = {
    [sym_file_descriptor] = ACTIONS(4034),
    [sym__concat] = ACTIONS(4034),
    [sym_variable_name] = ACTIONS(4034),
    [anon_sym_PIPE] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4034),
    [anon_sym_PIPE_AMP] = ACTIONS(4034),
    [anon_sym_AMP_AMP] = ACTIONS(4034),
    [anon_sym_PIPE_PIPE] = ACTIONS(4034),
    [anon_sym_LT] = ACTIONS(4036),
    [anon_sym_GT] = ACTIONS(4036),
    [anon_sym_GT_GT] = ACTIONS(4034),
    [anon_sym_AMP_GT] = ACTIONS(4036),
    [anon_sym_AMP_GT_GT] = ACTIONS(4034),
    [anon_sym_LT_AMP] = ACTIONS(4034),
    [anon_sym_GT_AMP] = ACTIONS(4034),
    [sym__special_characters] = ACTIONS(4034),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_DOLLAR] = ACTIONS(4036),
    [sym_raw_string] = ACTIONS(4034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4034),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4034),
    [anon_sym_BQUOTE] = ACTIONS(4034),
    [anon_sym_LT_LPAREN] = ACTIONS(4034),
    [anon_sym_GT_LPAREN] = ACTIONS(4034),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4034),
  },
  [1660] = {
    [sym_concatenation] = STATE(2045),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2045),
    [anon_sym_RBRACE] = ACTIONS(4759),
    [anon_sym_EQ] = ACTIONS(4761),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4763),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4761),
    [anon_sym_COLON_QMARK] = ACTIONS(4761),
    [anon_sym_COLON_DASH] = ACTIONS(4761),
    [anon_sym_PERCENT] = ACTIONS(4761),
    [anon_sym_DASH] = ACTIONS(4761),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1661] = {
    [sym_file_descriptor] = ACTIONS(4044),
    [sym__concat] = ACTIONS(4044),
    [sym_variable_name] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_RPAREN] = ACTIONS(4044),
    [anon_sym_PIPE_AMP] = ACTIONS(4044),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [anon_sym_LT] = ACTIONS(4046),
    [anon_sym_GT] = ACTIONS(4046),
    [anon_sym_GT_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT] = ACTIONS(4046),
    [anon_sym_AMP_GT_GT] = ACTIONS(4044),
    [anon_sym_LT_AMP] = ACTIONS(4044),
    [anon_sym_GT_AMP] = ACTIONS(4044),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(4044),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [sym_raw_string] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4044),
    [anon_sym_BQUOTE] = ACTIONS(4044),
    [anon_sym_LT_LPAREN] = ACTIONS(4044),
    [anon_sym_GT_LPAREN] = ACTIONS(4044),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4044),
  },
  [1662] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4765),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1663] = {
    [sym_file_descriptor] = ACTIONS(4050),
    [sym__concat] = ACTIONS(4050),
    [sym_variable_name] = ACTIONS(4050),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_RPAREN] = ACTIONS(4050),
    [anon_sym_PIPE_AMP] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4050),
    [anon_sym_AMP_GT] = ACTIONS(4052),
    [anon_sym_AMP_GT_GT] = ACTIONS(4050),
    [anon_sym_LT_AMP] = ACTIONS(4050),
    [anon_sym_GT_AMP] = ACTIONS(4050),
    [sym__special_characters] = ACTIONS(4050),
    [anon_sym_DQUOTE] = ACTIONS(4050),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [sym_raw_string] = ACTIONS(4050),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4050),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4050),
    [anon_sym_BQUOTE] = ACTIONS(4050),
    [anon_sym_LT_LPAREN] = ACTIONS(4050),
    [anon_sym_GT_LPAREN] = ACTIONS(4050),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4050),
  },
  [1664] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4767),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1665] = {
    [sym__concat] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3919),
    [sym__string_content] = ACTIONS(3917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3919),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3919),
    [anon_sym_BQUOTE] = ACTIONS(3919),
    [sym_comment] = ACTIONS(177),
  },
  [1666] = {
    [sym__concat] = ACTIONS(3923),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [sym__string_content] = ACTIONS(3923),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3925),
    [anon_sym_BQUOTE] = ACTIONS(3925),
    [sym_comment] = ACTIONS(177),
  },
  [1667] = {
    [sym__concat] = ACTIONS(4008),
    [anon_sym_DQUOTE] = ACTIONS(4010),
    [anon_sym_DOLLAR] = ACTIONS(4010),
    [sym__string_content] = ACTIONS(4008),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4010),
    [anon_sym_BQUOTE] = ACTIONS(4010),
    [sym_comment] = ACTIONS(177),
  },
  [1668] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4769),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1669] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4771),
    [sym_comment] = ACTIONS(53),
  },
  [1670] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4773),
    [sym_comment] = ACTIONS(53),
  },
  [1671] = {
    [anon_sym_RBRACE] = ACTIONS(4773),
    [sym_comment] = ACTIONS(53),
  },
  [1672] = {
    [sym_concatenation] = STATE(2052),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2052),
    [anon_sym_RBRACE] = ACTIONS(4775),
    [anon_sym_EQ] = ACTIONS(4777),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4777),
    [anon_sym_COLON_QMARK] = ACTIONS(4777),
    [anon_sym_COLON_DASH] = ACTIONS(4777),
    [anon_sym_PERCENT] = ACTIONS(4777),
    [anon_sym_DASH] = ACTIONS(4777),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1673] = {
    [sym__concat] = ACTIONS(4024),
    [anon_sym_DQUOTE] = ACTIONS(4026),
    [anon_sym_DOLLAR] = ACTIONS(4026),
    [sym__string_content] = ACTIONS(4024),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4026),
    [anon_sym_BQUOTE] = ACTIONS(4026),
    [sym_comment] = ACTIONS(177),
  },
  [1674] = {
    [sym_concatenation] = STATE(2054),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2054),
    [anon_sym_RBRACE] = ACTIONS(4781),
    [anon_sym_EQ] = ACTIONS(4783),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4785),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4783),
    [anon_sym_COLON_QMARK] = ACTIONS(4783),
    [anon_sym_COLON_DASH] = ACTIONS(4783),
    [anon_sym_PERCENT] = ACTIONS(4783),
    [anon_sym_DASH] = ACTIONS(4783),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1675] = {
    [sym__concat] = ACTIONS(4034),
    [anon_sym_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR] = ACTIONS(4036),
    [sym__string_content] = ACTIONS(4034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4036),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [sym_comment] = ACTIONS(177),
  },
  [1676] = {
    [sym_concatenation] = STATE(2056),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2056),
    [anon_sym_RBRACE] = ACTIONS(4787),
    [anon_sym_EQ] = ACTIONS(4789),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4791),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4789),
    [anon_sym_COLON_QMARK] = ACTIONS(4789),
    [anon_sym_COLON_DASH] = ACTIONS(4789),
    [anon_sym_PERCENT] = ACTIONS(4789),
    [anon_sym_DASH] = ACTIONS(4789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1677] = {
    [sym__concat] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(4046),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [sym__string_content] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4046),
    [anon_sym_BQUOTE] = ACTIONS(4046),
    [sym_comment] = ACTIONS(177),
  },
  [1678] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4793),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1679] = {
    [sym__concat] = ACTIONS(4050),
    [anon_sym_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [sym__string_content] = ACTIONS(4050),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4052),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4052),
    [anon_sym_BQUOTE] = ACTIONS(4052),
    [sym_comment] = ACTIONS(177),
  },
  [1680] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4795),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1681] = {
    [sym__concat] = ACTIONS(4797),
    [anon_sym_RBRACE] = ACTIONS(3331),
    [anon_sym_EQ] = ACTIONS(4799),
    [sym__special_characters] = ACTIONS(4799),
    [anon_sym_DQUOTE] = ACTIONS(3331),
    [anon_sym_DOLLAR] = ACTIONS(4799),
    [sym_raw_string] = ACTIONS(3331),
    [anon_sym_POUND] = ACTIONS(3331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3331),
    [aux_sym_SLASH] = ACTIONS(3331),
    [anon_sym_COLON] = ACTIONS(4799),
    [anon_sym_COLON_QMARK] = ACTIONS(4799),
    [anon_sym_COLON_DASH] = ACTIONS(4799),
    [anon_sym_PERCENT] = ACTIONS(4799),
    [anon_sym_DASH] = ACTIONS(4799),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3331),
    [anon_sym_BQUOTE] = ACTIONS(3331),
    [anon_sym_LT_LPAREN] = ACTIONS(3331),
    [anon_sym_GT_LPAREN] = ACTIONS(3331),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4799),
  },
  [1682] = {
    [anon_sym_RBRACE] = ACTIONS(3331),
    [anon_sym_EQ] = ACTIONS(4799),
    [sym__special_characters] = ACTIONS(4799),
    [anon_sym_DQUOTE] = ACTIONS(3331),
    [anon_sym_DOLLAR] = ACTIONS(4799),
    [sym_raw_string] = ACTIONS(3331),
    [anon_sym_POUND] = ACTIONS(3331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3331),
    [aux_sym_SLASH] = ACTIONS(3331),
    [anon_sym_COLON] = ACTIONS(4799),
    [anon_sym_COLON_QMARK] = ACTIONS(4799),
    [anon_sym_COLON_DASH] = ACTIONS(4799),
    [anon_sym_PERCENT] = ACTIONS(4799),
    [anon_sym_DASH] = ACTIONS(4799),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3331),
    [anon_sym_BQUOTE] = ACTIONS(3331),
    [anon_sym_LT_LPAREN] = ACTIONS(3331),
    [anon_sym_GT_LPAREN] = ACTIONS(3331),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4799),
  },
  [1683] = {
    [sym__concat] = ACTIONS(4801),
    [anon_sym_RBRACE] = ACTIONS(3335),
    [anon_sym_EQ] = ACTIONS(4803),
    [sym__special_characters] = ACTIONS(4803),
    [anon_sym_DQUOTE] = ACTIONS(3335),
    [anon_sym_DOLLAR] = ACTIONS(4803),
    [sym_raw_string] = ACTIONS(3335),
    [anon_sym_POUND] = ACTIONS(3335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3335),
    [aux_sym_SLASH] = ACTIONS(3335),
    [anon_sym_COLON] = ACTIONS(4803),
    [anon_sym_COLON_QMARK] = ACTIONS(4803),
    [anon_sym_COLON_DASH] = ACTIONS(4803),
    [anon_sym_PERCENT] = ACTIONS(4803),
    [anon_sym_DASH] = ACTIONS(4803),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3335),
    [anon_sym_BQUOTE] = ACTIONS(3335),
    [anon_sym_LT_LPAREN] = ACTIONS(3335),
    [anon_sym_GT_LPAREN] = ACTIONS(3335),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4803),
  },
  [1684] = {
    [anon_sym_RBRACE] = ACTIONS(3335),
    [anon_sym_EQ] = ACTIONS(4803),
    [sym__special_characters] = ACTIONS(4803),
    [anon_sym_DQUOTE] = ACTIONS(3335),
    [anon_sym_DOLLAR] = ACTIONS(4803),
    [sym_raw_string] = ACTIONS(3335),
    [anon_sym_POUND] = ACTIONS(3335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3335),
    [aux_sym_SLASH] = ACTIONS(3335),
    [anon_sym_COLON] = ACTIONS(4803),
    [anon_sym_COLON_QMARK] = ACTIONS(4803),
    [anon_sym_COLON_DASH] = ACTIONS(4803),
    [anon_sym_PERCENT] = ACTIONS(4803),
    [anon_sym_DASH] = ACTIONS(4803),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3335),
    [anon_sym_BQUOTE] = ACTIONS(3335),
    [anon_sym_LT_LPAREN] = ACTIONS(3335),
    [anon_sym_GT_LPAREN] = ACTIONS(3335),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4803),
  },
  [1685] = {
    [sym__concat] = ACTIONS(1654),
    [anon_sym_RBRACE] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
  },
  [1686] = {
    [aux_sym_concatenation_repeat1] = STATE(1686),
    [sym__concat] = ACTIONS(4805),
    [anon_sym_RBRACE] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
  },
  [1687] = {
    [sym__concat] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [sym_comment] = ACTIONS(53),
  },
  [1688] = {
    [sym_concatenation] = STATE(2064),
    [sym_string] = STATE(2063),
    [sym_simple_expansion] = STATE(2063),
    [sym_string_expansion] = STATE(2063),
    [sym_expansion] = STATE(2063),
    [sym_command_substitution] = STATE(2063),
    [sym_process_substitution] = STATE(2063),
    [anon_sym_RBRACE] = ACTIONS(4808),
    [sym__special_characters] = ACTIONS(4810),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(4812),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4812),
  },
  [1689] = {
    [sym__concat] = ACTIONS(1744),
    [anon_sym_RBRACE] = ACTIONS(1744),
    [sym_comment] = ACTIONS(53),
  },
  [1690] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4814),
  },
  [1691] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4816),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1692] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(4818),
    [sym_comment] = ACTIONS(53),
  },
  [1693] = {
    [sym_concatenation] = STATE(2070),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2070),
    [anon_sym_RBRACE] = ACTIONS(4820),
    [anon_sym_EQ] = ACTIONS(4822),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4826),
    [anon_sym_COLON] = ACTIONS(4822),
    [anon_sym_COLON_QMARK] = ACTIONS(4822),
    [anon_sym_COLON_DASH] = ACTIONS(4822),
    [anon_sym_PERCENT] = ACTIONS(4822),
    [anon_sym_DASH] = ACTIONS(4822),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1694] = {
    [sym_concatenation] = STATE(2073),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2073),
    [anon_sym_RBRACE] = ACTIONS(4828),
    [anon_sym_EQ] = ACTIONS(4830),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4834),
    [anon_sym_COLON] = ACTIONS(4830),
    [anon_sym_COLON_QMARK] = ACTIONS(4830),
    [anon_sym_COLON_DASH] = ACTIONS(4830),
    [anon_sym_PERCENT] = ACTIONS(4830),
    [anon_sym_DASH] = ACTIONS(4830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1695] = {
    [sym_concatenation] = STATE(2075),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2075),
    [anon_sym_RBRACE] = ACTIONS(4808),
    [anon_sym_EQ] = ACTIONS(4836),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4838),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(4840),
    [anon_sym_COLON] = ACTIONS(4836),
    [anon_sym_COLON_QMARK] = ACTIONS(4836),
    [anon_sym_COLON_DASH] = ACTIONS(4836),
    [anon_sym_PERCENT] = ACTIONS(4836),
    [anon_sym_DASH] = ACTIONS(4836),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1696] = {
    [sym__concat] = ACTIONS(1810),
    [anon_sym_RBRACE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(53),
  },
  [1697] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4842),
  },
  [1698] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4844),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1699] = {
    [sym__concat] = ACTIONS(1818),
    [anon_sym_RBRACE] = ACTIONS(1818),
    [sym_comment] = ACTIONS(53),
  },
  [1700] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4846),
  },
  [1701] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4808),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1702] = {
    [sym__concat] = ACTIONS(1952),
    [anon_sym_RBRACE] = ACTIONS(1952),
    [sym_comment] = ACTIONS(53),
  },
  [1703] = {
    [sym__concat] = ACTIONS(2018),
    [anon_sym_RBRACE] = ACTIONS(2018),
    [sym_comment] = ACTIONS(53),
  },
  [1704] = {
    [sym__concat] = ACTIONS(2752),
    [anon_sym_RBRACE] = ACTIONS(2752),
    [anon_sym_EQ] = ACTIONS(2754),
    [sym__special_characters] = ACTIONS(2754),
    [anon_sym_DQUOTE] = ACTIONS(2752),
    [anon_sym_DOLLAR] = ACTIONS(2754),
    [sym_raw_string] = ACTIONS(2752),
    [anon_sym_POUND] = ACTIONS(2752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2752),
    [anon_sym_COLON] = ACTIONS(2754),
    [anon_sym_COLON_QMARK] = ACTIONS(2754),
    [anon_sym_COLON_DASH] = ACTIONS(2754),
    [anon_sym_PERCENT] = ACTIONS(2754),
    [anon_sym_DASH] = ACTIONS(2754),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2752),
    [anon_sym_BQUOTE] = ACTIONS(2752),
    [anon_sym_LT_LPAREN] = ACTIONS(2752),
    [anon_sym_GT_LPAREN] = ACTIONS(2752),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2754),
  },
  [1705] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4848),
    [sym_comment] = ACTIONS(53),
  },
  [1706] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4850),
    [sym_comment] = ACTIONS(53),
  },
  [1707] = {
    [anon_sym_RBRACE] = ACTIONS(4850),
    [sym_comment] = ACTIONS(53),
  },
  [1708] = {
    [sym_concatenation] = STATE(2082),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2082),
    [anon_sym_RBRACE] = ACTIONS(4852),
    [anon_sym_EQ] = ACTIONS(4854),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4856),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4854),
    [anon_sym_COLON_QMARK] = ACTIONS(4854),
    [anon_sym_COLON_DASH] = ACTIONS(4854),
    [anon_sym_PERCENT] = ACTIONS(4854),
    [anon_sym_DASH] = ACTIONS(4854),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1709] = {
    [sym__concat] = ACTIONS(2830),
    [anon_sym_RBRACE] = ACTIONS(2830),
    [anon_sym_EQ] = ACTIONS(2832),
    [sym__special_characters] = ACTIONS(2832),
    [anon_sym_DQUOTE] = ACTIONS(2830),
    [anon_sym_DOLLAR] = ACTIONS(2832),
    [sym_raw_string] = ACTIONS(2830),
    [anon_sym_POUND] = ACTIONS(2830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2830),
    [anon_sym_COLON] = ACTIONS(2832),
    [anon_sym_COLON_QMARK] = ACTIONS(2832),
    [anon_sym_COLON_DASH] = ACTIONS(2832),
    [anon_sym_PERCENT] = ACTIONS(2832),
    [anon_sym_DASH] = ACTIONS(2832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2830),
    [anon_sym_BQUOTE] = ACTIONS(2830),
    [anon_sym_LT_LPAREN] = ACTIONS(2830),
    [anon_sym_GT_LPAREN] = ACTIONS(2830),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2832),
  },
  [1710] = {
    [sym_concatenation] = STATE(2085),
    [sym_string] = STATE(2084),
    [sym_simple_expansion] = STATE(2084),
    [sym_string_expansion] = STATE(2084),
    [sym_expansion] = STATE(2084),
    [sym_command_substitution] = STATE(2084),
    [sym_process_substitution] = STATE(2084),
    [anon_sym_RBRACE] = ACTIONS(4850),
    [sym__special_characters] = ACTIONS(4858),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(4860),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4860),
  },
  [1711] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(2873),
    [anon_sym_EQ] = ACTIONS(2875),
    [sym__special_characters] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2873),
    [anon_sym_POUND] = ACTIONS(2873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2873),
    [anon_sym_COLON] = ACTIONS(2875),
    [anon_sym_COLON_QMARK] = ACTIONS(2875),
    [anon_sym_COLON_DASH] = ACTIONS(2875),
    [anon_sym_PERCENT] = ACTIONS(2875),
    [anon_sym_DASH] = ACTIONS(2875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2873),
    [anon_sym_BQUOTE] = ACTIONS(2873),
    [anon_sym_LT_LPAREN] = ACTIONS(2873),
    [anon_sym_GT_LPAREN] = ACTIONS(2873),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2875),
  },
  [1712] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4862),
  },
  [1713] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4864),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1714] = {
    [sym__concat] = ACTIONS(2881),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [anon_sym_EQ] = ACTIONS(2883),
    [sym__special_characters] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [sym_raw_string] = ACTIONS(2881),
    [anon_sym_POUND] = ACTIONS(2881),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2881),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_COLON_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_DASH] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2881),
    [anon_sym_BQUOTE] = ACTIONS(2881),
    [anon_sym_LT_LPAREN] = ACTIONS(2881),
    [anon_sym_GT_LPAREN] = ACTIONS(2881),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2883),
  },
  [1715] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4866),
  },
  [1716] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4868),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1717] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4870),
  },
  [1718] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4850),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1719] = {
    [sym_concatenation] = STATE(2092),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2092),
    [anon_sym_RBRACE] = ACTIONS(4872),
    [anon_sym_EQ] = ACTIONS(4874),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4874),
    [anon_sym_COLON_QMARK] = ACTIONS(4874),
    [anon_sym_COLON_DASH] = ACTIONS(4874),
    [anon_sym_PERCENT] = ACTIONS(4874),
    [anon_sym_DASH] = ACTIONS(4874),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1720] = {
    [sym__concat] = ACTIONS(2897),
    [anon_sym_RBRACE] = ACTIONS(2897),
    [anon_sym_EQ] = ACTIONS(2899),
    [sym__special_characters] = ACTIONS(2899),
    [anon_sym_DQUOTE] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2899),
    [sym_raw_string] = ACTIONS(2897),
    [anon_sym_POUND] = ACTIONS(2897),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2897),
    [anon_sym_COLON] = ACTIONS(2899),
    [anon_sym_COLON_QMARK] = ACTIONS(2899),
    [anon_sym_COLON_DASH] = ACTIONS(2899),
    [anon_sym_PERCENT] = ACTIONS(2899),
    [anon_sym_DASH] = ACTIONS(2899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2897),
    [anon_sym_BQUOTE] = ACTIONS(2897),
    [anon_sym_LT_LPAREN] = ACTIONS(2897),
    [anon_sym_GT_LPAREN] = ACTIONS(2897),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2899),
  },
  [1721] = {
    [sym_concatenation] = STATE(2094),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2094),
    [anon_sym_RBRACE] = ACTIONS(4878),
    [anon_sym_EQ] = ACTIONS(4880),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4880),
    [anon_sym_COLON_QMARK] = ACTIONS(4880),
    [anon_sym_COLON_DASH] = ACTIONS(4880),
    [anon_sym_PERCENT] = ACTIONS(4880),
    [anon_sym_DASH] = ACTIONS(4880),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1722] = {
    [sym__simple_heredoc_body] = ACTIONS(4884),
    [sym__heredoc_body_beginning] = ACTIONS(4884),
    [sym_file_descriptor] = ACTIONS(4884),
    [sym__concat] = ACTIONS(4884),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_RPAREN] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [anon_sym_PIPE_AMP] = ACTIONS(4886),
    [anon_sym_AMP_AMP] = ACTIONS(4886),
    [anon_sym_PIPE_PIPE] = ACTIONS(4886),
    [anon_sym_EQ_TILDE] = ACTIONS(4886),
    [anon_sym_EQ_EQ] = ACTIONS(4886),
    [anon_sym_LT] = ACTIONS(4886),
    [anon_sym_GT] = ACTIONS(4886),
    [anon_sym_GT_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT_GT] = ACTIONS(4886),
    [anon_sym_LT_AMP] = ACTIONS(4886),
    [anon_sym_GT_AMP] = ACTIONS(4886),
    [anon_sym_LT_LT] = ACTIONS(4886),
    [anon_sym_LT_LT_DASH] = ACTIONS(4886),
    [anon_sym_LT_LT_LT] = ACTIONS(4886),
    [sym__special_characters] = ACTIONS(4886),
    [anon_sym_DQUOTE] = ACTIONS(4886),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4886),
    [anon_sym_BQUOTE] = ACTIONS(4886),
    [anon_sym_LT_LPAREN] = ACTIONS(4886),
    [anon_sym_GT_LPAREN] = ACTIONS(4886),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4886),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [1723] = {
    [sym__simple_heredoc_body] = ACTIONS(4888),
    [sym__heredoc_body_beginning] = ACTIONS(4888),
    [sym_file_descriptor] = ACTIONS(4888),
    [sym__concat] = ACTIONS(4888),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_RPAREN] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [anon_sym_PIPE_AMP] = ACTIONS(4890),
    [anon_sym_AMP_AMP] = ACTIONS(4890),
    [anon_sym_PIPE_PIPE] = ACTIONS(4890),
    [anon_sym_EQ_TILDE] = ACTIONS(4890),
    [anon_sym_EQ_EQ] = ACTIONS(4890),
    [anon_sym_LT] = ACTIONS(4890),
    [anon_sym_GT] = ACTIONS(4890),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT_GT] = ACTIONS(4890),
    [anon_sym_LT_AMP] = ACTIONS(4890),
    [anon_sym_GT_AMP] = ACTIONS(4890),
    [anon_sym_LT_LT] = ACTIONS(4890),
    [anon_sym_LT_LT_DASH] = ACTIONS(4890),
    [anon_sym_LT_LT_LT] = ACTIONS(4890),
    [sym__special_characters] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4890),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4890),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_LT_LPAREN] = ACTIONS(4890),
    [anon_sym_GT_LPAREN] = ACTIONS(4890),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4890),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [1724] = {
    [sym__simple_heredoc_body] = ACTIONS(4892),
    [sym__heredoc_body_beginning] = ACTIONS(4892),
    [sym_file_descriptor] = ACTIONS(4892),
    [sym__concat] = ACTIONS(4892),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_RPAREN] = ACTIONS(4894),
    [anon_sym_SEMI_SEMI] = ACTIONS(4894),
    [anon_sym_PIPE_AMP] = ACTIONS(4894),
    [anon_sym_AMP_AMP] = ACTIONS(4894),
    [anon_sym_PIPE_PIPE] = ACTIONS(4894),
    [anon_sym_EQ_TILDE] = ACTIONS(4894),
    [anon_sym_EQ_EQ] = ACTIONS(4894),
    [anon_sym_LT] = ACTIONS(4894),
    [anon_sym_GT] = ACTIONS(4894),
    [anon_sym_GT_GT] = ACTIONS(4894),
    [anon_sym_AMP_GT] = ACTIONS(4894),
    [anon_sym_AMP_GT_GT] = ACTIONS(4894),
    [anon_sym_LT_AMP] = ACTIONS(4894),
    [anon_sym_GT_AMP] = ACTIONS(4894),
    [anon_sym_LT_LT] = ACTIONS(4894),
    [anon_sym_LT_LT_DASH] = ACTIONS(4894),
    [anon_sym_LT_LT_LT] = ACTIONS(4894),
    [sym__special_characters] = ACTIONS(4894),
    [anon_sym_DQUOTE] = ACTIONS(4894),
    [anon_sym_DOLLAR] = ACTIONS(4894),
    [sym_raw_string] = ACTIONS(4894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4894),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4894),
    [anon_sym_GT_LPAREN] = ACTIONS(4894),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(4894),
    [anon_sym_LF] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4894),
  },
  [1725] = {
    [sym__simple_heredoc_body] = ACTIONS(4896),
    [sym__heredoc_body_beginning] = ACTIONS(4896),
    [sym_file_descriptor] = ACTIONS(4896),
    [sym__concat] = ACTIONS(4896),
    [anon_sym_PIPE] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(4898),
    [anon_sym_SEMI_SEMI] = ACTIONS(4898),
    [anon_sym_PIPE_AMP] = ACTIONS(4898),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_EQ_TILDE] = ACTIONS(4898),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4898),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_GT_GT] = ACTIONS(4898),
    [anon_sym_AMP_GT] = ACTIONS(4898),
    [anon_sym_AMP_GT_GT] = ACTIONS(4898),
    [anon_sym_LT_AMP] = ACTIONS(4898),
    [anon_sym_GT_AMP] = ACTIONS(4898),
    [anon_sym_LT_LT] = ACTIONS(4898),
    [anon_sym_LT_LT_DASH] = ACTIONS(4898),
    [anon_sym_LT_LT_LT] = ACTIONS(4898),
    [sym__special_characters] = ACTIONS(4898),
    [anon_sym_DQUOTE] = ACTIONS(4898),
    [anon_sym_DOLLAR] = ACTIONS(4898),
    [sym_raw_string] = ACTIONS(4898),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4898),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4898),
    [anon_sym_BQUOTE] = ACTIONS(4898),
    [anon_sym_LT_LPAREN] = ACTIONS(4898),
    [anon_sym_GT_LPAREN] = ACTIONS(4898),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4898),
    [anon_sym_SEMI] = ACTIONS(4898),
    [anon_sym_LF] = ACTIONS(4896),
    [anon_sym_AMP] = ACTIONS(4898),
  },
  [1726] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4900),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1727] = {
    [sym__simple_heredoc_body] = ACTIONS(4902),
    [sym__heredoc_body_beginning] = ACTIONS(4902),
    [sym_file_descriptor] = ACTIONS(4902),
    [sym__concat] = ACTIONS(4902),
    [anon_sym_PIPE] = ACTIONS(4904),
    [anon_sym_RPAREN] = ACTIONS(4904),
    [anon_sym_SEMI_SEMI] = ACTIONS(4904),
    [anon_sym_PIPE_AMP] = ACTIONS(4904),
    [anon_sym_AMP_AMP] = ACTIONS(4904),
    [anon_sym_PIPE_PIPE] = ACTIONS(4904),
    [anon_sym_EQ_TILDE] = ACTIONS(4904),
    [anon_sym_EQ_EQ] = ACTIONS(4904),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_GT] = ACTIONS(4904),
    [anon_sym_GT_GT] = ACTIONS(4904),
    [anon_sym_AMP_GT] = ACTIONS(4904),
    [anon_sym_AMP_GT_GT] = ACTIONS(4904),
    [anon_sym_LT_AMP] = ACTIONS(4904),
    [anon_sym_GT_AMP] = ACTIONS(4904),
    [anon_sym_LT_LT] = ACTIONS(4904),
    [anon_sym_LT_LT_DASH] = ACTIONS(4904),
    [anon_sym_LT_LT_LT] = ACTIONS(4904),
    [sym__special_characters] = ACTIONS(4904),
    [anon_sym_DQUOTE] = ACTIONS(4904),
    [anon_sym_DOLLAR] = ACTIONS(4904),
    [sym_raw_string] = ACTIONS(4904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4904),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4904),
    [anon_sym_BQUOTE] = ACTIONS(4904),
    [anon_sym_LT_LPAREN] = ACTIONS(4904),
    [anon_sym_GT_LPAREN] = ACTIONS(4904),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4904),
    [anon_sym_SEMI] = ACTIONS(4904),
    [anon_sym_LF] = ACTIONS(4902),
    [anon_sym_AMP] = ACTIONS(4904),
  },
  [1728] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4906),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1729] = {
    [sym__simple_heredoc_body] = ACTIONS(4908),
    [sym__heredoc_body_beginning] = ACTIONS(4908),
    [sym_file_descriptor] = ACTIONS(4908),
    [sym__concat] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_RPAREN] = ACTIONS(4910),
    [anon_sym_SEMI_SEMI] = ACTIONS(4910),
    [anon_sym_PIPE_AMP] = ACTIONS(4910),
    [anon_sym_AMP_AMP] = ACTIONS(4910),
    [anon_sym_PIPE_PIPE] = ACTIONS(4910),
    [anon_sym_EQ_TILDE] = ACTIONS(4910),
    [anon_sym_EQ_EQ] = ACTIONS(4910),
    [anon_sym_LT] = ACTIONS(4910),
    [anon_sym_GT] = ACTIONS(4910),
    [anon_sym_GT_GT] = ACTIONS(4910),
    [anon_sym_AMP_GT] = ACTIONS(4910),
    [anon_sym_AMP_GT_GT] = ACTIONS(4910),
    [anon_sym_LT_AMP] = ACTIONS(4910),
    [anon_sym_GT_AMP] = ACTIONS(4910),
    [anon_sym_LT_LT] = ACTIONS(4910),
    [anon_sym_LT_LT_DASH] = ACTIONS(4910),
    [anon_sym_LT_LT_LT] = ACTIONS(4910),
    [sym__special_characters] = ACTIONS(4910),
    [anon_sym_DQUOTE] = ACTIONS(4910),
    [anon_sym_DOLLAR] = ACTIONS(4910),
    [sym_raw_string] = ACTIONS(4910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4910),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4910),
    [anon_sym_BQUOTE] = ACTIONS(4910),
    [anon_sym_LT_LPAREN] = ACTIONS(4910),
    [anon_sym_GT_LPAREN] = ACTIONS(4910),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4910),
    [anon_sym_SEMI] = ACTIONS(4910),
    [anon_sym_LF] = ACTIONS(4908),
    [anon_sym_AMP] = ACTIONS(4910),
  },
  [1730] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4912),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1731] = {
    [sym__simple_heredoc_body] = ACTIONS(4914),
    [sym__heredoc_body_beginning] = ACTIONS(4914),
    [sym_file_descriptor] = ACTIONS(4914),
    [sym__concat] = ACTIONS(4914),
    [anon_sym_PIPE] = ACTIONS(4916),
    [anon_sym_RPAREN] = ACTIONS(4916),
    [anon_sym_SEMI_SEMI] = ACTIONS(4916),
    [anon_sym_PIPE_AMP] = ACTIONS(4916),
    [anon_sym_AMP_AMP] = ACTIONS(4916),
    [anon_sym_PIPE_PIPE] = ACTIONS(4916),
    [anon_sym_EQ_TILDE] = ACTIONS(4916),
    [anon_sym_EQ_EQ] = ACTIONS(4916),
    [anon_sym_LT] = ACTIONS(4916),
    [anon_sym_GT] = ACTIONS(4916),
    [anon_sym_GT_GT] = ACTIONS(4916),
    [anon_sym_AMP_GT] = ACTIONS(4916),
    [anon_sym_AMP_GT_GT] = ACTIONS(4916),
    [anon_sym_LT_AMP] = ACTIONS(4916),
    [anon_sym_GT_AMP] = ACTIONS(4916),
    [anon_sym_LT_LT] = ACTIONS(4916),
    [anon_sym_LT_LT_DASH] = ACTIONS(4916),
    [anon_sym_LT_LT_LT] = ACTIONS(4916),
    [sym__special_characters] = ACTIONS(4916),
    [anon_sym_DQUOTE] = ACTIONS(4916),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(4916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4916),
    [anon_sym_BQUOTE] = ACTIONS(4916),
    [anon_sym_LT_LPAREN] = ACTIONS(4916),
    [anon_sym_GT_LPAREN] = ACTIONS(4916),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4916),
    [anon_sym_SEMI] = ACTIONS(4916),
    [anon_sym_LF] = ACTIONS(4914),
    [anon_sym_AMP] = ACTIONS(4916),
  },
  [1732] = {
    [sym__simple_heredoc_body] = ACTIONS(4918),
    [sym__heredoc_body_beginning] = ACTIONS(4918),
    [sym_file_descriptor] = ACTIONS(4918),
    [sym__concat] = ACTIONS(4918),
    [anon_sym_PIPE] = ACTIONS(4920),
    [anon_sym_RPAREN] = ACTIONS(4920),
    [anon_sym_SEMI_SEMI] = ACTIONS(4920),
    [anon_sym_PIPE_AMP] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [anon_sym_EQ_TILDE] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(4920),
    [anon_sym_LT] = ACTIONS(4920),
    [anon_sym_GT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_AMP_GT] = ACTIONS(4920),
    [anon_sym_AMP_GT_GT] = ACTIONS(4920),
    [anon_sym_LT_AMP] = ACTIONS(4920),
    [anon_sym_GT_AMP] = ACTIONS(4920),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_LT_LT_DASH] = ACTIONS(4920),
    [anon_sym_LT_LT_LT] = ACTIONS(4920),
    [sym__special_characters] = ACTIONS(4920),
    [anon_sym_DQUOTE] = ACTIONS(4920),
    [anon_sym_DOLLAR] = ACTIONS(4920),
    [sym_raw_string] = ACTIONS(4920),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4920),
    [anon_sym_BQUOTE] = ACTIONS(4920),
    [anon_sym_LT_LPAREN] = ACTIONS(4920),
    [anon_sym_GT_LPAREN] = ACTIONS(4920),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4920),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym_LF] = ACTIONS(4918),
    [anon_sym_AMP] = ACTIONS(4920),
  },
  [1733] = {
    [aux_sym_concatenation_repeat1] = STATE(1733),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(2655),
    [sym_variable_name] = ACTIONS(1654),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1654),
    [anon_sym_PIPE_AMP] = ACTIONS(1654),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1654),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1654),
    [anon_sym_LT_AMP] = ACTIONS(1654),
    [anon_sym_GT_AMP] = ACTIONS(1654),
    [sym__special_characters] = ACTIONS(1654),
    [anon_sym_DQUOTE] = ACTIONS(1654),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1654),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1654),
    [anon_sym_BQUOTE] = ACTIONS(1654),
    [anon_sym_LT_LPAREN] = ACTIONS(1654),
    [anon_sym_GT_LPAREN] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1654),
  },
  [1734] = {
    [sym_do_group] = STATE(2098),
    [anon_sym_do] = ACTIONS(2907),
    [sym_comment] = ACTIONS(53),
  },
  [1735] = {
    [anon_sym_PIPE] = ACTIONS(2265),
    [anon_sym_RPAREN] = ACTIONS(2263),
    [anon_sym_PIPE_AMP] = ACTIONS(2263),
    [anon_sym_AMP_AMP] = ACTIONS(2263),
    [anon_sym_PIPE_PIPE] = ACTIONS(2263),
    [anon_sym_BQUOTE] = ACTIONS(2263),
    [sym_comment] = ACTIONS(53),
  },
  [1736] = {
    [sym__terminated_statement] = STATE(1063),
    [sym_for_statement] = STATE(599),
    [sym_while_statement] = STATE(599),
    [sym_if_statement] = STATE(599),
    [sym_case_statement] = STATE(599),
    [sym_function_definition] = STATE(599),
    [sym_subshell] = STATE(599),
    [sym_pipeline] = STATE(599),
    [sym_list] = STATE(599),
    [sym_negated_command] = STATE(599),
    [sym_test_command] = STATE(599),
    [sym_declaration_command] = STATE(599),
    [sym_unset_command] = STATE(599),
    [sym_command] = STATE(599),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(600),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1063),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_done] = ACTIONS(4922),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1737] = {
    [sym__simple_heredoc_body] = ACTIONS(3522),
    [sym__heredoc_body_beginning] = ACTIONS(3522),
    [sym_file_descriptor] = ACTIONS(3522),
    [anon_sym_PIPE] = ACTIONS(3524),
    [anon_sym_RPAREN] = ACTIONS(3522),
    [anon_sym_PIPE_AMP] = ACTIONS(3522),
    [anon_sym_AMP_AMP] = ACTIONS(3522),
    [anon_sym_PIPE_PIPE] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(3524),
    [anon_sym_GT] = ACTIONS(3524),
    [anon_sym_GT_GT] = ACTIONS(3522),
    [anon_sym_AMP_GT] = ACTIONS(3524),
    [anon_sym_AMP_GT_GT] = ACTIONS(3522),
    [anon_sym_LT_AMP] = ACTIONS(3522),
    [anon_sym_GT_AMP] = ACTIONS(3522),
    [anon_sym_LT_LT] = ACTIONS(3524),
    [anon_sym_LT_LT_DASH] = ACTIONS(3522),
    [anon_sym_LT_LT_LT] = ACTIONS(3522),
    [anon_sym_BQUOTE] = ACTIONS(3522),
    [sym_comment] = ACTIONS(53),
  },
  [1738] = {
    [anon_sym_PIPE] = ACTIONS(3528),
    [anon_sym_RPAREN] = ACTIONS(3530),
    [anon_sym_PIPE_AMP] = ACTIONS(3530),
    [anon_sym_AMP_AMP] = ACTIONS(3530),
    [anon_sym_PIPE_PIPE] = ACTIONS(3530),
    [anon_sym_BQUOTE] = ACTIONS(3530),
    [sym_comment] = ACTIONS(53),
  },
  [1739] = {
    [anon_sym_PIPE] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(3542),
    [anon_sym_PIPE_AMP] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_BQUOTE] = ACTIONS(3542),
    [sym_comment] = ACTIONS(53),
  },
  [1740] = {
    [anon_sym_fi] = ACTIONS(4924),
    [sym_comment] = ACTIONS(53),
  },
  [1741] = {
    [sym_elif_clause] = STATE(608),
    [sym_else_clause] = STATE(2101),
    [aux_sym_if_statement_repeat1] = STATE(1074),
    [anon_sym_fi] = ACTIONS(4924),
    [anon_sym_elif] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2295),
    [sym_comment] = ACTIONS(53),
  },
  [1742] = {
    [anon_sym_PIPE] = ACTIONS(3551),
    [anon_sym_RPAREN] = ACTIONS(3553),
    [anon_sym_PIPE_AMP] = ACTIONS(3553),
    [anon_sym_AMP_AMP] = ACTIONS(3553),
    [anon_sym_PIPE_PIPE] = ACTIONS(3553),
    [anon_sym_BQUOTE] = ACTIONS(3553),
    [sym_comment] = ACTIONS(53),
  },
  [1743] = {
    [anon_sym_esac] = ACTIONS(4926),
    [sym_comment] = ACTIONS(53),
  },
  [1744] = {
    [sym_case_item] = STATE(1522),
    [sym_last_case_item] = STATE(2103),
    [sym_concatenation] = STATE(1079),
    [sym_string] = STATE(1077),
    [sym_simple_expansion] = STATE(1077),
    [sym_string_expansion] = STATE(1077),
    [sym_expansion] = STATE(1077),
    [sym_command_substitution] = STATE(1077),
    [sym_process_substitution] = STATE(1077),
    [aux_sym_case_statement_repeat1] = STATE(1522),
    [sym__special_characters] = ACTIONS(2299),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2301),
  },
  [1745] = {
    [sym_case_item] = STATE(2105),
    [sym_last_case_item] = STATE(2103),
    [sym_concatenation] = STATE(1079),
    [sym_string] = STATE(1077),
    [sym_simple_expansion] = STATE(1077),
    [sym_string_expansion] = STATE(1077),
    [sym_expansion] = STATE(1077),
    [sym_command_substitution] = STATE(1077),
    [sym_process_substitution] = STATE(1077),
    [aux_sym_case_statement_repeat1] = STATE(2105),
    [anon_sym_esac] = ACTIONS(4928),
    [sym__special_characters] = ACTIONS(2299),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2303),
  },
  [1746] = {
    [anon_sym_PIPE] = ACTIONS(3565),
    [anon_sym_RPAREN] = ACTIONS(3567),
    [anon_sym_PIPE_AMP] = ACTIONS(3567),
    [anon_sym_AMP_AMP] = ACTIONS(3567),
    [anon_sym_PIPE_PIPE] = ACTIONS(3567),
    [anon_sym_BQUOTE] = ACTIONS(3567),
    [sym_comment] = ACTIONS(53),
  },
  [1747] = {
    [anon_sym_esac] = ACTIONS(4930),
    [sym_comment] = ACTIONS(53),
  },
  [1748] = {
    [sym_case_item] = STATE(1522),
    [sym_last_case_item] = STATE(2107),
    [sym_concatenation] = STATE(1079),
    [sym_string] = STATE(1077),
    [sym_simple_expansion] = STATE(1077),
    [sym_string_expansion] = STATE(1077),
    [sym_expansion] = STATE(1077),
    [sym_command_substitution] = STATE(1077),
    [sym_process_substitution] = STATE(1077),
    [aux_sym_case_statement_repeat1] = STATE(1522),
    [sym__special_characters] = ACTIONS(2299),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2301),
  },
  [1749] = {
    [sym_case_item] = STATE(2109),
    [sym_last_case_item] = STATE(2107),
    [sym_concatenation] = STATE(1079),
    [sym_string] = STATE(1077),
    [sym_simple_expansion] = STATE(1077),
    [sym_string_expansion] = STATE(1077),
    [sym_expansion] = STATE(1077),
    [sym_command_substitution] = STATE(1077),
    [sym_process_substitution] = STATE(1077),
    [aux_sym_case_statement_repeat1] = STATE(2109),
    [anon_sym_esac] = ACTIONS(4932),
    [sym__special_characters] = ACTIONS(2299),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2303),
  },
  [1750] = {
    [sym_file_redirect] = STATE(2110),
    [sym_file_descriptor] = ACTIONS(2929),
    [anon_sym_PIPE] = ACTIONS(3609),
    [anon_sym_RPAREN] = ACTIONS(3611),
    [anon_sym_PIPE_AMP] = ACTIONS(3611),
    [anon_sym_AMP_AMP] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(3611),
    [anon_sym_LT] = ACTIONS(2931),
    [anon_sym_GT] = ACTIONS(2931),
    [anon_sym_GT_GT] = ACTIONS(2933),
    [anon_sym_AMP_GT] = ACTIONS(2931),
    [anon_sym_AMP_GT_GT] = ACTIONS(2933),
    [anon_sym_LT_AMP] = ACTIONS(2933),
    [anon_sym_GT_AMP] = ACTIONS(2933),
    [sym_comment] = ACTIONS(53),
  },
  [1751] = {
    [sym_file_descriptor] = ACTIONS(3613),
    [anon_sym_PIPE] = ACTIONS(3615),
    [anon_sym_RPAREN] = ACTIONS(3613),
    [anon_sym_PIPE_AMP] = ACTIONS(3613),
    [anon_sym_AMP_AMP] = ACTIONS(3613),
    [anon_sym_PIPE_PIPE] = ACTIONS(3613),
    [anon_sym_LT] = ACTIONS(3615),
    [anon_sym_GT] = ACTIONS(3615),
    [anon_sym_GT_GT] = ACTIONS(3613),
    [anon_sym_AMP_GT] = ACTIONS(3615),
    [anon_sym_AMP_GT_GT] = ACTIONS(3613),
    [anon_sym_LT_AMP] = ACTIONS(3613),
    [anon_sym_GT_AMP] = ACTIONS(3613),
    [anon_sym_BQUOTE] = ACTIONS(3613),
    [sym_comment] = ACTIONS(53),
  },
  [1752] = {
    [sym_concatenation] = STATE(2113),
    [sym_string] = STATE(2112),
    [sym_simple_expansion] = STATE(2112),
    [sym_string_expansion] = STATE(2112),
    [sym_expansion] = STATE(2112),
    [sym_command_substitution] = STATE(2112),
    [sym_process_substitution] = STATE(2112),
    [sym__special_characters] = ACTIONS(4934),
    [anon_sym_DQUOTE] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [sym_raw_string] = ACTIONS(4936),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [anon_sym_LT_LPAREN] = ACTIONS(839),
    [anon_sym_GT_LPAREN] = ACTIONS(839),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4936),
  },
  [1753] = {
    [aux_sym_concatenation_repeat1] = STATE(2114),
    [sym__concat] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
  },
  [1754] = {
    [aux_sym_concatenation_repeat1] = STATE(2114),
    [sym__concat] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [sym_comment] = ACTIONS(53),
  },
  [1755] = {
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [sym_comment] = ACTIONS(53),
  },
  [1756] = {
    [anon_sym_PIPE] = ACTIONS(3641),
    [anon_sym_RPAREN] = ACTIONS(3643),
    [anon_sym_PIPE_AMP] = ACTIONS(3643),
    [anon_sym_AMP_AMP] = ACTIONS(3643),
    [anon_sym_PIPE_PIPE] = ACTIONS(3643),
    [anon_sym_BQUOTE] = ACTIONS(3643),
    [sym_comment] = ACTIONS(53),
  },
  [1757] = {
    [sym_concatenation] = STATE(2117),
    [sym_string] = STATE(2116),
    [sym_simple_expansion] = STATE(2116),
    [sym_string_expansion] = STATE(2116),
    [sym_expansion] = STATE(2116),
    [sym_command_substitution] = STATE(2116),
    [sym_process_substitution] = STATE(2116),
    [sym__special_characters] = ACTIONS(4938),
    [anon_sym_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [sym_raw_string] = ACTIONS(4940),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4104),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4106),
    [anon_sym_BQUOTE] = ACTIONS(4108),
    [anon_sym_LT_LPAREN] = ACTIONS(4110),
    [anon_sym_GT_LPAREN] = ACTIONS(4110),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4940),
  },
  [1758] = {
    [aux_sym_concatenation_repeat1] = STATE(2119),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(4942),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(661),
    [anon_sym_LT_AMP] = ACTIONS(661),
    [anon_sym_GT_AMP] = ACTIONS(661),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(661),
    [anon_sym_LT_LT_LT] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
  },
  [1759] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(2121),
    [anon_sym_DQUOTE] = ACTIONS(4944),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [1760] = {
    [sym_string] = STATE(2123),
    [anon_sym_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4946),
    [sym_raw_string] = ACTIONS(4948),
    [anon_sym_POUND] = ACTIONS(4946),
    [anon_sym_DASH] = ACTIONS(4946),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(4946),
    [anon_sym_QMARK] = ACTIONS(4946),
    [anon_sym_0] = ACTIONS(4952),
    [anon_sym__] = ACTIONS(4952),
  },
  [1761] = {
    [aux_sym_concatenation_repeat1] = STATE(2119),
    [sym_file_descriptor] = ACTIONS(677),
    [sym__concat] = ACTIONS(4942),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(677),
    [anon_sym_LT_LT_LT] = ACTIONS(677),
    [sym_comment] = ACTIONS(53),
  },
  [1762] = {
    [sym_subscript] = STATE(2129),
    [sym_variable_name] = ACTIONS(4954),
    [anon_sym_DOLLAR] = ACTIONS(4956),
    [anon_sym_POUND] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4960),
    [anon_sym_STAR] = ACTIONS(4956),
    [anon_sym_AT] = ACTIONS(4956),
    [anon_sym_QMARK] = ACTIONS(4956),
    [anon_sym_0] = ACTIONS(4962),
    [anon_sym__] = ACTIONS(4962),
  },
  [1763] = {
    [sym_for_statement] = STATE(2130),
    [sym_while_statement] = STATE(2130),
    [sym_if_statement] = STATE(2130),
    [sym_case_statement] = STATE(2130),
    [sym_function_definition] = STATE(2130),
    [sym_subshell] = STATE(2130),
    [sym_pipeline] = STATE(2130),
    [sym_list] = STATE(2130),
    [sym_negated_command] = STATE(2130),
    [sym_test_command] = STATE(2130),
    [sym_declaration_command] = STATE(2130),
    [sym_unset_command] = STATE(2130),
    [sym_command] = STATE(2130),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(2131),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [1764] = {
    [sym_for_statement] = STATE(2132),
    [sym_while_statement] = STATE(2132),
    [sym_if_statement] = STATE(2132),
    [sym_case_statement] = STATE(2132),
    [sym_function_definition] = STATE(2132),
    [sym_subshell] = STATE(2132),
    [sym_pipeline] = STATE(2132),
    [sym_list] = STATE(2132),
    [sym_negated_command] = STATE(2132),
    [sym_test_command] = STATE(2132),
    [sym_declaration_command] = STATE(2132),
    [sym_unset_command] = STATE(2132),
    [sym_command] = STATE(2132),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(2133),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [1765] = {
    [sym_for_statement] = STATE(2134),
    [sym_while_statement] = STATE(2134),
    [sym_if_statement] = STATE(2134),
    [sym_case_statement] = STATE(2134),
    [sym_function_definition] = STATE(2134),
    [sym_subshell] = STATE(2134),
    [sym_pipeline] = STATE(2134),
    [sym_list] = STATE(2134),
    [sym_negated_command] = STATE(2134),
    [sym_test_command] = STATE(2134),
    [sym_declaration_command] = STATE(2134),
    [sym_unset_command] = STATE(2134),
    [sym_command] = STATE(2134),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(2135),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [1766] = {
    [sym_file_descriptor] = ACTIONS(677),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(677),
    [anon_sym_LT_LT_LT] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [sym_comment] = ACTIONS(53),
  },
  [1767] = {
    [sym_file_descriptor] = ACTIONS(2066),
    [anon_sym_PIPE] = ACTIONS(2068),
    [anon_sym_RPAREN] = ACTIONS(2066),
    [anon_sym_PIPE_AMP] = ACTIONS(2066),
    [anon_sym_AMP_AMP] = ACTIONS(2066),
    [anon_sym_PIPE_PIPE] = ACTIONS(2066),
    [anon_sym_LT] = ACTIONS(2068),
    [anon_sym_GT] = ACTIONS(2068),
    [anon_sym_GT_GT] = ACTIONS(2066),
    [anon_sym_AMP_GT] = ACTIONS(2068),
    [anon_sym_AMP_GT_GT] = ACTIONS(2066),
    [anon_sym_LT_AMP] = ACTIONS(2066),
    [anon_sym_GT_AMP] = ACTIONS(2066),
    [anon_sym_LT_LT] = ACTIONS(2068),
    [anon_sym_LT_LT_DASH] = ACTIONS(2066),
    [anon_sym_LT_LT_LT] = ACTIONS(2066),
    [anon_sym_BQUOTE] = ACTIONS(2066),
    [sym_comment] = ACTIONS(53),
  },
  [1768] = {
    [aux_sym_concatenation_repeat1] = STATE(2119),
    [sym_file_descriptor] = ACTIONS(2070),
    [sym__concat] = ACTIONS(4942),
    [anon_sym_PIPE] = ACTIONS(2072),
    [anon_sym_RPAREN] = ACTIONS(2070),
    [anon_sym_PIPE_AMP] = ACTIONS(2070),
    [anon_sym_AMP_AMP] = ACTIONS(2070),
    [anon_sym_PIPE_PIPE] = ACTIONS(2070),
    [anon_sym_LT] = ACTIONS(2072),
    [anon_sym_GT] = ACTIONS(2072),
    [anon_sym_GT_GT] = ACTIONS(2070),
    [anon_sym_AMP_GT] = ACTIONS(2072),
    [anon_sym_AMP_GT_GT] = ACTIONS(2070),
    [anon_sym_LT_AMP] = ACTIONS(2070),
    [anon_sym_GT_AMP] = ACTIONS(2070),
    [anon_sym_LT_LT] = ACTIONS(2072),
    [anon_sym_LT_LT_DASH] = ACTIONS(2070),
    [anon_sym_LT_LT_LT] = ACTIONS(2070),
    [sym_comment] = ACTIONS(53),
  },
  [1769] = {
    [aux_sym_concatenation_repeat1] = STATE(2119),
    [sym_file_descriptor] = ACTIONS(2074),
    [sym__concat] = ACTIONS(4942),
    [anon_sym_PIPE] = ACTIONS(2076),
    [anon_sym_RPAREN] = ACTIONS(2074),
    [anon_sym_PIPE_AMP] = ACTIONS(2074),
    [anon_sym_AMP_AMP] = ACTIONS(2074),
    [anon_sym_PIPE_PIPE] = ACTIONS(2074),
    [anon_sym_LT] = ACTIONS(2076),
    [anon_sym_GT] = ACTIONS(2076),
    [anon_sym_GT_GT] = ACTIONS(2074),
    [anon_sym_AMP_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT_GT] = ACTIONS(2074),
    [anon_sym_LT_AMP] = ACTIONS(2074),
    [anon_sym_GT_AMP] = ACTIONS(2074),
    [anon_sym_LT_LT] = ACTIONS(2076),
    [anon_sym_LT_LT_DASH] = ACTIONS(2074),
    [anon_sym_LT_LT_LT] = ACTIONS(2074),
    [sym_comment] = ACTIONS(53),
  },
  [1770] = {
    [sym_file_descriptor] = ACTIONS(2074),
    [anon_sym_PIPE] = ACTIONS(2076),
    [anon_sym_RPAREN] = ACTIONS(2074),
    [anon_sym_PIPE_AMP] = ACTIONS(2074),
    [anon_sym_AMP_AMP] = ACTIONS(2074),
    [anon_sym_PIPE_PIPE] = ACTIONS(2074),
    [anon_sym_LT] = ACTIONS(2076),
    [anon_sym_GT] = ACTIONS(2076),
    [anon_sym_GT_GT] = ACTIONS(2074),
    [anon_sym_AMP_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT_GT] = ACTIONS(2074),
    [anon_sym_LT_AMP] = ACTIONS(2074),
    [anon_sym_GT_AMP] = ACTIONS(2074),
    [anon_sym_LT_LT] = ACTIONS(2076),
    [anon_sym_LT_LT_DASH] = ACTIONS(2074),
    [anon_sym_LT_LT_LT] = ACTIONS(2074),
    [anon_sym_BQUOTE] = ACTIONS(2074),
    [sym_comment] = ACTIONS(53),
  },
  [1771] = {
    [sym_file_redirect] = STATE(1771),
    [sym_heredoc_redirect] = STATE(1771),
    [sym_herestring_redirect] = STATE(1771),
    [aux_sym_while_statement_repeat1] = STATE(1771),
    [sym_file_descriptor] = ACTIONS(4964),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_RPAREN] = ACTIONS(2082),
    [anon_sym_PIPE_AMP] = ACTIONS(2082),
    [anon_sym_AMP_AMP] = ACTIONS(2082),
    [anon_sym_PIPE_PIPE] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(4967),
    [anon_sym_GT] = ACTIONS(4967),
    [anon_sym_GT_GT] = ACTIONS(4970),
    [anon_sym_AMP_GT] = ACTIONS(4967),
    [anon_sym_AMP_GT_GT] = ACTIONS(4970),
    [anon_sym_LT_AMP] = ACTIONS(4970),
    [anon_sym_GT_AMP] = ACTIONS(4970),
    [anon_sym_LT_LT] = ACTIONS(4973),
    [anon_sym_LT_LT_DASH] = ACTIONS(4976),
    [anon_sym_LT_LT_LT] = ACTIONS(4979),
    [sym_comment] = ACTIONS(53),
  },
  [1772] = {
    [sym_variable_name] = ACTIONS(2139),
    [anon_sym_PIPE] = ACTIONS(2141),
    [anon_sym_RPAREN] = ACTIONS(2139),
    [anon_sym_PIPE_AMP] = ACTIONS(2139),
    [anon_sym_AMP_AMP] = ACTIONS(2139),
    [anon_sym_PIPE_PIPE] = ACTIONS(2139),
    [sym__special_characters] = ACTIONS(2139),
    [anon_sym_DQUOTE] = ACTIONS(2139),
    [anon_sym_DOLLAR] = ACTIONS(2141),
    [sym_raw_string] = ACTIONS(2139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2139),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2139),
    [anon_sym_BQUOTE] = ACTIONS(2139),
    [anon_sym_LT_LPAREN] = ACTIONS(2139),
    [anon_sym_GT_LPAREN] = ACTIONS(2139),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2141),
    [sym_word] = ACTIONS(2141),
  },
  [1773] = {
    [sym_concatenation] = STATE(1019),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(1019),
    [anon_sym_RPAREN] = ACTIONS(4982),
    [sym__special_characters] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1119),
  },
  [1774] = {
    [sym__concat] = ACTIONS(2752),
    [sym_variable_name] = ACTIONS(2752),
    [anon_sym_PIPE] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(2752),
    [anon_sym_PIPE_AMP] = ACTIONS(2752),
    [anon_sym_AMP_AMP] = ACTIONS(2752),
    [anon_sym_PIPE_PIPE] = ACTIONS(2752),
    [sym__special_characters] = ACTIONS(2752),
    [anon_sym_DQUOTE] = ACTIONS(2752),
    [anon_sym_DOLLAR] = ACTIONS(2754),
    [sym_raw_string] = ACTIONS(2752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2752),
    [anon_sym_BQUOTE] = ACTIONS(2752),
    [anon_sym_LT_LPAREN] = ACTIONS(2752),
    [anon_sym_GT_LPAREN] = ACTIONS(2752),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2754),
    [sym_word] = ACTIONS(2754),
  },
  [1775] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4984),
    [sym_comment] = ACTIONS(53),
  },
  [1776] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(4986),
    [sym_comment] = ACTIONS(53),
  },
  [1777] = {
    [anon_sym_RBRACE] = ACTIONS(4986),
    [sym_comment] = ACTIONS(53),
  },
  [1778] = {
    [sym_concatenation] = STATE(2140),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2140),
    [anon_sym_RBRACE] = ACTIONS(4988),
    [anon_sym_EQ] = ACTIONS(4990),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(4992),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(4990),
    [anon_sym_COLON_QMARK] = ACTIONS(4990),
    [anon_sym_COLON_DASH] = ACTIONS(4990),
    [anon_sym_PERCENT] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4990),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1779] = {
    [sym__concat] = ACTIONS(2830),
    [sym_variable_name] = ACTIONS(2830),
    [anon_sym_PIPE] = ACTIONS(2832),
    [anon_sym_RPAREN] = ACTIONS(2830),
    [anon_sym_PIPE_AMP] = ACTIONS(2830),
    [anon_sym_AMP_AMP] = ACTIONS(2830),
    [anon_sym_PIPE_PIPE] = ACTIONS(2830),
    [sym__special_characters] = ACTIONS(2830),
    [anon_sym_DQUOTE] = ACTIONS(2830),
    [anon_sym_DOLLAR] = ACTIONS(2832),
    [sym_raw_string] = ACTIONS(2830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2830),
    [anon_sym_BQUOTE] = ACTIONS(2830),
    [anon_sym_LT_LPAREN] = ACTIONS(2830),
    [anon_sym_GT_LPAREN] = ACTIONS(2830),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2832),
    [sym_word] = ACTIONS(2832),
  },
  [1780] = {
    [sym_concatenation] = STATE(2143),
    [sym_string] = STATE(2142),
    [sym_simple_expansion] = STATE(2142),
    [sym_string_expansion] = STATE(2142),
    [sym_expansion] = STATE(2142),
    [sym_command_substitution] = STATE(2142),
    [sym_process_substitution] = STATE(2142),
    [anon_sym_RBRACE] = ACTIONS(4986),
    [sym__special_characters] = ACTIONS(4994),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(4996),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4996),
  },
  [1781] = {
    [sym__concat] = ACTIONS(2873),
    [sym_variable_name] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_PIPE_AMP] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [sym__special_characters] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2873),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2873),
    [anon_sym_BQUOTE] = ACTIONS(2873),
    [anon_sym_LT_LPAREN] = ACTIONS(2873),
    [anon_sym_GT_LPAREN] = ACTIONS(2873),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2875),
    [sym_word] = ACTIONS(2875),
  },
  [1782] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(4998),
  },
  [1783] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5000),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1784] = {
    [sym__concat] = ACTIONS(2881),
    [sym_variable_name] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [anon_sym_PIPE_AMP] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [sym__special_characters] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [sym_raw_string] = ACTIONS(2881),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2881),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2881),
    [anon_sym_BQUOTE] = ACTIONS(2881),
    [anon_sym_LT_LPAREN] = ACTIONS(2881),
    [anon_sym_GT_LPAREN] = ACTIONS(2881),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2883),
    [sym_word] = ACTIONS(2883),
  },
  [1785] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5002),
  },
  [1786] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5004),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1787] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5006),
  },
  [1788] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(4986),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1789] = {
    [sym_concatenation] = STATE(2150),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2150),
    [anon_sym_RBRACE] = ACTIONS(5008),
    [anon_sym_EQ] = ACTIONS(5010),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5010),
    [anon_sym_COLON_QMARK] = ACTIONS(5010),
    [anon_sym_COLON_DASH] = ACTIONS(5010),
    [anon_sym_PERCENT] = ACTIONS(5010),
    [anon_sym_DASH] = ACTIONS(5010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1790] = {
    [sym__concat] = ACTIONS(2897),
    [sym_variable_name] = ACTIONS(2897),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_RPAREN] = ACTIONS(2897),
    [anon_sym_PIPE_AMP] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2897),
    [anon_sym_PIPE_PIPE] = ACTIONS(2897),
    [sym__special_characters] = ACTIONS(2897),
    [anon_sym_DQUOTE] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2899),
    [sym_raw_string] = ACTIONS(2897),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2897),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2897),
    [anon_sym_BQUOTE] = ACTIONS(2897),
    [anon_sym_LT_LPAREN] = ACTIONS(2897),
    [anon_sym_GT_LPAREN] = ACTIONS(2897),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2899),
    [sym_word] = ACTIONS(2899),
  },
  [1791] = {
    [sym_concatenation] = STATE(2152),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2152),
    [anon_sym_RBRACE] = ACTIONS(5014),
    [anon_sym_EQ] = ACTIONS(5016),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5018),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5016),
    [anon_sym_COLON_QMARK] = ACTIONS(5016),
    [anon_sym_COLON_DASH] = ACTIONS(5016),
    [anon_sym_PERCENT] = ACTIONS(5016),
    [anon_sym_DASH] = ACTIONS(5016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1792] = {
    [sym__concat] = ACTIONS(2752),
    [anon_sym_PIPE] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(2752),
    [anon_sym_PIPE_AMP] = ACTIONS(2752),
    [anon_sym_AMP_AMP] = ACTIONS(2752),
    [anon_sym_PIPE_PIPE] = ACTIONS(2752),
    [sym__special_characters] = ACTIONS(2752),
    [anon_sym_DQUOTE] = ACTIONS(2752),
    [anon_sym_DOLLAR] = ACTIONS(2754),
    [sym_raw_string] = ACTIONS(2752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2752),
    [anon_sym_BQUOTE] = ACTIONS(2752),
    [anon_sym_LT_LPAREN] = ACTIONS(2752),
    [anon_sym_GT_LPAREN] = ACTIONS(2752),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2754),
    [sym_word] = ACTIONS(2754),
  },
  [1793] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5020),
    [sym_comment] = ACTIONS(53),
  },
  [1794] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(53),
  },
  [1795] = {
    [anon_sym_RBRACE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(53),
  },
  [1796] = {
    [sym_concatenation] = STATE(2156),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2156),
    [anon_sym_RBRACE] = ACTIONS(5024),
    [anon_sym_EQ] = ACTIONS(5026),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5026),
    [anon_sym_COLON_QMARK] = ACTIONS(5026),
    [anon_sym_COLON_DASH] = ACTIONS(5026),
    [anon_sym_PERCENT] = ACTIONS(5026),
    [anon_sym_DASH] = ACTIONS(5026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1797] = {
    [sym__concat] = ACTIONS(2830),
    [anon_sym_PIPE] = ACTIONS(2832),
    [anon_sym_RPAREN] = ACTIONS(2830),
    [anon_sym_PIPE_AMP] = ACTIONS(2830),
    [anon_sym_AMP_AMP] = ACTIONS(2830),
    [anon_sym_PIPE_PIPE] = ACTIONS(2830),
    [sym__special_characters] = ACTIONS(2830),
    [anon_sym_DQUOTE] = ACTIONS(2830),
    [anon_sym_DOLLAR] = ACTIONS(2832),
    [sym_raw_string] = ACTIONS(2830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2830),
    [anon_sym_BQUOTE] = ACTIONS(2830),
    [anon_sym_LT_LPAREN] = ACTIONS(2830),
    [anon_sym_GT_LPAREN] = ACTIONS(2830),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2832),
    [sym_word] = ACTIONS(2832),
  },
  [1798] = {
    [sym_concatenation] = STATE(2159),
    [sym_string] = STATE(2158),
    [sym_simple_expansion] = STATE(2158),
    [sym_string_expansion] = STATE(2158),
    [sym_expansion] = STATE(2158),
    [sym_command_substitution] = STATE(2158),
    [sym_process_substitution] = STATE(2158),
    [anon_sym_RBRACE] = ACTIONS(5022),
    [sym__special_characters] = ACTIONS(5030),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(5032),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5032),
  },
  [1799] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_PIPE_AMP] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [sym__special_characters] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2873),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2873),
    [anon_sym_BQUOTE] = ACTIONS(2873),
    [anon_sym_LT_LPAREN] = ACTIONS(2873),
    [anon_sym_GT_LPAREN] = ACTIONS(2873),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2875),
    [sym_word] = ACTIONS(2875),
  },
  [1800] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5034),
  },
  [1801] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5036),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1802] = {
    [sym__concat] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [anon_sym_PIPE_AMP] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [sym__special_characters] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [sym_raw_string] = ACTIONS(2881),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2881),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2881),
    [anon_sym_BQUOTE] = ACTIONS(2881),
    [anon_sym_LT_LPAREN] = ACTIONS(2881),
    [anon_sym_GT_LPAREN] = ACTIONS(2881),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2883),
    [sym_word] = ACTIONS(2883),
  },
  [1803] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5038),
  },
  [1804] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5040),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1805] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5042),
  },
  [1806] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5022),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1807] = {
    [sym_concatenation] = STATE(2166),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2166),
    [anon_sym_RBRACE] = ACTIONS(5044),
    [anon_sym_EQ] = ACTIONS(5046),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5046),
    [anon_sym_COLON_QMARK] = ACTIONS(5046),
    [anon_sym_COLON_DASH] = ACTIONS(5046),
    [anon_sym_PERCENT] = ACTIONS(5046),
    [anon_sym_DASH] = ACTIONS(5046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1808] = {
    [sym__concat] = ACTIONS(2897),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_RPAREN] = ACTIONS(2897),
    [anon_sym_PIPE_AMP] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2897),
    [anon_sym_PIPE_PIPE] = ACTIONS(2897),
    [sym__special_characters] = ACTIONS(2897),
    [anon_sym_DQUOTE] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2899),
    [sym_raw_string] = ACTIONS(2897),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2897),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2897),
    [anon_sym_BQUOTE] = ACTIONS(2897),
    [anon_sym_LT_LPAREN] = ACTIONS(2897),
    [anon_sym_GT_LPAREN] = ACTIONS(2897),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2899),
    [sym_word] = ACTIONS(2899),
  },
  [1809] = {
    [sym_concatenation] = STATE(2168),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2168),
    [anon_sym_RBRACE] = ACTIONS(5050),
    [anon_sym_EQ] = ACTIONS(5052),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5054),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5052),
    [anon_sym_COLON_QMARK] = ACTIONS(5052),
    [anon_sym_COLON_DASH] = ACTIONS(5052),
    [anon_sym_PERCENT] = ACTIONS(5052),
    [anon_sym_DASH] = ACTIONS(5052),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1810] = {
    [sym__simple_heredoc_body] = ACTIONS(3917),
    [sym__heredoc_body_beginning] = ACTIONS(3917),
    [sym_file_descriptor] = ACTIONS(3917),
    [sym__concat] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3919),
    [anon_sym_RPAREN] = ACTIONS(3917),
    [anon_sym_PIPE_AMP] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_EQ_TILDE] = ACTIONS(3919),
    [anon_sym_EQ_EQ] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_GT] = ACTIONS(3919),
    [anon_sym_GT_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT] = ACTIONS(3919),
    [anon_sym_AMP_GT_GT] = ACTIONS(3917),
    [anon_sym_LT_AMP] = ACTIONS(3917),
    [anon_sym_GT_AMP] = ACTIONS(3917),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_LT_LT_DASH] = ACTIONS(3917),
    [anon_sym_LT_LT_LT] = ACTIONS(3917),
    [sym__special_characters] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_DOLLAR] = ACTIONS(3919),
    [sym_raw_string] = ACTIONS(3917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3917),
    [anon_sym_BQUOTE] = ACTIONS(3917),
    [anon_sym_LT_LPAREN] = ACTIONS(3917),
    [anon_sym_GT_LPAREN] = ACTIONS(3917),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3919),
  },
  [1811] = {
    [sym__simple_heredoc_body] = ACTIONS(3923),
    [sym__heredoc_body_beginning] = ACTIONS(3923),
    [sym_file_descriptor] = ACTIONS(3923),
    [sym__concat] = ACTIONS(3923),
    [anon_sym_PIPE] = ACTIONS(3925),
    [anon_sym_RPAREN] = ACTIONS(3923),
    [anon_sym_PIPE_AMP] = ACTIONS(3923),
    [anon_sym_AMP_AMP] = ACTIONS(3923),
    [anon_sym_PIPE_PIPE] = ACTIONS(3923),
    [anon_sym_EQ_TILDE] = ACTIONS(3925),
    [anon_sym_EQ_EQ] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_GT] = ACTIONS(3925),
    [anon_sym_GT_GT] = ACTIONS(3923),
    [anon_sym_AMP_GT] = ACTIONS(3925),
    [anon_sym_AMP_GT_GT] = ACTIONS(3923),
    [anon_sym_LT_AMP] = ACTIONS(3923),
    [anon_sym_GT_AMP] = ACTIONS(3923),
    [anon_sym_LT_LT] = ACTIONS(3925),
    [anon_sym_LT_LT_DASH] = ACTIONS(3923),
    [anon_sym_LT_LT_LT] = ACTIONS(3923),
    [sym__special_characters] = ACTIONS(3923),
    [anon_sym_DQUOTE] = ACTIONS(3923),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [sym_raw_string] = ACTIONS(3923),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3923),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3923),
    [anon_sym_BQUOTE] = ACTIONS(3923),
    [anon_sym_LT_LPAREN] = ACTIONS(3923),
    [anon_sym_GT_LPAREN] = ACTIONS(3923),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3925),
  },
  [1812] = {
    [sym__simple_heredoc_body] = ACTIONS(4008),
    [sym__heredoc_body_beginning] = ACTIONS(4008),
    [sym_file_descriptor] = ACTIONS(4008),
    [sym__concat] = ACTIONS(4008),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_RPAREN] = ACTIONS(4008),
    [anon_sym_PIPE_AMP] = ACTIONS(4008),
    [anon_sym_AMP_AMP] = ACTIONS(4008),
    [anon_sym_PIPE_PIPE] = ACTIONS(4008),
    [anon_sym_EQ_TILDE] = ACTIONS(4010),
    [anon_sym_EQ_EQ] = ACTIONS(4010),
    [anon_sym_LT] = ACTIONS(4010),
    [anon_sym_GT] = ACTIONS(4010),
    [anon_sym_GT_GT] = ACTIONS(4008),
    [anon_sym_AMP_GT] = ACTIONS(4010),
    [anon_sym_AMP_GT_GT] = ACTIONS(4008),
    [anon_sym_LT_AMP] = ACTIONS(4008),
    [anon_sym_GT_AMP] = ACTIONS(4008),
    [anon_sym_LT_LT] = ACTIONS(4010),
    [anon_sym_LT_LT_DASH] = ACTIONS(4008),
    [anon_sym_LT_LT_LT] = ACTIONS(4008),
    [sym__special_characters] = ACTIONS(4008),
    [anon_sym_DQUOTE] = ACTIONS(4008),
    [anon_sym_DOLLAR] = ACTIONS(4010),
    [sym_raw_string] = ACTIONS(4008),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4008),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4008),
    [anon_sym_BQUOTE] = ACTIONS(4008),
    [anon_sym_LT_LPAREN] = ACTIONS(4008),
    [anon_sym_GT_LPAREN] = ACTIONS(4008),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4010),
  },
  [1813] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5056),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1814] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5058),
    [sym_comment] = ACTIONS(53),
  },
  [1815] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5060),
    [sym_comment] = ACTIONS(53),
  },
  [1816] = {
    [anon_sym_RBRACE] = ACTIONS(5060),
    [sym_comment] = ACTIONS(53),
  },
  [1817] = {
    [sym_concatenation] = STATE(2173),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2173),
    [anon_sym_RBRACE] = ACTIONS(5062),
    [anon_sym_EQ] = ACTIONS(5064),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5066),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5064),
    [anon_sym_COLON_QMARK] = ACTIONS(5064),
    [anon_sym_COLON_DASH] = ACTIONS(5064),
    [anon_sym_PERCENT] = ACTIONS(5064),
    [anon_sym_DASH] = ACTIONS(5064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1818] = {
    [sym__simple_heredoc_body] = ACTIONS(4024),
    [sym__heredoc_body_beginning] = ACTIONS(4024),
    [sym_file_descriptor] = ACTIONS(4024),
    [sym__concat] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_PIPE_AMP] = ACTIONS(4024),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_EQ_TILDE] = ACTIONS(4026),
    [anon_sym_EQ_EQ] = ACTIONS(4026),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_GT_GT] = ACTIONS(4024),
    [anon_sym_AMP_GT] = ACTIONS(4026),
    [anon_sym_AMP_GT_GT] = ACTIONS(4024),
    [anon_sym_LT_AMP] = ACTIONS(4024),
    [anon_sym_GT_AMP] = ACTIONS(4024),
    [anon_sym_LT_LT] = ACTIONS(4026),
    [anon_sym_LT_LT_DASH] = ACTIONS(4024),
    [anon_sym_LT_LT_LT] = ACTIONS(4024),
    [sym__special_characters] = ACTIONS(4024),
    [anon_sym_DQUOTE] = ACTIONS(4024),
    [anon_sym_DOLLAR] = ACTIONS(4026),
    [sym_raw_string] = ACTIONS(4024),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4024),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4024),
    [anon_sym_BQUOTE] = ACTIONS(4024),
    [anon_sym_LT_LPAREN] = ACTIONS(4024),
    [anon_sym_GT_LPAREN] = ACTIONS(4024),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4026),
  },
  [1819] = {
    [sym_concatenation] = STATE(2175),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2175),
    [anon_sym_RBRACE] = ACTIONS(5068),
    [anon_sym_EQ] = ACTIONS(5070),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5072),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5070),
    [anon_sym_COLON_QMARK] = ACTIONS(5070),
    [anon_sym_COLON_DASH] = ACTIONS(5070),
    [anon_sym_PERCENT] = ACTIONS(5070),
    [anon_sym_DASH] = ACTIONS(5070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1820] = {
    [sym__simple_heredoc_body] = ACTIONS(4034),
    [sym__heredoc_body_beginning] = ACTIONS(4034),
    [sym_file_descriptor] = ACTIONS(4034),
    [sym__concat] = ACTIONS(4034),
    [anon_sym_PIPE] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4034),
    [anon_sym_PIPE_AMP] = ACTIONS(4034),
    [anon_sym_AMP_AMP] = ACTIONS(4034),
    [anon_sym_PIPE_PIPE] = ACTIONS(4034),
    [anon_sym_EQ_TILDE] = ACTIONS(4036),
    [anon_sym_EQ_EQ] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4036),
    [anon_sym_GT] = ACTIONS(4036),
    [anon_sym_GT_GT] = ACTIONS(4034),
    [anon_sym_AMP_GT] = ACTIONS(4036),
    [anon_sym_AMP_GT_GT] = ACTIONS(4034),
    [anon_sym_LT_AMP] = ACTIONS(4034),
    [anon_sym_GT_AMP] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4036),
    [anon_sym_LT_LT_DASH] = ACTIONS(4034),
    [anon_sym_LT_LT_LT] = ACTIONS(4034),
    [sym__special_characters] = ACTIONS(4034),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_DOLLAR] = ACTIONS(4036),
    [sym_raw_string] = ACTIONS(4034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4034),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4034),
    [anon_sym_BQUOTE] = ACTIONS(4034),
    [anon_sym_LT_LPAREN] = ACTIONS(4034),
    [anon_sym_GT_LPAREN] = ACTIONS(4034),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4036),
  },
  [1821] = {
    [sym_concatenation] = STATE(2177),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2177),
    [anon_sym_RBRACE] = ACTIONS(5074),
    [anon_sym_EQ] = ACTIONS(5076),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5078),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5076),
    [anon_sym_COLON_QMARK] = ACTIONS(5076),
    [anon_sym_COLON_DASH] = ACTIONS(5076),
    [anon_sym_PERCENT] = ACTIONS(5076),
    [anon_sym_DASH] = ACTIONS(5076),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1822] = {
    [sym__simple_heredoc_body] = ACTIONS(4044),
    [sym__heredoc_body_beginning] = ACTIONS(4044),
    [sym_file_descriptor] = ACTIONS(4044),
    [sym__concat] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_RPAREN] = ACTIONS(4044),
    [anon_sym_PIPE_AMP] = ACTIONS(4044),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [anon_sym_EQ_TILDE] = ACTIONS(4046),
    [anon_sym_EQ_EQ] = ACTIONS(4046),
    [anon_sym_LT] = ACTIONS(4046),
    [anon_sym_GT] = ACTIONS(4046),
    [anon_sym_GT_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT] = ACTIONS(4046),
    [anon_sym_AMP_GT_GT] = ACTIONS(4044),
    [anon_sym_LT_AMP] = ACTIONS(4044),
    [anon_sym_GT_AMP] = ACTIONS(4044),
    [anon_sym_LT_LT] = ACTIONS(4046),
    [anon_sym_LT_LT_DASH] = ACTIONS(4044),
    [anon_sym_LT_LT_LT] = ACTIONS(4044),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(4044),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [sym_raw_string] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4044),
    [anon_sym_BQUOTE] = ACTIONS(4044),
    [anon_sym_LT_LPAREN] = ACTIONS(4044),
    [anon_sym_GT_LPAREN] = ACTIONS(4044),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4046),
  },
  [1823] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5080),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1824] = {
    [sym__simple_heredoc_body] = ACTIONS(4050),
    [sym__heredoc_body_beginning] = ACTIONS(4050),
    [sym_file_descriptor] = ACTIONS(4050),
    [sym__concat] = ACTIONS(4050),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_RPAREN] = ACTIONS(4050),
    [anon_sym_PIPE_AMP] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_EQ_TILDE] = ACTIONS(4052),
    [anon_sym_EQ_EQ] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4050),
    [anon_sym_AMP_GT] = ACTIONS(4052),
    [anon_sym_AMP_GT_GT] = ACTIONS(4050),
    [anon_sym_LT_AMP] = ACTIONS(4050),
    [anon_sym_GT_AMP] = ACTIONS(4050),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_LT_LT_DASH] = ACTIONS(4050),
    [anon_sym_LT_LT_LT] = ACTIONS(4050),
    [sym__special_characters] = ACTIONS(4050),
    [anon_sym_DQUOTE] = ACTIONS(4050),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [sym_raw_string] = ACTIONS(4050),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4050),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4050),
    [anon_sym_BQUOTE] = ACTIONS(4050),
    [anon_sym_LT_LPAREN] = ACTIONS(4050),
    [anon_sym_GT_LPAREN] = ACTIONS(4050),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4052),
  },
  [1825] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5082),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1826] = {
    [anon_sym_PIPE] = ACTIONS(3609),
    [anon_sym_RPAREN] = ACTIONS(3611),
    [anon_sym_PIPE_AMP] = ACTIONS(3611),
    [anon_sym_AMP_AMP] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(3611),
    [anon_sym_BQUOTE] = ACTIONS(3611),
    [sym_comment] = ACTIONS(53),
  },
  [1827] = {
    [aux_sym_concatenation_repeat1] = STATE(1827),
    [sym__simple_heredoc_body] = ACTIONS(1654),
    [sym__heredoc_body_beginning] = ACTIONS(1654),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(3110),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1654),
    [anon_sym_PIPE_AMP] = ACTIONS(1654),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1654),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1654),
    [anon_sym_LT_AMP] = ACTIONS(1654),
    [anon_sym_GT_AMP] = ACTIONS(1654),
    [anon_sym_LT_LT] = ACTIONS(1656),
    [anon_sym_LT_LT_DASH] = ACTIONS(1654),
    [anon_sym_LT_LT_LT] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
  },
  [1828] = {
    [anon_sym_PIPE] = ACTIONS(4302),
    [anon_sym_RPAREN] = ACTIONS(4304),
    [anon_sym_PIPE_AMP] = ACTIONS(4304),
    [anon_sym_AMP_AMP] = ACTIONS(4304),
    [anon_sym_PIPE_PIPE] = ACTIONS(4304),
    [anon_sym_BQUOTE] = ACTIONS(4304),
    [sym_comment] = ACTIONS(53),
  },
  [1829] = {
    [aux_sym_concatenation_repeat1] = STATE(1829),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(2655),
    [sym_variable_name] = ACTIONS(1654),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1654),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1654),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1654),
    [anon_sym_LT_AMP] = ACTIONS(1654),
    [anon_sym_GT_AMP] = ACTIONS(1654),
    [sym__special_characters] = ACTIONS(1654),
    [anon_sym_DQUOTE] = ACTIONS(1654),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1654),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1654),
    [anon_sym_BQUOTE] = ACTIONS(1654),
    [anon_sym_LT_LPAREN] = ACTIONS(1654),
    [anon_sym_GT_LPAREN] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1654),
  },
  [1830] = {
    [sym_file_redirect] = STATE(2110),
    [sym_file_descriptor] = ACTIONS(3209),
    [anon_sym_PIPE] = ACTIONS(3609),
    [anon_sym_PIPE_AMP] = ACTIONS(3611),
    [anon_sym_AMP_AMP] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(3611),
    [anon_sym_LT] = ACTIONS(3211),
    [anon_sym_GT] = ACTIONS(3211),
    [anon_sym_GT_GT] = ACTIONS(3213),
    [anon_sym_AMP_GT] = ACTIONS(3211),
    [anon_sym_AMP_GT_GT] = ACTIONS(3213),
    [anon_sym_LT_AMP] = ACTIONS(3213),
    [anon_sym_GT_AMP] = ACTIONS(3213),
    [anon_sym_BQUOTE] = ACTIONS(3611),
    [sym_comment] = ACTIONS(53),
  },
  [1831] = {
    [sym_concatenation] = STATE(2113),
    [sym_string] = STATE(2181),
    [sym_simple_expansion] = STATE(2181),
    [sym_string_expansion] = STATE(2181),
    [sym_expansion] = STATE(2181),
    [sym_command_substitution] = STATE(2181),
    [sym_process_substitution] = STATE(2181),
    [sym__special_characters] = ACTIONS(5084),
    [anon_sym_DQUOTE] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [sym_raw_string] = ACTIONS(5086),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [anon_sym_LT_LPAREN] = ACTIONS(839),
    [anon_sym_GT_LPAREN] = ACTIONS(839),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5086),
  },
  [1832] = {
    [aux_sym_concatenation_repeat1] = STATE(2182),
    [sym__concat] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_BQUOTE] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
  },
  [1833] = {
    [aux_sym_concatenation_repeat1] = STATE(2182),
    [sym__concat] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [sym_comment] = ACTIONS(53),
  },
  [1834] = {
    [sym_concatenation] = STATE(2117),
    [sym_string] = STATE(2184),
    [sym_simple_expansion] = STATE(2184),
    [sym_string_expansion] = STATE(2184),
    [sym_expansion] = STATE(2184),
    [sym_command_substitution] = STATE(2184),
    [sym_process_substitution] = STATE(2184),
    [sym__special_characters] = ACTIONS(5088),
    [anon_sym_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [sym_raw_string] = ACTIONS(5090),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4104),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4106),
    [anon_sym_BQUOTE] = ACTIONS(4108),
    [anon_sym_LT_LPAREN] = ACTIONS(4110),
    [anon_sym_GT_LPAREN] = ACTIONS(4110),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5090),
  },
  [1835] = {
    [aux_sym_concatenation_repeat1] = STATE(2185),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(4942),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(661),
    [anon_sym_LT_AMP] = ACTIONS(661),
    [anon_sym_GT_AMP] = ACTIONS(661),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(661),
    [anon_sym_LT_LT_LT] = ACTIONS(661),
    [anon_sym_BQUOTE] = ACTIONS(661),
    [sym_comment] = ACTIONS(53),
  },
  [1836] = {
    [aux_sym_concatenation_repeat1] = STATE(2185),
    [sym_file_descriptor] = ACTIONS(677),
    [sym__concat] = ACTIONS(4942),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(677),
    [anon_sym_LT_AMP] = ACTIONS(677),
    [anon_sym_GT_AMP] = ACTIONS(677),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(677),
    [anon_sym_LT_LT_LT] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [sym_comment] = ACTIONS(53),
  },
  [1837] = {
    [aux_sym_concatenation_repeat1] = STATE(2185),
    [sym_file_descriptor] = ACTIONS(2070),
    [sym__concat] = ACTIONS(4942),
    [anon_sym_PIPE] = ACTIONS(2072),
    [anon_sym_PIPE_AMP] = ACTIONS(2070),
    [anon_sym_AMP_AMP] = ACTIONS(2070),
    [anon_sym_PIPE_PIPE] = ACTIONS(2070),
    [anon_sym_LT] = ACTIONS(2072),
    [anon_sym_GT] = ACTIONS(2072),
    [anon_sym_GT_GT] = ACTIONS(2070),
    [anon_sym_AMP_GT] = ACTIONS(2072),
    [anon_sym_AMP_GT_GT] = ACTIONS(2070),
    [anon_sym_LT_AMP] = ACTIONS(2070),
    [anon_sym_GT_AMP] = ACTIONS(2070),
    [anon_sym_LT_LT] = ACTIONS(2072),
    [anon_sym_LT_LT_DASH] = ACTIONS(2070),
    [anon_sym_LT_LT_LT] = ACTIONS(2070),
    [anon_sym_BQUOTE] = ACTIONS(2070),
    [sym_comment] = ACTIONS(53),
  },
  [1838] = {
    [aux_sym_concatenation_repeat1] = STATE(2185),
    [sym_file_descriptor] = ACTIONS(2074),
    [sym__concat] = ACTIONS(4942),
    [anon_sym_PIPE] = ACTIONS(2076),
    [anon_sym_PIPE_AMP] = ACTIONS(2074),
    [anon_sym_AMP_AMP] = ACTIONS(2074),
    [anon_sym_PIPE_PIPE] = ACTIONS(2074),
    [anon_sym_LT] = ACTIONS(2076),
    [anon_sym_GT] = ACTIONS(2076),
    [anon_sym_GT_GT] = ACTIONS(2074),
    [anon_sym_AMP_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT_GT] = ACTIONS(2074),
    [anon_sym_LT_AMP] = ACTIONS(2074),
    [anon_sym_GT_AMP] = ACTIONS(2074),
    [anon_sym_LT_LT] = ACTIONS(2076),
    [anon_sym_LT_LT_DASH] = ACTIONS(2074),
    [anon_sym_LT_LT_LT] = ACTIONS(2074),
    [anon_sym_BQUOTE] = ACTIONS(2074),
    [sym_comment] = ACTIONS(53),
  },
  [1839] = {
    [sym_file_redirect] = STATE(1839),
    [sym_heredoc_redirect] = STATE(1839),
    [sym_herestring_redirect] = STATE(1839),
    [aux_sym_while_statement_repeat1] = STATE(1839),
    [sym_file_descriptor] = ACTIONS(5092),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_PIPE_AMP] = ACTIONS(2082),
    [anon_sym_AMP_AMP] = ACTIONS(2082),
    [anon_sym_PIPE_PIPE] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5098),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT_GT] = ACTIONS(5098),
    [anon_sym_LT_AMP] = ACTIONS(5098),
    [anon_sym_GT_AMP] = ACTIONS(5098),
    [anon_sym_LT_LT] = ACTIONS(4973),
    [anon_sym_LT_LT_DASH] = ACTIONS(4976),
    [anon_sym_LT_LT_LT] = ACTIONS(5101),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(53),
  },
  [1840] = {
    [aux_sym_concatenation_repeat1] = STATE(1840),
    [sym__simple_heredoc_body] = ACTIONS(1654),
    [sym__heredoc_body_beginning] = ACTIONS(1654),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(3110),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1654),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1654),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1654),
    [anon_sym_LT_AMP] = ACTIONS(1654),
    [anon_sym_GT_AMP] = ACTIONS(1654),
    [anon_sym_LT_LT] = ACTIONS(1656),
    [anon_sym_LT_LT_DASH] = ACTIONS(1654),
    [anon_sym_LT_LT_LT] = ACTIONS(1654),
    [anon_sym_BQUOTE] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
  },
  [1841] = {
    [sym__heredoc_body_middle] = ACTIONS(2752),
    [sym__heredoc_body_end] = ACTIONS(2752),
    [anon_sym_DOLLAR] = ACTIONS(2754),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2752),
    [sym_comment] = ACTIONS(53),
  },
  [1842] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5104),
    [sym_comment] = ACTIONS(53),
  },
  [1843] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5106),
    [sym_comment] = ACTIONS(53),
  },
  [1844] = {
    [anon_sym_RBRACE] = ACTIONS(5106),
    [sym_comment] = ACTIONS(53),
  },
  [1845] = {
    [sym_concatenation] = STATE(2189),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2189),
    [anon_sym_RBRACE] = ACTIONS(5108),
    [anon_sym_EQ] = ACTIONS(5110),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5112),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5110),
    [anon_sym_COLON_QMARK] = ACTIONS(5110),
    [anon_sym_COLON_DASH] = ACTIONS(5110),
    [anon_sym_PERCENT] = ACTIONS(5110),
    [anon_sym_DASH] = ACTIONS(5110),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1846] = {
    [sym__heredoc_body_middle] = ACTIONS(2830),
    [sym__heredoc_body_end] = ACTIONS(2830),
    [anon_sym_DOLLAR] = ACTIONS(2832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2830),
    [sym_comment] = ACTIONS(53),
  },
  [1847] = {
    [sym_concatenation] = STATE(2192),
    [sym_string] = STATE(2191),
    [sym_simple_expansion] = STATE(2191),
    [sym_string_expansion] = STATE(2191),
    [sym_expansion] = STATE(2191),
    [sym_command_substitution] = STATE(2191),
    [sym_process_substitution] = STATE(2191),
    [anon_sym_RBRACE] = ACTIONS(5106),
    [sym__special_characters] = ACTIONS(5114),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(5116),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5116),
  },
  [1848] = {
    [sym__heredoc_body_middle] = ACTIONS(2873),
    [sym__heredoc_body_end] = ACTIONS(2873),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2873),
    [sym_comment] = ACTIONS(53),
  },
  [1849] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5118),
  },
  [1850] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5120),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1851] = {
    [sym__heredoc_body_middle] = ACTIONS(2881),
    [sym__heredoc_body_end] = ACTIONS(2881),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2881),
    [sym_comment] = ACTIONS(53),
  },
  [1852] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5122),
  },
  [1853] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5124),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1854] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5126),
  },
  [1855] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5106),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1856] = {
    [sym_concatenation] = STATE(2199),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2199),
    [anon_sym_RBRACE] = ACTIONS(5128),
    [anon_sym_EQ] = ACTIONS(5130),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5132),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5130),
    [anon_sym_COLON_QMARK] = ACTIONS(5130),
    [anon_sym_COLON_DASH] = ACTIONS(5130),
    [anon_sym_PERCENT] = ACTIONS(5130),
    [anon_sym_DASH] = ACTIONS(5130),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1857] = {
    [sym__heredoc_body_middle] = ACTIONS(2897),
    [sym__heredoc_body_end] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2897),
    [sym_comment] = ACTIONS(53),
  },
  [1858] = {
    [sym_concatenation] = STATE(2201),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2201),
    [anon_sym_RBRACE] = ACTIONS(5134),
    [anon_sym_EQ] = ACTIONS(5136),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5138),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5136),
    [anon_sym_COLON_QMARK] = ACTIONS(5136),
    [anon_sym_COLON_DASH] = ACTIONS(5136),
    [anon_sym_PERCENT] = ACTIONS(5136),
    [anon_sym_DASH] = ACTIONS(5136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1859] = {
    [sym__concat] = ACTIONS(2752),
    [anon_sym_RPAREN] = ACTIONS(2752),
    [sym__special_characters] = ACTIONS(2752),
    [anon_sym_DQUOTE] = ACTIONS(2752),
    [anon_sym_DOLLAR] = ACTIONS(2754),
    [sym_raw_string] = ACTIONS(2752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2752),
    [anon_sym_BQUOTE] = ACTIONS(2752),
    [anon_sym_LT_LPAREN] = ACTIONS(2752),
    [anon_sym_GT_LPAREN] = ACTIONS(2752),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2752),
  },
  [1860] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5140),
    [sym_comment] = ACTIONS(53),
  },
  [1861] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5142),
    [sym_comment] = ACTIONS(53),
  },
  [1862] = {
    [anon_sym_RBRACE] = ACTIONS(5142),
    [sym_comment] = ACTIONS(53),
  },
  [1863] = {
    [sym_concatenation] = STATE(2205),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2205),
    [anon_sym_RBRACE] = ACTIONS(5144),
    [anon_sym_EQ] = ACTIONS(5146),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5146),
    [anon_sym_COLON_QMARK] = ACTIONS(5146),
    [anon_sym_COLON_DASH] = ACTIONS(5146),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [anon_sym_DASH] = ACTIONS(5146),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1864] = {
    [sym__concat] = ACTIONS(2830),
    [anon_sym_RPAREN] = ACTIONS(2830),
    [sym__special_characters] = ACTIONS(2830),
    [anon_sym_DQUOTE] = ACTIONS(2830),
    [anon_sym_DOLLAR] = ACTIONS(2832),
    [sym_raw_string] = ACTIONS(2830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2830),
    [anon_sym_BQUOTE] = ACTIONS(2830),
    [anon_sym_LT_LPAREN] = ACTIONS(2830),
    [anon_sym_GT_LPAREN] = ACTIONS(2830),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2830),
  },
  [1865] = {
    [sym_concatenation] = STATE(2208),
    [sym_string] = STATE(2207),
    [sym_simple_expansion] = STATE(2207),
    [sym_string_expansion] = STATE(2207),
    [sym_expansion] = STATE(2207),
    [sym_command_substitution] = STATE(2207),
    [sym_process_substitution] = STATE(2207),
    [anon_sym_RBRACE] = ACTIONS(5142),
    [sym__special_characters] = ACTIONS(5150),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(5152),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5152),
  },
  [1866] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [sym__special_characters] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2873),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2873),
    [anon_sym_BQUOTE] = ACTIONS(2873),
    [anon_sym_LT_LPAREN] = ACTIONS(2873),
    [anon_sym_GT_LPAREN] = ACTIONS(2873),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2873),
  },
  [1867] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5154),
  },
  [1868] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5156),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1869] = {
    [sym__concat] = ACTIONS(2881),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [sym__special_characters] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [sym_raw_string] = ACTIONS(2881),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2881),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2881),
    [anon_sym_BQUOTE] = ACTIONS(2881),
    [anon_sym_LT_LPAREN] = ACTIONS(2881),
    [anon_sym_GT_LPAREN] = ACTIONS(2881),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2881),
  },
  [1870] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5158),
  },
  [1871] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5160),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1872] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5162),
  },
  [1873] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5142),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1874] = {
    [sym_concatenation] = STATE(2215),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2215),
    [anon_sym_RBRACE] = ACTIONS(5164),
    [anon_sym_EQ] = ACTIONS(5166),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5168),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5166),
    [anon_sym_COLON_QMARK] = ACTIONS(5166),
    [anon_sym_COLON_DASH] = ACTIONS(5166),
    [anon_sym_PERCENT] = ACTIONS(5166),
    [anon_sym_DASH] = ACTIONS(5166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1875] = {
    [sym__concat] = ACTIONS(2897),
    [anon_sym_RPAREN] = ACTIONS(2897),
    [sym__special_characters] = ACTIONS(2897),
    [anon_sym_DQUOTE] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2899),
    [sym_raw_string] = ACTIONS(2897),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2897),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2897),
    [anon_sym_BQUOTE] = ACTIONS(2897),
    [anon_sym_LT_LPAREN] = ACTIONS(2897),
    [anon_sym_GT_LPAREN] = ACTIONS(2897),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2897),
  },
  [1876] = {
    [sym_concatenation] = STATE(2217),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2217),
    [anon_sym_RBRACE] = ACTIONS(5170),
    [anon_sym_EQ] = ACTIONS(5172),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5174),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5172),
    [anon_sym_COLON_QMARK] = ACTIONS(5172),
    [anon_sym_COLON_DASH] = ACTIONS(5172),
    [anon_sym_PERCENT] = ACTIONS(5172),
    [anon_sym_DASH] = ACTIONS(5172),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1877] = {
    [sym_file_descriptor] = ACTIONS(3917),
    [sym__concat] = ACTIONS(3917),
    [sym_variable_name] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3919),
    [anon_sym_RPAREN] = ACTIONS(3919),
    [anon_sym_SEMI_SEMI] = ACTIONS(3919),
    [anon_sym_PIPE_AMP] = ACTIONS(3919),
    [anon_sym_AMP_AMP] = ACTIONS(3919),
    [anon_sym_PIPE_PIPE] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_GT] = ACTIONS(3919),
    [anon_sym_GT_GT] = ACTIONS(3919),
    [anon_sym_AMP_GT] = ACTIONS(3919),
    [anon_sym_AMP_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_AMP] = ACTIONS(3919),
    [anon_sym_GT_AMP] = ACTIONS(3919),
    [sym__special_characters] = ACTIONS(3919),
    [anon_sym_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3919),
    [sym_raw_string] = ACTIONS(3919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3919),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3919),
    [anon_sym_BQUOTE] = ACTIONS(3919),
    [anon_sym_LT_LPAREN] = ACTIONS(3919),
    [anon_sym_GT_LPAREN] = ACTIONS(3919),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3919),
    [anon_sym_SEMI] = ACTIONS(3919),
    [anon_sym_LF] = ACTIONS(3917),
    [anon_sym_AMP] = ACTIONS(3919),
  },
  [1878] = {
    [sym_file_descriptor] = ACTIONS(3923),
    [sym__concat] = ACTIONS(3923),
    [sym_variable_name] = ACTIONS(3923),
    [anon_sym_PIPE] = ACTIONS(3925),
    [anon_sym_RPAREN] = ACTIONS(3925),
    [anon_sym_SEMI_SEMI] = ACTIONS(3925),
    [anon_sym_PIPE_AMP] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_GT] = ACTIONS(3925),
    [anon_sym_GT_GT] = ACTIONS(3925),
    [anon_sym_AMP_GT] = ACTIONS(3925),
    [anon_sym_AMP_GT_GT] = ACTIONS(3925),
    [anon_sym_LT_AMP] = ACTIONS(3925),
    [anon_sym_GT_AMP] = ACTIONS(3925),
    [sym__special_characters] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [sym_raw_string] = ACTIONS(3925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3925),
    [anon_sym_BQUOTE] = ACTIONS(3925),
    [anon_sym_LT_LPAREN] = ACTIONS(3925),
    [anon_sym_GT_LPAREN] = ACTIONS(3925),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3925),
    [anon_sym_SEMI] = ACTIONS(3925),
    [anon_sym_LF] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3925),
  },
  [1879] = {
    [sym_file_descriptor] = ACTIONS(4008),
    [sym__concat] = ACTIONS(4008),
    [sym_variable_name] = ACTIONS(4008),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_RPAREN] = ACTIONS(4010),
    [anon_sym_SEMI_SEMI] = ACTIONS(4010),
    [anon_sym_PIPE_AMP] = ACTIONS(4010),
    [anon_sym_AMP_AMP] = ACTIONS(4010),
    [anon_sym_PIPE_PIPE] = ACTIONS(4010),
    [anon_sym_LT] = ACTIONS(4010),
    [anon_sym_GT] = ACTIONS(4010),
    [anon_sym_GT_GT] = ACTIONS(4010),
    [anon_sym_AMP_GT] = ACTIONS(4010),
    [anon_sym_AMP_GT_GT] = ACTIONS(4010),
    [anon_sym_LT_AMP] = ACTIONS(4010),
    [anon_sym_GT_AMP] = ACTIONS(4010),
    [sym__special_characters] = ACTIONS(4010),
    [anon_sym_DQUOTE] = ACTIONS(4010),
    [anon_sym_DOLLAR] = ACTIONS(4010),
    [sym_raw_string] = ACTIONS(4010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4010),
    [anon_sym_BQUOTE] = ACTIONS(4010),
    [anon_sym_LT_LPAREN] = ACTIONS(4010),
    [anon_sym_GT_LPAREN] = ACTIONS(4010),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4010),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LF] = ACTIONS(4008),
    [anon_sym_AMP] = ACTIONS(4010),
  },
  [1880] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5176),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1881] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5178),
    [sym_comment] = ACTIONS(53),
  },
  [1882] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5180),
    [sym_comment] = ACTIONS(53),
  },
  [1883] = {
    [anon_sym_RBRACE] = ACTIONS(5180),
    [sym_comment] = ACTIONS(53),
  },
  [1884] = {
    [sym_concatenation] = STATE(2222),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2222),
    [anon_sym_RBRACE] = ACTIONS(5182),
    [anon_sym_EQ] = ACTIONS(5184),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5186),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5184),
    [anon_sym_COLON_QMARK] = ACTIONS(5184),
    [anon_sym_COLON_DASH] = ACTIONS(5184),
    [anon_sym_PERCENT] = ACTIONS(5184),
    [anon_sym_DASH] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1885] = {
    [sym_file_descriptor] = ACTIONS(4024),
    [sym__concat] = ACTIONS(4024),
    [sym_variable_name] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_RPAREN] = ACTIONS(4026),
    [anon_sym_SEMI_SEMI] = ACTIONS(4026),
    [anon_sym_PIPE_AMP] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4026),
    [anon_sym_PIPE_PIPE] = ACTIONS(4026),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_AMP_GT] = ACTIONS(4026),
    [anon_sym_AMP_GT_GT] = ACTIONS(4026),
    [anon_sym_LT_AMP] = ACTIONS(4026),
    [anon_sym_GT_AMP] = ACTIONS(4026),
    [sym__special_characters] = ACTIONS(4026),
    [anon_sym_DQUOTE] = ACTIONS(4026),
    [anon_sym_DOLLAR] = ACTIONS(4026),
    [sym_raw_string] = ACTIONS(4026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4026),
    [anon_sym_BQUOTE] = ACTIONS(4026),
    [anon_sym_LT_LPAREN] = ACTIONS(4026),
    [anon_sym_GT_LPAREN] = ACTIONS(4026),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4026),
    [anon_sym_SEMI] = ACTIONS(4026),
    [anon_sym_LF] = ACTIONS(4024),
    [anon_sym_AMP] = ACTIONS(4026),
  },
  [1886] = {
    [sym_concatenation] = STATE(2224),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2224),
    [anon_sym_RBRACE] = ACTIONS(5188),
    [anon_sym_EQ] = ACTIONS(5190),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5192),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5190),
    [anon_sym_COLON_QMARK] = ACTIONS(5190),
    [anon_sym_COLON_DASH] = ACTIONS(5190),
    [anon_sym_PERCENT] = ACTIONS(5190),
    [anon_sym_DASH] = ACTIONS(5190),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1887] = {
    [sym_file_descriptor] = ACTIONS(4034),
    [sym__concat] = ACTIONS(4034),
    [sym_variable_name] = ACTIONS(4034),
    [anon_sym_PIPE] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_SEMI_SEMI] = ACTIONS(4036),
    [anon_sym_PIPE_AMP] = ACTIONS(4036),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4036),
    [anon_sym_GT] = ACTIONS(4036),
    [anon_sym_GT_GT] = ACTIONS(4036),
    [anon_sym_AMP_GT] = ACTIONS(4036),
    [anon_sym_AMP_GT_GT] = ACTIONS(4036),
    [anon_sym_LT_AMP] = ACTIONS(4036),
    [anon_sym_GT_AMP] = ACTIONS(4036),
    [sym__special_characters] = ACTIONS(4036),
    [anon_sym_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR] = ACTIONS(4036),
    [sym_raw_string] = ACTIONS(4036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4036),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4036),
    [anon_sym_GT_LPAREN] = ACTIONS(4036),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4036),
    [anon_sym_SEMI] = ACTIONS(4036),
    [anon_sym_LF] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
  },
  [1888] = {
    [sym_concatenation] = STATE(2226),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2226),
    [anon_sym_RBRACE] = ACTIONS(5194),
    [anon_sym_EQ] = ACTIONS(5196),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5196),
    [anon_sym_COLON_QMARK] = ACTIONS(5196),
    [anon_sym_COLON_DASH] = ACTIONS(5196),
    [anon_sym_PERCENT] = ACTIONS(5196),
    [anon_sym_DASH] = ACTIONS(5196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1889] = {
    [sym_file_descriptor] = ACTIONS(4044),
    [sym__concat] = ACTIONS(4044),
    [sym_variable_name] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_RPAREN] = ACTIONS(4046),
    [anon_sym_SEMI_SEMI] = ACTIONS(4046),
    [anon_sym_PIPE_AMP] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4046),
    [anon_sym_PIPE_PIPE] = ACTIONS(4046),
    [anon_sym_LT] = ACTIONS(4046),
    [anon_sym_GT] = ACTIONS(4046),
    [anon_sym_GT_GT] = ACTIONS(4046),
    [anon_sym_AMP_GT] = ACTIONS(4046),
    [anon_sym_AMP_GT_GT] = ACTIONS(4046),
    [anon_sym_LT_AMP] = ACTIONS(4046),
    [anon_sym_GT_AMP] = ACTIONS(4046),
    [sym__special_characters] = ACTIONS(4046),
    [anon_sym_DQUOTE] = ACTIONS(4046),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [sym_raw_string] = ACTIONS(4046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4046),
    [anon_sym_BQUOTE] = ACTIONS(4046),
    [anon_sym_LT_LPAREN] = ACTIONS(4046),
    [anon_sym_GT_LPAREN] = ACTIONS(4046),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4046),
    [anon_sym_SEMI] = ACTIONS(4046),
    [anon_sym_LF] = ACTIONS(4044),
    [anon_sym_AMP] = ACTIONS(4046),
  },
  [1890] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5200),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1891] = {
    [sym_file_descriptor] = ACTIONS(4050),
    [sym__concat] = ACTIONS(4050),
    [sym_variable_name] = ACTIONS(4050),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_RPAREN] = ACTIONS(4052),
    [anon_sym_SEMI_SEMI] = ACTIONS(4052),
    [anon_sym_PIPE_AMP] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4052),
    [anon_sym_PIPE_PIPE] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_AMP_GT] = ACTIONS(4052),
    [anon_sym_AMP_GT_GT] = ACTIONS(4052),
    [anon_sym_LT_AMP] = ACTIONS(4052),
    [anon_sym_GT_AMP] = ACTIONS(4052),
    [sym__special_characters] = ACTIONS(4052),
    [anon_sym_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [sym_raw_string] = ACTIONS(4052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4052),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4052),
    [anon_sym_BQUOTE] = ACTIONS(4052),
    [anon_sym_LT_LPAREN] = ACTIONS(4052),
    [anon_sym_GT_LPAREN] = ACTIONS(4052),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4052),
    [anon_sym_SEMI] = ACTIONS(4052),
    [anon_sym_LF] = ACTIONS(4050),
    [anon_sym_AMP] = ACTIONS(4052),
  },
  [1892] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5202),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1893] = {
    [sym__concat] = ACTIONS(2752),
    [anon_sym_SEMI_SEMI] = ACTIONS(2754),
    [sym__special_characters] = ACTIONS(2754),
    [anon_sym_DQUOTE] = ACTIONS(2754),
    [anon_sym_DOLLAR] = ACTIONS(2754),
    [sym_raw_string] = ACTIONS(2754),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2754),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2754),
    [anon_sym_BQUOTE] = ACTIONS(2754),
    [anon_sym_LT_LPAREN] = ACTIONS(2754),
    [anon_sym_GT_LPAREN] = ACTIONS(2754),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2754),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_LF] = ACTIONS(2752),
    [anon_sym_AMP] = ACTIONS(2754),
  },
  [1894] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5204),
    [sym_comment] = ACTIONS(53),
  },
  [1895] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5206),
    [sym_comment] = ACTIONS(53),
  },
  [1896] = {
    [anon_sym_RBRACE] = ACTIONS(5206),
    [sym_comment] = ACTIONS(53),
  },
  [1897] = {
    [sym_concatenation] = STATE(2232),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2232),
    [anon_sym_RBRACE] = ACTIONS(5208),
    [anon_sym_EQ] = ACTIONS(5210),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5212),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5210),
    [anon_sym_COLON_QMARK] = ACTIONS(5210),
    [anon_sym_COLON_DASH] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5210),
    [anon_sym_DASH] = ACTIONS(5210),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1898] = {
    [sym__concat] = ACTIONS(2830),
    [anon_sym_SEMI_SEMI] = ACTIONS(2832),
    [sym__special_characters] = ACTIONS(2832),
    [anon_sym_DQUOTE] = ACTIONS(2832),
    [anon_sym_DOLLAR] = ACTIONS(2832),
    [sym_raw_string] = ACTIONS(2832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2832),
    [anon_sym_BQUOTE] = ACTIONS(2832),
    [anon_sym_LT_LPAREN] = ACTIONS(2832),
    [anon_sym_GT_LPAREN] = ACTIONS(2832),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2832),
    [anon_sym_SEMI] = ACTIONS(2832),
    [anon_sym_LF] = ACTIONS(2830),
    [anon_sym_AMP] = ACTIONS(2832),
  },
  [1899] = {
    [sym_concatenation] = STATE(2235),
    [sym_string] = STATE(2234),
    [sym_simple_expansion] = STATE(2234),
    [sym_string_expansion] = STATE(2234),
    [sym_expansion] = STATE(2234),
    [sym_command_substitution] = STATE(2234),
    [sym_process_substitution] = STATE(2234),
    [anon_sym_RBRACE] = ACTIONS(5206),
    [sym__special_characters] = ACTIONS(5214),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(5216),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5216),
  },
  [1900] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [sym__special_characters] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2875),
    [anon_sym_BQUOTE] = ACTIONS(2875),
    [anon_sym_LT_LPAREN] = ACTIONS(2875),
    [anon_sym_GT_LPAREN] = ACTIONS(2875),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [1901] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5218),
  },
  [1902] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5220),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1903] = {
    [sym__concat] = ACTIONS(2881),
    [anon_sym_SEMI_SEMI] = ACTIONS(2883),
    [sym__special_characters] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [sym_raw_string] = ACTIONS(2883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2883),
    [anon_sym_BQUOTE] = ACTIONS(2883),
    [anon_sym_LT_LPAREN] = ACTIONS(2883),
    [anon_sym_GT_LPAREN] = ACTIONS(2883),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_LF] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
  },
  [1904] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5222),
  },
  [1905] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5224),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1906] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5226),
  },
  [1907] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5206),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1908] = {
    [sym_concatenation] = STATE(2242),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2242),
    [anon_sym_RBRACE] = ACTIONS(5228),
    [anon_sym_EQ] = ACTIONS(5230),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5232),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5230),
    [anon_sym_COLON_QMARK] = ACTIONS(5230),
    [anon_sym_COLON_DASH] = ACTIONS(5230),
    [anon_sym_PERCENT] = ACTIONS(5230),
    [anon_sym_DASH] = ACTIONS(5230),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1909] = {
    [sym__concat] = ACTIONS(2897),
    [anon_sym_SEMI_SEMI] = ACTIONS(2899),
    [sym__special_characters] = ACTIONS(2899),
    [anon_sym_DQUOTE] = ACTIONS(2899),
    [anon_sym_DOLLAR] = ACTIONS(2899),
    [sym_raw_string] = ACTIONS(2899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2899),
    [anon_sym_BQUOTE] = ACTIONS(2899),
    [anon_sym_LT_LPAREN] = ACTIONS(2899),
    [anon_sym_GT_LPAREN] = ACTIONS(2899),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2899),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LF] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2899),
  },
  [1910] = {
    [sym_concatenation] = STATE(2244),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2244),
    [anon_sym_RBRACE] = ACTIONS(5234),
    [anon_sym_EQ] = ACTIONS(5236),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5236),
    [anon_sym_COLON_QMARK] = ACTIONS(5236),
    [anon_sym_COLON_DASH] = ACTIONS(5236),
    [anon_sym_PERCENT] = ACTIONS(5236),
    [anon_sym_DASH] = ACTIONS(5236),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1911] = {
    [sym__terminated_statement] = STATE(1072),
    [sym_for_statement] = STATE(607),
    [sym_while_statement] = STATE(607),
    [sym_if_statement] = STATE(607),
    [sym_case_statement] = STATE(607),
    [sym_function_definition] = STATE(607),
    [sym_subshell] = STATE(607),
    [sym_pipeline] = STATE(607),
    [sym_list] = STATE(607),
    [sym_negated_command] = STATE(607),
    [sym_test_command] = STATE(607),
    [sym_declaration_command] = STATE(607),
    [sym_unset_command] = STATE(607),
    [sym_command] = STATE(607),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(610),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(1072),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(5240),
    [anon_sym_elif] = ACTIONS(5240),
    [anon_sym_else] = ACTIONS(5240),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1912] = {
    [anon_sym_esac] = ACTIONS(5242),
    [anon_sym_PIPE] = ACTIONS(5242),
    [anon_sym_RPAREN] = ACTIONS(5242),
    [anon_sym_SEMI_SEMI] = ACTIONS(5242),
    [anon_sym_PIPE_AMP] = ACTIONS(5242),
    [anon_sym_AMP_AMP] = ACTIONS(5242),
    [anon_sym_PIPE_PIPE] = ACTIONS(5242),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5242),
    [anon_sym_LF] = ACTIONS(5244),
    [anon_sym_AMP] = ACTIONS(5242),
  },
  [1913] = {
    [aux_sym_concatenation_repeat1] = STATE(1517),
    [sym__concat] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(5246),
    [anon_sym_RPAREN] = ACTIONS(5246),
    [sym_comment] = ACTIONS(53),
  },
  [1914] = {
    [aux_sym_concatenation_repeat1] = STATE(1517),
    [sym__concat] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(5248),
    [anon_sym_RPAREN] = ACTIONS(5248),
    [sym_comment] = ACTIONS(53),
  },
  [1915] = {
    [anon_sym_PIPE] = ACTIONS(5248),
    [anon_sym_RPAREN] = ACTIONS(5248),
    [sym_comment] = ACTIONS(53),
  },
  [1916] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(5250),
    [anon_sym_PLUS_EQ] = ACTIONS(5250),
    [sym_comment] = ACTIONS(53),
  },
  [1917] = {
    [sym__terminated_statement] = STATE(2246),
    [sym_for_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_subshell] = STATE(39),
    [sym_pipeline] = STATE(39),
    [sym_list] = STATE(39),
    [sym_negated_command] = STATE(39),
    [sym_test_command] = STATE(39),
    [sym_declaration_command] = STATE(39),
    [sym_unset_command] = STATE(39),
    [sym_command] = STATE(39),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(40),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [1918] = {
    [anon_sym_esac] = ACTIONS(5252),
    [sym__special_characters] = ACTIONS(5254),
    [anon_sym_DQUOTE] = ACTIONS(5254),
    [anon_sym_DOLLAR] = ACTIONS(5256),
    [sym_raw_string] = ACTIONS(5254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5254),
    [anon_sym_BQUOTE] = ACTIONS(5254),
    [anon_sym_LT_LPAREN] = ACTIONS(5254),
    [anon_sym_GT_LPAREN] = ACTIONS(5254),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5256),
  },
  [1919] = {
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5258),
  },
  [1920] = {
    [sym_test_command] = STATE(70),
    [sym_command] = STATE(70),
    [sym_command_name] = STATE(1935),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(71),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1938),
    [sym_string] = STATE(1928),
    [sym_simple_expansion] = STATE(1928),
    [sym_string_expansion] = STATE(1928),
    [sym_expansion] = STATE(1928),
    [sym_command_substitution] = STATE(1928),
    [sym_process_substitution] = STATE(1928),
    [aux_sym_command_repeat1] = STATE(1940),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(4460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4462),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4468),
    [anon_sym_DQUOTE] = ACTIONS(4470),
    [anon_sym_DOLLAR] = ACTIONS(4472),
    [sym_raw_string] = ACTIONS(4474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4478),
    [anon_sym_BQUOTE] = ACTIONS(4480),
    [anon_sym_LT_LPAREN] = ACTIONS(4482),
    [anon_sym_GT_LPAREN] = ACTIONS(4482),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4474),
  },
  [1921] = {
    [sym__expression] = STATE(2248),
    [sym_binary_expression] = STATE(2248),
    [sym_unary_expression] = STATE(2248),
    [sym_parenthesized_expression] = STATE(2248),
    [sym_concatenation] = STATE(2248),
    [sym_string] = STATE(77),
    [sym_simple_expansion] = STATE(77),
    [sym_string_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [sym_process_substitution] = STATE(77),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(111),
    [sym__special_characters] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
    [sym_test_operator] = ACTIONS(131),
  },
  [1922] = {
    [sym__expression] = STATE(2249),
    [sym_binary_expression] = STATE(2249),
    [sym_unary_expression] = STATE(2249),
    [sym_parenthesized_expression] = STATE(2249),
    [sym_concatenation] = STATE(2249),
    [sym_string] = STATE(88),
    [sym_simple_expansion] = STATE(88),
    [sym_string_expansion] = STATE(88),
    [sym_expansion] = STATE(88),
    [sym_command_substitution] = STATE(88),
    [sym_process_substitution] = STATE(88),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(155),
  },
  [1923] = {
    [sym_variable_assignment] = STATE(2261),
    [sym_subscript] = STATE(2260),
    [sym_concatenation] = STATE(2261),
    [sym_string] = STATE(2254),
    [sym_simple_expansion] = STATE(2254),
    [sym_string_expansion] = STATE(2254),
    [sym_expansion] = STATE(2254),
    [sym_command_substitution] = STATE(2254),
    [sym_process_substitution] = STATE(2254),
    [aux_sym_declaration_command_repeat1] = STATE(2261),
    [sym_variable_name] = ACTIONS(5260),
    [anon_sym_esac] = ACTIONS(159),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(159),
    [anon_sym_PIPE_AMP] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(159),
    [anon_sym_PIPE_PIPE] = ACTIONS(159),
    [sym__special_characters] = ACTIONS(5262),
    [anon_sym_DQUOTE] = ACTIONS(5264),
    [anon_sym_DOLLAR] = ACTIONS(5266),
    [sym_raw_string] = ACTIONS(5268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5270),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5272),
    [anon_sym_BQUOTE] = ACTIONS(5274),
    [anon_sym_LT_LPAREN] = ACTIONS(5276),
    [anon_sym_GT_LPAREN] = ACTIONS(5276),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5278),
    [sym_word] = ACTIONS(5268),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_LF] = ACTIONS(181),
    [anon_sym_AMP] = ACTIONS(159),
  },
  [1924] = {
    [sym_concatenation] = STATE(2271),
    [sym_string] = STATE(2265),
    [sym_simple_expansion] = STATE(2265),
    [sym_string_expansion] = STATE(2265),
    [sym_expansion] = STATE(2265),
    [sym_command_substitution] = STATE(2265),
    [sym_process_substitution] = STATE(2265),
    [aux_sym_unset_command_repeat1] = STATE(2271),
    [anon_sym_esac] = ACTIONS(183),
    [anon_sym_PIPE] = ACTIONS(183),
    [anon_sym_SEMI_SEMI] = ACTIONS(183),
    [anon_sym_PIPE_AMP] = ACTIONS(183),
    [anon_sym_AMP_AMP] = ACTIONS(183),
    [anon_sym_PIPE_PIPE] = ACTIONS(183),
    [sym__special_characters] = ACTIONS(5280),
    [anon_sym_DQUOTE] = ACTIONS(5282),
    [anon_sym_DOLLAR] = ACTIONS(5284),
    [sym_raw_string] = ACTIONS(5286),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5290),
    [anon_sym_BQUOTE] = ACTIONS(5292),
    [anon_sym_LT_LPAREN] = ACTIONS(5294),
    [anon_sym_GT_LPAREN] = ACTIONS(5294),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5296),
    [sym_word] = ACTIONS(5286),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_LF] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(183),
  },
  [1925] = {
    [aux_sym_concatenation_repeat1] = STATE(2273),
    [sym__simple_heredoc_body] = ACTIONS(221),
    [sym__heredoc_body_beginning] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [sym__concat] = ACTIONS(5298),
    [anon_sym_esac] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(225),
    [anon_sym_SEMI_SEMI] = ACTIONS(225),
    [anon_sym_PIPE_AMP] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_EQ_TILDE] = ACTIONS(225),
    [anon_sym_EQ_EQ] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(225),
    [anon_sym_GT] = ACTIONS(225),
    [anon_sym_GT_GT] = ACTIONS(225),
    [anon_sym_AMP_GT] = ACTIONS(225),
    [anon_sym_AMP_GT_GT] = ACTIONS(225),
    [anon_sym_LT_AMP] = ACTIONS(225),
    [anon_sym_GT_AMP] = ACTIONS(225),
    [anon_sym_LT_LT] = ACTIONS(225),
    [anon_sym_LT_LT_DASH] = ACTIONS(225),
    [anon_sym_LT_LT_LT] = ACTIONS(225),
    [sym__special_characters] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [sym_raw_string] = ACTIONS(225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(225),
    [anon_sym_SEMI] = ACTIONS(225),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_AMP] = ACTIONS(225),
  },
  [1926] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(2275),
    [anon_sym_DQUOTE] = ACTIONS(5300),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [1927] = {
    [sym_string] = STATE(2277),
    [anon_sym_DQUOTE] = ACTIONS(4470),
    [anon_sym_DOLLAR] = ACTIONS(5302),
    [sym_raw_string] = ACTIONS(5304),
    [anon_sym_POUND] = ACTIONS(5302),
    [anon_sym_DASH] = ACTIONS(5302),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5306),
    [anon_sym_STAR] = ACTIONS(5302),
    [anon_sym_AT] = ACTIONS(5302),
    [anon_sym_QMARK] = ACTIONS(5302),
    [anon_sym_0] = ACTIONS(5308),
    [anon_sym__] = ACTIONS(5308),
  },
  [1928] = {
    [aux_sym_concatenation_repeat1] = STATE(2273),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(5298),
    [anon_sym_esac] = ACTIONS(249),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_SEMI_SEMI] = ACTIONS(249),
    [anon_sym_PIPE_AMP] = ACTIONS(249),
    [anon_sym_AMP_AMP] = ACTIONS(249),
    [anon_sym_PIPE_PIPE] = ACTIONS(249),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(249),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(249),
    [anon_sym_LT_AMP] = ACTIONS(249),
    [anon_sym_GT_AMP] = ACTIONS(249),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(249),
    [anon_sym_LT_LT_LT] = ACTIONS(249),
    [sym__special_characters] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(249),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(249),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(249),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_LT_LPAREN] = ACTIONS(249),
    [anon_sym_GT_LPAREN] = ACTIONS(249),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_LF] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(249),
  },
  [1929] = {
    [sym_subscript] = STATE(2283),
    [sym_variable_name] = ACTIONS(5310),
    [anon_sym_DOLLAR] = ACTIONS(5312),
    [anon_sym_POUND] = ACTIONS(5314),
    [anon_sym_DASH] = ACTIONS(5312),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5316),
    [anon_sym_STAR] = ACTIONS(5312),
    [anon_sym_AT] = ACTIONS(5312),
    [anon_sym_QMARK] = ACTIONS(5312),
    [anon_sym_0] = ACTIONS(5318),
    [anon_sym__] = ACTIONS(5318),
  },
  [1930] = {
    [sym_for_statement] = STATE(2284),
    [sym_while_statement] = STATE(2284),
    [sym_if_statement] = STATE(2284),
    [sym_case_statement] = STATE(2284),
    [sym_function_definition] = STATE(2284),
    [sym_subshell] = STATE(2284),
    [sym_pipeline] = STATE(2284),
    [sym_list] = STATE(2284),
    [sym_negated_command] = STATE(2284),
    [sym_test_command] = STATE(2284),
    [sym_declaration_command] = STATE(2284),
    [sym_unset_command] = STATE(2284),
    [sym_command] = STATE(2284),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(2285),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [1931] = {
    [sym_for_statement] = STATE(2286),
    [sym_while_statement] = STATE(2286),
    [sym_if_statement] = STATE(2286),
    [sym_case_statement] = STATE(2286),
    [sym_function_definition] = STATE(2286),
    [sym_subshell] = STATE(2286),
    [sym_pipeline] = STATE(2286),
    [sym_list] = STATE(2286),
    [sym_negated_command] = STATE(2286),
    [sym_test_command] = STATE(2286),
    [sym_declaration_command] = STATE(2286),
    [sym_unset_command] = STATE(2286),
    [sym_command] = STATE(2286),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(2287),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [1932] = {
    [sym_for_statement] = STATE(2288),
    [sym_while_statement] = STATE(2288),
    [sym_if_statement] = STATE(2288),
    [sym_case_statement] = STATE(2288),
    [sym_function_definition] = STATE(2288),
    [sym_subshell] = STATE(2288),
    [sym_pipeline] = STATE(2288),
    [sym_list] = STATE(2288),
    [sym_negated_command] = STATE(2288),
    [sym_test_command] = STATE(2288),
    [sym_declaration_command] = STATE(2288),
    [sym_unset_command] = STATE(2288),
    [sym_command] = STATE(2288),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(2289),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [1933] = {
    [aux_sym_concatenation_repeat1] = STATE(2273),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(5298),
    [anon_sym_esac] = ACTIONS(249),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_SEMI_SEMI] = ACTIONS(249),
    [anon_sym_LPAREN] = ACTIONS(5320),
    [anon_sym_PIPE_AMP] = ACTIONS(249),
    [anon_sym_AMP_AMP] = ACTIONS(249),
    [anon_sym_PIPE_PIPE] = ACTIONS(249),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(249),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(249),
    [anon_sym_LT_AMP] = ACTIONS(249),
    [anon_sym_GT_AMP] = ACTIONS(249),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(249),
    [anon_sym_LT_LT_LT] = ACTIONS(249),
    [sym__special_characters] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(249),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(249),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(249),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_LT_LPAREN] = ACTIONS(249),
    [anon_sym_GT_LPAREN] = ACTIONS(249),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_LF] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(249),
  },
  [1934] = {
    [anon_sym_esac] = ACTIONS(5252),
    [anon_sym_PIPE] = ACTIONS(5322),
    [anon_sym_SEMI_SEMI] = ACTIONS(5324),
    [anon_sym_PIPE_AMP] = ACTIONS(5322),
    [anon_sym_AMP_AMP] = ACTIONS(5326),
    [anon_sym_PIPE_PIPE] = ACTIONS(5326),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5328),
    [anon_sym_LF] = ACTIONS(5330),
    [anon_sym_AMP] = ACTIONS(5328),
  },
  [1935] = {
    [sym_file_redirect] = STATE(2301),
    [sym_heredoc_redirect] = STATE(2301),
    [sym_heredoc_body] = STATE(200),
    [sym_herestring_redirect] = STATE(2301),
    [sym_concatenation] = STATE(2302),
    [sym_string] = STATE(2300),
    [sym_simple_expansion] = STATE(2300),
    [sym_string_expansion] = STATE(2300),
    [sym_expansion] = STATE(2300),
    [sym_command_substitution] = STATE(2300),
    [sym_process_substitution] = STATE(2300),
    [aux_sym_while_statement_repeat1] = STATE(2301),
    [aux_sym_command_repeat2] = STATE(2302),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(5332),
    [anon_sym_esac] = ACTIONS(343),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_SEMI_SEMI] = ACTIONS(343),
    [anon_sym_PIPE_AMP] = ACTIONS(343),
    [anon_sym_AMP_AMP] = ACTIONS(343),
    [anon_sym_PIPE_PIPE] = ACTIONS(343),
    [anon_sym_EQ_TILDE] = ACTIONS(5334),
    [anon_sym_EQ_EQ] = ACTIONS(5334),
    [anon_sym_LT] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(5336),
    [anon_sym_GT_GT] = ACTIONS(5336),
    [anon_sym_AMP_GT] = ACTIONS(5336),
    [anon_sym_AMP_GT_GT] = ACTIONS(5336),
    [anon_sym_LT_AMP] = ACTIONS(5336),
    [anon_sym_GT_AMP] = ACTIONS(5336),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(5338),
    [sym__special_characters] = ACTIONS(5340),
    [anon_sym_DQUOTE] = ACTIONS(5342),
    [anon_sym_DOLLAR] = ACTIONS(4472),
    [sym_raw_string] = ACTIONS(5344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5346),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5348),
    [anon_sym_BQUOTE] = ACTIONS(5350),
    [anon_sym_LT_LPAREN] = ACTIONS(5352),
    [anon_sym_GT_LPAREN] = ACTIONS(5352),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5344),
    [anon_sym_SEMI] = ACTIONS(343),
    [anon_sym_LF] = ACTIONS(367),
    [anon_sym_AMP] = ACTIONS(343),
  },
  [1936] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_esac] = ACTIONS(5252),
    [anon_sym_PIPE] = ACTIONS(5322),
    [anon_sym_SEMI_SEMI] = ACTIONS(5324),
    [anon_sym_PIPE_AMP] = ACTIONS(5322),
    [anon_sym_AMP_AMP] = ACTIONS(5326),
    [anon_sym_PIPE_PIPE] = ACTIONS(5326),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(5328),
    [anon_sym_LF] = ACTIONS(5330),
    [anon_sym_AMP] = ACTIONS(5328),
  },
  [1937] = {
    [anon_sym_EQ] = ACTIONS(5250),
    [anon_sym_PLUS_EQ] = ACTIONS(5250),
    [sym_comment] = ACTIONS(53),
  },
  [1938] = {
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [anon_sym_esac] = ACTIONS(249),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_SEMI_SEMI] = ACTIONS(249),
    [anon_sym_PIPE_AMP] = ACTIONS(249),
    [anon_sym_AMP_AMP] = ACTIONS(249),
    [anon_sym_PIPE_PIPE] = ACTIONS(249),
    [anon_sym_EQ_TILDE] = ACTIONS(249),
    [anon_sym_EQ_EQ] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(249),
    [anon_sym_GT] = ACTIONS(249),
    [anon_sym_GT_GT] = ACTIONS(249),
    [anon_sym_AMP_GT] = ACTIONS(249),
    [anon_sym_AMP_GT_GT] = ACTIONS(249),
    [anon_sym_LT_AMP] = ACTIONS(249),
    [anon_sym_GT_AMP] = ACTIONS(249),
    [anon_sym_LT_LT] = ACTIONS(249),
    [anon_sym_LT_LT_DASH] = ACTIONS(249),
    [anon_sym_LT_LT_LT] = ACTIONS(249),
    [sym__special_characters] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(249),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [sym_raw_string] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(249),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(249),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_LT_LPAREN] = ACTIONS(249),
    [anon_sym_GT_LPAREN] = ACTIONS(249),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(249),
    [anon_sym_LF] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(249),
  },
  [1939] = {
    [sym__terminated_statement] = STATE(2306),
    [sym_for_statement] = STATE(2304),
    [sym_while_statement] = STATE(2304),
    [sym_if_statement] = STATE(2304),
    [sym_case_statement] = STATE(2304),
    [sym_function_definition] = STATE(2304),
    [sym_subshell] = STATE(2304),
    [sym_pipeline] = STATE(2304),
    [sym_list] = STATE(2304),
    [sym_negated_command] = STATE(2304),
    [sym_test_command] = STATE(2304),
    [sym_declaration_command] = STATE(2304),
    [sym_unset_command] = STATE(2304),
    [sym_command] = STATE(2304),
    [sym_command_name] = STATE(1935),
    [sym_variable_assignment] = STATE(2305),
    [sym_subscript] = STATE(1937),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1938),
    [sym_string] = STATE(1928),
    [sym_simple_expansion] = STATE(1928),
    [sym_string_expansion] = STATE(1928),
    [sym_expansion] = STATE(1928),
    [sym_command_substitution] = STATE(1928),
    [sym_process_substitution] = STATE(1928),
    [aux_sym_program_repeat1] = STATE(2306),
    [aux_sym_command_repeat1] = STATE(1940),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4448),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4450),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(5252),
    [anon_sym_SEMI_SEMI] = ACTIONS(5354),
    [anon_sym_function] = ACTIONS(4456),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4458),
    [anon_sym_LBRACK] = ACTIONS(4460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4462),
    [anon_sym_declare] = ACTIONS(4464),
    [anon_sym_typeset] = ACTIONS(4464),
    [anon_sym_export] = ACTIONS(4464),
    [anon_sym_readonly] = ACTIONS(4464),
    [anon_sym_local] = ACTIONS(4464),
    [anon_sym_unset] = ACTIONS(4466),
    [anon_sym_unsetenv] = ACTIONS(4466),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4468),
    [anon_sym_DQUOTE] = ACTIONS(4470),
    [anon_sym_DOLLAR] = ACTIONS(4472),
    [sym_raw_string] = ACTIONS(4474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4478),
    [anon_sym_BQUOTE] = ACTIONS(4480),
    [anon_sym_LT_LPAREN] = ACTIONS(4482),
    [anon_sym_GT_LPAREN] = ACTIONS(4482),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4484),
  },
  [1940] = {
    [sym_command_name] = STATE(2307),
    [sym_variable_assignment] = STATE(30),
    [sym_subscript] = STATE(71),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1938),
    [sym_string] = STATE(1928),
    [sym_simple_expansion] = STATE(1928),
    [sym_string_expansion] = STATE(1928),
    [sym_expansion] = STATE(1928),
    [sym_command_substitution] = STATE(1928),
    [sym_process_substitution] = STATE(1928),
    [aux_sym_command_repeat1] = STATE(205),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(107),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(5356),
    [anon_sym_DQUOTE] = ACTIONS(4470),
    [anon_sym_DOLLAR] = ACTIONS(4472),
    [sym_raw_string] = ACTIONS(4474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4478),
    [anon_sym_BQUOTE] = ACTIONS(4480),
    [anon_sym_LT_LPAREN] = ACTIONS(4482),
    [anon_sym_GT_LPAREN] = ACTIONS(4482),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4474),
  },
  [1941] = {
    [sym__terminated_statement] = STATE(2308),
    [sym_for_statement] = STATE(2304),
    [sym_while_statement] = STATE(2304),
    [sym_if_statement] = STATE(2304),
    [sym_case_statement] = STATE(2304),
    [sym_function_definition] = STATE(2304),
    [sym_subshell] = STATE(2304),
    [sym_pipeline] = STATE(2304),
    [sym_list] = STATE(2304),
    [sym_negated_command] = STATE(2304),
    [sym_test_command] = STATE(2304),
    [sym_declaration_command] = STATE(2304),
    [sym_unset_command] = STATE(2304),
    [sym_command] = STATE(2304),
    [sym_command_name] = STATE(1935),
    [sym_variable_assignment] = STATE(2305),
    [sym_subscript] = STATE(1937),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1938),
    [sym_string] = STATE(1928),
    [sym_simple_expansion] = STATE(1928),
    [sym_string_expansion] = STATE(1928),
    [sym_expansion] = STATE(1928),
    [sym_command_substitution] = STATE(1928),
    [sym_process_substitution] = STATE(1928),
    [aux_sym_program_repeat1] = STATE(2308),
    [aux_sym_command_repeat1] = STATE(1940),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4448),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4450),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(5252),
    [anon_sym_SEMI_SEMI] = ACTIONS(5354),
    [anon_sym_function] = ACTIONS(4456),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4458),
    [anon_sym_LBRACK] = ACTIONS(4460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4462),
    [anon_sym_declare] = ACTIONS(4464),
    [anon_sym_typeset] = ACTIONS(4464),
    [anon_sym_export] = ACTIONS(4464),
    [anon_sym_readonly] = ACTIONS(4464),
    [anon_sym_local] = ACTIONS(4464),
    [anon_sym_unset] = ACTIONS(4466),
    [anon_sym_unsetenv] = ACTIONS(4466),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4468),
    [anon_sym_DQUOTE] = ACTIONS(4470),
    [anon_sym_DOLLAR] = ACTIONS(4472),
    [sym_raw_string] = ACTIONS(4474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4478),
    [anon_sym_BQUOTE] = ACTIONS(4480),
    [anon_sym_LT_LPAREN] = ACTIONS(4482),
    [anon_sym_GT_LPAREN] = ACTIONS(4482),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4484),
  },
  [1942] = {
    [aux_sym_case_item_repeat1] = STATE(1942),
    [anon_sym_PIPE] = ACTIONS(5358),
    [anon_sym_RPAREN] = ACTIONS(5248),
    [sym_comment] = ACTIONS(53),
  },
  [1943] = {
    [aux_sym_concatenation_repeat1] = STATE(1943),
    [sym__concat] = ACTIONS(2524),
    [anon_sym_PIPE] = ACTIONS(1654),
    [anon_sym_RPAREN] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
  },
  [1944] = {
    [anon_sym_esac] = ACTIONS(5361),
    [sym__special_characters] = ACTIONS(5363),
    [anon_sym_DQUOTE] = ACTIONS(5363),
    [anon_sym_DOLLAR] = ACTIONS(5365),
    [sym_raw_string] = ACTIONS(5363),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5363),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5363),
    [anon_sym_BQUOTE] = ACTIONS(5363),
    [anon_sym_LT_LPAREN] = ACTIONS(5363),
    [anon_sym_GT_LPAREN] = ACTIONS(5363),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5365),
  },
  [1945] = {
    [anon_sym_esac] = ACTIONS(5361),
    [anon_sym_PIPE] = ACTIONS(5322),
    [anon_sym_SEMI_SEMI] = ACTIONS(5367),
    [anon_sym_PIPE_AMP] = ACTIONS(5322),
    [anon_sym_AMP_AMP] = ACTIONS(5326),
    [anon_sym_PIPE_PIPE] = ACTIONS(5326),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5328),
    [anon_sym_LF] = ACTIONS(5330),
    [anon_sym_AMP] = ACTIONS(5328),
  },
  [1946] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_esac] = ACTIONS(5361),
    [anon_sym_PIPE] = ACTIONS(5322),
    [anon_sym_SEMI_SEMI] = ACTIONS(5367),
    [anon_sym_PIPE_AMP] = ACTIONS(5322),
    [anon_sym_AMP_AMP] = ACTIONS(5326),
    [anon_sym_PIPE_PIPE] = ACTIONS(5326),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(5328),
    [anon_sym_LF] = ACTIONS(5330),
    [anon_sym_AMP] = ACTIONS(5328),
  },
  [1947] = {
    [sym__terminated_statement] = STATE(2306),
    [sym_for_statement] = STATE(2311),
    [sym_while_statement] = STATE(2311),
    [sym_if_statement] = STATE(2311),
    [sym_case_statement] = STATE(2311),
    [sym_function_definition] = STATE(2311),
    [sym_subshell] = STATE(2311),
    [sym_pipeline] = STATE(2311),
    [sym_list] = STATE(2311),
    [sym_negated_command] = STATE(2311),
    [sym_test_command] = STATE(2311),
    [sym_declaration_command] = STATE(2311),
    [sym_unset_command] = STATE(2311),
    [sym_command] = STATE(2311),
    [sym_command_name] = STATE(1935),
    [sym_variable_assignment] = STATE(2312),
    [sym_subscript] = STATE(1937),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1938),
    [sym_string] = STATE(1928),
    [sym_simple_expansion] = STATE(1928),
    [sym_string_expansion] = STATE(1928),
    [sym_expansion] = STATE(1928),
    [sym_command_substitution] = STATE(1928),
    [sym_process_substitution] = STATE(1928),
    [aux_sym_program_repeat1] = STATE(2306),
    [aux_sym_command_repeat1] = STATE(1940),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4448),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4450),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(5361),
    [anon_sym_SEMI_SEMI] = ACTIONS(5369),
    [anon_sym_function] = ACTIONS(4456),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4458),
    [anon_sym_LBRACK] = ACTIONS(4460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4462),
    [anon_sym_declare] = ACTIONS(4464),
    [anon_sym_typeset] = ACTIONS(4464),
    [anon_sym_export] = ACTIONS(4464),
    [anon_sym_readonly] = ACTIONS(4464),
    [anon_sym_local] = ACTIONS(4464),
    [anon_sym_unset] = ACTIONS(4466),
    [anon_sym_unsetenv] = ACTIONS(4466),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4468),
    [anon_sym_DQUOTE] = ACTIONS(4470),
    [anon_sym_DOLLAR] = ACTIONS(4472),
    [sym_raw_string] = ACTIONS(4474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4478),
    [anon_sym_BQUOTE] = ACTIONS(4480),
    [anon_sym_LT_LPAREN] = ACTIONS(4482),
    [anon_sym_GT_LPAREN] = ACTIONS(4482),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4484),
  },
  [1948] = {
    [sym__terminated_statement] = STATE(2313),
    [sym_for_statement] = STATE(2311),
    [sym_while_statement] = STATE(2311),
    [sym_if_statement] = STATE(2311),
    [sym_case_statement] = STATE(2311),
    [sym_function_definition] = STATE(2311),
    [sym_subshell] = STATE(2311),
    [sym_pipeline] = STATE(2311),
    [sym_list] = STATE(2311),
    [sym_negated_command] = STATE(2311),
    [sym_test_command] = STATE(2311),
    [sym_declaration_command] = STATE(2311),
    [sym_unset_command] = STATE(2311),
    [sym_command] = STATE(2311),
    [sym_command_name] = STATE(1935),
    [sym_variable_assignment] = STATE(2312),
    [sym_subscript] = STATE(1937),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1938),
    [sym_string] = STATE(1928),
    [sym_simple_expansion] = STATE(1928),
    [sym_string_expansion] = STATE(1928),
    [sym_expansion] = STATE(1928),
    [sym_command_substitution] = STATE(1928),
    [sym_process_substitution] = STATE(1928),
    [aux_sym_program_repeat1] = STATE(2313),
    [aux_sym_command_repeat1] = STATE(1940),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4448),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4450),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(5361),
    [anon_sym_SEMI_SEMI] = ACTIONS(5369),
    [anon_sym_function] = ACTIONS(4456),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4458),
    [anon_sym_LBRACK] = ACTIONS(4460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4462),
    [anon_sym_declare] = ACTIONS(4464),
    [anon_sym_typeset] = ACTIONS(4464),
    [anon_sym_export] = ACTIONS(4464),
    [anon_sym_readonly] = ACTIONS(4464),
    [anon_sym_local] = ACTIONS(4464),
    [anon_sym_unset] = ACTIONS(4466),
    [anon_sym_unsetenv] = ACTIONS(4466),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4468),
    [anon_sym_DQUOTE] = ACTIONS(4470),
    [anon_sym_DOLLAR] = ACTIONS(4472),
    [sym_raw_string] = ACTIONS(4474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4478),
    [anon_sym_BQUOTE] = ACTIONS(4480),
    [anon_sym_LT_LPAREN] = ACTIONS(4482),
    [anon_sym_GT_LPAREN] = ACTIONS(4482),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4484),
  },
  [1949] = {
    [anon_sym_esac] = ACTIONS(5371),
    [anon_sym_PIPE] = ACTIONS(5371),
    [anon_sym_RPAREN] = ACTIONS(5371),
    [anon_sym_SEMI_SEMI] = ACTIONS(5371),
    [anon_sym_PIPE_AMP] = ACTIONS(5371),
    [anon_sym_AMP_AMP] = ACTIONS(5371),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5371),
    [anon_sym_LF] = ACTIONS(5373),
    [anon_sym_AMP] = ACTIONS(5371),
  },
  [1950] = {
    [aux_sym_case_item_repeat1] = STATE(2315),
    [aux_sym_concatenation_repeat1] = STATE(1517),
    [sym__concat] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(3555),
    [anon_sym_RPAREN] = ACTIONS(5375),
    [sym_comment] = ACTIONS(53),
  },
  [1951] = {
    [aux_sym_case_item_repeat1] = STATE(2317),
    [aux_sym_concatenation_repeat1] = STATE(1517),
    [sym__concat] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(3555),
    [anon_sym_RPAREN] = ACTIONS(5377),
    [sym_comment] = ACTIONS(53),
  },
  [1952] = {
    [aux_sym_case_item_repeat1] = STATE(2317),
    [anon_sym_PIPE] = ACTIONS(3555),
    [anon_sym_RPAREN] = ACTIONS(5377),
    [sym_comment] = ACTIONS(53),
  },
  [1953] = {
    [anon_sym_esac] = ACTIONS(5379),
    [sym_comment] = ACTIONS(53),
  },
  [1954] = {
    [anon_sym_esac] = ACTIONS(5381),
    [anon_sym_PIPE] = ACTIONS(5381),
    [anon_sym_RPAREN] = ACTIONS(5381),
    [anon_sym_SEMI_SEMI] = ACTIONS(5381),
    [anon_sym_PIPE_AMP] = ACTIONS(5381),
    [anon_sym_AMP_AMP] = ACTIONS(5381),
    [anon_sym_PIPE_PIPE] = ACTIONS(5381),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5381),
    [anon_sym_LF] = ACTIONS(5383),
    [anon_sym_AMP] = ACTIONS(5381),
  },
  [1955] = {
    [anon_sym_esac] = ACTIONS(5385),
    [sym_comment] = ACTIONS(53),
  },
  [1956] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_in] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [1957] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_in] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [1958] = {
    [sym__concat] = ACTIONS(4892),
    [anon_sym_in] = ACTIONS(4894),
    [anon_sym_SEMI_SEMI] = ACTIONS(4894),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4894),
    [anon_sym_LF] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4894),
  },
  [1959] = {
    [sym__concat] = ACTIONS(4896),
    [anon_sym_in] = ACTIONS(4898),
    [anon_sym_SEMI_SEMI] = ACTIONS(4898),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4898),
    [anon_sym_LF] = ACTIONS(4896),
    [anon_sym_AMP] = ACTIONS(4898),
  },
  [1960] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5387),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1961] = {
    [sym__concat] = ACTIONS(4902),
    [anon_sym_in] = ACTIONS(4904),
    [anon_sym_SEMI_SEMI] = ACTIONS(4904),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4904),
    [anon_sym_LF] = ACTIONS(4902),
    [anon_sym_AMP] = ACTIONS(4904),
  },
  [1962] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5389),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1963] = {
    [sym__concat] = ACTIONS(4908),
    [anon_sym_in] = ACTIONS(4910),
    [anon_sym_SEMI_SEMI] = ACTIONS(4910),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4910),
    [anon_sym_LF] = ACTIONS(4908),
    [anon_sym_AMP] = ACTIONS(4910),
  },
  [1964] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5391),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1965] = {
    [sym__concat] = ACTIONS(4914),
    [anon_sym_in] = ACTIONS(4916),
    [anon_sym_SEMI_SEMI] = ACTIONS(4916),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4916),
    [anon_sym_LF] = ACTIONS(4914),
    [anon_sym_AMP] = ACTIONS(4916),
  },
  [1966] = {
    [sym__concat] = ACTIONS(4918),
    [anon_sym_in] = ACTIONS(4920),
    [anon_sym_SEMI_SEMI] = ACTIONS(4920),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym_LF] = ACTIONS(4918),
    [anon_sym_AMP] = ACTIONS(4920),
  },
  [1967] = {
    [aux_sym_concatenation_repeat1] = STATE(1967),
    [sym__concat] = ACTIONS(2612),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [1968] = {
    [aux_sym_concatenation_repeat1] = STATE(1970),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [1969] = {
    [aux_sym_concatenation_repeat1] = STATE(1970),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [1970] = {
    [aux_sym_concatenation_repeat1] = STATE(2323),
    [sym__concat] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [1971] = {
    [aux_sym_concatenation_repeat1] = STATE(1973),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(3687),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [1972] = {
    [aux_sym_concatenation_repeat1] = STATE(1973),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(3687),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [1973] = {
    [aux_sym_concatenation_repeat1] = STATE(2324),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(3687),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [1974] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_AMP_AMP] = ACTIONS(4884),
    [anon_sym_PIPE_PIPE] = ACTIONS(4884),
    [anon_sym_RBRACK] = ACTIONS(4884),
    [anon_sym_EQ_TILDE] = ACTIONS(4884),
    [anon_sym_EQ_EQ] = ACTIONS(4884),
    [anon_sym_EQ] = ACTIONS(4886),
    [anon_sym_LT] = ACTIONS(4884),
    [anon_sym_GT] = ACTIONS(4884),
    [anon_sym_BANG_EQ] = ACTIONS(4884),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4884),
  },
  [1975] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4888),
    [anon_sym_PIPE_PIPE] = ACTIONS(4888),
    [anon_sym_RBRACK] = ACTIONS(4888),
    [anon_sym_EQ_TILDE] = ACTIONS(4888),
    [anon_sym_EQ_EQ] = ACTIONS(4888),
    [anon_sym_EQ] = ACTIONS(4890),
    [anon_sym_LT] = ACTIONS(4888),
    [anon_sym_GT] = ACTIONS(4888),
    [anon_sym_BANG_EQ] = ACTIONS(4888),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4888),
  },
  [1976] = {
    [sym__concat] = ACTIONS(4892),
    [anon_sym_AMP_AMP] = ACTIONS(4892),
    [anon_sym_PIPE_PIPE] = ACTIONS(4892),
    [anon_sym_RBRACK] = ACTIONS(4892),
    [anon_sym_EQ_TILDE] = ACTIONS(4892),
    [anon_sym_EQ_EQ] = ACTIONS(4892),
    [anon_sym_EQ] = ACTIONS(4894),
    [anon_sym_LT] = ACTIONS(4892),
    [anon_sym_GT] = ACTIONS(4892),
    [anon_sym_BANG_EQ] = ACTIONS(4892),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4892),
  },
  [1977] = {
    [sym__concat] = ACTIONS(4896),
    [anon_sym_AMP_AMP] = ACTIONS(4896),
    [anon_sym_PIPE_PIPE] = ACTIONS(4896),
    [anon_sym_RBRACK] = ACTIONS(4896),
    [anon_sym_EQ_TILDE] = ACTIONS(4896),
    [anon_sym_EQ_EQ] = ACTIONS(4896),
    [anon_sym_EQ] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4896),
    [anon_sym_GT] = ACTIONS(4896),
    [anon_sym_BANG_EQ] = ACTIONS(4896),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4896),
  },
  [1978] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5393),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1979] = {
    [sym__concat] = ACTIONS(4902),
    [anon_sym_AMP_AMP] = ACTIONS(4902),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_RBRACK] = ACTIONS(4902),
    [anon_sym_EQ_TILDE] = ACTIONS(4902),
    [anon_sym_EQ_EQ] = ACTIONS(4902),
    [anon_sym_EQ] = ACTIONS(4904),
    [anon_sym_LT] = ACTIONS(4902),
    [anon_sym_GT] = ACTIONS(4902),
    [anon_sym_BANG_EQ] = ACTIONS(4902),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4902),
  },
  [1980] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5395),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1981] = {
    [sym__concat] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_RBRACK] = ACTIONS(4908),
    [anon_sym_EQ_TILDE] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4908),
    [anon_sym_EQ] = ACTIONS(4910),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_BANG_EQ] = ACTIONS(4908),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4908),
  },
  [1982] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5397),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1983] = {
    [sym__concat] = ACTIONS(4914),
    [anon_sym_AMP_AMP] = ACTIONS(4914),
    [anon_sym_PIPE_PIPE] = ACTIONS(4914),
    [anon_sym_RBRACK] = ACTIONS(4914),
    [anon_sym_EQ_TILDE] = ACTIONS(4914),
    [anon_sym_EQ_EQ] = ACTIONS(4914),
    [anon_sym_EQ] = ACTIONS(4916),
    [anon_sym_LT] = ACTIONS(4914),
    [anon_sym_GT] = ACTIONS(4914),
    [anon_sym_BANG_EQ] = ACTIONS(4914),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4914),
  },
  [1984] = {
    [sym__concat] = ACTIONS(4918),
    [anon_sym_AMP_AMP] = ACTIONS(4918),
    [anon_sym_PIPE_PIPE] = ACTIONS(4918),
    [anon_sym_RBRACK] = ACTIONS(4918),
    [anon_sym_EQ_TILDE] = ACTIONS(4918),
    [anon_sym_EQ_EQ] = ACTIONS(4918),
    [anon_sym_EQ] = ACTIONS(4920),
    [anon_sym_LT] = ACTIONS(4918),
    [anon_sym_GT] = ACTIONS(4918),
    [anon_sym_BANG_EQ] = ACTIONS(4918),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4918),
  },
  [1985] = {
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(1654),
    [anon_sym_esac] = ACTIONS(1656),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1656),
    [anon_sym_LT_AMP] = ACTIONS(1656),
    [anon_sym_GT_AMP] = ACTIONS(1656),
    [anon_sym_LT_LT] = ACTIONS(1656),
    [anon_sym_LT_LT_DASH] = ACTIONS(1656),
    [anon_sym_LT_LT_LT] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [1986] = {
    [aux_sym_concatenation_repeat1] = STATE(1986),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(5399),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1656),
    [anon_sym_LT_AMP] = ACTIONS(1656),
    [anon_sym_GT_AMP] = ACTIONS(1656),
    [anon_sym_LT_LT] = ACTIONS(1656),
    [anon_sym_LT_LT_DASH] = ACTIONS(1656),
    [anon_sym_LT_LT_LT] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [1987] = {
    [sym_file_descriptor] = ACTIONS(1703),
    [sym__concat] = ACTIONS(1703),
    [anon_sym_esac] = ACTIONS(1705),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_RPAREN] = ACTIONS(1705),
    [anon_sym_SEMI_SEMI] = ACTIONS(1705),
    [anon_sym_PIPE_AMP] = ACTIONS(1705),
    [anon_sym_AMP_AMP] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1705),
    [anon_sym_GT] = ACTIONS(1705),
    [anon_sym_GT_GT] = ACTIONS(1705),
    [anon_sym_AMP_GT] = ACTIONS(1705),
    [anon_sym_AMP_GT_GT] = ACTIONS(1705),
    [anon_sym_LT_AMP] = ACTIONS(1705),
    [anon_sym_GT_AMP] = ACTIONS(1705),
    [anon_sym_LT_LT] = ACTIONS(1705),
    [anon_sym_LT_LT_DASH] = ACTIONS(1705),
    [anon_sym_LT_LT_LT] = ACTIONS(1705),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_LF] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1705),
  },
  [1988] = {
    [sym_concatenation] = STATE(2331),
    [sym_string] = STATE(2330),
    [sym_simple_expansion] = STATE(2330),
    [sym_string_expansion] = STATE(2330),
    [sym_expansion] = STATE(2330),
    [sym_command_substitution] = STATE(2330),
    [sym_process_substitution] = STATE(2330),
    [anon_sym_RBRACE] = ACTIONS(5402),
    [sym__special_characters] = ACTIONS(5404),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(5406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5406),
  },
  [1989] = {
    [sym_file_descriptor] = ACTIONS(1744),
    [sym__concat] = ACTIONS(1744),
    [anon_sym_esac] = ACTIONS(1746),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_RPAREN] = ACTIONS(1746),
    [anon_sym_SEMI_SEMI] = ACTIONS(1746),
    [anon_sym_PIPE_AMP] = ACTIONS(1746),
    [anon_sym_AMP_AMP] = ACTIONS(1746),
    [anon_sym_PIPE_PIPE] = ACTIONS(1746),
    [anon_sym_LT] = ACTIONS(1746),
    [anon_sym_GT] = ACTIONS(1746),
    [anon_sym_GT_GT] = ACTIONS(1746),
    [anon_sym_AMP_GT] = ACTIONS(1746),
    [anon_sym_AMP_GT_GT] = ACTIONS(1746),
    [anon_sym_LT_AMP] = ACTIONS(1746),
    [anon_sym_GT_AMP] = ACTIONS(1746),
    [anon_sym_LT_LT] = ACTIONS(1746),
    [anon_sym_LT_LT_DASH] = ACTIONS(1746),
    [anon_sym_LT_LT_LT] = ACTIONS(1746),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1746),
    [anon_sym_LF] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(1746),
  },
  [1990] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5408),
  },
  [1991] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5410),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1992] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(5412),
    [sym_comment] = ACTIONS(53),
  },
  [1993] = {
    [sym_concatenation] = STATE(2337),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2337),
    [anon_sym_RBRACE] = ACTIONS(5414),
    [anon_sym_EQ] = ACTIONS(5416),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5418),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5420),
    [anon_sym_COLON] = ACTIONS(5416),
    [anon_sym_COLON_QMARK] = ACTIONS(5416),
    [anon_sym_COLON_DASH] = ACTIONS(5416),
    [anon_sym_PERCENT] = ACTIONS(5416),
    [anon_sym_DASH] = ACTIONS(5416),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1994] = {
    [sym_concatenation] = STATE(2340),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2340),
    [anon_sym_RBRACE] = ACTIONS(5422),
    [anon_sym_EQ] = ACTIONS(5424),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5426),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5428),
    [anon_sym_COLON] = ACTIONS(5424),
    [anon_sym_COLON_QMARK] = ACTIONS(5424),
    [anon_sym_COLON_DASH] = ACTIONS(5424),
    [anon_sym_PERCENT] = ACTIONS(5424),
    [anon_sym_DASH] = ACTIONS(5424),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1995] = {
    [sym_concatenation] = STATE(2342),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2342),
    [anon_sym_RBRACE] = ACTIONS(5402),
    [anon_sym_EQ] = ACTIONS(5430),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5432),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5434),
    [anon_sym_COLON] = ACTIONS(5430),
    [anon_sym_COLON_QMARK] = ACTIONS(5430),
    [anon_sym_COLON_DASH] = ACTIONS(5430),
    [anon_sym_PERCENT] = ACTIONS(5430),
    [anon_sym_DASH] = ACTIONS(5430),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1996] = {
    [sym_file_descriptor] = ACTIONS(1810),
    [sym__concat] = ACTIONS(1810),
    [anon_sym_esac] = ACTIONS(1812),
    [anon_sym_PIPE] = ACTIONS(1812),
    [anon_sym_RPAREN] = ACTIONS(1812),
    [anon_sym_SEMI_SEMI] = ACTIONS(1812),
    [anon_sym_PIPE_AMP] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1812),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [anon_sym_LT] = ACTIONS(1812),
    [anon_sym_GT] = ACTIONS(1812),
    [anon_sym_GT_GT] = ACTIONS(1812),
    [anon_sym_AMP_GT] = ACTIONS(1812),
    [anon_sym_AMP_GT_GT] = ACTIONS(1812),
    [anon_sym_LT_AMP] = ACTIONS(1812),
    [anon_sym_GT_AMP] = ACTIONS(1812),
    [anon_sym_LT_LT] = ACTIONS(1812),
    [anon_sym_LT_LT_DASH] = ACTIONS(1812),
    [anon_sym_LT_LT_LT] = ACTIONS(1812),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1812),
    [anon_sym_LF] = ACTIONS(1810),
    [anon_sym_AMP] = ACTIONS(1812),
  },
  [1997] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5436),
  },
  [1998] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5438),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [1999] = {
    [sym_file_descriptor] = ACTIONS(1818),
    [sym__concat] = ACTIONS(1818),
    [anon_sym_esac] = ACTIONS(1820),
    [anon_sym_PIPE] = ACTIONS(1820),
    [anon_sym_RPAREN] = ACTIONS(1820),
    [anon_sym_SEMI_SEMI] = ACTIONS(1820),
    [anon_sym_PIPE_AMP] = ACTIONS(1820),
    [anon_sym_AMP_AMP] = ACTIONS(1820),
    [anon_sym_PIPE_PIPE] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1820),
    [anon_sym_GT] = ACTIONS(1820),
    [anon_sym_GT_GT] = ACTIONS(1820),
    [anon_sym_AMP_GT] = ACTIONS(1820),
    [anon_sym_AMP_GT_GT] = ACTIONS(1820),
    [anon_sym_LT_AMP] = ACTIONS(1820),
    [anon_sym_GT_AMP] = ACTIONS(1820),
    [anon_sym_LT_LT] = ACTIONS(1820),
    [anon_sym_LT_LT_DASH] = ACTIONS(1820),
    [anon_sym_LT_LT_LT] = ACTIONS(1820),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1820),
    [anon_sym_LF] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1820),
  },
  [2000] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5440),
  },
  [2001] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5402),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2002] = {
    [sym_file_descriptor] = ACTIONS(1952),
    [sym__concat] = ACTIONS(1952),
    [anon_sym_esac] = ACTIONS(1954),
    [anon_sym_PIPE] = ACTIONS(1954),
    [anon_sym_RPAREN] = ACTIONS(1954),
    [anon_sym_SEMI_SEMI] = ACTIONS(1954),
    [anon_sym_PIPE_AMP] = ACTIONS(1954),
    [anon_sym_AMP_AMP] = ACTIONS(1954),
    [anon_sym_PIPE_PIPE] = ACTIONS(1954),
    [anon_sym_LT] = ACTIONS(1954),
    [anon_sym_GT] = ACTIONS(1954),
    [anon_sym_GT_GT] = ACTIONS(1954),
    [anon_sym_AMP_GT] = ACTIONS(1954),
    [anon_sym_AMP_GT_GT] = ACTIONS(1954),
    [anon_sym_LT_AMP] = ACTIONS(1954),
    [anon_sym_GT_AMP] = ACTIONS(1954),
    [anon_sym_LT_LT] = ACTIONS(1954),
    [anon_sym_LT_LT_DASH] = ACTIONS(1954),
    [anon_sym_LT_LT_LT] = ACTIONS(1954),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1954),
    [anon_sym_LF] = ACTIONS(1952),
    [anon_sym_AMP] = ACTIONS(1954),
  },
  [2003] = {
    [sym_file_descriptor] = ACTIONS(2018),
    [sym__concat] = ACTIONS(2018),
    [anon_sym_esac] = ACTIONS(2020),
    [anon_sym_PIPE] = ACTIONS(2020),
    [anon_sym_RPAREN] = ACTIONS(2020),
    [anon_sym_SEMI_SEMI] = ACTIONS(2020),
    [anon_sym_PIPE_AMP] = ACTIONS(2020),
    [anon_sym_AMP_AMP] = ACTIONS(2020),
    [anon_sym_PIPE_PIPE] = ACTIONS(2020),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(2020),
    [anon_sym_GT_GT] = ACTIONS(2020),
    [anon_sym_AMP_GT] = ACTIONS(2020),
    [anon_sym_AMP_GT_GT] = ACTIONS(2020),
    [anon_sym_LT_AMP] = ACTIONS(2020),
    [anon_sym_GT_AMP] = ACTIONS(2020),
    [anon_sym_LT_LT] = ACTIONS(2020),
    [anon_sym_LT_LT_DASH] = ACTIONS(2020),
    [anon_sym_LT_LT_LT] = ACTIONS(2020),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2020),
    [anon_sym_LF] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2020),
  },
  [2004] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_RPAREN] = ACTIONS(4884),
    [anon_sym_AMP_AMP] = ACTIONS(4884),
    [anon_sym_PIPE_PIPE] = ACTIONS(4884),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4884),
    [anon_sym_EQ_TILDE] = ACTIONS(4884),
    [anon_sym_EQ_EQ] = ACTIONS(4884),
    [anon_sym_EQ] = ACTIONS(4886),
    [anon_sym_LT] = ACTIONS(4884),
    [anon_sym_GT] = ACTIONS(4884),
    [anon_sym_BANG_EQ] = ACTIONS(4884),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4884),
  },
  [2005] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_RPAREN] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4888),
    [anon_sym_PIPE_PIPE] = ACTIONS(4888),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4888),
    [anon_sym_EQ_TILDE] = ACTIONS(4888),
    [anon_sym_EQ_EQ] = ACTIONS(4888),
    [anon_sym_EQ] = ACTIONS(4890),
    [anon_sym_LT] = ACTIONS(4888),
    [anon_sym_GT] = ACTIONS(4888),
    [anon_sym_BANG_EQ] = ACTIONS(4888),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4888),
  },
  [2006] = {
    [sym__concat] = ACTIONS(4892),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_RPAREN] = ACTIONS(4892),
    [anon_sym_AMP_AMP] = ACTIONS(4892),
    [anon_sym_PIPE_PIPE] = ACTIONS(4892),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4892),
    [anon_sym_EQ_TILDE] = ACTIONS(4892),
    [anon_sym_EQ_EQ] = ACTIONS(4892),
    [anon_sym_EQ] = ACTIONS(4894),
    [anon_sym_LT] = ACTIONS(4892),
    [anon_sym_GT] = ACTIONS(4892),
    [anon_sym_BANG_EQ] = ACTIONS(4892),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4892),
  },
  [2007] = {
    [sym__concat] = ACTIONS(4896),
    [anon_sym_PIPE] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(4896),
    [anon_sym_AMP_AMP] = ACTIONS(4896),
    [anon_sym_PIPE_PIPE] = ACTIONS(4896),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4896),
    [anon_sym_EQ_TILDE] = ACTIONS(4896),
    [anon_sym_EQ_EQ] = ACTIONS(4896),
    [anon_sym_EQ] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4896),
    [anon_sym_GT] = ACTIONS(4896),
    [anon_sym_BANG_EQ] = ACTIONS(4896),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4896),
  },
  [2008] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5442),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2009] = {
    [sym__concat] = ACTIONS(4902),
    [anon_sym_PIPE] = ACTIONS(4904),
    [anon_sym_RPAREN] = ACTIONS(4902),
    [anon_sym_AMP_AMP] = ACTIONS(4902),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4902),
    [anon_sym_EQ_TILDE] = ACTIONS(4902),
    [anon_sym_EQ_EQ] = ACTIONS(4902),
    [anon_sym_EQ] = ACTIONS(4904),
    [anon_sym_LT] = ACTIONS(4902),
    [anon_sym_GT] = ACTIONS(4902),
    [anon_sym_BANG_EQ] = ACTIONS(4902),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4902),
  },
  [2010] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5444),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2011] = {
    [sym__concat] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_RPAREN] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4908),
    [anon_sym_EQ_TILDE] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4908),
    [anon_sym_EQ] = ACTIONS(4910),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_BANG_EQ] = ACTIONS(4908),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4908),
  },
  [2012] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5446),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2013] = {
    [sym__concat] = ACTIONS(4914),
    [anon_sym_PIPE] = ACTIONS(4916),
    [anon_sym_RPAREN] = ACTIONS(4914),
    [anon_sym_AMP_AMP] = ACTIONS(4914),
    [anon_sym_PIPE_PIPE] = ACTIONS(4914),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4914),
    [anon_sym_EQ_TILDE] = ACTIONS(4914),
    [anon_sym_EQ_EQ] = ACTIONS(4914),
    [anon_sym_EQ] = ACTIONS(4916),
    [anon_sym_LT] = ACTIONS(4914),
    [anon_sym_GT] = ACTIONS(4914),
    [anon_sym_BANG_EQ] = ACTIONS(4914),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4914),
  },
  [2014] = {
    [sym__concat] = ACTIONS(4918),
    [anon_sym_PIPE] = ACTIONS(4920),
    [anon_sym_RPAREN] = ACTIONS(4918),
    [anon_sym_AMP_AMP] = ACTIONS(4918),
    [anon_sym_PIPE_PIPE] = ACTIONS(4918),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4918),
    [anon_sym_EQ_TILDE] = ACTIONS(4918),
    [anon_sym_EQ_EQ] = ACTIONS(4918),
    [anon_sym_EQ] = ACTIONS(4920),
    [anon_sym_LT] = ACTIONS(4918),
    [anon_sym_GT] = ACTIONS(4918),
    [anon_sym_BANG_EQ] = ACTIONS(4918),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4918),
  },
  [2015] = {
    [sym__concat] = ACTIONS(4884),
    [sym_variable_name] = ACTIONS(4884),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_RPAREN] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [anon_sym_PIPE_AMP] = ACTIONS(4886),
    [anon_sym_AMP_AMP] = ACTIONS(4886),
    [anon_sym_PIPE_PIPE] = ACTIONS(4886),
    [sym__special_characters] = ACTIONS(4886),
    [anon_sym_DQUOTE] = ACTIONS(4886),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4886),
    [anon_sym_BQUOTE] = ACTIONS(4886),
    [anon_sym_LT_LPAREN] = ACTIONS(4886),
    [anon_sym_GT_LPAREN] = ACTIONS(4886),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4886),
    [sym_word] = ACTIONS(4886),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [2016] = {
    [sym__concat] = ACTIONS(4888),
    [sym_variable_name] = ACTIONS(4888),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_RPAREN] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [anon_sym_PIPE_AMP] = ACTIONS(4890),
    [anon_sym_AMP_AMP] = ACTIONS(4890),
    [anon_sym_PIPE_PIPE] = ACTIONS(4890),
    [sym__special_characters] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4890),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4890),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_LT_LPAREN] = ACTIONS(4890),
    [anon_sym_GT_LPAREN] = ACTIONS(4890),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4890),
    [sym_word] = ACTIONS(4890),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [2017] = {
    [sym__concat] = ACTIONS(4892),
    [sym_variable_name] = ACTIONS(4892),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_RPAREN] = ACTIONS(4894),
    [anon_sym_SEMI_SEMI] = ACTIONS(4894),
    [anon_sym_PIPE_AMP] = ACTIONS(4894),
    [anon_sym_AMP_AMP] = ACTIONS(4894),
    [anon_sym_PIPE_PIPE] = ACTIONS(4894),
    [sym__special_characters] = ACTIONS(4894),
    [anon_sym_DQUOTE] = ACTIONS(4894),
    [anon_sym_DOLLAR] = ACTIONS(4894),
    [sym_raw_string] = ACTIONS(4894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4894),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4894),
    [anon_sym_GT_LPAREN] = ACTIONS(4894),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4894),
    [sym_word] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(4894),
    [anon_sym_LF] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4894),
  },
  [2018] = {
    [sym__concat] = ACTIONS(4896),
    [sym_variable_name] = ACTIONS(4896),
    [anon_sym_PIPE] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(4898),
    [anon_sym_SEMI_SEMI] = ACTIONS(4898),
    [anon_sym_PIPE_AMP] = ACTIONS(4898),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [sym__special_characters] = ACTIONS(4898),
    [anon_sym_DQUOTE] = ACTIONS(4898),
    [anon_sym_DOLLAR] = ACTIONS(4898),
    [sym_raw_string] = ACTIONS(4898),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4898),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4898),
    [anon_sym_BQUOTE] = ACTIONS(4898),
    [anon_sym_LT_LPAREN] = ACTIONS(4898),
    [anon_sym_GT_LPAREN] = ACTIONS(4898),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4898),
    [sym_word] = ACTIONS(4898),
    [anon_sym_SEMI] = ACTIONS(4898),
    [anon_sym_LF] = ACTIONS(4896),
    [anon_sym_AMP] = ACTIONS(4898),
  },
  [2019] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5448),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2020] = {
    [sym__concat] = ACTIONS(4902),
    [sym_variable_name] = ACTIONS(4902),
    [anon_sym_PIPE] = ACTIONS(4904),
    [anon_sym_RPAREN] = ACTIONS(4904),
    [anon_sym_SEMI_SEMI] = ACTIONS(4904),
    [anon_sym_PIPE_AMP] = ACTIONS(4904),
    [anon_sym_AMP_AMP] = ACTIONS(4904),
    [anon_sym_PIPE_PIPE] = ACTIONS(4904),
    [sym__special_characters] = ACTIONS(4904),
    [anon_sym_DQUOTE] = ACTIONS(4904),
    [anon_sym_DOLLAR] = ACTIONS(4904),
    [sym_raw_string] = ACTIONS(4904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4904),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4904),
    [anon_sym_BQUOTE] = ACTIONS(4904),
    [anon_sym_LT_LPAREN] = ACTIONS(4904),
    [anon_sym_GT_LPAREN] = ACTIONS(4904),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4904),
    [sym_word] = ACTIONS(4904),
    [anon_sym_SEMI] = ACTIONS(4904),
    [anon_sym_LF] = ACTIONS(4902),
    [anon_sym_AMP] = ACTIONS(4904),
  },
  [2021] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5450),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2022] = {
    [sym__concat] = ACTIONS(4908),
    [sym_variable_name] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_RPAREN] = ACTIONS(4910),
    [anon_sym_SEMI_SEMI] = ACTIONS(4910),
    [anon_sym_PIPE_AMP] = ACTIONS(4910),
    [anon_sym_AMP_AMP] = ACTIONS(4910),
    [anon_sym_PIPE_PIPE] = ACTIONS(4910),
    [sym__special_characters] = ACTIONS(4910),
    [anon_sym_DQUOTE] = ACTIONS(4910),
    [anon_sym_DOLLAR] = ACTIONS(4910),
    [sym_raw_string] = ACTIONS(4910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4910),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4910),
    [anon_sym_BQUOTE] = ACTIONS(4910),
    [anon_sym_LT_LPAREN] = ACTIONS(4910),
    [anon_sym_GT_LPAREN] = ACTIONS(4910),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4910),
    [sym_word] = ACTIONS(4910),
    [anon_sym_SEMI] = ACTIONS(4910),
    [anon_sym_LF] = ACTIONS(4908),
    [anon_sym_AMP] = ACTIONS(4910),
  },
  [2023] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2024] = {
    [sym__concat] = ACTIONS(4914),
    [sym_variable_name] = ACTIONS(4914),
    [anon_sym_PIPE] = ACTIONS(4916),
    [anon_sym_RPAREN] = ACTIONS(4916),
    [anon_sym_SEMI_SEMI] = ACTIONS(4916),
    [anon_sym_PIPE_AMP] = ACTIONS(4916),
    [anon_sym_AMP_AMP] = ACTIONS(4916),
    [anon_sym_PIPE_PIPE] = ACTIONS(4916),
    [sym__special_characters] = ACTIONS(4916),
    [anon_sym_DQUOTE] = ACTIONS(4916),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(4916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4916),
    [anon_sym_BQUOTE] = ACTIONS(4916),
    [anon_sym_LT_LPAREN] = ACTIONS(4916),
    [anon_sym_GT_LPAREN] = ACTIONS(4916),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4916),
    [sym_word] = ACTIONS(4916),
    [anon_sym_SEMI] = ACTIONS(4916),
    [anon_sym_LF] = ACTIONS(4914),
    [anon_sym_AMP] = ACTIONS(4916),
  },
  [2025] = {
    [sym__concat] = ACTIONS(4918),
    [sym_variable_name] = ACTIONS(4918),
    [anon_sym_PIPE] = ACTIONS(4920),
    [anon_sym_RPAREN] = ACTIONS(4920),
    [anon_sym_SEMI_SEMI] = ACTIONS(4920),
    [anon_sym_PIPE_AMP] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [sym__special_characters] = ACTIONS(4920),
    [anon_sym_DQUOTE] = ACTIONS(4920),
    [anon_sym_DOLLAR] = ACTIONS(4920),
    [sym_raw_string] = ACTIONS(4920),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4920),
    [anon_sym_BQUOTE] = ACTIONS(4920),
    [anon_sym_LT_LPAREN] = ACTIONS(4920),
    [anon_sym_GT_LPAREN] = ACTIONS(4920),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4920),
    [sym_word] = ACTIONS(4920),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym_LF] = ACTIONS(4918),
    [anon_sym_AMP] = ACTIONS(4920),
  },
  [2026] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_RPAREN] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [anon_sym_PIPE_AMP] = ACTIONS(4886),
    [anon_sym_AMP_AMP] = ACTIONS(4886),
    [anon_sym_PIPE_PIPE] = ACTIONS(4886),
    [sym__special_characters] = ACTIONS(4886),
    [anon_sym_DQUOTE] = ACTIONS(4886),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4886),
    [anon_sym_BQUOTE] = ACTIONS(4886),
    [anon_sym_LT_LPAREN] = ACTIONS(4886),
    [anon_sym_GT_LPAREN] = ACTIONS(4886),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4886),
    [sym_word] = ACTIONS(4886),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [2027] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_RPAREN] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [anon_sym_PIPE_AMP] = ACTIONS(4890),
    [anon_sym_AMP_AMP] = ACTIONS(4890),
    [anon_sym_PIPE_PIPE] = ACTIONS(4890),
    [sym__special_characters] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4890),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4890),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_LT_LPAREN] = ACTIONS(4890),
    [anon_sym_GT_LPAREN] = ACTIONS(4890),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4890),
    [sym_word] = ACTIONS(4890),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [2028] = {
    [sym__concat] = ACTIONS(4892),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_RPAREN] = ACTIONS(4894),
    [anon_sym_SEMI_SEMI] = ACTIONS(4894),
    [anon_sym_PIPE_AMP] = ACTIONS(4894),
    [anon_sym_AMP_AMP] = ACTIONS(4894),
    [anon_sym_PIPE_PIPE] = ACTIONS(4894),
    [sym__special_characters] = ACTIONS(4894),
    [anon_sym_DQUOTE] = ACTIONS(4894),
    [anon_sym_DOLLAR] = ACTIONS(4894),
    [sym_raw_string] = ACTIONS(4894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4894),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4894),
    [anon_sym_GT_LPAREN] = ACTIONS(4894),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4894),
    [sym_word] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(4894),
    [anon_sym_LF] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4894),
  },
  [2029] = {
    [sym__concat] = ACTIONS(4896),
    [anon_sym_PIPE] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(4898),
    [anon_sym_SEMI_SEMI] = ACTIONS(4898),
    [anon_sym_PIPE_AMP] = ACTIONS(4898),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [sym__special_characters] = ACTIONS(4898),
    [anon_sym_DQUOTE] = ACTIONS(4898),
    [anon_sym_DOLLAR] = ACTIONS(4898),
    [sym_raw_string] = ACTIONS(4898),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4898),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4898),
    [anon_sym_BQUOTE] = ACTIONS(4898),
    [anon_sym_LT_LPAREN] = ACTIONS(4898),
    [anon_sym_GT_LPAREN] = ACTIONS(4898),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4898),
    [sym_word] = ACTIONS(4898),
    [anon_sym_SEMI] = ACTIONS(4898),
    [anon_sym_LF] = ACTIONS(4896),
    [anon_sym_AMP] = ACTIONS(4898),
  },
  [2030] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2031] = {
    [sym__concat] = ACTIONS(4902),
    [anon_sym_PIPE] = ACTIONS(4904),
    [anon_sym_RPAREN] = ACTIONS(4904),
    [anon_sym_SEMI_SEMI] = ACTIONS(4904),
    [anon_sym_PIPE_AMP] = ACTIONS(4904),
    [anon_sym_AMP_AMP] = ACTIONS(4904),
    [anon_sym_PIPE_PIPE] = ACTIONS(4904),
    [sym__special_characters] = ACTIONS(4904),
    [anon_sym_DQUOTE] = ACTIONS(4904),
    [anon_sym_DOLLAR] = ACTIONS(4904),
    [sym_raw_string] = ACTIONS(4904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4904),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4904),
    [anon_sym_BQUOTE] = ACTIONS(4904),
    [anon_sym_LT_LPAREN] = ACTIONS(4904),
    [anon_sym_GT_LPAREN] = ACTIONS(4904),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4904),
    [sym_word] = ACTIONS(4904),
    [anon_sym_SEMI] = ACTIONS(4904),
    [anon_sym_LF] = ACTIONS(4902),
    [anon_sym_AMP] = ACTIONS(4904),
  },
  [2032] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5456),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2033] = {
    [sym__concat] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_RPAREN] = ACTIONS(4910),
    [anon_sym_SEMI_SEMI] = ACTIONS(4910),
    [anon_sym_PIPE_AMP] = ACTIONS(4910),
    [anon_sym_AMP_AMP] = ACTIONS(4910),
    [anon_sym_PIPE_PIPE] = ACTIONS(4910),
    [sym__special_characters] = ACTIONS(4910),
    [anon_sym_DQUOTE] = ACTIONS(4910),
    [anon_sym_DOLLAR] = ACTIONS(4910),
    [sym_raw_string] = ACTIONS(4910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4910),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4910),
    [anon_sym_BQUOTE] = ACTIONS(4910),
    [anon_sym_LT_LPAREN] = ACTIONS(4910),
    [anon_sym_GT_LPAREN] = ACTIONS(4910),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4910),
    [sym_word] = ACTIONS(4910),
    [anon_sym_SEMI] = ACTIONS(4910),
    [anon_sym_LF] = ACTIONS(4908),
    [anon_sym_AMP] = ACTIONS(4910),
  },
  [2034] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5458),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2035] = {
    [sym__concat] = ACTIONS(4914),
    [anon_sym_PIPE] = ACTIONS(4916),
    [anon_sym_RPAREN] = ACTIONS(4916),
    [anon_sym_SEMI_SEMI] = ACTIONS(4916),
    [anon_sym_PIPE_AMP] = ACTIONS(4916),
    [anon_sym_AMP_AMP] = ACTIONS(4916),
    [anon_sym_PIPE_PIPE] = ACTIONS(4916),
    [sym__special_characters] = ACTIONS(4916),
    [anon_sym_DQUOTE] = ACTIONS(4916),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(4916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4916),
    [anon_sym_BQUOTE] = ACTIONS(4916),
    [anon_sym_LT_LPAREN] = ACTIONS(4916),
    [anon_sym_GT_LPAREN] = ACTIONS(4916),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4916),
    [sym_word] = ACTIONS(4916),
    [anon_sym_SEMI] = ACTIONS(4916),
    [anon_sym_LF] = ACTIONS(4914),
    [anon_sym_AMP] = ACTIONS(4916),
  },
  [2036] = {
    [sym__concat] = ACTIONS(4918),
    [anon_sym_PIPE] = ACTIONS(4920),
    [anon_sym_RPAREN] = ACTIONS(4920),
    [anon_sym_SEMI_SEMI] = ACTIONS(4920),
    [anon_sym_PIPE_AMP] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [sym__special_characters] = ACTIONS(4920),
    [anon_sym_DQUOTE] = ACTIONS(4920),
    [anon_sym_DOLLAR] = ACTIONS(4920),
    [sym_raw_string] = ACTIONS(4920),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4920),
    [anon_sym_BQUOTE] = ACTIONS(4920),
    [anon_sym_LT_LPAREN] = ACTIONS(4920),
    [anon_sym_GT_LPAREN] = ACTIONS(4920),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4920),
    [sym_word] = ACTIONS(4920),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym_LF] = ACTIONS(4918),
    [anon_sym_AMP] = ACTIONS(4920),
  },
  [2037] = {
    [sym_file_descriptor] = ACTIONS(4884),
    [sym__concat] = ACTIONS(4884),
    [sym_variable_name] = ACTIONS(4884),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_RPAREN] = ACTIONS(4884),
    [anon_sym_PIPE_AMP] = ACTIONS(4884),
    [anon_sym_AMP_AMP] = ACTIONS(4884),
    [anon_sym_PIPE_PIPE] = ACTIONS(4884),
    [anon_sym_LT] = ACTIONS(4886),
    [anon_sym_GT] = ACTIONS(4886),
    [anon_sym_GT_GT] = ACTIONS(4884),
    [anon_sym_AMP_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT_GT] = ACTIONS(4884),
    [anon_sym_LT_AMP] = ACTIONS(4884),
    [anon_sym_GT_AMP] = ACTIONS(4884),
    [sym__special_characters] = ACTIONS(4884),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4884),
    [anon_sym_BQUOTE] = ACTIONS(4884),
    [anon_sym_LT_LPAREN] = ACTIONS(4884),
    [anon_sym_GT_LPAREN] = ACTIONS(4884),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4884),
  },
  [2038] = {
    [sym_file_descriptor] = ACTIONS(4888),
    [sym__concat] = ACTIONS(4888),
    [sym_variable_name] = ACTIONS(4888),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_RPAREN] = ACTIONS(4888),
    [anon_sym_PIPE_AMP] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4888),
    [anon_sym_PIPE_PIPE] = ACTIONS(4888),
    [anon_sym_LT] = ACTIONS(4890),
    [anon_sym_GT] = ACTIONS(4890),
    [anon_sym_GT_GT] = ACTIONS(4888),
    [anon_sym_AMP_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT_GT] = ACTIONS(4888),
    [anon_sym_LT_AMP] = ACTIONS(4888),
    [anon_sym_GT_AMP] = ACTIONS(4888),
    [sym__special_characters] = ACTIONS(4888),
    [anon_sym_DQUOTE] = ACTIONS(4888),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4888),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4888),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4888),
    [anon_sym_BQUOTE] = ACTIONS(4888),
    [anon_sym_LT_LPAREN] = ACTIONS(4888),
    [anon_sym_GT_LPAREN] = ACTIONS(4888),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4888),
  },
  [2039] = {
    [sym_file_descriptor] = ACTIONS(4892),
    [sym__concat] = ACTIONS(4892),
    [sym_variable_name] = ACTIONS(4892),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_RPAREN] = ACTIONS(4892),
    [anon_sym_PIPE_AMP] = ACTIONS(4892),
    [anon_sym_AMP_AMP] = ACTIONS(4892),
    [anon_sym_PIPE_PIPE] = ACTIONS(4892),
    [anon_sym_LT] = ACTIONS(4894),
    [anon_sym_GT] = ACTIONS(4894),
    [anon_sym_GT_GT] = ACTIONS(4892),
    [anon_sym_AMP_GT] = ACTIONS(4894),
    [anon_sym_AMP_GT_GT] = ACTIONS(4892),
    [anon_sym_LT_AMP] = ACTIONS(4892),
    [anon_sym_GT_AMP] = ACTIONS(4892),
    [sym__special_characters] = ACTIONS(4892),
    [anon_sym_DQUOTE] = ACTIONS(4892),
    [anon_sym_DOLLAR] = ACTIONS(4894),
    [sym_raw_string] = ACTIONS(4892),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4892),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4892),
    [anon_sym_BQUOTE] = ACTIONS(4892),
    [anon_sym_LT_LPAREN] = ACTIONS(4892),
    [anon_sym_GT_LPAREN] = ACTIONS(4892),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4892),
  },
  [2040] = {
    [sym_file_descriptor] = ACTIONS(4896),
    [sym__concat] = ACTIONS(4896),
    [sym_variable_name] = ACTIONS(4896),
    [anon_sym_PIPE] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(4896),
    [anon_sym_PIPE_AMP] = ACTIONS(4896),
    [anon_sym_AMP_AMP] = ACTIONS(4896),
    [anon_sym_PIPE_PIPE] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(4898),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_GT_GT] = ACTIONS(4896),
    [anon_sym_AMP_GT] = ACTIONS(4898),
    [anon_sym_AMP_GT_GT] = ACTIONS(4896),
    [anon_sym_LT_AMP] = ACTIONS(4896),
    [anon_sym_GT_AMP] = ACTIONS(4896),
    [sym__special_characters] = ACTIONS(4896),
    [anon_sym_DQUOTE] = ACTIONS(4896),
    [anon_sym_DOLLAR] = ACTIONS(4898),
    [sym_raw_string] = ACTIONS(4896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4896),
    [anon_sym_BQUOTE] = ACTIONS(4896),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4896),
  },
  [2041] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5460),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2042] = {
    [sym_file_descriptor] = ACTIONS(4902),
    [sym__concat] = ACTIONS(4902),
    [sym_variable_name] = ACTIONS(4902),
    [anon_sym_PIPE] = ACTIONS(4904),
    [anon_sym_RPAREN] = ACTIONS(4902),
    [anon_sym_PIPE_AMP] = ACTIONS(4902),
    [anon_sym_AMP_AMP] = ACTIONS(4902),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_GT] = ACTIONS(4904),
    [anon_sym_GT_GT] = ACTIONS(4902),
    [anon_sym_AMP_GT] = ACTIONS(4904),
    [anon_sym_AMP_GT_GT] = ACTIONS(4902),
    [anon_sym_LT_AMP] = ACTIONS(4902),
    [anon_sym_GT_AMP] = ACTIONS(4902),
    [sym__special_characters] = ACTIONS(4902),
    [anon_sym_DQUOTE] = ACTIONS(4902),
    [anon_sym_DOLLAR] = ACTIONS(4904),
    [sym_raw_string] = ACTIONS(4902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4902),
    [anon_sym_BQUOTE] = ACTIONS(4902),
    [anon_sym_LT_LPAREN] = ACTIONS(4902),
    [anon_sym_GT_LPAREN] = ACTIONS(4902),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4902),
  },
  [2043] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5462),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2044] = {
    [sym_file_descriptor] = ACTIONS(4908),
    [sym__concat] = ACTIONS(4908),
    [sym_variable_name] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_RPAREN] = ACTIONS(4908),
    [anon_sym_PIPE_AMP] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_LT] = ACTIONS(4910),
    [anon_sym_GT] = ACTIONS(4910),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_AMP_GT] = ACTIONS(4910),
    [anon_sym_AMP_GT_GT] = ACTIONS(4908),
    [anon_sym_LT_AMP] = ACTIONS(4908),
    [anon_sym_GT_AMP] = ACTIONS(4908),
    [sym__special_characters] = ACTIONS(4908),
    [anon_sym_DQUOTE] = ACTIONS(4908),
    [anon_sym_DOLLAR] = ACTIONS(4910),
    [sym_raw_string] = ACTIONS(4908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4908),
    [anon_sym_BQUOTE] = ACTIONS(4908),
    [anon_sym_LT_LPAREN] = ACTIONS(4908),
    [anon_sym_GT_LPAREN] = ACTIONS(4908),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4908),
  },
  [2045] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5464),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2046] = {
    [sym_file_descriptor] = ACTIONS(4914),
    [sym__concat] = ACTIONS(4914),
    [sym_variable_name] = ACTIONS(4914),
    [anon_sym_PIPE] = ACTIONS(4916),
    [anon_sym_RPAREN] = ACTIONS(4914),
    [anon_sym_PIPE_AMP] = ACTIONS(4914),
    [anon_sym_AMP_AMP] = ACTIONS(4914),
    [anon_sym_PIPE_PIPE] = ACTIONS(4914),
    [anon_sym_LT] = ACTIONS(4916),
    [anon_sym_GT] = ACTIONS(4916),
    [anon_sym_GT_GT] = ACTIONS(4914),
    [anon_sym_AMP_GT] = ACTIONS(4916),
    [anon_sym_AMP_GT_GT] = ACTIONS(4914),
    [anon_sym_LT_AMP] = ACTIONS(4914),
    [anon_sym_GT_AMP] = ACTIONS(4914),
    [sym__special_characters] = ACTIONS(4914),
    [anon_sym_DQUOTE] = ACTIONS(4914),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(4914),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4914),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4914),
    [anon_sym_BQUOTE] = ACTIONS(4914),
    [anon_sym_LT_LPAREN] = ACTIONS(4914),
    [anon_sym_GT_LPAREN] = ACTIONS(4914),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4914),
  },
  [2047] = {
    [sym_file_descriptor] = ACTIONS(4918),
    [sym__concat] = ACTIONS(4918),
    [sym_variable_name] = ACTIONS(4918),
    [anon_sym_PIPE] = ACTIONS(4920),
    [anon_sym_RPAREN] = ACTIONS(4918),
    [anon_sym_PIPE_AMP] = ACTIONS(4918),
    [anon_sym_AMP_AMP] = ACTIONS(4918),
    [anon_sym_PIPE_PIPE] = ACTIONS(4918),
    [anon_sym_LT] = ACTIONS(4920),
    [anon_sym_GT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4918),
    [anon_sym_AMP_GT] = ACTIONS(4920),
    [anon_sym_AMP_GT_GT] = ACTIONS(4918),
    [anon_sym_LT_AMP] = ACTIONS(4918),
    [anon_sym_GT_AMP] = ACTIONS(4918),
    [sym__special_characters] = ACTIONS(4918),
    [anon_sym_DQUOTE] = ACTIONS(4918),
    [anon_sym_DOLLAR] = ACTIONS(4920),
    [sym_raw_string] = ACTIONS(4918),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4918),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4918),
    [anon_sym_BQUOTE] = ACTIONS(4918),
    [anon_sym_LT_LPAREN] = ACTIONS(4918),
    [anon_sym_GT_LPAREN] = ACTIONS(4918),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4918),
  },
  [2048] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_DQUOTE] = ACTIONS(4886),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym__string_content] = ACTIONS(4884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4886),
    [anon_sym_BQUOTE] = ACTIONS(4886),
    [sym_comment] = ACTIONS(177),
  },
  [2049] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_DQUOTE] = ACTIONS(4890),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym__string_content] = ACTIONS(4888),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4890),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [sym_comment] = ACTIONS(177),
  },
  [2050] = {
    [sym__concat] = ACTIONS(4892),
    [anon_sym_DQUOTE] = ACTIONS(4894),
    [anon_sym_DOLLAR] = ACTIONS(4894),
    [sym__string_content] = ACTIONS(4892),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4894),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [sym_comment] = ACTIONS(177),
  },
  [2051] = {
    [sym__concat] = ACTIONS(4896),
    [anon_sym_DQUOTE] = ACTIONS(4898),
    [anon_sym_DOLLAR] = ACTIONS(4898),
    [sym__string_content] = ACTIONS(4896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4898),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4898),
    [anon_sym_BQUOTE] = ACTIONS(4898),
    [sym_comment] = ACTIONS(177),
  },
  [2052] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5466),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2053] = {
    [sym__concat] = ACTIONS(4902),
    [anon_sym_DQUOTE] = ACTIONS(4904),
    [anon_sym_DOLLAR] = ACTIONS(4904),
    [sym__string_content] = ACTIONS(4902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4904),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4904),
    [anon_sym_BQUOTE] = ACTIONS(4904),
    [sym_comment] = ACTIONS(177),
  },
  [2054] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5468),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2055] = {
    [sym__concat] = ACTIONS(4908),
    [anon_sym_DQUOTE] = ACTIONS(4910),
    [anon_sym_DOLLAR] = ACTIONS(4910),
    [sym__string_content] = ACTIONS(4908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4910),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4910),
    [anon_sym_BQUOTE] = ACTIONS(4910),
    [sym_comment] = ACTIONS(177),
  },
  [2056] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5470),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2057] = {
    [sym__concat] = ACTIONS(4914),
    [anon_sym_DQUOTE] = ACTIONS(4916),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym__string_content] = ACTIONS(4914),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4916),
    [anon_sym_BQUOTE] = ACTIONS(4916),
    [sym_comment] = ACTIONS(177),
  },
  [2058] = {
    [sym__concat] = ACTIONS(4918),
    [anon_sym_DQUOTE] = ACTIONS(4920),
    [anon_sym_DOLLAR] = ACTIONS(4920),
    [sym__string_content] = ACTIONS(4918),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4920),
    [anon_sym_BQUOTE] = ACTIONS(4920),
    [sym_comment] = ACTIONS(177),
  },
  [2059] = {
    [anon_sym_RBRACE] = ACTIONS(4306),
    [anon_sym_EQ] = ACTIONS(5472),
    [sym__special_characters] = ACTIONS(5472),
    [anon_sym_DQUOTE] = ACTIONS(4306),
    [anon_sym_DOLLAR] = ACTIONS(5472),
    [sym_raw_string] = ACTIONS(4306),
    [anon_sym_POUND] = ACTIONS(4306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4306),
    [aux_sym_SLASH] = ACTIONS(4306),
    [anon_sym_COLON] = ACTIONS(5472),
    [anon_sym_COLON_QMARK] = ACTIONS(5472),
    [anon_sym_COLON_DASH] = ACTIONS(5472),
    [anon_sym_PERCENT] = ACTIONS(5472),
    [anon_sym_DASH] = ACTIONS(5472),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4306),
    [anon_sym_BQUOTE] = ACTIONS(4306),
    [anon_sym_LT_LPAREN] = ACTIONS(4306),
    [anon_sym_GT_LPAREN] = ACTIONS(4306),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5472),
  },
  [2060] = {
    [anon_sym_RBRACE] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(5474),
    [sym__special_characters] = ACTIONS(5474),
    [anon_sym_DQUOTE] = ACTIONS(4308),
    [anon_sym_DOLLAR] = ACTIONS(5474),
    [sym_raw_string] = ACTIONS(4308),
    [anon_sym_POUND] = ACTIONS(4308),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4308),
    [aux_sym_SLASH] = ACTIONS(4308),
    [anon_sym_COLON] = ACTIONS(5474),
    [anon_sym_COLON_QMARK] = ACTIONS(5474),
    [anon_sym_COLON_DASH] = ACTIONS(5474),
    [anon_sym_PERCENT] = ACTIONS(5474),
    [anon_sym_DASH] = ACTIONS(5474),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4308),
    [anon_sym_BQUOTE] = ACTIONS(4308),
    [anon_sym_LT_LPAREN] = ACTIONS(4308),
    [anon_sym_GT_LPAREN] = ACTIONS(4308),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5474),
  },
  [2061] = {
    [sym__concat] = ACTIONS(2752),
    [anon_sym_RBRACE] = ACTIONS(2752),
    [sym_comment] = ACTIONS(53),
  },
  [2062] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5476),
    [sym_comment] = ACTIONS(53),
  },
  [2063] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5478),
    [sym_comment] = ACTIONS(53),
  },
  [2064] = {
    [anon_sym_RBRACE] = ACTIONS(5478),
    [sym_comment] = ACTIONS(53),
  },
  [2065] = {
    [sym_concatenation] = STATE(2364),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2364),
    [anon_sym_RBRACE] = ACTIONS(5480),
    [anon_sym_EQ] = ACTIONS(5482),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5482),
    [anon_sym_COLON_QMARK] = ACTIONS(5482),
    [anon_sym_COLON_DASH] = ACTIONS(5482),
    [anon_sym_PERCENT] = ACTIONS(5482),
    [anon_sym_DASH] = ACTIONS(5482),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2066] = {
    [sym__concat] = ACTIONS(2830),
    [anon_sym_RBRACE] = ACTIONS(2830),
    [sym_comment] = ACTIONS(53),
  },
  [2067] = {
    [sym_concatenation] = STATE(2367),
    [sym_string] = STATE(2366),
    [sym_simple_expansion] = STATE(2366),
    [sym_string_expansion] = STATE(2366),
    [sym_expansion] = STATE(2366),
    [sym_command_substitution] = STATE(2366),
    [sym_process_substitution] = STATE(2366),
    [anon_sym_RBRACE] = ACTIONS(5478),
    [sym__special_characters] = ACTIONS(5486),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(5488),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5488),
  },
  [2068] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(2873),
    [sym_comment] = ACTIONS(53),
  },
  [2069] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5490),
  },
  [2070] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5492),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2071] = {
    [sym__concat] = ACTIONS(2881),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [sym_comment] = ACTIONS(53),
  },
  [2072] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5494),
  },
  [2073] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5496),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2074] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5498),
  },
  [2075] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5478),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2076] = {
    [sym_concatenation] = STATE(2374),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2374),
    [anon_sym_RBRACE] = ACTIONS(5500),
    [anon_sym_EQ] = ACTIONS(5502),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5504),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5502),
    [anon_sym_COLON_QMARK] = ACTIONS(5502),
    [anon_sym_COLON_DASH] = ACTIONS(5502),
    [anon_sym_PERCENT] = ACTIONS(5502),
    [anon_sym_DASH] = ACTIONS(5502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2077] = {
    [sym__concat] = ACTIONS(2897),
    [anon_sym_RBRACE] = ACTIONS(2897),
    [sym_comment] = ACTIONS(53),
  },
  [2078] = {
    [sym_concatenation] = STATE(2376),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2376),
    [anon_sym_RBRACE] = ACTIONS(5506),
    [anon_sym_EQ] = ACTIONS(5508),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5508),
    [anon_sym_COLON_QMARK] = ACTIONS(5508),
    [anon_sym_COLON_DASH] = ACTIONS(5508),
    [anon_sym_PERCENT] = ACTIONS(5508),
    [anon_sym_DASH] = ACTIONS(5508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2079] = {
    [sym__concat] = ACTIONS(3917),
    [anon_sym_RBRACE] = ACTIONS(3917),
    [anon_sym_EQ] = ACTIONS(3919),
    [sym__special_characters] = ACTIONS(3919),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_DOLLAR] = ACTIONS(3919),
    [sym_raw_string] = ACTIONS(3917),
    [anon_sym_POUND] = ACTIONS(3917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3917),
    [anon_sym_COLON] = ACTIONS(3919),
    [anon_sym_COLON_QMARK] = ACTIONS(3919),
    [anon_sym_COLON_DASH] = ACTIONS(3919),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_DASH] = ACTIONS(3919),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3917),
    [anon_sym_BQUOTE] = ACTIONS(3917),
    [anon_sym_LT_LPAREN] = ACTIONS(3917),
    [anon_sym_GT_LPAREN] = ACTIONS(3917),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3919),
  },
  [2080] = {
    [sym__concat] = ACTIONS(3923),
    [anon_sym_RBRACE] = ACTIONS(3923),
    [anon_sym_EQ] = ACTIONS(3925),
    [sym__special_characters] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3923),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [sym_raw_string] = ACTIONS(3923),
    [anon_sym_POUND] = ACTIONS(3923),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3923),
    [anon_sym_COLON] = ACTIONS(3925),
    [anon_sym_COLON_QMARK] = ACTIONS(3925),
    [anon_sym_COLON_DASH] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3923),
    [anon_sym_BQUOTE] = ACTIONS(3923),
    [anon_sym_LT_LPAREN] = ACTIONS(3923),
    [anon_sym_GT_LPAREN] = ACTIONS(3923),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3925),
  },
  [2081] = {
    [sym__concat] = ACTIONS(4008),
    [anon_sym_RBRACE] = ACTIONS(4008),
    [anon_sym_EQ] = ACTIONS(4010),
    [sym__special_characters] = ACTIONS(4010),
    [anon_sym_DQUOTE] = ACTIONS(4008),
    [anon_sym_DOLLAR] = ACTIONS(4010),
    [sym_raw_string] = ACTIONS(4008),
    [anon_sym_POUND] = ACTIONS(4008),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4008),
    [anon_sym_COLON] = ACTIONS(4010),
    [anon_sym_COLON_QMARK] = ACTIONS(4010),
    [anon_sym_COLON_DASH] = ACTIONS(4010),
    [anon_sym_PERCENT] = ACTIONS(4010),
    [anon_sym_DASH] = ACTIONS(4010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4008),
    [anon_sym_BQUOTE] = ACTIONS(4008),
    [anon_sym_LT_LPAREN] = ACTIONS(4008),
    [anon_sym_GT_LPAREN] = ACTIONS(4008),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4010),
  },
  [2082] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5512),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2083] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5514),
    [sym_comment] = ACTIONS(53),
  },
  [2084] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5516),
    [sym_comment] = ACTIONS(53),
  },
  [2085] = {
    [anon_sym_RBRACE] = ACTIONS(5516),
    [sym_comment] = ACTIONS(53),
  },
  [2086] = {
    [sym_concatenation] = STATE(2381),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2381),
    [anon_sym_RBRACE] = ACTIONS(5518),
    [anon_sym_EQ] = ACTIONS(5520),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5522),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5520),
    [anon_sym_COLON_QMARK] = ACTIONS(5520),
    [anon_sym_COLON_DASH] = ACTIONS(5520),
    [anon_sym_PERCENT] = ACTIONS(5520),
    [anon_sym_DASH] = ACTIONS(5520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2087] = {
    [sym__concat] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_EQ] = ACTIONS(4026),
    [sym__special_characters] = ACTIONS(4026),
    [anon_sym_DQUOTE] = ACTIONS(4024),
    [anon_sym_DOLLAR] = ACTIONS(4026),
    [sym_raw_string] = ACTIONS(4024),
    [anon_sym_POUND] = ACTIONS(4024),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4024),
    [anon_sym_COLON] = ACTIONS(4026),
    [anon_sym_COLON_QMARK] = ACTIONS(4026),
    [anon_sym_COLON_DASH] = ACTIONS(4026),
    [anon_sym_PERCENT] = ACTIONS(4026),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4024),
    [anon_sym_BQUOTE] = ACTIONS(4024),
    [anon_sym_LT_LPAREN] = ACTIONS(4024),
    [anon_sym_GT_LPAREN] = ACTIONS(4024),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4026),
  },
  [2088] = {
    [sym_concatenation] = STATE(2383),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2383),
    [anon_sym_RBRACE] = ACTIONS(5524),
    [anon_sym_EQ] = ACTIONS(5526),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5526),
    [anon_sym_COLON_QMARK] = ACTIONS(5526),
    [anon_sym_COLON_DASH] = ACTIONS(5526),
    [anon_sym_PERCENT] = ACTIONS(5526),
    [anon_sym_DASH] = ACTIONS(5526),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2089] = {
    [sym__concat] = ACTIONS(4034),
    [anon_sym_RBRACE] = ACTIONS(4034),
    [anon_sym_EQ] = ACTIONS(4036),
    [sym__special_characters] = ACTIONS(4036),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_DOLLAR] = ACTIONS(4036),
    [sym_raw_string] = ACTIONS(4034),
    [anon_sym_POUND] = ACTIONS(4034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4034),
    [anon_sym_COLON] = ACTIONS(4036),
    [anon_sym_COLON_QMARK] = ACTIONS(4036),
    [anon_sym_COLON_DASH] = ACTIONS(4036),
    [anon_sym_PERCENT] = ACTIONS(4036),
    [anon_sym_DASH] = ACTIONS(4036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4034),
    [anon_sym_BQUOTE] = ACTIONS(4034),
    [anon_sym_LT_LPAREN] = ACTIONS(4034),
    [anon_sym_GT_LPAREN] = ACTIONS(4034),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4036),
  },
  [2090] = {
    [sym_concatenation] = STATE(2385),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2385),
    [anon_sym_RBRACE] = ACTIONS(5530),
    [anon_sym_EQ] = ACTIONS(5532),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5532),
    [anon_sym_COLON_QMARK] = ACTIONS(5532),
    [anon_sym_COLON_DASH] = ACTIONS(5532),
    [anon_sym_PERCENT] = ACTIONS(5532),
    [anon_sym_DASH] = ACTIONS(5532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2091] = {
    [sym__concat] = ACTIONS(4044),
    [anon_sym_RBRACE] = ACTIONS(4044),
    [anon_sym_EQ] = ACTIONS(4046),
    [sym__special_characters] = ACTIONS(4046),
    [anon_sym_DQUOTE] = ACTIONS(4044),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [sym_raw_string] = ACTIONS(4044),
    [anon_sym_POUND] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4044),
    [anon_sym_COLON] = ACTIONS(4046),
    [anon_sym_COLON_QMARK] = ACTIONS(4046),
    [anon_sym_COLON_DASH] = ACTIONS(4046),
    [anon_sym_PERCENT] = ACTIONS(4046),
    [anon_sym_DASH] = ACTIONS(4046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4044),
    [anon_sym_BQUOTE] = ACTIONS(4044),
    [anon_sym_LT_LPAREN] = ACTIONS(4044),
    [anon_sym_GT_LPAREN] = ACTIONS(4044),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4046),
  },
  [2092] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5536),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2093] = {
    [sym__concat] = ACTIONS(4050),
    [anon_sym_RBRACE] = ACTIONS(4050),
    [anon_sym_EQ] = ACTIONS(4052),
    [sym__special_characters] = ACTIONS(4052),
    [anon_sym_DQUOTE] = ACTIONS(4050),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [sym_raw_string] = ACTIONS(4050),
    [anon_sym_POUND] = ACTIONS(4050),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4050),
    [anon_sym_COLON] = ACTIONS(4052),
    [anon_sym_COLON_QMARK] = ACTIONS(4052),
    [anon_sym_COLON_DASH] = ACTIONS(4052),
    [anon_sym_PERCENT] = ACTIONS(4052),
    [anon_sym_DASH] = ACTIONS(4052),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4050),
    [anon_sym_BQUOTE] = ACTIONS(4050),
    [anon_sym_LT_LPAREN] = ACTIONS(4050),
    [anon_sym_GT_LPAREN] = ACTIONS(4050),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4052),
  },
  [2094] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5538),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2095] = {
    [sym__simple_heredoc_body] = ACTIONS(5540),
    [sym__heredoc_body_beginning] = ACTIONS(5540),
    [sym_file_descriptor] = ACTIONS(5540),
    [sym__concat] = ACTIONS(5540),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_RPAREN] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [anon_sym_PIPE_AMP] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE] = ACTIONS(5542),
    [anon_sym_EQ_TILDE] = ACTIONS(5542),
    [anon_sym_EQ_EQ] = ACTIONS(5542),
    [anon_sym_LT] = ACTIONS(5542),
    [anon_sym_GT] = ACTIONS(5542),
    [anon_sym_GT_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT_GT] = ACTIONS(5542),
    [anon_sym_LT_AMP] = ACTIONS(5542),
    [anon_sym_GT_AMP] = ACTIONS(5542),
    [anon_sym_LT_LT] = ACTIONS(5542),
    [anon_sym_LT_LT_DASH] = ACTIONS(5542),
    [anon_sym_LT_LT_LT] = ACTIONS(5542),
    [sym__special_characters] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [anon_sym_LT_LPAREN] = ACTIONS(5542),
    [anon_sym_GT_LPAREN] = ACTIONS(5542),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5542),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [2096] = {
    [sym__simple_heredoc_body] = ACTIONS(5544),
    [sym__heredoc_body_beginning] = ACTIONS(5544),
    [sym_file_descriptor] = ACTIONS(5544),
    [sym__concat] = ACTIONS(5544),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_RPAREN] = ACTIONS(5546),
    [anon_sym_SEMI_SEMI] = ACTIONS(5546),
    [anon_sym_PIPE_AMP] = ACTIONS(5546),
    [anon_sym_AMP_AMP] = ACTIONS(5546),
    [anon_sym_PIPE_PIPE] = ACTIONS(5546),
    [anon_sym_EQ_TILDE] = ACTIONS(5546),
    [anon_sym_EQ_EQ] = ACTIONS(5546),
    [anon_sym_LT] = ACTIONS(5546),
    [anon_sym_GT] = ACTIONS(5546),
    [anon_sym_GT_GT] = ACTIONS(5546),
    [anon_sym_AMP_GT] = ACTIONS(5546),
    [anon_sym_AMP_GT_GT] = ACTIONS(5546),
    [anon_sym_LT_AMP] = ACTIONS(5546),
    [anon_sym_GT_AMP] = ACTIONS(5546),
    [anon_sym_LT_LT] = ACTIONS(5546),
    [anon_sym_LT_LT_DASH] = ACTIONS(5546),
    [anon_sym_LT_LT_LT] = ACTIONS(5546),
    [sym__special_characters] = ACTIONS(5546),
    [anon_sym_DQUOTE] = ACTIONS(5546),
    [anon_sym_DOLLAR] = ACTIONS(5546),
    [sym_raw_string] = ACTIONS(5546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5546),
    [anon_sym_BQUOTE] = ACTIONS(5546),
    [anon_sym_LT_LPAREN] = ACTIONS(5546),
    [anon_sym_GT_LPAREN] = ACTIONS(5546),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5546),
    [anon_sym_SEMI] = ACTIONS(5546),
    [anon_sym_LF] = ACTIONS(5544),
    [anon_sym_AMP] = ACTIONS(5546),
  },
  [2097] = {
    [sym__simple_heredoc_body] = ACTIONS(5548),
    [sym__heredoc_body_beginning] = ACTIONS(5548),
    [sym_file_descriptor] = ACTIONS(5548),
    [sym__concat] = ACTIONS(5548),
    [anon_sym_PIPE] = ACTIONS(5550),
    [anon_sym_RPAREN] = ACTIONS(5550),
    [anon_sym_SEMI_SEMI] = ACTIONS(5550),
    [anon_sym_PIPE_AMP] = ACTIONS(5550),
    [anon_sym_AMP_AMP] = ACTIONS(5550),
    [anon_sym_PIPE_PIPE] = ACTIONS(5550),
    [anon_sym_EQ_TILDE] = ACTIONS(5550),
    [anon_sym_EQ_EQ] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5550),
    [anon_sym_GT] = ACTIONS(5550),
    [anon_sym_GT_GT] = ACTIONS(5550),
    [anon_sym_AMP_GT] = ACTIONS(5550),
    [anon_sym_AMP_GT_GT] = ACTIONS(5550),
    [anon_sym_LT_AMP] = ACTIONS(5550),
    [anon_sym_GT_AMP] = ACTIONS(5550),
    [anon_sym_LT_LT] = ACTIONS(5550),
    [anon_sym_LT_LT_DASH] = ACTIONS(5550),
    [anon_sym_LT_LT_LT] = ACTIONS(5550),
    [sym__special_characters] = ACTIONS(5550),
    [anon_sym_DQUOTE] = ACTIONS(5550),
    [anon_sym_DOLLAR] = ACTIONS(5550),
    [sym_raw_string] = ACTIONS(5550),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5550),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5550),
    [anon_sym_BQUOTE] = ACTIONS(5550),
    [anon_sym_LT_LPAREN] = ACTIONS(5550),
    [anon_sym_GT_LPAREN] = ACTIONS(5550),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5550),
    [anon_sym_SEMI] = ACTIONS(5550),
    [anon_sym_LF] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
  },
  [2098] = {
    [anon_sym_PIPE] = ACTIONS(4432),
    [anon_sym_RPAREN] = ACTIONS(4434),
    [anon_sym_PIPE_AMP] = ACTIONS(4434),
    [anon_sym_AMP_AMP] = ACTIONS(4434),
    [anon_sym_PIPE_PIPE] = ACTIONS(4434),
    [anon_sym_BQUOTE] = ACTIONS(4434),
    [sym_comment] = ACTIONS(53),
  },
  [2099] = {
    [anon_sym_PIPE] = ACTIONS(3524),
    [anon_sym_RPAREN] = ACTIONS(3522),
    [anon_sym_PIPE_AMP] = ACTIONS(3522),
    [anon_sym_AMP_AMP] = ACTIONS(3522),
    [anon_sym_PIPE_PIPE] = ACTIONS(3522),
    [anon_sym_BQUOTE] = ACTIONS(3522),
    [sym_comment] = ACTIONS(53),
  },
  [2100] = {
    [anon_sym_PIPE] = ACTIONS(4438),
    [anon_sym_RPAREN] = ACTIONS(4440),
    [anon_sym_PIPE_AMP] = ACTIONS(4440),
    [anon_sym_AMP_AMP] = ACTIONS(4440),
    [anon_sym_PIPE_PIPE] = ACTIONS(4440),
    [anon_sym_BQUOTE] = ACTIONS(4440),
    [sym_comment] = ACTIONS(53),
  },
  [2101] = {
    [anon_sym_fi] = ACTIONS(5552),
    [sym_comment] = ACTIONS(53),
  },
  [2102] = {
    [anon_sym_PIPE] = ACTIONS(4494),
    [anon_sym_RPAREN] = ACTIONS(4496),
    [anon_sym_PIPE_AMP] = ACTIONS(4496),
    [anon_sym_AMP_AMP] = ACTIONS(4496),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [sym_comment] = ACTIONS(53),
  },
  [2103] = {
    [anon_sym_esac] = ACTIONS(5554),
    [sym_comment] = ACTIONS(53),
  },
  [2104] = {
    [anon_sym_PIPE] = ACTIONS(4524),
    [anon_sym_RPAREN] = ACTIONS(4526),
    [anon_sym_PIPE_AMP] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_BQUOTE] = ACTIONS(4526),
    [sym_comment] = ACTIONS(53),
  },
  [2105] = {
    [sym_case_item] = STATE(1522),
    [sym_last_case_item] = STATE(2390),
    [sym_concatenation] = STATE(1079),
    [sym_string] = STATE(1077),
    [sym_simple_expansion] = STATE(1077),
    [sym_string_expansion] = STATE(1077),
    [sym_expansion] = STATE(1077),
    [sym_command_substitution] = STATE(1077),
    [sym_process_substitution] = STATE(1077),
    [aux_sym_case_statement_repeat1] = STATE(1522),
    [sym__special_characters] = ACTIONS(2299),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2301),
  },
  [2106] = {
    [anon_sym_PIPE] = ACTIONS(4528),
    [anon_sym_RPAREN] = ACTIONS(4530),
    [anon_sym_PIPE_AMP] = ACTIONS(4530),
    [anon_sym_AMP_AMP] = ACTIONS(4530),
    [anon_sym_PIPE_PIPE] = ACTIONS(4530),
    [anon_sym_BQUOTE] = ACTIONS(4530),
    [sym_comment] = ACTIONS(53),
  },
  [2107] = {
    [anon_sym_esac] = ACTIONS(5556),
    [sym_comment] = ACTIONS(53),
  },
  [2108] = {
    [anon_sym_PIPE] = ACTIONS(4534),
    [anon_sym_RPAREN] = ACTIONS(4536),
    [anon_sym_PIPE_AMP] = ACTIONS(4536),
    [anon_sym_AMP_AMP] = ACTIONS(4536),
    [anon_sym_PIPE_PIPE] = ACTIONS(4536),
    [anon_sym_BQUOTE] = ACTIONS(4536),
    [sym_comment] = ACTIONS(53),
  },
  [2109] = {
    [sym_case_item] = STATE(1522),
    [sym_last_case_item] = STATE(2392),
    [sym_concatenation] = STATE(1079),
    [sym_string] = STATE(1077),
    [sym_simple_expansion] = STATE(1077),
    [sym_string_expansion] = STATE(1077),
    [sym_expansion] = STATE(1077),
    [sym_command_substitution] = STATE(1077),
    [sym_process_substitution] = STATE(1077),
    [aux_sym_case_statement_repeat1] = STATE(1522),
    [sym__special_characters] = ACTIONS(2299),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(2301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2301),
  },
  [2110] = {
    [anon_sym_PIPE] = ACTIONS(4566),
    [anon_sym_RPAREN] = ACTIONS(4568),
    [anon_sym_PIPE_AMP] = ACTIONS(4568),
    [anon_sym_AMP_AMP] = ACTIONS(4568),
    [anon_sym_PIPE_PIPE] = ACTIONS(4568),
    [anon_sym_BQUOTE] = ACTIONS(4568),
    [sym_comment] = ACTIONS(53),
  },
  [2111] = {
    [aux_sym_concatenation_repeat1] = STATE(2114),
    [sym__concat] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [sym_comment] = ACTIONS(53),
  },
  [2112] = {
    [aux_sym_concatenation_repeat1] = STATE(2114),
    [sym__concat] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
  },
  [2113] = {
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
  },
  [2114] = {
    [aux_sym_concatenation_repeat1] = STATE(2393),
    [sym__concat] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(693),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
  },
  [2115] = {
    [aux_sym_concatenation_repeat1] = STATE(2119),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(4942),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [sym_comment] = ACTIONS(53),
  },
  [2116] = {
    [aux_sym_concatenation_repeat1] = STATE(2119),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(4942),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1093),
    [anon_sym_LT_LT_LT] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
  },
  [2117] = {
    [sym_file_descriptor] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1093),
    [anon_sym_LT_LT_LT] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
  },
  [2118] = {
    [sym_string] = STATE(2394),
    [sym_simple_expansion] = STATE(2394),
    [sym_string_expansion] = STATE(2394),
    [sym_expansion] = STATE(2394),
    [sym_command_substitution] = STATE(2394),
    [sym_process_substitution] = STATE(2394),
    [sym__special_characters] = ACTIONS(5558),
    [anon_sym_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [sym_raw_string] = ACTIONS(5558),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4104),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4106),
    [anon_sym_BQUOTE] = ACTIONS(4108),
    [anon_sym_LT_LPAREN] = ACTIONS(4110),
    [anon_sym_GT_LPAREN] = ACTIONS(4110),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5558),
  },
  [2119] = {
    [aux_sym_concatenation_repeat1] = STATE(2395),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(4942),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(693),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(693),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(693),
    [anon_sym_LT_AMP] = ACTIONS(693),
    [anon_sym_GT_AMP] = ACTIONS(693),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(693),
    [anon_sym_LT_LT_LT] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
  },
  [2120] = {
    [sym_file_descriptor] = ACTIONS(697),
    [sym__concat] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(697),
    [anon_sym_PIPE_AMP] = ACTIONS(697),
    [anon_sym_AMP_AMP] = ACTIONS(697),
    [anon_sym_PIPE_PIPE] = ACTIONS(697),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_GT_GT] = ACTIONS(697),
    [anon_sym_AMP_GT] = ACTIONS(699),
    [anon_sym_AMP_GT_GT] = ACTIONS(697),
    [anon_sym_LT_AMP] = ACTIONS(697),
    [anon_sym_GT_AMP] = ACTIONS(697),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_LT] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_comment] = ACTIONS(53),
  },
  [2121] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(5560),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [2122] = {
    [sym_file_descriptor] = ACTIONS(727),
    [sym__concat] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(727),
    [anon_sym_PIPE_AMP] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(727),
    [anon_sym_PIPE_PIPE] = ACTIONS(727),
    [anon_sym_LT] = ACTIONS(729),
    [anon_sym_GT] = ACTIONS(729),
    [anon_sym_GT_GT] = ACTIONS(727),
    [anon_sym_AMP_GT] = ACTIONS(729),
    [anon_sym_AMP_GT_GT] = ACTIONS(727),
    [anon_sym_LT_AMP] = ACTIONS(727),
    [anon_sym_GT_AMP] = ACTIONS(727),
    [anon_sym_LT_LT] = ACTIONS(729),
    [anon_sym_LT_LT_DASH] = ACTIONS(727),
    [anon_sym_LT_LT_LT] = ACTIONS(727),
    [anon_sym_BQUOTE] = ACTIONS(727),
    [sym_comment] = ACTIONS(53),
  },
  [2123] = {
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(731),
    [anon_sym_LT_LT_LT] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
  },
  [2124] = {
    [sym_file_descriptor] = ACTIONS(735),
    [sym__concat] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_PIPE_AMP] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(735),
    [anon_sym_LT_AMP] = ACTIONS(735),
    [anon_sym_GT_AMP] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_LT_LT_DASH] = ACTIONS(735),
    [anon_sym_LT_LT_LT] = ACTIONS(735),
    [anon_sym_BQUOTE] = ACTIONS(735),
    [sym_comment] = ACTIONS(53),
  },
  [2125] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(5562),
    [sym_comment] = ACTIONS(53),
  },
  [2126] = {
    [sym_concatenation] = STATE(2400),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2400),
    [anon_sym_RBRACE] = ACTIONS(5564),
    [anon_sym_EQ] = ACTIONS(5566),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5568),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5570),
    [anon_sym_COLON] = ACTIONS(5566),
    [anon_sym_COLON_QMARK] = ACTIONS(5566),
    [anon_sym_COLON_DASH] = ACTIONS(5566),
    [anon_sym_PERCENT] = ACTIONS(5566),
    [anon_sym_DASH] = ACTIONS(5566),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2127] = {
    [sym_subscript] = STATE(2404),
    [sym_variable_name] = ACTIONS(5572),
    [anon_sym_DOLLAR] = ACTIONS(5574),
    [anon_sym_DASH] = ACTIONS(5574),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5576),
    [anon_sym_STAR] = ACTIONS(5574),
    [anon_sym_AT] = ACTIONS(5574),
    [anon_sym_QMARK] = ACTIONS(5574),
    [anon_sym_0] = ACTIONS(5578),
    [anon_sym__] = ACTIONS(5578),
  },
  [2128] = {
    [sym_concatenation] = STATE(2407),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2407),
    [anon_sym_RBRACE] = ACTIONS(5580),
    [anon_sym_EQ] = ACTIONS(5582),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5584),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5586),
    [anon_sym_COLON] = ACTIONS(5582),
    [anon_sym_COLON_QMARK] = ACTIONS(5582),
    [anon_sym_COLON_DASH] = ACTIONS(5582),
    [anon_sym_PERCENT] = ACTIONS(5582),
    [anon_sym_DASH] = ACTIONS(5582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2129] = {
    [sym_concatenation] = STATE(2410),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2410),
    [anon_sym_RBRACE] = ACTIONS(5588),
    [anon_sym_EQ] = ACTIONS(5590),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5592),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5594),
    [anon_sym_COLON] = ACTIONS(5590),
    [anon_sym_COLON_QMARK] = ACTIONS(5590),
    [anon_sym_COLON_DASH] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_DASH] = ACTIONS(5590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2130] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(5596),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [2131] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(5596),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2132] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(5596),
    [sym_comment] = ACTIONS(53),
  },
  [2133] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(5596),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2134] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [2135] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2136] = {
    [sym_variable_name] = ACTIONS(3379),
    [anon_sym_PIPE] = ACTIONS(3381),
    [anon_sym_RPAREN] = ACTIONS(3379),
    [anon_sym_PIPE_AMP] = ACTIONS(3379),
    [anon_sym_AMP_AMP] = ACTIONS(3379),
    [anon_sym_PIPE_PIPE] = ACTIONS(3379),
    [sym__special_characters] = ACTIONS(3379),
    [anon_sym_DQUOTE] = ACTIONS(3379),
    [anon_sym_DOLLAR] = ACTIONS(3381),
    [sym_raw_string] = ACTIONS(3379),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3379),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3379),
    [anon_sym_BQUOTE] = ACTIONS(3379),
    [anon_sym_LT_LPAREN] = ACTIONS(3379),
    [anon_sym_GT_LPAREN] = ACTIONS(3379),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3381),
    [sym_word] = ACTIONS(3381),
  },
  [2137] = {
    [sym__concat] = ACTIONS(3917),
    [sym_variable_name] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3919),
    [anon_sym_RPAREN] = ACTIONS(3917),
    [anon_sym_PIPE_AMP] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [sym__special_characters] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_DOLLAR] = ACTIONS(3919),
    [sym_raw_string] = ACTIONS(3917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3917),
    [anon_sym_BQUOTE] = ACTIONS(3917),
    [anon_sym_LT_LPAREN] = ACTIONS(3917),
    [anon_sym_GT_LPAREN] = ACTIONS(3917),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3919),
    [sym_word] = ACTIONS(3919),
  },
  [2138] = {
    [sym__concat] = ACTIONS(3923),
    [sym_variable_name] = ACTIONS(3923),
    [anon_sym_PIPE] = ACTIONS(3925),
    [anon_sym_RPAREN] = ACTIONS(3923),
    [anon_sym_PIPE_AMP] = ACTIONS(3923),
    [anon_sym_AMP_AMP] = ACTIONS(3923),
    [anon_sym_PIPE_PIPE] = ACTIONS(3923),
    [sym__special_characters] = ACTIONS(3923),
    [anon_sym_DQUOTE] = ACTIONS(3923),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [sym_raw_string] = ACTIONS(3923),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3923),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3923),
    [anon_sym_BQUOTE] = ACTIONS(3923),
    [anon_sym_LT_LPAREN] = ACTIONS(3923),
    [anon_sym_GT_LPAREN] = ACTIONS(3923),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3925),
    [sym_word] = ACTIONS(3925),
  },
  [2139] = {
    [sym__concat] = ACTIONS(4008),
    [sym_variable_name] = ACTIONS(4008),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_RPAREN] = ACTIONS(4008),
    [anon_sym_PIPE_AMP] = ACTIONS(4008),
    [anon_sym_AMP_AMP] = ACTIONS(4008),
    [anon_sym_PIPE_PIPE] = ACTIONS(4008),
    [sym__special_characters] = ACTIONS(4008),
    [anon_sym_DQUOTE] = ACTIONS(4008),
    [anon_sym_DOLLAR] = ACTIONS(4010),
    [sym_raw_string] = ACTIONS(4008),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4008),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4008),
    [anon_sym_BQUOTE] = ACTIONS(4008),
    [anon_sym_LT_LPAREN] = ACTIONS(4008),
    [anon_sym_GT_LPAREN] = ACTIONS(4008),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4010),
    [sym_word] = ACTIONS(4010),
  },
  [2140] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5600),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2141] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5602),
    [sym_comment] = ACTIONS(53),
  },
  [2142] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5604),
    [sym_comment] = ACTIONS(53),
  },
  [2143] = {
    [anon_sym_RBRACE] = ACTIONS(5604),
    [sym_comment] = ACTIONS(53),
  },
  [2144] = {
    [sym_concatenation] = STATE(2417),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2417),
    [anon_sym_RBRACE] = ACTIONS(5606),
    [anon_sym_EQ] = ACTIONS(5608),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5610),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5608),
    [anon_sym_COLON_QMARK] = ACTIONS(5608),
    [anon_sym_COLON_DASH] = ACTIONS(5608),
    [anon_sym_PERCENT] = ACTIONS(5608),
    [anon_sym_DASH] = ACTIONS(5608),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2145] = {
    [sym__concat] = ACTIONS(4024),
    [sym_variable_name] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_PIPE_AMP] = ACTIONS(4024),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [sym__special_characters] = ACTIONS(4024),
    [anon_sym_DQUOTE] = ACTIONS(4024),
    [anon_sym_DOLLAR] = ACTIONS(4026),
    [sym_raw_string] = ACTIONS(4024),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4024),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4024),
    [anon_sym_BQUOTE] = ACTIONS(4024),
    [anon_sym_LT_LPAREN] = ACTIONS(4024),
    [anon_sym_GT_LPAREN] = ACTIONS(4024),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4026),
    [sym_word] = ACTIONS(4026),
  },
  [2146] = {
    [sym_concatenation] = STATE(2419),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2419),
    [anon_sym_RBRACE] = ACTIONS(5612),
    [anon_sym_EQ] = ACTIONS(5614),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5616),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5614),
    [anon_sym_COLON_QMARK] = ACTIONS(5614),
    [anon_sym_COLON_DASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5614),
    [anon_sym_DASH] = ACTIONS(5614),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2147] = {
    [sym__concat] = ACTIONS(4034),
    [sym_variable_name] = ACTIONS(4034),
    [anon_sym_PIPE] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4034),
    [anon_sym_PIPE_AMP] = ACTIONS(4034),
    [anon_sym_AMP_AMP] = ACTIONS(4034),
    [anon_sym_PIPE_PIPE] = ACTIONS(4034),
    [sym__special_characters] = ACTIONS(4034),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_DOLLAR] = ACTIONS(4036),
    [sym_raw_string] = ACTIONS(4034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4034),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4034),
    [anon_sym_BQUOTE] = ACTIONS(4034),
    [anon_sym_LT_LPAREN] = ACTIONS(4034),
    [anon_sym_GT_LPAREN] = ACTIONS(4034),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4036),
    [sym_word] = ACTIONS(4036),
  },
  [2148] = {
    [sym_concatenation] = STATE(2421),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2421),
    [anon_sym_RBRACE] = ACTIONS(5618),
    [anon_sym_EQ] = ACTIONS(5620),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5622),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5620),
    [anon_sym_COLON_QMARK] = ACTIONS(5620),
    [anon_sym_COLON_DASH] = ACTIONS(5620),
    [anon_sym_PERCENT] = ACTIONS(5620),
    [anon_sym_DASH] = ACTIONS(5620),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2149] = {
    [sym__concat] = ACTIONS(4044),
    [sym_variable_name] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_RPAREN] = ACTIONS(4044),
    [anon_sym_PIPE_AMP] = ACTIONS(4044),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(4044),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [sym_raw_string] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4044),
    [anon_sym_BQUOTE] = ACTIONS(4044),
    [anon_sym_LT_LPAREN] = ACTIONS(4044),
    [anon_sym_GT_LPAREN] = ACTIONS(4044),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4046),
    [sym_word] = ACTIONS(4046),
  },
  [2150] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5624),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2151] = {
    [sym__concat] = ACTIONS(4050),
    [sym_variable_name] = ACTIONS(4050),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_RPAREN] = ACTIONS(4050),
    [anon_sym_PIPE_AMP] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [sym__special_characters] = ACTIONS(4050),
    [anon_sym_DQUOTE] = ACTIONS(4050),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [sym_raw_string] = ACTIONS(4050),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4050),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4050),
    [anon_sym_BQUOTE] = ACTIONS(4050),
    [anon_sym_LT_LPAREN] = ACTIONS(4050),
    [anon_sym_GT_LPAREN] = ACTIONS(4050),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4052),
    [sym_word] = ACTIONS(4052),
  },
  [2152] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5626),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2153] = {
    [sym__concat] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3919),
    [anon_sym_RPAREN] = ACTIONS(3917),
    [anon_sym_PIPE_AMP] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [sym__special_characters] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_DOLLAR] = ACTIONS(3919),
    [sym_raw_string] = ACTIONS(3917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3917),
    [anon_sym_BQUOTE] = ACTIONS(3917),
    [anon_sym_LT_LPAREN] = ACTIONS(3917),
    [anon_sym_GT_LPAREN] = ACTIONS(3917),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3919),
    [sym_word] = ACTIONS(3919),
  },
  [2154] = {
    [sym__concat] = ACTIONS(3923),
    [anon_sym_PIPE] = ACTIONS(3925),
    [anon_sym_RPAREN] = ACTIONS(3923),
    [anon_sym_PIPE_AMP] = ACTIONS(3923),
    [anon_sym_AMP_AMP] = ACTIONS(3923),
    [anon_sym_PIPE_PIPE] = ACTIONS(3923),
    [sym__special_characters] = ACTIONS(3923),
    [anon_sym_DQUOTE] = ACTIONS(3923),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [sym_raw_string] = ACTIONS(3923),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3923),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3923),
    [anon_sym_BQUOTE] = ACTIONS(3923),
    [anon_sym_LT_LPAREN] = ACTIONS(3923),
    [anon_sym_GT_LPAREN] = ACTIONS(3923),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3925),
    [sym_word] = ACTIONS(3925),
  },
  [2155] = {
    [sym__concat] = ACTIONS(4008),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_RPAREN] = ACTIONS(4008),
    [anon_sym_PIPE_AMP] = ACTIONS(4008),
    [anon_sym_AMP_AMP] = ACTIONS(4008),
    [anon_sym_PIPE_PIPE] = ACTIONS(4008),
    [sym__special_characters] = ACTIONS(4008),
    [anon_sym_DQUOTE] = ACTIONS(4008),
    [anon_sym_DOLLAR] = ACTIONS(4010),
    [sym_raw_string] = ACTIONS(4008),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4008),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4008),
    [anon_sym_BQUOTE] = ACTIONS(4008),
    [anon_sym_LT_LPAREN] = ACTIONS(4008),
    [anon_sym_GT_LPAREN] = ACTIONS(4008),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4010),
    [sym_word] = ACTIONS(4010),
  },
  [2156] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2157] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5630),
    [sym_comment] = ACTIONS(53),
  },
  [2158] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5632),
    [sym_comment] = ACTIONS(53),
  },
  [2159] = {
    [anon_sym_RBRACE] = ACTIONS(5632),
    [sym_comment] = ACTIONS(53),
  },
  [2160] = {
    [sym_concatenation] = STATE(2428),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2428),
    [anon_sym_RBRACE] = ACTIONS(5634),
    [anon_sym_EQ] = ACTIONS(5636),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5638),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5636),
    [anon_sym_COLON_QMARK] = ACTIONS(5636),
    [anon_sym_COLON_DASH] = ACTIONS(5636),
    [anon_sym_PERCENT] = ACTIONS(5636),
    [anon_sym_DASH] = ACTIONS(5636),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2161] = {
    [sym__concat] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_PIPE_AMP] = ACTIONS(4024),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [sym__special_characters] = ACTIONS(4024),
    [anon_sym_DQUOTE] = ACTIONS(4024),
    [anon_sym_DOLLAR] = ACTIONS(4026),
    [sym_raw_string] = ACTIONS(4024),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4024),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4024),
    [anon_sym_BQUOTE] = ACTIONS(4024),
    [anon_sym_LT_LPAREN] = ACTIONS(4024),
    [anon_sym_GT_LPAREN] = ACTIONS(4024),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4026),
    [sym_word] = ACTIONS(4026),
  },
  [2162] = {
    [sym_concatenation] = STATE(2430),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2430),
    [anon_sym_RBRACE] = ACTIONS(5640),
    [anon_sym_EQ] = ACTIONS(5642),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5642),
    [anon_sym_COLON_QMARK] = ACTIONS(5642),
    [anon_sym_COLON_DASH] = ACTIONS(5642),
    [anon_sym_PERCENT] = ACTIONS(5642),
    [anon_sym_DASH] = ACTIONS(5642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2163] = {
    [sym__concat] = ACTIONS(4034),
    [anon_sym_PIPE] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4034),
    [anon_sym_PIPE_AMP] = ACTIONS(4034),
    [anon_sym_AMP_AMP] = ACTIONS(4034),
    [anon_sym_PIPE_PIPE] = ACTIONS(4034),
    [sym__special_characters] = ACTIONS(4034),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_DOLLAR] = ACTIONS(4036),
    [sym_raw_string] = ACTIONS(4034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4034),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4034),
    [anon_sym_BQUOTE] = ACTIONS(4034),
    [anon_sym_LT_LPAREN] = ACTIONS(4034),
    [anon_sym_GT_LPAREN] = ACTIONS(4034),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4036),
    [sym_word] = ACTIONS(4036),
  },
  [2164] = {
    [sym_concatenation] = STATE(2432),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2432),
    [anon_sym_RBRACE] = ACTIONS(5646),
    [anon_sym_EQ] = ACTIONS(5648),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5650),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5648),
    [anon_sym_COLON_QMARK] = ACTIONS(5648),
    [anon_sym_COLON_DASH] = ACTIONS(5648),
    [anon_sym_PERCENT] = ACTIONS(5648),
    [anon_sym_DASH] = ACTIONS(5648),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2165] = {
    [sym__concat] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_RPAREN] = ACTIONS(4044),
    [anon_sym_PIPE_AMP] = ACTIONS(4044),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(4044),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [sym_raw_string] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4044),
    [anon_sym_BQUOTE] = ACTIONS(4044),
    [anon_sym_LT_LPAREN] = ACTIONS(4044),
    [anon_sym_GT_LPAREN] = ACTIONS(4044),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4046),
    [sym_word] = ACTIONS(4046),
  },
  [2166] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5652),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2167] = {
    [sym__concat] = ACTIONS(4050),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_RPAREN] = ACTIONS(4050),
    [anon_sym_PIPE_AMP] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [sym__special_characters] = ACTIONS(4050),
    [anon_sym_DQUOTE] = ACTIONS(4050),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [sym_raw_string] = ACTIONS(4050),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4050),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4050),
    [anon_sym_BQUOTE] = ACTIONS(4050),
    [anon_sym_LT_LPAREN] = ACTIONS(4050),
    [anon_sym_GT_LPAREN] = ACTIONS(4050),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4052),
    [sym_word] = ACTIONS(4052),
  },
  [2168] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5654),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2169] = {
    [sym__simple_heredoc_body] = ACTIONS(4884),
    [sym__heredoc_body_beginning] = ACTIONS(4884),
    [sym_file_descriptor] = ACTIONS(4884),
    [sym__concat] = ACTIONS(4884),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_RPAREN] = ACTIONS(4884),
    [anon_sym_PIPE_AMP] = ACTIONS(4884),
    [anon_sym_AMP_AMP] = ACTIONS(4884),
    [anon_sym_PIPE_PIPE] = ACTIONS(4884),
    [anon_sym_EQ_TILDE] = ACTIONS(4886),
    [anon_sym_EQ_EQ] = ACTIONS(4886),
    [anon_sym_LT] = ACTIONS(4886),
    [anon_sym_GT] = ACTIONS(4886),
    [anon_sym_GT_GT] = ACTIONS(4884),
    [anon_sym_AMP_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT_GT] = ACTIONS(4884),
    [anon_sym_LT_AMP] = ACTIONS(4884),
    [anon_sym_GT_AMP] = ACTIONS(4884),
    [anon_sym_LT_LT] = ACTIONS(4886),
    [anon_sym_LT_LT_DASH] = ACTIONS(4884),
    [anon_sym_LT_LT_LT] = ACTIONS(4884),
    [sym__special_characters] = ACTIONS(4884),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4884),
    [anon_sym_BQUOTE] = ACTIONS(4884),
    [anon_sym_LT_LPAREN] = ACTIONS(4884),
    [anon_sym_GT_LPAREN] = ACTIONS(4884),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4886),
  },
  [2170] = {
    [sym__simple_heredoc_body] = ACTIONS(4888),
    [sym__heredoc_body_beginning] = ACTIONS(4888),
    [sym_file_descriptor] = ACTIONS(4888),
    [sym__concat] = ACTIONS(4888),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_RPAREN] = ACTIONS(4888),
    [anon_sym_PIPE_AMP] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4888),
    [anon_sym_PIPE_PIPE] = ACTIONS(4888),
    [anon_sym_EQ_TILDE] = ACTIONS(4890),
    [anon_sym_EQ_EQ] = ACTIONS(4890),
    [anon_sym_LT] = ACTIONS(4890),
    [anon_sym_GT] = ACTIONS(4890),
    [anon_sym_GT_GT] = ACTIONS(4888),
    [anon_sym_AMP_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT_GT] = ACTIONS(4888),
    [anon_sym_LT_AMP] = ACTIONS(4888),
    [anon_sym_GT_AMP] = ACTIONS(4888),
    [anon_sym_LT_LT] = ACTIONS(4890),
    [anon_sym_LT_LT_DASH] = ACTIONS(4888),
    [anon_sym_LT_LT_LT] = ACTIONS(4888),
    [sym__special_characters] = ACTIONS(4888),
    [anon_sym_DQUOTE] = ACTIONS(4888),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4888),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4888),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4888),
    [anon_sym_BQUOTE] = ACTIONS(4888),
    [anon_sym_LT_LPAREN] = ACTIONS(4888),
    [anon_sym_GT_LPAREN] = ACTIONS(4888),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4890),
  },
  [2171] = {
    [sym__simple_heredoc_body] = ACTIONS(4892),
    [sym__heredoc_body_beginning] = ACTIONS(4892),
    [sym_file_descriptor] = ACTIONS(4892),
    [sym__concat] = ACTIONS(4892),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_RPAREN] = ACTIONS(4892),
    [anon_sym_PIPE_AMP] = ACTIONS(4892),
    [anon_sym_AMP_AMP] = ACTIONS(4892),
    [anon_sym_PIPE_PIPE] = ACTIONS(4892),
    [anon_sym_EQ_TILDE] = ACTIONS(4894),
    [anon_sym_EQ_EQ] = ACTIONS(4894),
    [anon_sym_LT] = ACTIONS(4894),
    [anon_sym_GT] = ACTIONS(4894),
    [anon_sym_GT_GT] = ACTIONS(4892),
    [anon_sym_AMP_GT] = ACTIONS(4894),
    [anon_sym_AMP_GT_GT] = ACTIONS(4892),
    [anon_sym_LT_AMP] = ACTIONS(4892),
    [anon_sym_GT_AMP] = ACTIONS(4892),
    [anon_sym_LT_LT] = ACTIONS(4894),
    [anon_sym_LT_LT_DASH] = ACTIONS(4892),
    [anon_sym_LT_LT_LT] = ACTIONS(4892),
    [sym__special_characters] = ACTIONS(4892),
    [anon_sym_DQUOTE] = ACTIONS(4892),
    [anon_sym_DOLLAR] = ACTIONS(4894),
    [sym_raw_string] = ACTIONS(4892),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4892),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4892),
    [anon_sym_BQUOTE] = ACTIONS(4892),
    [anon_sym_LT_LPAREN] = ACTIONS(4892),
    [anon_sym_GT_LPAREN] = ACTIONS(4892),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4894),
  },
  [2172] = {
    [sym__simple_heredoc_body] = ACTIONS(4896),
    [sym__heredoc_body_beginning] = ACTIONS(4896),
    [sym_file_descriptor] = ACTIONS(4896),
    [sym__concat] = ACTIONS(4896),
    [anon_sym_PIPE] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(4896),
    [anon_sym_PIPE_AMP] = ACTIONS(4896),
    [anon_sym_AMP_AMP] = ACTIONS(4896),
    [anon_sym_PIPE_PIPE] = ACTIONS(4896),
    [anon_sym_EQ_TILDE] = ACTIONS(4898),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4898),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_GT_GT] = ACTIONS(4896),
    [anon_sym_AMP_GT] = ACTIONS(4898),
    [anon_sym_AMP_GT_GT] = ACTIONS(4896),
    [anon_sym_LT_AMP] = ACTIONS(4896),
    [anon_sym_GT_AMP] = ACTIONS(4896),
    [anon_sym_LT_LT] = ACTIONS(4898),
    [anon_sym_LT_LT_DASH] = ACTIONS(4896),
    [anon_sym_LT_LT_LT] = ACTIONS(4896),
    [sym__special_characters] = ACTIONS(4896),
    [anon_sym_DQUOTE] = ACTIONS(4896),
    [anon_sym_DOLLAR] = ACTIONS(4898),
    [sym_raw_string] = ACTIONS(4896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4896),
    [anon_sym_BQUOTE] = ACTIONS(4896),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4898),
  },
  [2173] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5656),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2174] = {
    [sym__simple_heredoc_body] = ACTIONS(4902),
    [sym__heredoc_body_beginning] = ACTIONS(4902),
    [sym_file_descriptor] = ACTIONS(4902),
    [sym__concat] = ACTIONS(4902),
    [anon_sym_PIPE] = ACTIONS(4904),
    [anon_sym_RPAREN] = ACTIONS(4902),
    [anon_sym_PIPE_AMP] = ACTIONS(4902),
    [anon_sym_AMP_AMP] = ACTIONS(4902),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_EQ_TILDE] = ACTIONS(4904),
    [anon_sym_EQ_EQ] = ACTIONS(4904),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_GT] = ACTIONS(4904),
    [anon_sym_GT_GT] = ACTIONS(4902),
    [anon_sym_AMP_GT] = ACTIONS(4904),
    [anon_sym_AMP_GT_GT] = ACTIONS(4902),
    [anon_sym_LT_AMP] = ACTIONS(4902),
    [anon_sym_GT_AMP] = ACTIONS(4902),
    [anon_sym_LT_LT] = ACTIONS(4904),
    [anon_sym_LT_LT_DASH] = ACTIONS(4902),
    [anon_sym_LT_LT_LT] = ACTIONS(4902),
    [sym__special_characters] = ACTIONS(4902),
    [anon_sym_DQUOTE] = ACTIONS(4902),
    [anon_sym_DOLLAR] = ACTIONS(4904),
    [sym_raw_string] = ACTIONS(4902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4902),
    [anon_sym_BQUOTE] = ACTIONS(4902),
    [anon_sym_LT_LPAREN] = ACTIONS(4902),
    [anon_sym_GT_LPAREN] = ACTIONS(4902),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4904),
  },
  [2175] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5658),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2176] = {
    [sym__simple_heredoc_body] = ACTIONS(4908),
    [sym__heredoc_body_beginning] = ACTIONS(4908),
    [sym_file_descriptor] = ACTIONS(4908),
    [sym__concat] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_RPAREN] = ACTIONS(4908),
    [anon_sym_PIPE_AMP] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_EQ_TILDE] = ACTIONS(4910),
    [anon_sym_EQ_EQ] = ACTIONS(4910),
    [anon_sym_LT] = ACTIONS(4910),
    [anon_sym_GT] = ACTIONS(4910),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_AMP_GT] = ACTIONS(4910),
    [anon_sym_AMP_GT_GT] = ACTIONS(4908),
    [anon_sym_LT_AMP] = ACTIONS(4908),
    [anon_sym_GT_AMP] = ACTIONS(4908),
    [anon_sym_LT_LT] = ACTIONS(4910),
    [anon_sym_LT_LT_DASH] = ACTIONS(4908),
    [anon_sym_LT_LT_LT] = ACTIONS(4908),
    [sym__special_characters] = ACTIONS(4908),
    [anon_sym_DQUOTE] = ACTIONS(4908),
    [anon_sym_DOLLAR] = ACTIONS(4910),
    [sym_raw_string] = ACTIONS(4908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4908),
    [anon_sym_BQUOTE] = ACTIONS(4908),
    [anon_sym_LT_LPAREN] = ACTIONS(4908),
    [anon_sym_GT_LPAREN] = ACTIONS(4908),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4910),
  },
  [2177] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5660),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2178] = {
    [sym__simple_heredoc_body] = ACTIONS(4914),
    [sym__heredoc_body_beginning] = ACTIONS(4914),
    [sym_file_descriptor] = ACTIONS(4914),
    [sym__concat] = ACTIONS(4914),
    [anon_sym_PIPE] = ACTIONS(4916),
    [anon_sym_RPAREN] = ACTIONS(4914),
    [anon_sym_PIPE_AMP] = ACTIONS(4914),
    [anon_sym_AMP_AMP] = ACTIONS(4914),
    [anon_sym_PIPE_PIPE] = ACTIONS(4914),
    [anon_sym_EQ_TILDE] = ACTIONS(4916),
    [anon_sym_EQ_EQ] = ACTIONS(4916),
    [anon_sym_LT] = ACTIONS(4916),
    [anon_sym_GT] = ACTIONS(4916),
    [anon_sym_GT_GT] = ACTIONS(4914),
    [anon_sym_AMP_GT] = ACTIONS(4916),
    [anon_sym_AMP_GT_GT] = ACTIONS(4914),
    [anon_sym_LT_AMP] = ACTIONS(4914),
    [anon_sym_GT_AMP] = ACTIONS(4914),
    [anon_sym_LT_LT] = ACTIONS(4916),
    [anon_sym_LT_LT_DASH] = ACTIONS(4914),
    [anon_sym_LT_LT_LT] = ACTIONS(4914),
    [sym__special_characters] = ACTIONS(4914),
    [anon_sym_DQUOTE] = ACTIONS(4914),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(4914),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4914),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4914),
    [anon_sym_BQUOTE] = ACTIONS(4914),
    [anon_sym_LT_LPAREN] = ACTIONS(4914),
    [anon_sym_GT_LPAREN] = ACTIONS(4914),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4916),
  },
  [2179] = {
    [sym__simple_heredoc_body] = ACTIONS(4918),
    [sym__heredoc_body_beginning] = ACTIONS(4918),
    [sym_file_descriptor] = ACTIONS(4918),
    [sym__concat] = ACTIONS(4918),
    [anon_sym_PIPE] = ACTIONS(4920),
    [anon_sym_RPAREN] = ACTIONS(4918),
    [anon_sym_PIPE_AMP] = ACTIONS(4918),
    [anon_sym_AMP_AMP] = ACTIONS(4918),
    [anon_sym_PIPE_PIPE] = ACTIONS(4918),
    [anon_sym_EQ_TILDE] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(4920),
    [anon_sym_LT] = ACTIONS(4920),
    [anon_sym_GT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4918),
    [anon_sym_AMP_GT] = ACTIONS(4920),
    [anon_sym_AMP_GT_GT] = ACTIONS(4918),
    [anon_sym_LT_AMP] = ACTIONS(4918),
    [anon_sym_GT_AMP] = ACTIONS(4918),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_LT_LT_DASH] = ACTIONS(4918),
    [anon_sym_LT_LT_LT] = ACTIONS(4918),
    [sym__special_characters] = ACTIONS(4918),
    [anon_sym_DQUOTE] = ACTIONS(4918),
    [anon_sym_DOLLAR] = ACTIONS(4920),
    [sym_raw_string] = ACTIONS(4918),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4918),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4918),
    [anon_sym_BQUOTE] = ACTIONS(4918),
    [anon_sym_LT_LPAREN] = ACTIONS(4918),
    [anon_sym_GT_LPAREN] = ACTIONS(4918),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4920),
  },
  [2180] = {
    [aux_sym_concatenation_repeat1] = STATE(2182),
    [sym__concat] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [sym_comment] = ACTIONS(53),
  },
  [2181] = {
    [aux_sym_concatenation_repeat1] = STATE(2182),
    [sym__concat] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
  },
  [2182] = {
    [aux_sym_concatenation_repeat1] = STATE(2438),
    [sym__concat] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
  },
  [2183] = {
    [aux_sym_concatenation_repeat1] = STATE(2185),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(4942),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [sym_comment] = ACTIONS(53),
  },
  [2184] = {
    [aux_sym_concatenation_repeat1] = STATE(2185),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(4942),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1093),
    [anon_sym_LT_LT_LT] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
  },
  [2185] = {
    [aux_sym_concatenation_repeat1] = STATE(2439),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(4942),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(693),
    [anon_sym_AMP_AMP] = ACTIONS(693),
    [anon_sym_PIPE_PIPE] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(693),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(693),
    [anon_sym_LT_AMP] = ACTIONS(693),
    [anon_sym_GT_AMP] = ACTIONS(693),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(693),
    [anon_sym_LT_LT_LT] = ACTIONS(693),
    [anon_sym_BQUOTE] = ACTIONS(693),
    [sym_comment] = ACTIONS(53),
  },
  [2186] = {
    [sym__heredoc_body_middle] = ACTIONS(3917),
    [sym__heredoc_body_end] = ACTIONS(3917),
    [anon_sym_DOLLAR] = ACTIONS(3919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3917),
    [sym_comment] = ACTIONS(53),
  },
  [2187] = {
    [sym__heredoc_body_middle] = ACTIONS(3923),
    [sym__heredoc_body_end] = ACTIONS(3923),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3923),
    [sym_comment] = ACTIONS(53),
  },
  [2188] = {
    [sym__heredoc_body_middle] = ACTIONS(4008),
    [sym__heredoc_body_end] = ACTIONS(4008),
    [anon_sym_DOLLAR] = ACTIONS(4010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4008),
    [sym_comment] = ACTIONS(53),
  },
  [2189] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5662),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2190] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5664),
    [sym_comment] = ACTIONS(53),
  },
  [2191] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5666),
    [sym_comment] = ACTIONS(53),
  },
  [2192] = {
    [anon_sym_RBRACE] = ACTIONS(5666),
    [sym_comment] = ACTIONS(53),
  },
  [2193] = {
    [sym_concatenation] = STATE(2444),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2444),
    [anon_sym_RBRACE] = ACTIONS(5668),
    [anon_sym_EQ] = ACTIONS(5670),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5672),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5670),
    [anon_sym_COLON_QMARK] = ACTIONS(5670),
    [anon_sym_COLON_DASH] = ACTIONS(5670),
    [anon_sym_PERCENT] = ACTIONS(5670),
    [anon_sym_DASH] = ACTIONS(5670),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2194] = {
    [sym__heredoc_body_middle] = ACTIONS(4024),
    [sym__heredoc_body_end] = ACTIONS(4024),
    [anon_sym_DOLLAR] = ACTIONS(4026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4024),
    [sym_comment] = ACTIONS(53),
  },
  [2195] = {
    [sym_concatenation] = STATE(2446),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2446),
    [anon_sym_RBRACE] = ACTIONS(5674),
    [anon_sym_EQ] = ACTIONS(5676),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5678),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5676),
    [anon_sym_COLON_QMARK] = ACTIONS(5676),
    [anon_sym_COLON_DASH] = ACTIONS(5676),
    [anon_sym_PERCENT] = ACTIONS(5676),
    [anon_sym_DASH] = ACTIONS(5676),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2196] = {
    [sym__heredoc_body_middle] = ACTIONS(4034),
    [sym__heredoc_body_end] = ACTIONS(4034),
    [anon_sym_DOLLAR] = ACTIONS(4036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4034),
    [sym_comment] = ACTIONS(53),
  },
  [2197] = {
    [sym_concatenation] = STATE(2448),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2448),
    [anon_sym_RBRACE] = ACTIONS(5680),
    [anon_sym_EQ] = ACTIONS(5682),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5684),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5682),
    [anon_sym_COLON_QMARK] = ACTIONS(5682),
    [anon_sym_COLON_DASH] = ACTIONS(5682),
    [anon_sym_PERCENT] = ACTIONS(5682),
    [anon_sym_DASH] = ACTIONS(5682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2198] = {
    [sym__heredoc_body_middle] = ACTIONS(4044),
    [sym__heredoc_body_end] = ACTIONS(4044),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4044),
    [sym_comment] = ACTIONS(53),
  },
  [2199] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5686),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2200] = {
    [sym__heredoc_body_middle] = ACTIONS(4050),
    [sym__heredoc_body_end] = ACTIONS(4050),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4050),
    [sym_comment] = ACTIONS(53),
  },
  [2201] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2202] = {
    [sym__concat] = ACTIONS(3917),
    [anon_sym_RPAREN] = ACTIONS(3917),
    [sym__special_characters] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_DOLLAR] = ACTIONS(3919),
    [sym_raw_string] = ACTIONS(3917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3917),
    [anon_sym_BQUOTE] = ACTIONS(3917),
    [anon_sym_LT_LPAREN] = ACTIONS(3917),
    [anon_sym_GT_LPAREN] = ACTIONS(3917),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3917),
  },
  [2203] = {
    [sym__concat] = ACTIONS(3923),
    [anon_sym_RPAREN] = ACTIONS(3923),
    [sym__special_characters] = ACTIONS(3923),
    [anon_sym_DQUOTE] = ACTIONS(3923),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [sym_raw_string] = ACTIONS(3923),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3923),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3923),
    [anon_sym_BQUOTE] = ACTIONS(3923),
    [anon_sym_LT_LPAREN] = ACTIONS(3923),
    [anon_sym_GT_LPAREN] = ACTIONS(3923),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3923),
  },
  [2204] = {
    [sym__concat] = ACTIONS(4008),
    [anon_sym_RPAREN] = ACTIONS(4008),
    [sym__special_characters] = ACTIONS(4008),
    [anon_sym_DQUOTE] = ACTIONS(4008),
    [anon_sym_DOLLAR] = ACTIONS(4010),
    [sym_raw_string] = ACTIONS(4008),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4008),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4008),
    [anon_sym_BQUOTE] = ACTIONS(4008),
    [anon_sym_LT_LPAREN] = ACTIONS(4008),
    [anon_sym_GT_LPAREN] = ACTIONS(4008),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4008),
  },
  [2205] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5690),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2206] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5692),
    [sym_comment] = ACTIONS(53),
  },
  [2207] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5694),
    [sym_comment] = ACTIONS(53),
  },
  [2208] = {
    [anon_sym_RBRACE] = ACTIONS(5694),
    [sym_comment] = ACTIONS(53),
  },
  [2209] = {
    [sym_concatenation] = STATE(2455),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2455),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_EQ] = ACTIONS(5698),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5700),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5698),
    [anon_sym_COLON_QMARK] = ACTIONS(5698),
    [anon_sym_COLON_DASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [anon_sym_DASH] = ACTIONS(5698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2210] = {
    [sym__concat] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [sym__special_characters] = ACTIONS(4024),
    [anon_sym_DQUOTE] = ACTIONS(4024),
    [anon_sym_DOLLAR] = ACTIONS(4026),
    [sym_raw_string] = ACTIONS(4024),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4024),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4024),
    [anon_sym_BQUOTE] = ACTIONS(4024),
    [anon_sym_LT_LPAREN] = ACTIONS(4024),
    [anon_sym_GT_LPAREN] = ACTIONS(4024),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4024),
  },
  [2211] = {
    [sym_concatenation] = STATE(2457),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2457),
    [anon_sym_RBRACE] = ACTIONS(5702),
    [anon_sym_EQ] = ACTIONS(5704),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5704),
    [anon_sym_COLON_QMARK] = ACTIONS(5704),
    [anon_sym_COLON_DASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5704),
    [anon_sym_DASH] = ACTIONS(5704),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2212] = {
    [sym__concat] = ACTIONS(4034),
    [anon_sym_RPAREN] = ACTIONS(4034),
    [sym__special_characters] = ACTIONS(4034),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_DOLLAR] = ACTIONS(4036),
    [sym_raw_string] = ACTIONS(4034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4034),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4034),
    [anon_sym_BQUOTE] = ACTIONS(4034),
    [anon_sym_LT_LPAREN] = ACTIONS(4034),
    [anon_sym_GT_LPAREN] = ACTIONS(4034),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4034),
  },
  [2213] = {
    [sym_concatenation] = STATE(2459),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2459),
    [anon_sym_RBRACE] = ACTIONS(5708),
    [anon_sym_EQ] = ACTIONS(5710),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5712),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5710),
    [anon_sym_COLON_QMARK] = ACTIONS(5710),
    [anon_sym_COLON_DASH] = ACTIONS(5710),
    [anon_sym_PERCENT] = ACTIONS(5710),
    [anon_sym_DASH] = ACTIONS(5710),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2214] = {
    [sym__concat] = ACTIONS(4044),
    [anon_sym_RPAREN] = ACTIONS(4044),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(4044),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [sym_raw_string] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4044),
    [anon_sym_BQUOTE] = ACTIONS(4044),
    [anon_sym_LT_LPAREN] = ACTIONS(4044),
    [anon_sym_GT_LPAREN] = ACTIONS(4044),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4044),
  },
  [2215] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5714),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2216] = {
    [sym__concat] = ACTIONS(4050),
    [anon_sym_RPAREN] = ACTIONS(4050),
    [sym__special_characters] = ACTIONS(4050),
    [anon_sym_DQUOTE] = ACTIONS(4050),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [sym_raw_string] = ACTIONS(4050),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4050),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4050),
    [anon_sym_BQUOTE] = ACTIONS(4050),
    [anon_sym_LT_LPAREN] = ACTIONS(4050),
    [anon_sym_GT_LPAREN] = ACTIONS(4050),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4050),
  },
  [2217] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5716),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2218] = {
    [sym_file_descriptor] = ACTIONS(4884),
    [sym__concat] = ACTIONS(4884),
    [sym_variable_name] = ACTIONS(4884),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_RPAREN] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [anon_sym_PIPE_AMP] = ACTIONS(4886),
    [anon_sym_AMP_AMP] = ACTIONS(4886),
    [anon_sym_PIPE_PIPE] = ACTIONS(4886),
    [anon_sym_LT] = ACTIONS(4886),
    [anon_sym_GT] = ACTIONS(4886),
    [anon_sym_GT_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT_GT] = ACTIONS(4886),
    [anon_sym_LT_AMP] = ACTIONS(4886),
    [anon_sym_GT_AMP] = ACTIONS(4886),
    [sym__special_characters] = ACTIONS(4886),
    [anon_sym_DQUOTE] = ACTIONS(4886),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4886),
    [anon_sym_BQUOTE] = ACTIONS(4886),
    [anon_sym_LT_LPAREN] = ACTIONS(4886),
    [anon_sym_GT_LPAREN] = ACTIONS(4886),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4886),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [2219] = {
    [sym_file_descriptor] = ACTIONS(4888),
    [sym__concat] = ACTIONS(4888),
    [sym_variable_name] = ACTIONS(4888),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_RPAREN] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [anon_sym_PIPE_AMP] = ACTIONS(4890),
    [anon_sym_AMP_AMP] = ACTIONS(4890),
    [anon_sym_PIPE_PIPE] = ACTIONS(4890),
    [anon_sym_LT] = ACTIONS(4890),
    [anon_sym_GT] = ACTIONS(4890),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT_GT] = ACTIONS(4890),
    [anon_sym_LT_AMP] = ACTIONS(4890),
    [anon_sym_GT_AMP] = ACTIONS(4890),
    [sym__special_characters] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4890),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4890),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_LT_LPAREN] = ACTIONS(4890),
    [anon_sym_GT_LPAREN] = ACTIONS(4890),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4890),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [2220] = {
    [sym_file_descriptor] = ACTIONS(4892),
    [sym__concat] = ACTIONS(4892),
    [sym_variable_name] = ACTIONS(4892),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_RPAREN] = ACTIONS(4894),
    [anon_sym_SEMI_SEMI] = ACTIONS(4894),
    [anon_sym_PIPE_AMP] = ACTIONS(4894),
    [anon_sym_AMP_AMP] = ACTIONS(4894),
    [anon_sym_PIPE_PIPE] = ACTIONS(4894),
    [anon_sym_LT] = ACTIONS(4894),
    [anon_sym_GT] = ACTIONS(4894),
    [anon_sym_GT_GT] = ACTIONS(4894),
    [anon_sym_AMP_GT] = ACTIONS(4894),
    [anon_sym_AMP_GT_GT] = ACTIONS(4894),
    [anon_sym_LT_AMP] = ACTIONS(4894),
    [anon_sym_GT_AMP] = ACTIONS(4894),
    [sym__special_characters] = ACTIONS(4894),
    [anon_sym_DQUOTE] = ACTIONS(4894),
    [anon_sym_DOLLAR] = ACTIONS(4894),
    [sym_raw_string] = ACTIONS(4894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4894),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4894),
    [anon_sym_GT_LPAREN] = ACTIONS(4894),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(4894),
    [anon_sym_LF] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4894),
  },
  [2221] = {
    [sym_file_descriptor] = ACTIONS(4896),
    [sym__concat] = ACTIONS(4896),
    [sym_variable_name] = ACTIONS(4896),
    [anon_sym_PIPE] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(4898),
    [anon_sym_SEMI_SEMI] = ACTIONS(4898),
    [anon_sym_PIPE_AMP] = ACTIONS(4898),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4898),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_GT_GT] = ACTIONS(4898),
    [anon_sym_AMP_GT] = ACTIONS(4898),
    [anon_sym_AMP_GT_GT] = ACTIONS(4898),
    [anon_sym_LT_AMP] = ACTIONS(4898),
    [anon_sym_GT_AMP] = ACTIONS(4898),
    [sym__special_characters] = ACTIONS(4898),
    [anon_sym_DQUOTE] = ACTIONS(4898),
    [anon_sym_DOLLAR] = ACTIONS(4898),
    [sym_raw_string] = ACTIONS(4898),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4898),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4898),
    [anon_sym_BQUOTE] = ACTIONS(4898),
    [anon_sym_LT_LPAREN] = ACTIONS(4898),
    [anon_sym_GT_LPAREN] = ACTIONS(4898),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4898),
    [anon_sym_SEMI] = ACTIONS(4898),
    [anon_sym_LF] = ACTIONS(4896),
    [anon_sym_AMP] = ACTIONS(4898),
  },
  [2222] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5718),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2223] = {
    [sym_file_descriptor] = ACTIONS(4902),
    [sym__concat] = ACTIONS(4902),
    [sym_variable_name] = ACTIONS(4902),
    [anon_sym_PIPE] = ACTIONS(4904),
    [anon_sym_RPAREN] = ACTIONS(4904),
    [anon_sym_SEMI_SEMI] = ACTIONS(4904),
    [anon_sym_PIPE_AMP] = ACTIONS(4904),
    [anon_sym_AMP_AMP] = ACTIONS(4904),
    [anon_sym_PIPE_PIPE] = ACTIONS(4904),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_GT] = ACTIONS(4904),
    [anon_sym_GT_GT] = ACTIONS(4904),
    [anon_sym_AMP_GT] = ACTIONS(4904),
    [anon_sym_AMP_GT_GT] = ACTIONS(4904),
    [anon_sym_LT_AMP] = ACTIONS(4904),
    [anon_sym_GT_AMP] = ACTIONS(4904),
    [sym__special_characters] = ACTIONS(4904),
    [anon_sym_DQUOTE] = ACTIONS(4904),
    [anon_sym_DOLLAR] = ACTIONS(4904),
    [sym_raw_string] = ACTIONS(4904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4904),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4904),
    [anon_sym_BQUOTE] = ACTIONS(4904),
    [anon_sym_LT_LPAREN] = ACTIONS(4904),
    [anon_sym_GT_LPAREN] = ACTIONS(4904),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4904),
    [anon_sym_SEMI] = ACTIONS(4904),
    [anon_sym_LF] = ACTIONS(4902),
    [anon_sym_AMP] = ACTIONS(4904),
  },
  [2224] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5720),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2225] = {
    [sym_file_descriptor] = ACTIONS(4908),
    [sym__concat] = ACTIONS(4908),
    [sym_variable_name] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_RPAREN] = ACTIONS(4910),
    [anon_sym_SEMI_SEMI] = ACTIONS(4910),
    [anon_sym_PIPE_AMP] = ACTIONS(4910),
    [anon_sym_AMP_AMP] = ACTIONS(4910),
    [anon_sym_PIPE_PIPE] = ACTIONS(4910),
    [anon_sym_LT] = ACTIONS(4910),
    [anon_sym_GT] = ACTIONS(4910),
    [anon_sym_GT_GT] = ACTIONS(4910),
    [anon_sym_AMP_GT] = ACTIONS(4910),
    [anon_sym_AMP_GT_GT] = ACTIONS(4910),
    [anon_sym_LT_AMP] = ACTIONS(4910),
    [anon_sym_GT_AMP] = ACTIONS(4910),
    [sym__special_characters] = ACTIONS(4910),
    [anon_sym_DQUOTE] = ACTIONS(4910),
    [anon_sym_DOLLAR] = ACTIONS(4910),
    [sym_raw_string] = ACTIONS(4910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4910),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4910),
    [anon_sym_BQUOTE] = ACTIONS(4910),
    [anon_sym_LT_LPAREN] = ACTIONS(4910),
    [anon_sym_GT_LPAREN] = ACTIONS(4910),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4910),
    [anon_sym_SEMI] = ACTIONS(4910),
    [anon_sym_LF] = ACTIONS(4908),
    [anon_sym_AMP] = ACTIONS(4910),
  },
  [2226] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5722),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2227] = {
    [sym_file_descriptor] = ACTIONS(4914),
    [sym__concat] = ACTIONS(4914),
    [sym_variable_name] = ACTIONS(4914),
    [anon_sym_PIPE] = ACTIONS(4916),
    [anon_sym_RPAREN] = ACTIONS(4916),
    [anon_sym_SEMI_SEMI] = ACTIONS(4916),
    [anon_sym_PIPE_AMP] = ACTIONS(4916),
    [anon_sym_AMP_AMP] = ACTIONS(4916),
    [anon_sym_PIPE_PIPE] = ACTIONS(4916),
    [anon_sym_LT] = ACTIONS(4916),
    [anon_sym_GT] = ACTIONS(4916),
    [anon_sym_GT_GT] = ACTIONS(4916),
    [anon_sym_AMP_GT] = ACTIONS(4916),
    [anon_sym_AMP_GT_GT] = ACTIONS(4916),
    [anon_sym_LT_AMP] = ACTIONS(4916),
    [anon_sym_GT_AMP] = ACTIONS(4916),
    [sym__special_characters] = ACTIONS(4916),
    [anon_sym_DQUOTE] = ACTIONS(4916),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(4916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4916),
    [anon_sym_BQUOTE] = ACTIONS(4916),
    [anon_sym_LT_LPAREN] = ACTIONS(4916),
    [anon_sym_GT_LPAREN] = ACTIONS(4916),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4916),
    [anon_sym_SEMI] = ACTIONS(4916),
    [anon_sym_LF] = ACTIONS(4914),
    [anon_sym_AMP] = ACTIONS(4916),
  },
  [2228] = {
    [sym_file_descriptor] = ACTIONS(4918),
    [sym__concat] = ACTIONS(4918),
    [sym_variable_name] = ACTIONS(4918),
    [anon_sym_PIPE] = ACTIONS(4920),
    [anon_sym_RPAREN] = ACTIONS(4920),
    [anon_sym_SEMI_SEMI] = ACTIONS(4920),
    [anon_sym_PIPE_AMP] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [anon_sym_LT] = ACTIONS(4920),
    [anon_sym_GT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_AMP_GT] = ACTIONS(4920),
    [anon_sym_AMP_GT_GT] = ACTIONS(4920),
    [anon_sym_LT_AMP] = ACTIONS(4920),
    [anon_sym_GT_AMP] = ACTIONS(4920),
    [sym__special_characters] = ACTIONS(4920),
    [anon_sym_DQUOTE] = ACTIONS(4920),
    [anon_sym_DOLLAR] = ACTIONS(4920),
    [sym_raw_string] = ACTIONS(4920),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4920),
    [anon_sym_BQUOTE] = ACTIONS(4920),
    [anon_sym_LT_LPAREN] = ACTIONS(4920),
    [anon_sym_GT_LPAREN] = ACTIONS(4920),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4920),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym_LF] = ACTIONS(4918),
    [anon_sym_AMP] = ACTIONS(4920),
  },
  [2229] = {
    [sym__concat] = ACTIONS(3917),
    [anon_sym_SEMI_SEMI] = ACTIONS(3919),
    [sym__special_characters] = ACTIONS(3919),
    [anon_sym_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3919),
    [sym_raw_string] = ACTIONS(3919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3919),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3919),
    [anon_sym_BQUOTE] = ACTIONS(3919),
    [anon_sym_LT_LPAREN] = ACTIONS(3919),
    [anon_sym_GT_LPAREN] = ACTIONS(3919),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3919),
    [anon_sym_SEMI] = ACTIONS(3919),
    [anon_sym_LF] = ACTIONS(3917),
    [anon_sym_AMP] = ACTIONS(3919),
  },
  [2230] = {
    [sym__concat] = ACTIONS(3923),
    [anon_sym_SEMI_SEMI] = ACTIONS(3925),
    [sym__special_characters] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [sym_raw_string] = ACTIONS(3925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3925),
    [anon_sym_BQUOTE] = ACTIONS(3925),
    [anon_sym_LT_LPAREN] = ACTIONS(3925),
    [anon_sym_GT_LPAREN] = ACTIONS(3925),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3925),
    [anon_sym_SEMI] = ACTIONS(3925),
    [anon_sym_LF] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3925),
  },
  [2231] = {
    [sym__concat] = ACTIONS(4008),
    [anon_sym_SEMI_SEMI] = ACTIONS(4010),
    [sym__special_characters] = ACTIONS(4010),
    [anon_sym_DQUOTE] = ACTIONS(4010),
    [anon_sym_DOLLAR] = ACTIONS(4010),
    [sym_raw_string] = ACTIONS(4010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4010),
    [anon_sym_BQUOTE] = ACTIONS(4010),
    [anon_sym_LT_LPAREN] = ACTIONS(4010),
    [anon_sym_GT_LPAREN] = ACTIONS(4010),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4010),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LF] = ACTIONS(4008),
    [anon_sym_AMP] = ACTIONS(4010),
  },
  [2232] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5724),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2233] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5726),
    [sym_comment] = ACTIONS(53),
  },
  [2234] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5728),
    [sym_comment] = ACTIONS(53),
  },
  [2235] = {
    [anon_sym_RBRACE] = ACTIONS(5728),
    [sym_comment] = ACTIONS(53),
  },
  [2236] = {
    [sym_concatenation] = STATE(2469),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2469),
    [anon_sym_RBRACE] = ACTIONS(5730),
    [anon_sym_EQ] = ACTIONS(5732),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5734),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5732),
    [anon_sym_COLON_QMARK] = ACTIONS(5732),
    [anon_sym_COLON_DASH] = ACTIONS(5732),
    [anon_sym_PERCENT] = ACTIONS(5732),
    [anon_sym_DASH] = ACTIONS(5732),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2237] = {
    [sym__concat] = ACTIONS(4024),
    [anon_sym_SEMI_SEMI] = ACTIONS(4026),
    [sym__special_characters] = ACTIONS(4026),
    [anon_sym_DQUOTE] = ACTIONS(4026),
    [anon_sym_DOLLAR] = ACTIONS(4026),
    [sym_raw_string] = ACTIONS(4026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4026),
    [anon_sym_BQUOTE] = ACTIONS(4026),
    [anon_sym_LT_LPAREN] = ACTIONS(4026),
    [anon_sym_GT_LPAREN] = ACTIONS(4026),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4026),
    [anon_sym_SEMI] = ACTIONS(4026),
    [anon_sym_LF] = ACTIONS(4024),
    [anon_sym_AMP] = ACTIONS(4026),
  },
  [2238] = {
    [sym_concatenation] = STATE(2471),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2471),
    [anon_sym_RBRACE] = ACTIONS(5736),
    [anon_sym_EQ] = ACTIONS(5738),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5740),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5738),
    [anon_sym_COLON_QMARK] = ACTIONS(5738),
    [anon_sym_COLON_DASH] = ACTIONS(5738),
    [anon_sym_PERCENT] = ACTIONS(5738),
    [anon_sym_DASH] = ACTIONS(5738),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2239] = {
    [sym__concat] = ACTIONS(4034),
    [anon_sym_SEMI_SEMI] = ACTIONS(4036),
    [sym__special_characters] = ACTIONS(4036),
    [anon_sym_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR] = ACTIONS(4036),
    [sym_raw_string] = ACTIONS(4036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4036),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4036),
    [anon_sym_GT_LPAREN] = ACTIONS(4036),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4036),
    [anon_sym_SEMI] = ACTIONS(4036),
    [anon_sym_LF] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
  },
  [2240] = {
    [sym_concatenation] = STATE(2473),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2473),
    [anon_sym_RBRACE] = ACTIONS(5742),
    [anon_sym_EQ] = ACTIONS(5744),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5744),
    [anon_sym_COLON_QMARK] = ACTIONS(5744),
    [anon_sym_COLON_DASH] = ACTIONS(5744),
    [anon_sym_PERCENT] = ACTIONS(5744),
    [anon_sym_DASH] = ACTIONS(5744),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2241] = {
    [sym__concat] = ACTIONS(4044),
    [anon_sym_SEMI_SEMI] = ACTIONS(4046),
    [sym__special_characters] = ACTIONS(4046),
    [anon_sym_DQUOTE] = ACTIONS(4046),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [sym_raw_string] = ACTIONS(4046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4046),
    [anon_sym_BQUOTE] = ACTIONS(4046),
    [anon_sym_LT_LPAREN] = ACTIONS(4046),
    [anon_sym_GT_LPAREN] = ACTIONS(4046),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4046),
    [anon_sym_SEMI] = ACTIONS(4046),
    [anon_sym_LF] = ACTIONS(4044),
    [anon_sym_AMP] = ACTIONS(4046),
  },
  [2242] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5748),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2243] = {
    [sym__concat] = ACTIONS(4050),
    [anon_sym_SEMI_SEMI] = ACTIONS(4052),
    [sym__special_characters] = ACTIONS(4052),
    [anon_sym_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [sym_raw_string] = ACTIONS(4052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4052),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4052),
    [anon_sym_BQUOTE] = ACTIONS(4052),
    [anon_sym_LT_LPAREN] = ACTIONS(4052),
    [anon_sym_GT_LPAREN] = ACTIONS(4052),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4052),
    [anon_sym_SEMI] = ACTIONS(4052),
    [anon_sym_LF] = ACTIONS(4050),
    [anon_sym_AMP] = ACTIONS(4052),
  },
  [2244] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5750),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2245] = {
    [sym_concatenation] = STATE(2476),
    [sym_string] = STATE(2481),
    [sym_array] = STATE(2476),
    [sym_simple_expansion] = STATE(2481),
    [sym_string_expansion] = STATE(2481),
    [sym_expansion] = STATE(2481),
    [sym_command_substitution] = STATE(2481),
    [sym_process_substitution] = STATE(2481),
    [sym__empty_value] = ACTIONS(5752),
    [anon_sym_LPAREN] = ACTIONS(5754),
    [sym__special_characters] = ACTIONS(5756),
    [anon_sym_DQUOTE] = ACTIONS(5758),
    [anon_sym_DOLLAR] = ACTIONS(5760),
    [sym_raw_string] = ACTIONS(5762),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5764),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5766),
    [anon_sym_BQUOTE] = ACTIONS(5768),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5762),
  },
  [2246] = {
    [sym_do_group] = STATE(2486),
    [anon_sym_do] = ACTIONS(411),
    [sym_comment] = ACTIONS(53),
  },
  [2247] = {
    [sym_compound_statement] = STATE(2488),
    [anon_sym_LPAREN] = ACTIONS(5772),
    [anon_sym_LBRACE] = ACTIONS(455),
    [sym_comment] = ACTIONS(53),
  },
  [2248] = {
    [anon_sym_AMP_AMP] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(543),
    [anon_sym_RBRACK] = ACTIONS(5774),
    [anon_sym_EQ_TILDE] = ACTIONS(547),
    [anon_sym_EQ_EQ] = ACTIONS(547),
    [anon_sym_EQ] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_BANG_EQ] = ACTIONS(543),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(543),
  },
  [2249] = {
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5774),
    [anon_sym_EQ_TILDE] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(577),
    [anon_sym_LT] = ACTIONS(573),
    [anon_sym_GT] = ACTIONS(573),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(573),
  },
  [2250] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(5776),
    [anon_sym_PLUS_EQ] = ACTIONS(5776),
    [sym_comment] = ACTIONS(53),
  },
  [2251] = {
    [aux_sym_concatenation_repeat1] = STATE(2492),
    [sym__concat] = ACTIONS(5778),
    [sym_variable_name] = ACTIONS(583),
    [anon_sym_esac] = ACTIONS(585),
    [anon_sym_PIPE] = ACTIONS(585),
    [anon_sym_SEMI_SEMI] = ACTIONS(585),
    [anon_sym_PIPE_AMP] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(585),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [sym__special_characters] = ACTIONS(585),
    [anon_sym_DQUOTE] = ACTIONS(585),
    [anon_sym_DOLLAR] = ACTIONS(585),
    [sym_raw_string] = ACTIONS(585),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(585),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_LT_LPAREN] = ACTIONS(585),
    [anon_sym_GT_LPAREN] = ACTIONS(585),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(585),
    [sym_word] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(585),
    [anon_sym_LF] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(585),
  },
  [2252] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(2494),
    [anon_sym_DQUOTE] = ACTIONS(5780),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [2253] = {
    [sym_string] = STATE(2496),
    [anon_sym_DQUOTE] = ACTIONS(5782),
    [anon_sym_DOLLAR] = ACTIONS(5784),
    [sym_raw_string] = ACTIONS(5786),
    [anon_sym_POUND] = ACTIONS(5784),
    [anon_sym_DASH] = ACTIONS(5784),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5788),
    [anon_sym_STAR] = ACTIONS(5784),
    [anon_sym_AT] = ACTIONS(5784),
    [anon_sym_QMARK] = ACTIONS(5784),
    [anon_sym_0] = ACTIONS(5790),
    [anon_sym__] = ACTIONS(5790),
  },
  [2254] = {
    [aux_sym_concatenation_repeat1] = STATE(2492),
    [sym__concat] = ACTIONS(5778),
    [sym_variable_name] = ACTIONS(599),
    [anon_sym_esac] = ACTIONS(601),
    [anon_sym_PIPE] = ACTIONS(601),
    [anon_sym_SEMI_SEMI] = ACTIONS(601),
    [anon_sym_PIPE_AMP] = ACTIONS(601),
    [anon_sym_AMP_AMP] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(601),
    [sym__special_characters] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [anon_sym_DOLLAR] = ACTIONS(601),
    [sym_raw_string] = ACTIONS(601),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(601),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(601),
    [anon_sym_BQUOTE] = ACTIONS(601),
    [anon_sym_LT_LPAREN] = ACTIONS(601),
    [anon_sym_GT_LPAREN] = ACTIONS(601),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(601),
    [sym_word] = ACTIONS(601),
    [anon_sym_SEMI] = ACTIONS(601),
    [anon_sym_LF] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(601),
  },
  [2255] = {
    [sym_subscript] = STATE(2502),
    [sym_variable_name] = ACTIONS(5792),
    [anon_sym_DOLLAR] = ACTIONS(5794),
    [anon_sym_POUND] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5794),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5798),
    [anon_sym_STAR] = ACTIONS(5794),
    [anon_sym_AT] = ACTIONS(5794),
    [anon_sym_QMARK] = ACTIONS(5794),
    [anon_sym_0] = ACTIONS(5800),
    [anon_sym__] = ACTIONS(5800),
  },
  [2256] = {
    [sym_for_statement] = STATE(2503),
    [sym_while_statement] = STATE(2503),
    [sym_if_statement] = STATE(2503),
    [sym_case_statement] = STATE(2503),
    [sym_function_definition] = STATE(2503),
    [sym_subshell] = STATE(2503),
    [sym_pipeline] = STATE(2503),
    [sym_list] = STATE(2503),
    [sym_negated_command] = STATE(2503),
    [sym_test_command] = STATE(2503),
    [sym_declaration_command] = STATE(2503),
    [sym_unset_command] = STATE(2503),
    [sym_command] = STATE(2503),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(2504),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [2257] = {
    [sym_for_statement] = STATE(2505),
    [sym_while_statement] = STATE(2505),
    [sym_if_statement] = STATE(2505),
    [sym_case_statement] = STATE(2505),
    [sym_function_definition] = STATE(2505),
    [sym_subshell] = STATE(2505),
    [sym_pipeline] = STATE(2505),
    [sym_list] = STATE(2505),
    [sym_negated_command] = STATE(2505),
    [sym_test_command] = STATE(2505),
    [sym_declaration_command] = STATE(2505),
    [sym_unset_command] = STATE(2505),
    [sym_command] = STATE(2505),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(2506),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [2258] = {
    [sym_for_statement] = STATE(2507),
    [sym_while_statement] = STATE(2507),
    [sym_if_statement] = STATE(2507),
    [sym_case_statement] = STATE(2507),
    [sym_function_definition] = STATE(2507),
    [sym_subshell] = STATE(2507),
    [sym_pipeline] = STATE(2507),
    [sym_list] = STATE(2507),
    [sym_negated_command] = STATE(2507),
    [sym_test_command] = STATE(2507),
    [sym_declaration_command] = STATE(2507),
    [sym_unset_command] = STATE(2507),
    [sym_command] = STATE(2507),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(2508),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [2259] = {
    [sym_variable_name] = ACTIONS(613),
    [anon_sym_esac] = ACTIONS(615),
    [anon_sym_PIPE] = ACTIONS(615),
    [anon_sym_SEMI_SEMI] = ACTIONS(615),
    [anon_sym_PIPE_AMP] = ACTIONS(615),
    [anon_sym_AMP_AMP] = ACTIONS(615),
    [anon_sym_PIPE_PIPE] = ACTIONS(615),
    [sym__special_characters] = ACTIONS(615),
    [anon_sym_DQUOTE] = ACTIONS(615),
    [anon_sym_DOLLAR] = ACTIONS(615),
    [sym_raw_string] = ACTIONS(615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(615),
    [anon_sym_BQUOTE] = ACTIONS(615),
    [anon_sym_LT_LPAREN] = ACTIONS(615),
    [anon_sym_GT_LPAREN] = ACTIONS(615),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(615),
    [sym_word] = ACTIONS(615),
    [anon_sym_SEMI] = ACTIONS(615),
    [anon_sym_LF] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(615),
  },
  [2260] = {
    [anon_sym_EQ] = ACTIONS(5776),
    [anon_sym_PLUS_EQ] = ACTIONS(5776),
    [sym_comment] = ACTIONS(53),
  },
  [2261] = {
    [sym_variable_assignment] = STATE(2509),
    [sym_subscript] = STATE(2260),
    [sym_concatenation] = STATE(2509),
    [sym_string] = STATE(2254),
    [sym_simple_expansion] = STATE(2254),
    [sym_string_expansion] = STATE(2254),
    [sym_expansion] = STATE(2254),
    [sym_command_substitution] = STATE(2254),
    [sym_process_substitution] = STATE(2254),
    [aux_sym_declaration_command_repeat1] = STATE(2509),
    [sym_variable_name] = ACTIONS(5260),
    [anon_sym_esac] = ACTIONS(617),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_SEMI_SEMI] = ACTIONS(617),
    [anon_sym_PIPE_AMP] = ACTIONS(617),
    [anon_sym_AMP_AMP] = ACTIONS(617),
    [anon_sym_PIPE_PIPE] = ACTIONS(617),
    [sym__special_characters] = ACTIONS(5262),
    [anon_sym_DQUOTE] = ACTIONS(5264),
    [anon_sym_DOLLAR] = ACTIONS(5266),
    [sym_raw_string] = ACTIONS(5268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5270),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5272),
    [anon_sym_BQUOTE] = ACTIONS(5274),
    [anon_sym_LT_LPAREN] = ACTIONS(5276),
    [anon_sym_GT_LPAREN] = ACTIONS(5276),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5278),
    [sym_word] = ACTIONS(5268),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_LF] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(617),
  },
  [2262] = {
    [aux_sym_concatenation_repeat1] = STATE(2511),
    [sym__concat] = ACTIONS(5802),
    [anon_sym_esac] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(623),
    [anon_sym_SEMI_SEMI] = ACTIONS(623),
    [anon_sym_PIPE_AMP] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(623),
    [sym__special_characters] = ACTIONS(623),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [sym_raw_string] = ACTIONS(623),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(623),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(623),
    [anon_sym_BQUOTE] = ACTIONS(623),
    [anon_sym_LT_LPAREN] = ACTIONS(623),
    [anon_sym_GT_LPAREN] = ACTIONS(623),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(623),
    [sym_word] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(623),
    [anon_sym_LF] = ACTIONS(625),
    [anon_sym_AMP] = ACTIONS(623),
  },
  [2263] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(2513),
    [anon_sym_DQUOTE] = ACTIONS(5804),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [2264] = {
    [sym_string] = STATE(2515),
    [anon_sym_DQUOTE] = ACTIONS(5806),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [sym_raw_string] = ACTIONS(5810),
    [anon_sym_POUND] = ACTIONS(5808),
    [anon_sym_DASH] = ACTIONS(5808),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5812),
    [anon_sym_STAR] = ACTIONS(5808),
    [anon_sym_AT] = ACTIONS(5808),
    [anon_sym_QMARK] = ACTIONS(5808),
    [anon_sym_0] = ACTIONS(5814),
    [anon_sym__] = ACTIONS(5814),
  },
  [2265] = {
    [aux_sym_concatenation_repeat1] = STATE(2511),
    [sym__concat] = ACTIONS(5802),
    [anon_sym_esac] = ACTIONS(639),
    [anon_sym_PIPE] = ACTIONS(639),
    [anon_sym_SEMI_SEMI] = ACTIONS(639),
    [anon_sym_PIPE_AMP] = ACTIONS(639),
    [anon_sym_AMP_AMP] = ACTIONS(639),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [sym__special_characters] = ACTIONS(639),
    [anon_sym_DQUOTE] = ACTIONS(639),
    [anon_sym_DOLLAR] = ACTIONS(639),
    [sym_raw_string] = ACTIONS(639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(639),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(639),
    [anon_sym_BQUOTE] = ACTIONS(639),
    [anon_sym_LT_LPAREN] = ACTIONS(639),
    [anon_sym_GT_LPAREN] = ACTIONS(639),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(639),
    [sym_word] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(639),
    [anon_sym_LF] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(639),
  },
  [2266] = {
    [sym_subscript] = STATE(2521),
    [sym_variable_name] = ACTIONS(5816),
    [anon_sym_DOLLAR] = ACTIONS(5818),
    [anon_sym_POUND] = ACTIONS(5820),
    [anon_sym_DASH] = ACTIONS(5818),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5822),
    [anon_sym_STAR] = ACTIONS(5818),
    [anon_sym_AT] = ACTIONS(5818),
    [anon_sym_QMARK] = ACTIONS(5818),
    [anon_sym_0] = ACTIONS(5824),
    [anon_sym__] = ACTIONS(5824),
  },
  [2267] = {
    [sym_for_statement] = STATE(2522),
    [sym_while_statement] = STATE(2522),
    [sym_if_statement] = STATE(2522),
    [sym_case_statement] = STATE(2522),
    [sym_function_definition] = STATE(2522),
    [sym_subshell] = STATE(2522),
    [sym_pipeline] = STATE(2522),
    [sym_list] = STATE(2522),
    [sym_negated_command] = STATE(2522),
    [sym_test_command] = STATE(2522),
    [sym_declaration_command] = STATE(2522),
    [sym_unset_command] = STATE(2522),
    [sym_command] = STATE(2522),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(2523),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [2268] = {
    [sym_for_statement] = STATE(2524),
    [sym_while_statement] = STATE(2524),
    [sym_if_statement] = STATE(2524),
    [sym_case_statement] = STATE(2524),
    [sym_function_definition] = STATE(2524),
    [sym_subshell] = STATE(2524),
    [sym_pipeline] = STATE(2524),
    [sym_list] = STATE(2524),
    [sym_negated_command] = STATE(2524),
    [sym_test_command] = STATE(2524),
    [sym_declaration_command] = STATE(2524),
    [sym_unset_command] = STATE(2524),
    [sym_command] = STATE(2524),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(2525),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [2269] = {
    [sym_for_statement] = STATE(2526),
    [sym_while_statement] = STATE(2526),
    [sym_if_statement] = STATE(2526),
    [sym_case_statement] = STATE(2526),
    [sym_function_definition] = STATE(2526),
    [sym_subshell] = STATE(2526),
    [sym_pipeline] = STATE(2526),
    [sym_list] = STATE(2526),
    [sym_negated_command] = STATE(2526),
    [sym_test_command] = STATE(2526),
    [sym_declaration_command] = STATE(2526),
    [sym_unset_command] = STATE(2526),
    [sym_command] = STATE(2526),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(2527),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [2270] = {
    [anon_sym_esac] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(653),
    [anon_sym_SEMI_SEMI] = ACTIONS(653),
    [anon_sym_PIPE_AMP] = ACTIONS(653),
    [anon_sym_AMP_AMP] = ACTIONS(653),
    [anon_sym_PIPE_PIPE] = ACTIONS(653),
    [sym__special_characters] = ACTIONS(653),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_DOLLAR] = ACTIONS(653),
    [sym_raw_string] = ACTIONS(653),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(653),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(653),
    [anon_sym_LT_LPAREN] = ACTIONS(653),
    [anon_sym_GT_LPAREN] = ACTIONS(653),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(653),
    [sym_word] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_LF] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(653),
  },
  [2271] = {
    [sym_concatenation] = STATE(2528),
    [sym_string] = STATE(2265),
    [sym_simple_expansion] = STATE(2265),
    [sym_string_expansion] = STATE(2265),
    [sym_expansion] = STATE(2265),
    [sym_command_substitution] = STATE(2265),
    [sym_process_substitution] = STATE(2265),
    [aux_sym_unset_command_repeat1] = STATE(2528),
    [anon_sym_esac] = ACTIONS(657),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_SEMI_SEMI] = ACTIONS(657),
    [anon_sym_PIPE_AMP] = ACTIONS(657),
    [anon_sym_AMP_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(657),
    [sym__special_characters] = ACTIONS(5280),
    [anon_sym_DQUOTE] = ACTIONS(5282),
    [anon_sym_DOLLAR] = ACTIONS(5284),
    [sym_raw_string] = ACTIONS(5286),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5290),
    [anon_sym_BQUOTE] = ACTIONS(5292),
    [anon_sym_LT_LPAREN] = ACTIONS(5294),
    [anon_sym_GT_LPAREN] = ACTIONS(5294),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5296),
    [sym_word] = ACTIONS(5286),
    [anon_sym_SEMI] = ACTIONS(657),
    [anon_sym_LF] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(657),
  },
  [2272] = {
    [sym_string] = STATE(2529),
    [sym_simple_expansion] = STATE(2529),
    [sym_string_expansion] = STATE(2529),
    [sym_expansion] = STATE(2529),
    [sym_command_substitution] = STATE(2529),
    [sym_process_substitution] = STATE(2529),
    [sym__special_characters] = ACTIONS(5826),
    [anon_sym_DQUOTE] = ACTIONS(4470),
    [anon_sym_DOLLAR] = ACTIONS(4472),
    [sym_raw_string] = ACTIONS(5826),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4478),
    [anon_sym_BQUOTE] = ACTIONS(4480),
    [anon_sym_LT_LPAREN] = ACTIONS(4482),
    [anon_sym_GT_LPAREN] = ACTIONS(4482),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5826),
  },
  [2273] = {
    [aux_sym_concatenation_repeat1] = STATE(2530),
    [sym__simple_heredoc_body] = ACTIONS(693),
    [sym__heredoc_body_beginning] = ACTIONS(693),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(5298),
    [anon_sym_esac] = ACTIONS(695),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_EQ_TILDE] = ACTIONS(695),
    [anon_sym_EQ_EQ] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [2274] = {
    [sym__simple_heredoc_body] = ACTIONS(697),
    [sym__heredoc_body_beginning] = ACTIONS(697),
    [sym_file_descriptor] = ACTIONS(697),
    [sym__concat] = ACTIONS(697),
    [anon_sym_esac] = ACTIONS(699),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_EQ_TILDE] = ACTIONS(699),
    [anon_sym_EQ_EQ] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_GT] = ACTIONS(699),
    [anon_sym_AMP_GT_GT] = ACTIONS(699),
    [anon_sym_LT_AMP] = ACTIONS(699),
    [anon_sym_GT_AMP] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_LT_LT_DASH] = ACTIONS(699),
    [anon_sym_LT_LT_LT] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_LF] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [2275] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(5828),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [2276] = {
    [sym__simple_heredoc_body] = ACTIONS(727),
    [sym__heredoc_body_beginning] = ACTIONS(727),
    [sym_file_descriptor] = ACTIONS(727),
    [sym__concat] = ACTIONS(727),
    [anon_sym_esac] = ACTIONS(729),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(729),
    [anon_sym_PIPE_AMP] = ACTIONS(729),
    [anon_sym_AMP_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(729),
    [anon_sym_EQ_TILDE] = ACTIONS(729),
    [anon_sym_EQ_EQ] = ACTIONS(729),
    [anon_sym_LT] = ACTIONS(729),
    [anon_sym_GT] = ACTIONS(729),
    [anon_sym_GT_GT] = ACTIONS(729),
    [anon_sym_AMP_GT] = ACTIONS(729),
    [anon_sym_AMP_GT_GT] = ACTIONS(729),
    [anon_sym_LT_AMP] = ACTIONS(729),
    [anon_sym_GT_AMP] = ACTIONS(729),
    [anon_sym_LT_LT] = ACTIONS(729),
    [anon_sym_LT_LT_DASH] = ACTIONS(729),
    [anon_sym_LT_LT_LT] = ACTIONS(729),
    [sym__special_characters] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(729),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(729),
    [anon_sym_BQUOTE] = ACTIONS(729),
    [anon_sym_LT_LPAREN] = ACTIONS(729),
    [anon_sym_GT_LPAREN] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(729),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_LF] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
  },
  [2277] = {
    [sym__simple_heredoc_body] = ACTIONS(731),
    [sym__heredoc_body_beginning] = ACTIONS(731),
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(731),
    [anon_sym_esac] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_EQ_TILDE] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(733),
    [anon_sym_LT_LT_LT] = ACTIONS(733),
    [sym__special_characters] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [anon_sym_LT_LPAREN] = ACTIONS(733),
    [anon_sym_GT_LPAREN] = ACTIONS(733),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [2278] = {
    [sym__simple_heredoc_body] = ACTIONS(735),
    [sym__heredoc_body_beginning] = ACTIONS(735),
    [sym_file_descriptor] = ACTIONS(735),
    [sym__concat] = ACTIONS(735),
    [anon_sym_esac] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(737),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_EQ_TILDE] = ACTIONS(737),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(737),
    [anon_sym_LT_AMP] = ACTIONS(737),
    [anon_sym_GT_AMP] = ACTIONS(737),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_LT_LT_DASH] = ACTIONS(737),
    [anon_sym_LT_LT_LT] = ACTIONS(737),
    [sym__special_characters] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [anon_sym_LT_LPAREN] = ACTIONS(737),
    [anon_sym_GT_LPAREN] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [2279] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(5830),
    [sym_comment] = ACTIONS(53),
  },
  [2280] = {
    [sym_concatenation] = STATE(2535),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2535),
    [anon_sym_RBRACE] = ACTIONS(5832),
    [anon_sym_EQ] = ACTIONS(5834),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5836),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5838),
    [anon_sym_COLON] = ACTIONS(5834),
    [anon_sym_COLON_QMARK] = ACTIONS(5834),
    [anon_sym_COLON_DASH] = ACTIONS(5834),
    [anon_sym_PERCENT] = ACTIONS(5834),
    [anon_sym_DASH] = ACTIONS(5834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2281] = {
    [sym_subscript] = STATE(2539),
    [sym_variable_name] = ACTIONS(5840),
    [anon_sym_DOLLAR] = ACTIONS(5842),
    [anon_sym_DASH] = ACTIONS(5842),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5844),
    [anon_sym_STAR] = ACTIONS(5842),
    [anon_sym_AT] = ACTIONS(5842),
    [anon_sym_QMARK] = ACTIONS(5842),
    [anon_sym_0] = ACTIONS(5846),
    [anon_sym__] = ACTIONS(5846),
  },
  [2282] = {
    [sym_concatenation] = STATE(2542),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2542),
    [anon_sym_RBRACE] = ACTIONS(5848),
    [anon_sym_EQ] = ACTIONS(5850),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5852),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5854),
    [anon_sym_COLON] = ACTIONS(5850),
    [anon_sym_COLON_QMARK] = ACTIONS(5850),
    [anon_sym_COLON_DASH] = ACTIONS(5850),
    [anon_sym_PERCENT] = ACTIONS(5850),
    [anon_sym_DASH] = ACTIONS(5850),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2283] = {
    [sym_concatenation] = STATE(2545),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2545),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_EQ] = ACTIONS(5858),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5860),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(5862),
    [anon_sym_COLON] = ACTIONS(5858),
    [anon_sym_COLON_QMARK] = ACTIONS(5858),
    [anon_sym_COLON_DASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [anon_sym_DASH] = ACTIONS(5858),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2284] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(5864),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [2285] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(5864),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2286] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(5864),
    [sym_comment] = ACTIONS(53),
  },
  [2287] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(5864),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2288] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(5866),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [2289] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(5866),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2290] = {
    [anon_sym_RPAREN] = ACTIONS(5868),
    [sym_comment] = ACTIONS(53),
  },
  [2291] = {
    [sym_for_statement] = STATE(529),
    [sym_while_statement] = STATE(529),
    [sym_if_statement] = STATE(529),
    [sym_case_statement] = STATE(529),
    [sym_function_definition] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_pipeline] = STATE(529),
    [sym_list] = STATE(529),
    [sym_negated_command] = STATE(529),
    [sym_test_command] = STATE(529),
    [sym_declaration_command] = STATE(529),
    [sym_unset_command] = STATE(529),
    [sym_command] = STATE(529),
    [sym_command_name] = STATE(1935),
    [sym_variable_assignment] = STATE(2549),
    [sym_subscript] = STATE(1937),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1938),
    [sym_string] = STATE(1928),
    [sym_simple_expansion] = STATE(1928),
    [sym_string_expansion] = STATE(1928),
    [sym_expansion] = STATE(1928),
    [sym_command_substitution] = STATE(1928),
    [sym_process_substitution] = STATE(1928),
    [aux_sym_command_repeat1] = STATE(1940),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4448),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4450),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(4456),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4458),
    [anon_sym_LBRACK] = ACTIONS(4460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4462),
    [anon_sym_declare] = ACTIONS(4464),
    [anon_sym_typeset] = ACTIONS(4464),
    [anon_sym_export] = ACTIONS(4464),
    [anon_sym_readonly] = ACTIONS(4464),
    [anon_sym_local] = ACTIONS(4464),
    [anon_sym_unset] = ACTIONS(4466),
    [anon_sym_unsetenv] = ACTIONS(4466),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4468),
    [anon_sym_DQUOTE] = ACTIONS(4470),
    [anon_sym_DOLLAR] = ACTIONS(4472),
    [sym_raw_string] = ACTIONS(4474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4478),
    [anon_sym_BQUOTE] = ACTIONS(4480),
    [anon_sym_LT_LPAREN] = ACTIONS(4482),
    [anon_sym_GT_LPAREN] = ACTIONS(4482),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4484),
  },
  [2292] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_esac] = ACTIONS(5870),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(5872),
    [anon_sym_DQUOTE] = ACTIONS(5874),
    [anon_sym_DOLLAR] = ACTIONS(5872),
    [sym_raw_string] = ACTIONS(5874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5874),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5874),
    [anon_sym_BQUOTE] = ACTIONS(5874),
    [anon_sym_LT_LPAREN] = ACTIONS(5874),
    [anon_sym_GT_LPAREN] = ACTIONS(5874),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5872),
  },
  [2293] = {
    [sym_for_statement] = STATE(2550),
    [sym_while_statement] = STATE(2550),
    [sym_if_statement] = STATE(2550),
    [sym_case_statement] = STATE(2550),
    [sym_function_definition] = STATE(2550),
    [sym_subshell] = STATE(2550),
    [sym_pipeline] = STATE(2550),
    [sym_list] = STATE(2550),
    [sym_negated_command] = STATE(2550),
    [sym_test_command] = STATE(2550),
    [sym_declaration_command] = STATE(2550),
    [sym_unset_command] = STATE(2550),
    [sym_command] = STATE(2550),
    [sym_command_name] = STATE(1935),
    [sym_variable_assignment] = STATE(2551),
    [sym_subscript] = STATE(1937),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1938),
    [sym_string] = STATE(1928),
    [sym_simple_expansion] = STATE(1928),
    [sym_string_expansion] = STATE(1928),
    [sym_expansion] = STATE(1928),
    [sym_command_substitution] = STATE(1928),
    [sym_process_substitution] = STATE(1928),
    [aux_sym_command_repeat1] = STATE(1940),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4448),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4450),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(4456),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4458),
    [anon_sym_LBRACK] = ACTIONS(4460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4462),
    [anon_sym_declare] = ACTIONS(4464),
    [anon_sym_typeset] = ACTIONS(4464),
    [anon_sym_export] = ACTIONS(4464),
    [anon_sym_readonly] = ACTIONS(4464),
    [anon_sym_local] = ACTIONS(4464),
    [anon_sym_unset] = ACTIONS(4466),
    [anon_sym_unsetenv] = ACTIONS(4466),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4468),
    [anon_sym_DQUOTE] = ACTIONS(4470),
    [anon_sym_DOLLAR] = ACTIONS(4472),
    [sym_raw_string] = ACTIONS(4474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4478),
    [anon_sym_BQUOTE] = ACTIONS(4480),
    [anon_sym_LT_LPAREN] = ACTIONS(4482),
    [anon_sym_GT_LPAREN] = ACTIONS(4482),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4484),
  },
  [2294] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_esac] = ACTIONS(953),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(953),
    [anon_sym_DQUOTE] = ACTIONS(951),
    [anon_sym_DOLLAR] = ACTIONS(953),
    [sym_raw_string] = ACTIONS(951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(951),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(951),
    [anon_sym_BQUOTE] = ACTIONS(951),
    [anon_sym_LT_LPAREN] = ACTIONS(951),
    [anon_sym_GT_LPAREN] = ACTIONS(951),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(953),
  },
  [2295] = {
    [anon_sym_LT] = ACTIONS(5876),
    [anon_sym_GT] = ACTIONS(5876),
    [anon_sym_GT_GT] = ACTIONS(5878),
    [anon_sym_AMP_GT] = ACTIONS(5876),
    [anon_sym_AMP_GT_GT] = ACTIONS(5878),
    [anon_sym_LT_AMP] = ACTIONS(5878),
    [anon_sym_GT_AMP] = ACTIONS(5878),
    [sym_comment] = ACTIONS(53),
  },
  [2296] = {
    [sym_concatenation] = STATE(2555),
    [sym_string] = STATE(2554),
    [sym_simple_expansion] = STATE(2554),
    [sym_string_expansion] = STATE(2554),
    [sym_expansion] = STATE(2554),
    [sym_command_substitution] = STATE(2554),
    [sym_process_substitution] = STATE(2554),
    [sym__special_characters] = ACTIONS(5880),
    [anon_sym_DQUOTE] = ACTIONS(5342),
    [anon_sym_DOLLAR] = ACTIONS(4472),
    [sym_raw_string] = ACTIONS(5882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5346),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5348),
    [anon_sym_BQUOTE] = ACTIONS(5350),
    [anon_sym_LT_LPAREN] = ACTIONS(5352),
    [anon_sym_GT_LPAREN] = ACTIONS(5352),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5882),
    [sym_regex] = ACTIONS(5884),
  },
  [2297] = {
    [sym_concatenation] = STATE(543),
    [sym_string] = STATE(2559),
    [sym_simple_expansion] = STATE(2559),
    [sym_string_expansion] = STATE(2559),
    [sym_expansion] = STATE(2559),
    [sym_command_substitution] = STATE(2559),
    [sym_process_substitution] = STATE(2559),
    [sym__special_characters] = ACTIONS(5886),
    [anon_sym_DQUOTE] = ACTIONS(5888),
    [anon_sym_DOLLAR] = ACTIONS(5890),
    [sym_raw_string] = ACTIONS(5892),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5896),
    [anon_sym_BQUOTE] = ACTIONS(5898),
    [anon_sym_LT_LPAREN] = ACTIONS(5900),
    [anon_sym_GT_LPAREN] = ACTIONS(5900),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5892),
  },
  [2298] = {
    [sym_concatenation] = STATE(547),
    [sym_string] = STATE(2565),
    [sym_simple_expansion] = STATE(2565),
    [sym_string_expansion] = STATE(2565),
    [sym_expansion] = STATE(2565),
    [sym_command_substitution] = STATE(2565),
    [sym_process_substitution] = STATE(2565),
    [sym__special_characters] = ACTIONS(5902),
    [anon_sym_DQUOTE] = ACTIONS(5888),
    [anon_sym_DOLLAR] = ACTIONS(5890),
    [sym_raw_string] = ACTIONS(5904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5896),
    [anon_sym_BQUOTE] = ACTIONS(5898),
    [anon_sym_LT_LPAREN] = ACTIONS(5900),
    [anon_sym_GT_LPAREN] = ACTIONS(5900),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5904),
  },
  [2299] = {
    [aux_sym_concatenation_repeat1] = STATE(2273),
    [sym__simple_heredoc_body] = ACTIONS(987),
    [sym__heredoc_body_beginning] = ACTIONS(987),
    [sym_file_descriptor] = ACTIONS(987),
    [sym__concat] = ACTIONS(5298),
    [anon_sym_esac] = ACTIONS(989),
    [anon_sym_PIPE] = ACTIONS(989),
    [anon_sym_SEMI_SEMI] = ACTIONS(989),
    [anon_sym_PIPE_AMP] = ACTIONS(989),
    [anon_sym_AMP_AMP] = ACTIONS(989),
    [anon_sym_PIPE_PIPE] = ACTIONS(989),
    [anon_sym_EQ_TILDE] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(989),
    [anon_sym_LT] = ACTIONS(989),
    [anon_sym_GT] = ACTIONS(989),
    [anon_sym_GT_GT] = ACTIONS(989),
    [anon_sym_AMP_GT] = ACTIONS(989),
    [anon_sym_AMP_GT_GT] = ACTIONS(989),
    [anon_sym_LT_AMP] = ACTIONS(989),
    [anon_sym_GT_AMP] = ACTIONS(989),
    [anon_sym_LT_LT] = ACTIONS(989),
    [anon_sym_LT_LT_DASH] = ACTIONS(989),
    [anon_sym_LT_LT_LT] = ACTIONS(989),
    [sym__special_characters] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(989),
    [anon_sym_DOLLAR] = ACTIONS(989),
    [sym_raw_string] = ACTIONS(989),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(989),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(989),
    [anon_sym_BQUOTE] = ACTIONS(989),
    [anon_sym_LT_LPAREN] = ACTIONS(989),
    [anon_sym_GT_LPAREN] = ACTIONS(989),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(989),
    [anon_sym_SEMI] = ACTIONS(989),
    [anon_sym_LF] = ACTIONS(987),
    [anon_sym_AMP] = ACTIONS(989),
  },
  [2300] = {
    [aux_sym_concatenation_repeat1] = STATE(2273),
    [sym__simple_heredoc_body] = ACTIONS(991),
    [sym__heredoc_body_beginning] = ACTIONS(991),
    [sym_file_descriptor] = ACTIONS(991),
    [sym__concat] = ACTIONS(5298),
    [anon_sym_esac] = ACTIONS(993),
    [anon_sym_PIPE] = ACTIONS(993),
    [anon_sym_SEMI_SEMI] = ACTIONS(993),
    [anon_sym_PIPE_AMP] = ACTIONS(993),
    [anon_sym_AMP_AMP] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT] = ACTIONS(993),
    [anon_sym_GT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(993),
    [anon_sym_AMP_GT] = ACTIONS(993),
    [anon_sym_AMP_GT_GT] = ACTIONS(993),
    [anon_sym_LT_AMP] = ACTIONS(993),
    [anon_sym_GT_AMP] = ACTIONS(993),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_LT_LT_DASH] = ACTIONS(993),
    [anon_sym_LT_LT_LT] = ACTIONS(993),
    [sym__special_characters] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(993),
    [anon_sym_DOLLAR] = ACTIONS(993),
    [sym_raw_string] = ACTIONS(993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(993),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(993),
    [anon_sym_LT_LPAREN] = ACTIONS(993),
    [anon_sym_GT_LPAREN] = ACTIONS(993),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(993),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_LF] = ACTIONS(991),
    [anon_sym_AMP] = ACTIONS(993),
  },
  [2301] = {
    [sym_file_redirect] = STATE(2566),
    [sym_heredoc_redirect] = STATE(2566),
    [sym_heredoc_body] = STATE(548),
    [sym_herestring_redirect] = STATE(2566),
    [aux_sym_while_statement_repeat1] = STATE(2566),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(5332),
    [anon_sym_esac] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(5336),
    [anon_sym_GT_GT] = ACTIONS(5336),
    [anon_sym_AMP_GT] = ACTIONS(5336),
    [anon_sym_AMP_GT_GT] = ACTIONS(5336),
    [anon_sym_LT_AMP] = ACTIONS(5336),
    [anon_sym_GT_AMP] = ACTIONS(5336),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(5338),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(995),
  },
  [2302] = {
    [sym_file_redirect] = STATE(2567),
    [sym_heredoc_redirect] = STATE(2567),
    [sym_heredoc_body] = STATE(548),
    [sym_herestring_redirect] = STATE(2567),
    [sym_concatenation] = STATE(2568),
    [sym_string] = STATE(2300),
    [sym_simple_expansion] = STATE(2300),
    [sym_string_expansion] = STATE(2300),
    [sym_expansion] = STATE(2300),
    [sym_command_substitution] = STATE(2300),
    [sym_process_substitution] = STATE(2300),
    [aux_sym_while_statement_repeat1] = STATE(2567),
    [aux_sym_command_repeat2] = STATE(2568),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(5332),
    [anon_sym_esac] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_EQ_TILDE] = ACTIONS(5334),
    [anon_sym_EQ_EQ] = ACTIONS(5334),
    [anon_sym_LT] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(5336),
    [anon_sym_GT_GT] = ACTIONS(5336),
    [anon_sym_AMP_GT] = ACTIONS(5336),
    [anon_sym_AMP_GT_GT] = ACTIONS(5336),
    [anon_sym_LT_AMP] = ACTIONS(5336),
    [anon_sym_GT_AMP] = ACTIONS(5336),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(5338),
    [sym__special_characters] = ACTIONS(5340),
    [anon_sym_DQUOTE] = ACTIONS(5342),
    [anon_sym_DOLLAR] = ACTIONS(4472),
    [sym_raw_string] = ACTIONS(5344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5346),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5348),
    [anon_sym_BQUOTE] = ACTIONS(5350),
    [anon_sym_LT_LPAREN] = ACTIONS(5352),
    [anon_sym_GT_LPAREN] = ACTIONS(5352),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5344),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(995),
  },
  [2303] = {
    [anon_sym_esac] = ACTIONS(5870),
    [sym__special_characters] = ACTIONS(5874),
    [anon_sym_DQUOTE] = ACTIONS(5874),
    [anon_sym_DOLLAR] = ACTIONS(5872),
    [sym_raw_string] = ACTIONS(5874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5874),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5874),
    [anon_sym_BQUOTE] = ACTIONS(5874),
    [anon_sym_LT_LPAREN] = ACTIONS(5874),
    [anon_sym_GT_LPAREN] = ACTIONS(5874),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5872),
  },
  [2304] = {
    [anon_sym_esac] = ACTIONS(5870),
    [anon_sym_PIPE] = ACTIONS(5322),
    [anon_sym_SEMI_SEMI] = ACTIONS(5906),
    [anon_sym_PIPE_AMP] = ACTIONS(5322),
    [anon_sym_AMP_AMP] = ACTIONS(5326),
    [anon_sym_PIPE_PIPE] = ACTIONS(5326),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5328),
    [anon_sym_LF] = ACTIONS(5330),
    [anon_sym_AMP] = ACTIONS(5328),
  },
  [2305] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_esac] = ACTIONS(5870),
    [anon_sym_PIPE] = ACTIONS(5322),
    [anon_sym_SEMI_SEMI] = ACTIONS(5906),
    [anon_sym_PIPE_AMP] = ACTIONS(5322),
    [anon_sym_AMP_AMP] = ACTIONS(5326),
    [anon_sym_PIPE_PIPE] = ACTIONS(5326),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(5328),
    [anon_sym_LF] = ACTIONS(5330),
    [anon_sym_AMP] = ACTIONS(5328),
  },
  [2306] = {
    [sym__terminated_statement] = STATE(2306),
    [sym_for_statement] = STATE(2570),
    [sym_while_statement] = STATE(2570),
    [sym_if_statement] = STATE(2570),
    [sym_case_statement] = STATE(2570),
    [sym_function_definition] = STATE(2570),
    [sym_subshell] = STATE(2570),
    [sym_pipeline] = STATE(2570),
    [sym_list] = STATE(2570),
    [sym_negated_command] = STATE(2570),
    [sym_test_command] = STATE(2570),
    [sym_declaration_command] = STATE(2570),
    [sym_unset_command] = STATE(2570),
    [sym_command] = STATE(2570),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2571),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2306),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(999),
    [sym_variable_name] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1010),
    [anon_sym_if] = ACTIONS(1013),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_esac] = ACTIONS(3526),
    [anon_sym_SEMI_SEMI] = ACTIONS(1005),
    [anon_sym_function] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1031),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_typeset] = ACTIONS(1034),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_local] = ACTIONS(1034),
    [anon_sym_unset] = ACTIONS(1037),
    [anon_sym_unsetenv] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_GT_GT] = ACTIONS(1043),
    [anon_sym_AMP_GT] = ACTIONS(1040),
    [anon_sym_AMP_GT_GT] = ACTIONS(1043),
    [anon_sym_LT_AMP] = ACTIONS(1043),
    [anon_sym_GT_AMP] = ACTIONS(1043),
    [sym__special_characters] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [sym_raw_string] = ACTIONS(1055),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1064),
    [anon_sym_LT_LPAREN] = ACTIONS(1067),
    [anon_sym_GT_LPAREN] = ACTIONS(1067),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1070),
  },
  [2307] = {
    [sym_file_redirect] = STATE(2567),
    [sym_heredoc_redirect] = STATE(2567),
    [sym_heredoc_body] = STATE(548),
    [sym_herestring_redirect] = STATE(2567),
    [sym_concatenation] = STATE(2572),
    [sym_string] = STATE(2300),
    [sym_simple_expansion] = STATE(2300),
    [sym_string_expansion] = STATE(2300),
    [sym_expansion] = STATE(2300),
    [sym_command_substitution] = STATE(2300),
    [sym_process_substitution] = STATE(2300),
    [aux_sym_while_statement_repeat1] = STATE(2567),
    [aux_sym_command_repeat2] = STATE(2572),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(5332),
    [anon_sym_esac] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI_SEMI] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_EQ_TILDE] = ACTIONS(5334),
    [anon_sym_EQ_EQ] = ACTIONS(5334),
    [anon_sym_LT] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(5336),
    [anon_sym_GT_GT] = ACTIONS(5336),
    [anon_sym_AMP_GT] = ACTIONS(5336),
    [anon_sym_AMP_GT_GT] = ACTIONS(5336),
    [anon_sym_LT_AMP] = ACTIONS(5336),
    [anon_sym_GT_AMP] = ACTIONS(5336),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(5338),
    [sym__special_characters] = ACTIONS(5340),
    [anon_sym_DQUOTE] = ACTIONS(5342),
    [anon_sym_DOLLAR] = ACTIONS(4472),
    [sym_raw_string] = ACTIONS(5344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5346),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5348),
    [anon_sym_BQUOTE] = ACTIONS(5350),
    [anon_sym_LT_LPAREN] = ACTIONS(5352),
    [anon_sym_GT_LPAREN] = ACTIONS(5352),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5344),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(995),
  },
  [2308] = {
    [sym__terminated_statement] = STATE(2306),
    [sym_for_statement] = STATE(2574),
    [sym_while_statement] = STATE(2574),
    [sym_if_statement] = STATE(2574),
    [sym_case_statement] = STATE(2574),
    [sym_function_definition] = STATE(2574),
    [sym_subshell] = STATE(2574),
    [sym_pipeline] = STATE(2574),
    [sym_list] = STATE(2574),
    [sym_negated_command] = STATE(2574),
    [sym_test_command] = STATE(2574),
    [sym_declaration_command] = STATE(2574),
    [sym_unset_command] = STATE(2574),
    [sym_command] = STATE(2574),
    [sym_command_name] = STATE(1935),
    [sym_variable_assignment] = STATE(2575),
    [sym_subscript] = STATE(1937),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1938),
    [sym_string] = STATE(1928),
    [sym_simple_expansion] = STATE(1928),
    [sym_string_expansion] = STATE(1928),
    [sym_expansion] = STATE(1928),
    [sym_command_substitution] = STATE(1928),
    [sym_process_substitution] = STATE(1928),
    [aux_sym_program_repeat1] = STATE(2306),
    [aux_sym_command_repeat1] = STATE(1940),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4448),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4450),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(5870),
    [anon_sym_SEMI_SEMI] = ACTIONS(5908),
    [anon_sym_function] = ACTIONS(4456),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4458),
    [anon_sym_LBRACK] = ACTIONS(4460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4462),
    [anon_sym_declare] = ACTIONS(4464),
    [anon_sym_typeset] = ACTIONS(4464),
    [anon_sym_export] = ACTIONS(4464),
    [anon_sym_readonly] = ACTIONS(4464),
    [anon_sym_local] = ACTIONS(4464),
    [anon_sym_unset] = ACTIONS(4466),
    [anon_sym_unsetenv] = ACTIONS(4466),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4468),
    [anon_sym_DQUOTE] = ACTIONS(4470),
    [anon_sym_DOLLAR] = ACTIONS(4472),
    [sym_raw_string] = ACTIONS(4474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4478),
    [anon_sym_BQUOTE] = ACTIONS(4480),
    [anon_sym_LT_LPAREN] = ACTIONS(4482),
    [anon_sym_GT_LPAREN] = ACTIONS(4482),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4484),
  },
  [2309] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_esac] = ACTIONS(5910),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(5912),
    [anon_sym_DQUOTE] = ACTIONS(5914),
    [anon_sym_DOLLAR] = ACTIONS(5912),
    [sym_raw_string] = ACTIONS(5914),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5914),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5914),
    [anon_sym_BQUOTE] = ACTIONS(5914),
    [anon_sym_LT_LPAREN] = ACTIONS(5914),
    [anon_sym_GT_LPAREN] = ACTIONS(5914),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5912),
  },
  [2310] = {
    [anon_sym_esac] = ACTIONS(5910),
    [sym__special_characters] = ACTIONS(5914),
    [anon_sym_DQUOTE] = ACTIONS(5914),
    [anon_sym_DOLLAR] = ACTIONS(5912),
    [sym_raw_string] = ACTIONS(5914),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5914),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5914),
    [anon_sym_BQUOTE] = ACTIONS(5914),
    [anon_sym_LT_LPAREN] = ACTIONS(5914),
    [anon_sym_GT_LPAREN] = ACTIONS(5914),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5912),
  },
  [2311] = {
    [anon_sym_esac] = ACTIONS(5910),
    [anon_sym_PIPE] = ACTIONS(5322),
    [anon_sym_SEMI_SEMI] = ACTIONS(5916),
    [anon_sym_PIPE_AMP] = ACTIONS(5322),
    [anon_sym_AMP_AMP] = ACTIONS(5326),
    [anon_sym_PIPE_PIPE] = ACTIONS(5326),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5328),
    [anon_sym_LF] = ACTIONS(5330),
    [anon_sym_AMP] = ACTIONS(5328),
  },
  [2312] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_esac] = ACTIONS(5910),
    [anon_sym_PIPE] = ACTIONS(5322),
    [anon_sym_SEMI_SEMI] = ACTIONS(5916),
    [anon_sym_PIPE_AMP] = ACTIONS(5322),
    [anon_sym_AMP_AMP] = ACTIONS(5326),
    [anon_sym_PIPE_PIPE] = ACTIONS(5326),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(5328),
    [anon_sym_LF] = ACTIONS(5330),
    [anon_sym_AMP] = ACTIONS(5328),
  },
  [2313] = {
    [sym__terminated_statement] = STATE(2306),
    [sym_for_statement] = STATE(2578),
    [sym_while_statement] = STATE(2578),
    [sym_if_statement] = STATE(2578),
    [sym_case_statement] = STATE(2578),
    [sym_function_definition] = STATE(2578),
    [sym_subshell] = STATE(2578),
    [sym_pipeline] = STATE(2578),
    [sym_list] = STATE(2578),
    [sym_negated_command] = STATE(2578),
    [sym_test_command] = STATE(2578),
    [sym_declaration_command] = STATE(2578),
    [sym_unset_command] = STATE(2578),
    [sym_command] = STATE(2578),
    [sym_command_name] = STATE(1935),
    [sym_variable_assignment] = STATE(2579),
    [sym_subscript] = STATE(1937),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(1938),
    [sym_string] = STATE(1928),
    [sym_simple_expansion] = STATE(1928),
    [sym_string_expansion] = STATE(1928),
    [sym_expansion] = STATE(1928),
    [sym_command_substitution] = STATE(1928),
    [sym_process_substitution] = STATE(1928),
    [aux_sym_program_repeat1] = STATE(2306),
    [aux_sym_command_repeat1] = STATE(1940),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4448),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4450),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(5910),
    [anon_sym_SEMI_SEMI] = ACTIONS(5918),
    [anon_sym_function] = ACTIONS(4456),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4458),
    [anon_sym_LBRACK] = ACTIONS(4460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4462),
    [anon_sym_declare] = ACTIONS(4464),
    [anon_sym_typeset] = ACTIONS(4464),
    [anon_sym_export] = ACTIONS(4464),
    [anon_sym_readonly] = ACTIONS(4464),
    [anon_sym_local] = ACTIONS(4464),
    [anon_sym_unset] = ACTIONS(4466),
    [anon_sym_unsetenv] = ACTIONS(4466),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4468),
    [anon_sym_DQUOTE] = ACTIONS(4470),
    [anon_sym_DOLLAR] = ACTIONS(4472),
    [sym_raw_string] = ACTIONS(4474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4478),
    [anon_sym_BQUOTE] = ACTIONS(4480),
    [anon_sym_LT_LPAREN] = ACTIONS(4482),
    [anon_sym_GT_LPAREN] = ACTIONS(4482),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4484),
  },
  [2314] = {
    [sym__terminated_statement] = STATE(2583),
    [sym_for_statement] = STATE(2581),
    [sym_while_statement] = STATE(2581),
    [sym_if_statement] = STATE(2581),
    [sym_case_statement] = STATE(2581),
    [sym_function_definition] = STATE(2581),
    [sym_subshell] = STATE(2581),
    [sym_pipeline] = STATE(2581),
    [sym_list] = STATE(2581),
    [sym_negated_command] = STATE(2581),
    [sym_test_command] = STATE(2581),
    [sym_declaration_command] = STATE(2581),
    [sym_unset_command] = STATE(2581),
    [sym_command] = STATE(2581),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2582),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2583),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(5920),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2315] = {
    [aux_sym_case_item_repeat1] = STATE(1942),
    [anon_sym_PIPE] = ACTIONS(3555),
    [anon_sym_RPAREN] = ACTIONS(5922),
    [sym_comment] = ACTIONS(53),
  },
  [2316] = {
    [sym__terminated_statement] = STATE(2588),
    [sym_for_statement] = STATE(2586),
    [sym_while_statement] = STATE(2586),
    [sym_if_statement] = STATE(2586),
    [sym_case_statement] = STATE(2586),
    [sym_function_definition] = STATE(2586),
    [sym_subshell] = STATE(2586),
    [sym_pipeline] = STATE(2586),
    [sym_list] = STATE(2586),
    [sym_negated_command] = STATE(2586),
    [sym_test_command] = STATE(2586),
    [sym_declaration_command] = STATE(2586),
    [sym_unset_command] = STATE(2586),
    [sym_command] = STATE(2586),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2587),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2588),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(5924),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2317] = {
    [aux_sym_case_item_repeat1] = STATE(1942),
    [anon_sym_PIPE] = ACTIONS(3555),
    [anon_sym_RPAREN] = ACTIONS(5926),
    [sym_comment] = ACTIONS(53),
  },
  [2318] = {
    [anon_sym_esac] = ACTIONS(5928),
    [anon_sym_PIPE] = ACTIONS(5928),
    [anon_sym_RPAREN] = ACTIONS(5928),
    [anon_sym_SEMI_SEMI] = ACTIONS(5928),
    [anon_sym_PIPE_AMP] = ACTIONS(5928),
    [anon_sym_AMP_AMP] = ACTIONS(5928),
    [anon_sym_PIPE_PIPE] = ACTIONS(5928),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5928),
    [anon_sym_LF] = ACTIONS(5930),
    [anon_sym_AMP] = ACTIONS(5928),
  },
  [2319] = {
    [anon_sym_esac] = ACTIONS(5932),
    [anon_sym_PIPE] = ACTIONS(5932),
    [anon_sym_RPAREN] = ACTIONS(5932),
    [anon_sym_SEMI_SEMI] = ACTIONS(5932),
    [anon_sym_PIPE_AMP] = ACTIONS(5932),
    [anon_sym_AMP_AMP] = ACTIONS(5932),
    [anon_sym_PIPE_PIPE] = ACTIONS(5932),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5932),
    [anon_sym_LF] = ACTIONS(5934),
    [anon_sym_AMP] = ACTIONS(5932),
  },
  [2320] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_in] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [2321] = {
    [sym__concat] = ACTIONS(5544),
    [anon_sym_in] = ACTIONS(5546),
    [anon_sym_SEMI_SEMI] = ACTIONS(5546),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5546),
    [anon_sym_LF] = ACTIONS(5544),
    [anon_sym_AMP] = ACTIONS(5546),
  },
  [2322] = {
    [sym__concat] = ACTIONS(5548),
    [anon_sym_in] = ACTIONS(5550),
    [anon_sym_SEMI_SEMI] = ACTIONS(5550),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5550),
    [anon_sym_LF] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
  },
  [2323] = {
    [aux_sym_concatenation_repeat1] = STATE(2323),
    [sym__concat] = ACTIONS(2612),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [2324] = {
    [aux_sym_concatenation_repeat1] = STATE(2324),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(5399),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1656),
    [anon_sym_LT_AMP] = ACTIONS(1656),
    [anon_sym_GT_AMP] = ACTIONS(1656),
    [anon_sym_LT_LT] = ACTIONS(1656),
    [anon_sym_LT_LT_DASH] = ACTIONS(1656),
    [anon_sym_LT_LT_LT] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [2325] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_AMP_AMP] = ACTIONS(5540),
    [anon_sym_PIPE_PIPE] = ACTIONS(5540),
    [anon_sym_RBRACK] = ACTIONS(5540),
    [anon_sym_EQ_TILDE] = ACTIONS(5540),
    [anon_sym_EQ_EQ] = ACTIONS(5540),
    [anon_sym_EQ] = ACTIONS(5542),
    [anon_sym_LT] = ACTIONS(5540),
    [anon_sym_GT] = ACTIONS(5540),
    [anon_sym_BANG_EQ] = ACTIONS(5540),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5540),
  },
  [2326] = {
    [sym__concat] = ACTIONS(5544),
    [anon_sym_AMP_AMP] = ACTIONS(5544),
    [anon_sym_PIPE_PIPE] = ACTIONS(5544),
    [anon_sym_RBRACK] = ACTIONS(5544),
    [anon_sym_EQ_TILDE] = ACTIONS(5544),
    [anon_sym_EQ_EQ] = ACTIONS(5544),
    [anon_sym_EQ] = ACTIONS(5546),
    [anon_sym_LT] = ACTIONS(5544),
    [anon_sym_GT] = ACTIONS(5544),
    [anon_sym_BANG_EQ] = ACTIONS(5544),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5544),
  },
  [2327] = {
    [sym__concat] = ACTIONS(5548),
    [anon_sym_AMP_AMP] = ACTIONS(5548),
    [anon_sym_PIPE_PIPE] = ACTIONS(5548),
    [anon_sym_RBRACK] = ACTIONS(5548),
    [anon_sym_EQ_TILDE] = ACTIONS(5548),
    [anon_sym_EQ_EQ] = ACTIONS(5548),
    [anon_sym_EQ] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5548),
    [anon_sym_GT] = ACTIONS(5548),
    [anon_sym_BANG_EQ] = ACTIONS(5548),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5548),
  },
  [2328] = {
    [sym_file_descriptor] = ACTIONS(2752),
    [sym__concat] = ACTIONS(2752),
    [anon_sym_esac] = ACTIONS(2754),
    [anon_sym_PIPE] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(2754),
    [anon_sym_SEMI_SEMI] = ACTIONS(2754),
    [anon_sym_PIPE_AMP] = ACTIONS(2754),
    [anon_sym_AMP_AMP] = ACTIONS(2754),
    [anon_sym_PIPE_PIPE] = ACTIONS(2754),
    [anon_sym_LT] = ACTIONS(2754),
    [anon_sym_GT] = ACTIONS(2754),
    [anon_sym_GT_GT] = ACTIONS(2754),
    [anon_sym_AMP_GT] = ACTIONS(2754),
    [anon_sym_AMP_GT_GT] = ACTIONS(2754),
    [anon_sym_LT_AMP] = ACTIONS(2754),
    [anon_sym_GT_AMP] = ACTIONS(2754),
    [anon_sym_LT_LT] = ACTIONS(2754),
    [anon_sym_LT_LT_DASH] = ACTIONS(2754),
    [anon_sym_LT_LT_LT] = ACTIONS(2754),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_LF] = ACTIONS(2752),
    [anon_sym_AMP] = ACTIONS(2754),
  },
  [2329] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5936),
    [sym_comment] = ACTIONS(53),
  },
  [2330] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5938),
    [sym_comment] = ACTIONS(53),
  },
  [2331] = {
    [anon_sym_RBRACE] = ACTIONS(5938),
    [sym_comment] = ACTIONS(53),
  },
  [2332] = {
    [sym_concatenation] = STATE(2593),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2593),
    [anon_sym_RBRACE] = ACTIONS(5940),
    [anon_sym_EQ] = ACTIONS(5942),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5944),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5942),
    [anon_sym_COLON_QMARK] = ACTIONS(5942),
    [anon_sym_COLON_DASH] = ACTIONS(5942),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_DASH] = ACTIONS(5942),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2333] = {
    [sym_file_descriptor] = ACTIONS(2830),
    [sym__concat] = ACTIONS(2830),
    [anon_sym_esac] = ACTIONS(2832),
    [anon_sym_PIPE] = ACTIONS(2832),
    [anon_sym_RPAREN] = ACTIONS(2832),
    [anon_sym_SEMI_SEMI] = ACTIONS(2832),
    [anon_sym_PIPE_AMP] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_PIPE_PIPE] = ACTIONS(2832),
    [anon_sym_LT] = ACTIONS(2832),
    [anon_sym_GT] = ACTIONS(2832),
    [anon_sym_GT_GT] = ACTIONS(2832),
    [anon_sym_AMP_GT] = ACTIONS(2832),
    [anon_sym_AMP_GT_GT] = ACTIONS(2832),
    [anon_sym_LT_AMP] = ACTIONS(2832),
    [anon_sym_GT_AMP] = ACTIONS(2832),
    [anon_sym_LT_LT] = ACTIONS(2832),
    [anon_sym_LT_LT_DASH] = ACTIONS(2832),
    [anon_sym_LT_LT_LT] = ACTIONS(2832),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2832),
    [anon_sym_LF] = ACTIONS(2830),
    [anon_sym_AMP] = ACTIONS(2832),
  },
  [2334] = {
    [sym_concatenation] = STATE(2596),
    [sym_string] = STATE(2595),
    [sym_simple_expansion] = STATE(2595),
    [sym_string_expansion] = STATE(2595),
    [sym_expansion] = STATE(2595),
    [sym_command_substitution] = STATE(2595),
    [sym_process_substitution] = STATE(2595),
    [anon_sym_RBRACE] = ACTIONS(5938),
    [sym__special_characters] = ACTIONS(5946),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(5948),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5948),
  },
  [2335] = {
    [sym_file_descriptor] = ACTIONS(2873),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_esac] = ACTIONS(2875),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [anon_sym_PIPE_AMP] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT_GT] = ACTIONS(2875),
    [anon_sym_LT_AMP] = ACTIONS(2875),
    [anon_sym_GT_AMP] = ACTIONS(2875),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_LT_LT_DASH] = ACTIONS(2875),
    [anon_sym_LT_LT_LT] = ACTIONS(2875),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [2336] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5950),
  },
  [2337] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5952),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2338] = {
    [sym_file_descriptor] = ACTIONS(2881),
    [sym__concat] = ACTIONS(2881),
    [anon_sym_esac] = ACTIONS(2883),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_RPAREN] = ACTIONS(2883),
    [anon_sym_SEMI_SEMI] = ACTIONS(2883),
    [anon_sym_PIPE_AMP] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_GT_GT] = ACTIONS(2883),
    [anon_sym_AMP_GT] = ACTIONS(2883),
    [anon_sym_AMP_GT_GT] = ACTIONS(2883),
    [anon_sym_LT_AMP] = ACTIONS(2883),
    [anon_sym_GT_AMP] = ACTIONS(2883),
    [anon_sym_LT_LT] = ACTIONS(2883),
    [anon_sym_LT_LT_DASH] = ACTIONS(2883),
    [anon_sym_LT_LT_LT] = ACTIONS(2883),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_LF] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
  },
  [2339] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5954),
  },
  [2340] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5956),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2341] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(5958),
  },
  [2342] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5938),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2343] = {
    [sym_concatenation] = STATE(2603),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2603),
    [anon_sym_RBRACE] = ACTIONS(5960),
    [anon_sym_EQ] = ACTIONS(5962),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5962),
    [anon_sym_COLON_QMARK] = ACTIONS(5962),
    [anon_sym_COLON_DASH] = ACTIONS(5962),
    [anon_sym_PERCENT] = ACTIONS(5962),
    [anon_sym_DASH] = ACTIONS(5962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2344] = {
    [sym_file_descriptor] = ACTIONS(2897),
    [sym__concat] = ACTIONS(2897),
    [anon_sym_esac] = ACTIONS(2899),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_RPAREN] = ACTIONS(2899),
    [anon_sym_SEMI_SEMI] = ACTIONS(2899),
    [anon_sym_PIPE_AMP] = ACTIONS(2899),
    [anon_sym_AMP_AMP] = ACTIONS(2899),
    [anon_sym_PIPE_PIPE] = ACTIONS(2899),
    [anon_sym_LT] = ACTIONS(2899),
    [anon_sym_GT] = ACTIONS(2899),
    [anon_sym_GT_GT] = ACTIONS(2899),
    [anon_sym_AMP_GT] = ACTIONS(2899),
    [anon_sym_AMP_GT_GT] = ACTIONS(2899),
    [anon_sym_LT_AMP] = ACTIONS(2899),
    [anon_sym_GT_AMP] = ACTIONS(2899),
    [anon_sym_LT_LT] = ACTIONS(2899),
    [anon_sym_LT_LT_DASH] = ACTIONS(2899),
    [anon_sym_LT_LT_LT] = ACTIONS(2899),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LF] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2899),
  },
  [2345] = {
    [sym_concatenation] = STATE(2605),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2605),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_EQ] = ACTIONS(5968),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5970),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5968),
    [anon_sym_COLON_QMARK] = ACTIONS(5968),
    [anon_sym_COLON_DASH] = ACTIONS(5968),
    [anon_sym_PERCENT] = ACTIONS(5968),
    [anon_sym_DASH] = ACTIONS(5968),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2346] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_RPAREN] = ACTIONS(5540),
    [anon_sym_AMP_AMP] = ACTIONS(5540),
    [anon_sym_PIPE_PIPE] = ACTIONS(5540),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5540),
    [anon_sym_EQ_TILDE] = ACTIONS(5540),
    [anon_sym_EQ_EQ] = ACTIONS(5540),
    [anon_sym_EQ] = ACTIONS(5542),
    [anon_sym_LT] = ACTIONS(5540),
    [anon_sym_GT] = ACTIONS(5540),
    [anon_sym_BANG_EQ] = ACTIONS(5540),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5540),
  },
  [2347] = {
    [sym__concat] = ACTIONS(5544),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_RPAREN] = ACTIONS(5544),
    [anon_sym_AMP_AMP] = ACTIONS(5544),
    [anon_sym_PIPE_PIPE] = ACTIONS(5544),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5544),
    [anon_sym_EQ_TILDE] = ACTIONS(5544),
    [anon_sym_EQ_EQ] = ACTIONS(5544),
    [anon_sym_EQ] = ACTIONS(5546),
    [anon_sym_LT] = ACTIONS(5544),
    [anon_sym_GT] = ACTIONS(5544),
    [anon_sym_BANG_EQ] = ACTIONS(5544),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5544),
  },
  [2348] = {
    [sym__concat] = ACTIONS(5548),
    [anon_sym_PIPE] = ACTIONS(5550),
    [anon_sym_RPAREN] = ACTIONS(5548),
    [anon_sym_AMP_AMP] = ACTIONS(5548),
    [anon_sym_PIPE_PIPE] = ACTIONS(5548),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5548),
    [anon_sym_EQ_TILDE] = ACTIONS(5548),
    [anon_sym_EQ_EQ] = ACTIONS(5548),
    [anon_sym_EQ] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5548),
    [anon_sym_GT] = ACTIONS(5548),
    [anon_sym_BANG_EQ] = ACTIONS(5548),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5548),
  },
  [2349] = {
    [sym__concat] = ACTIONS(5540),
    [sym_variable_name] = ACTIONS(5540),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_RPAREN] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [anon_sym_PIPE_AMP] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE] = ACTIONS(5542),
    [sym__special_characters] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [anon_sym_LT_LPAREN] = ACTIONS(5542),
    [anon_sym_GT_LPAREN] = ACTIONS(5542),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5542),
    [sym_word] = ACTIONS(5542),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [2350] = {
    [sym__concat] = ACTIONS(5544),
    [sym_variable_name] = ACTIONS(5544),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_RPAREN] = ACTIONS(5546),
    [anon_sym_SEMI_SEMI] = ACTIONS(5546),
    [anon_sym_PIPE_AMP] = ACTIONS(5546),
    [anon_sym_AMP_AMP] = ACTIONS(5546),
    [anon_sym_PIPE_PIPE] = ACTIONS(5546),
    [sym__special_characters] = ACTIONS(5546),
    [anon_sym_DQUOTE] = ACTIONS(5546),
    [anon_sym_DOLLAR] = ACTIONS(5546),
    [sym_raw_string] = ACTIONS(5546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5546),
    [anon_sym_BQUOTE] = ACTIONS(5546),
    [anon_sym_LT_LPAREN] = ACTIONS(5546),
    [anon_sym_GT_LPAREN] = ACTIONS(5546),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5546),
    [sym_word] = ACTIONS(5546),
    [anon_sym_SEMI] = ACTIONS(5546),
    [anon_sym_LF] = ACTIONS(5544),
    [anon_sym_AMP] = ACTIONS(5546),
  },
  [2351] = {
    [sym__concat] = ACTIONS(5548),
    [sym_variable_name] = ACTIONS(5548),
    [anon_sym_PIPE] = ACTIONS(5550),
    [anon_sym_RPAREN] = ACTIONS(5550),
    [anon_sym_SEMI_SEMI] = ACTIONS(5550),
    [anon_sym_PIPE_AMP] = ACTIONS(5550),
    [anon_sym_AMP_AMP] = ACTIONS(5550),
    [anon_sym_PIPE_PIPE] = ACTIONS(5550),
    [sym__special_characters] = ACTIONS(5550),
    [anon_sym_DQUOTE] = ACTIONS(5550),
    [anon_sym_DOLLAR] = ACTIONS(5550),
    [sym_raw_string] = ACTIONS(5550),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5550),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5550),
    [anon_sym_BQUOTE] = ACTIONS(5550),
    [anon_sym_LT_LPAREN] = ACTIONS(5550),
    [anon_sym_GT_LPAREN] = ACTIONS(5550),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5550),
    [sym_word] = ACTIONS(5550),
    [anon_sym_SEMI] = ACTIONS(5550),
    [anon_sym_LF] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
  },
  [2352] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_RPAREN] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [anon_sym_PIPE_AMP] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE] = ACTIONS(5542),
    [sym__special_characters] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [anon_sym_LT_LPAREN] = ACTIONS(5542),
    [anon_sym_GT_LPAREN] = ACTIONS(5542),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5542),
    [sym_word] = ACTIONS(5542),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [2353] = {
    [sym__concat] = ACTIONS(5544),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_RPAREN] = ACTIONS(5546),
    [anon_sym_SEMI_SEMI] = ACTIONS(5546),
    [anon_sym_PIPE_AMP] = ACTIONS(5546),
    [anon_sym_AMP_AMP] = ACTIONS(5546),
    [anon_sym_PIPE_PIPE] = ACTIONS(5546),
    [sym__special_characters] = ACTIONS(5546),
    [anon_sym_DQUOTE] = ACTIONS(5546),
    [anon_sym_DOLLAR] = ACTIONS(5546),
    [sym_raw_string] = ACTIONS(5546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5546),
    [anon_sym_BQUOTE] = ACTIONS(5546),
    [anon_sym_LT_LPAREN] = ACTIONS(5546),
    [anon_sym_GT_LPAREN] = ACTIONS(5546),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5546),
    [sym_word] = ACTIONS(5546),
    [anon_sym_SEMI] = ACTIONS(5546),
    [anon_sym_LF] = ACTIONS(5544),
    [anon_sym_AMP] = ACTIONS(5546),
  },
  [2354] = {
    [sym__concat] = ACTIONS(5548),
    [anon_sym_PIPE] = ACTIONS(5550),
    [anon_sym_RPAREN] = ACTIONS(5550),
    [anon_sym_SEMI_SEMI] = ACTIONS(5550),
    [anon_sym_PIPE_AMP] = ACTIONS(5550),
    [anon_sym_AMP_AMP] = ACTIONS(5550),
    [anon_sym_PIPE_PIPE] = ACTIONS(5550),
    [sym__special_characters] = ACTIONS(5550),
    [anon_sym_DQUOTE] = ACTIONS(5550),
    [anon_sym_DOLLAR] = ACTIONS(5550),
    [sym_raw_string] = ACTIONS(5550),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5550),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5550),
    [anon_sym_BQUOTE] = ACTIONS(5550),
    [anon_sym_LT_LPAREN] = ACTIONS(5550),
    [anon_sym_GT_LPAREN] = ACTIONS(5550),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5550),
    [sym_word] = ACTIONS(5550),
    [anon_sym_SEMI] = ACTIONS(5550),
    [anon_sym_LF] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
  },
  [2355] = {
    [sym_file_descriptor] = ACTIONS(5540),
    [sym__concat] = ACTIONS(5540),
    [sym_variable_name] = ACTIONS(5540),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_RPAREN] = ACTIONS(5540),
    [anon_sym_PIPE_AMP] = ACTIONS(5540),
    [anon_sym_AMP_AMP] = ACTIONS(5540),
    [anon_sym_PIPE_PIPE] = ACTIONS(5540),
    [anon_sym_LT] = ACTIONS(5542),
    [anon_sym_GT] = ACTIONS(5542),
    [anon_sym_GT_GT] = ACTIONS(5540),
    [anon_sym_AMP_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT_GT] = ACTIONS(5540),
    [anon_sym_LT_AMP] = ACTIONS(5540),
    [anon_sym_GT_AMP] = ACTIONS(5540),
    [sym__special_characters] = ACTIONS(5540),
    [anon_sym_DQUOTE] = ACTIONS(5540),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5540),
    [anon_sym_BQUOTE] = ACTIONS(5540),
    [anon_sym_LT_LPAREN] = ACTIONS(5540),
    [anon_sym_GT_LPAREN] = ACTIONS(5540),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5540),
  },
  [2356] = {
    [sym_file_descriptor] = ACTIONS(5544),
    [sym__concat] = ACTIONS(5544),
    [sym_variable_name] = ACTIONS(5544),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_RPAREN] = ACTIONS(5544),
    [anon_sym_PIPE_AMP] = ACTIONS(5544),
    [anon_sym_AMP_AMP] = ACTIONS(5544),
    [anon_sym_PIPE_PIPE] = ACTIONS(5544),
    [anon_sym_LT] = ACTIONS(5546),
    [anon_sym_GT] = ACTIONS(5546),
    [anon_sym_GT_GT] = ACTIONS(5544),
    [anon_sym_AMP_GT] = ACTIONS(5546),
    [anon_sym_AMP_GT_GT] = ACTIONS(5544),
    [anon_sym_LT_AMP] = ACTIONS(5544),
    [anon_sym_GT_AMP] = ACTIONS(5544),
    [sym__special_characters] = ACTIONS(5544),
    [anon_sym_DQUOTE] = ACTIONS(5544),
    [anon_sym_DOLLAR] = ACTIONS(5546),
    [sym_raw_string] = ACTIONS(5544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5544),
    [anon_sym_BQUOTE] = ACTIONS(5544),
    [anon_sym_LT_LPAREN] = ACTIONS(5544),
    [anon_sym_GT_LPAREN] = ACTIONS(5544),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5544),
  },
  [2357] = {
    [sym_file_descriptor] = ACTIONS(5548),
    [sym__concat] = ACTIONS(5548),
    [sym_variable_name] = ACTIONS(5548),
    [anon_sym_PIPE] = ACTIONS(5550),
    [anon_sym_RPAREN] = ACTIONS(5548),
    [anon_sym_PIPE_AMP] = ACTIONS(5548),
    [anon_sym_AMP_AMP] = ACTIONS(5548),
    [anon_sym_PIPE_PIPE] = ACTIONS(5548),
    [anon_sym_LT] = ACTIONS(5550),
    [anon_sym_GT] = ACTIONS(5550),
    [anon_sym_GT_GT] = ACTIONS(5548),
    [anon_sym_AMP_GT] = ACTIONS(5550),
    [anon_sym_AMP_GT_GT] = ACTIONS(5548),
    [anon_sym_LT_AMP] = ACTIONS(5548),
    [anon_sym_GT_AMP] = ACTIONS(5548),
    [sym__special_characters] = ACTIONS(5548),
    [anon_sym_DQUOTE] = ACTIONS(5548),
    [anon_sym_DOLLAR] = ACTIONS(5550),
    [sym_raw_string] = ACTIONS(5548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5548),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5548),
    [anon_sym_BQUOTE] = ACTIONS(5548),
    [anon_sym_LT_LPAREN] = ACTIONS(5548),
    [anon_sym_GT_LPAREN] = ACTIONS(5548),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5548),
  },
  [2358] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym__string_content] = ACTIONS(5540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [sym_comment] = ACTIONS(177),
  },
  [2359] = {
    [sym__concat] = ACTIONS(5544),
    [anon_sym_DQUOTE] = ACTIONS(5546),
    [anon_sym_DOLLAR] = ACTIONS(5546),
    [sym__string_content] = ACTIONS(5544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5546),
    [anon_sym_BQUOTE] = ACTIONS(5546),
    [sym_comment] = ACTIONS(177),
  },
  [2360] = {
    [sym__concat] = ACTIONS(5548),
    [anon_sym_DQUOTE] = ACTIONS(5550),
    [anon_sym_DOLLAR] = ACTIONS(5550),
    [sym__string_content] = ACTIONS(5548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5550),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5550),
    [anon_sym_BQUOTE] = ACTIONS(5550),
    [sym_comment] = ACTIONS(177),
  },
  [2361] = {
    [sym__concat] = ACTIONS(3917),
    [anon_sym_RBRACE] = ACTIONS(3917),
    [sym_comment] = ACTIONS(53),
  },
  [2362] = {
    [sym__concat] = ACTIONS(3923),
    [anon_sym_RBRACE] = ACTIONS(3923),
    [sym_comment] = ACTIONS(53),
  },
  [2363] = {
    [sym__concat] = ACTIONS(4008),
    [anon_sym_RBRACE] = ACTIONS(4008),
    [sym_comment] = ACTIONS(53),
  },
  [2364] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5972),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2365] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5974),
    [sym_comment] = ACTIONS(53),
  },
  [2366] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(5976),
    [sym_comment] = ACTIONS(53),
  },
  [2367] = {
    [anon_sym_RBRACE] = ACTIONS(5976),
    [sym_comment] = ACTIONS(53),
  },
  [2368] = {
    [sym_concatenation] = STATE(2610),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2610),
    [anon_sym_RBRACE] = ACTIONS(5978),
    [anon_sym_EQ] = ACTIONS(5980),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5982),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5980),
    [anon_sym_COLON_QMARK] = ACTIONS(5980),
    [anon_sym_COLON_DASH] = ACTIONS(5980),
    [anon_sym_PERCENT] = ACTIONS(5980),
    [anon_sym_DASH] = ACTIONS(5980),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2369] = {
    [sym__concat] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [sym_comment] = ACTIONS(53),
  },
  [2370] = {
    [sym_concatenation] = STATE(2612),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2612),
    [anon_sym_RBRACE] = ACTIONS(5984),
    [anon_sym_EQ] = ACTIONS(5986),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5988),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5986),
    [anon_sym_COLON_QMARK] = ACTIONS(5986),
    [anon_sym_COLON_DASH] = ACTIONS(5986),
    [anon_sym_PERCENT] = ACTIONS(5986),
    [anon_sym_DASH] = ACTIONS(5986),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2371] = {
    [sym__concat] = ACTIONS(4034),
    [anon_sym_RBRACE] = ACTIONS(4034),
    [sym_comment] = ACTIONS(53),
  },
  [2372] = {
    [sym_concatenation] = STATE(2614),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2614),
    [anon_sym_RBRACE] = ACTIONS(5990),
    [anon_sym_EQ] = ACTIONS(5992),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(5994),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(5992),
    [anon_sym_COLON_QMARK] = ACTIONS(5992),
    [anon_sym_COLON_DASH] = ACTIONS(5992),
    [anon_sym_PERCENT] = ACTIONS(5992),
    [anon_sym_DASH] = ACTIONS(5992),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2373] = {
    [sym__concat] = ACTIONS(4044),
    [anon_sym_RBRACE] = ACTIONS(4044),
    [sym_comment] = ACTIONS(53),
  },
  [2374] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5996),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2375] = {
    [sym__concat] = ACTIONS(4050),
    [anon_sym_RBRACE] = ACTIONS(4050),
    [sym_comment] = ACTIONS(53),
  },
  [2376] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(5998),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2377] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_RBRACE] = ACTIONS(4884),
    [anon_sym_EQ] = ACTIONS(4886),
    [sym__special_characters] = ACTIONS(4886),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4884),
    [anon_sym_POUND] = ACTIONS(4884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4884),
    [anon_sym_COLON] = ACTIONS(4886),
    [anon_sym_COLON_QMARK] = ACTIONS(4886),
    [anon_sym_COLON_DASH] = ACTIONS(4886),
    [anon_sym_PERCENT] = ACTIONS(4886),
    [anon_sym_DASH] = ACTIONS(4886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4884),
    [anon_sym_BQUOTE] = ACTIONS(4884),
    [anon_sym_LT_LPAREN] = ACTIONS(4884),
    [anon_sym_GT_LPAREN] = ACTIONS(4884),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4886),
  },
  [2378] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_RBRACE] = ACTIONS(4888),
    [anon_sym_EQ] = ACTIONS(4890),
    [sym__special_characters] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4888),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4888),
    [anon_sym_POUND] = ACTIONS(4888),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4888),
    [anon_sym_COLON] = ACTIONS(4890),
    [anon_sym_COLON_QMARK] = ACTIONS(4890),
    [anon_sym_COLON_DASH] = ACTIONS(4890),
    [anon_sym_PERCENT] = ACTIONS(4890),
    [anon_sym_DASH] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4888),
    [anon_sym_BQUOTE] = ACTIONS(4888),
    [anon_sym_LT_LPAREN] = ACTIONS(4888),
    [anon_sym_GT_LPAREN] = ACTIONS(4888),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4890),
  },
  [2379] = {
    [sym__concat] = ACTIONS(4892),
    [anon_sym_RBRACE] = ACTIONS(4892),
    [anon_sym_EQ] = ACTIONS(4894),
    [sym__special_characters] = ACTIONS(4894),
    [anon_sym_DQUOTE] = ACTIONS(4892),
    [anon_sym_DOLLAR] = ACTIONS(4894),
    [sym_raw_string] = ACTIONS(4892),
    [anon_sym_POUND] = ACTIONS(4892),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4892),
    [anon_sym_COLON] = ACTIONS(4894),
    [anon_sym_COLON_QMARK] = ACTIONS(4894),
    [anon_sym_COLON_DASH] = ACTIONS(4894),
    [anon_sym_PERCENT] = ACTIONS(4894),
    [anon_sym_DASH] = ACTIONS(4894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4892),
    [anon_sym_BQUOTE] = ACTIONS(4892),
    [anon_sym_LT_LPAREN] = ACTIONS(4892),
    [anon_sym_GT_LPAREN] = ACTIONS(4892),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4894),
  },
  [2380] = {
    [sym__concat] = ACTIONS(4896),
    [anon_sym_RBRACE] = ACTIONS(4896),
    [anon_sym_EQ] = ACTIONS(4898),
    [sym__special_characters] = ACTIONS(4898),
    [anon_sym_DQUOTE] = ACTIONS(4896),
    [anon_sym_DOLLAR] = ACTIONS(4898),
    [sym_raw_string] = ACTIONS(4896),
    [anon_sym_POUND] = ACTIONS(4896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4896),
    [anon_sym_COLON] = ACTIONS(4898),
    [anon_sym_COLON_QMARK] = ACTIONS(4898),
    [anon_sym_COLON_DASH] = ACTIONS(4898),
    [anon_sym_PERCENT] = ACTIONS(4898),
    [anon_sym_DASH] = ACTIONS(4898),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4896),
    [anon_sym_BQUOTE] = ACTIONS(4896),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4898),
  },
  [2381] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6000),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2382] = {
    [sym__concat] = ACTIONS(4902),
    [anon_sym_RBRACE] = ACTIONS(4902),
    [anon_sym_EQ] = ACTIONS(4904),
    [sym__special_characters] = ACTIONS(4904),
    [anon_sym_DQUOTE] = ACTIONS(4902),
    [anon_sym_DOLLAR] = ACTIONS(4904),
    [sym_raw_string] = ACTIONS(4902),
    [anon_sym_POUND] = ACTIONS(4902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4902),
    [anon_sym_COLON] = ACTIONS(4904),
    [anon_sym_COLON_QMARK] = ACTIONS(4904),
    [anon_sym_COLON_DASH] = ACTIONS(4904),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [anon_sym_DASH] = ACTIONS(4904),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4902),
    [anon_sym_BQUOTE] = ACTIONS(4902),
    [anon_sym_LT_LPAREN] = ACTIONS(4902),
    [anon_sym_GT_LPAREN] = ACTIONS(4902),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4904),
  },
  [2383] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6002),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2384] = {
    [sym__concat] = ACTIONS(4908),
    [anon_sym_RBRACE] = ACTIONS(4908),
    [anon_sym_EQ] = ACTIONS(4910),
    [sym__special_characters] = ACTIONS(4910),
    [anon_sym_DQUOTE] = ACTIONS(4908),
    [anon_sym_DOLLAR] = ACTIONS(4910),
    [sym_raw_string] = ACTIONS(4908),
    [anon_sym_POUND] = ACTIONS(4908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4908),
    [anon_sym_COLON] = ACTIONS(4910),
    [anon_sym_COLON_QMARK] = ACTIONS(4910),
    [anon_sym_COLON_DASH] = ACTIONS(4910),
    [anon_sym_PERCENT] = ACTIONS(4910),
    [anon_sym_DASH] = ACTIONS(4910),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4908),
    [anon_sym_BQUOTE] = ACTIONS(4908),
    [anon_sym_LT_LPAREN] = ACTIONS(4908),
    [anon_sym_GT_LPAREN] = ACTIONS(4908),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4910),
  },
  [2385] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6004),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2386] = {
    [sym__concat] = ACTIONS(4914),
    [anon_sym_RBRACE] = ACTIONS(4914),
    [anon_sym_EQ] = ACTIONS(4916),
    [sym__special_characters] = ACTIONS(4916),
    [anon_sym_DQUOTE] = ACTIONS(4914),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(4914),
    [anon_sym_POUND] = ACTIONS(4914),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4914),
    [anon_sym_COLON] = ACTIONS(4916),
    [anon_sym_COLON_QMARK] = ACTIONS(4916),
    [anon_sym_COLON_DASH] = ACTIONS(4916),
    [anon_sym_PERCENT] = ACTIONS(4916),
    [anon_sym_DASH] = ACTIONS(4916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4914),
    [anon_sym_BQUOTE] = ACTIONS(4914),
    [anon_sym_LT_LPAREN] = ACTIONS(4914),
    [anon_sym_GT_LPAREN] = ACTIONS(4914),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4916),
  },
  [2387] = {
    [sym__concat] = ACTIONS(4918),
    [anon_sym_RBRACE] = ACTIONS(4918),
    [anon_sym_EQ] = ACTIONS(4920),
    [sym__special_characters] = ACTIONS(4920),
    [anon_sym_DQUOTE] = ACTIONS(4918),
    [anon_sym_DOLLAR] = ACTIONS(4920),
    [sym_raw_string] = ACTIONS(4918),
    [anon_sym_POUND] = ACTIONS(4918),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4918),
    [anon_sym_COLON] = ACTIONS(4920),
    [anon_sym_COLON_QMARK] = ACTIONS(4920),
    [anon_sym_COLON_DASH] = ACTIONS(4920),
    [anon_sym_PERCENT] = ACTIONS(4920),
    [anon_sym_DASH] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4918),
    [anon_sym_BQUOTE] = ACTIONS(4918),
    [anon_sym_LT_LPAREN] = ACTIONS(4918),
    [anon_sym_GT_LPAREN] = ACTIONS(4918),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4920),
  },
  [2388] = {
    [anon_sym_PIPE] = ACTIONS(5242),
    [anon_sym_RPAREN] = ACTIONS(5244),
    [anon_sym_PIPE_AMP] = ACTIONS(5244),
    [anon_sym_AMP_AMP] = ACTIONS(5244),
    [anon_sym_PIPE_PIPE] = ACTIONS(5244),
    [anon_sym_BQUOTE] = ACTIONS(5244),
    [sym_comment] = ACTIONS(53),
  },
  [2389] = {
    [anon_sym_PIPE] = ACTIONS(5371),
    [anon_sym_RPAREN] = ACTIONS(5373),
    [anon_sym_PIPE_AMP] = ACTIONS(5373),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_PIPE_PIPE] = ACTIONS(5373),
    [anon_sym_BQUOTE] = ACTIONS(5373),
    [sym_comment] = ACTIONS(53),
  },
  [2390] = {
    [anon_sym_esac] = ACTIONS(6006),
    [sym_comment] = ACTIONS(53),
  },
  [2391] = {
    [anon_sym_PIPE] = ACTIONS(5381),
    [anon_sym_RPAREN] = ACTIONS(5383),
    [anon_sym_PIPE_AMP] = ACTIONS(5383),
    [anon_sym_AMP_AMP] = ACTIONS(5383),
    [anon_sym_PIPE_PIPE] = ACTIONS(5383),
    [anon_sym_BQUOTE] = ACTIONS(5383),
    [sym_comment] = ACTIONS(53),
  },
  [2392] = {
    [anon_sym_esac] = ACTIONS(6008),
    [sym_comment] = ACTIONS(53),
  },
  [2393] = {
    [aux_sym_concatenation_repeat1] = STATE(2393),
    [sym__concat] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1654),
    [anon_sym_PIPE_AMP] = ACTIONS(1654),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
  },
  [2394] = {
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(1654),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1654),
    [anon_sym_PIPE_AMP] = ACTIONS(1654),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1654),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1654),
    [anon_sym_LT_AMP] = ACTIONS(1654),
    [anon_sym_GT_AMP] = ACTIONS(1654),
    [anon_sym_LT_LT] = ACTIONS(1656),
    [anon_sym_LT_LT_DASH] = ACTIONS(1654),
    [anon_sym_LT_LT_LT] = ACTIONS(1654),
    [anon_sym_BQUOTE] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
  },
  [2395] = {
    [aux_sym_concatenation_repeat1] = STATE(2395),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(6010),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1654),
    [anon_sym_PIPE_AMP] = ACTIONS(1654),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1654),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1654),
    [anon_sym_LT_AMP] = ACTIONS(1654),
    [anon_sym_GT_AMP] = ACTIONS(1654),
    [anon_sym_LT_LT] = ACTIONS(1656),
    [anon_sym_LT_LT_DASH] = ACTIONS(1654),
    [anon_sym_LT_LT_LT] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
  },
  [2396] = {
    [sym_file_descriptor] = ACTIONS(1703),
    [sym__concat] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_PIPE_AMP] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_LT] = ACTIONS(1705),
    [anon_sym_GT] = ACTIONS(1705),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_AMP_GT] = ACTIONS(1705),
    [anon_sym_AMP_GT_GT] = ACTIONS(1703),
    [anon_sym_LT_AMP] = ACTIONS(1703),
    [anon_sym_GT_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1705),
    [anon_sym_LT_LT_DASH] = ACTIONS(1703),
    [anon_sym_LT_LT_LT] = ACTIONS(1703),
    [anon_sym_BQUOTE] = ACTIONS(1703),
    [sym_comment] = ACTIONS(53),
  },
  [2397] = {
    [sym_concatenation] = STATE(2625),
    [sym_string] = STATE(2624),
    [sym_simple_expansion] = STATE(2624),
    [sym_string_expansion] = STATE(2624),
    [sym_expansion] = STATE(2624),
    [sym_command_substitution] = STATE(2624),
    [sym_process_substitution] = STATE(2624),
    [anon_sym_RBRACE] = ACTIONS(6013),
    [sym__special_characters] = ACTIONS(6015),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(6017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6017),
  },
  [2398] = {
    [sym_file_descriptor] = ACTIONS(1744),
    [sym__concat] = ACTIONS(1744),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_RPAREN] = ACTIONS(1744),
    [anon_sym_PIPE_AMP] = ACTIONS(1744),
    [anon_sym_AMP_AMP] = ACTIONS(1744),
    [anon_sym_PIPE_PIPE] = ACTIONS(1744),
    [anon_sym_LT] = ACTIONS(1746),
    [anon_sym_GT] = ACTIONS(1746),
    [anon_sym_GT_GT] = ACTIONS(1744),
    [anon_sym_AMP_GT] = ACTIONS(1746),
    [anon_sym_AMP_GT_GT] = ACTIONS(1744),
    [anon_sym_LT_AMP] = ACTIONS(1744),
    [anon_sym_GT_AMP] = ACTIONS(1744),
    [anon_sym_LT_LT] = ACTIONS(1746),
    [anon_sym_LT_LT_DASH] = ACTIONS(1744),
    [anon_sym_LT_LT_LT] = ACTIONS(1744),
    [anon_sym_BQUOTE] = ACTIONS(1744),
    [sym_comment] = ACTIONS(53),
  },
  [2399] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6019),
  },
  [2400] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6021),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2401] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(6023),
    [sym_comment] = ACTIONS(53),
  },
  [2402] = {
    [sym_concatenation] = STATE(2631),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2631),
    [anon_sym_RBRACE] = ACTIONS(6025),
    [anon_sym_EQ] = ACTIONS(6027),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6029),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6031),
    [anon_sym_COLON] = ACTIONS(6027),
    [anon_sym_COLON_QMARK] = ACTIONS(6027),
    [anon_sym_COLON_DASH] = ACTIONS(6027),
    [anon_sym_PERCENT] = ACTIONS(6027),
    [anon_sym_DASH] = ACTIONS(6027),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2403] = {
    [sym_concatenation] = STATE(2634),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2634),
    [anon_sym_RBRACE] = ACTIONS(6033),
    [anon_sym_EQ] = ACTIONS(6035),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6037),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6039),
    [anon_sym_COLON] = ACTIONS(6035),
    [anon_sym_COLON_QMARK] = ACTIONS(6035),
    [anon_sym_COLON_DASH] = ACTIONS(6035),
    [anon_sym_PERCENT] = ACTIONS(6035),
    [anon_sym_DASH] = ACTIONS(6035),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2404] = {
    [sym_concatenation] = STATE(2636),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2636),
    [anon_sym_RBRACE] = ACTIONS(6013),
    [anon_sym_EQ] = ACTIONS(6041),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6045),
    [anon_sym_COLON] = ACTIONS(6041),
    [anon_sym_COLON_QMARK] = ACTIONS(6041),
    [anon_sym_COLON_DASH] = ACTIONS(6041),
    [anon_sym_PERCENT] = ACTIONS(6041),
    [anon_sym_DASH] = ACTIONS(6041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2405] = {
    [sym_file_descriptor] = ACTIONS(1810),
    [sym__concat] = ACTIONS(1810),
    [anon_sym_PIPE] = ACTIONS(1812),
    [anon_sym_RPAREN] = ACTIONS(1810),
    [anon_sym_PIPE_AMP] = ACTIONS(1810),
    [anon_sym_AMP_AMP] = ACTIONS(1810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1810),
    [anon_sym_LT] = ACTIONS(1812),
    [anon_sym_GT] = ACTIONS(1812),
    [anon_sym_GT_GT] = ACTIONS(1810),
    [anon_sym_AMP_GT] = ACTIONS(1812),
    [anon_sym_AMP_GT_GT] = ACTIONS(1810),
    [anon_sym_LT_AMP] = ACTIONS(1810),
    [anon_sym_GT_AMP] = ACTIONS(1810),
    [anon_sym_LT_LT] = ACTIONS(1812),
    [anon_sym_LT_LT_DASH] = ACTIONS(1810),
    [anon_sym_LT_LT_LT] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(53),
  },
  [2406] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6047),
  },
  [2407] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6049),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2408] = {
    [sym_file_descriptor] = ACTIONS(1818),
    [sym__concat] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1820),
    [anon_sym_RPAREN] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1820),
    [anon_sym_GT] = ACTIONS(1820),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT] = ACTIONS(1820),
    [anon_sym_AMP_GT_GT] = ACTIONS(1818),
    [anon_sym_LT_AMP] = ACTIONS(1818),
    [anon_sym_GT_AMP] = ACTIONS(1818),
    [anon_sym_LT_LT] = ACTIONS(1820),
    [anon_sym_LT_LT_DASH] = ACTIONS(1818),
    [anon_sym_LT_LT_LT] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(1818),
    [sym_comment] = ACTIONS(53),
  },
  [2409] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6051),
  },
  [2410] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6013),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2411] = {
    [sym_file_descriptor] = ACTIONS(1952),
    [sym__concat] = ACTIONS(1952),
    [anon_sym_PIPE] = ACTIONS(1954),
    [anon_sym_RPAREN] = ACTIONS(1952),
    [anon_sym_PIPE_AMP] = ACTIONS(1952),
    [anon_sym_AMP_AMP] = ACTIONS(1952),
    [anon_sym_PIPE_PIPE] = ACTIONS(1952),
    [anon_sym_LT] = ACTIONS(1954),
    [anon_sym_GT] = ACTIONS(1954),
    [anon_sym_GT_GT] = ACTIONS(1952),
    [anon_sym_AMP_GT] = ACTIONS(1954),
    [anon_sym_AMP_GT_GT] = ACTIONS(1952),
    [anon_sym_LT_AMP] = ACTIONS(1952),
    [anon_sym_GT_AMP] = ACTIONS(1952),
    [anon_sym_LT_LT] = ACTIONS(1954),
    [anon_sym_LT_LT_DASH] = ACTIONS(1952),
    [anon_sym_LT_LT_LT] = ACTIONS(1952),
    [anon_sym_BQUOTE] = ACTIONS(1952),
    [sym_comment] = ACTIONS(53),
  },
  [2412] = {
    [sym_file_descriptor] = ACTIONS(2018),
    [sym__concat] = ACTIONS(2018),
    [anon_sym_PIPE] = ACTIONS(2020),
    [anon_sym_RPAREN] = ACTIONS(2018),
    [anon_sym_PIPE_AMP] = ACTIONS(2018),
    [anon_sym_AMP_AMP] = ACTIONS(2018),
    [anon_sym_PIPE_PIPE] = ACTIONS(2018),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(2020),
    [anon_sym_GT_GT] = ACTIONS(2018),
    [anon_sym_AMP_GT] = ACTIONS(2020),
    [anon_sym_AMP_GT_GT] = ACTIONS(2018),
    [anon_sym_LT_AMP] = ACTIONS(2018),
    [anon_sym_GT_AMP] = ACTIONS(2018),
    [anon_sym_LT_LT] = ACTIONS(2020),
    [anon_sym_LT_LT_DASH] = ACTIONS(2018),
    [anon_sym_LT_LT_LT] = ACTIONS(2018),
    [anon_sym_BQUOTE] = ACTIONS(2018),
    [sym_comment] = ACTIONS(53),
  },
  [2413] = {
    [sym__concat] = ACTIONS(4884),
    [sym_variable_name] = ACTIONS(4884),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_RPAREN] = ACTIONS(4884),
    [anon_sym_PIPE_AMP] = ACTIONS(4884),
    [anon_sym_AMP_AMP] = ACTIONS(4884),
    [anon_sym_PIPE_PIPE] = ACTIONS(4884),
    [sym__special_characters] = ACTIONS(4884),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4884),
    [anon_sym_BQUOTE] = ACTIONS(4884),
    [anon_sym_LT_LPAREN] = ACTIONS(4884),
    [anon_sym_GT_LPAREN] = ACTIONS(4884),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4886),
    [sym_word] = ACTIONS(4886),
  },
  [2414] = {
    [sym__concat] = ACTIONS(4888),
    [sym_variable_name] = ACTIONS(4888),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_RPAREN] = ACTIONS(4888),
    [anon_sym_PIPE_AMP] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4888),
    [anon_sym_PIPE_PIPE] = ACTIONS(4888),
    [sym__special_characters] = ACTIONS(4888),
    [anon_sym_DQUOTE] = ACTIONS(4888),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4888),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4888),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4888),
    [anon_sym_BQUOTE] = ACTIONS(4888),
    [anon_sym_LT_LPAREN] = ACTIONS(4888),
    [anon_sym_GT_LPAREN] = ACTIONS(4888),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4890),
    [sym_word] = ACTIONS(4890),
  },
  [2415] = {
    [sym__concat] = ACTIONS(4892),
    [sym_variable_name] = ACTIONS(4892),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_RPAREN] = ACTIONS(4892),
    [anon_sym_PIPE_AMP] = ACTIONS(4892),
    [anon_sym_AMP_AMP] = ACTIONS(4892),
    [anon_sym_PIPE_PIPE] = ACTIONS(4892),
    [sym__special_characters] = ACTIONS(4892),
    [anon_sym_DQUOTE] = ACTIONS(4892),
    [anon_sym_DOLLAR] = ACTIONS(4894),
    [sym_raw_string] = ACTIONS(4892),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4892),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4892),
    [anon_sym_BQUOTE] = ACTIONS(4892),
    [anon_sym_LT_LPAREN] = ACTIONS(4892),
    [anon_sym_GT_LPAREN] = ACTIONS(4892),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4894),
    [sym_word] = ACTIONS(4894),
  },
  [2416] = {
    [sym__concat] = ACTIONS(4896),
    [sym_variable_name] = ACTIONS(4896),
    [anon_sym_PIPE] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(4896),
    [anon_sym_PIPE_AMP] = ACTIONS(4896),
    [anon_sym_AMP_AMP] = ACTIONS(4896),
    [anon_sym_PIPE_PIPE] = ACTIONS(4896),
    [sym__special_characters] = ACTIONS(4896),
    [anon_sym_DQUOTE] = ACTIONS(4896),
    [anon_sym_DOLLAR] = ACTIONS(4898),
    [sym_raw_string] = ACTIONS(4896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4896),
    [anon_sym_BQUOTE] = ACTIONS(4896),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4898),
    [sym_word] = ACTIONS(4898),
  },
  [2417] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6053),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2418] = {
    [sym__concat] = ACTIONS(4902),
    [sym_variable_name] = ACTIONS(4902),
    [anon_sym_PIPE] = ACTIONS(4904),
    [anon_sym_RPAREN] = ACTIONS(4902),
    [anon_sym_PIPE_AMP] = ACTIONS(4902),
    [anon_sym_AMP_AMP] = ACTIONS(4902),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [sym__special_characters] = ACTIONS(4902),
    [anon_sym_DQUOTE] = ACTIONS(4902),
    [anon_sym_DOLLAR] = ACTIONS(4904),
    [sym_raw_string] = ACTIONS(4902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4902),
    [anon_sym_BQUOTE] = ACTIONS(4902),
    [anon_sym_LT_LPAREN] = ACTIONS(4902),
    [anon_sym_GT_LPAREN] = ACTIONS(4902),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4904),
    [sym_word] = ACTIONS(4904),
  },
  [2419] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6055),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2420] = {
    [sym__concat] = ACTIONS(4908),
    [sym_variable_name] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_RPAREN] = ACTIONS(4908),
    [anon_sym_PIPE_AMP] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [sym__special_characters] = ACTIONS(4908),
    [anon_sym_DQUOTE] = ACTIONS(4908),
    [anon_sym_DOLLAR] = ACTIONS(4910),
    [sym_raw_string] = ACTIONS(4908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4908),
    [anon_sym_BQUOTE] = ACTIONS(4908),
    [anon_sym_LT_LPAREN] = ACTIONS(4908),
    [anon_sym_GT_LPAREN] = ACTIONS(4908),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4910),
    [sym_word] = ACTIONS(4910),
  },
  [2421] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6057),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2422] = {
    [sym__concat] = ACTIONS(4914),
    [sym_variable_name] = ACTIONS(4914),
    [anon_sym_PIPE] = ACTIONS(4916),
    [anon_sym_RPAREN] = ACTIONS(4914),
    [anon_sym_PIPE_AMP] = ACTIONS(4914),
    [anon_sym_AMP_AMP] = ACTIONS(4914),
    [anon_sym_PIPE_PIPE] = ACTIONS(4914),
    [sym__special_characters] = ACTIONS(4914),
    [anon_sym_DQUOTE] = ACTIONS(4914),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(4914),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4914),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4914),
    [anon_sym_BQUOTE] = ACTIONS(4914),
    [anon_sym_LT_LPAREN] = ACTIONS(4914),
    [anon_sym_GT_LPAREN] = ACTIONS(4914),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4916),
    [sym_word] = ACTIONS(4916),
  },
  [2423] = {
    [sym__concat] = ACTIONS(4918),
    [sym_variable_name] = ACTIONS(4918),
    [anon_sym_PIPE] = ACTIONS(4920),
    [anon_sym_RPAREN] = ACTIONS(4918),
    [anon_sym_PIPE_AMP] = ACTIONS(4918),
    [anon_sym_AMP_AMP] = ACTIONS(4918),
    [anon_sym_PIPE_PIPE] = ACTIONS(4918),
    [sym__special_characters] = ACTIONS(4918),
    [anon_sym_DQUOTE] = ACTIONS(4918),
    [anon_sym_DOLLAR] = ACTIONS(4920),
    [sym_raw_string] = ACTIONS(4918),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4918),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4918),
    [anon_sym_BQUOTE] = ACTIONS(4918),
    [anon_sym_LT_LPAREN] = ACTIONS(4918),
    [anon_sym_GT_LPAREN] = ACTIONS(4918),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4920),
    [sym_word] = ACTIONS(4920),
  },
  [2424] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_RPAREN] = ACTIONS(4884),
    [anon_sym_PIPE_AMP] = ACTIONS(4884),
    [anon_sym_AMP_AMP] = ACTIONS(4884),
    [anon_sym_PIPE_PIPE] = ACTIONS(4884),
    [sym__special_characters] = ACTIONS(4884),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4884),
    [anon_sym_BQUOTE] = ACTIONS(4884),
    [anon_sym_LT_LPAREN] = ACTIONS(4884),
    [anon_sym_GT_LPAREN] = ACTIONS(4884),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4886),
    [sym_word] = ACTIONS(4886),
  },
  [2425] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_RPAREN] = ACTIONS(4888),
    [anon_sym_PIPE_AMP] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4888),
    [anon_sym_PIPE_PIPE] = ACTIONS(4888),
    [sym__special_characters] = ACTIONS(4888),
    [anon_sym_DQUOTE] = ACTIONS(4888),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4888),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4888),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4888),
    [anon_sym_BQUOTE] = ACTIONS(4888),
    [anon_sym_LT_LPAREN] = ACTIONS(4888),
    [anon_sym_GT_LPAREN] = ACTIONS(4888),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4890),
    [sym_word] = ACTIONS(4890),
  },
  [2426] = {
    [sym__concat] = ACTIONS(4892),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_RPAREN] = ACTIONS(4892),
    [anon_sym_PIPE_AMP] = ACTIONS(4892),
    [anon_sym_AMP_AMP] = ACTIONS(4892),
    [anon_sym_PIPE_PIPE] = ACTIONS(4892),
    [sym__special_characters] = ACTIONS(4892),
    [anon_sym_DQUOTE] = ACTIONS(4892),
    [anon_sym_DOLLAR] = ACTIONS(4894),
    [sym_raw_string] = ACTIONS(4892),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4892),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4892),
    [anon_sym_BQUOTE] = ACTIONS(4892),
    [anon_sym_LT_LPAREN] = ACTIONS(4892),
    [anon_sym_GT_LPAREN] = ACTIONS(4892),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4894),
    [sym_word] = ACTIONS(4894),
  },
  [2427] = {
    [sym__concat] = ACTIONS(4896),
    [anon_sym_PIPE] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(4896),
    [anon_sym_PIPE_AMP] = ACTIONS(4896),
    [anon_sym_AMP_AMP] = ACTIONS(4896),
    [anon_sym_PIPE_PIPE] = ACTIONS(4896),
    [sym__special_characters] = ACTIONS(4896),
    [anon_sym_DQUOTE] = ACTIONS(4896),
    [anon_sym_DOLLAR] = ACTIONS(4898),
    [sym_raw_string] = ACTIONS(4896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4896),
    [anon_sym_BQUOTE] = ACTIONS(4896),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4898),
    [sym_word] = ACTIONS(4898),
  },
  [2428] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6059),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2429] = {
    [sym__concat] = ACTIONS(4902),
    [anon_sym_PIPE] = ACTIONS(4904),
    [anon_sym_RPAREN] = ACTIONS(4902),
    [anon_sym_PIPE_AMP] = ACTIONS(4902),
    [anon_sym_AMP_AMP] = ACTIONS(4902),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [sym__special_characters] = ACTIONS(4902),
    [anon_sym_DQUOTE] = ACTIONS(4902),
    [anon_sym_DOLLAR] = ACTIONS(4904),
    [sym_raw_string] = ACTIONS(4902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4902),
    [anon_sym_BQUOTE] = ACTIONS(4902),
    [anon_sym_LT_LPAREN] = ACTIONS(4902),
    [anon_sym_GT_LPAREN] = ACTIONS(4902),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4904),
    [sym_word] = ACTIONS(4904),
  },
  [2430] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6061),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2431] = {
    [sym__concat] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_RPAREN] = ACTIONS(4908),
    [anon_sym_PIPE_AMP] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [sym__special_characters] = ACTIONS(4908),
    [anon_sym_DQUOTE] = ACTIONS(4908),
    [anon_sym_DOLLAR] = ACTIONS(4910),
    [sym_raw_string] = ACTIONS(4908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4908),
    [anon_sym_BQUOTE] = ACTIONS(4908),
    [anon_sym_LT_LPAREN] = ACTIONS(4908),
    [anon_sym_GT_LPAREN] = ACTIONS(4908),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4910),
    [sym_word] = ACTIONS(4910),
  },
  [2432] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6063),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2433] = {
    [sym__concat] = ACTIONS(4914),
    [anon_sym_PIPE] = ACTIONS(4916),
    [anon_sym_RPAREN] = ACTIONS(4914),
    [anon_sym_PIPE_AMP] = ACTIONS(4914),
    [anon_sym_AMP_AMP] = ACTIONS(4914),
    [anon_sym_PIPE_PIPE] = ACTIONS(4914),
    [sym__special_characters] = ACTIONS(4914),
    [anon_sym_DQUOTE] = ACTIONS(4914),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(4914),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4914),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4914),
    [anon_sym_BQUOTE] = ACTIONS(4914),
    [anon_sym_LT_LPAREN] = ACTIONS(4914),
    [anon_sym_GT_LPAREN] = ACTIONS(4914),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4916),
    [sym_word] = ACTIONS(4916),
  },
  [2434] = {
    [sym__concat] = ACTIONS(4918),
    [anon_sym_PIPE] = ACTIONS(4920),
    [anon_sym_RPAREN] = ACTIONS(4918),
    [anon_sym_PIPE_AMP] = ACTIONS(4918),
    [anon_sym_AMP_AMP] = ACTIONS(4918),
    [anon_sym_PIPE_PIPE] = ACTIONS(4918),
    [sym__special_characters] = ACTIONS(4918),
    [anon_sym_DQUOTE] = ACTIONS(4918),
    [anon_sym_DOLLAR] = ACTIONS(4920),
    [sym_raw_string] = ACTIONS(4918),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4918),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4918),
    [anon_sym_BQUOTE] = ACTIONS(4918),
    [anon_sym_LT_LPAREN] = ACTIONS(4918),
    [anon_sym_GT_LPAREN] = ACTIONS(4918),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4920),
    [sym_word] = ACTIONS(4920),
  },
  [2435] = {
    [sym__simple_heredoc_body] = ACTIONS(5540),
    [sym__heredoc_body_beginning] = ACTIONS(5540),
    [sym_file_descriptor] = ACTIONS(5540),
    [sym__concat] = ACTIONS(5540),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_RPAREN] = ACTIONS(5540),
    [anon_sym_PIPE_AMP] = ACTIONS(5540),
    [anon_sym_AMP_AMP] = ACTIONS(5540),
    [anon_sym_PIPE_PIPE] = ACTIONS(5540),
    [anon_sym_EQ_TILDE] = ACTIONS(5542),
    [anon_sym_EQ_EQ] = ACTIONS(5542),
    [anon_sym_LT] = ACTIONS(5542),
    [anon_sym_GT] = ACTIONS(5542),
    [anon_sym_GT_GT] = ACTIONS(5540),
    [anon_sym_AMP_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT_GT] = ACTIONS(5540),
    [anon_sym_LT_AMP] = ACTIONS(5540),
    [anon_sym_GT_AMP] = ACTIONS(5540),
    [anon_sym_LT_LT] = ACTIONS(5542),
    [anon_sym_LT_LT_DASH] = ACTIONS(5540),
    [anon_sym_LT_LT_LT] = ACTIONS(5540),
    [sym__special_characters] = ACTIONS(5540),
    [anon_sym_DQUOTE] = ACTIONS(5540),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5540),
    [anon_sym_BQUOTE] = ACTIONS(5540),
    [anon_sym_LT_LPAREN] = ACTIONS(5540),
    [anon_sym_GT_LPAREN] = ACTIONS(5540),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5542),
  },
  [2436] = {
    [sym__simple_heredoc_body] = ACTIONS(5544),
    [sym__heredoc_body_beginning] = ACTIONS(5544),
    [sym_file_descriptor] = ACTIONS(5544),
    [sym__concat] = ACTIONS(5544),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_RPAREN] = ACTIONS(5544),
    [anon_sym_PIPE_AMP] = ACTIONS(5544),
    [anon_sym_AMP_AMP] = ACTIONS(5544),
    [anon_sym_PIPE_PIPE] = ACTIONS(5544),
    [anon_sym_EQ_TILDE] = ACTIONS(5546),
    [anon_sym_EQ_EQ] = ACTIONS(5546),
    [anon_sym_LT] = ACTIONS(5546),
    [anon_sym_GT] = ACTIONS(5546),
    [anon_sym_GT_GT] = ACTIONS(5544),
    [anon_sym_AMP_GT] = ACTIONS(5546),
    [anon_sym_AMP_GT_GT] = ACTIONS(5544),
    [anon_sym_LT_AMP] = ACTIONS(5544),
    [anon_sym_GT_AMP] = ACTIONS(5544),
    [anon_sym_LT_LT] = ACTIONS(5546),
    [anon_sym_LT_LT_DASH] = ACTIONS(5544),
    [anon_sym_LT_LT_LT] = ACTIONS(5544),
    [sym__special_characters] = ACTIONS(5544),
    [anon_sym_DQUOTE] = ACTIONS(5544),
    [anon_sym_DOLLAR] = ACTIONS(5546),
    [sym_raw_string] = ACTIONS(5544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5544),
    [anon_sym_BQUOTE] = ACTIONS(5544),
    [anon_sym_LT_LPAREN] = ACTIONS(5544),
    [anon_sym_GT_LPAREN] = ACTIONS(5544),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5546),
  },
  [2437] = {
    [sym__simple_heredoc_body] = ACTIONS(5548),
    [sym__heredoc_body_beginning] = ACTIONS(5548),
    [sym_file_descriptor] = ACTIONS(5548),
    [sym__concat] = ACTIONS(5548),
    [anon_sym_PIPE] = ACTIONS(5550),
    [anon_sym_RPAREN] = ACTIONS(5548),
    [anon_sym_PIPE_AMP] = ACTIONS(5548),
    [anon_sym_AMP_AMP] = ACTIONS(5548),
    [anon_sym_PIPE_PIPE] = ACTIONS(5548),
    [anon_sym_EQ_TILDE] = ACTIONS(5550),
    [anon_sym_EQ_EQ] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5550),
    [anon_sym_GT] = ACTIONS(5550),
    [anon_sym_GT_GT] = ACTIONS(5548),
    [anon_sym_AMP_GT] = ACTIONS(5550),
    [anon_sym_AMP_GT_GT] = ACTIONS(5548),
    [anon_sym_LT_AMP] = ACTIONS(5548),
    [anon_sym_GT_AMP] = ACTIONS(5548),
    [anon_sym_LT_LT] = ACTIONS(5550),
    [anon_sym_LT_LT_DASH] = ACTIONS(5548),
    [anon_sym_LT_LT_LT] = ACTIONS(5548),
    [sym__special_characters] = ACTIONS(5548),
    [anon_sym_DQUOTE] = ACTIONS(5548),
    [anon_sym_DOLLAR] = ACTIONS(5550),
    [sym_raw_string] = ACTIONS(5548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5548),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5548),
    [anon_sym_BQUOTE] = ACTIONS(5548),
    [anon_sym_LT_LPAREN] = ACTIONS(5548),
    [anon_sym_GT_LPAREN] = ACTIONS(5548),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5550),
  },
  [2438] = {
    [aux_sym_concatenation_repeat1] = STATE(2438),
    [sym__concat] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1654),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [anon_sym_BQUOTE] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
  },
  [2439] = {
    [aux_sym_concatenation_repeat1] = STATE(2439),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(6010),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1654),
    [anon_sym_AMP_AMP] = ACTIONS(1654),
    [anon_sym_PIPE_PIPE] = ACTIONS(1654),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1654),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1654),
    [anon_sym_LT_AMP] = ACTIONS(1654),
    [anon_sym_GT_AMP] = ACTIONS(1654),
    [anon_sym_LT_LT] = ACTIONS(1656),
    [anon_sym_LT_LT_DASH] = ACTIONS(1654),
    [anon_sym_LT_LT_LT] = ACTIONS(1654),
    [anon_sym_BQUOTE] = ACTIONS(1654),
    [sym_comment] = ACTIONS(53),
  },
  [2440] = {
    [sym__heredoc_body_middle] = ACTIONS(4884),
    [sym__heredoc_body_end] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4884),
    [sym_comment] = ACTIONS(53),
  },
  [2441] = {
    [sym__heredoc_body_middle] = ACTIONS(4888),
    [sym__heredoc_body_end] = ACTIONS(4888),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4888),
    [sym_comment] = ACTIONS(53),
  },
  [2442] = {
    [sym__heredoc_body_middle] = ACTIONS(4892),
    [sym__heredoc_body_end] = ACTIONS(4892),
    [anon_sym_DOLLAR] = ACTIONS(4894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4892),
    [sym_comment] = ACTIONS(53),
  },
  [2443] = {
    [sym__heredoc_body_middle] = ACTIONS(4896),
    [sym__heredoc_body_end] = ACTIONS(4896),
    [anon_sym_DOLLAR] = ACTIONS(4898),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4896),
    [sym_comment] = ACTIONS(53),
  },
  [2444] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6065),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2445] = {
    [sym__heredoc_body_middle] = ACTIONS(4902),
    [sym__heredoc_body_end] = ACTIONS(4902),
    [anon_sym_DOLLAR] = ACTIONS(4904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4902),
    [sym_comment] = ACTIONS(53),
  },
  [2446] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6067),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2447] = {
    [sym__heredoc_body_middle] = ACTIONS(4908),
    [sym__heredoc_body_end] = ACTIONS(4908),
    [anon_sym_DOLLAR] = ACTIONS(4910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4908),
    [sym_comment] = ACTIONS(53),
  },
  [2448] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6069),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2449] = {
    [sym__heredoc_body_middle] = ACTIONS(4914),
    [sym__heredoc_body_end] = ACTIONS(4914),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4914),
    [sym_comment] = ACTIONS(53),
  },
  [2450] = {
    [sym__heredoc_body_middle] = ACTIONS(4918),
    [sym__heredoc_body_end] = ACTIONS(4918),
    [anon_sym_DOLLAR] = ACTIONS(4920),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4918),
    [sym_comment] = ACTIONS(53),
  },
  [2451] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_RPAREN] = ACTIONS(4884),
    [sym__special_characters] = ACTIONS(4884),
    [anon_sym_DQUOTE] = ACTIONS(4884),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4884),
    [anon_sym_BQUOTE] = ACTIONS(4884),
    [anon_sym_LT_LPAREN] = ACTIONS(4884),
    [anon_sym_GT_LPAREN] = ACTIONS(4884),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4884),
  },
  [2452] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_RPAREN] = ACTIONS(4888),
    [sym__special_characters] = ACTIONS(4888),
    [anon_sym_DQUOTE] = ACTIONS(4888),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4888),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4888),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4888),
    [anon_sym_BQUOTE] = ACTIONS(4888),
    [anon_sym_LT_LPAREN] = ACTIONS(4888),
    [anon_sym_GT_LPAREN] = ACTIONS(4888),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4888),
  },
  [2453] = {
    [sym__concat] = ACTIONS(4892),
    [anon_sym_RPAREN] = ACTIONS(4892),
    [sym__special_characters] = ACTIONS(4892),
    [anon_sym_DQUOTE] = ACTIONS(4892),
    [anon_sym_DOLLAR] = ACTIONS(4894),
    [sym_raw_string] = ACTIONS(4892),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4892),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4892),
    [anon_sym_BQUOTE] = ACTIONS(4892),
    [anon_sym_LT_LPAREN] = ACTIONS(4892),
    [anon_sym_GT_LPAREN] = ACTIONS(4892),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4892),
  },
  [2454] = {
    [sym__concat] = ACTIONS(4896),
    [anon_sym_RPAREN] = ACTIONS(4896),
    [sym__special_characters] = ACTIONS(4896),
    [anon_sym_DQUOTE] = ACTIONS(4896),
    [anon_sym_DOLLAR] = ACTIONS(4898),
    [sym_raw_string] = ACTIONS(4896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4896),
    [anon_sym_BQUOTE] = ACTIONS(4896),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4896),
  },
  [2455] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6071),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2456] = {
    [sym__concat] = ACTIONS(4902),
    [anon_sym_RPAREN] = ACTIONS(4902),
    [sym__special_characters] = ACTIONS(4902),
    [anon_sym_DQUOTE] = ACTIONS(4902),
    [anon_sym_DOLLAR] = ACTIONS(4904),
    [sym_raw_string] = ACTIONS(4902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4902),
    [anon_sym_BQUOTE] = ACTIONS(4902),
    [anon_sym_LT_LPAREN] = ACTIONS(4902),
    [anon_sym_GT_LPAREN] = ACTIONS(4902),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4902),
  },
  [2457] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6073),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2458] = {
    [sym__concat] = ACTIONS(4908),
    [anon_sym_RPAREN] = ACTIONS(4908),
    [sym__special_characters] = ACTIONS(4908),
    [anon_sym_DQUOTE] = ACTIONS(4908),
    [anon_sym_DOLLAR] = ACTIONS(4910),
    [sym_raw_string] = ACTIONS(4908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4908),
    [anon_sym_BQUOTE] = ACTIONS(4908),
    [anon_sym_LT_LPAREN] = ACTIONS(4908),
    [anon_sym_GT_LPAREN] = ACTIONS(4908),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4908),
  },
  [2459] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6075),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2460] = {
    [sym__concat] = ACTIONS(4914),
    [anon_sym_RPAREN] = ACTIONS(4914),
    [sym__special_characters] = ACTIONS(4914),
    [anon_sym_DQUOTE] = ACTIONS(4914),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(4914),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4914),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4914),
    [anon_sym_BQUOTE] = ACTIONS(4914),
    [anon_sym_LT_LPAREN] = ACTIONS(4914),
    [anon_sym_GT_LPAREN] = ACTIONS(4914),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4914),
  },
  [2461] = {
    [sym__concat] = ACTIONS(4918),
    [anon_sym_RPAREN] = ACTIONS(4918),
    [sym__special_characters] = ACTIONS(4918),
    [anon_sym_DQUOTE] = ACTIONS(4918),
    [anon_sym_DOLLAR] = ACTIONS(4920),
    [sym_raw_string] = ACTIONS(4918),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4918),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4918),
    [anon_sym_BQUOTE] = ACTIONS(4918),
    [anon_sym_LT_LPAREN] = ACTIONS(4918),
    [anon_sym_GT_LPAREN] = ACTIONS(4918),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4918),
  },
  [2462] = {
    [sym_file_descriptor] = ACTIONS(5540),
    [sym__concat] = ACTIONS(5540),
    [sym_variable_name] = ACTIONS(5540),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_RPAREN] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [anon_sym_PIPE_AMP] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE] = ACTIONS(5542),
    [anon_sym_LT] = ACTIONS(5542),
    [anon_sym_GT] = ACTIONS(5542),
    [anon_sym_GT_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT_GT] = ACTIONS(5542),
    [anon_sym_LT_AMP] = ACTIONS(5542),
    [anon_sym_GT_AMP] = ACTIONS(5542),
    [sym__special_characters] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [anon_sym_LT_LPAREN] = ACTIONS(5542),
    [anon_sym_GT_LPAREN] = ACTIONS(5542),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5542),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [2463] = {
    [sym_file_descriptor] = ACTIONS(5544),
    [sym__concat] = ACTIONS(5544),
    [sym_variable_name] = ACTIONS(5544),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_RPAREN] = ACTIONS(5546),
    [anon_sym_SEMI_SEMI] = ACTIONS(5546),
    [anon_sym_PIPE_AMP] = ACTIONS(5546),
    [anon_sym_AMP_AMP] = ACTIONS(5546),
    [anon_sym_PIPE_PIPE] = ACTIONS(5546),
    [anon_sym_LT] = ACTIONS(5546),
    [anon_sym_GT] = ACTIONS(5546),
    [anon_sym_GT_GT] = ACTIONS(5546),
    [anon_sym_AMP_GT] = ACTIONS(5546),
    [anon_sym_AMP_GT_GT] = ACTIONS(5546),
    [anon_sym_LT_AMP] = ACTIONS(5546),
    [anon_sym_GT_AMP] = ACTIONS(5546),
    [sym__special_characters] = ACTIONS(5546),
    [anon_sym_DQUOTE] = ACTIONS(5546),
    [anon_sym_DOLLAR] = ACTIONS(5546),
    [sym_raw_string] = ACTIONS(5546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5546),
    [anon_sym_BQUOTE] = ACTIONS(5546),
    [anon_sym_LT_LPAREN] = ACTIONS(5546),
    [anon_sym_GT_LPAREN] = ACTIONS(5546),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5546),
    [anon_sym_SEMI] = ACTIONS(5546),
    [anon_sym_LF] = ACTIONS(5544),
    [anon_sym_AMP] = ACTIONS(5546),
  },
  [2464] = {
    [sym_file_descriptor] = ACTIONS(5548),
    [sym__concat] = ACTIONS(5548),
    [sym_variable_name] = ACTIONS(5548),
    [anon_sym_PIPE] = ACTIONS(5550),
    [anon_sym_RPAREN] = ACTIONS(5550),
    [anon_sym_SEMI_SEMI] = ACTIONS(5550),
    [anon_sym_PIPE_AMP] = ACTIONS(5550),
    [anon_sym_AMP_AMP] = ACTIONS(5550),
    [anon_sym_PIPE_PIPE] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5550),
    [anon_sym_GT] = ACTIONS(5550),
    [anon_sym_GT_GT] = ACTIONS(5550),
    [anon_sym_AMP_GT] = ACTIONS(5550),
    [anon_sym_AMP_GT_GT] = ACTIONS(5550),
    [anon_sym_LT_AMP] = ACTIONS(5550),
    [anon_sym_GT_AMP] = ACTIONS(5550),
    [sym__special_characters] = ACTIONS(5550),
    [anon_sym_DQUOTE] = ACTIONS(5550),
    [anon_sym_DOLLAR] = ACTIONS(5550),
    [sym_raw_string] = ACTIONS(5550),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5550),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5550),
    [anon_sym_BQUOTE] = ACTIONS(5550),
    [anon_sym_LT_LPAREN] = ACTIONS(5550),
    [anon_sym_GT_LPAREN] = ACTIONS(5550),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5550),
    [anon_sym_SEMI] = ACTIONS(5550),
    [anon_sym_LF] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
  },
  [2465] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [sym__special_characters] = ACTIONS(4886),
    [anon_sym_DQUOTE] = ACTIONS(4886),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4886),
    [anon_sym_BQUOTE] = ACTIONS(4886),
    [anon_sym_LT_LPAREN] = ACTIONS(4886),
    [anon_sym_GT_LPAREN] = ACTIONS(4886),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4886),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [2466] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [sym__special_characters] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4890),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4890),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_LT_LPAREN] = ACTIONS(4890),
    [anon_sym_GT_LPAREN] = ACTIONS(4890),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4890),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [2467] = {
    [sym__concat] = ACTIONS(4892),
    [anon_sym_SEMI_SEMI] = ACTIONS(4894),
    [sym__special_characters] = ACTIONS(4894),
    [anon_sym_DQUOTE] = ACTIONS(4894),
    [anon_sym_DOLLAR] = ACTIONS(4894),
    [sym_raw_string] = ACTIONS(4894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4894),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4894),
    [anon_sym_GT_LPAREN] = ACTIONS(4894),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(4894),
    [anon_sym_LF] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4894),
  },
  [2468] = {
    [sym__concat] = ACTIONS(4896),
    [anon_sym_SEMI_SEMI] = ACTIONS(4898),
    [sym__special_characters] = ACTIONS(4898),
    [anon_sym_DQUOTE] = ACTIONS(4898),
    [anon_sym_DOLLAR] = ACTIONS(4898),
    [sym_raw_string] = ACTIONS(4898),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4898),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4898),
    [anon_sym_BQUOTE] = ACTIONS(4898),
    [anon_sym_LT_LPAREN] = ACTIONS(4898),
    [anon_sym_GT_LPAREN] = ACTIONS(4898),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4898),
    [anon_sym_SEMI] = ACTIONS(4898),
    [anon_sym_LF] = ACTIONS(4896),
    [anon_sym_AMP] = ACTIONS(4898),
  },
  [2469] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6077),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2470] = {
    [sym__concat] = ACTIONS(4902),
    [anon_sym_SEMI_SEMI] = ACTIONS(4904),
    [sym__special_characters] = ACTIONS(4904),
    [anon_sym_DQUOTE] = ACTIONS(4904),
    [anon_sym_DOLLAR] = ACTIONS(4904),
    [sym_raw_string] = ACTIONS(4904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4904),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4904),
    [anon_sym_BQUOTE] = ACTIONS(4904),
    [anon_sym_LT_LPAREN] = ACTIONS(4904),
    [anon_sym_GT_LPAREN] = ACTIONS(4904),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4904),
    [anon_sym_SEMI] = ACTIONS(4904),
    [anon_sym_LF] = ACTIONS(4902),
    [anon_sym_AMP] = ACTIONS(4904),
  },
  [2471] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2472] = {
    [sym__concat] = ACTIONS(4908),
    [anon_sym_SEMI_SEMI] = ACTIONS(4910),
    [sym__special_characters] = ACTIONS(4910),
    [anon_sym_DQUOTE] = ACTIONS(4910),
    [anon_sym_DOLLAR] = ACTIONS(4910),
    [sym_raw_string] = ACTIONS(4910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4910),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4910),
    [anon_sym_BQUOTE] = ACTIONS(4910),
    [anon_sym_LT_LPAREN] = ACTIONS(4910),
    [anon_sym_GT_LPAREN] = ACTIONS(4910),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4910),
    [anon_sym_SEMI] = ACTIONS(4910),
    [anon_sym_LF] = ACTIONS(4908),
    [anon_sym_AMP] = ACTIONS(4910),
  },
  [2473] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2474] = {
    [sym__concat] = ACTIONS(4914),
    [anon_sym_SEMI_SEMI] = ACTIONS(4916),
    [sym__special_characters] = ACTIONS(4916),
    [anon_sym_DQUOTE] = ACTIONS(4916),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(4916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4916),
    [anon_sym_BQUOTE] = ACTIONS(4916),
    [anon_sym_LT_LPAREN] = ACTIONS(4916),
    [anon_sym_GT_LPAREN] = ACTIONS(4916),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4916),
    [anon_sym_SEMI] = ACTIONS(4916),
    [anon_sym_LF] = ACTIONS(4914),
    [anon_sym_AMP] = ACTIONS(4916),
  },
  [2475] = {
    [sym__concat] = ACTIONS(4918),
    [anon_sym_SEMI_SEMI] = ACTIONS(4920),
    [sym__special_characters] = ACTIONS(4920),
    [anon_sym_DQUOTE] = ACTIONS(4920),
    [anon_sym_DOLLAR] = ACTIONS(4920),
    [sym_raw_string] = ACTIONS(4920),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4920),
    [anon_sym_BQUOTE] = ACTIONS(4920),
    [anon_sym_LT_LPAREN] = ACTIONS(4920),
    [anon_sym_GT_LPAREN] = ACTIONS(4920),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4920),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym_LF] = ACTIONS(4918),
    [anon_sym_AMP] = ACTIONS(4920),
  },
  [2476] = {
    [sym_file_descriptor] = ACTIONS(1107),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_esac] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1109),
    [anon_sym_GT] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_AMP] = ACTIONS(1109),
    [anon_sym_GT_AMP] = ACTIONS(1109),
    [sym__special_characters] = ACTIONS(1109),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1109),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_LT_LPAREN] = ACTIONS(1109),
    [anon_sym_GT_LPAREN] = ACTIONS(1109),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1109),
  },
  [2477] = {
    [sym_concatenation] = STATE(2656),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(2656),
    [anon_sym_RPAREN] = ACTIONS(6083),
    [sym__special_characters] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1119),
  },
  [2478] = {
    [aux_sym_concatenation_repeat1] = STATE(2658),
    [sym_file_descriptor] = ACTIONS(1129),
    [sym__concat] = ACTIONS(6085),
    [sym_variable_name] = ACTIONS(1129),
    [anon_sym_esac] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_SEMI_SEMI] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1133),
    [anon_sym_AMP_GT] = ACTIONS(1133),
    [anon_sym_AMP_GT_GT] = ACTIONS(1133),
    [anon_sym_LT_AMP] = ACTIONS(1133),
    [anon_sym_GT_AMP] = ACTIONS(1133),
    [sym__special_characters] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1133),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1133),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_LF] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1133),
  },
  [2479] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(2660),
    [anon_sym_DQUOTE] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [2480] = {
    [sym_string] = STATE(2662),
    [anon_sym_DQUOTE] = ACTIONS(5758),
    [anon_sym_DOLLAR] = ACTIONS(6089),
    [sym_raw_string] = ACTIONS(6091),
    [anon_sym_POUND] = ACTIONS(6089),
    [anon_sym_DASH] = ACTIONS(6089),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6093),
    [anon_sym_STAR] = ACTIONS(6089),
    [anon_sym_AT] = ACTIONS(6089),
    [anon_sym_QMARK] = ACTIONS(6089),
    [anon_sym_0] = ACTIONS(6095),
    [anon_sym__] = ACTIONS(6095),
  },
  [2481] = {
    [aux_sym_concatenation_repeat1] = STATE(2658),
    [sym_file_descriptor] = ACTIONS(1107),
    [sym__concat] = ACTIONS(6085),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_esac] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1109),
    [anon_sym_GT] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT] = ACTIONS(1109),
    [anon_sym_AMP_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_AMP] = ACTIONS(1109),
    [anon_sym_GT_AMP] = ACTIONS(1109),
    [sym__special_characters] = ACTIONS(1109),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1109),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_LT_LPAREN] = ACTIONS(1109),
    [anon_sym_GT_LPAREN] = ACTIONS(1109),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1109),
  },
  [2482] = {
    [sym_subscript] = STATE(2668),
    [sym_variable_name] = ACTIONS(6097),
    [anon_sym_DOLLAR] = ACTIONS(6099),
    [anon_sym_POUND] = ACTIONS(6101),
    [anon_sym_DASH] = ACTIONS(6099),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6103),
    [anon_sym_STAR] = ACTIONS(6099),
    [anon_sym_AT] = ACTIONS(6099),
    [anon_sym_QMARK] = ACTIONS(6099),
    [anon_sym_0] = ACTIONS(6105),
    [anon_sym__] = ACTIONS(6105),
  },
  [2483] = {
    [sym_for_statement] = STATE(2669),
    [sym_while_statement] = STATE(2669),
    [sym_if_statement] = STATE(2669),
    [sym_case_statement] = STATE(2669),
    [sym_function_definition] = STATE(2669),
    [sym_subshell] = STATE(2669),
    [sym_pipeline] = STATE(2669),
    [sym_list] = STATE(2669),
    [sym_negated_command] = STATE(2669),
    [sym_test_command] = STATE(2669),
    [sym_declaration_command] = STATE(2669),
    [sym_unset_command] = STATE(2669),
    [sym_command] = STATE(2669),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(2670),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [2484] = {
    [sym_for_statement] = STATE(2671),
    [sym_while_statement] = STATE(2671),
    [sym_if_statement] = STATE(2671),
    [sym_case_statement] = STATE(2671),
    [sym_function_definition] = STATE(2671),
    [sym_subshell] = STATE(2671),
    [sym_pipeline] = STATE(2671),
    [sym_list] = STATE(2671),
    [sym_negated_command] = STATE(2671),
    [sym_test_command] = STATE(2671),
    [sym_declaration_command] = STATE(2671),
    [sym_unset_command] = STATE(2671),
    [sym_command] = STATE(2671),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(2672),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [2485] = {
    [sym_for_statement] = STATE(2673),
    [sym_while_statement] = STATE(2673),
    [sym_if_statement] = STATE(2673),
    [sym_case_statement] = STATE(2673),
    [sym_function_definition] = STATE(2673),
    [sym_subshell] = STATE(2673),
    [sym_pipeline] = STATE(2673),
    [sym_list] = STATE(2673),
    [sym_negated_command] = STATE(2673),
    [sym_test_command] = STATE(2673),
    [sym_declaration_command] = STATE(2673),
    [sym_unset_command] = STATE(2673),
    [sym_command] = STATE(2673),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(2674),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [2486] = {
    [sym_file_redirect] = STATE(2675),
    [sym_heredoc_redirect] = STATE(2675),
    [sym_heredoc_body] = STATE(602),
    [sym_herestring_redirect] = STATE(2675),
    [aux_sym_while_statement_repeat1] = STATE(2675),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(5332),
    [anon_sym_esac] = ACTIONS(1175),
    [anon_sym_PIPE] = ACTIONS(1175),
    [anon_sym_SEMI_SEMI] = ACTIONS(1175),
    [anon_sym_PIPE_AMP] = ACTIONS(1175),
    [anon_sym_AMP_AMP] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1175),
    [anon_sym_LT] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(5336),
    [anon_sym_GT_GT] = ACTIONS(5336),
    [anon_sym_AMP_GT] = ACTIONS(5336),
    [anon_sym_AMP_GT_GT] = ACTIONS(5336),
    [anon_sym_LT_AMP] = ACTIONS(5336),
    [anon_sym_GT_AMP] = ACTIONS(5336),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(5338),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1175),
    [anon_sym_LF] = ACTIONS(1177),
    [anon_sym_AMP] = ACTIONS(1175),
  },
  [2487] = {
    [anon_sym_RPAREN] = ACTIONS(6107),
    [sym_comment] = ACTIONS(53),
  },
  [2488] = {
    [sym_file_redirect] = STATE(643),
    [sym_file_descriptor] = ACTIONS(6109),
    [anon_sym_esac] = ACTIONS(1245),
    [anon_sym_PIPE] = ACTIONS(1245),
    [anon_sym_SEMI_SEMI] = ACTIONS(1245),
    [anon_sym_PIPE_AMP] = ACTIONS(1245),
    [anon_sym_AMP_AMP] = ACTIONS(1245),
    [anon_sym_PIPE_PIPE] = ACTIONS(1245),
    [anon_sym_LT] = ACTIONS(6111),
    [anon_sym_GT] = ACTIONS(6111),
    [anon_sym_GT_GT] = ACTIONS(6111),
    [anon_sym_AMP_GT] = ACTIONS(6111),
    [anon_sym_AMP_GT_GT] = ACTIONS(6111),
    [anon_sym_LT_AMP] = ACTIONS(6111),
    [anon_sym_GT_AMP] = ACTIONS(6111),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1245),
    [anon_sym_LF] = ACTIONS(1249),
    [anon_sym_AMP] = ACTIONS(1245),
  },
  [2489] = {
    [sym_file_redirect] = STATE(2682),
    [sym_heredoc_redirect] = STATE(2682),
    [sym_herestring_redirect] = STATE(2682),
    [aux_sym_while_statement_repeat1] = STATE(2682),
    [sym_file_descriptor] = ACTIONS(6113),
    [anon_sym_esac] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(1353),
    [anon_sym_SEMI_SEMI] = ACTIONS(1353),
    [anon_sym_PIPE_AMP] = ACTIONS(1353),
    [anon_sym_AMP_AMP] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1353),
    [anon_sym_LT] = ACTIONS(6115),
    [anon_sym_GT] = ACTIONS(6115),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_AMP_GT] = ACTIONS(6115),
    [anon_sym_AMP_GT_GT] = ACTIONS(6115),
    [anon_sym_LT_AMP] = ACTIONS(6115),
    [anon_sym_GT_AMP] = ACTIONS(6115),
    [anon_sym_LT_LT] = ACTIONS(1357),
    [anon_sym_LT_LT_DASH] = ACTIONS(1357),
    [anon_sym_LT_LT_LT] = ACTIONS(6117),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1353),
    [anon_sym_LF] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1353),
  },
  [2490] = {
    [sym_concatenation] = STATE(2683),
    [sym_string] = STATE(2686),
    [sym_array] = STATE(2683),
    [sym_simple_expansion] = STATE(2686),
    [sym_string_expansion] = STATE(2686),
    [sym_expansion] = STATE(2686),
    [sym_command_substitution] = STATE(2686),
    [sym_process_substitution] = STATE(2686),
    [sym__empty_value] = ACTIONS(6119),
    [anon_sym_LPAREN] = ACTIONS(6121),
    [sym__special_characters] = ACTIONS(6123),
    [anon_sym_DQUOTE] = ACTIONS(5782),
    [anon_sym_DOLLAR] = ACTIONS(5266),
    [sym_raw_string] = ACTIONS(6125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6127),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6129),
    [anon_sym_BQUOTE] = ACTIONS(6131),
    [anon_sym_LT_LPAREN] = ACTIONS(6133),
    [anon_sym_GT_LPAREN] = ACTIONS(6133),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6125),
  },
  [2491] = {
    [sym_string] = STATE(2687),
    [sym_simple_expansion] = STATE(2687),
    [sym_string_expansion] = STATE(2687),
    [sym_expansion] = STATE(2687),
    [sym_command_substitution] = STATE(2687),
    [sym_process_substitution] = STATE(2687),
    [sym__special_characters] = ACTIONS(6135),
    [anon_sym_DQUOTE] = ACTIONS(5782),
    [anon_sym_DOLLAR] = ACTIONS(5266),
    [sym_raw_string] = ACTIONS(6135),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6127),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6129),
    [anon_sym_BQUOTE] = ACTIONS(6131),
    [anon_sym_LT_LPAREN] = ACTIONS(6133),
    [anon_sym_GT_LPAREN] = ACTIONS(6133),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6135),
  },
  [2492] = {
    [aux_sym_concatenation_repeat1] = STATE(2688),
    [sym__concat] = ACTIONS(5778),
    [sym_variable_name] = ACTIONS(693),
    [anon_sym_esac] = ACTIONS(695),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(695),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [2493] = {
    [sym__concat] = ACTIONS(697),
    [sym_variable_name] = ACTIONS(697),
    [anon_sym_esac] = ACTIONS(699),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(699),
    [sym_word] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_LF] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [2494] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(6137),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [2495] = {
    [sym__concat] = ACTIONS(727),
    [sym_variable_name] = ACTIONS(727),
    [anon_sym_esac] = ACTIONS(729),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(729),
    [anon_sym_PIPE_AMP] = ACTIONS(729),
    [anon_sym_AMP_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(729),
    [sym__special_characters] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(729),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(729),
    [anon_sym_BQUOTE] = ACTIONS(729),
    [anon_sym_LT_LPAREN] = ACTIONS(729),
    [anon_sym_GT_LPAREN] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(729),
    [sym_word] = ACTIONS(729),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_LF] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
  },
  [2496] = {
    [sym__concat] = ACTIONS(731),
    [sym_variable_name] = ACTIONS(731),
    [anon_sym_esac] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [sym__special_characters] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [anon_sym_LT_LPAREN] = ACTIONS(733),
    [anon_sym_GT_LPAREN] = ACTIONS(733),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(733),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [2497] = {
    [sym__concat] = ACTIONS(735),
    [sym_variable_name] = ACTIONS(735),
    [anon_sym_esac] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(737),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__special_characters] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [anon_sym_LT_LPAREN] = ACTIONS(737),
    [anon_sym_GT_LPAREN] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(737),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [2498] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(6139),
    [sym_comment] = ACTIONS(53),
  },
  [2499] = {
    [sym_concatenation] = STATE(2693),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2693),
    [anon_sym_RBRACE] = ACTIONS(6141),
    [anon_sym_EQ] = ACTIONS(6143),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6147),
    [anon_sym_COLON] = ACTIONS(6143),
    [anon_sym_COLON_QMARK] = ACTIONS(6143),
    [anon_sym_COLON_DASH] = ACTIONS(6143),
    [anon_sym_PERCENT] = ACTIONS(6143),
    [anon_sym_DASH] = ACTIONS(6143),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2500] = {
    [sym_subscript] = STATE(2697),
    [sym_variable_name] = ACTIONS(6149),
    [anon_sym_DOLLAR] = ACTIONS(6151),
    [anon_sym_DASH] = ACTIONS(6151),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6153),
    [anon_sym_STAR] = ACTIONS(6151),
    [anon_sym_AT] = ACTIONS(6151),
    [anon_sym_QMARK] = ACTIONS(6151),
    [anon_sym_0] = ACTIONS(6155),
    [anon_sym__] = ACTIONS(6155),
  },
  [2501] = {
    [sym_concatenation] = STATE(2700),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2700),
    [anon_sym_RBRACE] = ACTIONS(6157),
    [anon_sym_EQ] = ACTIONS(6159),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6163),
    [anon_sym_COLON] = ACTIONS(6159),
    [anon_sym_COLON_QMARK] = ACTIONS(6159),
    [anon_sym_COLON_DASH] = ACTIONS(6159),
    [anon_sym_PERCENT] = ACTIONS(6159),
    [anon_sym_DASH] = ACTIONS(6159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2502] = {
    [sym_concatenation] = STATE(2703),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2703),
    [anon_sym_RBRACE] = ACTIONS(6165),
    [anon_sym_EQ] = ACTIONS(6167),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6169),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6171),
    [anon_sym_COLON] = ACTIONS(6167),
    [anon_sym_COLON_QMARK] = ACTIONS(6167),
    [anon_sym_COLON_DASH] = ACTIONS(6167),
    [anon_sym_PERCENT] = ACTIONS(6167),
    [anon_sym_DASH] = ACTIONS(6167),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2503] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(6173),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [2504] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(6173),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2505] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(6173),
    [sym_comment] = ACTIONS(53),
  },
  [2506] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(6173),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2507] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(6175),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [2508] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(6175),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2509] = {
    [sym_variable_assignment] = STATE(2509),
    [sym_subscript] = STATE(2260),
    [sym_concatenation] = STATE(2509),
    [sym_string] = STATE(2254),
    [sym_simple_expansion] = STATE(2254),
    [sym_string_expansion] = STATE(2254),
    [sym_expansion] = STATE(2254),
    [sym_command_substitution] = STATE(2254),
    [sym_process_substitution] = STATE(2254),
    [aux_sym_declaration_command_repeat1] = STATE(2509),
    [sym_variable_name] = ACTIONS(6177),
    [anon_sym_esac] = ACTIONS(1500),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_SEMI_SEMI] = ACTIONS(1500),
    [anon_sym_PIPE_AMP] = ACTIONS(1500),
    [anon_sym_AMP_AMP] = ACTIONS(1500),
    [anon_sym_PIPE_PIPE] = ACTIONS(1500),
    [sym__special_characters] = ACTIONS(6180),
    [anon_sym_DQUOTE] = ACTIONS(6183),
    [anon_sym_DOLLAR] = ACTIONS(6186),
    [sym_raw_string] = ACTIONS(6189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6192),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6195),
    [anon_sym_BQUOTE] = ACTIONS(6198),
    [anon_sym_LT_LPAREN] = ACTIONS(6201),
    [anon_sym_GT_LPAREN] = ACTIONS(6201),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6204),
    [sym_word] = ACTIONS(6189),
    [anon_sym_SEMI] = ACTIONS(1500),
    [anon_sym_LF] = ACTIONS(1529),
    [anon_sym_AMP] = ACTIONS(1500),
  },
  [2510] = {
    [sym_string] = STATE(2706),
    [sym_simple_expansion] = STATE(2706),
    [sym_string_expansion] = STATE(2706),
    [sym_expansion] = STATE(2706),
    [sym_command_substitution] = STATE(2706),
    [sym_process_substitution] = STATE(2706),
    [sym__special_characters] = ACTIONS(6207),
    [anon_sym_DQUOTE] = ACTIONS(5806),
    [anon_sym_DOLLAR] = ACTIONS(5284),
    [sym_raw_string] = ACTIONS(6207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6209),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6211),
    [anon_sym_BQUOTE] = ACTIONS(6213),
    [anon_sym_LT_LPAREN] = ACTIONS(6215),
    [anon_sym_GT_LPAREN] = ACTIONS(6215),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6207),
  },
  [2511] = {
    [aux_sym_concatenation_repeat1] = STATE(2707),
    [sym__concat] = ACTIONS(5802),
    [anon_sym_esac] = ACTIONS(695),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(695),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [2512] = {
    [sym__concat] = ACTIONS(697),
    [anon_sym_esac] = ACTIONS(699),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(699),
    [sym_word] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_LF] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [2513] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(6217),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [2514] = {
    [sym__concat] = ACTIONS(727),
    [anon_sym_esac] = ACTIONS(729),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(729),
    [anon_sym_PIPE_AMP] = ACTIONS(729),
    [anon_sym_AMP_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(729),
    [sym__special_characters] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(729),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(729),
    [anon_sym_BQUOTE] = ACTIONS(729),
    [anon_sym_LT_LPAREN] = ACTIONS(729),
    [anon_sym_GT_LPAREN] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(729),
    [sym_word] = ACTIONS(729),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_LF] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
  },
  [2515] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_esac] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [sym__special_characters] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [anon_sym_LT_LPAREN] = ACTIONS(733),
    [anon_sym_GT_LPAREN] = ACTIONS(733),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(733),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [2516] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_esac] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(737),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__special_characters] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [anon_sym_LT_LPAREN] = ACTIONS(737),
    [anon_sym_GT_LPAREN] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(737),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [2517] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(6219),
    [sym_comment] = ACTIONS(53),
  },
  [2518] = {
    [sym_concatenation] = STATE(2712),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2712),
    [anon_sym_RBRACE] = ACTIONS(6221),
    [anon_sym_EQ] = ACTIONS(6223),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6227),
    [anon_sym_COLON] = ACTIONS(6223),
    [anon_sym_COLON_QMARK] = ACTIONS(6223),
    [anon_sym_COLON_DASH] = ACTIONS(6223),
    [anon_sym_PERCENT] = ACTIONS(6223),
    [anon_sym_DASH] = ACTIONS(6223),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2519] = {
    [sym_subscript] = STATE(2716),
    [sym_variable_name] = ACTIONS(6229),
    [anon_sym_DOLLAR] = ACTIONS(6231),
    [anon_sym_DASH] = ACTIONS(6231),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6233),
    [anon_sym_STAR] = ACTIONS(6231),
    [anon_sym_AT] = ACTIONS(6231),
    [anon_sym_QMARK] = ACTIONS(6231),
    [anon_sym_0] = ACTIONS(6235),
    [anon_sym__] = ACTIONS(6235),
  },
  [2520] = {
    [sym_concatenation] = STATE(2719),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2719),
    [anon_sym_RBRACE] = ACTIONS(6237),
    [anon_sym_EQ] = ACTIONS(6239),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6241),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6243),
    [anon_sym_COLON] = ACTIONS(6239),
    [anon_sym_COLON_QMARK] = ACTIONS(6239),
    [anon_sym_COLON_DASH] = ACTIONS(6239),
    [anon_sym_PERCENT] = ACTIONS(6239),
    [anon_sym_DASH] = ACTIONS(6239),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2521] = {
    [sym_concatenation] = STATE(2722),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2722),
    [anon_sym_RBRACE] = ACTIONS(6245),
    [anon_sym_EQ] = ACTIONS(6247),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6251),
    [anon_sym_COLON] = ACTIONS(6247),
    [anon_sym_COLON_QMARK] = ACTIONS(6247),
    [anon_sym_COLON_DASH] = ACTIONS(6247),
    [anon_sym_PERCENT] = ACTIONS(6247),
    [anon_sym_DASH] = ACTIONS(6247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2522] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(6253),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [2523] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(6253),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2524] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(6253),
    [sym_comment] = ACTIONS(53),
  },
  [2525] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(6253),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2526] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(6255),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [2527] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(6255),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2528] = {
    [sym_concatenation] = STATE(2528),
    [sym_string] = STATE(2265),
    [sym_simple_expansion] = STATE(2265),
    [sym_string_expansion] = STATE(2265),
    [sym_expansion] = STATE(2265),
    [sym_command_substitution] = STATE(2265),
    [sym_process_substitution] = STATE(2265),
    [aux_sym_unset_command_repeat1] = STATE(2528),
    [anon_sym_esac] = ACTIONS(1581),
    [anon_sym_PIPE] = ACTIONS(1581),
    [anon_sym_SEMI_SEMI] = ACTIONS(1581),
    [anon_sym_PIPE_AMP] = ACTIONS(1581),
    [anon_sym_AMP_AMP] = ACTIONS(1581),
    [anon_sym_PIPE_PIPE] = ACTIONS(1581),
    [sym__special_characters] = ACTIONS(6257),
    [anon_sym_DQUOTE] = ACTIONS(6260),
    [anon_sym_DOLLAR] = ACTIONS(6263),
    [sym_raw_string] = ACTIONS(6266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6269),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6272),
    [anon_sym_BQUOTE] = ACTIONS(6275),
    [anon_sym_LT_LPAREN] = ACTIONS(6278),
    [anon_sym_GT_LPAREN] = ACTIONS(6278),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6281),
    [sym_word] = ACTIONS(6266),
    [anon_sym_SEMI] = ACTIONS(1581),
    [anon_sym_LF] = ACTIONS(1610),
    [anon_sym_AMP] = ACTIONS(1581),
  },
  [2529] = {
    [sym__simple_heredoc_body] = ACTIONS(1654),
    [sym__heredoc_body_beginning] = ACTIONS(1654),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(1654),
    [anon_sym_esac] = ACTIONS(1656),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [anon_sym_EQ_TILDE] = ACTIONS(1656),
    [anon_sym_EQ_EQ] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1656),
    [anon_sym_LT_AMP] = ACTIONS(1656),
    [anon_sym_GT_AMP] = ACTIONS(1656),
    [anon_sym_LT_LT] = ACTIONS(1656),
    [anon_sym_LT_LT_DASH] = ACTIONS(1656),
    [anon_sym_LT_LT_LT] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LT_LPAREN] = ACTIONS(1656),
    [anon_sym_GT_LPAREN] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [2530] = {
    [aux_sym_concatenation_repeat1] = STATE(2530),
    [sym__simple_heredoc_body] = ACTIONS(1654),
    [sym__heredoc_body_beginning] = ACTIONS(1654),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(6284),
    [anon_sym_esac] = ACTIONS(1656),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [anon_sym_EQ_TILDE] = ACTIONS(1656),
    [anon_sym_EQ_EQ] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1656),
    [anon_sym_LT_AMP] = ACTIONS(1656),
    [anon_sym_GT_AMP] = ACTIONS(1656),
    [anon_sym_LT_LT] = ACTIONS(1656),
    [anon_sym_LT_LT_DASH] = ACTIONS(1656),
    [anon_sym_LT_LT_LT] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LT_LPAREN] = ACTIONS(1656),
    [anon_sym_GT_LPAREN] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [2531] = {
    [sym__simple_heredoc_body] = ACTIONS(1703),
    [sym__heredoc_body_beginning] = ACTIONS(1703),
    [sym_file_descriptor] = ACTIONS(1703),
    [sym__concat] = ACTIONS(1703),
    [anon_sym_esac] = ACTIONS(1705),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_SEMI_SEMI] = ACTIONS(1705),
    [anon_sym_PIPE_AMP] = ACTIONS(1705),
    [anon_sym_AMP_AMP] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE] = ACTIONS(1705),
    [anon_sym_EQ_TILDE] = ACTIONS(1705),
    [anon_sym_EQ_EQ] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1705),
    [anon_sym_GT] = ACTIONS(1705),
    [anon_sym_GT_GT] = ACTIONS(1705),
    [anon_sym_AMP_GT] = ACTIONS(1705),
    [anon_sym_AMP_GT_GT] = ACTIONS(1705),
    [anon_sym_LT_AMP] = ACTIONS(1705),
    [anon_sym_GT_AMP] = ACTIONS(1705),
    [anon_sym_LT_LT] = ACTIONS(1705),
    [anon_sym_LT_LT_DASH] = ACTIONS(1705),
    [anon_sym_LT_LT_LT] = ACTIONS(1705),
    [sym__special_characters] = ACTIONS(1705),
    [anon_sym_DQUOTE] = ACTIONS(1705),
    [anon_sym_DOLLAR] = ACTIONS(1705),
    [sym_raw_string] = ACTIONS(1705),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1705),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1705),
    [anon_sym_BQUOTE] = ACTIONS(1705),
    [anon_sym_LT_LPAREN] = ACTIONS(1705),
    [anon_sym_GT_LPAREN] = ACTIONS(1705),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1705),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_LF] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1705),
  },
  [2532] = {
    [sym_concatenation] = STATE(2728),
    [sym_string] = STATE(2727),
    [sym_simple_expansion] = STATE(2727),
    [sym_string_expansion] = STATE(2727),
    [sym_expansion] = STATE(2727),
    [sym_command_substitution] = STATE(2727),
    [sym_process_substitution] = STATE(2727),
    [anon_sym_RBRACE] = ACTIONS(6287),
    [sym__special_characters] = ACTIONS(6289),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(6291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6291),
  },
  [2533] = {
    [sym__simple_heredoc_body] = ACTIONS(1744),
    [sym__heredoc_body_beginning] = ACTIONS(1744),
    [sym_file_descriptor] = ACTIONS(1744),
    [sym__concat] = ACTIONS(1744),
    [anon_sym_esac] = ACTIONS(1746),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_SEMI_SEMI] = ACTIONS(1746),
    [anon_sym_PIPE_AMP] = ACTIONS(1746),
    [anon_sym_AMP_AMP] = ACTIONS(1746),
    [anon_sym_PIPE_PIPE] = ACTIONS(1746),
    [anon_sym_EQ_TILDE] = ACTIONS(1746),
    [anon_sym_EQ_EQ] = ACTIONS(1746),
    [anon_sym_LT] = ACTIONS(1746),
    [anon_sym_GT] = ACTIONS(1746),
    [anon_sym_GT_GT] = ACTIONS(1746),
    [anon_sym_AMP_GT] = ACTIONS(1746),
    [anon_sym_AMP_GT_GT] = ACTIONS(1746),
    [anon_sym_LT_AMP] = ACTIONS(1746),
    [anon_sym_GT_AMP] = ACTIONS(1746),
    [anon_sym_LT_LT] = ACTIONS(1746),
    [anon_sym_LT_LT_DASH] = ACTIONS(1746),
    [anon_sym_LT_LT_LT] = ACTIONS(1746),
    [sym__special_characters] = ACTIONS(1746),
    [anon_sym_DQUOTE] = ACTIONS(1746),
    [anon_sym_DOLLAR] = ACTIONS(1746),
    [sym_raw_string] = ACTIONS(1746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1746),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1746),
    [anon_sym_GT_LPAREN] = ACTIONS(1746),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1746),
    [anon_sym_SEMI] = ACTIONS(1746),
    [anon_sym_LF] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(1746),
  },
  [2534] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6293),
  },
  [2535] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6295),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2536] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(6297),
    [sym_comment] = ACTIONS(53),
  },
  [2537] = {
    [sym_concatenation] = STATE(2734),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2734),
    [anon_sym_RBRACE] = ACTIONS(6299),
    [anon_sym_EQ] = ACTIONS(6301),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6303),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6305),
    [anon_sym_COLON] = ACTIONS(6301),
    [anon_sym_COLON_QMARK] = ACTIONS(6301),
    [anon_sym_COLON_DASH] = ACTIONS(6301),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_DASH] = ACTIONS(6301),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2538] = {
    [sym_concatenation] = STATE(2737),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2737),
    [anon_sym_RBRACE] = ACTIONS(6307),
    [anon_sym_EQ] = ACTIONS(6309),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6311),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6313),
    [anon_sym_COLON] = ACTIONS(6309),
    [anon_sym_COLON_QMARK] = ACTIONS(6309),
    [anon_sym_COLON_DASH] = ACTIONS(6309),
    [anon_sym_PERCENT] = ACTIONS(6309),
    [anon_sym_DASH] = ACTIONS(6309),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2539] = {
    [sym_concatenation] = STATE(2739),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2739),
    [anon_sym_RBRACE] = ACTIONS(6287),
    [anon_sym_EQ] = ACTIONS(6315),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6317),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6319),
    [anon_sym_COLON] = ACTIONS(6315),
    [anon_sym_COLON_QMARK] = ACTIONS(6315),
    [anon_sym_COLON_DASH] = ACTIONS(6315),
    [anon_sym_PERCENT] = ACTIONS(6315),
    [anon_sym_DASH] = ACTIONS(6315),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2540] = {
    [sym__simple_heredoc_body] = ACTIONS(1810),
    [sym__heredoc_body_beginning] = ACTIONS(1810),
    [sym_file_descriptor] = ACTIONS(1810),
    [sym__concat] = ACTIONS(1810),
    [anon_sym_esac] = ACTIONS(1812),
    [anon_sym_PIPE] = ACTIONS(1812),
    [anon_sym_SEMI_SEMI] = ACTIONS(1812),
    [anon_sym_PIPE_AMP] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1812),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [anon_sym_EQ_TILDE] = ACTIONS(1812),
    [anon_sym_EQ_EQ] = ACTIONS(1812),
    [anon_sym_LT] = ACTIONS(1812),
    [anon_sym_GT] = ACTIONS(1812),
    [anon_sym_GT_GT] = ACTIONS(1812),
    [anon_sym_AMP_GT] = ACTIONS(1812),
    [anon_sym_AMP_GT_GT] = ACTIONS(1812),
    [anon_sym_LT_AMP] = ACTIONS(1812),
    [anon_sym_GT_AMP] = ACTIONS(1812),
    [anon_sym_LT_LT] = ACTIONS(1812),
    [anon_sym_LT_LT_DASH] = ACTIONS(1812),
    [anon_sym_LT_LT_LT] = ACTIONS(1812),
    [sym__special_characters] = ACTIONS(1812),
    [anon_sym_DQUOTE] = ACTIONS(1812),
    [anon_sym_DOLLAR] = ACTIONS(1812),
    [sym_raw_string] = ACTIONS(1812),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1812),
    [anon_sym_GT_LPAREN] = ACTIONS(1812),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1812),
    [anon_sym_SEMI] = ACTIONS(1812),
    [anon_sym_LF] = ACTIONS(1810),
    [anon_sym_AMP] = ACTIONS(1812),
  },
  [2541] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6321),
  },
  [2542] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6323),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2543] = {
    [sym__simple_heredoc_body] = ACTIONS(1818),
    [sym__heredoc_body_beginning] = ACTIONS(1818),
    [sym_file_descriptor] = ACTIONS(1818),
    [sym__concat] = ACTIONS(1818),
    [anon_sym_esac] = ACTIONS(1820),
    [anon_sym_PIPE] = ACTIONS(1820),
    [anon_sym_SEMI_SEMI] = ACTIONS(1820),
    [anon_sym_PIPE_AMP] = ACTIONS(1820),
    [anon_sym_AMP_AMP] = ACTIONS(1820),
    [anon_sym_PIPE_PIPE] = ACTIONS(1820),
    [anon_sym_EQ_TILDE] = ACTIONS(1820),
    [anon_sym_EQ_EQ] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1820),
    [anon_sym_GT] = ACTIONS(1820),
    [anon_sym_GT_GT] = ACTIONS(1820),
    [anon_sym_AMP_GT] = ACTIONS(1820),
    [anon_sym_AMP_GT_GT] = ACTIONS(1820),
    [anon_sym_LT_AMP] = ACTIONS(1820),
    [anon_sym_GT_AMP] = ACTIONS(1820),
    [anon_sym_LT_LT] = ACTIONS(1820),
    [anon_sym_LT_LT_DASH] = ACTIONS(1820),
    [anon_sym_LT_LT_LT] = ACTIONS(1820),
    [sym__special_characters] = ACTIONS(1820),
    [anon_sym_DQUOTE] = ACTIONS(1820),
    [anon_sym_DOLLAR] = ACTIONS(1820),
    [sym_raw_string] = ACTIONS(1820),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1820),
    [anon_sym_BQUOTE] = ACTIONS(1820),
    [anon_sym_LT_LPAREN] = ACTIONS(1820),
    [anon_sym_GT_LPAREN] = ACTIONS(1820),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1820),
    [anon_sym_LF] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1820),
  },
  [2544] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6325),
  },
  [2545] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6287),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2546] = {
    [sym__simple_heredoc_body] = ACTIONS(1952),
    [sym__heredoc_body_beginning] = ACTIONS(1952),
    [sym_file_descriptor] = ACTIONS(1952),
    [sym__concat] = ACTIONS(1952),
    [anon_sym_esac] = ACTIONS(1954),
    [anon_sym_PIPE] = ACTIONS(1954),
    [anon_sym_SEMI_SEMI] = ACTIONS(1954),
    [anon_sym_PIPE_AMP] = ACTIONS(1954),
    [anon_sym_AMP_AMP] = ACTIONS(1954),
    [anon_sym_PIPE_PIPE] = ACTIONS(1954),
    [anon_sym_EQ_TILDE] = ACTIONS(1954),
    [anon_sym_EQ_EQ] = ACTIONS(1954),
    [anon_sym_LT] = ACTIONS(1954),
    [anon_sym_GT] = ACTIONS(1954),
    [anon_sym_GT_GT] = ACTIONS(1954),
    [anon_sym_AMP_GT] = ACTIONS(1954),
    [anon_sym_AMP_GT_GT] = ACTIONS(1954),
    [anon_sym_LT_AMP] = ACTIONS(1954),
    [anon_sym_GT_AMP] = ACTIONS(1954),
    [anon_sym_LT_LT] = ACTIONS(1954),
    [anon_sym_LT_LT_DASH] = ACTIONS(1954),
    [anon_sym_LT_LT_LT] = ACTIONS(1954),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1954),
    [anon_sym_DOLLAR] = ACTIONS(1954),
    [sym_raw_string] = ACTIONS(1954),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1954),
    [anon_sym_BQUOTE] = ACTIONS(1954),
    [anon_sym_LT_LPAREN] = ACTIONS(1954),
    [anon_sym_GT_LPAREN] = ACTIONS(1954),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1954),
    [anon_sym_SEMI] = ACTIONS(1954),
    [anon_sym_LF] = ACTIONS(1952),
    [anon_sym_AMP] = ACTIONS(1954),
  },
  [2547] = {
    [sym__simple_heredoc_body] = ACTIONS(2018),
    [sym__heredoc_body_beginning] = ACTIONS(2018),
    [sym_file_descriptor] = ACTIONS(2018),
    [sym__concat] = ACTIONS(2018),
    [anon_sym_esac] = ACTIONS(2020),
    [anon_sym_PIPE] = ACTIONS(2020),
    [anon_sym_SEMI_SEMI] = ACTIONS(2020),
    [anon_sym_PIPE_AMP] = ACTIONS(2020),
    [anon_sym_AMP_AMP] = ACTIONS(2020),
    [anon_sym_PIPE_PIPE] = ACTIONS(2020),
    [anon_sym_EQ_TILDE] = ACTIONS(2020),
    [anon_sym_EQ_EQ] = ACTIONS(2020),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(2020),
    [anon_sym_GT_GT] = ACTIONS(2020),
    [anon_sym_AMP_GT] = ACTIONS(2020),
    [anon_sym_AMP_GT_GT] = ACTIONS(2020),
    [anon_sym_LT_AMP] = ACTIONS(2020),
    [anon_sym_GT_AMP] = ACTIONS(2020),
    [anon_sym_LT_LT] = ACTIONS(2020),
    [anon_sym_LT_LT_DASH] = ACTIONS(2020),
    [anon_sym_LT_LT_LT] = ACTIONS(2020),
    [sym__special_characters] = ACTIONS(2020),
    [anon_sym_DQUOTE] = ACTIONS(2020),
    [anon_sym_DOLLAR] = ACTIONS(2020),
    [sym_raw_string] = ACTIONS(2020),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2020),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2020),
    [anon_sym_BQUOTE] = ACTIONS(2020),
    [anon_sym_LT_LPAREN] = ACTIONS(2020),
    [anon_sym_GT_LPAREN] = ACTIONS(2020),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2020),
    [anon_sym_SEMI] = ACTIONS(2020),
    [anon_sym_LF] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2020),
  },
  [2548] = {
    [sym_compound_statement] = STATE(2743),
    [anon_sym_LBRACE] = ACTIONS(455),
    [sym_comment] = ACTIONS(53),
  },
  [2549] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_esac] = ACTIONS(2022),
    [anon_sym_PIPE] = ACTIONS(2022),
    [anon_sym_SEMI_SEMI] = ACTIONS(2022),
    [anon_sym_PIPE_AMP] = ACTIONS(2022),
    [anon_sym_AMP_AMP] = ACTIONS(2022),
    [anon_sym_PIPE_PIPE] = ACTIONS(2022),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(2022),
    [anon_sym_LF] = ACTIONS(2024),
    [anon_sym_AMP] = ACTIONS(2022),
  },
  [2550] = {
    [anon_sym_esac] = ACTIONS(2026),
    [anon_sym_PIPE] = ACTIONS(5322),
    [anon_sym_SEMI_SEMI] = ACTIONS(2026),
    [anon_sym_PIPE_AMP] = ACTIONS(5322),
    [anon_sym_AMP_AMP] = ACTIONS(2026),
    [anon_sym_PIPE_PIPE] = ACTIONS(2026),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2026),
    [anon_sym_LF] = ACTIONS(2028),
    [anon_sym_AMP] = ACTIONS(2026),
  },
  [2551] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_esac] = ACTIONS(2026),
    [anon_sym_PIPE] = ACTIONS(5322),
    [anon_sym_SEMI_SEMI] = ACTIONS(2026),
    [anon_sym_PIPE_AMP] = ACTIONS(5322),
    [anon_sym_AMP_AMP] = ACTIONS(2026),
    [anon_sym_PIPE_PIPE] = ACTIONS(2026),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(2026),
    [anon_sym_LF] = ACTIONS(2028),
    [anon_sym_AMP] = ACTIONS(2026),
  },
  [2552] = {
    [sym_concatenation] = STATE(991),
    [sym_string] = STATE(2745),
    [sym_simple_expansion] = STATE(2745),
    [sym_string_expansion] = STATE(2745),
    [sym_expansion] = STATE(2745),
    [sym_command_substitution] = STATE(2745),
    [sym_process_substitution] = STATE(2745),
    [sym__special_characters] = ACTIONS(6327),
    [anon_sym_DQUOTE] = ACTIONS(5888),
    [anon_sym_DOLLAR] = ACTIONS(5890),
    [sym_raw_string] = ACTIONS(6329),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5896),
    [anon_sym_BQUOTE] = ACTIONS(5898),
    [anon_sym_LT_LPAREN] = ACTIONS(5900),
    [anon_sym_GT_LPAREN] = ACTIONS(5900),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6329),
  },
  [2553] = {
    [aux_sym_concatenation_repeat1] = STATE(2273),
    [sym__simple_heredoc_body] = ACTIONS(2058),
    [sym__heredoc_body_beginning] = ACTIONS(2058),
    [sym_file_descriptor] = ACTIONS(2058),
    [sym__concat] = ACTIONS(5298),
    [anon_sym_esac] = ACTIONS(2060),
    [anon_sym_PIPE] = ACTIONS(2060),
    [anon_sym_SEMI_SEMI] = ACTIONS(2060),
    [anon_sym_PIPE_AMP] = ACTIONS(2060),
    [anon_sym_AMP_AMP] = ACTIONS(2060),
    [anon_sym_PIPE_PIPE] = ACTIONS(2060),
    [anon_sym_EQ_TILDE] = ACTIONS(2060),
    [anon_sym_EQ_EQ] = ACTIONS(2060),
    [anon_sym_LT] = ACTIONS(2060),
    [anon_sym_GT] = ACTIONS(2060),
    [anon_sym_GT_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT] = ACTIONS(2060),
    [anon_sym_AMP_GT_GT] = ACTIONS(2060),
    [anon_sym_LT_AMP] = ACTIONS(2060),
    [anon_sym_GT_AMP] = ACTIONS(2060),
    [anon_sym_LT_LT] = ACTIONS(2060),
    [anon_sym_LT_LT_DASH] = ACTIONS(2060),
    [anon_sym_LT_LT_LT] = ACTIONS(2060),
    [sym__special_characters] = ACTIONS(2060),
    [anon_sym_DQUOTE] = ACTIONS(2060),
    [anon_sym_DOLLAR] = ACTIONS(2060),
    [sym_raw_string] = ACTIONS(2060),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2060),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2060),
    [anon_sym_BQUOTE] = ACTIONS(2060),
    [anon_sym_LT_LPAREN] = ACTIONS(2060),
    [anon_sym_GT_LPAREN] = ACTIONS(2060),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2060),
    [anon_sym_LF] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2060),
  },
  [2554] = {
    [aux_sym_concatenation_repeat1] = STATE(2273),
    [sym__simple_heredoc_body] = ACTIONS(2062),
    [sym__heredoc_body_beginning] = ACTIONS(2062),
    [sym_file_descriptor] = ACTIONS(2062),
    [sym__concat] = ACTIONS(5298),
    [anon_sym_esac] = ACTIONS(2064),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_SEMI_SEMI] = ACTIONS(2064),
    [anon_sym_PIPE_AMP] = ACTIONS(2064),
    [anon_sym_AMP_AMP] = ACTIONS(2064),
    [anon_sym_PIPE_PIPE] = ACTIONS(2064),
    [anon_sym_EQ_TILDE] = ACTIONS(2064),
    [anon_sym_EQ_EQ] = ACTIONS(2064),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2064),
    [anon_sym_LT_AMP] = ACTIONS(2064),
    [anon_sym_GT_AMP] = ACTIONS(2064),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2064),
    [anon_sym_LT_LT_LT] = ACTIONS(2064),
    [sym__special_characters] = ACTIONS(2064),
    [anon_sym_DQUOTE] = ACTIONS(2064),
    [anon_sym_DOLLAR] = ACTIONS(2064),
    [sym_raw_string] = ACTIONS(2064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2064),
    [anon_sym_BQUOTE] = ACTIONS(2064),
    [anon_sym_LT_LPAREN] = ACTIONS(2064),
    [anon_sym_GT_LPAREN] = ACTIONS(2064),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2064),
    [anon_sym_SEMI] = ACTIONS(2064),
    [anon_sym_LF] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2064),
  },
  [2555] = {
    [sym__simple_heredoc_body] = ACTIONS(2062),
    [sym__heredoc_body_beginning] = ACTIONS(2062),
    [sym_file_descriptor] = ACTIONS(2062),
    [anon_sym_esac] = ACTIONS(2064),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_SEMI_SEMI] = ACTIONS(2064),
    [anon_sym_PIPE_AMP] = ACTIONS(2064),
    [anon_sym_AMP_AMP] = ACTIONS(2064),
    [anon_sym_PIPE_PIPE] = ACTIONS(2064),
    [anon_sym_EQ_TILDE] = ACTIONS(2064),
    [anon_sym_EQ_EQ] = ACTIONS(2064),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2064),
    [anon_sym_LT_AMP] = ACTIONS(2064),
    [anon_sym_GT_AMP] = ACTIONS(2064),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2064),
    [anon_sym_LT_LT_LT] = ACTIONS(2064),
    [sym__special_characters] = ACTIONS(2064),
    [anon_sym_DQUOTE] = ACTIONS(2064),
    [anon_sym_DOLLAR] = ACTIONS(2064),
    [sym_raw_string] = ACTIONS(2064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2064),
    [anon_sym_BQUOTE] = ACTIONS(2064),
    [anon_sym_LT_LPAREN] = ACTIONS(2064),
    [anon_sym_GT_LPAREN] = ACTIONS(2064),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2064),
    [anon_sym_SEMI] = ACTIONS(2064),
    [anon_sym_LF] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2064),
  },
  [2556] = {
    [aux_sym_concatenation_repeat1] = STATE(2747),
    [sym__simple_heredoc_body] = ACTIONS(661),
    [sym__heredoc_body_beginning] = ACTIONS(661),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(6331),
    [anon_sym_esac] = ACTIONS(665),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(665),
    [anon_sym_AMP_AMP] = ACTIONS(665),
    [anon_sym_PIPE_PIPE] = ACTIONS(665),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(665),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(665),
    [anon_sym_LT_AMP] = ACTIONS(665),
    [anon_sym_GT_AMP] = ACTIONS(665),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(665),
    [anon_sym_LT_LT_LT] = ACTIONS(665),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [2557] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(2749),
    [anon_sym_DQUOTE] = ACTIONS(6333),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [2558] = {
    [sym_string] = STATE(2751),
    [anon_sym_DQUOTE] = ACTIONS(5888),
    [anon_sym_DOLLAR] = ACTIONS(6335),
    [sym_raw_string] = ACTIONS(6337),
    [anon_sym_POUND] = ACTIONS(6335),
    [anon_sym_DASH] = ACTIONS(6335),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6339),
    [anon_sym_STAR] = ACTIONS(6335),
    [anon_sym_AT] = ACTIONS(6335),
    [anon_sym_QMARK] = ACTIONS(6335),
    [anon_sym_0] = ACTIONS(6341),
    [anon_sym__] = ACTIONS(6341),
  },
  [2559] = {
    [aux_sym_concatenation_repeat1] = STATE(2747),
    [sym__simple_heredoc_body] = ACTIONS(677),
    [sym__heredoc_body_beginning] = ACTIONS(677),
    [sym_file_descriptor] = ACTIONS(677),
    [sym__concat] = ACTIONS(6331),
    [anon_sym_esac] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [2560] = {
    [sym_subscript] = STATE(2757),
    [sym_variable_name] = ACTIONS(6343),
    [anon_sym_DOLLAR] = ACTIONS(6345),
    [anon_sym_POUND] = ACTIONS(6347),
    [anon_sym_DASH] = ACTIONS(6345),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6349),
    [anon_sym_STAR] = ACTIONS(6345),
    [anon_sym_AT] = ACTIONS(6345),
    [anon_sym_QMARK] = ACTIONS(6345),
    [anon_sym_0] = ACTIONS(6351),
    [anon_sym__] = ACTIONS(6351),
  },
  [2561] = {
    [sym_for_statement] = STATE(2758),
    [sym_while_statement] = STATE(2758),
    [sym_if_statement] = STATE(2758),
    [sym_case_statement] = STATE(2758),
    [sym_function_definition] = STATE(2758),
    [sym_subshell] = STATE(2758),
    [sym_pipeline] = STATE(2758),
    [sym_list] = STATE(2758),
    [sym_negated_command] = STATE(2758),
    [sym_test_command] = STATE(2758),
    [sym_declaration_command] = STATE(2758),
    [sym_unset_command] = STATE(2758),
    [sym_command] = STATE(2758),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(2759),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [2562] = {
    [sym_for_statement] = STATE(2760),
    [sym_while_statement] = STATE(2760),
    [sym_if_statement] = STATE(2760),
    [sym_case_statement] = STATE(2760),
    [sym_function_definition] = STATE(2760),
    [sym_subshell] = STATE(2760),
    [sym_pipeline] = STATE(2760),
    [sym_list] = STATE(2760),
    [sym_negated_command] = STATE(2760),
    [sym_test_command] = STATE(2760),
    [sym_declaration_command] = STATE(2760),
    [sym_unset_command] = STATE(2760),
    [sym_command] = STATE(2760),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(2761),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [2563] = {
    [sym_for_statement] = STATE(2762),
    [sym_while_statement] = STATE(2762),
    [sym_if_statement] = STATE(2762),
    [sym_case_statement] = STATE(2762),
    [sym_function_definition] = STATE(2762),
    [sym_subshell] = STATE(2762),
    [sym_pipeline] = STATE(2762),
    [sym_list] = STATE(2762),
    [sym_negated_command] = STATE(2762),
    [sym_test_command] = STATE(2762),
    [sym_declaration_command] = STATE(2762),
    [sym_unset_command] = STATE(2762),
    [sym_command] = STATE(2762),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(2763),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [2564] = {
    [aux_sym_concatenation_repeat1] = STATE(2747),
    [sym__simple_heredoc_body] = ACTIONS(2070),
    [sym__heredoc_body_beginning] = ACTIONS(2070),
    [sym_file_descriptor] = ACTIONS(2070),
    [sym__concat] = ACTIONS(6331),
    [anon_sym_esac] = ACTIONS(2072),
    [anon_sym_PIPE] = ACTIONS(2072),
    [anon_sym_SEMI_SEMI] = ACTIONS(2072),
    [anon_sym_PIPE_AMP] = ACTIONS(2072),
    [anon_sym_AMP_AMP] = ACTIONS(2072),
    [anon_sym_PIPE_PIPE] = ACTIONS(2072),
    [anon_sym_LT] = ACTIONS(2072),
    [anon_sym_GT] = ACTIONS(2072),
    [anon_sym_GT_GT] = ACTIONS(2072),
    [anon_sym_AMP_GT] = ACTIONS(2072),
    [anon_sym_AMP_GT_GT] = ACTIONS(2072),
    [anon_sym_LT_AMP] = ACTIONS(2072),
    [anon_sym_GT_AMP] = ACTIONS(2072),
    [anon_sym_LT_LT] = ACTIONS(2072),
    [anon_sym_LT_LT_DASH] = ACTIONS(2072),
    [anon_sym_LT_LT_LT] = ACTIONS(2072),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2072),
    [anon_sym_LF] = ACTIONS(2070),
    [anon_sym_AMP] = ACTIONS(2072),
  },
  [2565] = {
    [aux_sym_concatenation_repeat1] = STATE(2747),
    [sym__simple_heredoc_body] = ACTIONS(2074),
    [sym__heredoc_body_beginning] = ACTIONS(2074),
    [sym_file_descriptor] = ACTIONS(2074),
    [sym__concat] = ACTIONS(6331),
    [anon_sym_esac] = ACTIONS(2076),
    [anon_sym_PIPE] = ACTIONS(2076),
    [anon_sym_SEMI_SEMI] = ACTIONS(2076),
    [anon_sym_PIPE_AMP] = ACTIONS(2076),
    [anon_sym_AMP_AMP] = ACTIONS(2076),
    [anon_sym_PIPE_PIPE] = ACTIONS(2076),
    [anon_sym_LT] = ACTIONS(2076),
    [anon_sym_GT] = ACTIONS(2076),
    [anon_sym_GT_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT_GT] = ACTIONS(2076),
    [anon_sym_LT_AMP] = ACTIONS(2076),
    [anon_sym_GT_AMP] = ACTIONS(2076),
    [anon_sym_LT_LT] = ACTIONS(2076),
    [anon_sym_LT_LT_DASH] = ACTIONS(2076),
    [anon_sym_LT_LT_LT] = ACTIONS(2076),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2076),
    [anon_sym_LF] = ACTIONS(2074),
    [anon_sym_AMP] = ACTIONS(2076),
  },
  [2566] = {
    [sym_file_redirect] = STATE(2566),
    [sym_heredoc_redirect] = STATE(2566),
    [sym_herestring_redirect] = STATE(2566),
    [aux_sym_while_statement_repeat1] = STATE(2566),
    [sym__simple_heredoc_body] = ACTIONS(2082),
    [sym__heredoc_body_beginning] = ACTIONS(2082),
    [sym_file_descriptor] = ACTIONS(6353),
    [anon_sym_esac] = ACTIONS(2087),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_SEMI_SEMI] = ACTIONS(2087),
    [anon_sym_PIPE_AMP] = ACTIONS(2087),
    [anon_sym_AMP_AMP] = ACTIONS(2087),
    [anon_sym_PIPE_PIPE] = ACTIONS(2087),
    [anon_sym_LT] = ACTIONS(6356),
    [anon_sym_GT] = ACTIONS(6356),
    [anon_sym_GT_GT] = ACTIONS(6356),
    [anon_sym_AMP_GT] = ACTIONS(6356),
    [anon_sym_AMP_GT_GT] = ACTIONS(6356),
    [anon_sym_LT_AMP] = ACTIONS(6356),
    [anon_sym_GT_AMP] = ACTIONS(6356),
    [anon_sym_LT_LT] = ACTIONS(2092),
    [anon_sym_LT_LT_DASH] = ACTIONS(2092),
    [anon_sym_LT_LT_LT] = ACTIONS(6359),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2087),
    [anon_sym_LF] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2087),
  },
  [2567] = {
    [sym_file_redirect] = STATE(2566),
    [sym_heredoc_redirect] = STATE(2566),
    [sym_heredoc_body] = STATE(993),
    [sym_herestring_redirect] = STATE(2566),
    [aux_sym_while_statement_repeat1] = STATE(2566),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(5332),
    [anon_sym_esac] = ACTIONS(2078),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_SEMI_SEMI] = ACTIONS(2078),
    [anon_sym_PIPE_AMP] = ACTIONS(2078),
    [anon_sym_AMP_AMP] = ACTIONS(2078),
    [anon_sym_PIPE_PIPE] = ACTIONS(2078),
    [anon_sym_LT] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(5336),
    [anon_sym_GT_GT] = ACTIONS(5336),
    [anon_sym_AMP_GT] = ACTIONS(5336),
    [anon_sym_AMP_GT_GT] = ACTIONS(5336),
    [anon_sym_LT_AMP] = ACTIONS(5336),
    [anon_sym_GT_AMP] = ACTIONS(5336),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(5338),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_LF] = ACTIONS(2080),
    [anon_sym_AMP] = ACTIONS(2078),
  },
  [2568] = {
    [sym_concatenation] = STATE(2568),
    [sym_string] = STATE(2300),
    [sym_simple_expansion] = STATE(2300),
    [sym_string_expansion] = STATE(2300),
    [sym_expansion] = STATE(2300),
    [sym_command_substitution] = STATE(2300),
    [sym_process_substitution] = STATE(2300),
    [aux_sym_command_repeat2] = STATE(2568),
    [sym__simple_heredoc_body] = ACTIONS(2062),
    [sym__heredoc_body_beginning] = ACTIONS(2062),
    [sym_file_descriptor] = ACTIONS(2062),
    [anon_sym_esac] = ACTIONS(2064),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_SEMI_SEMI] = ACTIONS(2064),
    [anon_sym_PIPE_AMP] = ACTIONS(2064),
    [anon_sym_AMP_AMP] = ACTIONS(2064),
    [anon_sym_PIPE_PIPE] = ACTIONS(2064),
    [anon_sym_EQ_TILDE] = ACTIONS(6362),
    [anon_sym_EQ_EQ] = ACTIONS(6362),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_GT] = ACTIONS(2064),
    [anon_sym_GT_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT] = ACTIONS(2064),
    [anon_sym_AMP_GT_GT] = ACTIONS(2064),
    [anon_sym_LT_AMP] = ACTIONS(2064),
    [anon_sym_GT_AMP] = ACTIONS(2064),
    [anon_sym_LT_LT] = ACTIONS(2064),
    [anon_sym_LT_LT_DASH] = ACTIONS(2064),
    [anon_sym_LT_LT_LT] = ACTIONS(2064),
    [sym__special_characters] = ACTIONS(6365),
    [anon_sym_DQUOTE] = ACTIONS(6368),
    [anon_sym_DOLLAR] = ACTIONS(6371),
    [sym_raw_string] = ACTIONS(6374),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6380),
    [anon_sym_BQUOTE] = ACTIONS(6383),
    [anon_sym_LT_LPAREN] = ACTIONS(6386),
    [anon_sym_GT_LPAREN] = ACTIONS(6386),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(6374),
    [anon_sym_SEMI] = ACTIONS(2064),
    [anon_sym_LF] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2064),
  },
  [2569] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_esac] = ACTIONS(6389),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(6391),
    [anon_sym_DQUOTE] = ACTIONS(6393),
    [anon_sym_DOLLAR] = ACTIONS(6391),
    [sym_raw_string] = ACTIONS(6393),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6393),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6393),
    [anon_sym_BQUOTE] = ACTIONS(6393),
    [anon_sym_LT_LPAREN] = ACTIONS(6393),
    [anon_sym_GT_LPAREN] = ACTIONS(6393),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6391),
  },
  [2570] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(5328),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5328),
    [anon_sym_LF] = ACTIONS(5330),
    [anon_sym_AMP] = ACTIONS(5328),
  },
  [2571] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(5328),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(5328),
    [anon_sym_LF] = ACTIONS(5330),
    [anon_sym_AMP] = ACTIONS(5328),
  },
  [2572] = {
    [sym_file_redirect] = STATE(2764),
    [sym_heredoc_redirect] = STATE(2764),
    [sym_heredoc_body] = STATE(993),
    [sym_herestring_redirect] = STATE(2764),
    [sym_concatenation] = STATE(2568),
    [sym_string] = STATE(2300),
    [sym_simple_expansion] = STATE(2300),
    [sym_string_expansion] = STATE(2300),
    [sym_expansion] = STATE(2300),
    [sym_command_substitution] = STATE(2300),
    [sym_process_substitution] = STATE(2300),
    [aux_sym_while_statement_repeat1] = STATE(2764),
    [aux_sym_command_repeat2] = STATE(2568),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(5332),
    [anon_sym_esac] = ACTIONS(2078),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_SEMI_SEMI] = ACTIONS(2078),
    [anon_sym_PIPE_AMP] = ACTIONS(2078),
    [anon_sym_AMP_AMP] = ACTIONS(2078),
    [anon_sym_PIPE_PIPE] = ACTIONS(2078),
    [anon_sym_EQ_TILDE] = ACTIONS(5334),
    [anon_sym_EQ_EQ] = ACTIONS(5334),
    [anon_sym_LT] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(5336),
    [anon_sym_GT_GT] = ACTIONS(5336),
    [anon_sym_AMP_GT] = ACTIONS(5336),
    [anon_sym_AMP_GT_GT] = ACTIONS(5336),
    [anon_sym_LT_AMP] = ACTIONS(5336),
    [anon_sym_GT_AMP] = ACTIONS(5336),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(5338),
    [sym__special_characters] = ACTIONS(5340),
    [anon_sym_DQUOTE] = ACTIONS(5342),
    [anon_sym_DOLLAR] = ACTIONS(4472),
    [sym_raw_string] = ACTIONS(5344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5346),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5348),
    [anon_sym_BQUOTE] = ACTIONS(5350),
    [anon_sym_LT_LPAREN] = ACTIONS(5352),
    [anon_sym_GT_LPAREN] = ACTIONS(5352),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5344),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_LF] = ACTIONS(2080),
    [anon_sym_AMP] = ACTIONS(2078),
  },
  [2573] = {
    [anon_sym_esac] = ACTIONS(6389),
    [sym__special_characters] = ACTIONS(6393),
    [anon_sym_DQUOTE] = ACTIONS(6393),
    [anon_sym_DOLLAR] = ACTIONS(6391),
    [sym_raw_string] = ACTIONS(6393),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6393),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6393),
    [anon_sym_BQUOTE] = ACTIONS(6393),
    [anon_sym_LT_LPAREN] = ACTIONS(6393),
    [anon_sym_GT_LPAREN] = ACTIONS(6393),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6391),
  },
  [2574] = {
    [anon_sym_esac] = ACTIONS(6389),
    [anon_sym_PIPE] = ACTIONS(5322),
    [anon_sym_SEMI_SEMI] = ACTIONS(6395),
    [anon_sym_PIPE_AMP] = ACTIONS(5322),
    [anon_sym_AMP_AMP] = ACTIONS(5326),
    [anon_sym_PIPE_PIPE] = ACTIONS(5326),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5328),
    [anon_sym_LF] = ACTIONS(5330),
    [anon_sym_AMP] = ACTIONS(5328),
  },
  [2575] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_esac] = ACTIONS(6389),
    [anon_sym_PIPE] = ACTIONS(5322),
    [anon_sym_SEMI_SEMI] = ACTIONS(6395),
    [anon_sym_PIPE_AMP] = ACTIONS(5322),
    [anon_sym_AMP_AMP] = ACTIONS(5326),
    [anon_sym_PIPE_PIPE] = ACTIONS(5326),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(5328),
    [anon_sym_LF] = ACTIONS(5330),
    [anon_sym_AMP] = ACTIONS(5328),
  },
  [2576] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_esac] = ACTIONS(6397),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(6399),
    [anon_sym_DQUOTE] = ACTIONS(6401),
    [anon_sym_DOLLAR] = ACTIONS(6399),
    [sym_raw_string] = ACTIONS(6401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6401),
    [anon_sym_BQUOTE] = ACTIONS(6401),
    [anon_sym_LT_LPAREN] = ACTIONS(6401),
    [anon_sym_GT_LPAREN] = ACTIONS(6401),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6399),
  },
  [2577] = {
    [anon_sym_esac] = ACTIONS(6397),
    [sym__special_characters] = ACTIONS(6401),
    [anon_sym_DQUOTE] = ACTIONS(6401),
    [anon_sym_DOLLAR] = ACTIONS(6399),
    [sym_raw_string] = ACTIONS(6401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6401),
    [anon_sym_BQUOTE] = ACTIONS(6401),
    [anon_sym_LT_LPAREN] = ACTIONS(6401),
    [anon_sym_GT_LPAREN] = ACTIONS(6401),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6399),
  },
  [2578] = {
    [anon_sym_esac] = ACTIONS(6397),
    [anon_sym_PIPE] = ACTIONS(5322),
    [anon_sym_SEMI_SEMI] = ACTIONS(6403),
    [anon_sym_PIPE_AMP] = ACTIONS(5322),
    [anon_sym_AMP_AMP] = ACTIONS(5326),
    [anon_sym_PIPE_PIPE] = ACTIONS(5326),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5328),
    [anon_sym_LF] = ACTIONS(5330),
    [anon_sym_AMP] = ACTIONS(5328),
  },
  [2579] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_esac] = ACTIONS(6397),
    [anon_sym_PIPE] = ACTIONS(5322),
    [anon_sym_SEMI_SEMI] = ACTIONS(6403),
    [anon_sym_PIPE_AMP] = ACTIONS(5322),
    [anon_sym_AMP_AMP] = ACTIONS(5326),
    [anon_sym_PIPE_PIPE] = ACTIONS(5326),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(5328),
    [anon_sym_LF] = ACTIONS(5330),
    [anon_sym_AMP] = ACTIONS(5328),
  },
  [2580] = {
    [sym__special_characters] = ACTIONS(5254),
    [anon_sym_DQUOTE] = ACTIONS(5254),
    [anon_sym_DOLLAR] = ACTIONS(5256),
    [sym_raw_string] = ACTIONS(5254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5254),
    [anon_sym_BQUOTE] = ACTIONS(5254),
    [anon_sym_LT_LPAREN] = ACTIONS(5254),
    [anon_sym_GT_LPAREN] = ACTIONS(5254),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5254),
  },
  [2581] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(6405),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2582] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(6405),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2583] = {
    [sym__terminated_statement] = STATE(2771),
    [sym_for_statement] = STATE(2769),
    [sym_while_statement] = STATE(2769),
    [sym_if_statement] = STATE(2769),
    [sym_case_statement] = STATE(2769),
    [sym_function_definition] = STATE(2769),
    [sym_subshell] = STATE(2769),
    [sym_pipeline] = STATE(2769),
    [sym_list] = STATE(2769),
    [sym_negated_command] = STATE(2769),
    [sym_test_command] = STATE(2769),
    [sym_declaration_command] = STATE(2769),
    [sym_unset_command] = STATE(2769),
    [sym_command] = STATE(2769),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2770),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2771),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(6407),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2584] = {
    [sym__terminated_statement] = STATE(2772),
    [sym_for_statement] = STATE(2769),
    [sym_while_statement] = STATE(2769),
    [sym_if_statement] = STATE(2769),
    [sym_case_statement] = STATE(2769),
    [sym_function_definition] = STATE(2769),
    [sym_subshell] = STATE(2769),
    [sym_pipeline] = STATE(2769),
    [sym_list] = STATE(2769),
    [sym_negated_command] = STATE(2769),
    [sym_test_command] = STATE(2769),
    [sym_declaration_command] = STATE(2769),
    [sym_unset_command] = STATE(2769),
    [sym_command] = STATE(2769),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2770),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2772),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(6407),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2585] = {
    [sym__special_characters] = ACTIONS(5363),
    [anon_sym_DQUOTE] = ACTIONS(5363),
    [anon_sym_DOLLAR] = ACTIONS(5365),
    [sym_raw_string] = ACTIONS(5363),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5363),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5363),
    [anon_sym_BQUOTE] = ACTIONS(5363),
    [anon_sym_LT_LPAREN] = ACTIONS(5363),
    [anon_sym_GT_LPAREN] = ACTIONS(5363),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5363),
  },
  [2586] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(6409),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2587] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(6409),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2588] = {
    [sym__terminated_statement] = STATE(2771),
    [sym_for_statement] = STATE(2775),
    [sym_while_statement] = STATE(2775),
    [sym_if_statement] = STATE(2775),
    [sym_case_statement] = STATE(2775),
    [sym_function_definition] = STATE(2775),
    [sym_subshell] = STATE(2775),
    [sym_pipeline] = STATE(2775),
    [sym_list] = STATE(2775),
    [sym_negated_command] = STATE(2775),
    [sym_test_command] = STATE(2775),
    [sym_declaration_command] = STATE(2775),
    [sym_unset_command] = STATE(2775),
    [sym_command] = STATE(2775),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2776),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2771),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(6411),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2589] = {
    [sym__terminated_statement] = STATE(2777),
    [sym_for_statement] = STATE(2775),
    [sym_while_statement] = STATE(2775),
    [sym_if_statement] = STATE(2775),
    [sym_case_statement] = STATE(2775),
    [sym_function_definition] = STATE(2775),
    [sym_subshell] = STATE(2775),
    [sym_pipeline] = STATE(2775),
    [sym_list] = STATE(2775),
    [sym_negated_command] = STATE(2775),
    [sym_test_command] = STATE(2775),
    [sym_declaration_command] = STATE(2775),
    [sym_unset_command] = STATE(2775),
    [sym_command] = STATE(2775),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2776),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2777),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(6411),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2590] = {
    [sym_file_descriptor] = ACTIONS(3917),
    [sym__concat] = ACTIONS(3917),
    [anon_sym_esac] = ACTIONS(3919),
    [anon_sym_PIPE] = ACTIONS(3919),
    [anon_sym_RPAREN] = ACTIONS(3919),
    [anon_sym_SEMI_SEMI] = ACTIONS(3919),
    [anon_sym_PIPE_AMP] = ACTIONS(3919),
    [anon_sym_AMP_AMP] = ACTIONS(3919),
    [anon_sym_PIPE_PIPE] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_GT] = ACTIONS(3919),
    [anon_sym_GT_GT] = ACTIONS(3919),
    [anon_sym_AMP_GT] = ACTIONS(3919),
    [anon_sym_AMP_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_AMP] = ACTIONS(3919),
    [anon_sym_GT_AMP] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_LT_LT_DASH] = ACTIONS(3919),
    [anon_sym_LT_LT_LT] = ACTIONS(3919),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3919),
    [anon_sym_LF] = ACTIONS(3917),
    [anon_sym_AMP] = ACTIONS(3919),
  },
  [2591] = {
    [sym_file_descriptor] = ACTIONS(3923),
    [sym__concat] = ACTIONS(3923),
    [anon_sym_esac] = ACTIONS(3925),
    [anon_sym_PIPE] = ACTIONS(3925),
    [anon_sym_RPAREN] = ACTIONS(3925),
    [anon_sym_SEMI_SEMI] = ACTIONS(3925),
    [anon_sym_PIPE_AMP] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_GT] = ACTIONS(3925),
    [anon_sym_GT_GT] = ACTIONS(3925),
    [anon_sym_AMP_GT] = ACTIONS(3925),
    [anon_sym_AMP_GT_GT] = ACTIONS(3925),
    [anon_sym_LT_AMP] = ACTIONS(3925),
    [anon_sym_GT_AMP] = ACTIONS(3925),
    [anon_sym_LT_LT] = ACTIONS(3925),
    [anon_sym_LT_LT_DASH] = ACTIONS(3925),
    [anon_sym_LT_LT_LT] = ACTIONS(3925),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3925),
    [anon_sym_LF] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3925),
  },
  [2592] = {
    [sym_file_descriptor] = ACTIONS(4008),
    [sym__concat] = ACTIONS(4008),
    [anon_sym_esac] = ACTIONS(4010),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_RPAREN] = ACTIONS(4010),
    [anon_sym_SEMI_SEMI] = ACTIONS(4010),
    [anon_sym_PIPE_AMP] = ACTIONS(4010),
    [anon_sym_AMP_AMP] = ACTIONS(4010),
    [anon_sym_PIPE_PIPE] = ACTIONS(4010),
    [anon_sym_LT] = ACTIONS(4010),
    [anon_sym_GT] = ACTIONS(4010),
    [anon_sym_GT_GT] = ACTIONS(4010),
    [anon_sym_AMP_GT] = ACTIONS(4010),
    [anon_sym_AMP_GT_GT] = ACTIONS(4010),
    [anon_sym_LT_AMP] = ACTIONS(4010),
    [anon_sym_GT_AMP] = ACTIONS(4010),
    [anon_sym_LT_LT] = ACTIONS(4010),
    [anon_sym_LT_LT_DASH] = ACTIONS(4010),
    [anon_sym_LT_LT_LT] = ACTIONS(4010),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LF] = ACTIONS(4008),
    [anon_sym_AMP] = ACTIONS(4010),
  },
  [2593] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6413),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2594] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(6415),
    [sym_comment] = ACTIONS(53),
  },
  [2595] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(6417),
    [sym_comment] = ACTIONS(53),
  },
  [2596] = {
    [anon_sym_RBRACE] = ACTIONS(6417),
    [sym_comment] = ACTIONS(53),
  },
  [2597] = {
    [sym_concatenation] = STATE(2782),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2782),
    [anon_sym_RBRACE] = ACTIONS(6419),
    [anon_sym_EQ] = ACTIONS(6421),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6423),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6421),
    [anon_sym_COLON_QMARK] = ACTIONS(6421),
    [anon_sym_COLON_DASH] = ACTIONS(6421),
    [anon_sym_PERCENT] = ACTIONS(6421),
    [anon_sym_DASH] = ACTIONS(6421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2598] = {
    [sym_file_descriptor] = ACTIONS(4024),
    [sym__concat] = ACTIONS(4024),
    [anon_sym_esac] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_RPAREN] = ACTIONS(4026),
    [anon_sym_SEMI_SEMI] = ACTIONS(4026),
    [anon_sym_PIPE_AMP] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4026),
    [anon_sym_PIPE_PIPE] = ACTIONS(4026),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_AMP_GT] = ACTIONS(4026),
    [anon_sym_AMP_GT_GT] = ACTIONS(4026),
    [anon_sym_LT_AMP] = ACTIONS(4026),
    [anon_sym_GT_AMP] = ACTIONS(4026),
    [anon_sym_LT_LT] = ACTIONS(4026),
    [anon_sym_LT_LT_DASH] = ACTIONS(4026),
    [anon_sym_LT_LT_LT] = ACTIONS(4026),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4026),
    [anon_sym_LF] = ACTIONS(4024),
    [anon_sym_AMP] = ACTIONS(4026),
  },
  [2599] = {
    [sym_concatenation] = STATE(2784),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2784),
    [anon_sym_RBRACE] = ACTIONS(6425),
    [anon_sym_EQ] = ACTIONS(6427),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6427),
    [anon_sym_COLON_QMARK] = ACTIONS(6427),
    [anon_sym_COLON_DASH] = ACTIONS(6427),
    [anon_sym_PERCENT] = ACTIONS(6427),
    [anon_sym_DASH] = ACTIONS(6427),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2600] = {
    [sym_file_descriptor] = ACTIONS(4034),
    [sym__concat] = ACTIONS(4034),
    [anon_sym_esac] = ACTIONS(4036),
    [anon_sym_PIPE] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_SEMI_SEMI] = ACTIONS(4036),
    [anon_sym_PIPE_AMP] = ACTIONS(4036),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4036),
    [anon_sym_GT] = ACTIONS(4036),
    [anon_sym_GT_GT] = ACTIONS(4036),
    [anon_sym_AMP_GT] = ACTIONS(4036),
    [anon_sym_AMP_GT_GT] = ACTIONS(4036),
    [anon_sym_LT_AMP] = ACTIONS(4036),
    [anon_sym_GT_AMP] = ACTIONS(4036),
    [anon_sym_LT_LT] = ACTIONS(4036),
    [anon_sym_LT_LT_DASH] = ACTIONS(4036),
    [anon_sym_LT_LT_LT] = ACTIONS(4036),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4036),
    [anon_sym_LF] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
  },
  [2601] = {
    [sym_concatenation] = STATE(2786),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2786),
    [anon_sym_RBRACE] = ACTIONS(6431),
    [anon_sym_EQ] = ACTIONS(6433),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6435),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6433),
    [anon_sym_COLON_QMARK] = ACTIONS(6433),
    [anon_sym_COLON_DASH] = ACTIONS(6433),
    [anon_sym_PERCENT] = ACTIONS(6433),
    [anon_sym_DASH] = ACTIONS(6433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2602] = {
    [sym_file_descriptor] = ACTIONS(4044),
    [sym__concat] = ACTIONS(4044),
    [anon_sym_esac] = ACTIONS(4046),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_RPAREN] = ACTIONS(4046),
    [anon_sym_SEMI_SEMI] = ACTIONS(4046),
    [anon_sym_PIPE_AMP] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4046),
    [anon_sym_PIPE_PIPE] = ACTIONS(4046),
    [anon_sym_LT] = ACTIONS(4046),
    [anon_sym_GT] = ACTIONS(4046),
    [anon_sym_GT_GT] = ACTIONS(4046),
    [anon_sym_AMP_GT] = ACTIONS(4046),
    [anon_sym_AMP_GT_GT] = ACTIONS(4046),
    [anon_sym_LT_AMP] = ACTIONS(4046),
    [anon_sym_GT_AMP] = ACTIONS(4046),
    [anon_sym_LT_LT] = ACTIONS(4046),
    [anon_sym_LT_LT_DASH] = ACTIONS(4046),
    [anon_sym_LT_LT_LT] = ACTIONS(4046),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4046),
    [anon_sym_LF] = ACTIONS(4044),
    [anon_sym_AMP] = ACTIONS(4046),
  },
  [2603] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6437),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2604] = {
    [sym_file_descriptor] = ACTIONS(4050),
    [sym__concat] = ACTIONS(4050),
    [anon_sym_esac] = ACTIONS(4052),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_RPAREN] = ACTIONS(4052),
    [anon_sym_SEMI_SEMI] = ACTIONS(4052),
    [anon_sym_PIPE_AMP] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4052),
    [anon_sym_PIPE_PIPE] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_AMP_GT] = ACTIONS(4052),
    [anon_sym_AMP_GT_GT] = ACTIONS(4052),
    [anon_sym_LT_AMP] = ACTIONS(4052),
    [anon_sym_GT_AMP] = ACTIONS(4052),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_LT_LT_DASH] = ACTIONS(4052),
    [anon_sym_LT_LT_LT] = ACTIONS(4052),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4052),
    [anon_sym_LF] = ACTIONS(4050),
    [anon_sym_AMP] = ACTIONS(4052),
  },
  [2605] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6439),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2606] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_RBRACE] = ACTIONS(4884),
    [sym_comment] = ACTIONS(53),
  },
  [2607] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_RBRACE] = ACTIONS(4888),
    [sym_comment] = ACTIONS(53),
  },
  [2608] = {
    [sym__concat] = ACTIONS(4892),
    [anon_sym_RBRACE] = ACTIONS(4892),
    [sym_comment] = ACTIONS(53),
  },
  [2609] = {
    [sym__concat] = ACTIONS(4896),
    [anon_sym_RBRACE] = ACTIONS(4896),
    [sym_comment] = ACTIONS(53),
  },
  [2610] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6441),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2611] = {
    [sym__concat] = ACTIONS(4902),
    [anon_sym_RBRACE] = ACTIONS(4902),
    [sym_comment] = ACTIONS(53),
  },
  [2612] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6443),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2613] = {
    [sym__concat] = ACTIONS(4908),
    [anon_sym_RBRACE] = ACTIONS(4908),
    [sym_comment] = ACTIONS(53),
  },
  [2614] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6445),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2615] = {
    [sym__concat] = ACTIONS(4914),
    [anon_sym_RBRACE] = ACTIONS(4914),
    [sym_comment] = ACTIONS(53),
  },
  [2616] = {
    [sym__concat] = ACTIONS(4918),
    [anon_sym_RBRACE] = ACTIONS(4918),
    [sym_comment] = ACTIONS(53),
  },
  [2617] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_RBRACE] = ACTIONS(5540),
    [anon_sym_EQ] = ACTIONS(5542),
    [sym__special_characters] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5540),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5540),
    [anon_sym_POUND] = ACTIONS(5540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5540),
    [anon_sym_COLON] = ACTIONS(5542),
    [anon_sym_COLON_QMARK] = ACTIONS(5542),
    [anon_sym_COLON_DASH] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_DASH] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5540),
    [anon_sym_BQUOTE] = ACTIONS(5540),
    [anon_sym_LT_LPAREN] = ACTIONS(5540),
    [anon_sym_GT_LPAREN] = ACTIONS(5540),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5542),
  },
  [2618] = {
    [sym__concat] = ACTIONS(5544),
    [anon_sym_RBRACE] = ACTIONS(5544),
    [anon_sym_EQ] = ACTIONS(5546),
    [sym__special_characters] = ACTIONS(5546),
    [anon_sym_DQUOTE] = ACTIONS(5544),
    [anon_sym_DOLLAR] = ACTIONS(5546),
    [sym_raw_string] = ACTIONS(5544),
    [anon_sym_POUND] = ACTIONS(5544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5544),
    [anon_sym_COLON] = ACTIONS(5546),
    [anon_sym_COLON_QMARK] = ACTIONS(5546),
    [anon_sym_COLON_DASH] = ACTIONS(5546),
    [anon_sym_PERCENT] = ACTIONS(5546),
    [anon_sym_DASH] = ACTIONS(5546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5544),
    [anon_sym_BQUOTE] = ACTIONS(5544),
    [anon_sym_LT_LPAREN] = ACTIONS(5544),
    [anon_sym_GT_LPAREN] = ACTIONS(5544),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5546),
  },
  [2619] = {
    [sym__concat] = ACTIONS(5548),
    [anon_sym_RBRACE] = ACTIONS(5548),
    [anon_sym_EQ] = ACTIONS(5550),
    [sym__special_characters] = ACTIONS(5550),
    [anon_sym_DQUOTE] = ACTIONS(5548),
    [anon_sym_DOLLAR] = ACTIONS(5550),
    [sym_raw_string] = ACTIONS(5548),
    [anon_sym_POUND] = ACTIONS(5548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5548),
    [anon_sym_COLON] = ACTIONS(5550),
    [anon_sym_COLON_QMARK] = ACTIONS(5550),
    [anon_sym_COLON_DASH] = ACTIONS(5550),
    [anon_sym_PERCENT] = ACTIONS(5550),
    [anon_sym_DASH] = ACTIONS(5550),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5548),
    [anon_sym_BQUOTE] = ACTIONS(5548),
    [anon_sym_LT_LPAREN] = ACTIONS(5548),
    [anon_sym_GT_LPAREN] = ACTIONS(5548),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5550),
  },
  [2620] = {
    [anon_sym_PIPE] = ACTIONS(5928),
    [anon_sym_RPAREN] = ACTIONS(5930),
    [anon_sym_PIPE_AMP] = ACTIONS(5930),
    [anon_sym_AMP_AMP] = ACTIONS(5930),
    [anon_sym_PIPE_PIPE] = ACTIONS(5930),
    [anon_sym_BQUOTE] = ACTIONS(5930),
    [sym_comment] = ACTIONS(53),
  },
  [2621] = {
    [anon_sym_PIPE] = ACTIONS(5932),
    [anon_sym_RPAREN] = ACTIONS(5934),
    [anon_sym_PIPE_AMP] = ACTIONS(5934),
    [anon_sym_AMP_AMP] = ACTIONS(5934),
    [anon_sym_PIPE_PIPE] = ACTIONS(5934),
    [anon_sym_BQUOTE] = ACTIONS(5934),
    [sym_comment] = ACTIONS(53),
  },
  [2622] = {
    [sym_file_descriptor] = ACTIONS(2752),
    [sym__concat] = ACTIONS(2752),
    [anon_sym_PIPE] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(2752),
    [anon_sym_PIPE_AMP] = ACTIONS(2752),
    [anon_sym_AMP_AMP] = ACTIONS(2752),
    [anon_sym_PIPE_PIPE] = ACTIONS(2752),
    [anon_sym_LT] = ACTIONS(2754),
    [anon_sym_GT] = ACTIONS(2754),
    [anon_sym_GT_GT] = ACTIONS(2752),
    [anon_sym_AMP_GT] = ACTIONS(2754),
    [anon_sym_AMP_GT_GT] = ACTIONS(2752),
    [anon_sym_LT_AMP] = ACTIONS(2752),
    [anon_sym_GT_AMP] = ACTIONS(2752),
    [anon_sym_LT_LT] = ACTIONS(2754),
    [anon_sym_LT_LT_DASH] = ACTIONS(2752),
    [anon_sym_LT_LT_LT] = ACTIONS(2752),
    [anon_sym_BQUOTE] = ACTIONS(2752),
    [sym_comment] = ACTIONS(53),
  },
  [2623] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(6447),
    [sym_comment] = ACTIONS(53),
  },
  [2624] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(6449),
    [sym_comment] = ACTIONS(53),
  },
  [2625] = {
    [anon_sym_RBRACE] = ACTIONS(6449),
    [sym_comment] = ACTIONS(53),
  },
  [2626] = {
    [sym_concatenation] = STATE(2795),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2795),
    [anon_sym_RBRACE] = ACTIONS(6451),
    [anon_sym_EQ] = ACTIONS(6453),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6453),
    [anon_sym_COLON_QMARK] = ACTIONS(6453),
    [anon_sym_COLON_DASH] = ACTIONS(6453),
    [anon_sym_PERCENT] = ACTIONS(6453),
    [anon_sym_DASH] = ACTIONS(6453),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2627] = {
    [sym_file_descriptor] = ACTIONS(2830),
    [sym__concat] = ACTIONS(2830),
    [anon_sym_PIPE] = ACTIONS(2832),
    [anon_sym_RPAREN] = ACTIONS(2830),
    [anon_sym_PIPE_AMP] = ACTIONS(2830),
    [anon_sym_AMP_AMP] = ACTIONS(2830),
    [anon_sym_PIPE_PIPE] = ACTIONS(2830),
    [anon_sym_LT] = ACTIONS(2832),
    [anon_sym_GT] = ACTIONS(2832),
    [anon_sym_GT_GT] = ACTIONS(2830),
    [anon_sym_AMP_GT] = ACTIONS(2832),
    [anon_sym_AMP_GT_GT] = ACTIONS(2830),
    [anon_sym_LT_AMP] = ACTIONS(2830),
    [anon_sym_GT_AMP] = ACTIONS(2830),
    [anon_sym_LT_LT] = ACTIONS(2832),
    [anon_sym_LT_LT_DASH] = ACTIONS(2830),
    [anon_sym_LT_LT_LT] = ACTIONS(2830),
    [anon_sym_BQUOTE] = ACTIONS(2830),
    [sym_comment] = ACTIONS(53),
  },
  [2628] = {
    [sym_concatenation] = STATE(2798),
    [sym_string] = STATE(2797),
    [sym_simple_expansion] = STATE(2797),
    [sym_string_expansion] = STATE(2797),
    [sym_expansion] = STATE(2797),
    [sym_command_substitution] = STATE(2797),
    [sym_process_substitution] = STATE(2797),
    [anon_sym_RBRACE] = ACTIONS(6449),
    [sym__special_characters] = ACTIONS(6457),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(6459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6459),
  },
  [2629] = {
    [sym_file_descriptor] = ACTIONS(2873),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_PIPE_AMP] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_GT] = ACTIONS(2873),
    [anon_sym_AMP_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT_GT] = ACTIONS(2873),
    [anon_sym_LT_AMP] = ACTIONS(2873),
    [anon_sym_GT_AMP] = ACTIONS(2873),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_LT_LT_DASH] = ACTIONS(2873),
    [anon_sym_LT_LT_LT] = ACTIONS(2873),
    [anon_sym_BQUOTE] = ACTIONS(2873),
    [sym_comment] = ACTIONS(53),
  },
  [2630] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6461),
  },
  [2631] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6463),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2632] = {
    [sym_file_descriptor] = ACTIONS(2881),
    [sym__concat] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [anon_sym_PIPE_AMP] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_GT_GT] = ACTIONS(2881),
    [anon_sym_AMP_GT] = ACTIONS(2883),
    [anon_sym_AMP_GT_GT] = ACTIONS(2881),
    [anon_sym_LT_AMP] = ACTIONS(2881),
    [anon_sym_GT_AMP] = ACTIONS(2881),
    [anon_sym_LT_LT] = ACTIONS(2883),
    [anon_sym_LT_LT_DASH] = ACTIONS(2881),
    [anon_sym_LT_LT_LT] = ACTIONS(2881),
    [anon_sym_BQUOTE] = ACTIONS(2881),
    [sym_comment] = ACTIONS(53),
  },
  [2633] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6465),
  },
  [2634] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6467),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2635] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6469),
  },
  [2636] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6449),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2637] = {
    [sym_concatenation] = STATE(2805),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2805),
    [anon_sym_RBRACE] = ACTIONS(6471),
    [anon_sym_EQ] = ACTIONS(6473),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6475),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6473),
    [anon_sym_COLON_QMARK] = ACTIONS(6473),
    [anon_sym_COLON_DASH] = ACTIONS(6473),
    [anon_sym_PERCENT] = ACTIONS(6473),
    [anon_sym_DASH] = ACTIONS(6473),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2638] = {
    [sym_file_descriptor] = ACTIONS(2897),
    [sym__concat] = ACTIONS(2897),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_RPAREN] = ACTIONS(2897),
    [anon_sym_PIPE_AMP] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2897),
    [anon_sym_PIPE_PIPE] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2899),
    [anon_sym_GT] = ACTIONS(2899),
    [anon_sym_GT_GT] = ACTIONS(2897),
    [anon_sym_AMP_GT] = ACTIONS(2899),
    [anon_sym_AMP_GT_GT] = ACTIONS(2897),
    [anon_sym_LT_AMP] = ACTIONS(2897),
    [anon_sym_GT_AMP] = ACTIONS(2897),
    [anon_sym_LT_LT] = ACTIONS(2899),
    [anon_sym_LT_LT_DASH] = ACTIONS(2897),
    [anon_sym_LT_LT_LT] = ACTIONS(2897),
    [anon_sym_BQUOTE] = ACTIONS(2897),
    [sym_comment] = ACTIONS(53),
  },
  [2639] = {
    [sym_concatenation] = STATE(2807),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2807),
    [anon_sym_RBRACE] = ACTIONS(6477),
    [anon_sym_EQ] = ACTIONS(6479),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6479),
    [anon_sym_COLON_QMARK] = ACTIONS(6479),
    [anon_sym_COLON_DASH] = ACTIONS(6479),
    [anon_sym_PERCENT] = ACTIONS(6479),
    [anon_sym_DASH] = ACTIONS(6479),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2640] = {
    [sym__concat] = ACTIONS(5540),
    [sym_variable_name] = ACTIONS(5540),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_RPAREN] = ACTIONS(5540),
    [anon_sym_PIPE_AMP] = ACTIONS(5540),
    [anon_sym_AMP_AMP] = ACTIONS(5540),
    [anon_sym_PIPE_PIPE] = ACTIONS(5540),
    [sym__special_characters] = ACTIONS(5540),
    [anon_sym_DQUOTE] = ACTIONS(5540),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5540),
    [anon_sym_BQUOTE] = ACTIONS(5540),
    [anon_sym_LT_LPAREN] = ACTIONS(5540),
    [anon_sym_GT_LPAREN] = ACTIONS(5540),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5542),
    [sym_word] = ACTIONS(5542),
  },
  [2641] = {
    [sym__concat] = ACTIONS(5544),
    [sym_variable_name] = ACTIONS(5544),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_RPAREN] = ACTIONS(5544),
    [anon_sym_PIPE_AMP] = ACTIONS(5544),
    [anon_sym_AMP_AMP] = ACTIONS(5544),
    [anon_sym_PIPE_PIPE] = ACTIONS(5544),
    [sym__special_characters] = ACTIONS(5544),
    [anon_sym_DQUOTE] = ACTIONS(5544),
    [anon_sym_DOLLAR] = ACTIONS(5546),
    [sym_raw_string] = ACTIONS(5544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5544),
    [anon_sym_BQUOTE] = ACTIONS(5544),
    [anon_sym_LT_LPAREN] = ACTIONS(5544),
    [anon_sym_GT_LPAREN] = ACTIONS(5544),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5546),
    [sym_word] = ACTIONS(5546),
  },
  [2642] = {
    [sym__concat] = ACTIONS(5548),
    [sym_variable_name] = ACTIONS(5548),
    [anon_sym_PIPE] = ACTIONS(5550),
    [anon_sym_RPAREN] = ACTIONS(5548),
    [anon_sym_PIPE_AMP] = ACTIONS(5548),
    [anon_sym_AMP_AMP] = ACTIONS(5548),
    [anon_sym_PIPE_PIPE] = ACTIONS(5548),
    [sym__special_characters] = ACTIONS(5548),
    [anon_sym_DQUOTE] = ACTIONS(5548),
    [anon_sym_DOLLAR] = ACTIONS(5550),
    [sym_raw_string] = ACTIONS(5548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5548),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5548),
    [anon_sym_BQUOTE] = ACTIONS(5548),
    [anon_sym_LT_LPAREN] = ACTIONS(5548),
    [anon_sym_GT_LPAREN] = ACTIONS(5548),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5550),
    [sym_word] = ACTIONS(5550),
  },
  [2643] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_RPAREN] = ACTIONS(5540),
    [anon_sym_PIPE_AMP] = ACTIONS(5540),
    [anon_sym_AMP_AMP] = ACTIONS(5540),
    [anon_sym_PIPE_PIPE] = ACTIONS(5540),
    [sym__special_characters] = ACTIONS(5540),
    [anon_sym_DQUOTE] = ACTIONS(5540),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5540),
    [anon_sym_BQUOTE] = ACTIONS(5540),
    [anon_sym_LT_LPAREN] = ACTIONS(5540),
    [anon_sym_GT_LPAREN] = ACTIONS(5540),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5542),
    [sym_word] = ACTIONS(5542),
  },
  [2644] = {
    [sym__concat] = ACTIONS(5544),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_RPAREN] = ACTIONS(5544),
    [anon_sym_PIPE_AMP] = ACTIONS(5544),
    [anon_sym_AMP_AMP] = ACTIONS(5544),
    [anon_sym_PIPE_PIPE] = ACTIONS(5544),
    [sym__special_characters] = ACTIONS(5544),
    [anon_sym_DQUOTE] = ACTIONS(5544),
    [anon_sym_DOLLAR] = ACTIONS(5546),
    [sym_raw_string] = ACTIONS(5544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5544),
    [anon_sym_BQUOTE] = ACTIONS(5544),
    [anon_sym_LT_LPAREN] = ACTIONS(5544),
    [anon_sym_GT_LPAREN] = ACTIONS(5544),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5546),
    [sym_word] = ACTIONS(5546),
  },
  [2645] = {
    [sym__concat] = ACTIONS(5548),
    [anon_sym_PIPE] = ACTIONS(5550),
    [anon_sym_RPAREN] = ACTIONS(5548),
    [anon_sym_PIPE_AMP] = ACTIONS(5548),
    [anon_sym_AMP_AMP] = ACTIONS(5548),
    [anon_sym_PIPE_PIPE] = ACTIONS(5548),
    [sym__special_characters] = ACTIONS(5548),
    [anon_sym_DQUOTE] = ACTIONS(5548),
    [anon_sym_DOLLAR] = ACTIONS(5550),
    [sym_raw_string] = ACTIONS(5548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5548),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5548),
    [anon_sym_BQUOTE] = ACTIONS(5548),
    [anon_sym_LT_LPAREN] = ACTIONS(5548),
    [anon_sym_GT_LPAREN] = ACTIONS(5548),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5550),
    [sym_word] = ACTIONS(5550),
  },
  [2646] = {
    [sym__heredoc_body_middle] = ACTIONS(5540),
    [sym__heredoc_body_end] = ACTIONS(5540),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5540),
    [sym_comment] = ACTIONS(53),
  },
  [2647] = {
    [sym__heredoc_body_middle] = ACTIONS(5544),
    [sym__heredoc_body_end] = ACTIONS(5544),
    [anon_sym_DOLLAR] = ACTIONS(5546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5544),
    [sym_comment] = ACTIONS(53),
  },
  [2648] = {
    [sym__heredoc_body_middle] = ACTIONS(5548),
    [sym__heredoc_body_end] = ACTIONS(5548),
    [anon_sym_DOLLAR] = ACTIONS(5550),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5548),
    [sym_comment] = ACTIONS(53),
  },
  [2649] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_RPAREN] = ACTIONS(5540),
    [sym__special_characters] = ACTIONS(5540),
    [anon_sym_DQUOTE] = ACTIONS(5540),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5540),
    [anon_sym_BQUOTE] = ACTIONS(5540),
    [anon_sym_LT_LPAREN] = ACTIONS(5540),
    [anon_sym_GT_LPAREN] = ACTIONS(5540),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5540),
  },
  [2650] = {
    [sym__concat] = ACTIONS(5544),
    [anon_sym_RPAREN] = ACTIONS(5544),
    [sym__special_characters] = ACTIONS(5544),
    [anon_sym_DQUOTE] = ACTIONS(5544),
    [anon_sym_DOLLAR] = ACTIONS(5546),
    [sym_raw_string] = ACTIONS(5544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5544),
    [anon_sym_BQUOTE] = ACTIONS(5544),
    [anon_sym_LT_LPAREN] = ACTIONS(5544),
    [anon_sym_GT_LPAREN] = ACTIONS(5544),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5544),
  },
  [2651] = {
    [sym__concat] = ACTIONS(5548),
    [anon_sym_RPAREN] = ACTIONS(5548),
    [sym__special_characters] = ACTIONS(5548),
    [anon_sym_DQUOTE] = ACTIONS(5548),
    [anon_sym_DOLLAR] = ACTIONS(5550),
    [sym_raw_string] = ACTIONS(5548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5548),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5548),
    [anon_sym_BQUOTE] = ACTIONS(5548),
    [anon_sym_LT_LPAREN] = ACTIONS(5548),
    [anon_sym_GT_LPAREN] = ACTIONS(5548),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5548),
  },
  [2652] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [sym__special_characters] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [anon_sym_LT_LPAREN] = ACTIONS(5542),
    [anon_sym_GT_LPAREN] = ACTIONS(5542),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5542),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [2653] = {
    [sym__concat] = ACTIONS(5544),
    [anon_sym_SEMI_SEMI] = ACTIONS(5546),
    [sym__special_characters] = ACTIONS(5546),
    [anon_sym_DQUOTE] = ACTIONS(5546),
    [anon_sym_DOLLAR] = ACTIONS(5546),
    [sym_raw_string] = ACTIONS(5546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5546),
    [anon_sym_BQUOTE] = ACTIONS(5546),
    [anon_sym_LT_LPAREN] = ACTIONS(5546),
    [anon_sym_GT_LPAREN] = ACTIONS(5546),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5546),
    [anon_sym_SEMI] = ACTIONS(5546),
    [anon_sym_LF] = ACTIONS(5544),
    [anon_sym_AMP] = ACTIONS(5546),
  },
  [2654] = {
    [sym__concat] = ACTIONS(5548),
    [anon_sym_SEMI_SEMI] = ACTIONS(5550),
    [sym__special_characters] = ACTIONS(5550),
    [anon_sym_DQUOTE] = ACTIONS(5550),
    [anon_sym_DOLLAR] = ACTIONS(5550),
    [sym_raw_string] = ACTIONS(5550),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5550),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5550),
    [anon_sym_BQUOTE] = ACTIONS(5550),
    [anon_sym_LT_LPAREN] = ACTIONS(5550),
    [anon_sym_GT_LPAREN] = ACTIONS(5550),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5550),
    [anon_sym_SEMI] = ACTIONS(5550),
    [anon_sym_LF] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
  },
  [2655] = {
    [sym_file_descriptor] = ACTIONS(2139),
    [sym_variable_name] = ACTIONS(2139),
    [anon_sym_esac] = ACTIONS(2141),
    [anon_sym_PIPE] = ACTIONS(2141),
    [anon_sym_SEMI_SEMI] = ACTIONS(2141),
    [anon_sym_PIPE_AMP] = ACTIONS(2141),
    [anon_sym_AMP_AMP] = ACTIONS(2141),
    [anon_sym_PIPE_PIPE] = ACTIONS(2141),
    [anon_sym_LT] = ACTIONS(2141),
    [anon_sym_GT] = ACTIONS(2141),
    [anon_sym_GT_GT] = ACTIONS(2141),
    [anon_sym_AMP_GT] = ACTIONS(2141),
    [anon_sym_AMP_GT_GT] = ACTIONS(2141),
    [anon_sym_LT_AMP] = ACTIONS(2141),
    [anon_sym_GT_AMP] = ACTIONS(2141),
    [sym__special_characters] = ACTIONS(2141),
    [anon_sym_DQUOTE] = ACTIONS(2141),
    [anon_sym_DOLLAR] = ACTIONS(2141),
    [sym_raw_string] = ACTIONS(2141),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2141),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2141),
    [anon_sym_BQUOTE] = ACTIONS(2141),
    [anon_sym_LT_LPAREN] = ACTIONS(2141),
    [anon_sym_GT_LPAREN] = ACTIONS(2141),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2141),
    [anon_sym_SEMI] = ACTIONS(2141),
    [anon_sym_LF] = ACTIONS(2139),
    [anon_sym_AMP] = ACTIONS(2141),
  },
  [2656] = {
    [sym_concatenation] = STATE(1019),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(1019),
    [anon_sym_RPAREN] = ACTIONS(6483),
    [sym__special_characters] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1119),
  },
  [2657] = {
    [sym_string] = STATE(2809),
    [sym_simple_expansion] = STATE(2809),
    [sym_string_expansion] = STATE(2809),
    [sym_expansion] = STATE(2809),
    [sym_command_substitution] = STATE(2809),
    [sym_process_substitution] = STATE(2809),
    [sym__special_characters] = ACTIONS(6485),
    [anon_sym_DQUOTE] = ACTIONS(5758),
    [anon_sym_DOLLAR] = ACTIONS(5760),
    [sym_raw_string] = ACTIONS(6485),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5764),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5766),
    [anon_sym_BQUOTE] = ACTIONS(5768),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6485),
  },
  [2658] = {
    [aux_sym_concatenation_repeat1] = STATE(2810),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(6085),
    [sym_variable_name] = ACTIONS(693),
    [anon_sym_esac] = ACTIONS(695),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(695),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [2659] = {
    [sym_file_descriptor] = ACTIONS(697),
    [sym__concat] = ACTIONS(697),
    [sym_variable_name] = ACTIONS(697),
    [anon_sym_esac] = ACTIONS(699),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_GT] = ACTIONS(699),
    [anon_sym_AMP_GT_GT] = ACTIONS(699),
    [anon_sym_LT_AMP] = ACTIONS(699),
    [anon_sym_GT_AMP] = ACTIONS(699),
    [sym__special_characters] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(699),
    [sym_raw_string] = ACTIONS(699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [anon_sym_LT_LPAREN] = ACTIONS(699),
    [anon_sym_GT_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_LF] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [2660] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(6487),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [2661] = {
    [sym_file_descriptor] = ACTIONS(727),
    [sym__concat] = ACTIONS(727),
    [sym_variable_name] = ACTIONS(727),
    [anon_sym_esac] = ACTIONS(729),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(729),
    [anon_sym_PIPE_AMP] = ACTIONS(729),
    [anon_sym_AMP_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(729),
    [anon_sym_LT] = ACTIONS(729),
    [anon_sym_GT] = ACTIONS(729),
    [anon_sym_GT_GT] = ACTIONS(729),
    [anon_sym_AMP_GT] = ACTIONS(729),
    [anon_sym_AMP_GT_GT] = ACTIONS(729),
    [anon_sym_LT_AMP] = ACTIONS(729),
    [anon_sym_GT_AMP] = ACTIONS(729),
    [sym__special_characters] = ACTIONS(729),
    [anon_sym_DQUOTE] = ACTIONS(729),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [sym_raw_string] = ACTIONS(729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(729),
    [anon_sym_BQUOTE] = ACTIONS(729),
    [anon_sym_LT_LPAREN] = ACTIONS(729),
    [anon_sym_GT_LPAREN] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(729),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_LF] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
  },
  [2662] = {
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(731),
    [sym_variable_name] = ACTIONS(731),
    [anon_sym_esac] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [sym__special_characters] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [anon_sym_LT_LPAREN] = ACTIONS(733),
    [anon_sym_GT_LPAREN] = ACTIONS(733),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [2663] = {
    [sym_file_descriptor] = ACTIONS(735),
    [sym__concat] = ACTIONS(735),
    [sym_variable_name] = ACTIONS(735),
    [anon_sym_esac] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(737),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(737),
    [anon_sym_LT_AMP] = ACTIONS(737),
    [anon_sym_GT_AMP] = ACTIONS(737),
    [sym__special_characters] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [sym_raw_string] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(737),
    [anon_sym_BQUOTE] = ACTIONS(737),
    [anon_sym_LT_LPAREN] = ACTIONS(737),
    [anon_sym_GT_LPAREN] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [2664] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(6489),
    [sym_comment] = ACTIONS(53),
  },
  [2665] = {
    [sym_concatenation] = STATE(2815),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2815),
    [anon_sym_RBRACE] = ACTIONS(6491),
    [anon_sym_EQ] = ACTIONS(6493),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6495),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6497),
    [anon_sym_COLON] = ACTIONS(6493),
    [anon_sym_COLON_QMARK] = ACTIONS(6493),
    [anon_sym_COLON_DASH] = ACTIONS(6493),
    [anon_sym_PERCENT] = ACTIONS(6493),
    [anon_sym_DASH] = ACTIONS(6493),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2666] = {
    [sym_subscript] = STATE(2819),
    [sym_variable_name] = ACTIONS(6499),
    [anon_sym_DOLLAR] = ACTIONS(6501),
    [anon_sym_DASH] = ACTIONS(6501),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6503),
    [anon_sym_STAR] = ACTIONS(6501),
    [anon_sym_AT] = ACTIONS(6501),
    [anon_sym_QMARK] = ACTIONS(6501),
    [anon_sym_0] = ACTIONS(6505),
    [anon_sym__] = ACTIONS(6505),
  },
  [2667] = {
    [sym_concatenation] = STATE(2822),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2822),
    [anon_sym_RBRACE] = ACTIONS(6507),
    [anon_sym_EQ] = ACTIONS(6509),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6511),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6513),
    [anon_sym_COLON] = ACTIONS(6509),
    [anon_sym_COLON_QMARK] = ACTIONS(6509),
    [anon_sym_COLON_DASH] = ACTIONS(6509),
    [anon_sym_PERCENT] = ACTIONS(6509),
    [anon_sym_DASH] = ACTIONS(6509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2668] = {
    [sym_concatenation] = STATE(2825),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2825),
    [anon_sym_RBRACE] = ACTIONS(6515),
    [anon_sym_EQ] = ACTIONS(6517),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6519),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6521),
    [anon_sym_COLON] = ACTIONS(6517),
    [anon_sym_COLON_QMARK] = ACTIONS(6517),
    [anon_sym_COLON_DASH] = ACTIONS(6517),
    [anon_sym_PERCENT] = ACTIONS(6517),
    [anon_sym_DASH] = ACTIONS(6517),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2669] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(6523),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [2670] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(6523),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2671] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(6523),
    [sym_comment] = ACTIONS(53),
  },
  [2672] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(6523),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2673] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(6525),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [2674] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(6525),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2675] = {
    [sym_file_redirect] = STATE(2566),
    [sym_heredoc_redirect] = STATE(2566),
    [sym_heredoc_body] = STATE(1064),
    [sym_herestring_redirect] = STATE(2566),
    [aux_sym_while_statement_repeat1] = STATE(2566),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(5332),
    [anon_sym_esac] = ACTIONS(2273),
    [anon_sym_PIPE] = ACTIONS(2273),
    [anon_sym_SEMI_SEMI] = ACTIONS(2273),
    [anon_sym_PIPE_AMP] = ACTIONS(2273),
    [anon_sym_AMP_AMP] = ACTIONS(2273),
    [anon_sym_PIPE_PIPE] = ACTIONS(2273),
    [anon_sym_LT] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(5336),
    [anon_sym_GT_GT] = ACTIONS(5336),
    [anon_sym_AMP_GT] = ACTIONS(5336),
    [anon_sym_AMP_GT_GT] = ACTIONS(5336),
    [anon_sym_LT_AMP] = ACTIONS(5336),
    [anon_sym_GT_AMP] = ACTIONS(5336),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(5338),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2273),
    [anon_sym_LF] = ACTIONS(2275),
    [anon_sym_AMP] = ACTIONS(2273),
  },
  [2676] = {
    [sym_compound_statement] = STATE(2828),
    [anon_sym_LBRACE] = ACTIONS(455),
    [sym_comment] = ACTIONS(53),
  },
  [2677] = {
    [anon_sym_LT] = ACTIONS(6527),
    [anon_sym_GT] = ACTIONS(6527),
    [anon_sym_GT_GT] = ACTIONS(6529),
    [anon_sym_AMP_GT] = ACTIONS(6527),
    [anon_sym_AMP_GT_GT] = ACTIONS(6529),
    [anon_sym_LT_AMP] = ACTIONS(6529),
    [anon_sym_GT_AMP] = ACTIONS(6529),
    [sym_comment] = ACTIONS(53),
  },
  [2678] = {
    [sym_concatenation] = STATE(1111),
    [sym_string] = STATE(2833),
    [sym_simple_expansion] = STATE(2833),
    [sym_string_expansion] = STATE(2833),
    [sym_expansion] = STATE(2833),
    [sym_command_substitution] = STATE(2833),
    [sym_process_substitution] = STATE(2833),
    [sym__special_characters] = ACTIONS(6531),
    [anon_sym_DQUOTE] = ACTIONS(6533),
    [anon_sym_DOLLAR] = ACTIONS(6535),
    [sym_raw_string] = ACTIONS(6537),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6539),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6541),
    [anon_sym_BQUOTE] = ACTIONS(6543),
    [anon_sym_LT_LPAREN] = ACTIONS(6545),
    [anon_sym_GT_LPAREN] = ACTIONS(6545),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6537),
  },
  [2679] = {
    [anon_sym_LT] = ACTIONS(6547),
    [anon_sym_GT] = ACTIONS(6547),
    [anon_sym_GT_GT] = ACTIONS(6549),
    [anon_sym_AMP_GT] = ACTIONS(6547),
    [anon_sym_AMP_GT_GT] = ACTIONS(6549),
    [anon_sym_LT_AMP] = ACTIONS(6549),
    [anon_sym_GT_AMP] = ACTIONS(6549),
    [sym_comment] = ACTIONS(53),
  },
  [2680] = {
    [sym_concatenation] = STATE(1161),
    [sym_string] = STATE(2840),
    [sym_simple_expansion] = STATE(2840),
    [sym_string_expansion] = STATE(2840),
    [sym_expansion] = STATE(2840),
    [sym_command_substitution] = STATE(2840),
    [sym_process_substitution] = STATE(2840),
    [sym__special_characters] = ACTIONS(6551),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(6553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2508),
    [anon_sym_BQUOTE] = ACTIONS(2510),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6553),
  },
  [2681] = {
    [sym_concatenation] = STATE(1165),
    [sym_string] = STATE(2842),
    [sym_simple_expansion] = STATE(2842),
    [sym_string_expansion] = STATE(2842),
    [sym_expansion] = STATE(2842),
    [sym_command_substitution] = STATE(2842),
    [sym_process_substitution] = STATE(2842),
    [sym__special_characters] = ACTIONS(6555),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(6557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2508),
    [anon_sym_BQUOTE] = ACTIONS(2510),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6557),
  },
  [2682] = {
    [sym_file_redirect] = STATE(2843),
    [sym_heredoc_redirect] = STATE(2843),
    [sym_herestring_redirect] = STATE(2843),
    [aux_sym_while_statement_repeat1] = STATE(2843),
    [sym_file_descriptor] = ACTIONS(6113),
    [anon_sym_esac] = ACTIONS(2520),
    [anon_sym_PIPE] = ACTIONS(2520),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(6115),
    [anon_sym_GT] = ACTIONS(6115),
    [anon_sym_GT_GT] = ACTIONS(6115),
    [anon_sym_AMP_GT] = ACTIONS(6115),
    [anon_sym_AMP_GT_GT] = ACTIONS(6115),
    [anon_sym_LT_AMP] = ACTIONS(6115),
    [anon_sym_GT_AMP] = ACTIONS(6115),
    [anon_sym_LT_LT] = ACTIONS(1357),
    [anon_sym_LT_LT_DASH] = ACTIONS(1357),
    [anon_sym_LT_LT_LT] = ACTIONS(6117),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2520),
    [anon_sym_LF] = ACTIONS(2522),
    [anon_sym_AMP] = ACTIONS(2520),
  },
  [2683] = {
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_esac] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [sym__special_characters] = ACTIONS(1109),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1109),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_LT_LPAREN] = ACTIONS(1109),
    [anon_sym_GT_LPAREN] = ACTIONS(1109),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1109),
    [sym_word] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1109),
  },
  [2684] = {
    [sym_concatenation] = STATE(2845),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(2845),
    [anon_sym_RPAREN] = ACTIONS(6559),
    [sym__special_characters] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1119),
  },
  [2685] = {
    [aux_sym_concatenation_repeat1] = STATE(2492),
    [sym__concat] = ACTIONS(5778),
    [sym_variable_name] = ACTIONS(1129),
    [anon_sym_esac] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_SEMI_SEMI] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [sym__special_characters] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1133),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [anon_sym_LT_LPAREN] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(1133),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1133),
    [sym_word] = ACTIONS(1133),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_LF] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1133),
  },
  [2686] = {
    [aux_sym_concatenation_repeat1] = STATE(2492),
    [sym__concat] = ACTIONS(5778),
    [sym_variable_name] = ACTIONS(1107),
    [anon_sym_esac] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_PIPE_AMP] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [sym__special_characters] = ACTIONS(1109),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1109),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_LT_LPAREN] = ACTIONS(1109),
    [anon_sym_GT_LPAREN] = ACTIONS(1109),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1109),
    [sym_word] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1109),
  },
  [2687] = {
    [sym__concat] = ACTIONS(1654),
    [sym_variable_name] = ACTIONS(1654),
    [anon_sym_esac] = ACTIONS(1656),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LT_LPAREN] = ACTIONS(1656),
    [anon_sym_GT_LPAREN] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1656),
    [sym_word] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [2688] = {
    [aux_sym_concatenation_repeat1] = STATE(2688),
    [sym__concat] = ACTIONS(6561),
    [sym_variable_name] = ACTIONS(1654),
    [anon_sym_esac] = ACTIONS(1656),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LT_LPAREN] = ACTIONS(1656),
    [anon_sym_GT_LPAREN] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1656),
    [sym_word] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [2689] = {
    [sym__concat] = ACTIONS(1703),
    [sym_variable_name] = ACTIONS(1703),
    [anon_sym_esac] = ACTIONS(1705),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_SEMI_SEMI] = ACTIONS(1705),
    [anon_sym_PIPE_AMP] = ACTIONS(1705),
    [anon_sym_AMP_AMP] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE] = ACTIONS(1705),
    [sym__special_characters] = ACTIONS(1705),
    [anon_sym_DQUOTE] = ACTIONS(1705),
    [anon_sym_DOLLAR] = ACTIONS(1705),
    [sym_raw_string] = ACTIONS(1705),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1705),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1705),
    [anon_sym_BQUOTE] = ACTIONS(1705),
    [anon_sym_LT_LPAREN] = ACTIONS(1705),
    [anon_sym_GT_LPAREN] = ACTIONS(1705),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1705),
    [sym_word] = ACTIONS(1705),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_LF] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1705),
  },
  [2690] = {
    [sym_concatenation] = STATE(2849),
    [sym_string] = STATE(2848),
    [sym_simple_expansion] = STATE(2848),
    [sym_string_expansion] = STATE(2848),
    [sym_expansion] = STATE(2848),
    [sym_command_substitution] = STATE(2848),
    [sym_process_substitution] = STATE(2848),
    [anon_sym_RBRACE] = ACTIONS(6564),
    [sym__special_characters] = ACTIONS(6566),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(6568),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6568),
  },
  [2691] = {
    [sym__concat] = ACTIONS(1744),
    [sym_variable_name] = ACTIONS(1744),
    [anon_sym_esac] = ACTIONS(1746),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_SEMI_SEMI] = ACTIONS(1746),
    [anon_sym_PIPE_AMP] = ACTIONS(1746),
    [anon_sym_AMP_AMP] = ACTIONS(1746),
    [anon_sym_PIPE_PIPE] = ACTIONS(1746),
    [sym__special_characters] = ACTIONS(1746),
    [anon_sym_DQUOTE] = ACTIONS(1746),
    [anon_sym_DOLLAR] = ACTIONS(1746),
    [sym_raw_string] = ACTIONS(1746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1746),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1746),
    [anon_sym_GT_LPAREN] = ACTIONS(1746),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1746),
    [sym_word] = ACTIONS(1746),
    [anon_sym_SEMI] = ACTIONS(1746),
    [anon_sym_LF] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(1746),
  },
  [2692] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6570),
  },
  [2693] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6572),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2694] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(6574),
    [sym_comment] = ACTIONS(53),
  },
  [2695] = {
    [sym_concatenation] = STATE(2855),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2855),
    [anon_sym_RBRACE] = ACTIONS(6576),
    [anon_sym_EQ] = ACTIONS(6578),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6580),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6582),
    [anon_sym_COLON] = ACTIONS(6578),
    [anon_sym_COLON_QMARK] = ACTIONS(6578),
    [anon_sym_COLON_DASH] = ACTIONS(6578),
    [anon_sym_PERCENT] = ACTIONS(6578),
    [anon_sym_DASH] = ACTIONS(6578),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2696] = {
    [sym_concatenation] = STATE(2858),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2858),
    [anon_sym_RBRACE] = ACTIONS(6584),
    [anon_sym_EQ] = ACTIONS(6586),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6588),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6590),
    [anon_sym_COLON] = ACTIONS(6586),
    [anon_sym_COLON_QMARK] = ACTIONS(6586),
    [anon_sym_COLON_DASH] = ACTIONS(6586),
    [anon_sym_PERCENT] = ACTIONS(6586),
    [anon_sym_DASH] = ACTIONS(6586),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2697] = {
    [sym_concatenation] = STATE(2860),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2860),
    [anon_sym_RBRACE] = ACTIONS(6564),
    [anon_sym_EQ] = ACTIONS(6592),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6594),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6596),
    [anon_sym_COLON] = ACTIONS(6592),
    [anon_sym_COLON_QMARK] = ACTIONS(6592),
    [anon_sym_COLON_DASH] = ACTIONS(6592),
    [anon_sym_PERCENT] = ACTIONS(6592),
    [anon_sym_DASH] = ACTIONS(6592),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2698] = {
    [sym__concat] = ACTIONS(1810),
    [sym_variable_name] = ACTIONS(1810),
    [anon_sym_esac] = ACTIONS(1812),
    [anon_sym_PIPE] = ACTIONS(1812),
    [anon_sym_SEMI_SEMI] = ACTIONS(1812),
    [anon_sym_PIPE_AMP] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1812),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [sym__special_characters] = ACTIONS(1812),
    [anon_sym_DQUOTE] = ACTIONS(1812),
    [anon_sym_DOLLAR] = ACTIONS(1812),
    [sym_raw_string] = ACTIONS(1812),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1812),
    [anon_sym_GT_LPAREN] = ACTIONS(1812),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1812),
    [sym_word] = ACTIONS(1812),
    [anon_sym_SEMI] = ACTIONS(1812),
    [anon_sym_LF] = ACTIONS(1810),
    [anon_sym_AMP] = ACTIONS(1812),
  },
  [2699] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6598),
  },
  [2700] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6600),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2701] = {
    [sym__concat] = ACTIONS(1818),
    [sym_variable_name] = ACTIONS(1818),
    [anon_sym_esac] = ACTIONS(1820),
    [anon_sym_PIPE] = ACTIONS(1820),
    [anon_sym_SEMI_SEMI] = ACTIONS(1820),
    [anon_sym_PIPE_AMP] = ACTIONS(1820),
    [anon_sym_AMP_AMP] = ACTIONS(1820),
    [anon_sym_PIPE_PIPE] = ACTIONS(1820),
    [sym__special_characters] = ACTIONS(1820),
    [anon_sym_DQUOTE] = ACTIONS(1820),
    [anon_sym_DOLLAR] = ACTIONS(1820),
    [sym_raw_string] = ACTIONS(1820),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1820),
    [anon_sym_BQUOTE] = ACTIONS(1820),
    [anon_sym_LT_LPAREN] = ACTIONS(1820),
    [anon_sym_GT_LPAREN] = ACTIONS(1820),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1820),
    [sym_word] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1820),
    [anon_sym_LF] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1820),
  },
  [2702] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6602),
  },
  [2703] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6564),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2704] = {
    [sym__concat] = ACTIONS(1952),
    [sym_variable_name] = ACTIONS(1952),
    [anon_sym_esac] = ACTIONS(1954),
    [anon_sym_PIPE] = ACTIONS(1954),
    [anon_sym_SEMI_SEMI] = ACTIONS(1954),
    [anon_sym_PIPE_AMP] = ACTIONS(1954),
    [anon_sym_AMP_AMP] = ACTIONS(1954),
    [anon_sym_PIPE_PIPE] = ACTIONS(1954),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1954),
    [anon_sym_DOLLAR] = ACTIONS(1954),
    [sym_raw_string] = ACTIONS(1954),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1954),
    [anon_sym_BQUOTE] = ACTIONS(1954),
    [anon_sym_LT_LPAREN] = ACTIONS(1954),
    [anon_sym_GT_LPAREN] = ACTIONS(1954),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1954),
    [sym_word] = ACTIONS(1954),
    [anon_sym_SEMI] = ACTIONS(1954),
    [anon_sym_LF] = ACTIONS(1952),
    [anon_sym_AMP] = ACTIONS(1954),
  },
  [2705] = {
    [sym__concat] = ACTIONS(2018),
    [sym_variable_name] = ACTIONS(2018),
    [anon_sym_esac] = ACTIONS(2020),
    [anon_sym_PIPE] = ACTIONS(2020),
    [anon_sym_SEMI_SEMI] = ACTIONS(2020),
    [anon_sym_PIPE_AMP] = ACTIONS(2020),
    [anon_sym_AMP_AMP] = ACTIONS(2020),
    [anon_sym_PIPE_PIPE] = ACTIONS(2020),
    [sym__special_characters] = ACTIONS(2020),
    [anon_sym_DQUOTE] = ACTIONS(2020),
    [anon_sym_DOLLAR] = ACTIONS(2020),
    [sym_raw_string] = ACTIONS(2020),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2020),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2020),
    [anon_sym_BQUOTE] = ACTIONS(2020),
    [anon_sym_LT_LPAREN] = ACTIONS(2020),
    [anon_sym_GT_LPAREN] = ACTIONS(2020),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2020),
    [sym_word] = ACTIONS(2020),
    [anon_sym_SEMI] = ACTIONS(2020),
    [anon_sym_LF] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2020),
  },
  [2706] = {
    [sym__concat] = ACTIONS(1654),
    [anon_sym_esac] = ACTIONS(1656),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LT_LPAREN] = ACTIONS(1656),
    [anon_sym_GT_LPAREN] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1656),
    [sym_word] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [2707] = {
    [aux_sym_concatenation_repeat1] = STATE(2707),
    [sym__concat] = ACTIONS(6604),
    [anon_sym_esac] = ACTIONS(1656),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LT_LPAREN] = ACTIONS(1656),
    [anon_sym_GT_LPAREN] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1656),
    [sym_word] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [2708] = {
    [sym__concat] = ACTIONS(1703),
    [anon_sym_esac] = ACTIONS(1705),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_SEMI_SEMI] = ACTIONS(1705),
    [anon_sym_PIPE_AMP] = ACTIONS(1705),
    [anon_sym_AMP_AMP] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE] = ACTIONS(1705),
    [sym__special_characters] = ACTIONS(1705),
    [anon_sym_DQUOTE] = ACTIONS(1705),
    [anon_sym_DOLLAR] = ACTIONS(1705),
    [sym_raw_string] = ACTIONS(1705),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1705),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1705),
    [anon_sym_BQUOTE] = ACTIONS(1705),
    [anon_sym_LT_LPAREN] = ACTIONS(1705),
    [anon_sym_GT_LPAREN] = ACTIONS(1705),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1705),
    [sym_word] = ACTIONS(1705),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_LF] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1705),
  },
  [2709] = {
    [sym_concatenation] = STATE(2867),
    [sym_string] = STATE(2866),
    [sym_simple_expansion] = STATE(2866),
    [sym_string_expansion] = STATE(2866),
    [sym_expansion] = STATE(2866),
    [sym_command_substitution] = STATE(2866),
    [sym_process_substitution] = STATE(2866),
    [anon_sym_RBRACE] = ACTIONS(6607),
    [sym__special_characters] = ACTIONS(6609),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(6611),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6611),
  },
  [2710] = {
    [sym__concat] = ACTIONS(1744),
    [anon_sym_esac] = ACTIONS(1746),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_SEMI_SEMI] = ACTIONS(1746),
    [anon_sym_PIPE_AMP] = ACTIONS(1746),
    [anon_sym_AMP_AMP] = ACTIONS(1746),
    [anon_sym_PIPE_PIPE] = ACTIONS(1746),
    [sym__special_characters] = ACTIONS(1746),
    [anon_sym_DQUOTE] = ACTIONS(1746),
    [anon_sym_DOLLAR] = ACTIONS(1746),
    [sym_raw_string] = ACTIONS(1746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1746),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1746),
    [anon_sym_GT_LPAREN] = ACTIONS(1746),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1746),
    [sym_word] = ACTIONS(1746),
    [anon_sym_SEMI] = ACTIONS(1746),
    [anon_sym_LF] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(1746),
  },
  [2711] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6613),
  },
  [2712] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6615),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2713] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(6617),
    [sym_comment] = ACTIONS(53),
  },
  [2714] = {
    [sym_concatenation] = STATE(2873),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2873),
    [anon_sym_RBRACE] = ACTIONS(6619),
    [anon_sym_EQ] = ACTIONS(6621),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6623),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6625),
    [anon_sym_COLON] = ACTIONS(6621),
    [anon_sym_COLON_QMARK] = ACTIONS(6621),
    [anon_sym_COLON_DASH] = ACTIONS(6621),
    [anon_sym_PERCENT] = ACTIONS(6621),
    [anon_sym_DASH] = ACTIONS(6621),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2715] = {
    [sym_concatenation] = STATE(2876),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2876),
    [anon_sym_RBRACE] = ACTIONS(6627),
    [anon_sym_EQ] = ACTIONS(6629),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6631),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6633),
    [anon_sym_COLON] = ACTIONS(6629),
    [anon_sym_COLON_QMARK] = ACTIONS(6629),
    [anon_sym_COLON_DASH] = ACTIONS(6629),
    [anon_sym_PERCENT] = ACTIONS(6629),
    [anon_sym_DASH] = ACTIONS(6629),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2716] = {
    [sym_concatenation] = STATE(2878),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2878),
    [anon_sym_RBRACE] = ACTIONS(6607),
    [anon_sym_EQ] = ACTIONS(6635),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6637),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6639),
    [anon_sym_COLON] = ACTIONS(6635),
    [anon_sym_COLON_QMARK] = ACTIONS(6635),
    [anon_sym_COLON_DASH] = ACTIONS(6635),
    [anon_sym_PERCENT] = ACTIONS(6635),
    [anon_sym_DASH] = ACTIONS(6635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2717] = {
    [sym__concat] = ACTIONS(1810),
    [anon_sym_esac] = ACTIONS(1812),
    [anon_sym_PIPE] = ACTIONS(1812),
    [anon_sym_SEMI_SEMI] = ACTIONS(1812),
    [anon_sym_PIPE_AMP] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1812),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [sym__special_characters] = ACTIONS(1812),
    [anon_sym_DQUOTE] = ACTIONS(1812),
    [anon_sym_DOLLAR] = ACTIONS(1812),
    [sym_raw_string] = ACTIONS(1812),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1812),
    [anon_sym_GT_LPAREN] = ACTIONS(1812),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1812),
    [sym_word] = ACTIONS(1812),
    [anon_sym_SEMI] = ACTIONS(1812),
    [anon_sym_LF] = ACTIONS(1810),
    [anon_sym_AMP] = ACTIONS(1812),
  },
  [2718] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6641),
  },
  [2719] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6643),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2720] = {
    [sym__concat] = ACTIONS(1818),
    [anon_sym_esac] = ACTIONS(1820),
    [anon_sym_PIPE] = ACTIONS(1820),
    [anon_sym_SEMI_SEMI] = ACTIONS(1820),
    [anon_sym_PIPE_AMP] = ACTIONS(1820),
    [anon_sym_AMP_AMP] = ACTIONS(1820),
    [anon_sym_PIPE_PIPE] = ACTIONS(1820),
    [sym__special_characters] = ACTIONS(1820),
    [anon_sym_DQUOTE] = ACTIONS(1820),
    [anon_sym_DOLLAR] = ACTIONS(1820),
    [sym_raw_string] = ACTIONS(1820),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1820),
    [anon_sym_BQUOTE] = ACTIONS(1820),
    [anon_sym_LT_LPAREN] = ACTIONS(1820),
    [anon_sym_GT_LPAREN] = ACTIONS(1820),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1820),
    [sym_word] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1820),
    [anon_sym_LF] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1820),
  },
  [2721] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6645),
  },
  [2722] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6607),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2723] = {
    [sym__concat] = ACTIONS(1952),
    [anon_sym_esac] = ACTIONS(1954),
    [anon_sym_PIPE] = ACTIONS(1954),
    [anon_sym_SEMI_SEMI] = ACTIONS(1954),
    [anon_sym_PIPE_AMP] = ACTIONS(1954),
    [anon_sym_AMP_AMP] = ACTIONS(1954),
    [anon_sym_PIPE_PIPE] = ACTIONS(1954),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1954),
    [anon_sym_DOLLAR] = ACTIONS(1954),
    [sym_raw_string] = ACTIONS(1954),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1954),
    [anon_sym_BQUOTE] = ACTIONS(1954),
    [anon_sym_LT_LPAREN] = ACTIONS(1954),
    [anon_sym_GT_LPAREN] = ACTIONS(1954),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1954),
    [sym_word] = ACTIONS(1954),
    [anon_sym_SEMI] = ACTIONS(1954),
    [anon_sym_LF] = ACTIONS(1952),
    [anon_sym_AMP] = ACTIONS(1954),
  },
  [2724] = {
    [sym__concat] = ACTIONS(2018),
    [anon_sym_esac] = ACTIONS(2020),
    [anon_sym_PIPE] = ACTIONS(2020),
    [anon_sym_SEMI_SEMI] = ACTIONS(2020),
    [anon_sym_PIPE_AMP] = ACTIONS(2020),
    [anon_sym_AMP_AMP] = ACTIONS(2020),
    [anon_sym_PIPE_PIPE] = ACTIONS(2020),
    [sym__special_characters] = ACTIONS(2020),
    [anon_sym_DQUOTE] = ACTIONS(2020),
    [anon_sym_DOLLAR] = ACTIONS(2020),
    [sym_raw_string] = ACTIONS(2020),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2020),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2020),
    [anon_sym_BQUOTE] = ACTIONS(2020),
    [anon_sym_LT_LPAREN] = ACTIONS(2020),
    [anon_sym_GT_LPAREN] = ACTIONS(2020),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2020),
    [sym_word] = ACTIONS(2020),
    [anon_sym_SEMI] = ACTIONS(2020),
    [anon_sym_LF] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2020),
  },
  [2725] = {
    [sym__simple_heredoc_body] = ACTIONS(2752),
    [sym__heredoc_body_beginning] = ACTIONS(2752),
    [sym_file_descriptor] = ACTIONS(2752),
    [sym__concat] = ACTIONS(2752),
    [anon_sym_esac] = ACTIONS(2754),
    [anon_sym_PIPE] = ACTIONS(2754),
    [anon_sym_SEMI_SEMI] = ACTIONS(2754),
    [anon_sym_PIPE_AMP] = ACTIONS(2754),
    [anon_sym_AMP_AMP] = ACTIONS(2754),
    [anon_sym_PIPE_PIPE] = ACTIONS(2754),
    [anon_sym_EQ_TILDE] = ACTIONS(2754),
    [anon_sym_EQ_EQ] = ACTIONS(2754),
    [anon_sym_LT] = ACTIONS(2754),
    [anon_sym_GT] = ACTIONS(2754),
    [anon_sym_GT_GT] = ACTIONS(2754),
    [anon_sym_AMP_GT] = ACTIONS(2754),
    [anon_sym_AMP_GT_GT] = ACTIONS(2754),
    [anon_sym_LT_AMP] = ACTIONS(2754),
    [anon_sym_GT_AMP] = ACTIONS(2754),
    [anon_sym_LT_LT] = ACTIONS(2754),
    [anon_sym_LT_LT_DASH] = ACTIONS(2754),
    [anon_sym_LT_LT_LT] = ACTIONS(2754),
    [sym__special_characters] = ACTIONS(2754),
    [anon_sym_DQUOTE] = ACTIONS(2754),
    [anon_sym_DOLLAR] = ACTIONS(2754),
    [sym_raw_string] = ACTIONS(2754),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2754),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2754),
    [anon_sym_BQUOTE] = ACTIONS(2754),
    [anon_sym_LT_LPAREN] = ACTIONS(2754),
    [anon_sym_GT_LPAREN] = ACTIONS(2754),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2754),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_LF] = ACTIONS(2752),
    [anon_sym_AMP] = ACTIONS(2754),
  },
  [2726] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(6647),
    [sym_comment] = ACTIONS(53),
  },
  [2727] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(6649),
    [sym_comment] = ACTIONS(53),
  },
  [2728] = {
    [anon_sym_RBRACE] = ACTIONS(6649),
    [sym_comment] = ACTIONS(53),
  },
  [2729] = {
    [sym_concatenation] = STATE(2885),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2885),
    [anon_sym_RBRACE] = ACTIONS(6651),
    [anon_sym_EQ] = ACTIONS(6653),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6655),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6653),
    [anon_sym_COLON_QMARK] = ACTIONS(6653),
    [anon_sym_COLON_DASH] = ACTIONS(6653),
    [anon_sym_PERCENT] = ACTIONS(6653),
    [anon_sym_DASH] = ACTIONS(6653),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2730] = {
    [sym__simple_heredoc_body] = ACTIONS(2830),
    [sym__heredoc_body_beginning] = ACTIONS(2830),
    [sym_file_descriptor] = ACTIONS(2830),
    [sym__concat] = ACTIONS(2830),
    [anon_sym_esac] = ACTIONS(2832),
    [anon_sym_PIPE] = ACTIONS(2832),
    [anon_sym_SEMI_SEMI] = ACTIONS(2832),
    [anon_sym_PIPE_AMP] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_PIPE_PIPE] = ACTIONS(2832),
    [anon_sym_EQ_TILDE] = ACTIONS(2832),
    [anon_sym_EQ_EQ] = ACTIONS(2832),
    [anon_sym_LT] = ACTIONS(2832),
    [anon_sym_GT] = ACTIONS(2832),
    [anon_sym_GT_GT] = ACTIONS(2832),
    [anon_sym_AMP_GT] = ACTIONS(2832),
    [anon_sym_AMP_GT_GT] = ACTIONS(2832),
    [anon_sym_LT_AMP] = ACTIONS(2832),
    [anon_sym_GT_AMP] = ACTIONS(2832),
    [anon_sym_LT_LT] = ACTIONS(2832),
    [anon_sym_LT_LT_DASH] = ACTIONS(2832),
    [anon_sym_LT_LT_LT] = ACTIONS(2832),
    [sym__special_characters] = ACTIONS(2832),
    [anon_sym_DQUOTE] = ACTIONS(2832),
    [anon_sym_DOLLAR] = ACTIONS(2832),
    [sym_raw_string] = ACTIONS(2832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2832),
    [anon_sym_BQUOTE] = ACTIONS(2832),
    [anon_sym_LT_LPAREN] = ACTIONS(2832),
    [anon_sym_GT_LPAREN] = ACTIONS(2832),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2832),
    [anon_sym_SEMI] = ACTIONS(2832),
    [anon_sym_LF] = ACTIONS(2830),
    [anon_sym_AMP] = ACTIONS(2832),
  },
  [2731] = {
    [sym_concatenation] = STATE(2888),
    [sym_string] = STATE(2887),
    [sym_simple_expansion] = STATE(2887),
    [sym_string_expansion] = STATE(2887),
    [sym_expansion] = STATE(2887),
    [sym_command_substitution] = STATE(2887),
    [sym_process_substitution] = STATE(2887),
    [anon_sym_RBRACE] = ACTIONS(6649),
    [sym__special_characters] = ACTIONS(6657),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(6659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6659),
  },
  [2732] = {
    [sym__simple_heredoc_body] = ACTIONS(2873),
    [sym__heredoc_body_beginning] = ACTIONS(2873),
    [sym_file_descriptor] = ACTIONS(2873),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_esac] = ACTIONS(2875),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [anon_sym_PIPE_AMP] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [anon_sym_EQ_TILDE] = ACTIONS(2875),
    [anon_sym_EQ_EQ] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT_GT] = ACTIONS(2875),
    [anon_sym_LT_AMP] = ACTIONS(2875),
    [anon_sym_GT_AMP] = ACTIONS(2875),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_LT_LT_DASH] = ACTIONS(2875),
    [anon_sym_LT_LT_LT] = ACTIONS(2875),
    [sym__special_characters] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2875),
    [anon_sym_BQUOTE] = ACTIONS(2875),
    [anon_sym_LT_LPAREN] = ACTIONS(2875),
    [anon_sym_GT_LPAREN] = ACTIONS(2875),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [2733] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6661),
  },
  [2734] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6663),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2735] = {
    [sym__simple_heredoc_body] = ACTIONS(2881),
    [sym__heredoc_body_beginning] = ACTIONS(2881),
    [sym_file_descriptor] = ACTIONS(2881),
    [sym__concat] = ACTIONS(2881),
    [anon_sym_esac] = ACTIONS(2883),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_SEMI_SEMI] = ACTIONS(2883),
    [anon_sym_PIPE_AMP] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_EQ_TILDE] = ACTIONS(2883),
    [anon_sym_EQ_EQ] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_GT_GT] = ACTIONS(2883),
    [anon_sym_AMP_GT] = ACTIONS(2883),
    [anon_sym_AMP_GT_GT] = ACTIONS(2883),
    [anon_sym_LT_AMP] = ACTIONS(2883),
    [anon_sym_GT_AMP] = ACTIONS(2883),
    [anon_sym_LT_LT] = ACTIONS(2883),
    [anon_sym_LT_LT_DASH] = ACTIONS(2883),
    [anon_sym_LT_LT_LT] = ACTIONS(2883),
    [sym__special_characters] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [sym_raw_string] = ACTIONS(2883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2883),
    [anon_sym_BQUOTE] = ACTIONS(2883),
    [anon_sym_LT_LPAREN] = ACTIONS(2883),
    [anon_sym_GT_LPAREN] = ACTIONS(2883),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_LF] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
  },
  [2736] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6665),
  },
  [2737] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6667),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2738] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6669),
  },
  [2739] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6649),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2740] = {
    [sym_concatenation] = STATE(2895),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2895),
    [anon_sym_RBRACE] = ACTIONS(6671),
    [anon_sym_EQ] = ACTIONS(6673),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6673),
    [anon_sym_COLON_QMARK] = ACTIONS(6673),
    [anon_sym_COLON_DASH] = ACTIONS(6673),
    [anon_sym_PERCENT] = ACTIONS(6673),
    [anon_sym_DASH] = ACTIONS(6673),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2741] = {
    [sym__simple_heredoc_body] = ACTIONS(2897),
    [sym__heredoc_body_beginning] = ACTIONS(2897),
    [sym_file_descriptor] = ACTIONS(2897),
    [sym__concat] = ACTIONS(2897),
    [anon_sym_esac] = ACTIONS(2899),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_SEMI_SEMI] = ACTIONS(2899),
    [anon_sym_PIPE_AMP] = ACTIONS(2899),
    [anon_sym_AMP_AMP] = ACTIONS(2899),
    [anon_sym_PIPE_PIPE] = ACTIONS(2899),
    [anon_sym_EQ_TILDE] = ACTIONS(2899),
    [anon_sym_EQ_EQ] = ACTIONS(2899),
    [anon_sym_LT] = ACTIONS(2899),
    [anon_sym_GT] = ACTIONS(2899),
    [anon_sym_GT_GT] = ACTIONS(2899),
    [anon_sym_AMP_GT] = ACTIONS(2899),
    [anon_sym_AMP_GT_GT] = ACTIONS(2899),
    [anon_sym_LT_AMP] = ACTIONS(2899),
    [anon_sym_GT_AMP] = ACTIONS(2899),
    [anon_sym_LT_LT] = ACTIONS(2899),
    [anon_sym_LT_LT_DASH] = ACTIONS(2899),
    [anon_sym_LT_LT_LT] = ACTIONS(2899),
    [sym__special_characters] = ACTIONS(2899),
    [anon_sym_DQUOTE] = ACTIONS(2899),
    [anon_sym_DOLLAR] = ACTIONS(2899),
    [sym_raw_string] = ACTIONS(2899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2899),
    [anon_sym_BQUOTE] = ACTIONS(2899),
    [anon_sym_LT_LPAREN] = ACTIONS(2899),
    [anon_sym_GT_LPAREN] = ACTIONS(2899),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2899),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LF] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2899),
  },
  [2742] = {
    [sym_concatenation] = STATE(2897),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2897),
    [anon_sym_RBRACE] = ACTIONS(6677),
    [anon_sym_EQ] = ACTIONS(6679),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6679),
    [anon_sym_COLON_QMARK] = ACTIONS(6679),
    [anon_sym_COLON_DASH] = ACTIONS(6679),
    [anon_sym_PERCENT] = ACTIONS(6679),
    [anon_sym_DASH] = ACTIONS(6679),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2743] = {
    [sym_file_redirect] = STATE(1432),
    [sym_file_descriptor] = ACTIONS(6109),
    [anon_sym_esac] = ACTIONS(2376),
    [anon_sym_PIPE] = ACTIONS(2376),
    [anon_sym_SEMI_SEMI] = ACTIONS(2376),
    [anon_sym_PIPE_AMP] = ACTIONS(2376),
    [anon_sym_AMP_AMP] = ACTIONS(2376),
    [anon_sym_PIPE_PIPE] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(6111),
    [anon_sym_GT] = ACTIONS(6111),
    [anon_sym_GT_GT] = ACTIONS(6111),
    [anon_sym_AMP_GT] = ACTIONS(6111),
    [anon_sym_AMP_GT_GT] = ACTIONS(6111),
    [anon_sym_LT_AMP] = ACTIONS(6111),
    [anon_sym_GT_AMP] = ACTIONS(6111),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2376),
    [anon_sym_LF] = ACTIONS(2378),
    [anon_sym_AMP] = ACTIONS(2376),
  },
  [2744] = {
    [aux_sym_concatenation_repeat1] = STATE(2747),
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(6331),
    [anon_sym_esac] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [2745] = {
    [aux_sym_concatenation_repeat1] = STATE(2747),
    [sym__simple_heredoc_body] = ACTIONS(1093),
    [sym__heredoc_body_beginning] = ACTIONS(1093),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(6331),
    [anon_sym_esac] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [2746] = {
    [sym_string] = STATE(2898),
    [sym_simple_expansion] = STATE(2898),
    [sym_string_expansion] = STATE(2898),
    [sym_expansion] = STATE(2898),
    [sym_command_substitution] = STATE(2898),
    [sym_process_substitution] = STATE(2898),
    [sym__special_characters] = ACTIONS(6683),
    [anon_sym_DQUOTE] = ACTIONS(5888),
    [anon_sym_DOLLAR] = ACTIONS(5890),
    [sym_raw_string] = ACTIONS(6683),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5896),
    [anon_sym_BQUOTE] = ACTIONS(5898),
    [anon_sym_LT_LPAREN] = ACTIONS(5900),
    [anon_sym_GT_LPAREN] = ACTIONS(5900),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6683),
  },
  [2747] = {
    [aux_sym_concatenation_repeat1] = STATE(2899),
    [sym__simple_heredoc_body] = ACTIONS(693),
    [sym__heredoc_body_beginning] = ACTIONS(693),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(6331),
    [anon_sym_esac] = ACTIONS(695),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [2748] = {
    [sym__simple_heredoc_body] = ACTIONS(697),
    [sym__heredoc_body_beginning] = ACTIONS(697),
    [sym_file_descriptor] = ACTIONS(697),
    [sym__concat] = ACTIONS(697),
    [anon_sym_esac] = ACTIONS(699),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_GT] = ACTIONS(699),
    [anon_sym_AMP_GT_GT] = ACTIONS(699),
    [anon_sym_LT_AMP] = ACTIONS(699),
    [anon_sym_GT_AMP] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_LT_LT_DASH] = ACTIONS(699),
    [anon_sym_LT_LT_LT] = ACTIONS(699),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_LF] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [2749] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(6685),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [2750] = {
    [sym__simple_heredoc_body] = ACTIONS(727),
    [sym__heredoc_body_beginning] = ACTIONS(727),
    [sym_file_descriptor] = ACTIONS(727),
    [sym__concat] = ACTIONS(727),
    [anon_sym_esac] = ACTIONS(729),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(729),
    [anon_sym_PIPE_AMP] = ACTIONS(729),
    [anon_sym_AMP_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(729),
    [anon_sym_LT] = ACTIONS(729),
    [anon_sym_GT] = ACTIONS(729),
    [anon_sym_GT_GT] = ACTIONS(729),
    [anon_sym_AMP_GT] = ACTIONS(729),
    [anon_sym_AMP_GT_GT] = ACTIONS(729),
    [anon_sym_LT_AMP] = ACTIONS(729),
    [anon_sym_GT_AMP] = ACTIONS(729),
    [anon_sym_LT_LT] = ACTIONS(729),
    [anon_sym_LT_LT_DASH] = ACTIONS(729),
    [anon_sym_LT_LT_LT] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_LF] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
  },
  [2751] = {
    [sym__simple_heredoc_body] = ACTIONS(731),
    [sym__heredoc_body_beginning] = ACTIONS(731),
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(731),
    [anon_sym_esac] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(733),
    [anon_sym_LT_LT_LT] = ACTIONS(733),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [2752] = {
    [sym__simple_heredoc_body] = ACTIONS(735),
    [sym__heredoc_body_beginning] = ACTIONS(735),
    [sym_file_descriptor] = ACTIONS(735),
    [sym__concat] = ACTIONS(735),
    [anon_sym_esac] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(737),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(737),
    [anon_sym_LT_AMP] = ACTIONS(737),
    [anon_sym_GT_AMP] = ACTIONS(737),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_LT_LT_DASH] = ACTIONS(737),
    [anon_sym_LT_LT_LT] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [2753] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(6687),
    [sym_comment] = ACTIONS(53),
  },
  [2754] = {
    [sym_concatenation] = STATE(2904),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2904),
    [anon_sym_RBRACE] = ACTIONS(6689),
    [anon_sym_EQ] = ACTIONS(6691),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6695),
    [anon_sym_COLON] = ACTIONS(6691),
    [anon_sym_COLON_QMARK] = ACTIONS(6691),
    [anon_sym_COLON_DASH] = ACTIONS(6691),
    [anon_sym_PERCENT] = ACTIONS(6691),
    [anon_sym_DASH] = ACTIONS(6691),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2755] = {
    [sym_subscript] = STATE(2908),
    [sym_variable_name] = ACTIONS(6697),
    [anon_sym_DOLLAR] = ACTIONS(6699),
    [anon_sym_DASH] = ACTIONS(6699),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6701),
    [anon_sym_STAR] = ACTIONS(6699),
    [anon_sym_AT] = ACTIONS(6699),
    [anon_sym_QMARK] = ACTIONS(6699),
    [anon_sym_0] = ACTIONS(6703),
    [anon_sym__] = ACTIONS(6703),
  },
  [2756] = {
    [sym_concatenation] = STATE(2911),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2911),
    [anon_sym_RBRACE] = ACTIONS(6705),
    [anon_sym_EQ] = ACTIONS(6707),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6709),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6711),
    [anon_sym_COLON] = ACTIONS(6707),
    [anon_sym_COLON_QMARK] = ACTIONS(6707),
    [anon_sym_COLON_DASH] = ACTIONS(6707),
    [anon_sym_PERCENT] = ACTIONS(6707),
    [anon_sym_DASH] = ACTIONS(6707),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2757] = {
    [sym_concatenation] = STATE(2914),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2914),
    [anon_sym_RBRACE] = ACTIONS(6713),
    [anon_sym_EQ] = ACTIONS(6715),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6717),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6719),
    [anon_sym_COLON] = ACTIONS(6715),
    [anon_sym_COLON_QMARK] = ACTIONS(6715),
    [anon_sym_COLON_DASH] = ACTIONS(6715),
    [anon_sym_PERCENT] = ACTIONS(6715),
    [anon_sym_DASH] = ACTIONS(6715),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2758] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(6721),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [2759] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(6721),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2760] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(6721),
    [sym_comment] = ACTIONS(53),
  },
  [2761] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(6721),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2762] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(6723),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [2763] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(6723),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2764] = {
    [sym_file_redirect] = STATE(2566),
    [sym_heredoc_redirect] = STATE(2566),
    [sym_heredoc_body] = STATE(1448),
    [sym_herestring_redirect] = STATE(2566),
    [aux_sym_while_statement_repeat1] = STATE(2566),
    [sym__simple_heredoc_body] = ACTIONS(337),
    [sym__heredoc_body_beginning] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(5332),
    [anon_sym_esac] = ACTIONS(3325),
    [anon_sym_PIPE] = ACTIONS(3325),
    [anon_sym_SEMI_SEMI] = ACTIONS(3325),
    [anon_sym_PIPE_AMP] = ACTIONS(3325),
    [anon_sym_AMP_AMP] = ACTIONS(3325),
    [anon_sym_PIPE_PIPE] = ACTIONS(3325),
    [anon_sym_LT] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(5336),
    [anon_sym_GT_GT] = ACTIONS(5336),
    [anon_sym_AMP_GT] = ACTIONS(5336),
    [anon_sym_AMP_GT_GT] = ACTIONS(5336),
    [anon_sym_LT_AMP] = ACTIONS(5336),
    [anon_sym_GT_AMP] = ACTIONS(5336),
    [anon_sym_LT_LT] = ACTIONS(349),
    [anon_sym_LT_LT_DASH] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(5338),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3325),
    [anon_sym_LF] = ACTIONS(3327),
    [anon_sym_AMP] = ACTIONS(3325),
  },
  [2765] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_esac] = ACTIONS(6725),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(6727),
    [anon_sym_DQUOTE] = ACTIONS(6729),
    [anon_sym_DOLLAR] = ACTIONS(6727),
    [sym_raw_string] = ACTIONS(6729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6729),
    [anon_sym_BQUOTE] = ACTIONS(6729),
    [anon_sym_LT_LPAREN] = ACTIONS(6729),
    [anon_sym_GT_LPAREN] = ACTIONS(6729),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6727),
  },
  [2766] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_esac] = ACTIONS(6731),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(6733),
    [anon_sym_DQUOTE] = ACTIONS(6735),
    [anon_sym_DOLLAR] = ACTIONS(6733),
    [sym_raw_string] = ACTIONS(6735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6735),
    [anon_sym_BQUOTE] = ACTIONS(6735),
    [anon_sym_LT_LPAREN] = ACTIONS(6735),
    [anon_sym_GT_LPAREN] = ACTIONS(6735),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6733),
  },
  [2767] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(5872),
    [anon_sym_DQUOTE] = ACTIONS(5874),
    [anon_sym_DOLLAR] = ACTIONS(5872),
    [sym_raw_string] = ACTIONS(5874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5874),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5874),
    [anon_sym_BQUOTE] = ACTIONS(5874),
    [anon_sym_LT_LPAREN] = ACTIONS(5874),
    [anon_sym_GT_LPAREN] = ACTIONS(5874),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5872),
  },
  [2768] = {
    [sym__special_characters] = ACTIONS(5874),
    [anon_sym_DQUOTE] = ACTIONS(5874),
    [anon_sym_DOLLAR] = ACTIONS(5872),
    [sym_raw_string] = ACTIONS(5874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5874),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5874),
    [anon_sym_BQUOTE] = ACTIONS(5874),
    [anon_sym_LT_LPAREN] = ACTIONS(5874),
    [anon_sym_GT_LPAREN] = ACTIONS(5874),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5874),
  },
  [2769] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(6737),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2770] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(6737),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2771] = {
    [sym__terminated_statement] = STATE(2771),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2771),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(999),
    [sym_variable_name] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1010),
    [anon_sym_if] = ACTIONS(1013),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_SEMI_SEMI] = ACTIONS(1005),
    [anon_sym_function] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1031),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_typeset] = ACTIONS(1034),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_local] = ACTIONS(1034),
    [anon_sym_unset] = ACTIONS(1037),
    [anon_sym_unsetenv] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_GT_GT] = ACTIONS(1043),
    [anon_sym_AMP_GT] = ACTIONS(1040),
    [anon_sym_AMP_GT_GT] = ACTIONS(1043),
    [anon_sym_LT_AMP] = ACTIONS(1043),
    [anon_sym_GT_AMP] = ACTIONS(1043),
    [sym__special_characters] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [sym_raw_string] = ACTIONS(1055),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1064),
    [anon_sym_LT_LPAREN] = ACTIONS(1067),
    [anon_sym_GT_LPAREN] = ACTIONS(1067),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1070),
  },
  [2772] = {
    [sym__terminated_statement] = STATE(2771),
    [sym_for_statement] = STATE(2919),
    [sym_while_statement] = STATE(2919),
    [sym_if_statement] = STATE(2919),
    [sym_case_statement] = STATE(2919),
    [sym_function_definition] = STATE(2919),
    [sym_subshell] = STATE(2919),
    [sym_pipeline] = STATE(2919),
    [sym_list] = STATE(2919),
    [sym_negated_command] = STATE(2919),
    [sym_test_command] = STATE(2919),
    [sym_declaration_command] = STATE(2919),
    [sym_unset_command] = STATE(2919),
    [sym_command] = STATE(2919),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2920),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2771),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(6739),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2773] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(5912),
    [anon_sym_DQUOTE] = ACTIONS(5914),
    [anon_sym_DOLLAR] = ACTIONS(5912),
    [sym_raw_string] = ACTIONS(5914),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5914),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5914),
    [anon_sym_BQUOTE] = ACTIONS(5914),
    [anon_sym_LT_LPAREN] = ACTIONS(5914),
    [anon_sym_GT_LPAREN] = ACTIONS(5914),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5912),
  },
  [2774] = {
    [sym__special_characters] = ACTIONS(5914),
    [anon_sym_DQUOTE] = ACTIONS(5914),
    [anon_sym_DOLLAR] = ACTIONS(5912),
    [sym_raw_string] = ACTIONS(5914),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5914),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5914),
    [anon_sym_BQUOTE] = ACTIONS(5914),
    [anon_sym_LT_LPAREN] = ACTIONS(5914),
    [anon_sym_GT_LPAREN] = ACTIONS(5914),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5914),
  },
  [2775] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(6741),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2776] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(6741),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2777] = {
    [sym__terminated_statement] = STATE(2771),
    [sym_for_statement] = STATE(2923),
    [sym_while_statement] = STATE(2923),
    [sym_if_statement] = STATE(2923),
    [sym_case_statement] = STATE(2923),
    [sym_function_definition] = STATE(2923),
    [sym_subshell] = STATE(2923),
    [sym_pipeline] = STATE(2923),
    [sym_list] = STATE(2923),
    [sym_negated_command] = STATE(2923),
    [sym_test_command] = STATE(2923),
    [sym_declaration_command] = STATE(2923),
    [sym_unset_command] = STATE(2923),
    [sym_command] = STATE(2923),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(2924),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_program_repeat1] = STATE(2771),
    [aux_sym_command_repeat1] = STATE(33),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(6743),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2778] = {
    [sym_file_descriptor] = ACTIONS(4884),
    [sym__concat] = ACTIONS(4884),
    [anon_sym_esac] = ACTIONS(4886),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_RPAREN] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [anon_sym_PIPE_AMP] = ACTIONS(4886),
    [anon_sym_AMP_AMP] = ACTIONS(4886),
    [anon_sym_PIPE_PIPE] = ACTIONS(4886),
    [anon_sym_LT] = ACTIONS(4886),
    [anon_sym_GT] = ACTIONS(4886),
    [anon_sym_GT_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT_GT] = ACTIONS(4886),
    [anon_sym_LT_AMP] = ACTIONS(4886),
    [anon_sym_GT_AMP] = ACTIONS(4886),
    [anon_sym_LT_LT] = ACTIONS(4886),
    [anon_sym_LT_LT_DASH] = ACTIONS(4886),
    [anon_sym_LT_LT_LT] = ACTIONS(4886),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [2779] = {
    [sym_file_descriptor] = ACTIONS(4888),
    [sym__concat] = ACTIONS(4888),
    [anon_sym_esac] = ACTIONS(4890),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_RPAREN] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [anon_sym_PIPE_AMP] = ACTIONS(4890),
    [anon_sym_AMP_AMP] = ACTIONS(4890),
    [anon_sym_PIPE_PIPE] = ACTIONS(4890),
    [anon_sym_LT] = ACTIONS(4890),
    [anon_sym_GT] = ACTIONS(4890),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT_GT] = ACTIONS(4890),
    [anon_sym_LT_AMP] = ACTIONS(4890),
    [anon_sym_GT_AMP] = ACTIONS(4890),
    [anon_sym_LT_LT] = ACTIONS(4890),
    [anon_sym_LT_LT_DASH] = ACTIONS(4890),
    [anon_sym_LT_LT_LT] = ACTIONS(4890),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [2780] = {
    [sym_file_descriptor] = ACTIONS(4892),
    [sym__concat] = ACTIONS(4892),
    [anon_sym_esac] = ACTIONS(4894),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_RPAREN] = ACTIONS(4894),
    [anon_sym_SEMI_SEMI] = ACTIONS(4894),
    [anon_sym_PIPE_AMP] = ACTIONS(4894),
    [anon_sym_AMP_AMP] = ACTIONS(4894),
    [anon_sym_PIPE_PIPE] = ACTIONS(4894),
    [anon_sym_LT] = ACTIONS(4894),
    [anon_sym_GT] = ACTIONS(4894),
    [anon_sym_GT_GT] = ACTIONS(4894),
    [anon_sym_AMP_GT] = ACTIONS(4894),
    [anon_sym_AMP_GT_GT] = ACTIONS(4894),
    [anon_sym_LT_AMP] = ACTIONS(4894),
    [anon_sym_GT_AMP] = ACTIONS(4894),
    [anon_sym_LT_LT] = ACTIONS(4894),
    [anon_sym_LT_LT_DASH] = ACTIONS(4894),
    [anon_sym_LT_LT_LT] = ACTIONS(4894),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4894),
    [anon_sym_LF] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4894),
  },
  [2781] = {
    [sym_file_descriptor] = ACTIONS(4896),
    [sym__concat] = ACTIONS(4896),
    [anon_sym_esac] = ACTIONS(4898),
    [anon_sym_PIPE] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(4898),
    [anon_sym_SEMI_SEMI] = ACTIONS(4898),
    [anon_sym_PIPE_AMP] = ACTIONS(4898),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4898),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_GT_GT] = ACTIONS(4898),
    [anon_sym_AMP_GT] = ACTIONS(4898),
    [anon_sym_AMP_GT_GT] = ACTIONS(4898),
    [anon_sym_LT_AMP] = ACTIONS(4898),
    [anon_sym_GT_AMP] = ACTIONS(4898),
    [anon_sym_LT_LT] = ACTIONS(4898),
    [anon_sym_LT_LT_DASH] = ACTIONS(4898),
    [anon_sym_LT_LT_LT] = ACTIONS(4898),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4898),
    [anon_sym_LF] = ACTIONS(4896),
    [anon_sym_AMP] = ACTIONS(4898),
  },
  [2782] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2783] = {
    [sym_file_descriptor] = ACTIONS(4902),
    [sym__concat] = ACTIONS(4902),
    [anon_sym_esac] = ACTIONS(4904),
    [anon_sym_PIPE] = ACTIONS(4904),
    [anon_sym_RPAREN] = ACTIONS(4904),
    [anon_sym_SEMI_SEMI] = ACTIONS(4904),
    [anon_sym_PIPE_AMP] = ACTIONS(4904),
    [anon_sym_AMP_AMP] = ACTIONS(4904),
    [anon_sym_PIPE_PIPE] = ACTIONS(4904),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_GT] = ACTIONS(4904),
    [anon_sym_GT_GT] = ACTIONS(4904),
    [anon_sym_AMP_GT] = ACTIONS(4904),
    [anon_sym_AMP_GT_GT] = ACTIONS(4904),
    [anon_sym_LT_AMP] = ACTIONS(4904),
    [anon_sym_GT_AMP] = ACTIONS(4904),
    [anon_sym_LT_LT] = ACTIONS(4904),
    [anon_sym_LT_LT_DASH] = ACTIONS(4904),
    [anon_sym_LT_LT_LT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4904),
    [anon_sym_LF] = ACTIONS(4902),
    [anon_sym_AMP] = ACTIONS(4904),
  },
  [2784] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6747),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2785] = {
    [sym_file_descriptor] = ACTIONS(4908),
    [sym__concat] = ACTIONS(4908),
    [anon_sym_esac] = ACTIONS(4910),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_RPAREN] = ACTIONS(4910),
    [anon_sym_SEMI_SEMI] = ACTIONS(4910),
    [anon_sym_PIPE_AMP] = ACTIONS(4910),
    [anon_sym_AMP_AMP] = ACTIONS(4910),
    [anon_sym_PIPE_PIPE] = ACTIONS(4910),
    [anon_sym_LT] = ACTIONS(4910),
    [anon_sym_GT] = ACTIONS(4910),
    [anon_sym_GT_GT] = ACTIONS(4910),
    [anon_sym_AMP_GT] = ACTIONS(4910),
    [anon_sym_AMP_GT_GT] = ACTIONS(4910),
    [anon_sym_LT_AMP] = ACTIONS(4910),
    [anon_sym_GT_AMP] = ACTIONS(4910),
    [anon_sym_LT_LT] = ACTIONS(4910),
    [anon_sym_LT_LT_DASH] = ACTIONS(4910),
    [anon_sym_LT_LT_LT] = ACTIONS(4910),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4910),
    [anon_sym_LF] = ACTIONS(4908),
    [anon_sym_AMP] = ACTIONS(4910),
  },
  [2786] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6749),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2787] = {
    [sym_file_descriptor] = ACTIONS(4914),
    [sym__concat] = ACTIONS(4914),
    [anon_sym_esac] = ACTIONS(4916),
    [anon_sym_PIPE] = ACTIONS(4916),
    [anon_sym_RPAREN] = ACTIONS(4916),
    [anon_sym_SEMI_SEMI] = ACTIONS(4916),
    [anon_sym_PIPE_AMP] = ACTIONS(4916),
    [anon_sym_AMP_AMP] = ACTIONS(4916),
    [anon_sym_PIPE_PIPE] = ACTIONS(4916),
    [anon_sym_LT] = ACTIONS(4916),
    [anon_sym_GT] = ACTIONS(4916),
    [anon_sym_GT_GT] = ACTIONS(4916),
    [anon_sym_AMP_GT] = ACTIONS(4916),
    [anon_sym_AMP_GT_GT] = ACTIONS(4916),
    [anon_sym_LT_AMP] = ACTIONS(4916),
    [anon_sym_GT_AMP] = ACTIONS(4916),
    [anon_sym_LT_LT] = ACTIONS(4916),
    [anon_sym_LT_LT_DASH] = ACTIONS(4916),
    [anon_sym_LT_LT_LT] = ACTIONS(4916),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4916),
    [anon_sym_LF] = ACTIONS(4914),
    [anon_sym_AMP] = ACTIONS(4916),
  },
  [2788] = {
    [sym_file_descriptor] = ACTIONS(4918),
    [sym__concat] = ACTIONS(4918),
    [anon_sym_esac] = ACTIONS(4920),
    [anon_sym_PIPE] = ACTIONS(4920),
    [anon_sym_RPAREN] = ACTIONS(4920),
    [anon_sym_SEMI_SEMI] = ACTIONS(4920),
    [anon_sym_PIPE_AMP] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [anon_sym_LT] = ACTIONS(4920),
    [anon_sym_GT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_AMP_GT] = ACTIONS(4920),
    [anon_sym_AMP_GT_GT] = ACTIONS(4920),
    [anon_sym_LT_AMP] = ACTIONS(4920),
    [anon_sym_GT_AMP] = ACTIONS(4920),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_LT_LT_DASH] = ACTIONS(4920),
    [anon_sym_LT_LT_LT] = ACTIONS(4920),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym_LF] = ACTIONS(4918),
    [anon_sym_AMP] = ACTIONS(4920),
  },
  [2789] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_RBRACE] = ACTIONS(5540),
    [sym_comment] = ACTIONS(53),
  },
  [2790] = {
    [sym__concat] = ACTIONS(5544),
    [anon_sym_RBRACE] = ACTIONS(5544),
    [sym_comment] = ACTIONS(53),
  },
  [2791] = {
    [sym__concat] = ACTIONS(5548),
    [anon_sym_RBRACE] = ACTIONS(5548),
    [sym_comment] = ACTIONS(53),
  },
  [2792] = {
    [sym_file_descriptor] = ACTIONS(3917),
    [sym__concat] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3919),
    [anon_sym_RPAREN] = ACTIONS(3917),
    [anon_sym_PIPE_AMP] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_GT] = ACTIONS(3919),
    [anon_sym_GT_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT] = ACTIONS(3919),
    [anon_sym_AMP_GT_GT] = ACTIONS(3917),
    [anon_sym_LT_AMP] = ACTIONS(3917),
    [anon_sym_GT_AMP] = ACTIONS(3917),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_LT_LT_DASH] = ACTIONS(3917),
    [anon_sym_LT_LT_LT] = ACTIONS(3917),
    [anon_sym_BQUOTE] = ACTIONS(3917),
    [sym_comment] = ACTIONS(53),
  },
  [2793] = {
    [sym_file_descriptor] = ACTIONS(3923),
    [sym__concat] = ACTIONS(3923),
    [anon_sym_PIPE] = ACTIONS(3925),
    [anon_sym_RPAREN] = ACTIONS(3923),
    [anon_sym_PIPE_AMP] = ACTIONS(3923),
    [anon_sym_AMP_AMP] = ACTIONS(3923),
    [anon_sym_PIPE_PIPE] = ACTIONS(3923),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_GT] = ACTIONS(3925),
    [anon_sym_GT_GT] = ACTIONS(3923),
    [anon_sym_AMP_GT] = ACTIONS(3925),
    [anon_sym_AMP_GT_GT] = ACTIONS(3923),
    [anon_sym_LT_AMP] = ACTIONS(3923),
    [anon_sym_GT_AMP] = ACTIONS(3923),
    [anon_sym_LT_LT] = ACTIONS(3925),
    [anon_sym_LT_LT_DASH] = ACTIONS(3923),
    [anon_sym_LT_LT_LT] = ACTIONS(3923),
    [anon_sym_BQUOTE] = ACTIONS(3923),
    [sym_comment] = ACTIONS(53),
  },
  [2794] = {
    [sym_file_descriptor] = ACTIONS(4008),
    [sym__concat] = ACTIONS(4008),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_RPAREN] = ACTIONS(4008),
    [anon_sym_PIPE_AMP] = ACTIONS(4008),
    [anon_sym_AMP_AMP] = ACTIONS(4008),
    [anon_sym_PIPE_PIPE] = ACTIONS(4008),
    [anon_sym_LT] = ACTIONS(4010),
    [anon_sym_GT] = ACTIONS(4010),
    [anon_sym_GT_GT] = ACTIONS(4008),
    [anon_sym_AMP_GT] = ACTIONS(4010),
    [anon_sym_AMP_GT_GT] = ACTIONS(4008),
    [anon_sym_LT_AMP] = ACTIONS(4008),
    [anon_sym_GT_AMP] = ACTIONS(4008),
    [anon_sym_LT_LT] = ACTIONS(4010),
    [anon_sym_LT_LT_DASH] = ACTIONS(4008),
    [anon_sym_LT_LT_LT] = ACTIONS(4008),
    [anon_sym_BQUOTE] = ACTIONS(4008),
    [sym_comment] = ACTIONS(53),
  },
  [2795] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6751),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2796] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(6753),
    [sym_comment] = ACTIONS(53),
  },
  [2797] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(6755),
    [sym_comment] = ACTIONS(53),
  },
  [2798] = {
    [anon_sym_RBRACE] = ACTIONS(6755),
    [sym_comment] = ACTIONS(53),
  },
  [2799] = {
    [sym_concatenation] = STATE(2932),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2932),
    [anon_sym_RBRACE] = ACTIONS(6757),
    [anon_sym_EQ] = ACTIONS(6759),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6759),
    [anon_sym_COLON_QMARK] = ACTIONS(6759),
    [anon_sym_COLON_DASH] = ACTIONS(6759),
    [anon_sym_PERCENT] = ACTIONS(6759),
    [anon_sym_DASH] = ACTIONS(6759),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2800] = {
    [sym_file_descriptor] = ACTIONS(4024),
    [sym__concat] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_PIPE_AMP] = ACTIONS(4024),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_GT_GT] = ACTIONS(4024),
    [anon_sym_AMP_GT] = ACTIONS(4026),
    [anon_sym_AMP_GT_GT] = ACTIONS(4024),
    [anon_sym_LT_AMP] = ACTIONS(4024),
    [anon_sym_GT_AMP] = ACTIONS(4024),
    [anon_sym_LT_LT] = ACTIONS(4026),
    [anon_sym_LT_LT_DASH] = ACTIONS(4024),
    [anon_sym_LT_LT_LT] = ACTIONS(4024),
    [anon_sym_BQUOTE] = ACTIONS(4024),
    [sym_comment] = ACTIONS(53),
  },
  [2801] = {
    [sym_concatenation] = STATE(2934),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2934),
    [anon_sym_RBRACE] = ACTIONS(6763),
    [anon_sym_EQ] = ACTIONS(6765),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6765),
    [anon_sym_COLON_QMARK] = ACTIONS(6765),
    [anon_sym_COLON_DASH] = ACTIONS(6765),
    [anon_sym_PERCENT] = ACTIONS(6765),
    [anon_sym_DASH] = ACTIONS(6765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2802] = {
    [sym_file_descriptor] = ACTIONS(4034),
    [sym__concat] = ACTIONS(4034),
    [anon_sym_PIPE] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4034),
    [anon_sym_PIPE_AMP] = ACTIONS(4034),
    [anon_sym_AMP_AMP] = ACTIONS(4034),
    [anon_sym_PIPE_PIPE] = ACTIONS(4034),
    [anon_sym_LT] = ACTIONS(4036),
    [anon_sym_GT] = ACTIONS(4036),
    [anon_sym_GT_GT] = ACTIONS(4034),
    [anon_sym_AMP_GT] = ACTIONS(4036),
    [anon_sym_AMP_GT_GT] = ACTIONS(4034),
    [anon_sym_LT_AMP] = ACTIONS(4034),
    [anon_sym_GT_AMP] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4036),
    [anon_sym_LT_LT_DASH] = ACTIONS(4034),
    [anon_sym_LT_LT_LT] = ACTIONS(4034),
    [anon_sym_BQUOTE] = ACTIONS(4034),
    [sym_comment] = ACTIONS(53),
  },
  [2803] = {
    [sym_concatenation] = STATE(2936),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2936),
    [anon_sym_RBRACE] = ACTIONS(6769),
    [anon_sym_EQ] = ACTIONS(6771),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6773),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6771),
    [anon_sym_COLON_QMARK] = ACTIONS(6771),
    [anon_sym_COLON_DASH] = ACTIONS(6771),
    [anon_sym_PERCENT] = ACTIONS(6771),
    [anon_sym_DASH] = ACTIONS(6771),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2804] = {
    [sym_file_descriptor] = ACTIONS(4044),
    [sym__concat] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_RPAREN] = ACTIONS(4044),
    [anon_sym_PIPE_AMP] = ACTIONS(4044),
    [anon_sym_AMP_AMP] = ACTIONS(4044),
    [anon_sym_PIPE_PIPE] = ACTIONS(4044),
    [anon_sym_LT] = ACTIONS(4046),
    [anon_sym_GT] = ACTIONS(4046),
    [anon_sym_GT_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT] = ACTIONS(4046),
    [anon_sym_AMP_GT_GT] = ACTIONS(4044),
    [anon_sym_LT_AMP] = ACTIONS(4044),
    [anon_sym_GT_AMP] = ACTIONS(4044),
    [anon_sym_LT_LT] = ACTIONS(4046),
    [anon_sym_LT_LT_DASH] = ACTIONS(4044),
    [anon_sym_LT_LT_LT] = ACTIONS(4044),
    [anon_sym_BQUOTE] = ACTIONS(4044),
    [sym_comment] = ACTIONS(53),
  },
  [2805] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6775),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2806] = {
    [sym_file_descriptor] = ACTIONS(4050),
    [sym__concat] = ACTIONS(4050),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_RPAREN] = ACTIONS(4050),
    [anon_sym_PIPE_AMP] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4050),
    [anon_sym_AMP_GT] = ACTIONS(4052),
    [anon_sym_AMP_GT_GT] = ACTIONS(4050),
    [anon_sym_LT_AMP] = ACTIONS(4050),
    [anon_sym_GT_AMP] = ACTIONS(4050),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_LT_LT_DASH] = ACTIONS(4050),
    [anon_sym_LT_LT_LT] = ACTIONS(4050),
    [anon_sym_BQUOTE] = ACTIONS(4050),
    [sym_comment] = ACTIONS(53),
  },
  [2807] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6777),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2808] = {
    [sym_file_descriptor] = ACTIONS(3379),
    [sym_variable_name] = ACTIONS(3379),
    [anon_sym_esac] = ACTIONS(3381),
    [anon_sym_PIPE] = ACTIONS(3381),
    [anon_sym_SEMI_SEMI] = ACTIONS(3381),
    [anon_sym_PIPE_AMP] = ACTIONS(3381),
    [anon_sym_AMP_AMP] = ACTIONS(3381),
    [anon_sym_PIPE_PIPE] = ACTIONS(3381),
    [anon_sym_LT] = ACTIONS(3381),
    [anon_sym_GT] = ACTIONS(3381),
    [anon_sym_GT_GT] = ACTIONS(3381),
    [anon_sym_AMP_GT] = ACTIONS(3381),
    [anon_sym_AMP_GT_GT] = ACTIONS(3381),
    [anon_sym_LT_AMP] = ACTIONS(3381),
    [anon_sym_GT_AMP] = ACTIONS(3381),
    [sym__special_characters] = ACTIONS(3381),
    [anon_sym_DQUOTE] = ACTIONS(3381),
    [anon_sym_DOLLAR] = ACTIONS(3381),
    [sym_raw_string] = ACTIONS(3381),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3381),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3381),
    [anon_sym_BQUOTE] = ACTIONS(3381),
    [anon_sym_LT_LPAREN] = ACTIONS(3381),
    [anon_sym_GT_LPAREN] = ACTIONS(3381),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3381),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym_LF] = ACTIONS(3379),
    [anon_sym_AMP] = ACTIONS(3381),
  },
  [2809] = {
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(1654),
    [sym_variable_name] = ACTIONS(1654),
    [anon_sym_esac] = ACTIONS(1656),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1656),
    [anon_sym_LT_AMP] = ACTIONS(1656),
    [anon_sym_GT_AMP] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LT_LPAREN] = ACTIONS(1656),
    [anon_sym_GT_LPAREN] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [2810] = {
    [aux_sym_concatenation_repeat1] = STATE(2810),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(6779),
    [sym_variable_name] = ACTIONS(1654),
    [anon_sym_esac] = ACTIONS(1656),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1656),
    [anon_sym_LT_AMP] = ACTIONS(1656),
    [anon_sym_GT_AMP] = ACTIONS(1656),
    [sym__special_characters] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [sym_raw_string] = ACTIONS(1656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LT_LPAREN] = ACTIONS(1656),
    [anon_sym_GT_LPAREN] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [2811] = {
    [sym_file_descriptor] = ACTIONS(1703),
    [sym__concat] = ACTIONS(1703),
    [sym_variable_name] = ACTIONS(1703),
    [anon_sym_esac] = ACTIONS(1705),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_SEMI_SEMI] = ACTIONS(1705),
    [anon_sym_PIPE_AMP] = ACTIONS(1705),
    [anon_sym_AMP_AMP] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1705),
    [anon_sym_GT] = ACTIONS(1705),
    [anon_sym_GT_GT] = ACTIONS(1705),
    [anon_sym_AMP_GT] = ACTIONS(1705),
    [anon_sym_AMP_GT_GT] = ACTIONS(1705),
    [anon_sym_LT_AMP] = ACTIONS(1705),
    [anon_sym_GT_AMP] = ACTIONS(1705),
    [sym__special_characters] = ACTIONS(1705),
    [anon_sym_DQUOTE] = ACTIONS(1705),
    [anon_sym_DOLLAR] = ACTIONS(1705),
    [sym_raw_string] = ACTIONS(1705),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1705),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1705),
    [anon_sym_BQUOTE] = ACTIONS(1705),
    [anon_sym_LT_LPAREN] = ACTIONS(1705),
    [anon_sym_GT_LPAREN] = ACTIONS(1705),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1705),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_LF] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1705),
  },
  [2812] = {
    [sym_concatenation] = STATE(2942),
    [sym_string] = STATE(2941),
    [sym_simple_expansion] = STATE(2941),
    [sym_string_expansion] = STATE(2941),
    [sym_expansion] = STATE(2941),
    [sym_command_substitution] = STATE(2941),
    [sym_process_substitution] = STATE(2941),
    [anon_sym_RBRACE] = ACTIONS(6782),
    [sym__special_characters] = ACTIONS(6784),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(6786),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6786),
  },
  [2813] = {
    [sym_file_descriptor] = ACTIONS(1744),
    [sym__concat] = ACTIONS(1744),
    [sym_variable_name] = ACTIONS(1744),
    [anon_sym_esac] = ACTIONS(1746),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_SEMI_SEMI] = ACTIONS(1746),
    [anon_sym_PIPE_AMP] = ACTIONS(1746),
    [anon_sym_AMP_AMP] = ACTIONS(1746),
    [anon_sym_PIPE_PIPE] = ACTIONS(1746),
    [anon_sym_LT] = ACTIONS(1746),
    [anon_sym_GT] = ACTIONS(1746),
    [anon_sym_GT_GT] = ACTIONS(1746),
    [anon_sym_AMP_GT] = ACTIONS(1746),
    [anon_sym_AMP_GT_GT] = ACTIONS(1746),
    [anon_sym_LT_AMP] = ACTIONS(1746),
    [anon_sym_GT_AMP] = ACTIONS(1746),
    [sym__special_characters] = ACTIONS(1746),
    [anon_sym_DQUOTE] = ACTIONS(1746),
    [anon_sym_DOLLAR] = ACTIONS(1746),
    [sym_raw_string] = ACTIONS(1746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1746),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [anon_sym_LT_LPAREN] = ACTIONS(1746),
    [anon_sym_GT_LPAREN] = ACTIONS(1746),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1746),
    [anon_sym_SEMI] = ACTIONS(1746),
    [anon_sym_LF] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(1746),
  },
  [2814] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6788),
  },
  [2815] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6790),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2816] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(6792),
    [sym_comment] = ACTIONS(53),
  },
  [2817] = {
    [sym_concatenation] = STATE(2948),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2948),
    [anon_sym_RBRACE] = ACTIONS(6794),
    [anon_sym_EQ] = ACTIONS(6796),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6798),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6800),
    [anon_sym_COLON] = ACTIONS(6796),
    [anon_sym_COLON_QMARK] = ACTIONS(6796),
    [anon_sym_COLON_DASH] = ACTIONS(6796),
    [anon_sym_PERCENT] = ACTIONS(6796),
    [anon_sym_DASH] = ACTIONS(6796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2818] = {
    [sym_concatenation] = STATE(2951),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2951),
    [anon_sym_RBRACE] = ACTIONS(6802),
    [anon_sym_EQ] = ACTIONS(6804),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6806),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6808),
    [anon_sym_COLON] = ACTIONS(6804),
    [anon_sym_COLON_QMARK] = ACTIONS(6804),
    [anon_sym_COLON_DASH] = ACTIONS(6804),
    [anon_sym_PERCENT] = ACTIONS(6804),
    [anon_sym_DASH] = ACTIONS(6804),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2819] = {
    [sym_concatenation] = STATE(2953),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2953),
    [anon_sym_RBRACE] = ACTIONS(6782),
    [anon_sym_EQ] = ACTIONS(6810),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6812),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(6810),
    [anon_sym_COLON_QMARK] = ACTIONS(6810),
    [anon_sym_COLON_DASH] = ACTIONS(6810),
    [anon_sym_PERCENT] = ACTIONS(6810),
    [anon_sym_DASH] = ACTIONS(6810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2820] = {
    [sym_file_descriptor] = ACTIONS(1810),
    [sym__concat] = ACTIONS(1810),
    [sym_variable_name] = ACTIONS(1810),
    [anon_sym_esac] = ACTIONS(1812),
    [anon_sym_PIPE] = ACTIONS(1812),
    [anon_sym_SEMI_SEMI] = ACTIONS(1812),
    [anon_sym_PIPE_AMP] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1812),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [anon_sym_LT] = ACTIONS(1812),
    [anon_sym_GT] = ACTIONS(1812),
    [anon_sym_GT_GT] = ACTIONS(1812),
    [anon_sym_AMP_GT] = ACTIONS(1812),
    [anon_sym_AMP_GT_GT] = ACTIONS(1812),
    [anon_sym_LT_AMP] = ACTIONS(1812),
    [anon_sym_GT_AMP] = ACTIONS(1812),
    [sym__special_characters] = ACTIONS(1812),
    [anon_sym_DQUOTE] = ACTIONS(1812),
    [anon_sym_DOLLAR] = ACTIONS(1812),
    [sym_raw_string] = ACTIONS(1812),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1812),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1812),
    [anon_sym_GT_LPAREN] = ACTIONS(1812),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1812),
    [anon_sym_SEMI] = ACTIONS(1812),
    [anon_sym_LF] = ACTIONS(1810),
    [anon_sym_AMP] = ACTIONS(1812),
  },
  [2821] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6816),
  },
  [2822] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6818),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2823] = {
    [sym_file_descriptor] = ACTIONS(1818),
    [sym__concat] = ACTIONS(1818),
    [sym_variable_name] = ACTIONS(1818),
    [anon_sym_esac] = ACTIONS(1820),
    [anon_sym_PIPE] = ACTIONS(1820),
    [anon_sym_SEMI_SEMI] = ACTIONS(1820),
    [anon_sym_PIPE_AMP] = ACTIONS(1820),
    [anon_sym_AMP_AMP] = ACTIONS(1820),
    [anon_sym_PIPE_PIPE] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1820),
    [anon_sym_GT] = ACTIONS(1820),
    [anon_sym_GT_GT] = ACTIONS(1820),
    [anon_sym_AMP_GT] = ACTIONS(1820),
    [anon_sym_AMP_GT_GT] = ACTIONS(1820),
    [anon_sym_LT_AMP] = ACTIONS(1820),
    [anon_sym_GT_AMP] = ACTIONS(1820),
    [sym__special_characters] = ACTIONS(1820),
    [anon_sym_DQUOTE] = ACTIONS(1820),
    [anon_sym_DOLLAR] = ACTIONS(1820),
    [sym_raw_string] = ACTIONS(1820),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1820),
    [anon_sym_BQUOTE] = ACTIONS(1820),
    [anon_sym_LT_LPAREN] = ACTIONS(1820),
    [anon_sym_GT_LPAREN] = ACTIONS(1820),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1820),
    [anon_sym_LF] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1820),
  },
  [2824] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6820),
  },
  [2825] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6782),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2826] = {
    [sym_file_descriptor] = ACTIONS(1952),
    [sym__concat] = ACTIONS(1952),
    [sym_variable_name] = ACTIONS(1952),
    [anon_sym_esac] = ACTIONS(1954),
    [anon_sym_PIPE] = ACTIONS(1954),
    [anon_sym_SEMI_SEMI] = ACTIONS(1954),
    [anon_sym_PIPE_AMP] = ACTIONS(1954),
    [anon_sym_AMP_AMP] = ACTIONS(1954),
    [anon_sym_PIPE_PIPE] = ACTIONS(1954),
    [anon_sym_LT] = ACTIONS(1954),
    [anon_sym_GT] = ACTIONS(1954),
    [anon_sym_GT_GT] = ACTIONS(1954),
    [anon_sym_AMP_GT] = ACTIONS(1954),
    [anon_sym_AMP_GT_GT] = ACTIONS(1954),
    [anon_sym_LT_AMP] = ACTIONS(1954),
    [anon_sym_GT_AMP] = ACTIONS(1954),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1954),
    [anon_sym_DOLLAR] = ACTIONS(1954),
    [sym_raw_string] = ACTIONS(1954),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1954),
    [anon_sym_BQUOTE] = ACTIONS(1954),
    [anon_sym_LT_LPAREN] = ACTIONS(1954),
    [anon_sym_GT_LPAREN] = ACTIONS(1954),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(1954),
    [anon_sym_SEMI] = ACTIONS(1954),
    [anon_sym_LF] = ACTIONS(1952),
    [anon_sym_AMP] = ACTIONS(1954),
  },
  [2827] = {
    [sym_file_descriptor] = ACTIONS(2018),
    [sym__concat] = ACTIONS(2018),
    [sym_variable_name] = ACTIONS(2018),
    [anon_sym_esac] = ACTIONS(2020),
    [anon_sym_PIPE] = ACTIONS(2020),
    [anon_sym_SEMI_SEMI] = ACTIONS(2020),
    [anon_sym_PIPE_AMP] = ACTIONS(2020),
    [anon_sym_AMP_AMP] = ACTIONS(2020),
    [anon_sym_PIPE_PIPE] = ACTIONS(2020),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(2020),
    [anon_sym_GT_GT] = ACTIONS(2020),
    [anon_sym_AMP_GT] = ACTIONS(2020),
    [anon_sym_AMP_GT_GT] = ACTIONS(2020),
    [anon_sym_LT_AMP] = ACTIONS(2020),
    [anon_sym_GT_AMP] = ACTIONS(2020),
    [sym__special_characters] = ACTIONS(2020),
    [anon_sym_DQUOTE] = ACTIONS(2020),
    [anon_sym_DOLLAR] = ACTIONS(2020),
    [sym_raw_string] = ACTIONS(2020),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2020),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2020),
    [anon_sym_BQUOTE] = ACTIONS(2020),
    [anon_sym_LT_LPAREN] = ACTIONS(2020),
    [anon_sym_GT_LPAREN] = ACTIONS(2020),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2020),
    [anon_sym_SEMI] = ACTIONS(2020),
    [anon_sym_LF] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2020),
  },
  [2828] = {
    [sym_file_redirect] = STATE(1545),
    [sym_file_descriptor] = ACTIONS(6109),
    [anon_sym_esac] = ACTIONS(3609),
    [anon_sym_PIPE] = ACTIONS(3609),
    [anon_sym_SEMI_SEMI] = ACTIONS(3609),
    [anon_sym_PIPE_AMP] = ACTIONS(3609),
    [anon_sym_AMP_AMP] = ACTIONS(3609),
    [anon_sym_PIPE_PIPE] = ACTIONS(3609),
    [anon_sym_LT] = ACTIONS(6111),
    [anon_sym_GT] = ACTIONS(6111),
    [anon_sym_GT_GT] = ACTIONS(6111),
    [anon_sym_AMP_GT] = ACTIONS(6111),
    [anon_sym_AMP_GT_GT] = ACTIONS(6111),
    [anon_sym_LT_AMP] = ACTIONS(6111),
    [anon_sym_GT_AMP] = ACTIONS(6111),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3609),
    [anon_sym_LF] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3609),
  },
  [2829] = {
    [sym_concatenation] = STATE(1548),
    [sym_string] = STATE(2958),
    [sym_simple_expansion] = STATE(2958),
    [sym_string_expansion] = STATE(2958),
    [sym_expansion] = STATE(2958),
    [sym_command_substitution] = STATE(2958),
    [sym_process_substitution] = STATE(2958),
    [sym__special_characters] = ACTIONS(6822),
    [anon_sym_DQUOTE] = ACTIONS(6533),
    [anon_sym_DOLLAR] = ACTIONS(6535),
    [sym_raw_string] = ACTIONS(6824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6539),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6541),
    [anon_sym_BQUOTE] = ACTIONS(6543),
    [anon_sym_LT_LPAREN] = ACTIONS(6545),
    [anon_sym_GT_LPAREN] = ACTIONS(6545),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6824),
  },
  [2830] = {
    [aux_sym_concatenation_repeat1] = STATE(2960),
    [sym__concat] = ACTIONS(6826),
    [anon_sym_esac] = ACTIONS(665),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(665),
    [anon_sym_AMP_AMP] = ACTIONS(665),
    [anon_sym_PIPE_PIPE] = ACTIONS(665),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [2831] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(2962),
    [anon_sym_DQUOTE] = ACTIONS(6828),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [2832] = {
    [sym_string] = STATE(2964),
    [anon_sym_DQUOTE] = ACTIONS(6533),
    [anon_sym_DOLLAR] = ACTIONS(6830),
    [sym_raw_string] = ACTIONS(6832),
    [anon_sym_POUND] = ACTIONS(6830),
    [anon_sym_DASH] = ACTIONS(6830),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6834),
    [anon_sym_STAR] = ACTIONS(6830),
    [anon_sym_AT] = ACTIONS(6830),
    [anon_sym_QMARK] = ACTIONS(6830),
    [anon_sym_0] = ACTIONS(6836),
    [anon_sym__] = ACTIONS(6836),
  },
  [2833] = {
    [aux_sym_concatenation_repeat1] = STATE(2960),
    [sym__concat] = ACTIONS(6826),
    [anon_sym_esac] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [2834] = {
    [sym_subscript] = STATE(2970),
    [sym_variable_name] = ACTIONS(6838),
    [anon_sym_DOLLAR] = ACTIONS(6840),
    [anon_sym_POUND] = ACTIONS(6842),
    [anon_sym_DASH] = ACTIONS(6840),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6844),
    [anon_sym_STAR] = ACTIONS(6840),
    [anon_sym_AT] = ACTIONS(6840),
    [anon_sym_QMARK] = ACTIONS(6840),
    [anon_sym_0] = ACTIONS(6846),
    [anon_sym__] = ACTIONS(6846),
  },
  [2835] = {
    [sym_for_statement] = STATE(2971),
    [sym_while_statement] = STATE(2971),
    [sym_if_statement] = STATE(2971),
    [sym_case_statement] = STATE(2971),
    [sym_function_definition] = STATE(2971),
    [sym_subshell] = STATE(2971),
    [sym_pipeline] = STATE(2971),
    [sym_list] = STATE(2971),
    [sym_negated_command] = STATE(2971),
    [sym_test_command] = STATE(2971),
    [sym_declaration_command] = STATE(2971),
    [sym_unset_command] = STATE(2971),
    [sym_command] = STATE(2971),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(2972),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [2836] = {
    [sym_for_statement] = STATE(2973),
    [sym_while_statement] = STATE(2973),
    [sym_if_statement] = STATE(2973),
    [sym_case_statement] = STATE(2973),
    [sym_function_definition] = STATE(2973),
    [sym_subshell] = STATE(2973),
    [sym_pipeline] = STATE(2973),
    [sym_list] = STATE(2973),
    [sym_negated_command] = STATE(2973),
    [sym_test_command] = STATE(2973),
    [sym_declaration_command] = STATE(2973),
    [sym_unset_command] = STATE(2973),
    [sym_command] = STATE(2973),
    [sym_command_name] = STATE(181),
    [sym_variable_assignment] = STATE(2974),
    [sym_subscript] = STATE(183),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(178),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym_expansion] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_process_substitution] = STATE(178),
    [aux_sym_command_repeat1] = STATE(184),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(313),
    [anon_sym_declare] = ACTIONS(315),
    [anon_sym_typeset] = ACTIONS(315),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_local] = ACTIONS(315),
    [anon_sym_unset] = ACTIONS(317),
    [anon_sym_unsetenv] = ACTIONS(317),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(323),
  },
  [2837] = {
    [sym_for_statement] = STATE(2975),
    [sym_while_statement] = STATE(2975),
    [sym_if_statement] = STATE(2975),
    [sym_case_statement] = STATE(2975),
    [sym_function_definition] = STATE(2975),
    [sym_subshell] = STATE(2975),
    [sym_pipeline] = STATE(2975),
    [sym_list] = STATE(2975),
    [sym_negated_command] = STATE(2975),
    [sym_test_command] = STATE(2975),
    [sym_declaration_command] = STATE(2975),
    [sym_unset_command] = STATE(2975),
    [sym_command] = STATE(2975),
    [sym_command_name] = STATE(164),
    [sym_variable_assignment] = STATE(2976),
    [sym_subscript] = STATE(166),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(167),
    [sym_string] = STATE(157),
    [sym_simple_expansion] = STATE(157),
    [sym_string_expansion] = STATE(157),
    [sym_expansion] = STATE(157),
    [sym_command_substitution] = STATE(157),
    [sym_process_substitution] = STATE(157),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(261),
    [anon_sym_for] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(281),
    [anon_sym_typeset] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_local] = ACTIONS(281),
    [anon_sym_unset] = ACTIONS(283),
    [anon_sym_unsetenv] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(301),
  },
  [2838] = {
    [sym_concatenation] = STATE(1581),
    [sym_string] = STATE(2978),
    [sym_simple_expansion] = STATE(2978),
    [sym_string_expansion] = STATE(2978),
    [sym_expansion] = STATE(2978),
    [sym_command_substitution] = STATE(2978),
    [sym_process_substitution] = STATE(2978),
    [sym__special_characters] = ACTIONS(6848),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(6850),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2508),
    [anon_sym_BQUOTE] = ACTIONS(2510),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6850),
  },
  [2839] = {
    [aux_sym_concatenation_repeat1] = STATE(2979),
    [sym_file_descriptor] = ACTIONS(661),
    [sym__concat] = ACTIONS(3687),
    [anon_sym_esac] = ACTIONS(665),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(665),
    [anon_sym_PIPE_AMP] = ACTIONS(665),
    [anon_sym_AMP_AMP] = ACTIONS(665),
    [anon_sym_PIPE_PIPE] = ACTIONS(665),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(665),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(665),
    [anon_sym_LT_AMP] = ACTIONS(665),
    [anon_sym_GT_AMP] = ACTIONS(665),
    [anon_sym_LT_LT] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(665),
    [anon_sym_LT_LT_LT] = ACTIONS(665),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_LF] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(665),
  },
  [2840] = {
    [aux_sym_concatenation_repeat1] = STATE(2979),
    [sym_file_descriptor] = ACTIONS(677),
    [sym__concat] = ACTIONS(3687),
    [anon_sym_esac] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_SEMI_SEMI] = ACTIONS(679),
    [anon_sym_PIPE_AMP] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_AMP_GT] = ACTIONS(679),
    [anon_sym_AMP_GT_GT] = ACTIONS(679),
    [anon_sym_LT_AMP] = ACTIONS(679),
    [anon_sym_GT_AMP] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_LT_LT_DASH] = ACTIONS(679),
    [anon_sym_LT_LT_LT] = ACTIONS(679),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_LF] = ACTIONS(677),
    [anon_sym_AMP] = ACTIONS(679),
  },
  [2841] = {
    [aux_sym_concatenation_repeat1] = STATE(2979),
    [sym_file_descriptor] = ACTIONS(2070),
    [sym__concat] = ACTIONS(3687),
    [anon_sym_esac] = ACTIONS(2072),
    [anon_sym_PIPE] = ACTIONS(2072),
    [anon_sym_SEMI_SEMI] = ACTIONS(2072),
    [anon_sym_PIPE_AMP] = ACTIONS(2072),
    [anon_sym_AMP_AMP] = ACTIONS(2072),
    [anon_sym_PIPE_PIPE] = ACTIONS(2072),
    [anon_sym_LT] = ACTIONS(2072),
    [anon_sym_GT] = ACTIONS(2072),
    [anon_sym_GT_GT] = ACTIONS(2072),
    [anon_sym_AMP_GT] = ACTIONS(2072),
    [anon_sym_AMP_GT_GT] = ACTIONS(2072),
    [anon_sym_LT_AMP] = ACTIONS(2072),
    [anon_sym_GT_AMP] = ACTIONS(2072),
    [anon_sym_LT_LT] = ACTIONS(2072),
    [anon_sym_LT_LT_DASH] = ACTIONS(2072),
    [anon_sym_LT_LT_LT] = ACTIONS(2072),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2072),
    [anon_sym_LF] = ACTIONS(2070),
    [anon_sym_AMP] = ACTIONS(2072),
  },
  [2842] = {
    [aux_sym_concatenation_repeat1] = STATE(2979),
    [sym_file_descriptor] = ACTIONS(2074),
    [sym__concat] = ACTIONS(3687),
    [anon_sym_esac] = ACTIONS(2076),
    [anon_sym_PIPE] = ACTIONS(2076),
    [anon_sym_SEMI_SEMI] = ACTIONS(2076),
    [anon_sym_PIPE_AMP] = ACTIONS(2076),
    [anon_sym_AMP_AMP] = ACTIONS(2076),
    [anon_sym_PIPE_PIPE] = ACTIONS(2076),
    [anon_sym_LT] = ACTIONS(2076),
    [anon_sym_GT] = ACTIONS(2076),
    [anon_sym_GT_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT] = ACTIONS(2076),
    [anon_sym_AMP_GT_GT] = ACTIONS(2076),
    [anon_sym_LT_AMP] = ACTIONS(2076),
    [anon_sym_GT_AMP] = ACTIONS(2076),
    [anon_sym_LT_LT] = ACTIONS(2076),
    [anon_sym_LT_LT_DASH] = ACTIONS(2076),
    [anon_sym_LT_LT_LT] = ACTIONS(2076),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2076),
    [anon_sym_LF] = ACTIONS(2074),
    [anon_sym_AMP] = ACTIONS(2076),
  },
  [2843] = {
    [sym_file_redirect] = STATE(2843),
    [sym_heredoc_redirect] = STATE(2843),
    [sym_herestring_redirect] = STATE(2843),
    [aux_sym_while_statement_repeat1] = STATE(2843),
    [sym_file_descriptor] = ACTIONS(6852),
    [anon_sym_esac] = ACTIONS(2087),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_SEMI_SEMI] = ACTIONS(2087),
    [anon_sym_PIPE_AMP] = ACTIONS(2087),
    [anon_sym_AMP_AMP] = ACTIONS(2087),
    [anon_sym_PIPE_PIPE] = ACTIONS(2087),
    [anon_sym_LT] = ACTIONS(6855),
    [anon_sym_GT] = ACTIONS(6855),
    [anon_sym_GT_GT] = ACTIONS(6855),
    [anon_sym_AMP_GT] = ACTIONS(6855),
    [anon_sym_AMP_GT_GT] = ACTIONS(6855),
    [anon_sym_LT_AMP] = ACTIONS(6855),
    [anon_sym_GT_AMP] = ACTIONS(6855),
    [anon_sym_LT_LT] = ACTIONS(3715),
    [anon_sym_LT_LT_DASH] = ACTIONS(3715),
    [anon_sym_LT_LT_LT] = ACTIONS(6858),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2087),
    [anon_sym_LF] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2087),
  },
  [2844] = {
    [sym_variable_name] = ACTIONS(2139),
    [anon_sym_esac] = ACTIONS(2141),
    [anon_sym_PIPE] = ACTIONS(2141),
    [anon_sym_SEMI_SEMI] = ACTIONS(2141),
    [anon_sym_PIPE_AMP] = ACTIONS(2141),
    [anon_sym_AMP_AMP] = ACTIONS(2141),
    [anon_sym_PIPE_PIPE] = ACTIONS(2141),
    [sym__special_characters] = ACTIONS(2141),
    [anon_sym_DQUOTE] = ACTIONS(2141),
    [anon_sym_DOLLAR] = ACTIONS(2141),
    [sym_raw_string] = ACTIONS(2141),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2141),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2141),
    [anon_sym_BQUOTE] = ACTIONS(2141),
    [anon_sym_LT_LPAREN] = ACTIONS(2141),
    [anon_sym_GT_LPAREN] = ACTIONS(2141),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2141),
    [sym_word] = ACTIONS(2141),
    [anon_sym_SEMI] = ACTIONS(2141),
    [anon_sym_LF] = ACTIONS(2139),
    [anon_sym_AMP] = ACTIONS(2141),
  },
  [2845] = {
    [sym_concatenation] = STATE(1019),
    [sym_string] = STATE(563),
    [sym_simple_expansion] = STATE(563),
    [sym_string_expansion] = STATE(563),
    [sym_expansion] = STATE(563),
    [sym_command_substitution] = STATE(563),
    [sym_process_substitution] = STATE(563),
    [aux_sym_for_statement_repeat1] = STATE(1019),
    [anon_sym_RPAREN] = ACTIONS(6861),
    [sym__special_characters] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [anon_sym_LT_LPAREN] = ACTIONS(1127),
    [anon_sym_GT_LPAREN] = ACTIONS(1127),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1119),
  },
  [2846] = {
    [sym__concat] = ACTIONS(2752),
    [sym_variable_name] = ACTIONS(2752),
    [anon_sym_esac] = ACTIONS(2754),
    [anon_sym_PIPE] = ACTIONS(2754),
    [anon_sym_SEMI_SEMI] = ACTIONS(2754),
    [anon_sym_PIPE_AMP] = ACTIONS(2754),
    [anon_sym_AMP_AMP] = ACTIONS(2754),
    [anon_sym_PIPE_PIPE] = ACTIONS(2754),
    [sym__special_characters] = ACTIONS(2754),
    [anon_sym_DQUOTE] = ACTIONS(2754),
    [anon_sym_DOLLAR] = ACTIONS(2754),
    [sym_raw_string] = ACTIONS(2754),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2754),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2754),
    [anon_sym_BQUOTE] = ACTIONS(2754),
    [anon_sym_LT_LPAREN] = ACTIONS(2754),
    [anon_sym_GT_LPAREN] = ACTIONS(2754),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2754),
    [sym_word] = ACTIONS(2754),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_LF] = ACTIONS(2752),
    [anon_sym_AMP] = ACTIONS(2754),
  },
  [2847] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(6863),
    [sym_comment] = ACTIONS(53),
  },
  [2848] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(6865),
    [sym_comment] = ACTIONS(53),
  },
  [2849] = {
    [anon_sym_RBRACE] = ACTIONS(6865),
    [sym_comment] = ACTIONS(53),
  },
  [2850] = {
    [sym_concatenation] = STATE(2984),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2984),
    [anon_sym_RBRACE] = ACTIONS(6867),
    [anon_sym_EQ] = ACTIONS(6869),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6871),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6869),
    [anon_sym_COLON_QMARK] = ACTIONS(6869),
    [anon_sym_COLON_DASH] = ACTIONS(6869),
    [anon_sym_PERCENT] = ACTIONS(6869),
    [anon_sym_DASH] = ACTIONS(6869),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2851] = {
    [sym__concat] = ACTIONS(2830),
    [sym_variable_name] = ACTIONS(2830),
    [anon_sym_esac] = ACTIONS(2832),
    [anon_sym_PIPE] = ACTIONS(2832),
    [anon_sym_SEMI_SEMI] = ACTIONS(2832),
    [anon_sym_PIPE_AMP] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_PIPE_PIPE] = ACTIONS(2832),
    [sym__special_characters] = ACTIONS(2832),
    [anon_sym_DQUOTE] = ACTIONS(2832),
    [anon_sym_DOLLAR] = ACTIONS(2832),
    [sym_raw_string] = ACTIONS(2832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2832),
    [anon_sym_BQUOTE] = ACTIONS(2832),
    [anon_sym_LT_LPAREN] = ACTIONS(2832),
    [anon_sym_GT_LPAREN] = ACTIONS(2832),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2832),
    [sym_word] = ACTIONS(2832),
    [anon_sym_SEMI] = ACTIONS(2832),
    [anon_sym_LF] = ACTIONS(2830),
    [anon_sym_AMP] = ACTIONS(2832),
  },
  [2852] = {
    [sym_concatenation] = STATE(2987),
    [sym_string] = STATE(2986),
    [sym_simple_expansion] = STATE(2986),
    [sym_string_expansion] = STATE(2986),
    [sym_expansion] = STATE(2986),
    [sym_command_substitution] = STATE(2986),
    [sym_process_substitution] = STATE(2986),
    [anon_sym_RBRACE] = ACTIONS(6865),
    [sym__special_characters] = ACTIONS(6873),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(6875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6875),
  },
  [2853] = {
    [sym__concat] = ACTIONS(2873),
    [sym_variable_name] = ACTIONS(2873),
    [anon_sym_esac] = ACTIONS(2875),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [anon_sym_PIPE_AMP] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [sym__special_characters] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2875),
    [anon_sym_BQUOTE] = ACTIONS(2875),
    [anon_sym_LT_LPAREN] = ACTIONS(2875),
    [anon_sym_GT_LPAREN] = ACTIONS(2875),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2875),
    [sym_word] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [2854] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6877),
  },
  [2855] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6879),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2856] = {
    [sym__concat] = ACTIONS(2881),
    [sym_variable_name] = ACTIONS(2881),
    [anon_sym_esac] = ACTIONS(2883),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_SEMI_SEMI] = ACTIONS(2883),
    [anon_sym_PIPE_AMP] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [sym__special_characters] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [sym_raw_string] = ACTIONS(2883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2883),
    [anon_sym_BQUOTE] = ACTIONS(2883),
    [anon_sym_LT_LPAREN] = ACTIONS(2883),
    [anon_sym_GT_LPAREN] = ACTIONS(2883),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2883),
    [sym_word] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_LF] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
  },
  [2857] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6881),
  },
  [2858] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6883),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2859] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6885),
  },
  [2860] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6865),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2861] = {
    [sym_concatenation] = STATE(2994),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2994),
    [anon_sym_RBRACE] = ACTIONS(6887),
    [anon_sym_EQ] = ACTIONS(6889),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6891),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6889),
    [anon_sym_COLON_QMARK] = ACTIONS(6889),
    [anon_sym_COLON_DASH] = ACTIONS(6889),
    [anon_sym_PERCENT] = ACTIONS(6889),
    [anon_sym_DASH] = ACTIONS(6889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2862] = {
    [sym__concat] = ACTIONS(2897),
    [sym_variable_name] = ACTIONS(2897),
    [anon_sym_esac] = ACTIONS(2899),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_SEMI_SEMI] = ACTIONS(2899),
    [anon_sym_PIPE_AMP] = ACTIONS(2899),
    [anon_sym_AMP_AMP] = ACTIONS(2899),
    [anon_sym_PIPE_PIPE] = ACTIONS(2899),
    [sym__special_characters] = ACTIONS(2899),
    [anon_sym_DQUOTE] = ACTIONS(2899),
    [anon_sym_DOLLAR] = ACTIONS(2899),
    [sym_raw_string] = ACTIONS(2899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2899),
    [anon_sym_BQUOTE] = ACTIONS(2899),
    [anon_sym_LT_LPAREN] = ACTIONS(2899),
    [anon_sym_GT_LPAREN] = ACTIONS(2899),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2899),
    [sym_word] = ACTIONS(2899),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LF] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2899),
  },
  [2863] = {
    [sym_concatenation] = STATE(2996),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(2996),
    [anon_sym_RBRACE] = ACTIONS(6893),
    [anon_sym_EQ] = ACTIONS(6895),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6897),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6895),
    [anon_sym_COLON_QMARK] = ACTIONS(6895),
    [anon_sym_COLON_DASH] = ACTIONS(6895),
    [anon_sym_PERCENT] = ACTIONS(6895),
    [anon_sym_DASH] = ACTIONS(6895),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2864] = {
    [sym__concat] = ACTIONS(2752),
    [anon_sym_esac] = ACTIONS(2754),
    [anon_sym_PIPE] = ACTIONS(2754),
    [anon_sym_SEMI_SEMI] = ACTIONS(2754),
    [anon_sym_PIPE_AMP] = ACTIONS(2754),
    [anon_sym_AMP_AMP] = ACTIONS(2754),
    [anon_sym_PIPE_PIPE] = ACTIONS(2754),
    [sym__special_characters] = ACTIONS(2754),
    [anon_sym_DQUOTE] = ACTIONS(2754),
    [anon_sym_DOLLAR] = ACTIONS(2754),
    [sym_raw_string] = ACTIONS(2754),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2754),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2754),
    [anon_sym_BQUOTE] = ACTIONS(2754),
    [anon_sym_LT_LPAREN] = ACTIONS(2754),
    [anon_sym_GT_LPAREN] = ACTIONS(2754),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2754),
    [sym_word] = ACTIONS(2754),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_LF] = ACTIONS(2752),
    [anon_sym_AMP] = ACTIONS(2754),
  },
  [2865] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(6899),
    [sym_comment] = ACTIONS(53),
  },
  [2866] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(6901),
    [sym_comment] = ACTIONS(53),
  },
  [2867] = {
    [anon_sym_RBRACE] = ACTIONS(6901),
    [sym_comment] = ACTIONS(53),
  },
  [2868] = {
    [sym_concatenation] = STATE(3000),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3000),
    [anon_sym_RBRACE] = ACTIONS(6903),
    [anon_sym_EQ] = ACTIONS(6905),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6907),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6905),
    [anon_sym_COLON_QMARK] = ACTIONS(6905),
    [anon_sym_COLON_DASH] = ACTIONS(6905),
    [anon_sym_PERCENT] = ACTIONS(6905),
    [anon_sym_DASH] = ACTIONS(6905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2869] = {
    [sym__concat] = ACTIONS(2830),
    [anon_sym_esac] = ACTIONS(2832),
    [anon_sym_PIPE] = ACTIONS(2832),
    [anon_sym_SEMI_SEMI] = ACTIONS(2832),
    [anon_sym_PIPE_AMP] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_PIPE_PIPE] = ACTIONS(2832),
    [sym__special_characters] = ACTIONS(2832),
    [anon_sym_DQUOTE] = ACTIONS(2832),
    [anon_sym_DOLLAR] = ACTIONS(2832),
    [sym_raw_string] = ACTIONS(2832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2832),
    [anon_sym_BQUOTE] = ACTIONS(2832),
    [anon_sym_LT_LPAREN] = ACTIONS(2832),
    [anon_sym_GT_LPAREN] = ACTIONS(2832),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2832),
    [sym_word] = ACTIONS(2832),
    [anon_sym_SEMI] = ACTIONS(2832),
    [anon_sym_LF] = ACTIONS(2830),
    [anon_sym_AMP] = ACTIONS(2832),
  },
  [2870] = {
    [sym_concatenation] = STATE(3003),
    [sym_string] = STATE(3002),
    [sym_simple_expansion] = STATE(3002),
    [sym_string_expansion] = STATE(3002),
    [sym_expansion] = STATE(3002),
    [sym_command_substitution] = STATE(3002),
    [sym_process_substitution] = STATE(3002),
    [anon_sym_RBRACE] = ACTIONS(6901),
    [sym__special_characters] = ACTIONS(6909),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(6911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6911),
  },
  [2871] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_esac] = ACTIONS(2875),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [anon_sym_PIPE_AMP] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [sym__special_characters] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2875),
    [anon_sym_BQUOTE] = ACTIONS(2875),
    [anon_sym_LT_LPAREN] = ACTIONS(2875),
    [anon_sym_GT_LPAREN] = ACTIONS(2875),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2875),
    [sym_word] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [2872] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6913),
  },
  [2873] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6915),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2874] = {
    [sym__concat] = ACTIONS(2881),
    [anon_sym_esac] = ACTIONS(2883),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_SEMI_SEMI] = ACTIONS(2883),
    [anon_sym_PIPE_AMP] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [sym__special_characters] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [sym_raw_string] = ACTIONS(2883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2883),
    [anon_sym_BQUOTE] = ACTIONS(2883),
    [anon_sym_LT_LPAREN] = ACTIONS(2883),
    [anon_sym_GT_LPAREN] = ACTIONS(2883),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2883),
    [sym_word] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_LF] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
  },
  [2875] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6917),
  },
  [2876] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6919),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2877] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6921),
  },
  [2878] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6901),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2879] = {
    [sym_concatenation] = STATE(3010),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3010),
    [anon_sym_RBRACE] = ACTIONS(6923),
    [anon_sym_EQ] = ACTIONS(6925),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6925),
    [anon_sym_COLON_QMARK] = ACTIONS(6925),
    [anon_sym_COLON_DASH] = ACTIONS(6925),
    [anon_sym_PERCENT] = ACTIONS(6925),
    [anon_sym_DASH] = ACTIONS(6925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2880] = {
    [sym__concat] = ACTIONS(2897),
    [anon_sym_esac] = ACTIONS(2899),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_SEMI_SEMI] = ACTIONS(2899),
    [anon_sym_PIPE_AMP] = ACTIONS(2899),
    [anon_sym_AMP_AMP] = ACTIONS(2899),
    [anon_sym_PIPE_PIPE] = ACTIONS(2899),
    [sym__special_characters] = ACTIONS(2899),
    [anon_sym_DQUOTE] = ACTIONS(2899),
    [anon_sym_DOLLAR] = ACTIONS(2899),
    [sym_raw_string] = ACTIONS(2899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2899),
    [anon_sym_BQUOTE] = ACTIONS(2899),
    [anon_sym_LT_LPAREN] = ACTIONS(2899),
    [anon_sym_GT_LPAREN] = ACTIONS(2899),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2899),
    [sym_word] = ACTIONS(2899),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LF] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2899),
  },
  [2881] = {
    [sym_concatenation] = STATE(3012),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3012),
    [anon_sym_RBRACE] = ACTIONS(6929),
    [anon_sym_EQ] = ACTIONS(6931),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6933),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6931),
    [anon_sym_COLON_QMARK] = ACTIONS(6931),
    [anon_sym_COLON_DASH] = ACTIONS(6931),
    [anon_sym_PERCENT] = ACTIONS(6931),
    [anon_sym_DASH] = ACTIONS(6931),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2882] = {
    [sym__simple_heredoc_body] = ACTIONS(3917),
    [sym__heredoc_body_beginning] = ACTIONS(3917),
    [sym_file_descriptor] = ACTIONS(3917),
    [sym__concat] = ACTIONS(3917),
    [anon_sym_esac] = ACTIONS(3919),
    [anon_sym_PIPE] = ACTIONS(3919),
    [anon_sym_SEMI_SEMI] = ACTIONS(3919),
    [anon_sym_PIPE_AMP] = ACTIONS(3919),
    [anon_sym_AMP_AMP] = ACTIONS(3919),
    [anon_sym_PIPE_PIPE] = ACTIONS(3919),
    [anon_sym_EQ_TILDE] = ACTIONS(3919),
    [anon_sym_EQ_EQ] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_GT] = ACTIONS(3919),
    [anon_sym_GT_GT] = ACTIONS(3919),
    [anon_sym_AMP_GT] = ACTIONS(3919),
    [anon_sym_AMP_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_AMP] = ACTIONS(3919),
    [anon_sym_GT_AMP] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_LT_LT_DASH] = ACTIONS(3919),
    [anon_sym_LT_LT_LT] = ACTIONS(3919),
    [sym__special_characters] = ACTIONS(3919),
    [anon_sym_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3919),
    [sym_raw_string] = ACTIONS(3919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3919),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3919),
    [anon_sym_BQUOTE] = ACTIONS(3919),
    [anon_sym_LT_LPAREN] = ACTIONS(3919),
    [anon_sym_GT_LPAREN] = ACTIONS(3919),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3919),
    [anon_sym_SEMI] = ACTIONS(3919),
    [anon_sym_LF] = ACTIONS(3917),
    [anon_sym_AMP] = ACTIONS(3919),
  },
  [2883] = {
    [sym__simple_heredoc_body] = ACTIONS(3923),
    [sym__heredoc_body_beginning] = ACTIONS(3923),
    [sym_file_descriptor] = ACTIONS(3923),
    [sym__concat] = ACTIONS(3923),
    [anon_sym_esac] = ACTIONS(3925),
    [anon_sym_PIPE] = ACTIONS(3925),
    [anon_sym_SEMI_SEMI] = ACTIONS(3925),
    [anon_sym_PIPE_AMP] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [anon_sym_EQ_TILDE] = ACTIONS(3925),
    [anon_sym_EQ_EQ] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_GT] = ACTIONS(3925),
    [anon_sym_GT_GT] = ACTIONS(3925),
    [anon_sym_AMP_GT] = ACTIONS(3925),
    [anon_sym_AMP_GT_GT] = ACTIONS(3925),
    [anon_sym_LT_AMP] = ACTIONS(3925),
    [anon_sym_GT_AMP] = ACTIONS(3925),
    [anon_sym_LT_LT] = ACTIONS(3925),
    [anon_sym_LT_LT_DASH] = ACTIONS(3925),
    [anon_sym_LT_LT_LT] = ACTIONS(3925),
    [sym__special_characters] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [sym_raw_string] = ACTIONS(3925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3925),
    [anon_sym_BQUOTE] = ACTIONS(3925),
    [anon_sym_LT_LPAREN] = ACTIONS(3925),
    [anon_sym_GT_LPAREN] = ACTIONS(3925),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3925),
    [anon_sym_SEMI] = ACTIONS(3925),
    [anon_sym_LF] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3925),
  },
  [2884] = {
    [sym__simple_heredoc_body] = ACTIONS(4008),
    [sym__heredoc_body_beginning] = ACTIONS(4008),
    [sym_file_descriptor] = ACTIONS(4008),
    [sym__concat] = ACTIONS(4008),
    [anon_sym_esac] = ACTIONS(4010),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_SEMI_SEMI] = ACTIONS(4010),
    [anon_sym_PIPE_AMP] = ACTIONS(4010),
    [anon_sym_AMP_AMP] = ACTIONS(4010),
    [anon_sym_PIPE_PIPE] = ACTIONS(4010),
    [anon_sym_EQ_TILDE] = ACTIONS(4010),
    [anon_sym_EQ_EQ] = ACTIONS(4010),
    [anon_sym_LT] = ACTIONS(4010),
    [anon_sym_GT] = ACTIONS(4010),
    [anon_sym_GT_GT] = ACTIONS(4010),
    [anon_sym_AMP_GT] = ACTIONS(4010),
    [anon_sym_AMP_GT_GT] = ACTIONS(4010),
    [anon_sym_LT_AMP] = ACTIONS(4010),
    [anon_sym_GT_AMP] = ACTIONS(4010),
    [anon_sym_LT_LT] = ACTIONS(4010),
    [anon_sym_LT_LT_DASH] = ACTIONS(4010),
    [anon_sym_LT_LT_LT] = ACTIONS(4010),
    [sym__special_characters] = ACTIONS(4010),
    [anon_sym_DQUOTE] = ACTIONS(4010),
    [anon_sym_DOLLAR] = ACTIONS(4010),
    [sym_raw_string] = ACTIONS(4010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4010),
    [anon_sym_BQUOTE] = ACTIONS(4010),
    [anon_sym_LT_LPAREN] = ACTIONS(4010),
    [anon_sym_GT_LPAREN] = ACTIONS(4010),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4010),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LF] = ACTIONS(4008),
    [anon_sym_AMP] = ACTIONS(4010),
  },
  [2885] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6935),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2886] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(6937),
    [sym_comment] = ACTIONS(53),
  },
  [2887] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(6939),
    [sym_comment] = ACTIONS(53),
  },
  [2888] = {
    [anon_sym_RBRACE] = ACTIONS(6939),
    [sym_comment] = ACTIONS(53),
  },
  [2889] = {
    [sym_concatenation] = STATE(3017),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3017),
    [anon_sym_RBRACE] = ACTIONS(6941),
    [anon_sym_EQ] = ACTIONS(6943),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6943),
    [anon_sym_COLON_QMARK] = ACTIONS(6943),
    [anon_sym_COLON_DASH] = ACTIONS(6943),
    [anon_sym_PERCENT] = ACTIONS(6943),
    [anon_sym_DASH] = ACTIONS(6943),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2890] = {
    [sym__simple_heredoc_body] = ACTIONS(4024),
    [sym__heredoc_body_beginning] = ACTIONS(4024),
    [sym_file_descriptor] = ACTIONS(4024),
    [sym__concat] = ACTIONS(4024),
    [anon_sym_esac] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_SEMI_SEMI] = ACTIONS(4026),
    [anon_sym_PIPE_AMP] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4026),
    [anon_sym_PIPE_PIPE] = ACTIONS(4026),
    [anon_sym_EQ_TILDE] = ACTIONS(4026),
    [anon_sym_EQ_EQ] = ACTIONS(4026),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_AMP_GT] = ACTIONS(4026),
    [anon_sym_AMP_GT_GT] = ACTIONS(4026),
    [anon_sym_LT_AMP] = ACTIONS(4026),
    [anon_sym_GT_AMP] = ACTIONS(4026),
    [anon_sym_LT_LT] = ACTIONS(4026),
    [anon_sym_LT_LT_DASH] = ACTIONS(4026),
    [anon_sym_LT_LT_LT] = ACTIONS(4026),
    [sym__special_characters] = ACTIONS(4026),
    [anon_sym_DQUOTE] = ACTIONS(4026),
    [anon_sym_DOLLAR] = ACTIONS(4026),
    [sym_raw_string] = ACTIONS(4026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4026),
    [anon_sym_BQUOTE] = ACTIONS(4026),
    [anon_sym_LT_LPAREN] = ACTIONS(4026),
    [anon_sym_GT_LPAREN] = ACTIONS(4026),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4026),
    [anon_sym_SEMI] = ACTIONS(4026),
    [anon_sym_LF] = ACTIONS(4024),
    [anon_sym_AMP] = ACTIONS(4026),
  },
  [2891] = {
    [sym_concatenation] = STATE(3019),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3019),
    [anon_sym_RBRACE] = ACTIONS(6947),
    [anon_sym_EQ] = ACTIONS(6949),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6949),
    [anon_sym_COLON_QMARK] = ACTIONS(6949),
    [anon_sym_COLON_DASH] = ACTIONS(6949),
    [anon_sym_PERCENT] = ACTIONS(6949),
    [anon_sym_DASH] = ACTIONS(6949),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2892] = {
    [sym__simple_heredoc_body] = ACTIONS(4034),
    [sym__heredoc_body_beginning] = ACTIONS(4034),
    [sym_file_descriptor] = ACTIONS(4034),
    [sym__concat] = ACTIONS(4034),
    [anon_sym_esac] = ACTIONS(4036),
    [anon_sym_PIPE] = ACTIONS(4036),
    [anon_sym_SEMI_SEMI] = ACTIONS(4036),
    [anon_sym_PIPE_AMP] = ACTIONS(4036),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [anon_sym_EQ_TILDE] = ACTIONS(4036),
    [anon_sym_EQ_EQ] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4036),
    [anon_sym_GT] = ACTIONS(4036),
    [anon_sym_GT_GT] = ACTIONS(4036),
    [anon_sym_AMP_GT] = ACTIONS(4036),
    [anon_sym_AMP_GT_GT] = ACTIONS(4036),
    [anon_sym_LT_AMP] = ACTIONS(4036),
    [anon_sym_GT_AMP] = ACTIONS(4036),
    [anon_sym_LT_LT] = ACTIONS(4036),
    [anon_sym_LT_LT_DASH] = ACTIONS(4036),
    [anon_sym_LT_LT_LT] = ACTIONS(4036),
    [sym__special_characters] = ACTIONS(4036),
    [anon_sym_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR] = ACTIONS(4036),
    [sym_raw_string] = ACTIONS(4036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4036),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4036),
    [anon_sym_GT_LPAREN] = ACTIONS(4036),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4036),
    [anon_sym_SEMI] = ACTIONS(4036),
    [anon_sym_LF] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
  },
  [2893] = {
    [sym_concatenation] = STATE(3021),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3021),
    [anon_sym_RBRACE] = ACTIONS(6953),
    [anon_sym_EQ] = ACTIONS(6955),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(6955),
    [anon_sym_COLON_QMARK] = ACTIONS(6955),
    [anon_sym_COLON_DASH] = ACTIONS(6955),
    [anon_sym_PERCENT] = ACTIONS(6955),
    [anon_sym_DASH] = ACTIONS(6955),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2894] = {
    [sym__simple_heredoc_body] = ACTIONS(4044),
    [sym__heredoc_body_beginning] = ACTIONS(4044),
    [sym_file_descriptor] = ACTIONS(4044),
    [sym__concat] = ACTIONS(4044),
    [anon_sym_esac] = ACTIONS(4046),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_SEMI_SEMI] = ACTIONS(4046),
    [anon_sym_PIPE_AMP] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4046),
    [anon_sym_PIPE_PIPE] = ACTIONS(4046),
    [anon_sym_EQ_TILDE] = ACTIONS(4046),
    [anon_sym_EQ_EQ] = ACTIONS(4046),
    [anon_sym_LT] = ACTIONS(4046),
    [anon_sym_GT] = ACTIONS(4046),
    [anon_sym_GT_GT] = ACTIONS(4046),
    [anon_sym_AMP_GT] = ACTIONS(4046),
    [anon_sym_AMP_GT_GT] = ACTIONS(4046),
    [anon_sym_LT_AMP] = ACTIONS(4046),
    [anon_sym_GT_AMP] = ACTIONS(4046),
    [anon_sym_LT_LT] = ACTIONS(4046),
    [anon_sym_LT_LT_DASH] = ACTIONS(4046),
    [anon_sym_LT_LT_LT] = ACTIONS(4046),
    [sym__special_characters] = ACTIONS(4046),
    [anon_sym_DQUOTE] = ACTIONS(4046),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [sym_raw_string] = ACTIONS(4046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4046),
    [anon_sym_BQUOTE] = ACTIONS(4046),
    [anon_sym_LT_LPAREN] = ACTIONS(4046),
    [anon_sym_GT_LPAREN] = ACTIONS(4046),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4046),
    [anon_sym_SEMI] = ACTIONS(4046),
    [anon_sym_LF] = ACTIONS(4044),
    [anon_sym_AMP] = ACTIONS(4046),
  },
  [2895] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6959),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2896] = {
    [sym__simple_heredoc_body] = ACTIONS(4050),
    [sym__heredoc_body_beginning] = ACTIONS(4050),
    [sym_file_descriptor] = ACTIONS(4050),
    [sym__concat] = ACTIONS(4050),
    [anon_sym_esac] = ACTIONS(4052),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_SEMI_SEMI] = ACTIONS(4052),
    [anon_sym_PIPE_AMP] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4052),
    [anon_sym_PIPE_PIPE] = ACTIONS(4052),
    [anon_sym_EQ_TILDE] = ACTIONS(4052),
    [anon_sym_EQ_EQ] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_AMP_GT] = ACTIONS(4052),
    [anon_sym_AMP_GT_GT] = ACTIONS(4052),
    [anon_sym_LT_AMP] = ACTIONS(4052),
    [anon_sym_GT_AMP] = ACTIONS(4052),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_LT_LT_DASH] = ACTIONS(4052),
    [anon_sym_LT_LT_LT] = ACTIONS(4052),
    [sym__special_characters] = ACTIONS(4052),
    [anon_sym_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [sym_raw_string] = ACTIONS(4052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4052),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4052),
    [anon_sym_BQUOTE] = ACTIONS(4052),
    [anon_sym_LT_LPAREN] = ACTIONS(4052),
    [anon_sym_GT_LPAREN] = ACTIONS(4052),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4052),
    [anon_sym_SEMI] = ACTIONS(4052),
    [anon_sym_LF] = ACTIONS(4050),
    [anon_sym_AMP] = ACTIONS(4052),
  },
  [2897] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6961),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2898] = {
    [sym__simple_heredoc_body] = ACTIONS(1654),
    [sym__heredoc_body_beginning] = ACTIONS(1654),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(1654),
    [anon_sym_esac] = ACTIONS(1656),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1656),
    [anon_sym_LT_AMP] = ACTIONS(1656),
    [anon_sym_GT_AMP] = ACTIONS(1656),
    [anon_sym_LT_LT] = ACTIONS(1656),
    [anon_sym_LT_LT_DASH] = ACTIONS(1656),
    [anon_sym_LT_LT_LT] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [2899] = {
    [aux_sym_concatenation_repeat1] = STATE(2899),
    [sym__simple_heredoc_body] = ACTIONS(1654),
    [sym__heredoc_body_beginning] = ACTIONS(1654),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(6963),
    [anon_sym_esac] = ACTIONS(1656),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1656),
    [anon_sym_LT_AMP] = ACTIONS(1656),
    [anon_sym_GT_AMP] = ACTIONS(1656),
    [anon_sym_LT_LT] = ACTIONS(1656),
    [anon_sym_LT_LT_DASH] = ACTIONS(1656),
    [anon_sym_LT_LT_LT] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [2900] = {
    [sym__simple_heredoc_body] = ACTIONS(1703),
    [sym__heredoc_body_beginning] = ACTIONS(1703),
    [sym_file_descriptor] = ACTIONS(1703),
    [sym__concat] = ACTIONS(1703),
    [anon_sym_esac] = ACTIONS(1705),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_SEMI_SEMI] = ACTIONS(1705),
    [anon_sym_PIPE_AMP] = ACTIONS(1705),
    [anon_sym_AMP_AMP] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1705),
    [anon_sym_GT] = ACTIONS(1705),
    [anon_sym_GT_GT] = ACTIONS(1705),
    [anon_sym_AMP_GT] = ACTIONS(1705),
    [anon_sym_AMP_GT_GT] = ACTIONS(1705),
    [anon_sym_LT_AMP] = ACTIONS(1705),
    [anon_sym_GT_AMP] = ACTIONS(1705),
    [anon_sym_LT_LT] = ACTIONS(1705),
    [anon_sym_LT_LT_DASH] = ACTIONS(1705),
    [anon_sym_LT_LT_LT] = ACTIONS(1705),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_LF] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1705),
  },
  [2901] = {
    [sym_concatenation] = STATE(3027),
    [sym_string] = STATE(3026),
    [sym_simple_expansion] = STATE(3026),
    [sym_string_expansion] = STATE(3026),
    [sym_expansion] = STATE(3026),
    [sym_command_substitution] = STATE(3026),
    [sym_process_substitution] = STATE(3026),
    [anon_sym_RBRACE] = ACTIONS(6966),
    [sym__special_characters] = ACTIONS(6968),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(6970),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6970),
  },
  [2902] = {
    [sym__simple_heredoc_body] = ACTIONS(1744),
    [sym__heredoc_body_beginning] = ACTIONS(1744),
    [sym_file_descriptor] = ACTIONS(1744),
    [sym__concat] = ACTIONS(1744),
    [anon_sym_esac] = ACTIONS(1746),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_SEMI_SEMI] = ACTIONS(1746),
    [anon_sym_PIPE_AMP] = ACTIONS(1746),
    [anon_sym_AMP_AMP] = ACTIONS(1746),
    [anon_sym_PIPE_PIPE] = ACTIONS(1746),
    [anon_sym_LT] = ACTIONS(1746),
    [anon_sym_GT] = ACTIONS(1746),
    [anon_sym_GT_GT] = ACTIONS(1746),
    [anon_sym_AMP_GT] = ACTIONS(1746),
    [anon_sym_AMP_GT_GT] = ACTIONS(1746),
    [anon_sym_LT_AMP] = ACTIONS(1746),
    [anon_sym_GT_AMP] = ACTIONS(1746),
    [anon_sym_LT_LT] = ACTIONS(1746),
    [anon_sym_LT_LT_DASH] = ACTIONS(1746),
    [anon_sym_LT_LT_LT] = ACTIONS(1746),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1746),
    [anon_sym_LF] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(1746),
  },
  [2903] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(6972),
  },
  [2904] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6974),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2905] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(6976),
    [sym_comment] = ACTIONS(53),
  },
  [2906] = {
    [sym_concatenation] = STATE(3033),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3033),
    [anon_sym_RBRACE] = ACTIONS(6978),
    [anon_sym_EQ] = ACTIONS(6980),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6982),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6984),
    [anon_sym_COLON] = ACTIONS(6980),
    [anon_sym_COLON_QMARK] = ACTIONS(6980),
    [anon_sym_COLON_DASH] = ACTIONS(6980),
    [anon_sym_PERCENT] = ACTIONS(6980),
    [anon_sym_DASH] = ACTIONS(6980),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2907] = {
    [sym_concatenation] = STATE(3036),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3036),
    [anon_sym_RBRACE] = ACTIONS(6986),
    [anon_sym_EQ] = ACTIONS(6988),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6990),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6992),
    [anon_sym_COLON] = ACTIONS(6988),
    [anon_sym_COLON_QMARK] = ACTIONS(6988),
    [anon_sym_COLON_DASH] = ACTIONS(6988),
    [anon_sym_PERCENT] = ACTIONS(6988),
    [anon_sym_DASH] = ACTIONS(6988),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2908] = {
    [sym_concatenation] = STATE(3038),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3038),
    [anon_sym_RBRACE] = ACTIONS(6966),
    [anon_sym_EQ] = ACTIONS(6994),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(6996),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(6998),
    [anon_sym_COLON] = ACTIONS(6994),
    [anon_sym_COLON_QMARK] = ACTIONS(6994),
    [anon_sym_COLON_DASH] = ACTIONS(6994),
    [anon_sym_PERCENT] = ACTIONS(6994),
    [anon_sym_DASH] = ACTIONS(6994),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2909] = {
    [sym__simple_heredoc_body] = ACTIONS(1810),
    [sym__heredoc_body_beginning] = ACTIONS(1810),
    [sym_file_descriptor] = ACTIONS(1810),
    [sym__concat] = ACTIONS(1810),
    [anon_sym_esac] = ACTIONS(1812),
    [anon_sym_PIPE] = ACTIONS(1812),
    [anon_sym_SEMI_SEMI] = ACTIONS(1812),
    [anon_sym_PIPE_AMP] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1812),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [anon_sym_LT] = ACTIONS(1812),
    [anon_sym_GT] = ACTIONS(1812),
    [anon_sym_GT_GT] = ACTIONS(1812),
    [anon_sym_AMP_GT] = ACTIONS(1812),
    [anon_sym_AMP_GT_GT] = ACTIONS(1812),
    [anon_sym_LT_AMP] = ACTIONS(1812),
    [anon_sym_GT_AMP] = ACTIONS(1812),
    [anon_sym_LT_LT] = ACTIONS(1812),
    [anon_sym_LT_LT_DASH] = ACTIONS(1812),
    [anon_sym_LT_LT_LT] = ACTIONS(1812),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1812),
    [anon_sym_LF] = ACTIONS(1810),
    [anon_sym_AMP] = ACTIONS(1812),
  },
  [2910] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(7000),
  },
  [2911] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7002),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2912] = {
    [sym__simple_heredoc_body] = ACTIONS(1818),
    [sym__heredoc_body_beginning] = ACTIONS(1818),
    [sym_file_descriptor] = ACTIONS(1818),
    [sym__concat] = ACTIONS(1818),
    [anon_sym_esac] = ACTIONS(1820),
    [anon_sym_PIPE] = ACTIONS(1820),
    [anon_sym_SEMI_SEMI] = ACTIONS(1820),
    [anon_sym_PIPE_AMP] = ACTIONS(1820),
    [anon_sym_AMP_AMP] = ACTIONS(1820),
    [anon_sym_PIPE_PIPE] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1820),
    [anon_sym_GT] = ACTIONS(1820),
    [anon_sym_GT_GT] = ACTIONS(1820),
    [anon_sym_AMP_GT] = ACTIONS(1820),
    [anon_sym_AMP_GT_GT] = ACTIONS(1820),
    [anon_sym_LT_AMP] = ACTIONS(1820),
    [anon_sym_GT_AMP] = ACTIONS(1820),
    [anon_sym_LT_LT] = ACTIONS(1820),
    [anon_sym_LT_LT_DASH] = ACTIONS(1820),
    [anon_sym_LT_LT_LT] = ACTIONS(1820),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1820),
    [anon_sym_LF] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1820),
  },
  [2913] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(7004),
  },
  [2914] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(6966),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2915] = {
    [sym__simple_heredoc_body] = ACTIONS(1952),
    [sym__heredoc_body_beginning] = ACTIONS(1952),
    [sym_file_descriptor] = ACTIONS(1952),
    [sym__concat] = ACTIONS(1952),
    [anon_sym_esac] = ACTIONS(1954),
    [anon_sym_PIPE] = ACTIONS(1954),
    [anon_sym_SEMI_SEMI] = ACTIONS(1954),
    [anon_sym_PIPE_AMP] = ACTIONS(1954),
    [anon_sym_AMP_AMP] = ACTIONS(1954),
    [anon_sym_PIPE_PIPE] = ACTIONS(1954),
    [anon_sym_LT] = ACTIONS(1954),
    [anon_sym_GT] = ACTIONS(1954),
    [anon_sym_GT_GT] = ACTIONS(1954),
    [anon_sym_AMP_GT] = ACTIONS(1954),
    [anon_sym_AMP_GT_GT] = ACTIONS(1954),
    [anon_sym_LT_AMP] = ACTIONS(1954),
    [anon_sym_GT_AMP] = ACTIONS(1954),
    [anon_sym_LT_LT] = ACTIONS(1954),
    [anon_sym_LT_LT_DASH] = ACTIONS(1954),
    [anon_sym_LT_LT_LT] = ACTIONS(1954),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1954),
    [anon_sym_LF] = ACTIONS(1952),
    [anon_sym_AMP] = ACTIONS(1954),
  },
  [2916] = {
    [sym__simple_heredoc_body] = ACTIONS(2018),
    [sym__heredoc_body_beginning] = ACTIONS(2018),
    [sym_file_descriptor] = ACTIONS(2018),
    [sym__concat] = ACTIONS(2018),
    [anon_sym_esac] = ACTIONS(2020),
    [anon_sym_PIPE] = ACTIONS(2020),
    [anon_sym_SEMI_SEMI] = ACTIONS(2020),
    [anon_sym_PIPE_AMP] = ACTIONS(2020),
    [anon_sym_AMP_AMP] = ACTIONS(2020),
    [anon_sym_PIPE_PIPE] = ACTIONS(2020),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(2020),
    [anon_sym_GT_GT] = ACTIONS(2020),
    [anon_sym_AMP_GT] = ACTIONS(2020),
    [anon_sym_AMP_GT_GT] = ACTIONS(2020),
    [anon_sym_LT_AMP] = ACTIONS(2020),
    [anon_sym_GT_AMP] = ACTIONS(2020),
    [anon_sym_LT_LT] = ACTIONS(2020),
    [anon_sym_LT_LT_DASH] = ACTIONS(2020),
    [anon_sym_LT_LT_LT] = ACTIONS(2020),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2020),
    [anon_sym_LF] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2020),
  },
  [2917] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(6391),
    [anon_sym_DQUOTE] = ACTIONS(6393),
    [anon_sym_DOLLAR] = ACTIONS(6391),
    [sym_raw_string] = ACTIONS(6393),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6393),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6393),
    [anon_sym_BQUOTE] = ACTIONS(6393),
    [anon_sym_LT_LPAREN] = ACTIONS(6393),
    [anon_sym_GT_LPAREN] = ACTIONS(6393),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6391),
  },
  [2918] = {
    [sym__special_characters] = ACTIONS(6393),
    [anon_sym_DQUOTE] = ACTIONS(6393),
    [anon_sym_DOLLAR] = ACTIONS(6391),
    [sym_raw_string] = ACTIONS(6393),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6393),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6393),
    [anon_sym_BQUOTE] = ACTIONS(6393),
    [anon_sym_LT_LPAREN] = ACTIONS(6393),
    [anon_sym_GT_LPAREN] = ACTIONS(6393),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6393),
  },
  [2919] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(7006),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2920] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(7006),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2921] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(6399),
    [anon_sym_DQUOTE] = ACTIONS(6401),
    [anon_sym_DOLLAR] = ACTIONS(6399),
    [sym_raw_string] = ACTIONS(6401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6401),
    [anon_sym_BQUOTE] = ACTIONS(6401),
    [anon_sym_LT_LPAREN] = ACTIONS(6401),
    [anon_sym_GT_LPAREN] = ACTIONS(6401),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6399),
  },
  [2922] = {
    [sym__special_characters] = ACTIONS(6401),
    [anon_sym_DQUOTE] = ACTIONS(6401),
    [anon_sym_DOLLAR] = ACTIONS(6399),
    [sym_raw_string] = ACTIONS(6401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6401),
    [anon_sym_BQUOTE] = ACTIONS(6401),
    [anon_sym_LT_LPAREN] = ACTIONS(6401),
    [anon_sym_GT_LPAREN] = ACTIONS(6401),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6401),
  },
  [2923] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(7008),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2924] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(7008),
    [anon_sym_PIPE_AMP] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_characters] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(331),
  },
  [2925] = {
    [sym_file_descriptor] = ACTIONS(5540),
    [sym__concat] = ACTIONS(5540),
    [anon_sym_esac] = ACTIONS(5542),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_RPAREN] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [anon_sym_PIPE_AMP] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE] = ACTIONS(5542),
    [anon_sym_LT] = ACTIONS(5542),
    [anon_sym_GT] = ACTIONS(5542),
    [anon_sym_GT_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT_GT] = ACTIONS(5542),
    [anon_sym_LT_AMP] = ACTIONS(5542),
    [anon_sym_GT_AMP] = ACTIONS(5542),
    [anon_sym_LT_LT] = ACTIONS(5542),
    [anon_sym_LT_LT_DASH] = ACTIONS(5542),
    [anon_sym_LT_LT_LT] = ACTIONS(5542),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [2926] = {
    [sym_file_descriptor] = ACTIONS(5544),
    [sym__concat] = ACTIONS(5544),
    [anon_sym_esac] = ACTIONS(5546),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_RPAREN] = ACTIONS(5546),
    [anon_sym_SEMI_SEMI] = ACTIONS(5546),
    [anon_sym_PIPE_AMP] = ACTIONS(5546),
    [anon_sym_AMP_AMP] = ACTIONS(5546),
    [anon_sym_PIPE_PIPE] = ACTIONS(5546),
    [anon_sym_LT] = ACTIONS(5546),
    [anon_sym_GT] = ACTIONS(5546),
    [anon_sym_GT_GT] = ACTIONS(5546),
    [anon_sym_AMP_GT] = ACTIONS(5546),
    [anon_sym_AMP_GT_GT] = ACTIONS(5546),
    [anon_sym_LT_AMP] = ACTIONS(5546),
    [anon_sym_GT_AMP] = ACTIONS(5546),
    [anon_sym_LT_LT] = ACTIONS(5546),
    [anon_sym_LT_LT_DASH] = ACTIONS(5546),
    [anon_sym_LT_LT_LT] = ACTIONS(5546),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5546),
    [anon_sym_LF] = ACTIONS(5544),
    [anon_sym_AMP] = ACTIONS(5546),
  },
  [2927] = {
    [sym_file_descriptor] = ACTIONS(5548),
    [sym__concat] = ACTIONS(5548),
    [anon_sym_esac] = ACTIONS(5550),
    [anon_sym_PIPE] = ACTIONS(5550),
    [anon_sym_RPAREN] = ACTIONS(5550),
    [anon_sym_SEMI_SEMI] = ACTIONS(5550),
    [anon_sym_PIPE_AMP] = ACTIONS(5550),
    [anon_sym_AMP_AMP] = ACTIONS(5550),
    [anon_sym_PIPE_PIPE] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5550),
    [anon_sym_GT] = ACTIONS(5550),
    [anon_sym_GT_GT] = ACTIONS(5550),
    [anon_sym_AMP_GT] = ACTIONS(5550),
    [anon_sym_AMP_GT_GT] = ACTIONS(5550),
    [anon_sym_LT_AMP] = ACTIONS(5550),
    [anon_sym_GT_AMP] = ACTIONS(5550),
    [anon_sym_LT_LT] = ACTIONS(5550),
    [anon_sym_LT_LT_DASH] = ACTIONS(5550),
    [anon_sym_LT_LT_LT] = ACTIONS(5550),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5550),
    [anon_sym_LF] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
  },
  [2928] = {
    [sym_file_descriptor] = ACTIONS(4884),
    [sym__concat] = ACTIONS(4884),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_RPAREN] = ACTIONS(4884),
    [anon_sym_PIPE_AMP] = ACTIONS(4884),
    [anon_sym_AMP_AMP] = ACTIONS(4884),
    [anon_sym_PIPE_PIPE] = ACTIONS(4884),
    [anon_sym_LT] = ACTIONS(4886),
    [anon_sym_GT] = ACTIONS(4886),
    [anon_sym_GT_GT] = ACTIONS(4884),
    [anon_sym_AMP_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT_GT] = ACTIONS(4884),
    [anon_sym_LT_AMP] = ACTIONS(4884),
    [anon_sym_GT_AMP] = ACTIONS(4884),
    [anon_sym_LT_LT] = ACTIONS(4886),
    [anon_sym_LT_LT_DASH] = ACTIONS(4884),
    [anon_sym_LT_LT_LT] = ACTIONS(4884),
    [anon_sym_BQUOTE] = ACTIONS(4884),
    [sym_comment] = ACTIONS(53),
  },
  [2929] = {
    [sym_file_descriptor] = ACTIONS(4888),
    [sym__concat] = ACTIONS(4888),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_RPAREN] = ACTIONS(4888),
    [anon_sym_PIPE_AMP] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4888),
    [anon_sym_PIPE_PIPE] = ACTIONS(4888),
    [anon_sym_LT] = ACTIONS(4890),
    [anon_sym_GT] = ACTIONS(4890),
    [anon_sym_GT_GT] = ACTIONS(4888),
    [anon_sym_AMP_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT_GT] = ACTIONS(4888),
    [anon_sym_LT_AMP] = ACTIONS(4888),
    [anon_sym_GT_AMP] = ACTIONS(4888),
    [anon_sym_LT_LT] = ACTIONS(4890),
    [anon_sym_LT_LT_DASH] = ACTIONS(4888),
    [anon_sym_LT_LT_LT] = ACTIONS(4888),
    [anon_sym_BQUOTE] = ACTIONS(4888),
    [sym_comment] = ACTIONS(53),
  },
  [2930] = {
    [sym_file_descriptor] = ACTIONS(4892),
    [sym__concat] = ACTIONS(4892),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_RPAREN] = ACTIONS(4892),
    [anon_sym_PIPE_AMP] = ACTIONS(4892),
    [anon_sym_AMP_AMP] = ACTIONS(4892),
    [anon_sym_PIPE_PIPE] = ACTIONS(4892),
    [anon_sym_LT] = ACTIONS(4894),
    [anon_sym_GT] = ACTIONS(4894),
    [anon_sym_GT_GT] = ACTIONS(4892),
    [anon_sym_AMP_GT] = ACTIONS(4894),
    [anon_sym_AMP_GT_GT] = ACTIONS(4892),
    [anon_sym_LT_AMP] = ACTIONS(4892),
    [anon_sym_GT_AMP] = ACTIONS(4892),
    [anon_sym_LT_LT] = ACTIONS(4894),
    [anon_sym_LT_LT_DASH] = ACTIONS(4892),
    [anon_sym_LT_LT_LT] = ACTIONS(4892),
    [anon_sym_BQUOTE] = ACTIONS(4892),
    [sym_comment] = ACTIONS(53),
  },
  [2931] = {
    [sym_file_descriptor] = ACTIONS(4896),
    [sym__concat] = ACTIONS(4896),
    [anon_sym_PIPE] = ACTIONS(4898),
    [anon_sym_RPAREN] = ACTIONS(4896),
    [anon_sym_PIPE_AMP] = ACTIONS(4896),
    [anon_sym_AMP_AMP] = ACTIONS(4896),
    [anon_sym_PIPE_PIPE] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(4898),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_GT_GT] = ACTIONS(4896),
    [anon_sym_AMP_GT] = ACTIONS(4898),
    [anon_sym_AMP_GT_GT] = ACTIONS(4896),
    [anon_sym_LT_AMP] = ACTIONS(4896),
    [anon_sym_GT_AMP] = ACTIONS(4896),
    [anon_sym_LT_LT] = ACTIONS(4898),
    [anon_sym_LT_LT_DASH] = ACTIONS(4896),
    [anon_sym_LT_LT_LT] = ACTIONS(4896),
    [anon_sym_BQUOTE] = ACTIONS(4896),
    [sym_comment] = ACTIONS(53),
  },
  [2932] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7010),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2933] = {
    [sym_file_descriptor] = ACTIONS(4902),
    [sym__concat] = ACTIONS(4902),
    [anon_sym_PIPE] = ACTIONS(4904),
    [anon_sym_RPAREN] = ACTIONS(4902),
    [anon_sym_PIPE_AMP] = ACTIONS(4902),
    [anon_sym_AMP_AMP] = ACTIONS(4902),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_GT] = ACTIONS(4904),
    [anon_sym_GT_GT] = ACTIONS(4902),
    [anon_sym_AMP_GT] = ACTIONS(4904),
    [anon_sym_AMP_GT_GT] = ACTIONS(4902),
    [anon_sym_LT_AMP] = ACTIONS(4902),
    [anon_sym_GT_AMP] = ACTIONS(4902),
    [anon_sym_LT_LT] = ACTIONS(4904),
    [anon_sym_LT_LT_DASH] = ACTIONS(4902),
    [anon_sym_LT_LT_LT] = ACTIONS(4902),
    [anon_sym_BQUOTE] = ACTIONS(4902),
    [sym_comment] = ACTIONS(53),
  },
  [2934] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7012),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2935] = {
    [sym_file_descriptor] = ACTIONS(4908),
    [sym__concat] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_RPAREN] = ACTIONS(4908),
    [anon_sym_PIPE_AMP] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_LT] = ACTIONS(4910),
    [anon_sym_GT] = ACTIONS(4910),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_AMP_GT] = ACTIONS(4910),
    [anon_sym_AMP_GT_GT] = ACTIONS(4908),
    [anon_sym_LT_AMP] = ACTIONS(4908),
    [anon_sym_GT_AMP] = ACTIONS(4908),
    [anon_sym_LT_LT] = ACTIONS(4910),
    [anon_sym_LT_LT_DASH] = ACTIONS(4908),
    [anon_sym_LT_LT_LT] = ACTIONS(4908),
    [anon_sym_BQUOTE] = ACTIONS(4908),
    [sym_comment] = ACTIONS(53),
  },
  [2936] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7014),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2937] = {
    [sym_file_descriptor] = ACTIONS(4914),
    [sym__concat] = ACTIONS(4914),
    [anon_sym_PIPE] = ACTIONS(4916),
    [anon_sym_RPAREN] = ACTIONS(4914),
    [anon_sym_PIPE_AMP] = ACTIONS(4914),
    [anon_sym_AMP_AMP] = ACTIONS(4914),
    [anon_sym_PIPE_PIPE] = ACTIONS(4914),
    [anon_sym_LT] = ACTIONS(4916),
    [anon_sym_GT] = ACTIONS(4916),
    [anon_sym_GT_GT] = ACTIONS(4914),
    [anon_sym_AMP_GT] = ACTIONS(4916),
    [anon_sym_AMP_GT_GT] = ACTIONS(4914),
    [anon_sym_LT_AMP] = ACTIONS(4914),
    [anon_sym_GT_AMP] = ACTIONS(4914),
    [anon_sym_LT_LT] = ACTIONS(4916),
    [anon_sym_LT_LT_DASH] = ACTIONS(4914),
    [anon_sym_LT_LT_LT] = ACTIONS(4914),
    [anon_sym_BQUOTE] = ACTIONS(4914),
    [sym_comment] = ACTIONS(53),
  },
  [2938] = {
    [sym_file_descriptor] = ACTIONS(4918),
    [sym__concat] = ACTIONS(4918),
    [anon_sym_PIPE] = ACTIONS(4920),
    [anon_sym_RPAREN] = ACTIONS(4918),
    [anon_sym_PIPE_AMP] = ACTIONS(4918),
    [anon_sym_AMP_AMP] = ACTIONS(4918),
    [anon_sym_PIPE_PIPE] = ACTIONS(4918),
    [anon_sym_LT] = ACTIONS(4920),
    [anon_sym_GT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4918),
    [anon_sym_AMP_GT] = ACTIONS(4920),
    [anon_sym_AMP_GT_GT] = ACTIONS(4918),
    [anon_sym_LT_AMP] = ACTIONS(4918),
    [anon_sym_GT_AMP] = ACTIONS(4918),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_LT_LT_DASH] = ACTIONS(4918),
    [anon_sym_LT_LT_LT] = ACTIONS(4918),
    [anon_sym_BQUOTE] = ACTIONS(4918),
    [sym_comment] = ACTIONS(53),
  },
  [2939] = {
    [sym_file_descriptor] = ACTIONS(2752),
    [sym__concat] = ACTIONS(2752),
    [sym_variable_name] = ACTIONS(2752),
    [anon_sym_esac] = ACTIONS(2754),
    [anon_sym_PIPE] = ACTIONS(2754),
    [anon_sym_SEMI_SEMI] = ACTIONS(2754),
    [anon_sym_PIPE_AMP] = ACTIONS(2754),
    [anon_sym_AMP_AMP] = ACTIONS(2754),
    [anon_sym_PIPE_PIPE] = ACTIONS(2754),
    [anon_sym_LT] = ACTIONS(2754),
    [anon_sym_GT] = ACTIONS(2754),
    [anon_sym_GT_GT] = ACTIONS(2754),
    [anon_sym_AMP_GT] = ACTIONS(2754),
    [anon_sym_AMP_GT_GT] = ACTIONS(2754),
    [anon_sym_LT_AMP] = ACTIONS(2754),
    [anon_sym_GT_AMP] = ACTIONS(2754),
    [sym__special_characters] = ACTIONS(2754),
    [anon_sym_DQUOTE] = ACTIONS(2754),
    [anon_sym_DOLLAR] = ACTIONS(2754),
    [sym_raw_string] = ACTIONS(2754),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2754),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2754),
    [anon_sym_BQUOTE] = ACTIONS(2754),
    [anon_sym_LT_LPAREN] = ACTIONS(2754),
    [anon_sym_GT_LPAREN] = ACTIONS(2754),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2754),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_LF] = ACTIONS(2752),
    [anon_sym_AMP] = ACTIONS(2754),
  },
  [2940] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(7016),
    [sym_comment] = ACTIONS(53),
  },
  [2941] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(7018),
    [sym_comment] = ACTIONS(53),
  },
  [2942] = {
    [anon_sym_RBRACE] = ACTIONS(7018),
    [sym_comment] = ACTIONS(53),
  },
  [2943] = {
    [sym_concatenation] = STATE(3050),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3050),
    [anon_sym_RBRACE] = ACTIONS(7020),
    [anon_sym_EQ] = ACTIONS(7022),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7024),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7022),
    [anon_sym_COLON_QMARK] = ACTIONS(7022),
    [anon_sym_COLON_DASH] = ACTIONS(7022),
    [anon_sym_PERCENT] = ACTIONS(7022),
    [anon_sym_DASH] = ACTIONS(7022),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2944] = {
    [sym_file_descriptor] = ACTIONS(2830),
    [sym__concat] = ACTIONS(2830),
    [sym_variable_name] = ACTIONS(2830),
    [anon_sym_esac] = ACTIONS(2832),
    [anon_sym_PIPE] = ACTIONS(2832),
    [anon_sym_SEMI_SEMI] = ACTIONS(2832),
    [anon_sym_PIPE_AMP] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_PIPE_PIPE] = ACTIONS(2832),
    [anon_sym_LT] = ACTIONS(2832),
    [anon_sym_GT] = ACTIONS(2832),
    [anon_sym_GT_GT] = ACTIONS(2832),
    [anon_sym_AMP_GT] = ACTIONS(2832),
    [anon_sym_AMP_GT_GT] = ACTIONS(2832),
    [anon_sym_LT_AMP] = ACTIONS(2832),
    [anon_sym_GT_AMP] = ACTIONS(2832),
    [sym__special_characters] = ACTIONS(2832),
    [anon_sym_DQUOTE] = ACTIONS(2832),
    [anon_sym_DOLLAR] = ACTIONS(2832),
    [sym_raw_string] = ACTIONS(2832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2832),
    [anon_sym_BQUOTE] = ACTIONS(2832),
    [anon_sym_LT_LPAREN] = ACTIONS(2832),
    [anon_sym_GT_LPAREN] = ACTIONS(2832),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2832),
    [anon_sym_SEMI] = ACTIONS(2832),
    [anon_sym_LF] = ACTIONS(2830),
    [anon_sym_AMP] = ACTIONS(2832),
  },
  [2945] = {
    [sym_concatenation] = STATE(3053),
    [sym_string] = STATE(3052),
    [sym_simple_expansion] = STATE(3052),
    [sym_string_expansion] = STATE(3052),
    [sym_expansion] = STATE(3052),
    [sym_command_substitution] = STATE(3052),
    [sym_process_substitution] = STATE(3052),
    [anon_sym_RBRACE] = ACTIONS(7018),
    [sym__special_characters] = ACTIONS(7026),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(7028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(7028),
  },
  [2946] = {
    [sym_file_descriptor] = ACTIONS(2873),
    [sym__concat] = ACTIONS(2873),
    [sym_variable_name] = ACTIONS(2873),
    [anon_sym_esac] = ACTIONS(2875),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [anon_sym_PIPE_AMP] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT_GT] = ACTIONS(2875),
    [anon_sym_LT_AMP] = ACTIONS(2875),
    [anon_sym_GT_AMP] = ACTIONS(2875),
    [sym__special_characters] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_raw_string] = ACTIONS(2875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2875),
    [anon_sym_BQUOTE] = ACTIONS(2875),
    [anon_sym_LT_LPAREN] = ACTIONS(2875),
    [anon_sym_GT_LPAREN] = ACTIONS(2875),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [2947] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(7030),
  },
  [2948] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7032),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2949] = {
    [sym_file_descriptor] = ACTIONS(2881),
    [sym__concat] = ACTIONS(2881),
    [sym_variable_name] = ACTIONS(2881),
    [anon_sym_esac] = ACTIONS(2883),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_SEMI_SEMI] = ACTIONS(2883),
    [anon_sym_PIPE_AMP] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_GT_GT] = ACTIONS(2883),
    [anon_sym_AMP_GT] = ACTIONS(2883),
    [anon_sym_AMP_GT_GT] = ACTIONS(2883),
    [anon_sym_LT_AMP] = ACTIONS(2883),
    [anon_sym_GT_AMP] = ACTIONS(2883),
    [sym__special_characters] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [sym_raw_string] = ACTIONS(2883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2883),
    [anon_sym_BQUOTE] = ACTIONS(2883),
    [anon_sym_LT_LPAREN] = ACTIONS(2883),
    [anon_sym_GT_LPAREN] = ACTIONS(2883),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_LF] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
  },
  [2950] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(7034),
  },
  [2951] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7036),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2952] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(7038),
  },
  [2953] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7018),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2954] = {
    [sym_concatenation] = STATE(3060),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3060),
    [anon_sym_RBRACE] = ACTIONS(7040),
    [anon_sym_EQ] = ACTIONS(7042),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7042),
    [anon_sym_COLON_QMARK] = ACTIONS(7042),
    [anon_sym_COLON_DASH] = ACTIONS(7042),
    [anon_sym_PERCENT] = ACTIONS(7042),
    [anon_sym_DASH] = ACTIONS(7042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2955] = {
    [sym_file_descriptor] = ACTIONS(2897),
    [sym__concat] = ACTIONS(2897),
    [sym_variable_name] = ACTIONS(2897),
    [anon_sym_esac] = ACTIONS(2899),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_SEMI_SEMI] = ACTIONS(2899),
    [anon_sym_PIPE_AMP] = ACTIONS(2899),
    [anon_sym_AMP_AMP] = ACTIONS(2899),
    [anon_sym_PIPE_PIPE] = ACTIONS(2899),
    [anon_sym_LT] = ACTIONS(2899),
    [anon_sym_GT] = ACTIONS(2899),
    [anon_sym_GT_GT] = ACTIONS(2899),
    [anon_sym_AMP_GT] = ACTIONS(2899),
    [anon_sym_AMP_GT_GT] = ACTIONS(2899),
    [anon_sym_LT_AMP] = ACTIONS(2899),
    [anon_sym_GT_AMP] = ACTIONS(2899),
    [sym__special_characters] = ACTIONS(2899),
    [anon_sym_DQUOTE] = ACTIONS(2899),
    [anon_sym_DOLLAR] = ACTIONS(2899),
    [sym_raw_string] = ACTIONS(2899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2899),
    [anon_sym_BQUOTE] = ACTIONS(2899),
    [anon_sym_LT_LPAREN] = ACTIONS(2899),
    [anon_sym_GT_LPAREN] = ACTIONS(2899),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(2899),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LF] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2899),
  },
  [2956] = {
    [sym_concatenation] = STATE(3062),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3062),
    [anon_sym_RBRACE] = ACTIONS(7046),
    [anon_sym_EQ] = ACTIONS(7048),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7050),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7048),
    [anon_sym_COLON_QMARK] = ACTIONS(7048),
    [anon_sym_COLON_DASH] = ACTIONS(7048),
    [anon_sym_PERCENT] = ACTIONS(7048),
    [anon_sym_DASH] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2957] = {
    [aux_sym_concatenation_repeat1] = STATE(2960),
    [sym__concat] = ACTIONS(6826),
    [anon_sym_esac] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [2958] = {
    [aux_sym_concatenation_repeat1] = STATE(2960),
    [sym__concat] = ACTIONS(6826),
    [anon_sym_esac] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [2959] = {
    [sym_string] = STATE(3063),
    [sym_simple_expansion] = STATE(3063),
    [sym_string_expansion] = STATE(3063),
    [sym_expansion] = STATE(3063),
    [sym_command_substitution] = STATE(3063),
    [sym_process_substitution] = STATE(3063),
    [sym__special_characters] = ACTIONS(7052),
    [anon_sym_DQUOTE] = ACTIONS(6533),
    [anon_sym_DOLLAR] = ACTIONS(6535),
    [sym_raw_string] = ACTIONS(7052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6539),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6541),
    [anon_sym_BQUOTE] = ACTIONS(6543),
    [anon_sym_LT_LPAREN] = ACTIONS(6545),
    [anon_sym_GT_LPAREN] = ACTIONS(6545),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(7052),
  },
  [2960] = {
    [aux_sym_concatenation_repeat1] = STATE(3064),
    [sym__concat] = ACTIONS(6826),
    [anon_sym_esac] = ACTIONS(695),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [2961] = {
    [sym__concat] = ACTIONS(697),
    [anon_sym_esac] = ACTIONS(699),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_SEMI_SEMI] = ACTIONS(699),
    [anon_sym_PIPE_AMP] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_LF] = ACTIONS(697),
    [anon_sym_AMP] = ACTIONS(699),
  },
  [2962] = {
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [aux_sym_string_repeat1] = STATE(406),
    [anon_sym_DQUOTE] = ACTIONS(7054),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__string_content] = ACTIONS(231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_comment] = ACTIONS(177),
  },
  [2963] = {
    [sym__concat] = ACTIONS(727),
    [anon_sym_esac] = ACTIONS(729),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_SEMI_SEMI] = ACTIONS(729),
    [anon_sym_PIPE_AMP] = ACTIONS(729),
    [anon_sym_AMP_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(729),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(729),
    [anon_sym_LF] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(729),
  },
  [2964] = {
    [sym__concat] = ACTIONS(731),
    [anon_sym_esac] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [2965] = {
    [sym__concat] = ACTIONS(735),
    [anon_sym_esac] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI_SEMI] = ACTIONS(737),
    [anon_sym_PIPE_AMP] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(737),
  },
  [2966] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(7056),
    [sym_comment] = ACTIONS(53),
  },
  [2967] = {
    [sym_concatenation] = STATE(3069),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3069),
    [anon_sym_RBRACE] = ACTIONS(7058),
    [anon_sym_EQ] = ACTIONS(7060),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(7064),
    [anon_sym_COLON] = ACTIONS(7060),
    [anon_sym_COLON_QMARK] = ACTIONS(7060),
    [anon_sym_COLON_DASH] = ACTIONS(7060),
    [anon_sym_PERCENT] = ACTIONS(7060),
    [anon_sym_DASH] = ACTIONS(7060),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2968] = {
    [sym_subscript] = STATE(3073),
    [sym_variable_name] = ACTIONS(7066),
    [anon_sym_DOLLAR] = ACTIONS(7068),
    [anon_sym_DASH] = ACTIONS(7068),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7070),
    [anon_sym_STAR] = ACTIONS(7068),
    [anon_sym_AT] = ACTIONS(7068),
    [anon_sym_QMARK] = ACTIONS(7068),
    [anon_sym_0] = ACTIONS(7072),
    [anon_sym__] = ACTIONS(7072),
  },
  [2969] = {
    [sym_concatenation] = STATE(3076),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3076),
    [anon_sym_RBRACE] = ACTIONS(7074),
    [anon_sym_EQ] = ACTIONS(7076),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7078),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(7080),
    [anon_sym_COLON] = ACTIONS(7076),
    [anon_sym_COLON_QMARK] = ACTIONS(7076),
    [anon_sym_COLON_DASH] = ACTIONS(7076),
    [anon_sym_PERCENT] = ACTIONS(7076),
    [anon_sym_DASH] = ACTIONS(7076),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2970] = {
    [sym_concatenation] = STATE(3079),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3079),
    [anon_sym_RBRACE] = ACTIONS(7082),
    [anon_sym_EQ] = ACTIONS(7084),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7086),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(7088),
    [anon_sym_COLON] = ACTIONS(7084),
    [anon_sym_COLON_QMARK] = ACTIONS(7084),
    [anon_sym_COLON_DASH] = ACTIONS(7084),
    [anon_sym_PERCENT] = ACTIONS(7084),
    [anon_sym_DASH] = ACTIONS(7084),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2971] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(7090),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [2972] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(7090),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2973] = {
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_BQUOTE] = ACTIONS(7090),
    [sym_comment] = ACTIONS(53),
  },
  [2974] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(7090),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2975] = {
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(7092),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [sym_comment] = ACTIONS(53),
  },
  [2976] = {
    [sym_file_descriptor] = ACTIONS(369),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(7092),
    [anon_sym_PIPE_AMP] = ACTIONS(873),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_AMP_GT_GT] = ACTIONS(369),
    [anon_sym_LT_AMP] = ACTIONS(369),
    [anon_sym_GT_AMP] = ACTIONS(369),
    [sym__special_characters] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(369),
  },
  [2977] = {
    [aux_sym_concatenation_repeat1] = STATE(2979),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(3687),
    [anon_sym_esac] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_AMP] = ACTIONS(1091),
    [anon_sym_GT_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1091),
    [anon_sym_LT_LT_LT] = ACTIONS(1091),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [2978] = {
    [aux_sym_concatenation_repeat1] = STATE(2979),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(3687),
    [anon_sym_esac] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(1095),
    [anon_sym_PIPE_AMP] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT] = ACTIONS(1095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_AMP] = ACTIONS(1095),
    [anon_sym_GT_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1095),
    [anon_sym_LT_LT_LT] = ACTIONS(1095),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
  },
  [2979] = {
    [aux_sym_concatenation_repeat1] = STATE(3082),
    [sym_file_descriptor] = ACTIONS(693),
    [sym__concat] = ACTIONS(3687),
    [anon_sym_esac] = ACTIONS(695),
    [anon_sym_PIPE] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(695),
    [anon_sym_AMP_GT] = ACTIONS(695),
    [anon_sym_AMP_GT_GT] = ACTIONS(695),
    [anon_sym_LT_AMP] = ACTIONS(695),
    [anon_sym_GT_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(695),
    [anon_sym_LT_LT_DASH] = ACTIONS(695),
    [anon_sym_LT_LT_LT] = ACTIONS(695),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_LF] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(695),
  },
  [2980] = {
    [sym_variable_name] = ACTIONS(3379),
    [anon_sym_esac] = ACTIONS(3381),
    [anon_sym_PIPE] = ACTIONS(3381),
    [anon_sym_SEMI_SEMI] = ACTIONS(3381),
    [anon_sym_PIPE_AMP] = ACTIONS(3381),
    [anon_sym_AMP_AMP] = ACTIONS(3381),
    [anon_sym_PIPE_PIPE] = ACTIONS(3381),
    [sym__special_characters] = ACTIONS(3381),
    [anon_sym_DQUOTE] = ACTIONS(3381),
    [anon_sym_DOLLAR] = ACTIONS(3381),
    [sym_raw_string] = ACTIONS(3381),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3381),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3381),
    [anon_sym_BQUOTE] = ACTIONS(3381),
    [anon_sym_LT_LPAREN] = ACTIONS(3381),
    [anon_sym_GT_LPAREN] = ACTIONS(3381),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3381),
    [sym_word] = ACTIONS(3381),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym_LF] = ACTIONS(3379),
    [anon_sym_AMP] = ACTIONS(3381),
  },
  [2981] = {
    [sym__concat] = ACTIONS(3917),
    [sym_variable_name] = ACTIONS(3917),
    [anon_sym_esac] = ACTIONS(3919),
    [anon_sym_PIPE] = ACTIONS(3919),
    [anon_sym_SEMI_SEMI] = ACTIONS(3919),
    [anon_sym_PIPE_AMP] = ACTIONS(3919),
    [anon_sym_AMP_AMP] = ACTIONS(3919),
    [anon_sym_PIPE_PIPE] = ACTIONS(3919),
    [sym__special_characters] = ACTIONS(3919),
    [anon_sym_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3919),
    [sym_raw_string] = ACTIONS(3919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3919),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3919),
    [anon_sym_BQUOTE] = ACTIONS(3919),
    [anon_sym_LT_LPAREN] = ACTIONS(3919),
    [anon_sym_GT_LPAREN] = ACTIONS(3919),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3919),
    [sym_word] = ACTIONS(3919),
    [anon_sym_SEMI] = ACTIONS(3919),
    [anon_sym_LF] = ACTIONS(3917),
    [anon_sym_AMP] = ACTIONS(3919),
  },
  [2982] = {
    [sym__concat] = ACTIONS(3923),
    [sym_variable_name] = ACTIONS(3923),
    [anon_sym_esac] = ACTIONS(3925),
    [anon_sym_PIPE] = ACTIONS(3925),
    [anon_sym_SEMI_SEMI] = ACTIONS(3925),
    [anon_sym_PIPE_AMP] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [sym__special_characters] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [sym_raw_string] = ACTIONS(3925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3925),
    [anon_sym_BQUOTE] = ACTIONS(3925),
    [anon_sym_LT_LPAREN] = ACTIONS(3925),
    [anon_sym_GT_LPAREN] = ACTIONS(3925),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3925),
    [sym_word] = ACTIONS(3925),
    [anon_sym_SEMI] = ACTIONS(3925),
    [anon_sym_LF] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3925),
  },
  [2983] = {
    [sym__concat] = ACTIONS(4008),
    [sym_variable_name] = ACTIONS(4008),
    [anon_sym_esac] = ACTIONS(4010),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_SEMI_SEMI] = ACTIONS(4010),
    [anon_sym_PIPE_AMP] = ACTIONS(4010),
    [anon_sym_AMP_AMP] = ACTIONS(4010),
    [anon_sym_PIPE_PIPE] = ACTIONS(4010),
    [sym__special_characters] = ACTIONS(4010),
    [anon_sym_DQUOTE] = ACTIONS(4010),
    [anon_sym_DOLLAR] = ACTIONS(4010),
    [sym_raw_string] = ACTIONS(4010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4010),
    [anon_sym_BQUOTE] = ACTIONS(4010),
    [anon_sym_LT_LPAREN] = ACTIONS(4010),
    [anon_sym_GT_LPAREN] = ACTIONS(4010),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4010),
    [sym_word] = ACTIONS(4010),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LF] = ACTIONS(4008),
    [anon_sym_AMP] = ACTIONS(4010),
  },
  [2984] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7094),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2985] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(7096),
    [sym_comment] = ACTIONS(53),
  },
  [2986] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(7098),
    [sym_comment] = ACTIONS(53),
  },
  [2987] = {
    [anon_sym_RBRACE] = ACTIONS(7098),
    [sym_comment] = ACTIONS(53),
  },
  [2988] = {
    [sym_concatenation] = STATE(3087),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3087),
    [anon_sym_RBRACE] = ACTIONS(7100),
    [anon_sym_EQ] = ACTIONS(7102),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7104),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7102),
    [anon_sym_COLON_QMARK] = ACTIONS(7102),
    [anon_sym_COLON_DASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [anon_sym_DASH] = ACTIONS(7102),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2989] = {
    [sym__concat] = ACTIONS(4024),
    [sym_variable_name] = ACTIONS(4024),
    [anon_sym_esac] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_SEMI_SEMI] = ACTIONS(4026),
    [anon_sym_PIPE_AMP] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4026),
    [anon_sym_PIPE_PIPE] = ACTIONS(4026),
    [sym__special_characters] = ACTIONS(4026),
    [anon_sym_DQUOTE] = ACTIONS(4026),
    [anon_sym_DOLLAR] = ACTIONS(4026),
    [sym_raw_string] = ACTIONS(4026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4026),
    [anon_sym_BQUOTE] = ACTIONS(4026),
    [anon_sym_LT_LPAREN] = ACTIONS(4026),
    [anon_sym_GT_LPAREN] = ACTIONS(4026),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4026),
    [sym_word] = ACTIONS(4026),
    [anon_sym_SEMI] = ACTIONS(4026),
    [anon_sym_LF] = ACTIONS(4024),
    [anon_sym_AMP] = ACTIONS(4026),
  },
  [2990] = {
    [sym_concatenation] = STATE(3089),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3089),
    [anon_sym_RBRACE] = ACTIONS(7106),
    [anon_sym_EQ] = ACTIONS(7108),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7110),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7108),
    [anon_sym_COLON_QMARK] = ACTIONS(7108),
    [anon_sym_COLON_DASH] = ACTIONS(7108),
    [anon_sym_PERCENT] = ACTIONS(7108),
    [anon_sym_DASH] = ACTIONS(7108),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2991] = {
    [sym__concat] = ACTIONS(4034),
    [sym_variable_name] = ACTIONS(4034),
    [anon_sym_esac] = ACTIONS(4036),
    [anon_sym_PIPE] = ACTIONS(4036),
    [anon_sym_SEMI_SEMI] = ACTIONS(4036),
    [anon_sym_PIPE_AMP] = ACTIONS(4036),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [sym__special_characters] = ACTIONS(4036),
    [anon_sym_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR] = ACTIONS(4036),
    [sym_raw_string] = ACTIONS(4036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4036),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4036),
    [anon_sym_GT_LPAREN] = ACTIONS(4036),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4036),
    [sym_word] = ACTIONS(4036),
    [anon_sym_SEMI] = ACTIONS(4036),
    [anon_sym_LF] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
  },
  [2992] = {
    [sym_concatenation] = STATE(3091),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3091),
    [anon_sym_RBRACE] = ACTIONS(7112),
    [anon_sym_EQ] = ACTIONS(7114),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7116),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7114),
    [anon_sym_COLON_QMARK] = ACTIONS(7114),
    [anon_sym_COLON_DASH] = ACTIONS(7114),
    [anon_sym_PERCENT] = ACTIONS(7114),
    [anon_sym_DASH] = ACTIONS(7114),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2993] = {
    [sym__concat] = ACTIONS(4044),
    [sym_variable_name] = ACTIONS(4044),
    [anon_sym_esac] = ACTIONS(4046),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_SEMI_SEMI] = ACTIONS(4046),
    [anon_sym_PIPE_AMP] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4046),
    [anon_sym_PIPE_PIPE] = ACTIONS(4046),
    [sym__special_characters] = ACTIONS(4046),
    [anon_sym_DQUOTE] = ACTIONS(4046),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [sym_raw_string] = ACTIONS(4046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4046),
    [anon_sym_BQUOTE] = ACTIONS(4046),
    [anon_sym_LT_LPAREN] = ACTIONS(4046),
    [anon_sym_GT_LPAREN] = ACTIONS(4046),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4046),
    [sym_word] = ACTIONS(4046),
    [anon_sym_SEMI] = ACTIONS(4046),
    [anon_sym_LF] = ACTIONS(4044),
    [anon_sym_AMP] = ACTIONS(4046),
  },
  [2994] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7118),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2995] = {
    [sym__concat] = ACTIONS(4050),
    [sym_variable_name] = ACTIONS(4050),
    [anon_sym_esac] = ACTIONS(4052),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_SEMI_SEMI] = ACTIONS(4052),
    [anon_sym_PIPE_AMP] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4052),
    [anon_sym_PIPE_PIPE] = ACTIONS(4052),
    [sym__special_characters] = ACTIONS(4052),
    [anon_sym_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [sym_raw_string] = ACTIONS(4052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4052),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4052),
    [anon_sym_BQUOTE] = ACTIONS(4052),
    [anon_sym_LT_LPAREN] = ACTIONS(4052),
    [anon_sym_GT_LPAREN] = ACTIONS(4052),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4052),
    [sym_word] = ACTIONS(4052),
    [anon_sym_SEMI] = ACTIONS(4052),
    [anon_sym_LF] = ACTIONS(4050),
    [anon_sym_AMP] = ACTIONS(4052),
  },
  [2996] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7120),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [2997] = {
    [sym__concat] = ACTIONS(3917),
    [anon_sym_esac] = ACTIONS(3919),
    [anon_sym_PIPE] = ACTIONS(3919),
    [anon_sym_SEMI_SEMI] = ACTIONS(3919),
    [anon_sym_PIPE_AMP] = ACTIONS(3919),
    [anon_sym_AMP_AMP] = ACTIONS(3919),
    [anon_sym_PIPE_PIPE] = ACTIONS(3919),
    [sym__special_characters] = ACTIONS(3919),
    [anon_sym_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3919),
    [sym_raw_string] = ACTIONS(3919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3919),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3919),
    [anon_sym_BQUOTE] = ACTIONS(3919),
    [anon_sym_LT_LPAREN] = ACTIONS(3919),
    [anon_sym_GT_LPAREN] = ACTIONS(3919),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3919),
    [sym_word] = ACTIONS(3919),
    [anon_sym_SEMI] = ACTIONS(3919),
    [anon_sym_LF] = ACTIONS(3917),
    [anon_sym_AMP] = ACTIONS(3919),
  },
  [2998] = {
    [sym__concat] = ACTIONS(3923),
    [anon_sym_esac] = ACTIONS(3925),
    [anon_sym_PIPE] = ACTIONS(3925),
    [anon_sym_SEMI_SEMI] = ACTIONS(3925),
    [anon_sym_PIPE_AMP] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [sym__special_characters] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [sym_raw_string] = ACTIONS(3925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3925),
    [anon_sym_BQUOTE] = ACTIONS(3925),
    [anon_sym_LT_LPAREN] = ACTIONS(3925),
    [anon_sym_GT_LPAREN] = ACTIONS(3925),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3925),
    [sym_word] = ACTIONS(3925),
    [anon_sym_SEMI] = ACTIONS(3925),
    [anon_sym_LF] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3925),
  },
  [2999] = {
    [sym__concat] = ACTIONS(4008),
    [anon_sym_esac] = ACTIONS(4010),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_SEMI_SEMI] = ACTIONS(4010),
    [anon_sym_PIPE_AMP] = ACTIONS(4010),
    [anon_sym_AMP_AMP] = ACTIONS(4010),
    [anon_sym_PIPE_PIPE] = ACTIONS(4010),
    [sym__special_characters] = ACTIONS(4010),
    [anon_sym_DQUOTE] = ACTIONS(4010),
    [anon_sym_DOLLAR] = ACTIONS(4010),
    [sym_raw_string] = ACTIONS(4010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4010),
    [anon_sym_BQUOTE] = ACTIONS(4010),
    [anon_sym_LT_LPAREN] = ACTIONS(4010),
    [anon_sym_GT_LPAREN] = ACTIONS(4010),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4010),
    [sym_word] = ACTIONS(4010),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LF] = ACTIONS(4008),
    [anon_sym_AMP] = ACTIONS(4010),
  },
  [3000] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7122),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3001] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(7124),
    [sym_comment] = ACTIONS(53),
  },
  [3002] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(7126),
    [sym_comment] = ACTIONS(53),
  },
  [3003] = {
    [anon_sym_RBRACE] = ACTIONS(7126),
    [sym_comment] = ACTIONS(53),
  },
  [3004] = {
    [sym_concatenation] = STATE(3098),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3098),
    [anon_sym_RBRACE] = ACTIONS(7128),
    [anon_sym_EQ] = ACTIONS(7130),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7132),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7130),
    [anon_sym_COLON_QMARK] = ACTIONS(7130),
    [anon_sym_COLON_DASH] = ACTIONS(7130),
    [anon_sym_PERCENT] = ACTIONS(7130),
    [anon_sym_DASH] = ACTIONS(7130),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3005] = {
    [sym__concat] = ACTIONS(4024),
    [anon_sym_esac] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_SEMI_SEMI] = ACTIONS(4026),
    [anon_sym_PIPE_AMP] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4026),
    [anon_sym_PIPE_PIPE] = ACTIONS(4026),
    [sym__special_characters] = ACTIONS(4026),
    [anon_sym_DQUOTE] = ACTIONS(4026),
    [anon_sym_DOLLAR] = ACTIONS(4026),
    [sym_raw_string] = ACTIONS(4026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4026),
    [anon_sym_BQUOTE] = ACTIONS(4026),
    [anon_sym_LT_LPAREN] = ACTIONS(4026),
    [anon_sym_GT_LPAREN] = ACTIONS(4026),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4026),
    [sym_word] = ACTIONS(4026),
    [anon_sym_SEMI] = ACTIONS(4026),
    [anon_sym_LF] = ACTIONS(4024),
    [anon_sym_AMP] = ACTIONS(4026),
  },
  [3006] = {
    [sym_concatenation] = STATE(3100),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3100),
    [anon_sym_RBRACE] = ACTIONS(7134),
    [anon_sym_EQ] = ACTIONS(7136),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7138),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7136),
    [anon_sym_COLON_QMARK] = ACTIONS(7136),
    [anon_sym_COLON_DASH] = ACTIONS(7136),
    [anon_sym_PERCENT] = ACTIONS(7136),
    [anon_sym_DASH] = ACTIONS(7136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3007] = {
    [sym__concat] = ACTIONS(4034),
    [anon_sym_esac] = ACTIONS(4036),
    [anon_sym_PIPE] = ACTIONS(4036),
    [anon_sym_SEMI_SEMI] = ACTIONS(4036),
    [anon_sym_PIPE_AMP] = ACTIONS(4036),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [sym__special_characters] = ACTIONS(4036),
    [anon_sym_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR] = ACTIONS(4036),
    [sym_raw_string] = ACTIONS(4036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4036),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4036),
    [anon_sym_GT_LPAREN] = ACTIONS(4036),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4036),
    [sym_word] = ACTIONS(4036),
    [anon_sym_SEMI] = ACTIONS(4036),
    [anon_sym_LF] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
  },
  [3008] = {
    [sym_concatenation] = STATE(3102),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3102),
    [anon_sym_RBRACE] = ACTIONS(7140),
    [anon_sym_EQ] = ACTIONS(7142),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7142),
    [anon_sym_COLON_QMARK] = ACTIONS(7142),
    [anon_sym_COLON_DASH] = ACTIONS(7142),
    [anon_sym_PERCENT] = ACTIONS(7142),
    [anon_sym_DASH] = ACTIONS(7142),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3009] = {
    [sym__concat] = ACTIONS(4044),
    [anon_sym_esac] = ACTIONS(4046),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_SEMI_SEMI] = ACTIONS(4046),
    [anon_sym_PIPE_AMP] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4046),
    [anon_sym_PIPE_PIPE] = ACTIONS(4046),
    [sym__special_characters] = ACTIONS(4046),
    [anon_sym_DQUOTE] = ACTIONS(4046),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [sym_raw_string] = ACTIONS(4046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4046),
    [anon_sym_BQUOTE] = ACTIONS(4046),
    [anon_sym_LT_LPAREN] = ACTIONS(4046),
    [anon_sym_GT_LPAREN] = ACTIONS(4046),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4046),
    [sym_word] = ACTIONS(4046),
    [anon_sym_SEMI] = ACTIONS(4046),
    [anon_sym_LF] = ACTIONS(4044),
    [anon_sym_AMP] = ACTIONS(4046),
  },
  [3010] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7146),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3011] = {
    [sym__concat] = ACTIONS(4050),
    [anon_sym_esac] = ACTIONS(4052),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_SEMI_SEMI] = ACTIONS(4052),
    [anon_sym_PIPE_AMP] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4052),
    [anon_sym_PIPE_PIPE] = ACTIONS(4052),
    [sym__special_characters] = ACTIONS(4052),
    [anon_sym_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [sym_raw_string] = ACTIONS(4052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4052),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4052),
    [anon_sym_BQUOTE] = ACTIONS(4052),
    [anon_sym_LT_LPAREN] = ACTIONS(4052),
    [anon_sym_GT_LPAREN] = ACTIONS(4052),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4052),
    [sym_word] = ACTIONS(4052),
    [anon_sym_SEMI] = ACTIONS(4052),
    [anon_sym_LF] = ACTIONS(4050),
    [anon_sym_AMP] = ACTIONS(4052),
  },
  [3012] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7148),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3013] = {
    [sym__simple_heredoc_body] = ACTIONS(4884),
    [sym__heredoc_body_beginning] = ACTIONS(4884),
    [sym_file_descriptor] = ACTIONS(4884),
    [sym__concat] = ACTIONS(4884),
    [anon_sym_esac] = ACTIONS(4886),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [anon_sym_PIPE_AMP] = ACTIONS(4886),
    [anon_sym_AMP_AMP] = ACTIONS(4886),
    [anon_sym_PIPE_PIPE] = ACTIONS(4886),
    [anon_sym_EQ_TILDE] = ACTIONS(4886),
    [anon_sym_EQ_EQ] = ACTIONS(4886),
    [anon_sym_LT] = ACTIONS(4886),
    [anon_sym_GT] = ACTIONS(4886),
    [anon_sym_GT_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT_GT] = ACTIONS(4886),
    [anon_sym_LT_AMP] = ACTIONS(4886),
    [anon_sym_GT_AMP] = ACTIONS(4886),
    [anon_sym_LT_LT] = ACTIONS(4886),
    [anon_sym_LT_LT_DASH] = ACTIONS(4886),
    [anon_sym_LT_LT_LT] = ACTIONS(4886),
    [sym__special_characters] = ACTIONS(4886),
    [anon_sym_DQUOTE] = ACTIONS(4886),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4886),
    [anon_sym_BQUOTE] = ACTIONS(4886),
    [anon_sym_LT_LPAREN] = ACTIONS(4886),
    [anon_sym_GT_LPAREN] = ACTIONS(4886),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4886),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [3014] = {
    [sym__simple_heredoc_body] = ACTIONS(4888),
    [sym__heredoc_body_beginning] = ACTIONS(4888),
    [sym_file_descriptor] = ACTIONS(4888),
    [sym__concat] = ACTIONS(4888),
    [anon_sym_esac] = ACTIONS(4890),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [anon_sym_PIPE_AMP] = ACTIONS(4890),
    [anon_sym_AMP_AMP] = ACTIONS(4890),
    [anon_sym_PIPE_PIPE] = ACTIONS(4890),
    [anon_sym_EQ_TILDE] = ACTIONS(4890),
    [anon_sym_EQ_EQ] = ACTIONS(4890),
    [anon_sym_LT] = ACTIONS(4890),
    [anon_sym_GT] = ACTIONS(4890),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT_GT] = ACTIONS(4890),
    [anon_sym_LT_AMP] = ACTIONS(4890),
    [anon_sym_GT_AMP] = ACTIONS(4890),
    [anon_sym_LT_LT] = ACTIONS(4890),
    [anon_sym_LT_LT_DASH] = ACTIONS(4890),
    [anon_sym_LT_LT_LT] = ACTIONS(4890),
    [sym__special_characters] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4890),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4890),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_LT_LPAREN] = ACTIONS(4890),
    [anon_sym_GT_LPAREN] = ACTIONS(4890),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4890),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [3015] = {
    [sym__simple_heredoc_body] = ACTIONS(4892),
    [sym__heredoc_body_beginning] = ACTIONS(4892),
    [sym_file_descriptor] = ACTIONS(4892),
    [sym__concat] = ACTIONS(4892),
    [anon_sym_esac] = ACTIONS(4894),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_SEMI_SEMI] = ACTIONS(4894),
    [anon_sym_PIPE_AMP] = ACTIONS(4894),
    [anon_sym_AMP_AMP] = ACTIONS(4894),
    [anon_sym_PIPE_PIPE] = ACTIONS(4894),
    [anon_sym_EQ_TILDE] = ACTIONS(4894),
    [anon_sym_EQ_EQ] = ACTIONS(4894),
    [anon_sym_LT] = ACTIONS(4894),
    [anon_sym_GT] = ACTIONS(4894),
    [anon_sym_GT_GT] = ACTIONS(4894),
    [anon_sym_AMP_GT] = ACTIONS(4894),
    [anon_sym_AMP_GT_GT] = ACTIONS(4894),
    [anon_sym_LT_AMP] = ACTIONS(4894),
    [anon_sym_GT_AMP] = ACTIONS(4894),
    [anon_sym_LT_LT] = ACTIONS(4894),
    [anon_sym_LT_LT_DASH] = ACTIONS(4894),
    [anon_sym_LT_LT_LT] = ACTIONS(4894),
    [sym__special_characters] = ACTIONS(4894),
    [anon_sym_DQUOTE] = ACTIONS(4894),
    [anon_sym_DOLLAR] = ACTIONS(4894),
    [sym_raw_string] = ACTIONS(4894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4894),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4894),
    [anon_sym_GT_LPAREN] = ACTIONS(4894),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(4894),
    [anon_sym_LF] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4894),
  },
  [3016] = {
    [sym__simple_heredoc_body] = ACTIONS(4896),
    [sym__heredoc_body_beginning] = ACTIONS(4896),
    [sym_file_descriptor] = ACTIONS(4896),
    [sym__concat] = ACTIONS(4896),
    [anon_sym_esac] = ACTIONS(4898),
    [anon_sym_PIPE] = ACTIONS(4898),
    [anon_sym_SEMI_SEMI] = ACTIONS(4898),
    [anon_sym_PIPE_AMP] = ACTIONS(4898),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_EQ_TILDE] = ACTIONS(4898),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4898),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_GT_GT] = ACTIONS(4898),
    [anon_sym_AMP_GT] = ACTIONS(4898),
    [anon_sym_AMP_GT_GT] = ACTIONS(4898),
    [anon_sym_LT_AMP] = ACTIONS(4898),
    [anon_sym_GT_AMP] = ACTIONS(4898),
    [anon_sym_LT_LT] = ACTIONS(4898),
    [anon_sym_LT_LT_DASH] = ACTIONS(4898),
    [anon_sym_LT_LT_LT] = ACTIONS(4898),
    [sym__special_characters] = ACTIONS(4898),
    [anon_sym_DQUOTE] = ACTIONS(4898),
    [anon_sym_DOLLAR] = ACTIONS(4898),
    [sym_raw_string] = ACTIONS(4898),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4898),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4898),
    [anon_sym_BQUOTE] = ACTIONS(4898),
    [anon_sym_LT_LPAREN] = ACTIONS(4898),
    [anon_sym_GT_LPAREN] = ACTIONS(4898),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4898),
    [anon_sym_SEMI] = ACTIONS(4898),
    [anon_sym_LF] = ACTIONS(4896),
    [anon_sym_AMP] = ACTIONS(4898),
  },
  [3017] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7150),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3018] = {
    [sym__simple_heredoc_body] = ACTIONS(4902),
    [sym__heredoc_body_beginning] = ACTIONS(4902),
    [sym_file_descriptor] = ACTIONS(4902),
    [sym__concat] = ACTIONS(4902),
    [anon_sym_esac] = ACTIONS(4904),
    [anon_sym_PIPE] = ACTIONS(4904),
    [anon_sym_SEMI_SEMI] = ACTIONS(4904),
    [anon_sym_PIPE_AMP] = ACTIONS(4904),
    [anon_sym_AMP_AMP] = ACTIONS(4904),
    [anon_sym_PIPE_PIPE] = ACTIONS(4904),
    [anon_sym_EQ_TILDE] = ACTIONS(4904),
    [anon_sym_EQ_EQ] = ACTIONS(4904),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_GT] = ACTIONS(4904),
    [anon_sym_GT_GT] = ACTIONS(4904),
    [anon_sym_AMP_GT] = ACTIONS(4904),
    [anon_sym_AMP_GT_GT] = ACTIONS(4904),
    [anon_sym_LT_AMP] = ACTIONS(4904),
    [anon_sym_GT_AMP] = ACTIONS(4904),
    [anon_sym_LT_LT] = ACTIONS(4904),
    [anon_sym_LT_LT_DASH] = ACTIONS(4904),
    [anon_sym_LT_LT_LT] = ACTIONS(4904),
    [sym__special_characters] = ACTIONS(4904),
    [anon_sym_DQUOTE] = ACTIONS(4904),
    [anon_sym_DOLLAR] = ACTIONS(4904),
    [sym_raw_string] = ACTIONS(4904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4904),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4904),
    [anon_sym_BQUOTE] = ACTIONS(4904),
    [anon_sym_LT_LPAREN] = ACTIONS(4904),
    [anon_sym_GT_LPAREN] = ACTIONS(4904),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4904),
    [anon_sym_SEMI] = ACTIONS(4904),
    [anon_sym_LF] = ACTIONS(4902),
    [anon_sym_AMP] = ACTIONS(4904),
  },
  [3019] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7152),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3020] = {
    [sym__simple_heredoc_body] = ACTIONS(4908),
    [sym__heredoc_body_beginning] = ACTIONS(4908),
    [sym_file_descriptor] = ACTIONS(4908),
    [sym__concat] = ACTIONS(4908),
    [anon_sym_esac] = ACTIONS(4910),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_SEMI_SEMI] = ACTIONS(4910),
    [anon_sym_PIPE_AMP] = ACTIONS(4910),
    [anon_sym_AMP_AMP] = ACTIONS(4910),
    [anon_sym_PIPE_PIPE] = ACTIONS(4910),
    [anon_sym_EQ_TILDE] = ACTIONS(4910),
    [anon_sym_EQ_EQ] = ACTIONS(4910),
    [anon_sym_LT] = ACTIONS(4910),
    [anon_sym_GT] = ACTIONS(4910),
    [anon_sym_GT_GT] = ACTIONS(4910),
    [anon_sym_AMP_GT] = ACTIONS(4910),
    [anon_sym_AMP_GT_GT] = ACTIONS(4910),
    [anon_sym_LT_AMP] = ACTIONS(4910),
    [anon_sym_GT_AMP] = ACTIONS(4910),
    [anon_sym_LT_LT] = ACTIONS(4910),
    [anon_sym_LT_LT_DASH] = ACTIONS(4910),
    [anon_sym_LT_LT_LT] = ACTIONS(4910),
    [sym__special_characters] = ACTIONS(4910),
    [anon_sym_DQUOTE] = ACTIONS(4910),
    [anon_sym_DOLLAR] = ACTIONS(4910),
    [sym_raw_string] = ACTIONS(4910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4910),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4910),
    [anon_sym_BQUOTE] = ACTIONS(4910),
    [anon_sym_LT_LPAREN] = ACTIONS(4910),
    [anon_sym_GT_LPAREN] = ACTIONS(4910),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4910),
    [anon_sym_SEMI] = ACTIONS(4910),
    [anon_sym_LF] = ACTIONS(4908),
    [anon_sym_AMP] = ACTIONS(4910),
  },
  [3021] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7154),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3022] = {
    [sym__simple_heredoc_body] = ACTIONS(4914),
    [sym__heredoc_body_beginning] = ACTIONS(4914),
    [sym_file_descriptor] = ACTIONS(4914),
    [sym__concat] = ACTIONS(4914),
    [anon_sym_esac] = ACTIONS(4916),
    [anon_sym_PIPE] = ACTIONS(4916),
    [anon_sym_SEMI_SEMI] = ACTIONS(4916),
    [anon_sym_PIPE_AMP] = ACTIONS(4916),
    [anon_sym_AMP_AMP] = ACTIONS(4916),
    [anon_sym_PIPE_PIPE] = ACTIONS(4916),
    [anon_sym_EQ_TILDE] = ACTIONS(4916),
    [anon_sym_EQ_EQ] = ACTIONS(4916),
    [anon_sym_LT] = ACTIONS(4916),
    [anon_sym_GT] = ACTIONS(4916),
    [anon_sym_GT_GT] = ACTIONS(4916),
    [anon_sym_AMP_GT] = ACTIONS(4916),
    [anon_sym_AMP_GT_GT] = ACTIONS(4916),
    [anon_sym_LT_AMP] = ACTIONS(4916),
    [anon_sym_GT_AMP] = ACTIONS(4916),
    [anon_sym_LT_LT] = ACTIONS(4916),
    [anon_sym_LT_LT_DASH] = ACTIONS(4916),
    [anon_sym_LT_LT_LT] = ACTIONS(4916),
    [sym__special_characters] = ACTIONS(4916),
    [anon_sym_DQUOTE] = ACTIONS(4916),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(4916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4916),
    [anon_sym_BQUOTE] = ACTIONS(4916),
    [anon_sym_LT_LPAREN] = ACTIONS(4916),
    [anon_sym_GT_LPAREN] = ACTIONS(4916),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4916),
    [anon_sym_SEMI] = ACTIONS(4916),
    [anon_sym_LF] = ACTIONS(4914),
    [anon_sym_AMP] = ACTIONS(4916),
  },
  [3023] = {
    [sym__simple_heredoc_body] = ACTIONS(4918),
    [sym__heredoc_body_beginning] = ACTIONS(4918),
    [sym_file_descriptor] = ACTIONS(4918),
    [sym__concat] = ACTIONS(4918),
    [anon_sym_esac] = ACTIONS(4920),
    [anon_sym_PIPE] = ACTIONS(4920),
    [anon_sym_SEMI_SEMI] = ACTIONS(4920),
    [anon_sym_PIPE_AMP] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [anon_sym_EQ_TILDE] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(4920),
    [anon_sym_LT] = ACTIONS(4920),
    [anon_sym_GT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_AMP_GT] = ACTIONS(4920),
    [anon_sym_AMP_GT_GT] = ACTIONS(4920),
    [anon_sym_LT_AMP] = ACTIONS(4920),
    [anon_sym_GT_AMP] = ACTIONS(4920),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_LT_LT_DASH] = ACTIONS(4920),
    [anon_sym_LT_LT_LT] = ACTIONS(4920),
    [sym__special_characters] = ACTIONS(4920),
    [anon_sym_DQUOTE] = ACTIONS(4920),
    [anon_sym_DOLLAR] = ACTIONS(4920),
    [sym_raw_string] = ACTIONS(4920),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4920),
    [anon_sym_BQUOTE] = ACTIONS(4920),
    [anon_sym_LT_LPAREN] = ACTIONS(4920),
    [anon_sym_GT_LPAREN] = ACTIONS(4920),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4920),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym_LF] = ACTIONS(4918),
    [anon_sym_AMP] = ACTIONS(4920),
  },
  [3024] = {
    [sym__simple_heredoc_body] = ACTIONS(2752),
    [sym__heredoc_body_beginning] = ACTIONS(2752),
    [sym_file_descriptor] = ACTIONS(2752),
    [sym__concat] = ACTIONS(2752),
    [anon_sym_esac] = ACTIONS(2754),
    [anon_sym_PIPE] = ACTIONS(2754),
    [anon_sym_SEMI_SEMI] = ACTIONS(2754),
    [anon_sym_PIPE_AMP] = ACTIONS(2754),
    [anon_sym_AMP_AMP] = ACTIONS(2754),
    [anon_sym_PIPE_PIPE] = ACTIONS(2754),
    [anon_sym_LT] = ACTIONS(2754),
    [anon_sym_GT] = ACTIONS(2754),
    [anon_sym_GT_GT] = ACTIONS(2754),
    [anon_sym_AMP_GT] = ACTIONS(2754),
    [anon_sym_AMP_GT_GT] = ACTIONS(2754),
    [anon_sym_LT_AMP] = ACTIONS(2754),
    [anon_sym_GT_AMP] = ACTIONS(2754),
    [anon_sym_LT_LT] = ACTIONS(2754),
    [anon_sym_LT_LT_DASH] = ACTIONS(2754),
    [anon_sym_LT_LT_LT] = ACTIONS(2754),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_LF] = ACTIONS(2752),
    [anon_sym_AMP] = ACTIONS(2754),
  },
  [3025] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(7156),
    [sym_comment] = ACTIONS(53),
  },
  [3026] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(7158),
    [sym_comment] = ACTIONS(53),
  },
  [3027] = {
    [anon_sym_RBRACE] = ACTIONS(7158),
    [sym_comment] = ACTIONS(53),
  },
  [3028] = {
    [sym_concatenation] = STATE(3111),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3111),
    [anon_sym_RBRACE] = ACTIONS(7160),
    [anon_sym_EQ] = ACTIONS(7162),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7164),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7162),
    [anon_sym_COLON_QMARK] = ACTIONS(7162),
    [anon_sym_COLON_DASH] = ACTIONS(7162),
    [anon_sym_PERCENT] = ACTIONS(7162),
    [anon_sym_DASH] = ACTIONS(7162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3029] = {
    [sym__simple_heredoc_body] = ACTIONS(2830),
    [sym__heredoc_body_beginning] = ACTIONS(2830),
    [sym_file_descriptor] = ACTIONS(2830),
    [sym__concat] = ACTIONS(2830),
    [anon_sym_esac] = ACTIONS(2832),
    [anon_sym_PIPE] = ACTIONS(2832),
    [anon_sym_SEMI_SEMI] = ACTIONS(2832),
    [anon_sym_PIPE_AMP] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_PIPE_PIPE] = ACTIONS(2832),
    [anon_sym_LT] = ACTIONS(2832),
    [anon_sym_GT] = ACTIONS(2832),
    [anon_sym_GT_GT] = ACTIONS(2832),
    [anon_sym_AMP_GT] = ACTIONS(2832),
    [anon_sym_AMP_GT_GT] = ACTIONS(2832),
    [anon_sym_LT_AMP] = ACTIONS(2832),
    [anon_sym_GT_AMP] = ACTIONS(2832),
    [anon_sym_LT_LT] = ACTIONS(2832),
    [anon_sym_LT_LT_DASH] = ACTIONS(2832),
    [anon_sym_LT_LT_LT] = ACTIONS(2832),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2832),
    [anon_sym_LF] = ACTIONS(2830),
    [anon_sym_AMP] = ACTIONS(2832),
  },
  [3030] = {
    [sym_concatenation] = STATE(3114),
    [sym_string] = STATE(3113),
    [sym_simple_expansion] = STATE(3113),
    [sym_string_expansion] = STATE(3113),
    [sym_expansion] = STATE(3113),
    [sym_command_substitution] = STATE(3113),
    [sym_process_substitution] = STATE(3113),
    [anon_sym_RBRACE] = ACTIONS(7158),
    [sym__special_characters] = ACTIONS(7166),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(7168),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(7168),
  },
  [3031] = {
    [sym__simple_heredoc_body] = ACTIONS(2873),
    [sym__heredoc_body_beginning] = ACTIONS(2873),
    [sym_file_descriptor] = ACTIONS(2873),
    [sym__concat] = ACTIONS(2873),
    [anon_sym_esac] = ACTIONS(2875),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [anon_sym_PIPE_AMP] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT] = ACTIONS(2875),
    [anon_sym_AMP_GT_GT] = ACTIONS(2875),
    [anon_sym_LT_AMP] = ACTIONS(2875),
    [anon_sym_GT_AMP] = ACTIONS(2875),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_LT_LT_DASH] = ACTIONS(2875),
    [anon_sym_LT_LT_LT] = ACTIONS(2875),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [3032] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(7170),
  },
  [3033] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7172),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3034] = {
    [sym__simple_heredoc_body] = ACTIONS(2881),
    [sym__heredoc_body_beginning] = ACTIONS(2881),
    [sym_file_descriptor] = ACTIONS(2881),
    [sym__concat] = ACTIONS(2881),
    [anon_sym_esac] = ACTIONS(2883),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_SEMI_SEMI] = ACTIONS(2883),
    [anon_sym_PIPE_AMP] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_GT_GT] = ACTIONS(2883),
    [anon_sym_AMP_GT] = ACTIONS(2883),
    [anon_sym_AMP_GT_GT] = ACTIONS(2883),
    [anon_sym_LT_AMP] = ACTIONS(2883),
    [anon_sym_GT_AMP] = ACTIONS(2883),
    [anon_sym_LT_LT] = ACTIONS(2883),
    [anon_sym_LT_LT_DASH] = ACTIONS(2883),
    [anon_sym_LT_LT_LT] = ACTIONS(2883),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_LF] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
  },
  [3035] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(7174),
  },
  [3036] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7176),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3037] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(7178),
  },
  [3038] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7158),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3039] = {
    [sym_concatenation] = STATE(3121),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3121),
    [anon_sym_RBRACE] = ACTIONS(7180),
    [anon_sym_EQ] = ACTIONS(7182),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7182),
    [anon_sym_COLON_QMARK] = ACTIONS(7182),
    [anon_sym_COLON_DASH] = ACTIONS(7182),
    [anon_sym_PERCENT] = ACTIONS(7182),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3040] = {
    [sym__simple_heredoc_body] = ACTIONS(2897),
    [sym__heredoc_body_beginning] = ACTIONS(2897),
    [sym_file_descriptor] = ACTIONS(2897),
    [sym__concat] = ACTIONS(2897),
    [anon_sym_esac] = ACTIONS(2899),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_SEMI_SEMI] = ACTIONS(2899),
    [anon_sym_PIPE_AMP] = ACTIONS(2899),
    [anon_sym_AMP_AMP] = ACTIONS(2899),
    [anon_sym_PIPE_PIPE] = ACTIONS(2899),
    [anon_sym_LT] = ACTIONS(2899),
    [anon_sym_GT] = ACTIONS(2899),
    [anon_sym_GT_GT] = ACTIONS(2899),
    [anon_sym_AMP_GT] = ACTIONS(2899),
    [anon_sym_AMP_GT_GT] = ACTIONS(2899),
    [anon_sym_LT_AMP] = ACTIONS(2899),
    [anon_sym_GT_AMP] = ACTIONS(2899),
    [anon_sym_LT_LT] = ACTIONS(2899),
    [anon_sym_LT_LT_DASH] = ACTIONS(2899),
    [anon_sym_LT_LT_LT] = ACTIONS(2899),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LF] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2899),
  },
  [3041] = {
    [sym_concatenation] = STATE(3123),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3123),
    [anon_sym_RBRACE] = ACTIONS(7186),
    [anon_sym_EQ] = ACTIONS(7188),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7190),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7188),
    [anon_sym_COLON_QMARK] = ACTIONS(7188),
    [anon_sym_COLON_DASH] = ACTIONS(7188),
    [anon_sym_PERCENT] = ACTIONS(7188),
    [anon_sym_DASH] = ACTIONS(7188),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3042] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(6727),
    [anon_sym_DQUOTE] = ACTIONS(6729),
    [anon_sym_DOLLAR] = ACTIONS(6727),
    [sym_raw_string] = ACTIONS(6729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6729),
    [anon_sym_BQUOTE] = ACTIONS(6729),
    [anon_sym_LT_LPAREN] = ACTIONS(6729),
    [anon_sym_GT_LPAREN] = ACTIONS(6729),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6727),
  },
  [3043] = {
    [sym_file_descriptor] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_SEMI_SEMI] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_typeset] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_local] = ACTIONS(953),
    [anon_sym_unset] = ACTIONS(953),
    [anon_sym_unsetenv] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(951),
    [anon_sym_AMP_GT] = ACTIONS(953),
    [anon_sym_AMP_GT_GT] = ACTIONS(951),
    [anon_sym_LT_AMP] = ACTIONS(951),
    [anon_sym_GT_AMP] = ACTIONS(951),
    [sym__special_characters] = ACTIONS(6733),
    [anon_sym_DQUOTE] = ACTIONS(6735),
    [anon_sym_DOLLAR] = ACTIONS(6733),
    [sym_raw_string] = ACTIONS(6735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6735),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6735),
    [anon_sym_BQUOTE] = ACTIONS(6735),
    [anon_sym_LT_LPAREN] = ACTIONS(6735),
    [anon_sym_GT_LPAREN] = ACTIONS(6735),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6733),
  },
  [3044] = {
    [sym_file_descriptor] = ACTIONS(5540),
    [sym__concat] = ACTIONS(5540),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_RPAREN] = ACTIONS(5540),
    [anon_sym_PIPE_AMP] = ACTIONS(5540),
    [anon_sym_AMP_AMP] = ACTIONS(5540),
    [anon_sym_PIPE_PIPE] = ACTIONS(5540),
    [anon_sym_LT] = ACTIONS(5542),
    [anon_sym_GT] = ACTIONS(5542),
    [anon_sym_GT_GT] = ACTIONS(5540),
    [anon_sym_AMP_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT_GT] = ACTIONS(5540),
    [anon_sym_LT_AMP] = ACTIONS(5540),
    [anon_sym_GT_AMP] = ACTIONS(5540),
    [anon_sym_LT_LT] = ACTIONS(5542),
    [anon_sym_LT_LT_DASH] = ACTIONS(5540),
    [anon_sym_LT_LT_LT] = ACTIONS(5540),
    [anon_sym_BQUOTE] = ACTIONS(5540),
    [sym_comment] = ACTIONS(53),
  },
  [3045] = {
    [sym_file_descriptor] = ACTIONS(5544),
    [sym__concat] = ACTIONS(5544),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_RPAREN] = ACTIONS(5544),
    [anon_sym_PIPE_AMP] = ACTIONS(5544),
    [anon_sym_AMP_AMP] = ACTIONS(5544),
    [anon_sym_PIPE_PIPE] = ACTIONS(5544),
    [anon_sym_LT] = ACTIONS(5546),
    [anon_sym_GT] = ACTIONS(5546),
    [anon_sym_GT_GT] = ACTIONS(5544),
    [anon_sym_AMP_GT] = ACTIONS(5546),
    [anon_sym_AMP_GT_GT] = ACTIONS(5544),
    [anon_sym_LT_AMP] = ACTIONS(5544),
    [anon_sym_GT_AMP] = ACTIONS(5544),
    [anon_sym_LT_LT] = ACTIONS(5546),
    [anon_sym_LT_LT_DASH] = ACTIONS(5544),
    [anon_sym_LT_LT_LT] = ACTIONS(5544),
    [anon_sym_BQUOTE] = ACTIONS(5544),
    [sym_comment] = ACTIONS(53),
  },
  [3046] = {
    [sym_file_descriptor] = ACTIONS(5548),
    [sym__concat] = ACTIONS(5548),
    [anon_sym_PIPE] = ACTIONS(5550),
    [anon_sym_RPAREN] = ACTIONS(5548),
    [anon_sym_PIPE_AMP] = ACTIONS(5548),
    [anon_sym_AMP_AMP] = ACTIONS(5548),
    [anon_sym_PIPE_PIPE] = ACTIONS(5548),
    [anon_sym_LT] = ACTIONS(5550),
    [anon_sym_GT] = ACTIONS(5550),
    [anon_sym_GT_GT] = ACTIONS(5548),
    [anon_sym_AMP_GT] = ACTIONS(5550),
    [anon_sym_AMP_GT_GT] = ACTIONS(5548),
    [anon_sym_LT_AMP] = ACTIONS(5548),
    [anon_sym_GT_AMP] = ACTIONS(5548),
    [anon_sym_LT_LT] = ACTIONS(5550),
    [anon_sym_LT_LT_DASH] = ACTIONS(5548),
    [anon_sym_LT_LT_LT] = ACTIONS(5548),
    [anon_sym_BQUOTE] = ACTIONS(5548),
    [sym_comment] = ACTIONS(53),
  },
  [3047] = {
    [sym_file_descriptor] = ACTIONS(3917),
    [sym__concat] = ACTIONS(3917),
    [sym_variable_name] = ACTIONS(3917),
    [anon_sym_esac] = ACTIONS(3919),
    [anon_sym_PIPE] = ACTIONS(3919),
    [anon_sym_SEMI_SEMI] = ACTIONS(3919),
    [anon_sym_PIPE_AMP] = ACTIONS(3919),
    [anon_sym_AMP_AMP] = ACTIONS(3919),
    [anon_sym_PIPE_PIPE] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_GT] = ACTIONS(3919),
    [anon_sym_GT_GT] = ACTIONS(3919),
    [anon_sym_AMP_GT] = ACTIONS(3919),
    [anon_sym_AMP_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_AMP] = ACTIONS(3919),
    [anon_sym_GT_AMP] = ACTIONS(3919),
    [sym__special_characters] = ACTIONS(3919),
    [anon_sym_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3919),
    [sym_raw_string] = ACTIONS(3919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3919),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3919),
    [anon_sym_BQUOTE] = ACTIONS(3919),
    [anon_sym_LT_LPAREN] = ACTIONS(3919),
    [anon_sym_GT_LPAREN] = ACTIONS(3919),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3919),
    [anon_sym_SEMI] = ACTIONS(3919),
    [anon_sym_LF] = ACTIONS(3917),
    [anon_sym_AMP] = ACTIONS(3919),
  },
  [3048] = {
    [sym_file_descriptor] = ACTIONS(3923),
    [sym__concat] = ACTIONS(3923),
    [sym_variable_name] = ACTIONS(3923),
    [anon_sym_esac] = ACTIONS(3925),
    [anon_sym_PIPE] = ACTIONS(3925),
    [anon_sym_SEMI_SEMI] = ACTIONS(3925),
    [anon_sym_PIPE_AMP] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_GT] = ACTIONS(3925),
    [anon_sym_GT_GT] = ACTIONS(3925),
    [anon_sym_AMP_GT] = ACTIONS(3925),
    [anon_sym_AMP_GT_GT] = ACTIONS(3925),
    [anon_sym_LT_AMP] = ACTIONS(3925),
    [anon_sym_GT_AMP] = ACTIONS(3925),
    [sym__special_characters] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [sym_raw_string] = ACTIONS(3925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3925),
    [anon_sym_BQUOTE] = ACTIONS(3925),
    [anon_sym_LT_LPAREN] = ACTIONS(3925),
    [anon_sym_GT_LPAREN] = ACTIONS(3925),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(3925),
    [anon_sym_SEMI] = ACTIONS(3925),
    [anon_sym_LF] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3925),
  },
  [3049] = {
    [sym_file_descriptor] = ACTIONS(4008),
    [sym__concat] = ACTIONS(4008),
    [sym_variable_name] = ACTIONS(4008),
    [anon_sym_esac] = ACTIONS(4010),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_SEMI_SEMI] = ACTIONS(4010),
    [anon_sym_PIPE_AMP] = ACTIONS(4010),
    [anon_sym_AMP_AMP] = ACTIONS(4010),
    [anon_sym_PIPE_PIPE] = ACTIONS(4010),
    [anon_sym_LT] = ACTIONS(4010),
    [anon_sym_GT] = ACTIONS(4010),
    [anon_sym_GT_GT] = ACTIONS(4010),
    [anon_sym_AMP_GT] = ACTIONS(4010),
    [anon_sym_AMP_GT_GT] = ACTIONS(4010),
    [anon_sym_LT_AMP] = ACTIONS(4010),
    [anon_sym_GT_AMP] = ACTIONS(4010),
    [sym__special_characters] = ACTIONS(4010),
    [anon_sym_DQUOTE] = ACTIONS(4010),
    [anon_sym_DOLLAR] = ACTIONS(4010),
    [sym_raw_string] = ACTIONS(4010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4010),
    [anon_sym_BQUOTE] = ACTIONS(4010),
    [anon_sym_LT_LPAREN] = ACTIONS(4010),
    [anon_sym_GT_LPAREN] = ACTIONS(4010),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4010),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LF] = ACTIONS(4008),
    [anon_sym_AMP] = ACTIONS(4010),
  },
  [3050] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7192),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3051] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(7194),
    [sym_comment] = ACTIONS(53),
  },
  [3052] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(7196),
    [sym_comment] = ACTIONS(53),
  },
  [3053] = {
    [anon_sym_RBRACE] = ACTIONS(7196),
    [sym_comment] = ACTIONS(53),
  },
  [3054] = {
    [sym_concatenation] = STATE(3128),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3128),
    [anon_sym_RBRACE] = ACTIONS(7198),
    [anon_sym_EQ] = ACTIONS(7200),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7200),
    [anon_sym_COLON_QMARK] = ACTIONS(7200),
    [anon_sym_COLON_DASH] = ACTIONS(7200),
    [anon_sym_PERCENT] = ACTIONS(7200),
    [anon_sym_DASH] = ACTIONS(7200),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3055] = {
    [sym_file_descriptor] = ACTIONS(4024),
    [sym__concat] = ACTIONS(4024),
    [sym_variable_name] = ACTIONS(4024),
    [anon_sym_esac] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_SEMI_SEMI] = ACTIONS(4026),
    [anon_sym_PIPE_AMP] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4026),
    [anon_sym_PIPE_PIPE] = ACTIONS(4026),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_AMP_GT] = ACTIONS(4026),
    [anon_sym_AMP_GT_GT] = ACTIONS(4026),
    [anon_sym_LT_AMP] = ACTIONS(4026),
    [anon_sym_GT_AMP] = ACTIONS(4026),
    [sym__special_characters] = ACTIONS(4026),
    [anon_sym_DQUOTE] = ACTIONS(4026),
    [anon_sym_DOLLAR] = ACTIONS(4026),
    [sym_raw_string] = ACTIONS(4026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4026),
    [anon_sym_BQUOTE] = ACTIONS(4026),
    [anon_sym_LT_LPAREN] = ACTIONS(4026),
    [anon_sym_GT_LPAREN] = ACTIONS(4026),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4026),
    [anon_sym_SEMI] = ACTIONS(4026),
    [anon_sym_LF] = ACTIONS(4024),
    [anon_sym_AMP] = ACTIONS(4026),
  },
  [3056] = {
    [sym_concatenation] = STATE(3130),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3130),
    [anon_sym_RBRACE] = ACTIONS(7204),
    [anon_sym_EQ] = ACTIONS(7206),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7208),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7206),
    [anon_sym_COLON_QMARK] = ACTIONS(7206),
    [anon_sym_COLON_DASH] = ACTIONS(7206),
    [anon_sym_PERCENT] = ACTIONS(7206),
    [anon_sym_DASH] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3057] = {
    [sym_file_descriptor] = ACTIONS(4034),
    [sym__concat] = ACTIONS(4034),
    [sym_variable_name] = ACTIONS(4034),
    [anon_sym_esac] = ACTIONS(4036),
    [anon_sym_PIPE] = ACTIONS(4036),
    [anon_sym_SEMI_SEMI] = ACTIONS(4036),
    [anon_sym_PIPE_AMP] = ACTIONS(4036),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4036),
    [anon_sym_GT] = ACTIONS(4036),
    [anon_sym_GT_GT] = ACTIONS(4036),
    [anon_sym_AMP_GT] = ACTIONS(4036),
    [anon_sym_AMP_GT_GT] = ACTIONS(4036),
    [anon_sym_LT_AMP] = ACTIONS(4036),
    [anon_sym_GT_AMP] = ACTIONS(4036),
    [sym__special_characters] = ACTIONS(4036),
    [anon_sym_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR] = ACTIONS(4036),
    [sym_raw_string] = ACTIONS(4036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4036),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4036),
    [anon_sym_GT_LPAREN] = ACTIONS(4036),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4036),
    [anon_sym_SEMI] = ACTIONS(4036),
    [anon_sym_LF] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
  },
  [3058] = {
    [sym_concatenation] = STATE(3132),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3132),
    [anon_sym_RBRACE] = ACTIONS(7210),
    [anon_sym_EQ] = ACTIONS(7212),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7214),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7212),
    [anon_sym_COLON_QMARK] = ACTIONS(7212),
    [anon_sym_COLON_DASH] = ACTIONS(7212),
    [anon_sym_PERCENT] = ACTIONS(7212),
    [anon_sym_DASH] = ACTIONS(7212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3059] = {
    [sym_file_descriptor] = ACTIONS(4044),
    [sym__concat] = ACTIONS(4044),
    [sym_variable_name] = ACTIONS(4044),
    [anon_sym_esac] = ACTIONS(4046),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_SEMI_SEMI] = ACTIONS(4046),
    [anon_sym_PIPE_AMP] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4046),
    [anon_sym_PIPE_PIPE] = ACTIONS(4046),
    [anon_sym_LT] = ACTIONS(4046),
    [anon_sym_GT] = ACTIONS(4046),
    [anon_sym_GT_GT] = ACTIONS(4046),
    [anon_sym_AMP_GT] = ACTIONS(4046),
    [anon_sym_AMP_GT_GT] = ACTIONS(4046),
    [anon_sym_LT_AMP] = ACTIONS(4046),
    [anon_sym_GT_AMP] = ACTIONS(4046),
    [sym__special_characters] = ACTIONS(4046),
    [anon_sym_DQUOTE] = ACTIONS(4046),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [sym_raw_string] = ACTIONS(4046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4046),
    [anon_sym_BQUOTE] = ACTIONS(4046),
    [anon_sym_LT_LPAREN] = ACTIONS(4046),
    [anon_sym_GT_LPAREN] = ACTIONS(4046),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4046),
    [anon_sym_SEMI] = ACTIONS(4046),
    [anon_sym_LF] = ACTIONS(4044),
    [anon_sym_AMP] = ACTIONS(4046),
  },
  [3060] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7216),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3061] = {
    [sym_file_descriptor] = ACTIONS(4050),
    [sym__concat] = ACTIONS(4050),
    [sym_variable_name] = ACTIONS(4050),
    [anon_sym_esac] = ACTIONS(4052),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_SEMI_SEMI] = ACTIONS(4052),
    [anon_sym_PIPE_AMP] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4052),
    [anon_sym_PIPE_PIPE] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_AMP_GT] = ACTIONS(4052),
    [anon_sym_AMP_GT_GT] = ACTIONS(4052),
    [anon_sym_LT_AMP] = ACTIONS(4052),
    [anon_sym_GT_AMP] = ACTIONS(4052),
    [sym__special_characters] = ACTIONS(4052),
    [anon_sym_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [sym_raw_string] = ACTIONS(4052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4052),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4052),
    [anon_sym_BQUOTE] = ACTIONS(4052),
    [anon_sym_LT_LPAREN] = ACTIONS(4052),
    [anon_sym_GT_LPAREN] = ACTIONS(4052),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4052),
    [anon_sym_SEMI] = ACTIONS(4052),
    [anon_sym_LF] = ACTIONS(4050),
    [anon_sym_AMP] = ACTIONS(4052),
  },
  [3062] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7218),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3063] = {
    [sym__concat] = ACTIONS(1654),
    [anon_sym_esac] = ACTIONS(1656),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [3064] = {
    [aux_sym_concatenation_repeat1] = STATE(3064),
    [sym__concat] = ACTIONS(7220),
    [anon_sym_esac] = ACTIONS(1656),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [3065] = {
    [sym__concat] = ACTIONS(1703),
    [anon_sym_esac] = ACTIONS(1705),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_SEMI_SEMI] = ACTIONS(1705),
    [anon_sym_PIPE_AMP] = ACTIONS(1705),
    [anon_sym_AMP_AMP] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE] = ACTIONS(1705),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_LF] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1705),
  },
  [3066] = {
    [sym_concatenation] = STATE(3138),
    [sym_string] = STATE(3137),
    [sym_simple_expansion] = STATE(3137),
    [sym_string_expansion] = STATE(3137),
    [sym_expansion] = STATE(3137),
    [sym_command_substitution] = STATE(3137),
    [sym_process_substitution] = STATE(3137),
    [anon_sym_RBRACE] = ACTIONS(7223),
    [sym__special_characters] = ACTIONS(7225),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(7227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(7227),
  },
  [3067] = {
    [sym__concat] = ACTIONS(1744),
    [anon_sym_esac] = ACTIONS(1746),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_SEMI_SEMI] = ACTIONS(1746),
    [anon_sym_PIPE_AMP] = ACTIONS(1746),
    [anon_sym_AMP_AMP] = ACTIONS(1746),
    [anon_sym_PIPE_PIPE] = ACTIONS(1746),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1746),
    [anon_sym_LF] = ACTIONS(1744),
    [anon_sym_AMP] = ACTIONS(1746),
  },
  [3068] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(7229),
  },
  [3069] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7231),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3070] = {
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_EQ] = ACTIONS(7233),
    [sym_comment] = ACTIONS(53),
  },
  [3071] = {
    [sym_concatenation] = STATE(3144),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3144),
    [anon_sym_RBRACE] = ACTIONS(7235),
    [anon_sym_EQ] = ACTIONS(7237),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7239),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(7241),
    [anon_sym_COLON] = ACTIONS(7237),
    [anon_sym_COLON_QMARK] = ACTIONS(7237),
    [anon_sym_COLON_DASH] = ACTIONS(7237),
    [anon_sym_PERCENT] = ACTIONS(7237),
    [anon_sym_DASH] = ACTIONS(7237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3072] = {
    [sym_concatenation] = STATE(3147),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3147),
    [anon_sym_RBRACE] = ACTIONS(7243),
    [anon_sym_EQ] = ACTIONS(7245),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(7249),
    [anon_sym_COLON] = ACTIONS(7245),
    [anon_sym_COLON_QMARK] = ACTIONS(7245),
    [anon_sym_COLON_DASH] = ACTIONS(7245),
    [anon_sym_PERCENT] = ACTIONS(7245),
    [anon_sym_DASH] = ACTIONS(7245),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3073] = {
    [sym_concatenation] = STATE(3149),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3149),
    [anon_sym_RBRACE] = ACTIONS(7223),
    [anon_sym_EQ] = ACTIONS(7251),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [aux_sym_SLASH] = ACTIONS(7255),
    [anon_sym_COLON] = ACTIONS(7251),
    [anon_sym_COLON_QMARK] = ACTIONS(7251),
    [anon_sym_COLON_DASH] = ACTIONS(7251),
    [anon_sym_PERCENT] = ACTIONS(7251),
    [anon_sym_DASH] = ACTIONS(7251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3074] = {
    [sym__concat] = ACTIONS(1810),
    [anon_sym_esac] = ACTIONS(1812),
    [anon_sym_PIPE] = ACTIONS(1812),
    [anon_sym_SEMI_SEMI] = ACTIONS(1812),
    [anon_sym_PIPE_AMP] = ACTIONS(1812),
    [anon_sym_AMP_AMP] = ACTIONS(1812),
    [anon_sym_PIPE_PIPE] = ACTIONS(1812),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1812),
    [anon_sym_LF] = ACTIONS(1810),
    [anon_sym_AMP] = ACTIONS(1812),
  },
  [3075] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(7257),
  },
  [3076] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7259),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3077] = {
    [sym__concat] = ACTIONS(1818),
    [anon_sym_esac] = ACTIONS(1820),
    [anon_sym_PIPE] = ACTIONS(1820),
    [anon_sym_SEMI_SEMI] = ACTIONS(1820),
    [anon_sym_PIPE_AMP] = ACTIONS(1820),
    [anon_sym_AMP_AMP] = ACTIONS(1820),
    [anon_sym_PIPE_PIPE] = ACTIONS(1820),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1820),
    [anon_sym_LF] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1820),
  },
  [3078] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(7261),
  },
  [3079] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7223),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3080] = {
    [sym__concat] = ACTIONS(1952),
    [anon_sym_esac] = ACTIONS(1954),
    [anon_sym_PIPE] = ACTIONS(1954),
    [anon_sym_SEMI_SEMI] = ACTIONS(1954),
    [anon_sym_PIPE_AMP] = ACTIONS(1954),
    [anon_sym_AMP_AMP] = ACTIONS(1954),
    [anon_sym_PIPE_PIPE] = ACTIONS(1954),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1954),
    [anon_sym_LF] = ACTIONS(1952),
    [anon_sym_AMP] = ACTIONS(1954),
  },
  [3081] = {
    [sym__concat] = ACTIONS(2018),
    [anon_sym_esac] = ACTIONS(2020),
    [anon_sym_PIPE] = ACTIONS(2020),
    [anon_sym_SEMI_SEMI] = ACTIONS(2020),
    [anon_sym_PIPE_AMP] = ACTIONS(2020),
    [anon_sym_AMP_AMP] = ACTIONS(2020),
    [anon_sym_PIPE_PIPE] = ACTIONS(2020),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2020),
    [anon_sym_LF] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2020),
  },
  [3082] = {
    [aux_sym_concatenation_repeat1] = STATE(3082),
    [sym_file_descriptor] = ACTIONS(1654),
    [sym__concat] = ACTIONS(5399),
    [anon_sym_esac] = ACTIONS(1656),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_SEMI_SEMI] = ACTIONS(1656),
    [anon_sym_PIPE_AMP] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1656),
    [anon_sym_PIPE_PIPE] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_GT_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT_GT] = ACTIONS(1656),
    [anon_sym_LT_AMP] = ACTIONS(1656),
    [anon_sym_GT_AMP] = ACTIONS(1656),
    [anon_sym_LT_LT] = ACTIONS(1656),
    [anon_sym_LT_LT_DASH] = ACTIONS(1656),
    [anon_sym_LT_LT_LT] = ACTIONS(1656),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_LF] = ACTIONS(1654),
    [anon_sym_AMP] = ACTIONS(1656),
  },
  [3083] = {
    [sym__concat] = ACTIONS(4884),
    [sym_variable_name] = ACTIONS(4884),
    [anon_sym_esac] = ACTIONS(4886),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [anon_sym_PIPE_AMP] = ACTIONS(4886),
    [anon_sym_AMP_AMP] = ACTIONS(4886),
    [anon_sym_PIPE_PIPE] = ACTIONS(4886),
    [sym__special_characters] = ACTIONS(4886),
    [anon_sym_DQUOTE] = ACTIONS(4886),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4886),
    [anon_sym_BQUOTE] = ACTIONS(4886),
    [anon_sym_LT_LPAREN] = ACTIONS(4886),
    [anon_sym_GT_LPAREN] = ACTIONS(4886),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4886),
    [sym_word] = ACTIONS(4886),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [3084] = {
    [sym__concat] = ACTIONS(4888),
    [sym_variable_name] = ACTIONS(4888),
    [anon_sym_esac] = ACTIONS(4890),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [anon_sym_PIPE_AMP] = ACTIONS(4890),
    [anon_sym_AMP_AMP] = ACTIONS(4890),
    [anon_sym_PIPE_PIPE] = ACTIONS(4890),
    [sym__special_characters] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4890),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4890),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_LT_LPAREN] = ACTIONS(4890),
    [anon_sym_GT_LPAREN] = ACTIONS(4890),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4890),
    [sym_word] = ACTIONS(4890),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [3085] = {
    [sym__concat] = ACTIONS(4892),
    [sym_variable_name] = ACTIONS(4892),
    [anon_sym_esac] = ACTIONS(4894),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_SEMI_SEMI] = ACTIONS(4894),
    [anon_sym_PIPE_AMP] = ACTIONS(4894),
    [anon_sym_AMP_AMP] = ACTIONS(4894),
    [anon_sym_PIPE_PIPE] = ACTIONS(4894),
    [sym__special_characters] = ACTIONS(4894),
    [anon_sym_DQUOTE] = ACTIONS(4894),
    [anon_sym_DOLLAR] = ACTIONS(4894),
    [sym_raw_string] = ACTIONS(4894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4894),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4894),
    [anon_sym_GT_LPAREN] = ACTIONS(4894),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4894),
    [sym_word] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(4894),
    [anon_sym_LF] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4894),
  },
  [3086] = {
    [sym__concat] = ACTIONS(4896),
    [sym_variable_name] = ACTIONS(4896),
    [anon_sym_esac] = ACTIONS(4898),
    [anon_sym_PIPE] = ACTIONS(4898),
    [anon_sym_SEMI_SEMI] = ACTIONS(4898),
    [anon_sym_PIPE_AMP] = ACTIONS(4898),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [sym__special_characters] = ACTIONS(4898),
    [anon_sym_DQUOTE] = ACTIONS(4898),
    [anon_sym_DOLLAR] = ACTIONS(4898),
    [sym_raw_string] = ACTIONS(4898),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4898),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4898),
    [anon_sym_BQUOTE] = ACTIONS(4898),
    [anon_sym_LT_LPAREN] = ACTIONS(4898),
    [anon_sym_GT_LPAREN] = ACTIONS(4898),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4898),
    [sym_word] = ACTIONS(4898),
    [anon_sym_SEMI] = ACTIONS(4898),
    [anon_sym_LF] = ACTIONS(4896),
    [anon_sym_AMP] = ACTIONS(4898),
  },
  [3087] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7263),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3088] = {
    [sym__concat] = ACTIONS(4902),
    [sym_variable_name] = ACTIONS(4902),
    [anon_sym_esac] = ACTIONS(4904),
    [anon_sym_PIPE] = ACTIONS(4904),
    [anon_sym_SEMI_SEMI] = ACTIONS(4904),
    [anon_sym_PIPE_AMP] = ACTIONS(4904),
    [anon_sym_AMP_AMP] = ACTIONS(4904),
    [anon_sym_PIPE_PIPE] = ACTIONS(4904),
    [sym__special_characters] = ACTIONS(4904),
    [anon_sym_DQUOTE] = ACTIONS(4904),
    [anon_sym_DOLLAR] = ACTIONS(4904),
    [sym_raw_string] = ACTIONS(4904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4904),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4904),
    [anon_sym_BQUOTE] = ACTIONS(4904),
    [anon_sym_LT_LPAREN] = ACTIONS(4904),
    [anon_sym_GT_LPAREN] = ACTIONS(4904),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4904),
    [sym_word] = ACTIONS(4904),
    [anon_sym_SEMI] = ACTIONS(4904),
    [anon_sym_LF] = ACTIONS(4902),
    [anon_sym_AMP] = ACTIONS(4904),
  },
  [3089] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7265),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3090] = {
    [sym__concat] = ACTIONS(4908),
    [sym_variable_name] = ACTIONS(4908),
    [anon_sym_esac] = ACTIONS(4910),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_SEMI_SEMI] = ACTIONS(4910),
    [anon_sym_PIPE_AMP] = ACTIONS(4910),
    [anon_sym_AMP_AMP] = ACTIONS(4910),
    [anon_sym_PIPE_PIPE] = ACTIONS(4910),
    [sym__special_characters] = ACTIONS(4910),
    [anon_sym_DQUOTE] = ACTIONS(4910),
    [anon_sym_DOLLAR] = ACTIONS(4910),
    [sym_raw_string] = ACTIONS(4910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4910),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4910),
    [anon_sym_BQUOTE] = ACTIONS(4910),
    [anon_sym_LT_LPAREN] = ACTIONS(4910),
    [anon_sym_GT_LPAREN] = ACTIONS(4910),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4910),
    [sym_word] = ACTIONS(4910),
    [anon_sym_SEMI] = ACTIONS(4910),
    [anon_sym_LF] = ACTIONS(4908),
    [anon_sym_AMP] = ACTIONS(4910),
  },
  [3091] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7267),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3092] = {
    [sym__concat] = ACTIONS(4914),
    [sym_variable_name] = ACTIONS(4914),
    [anon_sym_esac] = ACTIONS(4916),
    [anon_sym_PIPE] = ACTIONS(4916),
    [anon_sym_SEMI_SEMI] = ACTIONS(4916),
    [anon_sym_PIPE_AMP] = ACTIONS(4916),
    [anon_sym_AMP_AMP] = ACTIONS(4916),
    [anon_sym_PIPE_PIPE] = ACTIONS(4916),
    [sym__special_characters] = ACTIONS(4916),
    [anon_sym_DQUOTE] = ACTIONS(4916),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(4916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4916),
    [anon_sym_BQUOTE] = ACTIONS(4916),
    [anon_sym_LT_LPAREN] = ACTIONS(4916),
    [anon_sym_GT_LPAREN] = ACTIONS(4916),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4916),
    [sym_word] = ACTIONS(4916),
    [anon_sym_SEMI] = ACTIONS(4916),
    [anon_sym_LF] = ACTIONS(4914),
    [anon_sym_AMP] = ACTIONS(4916),
  },
  [3093] = {
    [sym__concat] = ACTIONS(4918),
    [sym_variable_name] = ACTIONS(4918),
    [anon_sym_esac] = ACTIONS(4920),
    [anon_sym_PIPE] = ACTIONS(4920),
    [anon_sym_SEMI_SEMI] = ACTIONS(4920),
    [anon_sym_PIPE_AMP] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [sym__special_characters] = ACTIONS(4920),
    [anon_sym_DQUOTE] = ACTIONS(4920),
    [anon_sym_DOLLAR] = ACTIONS(4920),
    [sym_raw_string] = ACTIONS(4920),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4920),
    [anon_sym_BQUOTE] = ACTIONS(4920),
    [anon_sym_LT_LPAREN] = ACTIONS(4920),
    [anon_sym_GT_LPAREN] = ACTIONS(4920),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4920),
    [sym_word] = ACTIONS(4920),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym_LF] = ACTIONS(4918),
    [anon_sym_AMP] = ACTIONS(4920),
  },
  [3094] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_esac] = ACTIONS(4886),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [anon_sym_PIPE_AMP] = ACTIONS(4886),
    [anon_sym_AMP_AMP] = ACTIONS(4886),
    [anon_sym_PIPE_PIPE] = ACTIONS(4886),
    [sym__special_characters] = ACTIONS(4886),
    [anon_sym_DQUOTE] = ACTIONS(4886),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4886),
    [anon_sym_BQUOTE] = ACTIONS(4886),
    [anon_sym_LT_LPAREN] = ACTIONS(4886),
    [anon_sym_GT_LPAREN] = ACTIONS(4886),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4886),
    [sym_word] = ACTIONS(4886),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [3095] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_esac] = ACTIONS(4890),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [anon_sym_PIPE_AMP] = ACTIONS(4890),
    [anon_sym_AMP_AMP] = ACTIONS(4890),
    [anon_sym_PIPE_PIPE] = ACTIONS(4890),
    [sym__special_characters] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4890),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4890),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_LT_LPAREN] = ACTIONS(4890),
    [anon_sym_GT_LPAREN] = ACTIONS(4890),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4890),
    [sym_word] = ACTIONS(4890),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [3096] = {
    [sym__concat] = ACTIONS(4892),
    [anon_sym_esac] = ACTIONS(4894),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_SEMI_SEMI] = ACTIONS(4894),
    [anon_sym_PIPE_AMP] = ACTIONS(4894),
    [anon_sym_AMP_AMP] = ACTIONS(4894),
    [anon_sym_PIPE_PIPE] = ACTIONS(4894),
    [sym__special_characters] = ACTIONS(4894),
    [anon_sym_DQUOTE] = ACTIONS(4894),
    [anon_sym_DOLLAR] = ACTIONS(4894),
    [sym_raw_string] = ACTIONS(4894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4894),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4894),
    [anon_sym_GT_LPAREN] = ACTIONS(4894),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4894),
    [sym_word] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(4894),
    [anon_sym_LF] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4894),
  },
  [3097] = {
    [sym__concat] = ACTIONS(4896),
    [anon_sym_esac] = ACTIONS(4898),
    [anon_sym_PIPE] = ACTIONS(4898),
    [anon_sym_SEMI_SEMI] = ACTIONS(4898),
    [anon_sym_PIPE_AMP] = ACTIONS(4898),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [sym__special_characters] = ACTIONS(4898),
    [anon_sym_DQUOTE] = ACTIONS(4898),
    [anon_sym_DOLLAR] = ACTIONS(4898),
    [sym_raw_string] = ACTIONS(4898),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4898),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4898),
    [anon_sym_BQUOTE] = ACTIONS(4898),
    [anon_sym_LT_LPAREN] = ACTIONS(4898),
    [anon_sym_GT_LPAREN] = ACTIONS(4898),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4898),
    [sym_word] = ACTIONS(4898),
    [anon_sym_SEMI] = ACTIONS(4898),
    [anon_sym_LF] = ACTIONS(4896),
    [anon_sym_AMP] = ACTIONS(4898),
  },
  [3098] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7269),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3099] = {
    [sym__concat] = ACTIONS(4902),
    [anon_sym_esac] = ACTIONS(4904),
    [anon_sym_PIPE] = ACTIONS(4904),
    [anon_sym_SEMI_SEMI] = ACTIONS(4904),
    [anon_sym_PIPE_AMP] = ACTIONS(4904),
    [anon_sym_AMP_AMP] = ACTIONS(4904),
    [anon_sym_PIPE_PIPE] = ACTIONS(4904),
    [sym__special_characters] = ACTIONS(4904),
    [anon_sym_DQUOTE] = ACTIONS(4904),
    [anon_sym_DOLLAR] = ACTIONS(4904),
    [sym_raw_string] = ACTIONS(4904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4904),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4904),
    [anon_sym_BQUOTE] = ACTIONS(4904),
    [anon_sym_LT_LPAREN] = ACTIONS(4904),
    [anon_sym_GT_LPAREN] = ACTIONS(4904),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4904),
    [sym_word] = ACTIONS(4904),
    [anon_sym_SEMI] = ACTIONS(4904),
    [anon_sym_LF] = ACTIONS(4902),
    [anon_sym_AMP] = ACTIONS(4904),
  },
  [3100] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7271),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3101] = {
    [sym__concat] = ACTIONS(4908),
    [anon_sym_esac] = ACTIONS(4910),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_SEMI_SEMI] = ACTIONS(4910),
    [anon_sym_PIPE_AMP] = ACTIONS(4910),
    [anon_sym_AMP_AMP] = ACTIONS(4910),
    [anon_sym_PIPE_PIPE] = ACTIONS(4910),
    [sym__special_characters] = ACTIONS(4910),
    [anon_sym_DQUOTE] = ACTIONS(4910),
    [anon_sym_DOLLAR] = ACTIONS(4910),
    [sym_raw_string] = ACTIONS(4910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4910),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4910),
    [anon_sym_BQUOTE] = ACTIONS(4910),
    [anon_sym_LT_LPAREN] = ACTIONS(4910),
    [anon_sym_GT_LPAREN] = ACTIONS(4910),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4910),
    [sym_word] = ACTIONS(4910),
    [anon_sym_SEMI] = ACTIONS(4910),
    [anon_sym_LF] = ACTIONS(4908),
    [anon_sym_AMP] = ACTIONS(4910),
  },
  [3102] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7273),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3103] = {
    [sym__concat] = ACTIONS(4914),
    [anon_sym_esac] = ACTIONS(4916),
    [anon_sym_PIPE] = ACTIONS(4916),
    [anon_sym_SEMI_SEMI] = ACTIONS(4916),
    [anon_sym_PIPE_AMP] = ACTIONS(4916),
    [anon_sym_AMP_AMP] = ACTIONS(4916),
    [anon_sym_PIPE_PIPE] = ACTIONS(4916),
    [sym__special_characters] = ACTIONS(4916),
    [anon_sym_DQUOTE] = ACTIONS(4916),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(4916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4916),
    [anon_sym_BQUOTE] = ACTIONS(4916),
    [anon_sym_LT_LPAREN] = ACTIONS(4916),
    [anon_sym_GT_LPAREN] = ACTIONS(4916),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4916),
    [sym_word] = ACTIONS(4916),
    [anon_sym_SEMI] = ACTIONS(4916),
    [anon_sym_LF] = ACTIONS(4914),
    [anon_sym_AMP] = ACTIONS(4916),
  },
  [3104] = {
    [sym__concat] = ACTIONS(4918),
    [anon_sym_esac] = ACTIONS(4920),
    [anon_sym_PIPE] = ACTIONS(4920),
    [anon_sym_SEMI_SEMI] = ACTIONS(4920),
    [anon_sym_PIPE_AMP] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [sym__special_characters] = ACTIONS(4920),
    [anon_sym_DQUOTE] = ACTIONS(4920),
    [anon_sym_DOLLAR] = ACTIONS(4920),
    [sym_raw_string] = ACTIONS(4920),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4920),
    [anon_sym_BQUOTE] = ACTIONS(4920),
    [anon_sym_LT_LPAREN] = ACTIONS(4920),
    [anon_sym_GT_LPAREN] = ACTIONS(4920),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4920),
    [sym_word] = ACTIONS(4920),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym_LF] = ACTIONS(4918),
    [anon_sym_AMP] = ACTIONS(4920),
  },
  [3105] = {
    [sym__simple_heredoc_body] = ACTIONS(5540),
    [sym__heredoc_body_beginning] = ACTIONS(5540),
    [sym_file_descriptor] = ACTIONS(5540),
    [sym__concat] = ACTIONS(5540),
    [anon_sym_esac] = ACTIONS(5542),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [anon_sym_PIPE_AMP] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE] = ACTIONS(5542),
    [anon_sym_EQ_TILDE] = ACTIONS(5542),
    [anon_sym_EQ_EQ] = ACTIONS(5542),
    [anon_sym_LT] = ACTIONS(5542),
    [anon_sym_GT] = ACTIONS(5542),
    [anon_sym_GT_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT_GT] = ACTIONS(5542),
    [anon_sym_LT_AMP] = ACTIONS(5542),
    [anon_sym_GT_AMP] = ACTIONS(5542),
    [anon_sym_LT_LT] = ACTIONS(5542),
    [anon_sym_LT_LT_DASH] = ACTIONS(5542),
    [anon_sym_LT_LT_LT] = ACTIONS(5542),
    [sym__special_characters] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [anon_sym_LT_LPAREN] = ACTIONS(5542),
    [anon_sym_GT_LPAREN] = ACTIONS(5542),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5542),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [3106] = {
    [sym__simple_heredoc_body] = ACTIONS(5544),
    [sym__heredoc_body_beginning] = ACTIONS(5544),
    [sym_file_descriptor] = ACTIONS(5544),
    [sym__concat] = ACTIONS(5544),
    [anon_sym_esac] = ACTIONS(5546),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_SEMI_SEMI] = ACTIONS(5546),
    [anon_sym_PIPE_AMP] = ACTIONS(5546),
    [anon_sym_AMP_AMP] = ACTIONS(5546),
    [anon_sym_PIPE_PIPE] = ACTIONS(5546),
    [anon_sym_EQ_TILDE] = ACTIONS(5546),
    [anon_sym_EQ_EQ] = ACTIONS(5546),
    [anon_sym_LT] = ACTIONS(5546),
    [anon_sym_GT] = ACTIONS(5546),
    [anon_sym_GT_GT] = ACTIONS(5546),
    [anon_sym_AMP_GT] = ACTIONS(5546),
    [anon_sym_AMP_GT_GT] = ACTIONS(5546),
    [anon_sym_LT_AMP] = ACTIONS(5546),
    [anon_sym_GT_AMP] = ACTIONS(5546),
    [anon_sym_LT_LT] = ACTIONS(5546),
    [anon_sym_LT_LT_DASH] = ACTIONS(5546),
    [anon_sym_LT_LT_LT] = ACTIONS(5546),
    [sym__special_characters] = ACTIONS(5546),
    [anon_sym_DQUOTE] = ACTIONS(5546),
    [anon_sym_DOLLAR] = ACTIONS(5546),
    [sym_raw_string] = ACTIONS(5546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5546),
    [anon_sym_BQUOTE] = ACTIONS(5546),
    [anon_sym_LT_LPAREN] = ACTIONS(5546),
    [anon_sym_GT_LPAREN] = ACTIONS(5546),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5546),
    [anon_sym_SEMI] = ACTIONS(5546),
    [anon_sym_LF] = ACTIONS(5544),
    [anon_sym_AMP] = ACTIONS(5546),
  },
  [3107] = {
    [sym__simple_heredoc_body] = ACTIONS(5548),
    [sym__heredoc_body_beginning] = ACTIONS(5548),
    [sym_file_descriptor] = ACTIONS(5548),
    [sym__concat] = ACTIONS(5548),
    [anon_sym_esac] = ACTIONS(5550),
    [anon_sym_PIPE] = ACTIONS(5550),
    [anon_sym_SEMI_SEMI] = ACTIONS(5550),
    [anon_sym_PIPE_AMP] = ACTIONS(5550),
    [anon_sym_AMP_AMP] = ACTIONS(5550),
    [anon_sym_PIPE_PIPE] = ACTIONS(5550),
    [anon_sym_EQ_TILDE] = ACTIONS(5550),
    [anon_sym_EQ_EQ] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5550),
    [anon_sym_GT] = ACTIONS(5550),
    [anon_sym_GT_GT] = ACTIONS(5550),
    [anon_sym_AMP_GT] = ACTIONS(5550),
    [anon_sym_AMP_GT_GT] = ACTIONS(5550),
    [anon_sym_LT_AMP] = ACTIONS(5550),
    [anon_sym_GT_AMP] = ACTIONS(5550),
    [anon_sym_LT_LT] = ACTIONS(5550),
    [anon_sym_LT_LT_DASH] = ACTIONS(5550),
    [anon_sym_LT_LT_LT] = ACTIONS(5550),
    [sym__special_characters] = ACTIONS(5550),
    [anon_sym_DQUOTE] = ACTIONS(5550),
    [anon_sym_DOLLAR] = ACTIONS(5550),
    [sym_raw_string] = ACTIONS(5550),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5550),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5550),
    [anon_sym_BQUOTE] = ACTIONS(5550),
    [anon_sym_LT_LPAREN] = ACTIONS(5550),
    [anon_sym_GT_LPAREN] = ACTIONS(5550),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5550),
    [anon_sym_SEMI] = ACTIONS(5550),
    [anon_sym_LF] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
  },
  [3108] = {
    [sym__simple_heredoc_body] = ACTIONS(3917),
    [sym__heredoc_body_beginning] = ACTIONS(3917),
    [sym_file_descriptor] = ACTIONS(3917),
    [sym__concat] = ACTIONS(3917),
    [anon_sym_esac] = ACTIONS(3919),
    [anon_sym_PIPE] = ACTIONS(3919),
    [anon_sym_SEMI_SEMI] = ACTIONS(3919),
    [anon_sym_PIPE_AMP] = ACTIONS(3919),
    [anon_sym_AMP_AMP] = ACTIONS(3919),
    [anon_sym_PIPE_PIPE] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_GT] = ACTIONS(3919),
    [anon_sym_GT_GT] = ACTIONS(3919),
    [anon_sym_AMP_GT] = ACTIONS(3919),
    [anon_sym_AMP_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_AMP] = ACTIONS(3919),
    [anon_sym_GT_AMP] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_LT_LT_DASH] = ACTIONS(3919),
    [anon_sym_LT_LT_LT] = ACTIONS(3919),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3919),
    [anon_sym_LF] = ACTIONS(3917),
    [anon_sym_AMP] = ACTIONS(3919),
  },
  [3109] = {
    [sym__simple_heredoc_body] = ACTIONS(3923),
    [sym__heredoc_body_beginning] = ACTIONS(3923),
    [sym_file_descriptor] = ACTIONS(3923),
    [sym__concat] = ACTIONS(3923),
    [anon_sym_esac] = ACTIONS(3925),
    [anon_sym_PIPE] = ACTIONS(3925),
    [anon_sym_SEMI_SEMI] = ACTIONS(3925),
    [anon_sym_PIPE_AMP] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_GT] = ACTIONS(3925),
    [anon_sym_GT_GT] = ACTIONS(3925),
    [anon_sym_AMP_GT] = ACTIONS(3925),
    [anon_sym_AMP_GT_GT] = ACTIONS(3925),
    [anon_sym_LT_AMP] = ACTIONS(3925),
    [anon_sym_GT_AMP] = ACTIONS(3925),
    [anon_sym_LT_LT] = ACTIONS(3925),
    [anon_sym_LT_LT_DASH] = ACTIONS(3925),
    [anon_sym_LT_LT_LT] = ACTIONS(3925),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3925),
    [anon_sym_LF] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3925),
  },
  [3110] = {
    [sym__simple_heredoc_body] = ACTIONS(4008),
    [sym__heredoc_body_beginning] = ACTIONS(4008),
    [sym_file_descriptor] = ACTIONS(4008),
    [sym__concat] = ACTIONS(4008),
    [anon_sym_esac] = ACTIONS(4010),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_SEMI_SEMI] = ACTIONS(4010),
    [anon_sym_PIPE_AMP] = ACTIONS(4010),
    [anon_sym_AMP_AMP] = ACTIONS(4010),
    [anon_sym_PIPE_PIPE] = ACTIONS(4010),
    [anon_sym_LT] = ACTIONS(4010),
    [anon_sym_GT] = ACTIONS(4010),
    [anon_sym_GT_GT] = ACTIONS(4010),
    [anon_sym_AMP_GT] = ACTIONS(4010),
    [anon_sym_AMP_GT_GT] = ACTIONS(4010),
    [anon_sym_LT_AMP] = ACTIONS(4010),
    [anon_sym_GT_AMP] = ACTIONS(4010),
    [anon_sym_LT_LT] = ACTIONS(4010),
    [anon_sym_LT_LT_DASH] = ACTIONS(4010),
    [anon_sym_LT_LT_LT] = ACTIONS(4010),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LF] = ACTIONS(4008),
    [anon_sym_AMP] = ACTIONS(4010),
  },
  [3111] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7275),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3112] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(7277),
    [sym_comment] = ACTIONS(53),
  },
  [3113] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(7279),
    [sym_comment] = ACTIONS(53),
  },
  [3114] = {
    [anon_sym_RBRACE] = ACTIONS(7279),
    [sym_comment] = ACTIONS(53),
  },
  [3115] = {
    [sym_concatenation] = STATE(3163),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3163),
    [anon_sym_RBRACE] = ACTIONS(7281),
    [anon_sym_EQ] = ACTIONS(7283),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7285),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7283),
    [anon_sym_COLON_QMARK] = ACTIONS(7283),
    [anon_sym_COLON_DASH] = ACTIONS(7283),
    [anon_sym_PERCENT] = ACTIONS(7283),
    [anon_sym_DASH] = ACTIONS(7283),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3116] = {
    [sym__simple_heredoc_body] = ACTIONS(4024),
    [sym__heredoc_body_beginning] = ACTIONS(4024),
    [sym_file_descriptor] = ACTIONS(4024),
    [sym__concat] = ACTIONS(4024),
    [anon_sym_esac] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_SEMI_SEMI] = ACTIONS(4026),
    [anon_sym_PIPE_AMP] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4026),
    [anon_sym_PIPE_PIPE] = ACTIONS(4026),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_AMP_GT] = ACTIONS(4026),
    [anon_sym_AMP_GT_GT] = ACTIONS(4026),
    [anon_sym_LT_AMP] = ACTIONS(4026),
    [anon_sym_GT_AMP] = ACTIONS(4026),
    [anon_sym_LT_LT] = ACTIONS(4026),
    [anon_sym_LT_LT_DASH] = ACTIONS(4026),
    [anon_sym_LT_LT_LT] = ACTIONS(4026),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4026),
    [anon_sym_LF] = ACTIONS(4024),
    [anon_sym_AMP] = ACTIONS(4026),
  },
  [3117] = {
    [sym_concatenation] = STATE(3165),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3165),
    [anon_sym_RBRACE] = ACTIONS(7287),
    [anon_sym_EQ] = ACTIONS(7289),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7289),
    [anon_sym_COLON_QMARK] = ACTIONS(7289),
    [anon_sym_COLON_DASH] = ACTIONS(7289),
    [anon_sym_PERCENT] = ACTIONS(7289),
    [anon_sym_DASH] = ACTIONS(7289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3118] = {
    [sym__simple_heredoc_body] = ACTIONS(4034),
    [sym__heredoc_body_beginning] = ACTIONS(4034),
    [sym_file_descriptor] = ACTIONS(4034),
    [sym__concat] = ACTIONS(4034),
    [anon_sym_esac] = ACTIONS(4036),
    [anon_sym_PIPE] = ACTIONS(4036),
    [anon_sym_SEMI_SEMI] = ACTIONS(4036),
    [anon_sym_PIPE_AMP] = ACTIONS(4036),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4036),
    [anon_sym_GT] = ACTIONS(4036),
    [anon_sym_GT_GT] = ACTIONS(4036),
    [anon_sym_AMP_GT] = ACTIONS(4036),
    [anon_sym_AMP_GT_GT] = ACTIONS(4036),
    [anon_sym_LT_AMP] = ACTIONS(4036),
    [anon_sym_GT_AMP] = ACTIONS(4036),
    [anon_sym_LT_LT] = ACTIONS(4036),
    [anon_sym_LT_LT_DASH] = ACTIONS(4036),
    [anon_sym_LT_LT_LT] = ACTIONS(4036),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4036),
    [anon_sym_LF] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
  },
  [3119] = {
    [sym_concatenation] = STATE(3167),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3167),
    [anon_sym_RBRACE] = ACTIONS(7293),
    [anon_sym_EQ] = ACTIONS(7295),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7297),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7295),
    [anon_sym_COLON_QMARK] = ACTIONS(7295),
    [anon_sym_COLON_DASH] = ACTIONS(7295),
    [anon_sym_PERCENT] = ACTIONS(7295),
    [anon_sym_DASH] = ACTIONS(7295),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3120] = {
    [sym__simple_heredoc_body] = ACTIONS(4044),
    [sym__heredoc_body_beginning] = ACTIONS(4044),
    [sym_file_descriptor] = ACTIONS(4044),
    [sym__concat] = ACTIONS(4044),
    [anon_sym_esac] = ACTIONS(4046),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_SEMI_SEMI] = ACTIONS(4046),
    [anon_sym_PIPE_AMP] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4046),
    [anon_sym_PIPE_PIPE] = ACTIONS(4046),
    [anon_sym_LT] = ACTIONS(4046),
    [anon_sym_GT] = ACTIONS(4046),
    [anon_sym_GT_GT] = ACTIONS(4046),
    [anon_sym_AMP_GT] = ACTIONS(4046),
    [anon_sym_AMP_GT_GT] = ACTIONS(4046),
    [anon_sym_LT_AMP] = ACTIONS(4046),
    [anon_sym_GT_AMP] = ACTIONS(4046),
    [anon_sym_LT_LT] = ACTIONS(4046),
    [anon_sym_LT_LT_DASH] = ACTIONS(4046),
    [anon_sym_LT_LT_LT] = ACTIONS(4046),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4046),
    [anon_sym_LF] = ACTIONS(4044),
    [anon_sym_AMP] = ACTIONS(4046),
  },
  [3121] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7299),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3122] = {
    [sym__simple_heredoc_body] = ACTIONS(4050),
    [sym__heredoc_body_beginning] = ACTIONS(4050),
    [sym_file_descriptor] = ACTIONS(4050),
    [sym__concat] = ACTIONS(4050),
    [anon_sym_esac] = ACTIONS(4052),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_SEMI_SEMI] = ACTIONS(4052),
    [anon_sym_PIPE_AMP] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4052),
    [anon_sym_PIPE_PIPE] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_AMP_GT] = ACTIONS(4052),
    [anon_sym_AMP_GT_GT] = ACTIONS(4052),
    [anon_sym_LT_AMP] = ACTIONS(4052),
    [anon_sym_GT_AMP] = ACTIONS(4052),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_LT_LT_DASH] = ACTIONS(4052),
    [anon_sym_LT_LT_LT] = ACTIONS(4052),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4052),
    [anon_sym_LF] = ACTIONS(4050),
    [anon_sym_AMP] = ACTIONS(4052),
  },
  [3123] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7301),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3124] = {
    [sym_file_descriptor] = ACTIONS(4884),
    [sym__concat] = ACTIONS(4884),
    [sym_variable_name] = ACTIONS(4884),
    [anon_sym_esac] = ACTIONS(4886),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [anon_sym_PIPE_AMP] = ACTIONS(4886),
    [anon_sym_AMP_AMP] = ACTIONS(4886),
    [anon_sym_PIPE_PIPE] = ACTIONS(4886),
    [anon_sym_LT] = ACTIONS(4886),
    [anon_sym_GT] = ACTIONS(4886),
    [anon_sym_GT_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT_GT] = ACTIONS(4886),
    [anon_sym_LT_AMP] = ACTIONS(4886),
    [anon_sym_GT_AMP] = ACTIONS(4886),
    [sym__special_characters] = ACTIONS(4886),
    [anon_sym_DQUOTE] = ACTIONS(4886),
    [anon_sym_DOLLAR] = ACTIONS(4886),
    [sym_raw_string] = ACTIONS(4886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4886),
    [anon_sym_BQUOTE] = ACTIONS(4886),
    [anon_sym_LT_LPAREN] = ACTIONS(4886),
    [anon_sym_GT_LPAREN] = ACTIONS(4886),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4886),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [3125] = {
    [sym_file_descriptor] = ACTIONS(4888),
    [sym__concat] = ACTIONS(4888),
    [sym_variable_name] = ACTIONS(4888),
    [anon_sym_esac] = ACTIONS(4890),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [anon_sym_PIPE_AMP] = ACTIONS(4890),
    [anon_sym_AMP_AMP] = ACTIONS(4890),
    [anon_sym_PIPE_PIPE] = ACTIONS(4890),
    [anon_sym_LT] = ACTIONS(4890),
    [anon_sym_GT] = ACTIONS(4890),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT_GT] = ACTIONS(4890),
    [anon_sym_LT_AMP] = ACTIONS(4890),
    [anon_sym_GT_AMP] = ACTIONS(4890),
    [sym__special_characters] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4890),
    [anon_sym_DOLLAR] = ACTIONS(4890),
    [sym_raw_string] = ACTIONS(4890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4890),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_LT_LPAREN] = ACTIONS(4890),
    [anon_sym_GT_LPAREN] = ACTIONS(4890),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4890),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [3126] = {
    [sym_file_descriptor] = ACTIONS(4892),
    [sym__concat] = ACTIONS(4892),
    [sym_variable_name] = ACTIONS(4892),
    [anon_sym_esac] = ACTIONS(4894),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_SEMI_SEMI] = ACTIONS(4894),
    [anon_sym_PIPE_AMP] = ACTIONS(4894),
    [anon_sym_AMP_AMP] = ACTIONS(4894),
    [anon_sym_PIPE_PIPE] = ACTIONS(4894),
    [anon_sym_LT] = ACTIONS(4894),
    [anon_sym_GT] = ACTIONS(4894),
    [anon_sym_GT_GT] = ACTIONS(4894),
    [anon_sym_AMP_GT] = ACTIONS(4894),
    [anon_sym_AMP_GT_GT] = ACTIONS(4894),
    [anon_sym_LT_AMP] = ACTIONS(4894),
    [anon_sym_GT_AMP] = ACTIONS(4894),
    [sym__special_characters] = ACTIONS(4894),
    [anon_sym_DQUOTE] = ACTIONS(4894),
    [anon_sym_DOLLAR] = ACTIONS(4894),
    [sym_raw_string] = ACTIONS(4894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4894),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4894),
    [anon_sym_BQUOTE] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4894),
    [anon_sym_GT_LPAREN] = ACTIONS(4894),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(4894),
    [anon_sym_LF] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4894),
  },
  [3127] = {
    [sym_file_descriptor] = ACTIONS(4896),
    [sym__concat] = ACTIONS(4896),
    [sym_variable_name] = ACTIONS(4896),
    [anon_sym_esac] = ACTIONS(4898),
    [anon_sym_PIPE] = ACTIONS(4898),
    [anon_sym_SEMI_SEMI] = ACTIONS(4898),
    [anon_sym_PIPE_AMP] = ACTIONS(4898),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4898),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_GT_GT] = ACTIONS(4898),
    [anon_sym_AMP_GT] = ACTIONS(4898),
    [anon_sym_AMP_GT_GT] = ACTIONS(4898),
    [anon_sym_LT_AMP] = ACTIONS(4898),
    [anon_sym_GT_AMP] = ACTIONS(4898),
    [sym__special_characters] = ACTIONS(4898),
    [anon_sym_DQUOTE] = ACTIONS(4898),
    [anon_sym_DOLLAR] = ACTIONS(4898),
    [sym_raw_string] = ACTIONS(4898),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4898),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4898),
    [anon_sym_BQUOTE] = ACTIONS(4898),
    [anon_sym_LT_LPAREN] = ACTIONS(4898),
    [anon_sym_GT_LPAREN] = ACTIONS(4898),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4898),
    [anon_sym_SEMI] = ACTIONS(4898),
    [anon_sym_LF] = ACTIONS(4896),
    [anon_sym_AMP] = ACTIONS(4898),
  },
  [3128] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7303),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3129] = {
    [sym_file_descriptor] = ACTIONS(4902),
    [sym__concat] = ACTIONS(4902),
    [sym_variable_name] = ACTIONS(4902),
    [anon_sym_esac] = ACTIONS(4904),
    [anon_sym_PIPE] = ACTIONS(4904),
    [anon_sym_SEMI_SEMI] = ACTIONS(4904),
    [anon_sym_PIPE_AMP] = ACTIONS(4904),
    [anon_sym_AMP_AMP] = ACTIONS(4904),
    [anon_sym_PIPE_PIPE] = ACTIONS(4904),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_GT] = ACTIONS(4904),
    [anon_sym_GT_GT] = ACTIONS(4904),
    [anon_sym_AMP_GT] = ACTIONS(4904),
    [anon_sym_AMP_GT_GT] = ACTIONS(4904),
    [anon_sym_LT_AMP] = ACTIONS(4904),
    [anon_sym_GT_AMP] = ACTIONS(4904),
    [sym__special_characters] = ACTIONS(4904),
    [anon_sym_DQUOTE] = ACTIONS(4904),
    [anon_sym_DOLLAR] = ACTIONS(4904),
    [sym_raw_string] = ACTIONS(4904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4904),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4904),
    [anon_sym_BQUOTE] = ACTIONS(4904),
    [anon_sym_LT_LPAREN] = ACTIONS(4904),
    [anon_sym_GT_LPAREN] = ACTIONS(4904),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4904),
    [anon_sym_SEMI] = ACTIONS(4904),
    [anon_sym_LF] = ACTIONS(4902),
    [anon_sym_AMP] = ACTIONS(4904),
  },
  [3130] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7305),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3131] = {
    [sym_file_descriptor] = ACTIONS(4908),
    [sym__concat] = ACTIONS(4908),
    [sym_variable_name] = ACTIONS(4908),
    [anon_sym_esac] = ACTIONS(4910),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_SEMI_SEMI] = ACTIONS(4910),
    [anon_sym_PIPE_AMP] = ACTIONS(4910),
    [anon_sym_AMP_AMP] = ACTIONS(4910),
    [anon_sym_PIPE_PIPE] = ACTIONS(4910),
    [anon_sym_LT] = ACTIONS(4910),
    [anon_sym_GT] = ACTIONS(4910),
    [anon_sym_GT_GT] = ACTIONS(4910),
    [anon_sym_AMP_GT] = ACTIONS(4910),
    [anon_sym_AMP_GT_GT] = ACTIONS(4910),
    [anon_sym_LT_AMP] = ACTIONS(4910),
    [anon_sym_GT_AMP] = ACTIONS(4910),
    [sym__special_characters] = ACTIONS(4910),
    [anon_sym_DQUOTE] = ACTIONS(4910),
    [anon_sym_DOLLAR] = ACTIONS(4910),
    [sym_raw_string] = ACTIONS(4910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4910),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4910),
    [anon_sym_BQUOTE] = ACTIONS(4910),
    [anon_sym_LT_LPAREN] = ACTIONS(4910),
    [anon_sym_GT_LPAREN] = ACTIONS(4910),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4910),
    [anon_sym_SEMI] = ACTIONS(4910),
    [anon_sym_LF] = ACTIONS(4908),
    [anon_sym_AMP] = ACTIONS(4910),
  },
  [3132] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7307),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3133] = {
    [sym_file_descriptor] = ACTIONS(4914),
    [sym__concat] = ACTIONS(4914),
    [sym_variable_name] = ACTIONS(4914),
    [anon_sym_esac] = ACTIONS(4916),
    [anon_sym_PIPE] = ACTIONS(4916),
    [anon_sym_SEMI_SEMI] = ACTIONS(4916),
    [anon_sym_PIPE_AMP] = ACTIONS(4916),
    [anon_sym_AMP_AMP] = ACTIONS(4916),
    [anon_sym_PIPE_PIPE] = ACTIONS(4916),
    [anon_sym_LT] = ACTIONS(4916),
    [anon_sym_GT] = ACTIONS(4916),
    [anon_sym_GT_GT] = ACTIONS(4916),
    [anon_sym_AMP_GT] = ACTIONS(4916),
    [anon_sym_AMP_GT_GT] = ACTIONS(4916),
    [anon_sym_LT_AMP] = ACTIONS(4916),
    [anon_sym_GT_AMP] = ACTIONS(4916),
    [sym__special_characters] = ACTIONS(4916),
    [anon_sym_DQUOTE] = ACTIONS(4916),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(4916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4916),
    [anon_sym_BQUOTE] = ACTIONS(4916),
    [anon_sym_LT_LPAREN] = ACTIONS(4916),
    [anon_sym_GT_LPAREN] = ACTIONS(4916),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4916),
    [anon_sym_SEMI] = ACTIONS(4916),
    [anon_sym_LF] = ACTIONS(4914),
    [anon_sym_AMP] = ACTIONS(4916),
  },
  [3134] = {
    [sym_file_descriptor] = ACTIONS(4918),
    [sym__concat] = ACTIONS(4918),
    [sym_variable_name] = ACTIONS(4918),
    [anon_sym_esac] = ACTIONS(4920),
    [anon_sym_PIPE] = ACTIONS(4920),
    [anon_sym_SEMI_SEMI] = ACTIONS(4920),
    [anon_sym_PIPE_AMP] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [anon_sym_LT] = ACTIONS(4920),
    [anon_sym_GT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_AMP_GT] = ACTIONS(4920),
    [anon_sym_AMP_GT_GT] = ACTIONS(4920),
    [anon_sym_LT_AMP] = ACTIONS(4920),
    [anon_sym_GT_AMP] = ACTIONS(4920),
    [sym__special_characters] = ACTIONS(4920),
    [anon_sym_DQUOTE] = ACTIONS(4920),
    [anon_sym_DOLLAR] = ACTIONS(4920),
    [sym_raw_string] = ACTIONS(4920),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4920),
    [anon_sym_BQUOTE] = ACTIONS(4920),
    [anon_sym_LT_LPAREN] = ACTIONS(4920),
    [anon_sym_GT_LPAREN] = ACTIONS(4920),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(4920),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym_LF] = ACTIONS(4918),
    [anon_sym_AMP] = ACTIONS(4920),
  },
  [3135] = {
    [sym__concat] = ACTIONS(2752),
    [anon_sym_esac] = ACTIONS(2754),
    [anon_sym_PIPE] = ACTIONS(2754),
    [anon_sym_SEMI_SEMI] = ACTIONS(2754),
    [anon_sym_PIPE_AMP] = ACTIONS(2754),
    [anon_sym_AMP_AMP] = ACTIONS(2754),
    [anon_sym_PIPE_PIPE] = ACTIONS(2754),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_LF] = ACTIONS(2752),
    [anon_sym_AMP] = ACTIONS(2754),
  },
  [3136] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(7309),
    [sym_comment] = ACTIONS(53),
  },
  [3137] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(7311),
    [sym_comment] = ACTIONS(53),
  },
  [3138] = {
    [anon_sym_RBRACE] = ACTIONS(7311),
    [sym_comment] = ACTIONS(53),
  },
  [3139] = {
    [sym_concatenation] = STATE(3176),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3176),
    [anon_sym_RBRACE] = ACTIONS(7313),
    [anon_sym_EQ] = ACTIONS(7315),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7317),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7315),
    [anon_sym_COLON_QMARK] = ACTIONS(7315),
    [anon_sym_COLON_DASH] = ACTIONS(7315),
    [anon_sym_PERCENT] = ACTIONS(7315),
    [anon_sym_DASH] = ACTIONS(7315),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3140] = {
    [sym__concat] = ACTIONS(2830),
    [anon_sym_esac] = ACTIONS(2832),
    [anon_sym_PIPE] = ACTIONS(2832),
    [anon_sym_SEMI_SEMI] = ACTIONS(2832),
    [anon_sym_PIPE_AMP] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_PIPE_PIPE] = ACTIONS(2832),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2832),
    [anon_sym_LF] = ACTIONS(2830),
    [anon_sym_AMP] = ACTIONS(2832),
  },
  [3141] = {
    [sym_concatenation] = STATE(3179),
    [sym_string] = STATE(3178),
    [sym_simple_expansion] = STATE(3178),
    [sym_string_expansion] = STATE(3178),
    [sym_expansion] = STATE(3178),
    [sym_command_substitution] = STATE(3178),
    [sym_process_substitution] = STATE(3178),
    [anon_sym_RBRACE] = ACTIONS(7311),
    [sym__special_characters] = ACTIONS(7319),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [sym_raw_string] = ACTIONS(7321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1738),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LT_LPAREN] = ACTIONS(1742),
    [anon_sym_GT_LPAREN] = ACTIONS(1742),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(7321),
  },
  [3142] = {
    [sym__concat] = ACTIONS(2873),
    [anon_sym_esac] = ACTIONS(2875),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_SEMI_SEMI] = ACTIONS(2875),
    [anon_sym_PIPE_AMP] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LF] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2875),
  },
  [3143] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(7323),
  },
  [3144] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7325),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3145] = {
    [sym__concat] = ACTIONS(2881),
    [anon_sym_esac] = ACTIONS(2883),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_SEMI_SEMI] = ACTIONS(2883),
    [anon_sym_PIPE_AMP] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_LF] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
  },
  [3146] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(7327),
  },
  [3147] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7329),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3148] = {
    [sym_comment] = ACTIONS(177),
    [sym_regex_without_right_brace] = ACTIONS(7331),
  },
  [3149] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7311),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3150] = {
    [sym_concatenation] = STATE(3186),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3186),
    [anon_sym_RBRACE] = ACTIONS(7333),
    [anon_sym_EQ] = ACTIONS(7335),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7335),
    [anon_sym_COLON_QMARK] = ACTIONS(7335),
    [anon_sym_COLON_DASH] = ACTIONS(7335),
    [anon_sym_PERCENT] = ACTIONS(7335),
    [anon_sym_DASH] = ACTIONS(7335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3151] = {
    [sym__concat] = ACTIONS(2897),
    [anon_sym_esac] = ACTIONS(2899),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_SEMI_SEMI] = ACTIONS(2899),
    [anon_sym_PIPE_AMP] = ACTIONS(2899),
    [anon_sym_AMP_AMP] = ACTIONS(2899),
    [anon_sym_PIPE_PIPE] = ACTIONS(2899),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LF] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2899),
  },
  [3152] = {
    [sym_concatenation] = STATE(3188),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3188),
    [anon_sym_RBRACE] = ACTIONS(7339),
    [anon_sym_EQ] = ACTIONS(7341),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7343),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7341),
    [anon_sym_COLON_QMARK] = ACTIONS(7341),
    [anon_sym_COLON_DASH] = ACTIONS(7341),
    [anon_sym_PERCENT] = ACTIONS(7341),
    [anon_sym_DASH] = ACTIONS(7341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3153] = {
    [sym__concat] = ACTIONS(5540),
    [sym_variable_name] = ACTIONS(5540),
    [anon_sym_esac] = ACTIONS(5542),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [anon_sym_PIPE_AMP] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE] = ACTIONS(5542),
    [sym__special_characters] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [anon_sym_LT_LPAREN] = ACTIONS(5542),
    [anon_sym_GT_LPAREN] = ACTIONS(5542),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5542),
    [sym_word] = ACTIONS(5542),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [3154] = {
    [sym__concat] = ACTIONS(5544),
    [sym_variable_name] = ACTIONS(5544),
    [anon_sym_esac] = ACTIONS(5546),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_SEMI_SEMI] = ACTIONS(5546),
    [anon_sym_PIPE_AMP] = ACTIONS(5546),
    [anon_sym_AMP_AMP] = ACTIONS(5546),
    [anon_sym_PIPE_PIPE] = ACTIONS(5546),
    [sym__special_characters] = ACTIONS(5546),
    [anon_sym_DQUOTE] = ACTIONS(5546),
    [anon_sym_DOLLAR] = ACTIONS(5546),
    [sym_raw_string] = ACTIONS(5546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5546),
    [anon_sym_BQUOTE] = ACTIONS(5546),
    [anon_sym_LT_LPAREN] = ACTIONS(5546),
    [anon_sym_GT_LPAREN] = ACTIONS(5546),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5546),
    [sym_word] = ACTIONS(5546),
    [anon_sym_SEMI] = ACTIONS(5546),
    [anon_sym_LF] = ACTIONS(5544),
    [anon_sym_AMP] = ACTIONS(5546),
  },
  [3155] = {
    [sym__concat] = ACTIONS(5548),
    [sym_variable_name] = ACTIONS(5548),
    [anon_sym_esac] = ACTIONS(5550),
    [anon_sym_PIPE] = ACTIONS(5550),
    [anon_sym_SEMI_SEMI] = ACTIONS(5550),
    [anon_sym_PIPE_AMP] = ACTIONS(5550),
    [anon_sym_AMP_AMP] = ACTIONS(5550),
    [anon_sym_PIPE_PIPE] = ACTIONS(5550),
    [sym__special_characters] = ACTIONS(5550),
    [anon_sym_DQUOTE] = ACTIONS(5550),
    [anon_sym_DOLLAR] = ACTIONS(5550),
    [sym_raw_string] = ACTIONS(5550),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5550),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5550),
    [anon_sym_BQUOTE] = ACTIONS(5550),
    [anon_sym_LT_LPAREN] = ACTIONS(5550),
    [anon_sym_GT_LPAREN] = ACTIONS(5550),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5550),
    [sym_word] = ACTIONS(5550),
    [anon_sym_SEMI] = ACTIONS(5550),
    [anon_sym_LF] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
  },
  [3156] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_esac] = ACTIONS(5542),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [anon_sym_PIPE_AMP] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE] = ACTIONS(5542),
    [sym__special_characters] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [anon_sym_LT_LPAREN] = ACTIONS(5542),
    [anon_sym_GT_LPAREN] = ACTIONS(5542),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5542),
    [sym_word] = ACTIONS(5542),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [3157] = {
    [sym__concat] = ACTIONS(5544),
    [anon_sym_esac] = ACTIONS(5546),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_SEMI_SEMI] = ACTIONS(5546),
    [anon_sym_PIPE_AMP] = ACTIONS(5546),
    [anon_sym_AMP_AMP] = ACTIONS(5546),
    [anon_sym_PIPE_PIPE] = ACTIONS(5546),
    [sym__special_characters] = ACTIONS(5546),
    [anon_sym_DQUOTE] = ACTIONS(5546),
    [anon_sym_DOLLAR] = ACTIONS(5546),
    [sym_raw_string] = ACTIONS(5546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5546),
    [anon_sym_BQUOTE] = ACTIONS(5546),
    [anon_sym_LT_LPAREN] = ACTIONS(5546),
    [anon_sym_GT_LPAREN] = ACTIONS(5546),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5546),
    [sym_word] = ACTIONS(5546),
    [anon_sym_SEMI] = ACTIONS(5546),
    [anon_sym_LF] = ACTIONS(5544),
    [anon_sym_AMP] = ACTIONS(5546),
  },
  [3158] = {
    [sym__concat] = ACTIONS(5548),
    [anon_sym_esac] = ACTIONS(5550),
    [anon_sym_PIPE] = ACTIONS(5550),
    [anon_sym_SEMI_SEMI] = ACTIONS(5550),
    [anon_sym_PIPE_AMP] = ACTIONS(5550),
    [anon_sym_AMP_AMP] = ACTIONS(5550),
    [anon_sym_PIPE_PIPE] = ACTIONS(5550),
    [sym__special_characters] = ACTIONS(5550),
    [anon_sym_DQUOTE] = ACTIONS(5550),
    [anon_sym_DOLLAR] = ACTIONS(5550),
    [sym_raw_string] = ACTIONS(5550),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5550),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5550),
    [anon_sym_BQUOTE] = ACTIONS(5550),
    [anon_sym_LT_LPAREN] = ACTIONS(5550),
    [anon_sym_GT_LPAREN] = ACTIONS(5550),
    [sym_comment] = ACTIONS(177),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5550),
    [sym_word] = ACTIONS(5550),
    [anon_sym_SEMI] = ACTIONS(5550),
    [anon_sym_LF] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
  },
  [3159] = {
    [sym__simple_heredoc_body] = ACTIONS(4884),
    [sym__heredoc_body_beginning] = ACTIONS(4884),
    [sym_file_descriptor] = ACTIONS(4884),
    [sym__concat] = ACTIONS(4884),
    [anon_sym_esac] = ACTIONS(4886),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [anon_sym_PIPE_AMP] = ACTIONS(4886),
    [anon_sym_AMP_AMP] = ACTIONS(4886),
    [anon_sym_PIPE_PIPE] = ACTIONS(4886),
    [anon_sym_LT] = ACTIONS(4886),
    [anon_sym_GT] = ACTIONS(4886),
    [anon_sym_GT_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT] = ACTIONS(4886),
    [anon_sym_AMP_GT_GT] = ACTIONS(4886),
    [anon_sym_LT_AMP] = ACTIONS(4886),
    [anon_sym_GT_AMP] = ACTIONS(4886),
    [anon_sym_LT_LT] = ACTIONS(4886),
    [anon_sym_LT_LT_DASH] = ACTIONS(4886),
    [anon_sym_LT_LT_LT] = ACTIONS(4886),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [3160] = {
    [sym__simple_heredoc_body] = ACTIONS(4888),
    [sym__heredoc_body_beginning] = ACTIONS(4888),
    [sym_file_descriptor] = ACTIONS(4888),
    [sym__concat] = ACTIONS(4888),
    [anon_sym_esac] = ACTIONS(4890),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [anon_sym_PIPE_AMP] = ACTIONS(4890),
    [anon_sym_AMP_AMP] = ACTIONS(4890),
    [anon_sym_PIPE_PIPE] = ACTIONS(4890),
    [anon_sym_LT] = ACTIONS(4890),
    [anon_sym_GT] = ACTIONS(4890),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT] = ACTIONS(4890),
    [anon_sym_AMP_GT_GT] = ACTIONS(4890),
    [anon_sym_LT_AMP] = ACTIONS(4890),
    [anon_sym_GT_AMP] = ACTIONS(4890),
    [anon_sym_LT_LT] = ACTIONS(4890),
    [anon_sym_LT_LT_DASH] = ACTIONS(4890),
    [anon_sym_LT_LT_LT] = ACTIONS(4890),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [3161] = {
    [sym__simple_heredoc_body] = ACTIONS(4892),
    [sym__heredoc_body_beginning] = ACTIONS(4892),
    [sym_file_descriptor] = ACTIONS(4892),
    [sym__concat] = ACTIONS(4892),
    [anon_sym_esac] = ACTIONS(4894),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_SEMI_SEMI] = ACTIONS(4894),
    [anon_sym_PIPE_AMP] = ACTIONS(4894),
    [anon_sym_AMP_AMP] = ACTIONS(4894),
    [anon_sym_PIPE_PIPE] = ACTIONS(4894),
    [anon_sym_LT] = ACTIONS(4894),
    [anon_sym_GT] = ACTIONS(4894),
    [anon_sym_GT_GT] = ACTIONS(4894),
    [anon_sym_AMP_GT] = ACTIONS(4894),
    [anon_sym_AMP_GT_GT] = ACTIONS(4894),
    [anon_sym_LT_AMP] = ACTIONS(4894),
    [anon_sym_GT_AMP] = ACTIONS(4894),
    [anon_sym_LT_LT] = ACTIONS(4894),
    [anon_sym_LT_LT_DASH] = ACTIONS(4894),
    [anon_sym_LT_LT_LT] = ACTIONS(4894),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4894),
    [anon_sym_LF] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4894),
  },
  [3162] = {
    [sym__simple_heredoc_body] = ACTIONS(4896),
    [sym__heredoc_body_beginning] = ACTIONS(4896),
    [sym_file_descriptor] = ACTIONS(4896),
    [sym__concat] = ACTIONS(4896),
    [anon_sym_esac] = ACTIONS(4898),
    [anon_sym_PIPE] = ACTIONS(4898),
    [anon_sym_SEMI_SEMI] = ACTIONS(4898),
    [anon_sym_PIPE_AMP] = ACTIONS(4898),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(4898),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_GT_GT] = ACTIONS(4898),
    [anon_sym_AMP_GT] = ACTIONS(4898),
    [anon_sym_AMP_GT_GT] = ACTIONS(4898),
    [anon_sym_LT_AMP] = ACTIONS(4898),
    [anon_sym_GT_AMP] = ACTIONS(4898),
    [anon_sym_LT_LT] = ACTIONS(4898),
    [anon_sym_LT_LT_DASH] = ACTIONS(4898),
    [anon_sym_LT_LT_LT] = ACTIONS(4898),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4898),
    [anon_sym_LF] = ACTIONS(4896),
    [anon_sym_AMP] = ACTIONS(4898),
  },
  [3163] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7345),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3164] = {
    [sym__simple_heredoc_body] = ACTIONS(4902),
    [sym__heredoc_body_beginning] = ACTIONS(4902),
    [sym_file_descriptor] = ACTIONS(4902),
    [sym__concat] = ACTIONS(4902),
    [anon_sym_esac] = ACTIONS(4904),
    [anon_sym_PIPE] = ACTIONS(4904),
    [anon_sym_SEMI_SEMI] = ACTIONS(4904),
    [anon_sym_PIPE_AMP] = ACTIONS(4904),
    [anon_sym_AMP_AMP] = ACTIONS(4904),
    [anon_sym_PIPE_PIPE] = ACTIONS(4904),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_GT] = ACTIONS(4904),
    [anon_sym_GT_GT] = ACTIONS(4904),
    [anon_sym_AMP_GT] = ACTIONS(4904),
    [anon_sym_AMP_GT_GT] = ACTIONS(4904),
    [anon_sym_LT_AMP] = ACTIONS(4904),
    [anon_sym_GT_AMP] = ACTIONS(4904),
    [anon_sym_LT_LT] = ACTIONS(4904),
    [anon_sym_LT_LT_DASH] = ACTIONS(4904),
    [anon_sym_LT_LT_LT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4904),
    [anon_sym_LF] = ACTIONS(4902),
    [anon_sym_AMP] = ACTIONS(4904),
  },
  [3165] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7347),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3166] = {
    [sym__simple_heredoc_body] = ACTIONS(4908),
    [sym__heredoc_body_beginning] = ACTIONS(4908),
    [sym_file_descriptor] = ACTIONS(4908),
    [sym__concat] = ACTIONS(4908),
    [anon_sym_esac] = ACTIONS(4910),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_SEMI_SEMI] = ACTIONS(4910),
    [anon_sym_PIPE_AMP] = ACTIONS(4910),
    [anon_sym_AMP_AMP] = ACTIONS(4910),
    [anon_sym_PIPE_PIPE] = ACTIONS(4910),
    [anon_sym_LT] = ACTIONS(4910),
    [anon_sym_GT] = ACTIONS(4910),
    [anon_sym_GT_GT] = ACTIONS(4910),
    [anon_sym_AMP_GT] = ACTIONS(4910),
    [anon_sym_AMP_GT_GT] = ACTIONS(4910),
    [anon_sym_LT_AMP] = ACTIONS(4910),
    [anon_sym_GT_AMP] = ACTIONS(4910),
    [anon_sym_LT_LT] = ACTIONS(4910),
    [anon_sym_LT_LT_DASH] = ACTIONS(4910),
    [anon_sym_LT_LT_LT] = ACTIONS(4910),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4910),
    [anon_sym_LF] = ACTIONS(4908),
    [anon_sym_AMP] = ACTIONS(4910),
  },
  [3167] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7349),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3168] = {
    [sym__simple_heredoc_body] = ACTIONS(4914),
    [sym__heredoc_body_beginning] = ACTIONS(4914),
    [sym_file_descriptor] = ACTIONS(4914),
    [sym__concat] = ACTIONS(4914),
    [anon_sym_esac] = ACTIONS(4916),
    [anon_sym_PIPE] = ACTIONS(4916),
    [anon_sym_SEMI_SEMI] = ACTIONS(4916),
    [anon_sym_PIPE_AMP] = ACTIONS(4916),
    [anon_sym_AMP_AMP] = ACTIONS(4916),
    [anon_sym_PIPE_PIPE] = ACTIONS(4916),
    [anon_sym_LT] = ACTIONS(4916),
    [anon_sym_GT] = ACTIONS(4916),
    [anon_sym_GT_GT] = ACTIONS(4916),
    [anon_sym_AMP_GT] = ACTIONS(4916),
    [anon_sym_AMP_GT_GT] = ACTIONS(4916),
    [anon_sym_LT_AMP] = ACTIONS(4916),
    [anon_sym_GT_AMP] = ACTIONS(4916),
    [anon_sym_LT_LT] = ACTIONS(4916),
    [anon_sym_LT_LT_DASH] = ACTIONS(4916),
    [anon_sym_LT_LT_LT] = ACTIONS(4916),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4916),
    [anon_sym_LF] = ACTIONS(4914),
    [anon_sym_AMP] = ACTIONS(4916),
  },
  [3169] = {
    [sym__simple_heredoc_body] = ACTIONS(4918),
    [sym__heredoc_body_beginning] = ACTIONS(4918),
    [sym_file_descriptor] = ACTIONS(4918),
    [sym__concat] = ACTIONS(4918),
    [anon_sym_esac] = ACTIONS(4920),
    [anon_sym_PIPE] = ACTIONS(4920),
    [anon_sym_SEMI_SEMI] = ACTIONS(4920),
    [anon_sym_PIPE_AMP] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [anon_sym_LT] = ACTIONS(4920),
    [anon_sym_GT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_AMP_GT] = ACTIONS(4920),
    [anon_sym_AMP_GT_GT] = ACTIONS(4920),
    [anon_sym_LT_AMP] = ACTIONS(4920),
    [anon_sym_GT_AMP] = ACTIONS(4920),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_LT_LT_DASH] = ACTIONS(4920),
    [anon_sym_LT_LT_LT] = ACTIONS(4920),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym_LF] = ACTIONS(4918),
    [anon_sym_AMP] = ACTIONS(4920),
  },
  [3170] = {
    [sym_file_descriptor] = ACTIONS(5540),
    [sym__concat] = ACTIONS(5540),
    [sym_variable_name] = ACTIONS(5540),
    [anon_sym_esac] = ACTIONS(5542),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [anon_sym_PIPE_AMP] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE] = ACTIONS(5542),
    [anon_sym_LT] = ACTIONS(5542),
    [anon_sym_GT] = ACTIONS(5542),
    [anon_sym_GT_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT_GT] = ACTIONS(5542),
    [anon_sym_LT_AMP] = ACTIONS(5542),
    [anon_sym_GT_AMP] = ACTIONS(5542),
    [sym__special_characters] = ACTIONS(5542),
    [anon_sym_DQUOTE] = ACTIONS(5542),
    [anon_sym_DOLLAR] = ACTIONS(5542),
    [sym_raw_string] = ACTIONS(5542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5542),
    [anon_sym_BQUOTE] = ACTIONS(5542),
    [anon_sym_LT_LPAREN] = ACTIONS(5542),
    [anon_sym_GT_LPAREN] = ACTIONS(5542),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5542),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [3171] = {
    [sym_file_descriptor] = ACTIONS(5544),
    [sym__concat] = ACTIONS(5544),
    [sym_variable_name] = ACTIONS(5544),
    [anon_sym_esac] = ACTIONS(5546),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_SEMI_SEMI] = ACTIONS(5546),
    [anon_sym_PIPE_AMP] = ACTIONS(5546),
    [anon_sym_AMP_AMP] = ACTIONS(5546),
    [anon_sym_PIPE_PIPE] = ACTIONS(5546),
    [anon_sym_LT] = ACTIONS(5546),
    [anon_sym_GT] = ACTIONS(5546),
    [anon_sym_GT_GT] = ACTIONS(5546),
    [anon_sym_AMP_GT] = ACTIONS(5546),
    [anon_sym_AMP_GT_GT] = ACTIONS(5546),
    [anon_sym_LT_AMP] = ACTIONS(5546),
    [anon_sym_GT_AMP] = ACTIONS(5546),
    [sym__special_characters] = ACTIONS(5546),
    [anon_sym_DQUOTE] = ACTIONS(5546),
    [anon_sym_DOLLAR] = ACTIONS(5546),
    [sym_raw_string] = ACTIONS(5546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5546),
    [anon_sym_BQUOTE] = ACTIONS(5546),
    [anon_sym_LT_LPAREN] = ACTIONS(5546),
    [anon_sym_GT_LPAREN] = ACTIONS(5546),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5546),
    [anon_sym_SEMI] = ACTIONS(5546),
    [anon_sym_LF] = ACTIONS(5544),
    [anon_sym_AMP] = ACTIONS(5546),
  },
  [3172] = {
    [sym_file_descriptor] = ACTIONS(5548),
    [sym__concat] = ACTIONS(5548),
    [sym_variable_name] = ACTIONS(5548),
    [anon_sym_esac] = ACTIONS(5550),
    [anon_sym_PIPE] = ACTIONS(5550),
    [anon_sym_SEMI_SEMI] = ACTIONS(5550),
    [anon_sym_PIPE_AMP] = ACTIONS(5550),
    [anon_sym_AMP_AMP] = ACTIONS(5550),
    [anon_sym_PIPE_PIPE] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5550),
    [anon_sym_GT] = ACTIONS(5550),
    [anon_sym_GT_GT] = ACTIONS(5550),
    [anon_sym_AMP_GT] = ACTIONS(5550),
    [anon_sym_AMP_GT_GT] = ACTIONS(5550),
    [anon_sym_LT_AMP] = ACTIONS(5550),
    [anon_sym_GT_AMP] = ACTIONS(5550),
    [sym__special_characters] = ACTIONS(5550),
    [anon_sym_DQUOTE] = ACTIONS(5550),
    [anon_sym_DOLLAR] = ACTIONS(5550),
    [sym_raw_string] = ACTIONS(5550),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5550),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5550),
    [anon_sym_BQUOTE] = ACTIONS(5550),
    [anon_sym_LT_LPAREN] = ACTIONS(5550),
    [anon_sym_GT_LPAREN] = ACTIONS(5550),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(5550),
    [anon_sym_SEMI] = ACTIONS(5550),
    [anon_sym_LF] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
  },
  [3173] = {
    [sym__concat] = ACTIONS(3917),
    [anon_sym_esac] = ACTIONS(3919),
    [anon_sym_PIPE] = ACTIONS(3919),
    [anon_sym_SEMI_SEMI] = ACTIONS(3919),
    [anon_sym_PIPE_AMP] = ACTIONS(3919),
    [anon_sym_AMP_AMP] = ACTIONS(3919),
    [anon_sym_PIPE_PIPE] = ACTIONS(3919),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3919),
    [anon_sym_LF] = ACTIONS(3917),
    [anon_sym_AMP] = ACTIONS(3919),
  },
  [3174] = {
    [sym__concat] = ACTIONS(3923),
    [anon_sym_esac] = ACTIONS(3925),
    [anon_sym_PIPE] = ACTIONS(3925),
    [anon_sym_SEMI_SEMI] = ACTIONS(3925),
    [anon_sym_PIPE_AMP] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(3925),
    [anon_sym_LF] = ACTIONS(3923),
    [anon_sym_AMP] = ACTIONS(3925),
  },
  [3175] = {
    [sym__concat] = ACTIONS(4008),
    [anon_sym_esac] = ACTIONS(4010),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_SEMI_SEMI] = ACTIONS(4010),
    [anon_sym_PIPE_AMP] = ACTIONS(4010),
    [anon_sym_AMP_AMP] = ACTIONS(4010),
    [anon_sym_PIPE_PIPE] = ACTIONS(4010),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_LF] = ACTIONS(4008),
    [anon_sym_AMP] = ACTIONS(4010),
  },
  [3176] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7351),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3177] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(7353),
    [sym_comment] = ACTIONS(53),
  },
  [3178] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [sym__concat] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(7355),
    [sym_comment] = ACTIONS(53),
  },
  [3179] = {
    [anon_sym_RBRACE] = ACTIONS(7355),
    [sym_comment] = ACTIONS(53),
  },
  [3180] = {
    [sym_concatenation] = STATE(3196),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3196),
    [anon_sym_RBRACE] = ACTIONS(7357),
    [anon_sym_EQ] = ACTIONS(7359),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7361),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7359),
    [anon_sym_COLON_QMARK] = ACTIONS(7359),
    [anon_sym_COLON_DASH] = ACTIONS(7359),
    [anon_sym_PERCENT] = ACTIONS(7359),
    [anon_sym_DASH] = ACTIONS(7359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3181] = {
    [sym__concat] = ACTIONS(4024),
    [anon_sym_esac] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4026),
    [anon_sym_SEMI_SEMI] = ACTIONS(4026),
    [anon_sym_PIPE_AMP] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4026),
    [anon_sym_PIPE_PIPE] = ACTIONS(4026),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4026),
    [anon_sym_LF] = ACTIONS(4024),
    [anon_sym_AMP] = ACTIONS(4026),
  },
  [3182] = {
    [sym_concatenation] = STATE(3198),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3198),
    [anon_sym_RBRACE] = ACTIONS(7363),
    [anon_sym_EQ] = ACTIONS(7365),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7367),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7365),
    [anon_sym_COLON_QMARK] = ACTIONS(7365),
    [anon_sym_COLON_DASH] = ACTIONS(7365),
    [anon_sym_PERCENT] = ACTIONS(7365),
    [anon_sym_DASH] = ACTIONS(7365),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3183] = {
    [sym__concat] = ACTIONS(4034),
    [anon_sym_esac] = ACTIONS(4036),
    [anon_sym_PIPE] = ACTIONS(4036),
    [anon_sym_SEMI_SEMI] = ACTIONS(4036),
    [anon_sym_PIPE_AMP] = ACTIONS(4036),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4036),
    [anon_sym_LF] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
  },
  [3184] = {
    [sym_concatenation] = STATE(3200),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(3200),
    [anon_sym_RBRACE] = ACTIONS(7369),
    [anon_sym_EQ] = ACTIONS(7371),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(7373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(7371),
    [anon_sym_COLON_QMARK] = ACTIONS(7371),
    [anon_sym_COLON_DASH] = ACTIONS(7371),
    [anon_sym_PERCENT] = ACTIONS(7371),
    [anon_sym_DASH] = ACTIONS(7371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3185] = {
    [sym__concat] = ACTIONS(4044),
    [anon_sym_esac] = ACTIONS(4046),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_SEMI_SEMI] = ACTIONS(4046),
    [anon_sym_PIPE_AMP] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4046),
    [anon_sym_PIPE_PIPE] = ACTIONS(4046),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4046),
    [anon_sym_LF] = ACTIONS(4044),
    [anon_sym_AMP] = ACTIONS(4046),
  },
  [3186] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7375),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3187] = {
    [sym__concat] = ACTIONS(4050),
    [anon_sym_esac] = ACTIONS(4052),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_SEMI_SEMI] = ACTIONS(4052),
    [anon_sym_PIPE_AMP] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4052),
    [anon_sym_PIPE_PIPE] = ACTIONS(4052),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4052),
    [anon_sym_LF] = ACTIONS(4050),
    [anon_sym_AMP] = ACTIONS(4052),
  },
  [3188] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7377),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3189] = {
    [sym__simple_heredoc_body] = ACTIONS(5540),
    [sym__heredoc_body_beginning] = ACTIONS(5540),
    [sym_file_descriptor] = ACTIONS(5540),
    [sym__concat] = ACTIONS(5540),
    [anon_sym_esac] = ACTIONS(5542),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [anon_sym_PIPE_AMP] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE] = ACTIONS(5542),
    [anon_sym_LT] = ACTIONS(5542),
    [anon_sym_GT] = ACTIONS(5542),
    [anon_sym_GT_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT] = ACTIONS(5542),
    [anon_sym_AMP_GT_GT] = ACTIONS(5542),
    [anon_sym_LT_AMP] = ACTIONS(5542),
    [anon_sym_GT_AMP] = ACTIONS(5542),
    [anon_sym_LT_LT] = ACTIONS(5542),
    [anon_sym_LT_LT_DASH] = ACTIONS(5542),
    [anon_sym_LT_LT_LT] = ACTIONS(5542),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [3190] = {
    [sym__simple_heredoc_body] = ACTIONS(5544),
    [sym__heredoc_body_beginning] = ACTIONS(5544),
    [sym_file_descriptor] = ACTIONS(5544),
    [sym__concat] = ACTIONS(5544),
    [anon_sym_esac] = ACTIONS(5546),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_SEMI_SEMI] = ACTIONS(5546),
    [anon_sym_PIPE_AMP] = ACTIONS(5546),
    [anon_sym_AMP_AMP] = ACTIONS(5546),
    [anon_sym_PIPE_PIPE] = ACTIONS(5546),
    [anon_sym_LT] = ACTIONS(5546),
    [anon_sym_GT] = ACTIONS(5546),
    [anon_sym_GT_GT] = ACTIONS(5546),
    [anon_sym_AMP_GT] = ACTIONS(5546),
    [anon_sym_AMP_GT_GT] = ACTIONS(5546),
    [anon_sym_LT_AMP] = ACTIONS(5546),
    [anon_sym_GT_AMP] = ACTIONS(5546),
    [anon_sym_LT_LT] = ACTIONS(5546),
    [anon_sym_LT_LT_DASH] = ACTIONS(5546),
    [anon_sym_LT_LT_LT] = ACTIONS(5546),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5546),
    [anon_sym_LF] = ACTIONS(5544),
    [anon_sym_AMP] = ACTIONS(5546),
  },
  [3191] = {
    [sym__simple_heredoc_body] = ACTIONS(5548),
    [sym__heredoc_body_beginning] = ACTIONS(5548),
    [sym_file_descriptor] = ACTIONS(5548),
    [sym__concat] = ACTIONS(5548),
    [anon_sym_esac] = ACTIONS(5550),
    [anon_sym_PIPE] = ACTIONS(5550),
    [anon_sym_SEMI_SEMI] = ACTIONS(5550),
    [anon_sym_PIPE_AMP] = ACTIONS(5550),
    [anon_sym_AMP_AMP] = ACTIONS(5550),
    [anon_sym_PIPE_PIPE] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5550),
    [anon_sym_GT] = ACTIONS(5550),
    [anon_sym_GT_GT] = ACTIONS(5550),
    [anon_sym_AMP_GT] = ACTIONS(5550),
    [anon_sym_AMP_GT_GT] = ACTIONS(5550),
    [anon_sym_LT_AMP] = ACTIONS(5550),
    [anon_sym_GT_AMP] = ACTIONS(5550),
    [anon_sym_LT_LT] = ACTIONS(5550),
    [anon_sym_LT_LT_DASH] = ACTIONS(5550),
    [anon_sym_LT_LT_LT] = ACTIONS(5550),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5550),
    [anon_sym_LF] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
  },
  [3192] = {
    [sym__concat] = ACTIONS(4884),
    [anon_sym_esac] = ACTIONS(4886),
    [anon_sym_PIPE] = ACTIONS(4886),
    [anon_sym_SEMI_SEMI] = ACTIONS(4886),
    [anon_sym_PIPE_AMP] = ACTIONS(4886),
    [anon_sym_AMP_AMP] = ACTIONS(4886),
    [anon_sym_PIPE_PIPE] = ACTIONS(4886),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_AMP] = ACTIONS(4886),
  },
  [3193] = {
    [sym__concat] = ACTIONS(4888),
    [anon_sym_esac] = ACTIONS(4890),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_SEMI_SEMI] = ACTIONS(4890),
    [anon_sym_PIPE_AMP] = ACTIONS(4890),
    [anon_sym_AMP_AMP] = ACTIONS(4890),
    [anon_sym_PIPE_PIPE] = ACTIONS(4890),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4890),
    [anon_sym_LF] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
  },
  [3194] = {
    [sym__concat] = ACTIONS(4892),
    [anon_sym_esac] = ACTIONS(4894),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_SEMI_SEMI] = ACTIONS(4894),
    [anon_sym_PIPE_AMP] = ACTIONS(4894),
    [anon_sym_AMP_AMP] = ACTIONS(4894),
    [anon_sym_PIPE_PIPE] = ACTIONS(4894),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4894),
    [anon_sym_LF] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4894),
  },
  [3195] = {
    [sym__concat] = ACTIONS(4896),
    [anon_sym_esac] = ACTIONS(4898),
    [anon_sym_PIPE] = ACTIONS(4898),
    [anon_sym_SEMI_SEMI] = ACTIONS(4898),
    [anon_sym_PIPE_AMP] = ACTIONS(4898),
    [anon_sym_AMP_AMP] = ACTIONS(4898),
    [anon_sym_PIPE_PIPE] = ACTIONS(4898),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4898),
    [anon_sym_LF] = ACTIONS(4896),
    [anon_sym_AMP] = ACTIONS(4898),
  },
  [3196] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7379),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3197] = {
    [sym__concat] = ACTIONS(4902),
    [anon_sym_esac] = ACTIONS(4904),
    [anon_sym_PIPE] = ACTIONS(4904),
    [anon_sym_SEMI_SEMI] = ACTIONS(4904),
    [anon_sym_PIPE_AMP] = ACTIONS(4904),
    [anon_sym_AMP_AMP] = ACTIONS(4904),
    [anon_sym_PIPE_PIPE] = ACTIONS(4904),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4904),
    [anon_sym_LF] = ACTIONS(4902),
    [anon_sym_AMP] = ACTIONS(4904),
  },
  [3198] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7381),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3199] = {
    [sym__concat] = ACTIONS(4908),
    [anon_sym_esac] = ACTIONS(4910),
    [anon_sym_PIPE] = ACTIONS(4910),
    [anon_sym_SEMI_SEMI] = ACTIONS(4910),
    [anon_sym_PIPE_AMP] = ACTIONS(4910),
    [anon_sym_AMP_AMP] = ACTIONS(4910),
    [anon_sym_PIPE_PIPE] = ACTIONS(4910),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4910),
    [anon_sym_LF] = ACTIONS(4908),
    [anon_sym_AMP] = ACTIONS(4910),
  },
  [3200] = {
    [sym_concatenation] = STATE(839),
    [sym_string] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_process_substitution] = STATE(413),
    [aux_sym_expansion_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(7383),
    [anon_sym_EQ] = ACTIONS(1782),
    [sym__special_characters] = ACTIONS(747),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(753),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1782),
    [anon_sym_COLON_QMARK] = ACTIONS(1782),
    [anon_sym_COLON_DASH] = ACTIONS(1782),
    [anon_sym_PERCENT] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(761),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(177),
    [sym_word] = ACTIONS(767),
  },
  [3201] = {
    [sym__concat] = ACTIONS(4914),
    [anon_sym_esac] = ACTIONS(4916),
    [anon_sym_PIPE] = ACTIONS(4916),
    [anon_sym_SEMI_SEMI] = ACTIONS(4916),
    [anon_sym_PIPE_AMP] = ACTIONS(4916),
    [anon_sym_AMP_AMP] = ACTIONS(4916),
    [anon_sym_PIPE_PIPE] = ACTIONS(4916),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4916),
    [anon_sym_LF] = ACTIONS(4914),
    [anon_sym_AMP] = ACTIONS(4916),
  },
  [3202] = {
    [sym__concat] = ACTIONS(4918),
    [anon_sym_esac] = ACTIONS(4920),
    [anon_sym_PIPE] = ACTIONS(4920),
    [anon_sym_SEMI_SEMI] = ACTIONS(4920),
    [anon_sym_PIPE_AMP] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym_LF] = ACTIONS(4918),
    [anon_sym_AMP] = ACTIONS(4920),
  },
  [3203] = {
    [sym__concat] = ACTIONS(5540),
    [anon_sym_esac] = ACTIONS(5542),
    [anon_sym_PIPE] = ACTIONS(5542),
    [anon_sym_SEMI_SEMI] = ACTIONS(5542),
    [anon_sym_PIPE_AMP] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE] = ACTIONS(5542),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_LF] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5542),
  },
  [3204] = {
    [sym__concat] = ACTIONS(5544),
    [anon_sym_esac] = ACTIONS(5546),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_SEMI_SEMI] = ACTIONS(5546),
    [anon_sym_PIPE_AMP] = ACTIONS(5546),
    [anon_sym_AMP_AMP] = ACTIONS(5546),
    [anon_sym_PIPE_PIPE] = ACTIONS(5546),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5546),
    [anon_sym_LF] = ACTIONS(5544),
    [anon_sym_AMP] = ACTIONS(5546),
  },
  [3205] = {
    [sym__concat] = ACTIONS(5548),
    [anon_sym_esac] = ACTIONS(5550),
    [anon_sym_PIPE] = ACTIONS(5550),
    [anon_sym_SEMI_SEMI] = ACTIONS(5550),
    [anon_sym_PIPE_AMP] = ACTIONS(5550),
    [anon_sym_AMP_AMP] = ACTIONS(5550),
    [anon_sym_PIPE_PIPE] = ACTIONS(5550),
    [sym_comment] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(5550),
    [anon_sym_LF] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = true}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, RECOVER(),
  [5] = {.count = 1, .reusable = true}, SHIFT(2),
  [7] = {.count = 1, .reusable = true}, SHIFT(3),
  [9] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [11] = {.count = 1, .reusable = false}, SHIFT(4),
  [13] = {.count = 1, .reusable = false}, SHIFT(5),
  [15] = {.count = 1, .reusable = false}, SHIFT(6),
  [17] = {.count = 1, .reusable = false}, SHIFT(7),
  [19] = {.count = 1, .reusable = false}, SHIFT(8),
  [21] = {.count = 1, .reusable = true}, SHIFT(9),
  [23] = {.count = 1, .reusable = false}, SHIFT(10),
  [25] = {.count = 1, .reusable = false}, SHIFT(11),
  [27] = {.count = 1, .reusable = true}, SHIFT(12),
  [29] = {.count = 1, .reusable = false}, SHIFT(13),
  [31] = {.count = 1, .reusable = false}, SHIFT(14),
  [33] = {.count = 1, .reusable = false}, SHIFT(15),
  [35] = {.count = 1, .reusable = true}, SHIFT(15),
  [37] = {.count = 1, .reusable = false}, SHIFT(16),
  [39] = {.count = 1, .reusable = true}, SHIFT(17),
  [41] = {.count = 1, .reusable = false}, SHIFT(18),
  [43] = {.count = 1, .reusable = true}, SHIFT(19),
  [45] = {.count = 1, .reusable = true}, SHIFT(20),
  [47] = {.count = 1, .reusable = true}, SHIFT(21),
  [49] = {.count = 1, .reusable = true}, SHIFT(22),
  [51] = {.count = 1, .reusable = true}, SHIFT(23),
  [53] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [55] = {.count = 1, .reusable = false}, SHIFT(24),
  [57] = {.count = 1, .reusable = false}, SHIFT(34),
  [59] = {.count = 1, .reusable = true}, SHIFT(34),
  [61] = {.count = 1, .reusable = true}, SHIFT(35),
  [63] = {.count = 1, .reusable = true}, SHIFT(36),
  [65] = {.count = 1, .reusable = true}, SHIFT(37),
  [67] = {.count = 1, .reusable = true}, SHIFT(42),
  [69] = {.count = 1, .reusable = true}, SHIFT(43),
  [71] = {.count = 1, .reusable = false}, SHIFT(44),
  [73] = {.count = 1, .reusable = true}, SHIFT(45),
  [75] = {.count = 1, .reusable = true}, SHIFT(46),
  [77] = {.count = 1, .reusable = true}, SHIFT(47),
  [79] = {.count = 1, .reusable = true}, SHIFT(48),
  [81] = {.count = 1, .reusable = true}, SHIFT(49),
  [83] = {.count = 1, .reusable = true}, SHIFT(51),
  [85] = {.count = 1, .reusable = true}, SHIFT(52),
  [87] = {.count = 1, .reusable = false}, SHIFT(53),
  [89] = {.count = 1, .reusable = false}, SHIFT(54),
  [91] = {.count = 1, .reusable = false}, SHIFT(55),
  [93] = {.count = 1, .reusable = false}, SHIFT(56),
  [95] = {.count = 1, .reusable = true}, SHIFT(57),
  [97] = {.count = 1, .reusable = false}, SHIFT(58),
  [99] = {.count = 1, .reusable = false}, SHIFT(59),
  [101] = {.count = 1, .reusable = false}, SHIFT(60),
  [103] = {.count = 1, .reusable = true}, SHIFT(61),
  [105] = {.count = 1, .reusable = false}, SHIFT(62),
  [107] = {.count = 1, .reusable = true}, SHIFT(69),
  [109] = {.count = 1, .reusable = true}, SHIFT(72),
  [111] = {.count = 1, .reusable = false}, SHIFT(73),
  [113] = {.count = 1, .reusable = true}, SHIFT(74),
  [115] = {.count = 1, .reusable = true}, SHIFT(75),
  [117] = {.count = 1, .reusable = false}, SHIFT(76),
  [119] = {.count = 1, .reusable = true}, SHIFT(77),
  [121] = {.count = 1, .reusable = true}, SHIFT(78),
  [123] = {.count = 1, .reusable = true}, SHIFT(79),
  [125] = {.count = 1, .reusable = true}, SHIFT(80),
  [127] = {.count = 1, .reusable = true}, SHIFT(81),
  [129] = {.count = 1, .reusable = false}, SHIFT(77),
  [131] = {.count = 1, .reusable = true}, SHIFT(73),
  [133] = {.count = 1, .reusable = true}, SHIFT(83),
  [135] = {.count = 1, .reusable = false}, SHIFT(84),
  [137] = {.count = 1, .reusable = true}, SHIFT(85),
  [139] = {.count = 1, .reusable = true}, SHIFT(86),
  [141] = {.count = 1, .reusable = false}, SHIFT(87),
  [143] = {.count = 1, .reusable = true}, SHIFT(88),
  [145] = {.count = 1, .reusable = true}, SHIFT(89),
  [147] = {.count = 1, .reusable = true}, SHIFT(90),
  [149] = {.count = 1, .reusable = true}, SHIFT(91),
  [151] = {.count = 1, .reusable = true}, SHIFT(92),
  [153] = {.count = 1, .reusable = false}, SHIFT(88),
  [155] = {.count = 1, .reusable = true}, SHIFT(84),
  [157] = {.count = 1, .reusable = true}, SHIFT(94),
  [159] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 1),
  [161] = {.count = 1, .reusable = false}, SHIFT(95),
  [163] = {.count = 1, .reusable = false}, SHIFT(96),
  [165] = {.count = 1, .reusable = false}, SHIFT(97),
  [167] = {.count = 1, .reusable = false}, SHIFT(98),
  [169] = {.count = 1, .reusable = false}, SHIFT(99),
  [171] = {.count = 1, .reusable = false}, SHIFT(100),
  [173] = {.count = 1, .reusable = false}, SHIFT(101),
  [175] = {.count = 1, .reusable = false}, SHIFT(102),
  [177] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [179] = {.count = 1, .reusable = false}, SHIFT(103),
  [181] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 1),
  [183] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 1),
  [185] = {.count = 1, .reusable = false}, SHIFT(106),
  [187] = {.count = 1, .reusable = false}, SHIFT(107),
  [189] = {.count = 1, .reusable = false}, SHIFT(108),
  [191] = {.count = 1, .reusable = false}, SHIFT(109),
  [193] = {.count = 1, .reusable = false}, SHIFT(110),
  [195] = {.count = 1, .reusable = false}, SHIFT(111),
  [197] = {.count = 1, .reusable = false}, SHIFT(112),
  [199] = {.count = 1, .reusable = false}, SHIFT(113),
  [201] = {.count = 1, .reusable = false}, SHIFT(114),
  [203] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 1),
  [205] = {.count = 1, .reusable = true}, SHIFT(116),
  [207] = {.count = 1, .reusable = true}, SHIFT(117),
  [209] = {.count = 1, .reusable = false}, SHIFT(118),
  [211] = {.count = 1, .reusable = true}, SHIFT(119),
  [213] = {.count = 1, .reusable = true}, SHIFT(120),
  [215] = {.count = 1, .reusable = true}, SHIFT(121),
  [217] = {.count = 1, .reusable = true}, SHIFT(122),
  [219] = {.count = 1, .reusable = true}, SHIFT(123),
  [221] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [223] = {.count = 1, .reusable = true}, SHIFT(125),
  [225] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [227] = {.count = 1, .reusable = false}, SHIFT(127),
  [229] = {.count = 1, .reusable = false}, SHIFT(128),
  [231] = {.count = 1, .reusable = true}, SHIFT(129),
  [233] = {.count = 1, .reusable = false}, SHIFT(130),
  [235] = {.count = 1, .reusable = false}, SHIFT(131),
  [237] = {.count = 1, .reusable = false}, SHIFT(132),
  [239] = {.count = 1, .reusable = true}, SHIFT(134),
  [241] = {.count = 1, .reusable = true}, SHIFT(135),
  [243] = {.count = 1, .reusable = false}, SHIFT(136),
  [245] = {.count = 1, .reusable = false}, SHIFT(134),
  [247] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1),
  [249] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1),
  [251] = {.count = 1, .reusable = true}, SHIFT(137),
  [253] = {.count = 1, .reusable = true}, SHIFT(138),
  [255] = {.count = 1, .reusable = true}, SHIFT(139),
  [257] = {.count = 1, .reusable = false}, SHIFT(140),
  [259] = {.count = 1, .reusable = false}, SHIFT(138),
  [261] = {.count = 1, .reusable = true}, SHIFT(142),
  [263] = {.count = 1, .reusable = false}, SHIFT(143),
  [265] = {.count = 1, .reusable = false}, SHIFT(144),
  [267] = {.count = 1, .reusable = false}, SHIFT(145),
  [269] = {.count = 1, .reusable = false}, SHIFT(146),
  [271] = {.count = 1, .reusable = false}, SHIFT(147),
  [273] = {.count = 1, .reusable = true}, SHIFT(148),
  [275] = {.count = 1, .reusable = false}, SHIFT(149),
  [277] = {.count = 1, .reusable = false}, SHIFT(150),
  [279] = {.count = 1, .reusable = true}, SHIFT(151),
  [281] = {.count = 1, .reusable = false}, SHIFT(152),
  [283] = {.count = 1, .reusable = false}, SHIFT(153),
  [285] = {.count = 1, .reusable = false}, SHIFT(154),
  [287] = {.count = 1, .reusable = true}, SHIFT(155),
  [289] = {.count = 1, .reusable = false}, SHIFT(156),
  [291] = {.count = 1, .reusable = true}, SHIFT(157),
  [293] = {.count = 1, .reusable = true}, SHIFT(158),
  [295] = {.count = 1, .reusable = true}, SHIFT(159),
  [297] = {.count = 1, .reusable = true}, SHIFT(160),
  [299] = {.count = 1, .reusable = true}, SHIFT(161),
  [301] = {.count = 1, .reusable = false}, SHIFT(162),
  [303] = {.count = 1, .reusable = true}, SHIFT(169),
  [305] = {.count = 1, .reusable = false}, SHIFT(170),
  [307] = {.count = 1, .reusable = false}, SHIFT(171),
  [309] = {.count = 1, .reusable = false}, SHIFT(172),
  [311] = {.count = 1, .reusable = false}, SHIFT(173),
  [313] = {.count = 1, .reusable = true}, SHIFT(174),
  [315] = {.count = 1, .reusable = false}, SHIFT(175),
  [317] = {.count = 1, .reusable = false}, SHIFT(176),
  [319] = {.count = 1, .reusable = false}, SHIFT(177),
  [321] = {.count = 1, .reusable = true}, SHIFT(178),
  [323] = {.count = 1, .reusable = false}, SHIFT(179),
  [325] = {.count = 1, .reusable = false}, SHIFT(187),
  [327] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [329] = {.count = 1, .reusable = false}, SHIFT(188),
  [331] = {.count = 1, .reusable = false}, SHIFT(189),
  [333] = {.count = 1, .reusable = false}, SHIFT(190),
  [335] = {.count = 1, .reusable = true}, SHIFT(189),
  [337] = {.count = 1, .reusable = true}, SHIFT(191),
  [339] = {.count = 1, .reusable = true}, SHIFT(192),
  [341] = {.count = 1, .reusable = true}, SHIFT(193),
  [343] = {.count = 1, .reusable = false}, REDUCE(sym_command, 1),
  [345] = {.count = 1, .reusable = false}, SHIFT(194),
  [347] = {.count = 1, .reusable = false}, SHIFT(195),
  [349] = {.count = 1, .reusable = false}, SHIFT(196),
  [351] = {.count = 1, .reusable = false}, SHIFT(197),
  [353] = {.count = 1, .reusable = false}, SHIFT(198),
  [355] = {.count = 1, .reusable = false}, SHIFT(17),
  [357] = {.count = 1, .reusable = false}, SHIFT(199),
  [359] = {.count = 1, .reusable = false}, SHIFT(20),
  [361] = {.count = 1, .reusable = false}, SHIFT(21),
  [363] = {.count = 1, .reusable = false}, SHIFT(22),
  [365] = {.count = 1, .reusable = false}, SHIFT(23),
  [367] = {.count = 1, .reusable = true}, REDUCE(sym_command, 1),
  [369] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 1),
  [371] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 1),
  [373] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [375] = {.count = 1, .reusable = true}, SHIFT(16),
  [377] = {.count = 1, .reusable = true}, SHIFT(206),
  [379] = {.count = 1, .reusable = true}, SHIFT(207),
  [381] = {.count = 1, .reusable = true}, SHIFT(209),
  [383] = {.count = 1, .reusable = true}, SHIFT(210),
  [385] = {.count = 1, .reusable = true}, SHIFT(212),
  [387] = {.count = 1, .reusable = true}, SHIFT(213),
  [389] = {.count = 1, .reusable = true}, SHIFT(214),
  [391] = {.count = 1, .reusable = true}, SHIFT(215),
  [393] = {.count = 1, .reusable = false}, SHIFT(216),
  [395] = {.count = 1, .reusable = true}, SHIFT(217),
  [397] = {.count = 1, .reusable = true}, SHIFT(218),
  [399] = {.count = 1, .reusable = true}, SHIFT(219),
  [401] = {.count = 1, .reusable = true}, SHIFT(220),
  [403] = {.count = 1, .reusable = true}, SHIFT(221),
  [405] = {.count = 1, .reusable = false}, SHIFT(222),
  [407] = {.count = 1, .reusable = false}, SHIFT(223),
  [409] = {.count = 1, .reusable = true}, SHIFT(223),
  [411] = {.count = 1, .reusable = true}, SHIFT(224),
  [413] = {.count = 1, .reusable = false}, SHIFT(226),
  [415] = {.count = 1, .reusable = true}, SHIFT(226),
  [417] = {.count = 1, .reusable = true}, SHIFT(227),
  [419] = {.count = 1, .reusable = true}, SHIFT(228),
  [421] = {.count = 1, .reusable = false}, SHIFT(229),
  [423] = {.count = 1, .reusable = false}, SHIFT(230),
  [425] = {.count = 1, .reusable = true}, SHIFT(230),
  [427] = {.count = 1, .reusable = false}, SHIFT(232),
  [429] = {.count = 1, .reusable = true}, SHIFT(234),
  [431] = {.count = 1, .reusable = true}, SHIFT(235),
  [433] = {.count = 1, .reusable = false}, SHIFT(236),
  [435] = {.count = 1, .reusable = false}, SHIFT(234),
  [437] = {.count = 1, .reusable = false}, SHIFT(237),
  [439] = {.count = 1, .reusable = false}, SHIFT(238),
  [441] = {.count = 1, .reusable = true}, SHIFT(238),
  [443] = {.count = 1, .reusable = true}, SHIFT(239),
  [445] = {.count = 1, .reusable = true}, SHIFT(240),
  [447] = {.count = 1, .reusable = true}, SHIFT(241),
  [449] = {.count = 1, .reusable = false}, SHIFT(242),
  [451] = {.count = 1, .reusable = false}, SHIFT(240),
  [453] = {.count = 1, .reusable = true}, SHIFT(250),
  [455] = {.count = 1, .reusable = true}, SHIFT(251),
  [457] = {.count = 1, .reusable = true}, SHIFT(253),
  [459] = {.count = 1, .reusable = true}, SHIFT(255),
  [461] = {.count = 1, .reusable = true}, SHIFT(258),
  [463] = {.count = 1, .reusable = false}, SHIFT(259),
  [465] = {.count = 1, .reusable = false}, SHIFT(260),
  [467] = {.count = 1, .reusable = false}, SHIFT(263),
  [469] = {.count = 1, .reusable = false}, SHIFT(264),
  [471] = {.count = 1, .reusable = false}, SHIFT(267),
  [473] = {.count = 1, .reusable = false}, SHIFT(268),
  [475] = {.count = 1, .reusable = false}, SHIFT(269),
  [477] = {.count = 1, .reusable = false}, SHIFT(270),
  [479] = {.count = 1, .reusable = false}, SHIFT(271),
  [481] = {.count = 1, .reusable = true}, SHIFT(270),
  [483] = {.count = 1, .reusable = true}, SHIFT(272),
  [485] = {.count = 1, .reusable = false}, SHIFT(273),
  [487] = {.count = 1, .reusable = false}, SHIFT(274),
  [489] = {.count = 1, .reusable = false}, SHIFT(275),
  [491] = {.count = 1, .reusable = false}, SHIFT(276),
  [493] = {.count = 1, .reusable = false}, SHIFT(277),
  [495] = {.count = 1, .reusable = true}, SHIFT(60),
  [497] = {.count = 1, .reusable = true}, SHIFT(284),
  [499] = {.count = 1, .reusable = false}, REDUCE(sym_negated_command, 2),
  [501] = {.count = 1, .reusable = true}, REDUCE(sym_negated_command, 2),
  [503] = {.count = 1, .reusable = false}, SHIFT(285),
  [505] = {.count = 1, .reusable = true}, SHIFT(286),
  [507] = {.count = 1, .reusable = true}, SHIFT(287),
  [509] = {.count = 1, .reusable = false}, SHIFT(287),
  [511] = {.count = 1, .reusable = true}, SHIFT(285),
  [513] = {.count = 1, .reusable = true}, SHIFT(290),
  [515] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [517] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [519] = {.count = 1, .reusable = false}, SHIFT(292),
  [521] = {.count = 1, .reusable = true}, SHIFT(294),
  [523] = {.count = 1, .reusable = true}, SHIFT(295),
  [525] = {.count = 1, .reusable = false}, SHIFT(296),
  [527] = {.count = 1, .reusable = false}, SHIFT(294),
  [529] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [531] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [533] = {.count = 1, .reusable = true}, SHIFT(297),
  [535] = {.count = 1, .reusable = true}, SHIFT(298),
  [537] = {.count = 1, .reusable = true}, SHIFT(299),
  [539] = {.count = 1, .reusable = false}, SHIFT(300),
  [541] = {.count = 1, .reusable = false}, SHIFT(298),
  [543] = {.count = 1, .reusable = true}, SHIFT(308),
  [545] = {.count = 1, .reusable = true}, SHIFT(309),
  [547] = {.count = 1, .reusable = true}, SHIFT(310),
  [549] = {.count = 1, .reusable = false}, SHIFT(308),
  [551] = {.count = 1, .reusable = true}, SHIFT(313),
  [553] = {.count = 1, .reusable = false}, SHIFT(315),
  [555] = {.count = 1, .reusable = true}, SHIFT(317),
  [557] = {.count = 1, .reusable = true}, SHIFT(318),
  [559] = {.count = 1, .reusable = false}, SHIFT(319),
  [561] = {.count = 1, .reusable = false}, SHIFT(317),
  [563] = {.count = 1, .reusable = true}, SHIFT(320),
  [565] = {.count = 1, .reusable = true}, SHIFT(321),
  [567] = {.count = 1, .reusable = true}, SHIFT(322),
  [569] = {.count = 1, .reusable = false}, SHIFT(323),
  [571] = {.count = 1, .reusable = false}, SHIFT(321),
  [573] = {.count = 1, .reusable = true}, SHIFT(331),
  [575] = {.count = 1, .reusable = true}, SHIFT(332),
  [577] = {.count = 1, .reusable = false}, SHIFT(331),
  [579] = {.count = 1, .reusable = true}, SHIFT(333),
  [581] = {.count = 1, .reusable = true}, SHIFT(334),
  [583] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [585] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [587] = {.count = 1, .reusable = false}, SHIFT(336),
  [589] = {.count = 1, .reusable = true}, SHIFT(96),
  [591] = {.count = 1, .reusable = true}, SHIFT(338),
  [593] = {.count = 1, .reusable = true}, SHIFT(339),
  [595] = {.count = 1, .reusable = false}, SHIFT(340),
  [597] = {.count = 1, .reusable = false}, SHIFT(338),
  [599] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [601] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [603] = {.count = 1, .reusable = true}, SHIFT(341),
  [605] = {.count = 1, .reusable = true}, SHIFT(342),
  [607] = {.count = 1, .reusable = true}, SHIFT(343),
  [609] = {.count = 1, .reusable = false}, SHIFT(344),
  [611] = {.count = 1, .reusable = false}, SHIFT(342),
  [613] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 2),
  [615] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 2),
  [617] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 2),
  [619] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 2),
  [621] = {.count = 1, .reusable = true}, SHIFT(353),
  [623] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 1),
  [625] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 1),
  [627] = {.count = 1, .reusable = false}, SHIFT(355),
  [629] = {.count = 1, .reusable = true}, SHIFT(107),
  [631] = {.count = 1, .reusable = true}, SHIFT(357),
  [633] = {.count = 1, .reusable = true}, SHIFT(358),
  [635] = {.count = 1, .reusable = false}, SHIFT(359),
  [637] = {.count = 1, .reusable = false}, SHIFT(357),
  [639] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [641] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [643] = {.count = 1, .reusable = true}, SHIFT(360),
  [645] = {.count = 1, .reusable = true}, SHIFT(361),
  [647] = {.count = 1, .reusable = true}, SHIFT(362),
  [649] = {.count = 1, .reusable = false}, SHIFT(363),
  [651] = {.count = 1, .reusable = false}, SHIFT(361),
  [653] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 2),
  [655] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 2),
  [657] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 2),
  [659] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 2),
  [661] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 3),
  [663] = {.count = 1, .reusable = true}, SHIFT(372),
  [665] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 3),
  [667] = {.count = 1, .reusable = false}, SHIFT(374),
  [669] = {.count = 1, .reusable = true}, SHIFT(376),
  [671] = {.count = 1, .reusable = true}, SHIFT(377),
  [673] = {.count = 1, .reusable = false}, SHIFT(378),
  [675] = {.count = 1, .reusable = false}, SHIFT(376),
  [677] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2),
  [679] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2),
  [681] = {.count = 1, .reusable = true}, SHIFT(379),
  [683] = {.count = 1, .reusable = true}, SHIFT(380),
  [685] = {.count = 1, .reusable = true}, SHIFT(381),
  [687] = {.count = 1, .reusable = false}, SHIFT(382),
  [689] = {.count = 1, .reusable = false}, SHIFT(380),
  [691] = {.count = 1, .reusable = true}, SHIFT(390),
  [693] = {.count = 1, .reusable = true}, REDUCE(sym_concatenation, 2),
  [695] = {.count = 1, .reusable = false}, REDUCE(sym_concatenation, 2),
  [697] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [699] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [701] = {.count = 1, .reusable = false}, SHIFT(392),
  [703] = {.count = 1, .reusable = false}, SHIFT(393),
  [705] = {.count = 1, .reusable = true}, SHIFT(392),
  [707] = {.count = 1, .reusable = false}, SHIFT(394),
  [709] = {.count = 1, .reusable = true}, SHIFT(395),
  [711] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 1),
  [713] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 1),
  [715] = {.count = 1, .reusable = true}, SHIFT(396),
  [717] = {.count = 1, .reusable = true}, SHIFT(397),
  [719] = {.count = 1, .reusable = true}, SHIFT(398),
  [721] = {.count = 1, .reusable = false}, SHIFT(399),
  [723] = {.count = 1, .reusable = false}, SHIFT(397),
  [725] = {.count = 1, .reusable = false}, SHIFT(405),
  [727] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 4),
  [729] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 4),
  [731] = {.count = 1, .reusable = true}, REDUCE(sym_string_expansion, 2),
  [733] = {.count = 1, .reusable = false}, REDUCE(sym_string_expansion, 2),
  [735] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 5),
  [737] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 5),
  [739] = {.count = 1, .reusable = true}, SHIFT(407),
  [741] = {.count = 1, .reusable = true}, SHIFT(408),
  [743] = {.count = 1, .reusable = true}, SHIFT(409),
  [745] = {.count = 1, .reusable = false}, SHIFT(419),
  [747] = {.count = 1, .reusable = false}, SHIFT(410),
  [749] = {.count = 1, .reusable = true}, SHIFT(411),
  [751] = {.count = 1, .reusable = false}, SHIFT(412),
  [753] = {.count = 1, .reusable = true}, SHIFT(413),
  [755] = {.count = 1, .reusable = true}, SHIFT(419),
  [757] = {.count = 1, .reusable = true}, SHIFT(414),
  [759] = {.count = 1, .reusable = true}, SHIFT(415),
  [761] = {.count = 1, .reusable = true}, SHIFT(416),
  [763] = {.count = 1, .reusable = true}, SHIFT(417),
  [765] = {.count = 1, .reusable = true}, SHIFT(418),
  [767] = {.count = 1, .reusable = false}, SHIFT(413),
  [769] = {.count = 1, .reusable = true}, SHIFT(420),
  [771] = {.count = 1, .reusable = true}, SHIFT(421),
  [773] = {.count = 1, .reusable = false}, SHIFT(422),
  [775] = {.count = 1, .reusable = false}, SHIFT(421),
  [777] = {.count = 1, .reusable = true}, SHIFT(424),
  [779] = {.count = 1, .reusable = false}, SHIFT(426),
  [781] = {.count = 1, .reusable = true}, SHIFT(426),
  [783] = {.count = 1, .reusable = true}, SHIFT(425),
  [785] = {.count = 1, .reusable = true}, SHIFT(427),
  [787] = {.count = 1, .reusable = false}, SHIFT(429),
  [789] = {.count = 1, .reusable = true}, SHIFT(429),
  [791] = {.count = 1, .reusable = true}, SHIFT(428),
  [793] = {.count = 1, .reusable = true}, SHIFT(430),
  [795] = {.count = 1, .reusable = true}, SHIFT(431),
  [797] = {.count = 1, .reusable = true}, SHIFT(434),
  [799] = {.count = 1, .reusable = true}, SHIFT(435),
  [801] = {.count = 1, .reusable = true}, SHIFT(437),
  [803] = {.count = 1, .reusable = true}, SHIFT(444),
  [805] = {.count = 1, .reusable = true}, SHIFT(445),
  [807] = {.count = 1, .reusable = true}, SHIFT(446),
  [809] = {.count = 1, .reusable = false}, SHIFT(447),
  [811] = {.count = 1, .reusable = true}, SHIFT(448),
  [813] = {.count = 1, .reusable = true}, SHIFT(449),
  [815] = {.count = 1, .reusable = true}, SHIFT(450),
  [817] = {.count = 1, .reusable = true}, SHIFT(451),
  [819] = {.count = 1, .reusable = true}, SHIFT(452),
  [821] = {.count = 1, .reusable = false}, SHIFT(453),
  [823] = {.count = 1, .reusable = false}, SHIFT(448),
  [825] = {.count = 1, .reusable = true}, SHIFT(456),
  [827] = {.count = 1, .reusable = true}, SHIFT(457),
  [829] = {.count = 1, .reusable = false}, SHIFT(458),
  [831] = {.count = 1, .reusable = true}, SHIFT(459),
  [833] = {.count = 1, .reusable = true}, SHIFT(460),
  [835] = {.count = 1, .reusable = true}, SHIFT(461),
  [837] = {.count = 1, .reusable = true}, SHIFT(462),
  [839] = {.count = 1, .reusable = true}, SHIFT(463),
  [841] = {.count = 1, .reusable = false}, SHIFT(464),
  [843] = {.count = 1, .reusable = false}, SHIFT(459),
  [845] = {.count = 1, .reusable = true}, SHIFT(466),
  [847] = {.count = 1, .reusable = false}, SHIFT(468),
  [849] = {.count = 1, .reusable = true}, SHIFT(470),
  [851] = {.count = 1, .reusable = true}, SHIFT(471),
  [853] = {.count = 1, .reusable = false}, SHIFT(472),
  [855] = {.count = 1, .reusable = false}, SHIFT(470),
  [857] = {.count = 1, .reusable = true}, SHIFT(473),
  [859] = {.count = 1, .reusable = true}, SHIFT(474),
  [861] = {.count = 1, .reusable = true}, SHIFT(475),
  [863] = {.count = 1, .reusable = false}, SHIFT(476),
  [865] = {.count = 1, .reusable = false}, SHIFT(474),
  [867] = {.count = 1, .reusable = true}, SHIFT(484),
  [869] = {.count = 1, .reusable = false}, SHIFT(485),
  [871] = {.count = 1, .reusable = true}, SHIFT(486),
  [873] = {.count = 1, .reusable = true}, SHIFT(485),
  [875] = {.count = 1, .reusable = true}, SHIFT(487),
  [877] = {.count = 1, .reusable = true}, SHIFT(488),
  [879] = {.count = 1, .reusable = true}, SHIFT(489),
  [881] = {.count = 1, .reusable = true}, SHIFT(490),
  [883] = {.count = 1, .reusable = false}, SHIFT(491),
  [885] = {.count = 1, .reusable = false}, SHIFT(492),
  [887] = {.count = 1, .reusable = true}, SHIFT(492),
  [889] = {.count = 1, .reusable = false}, SHIFT(493),
  [891] = {.count = 1, .reusable = true}, SHIFT(493),
  [893] = {.count = 1, .reusable = true}, SHIFT(494),
  [895] = {.count = 1, .reusable = true}, SHIFT(495),
  [897] = {.count = 1, .reusable = true}, SHIFT(496),
  [899] = {.count = 1, .reusable = false}, SHIFT(496),
  [901] = {.count = 1, .reusable = true}, SHIFT(154),
  [903] = {.count = 1, .reusable = true}, SHIFT(501),
  [905] = {.count = 1, .reusable = true}, SHIFT(503),
  [907] = {.count = 1, .reusable = true}, SHIFT(506),
  [909] = {.count = 1, .reusable = true}, SHIFT(507),
  [911] = {.count = 1, .reusable = true}, SHIFT(508),
  [913] = {.count = 1, .reusable = false}, SHIFT(508),
  [915] = {.count = 1, .reusable = true}, SHIFT(511),
  [917] = {.count = 1, .reusable = true}, SHIFT(512),
  [919] = {.count = 1, .reusable = false}, SHIFT(512),
  [921] = {.count = 1, .reusable = true}, SHIFT(515),
  [923] = {.count = 1, .reusable = false}, SHIFT(516),
  [925] = {.count = 1, .reusable = true}, SHIFT(516),
  [927] = {.count = 1, .reusable = true}, SHIFT(517),
  [929] = {.count = 1, .reusable = true}, SHIFT(518),
  [931] = {.count = 1, .reusable = false}, SHIFT(519),
  [933] = {.count = 1, .reusable = false}, SHIFT(520),
  [935] = {.count = 1, .reusable = true}, SHIFT(520),
  [937] = {.count = 1, .reusable = true}, SHIFT(521),
  [939] = {.count = 1, .reusable = true}, SHIFT(522),
  [941] = {.count = 1, .reusable = true}, SHIFT(523),
  [943] = {.count = 1, .reusable = false}, SHIFT(523),
  [945] = {.count = 1, .reusable = true}, SHIFT(177),
  [947] = {.count = 1, .reusable = true}, SHIFT(527),
  [949] = {.count = 1, .reusable = true}, SHIFT(528),
  [951] = {.count = 1, .reusable = true}, REDUCE(sym__terminated_statement, 2),
  [953] = {.count = 1, .reusable = false}, REDUCE(sym__terminated_statement, 2),
  [955] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 1),
  [957] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 1),
  [959] = {.count = 1, .reusable = true}, SHIFT(536),
  [961] = {.count = 1, .reusable = true}, SHIFT(533),
  [963] = {.count = 1, .reusable = false}, SHIFT(534),
  [965] = {.count = 1, .reusable = true}, SHIFT(535),
  [967] = {.count = 1, .reusable = false}, SHIFT(537),
  [969] = {.count = 1, .reusable = true}, SHIFT(537),
  [971] = {.count = 1, .reusable = false}, SHIFT(538),
  [973] = {.count = 1, .reusable = false}, SHIFT(539),
  [975] = {.count = 1, .reusable = false}, SHIFT(540),
  [977] = {.count = 1, .reusable = true}, SHIFT(541),
  [979] = {.count = 1, .reusable = true}, SHIFT(542),
  [981] = {.count = 1, .reusable = true}, SHIFT(544),
  [983] = {.count = 1, .reusable = true}, SHIFT(545),
  [985] = {.count = 1, .reusable = true}, SHIFT(546),
  [987] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1, .alias_sequence_id = 1),
  [989] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1, .alias_sequence_id = 1),
  [991] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1),
  [993] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1),
  [995] = {.count = 1, .reusable = false}, REDUCE(sym_command, 2),
  [997] = {.count = 1, .reusable = true}, REDUCE(sym_command, 2),
  [999] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2),
  [1002] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3),
  [1005] = {.count = 1, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2),
  [1007] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4),
  [1010] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5),
  [1013] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(6),
  [1016] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(7),
  [1019] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(8),
  [1022] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(9),
  [1025] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(10),
  [1028] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(11),
  [1031] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(12),
  [1034] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(13),
  [1037] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(14),
  [1040] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(15),
  [1043] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(15),
  [1046] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(16),
  [1049] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(17),
  [1052] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(18),
  [1055] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(19),
  [1058] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(20),
  [1061] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(21),
  [1064] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(22),
  [1067] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(23),
  [1070] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(24),
  [1073] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(2),
  [1076] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(69),
  [1079] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(15),
  [1082] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(15),
  [1085] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2),
  [1087] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2),
  [1089] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 6),
  [1091] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 6),
  [1093] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3),
  [1095] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3),
  [1097] = {.count = 1, .reusable = true}, SHIFT(553),
  [1099] = {.count = 1, .reusable = true}, SHIFT(554),
  [1101] = {.count = 1, .reusable = true}, SHIFT(556),
  [1103] = {.count = 1, .reusable = true}, SHIFT(557),
  [1105] = {.count = 1, .reusable = true}, SHIFT(558),
  [1107] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment, 3),
  [1109] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment, 3),
  [1111] = {.count = 1, .reusable = true}, SHIFT(559),
  [1113] = {.count = 1, .reusable = true}, SHIFT(560),
  [1115] = {.count = 1, .reusable = true}, SHIFT(561),
  [1117] = {.count = 1, .reusable = false}, SHIFT(562),
  [1119] = {.count = 1, .reusable = true}, SHIFT(563),
  [1121] = {.count = 1, .reusable = true}, SHIFT(564),
  [1123] = {.count = 1, .reusable = true}, SHIFT(565),
  [1125] = {.count = 1, .reusable = true}, SHIFT(566),
  [1127] = {.count = 1, .reusable = true}, SHIFT(567),
  [1129] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment, 3, .alias_sequence_id = 6),
  [1131] = {.count = 1, .reusable = true}, SHIFT(569),
  [1133] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment, 3, .alias_sequence_id = 6),
  [1135] = {.count = 1, .reusable = false}, SHIFT(571),
  [1137] = {.count = 1, .reusable = true}, SHIFT(573),
  [1139] = {.count = 1, .reusable = true}, SHIFT(574),
  [1141] = {.count = 1, .reusable = false}, SHIFT(575),
  [1143] = {.count = 1, .reusable = false}, SHIFT(573),
  [1145] = {.count = 1, .reusable = true}, SHIFT(576),
  [1147] = {.count = 1, .reusable = true}, SHIFT(577),
  [1149] = {.count = 1, .reusable = true}, SHIFT(578),
  [1151] = {.count = 1, .reusable = false}, SHIFT(579),
  [1153] = {.count = 1, .reusable = false}, SHIFT(577),
  [1155] = {.count = 1, .reusable = true}, SHIFT(587),
  [1157] = {.count = 1, .reusable = true}, SHIFT(588),
  [1159] = {.count = 1, .reusable = false}, SHIFT(589),
  [1161] = {.count = 1, .reusable = true}, SHIFT(590),
  [1163] = {.count = 1, .reusable = true}, SHIFT(591),
  [1165] = {.count = 1, .reusable = true}, SHIFT(592),
  [1167] = {.count = 1, .reusable = true}, SHIFT(593),
  [1169] = {.count = 1, .reusable = true}, SHIFT(594),
  [1171] = {.count = 1, .reusable = true}, SHIFT(596),
  [1173] = {.count = 1, .reusable = false}, SHIFT(598),
  [1175] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3),
  [1177] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3),
  [1179] = {.count = 1, .reusable = false}, SHIFT(604),
  [1181] = {.count = 1, .reusable = false}, SHIFT(605),
  [1183] = {.count = 1, .reusable = false}, SHIFT(606),
  [1185] = {.count = 1, .reusable = true}, SHIFT(613),
  [1187] = {.count = 1, .reusable = false}, SHIFT(614),
  [1189] = {.count = 1, .reusable = true}, SHIFT(614),
  [1191] = {.count = 1, .reusable = true}, SHIFT(615),
  [1193] = {.count = 1, .reusable = false}, SHIFT(617),
  [1195] = {.count = 1, .reusable = false}, SHIFT(618),
  [1197] = {.count = 1, .reusable = true}, SHIFT(618),
  [1199] = {.count = 1, .reusable = true}, SHIFT(619),
  [1201] = {.count = 1, .reusable = true}, SHIFT(620),
  [1203] = {.count = 1, .reusable = true}, SHIFT(621),
  [1205] = {.count = 1, .reusable = false}, SHIFT(623),
  [1207] = {.count = 1, .reusable = true}, SHIFT(623),
  [1209] = {.count = 1, .reusable = true}, SHIFT(622),
  [1211] = {.count = 1, .reusable = true}, SHIFT(624),
  [1213] = {.count = 1, .reusable = true}, SHIFT(625),
  [1215] = {.count = 1, .reusable = false}, SHIFT(626),
  [1217] = {.count = 1, .reusable = false}, SHIFT(625),
  [1219] = {.count = 1, .reusable = true}, SHIFT(628),
  [1221] = {.count = 1, .reusable = false}, SHIFT(630),
  [1223] = {.count = 1, .reusable = true}, SHIFT(630),
  [1225] = {.count = 1, .reusable = true}, SHIFT(629),
  [1227] = {.count = 1, .reusable = true}, SHIFT(631),
  [1229] = {.count = 1, .reusable = false}, SHIFT(633),
  [1231] = {.count = 1, .reusable = true}, SHIFT(633),
  [1233] = {.count = 1, .reusable = true}, SHIFT(632),
  [1235] = {.count = 1, .reusable = true}, SHIFT(634),
  [1237] = {.count = 1, .reusable = true}, SHIFT(635),
  [1239] = {.count = 1, .reusable = true}, SHIFT(636),
  [1241] = {.count = 1, .reusable = true}, SHIFT(637),
  [1243] = {.count = 1, .reusable = true}, SHIFT(641),
  [1245] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 3),
  [1247] = {.count = 1, .reusable = false}, SHIFT(642),
  [1249] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 3),
  [1251] = {.count = 1, .reusable = true}, SHIFT(644),
  [1253] = {.count = 1, .reusable = true}, SHIFT(645),
  [1255] = {.count = 1, .reusable = true}, SHIFT(647),
  [1257] = {.count = 1, .reusable = true}, SHIFT(649),
  [1259] = {.count = 1, .reusable = true}, SHIFT(650),
  [1261] = {.count = 1, .reusable = true}, SHIFT(656),
  [1263] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 3),
  [1265] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 3),
  [1267] = {.count = 1, .reusable = true}, SHIFT(657),
  [1269] = {.count = 1, .reusable = false}, SHIFT(660),
  [1271] = {.count = 1, .reusable = true}, SHIFT(660),
  [1273] = {.count = 1, .reusable = false}, SHIFT(661),
  [1275] = {.count = 1, .reusable = false}, SHIFT(662),
  [1277] = {.count = 1, .reusable = true}, SHIFT(663),
  [1279] = {.count = 1, .reusable = true}, SHIFT(664),
  [1281] = {.count = 1, .reusable = true}, SHIFT(665),
  [1283] = {.count = 1, .reusable = true}, SHIFT(666),
  [1285] = {.count = 1, .reusable = false}, SHIFT(657),
  [1287] = {.count = 1, .reusable = false}, SHIFT(670),
  [1289] = {.count = 1, .reusable = true}, SHIFT(670),
  [1291] = {.count = 1, .reusable = true}, SHIFT(672),
  [1293] = {.count = 1, .reusable = true}, SHIFT(673),
  [1295] = {.count = 1, .reusable = true}, SHIFT(674),
  [1297] = {.count = 1, .reusable = true}, SHIFT(675),
  [1299] = {.count = 1, .reusable = true}, SHIFT(678),
  [1301] = {.count = 1, .reusable = true}, SHIFT(679),
  [1303] = {.count = 1, .reusable = true}, SHIFT(680),
  [1305] = {.count = 1, .reusable = false}, SHIFT(679),
  [1307] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2),
  [1309] = {.count = 1, .reusable = true}, SHIFT(681),
  [1311] = {.count = 1, .reusable = false}, SHIFT(683),
  [1313] = {.count = 1, .reusable = true}, SHIFT(684),
  [1315] = {.count = 1, .reusable = true}, SHIFT(685),
  [1317] = {.count = 1, .reusable = false}, SHIFT(687),
  [1319] = {.count = 1, .reusable = true}, SHIFT(687),
  [1321] = {.count = 1, .reusable = true}, SHIFT(686),
  [1323] = {.count = 1, .reusable = true}, SHIFT(688),
  [1325] = {.count = 1, .reusable = true}, SHIFT(689),
  [1327] = {.count = 1, .reusable = false}, SHIFT(690),
  [1329] = {.count = 1, .reusable = false}, SHIFT(689),
  [1331] = {.count = 1, .reusable = true}, SHIFT(692),
  [1333] = {.count = 1, .reusable = false}, SHIFT(694),
  [1335] = {.count = 1, .reusable = true}, SHIFT(694),
  [1337] = {.count = 1, .reusable = true}, SHIFT(693),
  [1339] = {.count = 1, .reusable = true}, SHIFT(695),
  [1341] = {.count = 1, .reusable = false}, SHIFT(697),
  [1343] = {.count = 1, .reusable = true}, SHIFT(697),
  [1345] = {.count = 1, .reusable = true}, SHIFT(696),
  [1347] = {.count = 1, .reusable = true}, SHIFT(698),
  [1349] = {.count = 1, .reusable = true}, SHIFT(699),
  [1351] = {.count = 1, .reusable = true}, SHIFT(701),
  [1353] = {.count = 1, .reusable = false}, REDUCE(sym_test_command, 3),
  [1355] = {.count = 1, .reusable = false}, SHIFT(702),
  [1357] = {.count = 1, .reusable = false}, SHIFT(703),
  [1359] = {.count = 1, .reusable = false}, SHIFT(704),
  [1361] = {.count = 1, .reusable = true}, REDUCE(sym_test_command, 3),
  [1363] = {.count = 1, .reusable = false}, SHIFT(72),
  [1365] = {.count = 1, .reusable = false}, SHIFT(74),
  [1367] = {.count = 1, .reusable = false}, SHIFT(75),
  [1369] = {.count = 1, .reusable = false}, SHIFT(78),
  [1371] = {.count = 1, .reusable = false}, SHIFT(79),
  [1373] = {.count = 1, .reusable = false}, SHIFT(80),
  [1375] = {.count = 1, .reusable = false}, SHIFT(81),
  [1377] = {.count = 1, .reusable = false}, SHIFT(706),
  [1379] = {.count = 1, .reusable = true}, SHIFT(707),
  [1381] = {.count = 1, .reusable = true}, SHIFT(708),
  [1383] = {.count = 1, .reusable = false}, SHIFT(710),
  [1385] = {.count = 1, .reusable = true}, SHIFT(711),
  [1387] = {.count = 1, .reusable = true}, SHIFT(712),
  [1389] = {.count = 1, .reusable = false}, SHIFT(714),
  [1391] = {.count = 1, .reusable = true}, SHIFT(714),
  [1393] = {.count = 1, .reusable = true}, SHIFT(713),
  [1395] = {.count = 1, .reusable = true}, SHIFT(715),
  [1397] = {.count = 1, .reusable = true}, SHIFT(716),
  [1399] = {.count = 1, .reusable = false}, SHIFT(717),
  [1401] = {.count = 1, .reusable = false}, SHIFT(716),
  [1403] = {.count = 1, .reusable = true}, SHIFT(719),
  [1405] = {.count = 1, .reusable = false}, SHIFT(721),
  [1407] = {.count = 1, .reusable = true}, SHIFT(721),
  [1409] = {.count = 1, .reusable = true}, SHIFT(720),
  [1411] = {.count = 1, .reusable = true}, SHIFT(722),
  [1413] = {.count = 1, .reusable = false}, SHIFT(724),
  [1415] = {.count = 1, .reusable = true}, SHIFT(724),
  [1417] = {.count = 1, .reusable = true}, SHIFT(723),
  [1419] = {.count = 1, .reusable = true}, SHIFT(725),
  [1421] = {.count = 1, .reusable = true}, SHIFT(726),
  [1423] = {.count = 1, .reusable = false}, SHIFT(83),
  [1425] = {.count = 1, .reusable = false}, SHIFT(85),
  [1427] = {.count = 1, .reusable = false}, SHIFT(86),
  [1429] = {.count = 1, .reusable = false}, SHIFT(89),
  [1431] = {.count = 1, .reusable = false}, SHIFT(90),
  [1433] = {.count = 1, .reusable = false}, SHIFT(91),
  [1435] = {.count = 1, .reusable = false}, SHIFT(92),
  [1437] = {.count = 1, .reusable = false}, SHIFT(728),
  [1439] = {.count = 1, .reusable = true}, SHIFT(729),
  [1441] = {.count = 1, .reusable = true}, SHIFT(730),
  [1443] = {.count = 1, .reusable = true}, SHIFT(731),
  [1445] = {.count = 1, .reusable = true}, SHIFT(732),
  [1447] = {.count = 1, .reusable = true}, SHIFT(99),
  [1449] = {.count = 1, .reusable = true}, SHIFT(100),
  [1451] = {.count = 1, .reusable = true}, SHIFT(101),
  [1453] = {.count = 1, .reusable = true}, SHIFT(102),
  [1455] = {.count = 1, .reusable = true}, SHIFT(733),
  [1457] = {.count = 1, .reusable = false}, SHIFT(735),
  [1459] = {.count = 1, .reusable = true}, SHIFT(736),
  [1461] = {.count = 1, .reusable = true}, SHIFT(737),
  [1463] = {.count = 1, .reusable = false}, SHIFT(739),
  [1465] = {.count = 1, .reusable = true}, SHIFT(739),
  [1467] = {.count = 1, .reusable = true}, SHIFT(738),
  [1469] = {.count = 1, .reusable = true}, SHIFT(740),
  [1471] = {.count = 1, .reusable = true}, SHIFT(741),
  [1473] = {.count = 1, .reusable = false}, SHIFT(742),
  [1475] = {.count = 1, .reusable = false}, SHIFT(741),
  [1477] = {.count = 1, .reusable = true}, SHIFT(744),
  [1479] = {.count = 1, .reusable = false}, SHIFT(746),
  [1481] = {.count = 1, .reusable = true}, SHIFT(746),
  [1483] = {.count = 1, .reusable = true}, SHIFT(745),
  [1485] = {.count = 1, .reusable = true}, SHIFT(747),
  [1487] = {.count = 1, .reusable = false}, SHIFT(749),
  [1489] = {.count = 1, .reusable = true}, SHIFT(749),
  [1491] = {.count = 1, .reusable = true}, SHIFT(748),
  [1493] = {.count = 1, .reusable = true}, SHIFT(750),
  [1495] = {.count = 1, .reusable = true}, SHIFT(751),
  [1497] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(94),
  [1500] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [1502] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(95),
  [1505] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(96),
  [1508] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(97),
  [1511] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(98),
  [1514] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(99),
  [1517] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(100),
  [1520] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(101),
  [1523] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(102),
  [1526] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(103),
  [1529] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [1531] = {.count = 1, .reusable = true}, SHIFT(752),
  [1533] = {.count = 1, .reusable = true}, SHIFT(110),
  [1535] = {.count = 1, .reusable = true}, SHIFT(111),
  [1537] = {.count = 1, .reusable = true}, SHIFT(112),
  [1539] = {.count = 1, .reusable = true}, SHIFT(113),
  [1541] = {.count = 1, .reusable = false}, SHIFT(754),
  [1543] = {.count = 1, .reusable = true}, SHIFT(755),
  [1545] = {.count = 1, .reusable = true}, SHIFT(756),
  [1547] = {.count = 1, .reusable = false}, SHIFT(758),
  [1549] = {.count = 1, .reusable = true}, SHIFT(758),
  [1551] = {.count = 1, .reusable = true}, SHIFT(757),
  [1553] = {.count = 1, .reusable = true}, SHIFT(759),
  [1555] = {.count = 1, .reusable = true}, SHIFT(760),
  [1557] = {.count = 1, .reusable = false}, SHIFT(761),
  [1559] = {.count = 1, .reusable = false}, SHIFT(760),
  [1561] = {.count = 1, .reusable = true}, SHIFT(763),
  [1563] = {.count = 1, .reusable = false}, SHIFT(765),
  [1565] = {.count = 1, .reusable = true}, SHIFT(765),
  [1567] = {.count = 1, .reusable = true}, SHIFT(764),
  [1569] = {.count = 1, .reusable = true}, SHIFT(766),
  [1571] = {.count = 1, .reusable = false}, SHIFT(768),
  [1573] = {.count = 1, .reusable = true}, SHIFT(768),
  [1575] = {.count = 1, .reusable = true}, SHIFT(767),
  [1577] = {.count = 1, .reusable = true}, SHIFT(769),
  [1579] = {.count = 1, .reusable = true}, SHIFT(770),
  [1581] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [1583] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(106),
  [1586] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(107),
  [1589] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(108),
  [1592] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(109),
  [1595] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(110),
  [1598] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(111),
  [1601] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(112),
  [1604] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(113),
  [1607] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(114),
  [1610] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [1612] = {.count = 1, .reusable = true}, SHIFT(771),
  [1614] = {.count = 1, .reusable = false}, SHIFT(773),
  [1616] = {.count = 1, .reusable = true}, SHIFT(774),
  [1618] = {.count = 1, .reusable = true}, SHIFT(775),
  [1620] = {.count = 1, .reusable = false}, SHIFT(777),
  [1622] = {.count = 1, .reusable = true}, SHIFT(777),
  [1624] = {.count = 1, .reusable = true}, SHIFT(776),
  [1626] = {.count = 1, .reusable = true}, SHIFT(778),
  [1628] = {.count = 1, .reusable = true}, SHIFT(779),
  [1630] = {.count = 1, .reusable = false}, SHIFT(780),
  [1632] = {.count = 1, .reusable = false}, SHIFT(779),
  [1634] = {.count = 1, .reusable = true}, SHIFT(782),
  [1636] = {.count = 1, .reusable = false}, SHIFT(784),
  [1638] = {.count = 1, .reusable = true}, SHIFT(784),
  [1640] = {.count = 1, .reusable = true}, SHIFT(783),
  [1642] = {.count = 1, .reusable = true}, SHIFT(785),
  [1644] = {.count = 1, .reusable = false}, SHIFT(787),
  [1646] = {.count = 1, .reusable = true}, SHIFT(787),
  [1648] = {.count = 1, .reusable = true}, SHIFT(786),
  [1650] = {.count = 1, .reusable = true}, SHIFT(788),
  [1652] = {.count = 1, .reusable = true}, SHIFT(789),
  [1654] = {.count = 1, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1656] = {.count = 1, .reusable = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1658] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(125),
  [1661] = {.count = 1, .reusable = true}, SHIFT(790),
  [1663] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [1665] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2),
  [1667] = {.count = 1, .reusable = true}, SHIFT(791),
  [1669] = {.count = 1, .reusable = true}, SHIFT(792),
  [1671] = {.count = 1, .reusable = false}, SHIFT(794),
  [1673] = {.count = 1, .reusable = true}, SHIFT(794),
  [1675] = {.count = 1, .reusable = true}, SHIFT(793),
  [1677] = {.count = 1, .reusable = true}, SHIFT(795),
  [1679] = {.count = 1, .reusable = true}, SHIFT(796),
  [1681] = {.count = 1, .reusable = false}, SHIFT(797),
  [1683] = {.count = 1, .reusable = false}, SHIFT(796),
  [1685] = {.count = 1, .reusable = true}, SHIFT(799),
  [1687] = {.count = 1, .reusable = false}, SHIFT(801),
  [1689] = {.count = 1, .reusable = true}, SHIFT(801),
  [1691] = {.count = 1, .reusable = true}, SHIFT(800),
  [1693] = {.count = 1, .reusable = true}, SHIFT(802),
  [1695] = {.count = 1, .reusable = false}, SHIFT(804),
  [1697] = {.count = 1, .reusable = true}, SHIFT(804),
  [1699] = {.count = 1, .reusable = true}, SHIFT(803),
  [1701] = {.count = 1, .reusable = true}, SHIFT(805),
  [1703] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [1705] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [1707] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(128),
  [1710] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(129),
  [1713] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(130),
  [1716] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(131),
  [1719] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(132),
  [1722] = {.count = 1, .reusable = true}, SHIFT(806),
  [1724] = {.count = 1, .reusable = true}, SHIFT(807),
  [1726] = {.count = 1, .reusable = true}, SHIFT(809),
  [1728] = {.count = 1, .reusable = false}, SHIFT(810),
  [1730] = {.count = 1, .reusable = true}, SHIFT(811),
  [1732] = {.count = 1, .reusable = false}, SHIFT(812),
  [1734] = {.count = 1, .reusable = true}, SHIFT(813),
  [1736] = {.count = 1, .reusable = true}, SHIFT(814),
  [1738] = {.count = 1, .reusable = true}, SHIFT(815),
  [1740] = {.count = 1, .reusable = true}, SHIFT(816),
  [1742] = {.count = 1, .reusable = true}, SHIFT(817),
  [1744] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3, .alias_sequence_id = 4),
  [1746] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 4),
  [1748] = {.count = 1, .reusable = true}, SHIFT(819),
  [1750] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [1752] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [1754] = {.count = 1, .reusable = false}, SHIFT(821),
  [1756] = {.count = 1, .reusable = true}, SHIFT(823),
  [1758] = {.count = 1, .reusable = true}, SHIFT(824),
  [1760] = {.count = 1, .reusable = false}, SHIFT(825),
  [1762] = {.count = 1, .reusable = false}, SHIFT(823),
  [1764] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1),
  [1766] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1),
  [1768] = {.count = 1, .reusable = true}, SHIFT(826),
  [1770] = {.count = 1, .reusable = true}, SHIFT(827),
  [1772] = {.count = 1, .reusable = true}, SHIFT(828),
  [1774] = {.count = 1, .reusable = false}, SHIFT(829),
  [1776] = {.count = 1, .reusable = false}, SHIFT(827),
  [1778] = {.count = 1, .reusable = true}, SHIFT(831),
  [1780] = {.count = 1, .reusable = true}, SHIFT(838),
  [1782] = {.count = 1, .reusable = false}, SHIFT(839),
  [1784] = {.count = 1, .reusable = true}, SHIFT(839),
  [1786] = {.count = 1, .reusable = true}, SHIFT(840),
  [1788] = {.count = 1, .reusable = true}, SHIFT(841),
  [1790] = {.count = 1, .reusable = false}, SHIFT(843),
  [1792] = {.count = 1, .reusable = true}, SHIFT(843),
  [1794] = {.count = 1, .reusable = true}, SHIFT(842),
  [1796] = {.count = 1, .reusable = true}, SHIFT(844),
  [1798] = {.count = 1, .reusable = false}, SHIFT(846),
  [1800] = {.count = 1, .reusable = true}, SHIFT(846),
  [1802] = {.count = 1, .reusable = true}, SHIFT(845),
  [1804] = {.count = 1, .reusable = false}, SHIFT(848),
  [1806] = {.count = 1, .reusable = true}, SHIFT(848),
  [1808] = {.count = 1, .reusable = true}, SHIFT(847),
  [1810] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3, .alias_sequence_id = 5),
  [1812] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 5),
  [1814] = {.count = 1, .reusable = true}, SHIFT(849),
  [1816] = {.count = 1, .reusable = true}, SHIFT(850),
  [1818] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3),
  [1820] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3),
  [1822] = {.count = 1, .reusable = true}, SHIFT(851),
  [1824] = {.count = 1, .reusable = true}, SHIFT(852),
  [1826] = {.count = 1, .reusable = true}, SHIFT(853),
  [1828] = {.count = 1, .reusable = false}, SHIFT(854),
  [1830] = {.count = 1, .reusable = false}, SHIFT(855),
  [1832] = {.count = 1, .reusable = true}, SHIFT(855),
  [1834] = {.count = 1, .reusable = true}, SHIFT(856),
  [1836] = {.count = 1, .reusable = true}, SHIFT(858),
  [1838] = {.count = 1, .reusable = false}, SHIFT(859),
  [1840] = {.count = 1, .reusable = false}, SHIFT(860),
  [1842] = {.count = 1, .reusable = true}, SHIFT(860),
  [1844] = {.count = 1, .reusable = false}, SHIFT(861),
  [1846] = {.count = 1, .reusable = false}, SHIFT(862),
  [1848] = {.count = 1, .reusable = true}, SHIFT(862),
  [1850] = {.count = 1, .reusable = true}, SHIFT(863),
  [1852] = {.count = 1, .reusable = true}, SHIFT(864),
  [1854] = {.count = 1, .reusable = false}, SHIFT(866),
  [1856] = {.count = 1, .reusable = false}, SHIFT(867),
  [1858] = {.count = 1, .reusable = true}, SHIFT(867),
  [1860] = {.count = 1, .reusable = true}, SHIFT(870),
  [1862] = {.count = 1, .reusable = true}, SHIFT(871),
  [1864] = {.count = 1, .reusable = true}, SHIFT(872),
  [1866] = {.count = 1, .reusable = false}, SHIFT(874),
  [1868] = {.count = 1, .reusable = true}, SHIFT(876),
  [1870] = {.count = 1, .reusable = true}, SHIFT(877),
  [1872] = {.count = 1, .reusable = false}, SHIFT(878),
  [1874] = {.count = 1, .reusable = false}, SHIFT(876),
  [1876] = {.count = 1, .reusable = true}, SHIFT(879),
  [1878] = {.count = 1, .reusable = true}, SHIFT(880),
  [1880] = {.count = 1, .reusable = true}, SHIFT(881),
  [1882] = {.count = 1, .reusable = false}, SHIFT(882),
  [1884] = {.count = 1, .reusable = false}, SHIFT(880),
  [1886] = {.count = 1, .reusable = true}, SHIFT(891),
  [1888] = {.count = 1, .reusable = false}, SHIFT(893),
  [1890] = {.count = 1, .reusable = true}, SHIFT(895),
  [1892] = {.count = 1, .reusable = true}, SHIFT(896),
  [1894] = {.count = 1, .reusable = false}, SHIFT(897),
  [1896] = {.count = 1, .reusable = false}, SHIFT(895),
  [1898] = {.count = 1, .reusable = true}, SHIFT(898),
  [1900] = {.count = 1, .reusable = true}, SHIFT(899),
  [1902] = {.count = 1, .reusable = true}, SHIFT(900),
  [1904] = {.count = 1, .reusable = false}, SHIFT(901),
  [1906] = {.count = 1, .reusable = false}, SHIFT(899),
  [1908] = {.count = 1, .reusable = true}, SHIFT(910),
  [1910] = {.count = 1, .reusable = false}, SHIFT(912),
  [1912] = {.count = 1, .reusable = true}, SHIFT(913),
  [1914] = {.count = 1, .reusable = true}, SHIFT(914),
  [1916] = {.count = 1, .reusable = false}, SHIFT(916),
  [1918] = {.count = 1, .reusable = true}, SHIFT(916),
  [1920] = {.count = 1, .reusable = true}, SHIFT(915),
  [1922] = {.count = 1, .reusable = true}, SHIFT(917),
  [1924] = {.count = 1, .reusable = true}, SHIFT(918),
  [1926] = {.count = 1, .reusable = false}, SHIFT(919),
  [1928] = {.count = 1, .reusable = false}, SHIFT(918),
  [1930] = {.count = 1, .reusable = true}, SHIFT(921),
  [1932] = {.count = 1, .reusable = false}, SHIFT(923),
  [1934] = {.count = 1, .reusable = true}, SHIFT(923),
  [1936] = {.count = 1, .reusable = true}, SHIFT(922),
  [1938] = {.count = 1, .reusable = true}, SHIFT(924),
  [1940] = {.count = 1, .reusable = false}, SHIFT(926),
  [1942] = {.count = 1, .reusable = true}, SHIFT(926),
  [1944] = {.count = 1, .reusable = true}, SHIFT(925),
  [1946] = {.count = 1, .reusable = true}, SHIFT(927),
  [1948] = {.count = 1, .reusable = true}, SHIFT(928),
  [1950] = {.count = 1, .reusable = true}, SHIFT(929),
  [1952] = {.count = 1, .reusable = true}, REDUCE(sym_command_substitution, 3),
  [1954] = {.count = 1, .reusable = false}, REDUCE(sym_command_substitution, 3),
  [1956] = {.count = 1, .reusable = true}, SHIFT(935),
  [1958] = {.count = 1, .reusable = true}, SHIFT(934),
  [1960] = {.count = 1, .reusable = false}, SHIFT(936),
  [1962] = {.count = 1, .reusable = true}, SHIFT(936),
  [1964] = {.count = 1, .reusable = false}, SHIFT(937),
  [1966] = {.count = 1, .reusable = false}, SHIFT(155),
  [1968] = {.count = 1, .reusable = false}, SHIFT(938),
  [1970] = {.count = 1, .reusable = false}, SHIFT(158),
  [1972] = {.count = 1, .reusable = false}, SHIFT(159),
  [1974] = {.count = 1, .reusable = false}, SHIFT(160),
  [1976] = {.count = 1, .reusable = false}, SHIFT(161),
  [1978] = {.count = 1, .reusable = false}, SHIFT(939),
  [1980] = {.count = 1, .reusable = true}, SHIFT(940),
  [1982] = {.count = 1, .reusable = true}, SHIFT(941),
  [1984] = {.count = 1, .reusable = true}, SHIFT(943),
  [1986] = {.count = 1, .reusable = true}, SHIFT(944),
  [1988] = {.count = 1, .reusable = true}, SHIFT(945),
  [1990] = {.count = 1, .reusable = true}, SHIFT(952),
  [1992] = {.count = 1, .reusable = true}, SHIFT(953),
  [1994] = {.count = 1, .reusable = true}, SHIFT(955),
  [1996] = {.count = 1, .reusable = true}, SHIFT(957),
  [1998] = {.count = 1, .reusable = true}, SHIFT(958),
  [2000] = {.count = 1, .reusable = true}, SHIFT(964),
  [2002] = {.count = 1, .reusable = false}, SHIFT(968),
  [2004] = {.count = 1, .reusable = true}, SHIFT(968),
  [2006] = {.count = 1, .reusable = false}, SHIFT(969),
  [2008] = {.count = 1, .reusable = false}, SHIFT(970),
  [2010] = {.count = 1, .reusable = true}, SHIFT(971),
  [2012] = {.count = 1, .reusable = true}, SHIFT(972),
  [2014] = {.count = 1, .reusable = true}, SHIFT(973),
  [2016] = {.count = 1, .reusable = true}, SHIFT(974),
  [2018] = {.count = 1, .reusable = true}, REDUCE(sym_process_substitution, 3),
  [2020] = {.count = 1, .reusable = false}, REDUCE(sym_process_substitution, 3),
  [2022] = {.count = 1, .reusable = false}, REDUCE(sym_pipeline, 3),
  [2024] = {.count = 1, .reusable = true}, REDUCE(sym_pipeline, 3),
  [2026] = {.count = 1, .reusable = false}, REDUCE(sym_list, 3),
  [2028] = {.count = 1, .reusable = true}, REDUCE(sym_list, 3),
  [2030] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 2),
  [2032] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 2),
  [2034] = {.count = 1, .reusable = true}, SHIFT(980),
  [2036] = {.count = 1, .reusable = false}, SHIFT(981),
  [2038] = {.count = 1, .reusable = false}, SHIFT(980),
  [2040] = {.count = 1, .reusable = true}, SHIFT(982),
  [2042] = {.count = 1, .reusable = true}, SHIFT(983),
  [2044] = {.count = 1, .reusable = true}, SHIFT(984),
  [2046] = {.count = 1, .reusable = false}, SHIFT(985),
  [2048] = {.count = 1, .reusable = false}, SHIFT(983),
  [2050] = {.count = 1, .reusable = true}, SHIFT(988),
  [2052] = {.count = 1, .reusable = true}, SHIFT(987),
  [2054] = {.count = 1, .reusable = true}, SHIFT(989),
  [2056] = {.count = 1, .reusable = true}, SHIFT(990),
  [2058] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2, .alias_sequence_id = 3),
  [2060] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2, .alias_sequence_id = 3),
  [2062] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2),
  [2064] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2),
  [2066] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_redirect, 2),
  [2068] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_redirect, 2),
  [2070] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 3),
  [2072] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 3),
  [2074] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2),
  [2076] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2),
  [2078] = {.count = 1, .reusable = false}, REDUCE(sym_command, 3),
  [2080] = {.count = 1, .reusable = true}, REDUCE(sym_command, 3),
  [2082] = {.count = 1, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2),
  [2084] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(193),
  [2087] = {.count = 1, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2),
  [2089] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(195),
  [2092] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(196),
  [2095] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(197),
  [2098] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(194),
  [2101] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(198),
  [2104] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(17),
  [2107] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(18),
  [2110] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(199),
  [2113] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(20),
  [2116] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(21),
  [2119] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(22),
  [2122] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(23),
  [2125] = {.count = 1, .reusable = true}, SHIFT(995),
  [2127] = {.count = 1, .reusable = false}, SHIFT(681),
  [2129] = {.count = 1, .reusable = true}, SHIFT(996),
  [2131] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4, .alias_sequence_id = 6),
  [2133] = {.count = 1, .reusable = true}, SHIFT(998),
  [2135] = {.count = 1, .reusable = true}, SHIFT(999),
  [2137] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4),
  [2139] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [2141] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [2143] = {.count = 1, .reusable = true}, SHIFT(1000),
  [2145] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [2147] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [2149] = {.count = 1, .reusable = false}, SHIFT(1002),
  [2151] = {.count = 1, .reusable = true}, SHIFT(1004),
  [2153] = {.count = 1, .reusable = true}, SHIFT(1005),
  [2155] = {.count = 1, .reusable = false}, SHIFT(1006),
  [2157] = {.count = 1, .reusable = false}, SHIFT(1004),
  [2159] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [2161] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [2163] = {.count = 1, .reusable = true}, SHIFT(1007),
  [2165] = {.count = 1, .reusable = true}, SHIFT(1008),
  [2167] = {.count = 1, .reusable = true}, SHIFT(1009),
  [2169] = {.count = 1, .reusable = false}, SHIFT(1010),
  [2171] = {.count = 1, .reusable = false}, SHIFT(1008),
  [2173] = {.count = 1, .reusable = true}, SHIFT(1018),
  [2175] = {.count = 1, .reusable = true}, SHIFT(1020),
  [2177] = {.count = 1, .reusable = false}, SHIFT(1022),
  [2179] = {.count = 1, .reusable = true}, SHIFT(1023),
  [2181] = {.count = 1, .reusable = true}, SHIFT(1024),
  [2183] = {.count = 1, .reusable = false}, SHIFT(1026),
  [2185] = {.count = 1, .reusable = true}, SHIFT(1026),
  [2187] = {.count = 1, .reusable = true}, SHIFT(1025),
  [2189] = {.count = 1, .reusable = true}, SHIFT(1027),
  [2191] = {.count = 1, .reusable = true}, SHIFT(1028),
  [2193] = {.count = 1, .reusable = false}, SHIFT(1029),
  [2195] = {.count = 1, .reusable = false}, SHIFT(1028),
  [2197] = {.count = 1, .reusable = true}, SHIFT(1031),
  [2199] = {.count = 1, .reusable = false}, SHIFT(1033),
  [2201] = {.count = 1, .reusable = true}, SHIFT(1033),
  [2203] = {.count = 1, .reusable = true}, SHIFT(1032),
  [2205] = {.count = 1, .reusable = true}, SHIFT(1034),
  [2207] = {.count = 1, .reusable = false}, SHIFT(1036),
  [2209] = {.count = 1, .reusable = true}, SHIFT(1036),
  [2211] = {.count = 1, .reusable = true}, SHIFT(1035),
  [2213] = {.count = 1, .reusable = true}, SHIFT(1037),
  [2215] = {.count = 1, .reusable = true}, SHIFT(1038),
  [2217] = {.count = 1, .reusable = true}, SHIFT(1039),
  [2219] = {.count = 1, .reusable = false}, SHIFT(1041),
  [2221] = {.count = 1, .reusable = true}, SHIFT(1043),
  [2223] = {.count = 1, .reusable = true}, SHIFT(1044),
  [2225] = {.count = 1, .reusable = false}, SHIFT(1045),
  [2227] = {.count = 1, .reusable = false}, SHIFT(1043),
  [2229] = {.count = 1, .reusable = true}, SHIFT(1046),
  [2231] = {.count = 1, .reusable = true}, SHIFT(1047),
  [2233] = {.count = 1, .reusable = true}, SHIFT(1048),
  [2235] = {.count = 1, .reusable = false}, SHIFT(1049),
  [2237] = {.count = 1, .reusable = false}, SHIFT(1047),
  [2239] = {.count = 1, .reusable = false}, SHIFT(1057),
  [2241] = {.count = 1, .reusable = false}, SHIFT(587),
  [2243] = {.count = 1, .reusable = false}, SHIFT(588),
  [2245] = {.count = 1, .reusable = false}, SHIFT(590),
  [2247] = {.count = 1, .reusable = false}, SHIFT(591),
  [2249] = {.count = 1, .reusable = false}, SHIFT(592),
  [2251] = {.count = 1, .reusable = false}, SHIFT(593),
  [2253] = {.count = 1, .reusable = false}, SHIFT(594),
  [2255] = {.count = 1, .reusable = true}, SHIFT(1057),
  [2257] = {.count = 1, .reusable = false}, SHIFT(1059),
  [2259] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 4, .alias_sequence_id = 5),
  [2261] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 4, .alias_sequence_id = 5),
  [2263] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 2),
  [2265] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 2),
  [2267] = {.count = 1, .reusable = false}, SHIFT(1061),
  [2269] = {.count = 1, .reusable = true}, SHIFT(1061),
  [2271] = {.count = 1, .reusable = false}, SHIFT(1062),
  [2273] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 4),
  [2275] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 4),
  [2277] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 4),
  [2279] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 4),
  [2281] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 1),
  [2283] = {.count = 1, .reusable = false}, SHIFT(1069),
  [2285] = {.count = 1, .reusable = true}, SHIFT(1069),
  [2287] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 1),
  [2289] = {.count = 1, .reusable = true}, SHIFT(1070),
  [2291] = {.count = 1, .reusable = false}, SHIFT(1070),
  [2293] = {.count = 1, .reusable = true}, SHIFT(605),
  [2295] = {.count = 1, .reusable = true}, SHIFT(606),
  [2297] = {.count = 1, .reusable = false}, SHIFT(1075),
  [2299] = {.count = 1, .reusable = true}, SHIFT(1076),
  [2301] = {.count = 1, .reusable = true}, SHIFT(1077),
  [2303] = {.count = 1, .reusable = false}, SHIFT(1077),
  [2305] = {.count = 1, .reusable = false}, SHIFT(1081),
  [2307] = {.count = 1, .reusable = true}, SHIFT(1081),
  [2309] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(228),
  [2312] = {.count = 1, .reusable = false}, SHIFT(1082),
  [2314] = {.count = 1, .reusable = false}, SHIFT(1085),
  [2316] = {.count = 1, .reusable = true}, SHIFT(1085),
  [2318] = {.count = 1, .reusable = true}, SHIFT(1086),
  [2320] = {.count = 1, .reusable = false}, SHIFT(1087),
  [2322] = {.count = 1, .reusable = true}, SHIFT(1088),
  [2324] = {.count = 1, .reusable = true}, SHIFT(1090),
  [2326] = {.count = 1, .reusable = true}, SHIFT(1091),
  [2328] = {.count = 1, .reusable = true}, SHIFT(1092),
  [2330] = {.count = 1, .reusable = true}, SHIFT(1093),
  [2332] = {.count = 1, .reusable = false}, SHIFT(1095),
  [2334] = {.count = 1, .reusable = true}, SHIFT(1095),
  [2336] = {.count = 1, .reusable = true}, SHIFT(1094),
  [2338] = {.count = 1, .reusable = true}, SHIFT(1096),
  [2340] = {.count = 1, .reusable = false}, SHIFT(1098),
  [2342] = {.count = 1, .reusable = true}, SHIFT(1098),
  [2344] = {.count = 1, .reusable = true}, SHIFT(1097),
  [2346] = {.count = 1, .reusable = false}, SHIFT(1100),
  [2348] = {.count = 1, .reusable = true}, SHIFT(1100),
  [2350] = {.count = 1, .reusable = true}, SHIFT(1099),
  [2352] = {.count = 1, .reusable = true}, SHIFT(1101),
  [2354] = {.count = 1, .reusable = true}, SHIFT(1102),
  [2356] = {.count = 1, .reusable = true}, SHIFT(1103),
  [2358] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 2),
  [2360] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 2),
  [2362] = {.count = 1, .reusable = false}, SHIFT(1105),
  [2364] = {.count = 1, .reusable = true}, SHIFT(1105),
  [2366] = {.count = 1, .reusable = true}, SHIFT(1106),
  [2368] = {.count = 1, .reusable = false}, SHIFT(1108),
  [2370] = {.count = 1, .reusable = true}, SHIFT(1108),
  [2372] = {.count = 1, .reusable = true}, SHIFT(1109),
  [2374] = {.count = 1, .reusable = true}, SHIFT(1110),
  [2376] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 4),
  [2378] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 4),
  [2380] = {.count = 1, .reusable = true}, SHIFT(1114),
  [2382] = {.count = 1, .reusable = true}, SHIFT(1115),
  [2384] = {.count = 1, .reusable = false}, SHIFT(1116),
  [2386] = {.count = 1, .reusable = true}, SHIFT(1117),
  [2388] = {.count = 1, .reusable = false}, SHIFT(1118),
  [2390] = {.count = 1, .reusable = false}, SHIFT(1119),
  [2392] = {.count = 1, .reusable = true}, SHIFT(1121),
  [2394] = {.count = 1, .reusable = true}, SHIFT(1122),
  [2396] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(258),
  [2399] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(259),
  [2402] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(260),
  [2405] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(263),
  [2408] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(264),
  [2411] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 4),
  [2413] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 4),
  [2415] = {.count = 1, .reusable = true}, SHIFT(1126),
  [2417] = {.count = 1, .reusable = true}, SHIFT(1127),
  [2419] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(272),
  [2422] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(274),
  [2425] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(275),
  [2428] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(273),
  [2431] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(276),
  [2434] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(277),
  [2437] = {.count = 1, .reusable = true}, SHIFT(1129),
  [2439] = {.count = 1, .reusable = true}, SHIFT(1131),
  [2441] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [2443] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [2445] = {.count = 1, .reusable = false}, SHIFT(286),
  [2447] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(290),
  [2450] = {.count = 1, .reusable = true}, SHIFT(1134),
  [2452] = {.count = 1, .reusable = false}, SHIFT(1135),
  [2454] = {.count = 1, .reusable = true}, SHIFT(1136),
  [2456] = {.count = 1, .reusable = true}, SHIFT(1138),
  [2458] = {.count = 1, .reusable = true}, SHIFT(1139),
  [2460] = {.count = 1, .reusable = true}, SHIFT(1140),
  [2462] = {.count = 1, .reusable = true}, SHIFT(1141),
  [2464] = {.count = 1, .reusable = false}, SHIFT(1143),
  [2466] = {.count = 1, .reusable = true}, SHIFT(1143),
  [2468] = {.count = 1, .reusable = true}, SHIFT(1142),
  [2470] = {.count = 1, .reusable = true}, SHIFT(1144),
  [2472] = {.count = 1, .reusable = false}, SHIFT(1146),
  [2474] = {.count = 1, .reusable = true}, SHIFT(1146),
  [2476] = {.count = 1, .reusable = true}, SHIFT(1145),
  [2478] = {.count = 1, .reusable = false}, SHIFT(1148),
  [2480] = {.count = 1, .reusable = true}, SHIFT(1148),
  [2482] = {.count = 1, .reusable = true}, SHIFT(1147),
  [2484] = {.count = 1, .reusable = true}, SHIFT(1149),
  [2486] = {.count = 1, .reusable = true}, SHIFT(1150),
  [2488] = {.count = 1, .reusable = true}, SHIFT(1151),
  [2490] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3),
  [2492] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3),
  [2494] = {.count = 1, .reusable = false}, SHIFT(1152),
  [2496] = {.count = 1, .reusable = true}, SHIFT(1152),
  [2498] = {.count = 1, .reusable = true}, SHIFT(1153),
  [2500] = {.count = 1, .reusable = true}, SHIFT(1154),
  [2502] = {.count = 1, .reusable = false}, SHIFT(1155),
  [2504] = {.count = 1, .reusable = true}, SHIFT(1156),
  [2506] = {.count = 1, .reusable = true}, SHIFT(1157),
  [2508] = {.count = 1, .reusable = true}, SHIFT(1158),
  [2510] = {.count = 1, .reusable = true}, SHIFT(1159),
  [2512] = {.count = 1, .reusable = true}, SHIFT(1160),
  [2514] = {.count = 1, .reusable = true}, SHIFT(1162),
  [2516] = {.count = 1, .reusable = true}, SHIFT(1163),
  [2518] = {.count = 1, .reusable = true}, SHIFT(1164),
  [2520] = {.count = 1, .reusable = false}, REDUCE(sym_test_command, 4),
  [2522] = {.count = 1, .reusable = true}, REDUCE(sym_test_command, 4),
  [2524] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(313),
  [2527] = {.count = 1, .reusable = true}, SHIFT(1167),
  [2529] = {.count = 1, .reusable = false}, SHIFT(1168),
  [2531] = {.count = 1, .reusable = true}, SHIFT(1169),
  [2533] = {.count = 1, .reusable = true}, SHIFT(1171),
  [2535] = {.count = 1, .reusable = true}, SHIFT(1172),
  [2537] = {.count = 1, .reusable = true}, SHIFT(1173),
  [2539] = {.count = 1, .reusable = true}, SHIFT(1174),
  [2541] = {.count = 1, .reusable = false}, SHIFT(1176),
  [2543] = {.count = 1, .reusable = true}, SHIFT(1176),
  [2545] = {.count = 1, .reusable = true}, SHIFT(1175),
  [2547] = {.count = 1, .reusable = true}, SHIFT(1177),
  [2549] = {.count = 1, .reusable = false}, SHIFT(1179),
  [2551] = {.count = 1, .reusable = true}, SHIFT(1179),
  [2553] = {.count = 1, .reusable = true}, SHIFT(1178),
  [2555] = {.count = 1, .reusable = false}, SHIFT(1181),
  [2557] = {.count = 1, .reusable = true}, SHIFT(1181),
  [2559] = {.count = 1, .reusable = true}, SHIFT(1180),
  [2561] = {.count = 1, .reusable = true}, SHIFT(1182),
  [2563] = {.count = 1, .reusable = true}, SHIFT(1183),
  [2565] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2567] = {.count = 1, .reusable = true}, SHIFT(1185),
  [2569] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(334),
  [2572] = {.count = 1, .reusable = true}, SHIFT(1187),
  [2574] = {.count = 1, .reusable = false}, SHIFT(1188),
  [2576] = {.count = 1, .reusable = true}, SHIFT(1189),
  [2578] = {.count = 1, .reusable = true}, SHIFT(1191),
  [2580] = {.count = 1, .reusable = true}, SHIFT(1192),
  [2582] = {.count = 1, .reusable = true}, SHIFT(1193),
  [2584] = {.count = 1, .reusable = true}, SHIFT(1194),
  [2586] = {.count = 1, .reusable = false}, SHIFT(1196),
  [2588] = {.count = 1, .reusable = true}, SHIFT(1196),
  [2590] = {.count = 1, .reusable = true}, SHIFT(1195),
  [2592] = {.count = 1, .reusable = true}, SHIFT(1197),
  [2594] = {.count = 1, .reusable = false}, SHIFT(1199),
  [2596] = {.count = 1, .reusable = true}, SHIFT(1199),
  [2598] = {.count = 1, .reusable = true}, SHIFT(1198),
  [2600] = {.count = 1, .reusable = false}, SHIFT(1201),
  [2602] = {.count = 1, .reusable = true}, SHIFT(1201),
  [2604] = {.count = 1, .reusable = true}, SHIFT(1200),
  [2606] = {.count = 1, .reusable = true}, SHIFT(1202),
  [2608] = {.count = 1, .reusable = true}, SHIFT(1203),
  [2610] = {.count = 1, .reusable = true}, SHIFT(1204),
  [2612] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(353),
  [2615] = {.count = 1, .reusable = true}, SHIFT(1205),
  [2617] = {.count = 1, .reusable = false}, SHIFT(1206),
  [2619] = {.count = 1, .reusable = true}, SHIFT(1207),
  [2621] = {.count = 1, .reusable = true}, SHIFT(1209),
  [2623] = {.count = 1, .reusable = true}, SHIFT(1210),
  [2625] = {.count = 1, .reusable = true}, SHIFT(1211),
  [2627] = {.count = 1, .reusable = true}, SHIFT(1212),
  [2629] = {.count = 1, .reusable = false}, SHIFT(1214),
  [2631] = {.count = 1, .reusable = true}, SHIFT(1214),
  [2633] = {.count = 1, .reusable = true}, SHIFT(1213),
  [2635] = {.count = 1, .reusable = true}, SHIFT(1215),
  [2637] = {.count = 1, .reusable = false}, SHIFT(1217),
  [2639] = {.count = 1, .reusable = true}, SHIFT(1217),
  [2641] = {.count = 1, .reusable = true}, SHIFT(1216),
  [2643] = {.count = 1, .reusable = false}, SHIFT(1219),
  [2645] = {.count = 1, .reusable = true}, SHIFT(1219),
  [2647] = {.count = 1, .reusable = true}, SHIFT(1218),
  [2649] = {.count = 1, .reusable = true}, SHIFT(1220),
  [2651] = {.count = 1, .reusable = true}, SHIFT(1221),
  [2653] = {.count = 1, .reusable = true}, SHIFT(1222),
  [2655] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(372),
  [2658] = {.count = 1, .reusable = true}, SHIFT(1223),
  [2660] = {.count = 1, .reusable = false}, SHIFT(1224),
  [2662] = {.count = 1, .reusable = true}, SHIFT(1225),
  [2664] = {.count = 1, .reusable = true}, SHIFT(1227),
  [2666] = {.count = 1, .reusable = true}, SHIFT(1228),
  [2668] = {.count = 1, .reusable = true}, SHIFT(1229),
  [2670] = {.count = 1, .reusable = true}, SHIFT(1230),
  [2672] = {.count = 1, .reusable = false}, SHIFT(1232),
  [2674] = {.count = 1, .reusable = true}, SHIFT(1232),
  [2676] = {.count = 1, .reusable = true}, SHIFT(1231),
  [2678] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2680] = {.count = 1, .reusable = false}, SHIFT(1235),
  [2682] = {.count = 1, .reusable = true}, SHIFT(1235),
  [2684] = {.count = 1, .reusable = true}, SHIFT(1234),
  [2686] = {.count = 1, .reusable = false}, SHIFT(1237),
  [2688] = {.count = 1, .reusable = true}, SHIFT(1237),
  [2690] = {.count = 1, .reusable = true}, SHIFT(1236),
  [2692] = {.count = 1, .reusable = true}, SHIFT(1238),
  [2694] = {.count = 1, .reusable = true}, SHIFT(1239),
  [2696] = {.count = 1, .reusable = true}, SHIFT(1240),
  [2698] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 3),
  [2700] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 3),
  [2702] = {.count = 1, .reusable = true}, SHIFT(1241),
  [2704] = {.count = 1, .reusable = false}, SHIFT(1242),
  [2706] = {.count = 1, .reusable = true}, SHIFT(1243),
  [2708] = {.count = 1, .reusable = true}, SHIFT(1245),
  [2710] = {.count = 1, .reusable = true}, SHIFT(1246),
  [2712] = {.count = 1, .reusable = true}, SHIFT(1247),
  [2714] = {.count = 1, .reusable = true}, SHIFT(1248),
  [2716] = {.count = 1, .reusable = false}, SHIFT(1250),
  [2718] = {.count = 1, .reusable = true}, SHIFT(1250),
  [2720] = {.count = 1, .reusable = true}, SHIFT(1249),
  [2722] = {.count = 1, .reusable = true}, SHIFT(1251),
  [2724] = {.count = 1, .reusable = false}, SHIFT(1253),
  [2726] = {.count = 1, .reusable = true}, SHIFT(1253),
  [2728] = {.count = 1, .reusable = true}, SHIFT(1252),
  [2730] = {.count = 1, .reusable = false}, SHIFT(1255),
  [2732] = {.count = 1, .reusable = true}, SHIFT(1255),
  [2734] = {.count = 1, .reusable = true}, SHIFT(1254),
  [2736] = {.count = 1, .reusable = true}, SHIFT(1256),
  [2738] = {.count = 1, .reusable = true}, SHIFT(1257),
  [2740] = {.count = 1, .reusable = true}, SHIFT(1258),
  [2742] = {.count = 1, .reusable = true}, SHIFT(1259),
  [2744] = {.count = 1, .reusable = true}, SHIFT(1260),
  [2746] = {.count = 1, .reusable = true}, SHIFT(1261),
  [2748] = {.count = 1, .reusable = true}, SHIFT(1262),
  [2750] = {.count = 1, .reusable = true}, SHIFT(1263),
  [2752] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4),
  [2754] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4),
  [2756] = {.count = 1, .reusable = true}, SHIFT(1264),
  [2758] = {.count = 1, .reusable = true}, SHIFT(1265),
  [2760] = {.count = 1, .reusable = false}, SHIFT(1267),
  [2762] = {.count = 1, .reusable = true}, SHIFT(1269),
  [2764] = {.count = 1, .reusable = true}, SHIFT(1270),
  [2766] = {.count = 1, .reusable = false}, SHIFT(1271),
  [2768] = {.count = 1, .reusable = false}, SHIFT(1269),
  [2770] = {.count = 1, .reusable = true}, SHIFT(1272),
  [2772] = {.count = 1, .reusable = true}, SHIFT(1273),
  [2774] = {.count = 1, .reusable = true}, SHIFT(1274),
  [2776] = {.count = 1, .reusable = true}, SHIFT(1275),
  [2778] = {.count = 1, .reusable = false}, SHIFT(1276),
  [2780] = {.count = 1, .reusable = false}, SHIFT(1274),
  [2782] = {.count = 1, .reusable = true}, SHIFT(1284),
  [2784] = {.count = 1, .reusable = false}, SHIFT(1286),
  [2786] = {.count = 1, .reusable = true}, SHIFT(1287),
  [2788] = {.count = 1, .reusable = true}, SHIFT(1288),
  [2790] = {.count = 1, .reusable = false}, SHIFT(1290),
  [2792] = {.count = 1, .reusable = true}, SHIFT(1290),
  [2794] = {.count = 1, .reusable = true}, SHIFT(1289),
  [2796] = {.count = 1, .reusable = true}, SHIFT(1291),
  [2798] = {.count = 1, .reusable = true}, SHIFT(1292),
  [2800] = {.count = 1, .reusable = false}, SHIFT(1293),
  [2802] = {.count = 1, .reusable = false}, SHIFT(1292),
  [2804] = {.count = 1, .reusable = true}, SHIFT(1295),
  [2806] = {.count = 1, .reusable = false}, SHIFT(1297),
  [2808] = {.count = 1, .reusable = true}, SHIFT(1297),
  [2810] = {.count = 1, .reusable = true}, SHIFT(1296),
  [2812] = {.count = 1, .reusable = true}, SHIFT(1298),
  [2814] = {.count = 1, .reusable = false}, SHIFT(1300),
  [2816] = {.count = 1, .reusable = true}, SHIFT(1300),
  [2818] = {.count = 1, .reusable = true}, SHIFT(1299),
  [2820] = {.count = 1, .reusable = true}, SHIFT(1301),
  [2822] = {.count = 1, .reusable = false}, SHIFT(1302),
  [2824] = {.count = 1, .reusable = true}, SHIFT(1302),
  [2826] = {.count = 1, .reusable = true}, SHIFT(1303),
  [2828] = {.count = 1, .reusable = true}, SHIFT(1304),
  [2830] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 4),
  [2832] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 4),
  [2834] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2),
  [2836] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(839),
  [2839] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(410),
  [2842] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(411),
  [2845] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(412),
  [2848] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(413),
  [2851] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(839),
  [2854] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(414),
  [2857] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(416),
  [2860] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(417),
  [2863] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(418),
  [2866] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(413),
  [2869] = {.count = 1, .reusable = false}, SHIFT(1305),
  [2871] = {.count = 1, .reusable = true}, SHIFT(1306),
  [2873] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 7),
  [2875] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 7),
  [2877] = {.count = 1, .reusable = true}, SHIFT(1308),
  [2879] = {.count = 1, .reusable = true}, SHIFT(1309),
  [2881] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 8),
  [2883] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 8),
  [2885] = {.count = 1, .reusable = true}, SHIFT(1310),
  [2887] = {.count = 1, .reusable = true}, SHIFT(1311),
  [2889] = {.count = 1, .reusable = true}, SHIFT(1312),
  [2891] = {.count = 1, .reusable = true}, SHIFT(1313),
  [2893] = {.count = 1, .reusable = false}, SHIFT(1314),
  [2895] = {.count = 1, .reusable = true}, SHIFT(1314),
  [2897] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [2899] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [2901] = {.count = 1, .reusable = true}, SHIFT(1315),
  [2903] = {.count = 1, .reusable = false}, SHIFT(1316),
  [2905] = {.count = 1, .reusable = true}, SHIFT(1316),
  [2907] = {.count = 1, .reusable = true}, SHIFT(1319),
  [2909] = {.count = 1, .reusable = false}, SHIFT(1321),
  [2911] = {.count = 1, .reusable = false}, SHIFT(1325),
  [2913] = {.count = 1, .reusable = false}, SHIFT(1329),
  [2915] = {.count = 1, .reusable = true}, SHIFT(1329),
  [2917] = {.count = 1, .reusable = true}, SHIFT(1330),
  [2919] = {.count = 1, .reusable = false}, SHIFT(1331),
  [2921] = {.count = 1, .reusable = true}, SHIFT(1331),
  [2923] = {.count = 1, .reusable = true}, SHIFT(1332),
  [2925] = {.count = 1, .reusable = true}, SHIFT(1333),
  [2927] = {.count = 1, .reusable = true}, SHIFT(1334),
  [2929] = {.count = 1, .reusable = true}, SHIFT(1336),
  [2931] = {.count = 1, .reusable = false}, SHIFT(1337),
  [2933] = {.count = 1, .reusable = true}, SHIFT(1337),
  [2935] = {.count = 1, .reusable = true}, SHIFT(1339),
  [2937] = {.count = 1, .reusable = false}, SHIFT(1339),
  [2939] = {.count = 1, .reusable = false}, SHIFT(1340),
  [2941] = {.count = 1, .reusable = true}, SHIFT(1340),
  [2943] = {.count = 1, .reusable = true}, SHIFT(1341),
  [2945] = {.count = 1, .reusable = false}, SHIFT(1342),
  [2947] = {.count = 1, .reusable = true}, SHIFT(1342),
  [2949] = {.count = 1, .reusable = false}, SHIFT(1343),
  [2951] = {.count = 1, .reusable = true}, SHIFT(1343),
  [2953] = {.count = 1, .reusable = true}, SHIFT(1344),
  [2955] = {.count = 1, .reusable = true}, SHIFT(1346),
  [2957] = {.count = 1, .reusable = true}, SHIFT(1347),
  [2959] = {.count = 1, .reusable = true}, SHIFT(1348),
  [2961] = {.count = 1, .reusable = true}, SHIFT(1349),
  [2963] = {.count = 1, .reusable = true}, SHIFT(1350),
  [2965] = {.count = 1, .reusable = false}, SHIFT(1352),
  [2967] = {.count = 1, .reusable = true}, SHIFT(1353),
  [2969] = {.count = 1, .reusable = true}, SHIFT(1354),
  [2971] = {.count = 1, .reusable = false}, SHIFT(1356),
  [2973] = {.count = 1, .reusable = true}, SHIFT(1356),
  [2975] = {.count = 1, .reusable = true}, SHIFT(1355),
  [2977] = {.count = 1, .reusable = true}, SHIFT(1357),
  [2979] = {.count = 1, .reusable = true}, SHIFT(1358),
  [2981] = {.count = 1, .reusable = false}, SHIFT(1359),
  [2983] = {.count = 1, .reusable = false}, SHIFT(1358),
  [2985] = {.count = 1, .reusable = true}, SHIFT(1361),
  [2987] = {.count = 1, .reusable = false}, SHIFT(1363),
  [2989] = {.count = 1, .reusable = true}, SHIFT(1363),
  [2991] = {.count = 1, .reusable = true}, SHIFT(1362),
  [2993] = {.count = 1, .reusable = true}, SHIFT(1364),
  [2995] = {.count = 1, .reusable = false}, SHIFT(1366),
  [2997] = {.count = 1, .reusable = true}, SHIFT(1366),
  [2999] = {.count = 1, .reusable = true}, SHIFT(1365),
  [3001] = {.count = 1, .reusable = true}, SHIFT(1367),
  [3003] = {.count = 1, .reusable = true}, SHIFT(1368),
  [3005] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(444),
  [3008] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(445),
  [3011] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(446),
  [3014] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(447),
  [3017] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(448),
  [3020] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(449),
  [3023] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(450),
  [3026] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(451),
  [3029] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(452),
  [3032] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(453),
  [3035] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(448),
  [3038] = {.count = 1, .reusable = true}, SHIFT(1369),
  [3040] = {.count = 1, .reusable = false}, SHIFT(1371),
  [3042] = {.count = 1, .reusable = true}, SHIFT(1372),
  [3044] = {.count = 1, .reusable = true}, SHIFT(1373),
  [3046] = {.count = 1, .reusable = false}, SHIFT(1375),
  [3048] = {.count = 1, .reusable = true}, SHIFT(1375),
  [3050] = {.count = 1, .reusable = true}, SHIFT(1374),
  [3052] = {.count = 1, .reusable = true}, SHIFT(1376),
  [3054] = {.count = 1, .reusable = true}, SHIFT(1377),
  [3056] = {.count = 1, .reusable = false}, SHIFT(1378),
  [3058] = {.count = 1, .reusable = false}, SHIFT(1377),
  [3060] = {.count = 1, .reusable = true}, SHIFT(1380),
  [3062] = {.count = 1, .reusable = false}, SHIFT(1382),
  [3064] = {.count = 1, .reusable = true}, SHIFT(1382),
  [3066] = {.count = 1, .reusable = true}, SHIFT(1381),
  [3068] = {.count = 1, .reusable = true}, SHIFT(1383),
  [3070] = {.count = 1, .reusable = false}, SHIFT(1385),
  [3072] = {.count = 1, .reusable = true}, SHIFT(1385),
  [3074] = {.count = 1, .reusable = true}, SHIFT(1384),
  [3076] = {.count = 1, .reusable = true}, SHIFT(1386),
  [3078] = {.count = 1, .reusable = true}, SHIFT(1387),
  [3080] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(456),
  [3083] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(457),
  [3086] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(458),
  [3089] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(459),
  [3092] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(460),
  [3095] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(461),
  [3098] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(462),
  [3101] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(463),
  [3104] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(464),
  [3107] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(459),
  [3110] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(466),
  [3113] = {.count = 1, .reusable = true}, SHIFT(1388),
  [3115] = {.count = 1, .reusable = false}, SHIFT(1389),
  [3117] = {.count = 1, .reusable = true}, SHIFT(1390),
  [3119] = {.count = 1, .reusable = true}, SHIFT(1392),
  [3121] = {.count = 1, .reusable = true}, SHIFT(1393),
  [3123] = {.count = 1, .reusable = true}, SHIFT(1394),
  [3125] = {.count = 1, .reusable = true}, SHIFT(1395),
  [3127] = {.count = 1, .reusable = false}, SHIFT(1397),
  [3129] = {.count = 1, .reusable = true}, SHIFT(1397),
  [3131] = {.count = 1, .reusable = true}, SHIFT(1396),
  [3133] = {.count = 1, .reusable = true}, SHIFT(1398),
  [3135] = {.count = 1, .reusable = false}, SHIFT(1400),
  [3137] = {.count = 1, .reusable = true}, SHIFT(1400),
  [3139] = {.count = 1, .reusable = true}, SHIFT(1399),
  [3141] = {.count = 1, .reusable = false}, SHIFT(1402),
  [3143] = {.count = 1, .reusable = true}, SHIFT(1402),
  [3145] = {.count = 1, .reusable = true}, SHIFT(1401),
  [3147] = {.count = 1, .reusable = true}, SHIFT(1403),
  [3149] = {.count = 1, .reusable = true}, SHIFT(1404),
  [3151] = {.count = 1, .reusable = true}, SHIFT(1405),
  [3153] = {.count = 1, .reusable = true}, SHIFT(1407),
  [3155] = {.count = 1, .reusable = true}, SHIFT(1408),
  [3157] = {.count = 1, .reusable = true}, SHIFT(1409),
  [3159] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(490),
  [3162] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(492),
  [3165] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(492),
  [3168] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(493),
  [3171] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(493),
  [3174] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(494),
  [3177] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(491),
  [3180] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(495),
  [3183] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(155),
  [3186] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(156),
  [3189] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(496),
  [3192] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(158),
  [3195] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(159),
  [3198] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(160),
  [3201] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(161),
  [3204] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(496),
  [3207] = {.count = 1, .reusable = true}, SHIFT(1416),
  [3209] = {.count = 1, .reusable = true}, SHIFT(1417),
  [3211] = {.count = 1, .reusable = false}, SHIFT(1418),
  [3213] = {.count = 1, .reusable = true}, SHIFT(1418),
  [3215] = {.count = 1, .reusable = true}, SHIFT(1419),
  [3217] = {.count = 1, .reusable = false}, SHIFT(1420),
  [3219] = {.count = 1, .reusable = true}, SHIFT(1420),
  [3221] = {.count = 1, .reusable = true}, SHIFT(1421),
  [3223] = {.count = 1, .reusable = true}, SHIFT(1423),
  [3225] = {.count = 1, .reusable = true}, SHIFT(1424),
  [3227] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(506),
  [3230] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(507),
  [3233] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(508),
  [3236] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(508),
  [3239] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(511),
  [3242] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(512),
  [3245] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(512),
  [3248] = {.count = 1, .reusable = true}, SHIFT(1428),
  [3250] = {.count = 1, .reusable = true}, SHIFT(1429),
  [3252] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(518),
  [3255] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(520),
  [3258] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(520),
  [3261] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(521),
  [3264] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(519),
  [3267] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(522),
  [3270] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(523),
  [3273] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(523),
  [3276] = {.count = 1, .reusable = true}, SHIFT(1433),
  [3278] = {.count = 1, .reusable = true}, SHIFT(1434),
  [3280] = {.count = 1, .reusable = false}, SHIFT(1436),
  [3282] = {.count = 1, .reusable = true}, SHIFT(1436),
  [3284] = {.count = 1, .reusable = true}, SHIFT(1435),
  [3286] = {.count = 1, .reusable = true}, SHIFT(1437),
  [3288] = {.count = 1, .reusable = true}, SHIFT(1438),
  [3290] = {.count = 1, .reusable = false}, SHIFT(1439),
  [3292] = {.count = 1, .reusable = false}, SHIFT(1438),
  [3294] = {.count = 1, .reusable = true}, SHIFT(1441),
  [3296] = {.count = 1, .reusable = false}, SHIFT(1443),
  [3298] = {.count = 1, .reusable = true}, SHIFT(1443),
  [3300] = {.count = 1, .reusable = true}, SHIFT(1442),
  [3302] = {.count = 1, .reusable = true}, SHIFT(1444),
  [3304] = {.count = 1, .reusable = false}, SHIFT(1446),
  [3306] = {.count = 1, .reusable = true}, SHIFT(1446),
  [3308] = {.count = 1, .reusable = true}, SHIFT(1445),
  [3310] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 3),
  [3312] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 3),
  [3314] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(988),
  [3317] = {.count = 1, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2),
  [3319] = {.count = 2, .reusable = false}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(534),
  [3322] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(535),
  [3325] = {.count = 1, .reusable = false}, REDUCE(sym_command, 4),
  [3327] = {.count = 1, .reusable = true}, REDUCE(sym_command, 4),
  [3329] = {.count = 1, .reusable = true}, SHIFT(1449),
  [3331] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5, .alias_sequence_id = 6),
  [3333] = {.count = 1, .reusable = true}, SHIFT(1450),
  [3335] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5),
  [3337] = {.count = 1, .reusable = true}, SHIFT(1451),
  [3339] = {.count = 1, .reusable = false}, SHIFT(1453),
  [3341] = {.count = 1, .reusable = true}, SHIFT(1454),
  [3343] = {.count = 1, .reusable = true}, SHIFT(1455),
  [3345] = {.count = 1, .reusable = false}, SHIFT(1457),
  [3347] = {.count = 1, .reusable = true}, SHIFT(1457),
  [3349] = {.count = 1, .reusable = true}, SHIFT(1456),
  [3351] = {.count = 1, .reusable = true}, SHIFT(1458),
  [3353] = {.count = 1, .reusable = true}, SHIFT(1459),
  [3355] = {.count = 1, .reusable = false}, SHIFT(1460),
  [3357] = {.count = 1, .reusable = false}, SHIFT(1459),
  [3359] = {.count = 1, .reusable = true}, SHIFT(1462),
  [3361] = {.count = 1, .reusable = false}, SHIFT(1464),
  [3363] = {.count = 1, .reusable = true}, SHIFT(1464),
  [3365] = {.count = 1, .reusable = true}, SHIFT(1463),
  [3367] = {.count = 1, .reusable = true}, SHIFT(1465),
  [3369] = {.count = 1, .reusable = false}, SHIFT(1467),
  [3371] = {.count = 1, .reusable = true}, SHIFT(1467),
  [3373] = {.count = 1, .reusable = true}, SHIFT(1466),
  [3375] = {.count = 1, .reusable = true}, SHIFT(1468),
  [3377] = {.count = 1, .reusable = true}, SHIFT(1469),
  [3379] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [3381] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [3383] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [3385] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(560),
  [3388] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(561),
  [3391] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(562),
  [3394] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(563),
  [3397] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(564),
  [3400] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(565),
  [3403] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(566),
  [3406] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(567),
  [3409] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(569),
  [3412] = {.count = 1, .reusable = true}, SHIFT(1470),
  [3414] = {.count = 1, .reusable = false}, SHIFT(1471),
  [3416] = {.count = 1, .reusable = true}, SHIFT(1472),
  [3418] = {.count = 1, .reusable = true}, SHIFT(1474),
  [3420] = {.count = 1, .reusable = true}, SHIFT(1475),
  [3422] = {.count = 1, .reusable = true}, SHIFT(1476),
  [3424] = {.count = 1, .reusable = true}, SHIFT(1477),
  [3426] = {.count = 1, .reusable = false}, SHIFT(1479),
  [3428] = {.count = 1, .reusable = true}, SHIFT(1479),
  [3430] = {.count = 1, .reusable = true}, SHIFT(1478),
  [3432] = {.count = 1, .reusable = true}, SHIFT(1480),
  [3434] = {.count = 1, .reusable = false}, SHIFT(1482),
  [3436] = {.count = 1, .reusable = true}, SHIFT(1482),
  [3438] = {.count = 1, .reusable = true}, SHIFT(1481),
  [3440] = {.count = 1, .reusable = false}, SHIFT(1484),
  [3442] = {.count = 1, .reusable = true}, SHIFT(1484),
  [3444] = {.count = 1, .reusable = true}, SHIFT(1483),
  [3446] = {.count = 1, .reusable = true}, SHIFT(1485),
  [3448] = {.count = 1, .reusable = true}, SHIFT(1486),
  [3450] = {.count = 1, .reusable = true}, SHIFT(1487),
  [3452] = {.count = 1, .reusable = true}, SHIFT(1488),
  [3454] = {.count = 1, .reusable = false}, SHIFT(1490),
  [3456] = {.count = 1, .reusable = true}, SHIFT(1491),
  [3458] = {.count = 1, .reusable = true}, SHIFT(1492),
  [3460] = {.count = 1, .reusable = false}, SHIFT(1494),
  [3462] = {.count = 1, .reusable = true}, SHIFT(1494),
  [3464] = {.count = 1, .reusable = true}, SHIFT(1493),
  [3466] = {.count = 1, .reusable = true}, SHIFT(1495),
  [3468] = {.count = 1, .reusable = true}, SHIFT(1496),
  [3470] = {.count = 1, .reusable = false}, SHIFT(1497),
  [3472] = {.count = 1, .reusable = false}, SHIFT(1496),
  [3474] = {.count = 1, .reusable = true}, SHIFT(1499),
  [3476] = {.count = 1, .reusable = false}, SHIFT(1501),
  [3478] = {.count = 1, .reusable = true}, SHIFT(1501),
  [3480] = {.count = 1, .reusable = true}, SHIFT(1500),
  [3482] = {.count = 1, .reusable = true}, SHIFT(1502),
  [3484] = {.count = 1, .reusable = false}, SHIFT(1504),
  [3486] = {.count = 1, .reusable = true}, SHIFT(1504),
  [3488] = {.count = 1, .reusable = true}, SHIFT(1503),
  [3490] = {.count = 1, .reusable = true}, SHIFT(1505),
  [3492] = {.count = 1, .reusable = true}, SHIFT(1506),
  [3494] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [3496] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(587),
  [3499] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(588),
  [3502] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(589),
  [3505] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(590),
  [3508] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(591),
  [3511] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(592),
  [3514] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(593),
  [3517] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(594),
  [3520] = {.count = 1, .reusable = false}, SHIFT(1508),
  [3522] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 3),
  [3524] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 3),
  [3526] = {.count = 1, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2),
  [3528] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 5),
  [3530] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 5),
  [3532] = {.count = 1, .reusable = true}, SHIFT(1509),
  [3534] = {.count = 1, .reusable = false}, SHIFT(1510),
  [3536] = {.count = 1, .reusable = true}, SHIFT(1510),
  [3538] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 2),
  [3540] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [3542] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [3544] = {.count = 1, .reusable = true}, SHIFT(1512),
  [3546] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [3548] = {.count = 2, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(605),
  [3551] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 3),
  [3553] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 3),
  [3555] = {.count = 1, .reusable = true}, SHIFT(1514),
  [3557] = {.count = 1, .reusable = true}, SHIFT(1515),
  [3559] = {.count = 1, .reusable = true}, SHIFT(1518),
  [3561] = {.count = 1, .reusable = true}, SHIFT(1520),
  [3563] = {.count = 1, .reusable = false}, SHIFT(1523),
  [3565] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5),
  [3567] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5),
  [3569] = {.count = 1, .reusable = true}, SHIFT(1525),
  [3571] = {.count = 1, .reusable = false}, SHIFT(1527),
  [3573] = {.count = 1, .reusable = true}, SHIFT(1529),
  [3575] = {.count = 1, .reusable = true}, SHIFT(1530),
  [3577] = {.count = 1, .reusable = true}, SHIFT(1531),
  [3579] = {.count = 1, .reusable = false}, SHIFT(1532),
  [3581] = {.count = 1, .reusable = true}, SHIFT(1532),
  [3583] = {.count = 1, .reusable = false}, SHIFT(1533),
  [3585] = {.count = 1, .reusable = true}, SHIFT(1534),
  [3587] = {.count = 1, .reusable = true}, SHIFT(1536),
  [3589] = {.count = 1, .reusable = true}, SHIFT(1537),
  [3591] = {.count = 1, .reusable = true}, SHIFT(1538),
  [3593] = {.count = 1, .reusable = true}, SHIFT(1539),
  [3595] = {.count = 1, .reusable = true}, SHIFT(1540),
  [3597] = {.count = 1, .reusable = true}, SHIFT(1541),
  [3599] = {.count = 1, .reusable = false}, SHIFT(1542),
  [3601] = {.count = 1, .reusable = true}, SHIFT(1542),
  [3603] = {.count = 1, .reusable = true}, SHIFT(1543),
  [3605] = {.count = 1, .reusable = false}, SHIFT(1544),
  [3607] = {.count = 1, .reusable = true}, SHIFT(1544),
  [3609] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 5),
  [3611] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 5),
  [3613] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 3),
  [3615] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 3),
  [3617] = {.count = 1, .reusable = true}, SHIFT(1546),
  [3619] = {.count = 1, .reusable = true}, SHIFT(1547),
  [3621] = {.count = 1, .reusable = false}, SHIFT(1552),
  [3623] = {.count = 1, .reusable = true}, SHIFT(1552),
  [3625] = {.count = 1, .reusable = true}, SHIFT(1553),
  [3627] = {.count = 1, .reusable = true}, SHIFT(1554),
  [3629] = {.count = 1, .reusable = false}, SHIFT(1555),
  [3631] = {.count = 1, .reusable = true}, SHIFT(1555),
  [3633] = {.count = 1, .reusable = true}, SHIFT(1556),
  [3635] = {.count = 1, .reusable = true}, SHIFT(1557),
  [3637] = {.count = 1, .reusable = true}, SHIFT(1558),
  [3639] = {.count = 1, .reusable = true}, SHIFT(1559),
  [3641] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 5),
  [3643] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 5),
  [3645] = {.count = 1, .reusable = true}, SHIFT(1562),
  [3647] = {.count = 1, .reusable = true}, SHIFT(1563),
  [3649] = {.count = 1, .reusable = true}, SHIFT(1564),
  [3651] = {.count = 1, .reusable = true}, SHIFT(1565),
  [3653] = {.count = 1, .reusable = false}, SHIFT(1566),
  [3655] = {.count = 1, .reusable = true}, SHIFT(1566),
  [3657] = {.count = 1, .reusable = false}, SHIFT(1567),
  [3659] = {.count = 1, .reusable = true}, SHIFT(1568),
  [3661] = {.count = 1, .reusable = true}, SHIFT(1570),
  [3663] = {.count = 1, .reusable = true}, SHIFT(1571),
  [3665] = {.count = 1, .reusable = true}, SHIFT(1572),
  [3667] = {.count = 1, .reusable = true}, SHIFT(1573),
  [3669] = {.count = 1, .reusable = true}, SHIFT(1574),
  [3671] = {.count = 1, .reusable = true}, SHIFT(1575),
  [3673] = {.count = 1, .reusable = false}, SHIFT(1576),
  [3675] = {.count = 1, .reusable = true}, SHIFT(1576),
  [3677] = {.count = 1, .reusable = true}, SHIFT(1577),
  [3679] = {.count = 1, .reusable = false}, SHIFT(1578),
  [3681] = {.count = 1, .reusable = true}, SHIFT(1578),
  [3683] = {.count = 1, .reusable = true}, SHIFT(1579),
  [3685] = {.count = 1, .reusable = true}, SHIFT(1580),
  [3687] = {.count = 1, .reusable = true}, SHIFT(1582),
  [3689] = {.count = 1, .reusable = false}, SHIFT(1584),
  [3691] = {.count = 1, .reusable = true}, SHIFT(1586),
  [3693] = {.count = 1, .reusable = true}, SHIFT(1587),
  [3695] = {.count = 1, .reusable = false}, SHIFT(1588),
  [3697] = {.count = 1, .reusable = false}, SHIFT(1586),
  [3699] = {.count = 1, .reusable = true}, SHIFT(1589),
  [3701] = {.count = 1, .reusable = true}, SHIFT(1590),
  [3703] = {.count = 1, .reusable = true}, SHIFT(1591),
  [3705] = {.count = 1, .reusable = false}, SHIFT(1592),
  [3707] = {.count = 1, .reusable = false}, SHIFT(1590),
  [3709] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(701),
  [3712] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(702),
  [3715] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(703),
  [3718] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(704),
  [3721] = {.count = 1, .reusable = true}, SHIFT(1600),
  [3723] = {.count = 1, .reusable = true}, SHIFT(1601),
  [3725] = {.count = 1, .reusable = true}, SHIFT(1602),
  [3727] = {.count = 1, .reusable = false}, SHIFT(1603),
  [3729] = {.count = 1, .reusable = true}, SHIFT(1603),
  [3731] = {.count = 1, .reusable = false}, SHIFT(1604),
  [3733] = {.count = 1, .reusable = true}, SHIFT(1605),
  [3735] = {.count = 1, .reusable = true}, SHIFT(1607),
  [3737] = {.count = 1, .reusable = true}, SHIFT(1608),
  [3739] = {.count = 1, .reusable = true}, SHIFT(1609),
  [3741] = {.count = 1, .reusable = true}, SHIFT(1610),
  [3743] = {.count = 1, .reusable = true}, SHIFT(1611),
  [3745] = {.count = 1, .reusable = true}, SHIFT(1612),
  [3747] = {.count = 1, .reusable = false}, SHIFT(1613),
  [3749] = {.count = 1, .reusable = true}, SHIFT(1613),
  [3751] = {.count = 1, .reusable = true}, SHIFT(1614),
  [3753] = {.count = 1, .reusable = false}, SHIFT(1615),
  [3755] = {.count = 1, .reusable = true}, SHIFT(1615),
  [3757] = {.count = 1, .reusable = true}, SHIFT(1616),
  [3759] = {.count = 1, .reusable = true}, SHIFT(1617),
  [3761] = {.count = 1, .reusable = true}, SHIFT(1618),
  [3763] = {.count = 1, .reusable = true}, SHIFT(1619),
  [3765] = {.count = 1, .reusable = false}, SHIFT(1620),
  [3767] = {.count = 1, .reusable = true}, SHIFT(1620),
  [3769] = {.count = 1, .reusable = false}, SHIFT(1621),
  [3771] = {.count = 1, .reusable = true}, SHIFT(1622),
  [3773] = {.count = 1, .reusable = true}, SHIFT(1624),
  [3775] = {.count = 1, .reusable = true}, SHIFT(1625),
  [3777] = {.count = 1, .reusable = true}, SHIFT(1626),
  [3779] = {.count = 1, .reusable = true}, SHIFT(1627),
  [3781] = {.count = 1, .reusable = true}, SHIFT(1628),
  [3783] = {.count = 1, .reusable = true}, SHIFT(1629),
  [3785] = {.count = 1, .reusable = false}, SHIFT(1630),
  [3787] = {.count = 1, .reusable = true}, SHIFT(1630),
  [3789] = {.count = 1, .reusable = true}, SHIFT(1631),
  [3791] = {.count = 1, .reusable = false}, SHIFT(1632),
  [3793] = {.count = 1, .reusable = true}, SHIFT(1632),
  [3795] = {.count = 1, .reusable = true}, SHIFT(1633),
  [3797] = {.count = 1, .reusable = true}, SHIFT(1634),
  [3799] = {.count = 1, .reusable = true}, SHIFT(1635),
  [3801] = {.count = 1, .reusable = false}, SHIFT(1636),
  [3803] = {.count = 1, .reusable = true}, SHIFT(1636),
  [3805] = {.count = 1, .reusable = false}, SHIFT(1637),
  [3807] = {.count = 1, .reusable = true}, SHIFT(1638),
  [3809] = {.count = 1, .reusable = true}, SHIFT(1640),
  [3811] = {.count = 1, .reusable = true}, SHIFT(1641),
  [3813] = {.count = 1, .reusable = true}, SHIFT(1642),
  [3815] = {.count = 1, .reusable = true}, SHIFT(1643),
  [3817] = {.count = 1, .reusable = true}, SHIFT(1644),
  [3819] = {.count = 1, .reusable = true}, SHIFT(1645),
  [3821] = {.count = 1, .reusable = false}, SHIFT(1646),
  [3823] = {.count = 1, .reusable = true}, SHIFT(1646),
  [3825] = {.count = 1, .reusable = true}, SHIFT(1647),
  [3827] = {.count = 1, .reusable = false}, SHIFT(1648),
  [3829] = {.count = 1, .reusable = true}, SHIFT(1648),
  [3831] = {.count = 1, .reusable = true}, SHIFT(1649),
  [3833] = {.count = 1, .reusable = true}, SHIFT(1650),
  [3835] = {.count = 1, .reusable = true}, SHIFT(1651),
  [3837] = {.count = 1, .reusable = false}, SHIFT(1652),
  [3839] = {.count = 1, .reusable = true}, SHIFT(1652),
  [3841] = {.count = 1, .reusable = false}, SHIFT(1653),
  [3843] = {.count = 1, .reusable = true}, SHIFT(1654),
  [3845] = {.count = 1, .reusable = true}, SHIFT(1656),
  [3847] = {.count = 1, .reusable = true}, SHIFT(1657),
  [3849] = {.count = 1, .reusable = true}, SHIFT(1658),
  [3851] = {.count = 1, .reusable = true}, SHIFT(1659),
  [3853] = {.count = 1, .reusable = true}, SHIFT(1660),
  [3855] = {.count = 1, .reusable = true}, SHIFT(1661),
  [3857] = {.count = 1, .reusable = false}, SHIFT(1662),
  [3859] = {.count = 1, .reusable = true}, SHIFT(1662),
  [3861] = {.count = 1, .reusable = true}, SHIFT(1663),
  [3863] = {.count = 1, .reusable = false}, SHIFT(1664),
  [3865] = {.count = 1, .reusable = true}, SHIFT(1664),
  [3867] = {.count = 1, .reusable = true}, SHIFT(1665),
  [3869] = {.count = 1, .reusable = true}, SHIFT(1666),
  [3871] = {.count = 1, .reusable = true}, SHIFT(1667),
  [3873] = {.count = 1, .reusable = false}, SHIFT(1668),
  [3875] = {.count = 1, .reusable = true}, SHIFT(1668),
  [3877] = {.count = 1, .reusable = false}, SHIFT(1669),
  [3879] = {.count = 1, .reusable = true}, SHIFT(1670),
  [3881] = {.count = 1, .reusable = true}, SHIFT(1672),
  [3883] = {.count = 1, .reusable = true}, SHIFT(1673),
  [3885] = {.count = 1, .reusable = true}, SHIFT(1674),
  [3887] = {.count = 1, .reusable = true}, SHIFT(1675),
  [3889] = {.count = 1, .reusable = true}, SHIFT(1676),
  [3891] = {.count = 1, .reusable = true}, SHIFT(1677),
  [3893] = {.count = 1, .reusable = false}, SHIFT(1678),
  [3895] = {.count = 1, .reusable = true}, SHIFT(1678),
  [3897] = {.count = 1, .reusable = true}, SHIFT(1679),
  [3899] = {.count = 1, .reusable = false}, SHIFT(1680),
  [3901] = {.count = 1, .reusable = true}, SHIFT(1680),
  [3903] = {.count = 1, .reusable = true}, SHIFT(1681),
  [3905] = {.count = 1, .reusable = true}, SHIFT(1682),
  [3907] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4, .alias_sequence_id = 6),
  [3909] = {.count = 1, .reusable = true}, SHIFT(1683),
  [3911] = {.count = 1, .reusable = true}, SHIFT(1684),
  [3913] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4),
  [3915] = {.count = 1, .reusable = true}, SHIFT(1685),
  [3917] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 9),
  [3919] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 9),
  [3921] = {.count = 1, .reusable = false}, SHIFT(1687),
  [3923] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5),
  [3925] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5),
  [3927] = {.count = 1, .reusable = true}, SHIFT(1688),
  [3929] = {.count = 1, .reusable = true}, SHIFT(1689),
  [3931] = {.count = 1, .reusable = false}, SHIFT(1691),
  [3933] = {.count = 1, .reusable = true}, SHIFT(1691),
  [3935] = {.count = 1, .reusable = true}, SHIFT(1690),
  [3937] = {.count = 1, .reusable = true}, SHIFT(1692),
  [3939] = {.count = 1, .reusable = true}, SHIFT(1693),
  [3941] = {.count = 1, .reusable = false}, SHIFT(1694),
  [3943] = {.count = 1, .reusable = false}, SHIFT(1693),
  [3945] = {.count = 1, .reusable = true}, SHIFT(1696),
  [3947] = {.count = 1, .reusable = false}, SHIFT(1698),
  [3949] = {.count = 1, .reusable = true}, SHIFT(1698),
  [3951] = {.count = 1, .reusable = true}, SHIFT(1697),
  [3953] = {.count = 1, .reusable = true}, SHIFT(1699),
  [3955] = {.count = 1, .reusable = false}, SHIFT(1701),
  [3957] = {.count = 1, .reusable = true}, SHIFT(1701),
  [3959] = {.count = 1, .reusable = true}, SHIFT(1700),
  [3961] = {.count = 1, .reusable = true}, SHIFT(1702),
  [3963] = {.count = 1, .reusable = true}, SHIFT(1703),
  [3965] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(819),
  [3968] = {.count = 1, .reusable = true}, SHIFT(1704),
  [3970] = {.count = 1, .reusable = false}, SHIFT(1705),
  [3972] = {.count = 1, .reusable = true}, SHIFT(1706),
  [3974] = {.count = 1, .reusable = true}, SHIFT(1708),
  [3976] = {.count = 1, .reusable = true}, SHIFT(1709),
  [3978] = {.count = 1, .reusable = true}, SHIFT(1710),
  [3980] = {.count = 1, .reusable = true}, SHIFT(1711),
  [3982] = {.count = 1, .reusable = false}, SHIFT(1713),
  [3984] = {.count = 1, .reusable = true}, SHIFT(1713),
  [3986] = {.count = 1, .reusable = true}, SHIFT(1712),
  [3988] = {.count = 1, .reusable = true}, SHIFT(1714),
  [3990] = {.count = 1, .reusable = false}, SHIFT(1716),
  [3992] = {.count = 1, .reusable = true}, SHIFT(1716),
  [3994] = {.count = 1, .reusable = true}, SHIFT(1715),
  [3996] = {.count = 1, .reusable = false}, SHIFT(1718),
  [3998] = {.count = 1, .reusable = true}, SHIFT(1718),
  [4000] = {.count = 1, .reusable = true}, SHIFT(1717),
  [4002] = {.count = 1, .reusable = true}, SHIFT(1719),
  [4004] = {.count = 1, .reusable = true}, SHIFT(1720),
  [4006] = {.count = 1, .reusable = true}, SHIFT(1721),
  [4008] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 10),
  [4010] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 10),
  [4012] = {.count = 1, .reusable = true}, SHIFT(1722),
  [4014] = {.count = 1, .reusable = true}, SHIFT(1723),
  [4016] = {.count = 1, .reusable = true}, SHIFT(1724),
  [4018] = {.count = 1, .reusable = true}, SHIFT(1725),
  [4020] = {.count = 1, .reusable = false}, SHIFT(1726),
  [4022] = {.count = 1, .reusable = true}, SHIFT(1726),
  [4024] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 7),
  [4026] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 7),
  [4028] = {.count = 1, .reusable = true}, SHIFT(1727),
  [4030] = {.count = 1, .reusable = false}, SHIFT(1728),
  [4032] = {.count = 1, .reusable = true}, SHIFT(1728),
  [4034] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 8),
  [4036] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 8),
  [4038] = {.count = 1, .reusable = true}, SHIFT(1729),
  [4040] = {.count = 1, .reusable = false}, SHIFT(1730),
  [4042] = {.count = 1, .reusable = true}, SHIFT(1730),
  [4044] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 11),
  [4046] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 11),
  [4048] = {.count = 1, .reusable = true}, SHIFT(1731),
  [4050] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 12),
  [4052] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 12),
  [4054] = {.count = 1, .reusable = true}, SHIFT(1732),
  [4056] = {.count = 1, .reusable = false}, SHIFT(1734),
  [4058] = {.count = 1, .reusable = true}, SHIFT(1734),
  [4060] = {.count = 1, .reusable = false}, SHIFT(1735),
  [4062] = {.count = 1, .reusable = false}, SHIFT(1737),
  [4064] = {.count = 1, .reusable = true}, SHIFT(1739),
  [4066] = {.count = 1, .reusable = false}, SHIFT(1739),
  [4068] = {.count = 1, .reusable = false}, SHIFT(1742),
  [4070] = {.count = 1, .reusable = false}, SHIFT(1745),
  [4072] = {.count = 1, .reusable = true}, SHIFT(1745),
  [4074] = {.count = 1, .reusable = false}, SHIFT(1746),
  [4076] = {.count = 1, .reusable = false}, SHIFT(1749),
  [4078] = {.count = 1, .reusable = true}, SHIFT(1749),
  [4080] = {.count = 1, .reusable = true}, SHIFT(1751),
  [4082] = {.count = 1, .reusable = false}, SHIFT(1752),
  [4084] = {.count = 1, .reusable = true}, SHIFT(1752),
  [4086] = {.count = 1, .reusable = true}, SHIFT(1753),
  [4088] = {.count = 1, .reusable = true}, SHIFT(1754),
  [4090] = {.count = 1, .reusable = true}, SHIFT(1756),
  [4092] = {.count = 1, .reusable = false}, SHIFT(1757),
  [4094] = {.count = 1, .reusable = true}, SHIFT(1757),
  [4096] = {.count = 1, .reusable = true}, SHIFT(1758),
  [4098] = {.count = 1, .reusable = true}, SHIFT(1759),
  [4100] = {.count = 1, .reusable = false}, SHIFT(1760),
  [4102] = {.count = 1, .reusable = true}, SHIFT(1761),
  [4104] = {.count = 1, .reusable = true}, SHIFT(1762),
  [4106] = {.count = 1, .reusable = true}, SHIFT(1763),
  [4108] = {.count = 1, .reusable = true}, SHIFT(1764),
  [4110] = {.count = 1, .reusable = true}, SHIFT(1765),
  [4112] = {.count = 1, .reusable = true}, SHIFT(1767),
  [4114] = {.count = 1, .reusable = true}, SHIFT(1768),
  [4116] = {.count = 1, .reusable = true}, SHIFT(1769),
  [4118] = {.count = 1, .reusable = true}, SHIFT(1772),
  [4120] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(872),
  [4123] = {.count = 1, .reusable = true}, SHIFT(1774),
  [4125] = {.count = 1, .reusable = false}, SHIFT(1775),
  [4127] = {.count = 1, .reusable = true}, SHIFT(1776),
  [4129] = {.count = 1, .reusable = true}, SHIFT(1778),
  [4131] = {.count = 1, .reusable = true}, SHIFT(1779),
  [4133] = {.count = 1, .reusable = true}, SHIFT(1780),
  [4135] = {.count = 1, .reusable = true}, SHIFT(1781),
  [4137] = {.count = 1, .reusable = false}, SHIFT(1783),
  [4139] = {.count = 1, .reusable = true}, SHIFT(1783),
  [4141] = {.count = 1, .reusable = true}, SHIFT(1782),
  [4143] = {.count = 1, .reusable = true}, SHIFT(1784),
  [4145] = {.count = 1, .reusable = false}, SHIFT(1786),
  [4147] = {.count = 1, .reusable = true}, SHIFT(1786),
  [4149] = {.count = 1, .reusable = true}, SHIFT(1785),
  [4151] = {.count = 1, .reusable = false}, SHIFT(1788),
  [4153] = {.count = 1, .reusable = true}, SHIFT(1788),
  [4155] = {.count = 1, .reusable = true}, SHIFT(1787),
  [4157] = {.count = 1, .reusable = true}, SHIFT(1789),
  [4159] = {.count = 1, .reusable = true}, SHIFT(1790),
  [4161] = {.count = 1, .reusable = true}, SHIFT(1791),
  [4163] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(891),
  [4166] = {.count = 1, .reusable = true}, SHIFT(1792),
  [4168] = {.count = 1, .reusable = false}, SHIFT(1793),
  [4170] = {.count = 1, .reusable = true}, SHIFT(1794),
  [4172] = {.count = 1, .reusable = true}, SHIFT(1796),
  [4174] = {.count = 1, .reusable = true}, SHIFT(1797),
  [4176] = {.count = 1, .reusable = true}, SHIFT(1798),
  [4178] = {.count = 1, .reusable = true}, SHIFT(1799),
  [4180] = {.count = 1, .reusable = false}, SHIFT(1801),
  [4182] = {.count = 1, .reusable = true}, SHIFT(1801),
  [4184] = {.count = 1, .reusable = true}, SHIFT(1800),
  [4186] = {.count = 1, .reusable = true}, SHIFT(1802),
  [4188] = {.count = 1, .reusable = false}, SHIFT(1804),
  [4190] = {.count = 1, .reusable = true}, SHIFT(1804),
  [4192] = {.count = 1, .reusable = true}, SHIFT(1803),
  [4194] = {.count = 1, .reusable = false}, SHIFT(1806),
  [4196] = {.count = 1, .reusable = true}, SHIFT(1806),
  [4198] = {.count = 1, .reusable = true}, SHIFT(1805),
  [4200] = {.count = 1, .reusable = true}, SHIFT(1807),
  [4202] = {.count = 1, .reusable = true}, SHIFT(1808),
  [4204] = {.count = 1, .reusable = true}, SHIFT(1809),
  [4206] = {.count = 1, .reusable = true}, SHIFT(1810),
  [4208] = {.count = 1, .reusable = true}, SHIFT(1811),
  [4210] = {.count = 1, .reusable = true}, SHIFT(1812),
  [4212] = {.count = 1, .reusable = false}, SHIFT(1813),
  [4214] = {.count = 1, .reusable = true}, SHIFT(1813),
  [4216] = {.count = 1, .reusable = false}, SHIFT(1814),
  [4218] = {.count = 1, .reusable = true}, SHIFT(1815),
  [4220] = {.count = 1, .reusable = true}, SHIFT(1817),
  [4222] = {.count = 1, .reusable = true}, SHIFT(1818),
  [4224] = {.count = 1, .reusable = true}, SHIFT(1819),
  [4226] = {.count = 1, .reusable = true}, SHIFT(1820),
  [4228] = {.count = 1, .reusable = true}, SHIFT(1821),
  [4230] = {.count = 1, .reusable = true}, SHIFT(1822),
  [4232] = {.count = 1, .reusable = false}, SHIFT(1823),
  [4234] = {.count = 1, .reusable = true}, SHIFT(1823),
  [4236] = {.count = 1, .reusable = true}, SHIFT(1824),
  [4238] = {.count = 1, .reusable = false}, SHIFT(1825),
  [4240] = {.count = 1, .reusable = true}, SHIFT(1825),
  [4242] = {.count = 1, .reusable = false}, SHIFT(1831),
  [4244] = {.count = 1, .reusable = true}, SHIFT(1831),
  [4246] = {.count = 1, .reusable = true}, SHIFT(1832),
  [4248] = {.count = 1, .reusable = true}, SHIFT(1833),
  [4250] = {.count = 1, .reusable = false}, SHIFT(1834),
  [4252] = {.count = 1, .reusable = true}, SHIFT(1834),
  [4254] = {.count = 1, .reusable = true}, SHIFT(1835),
  [4256] = {.count = 1, .reusable = true}, SHIFT(1836),
  [4258] = {.count = 1, .reusable = true}, SHIFT(1837),
  [4260] = {.count = 1, .reusable = true}, SHIFT(1838),
  [4262] = {.count = 1, .reusable = true}, SHIFT(1841),
  [4264] = {.count = 1, .reusable = false}, SHIFT(1842),
  [4266] = {.count = 1, .reusable = true}, SHIFT(1843),
  [4268] = {.count = 1, .reusable = true}, SHIFT(1845),
  [4270] = {.count = 1, .reusable = true}, SHIFT(1846),
  [4272] = {.count = 1, .reusable = true}, SHIFT(1847),
  [4274] = {.count = 1, .reusable = true}, SHIFT(1848),
  [4276] = {.count = 1, .reusable = false}, SHIFT(1850),
  [4278] = {.count = 1, .reusable = true}, SHIFT(1850),
  [4280] = {.count = 1, .reusable = true}, SHIFT(1849),
  [4282] = {.count = 1, .reusable = true}, SHIFT(1851),
  [4284] = {.count = 1, .reusable = false}, SHIFT(1853),
  [4286] = {.count = 1, .reusable = true}, SHIFT(1853),
  [4288] = {.count = 1, .reusable = true}, SHIFT(1852),
  [4290] = {.count = 1, .reusable = false}, SHIFT(1855),
  [4292] = {.count = 1, .reusable = true}, SHIFT(1855),
  [4294] = {.count = 1, .reusable = true}, SHIFT(1854),
  [4296] = {.count = 1, .reusable = true}, SHIFT(1856),
  [4298] = {.count = 1, .reusable = true}, SHIFT(1857),
  [4300] = {.count = 1, .reusable = true}, SHIFT(1858),
  [4302] = {.count = 1, .reusable = false}, REDUCE(sym_command, 5),
  [4304] = {.count = 1, .reusable = true}, REDUCE(sym_command, 5),
  [4306] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6, .alias_sequence_id = 6),
  [4308] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6),
  [4310] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1000),
  [4313] = {.count = 1, .reusable = true}, SHIFT(1859),
  [4315] = {.count = 1, .reusable = false}, SHIFT(1860),
  [4317] = {.count = 1, .reusable = true}, SHIFT(1861),
  [4319] = {.count = 1, .reusable = true}, SHIFT(1863),
  [4321] = {.count = 1, .reusable = true}, SHIFT(1864),
  [4323] = {.count = 1, .reusable = true}, SHIFT(1865),
  [4325] = {.count = 1, .reusable = true}, SHIFT(1866),
  [4327] = {.count = 1, .reusable = false}, SHIFT(1868),
  [4329] = {.count = 1, .reusable = true}, SHIFT(1868),
  [4331] = {.count = 1, .reusable = true}, SHIFT(1867),
  [4333] = {.count = 1, .reusable = true}, SHIFT(1869),
  [4335] = {.count = 1, .reusable = false}, SHIFT(1871),
  [4337] = {.count = 1, .reusable = true}, SHIFT(1871),
  [4339] = {.count = 1, .reusable = true}, SHIFT(1870),
  [4341] = {.count = 1, .reusable = false}, SHIFT(1873),
  [4343] = {.count = 1, .reusable = true}, SHIFT(1873),
  [4345] = {.count = 1, .reusable = true}, SHIFT(1872),
  [4347] = {.count = 1, .reusable = true}, SHIFT(1874),
  [4349] = {.count = 1, .reusable = true}, SHIFT(1875),
  [4351] = {.count = 1, .reusable = true}, SHIFT(1876),
  [4353] = {.count = 1, .reusable = true}, SHIFT(1877),
  [4355] = {.count = 1, .reusable = true}, SHIFT(1878),
  [4357] = {.count = 1, .reusable = true}, SHIFT(1879),
  [4359] = {.count = 1, .reusable = false}, SHIFT(1880),
  [4361] = {.count = 1, .reusable = true}, SHIFT(1880),
  [4363] = {.count = 1, .reusable = false}, SHIFT(1881),
  [4365] = {.count = 1, .reusable = true}, SHIFT(1882),
  [4367] = {.count = 1, .reusable = true}, SHIFT(1884),
  [4369] = {.count = 1, .reusable = true}, SHIFT(1885),
  [4371] = {.count = 1, .reusable = true}, SHIFT(1886),
  [4373] = {.count = 1, .reusable = true}, SHIFT(1887),
  [4375] = {.count = 1, .reusable = true}, SHIFT(1888),
  [4377] = {.count = 1, .reusable = true}, SHIFT(1889),
  [4379] = {.count = 1, .reusable = false}, SHIFT(1890),
  [4381] = {.count = 1, .reusable = true}, SHIFT(1890),
  [4383] = {.count = 1, .reusable = true}, SHIFT(1891),
  [4385] = {.count = 1, .reusable = false}, SHIFT(1892),
  [4387] = {.count = 1, .reusable = true}, SHIFT(1892),
  [4389] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1039),
  [4392] = {.count = 1, .reusable = true}, SHIFT(1893),
  [4394] = {.count = 1, .reusable = false}, SHIFT(1894),
  [4396] = {.count = 1, .reusable = true}, SHIFT(1895),
  [4398] = {.count = 1, .reusable = true}, SHIFT(1897),
  [4400] = {.count = 1, .reusable = true}, SHIFT(1898),
  [4402] = {.count = 1, .reusable = true}, SHIFT(1899),
  [4404] = {.count = 1, .reusable = true}, SHIFT(1900),
  [4406] = {.count = 1, .reusable = false}, SHIFT(1902),
  [4408] = {.count = 1, .reusable = true}, SHIFT(1902),
  [4410] = {.count = 1, .reusable = true}, SHIFT(1901),
  [4412] = {.count = 1, .reusable = true}, SHIFT(1903),
  [4414] = {.count = 1, .reusable = false}, SHIFT(1905),
  [4416] = {.count = 1, .reusable = true}, SHIFT(1905),
  [4418] = {.count = 1, .reusable = true}, SHIFT(1904),
  [4420] = {.count = 1, .reusable = false}, SHIFT(1907),
  [4422] = {.count = 1, .reusable = true}, SHIFT(1907),
  [4424] = {.count = 1, .reusable = true}, SHIFT(1906),
  [4426] = {.count = 1, .reusable = true}, SHIFT(1908),
  [4428] = {.count = 1, .reusable = true}, SHIFT(1909),
  [4430] = {.count = 1, .reusable = true}, SHIFT(1910),
  [4432] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6, .alias_sequence_id = 5),
  [4434] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6, .alias_sequence_id = 5),
  [4436] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 3),
  [4438] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6),
  [4440] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6),
  [4442] = {.count = 1, .reusable = true}, SHIFT(1912),
  [4444] = {.count = 1, .reusable = true}, SHIFT(1913),
  [4446] = {.count = 1, .reusable = true}, SHIFT(1914),
  [4448] = {.count = 1, .reusable = true}, SHIFT(1916),
  [4450] = {.count = 1, .reusable = false}, SHIFT(1917),
  [4452] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2, .alias_sequence_id = 1),
  [4454] = {.count = 1, .reusable = true}, SHIFT(1918),
  [4456] = {.count = 1, .reusable = false}, SHIFT(1919),
  [4458] = {.count = 1, .reusable = false}, SHIFT(1920),
  [4460] = {.count = 1, .reusable = false}, SHIFT(1921),
  [4462] = {.count = 1, .reusable = true}, SHIFT(1922),
  [4464] = {.count = 1, .reusable = false}, SHIFT(1923),
  [4466] = {.count = 1, .reusable = false}, SHIFT(1924),
  [4468] = {.count = 1, .reusable = false}, SHIFT(1925),
  [4470] = {.count = 1, .reusable = true}, SHIFT(1926),
  [4472] = {.count = 1, .reusable = false}, SHIFT(1927),
  [4474] = {.count = 1, .reusable = true}, SHIFT(1928),
  [4476] = {.count = 1, .reusable = true}, SHIFT(1929),
  [4478] = {.count = 1, .reusable = true}, SHIFT(1930),
  [4480] = {.count = 1, .reusable = true}, SHIFT(1931),
  [4482] = {.count = 1, .reusable = true}, SHIFT(1932),
  [4484] = {.count = 1, .reusable = false}, SHIFT(1933),
  [4486] = {.count = 1, .reusable = true}, SHIFT(1941),
  [4488] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2),
  [4490] = {.count = 1, .reusable = true}, SHIFT(1944),
  [4492] = {.count = 1, .reusable = true}, SHIFT(1948),
  [4494] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 13),
  [4496] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 13),
  [4498] = {.count = 1, .reusable = true}, SHIFT(1949),
  [4500] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1950),
  [4503] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(86),
  [4506] = {.count = 2, .reusable = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(87),
  [4509] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1951),
  [4512] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(89),
  [4515] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(90),
  [4518] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(91),
  [4521] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(92),
  [4524] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 3),
  [4526] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 3),
  [4528] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 14),
  [4530] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 14),
  [4532] = {.count = 1, .reusable = true}, SHIFT(1954),
  [4534] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6),
  [4536] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6),
  [4538] = {.count = 1, .reusable = true}, SHIFT(1956),
  [4540] = {.count = 1, .reusable = true}, SHIFT(1957),
  [4542] = {.count = 1, .reusable = true}, SHIFT(1958),
  [4544] = {.count = 1, .reusable = true}, SHIFT(1959),
  [4546] = {.count = 1, .reusable = false}, SHIFT(1960),
  [4548] = {.count = 1, .reusable = true}, SHIFT(1960),
  [4550] = {.count = 1, .reusable = true}, SHIFT(1961),
  [4552] = {.count = 1, .reusable = false}, SHIFT(1962),
  [4554] = {.count = 1, .reusable = true}, SHIFT(1962),
  [4556] = {.count = 1, .reusable = true}, SHIFT(1963),
  [4558] = {.count = 1, .reusable = false}, SHIFT(1964),
  [4560] = {.count = 1, .reusable = true}, SHIFT(1964),
  [4562] = {.count = 1, .reusable = true}, SHIFT(1965),
  [4564] = {.count = 1, .reusable = true}, SHIFT(1966),
  [4566] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 6),
  [4568] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 6),
  [4570] = {.count = 1, .reusable = true}, SHIFT(1968),
  [4572] = {.count = 1, .reusable = true}, SHIFT(1969),
  [4574] = {.count = 1, .reusable = true}, SHIFT(1971),
  [4576] = {.count = 1, .reusable = true}, SHIFT(1972),
  [4578] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1117),
  [4581] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1118),
  [4584] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1119),
  [4587] = {.count = 1, .reusable = true}, SHIFT(1974),
  [4589] = {.count = 1, .reusable = true}, SHIFT(1975),
  [4591] = {.count = 1, .reusable = true}, SHIFT(1976),
  [4593] = {.count = 1, .reusable = true}, SHIFT(1977),
  [4595] = {.count = 1, .reusable = false}, SHIFT(1978),
  [4597] = {.count = 1, .reusable = true}, SHIFT(1978),
  [4599] = {.count = 1, .reusable = true}, SHIFT(1979),
  [4601] = {.count = 1, .reusable = false}, SHIFT(1980),
  [4603] = {.count = 1, .reusable = true}, SHIFT(1980),
  [4605] = {.count = 1, .reusable = true}, SHIFT(1981),
  [4607] = {.count = 1, .reusable = false}, SHIFT(1982),
  [4609] = {.count = 1, .reusable = true}, SHIFT(1982),
  [4611] = {.count = 1, .reusable = true}, SHIFT(1983),
  [4613] = {.count = 1, .reusable = true}, SHIFT(1984),
  [4615] = {.count = 1, .reusable = true}, SHIFT(1985),
  [4617] = {.count = 1, .reusable = false}, SHIFT(1987),
  [4619] = {.count = 1, .reusable = true}, SHIFT(1988),
  [4621] = {.count = 1, .reusable = true}, SHIFT(1989),
  [4623] = {.count = 1, .reusable = false}, SHIFT(1991),
  [4625] = {.count = 1, .reusable = true}, SHIFT(1991),
  [4627] = {.count = 1, .reusable = true}, SHIFT(1990),
  [4629] = {.count = 1, .reusable = true}, SHIFT(1992),
  [4631] = {.count = 1, .reusable = true}, SHIFT(1993),
  [4633] = {.count = 1, .reusable = false}, SHIFT(1994),
  [4635] = {.count = 1, .reusable = false}, SHIFT(1993),
  [4637] = {.count = 1, .reusable = true}, SHIFT(1996),
  [4639] = {.count = 1, .reusable = false}, SHIFT(1998),
  [4641] = {.count = 1, .reusable = true}, SHIFT(1998),
  [4643] = {.count = 1, .reusable = true}, SHIFT(1997),
  [4645] = {.count = 1, .reusable = true}, SHIFT(1999),
  [4647] = {.count = 1, .reusable = false}, SHIFT(2001),
  [4649] = {.count = 1, .reusable = true}, SHIFT(2001),
  [4651] = {.count = 1, .reusable = true}, SHIFT(2000),
  [4653] = {.count = 1, .reusable = true}, SHIFT(2002),
  [4655] = {.count = 1, .reusable = true}, SHIFT(2003),
  [4657] = {.count = 1, .reusable = true}, SHIFT(2004),
  [4659] = {.count = 1, .reusable = true}, SHIFT(2005),
  [4661] = {.count = 1, .reusable = true}, SHIFT(2006),
  [4663] = {.count = 1, .reusable = true}, SHIFT(2007),
  [4665] = {.count = 1, .reusable = false}, SHIFT(2008),
  [4667] = {.count = 1, .reusable = true}, SHIFT(2008),
  [4669] = {.count = 1, .reusable = true}, SHIFT(2009),
  [4671] = {.count = 1, .reusable = false}, SHIFT(2010),
  [4673] = {.count = 1, .reusable = true}, SHIFT(2010),
  [4675] = {.count = 1, .reusable = true}, SHIFT(2011),
  [4677] = {.count = 1, .reusable = false}, SHIFT(2012),
  [4679] = {.count = 1, .reusable = true}, SHIFT(2012),
  [4681] = {.count = 1, .reusable = true}, SHIFT(2013),
  [4683] = {.count = 1, .reusable = true}, SHIFT(2014),
  [4685] = {.count = 1, .reusable = true}, SHIFT(2015),
  [4687] = {.count = 1, .reusable = true}, SHIFT(2016),
  [4689] = {.count = 1, .reusable = true}, SHIFT(2017),
  [4691] = {.count = 1, .reusable = true}, SHIFT(2018),
  [4693] = {.count = 1, .reusable = false}, SHIFT(2019),
  [4695] = {.count = 1, .reusable = true}, SHIFT(2019),
  [4697] = {.count = 1, .reusable = true}, SHIFT(2020),
  [4699] = {.count = 1, .reusable = false}, SHIFT(2021),
  [4701] = {.count = 1, .reusable = true}, SHIFT(2021),
  [4703] = {.count = 1, .reusable = true}, SHIFT(2022),
  [4705] = {.count = 1, .reusable = false}, SHIFT(2023),
  [4707] = {.count = 1, .reusable = true}, SHIFT(2023),
  [4709] = {.count = 1, .reusable = true}, SHIFT(2024),
  [4711] = {.count = 1, .reusable = true}, SHIFT(2025),
  [4713] = {.count = 1, .reusable = true}, SHIFT(2026),
  [4715] = {.count = 1, .reusable = true}, SHIFT(2027),
  [4717] = {.count = 1, .reusable = true}, SHIFT(2028),
  [4719] = {.count = 1, .reusable = true}, SHIFT(2029),
  [4721] = {.count = 1, .reusable = false}, SHIFT(2030),
  [4723] = {.count = 1, .reusable = true}, SHIFT(2030),
  [4725] = {.count = 1, .reusable = true}, SHIFT(2031),
  [4727] = {.count = 1, .reusable = false}, SHIFT(2032),
  [4729] = {.count = 1, .reusable = true}, SHIFT(2032),
  [4731] = {.count = 1, .reusable = true}, SHIFT(2033),
  [4733] = {.count = 1, .reusable = false}, SHIFT(2034),
  [4735] = {.count = 1, .reusable = true}, SHIFT(2034),
  [4737] = {.count = 1, .reusable = true}, SHIFT(2035),
  [4739] = {.count = 1, .reusable = true}, SHIFT(2036),
  [4741] = {.count = 1, .reusable = true}, SHIFT(2037),
  [4743] = {.count = 1, .reusable = true}, SHIFT(2038),
  [4745] = {.count = 1, .reusable = true}, SHIFT(2039),
  [4747] = {.count = 1, .reusable = true}, SHIFT(2040),
  [4749] = {.count = 1, .reusable = false}, SHIFT(2041),
  [4751] = {.count = 1, .reusable = true}, SHIFT(2041),
  [4753] = {.count = 1, .reusable = true}, SHIFT(2042),
  [4755] = {.count = 1, .reusable = false}, SHIFT(2043),
  [4757] = {.count = 1, .reusable = true}, SHIFT(2043),
  [4759] = {.count = 1, .reusable = true}, SHIFT(2044),
  [4761] = {.count = 1, .reusable = false}, SHIFT(2045),
  [4763] = {.count = 1, .reusable = true}, SHIFT(2045),
  [4765] = {.count = 1, .reusable = true}, SHIFT(2046),
  [4767] = {.count = 1, .reusable = true}, SHIFT(2047),
  [4769] = {.count = 1, .reusable = true}, SHIFT(2048),
  [4771] = {.count = 1, .reusable = true}, SHIFT(2049),
  [4773] = {.count = 1, .reusable = true}, SHIFT(2050),
  [4775] = {.count = 1, .reusable = true}, SHIFT(2051),
  [4777] = {.count = 1, .reusable = false}, SHIFT(2052),
  [4779] = {.count = 1, .reusable = true}, SHIFT(2052),
  [4781] = {.count = 1, .reusable = true}, SHIFT(2053),
  [4783] = {.count = 1, .reusable = false}, SHIFT(2054),
  [4785] = {.count = 1, .reusable = true}, SHIFT(2054),
  [4787] = {.count = 1, .reusable = true}, SHIFT(2055),
  [4789] = {.count = 1, .reusable = false}, SHIFT(2056),
  [4791] = {.count = 1, .reusable = true}, SHIFT(2056),
  [4793] = {.count = 1, .reusable = true}, SHIFT(2057),
  [4795] = {.count = 1, .reusable = true}, SHIFT(2058),
  [4797] = {.count = 1, .reusable = true}, SHIFT(2059),
  [4799] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5, .alias_sequence_id = 6),
  [4801] = {.count = 1, .reusable = true}, SHIFT(2060),
  [4803] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5),
  [4805] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1264),
  [4808] = {.count = 1, .reusable = true}, SHIFT(2061),
  [4810] = {.count = 1, .reusable = false}, SHIFT(2062),
  [4812] = {.count = 1, .reusable = true}, SHIFT(2063),
  [4814] = {.count = 1, .reusable = true}, SHIFT(2065),
  [4816] = {.count = 1, .reusable = true}, SHIFT(2066),
  [4818] = {.count = 1, .reusable = true}, SHIFT(2067),
  [4820] = {.count = 1, .reusable = true}, SHIFT(2068),
  [4822] = {.count = 1, .reusable = false}, SHIFT(2070),
  [4824] = {.count = 1, .reusable = true}, SHIFT(2070),
  [4826] = {.count = 1, .reusable = true}, SHIFT(2069),
  [4828] = {.count = 1, .reusable = true}, SHIFT(2071),
  [4830] = {.count = 1, .reusable = false}, SHIFT(2073),
  [4832] = {.count = 1, .reusable = true}, SHIFT(2073),
  [4834] = {.count = 1, .reusable = true}, SHIFT(2072),
  [4836] = {.count = 1, .reusable = false}, SHIFT(2075),
  [4838] = {.count = 1, .reusable = true}, SHIFT(2075),
  [4840] = {.count = 1, .reusable = true}, SHIFT(2074),
  [4842] = {.count = 1, .reusable = true}, SHIFT(2076),
  [4844] = {.count = 1, .reusable = true}, SHIFT(2077),
  [4846] = {.count = 1, .reusable = true}, SHIFT(2078),
  [4848] = {.count = 1, .reusable = true}, SHIFT(2079),
  [4850] = {.count = 1, .reusable = true}, SHIFT(2080),
  [4852] = {.count = 1, .reusable = true}, SHIFT(2081),
  [4854] = {.count = 1, .reusable = false}, SHIFT(2082),
  [4856] = {.count = 1, .reusable = true}, SHIFT(2082),
  [4858] = {.count = 1, .reusable = false}, SHIFT(2083),
  [4860] = {.count = 1, .reusable = true}, SHIFT(2084),
  [4862] = {.count = 1, .reusable = true}, SHIFT(2086),
  [4864] = {.count = 1, .reusable = true}, SHIFT(2087),
  [4866] = {.count = 1, .reusable = true}, SHIFT(2088),
  [4868] = {.count = 1, .reusable = true}, SHIFT(2089),
  [4870] = {.count = 1, .reusable = true}, SHIFT(2090),
  [4872] = {.count = 1, .reusable = true}, SHIFT(2091),
  [4874] = {.count = 1, .reusable = false}, SHIFT(2092),
  [4876] = {.count = 1, .reusable = true}, SHIFT(2092),
  [4878] = {.count = 1, .reusable = true}, SHIFT(2093),
  [4880] = {.count = 1, .reusable = false}, SHIFT(2094),
  [4882] = {.count = 1, .reusable = true}, SHIFT(2094),
  [4884] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 10),
  [4886] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 10),
  [4888] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 15),
  [4890] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 15),
  [4892] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6),
  [4894] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6),
  [4896] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 16),
  [4898] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 16),
  [4900] = {.count = 1, .reusable = true}, SHIFT(2095),
  [4902] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 17),
  [4904] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 17),
  [4906] = {.count = 1, .reusable = true}, SHIFT(2096),
  [4908] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 18),
  [4910] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 18),
  [4912] = {.count = 1, .reusable = true}, SHIFT(2097),
  [4914] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 11),
  [4916] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 11),
  [4918] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 12),
  [4920] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 12),
  [4922] = {.count = 1, .reusable = false}, SHIFT(2099),
  [4924] = {.count = 1, .reusable = true}, SHIFT(2100),
  [4926] = {.count = 1, .reusable = true}, SHIFT(2102),
  [4928] = {.count = 1, .reusable = false}, SHIFT(2104),
  [4930] = {.count = 1, .reusable = true}, SHIFT(2106),
  [4932] = {.count = 1, .reusable = false}, SHIFT(2108),
  [4934] = {.count = 1, .reusable = true}, SHIFT(2111),
  [4936] = {.count = 1, .reusable = true}, SHIFT(2112),
  [4938] = {.count = 1, .reusable = true}, SHIFT(2115),
  [4940] = {.count = 1, .reusable = true}, SHIFT(2116),
  [4942] = {.count = 1, .reusable = true}, SHIFT(2118),
  [4944] = {.count = 1, .reusable = false}, SHIFT(2120),
  [4946] = {.count = 1, .reusable = true}, SHIFT(2122),
  [4948] = {.count = 1, .reusable = true}, SHIFT(2123),
  [4950] = {.count = 1, .reusable = false}, SHIFT(2124),
  [4952] = {.count = 1, .reusable = false}, SHIFT(2122),
  [4954] = {.count = 1, .reusable = true}, SHIFT(2125),
  [4956] = {.count = 1, .reusable = true}, SHIFT(2126),
  [4958] = {.count = 1, .reusable = true}, SHIFT(2127),
  [4960] = {.count = 1, .reusable = false}, SHIFT(2128),
  [4962] = {.count = 1, .reusable = false}, SHIFT(2126),
  [4964] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1341),
  [4967] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1342),
  [4970] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1342),
  [4973] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1343),
  [4976] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1343),
  [4979] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1344),
  [4982] = {.count = 1, .reusable = true}, SHIFT(2136),
  [4984] = {.count = 1, .reusable = true}, SHIFT(2137),
  [4986] = {.count = 1, .reusable = true}, SHIFT(2138),
  [4988] = {.count = 1, .reusable = true}, SHIFT(2139),
  [4990] = {.count = 1, .reusable = false}, SHIFT(2140),
  [4992] = {.count = 1, .reusable = true}, SHIFT(2140),
  [4994] = {.count = 1, .reusable = false}, SHIFT(2141),
  [4996] = {.count = 1, .reusable = true}, SHIFT(2142),
  [4998] = {.count = 1, .reusable = true}, SHIFT(2144),
  [5000] = {.count = 1, .reusable = true}, SHIFT(2145),
  [5002] = {.count = 1, .reusable = true}, SHIFT(2146),
  [5004] = {.count = 1, .reusable = true}, SHIFT(2147),
  [5006] = {.count = 1, .reusable = true}, SHIFT(2148),
  [5008] = {.count = 1, .reusable = true}, SHIFT(2149),
  [5010] = {.count = 1, .reusable = false}, SHIFT(2150),
  [5012] = {.count = 1, .reusable = true}, SHIFT(2150),
  [5014] = {.count = 1, .reusable = true}, SHIFT(2151),
  [5016] = {.count = 1, .reusable = false}, SHIFT(2152),
  [5018] = {.count = 1, .reusable = true}, SHIFT(2152),
  [5020] = {.count = 1, .reusable = true}, SHIFT(2153),
  [5022] = {.count = 1, .reusable = true}, SHIFT(2154),
  [5024] = {.count = 1, .reusable = true}, SHIFT(2155),
  [5026] = {.count = 1, .reusable = false}, SHIFT(2156),
  [5028] = {.count = 1, .reusable = true}, SHIFT(2156),
  [5030] = {.count = 1, .reusable = false}, SHIFT(2157),
  [5032] = {.count = 1, .reusable = true}, SHIFT(2158),
  [5034] = {.count = 1, .reusable = true}, SHIFT(2160),
  [5036] = {.count = 1, .reusable = true}, SHIFT(2161),
  [5038] = {.count = 1, .reusable = true}, SHIFT(2162),
  [5040] = {.count = 1, .reusable = true}, SHIFT(2163),
  [5042] = {.count = 1, .reusable = true}, SHIFT(2164),
  [5044] = {.count = 1, .reusable = true}, SHIFT(2165),
  [5046] = {.count = 1, .reusable = false}, SHIFT(2166),
  [5048] = {.count = 1, .reusable = true}, SHIFT(2166),
  [5050] = {.count = 1, .reusable = true}, SHIFT(2167),
  [5052] = {.count = 1, .reusable = false}, SHIFT(2168),
  [5054] = {.count = 1, .reusable = true}, SHIFT(2168),
  [5056] = {.count = 1, .reusable = true}, SHIFT(2169),
  [5058] = {.count = 1, .reusable = true}, SHIFT(2170),
  [5060] = {.count = 1, .reusable = true}, SHIFT(2171),
  [5062] = {.count = 1, .reusable = true}, SHIFT(2172),
  [5064] = {.count = 1, .reusable = false}, SHIFT(2173),
  [5066] = {.count = 1, .reusable = true}, SHIFT(2173),
  [5068] = {.count = 1, .reusable = true}, SHIFT(2174),
  [5070] = {.count = 1, .reusable = false}, SHIFT(2175),
  [5072] = {.count = 1, .reusable = true}, SHIFT(2175),
  [5074] = {.count = 1, .reusable = true}, SHIFT(2176),
  [5076] = {.count = 1, .reusable = false}, SHIFT(2177),
  [5078] = {.count = 1, .reusable = true}, SHIFT(2177),
  [5080] = {.count = 1, .reusable = true}, SHIFT(2178),
  [5082] = {.count = 1, .reusable = true}, SHIFT(2179),
  [5084] = {.count = 1, .reusable = true}, SHIFT(2180),
  [5086] = {.count = 1, .reusable = true}, SHIFT(2181),
  [5088] = {.count = 1, .reusable = true}, SHIFT(2183),
  [5090] = {.count = 1, .reusable = true}, SHIFT(2184),
  [5092] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1419),
  [5095] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1420),
  [5098] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1420),
  [5101] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1421),
  [5104] = {.count = 1, .reusable = true}, SHIFT(2186),
  [5106] = {.count = 1, .reusable = true}, SHIFT(2187),
  [5108] = {.count = 1, .reusable = true}, SHIFT(2188),
  [5110] = {.count = 1, .reusable = false}, SHIFT(2189),
  [5112] = {.count = 1, .reusable = true}, SHIFT(2189),
  [5114] = {.count = 1, .reusable = false}, SHIFT(2190),
  [5116] = {.count = 1, .reusable = true}, SHIFT(2191),
  [5118] = {.count = 1, .reusable = true}, SHIFT(2193),
  [5120] = {.count = 1, .reusable = true}, SHIFT(2194),
  [5122] = {.count = 1, .reusable = true}, SHIFT(2195),
  [5124] = {.count = 1, .reusable = true}, SHIFT(2196),
  [5126] = {.count = 1, .reusable = true}, SHIFT(2197),
  [5128] = {.count = 1, .reusable = true}, SHIFT(2198),
  [5130] = {.count = 1, .reusable = false}, SHIFT(2199),
  [5132] = {.count = 1, .reusable = true}, SHIFT(2199),
  [5134] = {.count = 1, .reusable = true}, SHIFT(2200),
  [5136] = {.count = 1, .reusable = false}, SHIFT(2201),
  [5138] = {.count = 1, .reusable = true}, SHIFT(2201),
  [5140] = {.count = 1, .reusable = true}, SHIFT(2202),
  [5142] = {.count = 1, .reusable = true}, SHIFT(2203),
  [5144] = {.count = 1, .reusable = true}, SHIFT(2204),
  [5146] = {.count = 1, .reusable = false}, SHIFT(2205),
  [5148] = {.count = 1, .reusable = true}, SHIFT(2205),
  [5150] = {.count = 1, .reusable = false}, SHIFT(2206),
  [5152] = {.count = 1, .reusable = true}, SHIFT(2207),
  [5154] = {.count = 1, .reusable = true}, SHIFT(2209),
  [5156] = {.count = 1, .reusable = true}, SHIFT(2210),
  [5158] = {.count = 1, .reusable = true}, SHIFT(2211),
  [5160] = {.count = 1, .reusable = true}, SHIFT(2212),
  [5162] = {.count = 1, .reusable = true}, SHIFT(2213),
  [5164] = {.count = 1, .reusable = true}, SHIFT(2214),
  [5166] = {.count = 1, .reusable = false}, SHIFT(2215),
  [5168] = {.count = 1, .reusable = true}, SHIFT(2215),
  [5170] = {.count = 1, .reusable = true}, SHIFT(2216),
  [5172] = {.count = 1, .reusable = false}, SHIFT(2217),
  [5174] = {.count = 1, .reusable = true}, SHIFT(2217),
  [5176] = {.count = 1, .reusable = true}, SHIFT(2218),
  [5178] = {.count = 1, .reusable = true}, SHIFT(2219),
  [5180] = {.count = 1, .reusable = true}, SHIFT(2220),
  [5182] = {.count = 1, .reusable = true}, SHIFT(2221),
  [5184] = {.count = 1, .reusable = false}, SHIFT(2222),
  [5186] = {.count = 1, .reusable = true}, SHIFT(2222),
  [5188] = {.count = 1, .reusable = true}, SHIFT(2223),
  [5190] = {.count = 1, .reusable = false}, SHIFT(2224),
  [5192] = {.count = 1, .reusable = true}, SHIFT(2224),
  [5194] = {.count = 1, .reusable = true}, SHIFT(2225),
  [5196] = {.count = 1, .reusable = false}, SHIFT(2226),
  [5198] = {.count = 1, .reusable = true}, SHIFT(2226),
  [5200] = {.count = 1, .reusable = true}, SHIFT(2227),
  [5202] = {.count = 1, .reusable = true}, SHIFT(2228),
  [5204] = {.count = 1, .reusable = true}, SHIFT(2229),
  [5206] = {.count = 1, .reusable = true}, SHIFT(2230),
  [5208] = {.count = 1, .reusable = true}, SHIFT(2231),
  [5210] = {.count = 1, .reusable = false}, SHIFT(2232),
  [5212] = {.count = 1, .reusable = true}, SHIFT(2232),
  [5214] = {.count = 1, .reusable = false}, SHIFT(2233),
  [5216] = {.count = 1, .reusable = true}, SHIFT(2234),
  [5218] = {.count = 1, .reusable = true}, SHIFT(2236),
  [5220] = {.count = 1, .reusable = true}, SHIFT(2237),
  [5222] = {.count = 1, .reusable = true}, SHIFT(2238),
  [5224] = {.count = 1, .reusable = true}, SHIFT(2239),
  [5226] = {.count = 1, .reusable = true}, SHIFT(2240),
  [5228] = {.count = 1, .reusable = true}, SHIFT(2241),
  [5230] = {.count = 1, .reusable = false}, SHIFT(2242),
  [5232] = {.count = 1, .reusable = true}, SHIFT(2242),
  [5234] = {.count = 1, .reusable = true}, SHIFT(2243),
  [5236] = {.count = 1, .reusable = false}, SHIFT(2244),
  [5238] = {.count = 1, .reusable = true}, SHIFT(2244),
  [5240] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 4),
  [5242] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 7),
  [5244] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 7),
  [5246] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2, .alias_sequence_id = 3),
  [5248] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2),
  [5250] = {.count = 1, .reusable = true}, SHIFT(2245),
  [5252] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3, .alias_sequence_id = 1),
  [5254] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [5256] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [5258] = {.count = 1, .reusable = true}, SHIFT(2247),
  [5260] = {.count = 1, .reusable = true}, SHIFT(2250),
  [5262] = {.count = 1, .reusable = false}, SHIFT(2251),
  [5264] = {.count = 1, .reusable = false}, SHIFT(2252),
  [5266] = {.count = 1, .reusable = false}, SHIFT(2253),
  [5268] = {.count = 1, .reusable = false}, SHIFT(2254),
  [5270] = {.count = 1, .reusable = false}, SHIFT(2255),
  [5272] = {.count = 1, .reusable = false}, SHIFT(2256),
  [5274] = {.count = 1, .reusable = false}, SHIFT(2257),
  [5276] = {.count = 1, .reusable = false}, SHIFT(2258),
  [5278] = {.count = 1, .reusable = false}, SHIFT(2259),
  [5280] = {.count = 1, .reusable = false}, SHIFT(2262),
  [5282] = {.count = 1, .reusable = false}, SHIFT(2263),
  [5284] = {.count = 1, .reusable = false}, SHIFT(2264),
  [5286] = {.count = 1, .reusable = false}, SHIFT(2265),
  [5288] = {.count = 1, .reusable = false}, SHIFT(2266),
  [5290] = {.count = 1, .reusable = false}, SHIFT(2267),
  [5292] = {.count = 1, .reusable = false}, SHIFT(2268),
  [5294] = {.count = 1, .reusable = false}, SHIFT(2269),
  [5296] = {.count = 1, .reusable = false}, SHIFT(2270),
  [5298] = {.count = 1, .reusable = true}, SHIFT(2272),
  [5300] = {.count = 1, .reusable = false}, SHIFT(2274),
  [5302] = {.count = 1, .reusable = true}, SHIFT(2276),
  [5304] = {.count = 1, .reusable = true}, SHIFT(2277),
  [5306] = {.count = 1, .reusable = false}, SHIFT(2278),
  [5308] = {.count = 1, .reusable = false}, SHIFT(2276),
  [5310] = {.count = 1, .reusable = true}, SHIFT(2279),
  [5312] = {.count = 1, .reusable = true}, SHIFT(2280),
  [5314] = {.count = 1, .reusable = true}, SHIFT(2281),
  [5316] = {.count = 1, .reusable = false}, SHIFT(2282),
  [5318] = {.count = 1, .reusable = false}, SHIFT(2280),
  [5320] = {.count = 1, .reusable = false}, SHIFT(2290),
  [5322] = {.count = 1, .reusable = false}, SHIFT(2291),
  [5324] = {.count = 1, .reusable = false}, SHIFT(2292),
  [5326] = {.count = 1, .reusable = false}, SHIFT(2293),
  [5328] = {.count = 1, .reusable = false}, SHIFT(2294),
  [5330] = {.count = 1, .reusable = true}, SHIFT(2294),
  [5332] = {.count = 1, .reusable = true}, SHIFT(2295),
  [5334] = {.count = 1, .reusable = false}, SHIFT(2296),
  [5336] = {.count = 1, .reusable = false}, SHIFT(2297),
  [5338] = {.count = 1, .reusable = false}, SHIFT(2298),
  [5340] = {.count = 1, .reusable = false}, SHIFT(2299),
  [5342] = {.count = 1, .reusable = false}, SHIFT(1926),
  [5344] = {.count = 1, .reusable = false}, SHIFT(2300),
  [5346] = {.count = 1, .reusable = false}, SHIFT(1929),
  [5348] = {.count = 1, .reusable = false}, SHIFT(1930),
  [5350] = {.count = 1, .reusable = false}, SHIFT(1931),
  [5352] = {.count = 1, .reusable = false}, SHIFT(1932),
  [5354] = {.count = 1, .reusable = true}, SHIFT(2303),
  [5356] = {.count = 1, .reusable = true}, SHIFT(1925),
  [5358] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2), SHIFT_REPEAT(1514),
  [5361] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3),
  [5363] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3),
  [5365] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3),
  [5367] = {.count = 1, .reusable = false}, SHIFT(2309),
  [5369] = {.count = 1, .reusable = true}, SHIFT(2310),
  [5371] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 19),
  [5373] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 19),
  [5375] = {.count = 1, .reusable = true}, SHIFT(2314),
  [5377] = {.count = 1, .reusable = true}, SHIFT(2316),
  [5379] = {.count = 1, .reusable = true}, SHIFT(2318),
  [5381] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 20),
  [5383] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 20),
  [5385] = {.count = 1, .reusable = true}, SHIFT(2319),
  [5387] = {.count = 1, .reusable = true}, SHIFT(2320),
  [5389] = {.count = 1, .reusable = true}, SHIFT(2321),
  [5391] = {.count = 1, .reusable = true}, SHIFT(2322),
  [5393] = {.count = 1, .reusable = true}, SHIFT(2325),
  [5395] = {.count = 1, .reusable = true}, SHIFT(2326),
  [5397] = {.count = 1, .reusable = true}, SHIFT(2327),
  [5399] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1582),
  [5402] = {.count = 1, .reusable = true}, SHIFT(2328),
  [5404] = {.count = 1, .reusable = false}, SHIFT(2329),
  [5406] = {.count = 1, .reusable = true}, SHIFT(2330),
  [5408] = {.count = 1, .reusable = true}, SHIFT(2332),
  [5410] = {.count = 1, .reusable = true}, SHIFT(2333),
  [5412] = {.count = 1, .reusable = true}, SHIFT(2334),
  [5414] = {.count = 1, .reusable = true}, SHIFT(2335),
  [5416] = {.count = 1, .reusable = false}, SHIFT(2337),
  [5418] = {.count = 1, .reusable = true}, SHIFT(2337),
  [5420] = {.count = 1, .reusable = true}, SHIFT(2336),
  [5422] = {.count = 1, .reusable = true}, SHIFT(2338),
  [5424] = {.count = 1, .reusable = false}, SHIFT(2340),
  [5426] = {.count = 1, .reusable = true}, SHIFT(2340),
  [5428] = {.count = 1, .reusable = true}, SHIFT(2339),
  [5430] = {.count = 1, .reusable = false}, SHIFT(2342),
  [5432] = {.count = 1, .reusable = true}, SHIFT(2342),
  [5434] = {.count = 1, .reusable = true}, SHIFT(2341),
  [5436] = {.count = 1, .reusable = true}, SHIFT(2343),
  [5438] = {.count = 1, .reusable = true}, SHIFT(2344),
  [5440] = {.count = 1, .reusable = true}, SHIFT(2345),
  [5442] = {.count = 1, .reusable = true}, SHIFT(2346),
  [5444] = {.count = 1, .reusable = true}, SHIFT(2347),
  [5446] = {.count = 1, .reusable = true}, SHIFT(2348),
  [5448] = {.count = 1, .reusable = true}, SHIFT(2349),
  [5450] = {.count = 1, .reusable = true}, SHIFT(2350),
  [5452] = {.count = 1, .reusable = true}, SHIFT(2351),
  [5454] = {.count = 1, .reusable = true}, SHIFT(2352),
  [5456] = {.count = 1, .reusable = true}, SHIFT(2353),
  [5458] = {.count = 1, .reusable = true}, SHIFT(2354),
  [5460] = {.count = 1, .reusable = true}, SHIFT(2355),
  [5462] = {.count = 1, .reusable = true}, SHIFT(2356),
  [5464] = {.count = 1, .reusable = true}, SHIFT(2357),
  [5466] = {.count = 1, .reusable = true}, SHIFT(2358),
  [5468] = {.count = 1, .reusable = true}, SHIFT(2359),
  [5470] = {.count = 1, .reusable = true}, SHIFT(2360),
  [5472] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6, .alias_sequence_id = 6),
  [5474] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6),
  [5476] = {.count = 1, .reusable = true}, SHIFT(2361),
  [5478] = {.count = 1, .reusable = true}, SHIFT(2362),
  [5480] = {.count = 1, .reusable = true}, SHIFT(2363),
  [5482] = {.count = 1, .reusable = false}, SHIFT(2364),
  [5484] = {.count = 1, .reusable = true}, SHIFT(2364),
  [5486] = {.count = 1, .reusable = false}, SHIFT(2365),
  [5488] = {.count = 1, .reusable = true}, SHIFT(2366),
  [5490] = {.count = 1, .reusable = true}, SHIFT(2368),
  [5492] = {.count = 1, .reusable = true}, SHIFT(2369),
  [5494] = {.count = 1, .reusable = true}, SHIFT(2370),
  [5496] = {.count = 1, .reusable = true}, SHIFT(2371),
  [5498] = {.count = 1, .reusable = true}, SHIFT(2372),
  [5500] = {.count = 1, .reusable = true}, SHIFT(2373),
  [5502] = {.count = 1, .reusable = false}, SHIFT(2374),
  [5504] = {.count = 1, .reusable = true}, SHIFT(2374),
  [5506] = {.count = 1, .reusable = true}, SHIFT(2375),
  [5508] = {.count = 1, .reusable = false}, SHIFT(2376),
  [5510] = {.count = 1, .reusable = true}, SHIFT(2376),
  [5512] = {.count = 1, .reusable = true}, SHIFT(2377),
  [5514] = {.count = 1, .reusable = true}, SHIFT(2378),
  [5516] = {.count = 1, .reusable = true}, SHIFT(2379),
  [5518] = {.count = 1, .reusable = true}, SHIFT(2380),
  [5520] = {.count = 1, .reusable = false}, SHIFT(2381),
  [5522] = {.count = 1, .reusable = true}, SHIFT(2381),
  [5524] = {.count = 1, .reusable = true}, SHIFT(2382),
  [5526] = {.count = 1, .reusable = false}, SHIFT(2383),
  [5528] = {.count = 1, .reusable = true}, SHIFT(2383),
  [5530] = {.count = 1, .reusable = true}, SHIFT(2384),
  [5532] = {.count = 1, .reusable = false}, SHIFT(2385),
  [5534] = {.count = 1, .reusable = true}, SHIFT(2385),
  [5536] = {.count = 1, .reusable = true}, SHIFT(2386),
  [5538] = {.count = 1, .reusable = true}, SHIFT(2387),
  [5540] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7, .alias_sequence_id = 16),
  [5542] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 16),
  [5544] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7, .alias_sequence_id = 17),
  [5546] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 17),
  [5548] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7, .alias_sequence_id = 18),
  [5550] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 18),
  [5552] = {.count = 1, .reusable = true}, SHIFT(2388),
  [5554] = {.count = 1, .reusable = true}, SHIFT(2389),
  [5556] = {.count = 1, .reusable = true}, SHIFT(2391),
  [5558] = {.count = 1, .reusable = true}, SHIFT(2394),
  [5560] = {.count = 1, .reusable = false}, SHIFT(2396),
  [5562] = {.count = 1, .reusable = true}, SHIFT(2397),
  [5564] = {.count = 1, .reusable = true}, SHIFT(2398),
  [5566] = {.count = 1, .reusable = false}, SHIFT(2400),
  [5568] = {.count = 1, .reusable = true}, SHIFT(2400),
  [5570] = {.count = 1, .reusable = true}, SHIFT(2399),
  [5572] = {.count = 1, .reusable = true}, SHIFT(2401),
  [5574] = {.count = 1, .reusable = true}, SHIFT(2402),
  [5576] = {.count = 1, .reusable = false}, SHIFT(2403),
  [5578] = {.count = 1, .reusable = false}, SHIFT(2402),
  [5580] = {.count = 1, .reusable = true}, SHIFT(2405),
  [5582] = {.count = 1, .reusable = false}, SHIFT(2407),
  [5584] = {.count = 1, .reusable = true}, SHIFT(2407),
  [5586] = {.count = 1, .reusable = true}, SHIFT(2406),
  [5588] = {.count = 1, .reusable = true}, SHIFT(2408),
  [5590] = {.count = 1, .reusable = false}, SHIFT(2410),
  [5592] = {.count = 1, .reusable = true}, SHIFT(2410),
  [5594] = {.count = 1, .reusable = true}, SHIFT(2409),
  [5596] = {.count = 1, .reusable = true}, SHIFT(2411),
  [5598] = {.count = 1, .reusable = true}, SHIFT(2412),
  [5600] = {.count = 1, .reusable = true}, SHIFT(2413),
  [5602] = {.count = 1, .reusable = true}, SHIFT(2414),
  [5604] = {.count = 1, .reusable = true}, SHIFT(2415),
  [5606] = {.count = 1, .reusable = true}, SHIFT(2416),
  [5608] = {.count = 1, .reusable = false}, SHIFT(2417),
  [5610] = {.count = 1, .reusable = true}, SHIFT(2417),
  [5612] = {.count = 1, .reusable = true}, SHIFT(2418),
  [5614] = {.count = 1, .reusable = false}, SHIFT(2419),
  [5616] = {.count = 1, .reusable = true}, SHIFT(2419),
  [5618] = {.count = 1, .reusable = true}, SHIFT(2420),
  [5620] = {.count = 1, .reusable = false}, SHIFT(2421),
  [5622] = {.count = 1, .reusable = true}, SHIFT(2421),
  [5624] = {.count = 1, .reusable = true}, SHIFT(2422),
  [5626] = {.count = 1, .reusable = true}, SHIFT(2423),
  [5628] = {.count = 1, .reusable = true}, SHIFT(2424),
  [5630] = {.count = 1, .reusable = true}, SHIFT(2425),
  [5632] = {.count = 1, .reusable = true}, SHIFT(2426),
  [5634] = {.count = 1, .reusable = true}, SHIFT(2427),
  [5636] = {.count = 1, .reusable = false}, SHIFT(2428),
  [5638] = {.count = 1, .reusable = true}, SHIFT(2428),
  [5640] = {.count = 1, .reusable = true}, SHIFT(2429),
  [5642] = {.count = 1, .reusable = false}, SHIFT(2430),
  [5644] = {.count = 1, .reusable = true}, SHIFT(2430),
  [5646] = {.count = 1, .reusable = true}, SHIFT(2431),
  [5648] = {.count = 1, .reusable = false}, SHIFT(2432),
  [5650] = {.count = 1, .reusable = true}, SHIFT(2432),
  [5652] = {.count = 1, .reusable = true}, SHIFT(2433),
  [5654] = {.count = 1, .reusable = true}, SHIFT(2434),
  [5656] = {.count = 1, .reusable = true}, SHIFT(2435),
  [5658] = {.count = 1, .reusable = true}, SHIFT(2436),
  [5660] = {.count = 1, .reusable = true}, SHIFT(2437),
  [5662] = {.count = 1, .reusable = true}, SHIFT(2440),
  [5664] = {.count = 1, .reusable = true}, SHIFT(2441),
  [5666] = {.count = 1, .reusable = true}, SHIFT(2442),
  [5668] = {.count = 1, .reusable = true}, SHIFT(2443),
  [5670] = {.count = 1, .reusable = false}, SHIFT(2444),
  [5672] = {.count = 1, .reusable = true}, SHIFT(2444),
  [5674] = {.count = 1, .reusable = true}, SHIFT(2445),
  [5676] = {.count = 1, .reusable = false}, SHIFT(2446),
  [5678] = {.count = 1, .reusable = true}, SHIFT(2446),
  [5680] = {.count = 1, .reusable = true}, SHIFT(2447),
  [5682] = {.count = 1, .reusable = false}, SHIFT(2448),
  [5684] = {.count = 1, .reusable = true}, SHIFT(2448),
  [5686] = {.count = 1, .reusable = true}, SHIFT(2449),
  [5688] = {.count = 1, .reusable = true}, SHIFT(2450),
  [5690] = {.count = 1, .reusable = true}, SHIFT(2451),
  [5692] = {.count = 1, .reusable = true}, SHIFT(2452),
  [5694] = {.count = 1, .reusable = true}, SHIFT(2453),
  [5696] = {.count = 1, .reusable = true}, SHIFT(2454),
  [5698] = {.count = 1, .reusable = false}, SHIFT(2455),
  [5700] = {.count = 1, .reusable = true}, SHIFT(2455),
  [5702] = {.count = 1, .reusable = true}, SHIFT(2456),
  [5704] = {.count = 1, .reusable = false}, SHIFT(2457),
  [5706] = {.count = 1, .reusable = true}, SHIFT(2457),
  [5708] = {.count = 1, .reusable = true}, SHIFT(2458),
  [5710] = {.count = 1, .reusable = false}, SHIFT(2459),
  [5712] = {.count = 1, .reusable = true}, SHIFT(2459),
  [5714] = {.count = 1, .reusable = true}, SHIFT(2460),
  [5716] = {.count = 1, .reusable = true}, SHIFT(2461),
  [5718] = {.count = 1, .reusable = true}, SHIFT(2462),
  [5720] = {.count = 1, .reusable = true}, SHIFT(2463),
  [5722] = {.count = 1, .reusable = true}, SHIFT(2464),
  [5724] = {.count = 1, .reusable = true}, SHIFT(2465),
  [5726] = {.count = 1, .reusable = true}, SHIFT(2466),
  [5728] = {.count = 1, .reusable = true}, SHIFT(2467),
  [5730] = {.count = 1, .reusable = true}, SHIFT(2468),
  [5732] = {.count = 1, .reusable = false}, SHIFT(2469),
  [5734] = {.count = 1, .reusable = true}, SHIFT(2469),
  [5736] = {.count = 1, .reusable = true}, SHIFT(2470),
  [5738] = {.count = 1, .reusable = false}, SHIFT(2471),
  [5740] = {.count = 1, .reusable = true}, SHIFT(2471),
  [5742] = {.count = 1, .reusable = true}, SHIFT(2472),
  [5744] = {.count = 1, .reusable = false}, SHIFT(2473),
  [5746] = {.count = 1, .reusable = true}, SHIFT(2473),
  [5748] = {.count = 1, .reusable = true}, SHIFT(2474),
  [5750] = {.count = 1, .reusable = true}, SHIFT(2475),
  [5752] = {.count = 1, .reusable = true}, SHIFT(2476),
  [5754] = {.count = 1, .reusable = true}, SHIFT(2477),
  [5756] = {.count = 1, .reusable = true}, SHIFT(2478),
  [5758] = {.count = 1, .reusable = true}, SHIFT(2479),
  [5760] = {.count = 1, .reusable = false}, SHIFT(2480),
  [5762] = {.count = 1, .reusable = true}, SHIFT(2481),
  [5764] = {.count = 1, .reusable = true}, SHIFT(2482),
  [5766] = {.count = 1, .reusable = true}, SHIFT(2483),
  [5768] = {.count = 1, .reusable = true}, SHIFT(2484),
  [5770] = {.count = 1, .reusable = true}, SHIFT(2485),
  [5772] = {.count = 1, .reusable = true}, SHIFT(2487),
  [5774] = {.count = 1, .reusable = true}, SHIFT(2489),
  [5776] = {.count = 1, .reusable = true}, SHIFT(2490),
  [5778] = {.count = 1, .reusable = true}, SHIFT(2491),
  [5780] = {.count = 1, .reusable = false}, SHIFT(2493),
  [5782] = {.count = 1, .reusable = true}, SHIFT(2252),
  [5784] = {.count = 1, .reusable = true}, SHIFT(2495),
  [5786] = {.count = 1, .reusable = true}, SHIFT(2496),
  [5788] = {.count = 1, .reusable = false}, SHIFT(2497),
  [5790] = {.count = 1, .reusable = false}, SHIFT(2495),
  [5792] = {.count = 1, .reusable = true}, SHIFT(2498),
  [5794] = {.count = 1, .reusable = true}, SHIFT(2499),
  [5796] = {.count = 1, .reusable = true}, SHIFT(2500),
  [5798] = {.count = 1, .reusable = false}, SHIFT(2501),
  [5800] = {.count = 1, .reusable = false}, SHIFT(2499),
  [5802] = {.count = 1, .reusable = true}, SHIFT(2510),
  [5804] = {.count = 1, .reusable = false}, SHIFT(2512),
  [5806] = {.count = 1, .reusable = true}, SHIFT(2263),
  [5808] = {.count = 1, .reusable = true}, SHIFT(2514),
  [5810] = {.count = 1, .reusable = true}, SHIFT(2515),
  [5812] = {.count = 1, .reusable = false}, SHIFT(2516),
  [5814] = {.count = 1, .reusable = false}, SHIFT(2514),
  [5816] = {.count = 1, .reusable = true}, SHIFT(2517),
  [5818] = {.count = 1, .reusable = true}, SHIFT(2518),
  [5820] = {.count = 1, .reusable = true}, SHIFT(2519),
  [5822] = {.count = 1, .reusable = false}, SHIFT(2520),
  [5824] = {.count = 1, .reusable = false}, SHIFT(2518),
  [5826] = {.count = 1, .reusable = true}, SHIFT(2529),
  [5828] = {.count = 1, .reusable = false}, SHIFT(2531),
  [5830] = {.count = 1, .reusable = true}, SHIFT(2532),
  [5832] = {.count = 1, .reusable = true}, SHIFT(2533),
  [5834] = {.count = 1, .reusable = false}, SHIFT(2535),
  [5836] = {.count = 1, .reusable = true}, SHIFT(2535),
  [5838] = {.count = 1, .reusable = true}, SHIFT(2534),
  [5840] = {.count = 1, .reusable = true}, SHIFT(2536),
  [5842] = {.count = 1, .reusable = true}, SHIFT(2537),
  [5844] = {.count = 1, .reusable = false}, SHIFT(2538),
  [5846] = {.count = 1, .reusable = false}, SHIFT(2537),
  [5848] = {.count = 1, .reusable = true}, SHIFT(2540),
  [5850] = {.count = 1, .reusable = false}, SHIFT(2542),
  [5852] = {.count = 1, .reusable = true}, SHIFT(2542),
  [5854] = {.count = 1, .reusable = true}, SHIFT(2541),
  [5856] = {.count = 1, .reusable = true}, SHIFT(2543),
  [5858] = {.count = 1, .reusable = false}, SHIFT(2545),
  [5860] = {.count = 1, .reusable = true}, SHIFT(2545),
  [5862] = {.count = 1, .reusable = true}, SHIFT(2544),
  [5864] = {.count = 1, .reusable = true}, SHIFT(2546),
  [5866] = {.count = 1, .reusable = true}, SHIFT(2547),
  [5868] = {.count = 1, .reusable = true}, SHIFT(2548),
  [5870] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4, .alias_sequence_id = 1),
  [5872] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [5874] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [5876] = {.count = 1, .reusable = false}, SHIFT(2552),
  [5878] = {.count = 1, .reusable = true}, SHIFT(2552),
  [5880] = {.count = 1, .reusable = false}, SHIFT(2553),
  [5882] = {.count = 1, .reusable = false}, SHIFT(2554),
  [5884] = {.count = 1, .reusable = false}, SHIFT(2555),
  [5886] = {.count = 1, .reusable = true}, SHIFT(2556),
  [5888] = {.count = 1, .reusable = true}, SHIFT(2557),
  [5890] = {.count = 1, .reusable = false}, SHIFT(2558),
  [5892] = {.count = 1, .reusable = true}, SHIFT(2559),
  [5894] = {.count = 1, .reusable = true}, SHIFT(2560),
  [5896] = {.count = 1, .reusable = true}, SHIFT(2561),
  [5898] = {.count = 1, .reusable = true}, SHIFT(2562),
  [5900] = {.count = 1, .reusable = true}, SHIFT(2563),
  [5902] = {.count = 1, .reusable = true}, SHIFT(2564),
  [5904] = {.count = 1, .reusable = true}, SHIFT(2565),
  [5906] = {.count = 1, .reusable = false}, SHIFT(2569),
  [5908] = {.count = 1, .reusable = true}, SHIFT(2573),
  [5910] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4),
  [5912] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4),
  [5914] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4),
  [5916] = {.count = 1, .reusable = false}, SHIFT(2576),
  [5918] = {.count = 1, .reusable = true}, SHIFT(2577),
  [5920] = {.count = 1, .reusable = true}, SHIFT(2580),
  [5922] = {.count = 1, .reusable = true}, SHIFT(2584),
  [5924] = {.count = 1, .reusable = true}, SHIFT(2585),
  [5926] = {.count = 1, .reusable = true}, SHIFT(2589),
  [5928] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 21),
  [5930] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 21),
  [5932] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 22),
  [5934] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 22),
  [5936] = {.count = 1, .reusable = true}, SHIFT(2590),
  [5938] = {.count = 1, .reusable = true}, SHIFT(2591),
  [5940] = {.count = 1, .reusable = true}, SHIFT(2592),
  [5942] = {.count = 1, .reusable = false}, SHIFT(2593),
  [5944] = {.count = 1, .reusable = true}, SHIFT(2593),
  [5946] = {.count = 1, .reusable = false}, SHIFT(2594),
  [5948] = {.count = 1, .reusable = true}, SHIFT(2595),
  [5950] = {.count = 1, .reusable = true}, SHIFT(2597),
  [5952] = {.count = 1, .reusable = true}, SHIFT(2598),
  [5954] = {.count = 1, .reusable = true}, SHIFT(2599),
  [5956] = {.count = 1, .reusable = true}, SHIFT(2600),
  [5958] = {.count = 1, .reusable = true}, SHIFT(2601),
  [5960] = {.count = 1, .reusable = true}, SHIFT(2602),
  [5962] = {.count = 1, .reusable = false}, SHIFT(2603),
  [5964] = {.count = 1, .reusable = true}, SHIFT(2603),
  [5966] = {.count = 1, .reusable = true}, SHIFT(2604),
  [5968] = {.count = 1, .reusable = false}, SHIFT(2605),
  [5970] = {.count = 1, .reusable = true}, SHIFT(2605),
  [5972] = {.count = 1, .reusable = true}, SHIFT(2606),
  [5974] = {.count = 1, .reusable = true}, SHIFT(2607),
  [5976] = {.count = 1, .reusable = true}, SHIFT(2608),
  [5978] = {.count = 1, .reusable = true}, SHIFT(2609),
  [5980] = {.count = 1, .reusable = false}, SHIFT(2610),
  [5982] = {.count = 1, .reusable = true}, SHIFT(2610),
  [5984] = {.count = 1, .reusable = true}, SHIFT(2611),
  [5986] = {.count = 1, .reusable = false}, SHIFT(2612),
  [5988] = {.count = 1, .reusable = true}, SHIFT(2612),
  [5990] = {.count = 1, .reusable = true}, SHIFT(2613),
  [5992] = {.count = 1, .reusable = false}, SHIFT(2614),
  [5994] = {.count = 1, .reusable = true}, SHIFT(2614),
  [5996] = {.count = 1, .reusable = true}, SHIFT(2615),
  [5998] = {.count = 1, .reusable = true}, SHIFT(2616),
  [6000] = {.count = 1, .reusable = true}, SHIFT(2617),
  [6002] = {.count = 1, .reusable = true}, SHIFT(2618),
  [6004] = {.count = 1, .reusable = true}, SHIFT(2619),
  [6006] = {.count = 1, .reusable = true}, SHIFT(2620),
  [6008] = {.count = 1, .reusable = true}, SHIFT(2621),
  [6010] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2118),
  [6013] = {.count = 1, .reusable = true}, SHIFT(2622),
  [6015] = {.count = 1, .reusable = false}, SHIFT(2623),
  [6017] = {.count = 1, .reusable = true}, SHIFT(2624),
  [6019] = {.count = 1, .reusable = true}, SHIFT(2626),
  [6021] = {.count = 1, .reusable = true}, SHIFT(2627),
  [6023] = {.count = 1, .reusable = true}, SHIFT(2628),
  [6025] = {.count = 1, .reusable = true}, SHIFT(2629),
  [6027] = {.count = 1, .reusable = false}, SHIFT(2631),
  [6029] = {.count = 1, .reusable = true}, SHIFT(2631),
  [6031] = {.count = 1, .reusable = true}, SHIFT(2630),
  [6033] = {.count = 1, .reusable = true}, SHIFT(2632),
  [6035] = {.count = 1, .reusable = false}, SHIFT(2634),
  [6037] = {.count = 1, .reusable = true}, SHIFT(2634),
  [6039] = {.count = 1, .reusable = true}, SHIFT(2633),
  [6041] = {.count = 1, .reusable = false}, SHIFT(2636),
  [6043] = {.count = 1, .reusable = true}, SHIFT(2636),
  [6045] = {.count = 1, .reusable = true}, SHIFT(2635),
  [6047] = {.count = 1, .reusable = true}, SHIFT(2637),
  [6049] = {.count = 1, .reusable = true}, SHIFT(2638),
  [6051] = {.count = 1, .reusable = true}, SHIFT(2639),
  [6053] = {.count = 1, .reusable = true}, SHIFT(2640),
  [6055] = {.count = 1, .reusable = true}, SHIFT(2641),
  [6057] = {.count = 1, .reusable = true}, SHIFT(2642),
  [6059] = {.count = 1, .reusable = true}, SHIFT(2643),
  [6061] = {.count = 1, .reusable = true}, SHIFT(2644),
  [6063] = {.count = 1, .reusable = true}, SHIFT(2645),
  [6065] = {.count = 1, .reusable = true}, SHIFT(2646),
  [6067] = {.count = 1, .reusable = true}, SHIFT(2647),
  [6069] = {.count = 1, .reusable = true}, SHIFT(2648),
  [6071] = {.count = 1, .reusable = true}, SHIFT(2649),
  [6073] = {.count = 1, .reusable = true}, SHIFT(2650),
  [6075] = {.count = 1, .reusable = true}, SHIFT(2651),
  [6077] = {.count = 1, .reusable = true}, SHIFT(2652),
  [6079] = {.count = 1, .reusable = true}, SHIFT(2653),
  [6081] = {.count = 1, .reusable = true}, SHIFT(2654),
  [6083] = {.count = 1, .reusable = true}, SHIFT(2655),
  [6085] = {.count = 1, .reusable = true}, SHIFT(2657),
  [6087] = {.count = 1, .reusable = false}, SHIFT(2659),
  [6089] = {.count = 1, .reusable = true}, SHIFT(2661),
  [6091] = {.count = 1, .reusable = true}, SHIFT(2662),
  [6093] = {.count = 1, .reusable = false}, SHIFT(2663),
  [6095] = {.count = 1, .reusable = false}, SHIFT(2661),
  [6097] = {.count = 1, .reusable = true}, SHIFT(2664),
  [6099] = {.count = 1, .reusable = true}, SHIFT(2665),
  [6101] = {.count = 1, .reusable = true}, SHIFT(2666),
  [6103] = {.count = 1, .reusable = false}, SHIFT(2667),
  [6105] = {.count = 1, .reusable = false}, SHIFT(2665),
  [6107] = {.count = 1, .reusable = true}, SHIFT(2676),
  [6109] = {.count = 1, .reusable = true}, SHIFT(2677),
  [6111] = {.count = 1, .reusable = false}, SHIFT(2678),
  [6113] = {.count = 1, .reusable = true}, SHIFT(2679),
  [6115] = {.count = 1, .reusable = false}, SHIFT(2680),
  [6117] = {.count = 1, .reusable = false}, SHIFT(2681),
  [6119] = {.count = 1, .reusable = true}, SHIFT(2683),
  [6121] = {.count = 1, .reusable = true}, SHIFT(2684),
  [6123] = {.count = 1, .reusable = true}, SHIFT(2685),
  [6125] = {.count = 1, .reusable = true}, SHIFT(2686),
  [6127] = {.count = 1, .reusable = true}, SHIFT(2255),
  [6129] = {.count = 1, .reusable = true}, SHIFT(2256),
  [6131] = {.count = 1, .reusable = true}, SHIFT(2257),
  [6133] = {.count = 1, .reusable = true}, SHIFT(2258),
  [6135] = {.count = 1, .reusable = true}, SHIFT(2687),
  [6137] = {.count = 1, .reusable = false}, SHIFT(2689),
  [6139] = {.count = 1, .reusable = true}, SHIFT(2690),
  [6141] = {.count = 1, .reusable = true}, SHIFT(2691),
  [6143] = {.count = 1, .reusable = false}, SHIFT(2693),
  [6145] = {.count = 1, .reusable = true}, SHIFT(2693),
  [6147] = {.count = 1, .reusable = true}, SHIFT(2692),
  [6149] = {.count = 1, .reusable = true}, SHIFT(2694),
  [6151] = {.count = 1, .reusable = true}, SHIFT(2695),
  [6153] = {.count = 1, .reusable = false}, SHIFT(2696),
  [6155] = {.count = 1, .reusable = false}, SHIFT(2695),
  [6157] = {.count = 1, .reusable = true}, SHIFT(2698),
  [6159] = {.count = 1, .reusable = false}, SHIFT(2700),
  [6161] = {.count = 1, .reusable = true}, SHIFT(2700),
  [6163] = {.count = 1, .reusable = true}, SHIFT(2699),
  [6165] = {.count = 1, .reusable = true}, SHIFT(2701),
  [6167] = {.count = 1, .reusable = false}, SHIFT(2703),
  [6169] = {.count = 1, .reusable = true}, SHIFT(2703),
  [6171] = {.count = 1, .reusable = true}, SHIFT(2702),
  [6173] = {.count = 1, .reusable = true}, SHIFT(2704),
  [6175] = {.count = 1, .reusable = true}, SHIFT(2705),
  [6177] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2250),
  [6180] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2251),
  [6183] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2252),
  [6186] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2253),
  [6189] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2254),
  [6192] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2255),
  [6195] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2256),
  [6198] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2257),
  [6201] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2258),
  [6204] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2259),
  [6207] = {.count = 1, .reusable = true}, SHIFT(2706),
  [6209] = {.count = 1, .reusable = true}, SHIFT(2266),
  [6211] = {.count = 1, .reusable = true}, SHIFT(2267),
  [6213] = {.count = 1, .reusable = true}, SHIFT(2268),
  [6215] = {.count = 1, .reusable = true}, SHIFT(2269),
  [6217] = {.count = 1, .reusable = false}, SHIFT(2708),
  [6219] = {.count = 1, .reusable = true}, SHIFT(2709),
  [6221] = {.count = 1, .reusable = true}, SHIFT(2710),
  [6223] = {.count = 1, .reusable = false}, SHIFT(2712),
  [6225] = {.count = 1, .reusable = true}, SHIFT(2712),
  [6227] = {.count = 1, .reusable = true}, SHIFT(2711),
  [6229] = {.count = 1, .reusable = true}, SHIFT(2713),
  [6231] = {.count = 1, .reusable = true}, SHIFT(2714),
  [6233] = {.count = 1, .reusable = false}, SHIFT(2715),
  [6235] = {.count = 1, .reusable = false}, SHIFT(2714),
  [6237] = {.count = 1, .reusable = true}, SHIFT(2717),
  [6239] = {.count = 1, .reusable = false}, SHIFT(2719),
  [6241] = {.count = 1, .reusable = true}, SHIFT(2719),
  [6243] = {.count = 1, .reusable = true}, SHIFT(2718),
  [6245] = {.count = 1, .reusable = true}, SHIFT(2720),
  [6247] = {.count = 1, .reusable = false}, SHIFT(2722),
  [6249] = {.count = 1, .reusable = true}, SHIFT(2722),
  [6251] = {.count = 1, .reusable = true}, SHIFT(2721),
  [6253] = {.count = 1, .reusable = true}, SHIFT(2723),
  [6255] = {.count = 1, .reusable = true}, SHIFT(2724),
  [6257] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2262),
  [6260] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2263),
  [6263] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2264),
  [6266] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2265),
  [6269] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2266),
  [6272] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2267),
  [6275] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2268),
  [6278] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2269),
  [6281] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2270),
  [6284] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2272),
  [6287] = {.count = 1, .reusable = true}, SHIFT(2725),
  [6289] = {.count = 1, .reusable = false}, SHIFT(2726),
  [6291] = {.count = 1, .reusable = true}, SHIFT(2727),
  [6293] = {.count = 1, .reusable = true}, SHIFT(2729),
  [6295] = {.count = 1, .reusable = true}, SHIFT(2730),
  [6297] = {.count = 1, .reusable = true}, SHIFT(2731),
  [6299] = {.count = 1, .reusable = true}, SHIFT(2732),
  [6301] = {.count = 1, .reusable = false}, SHIFT(2734),
  [6303] = {.count = 1, .reusable = true}, SHIFT(2734),
  [6305] = {.count = 1, .reusable = true}, SHIFT(2733),
  [6307] = {.count = 1, .reusable = true}, SHIFT(2735),
  [6309] = {.count = 1, .reusable = false}, SHIFT(2737),
  [6311] = {.count = 1, .reusable = true}, SHIFT(2737),
  [6313] = {.count = 1, .reusable = true}, SHIFT(2736),
  [6315] = {.count = 1, .reusable = false}, SHIFT(2739),
  [6317] = {.count = 1, .reusable = true}, SHIFT(2739),
  [6319] = {.count = 1, .reusable = true}, SHIFT(2738),
  [6321] = {.count = 1, .reusable = true}, SHIFT(2740),
  [6323] = {.count = 1, .reusable = true}, SHIFT(2741),
  [6325] = {.count = 1, .reusable = true}, SHIFT(2742),
  [6327] = {.count = 1, .reusable = true}, SHIFT(2744),
  [6329] = {.count = 1, .reusable = true}, SHIFT(2745),
  [6331] = {.count = 1, .reusable = true}, SHIFT(2746),
  [6333] = {.count = 1, .reusable = false}, SHIFT(2748),
  [6335] = {.count = 1, .reusable = true}, SHIFT(2750),
  [6337] = {.count = 1, .reusable = true}, SHIFT(2751),
  [6339] = {.count = 1, .reusable = false}, SHIFT(2752),
  [6341] = {.count = 1, .reusable = false}, SHIFT(2750),
  [6343] = {.count = 1, .reusable = true}, SHIFT(2753),
  [6345] = {.count = 1, .reusable = true}, SHIFT(2754),
  [6347] = {.count = 1, .reusable = true}, SHIFT(2755),
  [6349] = {.count = 1, .reusable = false}, SHIFT(2756),
  [6351] = {.count = 1, .reusable = false}, SHIFT(2754),
  [6353] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2295),
  [6356] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2297),
  [6359] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2298),
  [6362] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2296),
  [6365] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2299),
  [6368] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1926),
  [6371] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1927),
  [6374] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2300),
  [6377] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1929),
  [6380] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1930),
  [6383] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1931),
  [6386] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1932),
  [6389] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5, .alias_sequence_id = 1),
  [6391] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [6393] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [6395] = {.count = 1, .reusable = false}, SHIFT(2765),
  [6397] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5),
  [6399] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5),
  [6401] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5),
  [6403] = {.count = 1, .reusable = false}, SHIFT(2766),
  [6405] = {.count = 1, .reusable = false}, SHIFT(2767),
  [6407] = {.count = 1, .reusable = true}, SHIFT(2768),
  [6409] = {.count = 1, .reusable = false}, SHIFT(2773),
  [6411] = {.count = 1, .reusable = true}, SHIFT(2774),
  [6413] = {.count = 1, .reusable = true}, SHIFT(2778),
  [6415] = {.count = 1, .reusable = true}, SHIFT(2779),
  [6417] = {.count = 1, .reusable = true}, SHIFT(2780),
  [6419] = {.count = 1, .reusable = true}, SHIFT(2781),
  [6421] = {.count = 1, .reusable = false}, SHIFT(2782),
  [6423] = {.count = 1, .reusable = true}, SHIFT(2782),
  [6425] = {.count = 1, .reusable = true}, SHIFT(2783),
  [6427] = {.count = 1, .reusable = false}, SHIFT(2784),
  [6429] = {.count = 1, .reusable = true}, SHIFT(2784),
  [6431] = {.count = 1, .reusable = true}, SHIFT(2785),
  [6433] = {.count = 1, .reusable = false}, SHIFT(2786),
  [6435] = {.count = 1, .reusable = true}, SHIFT(2786),
  [6437] = {.count = 1, .reusable = true}, SHIFT(2787),
  [6439] = {.count = 1, .reusable = true}, SHIFT(2788),
  [6441] = {.count = 1, .reusable = true}, SHIFT(2789),
  [6443] = {.count = 1, .reusable = true}, SHIFT(2790),
  [6445] = {.count = 1, .reusable = true}, SHIFT(2791),
  [6447] = {.count = 1, .reusable = true}, SHIFT(2792),
  [6449] = {.count = 1, .reusable = true}, SHIFT(2793),
  [6451] = {.count = 1, .reusable = true}, SHIFT(2794),
  [6453] = {.count = 1, .reusable = false}, SHIFT(2795),
  [6455] = {.count = 1, .reusable = true}, SHIFT(2795),
  [6457] = {.count = 1, .reusable = false}, SHIFT(2796),
  [6459] = {.count = 1, .reusable = true}, SHIFT(2797),
  [6461] = {.count = 1, .reusable = true}, SHIFT(2799),
  [6463] = {.count = 1, .reusable = true}, SHIFT(2800),
  [6465] = {.count = 1, .reusable = true}, SHIFT(2801),
  [6467] = {.count = 1, .reusable = true}, SHIFT(2802),
  [6469] = {.count = 1, .reusable = true}, SHIFT(2803),
  [6471] = {.count = 1, .reusable = true}, SHIFT(2804),
  [6473] = {.count = 1, .reusable = false}, SHIFT(2805),
  [6475] = {.count = 1, .reusable = true}, SHIFT(2805),
  [6477] = {.count = 1, .reusable = true}, SHIFT(2806),
  [6479] = {.count = 1, .reusable = false}, SHIFT(2807),
  [6481] = {.count = 1, .reusable = true}, SHIFT(2807),
  [6483] = {.count = 1, .reusable = true}, SHIFT(2808),
  [6485] = {.count = 1, .reusable = true}, SHIFT(2809),
  [6487] = {.count = 1, .reusable = false}, SHIFT(2811),
  [6489] = {.count = 1, .reusable = true}, SHIFT(2812),
  [6491] = {.count = 1, .reusable = true}, SHIFT(2813),
  [6493] = {.count = 1, .reusable = false}, SHIFT(2815),
  [6495] = {.count = 1, .reusable = true}, SHIFT(2815),
  [6497] = {.count = 1, .reusable = true}, SHIFT(2814),
  [6499] = {.count = 1, .reusable = true}, SHIFT(2816),
  [6501] = {.count = 1, .reusable = true}, SHIFT(2817),
  [6503] = {.count = 1, .reusable = false}, SHIFT(2818),
  [6505] = {.count = 1, .reusable = false}, SHIFT(2817),
  [6507] = {.count = 1, .reusable = true}, SHIFT(2820),
  [6509] = {.count = 1, .reusable = false}, SHIFT(2822),
  [6511] = {.count = 1, .reusable = true}, SHIFT(2822),
  [6513] = {.count = 1, .reusable = true}, SHIFT(2821),
  [6515] = {.count = 1, .reusable = true}, SHIFT(2823),
  [6517] = {.count = 1, .reusable = false}, SHIFT(2825),
  [6519] = {.count = 1, .reusable = true}, SHIFT(2825),
  [6521] = {.count = 1, .reusable = true}, SHIFT(2824),
  [6523] = {.count = 1, .reusable = true}, SHIFT(2826),
  [6525] = {.count = 1, .reusable = true}, SHIFT(2827),
  [6527] = {.count = 1, .reusable = false}, SHIFT(2829),
  [6529] = {.count = 1, .reusable = true}, SHIFT(2829),
  [6531] = {.count = 1, .reusable = true}, SHIFT(2830),
  [6533] = {.count = 1, .reusable = true}, SHIFT(2831),
  [6535] = {.count = 1, .reusable = false}, SHIFT(2832),
  [6537] = {.count = 1, .reusable = true}, SHIFT(2833),
  [6539] = {.count = 1, .reusable = true}, SHIFT(2834),
  [6541] = {.count = 1, .reusable = true}, SHIFT(2835),
  [6543] = {.count = 1, .reusable = true}, SHIFT(2836),
  [6545] = {.count = 1, .reusable = true}, SHIFT(2837),
  [6547] = {.count = 1, .reusable = false}, SHIFT(2838),
  [6549] = {.count = 1, .reusable = true}, SHIFT(2838),
  [6551] = {.count = 1, .reusable = true}, SHIFT(2839),
  [6553] = {.count = 1, .reusable = true}, SHIFT(2840),
  [6555] = {.count = 1, .reusable = true}, SHIFT(2841),
  [6557] = {.count = 1, .reusable = true}, SHIFT(2842),
  [6559] = {.count = 1, .reusable = true}, SHIFT(2844),
  [6561] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2491),
  [6564] = {.count = 1, .reusable = true}, SHIFT(2846),
  [6566] = {.count = 1, .reusable = false}, SHIFT(2847),
  [6568] = {.count = 1, .reusable = true}, SHIFT(2848),
  [6570] = {.count = 1, .reusable = true}, SHIFT(2850),
  [6572] = {.count = 1, .reusable = true}, SHIFT(2851),
  [6574] = {.count = 1, .reusable = true}, SHIFT(2852),
  [6576] = {.count = 1, .reusable = true}, SHIFT(2853),
  [6578] = {.count = 1, .reusable = false}, SHIFT(2855),
  [6580] = {.count = 1, .reusable = true}, SHIFT(2855),
  [6582] = {.count = 1, .reusable = true}, SHIFT(2854),
  [6584] = {.count = 1, .reusable = true}, SHIFT(2856),
  [6586] = {.count = 1, .reusable = false}, SHIFT(2858),
  [6588] = {.count = 1, .reusable = true}, SHIFT(2858),
  [6590] = {.count = 1, .reusable = true}, SHIFT(2857),
  [6592] = {.count = 1, .reusable = false}, SHIFT(2860),
  [6594] = {.count = 1, .reusable = true}, SHIFT(2860),
  [6596] = {.count = 1, .reusable = true}, SHIFT(2859),
  [6598] = {.count = 1, .reusable = true}, SHIFT(2861),
  [6600] = {.count = 1, .reusable = true}, SHIFT(2862),
  [6602] = {.count = 1, .reusable = true}, SHIFT(2863),
  [6604] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2510),
  [6607] = {.count = 1, .reusable = true}, SHIFT(2864),
  [6609] = {.count = 1, .reusable = false}, SHIFT(2865),
  [6611] = {.count = 1, .reusable = true}, SHIFT(2866),
  [6613] = {.count = 1, .reusable = true}, SHIFT(2868),
  [6615] = {.count = 1, .reusable = true}, SHIFT(2869),
  [6617] = {.count = 1, .reusable = true}, SHIFT(2870),
  [6619] = {.count = 1, .reusable = true}, SHIFT(2871),
  [6621] = {.count = 1, .reusable = false}, SHIFT(2873),
  [6623] = {.count = 1, .reusable = true}, SHIFT(2873),
  [6625] = {.count = 1, .reusable = true}, SHIFT(2872),
  [6627] = {.count = 1, .reusable = true}, SHIFT(2874),
  [6629] = {.count = 1, .reusable = false}, SHIFT(2876),
  [6631] = {.count = 1, .reusable = true}, SHIFT(2876),
  [6633] = {.count = 1, .reusable = true}, SHIFT(2875),
  [6635] = {.count = 1, .reusable = false}, SHIFT(2878),
  [6637] = {.count = 1, .reusable = true}, SHIFT(2878),
  [6639] = {.count = 1, .reusable = true}, SHIFT(2877),
  [6641] = {.count = 1, .reusable = true}, SHIFT(2879),
  [6643] = {.count = 1, .reusable = true}, SHIFT(2880),
  [6645] = {.count = 1, .reusable = true}, SHIFT(2881),
  [6647] = {.count = 1, .reusable = true}, SHIFT(2882),
  [6649] = {.count = 1, .reusable = true}, SHIFT(2883),
  [6651] = {.count = 1, .reusable = true}, SHIFT(2884),
  [6653] = {.count = 1, .reusable = false}, SHIFT(2885),
  [6655] = {.count = 1, .reusable = true}, SHIFT(2885),
  [6657] = {.count = 1, .reusable = false}, SHIFT(2886),
  [6659] = {.count = 1, .reusable = true}, SHIFT(2887),
  [6661] = {.count = 1, .reusable = true}, SHIFT(2889),
  [6663] = {.count = 1, .reusable = true}, SHIFT(2890),
  [6665] = {.count = 1, .reusable = true}, SHIFT(2891),
  [6667] = {.count = 1, .reusable = true}, SHIFT(2892),
  [6669] = {.count = 1, .reusable = true}, SHIFT(2893),
  [6671] = {.count = 1, .reusable = true}, SHIFT(2894),
  [6673] = {.count = 1, .reusable = false}, SHIFT(2895),
  [6675] = {.count = 1, .reusable = true}, SHIFT(2895),
  [6677] = {.count = 1, .reusable = true}, SHIFT(2896),
  [6679] = {.count = 1, .reusable = false}, SHIFT(2897),
  [6681] = {.count = 1, .reusable = true}, SHIFT(2897),
  [6683] = {.count = 1, .reusable = true}, SHIFT(2898),
  [6685] = {.count = 1, .reusable = false}, SHIFT(2900),
  [6687] = {.count = 1, .reusable = true}, SHIFT(2901),
  [6689] = {.count = 1, .reusable = true}, SHIFT(2902),
  [6691] = {.count = 1, .reusable = false}, SHIFT(2904),
  [6693] = {.count = 1, .reusable = true}, SHIFT(2904),
  [6695] = {.count = 1, .reusable = true}, SHIFT(2903),
  [6697] = {.count = 1, .reusable = true}, SHIFT(2905),
  [6699] = {.count = 1, .reusable = true}, SHIFT(2906),
  [6701] = {.count = 1, .reusable = false}, SHIFT(2907),
  [6703] = {.count = 1, .reusable = false}, SHIFT(2906),
  [6705] = {.count = 1, .reusable = true}, SHIFT(2909),
  [6707] = {.count = 1, .reusable = false}, SHIFT(2911),
  [6709] = {.count = 1, .reusable = true}, SHIFT(2911),
  [6711] = {.count = 1, .reusable = true}, SHIFT(2910),
  [6713] = {.count = 1, .reusable = true}, SHIFT(2912),
  [6715] = {.count = 1, .reusable = false}, SHIFT(2914),
  [6717] = {.count = 1, .reusable = true}, SHIFT(2914),
  [6719] = {.count = 1, .reusable = true}, SHIFT(2913),
  [6721] = {.count = 1, .reusable = true}, SHIFT(2915),
  [6723] = {.count = 1, .reusable = true}, SHIFT(2916),
  [6725] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 6, .alias_sequence_id = 1),
  [6727] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 6, .alias_sequence_id = 1),
  [6729] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 6, .alias_sequence_id = 1),
  [6731] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 6),
  [6733] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 6),
  [6735] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 6),
  [6737] = {.count = 1, .reusable = false}, SHIFT(2917),
  [6739] = {.count = 1, .reusable = true}, SHIFT(2918),
  [6741] = {.count = 1, .reusable = false}, SHIFT(2921),
  [6743] = {.count = 1, .reusable = true}, SHIFT(2922),
  [6745] = {.count = 1, .reusable = true}, SHIFT(2925),
  [6747] = {.count = 1, .reusable = true}, SHIFT(2926),
  [6749] = {.count = 1, .reusable = true}, SHIFT(2927),
  [6751] = {.count = 1, .reusable = true}, SHIFT(2928),
  [6753] = {.count = 1, .reusable = true}, SHIFT(2929),
  [6755] = {.count = 1, .reusable = true}, SHIFT(2930),
  [6757] = {.count = 1, .reusable = true}, SHIFT(2931),
  [6759] = {.count = 1, .reusable = false}, SHIFT(2932),
  [6761] = {.count = 1, .reusable = true}, SHIFT(2932),
  [6763] = {.count = 1, .reusable = true}, SHIFT(2933),
  [6765] = {.count = 1, .reusable = false}, SHIFT(2934),
  [6767] = {.count = 1, .reusable = true}, SHIFT(2934),
  [6769] = {.count = 1, .reusable = true}, SHIFT(2935),
  [6771] = {.count = 1, .reusable = false}, SHIFT(2936),
  [6773] = {.count = 1, .reusable = true}, SHIFT(2936),
  [6775] = {.count = 1, .reusable = true}, SHIFT(2937),
  [6777] = {.count = 1, .reusable = true}, SHIFT(2938),
  [6779] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2657),
  [6782] = {.count = 1, .reusable = true}, SHIFT(2939),
  [6784] = {.count = 1, .reusable = false}, SHIFT(2940),
  [6786] = {.count = 1, .reusable = true}, SHIFT(2941),
  [6788] = {.count = 1, .reusable = true}, SHIFT(2943),
  [6790] = {.count = 1, .reusable = true}, SHIFT(2944),
  [6792] = {.count = 1, .reusable = true}, SHIFT(2945),
  [6794] = {.count = 1, .reusable = true}, SHIFT(2946),
  [6796] = {.count = 1, .reusable = false}, SHIFT(2948),
  [6798] = {.count = 1, .reusable = true}, SHIFT(2948),
  [6800] = {.count = 1, .reusable = true}, SHIFT(2947),
  [6802] = {.count = 1, .reusable = true}, SHIFT(2949),
  [6804] = {.count = 1, .reusable = false}, SHIFT(2951),
  [6806] = {.count = 1, .reusable = true}, SHIFT(2951),
  [6808] = {.count = 1, .reusable = true}, SHIFT(2950),
  [6810] = {.count = 1, .reusable = false}, SHIFT(2953),
  [6812] = {.count = 1, .reusable = true}, SHIFT(2953),
  [6814] = {.count = 1, .reusable = true}, SHIFT(2952),
  [6816] = {.count = 1, .reusable = true}, SHIFT(2954),
  [6818] = {.count = 1, .reusable = true}, SHIFT(2955),
  [6820] = {.count = 1, .reusable = true}, SHIFT(2956),
  [6822] = {.count = 1, .reusable = true}, SHIFT(2957),
  [6824] = {.count = 1, .reusable = true}, SHIFT(2958),
  [6826] = {.count = 1, .reusable = true}, SHIFT(2959),
  [6828] = {.count = 1, .reusable = false}, SHIFT(2961),
  [6830] = {.count = 1, .reusable = true}, SHIFT(2963),
  [6832] = {.count = 1, .reusable = true}, SHIFT(2964),
  [6834] = {.count = 1, .reusable = false}, SHIFT(2965),
  [6836] = {.count = 1, .reusable = false}, SHIFT(2963),
  [6838] = {.count = 1, .reusable = true}, SHIFT(2966),
  [6840] = {.count = 1, .reusable = true}, SHIFT(2967),
  [6842] = {.count = 1, .reusable = true}, SHIFT(2968),
  [6844] = {.count = 1, .reusable = false}, SHIFT(2969),
  [6846] = {.count = 1, .reusable = false}, SHIFT(2967),
  [6848] = {.count = 1, .reusable = true}, SHIFT(2977),
  [6850] = {.count = 1, .reusable = true}, SHIFT(2978),
  [6852] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2679),
  [6855] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2680),
  [6858] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2681),
  [6861] = {.count = 1, .reusable = true}, SHIFT(2980),
  [6863] = {.count = 1, .reusable = true}, SHIFT(2981),
  [6865] = {.count = 1, .reusable = true}, SHIFT(2982),
  [6867] = {.count = 1, .reusable = true}, SHIFT(2983),
  [6869] = {.count = 1, .reusable = false}, SHIFT(2984),
  [6871] = {.count = 1, .reusable = true}, SHIFT(2984),
  [6873] = {.count = 1, .reusable = false}, SHIFT(2985),
  [6875] = {.count = 1, .reusable = true}, SHIFT(2986),
  [6877] = {.count = 1, .reusable = true}, SHIFT(2988),
  [6879] = {.count = 1, .reusable = true}, SHIFT(2989),
  [6881] = {.count = 1, .reusable = true}, SHIFT(2990),
  [6883] = {.count = 1, .reusable = true}, SHIFT(2991),
  [6885] = {.count = 1, .reusable = true}, SHIFT(2992),
  [6887] = {.count = 1, .reusable = true}, SHIFT(2993),
  [6889] = {.count = 1, .reusable = false}, SHIFT(2994),
  [6891] = {.count = 1, .reusable = true}, SHIFT(2994),
  [6893] = {.count = 1, .reusable = true}, SHIFT(2995),
  [6895] = {.count = 1, .reusable = false}, SHIFT(2996),
  [6897] = {.count = 1, .reusable = true}, SHIFT(2996),
  [6899] = {.count = 1, .reusable = true}, SHIFT(2997),
  [6901] = {.count = 1, .reusable = true}, SHIFT(2998),
  [6903] = {.count = 1, .reusable = true}, SHIFT(2999),
  [6905] = {.count = 1, .reusable = false}, SHIFT(3000),
  [6907] = {.count = 1, .reusable = true}, SHIFT(3000),
  [6909] = {.count = 1, .reusable = false}, SHIFT(3001),
  [6911] = {.count = 1, .reusable = true}, SHIFT(3002),
  [6913] = {.count = 1, .reusable = true}, SHIFT(3004),
  [6915] = {.count = 1, .reusable = true}, SHIFT(3005),
  [6917] = {.count = 1, .reusable = true}, SHIFT(3006),
  [6919] = {.count = 1, .reusable = true}, SHIFT(3007),
  [6921] = {.count = 1, .reusable = true}, SHIFT(3008),
  [6923] = {.count = 1, .reusable = true}, SHIFT(3009),
  [6925] = {.count = 1, .reusable = false}, SHIFT(3010),
  [6927] = {.count = 1, .reusable = true}, SHIFT(3010),
  [6929] = {.count = 1, .reusable = true}, SHIFT(3011),
  [6931] = {.count = 1, .reusable = false}, SHIFT(3012),
  [6933] = {.count = 1, .reusable = true}, SHIFT(3012),
  [6935] = {.count = 1, .reusable = true}, SHIFT(3013),
  [6937] = {.count = 1, .reusable = true}, SHIFT(3014),
  [6939] = {.count = 1, .reusable = true}, SHIFT(3015),
  [6941] = {.count = 1, .reusable = true}, SHIFT(3016),
  [6943] = {.count = 1, .reusable = false}, SHIFT(3017),
  [6945] = {.count = 1, .reusable = true}, SHIFT(3017),
  [6947] = {.count = 1, .reusable = true}, SHIFT(3018),
  [6949] = {.count = 1, .reusable = false}, SHIFT(3019),
  [6951] = {.count = 1, .reusable = true}, SHIFT(3019),
  [6953] = {.count = 1, .reusable = true}, SHIFT(3020),
  [6955] = {.count = 1, .reusable = false}, SHIFT(3021),
  [6957] = {.count = 1, .reusable = true}, SHIFT(3021),
  [6959] = {.count = 1, .reusable = true}, SHIFT(3022),
  [6961] = {.count = 1, .reusable = true}, SHIFT(3023),
  [6963] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2746),
  [6966] = {.count = 1, .reusable = true}, SHIFT(3024),
  [6968] = {.count = 1, .reusable = false}, SHIFT(3025),
  [6970] = {.count = 1, .reusable = true}, SHIFT(3026),
  [6972] = {.count = 1, .reusable = true}, SHIFT(3028),
  [6974] = {.count = 1, .reusable = true}, SHIFT(3029),
  [6976] = {.count = 1, .reusable = true}, SHIFT(3030),
  [6978] = {.count = 1, .reusable = true}, SHIFT(3031),
  [6980] = {.count = 1, .reusable = false}, SHIFT(3033),
  [6982] = {.count = 1, .reusable = true}, SHIFT(3033),
  [6984] = {.count = 1, .reusable = true}, SHIFT(3032),
  [6986] = {.count = 1, .reusable = true}, SHIFT(3034),
  [6988] = {.count = 1, .reusable = false}, SHIFT(3036),
  [6990] = {.count = 1, .reusable = true}, SHIFT(3036),
  [6992] = {.count = 1, .reusable = true}, SHIFT(3035),
  [6994] = {.count = 1, .reusable = false}, SHIFT(3038),
  [6996] = {.count = 1, .reusable = true}, SHIFT(3038),
  [6998] = {.count = 1, .reusable = true}, SHIFT(3037),
  [7000] = {.count = 1, .reusable = true}, SHIFT(3039),
  [7002] = {.count = 1, .reusable = true}, SHIFT(3040),
  [7004] = {.count = 1, .reusable = true}, SHIFT(3041),
  [7006] = {.count = 1, .reusable = false}, SHIFT(3042),
  [7008] = {.count = 1, .reusable = false}, SHIFT(3043),
  [7010] = {.count = 1, .reusable = true}, SHIFT(3044),
  [7012] = {.count = 1, .reusable = true}, SHIFT(3045),
  [7014] = {.count = 1, .reusable = true}, SHIFT(3046),
  [7016] = {.count = 1, .reusable = true}, SHIFT(3047),
  [7018] = {.count = 1, .reusable = true}, SHIFT(3048),
  [7020] = {.count = 1, .reusable = true}, SHIFT(3049),
  [7022] = {.count = 1, .reusable = false}, SHIFT(3050),
  [7024] = {.count = 1, .reusable = true}, SHIFT(3050),
  [7026] = {.count = 1, .reusable = false}, SHIFT(3051),
  [7028] = {.count = 1, .reusable = true}, SHIFT(3052),
  [7030] = {.count = 1, .reusable = true}, SHIFT(3054),
  [7032] = {.count = 1, .reusable = true}, SHIFT(3055),
  [7034] = {.count = 1, .reusable = true}, SHIFT(3056),
  [7036] = {.count = 1, .reusable = true}, SHIFT(3057),
  [7038] = {.count = 1, .reusable = true}, SHIFT(3058),
  [7040] = {.count = 1, .reusable = true}, SHIFT(3059),
  [7042] = {.count = 1, .reusable = false}, SHIFT(3060),
  [7044] = {.count = 1, .reusable = true}, SHIFT(3060),
  [7046] = {.count = 1, .reusable = true}, SHIFT(3061),
  [7048] = {.count = 1, .reusable = false}, SHIFT(3062),
  [7050] = {.count = 1, .reusable = true}, SHIFT(3062),
  [7052] = {.count = 1, .reusable = true}, SHIFT(3063),
  [7054] = {.count = 1, .reusable = false}, SHIFT(3065),
  [7056] = {.count = 1, .reusable = true}, SHIFT(3066),
  [7058] = {.count = 1, .reusable = true}, SHIFT(3067),
  [7060] = {.count = 1, .reusable = false}, SHIFT(3069),
  [7062] = {.count = 1, .reusable = true}, SHIFT(3069),
  [7064] = {.count = 1, .reusable = true}, SHIFT(3068),
  [7066] = {.count = 1, .reusable = true}, SHIFT(3070),
  [7068] = {.count = 1, .reusable = true}, SHIFT(3071),
  [7070] = {.count = 1, .reusable = false}, SHIFT(3072),
  [7072] = {.count = 1, .reusable = false}, SHIFT(3071),
  [7074] = {.count = 1, .reusable = true}, SHIFT(3074),
  [7076] = {.count = 1, .reusable = false}, SHIFT(3076),
  [7078] = {.count = 1, .reusable = true}, SHIFT(3076),
  [7080] = {.count = 1, .reusable = true}, SHIFT(3075),
  [7082] = {.count = 1, .reusable = true}, SHIFT(3077),
  [7084] = {.count = 1, .reusable = false}, SHIFT(3079),
  [7086] = {.count = 1, .reusable = true}, SHIFT(3079),
  [7088] = {.count = 1, .reusable = true}, SHIFT(3078),
  [7090] = {.count = 1, .reusable = true}, SHIFT(3080),
  [7092] = {.count = 1, .reusable = true}, SHIFT(3081),
  [7094] = {.count = 1, .reusable = true}, SHIFT(3083),
  [7096] = {.count = 1, .reusable = true}, SHIFT(3084),
  [7098] = {.count = 1, .reusable = true}, SHIFT(3085),
  [7100] = {.count = 1, .reusable = true}, SHIFT(3086),
  [7102] = {.count = 1, .reusable = false}, SHIFT(3087),
  [7104] = {.count = 1, .reusable = true}, SHIFT(3087),
  [7106] = {.count = 1, .reusable = true}, SHIFT(3088),
  [7108] = {.count = 1, .reusable = false}, SHIFT(3089),
  [7110] = {.count = 1, .reusable = true}, SHIFT(3089),
  [7112] = {.count = 1, .reusable = true}, SHIFT(3090),
  [7114] = {.count = 1, .reusable = false}, SHIFT(3091),
  [7116] = {.count = 1, .reusable = true}, SHIFT(3091),
  [7118] = {.count = 1, .reusable = true}, SHIFT(3092),
  [7120] = {.count = 1, .reusable = true}, SHIFT(3093),
  [7122] = {.count = 1, .reusable = true}, SHIFT(3094),
  [7124] = {.count = 1, .reusable = true}, SHIFT(3095),
  [7126] = {.count = 1, .reusable = true}, SHIFT(3096),
  [7128] = {.count = 1, .reusable = true}, SHIFT(3097),
  [7130] = {.count = 1, .reusable = false}, SHIFT(3098),
  [7132] = {.count = 1, .reusable = true}, SHIFT(3098),
  [7134] = {.count = 1, .reusable = true}, SHIFT(3099),
  [7136] = {.count = 1, .reusable = false}, SHIFT(3100),
  [7138] = {.count = 1, .reusable = true}, SHIFT(3100),
  [7140] = {.count = 1, .reusable = true}, SHIFT(3101),
  [7142] = {.count = 1, .reusable = false}, SHIFT(3102),
  [7144] = {.count = 1, .reusable = true}, SHIFT(3102),
  [7146] = {.count = 1, .reusable = true}, SHIFT(3103),
  [7148] = {.count = 1, .reusable = true}, SHIFT(3104),
  [7150] = {.count = 1, .reusable = true}, SHIFT(3105),
  [7152] = {.count = 1, .reusable = true}, SHIFT(3106),
  [7154] = {.count = 1, .reusable = true}, SHIFT(3107),
  [7156] = {.count = 1, .reusable = true}, SHIFT(3108),
  [7158] = {.count = 1, .reusable = true}, SHIFT(3109),
  [7160] = {.count = 1, .reusable = true}, SHIFT(3110),
  [7162] = {.count = 1, .reusable = false}, SHIFT(3111),
  [7164] = {.count = 1, .reusable = true}, SHIFT(3111),
  [7166] = {.count = 1, .reusable = false}, SHIFT(3112),
  [7168] = {.count = 1, .reusable = true}, SHIFT(3113),
  [7170] = {.count = 1, .reusable = true}, SHIFT(3115),
  [7172] = {.count = 1, .reusable = true}, SHIFT(3116),
  [7174] = {.count = 1, .reusable = true}, SHIFT(3117),
  [7176] = {.count = 1, .reusable = true}, SHIFT(3118),
  [7178] = {.count = 1, .reusable = true}, SHIFT(3119),
  [7180] = {.count = 1, .reusable = true}, SHIFT(3120),
  [7182] = {.count = 1, .reusable = false}, SHIFT(3121),
  [7184] = {.count = 1, .reusable = true}, SHIFT(3121),
  [7186] = {.count = 1, .reusable = true}, SHIFT(3122),
  [7188] = {.count = 1, .reusable = false}, SHIFT(3123),
  [7190] = {.count = 1, .reusable = true}, SHIFT(3123),
  [7192] = {.count = 1, .reusable = true}, SHIFT(3124),
  [7194] = {.count = 1, .reusable = true}, SHIFT(3125),
  [7196] = {.count = 1, .reusable = true}, SHIFT(3126),
  [7198] = {.count = 1, .reusable = true}, SHIFT(3127),
  [7200] = {.count = 1, .reusable = false}, SHIFT(3128),
  [7202] = {.count = 1, .reusable = true}, SHIFT(3128),
  [7204] = {.count = 1, .reusable = true}, SHIFT(3129),
  [7206] = {.count = 1, .reusable = false}, SHIFT(3130),
  [7208] = {.count = 1, .reusable = true}, SHIFT(3130),
  [7210] = {.count = 1, .reusable = true}, SHIFT(3131),
  [7212] = {.count = 1, .reusable = false}, SHIFT(3132),
  [7214] = {.count = 1, .reusable = true}, SHIFT(3132),
  [7216] = {.count = 1, .reusable = true}, SHIFT(3133),
  [7218] = {.count = 1, .reusable = true}, SHIFT(3134),
  [7220] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2959),
  [7223] = {.count = 1, .reusable = true}, SHIFT(3135),
  [7225] = {.count = 1, .reusable = false}, SHIFT(3136),
  [7227] = {.count = 1, .reusable = true}, SHIFT(3137),
  [7229] = {.count = 1, .reusable = true}, SHIFT(3139),
  [7231] = {.count = 1, .reusable = true}, SHIFT(3140),
  [7233] = {.count = 1, .reusable = true}, SHIFT(3141),
  [7235] = {.count = 1, .reusable = true}, SHIFT(3142),
  [7237] = {.count = 1, .reusable = false}, SHIFT(3144),
  [7239] = {.count = 1, .reusable = true}, SHIFT(3144),
  [7241] = {.count = 1, .reusable = true}, SHIFT(3143),
  [7243] = {.count = 1, .reusable = true}, SHIFT(3145),
  [7245] = {.count = 1, .reusable = false}, SHIFT(3147),
  [7247] = {.count = 1, .reusable = true}, SHIFT(3147),
  [7249] = {.count = 1, .reusable = true}, SHIFT(3146),
  [7251] = {.count = 1, .reusable = false}, SHIFT(3149),
  [7253] = {.count = 1, .reusable = true}, SHIFT(3149),
  [7255] = {.count = 1, .reusable = true}, SHIFT(3148),
  [7257] = {.count = 1, .reusable = true}, SHIFT(3150),
  [7259] = {.count = 1, .reusable = true}, SHIFT(3151),
  [7261] = {.count = 1, .reusable = true}, SHIFT(3152),
  [7263] = {.count = 1, .reusable = true}, SHIFT(3153),
  [7265] = {.count = 1, .reusable = true}, SHIFT(3154),
  [7267] = {.count = 1, .reusable = true}, SHIFT(3155),
  [7269] = {.count = 1, .reusable = true}, SHIFT(3156),
  [7271] = {.count = 1, .reusable = true}, SHIFT(3157),
  [7273] = {.count = 1, .reusable = true}, SHIFT(3158),
  [7275] = {.count = 1, .reusable = true}, SHIFT(3159),
  [7277] = {.count = 1, .reusable = true}, SHIFT(3160),
  [7279] = {.count = 1, .reusable = true}, SHIFT(3161),
  [7281] = {.count = 1, .reusable = true}, SHIFT(3162),
  [7283] = {.count = 1, .reusable = false}, SHIFT(3163),
  [7285] = {.count = 1, .reusable = true}, SHIFT(3163),
  [7287] = {.count = 1, .reusable = true}, SHIFT(3164),
  [7289] = {.count = 1, .reusable = false}, SHIFT(3165),
  [7291] = {.count = 1, .reusable = true}, SHIFT(3165),
  [7293] = {.count = 1, .reusable = true}, SHIFT(3166),
  [7295] = {.count = 1, .reusable = false}, SHIFT(3167),
  [7297] = {.count = 1, .reusable = true}, SHIFT(3167),
  [7299] = {.count = 1, .reusable = true}, SHIFT(3168),
  [7301] = {.count = 1, .reusable = true}, SHIFT(3169),
  [7303] = {.count = 1, .reusable = true}, SHIFT(3170),
  [7305] = {.count = 1, .reusable = true}, SHIFT(3171),
  [7307] = {.count = 1, .reusable = true}, SHIFT(3172),
  [7309] = {.count = 1, .reusable = true}, SHIFT(3173),
  [7311] = {.count = 1, .reusable = true}, SHIFT(3174),
  [7313] = {.count = 1, .reusable = true}, SHIFT(3175),
  [7315] = {.count = 1, .reusable = false}, SHIFT(3176),
  [7317] = {.count = 1, .reusable = true}, SHIFT(3176),
  [7319] = {.count = 1, .reusable = false}, SHIFT(3177),
  [7321] = {.count = 1, .reusable = true}, SHIFT(3178),
  [7323] = {.count = 1, .reusable = true}, SHIFT(3180),
  [7325] = {.count = 1, .reusable = true}, SHIFT(3181),
  [7327] = {.count = 1, .reusable = true}, SHIFT(3182),
  [7329] = {.count = 1, .reusable = true}, SHIFT(3183),
  [7331] = {.count = 1, .reusable = true}, SHIFT(3184),
  [7333] = {.count = 1, .reusable = true}, SHIFT(3185),
  [7335] = {.count = 1, .reusable = false}, SHIFT(3186),
  [7337] = {.count = 1, .reusable = true}, SHIFT(3186),
  [7339] = {.count = 1, .reusable = true}, SHIFT(3187),
  [7341] = {.count = 1, .reusable = false}, SHIFT(3188),
  [7343] = {.count = 1, .reusable = true}, SHIFT(3188),
  [7345] = {.count = 1, .reusable = true}, SHIFT(3189),
  [7347] = {.count = 1, .reusable = true}, SHIFT(3190),
  [7349] = {.count = 1, .reusable = true}, SHIFT(3191),
  [7351] = {.count = 1, .reusable = true}, SHIFT(3192),
  [7353] = {.count = 1, .reusable = true}, SHIFT(3193),
  [7355] = {.count = 1, .reusable = true}, SHIFT(3194),
  [7357] = {.count = 1, .reusable = true}, SHIFT(3195),
  [7359] = {.count = 1, .reusable = false}, SHIFT(3196),
  [7361] = {.count = 1, .reusable = true}, SHIFT(3196),
  [7363] = {.count = 1, .reusable = true}, SHIFT(3197),
  [7365] = {.count = 1, .reusable = false}, SHIFT(3198),
  [7367] = {.count = 1, .reusable = true}, SHIFT(3198),
  [7369] = {.count = 1, .reusable = true}, SHIFT(3199),
  [7371] = {.count = 1, .reusable = false}, SHIFT(3200),
  [7373] = {.count = 1, .reusable = true}, SHIFT(3200),
  [7375] = {.count = 1, .reusable = true}, SHIFT(3201),
  [7377] = {.count = 1, .reusable = true}, SHIFT(3202),
  [7379] = {.count = 1, .reusable = true}, SHIFT(3203),
  [7381] = {.count = 1, .reusable = true}, SHIFT(3204),
  [7383] = {.count = 1, .reusable = true}, SHIFT(3205),
};

void *tree_sitter_bash_external_scanner_create();
void tree_sitter_bash_external_scanner_destroy(void *);
bool tree_sitter_bash_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_bash_external_scanner_serialize(void *, char *);
void tree_sitter_bash_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_bash() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_bash_external_scanner_create,
      tree_sitter_bash_external_scanner_destroy,
      tree_sitter_bash_external_scanner_scan,
      tree_sitter_bash_external_scanner_serialize,
      tree_sitter_bash_external_scanner_deserialize,
    },
  };
  return &language;
}
