#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 8
#define STATE_COUNT 1737
#define SYMBOL_COUNT 208
#define ALIAS_COUNT 18
#define TOKEN_COUNT 98
#define EXTERNAL_TOKEN_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 5

enum {
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH = 1,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH = 2,
  aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH = 3,
  anon_sym_LF = 4,
  anon_sym_LPAREN = 5,
  anon_sym_DOT_DOT_DOT = 6,
  anon_sym_COMMA = 7,
  anon_sym_RPAREN = 8,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH = 9,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH = 10,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH = 11,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH = 12,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH = 13,
  aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH = 14,
  sym_preproc_directive = 15,
  sym_preproc_arg = 16,
  anon_sym_SEMI = 17,
  anon_sym_typedef = 18,
  anon_sym_extern = 19,
  anon_sym_LBRACE = 20,
  anon_sym_RBRACE = 21,
  anon_sym_STAR = 22,
  anon_sym_LBRACK = 23,
  anon_sym_RBRACK = 24,
  anon_sym_EQ = 25,
  anon_sym_static = 26,
  anon_sym_auto = 27,
  anon_sym_register = 28,
  anon_sym_inline = 29,
  anon_sym_const = 30,
  anon_sym_restrict = 31,
  anon_sym_volatile = 32,
  anon_sym__Atomic = 33,
  anon_sym_unsigned = 34,
  anon_sym_long = 35,
  anon_sym_short = 36,
  sym_primitive_type = 37,
  anon_sym_enum = 38,
  anon_sym_struct = 39,
  anon_sym_union = 40,
  anon_sym_COLON = 41,
  anon_sym_if = 42,
  anon_sym_else = 43,
  anon_sym_switch = 44,
  anon_sym_case = 45,
  anon_sym_default = 46,
  anon_sym_while = 47,
  anon_sym_do = 48,
  anon_sym_for = 49,
  anon_sym_return = 50,
  anon_sym_break = 51,
  anon_sym_continue = 52,
  anon_sym_goto = 53,
  anon_sym_QMARK = 54,
  anon_sym_STAR_EQ = 55,
  anon_sym_SLASH_EQ = 56,
  anon_sym_PERCENT_EQ = 57,
  anon_sym_PLUS_EQ = 58,
  anon_sym_DASH_EQ = 59,
  anon_sym_LT_LT_EQ = 60,
  anon_sym_GT_GT_EQ = 61,
  anon_sym_AMP_EQ = 62,
  anon_sym_CARET_EQ = 63,
  anon_sym_PIPE_EQ = 64,
  anon_sym_AMP = 65,
  anon_sym_PIPE_PIPE = 66,
  anon_sym_AMP_AMP = 67,
  anon_sym_BANG = 68,
  anon_sym_PIPE = 69,
  anon_sym_CARET = 70,
  anon_sym_TILDE = 71,
  anon_sym_EQ_EQ = 72,
  anon_sym_BANG_EQ = 73,
  anon_sym_LT = 74,
  anon_sym_GT = 75,
  anon_sym_LT_EQ = 76,
  anon_sym_GT_EQ = 77,
  anon_sym_LT_LT = 78,
  anon_sym_GT_GT = 79,
  anon_sym_PLUS = 80,
  anon_sym_DASH = 81,
  anon_sym_SLASH = 82,
  anon_sym_PERCENT = 83,
  anon_sym_DASH_DASH = 84,
  anon_sym_PLUS_PLUS = 85,
  anon_sym_sizeof = 86,
  anon_sym_DOT = 87,
  anon_sym_DASH_GT = 88,
  sym_number_literal = 89,
  sym_char_literal = 90,
  sym_string_literal = 91,
  sym_system_lib_string = 92,
  sym_true = 93,
  sym_false = 94,
  sym_null = 95,
  sym_identifier = 96,
  sym_comment = 97,
  sym_translation_unit = 98,
  sym_preproc_include = 99,
  sym_preproc_def = 100,
  sym_preproc_function_def = 101,
  sym_preproc_params = 102,
  sym_preproc_call = 103,
  sym_preproc_if = 104,
  sym_preproc_ifdef = 105,
  sym_preproc_else = 106,
  sym_preproc_elif = 107,
  sym_preproc_if_in_compound_statement = 108,
  sym_preproc_ifdef_in_compound_statement = 109,
  sym_preproc_else_in_compound_statement = 110,
  sym_preproc_elif_in_compound_statement = 111,
  sym_preproc_if_in_field_declaration_list = 112,
  sym_preproc_ifdef_in_field_declaration_list = 113,
  sym_preproc_else_in_field_declaration_list = 114,
  sym_preproc_elif_in_field_declaration_list = 115,
  sym_function_definition = 116,
  sym_declaration = 117,
  sym_type_definition = 118,
  sym__declaration_specifiers = 119,
  sym_linkage_specification = 120,
  sym_declaration_list = 121,
  sym__declarator = 122,
  sym__field_declarator = 123,
  sym__type_declarator = 124,
  sym__abstract_declarator = 125,
  sym_pointer_declarator = 126,
  sym_pointer_field_declarator = 127,
  sym_pointer_type_declarator = 128,
  sym_abstract_pointer_declarator = 129,
  sym_function_declarator = 130,
  sym_function_field_declarator = 131,
  sym_function_type_declarator = 132,
  sym_abstract_function_declarator = 133,
  sym_array_declarator = 134,
  sym_array_field_declarator = 135,
  sym_array_type_declarator = 136,
  sym_abstract_array_declarator = 137,
  sym_init_declarator = 138,
  sym_compound_statement = 139,
  sym_storage_class_specifier = 140,
  sym_type_qualifier = 141,
  sym__type_specifier = 142,
  sym_sized_type_specifier = 143,
  sym_enum_specifier = 144,
  sym_enumerator_list = 145,
  sym_struct_specifier = 146,
  sym_union_specifier = 147,
  sym_field_declaration_list = 148,
  sym_field_declaration = 149,
  sym_enumerator = 150,
  sym_parameter_list = 151,
  sym_parameter_declaration = 152,
  sym_labeled_statement = 153,
  sym_expression_statement = 154,
  sym_if_statement = 155,
  sym_switch_statement = 156,
  sym_case_statement = 157,
  sym_while_statement = 158,
  sym_do_statement = 159,
  sym_for_statement = 160,
  sym_return_statement = 161,
  sym_break_statement = 162,
  sym_continue_statement = 163,
  sym_goto_statement = 164,
  sym__expression = 165,
  sym_comma_expression = 166,
  sym_conditional_expression = 167,
  sym_assignment_expression = 168,
  sym_pointer_expression = 169,
  sym_logical_expression = 170,
  sym_bitwise_expression = 171,
  sym_equality_expression = 172,
  sym_relational_expression = 173,
  sym_shift_expression = 174,
  sym_math_expression = 175,
  sym_cast_expression = 176,
  sym_type_descriptor = 177,
  sym_sizeof_expression = 178,
  sym_subscript_expression = 179,
  sym_call_expression = 180,
  sym_argument_list = 181,
  sym_field_expression = 182,
  sym_compound_literal_expression = 183,
  sym_parenthesized_expression = 184,
  sym_initializer_list = 185,
  sym_initializer_pair = 186,
  sym_subscript_designator = 187,
  sym_field_designator = 188,
  sym_concatenated_string = 189,
  sym__empty_declaration = 190,
  sym_macro_type_specifier = 191,
  aux_sym_translation_unit_repeat1 = 192,
  aux_sym_preproc_params_repeat1 = 193,
  aux_sym_preproc_if_in_compound_statement_repeat1 = 194,
  aux_sym_preproc_if_in_field_declaration_list_repeat1 = 195,
  aux_sym_declaration_repeat1 = 196,
  aux_sym_type_definition_repeat1 = 197,
  aux_sym__declaration_specifiers_repeat1 = 198,
  aux_sym_sized_type_specifier_repeat1 = 199,
  aux_sym_enumerator_list_repeat1 = 200,
  aux_sym_field_declaration_list_repeat1 = 201,
  aux_sym_field_declaration_repeat1 = 202,
  aux_sym_parameter_list_repeat1 = 203,
  aux_sym_for_statement_repeat1 = 204,
  aux_sym_initializer_list_repeat1 = 205,
  aux_sym_initializer_pair_repeat1 = 206,
  aux_sym_concatenated_string_repeat1 = 207,
  anon_alias_sym_POUNDdefine = 208,
  anon_alias_sym_POUNDelif = 209,
  anon_alias_sym_POUNDelse = 210,
  anon_alias_sym_POUNDendif = 211,
  anon_alias_sym_POUNDif = 212,
  anon_alias_sym_POUNDifdef = 213,
  anon_alias_sym_POUNDifndef = 214,
  anon_alias_sym_POUNDinclude = 215,
  alias_sym_array_declarator = 216,
  alias_sym_field_identifier = 217,
  alias_sym_function_declarator = 218,
  alias_sym_pointer_declarator = 219,
  alias_sym_preproc_elif = 220,
  alias_sym_preproc_else = 221,
  alias_sym_preproc_if = 222,
  alias_sym_preproc_ifdef = 223,
  alias_sym_statement_identifier = 224,
  alias_sym_type_identifier = 225,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "END",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = "/#[ 	]*include/",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = "/#[ 	]*define/",
  [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = "/[ \\t]+/",
  [anon_sym_LF] = "\n",
  [anon_sym_LPAREN] = "(",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = "/#[ 	]*if/",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = "/#[ 	]*endif/",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = "/#[ 	]*ifdef/",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = "/#[ 	]*ifndef/",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = "/#[ 	]*else/",
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = "/#[ 	]*elif/",
  [sym_preproc_directive] = "preproc_directive",
  [sym_preproc_arg] = "preproc_arg",
  [anon_sym_SEMI] = ";",
  [anon_sym_typedef] = "typedef",
  [anon_sym_extern] = "extern",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_STAR] = "*",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_EQ] = "=",
  [anon_sym_static] = "static",
  [anon_sym_auto] = "auto",
  [anon_sym_register] = "register",
  [anon_sym_inline] = "inline",
  [anon_sym_const] = "const",
  [anon_sym_restrict] = "restrict",
  [anon_sym_volatile] = "volatile",
  [anon_sym__Atomic] = "_Atomic",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_long] = "long",
  [anon_sym_short] = "short",
  [sym_primitive_type] = "primitive_type",
  [anon_sym_enum] = "enum",
  [anon_sym_struct] = "struct",
  [anon_sym_union] = "union",
  [anon_sym_COLON] = ":",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_for] = "for",
  [anon_sym_return] = "return",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym_QMARK] = "?",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_AMP] = "&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_BANG] = "!",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_TILDE] = "~",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym_DOT] = ".",
  [anon_sym_DASH_GT] = "->",
  [sym_number_literal] = "number_literal",
  [sym_char_literal] = "char_literal",
  [sym_string_literal] = "string_literal",
  [sym_system_lib_string] = "system_lib_string",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_identifier] = "identifier",
  [sym_comment] = "comment",
  [sym_translation_unit] = "translation_unit",
  [sym_preproc_include] = "preproc_include",
  [sym_preproc_def] = "preproc_def",
  [sym_preproc_function_def] = "preproc_function_def",
  [sym_preproc_params] = "preproc_params",
  [sym_preproc_call] = "preproc_call",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_ifdef] = "preproc_ifdef",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_elif] = "preproc_elif",
  [sym_preproc_if_in_compound_statement] = "preproc_if_in_compound_statement",
  [sym_preproc_ifdef_in_compound_statement] = "preproc_ifdef_in_compound_statement",
  [sym_preproc_else_in_compound_statement] = "preproc_else_in_compound_statement",
  [sym_preproc_elif_in_compound_statement] = "preproc_elif_in_compound_statement",
  [sym_preproc_if_in_field_declaration_list] = "preproc_if_in_field_declaration_list",
  [sym_preproc_ifdef_in_field_declaration_list] = "preproc_ifdef_in_field_declaration_list",
  [sym_preproc_else_in_field_declaration_list] = "preproc_else_in_field_declaration_list",
  [sym_preproc_elif_in_field_declaration_list] = "preproc_elif_in_field_declaration_list",
  [sym_function_definition] = "function_definition",
  [sym_declaration] = "declaration",
  [sym_type_definition] = "type_definition",
  [sym__declaration_specifiers] = "_declaration_specifiers",
  [sym_linkage_specification] = "linkage_specification",
  [sym_declaration_list] = "declaration_list",
  [sym__declarator] = "_declarator",
  [sym__field_declarator] = "_field_declarator",
  [sym__type_declarator] = "_type_declarator",
  [sym__abstract_declarator] = "_abstract_declarator",
  [sym_pointer_declarator] = "pointer_declarator",
  [sym_pointer_field_declarator] = "pointer_field_declarator",
  [sym_pointer_type_declarator] = "pointer_type_declarator",
  [sym_abstract_pointer_declarator] = "abstract_pointer_declarator",
  [sym_function_declarator] = "function_declarator",
  [sym_function_field_declarator] = "function_field_declarator",
  [sym_function_type_declarator] = "function_type_declarator",
  [sym_abstract_function_declarator] = "abstract_function_declarator",
  [sym_array_declarator] = "array_declarator",
  [sym_array_field_declarator] = "array_field_declarator",
  [sym_array_type_declarator] = "array_type_declarator",
  [sym_abstract_array_declarator] = "abstract_array_declarator",
  [sym_init_declarator] = "init_declarator",
  [sym_compound_statement] = "compound_statement",
  [sym_storage_class_specifier] = "storage_class_specifier",
  [sym_type_qualifier] = "type_qualifier",
  [sym__type_specifier] = "_type_specifier",
  [sym_sized_type_specifier] = "sized_type_specifier",
  [sym_enum_specifier] = "enum_specifier",
  [sym_enumerator_list] = "enumerator_list",
  [sym_struct_specifier] = "struct_specifier",
  [sym_union_specifier] = "union_specifier",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym_field_declaration] = "field_declaration",
  [sym_enumerator] = "enumerator",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_labeled_statement] = "labeled_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_case_statement] = "case_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym_return_statement] = "return_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym__expression] = "_expression",
  [sym_comma_expression] = "comma_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_pointer_expression] = "pointer_expression",
  [sym_logical_expression] = "logical_expression",
  [sym_bitwise_expression] = "bitwise_expression",
  [sym_equality_expression] = "equality_expression",
  [sym_relational_expression] = "relational_expression",
  [sym_shift_expression] = "shift_expression",
  [sym_math_expression] = "math_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_type_descriptor] = "type_descriptor",
  [sym_sizeof_expression] = "sizeof_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_call_expression] = "call_expression",
  [sym_argument_list] = "argument_list",
  [sym_field_expression] = "field_expression",
  [sym_compound_literal_expression] = "compound_literal_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_initializer_list] = "initializer_list",
  [sym_initializer_pair] = "initializer_pair",
  [sym_subscript_designator] = "subscript_designator",
  [sym_field_designator] = "field_designator",
  [sym_concatenated_string] = "concatenated_string",
  [sym__empty_declaration] = "_empty_declaration",
  [sym_macro_type_specifier] = "macro_type_specifier",
  [aux_sym_translation_unit_repeat1] = "translation_unit_repeat1",
  [aux_sym_preproc_params_repeat1] = "preproc_params_repeat1",
  [aux_sym_preproc_if_in_compound_statement_repeat1] = "preproc_if_in_compound_statement_repeat1",
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = "preproc_if_in_field_declaration_list_repeat1",
  [aux_sym_declaration_repeat1] = "declaration_repeat1",
  [aux_sym_type_definition_repeat1] = "type_definition_repeat1",
  [aux_sym__declaration_specifiers_repeat1] = "_declaration_specifiers_repeat1",
  [aux_sym_sized_type_specifier_repeat1] = "sized_type_specifier_repeat1",
  [aux_sym_enumerator_list_repeat1] = "enumerator_list_repeat1",
  [aux_sym_field_declaration_list_repeat1] = "field_declaration_list_repeat1",
  [aux_sym_field_declaration_repeat1] = "field_declaration_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_initializer_list_repeat1] = "initializer_list_repeat1",
  [aux_sym_initializer_pair_repeat1] = "initializer_pair_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [anon_alias_sym_POUNDdefine] = "#define",
  [anon_alias_sym_POUNDelif] = "#elif",
  [anon_alias_sym_POUNDelse] = "#else",
  [anon_alias_sym_POUNDendif] = "#endif",
  [anon_alias_sym_POUNDif] = "#if",
  [anon_alias_sym_POUNDifdef] = "#ifdef",
  [anon_alias_sym_POUNDifndef] = "#ifndef",
  [anon_alias_sym_POUNDinclude] = "#include",
  [alias_sym_array_declarator] = "array_declarator",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_function_declarator] = "function_declarator",
  [alias_sym_pointer_declarator] = "pointer_declarator",
  [alias_sym_preproc_elif] = "preproc_elif",
  [alias_sym_preproc_else] = "preproc_else",
  [alias_sym_preproc_if] = "preproc_if",
  [alias_sym_preproc_ifdef] = "preproc_ifdef",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = {
    .visible = false,
    .named = false,
  },
  [sym_preproc_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_arg] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typedef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_auto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_register] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restrict] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Atomic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_system_lib_string] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_translation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_include] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_function_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_params] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_linkage_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declarator] = {
    .visible = false,
    .named = true,
  },
  [sym__field_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym__type_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym__abstract_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_init_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_storage_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym__type_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym_sized_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_union_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_comma_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_bitwise_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_equality_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_relational_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_shift_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_math_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym_sizeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_field_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_macro_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_translation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_params_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_compound_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_specifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sized_type_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_pair_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [anon_alias_sym_POUNDdefine] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_POUNDelif] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_POUNDelse] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_POUNDendif] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_POUNDif] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_POUNDifdef] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_POUNDifndef] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_POUNDinclude] = {
    .visible = true,
    .named = false,
  },
  [alias_sym_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_preproc_ifdef] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[42][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [2] = {
    [0] = anon_alias_sym_POUNDinclude,
  },
  [3] = {
    [1] = alias_sym_type_identifier,
  },
  [4] = {
    [0] = anon_alias_sym_POUNDdefine,
  },
  [5] = {
    [0] = anon_alias_sym_POUNDif,
    [2] = anon_alias_sym_POUNDendif,
  },
  [6] = {
    [0] = anon_alias_sym_POUNDelse,
  },
  [7] = {
    [0] = anon_alias_sym_POUNDifdef,
    [2] = anon_alias_sym_POUNDendif,
  },
  [8] = {
    [0] = anon_alias_sym_POUNDifndef,
    [2] = anon_alias_sym_POUNDendif,
  },
  [9] = {
    [0] = alias_sym_pointer_declarator,
  },
  [10] = {
    [0] = alias_sym_function_declarator,
  },
  [11] = {
    [0] = alias_sym_array_declarator,
  },
  [12] = {
    [0] = alias_sym_preproc_if,
  },
  [13] = {
    [0] = alias_sym_preproc_ifdef,
  },
  [14] = {
    [0] = anon_alias_sym_POUNDelif,
  },
  [15] = {
    [0] = anon_alias_sym_POUNDif,
    [3] = anon_alias_sym_POUNDendif,
  },
  [16] = {
    [0] = anon_alias_sym_POUNDifdef,
    [3] = anon_alias_sym_POUNDendif,
  },
  [17] = {
    [0] = anon_alias_sym_POUNDifndef,
    [3] = anon_alias_sym_POUNDendif,
  },
  [18] = {
    [0] = alias_sym_field_identifier,
  },
  [19] = {
    [0] = anon_alias_sym_POUNDif,
    [4] = anon_alias_sym_POUNDendif,
  },
  [20] = {
    [0] = anon_alias_sym_POUNDifdef,
    [4] = anon_alias_sym_POUNDendif,
  },
  [21] = {
    [0] = anon_alias_sym_POUNDifndef,
    [4] = anon_alias_sym_POUNDendif,
  },
  [22] = {
    [0] = anon_alias_sym_POUNDif,
    [2] = alias_sym_preproc_else,
    [3] = anon_alias_sym_POUNDendif,
  },
  [23] = {
    [0] = anon_alias_sym_POUNDif,
    [2] = alias_sym_preproc_elif,
    [3] = anon_alias_sym_POUNDendif,
  },
  [24] = {
    [0] = anon_alias_sym_POUNDifdef,
    [2] = alias_sym_preproc_else,
    [3] = anon_alias_sym_POUNDendif,
  },
  [25] = {
    [0] = anon_alias_sym_POUNDifdef,
    [2] = alias_sym_preproc_elif,
    [3] = anon_alias_sym_POUNDendif,
  },
  [26] = {
    [0] = anon_alias_sym_POUNDifndef,
    [2] = alias_sym_preproc_else,
    [3] = anon_alias_sym_POUNDendif,
  },
  [27] = {
    [0] = anon_alias_sym_POUNDifndef,
    [2] = alias_sym_preproc_elif,
    [3] = anon_alias_sym_POUNDendif,
  },
  [28] = {
    [1] = alias_sym_statement_identifier,
  },
  [29] = {
    [0] = alias_sym_statement_identifier,
  },
  [30] = {
    [2] = alias_sym_field_identifier,
  },
  [31] = {
    [1] = alias_sym_field_identifier,
  },
  [32] = {
    [0] = anon_alias_sym_POUNDelif,
    [2] = alias_sym_preproc_else,
  },
  [33] = {
    [0] = anon_alias_sym_POUNDelif,
    [2] = alias_sym_preproc_elif,
  },
  [34] = {
    [0] = anon_alias_sym_POUNDif,
    [3] = alias_sym_preproc_else,
    [4] = anon_alias_sym_POUNDendif,
  },
  [35] = {
    [0] = anon_alias_sym_POUNDif,
    [3] = alias_sym_preproc_elif,
    [4] = anon_alias_sym_POUNDendif,
  },
  [36] = {
    [0] = anon_alias_sym_POUNDifdef,
    [3] = alias_sym_preproc_else,
    [4] = anon_alias_sym_POUNDendif,
  },
  [37] = {
    [0] = anon_alias_sym_POUNDifdef,
    [3] = alias_sym_preproc_elif,
    [4] = anon_alias_sym_POUNDendif,
  },
  [38] = {
    [0] = anon_alias_sym_POUNDifndef,
    [3] = alias_sym_preproc_else,
    [4] = anon_alias_sym_POUNDendif,
  },
  [39] = {
    [0] = anon_alias_sym_POUNDifndef,
    [3] = alias_sym_preproc_elif,
    [4] = anon_alias_sym_POUNDendif,
  },
  [40] = {
    [0] = anon_alias_sym_POUNDelif,
    [3] = alias_sym_preproc_else,
  },
  [41] = {
    [0] = anon_alias_sym_POUNDelif,
    [3] = alias_sym_preproc_elif,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(62);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(81);
      if (lookahead == '<')
        ADVANCE(82);
      if (lookahead == '=')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(92);
      if (lookahead == '?')
        ADVANCE(96);
      if (lookahead == 'F')
        ADVANCE(97);
      if (lookahead == 'N')
        ADVANCE(103);
      if (lookahead == 'T')
        ADVANCE(107);
      if (lookahead == '[')
        ADVANCE(111);
      if (lookahead == ']')
        ADVANCE(112);
      if (lookahead == '^')
        ADVANCE(113);
      if (lookahead == '_')
        ADVANCE(115);
      if (lookahead == 'a')
        ADVANCE(122);
      if (lookahead == 'b')
        ADVANCE(126);
      if (lookahead == 'c')
        ADVANCE(134);
      if (lookahead == 'd')
        ADVANCE(157);
      if (lookahead == 'e')
        ADVANCE(168);
      if (lookahead == 'f')
        ADVANCE(180);
      if (lookahead == 'g')
        ADVANCE(188);
      if (lookahead == 'i')
        ADVANCE(192);
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 'r')
        ADVANCE(203);
      if (lookahead == 's')
        ADVANCE(221);
      if (lookahead == 't')
        ADVANCE(248);
      if (lookahead == 'u')
        ADVANCE(257);
      if (lookahead == 'v')
        ADVANCE(271);
      if (lookahead == 'w')
        ADVANCE(280);
      if (lookahead == '{')
        ADVANCE(285);
      if (lookahead == '|')
        ADVANCE(286);
      if (lookahead == '}')
        ADVANCE(289);
      if (lookahead == '~')
        ADVANCE(290);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('h' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=')
        ADVANCE(3);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 4:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '\\')
        ADVANCE(6);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(4);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_string_literal);
      END_STATE();
    case 6:
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(4);
      END_STATE();
    case 7:
      if (lookahead == 'd')
        ADVANCE(8);
      if (lookahead == 'e')
        ADVANCE(15);
      if (lookahead == 'i')
        ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(7);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(9);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(10);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i')
        ADVANCE(11);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n')
        ADVANCE(12);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(13);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l')
        ADVANCE(16);
      if (lookahead == 'n')
        ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i')
        ADVANCE(17);
      if (lookahead == 's')
        ADVANCE(19);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(18);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd')
        ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i')
        ADVANCE(23);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(24);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(26);
      if (lookahead == 'n')
        ADVANCE(34);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH);
      if (lookahead == 'd')
        ADVANCE(27);
      if (lookahead == 'n')
        ADVANCE(30);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(28);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd')
        ADVANCE(31);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(32);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f')
        ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'c')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l')
        ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'u')
        ADVANCE(37);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd')
        ADVANCE(38);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e')
        ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=')
        ADVANCE(41);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(43);
      if (lookahead == '=')
        ADVANCE(44);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 45:
      if (lookahead == '\\')
        ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '\'')
        ADVANCE(49);
      END_STATE();
    case 46:
      if (lookahead == '\'')
        ADVANCE(47);
      if (lookahead != 0)
        ADVANCE(49);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(sym_char_literal);
      if (lookahead == '\'')
        ADVANCE(48);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(sym_char_literal);
      END_STATE();
    case 49:
      if (lookahead == '\'')
        ADVANCE(48);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=')
        ADVANCE(53);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(55);
      if (lookahead == '=')
        ADVANCE(56);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(59);
      if (lookahead == '=')
        ADVANCE(60);
      if (lookahead == '>')
        ADVANCE(61);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.')
        ADVANCE(63);
      END_STATE();
    case 63:
      if (lookahead == '.')
        ADVANCE(64);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*')
        ADVANCE(66);
      if (lookahead == '/')
        ADVANCE(69);
      if (lookahead == '=')
        ADVANCE(70);
      END_STATE();
    case 66:
      if (lookahead == '*')
        ADVANCE(67);
      if (lookahead != 0)
        ADVANCE(66);
      END_STATE();
    case 67:
      if (lookahead == '*')
        ADVANCE(67);
      if (lookahead == '/')
        ADVANCE(68);
      if (lookahead != 0)
        ADVANCE(66);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(69);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '.')
        ADVANCE(72);
      if (lookahead == 'L')
        ADVANCE(74);
      if (lookahead == 'U')
        ADVANCE(74);
      if (lookahead == 'b')
        ADVANCE(75);
      if (lookahead == 'l')
        ADVANCE(74);
      if (lookahead == 'u')
        ADVANCE(74);
      if (lookahead == 'x')
        ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      END_STATE();
    case 72:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L')
        ADVANCE(74);
      if (lookahead == 'U')
        ADVANCE(74);
      if (lookahead == 'l')
        ADVANCE(74);
      if (lookahead == 'u')
        ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(73);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L')
        ADVANCE(74);
      if (lookahead == 'U')
        ADVANCE(74);
      if (lookahead == 'l')
        ADVANCE(74);
      if (lookahead == 'u')
        ADVANCE(74);
      END_STATE();
    case 75:
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(76);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L')
        ADVANCE(74);
      if (lookahead == 'U')
        ADVANCE(74);
      if (lookahead == 'l')
        ADVANCE(74);
      if (lookahead == 'u')
        ADVANCE(74);
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(76);
      END_STATE();
    case 77:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'f'))
        ADVANCE(78);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L')
        ADVANCE(78);
      if (lookahead == 'U')
        ADVANCE(78);
      if (lookahead == 'l')
        ADVANCE(74);
      if (lookahead == 'u')
        ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'f'))
        ADVANCE(78);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '.')
        ADVANCE(72);
      if (lookahead == 'L')
        ADVANCE(74);
      if (lookahead == 'U')
        ADVANCE(74);
      if (lookahead == 'l')
        ADVANCE(74);
      if (lookahead == 'u')
        ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(83);
      if (lookahead == '=')
        ADVANCE(89);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '\\')
        ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(88);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '\\')
        ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(88);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '\\')
        ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(88);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_system_lib_string);
      END_STATE();
    case 86:
      if (lookahead == '>')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(88);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_system_lib_string);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '\\')
        ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(88);
      END_STATE();
    case 88:
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '\\')
        ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(88);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '\\')
        ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(88);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(91);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(93);
      if (lookahead == '>')
        ADVANCE(94);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=')
        ADVANCE(95);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'A')
        ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'L')
        ADVANCE(99);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'S')
        ADVANCE(100);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E')
        ADVANCE(101);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_false);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'U')
        ADVANCE(104);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'L')
        ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'L')
        ADVANCE(106);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_null);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'R')
        ADVANCE(108);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'U')
        ADVANCE(109);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E')
        ADVANCE(110);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_true);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=')
        ADVANCE(114);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'A')
        ADVANCE(116);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(117);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(118);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'm')
        ADVANCE(119);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(120);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c')
        ADVANCE(121);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym__Atomic);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u')
        ADVANCE(123);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(124);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(125);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_auto);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(127);
      if (lookahead == 'r')
        ADVANCE(130);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(128);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(129);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_primitive_type);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(131);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(132);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'k')
        ADVANCE(133);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_break);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(135);
      if (lookahead == 'h')
        ADVANCE(138);
      if (lookahead == 'o')
        ADVANCE(148);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(136);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(137);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_case);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(139);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(140);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '1')
        ADVANCE(141);
      if (lookahead == '3')
        ADVANCE(144);
      if (lookahead == '6')
        ADVANCE(145);
      if (lookahead == '8')
        ADVANCE(142);
      if (lookahead == 'p')
        ADVANCE(146);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '6')
        ADVANCE(142);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_')
        ADVANCE(143);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(129);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '2')
        ADVANCE(142);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '4')
        ADVANCE(142);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(147);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(142);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(149);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(150);
      if (lookahead == 't')
        ADVANCE(152);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(151);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_const);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(153);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(154);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u')
        ADVANCE(155);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(156);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_continue);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(158);
      if (lookahead == 'o')
        ADVANCE(164);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f')
        ADVANCE(159);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(160);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u')
        ADVANCE(161);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(162);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(163);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_default);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u')
        ADVANCE(165);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'b')
        ADVANCE(166);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(167);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(129);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(169);
      if (lookahead == 'n')
        ADVANCE(172);
      if (lookahead == 'x')
        ADVANCE(175);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(170);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(171);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_else);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u')
        ADVANCE(173);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'm')
        ADVANCE(174);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_enum);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(176);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(177);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(178);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(179);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_extern);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(181);
      if (lookahead == 'l')
        ADVANCE(184);
      if (lookahead == 'o')
        ADVANCE(186);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(182);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(183);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(101);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(185);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(143);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(187);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_for);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(189);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(190);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(191);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_goto);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f')
        ADVANCE(193);
      if (lookahead == 'n')
        ADVANCE(194);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_if);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(195);
      if (lookahead == 't')
        ADVANCE(140);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(196);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(198);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_inline);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(200);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(201);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'g')
        ADVANCE(202);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_long);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(204);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'g')
        ADVANCE(205);
      if (lookahead == 's')
        ADVANCE(211);
      if (lookahead == 't')
        ADVANCE(217);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(206);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(207);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(208);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(209);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(210);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_register);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(212);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(213);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(214);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c')
        ADVANCE(215);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(216);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_restrict);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u')
        ADVANCE(218);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(219);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(220);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_return);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(222);
      if (lookahead == 'i')
        ADVANCE(226);
      if (lookahead == 's')
        ADVANCE(231);
      if (lookahead == 't')
        ADVANCE(234);
      if (lookahead == 'w')
        ADVANCE(243);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(223);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(225);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_short);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'z')
        ADVANCE(227);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y'))
        ADVANCE(102);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(228);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_')
        ADVANCE(143);
      if (lookahead == 'o')
        ADVANCE(229);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f')
        ADVANCE(230);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_sizeof);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(232);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'z')
        ADVANCE(233);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y'))
        ADVANCE(102);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(142);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(235);
      if (lookahead == 'r')
        ADVANCE(239);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(236);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(237);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c')
        ADVANCE(238);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_static);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u')
        ADVANCE(240);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c')
        ADVANCE(241);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(242);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_struct);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(244);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(245);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c')
        ADVANCE(246);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(247);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_switch);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(249);
      if (lookahead == 'y')
        ADVANCE(251);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u')
        ADVANCE(250);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(110);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p')
        ADVANCE(252);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(253);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd')
        ADVANCE(254);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(255);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f')
        ADVANCE(256);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_typedef);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(258);
      if (lookahead == 'n')
        ADVANCE(261);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(259);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(260);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '1')
        ADVANCE(141);
      if (lookahead == '3')
        ADVANCE(144);
      if (lookahead == '6')
        ADVANCE(145);
      if (lookahead == '8')
        ADVANCE(142);
      if (lookahead == 'p')
        ADVANCE(146);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(262);
      if (lookahead == 's')
        ADVANCE(265);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(263);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(264);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_union);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(266);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'g')
        ADVANCE(267);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(268);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(269);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd')
        ADVANCE(270);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_unsigned);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(272);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(273);
      if (lookahead == 'l')
        ADVANCE(274);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd')
        ADVANCE(129);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(275);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(276);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(277);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(278);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_volatile);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(281);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(282);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(283);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(284);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_while);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=')
        ADVANCE(287);
      if (lookahead == '|')
        ADVANCE(288);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 291:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(292);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == ';')
        ADVANCE(81);
      if (lookahead == '_')
        ADVANCE(115);
      if (lookahead == 'a')
        ADVANCE(122);
      if (lookahead == 'b')
        ADVANCE(294);
      if (lookahead == 'c')
        ADVANCE(295);
      if (lookahead == 'd')
        ADVANCE(298);
      if (lookahead == 'e')
        ADVANCE(300);
      if (lookahead == 'f')
        ADVANCE(301);
      if (lookahead == 'i')
        ADVANCE(302);
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 'r')
        ADVANCE(303);
      if (lookahead == 's')
        ADVANCE(305);
      if (lookahead == 't')
        ADVANCE(306);
      if (lookahead == 'u')
        ADVANCE(257);
      if (lookahead == 'v')
        ADVANCE(271);
      if (lookahead == '}')
        ADVANCE(289);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(291);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 292:
      if (lookahead == 'd')
        ADVANCE(8);
      if (lookahead == 'i')
        ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(292);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 293:
      if (lookahead == '*')
        ADVANCE(66);
      if (lookahead == '/')
        ADVANCE(69);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(127);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(138);
      if (lookahead == 'o')
        ADVANCE(296);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(297);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(150);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(299);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u')
        ADVANCE(165);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(172);
      if (lookahead == 'x')
        ADVANCE(175);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(184);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(194);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(304);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'g')
        ADVANCE(205);
      if (lookahead == 's')
        ADVANCE(211);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(222);
      if (lookahead == 'i')
        ADVANCE(232);
      if (lookahead == 's')
        ADVANCE(231);
      if (lookahead == 't')
        ADVANCE(234);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'y')
        ADVANCE(251);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 307:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == '<')
        ADVANCE(88);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(307);
      END_STATE();
    case 308:
      if (lookahead == '!')
        ADVANCE(309);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(62);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(81);
      if (lookahead == '<')
        ADVANCE(310);
      if (lookahead == '=')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(92);
      if (lookahead == '?')
        ADVANCE(96);
      if (lookahead == '[')
        ADVANCE(111);
      if (lookahead == ']')
        ADVANCE(112);
      if (lookahead == '^')
        ADVANCE(113);
      if (lookahead == '{')
        ADVANCE(285);
      if (lookahead == '|')
        ADVANCE(286);
      if (lookahead == '}')
        ADVANCE(289);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(308);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 309:
      if (lookahead == '=')
        ADVANCE(3);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(311);
      if (lookahead == '=')
        ADVANCE(313);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=')
        ADVANCE(312);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 314:
      if (lookahead == '\n')
        SKIP(314);
      if (lookahead == '/')
        ADVANCE(315);
      if (lookahead == '\\')
        ADVANCE(320);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(322);
      if (lookahead != 0)
        ADVANCE(321);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*')
        ADVANCE(316);
      if (lookahead == '/')
        ADVANCE(319);
      if (lookahead == '\\')
        ADVANCE(320);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(321);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n')
        ADVANCE(66);
      if (lookahead == '*')
        ADVANCE(317);
      if (lookahead == '\\')
        ADVANCE(318);
      if (lookahead != 0)
        ADVANCE(316);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n')
        ADVANCE(66);
      if (lookahead == '*')
        ADVANCE(317);
      if (lookahead == '/')
        ADVANCE(68);
      if (lookahead == '\\')
        ADVANCE(318);
      if (lookahead != 0)
        ADVANCE(316);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n')
        ADVANCE(316);
      if (lookahead == '*')
        ADVANCE(317);
      if (lookahead == '\\')
        ADVANCE(318);
      if (lookahead != 0)
        ADVANCE(316);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\')
        ADVANCE(319);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(319);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n')
        ADVANCE(321);
      if (lookahead == '\\')
        ADVANCE(320);
      if (lookahead != 0)
        ADVANCE(321);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\\')
        ADVANCE(320);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(321);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/')
        ADVANCE(315);
      if (lookahead == '\\')
        ADVANCE(320);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(322);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(321);
      END_STATE();
    case 323:
      if (lookahead == '\n')
        ADVANCE(324);
      if (lookahead == '\r')
        SKIP(323);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(325);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(325);
      END_STATE();
    case 326:
      if (lookahead == '#')
        ADVANCE(327);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == '_')
        ADVANCE(115);
      if (lookahead == 'b')
        ADVANCE(294);
      if (lookahead == 'c')
        ADVANCE(295);
      if (lookahead == 'd')
        ADVANCE(298);
      if (lookahead == 'e')
        ADVANCE(333);
      if (lookahead == 'f')
        ADVANCE(301);
      if (lookahead == 'i')
        ADVANCE(334);
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 'r')
        ADVANCE(336);
      if (lookahead == 's')
        ADVANCE(338);
      if (lookahead == 'u')
        ADVANCE(257);
      if (lookahead == 'v')
        ADVANCE(271);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(326);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 327:
      if (lookahead == 'e')
        ADVANCE(328);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(327);
      END_STATE();
    case 328:
      if (lookahead == 'n')
        ADVANCE(329);
      END_STATE();
    case 329:
      if (lookahead == 'd')
        ADVANCE(330);
      END_STATE();
    case 330:
      if (lookahead == 'i')
        ADVANCE(331);
      END_STATE();
    case 331:
      if (lookahead == 'f')
        ADVANCE(332);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(172);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(335);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(140);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(337);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(211);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(222);
      if (lookahead == 'i')
        ADVANCE(232);
      if (lookahead == 's')
        ADVANCE(231);
      if (lookahead == 't')
        ADVANCE(339);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(239);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 340:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(341);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == '_')
        ADVANCE(115);
      if (lookahead == 'a')
        ADVANCE(122);
      if (lookahead == 'b')
        ADVANCE(294);
      if (lookahead == 'c')
        ADVANCE(295);
      if (lookahead == 'd')
        ADVANCE(298);
      if (lookahead == 'e')
        ADVANCE(300);
      if (lookahead == 'f')
        ADVANCE(301);
      if (lookahead == 'i')
        ADVANCE(302);
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 'r')
        ADVANCE(303);
      if (lookahead == 's')
        ADVANCE(305);
      if (lookahead == 'u')
        ADVANCE(257);
      if (lookahead == 'v')
        ADVANCE(271);
      if (lookahead == '{')
        ADVANCE(285);
      if (lookahead == '}')
        ADVANCE(289);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(340);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 341:
      if (lookahead == 'i')
        ADVANCE(342);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(341);
      END_STATE();
    case 342:
      if (lookahead == 'f')
        ADVANCE(343);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH);
      if (lookahead == 'd')
        ADVANCE(344);
      if (lookahead == 'n')
        ADVANCE(347);
      END_STATE();
    case 344:
      if (lookahead == 'e')
        ADVANCE(345);
      END_STATE();
    case 345:
      if (lookahead == 'f')
        ADVANCE(346);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH);
      END_STATE();
    case 347:
      if (lookahead == 'd')
        ADVANCE(348);
      END_STATE();
    case 348:
      if (lookahead == 'e')
        ADVANCE(349);
      END_STATE();
    case 349:
      if (lookahead == 'f')
        ADVANCE(350);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH);
      END_STATE();
    case 351:
      if (lookahead == '!')
        ADVANCE(309);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(352);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(81);
      if (lookahead == '<')
        ADVANCE(310);
      if (lookahead == '=')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(92);
      if (lookahead == '?')
        ADVANCE(96);
      if (lookahead == '[')
        ADVANCE(111);
      if (lookahead == ']')
        ADVANCE(112);
      if (lookahead == '^')
        ADVANCE(113);
      if (lookahead == '_')
        ADVANCE(115);
      if (lookahead == 'a')
        ADVANCE(122);
      if (lookahead == 'c')
        ADVANCE(353);
      if (lookahead == 'e')
        ADVANCE(354);
      if (lookahead == 'i')
        ADVANCE(355);
      if (lookahead == 'r')
        ADVANCE(303);
      if (lookahead == 's')
        ADVANCE(357);
      if (lookahead == 'v')
        ADVANCE(359);
      if (lookahead == '{')
        ADVANCE(285);
      if (lookahead == '|')
        ADVANCE(286);
      if (lookahead == '}')
        ADVANCE(289);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(351);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(296);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'x')
        ADVANCE(175);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(356);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(195);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(358);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(235);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(360);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(274);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 361:
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(362);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(81);
      if (lookahead == '[')
        ADVANCE(111);
      if (lookahead == '_')
        ADVANCE(115);
      if (lookahead == 'a')
        ADVANCE(122);
      if (lookahead == 'b')
        ADVANCE(294);
      if (lookahead == 'c')
        ADVANCE(295);
      if (lookahead == 'd')
        ADVANCE(298);
      if (lookahead == 'e')
        ADVANCE(354);
      if (lookahead == 'f')
        ADVANCE(301);
      if (lookahead == 'i')
        ADVANCE(302);
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 'r')
        ADVANCE(303);
      if (lookahead == 's')
        ADVANCE(363);
      if (lookahead == 'u')
        ADVANCE(364);
      if (lookahead == 'v')
        ADVANCE(271);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(361);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(222);
      if (lookahead == 'i')
        ADVANCE(232);
      if (lookahead == 's')
        ADVANCE(231);
      if (lookahead == 't')
        ADVANCE(358);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(258);
      if (lookahead == 'n')
        ADVANCE(365);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(265);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 366:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == '_')
        ADVANCE(115);
      if (lookahead == 'a')
        ADVANCE(122);
      if (lookahead == 'b')
        ADVANCE(294);
      if (lookahead == 'c')
        ADVANCE(295);
      if (lookahead == 'd')
        ADVANCE(298);
      if (lookahead == 'e')
        ADVANCE(300);
      if (lookahead == 'f')
        ADVANCE(301);
      if (lookahead == 'i')
        ADVANCE(302);
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 'r')
        ADVANCE(303);
      if (lookahead == 's')
        ADVANCE(305);
      if (lookahead == 't')
        ADVANCE(306);
      if (lookahead == 'u')
        ADVANCE(257);
      if (lookahead == 'v')
        ADVANCE(271);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(366);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 367:
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(362);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == '[')
        ADVANCE(111);
      if (lookahead == 'b')
        ADVANCE(294);
      if (lookahead == 'c')
        ADVANCE(368);
      if (lookahead == 'd')
        ADVANCE(298);
      if (lookahead == 'f')
        ADVANCE(301);
      if (lookahead == 'i')
        ADVANCE(334);
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 's')
        ADVANCE(369);
      if (lookahead == 'u')
        ADVANCE(364);
      if (lookahead == 'v')
        ADVANCE(370);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(367);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(138);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(222);
      if (lookahead == 'i')
        ADVANCE(232);
      if (lookahead == 's')
        ADVANCE(231);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(371);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(273);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 372:
      if (lookahead == '\n')
        ADVANCE(324);
      if (lookahead == '/')
        ADVANCE(315);
      if (lookahead == '\\')
        ADVANCE(320);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(373);
      if (lookahead != 0)
        ADVANCE(321);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/')
        ADVANCE(315);
      if (lookahead == '\\')
        ADVANCE(320);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(373);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(321);
      END_STATE();
    case 374:
      if (lookahead == '#')
        ADVANCE(375);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == '_')
        ADVANCE(115);
      if (lookahead == 'a')
        ADVANCE(122);
      if (lookahead == 'b')
        ADVANCE(294);
      if (lookahead == 'c')
        ADVANCE(295);
      if (lookahead == 'd')
        ADVANCE(298);
      if (lookahead == 'e')
        ADVANCE(300);
      if (lookahead == 'f')
        ADVANCE(301);
      if (lookahead == 'i')
        ADVANCE(302);
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 'r')
        ADVANCE(303);
      if (lookahead == 's')
        ADVANCE(305);
      if (lookahead == 't')
        ADVANCE(306);
      if (lookahead == 'u')
        ADVANCE(257);
      if (lookahead == 'v')
        ADVANCE(271);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(374);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 375:
      if (lookahead == 'd')
        ADVANCE(8);
      if (lookahead == 'e')
        ADVANCE(376);
      if (lookahead == 'i')
        ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(375);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n')
        ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(14);
      END_STATE();
    case 377:
      if (lookahead == '\n')
        ADVANCE(324);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(377);
      END_STATE();
    case 378:
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(362);
      if (lookahead == '.')
        ADVANCE(379);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == '[')
        ADVANCE(111);
      if (lookahead == '_')
        ADVANCE(115);
      if (lookahead == 'a')
        ADVANCE(122);
      if (lookahead == 'b')
        ADVANCE(294);
      if (lookahead == 'c')
        ADVANCE(295);
      if (lookahead == 'd')
        ADVANCE(298);
      if (lookahead == 'e')
        ADVANCE(300);
      if (lookahead == 'f')
        ADVANCE(301);
      if (lookahead == 'i')
        ADVANCE(302);
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 'r')
        ADVANCE(303);
      if (lookahead == 's')
        ADVANCE(305);
      if (lookahead == 'u')
        ADVANCE(257);
      if (lookahead == 'v')
        ADVANCE(271);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(378);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 379:
      if (lookahead == '.')
        ADVANCE(63);
      END_STATE();
    case 380:
      if (lookahead == '!')
        ADVANCE(381);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(292);
      if (lookahead == '&')
        ADVANCE(382);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(362);
      if (lookahead == '+')
        ADVANCE(383);
      if (lookahead == '-')
        ADVANCE(384);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ';')
        ADVANCE(81);
      if (lookahead == 'F')
        ADVANCE(97);
      if (lookahead == 'N')
        ADVANCE(103);
      if (lookahead == 'T')
        ADVANCE(107);
      if (lookahead == '_')
        ADVANCE(115);
      if (lookahead == 'a')
        ADVANCE(122);
      if (lookahead == 'b')
        ADVANCE(126);
      if (lookahead == 'c')
        ADVANCE(134);
      if (lookahead == 'd')
        ADVANCE(157);
      if (lookahead == 'e')
        ADVANCE(300);
      if (lookahead == 'f')
        ADVANCE(180);
      if (lookahead == 'g')
        ADVANCE(188);
      if (lookahead == 'i')
        ADVANCE(192);
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 'r')
        ADVANCE(203);
      if (lookahead == 's')
        ADVANCE(221);
      if (lookahead == 't')
        ADVANCE(248);
      if (lookahead == 'u')
        ADVANCE(257);
      if (lookahead == 'v')
        ADVANCE(271);
      if (lookahead == 'w')
        ADVANCE(280);
      if (lookahead == '{')
        ADVANCE(285);
      if (lookahead == '}')
        ADVANCE(289);
      if (lookahead == '~')
        ADVANCE(290);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(380);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('h' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(55);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(59);
      END_STATE();
    case 385:
      if (lookahead == '!')
        ADVANCE(381);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(382);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(362);
      if (lookahead == '+')
        ADVANCE(383);
      if (lookahead == '-')
        ADVANCE(384);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ';')
        ADVANCE(81);
      if (lookahead == 'F')
        ADVANCE(97);
      if (lookahead == 'N')
        ADVANCE(103);
      if (lookahead == 'T')
        ADVANCE(107);
      if (lookahead == ']')
        ADVANCE(112);
      if (lookahead == '_')
        ADVANCE(115);
      if (lookahead == 'a')
        ADVANCE(122);
      if (lookahead == 'b')
        ADVANCE(294);
      if (lookahead == 'c')
        ADVANCE(295);
      if (lookahead == 'd')
        ADVANCE(298);
      if (lookahead == 'e')
        ADVANCE(300);
      if (lookahead == 'f')
        ADVANCE(386);
      if (lookahead == 'i')
        ADVANCE(302);
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 'r')
        ADVANCE(303);
      if (lookahead == 's')
        ADVANCE(387);
      if (lookahead == 't')
        ADVANCE(388);
      if (lookahead == 'u')
        ADVANCE(257);
      if (lookahead == 'v')
        ADVANCE(271);
      if (lookahead == '~')
        ADVANCE(290);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(385);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(181);
      if (lookahead == 'l')
        ADVANCE(184);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(222);
      if (lookahead == 'i')
        ADVANCE(226);
      if (lookahead == 's')
        ADVANCE(231);
      if (lookahead == 't')
        ADVANCE(234);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(249);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 389:
      if (lookahead == '!')
        ADVANCE(381);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(382);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(362);
      if (lookahead == '+')
        ADVANCE(383);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(384);
      if (lookahead == '.')
        ADVANCE(352);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ';')
        ADVANCE(81);
      if (lookahead == 'F')
        ADVANCE(97);
      if (lookahead == 'N')
        ADVANCE(103);
      if (lookahead == 'T')
        ADVANCE(107);
      if (lookahead == '[')
        ADVANCE(111);
      if (lookahead == ']')
        ADVANCE(112);
      if (lookahead == 'f')
        ADVANCE(390);
      if (lookahead == 's')
        ADVANCE(391);
      if (lookahead == 't')
        ADVANCE(388);
      if (lookahead == '{')
        ADVANCE(285);
      if (lookahead == '}')
        ADVANCE(289);
      if (lookahead == '~')
        ADVANCE(290);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(389);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(392);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'z')
        ADVANCE(393);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y'))
        ADVANCE(102);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(394);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(229);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 395:
      if (lookahead == '#')
        ADVANCE(396);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == '_')
        ADVANCE(115);
      if (lookahead == 'a')
        ADVANCE(122);
      if (lookahead == 'b')
        ADVANCE(294);
      if (lookahead == 'c')
        ADVANCE(295);
      if (lookahead == 'd')
        ADVANCE(298);
      if (lookahead == 'e')
        ADVANCE(300);
      if (lookahead == 'f')
        ADVANCE(301);
      if (lookahead == 'i')
        ADVANCE(302);
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 'r')
        ADVANCE(303);
      if (lookahead == 's')
        ADVANCE(305);
      if (lookahead == 'u')
        ADVANCE(257);
      if (lookahead == 'v')
        ADVANCE(271);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(395);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 396:
      if (lookahead == 'e')
        ADVANCE(397);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(396);
      END_STATE();
    case 397:
      if (lookahead == 'l')
        ADVANCE(398);
      if (lookahead == 'n')
        ADVANCE(329);
      END_STATE();
    case 398:
      if (lookahead == 'i')
        ADVANCE(399);
      if (lookahead == 's')
        ADVANCE(401);
      END_STATE();
    case 399:
      if (lookahead == 'f')
        ADVANCE(400);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH);
      END_STATE();
    case 401:
      if (lookahead == 'e')
        ADVANCE(402);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH);
      END_STATE();
    case 403:
      if (lookahead == '#')
        ADVANCE(404);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == '_')
        ADVANCE(115);
      if (lookahead == 'a')
        ADVANCE(122);
      if (lookahead == 'b')
        ADVANCE(294);
      if (lookahead == 'c')
        ADVANCE(295);
      if (lookahead == 'd')
        ADVANCE(298);
      if (lookahead == 'e')
        ADVANCE(300);
      if (lookahead == 'f')
        ADVANCE(301);
      if (lookahead == 'i')
        ADVANCE(302);
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 'r')
        ADVANCE(303);
      if (lookahead == 's')
        ADVANCE(305);
      if (lookahead == 'u')
        ADVANCE(257);
      if (lookahead == 'v')
        ADVANCE(271);
      if (lookahead == '}')
        ADVANCE(289);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(403);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 404:
      if (lookahead == 'e')
        ADVANCE(397);
      if (lookahead == 'i')
        ADVANCE(342);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(404);
      END_STATE();
    case 405:
      if (lookahead == '!')
        ADVANCE(381);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(382);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(362);
      if (lookahead == '+')
        ADVANCE(383);
      if (lookahead == '-')
        ADVANCE(384);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == 'F')
        ADVANCE(97);
      if (lookahead == 'N')
        ADVANCE(103);
      if (lookahead == 'T')
        ADVANCE(107);
      if (lookahead == '_')
        ADVANCE(115);
      if (lookahead == 'b')
        ADVANCE(294);
      if (lookahead == 'c')
        ADVANCE(295);
      if (lookahead == 'd')
        ADVANCE(298);
      if (lookahead == 'e')
        ADVANCE(333);
      if (lookahead == 'f')
        ADVANCE(386);
      if (lookahead == 'i')
        ADVANCE(334);
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 'r')
        ADVANCE(336);
      if (lookahead == 's')
        ADVANCE(406);
      if (lookahead == 't')
        ADVANCE(388);
      if (lookahead == 'u')
        ADVANCE(257);
      if (lookahead == 'v')
        ADVANCE(271);
      if (lookahead == '~')
        ADVANCE(290);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(405);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(222);
      if (lookahead == 'i')
        ADVANCE(226);
      if (lookahead == 's')
        ADVANCE(231);
      if (lookahead == 't')
        ADVANCE(339);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 407:
      if (lookahead == '!')
        ADVANCE(381);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(382);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(362);
      if (lookahead == '+')
        ADVANCE(383);
      if (lookahead == '-')
        ADVANCE(384);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ';')
        ADVANCE(81);
      if (lookahead == 'F')
        ADVANCE(97);
      if (lookahead == 'N')
        ADVANCE(103);
      if (lookahead == 'T')
        ADVANCE(107);
      if (lookahead == 'b')
        ADVANCE(408);
      if (lookahead == 'c')
        ADVANCE(409);
      if (lookahead == 'd')
        ADVANCE(412);
      if (lookahead == 'f')
        ADVANCE(414);
      if (lookahead == 'g')
        ADVANCE(188);
      if (lookahead == 'i')
        ADVANCE(415);
      if (lookahead == 'r')
        ADVANCE(416);
      if (lookahead == 's')
        ADVANCE(418);
      if (lookahead == 't')
        ADVANCE(388);
      if (lookahead == 'w')
        ADVANCE(280);
      if (lookahead == '{')
        ADVANCE(285);
      if (lookahead == '~')
        ADVANCE(290);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(407);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(130);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(135);
      if (lookahead == 'o')
        ADVANCE(410);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(411);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(152);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(158);
      if (lookahead == 'o')
        ADVANCE(413);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(anon_sym_do);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(181);
      if (lookahead == 'o')
        ADVANCE(186);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f')
        ADVANCE(193);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(417);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(217);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(392);
      if (lookahead == 'w')
        ADVANCE(243);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 419:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(352);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == '<')
        ADVANCE(310);
      if (lookahead == '=')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(92);
      if (lookahead == '?')
        ADVANCE(96);
      if (lookahead == 'F')
        ADVANCE(97);
      if (lookahead == 'N')
        ADVANCE(103);
      if (lookahead == 'T')
        ADVANCE(107);
      if (lookahead == '[')
        ADVANCE(111);
      if (lookahead == ']')
        ADVANCE(112);
      if (lookahead == '^')
        ADVANCE(113);
      if (lookahead == '_')
        ADVANCE(115);
      if (lookahead == 'a')
        ADVANCE(122);
      if (lookahead == 'c')
        ADVANCE(353);
      if (lookahead == 'e')
        ADVANCE(354);
      if (lookahead == 'f')
        ADVANCE(390);
      if (lookahead == 'i')
        ADVANCE(355);
      if (lookahead == 'r')
        ADVANCE(303);
      if (lookahead == 's')
        ADVANCE(420);
      if (lookahead == 't')
        ADVANCE(388);
      if (lookahead == 'v')
        ADVANCE(359);
      if (lookahead == '|')
        ADVANCE(286);
      if (lookahead == '~')
        ADVANCE(290);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(419);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i')
        ADVANCE(392);
      if (lookahead == 't')
        ADVANCE(358);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 421:
      if (lookahead == '!')
        ADVANCE(381);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(382);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(362);
      if (lookahead == '+')
        ADVANCE(383);
      if (lookahead == '-')
        ADVANCE(384);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == 'F')
        ADVANCE(97);
      if (lookahead == 'N')
        ADVANCE(103);
      if (lookahead == 'T')
        ADVANCE(107);
      if (lookahead == ']')
        ADVANCE(112);
      if (lookahead == '_')
        ADVANCE(115);
      if (lookahead == 'a')
        ADVANCE(122);
      if (lookahead == 'c')
        ADVANCE(353);
      if (lookahead == 'e')
        ADVANCE(354);
      if (lookahead == 'f')
        ADVANCE(390);
      if (lookahead == 'i')
        ADVANCE(355);
      if (lookahead == 'r')
        ADVANCE(303);
      if (lookahead == 's')
        ADVANCE(420);
      if (lookahead == 't')
        ADVANCE(388);
      if (lookahead == 'v')
        ADVANCE(359);
      if (lookahead == '{')
        ADVANCE(285);
      if (lookahead == '~')
        ADVANCE(290);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(421);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 422:
      if (lookahead == '!')
        ADVANCE(381);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(382);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(362);
      if (lookahead == '+')
        ADVANCE(383);
      if (lookahead == '-')
        ADVANCE(384);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == 'F')
        ADVANCE(97);
      if (lookahead == 'N')
        ADVANCE(103);
      if (lookahead == 'T')
        ADVANCE(107);
      if (lookahead == ']')
        ADVANCE(112);
      if (lookahead == '_')
        ADVANCE(115);
      if (lookahead == 'a')
        ADVANCE(122);
      if (lookahead == 'b')
        ADVANCE(294);
      if (lookahead == 'c')
        ADVANCE(295);
      if (lookahead == 'd')
        ADVANCE(298);
      if (lookahead == 'e')
        ADVANCE(354);
      if (lookahead == 'f')
        ADVANCE(386);
      if (lookahead == 'i')
        ADVANCE(302);
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 'r')
        ADVANCE(303);
      if (lookahead == 's')
        ADVANCE(423);
      if (lookahead == 't')
        ADVANCE(388);
      if (lookahead == 'u')
        ADVANCE(364);
      if (lookahead == 'v')
        ADVANCE(271);
      if (lookahead == '~')
        ADVANCE(290);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(422);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h')
        ADVANCE(222);
      if (lookahead == 'i')
        ADVANCE(226);
      if (lookahead == 's')
        ADVANCE(231);
      if (lookahead == 't')
        ADVANCE(358);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 424:
      if (lookahead == '!')
        ADVANCE(381);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(382);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(362);
      if (lookahead == '+')
        ADVANCE(383);
      if (lookahead == '-')
        ADVANCE(384);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ';')
        ADVANCE(81);
      if (lookahead == 'F')
        ADVANCE(97);
      if (lookahead == 'N')
        ADVANCE(103);
      if (lookahead == 'T')
        ADVANCE(107);
      if (lookahead == '_')
        ADVANCE(115);
      if (lookahead == 'a')
        ADVANCE(122);
      if (lookahead == 'b')
        ADVANCE(126);
      if (lookahead == 'c')
        ADVANCE(134);
      if (lookahead == 'd')
        ADVANCE(157);
      if (lookahead == 'e')
        ADVANCE(300);
      if (lookahead == 'f')
        ADVANCE(180);
      if (lookahead == 'g')
        ADVANCE(188);
      if (lookahead == 'i')
        ADVANCE(192);
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 'r')
        ADVANCE(203);
      if (lookahead == 's')
        ADVANCE(221);
      if (lookahead == 't')
        ADVANCE(248);
      if (lookahead == 'u')
        ADVANCE(257);
      if (lookahead == 'v')
        ADVANCE(271);
      if (lookahead == 'w')
        ADVANCE(280);
      if (lookahead == '{')
        ADVANCE(285);
      if (lookahead == '~')
        ADVANCE(290);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(424);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('h' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 425:
      if (lookahead == '!')
        ADVANCE(381);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(375);
      if (lookahead == '&')
        ADVANCE(382);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(362);
      if (lookahead == '+')
        ADVANCE(383);
      if (lookahead == '-')
        ADVANCE(384);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ';')
        ADVANCE(81);
      if (lookahead == 'F')
        ADVANCE(97);
      if (lookahead == 'N')
        ADVANCE(103);
      if (lookahead == 'T')
        ADVANCE(107);
      if (lookahead == '_')
        ADVANCE(115);
      if (lookahead == 'a')
        ADVANCE(122);
      if (lookahead == 'b')
        ADVANCE(126);
      if (lookahead == 'c')
        ADVANCE(134);
      if (lookahead == 'd')
        ADVANCE(157);
      if (lookahead == 'e')
        ADVANCE(300);
      if (lookahead == 'f')
        ADVANCE(180);
      if (lookahead == 'g')
        ADVANCE(188);
      if (lookahead == 'i')
        ADVANCE(192);
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 'r')
        ADVANCE(203);
      if (lookahead == 's')
        ADVANCE(221);
      if (lookahead == 't')
        ADVANCE(248);
      if (lookahead == 'u')
        ADVANCE(257);
      if (lookahead == 'v')
        ADVANCE(271);
      if (lookahead == 'w')
        ADVANCE(280);
      if (lookahead == '{')
        ADVANCE(285);
      if (lookahead == '~')
        ADVANCE(290);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(425);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('h' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 426:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(40);
      if (lookahead == '&')
        ADVANCE(42);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == ')')
        ADVANCE(51);
      if (lookahead == '*')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(54);
      if (lookahead == ',')
        ADVANCE(57);
      if (lookahead == '-')
        ADVANCE(58);
      if (lookahead == '.')
        ADVANCE(352);
      if (lookahead == '/')
        ADVANCE(65);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ':')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(81);
      if (lookahead == '<')
        ADVANCE(310);
      if (lookahead == '=')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(92);
      if (lookahead == '?')
        ADVANCE(96);
      if (lookahead == 'F')
        ADVANCE(97);
      if (lookahead == 'N')
        ADVANCE(103);
      if (lookahead == 'T')
        ADVANCE(107);
      if (lookahead == '[')
        ADVANCE(111);
      if (lookahead == ']')
        ADVANCE(112);
      if (lookahead == '^')
        ADVANCE(113);
      if (lookahead == 'f')
        ADVANCE(390);
      if (lookahead == 's')
        ADVANCE(391);
      if (lookahead == 't')
        ADVANCE(388);
      if (lookahead == '{')
        ADVANCE(285);
      if (lookahead == '|')
        ADVANCE(286);
      if (lookahead == '}')
        ADVANCE(289);
      if (lookahead == '~')
        ADVANCE(290);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(426);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 427:
      if (lookahead == '!')
        ADVANCE(381);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(292);
      if (lookahead == '&')
        ADVANCE(382);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(362);
      if (lookahead == '+')
        ADVANCE(383);
      if (lookahead == '-')
        ADVANCE(384);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ';')
        ADVANCE(81);
      if (lookahead == 'F')
        ADVANCE(97);
      if (lookahead == 'N')
        ADVANCE(103);
      if (lookahead == 'T')
        ADVANCE(107);
      if (lookahead == '_')
        ADVANCE(115);
      if (lookahead == 'a')
        ADVANCE(122);
      if (lookahead == 'b')
        ADVANCE(126);
      if (lookahead == 'c')
        ADVANCE(134);
      if (lookahead == 'd')
        ADVANCE(157);
      if (lookahead == 'e')
        ADVANCE(168);
      if (lookahead == 'f')
        ADVANCE(180);
      if (lookahead == 'g')
        ADVANCE(188);
      if (lookahead == 'i')
        ADVANCE(192);
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 'r')
        ADVANCE(203);
      if (lookahead == 's')
        ADVANCE(221);
      if (lookahead == 't')
        ADVANCE(248);
      if (lookahead == 'u')
        ADVANCE(257);
      if (lookahead == 'v')
        ADVANCE(271);
      if (lookahead == 'w')
        ADVANCE(280);
      if (lookahead == '{')
        ADVANCE(285);
      if (lookahead == '}')
        ADVANCE(289);
      if (lookahead == '~')
        ADVANCE(290);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(427);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('h' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 428:
      if (lookahead == '!')
        ADVANCE(381);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(382);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(362);
      if (lookahead == '+')
        ADVANCE(383);
      if (lookahead == '-')
        ADVANCE(384);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ';')
        ADVANCE(81);
      if (lookahead == 'F')
        ADVANCE(97);
      if (lookahead == 'N')
        ADVANCE(103);
      if (lookahead == 'T')
        ADVANCE(107);
      if (lookahead == '_')
        ADVANCE(115);
      if (lookahead == 'a')
        ADVANCE(122);
      if (lookahead == 'b')
        ADVANCE(126);
      if (lookahead == 'c')
        ADVANCE(134);
      if (lookahead == 'd')
        ADVANCE(157);
      if (lookahead == 'e')
        ADVANCE(168);
      if (lookahead == 'f')
        ADVANCE(180);
      if (lookahead == 'g')
        ADVANCE(188);
      if (lookahead == 'i')
        ADVANCE(192);
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 'r')
        ADVANCE(203);
      if (lookahead == 's')
        ADVANCE(221);
      if (lookahead == 't')
        ADVANCE(248);
      if (lookahead == 'u')
        ADVANCE(257);
      if (lookahead == 'v')
        ADVANCE(271);
      if (lookahead == 'w')
        ADVANCE(280);
      if (lookahead == '{')
        ADVANCE(285);
      if (lookahead == '~')
        ADVANCE(290);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(428);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('h' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    case 429:
      if (lookahead == '!')
        ADVANCE(381);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(375);
      if (lookahead == '&')
        ADVANCE(382);
      if (lookahead == '\'')
        ADVANCE(45);
      if (lookahead == '(')
        ADVANCE(50);
      if (lookahead == '*')
        ADVANCE(362);
      if (lookahead == '+')
        ADVANCE(383);
      if (lookahead == '-')
        ADVANCE(384);
      if (lookahead == '/')
        ADVANCE(293);
      if (lookahead == '0')
        ADVANCE(71);
      if (lookahead == ';')
        ADVANCE(81);
      if (lookahead == 'F')
        ADVANCE(97);
      if (lookahead == 'N')
        ADVANCE(103);
      if (lookahead == 'T')
        ADVANCE(107);
      if (lookahead == '_')
        ADVANCE(115);
      if (lookahead == 'a')
        ADVANCE(122);
      if (lookahead == 'b')
        ADVANCE(126);
      if (lookahead == 'c')
        ADVANCE(134);
      if (lookahead == 'd')
        ADVANCE(157);
      if (lookahead == 'e')
        ADVANCE(168);
      if (lookahead == 'f')
        ADVANCE(180);
      if (lookahead == 'g')
        ADVANCE(188);
      if (lookahead == 'i')
        ADVANCE(192);
      if (lookahead == 'l')
        ADVANCE(199);
      if (lookahead == 'r')
        ADVANCE(203);
      if (lookahead == 's')
        ADVANCE(221);
      if (lookahead == 't')
        ADVANCE(248);
      if (lookahead == 'u')
        ADVANCE(257);
      if (lookahead == 'v')
        ADVANCE(271);
      if (lookahead == 'w')
        ADVANCE(280);
      if (lookahead == '{')
        ADVANCE(285);
      if (lookahead == '~')
        ADVANCE(290);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(429);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('h' <= lookahead && lookahead <= 'z'))
        ADVANCE(102);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 291},
  [2] = {.lex_state = 307},
  [3] = {.lex_state = 308},
  [4] = {.lex_state = 314},
  [5] = {.lex_state = 308},
  [6] = {.lex_state = 308},
  [7] = {.lex_state = 323},
  [8] = {.lex_state = 326},
  [9] = {.lex_state = 340},
  [10] = {.lex_state = 340},
  [11] = {.lex_state = 340},
  [12] = {.lex_state = 308},
  [13] = {.lex_state = 308},
  [14] = {.lex_state = 308},
  [15] = {.lex_state = 351},
  [16] = {.lex_state = 0},
  [17] = {.lex_state = 308},
  [18] = {.lex_state = 351},
  [19] = {.lex_state = 291},
  [20] = {.lex_state = 340},
  [21] = {.lex_state = 361},
  [22] = {.lex_state = 291},
  [23] = {.lex_state = 323},
  [24] = {.lex_state = 366},
  [25] = {.lex_state = 366},
  [26] = {.lex_state = 366},
  [27] = {.lex_state = 314},
  [28] = {.lex_state = 291},
  [29] = {.lex_state = 326},
  [30] = {.lex_state = 308},
  [31] = {.lex_state = 308},
  [32] = {.lex_state = 308},
  [33] = {.lex_state = 308},
  [34] = {.lex_state = 308},
  [35] = {.lex_state = 326},
  [36] = {.lex_state = 367},
  [37] = {.lex_state = 340},
  [38] = {.lex_state = 308},
  [39] = {.lex_state = 351},
  [40] = {.lex_state = 351},
  [41] = {.lex_state = 340},
  [42] = {.lex_state = 351},
  [43] = {.lex_state = 351},
  [44] = {.lex_state = 351},
  [45] = {.lex_state = 351},
  [46] = {.lex_state = 326},
  [47] = {.lex_state = 308},
  [48] = {.lex_state = 291},
  [49] = {.lex_state = 308},
  [50] = {.lex_state = 308},
  [51] = {.lex_state = 308},
  [52] = {.lex_state = 351},
  [53] = {.lex_state = 351},
  [54] = {.lex_state = 351},
  [55] = {.lex_state = 291},
  [56] = {.lex_state = 351},
  [57] = {.lex_state = 340},
  [58] = {.lex_state = 351},
  [59] = {.lex_state = 351},
  [60] = {.lex_state = 361},
  [61] = {.lex_state = 314},
  [62] = {.lex_state = 291},
  [63] = {.lex_state = 308},
  [64] = {.lex_state = 372},
  [65] = {.lex_state = 307},
  [66] = {.lex_state = 308},
  [67] = {.lex_state = 314},
  [68] = {.lex_state = 291},
  [69] = {.lex_state = 308},
  [70] = {.lex_state = 308},
  [71] = {.lex_state = 374},
  [72] = {.lex_state = 314},
  [73] = {.lex_state = 323},
  [74] = {.lex_state = 326},
  [75] = {.lex_state = 340},
  [76] = {.lex_state = 326},
  [77] = {.lex_state = 308},
  [78] = {.lex_state = 366},
  [79] = {.lex_state = 291},
  [80] = {.lex_state = 326},
  [81] = {.lex_state = 366},
  [82] = {.lex_state = 291},
  [83] = {.lex_state = 326},
  [84] = {.lex_state = 366},
  [85] = {.lex_state = 377},
  [86] = {.lex_state = 308},
  [87] = {.lex_state = 308},
  [88] = {.lex_state = 308},
  [89] = {.lex_state = 340},
  [90] = {.lex_state = 308},
  [91] = {.lex_state = 308},
  [92] = {.lex_state = 308},
  [93] = {.lex_state = 308},
  [94] = {.lex_state = 326},
  [95] = {.lex_state = 308},
  [96] = {.lex_state = 308},
  [97] = {.lex_state = 308},
  [98] = {.lex_state = 308},
  [99] = {.lex_state = 308},
  [100] = {.lex_state = 308},
  [101] = {.lex_state = 308},
  [102] = {.lex_state = 308},
  [103] = {.lex_state = 326},
  [104] = {.lex_state = 308},
  [105] = {.lex_state = 308},
  [106] = {.lex_state = 367},
  [107] = {.lex_state = 291},
  [108] = {.lex_state = 291},
  [109] = {.lex_state = 308},
  [110] = {.lex_state = 351},
  [111] = {.lex_state = 340},
  [112] = {.lex_state = 361},
  [113] = {.lex_state = 291},
  [114] = {.lex_state = 351},
  [115] = {.lex_state = 308},
  [116] = {.lex_state = 308},
  [117] = {.lex_state = 351},
  [118] = {.lex_state = 314},
  [119] = {.lex_state = 308},
  [120] = {.lex_state = 308},
  [121] = {.lex_state = 351},
  [122] = {.lex_state = 340},
  [123] = {.lex_state = 340},
  [124] = {.lex_state = 308},
  [125] = {.lex_state = 351},
  [126] = {.lex_state = 340},
  [127] = {.lex_state = 361},
  [128] = {.lex_state = 340},
  [129] = {.lex_state = 351},
  [130] = {.lex_state = 351},
  [131] = {.lex_state = 308},
  [132] = {.lex_state = 308},
  [133] = {.lex_state = 326},
  [134] = {.lex_state = 367},
  [135] = {.lex_state = 308},
  [136] = {.lex_state = 308},
  [137] = {.lex_state = 308},
  [138] = {.lex_state = 378},
  [139] = {.lex_state = 308},
  [140] = {.lex_state = 291},
  [141] = {.lex_state = 380},
  [142] = {.lex_state = 385},
  [143] = {.lex_state = 389},
  [144] = {.lex_state = 291},
  [145] = {.lex_state = 308},
  [146] = {.lex_state = 308},
  [147] = {.lex_state = 351},
  [148] = {.lex_state = 351},
  [149] = {.lex_state = 377},
  [150] = {.lex_state = 308},
  [151] = {.lex_state = 372},
  [152] = {.lex_state = 291},
  [153] = {.lex_state = 377},
  [154] = {.lex_state = 366},
  [155] = {.lex_state = 323},
  [156] = {.lex_state = 366},
  [157] = {.lex_state = 366},
  [158] = {.lex_state = 366},
  [159] = {.lex_state = 307},
  [160] = {.lex_state = 308},
  [161] = {.lex_state = 314},
  [162] = {.lex_state = 308},
  [163] = {.lex_state = 308},
  [164] = {.lex_state = 323},
  [165] = {.lex_state = 326},
  [166] = {.lex_state = 340},
  [167] = {.lex_state = 308},
  [168] = {.lex_state = 374},
  [169] = {.lex_state = 366},
  [170] = {.lex_state = 314},
  [171] = {.lex_state = 366},
  [172] = {.lex_state = 308},
  [173] = {.lex_state = 326},
  [174] = {.lex_state = 340},
  [175] = {.lex_state = 291},
  [176] = {.lex_state = 366},
  [177] = {.lex_state = 308},
  [178] = {.lex_state = 308},
  [179] = {.lex_state = 326},
  [180] = {.lex_state = 366},
  [181] = {.lex_state = 291},
  [182] = {.lex_state = 326},
  [183] = {.lex_state = 291},
  [184] = {.lex_state = 326},
  [185] = {.lex_state = 291},
  [186] = {.lex_state = 291},
  [187] = {.lex_state = 308},
  [188] = {.lex_state = 308},
  [189] = {.lex_state = 308},
  [190] = {.lex_state = 308},
  [191] = {.lex_state = 340},
  [192] = {.lex_state = 308},
  [193] = {.lex_state = 308},
  [194] = {.lex_state = 308},
  [195] = {.lex_state = 308},
  [196] = {.lex_state = 308},
  [197] = {.lex_state = 308},
  [198] = {.lex_state = 291},
  [199] = {.lex_state = 385},
  [200] = {.lex_state = 308},
  [201] = {.lex_state = 308},
  [202] = {.lex_state = 291},
  [203] = {.lex_state = 291},
  [204] = {.lex_state = 351},
  [205] = {.lex_state = 351},
  [206] = {.lex_state = 361},
  [207] = {.lex_state = 351},
  [208] = {.lex_state = 389},
  [209] = {.lex_state = 308},
  [210] = {.lex_state = 308},
  [211] = {.lex_state = 395},
  [212] = {.lex_state = 395},
  [213] = {.lex_state = 395},
  [214] = {.lex_state = 308},
  [215] = {.lex_state = 403},
  [216] = {.lex_state = 308},
  [217] = {.lex_state = 389},
  [218] = {.lex_state = 308},
  [219] = {.lex_state = 308},
  [220] = {.lex_state = 308},
  [221] = {.lex_state = 308},
  [222] = {.lex_state = 308},
  [223] = {.lex_state = 351},
  [224] = {.lex_state = 351},
  [225] = {.lex_state = 361},
  [226] = {.lex_state = 351},
  [227] = {.lex_state = 340},
  [228] = {.lex_state = 378},
  [229] = {.lex_state = 308},
  [230] = {.lex_state = 385},
  [231] = {.lex_state = 308},
  [232] = {.lex_state = 308},
  [233] = {.lex_state = 351},
  [234] = {.lex_state = 308},
  [235] = {.lex_state = 367},
  [236] = {.lex_state = 308},
  [237] = {.lex_state = 308},
  [238] = {.lex_state = 308},
  [239] = {.lex_state = 308},
  [240] = {.lex_state = 351},
  [241] = {.lex_state = 340},
  [242] = {.lex_state = 361},
  [243] = {.lex_state = 308},
  [244] = {.lex_state = 308},
  [245] = {.lex_state = 308},
  [246] = {.lex_state = 307},
  [247] = {.lex_state = 308},
  [248] = {.lex_state = 405},
  [249] = {.lex_state = 314},
  [250] = {.lex_state = 308},
  [251] = {.lex_state = 308},
  [252] = {.lex_state = 323},
  [253] = {.lex_state = 380},
  [254] = {.lex_state = 326},
  [255] = {.lex_state = 380},
  [256] = {.lex_state = 291},
  [257] = {.lex_state = 389},
  [258] = {.lex_state = 291},
  [259] = {.lex_state = 291},
  [260] = {.lex_state = 389},
  [261] = {.lex_state = 308},
  [262] = {.lex_state = 291},
  [263] = {.lex_state = 407},
  [264] = {.lex_state = 291},
  [265] = {.lex_state = 389},
  [266] = {.lex_state = 291},
  [267] = {.lex_state = 291},
  [268] = {.lex_state = 308},
  [269] = {.lex_state = 389},
  [270] = {.lex_state = 389},
  [271] = {.lex_state = 389},
  [272] = {.lex_state = 389},
  [273] = {.lex_state = 351},
  [274] = {.lex_state = 351},
  [275] = {.lex_state = 380},
  [276] = {.lex_state = 380},
  [277] = {.lex_state = 308},
  [278] = {.lex_state = 308},
  [279] = {.lex_state = 291},
  [280] = {.lex_state = 380},
  [281] = {.lex_state = 405},
  [282] = {.lex_state = 389},
  [283] = {.lex_state = 308},
  [284] = {.lex_state = 308},
  [285] = {.lex_state = 308},
  [286] = {.lex_state = 308},
  [287] = {.lex_state = 389},
  [288] = {.lex_state = 389},
  [289] = {.lex_state = 389},
  [290] = {.lex_state = 389},
  [291] = {.lex_state = 351},
  [292] = {.lex_state = 419},
  [293] = {.lex_state = 389},
  [294] = {.lex_state = 421},
  [295] = {.lex_state = 308},
  [296] = {.lex_state = 340},
  [297] = {.lex_state = 422},
  [298] = {.lex_state = 389},
  [299] = {.lex_state = 308},
  [300] = {.lex_state = 308},
  [301] = {.lex_state = 291},
  [302] = {.lex_state = 308},
  [303] = {.lex_state = 291},
  [304] = {.lex_state = 308},
  [305] = {.lex_state = 372},
  [306] = {.lex_state = 308},
  [307] = {.lex_state = 291},
  [308] = {.lex_state = 314},
  [309] = {.lex_state = 366},
  [310] = {.lex_state = 372},
  [311] = {.lex_state = 366},
  [312] = {.lex_state = 326},
  [313] = {.lex_state = 366},
  [314] = {.lex_state = 366},
  [315] = {.lex_state = 326},
  [316] = {.lex_state = 366},
  [317] = {.lex_state = 366},
  [318] = {.lex_state = 326},
  [319] = {.lex_state = 366},
  [320] = {.lex_state = 374},
  [321] = {.lex_state = 323},
  [322] = {.lex_state = 366},
  [323] = {.lex_state = 366},
  [324] = {.lex_state = 366},
  [325] = {.lex_state = 314},
  [326] = {.lex_state = 374},
  [327] = {.lex_state = 308},
  [328] = {.lex_state = 326},
  [329] = {.lex_state = 340},
  [330] = {.lex_state = 374},
  [331] = {.lex_state = 308},
  [332] = {.lex_state = 308},
  [333] = {.lex_state = 374},
  [334] = {.lex_state = 326},
  [335] = {.lex_state = 366},
  [336] = {.lex_state = 377},
  [337] = {.lex_state = 308},
  [338] = {.lex_state = 308},
  [339] = {.lex_state = 291},
  [340] = {.lex_state = 366},
  [341] = {.lex_state = 308},
  [342] = {.lex_state = 366},
  [343] = {.lex_state = 380},
  [344] = {.lex_state = 366},
  [345] = {.lex_state = 308},
  [346] = {.lex_state = 291},
  [347] = {.lex_state = 291},
  [348] = {.lex_state = 291},
  [349] = {.lex_state = 308},
  [350] = {.lex_state = 308},
  [351] = {.lex_state = 308},
  [352] = {.lex_state = 308},
  [353] = {.lex_state = 308},
  [354] = {.lex_state = 308},
  [355] = {.lex_state = 308},
  [356] = {.lex_state = 389},
  [357] = {.lex_state = 308},
  [358] = {.lex_state = 291},
  [359] = {.lex_state = 291},
  [360] = {.lex_state = 291},
  [361] = {.lex_state = 351},
  [362] = {.lex_state = 351},
  [363] = {.lex_state = 405},
  [364] = {.lex_state = 389},
  [365] = {.lex_state = 389},
  [366] = {.lex_state = 389},
  [367] = {.lex_state = 389},
  [368] = {.lex_state = 389},
  [369] = {.lex_state = 351},
  [370] = {.lex_state = 308},
  [371] = {.lex_state = 351},
  [372] = {.lex_state = 308},
  [373] = {.lex_state = 308},
  [374] = {.lex_state = 308},
  [375] = {.lex_state = 340},
  [376] = {.lex_state = 395},
  [377] = {.lex_state = 314},
  [378] = {.lex_state = 326},
  [379] = {.lex_state = 326},
  [380] = {.lex_state = 395},
  [381] = {.lex_state = 340},
  [382] = {.lex_state = 326},
  [383] = {.lex_state = 326},
  [384] = {.lex_state = 395},
  [385] = {.lex_state = 340},
  [386] = {.lex_state = 326},
  [387] = {.lex_state = 326},
  [388] = {.lex_state = 395},
  [389] = {.lex_state = 308},
  [390] = {.lex_state = 308},
  [391] = {.lex_state = 308},
  [392] = {.lex_state = 405},
  [393] = {.lex_state = 389},
  [394] = {.lex_state = 389},
  [395] = {.lex_state = 389},
  [396] = {.lex_state = 389},
  [397] = {.lex_state = 389},
  [398] = {.lex_state = 351},
  [399] = {.lex_state = 308},
  [400] = {.lex_state = 308},
  [401] = {.lex_state = 403},
  [402] = {.lex_state = 385},
  [403] = {.lex_state = 389},
  [404] = {.lex_state = 308},
  [405] = {.lex_state = 308},
  [406] = {.lex_state = 351},
  [407] = {.lex_state = 351},
  [408] = {.lex_state = 308},
  [409] = {.lex_state = 308},
  [410] = {.lex_state = 308},
  [411] = {.lex_state = 389},
  [412] = {.lex_state = 308},
  [413] = {.lex_state = 385},
  [414] = {.lex_state = 308},
  [415] = {.lex_state = 308},
  [416] = {.lex_state = 378},
  [417] = {.lex_state = 308},
  [418] = {.lex_state = 308},
  [419] = {.lex_state = 378},
  [420] = {.lex_state = 308},
  [421] = {.lex_state = 308},
  [422] = {.lex_state = 308},
  [423] = {.lex_state = 351},
  [424] = {.lex_state = 351},
  [425] = {.lex_state = 361},
  [426] = {.lex_state = 380},
  [427] = {.lex_state = 323},
  [428] = {.lex_state = 405},
  [429] = {.lex_state = 389},
  [430] = {.lex_state = 389},
  [431] = {.lex_state = 389},
  [432] = {.lex_state = 389},
  [433] = {.lex_state = 389},
  [434] = {.lex_state = 351},
  [435] = {.lex_state = 308},
  [436] = {.lex_state = 308},
  [437] = {.lex_state = 308},
  [438] = {.lex_state = 308},
  [439] = {.lex_state = 424},
  [440] = {.lex_state = 424},
  [441] = {.lex_state = 424},
  [442] = {.lex_state = 314},
  [443] = {.lex_state = 380},
  [444] = {.lex_state = 308},
  [445] = {.lex_state = 326},
  [446] = {.lex_state = 380},
  [447] = {.lex_state = 380},
  [448] = {.lex_state = 308},
  [449] = {.lex_state = 389},
  [450] = {.lex_state = 389},
  [451] = {.lex_state = 405},
  [452] = {.lex_state = 389},
  [453] = {.lex_state = 389},
  [454] = {.lex_state = 389},
  [455] = {.lex_state = 389},
  [456] = {.lex_state = 389},
  [457] = {.lex_state = 351},
  [458] = {.lex_state = 308},
  [459] = {.lex_state = 380},
  [460] = {.lex_state = 389},
  [461] = {.lex_state = 291},
  [462] = {.lex_state = 291},
  [463] = {.lex_state = 389},
  [464] = {.lex_state = 308},
  [465] = {.lex_state = 291},
  [466] = {.lex_state = 291},
  [467] = {.lex_state = 308},
  [468] = {.lex_state = 380},
  [469] = {.lex_state = 385},
  [470] = {.lex_state = 380},
  [471] = {.lex_state = 308},
  [472] = {.lex_state = 380},
  [473] = {.lex_state = 380},
  [474] = {.lex_state = 291},
  [475] = {.lex_state = 308},
  [476] = {.lex_state = 308},
  [477] = {.lex_state = 308},
  [478] = {.lex_state = 405},
  [479] = {.lex_state = 308},
  [480] = {.lex_state = 351},
  [481] = {.lex_state = 407},
  [482] = {.lex_state = 380},
  [483] = {.lex_state = 308},
  [484] = {.lex_state = 308},
  [485] = {.lex_state = 389},
  [486] = {.lex_state = 389},
  [487] = {.lex_state = 380},
  [488] = {.lex_state = 389},
  [489] = {.lex_state = 389},
  [490] = {.lex_state = 389},
  [491] = {.lex_state = 389},
  [492] = {.lex_state = 389},
  [493] = {.lex_state = 389},
  [494] = {.lex_state = 389},
  [495] = {.lex_state = 389},
  [496] = {.lex_state = 389},
  [497] = {.lex_state = 389},
  [498] = {.lex_state = 389},
  [499] = {.lex_state = 389},
  [500] = {.lex_state = 389},
  [501] = {.lex_state = 308},
  [502] = {.lex_state = 308},
  [503] = {.lex_state = 308},
  [504] = {.lex_state = 291},
  [505] = {.lex_state = 380},
  [506] = {.lex_state = 308},
  [507] = {.lex_state = 308},
  [508] = {.lex_state = 421},
  [509] = {.lex_state = 421},
  [510] = {.lex_state = 340},
  [511] = {.lex_state = 421},
  [512] = {.lex_state = 421},
  [513] = {.lex_state = 421},
  [514] = {.lex_state = 421},
  [515] = {.lex_state = 405},
  [516] = {.lex_state = 308},
  [517] = {.lex_state = 351},
  [518] = {.lex_state = 326},
  [519] = {.lex_state = 308},
  [520] = {.lex_state = 308},
  [521] = {.lex_state = 421},
  [522] = {.lex_state = 421},
  [523] = {.lex_state = 421},
  [524] = {.lex_state = 389},
  [525] = {.lex_state = 389},
  [526] = {.lex_state = 389},
  [527] = {.lex_state = 389},
  [528] = {.lex_state = 389},
  [529] = {.lex_state = 389},
  [530] = {.lex_state = 389},
  [531] = {.lex_state = 389},
  [532] = {.lex_state = 389},
  [533] = {.lex_state = 389},
  [534] = {.lex_state = 389},
  [535] = {.lex_state = 389},
  [536] = {.lex_state = 421},
  [537] = {.lex_state = 421},
  [538] = {.lex_state = 421},
  [539] = {.lex_state = 421},
  [540] = {.lex_state = 422},
  [541] = {.lex_state = 291},
  [542] = {.lex_state = 308},
  [543] = {.lex_state = 389},
  [544] = {.lex_state = 308},
  [545] = {.lex_state = 308},
  [546] = {.lex_state = 308},
  [547] = {.lex_state = 308},
  [548] = {.lex_state = 308},
  [549] = {.lex_state = 372},
  [550] = {.lex_state = 308},
  [551] = {.lex_state = 377},
  [552] = {.lex_state = 366},
  [553] = {.lex_state = 377},
  [554] = {.lex_state = 366},
  [555] = {.lex_state = 326},
  [556] = {.lex_state = 366},
  [557] = {.lex_state = 326},
  [558] = {.lex_state = 366},
  [559] = {.lex_state = 326},
  [560] = {.lex_state = 314},
  [561] = {.lex_state = 374},
  [562] = {.lex_state = 372},
  [563] = {.lex_state = 374},
  [564] = {.lex_state = 326},
  [565] = {.lex_state = 366},
  [566] = {.lex_state = 374},
  [567] = {.lex_state = 326},
  [568] = {.lex_state = 366},
  [569] = {.lex_state = 374},
  [570] = {.lex_state = 326},
  [571] = {.lex_state = 366},
  [572] = {.lex_state = 377},
  [573] = {.lex_state = 308},
  [574] = {.lex_state = 308},
  [575] = {.lex_state = 291},
  [576] = {.lex_state = 374},
  [577] = {.lex_state = 308},
  [578] = {.lex_state = 374},
  [579] = {.lex_state = 380},
  [580] = {.lex_state = 374},
  [581] = {.lex_state = 308},
  [582] = {.lex_state = 326},
  [583] = {.lex_state = 366},
  [584] = {.lex_state = 366},
  [585] = {.lex_state = 308},
  [586] = {.lex_state = 366},
  [587] = {.lex_state = 291},
  [588] = {.lex_state = 366},
  [589] = {.lex_state = 380},
  [590] = {.lex_state = 366},
  [591] = {.lex_state = 308},
  [592] = {.lex_state = 308},
  [593] = {.lex_state = 308},
  [594] = {.lex_state = 308},
  [595] = {.lex_state = 308},
  [596] = {.lex_state = 405},
  [597] = {.lex_state = 308},
  [598] = {.lex_state = 351},
  [599] = {.lex_state = 389},
  [600] = {.lex_state = 389},
  [601] = {.lex_state = 389},
  [602] = {.lex_state = 389},
  [603] = {.lex_state = 389},
  [604] = {.lex_state = 389},
  [605] = {.lex_state = 389},
  [606] = {.lex_state = 389},
  [607] = {.lex_state = 389},
  [608] = {.lex_state = 389},
  [609] = {.lex_state = 389},
  [610] = {.lex_state = 389},
  [611] = {.lex_state = 351},
  [612] = {.lex_state = 308},
  [613] = {.lex_state = 395},
  [614] = {.lex_state = 395},
  [615] = {.lex_state = 340},
  [616] = {.lex_state = 340},
  [617] = {.lex_state = 340},
  [618] = {.lex_state = 326},
  [619] = {.lex_state = 326},
  [620] = {.lex_state = 395},
  [621] = {.lex_state = 340},
  [622] = {.lex_state = 340},
  [623] = {.lex_state = 340},
  [624] = {.lex_state = 326},
  [625] = {.lex_state = 326},
  [626] = {.lex_state = 340},
  [627] = {.lex_state = 340},
  [628] = {.lex_state = 340},
  [629] = {.lex_state = 326},
  [630] = {.lex_state = 326},
  [631] = {.lex_state = 308},
  [632] = {.lex_state = 308},
  [633] = {.lex_state = 405},
  [634] = {.lex_state = 308},
  [635] = {.lex_state = 351},
  [636] = {.lex_state = 403},
  [637] = {.lex_state = 389},
  [638] = {.lex_state = 389},
  [639] = {.lex_state = 389},
  [640] = {.lex_state = 389},
  [641] = {.lex_state = 389},
  [642] = {.lex_state = 389},
  [643] = {.lex_state = 389},
  [644] = {.lex_state = 389},
  [645] = {.lex_state = 389},
  [646] = {.lex_state = 389},
  [647] = {.lex_state = 389},
  [648] = {.lex_state = 389},
  [649] = {.lex_state = 308},
  [650] = {.lex_state = 308},
  [651] = {.lex_state = 389},
  [652] = {.lex_state = 308},
  [653] = {.lex_state = 308},
  [654] = {.lex_state = 389},
  [655] = {.lex_state = 308},
  [656] = {.lex_state = 308},
  [657] = {.lex_state = 308},
  [658] = {.lex_state = 308},
  [659] = {.lex_state = 389},
  [660] = {.lex_state = 308},
  [661] = {.lex_state = 308},
  [662] = {.lex_state = 308},
  [663] = {.lex_state = 308},
  [664] = {.lex_state = 351},
  [665] = {.lex_state = 351},
  [666] = {.lex_state = 351},
  [667] = {.lex_state = 314},
  [668] = {.lex_state = 380},
  [669] = {.lex_state = 372},
  [670] = {.lex_state = 308},
  [671] = {.lex_state = 405},
  [672] = {.lex_state = 308},
  [673] = {.lex_state = 351},
  [674] = {.lex_state = 389},
  [675] = {.lex_state = 308},
  [676] = {.lex_state = 389},
  [677] = {.lex_state = 389},
  [678] = {.lex_state = 389},
  [679] = {.lex_state = 389},
  [680] = {.lex_state = 389},
  [681] = {.lex_state = 389},
  [682] = {.lex_state = 389},
  [683] = {.lex_state = 389},
  [684] = {.lex_state = 389},
  [685] = {.lex_state = 389},
  [686] = {.lex_state = 389},
  [687] = {.lex_state = 389},
  [688] = {.lex_state = 389},
  [689] = {.lex_state = 307},
  [690] = {.lex_state = 308},
  [691] = {.lex_state = 314},
  [692] = {.lex_state = 380},
  [693] = {.lex_state = 308},
  [694] = {.lex_state = 308},
  [695] = {.lex_state = 425},
  [696] = {.lex_state = 314},
  [697] = {.lex_state = 323},
  [698] = {.lex_state = 424},
  [699] = {.lex_state = 326},
  [700] = {.lex_state = 380},
  [701] = {.lex_state = 291},
  [702] = {.lex_state = 291},
  [703] = {.lex_state = 389},
  [704] = {.lex_state = 308},
  [705] = {.lex_state = 291},
  [706] = {.lex_state = 407},
  [707] = {.lex_state = 291},
  [708] = {.lex_state = 389},
  [709] = {.lex_state = 291},
  [710] = {.lex_state = 291},
  [711] = {.lex_state = 308},
  [712] = {.lex_state = 351},
  [713] = {.lex_state = 424},
  [714] = {.lex_state = 424},
  [715] = {.lex_state = 326},
  [716] = {.lex_state = 326},
  [717] = {.lex_state = 308},
  [718] = {.lex_state = 308},
  [719] = {.lex_state = 291},
  [720] = {.lex_state = 424},
  [721] = {.lex_state = 380},
  [722] = {.lex_state = 326},
  [723] = {.lex_state = 326},
  [724] = {.lex_state = 424},
  [725] = {.lex_state = 380},
  [726] = {.lex_state = 326},
  [727] = {.lex_state = 326},
  [728] = {.lex_state = 424},
  [729] = {.lex_state = 377},
  [730] = {.lex_state = 308},
  [731] = {.lex_state = 308},
  [732] = {.lex_state = 380},
  [733] = {.lex_state = 405},
  [734] = {.lex_state = 389},
  [735] = {.lex_state = 389},
  [736] = {.lex_state = 389},
  [737] = {.lex_state = 389},
  [738] = {.lex_state = 389},
  [739] = {.lex_state = 351},
  [740] = {.lex_state = 308},
  [741] = {.lex_state = 308},
  [742] = {.lex_state = 308},
  [743] = {.lex_state = 405},
  [744] = {.lex_state = 308},
  [745] = {.lex_state = 351},
  [746] = {.lex_state = 389},
  [747] = {.lex_state = 389},
  [748] = {.lex_state = 380},
  [749] = {.lex_state = 389},
  [750] = {.lex_state = 389},
  [751] = {.lex_state = 389},
  [752] = {.lex_state = 389},
  [753] = {.lex_state = 389},
  [754] = {.lex_state = 389},
  [755] = {.lex_state = 389},
  [756] = {.lex_state = 389},
  [757] = {.lex_state = 389},
  [758] = {.lex_state = 389},
  [759] = {.lex_state = 351},
  [760] = {.lex_state = 380},
  [761] = {.lex_state = 308},
  [762] = {.lex_state = 308},
  [763] = {.lex_state = 389},
  [764] = {.lex_state = 389},
  [765] = {.lex_state = 308},
  [766] = {.lex_state = 380},
  [767] = {.lex_state = 389},
  [768] = {.lex_state = 385},
  [769] = {.lex_state = 407},
  [770] = {.lex_state = 291},
  [771] = {.lex_state = 389},
  [772] = {.lex_state = 351},
  [773] = {.lex_state = 308},
  [774] = {.lex_state = 308},
  [775] = {.lex_state = 380},
  [776] = {.lex_state = 380},
  [777] = {.lex_state = 308},
  [778] = {.lex_state = 351},
  [779] = {.lex_state = 308},
  [780] = {.lex_state = 380},
  [781] = {.lex_state = 380},
  [782] = {.lex_state = 308},
  [783] = {.lex_state = 308},
  [784] = {.lex_state = 308},
  [785] = {.lex_state = 308},
  [786] = {.lex_state = 308},
  [787] = {.lex_state = 308},
  [788] = {.lex_state = 308},
  [789] = {.lex_state = 308},
  [790] = {.lex_state = 308},
  [791] = {.lex_state = 308},
  [792] = {.lex_state = 308},
  [793] = {.lex_state = 308},
  [794] = {.lex_state = 308},
  [795] = {.lex_state = 308},
  [796] = {.lex_state = 308},
  [797] = {.lex_state = 308},
  [798] = {.lex_state = 308},
  [799] = {.lex_state = 308},
  [800] = {.lex_state = 308},
  [801] = {.lex_state = 389},
  [802] = {.lex_state = 291},
  [803] = {.lex_state = 421},
  [804] = {.lex_state = 308},
  [805] = {.lex_state = 421},
  [806] = {.lex_state = 421},
  [807] = {.lex_state = 340},
  [808] = {.lex_state = 421},
  [809] = {.lex_state = 421},
  [810] = {.lex_state = 308},
  [811] = {.lex_state = 351},
  [812] = {.lex_state = 308},
  [813] = {.lex_state = 308},
  [814] = {.lex_state = 421},
  [815] = {.lex_state = 308},
  [816] = {.lex_state = 308},
  [817] = {.lex_state = 308},
  [818] = {.lex_state = 308},
  [819] = {.lex_state = 308},
  [820] = {.lex_state = 308},
  [821] = {.lex_state = 308},
  [822] = {.lex_state = 308},
  [823] = {.lex_state = 308},
  [824] = {.lex_state = 308},
  [825] = {.lex_state = 308},
  [826] = {.lex_state = 421},
  [827] = {.lex_state = 308},
  [828] = {.lex_state = 308},
  [829] = {.lex_state = 308},
  [830] = {.lex_state = 389},
  [831] = {.lex_state = 308},
  [832] = {.lex_state = 389},
  [833] = {.lex_state = 308},
  [834] = {.lex_state = 366},
  [835] = {.lex_state = 366},
  [836] = {.lex_state = 366},
  [837] = {.lex_state = 366},
  [838] = {.lex_state = 366},
  [839] = {.lex_state = 377},
  [840] = {.lex_state = 374},
  [841] = {.lex_state = 377},
  [842] = {.lex_state = 374},
  [843] = {.lex_state = 326},
  [844] = {.lex_state = 374},
  [845] = {.lex_state = 326},
  [846] = {.lex_state = 374},
  [847] = {.lex_state = 326},
  [848] = {.lex_state = 374},
  [849] = {.lex_state = 374},
  [850] = {.lex_state = 308},
  [851] = {.lex_state = 374},
  [852] = {.lex_state = 291},
  [853] = {.lex_state = 374},
  [854] = {.lex_state = 380},
  [855] = {.lex_state = 374},
  [856] = {.lex_state = 366},
  [857] = {.lex_state = 366},
  [858] = {.lex_state = 366},
  [859] = {.lex_state = 308},
  [860] = {.lex_state = 308},
  [861] = {.lex_state = 389},
  [862] = {.lex_state = 308},
  [863] = {.lex_state = 351},
  [864] = {.lex_state = 308},
  [865] = {.lex_state = 308},
  [866] = {.lex_state = 308},
  [867] = {.lex_state = 308},
  [868] = {.lex_state = 308},
  [869] = {.lex_state = 308},
  [870] = {.lex_state = 308},
  [871] = {.lex_state = 308},
  [872] = {.lex_state = 308},
  [873] = {.lex_state = 308},
  [874] = {.lex_state = 308},
  [875] = {.lex_state = 395},
  [876] = {.lex_state = 326},
  [877] = {.lex_state = 326},
  [878] = {.lex_state = 395},
  [879] = {.lex_state = 340},
  [880] = {.lex_state = 340},
  [881] = {.lex_state = 340},
  [882] = {.lex_state = 340},
  [883] = {.lex_state = 340},
  [884] = {.lex_state = 340},
  [885] = {.lex_state = 389},
  [886] = {.lex_state = 308},
  [887] = {.lex_state = 351},
  [888] = {.lex_state = 308},
  [889] = {.lex_state = 308},
  [890] = {.lex_state = 308},
  [891] = {.lex_state = 308},
  [892] = {.lex_state = 308},
  [893] = {.lex_state = 308},
  [894] = {.lex_state = 308},
  [895] = {.lex_state = 308},
  [896] = {.lex_state = 308},
  [897] = {.lex_state = 308},
  [898] = {.lex_state = 308},
  [899] = {.lex_state = 308},
  [900] = {.lex_state = 308},
  [901] = {.lex_state = 403},
  [902] = {.lex_state = 308},
  [903] = {.lex_state = 308},
  [904] = {.lex_state = 308},
  [905] = {.lex_state = 377},
  [906] = {.lex_state = 380},
  [907] = {.lex_state = 377},
  [908] = {.lex_state = 389},
  [909] = {.lex_state = 308},
  [910] = {.lex_state = 351},
  [911] = {.lex_state = 308},
  [912] = {.lex_state = 308},
  [913] = {.lex_state = 308},
  [914] = {.lex_state = 308},
  [915] = {.lex_state = 308},
  [916] = {.lex_state = 308},
  [917] = {.lex_state = 308},
  [918] = {.lex_state = 308},
  [919] = {.lex_state = 308},
  [920] = {.lex_state = 308},
  [921] = {.lex_state = 308},
  [922] = {.lex_state = 308},
  [923] = {.lex_state = 308},
  [924] = {.lex_state = 308},
  [925] = {.lex_state = 424},
  [926] = {.lex_state = 323},
  [927] = {.lex_state = 424},
  [928] = {.lex_state = 424},
  [929] = {.lex_state = 424},
  [930] = {.lex_state = 307},
  [931] = {.lex_state = 308},
  [932] = {.lex_state = 314},
  [933] = {.lex_state = 308},
  [934] = {.lex_state = 308},
  [935] = {.lex_state = 323},
  [936] = {.lex_state = 425},
  [937] = {.lex_state = 326},
  [938] = {.lex_state = 380},
  [939] = {.lex_state = 291},
  [940] = {.lex_state = 291},
  [941] = {.lex_state = 389},
  [942] = {.lex_state = 308},
  [943] = {.lex_state = 291},
  [944] = {.lex_state = 407},
  [945] = {.lex_state = 291},
  [946] = {.lex_state = 389},
  [947] = {.lex_state = 291},
  [948] = {.lex_state = 291},
  [949] = {.lex_state = 308},
  [950] = {.lex_state = 351},
  [951] = {.lex_state = 425},
  [952] = {.lex_state = 425},
  [953] = {.lex_state = 308},
  [954] = {.lex_state = 308},
  [955] = {.lex_state = 291},
  [956] = {.lex_state = 425},
  [957] = {.lex_state = 424},
  [958] = {.lex_state = 314},
  [959] = {.lex_state = 424},
  [960] = {.lex_state = 308},
  [961] = {.lex_state = 326},
  [962] = {.lex_state = 424},
  [963] = {.lex_state = 380},
  [964] = {.lex_state = 389},
  [965] = {.lex_state = 389},
  [966] = {.lex_state = 308},
  [967] = {.lex_state = 380},
  [968] = {.lex_state = 389},
  [969] = {.lex_state = 380},
  [970] = {.lex_state = 385},
  [971] = {.lex_state = 424},
  [972] = {.lex_state = 308},
  [973] = {.lex_state = 424},
  [974] = {.lex_state = 424},
  [975] = {.lex_state = 291},
  [976] = {.lex_state = 407},
  [977] = {.lex_state = 380},
  [978] = {.lex_state = 380},
  [979] = {.lex_state = 424},
  [980] = {.lex_state = 308},
  [981] = {.lex_state = 308},
  [982] = {.lex_state = 424},
  [983] = {.lex_state = 380},
  [984] = {.lex_state = 326},
  [985] = {.lex_state = 326},
  [986] = {.lex_state = 424},
  [987] = {.lex_state = 380},
  [988] = {.lex_state = 380},
  [989] = {.lex_state = 380},
  [990] = {.lex_state = 326},
  [991] = {.lex_state = 326},
  [992] = {.lex_state = 380},
  [993] = {.lex_state = 380},
  [994] = {.lex_state = 380},
  [995] = {.lex_state = 326},
  [996] = {.lex_state = 326},
  [997] = {.lex_state = 380},
  [998] = {.lex_state = 380},
  [999] = {.lex_state = 308},
  [1000] = {.lex_state = 308},
  [1001] = {.lex_state = 405},
  [1002] = {.lex_state = 308},
  [1003] = {.lex_state = 351},
  [1004] = {.lex_state = 407},
  [1005] = {.lex_state = 389},
  [1006] = {.lex_state = 389},
  [1007] = {.lex_state = 389},
  [1008] = {.lex_state = 389},
  [1009] = {.lex_state = 389},
  [1010] = {.lex_state = 389},
  [1011] = {.lex_state = 389},
  [1012] = {.lex_state = 389},
  [1013] = {.lex_state = 389},
  [1014] = {.lex_state = 389},
  [1015] = {.lex_state = 389},
  [1016] = {.lex_state = 389},
  [1017] = {.lex_state = 407},
  [1018] = {.lex_state = 389},
  [1019] = {.lex_state = 308},
  [1020] = {.lex_state = 351},
  [1021] = {.lex_state = 308},
  [1022] = {.lex_state = 380},
  [1023] = {.lex_state = 308},
  [1024] = {.lex_state = 308},
  [1025] = {.lex_state = 308},
  [1026] = {.lex_state = 308},
  [1027] = {.lex_state = 308},
  [1028] = {.lex_state = 308},
  [1029] = {.lex_state = 308},
  [1030] = {.lex_state = 308},
  [1031] = {.lex_state = 308},
  [1032] = {.lex_state = 308},
  [1033] = {.lex_state = 407},
  [1034] = {.lex_state = 308},
  [1035] = {.lex_state = 308},
  [1036] = {.lex_state = 380},
  [1037] = {.lex_state = 351},
  [1038] = {.lex_state = 308},
  [1039] = {.lex_state = 389},
  [1040] = {.lex_state = 308},
  [1041] = {.lex_state = 389},
  [1042] = {.lex_state = 389},
  [1043] = {.lex_state = 308},
  [1044] = {.lex_state = 308},
  [1045] = {.lex_state = 308},
  [1046] = {.lex_state = 389},
  [1047] = {.lex_state = 426},
  [1048] = {.lex_state = 380},
  [1049] = {.lex_state = 389},
  [1050] = {.lex_state = 308},
  [1051] = {.lex_state = 308},
  [1052] = {.lex_state = 308},
  [1053] = {.lex_state = 389},
  [1054] = {.lex_state = 421},
  [1055] = {.lex_state = 308},
  [1056] = {.lex_state = 308},
  [1057] = {.lex_state = 421},
  [1058] = {.lex_state = 426},
  [1059] = {.lex_state = 421},
  [1060] = {.lex_state = 389},
  [1061] = {.lex_state = 308},
  [1062] = {.lex_state = 308},
  [1063] = {.lex_state = 308},
  [1064] = {.lex_state = 308},
  [1065] = {.lex_state = 389},
  [1066] = {.lex_state = 308},
  [1067] = {.lex_state = 308},
  [1068] = {.lex_state = 308},
  [1069] = {.lex_state = 374},
  [1070] = {.lex_state = 374},
  [1071] = {.lex_state = 374},
  [1072] = {.lex_state = 374},
  [1073] = {.lex_state = 374},
  [1074] = {.lex_state = 374},
  [1075] = {.lex_state = 374},
  [1076] = {.lex_state = 374},
  [1077] = {.lex_state = 426},
  [1078] = {.lex_state = 389},
  [1079] = {.lex_state = 326},
  [1080] = {.lex_state = 326},
  [1081] = {.lex_state = 426},
  [1082] = {.lex_state = 389},
  [1083] = {.lex_state = 308},
  [1084] = {.lex_state = 403},
  [1085] = {.lex_state = 308},
  [1086] = {.lex_state = 380},
  [1087] = {.lex_state = 380},
  [1088] = {.lex_state = 426},
  [1089] = {.lex_state = 389},
  [1090] = {.lex_state = 314},
  [1091] = {.lex_state = 424},
  [1092] = {.lex_state = 372},
  [1093] = {.lex_state = 424},
  [1094] = {.lex_state = 326},
  [1095] = {.lex_state = 326},
  [1096] = {.lex_state = 424},
  [1097] = {.lex_state = 424},
  [1098] = {.lex_state = 326},
  [1099] = {.lex_state = 326},
  [1100] = {.lex_state = 424},
  [1101] = {.lex_state = 424},
  [1102] = {.lex_state = 326},
  [1103] = {.lex_state = 326},
  [1104] = {.lex_state = 424},
  [1105] = {.lex_state = 425},
  [1106] = {.lex_state = 323},
  [1107] = {.lex_state = 424},
  [1108] = {.lex_state = 424},
  [1109] = {.lex_state = 424},
  [1110] = {.lex_state = 314},
  [1111] = {.lex_state = 425},
  [1112] = {.lex_state = 308},
  [1113] = {.lex_state = 326},
  [1114] = {.lex_state = 425},
  [1115] = {.lex_state = 380},
  [1116] = {.lex_state = 389},
  [1117] = {.lex_state = 389},
  [1118] = {.lex_state = 308},
  [1119] = {.lex_state = 380},
  [1120] = {.lex_state = 389},
  [1121] = {.lex_state = 380},
  [1122] = {.lex_state = 385},
  [1123] = {.lex_state = 425},
  [1124] = {.lex_state = 308},
  [1125] = {.lex_state = 425},
  [1126] = {.lex_state = 425},
  [1127] = {.lex_state = 291},
  [1128] = {.lex_state = 407},
  [1129] = {.lex_state = 425},
  [1130] = {.lex_state = 308},
  [1131] = {.lex_state = 308},
  [1132] = {.lex_state = 425},
  [1133] = {.lex_state = 425},
  [1134] = {.lex_state = 326},
  [1135] = {.lex_state = 326},
  [1136] = {.lex_state = 424},
  [1137] = {.lex_state = 377},
  [1138] = {.lex_state = 308},
  [1139] = {.lex_state = 308},
  [1140] = {.lex_state = 424},
  [1141] = {.lex_state = 308},
  [1142] = {.lex_state = 308},
  [1143] = {.lex_state = 380},
  [1144] = {.lex_state = 351},
  [1145] = {.lex_state = 424},
  [1146] = {.lex_state = 308},
  [1147] = {.lex_state = 308},
  [1148] = {.lex_state = 291},
  [1149] = {.lex_state = 389},
  [1150] = {.lex_state = 308},
  [1151] = {.lex_state = 424},
  [1152] = {.lex_state = 424},
  [1153] = {.lex_state = 308},
  [1154] = {.lex_state = 424},
  [1155] = {.lex_state = 424},
  [1156] = {.lex_state = 308},
  [1157] = {.lex_state = 380},
  [1158] = {.lex_state = 380},
  [1159] = {.lex_state = 380},
  [1160] = {.lex_state = 380},
  [1161] = {.lex_state = 380},
  [1162] = {.lex_state = 380},
  [1163] = {.lex_state = 380},
  [1164] = {.lex_state = 389},
  [1165] = {.lex_state = 308},
  [1166] = {.lex_state = 351},
  [1167] = {.lex_state = 427},
  [1168] = {.lex_state = 380},
  [1169] = {.lex_state = 291},
  [1170] = {.lex_state = 291},
  [1171] = {.lex_state = 389},
  [1172] = {.lex_state = 308},
  [1173] = {.lex_state = 291},
  [1174] = {.lex_state = 407},
  [1175] = {.lex_state = 291},
  [1176] = {.lex_state = 389},
  [1177] = {.lex_state = 291},
  [1178] = {.lex_state = 291},
  [1179] = {.lex_state = 308},
  [1180] = {.lex_state = 308},
  [1181] = {.lex_state = 427},
  [1182] = {.lex_state = 308},
  [1183] = {.lex_state = 291},
  [1184] = {.lex_state = 308},
  [1185] = {.lex_state = 308},
  [1186] = {.lex_state = 308},
  [1187] = {.lex_state = 308},
  [1188] = {.lex_state = 308},
  [1189] = {.lex_state = 308},
  [1190] = {.lex_state = 308},
  [1191] = {.lex_state = 308},
  [1192] = {.lex_state = 308},
  [1193] = {.lex_state = 308},
  [1194] = {.lex_state = 308},
  [1195] = {.lex_state = 380},
  [1196] = {.lex_state = 426},
  [1197] = {.lex_state = 389},
  [1198] = {.lex_state = 380},
  [1199] = {.lex_state = 407},
  [1200] = {.lex_state = 407},
  [1201] = {.lex_state = 407},
  [1202] = {.lex_state = 389},
  [1203] = {.lex_state = 308},
  [1204] = {.lex_state = 389},
  [1205] = {.lex_state = 308},
  [1206] = {.lex_state = 407},
  [1207] = {.lex_state = 308},
  [1208] = {.lex_state = 389},
  [1209] = {.lex_state = 389},
  [1210] = {.lex_state = 308},
  [1211] = {.lex_state = 308},
  [1212] = {.lex_state = 308},
  [1213] = {.lex_state = 308},
  [1214] = {.lex_state = 308},
  [1215] = {.lex_state = 308},
  [1216] = {.lex_state = 421},
  [1217] = {.lex_state = 308},
  [1218] = {.lex_state = 308},
  [1219] = {.lex_state = 308},
  [1220] = {.lex_state = 389},
  [1221] = {.lex_state = 308},
  [1222] = {.lex_state = 308},
  [1223] = {.lex_state = 308},
  [1224] = {.lex_state = 377},
  [1225] = {.lex_state = 424},
  [1226] = {.lex_state = 377},
  [1227] = {.lex_state = 424},
  [1228] = {.lex_state = 424},
  [1229] = {.lex_state = 424},
  [1230] = {.lex_state = 326},
  [1231] = {.lex_state = 326},
  [1232] = {.lex_state = 424},
  [1233] = {.lex_state = 424},
  [1234] = {.lex_state = 424},
  [1235] = {.lex_state = 326},
  [1236] = {.lex_state = 326},
  [1237] = {.lex_state = 424},
  [1238] = {.lex_state = 424},
  [1239] = {.lex_state = 424},
  [1240] = {.lex_state = 326},
  [1241] = {.lex_state = 326},
  [1242] = {.lex_state = 314},
  [1243] = {.lex_state = 425},
  [1244] = {.lex_state = 372},
  [1245] = {.lex_state = 425},
  [1246] = {.lex_state = 326},
  [1247] = {.lex_state = 326},
  [1248] = {.lex_state = 424},
  [1249] = {.lex_state = 425},
  [1250] = {.lex_state = 326},
  [1251] = {.lex_state = 326},
  [1252] = {.lex_state = 424},
  [1253] = {.lex_state = 425},
  [1254] = {.lex_state = 326},
  [1255] = {.lex_state = 326},
  [1256] = {.lex_state = 424},
  [1257] = {.lex_state = 377},
  [1258] = {.lex_state = 308},
  [1259] = {.lex_state = 308},
  [1260] = {.lex_state = 425},
  [1261] = {.lex_state = 308},
  [1262] = {.lex_state = 308},
  [1263] = {.lex_state = 380},
  [1264] = {.lex_state = 351},
  [1265] = {.lex_state = 425},
  [1266] = {.lex_state = 308},
  [1267] = {.lex_state = 308},
  [1268] = {.lex_state = 291},
  [1269] = {.lex_state = 389},
  [1270] = {.lex_state = 308},
  [1271] = {.lex_state = 425},
  [1272] = {.lex_state = 425},
  [1273] = {.lex_state = 308},
  [1274] = {.lex_state = 425},
  [1275] = {.lex_state = 425},
  [1276] = {.lex_state = 308},
  [1277] = {.lex_state = 326},
  [1278] = {.lex_state = 326},
  [1279] = {.lex_state = 424},
  [1280] = {.lex_state = 424},
  [1281] = {.lex_state = 308},
  [1282] = {.lex_state = 407},
  [1283] = {.lex_state = 407},
  [1284] = {.lex_state = 424},
  [1285] = {.lex_state = 407},
  [1286] = {.lex_state = 389},
  [1287] = {.lex_state = 389},
  [1288] = {.lex_state = 308},
  [1289] = {.lex_state = 389},
  [1290] = {.lex_state = 424},
  [1291] = {.lex_state = 426},
  [1292] = {.lex_state = 427},
  [1293] = {.lex_state = 380},
  [1294] = {.lex_state = 389},
  [1295] = {.lex_state = 389},
  [1296] = {.lex_state = 308},
  [1297] = {.lex_state = 380},
  [1298] = {.lex_state = 389},
  [1299] = {.lex_state = 380},
  [1300] = {.lex_state = 385},
  [1301] = {.lex_state = 427},
  [1302] = {.lex_state = 308},
  [1303] = {.lex_state = 427},
  [1304] = {.lex_state = 427},
  [1305] = {.lex_state = 291},
  [1306] = {.lex_state = 407},
  [1307] = {.lex_state = 407},
  [1308] = {.lex_state = 427},
  [1309] = {.lex_state = 389},
  [1310] = {.lex_state = 308},
  [1311] = {.lex_state = 291},
  [1312] = {.lex_state = 291},
  [1313] = {.lex_state = 389},
  [1314] = {.lex_state = 308},
  [1315] = {.lex_state = 291},
  [1316] = {.lex_state = 291},
  [1317] = {.lex_state = 308},
  [1318] = {.lex_state = 427},
  [1319] = {.lex_state = 407},
  [1320] = {.lex_state = 308},
  [1321] = {.lex_state = 389},
  [1322] = {.lex_state = 308},
  [1323] = {.lex_state = 380},
  [1324] = {.lex_state = 380},
  [1325] = {.lex_state = 407},
  [1326] = {.lex_state = 308},
  [1327] = {.lex_state = 308},
  [1328] = {.lex_state = 389},
  [1329] = {.lex_state = 389},
  [1330] = {.lex_state = 421},
  [1331] = {.lex_state = 424},
  [1332] = {.lex_state = 424},
  [1333] = {.lex_state = 424},
  [1334] = {.lex_state = 424},
  [1335] = {.lex_state = 424},
  [1336] = {.lex_state = 424},
  [1337] = {.lex_state = 424},
  [1338] = {.lex_state = 424},
  [1339] = {.lex_state = 377},
  [1340] = {.lex_state = 425},
  [1341] = {.lex_state = 377},
  [1342] = {.lex_state = 425},
  [1343] = {.lex_state = 425},
  [1344] = {.lex_state = 425},
  [1345] = {.lex_state = 326},
  [1346] = {.lex_state = 326},
  [1347] = {.lex_state = 425},
  [1348] = {.lex_state = 425},
  [1349] = {.lex_state = 425},
  [1350] = {.lex_state = 326},
  [1351] = {.lex_state = 326},
  [1352] = {.lex_state = 425},
  [1353] = {.lex_state = 425},
  [1354] = {.lex_state = 425},
  [1355] = {.lex_state = 326},
  [1356] = {.lex_state = 326},
  [1357] = {.lex_state = 425},
  [1358] = {.lex_state = 425},
  [1359] = {.lex_state = 308},
  [1360] = {.lex_state = 407},
  [1361] = {.lex_state = 407},
  [1362] = {.lex_state = 425},
  [1363] = {.lex_state = 407},
  [1364] = {.lex_state = 389},
  [1365] = {.lex_state = 389},
  [1366] = {.lex_state = 308},
  [1367] = {.lex_state = 389},
  [1368] = {.lex_state = 425},
  [1369] = {.lex_state = 424},
  [1370] = {.lex_state = 428},
  [1371] = {.lex_state = 380},
  [1372] = {.lex_state = 291},
  [1373] = {.lex_state = 291},
  [1374] = {.lex_state = 389},
  [1375] = {.lex_state = 308},
  [1376] = {.lex_state = 291},
  [1377] = {.lex_state = 407},
  [1378] = {.lex_state = 291},
  [1379] = {.lex_state = 389},
  [1380] = {.lex_state = 291},
  [1381] = {.lex_state = 291},
  [1382] = {.lex_state = 308},
  [1383] = {.lex_state = 308},
  [1384] = {.lex_state = 428},
  [1385] = {.lex_state = 308},
  [1386] = {.lex_state = 291},
  [1387] = {.lex_state = 424},
  [1388] = {.lex_state = 424},
  [1389] = {.lex_state = 308},
  [1390] = {.lex_state = 407},
  [1391] = {.lex_state = 308},
  [1392] = {.lex_state = 389},
  [1393] = {.lex_state = 308},
  [1394] = {.lex_state = 427},
  [1395] = {.lex_state = 308},
  [1396] = {.lex_state = 308},
  [1397] = {.lex_state = 380},
  [1398] = {.lex_state = 326},
  [1399] = {.lex_state = 351},
  [1400] = {.lex_state = 427},
  [1401] = {.lex_state = 308},
  [1402] = {.lex_state = 308},
  [1403] = {.lex_state = 291},
  [1404] = {.lex_state = 389},
  [1405] = {.lex_state = 308},
  [1406] = {.lex_state = 427},
  [1407] = {.lex_state = 427},
  [1408] = {.lex_state = 427},
  [1409] = {.lex_state = 380},
  [1410] = {.lex_state = 308},
  [1411] = {.lex_state = 389},
  [1412] = {.lex_state = 389},
  [1413] = {.lex_state = 308},
  [1414] = {.lex_state = 380},
  [1415] = {.lex_state = 389},
  [1416] = {.lex_state = 385},
  [1417] = {.lex_state = 407},
  [1418] = {.lex_state = 407},
  [1419] = {.lex_state = 407},
  [1420] = {.lex_state = 308},
  [1421] = {.lex_state = 308},
  [1422] = {.lex_state = 389},
  [1423] = {.lex_state = 380},
  [1424] = {.lex_state = 407},
  [1425] = {.lex_state = 308},
  [1426] = {.lex_state = 308},
  [1427] = {.lex_state = 425},
  [1428] = {.lex_state = 425},
  [1429] = {.lex_state = 425},
  [1430] = {.lex_state = 425},
  [1431] = {.lex_state = 425},
  [1432] = {.lex_state = 425},
  [1433] = {.lex_state = 425},
  [1434] = {.lex_state = 425},
  [1435] = {.lex_state = 425},
  [1436] = {.lex_state = 429},
  [1437] = {.lex_state = 380},
  [1438] = {.lex_state = 291},
  [1439] = {.lex_state = 291},
  [1440] = {.lex_state = 389},
  [1441] = {.lex_state = 308},
  [1442] = {.lex_state = 291},
  [1443] = {.lex_state = 407},
  [1444] = {.lex_state = 291},
  [1445] = {.lex_state = 389},
  [1446] = {.lex_state = 291},
  [1447] = {.lex_state = 291},
  [1448] = {.lex_state = 308},
  [1449] = {.lex_state = 308},
  [1450] = {.lex_state = 429},
  [1451] = {.lex_state = 308},
  [1452] = {.lex_state = 291},
  [1453] = {.lex_state = 425},
  [1454] = {.lex_state = 425},
  [1455] = {.lex_state = 308},
  [1456] = {.lex_state = 407},
  [1457] = {.lex_state = 308},
  [1458] = {.lex_state = 389},
  [1459] = {.lex_state = 308},
  [1460] = {.lex_state = 428},
  [1461] = {.lex_state = 380},
  [1462] = {.lex_state = 389},
  [1463] = {.lex_state = 389},
  [1464] = {.lex_state = 308},
  [1465] = {.lex_state = 380},
  [1466] = {.lex_state = 389},
  [1467] = {.lex_state = 380},
  [1468] = {.lex_state = 385},
  [1469] = {.lex_state = 428},
  [1470] = {.lex_state = 308},
  [1471] = {.lex_state = 428},
  [1472] = {.lex_state = 428},
  [1473] = {.lex_state = 291},
  [1474] = {.lex_state = 407},
  [1475] = {.lex_state = 407},
  [1476] = {.lex_state = 428},
  [1477] = {.lex_state = 424},
  [1478] = {.lex_state = 424},
  [1479] = {.lex_state = 407},
  [1480] = {.lex_state = 308},
  [1481] = {.lex_state = 308},
  [1482] = {.lex_state = 389},
  [1483] = {.lex_state = 407},
  [1484] = {.lex_state = 407},
  [1485] = {.lex_state = 427},
  [1486] = {.lex_state = 308},
  [1487] = {.lex_state = 326},
  [1488] = {.lex_state = 308},
  [1489] = {.lex_state = 308},
  [1490] = {.lex_state = 407},
  [1491] = {.lex_state = 389},
  [1492] = {.lex_state = 389},
  [1493] = {.lex_state = 308},
  [1494] = {.lex_state = 389},
  [1495] = {.lex_state = 308},
  [1496] = {.lex_state = 308},
  [1497] = {.lex_state = 380},
  [1498] = {.lex_state = 351},
  [1499] = {.lex_state = 308},
  [1500] = {.lex_state = 389},
  [1501] = {.lex_state = 308},
  [1502] = {.lex_state = 407},
  [1503] = {.lex_state = 308},
  [1504] = {.lex_state = 308},
  [1505] = {.lex_state = 380},
  [1506] = {.lex_state = 407},
  [1507] = {.lex_state = 308},
  [1508] = {.lex_state = 429},
  [1509] = {.lex_state = 380},
  [1510] = {.lex_state = 389},
  [1511] = {.lex_state = 389},
  [1512] = {.lex_state = 308},
  [1513] = {.lex_state = 380},
  [1514] = {.lex_state = 389},
  [1515] = {.lex_state = 380},
  [1516] = {.lex_state = 385},
  [1517] = {.lex_state = 429},
  [1518] = {.lex_state = 308},
  [1519] = {.lex_state = 429},
  [1520] = {.lex_state = 429},
  [1521] = {.lex_state = 291},
  [1522] = {.lex_state = 407},
  [1523] = {.lex_state = 407},
  [1524] = {.lex_state = 429},
  [1525] = {.lex_state = 425},
  [1526] = {.lex_state = 425},
  [1527] = {.lex_state = 407},
  [1528] = {.lex_state = 308},
  [1529] = {.lex_state = 308},
  [1530] = {.lex_state = 389},
  [1531] = {.lex_state = 428},
  [1532] = {.lex_state = 308},
  [1533] = {.lex_state = 308},
  [1534] = {.lex_state = 380},
  [1535] = {.lex_state = 326},
  [1536] = {.lex_state = 351},
  [1537] = {.lex_state = 428},
  [1538] = {.lex_state = 308},
  [1539] = {.lex_state = 308},
  [1540] = {.lex_state = 291},
  [1541] = {.lex_state = 389},
  [1542] = {.lex_state = 308},
  [1543] = {.lex_state = 428},
  [1544] = {.lex_state = 428},
  [1545] = {.lex_state = 428},
  [1546] = {.lex_state = 424},
  [1547] = {.lex_state = 424},
  [1548] = {.lex_state = 407},
  [1549] = {.lex_state = 308},
  [1550] = {.lex_state = 308},
  [1551] = {.lex_state = 427},
  [1552] = {.lex_state = 427},
  [1553] = {.lex_state = 308},
  [1554] = {.lex_state = 308},
  [1555] = {.lex_state = 427},
  [1556] = {.lex_state = 308},
  [1557] = {.lex_state = 427},
  [1558] = {.lex_state = 308},
  [1559] = {.lex_state = 407},
  [1560] = {.lex_state = 308},
  [1561] = {.lex_state = 389},
  [1562] = {.lex_state = 308},
  [1563] = {.lex_state = 407},
  [1564] = {.lex_state = 407},
  [1565] = {.lex_state = 407},
  [1566] = {.lex_state = 389},
  [1567] = {.lex_state = 308},
  [1568] = {.lex_state = 389},
  [1569] = {.lex_state = 407},
  [1570] = {.lex_state = 308},
  [1571] = {.lex_state = 380},
  [1572] = {.lex_state = 407},
  [1573] = {.lex_state = 429},
  [1574] = {.lex_state = 308},
  [1575] = {.lex_state = 308},
  [1576] = {.lex_state = 380},
  [1577] = {.lex_state = 326},
  [1578] = {.lex_state = 351},
  [1579] = {.lex_state = 429},
  [1580] = {.lex_state = 308},
  [1581] = {.lex_state = 308},
  [1582] = {.lex_state = 291},
  [1583] = {.lex_state = 389},
  [1584] = {.lex_state = 308},
  [1585] = {.lex_state = 429},
  [1586] = {.lex_state = 429},
  [1587] = {.lex_state = 429},
  [1588] = {.lex_state = 425},
  [1589] = {.lex_state = 425},
  [1590] = {.lex_state = 407},
  [1591] = {.lex_state = 308},
  [1592] = {.lex_state = 308},
  [1593] = {.lex_state = 407},
  [1594] = {.lex_state = 407},
  [1595] = {.lex_state = 428},
  [1596] = {.lex_state = 308},
  [1597] = {.lex_state = 326},
  [1598] = {.lex_state = 308},
  [1599] = {.lex_state = 308},
  [1600] = {.lex_state = 407},
  [1601] = {.lex_state = 389},
  [1602] = {.lex_state = 389},
  [1603] = {.lex_state = 308},
  [1604] = {.lex_state = 389},
  [1605] = {.lex_state = 424},
  [1606] = {.lex_state = 407},
  [1607] = {.lex_state = 308},
  [1608] = {.lex_state = 407},
  [1609] = {.lex_state = 427},
  [1610] = {.lex_state = 308},
  [1611] = {.lex_state = 427},
  [1612] = {.lex_state = 427},
  [1613] = {.lex_state = 427},
  [1614] = {.lex_state = 407},
  [1615] = {.lex_state = 308},
  [1616] = {.lex_state = 308},
  [1617] = {.lex_state = 389},
  [1618] = {.lex_state = 427},
  [1619] = {.lex_state = 407},
  [1620] = {.lex_state = 308},
  [1621] = {.lex_state = 389},
  [1622] = {.lex_state = 308},
  [1623] = {.lex_state = 407},
  [1624] = {.lex_state = 380},
  [1625] = {.lex_state = 407},
  [1626] = {.lex_state = 407},
  [1627] = {.lex_state = 429},
  [1628] = {.lex_state = 308},
  [1629] = {.lex_state = 326},
  [1630] = {.lex_state = 308},
  [1631] = {.lex_state = 308},
  [1632] = {.lex_state = 407},
  [1633] = {.lex_state = 389},
  [1634] = {.lex_state = 389},
  [1635] = {.lex_state = 308},
  [1636] = {.lex_state = 389},
  [1637] = {.lex_state = 425},
  [1638] = {.lex_state = 407},
  [1639] = {.lex_state = 308},
  [1640] = {.lex_state = 428},
  [1641] = {.lex_state = 428},
  [1642] = {.lex_state = 308},
  [1643] = {.lex_state = 308},
  [1644] = {.lex_state = 428},
  [1645] = {.lex_state = 308},
  [1646] = {.lex_state = 428},
  [1647] = {.lex_state = 308},
  [1648] = {.lex_state = 407},
  [1649] = {.lex_state = 308},
  [1650] = {.lex_state = 389},
  [1651] = {.lex_state = 308},
  [1652] = {.lex_state = 424},
  [1653] = {.lex_state = 407},
  [1654] = {.lex_state = 427},
  [1655] = {.lex_state = 427},
  [1656] = {.lex_state = 427},
  [1657] = {.lex_state = 407},
  [1658] = {.lex_state = 308},
  [1659] = {.lex_state = 308},
  [1660] = {.lex_state = 407},
  [1661] = {.lex_state = 407},
  [1662] = {.lex_state = 308},
  [1663] = {.lex_state = 308},
  [1664] = {.lex_state = 389},
  [1665] = {.lex_state = 429},
  [1666] = {.lex_state = 429},
  [1667] = {.lex_state = 308},
  [1668] = {.lex_state = 308},
  [1669] = {.lex_state = 429},
  [1670] = {.lex_state = 308},
  [1671] = {.lex_state = 429},
  [1672] = {.lex_state = 308},
  [1673] = {.lex_state = 407},
  [1674] = {.lex_state = 308},
  [1675] = {.lex_state = 389},
  [1676] = {.lex_state = 308},
  [1677] = {.lex_state = 425},
  [1678] = {.lex_state = 407},
  [1679] = {.lex_state = 407},
  [1680] = {.lex_state = 428},
  [1681] = {.lex_state = 308},
  [1682] = {.lex_state = 428},
  [1683] = {.lex_state = 428},
  [1684] = {.lex_state = 428},
  [1685] = {.lex_state = 407},
  [1686] = {.lex_state = 308},
  [1687] = {.lex_state = 308},
  [1688] = {.lex_state = 389},
  [1689] = {.lex_state = 424},
  [1690] = {.lex_state = 427},
  [1691] = {.lex_state = 407},
  [1692] = {.lex_state = 308},
  [1693] = {.lex_state = 407},
  [1694] = {.lex_state = 308},
  [1695] = {.lex_state = 308},
  [1696] = {.lex_state = 407},
  [1697] = {.lex_state = 429},
  [1698] = {.lex_state = 308},
  [1699] = {.lex_state = 429},
  [1700] = {.lex_state = 429},
  [1701] = {.lex_state = 429},
  [1702] = {.lex_state = 407},
  [1703] = {.lex_state = 308},
  [1704] = {.lex_state = 308},
  [1705] = {.lex_state = 389},
  [1706] = {.lex_state = 425},
  [1707] = {.lex_state = 428},
  [1708] = {.lex_state = 428},
  [1709] = {.lex_state = 428},
  [1710] = {.lex_state = 407},
  [1711] = {.lex_state = 308},
  [1712] = {.lex_state = 308},
  [1713] = {.lex_state = 427},
  [1714] = {.lex_state = 407},
  [1715] = {.lex_state = 407},
  [1716] = {.lex_state = 308},
  [1717] = {.lex_state = 429},
  [1718] = {.lex_state = 429},
  [1719] = {.lex_state = 429},
  [1720] = {.lex_state = 407},
  [1721] = {.lex_state = 308},
  [1722] = {.lex_state = 308},
  [1723] = {.lex_state = 428},
  [1724] = {.lex_state = 407},
  [1725] = {.lex_state = 308},
  [1726] = {.lex_state = 427},
  [1727] = {.lex_state = 407},
  [1728] = {.lex_state = 429},
  [1729] = {.lex_state = 407},
  [1730] = {.lex_state = 308},
  [1731] = {.lex_state = 428},
  [1732] = {.lex_state = 407},
  [1733] = {.lex_state = 429},
  [1734] = {.lex_state = 407},
  [1735] = {.lex_state = 428},
  [1736] = {.lex_state = 429},
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3),
    [sym_preproc_directive] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_typedef] = ACTIONS(3),
    [anon_sym_extern] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(3),
    [anon_sym_auto] = ACTIONS(3),
    [anon_sym_register] = ACTIONS(3),
    [anon_sym_inline] = ACTIONS(3),
    [anon_sym_const] = ACTIONS(3),
    [anon_sym_restrict] = ACTIONS(3),
    [anon_sym_volatile] = ACTIONS(3),
    [anon_sym__Atomic] = ACTIONS(3),
    [anon_sym_unsigned] = ACTIONS(3),
    [anon_sym_long] = ACTIONS(3),
    [anon_sym_short] = ACTIONS(3),
    [sym_primitive_type] = ACTIONS(3),
    [anon_sym_enum] = ACTIONS(3),
    [anon_sym_struct] = ACTIONS(3),
    [anon_sym_union] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(3),
    [anon_sym_else] = ACTIONS(3),
    [anon_sym_switch] = ACTIONS(3),
    [anon_sym_case] = ACTIONS(3),
    [anon_sym_default] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3),
    [anon_sym_for] = ACTIONS(3),
    [anon_sym_return] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(3),
    [anon_sym_continue] = ACTIONS(3),
    [anon_sym_goto] = ACTIONS(3),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(3),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(3),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(3),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_LT_EQ] = ACTIONS(3),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(3),
    [anon_sym_SLASH] = ACTIONS(3),
    [anon_sym_PERCENT] = ACTIONS(3),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [sym_number_literal] = ACTIONS(1),
    [sym_char_literal] = ACTIONS(1),
    [sym_string_literal] = ACTIONS(1),
    [sym_system_lib_string] = ACTIONS(1),
    [sym_true] = ACTIONS(3),
    [sym_false] = ACTIONS(3),
    [sym_null] = ACTIONS(3),
    [sym_identifier] = ACTIONS(3),
    [sym_comment] = ACTIONS(5),
  },
  [1] = {
    [sym_translation_unit] = STATE(16),
    [sym_preproc_include] = STATE(19),
    [sym_preproc_def] = STATE(19),
    [sym_preproc_function_def] = STATE(19),
    [sym_preproc_call] = STATE(19),
    [sym_preproc_if] = STATE(19),
    [sym_preproc_ifdef] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_declaration] = STATE(19),
    [sym_type_definition] = STATE(19),
    [sym__declaration_specifiers] = STATE(17),
    [sym_linkage_specification] = STATE(19),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(19),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(19),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [ts_builtin_sym_end] = ACTIONS(8),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(10),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(12),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(14),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(16),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(18),
    [sym_preproc_directive] = ACTIONS(20),
    [anon_sym_typedef] = ACTIONS(22),
    [anon_sym_extern] = ACTIONS(24),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [2] = {
    [sym_string_literal] = ACTIONS(44),
    [sym_system_lib_string] = ACTIONS(44),
    [sym_comment] = ACTIONS(42),
  },
  [3] = {
    [sym_identifier] = ACTIONS(46),
    [sym_comment] = ACTIONS(42),
  },
  [4] = {
    [sym_preproc_arg] = ACTIONS(48),
    [sym_comment] = ACTIONS(50),
  },
  [5] = {
    [sym_identifier] = ACTIONS(52),
    [sym_comment] = ACTIONS(42),
  },
  [6] = {
    [sym_identifier] = ACTIONS(54),
    [sym_comment] = ACTIONS(42),
  },
  [7] = {
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(56),
    [anon_sym_LF] = ACTIONS(58),
    [sym_comment] = ACTIONS(50),
  },
  [8] = {
    [sym_type_qualifier] = STATE(35),
    [sym__type_specifier] = STATE(34),
    [sym_sized_type_specifier] = STATE(34),
    [sym_enum_specifier] = STATE(34),
    [sym_struct_specifier] = STATE(34),
    [sym_union_specifier] = STATE(34),
    [sym_macro_type_specifier] = STATE(34),
    [aux_sym_type_definition_repeat1] = STATE(35),
    [aux_sym_sized_type_specifier_repeat1] = STATE(36),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(62),
    [anon_sym_long] = ACTIONS(62),
    [anon_sym_short] = ACTIONS(62),
    [sym_primitive_type] = ACTIONS(64),
    [anon_sym_enum] = ACTIONS(66),
    [anon_sym_struct] = ACTIONS(68),
    [anon_sym_union] = ACTIONS(70),
    [sym_identifier] = ACTIONS(72),
    [sym_comment] = ACTIONS(42),
  },
  [9] = {
    [anon_sym_extern] = ACTIONS(74),
    [anon_sym_static] = ACTIONS(74),
    [anon_sym_auto] = ACTIONS(74),
    [anon_sym_register] = ACTIONS(74),
    [anon_sym_inline] = ACTIONS(74),
    [anon_sym_const] = ACTIONS(74),
    [anon_sym_restrict] = ACTIONS(74),
    [anon_sym_volatile] = ACTIONS(74),
    [anon_sym__Atomic] = ACTIONS(74),
    [anon_sym_unsigned] = ACTIONS(74),
    [anon_sym_long] = ACTIONS(74),
    [anon_sym_short] = ACTIONS(74),
    [sym_primitive_type] = ACTIONS(74),
    [anon_sym_enum] = ACTIONS(74),
    [anon_sym_struct] = ACTIONS(74),
    [anon_sym_union] = ACTIONS(74),
    [sym_string_literal] = ACTIONS(76),
    [sym_identifier] = ACTIONS(74),
    [sym_comment] = ACTIONS(42),
  },
  [10] = {
    [anon_sym_extern] = ACTIONS(74),
    [anon_sym_static] = ACTIONS(74),
    [anon_sym_auto] = ACTIONS(74),
    [anon_sym_register] = ACTIONS(74),
    [anon_sym_inline] = ACTIONS(74),
    [anon_sym_const] = ACTIONS(74),
    [anon_sym_restrict] = ACTIONS(74),
    [anon_sym_volatile] = ACTIONS(74),
    [anon_sym__Atomic] = ACTIONS(74),
    [anon_sym_unsigned] = ACTIONS(74),
    [anon_sym_long] = ACTIONS(74),
    [anon_sym_short] = ACTIONS(74),
    [sym_primitive_type] = ACTIONS(74),
    [anon_sym_enum] = ACTIONS(74),
    [anon_sym_struct] = ACTIONS(74),
    [anon_sym_union] = ACTIONS(74),
    [sym_identifier] = ACTIONS(74),
    [sym_comment] = ACTIONS(42),
  },
  [11] = {
    [anon_sym_extern] = ACTIONS(78),
    [anon_sym_static] = ACTIONS(78),
    [anon_sym_auto] = ACTIONS(78),
    [anon_sym_register] = ACTIONS(78),
    [anon_sym_inline] = ACTIONS(78),
    [anon_sym_const] = ACTIONS(78),
    [anon_sym_restrict] = ACTIONS(78),
    [anon_sym_volatile] = ACTIONS(78),
    [anon_sym__Atomic] = ACTIONS(78),
    [anon_sym_unsigned] = ACTIONS(78),
    [anon_sym_long] = ACTIONS(78),
    [anon_sym_short] = ACTIONS(78),
    [sym_primitive_type] = ACTIONS(78),
    [anon_sym_enum] = ACTIONS(78),
    [anon_sym_struct] = ACTIONS(78),
    [anon_sym_union] = ACTIONS(78),
    [sym_identifier] = ACTIONS(78),
    [sym_comment] = ACTIONS(42),
  },
  [12] = {
    [sym_enumerator_list] = STATE(40),
    [anon_sym_LBRACE] = ACTIONS(80),
    [sym_identifier] = ACTIONS(82),
    [sym_comment] = ACTIONS(42),
  },
  [13] = {
    [sym_field_declaration_list] = STATE(43),
    [anon_sym_LBRACE] = ACTIONS(84),
    [sym_identifier] = ACTIONS(86),
    [sym_comment] = ACTIONS(42),
  },
  [14] = {
    [sym_field_declaration_list] = STATE(45),
    [anon_sym_LBRACE] = ACTIONS(84),
    [sym_identifier] = ACTIONS(88),
    [sym_comment] = ACTIONS(42),
  },
  [15] = {
    [anon_sym_LPAREN] = ACTIONS(90),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(93),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_extern] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_auto] = ACTIONS(95),
    [anon_sym_register] = ACTIONS(95),
    [anon_sym_inline] = ACTIONS(95),
    [anon_sym_const] = ACTIONS(95),
    [anon_sym_restrict] = ACTIONS(95),
    [anon_sym_volatile] = ACTIONS(95),
    [anon_sym__Atomic] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(93),
    [sym_identifier] = ACTIONS(95),
    [sym_comment] = ACTIONS(42),
  },
  [16] = {
    [ts_builtin_sym_end] = ACTIONS(97),
    [sym_comment] = ACTIONS(42),
  },
  [17] = {
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(50),
    [sym_array_declarator] = STATE(50),
    [sym_init_declarator] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(99),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(42),
  },
  [18] = {
    [sym_storage_class_specifier] = STATE(54),
    [sym_type_qualifier] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(54),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_SEMI] = ACTIONS(107),
    [anon_sym_extern] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(107),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_auto] = ACTIONS(109),
    [anon_sym_register] = ACTIONS(109),
    [anon_sym_inline] = ACTIONS(109),
    [anon_sym_const] = ACTIONS(111),
    [anon_sym_restrict] = ACTIONS(111),
    [anon_sym_volatile] = ACTIONS(111),
    [anon_sym__Atomic] = ACTIONS(111),
    [sym_identifier] = ACTIONS(113),
    [sym_comment] = ACTIONS(42),
  },
  [19] = {
    [sym_preproc_include] = STATE(55),
    [sym_preproc_def] = STATE(55),
    [sym_preproc_function_def] = STATE(55),
    [sym_preproc_call] = STATE(55),
    [sym_preproc_if] = STATE(55),
    [sym_preproc_ifdef] = STATE(55),
    [sym_function_definition] = STATE(55),
    [sym_declaration] = STATE(55),
    [sym_type_definition] = STATE(55),
    [sym__declaration_specifiers] = STATE(17),
    [sym_linkage_specification] = STATE(55),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(55),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(55),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [ts_builtin_sym_end] = ACTIONS(115),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(10),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(12),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(14),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(16),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(18),
    [sym_preproc_directive] = ACTIONS(20),
    [anon_sym_typedef] = ACTIONS(22),
    [anon_sym_extern] = ACTIONS(24),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [20] = {
    [sym_storage_class_specifier] = STATE(57),
    [sym_type_qualifier] = STATE(57),
    [sym__type_specifier] = STATE(56),
    [sym_sized_type_specifier] = STATE(56),
    [sym_enum_specifier] = STATE(56),
    [sym_struct_specifier] = STATE(56),
    [sym_union_specifier] = STATE(56),
    [sym_macro_type_specifier] = STATE(56),
    [aux_sym__declaration_specifiers_repeat1] = STATE(57),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(117),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [21] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(60),
    [anon_sym_LPAREN] = ACTIONS(119),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_extern] = ACTIONS(121),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_static] = ACTIONS(121),
    [anon_sym_auto] = ACTIONS(121),
    [anon_sym_register] = ACTIONS(121),
    [anon_sym_inline] = ACTIONS(121),
    [anon_sym_const] = ACTIONS(121),
    [anon_sym_restrict] = ACTIONS(121),
    [anon_sym_volatile] = ACTIONS(121),
    [anon_sym__Atomic] = ACTIONS(121),
    [anon_sym_unsigned] = ACTIONS(123),
    [anon_sym_long] = ACTIONS(123),
    [anon_sym_short] = ACTIONS(123),
    [sym_primitive_type] = ACTIONS(125),
    [sym_identifier] = ACTIONS(127),
    [sym_comment] = ACTIONS(42),
  },
  [22] = {
    [ts_builtin_sym_end] = ACTIONS(130),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(132),
    [sym_preproc_directive] = ACTIONS(132),
    [anon_sym_typedef] = ACTIONS(132),
    [anon_sym_extern] = ACTIONS(132),
    [anon_sym_RBRACE] = ACTIONS(130),
    [anon_sym_static] = ACTIONS(132),
    [anon_sym_auto] = ACTIONS(132),
    [anon_sym_register] = ACTIONS(132),
    [anon_sym_inline] = ACTIONS(132),
    [anon_sym_const] = ACTIONS(132),
    [anon_sym_restrict] = ACTIONS(132),
    [anon_sym_volatile] = ACTIONS(132),
    [anon_sym__Atomic] = ACTIONS(132),
    [anon_sym_unsigned] = ACTIONS(132),
    [anon_sym_long] = ACTIONS(132),
    [anon_sym_short] = ACTIONS(132),
    [sym_primitive_type] = ACTIONS(132),
    [anon_sym_enum] = ACTIONS(132),
    [anon_sym_struct] = ACTIONS(132),
    [anon_sym_union] = ACTIONS(132),
    [sym_identifier] = ACTIONS(132),
    [sym_comment] = ACTIONS(42),
  },
  [23] = {
    [sym_preproc_params] = STATE(64),
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(134),
    [anon_sym_LF] = ACTIONS(136),
    [anon_sym_LPAREN] = ACTIONS(138),
    [sym_comment] = ACTIONS(50),
  },
  [24] = {
    [sym_preproc_include] = STATE(78),
    [sym_preproc_def] = STATE(78),
    [sym_preproc_function_def] = STATE(78),
    [sym_preproc_call] = STATE(78),
    [sym_preproc_if] = STATE(78),
    [sym_preproc_ifdef] = STATE(78),
    [sym_preproc_else] = STATE(76),
    [sym_preproc_elif] = STATE(76),
    [sym_function_definition] = STATE(78),
    [sym_declaration] = STATE(78),
    [sym_type_definition] = STATE(78),
    [sym__declaration_specifiers] = STATE(77),
    [sym_linkage_specification] = STATE(78),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(78),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(78),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(140),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(142),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(146),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(148),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(150),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(152),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(154),
    [sym_preproc_directive] = ACTIONS(156),
    [anon_sym_typedef] = ACTIONS(158),
    [anon_sym_extern] = ACTIONS(160),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [25] = {
    [sym_preproc_include] = STATE(81),
    [sym_preproc_def] = STATE(81),
    [sym_preproc_function_def] = STATE(81),
    [sym_preproc_call] = STATE(81),
    [sym_preproc_if] = STATE(81),
    [sym_preproc_ifdef] = STATE(81),
    [sym_preproc_else] = STATE(80),
    [sym_preproc_elif] = STATE(80),
    [sym_function_definition] = STATE(81),
    [sym_declaration] = STATE(81),
    [sym_type_definition] = STATE(81),
    [sym__declaration_specifiers] = STATE(77),
    [sym_linkage_specification] = STATE(81),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(81),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(140),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(142),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(162),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(148),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(150),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(152),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(154),
    [sym_preproc_directive] = ACTIONS(156),
    [anon_sym_typedef] = ACTIONS(158),
    [anon_sym_extern] = ACTIONS(160),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [26] = {
    [sym_preproc_include] = STATE(84),
    [sym_preproc_def] = STATE(84),
    [sym_preproc_function_def] = STATE(84),
    [sym_preproc_call] = STATE(84),
    [sym_preproc_if] = STATE(84),
    [sym_preproc_ifdef] = STATE(84),
    [sym_preproc_else] = STATE(83),
    [sym_preproc_elif] = STATE(83),
    [sym_function_definition] = STATE(84),
    [sym_declaration] = STATE(84),
    [sym_type_definition] = STATE(84),
    [sym__declaration_specifiers] = STATE(77),
    [sym_linkage_specification] = STATE(84),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(84),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(84),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(140),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(142),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(164),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(148),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(150),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(152),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(154),
    [sym_preproc_directive] = ACTIONS(156),
    [anon_sym_typedef] = ACTIONS(158),
    [anon_sym_extern] = ACTIONS(160),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [27] = {
    [sym_preproc_arg] = ACTIONS(166),
    [sym_comment] = ACTIONS(50),
  },
  [28] = {
    [ts_builtin_sym_end] = ACTIONS(168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(170),
    [sym_preproc_directive] = ACTIONS(170),
    [anon_sym_typedef] = ACTIONS(170),
    [anon_sym_extern] = ACTIONS(170),
    [anon_sym_RBRACE] = ACTIONS(168),
    [anon_sym_static] = ACTIONS(170),
    [anon_sym_auto] = ACTIONS(170),
    [anon_sym_register] = ACTIONS(170),
    [anon_sym_inline] = ACTIONS(170),
    [anon_sym_const] = ACTIONS(170),
    [anon_sym_restrict] = ACTIONS(170),
    [anon_sym_volatile] = ACTIONS(170),
    [anon_sym__Atomic] = ACTIONS(170),
    [anon_sym_unsigned] = ACTIONS(170),
    [anon_sym_long] = ACTIONS(170),
    [anon_sym_short] = ACTIONS(170),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(170),
    [anon_sym_struct] = ACTIONS(170),
    [anon_sym_union] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_comment] = ACTIONS(42),
  },
  [29] = {
    [anon_sym_const] = ACTIONS(78),
    [anon_sym_restrict] = ACTIONS(78),
    [anon_sym_volatile] = ACTIONS(78),
    [anon_sym__Atomic] = ACTIONS(78),
    [anon_sym_unsigned] = ACTIONS(78),
    [anon_sym_long] = ACTIONS(78),
    [anon_sym_short] = ACTIONS(78),
    [sym_primitive_type] = ACTIONS(78),
    [anon_sym_enum] = ACTIONS(78),
    [anon_sym_struct] = ACTIONS(78),
    [anon_sym_union] = ACTIONS(78),
    [sym_identifier] = ACTIONS(78),
    [sym_comment] = ACTIONS(42),
  },
  [30] = {
    [sym_enumerator_list] = STATE(88),
    [anon_sym_LBRACE] = ACTIONS(172),
    [sym_identifier] = ACTIONS(174),
    [sym_comment] = ACTIONS(42),
  },
  [31] = {
    [sym_field_declaration_list] = STATE(91),
    [anon_sym_LBRACE] = ACTIONS(176),
    [sym_identifier] = ACTIONS(178),
    [sym_comment] = ACTIONS(42),
  },
  [32] = {
    [sym_field_declaration_list] = STATE(93),
    [anon_sym_LBRACE] = ACTIONS(176),
    [sym_identifier] = ACTIONS(180),
    [sym_comment] = ACTIONS(42),
  },
  [33] = {
    [anon_sym_LPAREN] = ACTIONS(182),
    [anon_sym_STAR] = ACTIONS(93),
    [sym_identifier] = ACTIONS(93),
    [sym_comment] = ACTIONS(42),
  },
  [34] = {
    [sym__type_declarator] = STATE(98),
    [sym_pointer_type_declarator] = STATE(99),
    [sym_function_type_declarator] = STATE(100),
    [sym_array_type_declarator] = STATE(101),
    [anon_sym_LPAREN] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(187),
    [sym_identifier] = ACTIONS(189),
    [sym_comment] = ACTIONS(42),
  },
  [35] = {
    [sym_type_qualifier] = STATE(103),
    [sym__type_specifier] = STATE(102),
    [sym_sized_type_specifier] = STATE(102),
    [sym_enum_specifier] = STATE(102),
    [sym_struct_specifier] = STATE(102),
    [sym_union_specifier] = STATE(102),
    [sym_macro_type_specifier] = STATE(102),
    [aux_sym_type_definition_repeat1] = STATE(103),
    [aux_sym_sized_type_specifier_repeat1] = STATE(36),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(62),
    [anon_sym_long] = ACTIONS(62),
    [anon_sym_short] = ACTIONS(62),
    [sym_primitive_type] = ACTIONS(191),
    [anon_sym_enum] = ACTIONS(66),
    [anon_sym_struct] = ACTIONS(68),
    [anon_sym_union] = ACTIONS(70),
    [sym_identifier] = ACTIONS(72),
    [sym_comment] = ACTIONS(42),
  },
  [36] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(106),
    [anon_sym_LPAREN] = ACTIONS(119),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_unsigned] = ACTIONS(193),
    [anon_sym_long] = ACTIONS(193),
    [anon_sym_short] = ACTIONS(193),
    [sym_primitive_type] = ACTIONS(195),
    [sym_identifier] = ACTIONS(197),
    [sym_comment] = ACTIONS(42),
  },
  [37] = {
    [sym_function_definition] = STATE(108),
    [sym_declaration] = STATE(108),
    [sym__declaration_specifiers] = STATE(109),
    [sym_declaration_list] = STATE(108),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(200),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [38] = {
    [sym_enumerator] = STATE(116),
    [anon_sym_COMMA] = ACTIONS(206),
    [anon_sym_RBRACE] = ACTIONS(208),
    [sym_identifier] = ACTIONS(210),
    [sym_comment] = ACTIONS(42),
  },
  [39] = {
    [sym_enumerator_list] = STATE(117),
    [anon_sym_LPAREN] = ACTIONS(212),
    [anon_sym_COMMA] = ACTIONS(212),
    [anon_sym_RPAREN] = ACTIONS(212),
    [anon_sym_SEMI] = ACTIONS(212),
    [anon_sym_extern] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(80),
    [anon_sym_STAR] = ACTIONS(212),
    [anon_sym_LBRACK] = ACTIONS(212),
    [anon_sym_static] = ACTIONS(214),
    [anon_sym_auto] = ACTIONS(214),
    [anon_sym_register] = ACTIONS(214),
    [anon_sym_inline] = ACTIONS(214),
    [anon_sym_const] = ACTIONS(214),
    [anon_sym_restrict] = ACTIONS(214),
    [anon_sym_volatile] = ACTIONS(214),
    [anon_sym__Atomic] = ACTIONS(214),
    [anon_sym_COLON] = ACTIONS(212),
    [sym_identifier] = ACTIONS(214),
    [sym_comment] = ACTIONS(42),
  },
  [40] = {
    [anon_sym_LPAREN] = ACTIONS(216),
    [anon_sym_COMMA] = ACTIONS(216),
    [anon_sym_RPAREN] = ACTIONS(216),
    [anon_sym_SEMI] = ACTIONS(216),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(216),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_auto] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(218),
    [anon_sym_restrict] = ACTIONS(218),
    [anon_sym_volatile] = ACTIONS(218),
    [anon_sym__Atomic] = ACTIONS(218),
    [anon_sym_COLON] = ACTIONS(216),
    [sym_identifier] = ACTIONS(218),
    [sym_comment] = ACTIONS(42),
  },
  [41] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(122),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(123),
    [sym__declaration_specifiers] = STATE(124),
    [sym_storage_class_specifier] = STATE(126),
    [sym_type_qualifier] = STATE(126),
    [sym__type_specifier] = STATE(125),
    [sym_sized_type_specifier] = STATE(125),
    [sym_enum_specifier] = STATE(125),
    [sym_struct_specifier] = STATE(125),
    [sym_union_specifier] = STATE(125),
    [sym_field_declaration] = STATE(128),
    [sym_macro_type_specifier] = STATE(125),
    [aux_sym__declaration_specifiers_repeat1] = STATE(126),
    [aux_sym_sized_type_specifier_repeat1] = STATE(127),
    [aux_sym_field_declaration_list_repeat1] = STATE(128),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(220),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(224),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_RBRACE] = ACTIONS(226),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(228),
    [anon_sym_long] = ACTIONS(228),
    [anon_sym_short] = ACTIONS(228),
    [sym_primitive_type] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [42] = {
    [sym_field_declaration_list] = STATE(129),
    [anon_sym_LPAREN] = ACTIONS(232),
    [anon_sym_COMMA] = ACTIONS(232),
    [anon_sym_RPAREN] = ACTIONS(232),
    [anon_sym_SEMI] = ACTIONS(232),
    [anon_sym_extern] = ACTIONS(234),
    [anon_sym_LBRACE] = ACTIONS(84),
    [anon_sym_STAR] = ACTIONS(232),
    [anon_sym_LBRACK] = ACTIONS(232),
    [anon_sym_static] = ACTIONS(234),
    [anon_sym_auto] = ACTIONS(234),
    [anon_sym_register] = ACTIONS(234),
    [anon_sym_inline] = ACTIONS(234),
    [anon_sym_const] = ACTIONS(234),
    [anon_sym_restrict] = ACTIONS(234),
    [anon_sym_volatile] = ACTIONS(234),
    [anon_sym__Atomic] = ACTIONS(234),
    [anon_sym_COLON] = ACTIONS(232),
    [sym_identifier] = ACTIONS(234),
    [sym_comment] = ACTIONS(42),
  },
  [43] = {
    [anon_sym_LPAREN] = ACTIONS(236),
    [anon_sym_COMMA] = ACTIONS(236),
    [anon_sym_RPAREN] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(236),
    [anon_sym_extern] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(236),
    [anon_sym_LBRACK] = ACTIONS(236),
    [anon_sym_static] = ACTIONS(238),
    [anon_sym_auto] = ACTIONS(238),
    [anon_sym_register] = ACTIONS(238),
    [anon_sym_inline] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_restrict] = ACTIONS(238),
    [anon_sym_volatile] = ACTIONS(238),
    [anon_sym__Atomic] = ACTIONS(238),
    [anon_sym_COLON] = ACTIONS(236),
    [sym_identifier] = ACTIONS(238),
    [sym_comment] = ACTIONS(42),
  },
  [44] = {
    [sym_field_declaration_list] = STATE(130),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_COMMA] = ACTIONS(240),
    [anon_sym_RPAREN] = ACTIONS(240),
    [anon_sym_SEMI] = ACTIONS(240),
    [anon_sym_extern] = ACTIONS(242),
    [anon_sym_LBRACE] = ACTIONS(84),
    [anon_sym_STAR] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(240),
    [anon_sym_static] = ACTIONS(242),
    [anon_sym_auto] = ACTIONS(242),
    [anon_sym_register] = ACTIONS(242),
    [anon_sym_inline] = ACTIONS(242),
    [anon_sym_const] = ACTIONS(242),
    [anon_sym_restrict] = ACTIONS(242),
    [anon_sym_volatile] = ACTIONS(242),
    [anon_sym__Atomic] = ACTIONS(242),
    [anon_sym_COLON] = ACTIONS(240),
    [sym_identifier] = ACTIONS(242),
    [sym_comment] = ACTIONS(42),
  },
  [45] = {
    [anon_sym_LPAREN] = ACTIONS(244),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_RPAREN] = ACTIONS(244),
    [anon_sym_SEMI] = ACTIONS(244),
    [anon_sym_extern] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_static] = ACTIONS(246),
    [anon_sym_auto] = ACTIONS(246),
    [anon_sym_register] = ACTIONS(246),
    [anon_sym_inline] = ACTIONS(246),
    [anon_sym_const] = ACTIONS(246),
    [anon_sym_restrict] = ACTIONS(246),
    [anon_sym_volatile] = ACTIONS(246),
    [anon_sym__Atomic] = ACTIONS(246),
    [anon_sym_COLON] = ACTIONS(244),
    [sym_identifier] = ACTIONS(246),
    [sym_comment] = ACTIONS(42),
  },
  [46] = {
    [sym_type_qualifier] = STATE(133),
    [sym__type_specifier] = STATE(131),
    [sym_sized_type_specifier] = STATE(131),
    [sym_enum_specifier] = STATE(131),
    [sym_struct_specifier] = STATE(131),
    [sym_union_specifier] = STATE(131),
    [sym_type_descriptor] = STATE(132),
    [sym_macro_type_specifier] = STATE(131),
    [aux_sym_type_definition_repeat1] = STATE(133),
    [aux_sym_sized_type_specifier_repeat1] = STATE(134),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(248),
    [anon_sym_long] = ACTIONS(248),
    [anon_sym_short] = ACTIONS(248),
    [sym_primitive_type] = ACTIONS(250),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [47] = {
    [sym__declarator] = STATE(136),
    [sym_pointer_declarator] = STATE(136),
    [sym_function_declarator] = STATE(136),
    [sym_array_declarator] = STATE(136),
    [anon_sym_LPAREN] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_comment] = ACTIONS(42),
  },
  [48] = {
    [ts_builtin_sym_end] = ACTIONS(256),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(258),
    [sym_preproc_directive] = ACTIONS(258),
    [anon_sym_typedef] = ACTIONS(258),
    [anon_sym_extern] = ACTIONS(258),
    [anon_sym_RBRACE] = ACTIONS(256),
    [anon_sym_static] = ACTIONS(258),
    [anon_sym_auto] = ACTIONS(258),
    [anon_sym_register] = ACTIONS(258),
    [anon_sym_inline] = ACTIONS(258),
    [anon_sym_const] = ACTIONS(258),
    [anon_sym_restrict] = ACTIONS(258),
    [anon_sym_volatile] = ACTIONS(258),
    [anon_sym__Atomic] = ACTIONS(258),
    [anon_sym_unsigned] = ACTIONS(258),
    [anon_sym_long] = ACTIONS(258),
    [anon_sym_short] = ACTIONS(258),
    [sym_primitive_type] = ACTIONS(258),
    [anon_sym_enum] = ACTIONS(258),
    [anon_sym_struct] = ACTIONS(258),
    [anon_sym_union] = ACTIONS(258),
    [sym_identifier] = ACTIONS(258),
    [sym_comment] = ACTIONS(42),
  },
  [49] = {
    [sym__declarator] = STATE(137),
    [sym_pointer_declarator] = STATE(137),
    [sym_function_declarator] = STATE(137),
    [sym_array_declarator] = STATE(137),
    [anon_sym_LPAREN] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(103),
    [sym_identifier] = ACTIONS(260),
    [sym_comment] = ACTIONS(42),
  },
  [50] = {
    [sym_compound_statement] = STATE(144),
    [sym_parameter_list] = STATE(145),
    [aux_sym_declaration_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_LBRACK] = ACTIONS(270),
    [anon_sym_EQ] = ACTIONS(272),
    [sym_comment] = ACTIONS(42),
  },
  [51] = {
    [aux_sym_declaration_repeat1] = STATE(146),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(266),
    [sym_comment] = ACTIONS(42),
  },
  [52] = {
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_COMMA] = ACTIONS(274),
    [anon_sym_RPAREN] = ACTIONS(274),
    [anon_sym_SEMI] = ACTIONS(274),
    [anon_sym_extern] = ACTIONS(74),
    [anon_sym_STAR] = ACTIONS(274),
    [anon_sym_LBRACK] = ACTIONS(274),
    [anon_sym_static] = ACTIONS(74),
    [anon_sym_auto] = ACTIONS(74),
    [anon_sym_register] = ACTIONS(74),
    [anon_sym_inline] = ACTIONS(74),
    [anon_sym_const] = ACTIONS(74),
    [anon_sym_restrict] = ACTIONS(74),
    [anon_sym_volatile] = ACTIONS(74),
    [anon_sym__Atomic] = ACTIONS(74),
    [anon_sym_COLON] = ACTIONS(274),
    [sym_identifier] = ACTIONS(74),
    [sym_comment] = ACTIONS(42),
  },
  [53] = {
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_COMMA] = ACTIONS(276),
    [anon_sym_RPAREN] = ACTIONS(276),
    [anon_sym_SEMI] = ACTIONS(276),
    [anon_sym_extern] = ACTIONS(78),
    [anon_sym_STAR] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(276),
    [anon_sym_static] = ACTIONS(78),
    [anon_sym_auto] = ACTIONS(78),
    [anon_sym_register] = ACTIONS(78),
    [anon_sym_inline] = ACTIONS(78),
    [anon_sym_const] = ACTIONS(78),
    [anon_sym_restrict] = ACTIONS(78),
    [anon_sym_volatile] = ACTIONS(78),
    [anon_sym__Atomic] = ACTIONS(78),
    [anon_sym_COLON] = ACTIONS(276),
    [sym_identifier] = ACTIONS(78),
    [sym_comment] = ACTIONS(42),
  },
  [54] = {
    [sym_storage_class_specifier] = STATE(147),
    [sym_type_qualifier] = STATE(147),
    [aux_sym__declaration_specifiers_repeat1] = STATE(147),
    [anon_sym_LPAREN] = ACTIONS(278),
    [anon_sym_SEMI] = ACTIONS(278),
    [anon_sym_extern] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_auto] = ACTIONS(109),
    [anon_sym_register] = ACTIONS(109),
    [anon_sym_inline] = ACTIONS(109),
    [anon_sym_const] = ACTIONS(111),
    [anon_sym_restrict] = ACTIONS(111),
    [anon_sym_volatile] = ACTIONS(111),
    [anon_sym__Atomic] = ACTIONS(111),
    [sym_identifier] = ACTIONS(280),
    [sym_comment] = ACTIONS(42),
  },
  [55] = {
    [sym_preproc_include] = STATE(55),
    [sym_preproc_def] = STATE(55),
    [sym_preproc_function_def] = STATE(55),
    [sym_preproc_call] = STATE(55),
    [sym_preproc_if] = STATE(55),
    [sym_preproc_ifdef] = STATE(55),
    [sym_function_definition] = STATE(55),
    [sym_declaration] = STATE(55),
    [sym_type_definition] = STATE(55),
    [sym__declaration_specifiers] = STATE(17),
    [sym_linkage_specification] = STATE(55),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(55),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(55),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [ts_builtin_sym_end] = ACTIONS(282),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(284),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(287),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(296),
    [sym_preproc_directive] = ACTIONS(299),
    [anon_sym_typedef] = ACTIONS(302),
    [anon_sym_extern] = ACTIONS(305),
    [anon_sym_static] = ACTIONS(308),
    [anon_sym_auto] = ACTIONS(308),
    [anon_sym_register] = ACTIONS(308),
    [anon_sym_inline] = ACTIONS(308),
    [anon_sym_const] = ACTIONS(311),
    [anon_sym_restrict] = ACTIONS(311),
    [anon_sym_volatile] = ACTIONS(311),
    [anon_sym__Atomic] = ACTIONS(311),
    [anon_sym_unsigned] = ACTIONS(314),
    [anon_sym_long] = ACTIONS(314),
    [anon_sym_short] = ACTIONS(314),
    [sym_primitive_type] = ACTIONS(317),
    [anon_sym_enum] = ACTIONS(320),
    [anon_sym_struct] = ACTIONS(323),
    [anon_sym_union] = ACTIONS(326),
    [sym_identifier] = ACTIONS(329),
    [sym_comment] = ACTIONS(42),
  },
  [56] = {
    [sym_storage_class_specifier] = STATE(148),
    [sym_type_qualifier] = STATE(148),
    [aux_sym__declaration_specifiers_repeat1] = STATE(148),
    [anon_sym_LPAREN] = ACTIONS(278),
    [anon_sym_SEMI] = ACTIONS(278),
    [anon_sym_extern] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_auto] = ACTIONS(109),
    [anon_sym_register] = ACTIONS(109),
    [anon_sym_inline] = ACTIONS(109),
    [anon_sym_const] = ACTIONS(111),
    [anon_sym_restrict] = ACTIONS(111),
    [anon_sym_volatile] = ACTIONS(111),
    [anon_sym__Atomic] = ACTIONS(111),
    [sym_identifier] = ACTIONS(280),
    [sym_comment] = ACTIONS(42),
  },
  [57] = {
    [sym_storage_class_specifier] = STATE(57),
    [sym_type_qualifier] = STATE(57),
    [aux_sym__declaration_specifiers_repeat1] = STATE(57),
    [anon_sym_extern] = ACTIONS(332),
    [anon_sym_static] = ACTIONS(332),
    [anon_sym_auto] = ACTIONS(332),
    [anon_sym_register] = ACTIONS(332),
    [anon_sym_inline] = ACTIONS(332),
    [anon_sym_const] = ACTIONS(335),
    [anon_sym_restrict] = ACTIONS(335),
    [anon_sym_volatile] = ACTIONS(335),
    [anon_sym__Atomic] = ACTIONS(335),
    [anon_sym_unsigned] = ACTIONS(338),
    [anon_sym_long] = ACTIONS(338),
    [anon_sym_short] = ACTIONS(338),
    [sym_primitive_type] = ACTIONS(338),
    [anon_sym_enum] = ACTIONS(338),
    [anon_sym_struct] = ACTIONS(338),
    [anon_sym_union] = ACTIONS(338),
    [sym_identifier] = ACTIONS(338),
    [sym_comment] = ACTIONS(42),
  },
  [58] = {
    [anon_sym_LPAREN] = ACTIONS(340),
    [anon_sym_COMMA] = ACTIONS(340),
    [anon_sym_RPAREN] = ACTIONS(340),
    [anon_sym_SEMI] = ACTIONS(340),
    [anon_sym_extern] = ACTIONS(342),
    [anon_sym_STAR] = ACTIONS(340),
    [anon_sym_LBRACK] = ACTIONS(340),
    [anon_sym_static] = ACTIONS(342),
    [anon_sym_auto] = ACTIONS(342),
    [anon_sym_register] = ACTIONS(342),
    [anon_sym_inline] = ACTIONS(342),
    [anon_sym_const] = ACTIONS(342),
    [anon_sym_restrict] = ACTIONS(342),
    [anon_sym_volatile] = ACTIONS(342),
    [anon_sym__Atomic] = ACTIONS(342),
    [anon_sym_COLON] = ACTIONS(340),
    [sym_identifier] = ACTIONS(342),
    [sym_comment] = ACTIONS(42),
  },
  [59] = {
    [anon_sym_LPAREN] = ACTIONS(344),
    [anon_sym_COMMA] = ACTIONS(344),
    [anon_sym_RPAREN] = ACTIONS(344),
    [anon_sym_SEMI] = ACTIONS(344),
    [anon_sym_extern] = ACTIONS(346),
    [anon_sym_STAR] = ACTIONS(344),
    [anon_sym_LBRACK] = ACTIONS(344),
    [anon_sym_static] = ACTIONS(346),
    [anon_sym_auto] = ACTIONS(346),
    [anon_sym_register] = ACTIONS(346),
    [anon_sym_inline] = ACTIONS(346),
    [anon_sym_const] = ACTIONS(346),
    [anon_sym_restrict] = ACTIONS(346),
    [anon_sym_volatile] = ACTIONS(346),
    [anon_sym__Atomic] = ACTIONS(346),
    [anon_sym_COLON] = ACTIONS(344),
    [sym_identifier] = ACTIONS(346),
    [sym_comment] = ACTIONS(42),
  },
  [60] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(60),
    [anon_sym_LPAREN] = ACTIONS(348),
    [anon_sym_SEMI] = ACTIONS(348),
    [anon_sym_extern] = ACTIONS(350),
    [anon_sym_STAR] = ACTIONS(348),
    [anon_sym_static] = ACTIONS(350),
    [anon_sym_auto] = ACTIONS(350),
    [anon_sym_register] = ACTIONS(350),
    [anon_sym_inline] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(350),
    [anon_sym_restrict] = ACTIONS(350),
    [anon_sym_volatile] = ACTIONS(350),
    [anon_sym__Atomic] = ACTIONS(350),
    [anon_sym_unsigned] = ACTIONS(352),
    [anon_sym_long] = ACTIONS(352),
    [anon_sym_short] = ACTIONS(352),
    [sym_primitive_type] = ACTIONS(350),
    [sym_identifier] = ACTIONS(350),
    [sym_comment] = ACTIONS(42),
  },
  [61] = {
    [sym_preproc_arg] = ACTIONS(355),
    [sym_comment] = ACTIONS(50),
  },
  [62] = {
    [ts_builtin_sym_end] = ACTIONS(357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(359),
    [sym_preproc_directive] = ACTIONS(359),
    [anon_sym_typedef] = ACTIONS(359),
    [anon_sym_extern] = ACTIONS(359),
    [anon_sym_RBRACE] = ACTIONS(357),
    [anon_sym_static] = ACTIONS(359),
    [anon_sym_auto] = ACTIONS(359),
    [anon_sym_register] = ACTIONS(359),
    [anon_sym_inline] = ACTIONS(359),
    [anon_sym_const] = ACTIONS(359),
    [anon_sym_restrict] = ACTIONS(359),
    [anon_sym_volatile] = ACTIONS(359),
    [anon_sym__Atomic] = ACTIONS(359),
    [anon_sym_unsigned] = ACTIONS(359),
    [anon_sym_long] = ACTIONS(359),
    [anon_sym_short] = ACTIONS(359),
    [sym_primitive_type] = ACTIONS(359),
    [anon_sym_enum] = ACTIONS(359),
    [anon_sym_struct] = ACTIONS(359),
    [anon_sym_union] = ACTIONS(359),
    [sym_identifier] = ACTIONS(359),
    [sym_comment] = ACTIONS(42),
  },
  [63] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(361),
    [anon_sym_RPAREN] = ACTIONS(363),
    [sym_identifier] = ACTIONS(361),
    [sym_comment] = ACTIONS(42),
  },
  [64] = {
    [anon_sym_LF] = ACTIONS(365),
    [sym_preproc_arg] = ACTIONS(367),
    [sym_comment] = ACTIONS(50),
  },
  [65] = {
    [sym_string_literal] = ACTIONS(369),
    [sym_system_lib_string] = ACTIONS(369),
    [sym_comment] = ACTIONS(42),
  },
  [66] = {
    [sym_identifier] = ACTIONS(371),
    [sym_comment] = ACTIONS(42),
  },
  [67] = {
    [sym_preproc_arg] = ACTIONS(373),
    [sym_comment] = ACTIONS(50),
  },
  [68] = {
    [ts_builtin_sym_end] = ACTIONS(375),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(377),
    [sym_preproc_directive] = ACTIONS(377),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(377),
    [anon_sym_RBRACE] = ACTIONS(375),
    [anon_sym_static] = ACTIONS(377),
    [anon_sym_auto] = ACTIONS(377),
    [anon_sym_register] = ACTIONS(377),
    [anon_sym_inline] = ACTIONS(377),
    [anon_sym_const] = ACTIONS(377),
    [anon_sym_restrict] = ACTIONS(377),
    [anon_sym_volatile] = ACTIONS(377),
    [anon_sym__Atomic] = ACTIONS(377),
    [anon_sym_unsigned] = ACTIONS(377),
    [anon_sym_long] = ACTIONS(377),
    [anon_sym_short] = ACTIONS(377),
    [sym_primitive_type] = ACTIONS(377),
    [anon_sym_enum] = ACTIONS(377),
    [anon_sym_struct] = ACTIONS(377),
    [anon_sym_union] = ACTIONS(377),
    [sym_identifier] = ACTIONS(377),
    [sym_comment] = ACTIONS(42),
  },
  [69] = {
    [sym_identifier] = ACTIONS(379),
    [sym_comment] = ACTIONS(42),
  },
  [70] = {
    [sym_identifier] = ACTIONS(381),
    [sym_comment] = ACTIONS(42),
  },
  [71] = {
    [sym_preproc_include] = STATE(168),
    [sym_preproc_def] = STATE(168),
    [sym_preproc_function_def] = STATE(168),
    [sym_preproc_call] = STATE(168),
    [sym_preproc_if] = STATE(168),
    [sym_preproc_ifdef] = STATE(168),
    [sym_function_definition] = STATE(168),
    [sym_declaration] = STATE(168),
    [sym_type_definition] = STATE(168),
    [sym__declaration_specifiers] = STATE(167),
    [sym_linkage_specification] = STATE(168),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(168),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(168),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(383),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(385),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(387),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(391),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(393),
    [sym_preproc_directive] = ACTIONS(395),
    [anon_sym_typedef] = ACTIONS(397),
    [anon_sym_extern] = ACTIONS(399),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [72] = {
    [sym_preproc_arg] = ACTIONS(401),
    [sym_comment] = ACTIONS(50),
  },
  [73] = {
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(403),
    [anon_sym_LF] = ACTIONS(405),
    [sym_comment] = ACTIONS(50),
  },
  [74] = {
    [sym_type_qualifier] = STATE(173),
    [sym__type_specifier] = STATE(172),
    [sym_sized_type_specifier] = STATE(172),
    [sym_enum_specifier] = STATE(172),
    [sym_struct_specifier] = STATE(172),
    [sym_union_specifier] = STATE(172),
    [sym_macro_type_specifier] = STATE(172),
    [aux_sym_type_definition_repeat1] = STATE(173),
    [aux_sym_sized_type_specifier_repeat1] = STATE(36),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(62),
    [anon_sym_long] = ACTIONS(62),
    [anon_sym_short] = ACTIONS(62),
    [sym_primitive_type] = ACTIONS(407),
    [anon_sym_enum] = ACTIONS(66),
    [anon_sym_struct] = ACTIONS(68),
    [anon_sym_union] = ACTIONS(70),
    [sym_identifier] = ACTIONS(72),
    [sym_comment] = ACTIONS(42),
  },
  [75] = {
    [anon_sym_extern] = ACTIONS(74),
    [anon_sym_static] = ACTIONS(74),
    [anon_sym_auto] = ACTIONS(74),
    [anon_sym_register] = ACTIONS(74),
    [anon_sym_inline] = ACTIONS(74),
    [anon_sym_const] = ACTIONS(74),
    [anon_sym_restrict] = ACTIONS(74),
    [anon_sym_volatile] = ACTIONS(74),
    [anon_sym__Atomic] = ACTIONS(74),
    [anon_sym_unsigned] = ACTIONS(74),
    [anon_sym_long] = ACTIONS(74),
    [anon_sym_short] = ACTIONS(74),
    [sym_primitive_type] = ACTIONS(74),
    [anon_sym_enum] = ACTIONS(74),
    [anon_sym_struct] = ACTIONS(74),
    [anon_sym_union] = ACTIONS(74),
    [sym_string_literal] = ACTIONS(409),
    [sym_identifier] = ACTIONS(74),
    [sym_comment] = ACTIONS(42),
  },
  [76] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(411),
    [sym_comment] = ACTIONS(42),
  },
  [77] = {
    [sym__declarator] = STATE(177),
    [sym_pointer_declarator] = STATE(177),
    [sym_function_declarator] = STATE(177),
    [sym_array_declarator] = STATE(177),
    [sym_init_declarator] = STATE(178),
    [anon_sym_LPAREN] = ACTIONS(99),
    [anon_sym_SEMI] = ACTIONS(413),
    [anon_sym_STAR] = ACTIONS(103),
    [sym_identifier] = ACTIONS(415),
    [sym_comment] = ACTIONS(42),
  },
  [78] = {
    [sym_preproc_include] = STATE(180),
    [sym_preproc_def] = STATE(180),
    [sym_preproc_function_def] = STATE(180),
    [sym_preproc_call] = STATE(180),
    [sym_preproc_if] = STATE(180),
    [sym_preproc_ifdef] = STATE(180),
    [sym_preproc_else] = STATE(179),
    [sym_preproc_elif] = STATE(179),
    [sym_function_definition] = STATE(180),
    [sym_declaration] = STATE(180),
    [sym_type_definition] = STATE(180),
    [sym__declaration_specifiers] = STATE(77),
    [sym_linkage_specification] = STATE(180),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(180),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(140),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(142),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(417),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(148),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(150),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(152),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(154),
    [sym_preproc_directive] = ACTIONS(156),
    [anon_sym_typedef] = ACTIONS(158),
    [anon_sym_extern] = ACTIONS(160),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [79] = {
    [ts_builtin_sym_end] = ACTIONS(419),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(421),
    [sym_preproc_directive] = ACTIONS(421),
    [anon_sym_typedef] = ACTIONS(421),
    [anon_sym_extern] = ACTIONS(421),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_static] = ACTIONS(421),
    [anon_sym_auto] = ACTIONS(421),
    [anon_sym_register] = ACTIONS(421),
    [anon_sym_inline] = ACTIONS(421),
    [anon_sym_const] = ACTIONS(421),
    [anon_sym_restrict] = ACTIONS(421),
    [anon_sym_volatile] = ACTIONS(421),
    [anon_sym__Atomic] = ACTIONS(421),
    [anon_sym_unsigned] = ACTIONS(421),
    [anon_sym_long] = ACTIONS(421),
    [anon_sym_short] = ACTIONS(421),
    [sym_primitive_type] = ACTIONS(421),
    [anon_sym_enum] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(421),
    [anon_sym_union] = ACTIONS(421),
    [sym_identifier] = ACTIONS(421),
    [sym_comment] = ACTIONS(42),
  },
  [80] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(423),
    [sym_comment] = ACTIONS(42),
  },
  [81] = {
    [sym_preproc_include] = STATE(180),
    [sym_preproc_def] = STATE(180),
    [sym_preproc_function_def] = STATE(180),
    [sym_preproc_call] = STATE(180),
    [sym_preproc_if] = STATE(180),
    [sym_preproc_ifdef] = STATE(180),
    [sym_preproc_else] = STATE(182),
    [sym_preproc_elif] = STATE(182),
    [sym_function_definition] = STATE(180),
    [sym_declaration] = STATE(180),
    [sym_type_definition] = STATE(180),
    [sym__declaration_specifiers] = STATE(77),
    [sym_linkage_specification] = STATE(180),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(180),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(140),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(142),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(425),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(148),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(150),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(152),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(154),
    [sym_preproc_directive] = ACTIONS(156),
    [anon_sym_typedef] = ACTIONS(158),
    [anon_sym_extern] = ACTIONS(160),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [82] = {
    [ts_builtin_sym_end] = ACTIONS(427),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(429),
    [sym_preproc_directive] = ACTIONS(429),
    [anon_sym_typedef] = ACTIONS(429),
    [anon_sym_extern] = ACTIONS(429),
    [anon_sym_RBRACE] = ACTIONS(427),
    [anon_sym_static] = ACTIONS(429),
    [anon_sym_auto] = ACTIONS(429),
    [anon_sym_register] = ACTIONS(429),
    [anon_sym_inline] = ACTIONS(429),
    [anon_sym_const] = ACTIONS(429),
    [anon_sym_restrict] = ACTIONS(429),
    [anon_sym_volatile] = ACTIONS(429),
    [anon_sym__Atomic] = ACTIONS(429),
    [anon_sym_unsigned] = ACTIONS(429),
    [anon_sym_long] = ACTIONS(429),
    [anon_sym_short] = ACTIONS(429),
    [sym_primitive_type] = ACTIONS(429),
    [anon_sym_enum] = ACTIONS(429),
    [anon_sym_struct] = ACTIONS(429),
    [anon_sym_union] = ACTIONS(429),
    [sym_identifier] = ACTIONS(429),
    [sym_comment] = ACTIONS(42),
  },
  [83] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(431),
    [sym_comment] = ACTIONS(42),
  },
  [84] = {
    [sym_preproc_include] = STATE(180),
    [sym_preproc_def] = STATE(180),
    [sym_preproc_function_def] = STATE(180),
    [sym_preproc_call] = STATE(180),
    [sym_preproc_if] = STATE(180),
    [sym_preproc_ifdef] = STATE(180),
    [sym_preproc_else] = STATE(184),
    [sym_preproc_elif] = STATE(184),
    [sym_function_definition] = STATE(180),
    [sym_declaration] = STATE(180),
    [sym_type_definition] = STATE(180),
    [sym__declaration_specifiers] = STATE(77),
    [sym_linkage_specification] = STATE(180),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(180),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(140),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(142),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(433),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(148),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(150),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(152),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(154),
    [sym_preproc_directive] = ACTIONS(156),
    [anon_sym_typedef] = ACTIONS(158),
    [anon_sym_extern] = ACTIONS(160),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [85] = {
    [anon_sym_LF] = ACTIONS(435),
    [sym_comment] = ACTIONS(50),
  },
  [86] = {
    [sym_enumerator] = STATE(188),
    [anon_sym_COMMA] = ACTIONS(437),
    [anon_sym_RBRACE] = ACTIONS(439),
    [sym_identifier] = ACTIONS(210),
    [sym_comment] = ACTIONS(42),
  },
  [87] = {
    [sym_enumerator_list] = STATE(189),
    [anon_sym_LPAREN] = ACTIONS(212),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_STAR] = ACTIONS(212),
    [sym_identifier] = ACTIONS(212),
    [sym_comment] = ACTIONS(42),
  },
  [88] = {
    [anon_sym_LPAREN] = ACTIONS(216),
    [anon_sym_STAR] = ACTIONS(216),
    [sym_identifier] = ACTIONS(216),
    [sym_comment] = ACTIONS(42),
  },
  [89] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(122),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(123),
    [sym__declaration_specifiers] = STATE(124),
    [sym_storage_class_specifier] = STATE(126),
    [sym_type_qualifier] = STATE(126),
    [sym__type_specifier] = STATE(125),
    [sym_sized_type_specifier] = STATE(125),
    [sym_enum_specifier] = STATE(125),
    [sym_struct_specifier] = STATE(125),
    [sym_union_specifier] = STATE(125),
    [sym_field_declaration] = STATE(191),
    [sym_macro_type_specifier] = STATE(125),
    [aux_sym__declaration_specifiers_repeat1] = STATE(126),
    [aux_sym_sized_type_specifier_repeat1] = STATE(127),
    [aux_sym_field_declaration_list_repeat1] = STATE(191),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(220),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(224),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_RBRACE] = ACTIONS(441),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(228),
    [anon_sym_long] = ACTIONS(228),
    [anon_sym_short] = ACTIONS(228),
    [sym_primitive_type] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [90] = {
    [sym_field_declaration_list] = STATE(192),
    [anon_sym_LPAREN] = ACTIONS(232),
    [anon_sym_LBRACE] = ACTIONS(176),
    [anon_sym_STAR] = ACTIONS(232),
    [sym_identifier] = ACTIONS(232),
    [sym_comment] = ACTIONS(42),
  },
  [91] = {
    [anon_sym_LPAREN] = ACTIONS(236),
    [anon_sym_STAR] = ACTIONS(236),
    [sym_identifier] = ACTIONS(236),
    [sym_comment] = ACTIONS(42),
  },
  [92] = {
    [sym_field_declaration_list] = STATE(193),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_LBRACE] = ACTIONS(176),
    [anon_sym_STAR] = ACTIONS(240),
    [sym_identifier] = ACTIONS(240),
    [sym_comment] = ACTIONS(42),
  },
  [93] = {
    [anon_sym_LPAREN] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(244),
    [sym_identifier] = ACTIONS(244),
    [sym_comment] = ACTIONS(42),
  },
  [94] = {
    [sym_type_qualifier] = STATE(133),
    [sym__type_specifier] = STATE(131),
    [sym_sized_type_specifier] = STATE(131),
    [sym_enum_specifier] = STATE(131),
    [sym_struct_specifier] = STATE(131),
    [sym_union_specifier] = STATE(131),
    [sym_type_descriptor] = STATE(194),
    [sym_macro_type_specifier] = STATE(131),
    [aux_sym_type_definition_repeat1] = STATE(133),
    [aux_sym_sized_type_specifier_repeat1] = STATE(134),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(248),
    [anon_sym_long] = ACTIONS(248),
    [anon_sym_short] = ACTIONS(248),
    [sym_primitive_type] = ACTIONS(250),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [95] = {
    [sym__type_declarator] = STATE(196),
    [sym_pointer_type_declarator] = STATE(99),
    [sym_function_type_declarator] = STATE(100),
    [sym_array_type_declarator] = STATE(101),
    [anon_sym_LPAREN] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(443),
    [sym_identifier] = ACTIONS(189),
    [sym_comment] = ACTIONS(42),
  },
  [96] = {
    [sym__type_declarator] = STATE(197),
    [sym_pointer_type_declarator] = STATE(99),
    [sym_function_type_declarator] = STATE(100),
    [sym_array_type_declarator] = STATE(101),
    [anon_sym_LPAREN] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(187),
    [sym_identifier] = ACTIONS(189),
    [sym_comment] = ACTIONS(42),
  },
  [97] = {
    [anon_sym_LPAREN] = ACTIONS(445),
    [anon_sym_RPAREN] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(445),
    [sym_comment] = ACTIONS(42),
  },
  [98] = {
    [sym_parameter_list] = STATE(200),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_SEMI] = ACTIONS(447),
    [anon_sym_LBRACK] = ACTIONS(449),
    [sym_comment] = ACTIONS(42),
  },
  [99] = {
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(451),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(451),
    [sym_comment] = ACTIONS(42),
  },
  [100] = {
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [sym_comment] = ACTIONS(42),
  },
  [101] = {
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(455),
    [anon_sym_SEMI] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(455),
    [sym_comment] = ACTIONS(42),
  },
  [102] = {
    [sym__type_declarator] = STATE(201),
    [sym_pointer_type_declarator] = STATE(99),
    [sym_function_type_declarator] = STATE(100),
    [sym_array_type_declarator] = STATE(101),
    [anon_sym_LPAREN] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(187),
    [sym_identifier] = ACTIONS(189),
    [sym_comment] = ACTIONS(42),
  },
  [103] = {
    [sym_type_qualifier] = STATE(103),
    [aux_sym_type_definition_repeat1] = STATE(103),
    [anon_sym_const] = ACTIONS(457),
    [anon_sym_restrict] = ACTIONS(457),
    [anon_sym_volatile] = ACTIONS(457),
    [anon_sym__Atomic] = ACTIONS(457),
    [anon_sym_unsigned] = ACTIONS(460),
    [anon_sym_long] = ACTIONS(460),
    [anon_sym_short] = ACTIONS(460),
    [sym_primitive_type] = ACTIONS(460),
    [anon_sym_enum] = ACTIONS(460),
    [anon_sym_struct] = ACTIONS(460),
    [anon_sym_union] = ACTIONS(460),
    [sym_identifier] = ACTIONS(460),
    [sym_comment] = ACTIONS(42),
  },
  [104] = {
    [anon_sym_LPAREN] = ACTIONS(340),
    [anon_sym_STAR] = ACTIONS(340),
    [sym_identifier] = ACTIONS(340),
    [sym_comment] = ACTIONS(42),
  },
  [105] = {
    [anon_sym_LPAREN] = ACTIONS(344),
    [anon_sym_STAR] = ACTIONS(344),
    [sym_identifier] = ACTIONS(344),
    [sym_comment] = ACTIONS(42),
  },
  [106] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(106),
    [anon_sym_LPAREN] = ACTIONS(348),
    [anon_sym_STAR] = ACTIONS(348),
    [anon_sym_unsigned] = ACTIONS(462),
    [anon_sym_long] = ACTIONS(462),
    [anon_sym_short] = ACTIONS(462),
    [sym_primitive_type] = ACTIONS(350),
    [sym_identifier] = ACTIONS(350),
    [sym_comment] = ACTIONS(42),
  },
  [107] = {
    [sym_preproc_include] = STATE(203),
    [sym_preproc_def] = STATE(203),
    [sym_preproc_function_def] = STATE(203),
    [sym_preproc_call] = STATE(203),
    [sym_preproc_if] = STATE(203),
    [sym_preproc_ifdef] = STATE(203),
    [sym_function_definition] = STATE(203),
    [sym_declaration] = STATE(203),
    [sym_type_definition] = STATE(203),
    [sym__declaration_specifiers] = STATE(17),
    [sym_linkage_specification] = STATE(203),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(203),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(203),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(10),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(12),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(14),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(16),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(18),
    [sym_preproc_directive] = ACTIONS(20),
    [anon_sym_typedef] = ACTIONS(22),
    [anon_sym_extern] = ACTIONS(24),
    [anon_sym_RBRACE] = ACTIONS(465),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [108] = {
    [ts_builtin_sym_end] = ACTIONS(467),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(469),
    [sym_preproc_directive] = ACTIONS(469),
    [anon_sym_typedef] = ACTIONS(469),
    [anon_sym_extern] = ACTIONS(469),
    [anon_sym_RBRACE] = ACTIONS(467),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_auto] = ACTIONS(469),
    [anon_sym_register] = ACTIONS(469),
    [anon_sym_inline] = ACTIONS(469),
    [anon_sym_const] = ACTIONS(469),
    [anon_sym_restrict] = ACTIONS(469),
    [anon_sym_volatile] = ACTIONS(469),
    [anon_sym__Atomic] = ACTIONS(469),
    [anon_sym_unsigned] = ACTIONS(469),
    [anon_sym_long] = ACTIONS(469),
    [anon_sym_short] = ACTIONS(469),
    [sym_primitive_type] = ACTIONS(469),
    [anon_sym_enum] = ACTIONS(469),
    [anon_sym_struct] = ACTIONS(469),
    [anon_sym_union] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_comment] = ACTIONS(42),
  },
  [109] = {
    [sym__declarator] = STATE(50),
    [sym_pointer_declarator] = STATE(50),
    [sym_function_declarator] = STATE(50),
    [sym_array_declarator] = STATE(50),
    [sym_init_declarator] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [sym_comment] = ACTIONS(42),
  },
  [110] = {
    [sym_storage_class_specifier] = STATE(204),
    [sym_type_qualifier] = STATE(204),
    [aux_sym__declaration_specifiers_repeat1] = STATE(204),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_extern] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(107),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_auto] = ACTIONS(109),
    [anon_sym_register] = ACTIONS(109),
    [anon_sym_inline] = ACTIONS(109),
    [anon_sym_const] = ACTIONS(111),
    [anon_sym_restrict] = ACTIONS(111),
    [anon_sym_volatile] = ACTIONS(111),
    [anon_sym__Atomic] = ACTIONS(111),
    [sym_identifier] = ACTIONS(113),
    [sym_comment] = ACTIONS(42),
  },
  [111] = {
    [sym_storage_class_specifier] = STATE(57),
    [sym_type_qualifier] = STATE(57),
    [sym__type_specifier] = STATE(205),
    [sym_sized_type_specifier] = STATE(205),
    [sym_enum_specifier] = STATE(205),
    [sym_struct_specifier] = STATE(205),
    [sym_union_specifier] = STATE(205),
    [sym_macro_type_specifier] = STATE(205),
    [aux_sym__declaration_specifiers_repeat1] = STATE(57),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(471),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [112] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(206),
    [anon_sym_LPAREN] = ACTIONS(119),
    [anon_sym_extern] = ACTIONS(121),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_static] = ACTIONS(121),
    [anon_sym_auto] = ACTIONS(121),
    [anon_sym_register] = ACTIONS(121),
    [anon_sym_inline] = ACTIONS(121),
    [anon_sym_const] = ACTIONS(121),
    [anon_sym_restrict] = ACTIONS(121),
    [anon_sym_volatile] = ACTIONS(121),
    [anon_sym__Atomic] = ACTIONS(121),
    [anon_sym_unsigned] = ACTIONS(473),
    [anon_sym_long] = ACTIONS(473),
    [anon_sym_short] = ACTIONS(473),
    [sym_primitive_type] = ACTIONS(125),
    [sym_identifier] = ACTIONS(127),
    [sym_comment] = ACTIONS(42),
  },
  [113] = {
    [anon_sym_RBRACE] = ACTIONS(475),
    [sym_comment] = ACTIONS(42),
  },
  [114] = {
    [anon_sym_LPAREN] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(477),
    [anon_sym_RPAREN] = ACTIONS(477),
    [anon_sym_SEMI] = ACTIONS(477),
    [anon_sym_extern] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(479),
    [anon_sym_auto] = ACTIONS(479),
    [anon_sym_register] = ACTIONS(479),
    [anon_sym_inline] = ACTIONS(479),
    [anon_sym_const] = ACTIONS(479),
    [anon_sym_restrict] = ACTIONS(479),
    [anon_sym_volatile] = ACTIONS(479),
    [anon_sym__Atomic] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(477),
    [sym_identifier] = ACTIONS(479),
    [sym_comment] = ACTIONS(42),
  },
  [115] = {
    [anon_sym_COMMA] = ACTIONS(481),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_EQ] = ACTIONS(483),
    [sym_comment] = ACTIONS(42),
  },
  [116] = {
    [aux_sym_enumerator_list_repeat1] = STATE(210),
    [anon_sym_COMMA] = ACTIONS(485),
    [anon_sym_RBRACE] = ACTIONS(475),
    [sym_comment] = ACTIONS(42),
  },
  [117] = {
    [anon_sym_LPAREN] = ACTIONS(487),
    [anon_sym_COMMA] = ACTIONS(487),
    [anon_sym_RPAREN] = ACTIONS(487),
    [anon_sym_SEMI] = ACTIONS(487),
    [anon_sym_extern] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(487),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_auto] = ACTIONS(489),
    [anon_sym_register] = ACTIONS(489),
    [anon_sym_inline] = ACTIONS(489),
    [anon_sym_const] = ACTIONS(489),
    [anon_sym_restrict] = ACTIONS(489),
    [anon_sym_volatile] = ACTIONS(489),
    [anon_sym__Atomic] = ACTIONS(489),
    [anon_sym_COLON] = ACTIONS(487),
    [sym_identifier] = ACTIONS(489),
    [sym_comment] = ACTIONS(42),
  },
  [118] = {
    [sym_preproc_arg] = ACTIONS(491),
    [sym_comment] = ACTIONS(50),
  },
  [119] = {
    [sym_identifier] = ACTIONS(493),
    [sym_comment] = ACTIONS(42),
  },
  [120] = {
    [sym_identifier] = ACTIONS(495),
    [sym_comment] = ACTIONS(42),
  },
  [121] = {
    [anon_sym_LPAREN] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(497),
    [anon_sym_RPAREN] = ACTIONS(497),
    [anon_sym_SEMI] = ACTIONS(497),
    [anon_sym_extern] = ACTIONS(499),
    [anon_sym_STAR] = ACTIONS(497),
    [anon_sym_LBRACK] = ACTIONS(497),
    [anon_sym_static] = ACTIONS(499),
    [anon_sym_auto] = ACTIONS(499),
    [anon_sym_register] = ACTIONS(499),
    [anon_sym_inline] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(499),
    [anon_sym_restrict] = ACTIONS(499),
    [anon_sym_volatile] = ACTIONS(499),
    [anon_sym__Atomic] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(497),
    [sym_identifier] = ACTIONS(499),
    [sym_comment] = ACTIONS(42),
  },
  [122] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(501),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(503),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(503),
    [anon_sym_extern] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(501),
    [anon_sym_auto] = ACTIONS(501),
    [anon_sym_register] = ACTIONS(501),
    [anon_sym_inline] = ACTIONS(501),
    [anon_sym_const] = ACTIONS(501),
    [anon_sym_restrict] = ACTIONS(501),
    [anon_sym_volatile] = ACTIONS(501),
    [anon_sym__Atomic] = ACTIONS(501),
    [anon_sym_unsigned] = ACTIONS(501),
    [anon_sym_long] = ACTIONS(501),
    [anon_sym_short] = ACTIONS(501),
    [sym_primitive_type] = ACTIONS(501),
    [anon_sym_enum] = ACTIONS(501),
    [anon_sym_struct] = ACTIONS(501),
    [anon_sym_union] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_comment] = ACTIONS(42),
  },
  [123] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(505),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(507),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(507),
    [anon_sym_extern] = ACTIONS(505),
    [anon_sym_RBRACE] = ACTIONS(507),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_auto] = ACTIONS(505),
    [anon_sym_register] = ACTIONS(505),
    [anon_sym_inline] = ACTIONS(505),
    [anon_sym_const] = ACTIONS(505),
    [anon_sym_restrict] = ACTIONS(505),
    [anon_sym_volatile] = ACTIONS(505),
    [anon_sym__Atomic] = ACTIONS(505),
    [anon_sym_unsigned] = ACTIONS(505),
    [anon_sym_long] = ACTIONS(505),
    [anon_sym_short] = ACTIONS(505),
    [sym_primitive_type] = ACTIONS(505),
    [anon_sym_enum] = ACTIONS(505),
    [anon_sym_struct] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(505),
    [sym_identifier] = ACTIONS(505),
    [sym_comment] = ACTIONS(42),
  },
  [124] = {
    [sym__field_declarator] = STATE(219),
    [sym_pointer_field_declarator] = STATE(220),
    [sym_function_field_declarator] = STATE(221),
    [sym_array_field_declarator] = STATE(222),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_STAR] = ACTIONS(513),
    [anon_sym_COLON] = ACTIONS(515),
    [sym_identifier] = ACTIONS(517),
    [sym_comment] = ACTIONS(42),
  },
  [125] = {
    [sym_storage_class_specifier] = STATE(223),
    [sym_type_qualifier] = STATE(223),
    [aux_sym__declaration_specifiers_repeat1] = STATE(223),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_SEMI] = ACTIONS(107),
    [anon_sym_extern] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(107),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_auto] = ACTIONS(109),
    [anon_sym_register] = ACTIONS(109),
    [anon_sym_inline] = ACTIONS(109),
    [anon_sym_const] = ACTIONS(111),
    [anon_sym_restrict] = ACTIONS(111),
    [anon_sym_volatile] = ACTIONS(111),
    [anon_sym__Atomic] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(107),
    [sym_identifier] = ACTIONS(113),
    [sym_comment] = ACTIONS(42),
  },
  [126] = {
    [sym_storage_class_specifier] = STATE(57),
    [sym_type_qualifier] = STATE(57),
    [sym__type_specifier] = STATE(224),
    [sym_sized_type_specifier] = STATE(224),
    [sym_enum_specifier] = STATE(224),
    [sym_struct_specifier] = STATE(224),
    [sym_union_specifier] = STATE(224),
    [sym_macro_type_specifier] = STATE(224),
    [aux_sym__declaration_specifiers_repeat1] = STATE(57),
    [aux_sym_sized_type_specifier_repeat1] = STATE(127),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(228),
    [anon_sym_long] = ACTIONS(228),
    [anon_sym_short] = ACTIONS(228),
    [sym_primitive_type] = ACTIONS(519),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [127] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(119),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_extern] = ACTIONS(121),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_static] = ACTIONS(121),
    [anon_sym_auto] = ACTIONS(121),
    [anon_sym_register] = ACTIONS(121),
    [anon_sym_inline] = ACTIONS(121),
    [anon_sym_const] = ACTIONS(121),
    [anon_sym_restrict] = ACTIONS(121),
    [anon_sym_volatile] = ACTIONS(121),
    [anon_sym__Atomic] = ACTIONS(121),
    [anon_sym_unsigned] = ACTIONS(521),
    [anon_sym_long] = ACTIONS(521),
    [anon_sym_short] = ACTIONS(521),
    [sym_primitive_type] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(119),
    [sym_identifier] = ACTIONS(127),
    [sym_comment] = ACTIONS(42),
  },
  [128] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(122),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(123),
    [sym__declaration_specifiers] = STATE(124),
    [sym_storage_class_specifier] = STATE(126),
    [sym_type_qualifier] = STATE(126),
    [sym__type_specifier] = STATE(125),
    [sym_sized_type_specifier] = STATE(125),
    [sym_enum_specifier] = STATE(125),
    [sym_struct_specifier] = STATE(125),
    [sym_union_specifier] = STATE(125),
    [sym_field_declaration] = STATE(227),
    [sym_macro_type_specifier] = STATE(125),
    [aux_sym__declaration_specifiers_repeat1] = STATE(126),
    [aux_sym_sized_type_specifier_repeat1] = STATE(127),
    [aux_sym_field_declaration_list_repeat1] = STATE(227),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(220),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(224),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_RBRACE] = ACTIONS(523),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(228),
    [anon_sym_long] = ACTIONS(228),
    [anon_sym_short] = ACTIONS(228),
    [sym_primitive_type] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [129] = {
    [anon_sym_LPAREN] = ACTIONS(525),
    [anon_sym_COMMA] = ACTIONS(525),
    [anon_sym_RPAREN] = ACTIONS(525),
    [anon_sym_SEMI] = ACTIONS(525),
    [anon_sym_extern] = ACTIONS(527),
    [anon_sym_STAR] = ACTIONS(525),
    [anon_sym_LBRACK] = ACTIONS(525),
    [anon_sym_static] = ACTIONS(527),
    [anon_sym_auto] = ACTIONS(527),
    [anon_sym_register] = ACTIONS(527),
    [anon_sym_inline] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(527),
    [anon_sym_restrict] = ACTIONS(527),
    [anon_sym_volatile] = ACTIONS(527),
    [anon_sym__Atomic] = ACTIONS(527),
    [anon_sym_COLON] = ACTIONS(525),
    [sym_identifier] = ACTIONS(527),
    [sym_comment] = ACTIONS(42),
  },
  [130] = {
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_RPAREN] = ACTIONS(529),
    [anon_sym_SEMI] = ACTIONS(529),
    [anon_sym_extern] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(529),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_auto] = ACTIONS(531),
    [anon_sym_register] = ACTIONS(531),
    [anon_sym_inline] = ACTIONS(531),
    [anon_sym_const] = ACTIONS(531),
    [anon_sym_restrict] = ACTIONS(531),
    [anon_sym_volatile] = ACTIONS(531),
    [anon_sym__Atomic] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(529),
    [sym_identifier] = ACTIONS(531),
    [sym_comment] = ACTIONS(42),
  },
  [131] = {
    [sym__abstract_declarator] = STATE(231),
    [sym_abstract_pointer_declarator] = STATE(231),
    [sym_abstract_function_declarator] = STATE(231),
    [sym_abstract_array_declarator] = STATE(231),
    [sym_parameter_list] = STATE(232),
    [anon_sym_LPAREN] = ACTIONS(533),
    [anon_sym_RPAREN] = ACTIONS(535),
    [anon_sym_STAR] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(539),
    [sym_comment] = ACTIONS(42),
  },
  [132] = {
    [anon_sym_RPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(42),
  },
  [133] = {
    [sym_type_qualifier] = STATE(103),
    [sym__type_specifier] = STATE(234),
    [sym_sized_type_specifier] = STATE(234),
    [sym_enum_specifier] = STATE(234),
    [sym_struct_specifier] = STATE(234),
    [sym_union_specifier] = STATE(234),
    [sym_macro_type_specifier] = STATE(234),
    [aux_sym_type_definition_repeat1] = STATE(103),
    [aux_sym_sized_type_specifier_repeat1] = STATE(134),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(248),
    [anon_sym_long] = ACTIONS(248),
    [anon_sym_short] = ACTIONS(248),
    [sym_primitive_type] = ACTIONS(543),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [134] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(235),
    [anon_sym_LPAREN] = ACTIONS(119),
    [anon_sym_RPAREN] = ACTIONS(119),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_LBRACK] = ACTIONS(119),
    [anon_sym_unsigned] = ACTIONS(545),
    [anon_sym_long] = ACTIONS(545),
    [anon_sym_short] = ACTIONS(545),
    [sym_primitive_type] = ACTIONS(125),
    [sym_identifier] = ACTIONS(547),
    [sym_comment] = ACTIONS(42),
  },
  [135] = {
    [sym__declarator] = STATE(137),
    [sym_pointer_declarator] = STATE(137),
    [sym_function_declarator] = STATE(137),
    [sym_array_declarator] = STATE(137),
    [anon_sym_LPAREN] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(252),
    [sym_identifier] = ACTIONS(260),
    [sym_comment] = ACTIONS(42),
  },
  [136] = {
    [sym_parameter_list] = STATE(145),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_RPAREN] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(270),
    [sym_comment] = ACTIONS(42),
  },
  [137] = {
    [sym_parameter_list] = STATE(145),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_COMMA] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(551),
    [anon_sym_SEMI] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(270),
    [anon_sym_EQ] = ACTIONS(551),
    [sym_comment] = ACTIONS(42),
  },
  [138] = {
    [sym__declaration_specifiers] = STATE(239),
    [sym_storage_class_specifier] = STATE(241),
    [sym_type_qualifier] = STATE(241),
    [sym__type_specifier] = STATE(240),
    [sym_sized_type_specifier] = STATE(240),
    [sym_enum_specifier] = STATE(240),
    [sym_struct_specifier] = STATE(240),
    [sym_union_specifier] = STATE(240),
    [sym_parameter_declaration] = STATE(237),
    [sym_macro_type_specifier] = STATE(240),
    [aux_sym__declaration_specifiers_repeat1] = STATE(241),
    [aux_sym_sized_type_specifier_repeat1] = STATE(242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(553),
    [anon_sym_RPAREN] = ACTIONS(555),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(557),
    [anon_sym_long] = ACTIONS(557),
    [anon_sym_short] = ACTIONS(557),
    [sym_primitive_type] = ACTIONS(559),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [139] = {
    [sym__declarator] = STATE(244),
    [sym_pointer_declarator] = STATE(244),
    [sym_function_declarator] = STATE(244),
    [sym_array_declarator] = STATE(244),
    [sym_init_declarator] = STATE(245),
    [anon_sym_LPAREN] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(561),
    [sym_identifier] = ACTIONS(563),
    [sym_comment] = ACTIONS(42),
  },
  [140] = {
    [ts_builtin_sym_end] = ACTIONS(565),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(567),
    [sym_preproc_directive] = ACTIONS(567),
    [anon_sym_typedef] = ACTIONS(567),
    [anon_sym_extern] = ACTIONS(567),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_static] = ACTIONS(567),
    [anon_sym_auto] = ACTIONS(567),
    [anon_sym_register] = ACTIONS(567),
    [anon_sym_inline] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_restrict] = ACTIONS(567),
    [anon_sym_volatile] = ACTIONS(567),
    [anon_sym__Atomic] = ACTIONS(567),
    [anon_sym_unsigned] = ACTIONS(567),
    [anon_sym_long] = ACTIONS(567),
    [anon_sym_short] = ACTIONS(567),
    [sym_primitive_type] = ACTIONS(567),
    [anon_sym_enum] = ACTIONS(567),
    [anon_sym_struct] = ACTIONS(567),
    [anon_sym_union] = ACTIONS(567),
    [sym_identifier] = ACTIONS(567),
    [sym_comment] = ACTIONS(42),
  },
  [141] = {
    [sym_preproc_include] = STATE(280),
    [sym_preproc_def] = STATE(280),
    [sym_preproc_function_def] = STATE(280),
    [sym_preproc_call] = STATE(280),
    [sym_preproc_if_in_compound_statement] = STATE(275),
    [sym_preproc_ifdef_in_compound_statement] = STATE(276),
    [sym_declaration] = STATE(280),
    [sym_type_definition] = STATE(280),
    [sym__declaration_specifiers] = STATE(277),
    [sym_compound_statement] = STATE(280),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(280),
    [sym_expression_statement] = STATE(280),
    [sym_if_statement] = STATE(280),
    [sym_switch_statement] = STATE(280),
    [sym_case_statement] = STATE(280),
    [sym_while_statement] = STATE(280),
    [sym_do_statement] = STATE(280),
    [sym_for_statement] = STATE(280),
    [sym_return_statement] = STATE(280),
    [sym_break_statement] = STATE(280),
    [sym_continue_statement] = STATE(280),
    [sym_goto_statement] = STATE(280),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [sym__empty_declaration] = STATE(280),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(280),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(577),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(579),
    [sym_preproc_directive] = ACTIONS(581),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_typedef] = ACTIONS(585),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_RBRACE] = ACTIONS(589),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(631),
    [sym_comment] = ACTIONS(42),
  },
  [142] = {
    [sym__declaration_specifiers] = STATE(293),
    [sym_storage_class_specifier] = STATE(296),
    [sym_type_qualifier] = STATE(296),
    [sym__type_specifier] = STATE(294),
    [sym_sized_type_specifier] = STATE(294),
    [sym_enum_specifier] = STATE(294),
    [sym_struct_specifier] = STATE(294),
    [sym_union_specifier] = STATE(294),
    [sym__expression] = STATE(295),
    [sym_conditional_expression] = STATE(295),
    [sym_assignment_expression] = STATE(295),
    [sym_pointer_expression] = STATE(295),
    [sym_logical_expression] = STATE(295),
    [sym_bitwise_expression] = STATE(295),
    [sym_equality_expression] = STATE(295),
    [sym_relational_expression] = STATE(295),
    [sym_shift_expression] = STATE(295),
    [sym_math_expression] = STATE(295),
    [sym_cast_expression] = STATE(295),
    [sym_sizeof_expression] = STATE(295),
    [sym_subscript_expression] = STATE(295),
    [sym_call_expression] = STATE(295),
    [sym_field_expression] = STATE(295),
    [sym_compound_literal_expression] = STATE(295),
    [sym_parenthesized_expression] = STATE(295),
    [sym_concatenated_string] = STATE(295),
    [sym_macro_type_specifier] = STATE(294),
    [aux_sym__declaration_specifiers_repeat1] = STATE(296),
    [aux_sym_sized_type_specifier_repeat1] = STATE(297),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(637),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(639),
    [anon_sym_long] = ACTIONS(639),
    [anon_sym_short] = ACTIONS(639),
    [sym_primitive_type] = ACTIONS(641),
    [anon_sym_enum] = ACTIONS(643),
    [anon_sym_struct] = ACTIONS(645),
    [anon_sym_union] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(659),
    [sym_char_literal] = ACTIONS(659),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(663),
    [sym_false] = ACTIONS(663),
    [sym_null] = ACTIONS(663),
    [sym_identifier] = ACTIONS(665),
    [sym_comment] = ACTIONS(42),
  },
  [143] = {
    [sym__expression] = STATE(299),
    [sym_conditional_expression] = STATE(299),
    [sym_assignment_expression] = STATE(299),
    [sym_pointer_expression] = STATE(299),
    [sym_logical_expression] = STATE(299),
    [sym_bitwise_expression] = STATE(299),
    [sym_equality_expression] = STATE(299),
    [sym_relational_expression] = STATE(299),
    [sym_shift_expression] = STATE(299),
    [sym_math_expression] = STATE(299),
    [sym_cast_expression] = STATE(299),
    [sym_sizeof_expression] = STATE(299),
    [sym_subscript_expression] = STATE(299),
    [sym_call_expression] = STATE(299),
    [sym_field_expression] = STATE(299),
    [sym_compound_literal_expression] = STATE(299),
    [sym_parenthesized_expression] = STATE(299),
    [sym_initializer_list] = STATE(300),
    [sym_concatenated_string] = STATE(299),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(669),
    [sym_char_literal] = ACTIONS(669),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(671),
    [sym_false] = ACTIONS(671),
    [sym_null] = ACTIONS(671),
    [sym_identifier] = ACTIONS(671),
    [sym_comment] = ACTIONS(42),
  },
  [144] = {
    [ts_builtin_sym_end] = ACTIONS(673),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(675),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(675),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(675),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(675),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(675),
    [sym_preproc_directive] = ACTIONS(675),
    [anon_sym_typedef] = ACTIONS(675),
    [anon_sym_extern] = ACTIONS(675),
    [anon_sym_RBRACE] = ACTIONS(673),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_auto] = ACTIONS(675),
    [anon_sym_register] = ACTIONS(675),
    [anon_sym_inline] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_restrict] = ACTIONS(675),
    [anon_sym_volatile] = ACTIONS(675),
    [anon_sym__Atomic] = ACTIONS(675),
    [anon_sym_unsigned] = ACTIONS(675),
    [anon_sym_long] = ACTIONS(675),
    [anon_sym_short] = ACTIONS(675),
    [sym_primitive_type] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [sym_identifier] = ACTIONS(675),
    [sym_comment] = ACTIONS(42),
  },
  [145] = {
    [anon_sym_LPAREN] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(677),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(677),
    [sym_comment] = ACTIONS(42),
  },
  [146] = {
    [aux_sym_declaration_repeat1] = STATE(302),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(679),
    [sym_comment] = ACTIONS(42),
  },
  [147] = {
    [sym_storage_class_specifier] = STATE(147),
    [sym_type_qualifier] = STATE(147),
    [aux_sym__declaration_specifiers_repeat1] = STATE(147),
    [anon_sym_LPAREN] = ACTIONS(681),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_extern] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(681),
    [anon_sym_static] = ACTIONS(683),
    [anon_sym_auto] = ACTIONS(683),
    [anon_sym_register] = ACTIONS(683),
    [anon_sym_inline] = ACTIONS(683),
    [anon_sym_const] = ACTIONS(686),
    [anon_sym_restrict] = ACTIONS(686),
    [anon_sym_volatile] = ACTIONS(686),
    [anon_sym__Atomic] = ACTIONS(686),
    [sym_identifier] = ACTIONS(338),
    [sym_comment] = ACTIONS(42),
  },
  [148] = {
    [sym_storage_class_specifier] = STATE(147),
    [sym_type_qualifier] = STATE(147),
    [aux_sym__declaration_specifiers_repeat1] = STATE(147),
    [anon_sym_LPAREN] = ACTIONS(689),
    [anon_sym_SEMI] = ACTIONS(689),
    [anon_sym_extern] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_auto] = ACTIONS(109),
    [anon_sym_register] = ACTIONS(109),
    [anon_sym_inline] = ACTIONS(109),
    [anon_sym_const] = ACTIONS(111),
    [anon_sym_restrict] = ACTIONS(111),
    [anon_sym_volatile] = ACTIONS(111),
    [anon_sym__Atomic] = ACTIONS(111),
    [sym_identifier] = ACTIONS(691),
    [sym_comment] = ACTIONS(42),
  },
  [149] = {
    [anon_sym_LF] = ACTIONS(693),
    [sym_comment] = ACTIONS(50),
  },
  [150] = {
    [aux_sym_preproc_params_repeat1] = STATE(306),
    [anon_sym_COMMA] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(697),
    [sym_comment] = ACTIONS(42),
  },
  [151] = {
    [anon_sym_LF] = ACTIONS(699),
    [sym_preproc_arg] = ACTIONS(699),
    [sym_comment] = ACTIONS(50),
  },
  [152] = {
    [ts_builtin_sym_end] = ACTIONS(701),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(703),
    [sym_preproc_directive] = ACTIONS(703),
    [anon_sym_typedef] = ACTIONS(703),
    [anon_sym_extern] = ACTIONS(703),
    [anon_sym_RBRACE] = ACTIONS(701),
    [anon_sym_static] = ACTIONS(703),
    [anon_sym_auto] = ACTIONS(703),
    [anon_sym_register] = ACTIONS(703),
    [anon_sym_inline] = ACTIONS(703),
    [anon_sym_const] = ACTIONS(703),
    [anon_sym_restrict] = ACTIONS(703),
    [anon_sym_volatile] = ACTIONS(703),
    [anon_sym__Atomic] = ACTIONS(703),
    [anon_sym_unsigned] = ACTIONS(703),
    [anon_sym_long] = ACTIONS(703),
    [anon_sym_short] = ACTIONS(703),
    [sym_primitive_type] = ACTIONS(703),
    [anon_sym_enum] = ACTIONS(703),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_union] = ACTIONS(703),
    [sym_identifier] = ACTIONS(703),
    [sym_comment] = ACTIONS(42),
  },
  [153] = {
    [anon_sym_LF] = ACTIONS(705),
    [sym_comment] = ACTIONS(50),
  },
  [154] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(132),
    [sym_preproc_directive] = ACTIONS(132),
    [anon_sym_typedef] = ACTIONS(132),
    [anon_sym_extern] = ACTIONS(132),
    [anon_sym_static] = ACTIONS(132),
    [anon_sym_auto] = ACTIONS(132),
    [anon_sym_register] = ACTIONS(132),
    [anon_sym_inline] = ACTIONS(132),
    [anon_sym_const] = ACTIONS(132),
    [anon_sym_restrict] = ACTIONS(132),
    [anon_sym_volatile] = ACTIONS(132),
    [anon_sym__Atomic] = ACTIONS(132),
    [anon_sym_unsigned] = ACTIONS(132),
    [anon_sym_long] = ACTIONS(132),
    [anon_sym_short] = ACTIONS(132),
    [sym_primitive_type] = ACTIONS(132),
    [anon_sym_enum] = ACTIONS(132),
    [anon_sym_struct] = ACTIONS(132),
    [anon_sym_union] = ACTIONS(132),
    [sym_identifier] = ACTIONS(132),
    [sym_comment] = ACTIONS(42),
  },
  [155] = {
    [sym_preproc_params] = STATE(310),
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(707),
    [anon_sym_LF] = ACTIONS(709),
    [anon_sym_LPAREN] = ACTIONS(138),
    [sym_comment] = ACTIONS(50),
  },
  [156] = {
    [sym_preproc_include] = STATE(313),
    [sym_preproc_def] = STATE(313),
    [sym_preproc_function_def] = STATE(313),
    [sym_preproc_call] = STATE(313),
    [sym_preproc_if] = STATE(313),
    [sym_preproc_ifdef] = STATE(313),
    [sym_preproc_else] = STATE(312),
    [sym_preproc_elif] = STATE(312),
    [sym_function_definition] = STATE(313),
    [sym_declaration] = STATE(313),
    [sym_type_definition] = STATE(313),
    [sym__declaration_specifiers] = STATE(77),
    [sym_linkage_specification] = STATE(313),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(313),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(313),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(140),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(142),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(711),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(148),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(150),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(152),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(154),
    [sym_preproc_directive] = ACTIONS(156),
    [anon_sym_typedef] = ACTIONS(158),
    [anon_sym_extern] = ACTIONS(160),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [157] = {
    [sym_preproc_include] = STATE(316),
    [sym_preproc_def] = STATE(316),
    [sym_preproc_function_def] = STATE(316),
    [sym_preproc_call] = STATE(316),
    [sym_preproc_if] = STATE(316),
    [sym_preproc_ifdef] = STATE(316),
    [sym_preproc_else] = STATE(315),
    [sym_preproc_elif] = STATE(315),
    [sym_function_definition] = STATE(316),
    [sym_declaration] = STATE(316),
    [sym_type_definition] = STATE(316),
    [sym__declaration_specifiers] = STATE(77),
    [sym_linkage_specification] = STATE(316),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(316),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(316),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(140),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(142),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(713),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(148),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(150),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(152),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(154),
    [sym_preproc_directive] = ACTIONS(156),
    [anon_sym_typedef] = ACTIONS(158),
    [anon_sym_extern] = ACTIONS(160),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [158] = {
    [sym_preproc_include] = STATE(319),
    [sym_preproc_def] = STATE(319),
    [sym_preproc_function_def] = STATE(319),
    [sym_preproc_call] = STATE(319),
    [sym_preproc_if] = STATE(319),
    [sym_preproc_ifdef] = STATE(319),
    [sym_preproc_else] = STATE(318),
    [sym_preproc_elif] = STATE(318),
    [sym_function_definition] = STATE(319),
    [sym_declaration] = STATE(319),
    [sym_type_definition] = STATE(319),
    [sym__declaration_specifiers] = STATE(77),
    [sym_linkage_specification] = STATE(319),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(319),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(319),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(140),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(142),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(715),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(148),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(150),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(152),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(154),
    [sym_preproc_directive] = ACTIONS(156),
    [anon_sym_typedef] = ACTIONS(158),
    [anon_sym_extern] = ACTIONS(160),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [159] = {
    [sym_string_literal] = ACTIONS(717),
    [sym_system_lib_string] = ACTIONS(717),
    [sym_comment] = ACTIONS(42),
  },
  [160] = {
    [sym_identifier] = ACTIONS(719),
    [sym_comment] = ACTIONS(42),
  },
  [161] = {
    [sym_preproc_arg] = ACTIONS(721),
    [sym_comment] = ACTIONS(50),
  },
  [162] = {
    [sym_identifier] = ACTIONS(723),
    [sym_comment] = ACTIONS(42),
  },
  [163] = {
    [sym_identifier] = ACTIONS(725),
    [sym_comment] = ACTIONS(42),
  },
  [164] = {
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(727),
    [anon_sym_LF] = ACTIONS(729),
    [sym_comment] = ACTIONS(50),
  },
  [165] = {
    [sym_type_qualifier] = STATE(328),
    [sym__type_specifier] = STATE(327),
    [sym_sized_type_specifier] = STATE(327),
    [sym_enum_specifier] = STATE(327),
    [sym_struct_specifier] = STATE(327),
    [sym_union_specifier] = STATE(327),
    [sym_macro_type_specifier] = STATE(327),
    [aux_sym_type_definition_repeat1] = STATE(328),
    [aux_sym_sized_type_specifier_repeat1] = STATE(36),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(62),
    [anon_sym_long] = ACTIONS(62),
    [anon_sym_short] = ACTIONS(62),
    [sym_primitive_type] = ACTIONS(731),
    [anon_sym_enum] = ACTIONS(66),
    [anon_sym_struct] = ACTIONS(68),
    [anon_sym_union] = ACTIONS(70),
    [sym_identifier] = ACTIONS(72),
    [sym_comment] = ACTIONS(42),
  },
  [166] = {
    [anon_sym_extern] = ACTIONS(74),
    [anon_sym_static] = ACTIONS(74),
    [anon_sym_auto] = ACTIONS(74),
    [anon_sym_register] = ACTIONS(74),
    [anon_sym_inline] = ACTIONS(74),
    [anon_sym_const] = ACTIONS(74),
    [anon_sym_restrict] = ACTIONS(74),
    [anon_sym_volatile] = ACTIONS(74),
    [anon_sym__Atomic] = ACTIONS(74),
    [anon_sym_unsigned] = ACTIONS(74),
    [anon_sym_long] = ACTIONS(74),
    [anon_sym_short] = ACTIONS(74),
    [sym_primitive_type] = ACTIONS(74),
    [anon_sym_enum] = ACTIONS(74),
    [anon_sym_struct] = ACTIONS(74),
    [anon_sym_union] = ACTIONS(74),
    [sym_string_literal] = ACTIONS(733),
    [sym_identifier] = ACTIONS(74),
    [sym_comment] = ACTIONS(42),
  },
  [167] = {
    [sym__declarator] = STATE(331),
    [sym_pointer_declarator] = STATE(331),
    [sym_function_declarator] = STATE(331),
    [sym_array_declarator] = STATE(331),
    [sym_init_declarator] = STATE(332),
    [anon_sym_LPAREN] = ACTIONS(99),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_STAR] = ACTIONS(103),
    [sym_identifier] = ACTIONS(737),
    [sym_comment] = ACTIONS(42),
  },
  [168] = {
    [sym_preproc_include] = STATE(333),
    [sym_preproc_def] = STATE(333),
    [sym_preproc_function_def] = STATE(333),
    [sym_preproc_call] = STATE(333),
    [sym_preproc_if] = STATE(333),
    [sym_preproc_ifdef] = STATE(333),
    [sym_function_definition] = STATE(333),
    [sym_declaration] = STATE(333),
    [sym_type_definition] = STATE(333),
    [sym__declaration_specifiers] = STATE(167),
    [sym_linkage_specification] = STATE(333),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(333),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(333),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(383),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(385),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(387),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(739),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(391),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(393),
    [sym_preproc_directive] = ACTIONS(395),
    [anon_sym_typedef] = ACTIONS(397),
    [anon_sym_extern] = ACTIONS(399),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [169] = {
    [sym_preproc_include] = STATE(335),
    [sym_preproc_def] = STATE(335),
    [sym_preproc_function_def] = STATE(335),
    [sym_preproc_call] = STATE(335),
    [sym_preproc_if] = STATE(335),
    [sym_preproc_ifdef] = STATE(335),
    [sym_preproc_else] = STATE(334),
    [sym_preproc_elif] = STATE(334),
    [sym_function_definition] = STATE(335),
    [sym_declaration] = STATE(335),
    [sym_type_definition] = STATE(335),
    [sym__declaration_specifiers] = STATE(77),
    [sym_linkage_specification] = STATE(335),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(335),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(335),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(140),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(142),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(741),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(148),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(150),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(152),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(154),
    [sym_preproc_directive] = ACTIONS(156),
    [anon_sym_typedef] = ACTIONS(158),
    [anon_sym_extern] = ACTIONS(160),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [170] = {
    [sym_preproc_arg] = ACTIONS(743),
    [sym_comment] = ACTIONS(50),
  },
  [171] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(170),
    [sym_preproc_directive] = ACTIONS(170),
    [anon_sym_typedef] = ACTIONS(170),
    [anon_sym_extern] = ACTIONS(170),
    [anon_sym_static] = ACTIONS(170),
    [anon_sym_auto] = ACTIONS(170),
    [anon_sym_register] = ACTIONS(170),
    [anon_sym_inline] = ACTIONS(170),
    [anon_sym_const] = ACTIONS(170),
    [anon_sym_restrict] = ACTIONS(170),
    [anon_sym_volatile] = ACTIONS(170),
    [anon_sym__Atomic] = ACTIONS(170),
    [anon_sym_unsigned] = ACTIONS(170),
    [anon_sym_long] = ACTIONS(170),
    [anon_sym_short] = ACTIONS(170),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(170),
    [anon_sym_struct] = ACTIONS(170),
    [anon_sym_union] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_comment] = ACTIONS(42),
  },
  [172] = {
    [sym__type_declarator] = STATE(337),
    [sym_pointer_type_declarator] = STATE(99),
    [sym_function_type_declarator] = STATE(100),
    [sym_array_type_declarator] = STATE(101),
    [anon_sym_LPAREN] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(187),
    [sym_identifier] = ACTIONS(189),
    [sym_comment] = ACTIONS(42),
  },
  [173] = {
    [sym_type_qualifier] = STATE(103),
    [sym__type_specifier] = STATE(338),
    [sym_sized_type_specifier] = STATE(338),
    [sym_enum_specifier] = STATE(338),
    [sym_struct_specifier] = STATE(338),
    [sym_union_specifier] = STATE(338),
    [sym_macro_type_specifier] = STATE(338),
    [aux_sym_type_definition_repeat1] = STATE(103),
    [aux_sym_sized_type_specifier_repeat1] = STATE(36),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(62),
    [anon_sym_long] = ACTIONS(62),
    [anon_sym_short] = ACTIONS(62),
    [sym_primitive_type] = ACTIONS(745),
    [anon_sym_enum] = ACTIONS(66),
    [anon_sym_struct] = ACTIONS(68),
    [anon_sym_union] = ACTIONS(70),
    [sym_identifier] = ACTIONS(72),
    [sym_comment] = ACTIONS(42),
  },
  [174] = {
    [sym_function_definition] = STATE(340),
    [sym_declaration] = STATE(340),
    [sym__declaration_specifiers] = STATE(341),
    [sym_declaration_list] = STATE(340),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [175] = {
    [ts_builtin_sym_end] = ACTIONS(749),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(751),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(751),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(751),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(751),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(751),
    [sym_preproc_directive] = ACTIONS(751),
    [anon_sym_typedef] = ACTIONS(751),
    [anon_sym_extern] = ACTIONS(751),
    [anon_sym_RBRACE] = ACTIONS(749),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_auto] = ACTIONS(751),
    [anon_sym_register] = ACTIONS(751),
    [anon_sym_inline] = ACTIONS(751),
    [anon_sym_const] = ACTIONS(751),
    [anon_sym_restrict] = ACTIONS(751),
    [anon_sym_volatile] = ACTIONS(751),
    [anon_sym__Atomic] = ACTIONS(751),
    [anon_sym_unsigned] = ACTIONS(751),
    [anon_sym_long] = ACTIONS(751),
    [anon_sym_short] = ACTIONS(751),
    [sym_primitive_type] = ACTIONS(751),
    [anon_sym_enum] = ACTIONS(751),
    [anon_sym_struct] = ACTIONS(751),
    [anon_sym_union] = ACTIONS(751),
    [sym_identifier] = ACTIONS(751),
    [sym_comment] = ACTIONS(42),
  },
  [176] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(258),
    [sym_preproc_directive] = ACTIONS(258),
    [anon_sym_typedef] = ACTIONS(258),
    [anon_sym_extern] = ACTIONS(258),
    [anon_sym_static] = ACTIONS(258),
    [anon_sym_auto] = ACTIONS(258),
    [anon_sym_register] = ACTIONS(258),
    [anon_sym_inline] = ACTIONS(258),
    [anon_sym_const] = ACTIONS(258),
    [anon_sym_restrict] = ACTIONS(258),
    [anon_sym_volatile] = ACTIONS(258),
    [anon_sym__Atomic] = ACTIONS(258),
    [anon_sym_unsigned] = ACTIONS(258),
    [anon_sym_long] = ACTIONS(258),
    [anon_sym_short] = ACTIONS(258),
    [sym_primitive_type] = ACTIONS(258),
    [anon_sym_enum] = ACTIONS(258),
    [anon_sym_struct] = ACTIONS(258),
    [anon_sym_union] = ACTIONS(258),
    [sym_identifier] = ACTIONS(258),
    [sym_comment] = ACTIONS(42),
  },
  [177] = {
    [sym_compound_statement] = STATE(344),
    [sym_parameter_list] = STATE(145),
    [aux_sym_declaration_repeat1] = STATE(345),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(270),
    [anon_sym_EQ] = ACTIONS(272),
    [sym_comment] = ACTIONS(42),
  },
  [178] = {
    [aux_sym_declaration_repeat1] = STATE(345),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(753),
    [sym_comment] = ACTIONS(42),
  },
  [179] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(757),
    [sym_comment] = ACTIONS(42),
  },
  [180] = {
    [sym_preproc_include] = STATE(180),
    [sym_preproc_def] = STATE(180),
    [sym_preproc_function_def] = STATE(180),
    [sym_preproc_call] = STATE(180),
    [sym_preproc_if] = STATE(180),
    [sym_preproc_ifdef] = STATE(180),
    [sym_function_definition] = STATE(180),
    [sym_declaration] = STATE(180),
    [sym_type_definition] = STATE(180),
    [sym__declaration_specifiers] = STATE(77),
    [sym_linkage_specification] = STATE(180),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(180),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(759),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(762),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(765),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(768),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(770),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(773),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(768),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(768),
    [sym_preproc_directive] = ACTIONS(776),
    [anon_sym_typedef] = ACTIONS(779),
    [anon_sym_extern] = ACTIONS(782),
    [anon_sym_static] = ACTIONS(308),
    [anon_sym_auto] = ACTIONS(308),
    [anon_sym_register] = ACTIONS(308),
    [anon_sym_inline] = ACTIONS(308),
    [anon_sym_const] = ACTIONS(311),
    [anon_sym_restrict] = ACTIONS(311),
    [anon_sym_volatile] = ACTIONS(311),
    [anon_sym__Atomic] = ACTIONS(311),
    [anon_sym_unsigned] = ACTIONS(314),
    [anon_sym_long] = ACTIONS(314),
    [anon_sym_short] = ACTIONS(314),
    [sym_primitive_type] = ACTIONS(317),
    [anon_sym_enum] = ACTIONS(320),
    [anon_sym_struct] = ACTIONS(323),
    [anon_sym_union] = ACTIONS(326),
    [sym_identifier] = ACTIONS(329),
    [sym_comment] = ACTIONS(42),
  },
  [181] = {
    [ts_builtin_sym_end] = ACTIONS(785),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(787),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(787),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(787),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(787),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(787),
    [sym_preproc_directive] = ACTIONS(787),
    [anon_sym_typedef] = ACTIONS(787),
    [anon_sym_extern] = ACTIONS(787),
    [anon_sym_RBRACE] = ACTIONS(785),
    [anon_sym_static] = ACTIONS(787),
    [anon_sym_auto] = ACTIONS(787),
    [anon_sym_register] = ACTIONS(787),
    [anon_sym_inline] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(787),
    [anon_sym_restrict] = ACTIONS(787),
    [anon_sym_volatile] = ACTIONS(787),
    [anon_sym__Atomic] = ACTIONS(787),
    [anon_sym_unsigned] = ACTIONS(787),
    [anon_sym_long] = ACTIONS(787),
    [anon_sym_short] = ACTIONS(787),
    [sym_primitive_type] = ACTIONS(787),
    [anon_sym_enum] = ACTIONS(787),
    [anon_sym_struct] = ACTIONS(787),
    [anon_sym_union] = ACTIONS(787),
    [sym_identifier] = ACTIONS(787),
    [sym_comment] = ACTIONS(42),
  },
  [182] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(789),
    [sym_comment] = ACTIONS(42),
  },
  [183] = {
    [ts_builtin_sym_end] = ACTIONS(791),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(793),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(793),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(793),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(793),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(793),
    [sym_preproc_directive] = ACTIONS(793),
    [anon_sym_typedef] = ACTIONS(793),
    [anon_sym_extern] = ACTIONS(793),
    [anon_sym_RBRACE] = ACTIONS(791),
    [anon_sym_static] = ACTIONS(793),
    [anon_sym_auto] = ACTIONS(793),
    [anon_sym_register] = ACTIONS(793),
    [anon_sym_inline] = ACTIONS(793),
    [anon_sym_const] = ACTIONS(793),
    [anon_sym_restrict] = ACTIONS(793),
    [anon_sym_volatile] = ACTIONS(793),
    [anon_sym__Atomic] = ACTIONS(793),
    [anon_sym_unsigned] = ACTIONS(793),
    [anon_sym_long] = ACTIONS(793),
    [anon_sym_short] = ACTIONS(793),
    [sym_primitive_type] = ACTIONS(793),
    [anon_sym_enum] = ACTIONS(793),
    [anon_sym_struct] = ACTIONS(793),
    [anon_sym_union] = ACTIONS(793),
    [sym_identifier] = ACTIONS(793),
    [sym_comment] = ACTIONS(42),
  },
  [184] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(795),
    [sym_comment] = ACTIONS(42),
  },
  [185] = {
    [ts_builtin_sym_end] = ACTIONS(797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(799),
    [sym_preproc_directive] = ACTIONS(799),
    [anon_sym_typedef] = ACTIONS(799),
    [anon_sym_extern] = ACTIONS(799),
    [anon_sym_RBRACE] = ACTIONS(797),
    [anon_sym_static] = ACTIONS(799),
    [anon_sym_auto] = ACTIONS(799),
    [anon_sym_register] = ACTIONS(799),
    [anon_sym_inline] = ACTIONS(799),
    [anon_sym_const] = ACTIONS(799),
    [anon_sym_restrict] = ACTIONS(799),
    [anon_sym_volatile] = ACTIONS(799),
    [anon_sym__Atomic] = ACTIONS(799),
    [anon_sym_unsigned] = ACTIONS(799),
    [anon_sym_long] = ACTIONS(799),
    [anon_sym_short] = ACTIONS(799),
    [sym_primitive_type] = ACTIONS(799),
    [anon_sym_enum] = ACTIONS(799),
    [anon_sym_struct] = ACTIONS(799),
    [anon_sym_union] = ACTIONS(799),
    [sym_identifier] = ACTIONS(799),
    [sym_comment] = ACTIONS(42),
  },
  [186] = {
    [anon_sym_RBRACE] = ACTIONS(801),
    [sym_comment] = ACTIONS(42),
  },
  [187] = {
    [anon_sym_LPAREN] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_comment] = ACTIONS(42),
  },
  [188] = {
    [aux_sym_enumerator_list_repeat1] = STATE(351),
    [anon_sym_COMMA] = ACTIONS(803),
    [anon_sym_RBRACE] = ACTIONS(801),
    [sym_comment] = ACTIONS(42),
  },
  [189] = {
    [anon_sym_LPAREN] = ACTIONS(487),
    [anon_sym_STAR] = ACTIONS(487),
    [sym_identifier] = ACTIONS(487),
    [sym_comment] = ACTIONS(42),
  },
  [190] = {
    [anon_sym_LPAREN] = ACTIONS(497),
    [anon_sym_STAR] = ACTIONS(497),
    [sym_identifier] = ACTIONS(497),
    [sym_comment] = ACTIONS(42),
  },
  [191] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(122),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(123),
    [sym__declaration_specifiers] = STATE(124),
    [sym_storage_class_specifier] = STATE(126),
    [sym_type_qualifier] = STATE(126),
    [sym__type_specifier] = STATE(125),
    [sym_sized_type_specifier] = STATE(125),
    [sym_enum_specifier] = STATE(125),
    [sym_struct_specifier] = STATE(125),
    [sym_union_specifier] = STATE(125),
    [sym_field_declaration] = STATE(227),
    [sym_macro_type_specifier] = STATE(125),
    [aux_sym__declaration_specifiers_repeat1] = STATE(126),
    [aux_sym_sized_type_specifier_repeat1] = STATE(127),
    [aux_sym_field_declaration_list_repeat1] = STATE(227),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(220),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(224),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_RBRACE] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(228),
    [anon_sym_long] = ACTIONS(228),
    [anon_sym_short] = ACTIONS(228),
    [sym_primitive_type] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [192] = {
    [anon_sym_LPAREN] = ACTIONS(525),
    [anon_sym_STAR] = ACTIONS(525),
    [sym_identifier] = ACTIONS(525),
    [sym_comment] = ACTIONS(42),
  },
  [193] = {
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_STAR] = ACTIONS(529),
    [sym_identifier] = ACTIONS(529),
    [sym_comment] = ACTIONS(42),
  },
  [194] = {
    [anon_sym_RPAREN] = ACTIONS(807),
    [sym_comment] = ACTIONS(42),
  },
  [195] = {
    [sym__type_declarator] = STATE(197),
    [sym_pointer_type_declarator] = STATE(99),
    [sym_function_type_declarator] = STATE(100),
    [sym_array_type_declarator] = STATE(101),
    [anon_sym_LPAREN] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(443),
    [sym_identifier] = ACTIONS(189),
    [sym_comment] = ACTIONS(42),
  },
  [196] = {
    [sym_parameter_list] = STATE(200),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_LBRACK] = ACTIONS(449),
    [sym_comment] = ACTIONS(42),
  },
  [197] = {
    [sym_parameter_list] = STATE(200),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_RPAREN] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(811),
    [anon_sym_LBRACK] = ACTIONS(449),
    [sym_comment] = ACTIONS(42),
  },
  [198] = {
    [ts_builtin_sym_end] = ACTIONS(813),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(815),
    [sym_preproc_directive] = ACTIONS(815),
    [anon_sym_typedef] = ACTIONS(815),
    [anon_sym_extern] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_auto] = ACTIONS(815),
    [anon_sym_register] = ACTIONS(815),
    [anon_sym_inline] = ACTIONS(815),
    [anon_sym_const] = ACTIONS(815),
    [anon_sym_restrict] = ACTIONS(815),
    [anon_sym_volatile] = ACTIONS(815),
    [anon_sym__Atomic] = ACTIONS(815),
    [anon_sym_unsigned] = ACTIONS(815),
    [anon_sym_long] = ACTIONS(815),
    [anon_sym_short] = ACTIONS(815),
    [sym_primitive_type] = ACTIONS(815),
    [anon_sym_enum] = ACTIONS(815),
    [anon_sym_struct] = ACTIONS(815),
    [anon_sym_union] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_comment] = ACTIONS(42),
  },
  [199] = {
    [sym__declaration_specifiers] = STATE(356),
    [sym_storage_class_specifier] = STATE(296),
    [sym_type_qualifier] = STATE(296),
    [sym__type_specifier] = STATE(294),
    [sym_sized_type_specifier] = STATE(294),
    [sym_enum_specifier] = STATE(294),
    [sym_struct_specifier] = STATE(294),
    [sym_union_specifier] = STATE(294),
    [sym__expression] = STATE(357),
    [sym_conditional_expression] = STATE(357),
    [sym_assignment_expression] = STATE(357),
    [sym_pointer_expression] = STATE(357),
    [sym_logical_expression] = STATE(357),
    [sym_bitwise_expression] = STATE(357),
    [sym_equality_expression] = STATE(357),
    [sym_relational_expression] = STATE(357),
    [sym_shift_expression] = STATE(357),
    [sym_math_expression] = STATE(357),
    [sym_cast_expression] = STATE(357),
    [sym_sizeof_expression] = STATE(357),
    [sym_subscript_expression] = STATE(357),
    [sym_call_expression] = STATE(357),
    [sym_field_expression] = STATE(357),
    [sym_compound_literal_expression] = STATE(357),
    [sym_parenthesized_expression] = STATE(357),
    [sym_concatenated_string] = STATE(357),
    [sym_macro_type_specifier] = STATE(294),
    [aux_sym__declaration_specifiers_repeat1] = STATE(296),
    [aux_sym_sized_type_specifier_repeat1] = STATE(297),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(817),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(639),
    [anon_sym_long] = ACTIONS(639),
    [anon_sym_short] = ACTIONS(639),
    [sym_primitive_type] = ACTIONS(641),
    [anon_sym_enum] = ACTIONS(643),
    [anon_sym_struct] = ACTIONS(645),
    [anon_sym_union] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(819),
    [sym_char_literal] = ACTIONS(819),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(821),
    [sym_false] = ACTIONS(821),
    [sym_null] = ACTIONS(821),
    [sym_identifier] = ACTIONS(665),
    [sym_comment] = ACTIONS(42),
  },
  [200] = {
    [anon_sym_LPAREN] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(823),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_LBRACK] = ACTIONS(823),
    [sym_comment] = ACTIONS(42),
  },
  [201] = {
    [sym_parameter_list] = STATE(200),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_SEMI] = ACTIONS(825),
    [anon_sym_LBRACK] = ACTIONS(449),
    [sym_comment] = ACTIONS(42),
  },
  [202] = {
    [ts_builtin_sym_end] = ACTIONS(827),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(829),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(829),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(829),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(829),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(829),
    [sym_preproc_directive] = ACTIONS(829),
    [anon_sym_typedef] = ACTIONS(829),
    [anon_sym_extern] = ACTIONS(829),
    [anon_sym_RBRACE] = ACTIONS(827),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_auto] = ACTIONS(829),
    [anon_sym_register] = ACTIONS(829),
    [anon_sym_inline] = ACTIONS(829),
    [anon_sym_const] = ACTIONS(829),
    [anon_sym_restrict] = ACTIONS(829),
    [anon_sym_volatile] = ACTIONS(829),
    [anon_sym__Atomic] = ACTIONS(829),
    [anon_sym_unsigned] = ACTIONS(829),
    [anon_sym_long] = ACTIONS(829),
    [anon_sym_short] = ACTIONS(829),
    [sym_primitive_type] = ACTIONS(829),
    [anon_sym_enum] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_union] = ACTIONS(829),
    [sym_identifier] = ACTIONS(829),
    [sym_comment] = ACTIONS(42),
  },
  [203] = {
    [sym_preproc_include] = STATE(360),
    [sym_preproc_def] = STATE(360),
    [sym_preproc_function_def] = STATE(360),
    [sym_preproc_call] = STATE(360),
    [sym_preproc_if] = STATE(360),
    [sym_preproc_ifdef] = STATE(360),
    [sym_function_definition] = STATE(360),
    [sym_declaration] = STATE(360),
    [sym_type_definition] = STATE(360),
    [sym__declaration_specifiers] = STATE(17),
    [sym_linkage_specification] = STATE(360),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(360),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(360),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(10),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(12),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(14),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(16),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(18),
    [sym_preproc_directive] = ACTIONS(20),
    [anon_sym_typedef] = ACTIONS(22),
    [anon_sym_extern] = ACTIONS(24),
    [anon_sym_RBRACE] = ACTIONS(831),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [204] = {
    [sym_storage_class_specifier] = STATE(361),
    [sym_type_qualifier] = STATE(361),
    [aux_sym__declaration_specifiers_repeat1] = STATE(361),
    [anon_sym_LPAREN] = ACTIONS(278),
    [anon_sym_extern] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_auto] = ACTIONS(109),
    [anon_sym_register] = ACTIONS(109),
    [anon_sym_inline] = ACTIONS(109),
    [anon_sym_const] = ACTIONS(111),
    [anon_sym_restrict] = ACTIONS(111),
    [anon_sym_volatile] = ACTIONS(111),
    [anon_sym__Atomic] = ACTIONS(111),
    [sym_identifier] = ACTIONS(280),
    [sym_comment] = ACTIONS(42),
  },
  [205] = {
    [sym_storage_class_specifier] = STATE(362),
    [sym_type_qualifier] = STATE(362),
    [aux_sym__declaration_specifiers_repeat1] = STATE(362),
    [anon_sym_LPAREN] = ACTIONS(278),
    [anon_sym_extern] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_auto] = ACTIONS(109),
    [anon_sym_register] = ACTIONS(109),
    [anon_sym_inline] = ACTIONS(109),
    [anon_sym_const] = ACTIONS(111),
    [anon_sym_restrict] = ACTIONS(111),
    [anon_sym_volatile] = ACTIONS(111),
    [anon_sym__Atomic] = ACTIONS(111),
    [sym_identifier] = ACTIONS(280),
    [sym_comment] = ACTIONS(42),
  },
  [206] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(206),
    [anon_sym_LPAREN] = ACTIONS(348),
    [anon_sym_extern] = ACTIONS(350),
    [anon_sym_STAR] = ACTIONS(348),
    [anon_sym_static] = ACTIONS(350),
    [anon_sym_auto] = ACTIONS(350),
    [anon_sym_register] = ACTIONS(350),
    [anon_sym_inline] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(350),
    [anon_sym_restrict] = ACTIONS(350),
    [anon_sym_volatile] = ACTIONS(350),
    [anon_sym__Atomic] = ACTIONS(350),
    [anon_sym_unsigned] = ACTIONS(833),
    [anon_sym_long] = ACTIONS(833),
    [anon_sym_short] = ACTIONS(833),
    [sym_primitive_type] = ACTIONS(350),
    [sym_identifier] = ACTIONS(350),
    [sym_comment] = ACTIONS(42),
  },
  [207] = {
    [anon_sym_LPAREN] = ACTIONS(836),
    [anon_sym_COMMA] = ACTIONS(836),
    [anon_sym_RPAREN] = ACTIONS(836),
    [anon_sym_SEMI] = ACTIONS(836),
    [anon_sym_extern] = ACTIONS(838),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_LBRACK] = ACTIONS(836),
    [anon_sym_static] = ACTIONS(838),
    [anon_sym_auto] = ACTIONS(838),
    [anon_sym_register] = ACTIONS(838),
    [anon_sym_inline] = ACTIONS(838),
    [anon_sym_const] = ACTIONS(838),
    [anon_sym_restrict] = ACTIONS(838),
    [anon_sym_volatile] = ACTIONS(838),
    [anon_sym__Atomic] = ACTIONS(838),
    [anon_sym_COLON] = ACTIONS(836),
    [sym_identifier] = ACTIONS(838),
    [sym_comment] = ACTIONS(42),
  },
  [208] = {
    [sym__expression] = STATE(370),
    [sym_conditional_expression] = STATE(370),
    [sym_assignment_expression] = STATE(370),
    [sym_pointer_expression] = STATE(370),
    [sym_logical_expression] = STATE(370),
    [sym_bitwise_expression] = STATE(370),
    [sym_equality_expression] = STATE(370),
    [sym_relational_expression] = STATE(370),
    [sym_shift_expression] = STATE(370),
    [sym_math_expression] = STATE(370),
    [sym_cast_expression] = STATE(370),
    [sym_sizeof_expression] = STATE(370),
    [sym_subscript_expression] = STATE(370),
    [sym_call_expression] = STATE(370),
    [sym_field_expression] = STATE(370),
    [sym_compound_literal_expression] = STATE(370),
    [sym_parenthesized_expression] = STATE(370),
    [sym_concatenated_string] = STATE(370),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [sym_number_literal] = ACTIONS(854),
    [sym_char_literal] = ACTIONS(854),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(858),
    [sym_false] = ACTIONS(858),
    [sym_null] = ACTIONS(858),
    [sym_identifier] = ACTIONS(858),
    [sym_comment] = ACTIONS(42),
  },
  [209] = {
    [sym_enumerator] = STATE(372),
    [anon_sym_RBRACE] = ACTIONS(860),
    [sym_identifier] = ACTIONS(210),
    [sym_comment] = ACTIONS(42),
  },
  [210] = {
    [aux_sym_enumerator_list_repeat1] = STATE(374),
    [anon_sym_COMMA] = ACTIONS(862),
    [anon_sym_RBRACE] = ACTIONS(860),
    [sym_comment] = ACTIONS(42),
  },
  [211] = {
    [sym_preproc_else_in_field_declaration_list] = STATE(378),
    [sym_preproc_elif_in_field_declaration_list] = STATE(379),
    [sym__declaration_specifiers] = STATE(124),
    [sym_storage_class_specifier] = STATE(126),
    [sym_type_qualifier] = STATE(126),
    [sym__type_specifier] = STATE(125),
    [sym_sized_type_specifier] = STATE(125),
    [sym_enum_specifier] = STATE(125),
    [sym_struct_specifier] = STATE(125),
    [sym_union_specifier] = STATE(125),
    [sym_field_declaration] = STATE(380),
    [sym_macro_type_specifier] = STATE(125),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(380),
    [aux_sym__declaration_specifiers_repeat1] = STATE(126),
    [aux_sym_sized_type_specifier_repeat1] = STATE(127),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(864),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(868),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(228),
    [anon_sym_long] = ACTIONS(228),
    [anon_sym_short] = ACTIONS(228),
    [sym_primitive_type] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [212] = {
    [sym_preproc_else_in_field_declaration_list] = STATE(382),
    [sym_preproc_elif_in_field_declaration_list] = STATE(383),
    [sym__declaration_specifiers] = STATE(124),
    [sym_storage_class_specifier] = STATE(126),
    [sym_type_qualifier] = STATE(126),
    [sym__type_specifier] = STATE(125),
    [sym_sized_type_specifier] = STATE(125),
    [sym_enum_specifier] = STATE(125),
    [sym_struct_specifier] = STATE(125),
    [sym_union_specifier] = STATE(125),
    [sym_field_declaration] = STATE(384),
    [sym_macro_type_specifier] = STATE(125),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(384),
    [aux_sym__declaration_specifiers_repeat1] = STATE(126),
    [aux_sym_sized_type_specifier_repeat1] = STATE(127),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(870),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(868),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(228),
    [anon_sym_long] = ACTIONS(228),
    [anon_sym_short] = ACTIONS(228),
    [sym_primitive_type] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [213] = {
    [sym_preproc_else_in_field_declaration_list] = STATE(386),
    [sym_preproc_elif_in_field_declaration_list] = STATE(387),
    [sym__declaration_specifiers] = STATE(124),
    [sym_storage_class_specifier] = STATE(126),
    [sym_type_qualifier] = STATE(126),
    [sym__type_specifier] = STATE(125),
    [sym_sized_type_specifier] = STATE(125),
    [sym_enum_specifier] = STATE(125),
    [sym_struct_specifier] = STATE(125),
    [sym_union_specifier] = STATE(125),
    [sym_field_declaration] = STATE(388),
    [sym_macro_type_specifier] = STATE(125),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(388),
    [aux_sym__declaration_specifiers_repeat1] = STATE(126),
    [aux_sym_sized_type_specifier_repeat1] = STATE(127),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(868),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(228),
    [anon_sym_long] = ACTIONS(228),
    [anon_sym_short] = ACTIONS(228),
    [sym_primitive_type] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [214] = {
    [sym__field_declarator] = STATE(390),
    [sym_pointer_field_declarator] = STATE(220),
    [sym_function_field_declarator] = STATE(221),
    [sym_array_field_declarator] = STATE(222),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(874),
    [sym_identifier] = ACTIONS(517),
    [sym_comment] = ACTIONS(42),
  },
  [215] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(876),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(878),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(878),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(878),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(878),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(878),
    [anon_sym_extern] = ACTIONS(876),
    [anon_sym_RBRACE] = ACTIONS(878),
    [anon_sym_static] = ACTIONS(876),
    [anon_sym_auto] = ACTIONS(876),
    [anon_sym_register] = ACTIONS(876),
    [anon_sym_inline] = ACTIONS(876),
    [anon_sym_const] = ACTIONS(876),
    [anon_sym_restrict] = ACTIONS(876),
    [anon_sym_volatile] = ACTIONS(876),
    [anon_sym__Atomic] = ACTIONS(876),
    [anon_sym_unsigned] = ACTIONS(876),
    [anon_sym_long] = ACTIONS(876),
    [anon_sym_short] = ACTIONS(876),
    [sym_primitive_type] = ACTIONS(876),
    [anon_sym_enum] = ACTIONS(876),
    [anon_sym_struct] = ACTIONS(876),
    [anon_sym_union] = ACTIONS(876),
    [sym_identifier] = ACTIONS(876),
    [sym_comment] = ACTIONS(42),
  },
  [216] = {
    [sym__field_declarator] = STATE(391),
    [sym_pointer_field_declarator] = STATE(220),
    [sym_function_field_declarator] = STATE(221),
    [sym_array_field_declarator] = STATE(222),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(513),
    [sym_identifier] = ACTIONS(517),
    [sym_comment] = ACTIONS(42),
  },
  [217] = {
    [sym__expression] = STATE(399),
    [sym_conditional_expression] = STATE(399),
    [sym_assignment_expression] = STATE(399),
    [sym_pointer_expression] = STATE(399),
    [sym_logical_expression] = STATE(399),
    [sym_bitwise_expression] = STATE(399),
    [sym_equality_expression] = STATE(399),
    [sym_relational_expression] = STATE(399),
    [sym_shift_expression] = STATE(399),
    [sym_math_expression] = STATE(399),
    [sym_cast_expression] = STATE(399),
    [sym_sizeof_expression] = STATE(399),
    [sym_subscript_expression] = STATE(399),
    [sym_call_expression] = STATE(399),
    [sym_field_expression] = STATE(399),
    [sym_compound_literal_expression] = STATE(399),
    [sym_parenthesized_expression] = STATE(399),
    [sym_concatenated_string] = STATE(399),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(894),
    [sym_char_literal] = ACTIONS(894),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(898),
    [sym_false] = ACTIONS(898),
    [sym_null] = ACTIONS(898),
    [sym_identifier] = ACTIONS(898),
    [sym_comment] = ACTIONS(42),
  },
  [218] = {
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_COMMA] = ACTIONS(900),
    [anon_sym_RPAREN] = ACTIONS(900),
    [anon_sym_SEMI] = ACTIONS(900),
    [anon_sym_LBRACK] = ACTIONS(900),
    [anon_sym_COLON] = ACTIONS(900),
    [sym_comment] = ACTIONS(42),
  },
  [219] = {
    [sym_parameter_list] = STATE(404),
    [aux_sym_field_declaration_repeat1] = STATE(405),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_COMMA] = ACTIONS(902),
    [anon_sym_SEMI] = ACTIONS(904),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_COLON] = ACTIONS(908),
    [sym_comment] = ACTIONS(42),
  },
  [220] = {
    [anon_sym_LPAREN] = ACTIONS(910),
    [anon_sym_COMMA] = ACTIONS(910),
    [anon_sym_RPAREN] = ACTIONS(910),
    [anon_sym_SEMI] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(910),
    [anon_sym_COLON] = ACTIONS(910),
    [sym_comment] = ACTIONS(42),
  },
  [221] = {
    [anon_sym_LPAREN] = ACTIONS(912),
    [anon_sym_COMMA] = ACTIONS(912),
    [anon_sym_RPAREN] = ACTIONS(912),
    [anon_sym_SEMI] = ACTIONS(912),
    [anon_sym_LBRACK] = ACTIONS(912),
    [anon_sym_COLON] = ACTIONS(912),
    [sym_comment] = ACTIONS(42),
  },
  [222] = {
    [anon_sym_LPAREN] = ACTIONS(914),
    [anon_sym_COMMA] = ACTIONS(914),
    [anon_sym_RPAREN] = ACTIONS(914),
    [anon_sym_SEMI] = ACTIONS(914),
    [anon_sym_LBRACK] = ACTIONS(914),
    [anon_sym_COLON] = ACTIONS(914),
    [sym_comment] = ACTIONS(42),
  },
  [223] = {
    [sym_storage_class_specifier] = STATE(406),
    [sym_type_qualifier] = STATE(406),
    [aux_sym__declaration_specifiers_repeat1] = STATE(406),
    [anon_sym_LPAREN] = ACTIONS(278),
    [anon_sym_SEMI] = ACTIONS(278),
    [anon_sym_extern] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_auto] = ACTIONS(109),
    [anon_sym_register] = ACTIONS(109),
    [anon_sym_inline] = ACTIONS(109),
    [anon_sym_const] = ACTIONS(111),
    [anon_sym_restrict] = ACTIONS(111),
    [anon_sym_volatile] = ACTIONS(111),
    [anon_sym__Atomic] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(278),
    [sym_identifier] = ACTIONS(280),
    [sym_comment] = ACTIONS(42),
  },
  [224] = {
    [sym_storage_class_specifier] = STATE(407),
    [sym_type_qualifier] = STATE(407),
    [aux_sym__declaration_specifiers_repeat1] = STATE(407),
    [anon_sym_LPAREN] = ACTIONS(278),
    [anon_sym_SEMI] = ACTIONS(278),
    [anon_sym_extern] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_auto] = ACTIONS(109),
    [anon_sym_register] = ACTIONS(109),
    [anon_sym_inline] = ACTIONS(109),
    [anon_sym_const] = ACTIONS(111),
    [anon_sym_restrict] = ACTIONS(111),
    [anon_sym_volatile] = ACTIONS(111),
    [anon_sym__Atomic] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(278),
    [sym_identifier] = ACTIONS(280),
    [sym_comment] = ACTIONS(42),
  },
  [225] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(225),
    [anon_sym_LPAREN] = ACTIONS(348),
    [anon_sym_SEMI] = ACTIONS(348),
    [anon_sym_extern] = ACTIONS(350),
    [anon_sym_STAR] = ACTIONS(348),
    [anon_sym_static] = ACTIONS(350),
    [anon_sym_auto] = ACTIONS(350),
    [anon_sym_register] = ACTIONS(350),
    [anon_sym_inline] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(350),
    [anon_sym_restrict] = ACTIONS(350),
    [anon_sym_volatile] = ACTIONS(350),
    [anon_sym__Atomic] = ACTIONS(350),
    [anon_sym_unsigned] = ACTIONS(916),
    [anon_sym_long] = ACTIONS(916),
    [anon_sym_short] = ACTIONS(916),
    [sym_primitive_type] = ACTIONS(350),
    [anon_sym_COLON] = ACTIONS(348),
    [sym_identifier] = ACTIONS(350),
    [sym_comment] = ACTIONS(42),
  },
  [226] = {
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_extern] = ACTIONS(921),
    [anon_sym_STAR] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(921),
    [anon_sym_auto] = ACTIONS(921),
    [anon_sym_register] = ACTIONS(921),
    [anon_sym_inline] = ACTIONS(921),
    [anon_sym_const] = ACTIONS(921),
    [anon_sym_restrict] = ACTIONS(921),
    [anon_sym_volatile] = ACTIONS(921),
    [anon_sym__Atomic] = ACTIONS(921),
    [anon_sym_COLON] = ACTIONS(919),
    [sym_identifier] = ACTIONS(921),
    [sym_comment] = ACTIONS(42),
  },
  [227] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(122),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(123),
    [sym__declaration_specifiers] = STATE(124),
    [sym_storage_class_specifier] = STATE(126),
    [sym_type_qualifier] = STATE(126),
    [sym__type_specifier] = STATE(125),
    [sym_sized_type_specifier] = STATE(125),
    [sym_enum_specifier] = STATE(125),
    [sym_struct_specifier] = STATE(125),
    [sym_union_specifier] = STATE(125),
    [sym_field_declaration] = STATE(227),
    [sym_macro_type_specifier] = STATE(125),
    [aux_sym__declaration_specifiers_repeat1] = STATE(126),
    [aux_sym_sized_type_specifier_repeat1] = STATE(127),
    [aux_sym_field_declaration_list_repeat1] = STATE(227),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(923),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(926),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(929),
    [anon_sym_extern] = ACTIONS(932),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_static] = ACTIONS(932),
    [anon_sym_auto] = ACTIONS(932),
    [anon_sym_register] = ACTIONS(932),
    [anon_sym_inline] = ACTIONS(932),
    [anon_sym_const] = ACTIONS(937),
    [anon_sym_restrict] = ACTIONS(937),
    [anon_sym_volatile] = ACTIONS(937),
    [anon_sym__Atomic] = ACTIONS(937),
    [anon_sym_unsigned] = ACTIONS(940),
    [anon_sym_long] = ACTIONS(940),
    [anon_sym_short] = ACTIONS(940),
    [sym_primitive_type] = ACTIONS(943),
    [anon_sym_enum] = ACTIONS(946),
    [anon_sym_struct] = ACTIONS(949),
    [anon_sym_union] = ACTIONS(952),
    [sym_identifier] = ACTIONS(955),
    [sym_comment] = ACTIONS(42),
  },
  [228] = {
    [sym__declaration_specifiers] = STATE(239),
    [sym__abstract_declarator] = STATE(408),
    [sym_abstract_pointer_declarator] = STATE(408),
    [sym_abstract_function_declarator] = STATE(408),
    [sym_abstract_array_declarator] = STATE(408),
    [sym_storage_class_specifier] = STATE(241),
    [sym_type_qualifier] = STATE(241),
    [sym__type_specifier] = STATE(240),
    [sym_sized_type_specifier] = STATE(240),
    [sym_enum_specifier] = STATE(240),
    [sym_struct_specifier] = STATE(240),
    [sym_union_specifier] = STATE(240),
    [sym_parameter_list] = STATE(232),
    [sym_parameter_declaration] = STATE(237),
    [sym_macro_type_specifier] = STATE(240),
    [aux_sym__declaration_specifiers_repeat1] = STATE(241),
    [aux_sym_sized_type_specifier_repeat1] = STATE(242),
    [anon_sym_LPAREN] = ACTIONS(533),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(553),
    [anon_sym_RPAREN] = ACTIONS(555),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_STAR] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(539),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(557),
    [anon_sym_long] = ACTIONS(557),
    [anon_sym_short] = ACTIONS(557),
    [sym_primitive_type] = ACTIONS(559),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [229] = {
    [sym__abstract_declarator] = STATE(409),
    [sym_abstract_pointer_declarator] = STATE(409),
    [sym_abstract_function_declarator] = STATE(409),
    [sym_abstract_array_declarator] = STATE(409),
    [sym_parameter_list] = STATE(232),
    [anon_sym_LPAREN] = ACTIONS(533),
    [anon_sym_RPAREN] = ACTIONS(958),
    [anon_sym_STAR] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(539),
    [sym_comment] = ACTIONS(42),
  },
  [230] = {
    [sym__declaration_specifiers] = STATE(411),
    [sym_storage_class_specifier] = STATE(296),
    [sym_type_qualifier] = STATE(296),
    [sym__type_specifier] = STATE(294),
    [sym_sized_type_specifier] = STATE(294),
    [sym_enum_specifier] = STATE(294),
    [sym_struct_specifier] = STATE(294),
    [sym_union_specifier] = STATE(294),
    [sym__expression] = STATE(412),
    [sym_conditional_expression] = STATE(412),
    [sym_assignment_expression] = STATE(412),
    [sym_pointer_expression] = STATE(412),
    [sym_logical_expression] = STATE(412),
    [sym_bitwise_expression] = STATE(412),
    [sym_equality_expression] = STATE(412),
    [sym_relational_expression] = STATE(412),
    [sym_shift_expression] = STATE(412),
    [sym_math_expression] = STATE(412),
    [sym_cast_expression] = STATE(412),
    [sym_sizeof_expression] = STATE(412),
    [sym_subscript_expression] = STATE(412),
    [sym_call_expression] = STATE(412),
    [sym_field_expression] = STATE(412),
    [sym_compound_literal_expression] = STATE(412),
    [sym_parenthesized_expression] = STATE(412),
    [sym_concatenated_string] = STATE(412),
    [sym_macro_type_specifier] = STATE(294),
    [aux_sym__declaration_specifiers_repeat1] = STATE(296),
    [aux_sym_sized_type_specifier_repeat1] = STATE(297),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(639),
    [anon_sym_long] = ACTIONS(639),
    [anon_sym_short] = ACTIONS(639),
    [sym_primitive_type] = ACTIONS(641),
    [anon_sym_enum] = ACTIONS(643),
    [anon_sym_struct] = ACTIONS(645),
    [anon_sym_union] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(962),
    [sym_char_literal] = ACTIONS(962),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [sym_identifier] = ACTIONS(665),
    [sym_comment] = ACTIONS(42),
  },
  [231] = {
    [sym_parameter_list] = STATE(414),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_RPAREN] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(968),
    [sym_comment] = ACTIONS(42),
  },
  [232] = {
    [anon_sym_LPAREN] = ACTIONS(970),
    [anon_sym_COMMA] = ACTIONS(970),
    [anon_sym_RPAREN] = ACTIONS(970),
    [anon_sym_LBRACK] = ACTIONS(970),
    [sym_comment] = ACTIONS(42),
  },
  [233] = {
    [anon_sym_LPAREN] = ACTIONS(972),
    [anon_sym_COMMA] = ACTIONS(972),
    [anon_sym_RPAREN] = ACTIONS(972),
    [anon_sym_SEMI] = ACTIONS(972),
    [anon_sym_extern] = ACTIONS(974),
    [anon_sym_STAR] = ACTIONS(972),
    [anon_sym_LBRACK] = ACTIONS(972),
    [anon_sym_static] = ACTIONS(974),
    [anon_sym_auto] = ACTIONS(974),
    [anon_sym_register] = ACTIONS(974),
    [anon_sym_inline] = ACTIONS(974),
    [anon_sym_const] = ACTIONS(974),
    [anon_sym_restrict] = ACTIONS(974),
    [anon_sym_volatile] = ACTIONS(974),
    [anon_sym__Atomic] = ACTIONS(974),
    [anon_sym_COLON] = ACTIONS(972),
    [sym_identifier] = ACTIONS(974),
    [sym_comment] = ACTIONS(42),
  },
  [234] = {
    [sym__abstract_declarator] = STATE(415),
    [sym_abstract_pointer_declarator] = STATE(415),
    [sym_abstract_function_declarator] = STATE(415),
    [sym_abstract_array_declarator] = STATE(415),
    [sym_parameter_list] = STATE(232),
    [anon_sym_LPAREN] = ACTIONS(533),
    [anon_sym_RPAREN] = ACTIONS(966),
    [anon_sym_STAR] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(539),
    [sym_comment] = ACTIONS(42),
  },
  [235] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(235),
    [anon_sym_LPAREN] = ACTIONS(348),
    [anon_sym_RPAREN] = ACTIONS(348),
    [anon_sym_STAR] = ACTIONS(348),
    [anon_sym_LBRACK] = ACTIONS(348),
    [anon_sym_unsigned] = ACTIONS(976),
    [anon_sym_long] = ACTIONS(976),
    [anon_sym_short] = ACTIONS(976),
    [sym_primitive_type] = ACTIONS(350),
    [sym_identifier] = ACTIONS(350),
    [sym_comment] = ACTIONS(42),
  },
  [236] = {
    [anon_sym_LPAREN] = ACTIONS(979),
    [anon_sym_COMMA] = ACTIONS(979),
    [anon_sym_RPAREN] = ACTIONS(979),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_LBRACE] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(979),
    [sym_comment] = ACTIONS(42),
  },
  [237] = {
    [aux_sym_parameter_list_repeat1] = STATE(418),
    [anon_sym_COMMA] = ACTIONS(981),
    [anon_sym_RPAREN] = ACTIONS(983),
    [sym_comment] = ACTIONS(42),
  },
  [238] = {
    [anon_sym_LPAREN] = ACTIONS(985),
    [anon_sym_COMMA] = ACTIONS(985),
    [anon_sym_RPAREN] = ACTIONS(985),
    [anon_sym_SEMI] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(985),
    [anon_sym_EQ] = ACTIONS(985),
    [anon_sym_COLON] = ACTIONS(985),
    [sym_comment] = ACTIONS(42),
  },
  [239] = {
    [sym__declarator] = STATE(421),
    [sym__abstract_declarator] = STATE(422),
    [sym_pointer_declarator] = STATE(421),
    [sym_abstract_pointer_declarator] = STATE(422),
    [sym_function_declarator] = STATE(421),
    [sym_abstract_function_declarator] = STATE(422),
    [sym_array_declarator] = STATE(421),
    [sym_abstract_array_declarator] = STATE(422),
    [sym_parameter_list] = STATE(232),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_COMMA] = ACTIONS(989),
    [anon_sym_RPAREN] = ACTIONS(989),
    [anon_sym_STAR] = ACTIONS(991),
    [anon_sym_LBRACK] = ACTIONS(539),
    [sym_identifier] = ACTIONS(993),
    [sym_comment] = ACTIONS(42),
  },
  [240] = {
    [sym_storage_class_specifier] = STATE(423),
    [sym_type_qualifier] = STATE(423),
    [aux_sym__declaration_specifiers_repeat1] = STATE(423),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_COMMA] = ACTIONS(107),
    [anon_sym_RPAREN] = ACTIONS(107),
    [anon_sym_extern] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(107),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_auto] = ACTIONS(109),
    [anon_sym_register] = ACTIONS(109),
    [anon_sym_inline] = ACTIONS(109),
    [anon_sym_const] = ACTIONS(111),
    [anon_sym_restrict] = ACTIONS(111),
    [anon_sym_volatile] = ACTIONS(111),
    [anon_sym__Atomic] = ACTIONS(111),
    [sym_identifier] = ACTIONS(113),
    [sym_comment] = ACTIONS(42),
  },
  [241] = {
    [sym_storage_class_specifier] = STATE(57),
    [sym_type_qualifier] = STATE(57),
    [sym__type_specifier] = STATE(424),
    [sym_sized_type_specifier] = STATE(424),
    [sym_enum_specifier] = STATE(424),
    [sym_struct_specifier] = STATE(424),
    [sym_union_specifier] = STATE(424),
    [sym_macro_type_specifier] = STATE(424),
    [aux_sym__declaration_specifiers_repeat1] = STATE(57),
    [aux_sym_sized_type_specifier_repeat1] = STATE(242),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(557),
    [anon_sym_long] = ACTIONS(557),
    [anon_sym_short] = ACTIONS(557),
    [sym_primitive_type] = ACTIONS(995),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [242] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(425),
    [anon_sym_LPAREN] = ACTIONS(119),
    [anon_sym_COMMA] = ACTIONS(119),
    [anon_sym_RPAREN] = ACTIONS(119),
    [anon_sym_extern] = ACTIONS(121),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_LBRACK] = ACTIONS(119),
    [anon_sym_static] = ACTIONS(121),
    [anon_sym_auto] = ACTIONS(121),
    [anon_sym_register] = ACTIONS(121),
    [anon_sym_inline] = ACTIONS(121),
    [anon_sym_const] = ACTIONS(121),
    [anon_sym_restrict] = ACTIONS(121),
    [anon_sym_volatile] = ACTIONS(121),
    [anon_sym__Atomic] = ACTIONS(121),
    [anon_sym_unsigned] = ACTIONS(997),
    [anon_sym_long] = ACTIONS(997),
    [anon_sym_short] = ACTIONS(997),
    [sym_primitive_type] = ACTIONS(125),
    [sym_identifier] = ACTIONS(127),
    [sym_comment] = ACTIONS(42),
  },
  [243] = {
    [sym__declarator] = STATE(137),
    [sym_pointer_declarator] = STATE(137),
    [sym_function_declarator] = STATE(137),
    [sym_array_declarator] = STATE(137),
    [anon_sym_LPAREN] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(561),
    [sym_identifier] = ACTIONS(260),
    [sym_comment] = ACTIONS(42),
  },
  [244] = {
    [sym_parameter_list] = STATE(145),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_LBRACK] = ACTIONS(270),
    [anon_sym_EQ] = ACTIONS(272),
    [sym_comment] = ACTIONS(42),
  },
  [245] = {
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_SEMI] = ACTIONS(999),
    [sym_comment] = ACTIONS(42),
  },
  [246] = {
    [sym_string_literal] = ACTIONS(1001),
    [sym_system_lib_string] = ACTIONS(1001),
    [sym_comment] = ACTIONS(42),
  },
  [247] = {
    [sym_identifier] = ACTIONS(1003),
    [sym_comment] = ACTIONS(42),
  },
  [248] = {
    [sym_type_qualifier] = STATE(133),
    [sym__type_specifier] = STATE(131),
    [sym_sized_type_specifier] = STATE(131),
    [sym_enum_specifier] = STATE(131),
    [sym_struct_specifier] = STATE(131),
    [sym_union_specifier] = STATE(131),
    [sym__expression] = STATE(436),
    [sym_comma_expression] = STATE(437),
    [sym_conditional_expression] = STATE(436),
    [sym_assignment_expression] = STATE(436),
    [sym_pointer_expression] = STATE(436),
    [sym_logical_expression] = STATE(436),
    [sym_bitwise_expression] = STATE(436),
    [sym_equality_expression] = STATE(436),
    [sym_relational_expression] = STATE(436),
    [sym_shift_expression] = STATE(436),
    [sym_math_expression] = STATE(436),
    [sym_cast_expression] = STATE(436),
    [sym_type_descriptor] = STATE(438),
    [sym_sizeof_expression] = STATE(436),
    [sym_subscript_expression] = STATE(436),
    [sym_call_expression] = STATE(436),
    [sym_field_expression] = STATE(436),
    [sym_compound_literal_expression] = STATE(436),
    [sym_parenthesized_expression] = STATE(436),
    [sym_concatenated_string] = STATE(436),
    [sym_macro_type_specifier] = STATE(131),
    [aux_sym_type_definition_repeat1] = STATE(133),
    [aux_sym_sized_type_specifier_repeat1] = STATE(134),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(248),
    [anon_sym_long] = ACTIONS(248),
    [anon_sym_short] = ACTIONS(248),
    [sym_primitive_type] = ACTIONS(250),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1019),
    [sym_char_literal] = ACTIONS(1019),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(1023),
    [sym_false] = ACTIONS(1023),
    [sym_null] = ACTIONS(1023),
    [sym_identifier] = ACTIONS(1025),
    [sym_comment] = ACTIONS(42),
  },
  [249] = {
    [sym_preproc_arg] = ACTIONS(1027),
    [sym_comment] = ACTIONS(50),
  },
  [250] = {
    [sym_identifier] = ACTIONS(1029),
    [sym_comment] = ACTIONS(42),
  },
  [251] = {
    [sym_identifier] = ACTIONS(1031),
    [sym_comment] = ACTIONS(42),
  },
  [252] = {
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(1033),
    [anon_sym_LF] = ACTIONS(1035),
    [sym_comment] = ACTIONS(50),
  },
  [253] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1037),
    [sym_preproc_directive] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_typedef] = ACTIONS(1037),
    [anon_sym_extern] = ACTIONS(1037),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_STAR] = ACTIONS(1039),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_auto] = ACTIONS(1037),
    [anon_sym_register] = ACTIONS(1037),
    [anon_sym_inline] = ACTIONS(1037),
    [anon_sym_const] = ACTIONS(1037),
    [anon_sym_restrict] = ACTIONS(1037),
    [anon_sym_volatile] = ACTIONS(1037),
    [anon_sym__Atomic] = ACTIONS(1037),
    [anon_sym_unsigned] = ACTIONS(1037),
    [anon_sym_long] = ACTIONS(1037),
    [anon_sym_short] = ACTIONS(1037),
    [sym_primitive_type] = ACTIONS(1037),
    [anon_sym_enum] = ACTIONS(1037),
    [anon_sym_struct] = ACTIONS(1037),
    [anon_sym_union] = ACTIONS(1037),
    [anon_sym_if] = ACTIONS(1037),
    [anon_sym_switch] = ACTIONS(1037),
    [anon_sym_case] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1037),
    [anon_sym_do] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1037),
    [anon_sym_return] = ACTIONS(1037),
    [anon_sym_break] = ACTIONS(1037),
    [anon_sym_continue] = ACTIONS(1037),
    [anon_sym_goto] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_TILDE] = ACTIONS(1039),
    [anon_sym_PLUS] = ACTIONS(1037),
    [anon_sym_DASH] = ACTIONS(1037),
    [anon_sym_DASH_DASH] = ACTIONS(1039),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_sizeof] = ACTIONS(1037),
    [sym_number_literal] = ACTIONS(1039),
    [sym_char_literal] = ACTIONS(1039),
    [sym_string_literal] = ACTIONS(1039),
    [sym_true] = ACTIONS(1037),
    [sym_false] = ACTIONS(1037),
    [sym_null] = ACTIONS(1037),
    [sym_identifier] = ACTIONS(1037),
    [sym_comment] = ACTIONS(42),
  },
  [254] = {
    [sym_type_qualifier] = STATE(445),
    [sym__type_specifier] = STATE(444),
    [sym_sized_type_specifier] = STATE(444),
    [sym_enum_specifier] = STATE(444),
    [sym_struct_specifier] = STATE(444),
    [sym_union_specifier] = STATE(444),
    [sym_macro_type_specifier] = STATE(444),
    [aux_sym_type_definition_repeat1] = STATE(445),
    [aux_sym_sized_type_specifier_repeat1] = STATE(36),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(62),
    [anon_sym_long] = ACTIONS(62),
    [anon_sym_short] = ACTIONS(62),
    [sym_primitive_type] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(66),
    [anon_sym_struct] = ACTIONS(68),
    [anon_sym_union] = ACTIONS(70),
    [sym_identifier] = ACTIONS(72),
    [sym_comment] = ACTIONS(42),
  },
  [255] = {
    [sym_preproc_include] = STATE(447),
    [sym_preproc_def] = STATE(447),
    [sym_preproc_function_def] = STATE(447),
    [sym_preproc_call] = STATE(447),
    [sym_preproc_if_in_compound_statement] = STATE(275),
    [sym_preproc_ifdef_in_compound_statement] = STATE(276),
    [sym_declaration] = STATE(447),
    [sym_type_definition] = STATE(447),
    [sym__declaration_specifiers] = STATE(277),
    [sym_compound_statement] = STATE(447),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(447),
    [sym_expression_statement] = STATE(447),
    [sym_if_statement] = STATE(447),
    [sym_switch_statement] = STATE(447),
    [sym_case_statement] = STATE(447),
    [sym_while_statement] = STATE(447),
    [sym_do_statement] = STATE(447),
    [sym_for_statement] = STATE(447),
    [sym_return_statement] = STATE(447),
    [sym_break_statement] = STATE(447),
    [sym_continue_statement] = STATE(447),
    [sym_goto_statement] = STATE(447),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [sym__empty_declaration] = STATE(447),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(447),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(577),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(579),
    [sym_preproc_directive] = ACTIONS(581),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_typedef] = ACTIONS(585),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_RBRACE] = ACTIONS(1043),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(631),
    [sym_comment] = ACTIONS(42),
  },
  [256] = {
    [ts_builtin_sym_end] = ACTIONS(1045),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1047),
    [sym_preproc_directive] = ACTIONS(1047),
    [anon_sym_typedef] = ACTIONS(1047),
    [anon_sym_extern] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_auto] = ACTIONS(1047),
    [anon_sym_register] = ACTIONS(1047),
    [anon_sym_inline] = ACTIONS(1047),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_restrict] = ACTIONS(1047),
    [anon_sym_volatile] = ACTIONS(1047),
    [anon_sym__Atomic] = ACTIONS(1047),
    [anon_sym_unsigned] = ACTIONS(1047),
    [anon_sym_long] = ACTIONS(1047),
    [anon_sym_short] = ACTIONS(1047),
    [sym_primitive_type] = ACTIONS(1047),
    [anon_sym_enum] = ACTIONS(1047),
    [anon_sym_struct] = ACTIONS(1047),
    [anon_sym_union] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [sym_comment] = ACTIONS(42),
  },
  [257] = {
    [sym__expression] = STATE(448),
    [sym_conditional_expression] = STATE(448),
    [sym_assignment_expression] = STATE(448),
    [sym_pointer_expression] = STATE(448),
    [sym_logical_expression] = STATE(448),
    [sym_bitwise_expression] = STATE(448),
    [sym_equality_expression] = STATE(448),
    [sym_relational_expression] = STATE(448),
    [sym_shift_expression] = STATE(448),
    [sym_math_expression] = STATE(448),
    [sym_cast_expression] = STATE(448),
    [sym_sizeof_expression] = STATE(448),
    [sym_subscript_expression] = STATE(448),
    [sym_call_expression] = STATE(448),
    [sym_field_expression] = STATE(448),
    [sym_compound_literal_expression] = STATE(448),
    [sym_parenthesized_expression] = STATE(448),
    [sym_concatenated_string] = STATE(448),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1049),
    [sym_char_literal] = ACTIONS(1049),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1051),
    [sym_false] = ACTIONS(1051),
    [sym_null] = ACTIONS(1051),
    [sym_identifier] = ACTIONS(1051),
    [sym_comment] = ACTIONS(42),
  },
  [258] = {
    [anon_sym_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(42),
  },
  [259] = {
    [anon_sym_LPAREN] = ACTIONS(1055),
    [sym_comment] = ACTIONS(42),
  },
  [260] = {
    [sym__expression] = STATE(458),
    [sym_conditional_expression] = STATE(458),
    [sym_assignment_expression] = STATE(458),
    [sym_pointer_expression] = STATE(458),
    [sym_logical_expression] = STATE(458),
    [sym_bitwise_expression] = STATE(458),
    [sym_equality_expression] = STATE(458),
    [sym_relational_expression] = STATE(458),
    [sym_shift_expression] = STATE(458),
    [sym_math_expression] = STATE(458),
    [sym_cast_expression] = STATE(458),
    [sym_sizeof_expression] = STATE(458),
    [sym_subscript_expression] = STATE(458),
    [sym_call_expression] = STATE(458),
    [sym_field_expression] = STATE(458),
    [sym_compound_literal_expression] = STATE(458),
    [sym_parenthesized_expression] = STATE(458),
    [sym_concatenated_string] = STATE(458),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(1071),
    [sym_char_literal] = ACTIONS(1071),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(1075),
    [sym_false] = ACTIONS(1075),
    [sym_null] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_comment] = ACTIONS(42),
  },
  [261] = {
    [anon_sym_COLON] = ACTIONS(1077),
    [sym_comment] = ACTIONS(42),
  },
  [262] = {
    [anon_sym_LPAREN] = ACTIONS(1079),
    [sym_comment] = ACTIONS(42),
  },
  [263] = {
    [sym_compound_statement] = STATE(468),
    [sym_labeled_statement] = STATE(468),
    [sym_expression_statement] = STATE(468),
    [sym_if_statement] = STATE(468),
    [sym_switch_statement] = STATE(468),
    [sym_case_statement] = STATE(468),
    [sym_while_statement] = STATE(468),
    [sym_do_statement] = STATE(468),
    [sym_for_statement] = STATE(468),
    [sym_return_statement] = STATE(468),
    [sym_break_statement] = STATE(468),
    [sym_continue_statement] = STATE(468),
    [sym_goto_statement] = STATE(468),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_default] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(1089),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1093),
    [sym_comment] = ACTIONS(42),
  },
  [264] = {
    [anon_sym_LPAREN] = ACTIONS(1095),
    [sym_comment] = ACTIONS(42),
  },
  [265] = {
    [sym__expression] = STATE(471),
    [sym_conditional_expression] = STATE(471),
    [sym_assignment_expression] = STATE(471),
    [sym_pointer_expression] = STATE(471),
    [sym_logical_expression] = STATE(471),
    [sym_bitwise_expression] = STATE(471),
    [sym_equality_expression] = STATE(471),
    [sym_relational_expression] = STATE(471),
    [sym_shift_expression] = STATE(471),
    [sym_math_expression] = STATE(471),
    [sym_cast_expression] = STATE(471),
    [sym_sizeof_expression] = STATE(471),
    [sym_subscript_expression] = STATE(471),
    [sym_call_expression] = STATE(471),
    [sym_field_expression] = STATE(471),
    [sym_compound_literal_expression] = STATE(471),
    [sym_parenthesized_expression] = STATE(471),
    [sym_concatenated_string] = STATE(471),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(1099),
    [sym_char_literal] = ACTIONS(1099),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(1101),
    [sym_false] = ACTIONS(1101),
    [sym_null] = ACTIONS(1101),
    [sym_identifier] = ACTIONS(1101),
    [sym_comment] = ACTIONS(42),
  },
  [266] = {
    [anon_sym_SEMI] = ACTIONS(1103),
    [sym_comment] = ACTIONS(42),
  },
  [267] = {
    [anon_sym_SEMI] = ACTIONS(1105),
    [sym_comment] = ACTIONS(42),
  },
  [268] = {
    [sym_identifier] = ACTIONS(1107),
    [sym_comment] = ACTIONS(42),
  },
  [269] = {
    [sym__expression] = STATE(475),
    [sym_conditional_expression] = STATE(475),
    [sym_assignment_expression] = STATE(475),
    [sym_pointer_expression] = STATE(475),
    [sym_logical_expression] = STATE(475),
    [sym_bitwise_expression] = STATE(475),
    [sym_equality_expression] = STATE(475),
    [sym_relational_expression] = STATE(475),
    [sym_shift_expression] = STATE(475),
    [sym_math_expression] = STATE(475),
    [sym_cast_expression] = STATE(475),
    [sym_sizeof_expression] = STATE(475),
    [sym_subscript_expression] = STATE(475),
    [sym_call_expression] = STATE(475),
    [sym_field_expression] = STATE(475),
    [sym_compound_literal_expression] = STATE(475),
    [sym_parenthesized_expression] = STATE(475),
    [sym_concatenated_string] = STATE(475),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1109),
    [sym_char_literal] = ACTIONS(1109),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1111),
    [sym_false] = ACTIONS(1111),
    [sym_null] = ACTIONS(1111),
    [sym_identifier] = ACTIONS(1111),
    [sym_comment] = ACTIONS(42),
  },
  [270] = {
    [sym__expression] = STATE(476),
    [sym_conditional_expression] = STATE(476),
    [sym_assignment_expression] = STATE(476),
    [sym_pointer_expression] = STATE(476),
    [sym_logical_expression] = STATE(476),
    [sym_bitwise_expression] = STATE(476),
    [sym_equality_expression] = STATE(476),
    [sym_relational_expression] = STATE(476),
    [sym_shift_expression] = STATE(476),
    [sym_math_expression] = STATE(476),
    [sym_cast_expression] = STATE(476),
    [sym_sizeof_expression] = STATE(476),
    [sym_subscript_expression] = STATE(476),
    [sym_call_expression] = STATE(476),
    [sym_field_expression] = STATE(476),
    [sym_compound_literal_expression] = STATE(476),
    [sym_parenthesized_expression] = STATE(476),
    [sym_concatenated_string] = STATE(476),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1113),
    [sym_char_literal] = ACTIONS(1113),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1115),
    [sym_false] = ACTIONS(1115),
    [sym_null] = ACTIONS(1115),
    [sym_identifier] = ACTIONS(1115),
    [sym_comment] = ACTIONS(42),
  },
  [271] = {
    [sym__expression] = STATE(477),
    [sym_conditional_expression] = STATE(477),
    [sym_assignment_expression] = STATE(477),
    [sym_pointer_expression] = STATE(477),
    [sym_logical_expression] = STATE(477),
    [sym_bitwise_expression] = STATE(477),
    [sym_equality_expression] = STATE(477),
    [sym_relational_expression] = STATE(477),
    [sym_shift_expression] = STATE(477),
    [sym_math_expression] = STATE(477),
    [sym_cast_expression] = STATE(477),
    [sym_sizeof_expression] = STATE(477),
    [sym_subscript_expression] = STATE(477),
    [sym_call_expression] = STATE(477),
    [sym_field_expression] = STATE(477),
    [sym_compound_literal_expression] = STATE(477),
    [sym_parenthesized_expression] = STATE(477),
    [sym_concatenated_string] = STATE(477),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1117),
    [sym_char_literal] = ACTIONS(1117),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1119),
    [sym_false] = ACTIONS(1119),
    [sym_null] = ACTIONS(1119),
    [sym_identifier] = ACTIONS(1119),
    [sym_comment] = ACTIONS(42),
  },
  [272] = {
    [sym__expression] = STATE(479),
    [sym_conditional_expression] = STATE(479),
    [sym_assignment_expression] = STATE(479),
    [sym_pointer_expression] = STATE(479),
    [sym_logical_expression] = STATE(479),
    [sym_bitwise_expression] = STATE(479),
    [sym_equality_expression] = STATE(479),
    [sym_relational_expression] = STATE(479),
    [sym_shift_expression] = STATE(479),
    [sym_math_expression] = STATE(479),
    [sym_cast_expression] = STATE(479),
    [sym_sizeof_expression] = STATE(479),
    [sym_subscript_expression] = STATE(479),
    [sym_call_expression] = STATE(479),
    [sym_field_expression] = STATE(479),
    [sym_compound_literal_expression] = STATE(479),
    [sym_parenthesized_expression] = STATE(479),
    [sym_concatenated_string] = STATE(479),
    [anon_sym_LPAREN] = ACTIONS(1121),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1123),
    [sym_char_literal] = ACTIONS(1123),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_identifier] = ACTIONS(1125),
    [sym_comment] = ACTIONS(42),
  },
  [273] = {
    [aux_sym_concatenated_string_repeat1] = STATE(480),
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_string_literal] = ACTIONS(1131),
    [sym_comment] = ACTIONS(42),
  },
  [274] = {
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1137),
    [anon_sym_extern] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_auto] = ACTIONS(95),
    [anon_sym_register] = ACTIONS(95),
    [anon_sym_inline] = ACTIONS(95),
    [anon_sym_const] = ACTIONS(95),
    [anon_sym_restrict] = ACTIONS(95),
    [anon_sym_volatile] = ACTIONS(95),
    [anon_sym__Atomic] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_identifier] = ACTIONS(95),
    [sym_comment] = ACTIONS(42),
  },
  [275] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1145),
    [anon_sym_LPAREN] = ACTIONS(1147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1145),
    [sym_preproc_directive] = ACTIONS(1145),
    [anon_sym_SEMI] = ACTIONS(1147),
    [anon_sym_typedef] = ACTIONS(1145),
    [anon_sym_extern] = ACTIONS(1145),
    [anon_sym_LBRACE] = ACTIONS(1147),
    [anon_sym_RBRACE] = ACTIONS(1147),
    [anon_sym_STAR] = ACTIONS(1147),
    [anon_sym_static] = ACTIONS(1145),
    [anon_sym_auto] = ACTIONS(1145),
    [anon_sym_register] = ACTIONS(1145),
    [anon_sym_inline] = ACTIONS(1145),
    [anon_sym_const] = ACTIONS(1145),
    [anon_sym_restrict] = ACTIONS(1145),
    [anon_sym_volatile] = ACTIONS(1145),
    [anon_sym__Atomic] = ACTIONS(1145),
    [anon_sym_unsigned] = ACTIONS(1145),
    [anon_sym_long] = ACTIONS(1145),
    [anon_sym_short] = ACTIONS(1145),
    [sym_primitive_type] = ACTIONS(1145),
    [anon_sym_enum] = ACTIONS(1145),
    [anon_sym_struct] = ACTIONS(1145),
    [anon_sym_union] = ACTIONS(1145),
    [anon_sym_if] = ACTIONS(1145),
    [anon_sym_switch] = ACTIONS(1145),
    [anon_sym_case] = ACTIONS(1145),
    [anon_sym_default] = ACTIONS(1145),
    [anon_sym_while] = ACTIONS(1145),
    [anon_sym_do] = ACTIONS(1145),
    [anon_sym_for] = ACTIONS(1145),
    [anon_sym_return] = ACTIONS(1145),
    [anon_sym_break] = ACTIONS(1145),
    [anon_sym_continue] = ACTIONS(1145),
    [anon_sym_goto] = ACTIONS(1145),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_DASH_DASH] = ACTIONS(1147),
    [anon_sym_PLUS_PLUS] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1147),
    [sym_char_literal] = ACTIONS(1147),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1145),
    [sym_false] = ACTIONS(1145),
    [sym_null] = ACTIONS(1145),
    [sym_identifier] = ACTIONS(1145),
    [sym_comment] = ACTIONS(42),
  },
  [276] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1149),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1149),
    [sym_preproc_directive] = ACTIONS(1149),
    [anon_sym_SEMI] = ACTIONS(1151),
    [anon_sym_typedef] = ACTIONS(1149),
    [anon_sym_extern] = ACTIONS(1149),
    [anon_sym_LBRACE] = ACTIONS(1151),
    [anon_sym_RBRACE] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1151),
    [anon_sym_static] = ACTIONS(1149),
    [anon_sym_auto] = ACTIONS(1149),
    [anon_sym_register] = ACTIONS(1149),
    [anon_sym_inline] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_restrict] = ACTIONS(1149),
    [anon_sym_volatile] = ACTIONS(1149),
    [anon_sym__Atomic] = ACTIONS(1149),
    [anon_sym_unsigned] = ACTIONS(1149),
    [anon_sym_long] = ACTIONS(1149),
    [anon_sym_short] = ACTIONS(1149),
    [sym_primitive_type] = ACTIONS(1149),
    [anon_sym_enum] = ACTIONS(1149),
    [anon_sym_struct] = ACTIONS(1149),
    [anon_sym_union] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(1149),
    [anon_sym_switch] = ACTIONS(1149),
    [anon_sym_case] = ACTIONS(1149),
    [anon_sym_default] = ACTIONS(1149),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_do] = ACTIONS(1149),
    [anon_sym_for] = ACTIONS(1149),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_break] = ACTIONS(1149),
    [anon_sym_continue] = ACTIONS(1149),
    [anon_sym_goto] = ACTIONS(1149),
    [anon_sym_AMP] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(1149),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1151),
    [anon_sym_PLUS_PLUS] = ACTIONS(1151),
    [anon_sym_sizeof] = ACTIONS(1149),
    [sym_number_literal] = ACTIONS(1151),
    [sym_char_literal] = ACTIONS(1151),
    [sym_string_literal] = ACTIONS(1151),
    [sym_true] = ACTIONS(1149),
    [sym_false] = ACTIONS(1149),
    [sym_null] = ACTIONS(1149),
    [sym_identifier] = ACTIONS(1149),
    [sym_comment] = ACTIONS(42),
  },
  [277] = {
    [sym__declarator] = STATE(483),
    [sym_pointer_declarator] = STATE(483),
    [sym_function_declarator] = STATE(483),
    [sym_array_declarator] = STATE(483),
    [sym_init_declarator] = STATE(484),
    [anon_sym_LPAREN] = ACTIONS(99),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym_STAR] = ACTIONS(561),
    [sym_identifier] = ACTIONS(1155),
    [sym_comment] = ACTIONS(42),
  },
  [278] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_SEMI] = ACTIONS(1161),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_STAR_EQ] = ACTIONS(1171),
    [anon_sym_SLASH_EQ] = ACTIONS(1171),
    [anon_sym_PERCENT_EQ] = ACTIONS(1171),
    [anon_sym_PLUS_EQ] = ACTIONS(1171),
    [anon_sym_DASH_EQ] = ACTIONS(1171),
    [anon_sym_LT_LT_EQ] = ACTIONS(1171),
    [anon_sym_GT_GT_EQ] = ACTIONS(1171),
    [anon_sym_AMP_EQ] = ACTIONS(1171),
    [anon_sym_CARET_EQ] = ACTIONS(1171),
    [anon_sym_PIPE_EQ] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_PIPE_PIPE] = ACTIONS(1175),
    [anon_sym_AMP_AMP] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_LT] = ACTIONS(1185),
    [anon_sym_GT] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1187),
    [anon_sym_GT_EQ] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1189),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [279] = {
    [anon_sym_SEMI] = ACTIONS(1161),
    [sym_comment] = ACTIONS(42),
  },
  [280] = {
    [sym_preproc_include] = STATE(505),
    [sym_preproc_def] = STATE(505),
    [sym_preproc_function_def] = STATE(505),
    [sym_preproc_call] = STATE(505),
    [sym_preproc_if_in_compound_statement] = STATE(275),
    [sym_preproc_ifdef_in_compound_statement] = STATE(276),
    [sym_declaration] = STATE(505),
    [sym_type_definition] = STATE(505),
    [sym__declaration_specifiers] = STATE(277),
    [sym_compound_statement] = STATE(505),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(505),
    [sym_expression_statement] = STATE(505),
    [sym_if_statement] = STATE(505),
    [sym_switch_statement] = STATE(505),
    [sym_case_statement] = STATE(505),
    [sym_while_statement] = STATE(505),
    [sym_do_statement] = STATE(505),
    [sym_for_statement] = STATE(505),
    [sym_return_statement] = STATE(505),
    [sym_break_statement] = STATE(505),
    [sym_continue_statement] = STATE(505),
    [sym_goto_statement] = STATE(505),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [sym__empty_declaration] = STATE(505),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(505),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(577),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(579),
    [sym_preproc_directive] = ACTIONS(581),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_typedef] = ACTIONS(585),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_RBRACE] = ACTIONS(1197),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(631),
    [sym_comment] = ACTIONS(42),
  },
  [281] = {
    [sym_type_qualifier] = STATE(133),
    [sym__type_specifier] = STATE(131),
    [sym_sized_type_specifier] = STATE(131),
    [sym_enum_specifier] = STATE(131),
    [sym_struct_specifier] = STATE(131),
    [sym_union_specifier] = STATE(131),
    [sym__expression] = STATE(436),
    [sym_comma_expression] = STATE(437),
    [sym_conditional_expression] = STATE(436),
    [sym_assignment_expression] = STATE(436),
    [sym_pointer_expression] = STATE(436),
    [sym_logical_expression] = STATE(436),
    [sym_bitwise_expression] = STATE(436),
    [sym_equality_expression] = STATE(436),
    [sym_relational_expression] = STATE(436),
    [sym_shift_expression] = STATE(436),
    [sym_math_expression] = STATE(436),
    [sym_cast_expression] = STATE(436),
    [sym_type_descriptor] = STATE(506),
    [sym_sizeof_expression] = STATE(436),
    [sym_subscript_expression] = STATE(436),
    [sym_call_expression] = STATE(436),
    [sym_field_expression] = STATE(436),
    [sym_compound_literal_expression] = STATE(436),
    [sym_parenthesized_expression] = STATE(436),
    [sym_concatenated_string] = STATE(436),
    [sym_macro_type_specifier] = STATE(131),
    [aux_sym_type_definition_repeat1] = STATE(133),
    [aux_sym_sized_type_specifier_repeat1] = STATE(134),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(248),
    [anon_sym_long] = ACTIONS(248),
    [anon_sym_short] = ACTIONS(248),
    [sym_primitive_type] = ACTIONS(250),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1019),
    [sym_char_literal] = ACTIONS(1019),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(1023),
    [sym_false] = ACTIONS(1023),
    [sym_null] = ACTIONS(1023),
    [sym_identifier] = ACTIONS(1025),
    [sym_comment] = ACTIONS(42),
  },
  [282] = {
    [sym__expression] = STATE(448),
    [sym_conditional_expression] = STATE(448),
    [sym_assignment_expression] = STATE(448),
    [sym_pointer_expression] = STATE(448),
    [sym_logical_expression] = STATE(448),
    [sym_bitwise_expression] = STATE(448),
    [sym_equality_expression] = STATE(448),
    [sym_relational_expression] = STATE(448),
    [sym_shift_expression] = STATE(448),
    [sym_math_expression] = STATE(448),
    [sym_cast_expression] = STATE(448),
    [sym_sizeof_expression] = STATE(448),
    [sym_subscript_expression] = STATE(448),
    [sym_call_expression] = STATE(448),
    [sym_field_expression] = STATE(448),
    [sym_compound_literal_expression] = STATE(448),
    [sym_parenthesized_expression] = STATE(448),
    [sym_concatenated_string] = STATE(448),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(1049),
    [sym_char_literal] = ACTIONS(1049),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(1051),
    [sym_false] = ACTIONS(1051),
    [sym_null] = ACTIONS(1051),
    [sym_identifier] = ACTIONS(1051),
    [sym_comment] = ACTIONS(42),
  },
  [283] = {
    [anon_sym_LPAREN] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_RPAREN] = ACTIONS(1199),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_LBRACE] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [anon_sym_EQ] = ACTIONS(1199),
    [sym_comment] = ACTIONS(42),
  },
  [284] = {
    [sym_enumerator_list] = STATE(509),
    [anon_sym_LBRACE] = ACTIONS(1201),
    [sym_identifier] = ACTIONS(1203),
    [sym_comment] = ACTIONS(42),
  },
  [285] = {
    [sym_field_declaration_list] = STATE(512),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [sym_identifier] = ACTIONS(1207),
    [sym_comment] = ACTIONS(42),
  },
  [286] = {
    [sym_field_declaration_list] = STATE(514),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [sym_identifier] = ACTIONS(1209),
    [sym_comment] = ACTIONS(42),
  },
  [287] = {
    [sym__expression] = STATE(475),
    [sym_conditional_expression] = STATE(475),
    [sym_assignment_expression] = STATE(475),
    [sym_pointer_expression] = STATE(475),
    [sym_logical_expression] = STATE(475),
    [sym_bitwise_expression] = STATE(475),
    [sym_equality_expression] = STATE(475),
    [sym_relational_expression] = STATE(475),
    [sym_shift_expression] = STATE(475),
    [sym_math_expression] = STATE(475),
    [sym_cast_expression] = STATE(475),
    [sym_sizeof_expression] = STATE(475),
    [sym_subscript_expression] = STATE(475),
    [sym_call_expression] = STATE(475),
    [sym_field_expression] = STATE(475),
    [sym_compound_literal_expression] = STATE(475),
    [sym_parenthesized_expression] = STATE(475),
    [sym_concatenated_string] = STATE(475),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(1109),
    [sym_char_literal] = ACTIONS(1109),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(1111),
    [sym_false] = ACTIONS(1111),
    [sym_null] = ACTIONS(1111),
    [sym_identifier] = ACTIONS(1111),
    [sym_comment] = ACTIONS(42),
  },
  [288] = {
    [sym__expression] = STATE(476),
    [sym_conditional_expression] = STATE(476),
    [sym_assignment_expression] = STATE(476),
    [sym_pointer_expression] = STATE(476),
    [sym_logical_expression] = STATE(476),
    [sym_bitwise_expression] = STATE(476),
    [sym_equality_expression] = STATE(476),
    [sym_relational_expression] = STATE(476),
    [sym_shift_expression] = STATE(476),
    [sym_math_expression] = STATE(476),
    [sym_cast_expression] = STATE(476),
    [sym_sizeof_expression] = STATE(476),
    [sym_subscript_expression] = STATE(476),
    [sym_call_expression] = STATE(476),
    [sym_field_expression] = STATE(476),
    [sym_compound_literal_expression] = STATE(476),
    [sym_parenthesized_expression] = STATE(476),
    [sym_concatenated_string] = STATE(476),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(1113),
    [sym_char_literal] = ACTIONS(1113),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(1115),
    [sym_false] = ACTIONS(1115),
    [sym_null] = ACTIONS(1115),
    [sym_identifier] = ACTIONS(1115),
    [sym_comment] = ACTIONS(42),
  },
  [289] = {
    [sym__expression] = STATE(477),
    [sym_conditional_expression] = STATE(477),
    [sym_assignment_expression] = STATE(477),
    [sym_pointer_expression] = STATE(477),
    [sym_logical_expression] = STATE(477),
    [sym_bitwise_expression] = STATE(477),
    [sym_equality_expression] = STATE(477),
    [sym_relational_expression] = STATE(477),
    [sym_shift_expression] = STATE(477),
    [sym_math_expression] = STATE(477),
    [sym_cast_expression] = STATE(477),
    [sym_sizeof_expression] = STATE(477),
    [sym_subscript_expression] = STATE(477),
    [sym_call_expression] = STATE(477),
    [sym_field_expression] = STATE(477),
    [sym_compound_literal_expression] = STATE(477),
    [sym_parenthesized_expression] = STATE(477),
    [sym_concatenated_string] = STATE(477),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(1117),
    [sym_char_literal] = ACTIONS(1117),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(1119),
    [sym_false] = ACTIONS(1119),
    [sym_null] = ACTIONS(1119),
    [sym_identifier] = ACTIONS(1119),
    [sym_comment] = ACTIONS(42),
  },
  [290] = {
    [sym__expression] = STATE(516),
    [sym_conditional_expression] = STATE(516),
    [sym_assignment_expression] = STATE(516),
    [sym_pointer_expression] = STATE(516),
    [sym_logical_expression] = STATE(516),
    [sym_bitwise_expression] = STATE(516),
    [sym_equality_expression] = STATE(516),
    [sym_relational_expression] = STATE(516),
    [sym_shift_expression] = STATE(516),
    [sym_math_expression] = STATE(516),
    [sym_cast_expression] = STATE(516),
    [sym_sizeof_expression] = STATE(516),
    [sym_subscript_expression] = STATE(516),
    [sym_call_expression] = STATE(516),
    [sym_field_expression] = STATE(516),
    [sym_compound_literal_expression] = STATE(516),
    [sym_parenthesized_expression] = STATE(516),
    [sym_concatenated_string] = STATE(516),
    [anon_sym_LPAREN] = ACTIONS(1211),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(1213),
    [sym_char_literal] = ACTIONS(1213),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(1215),
    [sym_false] = ACTIONS(1215),
    [sym_null] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_comment] = ACTIONS(42),
  },
  [291] = {
    [aux_sym_concatenated_string_repeat1] = STATE(517),
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_RBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_string_literal] = ACTIONS(1217),
    [sym_comment] = ACTIONS(42),
  },
  [292] = {
    [anon_sym_LPAREN] = ACTIONS(1219),
    [anon_sym_extern] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_RBRACK] = ACTIONS(1137),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_auto] = ACTIONS(95),
    [anon_sym_register] = ACTIONS(95),
    [anon_sym_inline] = ACTIONS(95),
    [anon_sym_const] = ACTIONS(95),
    [anon_sym_restrict] = ACTIONS(95),
    [anon_sym_volatile] = ACTIONS(95),
    [anon_sym__Atomic] = ACTIONS(95),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1140),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(93),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1140),
    [anon_sym_DASH] = ACTIONS(1140),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1137),
    [anon_sym_PLUS_PLUS] = ACTIONS(1137),
    [anon_sym_sizeof] = ACTIONS(95),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_number_literal] = ACTIONS(93),
    [sym_char_literal] = ACTIONS(93),
    [sym_string_literal] = ACTIONS(93),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_identifier] = ACTIONS(95),
    [sym_comment] = ACTIONS(42),
  },
  [293] = {
    [sym__expression] = STATE(520),
    [sym_conditional_expression] = STATE(520),
    [sym_assignment_expression] = STATE(520),
    [sym_pointer_expression] = STATE(520),
    [sym_logical_expression] = STATE(520),
    [sym_bitwise_expression] = STATE(520),
    [sym_equality_expression] = STATE(520),
    [sym_relational_expression] = STATE(520),
    [sym_shift_expression] = STATE(520),
    [sym_math_expression] = STATE(520),
    [sym_cast_expression] = STATE(520),
    [sym_sizeof_expression] = STATE(520),
    [sym_subscript_expression] = STATE(520),
    [sym_call_expression] = STATE(520),
    [sym_field_expression] = STATE(520),
    [sym_compound_literal_expression] = STATE(520),
    [sym_parenthesized_expression] = STATE(520),
    [sym_concatenated_string] = STATE(520),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(1225),
    [sym_char_literal] = ACTIONS(1225),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(1227),
    [sym_false] = ACTIONS(1227),
    [sym_null] = ACTIONS(1227),
    [sym_identifier] = ACTIONS(1227),
    [sym_comment] = ACTIONS(42),
  },
  [294] = {
    [sym_storage_class_specifier] = STATE(523),
    [sym_type_qualifier] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(523),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_extern] = ACTIONS(1229),
    [anon_sym_STAR] = ACTIONS(107),
    [anon_sym_RBRACK] = ACTIONS(107),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_auto] = ACTIONS(1229),
    [anon_sym_register] = ACTIONS(1229),
    [anon_sym_inline] = ACTIONS(1229),
    [anon_sym_const] = ACTIONS(1231),
    [anon_sym_restrict] = ACTIONS(1231),
    [anon_sym_volatile] = ACTIONS(1231),
    [anon_sym__Atomic] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_DASH_DASH] = ACTIONS(107),
    [anon_sym_PLUS_PLUS] = ACTIONS(107),
    [anon_sym_sizeof] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(107),
    [sym_char_literal] = ACTIONS(107),
    [sym_string_literal] = ACTIONS(107),
    [sym_true] = ACTIONS(113),
    [sym_false] = ACTIONS(113),
    [sym_null] = ACTIONS(113),
    [sym_identifier] = ACTIONS(113),
    [sym_comment] = ACTIONS(42),
  },
  [295] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1237),
    [anon_sym_STAR_EQ] = ACTIONS(1239),
    [anon_sym_SLASH_EQ] = ACTIONS(1239),
    [anon_sym_PERCENT_EQ] = ACTIONS(1239),
    [anon_sym_PLUS_EQ] = ACTIONS(1239),
    [anon_sym_DASH_EQ] = ACTIONS(1239),
    [anon_sym_LT_LT_EQ] = ACTIONS(1239),
    [anon_sym_GT_GT_EQ] = ACTIONS(1239),
    [anon_sym_AMP_EQ] = ACTIONS(1239),
    [anon_sym_CARET_EQ] = ACTIONS(1239),
    [anon_sym_PIPE_EQ] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_PIPE_PIPE] = ACTIONS(1243),
    [anon_sym_AMP_AMP] = ACTIONS(1245),
    [anon_sym_PIPE] = ACTIONS(1247),
    [anon_sym_CARET] = ACTIONS(1249),
    [anon_sym_EQ_EQ] = ACTIONS(1251),
    [anon_sym_BANG_EQ] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1253),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [296] = {
    [sym_storage_class_specifier] = STATE(57),
    [sym_type_qualifier] = STATE(57),
    [sym__type_specifier] = STATE(537),
    [sym_sized_type_specifier] = STATE(537),
    [sym_enum_specifier] = STATE(537),
    [sym_struct_specifier] = STATE(537),
    [sym_union_specifier] = STATE(537),
    [sym_macro_type_specifier] = STATE(537),
    [aux_sym__declaration_specifiers_repeat1] = STATE(57),
    [aux_sym_sized_type_specifier_repeat1] = STATE(297),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(639),
    [anon_sym_long] = ACTIONS(639),
    [anon_sym_short] = ACTIONS(639),
    [sym_primitive_type] = ACTIONS(1261),
    [anon_sym_enum] = ACTIONS(643),
    [anon_sym_struct] = ACTIONS(645),
    [anon_sym_union] = ACTIONS(647),
    [sym_identifier] = ACTIONS(1263),
    [sym_comment] = ACTIONS(42),
  },
  [297] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(540),
    [anon_sym_LPAREN] = ACTIONS(119),
    [anon_sym_extern] = ACTIONS(121),
    [anon_sym_STAR] = ACTIONS(119),
    [anon_sym_RBRACK] = ACTIONS(119),
    [anon_sym_static] = ACTIONS(121),
    [anon_sym_auto] = ACTIONS(121),
    [anon_sym_register] = ACTIONS(121),
    [anon_sym_inline] = ACTIONS(121),
    [anon_sym_const] = ACTIONS(121),
    [anon_sym_restrict] = ACTIONS(121),
    [anon_sym_volatile] = ACTIONS(121),
    [anon_sym__Atomic] = ACTIONS(121),
    [anon_sym_unsigned] = ACTIONS(1265),
    [anon_sym_long] = ACTIONS(1265),
    [anon_sym_short] = ACTIONS(1265),
    [sym_primitive_type] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(121),
    [anon_sym_DASH] = ACTIONS(121),
    [anon_sym_DASH_DASH] = ACTIONS(119),
    [anon_sym_PLUS_PLUS] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [sym_number_literal] = ACTIONS(119),
    [sym_char_literal] = ACTIONS(119),
    [sym_string_literal] = ACTIONS(119),
    [sym_true] = ACTIONS(121),
    [sym_false] = ACTIONS(121),
    [sym_null] = ACTIONS(121),
    [sym_identifier] = ACTIONS(1269),
    [sym_comment] = ACTIONS(42),
  },
  [298] = {
    [sym__expression] = STATE(545),
    [sym_conditional_expression] = STATE(545),
    [sym_assignment_expression] = STATE(545),
    [sym_pointer_expression] = STATE(545),
    [sym_logical_expression] = STATE(545),
    [sym_bitwise_expression] = STATE(545),
    [sym_equality_expression] = STATE(545),
    [sym_relational_expression] = STATE(545),
    [sym_shift_expression] = STATE(545),
    [sym_math_expression] = STATE(545),
    [sym_cast_expression] = STATE(545),
    [sym_sizeof_expression] = STATE(545),
    [sym_subscript_expression] = STATE(545),
    [sym_call_expression] = STATE(545),
    [sym_field_expression] = STATE(545),
    [sym_compound_literal_expression] = STATE(545),
    [sym_parenthesized_expression] = STATE(545),
    [sym_initializer_list] = STATE(546),
    [sym_initializer_pair] = STATE(546),
    [sym_subscript_designator] = STATE(547),
    [sym_field_designator] = STATE(547),
    [sym_concatenated_string] = STATE(545),
    [aux_sym_initializer_pair_repeat1] = STATE(547),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_COMMA] = ACTIONS(1272),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(1274),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_LBRACK] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [anon_sym_DOT] = ACTIONS(1278),
    [sym_number_literal] = ACTIONS(1280),
    [sym_char_literal] = ACTIONS(1280),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(1282),
    [sym_false] = ACTIONS(1282),
    [sym_null] = ACTIONS(1282),
    [sym_identifier] = ACTIONS(1282),
    [sym_comment] = ACTIONS(42),
  },
  [299] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1284),
    [anon_sym_SEMI] = ACTIONS(1284),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_STAR_EQ] = ACTIONS(1171),
    [anon_sym_SLASH_EQ] = ACTIONS(1171),
    [anon_sym_PERCENT_EQ] = ACTIONS(1171),
    [anon_sym_PLUS_EQ] = ACTIONS(1171),
    [anon_sym_DASH_EQ] = ACTIONS(1171),
    [anon_sym_LT_LT_EQ] = ACTIONS(1171),
    [anon_sym_GT_GT_EQ] = ACTIONS(1171),
    [anon_sym_AMP_EQ] = ACTIONS(1171),
    [anon_sym_CARET_EQ] = ACTIONS(1171),
    [anon_sym_PIPE_EQ] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_PIPE_PIPE] = ACTIONS(1175),
    [anon_sym_AMP_AMP] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_LT] = ACTIONS(1185),
    [anon_sym_GT] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1187),
    [anon_sym_GT_EQ] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1189),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [300] = {
    [anon_sym_COMMA] = ACTIONS(1284),
    [anon_sym_SEMI] = ACTIONS(1284),
    [sym_comment] = ACTIONS(42),
  },
  [301] = {
    [ts_builtin_sym_end] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1288),
    [sym_preproc_directive] = ACTIONS(1288),
    [anon_sym_typedef] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1288),
    [anon_sym_RBRACE] = ACTIONS(1286),
    [anon_sym_static] = ACTIONS(1288),
    [anon_sym_auto] = ACTIONS(1288),
    [anon_sym_register] = ACTIONS(1288),
    [anon_sym_inline] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_restrict] = ACTIONS(1288),
    [anon_sym_volatile] = ACTIONS(1288),
    [anon_sym__Atomic] = ACTIONS(1288),
    [anon_sym_unsigned] = ACTIONS(1288),
    [anon_sym_long] = ACTIONS(1288),
    [anon_sym_short] = ACTIONS(1288),
    [sym_primitive_type] = ACTIONS(1288),
    [anon_sym_enum] = ACTIONS(1288),
    [anon_sym_struct] = ACTIONS(1288),
    [anon_sym_union] = ACTIONS(1288),
    [sym_identifier] = ACTIONS(1288),
    [sym_comment] = ACTIONS(42),
  },
  [302] = {
    [aux_sym_declaration_repeat1] = STATE(302),
    [anon_sym_COMMA] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(999),
    [sym_comment] = ACTIONS(42),
  },
  [303] = {
    [ts_builtin_sym_end] = ACTIONS(1293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1295),
    [sym_preproc_directive] = ACTIONS(1295),
    [anon_sym_typedef] = ACTIONS(1295),
    [anon_sym_extern] = ACTIONS(1295),
    [anon_sym_RBRACE] = ACTIONS(1293),
    [anon_sym_static] = ACTIONS(1295),
    [anon_sym_auto] = ACTIONS(1295),
    [anon_sym_register] = ACTIONS(1295),
    [anon_sym_inline] = ACTIONS(1295),
    [anon_sym_const] = ACTIONS(1295),
    [anon_sym_restrict] = ACTIONS(1295),
    [anon_sym_volatile] = ACTIONS(1295),
    [anon_sym__Atomic] = ACTIONS(1295),
    [anon_sym_unsigned] = ACTIONS(1295),
    [anon_sym_long] = ACTIONS(1295),
    [anon_sym_short] = ACTIONS(1295),
    [sym_primitive_type] = ACTIONS(1295),
    [anon_sym_enum] = ACTIONS(1295),
    [anon_sym_struct] = ACTIONS(1295),
    [anon_sym_union] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_comment] = ACTIONS(42),
  },
  [304] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1297),
    [sym_identifier] = ACTIONS(1297),
    [sym_comment] = ACTIONS(42),
  },
  [305] = {
    [anon_sym_LF] = ACTIONS(1299),
    [sym_preproc_arg] = ACTIONS(1299),
    [sym_comment] = ACTIONS(50),
  },
  [306] = {
    [aux_sym_preproc_params_repeat1] = STATE(550),
    [anon_sym_COMMA] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(1301),
    [sym_comment] = ACTIONS(42),
  },
  [307] = {
    [ts_builtin_sym_end] = ACTIONS(1303),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1305),
    [sym_preproc_directive] = ACTIONS(1305),
    [anon_sym_typedef] = ACTIONS(1305),
    [anon_sym_extern] = ACTIONS(1305),
    [anon_sym_RBRACE] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1305),
    [anon_sym_auto] = ACTIONS(1305),
    [anon_sym_register] = ACTIONS(1305),
    [anon_sym_inline] = ACTIONS(1305),
    [anon_sym_const] = ACTIONS(1305),
    [anon_sym_restrict] = ACTIONS(1305),
    [anon_sym_volatile] = ACTIONS(1305),
    [anon_sym__Atomic] = ACTIONS(1305),
    [anon_sym_unsigned] = ACTIONS(1305),
    [anon_sym_long] = ACTIONS(1305),
    [anon_sym_short] = ACTIONS(1305),
    [sym_primitive_type] = ACTIONS(1305),
    [anon_sym_enum] = ACTIONS(1305),
    [anon_sym_struct] = ACTIONS(1305),
    [anon_sym_union] = ACTIONS(1305),
    [sym_identifier] = ACTIONS(1305),
    [sym_comment] = ACTIONS(42),
  },
  [308] = {
    [sym_preproc_arg] = ACTIONS(1307),
    [sym_comment] = ACTIONS(50),
  },
  [309] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(359),
    [sym_preproc_directive] = ACTIONS(359),
    [anon_sym_typedef] = ACTIONS(359),
    [anon_sym_extern] = ACTIONS(359),
    [anon_sym_static] = ACTIONS(359),
    [anon_sym_auto] = ACTIONS(359),
    [anon_sym_register] = ACTIONS(359),
    [anon_sym_inline] = ACTIONS(359),
    [anon_sym_const] = ACTIONS(359),
    [anon_sym_restrict] = ACTIONS(359),
    [anon_sym_volatile] = ACTIONS(359),
    [anon_sym__Atomic] = ACTIONS(359),
    [anon_sym_unsigned] = ACTIONS(359),
    [anon_sym_long] = ACTIONS(359),
    [anon_sym_short] = ACTIONS(359),
    [sym_primitive_type] = ACTIONS(359),
    [anon_sym_enum] = ACTIONS(359),
    [anon_sym_struct] = ACTIONS(359),
    [anon_sym_union] = ACTIONS(359),
    [sym_identifier] = ACTIONS(359),
    [sym_comment] = ACTIONS(42),
  },
  [310] = {
    [anon_sym_LF] = ACTIONS(1309),
    [sym_preproc_arg] = ACTIONS(1311),
    [sym_comment] = ACTIONS(50),
  },
  [311] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(377),
    [sym_preproc_directive] = ACTIONS(377),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(377),
    [anon_sym_static] = ACTIONS(377),
    [anon_sym_auto] = ACTIONS(377),
    [anon_sym_register] = ACTIONS(377),
    [anon_sym_inline] = ACTIONS(377),
    [anon_sym_const] = ACTIONS(377),
    [anon_sym_restrict] = ACTIONS(377),
    [anon_sym_volatile] = ACTIONS(377),
    [anon_sym__Atomic] = ACTIONS(377),
    [anon_sym_unsigned] = ACTIONS(377),
    [anon_sym_long] = ACTIONS(377),
    [anon_sym_short] = ACTIONS(377),
    [sym_primitive_type] = ACTIONS(377),
    [anon_sym_enum] = ACTIONS(377),
    [anon_sym_struct] = ACTIONS(377),
    [anon_sym_union] = ACTIONS(377),
    [sym_identifier] = ACTIONS(377),
    [sym_comment] = ACTIONS(42),
  },
  [312] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1313),
    [sym_comment] = ACTIONS(42),
  },
  [313] = {
    [sym_preproc_include] = STATE(180),
    [sym_preproc_def] = STATE(180),
    [sym_preproc_function_def] = STATE(180),
    [sym_preproc_call] = STATE(180),
    [sym_preproc_if] = STATE(180),
    [sym_preproc_ifdef] = STATE(180),
    [sym_preproc_else] = STATE(555),
    [sym_preproc_elif] = STATE(555),
    [sym_function_definition] = STATE(180),
    [sym_declaration] = STATE(180),
    [sym_type_definition] = STATE(180),
    [sym__declaration_specifiers] = STATE(77),
    [sym_linkage_specification] = STATE(180),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(180),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(140),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(142),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1315),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(148),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(150),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(152),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(154),
    [sym_preproc_directive] = ACTIONS(156),
    [anon_sym_typedef] = ACTIONS(158),
    [anon_sym_extern] = ACTIONS(160),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [314] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(421),
    [sym_preproc_directive] = ACTIONS(421),
    [anon_sym_typedef] = ACTIONS(421),
    [anon_sym_extern] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(421),
    [anon_sym_auto] = ACTIONS(421),
    [anon_sym_register] = ACTIONS(421),
    [anon_sym_inline] = ACTIONS(421),
    [anon_sym_const] = ACTIONS(421),
    [anon_sym_restrict] = ACTIONS(421),
    [anon_sym_volatile] = ACTIONS(421),
    [anon_sym__Atomic] = ACTIONS(421),
    [anon_sym_unsigned] = ACTIONS(421),
    [anon_sym_long] = ACTIONS(421),
    [anon_sym_short] = ACTIONS(421),
    [sym_primitive_type] = ACTIONS(421),
    [anon_sym_enum] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(421),
    [anon_sym_union] = ACTIONS(421),
    [sym_identifier] = ACTIONS(421),
    [sym_comment] = ACTIONS(42),
  },
  [315] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1317),
    [sym_comment] = ACTIONS(42),
  },
  [316] = {
    [sym_preproc_include] = STATE(180),
    [sym_preproc_def] = STATE(180),
    [sym_preproc_function_def] = STATE(180),
    [sym_preproc_call] = STATE(180),
    [sym_preproc_if] = STATE(180),
    [sym_preproc_ifdef] = STATE(180),
    [sym_preproc_else] = STATE(557),
    [sym_preproc_elif] = STATE(557),
    [sym_function_definition] = STATE(180),
    [sym_declaration] = STATE(180),
    [sym_type_definition] = STATE(180),
    [sym__declaration_specifiers] = STATE(77),
    [sym_linkage_specification] = STATE(180),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(180),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(140),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(142),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1319),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(148),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(150),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(152),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(154),
    [sym_preproc_directive] = ACTIONS(156),
    [anon_sym_typedef] = ACTIONS(158),
    [anon_sym_extern] = ACTIONS(160),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [317] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(429),
    [sym_preproc_directive] = ACTIONS(429),
    [anon_sym_typedef] = ACTIONS(429),
    [anon_sym_extern] = ACTIONS(429),
    [anon_sym_static] = ACTIONS(429),
    [anon_sym_auto] = ACTIONS(429),
    [anon_sym_register] = ACTIONS(429),
    [anon_sym_inline] = ACTIONS(429),
    [anon_sym_const] = ACTIONS(429),
    [anon_sym_restrict] = ACTIONS(429),
    [anon_sym_volatile] = ACTIONS(429),
    [anon_sym__Atomic] = ACTIONS(429),
    [anon_sym_unsigned] = ACTIONS(429),
    [anon_sym_long] = ACTIONS(429),
    [anon_sym_short] = ACTIONS(429),
    [sym_primitive_type] = ACTIONS(429),
    [anon_sym_enum] = ACTIONS(429),
    [anon_sym_struct] = ACTIONS(429),
    [anon_sym_union] = ACTIONS(429),
    [sym_identifier] = ACTIONS(429),
    [sym_comment] = ACTIONS(42),
  },
  [318] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1321),
    [sym_comment] = ACTIONS(42),
  },
  [319] = {
    [sym_preproc_include] = STATE(180),
    [sym_preproc_def] = STATE(180),
    [sym_preproc_function_def] = STATE(180),
    [sym_preproc_call] = STATE(180),
    [sym_preproc_if] = STATE(180),
    [sym_preproc_ifdef] = STATE(180),
    [sym_preproc_else] = STATE(559),
    [sym_preproc_elif] = STATE(559),
    [sym_function_definition] = STATE(180),
    [sym_declaration] = STATE(180),
    [sym_type_definition] = STATE(180),
    [sym__declaration_specifiers] = STATE(77),
    [sym_linkage_specification] = STATE(180),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(180),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(140),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(142),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1323),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(148),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(150),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(152),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(154),
    [sym_preproc_directive] = ACTIONS(156),
    [anon_sym_typedef] = ACTIONS(158),
    [anon_sym_extern] = ACTIONS(160),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [320] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(132),
    [sym_preproc_directive] = ACTIONS(132),
    [anon_sym_typedef] = ACTIONS(132),
    [anon_sym_extern] = ACTIONS(132),
    [anon_sym_static] = ACTIONS(132),
    [anon_sym_auto] = ACTIONS(132),
    [anon_sym_register] = ACTIONS(132),
    [anon_sym_inline] = ACTIONS(132),
    [anon_sym_const] = ACTIONS(132),
    [anon_sym_restrict] = ACTIONS(132),
    [anon_sym_volatile] = ACTIONS(132),
    [anon_sym__Atomic] = ACTIONS(132),
    [anon_sym_unsigned] = ACTIONS(132),
    [anon_sym_long] = ACTIONS(132),
    [anon_sym_short] = ACTIONS(132),
    [sym_primitive_type] = ACTIONS(132),
    [anon_sym_enum] = ACTIONS(132),
    [anon_sym_struct] = ACTIONS(132),
    [anon_sym_union] = ACTIONS(132),
    [sym_identifier] = ACTIONS(132),
    [sym_comment] = ACTIONS(42),
  },
  [321] = {
    [sym_preproc_params] = STATE(562),
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(1325),
    [anon_sym_LF] = ACTIONS(1327),
    [anon_sym_LPAREN] = ACTIONS(138),
    [sym_comment] = ACTIONS(50),
  },
  [322] = {
    [sym_preproc_include] = STATE(565),
    [sym_preproc_def] = STATE(565),
    [sym_preproc_function_def] = STATE(565),
    [sym_preproc_call] = STATE(565),
    [sym_preproc_if] = STATE(565),
    [sym_preproc_ifdef] = STATE(565),
    [sym_preproc_else] = STATE(564),
    [sym_preproc_elif] = STATE(564),
    [sym_function_definition] = STATE(565),
    [sym_declaration] = STATE(565),
    [sym_type_definition] = STATE(565),
    [sym__declaration_specifiers] = STATE(77),
    [sym_linkage_specification] = STATE(565),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(565),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(565),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(140),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(142),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1329),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(148),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(150),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(152),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(154),
    [sym_preproc_directive] = ACTIONS(156),
    [anon_sym_typedef] = ACTIONS(158),
    [anon_sym_extern] = ACTIONS(160),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [323] = {
    [sym_preproc_include] = STATE(568),
    [sym_preproc_def] = STATE(568),
    [sym_preproc_function_def] = STATE(568),
    [sym_preproc_call] = STATE(568),
    [sym_preproc_if] = STATE(568),
    [sym_preproc_ifdef] = STATE(568),
    [sym_preproc_else] = STATE(567),
    [sym_preproc_elif] = STATE(567),
    [sym_function_definition] = STATE(568),
    [sym_declaration] = STATE(568),
    [sym_type_definition] = STATE(568),
    [sym__declaration_specifiers] = STATE(77),
    [sym_linkage_specification] = STATE(568),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(568),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(568),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(140),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(142),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1331),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(148),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(150),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(152),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(154),
    [sym_preproc_directive] = ACTIONS(156),
    [anon_sym_typedef] = ACTIONS(158),
    [anon_sym_extern] = ACTIONS(160),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [324] = {
    [sym_preproc_include] = STATE(571),
    [sym_preproc_def] = STATE(571),
    [sym_preproc_function_def] = STATE(571),
    [sym_preproc_call] = STATE(571),
    [sym_preproc_if] = STATE(571),
    [sym_preproc_ifdef] = STATE(571),
    [sym_preproc_else] = STATE(570),
    [sym_preproc_elif] = STATE(570),
    [sym_function_definition] = STATE(571),
    [sym_declaration] = STATE(571),
    [sym_type_definition] = STATE(571),
    [sym__declaration_specifiers] = STATE(77),
    [sym_linkage_specification] = STATE(571),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(571),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(571),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(140),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(142),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1333),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(148),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(150),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(152),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(154),
    [sym_preproc_directive] = ACTIONS(156),
    [anon_sym_typedef] = ACTIONS(158),
    [anon_sym_extern] = ACTIONS(160),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [325] = {
    [sym_preproc_arg] = ACTIONS(1335),
    [sym_comment] = ACTIONS(50),
  },
  [326] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(170),
    [sym_preproc_directive] = ACTIONS(170),
    [anon_sym_typedef] = ACTIONS(170),
    [anon_sym_extern] = ACTIONS(170),
    [anon_sym_static] = ACTIONS(170),
    [anon_sym_auto] = ACTIONS(170),
    [anon_sym_register] = ACTIONS(170),
    [anon_sym_inline] = ACTIONS(170),
    [anon_sym_const] = ACTIONS(170),
    [anon_sym_restrict] = ACTIONS(170),
    [anon_sym_volatile] = ACTIONS(170),
    [anon_sym__Atomic] = ACTIONS(170),
    [anon_sym_unsigned] = ACTIONS(170),
    [anon_sym_long] = ACTIONS(170),
    [anon_sym_short] = ACTIONS(170),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(170),
    [anon_sym_struct] = ACTIONS(170),
    [anon_sym_union] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_comment] = ACTIONS(42),
  },
  [327] = {
    [sym__type_declarator] = STATE(573),
    [sym_pointer_type_declarator] = STATE(99),
    [sym_function_type_declarator] = STATE(100),
    [sym_array_type_declarator] = STATE(101),
    [anon_sym_LPAREN] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(187),
    [sym_identifier] = ACTIONS(189),
    [sym_comment] = ACTIONS(42),
  },
  [328] = {
    [sym_type_qualifier] = STATE(103),
    [sym__type_specifier] = STATE(574),
    [sym_sized_type_specifier] = STATE(574),
    [sym_enum_specifier] = STATE(574),
    [sym_struct_specifier] = STATE(574),
    [sym_union_specifier] = STATE(574),
    [sym_macro_type_specifier] = STATE(574),
    [aux_sym_type_definition_repeat1] = STATE(103),
    [aux_sym_sized_type_specifier_repeat1] = STATE(36),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(62),
    [anon_sym_long] = ACTIONS(62),
    [anon_sym_short] = ACTIONS(62),
    [sym_primitive_type] = ACTIONS(1337),
    [anon_sym_enum] = ACTIONS(66),
    [anon_sym_struct] = ACTIONS(68),
    [anon_sym_union] = ACTIONS(70),
    [sym_identifier] = ACTIONS(72),
    [sym_comment] = ACTIONS(42),
  },
  [329] = {
    [sym_function_definition] = STATE(576),
    [sym_declaration] = STATE(576),
    [sym__declaration_specifiers] = STATE(577),
    [sym_declaration_list] = STATE(576),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1339),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [330] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(258),
    [sym_preproc_directive] = ACTIONS(258),
    [anon_sym_typedef] = ACTIONS(258),
    [anon_sym_extern] = ACTIONS(258),
    [anon_sym_static] = ACTIONS(258),
    [anon_sym_auto] = ACTIONS(258),
    [anon_sym_register] = ACTIONS(258),
    [anon_sym_inline] = ACTIONS(258),
    [anon_sym_const] = ACTIONS(258),
    [anon_sym_restrict] = ACTIONS(258),
    [anon_sym_volatile] = ACTIONS(258),
    [anon_sym__Atomic] = ACTIONS(258),
    [anon_sym_unsigned] = ACTIONS(258),
    [anon_sym_long] = ACTIONS(258),
    [anon_sym_short] = ACTIONS(258),
    [sym_primitive_type] = ACTIONS(258),
    [anon_sym_enum] = ACTIONS(258),
    [anon_sym_struct] = ACTIONS(258),
    [anon_sym_union] = ACTIONS(258),
    [sym_identifier] = ACTIONS(258),
    [sym_comment] = ACTIONS(42),
  },
  [331] = {
    [sym_compound_statement] = STATE(580),
    [sym_parameter_list] = STATE(145),
    [aux_sym_declaration_repeat1] = STATE(581),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_LBRACK] = ACTIONS(270),
    [anon_sym_EQ] = ACTIONS(272),
    [sym_comment] = ACTIONS(42),
  },
  [332] = {
    [aux_sym_declaration_repeat1] = STATE(581),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(1341),
    [sym_comment] = ACTIONS(42),
  },
  [333] = {
    [sym_preproc_include] = STATE(333),
    [sym_preproc_def] = STATE(333),
    [sym_preproc_function_def] = STATE(333),
    [sym_preproc_call] = STATE(333),
    [sym_preproc_if] = STATE(333),
    [sym_preproc_ifdef] = STATE(333),
    [sym_function_definition] = STATE(333),
    [sym_declaration] = STATE(333),
    [sym_type_definition] = STATE(333),
    [sym__declaration_specifiers] = STATE(167),
    [sym_linkage_specification] = STATE(333),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(333),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(333),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1345),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1348),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1351),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(768),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1354),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1357),
    [sym_preproc_directive] = ACTIONS(1360),
    [anon_sym_typedef] = ACTIONS(1363),
    [anon_sym_extern] = ACTIONS(1366),
    [anon_sym_static] = ACTIONS(308),
    [anon_sym_auto] = ACTIONS(308),
    [anon_sym_register] = ACTIONS(308),
    [anon_sym_inline] = ACTIONS(308),
    [anon_sym_const] = ACTIONS(311),
    [anon_sym_restrict] = ACTIONS(311),
    [anon_sym_volatile] = ACTIONS(311),
    [anon_sym__Atomic] = ACTIONS(311),
    [anon_sym_unsigned] = ACTIONS(314),
    [anon_sym_long] = ACTIONS(314),
    [anon_sym_short] = ACTIONS(314),
    [sym_primitive_type] = ACTIONS(317),
    [anon_sym_enum] = ACTIONS(320),
    [anon_sym_struct] = ACTIONS(323),
    [anon_sym_union] = ACTIONS(326),
    [sym_identifier] = ACTIONS(329),
    [sym_comment] = ACTIONS(42),
  },
  [334] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1369),
    [sym_comment] = ACTIONS(42),
  },
  [335] = {
    [sym_preproc_include] = STATE(180),
    [sym_preproc_def] = STATE(180),
    [sym_preproc_function_def] = STATE(180),
    [sym_preproc_call] = STATE(180),
    [sym_preproc_if] = STATE(180),
    [sym_preproc_ifdef] = STATE(180),
    [sym_preproc_else] = STATE(582),
    [sym_preproc_elif] = STATE(582),
    [sym_function_definition] = STATE(180),
    [sym_declaration] = STATE(180),
    [sym_type_definition] = STATE(180),
    [sym__declaration_specifiers] = STATE(77),
    [sym_linkage_specification] = STATE(180),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(180),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(140),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(142),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1371),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(148),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(150),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(152),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(154),
    [sym_preproc_directive] = ACTIONS(156),
    [anon_sym_typedef] = ACTIONS(158),
    [anon_sym_extern] = ACTIONS(160),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [336] = {
    [anon_sym_LF] = ACTIONS(1373),
    [sym_comment] = ACTIONS(50),
  },
  [337] = {
    [sym_parameter_list] = STATE(200),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(449),
    [sym_comment] = ACTIONS(42),
  },
  [338] = {
    [sym__type_declarator] = STATE(585),
    [sym_pointer_type_declarator] = STATE(99),
    [sym_function_type_declarator] = STATE(100),
    [sym_array_type_declarator] = STATE(101),
    [anon_sym_LPAREN] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(187),
    [sym_identifier] = ACTIONS(189),
    [sym_comment] = ACTIONS(42),
  },
  [339] = {
    [sym_preproc_include] = STATE(587),
    [sym_preproc_def] = STATE(587),
    [sym_preproc_function_def] = STATE(587),
    [sym_preproc_call] = STATE(587),
    [sym_preproc_if] = STATE(587),
    [sym_preproc_ifdef] = STATE(587),
    [sym_function_definition] = STATE(587),
    [sym_declaration] = STATE(587),
    [sym_type_definition] = STATE(587),
    [sym__declaration_specifiers] = STATE(17),
    [sym_linkage_specification] = STATE(587),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(587),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(587),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(10),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(12),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(14),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(16),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(18),
    [sym_preproc_directive] = ACTIONS(20),
    [anon_sym_typedef] = ACTIONS(22),
    [anon_sym_extern] = ACTIONS(24),
    [anon_sym_RBRACE] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [340] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(469),
    [sym_preproc_directive] = ACTIONS(469),
    [anon_sym_typedef] = ACTIONS(469),
    [anon_sym_extern] = ACTIONS(469),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_auto] = ACTIONS(469),
    [anon_sym_register] = ACTIONS(469),
    [anon_sym_inline] = ACTIONS(469),
    [anon_sym_const] = ACTIONS(469),
    [anon_sym_restrict] = ACTIONS(469),
    [anon_sym_volatile] = ACTIONS(469),
    [anon_sym__Atomic] = ACTIONS(469),
    [anon_sym_unsigned] = ACTIONS(469),
    [anon_sym_long] = ACTIONS(469),
    [anon_sym_short] = ACTIONS(469),
    [sym_primitive_type] = ACTIONS(469),
    [anon_sym_enum] = ACTIONS(469),
    [anon_sym_struct] = ACTIONS(469),
    [anon_sym_union] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_comment] = ACTIONS(42),
  },
  [341] = {
    [sym__declarator] = STATE(177),
    [sym_pointer_declarator] = STATE(177),
    [sym_function_declarator] = STATE(177),
    [sym_array_declarator] = STATE(177),
    [sym_init_declarator] = STATE(178),
    [anon_sym_LPAREN] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(103),
    [sym_identifier] = ACTIONS(415),
    [sym_comment] = ACTIONS(42),
  },
  [342] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(567),
    [sym_preproc_directive] = ACTIONS(567),
    [anon_sym_typedef] = ACTIONS(567),
    [anon_sym_extern] = ACTIONS(567),
    [anon_sym_static] = ACTIONS(567),
    [anon_sym_auto] = ACTIONS(567),
    [anon_sym_register] = ACTIONS(567),
    [anon_sym_inline] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_restrict] = ACTIONS(567),
    [anon_sym_volatile] = ACTIONS(567),
    [anon_sym__Atomic] = ACTIONS(567),
    [anon_sym_unsigned] = ACTIONS(567),
    [anon_sym_long] = ACTIONS(567),
    [anon_sym_short] = ACTIONS(567),
    [sym_primitive_type] = ACTIONS(567),
    [anon_sym_enum] = ACTIONS(567),
    [anon_sym_struct] = ACTIONS(567),
    [anon_sym_union] = ACTIONS(567),
    [sym_identifier] = ACTIONS(567),
    [sym_comment] = ACTIONS(42),
  },
  [343] = {
    [sym_preproc_include] = STATE(589),
    [sym_preproc_def] = STATE(589),
    [sym_preproc_function_def] = STATE(589),
    [sym_preproc_call] = STATE(589),
    [sym_preproc_if_in_compound_statement] = STATE(275),
    [sym_preproc_ifdef_in_compound_statement] = STATE(276),
    [sym_declaration] = STATE(589),
    [sym_type_definition] = STATE(589),
    [sym__declaration_specifiers] = STATE(277),
    [sym_compound_statement] = STATE(589),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(589),
    [sym_expression_statement] = STATE(589),
    [sym_if_statement] = STATE(589),
    [sym_switch_statement] = STATE(589),
    [sym_case_statement] = STATE(589),
    [sym_while_statement] = STATE(589),
    [sym_do_statement] = STATE(589),
    [sym_for_statement] = STATE(589),
    [sym_return_statement] = STATE(589),
    [sym_break_statement] = STATE(589),
    [sym_continue_statement] = STATE(589),
    [sym_goto_statement] = STATE(589),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [sym__empty_declaration] = STATE(589),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(589),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(577),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(579),
    [sym_preproc_directive] = ACTIONS(581),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_typedef] = ACTIONS(585),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_RBRACE] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(631),
    [sym_comment] = ACTIONS(42),
  },
  [344] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(675),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(675),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(675),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(675),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(675),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(675),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(675),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(675),
    [sym_preproc_directive] = ACTIONS(675),
    [anon_sym_typedef] = ACTIONS(675),
    [anon_sym_extern] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_auto] = ACTIONS(675),
    [anon_sym_register] = ACTIONS(675),
    [anon_sym_inline] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_restrict] = ACTIONS(675),
    [anon_sym_volatile] = ACTIONS(675),
    [anon_sym__Atomic] = ACTIONS(675),
    [anon_sym_unsigned] = ACTIONS(675),
    [anon_sym_long] = ACTIONS(675),
    [anon_sym_short] = ACTIONS(675),
    [sym_primitive_type] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [sym_identifier] = ACTIONS(675),
    [sym_comment] = ACTIONS(42),
  },
  [345] = {
    [aux_sym_declaration_repeat1] = STATE(302),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(1381),
    [sym_comment] = ACTIONS(42),
  },
  [346] = {
    [ts_builtin_sym_end] = ACTIONS(1383),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1385),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1385),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1385),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1385),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1385),
    [sym_preproc_directive] = ACTIONS(1385),
    [anon_sym_typedef] = ACTIONS(1385),
    [anon_sym_extern] = ACTIONS(1385),
    [anon_sym_RBRACE] = ACTIONS(1383),
    [anon_sym_static] = ACTIONS(1385),
    [anon_sym_auto] = ACTIONS(1385),
    [anon_sym_register] = ACTIONS(1385),
    [anon_sym_inline] = ACTIONS(1385),
    [anon_sym_const] = ACTIONS(1385),
    [anon_sym_restrict] = ACTIONS(1385),
    [anon_sym_volatile] = ACTIONS(1385),
    [anon_sym__Atomic] = ACTIONS(1385),
    [anon_sym_unsigned] = ACTIONS(1385),
    [anon_sym_long] = ACTIONS(1385),
    [anon_sym_short] = ACTIONS(1385),
    [sym_primitive_type] = ACTIONS(1385),
    [anon_sym_enum] = ACTIONS(1385),
    [anon_sym_struct] = ACTIONS(1385),
    [anon_sym_union] = ACTIONS(1385),
    [sym_identifier] = ACTIONS(1385),
    [sym_comment] = ACTIONS(42),
  },
  [347] = {
    [ts_builtin_sym_end] = ACTIONS(1387),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1389),
    [sym_preproc_directive] = ACTIONS(1389),
    [anon_sym_typedef] = ACTIONS(1389),
    [anon_sym_extern] = ACTIONS(1389),
    [anon_sym_RBRACE] = ACTIONS(1387),
    [anon_sym_static] = ACTIONS(1389),
    [anon_sym_auto] = ACTIONS(1389),
    [anon_sym_register] = ACTIONS(1389),
    [anon_sym_inline] = ACTIONS(1389),
    [anon_sym_const] = ACTIONS(1389),
    [anon_sym_restrict] = ACTIONS(1389),
    [anon_sym_volatile] = ACTIONS(1389),
    [anon_sym__Atomic] = ACTIONS(1389),
    [anon_sym_unsigned] = ACTIONS(1389),
    [anon_sym_long] = ACTIONS(1389),
    [anon_sym_short] = ACTIONS(1389),
    [sym_primitive_type] = ACTIONS(1389),
    [anon_sym_enum] = ACTIONS(1389),
    [anon_sym_struct] = ACTIONS(1389),
    [anon_sym_union] = ACTIONS(1389),
    [sym_identifier] = ACTIONS(1389),
    [sym_comment] = ACTIONS(42),
  },
  [348] = {
    [ts_builtin_sym_end] = ACTIONS(1391),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1393),
    [sym_preproc_directive] = ACTIONS(1393),
    [anon_sym_typedef] = ACTIONS(1393),
    [anon_sym_extern] = ACTIONS(1393),
    [anon_sym_RBRACE] = ACTIONS(1391),
    [anon_sym_static] = ACTIONS(1393),
    [anon_sym_auto] = ACTIONS(1393),
    [anon_sym_register] = ACTIONS(1393),
    [anon_sym_inline] = ACTIONS(1393),
    [anon_sym_const] = ACTIONS(1393),
    [anon_sym_restrict] = ACTIONS(1393),
    [anon_sym_volatile] = ACTIONS(1393),
    [anon_sym__Atomic] = ACTIONS(1393),
    [anon_sym_unsigned] = ACTIONS(1393),
    [anon_sym_long] = ACTIONS(1393),
    [anon_sym_short] = ACTIONS(1393),
    [sym_primitive_type] = ACTIONS(1393),
    [anon_sym_enum] = ACTIONS(1393),
    [anon_sym_struct] = ACTIONS(1393),
    [anon_sym_union] = ACTIONS(1393),
    [sym_identifier] = ACTIONS(1393),
    [sym_comment] = ACTIONS(42),
  },
  [349] = {
    [anon_sym_LPAREN] = ACTIONS(836),
    [anon_sym_STAR] = ACTIONS(836),
    [sym_identifier] = ACTIONS(836),
    [sym_comment] = ACTIONS(42),
  },
  [350] = {
    [sym_enumerator] = STATE(372),
    [anon_sym_RBRACE] = ACTIONS(1395),
    [sym_identifier] = ACTIONS(210),
    [sym_comment] = ACTIONS(42),
  },
  [351] = {
    [aux_sym_enumerator_list_repeat1] = STATE(374),
    [anon_sym_COMMA] = ACTIONS(1397),
    [anon_sym_RBRACE] = ACTIONS(1395),
    [sym_comment] = ACTIONS(42),
  },
  [352] = {
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_comment] = ACTIONS(42),
  },
  [353] = {
    [anon_sym_LPAREN] = ACTIONS(972),
    [anon_sym_STAR] = ACTIONS(972),
    [sym_identifier] = ACTIONS(972),
    [sym_comment] = ACTIONS(42),
  },
  [354] = {
    [anon_sym_LPAREN] = ACTIONS(1399),
    [anon_sym_RPAREN] = ACTIONS(1399),
    [anon_sym_SEMI] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(1399),
    [sym_comment] = ACTIONS(42),
  },
  [355] = {
    [anon_sym_LPAREN] = ACTIONS(1401),
    [anon_sym_RPAREN] = ACTIONS(1401),
    [anon_sym_SEMI] = ACTIONS(1401),
    [anon_sym_LBRACK] = ACTIONS(1401),
    [sym_comment] = ACTIONS(42),
  },
  [356] = {
    [sym__expression] = STATE(594),
    [sym_conditional_expression] = STATE(594),
    [sym_assignment_expression] = STATE(594),
    [sym_pointer_expression] = STATE(594),
    [sym_logical_expression] = STATE(594),
    [sym_bitwise_expression] = STATE(594),
    [sym_equality_expression] = STATE(594),
    [sym_relational_expression] = STATE(594),
    [sym_shift_expression] = STATE(594),
    [sym_math_expression] = STATE(594),
    [sym_cast_expression] = STATE(594),
    [sym_sizeof_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym_call_expression] = STATE(594),
    [sym_field_expression] = STATE(594),
    [sym_compound_literal_expression] = STATE(594),
    [sym_parenthesized_expression] = STATE(594),
    [sym_concatenated_string] = STATE(594),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(1403),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(1405),
    [sym_char_literal] = ACTIONS(1405),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(1407),
    [sym_false] = ACTIONS(1407),
    [sym_null] = ACTIONS(1407),
    [sym_identifier] = ACTIONS(1407),
    [sym_comment] = ACTIONS(42),
  },
  [357] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(1403),
    [anon_sym_EQ] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1237),
    [anon_sym_STAR_EQ] = ACTIONS(1239),
    [anon_sym_SLASH_EQ] = ACTIONS(1239),
    [anon_sym_PERCENT_EQ] = ACTIONS(1239),
    [anon_sym_PLUS_EQ] = ACTIONS(1239),
    [anon_sym_DASH_EQ] = ACTIONS(1239),
    [anon_sym_LT_LT_EQ] = ACTIONS(1239),
    [anon_sym_GT_GT_EQ] = ACTIONS(1239),
    [anon_sym_AMP_EQ] = ACTIONS(1239),
    [anon_sym_CARET_EQ] = ACTIONS(1239),
    [anon_sym_PIPE_EQ] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_PIPE_PIPE] = ACTIONS(1243),
    [anon_sym_AMP_AMP] = ACTIONS(1245),
    [anon_sym_PIPE] = ACTIONS(1247),
    [anon_sym_CARET] = ACTIONS(1249),
    [anon_sym_EQ_EQ] = ACTIONS(1251),
    [anon_sym_BANG_EQ] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1253),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [358] = {
    [ts_builtin_sym_end] = ACTIONS(1409),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1411),
    [sym_preproc_directive] = ACTIONS(1411),
    [anon_sym_typedef] = ACTIONS(1411),
    [anon_sym_extern] = ACTIONS(1411),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_static] = ACTIONS(1411),
    [anon_sym_auto] = ACTIONS(1411),
    [anon_sym_register] = ACTIONS(1411),
    [anon_sym_inline] = ACTIONS(1411),
    [anon_sym_const] = ACTIONS(1411),
    [anon_sym_restrict] = ACTIONS(1411),
    [anon_sym_volatile] = ACTIONS(1411),
    [anon_sym__Atomic] = ACTIONS(1411),
    [anon_sym_unsigned] = ACTIONS(1411),
    [anon_sym_long] = ACTIONS(1411),
    [anon_sym_short] = ACTIONS(1411),
    [sym_primitive_type] = ACTIONS(1411),
    [anon_sym_enum] = ACTIONS(1411),
    [anon_sym_struct] = ACTIONS(1411),
    [anon_sym_union] = ACTIONS(1411),
    [sym_identifier] = ACTIONS(1411),
    [sym_comment] = ACTIONS(42),
  },
  [359] = {
    [ts_builtin_sym_end] = ACTIONS(1413),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1415),
    [sym_preproc_directive] = ACTIONS(1415),
    [anon_sym_typedef] = ACTIONS(1415),
    [anon_sym_extern] = ACTIONS(1415),
    [anon_sym_RBRACE] = ACTIONS(1413),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_auto] = ACTIONS(1415),
    [anon_sym_register] = ACTIONS(1415),
    [anon_sym_inline] = ACTIONS(1415),
    [anon_sym_const] = ACTIONS(1415),
    [anon_sym_restrict] = ACTIONS(1415),
    [anon_sym_volatile] = ACTIONS(1415),
    [anon_sym__Atomic] = ACTIONS(1415),
    [anon_sym_unsigned] = ACTIONS(1415),
    [anon_sym_long] = ACTIONS(1415),
    [anon_sym_short] = ACTIONS(1415),
    [sym_primitive_type] = ACTIONS(1415),
    [anon_sym_enum] = ACTIONS(1415),
    [anon_sym_struct] = ACTIONS(1415),
    [anon_sym_union] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_comment] = ACTIONS(42),
  },
  [360] = {
    [sym_preproc_include] = STATE(360),
    [sym_preproc_def] = STATE(360),
    [sym_preproc_function_def] = STATE(360),
    [sym_preproc_call] = STATE(360),
    [sym_preproc_if] = STATE(360),
    [sym_preproc_ifdef] = STATE(360),
    [sym_function_definition] = STATE(360),
    [sym_declaration] = STATE(360),
    [sym_type_definition] = STATE(360),
    [sym__declaration_specifiers] = STATE(17),
    [sym_linkage_specification] = STATE(360),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(360),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(360),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(284),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(287),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(296),
    [sym_preproc_directive] = ACTIONS(299),
    [anon_sym_typedef] = ACTIONS(302),
    [anon_sym_extern] = ACTIONS(305),
    [anon_sym_RBRACE] = ACTIONS(282),
    [anon_sym_static] = ACTIONS(308),
    [anon_sym_auto] = ACTIONS(308),
    [anon_sym_register] = ACTIONS(308),
    [anon_sym_inline] = ACTIONS(308),
    [anon_sym_const] = ACTIONS(311),
    [anon_sym_restrict] = ACTIONS(311),
    [anon_sym_volatile] = ACTIONS(311),
    [anon_sym__Atomic] = ACTIONS(311),
    [anon_sym_unsigned] = ACTIONS(314),
    [anon_sym_long] = ACTIONS(314),
    [anon_sym_short] = ACTIONS(314),
    [sym_primitive_type] = ACTIONS(317),
    [anon_sym_enum] = ACTIONS(320),
    [anon_sym_struct] = ACTIONS(323),
    [anon_sym_union] = ACTIONS(326),
    [sym_identifier] = ACTIONS(329),
    [sym_comment] = ACTIONS(42),
  },
  [361] = {
    [sym_storage_class_specifier] = STATE(361),
    [sym_type_qualifier] = STATE(361),
    [aux_sym__declaration_specifiers_repeat1] = STATE(361),
    [anon_sym_LPAREN] = ACTIONS(681),
    [anon_sym_extern] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(681),
    [anon_sym_static] = ACTIONS(683),
    [anon_sym_auto] = ACTIONS(683),
    [anon_sym_register] = ACTIONS(683),
    [anon_sym_inline] = ACTIONS(683),
    [anon_sym_const] = ACTIONS(686),
    [anon_sym_restrict] = ACTIONS(686),
    [anon_sym_volatile] = ACTIONS(686),
    [anon_sym__Atomic] = ACTIONS(686),
    [sym_identifier] = ACTIONS(338),
    [sym_comment] = ACTIONS(42),
  },
  [362] = {
    [sym_storage_class_specifier] = STATE(361),
    [sym_type_qualifier] = STATE(361),
    [aux_sym__declaration_specifiers_repeat1] = STATE(361),
    [anon_sym_LPAREN] = ACTIONS(689),
    [anon_sym_extern] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_auto] = ACTIONS(109),
    [anon_sym_register] = ACTIONS(109),
    [anon_sym_inline] = ACTIONS(109),
    [anon_sym_const] = ACTIONS(111),
    [anon_sym_restrict] = ACTIONS(111),
    [anon_sym_volatile] = ACTIONS(111),
    [anon_sym__Atomic] = ACTIONS(111),
    [sym_identifier] = ACTIONS(691),
    [sym_comment] = ACTIONS(42),
  },
  [363] = {
    [sym_type_qualifier] = STATE(133),
    [sym__type_specifier] = STATE(131),
    [sym_sized_type_specifier] = STATE(131),
    [sym_enum_specifier] = STATE(131),
    [sym_struct_specifier] = STATE(131),
    [sym_union_specifier] = STATE(131),
    [sym__expression] = STATE(436),
    [sym_comma_expression] = STATE(437),
    [sym_conditional_expression] = STATE(436),
    [sym_assignment_expression] = STATE(436),
    [sym_pointer_expression] = STATE(436),
    [sym_logical_expression] = STATE(436),
    [sym_bitwise_expression] = STATE(436),
    [sym_equality_expression] = STATE(436),
    [sym_relational_expression] = STATE(436),
    [sym_shift_expression] = STATE(436),
    [sym_math_expression] = STATE(436),
    [sym_cast_expression] = STATE(436),
    [sym_type_descriptor] = STATE(595),
    [sym_sizeof_expression] = STATE(436),
    [sym_subscript_expression] = STATE(436),
    [sym_call_expression] = STATE(436),
    [sym_field_expression] = STATE(436),
    [sym_compound_literal_expression] = STATE(436),
    [sym_parenthesized_expression] = STATE(436),
    [sym_concatenated_string] = STATE(436),
    [sym_macro_type_specifier] = STATE(131),
    [aux_sym_type_definition_repeat1] = STATE(133),
    [aux_sym_sized_type_specifier_repeat1] = STATE(134),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(248),
    [anon_sym_long] = ACTIONS(248),
    [anon_sym_short] = ACTIONS(248),
    [sym_primitive_type] = ACTIONS(250),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1019),
    [sym_char_literal] = ACTIONS(1019),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(1023),
    [sym_false] = ACTIONS(1023),
    [sym_null] = ACTIONS(1023),
    [sym_identifier] = ACTIONS(1025),
    [sym_comment] = ACTIONS(42),
  },
  [364] = {
    [sym__expression] = STATE(448),
    [sym_conditional_expression] = STATE(448),
    [sym_assignment_expression] = STATE(448),
    [sym_pointer_expression] = STATE(448),
    [sym_logical_expression] = STATE(448),
    [sym_bitwise_expression] = STATE(448),
    [sym_equality_expression] = STATE(448),
    [sym_relational_expression] = STATE(448),
    [sym_shift_expression] = STATE(448),
    [sym_math_expression] = STATE(448),
    [sym_cast_expression] = STATE(448),
    [sym_sizeof_expression] = STATE(448),
    [sym_subscript_expression] = STATE(448),
    [sym_call_expression] = STATE(448),
    [sym_field_expression] = STATE(448),
    [sym_compound_literal_expression] = STATE(448),
    [sym_parenthesized_expression] = STATE(448),
    [sym_concatenated_string] = STATE(448),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [sym_number_literal] = ACTIONS(1049),
    [sym_char_literal] = ACTIONS(1049),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(1051),
    [sym_false] = ACTIONS(1051),
    [sym_null] = ACTIONS(1051),
    [sym_identifier] = ACTIONS(1051),
    [sym_comment] = ACTIONS(42),
  },
  [365] = {
    [sym__expression] = STATE(475),
    [sym_conditional_expression] = STATE(475),
    [sym_assignment_expression] = STATE(475),
    [sym_pointer_expression] = STATE(475),
    [sym_logical_expression] = STATE(475),
    [sym_bitwise_expression] = STATE(475),
    [sym_equality_expression] = STATE(475),
    [sym_relational_expression] = STATE(475),
    [sym_shift_expression] = STATE(475),
    [sym_math_expression] = STATE(475),
    [sym_cast_expression] = STATE(475),
    [sym_sizeof_expression] = STATE(475),
    [sym_subscript_expression] = STATE(475),
    [sym_call_expression] = STATE(475),
    [sym_field_expression] = STATE(475),
    [sym_compound_literal_expression] = STATE(475),
    [sym_parenthesized_expression] = STATE(475),
    [sym_concatenated_string] = STATE(475),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [sym_number_literal] = ACTIONS(1109),
    [sym_char_literal] = ACTIONS(1109),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(1111),
    [sym_false] = ACTIONS(1111),
    [sym_null] = ACTIONS(1111),
    [sym_identifier] = ACTIONS(1111),
    [sym_comment] = ACTIONS(42),
  },
  [366] = {
    [sym__expression] = STATE(476),
    [sym_conditional_expression] = STATE(476),
    [sym_assignment_expression] = STATE(476),
    [sym_pointer_expression] = STATE(476),
    [sym_logical_expression] = STATE(476),
    [sym_bitwise_expression] = STATE(476),
    [sym_equality_expression] = STATE(476),
    [sym_relational_expression] = STATE(476),
    [sym_shift_expression] = STATE(476),
    [sym_math_expression] = STATE(476),
    [sym_cast_expression] = STATE(476),
    [sym_sizeof_expression] = STATE(476),
    [sym_subscript_expression] = STATE(476),
    [sym_call_expression] = STATE(476),
    [sym_field_expression] = STATE(476),
    [sym_compound_literal_expression] = STATE(476),
    [sym_parenthesized_expression] = STATE(476),
    [sym_concatenated_string] = STATE(476),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [sym_number_literal] = ACTIONS(1113),
    [sym_char_literal] = ACTIONS(1113),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(1115),
    [sym_false] = ACTIONS(1115),
    [sym_null] = ACTIONS(1115),
    [sym_identifier] = ACTIONS(1115),
    [sym_comment] = ACTIONS(42),
  },
  [367] = {
    [sym__expression] = STATE(477),
    [sym_conditional_expression] = STATE(477),
    [sym_assignment_expression] = STATE(477),
    [sym_pointer_expression] = STATE(477),
    [sym_logical_expression] = STATE(477),
    [sym_bitwise_expression] = STATE(477),
    [sym_equality_expression] = STATE(477),
    [sym_relational_expression] = STATE(477),
    [sym_shift_expression] = STATE(477),
    [sym_math_expression] = STATE(477),
    [sym_cast_expression] = STATE(477),
    [sym_sizeof_expression] = STATE(477),
    [sym_subscript_expression] = STATE(477),
    [sym_call_expression] = STATE(477),
    [sym_field_expression] = STATE(477),
    [sym_compound_literal_expression] = STATE(477),
    [sym_parenthesized_expression] = STATE(477),
    [sym_concatenated_string] = STATE(477),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [sym_number_literal] = ACTIONS(1117),
    [sym_char_literal] = ACTIONS(1117),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(1119),
    [sym_false] = ACTIONS(1119),
    [sym_null] = ACTIONS(1119),
    [sym_identifier] = ACTIONS(1119),
    [sym_comment] = ACTIONS(42),
  },
  [368] = {
    [sym__expression] = STATE(597),
    [sym_conditional_expression] = STATE(597),
    [sym_assignment_expression] = STATE(597),
    [sym_pointer_expression] = STATE(597),
    [sym_logical_expression] = STATE(597),
    [sym_bitwise_expression] = STATE(597),
    [sym_equality_expression] = STATE(597),
    [sym_relational_expression] = STATE(597),
    [sym_shift_expression] = STATE(597),
    [sym_math_expression] = STATE(597),
    [sym_cast_expression] = STATE(597),
    [sym_sizeof_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym_call_expression] = STATE(597),
    [sym_field_expression] = STATE(597),
    [sym_compound_literal_expression] = STATE(597),
    [sym_parenthesized_expression] = STATE(597),
    [sym_concatenated_string] = STATE(597),
    [anon_sym_LPAREN] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [sym_number_literal] = ACTIONS(1419),
    [sym_char_literal] = ACTIONS(1419),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(1421),
    [sym_false] = ACTIONS(1421),
    [sym_null] = ACTIONS(1421),
    [sym_identifier] = ACTIONS(1421),
    [sym_comment] = ACTIONS(42),
  },
  [369] = {
    [aux_sym_concatenated_string_repeat1] = STATE(598),
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_RBRACE] = ACTIONS(1127),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_string_literal] = ACTIONS(1423),
    [sym_comment] = ACTIONS(42),
  },
  [370] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1425),
    [anon_sym_RBRACE] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1429),
    [anon_sym_QMARK] = ACTIONS(1431),
    [anon_sym_STAR_EQ] = ACTIONS(1433),
    [anon_sym_SLASH_EQ] = ACTIONS(1433),
    [anon_sym_PERCENT_EQ] = ACTIONS(1433),
    [anon_sym_PLUS_EQ] = ACTIONS(1433),
    [anon_sym_DASH_EQ] = ACTIONS(1433),
    [anon_sym_LT_LT_EQ] = ACTIONS(1433),
    [anon_sym_GT_GT_EQ] = ACTIONS(1433),
    [anon_sym_AMP_EQ] = ACTIONS(1433),
    [anon_sym_CARET_EQ] = ACTIONS(1433),
    [anon_sym_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_PIPE] = ACTIONS(1441),
    [anon_sym_CARET] = ACTIONS(1443),
    [anon_sym_EQ_EQ] = ACTIONS(1445),
    [anon_sym_BANG_EQ] = ACTIONS(1445),
    [anon_sym_LT] = ACTIONS(1447),
    [anon_sym_GT] = ACTIONS(1447),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1451),
    [anon_sym_GT_GT] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_SLASH] = ACTIONS(1427),
    [anon_sym_PERCENT] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [371] = {
    [anon_sym_LPAREN] = ACTIONS(1455),
    [anon_sym_COMMA] = ACTIONS(1455),
    [anon_sym_RPAREN] = ACTIONS(1455),
    [anon_sym_SEMI] = ACTIONS(1455),
    [anon_sym_extern] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1455),
    [anon_sym_LBRACK] = ACTIONS(1455),
    [anon_sym_static] = ACTIONS(1457),
    [anon_sym_auto] = ACTIONS(1457),
    [anon_sym_register] = ACTIONS(1457),
    [anon_sym_inline] = ACTIONS(1457),
    [anon_sym_const] = ACTIONS(1457),
    [anon_sym_restrict] = ACTIONS(1457),
    [anon_sym_volatile] = ACTIONS(1457),
    [anon_sym__Atomic] = ACTIONS(1457),
    [anon_sym_COLON] = ACTIONS(1455),
    [sym_identifier] = ACTIONS(1457),
    [sym_comment] = ACTIONS(42),
  },
  [372] = {
    [anon_sym_COMMA] = ACTIONS(1459),
    [anon_sym_RBRACE] = ACTIONS(1459),
    [sym_comment] = ACTIONS(42),
  },
  [373] = {
    [sym_enumerator] = STATE(372),
    [anon_sym_RBRACE] = ACTIONS(1461),
    [sym_identifier] = ACTIONS(210),
    [sym_comment] = ACTIONS(42),
  },
  [374] = {
    [aux_sym_enumerator_list_repeat1] = STATE(374),
    [anon_sym_COMMA] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(1459),
    [sym_comment] = ACTIONS(42),
  },
  [375] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1466),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1468),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1468),
    [anon_sym_extern] = ACTIONS(1466),
    [anon_sym_RBRACE] = ACTIONS(1468),
    [anon_sym_static] = ACTIONS(1466),
    [anon_sym_auto] = ACTIONS(1466),
    [anon_sym_register] = ACTIONS(1466),
    [anon_sym_inline] = ACTIONS(1466),
    [anon_sym_const] = ACTIONS(1466),
    [anon_sym_restrict] = ACTIONS(1466),
    [anon_sym_volatile] = ACTIONS(1466),
    [anon_sym__Atomic] = ACTIONS(1466),
    [anon_sym_unsigned] = ACTIONS(1466),
    [anon_sym_long] = ACTIONS(1466),
    [anon_sym_short] = ACTIONS(1466),
    [sym_primitive_type] = ACTIONS(1466),
    [anon_sym_enum] = ACTIONS(1466),
    [anon_sym_struct] = ACTIONS(1466),
    [anon_sym_union] = ACTIONS(1466),
    [sym_identifier] = ACTIONS(1466),
    [sym_comment] = ACTIONS(42),
  },
  [376] = {
    [sym__declaration_specifiers] = STATE(124),
    [sym_storage_class_specifier] = STATE(126),
    [sym_type_qualifier] = STATE(126),
    [sym__type_specifier] = STATE(125),
    [sym_sized_type_specifier] = STATE(125),
    [sym_enum_specifier] = STATE(125),
    [sym_struct_specifier] = STATE(125),
    [sym_union_specifier] = STATE(125),
    [sym_field_declaration] = STATE(613),
    [sym_macro_type_specifier] = STATE(125),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(613),
    [aux_sym__declaration_specifiers_repeat1] = STATE(126),
    [aux_sym_sized_type_specifier_repeat1] = STATE(127),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1470),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(228),
    [anon_sym_long] = ACTIONS(228),
    [anon_sym_short] = ACTIONS(228),
    [sym_primitive_type] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [377] = {
    [sym_preproc_arg] = ACTIONS(1472),
    [sym_comment] = ACTIONS(50),
  },
  [378] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1474),
    [sym_comment] = ACTIONS(42),
  },
  [379] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1476),
    [sym_comment] = ACTIONS(42),
  },
  [380] = {
    [sym_preproc_else_in_field_declaration_list] = STATE(618),
    [sym_preproc_elif_in_field_declaration_list] = STATE(619),
    [sym__declaration_specifiers] = STATE(124),
    [sym_storage_class_specifier] = STATE(126),
    [sym_type_qualifier] = STATE(126),
    [sym__type_specifier] = STATE(125),
    [sym_sized_type_specifier] = STATE(125),
    [sym_enum_specifier] = STATE(125),
    [sym_struct_specifier] = STATE(125),
    [sym_union_specifier] = STATE(125),
    [sym_field_declaration] = STATE(620),
    [sym_macro_type_specifier] = STATE(125),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(620),
    [aux_sym__declaration_specifiers_repeat1] = STATE(126),
    [aux_sym_sized_type_specifier_repeat1] = STATE(127),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1478),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(868),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(228),
    [anon_sym_long] = ACTIONS(228),
    [anon_sym_short] = ACTIONS(228),
    [sym_primitive_type] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [381] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1480),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1482),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1482),
    [anon_sym_extern] = ACTIONS(1480),
    [anon_sym_RBRACE] = ACTIONS(1482),
    [anon_sym_static] = ACTIONS(1480),
    [anon_sym_auto] = ACTIONS(1480),
    [anon_sym_register] = ACTIONS(1480),
    [anon_sym_inline] = ACTIONS(1480),
    [anon_sym_const] = ACTIONS(1480),
    [anon_sym_restrict] = ACTIONS(1480),
    [anon_sym_volatile] = ACTIONS(1480),
    [anon_sym__Atomic] = ACTIONS(1480),
    [anon_sym_unsigned] = ACTIONS(1480),
    [anon_sym_long] = ACTIONS(1480),
    [anon_sym_short] = ACTIONS(1480),
    [sym_primitive_type] = ACTIONS(1480),
    [anon_sym_enum] = ACTIONS(1480),
    [anon_sym_struct] = ACTIONS(1480),
    [anon_sym_union] = ACTIONS(1480),
    [sym_identifier] = ACTIONS(1480),
    [sym_comment] = ACTIONS(42),
  },
  [382] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1484),
    [sym_comment] = ACTIONS(42),
  },
  [383] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1486),
    [sym_comment] = ACTIONS(42),
  },
  [384] = {
    [sym_preproc_else_in_field_declaration_list] = STATE(624),
    [sym_preproc_elif_in_field_declaration_list] = STATE(625),
    [sym__declaration_specifiers] = STATE(124),
    [sym_storage_class_specifier] = STATE(126),
    [sym_type_qualifier] = STATE(126),
    [sym__type_specifier] = STATE(125),
    [sym_sized_type_specifier] = STATE(125),
    [sym_enum_specifier] = STATE(125),
    [sym_struct_specifier] = STATE(125),
    [sym_union_specifier] = STATE(125),
    [sym_field_declaration] = STATE(620),
    [sym_macro_type_specifier] = STATE(125),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(620),
    [aux_sym__declaration_specifiers_repeat1] = STATE(126),
    [aux_sym_sized_type_specifier_repeat1] = STATE(127),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1488),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(868),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(228),
    [anon_sym_long] = ACTIONS(228),
    [anon_sym_short] = ACTIONS(228),
    [sym_primitive_type] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [385] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1490),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1492),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1492),
    [anon_sym_extern] = ACTIONS(1490),
    [anon_sym_RBRACE] = ACTIONS(1492),
    [anon_sym_static] = ACTIONS(1490),
    [anon_sym_auto] = ACTIONS(1490),
    [anon_sym_register] = ACTIONS(1490),
    [anon_sym_inline] = ACTIONS(1490),
    [anon_sym_const] = ACTIONS(1490),
    [anon_sym_restrict] = ACTIONS(1490),
    [anon_sym_volatile] = ACTIONS(1490),
    [anon_sym__Atomic] = ACTIONS(1490),
    [anon_sym_unsigned] = ACTIONS(1490),
    [anon_sym_long] = ACTIONS(1490),
    [anon_sym_short] = ACTIONS(1490),
    [sym_primitive_type] = ACTIONS(1490),
    [anon_sym_enum] = ACTIONS(1490),
    [anon_sym_struct] = ACTIONS(1490),
    [anon_sym_union] = ACTIONS(1490),
    [sym_identifier] = ACTIONS(1490),
    [sym_comment] = ACTIONS(42),
  },
  [386] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1494),
    [sym_comment] = ACTIONS(42),
  },
  [387] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1496),
    [sym_comment] = ACTIONS(42),
  },
  [388] = {
    [sym_preproc_else_in_field_declaration_list] = STATE(629),
    [sym_preproc_elif_in_field_declaration_list] = STATE(630),
    [sym__declaration_specifiers] = STATE(124),
    [sym_storage_class_specifier] = STATE(126),
    [sym_type_qualifier] = STATE(126),
    [sym__type_specifier] = STATE(125),
    [sym_sized_type_specifier] = STATE(125),
    [sym_enum_specifier] = STATE(125),
    [sym_struct_specifier] = STATE(125),
    [sym_union_specifier] = STATE(125),
    [sym_field_declaration] = STATE(620),
    [sym_macro_type_specifier] = STATE(125),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(620),
    [aux_sym__declaration_specifiers_repeat1] = STATE(126),
    [aux_sym_sized_type_specifier_repeat1] = STATE(127),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1498),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(868),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(228),
    [anon_sym_long] = ACTIONS(228),
    [anon_sym_short] = ACTIONS(228),
    [sym_primitive_type] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [389] = {
    [sym__field_declarator] = STATE(391),
    [sym_pointer_field_declarator] = STATE(220),
    [sym_function_field_declarator] = STATE(221),
    [sym_array_field_declarator] = STATE(222),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(874),
    [sym_identifier] = ACTIONS(517),
    [sym_comment] = ACTIONS(42),
  },
  [390] = {
    [sym_parameter_list] = STATE(404),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_RPAREN] = ACTIONS(1500),
    [anon_sym_LBRACK] = ACTIONS(906),
    [sym_comment] = ACTIONS(42),
  },
  [391] = {
    [sym_parameter_list] = STATE(404),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_COMMA] = ACTIONS(1502),
    [anon_sym_RPAREN] = ACTIONS(1502),
    [anon_sym_SEMI] = ACTIONS(1502),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_COLON] = ACTIONS(1502),
    [sym_comment] = ACTIONS(42),
  },
  [392] = {
    [sym_type_qualifier] = STATE(133),
    [sym__type_specifier] = STATE(131),
    [sym_sized_type_specifier] = STATE(131),
    [sym_enum_specifier] = STATE(131),
    [sym_struct_specifier] = STATE(131),
    [sym_union_specifier] = STATE(131),
    [sym__expression] = STATE(436),
    [sym_comma_expression] = STATE(437),
    [sym_conditional_expression] = STATE(436),
    [sym_assignment_expression] = STATE(436),
    [sym_pointer_expression] = STATE(436),
    [sym_logical_expression] = STATE(436),
    [sym_bitwise_expression] = STATE(436),
    [sym_equality_expression] = STATE(436),
    [sym_relational_expression] = STATE(436),
    [sym_shift_expression] = STATE(436),
    [sym_math_expression] = STATE(436),
    [sym_cast_expression] = STATE(436),
    [sym_type_descriptor] = STATE(632),
    [sym_sizeof_expression] = STATE(436),
    [sym_subscript_expression] = STATE(436),
    [sym_call_expression] = STATE(436),
    [sym_field_expression] = STATE(436),
    [sym_compound_literal_expression] = STATE(436),
    [sym_parenthesized_expression] = STATE(436),
    [sym_concatenated_string] = STATE(436),
    [sym_macro_type_specifier] = STATE(131),
    [aux_sym_type_definition_repeat1] = STATE(133),
    [aux_sym_sized_type_specifier_repeat1] = STATE(134),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(248),
    [anon_sym_long] = ACTIONS(248),
    [anon_sym_short] = ACTIONS(248),
    [sym_primitive_type] = ACTIONS(250),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1019),
    [sym_char_literal] = ACTIONS(1019),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(1023),
    [sym_false] = ACTIONS(1023),
    [sym_null] = ACTIONS(1023),
    [sym_identifier] = ACTIONS(1025),
    [sym_comment] = ACTIONS(42),
  },
  [393] = {
    [sym__expression] = STATE(448),
    [sym_conditional_expression] = STATE(448),
    [sym_assignment_expression] = STATE(448),
    [sym_pointer_expression] = STATE(448),
    [sym_logical_expression] = STATE(448),
    [sym_bitwise_expression] = STATE(448),
    [sym_equality_expression] = STATE(448),
    [sym_relational_expression] = STATE(448),
    [sym_shift_expression] = STATE(448),
    [sym_math_expression] = STATE(448),
    [sym_cast_expression] = STATE(448),
    [sym_sizeof_expression] = STATE(448),
    [sym_subscript_expression] = STATE(448),
    [sym_call_expression] = STATE(448),
    [sym_field_expression] = STATE(448),
    [sym_compound_literal_expression] = STATE(448),
    [sym_parenthesized_expression] = STATE(448),
    [sym_concatenated_string] = STATE(448),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(1049),
    [sym_char_literal] = ACTIONS(1049),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(1051),
    [sym_false] = ACTIONS(1051),
    [sym_null] = ACTIONS(1051),
    [sym_identifier] = ACTIONS(1051),
    [sym_comment] = ACTIONS(42),
  },
  [394] = {
    [sym__expression] = STATE(475),
    [sym_conditional_expression] = STATE(475),
    [sym_assignment_expression] = STATE(475),
    [sym_pointer_expression] = STATE(475),
    [sym_logical_expression] = STATE(475),
    [sym_bitwise_expression] = STATE(475),
    [sym_equality_expression] = STATE(475),
    [sym_relational_expression] = STATE(475),
    [sym_shift_expression] = STATE(475),
    [sym_math_expression] = STATE(475),
    [sym_cast_expression] = STATE(475),
    [sym_sizeof_expression] = STATE(475),
    [sym_subscript_expression] = STATE(475),
    [sym_call_expression] = STATE(475),
    [sym_field_expression] = STATE(475),
    [sym_compound_literal_expression] = STATE(475),
    [sym_parenthesized_expression] = STATE(475),
    [sym_concatenated_string] = STATE(475),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(1109),
    [sym_char_literal] = ACTIONS(1109),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(1111),
    [sym_false] = ACTIONS(1111),
    [sym_null] = ACTIONS(1111),
    [sym_identifier] = ACTIONS(1111),
    [sym_comment] = ACTIONS(42),
  },
  [395] = {
    [sym__expression] = STATE(476),
    [sym_conditional_expression] = STATE(476),
    [sym_assignment_expression] = STATE(476),
    [sym_pointer_expression] = STATE(476),
    [sym_logical_expression] = STATE(476),
    [sym_bitwise_expression] = STATE(476),
    [sym_equality_expression] = STATE(476),
    [sym_relational_expression] = STATE(476),
    [sym_shift_expression] = STATE(476),
    [sym_math_expression] = STATE(476),
    [sym_cast_expression] = STATE(476),
    [sym_sizeof_expression] = STATE(476),
    [sym_subscript_expression] = STATE(476),
    [sym_call_expression] = STATE(476),
    [sym_field_expression] = STATE(476),
    [sym_compound_literal_expression] = STATE(476),
    [sym_parenthesized_expression] = STATE(476),
    [sym_concatenated_string] = STATE(476),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(1113),
    [sym_char_literal] = ACTIONS(1113),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(1115),
    [sym_false] = ACTIONS(1115),
    [sym_null] = ACTIONS(1115),
    [sym_identifier] = ACTIONS(1115),
    [sym_comment] = ACTIONS(42),
  },
  [396] = {
    [sym__expression] = STATE(477),
    [sym_conditional_expression] = STATE(477),
    [sym_assignment_expression] = STATE(477),
    [sym_pointer_expression] = STATE(477),
    [sym_logical_expression] = STATE(477),
    [sym_bitwise_expression] = STATE(477),
    [sym_equality_expression] = STATE(477),
    [sym_relational_expression] = STATE(477),
    [sym_shift_expression] = STATE(477),
    [sym_math_expression] = STATE(477),
    [sym_cast_expression] = STATE(477),
    [sym_sizeof_expression] = STATE(477),
    [sym_subscript_expression] = STATE(477),
    [sym_call_expression] = STATE(477),
    [sym_field_expression] = STATE(477),
    [sym_compound_literal_expression] = STATE(477),
    [sym_parenthesized_expression] = STATE(477),
    [sym_concatenated_string] = STATE(477),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(1117),
    [sym_char_literal] = ACTIONS(1117),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(1119),
    [sym_false] = ACTIONS(1119),
    [sym_null] = ACTIONS(1119),
    [sym_identifier] = ACTIONS(1119),
    [sym_comment] = ACTIONS(42),
  },
  [397] = {
    [sym__expression] = STATE(634),
    [sym_conditional_expression] = STATE(634),
    [sym_assignment_expression] = STATE(634),
    [sym_pointer_expression] = STATE(634),
    [sym_logical_expression] = STATE(634),
    [sym_bitwise_expression] = STATE(634),
    [sym_equality_expression] = STATE(634),
    [sym_relational_expression] = STATE(634),
    [sym_shift_expression] = STATE(634),
    [sym_math_expression] = STATE(634),
    [sym_cast_expression] = STATE(634),
    [sym_sizeof_expression] = STATE(634),
    [sym_subscript_expression] = STATE(634),
    [sym_call_expression] = STATE(634),
    [sym_field_expression] = STATE(634),
    [sym_compound_literal_expression] = STATE(634),
    [sym_parenthesized_expression] = STATE(634),
    [sym_concatenated_string] = STATE(634),
    [anon_sym_LPAREN] = ACTIONS(1504),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(1506),
    [sym_char_literal] = ACTIONS(1506),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(1508),
    [sym_false] = ACTIONS(1508),
    [sym_null] = ACTIONS(1508),
    [sym_identifier] = ACTIONS(1508),
    [sym_comment] = ACTIONS(42),
  },
  [398] = {
    [aux_sym_concatenated_string_repeat1] = STATE(635),
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_string_literal] = ACTIONS(1510),
    [sym_comment] = ACTIONS(42),
  },
  [399] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(1512),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [400] = {
    [sym__field_declarator] = STATE(649),
    [sym_pointer_field_declarator] = STATE(220),
    [sym_function_field_declarator] = STATE(221),
    [sym_array_field_declarator] = STATE(222),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(513),
    [sym_identifier] = ACTIONS(517),
    [sym_comment] = ACTIONS(42),
  },
  [401] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1542),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1544),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1544),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1544),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1544),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1544),
    [anon_sym_extern] = ACTIONS(1542),
    [anon_sym_RBRACE] = ACTIONS(1544),
    [anon_sym_static] = ACTIONS(1542),
    [anon_sym_auto] = ACTIONS(1542),
    [anon_sym_register] = ACTIONS(1542),
    [anon_sym_inline] = ACTIONS(1542),
    [anon_sym_const] = ACTIONS(1542),
    [anon_sym_restrict] = ACTIONS(1542),
    [anon_sym_volatile] = ACTIONS(1542),
    [anon_sym__Atomic] = ACTIONS(1542),
    [anon_sym_unsigned] = ACTIONS(1542),
    [anon_sym_long] = ACTIONS(1542),
    [anon_sym_short] = ACTIONS(1542),
    [sym_primitive_type] = ACTIONS(1542),
    [anon_sym_enum] = ACTIONS(1542),
    [anon_sym_struct] = ACTIONS(1542),
    [anon_sym_union] = ACTIONS(1542),
    [sym_identifier] = ACTIONS(1542),
    [sym_comment] = ACTIONS(42),
  },
  [402] = {
    [sym__declaration_specifiers] = STATE(651),
    [sym_storage_class_specifier] = STATE(296),
    [sym_type_qualifier] = STATE(296),
    [sym__type_specifier] = STATE(294),
    [sym_sized_type_specifier] = STATE(294),
    [sym_enum_specifier] = STATE(294),
    [sym_struct_specifier] = STATE(294),
    [sym_union_specifier] = STATE(294),
    [sym__expression] = STATE(652),
    [sym_conditional_expression] = STATE(652),
    [sym_assignment_expression] = STATE(652),
    [sym_pointer_expression] = STATE(652),
    [sym_logical_expression] = STATE(652),
    [sym_bitwise_expression] = STATE(652),
    [sym_equality_expression] = STATE(652),
    [sym_relational_expression] = STATE(652),
    [sym_shift_expression] = STATE(652),
    [sym_math_expression] = STATE(652),
    [sym_cast_expression] = STATE(652),
    [sym_sizeof_expression] = STATE(652),
    [sym_subscript_expression] = STATE(652),
    [sym_call_expression] = STATE(652),
    [sym_field_expression] = STATE(652),
    [sym_compound_literal_expression] = STATE(652),
    [sym_parenthesized_expression] = STATE(652),
    [sym_concatenated_string] = STATE(652),
    [sym_macro_type_specifier] = STATE(294),
    [aux_sym__declaration_specifiers_repeat1] = STATE(296),
    [aux_sym_sized_type_specifier_repeat1] = STATE(297),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(1546),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(639),
    [anon_sym_long] = ACTIONS(639),
    [anon_sym_short] = ACTIONS(639),
    [sym_primitive_type] = ACTIONS(641),
    [anon_sym_enum] = ACTIONS(643),
    [anon_sym_struct] = ACTIONS(645),
    [anon_sym_union] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(1548),
    [sym_char_literal] = ACTIONS(1548),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(1550),
    [sym_false] = ACTIONS(1550),
    [sym_null] = ACTIONS(1550),
    [sym_identifier] = ACTIONS(665),
    [sym_comment] = ACTIONS(42),
  },
  [403] = {
    [sym__expression] = STATE(653),
    [sym_conditional_expression] = STATE(653),
    [sym_assignment_expression] = STATE(653),
    [sym_pointer_expression] = STATE(653),
    [sym_logical_expression] = STATE(653),
    [sym_bitwise_expression] = STATE(653),
    [sym_equality_expression] = STATE(653),
    [sym_relational_expression] = STATE(653),
    [sym_shift_expression] = STATE(653),
    [sym_math_expression] = STATE(653),
    [sym_cast_expression] = STATE(653),
    [sym_sizeof_expression] = STATE(653),
    [sym_subscript_expression] = STATE(653),
    [sym_call_expression] = STATE(653),
    [sym_field_expression] = STATE(653),
    [sym_compound_literal_expression] = STATE(653),
    [sym_parenthesized_expression] = STATE(653),
    [sym_concatenated_string] = STATE(653),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(1552),
    [sym_char_literal] = ACTIONS(1552),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(1554),
    [sym_false] = ACTIONS(1554),
    [sym_null] = ACTIONS(1554),
    [sym_identifier] = ACTIONS(1554),
    [sym_comment] = ACTIONS(42),
  },
  [404] = {
    [anon_sym_LPAREN] = ACTIONS(1556),
    [anon_sym_COMMA] = ACTIONS(1556),
    [anon_sym_RPAREN] = ACTIONS(1556),
    [anon_sym_SEMI] = ACTIONS(1556),
    [anon_sym_LBRACK] = ACTIONS(1556),
    [anon_sym_COLON] = ACTIONS(1556),
    [sym_comment] = ACTIONS(42),
  },
  [405] = {
    [aux_sym_field_declaration_repeat1] = STATE(655),
    [anon_sym_COMMA] = ACTIONS(902),
    [anon_sym_SEMI] = ACTIONS(1512),
    [anon_sym_COLON] = ACTIONS(1558),
    [sym_comment] = ACTIONS(42),
  },
  [406] = {
    [sym_storage_class_specifier] = STATE(406),
    [sym_type_qualifier] = STATE(406),
    [aux_sym__declaration_specifiers_repeat1] = STATE(406),
    [anon_sym_LPAREN] = ACTIONS(681),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_extern] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(681),
    [anon_sym_static] = ACTIONS(683),
    [anon_sym_auto] = ACTIONS(683),
    [anon_sym_register] = ACTIONS(683),
    [anon_sym_inline] = ACTIONS(683),
    [anon_sym_const] = ACTIONS(686),
    [anon_sym_restrict] = ACTIONS(686),
    [anon_sym_volatile] = ACTIONS(686),
    [anon_sym__Atomic] = ACTIONS(686),
    [anon_sym_COLON] = ACTIONS(681),
    [sym_identifier] = ACTIONS(338),
    [sym_comment] = ACTIONS(42),
  },
  [407] = {
    [sym_storage_class_specifier] = STATE(406),
    [sym_type_qualifier] = STATE(406),
    [aux_sym__declaration_specifiers_repeat1] = STATE(406),
    [anon_sym_LPAREN] = ACTIONS(689),
    [anon_sym_SEMI] = ACTIONS(689),
    [anon_sym_extern] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_auto] = ACTIONS(109),
    [anon_sym_register] = ACTIONS(109),
    [anon_sym_inline] = ACTIONS(109),
    [anon_sym_const] = ACTIONS(111),
    [anon_sym_restrict] = ACTIONS(111),
    [anon_sym_volatile] = ACTIONS(111),
    [anon_sym__Atomic] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(689),
    [sym_identifier] = ACTIONS(691),
    [sym_comment] = ACTIONS(42),
  },
  [408] = {
    [sym_parameter_list] = STATE(414),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_RPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(968),
    [sym_comment] = ACTIONS(42),
  },
  [409] = {
    [sym_parameter_list] = STATE(414),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_COMMA] = ACTIONS(1562),
    [anon_sym_RPAREN] = ACTIONS(1562),
    [anon_sym_LBRACK] = ACTIONS(968),
    [sym_comment] = ACTIONS(42),
  },
  [410] = {
    [anon_sym_LPAREN] = ACTIONS(1564),
    [anon_sym_COMMA] = ACTIONS(1564),
    [anon_sym_RPAREN] = ACTIONS(1564),
    [anon_sym_LBRACK] = ACTIONS(1564),
    [sym_comment] = ACTIONS(42),
  },
  [411] = {
    [sym__expression] = STATE(658),
    [sym_conditional_expression] = STATE(658),
    [sym_assignment_expression] = STATE(658),
    [sym_pointer_expression] = STATE(658),
    [sym_logical_expression] = STATE(658),
    [sym_bitwise_expression] = STATE(658),
    [sym_equality_expression] = STATE(658),
    [sym_relational_expression] = STATE(658),
    [sym_shift_expression] = STATE(658),
    [sym_math_expression] = STATE(658),
    [sym_cast_expression] = STATE(658),
    [sym_sizeof_expression] = STATE(658),
    [sym_subscript_expression] = STATE(658),
    [sym_call_expression] = STATE(658),
    [sym_field_expression] = STATE(658),
    [sym_compound_literal_expression] = STATE(658),
    [sym_parenthesized_expression] = STATE(658),
    [sym_concatenated_string] = STATE(658),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(1568),
    [sym_char_literal] = ACTIONS(1568),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(1570),
    [sym_false] = ACTIONS(1570),
    [sym_null] = ACTIONS(1570),
    [sym_identifier] = ACTIONS(1570),
    [sym_comment] = ACTIONS(42),
  },
  [412] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(1566),
    [anon_sym_EQ] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1237),
    [anon_sym_STAR_EQ] = ACTIONS(1239),
    [anon_sym_SLASH_EQ] = ACTIONS(1239),
    [anon_sym_PERCENT_EQ] = ACTIONS(1239),
    [anon_sym_PLUS_EQ] = ACTIONS(1239),
    [anon_sym_DASH_EQ] = ACTIONS(1239),
    [anon_sym_LT_LT_EQ] = ACTIONS(1239),
    [anon_sym_GT_GT_EQ] = ACTIONS(1239),
    [anon_sym_AMP_EQ] = ACTIONS(1239),
    [anon_sym_CARET_EQ] = ACTIONS(1239),
    [anon_sym_PIPE_EQ] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_PIPE_PIPE] = ACTIONS(1243),
    [anon_sym_AMP_AMP] = ACTIONS(1245),
    [anon_sym_PIPE] = ACTIONS(1247),
    [anon_sym_CARET] = ACTIONS(1249),
    [anon_sym_EQ_EQ] = ACTIONS(1251),
    [anon_sym_BANG_EQ] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1253),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [413] = {
    [sym__declaration_specifiers] = STATE(659),
    [sym_storage_class_specifier] = STATE(296),
    [sym_type_qualifier] = STATE(296),
    [sym__type_specifier] = STATE(294),
    [sym_sized_type_specifier] = STATE(294),
    [sym_enum_specifier] = STATE(294),
    [sym_struct_specifier] = STATE(294),
    [sym_union_specifier] = STATE(294),
    [sym__expression] = STATE(658),
    [sym_conditional_expression] = STATE(658),
    [sym_assignment_expression] = STATE(658),
    [sym_pointer_expression] = STATE(658),
    [sym_logical_expression] = STATE(658),
    [sym_bitwise_expression] = STATE(658),
    [sym_equality_expression] = STATE(658),
    [sym_relational_expression] = STATE(658),
    [sym_shift_expression] = STATE(658),
    [sym_math_expression] = STATE(658),
    [sym_cast_expression] = STATE(658),
    [sym_sizeof_expression] = STATE(658),
    [sym_subscript_expression] = STATE(658),
    [sym_call_expression] = STATE(658),
    [sym_field_expression] = STATE(658),
    [sym_compound_literal_expression] = STATE(658),
    [sym_parenthesized_expression] = STATE(658),
    [sym_concatenated_string] = STATE(658),
    [sym_macro_type_specifier] = STATE(294),
    [aux_sym__declaration_specifiers_repeat1] = STATE(296),
    [aux_sym_sized_type_specifier_repeat1] = STATE(297),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(1566),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(639),
    [anon_sym_long] = ACTIONS(639),
    [anon_sym_short] = ACTIONS(639),
    [sym_primitive_type] = ACTIONS(641),
    [anon_sym_enum] = ACTIONS(643),
    [anon_sym_struct] = ACTIONS(645),
    [anon_sym_union] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(1568),
    [sym_char_literal] = ACTIONS(1568),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(1570),
    [sym_false] = ACTIONS(1570),
    [sym_null] = ACTIONS(1570),
    [sym_identifier] = ACTIONS(665),
    [sym_comment] = ACTIONS(42),
  },
  [414] = {
    [anon_sym_LPAREN] = ACTIONS(1572),
    [anon_sym_COMMA] = ACTIONS(1572),
    [anon_sym_RPAREN] = ACTIONS(1572),
    [anon_sym_LBRACK] = ACTIONS(1572),
    [sym_comment] = ACTIONS(42),
  },
  [415] = {
    [sym_parameter_list] = STATE(414),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_RPAREN] = ACTIONS(1574),
    [anon_sym_LBRACK] = ACTIONS(968),
    [sym_comment] = ACTIONS(42),
  },
  [416] = {
    [sym__declaration_specifiers] = STATE(239),
    [sym_storage_class_specifier] = STATE(241),
    [sym_type_qualifier] = STATE(241),
    [sym__type_specifier] = STATE(240),
    [sym_sized_type_specifier] = STATE(240),
    [sym_enum_specifier] = STATE(240),
    [sym_struct_specifier] = STATE(240),
    [sym_union_specifier] = STATE(240),
    [sym_parameter_declaration] = STATE(660),
    [sym_macro_type_specifier] = STATE(240),
    [aux_sym__declaration_specifiers_repeat1] = STATE(241),
    [aux_sym_sized_type_specifier_repeat1] = STATE(242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1576),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(557),
    [anon_sym_long] = ACTIONS(557),
    [anon_sym_short] = ACTIONS(557),
    [sym_primitive_type] = ACTIONS(559),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [417] = {
    [anon_sym_LPAREN] = ACTIONS(1578),
    [anon_sym_COMMA] = ACTIONS(1578),
    [anon_sym_RPAREN] = ACTIONS(1578),
    [anon_sym_SEMI] = ACTIONS(1578),
    [anon_sym_LBRACE] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_EQ] = ACTIONS(1578),
    [anon_sym_COLON] = ACTIONS(1578),
    [sym_comment] = ACTIONS(42),
  },
  [418] = {
    [aux_sym_parameter_list_repeat1] = STATE(662),
    [anon_sym_COMMA] = ACTIONS(981),
    [anon_sym_RPAREN] = ACTIONS(1580),
    [sym_comment] = ACTIONS(42),
  },
  [419] = {
    [sym__declaration_specifiers] = STATE(239),
    [sym__declarator] = STATE(136),
    [sym__abstract_declarator] = STATE(408),
    [sym_pointer_declarator] = STATE(136),
    [sym_abstract_pointer_declarator] = STATE(408),
    [sym_function_declarator] = STATE(136),
    [sym_abstract_function_declarator] = STATE(408),
    [sym_array_declarator] = STATE(136),
    [sym_abstract_array_declarator] = STATE(408),
    [sym_storage_class_specifier] = STATE(241),
    [sym_type_qualifier] = STATE(241),
    [sym__type_specifier] = STATE(240),
    [sym_sized_type_specifier] = STATE(240),
    [sym_enum_specifier] = STATE(240),
    [sym_struct_specifier] = STATE(240),
    [sym_union_specifier] = STATE(240),
    [sym_parameter_list] = STATE(232),
    [sym_parameter_declaration] = STATE(237),
    [sym_macro_type_specifier] = STATE(240),
    [aux_sym__declaration_specifiers_repeat1] = STATE(241),
    [aux_sym_sized_type_specifier_repeat1] = STATE(242),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(553),
    [anon_sym_RPAREN] = ACTIONS(555),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_STAR] = ACTIONS(1582),
    [anon_sym_LBRACK] = ACTIONS(539),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(557),
    [anon_sym_long] = ACTIONS(557),
    [anon_sym_short] = ACTIONS(557),
    [sym_primitive_type] = ACTIONS(559),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(1584),
    [sym_comment] = ACTIONS(42),
  },
  [420] = {
    [sym__declarator] = STATE(137),
    [sym__abstract_declarator] = STATE(409),
    [sym_pointer_declarator] = STATE(137),
    [sym_abstract_pointer_declarator] = STATE(409),
    [sym_function_declarator] = STATE(137),
    [sym_abstract_function_declarator] = STATE(409),
    [sym_array_declarator] = STATE(137),
    [sym_abstract_array_declarator] = STATE(409),
    [sym_parameter_list] = STATE(232),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_COMMA] = ACTIONS(958),
    [anon_sym_RPAREN] = ACTIONS(958),
    [anon_sym_STAR] = ACTIONS(991),
    [anon_sym_LBRACK] = ACTIONS(539),
    [sym_identifier] = ACTIONS(260),
    [sym_comment] = ACTIONS(42),
  },
  [421] = {
    [sym_parameter_list] = STATE(145),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_COMMA] = ACTIONS(1586),
    [anon_sym_RPAREN] = ACTIONS(1586),
    [anon_sym_LBRACK] = ACTIONS(270),
    [sym_comment] = ACTIONS(42),
  },
  [422] = {
    [sym_parameter_list] = STATE(414),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_COMMA] = ACTIONS(1586),
    [anon_sym_RPAREN] = ACTIONS(1586),
    [anon_sym_LBRACK] = ACTIONS(968),
    [sym_comment] = ACTIONS(42),
  },
  [423] = {
    [sym_storage_class_specifier] = STATE(665),
    [sym_type_qualifier] = STATE(665),
    [aux_sym__declaration_specifiers_repeat1] = STATE(665),
    [anon_sym_LPAREN] = ACTIONS(278),
    [anon_sym_COMMA] = ACTIONS(278),
    [anon_sym_RPAREN] = ACTIONS(278),
    [anon_sym_extern] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_LBRACK] = ACTIONS(278),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_auto] = ACTIONS(109),
    [anon_sym_register] = ACTIONS(109),
    [anon_sym_inline] = ACTIONS(109),
    [anon_sym_const] = ACTIONS(111),
    [anon_sym_restrict] = ACTIONS(111),
    [anon_sym_volatile] = ACTIONS(111),
    [anon_sym__Atomic] = ACTIONS(111),
    [sym_identifier] = ACTIONS(280),
    [sym_comment] = ACTIONS(42),
  },
  [424] = {
    [sym_storage_class_specifier] = STATE(666),
    [sym_type_qualifier] = STATE(666),
    [aux_sym__declaration_specifiers_repeat1] = STATE(666),
    [anon_sym_LPAREN] = ACTIONS(278),
    [anon_sym_COMMA] = ACTIONS(278),
    [anon_sym_RPAREN] = ACTIONS(278),
    [anon_sym_extern] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_LBRACK] = ACTIONS(278),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_auto] = ACTIONS(109),
    [anon_sym_register] = ACTIONS(109),
    [anon_sym_inline] = ACTIONS(109),
    [anon_sym_const] = ACTIONS(111),
    [anon_sym_restrict] = ACTIONS(111),
    [anon_sym_volatile] = ACTIONS(111),
    [anon_sym__Atomic] = ACTIONS(111),
    [sym_identifier] = ACTIONS(280),
    [sym_comment] = ACTIONS(42),
  },
  [425] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(425),
    [anon_sym_LPAREN] = ACTIONS(348),
    [anon_sym_COMMA] = ACTIONS(348),
    [anon_sym_RPAREN] = ACTIONS(348),
    [anon_sym_extern] = ACTIONS(350),
    [anon_sym_STAR] = ACTIONS(348),
    [anon_sym_LBRACK] = ACTIONS(348),
    [anon_sym_static] = ACTIONS(350),
    [anon_sym_auto] = ACTIONS(350),
    [anon_sym_register] = ACTIONS(350),
    [anon_sym_inline] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(350),
    [anon_sym_restrict] = ACTIONS(350),
    [anon_sym_volatile] = ACTIONS(350),
    [anon_sym__Atomic] = ACTIONS(350),
    [anon_sym_unsigned] = ACTIONS(1588),
    [anon_sym_long] = ACTIONS(1588),
    [anon_sym_short] = ACTIONS(1588),
    [sym_primitive_type] = ACTIONS(350),
    [sym_identifier] = ACTIONS(350),
    [sym_comment] = ACTIONS(42),
  },
  [426] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(132),
    [anon_sym_LPAREN] = ACTIONS(130),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(132),
    [sym_preproc_directive] = ACTIONS(132),
    [anon_sym_SEMI] = ACTIONS(130),
    [anon_sym_typedef] = ACTIONS(132),
    [anon_sym_extern] = ACTIONS(132),
    [anon_sym_LBRACE] = ACTIONS(130),
    [anon_sym_RBRACE] = ACTIONS(130),
    [anon_sym_STAR] = ACTIONS(130),
    [anon_sym_static] = ACTIONS(132),
    [anon_sym_auto] = ACTIONS(132),
    [anon_sym_register] = ACTIONS(132),
    [anon_sym_inline] = ACTIONS(132),
    [anon_sym_const] = ACTIONS(132),
    [anon_sym_restrict] = ACTIONS(132),
    [anon_sym_volatile] = ACTIONS(132),
    [anon_sym__Atomic] = ACTIONS(132),
    [anon_sym_unsigned] = ACTIONS(132),
    [anon_sym_long] = ACTIONS(132),
    [anon_sym_short] = ACTIONS(132),
    [sym_primitive_type] = ACTIONS(132),
    [anon_sym_enum] = ACTIONS(132),
    [anon_sym_struct] = ACTIONS(132),
    [anon_sym_union] = ACTIONS(132),
    [anon_sym_if] = ACTIONS(132),
    [anon_sym_switch] = ACTIONS(132),
    [anon_sym_case] = ACTIONS(132),
    [anon_sym_default] = ACTIONS(132),
    [anon_sym_while] = ACTIONS(132),
    [anon_sym_do] = ACTIONS(132),
    [anon_sym_for] = ACTIONS(132),
    [anon_sym_return] = ACTIONS(132),
    [anon_sym_break] = ACTIONS(132),
    [anon_sym_continue] = ACTIONS(132),
    [anon_sym_goto] = ACTIONS(132),
    [anon_sym_AMP] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(130),
    [anon_sym_TILDE] = ACTIONS(130),
    [anon_sym_PLUS] = ACTIONS(132),
    [anon_sym_DASH] = ACTIONS(132),
    [anon_sym_DASH_DASH] = ACTIONS(130),
    [anon_sym_PLUS_PLUS] = ACTIONS(130),
    [anon_sym_sizeof] = ACTIONS(132),
    [sym_number_literal] = ACTIONS(130),
    [sym_char_literal] = ACTIONS(130),
    [sym_string_literal] = ACTIONS(130),
    [sym_true] = ACTIONS(132),
    [sym_false] = ACTIONS(132),
    [sym_null] = ACTIONS(132),
    [sym_identifier] = ACTIONS(132),
    [sym_comment] = ACTIONS(42),
  },
  [427] = {
    [sym_preproc_params] = STATE(669),
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(1591),
    [anon_sym_LF] = ACTIONS(1593),
    [anon_sym_LPAREN] = ACTIONS(138),
    [sym_comment] = ACTIONS(50),
  },
  [428] = {
    [sym_type_qualifier] = STATE(133),
    [sym__type_specifier] = STATE(131),
    [sym_sized_type_specifier] = STATE(131),
    [sym_enum_specifier] = STATE(131),
    [sym_struct_specifier] = STATE(131),
    [sym_union_specifier] = STATE(131),
    [sym__expression] = STATE(436),
    [sym_comma_expression] = STATE(437),
    [sym_conditional_expression] = STATE(436),
    [sym_assignment_expression] = STATE(436),
    [sym_pointer_expression] = STATE(436),
    [sym_logical_expression] = STATE(436),
    [sym_bitwise_expression] = STATE(436),
    [sym_equality_expression] = STATE(436),
    [sym_relational_expression] = STATE(436),
    [sym_shift_expression] = STATE(436),
    [sym_math_expression] = STATE(436),
    [sym_cast_expression] = STATE(436),
    [sym_type_descriptor] = STATE(670),
    [sym_sizeof_expression] = STATE(436),
    [sym_subscript_expression] = STATE(436),
    [sym_call_expression] = STATE(436),
    [sym_field_expression] = STATE(436),
    [sym_compound_literal_expression] = STATE(436),
    [sym_parenthesized_expression] = STATE(436),
    [sym_concatenated_string] = STATE(436),
    [sym_macro_type_specifier] = STATE(131),
    [aux_sym_type_definition_repeat1] = STATE(133),
    [aux_sym_sized_type_specifier_repeat1] = STATE(134),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(248),
    [anon_sym_long] = ACTIONS(248),
    [anon_sym_short] = ACTIONS(248),
    [sym_primitive_type] = ACTIONS(250),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1019),
    [sym_char_literal] = ACTIONS(1019),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(1023),
    [sym_false] = ACTIONS(1023),
    [sym_null] = ACTIONS(1023),
    [sym_identifier] = ACTIONS(1025),
    [sym_comment] = ACTIONS(42),
  },
  [429] = {
    [sym__expression] = STATE(448),
    [sym_conditional_expression] = STATE(448),
    [sym_assignment_expression] = STATE(448),
    [sym_pointer_expression] = STATE(448),
    [sym_logical_expression] = STATE(448),
    [sym_bitwise_expression] = STATE(448),
    [sym_equality_expression] = STATE(448),
    [sym_relational_expression] = STATE(448),
    [sym_shift_expression] = STATE(448),
    [sym_math_expression] = STATE(448),
    [sym_cast_expression] = STATE(448),
    [sym_sizeof_expression] = STATE(448),
    [sym_subscript_expression] = STATE(448),
    [sym_call_expression] = STATE(448),
    [sym_field_expression] = STATE(448),
    [sym_compound_literal_expression] = STATE(448),
    [sym_parenthesized_expression] = STATE(448),
    [sym_concatenated_string] = STATE(448),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1049),
    [sym_char_literal] = ACTIONS(1049),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(1051),
    [sym_false] = ACTIONS(1051),
    [sym_null] = ACTIONS(1051),
    [sym_identifier] = ACTIONS(1051),
    [sym_comment] = ACTIONS(42),
  },
  [430] = {
    [sym__expression] = STATE(475),
    [sym_conditional_expression] = STATE(475),
    [sym_assignment_expression] = STATE(475),
    [sym_pointer_expression] = STATE(475),
    [sym_logical_expression] = STATE(475),
    [sym_bitwise_expression] = STATE(475),
    [sym_equality_expression] = STATE(475),
    [sym_relational_expression] = STATE(475),
    [sym_shift_expression] = STATE(475),
    [sym_math_expression] = STATE(475),
    [sym_cast_expression] = STATE(475),
    [sym_sizeof_expression] = STATE(475),
    [sym_subscript_expression] = STATE(475),
    [sym_call_expression] = STATE(475),
    [sym_field_expression] = STATE(475),
    [sym_compound_literal_expression] = STATE(475),
    [sym_parenthesized_expression] = STATE(475),
    [sym_concatenated_string] = STATE(475),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1109),
    [sym_char_literal] = ACTIONS(1109),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(1111),
    [sym_false] = ACTIONS(1111),
    [sym_null] = ACTIONS(1111),
    [sym_identifier] = ACTIONS(1111),
    [sym_comment] = ACTIONS(42),
  },
  [431] = {
    [sym__expression] = STATE(476),
    [sym_conditional_expression] = STATE(476),
    [sym_assignment_expression] = STATE(476),
    [sym_pointer_expression] = STATE(476),
    [sym_logical_expression] = STATE(476),
    [sym_bitwise_expression] = STATE(476),
    [sym_equality_expression] = STATE(476),
    [sym_relational_expression] = STATE(476),
    [sym_shift_expression] = STATE(476),
    [sym_math_expression] = STATE(476),
    [sym_cast_expression] = STATE(476),
    [sym_sizeof_expression] = STATE(476),
    [sym_subscript_expression] = STATE(476),
    [sym_call_expression] = STATE(476),
    [sym_field_expression] = STATE(476),
    [sym_compound_literal_expression] = STATE(476),
    [sym_parenthesized_expression] = STATE(476),
    [sym_concatenated_string] = STATE(476),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1113),
    [sym_char_literal] = ACTIONS(1113),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(1115),
    [sym_false] = ACTIONS(1115),
    [sym_null] = ACTIONS(1115),
    [sym_identifier] = ACTIONS(1115),
    [sym_comment] = ACTIONS(42),
  },
  [432] = {
    [sym__expression] = STATE(477),
    [sym_conditional_expression] = STATE(477),
    [sym_assignment_expression] = STATE(477),
    [sym_pointer_expression] = STATE(477),
    [sym_logical_expression] = STATE(477),
    [sym_bitwise_expression] = STATE(477),
    [sym_equality_expression] = STATE(477),
    [sym_relational_expression] = STATE(477),
    [sym_shift_expression] = STATE(477),
    [sym_math_expression] = STATE(477),
    [sym_cast_expression] = STATE(477),
    [sym_sizeof_expression] = STATE(477),
    [sym_subscript_expression] = STATE(477),
    [sym_call_expression] = STATE(477),
    [sym_field_expression] = STATE(477),
    [sym_compound_literal_expression] = STATE(477),
    [sym_parenthesized_expression] = STATE(477),
    [sym_concatenated_string] = STATE(477),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1117),
    [sym_char_literal] = ACTIONS(1117),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(1119),
    [sym_false] = ACTIONS(1119),
    [sym_null] = ACTIONS(1119),
    [sym_identifier] = ACTIONS(1119),
    [sym_comment] = ACTIONS(42),
  },
  [433] = {
    [sym__expression] = STATE(672),
    [sym_conditional_expression] = STATE(672),
    [sym_assignment_expression] = STATE(672),
    [sym_pointer_expression] = STATE(672),
    [sym_logical_expression] = STATE(672),
    [sym_bitwise_expression] = STATE(672),
    [sym_equality_expression] = STATE(672),
    [sym_relational_expression] = STATE(672),
    [sym_shift_expression] = STATE(672),
    [sym_math_expression] = STATE(672),
    [sym_cast_expression] = STATE(672),
    [sym_sizeof_expression] = STATE(672),
    [sym_subscript_expression] = STATE(672),
    [sym_call_expression] = STATE(672),
    [sym_field_expression] = STATE(672),
    [sym_compound_literal_expression] = STATE(672),
    [sym_parenthesized_expression] = STATE(672),
    [sym_concatenated_string] = STATE(672),
    [anon_sym_LPAREN] = ACTIONS(1595),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1597),
    [sym_char_literal] = ACTIONS(1597),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_null] = ACTIONS(1599),
    [sym_identifier] = ACTIONS(1599),
    [sym_comment] = ACTIONS(42),
  },
  [434] = {
    [aux_sym_concatenated_string_repeat1] = STATE(673),
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_RPAREN] = ACTIONS(1127),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_string_literal] = ACTIONS(1601),
    [sym_comment] = ACTIONS(42),
  },
  [435] = {
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_RPAREN] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_comment] = ACTIONS(42),
  },
  [436] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1603),
    [anon_sym_RPAREN] = ACTIONS(1605),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [437] = {
    [anon_sym_RPAREN] = ACTIONS(1605),
    [sym_comment] = ACTIONS(42),
  },
  [438] = {
    [anon_sym_RPAREN] = ACTIONS(1635),
    [sym_comment] = ACTIONS(42),
  },
  [439] = {
    [sym_preproc_include] = STATE(720),
    [sym_preproc_def] = STATE(720),
    [sym_preproc_function_def] = STATE(720),
    [sym_preproc_call] = STATE(720),
    [sym_preproc_if_in_compound_statement] = STATE(713),
    [sym_preproc_ifdef_in_compound_statement] = STATE(714),
    [sym_preproc_else_in_compound_statement] = STATE(715),
    [sym_preproc_elif_in_compound_statement] = STATE(716),
    [sym_declaration] = STATE(720),
    [sym_type_definition] = STATE(720),
    [sym__declaration_specifiers] = STATE(717),
    [sym_compound_statement] = STATE(720),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(720),
    [sym_expression_statement] = STATE(720),
    [sym_if_statement] = STATE(720),
    [sym_switch_statement] = STATE(720),
    [sym_case_statement] = STATE(720),
    [sym_while_statement] = STATE(720),
    [sym_do_statement] = STATE(720),
    [sym_for_statement] = STATE(720),
    [sym_return_statement] = STATE(720),
    [sym_break_statement] = STATE(720),
    [sym_continue_statement] = STATE(720),
    [sym_goto_statement] = STATE(720),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym__empty_declaration] = STATE(720),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(720),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1639),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1643),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1645),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1647),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1651),
    [sym_preproc_directive] = ACTIONS(1653),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_typedef] = ACTIONS(1657),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(42),
  },
  [440] = {
    [sym_preproc_include] = STATE(724),
    [sym_preproc_def] = STATE(724),
    [sym_preproc_function_def] = STATE(724),
    [sym_preproc_call] = STATE(724),
    [sym_preproc_if_in_compound_statement] = STATE(713),
    [sym_preproc_ifdef_in_compound_statement] = STATE(714),
    [sym_preproc_else_in_compound_statement] = STATE(722),
    [sym_preproc_elif_in_compound_statement] = STATE(723),
    [sym_declaration] = STATE(724),
    [sym_type_definition] = STATE(724),
    [sym__declaration_specifiers] = STATE(717),
    [sym_compound_statement] = STATE(724),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(724),
    [sym_expression_statement] = STATE(724),
    [sym_if_statement] = STATE(724),
    [sym_switch_statement] = STATE(724),
    [sym_case_statement] = STATE(724),
    [sym_while_statement] = STATE(724),
    [sym_do_statement] = STATE(724),
    [sym_for_statement] = STATE(724),
    [sym_return_statement] = STATE(724),
    [sym_break_statement] = STATE(724),
    [sym_continue_statement] = STATE(724),
    [sym_goto_statement] = STATE(724),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym__empty_declaration] = STATE(724),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(724),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1639),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1689),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1645),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1647),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1651),
    [sym_preproc_directive] = ACTIONS(1653),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_typedef] = ACTIONS(1657),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(42),
  },
  [441] = {
    [sym_preproc_include] = STATE(728),
    [sym_preproc_def] = STATE(728),
    [sym_preproc_function_def] = STATE(728),
    [sym_preproc_call] = STATE(728),
    [sym_preproc_if_in_compound_statement] = STATE(713),
    [sym_preproc_ifdef_in_compound_statement] = STATE(714),
    [sym_preproc_else_in_compound_statement] = STATE(726),
    [sym_preproc_elif_in_compound_statement] = STATE(727),
    [sym_declaration] = STATE(728),
    [sym_type_definition] = STATE(728),
    [sym__declaration_specifiers] = STATE(717),
    [sym_compound_statement] = STATE(728),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(728),
    [sym_expression_statement] = STATE(728),
    [sym_if_statement] = STATE(728),
    [sym_switch_statement] = STATE(728),
    [sym_case_statement] = STATE(728),
    [sym_while_statement] = STATE(728),
    [sym_do_statement] = STATE(728),
    [sym_for_statement] = STATE(728),
    [sym_return_statement] = STATE(728),
    [sym_break_statement] = STATE(728),
    [sym_continue_statement] = STATE(728),
    [sym_goto_statement] = STATE(728),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym__empty_declaration] = STATE(728),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(728),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1639),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1691),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1645),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1647),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1651),
    [sym_preproc_directive] = ACTIONS(1653),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_typedef] = ACTIONS(1657),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(42),
  },
  [442] = {
    [sym_preproc_arg] = ACTIONS(1693),
    [sym_comment] = ACTIONS(50),
  },
  [443] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(170),
    [anon_sym_LPAREN] = ACTIONS(168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(170),
    [sym_preproc_directive] = ACTIONS(170),
    [anon_sym_SEMI] = ACTIONS(168),
    [anon_sym_typedef] = ACTIONS(170),
    [anon_sym_extern] = ACTIONS(170),
    [anon_sym_LBRACE] = ACTIONS(168),
    [anon_sym_RBRACE] = ACTIONS(168),
    [anon_sym_STAR] = ACTIONS(168),
    [anon_sym_static] = ACTIONS(170),
    [anon_sym_auto] = ACTIONS(170),
    [anon_sym_register] = ACTIONS(170),
    [anon_sym_inline] = ACTIONS(170),
    [anon_sym_const] = ACTIONS(170),
    [anon_sym_restrict] = ACTIONS(170),
    [anon_sym_volatile] = ACTIONS(170),
    [anon_sym__Atomic] = ACTIONS(170),
    [anon_sym_unsigned] = ACTIONS(170),
    [anon_sym_long] = ACTIONS(170),
    [anon_sym_short] = ACTIONS(170),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(170),
    [anon_sym_struct] = ACTIONS(170),
    [anon_sym_union] = ACTIONS(170),
    [anon_sym_if] = ACTIONS(170),
    [anon_sym_switch] = ACTIONS(170),
    [anon_sym_case] = ACTIONS(170),
    [anon_sym_default] = ACTIONS(170),
    [anon_sym_while] = ACTIONS(170),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(170),
    [anon_sym_break] = ACTIONS(170),
    [anon_sym_continue] = ACTIONS(170),
    [anon_sym_goto] = ACTIONS(170),
    [anon_sym_AMP] = ACTIONS(168),
    [anon_sym_BANG] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(168),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_DASH_DASH] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(168),
    [anon_sym_sizeof] = ACTIONS(170),
    [sym_number_literal] = ACTIONS(168),
    [sym_char_literal] = ACTIONS(168),
    [sym_string_literal] = ACTIONS(168),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_null] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_comment] = ACTIONS(42),
  },
  [444] = {
    [sym__type_declarator] = STATE(730),
    [sym_pointer_type_declarator] = STATE(99),
    [sym_function_type_declarator] = STATE(100),
    [sym_array_type_declarator] = STATE(101),
    [anon_sym_LPAREN] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(187),
    [sym_identifier] = ACTIONS(189),
    [sym_comment] = ACTIONS(42),
  },
  [445] = {
    [sym_type_qualifier] = STATE(103),
    [sym__type_specifier] = STATE(731),
    [sym_sized_type_specifier] = STATE(731),
    [sym_enum_specifier] = STATE(731),
    [sym_struct_specifier] = STATE(731),
    [sym_union_specifier] = STATE(731),
    [sym_macro_type_specifier] = STATE(731),
    [aux_sym_type_definition_repeat1] = STATE(103),
    [aux_sym_sized_type_specifier_repeat1] = STATE(36),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(62),
    [anon_sym_long] = ACTIONS(62),
    [anon_sym_short] = ACTIONS(62),
    [sym_primitive_type] = ACTIONS(1695),
    [anon_sym_enum] = ACTIONS(66),
    [anon_sym_struct] = ACTIONS(68),
    [anon_sym_union] = ACTIONS(70),
    [sym_identifier] = ACTIONS(72),
    [sym_comment] = ACTIONS(42),
  },
  [446] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1045),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1047),
    [sym_preproc_directive] = ACTIONS(1047),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_typedef] = ACTIONS(1047),
    [anon_sym_extern] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_auto] = ACTIONS(1047),
    [anon_sym_register] = ACTIONS(1047),
    [anon_sym_inline] = ACTIONS(1047),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_restrict] = ACTIONS(1047),
    [anon_sym_volatile] = ACTIONS(1047),
    [anon_sym__Atomic] = ACTIONS(1047),
    [anon_sym_unsigned] = ACTIONS(1047),
    [anon_sym_long] = ACTIONS(1047),
    [anon_sym_short] = ACTIONS(1047),
    [sym_primitive_type] = ACTIONS(1047),
    [anon_sym_enum] = ACTIONS(1047),
    [anon_sym_struct] = ACTIONS(1047),
    [anon_sym_union] = ACTIONS(1047),
    [anon_sym_if] = ACTIONS(1047),
    [anon_sym_switch] = ACTIONS(1047),
    [anon_sym_case] = ACTIONS(1047),
    [anon_sym_default] = ACTIONS(1047),
    [anon_sym_while] = ACTIONS(1047),
    [anon_sym_do] = ACTIONS(1047),
    [anon_sym_for] = ACTIONS(1047),
    [anon_sym_return] = ACTIONS(1047),
    [anon_sym_break] = ACTIONS(1047),
    [anon_sym_continue] = ACTIONS(1047),
    [anon_sym_goto] = ACTIONS(1047),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_PLUS] = ACTIONS(1047),
    [anon_sym_DASH] = ACTIONS(1047),
    [anon_sym_DASH_DASH] = ACTIONS(1045),
    [anon_sym_PLUS_PLUS] = ACTIONS(1045),
    [anon_sym_sizeof] = ACTIONS(1047),
    [sym_number_literal] = ACTIONS(1045),
    [sym_char_literal] = ACTIONS(1045),
    [sym_string_literal] = ACTIONS(1045),
    [sym_true] = ACTIONS(1047),
    [sym_false] = ACTIONS(1047),
    [sym_null] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [sym_comment] = ACTIONS(42),
  },
  [447] = {
    [sym_preproc_include] = STATE(505),
    [sym_preproc_def] = STATE(505),
    [sym_preproc_function_def] = STATE(505),
    [sym_preproc_call] = STATE(505),
    [sym_preproc_if_in_compound_statement] = STATE(275),
    [sym_preproc_ifdef_in_compound_statement] = STATE(276),
    [sym_declaration] = STATE(505),
    [sym_type_definition] = STATE(505),
    [sym__declaration_specifiers] = STATE(277),
    [sym_compound_statement] = STATE(505),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(505),
    [sym_expression_statement] = STATE(505),
    [sym_if_statement] = STATE(505),
    [sym_switch_statement] = STATE(505),
    [sym_case_statement] = STATE(505),
    [sym_while_statement] = STATE(505),
    [sym_do_statement] = STATE(505),
    [sym_for_statement] = STATE(505),
    [sym_return_statement] = STATE(505),
    [sym_break_statement] = STATE(505),
    [sym_continue_statement] = STATE(505),
    [sym_goto_statement] = STATE(505),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [sym__empty_declaration] = STATE(505),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(505),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(577),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(579),
    [sym_preproc_directive] = ACTIONS(581),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_typedef] = ACTIONS(585),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_RBRACE] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(631),
    [sym_comment] = ACTIONS(42),
  },
  [448] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1699),
    [anon_sym_RPAREN] = ACTIONS(1699),
    [anon_sym_SEMI] = ACTIONS(1699),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(1699),
    [anon_sym_EQ] = ACTIONS(1701),
    [anon_sym_COLON] = ACTIONS(1699),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_STAR_EQ] = ACTIONS(1699),
    [anon_sym_SLASH_EQ] = ACTIONS(1699),
    [anon_sym_PERCENT_EQ] = ACTIONS(1699),
    [anon_sym_PLUS_EQ] = ACTIONS(1699),
    [anon_sym_DASH_EQ] = ACTIONS(1699),
    [anon_sym_LT_LT_EQ] = ACTIONS(1699),
    [anon_sym_GT_GT_EQ] = ACTIONS(1699),
    [anon_sym_AMP_EQ] = ACTIONS(1699),
    [anon_sym_CARET_EQ] = ACTIONS(1699),
    [anon_sym_PIPE_EQ] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1701),
    [anon_sym_PIPE_PIPE] = ACTIONS(1699),
    [anon_sym_AMP_AMP] = ACTIONS(1699),
    [anon_sym_PIPE] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1701),
    [anon_sym_EQ_EQ] = ACTIONS(1699),
    [anon_sym_BANG_EQ] = ACTIONS(1699),
    [anon_sym_LT] = ACTIONS(1701),
    [anon_sym_GT] = ACTIONS(1701),
    [anon_sym_LT_EQ] = ACTIONS(1699),
    [anon_sym_GT_EQ] = ACTIONS(1699),
    [anon_sym_LT_LT] = ACTIONS(1701),
    [anon_sym_GT_GT] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1701),
    [anon_sym_DASH] = ACTIONS(1701),
    [anon_sym_SLASH] = ACTIONS(1701),
    [anon_sym_PERCENT] = ACTIONS(1701),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [449] = {
    [sym__expression] = STATE(740),
    [sym_conditional_expression] = STATE(740),
    [sym_assignment_expression] = STATE(740),
    [sym_pointer_expression] = STATE(740),
    [sym_logical_expression] = STATE(740),
    [sym_bitwise_expression] = STATE(740),
    [sym_equality_expression] = STATE(740),
    [sym_relational_expression] = STATE(740),
    [sym_shift_expression] = STATE(740),
    [sym_math_expression] = STATE(740),
    [sym_cast_expression] = STATE(740),
    [sym_sizeof_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_field_expression] = STATE(740),
    [sym_compound_literal_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_concatenated_string] = STATE(740),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(1717),
    [sym_char_literal] = ACTIONS(1717),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(1721),
    [sym_false] = ACTIONS(1721),
    [sym_null] = ACTIONS(1721),
    [sym_identifier] = ACTIONS(1721),
    [sym_comment] = ACTIONS(42),
  },
  [450] = {
    [sym__expression] = STATE(741),
    [sym_conditional_expression] = STATE(741),
    [sym_assignment_expression] = STATE(741),
    [sym_pointer_expression] = STATE(741),
    [sym_logical_expression] = STATE(741),
    [sym_bitwise_expression] = STATE(741),
    [sym_equality_expression] = STATE(741),
    [sym_relational_expression] = STATE(741),
    [sym_shift_expression] = STATE(741),
    [sym_math_expression] = STATE(741),
    [sym_cast_expression] = STATE(741),
    [sym_sizeof_expression] = STATE(741),
    [sym_subscript_expression] = STATE(741),
    [sym_call_expression] = STATE(741),
    [sym_field_expression] = STATE(741),
    [sym_compound_literal_expression] = STATE(741),
    [sym_parenthesized_expression] = STATE(741),
    [sym_concatenated_string] = STATE(741),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(1723),
    [sym_char_literal] = ACTIONS(1723),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(1725),
    [sym_false] = ACTIONS(1725),
    [sym_null] = ACTIONS(1725),
    [sym_identifier] = ACTIONS(1725),
    [sym_comment] = ACTIONS(42),
  },
  [451] = {
    [sym_type_qualifier] = STATE(133),
    [sym__type_specifier] = STATE(131),
    [sym_sized_type_specifier] = STATE(131),
    [sym_enum_specifier] = STATE(131),
    [sym_struct_specifier] = STATE(131),
    [sym_union_specifier] = STATE(131),
    [sym__expression] = STATE(436),
    [sym_comma_expression] = STATE(437),
    [sym_conditional_expression] = STATE(436),
    [sym_assignment_expression] = STATE(436),
    [sym_pointer_expression] = STATE(436),
    [sym_logical_expression] = STATE(436),
    [sym_bitwise_expression] = STATE(436),
    [sym_equality_expression] = STATE(436),
    [sym_relational_expression] = STATE(436),
    [sym_shift_expression] = STATE(436),
    [sym_math_expression] = STATE(436),
    [sym_cast_expression] = STATE(436),
    [sym_type_descriptor] = STATE(742),
    [sym_sizeof_expression] = STATE(436),
    [sym_subscript_expression] = STATE(436),
    [sym_call_expression] = STATE(436),
    [sym_field_expression] = STATE(436),
    [sym_compound_literal_expression] = STATE(436),
    [sym_parenthesized_expression] = STATE(436),
    [sym_concatenated_string] = STATE(436),
    [sym_macro_type_specifier] = STATE(131),
    [aux_sym_type_definition_repeat1] = STATE(133),
    [aux_sym_sized_type_specifier_repeat1] = STATE(134),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(248),
    [anon_sym_long] = ACTIONS(248),
    [anon_sym_short] = ACTIONS(248),
    [sym_primitive_type] = ACTIONS(250),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1019),
    [sym_char_literal] = ACTIONS(1019),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(1023),
    [sym_false] = ACTIONS(1023),
    [sym_null] = ACTIONS(1023),
    [sym_identifier] = ACTIONS(1025),
    [sym_comment] = ACTIONS(42),
  },
  [452] = {
    [sym__expression] = STATE(448),
    [sym_conditional_expression] = STATE(448),
    [sym_assignment_expression] = STATE(448),
    [sym_pointer_expression] = STATE(448),
    [sym_logical_expression] = STATE(448),
    [sym_bitwise_expression] = STATE(448),
    [sym_equality_expression] = STATE(448),
    [sym_relational_expression] = STATE(448),
    [sym_shift_expression] = STATE(448),
    [sym_math_expression] = STATE(448),
    [sym_cast_expression] = STATE(448),
    [sym_sizeof_expression] = STATE(448),
    [sym_subscript_expression] = STATE(448),
    [sym_call_expression] = STATE(448),
    [sym_field_expression] = STATE(448),
    [sym_compound_literal_expression] = STATE(448),
    [sym_parenthesized_expression] = STATE(448),
    [sym_concatenated_string] = STATE(448),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(1049),
    [sym_char_literal] = ACTIONS(1049),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(1051),
    [sym_false] = ACTIONS(1051),
    [sym_null] = ACTIONS(1051),
    [sym_identifier] = ACTIONS(1051),
    [sym_comment] = ACTIONS(42),
  },
  [453] = {
    [sym__expression] = STATE(475),
    [sym_conditional_expression] = STATE(475),
    [sym_assignment_expression] = STATE(475),
    [sym_pointer_expression] = STATE(475),
    [sym_logical_expression] = STATE(475),
    [sym_bitwise_expression] = STATE(475),
    [sym_equality_expression] = STATE(475),
    [sym_relational_expression] = STATE(475),
    [sym_shift_expression] = STATE(475),
    [sym_math_expression] = STATE(475),
    [sym_cast_expression] = STATE(475),
    [sym_sizeof_expression] = STATE(475),
    [sym_subscript_expression] = STATE(475),
    [sym_call_expression] = STATE(475),
    [sym_field_expression] = STATE(475),
    [sym_compound_literal_expression] = STATE(475),
    [sym_parenthesized_expression] = STATE(475),
    [sym_concatenated_string] = STATE(475),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(1109),
    [sym_char_literal] = ACTIONS(1109),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(1111),
    [sym_false] = ACTIONS(1111),
    [sym_null] = ACTIONS(1111),
    [sym_identifier] = ACTIONS(1111),
    [sym_comment] = ACTIONS(42),
  },
  [454] = {
    [sym__expression] = STATE(476),
    [sym_conditional_expression] = STATE(476),
    [sym_assignment_expression] = STATE(476),
    [sym_pointer_expression] = STATE(476),
    [sym_logical_expression] = STATE(476),
    [sym_bitwise_expression] = STATE(476),
    [sym_equality_expression] = STATE(476),
    [sym_relational_expression] = STATE(476),
    [sym_shift_expression] = STATE(476),
    [sym_math_expression] = STATE(476),
    [sym_cast_expression] = STATE(476),
    [sym_sizeof_expression] = STATE(476),
    [sym_subscript_expression] = STATE(476),
    [sym_call_expression] = STATE(476),
    [sym_field_expression] = STATE(476),
    [sym_compound_literal_expression] = STATE(476),
    [sym_parenthesized_expression] = STATE(476),
    [sym_concatenated_string] = STATE(476),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(1113),
    [sym_char_literal] = ACTIONS(1113),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(1115),
    [sym_false] = ACTIONS(1115),
    [sym_null] = ACTIONS(1115),
    [sym_identifier] = ACTIONS(1115),
    [sym_comment] = ACTIONS(42),
  },
  [455] = {
    [sym__expression] = STATE(477),
    [sym_conditional_expression] = STATE(477),
    [sym_assignment_expression] = STATE(477),
    [sym_pointer_expression] = STATE(477),
    [sym_logical_expression] = STATE(477),
    [sym_bitwise_expression] = STATE(477),
    [sym_equality_expression] = STATE(477),
    [sym_relational_expression] = STATE(477),
    [sym_shift_expression] = STATE(477),
    [sym_math_expression] = STATE(477),
    [sym_cast_expression] = STATE(477),
    [sym_sizeof_expression] = STATE(477),
    [sym_subscript_expression] = STATE(477),
    [sym_call_expression] = STATE(477),
    [sym_field_expression] = STATE(477),
    [sym_compound_literal_expression] = STATE(477),
    [sym_parenthesized_expression] = STATE(477),
    [sym_concatenated_string] = STATE(477),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(1117),
    [sym_char_literal] = ACTIONS(1117),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(1119),
    [sym_false] = ACTIONS(1119),
    [sym_null] = ACTIONS(1119),
    [sym_identifier] = ACTIONS(1119),
    [sym_comment] = ACTIONS(42),
  },
  [456] = {
    [sym__expression] = STATE(744),
    [sym_conditional_expression] = STATE(744),
    [sym_assignment_expression] = STATE(744),
    [sym_pointer_expression] = STATE(744),
    [sym_logical_expression] = STATE(744),
    [sym_bitwise_expression] = STATE(744),
    [sym_equality_expression] = STATE(744),
    [sym_relational_expression] = STATE(744),
    [sym_shift_expression] = STATE(744),
    [sym_math_expression] = STATE(744),
    [sym_cast_expression] = STATE(744),
    [sym_sizeof_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_call_expression] = STATE(744),
    [sym_field_expression] = STATE(744),
    [sym_compound_literal_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(744),
    [sym_concatenated_string] = STATE(744),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(1729),
    [sym_char_literal] = ACTIONS(1729),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(1731),
    [sym_false] = ACTIONS(1731),
    [sym_null] = ACTIONS(1731),
    [sym_identifier] = ACTIONS(1731),
    [sym_comment] = ACTIONS(42),
  },
  [457] = {
    [aux_sym_concatenated_string_repeat1] = STATE(745),
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_COLON] = ACTIONS(1127),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_string_literal] = ACTIONS(1733),
    [sym_comment] = ACTIONS(42),
  },
  [458] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1737),
    [anon_sym_COLON] = ACTIONS(1739),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1743),
    [anon_sym_SLASH_EQ] = ACTIONS(1743),
    [anon_sym_PERCENT_EQ] = ACTIONS(1743),
    [anon_sym_PLUS_EQ] = ACTIONS(1743),
    [anon_sym_DASH_EQ] = ACTIONS(1743),
    [anon_sym_LT_LT_EQ] = ACTIONS(1743),
    [anon_sym_GT_GT_EQ] = ACTIONS(1743),
    [anon_sym_AMP_EQ] = ACTIONS(1743),
    [anon_sym_CARET_EQ] = ACTIONS(1743),
    [anon_sym_PIPE_EQ] = ACTIONS(1743),
    [anon_sym_AMP] = ACTIONS(1745),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_AMP_AMP] = ACTIONS(1749),
    [anon_sym_PIPE] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_GT] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [459] = {
    [sym_declaration] = STATE(760),
    [sym_type_definition] = STATE(760),
    [sym__declaration_specifiers] = STATE(761),
    [sym_compound_statement] = STATE(760),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(760),
    [sym_expression_statement] = STATE(760),
    [sym_if_statement] = STATE(760),
    [sym_switch_statement] = STATE(760),
    [sym_case_statement] = STATE(760),
    [sym_while_statement] = STATE(760),
    [sym_do_statement] = STATE(760),
    [sym_for_statement] = STATE(760),
    [sym_return_statement] = STATE(760),
    [sym_break_statement] = STATE(760),
    [sym_continue_statement] = STATE(760),
    [sym_goto_statement] = STATE(760),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_typedef] = ACTIONS(585),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1765),
    [sym_comment] = ACTIONS(42),
  },
  [460] = {
    [sym__expression] = STATE(762),
    [sym_conditional_expression] = STATE(762),
    [sym_assignment_expression] = STATE(762),
    [sym_pointer_expression] = STATE(762),
    [sym_logical_expression] = STATE(762),
    [sym_bitwise_expression] = STATE(762),
    [sym_equality_expression] = STATE(762),
    [sym_relational_expression] = STATE(762),
    [sym_shift_expression] = STATE(762),
    [sym_math_expression] = STATE(762),
    [sym_cast_expression] = STATE(762),
    [sym_sizeof_expression] = STATE(762),
    [sym_subscript_expression] = STATE(762),
    [sym_call_expression] = STATE(762),
    [sym_field_expression] = STATE(762),
    [sym_compound_literal_expression] = STATE(762),
    [sym_parenthesized_expression] = STATE(762),
    [sym_concatenated_string] = STATE(762),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(1767),
    [sym_char_literal] = ACTIONS(1767),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(1769),
    [sym_false] = ACTIONS(1769),
    [sym_null] = ACTIONS(1769),
    [sym_identifier] = ACTIONS(1769),
    [sym_comment] = ACTIONS(42),
  },
  [461] = {
    [anon_sym_LPAREN] = ACTIONS(1771),
    [sym_comment] = ACTIONS(42),
  },
  [462] = {
    [anon_sym_LPAREN] = ACTIONS(1773),
    [sym_comment] = ACTIONS(42),
  },
  [463] = {
    [sym__expression] = STATE(765),
    [sym_conditional_expression] = STATE(765),
    [sym_assignment_expression] = STATE(765),
    [sym_pointer_expression] = STATE(765),
    [sym_logical_expression] = STATE(765),
    [sym_bitwise_expression] = STATE(765),
    [sym_equality_expression] = STATE(765),
    [sym_relational_expression] = STATE(765),
    [sym_shift_expression] = STATE(765),
    [sym_math_expression] = STATE(765),
    [sym_cast_expression] = STATE(765),
    [sym_sizeof_expression] = STATE(765),
    [sym_subscript_expression] = STATE(765),
    [sym_call_expression] = STATE(765),
    [sym_field_expression] = STATE(765),
    [sym_compound_literal_expression] = STATE(765),
    [sym_parenthesized_expression] = STATE(765),
    [sym_concatenated_string] = STATE(765),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(1775),
    [sym_char_literal] = ACTIONS(1775),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(1777),
    [sym_false] = ACTIONS(1777),
    [sym_null] = ACTIONS(1777),
    [sym_identifier] = ACTIONS(1777),
    [sym_comment] = ACTIONS(42),
  },
  [464] = {
    [anon_sym_COLON] = ACTIONS(1779),
    [sym_comment] = ACTIONS(42),
  },
  [465] = {
    [anon_sym_LPAREN] = ACTIONS(1781),
    [sym_comment] = ACTIONS(42),
  },
  [466] = {
    [anon_sym_LPAREN] = ACTIONS(1783),
    [sym_comment] = ACTIONS(42),
  },
  [467] = {
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_COLON] = ACTIONS(1785),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_comment] = ACTIONS(42),
  },
  [468] = {
    [anon_sym_while] = ACTIONS(1787),
    [sym_comment] = ACTIONS(42),
  },
  [469] = {
    [sym_declaration] = STATE(771),
    [sym__declaration_specifiers] = STATE(773),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym__expression] = STATE(774),
    [sym_conditional_expression] = STATE(774),
    [sym_assignment_expression] = STATE(774),
    [sym_pointer_expression] = STATE(774),
    [sym_logical_expression] = STATE(774),
    [sym_bitwise_expression] = STATE(774),
    [sym_equality_expression] = STATE(774),
    [sym_relational_expression] = STATE(774),
    [sym_shift_expression] = STATE(774),
    [sym_math_expression] = STATE(774),
    [sym_cast_expression] = STATE(774),
    [sym_sizeof_expression] = STATE(774),
    [sym_subscript_expression] = STATE(774),
    [sym_call_expression] = STATE(774),
    [sym_field_expression] = STATE(774),
    [sym_compound_literal_expression] = STATE(774),
    [sym_parenthesized_expression] = STATE(774),
    [sym_concatenated_string] = STATE(774),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(1789),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(1791),
    [sym_char_literal] = ACTIONS(1791),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(1793),
    [sym_false] = ACTIONS(1793),
    [sym_null] = ACTIONS(1793),
    [sym_identifier] = ACTIONS(1795),
    [sym_comment] = ACTIONS(42),
  },
  [470] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1797),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1797),
    [sym_preproc_directive] = ACTIONS(1797),
    [anon_sym_SEMI] = ACTIONS(1799),
    [anon_sym_typedef] = ACTIONS(1797),
    [anon_sym_extern] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1799),
    [anon_sym_RBRACE] = ACTIONS(1799),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_static] = ACTIONS(1797),
    [anon_sym_auto] = ACTIONS(1797),
    [anon_sym_register] = ACTIONS(1797),
    [anon_sym_inline] = ACTIONS(1797),
    [anon_sym_const] = ACTIONS(1797),
    [anon_sym_restrict] = ACTIONS(1797),
    [anon_sym_volatile] = ACTIONS(1797),
    [anon_sym__Atomic] = ACTIONS(1797),
    [anon_sym_unsigned] = ACTIONS(1797),
    [anon_sym_long] = ACTIONS(1797),
    [anon_sym_short] = ACTIONS(1797),
    [sym_primitive_type] = ACTIONS(1797),
    [anon_sym_enum] = ACTIONS(1797),
    [anon_sym_struct] = ACTIONS(1797),
    [anon_sym_union] = ACTIONS(1797),
    [anon_sym_if] = ACTIONS(1797),
    [anon_sym_switch] = ACTIONS(1797),
    [anon_sym_case] = ACTIONS(1797),
    [anon_sym_default] = ACTIONS(1797),
    [anon_sym_while] = ACTIONS(1797),
    [anon_sym_do] = ACTIONS(1797),
    [anon_sym_for] = ACTIONS(1797),
    [anon_sym_return] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1797),
    [anon_sym_continue] = ACTIONS(1797),
    [anon_sym_goto] = ACTIONS(1797),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_sizeof] = ACTIONS(1797),
    [sym_number_literal] = ACTIONS(1799),
    [sym_char_literal] = ACTIONS(1799),
    [sym_string_literal] = ACTIONS(1799),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [sym_null] = ACTIONS(1797),
    [sym_identifier] = ACTIONS(1797),
    [sym_comment] = ACTIONS(42),
  },
  [471] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [472] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1803),
    [anon_sym_LPAREN] = ACTIONS(1805),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1803),
    [sym_preproc_directive] = ACTIONS(1803),
    [anon_sym_SEMI] = ACTIONS(1805),
    [anon_sym_typedef] = ACTIONS(1803),
    [anon_sym_extern] = ACTIONS(1803),
    [anon_sym_LBRACE] = ACTIONS(1805),
    [anon_sym_RBRACE] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_static] = ACTIONS(1803),
    [anon_sym_auto] = ACTIONS(1803),
    [anon_sym_register] = ACTIONS(1803),
    [anon_sym_inline] = ACTIONS(1803),
    [anon_sym_const] = ACTIONS(1803),
    [anon_sym_restrict] = ACTIONS(1803),
    [anon_sym_volatile] = ACTIONS(1803),
    [anon_sym__Atomic] = ACTIONS(1803),
    [anon_sym_unsigned] = ACTIONS(1803),
    [anon_sym_long] = ACTIONS(1803),
    [anon_sym_short] = ACTIONS(1803),
    [sym_primitive_type] = ACTIONS(1803),
    [anon_sym_enum] = ACTIONS(1803),
    [anon_sym_struct] = ACTIONS(1803),
    [anon_sym_union] = ACTIONS(1803),
    [anon_sym_if] = ACTIONS(1803),
    [anon_sym_switch] = ACTIONS(1803),
    [anon_sym_case] = ACTIONS(1803),
    [anon_sym_default] = ACTIONS(1803),
    [anon_sym_while] = ACTIONS(1803),
    [anon_sym_do] = ACTIONS(1803),
    [anon_sym_for] = ACTIONS(1803),
    [anon_sym_return] = ACTIONS(1803),
    [anon_sym_break] = ACTIONS(1803),
    [anon_sym_continue] = ACTIONS(1803),
    [anon_sym_goto] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1803),
    [anon_sym_DASH] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1805),
    [anon_sym_PLUS_PLUS] = ACTIONS(1805),
    [anon_sym_sizeof] = ACTIONS(1803),
    [sym_number_literal] = ACTIONS(1805),
    [sym_char_literal] = ACTIONS(1805),
    [sym_string_literal] = ACTIONS(1805),
    [sym_true] = ACTIONS(1803),
    [sym_false] = ACTIONS(1803),
    [sym_null] = ACTIONS(1803),
    [sym_identifier] = ACTIONS(1803),
    [sym_comment] = ACTIONS(42),
  },
  [473] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1807),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1807),
    [sym_preproc_directive] = ACTIONS(1807),
    [anon_sym_SEMI] = ACTIONS(1809),
    [anon_sym_typedef] = ACTIONS(1807),
    [anon_sym_extern] = ACTIONS(1807),
    [anon_sym_LBRACE] = ACTIONS(1809),
    [anon_sym_RBRACE] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_static] = ACTIONS(1807),
    [anon_sym_auto] = ACTIONS(1807),
    [anon_sym_register] = ACTIONS(1807),
    [anon_sym_inline] = ACTIONS(1807),
    [anon_sym_const] = ACTIONS(1807),
    [anon_sym_restrict] = ACTIONS(1807),
    [anon_sym_volatile] = ACTIONS(1807),
    [anon_sym__Atomic] = ACTIONS(1807),
    [anon_sym_unsigned] = ACTIONS(1807),
    [anon_sym_long] = ACTIONS(1807),
    [anon_sym_short] = ACTIONS(1807),
    [sym_primitive_type] = ACTIONS(1807),
    [anon_sym_enum] = ACTIONS(1807),
    [anon_sym_struct] = ACTIONS(1807),
    [anon_sym_union] = ACTIONS(1807),
    [anon_sym_if] = ACTIONS(1807),
    [anon_sym_switch] = ACTIONS(1807),
    [anon_sym_case] = ACTIONS(1807),
    [anon_sym_default] = ACTIONS(1807),
    [anon_sym_while] = ACTIONS(1807),
    [anon_sym_do] = ACTIONS(1807),
    [anon_sym_for] = ACTIONS(1807),
    [anon_sym_return] = ACTIONS(1807),
    [anon_sym_break] = ACTIONS(1807),
    [anon_sym_continue] = ACTIONS(1807),
    [anon_sym_goto] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1809),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1809),
    [anon_sym_PLUS_PLUS] = ACTIONS(1809),
    [anon_sym_sizeof] = ACTIONS(1807),
    [sym_number_literal] = ACTIONS(1809),
    [sym_char_literal] = ACTIONS(1809),
    [sym_string_literal] = ACTIONS(1809),
    [sym_true] = ACTIONS(1807),
    [sym_false] = ACTIONS(1807),
    [sym_null] = ACTIONS(1807),
    [sym_identifier] = ACTIONS(1807),
    [sym_comment] = ACTIONS(42),
  },
  [474] = {
    [anon_sym_SEMI] = ACTIONS(1811),
    [sym_comment] = ACTIONS(42),
  },
  [475] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1813),
    [anon_sym_RPAREN] = ACTIONS(1813),
    [anon_sym_SEMI] = ACTIONS(1813),
    [anon_sym_RBRACE] = ACTIONS(1813),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(1813),
    [anon_sym_EQ] = ACTIONS(1815),
    [anon_sym_COLON] = ACTIONS(1813),
    [anon_sym_QMARK] = ACTIONS(1813),
    [anon_sym_STAR_EQ] = ACTIONS(1813),
    [anon_sym_SLASH_EQ] = ACTIONS(1813),
    [anon_sym_PERCENT_EQ] = ACTIONS(1813),
    [anon_sym_PLUS_EQ] = ACTIONS(1813),
    [anon_sym_DASH_EQ] = ACTIONS(1813),
    [anon_sym_LT_LT_EQ] = ACTIONS(1813),
    [anon_sym_GT_GT_EQ] = ACTIONS(1813),
    [anon_sym_AMP_EQ] = ACTIONS(1813),
    [anon_sym_CARET_EQ] = ACTIONS(1813),
    [anon_sym_PIPE_EQ] = ACTIONS(1813),
    [anon_sym_AMP] = ACTIONS(1815),
    [anon_sym_PIPE_PIPE] = ACTIONS(1813),
    [anon_sym_AMP_AMP] = ACTIONS(1813),
    [anon_sym_PIPE] = ACTIONS(1815),
    [anon_sym_CARET] = ACTIONS(1815),
    [anon_sym_EQ_EQ] = ACTIONS(1813),
    [anon_sym_BANG_EQ] = ACTIONS(1813),
    [anon_sym_LT] = ACTIONS(1815),
    [anon_sym_GT] = ACTIONS(1815),
    [anon_sym_LT_EQ] = ACTIONS(1813),
    [anon_sym_GT_EQ] = ACTIONS(1813),
    [anon_sym_LT_LT] = ACTIONS(1815),
    [anon_sym_GT_GT] = ACTIONS(1815),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_SLASH] = ACTIONS(1815),
    [anon_sym_PERCENT] = ACTIONS(1815),
    [anon_sym_DASH_DASH] = ACTIONS(1813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1813),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [476] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1817),
    [anon_sym_RPAREN] = ACTIONS(1817),
    [anon_sym_SEMI] = ACTIONS(1817),
    [anon_sym_RBRACE] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(1817),
    [anon_sym_EQ] = ACTIONS(1819),
    [anon_sym_COLON] = ACTIONS(1817),
    [anon_sym_QMARK] = ACTIONS(1817),
    [anon_sym_STAR_EQ] = ACTIONS(1817),
    [anon_sym_SLASH_EQ] = ACTIONS(1817),
    [anon_sym_PERCENT_EQ] = ACTIONS(1817),
    [anon_sym_PLUS_EQ] = ACTIONS(1817),
    [anon_sym_DASH_EQ] = ACTIONS(1817),
    [anon_sym_LT_LT_EQ] = ACTIONS(1817),
    [anon_sym_GT_GT_EQ] = ACTIONS(1817),
    [anon_sym_AMP_EQ] = ACTIONS(1817),
    [anon_sym_CARET_EQ] = ACTIONS(1817),
    [anon_sym_PIPE_EQ] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1819),
    [anon_sym_PIPE_PIPE] = ACTIONS(1817),
    [anon_sym_AMP_AMP] = ACTIONS(1817),
    [anon_sym_PIPE] = ACTIONS(1819),
    [anon_sym_CARET] = ACTIONS(1819),
    [anon_sym_EQ_EQ] = ACTIONS(1817),
    [anon_sym_BANG_EQ] = ACTIONS(1817),
    [anon_sym_LT] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(1819),
    [anon_sym_LT_EQ] = ACTIONS(1817),
    [anon_sym_GT_EQ] = ACTIONS(1817),
    [anon_sym_LT_LT] = ACTIONS(1819),
    [anon_sym_GT_GT] = ACTIONS(1819),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_SLASH] = ACTIONS(1819),
    [anon_sym_PERCENT] = ACTIONS(1819),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [477] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1821),
    [anon_sym_RPAREN] = ACTIONS(1821),
    [anon_sym_SEMI] = ACTIONS(1821),
    [anon_sym_RBRACE] = ACTIONS(1821),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(1821),
    [anon_sym_EQ] = ACTIONS(1823),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_QMARK] = ACTIONS(1821),
    [anon_sym_STAR_EQ] = ACTIONS(1821),
    [anon_sym_SLASH_EQ] = ACTIONS(1821),
    [anon_sym_PERCENT_EQ] = ACTIONS(1821),
    [anon_sym_PLUS_EQ] = ACTIONS(1821),
    [anon_sym_DASH_EQ] = ACTIONS(1821),
    [anon_sym_LT_LT_EQ] = ACTIONS(1821),
    [anon_sym_GT_GT_EQ] = ACTIONS(1821),
    [anon_sym_AMP_EQ] = ACTIONS(1821),
    [anon_sym_CARET_EQ] = ACTIONS(1821),
    [anon_sym_PIPE_EQ] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1823),
    [anon_sym_PIPE_PIPE] = ACTIONS(1821),
    [anon_sym_AMP_AMP] = ACTIONS(1821),
    [anon_sym_PIPE] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1823),
    [anon_sym_EQ_EQ] = ACTIONS(1821),
    [anon_sym_BANG_EQ] = ACTIONS(1821),
    [anon_sym_LT] = ACTIONS(1823),
    [anon_sym_GT] = ACTIONS(1823),
    [anon_sym_LT_EQ] = ACTIONS(1821),
    [anon_sym_GT_EQ] = ACTIONS(1821),
    [anon_sym_LT_LT] = ACTIONS(1823),
    [anon_sym_GT_GT] = ACTIONS(1823),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_SLASH] = ACTIONS(1823),
    [anon_sym_PERCENT] = ACTIONS(1823),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [478] = {
    [sym_type_qualifier] = STATE(133),
    [sym__type_specifier] = STATE(131),
    [sym_sized_type_specifier] = STATE(131),
    [sym_enum_specifier] = STATE(131),
    [sym_struct_specifier] = STATE(131),
    [sym_union_specifier] = STATE(131),
    [sym__expression] = STATE(436),
    [sym_comma_expression] = STATE(437),
    [sym_conditional_expression] = STATE(436),
    [sym_assignment_expression] = STATE(436),
    [sym_pointer_expression] = STATE(436),
    [sym_logical_expression] = STATE(436),
    [sym_bitwise_expression] = STATE(436),
    [sym_equality_expression] = STATE(436),
    [sym_relational_expression] = STATE(436),
    [sym_shift_expression] = STATE(436),
    [sym_math_expression] = STATE(436),
    [sym_cast_expression] = STATE(436),
    [sym_type_descriptor] = STATE(777),
    [sym_sizeof_expression] = STATE(436),
    [sym_subscript_expression] = STATE(436),
    [sym_call_expression] = STATE(436),
    [sym_field_expression] = STATE(436),
    [sym_compound_literal_expression] = STATE(436),
    [sym_parenthesized_expression] = STATE(436),
    [sym_concatenated_string] = STATE(436),
    [sym_macro_type_specifier] = STATE(131),
    [aux_sym_type_definition_repeat1] = STATE(133),
    [aux_sym_sized_type_specifier_repeat1] = STATE(134),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(248),
    [anon_sym_long] = ACTIONS(248),
    [anon_sym_short] = ACTIONS(248),
    [sym_primitive_type] = ACTIONS(250),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1019),
    [sym_char_literal] = ACTIONS(1019),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(1023),
    [sym_false] = ACTIONS(1023),
    [sym_null] = ACTIONS(1023),
    [sym_identifier] = ACTIONS(1025),
    [sym_comment] = ACTIONS(42),
  },
  [479] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1825),
    [anon_sym_SEMI] = ACTIONS(1825),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1827),
    [anon_sym_QMARK] = ACTIONS(1825),
    [anon_sym_STAR_EQ] = ACTIONS(1825),
    [anon_sym_SLASH_EQ] = ACTIONS(1825),
    [anon_sym_PERCENT_EQ] = ACTIONS(1825),
    [anon_sym_PLUS_EQ] = ACTIONS(1825),
    [anon_sym_DASH_EQ] = ACTIONS(1825),
    [anon_sym_LT_LT_EQ] = ACTIONS(1825),
    [anon_sym_GT_GT_EQ] = ACTIONS(1825),
    [anon_sym_AMP_EQ] = ACTIONS(1825),
    [anon_sym_CARET_EQ] = ACTIONS(1825),
    [anon_sym_PIPE_EQ] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1827),
    [anon_sym_PIPE_PIPE] = ACTIONS(1825),
    [anon_sym_AMP_AMP] = ACTIONS(1825),
    [anon_sym_PIPE] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1827),
    [anon_sym_EQ_EQ] = ACTIONS(1825),
    [anon_sym_BANG_EQ] = ACTIONS(1825),
    [anon_sym_LT] = ACTIONS(1827),
    [anon_sym_GT] = ACTIONS(1827),
    [anon_sym_LT_EQ] = ACTIONS(1825),
    [anon_sym_GT_EQ] = ACTIONS(1825),
    [anon_sym_LT_LT] = ACTIONS(1189),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [480] = {
    [aux_sym_concatenated_string_repeat1] = STATE(778),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_COMMA] = ACTIONS(1829),
    [anon_sym_SEMI] = ACTIONS(1829),
    [anon_sym_STAR] = ACTIONS(1831),
    [anon_sym_LBRACK] = ACTIONS(1829),
    [anon_sym_EQ] = ACTIONS(1831),
    [anon_sym_QMARK] = ACTIONS(1829),
    [anon_sym_STAR_EQ] = ACTIONS(1829),
    [anon_sym_SLASH_EQ] = ACTIONS(1829),
    [anon_sym_PERCENT_EQ] = ACTIONS(1829),
    [anon_sym_PLUS_EQ] = ACTIONS(1829),
    [anon_sym_DASH_EQ] = ACTIONS(1829),
    [anon_sym_LT_LT_EQ] = ACTIONS(1829),
    [anon_sym_GT_GT_EQ] = ACTIONS(1829),
    [anon_sym_AMP_EQ] = ACTIONS(1829),
    [anon_sym_CARET_EQ] = ACTIONS(1829),
    [anon_sym_PIPE_EQ] = ACTIONS(1829),
    [anon_sym_AMP] = ACTIONS(1831),
    [anon_sym_PIPE_PIPE] = ACTIONS(1829),
    [anon_sym_AMP_AMP] = ACTIONS(1829),
    [anon_sym_PIPE] = ACTIONS(1831),
    [anon_sym_CARET] = ACTIONS(1831),
    [anon_sym_EQ_EQ] = ACTIONS(1829),
    [anon_sym_BANG_EQ] = ACTIONS(1829),
    [anon_sym_LT] = ACTIONS(1831),
    [anon_sym_GT] = ACTIONS(1831),
    [anon_sym_LT_EQ] = ACTIONS(1829),
    [anon_sym_GT_EQ] = ACTIONS(1829),
    [anon_sym_LT_LT] = ACTIONS(1831),
    [anon_sym_GT_GT] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_SLASH] = ACTIONS(1831),
    [anon_sym_PERCENT] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1829),
    [anon_sym_PLUS_PLUS] = ACTIONS(1829),
    [anon_sym_DOT] = ACTIONS(1829),
    [anon_sym_DASH_GT] = ACTIONS(1829),
    [sym_string_literal] = ACTIONS(1833),
    [sym_comment] = ACTIONS(42),
  },
  [481] = {
    [sym_compound_statement] = STATE(780),
    [sym_labeled_statement] = STATE(780),
    [sym_expression_statement] = STATE(780),
    [sym_if_statement] = STATE(780),
    [sym_switch_statement] = STATE(780),
    [sym_case_statement] = STATE(780),
    [sym_while_statement] = STATE(780),
    [sym_do_statement] = STATE(780),
    [sym_for_statement] = STATE(780),
    [sym_return_statement] = STATE(780),
    [sym_break_statement] = STATE(780),
    [sym_continue_statement] = STATE(780),
    [sym_goto_statement] = STATE(780),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1835),
    [sym_comment] = ACTIONS(42),
  },
  [482] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(258),
    [anon_sym_LPAREN] = ACTIONS(256),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(258),
    [sym_preproc_directive] = ACTIONS(258),
    [anon_sym_SEMI] = ACTIONS(256),
    [anon_sym_typedef] = ACTIONS(258),
    [anon_sym_extern] = ACTIONS(258),
    [anon_sym_LBRACE] = ACTIONS(256),
    [anon_sym_RBRACE] = ACTIONS(256),
    [anon_sym_STAR] = ACTIONS(256),
    [anon_sym_static] = ACTIONS(258),
    [anon_sym_auto] = ACTIONS(258),
    [anon_sym_register] = ACTIONS(258),
    [anon_sym_inline] = ACTIONS(258),
    [anon_sym_const] = ACTIONS(258),
    [anon_sym_restrict] = ACTIONS(258),
    [anon_sym_volatile] = ACTIONS(258),
    [anon_sym__Atomic] = ACTIONS(258),
    [anon_sym_unsigned] = ACTIONS(258),
    [anon_sym_long] = ACTIONS(258),
    [anon_sym_short] = ACTIONS(258),
    [sym_primitive_type] = ACTIONS(258),
    [anon_sym_enum] = ACTIONS(258),
    [anon_sym_struct] = ACTIONS(258),
    [anon_sym_union] = ACTIONS(258),
    [anon_sym_if] = ACTIONS(258),
    [anon_sym_switch] = ACTIONS(258),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_default] = ACTIONS(258),
    [anon_sym_while] = ACTIONS(258),
    [anon_sym_do] = ACTIONS(258),
    [anon_sym_for] = ACTIONS(258),
    [anon_sym_return] = ACTIONS(258),
    [anon_sym_break] = ACTIONS(258),
    [anon_sym_continue] = ACTIONS(258),
    [anon_sym_goto] = ACTIONS(258),
    [anon_sym_AMP] = ACTIONS(256),
    [anon_sym_BANG] = ACTIONS(256),
    [anon_sym_TILDE] = ACTIONS(256),
    [anon_sym_PLUS] = ACTIONS(258),
    [anon_sym_DASH] = ACTIONS(258),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_sizeof] = ACTIONS(258),
    [sym_number_literal] = ACTIONS(256),
    [sym_char_literal] = ACTIONS(256),
    [sym_string_literal] = ACTIONS(256),
    [sym_true] = ACTIONS(258),
    [sym_false] = ACTIONS(258),
    [sym_null] = ACTIONS(258),
    [sym_identifier] = ACTIONS(258),
    [sym_comment] = ACTIONS(42),
  },
  [483] = {
    [sym_parameter_list] = STATE(145),
    [aux_sym_declaration_repeat1] = STATE(782),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(270),
    [anon_sym_EQ] = ACTIONS(272),
    [sym_comment] = ACTIONS(42),
  },
  [484] = {
    [aux_sym_declaration_repeat1] = STATE(782),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(1837),
    [sym_comment] = ACTIONS(42),
  },
  [485] = {
    [sym__expression] = STATE(784),
    [sym_conditional_expression] = STATE(784),
    [sym_assignment_expression] = STATE(784),
    [sym_pointer_expression] = STATE(784),
    [sym_logical_expression] = STATE(784),
    [sym_bitwise_expression] = STATE(784),
    [sym_equality_expression] = STATE(784),
    [sym_relational_expression] = STATE(784),
    [sym_shift_expression] = STATE(784),
    [sym_math_expression] = STATE(784),
    [sym_cast_expression] = STATE(784),
    [sym_sizeof_expression] = STATE(784),
    [sym_subscript_expression] = STATE(784),
    [sym_call_expression] = STATE(784),
    [sym_field_expression] = STATE(784),
    [sym_compound_literal_expression] = STATE(784),
    [sym_parenthesized_expression] = STATE(784),
    [sym_concatenated_string] = STATE(784),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(1839),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1841),
    [sym_char_literal] = ACTIONS(1841),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(1843),
    [sym_false] = ACTIONS(1843),
    [sym_null] = ACTIONS(1843),
    [sym_identifier] = ACTIONS(1843),
    [sym_comment] = ACTIONS(42),
  },
  [486] = {
    [sym__expression] = STATE(785),
    [sym_comma_expression] = STATE(786),
    [sym_conditional_expression] = STATE(785),
    [sym_assignment_expression] = STATE(785),
    [sym_pointer_expression] = STATE(785),
    [sym_logical_expression] = STATE(785),
    [sym_bitwise_expression] = STATE(785),
    [sym_equality_expression] = STATE(785),
    [sym_relational_expression] = STATE(785),
    [sym_shift_expression] = STATE(785),
    [sym_math_expression] = STATE(785),
    [sym_cast_expression] = STATE(785),
    [sym_sizeof_expression] = STATE(785),
    [sym_subscript_expression] = STATE(785),
    [sym_call_expression] = STATE(785),
    [sym_field_expression] = STATE(785),
    [sym_compound_literal_expression] = STATE(785),
    [sym_parenthesized_expression] = STATE(785),
    [sym_concatenated_string] = STATE(785),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1845),
    [sym_char_literal] = ACTIONS(1845),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1847),
    [sym_false] = ACTIONS(1847),
    [sym_null] = ACTIONS(1847),
    [sym_identifier] = ACTIONS(1847),
    [sym_comment] = ACTIONS(42),
  },
  [487] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1849),
    [anon_sym_LPAREN] = ACTIONS(1851),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1849),
    [sym_preproc_directive] = ACTIONS(1849),
    [anon_sym_SEMI] = ACTIONS(1851),
    [anon_sym_typedef] = ACTIONS(1849),
    [anon_sym_extern] = ACTIONS(1849),
    [anon_sym_LBRACE] = ACTIONS(1851),
    [anon_sym_RBRACE] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1851),
    [anon_sym_static] = ACTIONS(1849),
    [anon_sym_auto] = ACTIONS(1849),
    [anon_sym_register] = ACTIONS(1849),
    [anon_sym_inline] = ACTIONS(1849),
    [anon_sym_const] = ACTIONS(1849),
    [anon_sym_restrict] = ACTIONS(1849),
    [anon_sym_volatile] = ACTIONS(1849),
    [anon_sym__Atomic] = ACTIONS(1849),
    [anon_sym_unsigned] = ACTIONS(1849),
    [anon_sym_long] = ACTIONS(1849),
    [anon_sym_short] = ACTIONS(1849),
    [sym_primitive_type] = ACTIONS(1849),
    [anon_sym_enum] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1849),
    [anon_sym_union] = ACTIONS(1849),
    [anon_sym_if] = ACTIONS(1849),
    [anon_sym_switch] = ACTIONS(1849),
    [anon_sym_case] = ACTIONS(1849),
    [anon_sym_default] = ACTIONS(1849),
    [anon_sym_while] = ACTIONS(1849),
    [anon_sym_do] = ACTIONS(1849),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(1849),
    [anon_sym_break] = ACTIONS(1849),
    [anon_sym_continue] = ACTIONS(1849),
    [anon_sym_goto] = ACTIONS(1849),
    [anon_sym_AMP] = ACTIONS(1851),
    [anon_sym_BANG] = ACTIONS(1851),
    [anon_sym_TILDE] = ACTIONS(1851),
    [anon_sym_PLUS] = ACTIONS(1849),
    [anon_sym_DASH] = ACTIONS(1849),
    [anon_sym_DASH_DASH] = ACTIONS(1851),
    [anon_sym_PLUS_PLUS] = ACTIONS(1851),
    [anon_sym_sizeof] = ACTIONS(1849),
    [sym_number_literal] = ACTIONS(1851),
    [sym_char_literal] = ACTIONS(1851),
    [sym_string_literal] = ACTIONS(1851),
    [sym_true] = ACTIONS(1849),
    [sym_false] = ACTIONS(1849),
    [sym_null] = ACTIONS(1849),
    [sym_identifier] = ACTIONS(1849),
    [sym_comment] = ACTIONS(42),
  },
  [488] = {
    [sym__expression] = STATE(787),
    [sym_conditional_expression] = STATE(787),
    [sym_assignment_expression] = STATE(787),
    [sym_pointer_expression] = STATE(787),
    [sym_logical_expression] = STATE(787),
    [sym_bitwise_expression] = STATE(787),
    [sym_equality_expression] = STATE(787),
    [sym_relational_expression] = STATE(787),
    [sym_shift_expression] = STATE(787),
    [sym_math_expression] = STATE(787),
    [sym_cast_expression] = STATE(787),
    [sym_sizeof_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_call_expression] = STATE(787),
    [sym_field_expression] = STATE(787),
    [sym_compound_literal_expression] = STATE(787),
    [sym_parenthesized_expression] = STATE(787),
    [sym_concatenated_string] = STATE(787),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1853),
    [sym_char_literal] = ACTIONS(1853),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1855),
    [sym_false] = ACTIONS(1855),
    [sym_null] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_comment] = ACTIONS(42),
  },
  [489] = {
    [sym__expression] = STATE(788),
    [sym_conditional_expression] = STATE(788),
    [sym_assignment_expression] = STATE(788),
    [sym_pointer_expression] = STATE(788),
    [sym_logical_expression] = STATE(788),
    [sym_bitwise_expression] = STATE(788),
    [sym_equality_expression] = STATE(788),
    [sym_relational_expression] = STATE(788),
    [sym_shift_expression] = STATE(788),
    [sym_math_expression] = STATE(788),
    [sym_cast_expression] = STATE(788),
    [sym_sizeof_expression] = STATE(788),
    [sym_subscript_expression] = STATE(788),
    [sym_call_expression] = STATE(788),
    [sym_field_expression] = STATE(788),
    [sym_compound_literal_expression] = STATE(788),
    [sym_parenthesized_expression] = STATE(788),
    [sym_concatenated_string] = STATE(788),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(1857),
    [sym_char_literal] = ACTIONS(1857),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(1859),
    [sym_false] = ACTIONS(1859),
    [sym_null] = ACTIONS(1859),
    [sym_identifier] = ACTIONS(1859),
    [sym_comment] = ACTIONS(42),
  },
  [490] = {
    [sym__expression] = STATE(789),
    [sym_conditional_expression] = STATE(789),
    [sym_assignment_expression] = STATE(789),
    [sym_pointer_expression] = STATE(789),
    [sym_logical_expression] = STATE(789),
    [sym_bitwise_expression] = STATE(789),
    [sym_equality_expression] = STATE(789),
    [sym_relational_expression] = STATE(789),
    [sym_shift_expression] = STATE(789),
    [sym_math_expression] = STATE(789),
    [sym_cast_expression] = STATE(789),
    [sym_sizeof_expression] = STATE(789),
    [sym_subscript_expression] = STATE(789),
    [sym_call_expression] = STATE(789),
    [sym_field_expression] = STATE(789),
    [sym_compound_literal_expression] = STATE(789),
    [sym_parenthesized_expression] = STATE(789),
    [sym_concatenated_string] = STATE(789),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1861),
    [sym_char_literal] = ACTIONS(1861),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1863),
    [sym_false] = ACTIONS(1863),
    [sym_null] = ACTIONS(1863),
    [sym_identifier] = ACTIONS(1863),
    [sym_comment] = ACTIONS(42),
  },
  [491] = {
    [sym__expression] = STATE(790),
    [sym_conditional_expression] = STATE(790),
    [sym_assignment_expression] = STATE(790),
    [sym_pointer_expression] = STATE(790),
    [sym_logical_expression] = STATE(790),
    [sym_bitwise_expression] = STATE(790),
    [sym_equality_expression] = STATE(790),
    [sym_relational_expression] = STATE(790),
    [sym_shift_expression] = STATE(790),
    [sym_math_expression] = STATE(790),
    [sym_cast_expression] = STATE(790),
    [sym_sizeof_expression] = STATE(790),
    [sym_subscript_expression] = STATE(790),
    [sym_call_expression] = STATE(790),
    [sym_field_expression] = STATE(790),
    [sym_compound_literal_expression] = STATE(790),
    [sym_parenthesized_expression] = STATE(790),
    [sym_concatenated_string] = STATE(790),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(1865),
    [sym_char_literal] = ACTIONS(1865),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(1867),
    [sym_false] = ACTIONS(1867),
    [sym_null] = ACTIONS(1867),
    [sym_identifier] = ACTIONS(1867),
    [sym_comment] = ACTIONS(42),
  },
  [492] = {
    [sym__expression] = STATE(791),
    [sym_conditional_expression] = STATE(791),
    [sym_assignment_expression] = STATE(791),
    [sym_pointer_expression] = STATE(791),
    [sym_logical_expression] = STATE(791),
    [sym_bitwise_expression] = STATE(791),
    [sym_equality_expression] = STATE(791),
    [sym_relational_expression] = STATE(791),
    [sym_shift_expression] = STATE(791),
    [sym_math_expression] = STATE(791),
    [sym_cast_expression] = STATE(791),
    [sym_sizeof_expression] = STATE(791),
    [sym_subscript_expression] = STATE(791),
    [sym_call_expression] = STATE(791),
    [sym_field_expression] = STATE(791),
    [sym_compound_literal_expression] = STATE(791),
    [sym_parenthesized_expression] = STATE(791),
    [sym_concatenated_string] = STATE(791),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1869),
    [sym_char_literal] = ACTIONS(1869),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1871),
    [sym_false] = ACTIONS(1871),
    [sym_null] = ACTIONS(1871),
    [sym_identifier] = ACTIONS(1871),
    [sym_comment] = ACTIONS(42),
  },
  [493] = {
    [sym__expression] = STATE(792),
    [sym_conditional_expression] = STATE(792),
    [sym_assignment_expression] = STATE(792),
    [sym_pointer_expression] = STATE(792),
    [sym_logical_expression] = STATE(792),
    [sym_bitwise_expression] = STATE(792),
    [sym_equality_expression] = STATE(792),
    [sym_relational_expression] = STATE(792),
    [sym_shift_expression] = STATE(792),
    [sym_math_expression] = STATE(792),
    [sym_cast_expression] = STATE(792),
    [sym_sizeof_expression] = STATE(792),
    [sym_subscript_expression] = STATE(792),
    [sym_call_expression] = STATE(792),
    [sym_field_expression] = STATE(792),
    [sym_compound_literal_expression] = STATE(792),
    [sym_parenthesized_expression] = STATE(792),
    [sym_concatenated_string] = STATE(792),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1873),
    [sym_char_literal] = ACTIONS(1873),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1875),
    [sym_false] = ACTIONS(1875),
    [sym_null] = ACTIONS(1875),
    [sym_identifier] = ACTIONS(1875),
    [sym_comment] = ACTIONS(42),
  },
  [494] = {
    [sym__expression] = STATE(793),
    [sym_conditional_expression] = STATE(793),
    [sym_assignment_expression] = STATE(793),
    [sym_pointer_expression] = STATE(793),
    [sym_logical_expression] = STATE(793),
    [sym_bitwise_expression] = STATE(793),
    [sym_equality_expression] = STATE(793),
    [sym_relational_expression] = STATE(793),
    [sym_shift_expression] = STATE(793),
    [sym_math_expression] = STATE(793),
    [sym_cast_expression] = STATE(793),
    [sym_sizeof_expression] = STATE(793),
    [sym_subscript_expression] = STATE(793),
    [sym_call_expression] = STATE(793),
    [sym_field_expression] = STATE(793),
    [sym_compound_literal_expression] = STATE(793),
    [sym_parenthesized_expression] = STATE(793),
    [sym_concatenated_string] = STATE(793),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1877),
    [sym_char_literal] = ACTIONS(1877),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1879),
    [sym_false] = ACTIONS(1879),
    [sym_null] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_comment] = ACTIONS(42),
  },
  [495] = {
    [sym__expression] = STATE(794),
    [sym_conditional_expression] = STATE(794),
    [sym_assignment_expression] = STATE(794),
    [sym_pointer_expression] = STATE(794),
    [sym_logical_expression] = STATE(794),
    [sym_bitwise_expression] = STATE(794),
    [sym_equality_expression] = STATE(794),
    [sym_relational_expression] = STATE(794),
    [sym_shift_expression] = STATE(794),
    [sym_math_expression] = STATE(794),
    [sym_cast_expression] = STATE(794),
    [sym_sizeof_expression] = STATE(794),
    [sym_subscript_expression] = STATE(794),
    [sym_call_expression] = STATE(794),
    [sym_field_expression] = STATE(794),
    [sym_compound_literal_expression] = STATE(794),
    [sym_parenthesized_expression] = STATE(794),
    [sym_concatenated_string] = STATE(794),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1881),
    [sym_char_literal] = ACTIONS(1881),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [sym_null] = ACTIONS(1883),
    [sym_identifier] = ACTIONS(1883),
    [sym_comment] = ACTIONS(42),
  },
  [496] = {
    [sym__expression] = STATE(795),
    [sym_conditional_expression] = STATE(795),
    [sym_assignment_expression] = STATE(795),
    [sym_pointer_expression] = STATE(795),
    [sym_logical_expression] = STATE(795),
    [sym_bitwise_expression] = STATE(795),
    [sym_equality_expression] = STATE(795),
    [sym_relational_expression] = STATE(795),
    [sym_shift_expression] = STATE(795),
    [sym_math_expression] = STATE(795),
    [sym_cast_expression] = STATE(795),
    [sym_sizeof_expression] = STATE(795),
    [sym_subscript_expression] = STATE(795),
    [sym_call_expression] = STATE(795),
    [sym_field_expression] = STATE(795),
    [sym_compound_literal_expression] = STATE(795),
    [sym_parenthesized_expression] = STATE(795),
    [sym_concatenated_string] = STATE(795),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1885),
    [sym_char_literal] = ACTIONS(1885),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1887),
    [sym_false] = ACTIONS(1887),
    [sym_null] = ACTIONS(1887),
    [sym_identifier] = ACTIONS(1887),
    [sym_comment] = ACTIONS(42),
  },
  [497] = {
    [sym__expression] = STATE(796),
    [sym_conditional_expression] = STATE(796),
    [sym_assignment_expression] = STATE(796),
    [sym_pointer_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_bitwise_expression] = STATE(796),
    [sym_equality_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_shift_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_cast_expression] = STATE(796),
    [sym_sizeof_expression] = STATE(796),
    [sym_subscript_expression] = STATE(796),
    [sym_call_expression] = STATE(796),
    [sym_field_expression] = STATE(796),
    [sym_compound_literal_expression] = STATE(796),
    [sym_parenthesized_expression] = STATE(796),
    [sym_concatenated_string] = STATE(796),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1889),
    [sym_char_literal] = ACTIONS(1889),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1891),
    [sym_false] = ACTIONS(1891),
    [sym_null] = ACTIONS(1891),
    [sym_identifier] = ACTIONS(1891),
    [sym_comment] = ACTIONS(42),
  },
  [498] = {
    [sym__expression] = STATE(797),
    [sym_conditional_expression] = STATE(797),
    [sym_assignment_expression] = STATE(797),
    [sym_pointer_expression] = STATE(797),
    [sym_logical_expression] = STATE(797),
    [sym_bitwise_expression] = STATE(797),
    [sym_equality_expression] = STATE(797),
    [sym_relational_expression] = STATE(797),
    [sym_shift_expression] = STATE(797),
    [sym_math_expression] = STATE(797),
    [sym_cast_expression] = STATE(797),
    [sym_sizeof_expression] = STATE(797),
    [sym_subscript_expression] = STATE(797),
    [sym_call_expression] = STATE(797),
    [sym_field_expression] = STATE(797),
    [sym_compound_literal_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_concatenated_string] = STATE(797),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1893),
    [sym_char_literal] = ACTIONS(1893),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1895),
    [sym_false] = ACTIONS(1895),
    [sym_null] = ACTIONS(1895),
    [sym_identifier] = ACTIONS(1895),
    [sym_comment] = ACTIONS(42),
  },
  [499] = {
    [sym__expression] = STATE(798),
    [sym_conditional_expression] = STATE(798),
    [sym_assignment_expression] = STATE(798),
    [sym_pointer_expression] = STATE(798),
    [sym_logical_expression] = STATE(798),
    [sym_bitwise_expression] = STATE(798),
    [sym_equality_expression] = STATE(798),
    [sym_relational_expression] = STATE(798),
    [sym_shift_expression] = STATE(798),
    [sym_math_expression] = STATE(798),
    [sym_cast_expression] = STATE(798),
    [sym_sizeof_expression] = STATE(798),
    [sym_subscript_expression] = STATE(798),
    [sym_call_expression] = STATE(798),
    [sym_field_expression] = STATE(798),
    [sym_compound_literal_expression] = STATE(798),
    [sym_parenthesized_expression] = STATE(798),
    [sym_concatenated_string] = STATE(798),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1897),
    [sym_char_literal] = ACTIONS(1897),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1899),
    [sym_false] = ACTIONS(1899),
    [sym_null] = ACTIONS(1899),
    [sym_identifier] = ACTIONS(1899),
    [sym_comment] = ACTIONS(42),
  },
  [500] = {
    [sym__expression] = STATE(799),
    [sym_conditional_expression] = STATE(799),
    [sym_assignment_expression] = STATE(799),
    [sym_pointer_expression] = STATE(799),
    [sym_logical_expression] = STATE(799),
    [sym_bitwise_expression] = STATE(799),
    [sym_equality_expression] = STATE(799),
    [sym_relational_expression] = STATE(799),
    [sym_shift_expression] = STATE(799),
    [sym_math_expression] = STATE(799),
    [sym_cast_expression] = STATE(799),
    [sym_sizeof_expression] = STATE(799),
    [sym_subscript_expression] = STATE(799),
    [sym_call_expression] = STATE(799),
    [sym_field_expression] = STATE(799),
    [sym_compound_literal_expression] = STATE(799),
    [sym_parenthesized_expression] = STATE(799),
    [sym_concatenated_string] = STATE(799),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1901),
    [sym_char_literal] = ACTIONS(1901),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1903),
    [sym_false] = ACTIONS(1903),
    [sym_null] = ACTIONS(1903),
    [sym_identifier] = ACTIONS(1903),
    [sym_comment] = ACTIONS(42),
  },
  [501] = {
    [anon_sym_LPAREN] = ACTIONS(1821),
    [anon_sym_COMMA] = ACTIONS(1821),
    [anon_sym_RPAREN] = ACTIONS(1821),
    [anon_sym_SEMI] = ACTIONS(1821),
    [anon_sym_RBRACE] = ACTIONS(1821),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(1821),
    [anon_sym_RBRACK] = ACTIONS(1821),
    [anon_sym_EQ] = ACTIONS(1823),
    [anon_sym_COLON] = ACTIONS(1821),
    [anon_sym_QMARK] = ACTIONS(1821),
    [anon_sym_STAR_EQ] = ACTIONS(1821),
    [anon_sym_SLASH_EQ] = ACTIONS(1821),
    [anon_sym_PERCENT_EQ] = ACTIONS(1821),
    [anon_sym_PLUS_EQ] = ACTIONS(1821),
    [anon_sym_DASH_EQ] = ACTIONS(1821),
    [anon_sym_LT_LT_EQ] = ACTIONS(1821),
    [anon_sym_GT_GT_EQ] = ACTIONS(1821),
    [anon_sym_AMP_EQ] = ACTIONS(1821),
    [anon_sym_CARET_EQ] = ACTIONS(1821),
    [anon_sym_PIPE_EQ] = ACTIONS(1821),
    [anon_sym_AMP] = ACTIONS(1823),
    [anon_sym_PIPE_PIPE] = ACTIONS(1821),
    [anon_sym_AMP_AMP] = ACTIONS(1821),
    [anon_sym_PIPE] = ACTIONS(1823),
    [anon_sym_CARET] = ACTIONS(1823),
    [anon_sym_EQ_EQ] = ACTIONS(1821),
    [anon_sym_BANG_EQ] = ACTIONS(1821),
    [anon_sym_LT] = ACTIONS(1823),
    [anon_sym_GT] = ACTIONS(1823),
    [anon_sym_LT_EQ] = ACTIONS(1821),
    [anon_sym_GT_EQ] = ACTIONS(1821),
    [anon_sym_LT_LT] = ACTIONS(1823),
    [anon_sym_GT_GT] = ACTIONS(1823),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_SLASH] = ACTIONS(1823),
    [anon_sym_PERCENT] = ACTIONS(1823),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DOT] = ACTIONS(1821),
    [anon_sym_DASH_GT] = ACTIONS(1821),
    [sym_comment] = ACTIONS(42),
  },
  [502] = {
    [sym_identifier] = ACTIONS(1905),
    [sym_comment] = ACTIONS(42),
  },
  [503] = {
    [anon_sym_LPAREN] = ACTIONS(1907),
    [anon_sym_COMMA] = ACTIONS(1907),
    [anon_sym_RPAREN] = ACTIONS(1907),
    [anon_sym_SEMI] = ACTIONS(1907),
    [anon_sym_RBRACE] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1907),
    [anon_sym_RBRACK] = ACTIONS(1907),
    [anon_sym_EQ] = ACTIONS(1909),
    [anon_sym_COLON] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(1907),
    [anon_sym_STAR_EQ] = ACTIONS(1907),
    [anon_sym_SLASH_EQ] = ACTIONS(1907),
    [anon_sym_PERCENT_EQ] = ACTIONS(1907),
    [anon_sym_PLUS_EQ] = ACTIONS(1907),
    [anon_sym_DASH_EQ] = ACTIONS(1907),
    [anon_sym_LT_LT_EQ] = ACTIONS(1907),
    [anon_sym_GT_GT_EQ] = ACTIONS(1907),
    [anon_sym_AMP_EQ] = ACTIONS(1907),
    [anon_sym_CARET_EQ] = ACTIONS(1907),
    [anon_sym_PIPE_EQ] = ACTIONS(1907),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_PIPE_PIPE] = ACTIONS(1907),
    [anon_sym_AMP_AMP] = ACTIONS(1907),
    [anon_sym_PIPE] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1909),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1907),
    [anon_sym_LT] = ACTIONS(1909),
    [anon_sym_GT] = ACTIONS(1909),
    [anon_sym_LT_EQ] = ACTIONS(1907),
    [anon_sym_GT_EQ] = ACTIONS(1907),
    [anon_sym_LT_LT] = ACTIONS(1909),
    [anon_sym_GT_GT] = ACTIONS(1909),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_SLASH] = ACTIONS(1909),
    [anon_sym_PERCENT] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1907),
    [anon_sym_PLUS_PLUS] = ACTIONS(1907),
    [anon_sym_DOT] = ACTIONS(1907),
    [anon_sym_DASH_GT] = ACTIONS(1907),
    [sym_comment] = ACTIONS(42),
  },
  [504] = {
    [ts_builtin_sym_end] = ACTIONS(1911),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym_RBRACE] = ACTIONS(1911),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_auto] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(42),
  },
  [505] = {
    [sym_preproc_include] = STATE(505),
    [sym_preproc_def] = STATE(505),
    [sym_preproc_function_def] = STATE(505),
    [sym_preproc_call] = STATE(505),
    [sym_preproc_if_in_compound_statement] = STATE(275),
    [sym_preproc_ifdef_in_compound_statement] = STATE(276),
    [sym_declaration] = STATE(505),
    [sym_type_definition] = STATE(505),
    [sym__declaration_specifiers] = STATE(277),
    [sym_compound_statement] = STATE(505),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(505),
    [sym_expression_statement] = STATE(505),
    [sym_if_statement] = STATE(505),
    [sym_switch_statement] = STATE(505),
    [sym_case_statement] = STATE(505),
    [sym_while_statement] = STATE(505),
    [sym_do_statement] = STATE(505),
    [sym_for_statement] = STATE(505),
    [sym_return_statement] = STATE(505),
    [sym_break_statement] = STATE(505),
    [sym_continue_statement] = STATE(505),
    [sym_goto_statement] = STATE(505),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [sym__empty_declaration] = STATE(505),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(505),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1915),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1918),
    [anon_sym_LPAREN] = ACTIONS(1921),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1924),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1927),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1930),
    [sym_preproc_directive] = ACTIONS(1933),
    [anon_sym_SEMI] = ACTIONS(1936),
    [anon_sym_typedef] = ACTIONS(1939),
    [anon_sym_extern] = ACTIONS(1942),
    [anon_sym_LBRACE] = ACTIONS(1945),
    [anon_sym_RBRACE] = ACTIONS(1948),
    [anon_sym_STAR] = ACTIONS(1950),
    [anon_sym_static] = ACTIONS(1942),
    [anon_sym_auto] = ACTIONS(1942),
    [anon_sym_register] = ACTIONS(1942),
    [anon_sym_inline] = ACTIONS(1942),
    [anon_sym_const] = ACTIONS(1953),
    [anon_sym_restrict] = ACTIONS(1953),
    [anon_sym_volatile] = ACTIONS(1953),
    [anon_sym__Atomic] = ACTIONS(1953),
    [anon_sym_unsigned] = ACTIONS(1956),
    [anon_sym_long] = ACTIONS(1956),
    [anon_sym_short] = ACTIONS(1956),
    [sym_primitive_type] = ACTIONS(1959),
    [anon_sym_enum] = ACTIONS(1962),
    [anon_sym_struct] = ACTIONS(1965),
    [anon_sym_union] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1971),
    [anon_sym_switch] = ACTIONS(1974),
    [anon_sym_case] = ACTIONS(1977),
    [anon_sym_default] = ACTIONS(1980),
    [anon_sym_while] = ACTIONS(1983),
    [anon_sym_do] = ACTIONS(1986),
    [anon_sym_for] = ACTIONS(1989),
    [anon_sym_return] = ACTIONS(1992),
    [anon_sym_break] = ACTIONS(1995),
    [anon_sym_continue] = ACTIONS(1998),
    [anon_sym_goto] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(1950),
    [anon_sym_BANG] = ACTIONS(2004),
    [anon_sym_TILDE] = ACTIONS(2007),
    [anon_sym_PLUS] = ACTIONS(2010),
    [anon_sym_DASH] = ACTIONS(2010),
    [anon_sym_DASH_DASH] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2013),
    [anon_sym_sizeof] = ACTIONS(2016),
    [sym_number_literal] = ACTIONS(2019),
    [sym_char_literal] = ACTIONS(2019),
    [sym_string_literal] = ACTIONS(2022),
    [sym_true] = ACTIONS(2025),
    [sym_false] = ACTIONS(2025),
    [sym_null] = ACTIONS(2025),
    [sym_identifier] = ACTIONS(2028),
    [sym_comment] = ACTIONS(42),
  },
  [506] = {
    [anon_sym_RPAREN] = ACTIONS(2031),
    [sym_comment] = ACTIONS(42),
  },
  [507] = {
    [sym_enumerator] = STATE(804),
    [anon_sym_COMMA] = ACTIONS(2033),
    [anon_sym_RBRACE] = ACTIONS(2035),
    [sym_identifier] = ACTIONS(210),
    [sym_comment] = ACTIONS(42),
  },
  [508] = {
    [sym_enumerator_list] = STATE(805),
    [anon_sym_LPAREN] = ACTIONS(212),
    [anon_sym_extern] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(212),
    [anon_sym_RBRACK] = ACTIONS(212),
    [anon_sym_static] = ACTIONS(214),
    [anon_sym_auto] = ACTIONS(214),
    [anon_sym_register] = ACTIONS(214),
    [anon_sym_inline] = ACTIONS(214),
    [anon_sym_const] = ACTIONS(214),
    [anon_sym_restrict] = ACTIONS(214),
    [anon_sym_volatile] = ACTIONS(214),
    [anon_sym__Atomic] = ACTIONS(214),
    [anon_sym_AMP] = ACTIONS(212),
    [anon_sym_BANG] = ACTIONS(212),
    [anon_sym_TILDE] = ACTIONS(212),
    [anon_sym_PLUS] = ACTIONS(214),
    [anon_sym_DASH] = ACTIONS(214),
    [anon_sym_DASH_DASH] = ACTIONS(212),
    [anon_sym_PLUS_PLUS] = ACTIONS(212),
    [anon_sym_sizeof] = ACTIONS(214),
    [sym_number_literal] = ACTIONS(212),
    [sym_char_literal] = ACTIONS(212),
    [sym_string_literal] = ACTIONS(212),
    [sym_true] = ACTIONS(214),
    [sym_false] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [sym_identifier] = ACTIONS(214),
    [sym_comment] = ACTIONS(42),
  },
  [509] = {
    [anon_sym_LPAREN] = ACTIONS(216),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(216),
    [anon_sym_RBRACK] = ACTIONS(216),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_auto] = ACTIONS(218),
    [anon_sym_register] = ACTIONS(218),
    [anon_sym_inline] = ACTIONS(218),
    [anon_sym_const] = ACTIONS(218),
    [anon_sym_restrict] = ACTIONS(218),
    [anon_sym_volatile] = ACTIONS(218),
    [anon_sym__Atomic] = ACTIONS(218),
    [anon_sym_AMP] = ACTIONS(216),
    [anon_sym_BANG] = ACTIONS(216),
    [anon_sym_TILDE] = ACTIONS(216),
    [anon_sym_PLUS] = ACTIONS(218),
    [anon_sym_DASH] = ACTIONS(218),
    [anon_sym_DASH_DASH] = ACTIONS(216),
    [anon_sym_PLUS_PLUS] = ACTIONS(216),
    [anon_sym_sizeof] = ACTIONS(218),
    [sym_number_literal] = ACTIONS(216),
    [sym_char_literal] = ACTIONS(216),
    [sym_string_literal] = ACTIONS(216),
    [sym_true] = ACTIONS(218),
    [sym_false] = ACTIONS(218),
    [sym_null] = ACTIONS(218),
    [sym_identifier] = ACTIONS(218),
    [sym_comment] = ACTIONS(42),
  },
  [510] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(122),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(123),
    [sym__declaration_specifiers] = STATE(124),
    [sym_storage_class_specifier] = STATE(126),
    [sym_type_qualifier] = STATE(126),
    [sym__type_specifier] = STATE(125),
    [sym_sized_type_specifier] = STATE(125),
    [sym_enum_specifier] = STATE(125),
    [sym_struct_specifier] = STATE(125),
    [sym_union_specifier] = STATE(125),
    [sym_field_declaration] = STATE(807),
    [sym_macro_type_specifier] = STATE(125),
    [aux_sym__declaration_specifiers_repeat1] = STATE(126),
    [aux_sym_sized_type_specifier_repeat1] = STATE(127),
    [aux_sym_field_declaration_list_repeat1] = STATE(807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(220),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(224),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_RBRACE] = ACTIONS(2037),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(228),
    [anon_sym_long] = ACTIONS(228),
    [anon_sym_short] = ACTIONS(228),
    [sym_primitive_type] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [511] = {
    [sym_field_declaration_list] = STATE(808),
    [anon_sym_LPAREN] = ACTIONS(232),
    [anon_sym_extern] = ACTIONS(234),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_STAR] = ACTIONS(232),
    [anon_sym_RBRACK] = ACTIONS(232),
    [anon_sym_static] = ACTIONS(234),
    [anon_sym_auto] = ACTIONS(234),
    [anon_sym_register] = ACTIONS(234),
    [anon_sym_inline] = ACTIONS(234),
    [anon_sym_const] = ACTIONS(234),
    [anon_sym_restrict] = ACTIONS(234),
    [anon_sym_volatile] = ACTIONS(234),
    [anon_sym__Atomic] = ACTIONS(234),
    [anon_sym_AMP] = ACTIONS(232),
    [anon_sym_BANG] = ACTIONS(232),
    [anon_sym_TILDE] = ACTIONS(232),
    [anon_sym_PLUS] = ACTIONS(234),
    [anon_sym_DASH] = ACTIONS(234),
    [anon_sym_DASH_DASH] = ACTIONS(232),
    [anon_sym_PLUS_PLUS] = ACTIONS(232),
    [anon_sym_sizeof] = ACTIONS(234),
    [sym_number_literal] = ACTIONS(232),
    [sym_char_literal] = ACTIONS(232),
    [sym_string_literal] = ACTIONS(232),
    [sym_true] = ACTIONS(234),
    [sym_false] = ACTIONS(234),
    [sym_null] = ACTIONS(234),
    [sym_identifier] = ACTIONS(234),
    [sym_comment] = ACTIONS(42),
  },
  [512] = {
    [anon_sym_LPAREN] = ACTIONS(236),
    [anon_sym_extern] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(236),
    [anon_sym_RBRACK] = ACTIONS(236),
    [anon_sym_static] = ACTIONS(238),
    [anon_sym_auto] = ACTIONS(238),
    [anon_sym_register] = ACTIONS(238),
    [anon_sym_inline] = ACTIONS(238),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_restrict] = ACTIONS(238),
    [anon_sym_volatile] = ACTIONS(238),
    [anon_sym__Atomic] = ACTIONS(238),
    [anon_sym_AMP] = ACTIONS(236),
    [anon_sym_BANG] = ACTIONS(236),
    [anon_sym_TILDE] = ACTIONS(236),
    [anon_sym_PLUS] = ACTIONS(238),
    [anon_sym_DASH] = ACTIONS(238),
    [anon_sym_DASH_DASH] = ACTIONS(236),
    [anon_sym_PLUS_PLUS] = ACTIONS(236),
    [anon_sym_sizeof] = ACTIONS(238),
    [sym_number_literal] = ACTIONS(236),
    [sym_char_literal] = ACTIONS(236),
    [sym_string_literal] = ACTIONS(236),
    [sym_true] = ACTIONS(238),
    [sym_false] = ACTIONS(238),
    [sym_null] = ACTIONS(238),
    [sym_identifier] = ACTIONS(238),
    [sym_comment] = ACTIONS(42),
  },
  [513] = {
    [sym_field_declaration_list] = STATE(809),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_extern] = ACTIONS(242),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_STAR] = ACTIONS(240),
    [anon_sym_RBRACK] = ACTIONS(240),
    [anon_sym_static] = ACTIONS(242),
    [anon_sym_auto] = ACTIONS(242),
    [anon_sym_register] = ACTIONS(242),
    [anon_sym_inline] = ACTIONS(242),
    [anon_sym_const] = ACTIONS(242),
    [anon_sym_restrict] = ACTIONS(242),
    [anon_sym_volatile] = ACTIONS(242),
    [anon_sym__Atomic] = ACTIONS(242),
    [anon_sym_AMP] = ACTIONS(240),
    [anon_sym_BANG] = ACTIONS(240),
    [anon_sym_TILDE] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_DASH_DASH] = ACTIONS(240),
    [anon_sym_PLUS_PLUS] = ACTIONS(240),
    [anon_sym_sizeof] = ACTIONS(242),
    [sym_number_literal] = ACTIONS(240),
    [sym_char_literal] = ACTIONS(240),
    [sym_string_literal] = ACTIONS(240),
    [sym_true] = ACTIONS(242),
    [sym_false] = ACTIONS(242),
    [sym_null] = ACTIONS(242),
    [sym_identifier] = ACTIONS(242),
    [sym_comment] = ACTIONS(42),
  },
  [514] = {
    [anon_sym_LPAREN] = ACTIONS(244),
    [anon_sym_extern] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(244),
    [anon_sym_RBRACK] = ACTIONS(244),
    [anon_sym_static] = ACTIONS(246),
    [anon_sym_auto] = ACTIONS(246),
    [anon_sym_register] = ACTIONS(246),
    [anon_sym_inline] = ACTIONS(246),
    [anon_sym_const] = ACTIONS(246),
    [anon_sym_restrict] = ACTIONS(246),
    [anon_sym_volatile] = ACTIONS(246),
    [anon_sym__Atomic] = ACTIONS(246),
    [anon_sym_AMP] = ACTIONS(244),
    [anon_sym_BANG] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(244),
    [anon_sym_PLUS] = ACTIONS(246),
    [anon_sym_DASH] = ACTIONS(246),
    [anon_sym_DASH_DASH] = ACTIONS(244),
    [anon_sym_PLUS_PLUS] = ACTIONS(244),
    [anon_sym_sizeof] = ACTIONS(246),
    [sym_number_literal] = ACTIONS(244),
    [sym_char_literal] = ACTIONS(244),
    [sym_string_literal] = ACTIONS(244),
    [sym_true] = ACTIONS(246),
    [sym_false] = ACTIONS(246),
    [sym_null] = ACTIONS(246),
    [sym_identifier] = ACTIONS(246),
    [sym_comment] = ACTIONS(42),
  },
  [515] = {
    [sym_type_qualifier] = STATE(133),
    [sym__type_specifier] = STATE(131),
    [sym_sized_type_specifier] = STATE(131),
    [sym_enum_specifier] = STATE(131),
    [sym_struct_specifier] = STATE(131),
    [sym_union_specifier] = STATE(131),
    [sym__expression] = STATE(436),
    [sym_comma_expression] = STATE(437),
    [sym_conditional_expression] = STATE(436),
    [sym_assignment_expression] = STATE(436),
    [sym_pointer_expression] = STATE(436),
    [sym_logical_expression] = STATE(436),
    [sym_bitwise_expression] = STATE(436),
    [sym_equality_expression] = STATE(436),
    [sym_relational_expression] = STATE(436),
    [sym_shift_expression] = STATE(436),
    [sym_math_expression] = STATE(436),
    [sym_cast_expression] = STATE(436),
    [sym_type_descriptor] = STATE(810),
    [sym_sizeof_expression] = STATE(436),
    [sym_subscript_expression] = STATE(436),
    [sym_call_expression] = STATE(436),
    [sym_field_expression] = STATE(436),
    [sym_compound_literal_expression] = STATE(436),
    [sym_parenthesized_expression] = STATE(436),
    [sym_concatenated_string] = STATE(436),
    [sym_macro_type_specifier] = STATE(131),
    [aux_sym_type_definition_repeat1] = STATE(133),
    [aux_sym_sized_type_specifier_repeat1] = STATE(134),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(248),
    [anon_sym_long] = ACTIONS(248),
    [anon_sym_short] = ACTIONS(248),
    [sym_primitive_type] = ACTIONS(250),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1019),
    [sym_char_literal] = ACTIONS(1019),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(1023),
    [sym_false] = ACTIONS(1023),
    [sym_null] = ACTIONS(1023),
    [sym_identifier] = ACTIONS(1025),
    [sym_comment] = ACTIONS(42),
  },
  [516] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(1825),
    [anon_sym_EQ] = ACTIONS(1827),
    [anon_sym_QMARK] = ACTIONS(1825),
    [anon_sym_STAR_EQ] = ACTIONS(1825),
    [anon_sym_SLASH_EQ] = ACTIONS(1825),
    [anon_sym_PERCENT_EQ] = ACTIONS(1825),
    [anon_sym_PLUS_EQ] = ACTIONS(1825),
    [anon_sym_DASH_EQ] = ACTIONS(1825),
    [anon_sym_LT_LT_EQ] = ACTIONS(1825),
    [anon_sym_GT_GT_EQ] = ACTIONS(1825),
    [anon_sym_AMP_EQ] = ACTIONS(1825),
    [anon_sym_CARET_EQ] = ACTIONS(1825),
    [anon_sym_PIPE_EQ] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1827),
    [anon_sym_PIPE_PIPE] = ACTIONS(1825),
    [anon_sym_AMP_AMP] = ACTIONS(1825),
    [anon_sym_PIPE] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1827),
    [anon_sym_EQ_EQ] = ACTIONS(1825),
    [anon_sym_BANG_EQ] = ACTIONS(1825),
    [anon_sym_LT] = ACTIONS(1827),
    [anon_sym_GT] = ACTIONS(1827),
    [anon_sym_LT_EQ] = ACTIONS(1825),
    [anon_sym_GT_EQ] = ACTIONS(1825),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [517] = {
    [aux_sym_concatenated_string_repeat1] = STATE(811),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_STAR] = ACTIONS(1831),
    [anon_sym_LBRACK] = ACTIONS(1829),
    [anon_sym_RBRACK] = ACTIONS(1829),
    [anon_sym_EQ] = ACTIONS(1831),
    [anon_sym_QMARK] = ACTIONS(1829),
    [anon_sym_STAR_EQ] = ACTIONS(1829),
    [anon_sym_SLASH_EQ] = ACTIONS(1829),
    [anon_sym_PERCENT_EQ] = ACTIONS(1829),
    [anon_sym_PLUS_EQ] = ACTIONS(1829),
    [anon_sym_DASH_EQ] = ACTIONS(1829),
    [anon_sym_LT_LT_EQ] = ACTIONS(1829),
    [anon_sym_GT_GT_EQ] = ACTIONS(1829),
    [anon_sym_AMP_EQ] = ACTIONS(1829),
    [anon_sym_CARET_EQ] = ACTIONS(1829),
    [anon_sym_PIPE_EQ] = ACTIONS(1829),
    [anon_sym_AMP] = ACTIONS(1831),
    [anon_sym_PIPE_PIPE] = ACTIONS(1829),
    [anon_sym_AMP_AMP] = ACTIONS(1829),
    [anon_sym_PIPE] = ACTIONS(1831),
    [anon_sym_CARET] = ACTIONS(1831),
    [anon_sym_EQ_EQ] = ACTIONS(1829),
    [anon_sym_BANG_EQ] = ACTIONS(1829),
    [anon_sym_LT] = ACTIONS(1831),
    [anon_sym_GT] = ACTIONS(1831),
    [anon_sym_LT_EQ] = ACTIONS(1829),
    [anon_sym_GT_EQ] = ACTIONS(1829),
    [anon_sym_LT_LT] = ACTIONS(1831),
    [anon_sym_GT_GT] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_SLASH] = ACTIONS(1831),
    [anon_sym_PERCENT] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1829),
    [anon_sym_PLUS_PLUS] = ACTIONS(1829),
    [anon_sym_DOT] = ACTIONS(1829),
    [anon_sym_DASH_GT] = ACTIONS(1829),
    [sym_string_literal] = ACTIONS(2039),
    [sym_comment] = ACTIONS(42),
  },
  [518] = {
    [sym_type_qualifier] = STATE(133),
    [sym__type_specifier] = STATE(131),
    [sym_sized_type_specifier] = STATE(131),
    [sym_enum_specifier] = STATE(131),
    [sym_struct_specifier] = STATE(131),
    [sym_union_specifier] = STATE(131),
    [sym_type_descriptor] = STATE(812),
    [sym_macro_type_specifier] = STATE(131),
    [aux_sym_type_definition_repeat1] = STATE(133),
    [aux_sym_sized_type_specifier_repeat1] = STATE(134),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(248),
    [anon_sym_long] = ACTIONS(248),
    [anon_sym_short] = ACTIONS(248),
    [sym_primitive_type] = ACTIONS(250),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [519] = {
    [anon_sym_LPAREN] = ACTIONS(2041),
    [anon_sym_COMMA] = ACTIONS(2041),
    [anon_sym_RPAREN] = ACTIONS(2041),
    [anon_sym_SEMI] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2041),
    [anon_sym_LBRACK] = ACTIONS(2041),
    [anon_sym_EQ] = ACTIONS(2041),
    [sym_comment] = ACTIONS(42),
  },
  [520] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2043),
    [anon_sym_EQ] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1237),
    [anon_sym_STAR_EQ] = ACTIONS(1239),
    [anon_sym_SLASH_EQ] = ACTIONS(1239),
    [anon_sym_PERCENT_EQ] = ACTIONS(1239),
    [anon_sym_PLUS_EQ] = ACTIONS(1239),
    [anon_sym_DASH_EQ] = ACTIONS(1239),
    [anon_sym_LT_LT_EQ] = ACTIONS(1239),
    [anon_sym_GT_GT_EQ] = ACTIONS(1239),
    [anon_sym_AMP_EQ] = ACTIONS(1239),
    [anon_sym_CARET_EQ] = ACTIONS(1239),
    [anon_sym_PIPE_EQ] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_PIPE_PIPE] = ACTIONS(1243),
    [anon_sym_AMP_AMP] = ACTIONS(1245),
    [anon_sym_PIPE] = ACTIONS(1247),
    [anon_sym_CARET] = ACTIONS(1249),
    [anon_sym_EQ_EQ] = ACTIONS(1251),
    [anon_sym_BANG_EQ] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1253),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [521] = {
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_extern] = ACTIONS(74),
    [anon_sym_STAR] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(274),
    [anon_sym_static] = ACTIONS(74),
    [anon_sym_auto] = ACTIONS(74),
    [anon_sym_register] = ACTIONS(74),
    [anon_sym_inline] = ACTIONS(74),
    [anon_sym_const] = ACTIONS(74),
    [anon_sym_restrict] = ACTIONS(74),
    [anon_sym_volatile] = ACTIONS(74),
    [anon_sym__Atomic] = ACTIONS(74),
    [anon_sym_AMP] = ACTIONS(274),
    [anon_sym_BANG] = ACTIONS(274),
    [anon_sym_TILDE] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(74),
    [anon_sym_DASH] = ACTIONS(74),
    [anon_sym_DASH_DASH] = ACTIONS(274),
    [anon_sym_PLUS_PLUS] = ACTIONS(274),
    [anon_sym_sizeof] = ACTIONS(74),
    [sym_number_literal] = ACTIONS(274),
    [sym_char_literal] = ACTIONS(274),
    [sym_string_literal] = ACTIONS(274),
    [sym_true] = ACTIONS(74),
    [sym_false] = ACTIONS(74),
    [sym_null] = ACTIONS(74),
    [sym_identifier] = ACTIONS(74),
    [sym_comment] = ACTIONS(42),
  },
  [522] = {
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_extern] = ACTIONS(78),
    [anon_sym_STAR] = ACTIONS(276),
    [anon_sym_RBRACK] = ACTIONS(276),
    [anon_sym_static] = ACTIONS(78),
    [anon_sym_auto] = ACTIONS(78),
    [anon_sym_register] = ACTIONS(78),
    [anon_sym_inline] = ACTIONS(78),
    [anon_sym_const] = ACTIONS(78),
    [anon_sym_restrict] = ACTIONS(78),
    [anon_sym_volatile] = ACTIONS(78),
    [anon_sym__Atomic] = ACTIONS(78),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_BANG] = ACTIONS(276),
    [anon_sym_TILDE] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(78),
    [anon_sym_DASH] = ACTIONS(78),
    [anon_sym_DASH_DASH] = ACTIONS(276),
    [anon_sym_PLUS_PLUS] = ACTIONS(276),
    [anon_sym_sizeof] = ACTIONS(78),
    [sym_number_literal] = ACTIONS(276),
    [sym_char_literal] = ACTIONS(276),
    [sym_string_literal] = ACTIONS(276),
    [sym_true] = ACTIONS(78),
    [sym_false] = ACTIONS(78),
    [sym_null] = ACTIONS(78),
    [sym_identifier] = ACTIONS(78),
    [sym_comment] = ACTIONS(42),
  },
  [523] = {
    [sym_storage_class_specifier] = STATE(814),
    [sym_type_qualifier] = STATE(814),
    [aux_sym__declaration_specifiers_repeat1] = STATE(814),
    [anon_sym_LPAREN] = ACTIONS(278),
    [anon_sym_extern] = ACTIONS(1229),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_RBRACK] = ACTIONS(278),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_auto] = ACTIONS(1229),
    [anon_sym_register] = ACTIONS(1229),
    [anon_sym_inline] = ACTIONS(1229),
    [anon_sym_const] = ACTIONS(1231),
    [anon_sym_restrict] = ACTIONS(1231),
    [anon_sym_volatile] = ACTIONS(1231),
    [anon_sym__Atomic] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(278),
    [anon_sym_TILDE] = ACTIONS(278),
    [anon_sym_PLUS] = ACTIONS(280),
    [anon_sym_DASH] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(278),
    [anon_sym_sizeof] = ACTIONS(280),
    [sym_number_literal] = ACTIONS(278),
    [sym_char_literal] = ACTIONS(278),
    [sym_string_literal] = ACTIONS(278),
    [sym_true] = ACTIONS(280),
    [sym_false] = ACTIONS(280),
    [sym_null] = ACTIONS(280),
    [sym_identifier] = ACTIONS(280),
    [sym_comment] = ACTIONS(42),
  },
  [524] = {
    [sym__expression] = STATE(787),
    [sym_conditional_expression] = STATE(787),
    [sym_assignment_expression] = STATE(787),
    [sym_pointer_expression] = STATE(787),
    [sym_logical_expression] = STATE(787),
    [sym_bitwise_expression] = STATE(787),
    [sym_equality_expression] = STATE(787),
    [sym_relational_expression] = STATE(787),
    [sym_shift_expression] = STATE(787),
    [sym_math_expression] = STATE(787),
    [sym_cast_expression] = STATE(787),
    [sym_sizeof_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_call_expression] = STATE(787),
    [sym_field_expression] = STATE(787),
    [sym_compound_literal_expression] = STATE(787),
    [sym_parenthesized_expression] = STATE(787),
    [sym_concatenated_string] = STATE(787),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(1853),
    [sym_char_literal] = ACTIONS(1853),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(1855),
    [sym_false] = ACTIONS(1855),
    [sym_null] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_comment] = ACTIONS(42),
  },
  [525] = {
    [sym__expression] = STATE(815),
    [sym_conditional_expression] = STATE(815),
    [sym_assignment_expression] = STATE(815),
    [sym_pointer_expression] = STATE(815),
    [sym_logical_expression] = STATE(815),
    [sym_bitwise_expression] = STATE(815),
    [sym_equality_expression] = STATE(815),
    [sym_relational_expression] = STATE(815),
    [sym_shift_expression] = STATE(815),
    [sym_math_expression] = STATE(815),
    [sym_cast_expression] = STATE(815),
    [sym_sizeof_expression] = STATE(815),
    [sym_subscript_expression] = STATE(815),
    [sym_call_expression] = STATE(815),
    [sym_field_expression] = STATE(815),
    [sym_compound_literal_expression] = STATE(815),
    [sym_parenthesized_expression] = STATE(815),
    [sym_concatenated_string] = STATE(815),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(2045),
    [sym_char_literal] = ACTIONS(2045),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(2047),
    [sym_false] = ACTIONS(2047),
    [sym_null] = ACTIONS(2047),
    [sym_identifier] = ACTIONS(2047),
    [sym_comment] = ACTIONS(42),
  },
  [526] = {
    [sym__expression] = STATE(816),
    [sym_conditional_expression] = STATE(816),
    [sym_assignment_expression] = STATE(816),
    [sym_pointer_expression] = STATE(816),
    [sym_logical_expression] = STATE(816),
    [sym_bitwise_expression] = STATE(816),
    [sym_equality_expression] = STATE(816),
    [sym_relational_expression] = STATE(816),
    [sym_shift_expression] = STATE(816),
    [sym_math_expression] = STATE(816),
    [sym_cast_expression] = STATE(816),
    [sym_sizeof_expression] = STATE(816),
    [sym_subscript_expression] = STATE(816),
    [sym_call_expression] = STATE(816),
    [sym_field_expression] = STATE(816),
    [sym_compound_literal_expression] = STATE(816),
    [sym_parenthesized_expression] = STATE(816),
    [sym_concatenated_string] = STATE(816),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(2049),
    [sym_char_literal] = ACTIONS(2049),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(2051),
    [sym_false] = ACTIONS(2051),
    [sym_null] = ACTIONS(2051),
    [sym_identifier] = ACTIONS(2051),
    [sym_comment] = ACTIONS(42),
  },
  [527] = {
    [sym__expression] = STATE(817),
    [sym_conditional_expression] = STATE(817),
    [sym_assignment_expression] = STATE(817),
    [sym_pointer_expression] = STATE(817),
    [sym_logical_expression] = STATE(817),
    [sym_bitwise_expression] = STATE(817),
    [sym_equality_expression] = STATE(817),
    [sym_relational_expression] = STATE(817),
    [sym_shift_expression] = STATE(817),
    [sym_math_expression] = STATE(817),
    [sym_cast_expression] = STATE(817),
    [sym_sizeof_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_call_expression] = STATE(817),
    [sym_field_expression] = STATE(817),
    [sym_compound_literal_expression] = STATE(817),
    [sym_parenthesized_expression] = STATE(817),
    [sym_concatenated_string] = STATE(817),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(2053),
    [sym_char_literal] = ACTIONS(2053),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(2055),
    [sym_false] = ACTIONS(2055),
    [sym_null] = ACTIONS(2055),
    [sym_identifier] = ACTIONS(2055),
    [sym_comment] = ACTIONS(42),
  },
  [528] = {
    [sym__expression] = STATE(818),
    [sym_conditional_expression] = STATE(818),
    [sym_assignment_expression] = STATE(818),
    [sym_pointer_expression] = STATE(818),
    [sym_logical_expression] = STATE(818),
    [sym_bitwise_expression] = STATE(818),
    [sym_equality_expression] = STATE(818),
    [sym_relational_expression] = STATE(818),
    [sym_shift_expression] = STATE(818),
    [sym_math_expression] = STATE(818),
    [sym_cast_expression] = STATE(818),
    [sym_sizeof_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_call_expression] = STATE(818),
    [sym_field_expression] = STATE(818),
    [sym_compound_literal_expression] = STATE(818),
    [sym_parenthesized_expression] = STATE(818),
    [sym_concatenated_string] = STATE(818),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(2057),
    [sym_char_literal] = ACTIONS(2057),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(2059),
    [sym_false] = ACTIONS(2059),
    [sym_null] = ACTIONS(2059),
    [sym_identifier] = ACTIONS(2059),
    [sym_comment] = ACTIONS(42),
  },
  [529] = {
    [sym__expression] = STATE(819),
    [sym_conditional_expression] = STATE(819),
    [sym_assignment_expression] = STATE(819),
    [sym_pointer_expression] = STATE(819),
    [sym_logical_expression] = STATE(819),
    [sym_bitwise_expression] = STATE(819),
    [sym_equality_expression] = STATE(819),
    [sym_relational_expression] = STATE(819),
    [sym_shift_expression] = STATE(819),
    [sym_math_expression] = STATE(819),
    [sym_cast_expression] = STATE(819),
    [sym_sizeof_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_call_expression] = STATE(819),
    [sym_field_expression] = STATE(819),
    [sym_compound_literal_expression] = STATE(819),
    [sym_parenthesized_expression] = STATE(819),
    [sym_concatenated_string] = STATE(819),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(2061),
    [sym_char_literal] = ACTIONS(2061),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(2063),
    [sym_false] = ACTIONS(2063),
    [sym_null] = ACTIONS(2063),
    [sym_identifier] = ACTIONS(2063),
    [sym_comment] = ACTIONS(42),
  },
  [530] = {
    [sym__expression] = STATE(820),
    [sym_conditional_expression] = STATE(820),
    [sym_assignment_expression] = STATE(820),
    [sym_pointer_expression] = STATE(820),
    [sym_logical_expression] = STATE(820),
    [sym_bitwise_expression] = STATE(820),
    [sym_equality_expression] = STATE(820),
    [sym_relational_expression] = STATE(820),
    [sym_shift_expression] = STATE(820),
    [sym_math_expression] = STATE(820),
    [sym_cast_expression] = STATE(820),
    [sym_sizeof_expression] = STATE(820),
    [sym_subscript_expression] = STATE(820),
    [sym_call_expression] = STATE(820),
    [sym_field_expression] = STATE(820),
    [sym_compound_literal_expression] = STATE(820),
    [sym_parenthesized_expression] = STATE(820),
    [sym_concatenated_string] = STATE(820),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(2065),
    [sym_char_literal] = ACTIONS(2065),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_identifier] = ACTIONS(2067),
    [sym_comment] = ACTIONS(42),
  },
  [531] = {
    [sym__expression] = STATE(821),
    [sym_conditional_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_pointer_expression] = STATE(821),
    [sym_logical_expression] = STATE(821),
    [sym_bitwise_expression] = STATE(821),
    [sym_equality_expression] = STATE(821),
    [sym_relational_expression] = STATE(821),
    [sym_shift_expression] = STATE(821),
    [sym_math_expression] = STATE(821),
    [sym_cast_expression] = STATE(821),
    [sym_sizeof_expression] = STATE(821),
    [sym_subscript_expression] = STATE(821),
    [sym_call_expression] = STATE(821),
    [sym_field_expression] = STATE(821),
    [sym_compound_literal_expression] = STATE(821),
    [sym_parenthesized_expression] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(2069),
    [sym_char_literal] = ACTIONS(2069),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(2071),
    [sym_false] = ACTIONS(2071),
    [sym_null] = ACTIONS(2071),
    [sym_identifier] = ACTIONS(2071),
    [sym_comment] = ACTIONS(42),
  },
  [532] = {
    [sym__expression] = STATE(822),
    [sym_conditional_expression] = STATE(822),
    [sym_assignment_expression] = STATE(822),
    [sym_pointer_expression] = STATE(822),
    [sym_logical_expression] = STATE(822),
    [sym_bitwise_expression] = STATE(822),
    [sym_equality_expression] = STATE(822),
    [sym_relational_expression] = STATE(822),
    [sym_shift_expression] = STATE(822),
    [sym_math_expression] = STATE(822),
    [sym_cast_expression] = STATE(822),
    [sym_sizeof_expression] = STATE(822),
    [sym_subscript_expression] = STATE(822),
    [sym_call_expression] = STATE(822),
    [sym_field_expression] = STATE(822),
    [sym_compound_literal_expression] = STATE(822),
    [sym_parenthesized_expression] = STATE(822),
    [sym_concatenated_string] = STATE(822),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(2073),
    [sym_char_literal] = ACTIONS(2073),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(2075),
    [sym_false] = ACTIONS(2075),
    [sym_null] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_comment] = ACTIONS(42),
  },
  [533] = {
    [sym__expression] = STATE(823),
    [sym_conditional_expression] = STATE(823),
    [sym_assignment_expression] = STATE(823),
    [sym_pointer_expression] = STATE(823),
    [sym_logical_expression] = STATE(823),
    [sym_bitwise_expression] = STATE(823),
    [sym_equality_expression] = STATE(823),
    [sym_relational_expression] = STATE(823),
    [sym_shift_expression] = STATE(823),
    [sym_math_expression] = STATE(823),
    [sym_cast_expression] = STATE(823),
    [sym_sizeof_expression] = STATE(823),
    [sym_subscript_expression] = STATE(823),
    [sym_call_expression] = STATE(823),
    [sym_field_expression] = STATE(823),
    [sym_compound_literal_expression] = STATE(823),
    [sym_parenthesized_expression] = STATE(823),
    [sym_concatenated_string] = STATE(823),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(2077),
    [sym_char_literal] = ACTIONS(2077),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(2079),
    [sym_false] = ACTIONS(2079),
    [sym_null] = ACTIONS(2079),
    [sym_identifier] = ACTIONS(2079),
    [sym_comment] = ACTIONS(42),
  },
  [534] = {
    [sym__expression] = STATE(824),
    [sym_conditional_expression] = STATE(824),
    [sym_assignment_expression] = STATE(824),
    [sym_pointer_expression] = STATE(824),
    [sym_logical_expression] = STATE(824),
    [sym_bitwise_expression] = STATE(824),
    [sym_equality_expression] = STATE(824),
    [sym_relational_expression] = STATE(824),
    [sym_shift_expression] = STATE(824),
    [sym_math_expression] = STATE(824),
    [sym_cast_expression] = STATE(824),
    [sym_sizeof_expression] = STATE(824),
    [sym_subscript_expression] = STATE(824),
    [sym_call_expression] = STATE(824),
    [sym_field_expression] = STATE(824),
    [sym_compound_literal_expression] = STATE(824),
    [sym_parenthesized_expression] = STATE(824),
    [sym_concatenated_string] = STATE(824),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(2081),
    [sym_char_literal] = ACTIONS(2081),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(2083),
    [sym_false] = ACTIONS(2083),
    [sym_null] = ACTIONS(2083),
    [sym_identifier] = ACTIONS(2083),
    [sym_comment] = ACTIONS(42),
  },
  [535] = {
    [sym__expression] = STATE(825),
    [sym_conditional_expression] = STATE(825),
    [sym_assignment_expression] = STATE(825),
    [sym_pointer_expression] = STATE(825),
    [sym_logical_expression] = STATE(825),
    [sym_bitwise_expression] = STATE(825),
    [sym_equality_expression] = STATE(825),
    [sym_relational_expression] = STATE(825),
    [sym_shift_expression] = STATE(825),
    [sym_math_expression] = STATE(825),
    [sym_cast_expression] = STATE(825),
    [sym_sizeof_expression] = STATE(825),
    [sym_subscript_expression] = STATE(825),
    [sym_call_expression] = STATE(825),
    [sym_field_expression] = STATE(825),
    [sym_compound_literal_expression] = STATE(825),
    [sym_parenthesized_expression] = STATE(825),
    [sym_concatenated_string] = STATE(825),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(2085),
    [sym_char_literal] = ACTIONS(2085),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(2087),
    [sym_false] = ACTIONS(2087),
    [sym_null] = ACTIONS(2087),
    [sym_identifier] = ACTIONS(2087),
    [sym_comment] = ACTIONS(42),
  },
  [536] = {
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_extern] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(93),
    [anon_sym_RBRACK] = ACTIONS(93),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_auto] = ACTIONS(95),
    [anon_sym_register] = ACTIONS(95),
    [anon_sym_inline] = ACTIONS(95),
    [anon_sym_const] = ACTIONS(95),
    [anon_sym_restrict] = ACTIONS(95),
    [anon_sym_volatile] = ACTIONS(95),
    [anon_sym__Atomic] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(93),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_TILDE] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_sizeof] = ACTIONS(95),
    [sym_number_literal] = ACTIONS(93),
    [sym_char_literal] = ACTIONS(93),
    [sym_string_literal] = ACTIONS(93),
    [sym_true] = ACTIONS(95),
    [sym_false] = ACTIONS(95),
    [sym_null] = ACTIONS(95),
    [sym_identifier] = ACTIONS(95),
    [sym_comment] = ACTIONS(42),
  },
  [537] = {
    [sym_storage_class_specifier] = STATE(826),
    [sym_type_qualifier] = STATE(826),
    [aux_sym__declaration_specifiers_repeat1] = STATE(826),
    [anon_sym_LPAREN] = ACTIONS(278),
    [anon_sym_extern] = ACTIONS(1229),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_RBRACK] = ACTIONS(278),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_auto] = ACTIONS(1229),
    [anon_sym_register] = ACTIONS(1229),
    [anon_sym_inline] = ACTIONS(1229),
    [anon_sym_const] = ACTIONS(1231),
    [anon_sym_restrict] = ACTIONS(1231),
    [anon_sym_volatile] = ACTIONS(1231),
    [anon_sym__Atomic] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(278),
    [anon_sym_TILDE] = ACTIONS(278),
    [anon_sym_PLUS] = ACTIONS(280),
    [anon_sym_DASH] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(278),
    [anon_sym_sizeof] = ACTIONS(280),
    [sym_number_literal] = ACTIONS(278),
    [sym_char_literal] = ACTIONS(278),
    [sym_string_literal] = ACTIONS(278),
    [sym_true] = ACTIONS(280),
    [sym_false] = ACTIONS(280),
    [sym_null] = ACTIONS(280),
    [sym_identifier] = ACTIONS(280),
    [sym_comment] = ACTIONS(42),
  },
  [538] = {
    [anon_sym_LPAREN] = ACTIONS(340),
    [anon_sym_extern] = ACTIONS(342),
    [anon_sym_STAR] = ACTIONS(340),
    [anon_sym_RBRACK] = ACTIONS(340),
    [anon_sym_static] = ACTIONS(342),
    [anon_sym_auto] = ACTIONS(342),
    [anon_sym_register] = ACTIONS(342),
    [anon_sym_inline] = ACTIONS(342),
    [anon_sym_const] = ACTIONS(342),
    [anon_sym_restrict] = ACTIONS(342),
    [anon_sym_volatile] = ACTIONS(342),
    [anon_sym__Atomic] = ACTIONS(342),
    [anon_sym_AMP] = ACTIONS(340),
    [anon_sym_BANG] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(340),
    [anon_sym_PLUS] = ACTIONS(342),
    [anon_sym_DASH] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(340),
    [anon_sym_PLUS_PLUS] = ACTIONS(340),
    [anon_sym_sizeof] = ACTIONS(342),
    [sym_number_literal] = ACTIONS(340),
    [sym_char_literal] = ACTIONS(340),
    [sym_string_literal] = ACTIONS(340),
    [sym_true] = ACTIONS(342),
    [sym_false] = ACTIONS(342),
    [sym_null] = ACTIONS(342),
    [sym_identifier] = ACTIONS(342),
    [sym_comment] = ACTIONS(42),
  },
  [539] = {
    [anon_sym_LPAREN] = ACTIONS(344),
    [anon_sym_extern] = ACTIONS(346),
    [anon_sym_STAR] = ACTIONS(344),
    [anon_sym_RBRACK] = ACTIONS(344),
    [anon_sym_static] = ACTIONS(346),
    [anon_sym_auto] = ACTIONS(346),
    [anon_sym_register] = ACTIONS(346),
    [anon_sym_inline] = ACTIONS(346),
    [anon_sym_const] = ACTIONS(346),
    [anon_sym_restrict] = ACTIONS(346),
    [anon_sym_volatile] = ACTIONS(346),
    [anon_sym__Atomic] = ACTIONS(346),
    [anon_sym_AMP] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_TILDE] = ACTIONS(344),
    [anon_sym_PLUS] = ACTIONS(346),
    [anon_sym_DASH] = ACTIONS(346),
    [anon_sym_DASH_DASH] = ACTIONS(344),
    [anon_sym_PLUS_PLUS] = ACTIONS(344),
    [anon_sym_sizeof] = ACTIONS(346),
    [sym_number_literal] = ACTIONS(344),
    [sym_char_literal] = ACTIONS(344),
    [sym_string_literal] = ACTIONS(344),
    [sym_true] = ACTIONS(346),
    [sym_false] = ACTIONS(346),
    [sym_null] = ACTIONS(346),
    [sym_identifier] = ACTIONS(346),
    [sym_comment] = ACTIONS(42),
  },
  [540] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(540),
    [anon_sym_LPAREN] = ACTIONS(348),
    [anon_sym_extern] = ACTIONS(350),
    [anon_sym_STAR] = ACTIONS(348),
    [anon_sym_RBRACK] = ACTIONS(348),
    [anon_sym_static] = ACTIONS(350),
    [anon_sym_auto] = ACTIONS(350),
    [anon_sym_register] = ACTIONS(350),
    [anon_sym_inline] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(350),
    [anon_sym_restrict] = ACTIONS(350),
    [anon_sym_volatile] = ACTIONS(350),
    [anon_sym__Atomic] = ACTIONS(350),
    [anon_sym_unsigned] = ACTIONS(2092),
    [anon_sym_long] = ACTIONS(2092),
    [anon_sym_short] = ACTIONS(2092),
    [sym_primitive_type] = ACTIONS(350),
    [anon_sym_AMP] = ACTIONS(348),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_PLUS] = ACTIONS(350),
    [anon_sym_DASH] = ACTIONS(350),
    [anon_sym_DASH_DASH] = ACTIONS(348),
    [anon_sym_PLUS_PLUS] = ACTIONS(348),
    [anon_sym_sizeof] = ACTIONS(350),
    [sym_number_literal] = ACTIONS(348),
    [sym_char_literal] = ACTIONS(348),
    [sym_string_literal] = ACTIONS(348),
    [sym_true] = ACTIONS(350),
    [sym_false] = ACTIONS(350),
    [sym_null] = ACTIONS(350),
    [sym_identifier] = ACTIONS(350),
    [sym_comment] = ACTIONS(42),
  },
  [541] = {
    [anon_sym_RBRACE] = ACTIONS(2095),
    [sym_comment] = ACTIONS(42),
  },
  [542] = {
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_COMMA] = ACTIONS(2097),
    [anon_sym_RPAREN] = ACTIONS(2097),
    [anon_sym_SEMI] = ACTIONS(2097),
    [anon_sym_RBRACE] = ACTIONS(2097),
    [anon_sym_STAR] = ACTIONS(2099),
    [anon_sym_LBRACK] = ACTIONS(2097),
    [anon_sym_RBRACK] = ACTIONS(2097),
    [anon_sym_EQ] = ACTIONS(2099),
    [anon_sym_COLON] = ACTIONS(2097),
    [anon_sym_QMARK] = ACTIONS(2097),
    [anon_sym_STAR_EQ] = ACTIONS(2097),
    [anon_sym_SLASH_EQ] = ACTIONS(2097),
    [anon_sym_PERCENT_EQ] = ACTIONS(2097),
    [anon_sym_PLUS_EQ] = ACTIONS(2097),
    [anon_sym_DASH_EQ] = ACTIONS(2097),
    [anon_sym_LT_LT_EQ] = ACTIONS(2097),
    [anon_sym_GT_GT_EQ] = ACTIONS(2097),
    [anon_sym_AMP_EQ] = ACTIONS(2097),
    [anon_sym_CARET_EQ] = ACTIONS(2097),
    [anon_sym_PIPE_EQ] = ACTIONS(2097),
    [anon_sym_AMP] = ACTIONS(2099),
    [anon_sym_PIPE_PIPE] = ACTIONS(2097),
    [anon_sym_AMP_AMP] = ACTIONS(2097),
    [anon_sym_PIPE] = ACTIONS(2099),
    [anon_sym_CARET] = ACTIONS(2099),
    [anon_sym_EQ_EQ] = ACTIONS(2097),
    [anon_sym_BANG_EQ] = ACTIONS(2097),
    [anon_sym_LT] = ACTIONS(2099),
    [anon_sym_GT] = ACTIONS(2099),
    [anon_sym_LT_EQ] = ACTIONS(2097),
    [anon_sym_GT_EQ] = ACTIONS(2097),
    [anon_sym_LT_LT] = ACTIONS(2099),
    [anon_sym_GT_GT] = ACTIONS(2099),
    [anon_sym_PLUS] = ACTIONS(2099),
    [anon_sym_DASH] = ACTIONS(2099),
    [anon_sym_SLASH] = ACTIONS(2099),
    [anon_sym_PERCENT] = ACTIONS(2099),
    [anon_sym_DASH_DASH] = ACTIONS(2097),
    [anon_sym_PLUS_PLUS] = ACTIONS(2097),
    [anon_sym_DOT] = ACTIONS(2097),
    [anon_sym_DASH_GT] = ACTIONS(2097),
    [sym_comment] = ACTIONS(42),
  },
  [543] = {
    [sym__expression] = STATE(828),
    [sym_conditional_expression] = STATE(828),
    [sym_assignment_expression] = STATE(828),
    [sym_pointer_expression] = STATE(828),
    [sym_logical_expression] = STATE(828),
    [sym_bitwise_expression] = STATE(828),
    [sym_equality_expression] = STATE(828),
    [sym_relational_expression] = STATE(828),
    [sym_shift_expression] = STATE(828),
    [sym_math_expression] = STATE(828),
    [sym_cast_expression] = STATE(828),
    [sym_sizeof_expression] = STATE(828),
    [sym_subscript_expression] = STATE(828),
    [sym_call_expression] = STATE(828),
    [sym_field_expression] = STATE(828),
    [sym_compound_literal_expression] = STATE(828),
    [sym_parenthesized_expression] = STATE(828),
    [sym_concatenated_string] = STATE(828),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(2101),
    [sym_char_literal] = ACTIONS(2101),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(2103),
    [sym_false] = ACTIONS(2103),
    [sym_null] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2103),
    [sym_comment] = ACTIONS(42),
  },
  [544] = {
    [sym_identifier] = ACTIONS(2105),
    [sym_comment] = ACTIONS(42),
  },
  [545] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_initializer_list_repeat1] = STATE(831),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2095),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1429),
    [anon_sym_QMARK] = ACTIONS(1431),
    [anon_sym_STAR_EQ] = ACTIONS(1433),
    [anon_sym_SLASH_EQ] = ACTIONS(1433),
    [anon_sym_PERCENT_EQ] = ACTIONS(1433),
    [anon_sym_PLUS_EQ] = ACTIONS(1433),
    [anon_sym_DASH_EQ] = ACTIONS(1433),
    [anon_sym_LT_LT_EQ] = ACTIONS(1433),
    [anon_sym_GT_GT_EQ] = ACTIONS(1433),
    [anon_sym_AMP_EQ] = ACTIONS(1433),
    [anon_sym_CARET_EQ] = ACTIONS(1433),
    [anon_sym_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_PIPE] = ACTIONS(1441),
    [anon_sym_CARET] = ACTIONS(1443),
    [anon_sym_EQ_EQ] = ACTIONS(1445),
    [anon_sym_BANG_EQ] = ACTIONS(1445),
    [anon_sym_LT] = ACTIONS(1447),
    [anon_sym_GT] = ACTIONS(1447),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1451),
    [anon_sym_GT_GT] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_SLASH] = ACTIONS(1427),
    [anon_sym_PERCENT] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [546] = {
    [aux_sym_initializer_list_repeat1] = STATE(831),
    [anon_sym_COMMA] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2095),
    [sym_comment] = ACTIONS(42),
  },
  [547] = {
    [sym_subscript_designator] = STATE(833),
    [sym_field_designator] = STATE(833),
    [aux_sym_initializer_pair_repeat1] = STATE(833),
    [anon_sym_LBRACK] = ACTIONS(1276),
    [anon_sym_EQ] = ACTIONS(2109),
    [anon_sym_DOT] = ACTIONS(1278),
    [sym_comment] = ACTIONS(42),
  },
  [548] = {
    [anon_sym_COMMA] = ACTIONS(2111),
    [anon_sym_RPAREN] = ACTIONS(2111),
    [sym_comment] = ACTIONS(42),
  },
  [549] = {
    [anon_sym_LF] = ACTIONS(2113),
    [sym_preproc_arg] = ACTIONS(2113),
    [sym_comment] = ACTIONS(50),
  },
  [550] = {
    [aux_sym_preproc_params_repeat1] = STATE(550),
    [anon_sym_COMMA] = ACTIONS(2115),
    [anon_sym_RPAREN] = ACTIONS(2111),
    [sym_comment] = ACTIONS(42),
  },
  [551] = {
    [anon_sym_LF] = ACTIONS(2118),
    [sym_comment] = ACTIONS(50),
  },
  [552] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(703),
    [sym_preproc_directive] = ACTIONS(703),
    [anon_sym_typedef] = ACTIONS(703),
    [anon_sym_extern] = ACTIONS(703),
    [anon_sym_static] = ACTIONS(703),
    [anon_sym_auto] = ACTIONS(703),
    [anon_sym_register] = ACTIONS(703),
    [anon_sym_inline] = ACTIONS(703),
    [anon_sym_const] = ACTIONS(703),
    [anon_sym_restrict] = ACTIONS(703),
    [anon_sym_volatile] = ACTIONS(703),
    [anon_sym__Atomic] = ACTIONS(703),
    [anon_sym_unsigned] = ACTIONS(703),
    [anon_sym_long] = ACTIONS(703),
    [anon_sym_short] = ACTIONS(703),
    [sym_primitive_type] = ACTIONS(703),
    [anon_sym_enum] = ACTIONS(703),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_union] = ACTIONS(703),
    [sym_identifier] = ACTIONS(703),
    [sym_comment] = ACTIONS(42),
  },
  [553] = {
    [anon_sym_LF] = ACTIONS(2120),
    [sym_comment] = ACTIONS(50),
  },
  [554] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(751),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(751),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(751),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(751),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(751),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(751),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(751),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(751),
    [sym_preproc_directive] = ACTIONS(751),
    [anon_sym_typedef] = ACTIONS(751),
    [anon_sym_extern] = ACTIONS(751),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_auto] = ACTIONS(751),
    [anon_sym_register] = ACTIONS(751),
    [anon_sym_inline] = ACTIONS(751),
    [anon_sym_const] = ACTIONS(751),
    [anon_sym_restrict] = ACTIONS(751),
    [anon_sym_volatile] = ACTIONS(751),
    [anon_sym__Atomic] = ACTIONS(751),
    [anon_sym_unsigned] = ACTIONS(751),
    [anon_sym_long] = ACTIONS(751),
    [anon_sym_short] = ACTIONS(751),
    [sym_primitive_type] = ACTIONS(751),
    [anon_sym_enum] = ACTIONS(751),
    [anon_sym_struct] = ACTIONS(751),
    [anon_sym_union] = ACTIONS(751),
    [sym_identifier] = ACTIONS(751),
    [sym_comment] = ACTIONS(42),
  },
  [555] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2122),
    [sym_comment] = ACTIONS(42),
  },
  [556] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(787),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(787),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(787),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(787),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(787),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(787),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(787),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(787),
    [sym_preproc_directive] = ACTIONS(787),
    [anon_sym_typedef] = ACTIONS(787),
    [anon_sym_extern] = ACTIONS(787),
    [anon_sym_static] = ACTIONS(787),
    [anon_sym_auto] = ACTIONS(787),
    [anon_sym_register] = ACTIONS(787),
    [anon_sym_inline] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(787),
    [anon_sym_restrict] = ACTIONS(787),
    [anon_sym_volatile] = ACTIONS(787),
    [anon_sym__Atomic] = ACTIONS(787),
    [anon_sym_unsigned] = ACTIONS(787),
    [anon_sym_long] = ACTIONS(787),
    [anon_sym_short] = ACTIONS(787),
    [sym_primitive_type] = ACTIONS(787),
    [anon_sym_enum] = ACTIONS(787),
    [anon_sym_struct] = ACTIONS(787),
    [anon_sym_union] = ACTIONS(787),
    [sym_identifier] = ACTIONS(787),
    [sym_comment] = ACTIONS(42),
  },
  [557] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2124),
    [sym_comment] = ACTIONS(42),
  },
  [558] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(793),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(793),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(793),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(793),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(793),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(793),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(793),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(793),
    [sym_preproc_directive] = ACTIONS(793),
    [anon_sym_typedef] = ACTIONS(793),
    [anon_sym_extern] = ACTIONS(793),
    [anon_sym_static] = ACTIONS(793),
    [anon_sym_auto] = ACTIONS(793),
    [anon_sym_register] = ACTIONS(793),
    [anon_sym_inline] = ACTIONS(793),
    [anon_sym_const] = ACTIONS(793),
    [anon_sym_restrict] = ACTIONS(793),
    [anon_sym_volatile] = ACTIONS(793),
    [anon_sym__Atomic] = ACTIONS(793),
    [anon_sym_unsigned] = ACTIONS(793),
    [anon_sym_long] = ACTIONS(793),
    [anon_sym_short] = ACTIONS(793),
    [sym_primitive_type] = ACTIONS(793),
    [anon_sym_enum] = ACTIONS(793),
    [anon_sym_struct] = ACTIONS(793),
    [anon_sym_union] = ACTIONS(793),
    [sym_identifier] = ACTIONS(793),
    [sym_comment] = ACTIONS(42),
  },
  [559] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2126),
    [sym_comment] = ACTIONS(42),
  },
  [560] = {
    [sym_preproc_arg] = ACTIONS(2128),
    [sym_comment] = ACTIONS(50),
  },
  [561] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(359),
    [sym_preproc_directive] = ACTIONS(359),
    [anon_sym_typedef] = ACTIONS(359),
    [anon_sym_extern] = ACTIONS(359),
    [anon_sym_static] = ACTIONS(359),
    [anon_sym_auto] = ACTIONS(359),
    [anon_sym_register] = ACTIONS(359),
    [anon_sym_inline] = ACTIONS(359),
    [anon_sym_const] = ACTIONS(359),
    [anon_sym_restrict] = ACTIONS(359),
    [anon_sym_volatile] = ACTIONS(359),
    [anon_sym__Atomic] = ACTIONS(359),
    [anon_sym_unsigned] = ACTIONS(359),
    [anon_sym_long] = ACTIONS(359),
    [anon_sym_short] = ACTIONS(359),
    [sym_primitive_type] = ACTIONS(359),
    [anon_sym_enum] = ACTIONS(359),
    [anon_sym_struct] = ACTIONS(359),
    [anon_sym_union] = ACTIONS(359),
    [sym_identifier] = ACTIONS(359),
    [sym_comment] = ACTIONS(42),
  },
  [562] = {
    [anon_sym_LF] = ACTIONS(2130),
    [sym_preproc_arg] = ACTIONS(2132),
    [sym_comment] = ACTIONS(50),
  },
  [563] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(377),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(377),
    [sym_preproc_directive] = ACTIONS(377),
    [anon_sym_typedef] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(377),
    [anon_sym_static] = ACTIONS(377),
    [anon_sym_auto] = ACTIONS(377),
    [anon_sym_register] = ACTIONS(377),
    [anon_sym_inline] = ACTIONS(377),
    [anon_sym_const] = ACTIONS(377),
    [anon_sym_restrict] = ACTIONS(377),
    [anon_sym_volatile] = ACTIONS(377),
    [anon_sym__Atomic] = ACTIONS(377),
    [anon_sym_unsigned] = ACTIONS(377),
    [anon_sym_long] = ACTIONS(377),
    [anon_sym_short] = ACTIONS(377),
    [sym_primitive_type] = ACTIONS(377),
    [anon_sym_enum] = ACTIONS(377),
    [anon_sym_struct] = ACTIONS(377),
    [anon_sym_union] = ACTIONS(377),
    [sym_identifier] = ACTIONS(377),
    [sym_comment] = ACTIONS(42),
  },
  [564] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2134),
    [sym_comment] = ACTIONS(42),
  },
  [565] = {
    [sym_preproc_include] = STATE(180),
    [sym_preproc_def] = STATE(180),
    [sym_preproc_function_def] = STATE(180),
    [sym_preproc_call] = STATE(180),
    [sym_preproc_if] = STATE(180),
    [sym_preproc_ifdef] = STATE(180),
    [sym_preproc_else] = STATE(843),
    [sym_preproc_elif] = STATE(843),
    [sym_function_definition] = STATE(180),
    [sym_declaration] = STATE(180),
    [sym_type_definition] = STATE(180),
    [sym__declaration_specifiers] = STATE(77),
    [sym_linkage_specification] = STATE(180),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(180),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(140),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(142),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2136),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(148),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(150),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(152),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(154),
    [sym_preproc_directive] = ACTIONS(156),
    [anon_sym_typedef] = ACTIONS(158),
    [anon_sym_extern] = ACTIONS(160),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [566] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(421),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(421),
    [sym_preproc_directive] = ACTIONS(421),
    [anon_sym_typedef] = ACTIONS(421),
    [anon_sym_extern] = ACTIONS(421),
    [anon_sym_static] = ACTIONS(421),
    [anon_sym_auto] = ACTIONS(421),
    [anon_sym_register] = ACTIONS(421),
    [anon_sym_inline] = ACTIONS(421),
    [anon_sym_const] = ACTIONS(421),
    [anon_sym_restrict] = ACTIONS(421),
    [anon_sym_volatile] = ACTIONS(421),
    [anon_sym__Atomic] = ACTIONS(421),
    [anon_sym_unsigned] = ACTIONS(421),
    [anon_sym_long] = ACTIONS(421),
    [anon_sym_short] = ACTIONS(421),
    [sym_primitive_type] = ACTIONS(421),
    [anon_sym_enum] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(421),
    [anon_sym_union] = ACTIONS(421),
    [sym_identifier] = ACTIONS(421),
    [sym_comment] = ACTIONS(42),
  },
  [567] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2138),
    [sym_comment] = ACTIONS(42),
  },
  [568] = {
    [sym_preproc_include] = STATE(180),
    [sym_preproc_def] = STATE(180),
    [sym_preproc_function_def] = STATE(180),
    [sym_preproc_call] = STATE(180),
    [sym_preproc_if] = STATE(180),
    [sym_preproc_ifdef] = STATE(180),
    [sym_preproc_else] = STATE(845),
    [sym_preproc_elif] = STATE(845),
    [sym_function_definition] = STATE(180),
    [sym_declaration] = STATE(180),
    [sym_type_definition] = STATE(180),
    [sym__declaration_specifiers] = STATE(77),
    [sym_linkage_specification] = STATE(180),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(180),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(140),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(142),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2140),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(148),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(150),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(152),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(154),
    [sym_preproc_directive] = ACTIONS(156),
    [anon_sym_typedef] = ACTIONS(158),
    [anon_sym_extern] = ACTIONS(160),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [569] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(429),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(429),
    [sym_preproc_directive] = ACTIONS(429),
    [anon_sym_typedef] = ACTIONS(429),
    [anon_sym_extern] = ACTIONS(429),
    [anon_sym_static] = ACTIONS(429),
    [anon_sym_auto] = ACTIONS(429),
    [anon_sym_register] = ACTIONS(429),
    [anon_sym_inline] = ACTIONS(429),
    [anon_sym_const] = ACTIONS(429),
    [anon_sym_restrict] = ACTIONS(429),
    [anon_sym_volatile] = ACTIONS(429),
    [anon_sym__Atomic] = ACTIONS(429),
    [anon_sym_unsigned] = ACTIONS(429),
    [anon_sym_long] = ACTIONS(429),
    [anon_sym_short] = ACTIONS(429),
    [sym_primitive_type] = ACTIONS(429),
    [anon_sym_enum] = ACTIONS(429),
    [anon_sym_struct] = ACTIONS(429),
    [anon_sym_union] = ACTIONS(429),
    [sym_identifier] = ACTIONS(429),
    [sym_comment] = ACTIONS(42),
  },
  [570] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2142),
    [sym_comment] = ACTIONS(42),
  },
  [571] = {
    [sym_preproc_include] = STATE(180),
    [sym_preproc_def] = STATE(180),
    [sym_preproc_function_def] = STATE(180),
    [sym_preproc_call] = STATE(180),
    [sym_preproc_if] = STATE(180),
    [sym_preproc_ifdef] = STATE(180),
    [sym_preproc_else] = STATE(847),
    [sym_preproc_elif] = STATE(847),
    [sym_function_definition] = STATE(180),
    [sym_declaration] = STATE(180),
    [sym_type_definition] = STATE(180),
    [sym__declaration_specifiers] = STATE(77),
    [sym_linkage_specification] = STATE(180),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(180),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(180),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(140),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(142),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2144),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(148),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(150),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(152),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(154),
    [sym_preproc_directive] = ACTIONS(156),
    [anon_sym_typedef] = ACTIONS(158),
    [anon_sym_extern] = ACTIONS(160),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [572] = {
    [anon_sym_LF] = ACTIONS(2146),
    [sym_comment] = ACTIONS(50),
  },
  [573] = {
    [sym_parameter_list] = STATE(200),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_SEMI] = ACTIONS(2148),
    [anon_sym_LBRACK] = ACTIONS(449),
    [sym_comment] = ACTIONS(42),
  },
  [574] = {
    [sym__type_declarator] = STATE(850),
    [sym_pointer_type_declarator] = STATE(99),
    [sym_function_type_declarator] = STATE(100),
    [sym_array_type_declarator] = STATE(101),
    [anon_sym_LPAREN] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(187),
    [sym_identifier] = ACTIONS(189),
    [sym_comment] = ACTIONS(42),
  },
  [575] = {
    [sym_preproc_include] = STATE(852),
    [sym_preproc_def] = STATE(852),
    [sym_preproc_function_def] = STATE(852),
    [sym_preproc_call] = STATE(852),
    [sym_preproc_if] = STATE(852),
    [sym_preproc_ifdef] = STATE(852),
    [sym_function_definition] = STATE(852),
    [sym_declaration] = STATE(852),
    [sym_type_definition] = STATE(852),
    [sym__declaration_specifiers] = STATE(17),
    [sym_linkage_specification] = STATE(852),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(852),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(852),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(10),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(12),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(14),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(16),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(18),
    [sym_preproc_directive] = ACTIONS(20),
    [anon_sym_typedef] = ACTIONS(22),
    [anon_sym_extern] = ACTIONS(24),
    [anon_sym_RBRACE] = ACTIONS(2150),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [576] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(469),
    [sym_preproc_directive] = ACTIONS(469),
    [anon_sym_typedef] = ACTIONS(469),
    [anon_sym_extern] = ACTIONS(469),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_auto] = ACTIONS(469),
    [anon_sym_register] = ACTIONS(469),
    [anon_sym_inline] = ACTIONS(469),
    [anon_sym_const] = ACTIONS(469),
    [anon_sym_restrict] = ACTIONS(469),
    [anon_sym_volatile] = ACTIONS(469),
    [anon_sym__Atomic] = ACTIONS(469),
    [anon_sym_unsigned] = ACTIONS(469),
    [anon_sym_long] = ACTIONS(469),
    [anon_sym_short] = ACTIONS(469),
    [sym_primitive_type] = ACTIONS(469),
    [anon_sym_enum] = ACTIONS(469),
    [anon_sym_struct] = ACTIONS(469),
    [anon_sym_union] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_comment] = ACTIONS(42),
  },
  [577] = {
    [sym__declarator] = STATE(331),
    [sym_pointer_declarator] = STATE(331),
    [sym_function_declarator] = STATE(331),
    [sym_array_declarator] = STATE(331),
    [sym_init_declarator] = STATE(332),
    [anon_sym_LPAREN] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(103),
    [sym_identifier] = ACTIONS(737),
    [sym_comment] = ACTIONS(42),
  },
  [578] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(567),
    [sym_preproc_directive] = ACTIONS(567),
    [anon_sym_typedef] = ACTIONS(567),
    [anon_sym_extern] = ACTIONS(567),
    [anon_sym_static] = ACTIONS(567),
    [anon_sym_auto] = ACTIONS(567),
    [anon_sym_register] = ACTIONS(567),
    [anon_sym_inline] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_restrict] = ACTIONS(567),
    [anon_sym_volatile] = ACTIONS(567),
    [anon_sym__Atomic] = ACTIONS(567),
    [anon_sym_unsigned] = ACTIONS(567),
    [anon_sym_long] = ACTIONS(567),
    [anon_sym_short] = ACTIONS(567),
    [sym_primitive_type] = ACTIONS(567),
    [anon_sym_enum] = ACTIONS(567),
    [anon_sym_struct] = ACTIONS(567),
    [anon_sym_union] = ACTIONS(567),
    [sym_identifier] = ACTIONS(567),
    [sym_comment] = ACTIONS(42),
  },
  [579] = {
    [sym_preproc_include] = STATE(854),
    [sym_preproc_def] = STATE(854),
    [sym_preproc_function_def] = STATE(854),
    [sym_preproc_call] = STATE(854),
    [sym_preproc_if_in_compound_statement] = STATE(275),
    [sym_preproc_ifdef_in_compound_statement] = STATE(276),
    [sym_declaration] = STATE(854),
    [sym_type_definition] = STATE(854),
    [sym__declaration_specifiers] = STATE(277),
    [sym_compound_statement] = STATE(854),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(854),
    [sym_expression_statement] = STATE(854),
    [sym_if_statement] = STATE(854),
    [sym_switch_statement] = STATE(854),
    [sym_case_statement] = STATE(854),
    [sym_while_statement] = STATE(854),
    [sym_do_statement] = STATE(854),
    [sym_for_statement] = STATE(854),
    [sym_return_statement] = STATE(854),
    [sym_break_statement] = STATE(854),
    [sym_continue_statement] = STATE(854),
    [sym_goto_statement] = STATE(854),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [sym__empty_declaration] = STATE(854),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(854),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(577),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(579),
    [sym_preproc_directive] = ACTIONS(581),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_typedef] = ACTIONS(585),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_RBRACE] = ACTIONS(2152),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(631),
    [sym_comment] = ACTIONS(42),
  },
  [580] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(675),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(675),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(675),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(675),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(675),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(675),
    [sym_preproc_directive] = ACTIONS(675),
    [anon_sym_typedef] = ACTIONS(675),
    [anon_sym_extern] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_auto] = ACTIONS(675),
    [anon_sym_register] = ACTIONS(675),
    [anon_sym_inline] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(675),
    [anon_sym_restrict] = ACTIONS(675),
    [anon_sym_volatile] = ACTIONS(675),
    [anon_sym__Atomic] = ACTIONS(675),
    [anon_sym_unsigned] = ACTIONS(675),
    [anon_sym_long] = ACTIONS(675),
    [anon_sym_short] = ACTIONS(675),
    [sym_primitive_type] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_union] = ACTIONS(675),
    [sym_identifier] = ACTIONS(675),
    [sym_comment] = ACTIONS(42),
  },
  [581] = {
    [aux_sym_declaration_repeat1] = STATE(302),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(2154),
    [sym_comment] = ACTIONS(42),
  },
  [582] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2156),
    [sym_comment] = ACTIONS(42),
  },
  [583] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(799),
    [sym_preproc_directive] = ACTIONS(799),
    [anon_sym_typedef] = ACTIONS(799),
    [anon_sym_extern] = ACTIONS(799),
    [anon_sym_static] = ACTIONS(799),
    [anon_sym_auto] = ACTIONS(799),
    [anon_sym_register] = ACTIONS(799),
    [anon_sym_inline] = ACTIONS(799),
    [anon_sym_const] = ACTIONS(799),
    [anon_sym_restrict] = ACTIONS(799),
    [anon_sym_volatile] = ACTIONS(799),
    [anon_sym__Atomic] = ACTIONS(799),
    [anon_sym_unsigned] = ACTIONS(799),
    [anon_sym_long] = ACTIONS(799),
    [anon_sym_short] = ACTIONS(799),
    [sym_primitive_type] = ACTIONS(799),
    [anon_sym_enum] = ACTIONS(799),
    [anon_sym_struct] = ACTIONS(799),
    [anon_sym_union] = ACTIONS(799),
    [sym_identifier] = ACTIONS(799),
    [sym_comment] = ACTIONS(42),
  },
  [584] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(815),
    [sym_preproc_directive] = ACTIONS(815),
    [anon_sym_typedef] = ACTIONS(815),
    [anon_sym_extern] = ACTIONS(815),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_auto] = ACTIONS(815),
    [anon_sym_register] = ACTIONS(815),
    [anon_sym_inline] = ACTIONS(815),
    [anon_sym_const] = ACTIONS(815),
    [anon_sym_restrict] = ACTIONS(815),
    [anon_sym_volatile] = ACTIONS(815),
    [anon_sym__Atomic] = ACTIONS(815),
    [anon_sym_unsigned] = ACTIONS(815),
    [anon_sym_long] = ACTIONS(815),
    [anon_sym_short] = ACTIONS(815),
    [sym_primitive_type] = ACTIONS(815),
    [anon_sym_enum] = ACTIONS(815),
    [anon_sym_struct] = ACTIONS(815),
    [anon_sym_union] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_comment] = ACTIONS(42),
  },
  [585] = {
    [sym_parameter_list] = STATE(200),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_SEMI] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(449),
    [sym_comment] = ACTIONS(42),
  },
  [586] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(829),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(829),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(829),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(829),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(829),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(829),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(829),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(829),
    [sym_preproc_directive] = ACTIONS(829),
    [anon_sym_typedef] = ACTIONS(829),
    [anon_sym_extern] = ACTIONS(829),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_auto] = ACTIONS(829),
    [anon_sym_register] = ACTIONS(829),
    [anon_sym_inline] = ACTIONS(829),
    [anon_sym_const] = ACTIONS(829),
    [anon_sym_restrict] = ACTIONS(829),
    [anon_sym_volatile] = ACTIONS(829),
    [anon_sym__Atomic] = ACTIONS(829),
    [anon_sym_unsigned] = ACTIONS(829),
    [anon_sym_long] = ACTIONS(829),
    [anon_sym_short] = ACTIONS(829),
    [sym_primitive_type] = ACTIONS(829),
    [anon_sym_enum] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_union] = ACTIONS(829),
    [sym_identifier] = ACTIONS(829),
    [sym_comment] = ACTIONS(42),
  },
  [587] = {
    [sym_preproc_include] = STATE(360),
    [sym_preproc_def] = STATE(360),
    [sym_preproc_function_def] = STATE(360),
    [sym_preproc_call] = STATE(360),
    [sym_preproc_if] = STATE(360),
    [sym_preproc_ifdef] = STATE(360),
    [sym_function_definition] = STATE(360),
    [sym_declaration] = STATE(360),
    [sym_type_definition] = STATE(360),
    [sym__declaration_specifiers] = STATE(17),
    [sym_linkage_specification] = STATE(360),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(360),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(360),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(10),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(12),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(14),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(16),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(18),
    [sym_preproc_directive] = ACTIONS(20),
    [anon_sym_typedef] = ACTIONS(22),
    [anon_sym_extern] = ACTIONS(24),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [588] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1047),
    [sym_preproc_directive] = ACTIONS(1047),
    [anon_sym_typedef] = ACTIONS(1047),
    [anon_sym_extern] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_auto] = ACTIONS(1047),
    [anon_sym_register] = ACTIONS(1047),
    [anon_sym_inline] = ACTIONS(1047),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_restrict] = ACTIONS(1047),
    [anon_sym_volatile] = ACTIONS(1047),
    [anon_sym__Atomic] = ACTIONS(1047),
    [anon_sym_unsigned] = ACTIONS(1047),
    [anon_sym_long] = ACTIONS(1047),
    [anon_sym_short] = ACTIONS(1047),
    [sym_primitive_type] = ACTIONS(1047),
    [anon_sym_enum] = ACTIONS(1047),
    [anon_sym_struct] = ACTIONS(1047),
    [anon_sym_union] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [sym_comment] = ACTIONS(42),
  },
  [589] = {
    [sym_preproc_include] = STATE(505),
    [sym_preproc_def] = STATE(505),
    [sym_preproc_function_def] = STATE(505),
    [sym_preproc_call] = STATE(505),
    [sym_preproc_if_in_compound_statement] = STATE(275),
    [sym_preproc_ifdef_in_compound_statement] = STATE(276),
    [sym_declaration] = STATE(505),
    [sym_type_definition] = STATE(505),
    [sym__declaration_specifiers] = STATE(277),
    [sym_compound_statement] = STATE(505),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(505),
    [sym_expression_statement] = STATE(505),
    [sym_if_statement] = STATE(505),
    [sym_switch_statement] = STATE(505),
    [sym_case_statement] = STATE(505),
    [sym_while_statement] = STATE(505),
    [sym_do_statement] = STATE(505),
    [sym_for_statement] = STATE(505),
    [sym_return_statement] = STATE(505),
    [sym_break_statement] = STATE(505),
    [sym_continue_statement] = STATE(505),
    [sym_goto_statement] = STATE(505),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [sym__empty_declaration] = STATE(505),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(505),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(577),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(579),
    [sym_preproc_directive] = ACTIONS(581),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_typedef] = ACTIONS(585),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_RBRACE] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(631),
    [sym_comment] = ACTIONS(42),
  },
  [590] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1288),
    [sym_preproc_directive] = ACTIONS(1288),
    [anon_sym_typedef] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1288),
    [anon_sym_static] = ACTIONS(1288),
    [anon_sym_auto] = ACTIONS(1288),
    [anon_sym_register] = ACTIONS(1288),
    [anon_sym_inline] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_restrict] = ACTIONS(1288),
    [anon_sym_volatile] = ACTIONS(1288),
    [anon_sym__Atomic] = ACTIONS(1288),
    [anon_sym_unsigned] = ACTIONS(1288),
    [anon_sym_long] = ACTIONS(1288),
    [anon_sym_short] = ACTIONS(1288),
    [sym_primitive_type] = ACTIONS(1288),
    [anon_sym_enum] = ACTIONS(1288),
    [anon_sym_struct] = ACTIONS(1288),
    [anon_sym_union] = ACTIONS(1288),
    [sym_identifier] = ACTIONS(1288),
    [sym_comment] = ACTIONS(42),
  },
  [591] = {
    [anon_sym_LPAREN] = ACTIONS(1455),
    [anon_sym_STAR] = ACTIONS(1455),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(42),
  },
  [592] = {
    [sym_enumerator] = STATE(372),
    [anon_sym_RBRACE] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(210),
    [sym_comment] = ACTIONS(42),
  },
  [593] = {
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_RPAREN] = ACTIONS(2166),
    [anon_sym_SEMI] = ACTIONS(2166),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [sym_comment] = ACTIONS(42),
  },
  [594] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2168),
    [anon_sym_EQ] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1237),
    [anon_sym_STAR_EQ] = ACTIONS(1239),
    [anon_sym_SLASH_EQ] = ACTIONS(1239),
    [anon_sym_PERCENT_EQ] = ACTIONS(1239),
    [anon_sym_PLUS_EQ] = ACTIONS(1239),
    [anon_sym_DASH_EQ] = ACTIONS(1239),
    [anon_sym_LT_LT_EQ] = ACTIONS(1239),
    [anon_sym_GT_GT_EQ] = ACTIONS(1239),
    [anon_sym_AMP_EQ] = ACTIONS(1239),
    [anon_sym_CARET_EQ] = ACTIONS(1239),
    [anon_sym_PIPE_EQ] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_PIPE_PIPE] = ACTIONS(1243),
    [anon_sym_AMP_AMP] = ACTIONS(1245),
    [anon_sym_PIPE] = ACTIONS(1247),
    [anon_sym_CARET] = ACTIONS(1249),
    [anon_sym_EQ_EQ] = ACTIONS(1251),
    [anon_sym_BANG_EQ] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1253),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [595] = {
    [anon_sym_RPAREN] = ACTIONS(2170),
    [sym_comment] = ACTIONS(42),
  },
  [596] = {
    [sym_type_qualifier] = STATE(133),
    [sym__type_specifier] = STATE(131),
    [sym_sized_type_specifier] = STATE(131),
    [sym_enum_specifier] = STATE(131),
    [sym_struct_specifier] = STATE(131),
    [sym_union_specifier] = STATE(131),
    [sym__expression] = STATE(436),
    [sym_comma_expression] = STATE(437),
    [sym_conditional_expression] = STATE(436),
    [sym_assignment_expression] = STATE(436),
    [sym_pointer_expression] = STATE(436),
    [sym_logical_expression] = STATE(436),
    [sym_bitwise_expression] = STATE(436),
    [sym_equality_expression] = STATE(436),
    [sym_relational_expression] = STATE(436),
    [sym_shift_expression] = STATE(436),
    [sym_math_expression] = STATE(436),
    [sym_cast_expression] = STATE(436),
    [sym_type_descriptor] = STATE(862),
    [sym_sizeof_expression] = STATE(436),
    [sym_subscript_expression] = STATE(436),
    [sym_call_expression] = STATE(436),
    [sym_field_expression] = STATE(436),
    [sym_compound_literal_expression] = STATE(436),
    [sym_parenthesized_expression] = STATE(436),
    [sym_concatenated_string] = STATE(436),
    [sym_macro_type_specifier] = STATE(131),
    [aux_sym_type_definition_repeat1] = STATE(133),
    [aux_sym_sized_type_specifier_repeat1] = STATE(134),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(248),
    [anon_sym_long] = ACTIONS(248),
    [anon_sym_short] = ACTIONS(248),
    [sym_primitive_type] = ACTIONS(250),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1019),
    [sym_char_literal] = ACTIONS(1019),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(1023),
    [sym_false] = ACTIONS(1023),
    [sym_null] = ACTIONS(1023),
    [sym_identifier] = ACTIONS(1025),
    [sym_comment] = ACTIONS(42),
  },
  [597] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1825),
    [anon_sym_RBRACE] = ACTIONS(1825),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1827),
    [anon_sym_QMARK] = ACTIONS(1825),
    [anon_sym_STAR_EQ] = ACTIONS(1825),
    [anon_sym_SLASH_EQ] = ACTIONS(1825),
    [anon_sym_PERCENT_EQ] = ACTIONS(1825),
    [anon_sym_PLUS_EQ] = ACTIONS(1825),
    [anon_sym_DASH_EQ] = ACTIONS(1825),
    [anon_sym_LT_LT_EQ] = ACTIONS(1825),
    [anon_sym_GT_GT_EQ] = ACTIONS(1825),
    [anon_sym_AMP_EQ] = ACTIONS(1825),
    [anon_sym_CARET_EQ] = ACTIONS(1825),
    [anon_sym_PIPE_EQ] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1827),
    [anon_sym_PIPE_PIPE] = ACTIONS(1825),
    [anon_sym_AMP_AMP] = ACTIONS(1825),
    [anon_sym_PIPE] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1827),
    [anon_sym_EQ_EQ] = ACTIONS(1825),
    [anon_sym_BANG_EQ] = ACTIONS(1825),
    [anon_sym_LT] = ACTIONS(1827),
    [anon_sym_GT] = ACTIONS(1827),
    [anon_sym_LT_EQ] = ACTIONS(1825),
    [anon_sym_GT_EQ] = ACTIONS(1825),
    [anon_sym_LT_LT] = ACTIONS(1451),
    [anon_sym_GT_GT] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_SLASH] = ACTIONS(1427),
    [anon_sym_PERCENT] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [598] = {
    [aux_sym_concatenated_string_repeat1] = STATE(863),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_COMMA] = ACTIONS(1829),
    [anon_sym_RBRACE] = ACTIONS(1829),
    [anon_sym_STAR] = ACTIONS(1831),
    [anon_sym_LBRACK] = ACTIONS(1829),
    [anon_sym_EQ] = ACTIONS(1831),
    [anon_sym_QMARK] = ACTIONS(1829),
    [anon_sym_STAR_EQ] = ACTIONS(1829),
    [anon_sym_SLASH_EQ] = ACTIONS(1829),
    [anon_sym_PERCENT_EQ] = ACTIONS(1829),
    [anon_sym_PLUS_EQ] = ACTIONS(1829),
    [anon_sym_DASH_EQ] = ACTIONS(1829),
    [anon_sym_LT_LT_EQ] = ACTIONS(1829),
    [anon_sym_GT_GT_EQ] = ACTIONS(1829),
    [anon_sym_AMP_EQ] = ACTIONS(1829),
    [anon_sym_CARET_EQ] = ACTIONS(1829),
    [anon_sym_PIPE_EQ] = ACTIONS(1829),
    [anon_sym_AMP] = ACTIONS(1831),
    [anon_sym_PIPE_PIPE] = ACTIONS(1829),
    [anon_sym_AMP_AMP] = ACTIONS(1829),
    [anon_sym_PIPE] = ACTIONS(1831),
    [anon_sym_CARET] = ACTIONS(1831),
    [anon_sym_EQ_EQ] = ACTIONS(1829),
    [anon_sym_BANG_EQ] = ACTIONS(1829),
    [anon_sym_LT] = ACTIONS(1831),
    [anon_sym_GT] = ACTIONS(1831),
    [anon_sym_LT_EQ] = ACTIONS(1829),
    [anon_sym_GT_EQ] = ACTIONS(1829),
    [anon_sym_LT_LT] = ACTIONS(1831),
    [anon_sym_GT_GT] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_SLASH] = ACTIONS(1831),
    [anon_sym_PERCENT] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1829),
    [anon_sym_PLUS_PLUS] = ACTIONS(1829),
    [anon_sym_DOT] = ACTIONS(1829),
    [anon_sym_DASH_GT] = ACTIONS(1829),
    [sym_string_literal] = ACTIONS(2172),
    [sym_comment] = ACTIONS(42),
  },
  [599] = {
    [sym__expression] = STATE(787),
    [sym_conditional_expression] = STATE(787),
    [sym_assignment_expression] = STATE(787),
    [sym_pointer_expression] = STATE(787),
    [sym_logical_expression] = STATE(787),
    [sym_bitwise_expression] = STATE(787),
    [sym_equality_expression] = STATE(787),
    [sym_relational_expression] = STATE(787),
    [sym_shift_expression] = STATE(787),
    [sym_math_expression] = STATE(787),
    [sym_cast_expression] = STATE(787),
    [sym_sizeof_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_call_expression] = STATE(787),
    [sym_field_expression] = STATE(787),
    [sym_compound_literal_expression] = STATE(787),
    [sym_parenthesized_expression] = STATE(787),
    [sym_concatenated_string] = STATE(787),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [sym_number_literal] = ACTIONS(1853),
    [sym_char_literal] = ACTIONS(1853),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(1855),
    [sym_false] = ACTIONS(1855),
    [sym_null] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_comment] = ACTIONS(42),
  },
  [600] = {
    [sym__expression] = STATE(864),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(864),
    [sym_logical_expression] = STATE(864),
    [sym_bitwise_expression] = STATE(864),
    [sym_equality_expression] = STATE(864),
    [sym_relational_expression] = STATE(864),
    [sym_shift_expression] = STATE(864),
    [sym_math_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_call_expression] = STATE(864),
    [sym_field_expression] = STATE(864),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [sym_number_literal] = ACTIONS(2174),
    [sym_char_literal] = ACTIONS(2174),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(2176),
    [sym_false] = ACTIONS(2176),
    [sym_null] = ACTIONS(2176),
    [sym_identifier] = ACTIONS(2176),
    [sym_comment] = ACTIONS(42),
  },
  [601] = {
    [sym__expression] = STATE(865),
    [sym_conditional_expression] = STATE(865),
    [sym_assignment_expression] = STATE(865),
    [sym_pointer_expression] = STATE(865),
    [sym_logical_expression] = STATE(865),
    [sym_bitwise_expression] = STATE(865),
    [sym_equality_expression] = STATE(865),
    [sym_relational_expression] = STATE(865),
    [sym_shift_expression] = STATE(865),
    [sym_math_expression] = STATE(865),
    [sym_cast_expression] = STATE(865),
    [sym_sizeof_expression] = STATE(865),
    [sym_subscript_expression] = STATE(865),
    [sym_call_expression] = STATE(865),
    [sym_field_expression] = STATE(865),
    [sym_compound_literal_expression] = STATE(865),
    [sym_parenthesized_expression] = STATE(865),
    [sym_concatenated_string] = STATE(865),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(2178),
    [sym_char_literal] = ACTIONS(2178),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(2180),
    [sym_false] = ACTIONS(2180),
    [sym_null] = ACTIONS(2180),
    [sym_identifier] = ACTIONS(2180),
    [sym_comment] = ACTIONS(42),
  },
  [602] = {
    [sym__expression] = STATE(866),
    [sym_conditional_expression] = STATE(866),
    [sym_assignment_expression] = STATE(866),
    [sym_pointer_expression] = STATE(866),
    [sym_logical_expression] = STATE(866),
    [sym_bitwise_expression] = STATE(866),
    [sym_equality_expression] = STATE(866),
    [sym_relational_expression] = STATE(866),
    [sym_shift_expression] = STATE(866),
    [sym_math_expression] = STATE(866),
    [sym_cast_expression] = STATE(866),
    [sym_sizeof_expression] = STATE(866),
    [sym_subscript_expression] = STATE(866),
    [sym_call_expression] = STATE(866),
    [sym_field_expression] = STATE(866),
    [sym_compound_literal_expression] = STATE(866),
    [sym_parenthesized_expression] = STATE(866),
    [sym_concatenated_string] = STATE(866),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [sym_number_literal] = ACTIONS(2182),
    [sym_char_literal] = ACTIONS(2182),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(2184),
    [sym_false] = ACTIONS(2184),
    [sym_null] = ACTIONS(2184),
    [sym_identifier] = ACTIONS(2184),
    [sym_comment] = ACTIONS(42),
  },
  [603] = {
    [sym__expression] = STATE(867),
    [sym_conditional_expression] = STATE(867),
    [sym_assignment_expression] = STATE(867),
    [sym_pointer_expression] = STATE(867),
    [sym_logical_expression] = STATE(867),
    [sym_bitwise_expression] = STATE(867),
    [sym_equality_expression] = STATE(867),
    [sym_relational_expression] = STATE(867),
    [sym_shift_expression] = STATE(867),
    [sym_math_expression] = STATE(867),
    [sym_cast_expression] = STATE(867),
    [sym_sizeof_expression] = STATE(867),
    [sym_subscript_expression] = STATE(867),
    [sym_call_expression] = STATE(867),
    [sym_field_expression] = STATE(867),
    [sym_compound_literal_expression] = STATE(867),
    [sym_parenthesized_expression] = STATE(867),
    [sym_concatenated_string] = STATE(867),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [sym_number_literal] = ACTIONS(2186),
    [sym_char_literal] = ACTIONS(2186),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(2188),
    [sym_false] = ACTIONS(2188),
    [sym_null] = ACTIONS(2188),
    [sym_identifier] = ACTIONS(2188),
    [sym_comment] = ACTIONS(42),
  },
  [604] = {
    [sym__expression] = STATE(868),
    [sym_conditional_expression] = STATE(868),
    [sym_assignment_expression] = STATE(868),
    [sym_pointer_expression] = STATE(868),
    [sym_logical_expression] = STATE(868),
    [sym_bitwise_expression] = STATE(868),
    [sym_equality_expression] = STATE(868),
    [sym_relational_expression] = STATE(868),
    [sym_shift_expression] = STATE(868),
    [sym_math_expression] = STATE(868),
    [sym_cast_expression] = STATE(868),
    [sym_sizeof_expression] = STATE(868),
    [sym_subscript_expression] = STATE(868),
    [sym_call_expression] = STATE(868),
    [sym_field_expression] = STATE(868),
    [sym_compound_literal_expression] = STATE(868),
    [sym_parenthesized_expression] = STATE(868),
    [sym_concatenated_string] = STATE(868),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [sym_number_literal] = ACTIONS(2190),
    [sym_char_literal] = ACTIONS(2190),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(2192),
    [sym_false] = ACTIONS(2192),
    [sym_null] = ACTIONS(2192),
    [sym_identifier] = ACTIONS(2192),
    [sym_comment] = ACTIONS(42),
  },
  [605] = {
    [sym__expression] = STATE(869),
    [sym_conditional_expression] = STATE(869),
    [sym_assignment_expression] = STATE(869),
    [sym_pointer_expression] = STATE(869),
    [sym_logical_expression] = STATE(869),
    [sym_bitwise_expression] = STATE(869),
    [sym_equality_expression] = STATE(869),
    [sym_relational_expression] = STATE(869),
    [sym_shift_expression] = STATE(869),
    [sym_math_expression] = STATE(869),
    [sym_cast_expression] = STATE(869),
    [sym_sizeof_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_call_expression] = STATE(869),
    [sym_field_expression] = STATE(869),
    [sym_compound_literal_expression] = STATE(869),
    [sym_parenthesized_expression] = STATE(869),
    [sym_concatenated_string] = STATE(869),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [sym_number_literal] = ACTIONS(2194),
    [sym_char_literal] = ACTIONS(2194),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(2196),
    [sym_false] = ACTIONS(2196),
    [sym_null] = ACTIONS(2196),
    [sym_identifier] = ACTIONS(2196),
    [sym_comment] = ACTIONS(42),
  },
  [606] = {
    [sym__expression] = STATE(870),
    [sym_conditional_expression] = STATE(870),
    [sym_assignment_expression] = STATE(870),
    [sym_pointer_expression] = STATE(870),
    [sym_logical_expression] = STATE(870),
    [sym_bitwise_expression] = STATE(870),
    [sym_equality_expression] = STATE(870),
    [sym_relational_expression] = STATE(870),
    [sym_shift_expression] = STATE(870),
    [sym_math_expression] = STATE(870),
    [sym_cast_expression] = STATE(870),
    [sym_sizeof_expression] = STATE(870),
    [sym_subscript_expression] = STATE(870),
    [sym_call_expression] = STATE(870),
    [sym_field_expression] = STATE(870),
    [sym_compound_literal_expression] = STATE(870),
    [sym_parenthesized_expression] = STATE(870),
    [sym_concatenated_string] = STATE(870),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [sym_number_literal] = ACTIONS(2198),
    [sym_char_literal] = ACTIONS(2198),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(2200),
    [sym_false] = ACTIONS(2200),
    [sym_null] = ACTIONS(2200),
    [sym_identifier] = ACTIONS(2200),
    [sym_comment] = ACTIONS(42),
  },
  [607] = {
    [sym__expression] = STATE(871),
    [sym_conditional_expression] = STATE(871),
    [sym_assignment_expression] = STATE(871),
    [sym_pointer_expression] = STATE(871),
    [sym_logical_expression] = STATE(871),
    [sym_bitwise_expression] = STATE(871),
    [sym_equality_expression] = STATE(871),
    [sym_relational_expression] = STATE(871),
    [sym_shift_expression] = STATE(871),
    [sym_math_expression] = STATE(871),
    [sym_cast_expression] = STATE(871),
    [sym_sizeof_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_call_expression] = STATE(871),
    [sym_field_expression] = STATE(871),
    [sym_compound_literal_expression] = STATE(871),
    [sym_parenthesized_expression] = STATE(871),
    [sym_concatenated_string] = STATE(871),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [sym_number_literal] = ACTIONS(2202),
    [sym_char_literal] = ACTIONS(2202),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_identifier] = ACTIONS(2204),
    [sym_comment] = ACTIONS(42),
  },
  [608] = {
    [sym__expression] = STATE(872),
    [sym_conditional_expression] = STATE(872),
    [sym_assignment_expression] = STATE(872),
    [sym_pointer_expression] = STATE(872),
    [sym_logical_expression] = STATE(872),
    [sym_bitwise_expression] = STATE(872),
    [sym_equality_expression] = STATE(872),
    [sym_relational_expression] = STATE(872),
    [sym_shift_expression] = STATE(872),
    [sym_math_expression] = STATE(872),
    [sym_cast_expression] = STATE(872),
    [sym_sizeof_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_call_expression] = STATE(872),
    [sym_field_expression] = STATE(872),
    [sym_compound_literal_expression] = STATE(872),
    [sym_parenthesized_expression] = STATE(872),
    [sym_concatenated_string] = STATE(872),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [sym_number_literal] = ACTIONS(2206),
    [sym_char_literal] = ACTIONS(2206),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(2208),
    [sym_false] = ACTIONS(2208),
    [sym_null] = ACTIONS(2208),
    [sym_identifier] = ACTIONS(2208),
    [sym_comment] = ACTIONS(42),
  },
  [609] = {
    [sym__expression] = STATE(873),
    [sym_conditional_expression] = STATE(873),
    [sym_assignment_expression] = STATE(873),
    [sym_pointer_expression] = STATE(873),
    [sym_logical_expression] = STATE(873),
    [sym_bitwise_expression] = STATE(873),
    [sym_equality_expression] = STATE(873),
    [sym_relational_expression] = STATE(873),
    [sym_shift_expression] = STATE(873),
    [sym_math_expression] = STATE(873),
    [sym_cast_expression] = STATE(873),
    [sym_sizeof_expression] = STATE(873),
    [sym_subscript_expression] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_field_expression] = STATE(873),
    [sym_compound_literal_expression] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym_concatenated_string] = STATE(873),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [sym_number_literal] = ACTIONS(2210),
    [sym_char_literal] = ACTIONS(2210),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(2212),
    [sym_false] = ACTIONS(2212),
    [sym_null] = ACTIONS(2212),
    [sym_identifier] = ACTIONS(2212),
    [sym_comment] = ACTIONS(42),
  },
  [610] = {
    [sym__expression] = STATE(874),
    [sym_conditional_expression] = STATE(874),
    [sym_assignment_expression] = STATE(874),
    [sym_pointer_expression] = STATE(874),
    [sym_logical_expression] = STATE(874),
    [sym_bitwise_expression] = STATE(874),
    [sym_equality_expression] = STATE(874),
    [sym_relational_expression] = STATE(874),
    [sym_shift_expression] = STATE(874),
    [sym_math_expression] = STATE(874),
    [sym_cast_expression] = STATE(874),
    [sym_sizeof_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_call_expression] = STATE(874),
    [sym_field_expression] = STATE(874),
    [sym_compound_literal_expression] = STATE(874),
    [sym_parenthesized_expression] = STATE(874),
    [sym_concatenated_string] = STATE(874),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [sym_number_literal] = ACTIONS(2214),
    [sym_char_literal] = ACTIONS(2214),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(2216),
    [sym_false] = ACTIONS(2216),
    [sym_null] = ACTIONS(2216),
    [sym_identifier] = ACTIONS(2216),
    [sym_comment] = ACTIONS(42),
  },
  [611] = {
    [anon_sym_LPAREN] = ACTIONS(2218),
    [anon_sym_COMMA] = ACTIONS(2218),
    [anon_sym_RPAREN] = ACTIONS(2218),
    [anon_sym_SEMI] = ACTIONS(2218),
    [anon_sym_extern] = ACTIONS(2220),
    [anon_sym_STAR] = ACTIONS(2218),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_static] = ACTIONS(2220),
    [anon_sym_auto] = ACTIONS(2220),
    [anon_sym_register] = ACTIONS(2220),
    [anon_sym_inline] = ACTIONS(2220),
    [anon_sym_const] = ACTIONS(2220),
    [anon_sym_restrict] = ACTIONS(2220),
    [anon_sym_volatile] = ACTIONS(2220),
    [anon_sym__Atomic] = ACTIONS(2220),
    [anon_sym_COLON] = ACTIONS(2218),
    [sym_identifier] = ACTIONS(2220),
    [sym_comment] = ACTIONS(42),
  },
  [612] = {
    [sym_enumerator] = STATE(372),
    [sym_identifier] = ACTIONS(210),
    [sym_comment] = ACTIONS(42),
  },
  [613] = {
    [sym__declaration_specifiers] = STATE(124),
    [sym_storage_class_specifier] = STATE(126),
    [sym_type_qualifier] = STATE(126),
    [sym__type_specifier] = STATE(125),
    [sym_sized_type_specifier] = STATE(125),
    [sym_enum_specifier] = STATE(125),
    [sym_struct_specifier] = STATE(125),
    [sym_union_specifier] = STATE(125),
    [sym_field_declaration] = STATE(875),
    [sym_macro_type_specifier] = STATE(125),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(875),
    [aux_sym__declaration_specifiers_repeat1] = STATE(126),
    [aux_sym_sized_type_specifier_repeat1] = STATE(127),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(228),
    [anon_sym_long] = ACTIONS(228),
    [anon_sym_short] = ACTIONS(228),
    [sym_primitive_type] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [614] = {
    [sym_preproc_else_in_field_declaration_list] = STATE(876),
    [sym_preproc_elif_in_field_declaration_list] = STATE(877),
    [sym__declaration_specifiers] = STATE(124),
    [sym_storage_class_specifier] = STATE(126),
    [sym_type_qualifier] = STATE(126),
    [sym__type_specifier] = STATE(125),
    [sym_sized_type_specifier] = STATE(125),
    [sym_enum_specifier] = STATE(125),
    [sym_struct_specifier] = STATE(125),
    [sym_union_specifier] = STATE(125),
    [sym_field_declaration] = STATE(878),
    [sym_macro_type_specifier] = STATE(125),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(878),
    [aux_sym__declaration_specifiers_repeat1] = STATE(126),
    [aux_sym_sized_type_specifier_repeat1] = STATE(127),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2224),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(868),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(228),
    [anon_sym_long] = ACTIONS(228),
    [anon_sym_short] = ACTIONS(228),
    [sym_primitive_type] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [615] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2226),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2228),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2228),
    [anon_sym_extern] = ACTIONS(2226),
    [anon_sym_RBRACE] = ACTIONS(2228),
    [anon_sym_static] = ACTIONS(2226),
    [anon_sym_auto] = ACTIONS(2226),
    [anon_sym_register] = ACTIONS(2226),
    [anon_sym_inline] = ACTIONS(2226),
    [anon_sym_const] = ACTIONS(2226),
    [anon_sym_restrict] = ACTIONS(2226),
    [anon_sym_volatile] = ACTIONS(2226),
    [anon_sym__Atomic] = ACTIONS(2226),
    [anon_sym_unsigned] = ACTIONS(2226),
    [anon_sym_long] = ACTIONS(2226),
    [anon_sym_short] = ACTIONS(2226),
    [sym_primitive_type] = ACTIONS(2226),
    [anon_sym_enum] = ACTIONS(2226),
    [anon_sym_struct] = ACTIONS(2226),
    [anon_sym_union] = ACTIONS(2226),
    [sym_identifier] = ACTIONS(2226),
    [sym_comment] = ACTIONS(42),
  },
  [616] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2230),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2232),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2232),
    [anon_sym_extern] = ACTIONS(2230),
    [anon_sym_RBRACE] = ACTIONS(2232),
    [anon_sym_static] = ACTIONS(2230),
    [anon_sym_auto] = ACTIONS(2230),
    [anon_sym_register] = ACTIONS(2230),
    [anon_sym_inline] = ACTIONS(2230),
    [anon_sym_const] = ACTIONS(2230),
    [anon_sym_restrict] = ACTIONS(2230),
    [anon_sym_volatile] = ACTIONS(2230),
    [anon_sym__Atomic] = ACTIONS(2230),
    [anon_sym_unsigned] = ACTIONS(2230),
    [anon_sym_long] = ACTIONS(2230),
    [anon_sym_short] = ACTIONS(2230),
    [sym_primitive_type] = ACTIONS(2230),
    [anon_sym_enum] = ACTIONS(2230),
    [anon_sym_struct] = ACTIONS(2230),
    [anon_sym_union] = ACTIONS(2230),
    [sym_identifier] = ACTIONS(2230),
    [sym_comment] = ACTIONS(42),
  },
  [617] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2234),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2236),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2236),
    [anon_sym_extern] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2236),
    [anon_sym_static] = ACTIONS(2234),
    [anon_sym_auto] = ACTIONS(2234),
    [anon_sym_register] = ACTIONS(2234),
    [anon_sym_inline] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2234),
    [anon_sym_restrict] = ACTIONS(2234),
    [anon_sym_volatile] = ACTIONS(2234),
    [anon_sym__Atomic] = ACTIONS(2234),
    [anon_sym_unsigned] = ACTIONS(2234),
    [anon_sym_long] = ACTIONS(2234),
    [anon_sym_short] = ACTIONS(2234),
    [sym_primitive_type] = ACTIONS(2234),
    [anon_sym_enum] = ACTIONS(2234),
    [anon_sym_struct] = ACTIONS(2234),
    [anon_sym_union] = ACTIONS(2234),
    [sym_identifier] = ACTIONS(2234),
    [sym_comment] = ACTIONS(42),
  },
  [618] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2238),
    [sym_comment] = ACTIONS(42),
  },
  [619] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2240),
    [sym_comment] = ACTIONS(42),
  },
  [620] = {
    [sym__declaration_specifiers] = STATE(124),
    [sym_storage_class_specifier] = STATE(126),
    [sym_type_qualifier] = STATE(126),
    [sym__type_specifier] = STATE(125),
    [sym_sized_type_specifier] = STATE(125),
    [sym_enum_specifier] = STATE(125),
    [sym_struct_specifier] = STATE(125),
    [sym_union_specifier] = STATE(125),
    [sym_field_declaration] = STATE(620),
    [sym_macro_type_specifier] = STATE(125),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(620),
    [aux_sym__declaration_specifiers_repeat1] = STATE(126),
    [aux_sym_sized_type_specifier_repeat1] = STATE(127),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2242),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2242),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2242),
    [anon_sym_extern] = ACTIONS(2244),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_auto] = ACTIONS(2244),
    [anon_sym_register] = ACTIONS(2244),
    [anon_sym_inline] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2247),
    [anon_sym_restrict] = ACTIONS(2247),
    [anon_sym_volatile] = ACTIONS(2247),
    [anon_sym__Atomic] = ACTIONS(2247),
    [anon_sym_unsigned] = ACTIONS(2250),
    [anon_sym_long] = ACTIONS(2250),
    [anon_sym_short] = ACTIONS(2250),
    [sym_primitive_type] = ACTIONS(2253),
    [anon_sym_enum] = ACTIONS(2256),
    [anon_sym_struct] = ACTIONS(2259),
    [anon_sym_union] = ACTIONS(2262),
    [sym_identifier] = ACTIONS(2265),
    [sym_comment] = ACTIONS(42),
  },
  [621] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2268),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2270),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2270),
    [anon_sym_extern] = ACTIONS(2268),
    [anon_sym_RBRACE] = ACTIONS(2270),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_auto] = ACTIONS(2268),
    [anon_sym_register] = ACTIONS(2268),
    [anon_sym_inline] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_restrict] = ACTIONS(2268),
    [anon_sym_volatile] = ACTIONS(2268),
    [anon_sym__Atomic] = ACTIONS(2268),
    [anon_sym_unsigned] = ACTIONS(2268),
    [anon_sym_long] = ACTIONS(2268),
    [anon_sym_short] = ACTIONS(2268),
    [sym_primitive_type] = ACTIONS(2268),
    [anon_sym_enum] = ACTIONS(2268),
    [anon_sym_struct] = ACTIONS(2268),
    [anon_sym_union] = ACTIONS(2268),
    [sym_identifier] = ACTIONS(2268),
    [sym_comment] = ACTIONS(42),
  },
  [622] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2272),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2274),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2274),
    [anon_sym_extern] = ACTIONS(2272),
    [anon_sym_RBRACE] = ACTIONS(2274),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_auto] = ACTIONS(2272),
    [anon_sym_register] = ACTIONS(2272),
    [anon_sym_inline] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_restrict] = ACTIONS(2272),
    [anon_sym_volatile] = ACTIONS(2272),
    [anon_sym__Atomic] = ACTIONS(2272),
    [anon_sym_unsigned] = ACTIONS(2272),
    [anon_sym_long] = ACTIONS(2272),
    [anon_sym_short] = ACTIONS(2272),
    [sym_primitive_type] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
    [anon_sym_struct] = ACTIONS(2272),
    [anon_sym_union] = ACTIONS(2272),
    [sym_identifier] = ACTIONS(2272),
    [sym_comment] = ACTIONS(42),
  },
  [623] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2276),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2278),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2278),
    [anon_sym_extern] = ACTIONS(2276),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_auto] = ACTIONS(2276),
    [anon_sym_register] = ACTIONS(2276),
    [anon_sym_inline] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_restrict] = ACTIONS(2276),
    [anon_sym_volatile] = ACTIONS(2276),
    [anon_sym__Atomic] = ACTIONS(2276),
    [anon_sym_unsigned] = ACTIONS(2276),
    [anon_sym_long] = ACTIONS(2276),
    [anon_sym_short] = ACTIONS(2276),
    [sym_primitive_type] = ACTIONS(2276),
    [anon_sym_enum] = ACTIONS(2276),
    [anon_sym_struct] = ACTIONS(2276),
    [anon_sym_union] = ACTIONS(2276),
    [sym_identifier] = ACTIONS(2276),
    [sym_comment] = ACTIONS(42),
  },
  [624] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2280),
    [sym_comment] = ACTIONS(42),
  },
  [625] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2282),
    [sym_comment] = ACTIONS(42),
  },
  [626] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2284),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2286),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_auto] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [sym_identifier] = ACTIONS(2284),
    [sym_comment] = ACTIONS(42),
  },
  [627] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2290),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2290),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2290),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_auto] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [sym_identifier] = ACTIONS(2288),
    [sym_comment] = ACTIONS(42),
  },
  [628] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2292),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2294),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2294),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_auto] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym_unsigned] = ACTIONS(2292),
    [anon_sym_long] = ACTIONS(2292),
    [anon_sym_short] = ACTIONS(2292),
    [sym_primitive_type] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [anon_sym_struct] = ACTIONS(2292),
    [anon_sym_union] = ACTIONS(2292),
    [sym_identifier] = ACTIONS(2292),
    [sym_comment] = ACTIONS(42),
  },
  [629] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2296),
    [sym_comment] = ACTIONS(42),
  },
  [630] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2298),
    [sym_comment] = ACTIONS(42),
  },
  [631] = {
    [anon_sym_LPAREN] = ACTIONS(2300),
    [anon_sym_COMMA] = ACTIONS(2300),
    [anon_sym_RPAREN] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_COLON] = ACTIONS(2300),
    [sym_comment] = ACTIONS(42),
  },
  [632] = {
    [anon_sym_RPAREN] = ACTIONS(2302),
    [sym_comment] = ACTIONS(42),
  },
  [633] = {
    [sym_type_qualifier] = STATE(133),
    [sym__type_specifier] = STATE(131),
    [sym_sized_type_specifier] = STATE(131),
    [sym_enum_specifier] = STATE(131),
    [sym_struct_specifier] = STATE(131),
    [sym_union_specifier] = STATE(131),
    [sym__expression] = STATE(436),
    [sym_comma_expression] = STATE(437),
    [sym_conditional_expression] = STATE(436),
    [sym_assignment_expression] = STATE(436),
    [sym_pointer_expression] = STATE(436),
    [sym_logical_expression] = STATE(436),
    [sym_bitwise_expression] = STATE(436),
    [sym_equality_expression] = STATE(436),
    [sym_relational_expression] = STATE(436),
    [sym_shift_expression] = STATE(436),
    [sym_math_expression] = STATE(436),
    [sym_cast_expression] = STATE(436),
    [sym_type_descriptor] = STATE(886),
    [sym_sizeof_expression] = STATE(436),
    [sym_subscript_expression] = STATE(436),
    [sym_call_expression] = STATE(436),
    [sym_field_expression] = STATE(436),
    [sym_compound_literal_expression] = STATE(436),
    [sym_parenthesized_expression] = STATE(436),
    [sym_concatenated_string] = STATE(436),
    [sym_macro_type_specifier] = STATE(131),
    [aux_sym_type_definition_repeat1] = STATE(133),
    [aux_sym_sized_type_specifier_repeat1] = STATE(134),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(248),
    [anon_sym_long] = ACTIONS(248),
    [anon_sym_short] = ACTIONS(248),
    [sym_primitive_type] = ACTIONS(250),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1019),
    [sym_char_literal] = ACTIONS(1019),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(1023),
    [sym_false] = ACTIONS(1023),
    [sym_null] = ACTIONS(1023),
    [sym_identifier] = ACTIONS(1025),
    [sym_comment] = ACTIONS(42),
  },
  [634] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(1825),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1827),
    [anon_sym_QMARK] = ACTIONS(1825),
    [anon_sym_STAR_EQ] = ACTIONS(1825),
    [anon_sym_SLASH_EQ] = ACTIONS(1825),
    [anon_sym_PERCENT_EQ] = ACTIONS(1825),
    [anon_sym_PLUS_EQ] = ACTIONS(1825),
    [anon_sym_DASH_EQ] = ACTIONS(1825),
    [anon_sym_LT_LT_EQ] = ACTIONS(1825),
    [anon_sym_GT_GT_EQ] = ACTIONS(1825),
    [anon_sym_AMP_EQ] = ACTIONS(1825),
    [anon_sym_CARET_EQ] = ACTIONS(1825),
    [anon_sym_PIPE_EQ] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1827),
    [anon_sym_PIPE_PIPE] = ACTIONS(1825),
    [anon_sym_AMP_AMP] = ACTIONS(1825),
    [anon_sym_PIPE] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1827),
    [anon_sym_EQ_EQ] = ACTIONS(1825),
    [anon_sym_BANG_EQ] = ACTIONS(1825),
    [anon_sym_LT] = ACTIONS(1827),
    [anon_sym_GT] = ACTIONS(1827),
    [anon_sym_LT_EQ] = ACTIONS(1825),
    [anon_sym_GT_EQ] = ACTIONS(1825),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [635] = {
    [aux_sym_concatenated_string_repeat1] = STATE(887),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_SEMI] = ACTIONS(1829),
    [anon_sym_STAR] = ACTIONS(1831),
    [anon_sym_LBRACK] = ACTIONS(1829),
    [anon_sym_EQ] = ACTIONS(1831),
    [anon_sym_QMARK] = ACTIONS(1829),
    [anon_sym_STAR_EQ] = ACTIONS(1829),
    [anon_sym_SLASH_EQ] = ACTIONS(1829),
    [anon_sym_PERCENT_EQ] = ACTIONS(1829),
    [anon_sym_PLUS_EQ] = ACTIONS(1829),
    [anon_sym_DASH_EQ] = ACTIONS(1829),
    [anon_sym_LT_LT_EQ] = ACTIONS(1829),
    [anon_sym_GT_GT_EQ] = ACTIONS(1829),
    [anon_sym_AMP_EQ] = ACTIONS(1829),
    [anon_sym_CARET_EQ] = ACTIONS(1829),
    [anon_sym_PIPE_EQ] = ACTIONS(1829),
    [anon_sym_AMP] = ACTIONS(1831),
    [anon_sym_PIPE_PIPE] = ACTIONS(1829),
    [anon_sym_AMP_AMP] = ACTIONS(1829),
    [anon_sym_PIPE] = ACTIONS(1831),
    [anon_sym_CARET] = ACTIONS(1831),
    [anon_sym_EQ_EQ] = ACTIONS(1829),
    [anon_sym_BANG_EQ] = ACTIONS(1829),
    [anon_sym_LT] = ACTIONS(1831),
    [anon_sym_GT] = ACTIONS(1831),
    [anon_sym_LT_EQ] = ACTIONS(1829),
    [anon_sym_GT_EQ] = ACTIONS(1829),
    [anon_sym_LT_LT] = ACTIONS(1831),
    [anon_sym_GT_GT] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_SLASH] = ACTIONS(1831),
    [anon_sym_PERCENT] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1829),
    [anon_sym_PLUS_PLUS] = ACTIONS(1829),
    [anon_sym_DOT] = ACTIONS(1829),
    [anon_sym_DASH_GT] = ACTIONS(1829),
    [sym_string_literal] = ACTIONS(2304),
    [sym_comment] = ACTIONS(42),
  },
  [636] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2306),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2308),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2308),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2308),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2308),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2306),
    [anon_sym_auto] = ACTIONS(2306),
    [anon_sym_register] = ACTIONS(2306),
    [anon_sym_inline] = ACTIONS(2306),
    [anon_sym_const] = ACTIONS(2306),
    [anon_sym_restrict] = ACTIONS(2306),
    [anon_sym_volatile] = ACTIONS(2306),
    [anon_sym__Atomic] = ACTIONS(2306),
    [anon_sym_unsigned] = ACTIONS(2306),
    [anon_sym_long] = ACTIONS(2306),
    [anon_sym_short] = ACTIONS(2306),
    [sym_primitive_type] = ACTIONS(2306),
    [anon_sym_enum] = ACTIONS(2306),
    [anon_sym_struct] = ACTIONS(2306),
    [anon_sym_union] = ACTIONS(2306),
    [sym_identifier] = ACTIONS(2306),
    [sym_comment] = ACTIONS(42),
  },
  [637] = {
    [sym__expression] = STATE(787),
    [sym_conditional_expression] = STATE(787),
    [sym_assignment_expression] = STATE(787),
    [sym_pointer_expression] = STATE(787),
    [sym_logical_expression] = STATE(787),
    [sym_bitwise_expression] = STATE(787),
    [sym_equality_expression] = STATE(787),
    [sym_relational_expression] = STATE(787),
    [sym_shift_expression] = STATE(787),
    [sym_math_expression] = STATE(787),
    [sym_cast_expression] = STATE(787),
    [sym_sizeof_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_call_expression] = STATE(787),
    [sym_field_expression] = STATE(787),
    [sym_compound_literal_expression] = STATE(787),
    [sym_parenthesized_expression] = STATE(787),
    [sym_concatenated_string] = STATE(787),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(1853),
    [sym_char_literal] = ACTIONS(1853),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(1855),
    [sym_false] = ACTIONS(1855),
    [sym_null] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_comment] = ACTIONS(42),
  },
  [638] = {
    [sym__expression] = STATE(888),
    [sym_conditional_expression] = STATE(888),
    [sym_assignment_expression] = STATE(888),
    [sym_pointer_expression] = STATE(888),
    [sym_logical_expression] = STATE(888),
    [sym_bitwise_expression] = STATE(888),
    [sym_equality_expression] = STATE(888),
    [sym_relational_expression] = STATE(888),
    [sym_shift_expression] = STATE(888),
    [sym_math_expression] = STATE(888),
    [sym_cast_expression] = STATE(888),
    [sym_sizeof_expression] = STATE(888),
    [sym_subscript_expression] = STATE(888),
    [sym_call_expression] = STATE(888),
    [sym_field_expression] = STATE(888),
    [sym_compound_literal_expression] = STATE(888),
    [sym_parenthesized_expression] = STATE(888),
    [sym_concatenated_string] = STATE(888),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(2310),
    [sym_char_literal] = ACTIONS(2310),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(2312),
    [sym_false] = ACTIONS(2312),
    [sym_null] = ACTIONS(2312),
    [sym_identifier] = ACTIONS(2312),
    [sym_comment] = ACTIONS(42),
  },
  [639] = {
    [sym__expression] = STATE(889),
    [sym_conditional_expression] = STATE(889),
    [sym_assignment_expression] = STATE(889),
    [sym_pointer_expression] = STATE(889),
    [sym_logical_expression] = STATE(889),
    [sym_bitwise_expression] = STATE(889),
    [sym_equality_expression] = STATE(889),
    [sym_relational_expression] = STATE(889),
    [sym_shift_expression] = STATE(889),
    [sym_math_expression] = STATE(889),
    [sym_cast_expression] = STATE(889),
    [sym_sizeof_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_call_expression] = STATE(889),
    [sym_field_expression] = STATE(889),
    [sym_compound_literal_expression] = STATE(889),
    [sym_parenthesized_expression] = STATE(889),
    [sym_concatenated_string] = STATE(889),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(2314),
    [sym_char_literal] = ACTIONS(2314),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(2316),
    [sym_false] = ACTIONS(2316),
    [sym_null] = ACTIONS(2316),
    [sym_identifier] = ACTIONS(2316),
    [sym_comment] = ACTIONS(42),
  },
  [640] = {
    [sym__expression] = STATE(890),
    [sym_conditional_expression] = STATE(890),
    [sym_assignment_expression] = STATE(890),
    [sym_pointer_expression] = STATE(890),
    [sym_logical_expression] = STATE(890),
    [sym_bitwise_expression] = STATE(890),
    [sym_equality_expression] = STATE(890),
    [sym_relational_expression] = STATE(890),
    [sym_shift_expression] = STATE(890),
    [sym_math_expression] = STATE(890),
    [sym_cast_expression] = STATE(890),
    [sym_sizeof_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_call_expression] = STATE(890),
    [sym_field_expression] = STATE(890),
    [sym_compound_literal_expression] = STATE(890),
    [sym_parenthesized_expression] = STATE(890),
    [sym_concatenated_string] = STATE(890),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(2318),
    [sym_char_literal] = ACTIONS(2318),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(2320),
    [sym_false] = ACTIONS(2320),
    [sym_null] = ACTIONS(2320),
    [sym_identifier] = ACTIONS(2320),
    [sym_comment] = ACTIONS(42),
  },
  [641] = {
    [sym__expression] = STATE(891),
    [sym_conditional_expression] = STATE(891),
    [sym_assignment_expression] = STATE(891),
    [sym_pointer_expression] = STATE(891),
    [sym_logical_expression] = STATE(891),
    [sym_bitwise_expression] = STATE(891),
    [sym_equality_expression] = STATE(891),
    [sym_relational_expression] = STATE(891),
    [sym_shift_expression] = STATE(891),
    [sym_math_expression] = STATE(891),
    [sym_cast_expression] = STATE(891),
    [sym_sizeof_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_call_expression] = STATE(891),
    [sym_field_expression] = STATE(891),
    [sym_compound_literal_expression] = STATE(891),
    [sym_parenthesized_expression] = STATE(891),
    [sym_concatenated_string] = STATE(891),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(2322),
    [sym_char_literal] = ACTIONS(2322),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(2324),
    [sym_false] = ACTIONS(2324),
    [sym_null] = ACTIONS(2324),
    [sym_identifier] = ACTIONS(2324),
    [sym_comment] = ACTIONS(42),
  },
  [642] = {
    [sym__expression] = STATE(892),
    [sym_conditional_expression] = STATE(892),
    [sym_assignment_expression] = STATE(892),
    [sym_pointer_expression] = STATE(892),
    [sym_logical_expression] = STATE(892),
    [sym_bitwise_expression] = STATE(892),
    [sym_equality_expression] = STATE(892),
    [sym_relational_expression] = STATE(892),
    [sym_shift_expression] = STATE(892),
    [sym_math_expression] = STATE(892),
    [sym_cast_expression] = STATE(892),
    [sym_sizeof_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_call_expression] = STATE(892),
    [sym_field_expression] = STATE(892),
    [sym_compound_literal_expression] = STATE(892),
    [sym_parenthesized_expression] = STATE(892),
    [sym_concatenated_string] = STATE(892),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(2326),
    [sym_char_literal] = ACTIONS(2326),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(2328),
    [sym_false] = ACTIONS(2328),
    [sym_null] = ACTIONS(2328),
    [sym_identifier] = ACTIONS(2328),
    [sym_comment] = ACTIONS(42),
  },
  [643] = {
    [sym__expression] = STATE(893),
    [sym_conditional_expression] = STATE(893),
    [sym_assignment_expression] = STATE(893),
    [sym_pointer_expression] = STATE(893),
    [sym_logical_expression] = STATE(893),
    [sym_bitwise_expression] = STATE(893),
    [sym_equality_expression] = STATE(893),
    [sym_relational_expression] = STATE(893),
    [sym_shift_expression] = STATE(893),
    [sym_math_expression] = STATE(893),
    [sym_cast_expression] = STATE(893),
    [sym_sizeof_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_call_expression] = STATE(893),
    [sym_field_expression] = STATE(893),
    [sym_compound_literal_expression] = STATE(893),
    [sym_parenthesized_expression] = STATE(893),
    [sym_concatenated_string] = STATE(893),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(2330),
    [sym_char_literal] = ACTIONS(2330),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(2332),
    [sym_false] = ACTIONS(2332),
    [sym_null] = ACTIONS(2332),
    [sym_identifier] = ACTIONS(2332),
    [sym_comment] = ACTIONS(42),
  },
  [644] = {
    [sym__expression] = STATE(894),
    [sym_conditional_expression] = STATE(894),
    [sym_assignment_expression] = STATE(894),
    [sym_pointer_expression] = STATE(894),
    [sym_logical_expression] = STATE(894),
    [sym_bitwise_expression] = STATE(894),
    [sym_equality_expression] = STATE(894),
    [sym_relational_expression] = STATE(894),
    [sym_shift_expression] = STATE(894),
    [sym_math_expression] = STATE(894),
    [sym_cast_expression] = STATE(894),
    [sym_sizeof_expression] = STATE(894),
    [sym_subscript_expression] = STATE(894),
    [sym_call_expression] = STATE(894),
    [sym_field_expression] = STATE(894),
    [sym_compound_literal_expression] = STATE(894),
    [sym_parenthesized_expression] = STATE(894),
    [sym_concatenated_string] = STATE(894),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(2334),
    [sym_char_literal] = ACTIONS(2334),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(2336),
    [sym_false] = ACTIONS(2336),
    [sym_null] = ACTIONS(2336),
    [sym_identifier] = ACTIONS(2336),
    [sym_comment] = ACTIONS(42),
  },
  [645] = {
    [sym__expression] = STATE(895),
    [sym_conditional_expression] = STATE(895),
    [sym_assignment_expression] = STATE(895),
    [sym_pointer_expression] = STATE(895),
    [sym_logical_expression] = STATE(895),
    [sym_bitwise_expression] = STATE(895),
    [sym_equality_expression] = STATE(895),
    [sym_relational_expression] = STATE(895),
    [sym_shift_expression] = STATE(895),
    [sym_math_expression] = STATE(895),
    [sym_cast_expression] = STATE(895),
    [sym_sizeof_expression] = STATE(895),
    [sym_subscript_expression] = STATE(895),
    [sym_call_expression] = STATE(895),
    [sym_field_expression] = STATE(895),
    [sym_compound_literal_expression] = STATE(895),
    [sym_parenthesized_expression] = STATE(895),
    [sym_concatenated_string] = STATE(895),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(2338),
    [sym_char_literal] = ACTIONS(2338),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(2340),
    [sym_false] = ACTIONS(2340),
    [sym_null] = ACTIONS(2340),
    [sym_identifier] = ACTIONS(2340),
    [sym_comment] = ACTIONS(42),
  },
  [646] = {
    [sym__expression] = STATE(896),
    [sym_conditional_expression] = STATE(896),
    [sym_assignment_expression] = STATE(896),
    [sym_pointer_expression] = STATE(896),
    [sym_logical_expression] = STATE(896),
    [sym_bitwise_expression] = STATE(896),
    [sym_equality_expression] = STATE(896),
    [sym_relational_expression] = STATE(896),
    [sym_shift_expression] = STATE(896),
    [sym_math_expression] = STATE(896),
    [sym_cast_expression] = STATE(896),
    [sym_sizeof_expression] = STATE(896),
    [sym_subscript_expression] = STATE(896),
    [sym_call_expression] = STATE(896),
    [sym_field_expression] = STATE(896),
    [sym_compound_literal_expression] = STATE(896),
    [sym_parenthesized_expression] = STATE(896),
    [sym_concatenated_string] = STATE(896),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(2342),
    [sym_char_literal] = ACTIONS(2342),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(2344),
    [sym_false] = ACTIONS(2344),
    [sym_null] = ACTIONS(2344),
    [sym_identifier] = ACTIONS(2344),
    [sym_comment] = ACTIONS(42),
  },
  [647] = {
    [sym__expression] = STATE(897),
    [sym_conditional_expression] = STATE(897),
    [sym_assignment_expression] = STATE(897),
    [sym_pointer_expression] = STATE(897),
    [sym_logical_expression] = STATE(897),
    [sym_bitwise_expression] = STATE(897),
    [sym_equality_expression] = STATE(897),
    [sym_relational_expression] = STATE(897),
    [sym_shift_expression] = STATE(897),
    [sym_math_expression] = STATE(897),
    [sym_cast_expression] = STATE(897),
    [sym_sizeof_expression] = STATE(897),
    [sym_subscript_expression] = STATE(897),
    [sym_call_expression] = STATE(897),
    [sym_field_expression] = STATE(897),
    [sym_compound_literal_expression] = STATE(897),
    [sym_parenthesized_expression] = STATE(897),
    [sym_concatenated_string] = STATE(897),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(2346),
    [sym_char_literal] = ACTIONS(2346),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(2348),
    [sym_false] = ACTIONS(2348),
    [sym_null] = ACTIONS(2348),
    [sym_identifier] = ACTIONS(2348),
    [sym_comment] = ACTIONS(42),
  },
  [648] = {
    [sym__expression] = STATE(898),
    [sym_conditional_expression] = STATE(898),
    [sym_assignment_expression] = STATE(898),
    [sym_pointer_expression] = STATE(898),
    [sym_logical_expression] = STATE(898),
    [sym_bitwise_expression] = STATE(898),
    [sym_equality_expression] = STATE(898),
    [sym_relational_expression] = STATE(898),
    [sym_shift_expression] = STATE(898),
    [sym_math_expression] = STATE(898),
    [sym_cast_expression] = STATE(898),
    [sym_sizeof_expression] = STATE(898),
    [sym_subscript_expression] = STATE(898),
    [sym_call_expression] = STATE(898),
    [sym_field_expression] = STATE(898),
    [sym_compound_literal_expression] = STATE(898),
    [sym_parenthesized_expression] = STATE(898),
    [sym_concatenated_string] = STATE(898),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(2350),
    [sym_char_literal] = ACTIONS(2350),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(2352),
    [sym_false] = ACTIONS(2352),
    [sym_null] = ACTIONS(2352),
    [sym_identifier] = ACTIONS(2352),
    [sym_comment] = ACTIONS(42),
  },
  [649] = {
    [sym_parameter_list] = STATE(404),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_COMMA] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_COLON] = ACTIONS(2354),
    [sym_comment] = ACTIONS(42),
  },
  [650] = {
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_COMMA] = ACTIONS(2356),
    [anon_sym_RPAREN] = ACTIONS(2356),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_COLON] = ACTIONS(2356),
    [sym_comment] = ACTIONS(42),
  },
  [651] = {
    [sym__expression] = STATE(900),
    [sym_conditional_expression] = STATE(900),
    [sym_assignment_expression] = STATE(900),
    [sym_pointer_expression] = STATE(900),
    [sym_logical_expression] = STATE(900),
    [sym_bitwise_expression] = STATE(900),
    [sym_equality_expression] = STATE(900),
    [sym_relational_expression] = STATE(900),
    [sym_shift_expression] = STATE(900),
    [sym_math_expression] = STATE(900),
    [sym_cast_expression] = STATE(900),
    [sym_sizeof_expression] = STATE(900),
    [sym_subscript_expression] = STATE(900),
    [sym_call_expression] = STATE(900),
    [sym_field_expression] = STATE(900),
    [sym_compound_literal_expression] = STATE(900),
    [sym_parenthesized_expression] = STATE(900),
    [sym_concatenated_string] = STATE(900),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(2358),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(2360),
    [sym_char_literal] = ACTIONS(2360),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(2362),
    [sym_false] = ACTIONS(2362),
    [sym_null] = ACTIONS(2362),
    [sym_identifier] = ACTIONS(2362),
    [sym_comment] = ACTIONS(42),
  },
  [652] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2358),
    [anon_sym_EQ] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1237),
    [anon_sym_STAR_EQ] = ACTIONS(1239),
    [anon_sym_SLASH_EQ] = ACTIONS(1239),
    [anon_sym_PERCENT_EQ] = ACTIONS(1239),
    [anon_sym_PLUS_EQ] = ACTIONS(1239),
    [anon_sym_DASH_EQ] = ACTIONS(1239),
    [anon_sym_LT_LT_EQ] = ACTIONS(1239),
    [anon_sym_GT_GT_EQ] = ACTIONS(1239),
    [anon_sym_AMP_EQ] = ACTIONS(1239),
    [anon_sym_CARET_EQ] = ACTIONS(1239),
    [anon_sym_PIPE_EQ] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_PIPE_PIPE] = ACTIONS(1243),
    [anon_sym_AMP_AMP] = ACTIONS(1245),
    [anon_sym_PIPE] = ACTIONS(1247),
    [anon_sym_CARET] = ACTIONS(1249),
    [anon_sym_EQ_EQ] = ACTIONS(1251),
    [anon_sym_BANG_EQ] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1253),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [653] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [654] = {
    [sym__expression] = STATE(902),
    [sym_conditional_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_pointer_expression] = STATE(902),
    [sym_logical_expression] = STATE(902),
    [sym_bitwise_expression] = STATE(902),
    [sym_equality_expression] = STATE(902),
    [sym_relational_expression] = STATE(902),
    [sym_shift_expression] = STATE(902),
    [sym_math_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_sizeof_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_call_expression] = STATE(902),
    [sym_field_expression] = STATE(902),
    [sym_compound_literal_expression] = STATE(902),
    [sym_parenthesized_expression] = STATE(902),
    [sym_concatenated_string] = STATE(902),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(2366),
    [sym_char_literal] = ACTIONS(2366),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(2368),
    [sym_false] = ACTIONS(2368),
    [sym_null] = ACTIONS(2368),
    [sym_identifier] = ACTIONS(2368),
    [sym_comment] = ACTIONS(42),
  },
  [655] = {
    [aux_sym_field_declaration_repeat1] = STATE(655),
    [anon_sym_COMMA] = ACTIONS(2370),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_COLON] = ACTIONS(2354),
    [sym_comment] = ACTIONS(42),
  },
  [656] = {
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym_COMMA] = ACTIONS(2373),
    [anon_sym_RPAREN] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [sym_comment] = ACTIONS(42),
  },
  [657] = {
    [anon_sym_LPAREN] = ACTIONS(2375),
    [anon_sym_COMMA] = ACTIONS(2375),
    [anon_sym_RPAREN] = ACTIONS(2375),
    [anon_sym_LBRACK] = ACTIONS(2375),
    [sym_comment] = ACTIONS(42),
  },
  [658] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2377),
    [anon_sym_EQ] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1237),
    [anon_sym_STAR_EQ] = ACTIONS(1239),
    [anon_sym_SLASH_EQ] = ACTIONS(1239),
    [anon_sym_PERCENT_EQ] = ACTIONS(1239),
    [anon_sym_PLUS_EQ] = ACTIONS(1239),
    [anon_sym_DASH_EQ] = ACTIONS(1239),
    [anon_sym_LT_LT_EQ] = ACTIONS(1239),
    [anon_sym_GT_GT_EQ] = ACTIONS(1239),
    [anon_sym_AMP_EQ] = ACTIONS(1239),
    [anon_sym_CARET_EQ] = ACTIONS(1239),
    [anon_sym_PIPE_EQ] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_PIPE_PIPE] = ACTIONS(1243),
    [anon_sym_AMP_AMP] = ACTIONS(1245),
    [anon_sym_PIPE] = ACTIONS(1247),
    [anon_sym_CARET] = ACTIONS(1249),
    [anon_sym_EQ_EQ] = ACTIONS(1251),
    [anon_sym_BANG_EQ] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1253),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [659] = {
    [sym__expression] = STATE(904),
    [sym_conditional_expression] = STATE(904),
    [sym_assignment_expression] = STATE(904),
    [sym_pointer_expression] = STATE(904),
    [sym_logical_expression] = STATE(904),
    [sym_bitwise_expression] = STATE(904),
    [sym_equality_expression] = STATE(904),
    [sym_relational_expression] = STATE(904),
    [sym_shift_expression] = STATE(904),
    [sym_math_expression] = STATE(904),
    [sym_cast_expression] = STATE(904),
    [sym_sizeof_expression] = STATE(904),
    [sym_subscript_expression] = STATE(904),
    [sym_call_expression] = STATE(904),
    [sym_field_expression] = STATE(904),
    [sym_compound_literal_expression] = STATE(904),
    [sym_parenthesized_expression] = STATE(904),
    [sym_concatenated_string] = STATE(904),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(2377),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(2379),
    [sym_char_literal] = ACTIONS(2379),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(2381),
    [sym_false] = ACTIONS(2381),
    [sym_null] = ACTIONS(2381),
    [sym_identifier] = ACTIONS(2381),
    [sym_comment] = ACTIONS(42),
  },
  [660] = {
    [anon_sym_COMMA] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(2383),
    [sym_comment] = ACTIONS(42),
  },
  [661] = {
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_COMMA] = ACTIONS(2385),
    [anon_sym_RPAREN] = ACTIONS(2385),
    [anon_sym_SEMI] = ACTIONS(2385),
    [anon_sym_LBRACE] = ACTIONS(2385),
    [anon_sym_LBRACK] = ACTIONS(2385),
    [anon_sym_EQ] = ACTIONS(2385),
    [anon_sym_COLON] = ACTIONS(2385),
    [sym_comment] = ACTIONS(42),
  },
  [662] = {
    [aux_sym_parameter_list_repeat1] = STATE(662),
    [anon_sym_COMMA] = ACTIONS(2387),
    [anon_sym_RPAREN] = ACTIONS(2383),
    [sym_comment] = ACTIONS(42),
  },
  [663] = {
    [sym__declarator] = STATE(137),
    [sym__abstract_declarator] = STATE(409),
    [sym_pointer_declarator] = STATE(137),
    [sym_abstract_pointer_declarator] = STATE(409),
    [sym_function_declarator] = STATE(137),
    [sym_abstract_function_declarator] = STATE(409),
    [sym_array_declarator] = STATE(137),
    [sym_abstract_array_declarator] = STATE(409),
    [sym_parameter_list] = STATE(232),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_RPAREN] = ACTIONS(958),
    [anon_sym_STAR] = ACTIONS(1582),
    [anon_sym_LBRACK] = ACTIONS(539),
    [sym_identifier] = ACTIONS(260),
    [sym_comment] = ACTIONS(42),
  },
  [664] = {
    [anon_sym_LPAREN] = ACTIONS(2390),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(2394),
    [anon_sym_extern] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_auto] = ACTIONS(95),
    [anon_sym_register] = ACTIONS(95),
    [anon_sym_inline] = ACTIONS(95),
    [anon_sym_const] = ACTIONS(95),
    [anon_sym_restrict] = ACTIONS(95),
    [anon_sym_volatile] = ACTIONS(95),
    [anon_sym__Atomic] = ACTIONS(95),
    [sym_identifier] = ACTIONS(95),
    [sym_comment] = ACTIONS(42),
  },
  [665] = {
    [sym_storage_class_specifier] = STATE(665),
    [sym_type_qualifier] = STATE(665),
    [aux_sym__declaration_specifiers_repeat1] = STATE(665),
    [anon_sym_LPAREN] = ACTIONS(681),
    [anon_sym_COMMA] = ACTIONS(681),
    [anon_sym_RPAREN] = ACTIONS(681),
    [anon_sym_extern] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(681),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_static] = ACTIONS(683),
    [anon_sym_auto] = ACTIONS(683),
    [anon_sym_register] = ACTIONS(683),
    [anon_sym_inline] = ACTIONS(683),
    [anon_sym_const] = ACTIONS(686),
    [anon_sym_restrict] = ACTIONS(686),
    [anon_sym_volatile] = ACTIONS(686),
    [anon_sym__Atomic] = ACTIONS(686),
    [sym_identifier] = ACTIONS(338),
    [sym_comment] = ACTIONS(42),
  },
  [666] = {
    [sym_storage_class_specifier] = STATE(665),
    [sym_type_qualifier] = STATE(665),
    [aux_sym__declaration_specifiers_repeat1] = STATE(665),
    [anon_sym_LPAREN] = ACTIONS(689),
    [anon_sym_COMMA] = ACTIONS(689),
    [anon_sym_RPAREN] = ACTIONS(689),
    [anon_sym_extern] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_auto] = ACTIONS(109),
    [anon_sym_register] = ACTIONS(109),
    [anon_sym_inline] = ACTIONS(109),
    [anon_sym_const] = ACTIONS(111),
    [anon_sym_restrict] = ACTIONS(111),
    [anon_sym_volatile] = ACTIONS(111),
    [anon_sym__Atomic] = ACTIONS(111),
    [sym_identifier] = ACTIONS(691),
    [sym_comment] = ACTIONS(42),
  },
  [667] = {
    [sym_preproc_arg] = ACTIONS(2397),
    [sym_comment] = ACTIONS(50),
  },
  [668] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(359),
    [anon_sym_LPAREN] = ACTIONS(357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(359),
    [sym_preproc_directive] = ACTIONS(359),
    [anon_sym_SEMI] = ACTIONS(357),
    [anon_sym_typedef] = ACTIONS(359),
    [anon_sym_extern] = ACTIONS(359),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_RBRACE] = ACTIONS(357),
    [anon_sym_STAR] = ACTIONS(357),
    [anon_sym_static] = ACTIONS(359),
    [anon_sym_auto] = ACTIONS(359),
    [anon_sym_register] = ACTIONS(359),
    [anon_sym_inline] = ACTIONS(359),
    [anon_sym_const] = ACTIONS(359),
    [anon_sym_restrict] = ACTIONS(359),
    [anon_sym_volatile] = ACTIONS(359),
    [anon_sym__Atomic] = ACTIONS(359),
    [anon_sym_unsigned] = ACTIONS(359),
    [anon_sym_long] = ACTIONS(359),
    [anon_sym_short] = ACTIONS(359),
    [sym_primitive_type] = ACTIONS(359),
    [anon_sym_enum] = ACTIONS(359),
    [anon_sym_struct] = ACTIONS(359),
    [anon_sym_union] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(359),
    [anon_sym_case] = ACTIONS(359),
    [anon_sym_default] = ACTIONS(359),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_do] = ACTIONS(359),
    [anon_sym_for] = ACTIONS(359),
    [anon_sym_return] = ACTIONS(359),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(359),
    [anon_sym_goto] = ACTIONS(359),
    [anon_sym_AMP] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_DASH_DASH] = ACTIONS(357),
    [anon_sym_PLUS_PLUS] = ACTIONS(357),
    [anon_sym_sizeof] = ACTIONS(359),
    [sym_number_literal] = ACTIONS(357),
    [sym_char_literal] = ACTIONS(357),
    [sym_string_literal] = ACTIONS(357),
    [sym_true] = ACTIONS(359),
    [sym_false] = ACTIONS(359),
    [sym_null] = ACTIONS(359),
    [sym_identifier] = ACTIONS(359),
    [sym_comment] = ACTIONS(42),
  },
  [669] = {
    [anon_sym_LF] = ACTIONS(2399),
    [sym_preproc_arg] = ACTIONS(2401),
    [sym_comment] = ACTIONS(50),
  },
  [670] = {
    [anon_sym_RPAREN] = ACTIONS(2403),
    [sym_comment] = ACTIONS(42),
  },
  [671] = {
    [sym_type_qualifier] = STATE(133),
    [sym__type_specifier] = STATE(131),
    [sym_sized_type_specifier] = STATE(131),
    [sym_enum_specifier] = STATE(131),
    [sym_struct_specifier] = STATE(131),
    [sym_union_specifier] = STATE(131),
    [sym__expression] = STATE(436),
    [sym_comma_expression] = STATE(437),
    [sym_conditional_expression] = STATE(436),
    [sym_assignment_expression] = STATE(436),
    [sym_pointer_expression] = STATE(436),
    [sym_logical_expression] = STATE(436),
    [sym_bitwise_expression] = STATE(436),
    [sym_equality_expression] = STATE(436),
    [sym_relational_expression] = STATE(436),
    [sym_shift_expression] = STATE(436),
    [sym_math_expression] = STATE(436),
    [sym_cast_expression] = STATE(436),
    [sym_type_descriptor] = STATE(909),
    [sym_sizeof_expression] = STATE(436),
    [sym_subscript_expression] = STATE(436),
    [sym_call_expression] = STATE(436),
    [sym_field_expression] = STATE(436),
    [sym_compound_literal_expression] = STATE(436),
    [sym_parenthesized_expression] = STATE(436),
    [sym_concatenated_string] = STATE(436),
    [sym_macro_type_specifier] = STATE(131),
    [aux_sym_type_definition_repeat1] = STATE(133),
    [aux_sym_sized_type_specifier_repeat1] = STATE(134),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(248),
    [anon_sym_long] = ACTIONS(248),
    [anon_sym_short] = ACTIONS(248),
    [sym_primitive_type] = ACTIONS(250),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1019),
    [sym_char_literal] = ACTIONS(1019),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(1023),
    [sym_false] = ACTIONS(1023),
    [sym_null] = ACTIONS(1023),
    [sym_identifier] = ACTIONS(1025),
    [sym_comment] = ACTIONS(42),
  },
  [672] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1825),
    [anon_sym_RPAREN] = ACTIONS(1825),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1827),
    [anon_sym_QMARK] = ACTIONS(1825),
    [anon_sym_STAR_EQ] = ACTIONS(1825),
    [anon_sym_SLASH_EQ] = ACTIONS(1825),
    [anon_sym_PERCENT_EQ] = ACTIONS(1825),
    [anon_sym_PLUS_EQ] = ACTIONS(1825),
    [anon_sym_DASH_EQ] = ACTIONS(1825),
    [anon_sym_LT_LT_EQ] = ACTIONS(1825),
    [anon_sym_GT_GT_EQ] = ACTIONS(1825),
    [anon_sym_AMP_EQ] = ACTIONS(1825),
    [anon_sym_CARET_EQ] = ACTIONS(1825),
    [anon_sym_PIPE_EQ] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1827),
    [anon_sym_PIPE_PIPE] = ACTIONS(1825),
    [anon_sym_AMP_AMP] = ACTIONS(1825),
    [anon_sym_PIPE] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1827),
    [anon_sym_EQ_EQ] = ACTIONS(1825),
    [anon_sym_BANG_EQ] = ACTIONS(1825),
    [anon_sym_LT] = ACTIONS(1827),
    [anon_sym_GT] = ACTIONS(1827),
    [anon_sym_LT_EQ] = ACTIONS(1825),
    [anon_sym_GT_EQ] = ACTIONS(1825),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [673] = {
    [aux_sym_concatenated_string_repeat1] = STATE(910),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_COMMA] = ACTIONS(1829),
    [anon_sym_RPAREN] = ACTIONS(1829),
    [anon_sym_STAR] = ACTIONS(1831),
    [anon_sym_LBRACK] = ACTIONS(1829),
    [anon_sym_EQ] = ACTIONS(1831),
    [anon_sym_QMARK] = ACTIONS(1829),
    [anon_sym_STAR_EQ] = ACTIONS(1829),
    [anon_sym_SLASH_EQ] = ACTIONS(1829),
    [anon_sym_PERCENT_EQ] = ACTIONS(1829),
    [anon_sym_PLUS_EQ] = ACTIONS(1829),
    [anon_sym_DASH_EQ] = ACTIONS(1829),
    [anon_sym_LT_LT_EQ] = ACTIONS(1829),
    [anon_sym_GT_GT_EQ] = ACTIONS(1829),
    [anon_sym_AMP_EQ] = ACTIONS(1829),
    [anon_sym_CARET_EQ] = ACTIONS(1829),
    [anon_sym_PIPE_EQ] = ACTIONS(1829),
    [anon_sym_AMP] = ACTIONS(1831),
    [anon_sym_PIPE_PIPE] = ACTIONS(1829),
    [anon_sym_AMP_AMP] = ACTIONS(1829),
    [anon_sym_PIPE] = ACTIONS(1831),
    [anon_sym_CARET] = ACTIONS(1831),
    [anon_sym_EQ_EQ] = ACTIONS(1829),
    [anon_sym_BANG_EQ] = ACTIONS(1829),
    [anon_sym_LT] = ACTIONS(1831),
    [anon_sym_GT] = ACTIONS(1831),
    [anon_sym_LT_EQ] = ACTIONS(1829),
    [anon_sym_GT_EQ] = ACTIONS(1829),
    [anon_sym_LT_LT] = ACTIONS(1831),
    [anon_sym_GT_GT] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_SLASH] = ACTIONS(1831),
    [anon_sym_PERCENT] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1829),
    [anon_sym_PLUS_PLUS] = ACTIONS(1829),
    [anon_sym_DOT] = ACTIONS(1829),
    [anon_sym_DASH_GT] = ACTIONS(1829),
    [sym_string_literal] = ACTIONS(2405),
    [sym_comment] = ACTIONS(42),
  },
  [674] = {
    [sym__expression] = STATE(911),
    [sym_comma_expression] = STATE(786),
    [sym_conditional_expression] = STATE(911),
    [sym_assignment_expression] = STATE(911),
    [sym_pointer_expression] = STATE(911),
    [sym_logical_expression] = STATE(911),
    [sym_bitwise_expression] = STATE(911),
    [sym_equality_expression] = STATE(911),
    [sym_relational_expression] = STATE(911),
    [sym_shift_expression] = STATE(911),
    [sym_math_expression] = STATE(911),
    [sym_cast_expression] = STATE(911),
    [sym_sizeof_expression] = STATE(911),
    [sym_subscript_expression] = STATE(911),
    [sym_call_expression] = STATE(911),
    [sym_field_expression] = STATE(911),
    [sym_compound_literal_expression] = STATE(911),
    [sym_parenthesized_expression] = STATE(911),
    [sym_concatenated_string] = STATE(911),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(2407),
    [sym_char_literal] = ACTIONS(2407),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(2409),
    [sym_false] = ACTIONS(2409),
    [sym_null] = ACTIONS(2409),
    [sym_identifier] = ACTIONS(2409),
    [sym_comment] = ACTIONS(42),
  },
  [675] = {
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2411),
    [anon_sym_RPAREN] = ACTIONS(2411),
    [anon_sym_SEMI] = ACTIONS(2411),
    [anon_sym_RBRACE] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_RBRACK] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_STAR_EQ] = ACTIONS(2411),
    [anon_sym_SLASH_EQ] = ACTIONS(2411),
    [anon_sym_PERCENT_EQ] = ACTIONS(2411),
    [anon_sym_PLUS_EQ] = ACTIONS(2411),
    [anon_sym_DASH_EQ] = ACTIONS(2411),
    [anon_sym_LT_LT_EQ] = ACTIONS(2411),
    [anon_sym_GT_GT_EQ] = ACTIONS(2411),
    [anon_sym_AMP_EQ] = ACTIONS(2411),
    [anon_sym_CARET_EQ] = ACTIONS(2411),
    [anon_sym_PIPE_EQ] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2413),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_PIPE] = ACTIONS(2413),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_EQ_EQ] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_GT] = ACTIONS(2413),
    [anon_sym_LT_EQ] = ACTIONS(2411),
    [anon_sym_GT_EQ] = ACTIONS(2411),
    [anon_sym_LT_LT] = ACTIONS(2413),
    [anon_sym_GT_GT] = ACTIONS(2413),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_PERCENT] = ACTIONS(2413),
    [anon_sym_DASH_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_PLUS] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [sym_comment] = ACTIONS(42),
  },
  [676] = {
    [sym__expression] = STATE(787),
    [sym_conditional_expression] = STATE(787),
    [sym_assignment_expression] = STATE(787),
    [sym_pointer_expression] = STATE(787),
    [sym_logical_expression] = STATE(787),
    [sym_bitwise_expression] = STATE(787),
    [sym_equality_expression] = STATE(787),
    [sym_relational_expression] = STATE(787),
    [sym_shift_expression] = STATE(787),
    [sym_math_expression] = STATE(787),
    [sym_cast_expression] = STATE(787),
    [sym_sizeof_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_call_expression] = STATE(787),
    [sym_field_expression] = STATE(787),
    [sym_compound_literal_expression] = STATE(787),
    [sym_parenthesized_expression] = STATE(787),
    [sym_concatenated_string] = STATE(787),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1853),
    [sym_char_literal] = ACTIONS(1853),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(1855),
    [sym_false] = ACTIONS(1855),
    [sym_null] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_comment] = ACTIONS(42),
  },
  [677] = {
    [sym__expression] = STATE(912),
    [sym_conditional_expression] = STATE(912),
    [sym_assignment_expression] = STATE(912),
    [sym_pointer_expression] = STATE(912),
    [sym_logical_expression] = STATE(912),
    [sym_bitwise_expression] = STATE(912),
    [sym_equality_expression] = STATE(912),
    [sym_relational_expression] = STATE(912),
    [sym_shift_expression] = STATE(912),
    [sym_math_expression] = STATE(912),
    [sym_cast_expression] = STATE(912),
    [sym_sizeof_expression] = STATE(912),
    [sym_subscript_expression] = STATE(912),
    [sym_call_expression] = STATE(912),
    [sym_field_expression] = STATE(912),
    [sym_compound_literal_expression] = STATE(912),
    [sym_parenthesized_expression] = STATE(912),
    [sym_concatenated_string] = STATE(912),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(2415),
    [sym_char_literal] = ACTIONS(2415),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(2417),
    [sym_false] = ACTIONS(2417),
    [sym_null] = ACTIONS(2417),
    [sym_identifier] = ACTIONS(2417),
    [sym_comment] = ACTIONS(42),
  },
  [678] = {
    [sym__expression] = STATE(913),
    [sym_conditional_expression] = STATE(913),
    [sym_assignment_expression] = STATE(913),
    [sym_pointer_expression] = STATE(913),
    [sym_logical_expression] = STATE(913),
    [sym_bitwise_expression] = STATE(913),
    [sym_equality_expression] = STATE(913),
    [sym_relational_expression] = STATE(913),
    [sym_shift_expression] = STATE(913),
    [sym_math_expression] = STATE(913),
    [sym_cast_expression] = STATE(913),
    [sym_sizeof_expression] = STATE(913),
    [sym_subscript_expression] = STATE(913),
    [sym_call_expression] = STATE(913),
    [sym_field_expression] = STATE(913),
    [sym_compound_literal_expression] = STATE(913),
    [sym_parenthesized_expression] = STATE(913),
    [sym_concatenated_string] = STATE(913),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(2419),
    [sym_char_literal] = ACTIONS(2419),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(2421),
    [sym_false] = ACTIONS(2421),
    [sym_null] = ACTIONS(2421),
    [sym_identifier] = ACTIONS(2421),
    [sym_comment] = ACTIONS(42),
  },
  [679] = {
    [sym__expression] = STATE(914),
    [sym_conditional_expression] = STATE(914),
    [sym_assignment_expression] = STATE(914),
    [sym_pointer_expression] = STATE(914),
    [sym_logical_expression] = STATE(914),
    [sym_bitwise_expression] = STATE(914),
    [sym_equality_expression] = STATE(914),
    [sym_relational_expression] = STATE(914),
    [sym_shift_expression] = STATE(914),
    [sym_math_expression] = STATE(914),
    [sym_cast_expression] = STATE(914),
    [sym_sizeof_expression] = STATE(914),
    [sym_subscript_expression] = STATE(914),
    [sym_call_expression] = STATE(914),
    [sym_field_expression] = STATE(914),
    [sym_compound_literal_expression] = STATE(914),
    [sym_parenthesized_expression] = STATE(914),
    [sym_concatenated_string] = STATE(914),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(2423),
    [sym_char_literal] = ACTIONS(2423),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(2425),
    [sym_false] = ACTIONS(2425),
    [sym_null] = ACTIONS(2425),
    [sym_identifier] = ACTIONS(2425),
    [sym_comment] = ACTIONS(42),
  },
  [680] = {
    [sym__expression] = STATE(915),
    [sym_conditional_expression] = STATE(915),
    [sym_assignment_expression] = STATE(915),
    [sym_pointer_expression] = STATE(915),
    [sym_logical_expression] = STATE(915),
    [sym_bitwise_expression] = STATE(915),
    [sym_equality_expression] = STATE(915),
    [sym_relational_expression] = STATE(915),
    [sym_shift_expression] = STATE(915),
    [sym_math_expression] = STATE(915),
    [sym_cast_expression] = STATE(915),
    [sym_sizeof_expression] = STATE(915),
    [sym_subscript_expression] = STATE(915),
    [sym_call_expression] = STATE(915),
    [sym_field_expression] = STATE(915),
    [sym_compound_literal_expression] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym_concatenated_string] = STATE(915),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(2427),
    [sym_char_literal] = ACTIONS(2427),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(2429),
    [sym_false] = ACTIONS(2429),
    [sym_null] = ACTIONS(2429),
    [sym_identifier] = ACTIONS(2429),
    [sym_comment] = ACTIONS(42),
  },
  [681] = {
    [sym__expression] = STATE(916),
    [sym_conditional_expression] = STATE(916),
    [sym_assignment_expression] = STATE(916),
    [sym_pointer_expression] = STATE(916),
    [sym_logical_expression] = STATE(916),
    [sym_bitwise_expression] = STATE(916),
    [sym_equality_expression] = STATE(916),
    [sym_relational_expression] = STATE(916),
    [sym_shift_expression] = STATE(916),
    [sym_math_expression] = STATE(916),
    [sym_cast_expression] = STATE(916),
    [sym_sizeof_expression] = STATE(916),
    [sym_subscript_expression] = STATE(916),
    [sym_call_expression] = STATE(916),
    [sym_field_expression] = STATE(916),
    [sym_compound_literal_expression] = STATE(916),
    [sym_parenthesized_expression] = STATE(916),
    [sym_concatenated_string] = STATE(916),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(2431),
    [sym_char_literal] = ACTIONS(2431),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(2433),
    [sym_false] = ACTIONS(2433),
    [sym_null] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2433),
    [sym_comment] = ACTIONS(42),
  },
  [682] = {
    [sym__expression] = STATE(917),
    [sym_conditional_expression] = STATE(917),
    [sym_assignment_expression] = STATE(917),
    [sym_pointer_expression] = STATE(917),
    [sym_logical_expression] = STATE(917),
    [sym_bitwise_expression] = STATE(917),
    [sym_equality_expression] = STATE(917),
    [sym_relational_expression] = STATE(917),
    [sym_shift_expression] = STATE(917),
    [sym_math_expression] = STATE(917),
    [sym_cast_expression] = STATE(917),
    [sym_sizeof_expression] = STATE(917),
    [sym_subscript_expression] = STATE(917),
    [sym_call_expression] = STATE(917),
    [sym_field_expression] = STATE(917),
    [sym_compound_literal_expression] = STATE(917),
    [sym_parenthesized_expression] = STATE(917),
    [sym_concatenated_string] = STATE(917),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(2435),
    [sym_char_literal] = ACTIONS(2435),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(2437),
    [sym_false] = ACTIONS(2437),
    [sym_null] = ACTIONS(2437),
    [sym_identifier] = ACTIONS(2437),
    [sym_comment] = ACTIONS(42),
  },
  [683] = {
    [sym__expression] = STATE(918),
    [sym_conditional_expression] = STATE(918),
    [sym_assignment_expression] = STATE(918),
    [sym_pointer_expression] = STATE(918),
    [sym_logical_expression] = STATE(918),
    [sym_bitwise_expression] = STATE(918),
    [sym_equality_expression] = STATE(918),
    [sym_relational_expression] = STATE(918),
    [sym_shift_expression] = STATE(918),
    [sym_math_expression] = STATE(918),
    [sym_cast_expression] = STATE(918),
    [sym_sizeof_expression] = STATE(918),
    [sym_subscript_expression] = STATE(918),
    [sym_call_expression] = STATE(918),
    [sym_field_expression] = STATE(918),
    [sym_compound_literal_expression] = STATE(918),
    [sym_parenthesized_expression] = STATE(918),
    [sym_concatenated_string] = STATE(918),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(2439),
    [sym_char_literal] = ACTIONS(2439),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(2441),
    [sym_false] = ACTIONS(2441),
    [sym_null] = ACTIONS(2441),
    [sym_identifier] = ACTIONS(2441),
    [sym_comment] = ACTIONS(42),
  },
  [684] = {
    [sym__expression] = STATE(919),
    [sym_conditional_expression] = STATE(919),
    [sym_assignment_expression] = STATE(919),
    [sym_pointer_expression] = STATE(919),
    [sym_logical_expression] = STATE(919),
    [sym_bitwise_expression] = STATE(919),
    [sym_equality_expression] = STATE(919),
    [sym_relational_expression] = STATE(919),
    [sym_shift_expression] = STATE(919),
    [sym_math_expression] = STATE(919),
    [sym_cast_expression] = STATE(919),
    [sym_sizeof_expression] = STATE(919),
    [sym_subscript_expression] = STATE(919),
    [sym_call_expression] = STATE(919),
    [sym_field_expression] = STATE(919),
    [sym_compound_literal_expression] = STATE(919),
    [sym_parenthesized_expression] = STATE(919),
    [sym_concatenated_string] = STATE(919),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(2443),
    [sym_char_literal] = ACTIONS(2443),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(2445),
    [sym_false] = ACTIONS(2445),
    [sym_null] = ACTIONS(2445),
    [sym_identifier] = ACTIONS(2445),
    [sym_comment] = ACTIONS(42),
  },
  [685] = {
    [sym__expression] = STATE(920),
    [sym_conditional_expression] = STATE(920),
    [sym_assignment_expression] = STATE(920),
    [sym_pointer_expression] = STATE(920),
    [sym_logical_expression] = STATE(920),
    [sym_bitwise_expression] = STATE(920),
    [sym_equality_expression] = STATE(920),
    [sym_relational_expression] = STATE(920),
    [sym_shift_expression] = STATE(920),
    [sym_math_expression] = STATE(920),
    [sym_cast_expression] = STATE(920),
    [sym_sizeof_expression] = STATE(920),
    [sym_subscript_expression] = STATE(920),
    [sym_call_expression] = STATE(920),
    [sym_field_expression] = STATE(920),
    [sym_compound_literal_expression] = STATE(920),
    [sym_parenthesized_expression] = STATE(920),
    [sym_concatenated_string] = STATE(920),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(2447),
    [sym_char_literal] = ACTIONS(2447),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(2449),
    [sym_false] = ACTIONS(2449),
    [sym_null] = ACTIONS(2449),
    [sym_identifier] = ACTIONS(2449),
    [sym_comment] = ACTIONS(42),
  },
  [686] = {
    [sym__expression] = STATE(921),
    [sym_conditional_expression] = STATE(921),
    [sym_assignment_expression] = STATE(921),
    [sym_pointer_expression] = STATE(921),
    [sym_logical_expression] = STATE(921),
    [sym_bitwise_expression] = STATE(921),
    [sym_equality_expression] = STATE(921),
    [sym_relational_expression] = STATE(921),
    [sym_shift_expression] = STATE(921),
    [sym_math_expression] = STATE(921),
    [sym_cast_expression] = STATE(921),
    [sym_sizeof_expression] = STATE(921),
    [sym_subscript_expression] = STATE(921),
    [sym_call_expression] = STATE(921),
    [sym_field_expression] = STATE(921),
    [sym_compound_literal_expression] = STATE(921),
    [sym_parenthesized_expression] = STATE(921),
    [sym_concatenated_string] = STATE(921),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(2451),
    [sym_char_literal] = ACTIONS(2451),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [sym_null] = ACTIONS(2453),
    [sym_identifier] = ACTIONS(2453),
    [sym_comment] = ACTIONS(42),
  },
  [687] = {
    [sym__expression] = STATE(922),
    [sym_conditional_expression] = STATE(922),
    [sym_assignment_expression] = STATE(922),
    [sym_pointer_expression] = STATE(922),
    [sym_logical_expression] = STATE(922),
    [sym_bitwise_expression] = STATE(922),
    [sym_equality_expression] = STATE(922),
    [sym_relational_expression] = STATE(922),
    [sym_shift_expression] = STATE(922),
    [sym_math_expression] = STATE(922),
    [sym_cast_expression] = STATE(922),
    [sym_sizeof_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_call_expression] = STATE(922),
    [sym_field_expression] = STATE(922),
    [sym_compound_literal_expression] = STATE(922),
    [sym_parenthesized_expression] = STATE(922),
    [sym_concatenated_string] = STATE(922),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(2455),
    [sym_char_literal] = ACTIONS(2455),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(2457),
    [sym_false] = ACTIONS(2457),
    [sym_null] = ACTIONS(2457),
    [sym_identifier] = ACTIONS(2457),
    [sym_comment] = ACTIONS(42),
  },
  [688] = {
    [sym__expression] = STATE(923),
    [sym_conditional_expression] = STATE(923),
    [sym_assignment_expression] = STATE(923),
    [sym_pointer_expression] = STATE(923),
    [sym_logical_expression] = STATE(923),
    [sym_bitwise_expression] = STATE(923),
    [sym_equality_expression] = STATE(923),
    [sym_relational_expression] = STATE(923),
    [sym_shift_expression] = STATE(923),
    [sym_math_expression] = STATE(923),
    [sym_cast_expression] = STATE(923),
    [sym_sizeof_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_call_expression] = STATE(923),
    [sym_field_expression] = STATE(923),
    [sym_compound_literal_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(923),
    [sym_initializer_list] = STATE(924),
    [sym_concatenated_string] = STATE(923),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(2459),
    [sym_char_literal] = ACTIONS(2459),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(2461),
    [sym_false] = ACTIONS(2461),
    [sym_null] = ACTIONS(2461),
    [sym_identifier] = ACTIONS(2461),
    [sym_comment] = ACTIONS(42),
  },
  [689] = {
    [sym_string_literal] = ACTIONS(2463),
    [sym_system_lib_string] = ACTIONS(2463),
    [sym_comment] = ACTIONS(42),
  },
  [690] = {
    [sym_identifier] = ACTIONS(2465),
    [sym_comment] = ACTIONS(42),
  },
  [691] = {
    [sym_preproc_arg] = ACTIONS(2467),
    [sym_comment] = ACTIONS(50),
  },
  [692] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2469),
    [sym_preproc_directive] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_typedef] = ACTIONS(2469),
    [anon_sym_extern] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_STAR] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_auto] = ACTIONS(2469),
    [anon_sym_register] = ACTIONS(2469),
    [anon_sym_inline] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_restrict] = ACTIONS(2469),
    [anon_sym_volatile] = ACTIONS(2469),
    [anon_sym__Atomic] = ACTIONS(2469),
    [anon_sym_unsigned] = ACTIONS(2469),
    [anon_sym_long] = ACTIONS(2469),
    [anon_sym_short] = ACTIONS(2469),
    [sym_primitive_type] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_struct] = ACTIONS(2469),
    [anon_sym_union] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_goto] = ACTIONS(2469),
    [anon_sym_AMP] = ACTIONS(2471),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_sizeof] = ACTIONS(2469),
    [sym_number_literal] = ACTIONS(2471),
    [sym_char_literal] = ACTIONS(2471),
    [sym_string_literal] = ACTIONS(2471),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_identifier] = ACTIONS(2469),
    [sym_comment] = ACTIONS(42),
  },
  [693] = {
    [sym_identifier] = ACTIONS(2473),
    [sym_comment] = ACTIONS(42),
  },
  [694] = {
    [sym_identifier] = ACTIONS(2475),
    [sym_comment] = ACTIONS(42),
  },
  [695] = {
    [sym_preproc_include] = STATE(956),
    [sym_preproc_def] = STATE(956),
    [sym_preproc_function_def] = STATE(956),
    [sym_preproc_call] = STATE(956),
    [sym_preproc_if_in_compound_statement] = STATE(951),
    [sym_preproc_ifdef_in_compound_statement] = STATE(952),
    [sym_declaration] = STATE(956),
    [sym_type_definition] = STATE(956),
    [sym__declaration_specifiers] = STATE(953),
    [sym_compound_statement] = STATE(956),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(956),
    [sym_expression_statement] = STATE(956),
    [sym_if_statement] = STATE(956),
    [sym_switch_statement] = STATE(956),
    [sym_case_statement] = STATE(956),
    [sym_while_statement] = STATE(956),
    [sym_do_statement] = STATE(956),
    [sym_for_statement] = STATE(956),
    [sym_return_statement] = STATE(956),
    [sym_break_statement] = STATE(956),
    [sym_continue_statement] = STATE(956),
    [sym_goto_statement] = STATE(956),
    [sym__expression] = STATE(954),
    [sym_comma_expression] = STATE(955),
    [sym_conditional_expression] = STATE(954),
    [sym_assignment_expression] = STATE(954),
    [sym_pointer_expression] = STATE(954),
    [sym_logical_expression] = STATE(954),
    [sym_bitwise_expression] = STATE(954),
    [sym_equality_expression] = STATE(954),
    [sym_relational_expression] = STATE(954),
    [sym_shift_expression] = STATE(954),
    [sym_math_expression] = STATE(954),
    [sym_cast_expression] = STATE(954),
    [sym_sizeof_expression] = STATE(954),
    [sym_subscript_expression] = STATE(954),
    [sym_call_expression] = STATE(954),
    [sym_field_expression] = STATE(954),
    [sym_compound_literal_expression] = STATE(954),
    [sym_parenthesized_expression] = STATE(954),
    [sym_concatenated_string] = STATE(954),
    [sym__empty_declaration] = STATE(956),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(956),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2479),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2481),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2483),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2485),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2487),
    [sym_preproc_directive] = ACTIONS(2489),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_typedef] = ACTIONS(2493),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(2497),
    [anon_sym_switch] = ACTIONS(2499),
    [anon_sym_case] = ACTIONS(2501),
    [anon_sym_default] = ACTIONS(2503),
    [anon_sym_while] = ACTIONS(2505),
    [anon_sym_do] = ACTIONS(2507),
    [anon_sym_for] = ACTIONS(2509),
    [anon_sym_return] = ACTIONS(2511),
    [anon_sym_break] = ACTIONS(2513),
    [anon_sym_continue] = ACTIONS(2515),
    [anon_sym_goto] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(2519),
    [sym_char_literal] = ACTIONS(2519),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(2521),
    [sym_false] = ACTIONS(2521),
    [sym_null] = ACTIONS(2521),
    [sym_identifier] = ACTIONS(2523),
    [sym_comment] = ACTIONS(42),
  },
  [696] = {
    [sym_preproc_arg] = ACTIONS(2525),
    [sym_comment] = ACTIONS(50),
  },
  [697] = {
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(2527),
    [anon_sym_LF] = ACTIONS(2529),
    [sym_comment] = ACTIONS(50),
  },
  [698] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1037),
    [sym_preproc_directive] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_typedef] = ACTIONS(1037),
    [anon_sym_extern] = ACTIONS(1037),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_STAR] = ACTIONS(1039),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_auto] = ACTIONS(1037),
    [anon_sym_register] = ACTIONS(1037),
    [anon_sym_inline] = ACTIONS(1037),
    [anon_sym_const] = ACTIONS(1037),
    [anon_sym_restrict] = ACTIONS(1037),
    [anon_sym_volatile] = ACTIONS(1037),
    [anon_sym__Atomic] = ACTIONS(1037),
    [anon_sym_unsigned] = ACTIONS(1037),
    [anon_sym_long] = ACTIONS(1037),
    [anon_sym_short] = ACTIONS(1037),
    [sym_primitive_type] = ACTIONS(1037),
    [anon_sym_enum] = ACTIONS(1037),
    [anon_sym_struct] = ACTIONS(1037),
    [anon_sym_union] = ACTIONS(1037),
    [anon_sym_if] = ACTIONS(1037),
    [anon_sym_switch] = ACTIONS(1037),
    [anon_sym_case] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1037),
    [anon_sym_do] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1037),
    [anon_sym_return] = ACTIONS(1037),
    [anon_sym_break] = ACTIONS(1037),
    [anon_sym_continue] = ACTIONS(1037),
    [anon_sym_goto] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_TILDE] = ACTIONS(1039),
    [anon_sym_PLUS] = ACTIONS(1037),
    [anon_sym_DASH] = ACTIONS(1037),
    [anon_sym_DASH_DASH] = ACTIONS(1039),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_sizeof] = ACTIONS(1037),
    [sym_number_literal] = ACTIONS(1039),
    [sym_char_literal] = ACTIONS(1039),
    [sym_string_literal] = ACTIONS(1039),
    [sym_true] = ACTIONS(1037),
    [sym_false] = ACTIONS(1037),
    [sym_null] = ACTIONS(1037),
    [sym_identifier] = ACTIONS(1037),
    [sym_comment] = ACTIONS(42),
  },
  [699] = {
    [sym_type_qualifier] = STATE(961),
    [sym__type_specifier] = STATE(960),
    [sym_sized_type_specifier] = STATE(960),
    [sym_enum_specifier] = STATE(960),
    [sym_struct_specifier] = STATE(960),
    [sym_union_specifier] = STATE(960),
    [sym_macro_type_specifier] = STATE(960),
    [aux_sym_type_definition_repeat1] = STATE(961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(36),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(62),
    [anon_sym_long] = ACTIONS(62),
    [anon_sym_short] = ACTIONS(62),
    [sym_primitive_type] = ACTIONS(2531),
    [anon_sym_enum] = ACTIONS(66),
    [anon_sym_struct] = ACTIONS(68),
    [anon_sym_union] = ACTIONS(70),
    [sym_identifier] = ACTIONS(72),
    [sym_comment] = ACTIONS(42),
  },
  [700] = {
    [sym_preproc_include] = STATE(963),
    [sym_preproc_def] = STATE(963),
    [sym_preproc_function_def] = STATE(963),
    [sym_preproc_call] = STATE(963),
    [sym_preproc_if_in_compound_statement] = STATE(275),
    [sym_preproc_ifdef_in_compound_statement] = STATE(276),
    [sym_declaration] = STATE(963),
    [sym_type_definition] = STATE(963),
    [sym__declaration_specifiers] = STATE(277),
    [sym_compound_statement] = STATE(963),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(963),
    [sym_expression_statement] = STATE(963),
    [sym_if_statement] = STATE(963),
    [sym_switch_statement] = STATE(963),
    [sym_case_statement] = STATE(963),
    [sym_while_statement] = STATE(963),
    [sym_do_statement] = STATE(963),
    [sym_for_statement] = STATE(963),
    [sym_return_statement] = STATE(963),
    [sym_break_statement] = STATE(963),
    [sym_continue_statement] = STATE(963),
    [sym_goto_statement] = STATE(963),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [sym__empty_declaration] = STATE(963),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(963),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(577),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(579),
    [sym_preproc_directive] = ACTIONS(581),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_typedef] = ACTIONS(585),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_RBRACE] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(631),
    [sym_comment] = ACTIONS(42),
  },
  [701] = {
    [anon_sym_LPAREN] = ACTIONS(2535),
    [sym_comment] = ACTIONS(42),
  },
  [702] = {
    [anon_sym_LPAREN] = ACTIONS(2537),
    [sym_comment] = ACTIONS(42),
  },
  [703] = {
    [sym__expression] = STATE(966),
    [sym_conditional_expression] = STATE(966),
    [sym_assignment_expression] = STATE(966),
    [sym_pointer_expression] = STATE(966),
    [sym_logical_expression] = STATE(966),
    [sym_bitwise_expression] = STATE(966),
    [sym_equality_expression] = STATE(966),
    [sym_relational_expression] = STATE(966),
    [sym_shift_expression] = STATE(966),
    [sym_math_expression] = STATE(966),
    [sym_cast_expression] = STATE(966),
    [sym_sizeof_expression] = STATE(966),
    [sym_subscript_expression] = STATE(966),
    [sym_call_expression] = STATE(966),
    [sym_field_expression] = STATE(966),
    [sym_compound_literal_expression] = STATE(966),
    [sym_parenthesized_expression] = STATE(966),
    [sym_concatenated_string] = STATE(966),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(2539),
    [sym_char_literal] = ACTIONS(2539),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(2541),
    [sym_false] = ACTIONS(2541),
    [sym_null] = ACTIONS(2541),
    [sym_identifier] = ACTIONS(2541),
    [sym_comment] = ACTIONS(42),
  },
  [704] = {
    [anon_sym_COLON] = ACTIONS(2543),
    [sym_comment] = ACTIONS(42),
  },
  [705] = {
    [anon_sym_LPAREN] = ACTIONS(2545),
    [sym_comment] = ACTIONS(42),
  },
  [706] = {
    [sym_compound_statement] = STATE(969),
    [sym_labeled_statement] = STATE(969),
    [sym_expression_statement] = STATE(969),
    [sym_if_statement] = STATE(969),
    [sym_switch_statement] = STATE(969),
    [sym_case_statement] = STATE(969),
    [sym_while_statement] = STATE(969),
    [sym_do_statement] = STATE(969),
    [sym_for_statement] = STATE(969),
    [sym_return_statement] = STATE(969),
    [sym_break_statement] = STATE(969),
    [sym_continue_statement] = STATE(969),
    [sym_goto_statement] = STATE(969),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_default] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(1089),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1093),
    [sym_comment] = ACTIONS(42),
  },
  [707] = {
    [anon_sym_LPAREN] = ACTIONS(2547),
    [sym_comment] = ACTIONS(42),
  },
  [708] = {
    [sym__expression] = STATE(972),
    [sym_conditional_expression] = STATE(972),
    [sym_assignment_expression] = STATE(972),
    [sym_pointer_expression] = STATE(972),
    [sym_logical_expression] = STATE(972),
    [sym_bitwise_expression] = STATE(972),
    [sym_equality_expression] = STATE(972),
    [sym_relational_expression] = STATE(972),
    [sym_shift_expression] = STATE(972),
    [sym_math_expression] = STATE(972),
    [sym_cast_expression] = STATE(972),
    [sym_sizeof_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_call_expression] = STATE(972),
    [sym_field_expression] = STATE(972),
    [sym_compound_literal_expression] = STATE(972),
    [sym_parenthesized_expression] = STATE(972),
    [sym_concatenated_string] = STATE(972),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(2549),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(2551),
    [sym_char_literal] = ACTIONS(2551),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(2553),
    [sym_false] = ACTIONS(2553),
    [sym_null] = ACTIONS(2553),
    [sym_identifier] = ACTIONS(2553),
    [sym_comment] = ACTIONS(42),
  },
  [709] = {
    [anon_sym_SEMI] = ACTIONS(2555),
    [sym_comment] = ACTIONS(42),
  },
  [710] = {
    [anon_sym_SEMI] = ACTIONS(2557),
    [sym_comment] = ACTIONS(42),
  },
  [711] = {
    [sym_identifier] = ACTIONS(2559),
    [sym_comment] = ACTIONS(42),
  },
  [712] = {
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1137),
    [anon_sym_extern] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_auto] = ACTIONS(95),
    [anon_sym_register] = ACTIONS(95),
    [anon_sym_inline] = ACTIONS(95),
    [anon_sym_const] = ACTIONS(95),
    [anon_sym_restrict] = ACTIONS(95),
    [anon_sym_volatile] = ACTIONS(95),
    [anon_sym__Atomic] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(2561),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_identifier] = ACTIONS(95),
    [sym_comment] = ACTIONS(42),
  },
  [713] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1145),
    [anon_sym_LPAREN] = ACTIONS(1147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1145),
    [sym_preproc_directive] = ACTIONS(1145),
    [anon_sym_SEMI] = ACTIONS(1147),
    [anon_sym_typedef] = ACTIONS(1145),
    [anon_sym_extern] = ACTIONS(1145),
    [anon_sym_LBRACE] = ACTIONS(1147),
    [anon_sym_STAR] = ACTIONS(1147),
    [anon_sym_static] = ACTIONS(1145),
    [anon_sym_auto] = ACTIONS(1145),
    [anon_sym_register] = ACTIONS(1145),
    [anon_sym_inline] = ACTIONS(1145),
    [anon_sym_const] = ACTIONS(1145),
    [anon_sym_restrict] = ACTIONS(1145),
    [anon_sym_volatile] = ACTIONS(1145),
    [anon_sym__Atomic] = ACTIONS(1145),
    [anon_sym_unsigned] = ACTIONS(1145),
    [anon_sym_long] = ACTIONS(1145),
    [anon_sym_short] = ACTIONS(1145),
    [sym_primitive_type] = ACTIONS(1145),
    [anon_sym_enum] = ACTIONS(1145),
    [anon_sym_struct] = ACTIONS(1145),
    [anon_sym_union] = ACTIONS(1145),
    [anon_sym_if] = ACTIONS(1145),
    [anon_sym_switch] = ACTIONS(1145),
    [anon_sym_case] = ACTIONS(1145),
    [anon_sym_default] = ACTIONS(1145),
    [anon_sym_while] = ACTIONS(1145),
    [anon_sym_do] = ACTIONS(1145),
    [anon_sym_for] = ACTIONS(1145),
    [anon_sym_return] = ACTIONS(1145),
    [anon_sym_break] = ACTIONS(1145),
    [anon_sym_continue] = ACTIONS(1145),
    [anon_sym_goto] = ACTIONS(1145),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_DASH_DASH] = ACTIONS(1147),
    [anon_sym_PLUS_PLUS] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1147),
    [sym_char_literal] = ACTIONS(1147),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1145),
    [sym_false] = ACTIONS(1145),
    [sym_null] = ACTIONS(1145),
    [sym_identifier] = ACTIONS(1145),
    [sym_comment] = ACTIONS(42),
  },
  [714] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1149),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1149),
    [sym_preproc_directive] = ACTIONS(1149),
    [anon_sym_SEMI] = ACTIONS(1151),
    [anon_sym_typedef] = ACTIONS(1149),
    [anon_sym_extern] = ACTIONS(1149),
    [anon_sym_LBRACE] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1151),
    [anon_sym_static] = ACTIONS(1149),
    [anon_sym_auto] = ACTIONS(1149),
    [anon_sym_register] = ACTIONS(1149),
    [anon_sym_inline] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_restrict] = ACTIONS(1149),
    [anon_sym_volatile] = ACTIONS(1149),
    [anon_sym__Atomic] = ACTIONS(1149),
    [anon_sym_unsigned] = ACTIONS(1149),
    [anon_sym_long] = ACTIONS(1149),
    [anon_sym_short] = ACTIONS(1149),
    [sym_primitive_type] = ACTIONS(1149),
    [anon_sym_enum] = ACTIONS(1149),
    [anon_sym_struct] = ACTIONS(1149),
    [anon_sym_union] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(1149),
    [anon_sym_switch] = ACTIONS(1149),
    [anon_sym_case] = ACTIONS(1149),
    [anon_sym_default] = ACTIONS(1149),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_do] = ACTIONS(1149),
    [anon_sym_for] = ACTIONS(1149),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_break] = ACTIONS(1149),
    [anon_sym_continue] = ACTIONS(1149),
    [anon_sym_goto] = ACTIONS(1149),
    [anon_sym_AMP] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(1149),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1151),
    [anon_sym_PLUS_PLUS] = ACTIONS(1151),
    [anon_sym_sizeof] = ACTIONS(1149),
    [sym_number_literal] = ACTIONS(1151),
    [sym_char_literal] = ACTIONS(1151),
    [sym_string_literal] = ACTIONS(1151),
    [sym_true] = ACTIONS(1149),
    [sym_false] = ACTIONS(1149),
    [sym_null] = ACTIONS(1149),
    [sym_identifier] = ACTIONS(1149),
    [sym_comment] = ACTIONS(42),
  },
  [715] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2563),
    [sym_comment] = ACTIONS(42),
  },
  [716] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2565),
    [sym_comment] = ACTIONS(42),
  },
  [717] = {
    [sym__declarator] = STATE(980),
    [sym_pointer_declarator] = STATE(980),
    [sym_function_declarator] = STATE(980),
    [sym_array_declarator] = STATE(980),
    [sym_init_declarator] = STATE(981),
    [anon_sym_LPAREN] = ACTIONS(99),
    [anon_sym_SEMI] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(561),
    [sym_identifier] = ACTIONS(2569),
    [sym_comment] = ACTIONS(42),
  },
  [718] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_SEMI] = ACTIONS(2571),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_STAR_EQ] = ACTIONS(1171),
    [anon_sym_SLASH_EQ] = ACTIONS(1171),
    [anon_sym_PERCENT_EQ] = ACTIONS(1171),
    [anon_sym_PLUS_EQ] = ACTIONS(1171),
    [anon_sym_DASH_EQ] = ACTIONS(1171),
    [anon_sym_LT_LT_EQ] = ACTIONS(1171),
    [anon_sym_GT_GT_EQ] = ACTIONS(1171),
    [anon_sym_AMP_EQ] = ACTIONS(1171),
    [anon_sym_CARET_EQ] = ACTIONS(1171),
    [anon_sym_PIPE_EQ] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_PIPE_PIPE] = ACTIONS(1175),
    [anon_sym_AMP_AMP] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_LT] = ACTIONS(1185),
    [anon_sym_GT] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1187),
    [anon_sym_GT_EQ] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1189),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [719] = {
    [anon_sym_SEMI] = ACTIONS(2571),
    [sym_comment] = ACTIONS(42),
  },
  [720] = {
    [sym_preproc_include] = STATE(986),
    [sym_preproc_def] = STATE(986),
    [sym_preproc_function_def] = STATE(986),
    [sym_preproc_call] = STATE(986),
    [sym_preproc_if_in_compound_statement] = STATE(713),
    [sym_preproc_ifdef_in_compound_statement] = STATE(714),
    [sym_preproc_else_in_compound_statement] = STATE(984),
    [sym_preproc_elif_in_compound_statement] = STATE(985),
    [sym_declaration] = STATE(986),
    [sym_type_definition] = STATE(986),
    [sym__declaration_specifiers] = STATE(717),
    [sym_compound_statement] = STATE(986),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(986),
    [sym_expression_statement] = STATE(986),
    [sym_if_statement] = STATE(986),
    [sym_switch_statement] = STATE(986),
    [sym_case_statement] = STATE(986),
    [sym_while_statement] = STATE(986),
    [sym_do_statement] = STATE(986),
    [sym_for_statement] = STATE(986),
    [sym_return_statement] = STATE(986),
    [sym_break_statement] = STATE(986),
    [sym_continue_statement] = STATE(986),
    [sym_goto_statement] = STATE(986),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym__empty_declaration] = STATE(986),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(986),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1639),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1645),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1647),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1651),
    [sym_preproc_directive] = ACTIONS(1653),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_typedef] = ACTIONS(1657),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(42),
  },
  [721] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2575),
    [anon_sym_LPAREN] = ACTIONS(2577),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2575),
    [sym_preproc_directive] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(2577),
    [anon_sym_typedef] = ACTIONS(2575),
    [anon_sym_extern] = ACTIONS(2575),
    [anon_sym_LBRACE] = ACTIONS(2577),
    [anon_sym_RBRACE] = ACTIONS(2577),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_static] = ACTIONS(2575),
    [anon_sym_auto] = ACTIONS(2575),
    [anon_sym_register] = ACTIONS(2575),
    [anon_sym_inline] = ACTIONS(2575),
    [anon_sym_const] = ACTIONS(2575),
    [anon_sym_restrict] = ACTIONS(2575),
    [anon_sym_volatile] = ACTIONS(2575),
    [anon_sym__Atomic] = ACTIONS(2575),
    [anon_sym_unsigned] = ACTIONS(2575),
    [anon_sym_long] = ACTIONS(2575),
    [anon_sym_short] = ACTIONS(2575),
    [sym_primitive_type] = ACTIONS(2575),
    [anon_sym_enum] = ACTIONS(2575),
    [anon_sym_struct] = ACTIONS(2575),
    [anon_sym_union] = ACTIONS(2575),
    [anon_sym_if] = ACTIONS(2575),
    [anon_sym_switch] = ACTIONS(2575),
    [anon_sym_case] = ACTIONS(2575),
    [anon_sym_default] = ACTIONS(2575),
    [anon_sym_while] = ACTIONS(2575),
    [anon_sym_do] = ACTIONS(2575),
    [anon_sym_for] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2575),
    [anon_sym_break] = ACTIONS(2575),
    [anon_sym_continue] = ACTIONS(2575),
    [anon_sym_goto] = ACTIONS(2575),
    [anon_sym_AMP] = ACTIONS(2577),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2575),
    [anon_sym_DASH] = ACTIONS(2575),
    [anon_sym_DASH_DASH] = ACTIONS(2577),
    [anon_sym_PLUS_PLUS] = ACTIONS(2577),
    [anon_sym_sizeof] = ACTIONS(2575),
    [sym_number_literal] = ACTIONS(2577),
    [sym_char_literal] = ACTIONS(2577),
    [sym_string_literal] = ACTIONS(2577),
    [sym_true] = ACTIONS(2575),
    [sym_false] = ACTIONS(2575),
    [sym_null] = ACTIONS(2575),
    [sym_identifier] = ACTIONS(2575),
    [sym_comment] = ACTIONS(42),
  },
  [722] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2579),
    [sym_comment] = ACTIONS(42),
  },
  [723] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2581),
    [sym_comment] = ACTIONS(42),
  },
  [724] = {
    [sym_preproc_include] = STATE(986),
    [sym_preproc_def] = STATE(986),
    [sym_preproc_function_def] = STATE(986),
    [sym_preproc_call] = STATE(986),
    [sym_preproc_if_in_compound_statement] = STATE(713),
    [sym_preproc_ifdef_in_compound_statement] = STATE(714),
    [sym_preproc_else_in_compound_statement] = STATE(990),
    [sym_preproc_elif_in_compound_statement] = STATE(991),
    [sym_declaration] = STATE(986),
    [sym_type_definition] = STATE(986),
    [sym__declaration_specifiers] = STATE(717),
    [sym_compound_statement] = STATE(986),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(986),
    [sym_expression_statement] = STATE(986),
    [sym_if_statement] = STATE(986),
    [sym_switch_statement] = STATE(986),
    [sym_case_statement] = STATE(986),
    [sym_while_statement] = STATE(986),
    [sym_do_statement] = STATE(986),
    [sym_for_statement] = STATE(986),
    [sym_return_statement] = STATE(986),
    [sym_break_statement] = STATE(986),
    [sym_continue_statement] = STATE(986),
    [sym_goto_statement] = STATE(986),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym__empty_declaration] = STATE(986),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(986),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1639),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2583),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1645),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1647),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1651),
    [sym_preproc_directive] = ACTIONS(1653),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_typedef] = ACTIONS(1657),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(42),
  },
  [725] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2585),
    [anon_sym_LPAREN] = ACTIONS(2587),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2585),
    [sym_preproc_directive] = ACTIONS(2585),
    [anon_sym_SEMI] = ACTIONS(2587),
    [anon_sym_typedef] = ACTIONS(2585),
    [anon_sym_extern] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2587),
    [anon_sym_RBRACE] = ACTIONS(2587),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_static] = ACTIONS(2585),
    [anon_sym_auto] = ACTIONS(2585),
    [anon_sym_register] = ACTIONS(2585),
    [anon_sym_inline] = ACTIONS(2585),
    [anon_sym_const] = ACTIONS(2585),
    [anon_sym_restrict] = ACTIONS(2585),
    [anon_sym_volatile] = ACTIONS(2585),
    [anon_sym__Atomic] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [sym_primitive_type] = ACTIONS(2585),
    [anon_sym_enum] = ACTIONS(2585),
    [anon_sym_struct] = ACTIONS(2585),
    [anon_sym_union] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2585),
    [anon_sym_switch] = ACTIONS(2585),
    [anon_sym_case] = ACTIONS(2585),
    [anon_sym_default] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(2585),
    [anon_sym_do] = ACTIONS(2585),
    [anon_sym_for] = ACTIONS(2585),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_break] = ACTIONS(2585),
    [anon_sym_continue] = ACTIONS(2585),
    [anon_sym_goto] = ACTIONS(2585),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_BANG] = ACTIONS(2587),
    [anon_sym_TILDE] = ACTIONS(2587),
    [anon_sym_PLUS] = ACTIONS(2585),
    [anon_sym_DASH] = ACTIONS(2585),
    [anon_sym_DASH_DASH] = ACTIONS(2587),
    [anon_sym_PLUS_PLUS] = ACTIONS(2587),
    [anon_sym_sizeof] = ACTIONS(2585),
    [sym_number_literal] = ACTIONS(2587),
    [sym_char_literal] = ACTIONS(2587),
    [sym_string_literal] = ACTIONS(2587),
    [sym_true] = ACTIONS(2585),
    [sym_false] = ACTIONS(2585),
    [sym_null] = ACTIONS(2585),
    [sym_identifier] = ACTIONS(2585),
    [sym_comment] = ACTIONS(42),
  },
  [726] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2589),
    [sym_comment] = ACTIONS(42),
  },
  [727] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2591),
    [sym_comment] = ACTIONS(42),
  },
  [728] = {
    [sym_preproc_include] = STATE(986),
    [sym_preproc_def] = STATE(986),
    [sym_preproc_function_def] = STATE(986),
    [sym_preproc_call] = STATE(986),
    [sym_preproc_if_in_compound_statement] = STATE(713),
    [sym_preproc_ifdef_in_compound_statement] = STATE(714),
    [sym_preproc_else_in_compound_statement] = STATE(995),
    [sym_preproc_elif_in_compound_statement] = STATE(996),
    [sym_declaration] = STATE(986),
    [sym_type_definition] = STATE(986),
    [sym__declaration_specifiers] = STATE(717),
    [sym_compound_statement] = STATE(986),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(986),
    [sym_expression_statement] = STATE(986),
    [sym_if_statement] = STATE(986),
    [sym_switch_statement] = STATE(986),
    [sym_case_statement] = STATE(986),
    [sym_while_statement] = STATE(986),
    [sym_do_statement] = STATE(986),
    [sym_for_statement] = STATE(986),
    [sym_return_statement] = STATE(986),
    [sym_break_statement] = STATE(986),
    [sym_continue_statement] = STATE(986),
    [sym_goto_statement] = STATE(986),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym__empty_declaration] = STATE(986),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(986),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1639),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2593),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1645),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1647),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1651),
    [sym_preproc_directive] = ACTIONS(1653),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_typedef] = ACTIONS(1657),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(42),
  },
  [729] = {
    [anon_sym_LF] = ACTIONS(2595),
    [sym_comment] = ACTIONS(50),
  },
  [730] = {
    [sym_parameter_list] = STATE(200),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_SEMI] = ACTIONS(2597),
    [anon_sym_LBRACK] = ACTIONS(449),
    [sym_comment] = ACTIONS(42),
  },
  [731] = {
    [sym__type_declarator] = STATE(999),
    [sym_pointer_type_declarator] = STATE(99),
    [sym_function_type_declarator] = STATE(100),
    [sym_array_type_declarator] = STATE(101),
    [anon_sym_LPAREN] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(187),
    [sym_identifier] = ACTIONS(189),
    [sym_comment] = ACTIONS(42),
  },
  [732] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1913),
    [anon_sym_LPAREN] = ACTIONS(1911),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_RBRACE] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_auto] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [anon_sym_if] = ACTIONS(1913),
    [anon_sym_switch] = ACTIONS(1913),
    [anon_sym_case] = ACTIONS(1913),
    [anon_sym_default] = ACTIONS(1913),
    [anon_sym_while] = ACTIONS(1913),
    [anon_sym_do] = ACTIONS(1913),
    [anon_sym_for] = ACTIONS(1913),
    [anon_sym_return] = ACTIONS(1913),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1913),
    [anon_sym_goto] = ACTIONS(1913),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1913),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_sizeof] = ACTIONS(1913),
    [sym_number_literal] = ACTIONS(1911),
    [sym_char_literal] = ACTIONS(1911),
    [sym_string_literal] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [sym_null] = ACTIONS(1913),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(42),
  },
  [733] = {
    [sym_type_qualifier] = STATE(133),
    [sym__type_specifier] = STATE(131),
    [sym_sized_type_specifier] = STATE(131),
    [sym_enum_specifier] = STATE(131),
    [sym_struct_specifier] = STATE(131),
    [sym_union_specifier] = STATE(131),
    [sym__expression] = STATE(436),
    [sym_comma_expression] = STATE(437),
    [sym_conditional_expression] = STATE(436),
    [sym_assignment_expression] = STATE(436),
    [sym_pointer_expression] = STATE(436),
    [sym_logical_expression] = STATE(436),
    [sym_bitwise_expression] = STATE(436),
    [sym_equality_expression] = STATE(436),
    [sym_relational_expression] = STATE(436),
    [sym_shift_expression] = STATE(436),
    [sym_math_expression] = STATE(436),
    [sym_cast_expression] = STATE(436),
    [sym_type_descriptor] = STATE(1000),
    [sym_sizeof_expression] = STATE(436),
    [sym_subscript_expression] = STATE(436),
    [sym_call_expression] = STATE(436),
    [sym_field_expression] = STATE(436),
    [sym_compound_literal_expression] = STATE(436),
    [sym_parenthesized_expression] = STATE(436),
    [sym_concatenated_string] = STATE(436),
    [sym_macro_type_specifier] = STATE(131),
    [aux_sym_type_definition_repeat1] = STATE(133),
    [aux_sym_sized_type_specifier_repeat1] = STATE(134),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(248),
    [anon_sym_long] = ACTIONS(248),
    [anon_sym_short] = ACTIONS(248),
    [sym_primitive_type] = ACTIONS(250),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1019),
    [sym_char_literal] = ACTIONS(1019),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(1023),
    [sym_false] = ACTIONS(1023),
    [sym_null] = ACTIONS(1023),
    [sym_identifier] = ACTIONS(1025),
    [sym_comment] = ACTIONS(42),
  },
  [734] = {
    [sym__expression] = STATE(448),
    [sym_conditional_expression] = STATE(448),
    [sym_assignment_expression] = STATE(448),
    [sym_pointer_expression] = STATE(448),
    [sym_logical_expression] = STATE(448),
    [sym_bitwise_expression] = STATE(448),
    [sym_equality_expression] = STATE(448),
    [sym_relational_expression] = STATE(448),
    [sym_shift_expression] = STATE(448),
    [sym_math_expression] = STATE(448),
    [sym_cast_expression] = STATE(448),
    [sym_sizeof_expression] = STATE(448),
    [sym_subscript_expression] = STATE(448),
    [sym_call_expression] = STATE(448),
    [sym_field_expression] = STATE(448),
    [sym_compound_literal_expression] = STATE(448),
    [sym_parenthesized_expression] = STATE(448),
    [sym_concatenated_string] = STATE(448),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(1049),
    [sym_char_literal] = ACTIONS(1049),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(1051),
    [sym_false] = ACTIONS(1051),
    [sym_null] = ACTIONS(1051),
    [sym_identifier] = ACTIONS(1051),
    [sym_comment] = ACTIONS(42),
  },
  [735] = {
    [sym__expression] = STATE(475),
    [sym_conditional_expression] = STATE(475),
    [sym_assignment_expression] = STATE(475),
    [sym_pointer_expression] = STATE(475),
    [sym_logical_expression] = STATE(475),
    [sym_bitwise_expression] = STATE(475),
    [sym_equality_expression] = STATE(475),
    [sym_relational_expression] = STATE(475),
    [sym_shift_expression] = STATE(475),
    [sym_math_expression] = STATE(475),
    [sym_cast_expression] = STATE(475),
    [sym_sizeof_expression] = STATE(475),
    [sym_subscript_expression] = STATE(475),
    [sym_call_expression] = STATE(475),
    [sym_field_expression] = STATE(475),
    [sym_compound_literal_expression] = STATE(475),
    [sym_parenthesized_expression] = STATE(475),
    [sym_concatenated_string] = STATE(475),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(1109),
    [sym_char_literal] = ACTIONS(1109),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(1111),
    [sym_false] = ACTIONS(1111),
    [sym_null] = ACTIONS(1111),
    [sym_identifier] = ACTIONS(1111),
    [sym_comment] = ACTIONS(42),
  },
  [736] = {
    [sym__expression] = STATE(476),
    [sym_conditional_expression] = STATE(476),
    [sym_assignment_expression] = STATE(476),
    [sym_pointer_expression] = STATE(476),
    [sym_logical_expression] = STATE(476),
    [sym_bitwise_expression] = STATE(476),
    [sym_equality_expression] = STATE(476),
    [sym_relational_expression] = STATE(476),
    [sym_shift_expression] = STATE(476),
    [sym_math_expression] = STATE(476),
    [sym_cast_expression] = STATE(476),
    [sym_sizeof_expression] = STATE(476),
    [sym_subscript_expression] = STATE(476),
    [sym_call_expression] = STATE(476),
    [sym_field_expression] = STATE(476),
    [sym_compound_literal_expression] = STATE(476),
    [sym_parenthesized_expression] = STATE(476),
    [sym_concatenated_string] = STATE(476),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(1113),
    [sym_char_literal] = ACTIONS(1113),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(1115),
    [sym_false] = ACTIONS(1115),
    [sym_null] = ACTIONS(1115),
    [sym_identifier] = ACTIONS(1115),
    [sym_comment] = ACTIONS(42),
  },
  [737] = {
    [sym__expression] = STATE(477),
    [sym_conditional_expression] = STATE(477),
    [sym_assignment_expression] = STATE(477),
    [sym_pointer_expression] = STATE(477),
    [sym_logical_expression] = STATE(477),
    [sym_bitwise_expression] = STATE(477),
    [sym_equality_expression] = STATE(477),
    [sym_relational_expression] = STATE(477),
    [sym_shift_expression] = STATE(477),
    [sym_math_expression] = STATE(477),
    [sym_cast_expression] = STATE(477),
    [sym_sizeof_expression] = STATE(477),
    [sym_subscript_expression] = STATE(477),
    [sym_call_expression] = STATE(477),
    [sym_field_expression] = STATE(477),
    [sym_compound_literal_expression] = STATE(477),
    [sym_parenthesized_expression] = STATE(477),
    [sym_concatenated_string] = STATE(477),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(1117),
    [sym_char_literal] = ACTIONS(1117),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(1119),
    [sym_false] = ACTIONS(1119),
    [sym_null] = ACTIONS(1119),
    [sym_identifier] = ACTIONS(1119),
    [sym_comment] = ACTIONS(42),
  },
  [738] = {
    [sym__expression] = STATE(1002),
    [sym_conditional_expression] = STATE(1002),
    [sym_assignment_expression] = STATE(1002),
    [sym_pointer_expression] = STATE(1002),
    [sym_logical_expression] = STATE(1002),
    [sym_bitwise_expression] = STATE(1002),
    [sym_equality_expression] = STATE(1002),
    [sym_relational_expression] = STATE(1002),
    [sym_shift_expression] = STATE(1002),
    [sym_math_expression] = STATE(1002),
    [sym_cast_expression] = STATE(1002),
    [sym_sizeof_expression] = STATE(1002),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(1002),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_concatenated_string] = STATE(1002),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(2601),
    [sym_char_literal] = ACTIONS(2601),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(2603),
    [sym_false] = ACTIONS(2603),
    [sym_null] = ACTIONS(2603),
    [sym_identifier] = ACTIONS(2603),
    [sym_comment] = ACTIONS(42),
  },
  [739] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1003),
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_RPAREN] = ACTIONS(1127),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_string_literal] = ACTIONS(2605),
    [sym_comment] = ACTIONS(42),
  },
  [740] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(2607),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [741] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(2637),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [742] = {
    [anon_sym_RPAREN] = ACTIONS(2639),
    [sym_comment] = ACTIONS(42),
  },
  [743] = {
    [sym_type_qualifier] = STATE(133),
    [sym__type_specifier] = STATE(131),
    [sym_sized_type_specifier] = STATE(131),
    [sym_enum_specifier] = STATE(131),
    [sym_struct_specifier] = STATE(131),
    [sym_union_specifier] = STATE(131),
    [sym__expression] = STATE(436),
    [sym_comma_expression] = STATE(437),
    [sym_conditional_expression] = STATE(436),
    [sym_assignment_expression] = STATE(436),
    [sym_pointer_expression] = STATE(436),
    [sym_logical_expression] = STATE(436),
    [sym_bitwise_expression] = STATE(436),
    [sym_equality_expression] = STATE(436),
    [sym_relational_expression] = STATE(436),
    [sym_shift_expression] = STATE(436),
    [sym_math_expression] = STATE(436),
    [sym_cast_expression] = STATE(436),
    [sym_type_descriptor] = STATE(1019),
    [sym_sizeof_expression] = STATE(436),
    [sym_subscript_expression] = STATE(436),
    [sym_call_expression] = STATE(436),
    [sym_field_expression] = STATE(436),
    [sym_compound_literal_expression] = STATE(436),
    [sym_parenthesized_expression] = STATE(436),
    [sym_concatenated_string] = STATE(436),
    [sym_macro_type_specifier] = STATE(131),
    [aux_sym_type_definition_repeat1] = STATE(133),
    [aux_sym_sized_type_specifier_repeat1] = STATE(134),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(248),
    [anon_sym_long] = ACTIONS(248),
    [anon_sym_short] = ACTIONS(248),
    [sym_primitive_type] = ACTIONS(250),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1019),
    [sym_char_literal] = ACTIONS(1019),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(1023),
    [sym_false] = ACTIONS(1023),
    [sym_null] = ACTIONS(1023),
    [sym_identifier] = ACTIONS(1025),
    [sym_comment] = ACTIONS(42),
  },
  [744] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1827),
    [anon_sym_COLON] = ACTIONS(1825),
    [anon_sym_QMARK] = ACTIONS(1825),
    [anon_sym_STAR_EQ] = ACTIONS(1825),
    [anon_sym_SLASH_EQ] = ACTIONS(1825),
    [anon_sym_PERCENT_EQ] = ACTIONS(1825),
    [anon_sym_PLUS_EQ] = ACTIONS(1825),
    [anon_sym_DASH_EQ] = ACTIONS(1825),
    [anon_sym_LT_LT_EQ] = ACTIONS(1825),
    [anon_sym_GT_GT_EQ] = ACTIONS(1825),
    [anon_sym_AMP_EQ] = ACTIONS(1825),
    [anon_sym_CARET_EQ] = ACTIONS(1825),
    [anon_sym_PIPE_EQ] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1827),
    [anon_sym_PIPE_PIPE] = ACTIONS(1825),
    [anon_sym_AMP_AMP] = ACTIONS(1825),
    [anon_sym_PIPE] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1827),
    [anon_sym_EQ_EQ] = ACTIONS(1825),
    [anon_sym_BANG_EQ] = ACTIONS(1825),
    [anon_sym_LT] = ACTIONS(1827),
    [anon_sym_GT] = ACTIONS(1827),
    [anon_sym_LT_EQ] = ACTIONS(1825),
    [anon_sym_GT_EQ] = ACTIONS(1825),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [745] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1020),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_STAR] = ACTIONS(1831),
    [anon_sym_LBRACK] = ACTIONS(1829),
    [anon_sym_EQ] = ACTIONS(1831),
    [anon_sym_COLON] = ACTIONS(1829),
    [anon_sym_QMARK] = ACTIONS(1829),
    [anon_sym_STAR_EQ] = ACTIONS(1829),
    [anon_sym_SLASH_EQ] = ACTIONS(1829),
    [anon_sym_PERCENT_EQ] = ACTIONS(1829),
    [anon_sym_PLUS_EQ] = ACTIONS(1829),
    [anon_sym_DASH_EQ] = ACTIONS(1829),
    [anon_sym_LT_LT_EQ] = ACTIONS(1829),
    [anon_sym_GT_GT_EQ] = ACTIONS(1829),
    [anon_sym_AMP_EQ] = ACTIONS(1829),
    [anon_sym_CARET_EQ] = ACTIONS(1829),
    [anon_sym_PIPE_EQ] = ACTIONS(1829),
    [anon_sym_AMP] = ACTIONS(1831),
    [anon_sym_PIPE_PIPE] = ACTIONS(1829),
    [anon_sym_AMP_AMP] = ACTIONS(1829),
    [anon_sym_PIPE] = ACTIONS(1831),
    [anon_sym_CARET] = ACTIONS(1831),
    [anon_sym_EQ_EQ] = ACTIONS(1829),
    [anon_sym_BANG_EQ] = ACTIONS(1829),
    [anon_sym_LT] = ACTIONS(1831),
    [anon_sym_GT] = ACTIONS(1831),
    [anon_sym_LT_EQ] = ACTIONS(1829),
    [anon_sym_GT_EQ] = ACTIONS(1829),
    [anon_sym_LT_LT] = ACTIONS(1831),
    [anon_sym_GT_GT] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_SLASH] = ACTIONS(1831),
    [anon_sym_PERCENT] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1829),
    [anon_sym_PLUS_PLUS] = ACTIONS(1829),
    [anon_sym_DOT] = ACTIONS(1829),
    [anon_sym_DASH_GT] = ACTIONS(1829),
    [sym_string_literal] = ACTIONS(2641),
    [sym_comment] = ACTIONS(42),
  },
  [746] = {
    [sym__expression] = STATE(787),
    [sym_conditional_expression] = STATE(787),
    [sym_assignment_expression] = STATE(787),
    [sym_pointer_expression] = STATE(787),
    [sym_logical_expression] = STATE(787),
    [sym_bitwise_expression] = STATE(787),
    [sym_equality_expression] = STATE(787),
    [sym_relational_expression] = STATE(787),
    [sym_shift_expression] = STATE(787),
    [sym_math_expression] = STATE(787),
    [sym_cast_expression] = STATE(787),
    [sym_sizeof_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_call_expression] = STATE(787),
    [sym_field_expression] = STATE(787),
    [sym_compound_literal_expression] = STATE(787),
    [sym_parenthesized_expression] = STATE(787),
    [sym_concatenated_string] = STATE(787),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(1853),
    [sym_char_literal] = ACTIONS(1853),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(1855),
    [sym_false] = ACTIONS(1855),
    [sym_null] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_comment] = ACTIONS(42),
  },
  [747] = {
    [sym__expression] = STATE(1021),
    [sym_conditional_expression] = STATE(1021),
    [sym_assignment_expression] = STATE(1021),
    [sym_pointer_expression] = STATE(1021),
    [sym_logical_expression] = STATE(1021),
    [sym_bitwise_expression] = STATE(1021),
    [sym_equality_expression] = STATE(1021),
    [sym_relational_expression] = STATE(1021),
    [sym_shift_expression] = STATE(1021),
    [sym_math_expression] = STATE(1021),
    [sym_cast_expression] = STATE(1021),
    [sym_sizeof_expression] = STATE(1021),
    [sym_subscript_expression] = STATE(1021),
    [sym_call_expression] = STATE(1021),
    [sym_field_expression] = STATE(1021),
    [sym_compound_literal_expression] = STATE(1021),
    [sym_parenthesized_expression] = STATE(1021),
    [sym_concatenated_string] = STATE(1021),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(2643),
    [sym_char_literal] = ACTIONS(2643),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(2645),
    [sym_false] = ACTIONS(2645),
    [sym_null] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2645),
    [sym_comment] = ACTIONS(42),
  },
  [748] = {
    [sym_declaration] = STATE(1022),
    [sym_type_definition] = STATE(1022),
    [sym__declaration_specifiers] = STATE(761),
    [sym_compound_statement] = STATE(1022),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(1022),
    [sym_expression_statement] = STATE(1022),
    [sym_if_statement] = STATE(1022),
    [sym_switch_statement] = STATE(1022),
    [sym_case_statement] = STATE(1022),
    [sym_while_statement] = STATE(1022),
    [sym_do_statement] = STATE(1022),
    [sym_for_statement] = STATE(1022),
    [sym_return_statement] = STATE(1022),
    [sym_break_statement] = STATE(1022),
    [sym_continue_statement] = STATE(1022),
    [sym_goto_statement] = STATE(1022),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_typedef] = ACTIONS(585),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1765),
    [sym_comment] = ACTIONS(42),
  },
  [749] = {
    [sym__expression] = STATE(1023),
    [sym_conditional_expression] = STATE(1023),
    [sym_assignment_expression] = STATE(1023),
    [sym_pointer_expression] = STATE(1023),
    [sym_logical_expression] = STATE(1023),
    [sym_bitwise_expression] = STATE(1023),
    [sym_equality_expression] = STATE(1023),
    [sym_relational_expression] = STATE(1023),
    [sym_shift_expression] = STATE(1023),
    [sym_math_expression] = STATE(1023),
    [sym_cast_expression] = STATE(1023),
    [sym_sizeof_expression] = STATE(1023),
    [sym_subscript_expression] = STATE(1023),
    [sym_call_expression] = STATE(1023),
    [sym_field_expression] = STATE(1023),
    [sym_compound_literal_expression] = STATE(1023),
    [sym_parenthesized_expression] = STATE(1023),
    [sym_concatenated_string] = STATE(1023),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(2647),
    [sym_char_literal] = ACTIONS(2647),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(2649),
    [sym_false] = ACTIONS(2649),
    [sym_null] = ACTIONS(2649),
    [sym_identifier] = ACTIONS(2649),
    [sym_comment] = ACTIONS(42),
  },
  [750] = {
    [sym__expression] = STATE(1024),
    [sym_conditional_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1024),
    [sym_pointer_expression] = STATE(1024),
    [sym_logical_expression] = STATE(1024),
    [sym_bitwise_expression] = STATE(1024),
    [sym_equality_expression] = STATE(1024),
    [sym_relational_expression] = STATE(1024),
    [sym_shift_expression] = STATE(1024),
    [sym_math_expression] = STATE(1024),
    [sym_cast_expression] = STATE(1024),
    [sym_sizeof_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_call_expression] = STATE(1024),
    [sym_field_expression] = STATE(1024),
    [sym_compound_literal_expression] = STATE(1024),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_concatenated_string] = STATE(1024),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(2651),
    [sym_char_literal] = ACTIONS(2651),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(2653),
    [sym_false] = ACTIONS(2653),
    [sym_null] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_comment] = ACTIONS(42),
  },
  [751] = {
    [sym__expression] = STATE(1025),
    [sym_conditional_expression] = STATE(1025),
    [sym_assignment_expression] = STATE(1025),
    [sym_pointer_expression] = STATE(1025),
    [sym_logical_expression] = STATE(1025),
    [sym_bitwise_expression] = STATE(1025),
    [sym_equality_expression] = STATE(1025),
    [sym_relational_expression] = STATE(1025),
    [sym_shift_expression] = STATE(1025),
    [sym_math_expression] = STATE(1025),
    [sym_cast_expression] = STATE(1025),
    [sym_sizeof_expression] = STATE(1025),
    [sym_subscript_expression] = STATE(1025),
    [sym_call_expression] = STATE(1025),
    [sym_field_expression] = STATE(1025),
    [sym_compound_literal_expression] = STATE(1025),
    [sym_parenthesized_expression] = STATE(1025),
    [sym_concatenated_string] = STATE(1025),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(2655),
    [sym_char_literal] = ACTIONS(2655),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(2657),
    [sym_false] = ACTIONS(2657),
    [sym_null] = ACTIONS(2657),
    [sym_identifier] = ACTIONS(2657),
    [sym_comment] = ACTIONS(42),
  },
  [752] = {
    [sym__expression] = STATE(1026),
    [sym_conditional_expression] = STATE(1026),
    [sym_assignment_expression] = STATE(1026),
    [sym_pointer_expression] = STATE(1026),
    [sym_logical_expression] = STATE(1026),
    [sym_bitwise_expression] = STATE(1026),
    [sym_equality_expression] = STATE(1026),
    [sym_relational_expression] = STATE(1026),
    [sym_shift_expression] = STATE(1026),
    [sym_math_expression] = STATE(1026),
    [sym_cast_expression] = STATE(1026),
    [sym_sizeof_expression] = STATE(1026),
    [sym_subscript_expression] = STATE(1026),
    [sym_call_expression] = STATE(1026),
    [sym_field_expression] = STATE(1026),
    [sym_compound_literal_expression] = STATE(1026),
    [sym_parenthesized_expression] = STATE(1026),
    [sym_concatenated_string] = STATE(1026),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(2659),
    [sym_char_literal] = ACTIONS(2659),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(2661),
    [sym_false] = ACTIONS(2661),
    [sym_null] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_comment] = ACTIONS(42),
  },
  [753] = {
    [sym__expression] = STATE(1027),
    [sym_conditional_expression] = STATE(1027),
    [sym_assignment_expression] = STATE(1027),
    [sym_pointer_expression] = STATE(1027),
    [sym_logical_expression] = STATE(1027),
    [sym_bitwise_expression] = STATE(1027),
    [sym_equality_expression] = STATE(1027),
    [sym_relational_expression] = STATE(1027),
    [sym_shift_expression] = STATE(1027),
    [sym_math_expression] = STATE(1027),
    [sym_cast_expression] = STATE(1027),
    [sym_sizeof_expression] = STATE(1027),
    [sym_subscript_expression] = STATE(1027),
    [sym_call_expression] = STATE(1027),
    [sym_field_expression] = STATE(1027),
    [sym_compound_literal_expression] = STATE(1027),
    [sym_parenthesized_expression] = STATE(1027),
    [sym_concatenated_string] = STATE(1027),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(2663),
    [sym_char_literal] = ACTIONS(2663),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(2665),
    [sym_false] = ACTIONS(2665),
    [sym_null] = ACTIONS(2665),
    [sym_identifier] = ACTIONS(2665),
    [sym_comment] = ACTIONS(42),
  },
  [754] = {
    [sym__expression] = STATE(1028),
    [sym_conditional_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1028),
    [sym_pointer_expression] = STATE(1028),
    [sym_logical_expression] = STATE(1028),
    [sym_bitwise_expression] = STATE(1028),
    [sym_equality_expression] = STATE(1028),
    [sym_relational_expression] = STATE(1028),
    [sym_shift_expression] = STATE(1028),
    [sym_math_expression] = STATE(1028),
    [sym_cast_expression] = STATE(1028),
    [sym_sizeof_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_call_expression] = STATE(1028),
    [sym_field_expression] = STATE(1028),
    [sym_compound_literal_expression] = STATE(1028),
    [sym_parenthesized_expression] = STATE(1028),
    [sym_concatenated_string] = STATE(1028),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(2667),
    [sym_char_literal] = ACTIONS(2667),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [sym_null] = ACTIONS(2669),
    [sym_identifier] = ACTIONS(2669),
    [sym_comment] = ACTIONS(42),
  },
  [755] = {
    [sym__expression] = STATE(1029),
    [sym_conditional_expression] = STATE(1029),
    [sym_assignment_expression] = STATE(1029),
    [sym_pointer_expression] = STATE(1029),
    [sym_logical_expression] = STATE(1029),
    [sym_bitwise_expression] = STATE(1029),
    [sym_equality_expression] = STATE(1029),
    [sym_relational_expression] = STATE(1029),
    [sym_shift_expression] = STATE(1029),
    [sym_math_expression] = STATE(1029),
    [sym_cast_expression] = STATE(1029),
    [sym_sizeof_expression] = STATE(1029),
    [sym_subscript_expression] = STATE(1029),
    [sym_call_expression] = STATE(1029),
    [sym_field_expression] = STATE(1029),
    [sym_compound_literal_expression] = STATE(1029),
    [sym_parenthesized_expression] = STATE(1029),
    [sym_concatenated_string] = STATE(1029),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(2671),
    [sym_char_literal] = ACTIONS(2671),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [sym_null] = ACTIONS(2673),
    [sym_identifier] = ACTIONS(2673),
    [sym_comment] = ACTIONS(42),
  },
  [756] = {
    [sym__expression] = STATE(1030),
    [sym_conditional_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1030),
    [sym_pointer_expression] = STATE(1030),
    [sym_logical_expression] = STATE(1030),
    [sym_bitwise_expression] = STATE(1030),
    [sym_equality_expression] = STATE(1030),
    [sym_relational_expression] = STATE(1030),
    [sym_shift_expression] = STATE(1030),
    [sym_math_expression] = STATE(1030),
    [sym_cast_expression] = STATE(1030),
    [sym_sizeof_expression] = STATE(1030),
    [sym_subscript_expression] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_field_expression] = STATE(1030),
    [sym_compound_literal_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_concatenated_string] = STATE(1030),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(2675),
    [sym_char_literal] = ACTIONS(2675),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(2677),
    [sym_false] = ACTIONS(2677),
    [sym_null] = ACTIONS(2677),
    [sym_identifier] = ACTIONS(2677),
    [sym_comment] = ACTIONS(42),
  },
  [757] = {
    [sym__expression] = STATE(1031),
    [sym_conditional_expression] = STATE(1031),
    [sym_assignment_expression] = STATE(1031),
    [sym_pointer_expression] = STATE(1031),
    [sym_logical_expression] = STATE(1031),
    [sym_bitwise_expression] = STATE(1031),
    [sym_equality_expression] = STATE(1031),
    [sym_relational_expression] = STATE(1031),
    [sym_shift_expression] = STATE(1031),
    [sym_math_expression] = STATE(1031),
    [sym_cast_expression] = STATE(1031),
    [sym_sizeof_expression] = STATE(1031),
    [sym_subscript_expression] = STATE(1031),
    [sym_call_expression] = STATE(1031),
    [sym_field_expression] = STATE(1031),
    [sym_compound_literal_expression] = STATE(1031),
    [sym_parenthesized_expression] = STATE(1031),
    [sym_concatenated_string] = STATE(1031),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(2679),
    [sym_char_literal] = ACTIONS(2679),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(2681),
    [sym_false] = ACTIONS(2681),
    [sym_null] = ACTIONS(2681),
    [sym_identifier] = ACTIONS(2681),
    [sym_comment] = ACTIONS(42),
  },
  [758] = {
    [sym__expression] = STATE(1032),
    [sym_conditional_expression] = STATE(1032),
    [sym_assignment_expression] = STATE(1032),
    [sym_pointer_expression] = STATE(1032),
    [sym_logical_expression] = STATE(1032),
    [sym_bitwise_expression] = STATE(1032),
    [sym_equality_expression] = STATE(1032),
    [sym_relational_expression] = STATE(1032),
    [sym_shift_expression] = STATE(1032),
    [sym_math_expression] = STATE(1032),
    [sym_cast_expression] = STATE(1032),
    [sym_sizeof_expression] = STATE(1032),
    [sym_subscript_expression] = STATE(1032),
    [sym_call_expression] = STATE(1032),
    [sym_field_expression] = STATE(1032),
    [sym_compound_literal_expression] = STATE(1032),
    [sym_parenthesized_expression] = STATE(1032),
    [sym_concatenated_string] = STATE(1032),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(2683),
    [sym_char_literal] = ACTIONS(2683),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(2685),
    [sym_false] = ACTIONS(2685),
    [sym_null] = ACTIONS(2685),
    [sym_identifier] = ACTIONS(2685),
    [sym_comment] = ACTIONS(42),
  },
  [759] = {
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_extern] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_auto] = ACTIONS(95),
    [anon_sym_register] = ACTIONS(95),
    [anon_sym_inline] = ACTIONS(95),
    [anon_sym_const] = ACTIONS(95),
    [anon_sym_restrict] = ACTIONS(95),
    [anon_sym_volatile] = ACTIONS(95),
    [anon_sym__Atomic] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_identifier] = ACTIONS(95),
    [sym_comment] = ACTIONS(42),
  },
  [760] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2687),
    [sym_preproc_directive] = ACTIONS(2687),
    [anon_sym_SEMI] = ACTIONS(2689),
    [anon_sym_typedef] = ACTIONS(2687),
    [anon_sym_extern] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_RBRACE] = ACTIONS(2689),
    [anon_sym_STAR] = ACTIONS(2689),
    [anon_sym_static] = ACTIONS(2687),
    [anon_sym_auto] = ACTIONS(2687),
    [anon_sym_register] = ACTIONS(2687),
    [anon_sym_inline] = ACTIONS(2687),
    [anon_sym_const] = ACTIONS(2687),
    [anon_sym_restrict] = ACTIONS(2687),
    [anon_sym_volatile] = ACTIONS(2687),
    [anon_sym__Atomic] = ACTIONS(2687),
    [anon_sym_unsigned] = ACTIONS(2687),
    [anon_sym_long] = ACTIONS(2687),
    [anon_sym_short] = ACTIONS(2687),
    [sym_primitive_type] = ACTIONS(2687),
    [anon_sym_enum] = ACTIONS(2687),
    [anon_sym_struct] = ACTIONS(2687),
    [anon_sym_union] = ACTIONS(2687),
    [anon_sym_if] = ACTIONS(2687),
    [anon_sym_switch] = ACTIONS(2687),
    [anon_sym_case] = ACTIONS(2687),
    [anon_sym_default] = ACTIONS(2687),
    [anon_sym_while] = ACTIONS(2687),
    [anon_sym_do] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2687),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_break] = ACTIONS(2687),
    [anon_sym_continue] = ACTIONS(2687),
    [anon_sym_goto] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_BANG] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2687),
    [anon_sym_DASH] = ACTIONS(2687),
    [anon_sym_DASH_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_PLUS] = ACTIONS(2689),
    [anon_sym_sizeof] = ACTIONS(2687),
    [sym_number_literal] = ACTIONS(2689),
    [sym_char_literal] = ACTIONS(2689),
    [sym_string_literal] = ACTIONS(2689),
    [sym_true] = ACTIONS(2687),
    [sym_false] = ACTIONS(2687),
    [sym_null] = ACTIONS(2687),
    [sym_identifier] = ACTIONS(2687),
    [sym_comment] = ACTIONS(42),
  },
  [761] = {
    [sym__declarator] = STATE(483),
    [sym_pointer_declarator] = STATE(483),
    [sym_function_declarator] = STATE(483),
    [sym_array_declarator] = STATE(483),
    [sym_init_declarator] = STATE(484),
    [anon_sym_LPAREN] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(561),
    [sym_identifier] = ACTIONS(1155),
    [sym_comment] = ACTIONS(42),
  },
  [762] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(2691),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [763] = {
    [sym__expression] = STATE(1034),
    [sym_conditional_expression] = STATE(1034),
    [sym_assignment_expression] = STATE(1034),
    [sym_pointer_expression] = STATE(1034),
    [sym_logical_expression] = STATE(1034),
    [sym_bitwise_expression] = STATE(1034),
    [sym_equality_expression] = STATE(1034),
    [sym_relational_expression] = STATE(1034),
    [sym_shift_expression] = STATE(1034),
    [sym_math_expression] = STATE(1034),
    [sym_cast_expression] = STATE(1034),
    [sym_sizeof_expression] = STATE(1034),
    [sym_subscript_expression] = STATE(1034),
    [sym_call_expression] = STATE(1034),
    [sym_field_expression] = STATE(1034),
    [sym_compound_literal_expression] = STATE(1034),
    [sym_parenthesized_expression] = STATE(1034),
    [sym_concatenated_string] = STATE(1034),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(2693),
    [sym_char_literal] = ACTIONS(2693),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(2695),
    [sym_false] = ACTIONS(2695),
    [sym_null] = ACTIONS(2695),
    [sym_identifier] = ACTIONS(2695),
    [sym_comment] = ACTIONS(42),
  },
  [764] = {
    [sym__expression] = STATE(1035),
    [sym_conditional_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1035),
    [sym_pointer_expression] = STATE(1035),
    [sym_logical_expression] = STATE(1035),
    [sym_bitwise_expression] = STATE(1035),
    [sym_equality_expression] = STATE(1035),
    [sym_relational_expression] = STATE(1035),
    [sym_shift_expression] = STATE(1035),
    [sym_math_expression] = STATE(1035),
    [sym_cast_expression] = STATE(1035),
    [sym_sizeof_expression] = STATE(1035),
    [sym_subscript_expression] = STATE(1035),
    [sym_call_expression] = STATE(1035),
    [sym_field_expression] = STATE(1035),
    [sym_compound_literal_expression] = STATE(1035),
    [sym_parenthesized_expression] = STATE(1035),
    [sym_concatenated_string] = STATE(1035),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(2697),
    [sym_char_literal] = ACTIONS(2697),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(2699),
    [sym_false] = ACTIONS(2699),
    [sym_null] = ACTIONS(2699),
    [sym_identifier] = ACTIONS(2699),
    [sym_comment] = ACTIONS(42),
  },
  [765] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1737),
    [anon_sym_COLON] = ACTIONS(2701),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1743),
    [anon_sym_SLASH_EQ] = ACTIONS(1743),
    [anon_sym_PERCENT_EQ] = ACTIONS(1743),
    [anon_sym_PLUS_EQ] = ACTIONS(1743),
    [anon_sym_DASH_EQ] = ACTIONS(1743),
    [anon_sym_LT_LT_EQ] = ACTIONS(1743),
    [anon_sym_GT_GT_EQ] = ACTIONS(1743),
    [anon_sym_AMP_EQ] = ACTIONS(1743),
    [anon_sym_CARET_EQ] = ACTIONS(1743),
    [anon_sym_PIPE_EQ] = ACTIONS(1743),
    [anon_sym_AMP] = ACTIONS(1745),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_AMP_AMP] = ACTIONS(1749),
    [anon_sym_PIPE] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_GT] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [766] = {
    [sym_declaration] = STATE(760),
    [sym_type_definition] = STATE(760),
    [sym__declaration_specifiers] = STATE(761),
    [sym_compound_statement] = STATE(760),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(760),
    [sym_expression_statement] = STATE(760),
    [sym_if_statement] = STATE(760),
    [sym_switch_statement] = STATE(760),
    [sym_case_statement] = STATE(760),
    [sym_while_statement] = STATE(760),
    [sym_do_statement] = STATE(760),
    [sym_for_statement] = STATE(760),
    [sym_return_statement] = STATE(760),
    [sym_break_statement] = STATE(760),
    [sym_continue_statement] = STATE(760),
    [sym_goto_statement] = STATE(760),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_typedef] = ACTIONS(585),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_default] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(1089),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(2703),
    [sym_comment] = ACTIONS(42),
  },
  [767] = {
    [sym__expression] = STATE(1038),
    [sym_conditional_expression] = STATE(1038),
    [sym_assignment_expression] = STATE(1038),
    [sym_pointer_expression] = STATE(1038),
    [sym_logical_expression] = STATE(1038),
    [sym_bitwise_expression] = STATE(1038),
    [sym_equality_expression] = STATE(1038),
    [sym_relational_expression] = STATE(1038),
    [sym_shift_expression] = STATE(1038),
    [sym_math_expression] = STATE(1038),
    [sym_cast_expression] = STATE(1038),
    [sym_sizeof_expression] = STATE(1038),
    [sym_subscript_expression] = STATE(1038),
    [sym_call_expression] = STATE(1038),
    [sym_field_expression] = STATE(1038),
    [sym_compound_literal_expression] = STATE(1038),
    [sym_parenthesized_expression] = STATE(1038),
    [sym_concatenated_string] = STATE(1038),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(2705),
    [sym_char_literal] = ACTIONS(2705),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(2707),
    [sym_false] = ACTIONS(2707),
    [sym_null] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_comment] = ACTIONS(42),
  },
  [768] = {
    [sym_declaration] = STATE(1039),
    [sym__declaration_specifiers] = STATE(773),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym__expression] = STATE(1040),
    [sym_conditional_expression] = STATE(1040),
    [sym_assignment_expression] = STATE(1040),
    [sym_pointer_expression] = STATE(1040),
    [sym_logical_expression] = STATE(1040),
    [sym_bitwise_expression] = STATE(1040),
    [sym_equality_expression] = STATE(1040),
    [sym_relational_expression] = STATE(1040),
    [sym_shift_expression] = STATE(1040),
    [sym_math_expression] = STATE(1040),
    [sym_cast_expression] = STATE(1040),
    [sym_sizeof_expression] = STATE(1040),
    [sym_subscript_expression] = STATE(1040),
    [sym_call_expression] = STATE(1040),
    [sym_field_expression] = STATE(1040),
    [sym_compound_literal_expression] = STATE(1040),
    [sym_parenthesized_expression] = STATE(1040),
    [sym_concatenated_string] = STATE(1040),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(2709),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(2711),
    [sym_char_literal] = ACTIONS(2711),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(2713),
    [sym_false] = ACTIONS(2713),
    [sym_null] = ACTIONS(2713),
    [sym_identifier] = ACTIONS(1795),
    [sym_comment] = ACTIONS(42),
  },
  [769] = {
    [sym_compound_statement] = STATE(780),
    [sym_labeled_statement] = STATE(780),
    [sym_expression_statement] = STATE(780),
    [sym_if_statement] = STATE(780),
    [sym_switch_statement] = STATE(780),
    [sym_case_statement] = STATE(780),
    [sym_while_statement] = STATE(780),
    [sym_do_statement] = STATE(780),
    [sym_for_statement] = STATE(780),
    [sym_return_statement] = STATE(780),
    [sym_break_statement] = STATE(780),
    [sym_continue_statement] = STATE(780),
    [sym_goto_statement] = STATE(780),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_default] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(1089),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1093),
    [sym_comment] = ACTIONS(42),
  },
  [770] = {
    [anon_sym_LPAREN] = ACTIONS(2715),
    [sym_comment] = ACTIONS(42),
  },
  [771] = {
    [sym__expression] = STATE(1043),
    [sym_conditional_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1043),
    [sym_pointer_expression] = STATE(1043),
    [sym_logical_expression] = STATE(1043),
    [sym_bitwise_expression] = STATE(1043),
    [sym_equality_expression] = STATE(1043),
    [sym_relational_expression] = STATE(1043),
    [sym_shift_expression] = STATE(1043),
    [sym_math_expression] = STATE(1043),
    [sym_cast_expression] = STATE(1043),
    [sym_sizeof_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_call_expression] = STATE(1043),
    [sym_field_expression] = STATE(1043),
    [sym_compound_literal_expression] = STATE(1043),
    [sym_parenthesized_expression] = STATE(1043),
    [sym_concatenated_string] = STATE(1043),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(2719),
    [sym_char_literal] = ACTIONS(2719),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(2721),
    [sym_false] = ACTIONS(2721),
    [sym_null] = ACTIONS(2721),
    [sym_identifier] = ACTIONS(2721),
    [sym_comment] = ACTIONS(42),
  },
  [772] = {
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_extern] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_auto] = ACTIONS(95),
    [anon_sym_register] = ACTIONS(95),
    [anon_sym_inline] = ACTIONS(95),
    [anon_sym_const] = ACTIONS(95),
    [anon_sym_restrict] = ACTIONS(95),
    [anon_sym_volatile] = ACTIONS(95),
    [anon_sym__Atomic] = ACTIONS(95),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_identifier] = ACTIONS(95),
    [sym_comment] = ACTIONS(42),
  },
  [773] = {
    [sym__declarator] = STATE(1044),
    [sym_pointer_declarator] = STATE(1044),
    [sym_function_declarator] = STATE(1044),
    [sym_array_declarator] = STATE(1044),
    [sym_init_declarator] = STATE(1045),
    [anon_sym_LPAREN] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(561),
    [sym_identifier] = ACTIONS(2723),
    [sym_comment] = ACTIONS(42),
  },
  [774] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [775] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2727),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2727),
    [sym_preproc_directive] = ACTIONS(2727),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym_typedef] = ACTIONS(2727),
    [anon_sym_extern] = ACTIONS(2727),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_RBRACE] = ACTIONS(2729),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_auto] = ACTIONS(2727),
    [anon_sym_register] = ACTIONS(2727),
    [anon_sym_inline] = ACTIONS(2727),
    [anon_sym_const] = ACTIONS(2727),
    [anon_sym_restrict] = ACTIONS(2727),
    [anon_sym_volatile] = ACTIONS(2727),
    [anon_sym__Atomic] = ACTIONS(2727),
    [anon_sym_unsigned] = ACTIONS(2727),
    [anon_sym_long] = ACTIONS(2727),
    [anon_sym_short] = ACTIONS(2727),
    [sym_primitive_type] = ACTIONS(2727),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_struct] = ACTIONS(2727),
    [anon_sym_union] = ACTIONS(2727),
    [anon_sym_if] = ACTIONS(2727),
    [anon_sym_switch] = ACTIONS(2727),
    [anon_sym_case] = ACTIONS(2727),
    [anon_sym_default] = ACTIONS(2727),
    [anon_sym_while] = ACTIONS(2727),
    [anon_sym_do] = ACTIONS(2727),
    [anon_sym_for] = ACTIONS(2727),
    [anon_sym_return] = ACTIONS(2727),
    [anon_sym_break] = ACTIONS(2727),
    [anon_sym_continue] = ACTIONS(2727),
    [anon_sym_goto] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_BANG] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2727),
    [anon_sym_DASH] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_sizeof] = ACTIONS(2727),
    [sym_number_literal] = ACTIONS(2729),
    [sym_char_literal] = ACTIONS(2729),
    [sym_string_literal] = ACTIONS(2729),
    [sym_true] = ACTIONS(2727),
    [sym_false] = ACTIONS(2727),
    [sym_null] = ACTIONS(2727),
    [sym_identifier] = ACTIONS(2727),
    [sym_comment] = ACTIONS(42),
  },
  [776] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2731),
    [anon_sym_LPAREN] = ACTIONS(2733),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_RBRACE] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_auto] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_case] = ACTIONS(2731),
    [anon_sym_default] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [sym_number_literal] = ACTIONS(2733),
    [sym_char_literal] = ACTIONS(2733),
    [sym_string_literal] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [sym_null] = ACTIONS(2731),
    [sym_identifier] = ACTIONS(2731),
    [sym_comment] = ACTIONS(42),
  },
  [777] = {
    [anon_sym_RPAREN] = ACTIONS(2735),
    [sym_comment] = ACTIONS(42),
  },
  [778] = {
    [aux_sym_concatenated_string_repeat1] = STATE(778),
    [anon_sym_LPAREN] = ACTIONS(2737),
    [anon_sym_COMMA] = ACTIONS(2737),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_STAR] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2737),
    [anon_sym_EQ] = ACTIONS(2739),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2737),
    [anon_sym_SLASH_EQ] = ACTIONS(2737),
    [anon_sym_PERCENT_EQ] = ACTIONS(2737),
    [anon_sym_PLUS_EQ] = ACTIONS(2737),
    [anon_sym_DASH_EQ] = ACTIONS(2737),
    [anon_sym_LT_LT_EQ] = ACTIONS(2737),
    [anon_sym_GT_GT_EQ] = ACTIONS(2737),
    [anon_sym_AMP_EQ] = ACTIONS(2737),
    [anon_sym_CARET_EQ] = ACTIONS(2737),
    [anon_sym_PIPE_EQ] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2739),
    [anon_sym_PIPE_PIPE] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_PIPE] = ACTIONS(2739),
    [anon_sym_CARET] = ACTIONS(2739),
    [anon_sym_EQ_EQ] = ACTIONS(2737),
    [anon_sym_BANG_EQ] = ACTIONS(2737),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_GT] = ACTIONS(2739),
    [anon_sym_LT_EQ] = ACTIONS(2737),
    [anon_sym_GT_EQ] = ACTIONS(2737),
    [anon_sym_LT_LT] = ACTIONS(2739),
    [anon_sym_GT_GT] = ACTIONS(2739),
    [anon_sym_PLUS] = ACTIONS(2739),
    [anon_sym_DASH] = ACTIONS(2739),
    [anon_sym_SLASH] = ACTIONS(2739),
    [anon_sym_PERCENT] = ACTIONS(2739),
    [anon_sym_DASH_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_PLUS] = ACTIONS(2737),
    [anon_sym_DOT] = ACTIONS(2737),
    [anon_sym_DASH_GT] = ACTIONS(2737),
    [sym_string_literal] = ACTIONS(2741),
    [sym_comment] = ACTIONS(42),
  },
  [779] = {
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_COLON] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_comment] = ACTIONS(42),
  },
  [780] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2746),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2744),
    [sym_preproc_directive] = ACTIONS(2744),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_typedef] = ACTIONS(2744),
    [anon_sym_extern] = ACTIONS(2744),
    [anon_sym_LBRACE] = ACTIONS(2746),
    [anon_sym_RBRACE] = ACTIONS(2746),
    [anon_sym_STAR] = ACTIONS(2746),
    [anon_sym_static] = ACTIONS(2744),
    [anon_sym_auto] = ACTIONS(2744),
    [anon_sym_register] = ACTIONS(2744),
    [anon_sym_inline] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_restrict] = ACTIONS(2744),
    [anon_sym_volatile] = ACTIONS(2744),
    [anon_sym__Atomic] = ACTIONS(2744),
    [anon_sym_unsigned] = ACTIONS(2744),
    [anon_sym_long] = ACTIONS(2744),
    [anon_sym_short] = ACTIONS(2744),
    [sym_primitive_type] = ACTIONS(2744),
    [anon_sym_enum] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_union] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_switch] = ACTIONS(2744),
    [anon_sym_case] = ACTIONS(2744),
    [anon_sym_default] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [anon_sym_do] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_break] = ACTIONS(2744),
    [anon_sym_continue] = ACTIONS(2744),
    [anon_sym_goto] = ACTIONS(2744),
    [anon_sym_AMP] = ACTIONS(2746),
    [anon_sym_BANG] = ACTIONS(2746),
    [anon_sym_TILDE] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_DASH] = ACTIONS(2744),
    [anon_sym_DASH_DASH] = ACTIONS(2746),
    [anon_sym_PLUS_PLUS] = ACTIONS(2746),
    [anon_sym_sizeof] = ACTIONS(2744),
    [sym_number_literal] = ACTIONS(2746),
    [sym_char_literal] = ACTIONS(2746),
    [sym_string_literal] = ACTIONS(2746),
    [sym_true] = ACTIONS(2744),
    [sym_false] = ACTIONS(2744),
    [sym_null] = ACTIONS(2744),
    [sym_identifier] = ACTIONS(2744),
    [sym_comment] = ACTIONS(42),
  },
  [781] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(567),
    [anon_sym_LPAREN] = ACTIONS(565),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(567),
    [sym_preproc_directive] = ACTIONS(567),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_typedef] = ACTIONS(567),
    [anon_sym_extern] = ACTIONS(567),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_STAR] = ACTIONS(565),
    [anon_sym_static] = ACTIONS(567),
    [anon_sym_auto] = ACTIONS(567),
    [anon_sym_register] = ACTIONS(567),
    [anon_sym_inline] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_restrict] = ACTIONS(567),
    [anon_sym_volatile] = ACTIONS(567),
    [anon_sym__Atomic] = ACTIONS(567),
    [anon_sym_unsigned] = ACTIONS(567),
    [anon_sym_long] = ACTIONS(567),
    [anon_sym_short] = ACTIONS(567),
    [sym_primitive_type] = ACTIONS(567),
    [anon_sym_enum] = ACTIONS(567),
    [anon_sym_struct] = ACTIONS(567),
    [anon_sym_union] = ACTIONS(567),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_switch] = ACTIONS(567),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_default] = ACTIONS(567),
    [anon_sym_while] = ACTIONS(567),
    [anon_sym_do] = ACTIONS(567),
    [anon_sym_for] = ACTIONS(567),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_break] = ACTIONS(567),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(565),
    [anon_sym_TILDE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_sizeof] = ACTIONS(567),
    [sym_number_literal] = ACTIONS(565),
    [sym_char_literal] = ACTIONS(565),
    [sym_string_literal] = ACTIONS(565),
    [sym_true] = ACTIONS(567),
    [sym_false] = ACTIONS(567),
    [sym_null] = ACTIONS(567),
    [sym_identifier] = ACTIONS(567),
    [sym_comment] = ACTIONS(42),
  },
  [782] = {
    [aux_sym_declaration_repeat1] = STATE(302),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(2748),
    [sym_comment] = ACTIONS(42),
  },
  [783] = {
    [anon_sym_LPAREN] = ACTIONS(2750),
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_RPAREN] = ACTIONS(2750),
    [anon_sym_SEMI] = ACTIONS(2750),
    [anon_sym_RBRACE] = ACTIONS(2750),
    [anon_sym_STAR] = ACTIONS(2752),
    [anon_sym_LBRACK] = ACTIONS(2750),
    [anon_sym_RBRACK] = ACTIONS(2750),
    [anon_sym_EQ] = ACTIONS(2752),
    [anon_sym_COLON] = ACTIONS(2750),
    [anon_sym_QMARK] = ACTIONS(2750),
    [anon_sym_STAR_EQ] = ACTIONS(2750),
    [anon_sym_SLASH_EQ] = ACTIONS(2750),
    [anon_sym_PERCENT_EQ] = ACTIONS(2750),
    [anon_sym_PLUS_EQ] = ACTIONS(2750),
    [anon_sym_DASH_EQ] = ACTIONS(2750),
    [anon_sym_LT_LT_EQ] = ACTIONS(2750),
    [anon_sym_GT_GT_EQ] = ACTIONS(2750),
    [anon_sym_AMP_EQ] = ACTIONS(2750),
    [anon_sym_CARET_EQ] = ACTIONS(2750),
    [anon_sym_PIPE_EQ] = ACTIONS(2750),
    [anon_sym_AMP] = ACTIONS(2752),
    [anon_sym_PIPE_PIPE] = ACTIONS(2750),
    [anon_sym_AMP_AMP] = ACTIONS(2750),
    [anon_sym_PIPE] = ACTIONS(2752),
    [anon_sym_CARET] = ACTIONS(2752),
    [anon_sym_EQ_EQ] = ACTIONS(2750),
    [anon_sym_BANG_EQ] = ACTIONS(2750),
    [anon_sym_LT] = ACTIONS(2752),
    [anon_sym_GT] = ACTIONS(2752),
    [anon_sym_LT_EQ] = ACTIONS(2750),
    [anon_sym_GT_EQ] = ACTIONS(2750),
    [anon_sym_LT_LT] = ACTIONS(2752),
    [anon_sym_GT_GT] = ACTIONS(2752),
    [anon_sym_PLUS] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2752),
    [anon_sym_SLASH] = ACTIONS(2752),
    [anon_sym_PERCENT] = ACTIONS(2752),
    [anon_sym_DASH_DASH] = ACTIONS(2750),
    [anon_sym_PLUS_PLUS] = ACTIONS(2750),
    [anon_sym_DOT] = ACTIONS(2750),
    [anon_sym_DASH_GT] = ACTIONS(2750),
    [sym_comment] = ACTIONS(42),
  },
  [784] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1051),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(2756),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [785] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_SEMI] = ACTIONS(2758),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_STAR_EQ] = ACTIONS(1171),
    [anon_sym_SLASH_EQ] = ACTIONS(1171),
    [anon_sym_PERCENT_EQ] = ACTIONS(1171),
    [anon_sym_PLUS_EQ] = ACTIONS(1171),
    [anon_sym_DASH_EQ] = ACTIONS(1171),
    [anon_sym_LT_LT_EQ] = ACTIONS(1171),
    [anon_sym_GT_GT_EQ] = ACTIONS(1171),
    [anon_sym_AMP_EQ] = ACTIONS(1171),
    [anon_sym_CARET_EQ] = ACTIONS(1171),
    [anon_sym_PIPE_EQ] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_PIPE_PIPE] = ACTIONS(1175),
    [anon_sym_AMP_AMP] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_LT] = ACTIONS(1185),
    [anon_sym_GT] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1187),
    [anon_sym_GT_EQ] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1189),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [786] = {
    [anon_sym_RPAREN] = ACTIONS(2758),
    [anon_sym_SEMI] = ACTIONS(2758),
    [sym_comment] = ACTIONS(42),
  },
  [787] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2760),
    [anon_sym_RPAREN] = ACTIONS(2760),
    [anon_sym_SEMI] = ACTIONS(2760),
    [anon_sym_RBRACE] = ACTIONS(2760),
    [anon_sym_STAR] = ACTIONS(2762),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2760),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_COLON] = ACTIONS(2760),
    [anon_sym_QMARK] = ACTIONS(2760),
    [anon_sym_STAR_EQ] = ACTIONS(2760),
    [anon_sym_SLASH_EQ] = ACTIONS(2760),
    [anon_sym_PERCENT_EQ] = ACTIONS(2760),
    [anon_sym_PLUS_EQ] = ACTIONS(2760),
    [anon_sym_DASH_EQ] = ACTIONS(2760),
    [anon_sym_LT_LT_EQ] = ACTIONS(2760),
    [anon_sym_GT_GT_EQ] = ACTIONS(2760),
    [anon_sym_AMP_EQ] = ACTIONS(2760),
    [anon_sym_CARET_EQ] = ACTIONS(2760),
    [anon_sym_PIPE_EQ] = ACTIONS(2760),
    [anon_sym_AMP] = ACTIONS(2762),
    [anon_sym_PIPE_PIPE] = ACTIONS(2760),
    [anon_sym_AMP_AMP] = ACTIONS(2760),
    [anon_sym_PIPE] = ACTIONS(2762),
    [anon_sym_CARET] = ACTIONS(2762),
    [anon_sym_EQ_EQ] = ACTIONS(2760),
    [anon_sym_BANG_EQ] = ACTIONS(2760),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_GT] = ACTIONS(2762),
    [anon_sym_LT_EQ] = ACTIONS(2760),
    [anon_sym_GT_EQ] = ACTIONS(2760),
    [anon_sym_LT_LT] = ACTIONS(2762),
    [anon_sym_GT_GT] = ACTIONS(2762),
    [anon_sym_PLUS] = ACTIONS(2762),
    [anon_sym_DASH] = ACTIONS(2762),
    [anon_sym_SLASH] = ACTIONS(2762),
    [anon_sym_PERCENT] = ACTIONS(2762),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [788] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2764),
    [anon_sym_EQ] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1237),
    [anon_sym_STAR_EQ] = ACTIONS(1239),
    [anon_sym_SLASH_EQ] = ACTIONS(1239),
    [anon_sym_PERCENT_EQ] = ACTIONS(1239),
    [anon_sym_PLUS_EQ] = ACTIONS(1239),
    [anon_sym_DASH_EQ] = ACTIONS(1239),
    [anon_sym_LT_LT_EQ] = ACTIONS(1239),
    [anon_sym_GT_GT_EQ] = ACTIONS(1239),
    [anon_sym_AMP_EQ] = ACTIONS(1239),
    [anon_sym_CARET_EQ] = ACTIONS(1239),
    [anon_sym_PIPE_EQ] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_PIPE_PIPE] = ACTIONS(1243),
    [anon_sym_AMP_AMP] = ACTIONS(1245),
    [anon_sym_PIPE] = ACTIONS(1247),
    [anon_sym_CARET] = ACTIONS(1249),
    [anon_sym_EQ_EQ] = ACTIONS(1251),
    [anon_sym_BANG_EQ] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1253),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [789] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2766),
    [anon_sym_SEMI] = ACTIONS(2766),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_STAR_EQ] = ACTIONS(1171),
    [anon_sym_SLASH_EQ] = ACTIONS(1171),
    [anon_sym_PERCENT_EQ] = ACTIONS(1171),
    [anon_sym_PLUS_EQ] = ACTIONS(1171),
    [anon_sym_DASH_EQ] = ACTIONS(1171),
    [anon_sym_LT_LT_EQ] = ACTIONS(1171),
    [anon_sym_GT_GT_EQ] = ACTIONS(1171),
    [anon_sym_AMP_EQ] = ACTIONS(1171),
    [anon_sym_CARET_EQ] = ACTIONS(1171),
    [anon_sym_PIPE_EQ] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_PIPE_PIPE] = ACTIONS(1175),
    [anon_sym_AMP_AMP] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_LT] = ACTIONS(1185),
    [anon_sym_GT] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1187),
    [anon_sym_GT_EQ] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1189),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [790] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1737),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1743),
    [anon_sym_SLASH_EQ] = ACTIONS(1743),
    [anon_sym_PERCENT_EQ] = ACTIONS(1743),
    [anon_sym_PLUS_EQ] = ACTIONS(1743),
    [anon_sym_DASH_EQ] = ACTIONS(1743),
    [anon_sym_LT_LT_EQ] = ACTIONS(1743),
    [anon_sym_GT_GT_EQ] = ACTIONS(1743),
    [anon_sym_AMP_EQ] = ACTIONS(1743),
    [anon_sym_CARET_EQ] = ACTIONS(1743),
    [anon_sym_PIPE_EQ] = ACTIONS(1743),
    [anon_sym_AMP] = ACTIONS(1745),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_AMP_AMP] = ACTIONS(1749),
    [anon_sym_PIPE] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_GT] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [791] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_SEMI] = ACTIONS(2770),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_STAR_EQ] = ACTIONS(2770),
    [anon_sym_SLASH_EQ] = ACTIONS(2770),
    [anon_sym_PERCENT_EQ] = ACTIONS(2770),
    [anon_sym_PLUS_EQ] = ACTIONS(2770),
    [anon_sym_DASH_EQ] = ACTIONS(2770),
    [anon_sym_LT_LT_EQ] = ACTIONS(2770),
    [anon_sym_GT_GT_EQ] = ACTIONS(2770),
    [anon_sym_AMP_EQ] = ACTIONS(2770),
    [anon_sym_CARET_EQ] = ACTIONS(2770),
    [anon_sym_PIPE_EQ] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2772),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_PIPE] = ACTIONS(2772),
    [anon_sym_CARET] = ACTIONS(2772),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_LT] = ACTIONS(1185),
    [anon_sym_GT] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1187),
    [anon_sym_GT_EQ] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1189),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [792] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2774),
    [anon_sym_SEMI] = ACTIONS(2774),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2776),
    [anon_sym_QMARK] = ACTIONS(2774),
    [anon_sym_STAR_EQ] = ACTIONS(2774),
    [anon_sym_SLASH_EQ] = ACTIONS(2774),
    [anon_sym_PERCENT_EQ] = ACTIONS(2774),
    [anon_sym_PLUS_EQ] = ACTIONS(2774),
    [anon_sym_DASH_EQ] = ACTIONS(2774),
    [anon_sym_LT_LT_EQ] = ACTIONS(2774),
    [anon_sym_GT_GT_EQ] = ACTIONS(2774),
    [anon_sym_AMP_EQ] = ACTIONS(2774),
    [anon_sym_CARET_EQ] = ACTIONS(2774),
    [anon_sym_PIPE_EQ] = ACTIONS(2774),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_PIPE_PIPE] = ACTIONS(2774),
    [anon_sym_AMP_AMP] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_LT] = ACTIONS(1185),
    [anon_sym_GT] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1187),
    [anon_sym_GT_EQ] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1189),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [793] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2774),
    [anon_sym_SEMI] = ACTIONS(2774),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2776),
    [anon_sym_QMARK] = ACTIONS(2774),
    [anon_sym_STAR_EQ] = ACTIONS(2774),
    [anon_sym_SLASH_EQ] = ACTIONS(2774),
    [anon_sym_PERCENT_EQ] = ACTIONS(2774),
    [anon_sym_PLUS_EQ] = ACTIONS(2774),
    [anon_sym_DASH_EQ] = ACTIONS(2774),
    [anon_sym_LT_LT_EQ] = ACTIONS(2774),
    [anon_sym_GT_GT_EQ] = ACTIONS(2774),
    [anon_sym_AMP_EQ] = ACTIONS(2774),
    [anon_sym_CARET_EQ] = ACTIONS(2774),
    [anon_sym_PIPE_EQ] = ACTIONS(2774),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_PIPE_PIPE] = ACTIONS(2774),
    [anon_sym_AMP_AMP] = ACTIONS(2774),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_LT] = ACTIONS(1185),
    [anon_sym_GT] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1187),
    [anon_sym_GT_EQ] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1189),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [794] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_SEMI] = ACTIONS(2770),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_STAR_EQ] = ACTIONS(2770),
    [anon_sym_SLASH_EQ] = ACTIONS(2770),
    [anon_sym_PERCENT_EQ] = ACTIONS(2770),
    [anon_sym_PLUS_EQ] = ACTIONS(2770),
    [anon_sym_DASH_EQ] = ACTIONS(2770),
    [anon_sym_LT_LT_EQ] = ACTIONS(2770),
    [anon_sym_GT_GT_EQ] = ACTIONS(2770),
    [anon_sym_AMP_EQ] = ACTIONS(2770),
    [anon_sym_CARET_EQ] = ACTIONS(2770),
    [anon_sym_PIPE_EQ] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_PIPE] = ACTIONS(2772),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_LT] = ACTIONS(1185),
    [anon_sym_GT] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1187),
    [anon_sym_GT_EQ] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1189),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [795] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_SEMI] = ACTIONS(2770),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_STAR_EQ] = ACTIONS(2770),
    [anon_sym_SLASH_EQ] = ACTIONS(2770),
    [anon_sym_PERCENT_EQ] = ACTIONS(2770),
    [anon_sym_PLUS_EQ] = ACTIONS(2770),
    [anon_sym_DASH_EQ] = ACTIONS(2770),
    [anon_sym_LT_LT_EQ] = ACTIONS(2770),
    [anon_sym_GT_GT_EQ] = ACTIONS(2770),
    [anon_sym_AMP_EQ] = ACTIONS(2770),
    [anon_sym_CARET_EQ] = ACTIONS(2770),
    [anon_sym_PIPE_EQ] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_PIPE] = ACTIONS(2772),
    [anon_sym_CARET] = ACTIONS(2772),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_LT] = ACTIONS(1185),
    [anon_sym_GT] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1187),
    [anon_sym_GT_EQ] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1189),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [796] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2778),
    [anon_sym_SEMI] = ACTIONS(2778),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2780),
    [anon_sym_QMARK] = ACTIONS(2778),
    [anon_sym_STAR_EQ] = ACTIONS(2778),
    [anon_sym_SLASH_EQ] = ACTIONS(2778),
    [anon_sym_PERCENT_EQ] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2778),
    [anon_sym_DASH_EQ] = ACTIONS(2778),
    [anon_sym_LT_LT_EQ] = ACTIONS(2778),
    [anon_sym_GT_GT_EQ] = ACTIONS(2778),
    [anon_sym_AMP_EQ] = ACTIONS(2778),
    [anon_sym_CARET_EQ] = ACTIONS(2778),
    [anon_sym_PIPE_EQ] = ACTIONS(2778),
    [anon_sym_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2778),
    [anon_sym_AMP_AMP] = ACTIONS(2778),
    [anon_sym_PIPE] = ACTIONS(2780),
    [anon_sym_CARET] = ACTIONS(2780),
    [anon_sym_EQ_EQ] = ACTIONS(2778),
    [anon_sym_BANG_EQ] = ACTIONS(2778),
    [anon_sym_LT] = ACTIONS(1185),
    [anon_sym_GT] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1187),
    [anon_sym_GT_EQ] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1189),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [797] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2782),
    [anon_sym_SEMI] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2784),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_STAR_EQ] = ACTIONS(2782),
    [anon_sym_SLASH_EQ] = ACTIONS(2782),
    [anon_sym_PERCENT_EQ] = ACTIONS(2782),
    [anon_sym_PLUS_EQ] = ACTIONS(2782),
    [anon_sym_DASH_EQ] = ACTIONS(2782),
    [anon_sym_LT_LT_EQ] = ACTIONS(2782),
    [anon_sym_GT_GT_EQ] = ACTIONS(2782),
    [anon_sym_AMP_EQ] = ACTIONS(2782),
    [anon_sym_CARET_EQ] = ACTIONS(2782),
    [anon_sym_PIPE_EQ] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2784),
    [anon_sym_PIPE_PIPE] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2784),
    [anon_sym_CARET] = ACTIONS(2784),
    [anon_sym_EQ_EQ] = ACTIONS(2782),
    [anon_sym_BANG_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2784),
    [anon_sym_GT] = ACTIONS(2784),
    [anon_sym_LT_EQ] = ACTIONS(2782),
    [anon_sym_GT_EQ] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(1189),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [798] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2786),
    [anon_sym_SEMI] = ACTIONS(2786),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2788),
    [anon_sym_QMARK] = ACTIONS(2786),
    [anon_sym_STAR_EQ] = ACTIONS(2786),
    [anon_sym_SLASH_EQ] = ACTIONS(2786),
    [anon_sym_PERCENT_EQ] = ACTIONS(2786),
    [anon_sym_PLUS_EQ] = ACTIONS(2786),
    [anon_sym_DASH_EQ] = ACTIONS(2786),
    [anon_sym_LT_LT_EQ] = ACTIONS(2786),
    [anon_sym_GT_GT_EQ] = ACTIONS(2786),
    [anon_sym_AMP_EQ] = ACTIONS(2786),
    [anon_sym_CARET_EQ] = ACTIONS(2786),
    [anon_sym_PIPE_EQ] = ACTIONS(2786),
    [anon_sym_AMP] = ACTIONS(2788),
    [anon_sym_PIPE_PIPE] = ACTIONS(2786),
    [anon_sym_AMP_AMP] = ACTIONS(2786),
    [anon_sym_PIPE] = ACTIONS(2788),
    [anon_sym_CARET] = ACTIONS(2788),
    [anon_sym_EQ_EQ] = ACTIONS(2786),
    [anon_sym_BANG_EQ] = ACTIONS(2786),
    [anon_sym_LT] = ACTIONS(2788),
    [anon_sym_GT] = ACTIONS(2788),
    [anon_sym_LT_EQ] = ACTIONS(2786),
    [anon_sym_GT_EQ] = ACTIONS(2786),
    [anon_sym_LT_LT] = ACTIONS(2788),
    [anon_sym_GT_GT] = ACTIONS(2788),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [799] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2760),
    [anon_sym_SEMI] = ACTIONS(2760),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_QMARK] = ACTIONS(2760),
    [anon_sym_STAR_EQ] = ACTIONS(2760),
    [anon_sym_SLASH_EQ] = ACTIONS(2760),
    [anon_sym_PERCENT_EQ] = ACTIONS(2760),
    [anon_sym_PLUS_EQ] = ACTIONS(2760),
    [anon_sym_DASH_EQ] = ACTIONS(2760),
    [anon_sym_LT_LT_EQ] = ACTIONS(2760),
    [anon_sym_GT_GT_EQ] = ACTIONS(2760),
    [anon_sym_AMP_EQ] = ACTIONS(2760),
    [anon_sym_CARET_EQ] = ACTIONS(2760),
    [anon_sym_PIPE_EQ] = ACTIONS(2760),
    [anon_sym_AMP] = ACTIONS(2762),
    [anon_sym_PIPE_PIPE] = ACTIONS(2760),
    [anon_sym_AMP_AMP] = ACTIONS(2760),
    [anon_sym_PIPE] = ACTIONS(2762),
    [anon_sym_CARET] = ACTIONS(2762),
    [anon_sym_EQ_EQ] = ACTIONS(2760),
    [anon_sym_BANG_EQ] = ACTIONS(2760),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_GT] = ACTIONS(2762),
    [anon_sym_LT_EQ] = ACTIONS(2760),
    [anon_sym_GT_EQ] = ACTIONS(2760),
    [anon_sym_LT_LT] = ACTIONS(2762),
    [anon_sym_GT_GT] = ACTIONS(2762),
    [anon_sym_PLUS] = ACTIONS(2762),
    [anon_sym_DASH] = ACTIONS(2762),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [800] = {
    [anon_sym_LPAREN] = ACTIONS(2790),
    [anon_sym_COMMA] = ACTIONS(2790),
    [anon_sym_RPAREN] = ACTIONS(2790),
    [anon_sym_SEMI] = ACTIONS(2790),
    [anon_sym_RBRACE] = ACTIONS(2790),
    [anon_sym_STAR] = ACTIONS(2792),
    [anon_sym_LBRACK] = ACTIONS(2790),
    [anon_sym_RBRACK] = ACTIONS(2790),
    [anon_sym_EQ] = ACTIONS(2792),
    [anon_sym_COLON] = ACTIONS(2790),
    [anon_sym_QMARK] = ACTIONS(2790),
    [anon_sym_STAR_EQ] = ACTIONS(2790),
    [anon_sym_SLASH_EQ] = ACTIONS(2790),
    [anon_sym_PERCENT_EQ] = ACTIONS(2790),
    [anon_sym_PLUS_EQ] = ACTIONS(2790),
    [anon_sym_DASH_EQ] = ACTIONS(2790),
    [anon_sym_LT_LT_EQ] = ACTIONS(2790),
    [anon_sym_GT_GT_EQ] = ACTIONS(2790),
    [anon_sym_AMP_EQ] = ACTIONS(2790),
    [anon_sym_CARET_EQ] = ACTIONS(2790),
    [anon_sym_PIPE_EQ] = ACTIONS(2790),
    [anon_sym_AMP] = ACTIONS(2792),
    [anon_sym_PIPE_PIPE] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2792),
    [anon_sym_CARET] = ACTIONS(2792),
    [anon_sym_EQ_EQ] = ACTIONS(2790),
    [anon_sym_BANG_EQ] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2792),
    [anon_sym_GT] = ACTIONS(2792),
    [anon_sym_LT_EQ] = ACTIONS(2790),
    [anon_sym_GT_EQ] = ACTIONS(2790),
    [anon_sym_LT_LT] = ACTIONS(2792),
    [anon_sym_GT_GT] = ACTIONS(2792),
    [anon_sym_PLUS] = ACTIONS(2792),
    [anon_sym_DASH] = ACTIONS(2792),
    [anon_sym_SLASH] = ACTIONS(2792),
    [anon_sym_PERCENT] = ACTIONS(2792),
    [anon_sym_DASH_DASH] = ACTIONS(2790),
    [anon_sym_PLUS_PLUS] = ACTIONS(2790),
    [anon_sym_DOT] = ACTIONS(2790),
    [anon_sym_DASH_GT] = ACTIONS(2790),
    [sym_comment] = ACTIONS(42),
  },
  [801] = {
    [sym__expression] = STATE(923),
    [sym_conditional_expression] = STATE(923),
    [sym_assignment_expression] = STATE(923),
    [sym_pointer_expression] = STATE(923),
    [sym_logical_expression] = STATE(923),
    [sym_bitwise_expression] = STATE(923),
    [sym_equality_expression] = STATE(923),
    [sym_relational_expression] = STATE(923),
    [sym_shift_expression] = STATE(923),
    [sym_math_expression] = STATE(923),
    [sym_cast_expression] = STATE(923),
    [sym_sizeof_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_call_expression] = STATE(923),
    [sym_field_expression] = STATE(923),
    [sym_compound_literal_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(923),
    [sym_initializer_list] = STATE(924),
    [sym_concatenated_string] = STATE(923),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(2459),
    [sym_char_literal] = ACTIONS(2459),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(2461),
    [sym_false] = ACTIONS(2461),
    [sym_null] = ACTIONS(2461),
    [sym_identifier] = ACTIONS(2461),
    [sym_comment] = ACTIONS(42),
  },
  [802] = {
    [anon_sym_RBRACE] = ACTIONS(2794),
    [sym_comment] = ACTIONS(42),
  },
  [803] = {
    [anon_sym_LPAREN] = ACTIONS(477),
    [anon_sym_extern] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_RBRACK] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(479),
    [anon_sym_auto] = ACTIONS(479),
    [anon_sym_register] = ACTIONS(479),
    [anon_sym_inline] = ACTIONS(479),
    [anon_sym_const] = ACTIONS(479),
    [anon_sym_restrict] = ACTIONS(479),
    [anon_sym_volatile] = ACTIONS(479),
    [anon_sym__Atomic] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_BANG] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_DASH] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(477),
    [anon_sym_PLUS_PLUS] = ACTIONS(477),
    [anon_sym_sizeof] = ACTIONS(479),
    [sym_number_literal] = ACTIONS(477),
    [sym_char_literal] = ACTIONS(477),
    [sym_string_literal] = ACTIONS(477),
    [sym_true] = ACTIONS(479),
    [sym_false] = ACTIONS(479),
    [sym_null] = ACTIONS(479),
    [sym_identifier] = ACTIONS(479),
    [sym_comment] = ACTIONS(42),
  },
  [804] = {
    [aux_sym_enumerator_list_repeat1] = STATE(1056),
    [anon_sym_COMMA] = ACTIONS(2796),
    [anon_sym_RBRACE] = ACTIONS(2794),
    [sym_comment] = ACTIONS(42),
  },
  [805] = {
    [anon_sym_LPAREN] = ACTIONS(487),
    [anon_sym_extern] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(487),
    [anon_sym_RBRACK] = ACTIONS(487),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_auto] = ACTIONS(489),
    [anon_sym_register] = ACTIONS(489),
    [anon_sym_inline] = ACTIONS(489),
    [anon_sym_const] = ACTIONS(489),
    [anon_sym_restrict] = ACTIONS(489),
    [anon_sym_volatile] = ACTIONS(489),
    [anon_sym__Atomic] = ACTIONS(489),
    [anon_sym_AMP] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_PLUS] = ACTIONS(489),
    [anon_sym_DASH] = ACTIONS(489),
    [anon_sym_DASH_DASH] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_sizeof] = ACTIONS(489),
    [sym_number_literal] = ACTIONS(487),
    [sym_char_literal] = ACTIONS(487),
    [sym_string_literal] = ACTIONS(487),
    [sym_true] = ACTIONS(489),
    [sym_false] = ACTIONS(489),
    [sym_null] = ACTIONS(489),
    [sym_identifier] = ACTIONS(489),
    [sym_comment] = ACTIONS(42),
  },
  [806] = {
    [anon_sym_LPAREN] = ACTIONS(497),
    [anon_sym_extern] = ACTIONS(499),
    [anon_sym_STAR] = ACTIONS(497),
    [anon_sym_RBRACK] = ACTIONS(497),
    [anon_sym_static] = ACTIONS(499),
    [anon_sym_auto] = ACTIONS(499),
    [anon_sym_register] = ACTIONS(499),
    [anon_sym_inline] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(499),
    [anon_sym_restrict] = ACTIONS(499),
    [anon_sym_volatile] = ACTIONS(499),
    [anon_sym__Atomic] = ACTIONS(499),
    [anon_sym_AMP] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(497),
    [anon_sym_TILDE] = ACTIONS(497),
    [anon_sym_PLUS] = ACTIONS(499),
    [anon_sym_DASH] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(497),
    [anon_sym_sizeof] = ACTIONS(499),
    [sym_number_literal] = ACTIONS(497),
    [sym_char_literal] = ACTIONS(497),
    [sym_string_literal] = ACTIONS(497),
    [sym_true] = ACTIONS(499),
    [sym_false] = ACTIONS(499),
    [sym_null] = ACTIONS(499),
    [sym_identifier] = ACTIONS(499),
    [sym_comment] = ACTIONS(42),
  },
  [807] = {
    [sym_preproc_if_in_field_declaration_list] = STATE(122),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(123),
    [sym__declaration_specifiers] = STATE(124),
    [sym_storage_class_specifier] = STATE(126),
    [sym_type_qualifier] = STATE(126),
    [sym__type_specifier] = STATE(125),
    [sym_sized_type_specifier] = STATE(125),
    [sym_enum_specifier] = STATE(125),
    [sym_struct_specifier] = STATE(125),
    [sym_union_specifier] = STATE(125),
    [sym_field_declaration] = STATE(227),
    [sym_macro_type_specifier] = STATE(125),
    [aux_sym__declaration_specifiers_repeat1] = STATE(126),
    [aux_sym_sized_type_specifier_repeat1] = STATE(127),
    [aux_sym_field_declaration_list_repeat1] = STATE(227),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(220),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(222),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(224),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_RBRACE] = ACTIONS(2798),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(228),
    [anon_sym_long] = ACTIONS(228),
    [anon_sym_short] = ACTIONS(228),
    [sym_primitive_type] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [808] = {
    [anon_sym_LPAREN] = ACTIONS(525),
    [anon_sym_extern] = ACTIONS(527),
    [anon_sym_STAR] = ACTIONS(525),
    [anon_sym_RBRACK] = ACTIONS(525),
    [anon_sym_static] = ACTIONS(527),
    [anon_sym_auto] = ACTIONS(527),
    [anon_sym_register] = ACTIONS(527),
    [anon_sym_inline] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(527),
    [anon_sym_restrict] = ACTIONS(527),
    [anon_sym_volatile] = ACTIONS(527),
    [anon_sym__Atomic] = ACTIONS(527),
    [anon_sym_AMP] = ACTIONS(525),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_PLUS] = ACTIONS(527),
    [anon_sym_DASH] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(525),
    [anon_sym_PLUS_PLUS] = ACTIONS(525),
    [anon_sym_sizeof] = ACTIONS(527),
    [sym_number_literal] = ACTIONS(525),
    [sym_char_literal] = ACTIONS(525),
    [sym_string_literal] = ACTIONS(525),
    [sym_true] = ACTIONS(527),
    [sym_false] = ACTIONS(527),
    [sym_null] = ACTIONS(527),
    [sym_identifier] = ACTIONS(527),
    [sym_comment] = ACTIONS(42),
  },
  [809] = {
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_extern] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(529),
    [anon_sym_RBRACK] = ACTIONS(529),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_auto] = ACTIONS(531),
    [anon_sym_register] = ACTIONS(531),
    [anon_sym_inline] = ACTIONS(531),
    [anon_sym_const] = ACTIONS(531),
    [anon_sym_restrict] = ACTIONS(531),
    [anon_sym_volatile] = ACTIONS(531),
    [anon_sym__Atomic] = ACTIONS(531),
    [anon_sym_AMP] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(529),
    [anon_sym_TILDE] = ACTIONS(529),
    [anon_sym_PLUS] = ACTIONS(531),
    [anon_sym_DASH] = ACTIONS(531),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_sizeof] = ACTIONS(531),
    [sym_number_literal] = ACTIONS(529),
    [sym_char_literal] = ACTIONS(529),
    [sym_string_literal] = ACTIONS(529),
    [sym_true] = ACTIONS(531),
    [sym_false] = ACTIONS(531),
    [sym_null] = ACTIONS(531),
    [sym_identifier] = ACTIONS(531),
    [sym_comment] = ACTIONS(42),
  },
  [810] = {
    [anon_sym_RPAREN] = ACTIONS(2800),
    [sym_comment] = ACTIONS(42),
  },
  [811] = {
    [aux_sym_concatenated_string_repeat1] = STATE(811),
    [anon_sym_LPAREN] = ACTIONS(2737),
    [anon_sym_STAR] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2737),
    [anon_sym_RBRACK] = ACTIONS(2737),
    [anon_sym_EQ] = ACTIONS(2739),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2737),
    [anon_sym_SLASH_EQ] = ACTIONS(2737),
    [anon_sym_PERCENT_EQ] = ACTIONS(2737),
    [anon_sym_PLUS_EQ] = ACTIONS(2737),
    [anon_sym_DASH_EQ] = ACTIONS(2737),
    [anon_sym_LT_LT_EQ] = ACTIONS(2737),
    [anon_sym_GT_GT_EQ] = ACTIONS(2737),
    [anon_sym_AMP_EQ] = ACTIONS(2737),
    [anon_sym_CARET_EQ] = ACTIONS(2737),
    [anon_sym_PIPE_EQ] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2739),
    [anon_sym_PIPE_PIPE] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_PIPE] = ACTIONS(2739),
    [anon_sym_CARET] = ACTIONS(2739),
    [anon_sym_EQ_EQ] = ACTIONS(2737),
    [anon_sym_BANG_EQ] = ACTIONS(2737),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_GT] = ACTIONS(2739),
    [anon_sym_LT_EQ] = ACTIONS(2737),
    [anon_sym_GT_EQ] = ACTIONS(2737),
    [anon_sym_LT_LT] = ACTIONS(2739),
    [anon_sym_GT_GT] = ACTIONS(2739),
    [anon_sym_PLUS] = ACTIONS(2739),
    [anon_sym_DASH] = ACTIONS(2739),
    [anon_sym_SLASH] = ACTIONS(2739),
    [anon_sym_PERCENT] = ACTIONS(2739),
    [anon_sym_DASH_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_PLUS] = ACTIONS(2737),
    [anon_sym_DOT] = ACTIONS(2737),
    [anon_sym_DASH_GT] = ACTIONS(2737),
    [sym_string_literal] = ACTIONS(2802),
    [sym_comment] = ACTIONS(42),
  },
  [812] = {
    [anon_sym_RPAREN] = ACTIONS(2805),
    [sym_comment] = ACTIONS(42),
  },
  [813] = {
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_RPAREN] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_EQ] = ACTIONS(2807),
    [sym_comment] = ACTIONS(42),
  },
  [814] = {
    [sym_storage_class_specifier] = STATE(814),
    [sym_type_qualifier] = STATE(814),
    [aux_sym__declaration_specifiers_repeat1] = STATE(814),
    [anon_sym_LPAREN] = ACTIONS(681),
    [anon_sym_extern] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(681),
    [anon_sym_RBRACK] = ACTIONS(681),
    [anon_sym_static] = ACTIONS(2809),
    [anon_sym_auto] = ACTIONS(2809),
    [anon_sym_register] = ACTIONS(2809),
    [anon_sym_inline] = ACTIONS(2809),
    [anon_sym_const] = ACTIONS(2812),
    [anon_sym_restrict] = ACTIONS(2812),
    [anon_sym_volatile] = ACTIONS(2812),
    [anon_sym__Atomic] = ACTIONS(2812),
    [anon_sym_AMP] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(681),
    [anon_sym_TILDE] = ACTIONS(681),
    [anon_sym_PLUS] = ACTIONS(338),
    [anon_sym_DASH] = ACTIONS(338),
    [anon_sym_DASH_DASH] = ACTIONS(681),
    [anon_sym_PLUS_PLUS] = ACTIONS(681),
    [anon_sym_sizeof] = ACTIONS(338),
    [sym_number_literal] = ACTIONS(681),
    [sym_char_literal] = ACTIONS(681),
    [sym_string_literal] = ACTIONS(681),
    [sym_true] = ACTIONS(338),
    [sym_false] = ACTIONS(338),
    [sym_null] = ACTIONS(338),
    [sym_identifier] = ACTIONS(338),
    [sym_comment] = ACTIONS(42),
  },
  [815] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2766),
    [anon_sym_EQ] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_STAR_EQ] = ACTIONS(1239),
    [anon_sym_SLASH_EQ] = ACTIONS(1239),
    [anon_sym_PERCENT_EQ] = ACTIONS(1239),
    [anon_sym_PLUS_EQ] = ACTIONS(1239),
    [anon_sym_DASH_EQ] = ACTIONS(1239),
    [anon_sym_LT_LT_EQ] = ACTIONS(1239),
    [anon_sym_GT_GT_EQ] = ACTIONS(1239),
    [anon_sym_AMP_EQ] = ACTIONS(1239),
    [anon_sym_CARET_EQ] = ACTIONS(1239),
    [anon_sym_PIPE_EQ] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_PIPE_PIPE] = ACTIONS(1243),
    [anon_sym_AMP_AMP] = ACTIONS(1245),
    [anon_sym_PIPE] = ACTIONS(1247),
    [anon_sym_CARET] = ACTIONS(1249),
    [anon_sym_EQ_EQ] = ACTIONS(1251),
    [anon_sym_BANG_EQ] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1253),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [816] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1737),
    [anon_sym_COLON] = ACTIONS(2815),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1743),
    [anon_sym_SLASH_EQ] = ACTIONS(1743),
    [anon_sym_PERCENT_EQ] = ACTIONS(1743),
    [anon_sym_PLUS_EQ] = ACTIONS(1743),
    [anon_sym_DASH_EQ] = ACTIONS(1743),
    [anon_sym_LT_LT_EQ] = ACTIONS(1743),
    [anon_sym_GT_GT_EQ] = ACTIONS(1743),
    [anon_sym_AMP_EQ] = ACTIONS(1743),
    [anon_sym_CARET_EQ] = ACTIONS(1743),
    [anon_sym_PIPE_EQ] = ACTIONS(1743),
    [anon_sym_AMP] = ACTIONS(1745),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_AMP_AMP] = ACTIONS(1749),
    [anon_sym_PIPE] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_GT] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [817] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2770),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_STAR_EQ] = ACTIONS(2770),
    [anon_sym_SLASH_EQ] = ACTIONS(2770),
    [anon_sym_PERCENT_EQ] = ACTIONS(2770),
    [anon_sym_PLUS_EQ] = ACTIONS(2770),
    [anon_sym_DASH_EQ] = ACTIONS(2770),
    [anon_sym_LT_LT_EQ] = ACTIONS(2770),
    [anon_sym_GT_GT_EQ] = ACTIONS(2770),
    [anon_sym_AMP_EQ] = ACTIONS(2770),
    [anon_sym_CARET_EQ] = ACTIONS(2770),
    [anon_sym_PIPE_EQ] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2772),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_PIPE] = ACTIONS(2772),
    [anon_sym_CARET] = ACTIONS(2772),
    [anon_sym_EQ_EQ] = ACTIONS(1251),
    [anon_sym_BANG_EQ] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1253),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [818] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2774),
    [anon_sym_EQ] = ACTIONS(2776),
    [anon_sym_QMARK] = ACTIONS(2774),
    [anon_sym_STAR_EQ] = ACTIONS(2774),
    [anon_sym_SLASH_EQ] = ACTIONS(2774),
    [anon_sym_PERCENT_EQ] = ACTIONS(2774),
    [anon_sym_PLUS_EQ] = ACTIONS(2774),
    [anon_sym_DASH_EQ] = ACTIONS(2774),
    [anon_sym_LT_LT_EQ] = ACTIONS(2774),
    [anon_sym_GT_GT_EQ] = ACTIONS(2774),
    [anon_sym_AMP_EQ] = ACTIONS(2774),
    [anon_sym_CARET_EQ] = ACTIONS(2774),
    [anon_sym_PIPE_EQ] = ACTIONS(2774),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2774),
    [anon_sym_AMP_AMP] = ACTIONS(1245),
    [anon_sym_PIPE] = ACTIONS(1247),
    [anon_sym_CARET] = ACTIONS(1249),
    [anon_sym_EQ_EQ] = ACTIONS(1251),
    [anon_sym_BANG_EQ] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1253),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [819] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2774),
    [anon_sym_EQ] = ACTIONS(2776),
    [anon_sym_QMARK] = ACTIONS(2774),
    [anon_sym_STAR_EQ] = ACTIONS(2774),
    [anon_sym_SLASH_EQ] = ACTIONS(2774),
    [anon_sym_PERCENT_EQ] = ACTIONS(2774),
    [anon_sym_PLUS_EQ] = ACTIONS(2774),
    [anon_sym_DASH_EQ] = ACTIONS(2774),
    [anon_sym_LT_LT_EQ] = ACTIONS(2774),
    [anon_sym_GT_GT_EQ] = ACTIONS(2774),
    [anon_sym_AMP_EQ] = ACTIONS(2774),
    [anon_sym_CARET_EQ] = ACTIONS(2774),
    [anon_sym_PIPE_EQ] = ACTIONS(2774),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2774),
    [anon_sym_AMP_AMP] = ACTIONS(2774),
    [anon_sym_PIPE] = ACTIONS(1247),
    [anon_sym_CARET] = ACTIONS(1249),
    [anon_sym_EQ_EQ] = ACTIONS(1251),
    [anon_sym_BANG_EQ] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1253),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [820] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2770),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_STAR_EQ] = ACTIONS(2770),
    [anon_sym_SLASH_EQ] = ACTIONS(2770),
    [anon_sym_PERCENT_EQ] = ACTIONS(2770),
    [anon_sym_PLUS_EQ] = ACTIONS(2770),
    [anon_sym_DASH_EQ] = ACTIONS(2770),
    [anon_sym_LT_LT_EQ] = ACTIONS(2770),
    [anon_sym_GT_GT_EQ] = ACTIONS(2770),
    [anon_sym_AMP_EQ] = ACTIONS(2770),
    [anon_sym_CARET_EQ] = ACTIONS(2770),
    [anon_sym_PIPE_EQ] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_PIPE] = ACTIONS(2772),
    [anon_sym_CARET] = ACTIONS(1249),
    [anon_sym_EQ_EQ] = ACTIONS(1251),
    [anon_sym_BANG_EQ] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1253),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [821] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2770),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_STAR_EQ] = ACTIONS(2770),
    [anon_sym_SLASH_EQ] = ACTIONS(2770),
    [anon_sym_PERCENT_EQ] = ACTIONS(2770),
    [anon_sym_PLUS_EQ] = ACTIONS(2770),
    [anon_sym_DASH_EQ] = ACTIONS(2770),
    [anon_sym_LT_LT_EQ] = ACTIONS(2770),
    [anon_sym_GT_GT_EQ] = ACTIONS(2770),
    [anon_sym_AMP_EQ] = ACTIONS(2770),
    [anon_sym_CARET_EQ] = ACTIONS(2770),
    [anon_sym_PIPE_EQ] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_PIPE] = ACTIONS(2772),
    [anon_sym_CARET] = ACTIONS(2772),
    [anon_sym_EQ_EQ] = ACTIONS(1251),
    [anon_sym_BANG_EQ] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1253),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [822] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2780),
    [anon_sym_QMARK] = ACTIONS(2778),
    [anon_sym_STAR_EQ] = ACTIONS(2778),
    [anon_sym_SLASH_EQ] = ACTIONS(2778),
    [anon_sym_PERCENT_EQ] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2778),
    [anon_sym_DASH_EQ] = ACTIONS(2778),
    [anon_sym_LT_LT_EQ] = ACTIONS(2778),
    [anon_sym_GT_GT_EQ] = ACTIONS(2778),
    [anon_sym_AMP_EQ] = ACTIONS(2778),
    [anon_sym_CARET_EQ] = ACTIONS(2778),
    [anon_sym_PIPE_EQ] = ACTIONS(2778),
    [anon_sym_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2778),
    [anon_sym_AMP_AMP] = ACTIONS(2778),
    [anon_sym_PIPE] = ACTIONS(2780),
    [anon_sym_CARET] = ACTIONS(2780),
    [anon_sym_EQ_EQ] = ACTIONS(2778),
    [anon_sym_BANG_EQ] = ACTIONS(2778),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1253),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [823] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2782),
    [anon_sym_EQ] = ACTIONS(2784),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_STAR_EQ] = ACTIONS(2782),
    [anon_sym_SLASH_EQ] = ACTIONS(2782),
    [anon_sym_PERCENT_EQ] = ACTIONS(2782),
    [anon_sym_PLUS_EQ] = ACTIONS(2782),
    [anon_sym_DASH_EQ] = ACTIONS(2782),
    [anon_sym_LT_LT_EQ] = ACTIONS(2782),
    [anon_sym_GT_GT_EQ] = ACTIONS(2782),
    [anon_sym_AMP_EQ] = ACTIONS(2782),
    [anon_sym_CARET_EQ] = ACTIONS(2782),
    [anon_sym_PIPE_EQ] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2784),
    [anon_sym_PIPE_PIPE] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2784),
    [anon_sym_CARET] = ACTIONS(2784),
    [anon_sym_EQ_EQ] = ACTIONS(2782),
    [anon_sym_BANG_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2784),
    [anon_sym_GT] = ACTIONS(2784),
    [anon_sym_LT_EQ] = ACTIONS(2782),
    [anon_sym_GT_EQ] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [824] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2786),
    [anon_sym_EQ] = ACTIONS(2788),
    [anon_sym_QMARK] = ACTIONS(2786),
    [anon_sym_STAR_EQ] = ACTIONS(2786),
    [anon_sym_SLASH_EQ] = ACTIONS(2786),
    [anon_sym_PERCENT_EQ] = ACTIONS(2786),
    [anon_sym_PLUS_EQ] = ACTIONS(2786),
    [anon_sym_DASH_EQ] = ACTIONS(2786),
    [anon_sym_LT_LT_EQ] = ACTIONS(2786),
    [anon_sym_GT_GT_EQ] = ACTIONS(2786),
    [anon_sym_AMP_EQ] = ACTIONS(2786),
    [anon_sym_CARET_EQ] = ACTIONS(2786),
    [anon_sym_PIPE_EQ] = ACTIONS(2786),
    [anon_sym_AMP] = ACTIONS(2788),
    [anon_sym_PIPE_PIPE] = ACTIONS(2786),
    [anon_sym_AMP_AMP] = ACTIONS(2786),
    [anon_sym_PIPE] = ACTIONS(2788),
    [anon_sym_CARET] = ACTIONS(2788),
    [anon_sym_EQ_EQ] = ACTIONS(2786),
    [anon_sym_BANG_EQ] = ACTIONS(2786),
    [anon_sym_LT] = ACTIONS(2788),
    [anon_sym_GT] = ACTIONS(2788),
    [anon_sym_LT_EQ] = ACTIONS(2786),
    [anon_sym_GT_EQ] = ACTIONS(2786),
    [anon_sym_LT_LT] = ACTIONS(2788),
    [anon_sym_GT_GT] = ACTIONS(2788),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [825] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2760),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_QMARK] = ACTIONS(2760),
    [anon_sym_STAR_EQ] = ACTIONS(2760),
    [anon_sym_SLASH_EQ] = ACTIONS(2760),
    [anon_sym_PERCENT_EQ] = ACTIONS(2760),
    [anon_sym_PLUS_EQ] = ACTIONS(2760),
    [anon_sym_DASH_EQ] = ACTIONS(2760),
    [anon_sym_LT_LT_EQ] = ACTIONS(2760),
    [anon_sym_GT_GT_EQ] = ACTIONS(2760),
    [anon_sym_AMP_EQ] = ACTIONS(2760),
    [anon_sym_CARET_EQ] = ACTIONS(2760),
    [anon_sym_PIPE_EQ] = ACTIONS(2760),
    [anon_sym_AMP] = ACTIONS(2762),
    [anon_sym_PIPE_PIPE] = ACTIONS(2760),
    [anon_sym_AMP_AMP] = ACTIONS(2760),
    [anon_sym_PIPE] = ACTIONS(2762),
    [anon_sym_CARET] = ACTIONS(2762),
    [anon_sym_EQ_EQ] = ACTIONS(2760),
    [anon_sym_BANG_EQ] = ACTIONS(2760),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_GT] = ACTIONS(2762),
    [anon_sym_LT_EQ] = ACTIONS(2760),
    [anon_sym_GT_EQ] = ACTIONS(2760),
    [anon_sym_LT_LT] = ACTIONS(2762),
    [anon_sym_GT_GT] = ACTIONS(2762),
    [anon_sym_PLUS] = ACTIONS(2762),
    [anon_sym_DASH] = ACTIONS(2762),
    [anon_sym_SLASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [826] = {
    [sym_storage_class_specifier] = STATE(814),
    [sym_type_qualifier] = STATE(814),
    [aux_sym__declaration_specifiers_repeat1] = STATE(814),
    [anon_sym_LPAREN] = ACTIONS(689),
    [anon_sym_extern] = ACTIONS(1229),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_RBRACK] = ACTIONS(689),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_auto] = ACTIONS(1229),
    [anon_sym_register] = ACTIONS(1229),
    [anon_sym_inline] = ACTIONS(1229),
    [anon_sym_const] = ACTIONS(1231),
    [anon_sym_restrict] = ACTIONS(1231),
    [anon_sym_volatile] = ACTIONS(1231),
    [anon_sym__Atomic] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(689),
    [anon_sym_BANG] = ACTIONS(689),
    [anon_sym_TILDE] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(691),
    [anon_sym_DASH] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_sizeof] = ACTIONS(691),
    [sym_number_literal] = ACTIONS(689),
    [sym_char_literal] = ACTIONS(689),
    [sym_string_literal] = ACTIONS(689),
    [sym_true] = ACTIONS(691),
    [sym_false] = ACTIONS(691),
    [sym_null] = ACTIONS(691),
    [sym_identifier] = ACTIONS(691),
    [sym_comment] = ACTIONS(42),
  },
  [827] = {
    [anon_sym_LPAREN] = ACTIONS(2817),
    [anon_sym_COMMA] = ACTIONS(2817),
    [anon_sym_RPAREN] = ACTIONS(2817),
    [anon_sym_SEMI] = ACTIONS(2817),
    [anon_sym_RBRACE] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2817),
    [anon_sym_RBRACK] = ACTIONS(2817),
    [anon_sym_EQ] = ACTIONS(2819),
    [anon_sym_COLON] = ACTIONS(2817),
    [anon_sym_QMARK] = ACTIONS(2817),
    [anon_sym_STAR_EQ] = ACTIONS(2817),
    [anon_sym_SLASH_EQ] = ACTIONS(2817),
    [anon_sym_PERCENT_EQ] = ACTIONS(2817),
    [anon_sym_PLUS_EQ] = ACTIONS(2817),
    [anon_sym_DASH_EQ] = ACTIONS(2817),
    [anon_sym_LT_LT_EQ] = ACTIONS(2817),
    [anon_sym_GT_GT_EQ] = ACTIONS(2817),
    [anon_sym_AMP_EQ] = ACTIONS(2817),
    [anon_sym_CARET_EQ] = ACTIONS(2817),
    [anon_sym_PIPE_EQ] = ACTIONS(2817),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_PIPE_PIPE] = ACTIONS(2817),
    [anon_sym_AMP_AMP] = ACTIONS(2817),
    [anon_sym_PIPE] = ACTIONS(2819),
    [anon_sym_CARET] = ACTIONS(2819),
    [anon_sym_EQ_EQ] = ACTIONS(2817),
    [anon_sym_BANG_EQ] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(2819),
    [anon_sym_GT] = ACTIONS(2819),
    [anon_sym_LT_EQ] = ACTIONS(2817),
    [anon_sym_GT_EQ] = ACTIONS(2817),
    [anon_sym_LT_LT] = ACTIONS(2819),
    [anon_sym_GT_GT] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_DASH_DASH] = ACTIONS(2817),
    [anon_sym_PLUS_PLUS] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(2817),
    [anon_sym_DASH_GT] = ACTIONS(2817),
    [sym_comment] = ACTIONS(42),
  },
  [828] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2821),
    [anon_sym_EQ] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1237),
    [anon_sym_STAR_EQ] = ACTIONS(1239),
    [anon_sym_SLASH_EQ] = ACTIONS(1239),
    [anon_sym_PERCENT_EQ] = ACTIONS(1239),
    [anon_sym_PLUS_EQ] = ACTIONS(1239),
    [anon_sym_DASH_EQ] = ACTIONS(1239),
    [anon_sym_LT_LT_EQ] = ACTIONS(1239),
    [anon_sym_GT_GT_EQ] = ACTIONS(1239),
    [anon_sym_AMP_EQ] = ACTIONS(1239),
    [anon_sym_CARET_EQ] = ACTIONS(1239),
    [anon_sym_PIPE_EQ] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_PIPE_PIPE] = ACTIONS(1243),
    [anon_sym_AMP_AMP] = ACTIONS(1245),
    [anon_sym_PIPE] = ACTIONS(1247),
    [anon_sym_CARET] = ACTIONS(1249),
    [anon_sym_EQ_EQ] = ACTIONS(1251),
    [anon_sym_BANG_EQ] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1253),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [829] = {
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_EQ] = ACTIONS(2823),
    [anon_sym_DOT] = ACTIONS(2823),
    [sym_comment] = ACTIONS(42),
  },
  [830] = {
    [sym__expression] = STATE(1063),
    [sym_conditional_expression] = STATE(1063),
    [sym_assignment_expression] = STATE(1063),
    [sym_pointer_expression] = STATE(1063),
    [sym_logical_expression] = STATE(1063),
    [sym_bitwise_expression] = STATE(1063),
    [sym_equality_expression] = STATE(1063),
    [sym_relational_expression] = STATE(1063),
    [sym_shift_expression] = STATE(1063),
    [sym_math_expression] = STATE(1063),
    [sym_cast_expression] = STATE(1063),
    [sym_sizeof_expression] = STATE(1063),
    [sym_subscript_expression] = STATE(1063),
    [sym_call_expression] = STATE(1063),
    [sym_field_expression] = STATE(1063),
    [sym_compound_literal_expression] = STATE(1063),
    [sym_parenthesized_expression] = STATE(1063),
    [sym_initializer_list] = STATE(1064),
    [sym_initializer_pair] = STATE(1064),
    [sym_subscript_designator] = STATE(547),
    [sym_field_designator] = STATE(547),
    [sym_concatenated_string] = STATE(1063),
    [aux_sym_initializer_pair_repeat1] = STATE(547),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(2825),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_LBRACK] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [anon_sym_DOT] = ACTIONS(1278),
    [sym_number_literal] = ACTIONS(2827),
    [sym_char_literal] = ACTIONS(2827),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(2829),
    [sym_false] = ACTIONS(2829),
    [sym_null] = ACTIONS(2829),
    [sym_identifier] = ACTIONS(2829),
    [sym_comment] = ACTIONS(42),
  },
  [831] = {
    [aux_sym_initializer_list_repeat1] = STATE(1066),
    [anon_sym_COMMA] = ACTIONS(2831),
    [anon_sym_RBRACE] = ACTIONS(2825),
    [sym_comment] = ACTIONS(42),
  },
  [832] = {
    [sym__expression] = STATE(1067),
    [sym_conditional_expression] = STATE(1067),
    [sym_assignment_expression] = STATE(1067),
    [sym_pointer_expression] = STATE(1067),
    [sym_logical_expression] = STATE(1067),
    [sym_bitwise_expression] = STATE(1067),
    [sym_equality_expression] = STATE(1067),
    [sym_relational_expression] = STATE(1067),
    [sym_shift_expression] = STATE(1067),
    [sym_math_expression] = STATE(1067),
    [sym_cast_expression] = STATE(1067),
    [sym_sizeof_expression] = STATE(1067),
    [sym_subscript_expression] = STATE(1067),
    [sym_call_expression] = STATE(1067),
    [sym_field_expression] = STATE(1067),
    [sym_compound_literal_expression] = STATE(1067),
    [sym_parenthesized_expression] = STATE(1067),
    [sym_initializer_list] = STATE(1068),
    [sym_concatenated_string] = STATE(1067),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [sym_number_literal] = ACTIONS(2833),
    [sym_char_literal] = ACTIONS(2833),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(2835),
    [sym_false] = ACTIONS(2835),
    [sym_null] = ACTIONS(2835),
    [sym_identifier] = ACTIONS(2835),
    [sym_comment] = ACTIONS(42),
  },
  [833] = {
    [sym_subscript_designator] = STATE(833),
    [sym_field_designator] = STATE(833),
    [aux_sym_initializer_pair_repeat1] = STATE(833),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_EQ] = ACTIONS(2840),
    [anon_sym_DOT] = ACTIONS(2842),
    [sym_comment] = ACTIONS(42),
  },
  [834] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1295),
    [sym_preproc_directive] = ACTIONS(1295),
    [anon_sym_typedef] = ACTIONS(1295),
    [anon_sym_extern] = ACTIONS(1295),
    [anon_sym_static] = ACTIONS(1295),
    [anon_sym_auto] = ACTIONS(1295),
    [anon_sym_register] = ACTIONS(1295),
    [anon_sym_inline] = ACTIONS(1295),
    [anon_sym_const] = ACTIONS(1295),
    [anon_sym_restrict] = ACTIONS(1295),
    [anon_sym_volatile] = ACTIONS(1295),
    [anon_sym__Atomic] = ACTIONS(1295),
    [anon_sym_unsigned] = ACTIONS(1295),
    [anon_sym_long] = ACTIONS(1295),
    [anon_sym_short] = ACTIONS(1295),
    [sym_primitive_type] = ACTIONS(1295),
    [anon_sym_enum] = ACTIONS(1295),
    [anon_sym_struct] = ACTIONS(1295),
    [anon_sym_union] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_comment] = ACTIONS(42),
  },
  [835] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1305),
    [sym_preproc_directive] = ACTIONS(1305),
    [anon_sym_typedef] = ACTIONS(1305),
    [anon_sym_extern] = ACTIONS(1305),
    [anon_sym_static] = ACTIONS(1305),
    [anon_sym_auto] = ACTIONS(1305),
    [anon_sym_register] = ACTIONS(1305),
    [anon_sym_inline] = ACTIONS(1305),
    [anon_sym_const] = ACTIONS(1305),
    [anon_sym_restrict] = ACTIONS(1305),
    [anon_sym_volatile] = ACTIONS(1305),
    [anon_sym__Atomic] = ACTIONS(1305),
    [anon_sym_unsigned] = ACTIONS(1305),
    [anon_sym_long] = ACTIONS(1305),
    [anon_sym_short] = ACTIONS(1305),
    [sym_primitive_type] = ACTIONS(1305),
    [anon_sym_enum] = ACTIONS(1305),
    [anon_sym_struct] = ACTIONS(1305),
    [anon_sym_union] = ACTIONS(1305),
    [sym_identifier] = ACTIONS(1305),
    [sym_comment] = ACTIONS(42),
  },
  [836] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1385),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1385),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1385),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1385),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1385),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1385),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1385),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1385),
    [sym_preproc_directive] = ACTIONS(1385),
    [anon_sym_typedef] = ACTIONS(1385),
    [anon_sym_extern] = ACTIONS(1385),
    [anon_sym_static] = ACTIONS(1385),
    [anon_sym_auto] = ACTIONS(1385),
    [anon_sym_register] = ACTIONS(1385),
    [anon_sym_inline] = ACTIONS(1385),
    [anon_sym_const] = ACTIONS(1385),
    [anon_sym_restrict] = ACTIONS(1385),
    [anon_sym_volatile] = ACTIONS(1385),
    [anon_sym__Atomic] = ACTIONS(1385),
    [anon_sym_unsigned] = ACTIONS(1385),
    [anon_sym_long] = ACTIONS(1385),
    [anon_sym_short] = ACTIONS(1385),
    [sym_primitive_type] = ACTIONS(1385),
    [anon_sym_enum] = ACTIONS(1385),
    [anon_sym_struct] = ACTIONS(1385),
    [anon_sym_union] = ACTIONS(1385),
    [sym_identifier] = ACTIONS(1385),
    [sym_comment] = ACTIONS(42),
  },
  [837] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1389),
    [sym_preproc_directive] = ACTIONS(1389),
    [anon_sym_typedef] = ACTIONS(1389),
    [anon_sym_extern] = ACTIONS(1389),
    [anon_sym_static] = ACTIONS(1389),
    [anon_sym_auto] = ACTIONS(1389),
    [anon_sym_register] = ACTIONS(1389),
    [anon_sym_inline] = ACTIONS(1389),
    [anon_sym_const] = ACTIONS(1389),
    [anon_sym_restrict] = ACTIONS(1389),
    [anon_sym_volatile] = ACTIONS(1389),
    [anon_sym__Atomic] = ACTIONS(1389),
    [anon_sym_unsigned] = ACTIONS(1389),
    [anon_sym_long] = ACTIONS(1389),
    [anon_sym_short] = ACTIONS(1389),
    [sym_primitive_type] = ACTIONS(1389),
    [anon_sym_enum] = ACTIONS(1389),
    [anon_sym_struct] = ACTIONS(1389),
    [anon_sym_union] = ACTIONS(1389),
    [sym_identifier] = ACTIONS(1389),
    [sym_comment] = ACTIONS(42),
  },
  [838] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1393),
    [sym_preproc_directive] = ACTIONS(1393),
    [anon_sym_typedef] = ACTIONS(1393),
    [anon_sym_extern] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1393),
    [anon_sym_auto] = ACTIONS(1393),
    [anon_sym_register] = ACTIONS(1393),
    [anon_sym_inline] = ACTIONS(1393),
    [anon_sym_const] = ACTIONS(1393),
    [anon_sym_restrict] = ACTIONS(1393),
    [anon_sym_volatile] = ACTIONS(1393),
    [anon_sym__Atomic] = ACTIONS(1393),
    [anon_sym_unsigned] = ACTIONS(1393),
    [anon_sym_long] = ACTIONS(1393),
    [anon_sym_short] = ACTIONS(1393),
    [sym_primitive_type] = ACTIONS(1393),
    [anon_sym_enum] = ACTIONS(1393),
    [anon_sym_struct] = ACTIONS(1393),
    [anon_sym_union] = ACTIONS(1393),
    [sym_identifier] = ACTIONS(1393),
    [sym_comment] = ACTIONS(42),
  },
  [839] = {
    [anon_sym_LF] = ACTIONS(2845),
    [sym_comment] = ACTIONS(50),
  },
  [840] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(703),
    [sym_preproc_directive] = ACTIONS(703),
    [anon_sym_typedef] = ACTIONS(703),
    [anon_sym_extern] = ACTIONS(703),
    [anon_sym_static] = ACTIONS(703),
    [anon_sym_auto] = ACTIONS(703),
    [anon_sym_register] = ACTIONS(703),
    [anon_sym_inline] = ACTIONS(703),
    [anon_sym_const] = ACTIONS(703),
    [anon_sym_restrict] = ACTIONS(703),
    [anon_sym_volatile] = ACTIONS(703),
    [anon_sym__Atomic] = ACTIONS(703),
    [anon_sym_unsigned] = ACTIONS(703),
    [anon_sym_long] = ACTIONS(703),
    [anon_sym_short] = ACTIONS(703),
    [sym_primitive_type] = ACTIONS(703),
    [anon_sym_enum] = ACTIONS(703),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_union] = ACTIONS(703),
    [sym_identifier] = ACTIONS(703),
    [sym_comment] = ACTIONS(42),
  },
  [841] = {
    [anon_sym_LF] = ACTIONS(2847),
    [sym_comment] = ACTIONS(50),
  },
  [842] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(751),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(751),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(751),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(751),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(751),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(751),
    [sym_preproc_directive] = ACTIONS(751),
    [anon_sym_typedef] = ACTIONS(751),
    [anon_sym_extern] = ACTIONS(751),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_auto] = ACTIONS(751),
    [anon_sym_register] = ACTIONS(751),
    [anon_sym_inline] = ACTIONS(751),
    [anon_sym_const] = ACTIONS(751),
    [anon_sym_restrict] = ACTIONS(751),
    [anon_sym_volatile] = ACTIONS(751),
    [anon_sym__Atomic] = ACTIONS(751),
    [anon_sym_unsigned] = ACTIONS(751),
    [anon_sym_long] = ACTIONS(751),
    [anon_sym_short] = ACTIONS(751),
    [sym_primitive_type] = ACTIONS(751),
    [anon_sym_enum] = ACTIONS(751),
    [anon_sym_struct] = ACTIONS(751),
    [anon_sym_union] = ACTIONS(751),
    [sym_identifier] = ACTIONS(751),
    [sym_comment] = ACTIONS(42),
  },
  [843] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2849),
    [sym_comment] = ACTIONS(42),
  },
  [844] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(787),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(787),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(787),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(787),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(787),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(787),
    [sym_preproc_directive] = ACTIONS(787),
    [anon_sym_typedef] = ACTIONS(787),
    [anon_sym_extern] = ACTIONS(787),
    [anon_sym_static] = ACTIONS(787),
    [anon_sym_auto] = ACTIONS(787),
    [anon_sym_register] = ACTIONS(787),
    [anon_sym_inline] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(787),
    [anon_sym_restrict] = ACTIONS(787),
    [anon_sym_volatile] = ACTIONS(787),
    [anon_sym__Atomic] = ACTIONS(787),
    [anon_sym_unsigned] = ACTIONS(787),
    [anon_sym_long] = ACTIONS(787),
    [anon_sym_short] = ACTIONS(787),
    [sym_primitive_type] = ACTIONS(787),
    [anon_sym_enum] = ACTIONS(787),
    [anon_sym_struct] = ACTIONS(787),
    [anon_sym_union] = ACTIONS(787),
    [sym_identifier] = ACTIONS(787),
    [sym_comment] = ACTIONS(42),
  },
  [845] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2851),
    [sym_comment] = ACTIONS(42),
  },
  [846] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(793),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(793),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(793),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(793),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(793),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(793),
    [sym_preproc_directive] = ACTIONS(793),
    [anon_sym_typedef] = ACTIONS(793),
    [anon_sym_extern] = ACTIONS(793),
    [anon_sym_static] = ACTIONS(793),
    [anon_sym_auto] = ACTIONS(793),
    [anon_sym_register] = ACTIONS(793),
    [anon_sym_inline] = ACTIONS(793),
    [anon_sym_const] = ACTIONS(793),
    [anon_sym_restrict] = ACTIONS(793),
    [anon_sym_volatile] = ACTIONS(793),
    [anon_sym__Atomic] = ACTIONS(793),
    [anon_sym_unsigned] = ACTIONS(793),
    [anon_sym_long] = ACTIONS(793),
    [anon_sym_short] = ACTIONS(793),
    [sym_primitive_type] = ACTIONS(793),
    [anon_sym_enum] = ACTIONS(793),
    [anon_sym_struct] = ACTIONS(793),
    [anon_sym_union] = ACTIONS(793),
    [sym_identifier] = ACTIONS(793),
    [sym_comment] = ACTIONS(42),
  },
  [847] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2853),
    [sym_comment] = ACTIONS(42),
  },
  [848] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(799),
    [sym_preproc_directive] = ACTIONS(799),
    [anon_sym_typedef] = ACTIONS(799),
    [anon_sym_extern] = ACTIONS(799),
    [anon_sym_static] = ACTIONS(799),
    [anon_sym_auto] = ACTIONS(799),
    [anon_sym_register] = ACTIONS(799),
    [anon_sym_inline] = ACTIONS(799),
    [anon_sym_const] = ACTIONS(799),
    [anon_sym_restrict] = ACTIONS(799),
    [anon_sym_volatile] = ACTIONS(799),
    [anon_sym__Atomic] = ACTIONS(799),
    [anon_sym_unsigned] = ACTIONS(799),
    [anon_sym_long] = ACTIONS(799),
    [anon_sym_short] = ACTIONS(799),
    [sym_primitive_type] = ACTIONS(799),
    [anon_sym_enum] = ACTIONS(799),
    [anon_sym_struct] = ACTIONS(799),
    [anon_sym_union] = ACTIONS(799),
    [sym_identifier] = ACTIONS(799),
    [sym_comment] = ACTIONS(42),
  },
  [849] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(815),
    [sym_preproc_directive] = ACTIONS(815),
    [anon_sym_typedef] = ACTIONS(815),
    [anon_sym_extern] = ACTIONS(815),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_auto] = ACTIONS(815),
    [anon_sym_register] = ACTIONS(815),
    [anon_sym_inline] = ACTIONS(815),
    [anon_sym_const] = ACTIONS(815),
    [anon_sym_restrict] = ACTIONS(815),
    [anon_sym_volatile] = ACTIONS(815),
    [anon_sym__Atomic] = ACTIONS(815),
    [anon_sym_unsigned] = ACTIONS(815),
    [anon_sym_long] = ACTIONS(815),
    [anon_sym_short] = ACTIONS(815),
    [sym_primitive_type] = ACTIONS(815),
    [anon_sym_enum] = ACTIONS(815),
    [anon_sym_struct] = ACTIONS(815),
    [anon_sym_union] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_comment] = ACTIONS(42),
  },
  [850] = {
    [sym_parameter_list] = STATE(200),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_SEMI] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(449),
    [sym_comment] = ACTIONS(42),
  },
  [851] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(829),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(829),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(829),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(829),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(829),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(829),
    [sym_preproc_directive] = ACTIONS(829),
    [anon_sym_typedef] = ACTIONS(829),
    [anon_sym_extern] = ACTIONS(829),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_auto] = ACTIONS(829),
    [anon_sym_register] = ACTIONS(829),
    [anon_sym_inline] = ACTIONS(829),
    [anon_sym_const] = ACTIONS(829),
    [anon_sym_restrict] = ACTIONS(829),
    [anon_sym_volatile] = ACTIONS(829),
    [anon_sym__Atomic] = ACTIONS(829),
    [anon_sym_unsigned] = ACTIONS(829),
    [anon_sym_long] = ACTIONS(829),
    [anon_sym_short] = ACTIONS(829),
    [sym_primitive_type] = ACTIONS(829),
    [anon_sym_enum] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_union] = ACTIONS(829),
    [sym_identifier] = ACTIONS(829),
    [sym_comment] = ACTIONS(42),
  },
  [852] = {
    [sym_preproc_include] = STATE(360),
    [sym_preproc_def] = STATE(360),
    [sym_preproc_function_def] = STATE(360),
    [sym_preproc_call] = STATE(360),
    [sym_preproc_if] = STATE(360),
    [sym_preproc_ifdef] = STATE(360),
    [sym_function_definition] = STATE(360),
    [sym_declaration] = STATE(360),
    [sym_type_definition] = STATE(360),
    [sym__declaration_specifiers] = STATE(17),
    [sym_linkage_specification] = STATE(360),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym__empty_declaration] = STATE(360),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_translation_unit_repeat1] = STATE(360),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(10),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(12),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(14),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(16),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(18),
    [sym_preproc_directive] = ACTIONS(20),
    [anon_sym_typedef] = ACTIONS(22),
    [anon_sym_extern] = ACTIONS(24),
    [anon_sym_RBRACE] = ACTIONS(2857),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [853] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1047),
    [sym_preproc_directive] = ACTIONS(1047),
    [anon_sym_typedef] = ACTIONS(1047),
    [anon_sym_extern] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_auto] = ACTIONS(1047),
    [anon_sym_register] = ACTIONS(1047),
    [anon_sym_inline] = ACTIONS(1047),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_restrict] = ACTIONS(1047),
    [anon_sym_volatile] = ACTIONS(1047),
    [anon_sym__Atomic] = ACTIONS(1047),
    [anon_sym_unsigned] = ACTIONS(1047),
    [anon_sym_long] = ACTIONS(1047),
    [anon_sym_short] = ACTIONS(1047),
    [sym_primitive_type] = ACTIONS(1047),
    [anon_sym_enum] = ACTIONS(1047),
    [anon_sym_struct] = ACTIONS(1047),
    [anon_sym_union] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [sym_comment] = ACTIONS(42),
  },
  [854] = {
    [sym_preproc_include] = STATE(505),
    [sym_preproc_def] = STATE(505),
    [sym_preproc_function_def] = STATE(505),
    [sym_preproc_call] = STATE(505),
    [sym_preproc_if_in_compound_statement] = STATE(275),
    [sym_preproc_ifdef_in_compound_statement] = STATE(276),
    [sym_declaration] = STATE(505),
    [sym_type_definition] = STATE(505),
    [sym__declaration_specifiers] = STATE(277),
    [sym_compound_statement] = STATE(505),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(505),
    [sym_expression_statement] = STATE(505),
    [sym_if_statement] = STATE(505),
    [sym_switch_statement] = STATE(505),
    [sym_case_statement] = STATE(505),
    [sym_while_statement] = STATE(505),
    [sym_do_statement] = STATE(505),
    [sym_for_statement] = STATE(505),
    [sym_return_statement] = STATE(505),
    [sym_break_statement] = STATE(505),
    [sym_continue_statement] = STATE(505),
    [sym_goto_statement] = STATE(505),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [sym__empty_declaration] = STATE(505),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(505),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(577),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(579),
    [sym_preproc_directive] = ACTIONS(581),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_typedef] = ACTIONS(585),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_RBRACE] = ACTIONS(2859),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(631),
    [sym_comment] = ACTIONS(42),
  },
  [855] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1288),
    [sym_preproc_directive] = ACTIONS(1288),
    [anon_sym_typedef] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1288),
    [anon_sym_static] = ACTIONS(1288),
    [anon_sym_auto] = ACTIONS(1288),
    [anon_sym_register] = ACTIONS(1288),
    [anon_sym_inline] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_restrict] = ACTIONS(1288),
    [anon_sym_volatile] = ACTIONS(1288),
    [anon_sym__Atomic] = ACTIONS(1288),
    [anon_sym_unsigned] = ACTIONS(1288),
    [anon_sym_long] = ACTIONS(1288),
    [anon_sym_short] = ACTIONS(1288),
    [sym_primitive_type] = ACTIONS(1288),
    [anon_sym_enum] = ACTIONS(1288),
    [anon_sym_struct] = ACTIONS(1288),
    [anon_sym_union] = ACTIONS(1288),
    [sym_identifier] = ACTIONS(1288),
    [sym_comment] = ACTIONS(42),
  },
  [856] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1411),
    [sym_preproc_directive] = ACTIONS(1411),
    [anon_sym_typedef] = ACTIONS(1411),
    [anon_sym_extern] = ACTIONS(1411),
    [anon_sym_static] = ACTIONS(1411),
    [anon_sym_auto] = ACTIONS(1411),
    [anon_sym_register] = ACTIONS(1411),
    [anon_sym_inline] = ACTIONS(1411),
    [anon_sym_const] = ACTIONS(1411),
    [anon_sym_restrict] = ACTIONS(1411),
    [anon_sym_volatile] = ACTIONS(1411),
    [anon_sym__Atomic] = ACTIONS(1411),
    [anon_sym_unsigned] = ACTIONS(1411),
    [anon_sym_long] = ACTIONS(1411),
    [anon_sym_short] = ACTIONS(1411),
    [sym_primitive_type] = ACTIONS(1411),
    [anon_sym_enum] = ACTIONS(1411),
    [anon_sym_struct] = ACTIONS(1411),
    [anon_sym_union] = ACTIONS(1411),
    [sym_identifier] = ACTIONS(1411),
    [sym_comment] = ACTIONS(42),
  },
  [857] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1415),
    [sym_preproc_directive] = ACTIONS(1415),
    [anon_sym_typedef] = ACTIONS(1415),
    [anon_sym_extern] = ACTIONS(1415),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_auto] = ACTIONS(1415),
    [anon_sym_register] = ACTIONS(1415),
    [anon_sym_inline] = ACTIONS(1415),
    [anon_sym_const] = ACTIONS(1415),
    [anon_sym_restrict] = ACTIONS(1415),
    [anon_sym_volatile] = ACTIONS(1415),
    [anon_sym__Atomic] = ACTIONS(1415),
    [anon_sym_unsigned] = ACTIONS(1415),
    [anon_sym_long] = ACTIONS(1415),
    [anon_sym_short] = ACTIONS(1415),
    [sym_primitive_type] = ACTIONS(1415),
    [anon_sym_enum] = ACTIONS(1415),
    [anon_sym_struct] = ACTIONS(1415),
    [anon_sym_union] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_comment] = ACTIONS(42),
  },
  [858] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_auto] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(42),
  },
  [859] = {
    [anon_sym_LPAREN] = ACTIONS(2218),
    [anon_sym_STAR] = ACTIONS(2218),
    [sym_identifier] = ACTIONS(2218),
    [sym_comment] = ACTIONS(42),
  },
  [860] = {
    [anon_sym_LPAREN] = ACTIONS(2861),
    [anon_sym_RPAREN] = ACTIONS(2861),
    [anon_sym_SEMI] = ACTIONS(2861),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [sym_comment] = ACTIONS(42),
  },
  [861] = {
    [sym__expression] = STATE(923),
    [sym_conditional_expression] = STATE(923),
    [sym_assignment_expression] = STATE(923),
    [sym_pointer_expression] = STATE(923),
    [sym_logical_expression] = STATE(923),
    [sym_bitwise_expression] = STATE(923),
    [sym_equality_expression] = STATE(923),
    [sym_relational_expression] = STATE(923),
    [sym_shift_expression] = STATE(923),
    [sym_math_expression] = STATE(923),
    [sym_cast_expression] = STATE(923),
    [sym_sizeof_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_call_expression] = STATE(923),
    [sym_field_expression] = STATE(923),
    [sym_compound_literal_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(923),
    [sym_initializer_list] = STATE(924),
    [sym_concatenated_string] = STATE(923),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [sym_number_literal] = ACTIONS(2459),
    [sym_char_literal] = ACTIONS(2459),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(2461),
    [sym_false] = ACTIONS(2461),
    [sym_null] = ACTIONS(2461),
    [sym_identifier] = ACTIONS(2461),
    [sym_comment] = ACTIONS(42),
  },
  [862] = {
    [anon_sym_RPAREN] = ACTIONS(2863),
    [sym_comment] = ACTIONS(42),
  },
  [863] = {
    [aux_sym_concatenated_string_repeat1] = STATE(863),
    [anon_sym_LPAREN] = ACTIONS(2737),
    [anon_sym_COMMA] = ACTIONS(2737),
    [anon_sym_RBRACE] = ACTIONS(2737),
    [anon_sym_STAR] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2737),
    [anon_sym_EQ] = ACTIONS(2739),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2737),
    [anon_sym_SLASH_EQ] = ACTIONS(2737),
    [anon_sym_PERCENT_EQ] = ACTIONS(2737),
    [anon_sym_PLUS_EQ] = ACTIONS(2737),
    [anon_sym_DASH_EQ] = ACTIONS(2737),
    [anon_sym_LT_LT_EQ] = ACTIONS(2737),
    [anon_sym_GT_GT_EQ] = ACTIONS(2737),
    [anon_sym_AMP_EQ] = ACTIONS(2737),
    [anon_sym_CARET_EQ] = ACTIONS(2737),
    [anon_sym_PIPE_EQ] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2739),
    [anon_sym_PIPE_PIPE] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_PIPE] = ACTIONS(2739),
    [anon_sym_CARET] = ACTIONS(2739),
    [anon_sym_EQ_EQ] = ACTIONS(2737),
    [anon_sym_BANG_EQ] = ACTIONS(2737),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_GT] = ACTIONS(2739),
    [anon_sym_LT_EQ] = ACTIONS(2737),
    [anon_sym_GT_EQ] = ACTIONS(2737),
    [anon_sym_LT_LT] = ACTIONS(2739),
    [anon_sym_GT_GT] = ACTIONS(2739),
    [anon_sym_PLUS] = ACTIONS(2739),
    [anon_sym_DASH] = ACTIONS(2739),
    [anon_sym_SLASH] = ACTIONS(2739),
    [anon_sym_PERCENT] = ACTIONS(2739),
    [anon_sym_DASH_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_PLUS] = ACTIONS(2737),
    [anon_sym_DOT] = ACTIONS(2737),
    [anon_sym_DASH_GT] = ACTIONS(2737),
    [sym_string_literal] = ACTIONS(2865),
    [sym_comment] = ACTIONS(42),
  },
  [864] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2766),
    [anon_sym_RBRACE] = ACTIONS(2766),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1429),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_STAR_EQ] = ACTIONS(1433),
    [anon_sym_SLASH_EQ] = ACTIONS(1433),
    [anon_sym_PERCENT_EQ] = ACTIONS(1433),
    [anon_sym_PLUS_EQ] = ACTIONS(1433),
    [anon_sym_DASH_EQ] = ACTIONS(1433),
    [anon_sym_LT_LT_EQ] = ACTIONS(1433),
    [anon_sym_GT_GT_EQ] = ACTIONS(1433),
    [anon_sym_AMP_EQ] = ACTIONS(1433),
    [anon_sym_CARET_EQ] = ACTIONS(1433),
    [anon_sym_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_PIPE] = ACTIONS(1441),
    [anon_sym_CARET] = ACTIONS(1443),
    [anon_sym_EQ_EQ] = ACTIONS(1445),
    [anon_sym_BANG_EQ] = ACTIONS(1445),
    [anon_sym_LT] = ACTIONS(1447),
    [anon_sym_GT] = ACTIONS(1447),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1451),
    [anon_sym_GT_GT] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_SLASH] = ACTIONS(1427),
    [anon_sym_PERCENT] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [865] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1737),
    [anon_sym_COLON] = ACTIONS(2868),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1743),
    [anon_sym_SLASH_EQ] = ACTIONS(1743),
    [anon_sym_PERCENT_EQ] = ACTIONS(1743),
    [anon_sym_PLUS_EQ] = ACTIONS(1743),
    [anon_sym_DASH_EQ] = ACTIONS(1743),
    [anon_sym_LT_LT_EQ] = ACTIONS(1743),
    [anon_sym_GT_GT_EQ] = ACTIONS(1743),
    [anon_sym_AMP_EQ] = ACTIONS(1743),
    [anon_sym_CARET_EQ] = ACTIONS(1743),
    [anon_sym_PIPE_EQ] = ACTIONS(1743),
    [anon_sym_AMP] = ACTIONS(1745),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_AMP_AMP] = ACTIONS(1749),
    [anon_sym_PIPE] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_GT] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [866] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_STAR_EQ] = ACTIONS(2770),
    [anon_sym_SLASH_EQ] = ACTIONS(2770),
    [anon_sym_PERCENT_EQ] = ACTIONS(2770),
    [anon_sym_PLUS_EQ] = ACTIONS(2770),
    [anon_sym_DASH_EQ] = ACTIONS(2770),
    [anon_sym_LT_LT_EQ] = ACTIONS(2770),
    [anon_sym_GT_GT_EQ] = ACTIONS(2770),
    [anon_sym_AMP_EQ] = ACTIONS(2770),
    [anon_sym_CARET_EQ] = ACTIONS(2770),
    [anon_sym_PIPE_EQ] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2772),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_PIPE] = ACTIONS(2772),
    [anon_sym_CARET] = ACTIONS(2772),
    [anon_sym_EQ_EQ] = ACTIONS(1445),
    [anon_sym_BANG_EQ] = ACTIONS(1445),
    [anon_sym_LT] = ACTIONS(1447),
    [anon_sym_GT] = ACTIONS(1447),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1451),
    [anon_sym_GT_GT] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_SLASH] = ACTIONS(1427),
    [anon_sym_PERCENT] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [867] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2774),
    [anon_sym_RBRACE] = ACTIONS(2774),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2776),
    [anon_sym_QMARK] = ACTIONS(2774),
    [anon_sym_STAR_EQ] = ACTIONS(2774),
    [anon_sym_SLASH_EQ] = ACTIONS(2774),
    [anon_sym_PERCENT_EQ] = ACTIONS(2774),
    [anon_sym_PLUS_EQ] = ACTIONS(2774),
    [anon_sym_DASH_EQ] = ACTIONS(2774),
    [anon_sym_LT_LT_EQ] = ACTIONS(2774),
    [anon_sym_GT_GT_EQ] = ACTIONS(2774),
    [anon_sym_AMP_EQ] = ACTIONS(2774),
    [anon_sym_CARET_EQ] = ACTIONS(2774),
    [anon_sym_PIPE_EQ] = ACTIONS(2774),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_PIPE_PIPE] = ACTIONS(2774),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_PIPE] = ACTIONS(1441),
    [anon_sym_CARET] = ACTIONS(1443),
    [anon_sym_EQ_EQ] = ACTIONS(1445),
    [anon_sym_BANG_EQ] = ACTIONS(1445),
    [anon_sym_LT] = ACTIONS(1447),
    [anon_sym_GT] = ACTIONS(1447),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1451),
    [anon_sym_GT_GT] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_SLASH] = ACTIONS(1427),
    [anon_sym_PERCENT] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [868] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2774),
    [anon_sym_RBRACE] = ACTIONS(2774),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2776),
    [anon_sym_QMARK] = ACTIONS(2774),
    [anon_sym_STAR_EQ] = ACTIONS(2774),
    [anon_sym_SLASH_EQ] = ACTIONS(2774),
    [anon_sym_PERCENT_EQ] = ACTIONS(2774),
    [anon_sym_PLUS_EQ] = ACTIONS(2774),
    [anon_sym_DASH_EQ] = ACTIONS(2774),
    [anon_sym_LT_LT_EQ] = ACTIONS(2774),
    [anon_sym_GT_GT_EQ] = ACTIONS(2774),
    [anon_sym_AMP_EQ] = ACTIONS(2774),
    [anon_sym_CARET_EQ] = ACTIONS(2774),
    [anon_sym_PIPE_EQ] = ACTIONS(2774),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_PIPE_PIPE] = ACTIONS(2774),
    [anon_sym_AMP_AMP] = ACTIONS(2774),
    [anon_sym_PIPE] = ACTIONS(1441),
    [anon_sym_CARET] = ACTIONS(1443),
    [anon_sym_EQ_EQ] = ACTIONS(1445),
    [anon_sym_BANG_EQ] = ACTIONS(1445),
    [anon_sym_LT] = ACTIONS(1447),
    [anon_sym_GT] = ACTIONS(1447),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1451),
    [anon_sym_GT_GT] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_SLASH] = ACTIONS(1427),
    [anon_sym_PERCENT] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [869] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_STAR_EQ] = ACTIONS(2770),
    [anon_sym_SLASH_EQ] = ACTIONS(2770),
    [anon_sym_PERCENT_EQ] = ACTIONS(2770),
    [anon_sym_PLUS_EQ] = ACTIONS(2770),
    [anon_sym_DASH_EQ] = ACTIONS(2770),
    [anon_sym_LT_LT_EQ] = ACTIONS(2770),
    [anon_sym_GT_GT_EQ] = ACTIONS(2770),
    [anon_sym_AMP_EQ] = ACTIONS(2770),
    [anon_sym_CARET_EQ] = ACTIONS(2770),
    [anon_sym_PIPE_EQ] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_PIPE] = ACTIONS(2772),
    [anon_sym_CARET] = ACTIONS(1443),
    [anon_sym_EQ_EQ] = ACTIONS(1445),
    [anon_sym_BANG_EQ] = ACTIONS(1445),
    [anon_sym_LT] = ACTIONS(1447),
    [anon_sym_GT] = ACTIONS(1447),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1451),
    [anon_sym_GT_GT] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_SLASH] = ACTIONS(1427),
    [anon_sym_PERCENT] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [870] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_STAR_EQ] = ACTIONS(2770),
    [anon_sym_SLASH_EQ] = ACTIONS(2770),
    [anon_sym_PERCENT_EQ] = ACTIONS(2770),
    [anon_sym_PLUS_EQ] = ACTIONS(2770),
    [anon_sym_DASH_EQ] = ACTIONS(2770),
    [anon_sym_LT_LT_EQ] = ACTIONS(2770),
    [anon_sym_GT_GT_EQ] = ACTIONS(2770),
    [anon_sym_AMP_EQ] = ACTIONS(2770),
    [anon_sym_CARET_EQ] = ACTIONS(2770),
    [anon_sym_PIPE_EQ] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_PIPE] = ACTIONS(2772),
    [anon_sym_CARET] = ACTIONS(2772),
    [anon_sym_EQ_EQ] = ACTIONS(1445),
    [anon_sym_BANG_EQ] = ACTIONS(1445),
    [anon_sym_LT] = ACTIONS(1447),
    [anon_sym_GT] = ACTIONS(1447),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1451),
    [anon_sym_GT_GT] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_SLASH] = ACTIONS(1427),
    [anon_sym_PERCENT] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [871] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2778),
    [anon_sym_RBRACE] = ACTIONS(2778),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2780),
    [anon_sym_QMARK] = ACTIONS(2778),
    [anon_sym_STAR_EQ] = ACTIONS(2778),
    [anon_sym_SLASH_EQ] = ACTIONS(2778),
    [anon_sym_PERCENT_EQ] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2778),
    [anon_sym_DASH_EQ] = ACTIONS(2778),
    [anon_sym_LT_LT_EQ] = ACTIONS(2778),
    [anon_sym_GT_GT_EQ] = ACTIONS(2778),
    [anon_sym_AMP_EQ] = ACTIONS(2778),
    [anon_sym_CARET_EQ] = ACTIONS(2778),
    [anon_sym_PIPE_EQ] = ACTIONS(2778),
    [anon_sym_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2778),
    [anon_sym_AMP_AMP] = ACTIONS(2778),
    [anon_sym_PIPE] = ACTIONS(2780),
    [anon_sym_CARET] = ACTIONS(2780),
    [anon_sym_EQ_EQ] = ACTIONS(2778),
    [anon_sym_BANG_EQ] = ACTIONS(2778),
    [anon_sym_LT] = ACTIONS(1447),
    [anon_sym_GT] = ACTIONS(1447),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1451),
    [anon_sym_GT_GT] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_SLASH] = ACTIONS(1427),
    [anon_sym_PERCENT] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [872] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2782),
    [anon_sym_RBRACE] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2784),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_STAR_EQ] = ACTIONS(2782),
    [anon_sym_SLASH_EQ] = ACTIONS(2782),
    [anon_sym_PERCENT_EQ] = ACTIONS(2782),
    [anon_sym_PLUS_EQ] = ACTIONS(2782),
    [anon_sym_DASH_EQ] = ACTIONS(2782),
    [anon_sym_LT_LT_EQ] = ACTIONS(2782),
    [anon_sym_GT_GT_EQ] = ACTIONS(2782),
    [anon_sym_AMP_EQ] = ACTIONS(2782),
    [anon_sym_CARET_EQ] = ACTIONS(2782),
    [anon_sym_PIPE_EQ] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2784),
    [anon_sym_PIPE_PIPE] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2784),
    [anon_sym_CARET] = ACTIONS(2784),
    [anon_sym_EQ_EQ] = ACTIONS(2782),
    [anon_sym_BANG_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2784),
    [anon_sym_GT] = ACTIONS(2784),
    [anon_sym_LT_EQ] = ACTIONS(2782),
    [anon_sym_GT_EQ] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(1451),
    [anon_sym_GT_GT] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_SLASH] = ACTIONS(1427),
    [anon_sym_PERCENT] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [873] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2786),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2788),
    [anon_sym_QMARK] = ACTIONS(2786),
    [anon_sym_STAR_EQ] = ACTIONS(2786),
    [anon_sym_SLASH_EQ] = ACTIONS(2786),
    [anon_sym_PERCENT_EQ] = ACTIONS(2786),
    [anon_sym_PLUS_EQ] = ACTIONS(2786),
    [anon_sym_DASH_EQ] = ACTIONS(2786),
    [anon_sym_LT_LT_EQ] = ACTIONS(2786),
    [anon_sym_GT_GT_EQ] = ACTIONS(2786),
    [anon_sym_AMP_EQ] = ACTIONS(2786),
    [anon_sym_CARET_EQ] = ACTIONS(2786),
    [anon_sym_PIPE_EQ] = ACTIONS(2786),
    [anon_sym_AMP] = ACTIONS(2788),
    [anon_sym_PIPE_PIPE] = ACTIONS(2786),
    [anon_sym_AMP_AMP] = ACTIONS(2786),
    [anon_sym_PIPE] = ACTIONS(2788),
    [anon_sym_CARET] = ACTIONS(2788),
    [anon_sym_EQ_EQ] = ACTIONS(2786),
    [anon_sym_BANG_EQ] = ACTIONS(2786),
    [anon_sym_LT] = ACTIONS(2788),
    [anon_sym_GT] = ACTIONS(2788),
    [anon_sym_LT_EQ] = ACTIONS(2786),
    [anon_sym_GT_EQ] = ACTIONS(2786),
    [anon_sym_LT_LT] = ACTIONS(2788),
    [anon_sym_GT_GT] = ACTIONS(2788),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_SLASH] = ACTIONS(1427),
    [anon_sym_PERCENT] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [874] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2760),
    [anon_sym_RBRACE] = ACTIONS(2760),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_QMARK] = ACTIONS(2760),
    [anon_sym_STAR_EQ] = ACTIONS(2760),
    [anon_sym_SLASH_EQ] = ACTIONS(2760),
    [anon_sym_PERCENT_EQ] = ACTIONS(2760),
    [anon_sym_PLUS_EQ] = ACTIONS(2760),
    [anon_sym_DASH_EQ] = ACTIONS(2760),
    [anon_sym_LT_LT_EQ] = ACTIONS(2760),
    [anon_sym_GT_GT_EQ] = ACTIONS(2760),
    [anon_sym_AMP_EQ] = ACTIONS(2760),
    [anon_sym_CARET_EQ] = ACTIONS(2760),
    [anon_sym_PIPE_EQ] = ACTIONS(2760),
    [anon_sym_AMP] = ACTIONS(2762),
    [anon_sym_PIPE_PIPE] = ACTIONS(2760),
    [anon_sym_AMP_AMP] = ACTIONS(2760),
    [anon_sym_PIPE] = ACTIONS(2762),
    [anon_sym_CARET] = ACTIONS(2762),
    [anon_sym_EQ_EQ] = ACTIONS(2760),
    [anon_sym_BANG_EQ] = ACTIONS(2760),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_GT] = ACTIONS(2762),
    [anon_sym_LT_EQ] = ACTIONS(2760),
    [anon_sym_GT_EQ] = ACTIONS(2760),
    [anon_sym_LT_LT] = ACTIONS(2762),
    [anon_sym_GT_GT] = ACTIONS(2762),
    [anon_sym_PLUS] = ACTIONS(2762),
    [anon_sym_DASH] = ACTIONS(2762),
    [anon_sym_SLASH] = ACTIONS(1427),
    [anon_sym_PERCENT] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [875] = {
    [sym__declaration_specifiers] = STATE(124),
    [sym_storage_class_specifier] = STATE(126),
    [sym_type_qualifier] = STATE(126),
    [sym__type_specifier] = STATE(125),
    [sym_sized_type_specifier] = STATE(125),
    [sym_enum_specifier] = STATE(125),
    [sym_struct_specifier] = STATE(125),
    [sym_union_specifier] = STATE(125),
    [sym_field_declaration] = STATE(875),
    [sym_macro_type_specifier] = STATE(125),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(875),
    [aux_sym__declaration_specifiers_repeat1] = STATE(126),
    [aux_sym_sized_type_specifier_repeat1] = STATE(127),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2242),
    [anon_sym_extern] = ACTIONS(2244),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_auto] = ACTIONS(2244),
    [anon_sym_register] = ACTIONS(2244),
    [anon_sym_inline] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2247),
    [anon_sym_restrict] = ACTIONS(2247),
    [anon_sym_volatile] = ACTIONS(2247),
    [anon_sym__Atomic] = ACTIONS(2247),
    [anon_sym_unsigned] = ACTIONS(2250),
    [anon_sym_long] = ACTIONS(2250),
    [anon_sym_short] = ACTIONS(2250),
    [sym_primitive_type] = ACTIONS(2253),
    [anon_sym_enum] = ACTIONS(2256),
    [anon_sym_struct] = ACTIONS(2259),
    [anon_sym_union] = ACTIONS(2262),
    [sym_identifier] = ACTIONS(2265),
    [sym_comment] = ACTIONS(42),
  },
  [876] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2870),
    [sym_comment] = ACTIONS(42),
  },
  [877] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2872),
    [sym_comment] = ACTIONS(42),
  },
  [878] = {
    [sym_preproc_else_in_field_declaration_list] = STATE(1079),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1080),
    [sym__declaration_specifiers] = STATE(124),
    [sym_storage_class_specifier] = STATE(126),
    [sym_type_qualifier] = STATE(126),
    [sym__type_specifier] = STATE(125),
    [sym_sized_type_specifier] = STATE(125),
    [sym_enum_specifier] = STATE(125),
    [sym_struct_specifier] = STATE(125),
    [sym_union_specifier] = STATE(125),
    [sym_field_declaration] = STATE(620),
    [sym_macro_type_specifier] = STATE(125),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(620),
    [aux_sym__declaration_specifiers_repeat1] = STATE(126),
    [aux_sym_sized_type_specifier_repeat1] = STATE(127),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2874),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(866),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(868),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(228),
    [anon_sym_long] = ACTIONS(228),
    [anon_sym_short] = ACTIONS(228),
    [sym_primitive_type] = ACTIONS(230),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [sym_identifier] = ACTIONS(40),
    [sym_comment] = ACTIONS(42),
  },
  [879] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2876),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2878),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2878),
    [anon_sym_extern] = ACTIONS(2876),
    [anon_sym_RBRACE] = ACTIONS(2878),
    [anon_sym_static] = ACTIONS(2876),
    [anon_sym_auto] = ACTIONS(2876),
    [anon_sym_register] = ACTIONS(2876),
    [anon_sym_inline] = ACTIONS(2876),
    [anon_sym_const] = ACTIONS(2876),
    [anon_sym_restrict] = ACTIONS(2876),
    [anon_sym_volatile] = ACTIONS(2876),
    [anon_sym__Atomic] = ACTIONS(2876),
    [anon_sym_unsigned] = ACTIONS(2876),
    [anon_sym_long] = ACTIONS(2876),
    [anon_sym_short] = ACTIONS(2876),
    [sym_primitive_type] = ACTIONS(2876),
    [anon_sym_enum] = ACTIONS(2876),
    [anon_sym_struct] = ACTIONS(2876),
    [anon_sym_union] = ACTIONS(2876),
    [sym_identifier] = ACTIONS(2876),
    [sym_comment] = ACTIONS(42),
  },
  [880] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2880),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2882),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2882),
    [anon_sym_extern] = ACTIONS(2880),
    [anon_sym_RBRACE] = ACTIONS(2882),
    [anon_sym_static] = ACTIONS(2880),
    [anon_sym_auto] = ACTIONS(2880),
    [anon_sym_register] = ACTIONS(2880),
    [anon_sym_inline] = ACTIONS(2880),
    [anon_sym_const] = ACTIONS(2880),
    [anon_sym_restrict] = ACTIONS(2880),
    [anon_sym_volatile] = ACTIONS(2880),
    [anon_sym__Atomic] = ACTIONS(2880),
    [anon_sym_unsigned] = ACTIONS(2880),
    [anon_sym_long] = ACTIONS(2880),
    [anon_sym_short] = ACTIONS(2880),
    [sym_primitive_type] = ACTIONS(2880),
    [anon_sym_enum] = ACTIONS(2880),
    [anon_sym_struct] = ACTIONS(2880),
    [anon_sym_union] = ACTIONS(2880),
    [sym_identifier] = ACTIONS(2880),
    [sym_comment] = ACTIONS(42),
  },
  [881] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2884),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2886),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2886),
    [anon_sym_extern] = ACTIONS(2884),
    [anon_sym_RBRACE] = ACTIONS(2886),
    [anon_sym_static] = ACTIONS(2884),
    [anon_sym_auto] = ACTIONS(2884),
    [anon_sym_register] = ACTIONS(2884),
    [anon_sym_inline] = ACTIONS(2884),
    [anon_sym_const] = ACTIONS(2884),
    [anon_sym_restrict] = ACTIONS(2884),
    [anon_sym_volatile] = ACTIONS(2884),
    [anon_sym__Atomic] = ACTIONS(2884),
    [anon_sym_unsigned] = ACTIONS(2884),
    [anon_sym_long] = ACTIONS(2884),
    [anon_sym_short] = ACTIONS(2884),
    [sym_primitive_type] = ACTIONS(2884),
    [anon_sym_enum] = ACTIONS(2884),
    [anon_sym_struct] = ACTIONS(2884),
    [anon_sym_union] = ACTIONS(2884),
    [sym_identifier] = ACTIONS(2884),
    [sym_comment] = ACTIONS(42),
  },
  [882] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2888),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2890),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2890),
    [anon_sym_extern] = ACTIONS(2888),
    [anon_sym_RBRACE] = ACTIONS(2890),
    [anon_sym_static] = ACTIONS(2888),
    [anon_sym_auto] = ACTIONS(2888),
    [anon_sym_register] = ACTIONS(2888),
    [anon_sym_inline] = ACTIONS(2888),
    [anon_sym_const] = ACTIONS(2888),
    [anon_sym_restrict] = ACTIONS(2888),
    [anon_sym_volatile] = ACTIONS(2888),
    [anon_sym__Atomic] = ACTIONS(2888),
    [anon_sym_unsigned] = ACTIONS(2888),
    [anon_sym_long] = ACTIONS(2888),
    [anon_sym_short] = ACTIONS(2888),
    [sym_primitive_type] = ACTIONS(2888),
    [anon_sym_enum] = ACTIONS(2888),
    [anon_sym_struct] = ACTIONS(2888),
    [anon_sym_union] = ACTIONS(2888),
    [sym_identifier] = ACTIONS(2888),
    [sym_comment] = ACTIONS(42),
  },
  [883] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2892),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2894),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2894),
    [anon_sym_extern] = ACTIONS(2892),
    [anon_sym_RBRACE] = ACTIONS(2894),
    [anon_sym_static] = ACTIONS(2892),
    [anon_sym_auto] = ACTIONS(2892),
    [anon_sym_register] = ACTIONS(2892),
    [anon_sym_inline] = ACTIONS(2892),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_restrict] = ACTIONS(2892),
    [anon_sym_volatile] = ACTIONS(2892),
    [anon_sym__Atomic] = ACTIONS(2892),
    [anon_sym_unsigned] = ACTIONS(2892),
    [anon_sym_long] = ACTIONS(2892),
    [anon_sym_short] = ACTIONS(2892),
    [sym_primitive_type] = ACTIONS(2892),
    [anon_sym_enum] = ACTIONS(2892),
    [anon_sym_struct] = ACTIONS(2892),
    [anon_sym_union] = ACTIONS(2892),
    [sym_identifier] = ACTIONS(2892),
    [sym_comment] = ACTIONS(42),
  },
  [884] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2896),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2898),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2898),
    [anon_sym_extern] = ACTIONS(2896),
    [anon_sym_RBRACE] = ACTIONS(2898),
    [anon_sym_static] = ACTIONS(2896),
    [anon_sym_auto] = ACTIONS(2896),
    [anon_sym_register] = ACTIONS(2896),
    [anon_sym_inline] = ACTIONS(2896),
    [anon_sym_const] = ACTIONS(2896),
    [anon_sym_restrict] = ACTIONS(2896),
    [anon_sym_volatile] = ACTIONS(2896),
    [anon_sym__Atomic] = ACTIONS(2896),
    [anon_sym_unsigned] = ACTIONS(2896),
    [anon_sym_long] = ACTIONS(2896),
    [anon_sym_short] = ACTIONS(2896),
    [sym_primitive_type] = ACTIONS(2896),
    [anon_sym_enum] = ACTIONS(2896),
    [anon_sym_struct] = ACTIONS(2896),
    [anon_sym_union] = ACTIONS(2896),
    [sym_identifier] = ACTIONS(2896),
    [sym_comment] = ACTIONS(42),
  },
  [885] = {
    [sym__expression] = STATE(923),
    [sym_conditional_expression] = STATE(923),
    [sym_assignment_expression] = STATE(923),
    [sym_pointer_expression] = STATE(923),
    [sym_logical_expression] = STATE(923),
    [sym_bitwise_expression] = STATE(923),
    [sym_equality_expression] = STATE(923),
    [sym_relational_expression] = STATE(923),
    [sym_shift_expression] = STATE(923),
    [sym_math_expression] = STATE(923),
    [sym_cast_expression] = STATE(923),
    [sym_sizeof_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_call_expression] = STATE(923),
    [sym_field_expression] = STATE(923),
    [sym_compound_literal_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(923),
    [sym_initializer_list] = STATE(924),
    [sym_concatenated_string] = STATE(923),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(2459),
    [sym_char_literal] = ACTIONS(2459),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(2461),
    [sym_false] = ACTIONS(2461),
    [sym_null] = ACTIONS(2461),
    [sym_identifier] = ACTIONS(2461),
    [sym_comment] = ACTIONS(42),
  },
  [886] = {
    [anon_sym_RPAREN] = ACTIONS(2900),
    [sym_comment] = ACTIONS(42),
  },
  [887] = {
    [aux_sym_concatenated_string_repeat1] = STATE(887),
    [anon_sym_LPAREN] = ACTIONS(2737),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_STAR] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2737),
    [anon_sym_EQ] = ACTIONS(2739),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2737),
    [anon_sym_SLASH_EQ] = ACTIONS(2737),
    [anon_sym_PERCENT_EQ] = ACTIONS(2737),
    [anon_sym_PLUS_EQ] = ACTIONS(2737),
    [anon_sym_DASH_EQ] = ACTIONS(2737),
    [anon_sym_LT_LT_EQ] = ACTIONS(2737),
    [anon_sym_GT_GT_EQ] = ACTIONS(2737),
    [anon_sym_AMP_EQ] = ACTIONS(2737),
    [anon_sym_CARET_EQ] = ACTIONS(2737),
    [anon_sym_PIPE_EQ] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2739),
    [anon_sym_PIPE_PIPE] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_PIPE] = ACTIONS(2739),
    [anon_sym_CARET] = ACTIONS(2739),
    [anon_sym_EQ_EQ] = ACTIONS(2737),
    [anon_sym_BANG_EQ] = ACTIONS(2737),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_GT] = ACTIONS(2739),
    [anon_sym_LT_EQ] = ACTIONS(2737),
    [anon_sym_GT_EQ] = ACTIONS(2737),
    [anon_sym_LT_LT] = ACTIONS(2739),
    [anon_sym_GT_GT] = ACTIONS(2739),
    [anon_sym_PLUS] = ACTIONS(2739),
    [anon_sym_DASH] = ACTIONS(2739),
    [anon_sym_SLASH] = ACTIONS(2739),
    [anon_sym_PERCENT] = ACTIONS(2739),
    [anon_sym_DASH_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_PLUS] = ACTIONS(2737),
    [anon_sym_DOT] = ACTIONS(2737),
    [anon_sym_DASH_GT] = ACTIONS(2737),
    [sym_string_literal] = ACTIONS(2902),
    [sym_comment] = ACTIONS(42),
  },
  [888] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(2766),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [889] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1737),
    [anon_sym_COLON] = ACTIONS(2905),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1743),
    [anon_sym_SLASH_EQ] = ACTIONS(1743),
    [anon_sym_PERCENT_EQ] = ACTIONS(1743),
    [anon_sym_PLUS_EQ] = ACTIONS(1743),
    [anon_sym_DASH_EQ] = ACTIONS(1743),
    [anon_sym_LT_LT_EQ] = ACTIONS(1743),
    [anon_sym_GT_GT_EQ] = ACTIONS(1743),
    [anon_sym_AMP_EQ] = ACTIONS(1743),
    [anon_sym_CARET_EQ] = ACTIONS(1743),
    [anon_sym_PIPE_EQ] = ACTIONS(1743),
    [anon_sym_AMP] = ACTIONS(1745),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_AMP_AMP] = ACTIONS(1749),
    [anon_sym_PIPE] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_GT] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [890] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(2770),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_STAR_EQ] = ACTIONS(2770),
    [anon_sym_SLASH_EQ] = ACTIONS(2770),
    [anon_sym_PERCENT_EQ] = ACTIONS(2770),
    [anon_sym_PLUS_EQ] = ACTIONS(2770),
    [anon_sym_DASH_EQ] = ACTIONS(2770),
    [anon_sym_LT_LT_EQ] = ACTIONS(2770),
    [anon_sym_GT_GT_EQ] = ACTIONS(2770),
    [anon_sym_AMP_EQ] = ACTIONS(2770),
    [anon_sym_CARET_EQ] = ACTIONS(2770),
    [anon_sym_PIPE_EQ] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2772),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_PIPE] = ACTIONS(2772),
    [anon_sym_CARET] = ACTIONS(2772),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [891] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(2774),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2776),
    [anon_sym_QMARK] = ACTIONS(2774),
    [anon_sym_STAR_EQ] = ACTIONS(2774),
    [anon_sym_SLASH_EQ] = ACTIONS(2774),
    [anon_sym_PERCENT_EQ] = ACTIONS(2774),
    [anon_sym_PLUS_EQ] = ACTIONS(2774),
    [anon_sym_DASH_EQ] = ACTIONS(2774),
    [anon_sym_LT_LT_EQ] = ACTIONS(2774),
    [anon_sym_GT_GT_EQ] = ACTIONS(2774),
    [anon_sym_AMP_EQ] = ACTIONS(2774),
    [anon_sym_CARET_EQ] = ACTIONS(2774),
    [anon_sym_PIPE_EQ] = ACTIONS(2774),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(2774),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [892] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(2774),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2776),
    [anon_sym_QMARK] = ACTIONS(2774),
    [anon_sym_STAR_EQ] = ACTIONS(2774),
    [anon_sym_SLASH_EQ] = ACTIONS(2774),
    [anon_sym_PERCENT_EQ] = ACTIONS(2774),
    [anon_sym_PLUS_EQ] = ACTIONS(2774),
    [anon_sym_DASH_EQ] = ACTIONS(2774),
    [anon_sym_LT_LT_EQ] = ACTIONS(2774),
    [anon_sym_GT_GT_EQ] = ACTIONS(2774),
    [anon_sym_AMP_EQ] = ACTIONS(2774),
    [anon_sym_CARET_EQ] = ACTIONS(2774),
    [anon_sym_PIPE_EQ] = ACTIONS(2774),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(2774),
    [anon_sym_AMP_AMP] = ACTIONS(2774),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [893] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(2770),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_STAR_EQ] = ACTIONS(2770),
    [anon_sym_SLASH_EQ] = ACTIONS(2770),
    [anon_sym_PERCENT_EQ] = ACTIONS(2770),
    [anon_sym_PLUS_EQ] = ACTIONS(2770),
    [anon_sym_DASH_EQ] = ACTIONS(2770),
    [anon_sym_LT_LT_EQ] = ACTIONS(2770),
    [anon_sym_GT_GT_EQ] = ACTIONS(2770),
    [anon_sym_AMP_EQ] = ACTIONS(2770),
    [anon_sym_CARET_EQ] = ACTIONS(2770),
    [anon_sym_PIPE_EQ] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_PIPE] = ACTIONS(2772),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [894] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(2770),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_STAR_EQ] = ACTIONS(2770),
    [anon_sym_SLASH_EQ] = ACTIONS(2770),
    [anon_sym_PERCENT_EQ] = ACTIONS(2770),
    [anon_sym_PLUS_EQ] = ACTIONS(2770),
    [anon_sym_DASH_EQ] = ACTIONS(2770),
    [anon_sym_LT_LT_EQ] = ACTIONS(2770),
    [anon_sym_GT_GT_EQ] = ACTIONS(2770),
    [anon_sym_AMP_EQ] = ACTIONS(2770),
    [anon_sym_CARET_EQ] = ACTIONS(2770),
    [anon_sym_PIPE_EQ] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_PIPE] = ACTIONS(2772),
    [anon_sym_CARET] = ACTIONS(2772),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [895] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(2778),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2780),
    [anon_sym_QMARK] = ACTIONS(2778),
    [anon_sym_STAR_EQ] = ACTIONS(2778),
    [anon_sym_SLASH_EQ] = ACTIONS(2778),
    [anon_sym_PERCENT_EQ] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2778),
    [anon_sym_DASH_EQ] = ACTIONS(2778),
    [anon_sym_LT_LT_EQ] = ACTIONS(2778),
    [anon_sym_GT_GT_EQ] = ACTIONS(2778),
    [anon_sym_AMP_EQ] = ACTIONS(2778),
    [anon_sym_CARET_EQ] = ACTIONS(2778),
    [anon_sym_PIPE_EQ] = ACTIONS(2778),
    [anon_sym_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2778),
    [anon_sym_AMP_AMP] = ACTIONS(2778),
    [anon_sym_PIPE] = ACTIONS(2780),
    [anon_sym_CARET] = ACTIONS(2780),
    [anon_sym_EQ_EQ] = ACTIONS(2778),
    [anon_sym_BANG_EQ] = ACTIONS(2778),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [896] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2784),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_STAR_EQ] = ACTIONS(2782),
    [anon_sym_SLASH_EQ] = ACTIONS(2782),
    [anon_sym_PERCENT_EQ] = ACTIONS(2782),
    [anon_sym_PLUS_EQ] = ACTIONS(2782),
    [anon_sym_DASH_EQ] = ACTIONS(2782),
    [anon_sym_LT_LT_EQ] = ACTIONS(2782),
    [anon_sym_GT_GT_EQ] = ACTIONS(2782),
    [anon_sym_AMP_EQ] = ACTIONS(2782),
    [anon_sym_CARET_EQ] = ACTIONS(2782),
    [anon_sym_PIPE_EQ] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2784),
    [anon_sym_PIPE_PIPE] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2784),
    [anon_sym_CARET] = ACTIONS(2784),
    [anon_sym_EQ_EQ] = ACTIONS(2782),
    [anon_sym_BANG_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2784),
    [anon_sym_GT] = ACTIONS(2784),
    [anon_sym_LT_EQ] = ACTIONS(2782),
    [anon_sym_GT_EQ] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [897] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(2786),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2788),
    [anon_sym_QMARK] = ACTIONS(2786),
    [anon_sym_STAR_EQ] = ACTIONS(2786),
    [anon_sym_SLASH_EQ] = ACTIONS(2786),
    [anon_sym_PERCENT_EQ] = ACTIONS(2786),
    [anon_sym_PLUS_EQ] = ACTIONS(2786),
    [anon_sym_DASH_EQ] = ACTIONS(2786),
    [anon_sym_LT_LT_EQ] = ACTIONS(2786),
    [anon_sym_GT_GT_EQ] = ACTIONS(2786),
    [anon_sym_AMP_EQ] = ACTIONS(2786),
    [anon_sym_CARET_EQ] = ACTIONS(2786),
    [anon_sym_PIPE_EQ] = ACTIONS(2786),
    [anon_sym_AMP] = ACTIONS(2788),
    [anon_sym_PIPE_PIPE] = ACTIONS(2786),
    [anon_sym_AMP_AMP] = ACTIONS(2786),
    [anon_sym_PIPE] = ACTIONS(2788),
    [anon_sym_CARET] = ACTIONS(2788),
    [anon_sym_EQ_EQ] = ACTIONS(2786),
    [anon_sym_BANG_EQ] = ACTIONS(2786),
    [anon_sym_LT] = ACTIONS(2788),
    [anon_sym_GT] = ACTIONS(2788),
    [anon_sym_LT_EQ] = ACTIONS(2786),
    [anon_sym_GT_EQ] = ACTIONS(2786),
    [anon_sym_LT_LT] = ACTIONS(2788),
    [anon_sym_GT_GT] = ACTIONS(2788),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [898] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(2760),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_QMARK] = ACTIONS(2760),
    [anon_sym_STAR_EQ] = ACTIONS(2760),
    [anon_sym_SLASH_EQ] = ACTIONS(2760),
    [anon_sym_PERCENT_EQ] = ACTIONS(2760),
    [anon_sym_PLUS_EQ] = ACTIONS(2760),
    [anon_sym_DASH_EQ] = ACTIONS(2760),
    [anon_sym_LT_LT_EQ] = ACTIONS(2760),
    [anon_sym_GT_GT_EQ] = ACTIONS(2760),
    [anon_sym_AMP_EQ] = ACTIONS(2760),
    [anon_sym_CARET_EQ] = ACTIONS(2760),
    [anon_sym_PIPE_EQ] = ACTIONS(2760),
    [anon_sym_AMP] = ACTIONS(2762),
    [anon_sym_PIPE_PIPE] = ACTIONS(2760),
    [anon_sym_AMP_AMP] = ACTIONS(2760),
    [anon_sym_PIPE] = ACTIONS(2762),
    [anon_sym_CARET] = ACTIONS(2762),
    [anon_sym_EQ_EQ] = ACTIONS(2760),
    [anon_sym_BANG_EQ] = ACTIONS(2760),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_GT] = ACTIONS(2762),
    [anon_sym_LT_EQ] = ACTIONS(2760),
    [anon_sym_GT_EQ] = ACTIONS(2760),
    [anon_sym_LT_LT] = ACTIONS(2762),
    [anon_sym_GT_GT] = ACTIONS(2762),
    [anon_sym_PLUS] = ACTIONS(2762),
    [anon_sym_DASH] = ACTIONS(2762),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [899] = {
    [anon_sym_LPAREN] = ACTIONS(2907),
    [anon_sym_COMMA] = ACTIONS(2907),
    [anon_sym_RPAREN] = ACTIONS(2907),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_COLON] = ACTIONS(2907),
    [sym_comment] = ACTIONS(42),
  },
  [900] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2909),
    [anon_sym_EQ] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1237),
    [anon_sym_STAR_EQ] = ACTIONS(1239),
    [anon_sym_SLASH_EQ] = ACTIONS(1239),
    [anon_sym_PERCENT_EQ] = ACTIONS(1239),
    [anon_sym_PLUS_EQ] = ACTIONS(1239),
    [anon_sym_DASH_EQ] = ACTIONS(1239),
    [anon_sym_LT_LT_EQ] = ACTIONS(1239),
    [anon_sym_GT_GT_EQ] = ACTIONS(1239),
    [anon_sym_AMP_EQ] = ACTIONS(1239),
    [anon_sym_CARET_EQ] = ACTIONS(1239),
    [anon_sym_PIPE_EQ] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_PIPE_PIPE] = ACTIONS(1243),
    [anon_sym_AMP_AMP] = ACTIONS(1245),
    [anon_sym_PIPE] = ACTIONS(1247),
    [anon_sym_CARET] = ACTIONS(1249),
    [anon_sym_EQ_EQ] = ACTIONS(1251),
    [anon_sym_BANG_EQ] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1253),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [901] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2911),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2913),
    [anon_sym_extern] = ACTIONS(2911),
    [anon_sym_RBRACE] = ACTIONS(2913),
    [anon_sym_static] = ACTIONS(2911),
    [anon_sym_auto] = ACTIONS(2911),
    [anon_sym_register] = ACTIONS(2911),
    [anon_sym_inline] = ACTIONS(2911),
    [anon_sym_const] = ACTIONS(2911),
    [anon_sym_restrict] = ACTIONS(2911),
    [anon_sym_volatile] = ACTIONS(2911),
    [anon_sym__Atomic] = ACTIONS(2911),
    [anon_sym_unsigned] = ACTIONS(2911),
    [anon_sym_long] = ACTIONS(2911),
    [anon_sym_short] = ACTIONS(2911),
    [sym_primitive_type] = ACTIONS(2911),
    [anon_sym_enum] = ACTIONS(2911),
    [anon_sym_struct] = ACTIONS(2911),
    [anon_sym_union] = ACTIONS(2911),
    [sym_identifier] = ACTIONS(2911),
    [sym_comment] = ACTIONS(42),
  },
  [902] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [903] = {
    [anon_sym_LPAREN] = ACTIONS(2917),
    [anon_sym_COMMA] = ACTIONS(2917),
    [anon_sym_RPAREN] = ACTIONS(2917),
    [anon_sym_LBRACK] = ACTIONS(2917),
    [sym_comment] = ACTIONS(42),
  },
  [904] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2919),
    [anon_sym_EQ] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1237),
    [anon_sym_STAR_EQ] = ACTIONS(1239),
    [anon_sym_SLASH_EQ] = ACTIONS(1239),
    [anon_sym_PERCENT_EQ] = ACTIONS(1239),
    [anon_sym_PLUS_EQ] = ACTIONS(1239),
    [anon_sym_DASH_EQ] = ACTIONS(1239),
    [anon_sym_LT_LT_EQ] = ACTIONS(1239),
    [anon_sym_GT_GT_EQ] = ACTIONS(1239),
    [anon_sym_AMP_EQ] = ACTIONS(1239),
    [anon_sym_CARET_EQ] = ACTIONS(1239),
    [anon_sym_PIPE_EQ] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_PIPE_PIPE] = ACTIONS(1243),
    [anon_sym_AMP_AMP] = ACTIONS(1245),
    [anon_sym_PIPE] = ACTIONS(1247),
    [anon_sym_CARET] = ACTIONS(1249),
    [anon_sym_EQ_EQ] = ACTIONS(1251),
    [anon_sym_BANG_EQ] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1253),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [905] = {
    [anon_sym_LF] = ACTIONS(2921),
    [sym_comment] = ACTIONS(50),
  },
  [906] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(703),
    [anon_sym_LPAREN] = ACTIONS(701),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(703),
    [sym_preproc_directive] = ACTIONS(703),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_typedef] = ACTIONS(703),
    [anon_sym_extern] = ACTIONS(703),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_RBRACE] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(701),
    [anon_sym_static] = ACTIONS(703),
    [anon_sym_auto] = ACTIONS(703),
    [anon_sym_register] = ACTIONS(703),
    [anon_sym_inline] = ACTIONS(703),
    [anon_sym_const] = ACTIONS(703),
    [anon_sym_restrict] = ACTIONS(703),
    [anon_sym_volatile] = ACTIONS(703),
    [anon_sym__Atomic] = ACTIONS(703),
    [anon_sym_unsigned] = ACTIONS(703),
    [anon_sym_long] = ACTIONS(703),
    [anon_sym_short] = ACTIONS(703),
    [sym_primitive_type] = ACTIONS(703),
    [anon_sym_enum] = ACTIONS(703),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_union] = ACTIONS(703),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_switch] = ACTIONS(703),
    [anon_sym_case] = ACTIONS(703),
    [anon_sym_default] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_for] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(703),
    [anon_sym_break] = ACTIONS(703),
    [anon_sym_continue] = ACTIONS(703),
    [anon_sym_goto] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_BANG] = ACTIONS(701),
    [anon_sym_TILDE] = ACTIONS(701),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_DASH_DASH] = ACTIONS(701),
    [anon_sym_PLUS_PLUS] = ACTIONS(701),
    [anon_sym_sizeof] = ACTIONS(703),
    [sym_number_literal] = ACTIONS(701),
    [sym_char_literal] = ACTIONS(701),
    [sym_string_literal] = ACTIONS(701),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_identifier] = ACTIONS(703),
    [sym_comment] = ACTIONS(42),
  },
  [907] = {
    [anon_sym_LF] = ACTIONS(2923),
    [sym_comment] = ACTIONS(50),
  },
  [908] = {
    [sym__expression] = STATE(923),
    [sym_conditional_expression] = STATE(923),
    [sym_assignment_expression] = STATE(923),
    [sym_pointer_expression] = STATE(923),
    [sym_logical_expression] = STATE(923),
    [sym_bitwise_expression] = STATE(923),
    [sym_equality_expression] = STATE(923),
    [sym_relational_expression] = STATE(923),
    [sym_shift_expression] = STATE(923),
    [sym_math_expression] = STATE(923),
    [sym_cast_expression] = STATE(923),
    [sym_sizeof_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_call_expression] = STATE(923),
    [sym_field_expression] = STATE(923),
    [sym_compound_literal_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(923),
    [sym_initializer_list] = STATE(924),
    [sym_concatenated_string] = STATE(923),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(2459),
    [sym_char_literal] = ACTIONS(2459),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(2461),
    [sym_false] = ACTIONS(2461),
    [sym_null] = ACTIONS(2461),
    [sym_identifier] = ACTIONS(2461),
    [sym_comment] = ACTIONS(42),
  },
  [909] = {
    [anon_sym_RPAREN] = ACTIONS(2925),
    [sym_comment] = ACTIONS(42),
  },
  [910] = {
    [aux_sym_concatenated_string_repeat1] = STATE(910),
    [anon_sym_LPAREN] = ACTIONS(2737),
    [anon_sym_COMMA] = ACTIONS(2737),
    [anon_sym_RPAREN] = ACTIONS(2737),
    [anon_sym_STAR] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2737),
    [anon_sym_EQ] = ACTIONS(2739),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2737),
    [anon_sym_SLASH_EQ] = ACTIONS(2737),
    [anon_sym_PERCENT_EQ] = ACTIONS(2737),
    [anon_sym_PLUS_EQ] = ACTIONS(2737),
    [anon_sym_DASH_EQ] = ACTIONS(2737),
    [anon_sym_LT_LT_EQ] = ACTIONS(2737),
    [anon_sym_GT_GT_EQ] = ACTIONS(2737),
    [anon_sym_AMP_EQ] = ACTIONS(2737),
    [anon_sym_CARET_EQ] = ACTIONS(2737),
    [anon_sym_PIPE_EQ] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2739),
    [anon_sym_PIPE_PIPE] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_PIPE] = ACTIONS(2739),
    [anon_sym_CARET] = ACTIONS(2739),
    [anon_sym_EQ_EQ] = ACTIONS(2737),
    [anon_sym_BANG_EQ] = ACTIONS(2737),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_GT] = ACTIONS(2739),
    [anon_sym_LT_EQ] = ACTIONS(2737),
    [anon_sym_GT_EQ] = ACTIONS(2737),
    [anon_sym_LT_LT] = ACTIONS(2739),
    [anon_sym_GT_GT] = ACTIONS(2739),
    [anon_sym_PLUS] = ACTIONS(2739),
    [anon_sym_DASH] = ACTIONS(2739),
    [anon_sym_SLASH] = ACTIONS(2739),
    [anon_sym_PERCENT] = ACTIONS(2739),
    [anon_sym_DASH_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_PLUS] = ACTIONS(2737),
    [anon_sym_DOT] = ACTIONS(2737),
    [anon_sym_DASH_GT] = ACTIONS(2737),
    [sym_string_literal] = ACTIONS(2927),
    [sym_comment] = ACTIONS(42),
  },
  [911] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1603),
    [anon_sym_RPAREN] = ACTIONS(2758),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [912] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2766),
    [anon_sym_RPAREN] = ACTIONS(2766),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [913] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1737),
    [anon_sym_COLON] = ACTIONS(2930),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1743),
    [anon_sym_SLASH_EQ] = ACTIONS(1743),
    [anon_sym_PERCENT_EQ] = ACTIONS(1743),
    [anon_sym_PLUS_EQ] = ACTIONS(1743),
    [anon_sym_DASH_EQ] = ACTIONS(1743),
    [anon_sym_LT_LT_EQ] = ACTIONS(1743),
    [anon_sym_GT_GT_EQ] = ACTIONS(1743),
    [anon_sym_AMP_EQ] = ACTIONS(1743),
    [anon_sym_CARET_EQ] = ACTIONS(1743),
    [anon_sym_PIPE_EQ] = ACTIONS(1743),
    [anon_sym_AMP] = ACTIONS(1745),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_AMP_AMP] = ACTIONS(1749),
    [anon_sym_PIPE] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_GT] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [914] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_RPAREN] = ACTIONS(2770),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_STAR_EQ] = ACTIONS(2770),
    [anon_sym_SLASH_EQ] = ACTIONS(2770),
    [anon_sym_PERCENT_EQ] = ACTIONS(2770),
    [anon_sym_PLUS_EQ] = ACTIONS(2770),
    [anon_sym_DASH_EQ] = ACTIONS(2770),
    [anon_sym_LT_LT_EQ] = ACTIONS(2770),
    [anon_sym_GT_GT_EQ] = ACTIONS(2770),
    [anon_sym_AMP_EQ] = ACTIONS(2770),
    [anon_sym_CARET_EQ] = ACTIONS(2770),
    [anon_sym_PIPE_EQ] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2772),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_PIPE] = ACTIONS(2772),
    [anon_sym_CARET] = ACTIONS(2772),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [915] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2774),
    [anon_sym_RPAREN] = ACTIONS(2774),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2776),
    [anon_sym_QMARK] = ACTIONS(2774),
    [anon_sym_STAR_EQ] = ACTIONS(2774),
    [anon_sym_SLASH_EQ] = ACTIONS(2774),
    [anon_sym_PERCENT_EQ] = ACTIONS(2774),
    [anon_sym_PLUS_EQ] = ACTIONS(2774),
    [anon_sym_DASH_EQ] = ACTIONS(2774),
    [anon_sym_LT_LT_EQ] = ACTIONS(2774),
    [anon_sym_GT_GT_EQ] = ACTIONS(2774),
    [anon_sym_AMP_EQ] = ACTIONS(2774),
    [anon_sym_CARET_EQ] = ACTIONS(2774),
    [anon_sym_PIPE_EQ] = ACTIONS(2774),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(2774),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [916] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2774),
    [anon_sym_RPAREN] = ACTIONS(2774),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2776),
    [anon_sym_QMARK] = ACTIONS(2774),
    [anon_sym_STAR_EQ] = ACTIONS(2774),
    [anon_sym_SLASH_EQ] = ACTIONS(2774),
    [anon_sym_PERCENT_EQ] = ACTIONS(2774),
    [anon_sym_PLUS_EQ] = ACTIONS(2774),
    [anon_sym_DASH_EQ] = ACTIONS(2774),
    [anon_sym_LT_LT_EQ] = ACTIONS(2774),
    [anon_sym_GT_GT_EQ] = ACTIONS(2774),
    [anon_sym_AMP_EQ] = ACTIONS(2774),
    [anon_sym_CARET_EQ] = ACTIONS(2774),
    [anon_sym_PIPE_EQ] = ACTIONS(2774),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(2774),
    [anon_sym_AMP_AMP] = ACTIONS(2774),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [917] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_RPAREN] = ACTIONS(2770),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_STAR_EQ] = ACTIONS(2770),
    [anon_sym_SLASH_EQ] = ACTIONS(2770),
    [anon_sym_PERCENT_EQ] = ACTIONS(2770),
    [anon_sym_PLUS_EQ] = ACTIONS(2770),
    [anon_sym_DASH_EQ] = ACTIONS(2770),
    [anon_sym_LT_LT_EQ] = ACTIONS(2770),
    [anon_sym_GT_GT_EQ] = ACTIONS(2770),
    [anon_sym_AMP_EQ] = ACTIONS(2770),
    [anon_sym_CARET_EQ] = ACTIONS(2770),
    [anon_sym_PIPE_EQ] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_PIPE] = ACTIONS(2772),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [918] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_RPAREN] = ACTIONS(2770),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_STAR_EQ] = ACTIONS(2770),
    [anon_sym_SLASH_EQ] = ACTIONS(2770),
    [anon_sym_PERCENT_EQ] = ACTIONS(2770),
    [anon_sym_PLUS_EQ] = ACTIONS(2770),
    [anon_sym_DASH_EQ] = ACTIONS(2770),
    [anon_sym_LT_LT_EQ] = ACTIONS(2770),
    [anon_sym_GT_GT_EQ] = ACTIONS(2770),
    [anon_sym_AMP_EQ] = ACTIONS(2770),
    [anon_sym_CARET_EQ] = ACTIONS(2770),
    [anon_sym_PIPE_EQ] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_PIPE] = ACTIONS(2772),
    [anon_sym_CARET] = ACTIONS(2772),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [919] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2778),
    [anon_sym_RPAREN] = ACTIONS(2778),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2780),
    [anon_sym_QMARK] = ACTIONS(2778),
    [anon_sym_STAR_EQ] = ACTIONS(2778),
    [anon_sym_SLASH_EQ] = ACTIONS(2778),
    [anon_sym_PERCENT_EQ] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2778),
    [anon_sym_DASH_EQ] = ACTIONS(2778),
    [anon_sym_LT_LT_EQ] = ACTIONS(2778),
    [anon_sym_GT_GT_EQ] = ACTIONS(2778),
    [anon_sym_AMP_EQ] = ACTIONS(2778),
    [anon_sym_CARET_EQ] = ACTIONS(2778),
    [anon_sym_PIPE_EQ] = ACTIONS(2778),
    [anon_sym_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2778),
    [anon_sym_AMP_AMP] = ACTIONS(2778),
    [anon_sym_PIPE] = ACTIONS(2780),
    [anon_sym_CARET] = ACTIONS(2780),
    [anon_sym_EQ_EQ] = ACTIONS(2778),
    [anon_sym_BANG_EQ] = ACTIONS(2778),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [920] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2782),
    [anon_sym_RPAREN] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2784),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_STAR_EQ] = ACTIONS(2782),
    [anon_sym_SLASH_EQ] = ACTIONS(2782),
    [anon_sym_PERCENT_EQ] = ACTIONS(2782),
    [anon_sym_PLUS_EQ] = ACTIONS(2782),
    [anon_sym_DASH_EQ] = ACTIONS(2782),
    [anon_sym_LT_LT_EQ] = ACTIONS(2782),
    [anon_sym_GT_GT_EQ] = ACTIONS(2782),
    [anon_sym_AMP_EQ] = ACTIONS(2782),
    [anon_sym_CARET_EQ] = ACTIONS(2782),
    [anon_sym_PIPE_EQ] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2784),
    [anon_sym_PIPE_PIPE] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2784),
    [anon_sym_CARET] = ACTIONS(2784),
    [anon_sym_EQ_EQ] = ACTIONS(2782),
    [anon_sym_BANG_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2784),
    [anon_sym_GT] = ACTIONS(2784),
    [anon_sym_LT_EQ] = ACTIONS(2782),
    [anon_sym_GT_EQ] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [921] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2786),
    [anon_sym_RPAREN] = ACTIONS(2786),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2788),
    [anon_sym_QMARK] = ACTIONS(2786),
    [anon_sym_STAR_EQ] = ACTIONS(2786),
    [anon_sym_SLASH_EQ] = ACTIONS(2786),
    [anon_sym_PERCENT_EQ] = ACTIONS(2786),
    [anon_sym_PLUS_EQ] = ACTIONS(2786),
    [anon_sym_DASH_EQ] = ACTIONS(2786),
    [anon_sym_LT_LT_EQ] = ACTIONS(2786),
    [anon_sym_GT_GT_EQ] = ACTIONS(2786),
    [anon_sym_AMP_EQ] = ACTIONS(2786),
    [anon_sym_CARET_EQ] = ACTIONS(2786),
    [anon_sym_PIPE_EQ] = ACTIONS(2786),
    [anon_sym_AMP] = ACTIONS(2788),
    [anon_sym_PIPE_PIPE] = ACTIONS(2786),
    [anon_sym_AMP_AMP] = ACTIONS(2786),
    [anon_sym_PIPE] = ACTIONS(2788),
    [anon_sym_CARET] = ACTIONS(2788),
    [anon_sym_EQ_EQ] = ACTIONS(2786),
    [anon_sym_BANG_EQ] = ACTIONS(2786),
    [anon_sym_LT] = ACTIONS(2788),
    [anon_sym_GT] = ACTIONS(2788),
    [anon_sym_LT_EQ] = ACTIONS(2786),
    [anon_sym_GT_EQ] = ACTIONS(2786),
    [anon_sym_LT_LT] = ACTIONS(2788),
    [anon_sym_GT_GT] = ACTIONS(2788),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [922] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2760),
    [anon_sym_RPAREN] = ACTIONS(2760),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_QMARK] = ACTIONS(2760),
    [anon_sym_STAR_EQ] = ACTIONS(2760),
    [anon_sym_SLASH_EQ] = ACTIONS(2760),
    [anon_sym_PERCENT_EQ] = ACTIONS(2760),
    [anon_sym_PLUS_EQ] = ACTIONS(2760),
    [anon_sym_DASH_EQ] = ACTIONS(2760),
    [anon_sym_LT_LT_EQ] = ACTIONS(2760),
    [anon_sym_GT_GT_EQ] = ACTIONS(2760),
    [anon_sym_AMP_EQ] = ACTIONS(2760),
    [anon_sym_CARET_EQ] = ACTIONS(2760),
    [anon_sym_PIPE_EQ] = ACTIONS(2760),
    [anon_sym_AMP] = ACTIONS(2762),
    [anon_sym_PIPE_PIPE] = ACTIONS(2760),
    [anon_sym_AMP_AMP] = ACTIONS(2760),
    [anon_sym_PIPE] = ACTIONS(2762),
    [anon_sym_CARET] = ACTIONS(2762),
    [anon_sym_EQ_EQ] = ACTIONS(2760),
    [anon_sym_BANG_EQ] = ACTIONS(2760),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_GT] = ACTIONS(2762),
    [anon_sym_LT_EQ] = ACTIONS(2760),
    [anon_sym_GT_EQ] = ACTIONS(2760),
    [anon_sym_LT_LT] = ACTIONS(2762),
    [anon_sym_GT_GT] = ACTIONS(2762),
    [anon_sym_PLUS] = ACTIONS(2762),
    [anon_sym_DASH] = ACTIONS(2762),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [923] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2932),
    [anon_sym_RPAREN] = ACTIONS(2932),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym_RBRACE] = ACTIONS(2932),
    [anon_sym_STAR] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2932),
    [anon_sym_EQ] = ACTIONS(2934),
    [anon_sym_COLON] = ACTIONS(2932),
    [anon_sym_QMARK] = ACTIONS(2932),
    [anon_sym_STAR_EQ] = ACTIONS(2932),
    [anon_sym_SLASH_EQ] = ACTIONS(2932),
    [anon_sym_PERCENT_EQ] = ACTIONS(2932),
    [anon_sym_PLUS_EQ] = ACTIONS(2932),
    [anon_sym_DASH_EQ] = ACTIONS(2932),
    [anon_sym_LT_LT_EQ] = ACTIONS(2932),
    [anon_sym_GT_GT_EQ] = ACTIONS(2932),
    [anon_sym_AMP_EQ] = ACTIONS(2932),
    [anon_sym_CARET_EQ] = ACTIONS(2932),
    [anon_sym_PIPE_EQ] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_PIPE_PIPE] = ACTIONS(2932),
    [anon_sym_AMP_AMP] = ACTIONS(2932),
    [anon_sym_PIPE] = ACTIONS(2934),
    [anon_sym_CARET] = ACTIONS(2934),
    [anon_sym_EQ_EQ] = ACTIONS(2932),
    [anon_sym_BANG_EQ] = ACTIONS(2932),
    [anon_sym_LT] = ACTIONS(2934),
    [anon_sym_GT] = ACTIONS(2934),
    [anon_sym_LT_EQ] = ACTIONS(2932),
    [anon_sym_GT_EQ] = ACTIONS(2932),
    [anon_sym_LT_LT] = ACTIONS(2934),
    [anon_sym_GT_GT] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_SLASH] = ACTIONS(2934),
    [anon_sym_PERCENT] = ACTIONS(2934),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [924] = {
    [anon_sym_LPAREN] = ACTIONS(2936),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_RPAREN] = ACTIONS(2936),
    [anon_sym_SEMI] = ACTIONS(2936),
    [anon_sym_RBRACE] = ACTIONS(2936),
    [anon_sym_STAR] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(2936),
    [anon_sym_RBRACK] = ACTIONS(2936),
    [anon_sym_EQ] = ACTIONS(2938),
    [anon_sym_COLON] = ACTIONS(2936),
    [anon_sym_QMARK] = ACTIONS(2936),
    [anon_sym_STAR_EQ] = ACTIONS(2936),
    [anon_sym_SLASH_EQ] = ACTIONS(2936),
    [anon_sym_PERCENT_EQ] = ACTIONS(2936),
    [anon_sym_PLUS_EQ] = ACTIONS(2936),
    [anon_sym_DASH_EQ] = ACTIONS(2936),
    [anon_sym_LT_LT_EQ] = ACTIONS(2936),
    [anon_sym_GT_GT_EQ] = ACTIONS(2936),
    [anon_sym_AMP_EQ] = ACTIONS(2936),
    [anon_sym_CARET_EQ] = ACTIONS(2936),
    [anon_sym_PIPE_EQ] = ACTIONS(2936),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE] = ACTIONS(2936),
    [anon_sym_AMP_AMP] = ACTIONS(2936),
    [anon_sym_PIPE] = ACTIONS(2938),
    [anon_sym_CARET] = ACTIONS(2938),
    [anon_sym_EQ_EQ] = ACTIONS(2936),
    [anon_sym_BANG_EQ] = ACTIONS(2936),
    [anon_sym_LT] = ACTIONS(2938),
    [anon_sym_GT] = ACTIONS(2938),
    [anon_sym_LT_EQ] = ACTIONS(2936),
    [anon_sym_GT_EQ] = ACTIONS(2936),
    [anon_sym_LT_LT] = ACTIONS(2938),
    [anon_sym_GT_GT] = ACTIONS(2938),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_SLASH] = ACTIONS(2938),
    [anon_sym_PERCENT] = ACTIONS(2938),
    [anon_sym_DASH_DASH] = ACTIONS(2936),
    [anon_sym_PLUS_PLUS] = ACTIONS(2936),
    [anon_sym_DOT] = ACTIONS(2936),
    [anon_sym_DASH_GT] = ACTIONS(2936),
    [sym_comment] = ACTIONS(42),
  },
  [925] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(132),
    [anon_sym_LPAREN] = ACTIONS(130),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(132),
    [sym_preproc_directive] = ACTIONS(132),
    [anon_sym_SEMI] = ACTIONS(130),
    [anon_sym_typedef] = ACTIONS(132),
    [anon_sym_extern] = ACTIONS(132),
    [anon_sym_LBRACE] = ACTIONS(130),
    [anon_sym_STAR] = ACTIONS(130),
    [anon_sym_static] = ACTIONS(132),
    [anon_sym_auto] = ACTIONS(132),
    [anon_sym_register] = ACTIONS(132),
    [anon_sym_inline] = ACTIONS(132),
    [anon_sym_const] = ACTIONS(132),
    [anon_sym_restrict] = ACTIONS(132),
    [anon_sym_volatile] = ACTIONS(132),
    [anon_sym__Atomic] = ACTIONS(132),
    [anon_sym_unsigned] = ACTIONS(132),
    [anon_sym_long] = ACTIONS(132),
    [anon_sym_short] = ACTIONS(132),
    [sym_primitive_type] = ACTIONS(132),
    [anon_sym_enum] = ACTIONS(132),
    [anon_sym_struct] = ACTIONS(132),
    [anon_sym_union] = ACTIONS(132),
    [anon_sym_if] = ACTIONS(132),
    [anon_sym_switch] = ACTIONS(132),
    [anon_sym_case] = ACTIONS(132),
    [anon_sym_default] = ACTIONS(132),
    [anon_sym_while] = ACTIONS(132),
    [anon_sym_do] = ACTIONS(132),
    [anon_sym_for] = ACTIONS(132),
    [anon_sym_return] = ACTIONS(132),
    [anon_sym_break] = ACTIONS(132),
    [anon_sym_continue] = ACTIONS(132),
    [anon_sym_goto] = ACTIONS(132),
    [anon_sym_AMP] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(130),
    [anon_sym_TILDE] = ACTIONS(130),
    [anon_sym_PLUS] = ACTIONS(132),
    [anon_sym_DASH] = ACTIONS(132),
    [anon_sym_DASH_DASH] = ACTIONS(130),
    [anon_sym_PLUS_PLUS] = ACTIONS(130),
    [anon_sym_sizeof] = ACTIONS(132),
    [sym_number_literal] = ACTIONS(130),
    [sym_char_literal] = ACTIONS(130),
    [sym_string_literal] = ACTIONS(130),
    [sym_true] = ACTIONS(132),
    [sym_false] = ACTIONS(132),
    [sym_null] = ACTIONS(132),
    [sym_identifier] = ACTIONS(132),
    [sym_comment] = ACTIONS(42),
  },
  [926] = {
    [sym_preproc_params] = STATE(1092),
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(2940),
    [anon_sym_LF] = ACTIONS(2942),
    [anon_sym_LPAREN] = ACTIONS(138),
    [sym_comment] = ACTIONS(50),
  },
  [927] = {
    [sym_preproc_include] = STATE(1096),
    [sym_preproc_def] = STATE(1096),
    [sym_preproc_function_def] = STATE(1096),
    [sym_preproc_call] = STATE(1096),
    [sym_preproc_if_in_compound_statement] = STATE(713),
    [sym_preproc_ifdef_in_compound_statement] = STATE(714),
    [sym_preproc_else_in_compound_statement] = STATE(1094),
    [sym_preproc_elif_in_compound_statement] = STATE(1095),
    [sym_declaration] = STATE(1096),
    [sym_type_definition] = STATE(1096),
    [sym__declaration_specifiers] = STATE(717),
    [sym_compound_statement] = STATE(1096),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(1096),
    [sym_expression_statement] = STATE(1096),
    [sym_if_statement] = STATE(1096),
    [sym_switch_statement] = STATE(1096),
    [sym_case_statement] = STATE(1096),
    [sym_while_statement] = STATE(1096),
    [sym_do_statement] = STATE(1096),
    [sym_for_statement] = STATE(1096),
    [sym_return_statement] = STATE(1096),
    [sym_break_statement] = STATE(1096),
    [sym_continue_statement] = STATE(1096),
    [sym_goto_statement] = STATE(1096),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym__empty_declaration] = STATE(1096),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1096),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1639),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2944),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1645),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1647),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1651),
    [sym_preproc_directive] = ACTIONS(1653),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_typedef] = ACTIONS(1657),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(42),
  },
  [928] = {
    [sym_preproc_include] = STATE(1100),
    [sym_preproc_def] = STATE(1100),
    [sym_preproc_function_def] = STATE(1100),
    [sym_preproc_call] = STATE(1100),
    [sym_preproc_if_in_compound_statement] = STATE(713),
    [sym_preproc_ifdef_in_compound_statement] = STATE(714),
    [sym_preproc_else_in_compound_statement] = STATE(1098),
    [sym_preproc_elif_in_compound_statement] = STATE(1099),
    [sym_declaration] = STATE(1100),
    [sym_type_definition] = STATE(1100),
    [sym__declaration_specifiers] = STATE(717),
    [sym_compound_statement] = STATE(1100),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(1100),
    [sym_expression_statement] = STATE(1100),
    [sym_if_statement] = STATE(1100),
    [sym_switch_statement] = STATE(1100),
    [sym_case_statement] = STATE(1100),
    [sym_while_statement] = STATE(1100),
    [sym_do_statement] = STATE(1100),
    [sym_for_statement] = STATE(1100),
    [sym_return_statement] = STATE(1100),
    [sym_break_statement] = STATE(1100),
    [sym_continue_statement] = STATE(1100),
    [sym_goto_statement] = STATE(1100),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym__empty_declaration] = STATE(1100),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1100),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1639),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2946),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1645),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1647),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1651),
    [sym_preproc_directive] = ACTIONS(1653),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_typedef] = ACTIONS(1657),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(42),
  },
  [929] = {
    [sym_preproc_include] = STATE(1104),
    [sym_preproc_def] = STATE(1104),
    [sym_preproc_function_def] = STATE(1104),
    [sym_preproc_call] = STATE(1104),
    [sym_preproc_if_in_compound_statement] = STATE(713),
    [sym_preproc_ifdef_in_compound_statement] = STATE(714),
    [sym_preproc_else_in_compound_statement] = STATE(1102),
    [sym_preproc_elif_in_compound_statement] = STATE(1103),
    [sym_declaration] = STATE(1104),
    [sym_type_definition] = STATE(1104),
    [sym__declaration_specifiers] = STATE(717),
    [sym_compound_statement] = STATE(1104),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(1104),
    [sym_expression_statement] = STATE(1104),
    [sym_if_statement] = STATE(1104),
    [sym_switch_statement] = STATE(1104),
    [sym_case_statement] = STATE(1104),
    [sym_while_statement] = STATE(1104),
    [sym_do_statement] = STATE(1104),
    [sym_for_statement] = STATE(1104),
    [sym_return_statement] = STATE(1104),
    [sym_break_statement] = STATE(1104),
    [sym_continue_statement] = STATE(1104),
    [sym_goto_statement] = STATE(1104),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym__empty_declaration] = STATE(1104),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1104),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1639),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2948),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1645),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1647),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1651),
    [sym_preproc_directive] = ACTIONS(1653),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_typedef] = ACTIONS(1657),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(42),
  },
  [930] = {
    [sym_string_literal] = ACTIONS(2950),
    [sym_system_lib_string] = ACTIONS(2950),
    [sym_comment] = ACTIONS(42),
  },
  [931] = {
    [sym_identifier] = ACTIONS(2952),
    [sym_comment] = ACTIONS(42),
  },
  [932] = {
    [sym_preproc_arg] = ACTIONS(2954),
    [sym_comment] = ACTIONS(50),
  },
  [933] = {
    [sym_identifier] = ACTIONS(2956),
    [sym_comment] = ACTIONS(42),
  },
  [934] = {
    [sym_identifier] = ACTIONS(2958),
    [sym_comment] = ACTIONS(42),
  },
  [935] = {
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(2960),
    [anon_sym_LF] = ACTIONS(2962),
    [sym_comment] = ACTIONS(50),
  },
  [936] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1037),
    [sym_preproc_directive] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_typedef] = ACTIONS(1037),
    [anon_sym_extern] = ACTIONS(1037),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_STAR] = ACTIONS(1039),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_auto] = ACTIONS(1037),
    [anon_sym_register] = ACTIONS(1037),
    [anon_sym_inline] = ACTIONS(1037),
    [anon_sym_const] = ACTIONS(1037),
    [anon_sym_restrict] = ACTIONS(1037),
    [anon_sym_volatile] = ACTIONS(1037),
    [anon_sym__Atomic] = ACTIONS(1037),
    [anon_sym_unsigned] = ACTIONS(1037),
    [anon_sym_long] = ACTIONS(1037),
    [anon_sym_short] = ACTIONS(1037),
    [sym_primitive_type] = ACTIONS(1037),
    [anon_sym_enum] = ACTIONS(1037),
    [anon_sym_struct] = ACTIONS(1037),
    [anon_sym_union] = ACTIONS(1037),
    [anon_sym_if] = ACTIONS(1037),
    [anon_sym_switch] = ACTIONS(1037),
    [anon_sym_case] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1037),
    [anon_sym_do] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1037),
    [anon_sym_return] = ACTIONS(1037),
    [anon_sym_break] = ACTIONS(1037),
    [anon_sym_continue] = ACTIONS(1037),
    [anon_sym_goto] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_TILDE] = ACTIONS(1039),
    [anon_sym_PLUS] = ACTIONS(1037),
    [anon_sym_DASH] = ACTIONS(1037),
    [anon_sym_DASH_DASH] = ACTIONS(1039),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_sizeof] = ACTIONS(1037),
    [sym_number_literal] = ACTIONS(1039),
    [sym_char_literal] = ACTIONS(1039),
    [sym_string_literal] = ACTIONS(1039),
    [sym_true] = ACTIONS(1037),
    [sym_false] = ACTIONS(1037),
    [sym_null] = ACTIONS(1037),
    [sym_identifier] = ACTIONS(1037),
    [sym_comment] = ACTIONS(42),
  },
  [937] = {
    [sym_type_qualifier] = STATE(1113),
    [sym__type_specifier] = STATE(1112),
    [sym_sized_type_specifier] = STATE(1112),
    [sym_enum_specifier] = STATE(1112),
    [sym_struct_specifier] = STATE(1112),
    [sym_union_specifier] = STATE(1112),
    [sym_macro_type_specifier] = STATE(1112),
    [aux_sym_type_definition_repeat1] = STATE(1113),
    [aux_sym_sized_type_specifier_repeat1] = STATE(36),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(62),
    [anon_sym_long] = ACTIONS(62),
    [anon_sym_short] = ACTIONS(62),
    [sym_primitive_type] = ACTIONS(2964),
    [anon_sym_enum] = ACTIONS(66),
    [anon_sym_struct] = ACTIONS(68),
    [anon_sym_union] = ACTIONS(70),
    [sym_identifier] = ACTIONS(72),
    [sym_comment] = ACTIONS(42),
  },
  [938] = {
    [sym_preproc_include] = STATE(1115),
    [sym_preproc_def] = STATE(1115),
    [sym_preproc_function_def] = STATE(1115),
    [sym_preproc_call] = STATE(1115),
    [sym_preproc_if_in_compound_statement] = STATE(275),
    [sym_preproc_ifdef_in_compound_statement] = STATE(276),
    [sym_declaration] = STATE(1115),
    [sym_type_definition] = STATE(1115),
    [sym__declaration_specifiers] = STATE(277),
    [sym_compound_statement] = STATE(1115),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(1115),
    [sym_expression_statement] = STATE(1115),
    [sym_if_statement] = STATE(1115),
    [sym_switch_statement] = STATE(1115),
    [sym_case_statement] = STATE(1115),
    [sym_while_statement] = STATE(1115),
    [sym_do_statement] = STATE(1115),
    [sym_for_statement] = STATE(1115),
    [sym_return_statement] = STATE(1115),
    [sym_break_statement] = STATE(1115),
    [sym_continue_statement] = STATE(1115),
    [sym_goto_statement] = STATE(1115),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [sym__empty_declaration] = STATE(1115),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1115),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(577),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(579),
    [sym_preproc_directive] = ACTIONS(581),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_typedef] = ACTIONS(585),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_RBRACE] = ACTIONS(2966),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(631),
    [sym_comment] = ACTIONS(42),
  },
  [939] = {
    [anon_sym_LPAREN] = ACTIONS(2968),
    [sym_comment] = ACTIONS(42),
  },
  [940] = {
    [anon_sym_LPAREN] = ACTIONS(2970),
    [sym_comment] = ACTIONS(42),
  },
  [941] = {
    [sym__expression] = STATE(1118),
    [sym_conditional_expression] = STATE(1118),
    [sym_assignment_expression] = STATE(1118),
    [sym_pointer_expression] = STATE(1118),
    [sym_logical_expression] = STATE(1118),
    [sym_bitwise_expression] = STATE(1118),
    [sym_equality_expression] = STATE(1118),
    [sym_relational_expression] = STATE(1118),
    [sym_shift_expression] = STATE(1118),
    [sym_math_expression] = STATE(1118),
    [sym_cast_expression] = STATE(1118),
    [sym_sizeof_expression] = STATE(1118),
    [sym_subscript_expression] = STATE(1118),
    [sym_call_expression] = STATE(1118),
    [sym_field_expression] = STATE(1118),
    [sym_compound_literal_expression] = STATE(1118),
    [sym_parenthesized_expression] = STATE(1118),
    [sym_concatenated_string] = STATE(1118),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(2972),
    [sym_char_literal] = ACTIONS(2972),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(2974),
    [sym_false] = ACTIONS(2974),
    [sym_null] = ACTIONS(2974),
    [sym_identifier] = ACTIONS(2974),
    [sym_comment] = ACTIONS(42),
  },
  [942] = {
    [anon_sym_COLON] = ACTIONS(2976),
    [sym_comment] = ACTIONS(42),
  },
  [943] = {
    [anon_sym_LPAREN] = ACTIONS(2978),
    [sym_comment] = ACTIONS(42),
  },
  [944] = {
    [sym_compound_statement] = STATE(1121),
    [sym_labeled_statement] = STATE(1121),
    [sym_expression_statement] = STATE(1121),
    [sym_if_statement] = STATE(1121),
    [sym_switch_statement] = STATE(1121),
    [sym_case_statement] = STATE(1121),
    [sym_while_statement] = STATE(1121),
    [sym_do_statement] = STATE(1121),
    [sym_for_statement] = STATE(1121),
    [sym_return_statement] = STATE(1121),
    [sym_break_statement] = STATE(1121),
    [sym_continue_statement] = STATE(1121),
    [sym_goto_statement] = STATE(1121),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_default] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(1089),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1093),
    [sym_comment] = ACTIONS(42),
  },
  [945] = {
    [anon_sym_LPAREN] = ACTIONS(2980),
    [sym_comment] = ACTIONS(42),
  },
  [946] = {
    [sym__expression] = STATE(1124),
    [sym_conditional_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1124),
    [sym_pointer_expression] = STATE(1124),
    [sym_logical_expression] = STATE(1124),
    [sym_bitwise_expression] = STATE(1124),
    [sym_equality_expression] = STATE(1124),
    [sym_relational_expression] = STATE(1124),
    [sym_shift_expression] = STATE(1124),
    [sym_math_expression] = STATE(1124),
    [sym_cast_expression] = STATE(1124),
    [sym_sizeof_expression] = STATE(1124),
    [sym_subscript_expression] = STATE(1124),
    [sym_call_expression] = STATE(1124),
    [sym_field_expression] = STATE(1124),
    [sym_compound_literal_expression] = STATE(1124),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_concatenated_string] = STATE(1124),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(2984),
    [sym_char_literal] = ACTIONS(2984),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(2986),
    [sym_false] = ACTIONS(2986),
    [sym_null] = ACTIONS(2986),
    [sym_identifier] = ACTIONS(2986),
    [sym_comment] = ACTIONS(42),
  },
  [947] = {
    [anon_sym_SEMI] = ACTIONS(2988),
    [sym_comment] = ACTIONS(42),
  },
  [948] = {
    [anon_sym_SEMI] = ACTIONS(2990),
    [sym_comment] = ACTIONS(42),
  },
  [949] = {
    [sym_identifier] = ACTIONS(2992),
    [sym_comment] = ACTIONS(42),
  },
  [950] = {
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1137),
    [anon_sym_extern] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_auto] = ACTIONS(95),
    [anon_sym_register] = ACTIONS(95),
    [anon_sym_inline] = ACTIONS(95),
    [anon_sym_const] = ACTIONS(95),
    [anon_sym_restrict] = ACTIONS(95),
    [anon_sym_volatile] = ACTIONS(95),
    [anon_sym__Atomic] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(2994),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_identifier] = ACTIONS(95),
    [sym_comment] = ACTIONS(42),
  },
  [951] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1145),
    [anon_sym_LPAREN] = ACTIONS(1147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1145),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1145),
    [sym_preproc_directive] = ACTIONS(1145),
    [anon_sym_SEMI] = ACTIONS(1147),
    [anon_sym_typedef] = ACTIONS(1145),
    [anon_sym_extern] = ACTIONS(1145),
    [anon_sym_LBRACE] = ACTIONS(1147),
    [anon_sym_STAR] = ACTIONS(1147),
    [anon_sym_static] = ACTIONS(1145),
    [anon_sym_auto] = ACTIONS(1145),
    [anon_sym_register] = ACTIONS(1145),
    [anon_sym_inline] = ACTIONS(1145),
    [anon_sym_const] = ACTIONS(1145),
    [anon_sym_restrict] = ACTIONS(1145),
    [anon_sym_volatile] = ACTIONS(1145),
    [anon_sym__Atomic] = ACTIONS(1145),
    [anon_sym_unsigned] = ACTIONS(1145),
    [anon_sym_long] = ACTIONS(1145),
    [anon_sym_short] = ACTIONS(1145),
    [sym_primitive_type] = ACTIONS(1145),
    [anon_sym_enum] = ACTIONS(1145),
    [anon_sym_struct] = ACTIONS(1145),
    [anon_sym_union] = ACTIONS(1145),
    [anon_sym_if] = ACTIONS(1145),
    [anon_sym_switch] = ACTIONS(1145),
    [anon_sym_case] = ACTIONS(1145),
    [anon_sym_default] = ACTIONS(1145),
    [anon_sym_while] = ACTIONS(1145),
    [anon_sym_do] = ACTIONS(1145),
    [anon_sym_for] = ACTIONS(1145),
    [anon_sym_return] = ACTIONS(1145),
    [anon_sym_break] = ACTIONS(1145),
    [anon_sym_continue] = ACTIONS(1145),
    [anon_sym_goto] = ACTIONS(1145),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_DASH_DASH] = ACTIONS(1147),
    [anon_sym_PLUS_PLUS] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1147),
    [sym_char_literal] = ACTIONS(1147),
    [sym_string_literal] = ACTIONS(1147),
    [sym_true] = ACTIONS(1145),
    [sym_false] = ACTIONS(1145),
    [sym_null] = ACTIONS(1145),
    [sym_identifier] = ACTIONS(1145),
    [sym_comment] = ACTIONS(42),
  },
  [952] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1149),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1149),
    [sym_preproc_directive] = ACTIONS(1149),
    [anon_sym_SEMI] = ACTIONS(1151),
    [anon_sym_typedef] = ACTIONS(1149),
    [anon_sym_extern] = ACTIONS(1149),
    [anon_sym_LBRACE] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1151),
    [anon_sym_static] = ACTIONS(1149),
    [anon_sym_auto] = ACTIONS(1149),
    [anon_sym_register] = ACTIONS(1149),
    [anon_sym_inline] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_restrict] = ACTIONS(1149),
    [anon_sym_volatile] = ACTIONS(1149),
    [anon_sym__Atomic] = ACTIONS(1149),
    [anon_sym_unsigned] = ACTIONS(1149),
    [anon_sym_long] = ACTIONS(1149),
    [anon_sym_short] = ACTIONS(1149),
    [sym_primitive_type] = ACTIONS(1149),
    [anon_sym_enum] = ACTIONS(1149),
    [anon_sym_struct] = ACTIONS(1149),
    [anon_sym_union] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(1149),
    [anon_sym_switch] = ACTIONS(1149),
    [anon_sym_case] = ACTIONS(1149),
    [anon_sym_default] = ACTIONS(1149),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_do] = ACTIONS(1149),
    [anon_sym_for] = ACTIONS(1149),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_break] = ACTIONS(1149),
    [anon_sym_continue] = ACTIONS(1149),
    [anon_sym_goto] = ACTIONS(1149),
    [anon_sym_AMP] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(1149),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1151),
    [anon_sym_PLUS_PLUS] = ACTIONS(1151),
    [anon_sym_sizeof] = ACTIONS(1149),
    [sym_number_literal] = ACTIONS(1151),
    [sym_char_literal] = ACTIONS(1151),
    [sym_string_literal] = ACTIONS(1151),
    [sym_true] = ACTIONS(1149),
    [sym_false] = ACTIONS(1149),
    [sym_null] = ACTIONS(1149),
    [sym_identifier] = ACTIONS(1149),
    [sym_comment] = ACTIONS(42),
  },
  [953] = {
    [sym__declarator] = STATE(1130),
    [sym_pointer_declarator] = STATE(1130),
    [sym_function_declarator] = STATE(1130),
    [sym_array_declarator] = STATE(1130),
    [sym_init_declarator] = STATE(1131),
    [anon_sym_LPAREN] = ACTIONS(99),
    [anon_sym_SEMI] = ACTIONS(2996),
    [anon_sym_STAR] = ACTIONS(561),
    [sym_identifier] = ACTIONS(2998),
    [sym_comment] = ACTIONS(42),
  },
  [954] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_SEMI] = ACTIONS(3000),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_STAR_EQ] = ACTIONS(1171),
    [anon_sym_SLASH_EQ] = ACTIONS(1171),
    [anon_sym_PERCENT_EQ] = ACTIONS(1171),
    [anon_sym_PLUS_EQ] = ACTIONS(1171),
    [anon_sym_DASH_EQ] = ACTIONS(1171),
    [anon_sym_LT_LT_EQ] = ACTIONS(1171),
    [anon_sym_GT_GT_EQ] = ACTIONS(1171),
    [anon_sym_AMP_EQ] = ACTIONS(1171),
    [anon_sym_CARET_EQ] = ACTIONS(1171),
    [anon_sym_PIPE_EQ] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_PIPE_PIPE] = ACTIONS(1175),
    [anon_sym_AMP_AMP] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_LT] = ACTIONS(1185),
    [anon_sym_GT] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1187),
    [anon_sym_GT_EQ] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1189),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [955] = {
    [anon_sym_SEMI] = ACTIONS(3000),
    [sym_comment] = ACTIONS(42),
  },
  [956] = {
    [sym_preproc_include] = STATE(1133),
    [sym_preproc_def] = STATE(1133),
    [sym_preproc_function_def] = STATE(1133),
    [sym_preproc_call] = STATE(1133),
    [sym_preproc_if_in_compound_statement] = STATE(951),
    [sym_preproc_ifdef_in_compound_statement] = STATE(952),
    [sym_declaration] = STATE(1133),
    [sym_type_definition] = STATE(1133),
    [sym__declaration_specifiers] = STATE(953),
    [sym_compound_statement] = STATE(1133),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(1133),
    [sym_expression_statement] = STATE(1133),
    [sym_if_statement] = STATE(1133),
    [sym_switch_statement] = STATE(1133),
    [sym_case_statement] = STATE(1133),
    [sym_while_statement] = STATE(1133),
    [sym_do_statement] = STATE(1133),
    [sym_for_statement] = STATE(1133),
    [sym_return_statement] = STATE(1133),
    [sym_break_statement] = STATE(1133),
    [sym_continue_statement] = STATE(1133),
    [sym_goto_statement] = STATE(1133),
    [sym__expression] = STATE(954),
    [sym_comma_expression] = STATE(955),
    [sym_conditional_expression] = STATE(954),
    [sym_assignment_expression] = STATE(954),
    [sym_pointer_expression] = STATE(954),
    [sym_logical_expression] = STATE(954),
    [sym_bitwise_expression] = STATE(954),
    [sym_equality_expression] = STATE(954),
    [sym_relational_expression] = STATE(954),
    [sym_shift_expression] = STATE(954),
    [sym_math_expression] = STATE(954),
    [sym_cast_expression] = STATE(954),
    [sym_sizeof_expression] = STATE(954),
    [sym_subscript_expression] = STATE(954),
    [sym_call_expression] = STATE(954),
    [sym_field_expression] = STATE(954),
    [sym_compound_literal_expression] = STATE(954),
    [sym_parenthesized_expression] = STATE(954),
    [sym_concatenated_string] = STATE(954),
    [sym__empty_declaration] = STATE(1133),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1133),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2477),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2479),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2481),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3002),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2485),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2487),
    [sym_preproc_directive] = ACTIONS(2489),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_typedef] = ACTIONS(2493),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(2497),
    [anon_sym_switch] = ACTIONS(2499),
    [anon_sym_case] = ACTIONS(2501),
    [anon_sym_default] = ACTIONS(2503),
    [anon_sym_while] = ACTIONS(2505),
    [anon_sym_do] = ACTIONS(2507),
    [anon_sym_for] = ACTIONS(2509),
    [anon_sym_return] = ACTIONS(2511),
    [anon_sym_break] = ACTIONS(2513),
    [anon_sym_continue] = ACTIONS(2515),
    [anon_sym_goto] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(2519),
    [sym_char_literal] = ACTIONS(2519),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(2521),
    [sym_false] = ACTIONS(2521),
    [sym_null] = ACTIONS(2521),
    [sym_identifier] = ACTIONS(2523),
    [sym_comment] = ACTIONS(42),
  },
  [957] = {
    [sym_preproc_include] = STATE(1136),
    [sym_preproc_def] = STATE(1136),
    [sym_preproc_function_def] = STATE(1136),
    [sym_preproc_call] = STATE(1136),
    [sym_preproc_if_in_compound_statement] = STATE(713),
    [sym_preproc_ifdef_in_compound_statement] = STATE(714),
    [sym_preproc_else_in_compound_statement] = STATE(1134),
    [sym_preproc_elif_in_compound_statement] = STATE(1135),
    [sym_declaration] = STATE(1136),
    [sym_type_definition] = STATE(1136),
    [sym__declaration_specifiers] = STATE(717),
    [sym_compound_statement] = STATE(1136),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(1136),
    [sym_expression_statement] = STATE(1136),
    [sym_if_statement] = STATE(1136),
    [sym_switch_statement] = STATE(1136),
    [sym_case_statement] = STATE(1136),
    [sym_while_statement] = STATE(1136),
    [sym_do_statement] = STATE(1136),
    [sym_for_statement] = STATE(1136),
    [sym_return_statement] = STATE(1136),
    [sym_break_statement] = STATE(1136),
    [sym_continue_statement] = STATE(1136),
    [sym_goto_statement] = STATE(1136),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym__empty_declaration] = STATE(1136),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1136),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1639),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3004),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1645),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1647),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1651),
    [sym_preproc_directive] = ACTIONS(1653),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_typedef] = ACTIONS(1657),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(42),
  },
  [958] = {
    [sym_preproc_arg] = ACTIONS(3006),
    [sym_comment] = ACTIONS(50),
  },
  [959] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(170),
    [anon_sym_LPAREN] = ACTIONS(168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(170),
    [sym_preproc_directive] = ACTIONS(170),
    [anon_sym_SEMI] = ACTIONS(168),
    [anon_sym_typedef] = ACTIONS(170),
    [anon_sym_extern] = ACTIONS(170),
    [anon_sym_LBRACE] = ACTIONS(168),
    [anon_sym_STAR] = ACTIONS(168),
    [anon_sym_static] = ACTIONS(170),
    [anon_sym_auto] = ACTIONS(170),
    [anon_sym_register] = ACTIONS(170),
    [anon_sym_inline] = ACTIONS(170),
    [anon_sym_const] = ACTIONS(170),
    [anon_sym_restrict] = ACTIONS(170),
    [anon_sym_volatile] = ACTIONS(170),
    [anon_sym__Atomic] = ACTIONS(170),
    [anon_sym_unsigned] = ACTIONS(170),
    [anon_sym_long] = ACTIONS(170),
    [anon_sym_short] = ACTIONS(170),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(170),
    [anon_sym_struct] = ACTIONS(170),
    [anon_sym_union] = ACTIONS(170),
    [anon_sym_if] = ACTIONS(170),
    [anon_sym_switch] = ACTIONS(170),
    [anon_sym_case] = ACTIONS(170),
    [anon_sym_default] = ACTIONS(170),
    [anon_sym_while] = ACTIONS(170),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(170),
    [anon_sym_break] = ACTIONS(170),
    [anon_sym_continue] = ACTIONS(170),
    [anon_sym_goto] = ACTIONS(170),
    [anon_sym_AMP] = ACTIONS(168),
    [anon_sym_BANG] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(168),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_DASH_DASH] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(168),
    [anon_sym_sizeof] = ACTIONS(170),
    [sym_number_literal] = ACTIONS(168),
    [sym_char_literal] = ACTIONS(168),
    [sym_string_literal] = ACTIONS(168),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_null] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_comment] = ACTIONS(42),
  },
  [960] = {
    [sym__type_declarator] = STATE(1138),
    [sym_pointer_type_declarator] = STATE(99),
    [sym_function_type_declarator] = STATE(100),
    [sym_array_type_declarator] = STATE(101),
    [anon_sym_LPAREN] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(187),
    [sym_identifier] = ACTIONS(189),
    [sym_comment] = ACTIONS(42),
  },
  [961] = {
    [sym_type_qualifier] = STATE(103),
    [sym__type_specifier] = STATE(1139),
    [sym_sized_type_specifier] = STATE(1139),
    [sym_enum_specifier] = STATE(1139),
    [sym_struct_specifier] = STATE(1139),
    [sym_union_specifier] = STATE(1139),
    [sym_macro_type_specifier] = STATE(1139),
    [aux_sym_type_definition_repeat1] = STATE(103),
    [aux_sym_sized_type_specifier_repeat1] = STATE(36),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(62),
    [anon_sym_long] = ACTIONS(62),
    [anon_sym_short] = ACTIONS(62),
    [sym_primitive_type] = ACTIONS(3008),
    [anon_sym_enum] = ACTIONS(66),
    [anon_sym_struct] = ACTIONS(68),
    [anon_sym_union] = ACTIONS(70),
    [sym_identifier] = ACTIONS(72),
    [sym_comment] = ACTIONS(42),
  },
  [962] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1045),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1047),
    [sym_preproc_directive] = ACTIONS(1047),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_typedef] = ACTIONS(1047),
    [anon_sym_extern] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_auto] = ACTIONS(1047),
    [anon_sym_register] = ACTIONS(1047),
    [anon_sym_inline] = ACTIONS(1047),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_restrict] = ACTIONS(1047),
    [anon_sym_volatile] = ACTIONS(1047),
    [anon_sym__Atomic] = ACTIONS(1047),
    [anon_sym_unsigned] = ACTIONS(1047),
    [anon_sym_long] = ACTIONS(1047),
    [anon_sym_short] = ACTIONS(1047),
    [sym_primitive_type] = ACTIONS(1047),
    [anon_sym_enum] = ACTIONS(1047),
    [anon_sym_struct] = ACTIONS(1047),
    [anon_sym_union] = ACTIONS(1047),
    [anon_sym_if] = ACTIONS(1047),
    [anon_sym_switch] = ACTIONS(1047),
    [anon_sym_case] = ACTIONS(1047),
    [anon_sym_default] = ACTIONS(1047),
    [anon_sym_while] = ACTIONS(1047),
    [anon_sym_do] = ACTIONS(1047),
    [anon_sym_for] = ACTIONS(1047),
    [anon_sym_return] = ACTIONS(1047),
    [anon_sym_break] = ACTIONS(1047),
    [anon_sym_continue] = ACTIONS(1047),
    [anon_sym_goto] = ACTIONS(1047),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_PLUS] = ACTIONS(1047),
    [anon_sym_DASH] = ACTIONS(1047),
    [anon_sym_DASH_DASH] = ACTIONS(1045),
    [anon_sym_PLUS_PLUS] = ACTIONS(1045),
    [anon_sym_sizeof] = ACTIONS(1047),
    [sym_number_literal] = ACTIONS(1045),
    [sym_char_literal] = ACTIONS(1045),
    [sym_string_literal] = ACTIONS(1045),
    [sym_true] = ACTIONS(1047),
    [sym_false] = ACTIONS(1047),
    [sym_null] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [sym_comment] = ACTIONS(42),
  },
  [963] = {
    [sym_preproc_include] = STATE(505),
    [sym_preproc_def] = STATE(505),
    [sym_preproc_function_def] = STATE(505),
    [sym_preproc_call] = STATE(505),
    [sym_preproc_if_in_compound_statement] = STATE(275),
    [sym_preproc_ifdef_in_compound_statement] = STATE(276),
    [sym_declaration] = STATE(505),
    [sym_type_definition] = STATE(505),
    [sym__declaration_specifiers] = STATE(277),
    [sym_compound_statement] = STATE(505),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(505),
    [sym_expression_statement] = STATE(505),
    [sym_if_statement] = STATE(505),
    [sym_switch_statement] = STATE(505),
    [sym_case_statement] = STATE(505),
    [sym_while_statement] = STATE(505),
    [sym_do_statement] = STATE(505),
    [sym_for_statement] = STATE(505),
    [sym_return_statement] = STATE(505),
    [sym_break_statement] = STATE(505),
    [sym_continue_statement] = STATE(505),
    [sym_goto_statement] = STATE(505),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [sym__empty_declaration] = STATE(505),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(505),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(577),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(579),
    [sym_preproc_directive] = ACTIONS(581),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_typedef] = ACTIONS(585),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_RBRACE] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(631),
    [sym_comment] = ACTIONS(42),
  },
  [964] = {
    [sym__expression] = STATE(1141),
    [sym_conditional_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1141),
    [sym_pointer_expression] = STATE(1141),
    [sym_logical_expression] = STATE(1141),
    [sym_bitwise_expression] = STATE(1141),
    [sym_equality_expression] = STATE(1141),
    [sym_relational_expression] = STATE(1141),
    [sym_shift_expression] = STATE(1141),
    [sym_math_expression] = STATE(1141),
    [sym_cast_expression] = STATE(1141),
    [sym_sizeof_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_call_expression] = STATE(1141),
    [sym_field_expression] = STATE(1141),
    [sym_compound_literal_expression] = STATE(1141),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_concatenated_string] = STATE(1141),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(3012),
    [sym_char_literal] = ACTIONS(3012),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(3014),
    [sym_false] = ACTIONS(3014),
    [sym_null] = ACTIONS(3014),
    [sym_identifier] = ACTIONS(3014),
    [sym_comment] = ACTIONS(42),
  },
  [965] = {
    [sym__expression] = STATE(1142),
    [sym_conditional_expression] = STATE(1142),
    [sym_assignment_expression] = STATE(1142),
    [sym_pointer_expression] = STATE(1142),
    [sym_logical_expression] = STATE(1142),
    [sym_bitwise_expression] = STATE(1142),
    [sym_equality_expression] = STATE(1142),
    [sym_relational_expression] = STATE(1142),
    [sym_shift_expression] = STATE(1142),
    [sym_math_expression] = STATE(1142),
    [sym_cast_expression] = STATE(1142),
    [sym_sizeof_expression] = STATE(1142),
    [sym_subscript_expression] = STATE(1142),
    [sym_call_expression] = STATE(1142),
    [sym_field_expression] = STATE(1142),
    [sym_compound_literal_expression] = STATE(1142),
    [sym_parenthesized_expression] = STATE(1142),
    [sym_concatenated_string] = STATE(1142),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(3016),
    [sym_char_literal] = ACTIONS(3016),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [sym_null] = ACTIONS(3018),
    [sym_identifier] = ACTIONS(3018),
    [sym_comment] = ACTIONS(42),
  },
  [966] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1737),
    [anon_sym_COLON] = ACTIONS(3020),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1743),
    [anon_sym_SLASH_EQ] = ACTIONS(1743),
    [anon_sym_PERCENT_EQ] = ACTIONS(1743),
    [anon_sym_PLUS_EQ] = ACTIONS(1743),
    [anon_sym_DASH_EQ] = ACTIONS(1743),
    [anon_sym_LT_LT_EQ] = ACTIONS(1743),
    [anon_sym_GT_GT_EQ] = ACTIONS(1743),
    [anon_sym_AMP_EQ] = ACTIONS(1743),
    [anon_sym_CARET_EQ] = ACTIONS(1743),
    [anon_sym_PIPE_EQ] = ACTIONS(1743),
    [anon_sym_AMP] = ACTIONS(1745),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_AMP_AMP] = ACTIONS(1749),
    [anon_sym_PIPE] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_GT] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [967] = {
    [sym_declaration] = STATE(1145),
    [sym_type_definition] = STATE(1145),
    [sym__declaration_specifiers] = STATE(1146),
    [sym_compound_statement] = STATE(1145),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(1145),
    [sym_expression_statement] = STATE(1145),
    [sym_if_statement] = STATE(1145),
    [sym_switch_statement] = STATE(1145),
    [sym_case_statement] = STATE(1145),
    [sym_while_statement] = STATE(1145),
    [sym_do_statement] = STATE(1145),
    [sym_for_statement] = STATE(1145),
    [sym_return_statement] = STATE(1145),
    [sym_break_statement] = STATE(1145),
    [sym_continue_statement] = STATE(1145),
    [sym_goto_statement] = STATE(1145),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_typedef] = ACTIONS(1657),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(3022),
    [sym_comment] = ACTIONS(42),
  },
  [968] = {
    [sym__expression] = STATE(1147),
    [sym_conditional_expression] = STATE(1147),
    [sym_assignment_expression] = STATE(1147),
    [sym_pointer_expression] = STATE(1147),
    [sym_logical_expression] = STATE(1147),
    [sym_bitwise_expression] = STATE(1147),
    [sym_equality_expression] = STATE(1147),
    [sym_relational_expression] = STATE(1147),
    [sym_shift_expression] = STATE(1147),
    [sym_math_expression] = STATE(1147),
    [sym_cast_expression] = STATE(1147),
    [sym_sizeof_expression] = STATE(1147),
    [sym_subscript_expression] = STATE(1147),
    [sym_call_expression] = STATE(1147),
    [sym_field_expression] = STATE(1147),
    [sym_compound_literal_expression] = STATE(1147),
    [sym_parenthesized_expression] = STATE(1147),
    [sym_concatenated_string] = STATE(1147),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(3024),
    [sym_char_literal] = ACTIONS(3024),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(3026),
    [sym_false] = ACTIONS(3026),
    [sym_null] = ACTIONS(3026),
    [sym_identifier] = ACTIONS(3026),
    [sym_comment] = ACTIONS(42),
  },
  [969] = {
    [anon_sym_while] = ACTIONS(3028),
    [sym_comment] = ACTIONS(42),
  },
  [970] = {
    [sym_declaration] = STATE(1149),
    [sym__declaration_specifiers] = STATE(773),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym__expression] = STATE(1150),
    [sym_conditional_expression] = STATE(1150),
    [sym_assignment_expression] = STATE(1150),
    [sym_pointer_expression] = STATE(1150),
    [sym_logical_expression] = STATE(1150),
    [sym_bitwise_expression] = STATE(1150),
    [sym_equality_expression] = STATE(1150),
    [sym_relational_expression] = STATE(1150),
    [sym_shift_expression] = STATE(1150),
    [sym_math_expression] = STATE(1150),
    [sym_cast_expression] = STATE(1150),
    [sym_sizeof_expression] = STATE(1150),
    [sym_subscript_expression] = STATE(1150),
    [sym_call_expression] = STATE(1150),
    [sym_field_expression] = STATE(1150),
    [sym_compound_literal_expression] = STATE(1150),
    [sym_parenthesized_expression] = STATE(1150),
    [sym_concatenated_string] = STATE(1150),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(3030),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(3032),
    [sym_char_literal] = ACTIONS(3032),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [sym_null] = ACTIONS(3034),
    [sym_identifier] = ACTIONS(1795),
    [sym_comment] = ACTIONS(42),
  },
  [971] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1797),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1797),
    [sym_preproc_directive] = ACTIONS(1797),
    [anon_sym_SEMI] = ACTIONS(1799),
    [anon_sym_typedef] = ACTIONS(1797),
    [anon_sym_extern] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1799),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_static] = ACTIONS(1797),
    [anon_sym_auto] = ACTIONS(1797),
    [anon_sym_register] = ACTIONS(1797),
    [anon_sym_inline] = ACTIONS(1797),
    [anon_sym_const] = ACTIONS(1797),
    [anon_sym_restrict] = ACTIONS(1797),
    [anon_sym_volatile] = ACTIONS(1797),
    [anon_sym__Atomic] = ACTIONS(1797),
    [anon_sym_unsigned] = ACTIONS(1797),
    [anon_sym_long] = ACTIONS(1797),
    [anon_sym_short] = ACTIONS(1797),
    [sym_primitive_type] = ACTIONS(1797),
    [anon_sym_enum] = ACTIONS(1797),
    [anon_sym_struct] = ACTIONS(1797),
    [anon_sym_union] = ACTIONS(1797),
    [anon_sym_if] = ACTIONS(1797),
    [anon_sym_switch] = ACTIONS(1797),
    [anon_sym_case] = ACTIONS(1797),
    [anon_sym_default] = ACTIONS(1797),
    [anon_sym_while] = ACTIONS(1797),
    [anon_sym_do] = ACTIONS(1797),
    [anon_sym_for] = ACTIONS(1797),
    [anon_sym_return] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1797),
    [anon_sym_continue] = ACTIONS(1797),
    [anon_sym_goto] = ACTIONS(1797),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_sizeof] = ACTIONS(1797),
    [sym_number_literal] = ACTIONS(1799),
    [sym_char_literal] = ACTIONS(1799),
    [sym_string_literal] = ACTIONS(1799),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [sym_null] = ACTIONS(1797),
    [sym_identifier] = ACTIONS(1797),
    [sym_comment] = ACTIONS(42),
  },
  [972] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [973] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1803),
    [anon_sym_LPAREN] = ACTIONS(1805),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1803),
    [sym_preproc_directive] = ACTIONS(1803),
    [anon_sym_SEMI] = ACTIONS(1805),
    [anon_sym_typedef] = ACTIONS(1803),
    [anon_sym_extern] = ACTIONS(1803),
    [anon_sym_LBRACE] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_static] = ACTIONS(1803),
    [anon_sym_auto] = ACTIONS(1803),
    [anon_sym_register] = ACTIONS(1803),
    [anon_sym_inline] = ACTIONS(1803),
    [anon_sym_const] = ACTIONS(1803),
    [anon_sym_restrict] = ACTIONS(1803),
    [anon_sym_volatile] = ACTIONS(1803),
    [anon_sym__Atomic] = ACTIONS(1803),
    [anon_sym_unsigned] = ACTIONS(1803),
    [anon_sym_long] = ACTIONS(1803),
    [anon_sym_short] = ACTIONS(1803),
    [sym_primitive_type] = ACTIONS(1803),
    [anon_sym_enum] = ACTIONS(1803),
    [anon_sym_struct] = ACTIONS(1803),
    [anon_sym_union] = ACTIONS(1803),
    [anon_sym_if] = ACTIONS(1803),
    [anon_sym_switch] = ACTIONS(1803),
    [anon_sym_case] = ACTIONS(1803),
    [anon_sym_default] = ACTIONS(1803),
    [anon_sym_while] = ACTIONS(1803),
    [anon_sym_do] = ACTIONS(1803),
    [anon_sym_for] = ACTIONS(1803),
    [anon_sym_return] = ACTIONS(1803),
    [anon_sym_break] = ACTIONS(1803),
    [anon_sym_continue] = ACTIONS(1803),
    [anon_sym_goto] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1803),
    [anon_sym_DASH] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1805),
    [anon_sym_PLUS_PLUS] = ACTIONS(1805),
    [anon_sym_sizeof] = ACTIONS(1803),
    [sym_number_literal] = ACTIONS(1805),
    [sym_char_literal] = ACTIONS(1805),
    [sym_string_literal] = ACTIONS(1805),
    [sym_true] = ACTIONS(1803),
    [sym_false] = ACTIONS(1803),
    [sym_null] = ACTIONS(1803),
    [sym_identifier] = ACTIONS(1803),
    [sym_comment] = ACTIONS(42),
  },
  [974] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1807),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1807),
    [sym_preproc_directive] = ACTIONS(1807),
    [anon_sym_SEMI] = ACTIONS(1809),
    [anon_sym_typedef] = ACTIONS(1807),
    [anon_sym_extern] = ACTIONS(1807),
    [anon_sym_LBRACE] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_static] = ACTIONS(1807),
    [anon_sym_auto] = ACTIONS(1807),
    [anon_sym_register] = ACTIONS(1807),
    [anon_sym_inline] = ACTIONS(1807),
    [anon_sym_const] = ACTIONS(1807),
    [anon_sym_restrict] = ACTIONS(1807),
    [anon_sym_volatile] = ACTIONS(1807),
    [anon_sym__Atomic] = ACTIONS(1807),
    [anon_sym_unsigned] = ACTIONS(1807),
    [anon_sym_long] = ACTIONS(1807),
    [anon_sym_short] = ACTIONS(1807),
    [sym_primitive_type] = ACTIONS(1807),
    [anon_sym_enum] = ACTIONS(1807),
    [anon_sym_struct] = ACTIONS(1807),
    [anon_sym_union] = ACTIONS(1807),
    [anon_sym_if] = ACTIONS(1807),
    [anon_sym_switch] = ACTIONS(1807),
    [anon_sym_case] = ACTIONS(1807),
    [anon_sym_default] = ACTIONS(1807),
    [anon_sym_while] = ACTIONS(1807),
    [anon_sym_do] = ACTIONS(1807),
    [anon_sym_for] = ACTIONS(1807),
    [anon_sym_return] = ACTIONS(1807),
    [anon_sym_break] = ACTIONS(1807),
    [anon_sym_continue] = ACTIONS(1807),
    [anon_sym_goto] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1809),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1809),
    [anon_sym_PLUS_PLUS] = ACTIONS(1809),
    [anon_sym_sizeof] = ACTIONS(1807),
    [sym_number_literal] = ACTIONS(1809),
    [sym_char_literal] = ACTIONS(1809),
    [sym_string_literal] = ACTIONS(1809),
    [sym_true] = ACTIONS(1807),
    [sym_false] = ACTIONS(1807),
    [sym_null] = ACTIONS(1807),
    [sym_identifier] = ACTIONS(1807),
    [sym_comment] = ACTIONS(42),
  },
  [975] = {
    [anon_sym_SEMI] = ACTIONS(3038),
    [sym_comment] = ACTIONS(42),
  },
  [976] = {
    [sym_compound_statement] = STATE(1154),
    [sym_labeled_statement] = STATE(1154),
    [sym_expression_statement] = STATE(1154),
    [sym_if_statement] = STATE(1154),
    [sym_switch_statement] = STATE(1154),
    [sym_case_statement] = STATE(1154),
    [sym_while_statement] = STATE(1154),
    [sym_do_statement] = STATE(1154),
    [sym_for_statement] = STATE(1154),
    [sym_return_statement] = STATE(1154),
    [sym_break_statement] = STATE(1154),
    [sym_continue_statement] = STATE(1154),
    [sym_goto_statement] = STATE(1154),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(3040),
    [sym_comment] = ACTIONS(42),
  },
  [977] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3042),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3042),
    [anon_sym_LPAREN] = ACTIONS(3044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3042),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3042),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3042),
    [sym_preproc_directive] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym_typedef] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3044),
    [anon_sym_RBRACE] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_auto] = ACTIONS(3042),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_struct] = ACTIONS(3042),
    [anon_sym_union] = ACTIONS(3042),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_switch] = ACTIONS(3042),
    [anon_sym_case] = ACTIONS(3042),
    [anon_sym_default] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_for] = ACTIONS(3042),
    [anon_sym_return] = ACTIONS(3042),
    [anon_sym_break] = ACTIONS(3042),
    [anon_sym_continue] = ACTIONS(3042),
    [anon_sym_goto] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3044),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3044),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3044),
    [anon_sym_PLUS_PLUS] = ACTIONS(3044),
    [anon_sym_sizeof] = ACTIONS(3042),
    [sym_number_literal] = ACTIONS(3044),
    [sym_char_literal] = ACTIONS(3044),
    [sym_string_literal] = ACTIONS(3044),
    [sym_true] = ACTIONS(3042),
    [sym_false] = ACTIONS(3042),
    [sym_null] = ACTIONS(3042),
    [sym_identifier] = ACTIONS(3042),
    [sym_comment] = ACTIONS(42),
  },
  [978] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3046),
    [anon_sym_LPAREN] = ACTIONS(3048),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3046),
    [sym_preproc_directive] = ACTIONS(3046),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym_typedef] = ACTIONS(3046),
    [anon_sym_extern] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3048),
    [anon_sym_RBRACE] = ACTIONS(3048),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_static] = ACTIONS(3046),
    [anon_sym_auto] = ACTIONS(3046),
    [anon_sym_register] = ACTIONS(3046),
    [anon_sym_inline] = ACTIONS(3046),
    [anon_sym_const] = ACTIONS(3046),
    [anon_sym_restrict] = ACTIONS(3046),
    [anon_sym_volatile] = ACTIONS(3046),
    [anon_sym__Atomic] = ACTIONS(3046),
    [anon_sym_unsigned] = ACTIONS(3046),
    [anon_sym_long] = ACTIONS(3046),
    [anon_sym_short] = ACTIONS(3046),
    [sym_primitive_type] = ACTIONS(3046),
    [anon_sym_enum] = ACTIONS(3046),
    [anon_sym_struct] = ACTIONS(3046),
    [anon_sym_union] = ACTIONS(3046),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_switch] = ACTIONS(3046),
    [anon_sym_case] = ACTIONS(3046),
    [anon_sym_default] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_for] = ACTIONS(3046),
    [anon_sym_return] = ACTIONS(3046),
    [anon_sym_break] = ACTIONS(3046),
    [anon_sym_continue] = ACTIONS(3046),
    [anon_sym_goto] = ACTIONS(3046),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym_BANG] = ACTIONS(3048),
    [anon_sym_TILDE] = ACTIONS(3048),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_DASH] = ACTIONS(3046),
    [anon_sym_DASH_DASH] = ACTIONS(3048),
    [anon_sym_PLUS_PLUS] = ACTIONS(3048),
    [anon_sym_sizeof] = ACTIONS(3046),
    [sym_number_literal] = ACTIONS(3048),
    [sym_char_literal] = ACTIONS(3048),
    [sym_string_literal] = ACTIONS(3048),
    [sym_true] = ACTIONS(3046),
    [sym_false] = ACTIONS(3046),
    [sym_null] = ACTIONS(3046),
    [sym_identifier] = ACTIONS(3046),
    [sym_comment] = ACTIONS(42),
  },
  [979] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(258),
    [anon_sym_LPAREN] = ACTIONS(256),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(258),
    [sym_preproc_directive] = ACTIONS(258),
    [anon_sym_SEMI] = ACTIONS(256),
    [anon_sym_typedef] = ACTIONS(258),
    [anon_sym_extern] = ACTIONS(258),
    [anon_sym_LBRACE] = ACTIONS(256),
    [anon_sym_STAR] = ACTIONS(256),
    [anon_sym_static] = ACTIONS(258),
    [anon_sym_auto] = ACTIONS(258),
    [anon_sym_register] = ACTIONS(258),
    [anon_sym_inline] = ACTIONS(258),
    [anon_sym_const] = ACTIONS(258),
    [anon_sym_restrict] = ACTIONS(258),
    [anon_sym_volatile] = ACTIONS(258),
    [anon_sym__Atomic] = ACTIONS(258),
    [anon_sym_unsigned] = ACTIONS(258),
    [anon_sym_long] = ACTIONS(258),
    [anon_sym_short] = ACTIONS(258),
    [sym_primitive_type] = ACTIONS(258),
    [anon_sym_enum] = ACTIONS(258),
    [anon_sym_struct] = ACTIONS(258),
    [anon_sym_union] = ACTIONS(258),
    [anon_sym_if] = ACTIONS(258),
    [anon_sym_switch] = ACTIONS(258),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_default] = ACTIONS(258),
    [anon_sym_while] = ACTIONS(258),
    [anon_sym_do] = ACTIONS(258),
    [anon_sym_for] = ACTIONS(258),
    [anon_sym_return] = ACTIONS(258),
    [anon_sym_break] = ACTIONS(258),
    [anon_sym_continue] = ACTIONS(258),
    [anon_sym_goto] = ACTIONS(258),
    [anon_sym_AMP] = ACTIONS(256),
    [anon_sym_BANG] = ACTIONS(256),
    [anon_sym_TILDE] = ACTIONS(256),
    [anon_sym_PLUS] = ACTIONS(258),
    [anon_sym_DASH] = ACTIONS(258),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_sizeof] = ACTIONS(258),
    [sym_number_literal] = ACTIONS(256),
    [sym_char_literal] = ACTIONS(256),
    [sym_string_literal] = ACTIONS(256),
    [sym_true] = ACTIONS(258),
    [sym_false] = ACTIONS(258),
    [sym_null] = ACTIONS(258),
    [sym_identifier] = ACTIONS(258),
    [sym_comment] = ACTIONS(42),
  },
  [980] = {
    [sym_parameter_list] = STATE(145),
    [aux_sym_declaration_repeat1] = STATE(1156),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(270),
    [anon_sym_EQ] = ACTIONS(272),
    [sym_comment] = ACTIONS(42),
  },
  [981] = {
    [aux_sym_declaration_repeat1] = STATE(1156),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(3050),
    [sym_comment] = ACTIONS(42),
  },
  [982] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1849),
    [anon_sym_LPAREN] = ACTIONS(1851),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1849),
    [sym_preproc_directive] = ACTIONS(1849),
    [anon_sym_SEMI] = ACTIONS(1851),
    [anon_sym_typedef] = ACTIONS(1849),
    [anon_sym_extern] = ACTIONS(1849),
    [anon_sym_LBRACE] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1851),
    [anon_sym_static] = ACTIONS(1849),
    [anon_sym_auto] = ACTIONS(1849),
    [anon_sym_register] = ACTIONS(1849),
    [anon_sym_inline] = ACTIONS(1849),
    [anon_sym_const] = ACTIONS(1849),
    [anon_sym_restrict] = ACTIONS(1849),
    [anon_sym_volatile] = ACTIONS(1849),
    [anon_sym__Atomic] = ACTIONS(1849),
    [anon_sym_unsigned] = ACTIONS(1849),
    [anon_sym_long] = ACTIONS(1849),
    [anon_sym_short] = ACTIONS(1849),
    [sym_primitive_type] = ACTIONS(1849),
    [anon_sym_enum] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1849),
    [anon_sym_union] = ACTIONS(1849),
    [anon_sym_if] = ACTIONS(1849),
    [anon_sym_switch] = ACTIONS(1849),
    [anon_sym_case] = ACTIONS(1849),
    [anon_sym_default] = ACTIONS(1849),
    [anon_sym_while] = ACTIONS(1849),
    [anon_sym_do] = ACTIONS(1849),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(1849),
    [anon_sym_break] = ACTIONS(1849),
    [anon_sym_continue] = ACTIONS(1849),
    [anon_sym_goto] = ACTIONS(1849),
    [anon_sym_AMP] = ACTIONS(1851),
    [anon_sym_BANG] = ACTIONS(1851),
    [anon_sym_TILDE] = ACTIONS(1851),
    [anon_sym_PLUS] = ACTIONS(1849),
    [anon_sym_DASH] = ACTIONS(1849),
    [anon_sym_DASH_DASH] = ACTIONS(1851),
    [anon_sym_PLUS_PLUS] = ACTIONS(1851),
    [anon_sym_sizeof] = ACTIONS(1849),
    [sym_number_literal] = ACTIONS(1851),
    [sym_char_literal] = ACTIONS(1851),
    [sym_string_literal] = ACTIONS(1851),
    [sym_true] = ACTIONS(1849),
    [sym_false] = ACTIONS(1849),
    [sym_null] = ACTIONS(1849),
    [sym_identifier] = ACTIONS(1849),
    [sym_comment] = ACTIONS(42),
  },
  [983] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3052),
    [anon_sym_LPAREN] = ACTIONS(3054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3052),
    [sym_preproc_directive] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3054),
    [anon_sym_typedef] = ACTIONS(3052),
    [anon_sym_extern] = ACTIONS(3052),
    [anon_sym_LBRACE] = ACTIONS(3054),
    [anon_sym_RBRACE] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3054),
    [anon_sym_static] = ACTIONS(3052),
    [anon_sym_auto] = ACTIONS(3052),
    [anon_sym_register] = ACTIONS(3052),
    [anon_sym_inline] = ACTIONS(3052),
    [anon_sym_const] = ACTIONS(3052),
    [anon_sym_restrict] = ACTIONS(3052),
    [anon_sym_volatile] = ACTIONS(3052),
    [anon_sym__Atomic] = ACTIONS(3052),
    [anon_sym_unsigned] = ACTIONS(3052),
    [anon_sym_long] = ACTIONS(3052),
    [anon_sym_short] = ACTIONS(3052),
    [sym_primitive_type] = ACTIONS(3052),
    [anon_sym_enum] = ACTIONS(3052),
    [anon_sym_struct] = ACTIONS(3052),
    [anon_sym_union] = ACTIONS(3052),
    [anon_sym_if] = ACTIONS(3052),
    [anon_sym_switch] = ACTIONS(3052),
    [anon_sym_case] = ACTIONS(3052),
    [anon_sym_default] = ACTIONS(3052),
    [anon_sym_while] = ACTIONS(3052),
    [anon_sym_do] = ACTIONS(3052),
    [anon_sym_for] = ACTIONS(3052),
    [anon_sym_return] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3052),
    [anon_sym_continue] = ACTIONS(3052),
    [anon_sym_goto] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_TILDE] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3052),
    [anon_sym_DASH_DASH] = ACTIONS(3054),
    [anon_sym_PLUS_PLUS] = ACTIONS(3054),
    [anon_sym_sizeof] = ACTIONS(3052),
    [sym_number_literal] = ACTIONS(3054),
    [sym_char_literal] = ACTIONS(3054),
    [sym_string_literal] = ACTIONS(3054),
    [sym_true] = ACTIONS(3052),
    [sym_false] = ACTIONS(3052),
    [sym_null] = ACTIONS(3052),
    [sym_identifier] = ACTIONS(3052),
    [sym_comment] = ACTIONS(42),
  },
  [984] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3056),
    [sym_comment] = ACTIONS(42),
  },
  [985] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3058),
    [sym_comment] = ACTIONS(42),
  },
  [986] = {
    [sym_preproc_include] = STATE(986),
    [sym_preproc_def] = STATE(986),
    [sym_preproc_function_def] = STATE(986),
    [sym_preproc_call] = STATE(986),
    [sym_preproc_if_in_compound_statement] = STATE(713),
    [sym_preproc_ifdef_in_compound_statement] = STATE(714),
    [sym_declaration] = STATE(986),
    [sym_type_definition] = STATE(986),
    [sym__declaration_specifiers] = STATE(717),
    [sym_compound_statement] = STATE(986),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(986),
    [sym_expression_statement] = STATE(986),
    [sym_if_statement] = STATE(986),
    [sym_switch_statement] = STATE(986),
    [sym_case_statement] = STATE(986),
    [sym_while_statement] = STATE(986),
    [sym_do_statement] = STATE(986),
    [sym_for_statement] = STATE(986),
    [sym_return_statement] = STATE(986),
    [sym_break_statement] = STATE(986),
    [sym_continue_statement] = STATE(986),
    [sym_goto_statement] = STATE(986),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym__empty_declaration] = STATE(986),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(986),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3060),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3063),
    [anon_sym_LPAREN] = ACTIONS(1921),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3066),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3069),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3071),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3074),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3069),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3069),
    [sym_preproc_directive] = ACTIONS(3077),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_typedef] = ACTIONS(3083),
    [anon_sym_extern] = ACTIONS(1942),
    [anon_sym_LBRACE] = ACTIONS(3086),
    [anon_sym_STAR] = ACTIONS(1950),
    [anon_sym_static] = ACTIONS(1942),
    [anon_sym_auto] = ACTIONS(1942),
    [anon_sym_register] = ACTIONS(1942),
    [anon_sym_inline] = ACTIONS(1942),
    [anon_sym_const] = ACTIONS(1953),
    [anon_sym_restrict] = ACTIONS(1953),
    [anon_sym_volatile] = ACTIONS(1953),
    [anon_sym__Atomic] = ACTIONS(1953),
    [anon_sym_unsigned] = ACTIONS(1956),
    [anon_sym_long] = ACTIONS(1956),
    [anon_sym_short] = ACTIONS(1956),
    [sym_primitive_type] = ACTIONS(1959),
    [anon_sym_enum] = ACTIONS(1962),
    [anon_sym_struct] = ACTIONS(1965),
    [anon_sym_union] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(3089),
    [anon_sym_switch] = ACTIONS(3092),
    [anon_sym_case] = ACTIONS(3095),
    [anon_sym_default] = ACTIONS(3098),
    [anon_sym_while] = ACTIONS(3101),
    [anon_sym_do] = ACTIONS(3104),
    [anon_sym_for] = ACTIONS(3107),
    [anon_sym_return] = ACTIONS(3110),
    [anon_sym_break] = ACTIONS(3113),
    [anon_sym_continue] = ACTIONS(3116),
    [anon_sym_goto] = ACTIONS(3119),
    [anon_sym_AMP] = ACTIONS(1950),
    [anon_sym_BANG] = ACTIONS(2004),
    [anon_sym_TILDE] = ACTIONS(2007),
    [anon_sym_PLUS] = ACTIONS(2010),
    [anon_sym_DASH] = ACTIONS(2010),
    [anon_sym_DASH_DASH] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2013),
    [anon_sym_sizeof] = ACTIONS(2016),
    [sym_number_literal] = ACTIONS(3122),
    [sym_char_literal] = ACTIONS(3122),
    [sym_string_literal] = ACTIONS(2022),
    [sym_true] = ACTIONS(3125),
    [sym_false] = ACTIONS(3125),
    [sym_null] = ACTIONS(3125),
    [sym_identifier] = ACTIONS(3128),
    [sym_comment] = ACTIONS(42),
  },
  [987] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3131),
    [anon_sym_LPAREN] = ACTIONS(3133),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3131),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym_typedef] = ACTIONS(3131),
    [anon_sym_extern] = ACTIONS(3131),
    [anon_sym_LBRACE] = ACTIONS(3133),
    [anon_sym_RBRACE] = ACTIONS(3133),
    [anon_sym_STAR] = ACTIONS(3133),
    [anon_sym_static] = ACTIONS(3131),
    [anon_sym_auto] = ACTIONS(3131),
    [anon_sym_register] = ACTIONS(3131),
    [anon_sym_inline] = ACTIONS(3131),
    [anon_sym_const] = ACTIONS(3131),
    [anon_sym_restrict] = ACTIONS(3131),
    [anon_sym_volatile] = ACTIONS(3131),
    [anon_sym__Atomic] = ACTIONS(3131),
    [anon_sym_unsigned] = ACTIONS(3131),
    [anon_sym_long] = ACTIONS(3131),
    [anon_sym_short] = ACTIONS(3131),
    [sym_primitive_type] = ACTIONS(3131),
    [anon_sym_enum] = ACTIONS(3131),
    [anon_sym_struct] = ACTIONS(3131),
    [anon_sym_union] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(3131),
    [anon_sym_switch] = ACTIONS(3131),
    [anon_sym_case] = ACTIONS(3131),
    [anon_sym_default] = ACTIONS(3131),
    [anon_sym_while] = ACTIONS(3131),
    [anon_sym_do] = ACTIONS(3131),
    [anon_sym_for] = ACTIONS(3131),
    [anon_sym_return] = ACTIONS(3131),
    [anon_sym_break] = ACTIONS(3131),
    [anon_sym_continue] = ACTIONS(3131),
    [anon_sym_goto] = ACTIONS(3131),
    [anon_sym_AMP] = ACTIONS(3133),
    [anon_sym_BANG] = ACTIONS(3133),
    [anon_sym_TILDE] = ACTIONS(3133),
    [anon_sym_PLUS] = ACTIONS(3131),
    [anon_sym_DASH] = ACTIONS(3131),
    [anon_sym_DASH_DASH] = ACTIONS(3133),
    [anon_sym_PLUS_PLUS] = ACTIONS(3133),
    [anon_sym_sizeof] = ACTIONS(3131),
    [sym_number_literal] = ACTIONS(3133),
    [sym_char_literal] = ACTIONS(3133),
    [sym_string_literal] = ACTIONS(3133),
    [sym_true] = ACTIONS(3131),
    [sym_false] = ACTIONS(3131),
    [sym_null] = ACTIONS(3131),
    [sym_identifier] = ACTIONS(3131),
    [sym_comment] = ACTIONS(42),
  },
  [988] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3135),
    [anon_sym_LPAREN] = ACTIONS(3137),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3135),
    [sym_preproc_directive] = ACTIONS(3135),
    [anon_sym_SEMI] = ACTIONS(3137),
    [anon_sym_typedef] = ACTIONS(3135),
    [anon_sym_extern] = ACTIONS(3135),
    [anon_sym_LBRACE] = ACTIONS(3137),
    [anon_sym_RBRACE] = ACTIONS(3137),
    [anon_sym_STAR] = ACTIONS(3137),
    [anon_sym_static] = ACTIONS(3135),
    [anon_sym_auto] = ACTIONS(3135),
    [anon_sym_register] = ACTIONS(3135),
    [anon_sym_inline] = ACTIONS(3135),
    [anon_sym_const] = ACTIONS(3135),
    [anon_sym_restrict] = ACTIONS(3135),
    [anon_sym_volatile] = ACTIONS(3135),
    [anon_sym__Atomic] = ACTIONS(3135),
    [anon_sym_unsigned] = ACTIONS(3135),
    [anon_sym_long] = ACTIONS(3135),
    [anon_sym_short] = ACTIONS(3135),
    [sym_primitive_type] = ACTIONS(3135),
    [anon_sym_enum] = ACTIONS(3135),
    [anon_sym_struct] = ACTIONS(3135),
    [anon_sym_union] = ACTIONS(3135),
    [anon_sym_if] = ACTIONS(3135),
    [anon_sym_switch] = ACTIONS(3135),
    [anon_sym_case] = ACTIONS(3135),
    [anon_sym_default] = ACTIONS(3135),
    [anon_sym_while] = ACTIONS(3135),
    [anon_sym_do] = ACTIONS(3135),
    [anon_sym_for] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3135),
    [anon_sym_break] = ACTIONS(3135),
    [anon_sym_continue] = ACTIONS(3135),
    [anon_sym_goto] = ACTIONS(3135),
    [anon_sym_AMP] = ACTIONS(3137),
    [anon_sym_BANG] = ACTIONS(3137),
    [anon_sym_TILDE] = ACTIONS(3137),
    [anon_sym_PLUS] = ACTIONS(3135),
    [anon_sym_DASH] = ACTIONS(3135),
    [anon_sym_DASH_DASH] = ACTIONS(3137),
    [anon_sym_PLUS_PLUS] = ACTIONS(3137),
    [anon_sym_sizeof] = ACTIONS(3135),
    [sym_number_literal] = ACTIONS(3137),
    [sym_char_literal] = ACTIONS(3137),
    [sym_string_literal] = ACTIONS(3137),
    [sym_true] = ACTIONS(3135),
    [sym_false] = ACTIONS(3135),
    [sym_null] = ACTIONS(3135),
    [sym_identifier] = ACTIONS(3135),
    [sym_comment] = ACTIONS(42),
  },
  [989] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3139),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3139),
    [anon_sym_LPAREN] = ACTIONS(3141),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3139),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3139),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3139),
    [sym_preproc_directive] = ACTIONS(3139),
    [anon_sym_SEMI] = ACTIONS(3141),
    [anon_sym_typedef] = ACTIONS(3139),
    [anon_sym_extern] = ACTIONS(3139),
    [anon_sym_LBRACE] = ACTIONS(3141),
    [anon_sym_RBRACE] = ACTIONS(3141),
    [anon_sym_STAR] = ACTIONS(3141),
    [anon_sym_static] = ACTIONS(3139),
    [anon_sym_auto] = ACTIONS(3139),
    [anon_sym_register] = ACTIONS(3139),
    [anon_sym_inline] = ACTIONS(3139),
    [anon_sym_const] = ACTIONS(3139),
    [anon_sym_restrict] = ACTIONS(3139),
    [anon_sym_volatile] = ACTIONS(3139),
    [anon_sym__Atomic] = ACTIONS(3139),
    [anon_sym_unsigned] = ACTIONS(3139),
    [anon_sym_long] = ACTIONS(3139),
    [anon_sym_short] = ACTIONS(3139),
    [sym_primitive_type] = ACTIONS(3139),
    [anon_sym_enum] = ACTIONS(3139),
    [anon_sym_struct] = ACTIONS(3139),
    [anon_sym_union] = ACTIONS(3139),
    [anon_sym_if] = ACTIONS(3139),
    [anon_sym_switch] = ACTIONS(3139),
    [anon_sym_case] = ACTIONS(3139),
    [anon_sym_default] = ACTIONS(3139),
    [anon_sym_while] = ACTIONS(3139),
    [anon_sym_do] = ACTIONS(3139),
    [anon_sym_for] = ACTIONS(3139),
    [anon_sym_return] = ACTIONS(3139),
    [anon_sym_break] = ACTIONS(3139),
    [anon_sym_continue] = ACTIONS(3139),
    [anon_sym_goto] = ACTIONS(3139),
    [anon_sym_AMP] = ACTIONS(3141),
    [anon_sym_BANG] = ACTIONS(3141),
    [anon_sym_TILDE] = ACTIONS(3141),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_DASH_DASH] = ACTIONS(3141),
    [anon_sym_PLUS_PLUS] = ACTIONS(3141),
    [anon_sym_sizeof] = ACTIONS(3139),
    [sym_number_literal] = ACTIONS(3141),
    [sym_char_literal] = ACTIONS(3141),
    [sym_string_literal] = ACTIONS(3141),
    [sym_true] = ACTIONS(3139),
    [sym_false] = ACTIONS(3139),
    [sym_null] = ACTIONS(3139),
    [sym_identifier] = ACTIONS(3139),
    [sym_comment] = ACTIONS(42),
  },
  [990] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3143),
    [sym_comment] = ACTIONS(42),
  },
  [991] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3145),
    [sym_comment] = ACTIONS(42),
  },
  [992] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3147),
    [anon_sym_LPAREN] = ACTIONS(3149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3147),
    [sym_preproc_directive] = ACTIONS(3147),
    [anon_sym_SEMI] = ACTIONS(3149),
    [anon_sym_typedef] = ACTIONS(3147),
    [anon_sym_extern] = ACTIONS(3147),
    [anon_sym_LBRACE] = ACTIONS(3149),
    [anon_sym_RBRACE] = ACTIONS(3149),
    [anon_sym_STAR] = ACTIONS(3149),
    [anon_sym_static] = ACTIONS(3147),
    [anon_sym_auto] = ACTIONS(3147),
    [anon_sym_register] = ACTIONS(3147),
    [anon_sym_inline] = ACTIONS(3147),
    [anon_sym_const] = ACTIONS(3147),
    [anon_sym_restrict] = ACTIONS(3147),
    [anon_sym_volatile] = ACTIONS(3147),
    [anon_sym__Atomic] = ACTIONS(3147),
    [anon_sym_unsigned] = ACTIONS(3147),
    [anon_sym_long] = ACTIONS(3147),
    [anon_sym_short] = ACTIONS(3147),
    [sym_primitive_type] = ACTIONS(3147),
    [anon_sym_enum] = ACTIONS(3147),
    [anon_sym_struct] = ACTIONS(3147),
    [anon_sym_union] = ACTIONS(3147),
    [anon_sym_if] = ACTIONS(3147),
    [anon_sym_switch] = ACTIONS(3147),
    [anon_sym_case] = ACTIONS(3147),
    [anon_sym_default] = ACTIONS(3147),
    [anon_sym_while] = ACTIONS(3147),
    [anon_sym_do] = ACTIONS(3147),
    [anon_sym_for] = ACTIONS(3147),
    [anon_sym_return] = ACTIONS(3147),
    [anon_sym_break] = ACTIONS(3147),
    [anon_sym_continue] = ACTIONS(3147),
    [anon_sym_goto] = ACTIONS(3147),
    [anon_sym_AMP] = ACTIONS(3149),
    [anon_sym_BANG] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3149),
    [anon_sym_PLUS] = ACTIONS(3147),
    [anon_sym_DASH] = ACTIONS(3147),
    [anon_sym_DASH_DASH] = ACTIONS(3149),
    [anon_sym_PLUS_PLUS] = ACTIONS(3149),
    [anon_sym_sizeof] = ACTIONS(3147),
    [sym_number_literal] = ACTIONS(3149),
    [sym_char_literal] = ACTIONS(3149),
    [sym_string_literal] = ACTIONS(3149),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [sym_null] = ACTIONS(3147),
    [sym_identifier] = ACTIONS(3147),
    [sym_comment] = ACTIONS(42),
  },
  [993] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3151),
    [anon_sym_LPAREN] = ACTIONS(3153),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3151),
    [sym_preproc_directive] = ACTIONS(3151),
    [anon_sym_SEMI] = ACTIONS(3153),
    [anon_sym_typedef] = ACTIONS(3151),
    [anon_sym_extern] = ACTIONS(3151),
    [anon_sym_LBRACE] = ACTIONS(3153),
    [anon_sym_RBRACE] = ACTIONS(3153),
    [anon_sym_STAR] = ACTIONS(3153),
    [anon_sym_static] = ACTIONS(3151),
    [anon_sym_auto] = ACTIONS(3151),
    [anon_sym_register] = ACTIONS(3151),
    [anon_sym_inline] = ACTIONS(3151),
    [anon_sym_const] = ACTIONS(3151),
    [anon_sym_restrict] = ACTIONS(3151),
    [anon_sym_volatile] = ACTIONS(3151),
    [anon_sym__Atomic] = ACTIONS(3151),
    [anon_sym_unsigned] = ACTIONS(3151),
    [anon_sym_long] = ACTIONS(3151),
    [anon_sym_short] = ACTIONS(3151),
    [sym_primitive_type] = ACTIONS(3151),
    [anon_sym_enum] = ACTIONS(3151),
    [anon_sym_struct] = ACTIONS(3151),
    [anon_sym_union] = ACTIONS(3151),
    [anon_sym_if] = ACTIONS(3151),
    [anon_sym_switch] = ACTIONS(3151),
    [anon_sym_case] = ACTIONS(3151),
    [anon_sym_default] = ACTIONS(3151),
    [anon_sym_while] = ACTIONS(3151),
    [anon_sym_do] = ACTIONS(3151),
    [anon_sym_for] = ACTIONS(3151),
    [anon_sym_return] = ACTIONS(3151),
    [anon_sym_break] = ACTIONS(3151),
    [anon_sym_continue] = ACTIONS(3151),
    [anon_sym_goto] = ACTIONS(3151),
    [anon_sym_AMP] = ACTIONS(3153),
    [anon_sym_BANG] = ACTIONS(3153),
    [anon_sym_TILDE] = ACTIONS(3153),
    [anon_sym_PLUS] = ACTIONS(3151),
    [anon_sym_DASH] = ACTIONS(3151),
    [anon_sym_DASH_DASH] = ACTIONS(3153),
    [anon_sym_PLUS_PLUS] = ACTIONS(3153),
    [anon_sym_sizeof] = ACTIONS(3151),
    [sym_number_literal] = ACTIONS(3153),
    [sym_char_literal] = ACTIONS(3153),
    [sym_string_literal] = ACTIONS(3153),
    [sym_true] = ACTIONS(3151),
    [sym_false] = ACTIONS(3151),
    [sym_null] = ACTIONS(3151),
    [sym_identifier] = ACTIONS(3151),
    [sym_comment] = ACTIONS(42),
  },
  [994] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3155),
    [anon_sym_LPAREN] = ACTIONS(3157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3155),
    [sym_preproc_directive] = ACTIONS(3155),
    [anon_sym_SEMI] = ACTIONS(3157),
    [anon_sym_typedef] = ACTIONS(3155),
    [anon_sym_extern] = ACTIONS(3155),
    [anon_sym_LBRACE] = ACTIONS(3157),
    [anon_sym_RBRACE] = ACTIONS(3157),
    [anon_sym_STAR] = ACTIONS(3157),
    [anon_sym_static] = ACTIONS(3155),
    [anon_sym_auto] = ACTIONS(3155),
    [anon_sym_register] = ACTIONS(3155),
    [anon_sym_inline] = ACTIONS(3155),
    [anon_sym_const] = ACTIONS(3155),
    [anon_sym_restrict] = ACTIONS(3155),
    [anon_sym_volatile] = ACTIONS(3155),
    [anon_sym__Atomic] = ACTIONS(3155),
    [anon_sym_unsigned] = ACTIONS(3155),
    [anon_sym_long] = ACTIONS(3155),
    [anon_sym_short] = ACTIONS(3155),
    [sym_primitive_type] = ACTIONS(3155),
    [anon_sym_enum] = ACTIONS(3155),
    [anon_sym_struct] = ACTIONS(3155),
    [anon_sym_union] = ACTIONS(3155),
    [anon_sym_if] = ACTIONS(3155),
    [anon_sym_switch] = ACTIONS(3155),
    [anon_sym_case] = ACTIONS(3155),
    [anon_sym_default] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(3155),
    [anon_sym_do] = ACTIONS(3155),
    [anon_sym_for] = ACTIONS(3155),
    [anon_sym_return] = ACTIONS(3155),
    [anon_sym_break] = ACTIONS(3155),
    [anon_sym_continue] = ACTIONS(3155),
    [anon_sym_goto] = ACTIONS(3155),
    [anon_sym_AMP] = ACTIONS(3157),
    [anon_sym_BANG] = ACTIONS(3157),
    [anon_sym_TILDE] = ACTIONS(3157),
    [anon_sym_PLUS] = ACTIONS(3155),
    [anon_sym_DASH] = ACTIONS(3155),
    [anon_sym_DASH_DASH] = ACTIONS(3157),
    [anon_sym_PLUS_PLUS] = ACTIONS(3157),
    [anon_sym_sizeof] = ACTIONS(3155),
    [sym_number_literal] = ACTIONS(3157),
    [sym_char_literal] = ACTIONS(3157),
    [sym_string_literal] = ACTIONS(3157),
    [sym_true] = ACTIONS(3155),
    [sym_false] = ACTIONS(3155),
    [sym_null] = ACTIONS(3155),
    [sym_identifier] = ACTIONS(3155),
    [sym_comment] = ACTIONS(42),
  },
  [995] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3159),
    [sym_comment] = ACTIONS(42),
  },
  [996] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3161),
    [sym_comment] = ACTIONS(42),
  },
  [997] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(799),
    [sym_preproc_directive] = ACTIONS(799),
    [anon_sym_SEMI] = ACTIONS(797),
    [anon_sym_typedef] = ACTIONS(799),
    [anon_sym_extern] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(797),
    [anon_sym_RBRACE] = ACTIONS(797),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_static] = ACTIONS(799),
    [anon_sym_auto] = ACTIONS(799),
    [anon_sym_register] = ACTIONS(799),
    [anon_sym_inline] = ACTIONS(799),
    [anon_sym_const] = ACTIONS(799),
    [anon_sym_restrict] = ACTIONS(799),
    [anon_sym_volatile] = ACTIONS(799),
    [anon_sym__Atomic] = ACTIONS(799),
    [anon_sym_unsigned] = ACTIONS(799),
    [anon_sym_long] = ACTIONS(799),
    [anon_sym_short] = ACTIONS(799),
    [sym_primitive_type] = ACTIONS(799),
    [anon_sym_enum] = ACTIONS(799),
    [anon_sym_struct] = ACTIONS(799),
    [anon_sym_union] = ACTIONS(799),
    [anon_sym_if] = ACTIONS(799),
    [anon_sym_switch] = ACTIONS(799),
    [anon_sym_case] = ACTIONS(799),
    [anon_sym_default] = ACTIONS(799),
    [anon_sym_while] = ACTIONS(799),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(799),
    [anon_sym_break] = ACTIONS(799),
    [anon_sym_continue] = ACTIONS(799),
    [anon_sym_goto] = ACTIONS(799),
    [anon_sym_AMP] = ACTIONS(797),
    [anon_sym_BANG] = ACTIONS(797),
    [anon_sym_TILDE] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
    [anon_sym_sizeof] = ACTIONS(799),
    [sym_number_literal] = ACTIONS(797),
    [sym_char_literal] = ACTIONS(797),
    [sym_string_literal] = ACTIONS(797),
    [sym_true] = ACTIONS(799),
    [sym_false] = ACTIONS(799),
    [sym_null] = ACTIONS(799),
    [sym_identifier] = ACTIONS(799),
    [sym_comment] = ACTIONS(42),
  },
  [998] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(813),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(815),
    [sym_preproc_directive] = ACTIONS(815),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_typedef] = ACTIONS(815),
    [anon_sym_extern] = ACTIONS(815),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(813),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_auto] = ACTIONS(815),
    [anon_sym_register] = ACTIONS(815),
    [anon_sym_inline] = ACTIONS(815),
    [anon_sym_const] = ACTIONS(815),
    [anon_sym_restrict] = ACTIONS(815),
    [anon_sym_volatile] = ACTIONS(815),
    [anon_sym__Atomic] = ACTIONS(815),
    [anon_sym_unsigned] = ACTIONS(815),
    [anon_sym_long] = ACTIONS(815),
    [anon_sym_short] = ACTIONS(815),
    [sym_primitive_type] = ACTIONS(815),
    [anon_sym_enum] = ACTIONS(815),
    [anon_sym_struct] = ACTIONS(815),
    [anon_sym_union] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(815),
    [anon_sym_switch] = ACTIONS(815),
    [anon_sym_case] = ACTIONS(815),
    [anon_sym_default] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(815),
    [anon_sym_do] = ACTIONS(815),
    [anon_sym_for] = ACTIONS(815),
    [anon_sym_return] = ACTIONS(815),
    [anon_sym_break] = ACTIONS(815),
    [anon_sym_continue] = ACTIONS(815),
    [anon_sym_goto] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_sizeof] = ACTIONS(815),
    [sym_number_literal] = ACTIONS(813),
    [sym_char_literal] = ACTIONS(813),
    [sym_string_literal] = ACTIONS(813),
    [sym_true] = ACTIONS(815),
    [sym_false] = ACTIONS(815),
    [sym_null] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_comment] = ACTIONS(42),
  },
  [999] = {
    [sym_parameter_list] = STATE(200),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_SEMI] = ACTIONS(3163),
    [anon_sym_LBRACK] = ACTIONS(449),
    [sym_comment] = ACTIONS(42),
  },
  [1000] = {
    [anon_sym_RPAREN] = ACTIONS(3165),
    [sym_comment] = ACTIONS(42),
  },
  [1001] = {
    [sym_type_qualifier] = STATE(133),
    [sym__type_specifier] = STATE(131),
    [sym_sized_type_specifier] = STATE(131),
    [sym_enum_specifier] = STATE(131),
    [sym_struct_specifier] = STATE(131),
    [sym_union_specifier] = STATE(131),
    [sym__expression] = STATE(436),
    [sym_comma_expression] = STATE(437),
    [sym_conditional_expression] = STATE(436),
    [sym_assignment_expression] = STATE(436),
    [sym_pointer_expression] = STATE(436),
    [sym_logical_expression] = STATE(436),
    [sym_bitwise_expression] = STATE(436),
    [sym_equality_expression] = STATE(436),
    [sym_relational_expression] = STATE(436),
    [sym_shift_expression] = STATE(436),
    [sym_math_expression] = STATE(436),
    [sym_cast_expression] = STATE(436),
    [sym_type_descriptor] = STATE(1165),
    [sym_sizeof_expression] = STATE(436),
    [sym_subscript_expression] = STATE(436),
    [sym_call_expression] = STATE(436),
    [sym_field_expression] = STATE(436),
    [sym_compound_literal_expression] = STATE(436),
    [sym_parenthesized_expression] = STATE(436),
    [sym_concatenated_string] = STATE(436),
    [sym_macro_type_specifier] = STATE(131),
    [aux_sym_type_definition_repeat1] = STATE(133),
    [aux_sym_sized_type_specifier_repeat1] = STATE(134),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(248),
    [anon_sym_long] = ACTIONS(248),
    [anon_sym_short] = ACTIONS(248),
    [sym_primitive_type] = ACTIONS(250),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1019),
    [sym_char_literal] = ACTIONS(1019),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(1023),
    [sym_false] = ACTIONS(1023),
    [sym_null] = ACTIONS(1023),
    [sym_identifier] = ACTIONS(1025),
    [sym_comment] = ACTIONS(42),
  },
  [1002] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(1825),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1827),
    [anon_sym_QMARK] = ACTIONS(1825),
    [anon_sym_STAR_EQ] = ACTIONS(1825),
    [anon_sym_SLASH_EQ] = ACTIONS(1825),
    [anon_sym_PERCENT_EQ] = ACTIONS(1825),
    [anon_sym_PLUS_EQ] = ACTIONS(1825),
    [anon_sym_DASH_EQ] = ACTIONS(1825),
    [anon_sym_LT_LT_EQ] = ACTIONS(1825),
    [anon_sym_GT_GT_EQ] = ACTIONS(1825),
    [anon_sym_AMP_EQ] = ACTIONS(1825),
    [anon_sym_CARET_EQ] = ACTIONS(1825),
    [anon_sym_PIPE_EQ] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1827),
    [anon_sym_PIPE_PIPE] = ACTIONS(1825),
    [anon_sym_AMP_AMP] = ACTIONS(1825),
    [anon_sym_PIPE] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1827),
    [anon_sym_EQ_EQ] = ACTIONS(1825),
    [anon_sym_BANG_EQ] = ACTIONS(1825),
    [anon_sym_LT] = ACTIONS(1827),
    [anon_sym_GT] = ACTIONS(1827),
    [anon_sym_LT_EQ] = ACTIONS(1825),
    [anon_sym_GT_EQ] = ACTIONS(1825),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1003] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1166),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_RPAREN] = ACTIONS(1829),
    [anon_sym_STAR] = ACTIONS(1831),
    [anon_sym_LBRACK] = ACTIONS(1829),
    [anon_sym_EQ] = ACTIONS(1831),
    [anon_sym_QMARK] = ACTIONS(1829),
    [anon_sym_STAR_EQ] = ACTIONS(1829),
    [anon_sym_SLASH_EQ] = ACTIONS(1829),
    [anon_sym_PERCENT_EQ] = ACTIONS(1829),
    [anon_sym_PLUS_EQ] = ACTIONS(1829),
    [anon_sym_DASH_EQ] = ACTIONS(1829),
    [anon_sym_LT_LT_EQ] = ACTIONS(1829),
    [anon_sym_GT_GT_EQ] = ACTIONS(1829),
    [anon_sym_AMP_EQ] = ACTIONS(1829),
    [anon_sym_CARET_EQ] = ACTIONS(1829),
    [anon_sym_PIPE_EQ] = ACTIONS(1829),
    [anon_sym_AMP] = ACTIONS(1831),
    [anon_sym_PIPE_PIPE] = ACTIONS(1829),
    [anon_sym_AMP_AMP] = ACTIONS(1829),
    [anon_sym_PIPE] = ACTIONS(1831),
    [anon_sym_CARET] = ACTIONS(1831),
    [anon_sym_EQ_EQ] = ACTIONS(1829),
    [anon_sym_BANG_EQ] = ACTIONS(1829),
    [anon_sym_LT] = ACTIONS(1831),
    [anon_sym_GT] = ACTIONS(1831),
    [anon_sym_LT_EQ] = ACTIONS(1829),
    [anon_sym_GT_EQ] = ACTIONS(1829),
    [anon_sym_LT_LT] = ACTIONS(1831),
    [anon_sym_GT_GT] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_SLASH] = ACTIONS(1831),
    [anon_sym_PERCENT] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1829),
    [anon_sym_PLUS_PLUS] = ACTIONS(1829),
    [anon_sym_DOT] = ACTIONS(1829),
    [anon_sym_DASH_GT] = ACTIONS(1829),
    [sym_string_literal] = ACTIONS(3167),
    [sym_comment] = ACTIONS(42),
  },
  [1004] = {
    [sym_compound_statement] = STATE(1181),
    [sym_labeled_statement] = STATE(1181),
    [sym_expression_statement] = STATE(1181),
    [sym_if_statement] = STATE(1181),
    [sym_switch_statement] = STATE(1181),
    [sym_case_statement] = STATE(1181),
    [sym_while_statement] = STATE(1181),
    [sym_do_statement] = STATE(1181),
    [sym_for_statement] = STATE(1181),
    [sym_return_statement] = STATE(1181),
    [sym_break_statement] = STATE(1181),
    [sym_continue_statement] = STATE(1181),
    [sym_goto_statement] = STATE(1181),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3173),
    [anon_sym_switch] = ACTIONS(3175),
    [anon_sym_case] = ACTIONS(3177),
    [anon_sym_default] = ACTIONS(3179),
    [anon_sym_while] = ACTIONS(3181),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3185),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3199),
    [sym_comment] = ACTIONS(42),
  },
  [1005] = {
    [sym__expression] = STATE(787),
    [sym_conditional_expression] = STATE(787),
    [sym_assignment_expression] = STATE(787),
    [sym_pointer_expression] = STATE(787),
    [sym_logical_expression] = STATE(787),
    [sym_bitwise_expression] = STATE(787),
    [sym_equality_expression] = STATE(787),
    [sym_relational_expression] = STATE(787),
    [sym_shift_expression] = STATE(787),
    [sym_math_expression] = STATE(787),
    [sym_cast_expression] = STATE(787),
    [sym_sizeof_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_call_expression] = STATE(787),
    [sym_field_expression] = STATE(787),
    [sym_compound_literal_expression] = STATE(787),
    [sym_parenthesized_expression] = STATE(787),
    [sym_concatenated_string] = STATE(787),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(1853),
    [sym_char_literal] = ACTIONS(1853),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(1855),
    [sym_false] = ACTIONS(1855),
    [sym_null] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_comment] = ACTIONS(42),
  },
  [1006] = {
    [sym__expression] = STATE(1184),
    [sym_conditional_expression] = STATE(1184),
    [sym_assignment_expression] = STATE(1184),
    [sym_pointer_expression] = STATE(1184),
    [sym_logical_expression] = STATE(1184),
    [sym_bitwise_expression] = STATE(1184),
    [sym_equality_expression] = STATE(1184),
    [sym_relational_expression] = STATE(1184),
    [sym_shift_expression] = STATE(1184),
    [sym_math_expression] = STATE(1184),
    [sym_cast_expression] = STATE(1184),
    [sym_sizeof_expression] = STATE(1184),
    [sym_subscript_expression] = STATE(1184),
    [sym_call_expression] = STATE(1184),
    [sym_field_expression] = STATE(1184),
    [sym_compound_literal_expression] = STATE(1184),
    [sym_parenthesized_expression] = STATE(1184),
    [sym_concatenated_string] = STATE(1184),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(3201),
    [sym_char_literal] = ACTIONS(3201),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(3203),
    [sym_false] = ACTIONS(3203),
    [sym_null] = ACTIONS(3203),
    [sym_identifier] = ACTIONS(3203),
    [sym_comment] = ACTIONS(42),
  },
  [1007] = {
    [sym__expression] = STATE(1185),
    [sym_conditional_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1185),
    [sym_pointer_expression] = STATE(1185),
    [sym_logical_expression] = STATE(1185),
    [sym_bitwise_expression] = STATE(1185),
    [sym_equality_expression] = STATE(1185),
    [sym_relational_expression] = STATE(1185),
    [sym_shift_expression] = STATE(1185),
    [sym_math_expression] = STATE(1185),
    [sym_cast_expression] = STATE(1185),
    [sym_sizeof_expression] = STATE(1185),
    [sym_subscript_expression] = STATE(1185),
    [sym_call_expression] = STATE(1185),
    [sym_field_expression] = STATE(1185),
    [sym_compound_literal_expression] = STATE(1185),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_concatenated_string] = STATE(1185),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(3205),
    [sym_char_literal] = ACTIONS(3205),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [sym_null] = ACTIONS(3207),
    [sym_identifier] = ACTIONS(3207),
    [sym_comment] = ACTIONS(42),
  },
  [1008] = {
    [sym__expression] = STATE(1186),
    [sym_conditional_expression] = STATE(1186),
    [sym_assignment_expression] = STATE(1186),
    [sym_pointer_expression] = STATE(1186),
    [sym_logical_expression] = STATE(1186),
    [sym_bitwise_expression] = STATE(1186),
    [sym_equality_expression] = STATE(1186),
    [sym_relational_expression] = STATE(1186),
    [sym_shift_expression] = STATE(1186),
    [sym_math_expression] = STATE(1186),
    [sym_cast_expression] = STATE(1186),
    [sym_sizeof_expression] = STATE(1186),
    [sym_subscript_expression] = STATE(1186),
    [sym_call_expression] = STATE(1186),
    [sym_field_expression] = STATE(1186),
    [sym_compound_literal_expression] = STATE(1186),
    [sym_parenthesized_expression] = STATE(1186),
    [sym_concatenated_string] = STATE(1186),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(3209),
    [sym_char_literal] = ACTIONS(3209),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(3211),
    [sym_false] = ACTIONS(3211),
    [sym_null] = ACTIONS(3211),
    [sym_identifier] = ACTIONS(3211),
    [sym_comment] = ACTIONS(42),
  },
  [1009] = {
    [sym__expression] = STATE(1187),
    [sym_conditional_expression] = STATE(1187),
    [sym_assignment_expression] = STATE(1187),
    [sym_pointer_expression] = STATE(1187),
    [sym_logical_expression] = STATE(1187),
    [sym_bitwise_expression] = STATE(1187),
    [sym_equality_expression] = STATE(1187),
    [sym_relational_expression] = STATE(1187),
    [sym_shift_expression] = STATE(1187),
    [sym_math_expression] = STATE(1187),
    [sym_cast_expression] = STATE(1187),
    [sym_sizeof_expression] = STATE(1187),
    [sym_subscript_expression] = STATE(1187),
    [sym_call_expression] = STATE(1187),
    [sym_field_expression] = STATE(1187),
    [sym_compound_literal_expression] = STATE(1187),
    [sym_parenthesized_expression] = STATE(1187),
    [sym_concatenated_string] = STATE(1187),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(3213),
    [sym_char_literal] = ACTIONS(3213),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(3215),
    [sym_false] = ACTIONS(3215),
    [sym_null] = ACTIONS(3215),
    [sym_identifier] = ACTIONS(3215),
    [sym_comment] = ACTIONS(42),
  },
  [1010] = {
    [sym__expression] = STATE(1188),
    [sym_conditional_expression] = STATE(1188),
    [sym_assignment_expression] = STATE(1188),
    [sym_pointer_expression] = STATE(1188),
    [sym_logical_expression] = STATE(1188),
    [sym_bitwise_expression] = STATE(1188),
    [sym_equality_expression] = STATE(1188),
    [sym_relational_expression] = STATE(1188),
    [sym_shift_expression] = STATE(1188),
    [sym_math_expression] = STATE(1188),
    [sym_cast_expression] = STATE(1188),
    [sym_sizeof_expression] = STATE(1188),
    [sym_subscript_expression] = STATE(1188),
    [sym_call_expression] = STATE(1188),
    [sym_field_expression] = STATE(1188),
    [sym_compound_literal_expression] = STATE(1188),
    [sym_parenthesized_expression] = STATE(1188),
    [sym_concatenated_string] = STATE(1188),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(3217),
    [sym_char_literal] = ACTIONS(3217),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(3219),
    [sym_false] = ACTIONS(3219),
    [sym_null] = ACTIONS(3219),
    [sym_identifier] = ACTIONS(3219),
    [sym_comment] = ACTIONS(42),
  },
  [1011] = {
    [sym__expression] = STATE(1189),
    [sym_conditional_expression] = STATE(1189),
    [sym_assignment_expression] = STATE(1189),
    [sym_pointer_expression] = STATE(1189),
    [sym_logical_expression] = STATE(1189),
    [sym_bitwise_expression] = STATE(1189),
    [sym_equality_expression] = STATE(1189),
    [sym_relational_expression] = STATE(1189),
    [sym_shift_expression] = STATE(1189),
    [sym_math_expression] = STATE(1189),
    [sym_cast_expression] = STATE(1189),
    [sym_sizeof_expression] = STATE(1189),
    [sym_subscript_expression] = STATE(1189),
    [sym_call_expression] = STATE(1189),
    [sym_field_expression] = STATE(1189),
    [sym_compound_literal_expression] = STATE(1189),
    [sym_parenthesized_expression] = STATE(1189),
    [sym_concatenated_string] = STATE(1189),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(3221),
    [sym_char_literal] = ACTIONS(3221),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(3223),
    [sym_false] = ACTIONS(3223),
    [sym_null] = ACTIONS(3223),
    [sym_identifier] = ACTIONS(3223),
    [sym_comment] = ACTIONS(42),
  },
  [1012] = {
    [sym__expression] = STATE(1190),
    [sym_conditional_expression] = STATE(1190),
    [sym_assignment_expression] = STATE(1190),
    [sym_pointer_expression] = STATE(1190),
    [sym_logical_expression] = STATE(1190),
    [sym_bitwise_expression] = STATE(1190),
    [sym_equality_expression] = STATE(1190),
    [sym_relational_expression] = STATE(1190),
    [sym_shift_expression] = STATE(1190),
    [sym_math_expression] = STATE(1190),
    [sym_cast_expression] = STATE(1190),
    [sym_sizeof_expression] = STATE(1190),
    [sym_subscript_expression] = STATE(1190),
    [sym_call_expression] = STATE(1190),
    [sym_field_expression] = STATE(1190),
    [sym_compound_literal_expression] = STATE(1190),
    [sym_parenthesized_expression] = STATE(1190),
    [sym_concatenated_string] = STATE(1190),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(3225),
    [sym_char_literal] = ACTIONS(3225),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(3227),
    [sym_false] = ACTIONS(3227),
    [sym_null] = ACTIONS(3227),
    [sym_identifier] = ACTIONS(3227),
    [sym_comment] = ACTIONS(42),
  },
  [1013] = {
    [sym__expression] = STATE(1191),
    [sym_conditional_expression] = STATE(1191),
    [sym_assignment_expression] = STATE(1191),
    [sym_pointer_expression] = STATE(1191),
    [sym_logical_expression] = STATE(1191),
    [sym_bitwise_expression] = STATE(1191),
    [sym_equality_expression] = STATE(1191),
    [sym_relational_expression] = STATE(1191),
    [sym_shift_expression] = STATE(1191),
    [sym_math_expression] = STATE(1191),
    [sym_cast_expression] = STATE(1191),
    [sym_sizeof_expression] = STATE(1191),
    [sym_subscript_expression] = STATE(1191),
    [sym_call_expression] = STATE(1191),
    [sym_field_expression] = STATE(1191),
    [sym_compound_literal_expression] = STATE(1191),
    [sym_parenthesized_expression] = STATE(1191),
    [sym_concatenated_string] = STATE(1191),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(3229),
    [sym_char_literal] = ACTIONS(3229),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(3231),
    [sym_false] = ACTIONS(3231),
    [sym_null] = ACTIONS(3231),
    [sym_identifier] = ACTIONS(3231),
    [sym_comment] = ACTIONS(42),
  },
  [1014] = {
    [sym__expression] = STATE(1192),
    [sym_conditional_expression] = STATE(1192),
    [sym_assignment_expression] = STATE(1192),
    [sym_pointer_expression] = STATE(1192),
    [sym_logical_expression] = STATE(1192),
    [sym_bitwise_expression] = STATE(1192),
    [sym_equality_expression] = STATE(1192),
    [sym_relational_expression] = STATE(1192),
    [sym_shift_expression] = STATE(1192),
    [sym_math_expression] = STATE(1192),
    [sym_cast_expression] = STATE(1192),
    [sym_sizeof_expression] = STATE(1192),
    [sym_subscript_expression] = STATE(1192),
    [sym_call_expression] = STATE(1192),
    [sym_field_expression] = STATE(1192),
    [sym_compound_literal_expression] = STATE(1192),
    [sym_parenthesized_expression] = STATE(1192),
    [sym_concatenated_string] = STATE(1192),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(3233),
    [sym_char_literal] = ACTIONS(3233),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(3235),
    [sym_false] = ACTIONS(3235),
    [sym_null] = ACTIONS(3235),
    [sym_identifier] = ACTIONS(3235),
    [sym_comment] = ACTIONS(42),
  },
  [1015] = {
    [sym__expression] = STATE(1193),
    [sym_conditional_expression] = STATE(1193),
    [sym_assignment_expression] = STATE(1193),
    [sym_pointer_expression] = STATE(1193),
    [sym_logical_expression] = STATE(1193),
    [sym_bitwise_expression] = STATE(1193),
    [sym_equality_expression] = STATE(1193),
    [sym_relational_expression] = STATE(1193),
    [sym_shift_expression] = STATE(1193),
    [sym_math_expression] = STATE(1193),
    [sym_cast_expression] = STATE(1193),
    [sym_sizeof_expression] = STATE(1193),
    [sym_subscript_expression] = STATE(1193),
    [sym_call_expression] = STATE(1193),
    [sym_field_expression] = STATE(1193),
    [sym_compound_literal_expression] = STATE(1193),
    [sym_parenthesized_expression] = STATE(1193),
    [sym_concatenated_string] = STATE(1193),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(3237),
    [sym_char_literal] = ACTIONS(3237),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [sym_null] = ACTIONS(3239),
    [sym_identifier] = ACTIONS(3239),
    [sym_comment] = ACTIONS(42),
  },
  [1016] = {
    [sym__expression] = STATE(1194),
    [sym_conditional_expression] = STATE(1194),
    [sym_assignment_expression] = STATE(1194),
    [sym_pointer_expression] = STATE(1194),
    [sym_logical_expression] = STATE(1194),
    [sym_bitwise_expression] = STATE(1194),
    [sym_equality_expression] = STATE(1194),
    [sym_relational_expression] = STATE(1194),
    [sym_shift_expression] = STATE(1194),
    [sym_math_expression] = STATE(1194),
    [sym_cast_expression] = STATE(1194),
    [sym_sizeof_expression] = STATE(1194),
    [sym_subscript_expression] = STATE(1194),
    [sym_call_expression] = STATE(1194),
    [sym_field_expression] = STATE(1194),
    [sym_compound_literal_expression] = STATE(1194),
    [sym_parenthesized_expression] = STATE(1194),
    [sym_concatenated_string] = STATE(1194),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(3241),
    [sym_char_literal] = ACTIONS(3241),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(3243),
    [sym_false] = ACTIONS(3243),
    [sym_null] = ACTIONS(3243),
    [sym_identifier] = ACTIONS(3243),
    [sym_comment] = ACTIONS(42),
  },
  [1017] = {
    [sym_compound_statement] = STATE(1195),
    [sym_labeled_statement] = STATE(1195),
    [sym_expression_statement] = STATE(1195),
    [sym_if_statement] = STATE(1195),
    [sym_switch_statement] = STATE(1195),
    [sym_case_statement] = STATE(1195),
    [sym_while_statement] = STATE(1195),
    [sym_do_statement] = STATE(1195),
    [sym_for_statement] = STATE(1195),
    [sym_return_statement] = STATE(1195),
    [sym_break_statement] = STATE(1195),
    [sym_continue_statement] = STATE(1195),
    [sym_goto_statement] = STATE(1195),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1835),
    [sym_comment] = ACTIONS(42),
  },
  [1018] = {
    [sym__expression] = STATE(923),
    [sym_conditional_expression] = STATE(923),
    [sym_assignment_expression] = STATE(923),
    [sym_pointer_expression] = STATE(923),
    [sym_logical_expression] = STATE(923),
    [sym_bitwise_expression] = STATE(923),
    [sym_equality_expression] = STATE(923),
    [sym_relational_expression] = STATE(923),
    [sym_shift_expression] = STATE(923),
    [sym_math_expression] = STATE(923),
    [sym_cast_expression] = STATE(923),
    [sym_sizeof_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_call_expression] = STATE(923),
    [sym_field_expression] = STATE(923),
    [sym_compound_literal_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(923),
    [sym_initializer_list] = STATE(924),
    [sym_concatenated_string] = STATE(923),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(2459),
    [sym_char_literal] = ACTIONS(2459),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(2461),
    [sym_false] = ACTIONS(2461),
    [sym_null] = ACTIONS(2461),
    [sym_identifier] = ACTIONS(2461),
    [sym_comment] = ACTIONS(42),
  },
  [1019] = {
    [anon_sym_RPAREN] = ACTIONS(3245),
    [sym_comment] = ACTIONS(42),
  },
  [1020] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1020),
    [anon_sym_LPAREN] = ACTIONS(2737),
    [anon_sym_STAR] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2737),
    [anon_sym_EQ] = ACTIONS(2739),
    [anon_sym_COLON] = ACTIONS(2737),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2737),
    [anon_sym_SLASH_EQ] = ACTIONS(2737),
    [anon_sym_PERCENT_EQ] = ACTIONS(2737),
    [anon_sym_PLUS_EQ] = ACTIONS(2737),
    [anon_sym_DASH_EQ] = ACTIONS(2737),
    [anon_sym_LT_LT_EQ] = ACTIONS(2737),
    [anon_sym_GT_GT_EQ] = ACTIONS(2737),
    [anon_sym_AMP_EQ] = ACTIONS(2737),
    [anon_sym_CARET_EQ] = ACTIONS(2737),
    [anon_sym_PIPE_EQ] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2739),
    [anon_sym_PIPE_PIPE] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_PIPE] = ACTIONS(2739),
    [anon_sym_CARET] = ACTIONS(2739),
    [anon_sym_EQ_EQ] = ACTIONS(2737),
    [anon_sym_BANG_EQ] = ACTIONS(2737),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_GT] = ACTIONS(2739),
    [anon_sym_LT_EQ] = ACTIONS(2737),
    [anon_sym_GT_EQ] = ACTIONS(2737),
    [anon_sym_LT_LT] = ACTIONS(2739),
    [anon_sym_GT_GT] = ACTIONS(2739),
    [anon_sym_PLUS] = ACTIONS(2739),
    [anon_sym_DASH] = ACTIONS(2739),
    [anon_sym_SLASH] = ACTIONS(2739),
    [anon_sym_PERCENT] = ACTIONS(2739),
    [anon_sym_DASH_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_PLUS] = ACTIONS(2737),
    [anon_sym_DOT] = ACTIONS(2737),
    [anon_sym_DASH_GT] = ACTIONS(2737),
    [sym_string_literal] = ACTIONS(3247),
    [sym_comment] = ACTIONS(42),
  },
  [1021] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1737),
    [anon_sym_COLON] = ACTIONS(2766),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_STAR_EQ] = ACTIONS(1743),
    [anon_sym_SLASH_EQ] = ACTIONS(1743),
    [anon_sym_PERCENT_EQ] = ACTIONS(1743),
    [anon_sym_PLUS_EQ] = ACTIONS(1743),
    [anon_sym_DASH_EQ] = ACTIONS(1743),
    [anon_sym_LT_LT_EQ] = ACTIONS(1743),
    [anon_sym_GT_GT_EQ] = ACTIONS(1743),
    [anon_sym_AMP_EQ] = ACTIONS(1743),
    [anon_sym_CARET_EQ] = ACTIONS(1743),
    [anon_sym_PIPE_EQ] = ACTIONS(1743),
    [anon_sym_AMP] = ACTIONS(1745),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_AMP_AMP] = ACTIONS(1749),
    [anon_sym_PIPE] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_GT] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1022] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3250),
    [anon_sym_LPAREN] = ACTIONS(3252),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3250),
    [sym_preproc_directive] = ACTIONS(3250),
    [anon_sym_SEMI] = ACTIONS(3252),
    [anon_sym_typedef] = ACTIONS(3250),
    [anon_sym_extern] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3252),
    [anon_sym_RBRACE] = ACTIONS(3252),
    [anon_sym_STAR] = ACTIONS(3252),
    [anon_sym_static] = ACTIONS(3250),
    [anon_sym_auto] = ACTIONS(3250),
    [anon_sym_register] = ACTIONS(3250),
    [anon_sym_inline] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(3250),
    [anon_sym_restrict] = ACTIONS(3250),
    [anon_sym_volatile] = ACTIONS(3250),
    [anon_sym__Atomic] = ACTIONS(3250),
    [anon_sym_unsigned] = ACTIONS(3250),
    [anon_sym_long] = ACTIONS(3250),
    [anon_sym_short] = ACTIONS(3250),
    [sym_primitive_type] = ACTIONS(3250),
    [anon_sym_enum] = ACTIONS(3250),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_union] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_switch] = ACTIONS(3250),
    [anon_sym_case] = ACTIONS(3250),
    [anon_sym_default] = ACTIONS(3250),
    [anon_sym_while] = ACTIONS(3250),
    [anon_sym_do] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_goto] = ACTIONS(3250),
    [anon_sym_AMP] = ACTIONS(3252),
    [anon_sym_BANG] = ACTIONS(3252),
    [anon_sym_TILDE] = ACTIONS(3252),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3252),
    [anon_sym_PLUS_PLUS] = ACTIONS(3252),
    [anon_sym_sizeof] = ACTIONS(3250),
    [sym_number_literal] = ACTIONS(3252),
    [sym_char_literal] = ACTIONS(3252),
    [sym_string_literal] = ACTIONS(3252),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [sym_null] = ACTIONS(3250),
    [sym_identifier] = ACTIONS(3250),
    [sym_comment] = ACTIONS(42),
  },
  [1023] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1737),
    [anon_sym_COLON] = ACTIONS(3254),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1743),
    [anon_sym_SLASH_EQ] = ACTIONS(1743),
    [anon_sym_PERCENT_EQ] = ACTIONS(1743),
    [anon_sym_PLUS_EQ] = ACTIONS(1743),
    [anon_sym_DASH_EQ] = ACTIONS(1743),
    [anon_sym_LT_LT_EQ] = ACTIONS(1743),
    [anon_sym_GT_GT_EQ] = ACTIONS(1743),
    [anon_sym_AMP_EQ] = ACTIONS(1743),
    [anon_sym_CARET_EQ] = ACTIONS(1743),
    [anon_sym_PIPE_EQ] = ACTIONS(1743),
    [anon_sym_AMP] = ACTIONS(1745),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_AMP_AMP] = ACTIONS(1749),
    [anon_sym_PIPE] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_GT] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1024] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_COLON] = ACTIONS(2770),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_STAR_EQ] = ACTIONS(2770),
    [anon_sym_SLASH_EQ] = ACTIONS(2770),
    [anon_sym_PERCENT_EQ] = ACTIONS(2770),
    [anon_sym_PLUS_EQ] = ACTIONS(2770),
    [anon_sym_DASH_EQ] = ACTIONS(2770),
    [anon_sym_LT_LT_EQ] = ACTIONS(2770),
    [anon_sym_GT_GT_EQ] = ACTIONS(2770),
    [anon_sym_AMP_EQ] = ACTIONS(2770),
    [anon_sym_CARET_EQ] = ACTIONS(2770),
    [anon_sym_PIPE_EQ] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2772),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_PIPE] = ACTIONS(2772),
    [anon_sym_CARET] = ACTIONS(2772),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_GT] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1025] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2776),
    [anon_sym_COLON] = ACTIONS(2774),
    [anon_sym_QMARK] = ACTIONS(2774),
    [anon_sym_STAR_EQ] = ACTIONS(2774),
    [anon_sym_SLASH_EQ] = ACTIONS(2774),
    [anon_sym_PERCENT_EQ] = ACTIONS(2774),
    [anon_sym_PLUS_EQ] = ACTIONS(2774),
    [anon_sym_DASH_EQ] = ACTIONS(2774),
    [anon_sym_LT_LT_EQ] = ACTIONS(2774),
    [anon_sym_GT_GT_EQ] = ACTIONS(2774),
    [anon_sym_AMP_EQ] = ACTIONS(2774),
    [anon_sym_CARET_EQ] = ACTIONS(2774),
    [anon_sym_PIPE_EQ] = ACTIONS(2774),
    [anon_sym_AMP] = ACTIONS(1745),
    [anon_sym_PIPE_PIPE] = ACTIONS(2774),
    [anon_sym_AMP_AMP] = ACTIONS(1749),
    [anon_sym_PIPE] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_GT] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1026] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2776),
    [anon_sym_COLON] = ACTIONS(2774),
    [anon_sym_QMARK] = ACTIONS(2774),
    [anon_sym_STAR_EQ] = ACTIONS(2774),
    [anon_sym_SLASH_EQ] = ACTIONS(2774),
    [anon_sym_PERCENT_EQ] = ACTIONS(2774),
    [anon_sym_PLUS_EQ] = ACTIONS(2774),
    [anon_sym_DASH_EQ] = ACTIONS(2774),
    [anon_sym_LT_LT_EQ] = ACTIONS(2774),
    [anon_sym_GT_GT_EQ] = ACTIONS(2774),
    [anon_sym_AMP_EQ] = ACTIONS(2774),
    [anon_sym_CARET_EQ] = ACTIONS(2774),
    [anon_sym_PIPE_EQ] = ACTIONS(2774),
    [anon_sym_AMP] = ACTIONS(1745),
    [anon_sym_PIPE_PIPE] = ACTIONS(2774),
    [anon_sym_AMP_AMP] = ACTIONS(2774),
    [anon_sym_PIPE] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_GT] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1027] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_COLON] = ACTIONS(2770),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_STAR_EQ] = ACTIONS(2770),
    [anon_sym_SLASH_EQ] = ACTIONS(2770),
    [anon_sym_PERCENT_EQ] = ACTIONS(2770),
    [anon_sym_PLUS_EQ] = ACTIONS(2770),
    [anon_sym_DASH_EQ] = ACTIONS(2770),
    [anon_sym_LT_LT_EQ] = ACTIONS(2770),
    [anon_sym_GT_GT_EQ] = ACTIONS(2770),
    [anon_sym_AMP_EQ] = ACTIONS(2770),
    [anon_sym_CARET_EQ] = ACTIONS(2770),
    [anon_sym_PIPE_EQ] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(1745),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_PIPE] = ACTIONS(2772),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_GT] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1028] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_COLON] = ACTIONS(2770),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_STAR_EQ] = ACTIONS(2770),
    [anon_sym_SLASH_EQ] = ACTIONS(2770),
    [anon_sym_PERCENT_EQ] = ACTIONS(2770),
    [anon_sym_PLUS_EQ] = ACTIONS(2770),
    [anon_sym_DASH_EQ] = ACTIONS(2770),
    [anon_sym_LT_LT_EQ] = ACTIONS(2770),
    [anon_sym_GT_GT_EQ] = ACTIONS(2770),
    [anon_sym_AMP_EQ] = ACTIONS(2770),
    [anon_sym_CARET_EQ] = ACTIONS(2770),
    [anon_sym_PIPE_EQ] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(1745),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_PIPE] = ACTIONS(2772),
    [anon_sym_CARET] = ACTIONS(2772),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_GT] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1029] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2780),
    [anon_sym_COLON] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2778),
    [anon_sym_STAR_EQ] = ACTIONS(2778),
    [anon_sym_SLASH_EQ] = ACTIONS(2778),
    [anon_sym_PERCENT_EQ] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2778),
    [anon_sym_DASH_EQ] = ACTIONS(2778),
    [anon_sym_LT_LT_EQ] = ACTIONS(2778),
    [anon_sym_GT_GT_EQ] = ACTIONS(2778),
    [anon_sym_AMP_EQ] = ACTIONS(2778),
    [anon_sym_CARET_EQ] = ACTIONS(2778),
    [anon_sym_PIPE_EQ] = ACTIONS(2778),
    [anon_sym_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2778),
    [anon_sym_AMP_AMP] = ACTIONS(2778),
    [anon_sym_PIPE] = ACTIONS(2780),
    [anon_sym_CARET] = ACTIONS(2780),
    [anon_sym_EQ_EQ] = ACTIONS(2778),
    [anon_sym_BANG_EQ] = ACTIONS(2778),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_GT] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1030] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2784),
    [anon_sym_COLON] = ACTIONS(2782),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_STAR_EQ] = ACTIONS(2782),
    [anon_sym_SLASH_EQ] = ACTIONS(2782),
    [anon_sym_PERCENT_EQ] = ACTIONS(2782),
    [anon_sym_PLUS_EQ] = ACTIONS(2782),
    [anon_sym_DASH_EQ] = ACTIONS(2782),
    [anon_sym_LT_LT_EQ] = ACTIONS(2782),
    [anon_sym_GT_GT_EQ] = ACTIONS(2782),
    [anon_sym_AMP_EQ] = ACTIONS(2782),
    [anon_sym_CARET_EQ] = ACTIONS(2782),
    [anon_sym_PIPE_EQ] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2784),
    [anon_sym_PIPE_PIPE] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2784),
    [anon_sym_CARET] = ACTIONS(2784),
    [anon_sym_EQ_EQ] = ACTIONS(2782),
    [anon_sym_BANG_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2784),
    [anon_sym_GT] = ACTIONS(2784),
    [anon_sym_LT_EQ] = ACTIONS(2782),
    [anon_sym_GT_EQ] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1031] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2788),
    [anon_sym_COLON] = ACTIONS(2786),
    [anon_sym_QMARK] = ACTIONS(2786),
    [anon_sym_STAR_EQ] = ACTIONS(2786),
    [anon_sym_SLASH_EQ] = ACTIONS(2786),
    [anon_sym_PERCENT_EQ] = ACTIONS(2786),
    [anon_sym_PLUS_EQ] = ACTIONS(2786),
    [anon_sym_DASH_EQ] = ACTIONS(2786),
    [anon_sym_LT_LT_EQ] = ACTIONS(2786),
    [anon_sym_GT_GT_EQ] = ACTIONS(2786),
    [anon_sym_AMP_EQ] = ACTIONS(2786),
    [anon_sym_CARET_EQ] = ACTIONS(2786),
    [anon_sym_PIPE_EQ] = ACTIONS(2786),
    [anon_sym_AMP] = ACTIONS(2788),
    [anon_sym_PIPE_PIPE] = ACTIONS(2786),
    [anon_sym_AMP_AMP] = ACTIONS(2786),
    [anon_sym_PIPE] = ACTIONS(2788),
    [anon_sym_CARET] = ACTIONS(2788),
    [anon_sym_EQ_EQ] = ACTIONS(2786),
    [anon_sym_BANG_EQ] = ACTIONS(2786),
    [anon_sym_LT] = ACTIONS(2788),
    [anon_sym_GT] = ACTIONS(2788),
    [anon_sym_LT_EQ] = ACTIONS(2786),
    [anon_sym_GT_EQ] = ACTIONS(2786),
    [anon_sym_LT_LT] = ACTIONS(2788),
    [anon_sym_GT_GT] = ACTIONS(2788),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1032] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_COLON] = ACTIONS(2760),
    [anon_sym_QMARK] = ACTIONS(2760),
    [anon_sym_STAR_EQ] = ACTIONS(2760),
    [anon_sym_SLASH_EQ] = ACTIONS(2760),
    [anon_sym_PERCENT_EQ] = ACTIONS(2760),
    [anon_sym_PLUS_EQ] = ACTIONS(2760),
    [anon_sym_DASH_EQ] = ACTIONS(2760),
    [anon_sym_LT_LT_EQ] = ACTIONS(2760),
    [anon_sym_GT_GT_EQ] = ACTIONS(2760),
    [anon_sym_AMP_EQ] = ACTIONS(2760),
    [anon_sym_CARET_EQ] = ACTIONS(2760),
    [anon_sym_PIPE_EQ] = ACTIONS(2760),
    [anon_sym_AMP] = ACTIONS(2762),
    [anon_sym_PIPE_PIPE] = ACTIONS(2760),
    [anon_sym_AMP_AMP] = ACTIONS(2760),
    [anon_sym_PIPE] = ACTIONS(2762),
    [anon_sym_CARET] = ACTIONS(2762),
    [anon_sym_EQ_EQ] = ACTIONS(2760),
    [anon_sym_BANG_EQ] = ACTIONS(2760),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_GT] = ACTIONS(2762),
    [anon_sym_LT_EQ] = ACTIONS(2760),
    [anon_sym_GT_EQ] = ACTIONS(2760),
    [anon_sym_LT_LT] = ACTIONS(2762),
    [anon_sym_GT_GT] = ACTIONS(2762),
    [anon_sym_PLUS] = ACTIONS(2762),
    [anon_sym_DASH] = ACTIONS(2762),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1033] = {
    [sym_compound_statement] = STATE(1198),
    [sym_labeled_statement] = STATE(1198),
    [sym_expression_statement] = STATE(1198),
    [sym_if_statement] = STATE(1198),
    [sym_switch_statement] = STATE(1198),
    [sym_case_statement] = STATE(1198),
    [sym_while_statement] = STATE(1198),
    [sym_do_statement] = STATE(1198),
    [sym_for_statement] = STATE(1198),
    [sym_return_statement] = STATE(1198),
    [sym_break_statement] = STATE(1198),
    [sym_continue_statement] = STATE(1198),
    [sym_goto_statement] = STATE(1198),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1835),
    [sym_comment] = ACTIONS(42),
  },
  [1034] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(3256),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1035] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(3258),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1036] = {
    [sym_declaration] = STATE(1022),
    [sym_type_definition] = STATE(1022),
    [sym__declaration_specifiers] = STATE(761),
    [sym_compound_statement] = STATE(1022),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(1022),
    [sym_expression_statement] = STATE(1022),
    [sym_if_statement] = STATE(1022),
    [sym_switch_statement] = STATE(1022),
    [sym_case_statement] = STATE(1022),
    [sym_while_statement] = STATE(1022),
    [sym_do_statement] = STATE(1022),
    [sym_for_statement] = STATE(1022),
    [sym_return_statement] = STATE(1022),
    [sym_break_statement] = STATE(1022),
    [sym_continue_statement] = STATE(1022),
    [sym_goto_statement] = STATE(1022),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_typedef] = ACTIONS(585),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_default] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(1089),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(2703),
    [sym_comment] = ACTIONS(42),
  },
  [1037] = {
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_extern] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_auto] = ACTIONS(95),
    [anon_sym_register] = ACTIONS(95),
    [anon_sym_inline] = ACTIONS(95),
    [anon_sym_const] = ACTIONS(95),
    [anon_sym_restrict] = ACTIONS(95),
    [anon_sym_volatile] = ACTIONS(95),
    [anon_sym__Atomic] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(1785),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_identifier] = ACTIONS(95),
    [sym_comment] = ACTIONS(42),
  },
  [1038] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(3260),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1039] = {
    [sym__expression] = STATE(1203),
    [sym_conditional_expression] = STATE(1203),
    [sym_assignment_expression] = STATE(1203),
    [sym_pointer_expression] = STATE(1203),
    [sym_logical_expression] = STATE(1203),
    [sym_bitwise_expression] = STATE(1203),
    [sym_equality_expression] = STATE(1203),
    [sym_relational_expression] = STATE(1203),
    [sym_shift_expression] = STATE(1203),
    [sym_math_expression] = STATE(1203),
    [sym_cast_expression] = STATE(1203),
    [sym_sizeof_expression] = STATE(1203),
    [sym_subscript_expression] = STATE(1203),
    [sym_call_expression] = STATE(1203),
    [sym_field_expression] = STATE(1203),
    [sym_compound_literal_expression] = STATE(1203),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_concatenated_string] = STATE(1203),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(3262),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(3264),
    [sym_char_literal] = ACTIONS(3264),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(3266),
    [sym_false] = ACTIONS(3266),
    [sym_null] = ACTIONS(3266),
    [sym_identifier] = ACTIONS(3266),
    [sym_comment] = ACTIONS(42),
  },
  [1040] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(3268),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1041] = {
    [sym__expression] = STATE(1205),
    [sym_conditional_expression] = STATE(1205),
    [sym_assignment_expression] = STATE(1205),
    [sym_pointer_expression] = STATE(1205),
    [sym_logical_expression] = STATE(1205),
    [sym_bitwise_expression] = STATE(1205),
    [sym_equality_expression] = STATE(1205),
    [sym_relational_expression] = STATE(1205),
    [sym_shift_expression] = STATE(1205),
    [sym_math_expression] = STATE(1205),
    [sym_cast_expression] = STATE(1205),
    [sym_sizeof_expression] = STATE(1205),
    [sym_subscript_expression] = STATE(1205),
    [sym_call_expression] = STATE(1205),
    [sym_field_expression] = STATE(1205),
    [sym_compound_literal_expression] = STATE(1205),
    [sym_parenthesized_expression] = STATE(1205),
    [sym_concatenated_string] = STATE(1205),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(3270),
    [sym_char_literal] = ACTIONS(3270),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(3272),
    [sym_false] = ACTIONS(3272),
    [sym_null] = ACTIONS(3272),
    [sym_identifier] = ACTIONS(3272),
    [sym_comment] = ACTIONS(42),
  },
  [1042] = {
    [sym__expression] = STATE(1207),
    [sym_conditional_expression] = STATE(1207),
    [sym_assignment_expression] = STATE(1207),
    [sym_pointer_expression] = STATE(1207),
    [sym_logical_expression] = STATE(1207),
    [sym_bitwise_expression] = STATE(1207),
    [sym_equality_expression] = STATE(1207),
    [sym_relational_expression] = STATE(1207),
    [sym_shift_expression] = STATE(1207),
    [sym_math_expression] = STATE(1207),
    [sym_cast_expression] = STATE(1207),
    [sym_sizeof_expression] = STATE(1207),
    [sym_subscript_expression] = STATE(1207),
    [sym_call_expression] = STATE(1207),
    [sym_field_expression] = STATE(1207),
    [sym_compound_literal_expression] = STATE(1207),
    [sym_parenthesized_expression] = STATE(1207),
    [sym_concatenated_string] = STATE(1207),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(3274),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(3276),
    [sym_char_literal] = ACTIONS(3276),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(3278),
    [sym_false] = ACTIONS(3278),
    [sym_null] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_comment] = ACTIONS(42),
  },
  [1043] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(3280),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1044] = {
    [sym_parameter_list] = STATE(145),
    [aux_sym_declaration_repeat1] = STATE(1210),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(3282),
    [anon_sym_LBRACK] = ACTIONS(270),
    [anon_sym_EQ] = ACTIONS(272),
    [sym_comment] = ACTIONS(42),
  },
  [1045] = {
    [aux_sym_declaration_repeat1] = STATE(1210),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(3282),
    [sym_comment] = ACTIONS(42),
  },
  [1046] = {
    [sym__expression] = STATE(1211),
    [sym_conditional_expression] = STATE(1211),
    [sym_assignment_expression] = STATE(1211),
    [sym_pointer_expression] = STATE(1211),
    [sym_logical_expression] = STATE(1211),
    [sym_bitwise_expression] = STATE(1211),
    [sym_equality_expression] = STATE(1211),
    [sym_relational_expression] = STATE(1211),
    [sym_shift_expression] = STATE(1211),
    [sym_math_expression] = STATE(1211),
    [sym_cast_expression] = STATE(1211),
    [sym_sizeof_expression] = STATE(1211),
    [sym_subscript_expression] = STATE(1211),
    [sym_call_expression] = STATE(1211),
    [sym_field_expression] = STATE(1211),
    [sym_compound_literal_expression] = STATE(1211),
    [sym_parenthesized_expression] = STATE(1211),
    [sym_concatenated_string] = STATE(1211),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(3280),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(3284),
    [sym_char_literal] = ACTIONS(3284),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(3286),
    [sym_false] = ACTIONS(3286),
    [sym_null] = ACTIONS(3286),
    [sym_identifier] = ACTIONS(3286),
    [sym_comment] = ACTIONS(42),
  },
  [1047] = {
    [sym__expression] = STATE(923),
    [sym_conditional_expression] = STATE(923),
    [sym_assignment_expression] = STATE(923),
    [sym_pointer_expression] = STATE(923),
    [sym_logical_expression] = STATE(923),
    [sym_bitwise_expression] = STATE(923),
    [sym_equality_expression] = STATE(923),
    [sym_relational_expression] = STATE(923),
    [sym_shift_expression] = STATE(923),
    [sym_math_expression] = STATE(923),
    [sym_cast_expression] = STATE(923),
    [sym_sizeof_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_call_expression] = STATE(923),
    [sym_field_expression] = STATE(923),
    [sym_compound_literal_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(923),
    [sym_initializer_list] = STATE(924),
    [sym_concatenated_string] = STATE(923),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_COMMA] = ACTIONS(3288),
    [anon_sym_SEMI] = ACTIONS(3288),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_STAR] = ACTIONS(3290),
    [anon_sym_LBRACK] = ACTIONS(3288),
    [anon_sym_EQ] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3288),
    [anon_sym_STAR_EQ] = ACTIONS(3288),
    [anon_sym_SLASH_EQ] = ACTIONS(3288),
    [anon_sym_PERCENT_EQ] = ACTIONS(3288),
    [anon_sym_PLUS_EQ] = ACTIONS(3288),
    [anon_sym_DASH_EQ] = ACTIONS(3288),
    [anon_sym_LT_LT_EQ] = ACTIONS(3288),
    [anon_sym_GT_GT_EQ] = ACTIONS(3288),
    [anon_sym_AMP_EQ] = ACTIONS(3288),
    [anon_sym_CARET_EQ] = ACTIONS(3288),
    [anon_sym_PIPE_EQ] = ACTIONS(3288),
    [anon_sym_AMP] = ACTIONS(3290),
    [anon_sym_PIPE_PIPE] = ACTIONS(3288),
    [anon_sym_AMP_AMP] = ACTIONS(3288),
    [anon_sym_BANG] = ACTIONS(3294),
    [anon_sym_PIPE] = ACTIONS(3292),
    [anon_sym_CARET] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_EQ_EQ] = ACTIONS(3288),
    [anon_sym_BANG_EQ] = ACTIONS(3288),
    [anon_sym_LT] = ACTIONS(3292),
    [anon_sym_GT] = ACTIONS(3292),
    [anon_sym_LT_EQ] = ACTIONS(3288),
    [anon_sym_GT_EQ] = ACTIONS(3288),
    [anon_sym_LT_LT] = ACTIONS(3292),
    [anon_sym_GT_GT] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [anon_sym_DOT] = ACTIONS(3288),
    [anon_sym_DASH_GT] = ACTIONS(3288),
    [sym_number_literal] = ACTIONS(2459),
    [sym_char_literal] = ACTIONS(2459),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(2461),
    [sym_false] = ACTIONS(2461),
    [sym_null] = ACTIONS(2461),
    [sym_identifier] = ACTIONS(2461),
    [sym_comment] = ACTIONS(42),
  },
  [1048] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1288),
    [anon_sym_LPAREN] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1288),
    [sym_preproc_directive] = ACTIONS(1288),
    [anon_sym_SEMI] = ACTIONS(1286),
    [anon_sym_typedef] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1288),
    [anon_sym_LBRACE] = ACTIONS(1286),
    [anon_sym_RBRACE] = ACTIONS(1286),
    [anon_sym_STAR] = ACTIONS(1286),
    [anon_sym_static] = ACTIONS(1288),
    [anon_sym_auto] = ACTIONS(1288),
    [anon_sym_register] = ACTIONS(1288),
    [anon_sym_inline] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_restrict] = ACTIONS(1288),
    [anon_sym_volatile] = ACTIONS(1288),
    [anon_sym__Atomic] = ACTIONS(1288),
    [anon_sym_unsigned] = ACTIONS(1288),
    [anon_sym_long] = ACTIONS(1288),
    [anon_sym_short] = ACTIONS(1288),
    [sym_primitive_type] = ACTIONS(1288),
    [anon_sym_enum] = ACTIONS(1288),
    [anon_sym_struct] = ACTIONS(1288),
    [anon_sym_union] = ACTIONS(1288),
    [anon_sym_if] = ACTIONS(1288),
    [anon_sym_switch] = ACTIONS(1288),
    [anon_sym_case] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1288),
    [anon_sym_while] = ACTIONS(1288),
    [anon_sym_do] = ACTIONS(1288),
    [anon_sym_for] = ACTIONS(1288),
    [anon_sym_return] = ACTIONS(1288),
    [anon_sym_break] = ACTIONS(1288),
    [anon_sym_continue] = ACTIONS(1288),
    [anon_sym_goto] = ACTIONS(1288),
    [anon_sym_AMP] = ACTIONS(1286),
    [anon_sym_BANG] = ACTIONS(1286),
    [anon_sym_TILDE] = ACTIONS(1286),
    [anon_sym_PLUS] = ACTIONS(1288),
    [anon_sym_DASH] = ACTIONS(1288),
    [anon_sym_DASH_DASH] = ACTIONS(1286),
    [anon_sym_PLUS_PLUS] = ACTIONS(1286),
    [anon_sym_sizeof] = ACTIONS(1288),
    [sym_number_literal] = ACTIONS(1286),
    [sym_char_literal] = ACTIONS(1286),
    [sym_string_literal] = ACTIONS(1286),
    [sym_true] = ACTIONS(1288),
    [sym_false] = ACTIONS(1288),
    [sym_null] = ACTIONS(1288),
    [sym_identifier] = ACTIONS(1288),
    [sym_comment] = ACTIONS(42),
  },
  [1049] = {
    [sym__expression] = STATE(1212),
    [sym_conditional_expression] = STATE(1212),
    [sym_assignment_expression] = STATE(1212),
    [sym_pointer_expression] = STATE(1212),
    [sym_logical_expression] = STATE(1212),
    [sym_bitwise_expression] = STATE(1212),
    [sym_equality_expression] = STATE(1212),
    [sym_relational_expression] = STATE(1212),
    [sym_shift_expression] = STATE(1212),
    [sym_math_expression] = STATE(1212),
    [sym_cast_expression] = STATE(1212),
    [sym_sizeof_expression] = STATE(1212),
    [sym_subscript_expression] = STATE(1212),
    [sym_call_expression] = STATE(1212),
    [sym_field_expression] = STATE(1212),
    [sym_compound_literal_expression] = STATE(1212),
    [sym_parenthesized_expression] = STATE(1212),
    [sym_concatenated_string] = STATE(1212),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(3296),
    [sym_char_literal] = ACTIONS(3296),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(3298),
    [sym_false] = ACTIONS(3298),
    [sym_null] = ACTIONS(3298),
    [sym_identifier] = ACTIONS(3298),
    [sym_comment] = ACTIONS(42),
  },
  [1050] = {
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_COMMA] = ACTIONS(3300),
    [anon_sym_RPAREN] = ACTIONS(3300),
    [anon_sym_SEMI] = ACTIONS(3300),
    [anon_sym_RBRACE] = ACTIONS(3300),
    [anon_sym_STAR] = ACTIONS(3302),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_RBRACK] = ACTIONS(3300),
    [anon_sym_EQ] = ACTIONS(3302),
    [anon_sym_COLON] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3300),
    [anon_sym_STAR_EQ] = ACTIONS(3300),
    [anon_sym_SLASH_EQ] = ACTIONS(3300),
    [anon_sym_PERCENT_EQ] = ACTIONS(3300),
    [anon_sym_PLUS_EQ] = ACTIONS(3300),
    [anon_sym_DASH_EQ] = ACTIONS(3300),
    [anon_sym_LT_LT_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_AMP_EQ] = ACTIONS(3300),
    [anon_sym_CARET_EQ] = ACTIONS(3300),
    [anon_sym_PIPE_EQ] = ACTIONS(3300),
    [anon_sym_AMP] = ACTIONS(3302),
    [anon_sym_PIPE_PIPE] = ACTIONS(3300),
    [anon_sym_AMP_AMP] = ACTIONS(3300),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_CARET] = ACTIONS(3302),
    [anon_sym_EQ_EQ] = ACTIONS(3300),
    [anon_sym_BANG_EQ] = ACTIONS(3300),
    [anon_sym_LT] = ACTIONS(3302),
    [anon_sym_GT] = ACTIONS(3302),
    [anon_sym_LT_EQ] = ACTIONS(3300),
    [anon_sym_GT_EQ] = ACTIONS(3300),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_GT_GT] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_SLASH] = ACTIONS(3302),
    [anon_sym_PERCENT] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(3300),
    [anon_sym_DASH_GT] = ACTIONS(3300),
    [sym_comment] = ACTIONS(42),
  },
  [1051] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(3304),
    [sym_comment] = ACTIONS(42),
  },
  [1052] = {
    [anon_sym_LPAREN] = ACTIONS(3306),
    [anon_sym_COMMA] = ACTIONS(3306),
    [anon_sym_RPAREN] = ACTIONS(3306),
    [anon_sym_SEMI] = ACTIONS(3306),
    [anon_sym_RBRACE] = ACTIONS(3306),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3306),
    [anon_sym_EQ] = ACTIONS(3308),
    [anon_sym_COLON] = ACTIONS(3306),
    [anon_sym_QMARK] = ACTIONS(3306),
    [anon_sym_STAR_EQ] = ACTIONS(3306),
    [anon_sym_SLASH_EQ] = ACTIONS(3306),
    [anon_sym_PERCENT_EQ] = ACTIONS(3306),
    [anon_sym_PLUS_EQ] = ACTIONS(3306),
    [anon_sym_DASH_EQ] = ACTIONS(3306),
    [anon_sym_LT_LT_EQ] = ACTIONS(3306),
    [anon_sym_GT_GT_EQ] = ACTIONS(3306),
    [anon_sym_AMP_EQ] = ACTIONS(3306),
    [anon_sym_CARET_EQ] = ACTIONS(3306),
    [anon_sym_PIPE_EQ] = ACTIONS(3306),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_PIPE_PIPE] = ACTIONS(3306),
    [anon_sym_AMP_AMP] = ACTIONS(3306),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_CARET] = ACTIONS(3308),
    [anon_sym_EQ_EQ] = ACTIONS(3306),
    [anon_sym_BANG_EQ] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_LT_EQ] = ACTIONS(3306),
    [anon_sym_GT_EQ] = ACTIONS(3306),
    [anon_sym_LT_LT] = ACTIONS(3308),
    [anon_sym_GT_GT] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_SLASH] = ACTIONS(3308),
    [anon_sym_PERCENT] = ACTIONS(3308),
    [anon_sym_DASH_DASH] = ACTIONS(3306),
    [anon_sym_PLUS_PLUS] = ACTIONS(3306),
    [anon_sym_DOT] = ACTIONS(3306),
    [anon_sym_DASH_GT] = ACTIONS(3306),
    [sym_comment] = ACTIONS(42),
  },
  [1053] = {
    [sym__expression] = STATE(1215),
    [sym_conditional_expression] = STATE(1215),
    [sym_assignment_expression] = STATE(1215),
    [sym_pointer_expression] = STATE(1215),
    [sym_logical_expression] = STATE(1215),
    [sym_bitwise_expression] = STATE(1215),
    [sym_equality_expression] = STATE(1215),
    [sym_relational_expression] = STATE(1215),
    [sym_shift_expression] = STATE(1215),
    [sym_math_expression] = STATE(1215),
    [sym_cast_expression] = STATE(1215),
    [sym_sizeof_expression] = STATE(1215),
    [sym_subscript_expression] = STATE(1215),
    [sym_call_expression] = STATE(1215),
    [sym_field_expression] = STATE(1215),
    [sym_compound_literal_expression] = STATE(1215),
    [sym_parenthesized_expression] = STATE(1215),
    [sym_concatenated_string] = STATE(1215),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3310),
    [sym_char_literal] = ACTIONS(3310),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3312),
    [sym_false] = ACTIONS(3312),
    [sym_null] = ACTIONS(3312),
    [sym_identifier] = ACTIONS(3312),
    [sym_comment] = ACTIONS(42),
  },
  [1054] = {
    [anon_sym_LPAREN] = ACTIONS(836),
    [anon_sym_extern] = ACTIONS(838),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_RBRACK] = ACTIONS(836),
    [anon_sym_static] = ACTIONS(838),
    [anon_sym_auto] = ACTIONS(838),
    [anon_sym_register] = ACTIONS(838),
    [anon_sym_inline] = ACTIONS(838),
    [anon_sym_const] = ACTIONS(838),
    [anon_sym_restrict] = ACTIONS(838),
    [anon_sym_volatile] = ACTIONS(838),
    [anon_sym__Atomic] = ACTIONS(838),
    [anon_sym_AMP] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(836),
    [anon_sym_TILDE] = ACTIONS(836),
    [anon_sym_PLUS] = ACTIONS(838),
    [anon_sym_DASH] = ACTIONS(838),
    [anon_sym_DASH_DASH] = ACTIONS(836),
    [anon_sym_PLUS_PLUS] = ACTIONS(836),
    [anon_sym_sizeof] = ACTIONS(838),
    [sym_number_literal] = ACTIONS(836),
    [sym_char_literal] = ACTIONS(836),
    [sym_string_literal] = ACTIONS(836),
    [sym_true] = ACTIONS(838),
    [sym_false] = ACTIONS(838),
    [sym_null] = ACTIONS(838),
    [sym_identifier] = ACTIONS(838),
    [sym_comment] = ACTIONS(42),
  },
  [1055] = {
    [sym_enumerator] = STATE(372),
    [anon_sym_RBRACE] = ACTIONS(3314),
    [sym_identifier] = ACTIONS(210),
    [sym_comment] = ACTIONS(42),
  },
  [1056] = {
    [aux_sym_enumerator_list_repeat1] = STATE(374),
    [anon_sym_COMMA] = ACTIONS(3316),
    [anon_sym_RBRACE] = ACTIONS(3314),
    [sym_comment] = ACTIONS(42),
  },
  [1057] = {
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_extern] = ACTIONS(921),
    [anon_sym_STAR] = ACTIONS(919),
    [anon_sym_RBRACK] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(921),
    [anon_sym_auto] = ACTIONS(921),
    [anon_sym_register] = ACTIONS(921),
    [anon_sym_inline] = ACTIONS(921),
    [anon_sym_const] = ACTIONS(921),
    [anon_sym_restrict] = ACTIONS(921),
    [anon_sym_volatile] = ACTIONS(921),
    [anon_sym__Atomic] = ACTIONS(921),
    [anon_sym_AMP] = ACTIONS(919),
    [anon_sym_BANG] = ACTIONS(919),
    [anon_sym_TILDE] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_DASH_DASH] = ACTIONS(919),
    [anon_sym_PLUS_PLUS] = ACTIONS(919),
    [anon_sym_sizeof] = ACTIONS(921),
    [sym_number_literal] = ACTIONS(919),
    [sym_char_literal] = ACTIONS(919),
    [sym_string_literal] = ACTIONS(919),
    [sym_true] = ACTIONS(921),
    [sym_false] = ACTIONS(921),
    [sym_null] = ACTIONS(921),
    [sym_identifier] = ACTIONS(921),
    [sym_comment] = ACTIONS(42),
  },
  [1058] = {
    [sym__expression] = STATE(923),
    [sym_conditional_expression] = STATE(923),
    [sym_assignment_expression] = STATE(923),
    [sym_pointer_expression] = STATE(923),
    [sym_logical_expression] = STATE(923),
    [sym_bitwise_expression] = STATE(923),
    [sym_equality_expression] = STATE(923),
    [sym_relational_expression] = STATE(923),
    [sym_shift_expression] = STATE(923),
    [sym_math_expression] = STATE(923),
    [sym_cast_expression] = STATE(923),
    [sym_sizeof_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_call_expression] = STATE(923),
    [sym_field_expression] = STATE(923),
    [sym_compound_literal_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(923),
    [sym_initializer_list] = STATE(924),
    [sym_concatenated_string] = STATE(923),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3288),
    [anon_sym_RBRACK] = ACTIONS(3288),
    [anon_sym_EQ] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3288),
    [anon_sym_STAR_EQ] = ACTIONS(3288),
    [anon_sym_SLASH_EQ] = ACTIONS(3288),
    [anon_sym_PERCENT_EQ] = ACTIONS(3288),
    [anon_sym_PLUS_EQ] = ACTIONS(3288),
    [anon_sym_DASH_EQ] = ACTIONS(3288),
    [anon_sym_LT_LT_EQ] = ACTIONS(3288),
    [anon_sym_GT_GT_EQ] = ACTIONS(3288),
    [anon_sym_AMP_EQ] = ACTIONS(3288),
    [anon_sym_CARET_EQ] = ACTIONS(3288),
    [anon_sym_PIPE_EQ] = ACTIONS(3288),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_PIPE_PIPE] = ACTIONS(3288),
    [anon_sym_AMP_AMP] = ACTIONS(3288),
    [anon_sym_BANG] = ACTIONS(3320),
    [anon_sym_PIPE] = ACTIONS(3292),
    [anon_sym_CARET] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_EQ_EQ] = ACTIONS(3288),
    [anon_sym_BANG_EQ] = ACTIONS(3288),
    [anon_sym_LT] = ACTIONS(3292),
    [anon_sym_GT] = ACTIONS(3292),
    [anon_sym_LT_EQ] = ACTIONS(3288),
    [anon_sym_GT_EQ] = ACTIONS(3288),
    [anon_sym_LT_LT] = ACTIONS(3292),
    [anon_sym_GT_GT] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [anon_sym_DOT] = ACTIONS(3288),
    [anon_sym_DASH_GT] = ACTIONS(3288),
    [sym_number_literal] = ACTIONS(2459),
    [sym_char_literal] = ACTIONS(2459),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(2461),
    [sym_false] = ACTIONS(2461),
    [sym_null] = ACTIONS(2461),
    [sym_identifier] = ACTIONS(2461),
    [sym_comment] = ACTIONS(42),
  },
  [1059] = {
    [anon_sym_LPAREN] = ACTIONS(972),
    [anon_sym_extern] = ACTIONS(974),
    [anon_sym_STAR] = ACTIONS(972),
    [anon_sym_RBRACK] = ACTIONS(972),
    [anon_sym_static] = ACTIONS(974),
    [anon_sym_auto] = ACTIONS(974),
    [anon_sym_register] = ACTIONS(974),
    [anon_sym_inline] = ACTIONS(974),
    [anon_sym_const] = ACTIONS(974),
    [anon_sym_restrict] = ACTIONS(974),
    [anon_sym_volatile] = ACTIONS(974),
    [anon_sym__Atomic] = ACTIONS(974),
    [anon_sym_AMP] = ACTIONS(972),
    [anon_sym_BANG] = ACTIONS(972),
    [anon_sym_TILDE] = ACTIONS(972),
    [anon_sym_PLUS] = ACTIONS(974),
    [anon_sym_DASH] = ACTIONS(974),
    [anon_sym_DASH_DASH] = ACTIONS(972),
    [anon_sym_PLUS_PLUS] = ACTIONS(972),
    [anon_sym_sizeof] = ACTIONS(974),
    [sym_number_literal] = ACTIONS(972),
    [sym_char_literal] = ACTIONS(972),
    [sym_string_literal] = ACTIONS(972),
    [sym_true] = ACTIONS(974),
    [sym_false] = ACTIONS(974),
    [sym_null] = ACTIONS(974),
    [sym_identifier] = ACTIONS(974),
    [sym_comment] = ACTIONS(42),
  },
  [1060] = {
    [sym__expression] = STATE(1218),
    [sym_conditional_expression] = STATE(1218),
    [sym_assignment_expression] = STATE(1218),
    [sym_pointer_expression] = STATE(1218),
    [sym_logical_expression] = STATE(1218),
    [sym_bitwise_expression] = STATE(1218),
    [sym_equality_expression] = STATE(1218),
    [sym_relational_expression] = STATE(1218),
    [sym_shift_expression] = STATE(1218),
    [sym_math_expression] = STATE(1218),
    [sym_cast_expression] = STATE(1218),
    [sym_sizeof_expression] = STATE(1218),
    [sym_subscript_expression] = STATE(1218),
    [sym_call_expression] = STATE(1218),
    [sym_field_expression] = STATE(1218),
    [sym_compound_literal_expression] = STATE(1218),
    [sym_parenthesized_expression] = STATE(1218),
    [sym_concatenated_string] = STATE(1218),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_sizeof] = ACTIONS(657),
    [sym_number_literal] = ACTIONS(3322),
    [sym_char_literal] = ACTIONS(3322),
    [sym_string_literal] = ACTIONS(661),
    [sym_true] = ACTIONS(3324),
    [sym_false] = ACTIONS(3324),
    [sym_null] = ACTIONS(3324),
    [sym_identifier] = ACTIONS(3324),
    [sym_comment] = ACTIONS(42),
  },
  [1061] = {
    [anon_sym_LBRACK] = ACTIONS(3326),
    [anon_sym_EQ] = ACTIONS(3326),
    [anon_sym_DOT] = ACTIONS(3326),
    [sym_comment] = ACTIONS(42),
  },
  [1062] = {
    [anon_sym_LPAREN] = ACTIONS(3328),
    [anon_sym_COMMA] = ACTIONS(3328),
    [anon_sym_RPAREN] = ACTIONS(3328),
    [anon_sym_SEMI] = ACTIONS(3328),
    [anon_sym_RBRACE] = ACTIONS(3328),
    [anon_sym_STAR] = ACTIONS(3330),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_RBRACK] = ACTIONS(3328),
    [anon_sym_EQ] = ACTIONS(3330),
    [anon_sym_COLON] = ACTIONS(3328),
    [anon_sym_QMARK] = ACTIONS(3328),
    [anon_sym_STAR_EQ] = ACTIONS(3328),
    [anon_sym_SLASH_EQ] = ACTIONS(3328),
    [anon_sym_PERCENT_EQ] = ACTIONS(3328),
    [anon_sym_PLUS_EQ] = ACTIONS(3328),
    [anon_sym_DASH_EQ] = ACTIONS(3328),
    [anon_sym_LT_LT_EQ] = ACTIONS(3328),
    [anon_sym_GT_GT_EQ] = ACTIONS(3328),
    [anon_sym_AMP_EQ] = ACTIONS(3328),
    [anon_sym_CARET_EQ] = ACTIONS(3328),
    [anon_sym_PIPE_EQ] = ACTIONS(3328),
    [anon_sym_AMP] = ACTIONS(3330),
    [anon_sym_PIPE_PIPE] = ACTIONS(3328),
    [anon_sym_AMP_AMP] = ACTIONS(3328),
    [anon_sym_PIPE] = ACTIONS(3330),
    [anon_sym_CARET] = ACTIONS(3330),
    [anon_sym_EQ_EQ] = ACTIONS(3328),
    [anon_sym_BANG_EQ] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(3330),
    [anon_sym_GT] = ACTIONS(3330),
    [anon_sym_LT_EQ] = ACTIONS(3328),
    [anon_sym_GT_EQ] = ACTIONS(3328),
    [anon_sym_LT_LT] = ACTIONS(3330),
    [anon_sym_GT_GT] = ACTIONS(3330),
    [anon_sym_PLUS] = ACTIONS(3330),
    [anon_sym_DASH] = ACTIONS(3330),
    [anon_sym_SLASH] = ACTIONS(3330),
    [anon_sym_PERCENT] = ACTIONS(3330),
    [anon_sym_DASH_DASH] = ACTIONS(3328),
    [anon_sym_PLUS_PLUS] = ACTIONS(3328),
    [anon_sym_DOT] = ACTIONS(3328),
    [anon_sym_DASH_GT] = ACTIONS(3328),
    [sym_comment] = ACTIONS(42),
  },
  [1063] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(3332),
    [anon_sym_RBRACE] = ACTIONS(3332),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1429),
    [anon_sym_QMARK] = ACTIONS(1431),
    [anon_sym_STAR_EQ] = ACTIONS(1433),
    [anon_sym_SLASH_EQ] = ACTIONS(1433),
    [anon_sym_PERCENT_EQ] = ACTIONS(1433),
    [anon_sym_PLUS_EQ] = ACTIONS(1433),
    [anon_sym_DASH_EQ] = ACTIONS(1433),
    [anon_sym_LT_LT_EQ] = ACTIONS(1433),
    [anon_sym_GT_GT_EQ] = ACTIONS(1433),
    [anon_sym_AMP_EQ] = ACTIONS(1433),
    [anon_sym_CARET_EQ] = ACTIONS(1433),
    [anon_sym_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_PIPE] = ACTIONS(1441),
    [anon_sym_CARET] = ACTIONS(1443),
    [anon_sym_EQ_EQ] = ACTIONS(1445),
    [anon_sym_BANG_EQ] = ACTIONS(1445),
    [anon_sym_LT] = ACTIONS(1447),
    [anon_sym_GT] = ACTIONS(1447),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1451),
    [anon_sym_GT_GT] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_SLASH] = ACTIONS(1427),
    [anon_sym_PERCENT] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1064] = {
    [anon_sym_COMMA] = ACTIONS(3332),
    [anon_sym_RBRACE] = ACTIONS(3332),
    [sym_comment] = ACTIONS(42),
  },
  [1065] = {
    [sym__expression] = STATE(1063),
    [sym_conditional_expression] = STATE(1063),
    [sym_assignment_expression] = STATE(1063),
    [sym_pointer_expression] = STATE(1063),
    [sym_logical_expression] = STATE(1063),
    [sym_bitwise_expression] = STATE(1063),
    [sym_equality_expression] = STATE(1063),
    [sym_relational_expression] = STATE(1063),
    [sym_shift_expression] = STATE(1063),
    [sym_math_expression] = STATE(1063),
    [sym_cast_expression] = STATE(1063),
    [sym_sizeof_expression] = STATE(1063),
    [sym_subscript_expression] = STATE(1063),
    [sym_call_expression] = STATE(1063),
    [sym_field_expression] = STATE(1063),
    [sym_compound_literal_expression] = STATE(1063),
    [sym_parenthesized_expression] = STATE(1063),
    [sym_initializer_list] = STATE(1064),
    [sym_initializer_pair] = STATE(1064),
    [sym_subscript_designator] = STATE(547),
    [sym_field_designator] = STATE(547),
    [sym_concatenated_string] = STATE(1063),
    [aux_sym_initializer_pair_repeat1] = STATE(547),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(3334),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_LBRACK] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [anon_sym_DOT] = ACTIONS(1278),
    [sym_number_literal] = ACTIONS(2827),
    [sym_char_literal] = ACTIONS(2827),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(2829),
    [sym_false] = ACTIONS(2829),
    [sym_null] = ACTIONS(2829),
    [sym_identifier] = ACTIONS(2829),
    [sym_comment] = ACTIONS(42),
  },
  [1066] = {
    [aux_sym_initializer_list_repeat1] = STATE(1066),
    [anon_sym_COMMA] = ACTIONS(3336),
    [anon_sym_RBRACE] = ACTIONS(3332),
    [sym_comment] = ACTIONS(42),
  },
  [1067] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(3339),
    [anon_sym_RBRACE] = ACTIONS(3339),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1429),
    [anon_sym_QMARK] = ACTIONS(1431),
    [anon_sym_STAR_EQ] = ACTIONS(1433),
    [anon_sym_SLASH_EQ] = ACTIONS(1433),
    [anon_sym_PERCENT_EQ] = ACTIONS(1433),
    [anon_sym_PLUS_EQ] = ACTIONS(1433),
    [anon_sym_DASH_EQ] = ACTIONS(1433),
    [anon_sym_LT_LT_EQ] = ACTIONS(1433),
    [anon_sym_GT_GT_EQ] = ACTIONS(1433),
    [anon_sym_AMP_EQ] = ACTIONS(1433),
    [anon_sym_CARET_EQ] = ACTIONS(1433),
    [anon_sym_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_PIPE] = ACTIONS(1441),
    [anon_sym_CARET] = ACTIONS(1443),
    [anon_sym_EQ_EQ] = ACTIONS(1445),
    [anon_sym_BANG_EQ] = ACTIONS(1445),
    [anon_sym_LT] = ACTIONS(1447),
    [anon_sym_GT] = ACTIONS(1447),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1451),
    [anon_sym_GT_GT] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_SLASH] = ACTIONS(1427),
    [anon_sym_PERCENT] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1068] = {
    [anon_sym_COMMA] = ACTIONS(3339),
    [anon_sym_RBRACE] = ACTIONS(3339),
    [sym_comment] = ACTIONS(42),
  },
  [1069] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1295),
    [sym_preproc_directive] = ACTIONS(1295),
    [anon_sym_typedef] = ACTIONS(1295),
    [anon_sym_extern] = ACTIONS(1295),
    [anon_sym_static] = ACTIONS(1295),
    [anon_sym_auto] = ACTIONS(1295),
    [anon_sym_register] = ACTIONS(1295),
    [anon_sym_inline] = ACTIONS(1295),
    [anon_sym_const] = ACTIONS(1295),
    [anon_sym_restrict] = ACTIONS(1295),
    [anon_sym_volatile] = ACTIONS(1295),
    [anon_sym__Atomic] = ACTIONS(1295),
    [anon_sym_unsigned] = ACTIONS(1295),
    [anon_sym_long] = ACTIONS(1295),
    [anon_sym_short] = ACTIONS(1295),
    [sym_primitive_type] = ACTIONS(1295),
    [anon_sym_enum] = ACTIONS(1295),
    [anon_sym_struct] = ACTIONS(1295),
    [anon_sym_union] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_comment] = ACTIONS(42),
  },
  [1070] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1305),
    [sym_preproc_directive] = ACTIONS(1305),
    [anon_sym_typedef] = ACTIONS(1305),
    [anon_sym_extern] = ACTIONS(1305),
    [anon_sym_static] = ACTIONS(1305),
    [anon_sym_auto] = ACTIONS(1305),
    [anon_sym_register] = ACTIONS(1305),
    [anon_sym_inline] = ACTIONS(1305),
    [anon_sym_const] = ACTIONS(1305),
    [anon_sym_restrict] = ACTIONS(1305),
    [anon_sym_volatile] = ACTIONS(1305),
    [anon_sym__Atomic] = ACTIONS(1305),
    [anon_sym_unsigned] = ACTIONS(1305),
    [anon_sym_long] = ACTIONS(1305),
    [anon_sym_short] = ACTIONS(1305),
    [sym_primitive_type] = ACTIONS(1305),
    [anon_sym_enum] = ACTIONS(1305),
    [anon_sym_struct] = ACTIONS(1305),
    [anon_sym_union] = ACTIONS(1305),
    [sym_identifier] = ACTIONS(1305),
    [sym_comment] = ACTIONS(42),
  },
  [1071] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1385),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1385),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1385),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1385),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1385),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1385),
    [sym_preproc_directive] = ACTIONS(1385),
    [anon_sym_typedef] = ACTIONS(1385),
    [anon_sym_extern] = ACTIONS(1385),
    [anon_sym_static] = ACTIONS(1385),
    [anon_sym_auto] = ACTIONS(1385),
    [anon_sym_register] = ACTIONS(1385),
    [anon_sym_inline] = ACTIONS(1385),
    [anon_sym_const] = ACTIONS(1385),
    [anon_sym_restrict] = ACTIONS(1385),
    [anon_sym_volatile] = ACTIONS(1385),
    [anon_sym__Atomic] = ACTIONS(1385),
    [anon_sym_unsigned] = ACTIONS(1385),
    [anon_sym_long] = ACTIONS(1385),
    [anon_sym_short] = ACTIONS(1385),
    [sym_primitive_type] = ACTIONS(1385),
    [anon_sym_enum] = ACTIONS(1385),
    [anon_sym_struct] = ACTIONS(1385),
    [anon_sym_union] = ACTIONS(1385),
    [sym_identifier] = ACTIONS(1385),
    [sym_comment] = ACTIONS(42),
  },
  [1072] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1389),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1389),
    [sym_preproc_directive] = ACTIONS(1389),
    [anon_sym_typedef] = ACTIONS(1389),
    [anon_sym_extern] = ACTIONS(1389),
    [anon_sym_static] = ACTIONS(1389),
    [anon_sym_auto] = ACTIONS(1389),
    [anon_sym_register] = ACTIONS(1389),
    [anon_sym_inline] = ACTIONS(1389),
    [anon_sym_const] = ACTIONS(1389),
    [anon_sym_restrict] = ACTIONS(1389),
    [anon_sym_volatile] = ACTIONS(1389),
    [anon_sym__Atomic] = ACTIONS(1389),
    [anon_sym_unsigned] = ACTIONS(1389),
    [anon_sym_long] = ACTIONS(1389),
    [anon_sym_short] = ACTIONS(1389),
    [sym_primitive_type] = ACTIONS(1389),
    [anon_sym_enum] = ACTIONS(1389),
    [anon_sym_struct] = ACTIONS(1389),
    [anon_sym_union] = ACTIONS(1389),
    [sym_identifier] = ACTIONS(1389),
    [sym_comment] = ACTIONS(42),
  },
  [1073] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1393),
    [sym_preproc_directive] = ACTIONS(1393),
    [anon_sym_typedef] = ACTIONS(1393),
    [anon_sym_extern] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1393),
    [anon_sym_auto] = ACTIONS(1393),
    [anon_sym_register] = ACTIONS(1393),
    [anon_sym_inline] = ACTIONS(1393),
    [anon_sym_const] = ACTIONS(1393),
    [anon_sym_restrict] = ACTIONS(1393),
    [anon_sym_volatile] = ACTIONS(1393),
    [anon_sym__Atomic] = ACTIONS(1393),
    [anon_sym_unsigned] = ACTIONS(1393),
    [anon_sym_long] = ACTIONS(1393),
    [anon_sym_short] = ACTIONS(1393),
    [sym_primitive_type] = ACTIONS(1393),
    [anon_sym_enum] = ACTIONS(1393),
    [anon_sym_struct] = ACTIONS(1393),
    [anon_sym_union] = ACTIONS(1393),
    [sym_identifier] = ACTIONS(1393),
    [sym_comment] = ACTIONS(42),
  },
  [1074] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1411),
    [sym_preproc_directive] = ACTIONS(1411),
    [anon_sym_typedef] = ACTIONS(1411),
    [anon_sym_extern] = ACTIONS(1411),
    [anon_sym_static] = ACTIONS(1411),
    [anon_sym_auto] = ACTIONS(1411),
    [anon_sym_register] = ACTIONS(1411),
    [anon_sym_inline] = ACTIONS(1411),
    [anon_sym_const] = ACTIONS(1411),
    [anon_sym_restrict] = ACTIONS(1411),
    [anon_sym_volatile] = ACTIONS(1411),
    [anon_sym__Atomic] = ACTIONS(1411),
    [anon_sym_unsigned] = ACTIONS(1411),
    [anon_sym_long] = ACTIONS(1411),
    [anon_sym_short] = ACTIONS(1411),
    [sym_primitive_type] = ACTIONS(1411),
    [anon_sym_enum] = ACTIONS(1411),
    [anon_sym_struct] = ACTIONS(1411),
    [anon_sym_union] = ACTIONS(1411),
    [sym_identifier] = ACTIONS(1411),
    [sym_comment] = ACTIONS(42),
  },
  [1075] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1415),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1415),
    [sym_preproc_directive] = ACTIONS(1415),
    [anon_sym_typedef] = ACTIONS(1415),
    [anon_sym_extern] = ACTIONS(1415),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_auto] = ACTIONS(1415),
    [anon_sym_register] = ACTIONS(1415),
    [anon_sym_inline] = ACTIONS(1415),
    [anon_sym_const] = ACTIONS(1415),
    [anon_sym_restrict] = ACTIONS(1415),
    [anon_sym_volatile] = ACTIONS(1415),
    [anon_sym__Atomic] = ACTIONS(1415),
    [anon_sym_unsigned] = ACTIONS(1415),
    [anon_sym_long] = ACTIONS(1415),
    [anon_sym_short] = ACTIONS(1415),
    [sym_primitive_type] = ACTIONS(1415),
    [anon_sym_enum] = ACTIONS(1415),
    [anon_sym_struct] = ACTIONS(1415),
    [anon_sym_union] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_comment] = ACTIONS(42),
  },
  [1076] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_auto] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(42),
  },
  [1077] = {
    [sym__expression] = STATE(923),
    [sym_conditional_expression] = STATE(923),
    [sym_assignment_expression] = STATE(923),
    [sym_pointer_expression] = STATE(923),
    [sym_logical_expression] = STATE(923),
    [sym_bitwise_expression] = STATE(923),
    [sym_equality_expression] = STATE(923),
    [sym_relational_expression] = STATE(923),
    [sym_shift_expression] = STATE(923),
    [sym_math_expression] = STATE(923),
    [sym_cast_expression] = STATE(923),
    [sym_sizeof_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_call_expression] = STATE(923),
    [sym_field_expression] = STATE(923),
    [sym_compound_literal_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(923),
    [sym_initializer_list] = STATE(924),
    [sym_concatenated_string] = STATE(923),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_COMMA] = ACTIONS(3288),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(3288),
    [anon_sym_STAR] = ACTIONS(3341),
    [anon_sym_LBRACK] = ACTIONS(3288),
    [anon_sym_EQ] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3288),
    [anon_sym_STAR_EQ] = ACTIONS(3288),
    [anon_sym_SLASH_EQ] = ACTIONS(3288),
    [anon_sym_PERCENT_EQ] = ACTIONS(3288),
    [anon_sym_PLUS_EQ] = ACTIONS(3288),
    [anon_sym_DASH_EQ] = ACTIONS(3288),
    [anon_sym_LT_LT_EQ] = ACTIONS(3288),
    [anon_sym_GT_GT_EQ] = ACTIONS(3288),
    [anon_sym_AMP_EQ] = ACTIONS(3288),
    [anon_sym_CARET_EQ] = ACTIONS(3288),
    [anon_sym_PIPE_EQ] = ACTIONS(3288),
    [anon_sym_AMP] = ACTIONS(3341),
    [anon_sym_PIPE_PIPE] = ACTIONS(3288),
    [anon_sym_AMP_AMP] = ACTIONS(3288),
    [anon_sym_BANG] = ACTIONS(3343),
    [anon_sym_PIPE] = ACTIONS(3292),
    [anon_sym_CARET] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(3288),
    [anon_sym_BANG_EQ] = ACTIONS(3288),
    [anon_sym_LT] = ACTIONS(3292),
    [anon_sym_GT] = ACTIONS(3292),
    [anon_sym_LT_EQ] = ACTIONS(3288),
    [anon_sym_GT_EQ] = ACTIONS(3288),
    [anon_sym_LT_LT] = ACTIONS(3292),
    [anon_sym_GT_GT] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [anon_sym_DOT] = ACTIONS(3288),
    [anon_sym_DASH_GT] = ACTIONS(3288),
    [sym_number_literal] = ACTIONS(2459),
    [sym_char_literal] = ACTIONS(2459),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(2461),
    [sym_false] = ACTIONS(2461),
    [sym_null] = ACTIONS(2461),
    [sym_identifier] = ACTIONS(2461),
    [sym_comment] = ACTIONS(42),
  },
  [1078] = {
    [sym__expression] = STATE(1221),
    [sym_conditional_expression] = STATE(1221),
    [sym_assignment_expression] = STATE(1221),
    [sym_pointer_expression] = STATE(1221),
    [sym_logical_expression] = STATE(1221),
    [sym_bitwise_expression] = STATE(1221),
    [sym_equality_expression] = STATE(1221),
    [sym_relational_expression] = STATE(1221),
    [sym_shift_expression] = STATE(1221),
    [sym_math_expression] = STATE(1221),
    [sym_cast_expression] = STATE(1221),
    [sym_sizeof_expression] = STATE(1221),
    [sym_subscript_expression] = STATE(1221),
    [sym_call_expression] = STATE(1221),
    [sym_field_expression] = STATE(1221),
    [sym_compound_literal_expression] = STATE(1221),
    [sym_parenthesized_expression] = STATE(1221),
    [sym_concatenated_string] = STATE(1221),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [sym_number_literal] = ACTIONS(3345),
    [sym_char_literal] = ACTIONS(3345),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(3347),
    [sym_false] = ACTIONS(3347),
    [sym_null] = ACTIONS(3347),
    [sym_identifier] = ACTIONS(3347),
    [sym_comment] = ACTIONS(42),
  },
  [1079] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3349),
    [sym_comment] = ACTIONS(42),
  },
  [1080] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3351),
    [sym_comment] = ACTIONS(42),
  },
  [1081] = {
    [sym__expression] = STATE(923),
    [sym_conditional_expression] = STATE(923),
    [sym_assignment_expression] = STATE(923),
    [sym_pointer_expression] = STATE(923),
    [sym_logical_expression] = STATE(923),
    [sym_bitwise_expression] = STATE(923),
    [sym_equality_expression] = STATE(923),
    [sym_relational_expression] = STATE(923),
    [sym_shift_expression] = STATE(923),
    [sym_math_expression] = STATE(923),
    [sym_cast_expression] = STATE(923),
    [sym_sizeof_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_call_expression] = STATE(923),
    [sym_field_expression] = STATE(923),
    [sym_compound_literal_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(923),
    [sym_initializer_list] = STATE(924),
    [sym_concatenated_string] = STATE(923),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(3288),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_STAR] = ACTIONS(3353),
    [anon_sym_LBRACK] = ACTIONS(3288),
    [anon_sym_EQ] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3288),
    [anon_sym_STAR_EQ] = ACTIONS(3288),
    [anon_sym_SLASH_EQ] = ACTIONS(3288),
    [anon_sym_PERCENT_EQ] = ACTIONS(3288),
    [anon_sym_PLUS_EQ] = ACTIONS(3288),
    [anon_sym_DASH_EQ] = ACTIONS(3288),
    [anon_sym_LT_LT_EQ] = ACTIONS(3288),
    [anon_sym_GT_GT_EQ] = ACTIONS(3288),
    [anon_sym_AMP_EQ] = ACTIONS(3288),
    [anon_sym_CARET_EQ] = ACTIONS(3288),
    [anon_sym_PIPE_EQ] = ACTIONS(3288),
    [anon_sym_AMP] = ACTIONS(3353),
    [anon_sym_PIPE_PIPE] = ACTIONS(3288),
    [anon_sym_AMP_AMP] = ACTIONS(3288),
    [anon_sym_BANG] = ACTIONS(3355),
    [anon_sym_PIPE] = ACTIONS(3292),
    [anon_sym_CARET] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(3288),
    [anon_sym_BANG_EQ] = ACTIONS(3288),
    [anon_sym_LT] = ACTIONS(3292),
    [anon_sym_GT] = ACTIONS(3292),
    [anon_sym_LT_EQ] = ACTIONS(3288),
    [anon_sym_GT_EQ] = ACTIONS(3288),
    [anon_sym_LT_LT] = ACTIONS(3292),
    [anon_sym_GT_GT] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [anon_sym_DOT] = ACTIONS(3288),
    [anon_sym_DASH_GT] = ACTIONS(3288),
    [sym_number_literal] = ACTIONS(2459),
    [sym_char_literal] = ACTIONS(2459),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(2461),
    [sym_false] = ACTIONS(2461),
    [sym_null] = ACTIONS(2461),
    [sym_identifier] = ACTIONS(2461),
    [sym_comment] = ACTIONS(42),
  },
  [1082] = {
    [sym__expression] = STATE(1222),
    [sym_conditional_expression] = STATE(1222),
    [sym_assignment_expression] = STATE(1222),
    [sym_pointer_expression] = STATE(1222),
    [sym_logical_expression] = STATE(1222),
    [sym_bitwise_expression] = STATE(1222),
    [sym_equality_expression] = STATE(1222),
    [sym_relational_expression] = STATE(1222),
    [sym_shift_expression] = STATE(1222),
    [sym_math_expression] = STATE(1222),
    [sym_cast_expression] = STATE(1222),
    [sym_sizeof_expression] = STATE(1222),
    [sym_subscript_expression] = STATE(1222),
    [sym_call_expression] = STATE(1222),
    [sym_field_expression] = STATE(1222),
    [sym_compound_literal_expression] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1222),
    [sym_concatenated_string] = STATE(1222),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(3357),
    [sym_char_literal] = ACTIONS(3357),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(3359),
    [sym_false] = ACTIONS(3359),
    [sym_null] = ACTIONS(3359),
    [sym_identifier] = ACTIONS(3359),
    [sym_comment] = ACTIONS(42),
  },
  [1083] = {
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_COMMA] = ACTIONS(3361),
    [anon_sym_RPAREN] = ACTIONS(3361),
    [anon_sym_SEMI] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_COLON] = ACTIONS(3361),
    [sym_comment] = ACTIONS(42),
  },
  [1084] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3363),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3365),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3365),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3365),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3365),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3365),
    [anon_sym_extern] = ACTIONS(3363),
    [anon_sym_RBRACE] = ACTIONS(3365),
    [anon_sym_static] = ACTIONS(3363),
    [anon_sym_auto] = ACTIONS(3363),
    [anon_sym_register] = ACTIONS(3363),
    [anon_sym_inline] = ACTIONS(3363),
    [anon_sym_const] = ACTIONS(3363),
    [anon_sym_restrict] = ACTIONS(3363),
    [anon_sym_volatile] = ACTIONS(3363),
    [anon_sym__Atomic] = ACTIONS(3363),
    [anon_sym_unsigned] = ACTIONS(3363),
    [anon_sym_long] = ACTIONS(3363),
    [anon_sym_short] = ACTIONS(3363),
    [sym_primitive_type] = ACTIONS(3363),
    [anon_sym_enum] = ACTIONS(3363),
    [anon_sym_struct] = ACTIONS(3363),
    [anon_sym_union] = ACTIONS(3363),
    [sym_identifier] = ACTIONS(3363),
    [sym_comment] = ACTIONS(42),
  },
  [1085] = {
    [anon_sym_LPAREN] = ACTIONS(3367),
    [anon_sym_COMMA] = ACTIONS(3367),
    [anon_sym_RPAREN] = ACTIONS(3367),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [sym_comment] = ACTIONS(42),
  },
  [1086] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1295),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1295),
    [sym_preproc_directive] = ACTIONS(1295),
    [anon_sym_SEMI] = ACTIONS(1293),
    [anon_sym_typedef] = ACTIONS(1295),
    [anon_sym_extern] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_RBRACE] = ACTIONS(1293),
    [anon_sym_STAR] = ACTIONS(1293),
    [anon_sym_static] = ACTIONS(1295),
    [anon_sym_auto] = ACTIONS(1295),
    [anon_sym_register] = ACTIONS(1295),
    [anon_sym_inline] = ACTIONS(1295),
    [anon_sym_const] = ACTIONS(1295),
    [anon_sym_restrict] = ACTIONS(1295),
    [anon_sym_volatile] = ACTIONS(1295),
    [anon_sym__Atomic] = ACTIONS(1295),
    [anon_sym_unsigned] = ACTIONS(1295),
    [anon_sym_long] = ACTIONS(1295),
    [anon_sym_short] = ACTIONS(1295),
    [sym_primitive_type] = ACTIONS(1295),
    [anon_sym_enum] = ACTIONS(1295),
    [anon_sym_struct] = ACTIONS(1295),
    [anon_sym_union] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(1295),
    [anon_sym_switch] = ACTIONS(1295),
    [anon_sym_case] = ACTIONS(1295),
    [anon_sym_default] = ACTIONS(1295),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_do] = ACTIONS(1295),
    [anon_sym_for] = ACTIONS(1295),
    [anon_sym_return] = ACTIONS(1295),
    [anon_sym_break] = ACTIONS(1295),
    [anon_sym_continue] = ACTIONS(1295),
    [anon_sym_goto] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1295),
    [anon_sym_DASH] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1293),
    [anon_sym_sizeof] = ACTIONS(1295),
    [sym_number_literal] = ACTIONS(1293),
    [sym_char_literal] = ACTIONS(1293),
    [sym_string_literal] = ACTIONS(1293),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_null] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_comment] = ACTIONS(42),
  },
  [1087] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1305),
    [anon_sym_LPAREN] = ACTIONS(1303),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1305),
    [sym_preproc_directive] = ACTIONS(1305),
    [anon_sym_SEMI] = ACTIONS(1303),
    [anon_sym_typedef] = ACTIONS(1305),
    [anon_sym_extern] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1303),
    [anon_sym_RBRACE] = ACTIONS(1303),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1305),
    [anon_sym_auto] = ACTIONS(1305),
    [anon_sym_register] = ACTIONS(1305),
    [anon_sym_inline] = ACTIONS(1305),
    [anon_sym_const] = ACTIONS(1305),
    [anon_sym_restrict] = ACTIONS(1305),
    [anon_sym_volatile] = ACTIONS(1305),
    [anon_sym__Atomic] = ACTIONS(1305),
    [anon_sym_unsigned] = ACTIONS(1305),
    [anon_sym_long] = ACTIONS(1305),
    [anon_sym_short] = ACTIONS(1305),
    [sym_primitive_type] = ACTIONS(1305),
    [anon_sym_enum] = ACTIONS(1305),
    [anon_sym_struct] = ACTIONS(1305),
    [anon_sym_union] = ACTIONS(1305),
    [anon_sym_if] = ACTIONS(1305),
    [anon_sym_switch] = ACTIONS(1305),
    [anon_sym_case] = ACTIONS(1305),
    [anon_sym_default] = ACTIONS(1305),
    [anon_sym_while] = ACTIONS(1305),
    [anon_sym_do] = ACTIONS(1305),
    [anon_sym_for] = ACTIONS(1305),
    [anon_sym_return] = ACTIONS(1305),
    [anon_sym_break] = ACTIONS(1305),
    [anon_sym_continue] = ACTIONS(1305),
    [anon_sym_goto] = ACTIONS(1305),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_BANG] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1303),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_DASH] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1303),
    [anon_sym_PLUS_PLUS] = ACTIONS(1303),
    [anon_sym_sizeof] = ACTIONS(1305),
    [sym_number_literal] = ACTIONS(1303),
    [sym_char_literal] = ACTIONS(1303),
    [sym_string_literal] = ACTIONS(1303),
    [sym_true] = ACTIONS(1305),
    [sym_false] = ACTIONS(1305),
    [sym_null] = ACTIONS(1305),
    [sym_identifier] = ACTIONS(1305),
    [sym_comment] = ACTIONS(42),
  },
  [1088] = {
    [sym__expression] = STATE(923),
    [sym_conditional_expression] = STATE(923),
    [sym_assignment_expression] = STATE(923),
    [sym_pointer_expression] = STATE(923),
    [sym_logical_expression] = STATE(923),
    [sym_bitwise_expression] = STATE(923),
    [sym_equality_expression] = STATE(923),
    [sym_relational_expression] = STATE(923),
    [sym_shift_expression] = STATE(923),
    [sym_math_expression] = STATE(923),
    [sym_cast_expression] = STATE(923),
    [sym_sizeof_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_call_expression] = STATE(923),
    [sym_field_expression] = STATE(923),
    [sym_compound_literal_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(923),
    [sym_initializer_list] = STATE(924),
    [sym_concatenated_string] = STATE(923),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_COMMA] = ACTIONS(3288),
    [anon_sym_RPAREN] = ACTIONS(3288),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_STAR] = ACTIONS(3369),
    [anon_sym_LBRACK] = ACTIONS(3288),
    [anon_sym_EQ] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3288),
    [anon_sym_STAR_EQ] = ACTIONS(3288),
    [anon_sym_SLASH_EQ] = ACTIONS(3288),
    [anon_sym_PERCENT_EQ] = ACTIONS(3288),
    [anon_sym_PLUS_EQ] = ACTIONS(3288),
    [anon_sym_DASH_EQ] = ACTIONS(3288),
    [anon_sym_LT_LT_EQ] = ACTIONS(3288),
    [anon_sym_GT_GT_EQ] = ACTIONS(3288),
    [anon_sym_AMP_EQ] = ACTIONS(3288),
    [anon_sym_CARET_EQ] = ACTIONS(3288),
    [anon_sym_PIPE_EQ] = ACTIONS(3288),
    [anon_sym_AMP] = ACTIONS(3369),
    [anon_sym_PIPE_PIPE] = ACTIONS(3288),
    [anon_sym_AMP_AMP] = ACTIONS(3288),
    [anon_sym_BANG] = ACTIONS(3371),
    [anon_sym_PIPE] = ACTIONS(3292),
    [anon_sym_CARET] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_EQ_EQ] = ACTIONS(3288),
    [anon_sym_BANG_EQ] = ACTIONS(3288),
    [anon_sym_LT] = ACTIONS(3292),
    [anon_sym_GT] = ACTIONS(3292),
    [anon_sym_LT_EQ] = ACTIONS(3288),
    [anon_sym_GT_EQ] = ACTIONS(3288),
    [anon_sym_LT_LT] = ACTIONS(3292),
    [anon_sym_GT_GT] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [anon_sym_DOT] = ACTIONS(3288),
    [anon_sym_DASH_GT] = ACTIONS(3288),
    [sym_number_literal] = ACTIONS(2459),
    [sym_char_literal] = ACTIONS(2459),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(2461),
    [sym_false] = ACTIONS(2461),
    [sym_null] = ACTIONS(2461),
    [sym_identifier] = ACTIONS(2461),
    [sym_comment] = ACTIONS(42),
  },
  [1089] = {
    [sym__expression] = STATE(1223),
    [sym_conditional_expression] = STATE(1223),
    [sym_assignment_expression] = STATE(1223),
    [sym_pointer_expression] = STATE(1223),
    [sym_logical_expression] = STATE(1223),
    [sym_bitwise_expression] = STATE(1223),
    [sym_equality_expression] = STATE(1223),
    [sym_relational_expression] = STATE(1223),
    [sym_shift_expression] = STATE(1223),
    [sym_math_expression] = STATE(1223),
    [sym_cast_expression] = STATE(1223),
    [sym_sizeof_expression] = STATE(1223),
    [sym_subscript_expression] = STATE(1223),
    [sym_call_expression] = STATE(1223),
    [sym_field_expression] = STATE(1223),
    [sym_compound_literal_expression] = STATE(1223),
    [sym_parenthesized_expression] = STATE(1223),
    [sym_concatenated_string] = STATE(1223),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(3373),
    [sym_char_literal] = ACTIONS(3373),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(3375),
    [sym_false] = ACTIONS(3375),
    [sym_null] = ACTIONS(3375),
    [sym_identifier] = ACTIONS(3375),
    [sym_comment] = ACTIONS(42),
  },
  [1090] = {
    [sym_preproc_arg] = ACTIONS(3377),
    [sym_comment] = ACTIONS(50),
  },
  [1091] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(359),
    [anon_sym_LPAREN] = ACTIONS(357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(359),
    [sym_preproc_directive] = ACTIONS(359),
    [anon_sym_SEMI] = ACTIONS(357),
    [anon_sym_typedef] = ACTIONS(359),
    [anon_sym_extern] = ACTIONS(359),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_STAR] = ACTIONS(357),
    [anon_sym_static] = ACTIONS(359),
    [anon_sym_auto] = ACTIONS(359),
    [anon_sym_register] = ACTIONS(359),
    [anon_sym_inline] = ACTIONS(359),
    [anon_sym_const] = ACTIONS(359),
    [anon_sym_restrict] = ACTIONS(359),
    [anon_sym_volatile] = ACTIONS(359),
    [anon_sym__Atomic] = ACTIONS(359),
    [anon_sym_unsigned] = ACTIONS(359),
    [anon_sym_long] = ACTIONS(359),
    [anon_sym_short] = ACTIONS(359),
    [sym_primitive_type] = ACTIONS(359),
    [anon_sym_enum] = ACTIONS(359),
    [anon_sym_struct] = ACTIONS(359),
    [anon_sym_union] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(359),
    [anon_sym_case] = ACTIONS(359),
    [anon_sym_default] = ACTIONS(359),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_do] = ACTIONS(359),
    [anon_sym_for] = ACTIONS(359),
    [anon_sym_return] = ACTIONS(359),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(359),
    [anon_sym_goto] = ACTIONS(359),
    [anon_sym_AMP] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_DASH_DASH] = ACTIONS(357),
    [anon_sym_PLUS_PLUS] = ACTIONS(357),
    [anon_sym_sizeof] = ACTIONS(359),
    [sym_number_literal] = ACTIONS(357),
    [sym_char_literal] = ACTIONS(357),
    [sym_string_literal] = ACTIONS(357),
    [sym_true] = ACTIONS(359),
    [sym_false] = ACTIONS(359),
    [sym_null] = ACTIONS(359),
    [sym_identifier] = ACTIONS(359),
    [sym_comment] = ACTIONS(42),
  },
  [1092] = {
    [anon_sym_LF] = ACTIONS(3379),
    [sym_preproc_arg] = ACTIONS(3381),
    [sym_comment] = ACTIONS(50),
  },
  [1093] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2469),
    [sym_preproc_directive] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_typedef] = ACTIONS(2469),
    [anon_sym_extern] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_STAR] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_auto] = ACTIONS(2469),
    [anon_sym_register] = ACTIONS(2469),
    [anon_sym_inline] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_restrict] = ACTIONS(2469),
    [anon_sym_volatile] = ACTIONS(2469),
    [anon_sym__Atomic] = ACTIONS(2469),
    [anon_sym_unsigned] = ACTIONS(2469),
    [anon_sym_long] = ACTIONS(2469),
    [anon_sym_short] = ACTIONS(2469),
    [sym_primitive_type] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_struct] = ACTIONS(2469),
    [anon_sym_union] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_goto] = ACTIONS(2469),
    [anon_sym_AMP] = ACTIONS(2471),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_sizeof] = ACTIONS(2469),
    [sym_number_literal] = ACTIONS(2471),
    [sym_char_literal] = ACTIONS(2471),
    [sym_string_literal] = ACTIONS(2471),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_identifier] = ACTIONS(2469),
    [sym_comment] = ACTIONS(42),
  },
  [1094] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3383),
    [sym_comment] = ACTIONS(42),
  },
  [1095] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3385),
    [sym_comment] = ACTIONS(42),
  },
  [1096] = {
    [sym_preproc_include] = STATE(986),
    [sym_preproc_def] = STATE(986),
    [sym_preproc_function_def] = STATE(986),
    [sym_preproc_call] = STATE(986),
    [sym_preproc_if_in_compound_statement] = STATE(713),
    [sym_preproc_ifdef_in_compound_statement] = STATE(714),
    [sym_preproc_else_in_compound_statement] = STATE(1230),
    [sym_preproc_elif_in_compound_statement] = STATE(1231),
    [sym_declaration] = STATE(986),
    [sym_type_definition] = STATE(986),
    [sym__declaration_specifiers] = STATE(717),
    [sym_compound_statement] = STATE(986),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(986),
    [sym_expression_statement] = STATE(986),
    [sym_if_statement] = STATE(986),
    [sym_switch_statement] = STATE(986),
    [sym_case_statement] = STATE(986),
    [sym_while_statement] = STATE(986),
    [sym_do_statement] = STATE(986),
    [sym_for_statement] = STATE(986),
    [sym_return_statement] = STATE(986),
    [sym_break_statement] = STATE(986),
    [sym_continue_statement] = STATE(986),
    [sym_goto_statement] = STATE(986),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym__empty_declaration] = STATE(986),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(986),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1639),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3387),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1645),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1647),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1651),
    [sym_preproc_directive] = ACTIONS(1653),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_typedef] = ACTIONS(1657),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(42),
  },
  [1097] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2575),
    [anon_sym_LPAREN] = ACTIONS(2577),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2575),
    [sym_preproc_directive] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(2577),
    [anon_sym_typedef] = ACTIONS(2575),
    [anon_sym_extern] = ACTIONS(2575),
    [anon_sym_LBRACE] = ACTIONS(2577),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_static] = ACTIONS(2575),
    [anon_sym_auto] = ACTIONS(2575),
    [anon_sym_register] = ACTIONS(2575),
    [anon_sym_inline] = ACTIONS(2575),
    [anon_sym_const] = ACTIONS(2575),
    [anon_sym_restrict] = ACTIONS(2575),
    [anon_sym_volatile] = ACTIONS(2575),
    [anon_sym__Atomic] = ACTIONS(2575),
    [anon_sym_unsigned] = ACTIONS(2575),
    [anon_sym_long] = ACTIONS(2575),
    [anon_sym_short] = ACTIONS(2575),
    [sym_primitive_type] = ACTIONS(2575),
    [anon_sym_enum] = ACTIONS(2575),
    [anon_sym_struct] = ACTIONS(2575),
    [anon_sym_union] = ACTIONS(2575),
    [anon_sym_if] = ACTIONS(2575),
    [anon_sym_switch] = ACTIONS(2575),
    [anon_sym_case] = ACTIONS(2575),
    [anon_sym_default] = ACTIONS(2575),
    [anon_sym_while] = ACTIONS(2575),
    [anon_sym_do] = ACTIONS(2575),
    [anon_sym_for] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2575),
    [anon_sym_break] = ACTIONS(2575),
    [anon_sym_continue] = ACTIONS(2575),
    [anon_sym_goto] = ACTIONS(2575),
    [anon_sym_AMP] = ACTIONS(2577),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2575),
    [anon_sym_DASH] = ACTIONS(2575),
    [anon_sym_DASH_DASH] = ACTIONS(2577),
    [anon_sym_PLUS_PLUS] = ACTIONS(2577),
    [anon_sym_sizeof] = ACTIONS(2575),
    [sym_number_literal] = ACTIONS(2577),
    [sym_char_literal] = ACTIONS(2577),
    [sym_string_literal] = ACTIONS(2577),
    [sym_true] = ACTIONS(2575),
    [sym_false] = ACTIONS(2575),
    [sym_null] = ACTIONS(2575),
    [sym_identifier] = ACTIONS(2575),
    [sym_comment] = ACTIONS(42),
  },
  [1098] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3389),
    [sym_comment] = ACTIONS(42),
  },
  [1099] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3391),
    [sym_comment] = ACTIONS(42),
  },
  [1100] = {
    [sym_preproc_include] = STATE(986),
    [sym_preproc_def] = STATE(986),
    [sym_preproc_function_def] = STATE(986),
    [sym_preproc_call] = STATE(986),
    [sym_preproc_if_in_compound_statement] = STATE(713),
    [sym_preproc_ifdef_in_compound_statement] = STATE(714),
    [sym_preproc_else_in_compound_statement] = STATE(1235),
    [sym_preproc_elif_in_compound_statement] = STATE(1236),
    [sym_declaration] = STATE(986),
    [sym_type_definition] = STATE(986),
    [sym__declaration_specifiers] = STATE(717),
    [sym_compound_statement] = STATE(986),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(986),
    [sym_expression_statement] = STATE(986),
    [sym_if_statement] = STATE(986),
    [sym_switch_statement] = STATE(986),
    [sym_case_statement] = STATE(986),
    [sym_while_statement] = STATE(986),
    [sym_do_statement] = STATE(986),
    [sym_for_statement] = STATE(986),
    [sym_return_statement] = STATE(986),
    [sym_break_statement] = STATE(986),
    [sym_continue_statement] = STATE(986),
    [sym_goto_statement] = STATE(986),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym__empty_declaration] = STATE(986),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(986),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1639),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3393),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1645),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1647),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1651),
    [sym_preproc_directive] = ACTIONS(1653),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_typedef] = ACTIONS(1657),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(42),
  },
  [1101] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2585),
    [anon_sym_LPAREN] = ACTIONS(2587),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2585),
    [sym_preproc_directive] = ACTIONS(2585),
    [anon_sym_SEMI] = ACTIONS(2587),
    [anon_sym_typedef] = ACTIONS(2585),
    [anon_sym_extern] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2587),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_static] = ACTIONS(2585),
    [anon_sym_auto] = ACTIONS(2585),
    [anon_sym_register] = ACTIONS(2585),
    [anon_sym_inline] = ACTIONS(2585),
    [anon_sym_const] = ACTIONS(2585),
    [anon_sym_restrict] = ACTIONS(2585),
    [anon_sym_volatile] = ACTIONS(2585),
    [anon_sym__Atomic] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [sym_primitive_type] = ACTIONS(2585),
    [anon_sym_enum] = ACTIONS(2585),
    [anon_sym_struct] = ACTIONS(2585),
    [anon_sym_union] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2585),
    [anon_sym_switch] = ACTIONS(2585),
    [anon_sym_case] = ACTIONS(2585),
    [anon_sym_default] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(2585),
    [anon_sym_do] = ACTIONS(2585),
    [anon_sym_for] = ACTIONS(2585),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_break] = ACTIONS(2585),
    [anon_sym_continue] = ACTIONS(2585),
    [anon_sym_goto] = ACTIONS(2585),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_BANG] = ACTIONS(2587),
    [anon_sym_TILDE] = ACTIONS(2587),
    [anon_sym_PLUS] = ACTIONS(2585),
    [anon_sym_DASH] = ACTIONS(2585),
    [anon_sym_DASH_DASH] = ACTIONS(2587),
    [anon_sym_PLUS_PLUS] = ACTIONS(2587),
    [anon_sym_sizeof] = ACTIONS(2585),
    [sym_number_literal] = ACTIONS(2587),
    [sym_char_literal] = ACTIONS(2587),
    [sym_string_literal] = ACTIONS(2587),
    [sym_true] = ACTIONS(2585),
    [sym_false] = ACTIONS(2585),
    [sym_null] = ACTIONS(2585),
    [sym_identifier] = ACTIONS(2585),
    [sym_comment] = ACTIONS(42),
  },
  [1102] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3395),
    [sym_comment] = ACTIONS(42),
  },
  [1103] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3397),
    [sym_comment] = ACTIONS(42),
  },
  [1104] = {
    [sym_preproc_include] = STATE(986),
    [sym_preproc_def] = STATE(986),
    [sym_preproc_function_def] = STATE(986),
    [sym_preproc_call] = STATE(986),
    [sym_preproc_if_in_compound_statement] = STATE(713),
    [sym_preproc_ifdef_in_compound_statement] = STATE(714),
    [sym_preproc_else_in_compound_statement] = STATE(1240),
    [sym_preproc_elif_in_compound_statement] = STATE(1241),
    [sym_declaration] = STATE(986),
    [sym_type_definition] = STATE(986),
    [sym__declaration_specifiers] = STATE(717),
    [sym_compound_statement] = STATE(986),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(986),
    [sym_expression_statement] = STATE(986),
    [sym_if_statement] = STATE(986),
    [sym_switch_statement] = STATE(986),
    [sym_case_statement] = STATE(986),
    [sym_while_statement] = STATE(986),
    [sym_do_statement] = STATE(986),
    [sym_for_statement] = STATE(986),
    [sym_return_statement] = STATE(986),
    [sym_break_statement] = STATE(986),
    [sym_continue_statement] = STATE(986),
    [sym_goto_statement] = STATE(986),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym__empty_declaration] = STATE(986),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(986),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1639),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3399),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1645),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1647),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1651),
    [sym_preproc_directive] = ACTIONS(1653),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_typedef] = ACTIONS(1657),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(42),
  },
  [1105] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(132),
    [anon_sym_LPAREN] = ACTIONS(130),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(132),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(132),
    [sym_preproc_directive] = ACTIONS(132),
    [anon_sym_SEMI] = ACTIONS(130),
    [anon_sym_typedef] = ACTIONS(132),
    [anon_sym_extern] = ACTIONS(132),
    [anon_sym_LBRACE] = ACTIONS(130),
    [anon_sym_STAR] = ACTIONS(130),
    [anon_sym_static] = ACTIONS(132),
    [anon_sym_auto] = ACTIONS(132),
    [anon_sym_register] = ACTIONS(132),
    [anon_sym_inline] = ACTIONS(132),
    [anon_sym_const] = ACTIONS(132),
    [anon_sym_restrict] = ACTIONS(132),
    [anon_sym_volatile] = ACTIONS(132),
    [anon_sym__Atomic] = ACTIONS(132),
    [anon_sym_unsigned] = ACTIONS(132),
    [anon_sym_long] = ACTIONS(132),
    [anon_sym_short] = ACTIONS(132),
    [sym_primitive_type] = ACTIONS(132),
    [anon_sym_enum] = ACTIONS(132),
    [anon_sym_struct] = ACTIONS(132),
    [anon_sym_union] = ACTIONS(132),
    [anon_sym_if] = ACTIONS(132),
    [anon_sym_switch] = ACTIONS(132),
    [anon_sym_case] = ACTIONS(132),
    [anon_sym_default] = ACTIONS(132),
    [anon_sym_while] = ACTIONS(132),
    [anon_sym_do] = ACTIONS(132),
    [anon_sym_for] = ACTIONS(132),
    [anon_sym_return] = ACTIONS(132),
    [anon_sym_break] = ACTIONS(132),
    [anon_sym_continue] = ACTIONS(132),
    [anon_sym_goto] = ACTIONS(132),
    [anon_sym_AMP] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(130),
    [anon_sym_TILDE] = ACTIONS(130),
    [anon_sym_PLUS] = ACTIONS(132),
    [anon_sym_DASH] = ACTIONS(132),
    [anon_sym_DASH_DASH] = ACTIONS(130),
    [anon_sym_PLUS_PLUS] = ACTIONS(130),
    [anon_sym_sizeof] = ACTIONS(132),
    [sym_number_literal] = ACTIONS(130),
    [sym_char_literal] = ACTIONS(130),
    [sym_string_literal] = ACTIONS(130),
    [sym_true] = ACTIONS(132),
    [sym_false] = ACTIONS(132),
    [sym_null] = ACTIONS(132),
    [sym_identifier] = ACTIONS(132),
    [sym_comment] = ACTIONS(42),
  },
  [1106] = {
    [sym_preproc_params] = STATE(1244),
    [aux_sym_SLASH_LBRACK_BSLASHt_RBRACK_PLUS_SLASH] = ACTIONS(3401),
    [anon_sym_LF] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(138),
    [sym_comment] = ACTIONS(50),
  },
  [1107] = {
    [sym_preproc_include] = STATE(1248),
    [sym_preproc_def] = STATE(1248),
    [sym_preproc_function_def] = STATE(1248),
    [sym_preproc_call] = STATE(1248),
    [sym_preproc_if_in_compound_statement] = STATE(713),
    [sym_preproc_ifdef_in_compound_statement] = STATE(714),
    [sym_preproc_else_in_compound_statement] = STATE(1246),
    [sym_preproc_elif_in_compound_statement] = STATE(1247),
    [sym_declaration] = STATE(1248),
    [sym_type_definition] = STATE(1248),
    [sym__declaration_specifiers] = STATE(717),
    [sym_compound_statement] = STATE(1248),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(1248),
    [sym_expression_statement] = STATE(1248),
    [sym_if_statement] = STATE(1248),
    [sym_switch_statement] = STATE(1248),
    [sym_case_statement] = STATE(1248),
    [sym_while_statement] = STATE(1248),
    [sym_do_statement] = STATE(1248),
    [sym_for_statement] = STATE(1248),
    [sym_return_statement] = STATE(1248),
    [sym_break_statement] = STATE(1248),
    [sym_continue_statement] = STATE(1248),
    [sym_goto_statement] = STATE(1248),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym__empty_declaration] = STATE(1248),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1248),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1639),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3405),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1645),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1647),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1651),
    [sym_preproc_directive] = ACTIONS(1653),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_typedef] = ACTIONS(1657),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(42),
  },
  [1108] = {
    [sym_preproc_include] = STATE(1252),
    [sym_preproc_def] = STATE(1252),
    [sym_preproc_function_def] = STATE(1252),
    [sym_preproc_call] = STATE(1252),
    [sym_preproc_if_in_compound_statement] = STATE(713),
    [sym_preproc_ifdef_in_compound_statement] = STATE(714),
    [sym_preproc_else_in_compound_statement] = STATE(1250),
    [sym_preproc_elif_in_compound_statement] = STATE(1251),
    [sym_declaration] = STATE(1252),
    [sym_type_definition] = STATE(1252),
    [sym__declaration_specifiers] = STATE(717),
    [sym_compound_statement] = STATE(1252),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(1252),
    [sym_expression_statement] = STATE(1252),
    [sym_if_statement] = STATE(1252),
    [sym_switch_statement] = STATE(1252),
    [sym_case_statement] = STATE(1252),
    [sym_while_statement] = STATE(1252),
    [sym_do_statement] = STATE(1252),
    [sym_for_statement] = STATE(1252),
    [sym_return_statement] = STATE(1252),
    [sym_break_statement] = STATE(1252),
    [sym_continue_statement] = STATE(1252),
    [sym_goto_statement] = STATE(1252),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym__empty_declaration] = STATE(1252),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1252),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1639),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3407),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1645),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1647),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1651),
    [sym_preproc_directive] = ACTIONS(1653),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_typedef] = ACTIONS(1657),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(42),
  },
  [1109] = {
    [sym_preproc_include] = STATE(1256),
    [sym_preproc_def] = STATE(1256),
    [sym_preproc_function_def] = STATE(1256),
    [sym_preproc_call] = STATE(1256),
    [sym_preproc_if_in_compound_statement] = STATE(713),
    [sym_preproc_ifdef_in_compound_statement] = STATE(714),
    [sym_preproc_else_in_compound_statement] = STATE(1254),
    [sym_preproc_elif_in_compound_statement] = STATE(1255),
    [sym_declaration] = STATE(1256),
    [sym_type_definition] = STATE(1256),
    [sym__declaration_specifiers] = STATE(717),
    [sym_compound_statement] = STATE(1256),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(1256),
    [sym_expression_statement] = STATE(1256),
    [sym_if_statement] = STATE(1256),
    [sym_switch_statement] = STATE(1256),
    [sym_case_statement] = STATE(1256),
    [sym_while_statement] = STATE(1256),
    [sym_do_statement] = STATE(1256),
    [sym_for_statement] = STATE(1256),
    [sym_return_statement] = STATE(1256),
    [sym_break_statement] = STATE(1256),
    [sym_continue_statement] = STATE(1256),
    [sym_goto_statement] = STATE(1256),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym__empty_declaration] = STATE(1256),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1256),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1639),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3409),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1645),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1647),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1651),
    [sym_preproc_directive] = ACTIONS(1653),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_typedef] = ACTIONS(1657),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(42),
  },
  [1110] = {
    [sym_preproc_arg] = ACTIONS(3411),
    [sym_comment] = ACTIONS(50),
  },
  [1111] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(170),
    [anon_sym_LPAREN] = ACTIONS(168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(170),
    [sym_preproc_directive] = ACTIONS(170),
    [anon_sym_SEMI] = ACTIONS(168),
    [anon_sym_typedef] = ACTIONS(170),
    [anon_sym_extern] = ACTIONS(170),
    [anon_sym_LBRACE] = ACTIONS(168),
    [anon_sym_STAR] = ACTIONS(168),
    [anon_sym_static] = ACTIONS(170),
    [anon_sym_auto] = ACTIONS(170),
    [anon_sym_register] = ACTIONS(170),
    [anon_sym_inline] = ACTIONS(170),
    [anon_sym_const] = ACTIONS(170),
    [anon_sym_restrict] = ACTIONS(170),
    [anon_sym_volatile] = ACTIONS(170),
    [anon_sym__Atomic] = ACTIONS(170),
    [anon_sym_unsigned] = ACTIONS(170),
    [anon_sym_long] = ACTIONS(170),
    [anon_sym_short] = ACTIONS(170),
    [sym_primitive_type] = ACTIONS(170),
    [anon_sym_enum] = ACTIONS(170),
    [anon_sym_struct] = ACTIONS(170),
    [anon_sym_union] = ACTIONS(170),
    [anon_sym_if] = ACTIONS(170),
    [anon_sym_switch] = ACTIONS(170),
    [anon_sym_case] = ACTIONS(170),
    [anon_sym_default] = ACTIONS(170),
    [anon_sym_while] = ACTIONS(170),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(170),
    [anon_sym_return] = ACTIONS(170),
    [anon_sym_break] = ACTIONS(170),
    [anon_sym_continue] = ACTIONS(170),
    [anon_sym_goto] = ACTIONS(170),
    [anon_sym_AMP] = ACTIONS(168),
    [anon_sym_BANG] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(168),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_DASH] = ACTIONS(170),
    [anon_sym_DASH_DASH] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(168),
    [anon_sym_sizeof] = ACTIONS(170),
    [sym_number_literal] = ACTIONS(168),
    [sym_char_literal] = ACTIONS(168),
    [sym_string_literal] = ACTIONS(168),
    [sym_true] = ACTIONS(170),
    [sym_false] = ACTIONS(170),
    [sym_null] = ACTIONS(170),
    [sym_identifier] = ACTIONS(170),
    [sym_comment] = ACTIONS(42),
  },
  [1112] = {
    [sym__type_declarator] = STATE(1258),
    [sym_pointer_type_declarator] = STATE(99),
    [sym_function_type_declarator] = STATE(100),
    [sym_array_type_declarator] = STATE(101),
    [anon_sym_LPAREN] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(187),
    [sym_identifier] = ACTIONS(189),
    [sym_comment] = ACTIONS(42),
  },
  [1113] = {
    [sym_type_qualifier] = STATE(103),
    [sym__type_specifier] = STATE(1259),
    [sym_sized_type_specifier] = STATE(1259),
    [sym_enum_specifier] = STATE(1259),
    [sym_struct_specifier] = STATE(1259),
    [sym_union_specifier] = STATE(1259),
    [sym_macro_type_specifier] = STATE(1259),
    [aux_sym_type_definition_repeat1] = STATE(103),
    [aux_sym_sized_type_specifier_repeat1] = STATE(36),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(62),
    [anon_sym_long] = ACTIONS(62),
    [anon_sym_short] = ACTIONS(62),
    [sym_primitive_type] = ACTIONS(3413),
    [anon_sym_enum] = ACTIONS(66),
    [anon_sym_struct] = ACTIONS(68),
    [anon_sym_union] = ACTIONS(70),
    [sym_identifier] = ACTIONS(72),
    [sym_comment] = ACTIONS(42),
  },
  [1114] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1045),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1047),
    [sym_preproc_directive] = ACTIONS(1047),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_typedef] = ACTIONS(1047),
    [anon_sym_extern] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_auto] = ACTIONS(1047),
    [anon_sym_register] = ACTIONS(1047),
    [anon_sym_inline] = ACTIONS(1047),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_restrict] = ACTIONS(1047),
    [anon_sym_volatile] = ACTIONS(1047),
    [anon_sym__Atomic] = ACTIONS(1047),
    [anon_sym_unsigned] = ACTIONS(1047),
    [anon_sym_long] = ACTIONS(1047),
    [anon_sym_short] = ACTIONS(1047),
    [sym_primitive_type] = ACTIONS(1047),
    [anon_sym_enum] = ACTIONS(1047),
    [anon_sym_struct] = ACTIONS(1047),
    [anon_sym_union] = ACTIONS(1047),
    [anon_sym_if] = ACTIONS(1047),
    [anon_sym_switch] = ACTIONS(1047),
    [anon_sym_case] = ACTIONS(1047),
    [anon_sym_default] = ACTIONS(1047),
    [anon_sym_while] = ACTIONS(1047),
    [anon_sym_do] = ACTIONS(1047),
    [anon_sym_for] = ACTIONS(1047),
    [anon_sym_return] = ACTIONS(1047),
    [anon_sym_break] = ACTIONS(1047),
    [anon_sym_continue] = ACTIONS(1047),
    [anon_sym_goto] = ACTIONS(1047),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_PLUS] = ACTIONS(1047),
    [anon_sym_DASH] = ACTIONS(1047),
    [anon_sym_DASH_DASH] = ACTIONS(1045),
    [anon_sym_PLUS_PLUS] = ACTIONS(1045),
    [anon_sym_sizeof] = ACTIONS(1047),
    [sym_number_literal] = ACTIONS(1045),
    [sym_char_literal] = ACTIONS(1045),
    [sym_string_literal] = ACTIONS(1045),
    [sym_true] = ACTIONS(1047),
    [sym_false] = ACTIONS(1047),
    [sym_null] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [sym_comment] = ACTIONS(42),
  },
  [1115] = {
    [sym_preproc_include] = STATE(505),
    [sym_preproc_def] = STATE(505),
    [sym_preproc_function_def] = STATE(505),
    [sym_preproc_call] = STATE(505),
    [sym_preproc_if_in_compound_statement] = STATE(275),
    [sym_preproc_ifdef_in_compound_statement] = STATE(276),
    [sym_declaration] = STATE(505),
    [sym_type_definition] = STATE(505),
    [sym__declaration_specifiers] = STATE(277),
    [sym_compound_statement] = STATE(505),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(505),
    [sym_expression_statement] = STATE(505),
    [sym_if_statement] = STATE(505),
    [sym_switch_statement] = STATE(505),
    [sym_case_statement] = STATE(505),
    [sym_while_statement] = STATE(505),
    [sym_do_statement] = STATE(505),
    [sym_for_statement] = STATE(505),
    [sym_return_statement] = STATE(505),
    [sym_break_statement] = STATE(505),
    [sym_continue_statement] = STATE(505),
    [sym_goto_statement] = STATE(505),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [sym__empty_declaration] = STATE(505),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(505),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(577),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(579),
    [sym_preproc_directive] = ACTIONS(581),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_typedef] = ACTIONS(585),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(631),
    [sym_comment] = ACTIONS(42),
  },
  [1116] = {
    [sym__expression] = STATE(1261),
    [sym_conditional_expression] = STATE(1261),
    [sym_assignment_expression] = STATE(1261),
    [sym_pointer_expression] = STATE(1261),
    [sym_logical_expression] = STATE(1261),
    [sym_bitwise_expression] = STATE(1261),
    [sym_equality_expression] = STATE(1261),
    [sym_relational_expression] = STATE(1261),
    [sym_shift_expression] = STATE(1261),
    [sym_math_expression] = STATE(1261),
    [sym_cast_expression] = STATE(1261),
    [sym_sizeof_expression] = STATE(1261),
    [sym_subscript_expression] = STATE(1261),
    [sym_call_expression] = STATE(1261),
    [sym_field_expression] = STATE(1261),
    [sym_compound_literal_expression] = STATE(1261),
    [sym_parenthesized_expression] = STATE(1261),
    [sym_concatenated_string] = STATE(1261),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(3417),
    [sym_char_literal] = ACTIONS(3417),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(3419),
    [sym_false] = ACTIONS(3419),
    [sym_null] = ACTIONS(3419),
    [sym_identifier] = ACTIONS(3419),
    [sym_comment] = ACTIONS(42),
  },
  [1117] = {
    [sym__expression] = STATE(1262),
    [sym_conditional_expression] = STATE(1262),
    [sym_assignment_expression] = STATE(1262),
    [sym_pointer_expression] = STATE(1262),
    [sym_logical_expression] = STATE(1262),
    [sym_bitwise_expression] = STATE(1262),
    [sym_equality_expression] = STATE(1262),
    [sym_relational_expression] = STATE(1262),
    [sym_shift_expression] = STATE(1262),
    [sym_math_expression] = STATE(1262),
    [sym_cast_expression] = STATE(1262),
    [sym_sizeof_expression] = STATE(1262),
    [sym_subscript_expression] = STATE(1262),
    [sym_call_expression] = STATE(1262),
    [sym_field_expression] = STATE(1262),
    [sym_compound_literal_expression] = STATE(1262),
    [sym_parenthesized_expression] = STATE(1262),
    [sym_concatenated_string] = STATE(1262),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(3421),
    [sym_char_literal] = ACTIONS(3421),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(3423),
    [sym_false] = ACTIONS(3423),
    [sym_null] = ACTIONS(3423),
    [sym_identifier] = ACTIONS(3423),
    [sym_comment] = ACTIONS(42),
  },
  [1118] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1737),
    [anon_sym_COLON] = ACTIONS(3425),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1743),
    [anon_sym_SLASH_EQ] = ACTIONS(1743),
    [anon_sym_PERCENT_EQ] = ACTIONS(1743),
    [anon_sym_PLUS_EQ] = ACTIONS(1743),
    [anon_sym_DASH_EQ] = ACTIONS(1743),
    [anon_sym_LT_LT_EQ] = ACTIONS(1743),
    [anon_sym_GT_GT_EQ] = ACTIONS(1743),
    [anon_sym_AMP_EQ] = ACTIONS(1743),
    [anon_sym_CARET_EQ] = ACTIONS(1743),
    [anon_sym_PIPE_EQ] = ACTIONS(1743),
    [anon_sym_AMP] = ACTIONS(1745),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_AMP_AMP] = ACTIONS(1749),
    [anon_sym_PIPE] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_GT] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1119] = {
    [sym_declaration] = STATE(1265),
    [sym_type_definition] = STATE(1265),
    [sym__declaration_specifiers] = STATE(1266),
    [sym_compound_statement] = STATE(1265),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(1265),
    [sym_expression_statement] = STATE(1265),
    [sym_if_statement] = STATE(1265),
    [sym_switch_statement] = STATE(1265),
    [sym_case_statement] = STATE(1265),
    [sym_while_statement] = STATE(1265),
    [sym_do_statement] = STATE(1265),
    [sym_for_statement] = STATE(1265),
    [sym_return_statement] = STATE(1265),
    [sym_break_statement] = STATE(1265),
    [sym_continue_statement] = STATE(1265),
    [sym_goto_statement] = STATE(1265),
    [sym__expression] = STATE(954),
    [sym_comma_expression] = STATE(955),
    [sym_conditional_expression] = STATE(954),
    [sym_assignment_expression] = STATE(954),
    [sym_pointer_expression] = STATE(954),
    [sym_logical_expression] = STATE(954),
    [sym_bitwise_expression] = STATE(954),
    [sym_equality_expression] = STATE(954),
    [sym_relational_expression] = STATE(954),
    [sym_shift_expression] = STATE(954),
    [sym_math_expression] = STATE(954),
    [sym_cast_expression] = STATE(954),
    [sym_sizeof_expression] = STATE(954),
    [sym_subscript_expression] = STATE(954),
    [sym_call_expression] = STATE(954),
    [sym_field_expression] = STATE(954),
    [sym_compound_literal_expression] = STATE(954),
    [sym_parenthesized_expression] = STATE(954),
    [sym_concatenated_string] = STATE(954),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_typedef] = ACTIONS(2493),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(2497),
    [anon_sym_switch] = ACTIONS(2499),
    [anon_sym_case] = ACTIONS(2501),
    [anon_sym_default] = ACTIONS(2503),
    [anon_sym_while] = ACTIONS(2505),
    [anon_sym_do] = ACTIONS(2507),
    [anon_sym_for] = ACTIONS(2509),
    [anon_sym_return] = ACTIONS(2511),
    [anon_sym_break] = ACTIONS(2513),
    [anon_sym_continue] = ACTIONS(2515),
    [anon_sym_goto] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(2519),
    [sym_char_literal] = ACTIONS(2519),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(2521),
    [sym_false] = ACTIONS(2521),
    [sym_null] = ACTIONS(2521),
    [sym_identifier] = ACTIONS(3427),
    [sym_comment] = ACTIONS(42),
  },
  [1120] = {
    [sym__expression] = STATE(1267),
    [sym_conditional_expression] = STATE(1267),
    [sym_assignment_expression] = STATE(1267),
    [sym_pointer_expression] = STATE(1267),
    [sym_logical_expression] = STATE(1267),
    [sym_bitwise_expression] = STATE(1267),
    [sym_equality_expression] = STATE(1267),
    [sym_relational_expression] = STATE(1267),
    [sym_shift_expression] = STATE(1267),
    [sym_math_expression] = STATE(1267),
    [sym_cast_expression] = STATE(1267),
    [sym_sizeof_expression] = STATE(1267),
    [sym_subscript_expression] = STATE(1267),
    [sym_call_expression] = STATE(1267),
    [sym_field_expression] = STATE(1267),
    [sym_compound_literal_expression] = STATE(1267),
    [sym_parenthesized_expression] = STATE(1267),
    [sym_concatenated_string] = STATE(1267),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(3429),
    [sym_char_literal] = ACTIONS(3429),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(3431),
    [sym_false] = ACTIONS(3431),
    [sym_null] = ACTIONS(3431),
    [sym_identifier] = ACTIONS(3431),
    [sym_comment] = ACTIONS(42),
  },
  [1121] = {
    [anon_sym_while] = ACTIONS(3433),
    [sym_comment] = ACTIONS(42),
  },
  [1122] = {
    [sym_declaration] = STATE(1269),
    [sym__declaration_specifiers] = STATE(773),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym__expression] = STATE(1270),
    [sym_conditional_expression] = STATE(1270),
    [sym_assignment_expression] = STATE(1270),
    [sym_pointer_expression] = STATE(1270),
    [sym_logical_expression] = STATE(1270),
    [sym_bitwise_expression] = STATE(1270),
    [sym_equality_expression] = STATE(1270),
    [sym_relational_expression] = STATE(1270),
    [sym_shift_expression] = STATE(1270),
    [sym_math_expression] = STATE(1270),
    [sym_cast_expression] = STATE(1270),
    [sym_sizeof_expression] = STATE(1270),
    [sym_subscript_expression] = STATE(1270),
    [sym_call_expression] = STATE(1270),
    [sym_field_expression] = STATE(1270),
    [sym_compound_literal_expression] = STATE(1270),
    [sym_parenthesized_expression] = STATE(1270),
    [sym_concatenated_string] = STATE(1270),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(3435),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(3437),
    [sym_char_literal] = ACTIONS(3437),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(3439),
    [sym_false] = ACTIONS(3439),
    [sym_null] = ACTIONS(3439),
    [sym_identifier] = ACTIONS(1795),
    [sym_comment] = ACTIONS(42),
  },
  [1123] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1797),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1797),
    [sym_preproc_directive] = ACTIONS(1797),
    [anon_sym_SEMI] = ACTIONS(1799),
    [anon_sym_typedef] = ACTIONS(1797),
    [anon_sym_extern] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1799),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_static] = ACTIONS(1797),
    [anon_sym_auto] = ACTIONS(1797),
    [anon_sym_register] = ACTIONS(1797),
    [anon_sym_inline] = ACTIONS(1797),
    [anon_sym_const] = ACTIONS(1797),
    [anon_sym_restrict] = ACTIONS(1797),
    [anon_sym_volatile] = ACTIONS(1797),
    [anon_sym__Atomic] = ACTIONS(1797),
    [anon_sym_unsigned] = ACTIONS(1797),
    [anon_sym_long] = ACTIONS(1797),
    [anon_sym_short] = ACTIONS(1797),
    [sym_primitive_type] = ACTIONS(1797),
    [anon_sym_enum] = ACTIONS(1797),
    [anon_sym_struct] = ACTIONS(1797),
    [anon_sym_union] = ACTIONS(1797),
    [anon_sym_if] = ACTIONS(1797),
    [anon_sym_switch] = ACTIONS(1797),
    [anon_sym_case] = ACTIONS(1797),
    [anon_sym_default] = ACTIONS(1797),
    [anon_sym_while] = ACTIONS(1797),
    [anon_sym_do] = ACTIONS(1797),
    [anon_sym_for] = ACTIONS(1797),
    [anon_sym_return] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1797),
    [anon_sym_continue] = ACTIONS(1797),
    [anon_sym_goto] = ACTIONS(1797),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_sizeof] = ACTIONS(1797),
    [sym_number_literal] = ACTIONS(1799),
    [sym_char_literal] = ACTIONS(1799),
    [sym_string_literal] = ACTIONS(1799),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [sym_null] = ACTIONS(1797),
    [sym_identifier] = ACTIONS(1797),
    [sym_comment] = ACTIONS(42),
  },
  [1124] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(3441),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1125] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1803),
    [anon_sym_LPAREN] = ACTIONS(1805),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1803),
    [sym_preproc_directive] = ACTIONS(1803),
    [anon_sym_SEMI] = ACTIONS(1805),
    [anon_sym_typedef] = ACTIONS(1803),
    [anon_sym_extern] = ACTIONS(1803),
    [anon_sym_LBRACE] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_static] = ACTIONS(1803),
    [anon_sym_auto] = ACTIONS(1803),
    [anon_sym_register] = ACTIONS(1803),
    [anon_sym_inline] = ACTIONS(1803),
    [anon_sym_const] = ACTIONS(1803),
    [anon_sym_restrict] = ACTIONS(1803),
    [anon_sym_volatile] = ACTIONS(1803),
    [anon_sym__Atomic] = ACTIONS(1803),
    [anon_sym_unsigned] = ACTIONS(1803),
    [anon_sym_long] = ACTIONS(1803),
    [anon_sym_short] = ACTIONS(1803),
    [sym_primitive_type] = ACTIONS(1803),
    [anon_sym_enum] = ACTIONS(1803),
    [anon_sym_struct] = ACTIONS(1803),
    [anon_sym_union] = ACTIONS(1803),
    [anon_sym_if] = ACTIONS(1803),
    [anon_sym_switch] = ACTIONS(1803),
    [anon_sym_case] = ACTIONS(1803),
    [anon_sym_default] = ACTIONS(1803),
    [anon_sym_while] = ACTIONS(1803),
    [anon_sym_do] = ACTIONS(1803),
    [anon_sym_for] = ACTIONS(1803),
    [anon_sym_return] = ACTIONS(1803),
    [anon_sym_break] = ACTIONS(1803),
    [anon_sym_continue] = ACTIONS(1803),
    [anon_sym_goto] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1803),
    [anon_sym_DASH] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1805),
    [anon_sym_PLUS_PLUS] = ACTIONS(1805),
    [anon_sym_sizeof] = ACTIONS(1803),
    [sym_number_literal] = ACTIONS(1805),
    [sym_char_literal] = ACTIONS(1805),
    [sym_string_literal] = ACTIONS(1805),
    [sym_true] = ACTIONS(1803),
    [sym_false] = ACTIONS(1803),
    [sym_null] = ACTIONS(1803),
    [sym_identifier] = ACTIONS(1803),
    [sym_comment] = ACTIONS(42),
  },
  [1126] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1807),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1807),
    [sym_preproc_directive] = ACTIONS(1807),
    [anon_sym_SEMI] = ACTIONS(1809),
    [anon_sym_typedef] = ACTIONS(1807),
    [anon_sym_extern] = ACTIONS(1807),
    [anon_sym_LBRACE] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_static] = ACTIONS(1807),
    [anon_sym_auto] = ACTIONS(1807),
    [anon_sym_register] = ACTIONS(1807),
    [anon_sym_inline] = ACTIONS(1807),
    [anon_sym_const] = ACTIONS(1807),
    [anon_sym_restrict] = ACTIONS(1807),
    [anon_sym_volatile] = ACTIONS(1807),
    [anon_sym__Atomic] = ACTIONS(1807),
    [anon_sym_unsigned] = ACTIONS(1807),
    [anon_sym_long] = ACTIONS(1807),
    [anon_sym_short] = ACTIONS(1807),
    [sym_primitive_type] = ACTIONS(1807),
    [anon_sym_enum] = ACTIONS(1807),
    [anon_sym_struct] = ACTIONS(1807),
    [anon_sym_union] = ACTIONS(1807),
    [anon_sym_if] = ACTIONS(1807),
    [anon_sym_switch] = ACTIONS(1807),
    [anon_sym_case] = ACTIONS(1807),
    [anon_sym_default] = ACTIONS(1807),
    [anon_sym_while] = ACTIONS(1807),
    [anon_sym_do] = ACTIONS(1807),
    [anon_sym_for] = ACTIONS(1807),
    [anon_sym_return] = ACTIONS(1807),
    [anon_sym_break] = ACTIONS(1807),
    [anon_sym_continue] = ACTIONS(1807),
    [anon_sym_goto] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1809),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1809),
    [anon_sym_PLUS_PLUS] = ACTIONS(1809),
    [anon_sym_sizeof] = ACTIONS(1807),
    [sym_number_literal] = ACTIONS(1809),
    [sym_char_literal] = ACTIONS(1809),
    [sym_string_literal] = ACTIONS(1809),
    [sym_true] = ACTIONS(1807),
    [sym_false] = ACTIONS(1807),
    [sym_null] = ACTIONS(1807),
    [sym_identifier] = ACTIONS(1807),
    [sym_comment] = ACTIONS(42),
  },
  [1127] = {
    [anon_sym_SEMI] = ACTIONS(3443),
    [sym_comment] = ACTIONS(42),
  },
  [1128] = {
    [sym_compound_statement] = STATE(1274),
    [sym_labeled_statement] = STATE(1274),
    [sym_expression_statement] = STATE(1274),
    [sym_if_statement] = STATE(1274),
    [sym_switch_statement] = STATE(1274),
    [sym_case_statement] = STATE(1274),
    [sym_while_statement] = STATE(1274),
    [sym_do_statement] = STATE(1274),
    [sym_for_statement] = STATE(1274),
    [sym_return_statement] = STATE(1274),
    [sym_break_statement] = STATE(1274),
    [sym_continue_statement] = STATE(1274),
    [sym_goto_statement] = STATE(1274),
    [sym__expression] = STATE(954),
    [sym_comma_expression] = STATE(955),
    [sym_conditional_expression] = STATE(954),
    [sym_assignment_expression] = STATE(954),
    [sym_pointer_expression] = STATE(954),
    [sym_logical_expression] = STATE(954),
    [sym_bitwise_expression] = STATE(954),
    [sym_equality_expression] = STATE(954),
    [sym_relational_expression] = STATE(954),
    [sym_shift_expression] = STATE(954),
    [sym_math_expression] = STATE(954),
    [sym_cast_expression] = STATE(954),
    [sym_sizeof_expression] = STATE(954),
    [sym_subscript_expression] = STATE(954),
    [sym_call_expression] = STATE(954),
    [sym_field_expression] = STATE(954),
    [sym_compound_literal_expression] = STATE(954),
    [sym_parenthesized_expression] = STATE(954),
    [sym_concatenated_string] = STATE(954),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(2497),
    [anon_sym_switch] = ACTIONS(2499),
    [anon_sym_case] = ACTIONS(2501),
    [anon_sym_default] = ACTIONS(2503),
    [anon_sym_while] = ACTIONS(2505),
    [anon_sym_do] = ACTIONS(2507),
    [anon_sym_for] = ACTIONS(2509),
    [anon_sym_return] = ACTIONS(2511),
    [anon_sym_break] = ACTIONS(2513),
    [anon_sym_continue] = ACTIONS(2515),
    [anon_sym_goto] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(2519),
    [sym_char_literal] = ACTIONS(2519),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(2521),
    [sym_false] = ACTIONS(2521),
    [sym_null] = ACTIONS(2521),
    [sym_identifier] = ACTIONS(3445),
    [sym_comment] = ACTIONS(42),
  },
  [1129] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(258),
    [anon_sym_LPAREN] = ACTIONS(256),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(258),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(258),
    [sym_preproc_directive] = ACTIONS(258),
    [anon_sym_SEMI] = ACTIONS(256),
    [anon_sym_typedef] = ACTIONS(258),
    [anon_sym_extern] = ACTIONS(258),
    [anon_sym_LBRACE] = ACTIONS(256),
    [anon_sym_STAR] = ACTIONS(256),
    [anon_sym_static] = ACTIONS(258),
    [anon_sym_auto] = ACTIONS(258),
    [anon_sym_register] = ACTIONS(258),
    [anon_sym_inline] = ACTIONS(258),
    [anon_sym_const] = ACTIONS(258),
    [anon_sym_restrict] = ACTIONS(258),
    [anon_sym_volatile] = ACTIONS(258),
    [anon_sym__Atomic] = ACTIONS(258),
    [anon_sym_unsigned] = ACTIONS(258),
    [anon_sym_long] = ACTIONS(258),
    [anon_sym_short] = ACTIONS(258),
    [sym_primitive_type] = ACTIONS(258),
    [anon_sym_enum] = ACTIONS(258),
    [anon_sym_struct] = ACTIONS(258),
    [anon_sym_union] = ACTIONS(258),
    [anon_sym_if] = ACTIONS(258),
    [anon_sym_switch] = ACTIONS(258),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_default] = ACTIONS(258),
    [anon_sym_while] = ACTIONS(258),
    [anon_sym_do] = ACTIONS(258),
    [anon_sym_for] = ACTIONS(258),
    [anon_sym_return] = ACTIONS(258),
    [anon_sym_break] = ACTIONS(258),
    [anon_sym_continue] = ACTIONS(258),
    [anon_sym_goto] = ACTIONS(258),
    [anon_sym_AMP] = ACTIONS(256),
    [anon_sym_BANG] = ACTIONS(256),
    [anon_sym_TILDE] = ACTIONS(256),
    [anon_sym_PLUS] = ACTIONS(258),
    [anon_sym_DASH] = ACTIONS(258),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_sizeof] = ACTIONS(258),
    [sym_number_literal] = ACTIONS(256),
    [sym_char_literal] = ACTIONS(256),
    [sym_string_literal] = ACTIONS(256),
    [sym_true] = ACTIONS(258),
    [sym_false] = ACTIONS(258),
    [sym_null] = ACTIONS(258),
    [sym_identifier] = ACTIONS(258),
    [sym_comment] = ACTIONS(42),
  },
  [1130] = {
    [sym_parameter_list] = STATE(145),
    [aux_sym_declaration_repeat1] = STATE(1276),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(3447),
    [anon_sym_LBRACK] = ACTIONS(270),
    [anon_sym_EQ] = ACTIONS(272),
    [sym_comment] = ACTIONS(42),
  },
  [1131] = {
    [aux_sym_declaration_repeat1] = STATE(1276),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(3447),
    [sym_comment] = ACTIONS(42),
  },
  [1132] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1849),
    [anon_sym_LPAREN] = ACTIONS(1851),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1849),
    [sym_preproc_directive] = ACTIONS(1849),
    [anon_sym_SEMI] = ACTIONS(1851),
    [anon_sym_typedef] = ACTIONS(1849),
    [anon_sym_extern] = ACTIONS(1849),
    [anon_sym_LBRACE] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1851),
    [anon_sym_static] = ACTIONS(1849),
    [anon_sym_auto] = ACTIONS(1849),
    [anon_sym_register] = ACTIONS(1849),
    [anon_sym_inline] = ACTIONS(1849),
    [anon_sym_const] = ACTIONS(1849),
    [anon_sym_restrict] = ACTIONS(1849),
    [anon_sym_volatile] = ACTIONS(1849),
    [anon_sym__Atomic] = ACTIONS(1849),
    [anon_sym_unsigned] = ACTIONS(1849),
    [anon_sym_long] = ACTIONS(1849),
    [anon_sym_short] = ACTIONS(1849),
    [sym_primitive_type] = ACTIONS(1849),
    [anon_sym_enum] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1849),
    [anon_sym_union] = ACTIONS(1849),
    [anon_sym_if] = ACTIONS(1849),
    [anon_sym_switch] = ACTIONS(1849),
    [anon_sym_case] = ACTIONS(1849),
    [anon_sym_default] = ACTIONS(1849),
    [anon_sym_while] = ACTIONS(1849),
    [anon_sym_do] = ACTIONS(1849),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(1849),
    [anon_sym_break] = ACTIONS(1849),
    [anon_sym_continue] = ACTIONS(1849),
    [anon_sym_goto] = ACTIONS(1849),
    [anon_sym_AMP] = ACTIONS(1851),
    [anon_sym_BANG] = ACTIONS(1851),
    [anon_sym_TILDE] = ACTIONS(1851),
    [anon_sym_PLUS] = ACTIONS(1849),
    [anon_sym_DASH] = ACTIONS(1849),
    [anon_sym_DASH_DASH] = ACTIONS(1851),
    [anon_sym_PLUS_PLUS] = ACTIONS(1851),
    [anon_sym_sizeof] = ACTIONS(1849),
    [sym_number_literal] = ACTIONS(1851),
    [sym_char_literal] = ACTIONS(1851),
    [sym_string_literal] = ACTIONS(1851),
    [sym_true] = ACTIONS(1849),
    [sym_false] = ACTIONS(1849),
    [sym_null] = ACTIONS(1849),
    [sym_identifier] = ACTIONS(1849),
    [sym_comment] = ACTIONS(42),
  },
  [1133] = {
    [sym_preproc_include] = STATE(1133),
    [sym_preproc_def] = STATE(1133),
    [sym_preproc_function_def] = STATE(1133),
    [sym_preproc_call] = STATE(1133),
    [sym_preproc_if_in_compound_statement] = STATE(951),
    [sym_preproc_ifdef_in_compound_statement] = STATE(952),
    [sym_declaration] = STATE(1133),
    [sym_type_definition] = STATE(1133),
    [sym__declaration_specifiers] = STATE(953),
    [sym_compound_statement] = STATE(1133),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(1133),
    [sym_expression_statement] = STATE(1133),
    [sym_if_statement] = STATE(1133),
    [sym_switch_statement] = STATE(1133),
    [sym_case_statement] = STATE(1133),
    [sym_while_statement] = STATE(1133),
    [sym_do_statement] = STATE(1133),
    [sym_for_statement] = STATE(1133),
    [sym_return_statement] = STATE(1133),
    [sym_break_statement] = STATE(1133),
    [sym_continue_statement] = STATE(1133),
    [sym_goto_statement] = STATE(1133),
    [sym__expression] = STATE(954),
    [sym_comma_expression] = STATE(955),
    [sym_conditional_expression] = STATE(954),
    [sym_assignment_expression] = STATE(954),
    [sym_pointer_expression] = STATE(954),
    [sym_logical_expression] = STATE(954),
    [sym_bitwise_expression] = STATE(954),
    [sym_equality_expression] = STATE(954),
    [sym_relational_expression] = STATE(954),
    [sym_shift_expression] = STATE(954),
    [sym_math_expression] = STATE(954),
    [sym_cast_expression] = STATE(954),
    [sym_sizeof_expression] = STATE(954),
    [sym_subscript_expression] = STATE(954),
    [sym_call_expression] = STATE(954),
    [sym_field_expression] = STATE(954),
    [sym_compound_literal_expression] = STATE(954),
    [sym_parenthesized_expression] = STATE(954),
    [sym_concatenated_string] = STATE(954),
    [sym__empty_declaration] = STATE(1133),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1133),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3449),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3452),
    [anon_sym_LPAREN] = ACTIONS(1921),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3455),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3069),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3458),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3461),
    [sym_preproc_directive] = ACTIONS(3464),
    [anon_sym_SEMI] = ACTIONS(3467),
    [anon_sym_typedef] = ACTIONS(3470),
    [anon_sym_extern] = ACTIONS(1942),
    [anon_sym_LBRACE] = ACTIONS(3473),
    [anon_sym_STAR] = ACTIONS(1950),
    [anon_sym_static] = ACTIONS(1942),
    [anon_sym_auto] = ACTIONS(1942),
    [anon_sym_register] = ACTIONS(1942),
    [anon_sym_inline] = ACTIONS(1942),
    [anon_sym_const] = ACTIONS(1953),
    [anon_sym_restrict] = ACTIONS(1953),
    [anon_sym_volatile] = ACTIONS(1953),
    [anon_sym__Atomic] = ACTIONS(1953),
    [anon_sym_unsigned] = ACTIONS(1956),
    [anon_sym_long] = ACTIONS(1956),
    [anon_sym_short] = ACTIONS(1956),
    [sym_primitive_type] = ACTIONS(1959),
    [anon_sym_enum] = ACTIONS(1962),
    [anon_sym_struct] = ACTIONS(1965),
    [anon_sym_union] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(3476),
    [anon_sym_switch] = ACTIONS(3479),
    [anon_sym_case] = ACTIONS(3482),
    [anon_sym_default] = ACTIONS(3485),
    [anon_sym_while] = ACTIONS(3488),
    [anon_sym_do] = ACTIONS(3491),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_return] = ACTIONS(3497),
    [anon_sym_break] = ACTIONS(3500),
    [anon_sym_continue] = ACTIONS(3503),
    [anon_sym_goto] = ACTIONS(3506),
    [anon_sym_AMP] = ACTIONS(1950),
    [anon_sym_BANG] = ACTIONS(2004),
    [anon_sym_TILDE] = ACTIONS(2007),
    [anon_sym_PLUS] = ACTIONS(2010),
    [anon_sym_DASH] = ACTIONS(2010),
    [anon_sym_DASH_DASH] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2013),
    [anon_sym_sizeof] = ACTIONS(2016),
    [sym_number_literal] = ACTIONS(3509),
    [sym_char_literal] = ACTIONS(3509),
    [sym_string_literal] = ACTIONS(2022),
    [sym_true] = ACTIONS(3512),
    [sym_false] = ACTIONS(3512),
    [sym_null] = ACTIONS(3512),
    [sym_identifier] = ACTIONS(3515),
    [sym_comment] = ACTIONS(42),
  },
  [1134] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3518),
    [sym_comment] = ACTIONS(42),
  },
  [1135] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3520),
    [sym_comment] = ACTIONS(42),
  },
  [1136] = {
    [sym_preproc_include] = STATE(986),
    [sym_preproc_def] = STATE(986),
    [sym_preproc_function_def] = STATE(986),
    [sym_preproc_call] = STATE(986),
    [sym_preproc_if_in_compound_statement] = STATE(713),
    [sym_preproc_ifdef_in_compound_statement] = STATE(714),
    [sym_preproc_else_in_compound_statement] = STATE(1277),
    [sym_preproc_elif_in_compound_statement] = STATE(1278),
    [sym_declaration] = STATE(986),
    [sym_type_definition] = STATE(986),
    [sym__declaration_specifiers] = STATE(717),
    [sym_compound_statement] = STATE(986),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(986),
    [sym_expression_statement] = STATE(986),
    [sym_if_statement] = STATE(986),
    [sym_switch_statement] = STATE(986),
    [sym_case_statement] = STATE(986),
    [sym_while_statement] = STATE(986),
    [sym_do_statement] = STATE(986),
    [sym_for_statement] = STATE(986),
    [sym_return_statement] = STATE(986),
    [sym_break_statement] = STATE(986),
    [sym_continue_statement] = STATE(986),
    [sym_goto_statement] = STATE(986),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym__empty_declaration] = STATE(986),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(986),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1639),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3522),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1645),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1647),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1651),
    [sym_preproc_directive] = ACTIONS(1653),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_typedef] = ACTIONS(1657),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(42),
  },
  [1137] = {
    [anon_sym_LF] = ACTIONS(3524),
    [sym_comment] = ACTIONS(50),
  },
  [1138] = {
    [sym_parameter_list] = STATE(200),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_SEMI] = ACTIONS(3526),
    [anon_sym_LBRACK] = ACTIONS(449),
    [sym_comment] = ACTIONS(42),
  },
  [1139] = {
    [sym__type_declarator] = STATE(1281),
    [sym_pointer_type_declarator] = STATE(99),
    [sym_function_type_declarator] = STATE(100),
    [sym_array_type_declarator] = STATE(101),
    [anon_sym_LPAREN] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(187),
    [sym_identifier] = ACTIONS(189),
    [sym_comment] = ACTIONS(42),
  },
  [1140] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1913),
    [anon_sym_LPAREN] = ACTIONS(1911),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_auto] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [anon_sym_if] = ACTIONS(1913),
    [anon_sym_switch] = ACTIONS(1913),
    [anon_sym_case] = ACTIONS(1913),
    [anon_sym_default] = ACTIONS(1913),
    [anon_sym_while] = ACTIONS(1913),
    [anon_sym_do] = ACTIONS(1913),
    [anon_sym_for] = ACTIONS(1913),
    [anon_sym_return] = ACTIONS(1913),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1913),
    [anon_sym_goto] = ACTIONS(1913),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1913),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_sizeof] = ACTIONS(1913),
    [sym_number_literal] = ACTIONS(1911),
    [sym_char_literal] = ACTIONS(1911),
    [sym_string_literal] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [sym_null] = ACTIONS(1913),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(42),
  },
  [1141] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(3528),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1142] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(3530),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1143] = {
    [sym_declaration] = STATE(1284),
    [sym_type_definition] = STATE(1284),
    [sym__declaration_specifiers] = STATE(1146),
    [sym_compound_statement] = STATE(1284),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(1284),
    [sym_expression_statement] = STATE(1284),
    [sym_if_statement] = STATE(1284),
    [sym_switch_statement] = STATE(1284),
    [sym_case_statement] = STATE(1284),
    [sym_while_statement] = STATE(1284),
    [sym_do_statement] = STATE(1284),
    [sym_for_statement] = STATE(1284),
    [sym_return_statement] = STATE(1284),
    [sym_break_statement] = STATE(1284),
    [sym_continue_statement] = STATE(1284),
    [sym_goto_statement] = STATE(1284),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_typedef] = ACTIONS(1657),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(3022),
    [sym_comment] = ACTIONS(42),
  },
  [1144] = {
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_extern] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_auto] = ACTIONS(95),
    [anon_sym_register] = ACTIONS(95),
    [anon_sym_inline] = ACTIONS(95),
    [anon_sym_const] = ACTIONS(95),
    [anon_sym_restrict] = ACTIONS(95),
    [anon_sym_volatile] = ACTIONS(95),
    [anon_sym__Atomic] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(2561),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_identifier] = ACTIONS(95),
    [sym_comment] = ACTIONS(42),
  },
  [1145] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2687),
    [sym_preproc_directive] = ACTIONS(2687),
    [anon_sym_SEMI] = ACTIONS(2689),
    [anon_sym_typedef] = ACTIONS(2687),
    [anon_sym_extern] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_STAR] = ACTIONS(2689),
    [anon_sym_static] = ACTIONS(2687),
    [anon_sym_auto] = ACTIONS(2687),
    [anon_sym_register] = ACTIONS(2687),
    [anon_sym_inline] = ACTIONS(2687),
    [anon_sym_const] = ACTIONS(2687),
    [anon_sym_restrict] = ACTIONS(2687),
    [anon_sym_volatile] = ACTIONS(2687),
    [anon_sym__Atomic] = ACTIONS(2687),
    [anon_sym_unsigned] = ACTIONS(2687),
    [anon_sym_long] = ACTIONS(2687),
    [anon_sym_short] = ACTIONS(2687),
    [sym_primitive_type] = ACTIONS(2687),
    [anon_sym_enum] = ACTIONS(2687),
    [anon_sym_struct] = ACTIONS(2687),
    [anon_sym_union] = ACTIONS(2687),
    [anon_sym_if] = ACTIONS(2687),
    [anon_sym_switch] = ACTIONS(2687),
    [anon_sym_case] = ACTIONS(2687),
    [anon_sym_default] = ACTIONS(2687),
    [anon_sym_while] = ACTIONS(2687),
    [anon_sym_do] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2687),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_break] = ACTIONS(2687),
    [anon_sym_continue] = ACTIONS(2687),
    [anon_sym_goto] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_BANG] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2687),
    [anon_sym_DASH] = ACTIONS(2687),
    [anon_sym_DASH_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_PLUS] = ACTIONS(2689),
    [anon_sym_sizeof] = ACTIONS(2687),
    [sym_number_literal] = ACTIONS(2689),
    [sym_char_literal] = ACTIONS(2689),
    [sym_string_literal] = ACTIONS(2689),
    [sym_true] = ACTIONS(2687),
    [sym_false] = ACTIONS(2687),
    [sym_null] = ACTIONS(2687),
    [sym_identifier] = ACTIONS(2687),
    [sym_comment] = ACTIONS(42),
  },
  [1146] = {
    [sym__declarator] = STATE(980),
    [sym_pointer_declarator] = STATE(980),
    [sym_function_declarator] = STATE(980),
    [sym_array_declarator] = STATE(980),
    [sym_init_declarator] = STATE(981),
    [anon_sym_LPAREN] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(561),
    [sym_identifier] = ACTIONS(2569),
    [sym_comment] = ACTIONS(42),
  },
  [1147] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(3532),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1148] = {
    [anon_sym_LPAREN] = ACTIONS(3534),
    [sym_comment] = ACTIONS(42),
  },
  [1149] = {
    [sym__expression] = STATE(1288),
    [sym_conditional_expression] = STATE(1288),
    [sym_assignment_expression] = STATE(1288),
    [sym_pointer_expression] = STATE(1288),
    [sym_logical_expression] = STATE(1288),
    [sym_bitwise_expression] = STATE(1288),
    [sym_equality_expression] = STATE(1288),
    [sym_relational_expression] = STATE(1288),
    [sym_shift_expression] = STATE(1288),
    [sym_math_expression] = STATE(1288),
    [sym_cast_expression] = STATE(1288),
    [sym_sizeof_expression] = STATE(1288),
    [sym_subscript_expression] = STATE(1288),
    [sym_call_expression] = STATE(1288),
    [sym_field_expression] = STATE(1288),
    [sym_compound_literal_expression] = STATE(1288),
    [sym_parenthesized_expression] = STATE(1288),
    [sym_concatenated_string] = STATE(1288),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(3536),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(3538),
    [sym_char_literal] = ACTIONS(3538),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(3540),
    [sym_false] = ACTIONS(3540),
    [sym_null] = ACTIONS(3540),
    [sym_identifier] = ACTIONS(3540),
    [sym_comment] = ACTIONS(42),
  },
  [1150] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(3542),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1151] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2727),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2727),
    [sym_preproc_directive] = ACTIONS(2727),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym_typedef] = ACTIONS(2727),
    [anon_sym_extern] = ACTIONS(2727),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_auto] = ACTIONS(2727),
    [anon_sym_register] = ACTIONS(2727),
    [anon_sym_inline] = ACTIONS(2727),
    [anon_sym_const] = ACTIONS(2727),
    [anon_sym_restrict] = ACTIONS(2727),
    [anon_sym_volatile] = ACTIONS(2727),
    [anon_sym__Atomic] = ACTIONS(2727),
    [anon_sym_unsigned] = ACTIONS(2727),
    [anon_sym_long] = ACTIONS(2727),
    [anon_sym_short] = ACTIONS(2727),
    [sym_primitive_type] = ACTIONS(2727),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_struct] = ACTIONS(2727),
    [anon_sym_union] = ACTIONS(2727),
    [anon_sym_if] = ACTIONS(2727),
    [anon_sym_switch] = ACTIONS(2727),
    [anon_sym_case] = ACTIONS(2727),
    [anon_sym_default] = ACTIONS(2727),
    [anon_sym_while] = ACTIONS(2727),
    [anon_sym_do] = ACTIONS(2727),
    [anon_sym_for] = ACTIONS(2727),
    [anon_sym_return] = ACTIONS(2727),
    [anon_sym_break] = ACTIONS(2727),
    [anon_sym_continue] = ACTIONS(2727),
    [anon_sym_goto] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_BANG] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2727),
    [anon_sym_DASH] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_sizeof] = ACTIONS(2727),
    [sym_number_literal] = ACTIONS(2729),
    [sym_char_literal] = ACTIONS(2729),
    [sym_string_literal] = ACTIONS(2729),
    [sym_true] = ACTIONS(2727),
    [sym_false] = ACTIONS(2727),
    [sym_null] = ACTIONS(2727),
    [sym_identifier] = ACTIONS(2727),
    [sym_comment] = ACTIONS(42),
  },
  [1152] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2731),
    [anon_sym_LPAREN] = ACTIONS(2733),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_auto] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_case] = ACTIONS(2731),
    [anon_sym_default] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [sym_number_literal] = ACTIONS(2733),
    [sym_char_literal] = ACTIONS(2733),
    [sym_string_literal] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [sym_null] = ACTIONS(2731),
    [sym_identifier] = ACTIONS(2731),
    [sym_comment] = ACTIONS(42),
  },
  [1153] = {
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_COLON] = ACTIONS(2561),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_comment] = ACTIONS(42),
  },
  [1154] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2746),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2744),
    [sym_preproc_directive] = ACTIONS(2744),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_typedef] = ACTIONS(2744),
    [anon_sym_extern] = ACTIONS(2744),
    [anon_sym_LBRACE] = ACTIONS(2746),
    [anon_sym_STAR] = ACTIONS(2746),
    [anon_sym_static] = ACTIONS(2744),
    [anon_sym_auto] = ACTIONS(2744),
    [anon_sym_register] = ACTIONS(2744),
    [anon_sym_inline] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_restrict] = ACTIONS(2744),
    [anon_sym_volatile] = ACTIONS(2744),
    [anon_sym__Atomic] = ACTIONS(2744),
    [anon_sym_unsigned] = ACTIONS(2744),
    [anon_sym_long] = ACTIONS(2744),
    [anon_sym_short] = ACTIONS(2744),
    [sym_primitive_type] = ACTIONS(2744),
    [anon_sym_enum] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_union] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_switch] = ACTIONS(2744),
    [anon_sym_case] = ACTIONS(2744),
    [anon_sym_default] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [anon_sym_do] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_break] = ACTIONS(2744),
    [anon_sym_continue] = ACTIONS(2744),
    [anon_sym_goto] = ACTIONS(2744),
    [anon_sym_AMP] = ACTIONS(2746),
    [anon_sym_BANG] = ACTIONS(2746),
    [anon_sym_TILDE] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_DASH] = ACTIONS(2744),
    [anon_sym_DASH_DASH] = ACTIONS(2746),
    [anon_sym_PLUS_PLUS] = ACTIONS(2746),
    [anon_sym_sizeof] = ACTIONS(2744),
    [sym_number_literal] = ACTIONS(2746),
    [sym_char_literal] = ACTIONS(2746),
    [sym_string_literal] = ACTIONS(2746),
    [sym_true] = ACTIONS(2744),
    [sym_false] = ACTIONS(2744),
    [sym_null] = ACTIONS(2744),
    [sym_identifier] = ACTIONS(2744),
    [sym_comment] = ACTIONS(42),
  },
  [1155] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(567),
    [anon_sym_LPAREN] = ACTIONS(565),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(567),
    [sym_preproc_directive] = ACTIONS(567),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_typedef] = ACTIONS(567),
    [anon_sym_extern] = ACTIONS(567),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_STAR] = ACTIONS(565),
    [anon_sym_static] = ACTIONS(567),
    [anon_sym_auto] = ACTIONS(567),
    [anon_sym_register] = ACTIONS(567),
    [anon_sym_inline] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_restrict] = ACTIONS(567),
    [anon_sym_volatile] = ACTIONS(567),
    [anon_sym__Atomic] = ACTIONS(567),
    [anon_sym_unsigned] = ACTIONS(567),
    [anon_sym_long] = ACTIONS(567),
    [anon_sym_short] = ACTIONS(567),
    [sym_primitive_type] = ACTIONS(567),
    [anon_sym_enum] = ACTIONS(567),
    [anon_sym_struct] = ACTIONS(567),
    [anon_sym_union] = ACTIONS(567),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_switch] = ACTIONS(567),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_default] = ACTIONS(567),
    [anon_sym_while] = ACTIONS(567),
    [anon_sym_do] = ACTIONS(567),
    [anon_sym_for] = ACTIONS(567),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_break] = ACTIONS(567),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(565),
    [anon_sym_TILDE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_sizeof] = ACTIONS(567),
    [sym_number_literal] = ACTIONS(565),
    [sym_char_literal] = ACTIONS(565),
    [sym_string_literal] = ACTIONS(565),
    [sym_true] = ACTIONS(567),
    [sym_false] = ACTIONS(567),
    [sym_null] = ACTIONS(567),
    [sym_identifier] = ACTIONS(567),
    [sym_comment] = ACTIONS(42),
  },
  [1156] = {
    [aux_sym_declaration_repeat1] = STATE(302),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(3544),
    [sym_comment] = ACTIONS(42),
  },
  [1157] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3546),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3546),
    [anon_sym_LPAREN] = ACTIONS(3548),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3546),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3546),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3546),
    [sym_preproc_directive] = ACTIONS(3546),
    [anon_sym_SEMI] = ACTIONS(3548),
    [anon_sym_typedef] = ACTIONS(3546),
    [anon_sym_extern] = ACTIONS(3546),
    [anon_sym_LBRACE] = ACTIONS(3548),
    [anon_sym_RBRACE] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3548),
    [anon_sym_static] = ACTIONS(3546),
    [anon_sym_auto] = ACTIONS(3546),
    [anon_sym_register] = ACTIONS(3546),
    [anon_sym_inline] = ACTIONS(3546),
    [anon_sym_const] = ACTIONS(3546),
    [anon_sym_restrict] = ACTIONS(3546),
    [anon_sym_volatile] = ACTIONS(3546),
    [anon_sym__Atomic] = ACTIONS(3546),
    [anon_sym_unsigned] = ACTIONS(3546),
    [anon_sym_long] = ACTIONS(3546),
    [anon_sym_short] = ACTIONS(3546),
    [sym_primitive_type] = ACTIONS(3546),
    [anon_sym_enum] = ACTIONS(3546),
    [anon_sym_struct] = ACTIONS(3546),
    [anon_sym_union] = ACTIONS(3546),
    [anon_sym_if] = ACTIONS(3546),
    [anon_sym_switch] = ACTIONS(3546),
    [anon_sym_case] = ACTIONS(3546),
    [anon_sym_default] = ACTIONS(3546),
    [anon_sym_while] = ACTIONS(3546),
    [anon_sym_do] = ACTIONS(3546),
    [anon_sym_for] = ACTIONS(3546),
    [anon_sym_return] = ACTIONS(3546),
    [anon_sym_break] = ACTIONS(3546),
    [anon_sym_continue] = ACTIONS(3546),
    [anon_sym_goto] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_BANG] = ACTIONS(3548),
    [anon_sym_TILDE] = ACTIONS(3548),
    [anon_sym_PLUS] = ACTIONS(3546),
    [anon_sym_DASH] = ACTIONS(3546),
    [anon_sym_DASH_DASH] = ACTIONS(3548),
    [anon_sym_PLUS_PLUS] = ACTIONS(3548),
    [anon_sym_sizeof] = ACTIONS(3546),
    [sym_number_literal] = ACTIONS(3548),
    [sym_char_literal] = ACTIONS(3548),
    [sym_string_literal] = ACTIONS(3548),
    [sym_true] = ACTIONS(3546),
    [sym_false] = ACTIONS(3546),
    [sym_null] = ACTIONS(3546),
    [sym_identifier] = ACTIONS(3546),
    [sym_comment] = ACTIONS(42),
  },
  [1158] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3550),
    [anon_sym_LPAREN] = ACTIONS(3552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3550),
    [sym_preproc_directive] = ACTIONS(3550),
    [anon_sym_SEMI] = ACTIONS(3552),
    [anon_sym_typedef] = ACTIONS(3550),
    [anon_sym_extern] = ACTIONS(3550),
    [anon_sym_LBRACE] = ACTIONS(3552),
    [anon_sym_RBRACE] = ACTIONS(3552),
    [anon_sym_STAR] = ACTIONS(3552),
    [anon_sym_static] = ACTIONS(3550),
    [anon_sym_auto] = ACTIONS(3550),
    [anon_sym_register] = ACTIONS(3550),
    [anon_sym_inline] = ACTIONS(3550),
    [anon_sym_const] = ACTIONS(3550),
    [anon_sym_restrict] = ACTIONS(3550),
    [anon_sym_volatile] = ACTIONS(3550),
    [anon_sym__Atomic] = ACTIONS(3550),
    [anon_sym_unsigned] = ACTIONS(3550),
    [anon_sym_long] = ACTIONS(3550),
    [anon_sym_short] = ACTIONS(3550),
    [sym_primitive_type] = ACTIONS(3550),
    [anon_sym_enum] = ACTIONS(3550),
    [anon_sym_struct] = ACTIONS(3550),
    [anon_sym_union] = ACTIONS(3550),
    [anon_sym_if] = ACTIONS(3550),
    [anon_sym_switch] = ACTIONS(3550),
    [anon_sym_case] = ACTIONS(3550),
    [anon_sym_default] = ACTIONS(3550),
    [anon_sym_while] = ACTIONS(3550),
    [anon_sym_do] = ACTIONS(3550),
    [anon_sym_for] = ACTIONS(3550),
    [anon_sym_return] = ACTIONS(3550),
    [anon_sym_break] = ACTIONS(3550),
    [anon_sym_continue] = ACTIONS(3550),
    [anon_sym_goto] = ACTIONS(3550),
    [anon_sym_AMP] = ACTIONS(3552),
    [anon_sym_BANG] = ACTIONS(3552),
    [anon_sym_TILDE] = ACTIONS(3552),
    [anon_sym_PLUS] = ACTIONS(3550),
    [anon_sym_DASH] = ACTIONS(3550),
    [anon_sym_DASH_DASH] = ACTIONS(3552),
    [anon_sym_PLUS_PLUS] = ACTIONS(3552),
    [anon_sym_sizeof] = ACTIONS(3550),
    [sym_number_literal] = ACTIONS(3552),
    [sym_char_literal] = ACTIONS(3552),
    [sym_string_literal] = ACTIONS(3552),
    [sym_true] = ACTIONS(3550),
    [sym_false] = ACTIONS(3550),
    [sym_null] = ACTIONS(3550),
    [sym_identifier] = ACTIONS(3550),
    [sym_comment] = ACTIONS(42),
  },
  [1159] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3554),
    [anon_sym_LPAREN] = ACTIONS(3556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3554),
    [sym_preproc_directive] = ACTIONS(3554),
    [anon_sym_SEMI] = ACTIONS(3556),
    [anon_sym_typedef] = ACTIONS(3554),
    [anon_sym_extern] = ACTIONS(3554),
    [anon_sym_LBRACE] = ACTIONS(3556),
    [anon_sym_RBRACE] = ACTIONS(3556),
    [anon_sym_STAR] = ACTIONS(3556),
    [anon_sym_static] = ACTIONS(3554),
    [anon_sym_auto] = ACTIONS(3554),
    [anon_sym_register] = ACTIONS(3554),
    [anon_sym_inline] = ACTIONS(3554),
    [anon_sym_const] = ACTIONS(3554),
    [anon_sym_restrict] = ACTIONS(3554),
    [anon_sym_volatile] = ACTIONS(3554),
    [anon_sym__Atomic] = ACTIONS(3554),
    [anon_sym_unsigned] = ACTIONS(3554),
    [anon_sym_long] = ACTIONS(3554),
    [anon_sym_short] = ACTIONS(3554),
    [sym_primitive_type] = ACTIONS(3554),
    [anon_sym_enum] = ACTIONS(3554),
    [anon_sym_struct] = ACTIONS(3554),
    [anon_sym_union] = ACTIONS(3554),
    [anon_sym_if] = ACTIONS(3554),
    [anon_sym_switch] = ACTIONS(3554),
    [anon_sym_case] = ACTIONS(3554),
    [anon_sym_default] = ACTIONS(3554),
    [anon_sym_while] = ACTIONS(3554),
    [anon_sym_do] = ACTIONS(3554),
    [anon_sym_for] = ACTIONS(3554),
    [anon_sym_return] = ACTIONS(3554),
    [anon_sym_break] = ACTIONS(3554),
    [anon_sym_continue] = ACTIONS(3554),
    [anon_sym_goto] = ACTIONS(3554),
    [anon_sym_AMP] = ACTIONS(3556),
    [anon_sym_BANG] = ACTIONS(3556),
    [anon_sym_TILDE] = ACTIONS(3556),
    [anon_sym_PLUS] = ACTIONS(3554),
    [anon_sym_DASH] = ACTIONS(3554),
    [anon_sym_DASH_DASH] = ACTIONS(3556),
    [anon_sym_PLUS_PLUS] = ACTIONS(3556),
    [anon_sym_sizeof] = ACTIONS(3554),
    [sym_number_literal] = ACTIONS(3556),
    [sym_char_literal] = ACTIONS(3556),
    [sym_string_literal] = ACTIONS(3556),
    [sym_true] = ACTIONS(3554),
    [sym_false] = ACTIONS(3554),
    [sym_null] = ACTIONS(3554),
    [sym_identifier] = ACTIONS(3554),
    [sym_comment] = ACTIONS(42),
  },
  [1160] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3558),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3558),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3558),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3558),
    [sym_preproc_directive] = ACTIONS(3558),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym_typedef] = ACTIONS(3558),
    [anon_sym_extern] = ACTIONS(3558),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_RBRACE] = ACTIONS(3560),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_static] = ACTIONS(3558),
    [anon_sym_auto] = ACTIONS(3558),
    [anon_sym_register] = ACTIONS(3558),
    [anon_sym_inline] = ACTIONS(3558),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_restrict] = ACTIONS(3558),
    [anon_sym_volatile] = ACTIONS(3558),
    [anon_sym__Atomic] = ACTIONS(3558),
    [anon_sym_unsigned] = ACTIONS(3558),
    [anon_sym_long] = ACTIONS(3558),
    [anon_sym_short] = ACTIONS(3558),
    [sym_primitive_type] = ACTIONS(3558),
    [anon_sym_enum] = ACTIONS(3558),
    [anon_sym_struct] = ACTIONS(3558),
    [anon_sym_union] = ACTIONS(3558),
    [anon_sym_if] = ACTIONS(3558),
    [anon_sym_switch] = ACTIONS(3558),
    [anon_sym_case] = ACTIONS(3558),
    [anon_sym_default] = ACTIONS(3558),
    [anon_sym_while] = ACTIONS(3558),
    [anon_sym_do] = ACTIONS(3558),
    [anon_sym_for] = ACTIONS(3558),
    [anon_sym_return] = ACTIONS(3558),
    [anon_sym_break] = ACTIONS(3558),
    [anon_sym_continue] = ACTIONS(3558),
    [anon_sym_goto] = ACTIONS(3558),
    [anon_sym_AMP] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_PLUS] = ACTIONS(3558),
    [anon_sym_DASH] = ACTIONS(3558),
    [anon_sym_DASH_DASH] = ACTIONS(3560),
    [anon_sym_PLUS_PLUS] = ACTIONS(3560),
    [anon_sym_sizeof] = ACTIONS(3558),
    [sym_number_literal] = ACTIONS(3560),
    [sym_char_literal] = ACTIONS(3560),
    [sym_string_literal] = ACTIONS(3560),
    [sym_true] = ACTIONS(3558),
    [sym_false] = ACTIONS(3558),
    [sym_null] = ACTIONS(3558),
    [sym_identifier] = ACTIONS(3558),
    [sym_comment] = ACTIONS(42),
  },
  [1161] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3562),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(3564),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3562),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3562),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3564),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym_LBRACE] = ACTIONS(3564),
    [anon_sym_RBRACE] = ACTIONS(3564),
    [anon_sym_STAR] = ACTIONS(3564),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_auto] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_switch] = ACTIONS(3562),
    [anon_sym_case] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_goto] = ACTIONS(3562),
    [anon_sym_AMP] = ACTIONS(3564),
    [anon_sym_BANG] = ACTIONS(3564),
    [anon_sym_TILDE] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_DASH_DASH] = ACTIONS(3564),
    [anon_sym_PLUS_PLUS] = ACTIONS(3564),
    [anon_sym_sizeof] = ACTIONS(3562),
    [sym_number_literal] = ACTIONS(3564),
    [sym_char_literal] = ACTIONS(3564),
    [sym_string_literal] = ACTIONS(3564),
    [sym_true] = ACTIONS(3562),
    [sym_false] = ACTIONS(3562),
    [sym_null] = ACTIONS(3562),
    [sym_identifier] = ACTIONS(3562),
    [sym_comment] = ACTIONS(42),
  },
  [1162] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3566),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3566),
    [anon_sym_LPAREN] = ACTIONS(3568),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3566),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3566),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3566),
    [sym_preproc_directive] = ACTIONS(3566),
    [anon_sym_SEMI] = ACTIONS(3568),
    [anon_sym_typedef] = ACTIONS(3566),
    [anon_sym_extern] = ACTIONS(3566),
    [anon_sym_LBRACE] = ACTIONS(3568),
    [anon_sym_RBRACE] = ACTIONS(3568),
    [anon_sym_STAR] = ACTIONS(3568),
    [anon_sym_static] = ACTIONS(3566),
    [anon_sym_auto] = ACTIONS(3566),
    [anon_sym_register] = ACTIONS(3566),
    [anon_sym_inline] = ACTIONS(3566),
    [anon_sym_const] = ACTIONS(3566),
    [anon_sym_restrict] = ACTIONS(3566),
    [anon_sym_volatile] = ACTIONS(3566),
    [anon_sym__Atomic] = ACTIONS(3566),
    [anon_sym_unsigned] = ACTIONS(3566),
    [anon_sym_long] = ACTIONS(3566),
    [anon_sym_short] = ACTIONS(3566),
    [sym_primitive_type] = ACTIONS(3566),
    [anon_sym_enum] = ACTIONS(3566),
    [anon_sym_struct] = ACTIONS(3566),
    [anon_sym_union] = ACTIONS(3566),
    [anon_sym_if] = ACTIONS(3566),
    [anon_sym_switch] = ACTIONS(3566),
    [anon_sym_case] = ACTIONS(3566),
    [anon_sym_default] = ACTIONS(3566),
    [anon_sym_while] = ACTIONS(3566),
    [anon_sym_do] = ACTIONS(3566),
    [anon_sym_for] = ACTIONS(3566),
    [anon_sym_return] = ACTIONS(3566),
    [anon_sym_break] = ACTIONS(3566),
    [anon_sym_continue] = ACTIONS(3566),
    [anon_sym_goto] = ACTIONS(3566),
    [anon_sym_AMP] = ACTIONS(3568),
    [anon_sym_BANG] = ACTIONS(3568),
    [anon_sym_TILDE] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3566),
    [anon_sym_DASH] = ACTIONS(3566),
    [anon_sym_DASH_DASH] = ACTIONS(3568),
    [anon_sym_PLUS_PLUS] = ACTIONS(3568),
    [anon_sym_sizeof] = ACTIONS(3566),
    [sym_number_literal] = ACTIONS(3568),
    [sym_char_literal] = ACTIONS(3568),
    [sym_string_literal] = ACTIONS(3568),
    [sym_true] = ACTIONS(3566),
    [sym_false] = ACTIONS(3566),
    [sym_null] = ACTIONS(3566),
    [sym_identifier] = ACTIONS(3566),
    [sym_comment] = ACTIONS(42),
  },
  [1163] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1409),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1411),
    [sym_preproc_directive] = ACTIONS(1411),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_typedef] = ACTIONS(1411),
    [anon_sym_extern] = ACTIONS(1411),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_static] = ACTIONS(1411),
    [anon_sym_auto] = ACTIONS(1411),
    [anon_sym_register] = ACTIONS(1411),
    [anon_sym_inline] = ACTIONS(1411),
    [anon_sym_const] = ACTIONS(1411),
    [anon_sym_restrict] = ACTIONS(1411),
    [anon_sym_volatile] = ACTIONS(1411),
    [anon_sym__Atomic] = ACTIONS(1411),
    [anon_sym_unsigned] = ACTIONS(1411),
    [anon_sym_long] = ACTIONS(1411),
    [anon_sym_short] = ACTIONS(1411),
    [sym_primitive_type] = ACTIONS(1411),
    [anon_sym_enum] = ACTIONS(1411),
    [anon_sym_struct] = ACTIONS(1411),
    [anon_sym_union] = ACTIONS(1411),
    [anon_sym_if] = ACTIONS(1411),
    [anon_sym_switch] = ACTIONS(1411),
    [anon_sym_case] = ACTIONS(1411),
    [anon_sym_default] = ACTIONS(1411),
    [anon_sym_while] = ACTIONS(1411),
    [anon_sym_do] = ACTIONS(1411),
    [anon_sym_for] = ACTIONS(1411),
    [anon_sym_return] = ACTIONS(1411),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_continue] = ACTIONS(1411),
    [anon_sym_goto] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1411),
    [anon_sym_DASH] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1409),
    [anon_sym_sizeof] = ACTIONS(1411),
    [sym_number_literal] = ACTIONS(1409),
    [sym_char_literal] = ACTIONS(1409),
    [sym_string_literal] = ACTIONS(1409),
    [sym_true] = ACTIONS(1411),
    [sym_false] = ACTIONS(1411),
    [sym_null] = ACTIONS(1411),
    [sym_identifier] = ACTIONS(1411),
    [sym_comment] = ACTIONS(42),
  },
  [1164] = {
    [sym__expression] = STATE(923),
    [sym_conditional_expression] = STATE(923),
    [sym_assignment_expression] = STATE(923),
    [sym_pointer_expression] = STATE(923),
    [sym_logical_expression] = STATE(923),
    [sym_bitwise_expression] = STATE(923),
    [sym_equality_expression] = STATE(923),
    [sym_relational_expression] = STATE(923),
    [sym_shift_expression] = STATE(923),
    [sym_math_expression] = STATE(923),
    [sym_cast_expression] = STATE(923),
    [sym_sizeof_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_call_expression] = STATE(923),
    [sym_field_expression] = STATE(923),
    [sym_compound_literal_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(923),
    [sym_initializer_list] = STATE(924),
    [sym_concatenated_string] = STATE(923),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(2459),
    [sym_char_literal] = ACTIONS(2459),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(2461),
    [sym_false] = ACTIONS(2461),
    [sym_null] = ACTIONS(2461),
    [sym_identifier] = ACTIONS(2461),
    [sym_comment] = ACTIONS(42),
  },
  [1165] = {
    [anon_sym_RPAREN] = ACTIONS(3570),
    [sym_comment] = ACTIONS(42),
  },
  [1166] = {
    [aux_sym_concatenated_string_repeat1] = STATE(1166),
    [anon_sym_LPAREN] = ACTIONS(2737),
    [anon_sym_RPAREN] = ACTIONS(2737),
    [anon_sym_STAR] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2737),
    [anon_sym_EQ] = ACTIONS(2739),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_STAR_EQ] = ACTIONS(2737),
    [anon_sym_SLASH_EQ] = ACTIONS(2737),
    [anon_sym_PERCENT_EQ] = ACTIONS(2737),
    [anon_sym_PLUS_EQ] = ACTIONS(2737),
    [anon_sym_DASH_EQ] = ACTIONS(2737),
    [anon_sym_LT_LT_EQ] = ACTIONS(2737),
    [anon_sym_GT_GT_EQ] = ACTIONS(2737),
    [anon_sym_AMP_EQ] = ACTIONS(2737),
    [anon_sym_CARET_EQ] = ACTIONS(2737),
    [anon_sym_PIPE_EQ] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2739),
    [anon_sym_PIPE_PIPE] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_PIPE] = ACTIONS(2739),
    [anon_sym_CARET] = ACTIONS(2739),
    [anon_sym_EQ_EQ] = ACTIONS(2737),
    [anon_sym_BANG_EQ] = ACTIONS(2737),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_GT] = ACTIONS(2739),
    [anon_sym_LT_EQ] = ACTIONS(2737),
    [anon_sym_GT_EQ] = ACTIONS(2737),
    [anon_sym_LT_LT] = ACTIONS(2739),
    [anon_sym_GT_GT] = ACTIONS(2739),
    [anon_sym_PLUS] = ACTIONS(2739),
    [anon_sym_DASH] = ACTIONS(2739),
    [anon_sym_SLASH] = ACTIONS(2739),
    [anon_sym_PERCENT] = ACTIONS(2739),
    [anon_sym_DASH_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_PLUS] = ACTIONS(2737),
    [anon_sym_DOT] = ACTIONS(2737),
    [anon_sym_DASH_GT] = ACTIONS(2737),
    [sym_string_literal] = ACTIONS(3572),
    [sym_comment] = ACTIONS(42),
  },
  [1167] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1037),
    [sym_preproc_directive] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_typedef] = ACTIONS(1037),
    [anon_sym_extern] = ACTIONS(1037),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_STAR] = ACTIONS(1039),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_auto] = ACTIONS(1037),
    [anon_sym_register] = ACTIONS(1037),
    [anon_sym_inline] = ACTIONS(1037),
    [anon_sym_const] = ACTIONS(1037),
    [anon_sym_restrict] = ACTIONS(1037),
    [anon_sym_volatile] = ACTIONS(1037),
    [anon_sym__Atomic] = ACTIONS(1037),
    [anon_sym_unsigned] = ACTIONS(1037),
    [anon_sym_long] = ACTIONS(1037),
    [anon_sym_short] = ACTIONS(1037),
    [sym_primitive_type] = ACTIONS(1037),
    [anon_sym_enum] = ACTIONS(1037),
    [anon_sym_struct] = ACTIONS(1037),
    [anon_sym_union] = ACTIONS(1037),
    [anon_sym_if] = ACTIONS(1037),
    [anon_sym_else] = ACTIONS(1037),
    [anon_sym_switch] = ACTIONS(1037),
    [anon_sym_case] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1037),
    [anon_sym_do] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1037),
    [anon_sym_return] = ACTIONS(1037),
    [anon_sym_break] = ACTIONS(1037),
    [anon_sym_continue] = ACTIONS(1037),
    [anon_sym_goto] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_TILDE] = ACTIONS(1039),
    [anon_sym_PLUS] = ACTIONS(1037),
    [anon_sym_DASH] = ACTIONS(1037),
    [anon_sym_DASH_DASH] = ACTIONS(1039),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_sizeof] = ACTIONS(1037),
    [sym_number_literal] = ACTIONS(1039),
    [sym_char_literal] = ACTIONS(1039),
    [sym_string_literal] = ACTIONS(1039),
    [sym_true] = ACTIONS(1037),
    [sym_false] = ACTIONS(1037),
    [sym_null] = ACTIONS(1037),
    [sym_identifier] = ACTIONS(1037),
    [sym_comment] = ACTIONS(42),
  },
  [1168] = {
    [sym_preproc_include] = STATE(1293),
    [sym_preproc_def] = STATE(1293),
    [sym_preproc_function_def] = STATE(1293),
    [sym_preproc_call] = STATE(1293),
    [sym_preproc_if_in_compound_statement] = STATE(275),
    [sym_preproc_ifdef_in_compound_statement] = STATE(276),
    [sym_declaration] = STATE(1293),
    [sym_type_definition] = STATE(1293),
    [sym__declaration_specifiers] = STATE(277),
    [sym_compound_statement] = STATE(1293),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(1293),
    [sym_expression_statement] = STATE(1293),
    [sym_if_statement] = STATE(1293),
    [sym_switch_statement] = STATE(1293),
    [sym_case_statement] = STATE(1293),
    [sym_while_statement] = STATE(1293),
    [sym_do_statement] = STATE(1293),
    [sym_for_statement] = STATE(1293),
    [sym_return_statement] = STATE(1293),
    [sym_break_statement] = STATE(1293),
    [sym_continue_statement] = STATE(1293),
    [sym_goto_statement] = STATE(1293),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [sym__empty_declaration] = STATE(1293),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1293),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(577),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(579),
    [sym_preproc_directive] = ACTIONS(581),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_typedef] = ACTIONS(585),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_RBRACE] = ACTIONS(3575),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(631),
    [sym_comment] = ACTIONS(42),
  },
  [1169] = {
    [anon_sym_LPAREN] = ACTIONS(3577),
    [sym_comment] = ACTIONS(42),
  },
  [1170] = {
    [anon_sym_LPAREN] = ACTIONS(3579),
    [sym_comment] = ACTIONS(42),
  },
  [1171] = {
    [sym__expression] = STATE(1296),
    [sym_conditional_expression] = STATE(1296),
    [sym_assignment_expression] = STATE(1296),
    [sym_pointer_expression] = STATE(1296),
    [sym_logical_expression] = STATE(1296),
    [sym_bitwise_expression] = STATE(1296),
    [sym_equality_expression] = STATE(1296),
    [sym_relational_expression] = STATE(1296),
    [sym_shift_expression] = STATE(1296),
    [sym_math_expression] = STATE(1296),
    [sym_cast_expression] = STATE(1296),
    [sym_sizeof_expression] = STATE(1296),
    [sym_subscript_expression] = STATE(1296),
    [sym_call_expression] = STATE(1296),
    [sym_field_expression] = STATE(1296),
    [sym_compound_literal_expression] = STATE(1296),
    [sym_parenthesized_expression] = STATE(1296),
    [sym_concatenated_string] = STATE(1296),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(3581),
    [sym_char_literal] = ACTIONS(3581),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(3583),
    [sym_false] = ACTIONS(3583),
    [sym_null] = ACTIONS(3583),
    [sym_identifier] = ACTIONS(3583),
    [sym_comment] = ACTIONS(42),
  },
  [1172] = {
    [anon_sym_COLON] = ACTIONS(3585),
    [sym_comment] = ACTIONS(42),
  },
  [1173] = {
    [anon_sym_LPAREN] = ACTIONS(3587),
    [sym_comment] = ACTIONS(42),
  },
  [1174] = {
    [sym_compound_statement] = STATE(1299),
    [sym_labeled_statement] = STATE(1299),
    [sym_expression_statement] = STATE(1299),
    [sym_if_statement] = STATE(1299),
    [sym_switch_statement] = STATE(1299),
    [sym_case_statement] = STATE(1299),
    [sym_while_statement] = STATE(1299),
    [sym_do_statement] = STATE(1299),
    [sym_for_statement] = STATE(1299),
    [sym_return_statement] = STATE(1299),
    [sym_break_statement] = STATE(1299),
    [sym_continue_statement] = STATE(1299),
    [sym_goto_statement] = STATE(1299),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_default] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(1089),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1093),
    [sym_comment] = ACTIONS(42),
  },
  [1175] = {
    [anon_sym_LPAREN] = ACTIONS(3589),
    [sym_comment] = ACTIONS(42),
  },
  [1176] = {
    [sym__expression] = STATE(1302),
    [sym_conditional_expression] = STATE(1302),
    [sym_assignment_expression] = STATE(1302),
    [sym_pointer_expression] = STATE(1302),
    [sym_logical_expression] = STATE(1302),
    [sym_bitwise_expression] = STATE(1302),
    [sym_equality_expression] = STATE(1302),
    [sym_relational_expression] = STATE(1302),
    [sym_shift_expression] = STATE(1302),
    [sym_math_expression] = STATE(1302),
    [sym_cast_expression] = STATE(1302),
    [sym_sizeof_expression] = STATE(1302),
    [sym_subscript_expression] = STATE(1302),
    [sym_call_expression] = STATE(1302),
    [sym_field_expression] = STATE(1302),
    [sym_compound_literal_expression] = STATE(1302),
    [sym_parenthesized_expression] = STATE(1302),
    [sym_concatenated_string] = STATE(1302),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(3591),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(3593),
    [sym_char_literal] = ACTIONS(3593),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(3595),
    [sym_false] = ACTIONS(3595),
    [sym_null] = ACTIONS(3595),
    [sym_identifier] = ACTIONS(3595),
    [sym_comment] = ACTIONS(42),
  },
  [1177] = {
    [anon_sym_SEMI] = ACTIONS(3597),
    [sym_comment] = ACTIONS(42),
  },
  [1178] = {
    [anon_sym_SEMI] = ACTIONS(3599),
    [sym_comment] = ACTIONS(42),
  },
  [1179] = {
    [sym_identifier] = ACTIONS(3601),
    [sym_comment] = ACTIONS(42),
  },
  [1180] = {
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_COLON] = ACTIONS(3603),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_comment] = ACTIONS(42),
  },
  [1181] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3605),
    [anon_sym_LPAREN] = ACTIONS(3607),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3605),
    [sym_preproc_directive] = ACTIONS(3605),
    [anon_sym_SEMI] = ACTIONS(3607),
    [anon_sym_typedef] = ACTIONS(3605),
    [anon_sym_extern] = ACTIONS(3605),
    [anon_sym_LBRACE] = ACTIONS(3607),
    [anon_sym_RBRACE] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(3607),
    [anon_sym_static] = ACTIONS(3605),
    [anon_sym_auto] = ACTIONS(3605),
    [anon_sym_register] = ACTIONS(3605),
    [anon_sym_inline] = ACTIONS(3605),
    [anon_sym_const] = ACTIONS(3605),
    [anon_sym_restrict] = ACTIONS(3605),
    [anon_sym_volatile] = ACTIONS(3605),
    [anon_sym__Atomic] = ACTIONS(3605),
    [anon_sym_unsigned] = ACTIONS(3605),
    [anon_sym_long] = ACTIONS(3605),
    [anon_sym_short] = ACTIONS(3605),
    [sym_primitive_type] = ACTIONS(3605),
    [anon_sym_enum] = ACTIONS(3605),
    [anon_sym_struct] = ACTIONS(3605),
    [anon_sym_union] = ACTIONS(3605),
    [anon_sym_if] = ACTIONS(3605),
    [anon_sym_else] = ACTIONS(3609),
    [anon_sym_switch] = ACTIONS(3605),
    [anon_sym_case] = ACTIONS(3605),
    [anon_sym_default] = ACTIONS(3605),
    [anon_sym_while] = ACTIONS(3605),
    [anon_sym_do] = ACTIONS(3605),
    [anon_sym_for] = ACTIONS(3605),
    [anon_sym_return] = ACTIONS(3605),
    [anon_sym_break] = ACTIONS(3605),
    [anon_sym_continue] = ACTIONS(3605),
    [anon_sym_goto] = ACTIONS(3605),
    [anon_sym_AMP] = ACTIONS(3607),
    [anon_sym_BANG] = ACTIONS(3607),
    [anon_sym_TILDE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3605),
    [anon_sym_DASH] = ACTIONS(3605),
    [anon_sym_DASH_DASH] = ACTIONS(3607),
    [anon_sym_PLUS_PLUS] = ACTIONS(3607),
    [anon_sym_sizeof] = ACTIONS(3605),
    [sym_number_literal] = ACTIONS(3607),
    [sym_char_literal] = ACTIONS(3607),
    [sym_string_literal] = ACTIONS(3607),
    [sym_true] = ACTIONS(3605),
    [sym_false] = ACTIONS(3605),
    [sym_null] = ACTIONS(3605),
    [sym_identifier] = ACTIONS(3605),
    [sym_comment] = ACTIONS(42),
  },
  [1182] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_SEMI] = ACTIONS(3611),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_STAR_EQ] = ACTIONS(1171),
    [anon_sym_SLASH_EQ] = ACTIONS(1171),
    [anon_sym_PERCENT_EQ] = ACTIONS(1171),
    [anon_sym_PLUS_EQ] = ACTIONS(1171),
    [anon_sym_DASH_EQ] = ACTIONS(1171),
    [anon_sym_LT_LT_EQ] = ACTIONS(1171),
    [anon_sym_GT_GT_EQ] = ACTIONS(1171),
    [anon_sym_AMP_EQ] = ACTIONS(1171),
    [anon_sym_CARET_EQ] = ACTIONS(1171),
    [anon_sym_PIPE_EQ] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_PIPE_PIPE] = ACTIONS(1175),
    [anon_sym_AMP_AMP] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_LT] = ACTIONS(1185),
    [anon_sym_GT] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1187),
    [anon_sym_GT_EQ] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1189),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1183] = {
    [anon_sym_SEMI] = ACTIONS(3611),
    [sym_comment] = ACTIONS(42),
  },
  [1184] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(2766),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1185] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1737),
    [anon_sym_COLON] = ACTIONS(3613),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1743),
    [anon_sym_SLASH_EQ] = ACTIONS(1743),
    [anon_sym_PERCENT_EQ] = ACTIONS(1743),
    [anon_sym_PLUS_EQ] = ACTIONS(1743),
    [anon_sym_DASH_EQ] = ACTIONS(1743),
    [anon_sym_LT_LT_EQ] = ACTIONS(1743),
    [anon_sym_GT_GT_EQ] = ACTIONS(1743),
    [anon_sym_AMP_EQ] = ACTIONS(1743),
    [anon_sym_CARET_EQ] = ACTIONS(1743),
    [anon_sym_PIPE_EQ] = ACTIONS(1743),
    [anon_sym_AMP] = ACTIONS(1745),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_AMP_AMP] = ACTIONS(1749),
    [anon_sym_PIPE] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_GT] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1186] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(2770),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_STAR_EQ] = ACTIONS(2770),
    [anon_sym_SLASH_EQ] = ACTIONS(2770),
    [anon_sym_PERCENT_EQ] = ACTIONS(2770),
    [anon_sym_PLUS_EQ] = ACTIONS(2770),
    [anon_sym_DASH_EQ] = ACTIONS(2770),
    [anon_sym_LT_LT_EQ] = ACTIONS(2770),
    [anon_sym_GT_GT_EQ] = ACTIONS(2770),
    [anon_sym_AMP_EQ] = ACTIONS(2770),
    [anon_sym_CARET_EQ] = ACTIONS(2770),
    [anon_sym_PIPE_EQ] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2772),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_PIPE] = ACTIONS(2772),
    [anon_sym_CARET] = ACTIONS(2772),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1187] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(2774),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2776),
    [anon_sym_QMARK] = ACTIONS(2774),
    [anon_sym_STAR_EQ] = ACTIONS(2774),
    [anon_sym_SLASH_EQ] = ACTIONS(2774),
    [anon_sym_PERCENT_EQ] = ACTIONS(2774),
    [anon_sym_PLUS_EQ] = ACTIONS(2774),
    [anon_sym_DASH_EQ] = ACTIONS(2774),
    [anon_sym_LT_LT_EQ] = ACTIONS(2774),
    [anon_sym_GT_GT_EQ] = ACTIONS(2774),
    [anon_sym_AMP_EQ] = ACTIONS(2774),
    [anon_sym_CARET_EQ] = ACTIONS(2774),
    [anon_sym_PIPE_EQ] = ACTIONS(2774),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2774),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1188] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(2774),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2776),
    [anon_sym_QMARK] = ACTIONS(2774),
    [anon_sym_STAR_EQ] = ACTIONS(2774),
    [anon_sym_SLASH_EQ] = ACTIONS(2774),
    [anon_sym_PERCENT_EQ] = ACTIONS(2774),
    [anon_sym_PLUS_EQ] = ACTIONS(2774),
    [anon_sym_DASH_EQ] = ACTIONS(2774),
    [anon_sym_LT_LT_EQ] = ACTIONS(2774),
    [anon_sym_GT_GT_EQ] = ACTIONS(2774),
    [anon_sym_AMP_EQ] = ACTIONS(2774),
    [anon_sym_CARET_EQ] = ACTIONS(2774),
    [anon_sym_PIPE_EQ] = ACTIONS(2774),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2774),
    [anon_sym_AMP_AMP] = ACTIONS(2774),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1189] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(2770),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_STAR_EQ] = ACTIONS(2770),
    [anon_sym_SLASH_EQ] = ACTIONS(2770),
    [anon_sym_PERCENT_EQ] = ACTIONS(2770),
    [anon_sym_PLUS_EQ] = ACTIONS(2770),
    [anon_sym_DASH_EQ] = ACTIONS(2770),
    [anon_sym_LT_LT_EQ] = ACTIONS(2770),
    [anon_sym_GT_GT_EQ] = ACTIONS(2770),
    [anon_sym_AMP_EQ] = ACTIONS(2770),
    [anon_sym_CARET_EQ] = ACTIONS(2770),
    [anon_sym_PIPE_EQ] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_PIPE] = ACTIONS(2772),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1190] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(2770),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_STAR_EQ] = ACTIONS(2770),
    [anon_sym_SLASH_EQ] = ACTIONS(2770),
    [anon_sym_PERCENT_EQ] = ACTIONS(2770),
    [anon_sym_PLUS_EQ] = ACTIONS(2770),
    [anon_sym_DASH_EQ] = ACTIONS(2770),
    [anon_sym_LT_LT_EQ] = ACTIONS(2770),
    [anon_sym_GT_GT_EQ] = ACTIONS(2770),
    [anon_sym_AMP_EQ] = ACTIONS(2770),
    [anon_sym_CARET_EQ] = ACTIONS(2770),
    [anon_sym_PIPE_EQ] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_PIPE] = ACTIONS(2772),
    [anon_sym_CARET] = ACTIONS(2772),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1191] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(2778),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2780),
    [anon_sym_QMARK] = ACTIONS(2778),
    [anon_sym_STAR_EQ] = ACTIONS(2778),
    [anon_sym_SLASH_EQ] = ACTIONS(2778),
    [anon_sym_PERCENT_EQ] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2778),
    [anon_sym_DASH_EQ] = ACTIONS(2778),
    [anon_sym_LT_LT_EQ] = ACTIONS(2778),
    [anon_sym_GT_GT_EQ] = ACTIONS(2778),
    [anon_sym_AMP_EQ] = ACTIONS(2778),
    [anon_sym_CARET_EQ] = ACTIONS(2778),
    [anon_sym_PIPE_EQ] = ACTIONS(2778),
    [anon_sym_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2778),
    [anon_sym_AMP_AMP] = ACTIONS(2778),
    [anon_sym_PIPE] = ACTIONS(2780),
    [anon_sym_CARET] = ACTIONS(2780),
    [anon_sym_EQ_EQ] = ACTIONS(2778),
    [anon_sym_BANG_EQ] = ACTIONS(2778),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1192] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2784),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_STAR_EQ] = ACTIONS(2782),
    [anon_sym_SLASH_EQ] = ACTIONS(2782),
    [anon_sym_PERCENT_EQ] = ACTIONS(2782),
    [anon_sym_PLUS_EQ] = ACTIONS(2782),
    [anon_sym_DASH_EQ] = ACTIONS(2782),
    [anon_sym_LT_LT_EQ] = ACTIONS(2782),
    [anon_sym_GT_GT_EQ] = ACTIONS(2782),
    [anon_sym_AMP_EQ] = ACTIONS(2782),
    [anon_sym_CARET_EQ] = ACTIONS(2782),
    [anon_sym_PIPE_EQ] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2784),
    [anon_sym_PIPE_PIPE] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2784),
    [anon_sym_CARET] = ACTIONS(2784),
    [anon_sym_EQ_EQ] = ACTIONS(2782),
    [anon_sym_BANG_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2784),
    [anon_sym_GT] = ACTIONS(2784),
    [anon_sym_LT_EQ] = ACTIONS(2782),
    [anon_sym_GT_EQ] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1193] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(2786),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2788),
    [anon_sym_QMARK] = ACTIONS(2786),
    [anon_sym_STAR_EQ] = ACTIONS(2786),
    [anon_sym_SLASH_EQ] = ACTIONS(2786),
    [anon_sym_PERCENT_EQ] = ACTIONS(2786),
    [anon_sym_PLUS_EQ] = ACTIONS(2786),
    [anon_sym_DASH_EQ] = ACTIONS(2786),
    [anon_sym_LT_LT_EQ] = ACTIONS(2786),
    [anon_sym_GT_GT_EQ] = ACTIONS(2786),
    [anon_sym_AMP_EQ] = ACTIONS(2786),
    [anon_sym_CARET_EQ] = ACTIONS(2786),
    [anon_sym_PIPE_EQ] = ACTIONS(2786),
    [anon_sym_AMP] = ACTIONS(2788),
    [anon_sym_PIPE_PIPE] = ACTIONS(2786),
    [anon_sym_AMP_AMP] = ACTIONS(2786),
    [anon_sym_PIPE] = ACTIONS(2788),
    [anon_sym_CARET] = ACTIONS(2788),
    [anon_sym_EQ_EQ] = ACTIONS(2786),
    [anon_sym_BANG_EQ] = ACTIONS(2786),
    [anon_sym_LT] = ACTIONS(2788),
    [anon_sym_GT] = ACTIONS(2788),
    [anon_sym_LT_EQ] = ACTIONS(2786),
    [anon_sym_GT_EQ] = ACTIONS(2786),
    [anon_sym_LT_LT] = ACTIONS(2788),
    [anon_sym_GT_GT] = ACTIONS(2788),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1194] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(2760),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_QMARK] = ACTIONS(2760),
    [anon_sym_STAR_EQ] = ACTIONS(2760),
    [anon_sym_SLASH_EQ] = ACTIONS(2760),
    [anon_sym_PERCENT_EQ] = ACTIONS(2760),
    [anon_sym_PLUS_EQ] = ACTIONS(2760),
    [anon_sym_DASH_EQ] = ACTIONS(2760),
    [anon_sym_LT_LT_EQ] = ACTIONS(2760),
    [anon_sym_GT_GT_EQ] = ACTIONS(2760),
    [anon_sym_AMP_EQ] = ACTIONS(2760),
    [anon_sym_CARET_EQ] = ACTIONS(2760),
    [anon_sym_PIPE_EQ] = ACTIONS(2760),
    [anon_sym_AMP] = ACTIONS(2762),
    [anon_sym_PIPE_PIPE] = ACTIONS(2760),
    [anon_sym_AMP_AMP] = ACTIONS(2760),
    [anon_sym_PIPE] = ACTIONS(2762),
    [anon_sym_CARET] = ACTIONS(2762),
    [anon_sym_EQ_EQ] = ACTIONS(2760),
    [anon_sym_BANG_EQ] = ACTIONS(2760),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_GT] = ACTIONS(2762),
    [anon_sym_LT_EQ] = ACTIONS(2760),
    [anon_sym_GT_EQ] = ACTIONS(2760),
    [anon_sym_LT_LT] = ACTIONS(2762),
    [anon_sym_GT_GT] = ACTIONS(2762),
    [anon_sym_PLUS] = ACTIONS(2762),
    [anon_sym_DASH] = ACTIONS(2762),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1195] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3615),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3615),
    [sym_preproc_directive] = ACTIONS(3615),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_typedef] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_STAR] = ACTIONS(3617),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_auto] = ACTIONS(3615),
    [anon_sym_register] = ACTIONS(3615),
    [anon_sym_inline] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_restrict] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym__Atomic] = ACTIONS(3615),
    [anon_sym_unsigned] = ACTIONS(3615),
    [anon_sym_long] = ACTIONS(3615),
    [anon_sym_short] = ACTIONS(3615),
    [sym_primitive_type] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_union] = ACTIONS(3615),
    [anon_sym_if] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3615),
    [anon_sym_case] = ACTIONS(3615),
    [anon_sym_default] = ACTIONS(3615),
    [anon_sym_while] = ACTIONS(3615),
    [anon_sym_do] = ACTIONS(3615),
    [anon_sym_for] = ACTIONS(3615),
    [anon_sym_return] = ACTIONS(3615),
    [anon_sym_break] = ACTIONS(3615),
    [anon_sym_continue] = ACTIONS(3615),
    [anon_sym_goto] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_DASH_DASH] = ACTIONS(3617),
    [anon_sym_PLUS_PLUS] = ACTIONS(3617),
    [anon_sym_sizeof] = ACTIONS(3615),
    [sym_number_literal] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [sym_string_literal] = ACTIONS(3617),
    [sym_true] = ACTIONS(3615),
    [sym_false] = ACTIONS(3615),
    [sym_null] = ACTIONS(3615),
    [sym_identifier] = ACTIONS(3615),
    [sym_comment] = ACTIONS(42),
  },
  [1196] = {
    [sym__expression] = STATE(923),
    [sym_conditional_expression] = STATE(923),
    [sym_assignment_expression] = STATE(923),
    [sym_pointer_expression] = STATE(923),
    [sym_logical_expression] = STATE(923),
    [sym_bitwise_expression] = STATE(923),
    [sym_equality_expression] = STATE(923),
    [sym_relational_expression] = STATE(923),
    [sym_shift_expression] = STATE(923),
    [sym_math_expression] = STATE(923),
    [sym_cast_expression] = STATE(923),
    [sym_sizeof_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_call_expression] = STATE(923),
    [sym_field_expression] = STATE(923),
    [sym_compound_literal_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(923),
    [sym_initializer_list] = STATE(924),
    [sym_concatenated_string] = STATE(923),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_STAR] = ACTIONS(3619),
    [anon_sym_LBRACK] = ACTIONS(3288),
    [anon_sym_EQ] = ACTIONS(3292),
    [anon_sym_COLON] = ACTIONS(3288),
    [anon_sym_QMARK] = ACTIONS(3288),
    [anon_sym_STAR_EQ] = ACTIONS(3288),
    [anon_sym_SLASH_EQ] = ACTIONS(3288),
    [anon_sym_PERCENT_EQ] = ACTIONS(3288),
    [anon_sym_PLUS_EQ] = ACTIONS(3288),
    [anon_sym_DASH_EQ] = ACTIONS(3288),
    [anon_sym_LT_LT_EQ] = ACTIONS(3288),
    [anon_sym_GT_GT_EQ] = ACTIONS(3288),
    [anon_sym_AMP_EQ] = ACTIONS(3288),
    [anon_sym_CARET_EQ] = ACTIONS(3288),
    [anon_sym_PIPE_EQ] = ACTIONS(3288),
    [anon_sym_AMP] = ACTIONS(3619),
    [anon_sym_PIPE_PIPE] = ACTIONS(3288),
    [anon_sym_AMP_AMP] = ACTIONS(3288),
    [anon_sym_BANG] = ACTIONS(3621),
    [anon_sym_PIPE] = ACTIONS(3292),
    [anon_sym_CARET] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_EQ_EQ] = ACTIONS(3288),
    [anon_sym_BANG_EQ] = ACTIONS(3288),
    [anon_sym_LT] = ACTIONS(3292),
    [anon_sym_GT] = ACTIONS(3292),
    [anon_sym_LT_EQ] = ACTIONS(3288),
    [anon_sym_GT_EQ] = ACTIONS(3288),
    [anon_sym_LT_LT] = ACTIONS(3292),
    [anon_sym_GT_GT] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(3288),
    [anon_sym_DASH_GT] = ACTIONS(3288),
    [sym_number_literal] = ACTIONS(2459),
    [sym_char_literal] = ACTIONS(2459),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(2461),
    [sym_false] = ACTIONS(2461),
    [sym_null] = ACTIONS(2461),
    [sym_identifier] = ACTIONS(2461),
    [sym_comment] = ACTIONS(42),
  },
  [1197] = {
    [sym__expression] = STATE(1310),
    [sym_conditional_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1310),
    [sym_pointer_expression] = STATE(1310),
    [sym_logical_expression] = STATE(1310),
    [sym_bitwise_expression] = STATE(1310),
    [sym_equality_expression] = STATE(1310),
    [sym_relational_expression] = STATE(1310),
    [sym_shift_expression] = STATE(1310),
    [sym_math_expression] = STATE(1310),
    [sym_cast_expression] = STATE(1310),
    [sym_sizeof_expression] = STATE(1310),
    [sym_subscript_expression] = STATE(1310),
    [sym_call_expression] = STATE(1310),
    [sym_field_expression] = STATE(1310),
    [sym_compound_literal_expression] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1310),
    [sym_concatenated_string] = STATE(1310),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(3623),
    [sym_char_literal] = ACTIONS(3623),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(3625),
    [sym_false] = ACTIONS(3625),
    [sym_null] = ACTIONS(3625),
    [sym_identifier] = ACTIONS(3625),
    [sym_comment] = ACTIONS(42),
  },
  [1198] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3627),
    [sym_preproc_directive] = ACTIONS(3627),
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym_typedef] = ACTIONS(3627),
    [anon_sym_extern] = ACTIONS(3627),
    [anon_sym_LBRACE] = ACTIONS(3629),
    [anon_sym_RBRACE] = ACTIONS(3629),
    [anon_sym_STAR] = ACTIONS(3629),
    [anon_sym_static] = ACTIONS(3627),
    [anon_sym_auto] = ACTIONS(3627),
    [anon_sym_register] = ACTIONS(3627),
    [anon_sym_inline] = ACTIONS(3627),
    [anon_sym_const] = ACTIONS(3627),
    [anon_sym_restrict] = ACTIONS(3627),
    [anon_sym_volatile] = ACTIONS(3627),
    [anon_sym__Atomic] = ACTIONS(3627),
    [anon_sym_unsigned] = ACTIONS(3627),
    [anon_sym_long] = ACTIONS(3627),
    [anon_sym_short] = ACTIONS(3627),
    [sym_primitive_type] = ACTIONS(3627),
    [anon_sym_enum] = ACTIONS(3627),
    [anon_sym_struct] = ACTIONS(3627),
    [anon_sym_union] = ACTIONS(3627),
    [anon_sym_if] = ACTIONS(3627),
    [anon_sym_switch] = ACTIONS(3627),
    [anon_sym_case] = ACTIONS(3627),
    [anon_sym_default] = ACTIONS(3627),
    [anon_sym_while] = ACTIONS(3627),
    [anon_sym_do] = ACTIONS(3627),
    [anon_sym_for] = ACTIONS(3627),
    [anon_sym_return] = ACTIONS(3627),
    [anon_sym_break] = ACTIONS(3627),
    [anon_sym_continue] = ACTIONS(3627),
    [anon_sym_goto] = ACTIONS(3627),
    [anon_sym_AMP] = ACTIONS(3629),
    [anon_sym_BANG] = ACTIONS(3629),
    [anon_sym_TILDE] = ACTIONS(3629),
    [anon_sym_PLUS] = ACTIONS(3627),
    [anon_sym_DASH] = ACTIONS(3627),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_sizeof] = ACTIONS(3627),
    [sym_number_literal] = ACTIONS(3629),
    [sym_char_literal] = ACTIONS(3629),
    [sym_string_literal] = ACTIONS(3629),
    [sym_true] = ACTIONS(3627),
    [sym_false] = ACTIONS(3627),
    [sym_null] = ACTIONS(3627),
    [sym_identifier] = ACTIONS(3627),
    [sym_comment] = ACTIONS(42),
  },
  [1199] = {
    [sym_compound_statement] = STATE(1318),
    [sym_labeled_statement] = STATE(1318),
    [sym_expression_statement] = STATE(1318),
    [sym_if_statement] = STATE(1318),
    [sym_switch_statement] = STATE(1318),
    [sym_case_statement] = STATE(1318),
    [sym_while_statement] = STATE(1318),
    [sym_do_statement] = STATE(1318),
    [sym_for_statement] = STATE(1318),
    [sym_return_statement] = STATE(1318),
    [sym_break_statement] = STATE(1318),
    [sym_continue_statement] = STATE(1318),
    [sym_goto_statement] = STATE(1318),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3631),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_case] = ACTIONS(3635),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3639),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3643),
    [sym_comment] = ACTIONS(42),
  },
  [1200] = {
    [sym_compound_statement] = STATE(1195),
    [sym_labeled_statement] = STATE(1195),
    [sym_expression_statement] = STATE(1195),
    [sym_if_statement] = STATE(1195),
    [sym_switch_statement] = STATE(1195),
    [sym_case_statement] = STATE(1195),
    [sym_while_statement] = STATE(1195),
    [sym_do_statement] = STATE(1195),
    [sym_for_statement] = STATE(1195),
    [sym_return_statement] = STATE(1195),
    [sym_break_statement] = STATE(1195),
    [sym_continue_statement] = STATE(1195),
    [sym_goto_statement] = STATE(1195),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_default] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(1089),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1093),
    [sym_comment] = ACTIONS(42),
  },
  [1201] = {
    [sym_compound_statement] = STATE(1198),
    [sym_labeled_statement] = STATE(1198),
    [sym_expression_statement] = STATE(1198),
    [sym_if_statement] = STATE(1198),
    [sym_switch_statement] = STATE(1198),
    [sym_case_statement] = STATE(1198),
    [sym_while_statement] = STATE(1198),
    [sym_do_statement] = STATE(1198),
    [sym_for_statement] = STATE(1198),
    [sym_return_statement] = STATE(1198),
    [sym_break_statement] = STATE(1198),
    [sym_continue_statement] = STATE(1198),
    [sym_goto_statement] = STATE(1198),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_default] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(1089),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1093),
    [sym_comment] = ACTIONS(42),
  },
  [1202] = {
    [sym__expression] = STATE(1320),
    [sym_conditional_expression] = STATE(1320),
    [sym_assignment_expression] = STATE(1320),
    [sym_pointer_expression] = STATE(1320),
    [sym_logical_expression] = STATE(1320),
    [sym_bitwise_expression] = STATE(1320),
    [sym_equality_expression] = STATE(1320),
    [sym_relational_expression] = STATE(1320),
    [sym_shift_expression] = STATE(1320),
    [sym_math_expression] = STATE(1320),
    [sym_cast_expression] = STATE(1320),
    [sym_sizeof_expression] = STATE(1320),
    [sym_subscript_expression] = STATE(1320),
    [sym_call_expression] = STATE(1320),
    [sym_field_expression] = STATE(1320),
    [sym_compound_literal_expression] = STATE(1320),
    [sym_parenthesized_expression] = STATE(1320),
    [sym_concatenated_string] = STATE(1320),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(3645),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(3647),
    [sym_char_literal] = ACTIONS(3647),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [sym_null] = ACTIONS(3649),
    [sym_identifier] = ACTIONS(3649),
    [sym_comment] = ACTIONS(42),
  },
  [1203] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(3651),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1204] = {
    [sym__expression] = STATE(1322),
    [sym_conditional_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1322),
    [sym_pointer_expression] = STATE(1322),
    [sym_logical_expression] = STATE(1322),
    [sym_bitwise_expression] = STATE(1322),
    [sym_equality_expression] = STATE(1322),
    [sym_relational_expression] = STATE(1322),
    [sym_shift_expression] = STATE(1322),
    [sym_math_expression] = STATE(1322),
    [sym_cast_expression] = STATE(1322),
    [sym_sizeof_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_call_expression] = STATE(1322),
    [sym_field_expression] = STATE(1322),
    [sym_compound_literal_expression] = STATE(1322),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_concatenated_string] = STATE(1322),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(3651),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(3653),
    [sym_char_literal] = ACTIONS(3653),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(3655),
    [sym_false] = ACTIONS(3655),
    [sym_null] = ACTIONS(3655),
    [sym_identifier] = ACTIONS(3655),
    [sym_comment] = ACTIONS(42),
  },
  [1205] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(3657),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1206] = {
    [sym_compound_statement] = STATE(1324),
    [sym_labeled_statement] = STATE(1324),
    [sym_expression_statement] = STATE(1324),
    [sym_if_statement] = STATE(1324),
    [sym_switch_statement] = STATE(1324),
    [sym_case_statement] = STATE(1324),
    [sym_while_statement] = STATE(1324),
    [sym_do_statement] = STATE(1324),
    [sym_for_statement] = STATE(1324),
    [sym_return_statement] = STATE(1324),
    [sym_break_statement] = STATE(1324),
    [sym_continue_statement] = STATE(1324),
    [sym_goto_statement] = STATE(1324),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1835),
    [sym_comment] = ACTIONS(42),
  },
  [1207] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1326),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(3659),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1208] = {
    [sym__expression] = STATE(1327),
    [sym_conditional_expression] = STATE(1327),
    [sym_assignment_expression] = STATE(1327),
    [sym_pointer_expression] = STATE(1327),
    [sym_logical_expression] = STATE(1327),
    [sym_bitwise_expression] = STATE(1327),
    [sym_equality_expression] = STATE(1327),
    [sym_relational_expression] = STATE(1327),
    [sym_shift_expression] = STATE(1327),
    [sym_math_expression] = STATE(1327),
    [sym_cast_expression] = STATE(1327),
    [sym_sizeof_expression] = STATE(1327),
    [sym_subscript_expression] = STATE(1327),
    [sym_call_expression] = STATE(1327),
    [sym_field_expression] = STATE(1327),
    [sym_compound_literal_expression] = STATE(1327),
    [sym_parenthesized_expression] = STATE(1327),
    [sym_concatenated_string] = STATE(1327),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(3659),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(3661),
    [sym_char_literal] = ACTIONS(3661),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(3663),
    [sym_false] = ACTIONS(3663),
    [sym_null] = ACTIONS(3663),
    [sym_identifier] = ACTIONS(3663),
    [sym_comment] = ACTIONS(42),
  },
  [1209] = {
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_STAR] = ACTIONS(565),
    [anon_sym_AMP] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(565),
    [anon_sym_TILDE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_sizeof] = ACTIONS(567),
    [sym_number_literal] = ACTIONS(565),
    [sym_char_literal] = ACTIONS(565),
    [sym_string_literal] = ACTIONS(565),
    [sym_true] = ACTIONS(567),
    [sym_false] = ACTIONS(567),
    [sym_null] = ACTIONS(567),
    [sym_identifier] = ACTIONS(567),
    [sym_comment] = ACTIONS(42),
  },
  [1210] = {
    [aux_sym_declaration_repeat1] = STATE(302),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(3665),
    [sym_comment] = ACTIONS(42),
  },
  [1211] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(3667),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1212] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(3669),
    [anon_sym_RPAREN] = ACTIONS(3669),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1213] = {
    [anon_sym_LPAREN] = ACTIONS(3671),
    [anon_sym_COMMA] = ACTIONS(3671),
    [anon_sym_RPAREN] = ACTIONS(3671),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_STAR] = ACTIONS(3673),
    [anon_sym_LBRACK] = ACTIONS(3671),
    [anon_sym_RBRACK] = ACTIONS(3671),
    [anon_sym_EQ] = ACTIONS(3673),
    [anon_sym_COLON] = ACTIONS(3671),
    [anon_sym_QMARK] = ACTIONS(3671),
    [anon_sym_STAR_EQ] = ACTIONS(3671),
    [anon_sym_SLASH_EQ] = ACTIONS(3671),
    [anon_sym_PERCENT_EQ] = ACTIONS(3671),
    [anon_sym_PLUS_EQ] = ACTIONS(3671),
    [anon_sym_DASH_EQ] = ACTIONS(3671),
    [anon_sym_LT_LT_EQ] = ACTIONS(3671),
    [anon_sym_GT_GT_EQ] = ACTIONS(3671),
    [anon_sym_AMP_EQ] = ACTIONS(3671),
    [anon_sym_CARET_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_AMP] = ACTIONS(3673),
    [anon_sym_PIPE_PIPE] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3671),
    [anon_sym_PIPE] = ACTIONS(3673),
    [anon_sym_CARET] = ACTIONS(3673),
    [anon_sym_EQ_EQ] = ACTIONS(3671),
    [anon_sym_BANG_EQ] = ACTIONS(3671),
    [anon_sym_LT] = ACTIONS(3673),
    [anon_sym_GT] = ACTIONS(3673),
    [anon_sym_LT_EQ] = ACTIONS(3671),
    [anon_sym_GT_EQ] = ACTIONS(3671),
    [anon_sym_LT_LT] = ACTIONS(3673),
    [anon_sym_GT_GT] = ACTIONS(3673),
    [anon_sym_PLUS] = ACTIONS(3673),
    [anon_sym_DASH] = ACTIONS(3673),
    [anon_sym_SLASH] = ACTIONS(3673),
    [anon_sym_PERCENT] = ACTIONS(3673),
    [anon_sym_DASH_DASH] = ACTIONS(3671),
    [anon_sym_PLUS_PLUS] = ACTIONS(3671),
    [anon_sym_DOT] = ACTIONS(3671),
    [anon_sym_DASH_GT] = ACTIONS(3671),
    [sym_comment] = ACTIONS(42),
  },
  [1214] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(3675),
    [anon_sym_RPAREN] = ACTIONS(3669),
    [sym_comment] = ACTIONS(42),
  },
  [1215] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(3678),
    [anon_sym_SEMI] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_STAR_EQ] = ACTIONS(1171),
    [anon_sym_SLASH_EQ] = ACTIONS(1171),
    [anon_sym_PERCENT_EQ] = ACTIONS(1171),
    [anon_sym_PLUS_EQ] = ACTIONS(1171),
    [anon_sym_DASH_EQ] = ACTIONS(1171),
    [anon_sym_LT_LT_EQ] = ACTIONS(1171),
    [anon_sym_GT_GT_EQ] = ACTIONS(1171),
    [anon_sym_AMP_EQ] = ACTIONS(1171),
    [anon_sym_CARET_EQ] = ACTIONS(1171),
    [anon_sym_PIPE_EQ] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_PIPE_PIPE] = ACTIONS(1175),
    [anon_sym_AMP_AMP] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_LT] = ACTIONS(1185),
    [anon_sym_GT] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1187),
    [anon_sym_GT_EQ] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1189),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1216] = {
    [anon_sym_LPAREN] = ACTIONS(1455),
    [anon_sym_extern] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1455),
    [anon_sym_RBRACK] = ACTIONS(1455),
    [anon_sym_static] = ACTIONS(1457),
    [anon_sym_auto] = ACTIONS(1457),
    [anon_sym_register] = ACTIONS(1457),
    [anon_sym_inline] = ACTIONS(1457),
    [anon_sym_const] = ACTIONS(1457),
    [anon_sym_restrict] = ACTIONS(1457),
    [anon_sym_volatile] = ACTIONS(1457),
    [anon_sym__Atomic] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(1455),
    [anon_sym_BANG] = ACTIONS(1455),
    [anon_sym_TILDE] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_DASH_DASH] = ACTIONS(1455),
    [anon_sym_PLUS_PLUS] = ACTIONS(1455),
    [anon_sym_sizeof] = ACTIONS(1457),
    [sym_number_literal] = ACTIONS(1455),
    [sym_char_literal] = ACTIONS(1455),
    [sym_string_literal] = ACTIONS(1455),
    [sym_true] = ACTIONS(1457),
    [sym_false] = ACTIONS(1457),
    [sym_null] = ACTIONS(1457),
    [sym_identifier] = ACTIONS(1457),
    [sym_comment] = ACTIONS(42),
  },
  [1217] = {
    [sym_enumerator] = STATE(372),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [sym_identifier] = ACTIONS(210),
    [sym_comment] = ACTIONS(42),
  },
  [1218] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1237),
    [anon_sym_STAR_EQ] = ACTIONS(1239),
    [anon_sym_SLASH_EQ] = ACTIONS(1239),
    [anon_sym_PERCENT_EQ] = ACTIONS(1239),
    [anon_sym_PLUS_EQ] = ACTIONS(1239),
    [anon_sym_DASH_EQ] = ACTIONS(1239),
    [anon_sym_LT_LT_EQ] = ACTIONS(1239),
    [anon_sym_GT_GT_EQ] = ACTIONS(1239),
    [anon_sym_AMP_EQ] = ACTIONS(1239),
    [anon_sym_CARET_EQ] = ACTIONS(1239),
    [anon_sym_PIPE_EQ] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_PIPE_PIPE] = ACTIONS(1243),
    [anon_sym_AMP_AMP] = ACTIONS(1245),
    [anon_sym_PIPE] = ACTIONS(1247),
    [anon_sym_CARET] = ACTIONS(1249),
    [anon_sym_EQ_EQ] = ACTIONS(1251),
    [anon_sym_BANG_EQ] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1253),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1219] = {
    [anon_sym_LPAREN] = ACTIONS(3682),
    [anon_sym_COMMA] = ACTIONS(3682),
    [anon_sym_RPAREN] = ACTIONS(3682),
    [anon_sym_SEMI] = ACTIONS(3682),
    [anon_sym_RBRACE] = ACTIONS(3682),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(3682),
    [anon_sym_RBRACK] = ACTIONS(3682),
    [anon_sym_EQ] = ACTIONS(3684),
    [anon_sym_COLON] = ACTIONS(3682),
    [anon_sym_QMARK] = ACTIONS(3682),
    [anon_sym_STAR_EQ] = ACTIONS(3682),
    [anon_sym_SLASH_EQ] = ACTIONS(3682),
    [anon_sym_PERCENT_EQ] = ACTIONS(3682),
    [anon_sym_PLUS_EQ] = ACTIONS(3682),
    [anon_sym_DASH_EQ] = ACTIONS(3682),
    [anon_sym_LT_LT_EQ] = ACTIONS(3682),
    [anon_sym_GT_GT_EQ] = ACTIONS(3682),
    [anon_sym_AMP_EQ] = ACTIONS(3682),
    [anon_sym_CARET_EQ] = ACTIONS(3682),
    [anon_sym_PIPE_EQ] = ACTIONS(3682),
    [anon_sym_AMP] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3682),
    [anon_sym_AMP_AMP] = ACTIONS(3682),
    [anon_sym_PIPE] = ACTIONS(3684),
    [anon_sym_CARET] = ACTIONS(3684),
    [anon_sym_EQ_EQ] = ACTIONS(3682),
    [anon_sym_BANG_EQ] = ACTIONS(3682),
    [anon_sym_LT] = ACTIONS(3684),
    [anon_sym_GT] = ACTIONS(3684),
    [anon_sym_LT_EQ] = ACTIONS(3682),
    [anon_sym_GT_EQ] = ACTIONS(3682),
    [anon_sym_LT_LT] = ACTIONS(3684),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_PLUS] = ACTIONS(3684),
    [anon_sym_DASH] = ACTIONS(3684),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_PERCENT] = ACTIONS(3684),
    [anon_sym_DASH_DASH] = ACTIONS(3682),
    [anon_sym_PLUS_PLUS] = ACTIONS(3682),
    [anon_sym_DOT] = ACTIONS(3682),
    [anon_sym_DASH_GT] = ACTIONS(3682),
    [sym_comment] = ACTIONS(42),
  },
  [1220] = {
    [sym__expression] = STATE(1063),
    [sym_conditional_expression] = STATE(1063),
    [sym_assignment_expression] = STATE(1063),
    [sym_pointer_expression] = STATE(1063),
    [sym_logical_expression] = STATE(1063),
    [sym_bitwise_expression] = STATE(1063),
    [sym_equality_expression] = STATE(1063),
    [sym_relational_expression] = STATE(1063),
    [sym_shift_expression] = STATE(1063),
    [sym_math_expression] = STATE(1063),
    [sym_cast_expression] = STATE(1063),
    [sym_sizeof_expression] = STATE(1063),
    [sym_subscript_expression] = STATE(1063),
    [sym_call_expression] = STATE(1063),
    [sym_field_expression] = STATE(1063),
    [sym_compound_literal_expression] = STATE(1063),
    [sym_parenthesized_expression] = STATE(1063),
    [sym_initializer_list] = STATE(1064),
    [sym_initializer_pair] = STATE(1064),
    [sym_subscript_designator] = STATE(547),
    [sym_field_designator] = STATE(547),
    [sym_concatenated_string] = STATE(1063),
    [aux_sym_initializer_pair_repeat1] = STATE(547),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_LBRACK] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_sizeof] = ACTIONS(852),
    [anon_sym_DOT] = ACTIONS(1278),
    [sym_number_literal] = ACTIONS(2827),
    [sym_char_literal] = ACTIONS(2827),
    [sym_string_literal] = ACTIONS(856),
    [sym_true] = ACTIONS(2829),
    [sym_false] = ACTIONS(2829),
    [sym_null] = ACTIONS(2829),
    [sym_identifier] = ACTIONS(2829),
    [sym_comment] = ACTIONS(42),
  },
  [1221] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(3678),
    [anon_sym_RBRACE] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1429),
    [anon_sym_QMARK] = ACTIONS(1431),
    [anon_sym_STAR_EQ] = ACTIONS(1433),
    [anon_sym_SLASH_EQ] = ACTIONS(1433),
    [anon_sym_PERCENT_EQ] = ACTIONS(1433),
    [anon_sym_PLUS_EQ] = ACTIONS(1433),
    [anon_sym_DASH_EQ] = ACTIONS(1433),
    [anon_sym_LT_LT_EQ] = ACTIONS(1433),
    [anon_sym_GT_GT_EQ] = ACTIONS(1433),
    [anon_sym_AMP_EQ] = ACTIONS(1433),
    [anon_sym_CARET_EQ] = ACTIONS(1433),
    [anon_sym_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_PIPE] = ACTIONS(1441),
    [anon_sym_CARET] = ACTIONS(1443),
    [anon_sym_EQ_EQ] = ACTIONS(1445),
    [anon_sym_BANG_EQ] = ACTIONS(1445),
    [anon_sym_LT] = ACTIONS(1447),
    [anon_sym_GT] = ACTIONS(1447),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1451),
    [anon_sym_GT_GT] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_SLASH] = ACTIONS(1427),
    [anon_sym_PERCENT] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1222] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1223] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(3678),
    [anon_sym_RPAREN] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1224] = {
    [anon_sym_LF] = ACTIONS(3686),
    [sym_comment] = ACTIONS(50),
  },
  [1225] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(703),
    [anon_sym_LPAREN] = ACTIONS(701),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(703),
    [sym_preproc_directive] = ACTIONS(703),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_typedef] = ACTIONS(703),
    [anon_sym_extern] = ACTIONS(703),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(701),
    [anon_sym_static] = ACTIONS(703),
    [anon_sym_auto] = ACTIONS(703),
    [anon_sym_register] = ACTIONS(703),
    [anon_sym_inline] = ACTIONS(703),
    [anon_sym_const] = ACTIONS(703),
    [anon_sym_restrict] = ACTIONS(703),
    [anon_sym_volatile] = ACTIONS(703),
    [anon_sym__Atomic] = ACTIONS(703),
    [anon_sym_unsigned] = ACTIONS(703),
    [anon_sym_long] = ACTIONS(703),
    [anon_sym_short] = ACTIONS(703),
    [sym_primitive_type] = ACTIONS(703),
    [anon_sym_enum] = ACTIONS(703),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_union] = ACTIONS(703),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_switch] = ACTIONS(703),
    [anon_sym_case] = ACTIONS(703),
    [anon_sym_default] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_for] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(703),
    [anon_sym_break] = ACTIONS(703),
    [anon_sym_continue] = ACTIONS(703),
    [anon_sym_goto] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_BANG] = ACTIONS(701),
    [anon_sym_TILDE] = ACTIONS(701),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_DASH_DASH] = ACTIONS(701),
    [anon_sym_PLUS_PLUS] = ACTIONS(701),
    [anon_sym_sizeof] = ACTIONS(703),
    [sym_number_literal] = ACTIONS(701),
    [sym_char_literal] = ACTIONS(701),
    [sym_string_literal] = ACTIONS(701),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_identifier] = ACTIONS(703),
    [sym_comment] = ACTIONS(42),
  },
  [1226] = {
    [anon_sym_LF] = ACTIONS(3688),
    [sym_comment] = ACTIONS(50),
  },
  [1227] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3042),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3042),
    [anon_sym_LPAREN] = ACTIONS(3044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3042),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3042),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3042),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3042),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3042),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3042),
    [sym_preproc_directive] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym_typedef] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_auto] = ACTIONS(3042),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_struct] = ACTIONS(3042),
    [anon_sym_union] = ACTIONS(3042),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_switch] = ACTIONS(3042),
    [anon_sym_case] = ACTIONS(3042),
    [anon_sym_default] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_for] = ACTIONS(3042),
    [anon_sym_return] = ACTIONS(3042),
    [anon_sym_break] = ACTIONS(3042),
    [anon_sym_continue] = ACTIONS(3042),
    [anon_sym_goto] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3044),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3044),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3044),
    [anon_sym_PLUS_PLUS] = ACTIONS(3044),
    [anon_sym_sizeof] = ACTIONS(3042),
    [sym_number_literal] = ACTIONS(3044),
    [sym_char_literal] = ACTIONS(3044),
    [sym_string_literal] = ACTIONS(3044),
    [sym_true] = ACTIONS(3042),
    [sym_false] = ACTIONS(3042),
    [sym_null] = ACTIONS(3042),
    [sym_identifier] = ACTIONS(3042),
    [sym_comment] = ACTIONS(42),
  },
  [1228] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3046),
    [anon_sym_LPAREN] = ACTIONS(3048),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3046),
    [sym_preproc_directive] = ACTIONS(3046),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym_typedef] = ACTIONS(3046),
    [anon_sym_extern] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3048),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_static] = ACTIONS(3046),
    [anon_sym_auto] = ACTIONS(3046),
    [anon_sym_register] = ACTIONS(3046),
    [anon_sym_inline] = ACTIONS(3046),
    [anon_sym_const] = ACTIONS(3046),
    [anon_sym_restrict] = ACTIONS(3046),
    [anon_sym_volatile] = ACTIONS(3046),
    [anon_sym__Atomic] = ACTIONS(3046),
    [anon_sym_unsigned] = ACTIONS(3046),
    [anon_sym_long] = ACTIONS(3046),
    [anon_sym_short] = ACTIONS(3046),
    [sym_primitive_type] = ACTIONS(3046),
    [anon_sym_enum] = ACTIONS(3046),
    [anon_sym_struct] = ACTIONS(3046),
    [anon_sym_union] = ACTIONS(3046),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_switch] = ACTIONS(3046),
    [anon_sym_case] = ACTIONS(3046),
    [anon_sym_default] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_for] = ACTIONS(3046),
    [anon_sym_return] = ACTIONS(3046),
    [anon_sym_break] = ACTIONS(3046),
    [anon_sym_continue] = ACTIONS(3046),
    [anon_sym_goto] = ACTIONS(3046),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym_BANG] = ACTIONS(3048),
    [anon_sym_TILDE] = ACTIONS(3048),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_DASH] = ACTIONS(3046),
    [anon_sym_DASH_DASH] = ACTIONS(3048),
    [anon_sym_PLUS_PLUS] = ACTIONS(3048),
    [anon_sym_sizeof] = ACTIONS(3046),
    [sym_number_literal] = ACTIONS(3048),
    [sym_char_literal] = ACTIONS(3048),
    [sym_string_literal] = ACTIONS(3048),
    [sym_true] = ACTIONS(3046),
    [sym_false] = ACTIONS(3046),
    [sym_null] = ACTIONS(3046),
    [sym_identifier] = ACTIONS(3046),
    [sym_comment] = ACTIONS(42),
  },
  [1229] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3052),
    [anon_sym_LPAREN] = ACTIONS(3054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3052),
    [sym_preproc_directive] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3054),
    [anon_sym_typedef] = ACTIONS(3052),
    [anon_sym_extern] = ACTIONS(3052),
    [anon_sym_LBRACE] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3054),
    [anon_sym_static] = ACTIONS(3052),
    [anon_sym_auto] = ACTIONS(3052),
    [anon_sym_register] = ACTIONS(3052),
    [anon_sym_inline] = ACTIONS(3052),
    [anon_sym_const] = ACTIONS(3052),
    [anon_sym_restrict] = ACTIONS(3052),
    [anon_sym_volatile] = ACTIONS(3052),
    [anon_sym__Atomic] = ACTIONS(3052),
    [anon_sym_unsigned] = ACTIONS(3052),
    [anon_sym_long] = ACTIONS(3052),
    [anon_sym_short] = ACTIONS(3052),
    [sym_primitive_type] = ACTIONS(3052),
    [anon_sym_enum] = ACTIONS(3052),
    [anon_sym_struct] = ACTIONS(3052),
    [anon_sym_union] = ACTIONS(3052),
    [anon_sym_if] = ACTIONS(3052),
    [anon_sym_switch] = ACTIONS(3052),
    [anon_sym_case] = ACTIONS(3052),
    [anon_sym_default] = ACTIONS(3052),
    [anon_sym_while] = ACTIONS(3052),
    [anon_sym_do] = ACTIONS(3052),
    [anon_sym_for] = ACTIONS(3052),
    [anon_sym_return] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3052),
    [anon_sym_continue] = ACTIONS(3052),
    [anon_sym_goto] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_TILDE] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3052),
    [anon_sym_DASH_DASH] = ACTIONS(3054),
    [anon_sym_PLUS_PLUS] = ACTIONS(3054),
    [anon_sym_sizeof] = ACTIONS(3052),
    [sym_number_literal] = ACTIONS(3054),
    [sym_char_literal] = ACTIONS(3054),
    [sym_string_literal] = ACTIONS(3054),
    [sym_true] = ACTIONS(3052),
    [sym_false] = ACTIONS(3052),
    [sym_null] = ACTIONS(3052),
    [sym_identifier] = ACTIONS(3052),
    [sym_comment] = ACTIONS(42),
  },
  [1230] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3690),
    [sym_comment] = ACTIONS(42),
  },
  [1231] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3692),
    [sym_comment] = ACTIONS(42),
  },
  [1232] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3131),
    [anon_sym_LPAREN] = ACTIONS(3133),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3131),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym_typedef] = ACTIONS(3131),
    [anon_sym_extern] = ACTIONS(3131),
    [anon_sym_LBRACE] = ACTIONS(3133),
    [anon_sym_STAR] = ACTIONS(3133),
    [anon_sym_static] = ACTIONS(3131),
    [anon_sym_auto] = ACTIONS(3131),
    [anon_sym_register] = ACTIONS(3131),
    [anon_sym_inline] = ACTIONS(3131),
    [anon_sym_const] = ACTIONS(3131),
    [anon_sym_restrict] = ACTIONS(3131),
    [anon_sym_volatile] = ACTIONS(3131),
    [anon_sym__Atomic] = ACTIONS(3131),
    [anon_sym_unsigned] = ACTIONS(3131),
    [anon_sym_long] = ACTIONS(3131),
    [anon_sym_short] = ACTIONS(3131),
    [sym_primitive_type] = ACTIONS(3131),
    [anon_sym_enum] = ACTIONS(3131),
    [anon_sym_struct] = ACTIONS(3131),
    [anon_sym_union] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(3131),
    [anon_sym_switch] = ACTIONS(3131),
    [anon_sym_case] = ACTIONS(3131),
    [anon_sym_default] = ACTIONS(3131),
    [anon_sym_while] = ACTIONS(3131),
    [anon_sym_do] = ACTIONS(3131),
    [anon_sym_for] = ACTIONS(3131),
    [anon_sym_return] = ACTIONS(3131),
    [anon_sym_break] = ACTIONS(3131),
    [anon_sym_continue] = ACTIONS(3131),
    [anon_sym_goto] = ACTIONS(3131),
    [anon_sym_AMP] = ACTIONS(3133),
    [anon_sym_BANG] = ACTIONS(3133),
    [anon_sym_TILDE] = ACTIONS(3133),
    [anon_sym_PLUS] = ACTIONS(3131),
    [anon_sym_DASH] = ACTIONS(3131),
    [anon_sym_DASH_DASH] = ACTIONS(3133),
    [anon_sym_PLUS_PLUS] = ACTIONS(3133),
    [anon_sym_sizeof] = ACTIONS(3131),
    [sym_number_literal] = ACTIONS(3133),
    [sym_char_literal] = ACTIONS(3133),
    [sym_string_literal] = ACTIONS(3133),
    [sym_true] = ACTIONS(3131),
    [sym_false] = ACTIONS(3131),
    [sym_null] = ACTIONS(3131),
    [sym_identifier] = ACTIONS(3131),
    [sym_comment] = ACTIONS(42),
  },
  [1233] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3135),
    [anon_sym_LPAREN] = ACTIONS(3137),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3135),
    [sym_preproc_directive] = ACTIONS(3135),
    [anon_sym_SEMI] = ACTIONS(3137),
    [anon_sym_typedef] = ACTIONS(3135),
    [anon_sym_extern] = ACTIONS(3135),
    [anon_sym_LBRACE] = ACTIONS(3137),
    [anon_sym_STAR] = ACTIONS(3137),
    [anon_sym_static] = ACTIONS(3135),
    [anon_sym_auto] = ACTIONS(3135),
    [anon_sym_register] = ACTIONS(3135),
    [anon_sym_inline] = ACTIONS(3135),
    [anon_sym_const] = ACTIONS(3135),
    [anon_sym_restrict] = ACTIONS(3135),
    [anon_sym_volatile] = ACTIONS(3135),
    [anon_sym__Atomic] = ACTIONS(3135),
    [anon_sym_unsigned] = ACTIONS(3135),
    [anon_sym_long] = ACTIONS(3135),
    [anon_sym_short] = ACTIONS(3135),
    [sym_primitive_type] = ACTIONS(3135),
    [anon_sym_enum] = ACTIONS(3135),
    [anon_sym_struct] = ACTIONS(3135),
    [anon_sym_union] = ACTIONS(3135),
    [anon_sym_if] = ACTIONS(3135),
    [anon_sym_switch] = ACTIONS(3135),
    [anon_sym_case] = ACTIONS(3135),
    [anon_sym_default] = ACTIONS(3135),
    [anon_sym_while] = ACTIONS(3135),
    [anon_sym_do] = ACTIONS(3135),
    [anon_sym_for] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3135),
    [anon_sym_break] = ACTIONS(3135),
    [anon_sym_continue] = ACTIONS(3135),
    [anon_sym_goto] = ACTIONS(3135),
    [anon_sym_AMP] = ACTIONS(3137),
    [anon_sym_BANG] = ACTIONS(3137),
    [anon_sym_TILDE] = ACTIONS(3137),
    [anon_sym_PLUS] = ACTIONS(3135),
    [anon_sym_DASH] = ACTIONS(3135),
    [anon_sym_DASH_DASH] = ACTIONS(3137),
    [anon_sym_PLUS_PLUS] = ACTIONS(3137),
    [anon_sym_sizeof] = ACTIONS(3135),
    [sym_number_literal] = ACTIONS(3137),
    [sym_char_literal] = ACTIONS(3137),
    [sym_string_literal] = ACTIONS(3137),
    [sym_true] = ACTIONS(3135),
    [sym_false] = ACTIONS(3135),
    [sym_null] = ACTIONS(3135),
    [sym_identifier] = ACTIONS(3135),
    [sym_comment] = ACTIONS(42),
  },
  [1234] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3139),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3139),
    [anon_sym_LPAREN] = ACTIONS(3141),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3139),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3139),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3139),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3139),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3139),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3139),
    [sym_preproc_directive] = ACTIONS(3139),
    [anon_sym_SEMI] = ACTIONS(3141),
    [anon_sym_typedef] = ACTIONS(3139),
    [anon_sym_extern] = ACTIONS(3139),
    [anon_sym_LBRACE] = ACTIONS(3141),
    [anon_sym_STAR] = ACTIONS(3141),
    [anon_sym_static] = ACTIONS(3139),
    [anon_sym_auto] = ACTIONS(3139),
    [anon_sym_register] = ACTIONS(3139),
    [anon_sym_inline] = ACTIONS(3139),
    [anon_sym_const] = ACTIONS(3139),
    [anon_sym_restrict] = ACTIONS(3139),
    [anon_sym_volatile] = ACTIONS(3139),
    [anon_sym__Atomic] = ACTIONS(3139),
    [anon_sym_unsigned] = ACTIONS(3139),
    [anon_sym_long] = ACTIONS(3139),
    [anon_sym_short] = ACTIONS(3139),
    [sym_primitive_type] = ACTIONS(3139),
    [anon_sym_enum] = ACTIONS(3139),
    [anon_sym_struct] = ACTIONS(3139),
    [anon_sym_union] = ACTIONS(3139),
    [anon_sym_if] = ACTIONS(3139),
    [anon_sym_switch] = ACTIONS(3139),
    [anon_sym_case] = ACTIONS(3139),
    [anon_sym_default] = ACTIONS(3139),
    [anon_sym_while] = ACTIONS(3139),
    [anon_sym_do] = ACTIONS(3139),
    [anon_sym_for] = ACTIONS(3139),
    [anon_sym_return] = ACTIONS(3139),
    [anon_sym_break] = ACTIONS(3139),
    [anon_sym_continue] = ACTIONS(3139),
    [anon_sym_goto] = ACTIONS(3139),
    [anon_sym_AMP] = ACTIONS(3141),
    [anon_sym_BANG] = ACTIONS(3141),
    [anon_sym_TILDE] = ACTIONS(3141),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_DASH_DASH] = ACTIONS(3141),
    [anon_sym_PLUS_PLUS] = ACTIONS(3141),
    [anon_sym_sizeof] = ACTIONS(3139),
    [sym_number_literal] = ACTIONS(3141),
    [sym_char_literal] = ACTIONS(3141),
    [sym_string_literal] = ACTIONS(3141),
    [sym_true] = ACTIONS(3139),
    [sym_false] = ACTIONS(3139),
    [sym_null] = ACTIONS(3139),
    [sym_identifier] = ACTIONS(3139),
    [sym_comment] = ACTIONS(42),
  },
  [1235] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3694),
    [sym_comment] = ACTIONS(42),
  },
  [1236] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3696),
    [sym_comment] = ACTIONS(42),
  },
  [1237] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3147),
    [anon_sym_LPAREN] = ACTIONS(3149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3147),
    [sym_preproc_directive] = ACTIONS(3147),
    [anon_sym_SEMI] = ACTIONS(3149),
    [anon_sym_typedef] = ACTIONS(3147),
    [anon_sym_extern] = ACTIONS(3147),
    [anon_sym_LBRACE] = ACTIONS(3149),
    [anon_sym_STAR] = ACTIONS(3149),
    [anon_sym_static] = ACTIONS(3147),
    [anon_sym_auto] = ACTIONS(3147),
    [anon_sym_register] = ACTIONS(3147),
    [anon_sym_inline] = ACTIONS(3147),
    [anon_sym_const] = ACTIONS(3147),
    [anon_sym_restrict] = ACTIONS(3147),
    [anon_sym_volatile] = ACTIONS(3147),
    [anon_sym__Atomic] = ACTIONS(3147),
    [anon_sym_unsigned] = ACTIONS(3147),
    [anon_sym_long] = ACTIONS(3147),
    [anon_sym_short] = ACTIONS(3147),
    [sym_primitive_type] = ACTIONS(3147),
    [anon_sym_enum] = ACTIONS(3147),
    [anon_sym_struct] = ACTIONS(3147),
    [anon_sym_union] = ACTIONS(3147),
    [anon_sym_if] = ACTIONS(3147),
    [anon_sym_switch] = ACTIONS(3147),
    [anon_sym_case] = ACTIONS(3147),
    [anon_sym_default] = ACTIONS(3147),
    [anon_sym_while] = ACTIONS(3147),
    [anon_sym_do] = ACTIONS(3147),
    [anon_sym_for] = ACTIONS(3147),
    [anon_sym_return] = ACTIONS(3147),
    [anon_sym_break] = ACTIONS(3147),
    [anon_sym_continue] = ACTIONS(3147),
    [anon_sym_goto] = ACTIONS(3147),
    [anon_sym_AMP] = ACTIONS(3149),
    [anon_sym_BANG] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3149),
    [anon_sym_PLUS] = ACTIONS(3147),
    [anon_sym_DASH] = ACTIONS(3147),
    [anon_sym_DASH_DASH] = ACTIONS(3149),
    [anon_sym_PLUS_PLUS] = ACTIONS(3149),
    [anon_sym_sizeof] = ACTIONS(3147),
    [sym_number_literal] = ACTIONS(3149),
    [sym_char_literal] = ACTIONS(3149),
    [sym_string_literal] = ACTIONS(3149),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [sym_null] = ACTIONS(3147),
    [sym_identifier] = ACTIONS(3147),
    [sym_comment] = ACTIONS(42),
  },
  [1238] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3151),
    [anon_sym_LPAREN] = ACTIONS(3153),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3151),
    [sym_preproc_directive] = ACTIONS(3151),
    [anon_sym_SEMI] = ACTIONS(3153),
    [anon_sym_typedef] = ACTIONS(3151),
    [anon_sym_extern] = ACTIONS(3151),
    [anon_sym_LBRACE] = ACTIONS(3153),
    [anon_sym_STAR] = ACTIONS(3153),
    [anon_sym_static] = ACTIONS(3151),
    [anon_sym_auto] = ACTIONS(3151),
    [anon_sym_register] = ACTIONS(3151),
    [anon_sym_inline] = ACTIONS(3151),
    [anon_sym_const] = ACTIONS(3151),
    [anon_sym_restrict] = ACTIONS(3151),
    [anon_sym_volatile] = ACTIONS(3151),
    [anon_sym__Atomic] = ACTIONS(3151),
    [anon_sym_unsigned] = ACTIONS(3151),
    [anon_sym_long] = ACTIONS(3151),
    [anon_sym_short] = ACTIONS(3151),
    [sym_primitive_type] = ACTIONS(3151),
    [anon_sym_enum] = ACTIONS(3151),
    [anon_sym_struct] = ACTIONS(3151),
    [anon_sym_union] = ACTIONS(3151),
    [anon_sym_if] = ACTIONS(3151),
    [anon_sym_switch] = ACTIONS(3151),
    [anon_sym_case] = ACTIONS(3151),
    [anon_sym_default] = ACTIONS(3151),
    [anon_sym_while] = ACTIONS(3151),
    [anon_sym_do] = ACTIONS(3151),
    [anon_sym_for] = ACTIONS(3151),
    [anon_sym_return] = ACTIONS(3151),
    [anon_sym_break] = ACTIONS(3151),
    [anon_sym_continue] = ACTIONS(3151),
    [anon_sym_goto] = ACTIONS(3151),
    [anon_sym_AMP] = ACTIONS(3153),
    [anon_sym_BANG] = ACTIONS(3153),
    [anon_sym_TILDE] = ACTIONS(3153),
    [anon_sym_PLUS] = ACTIONS(3151),
    [anon_sym_DASH] = ACTIONS(3151),
    [anon_sym_DASH_DASH] = ACTIONS(3153),
    [anon_sym_PLUS_PLUS] = ACTIONS(3153),
    [anon_sym_sizeof] = ACTIONS(3151),
    [sym_number_literal] = ACTIONS(3153),
    [sym_char_literal] = ACTIONS(3153),
    [sym_string_literal] = ACTIONS(3153),
    [sym_true] = ACTIONS(3151),
    [sym_false] = ACTIONS(3151),
    [sym_null] = ACTIONS(3151),
    [sym_identifier] = ACTIONS(3151),
    [sym_comment] = ACTIONS(42),
  },
  [1239] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3155),
    [anon_sym_LPAREN] = ACTIONS(3157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3155),
    [sym_preproc_directive] = ACTIONS(3155),
    [anon_sym_SEMI] = ACTIONS(3157),
    [anon_sym_typedef] = ACTIONS(3155),
    [anon_sym_extern] = ACTIONS(3155),
    [anon_sym_LBRACE] = ACTIONS(3157),
    [anon_sym_STAR] = ACTIONS(3157),
    [anon_sym_static] = ACTIONS(3155),
    [anon_sym_auto] = ACTIONS(3155),
    [anon_sym_register] = ACTIONS(3155),
    [anon_sym_inline] = ACTIONS(3155),
    [anon_sym_const] = ACTIONS(3155),
    [anon_sym_restrict] = ACTIONS(3155),
    [anon_sym_volatile] = ACTIONS(3155),
    [anon_sym__Atomic] = ACTIONS(3155),
    [anon_sym_unsigned] = ACTIONS(3155),
    [anon_sym_long] = ACTIONS(3155),
    [anon_sym_short] = ACTIONS(3155),
    [sym_primitive_type] = ACTIONS(3155),
    [anon_sym_enum] = ACTIONS(3155),
    [anon_sym_struct] = ACTIONS(3155),
    [anon_sym_union] = ACTIONS(3155),
    [anon_sym_if] = ACTIONS(3155),
    [anon_sym_switch] = ACTIONS(3155),
    [anon_sym_case] = ACTIONS(3155),
    [anon_sym_default] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(3155),
    [anon_sym_do] = ACTIONS(3155),
    [anon_sym_for] = ACTIONS(3155),
    [anon_sym_return] = ACTIONS(3155),
    [anon_sym_break] = ACTIONS(3155),
    [anon_sym_continue] = ACTIONS(3155),
    [anon_sym_goto] = ACTIONS(3155),
    [anon_sym_AMP] = ACTIONS(3157),
    [anon_sym_BANG] = ACTIONS(3157),
    [anon_sym_TILDE] = ACTIONS(3157),
    [anon_sym_PLUS] = ACTIONS(3155),
    [anon_sym_DASH] = ACTIONS(3155),
    [anon_sym_DASH_DASH] = ACTIONS(3157),
    [anon_sym_PLUS_PLUS] = ACTIONS(3157),
    [anon_sym_sizeof] = ACTIONS(3155),
    [sym_number_literal] = ACTIONS(3157),
    [sym_char_literal] = ACTIONS(3157),
    [sym_string_literal] = ACTIONS(3157),
    [sym_true] = ACTIONS(3155),
    [sym_false] = ACTIONS(3155),
    [sym_null] = ACTIONS(3155),
    [sym_identifier] = ACTIONS(3155),
    [sym_comment] = ACTIONS(42),
  },
  [1240] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3698),
    [sym_comment] = ACTIONS(42),
  },
  [1241] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3700),
    [sym_comment] = ACTIONS(42),
  },
  [1242] = {
    [sym_preproc_arg] = ACTIONS(3702),
    [sym_comment] = ACTIONS(50),
  },
  [1243] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(359),
    [anon_sym_LPAREN] = ACTIONS(357),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(359),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(359),
    [sym_preproc_directive] = ACTIONS(359),
    [anon_sym_SEMI] = ACTIONS(357),
    [anon_sym_typedef] = ACTIONS(359),
    [anon_sym_extern] = ACTIONS(359),
    [anon_sym_LBRACE] = ACTIONS(357),
    [anon_sym_STAR] = ACTIONS(357),
    [anon_sym_static] = ACTIONS(359),
    [anon_sym_auto] = ACTIONS(359),
    [anon_sym_register] = ACTIONS(359),
    [anon_sym_inline] = ACTIONS(359),
    [anon_sym_const] = ACTIONS(359),
    [anon_sym_restrict] = ACTIONS(359),
    [anon_sym_volatile] = ACTIONS(359),
    [anon_sym__Atomic] = ACTIONS(359),
    [anon_sym_unsigned] = ACTIONS(359),
    [anon_sym_long] = ACTIONS(359),
    [anon_sym_short] = ACTIONS(359),
    [sym_primitive_type] = ACTIONS(359),
    [anon_sym_enum] = ACTIONS(359),
    [anon_sym_struct] = ACTIONS(359),
    [anon_sym_union] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(359),
    [anon_sym_case] = ACTIONS(359),
    [anon_sym_default] = ACTIONS(359),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_do] = ACTIONS(359),
    [anon_sym_for] = ACTIONS(359),
    [anon_sym_return] = ACTIONS(359),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(359),
    [anon_sym_goto] = ACTIONS(359),
    [anon_sym_AMP] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_DASH_DASH] = ACTIONS(357),
    [anon_sym_PLUS_PLUS] = ACTIONS(357),
    [anon_sym_sizeof] = ACTIONS(359),
    [sym_number_literal] = ACTIONS(357),
    [sym_char_literal] = ACTIONS(357),
    [sym_string_literal] = ACTIONS(357),
    [sym_true] = ACTIONS(359),
    [sym_false] = ACTIONS(359),
    [sym_null] = ACTIONS(359),
    [sym_identifier] = ACTIONS(359),
    [sym_comment] = ACTIONS(42),
  },
  [1244] = {
    [anon_sym_LF] = ACTIONS(3704),
    [sym_preproc_arg] = ACTIONS(3706),
    [sym_comment] = ACTIONS(50),
  },
  [1245] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2471),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2469),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2469),
    [sym_preproc_directive] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym_typedef] = ACTIONS(2469),
    [anon_sym_extern] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_STAR] = ACTIONS(2471),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_auto] = ACTIONS(2469),
    [anon_sym_register] = ACTIONS(2469),
    [anon_sym_inline] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_restrict] = ACTIONS(2469),
    [anon_sym_volatile] = ACTIONS(2469),
    [anon_sym__Atomic] = ACTIONS(2469),
    [anon_sym_unsigned] = ACTIONS(2469),
    [anon_sym_long] = ACTIONS(2469),
    [anon_sym_short] = ACTIONS(2469),
    [sym_primitive_type] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_struct] = ACTIONS(2469),
    [anon_sym_union] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_goto] = ACTIONS(2469),
    [anon_sym_AMP] = ACTIONS(2471),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_sizeof] = ACTIONS(2469),
    [sym_number_literal] = ACTIONS(2471),
    [sym_char_literal] = ACTIONS(2471),
    [sym_string_literal] = ACTIONS(2471),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_identifier] = ACTIONS(2469),
    [sym_comment] = ACTIONS(42),
  },
  [1246] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3708),
    [sym_comment] = ACTIONS(42),
  },
  [1247] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3710),
    [sym_comment] = ACTIONS(42),
  },
  [1248] = {
    [sym_preproc_include] = STATE(986),
    [sym_preproc_def] = STATE(986),
    [sym_preproc_function_def] = STATE(986),
    [sym_preproc_call] = STATE(986),
    [sym_preproc_if_in_compound_statement] = STATE(713),
    [sym_preproc_ifdef_in_compound_statement] = STATE(714),
    [sym_preproc_else_in_compound_statement] = STATE(1345),
    [sym_preproc_elif_in_compound_statement] = STATE(1346),
    [sym_declaration] = STATE(986),
    [sym_type_definition] = STATE(986),
    [sym__declaration_specifiers] = STATE(717),
    [sym_compound_statement] = STATE(986),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(986),
    [sym_expression_statement] = STATE(986),
    [sym_if_statement] = STATE(986),
    [sym_switch_statement] = STATE(986),
    [sym_case_statement] = STATE(986),
    [sym_while_statement] = STATE(986),
    [sym_do_statement] = STATE(986),
    [sym_for_statement] = STATE(986),
    [sym_return_statement] = STATE(986),
    [sym_break_statement] = STATE(986),
    [sym_continue_statement] = STATE(986),
    [sym_goto_statement] = STATE(986),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym__empty_declaration] = STATE(986),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(986),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1639),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3712),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1645),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1647),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1651),
    [sym_preproc_directive] = ACTIONS(1653),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_typedef] = ACTIONS(1657),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(42),
  },
  [1249] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2575),
    [anon_sym_LPAREN] = ACTIONS(2577),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2575),
    [sym_preproc_directive] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(2577),
    [anon_sym_typedef] = ACTIONS(2575),
    [anon_sym_extern] = ACTIONS(2575),
    [anon_sym_LBRACE] = ACTIONS(2577),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_static] = ACTIONS(2575),
    [anon_sym_auto] = ACTIONS(2575),
    [anon_sym_register] = ACTIONS(2575),
    [anon_sym_inline] = ACTIONS(2575),
    [anon_sym_const] = ACTIONS(2575),
    [anon_sym_restrict] = ACTIONS(2575),
    [anon_sym_volatile] = ACTIONS(2575),
    [anon_sym__Atomic] = ACTIONS(2575),
    [anon_sym_unsigned] = ACTIONS(2575),
    [anon_sym_long] = ACTIONS(2575),
    [anon_sym_short] = ACTIONS(2575),
    [sym_primitive_type] = ACTIONS(2575),
    [anon_sym_enum] = ACTIONS(2575),
    [anon_sym_struct] = ACTIONS(2575),
    [anon_sym_union] = ACTIONS(2575),
    [anon_sym_if] = ACTIONS(2575),
    [anon_sym_switch] = ACTIONS(2575),
    [anon_sym_case] = ACTIONS(2575),
    [anon_sym_default] = ACTIONS(2575),
    [anon_sym_while] = ACTIONS(2575),
    [anon_sym_do] = ACTIONS(2575),
    [anon_sym_for] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2575),
    [anon_sym_break] = ACTIONS(2575),
    [anon_sym_continue] = ACTIONS(2575),
    [anon_sym_goto] = ACTIONS(2575),
    [anon_sym_AMP] = ACTIONS(2577),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2575),
    [anon_sym_DASH] = ACTIONS(2575),
    [anon_sym_DASH_DASH] = ACTIONS(2577),
    [anon_sym_PLUS_PLUS] = ACTIONS(2577),
    [anon_sym_sizeof] = ACTIONS(2575),
    [sym_number_literal] = ACTIONS(2577),
    [sym_char_literal] = ACTIONS(2577),
    [sym_string_literal] = ACTIONS(2577),
    [sym_true] = ACTIONS(2575),
    [sym_false] = ACTIONS(2575),
    [sym_null] = ACTIONS(2575),
    [sym_identifier] = ACTIONS(2575),
    [sym_comment] = ACTIONS(42),
  },
  [1250] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(42),
  },
  [1251] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3716),
    [sym_comment] = ACTIONS(42),
  },
  [1252] = {
    [sym_preproc_include] = STATE(986),
    [sym_preproc_def] = STATE(986),
    [sym_preproc_function_def] = STATE(986),
    [sym_preproc_call] = STATE(986),
    [sym_preproc_if_in_compound_statement] = STATE(713),
    [sym_preproc_ifdef_in_compound_statement] = STATE(714),
    [sym_preproc_else_in_compound_statement] = STATE(1350),
    [sym_preproc_elif_in_compound_statement] = STATE(1351),
    [sym_declaration] = STATE(986),
    [sym_type_definition] = STATE(986),
    [sym__declaration_specifiers] = STATE(717),
    [sym_compound_statement] = STATE(986),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(986),
    [sym_expression_statement] = STATE(986),
    [sym_if_statement] = STATE(986),
    [sym_switch_statement] = STATE(986),
    [sym_case_statement] = STATE(986),
    [sym_while_statement] = STATE(986),
    [sym_do_statement] = STATE(986),
    [sym_for_statement] = STATE(986),
    [sym_return_statement] = STATE(986),
    [sym_break_statement] = STATE(986),
    [sym_continue_statement] = STATE(986),
    [sym_goto_statement] = STATE(986),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym__empty_declaration] = STATE(986),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(986),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1639),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3718),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1645),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1647),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1651),
    [sym_preproc_directive] = ACTIONS(1653),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_typedef] = ACTIONS(1657),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(42),
  },
  [1253] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2585),
    [anon_sym_LPAREN] = ACTIONS(2587),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2585),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2585),
    [sym_preproc_directive] = ACTIONS(2585),
    [anon_sym_SEMI] = ACTIONS(2587),
    [anon_sym_typedef] = ACTIONS(2585),
    [anon_sym_extern] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2587),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_static] = ACTIONS(2585),
    [anon_sym_auto] = ACTIONS(2585),
    [anon_sym_register] = ACTIONS(2585),
    [anon_sym_inline] = ACTIONS(2585),
    [anon_sym_const] = ACTIONS(2585),
    [anon_sym_restrict] = ACTIONS(2585),
    [anon_sym_volatile] = ACTIONS(2585),
    [anon_sym__Atomic] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [sym_primitive_type] = ACTIONS(2585),
    [anon_sym_enum] = ACTIONS(2585),
    [anon_sym_struct] = ACTIONS(2585),
    [anon_sym_union] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2585),
    [anon_sym_switch] = ACTIONS(2585),
    [anon_sym_case] = ACTIONS(2585),
    [anon_sym_default] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(2585),
    [anon_sym_do] = ACTIONS(2585),
    [anon_sym_for] = ACTIONS(2585),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_break] = ACTIONS(2585),
    [anon_sym_continue] = ACTIONS(2585),
    [anon_sym_goto] = ACTIONS(2585),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_BANG] = ACTIONS(2587),
    [anon_sym_TILDE] = ACTIONS(2587),
    [anon_sym_PLUS] = ACTIONS(2585),
    [anon_sym_DASH] = ACTIONS(2585),
    [anon_sym_DASH_DASH] = ACTIONS(2587),
    [anon_sym_PLUS_PLUS] = ACTIONS(2587),
    [anon_sym_sizeof] = ACTIONS(2585),
    [sym_number_literal] = ACTIONS(2587),
    [sym_char_literal] = ACTIONS(2587),
    [sym_string_literal] = ACTIONS(2587),
    [sym_true] = ACTIONS(2585),
    [sym_false] = ACTIONS(2585),
    [sym_null] = ACTIONS(2585),
    [sym_identifier] = ACTIONS(2585),
    [sym_comment] = ACTIONS(42),
  },
  [1254] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3720),
    [sym_comment] = ACTIONS(42),
  },
  [1255] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3722),
    [sym_comment] = ACTIONS(42),
  },
  [1256] = {
    [sym_preproc_include] = STATE(986),
    [sym_preproc_def] = STATE(986),
    [sym_preproc_function_def] = STATE(986),
    [sym_preproc_call] = STATE(986),
    [sym_preproc_if_in_compound_statement] = STATE(713),
    [sym_preproc_ifdef_in_compound_statement] = STATE(714),
    [sym_preproc_else_in_compound_statement] = STATE(1355),
    [sym_preproc_elif_in_compound_statement] = STATE(1356),
    [sym_declaration] = STATE(986),
    [sym_type_definition] = STATE(986),
    [sym__declaration_specifiers] = STATE(717),
    [sym_compound_statement] = STATE(986),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(986),
    [sym_expression_statement] = STATE(986),
    [sym_if_statement] = STATE(986),
    [sym_switch_statement] = STATE(986),
    [sym_case_statement] = STATE(986),
    [sym_while_statement] = STATE(986),
    [sym_do_statement] = STATE(986),
    [sym_for_statement] = STATE(986),
    [sym_return_statement] = STATE(986),
    [sym_break_statement] = STATE(986),
    [sym_continue_statement] = STATE(986),
    [sym_goto_statement] = STATE(986),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [sym__empty_declaration] = STATE(986),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(986),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1637),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1639),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1641),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3724),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1645),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1647),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1649),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1651),
    [sym_preproc_directive] = ACTIONS(1653),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_typedef] = ACTIONS(1657),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(1687),
    [sym_comment] = ACTIONS(42),
  },
  [1257] = {
    [anon_sym_LF] = ACTIONS(3726),
    [sym_comment] = ACTIONS(50),
  },
  [1258] = {
    [sym_parameter_list] = STATE(200),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_SEMI] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(449),
    [sym_comment] = ACTIONS(42),
  },
  [1259] = {
    [sym__type_declarator] = STATE(1359),
    [sym_pointer_type_declarator] = STATE(99),
    [sym_function_type_declarator] = STATE(100),
    [sym_array_type_declarator] = STATE(101),
    [anon_sym_LPAREN] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(187),
    [sym_identifier] = ACTIONS(189),
    [sym_comment] = ACTIONS(42),
  },
  [1260] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1913),
    [anon_sym_LPAREN] = ACTIONS(1911),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_auto] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [anon_sym_if] = ACTIONS(1913),
    [anon_sym_switch] = ACTIONS(1913),
    [anon_sym_case] = ACTIONS(1913),
    [anon_sym_default] = ACTIONS(1913),
    [anon_sym_while] = ACTIONS(1913),
    [anon_sym_do] = ACTIONS(1913),
    [anon_sym_for] = ACTIONS(1913),
    [anon_sym_return] = ACTIONS(1913),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1913),
    [anon_sym_goto] = ACTIONS(1913),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1913),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_sizeof] = ACTIONS(1913),
    [sym_number_literal] = ACTIONS(1911),
    [sym_char_literal] = ACTIONS(1911),
    [sym_string_literal] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [sym_null] = ACTIONS(1913),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(42),
  },
  [1261] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(3730),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1262] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(3732),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1263] = {
    [sym_declaration] = STATE(1362),
    [sym_type_definition] = STATE(1362),
    [sym__declaration_specifiers] = STATE(1266),
    [sym_compound_statement] = STATE(1362),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(1362),
    [sym_expression_statement] = STATE(1362),
    [sym_if_statement] = STATE(1362),
    [sym_switch_statement] = STATE(1362),
    [sym_case_statement] = STATE(1362),
    [sym_while_statement] = STATE(1362),
    [sym_do_statement] = STATE(1362),
    [sym_for_statement] = STATE(1362),
    [sym_return_statement] = STATE(1362),
    [sym_break_statement] = STATE(1362),
    [sym_continue_statement] = STATE(1362),
    [sym_goto_statement] = STATE(1362),
    [sym__expression] = STATE(954),
    [sym_comma_expression] = STATE(955),
    [sym_conditional_expression] = STATE(954),
    [sym_assignment_expression] = STATE(954),
    [sym_pointer_expression] = STATE(954),
    [sym_logical_expression] = STATE(954),
    [sym_bitwise_expression] = STATE(954),
    [sym_equality_expression] = STATE(954),
    [sym_relational_expression] = STATE(954),
    [sym_shift_expression] = STATE(954),
    [sym_math_expression] = STATE(954),
    [sym_cast_expression] = STATE(954),
    [sym_sizeof_expression] = STATE(954),
    [sym_subscript_expression] = STATE(954),
    [sym_call_expression] = STATE(954),
    [sym_field_expression] = STATE(954),
    [sym_compound_literal_expression] = STATE(954),
    [sym_parenthesized_expression] = STATE(954),
    [sym_concatenated_string] = STATE(954),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_typedef] = ACTIONS(2493),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(2497),
    [anon_sym_switch] = ACTIONS(2499),
    [anon_sym_case] = ACTIONS(2501),
    [anon_sym_default] = ACTIONS(2503),
    [anon_sym_while] = ACTIONS(2505),
    [anon_sym_do] = ACTIONS(2507),
    [anon_sym_for] = ACTIONS(2509),
    [anon_sym_return] = ACTIONS(2511),
    [anon_sym_break] = ACTIONS(2513),
    [anon_sym_continue] = ACTIONS(2515),
    [anon_sym_goto] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(2519),
    [sym_char_literal] = ACTIONS(2519),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(2521),
    [sym_false] = ACTIONS(2521),
    [sym_null] = ACTIONS(2521),
    [sym_identifier] = ACTIONS(3427),
    [sym_comment] = ACTIONS(42),
  },
  [1264] = {
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_extern] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_auto] = ACTIONS(95),
    [anon_sym_register] = ACTIONS(95),
    [anon_sym_inline] = ACTIONS(95),
    [anon_sym_const] = ACTIONS(95),
    [anon_sym_restrict] = ACTIONS(95),
    [anon_sym_volatile] = ACTIONS(95),
    [anon_sym__Atomic] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(2994),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_identifier] = ACTIONS(95),
    [sym_comment] = ACTIONS(42),
  },
  [1265] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2687),
    [sym_preproc_directive] = ACTIONS(2687),
    [anon_sym_SEMI] = ACTIONS(2689),
    [anon_sym_typedef] = ACTIONS(2687),
    [anon_sym_extern] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_STAR] = ACTIONS(2689),
    [anon_sym_static] = ACTIONS(2687),
    [anon_sym_auto] = ACTIONS(2687),
    [anon_sym_register] = ACTIONS(2687),
    [anon_sym_inline] = ACTIONS(2687),
    [anon_sym_const] = ACTIONS(2687),
    [anon_sym_restrict] = ACTIONS(2687),
    [anon_sym_volatile] = ACTIONS(2687),
    [anon_sym__Atomic] = ACTIONS(2687),
    [anon_sym_unsigned] = ACTIONS(2687),
    [anon_sym_long] = ACTIONS(2687),
    [anon_sym_short] = ACTIONS(2687),
    [sym_primitive_type] = ACTIONS(2687),
    [anon_sym_enum] = ACTIONS(2687),
    [anon_sym_struct] = ACTIONS(2687),
    [anon_sym_union] = ACTIONS(2687),
    [anon_sym_if] = ACTIONS(2687),
    [anon_sym_switch] = ACTIONS(2687),
    [anon_sym_case] = ACTIONS(2687),
    [anon_sym_default] = ACTIONS(2687),
    [anon_sym_while] = ACTIONS(2687),
    [anon_sym_do] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2687),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_break] = ACTIONS(2687),
    [anon_sym_continue] = ACTIONS(2687),
    [anon_sym_goto] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_BANG] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2687),
    [anon_sym_DASH] = ACTIONS(2687),
    [anon_sym_DASH_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_PLUS] = ACTIONS(2689),
    [anon_sym_sizeof] = ACTIONS(2687),
    [sym_number_literal] = ACTIONS(2689),
    [sym_char_literal] = ACTIONS(2689),
    [sym_string_literal] = ACTIONS(2689),
    [sym_true] = ACTIONS(2687),
    [sym_false] = ACTIONS(2687),
    [sym_null] = ACTIONS(2687),
    [sym_identifier] = ACTIONS(2687),
    [sym_comment] = ACTIONS(42),
  },
  [1266] = {
    [sym__declarator] = STATE(1130),
    [sym_pointer_declarator] = STATE(1130),
    [sym_function_declarator] = STATE(1130),
    [sym_array_declarator] = STATE(1130),
    [sym_init_declarator] = STATE(1131),
    [anon_sym_LPAREN] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(561),
    [sym_identifier] = ACTIONS(2998),
    [sym_comment] = ACTIONS(42),
  },
  [1267] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(3734),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1268] = {
    [anon_sym_LPAREN] = ACTIONS(3736),
    [sym_comment] = ACTIONS(42),
  },
  [1269] = {
    [sym__expression] = STATE(1366),
    [sym_conditional_expression] = STATE(1366),
    [sym_assignment_expression] = STATE(1366),
    [sym_pointer_expression] = STATE(1366),
    [sym_logical_expression] = STATE(1366),
    [sym_bitwise_expression] = STATE(1366),
    [sym_equality_expression] = STATE(1366),
    [sym_relational_expression] = STATE(1366),
    [sym_shift_expression] = STATE(1366),
    [sym_math_expression] = STATE(1366),
    [sym_cast_expression] = STATE(1366),
    [sym_sizeof_expression] = STATE(1366),
    [sym_subscript_expression] = STATE(1366),
    [sym_call_expression] = STATE(1366),
    [sym_field_expression] = STATE(1366),
    [sym_compound_literal_expression] = STATE(1366),
    [sym_parenthesized_expression] = STATE(1366),
    [sym_concatenated_string] = STATE(1366),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(3738),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(3740),
    [sym_char_literal] = ACTIONS(3740),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(3742),
    [sym_false] = ACTIONS(3742),
    [sym_null] = ACTIONS(3742),
    [sym_identifier] = ACTIONS(3742),
    [sym_comment] = ACTIONS(42),
  },
  [1270] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1271] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2727),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2727),
    [sym_preproc_directive] = ACTIONS(2727),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym_typedef] = ACTIONS(2727),
    [anon_sym_extern] = ACTIONS(2727),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_auto] = ACTIONS(2727),
    [anon_sym_register] = ACTIONS(2727),
    [anon_sym_inline] = ACTIONS(2727),
    [anon_sym_const] = ACTIONS(2727),
    [anon_sym_restrict] = ACTIONS(2727),
    [anon_sym_volatile] = ACTIONS(2727),
    [anon_sym__Atomic] = ACTIONS(2727),
    [anon_sym_unsigned] = ACTIONS(2727),
    [anon_sym_long] = ACTIONS(2727),
    [anon_sym_short] = ACTIONS(2727),
    [sym_primitive_type] = ACTIONS(2727),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_struct] = ACTIONS(2727),
    [anon_sym_union] = ACTIONS(2727),
    [anon_sym_if] = ACTIONS(2727),
    [anon_sym_switch] = ACTIONS(2727),
    [anon_sym_case] = ACTIONS(2727),
    [anon_sym_default] = ACTIONS(2727),
    [anon_sym_while] = ACTIONS(2727),
    [anon_sym_do] = ACTIONS(2727),
    [anon_sym_for] = ACTIONS(2727),
    [anon_sym_return] = ACTIONS(2727),
    [anon_sym_break] = ACTIONS(2727),
    [anon_sym_continue] = ACTIONS(2727),
    [anon_sym_goto] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_BANG] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2727),
    [anon_sym_DASH] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_sizeof] = ACTIONS(2727),
    [sym_number_literal] = ACTIONS(2729),
    [sym_char_literal] = ACTIONS(2729),
    [sym_string_literal] = ACTIONS(2729),
    [sym_true] = ACTIONS(2727),
    [sym_false] = ACTIONS(2727),
    [sym_null] = ACTIONS(2727),
    [sym_identifier] = ACTIONS(2727),
    [sym_comment] = ACTIONS(42),
  },
  [1272] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2731),
    [anon_sym_LPAREN] = ACTIONS(2733),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_auto] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_case] = ACTIONS(2731),
    [anon_sym_default] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [sym_number_literal] = ACTIONS(2733),
    [sym_char_literal] = ACTIONS(2733),
    [sym_string_literal] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [sym_null] = ACTIONS(2731),
    [sym_identifier] = ACTIONS(2731),
    [sym_comment] = ACTIONS(42),
  },
  [1273] = {
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_COLON] = ACTIONS(2994),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_comment] = ACTIONS(42),
  },
  [1274] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2746),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2744),
    [sym_preproc_directive] = ACTIONS(2744),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_typedef] = ACTIONS(2744),
    [anon_sym_extern] = ACTIONS(2744),
    [anon_sym_LBRACE] = ACTIONS(2746),
    [anon_sym_STAR] = ACTIONS(2746),
    [anon_sym_static] = ACTIONS(2744),
    [anon_sym_auto] = ACTIONS(2744),
    [anon_sym_register] = ACTIONS(2744),
    [anon_sym_inline] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_restrict] = ACTIONS(2744),
    [anon_sym_volatile] = ACTIONS(2744),
    [anon_sym__Atomic] = ACTIONS(2744),
    [anon_sym_unsigned] = ACTIONS(2744),
    [anon_sym_long] = ACTIONS(2744),
    [anon_sym_short] = ACTIONS(2744),
    [sym_primitive_type] = ACTIONS(2744),
    [anon_sym_enum] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_union] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_switch] = ACTIONS(2744),
    [anon_sym_case] = ACTIONS(2744),
    [anon_sym_default] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [anon_sym_do] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_break] = ACTIONS(2744),
    [anon_sym_continue] = ACTIONS(2744),
    [anon_sym_goto] = ACTIONS(2744),
    [anon_sym_AMP] = ACTIONS(2746),
    [anon_sym_BANG] = ACTIONS(2746),
    [anon_sym_TILDE] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_DASH] = ACTIONS(2744),
    [anon_sym_DASH_DASH] = ACTIONS(2746),
    [anon_sym_PLUS_PLUS] = ACTIONS(2746),
    [anon_sym_sizeof] = ACTIONS(2744),
    [sym_number_literal] = ACTIONS(2746),
    [sym_char_literal] = ACTIONS(2746),
    [sym_string_literal] = ACTIONS(2746),
    [sym_true] = ACTIONS(2744),
    [sym_false] = ACTIONS(2744),
    [sym_null] = ACTIONS(2744),
    [sym_identifier] = ACTIONS(2744),
    [sym_comment] = ACTIONS(42),
  },
  [1275] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(567),
    [anon_sym_LPAREN] = ACTIONS(565),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(567),
    [sym_preproc_directive] = ACTIONS(567),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_typedef] = ACTIONS(567),
    [anon_sym_extern] = ACTIONS(567),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_STAR] = ACTIONS(565),
    [anon_sym_static] = ACTIONS(567),
    [anon_sym_auto] = ACTIONS(567),
    [anon_sym_register] = ACTIONS(567),
    [anon_sym_inline] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_restrict] = ACTIONS(567),
    [anon_sym_volatile] = ACTIONS(567),
    [anon_sym__Atomic] = ACTIONS(567),
    [anon_sym_unsigned] = ACTIONS(567),
    [anon_sym_long] = ACTIONS(567),
    [anon_sym_short] = ACTIONS(567),
    [sym_primitive_type] = ACTIONS(567),
    [anon_sym_enum] = ACTIONS(567),
    [anon_sym_struct] = ACTIONS(567),
    [anon_sym_union] = ACTIONS(567),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_switch] = ACTIONS(567),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_default] = ACTIONS(567),
    [anon_sym_while] = ACTIONS(567),
    [anon_sym_do] = ACTIONS(567),
    [anon_sym_for] = ACTIONS(567),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_break] = ACTIONS(567),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(565),
    [anon_sym_TILDE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_sizeof] = ACTIONS(567),
    [sym_number_literal] = ACTIONS(565),
    [sym_char_literal] = ACTIONS(565),
    [sym_string_literal] = ACTIONS(565),
    [sym_true] = ACTIONS(567),
    [sym_false] = ACTIONS(567),
    [sym_null] = ACTIONS(567),
    [sym_identifier] = ACTIONS(567),
    [sym_comment] = ACTIONS(42),
  },
  [1276] = {
    [aux_sym_declaration_repeat1] = STATE(302),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(3746),
    [sym_comment] = ACTIONS(42),
  },
  [1277] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3748),
    [sym_comment] = ACTIONS(42),
  },
  [1278] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3750),
    [sym_comment] = ACTIONS(42),
  },
  [1279] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(799),
    [sym_preproc_directive] = ACTIONS(799),
    [anon_sym_SEMI] = ACTIONS(797),
    [anon_sym_typedef] = ACTIONS(799),
    [anon_sym_extern] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(797),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_static] = ACTIONS(799),
    [anon_sym_auto] = ACTIONS(799),
    [anon_sym_register] = ACTIONS(799),
    [anon_sym_inline] = ACTIONS(799),
    [anon_sym_const] = ACTIONS(799),
    [anon_sym_restrict] = ACTIONS(799),
    [anon_sym_volatile] = ACTIONS(799),
    [anon_sym__Atomic] = ACTIONS(799),
    [anon_sym_unsigned] = ACTIONS(799),
    [anon_sym_long] = ACTIONS(799),
    [anon_sym_short] = ACTIONS(799),
    [sym_primitive_type] = ACTIONS(799),
    [anon_sym_enum] = ACTIONS(799),
    [anon_sym_struct] = ACTIONS(799),
    [anon_sym_union] = ACTIONS(799),
    [anon_sym_if] = ACTIONS(799),
    [anon_sym_switch] = ACTIONS(799),
    [anon_sym_case] = ACTIONS(799),
    [anon_sym_default] = ACTIONS(799),
    [anon_sym_while] = ACTIONS(799),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(799),
    [anon_sym_break] = ACTIONS(799),
    [anon_sym_continue] = ACTIONS(799),
    [anon_sym_goto] = ACTIONS(799),
    [anon_sym_AMP] = ACTIONS(797),
    [anon_sym_BANG] = ACTIONS(797),
    [anon_sym_TILDE] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
    [anon_sym_sizeof] = ACTIONS(799),
    [sym_number_literal] = ACTIONS(797),
    [sym_char_literal] = ACTIONS(797),
    [sym_string_literal] = ACTIONS(797),
    [sym_true] = ACTIONS(799),
    [sym_false] = ACTIONS(799),
    [sym_null] = ACTIONS(799),
    [sym_identifier] = ACTIONS(799),
    [sym_comment] = ACTIONS(42),
  },
  [1280] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(813),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(815),
    [sym_preproc_directive] = ACTIONS(815),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_typedef] = ACTIONS(815),
    [anon_sym_extern] = ACTIONS(815),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_auto] = ACTIONS(815),
    [anon_sym_register] = ACTIONS(815),
    [anon_sym_inline] = ACTIONS(815),
    [anon_sym_const] = ACTIONS(815),
    [anon_sym_restrict] = ACTIONS(815),
    [anon_sym_volatile] = ACTIONS(815),
    [anon_sym__Atomic] = ACTIONS(815),
    [anon_sym_unsigned] = ACTIONS(815),
    [anon_sym_long] = ACTIONS(815),
    [anon_sym_short] = ACTIONS(815),
    [sym_primitive_type] = ACTIONS(815),
    [anon_sym_enum] = ACTIONS(815),
    [anon_sym_struct] = ACTIONS(815),
    [anon_sym_union] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(815),
    [anon_sym_switch] = ACTIONS(815),
    [anon_sym_case] = ACTIONS(815),
    [anon_sym_default] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(815),
    [anon_sym_do] = ACTIONS(815),
    [anon_sym_for] = ACTIONS(815),
    [anon_sym_return] = ACTIONS(815),
    [anon_sym_break] = ACTIONS(815),
    [anon_sym_continue] = ACTIONS(815),
    [anon_sym_goto] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_sizeof] = ACTIONS(815),
    [sym_number_literal] = ACTIONS(813),
    [sym_char_literal] = ACTIONS(813),
    [sym_string_literal] = ACTIONS(813),
    [sym_true] = ACTIONS(815),
    [sym_false] = ACTIONS(815),
    [sym_null] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_comment] = ACTIONS(42),
  },
  [1281] = {
    [sym_parameter_list] = STATE(200),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_SEMI] = ACTIONS(3752),
    [anon_sym_LBRACK] = ACTIONS(449),
    [sym_comment] = ACTIONS(42),
  },
  [1282] = {
    [sym_compound_statement] = STATE(1384),
    [sym_labeled_statement] = STATE(1384),
    [sym_expression_statement] = STATE(1384),
    [sym_if_statement] = STATE(1384),
    [sym_switch_statement] = STATE(1384),
    [sym_case_statement] = STATE(1384),
    [sym_while_statement] = STATE(1384),
    [sym_do_statement] = STATE(1384),
    [sym_for_statement] = STATE(1384),
    [sym_return_statement] = STATE(1384),
    [sym_break_statement] = STATE(1384),
    [sym_continue_statement] = STATE(1384),
    [sym_goto_statement] = STATE(1384),
    [sym__expression] = STATE(1385),
    [sym_comma_expression] = STATE(1386),
    [sym_conditional_expression] = STATE(1385),
    [sym_assignment_expression] = STATE(1385),
    [sym_pointer_expression] = STATE(1385),
    [sym_logical_expression] = STATE(1385),
    [sym_bitwise_expression] = STATE(1385),
    [sym_equality_expression] = STATE(1385),
    [sym_relational_expression] = STATE(1385),
    [sym_shift_expression] = STATE(1385),
    [sym_math_expression] = STATE(1385),
    [sym_cast_expression] = STATE(1385),
    [sym_sizeof_expression] = STATE(1385),
    [sym_subscript_expression] = STATE(1385),
    [sym_call_expression] = STATE(1385),
    [sym_field_expression] = STATE(1385),
    [sym_compound_literal_expression] = STATE(1385),
    [sym_parenthesized_expression] = STATE(1385),
    [sym_concatenated_string] = STATE(1385),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3754),
    [anon_sym_LBRACE] = ACTIONS(3756),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3758),
    [anon_sym_switch] = ACTIONS(3760),
    [anon_sym_case] = ACTIONS(3762),
    [anon_sym_default] = ACTIONS(3764),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3772),
    [anon_sym_break] = ACTIONS(3774),
    [anon_sym_continue] = ACTIONS(3776),
    [anon_sym_goto] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3780),
    [sym_char_literal] = ACTIONS(3780),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3782),
    [sym_false] = ACTIONS(3782),
    [sym_null] = ACTIONS(3782),
    [sym_identifier] = ACTIONS(3784),
    [sym_comment] = ACTIONS(42),
  },
  [1283] = {
    [sym_compound_statement] = STATE(1387),
    [sym_labeled_statement] = STATE(1387),
    [sym_expression_statement] = STATE(1387),
    [sym_if_statement] = STATE(1387),
    [sym_switch_statement] = STATE(1387),
    [sym_case_statement] = STATE(1387),
    [sym_while_statement] = STATE(1387),
    [sym_do_statement] = STATE(1387),
    [sym_for_statement] = STATE(1387),
    [sym_return_statement] = STATE(1387),
    [sym_break_statement] = STATE(1387),
    [sym_continue_statement] = STATE(1387),
    [sym_goto_statement] = STATE(1387),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(3040),
    [sym_comment] = ACTIONS(42),
  },
  [1284] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3250),
    [anon_sym_LPAREN] = ACTIONS(3252),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3250),
    [sym_preproc_directive] = ACTIONS(3250),
    [anon_sym_SEMI] = ACTIONS(3252),
    [anon_sym_typedef] = ACTIONS(3250),
    [anon_sym_extern] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3252),
    [anon_sym_STAR] = ACTIONS(3252),
    [anon_sym_static] = ACTIONS(3250),
    [anon_sym_auto] = ACTIONS(3250),
    [anon_sym_register] = ACTIONS(3250),
    [anon_sym_inline] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(3250),
    [anon_sym_restrict] = ACTIONS(3250),
    [anon_sym_volatile] = ACTIONS(3250),
    [anon_sym__Atomic] = ACTIONS(3250),
    [anon_sym_unsigned] = ACTIONS(3250),
    [anon_sym_long] = ACTIONS(3250),
    [anon_sym_short] = ACTIONS(3250),
    [sym_primitive_type] = ACTIONS(3250),
    [anon_sym_enum] = ACTIONS(3250),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_union] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_switch] = ACTIONS(3250),
    [anon_sym_case] = ACTIONS(3250),
    [anon_sym_default] = ACTIONS(3250),
    [anon_sym_while] = ACTIONS(3250),
    [anon_sym_do] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_goto] = ACTIONS(3250),
    [anon_sym_AMP] = ACTIONS(3252),
    [anon_sym_BANG] = ACTIONS(3252),
    [anon_sym_TILDE] = ACTIONS(3252),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3252),
    [anon_sym_PLUS_PLUS] = ACTIONS(3252),
    [anon_sym_sizeof] = ACTIONS(3250),
    [sym_number_literal] = ACTIONS(3252),
    [sym_char_literal] = ACTIONS(3252),
    [sym_string_literal] = ACTIONS(3252),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [sym_null] = ACTIONS(3250),
    [sym_identifier] = ACTIONS(3250),
    [sym_comment] = ACTIONS(42),
  },
  [1285] = {
    [sym_compound_statement] = STATE(1388),
    [sym_labeled_statement] = STATE(1388),
    [sym_expression_statement] = STATE(1388),
    [sym_if_statement] = STATE(1388),
    [sym_switch_statement] = STATE(1388),
    [sym_case_statement] = STATE(1388),
    [sym_while_statement] = STATE(1388),
    [sym_do_statement] = STATE(1388),
    [sym_for_statement] = STATE(1388),
    [sym_return_statement] = STATE(1388),
    [sym_break_statement] = STATE(1388),
    [sym_continue_statement] = STATE(1388),
    [sym_goto_statement] = STATE(1388),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(3040),
    [sym_comment] = ACTIONS(42),
  },
  [1286] = {
    [sym__expression] = STATE(1389),
    [sym_conditional_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1389),
    [sym_pointer_expression] = STATE(1389),
    [sym_logical_expression] = STATE(1389),
    [sym_bitwise_expression] = STATE(1389),
    [sym_equality_expression] = STATE(1389),
    [sym_relational_expression] = STATE(1389),
    [sym_shift_expression] = STATE(1389),
    [sym_math_expression] = STATE(1389),
    [sym_cast_expression] = STATE(1389),
    [sym_sizeof_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_call_expression] = STATE(1389),
    [sym_field_expression] = STATE(1389),
    [sym_compound_literal_expression] = STATE(1389),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_concatenated_string] = STATE(1389),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(3786),
    [sym_char_literal] = ACTIONS(3786),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(3788),
    [sym_false] = ACTIONS(3788),
    [sym_null] = ACTIONS(3788),
    [sym_identifier] = ACTIONS(3788),
    [sym_comment] = ACTIONS(42),
  },
  [1287] = {
    [sym__expression] = STATE(1391),
    [sym_conditional_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(1391),
    [sym_pointer_expression] = STATE(1391),
    [sym_logical_expression] = STATE(1391),
    [sym_bitwise_expression] = STATE(1391),
    [sym_equality_expression] = STATE(1391),
    [sym_relational_expression] = STATE(1391),
    [sym_shift_expression] = STATE(1391),
    [sym_math_expression] = STATE(1391),
    [sym_cast_expression] = STATE(1391),
    [sym_sizeof_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1391),
    [sym_call_expression] = STATE(1391),
    [sym_field_expression] = STATE(1391),
    [sym_compound_literal_expression] = STATE(1391),
    [sym_parenthesized_expression] = STATE(1391),
    [sym_concatenated_string] = STATE(1391),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(3790),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(3792),
    [sym_char_literal] = ACTIONS(3792),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(3794),
    [sym_false] = ACTIONS(3794),
    [sym_null] = ACTIONS(3794),
    [sym_identifier] = ACTIONS(3794),
    [sym_comment] = ACTIONS(42),
  },
  [1288] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(3796),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1289] = {
    [sym__expression] = STATE(1393),
    [sym_conditional_expression] = STATE(1393),
    [sym_assignment_expression] = STATE(1393),
    [sym_pointer_expression] = STATE(1393),
    [sym_logical_expression] = STATE(1393),
    [sym_bitwise_expression] = STATE(1393),
    [sym_equality_expression] = STATE(1393),
    [sym_relational_expression] = STATE(1393),
    [sym_shift_expression] = STATE(1393),
    [sym_math_expression] = STATE(1393),
    [sym_cast_expression] = STATE(1393),
    [sym_sizeof_expression] = STATE(1393),
    [sym_subscript_expression] = STATE(1393),
    [sym_call_expression] = STATE(1393),
    [sym_field_expression] = STATE(1393),
    [sym_compound_literal_expression] = STATE(1393),
    [sym_parenthesized_expression] = STATE(1393),
    [sym_concatenated_string] = STATE(1393),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(3796),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(3798),
    [sym_char_literal] = ACTIONS(3798),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(3800),
    [sym_false] = ACTIONS(3800),
    [sym_null] = ACTIONS(3800),
    [sym_identifier] = ACTIONS(3800),
    [sym_comment] = ACTIONS(42),
  },
  [1290] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1288),
    [anon_sym_LPAREN] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1288),
    [sym_preproc_directive] = ACTIONS(1288),
    [anon_sym_SEMI] = ACTIONS(1286),
    [anon_sym_typedef] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1288),
    [anon_sym_LBRACE] = ACTIONS(1286),
    [anon_sym_STAR] = ACTIONS(1286),
    [anon_sym_static] = ACTIONS(1288),
    [anon_sym_auto] = ACTIONS(1288),
    [anon_sym_register] = ACTIONS(1288),
    [anon_sym_inline] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_restrict] = ACTIONS(1288),
    [anon_sym_volatile] = ACTIONS(1288),
    [anon_sym__Atomic] = ACTIONS(1288),
    [anon_sym_unsigned] = ACTIONS(1288),
    [anon_sym_long] = ACTIONS(1288),
    [anon_sym_short] = ACTIONS(1288),
    [sym_primitive_type] = ACTIONS(1288),
    [anon_sym_enum] = ACTIONS(1288),
    [anon_sym_struct] = ACTIONS(1288),
    [anon_sym_union] = ACTIONS(1288),
    [anon_sym_if] = ACTIONS(1288),
    [anon_sym_switch] = ACTIONS(1288),
    [anon_sym_case] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1288),
    [anon_sym_while] = ACTIONS(1288),
    [anon_sym_do] = ACTIONS(1288),
    [anon_sym_for] = ACTIONS(1288),
    [anon_sym_return] = ACTIONS(1288),
    [anon_sym_break] = ACTIONS(1288),
    [anon_sym_continue] = ACTIONS(1288),
    [anon_sym_goto] = ACTIONS(1288),
    [anon_sym_AMP] = ACTIONS(1286),
    [anon_sym_BANG] = ACTIONS(1286),
    [anon_sym_TILDE] = ACTIONS(1286),
    [anon_sym_PLUS] = ACTIONS(1288),
    [anon_sym_DASH] = ACTIONS(1288),
    [anon_sym_DASH_DASH] = ACTIONS(1286),
    [anon_sym_PLUS_PLUS] = ACTIONS(1286),
    [anon_sym_sizeof] = ACTIONS(1288),
    [sym_number_literal] = ACTIONS(1286),
    [sym_char_literal] = ACTIONS(1286),
    [sym_string_literal] = ACTIONS(1286),
    [sym_true] = ACTIONS(1288),
    [sym_false] = ACTIONS(1288),
    [sym_null] = ACTIONS(1288),
    [sym_identifier] = ACTIONS(1288),
    [sym_comment] = ACTIONS(42),
  },
  [1291] = {
    [sym__expression] = STATE(923),
    [sym_conditional_expression] = STATE(923),
    [sym_assignment_expression] = STATE(923),
    [sym_pointer_expression] = STATE(923),
    [sym_logical_expression] = STATE(923),
    [sym_bitwise_expression] = STATE(923),
    [sym_equality_expression] = STATE(923),
    [sym_relational_expression] = STATE(923),
    [sym_shift_expression] = STATE(923),
    [sym_math_expression] = STATE(923),
    [sym_cast_expression] = STATE(923),
    [sym_sizeof_expression] = STATE(923),
    [sym_subscript_expression] = STATE(923),
    [sym_call_expression] = STATE(923),
    [sym_field_expression] = STATE(923),
    [sym_compound_literal_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(923),
    [sym_initializer_list] = STATE(924),
    [sym_concatenated_string] = STATE(923),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(3288),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_STAR] = ACTIONS(3802),
    [anon_sym_LBRACK] = ACTIONS(3288),
    [anon_sym_EQ] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3288),
    [anon_sym_STAR_EQ] = ACTIONS(3288),
    [anon_sym_SLASH_EQ] = ACTIONS(3288),
    [anon_sym_PERCENT_EQ] = ACTIONS(3288),
    [anon_sym_PLUS_EQ] = ACTIONS(3288),
    [anon_sym_DASH_EQ] = ACTIONS(3288),
    [anon_sym_LT_LT_EQ] = ACTIONS(3288),
    [anon_sym_GT_GT_EQ] = ACTIONS(3288),
    [anon_sym_AMP_EQ] = ACTIONS(3288),
    [anon_sym_CARET_EQ] = ACTIONS(3288),
    [anon_sym_PIPE_EQ] = ACTIONS(3288),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_PIPE_PIPE] = ACTIONS(3288),
    [anon_sym_AMP_AMP] = ACTIONS(3288),
    [anon_sym_BANG] = ACTIONS(3804),
    [anon_sym_PIPE] = ACTIONS(3292),
    [anon_sym_CARET] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_EQ_EQ] = ACTIONS(3288),
    [anon_sym_BANG_EQ] = ACTIONS(3288),
    [anon_sym_LT] = ACTIONS(3292),
    [anon_sym_GT] = ACTIONS(3292),
    [anon_sym_LT_EQ] = ACTIONS(3288),
    [anon_sym_GT_EQ] = ACTIONS(3288),
    [anon_sym_LT_LT] = ACTIONS(3292),
    [anon_sym_GT_GT] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [anon_sym_DOT] = ACTIONS(3288),
    [anon_sym_DASH_GT] = ACTIONS(3288),
    [sym_number_literal] = ACTIONS(2459),
    [sym_char_literal] = ACTIONS(2459),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(2461),
    [sym_false] = ACTIONS(2461),
    [sym_null] = ACTIONS(2461),
    [sym_identifier] = ACTIONS(2461),
    [sym_comment] = ACTIONS(42),
  },
  [1292] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1045),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1047),
    [sym_preproc_directive] = ACTIONS(1047),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_typedef] = ACTIONS(1047),
    [anon_sym_extern] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_auto] = ACTIONS(1047),
    [anon_sym_register] = ACTIONS(1047),
    [anon_sym_inline] = ACTIONS(1047),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_restrict] = ACTIONS(1047),
    [anon_sym_volatile] = ACTIONS(1047),
    [anon_sym__Atomic] = ACTIONS(1047),
    [anon_sym_unsigned] = ACTIONS(1047),
    [anon_sym_long] = ACTIONS(1047),
    [anon_sym_short] = ACTIONS(1047),
    [sym_primitive_type] = ACTIONS(1047),
    [anon_sym_enum] = ACTIONS(1047),
    [anon_sym_struct] = ACTIONS(1047),
    [anon_sym_union] = ACTIONS(1047),
    [anon_sym_if] = ACTIONS(1047),
    [anon_sym_else] = ACTIONS(1047),
    [anon_sym_switch] = ACTIONS(1047),
    [anon_sym_case] = ACTIONS(1047),
    [anon_sym_default] = ACTIONS(1047),
    [anon_sym_while] = ACTIONS(1047),
    [anon_sym_do] = ACTIONS(1047),
    [anon_sym_for] = ACTIONS(1047),
    [anon_sym_return] = ACTIONS(1047),
    [anon_sym_break] = ACTIONS(1047),
    [anon_sym_continue] = ACTIONS(1047),
    [anon_sym_goto] = ACTIONS(1047),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_PLUS] = ACTIONS(1047),
    [anon_sym_DASH] = ACTIONS(1047),
    [anon_sym_DASH_DASH] = ACTIONS(1045),
    [anon_sym_PLUS_PLUS] = ACTIONS(1045),
    [anon_sym_sizeof] = ACTIONS(1047),
    [sym_number_literal] = ACTIONS(1045),
    [sym_char_literal] = ACTIONS(1045),
    [sym_string_literal] = ACTIONS(1045),
    [sym_true] = ACTIONS(1047),
    [sym_false] = ACTIONS(1047),
    [sym_null] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [sym_comment] = ACTIONS(42),
  },
  [1293] = {
    [sym_preproc_include] = STATE(505),
    [sym_preproc_def] = STATE(505),
    [sym_preproc_function_def] = STATE(505),
    [sym_preproc_call] = STATE(505),
    [sym_preproc_if_in_compound_statement] = STATE(275),
    [sym_preproc_ifdef_in_compound_statement] = STATE(276),
    [sym_declaration] = STATE(505),
    [sym_type_definition] = STATE(505),
    [sym__declaration_specifiers] = STATE(277),
    [sym_compound_statement] = STATE(505),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(505),
    [sym_expression_statement] = STATE(505),
    [sym_if_statement] = STATE(505),
    [sym_switch_statement] = STATE(505),
    [sym_case_statement] = STATE(505),
    [sym_while_statement] = STATE(505),
    [sym_do_statement] = STATE(505),
    [sym_for_statement] = STATE(505),
    [sym_return_statement] = STATE(505),
    [sym_break_statement] = STATE(505),
    [sym_continue_statement] = STATE(505),
    [sym_goto_statement] = STATE(505),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [sym__empty_declaration] = STATE(505),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(505),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(577),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(579),
    [sym_preproc_directive] = ACTIONS(581),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_typedef] = ACTIONS(585),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_RBRACE] = ACTIONS(3806),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(631),
    [sym_comment] = ACTIONS(42),
  },
  [1294] = {
    [sym__expression] = STATE(1395),
    [sym_conditional_expression] = STATE(1395),
    [sym_assignment_expression] = STATE(1395),
    [sym_pointer_expression] = STATE(1395),
    [sym_logical_expression] = STATE(1395),
    [sym_bitwise_expression] = STATE(1395),
    [sym_equality_expression] = STATE(1395),
    [sym_relational_expression] = STATE(1395),
    [sym_shift_expression] = STATE(1395),
    [sym_math_expression] = STATE(1395),
    [sym_cast_expression] = STATE(1395),
    [sym_sizeof_expression] = STATE(1395),
    [sym_subscript_expression] = STATE(1395),
    [sym_call_expression] = STATE(1395),
    [sym_field_expression] = STATE(1395),
    [sym_compound_literal_expression] = STATE(1395),
    [sym_parenthesized_expression] = STATE(1395),
    [sym_concatenated_string] = STATE(1395),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(3808),
    [sym_char_literal] = ACTIONS(3808),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(3810),
    [sym_false] = ACTIONS(3810),
    [sym_null] = ACTIONS(3810),
    [sym_identifier] = ACTIONS(3810),
    [sym_comment] = ACTIONS(42),
  },
  [1295] = {
    [sym__expression] = STATE(1396),
    [sym_conditional_expression] = STATE(1396),
    [sym_assignment_expression] = STATE(1396),
    [sym_pointer_expression] = STATE(1396),
    [sym_logical_expression] = STATE(1396),
    [sym_bitwise_expression] = STATE(1396),
    [sym_equality_expression] = STATE(1396),
    [sym_relational_expression] = STATE(1396),
    [sym_shift_expression] = STATE(1396),
    [sym_math_expression] = STATE(1396),
    [sym_cast_expression] = STATE(1396),
    [sym_sizeof_expression] = STATE(1396),
    [sym_subscript_expression] = STATE(1396),
    [sym_call_expression] = STATE(1396),
    [sym_field_expression] = STATE(1396),
    [sym_compound_literal_expression] = STATE(1396),
    [sym_parenthesized_expression] = STATE(1396),
    [sym_concatenated_string] = STATE(1396),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(3812),
    [sym_char_literal] = ACTIONS(3812),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(3814),
    [sym_false] = ACTIONS(3814),
    [sym_null] = ACTIONS(3814),
    [sym_identifier] = ACTIONS(3814),
    [sym_comment] = ACTIONS(42),
  },
  [1296] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1737),
    [anon_sym_COLON] = ACTIONS(3816),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1743),
    [anon_sym_SLASH_EQ] = ACTIONS(1743),
    [anon_sym_PERCENT_EQ] = ACTIONS(1743),
    [anon_sym_PLUS_EQ] = ACTIONS(1743),
    [anon_sym_DASH_EQ] = ACTIONS(1743),
    [anon_sym_LT_LT_EQ] = ACTIONS(1743),
    [anon_sym_GT_GT_EQ] = ACTIONS(1743),
    [anon_sym_AMP_EQ] = ACTIONS(1743),
    [anon_sym_CARET_EQ] = ACTIONS(1743),
    [anon_sym_PIPE_EQ] = ACTIONS(1743),
    [anon_sym_AMP] = ACTIONS(1745),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_AMP_AMP] = ACTIONS(1749),
    [anon_sym_PIPE] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_GT] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1297] = {
    [sym_declaration] = STATE(1400),
    [sym_type_definition] = STATE(1400),
    [sym__declaration_specifiers] = STATE(1401),
    [sym_compound_statement] = STATE(1400),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(1400),
    [sym_expression_statement] = STATE(1400),
    [sym_if_statement] = STATE(1400),
    [sym_switch_statement] = STATE(1400),
    [sym_case_statement] = STATE(1400),
    [sym_while_statement] = STATE(1400),
    [sym_do_statement] = STATE(1400),
    [sym_for_statement] = STATE(1400),
    [sym_return_statement] = STATE(1400),
    [sym_break_statement] = STATE(1400),
    [sym_continue_statement] = STATE(1400),
    [sym_goto_statement] = STATE(1400),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_typedef] = ACTIONS(3818),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(3173),
    [anon_sym_switch] = ACTIONS(3175),
    [anon_sym_case] = ACTIONS(3177),
    [anon_sym_default] = ACTIONS(3179),
    [anon_sym_while] = ACTIONS(3181),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3185),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3820),
    [sym_comment] = ACTIONS(42),
  },
  [1298] = {
    [sym__expression] = STATE(1402),
    [sym_conditional_expression] = STATE(1402),
    [sym_assignment_expression] = STATE(1402),
    [sym_pointer_expression] = STATE(1402),
    [sym_logical_expression] = STATE(1402),
    [sym_bitwise_expression] = STATE(1402),
    [sym_equality_expression] = STATE(1402),
    [sym_relational_expression] = STATE(1402),
    [sym_shift_expression] = STATE(1402),
    [sym_math_expression] = STATE(1402),
    [sym_cast_expression] = STATE(1402),
    [sym_sizeof_expression] = STATE(1402),
    [sym_subscript_expression] = STATE(1402),
    [sym_call_expression] = STATE(1402),
    [sym_field_expression] = STATE(1402),
    [sym_compound_literal_expression] = STATE(1402),
    [sym_parenthesized_expression] = STATE(1402),
    [sym_concatenated_string] = STATE(1402),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(3822),
    [sym_char_literal] = ACTIONS(3822),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(3824),
    [sym_false] = ACTIONS(3824),
    [sym_null] = ACTIONS(3824),
    [sym_identifier] = ACTIONS(3824),
    [sym_comment] = ACTIONS(42),
  },
  [1299] = {
    [anon_sym_while] = ACTIONS(3826),
    [sym_comment] = ACTIONS(42),
  },
  [1300] = {
    [sym_declaration] = STATE(1404),
    [sym__declaration_specifiers] = STATE(773),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym__expression] = STATE(1405),
    [sym_conditional_expression] = STATE(1405),
    [sym_assignment_expression] = STATE(1405),
    [sym_pointer_expression] = STATE(1405),
    [sym_logical_expression] = STATE(1405),
    [sym_bitwise_expression] = STATE(1405),
    [sym_equality_expression] = STATE(1405),
    [sym_relational_expression] = STATE(1405),
    [sym_shift_expression] = STATE(1405),
    [sym_math_expression] = STATE(1405),
    [sym_cast_expression] = STATE(1405),
    [sym_sizeof_expression] = STATE(1405),
    [sym_subscript_expression] = STATE(1405),
    [sym_call_expression] = STATE(1405),
    [sym_field_expression] = STATE(1405),
    [sym_compound_literal_expression] = STATE(1405),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_concatenated_string] = STATE(1405),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(3828),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(3830),
    [sym_char_literal] = ACTIONS(3830),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [sym_null] = ACTIONS(3832),
    [sym_identifier] = ACTIONS(1795),
    [sym_comment] = ACTIONS(42),
  },
  [1301] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1797),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1797),
    [sym_preproc_directive] = ACTIONS(1797),
    [anon_sym_SEMI] = ACTIONS(1799),
    [anon_sym_typedef] = ACTIONS(1797),
    [anon_sym_extern] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1799),
    [anon_sym_RBRACE] = ACTIONS(1799),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_static] = ACTIONS(1797),
    [anon_sym_auto] = ACTIONS(1797),
    [anon_sym_register] = ACTIONS(1797),
    [anon_sym_inline] = ACTIONS(1797),
    [anon_sym_const] = ACTIONS(1797),
    [anon_sym_restrict] = ACTIONS(1797),
    [anon_sym_volatile] = ACTIONS(1797),
    [anon_sym__Atomic] = ACTIONS(1797),
    [anon_sym_unsigned] = ACTIONS(1797),
    [anon_sym_long] = ACTIONS(1797),
    [anon_sym_short] = ACTIONS(1797),
    [sym_primitive_type] = ACTIONS(1797),
    [anon_sym_enum] = ACTIONS(1797),
    [anon_sym_struct] = ACTIONS(1797),
    [anon_sym_union] = ACTIONS(1797),
    [anon_sym_if] = ACTIONS(1797),
    [anon_sym_else] = ACTIONS(1797),
    [anon_sym_switch] = ACTIONS(1797),
    [anon_sym_case] = ACTIONS(1797),
    [anon_sym_default] = ACTIONS(1797),
    [anon_sym_while] = ACTIONS(1797),
    [anon_sym_do] = ACTIONS(1797),
    [anon_sym_for] = ACTIONS(1797),
    [anon_sym_return] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1797),
    [anon_sym_continue] = ACTIONS(1797),
    [anon_sym_goto] = ACTIONS(1797),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_sizeof] = ACTIONS(1797),
    [sym_number_literal] = ACTIONS(1799),
    [sym_char_literal] = ACTIONS(1799),
    [sym_string_literal] = ACTIONS(1799),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [sym_null] = ACTIONS(1797),
    [sym_identifier] = ACTIONS(1797),
    [sym_comment] = ACTIONS(42),
  },
  [1302] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(3834),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1303] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1803),
    [anon_sym_LPAREN] = ACTIONS(1805),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1803),
    [sym_preproc_directive] = ACTIONS(1803),
    [anon_sym_SEMI] = ACTIONS(1805),
    [anon_sym_typedef] = ACTIONS(1803),
    [anon_sym_extern] = ACTIONS(1803),
    [anon_sym_LBRACE] = ACTIONS(1805),
    [anon_sym_RBRACE] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_static] = ACTIONS(1803),
    [anon_sym_auto] = ACTIONS(1803),
    [anon_sym_register] = ACTIONS(1803),
    [anon_sym_inline] = ACTIONS(1803),
    [anon_sym_const] = ACTIONS(1803),
    [anon_sym_restrict] = ACTIONS(1803),
    [anon_sym_volatile] = ACTIONS(1803),
    [anon_sym__Atomic] = ACTIONS(1803),
    [anon_sym_unsigned] = ACTIONS(1803),
    [anon_sym_long] = ACTIONS(1803),
    [anon_sym_short] = ACTIONS(1803),
    [sym_primitive_type] = ACTIONS(1803),
    [anon_sym_enum] = ACTIONS(1803),
    [anon_sym_struct] = ACTIONS(1803),
    [anon_sym_union] = ACTIONS(1803),
    [anon_sym_if] = ACTIONS(1803),
    [anon_sym_else] = ACTIONS(1803),
    [anon_sym_switch] = ACTIONS(1803),
    [anon_sym_case] = ACTIONS(1803),
    [anon_sym_default] = ACTIONS(1803),
    [anon_sym_while] = ACTIONS(1803),
    [anon_sym_do] = ACTIONS(1803),
    [anon_sym_for] = ACTIONS(1803),
    [anon_sym_return] = ACTIONS(1803),
    [anon_sym_break] = ACTIONS(1803),
    [anon_sym_continue] = ACTIONS(1803),
    [anon_sym_goto] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1803),
    [anon_sym_DASH] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1805),
    [anon_sym_PLUS_PLUS] = ACTIONS(1805),
    [anon_sym_sizeof] = ACTIONS(1803),
    [sym_number_literal] = ACTIONS(1805),
    [sym_char_literal] = ACTIONS(1805),
    [sym_string_literal] = ACTIONS(1805),
    [sym_true] = ACTIONS(1803),
    [sym_false] = ACTIONS(1803),
    [sym_null] = ACTIONS(1803),
    [sym_identifier] = ACTIONS(1803),
    [sym_comment] = ACTIONS(42),
  },
  [1304] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1807),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1807),
    [sym_preproc_directive] = ACTIONS(1807),
    [anon_sym_SEMI] = ACTIONS(1809),
    [anon_sym_typedef] = ACTIONS(1807),
    [anon_sym_extern] = ACTIONS(1807),
    [anon_sym_LBRACE] = ACTIONS(1809),
    [anon_sym_RBRACE] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_static] = ACTIONS(1807),
    [anon_sym_auto] = ACTIONS(1807),
    [anon_sym_register] = ACTIONS(1807),
    [anon_sym_inline] = ACTIONS(1807),
    [anon_sym_const] = ACTIONS(1807),
    [anon_sym_restrict] = ACTIONS(1807),
    [anon_sym_volatile] = ACTIONS(1807),
    [anon_sym__Atomic] = ACTIONS(1807),
    [anon_sym_unsigned] = ACTIONS(1807),
    [anon_sym_long] = ACTIONS(1807),
    [anon_sym_short] = ACTIONS(1807),
    [sym_primitive_type] = ACTIONS(1807),
    [anon_sym_enum] = ACTIONS(1807),
    [anon_sym_struct] = ACTIONS(1807),
    [anon_sym_union] = ACTIONS(1807),
    [anon_sym_if] = ACTIONS(1807),
    [anon_sym_else] = ACTIONS(1807),
    [anon_sym_switch] = ACTIONS(1807),
    [anon_sym_case] = ACTIONS(1807),
    [anon_sym_default] = ACTIONS(1807),
    [anon_sym_while] = ACTIONS(1807),
    [anon_sym_do] = ACTIONS(1807),
    [anon_sym_for] = ACTIONS(1807),
    [anon_sym_return] = ACTIONS(1807),
    [anon_sym_break] = ACTIONS(1807),
    [anon_sym_continue] = ACTIONS(1807),
    [anon_sym_goto] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1809),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1809),
    [anon_sym_PLUS_PLUS] = ACTIONS(1809),
    [anon_sym_sizeof] = ACTIONS(1807),
    [sym_number_literal] = ACTIONS(1809),
    [sym_char_literal] = ACTIONS(1809),
    [sym_string_literal] = ACTIONS(1809),
    [sym_true] = ACTIONS(1807),
    [sym_false] = ACTIONS(1807),
    [sym_null] = ACTIONS(1807),
    [sym_identifier] = ACTIONS(1807),
    [sym_comment] = ACTIONS(42),
  },
  [1305] = {
    [anon_sym_SEMI] = ACTIONS(3836),
    [sym_comment] = ACTIONS(42),
  },
  [1306] = {
    [sym_compound_statement] = STATE(1408),
    [sym_labeled_statement] = STATE(1408),
    [sym_expression_statement] = STATE(1408),
    [sym_if_statement] = STATE(1408),
    [sym_switch_statement] = STATE(1408),
    [sym_case_statement] = STATE(1408),
    [sym_while_statement] = STATE(1408),
    [sym_do_statement] = STATE(1408),
    [sym_for_statement] = STATE(1408),
    [sym_return_statement] = STATE(1408),
    [sym_break_statement] = STATE(1408),
    [sym_continue_statement] = STATE(1408),
    [sym_goto_statement] = STATE(1408),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3173),
    [anon_sym_switch] = ACTIONS(3175),
    [anon_sym_case] = ACTIONS(3177),
    [anon_sym_default] = ACTIONS(3179),
    [anon_sym_while] = ACTIONS(3181),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3185),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3199),
    [sym_comment] = ACTIONS(42),
  },
  [1307] = {
    [sym_compound_statement] = STATE(1409),
    [sym_labeled_statement] = STATE(1409),
    [sym_expression_statement] = STATE(1409),
    [sym_if_statement] = STATE(1409),
    [sym_switch_statement] = STATE(1409),
    [sym_case_statement] = STATE(1409),
    [sym_while_statement] = STATE(1409),
    [sym_do_statement] = STATE(1409),
    [sym_for_statement] = STATE(1409),
    [sym_return_statement] = STATE(1409),
    [sym_break_statement] = STATE(1409),
    [sym_continue_statement] = STATE(1409),
    [sym_goto_statement] = STATE(1409),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1835),
    [sym_comment] = ACTIONS(42),
  },
  [1308] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1849),
    [anon_sym_LPAREN] = ACTIONS(1851),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1849),
    [sym_preproc_directive] = ACTIONS(1849),
    [anon_sym_SEMI] = ACTIONS(1851),
    [anon_sym_typedef] = ACTIONS(1849),
    [anon_sym_extern] = ACTIONS(1849),
    [anon_sym_LBRACE] = ACTIONS(1851),
    [anon_sym_RBRACE] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1851),
    [anon_sym_static] = ACTIONS(1849),
    [anon_sym_auto] = ACTIONS(1849),
    [anon_sym_register] = ACTIONS(1849),
    [anon_sym_inline] = ACTIONS(1849),
    [anon_sym_const] = ACTIONS(1849),
    [anon_sym_restrict] = ACTIONS(1849),
    [anon_sym_volatile] = ACTIONS(1849),
    [anon_sym__Atomic] = ACTIONS(1849),
    [anon_sym_unsigned] = ACTIONS(1849),
    [anon_sym_long] = ACTIONS(1849),
    [anon_sym_short] = ACTIONS(1849),
    [sym_primitive_type] = ACTIONS(1849),
    [anon_sym_enum] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1849),
    [anon_sym_union] = ACTIONS(1849),
    [anon_sym_if] = ACTIONS(1849),
    [anon_sym_else] = ACTIONS(1849),
    [anon_sym_switch] = ACTIONS(1849),
    [anon_sym_case] = ACTIONS(1849),
    [anon_sym_default] = ACTIONS(1849),
    [anon_sym_while] = ACTIONS(1849),
    [anon_sym_do] = ACTIONS(1849),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(1849),
    [anon_sym_break] = ACTIONS(1849),
    [anon_sym_continue] = ACTIONS(1849),
    [anon_sym_goto] = ACTIONS(1849),
    [anon_sym_AMP] = ACTIONS(1851),
    [anon_sym_BANG] = ACTIONS(1851),
    [anon_sym_TILDE] = ACTIONS(1851),
    [anon_sym_PLUS] = ACTIONS(1849),
    [anon_sym_DASH] = ACTIONS(1849),
    [anon_sym_DASH_DASH] = ACTIONS(1851),
    [anon_sym_PLUS_PLUS] = ACTIONS(1851),
    [anon_sym_sizeof] = ACTIONS(1849),
    [sym_number_literal] = ACTIONS(1851),
    [sym_char_literal] = ACTIONS(1851),
    [sym_string_literal] = ACTIONS(1851),
    [sym_true] = ACTIONS(1849),
    [sym_false] = ACTIONS(1849),
    [sym_null] = ACTIONS(1849),
    [sym_identifier] = ACTIONS(1849),
    [sym_comment] = ACTIONS(42),
  },
  [1309] = {
    [sym__expression] = STATE(1410),
    [sym_conditional_expression] = STATE(1410),
    [sym_assignment_expression] = STATE(1410),
    [sym_pointer_expression] = STATE(1410),
    [sym_logical_expression] = STATE(1410),
    [sym_bitwise_expression] = STATE(1410),
    [sym_equality_expression] = STATE(1410),
    [sym_relational_expression] = STATE(1410),
    [sym_shift_expression] = STATE(1410),
    [sym_math_expression] = STATE(1410),
    [sym_cast_expression] = STATE(1410),
    [sym_sizeof_expression] = STATE(1410),
    [sym_subscript_expression] = STATE(1410),
    [sym_call_expression] = STATE(1410),
    [sym_field_expression] = STATE(1410),
    [sym_compound_literal_expression] = STATE(1410),
    [sym_parenthesized_expression] = STATE(1410),
    [sym_concatenated_string] = STATE(1410),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(3838),
    [sym_char_literal] = ACTIONS(3838),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(3840),
    [sym_false] = ACTIONS(3840),
    [sym_null] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(3840),
    [sym_comment] = ACTIONS(42),
  },
  [1310] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1737),
    [anon_sym_COLON] = ACTIONS(3678),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1743),
    [anon_sym_SLASH_EQ] = ACTIONS(1743),
    [anon_sym_PERCENT_EQ] = ACTIONS(1743),
    [anon_sym_PLUS_EQ] = ACTIONS(1743),
    [anon_sym_DASH_EQ] = ACTIONS(1743),
    [anon_sym_LT_LT_EQ] = ACTIONS(1743),
    [anon_sym_GT_GT_EQ] = ACTIONS(1743),
    [anon_sym_AMP_EQ] = ACTIONS(1743),
    [anon_sym_CARET_EQ] = ACTIONS(1743),
    [anon_sym_PIPE_EQ] = ACTIONS(1743),
    [anon_sym_AMP] = ACTIONS(1745),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_AMP_AMP] = ACTIONS(1749),
    [anon_sym_PIPE] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_GT] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1311] = {
    [anon_sym_LPAREN] = ACTIONS(3842),
    [sym_comment] = ACTIONS(42),
  },
  [1312] = {
    [anon_sym_LPAREN] = ACTIONS(3844),
    [sym_comment] = ACTIONS(42),
  },
  [1313] = {
    [sym__expression] = STATE(1413),
    [sym_conditional_expression] = STATE(1413),
    [sym_assignment_expression] = STATE(1413),
    [sym_pointer_expression] = STATE(1413),
    [sym_logical_expression] = STATE(1413),
    [sym_bitwise_expression] = STATE(1413),
    [sym_equality_expression] = STATE(1413),
    [sym_relational_expression] = STATE(1413),
    [sym_shift_expression] = STATE(1413),
    [sym_math_expression] = STATE(1413),
    [sym_cast_expression] = STATE(1413),
    [sym_sizeof_expression] = STATE(1413),
    [sym_subscript_expression] = STATE(1413),
    [sym_call_expression] = STATE(1413),
    [sym_field_expression] = STATE(1413),
    [sym_compound_literal_expression] = STATE(1413),
    [sym_parenthesized_expression] = STATE(1413),
    [sym_concatenated_string] = STATE(1413),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(3846),
    [sym_char_literal] = ACTIONS(3846),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(3848),
    [sym_false] = ACTIONS(3848),
    [sym_null] = ACTIONS(3848),
    [sym_identifier] = ACTIONS(3848),
    [sym_comment] = ACTIONS(42),
  },
  [1314] = {
    [anon_sym_COLON] = ACTIONS(3850),
    [sym_comment] = ACTIONS(42),
  },
  [1315] = {
    [anon_sym_LPAREN] = ACTIONS(3852),
    [sym_comment] = ACTIONS(42),
  },
  [1316] = {
    [anon_sym_LPAREN] = ACTIONS(3854),
    [sym_comment] = ACTIONS(42),
  },
  [1317] = {
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_COLON] = ACTIONS(3856),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_comment] = ACTIONS(42),
  },
  [1318] = {
    [anon_sym_else] = ACTIONS(3858),
    [anon_sym_while] = ACTIONS(3607),
    [sym_comment] = ACTIONS(42),
  },
  [1319] = {
    [sym_compound_statement] = STATE(1324),
    [sym_labeled_statement] = STATE(1324),
    [sym_expression_statement] = STATE(1324),
    [sym_if_statement] = STATE(1324),
    [sym_switch_statement] = STATE(1324),
    [sym_case_statement] = STATE(1324),
    [sym_while_statement] = STATE(1324),
    [sym_do_statement] = STATE(1324),
    [sym_for_statement] = STATE(1324),
    [sym_return_statement] = STATE(1324),
    [sym_break_statement] = STATE(1324),
    [sym_continue_statement] = STATE(1324),
    [sym_goto_statement] = STATE(1324),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_default] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(1089),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1093),
    [sym_comment] = ACTIONS(42),
  },
  [1320] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1420),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(3860),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1321] = {
    [sym__expression] = STATE(1421),
    [sym_conditional_expression] = STATE(1421),
    [sym_assignment_expression] = STATE(1421),
    [sym_pointer_expression] = STATE(1421),
    [sym_logical_expression] = STATE(1421),
    [sym_bitwise_expression] = STATE(1421),
    [sym_equality_expression] = STATE(1421),
    [sym_relational_expression] = STATE(1421),
    [sym_shift_expression] = STATE(1421),
    [sym_math_expression] = STATE(1421),
    [sym_cast_expression] = STATE(1421),
    [sym_sizeof_expression] = STATE(1421),
    [sym_subscript_expression] = STATE(1421),
    [sym_call_expression] = STATE(1421),
    [sym_field_expression] = STATE(1421),
    [sym_compound_literal_expression] = STATE(1421),
    [sym_parenthesized_expression] = STATE(1421),
    [sym_concatenated_string] = STATE(1421),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(3860),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(3862),
    [sym_char_literal] = ACTIONS(3862),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(3864),
    [sym_false] = ACTIONS(3864),
    [sym_null] = ACTIONS(3864),
    [sym_identifier] = ACTIONS(3864),
    [sym_comment] = ACTIONS(42),
  },
  [1322] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(3866),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1323] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3868),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3868),
    [sym_preproc_directive] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3870),
    [anon_sym_typedef] = ACTIONS(3868),
    [anon_sym_extern] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3870),
    [anon_sym_RBRACE] = ACTIONS(3870),
    [anon_sym_STAR] = ACTIONS(3870),
    [anon_sym_static] = ACTIONS(3868),
    [anon_sym_auto] = ACTIONS(3868),
    [anon_sym_register] = ACTIONS(3868),
    [anon_sym_inline] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(3868),
    [anon_sym_restrict] = ACTIONS(3868),
    [anon_sym_volatile] = ACTIONS(3868),
    [anon_sym__Atomic] = ACTIONS(3868),
    [anon_sym_unsigned] = ACTIONS(3868),
    [anon_sym_long] = ACTIONS(3868),
    [anon_sym_short] = ACTIONS(3868),
    [sym_primitive_type] = ACTIONS(3868),
    [anon_sym_enum] = ACTIONS(3868),
    [anon_sym_struct] = ACTIONS(3868),
    [anon_sym_union] = ACTIONS(3868),
    [anon_sym_if] = ACTIONS(3868),
    [anon_sym_switch] = ACTIONS(3868),
    [anon_sym_case] = ACTIONS(3868),
    [anon_sym_default] = ACTIONS(3868),
    [anon_sym_while] = ACTIONS(3868),
    [anon_sym_do] = ACTIONS(3868),
    [anon_sym_for] = ACTIONS(3868),
    [anon_sym_return] = ACTIONS(3868),
    [anon_sym_break] = ACTIONS(3868),
    [anon_sym_continue] = ACTIONS(3868),
    [anon_sym_goto] = ACTIONS(3868),
    [anon_sym_AMP] = ACTIONS(3870),
    [anon_sym_BANG] = ACTIONS(3870),
    [anon_sym_TILDE] = ACTIONS(3870),
    [anon_sym_PLUS] = ACTIONS(3868),
    [anon_sym_DASH] = ACTIONS(3868),
    [anon_sym_DASH_DASH] = ACTIONS(3870),
    [anon_sym_PLUS_PLUS] = ACTIONS(3870),
    [anon_sym_sizeof] = ACTIONS(3868),
    [sym_number_literal] = ACTIONS(3870),
    [sym_char_literal] = ACTIONS(3870),
    [sym_string_literal] = ACTIONS(3870),
    [sym_true] = ACTIONS(3868),
    [sym_false] = ACTIONS(3868),
    [sym_null] = ACTIONS(3868),
    [sym_identifier] = ACTIONS(3868),
    [sym_comment] = ACTIONS(42),
  },
  [1324] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3872),
    [anon_sym_LPAREN] = ACTIONS(3874),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3872),
    [sym_preproc_directive] = ACTIONS(3872),
    [anon_sym_SEMI] = ACTIONS(3874),
    [anon_sym_typedef] = ACTIONS(3872),
    [anon_sym_extern] = ACTIONS(3872),
    [anon_sym_LBRACE] = ACTIONS(3874),
    [anon_sym_RBRACE] = ACTIONS(3874),
    [anon_sym_STAR] = ACTIONS(3874),
    [anon_sym_static] = ACTIONS(3872),
    [anon_sym_auto] = ACTIONS(3872),
    [anon_sym_register] = ACTIONS(3872),
    [anon_sym_inline] = ACTIONS(3872),
    [anon_sym_const] = ACTIONS(3872),
    [anon_sym_restrict] = ACTIONS(3872),
    [anon_sym_volatile] = ACTIONS(3872),
    [anon_sym__Atomic] = ACTIONS(3872),
    [anon_sym_unsigned] = ACTIONS(3872),
    [anon_sym_long] = ACTIONS(3872),
    [anon_sym_short] = ACTIONS(3872),
    [sym_primitive_type] = ACTIONS(3872),
    [anon_sym_enum] = ACTIONS(3872),
    [anon_sym_struct] = ACTIONS(3872),
    [anon_sym_union] = ACTIONS(3872),
    [anon_sym_if] = ACTIONS(3872),
    [anon_sym_switch] = ACTIONS(3872),
    [anon_sym_case] = ACTIONS(3872),
    [anon_sym_default] = ACTIONS(3872),
    [anon_sym_while] = ACTIONS(3872),
    [anon_sym_do] = ACTIONS(3872),
    [anon_sym_for] = ACTIONS(3872),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_break] = ACTIONS(3872),
    [anon_sym_continue] = ACTIONS(3872),
    [anon_sym_goto] = ACTIONS(3872),
    [anon_sym_AMP] = ACTIONS(3874),
    [anon_sym_BANG] = ACTIONS(3874),
    [anon_sym_TILDE] = ACTIONS(3874),
    [anon_sym_PLUS] = ACTIONS(3872),
    [anon_sym_DASH] = ACTIONS(3872),
    [anon_sym_DASH_DASH] = ACTIONS(3874),
    [anon_sym_PLUS_PLUS] = ACTIONS(3874),
    [anon_sym_sizeof] = ACTIONS(3872),
    [sym_number_literal] = ACTIONS(3874),
    [sym_char_literal] = ACTIONS(3874),
    [sym_string_literal] = ACTIONS(3874),
    [sym_true] = ACTIONS(3872),
    [sym_false] = ACTIONS(3872),
    [sym_null] = ACTIONS(3872),
    [sym_identifier] = ACTIONS(3872),
    [sym_comment] = ACTIONS(42),
  },
  [1325] = {
    [sym_compound_statement] = STATE(1423),
    [sym_labeled_statement] = STATE(1423),
    [sym_expression_statement] = STATE(1423),
    [sym_if_statement] = STATE(1423),
    [sym_switch_statement] = STATE(1423),
    [sym_case_statement] = STATE(1423),
    [sym_while_statement] = STATE(1423),
    [sym_do_statement] = STATE(1423),
    [sym_for_statement] = STATE(1423),
    [sym_return_statement] = STATE(1423),
    [sym_break_statement] = STATE(1423),
    [sym_continue_statement] = STATE(1423),
    [sym_goto_statement] = STATE(1423),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1835),
    [sym_comment] = ACTIONS(42),
  },
  [1326] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(3876),
    [sym_comment] = ACTIONS(42),
  },
  [1327] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1425),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(3876),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1328] = {
    [anon_sym_LPAREN] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(1286),
    [anon_sym_STAR] = ACTIONS(1286),
    [anon_sym_AMP] = ACTIONS(1286),
    [anon_sym_BANG] = ACTIONS(1286),
    [anon_sym_TILDE] = ACTIONS(1286),
    [anon_sym_PLUS] = ACTIONS(1288),
    [anon_sym_DASH] = ACTIONS(1288),
    [anon_sym_DASH_DASH] = ACTIONS(1286),
    [anon_sym_PLUS_PLUS] = ACTIONS(1286),
    [anon_sym_sizeof] = ACTIONS(1288),
    [sym_number_literal] = ACTIONS(1286),
    [sym_char_literal] = ACTIONS(1286),
    [sym_string_literal] = ACTIONS(1286),
    [sym_true] = ACTIONS(1288),
    [sym_false] = ACTIONS(1288),
    [sym_null] = ACTIONS(1288),
    [sym_identifier] = ACTIONS(1288),
    [sym_comment] = ACTIONS(42),
  },
  [1329] = {
    [sym__expression] = STATE(1426),
    [sym_conditional_expression] = STATE(1426),
    [sym_assignment_expression] = STATE(1426),
    [sym_pointer_expression] = STATE(1426),
    [sym_logical_expression] = STATE(1426),
    [sym_bitwise_expression] = STATE(1426),
    [sym_equality_expression] = STATE(1426),
    [sym_relational_expression] = STATE(1426),
    [sym_shift_expression] = STATE(1426),
    [sym_math_expression] = STATE(1426),
    [sym_cast_expression] = STATE(1426),
    [sym_sizeof_expression] = STATE(1426),
    [sym_subscript_expression] = STATE(1426),
    [sym_call_expression] = STATE(1426),
    [sym_field_expression] = STATE(1426),
    [sym_compound_literal_expression] = STATE(1426),
    [sym_parenthesized_expression] = STATE(1426),
    [sym_concatenated_string] = STATE(1426),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(3876),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(3878),
    [sym_char_literal] = ACTIONS(3878),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(3880),
    [sym_false] = ACTIONS(3880),
    [sym_null] = ACTIONS(3880),
    [sym_identifier] = ACTIONS(3880),
    [sym_comment] = ACTIONS(42),
  },
  [1330] = {
    [anon_sym_LPAREN] = ACTIONS(2218),
    [anon_sym_extern] = ACTIONS(2220),
    [anon_sym_STAR] = ACTIONS(2218),
    [anon_sym_RBRACK] = ACTIONS(2218),
    [anon_sym_static] = ACTIONS(2220),
    [anon_sym_auto] = ACTIONS(2220),
    [anon_sym_register] = ACTIONS(2220),
    [anon_sym_inline] = ACTIONS(2220),
    [anon_sym_const] = ACTIONS(2220),
    [anon_sym_restrict] = ACTIONS(2220),
    [anon_sym_volatile] = ACTIONS(2220),
    [anon_sym__Atomic] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2218),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_DASH] = ACTIONS(2220),
    [anon_sym_DASH_DASH] = ACTIONS(2218),
    [anon_sym_PLUS_PLUS] = ACTIONS(2218),
    [anon_sym_sizeof] = ACTIONS(2220),
    [sym_number_literal] = ACTIONS(2218),
    [sym_char_literal] = ACTIONS(2218),
    [sym_string_literal] = ACTIONS(2218),
    [sym_true] = ACTIONS(2220),
    [sym_false] = ACTIONS(2220),
    [sym_null] = ACTIONS(2220),
    [sym_identifier] = ACTIONS(2220),
    [sym_comment] = ACTIONS(42),
  },
  [1331] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1295),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1295),
    [sym_preproc_directive] = ACTIONS(1295),
    [anon_sym_SEMI] = ACTIONS(1293),
    [anon_sym_typedef] = ACTIONS(1295),
    [anon_sym_extern] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_STAR] = ACTIONS(1293),
    [anon_sym_static] = ACTIONS(1295),
    [anon_sym_auto] = ACTIONS(1295),
    [anon_sym_register] = ACTIONS(1295),
    [anon_sym_inline] = ACTIONS(1295),
    [anon_sym_const] = ACTIONS(1295),
    [anon_sym_restrict] = ACTIONS(1295),
    [anon_sym_volatile] = ACTIONS(1295),
    [anon_sym__Atomic] = ACTIONS(1295),
    [anon_sym_unsigned] = ACTIONS(1295),
    [anon_sym_long] = ACTIONS(1295),
    [anon_sym_short] = ACTIONS(1295),
    [sym_primitive_type] = ACTIONS(1295),
    [anon_sym_enum] = ACTIONS(1295),
    [anon_sym_struct] = ACTIONS(1295),
    [anon_sym_union] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(1295),
    [anon_sym_switch] = ACTIONS(1295),
    [anon_sym_case] = ACTIONS(1295),
    [anon_sym_default] = ACTIONS(1295),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_do] = ACTIONS(1295),
    [anon_sym_for] = ACTIONS(1295),
    [anon_sym_return] = ACTIONS(1295),
    [anon_sym_break] = ACTIONS(1295),
    [anon_sym_continue] = ACTIONS(1295),
    [anon_sym_goto] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1295),
    [anon_sym_DASH] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1293),
    [anon_sym_sizeof] = ACTIONS(1295),
    [sym_number_literal] = ACTIONS(1293),
    [sym_char_literal] = ACTIONS(1293),
    [sym_string_literal] = ACTIONS(1293),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_null] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_comment] = ACTIONS(42),
  },
  [1332] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1305),
    [anon_sym_LPAREN] = ACTIONS(1303),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1305),
    [sym_preproc_directive] = ACTIONS(1305),
    [anon_sym_SEMI] = ACTIONS(1303),
    [anon_sym_typedef] = ACTIONS(1305),
    [anon_sym_extern] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1303),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1305),
    [anon_sym_auto] = ACTIONS(1305),
    [anon_sym_register] = ACTIONS(1305),
    [anon_sym_inline] = ACTIONS(1305),
    [anon_sym_const] = ACTIONS(1305),
    [anon_sym_restrict] = ACTIONS(1305),
    [anon_sym_volatile] = ACTIONS(1305),
    [anon_sym__Atomic] = ACTIONS(1305),
    [anon_sym_unsigned] = ACTIONS(1305),
    [anon_sym_long] = ACTIONS(1305),
    [anon_sym_short] = ACTIONS(1305),
    [sym_primitive_type] = ACTIONS(1305),
    [anon_sym_enum] = ACTIONS(1305),
    [anon_sym_struct] = ACTIONS(1305),
    [anon_sym_union] = ACTIONS(1305),
    [anon_sym_if] = ACTIONS(1305),
    [anon_sym_switch] = ACTIONS(1305),
    [anon_sym_case] = ACTIONS(1305),
    [anon_sym_default] = ACTIONS(1305),
    [anon_sym_while] = ACTIONS(1305),
    [anon_sym_do] = ACTIONS(1305),
    [anon_sym_for] = ACTIONS(1305),
    [anon_sym_return] = ACTIONS(1305),
    [anon_sym_break] = ACTIONS(1305),
    [anon_sym_continue] = ACTIONS(1305),
    [anon_sym_goto] = ACTIONS(1305),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_BANG] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1303),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_DASH] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1303),
    [anon_sym_PLUS_PLUS] = ACTIONS(1303),
    [anon_sym_sizeof] = ACTIONS(1305),
    [sym_number_literal] = ACTIONS(1303),
    [sym_char_literal] = ACTIONS(1303),
    [sym_string_literal] = ACTIONS(1303),
    [sym_true] = ACTIONS(1305),
    [sym_false] = ACTIONS(1305),
    [sym_null] = ACTIONS(1305),
    [sym_identifier] = ACTIONS(1305),
    [sym_comment] = ACTIONS(42),
  },
  [1333] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3546),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3546),
    [anon_sym_LPAREN] = ACTIONS(3548),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3546),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3546),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3546),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3546),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3546),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3546),
    [sym_preproc_directive] = ACTIONS(3546),
    [anon_sym_SEMI] = ACTIONS(3548),
    [anon_sym_typedef] = ACTIONS(3546),
    [anon_sym_extern] = ACTIONS(3546),
    [anon_sym_LBRACE] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3548),
    [anon_sym_static] = ACTIONS(3546),
    [anon_sym_auto] = ACTIONS(3546),
    [anon_sym_register] = ACTIONS(3546),
    [anon_sym_inline] = ACTIONS(3546),
    [anon_sym_const] = ACTIONS(3546),
    [anon_sym_restrict] = ACTIONS(3546),
    [anon_sym_volatile] = ACTIONS(3546),
    [anon_sym__Atomic] = ACTIONS(3546),
    [anon_sym_unsigned] = ACTIONS(3546),
    [anon_sym_long] = ACTIONS(3546),
    [anon_sym_short] = ACTIONS(3546),
    [sym_primitive_type] = ACTIONS(3546),
    [anon_sym_enum] = ACTIONS(3546),
    [anon_sym_struct] = ACTIONS(3546),
    [anon_sym_union] = ACTIONS(3546),
    [anon_sym_if] = ACTIONS(3546),
    [anon_sym_switch] = ACTIONS(3546),
    [anon_sym_case] = ACTIONS(3546),
    [anon_sym_default] = ACTIONS(3546),
    [anon_sym_while] = ACTIONS(3546),
    [anon_sym_do] = ACTIONS(3546),
    [anon_sym_for] = ACTIONS(3546),
    [anon_sym_return] = ACTIONS(3546),
    [anon_sym_break] = ACTIONS(3546),
    [anon_sym_continue] = ACTIONS(3546),
    [anon_sym_goto] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_BANG] = ACTIONS(3548),
    [anon_sym_TILDE] = ACTIONS(3548),
    [anon_sym_PLUS] = ACTIONS(3546),
    [anon_sym_DASH] = ACTIONS(3546),
    [anon_sym_DASH_DASH] = ACTIONS(3548),
    [anon_sym_PLUS_PLUS] = ACTIONS(3548),
    [anon_sym_sizeof] = ACTIONS(3546),
    [sym_number_literal] = ACTIONS(3548),
    [sym_char_literal] = ACTIONS(3548),
    [sym_string_literal] = ACTIONS(3548),
    [sym_true] = ACTIONS(3546),
    [sym_false] = ACTIONS(3546),
    [sym_null] = ACTIONS(3546),
    [sym_identifier] = ACTIONS(3546),
    [sym_comment] = ACTIONS(42),
  },
  [1334] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3550),
    [anon_sym_LPAREN] = ACTIONS(3552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3550),
    [sym_preproc_directive] = ACTIONS(3550),
    [anon_sym_SEMI] = ACTIONS(3552),
    [anon_sym_typedef] = ACTIONS(3550),
    [anon_sym_extern] = ACTIONS(3550),
    [anon_sym_LBRACE] = ACTIONS(3552),
    [anon_sym_STAR] = ACTIONS(3552),
    [anon_sym_static] = ACTIONS(3550),
    [anon_sym_auto] = ACTIONS(3550),
    [anon_sym_register] = ACTIONS(3550),
    [anon_sym_inline] = ACTIONS(3550),
    [anon_sym_const] = ACTIONS(3550),
    [anon_sym_restrict] = ACTIONS(3550),
    [anon_sym_volatile] = ACTIONS(3550),
    [anon_sym__Atomic] = ACTIONS(3550),
    [anon_sym_unsigned] = ACTIONS(3550),
    [anon_sym_long] = ACTIONS(3550),
    [anon_sym_short] = ACTIONS(3550),
    [sym_primitive_type] = ACTIONS(3550),
    [anon_sym_enum] = ACTIONS(3550),
    [anon_sym_struct] = ACTIONS(3550),
    [anon_sym_union] = ACTIONS(3550),
    [anon_sym_if] = ACTIONS(3550),
    [anon_sym_switch] = ACTIONS(3550),
    [anon_sym_case] = ACTIONS(3550),
    [anon_sym_default] = ACTIONS(3550),
    [anon_sym_while] = ACTIONS(3550),
    [anon_sym_do] = ACTIONS(3550),
    [anon_sym_for] = ACTIONS(3550),
    [anon_sym_return] = ACTIONS(3550),
    [anon_sym_break] = ACTIONS(3550),
    [anon_sym_continue] = ACTIONS(3550),
    [anon_sym_goto] = ACTIONS(3550),
    [anon_sym_AMP] = ACTIONS(3552),
    [anon_sym_BANG] = ACTIONS(3552),
    [anon_sym_TILDE] = ACTIONS(3552),
    [anon_sym_PLUS] = ACTIONS(3550),
    [anon_sym_DASH] = ACTIONS(3550),
    [anon_sym_DASH_DASH] = ACTIONS(3552),
    [anon_sym_PLUS_PLUS] = ACTIONS(3552),
    [anon_sym_sizeof] = ACTIONS(3550),
    [sym_number_literal] = ACTIONS(3552),
    [sym_char_literal] = ACTIONS(3552),
    [sym_string_literal] = ACTIONS(3552),
    [sym_true] = ACTIONS(3550),
    [sym_false] = ACTIONS(3550),
    [sym_null] = ACTIONS(3550),
    [sym_identifier] = ACTIONS(3550),
    [sym_comment] = ACTIONS(42),
  },
  [1335] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3554),
    [anon_sym_LPAREN] = ACTIONS(3556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3554),
    [sym_preproc_directive] = ACTIONS(3554),
    [anon_sym_SEMI] = ACTIONS(3556),
    [anon_sym_typedef] = ACTIONS(3554),
    [anon_sym_extern] = ACTIONS(3554),
    [anon_sym_LBRACE] = ACTIONS(3556),
    [anon_sym_STAR] = ACTIONS(3556),
    [anon_sym_static] = ACTIONS(3554),
    [anon_sym_auto] = ACTIONS(3554),
    [anon_sym_register] = ACTIONS(3554),
    [anon_sym_inline] = ACTIONS(3554),
    [anon_sym_const] = ACTIONS(3554),
    [anon_sym_restrict] = ACTIONS(3554),
    [anon_sym_volatile] = ACTIONS(3554),
    [anon_sym__Atomic] = ACTIONS(3554),
    [anon_sym_unsigned] = ACTIONS(3554),
    [anon_sym_long] = ACTIONS(3554),
    [anon_sym_short] = ACTIONS(3554),
    [sym_primitive_type] = ACTIONS(3554),
    [anon_sym_enum] = ACTIONS(3554),
    [anon_sym_struct] = ACTIONS(3554),
    [anon_sym_union] = ACTIONS(3554),
    [anon_sym_if] = ACTIONS(3554),
    [anon_sym_switch] = ACTIONS(3554),
    [anon_sym_case] = ACTIONS(3554),
    [anon_sym_default] = ACTIONS(3554),
    [anon_sym_while] = ACTIONS(3554),
    [anon_sym_do] = ACTIONS(3554),
    [anon_sym_for] = ACTIONS(3554),
    [anon_sym_return] = ACTIONS(3554),
    [anon_sym_break] = ACTIONS(3554),
    [anon_sym_continue] = ACTIONS(3554),
    [anon_sym_goto] = ACTIONS(3554),
    [anon_sym_AMP] = ACTIONS(3556),
    [anon_sym_BANG] = ACTIONS(3556),
    [anon_sym_TILDE] = ACTIONS(3556),
    [anon_sym_PLUS] = ACTIONS(3554),
    [anon_sym_DASH] = ACTIONS(3554),
    [anon_sym_DASH_DASH] = ACTIONS(3556),
    [anon_sym_PLUS_PLUS] = ACTIONS(3556),
    [anon_sym_sizeof] = ACTIONS(3554),
    [sym_number_literal] = ACTIONS(3556),
    [sym_char_literal] = ACTIONS(3556),
    [sym_string_literal] = ACTIONS(3556),
    [sym_true] = ACTIONS(3554),
    [sym_false] = ACTIONS(3554),
    [sym_null] = ACTIONS(3554),
    [sym_identifier] = ACTIONS(3554),
    [sym_comment] = ACTIONS(42),
  },
  [1336] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3558),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3558),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3558),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3558),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3558),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3558),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3558),
    [sym_preproc_directive] = ACTIONS(3558),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym_typedef] = ACTIONS(3558),
    [anon_sym_extern] = ACTIONS(3558),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_static] = ACTIONS(3558),
    [anon_sym_auto] = ACTIONS(3558),
    [anon_sym_register] = ACTIONS(3558),
    [anon_sym_inline] = ACTIONS(3558),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_restrict] = ACTIONS(3558),
    [anon_sym_volatile] = ACTIONS(3558),
    [anon_sym__Atomic] = ACTIONS(3558),
    [anon_sym_unsigned] = ACTIONS(3558),
    [anon_sym_long] = ACTIONS(3558),
    [anon_sym_short] = ACTIONS(3558),
    [sym_primitive_type] = ACTIONS(3558),
    [anon_sym_enum] = ACTIONS(3558),
    [anon_sym_struct] = ACTIONS(3558),
    [anon_sym_union] = ACTIONS(3558),
    [anon_sym_if] = ACTIONS(3558),
    [anon_sym_switch] = ACTIONS(3558),
    [anon_sym_case] = ACTIONS(3558),
    [anon_sym_default] = ACTIONS(3558),
    [anon_sym_while] = ACTIONS(3558),
    [anon_sym_do] = ACTIONS(3558),
    [anon_sym_for] = ACTIONS(3558),
    [anon_sym_return] = ACTIONS(3558),
    [anon_sym_break] = ACTIONS(3558),
    [anon_sym_continue] = ACTIONS(3558),
    [anon_sym_goto] = ACTIONS(3558),
    [anon_sym_AMP] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_PLUS] = ACTIONS(3558),
    [anon_sym_DASH] = ACTIONS(3558),
    [anon_sym_DASH_DASH] = ACTIONS(3560),
    [anon_sym_PLUS_PLUS] = ACTIONS(3560),
    [anon_sym_sizeof] = ACTIONS(3558),
    [sym_number_literal] = ACTIONS(3560),
    [sym_char_literal] = ACTIONS(3560),
    [sym_string_literal] = ACTIONS(3560),
    [sym_true] = ACTIONS(3558),
    [sym_false] = ACTIONS(3558),
    [sym_null] = ACTIONS(3558),
    [sym_identifier] = ACTIONS(3558),
    [sym_comment] = ACTIONS(42),
  },
  [1337] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3562),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(3564),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3562),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3562),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3562),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3562),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3562),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3564),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym_LBRACE] = ACTIONS(3564),
    [anon_sym_STAR] = ACTIONS(3564),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_auto] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_switch] = ACTIONS(3562),
    [anon_sym_case] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_goto] = ACTIONS(3562),
    [anon_sym_AMP] = ACTIONS(3564),
    [anon_sym_BANG] = ACTIONS(3564),
    [anon_sym_TILDE] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_DASH_DASH] = ACTIONS(3564),
    [anon_sym_PLUS_PLUS] = ACTIONS(3564),
    [anon_sym_sizeof] = ACTIONS(3562),
    [sym_number_literal] = ACTIONS(3564),
    [sym_char_literal] = ACTIONS(3564),
    [sym_string_literal] = ACTIONS(3564),
    [sym_true] = ACTIONS(3562),
    [sym_false] = ACTIONS(3562),
    [sym_null] = ACTIONS(3562),
    [sym_identifier] = ACTIONS(3562),
    [sym_comment] = ACTIONS(42),
  },
  [1338] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3566),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3566),
    [anon_sym_LPAREN] = ACTIONS(3568),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3566),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3566),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3566),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3566),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3566),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3566),
    [sym_preproc_directive] = ACTIONS(3566),
    [anon_sym_SEMI] = ACTIONS(3568),
    [anon_sym_typedef] = ACTIONS(3566),
    [anon_sym_extern] = ACTIONS(3566),
    [anon_sym_LBRACE] = ACTIONS(3568),
    [anon_sym_STAR] = ACTIONS(3568),
    [anon_sym_static] = ACTIONS(3566),
    [anon_sym_auto] = ACTIONS(3566),
    [anon_sym_register] = ACTIONS(3566),
    [anon_sym_inline] = ACTIONS(3566),
    [anon_sym_const] = ACTIONS(3566),
    [anon_sym_restrict] = ACTIONS(3566),
    [anon_sym_volatile] = ACTIONS(3566),
    [anon_sym__Atomic] = ACTIONS(3566),
    [anon_sym_unsigned] = ACTIONS(3566),
    [anon_sym_long] = ACTIONS(3566),
    [anon_sym_short] = ACTIONS(3566),
    [sym_primitive_type] = ACTIONS(3566),
    [anon_sym_enum] = ACTIONS(3566),
    [anon_sym_struct] = ACTIONS(3566),
    [anon_sym_union] = ACTIONS(3566),
    [anon_sym_if] = ACTIONS(3566),
    [anon_sym_switch] = ACTIONS(3566),
    [anon_sym_case] = ACTIONS(3566),
    [anon_sym_default] = ACTIONS(3566),
    [anon_sym_while] = ACTIONS(3566),
    [anon_sym_do] = ACTIONS(3566),
    [anon_sym_for] = ACTIONS(3566),
    [anon_sym_return] = ACTIONS(3566),
    [anon_sym_break] = ACTIONS(3566),
    [anon_sym_continue] = ACTIONS(3566),
    [anon_sym_goto] = ACTIONS(3566),
    [anon_sym_AMP] = ACTIONS(3568),
    [anon_sym_BANG] = ACTIONS(3568),
    [anon_sym_TILDE] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3566),
    [anon_sym_DASH] = ACTIONS(3566),
    [anon_sym_DASH_DASH] = ACTIONS(3568),
    [anon_sym_PLUS_PLUS] = ACTIONS(3568),
    [anon_sym_sizeof] = ACTIONS(3566),
    [sym_number_literal] = ACTIONS(3568),
    [sym_char_literal] = ACTIONS(3568),
    [sym_string_literal] = ACTIONS(3568),
    [sym_true] = ACTIONS(3566),
    [sym_false] = ACTIONS(3566),
    [sym_null] = ACTIONS(3566),
    [sym_identifier] = ACTIONS(3566),
    [sym_comment] = ACTIONS(42),
  },
  [1339] = {
    [anon_sym_LF] = ACTIONS(3882),
    [sym_comment] = ACTIONS(50),
  },
  [1340] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(703),
    [anon_sym_LPAREN] = ACTIONS(701),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(703),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(703),
    [sym_preproc_directive] = ACTIONS(703),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_typedef] = ACTIONS(703),
    [anon_sym_extern] = ACTIONS(703),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(701),
    [anon_sym_static] = ACTIONS(703),
    [anon_sym_auto] = ACTIONS(703),
    [anon_sym_register] = ACTIONS(703),
    [anon_sym_inline] = ACTIONS(703),
    [anon_sym_const] = ACTIONS(703),
    [anon_sym_restrict] = ACTIONS(703),
    [anon_sym_volatile] = ACTIONS(703),
    [anon_sym__Atomic] = ACTIONS(703),
    [anon_sym_unsigned] = ACTIONS(703),
    [anon_sym_long] = ACTIONS(703),
    [anon_sym_short] = ACTIONS(703),
    [sym_primitive_type] = ACTIONS(703),
    [anon_sym_enum] = ACTIONS(703),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_union] = ACTIONS(703),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_switch] = ACTIONS(703),
    [anon_sym_case] = ACTIONS(703),
    [anon_sym_default] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_for] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(703),
    [anon_sym_break] = ACTIONS(703),
    [anon_sym_continue] = ACTIONS(703),
    [anon_sym_goto] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_BANG] = ACTIONS(701),
    [anon_sym_TILDE] = ACTIONS(701),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_DASH_DASH] = ACTIONS(701),
    [anon_sym_PLUS_PLUS] = ACTIONS(701),
    [anon_sym_sizeof] = ACTIONS(703),
    [sym_number_literal] = ACTIONS(701),
    [sym_char_literal] = ACTIONS(701),
    [sym_string_literal] = ACTIONS(701),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_identifier] = ACTIONS(703),
    [sym_comment] = ACTIONS(42),
  },
  [1341] = {
    [anon_sym_LF] = ACTIONS(3884),
    [sym_comment] = ACTIONS(50),
  },
  [1342] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3042),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3042),
    [anon_sym_LPAREN] = ACTIONS(3044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3042),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3042),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3042),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3042),
    [sym_preproc_directive] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym_typedef] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_auto] = ACTIONS(3042),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_struct] = ACTIONS(3042),
    [anon_sym_union] = ACTIONS(3042),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_switch] = ACTIONS(3042),
    [anon_sym_case] = ACTIONS(3042),
    [anon_sym_default] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_for] = ACTIONS(3042),
    [anon_sym_return] = ACTIONS(3042),
    [anon_sym_break] = ACTIONS(3042),
    [anon_sym_continue] = ACTIONS(3042),
    [anon_sym_goto] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3044),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3044),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3044),
    [anon_sym_PLUS_PLUS] = ACTIONS(3044),
    [anon_sym_sizeof] = ACTIONS(3042),
    [sym_number_literal] = ACTIONS(3044),
    [sym_char_literal] = ACTIONS(3044),
    [sym_string_literal] = ACTIONS(3044),
    [sym_true] = ACTIONS(3042),
    [sym_false] = ACTIONS(3042),
    [sym_null] = ACTIONS(3042),
    [sym_identifier] = ACTIONS(3042),
    [sym_comment] = ACTIONS(42),
  },
  [1343] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3046),
    [anon_sym_LPAREN] = ACTIONS(3048),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3046),
    [sym_preproc_directive] = ACTIONS(3046),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym_typedef] = ACTIONS(3046),
    [anon_sym_extern] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3048),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_static] = ACTIONS(3046),
    [anon_sym_auto] = ACTIONS(3046),
    [anon_sym_register] = ACTIONS(3046),
    [anon_sym_inline] = ACTIONS(3046),
    [anon_sym_const] = ACTIONS(3046),
    [anon_sym_restrict] = ACTIONS(3046),
    [anon_sym_volatile] = ACTIONS(3046),
    [anon_sym__Atomic] = ACTIONS(3046),
    [anon_sym_unsigned] = ACTIONS(3046),
    [anon_sym_long] = ACTIONS(3046),
    [anon_sym_short] = ACTIONS(3046),
    [sym_primitive_type] = ACTIONS(3046),
    [anon_sym_enum] = ACTIONS(3046),
    [anon_sym_struct] = ACTIONS(3046),
    [anon_sym_union] = ACTIONS(3046),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_switch] = ACTIONS(3046),
    [anon_sym_case] = ACTIONS(3046),
    [anon_sym_default] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_for] = ACTIONS(3046),
    [anon_sym_return] = ACTIONS(3046),
    [anon_sym_break] = ACTIONS(3046),
    [anon_sym_continue] = ACTIONS(3046),
    [anon_sym_goto] = ACTIONS(3046),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym_BANG] = ACTIONS(3048),
    [anon_sym_TILDE] = ACTIONS(3048),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_DASH] = ACTIONS(3046),
    [anon_sym_DASH_DASH] = ACTIONS(3048),
    [anon_sym_PLUS_PLUS] = ACTIONS(3048),
    [anon_sym_sizeof] = ACTIONS(3046),
    [sym_number_literal] = ACTIONS(3048),
    [sym_char_literal] = ACTIONS(3048),
    [sym_string_literal] = ACTIONS(3048),
    [sym_true] = ACTIONS(3046),
    [sym_false] = ACTIONS(3046),
    [sym_null] = ACTIONS(3046),
    [sym_identifier] = ACTIONS(3046),
    [sym_comment] = ACTIONS(42),
  },
  [1344] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3052),
    [anon_sym_LPAREN] = ACTIONS(3054),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3052),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3052),
    [sym_preproc_directive] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3054),
    [anon_sym_typedef] = ACTIONS(3052),
    [anon_sym_extern] = ACTIONS(3052),
    [anon_sym_LBRACE] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3054),
    [anon_sym_static] = ACTIONS(3052),
    [anon_sym_auto] = ACTIONS(3052),
    [anon_sym_register] = ACTIONS(3052),
    [anon_sym_inline] = ACTIONS(3052),
    [anon_sym_const] = ACTIONS(3052),
    [anon_sym_restrict] = ACTIONS(3052),
    [anon_sym_volatile] = ACTIONS(3052),
    [anon_sym__Atomic] = ACTIONS(3052),
    [anon_sym_unsigned] = ACTIONS(3052),
    [anon_sym_long] = ACTIONS(3052),
    [anon_sym_short] = ACTIONS(3052),
    [sym_primitive_type] = ACTIONS(3052),
    [anon_sym_enum] = ACTIONS(3052),
    [anon_sym_struct] = ACTIONS(3052),
    [anon_sym_union] = ACTIONS(3052),
    [anon_sym_if] = ACTIONS(3052),
    [anon_sym_switch] = ACTIONS(3052),
    [anon_sym_case] = ACTIONS(3052),
    [anon_sym_default] = ACTIONS(3052),
    [anon_sym_while] = ACTIONS(3052),
    [anon_sym_do] = ACTIONS(3052),
    [anon_sym_for] = ACTIONS(3052),
    [anon_sym_return] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3052),
    [anon_sym_continue] = ACTIONS(3052),
    [anon_sym_goto] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_TILDE] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3052),
    [anon_sym_DASH_DASH] = ACTIONS(3054),
    [anon_sym_PLUS_PLUS] = ACTIONS(3054),
    [anon_sym_sizeof] = ACTIONS(3052),
    [sym_number_literal] = ACTIONS(3054),
    [sym_char_literal] = ACTIONS(3054),
    [sym_string_literal] = ACTIONS(3054),
    [sym_true] = ACTIONS(3052),
    [sym_false] = ACTIONS(3052),
    [sym_null] = ACTIONS(3052),
    [sym_identifier] = ACTIONS(3052),
    [sym_comment] = ACTIONS(42),
  },
  [1345] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3886),
    [sym_comment] = ACTIONS(42),
  },
  [1346] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3888),
    [sym_comment] = ACTIONS(42),
  },
  [1347] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3131),
    [anon_sym_LPAREN] = ACTIONS(3133),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3131),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3131),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym_typedef] = ACTIONS(3131),
    [anon_sym_extern] = ACTIONS(3131),
    [anon_sym_LBRACE] = ACTIONS(3133),
    [anon_sym_STAR] = ACTIONS(3133),
    [anon_sym_static] = ACTIONS(3131),
    [anon_sym_auto] = ACTIONS(3131),
    [anon_sym_register] = ACTIONS(3131),
    [anon_sym_inline] = ACTIONS(3131),
    [anon_sym_const] = ACTIONS(3131),
    [anon_sym_restrict] = ACTIONS(3131),
    [anon_sym_volatile] = ACTIONS(3131),
    [anon_sym__Atomic] = ACTIONS(3131),
    [anon_sym_unsigned] = ACTIONS(3131),
    [anon_sym_long] = ACTIONS(3131),
    [anon_sym_short] = ACTIONS(3131),
    [sym_primitive_type] = ACTIONS(3131),
    [anon_sym_enum] = ACTIONS(3131),
    [anon_sym_struct] = ACTIONS(3131),
    [anon_sym_union] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(3131),
    [anon_sym_switch] = ACTIONS(3131),
    [anon_sym_case] = ACTIONS(3131),
    [anon_sym_default] = ACTIONS(3131),
    [anon_sym_while] = ACTIONS(3131),
    [anon_sym_do] = ACTIONS(3131),
    [anon_sym_for] = ACTIONS(3131),
    [anon_sym_return] = ACTIONS(3131),
    [anon_sym_break] = ACTIONS(3131),
    [anon_sym_continue] = ACTIONS(3131),
    [anon_sym_goto] = ACTIONS(3131),
    [anon_sym_AMP] = ACTIONS(3133),
    [anon_sym_BANG] = ACTIONS(3133),
    [anon_sym_TILDE] = ACTIONS(3133),
    [anon_sym_PLUS] = ACTIONS(3131),
    [anon_sym_DASH] = ACTIONS(3131),
    [anon_sym_DASH_DASH] = ACTIONS(3133),
    [anon_sym_PLUS_PLUS] = ACTIONS(3133),
    [anon_sym_sizeof] = ACTIONS(3131),
    [sym_number_literal] = ACTIONS(3133),
    [sym_char_literal] = ACTIONS(3133),
    [sym_string_literal] = ACTIONS(3133),
    [sym_true] = ACTIONS(3131),
    [sym_false] = ACTIONS(3131),
    [sym_null] = ACTIONS(3131),
    [sym_identifier] = ACTIONS(3131),
    [sym_comment] = ACTIONS(42),
  },
  [1348] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3135),
    [anon_sym_LPAREN] = ACTIONS(3137),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3135),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3135),
    [sym_preproc_directive] = ACTIONS(3135),
    [anon_sym_SEMI] = ACTIONS(3137),
    [anon_sym_typedef] = ACTIONS(3135),
    [anon_sym_extern] = ACTIONS(3135),
    [anon_sym_LBRACE] = ACTIONS(3137),
    [anon_sym_STAR] = ACTIONS(3137),
    [anon_sym_static] = ACTIONS(3135),
    [anon_sym_auto] = ACTIONS(3135),
    [anon_sym_register] = ACTIONS(3135),
    [anon_sym_inline] = ACTIONS(3135),
    [anon_sym_const] = ACTIONS(3135),
    [anon_sym_restrict] = ACTIONS(3135),
    [anon_sym_volatile] = ACTIONS(3135),
    [anon_sym__Atomic] = ACTIONS(3135),
    [anon_sym_unsigned] = ACTIONS(3135),
    [anon_sym_long] = ACTIONS(3135),
    [anon_sym_short] = ACTIONS(3135),
    [sym_primitive_type] = ACTIONS(3135),
    [anon_sym_enum] = ACTIONS(3135),
    [anon_sym_struct] = ACTIONS(3135),
    [anon_sym_union] = ACTIONS(3135),
    [anon_sym_if] = ACTIONS(3135),
    [anon_sym_switch] = ACTIONS(3135),
    [anon_sym_case] = ACTIONS(3135),
    [anon_sym_default] = ACTIONS(3135),
    [anon_sym_while] = ACTIONS(3135),
    [anon_sym_do] = ACTIONS(3135),
    [anon_sym_for] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3135),
    [anon_sym_break] = ACTIONS(3135),
    [anon_sym_continue] = ACTIONS(3135),
    [anon_sym_goto] = ACTIONS(3135),
    [anon_sym_AMP] = ACTIONS(3137),
    [anon_sym_BANG] = ACTIONS(3137),
    [anon_sym_TILDE] = ACTIONS(3137),
    [anon_sym_PLUS] = ACTIONS(3135),
    [anon_sym_DASH] = ACTIONS(3135),
    [anon_sym_DASH_DASH] = ACTIONS(3137),
    [anon_sym_PLUS_PLUS] = ACTIONS(3137),
    [anon_sym_sizeof] = ACTIONS(3135),
    [sym_number_literal] = ACTIONS(3137),
    [sym_char_literal] = ACTIONS(3137),
    [sym_string_literal] = ACTIONS(3137),
    [sym_true] = ACTIONS(3135),
    [sym_false] = ACTIONS(3135),
    [sym_null] = ACTIONS(3135),
    [sym_identifier] = ACTIONS(3135),
    [sym_comment] = ACTIONS(42),
  },
  [1349] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3139),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3139),
    [anon_sym_LPAREN] = ACTIONS(3141),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3139),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3139),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3139),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3139),
    [sym_preproc_directive] = ACTIONS(3139),
    [anon_sym_SEMI] = ACTIONS(3141),
    [anon_sym_typedef] = ACTIONS(3139),
    [anon_sym_extern] = ACTIONS(3139),
    [anon_sym_LBRACE] = ACTIONS(3141),
    [anon_sym_STAR] = ACTIONS(3141),
    [anon_sym_static] = ACTIONS(3139),
    [anon_sym_auto] = ACTIONS(3139),
    [anon_sym_register] = ACTIONS(3139),
    [anon_sym_inline] = ACTIONS(3139),
    [anon_sym_const] = ACTIONS(3139),
    [anon_sym_restrict] = ACTIONS(3139),
    [anon_sym_volatile] = ACTIONS(3139),
    [anon_sym__Atomic] = ACTIONS(3139),
    [anon_sym_unsigned] = ACTIONS(3139),
    [anon_sym_long] = ACTIONS(3139),
    [anon_sym_short] = ACTIONS(3139),
    [sym_primitive_type] = ACTIONS(3139),
    [anon_sym_enum] = ACTIONS(3139),
    [anon_sym_struct] = ACTIONS(3139),
    [anon_sym_union] = ACTIONS(3139),
    [anon_sym_if] = ACTIONS(3139),
    [anon_sym_switch] = ACTIONS(3139),
    [anon_sym_case] = ACTIONS(3139),
    [anon_sym_default] = ACTIONS(3139),
    [anon_sym_while] = ACTIONS(3139),
    [anon_sym_do] = ACTIONS(3139),
    [anon_sym_for] = ACTIONS(3139),
    [anon_sym_return] = ACTIONS(3139),
    [anon_sym_break] = ACTIONS(3139),
    [anon_sym_continue] = ACTIONS(3139),
    [anon_sym_goto] = ACTIONS(3139),
    [anon_sym_AMP] = ACTIONS(3141),
    [anon_sym_BANG] = ACTIONS(3141),
    [anon_sym_TILDE] = ACTIONS(3141),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_DASH_DASH] = ACTIONS(3141),
    [anon_sym_PLUS_PLUS] = ACTIONS(3141),
    [anon_sym_sizeof] = ACTIONS(3139),
    [sym_number_literal] = ACTIONS(3141),
    [sym_char_literal] = ACTIONS(3141),
    [sym_string_literal] = ACTIONS(3141),
    [sym_true] = ACTIONS(3139),
    [sym_false] = ACTIONS(3139),
    [sym_null] = ACTIONS(3139),
    [sym_identifier] = ACTIONS(3139),
    [sym_comment] = ACTIONS(42),
  },
  [1350] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3890),
    [sym_comment] = ACTIONS(42),
  },
  [1351] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3892),
    [sym_comment] = ACTIONS(42),
  },
  [1352] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3147),
    [anon_sym_LPAREN] = ACTIONS(3149),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3147),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3147),
    [sym_preproc_directive] = ACTIONS(3147),
    [anon_sym_SEMI] = ACTIONS(3149),
    [anon_sym_typedef] = ACTIONS(3147),
    [anon_sym_extern] = ACTIONS(3147),
    [anon_sym_LBRACE] = ACTIONS(3149),
    [anon_sym_STAR] = ACTIONS(3149),
    [anon_sym_static] = ACTIONS(3147),
    [anon_sym_auto] = ACTIONS(3147),
    [anon_sym_register] = ACTIONS(3147),
    [anon_sym_inline] = ACTIONS(3147),
    [anon_sym_const] = ACTIONS(3147),
    [anon_sym_restrict] = ACTIONS(3147),
    [anon_sym_volatile] = ACTIONS(3147),
    [anon_sym__Atomic] = ACTIONS(3147),
    [anon_sym_unsigned] = ACTIONS(3147),
    [anon_sym_long] = ACTIONS(3147),
    [anon_sym_short] = ACTIONS(3147),
    [sym_primitive_type] = ACTIONS(3147),
    [anon_sym_enum] = ACTIONS(3147),
    [anon_sym_struct] = ACTIONS(3147),
    [anon_sym_union] = ACTIONS(3147),
    [anon_sym_if] = ACTIONS(3147),
    [anon_sym_switch] = ACTIONS(3147),
    [anon_sym_case] = ACTIONS(3147),
    [anon_sym_default] = ACTIONS(3147),
    [anon_sym_while] = ACTIONS(3147),
    [anon_sym_do] = ACTIONS(3147),
    [anon_sym_for] = ACTIONS(3147),
    [anon_sym_return] = ACTIONS(3147),
    [anon_sym_break] = ACTIONS(3147),
    [anon_sym_continue] = ACTIONS(3147),
    [anon_sym_goto] = ACTIONS(3147),
    [anon_sym_AMP] = ACTIONS(3149),
    [anon_sym_BANG] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3149),
    [anon_sym_PLUS] = ACTIONS(3147),
    [anon_sym_DASH] = ACTIONS(3147),
    [anon_sym_DASH_DASH] = ACTIONS(3149),
    [anon_sym_PLUS_PLUS] = ACTIONS(3149),
    [anon_sym_sizeof] = ACTIONS(3147),
    [sym_number_literal] = ACTIONS(3149),
    [sym_char_literal] = ACTIONS(3149),
    [sym_string_literal] = ACTIONS(3149),
    [sym_true] = ACTIONS(3147),
    [sym_false] = ACTIONS(3147),
    [sym_null] = ACTIONS(3147),
    [sym_identifier] = ACTIONS(3147),
    [sym_comment] = ACTIONS(42),
  },
  [1353] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3151),
    [anon_sym_LPAREN] = ACTIONS(3153),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3151),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3151),
    [sym_preproc_directive] = ACTIONS(3151),
    [anon_sym_SEMI] = ACTIONS(3153),
    [anon_sym_typedef] = ACTIONS(3151),
    [anon_sym_extern] = ACTIONS(3151),
    [anon_sym_LBRACE] = ACTIONS(3153),
    [anon_sym_STAR] = ACTIONS(3153),
    [anon_sym_static] = ACTIONS(3151),
    [anon_sym_auto] = ACTIONS(3151),
    [anon_sym_register] = ACTIONS(3151),
    [anon_sym_inline] = ACTIONS(3151),
    [anon_sym_const] = ACTIONS(3151),
    [anon_sym_restrict] = ACTIONS(3151),
    [anon_sym_volatile] = ACTIONS(3151),
    [anon_sym__Atomic] = ACTIONS(3151),
    [anon_sym_unsigned] = ACTIONS(3151),
    [anon_sym_long] = ACTIONS(3151),
    [anon_sym_short] = ACTIONS(3151),
    [sym_primitive_type] = ACTIONS(3151),
    [anon_sym_enum] = ACTIONS(3151),
    [anon_sym_struct] = ACTIONS(3151),
    [anon_sym_union] = ACTIONS(3151),
    [anon_sym_if] = ACTIONS(3151),
    [anon_sym_switch] = ACTIONS(3151),
    [anon_sym_case] = ACTIONS(3151),
    [anon_sym_default] = ACTIONS(3151),
    [anon_sym_while] = ACTIONS(3151),
    [anon_sym_do] = ACTIONS(3151),
    [anon_sym_for] = ACTIONS(3151),
    [anon_sym_return] = ACTIONS(3151),
    [anon_sym_break] = ACTIONS(3151),
    [anon_sym_continue] = ACTIONS(3151),
    [anon_sym_goto] = ACTIONS(3151),
    [anon_sym_AMP] = ACTIONS(3153),
    [anon_sym_BANG] = ACTIONS(3153),
    [anon_sym_TILDE] = ACTIONS(3153),
    [anon_sym_PLUS] = ACTIONS(3151),
    [anon_sym_DASH] = ACTIONS(3151),
    [anon_sym_DASH_DASH] = ACTIONS(3153),
    [anon_sym_PLUS_PLUS] = ACTIONS(3153),
    [anon_sym_sizeof] = ACTIONS(3151),
    [sym_number_literal] = ACTIONS(3153),
    [sym_char_literal] = ACTIONS(3153),
    [sym_string_literal] = ACTIONS(3153),
    [sym_true] = ACTIONS(3151),
    [sym_false] = ACTIONS(3151),
    [sym_null] = ACTIONS(3151),
    [sym_identifier] = ACTIONS(3151),
    [sym_comment] = ACTIONS(42),
  },
  [1354] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3155),
    [anon_sym_LPAREN] = ACTIONS(3157),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3155),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3155),
    [sym_preproc_directive] = ACTIONS(3155),
    [anon_sym_SEMI] = ACTIONS(3157),
    [anon_sym_typedef] = ACTIONS(3155),
    [anon_sym_extern] = ACTIONS(3155),
    [anon_sym_LBRACE] = ACTIONS(3157),
    [anon_sym_STAR] = ACTIONS(3157),
    [anon_sym_static] = ACTIONS(3155),
    [anon_sym_auto] = ACTIONS(3155),
    [anon_sym_register] = ACTIONS(3155),
    [anon_sym_inline] = ACTIONS(3155),
    [anon_sym_const] = ACTIONS(3155),
    [anon_sym_restrict] = ACTIONS(3155),
    [anon_sym_volatile] = ACTIONS(3155),
    [anon_sym__Atomic] = ACTIONS(3155),
    [anon_sym_unsigned] = ACTIONS(3155),
    [anon_sym_long] = ACTIONS(3155),
    [anon_sym_short] = ACTIONS(3155),
    [sym_primitive_type] = ACTIONS(3155),
    [anon_sym_enum] = ACTIONS(3155),
    [anon_sym_struct] = ACTIONS(3155),
    [anon_sym_union] = ACTIONS(3155),
    [anon_sym_if] = ACTIONS(3155),
    [anon_sym_switch] = ACTIONS(3155),
    [anon_sym_case] = ACTIONS(3155),
    [anon_sym_default] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(3155),
    [anon_sym_do] = ACTIONS(3155),
    [anon_sym_for] = ACTIONS(3155),
    [anon_sym_return] = ACTIONS(3155),
    [anon_sym_break] = ACTIONS(3155),
    [anon_sym_continue] = ACTIONS(3155),
    [anon_sym_goto] = ACTIONS(3155),
    [anon_sym_AMP] = ACTIONS(3157),
    [anon_sym_BANG] = ACTIONS(3157),
    [anon_sym_TILDE] = ACTIONS(3157),
    [anon_sym_PLUS] = ACTIONS(3155),
    [anon_sym_DASH] = ACTIONS(3155),
    [anon_sym_DASH_DASH] = ACTIONS(3157),
    [anon_sym_PLUS_PLUS] = ACTIONS(3157),
    [anon_sym_sizeof] = ACTIONS(3155),
    [sym_number_literal] = ACTIONS(3157),
    [sym_char_literal] = ACTIONS(3157),
    [sym_string_literal] = ACTIONS(3157),
    [sym_true] = ACTIONS(3155),
    [sym_false] = ACTIONS(3155),
    [sym_null] = ACTIONS(3155),
    [sym_identifier] = ACTIONS(3155),
    [sym_comment] = ACTIONS(42),
  },
  [1355] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3894),
    [sym_comment] = ACTIONS(42),
  },
  [1356] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3896),
    [sym_comment] = ACTIONS(42),
  },
  [1357] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(799),
    [sym_preproc_directive] = ACTIONS(799),
    [anon_sym_SEMI] = ACTIONS(797),
    [anon_sym_typedef] = ACTIONS(799),
    [anon_sym_extern] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(797),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_static] = ACTIONS(799),
    [anon_sym_auto] = ACTIONS(799),
    [anon_sym_register] = ACTIONS(799),
    [anon_sym_inline] = ACTIONS(799),
    [anon_sym_const] = ACTIONS(799),
    [anon_sym_restrict] = ACTIONS(799),
    [anon_sym_volatile] = ACTIONS(799),
    [anon_sym__Atomic] = ACTIONS(799),
    [anon_sym_unsigned] = ACTIONS(799),
    [anon_sym_long] = ACTIONS(799),
    [anon_sym_short] = ACTIONS(799),
    [sym_primitive_type] = ACTIONS(799),
    [anon_sym_enum] = ACTIONS(799),
    [anon_sym_struct] = ACTIONS(799),
    [anon_sym_union] = ACTIONS(799),
    [anon_sym_if] = ACTIONS(799),
    [anon_sym_switch] = ACTIONS(799),
    [anon_sym_case] = ACTIONS(799),
    [anon_sym_default] = ACTIONS(799),
    [anon_sym_while] = ACTIONS(799),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(799),
    [anon_sym_break] = ACTIONS(799),
    [anon_sym_continue] = ACTIONS(799),
    [anon_sym_goto] = ACTIONS(799),
    [anon_sym_AMP] = ACTIONS(797),
    [anon_sym_BANG] = ACTIONS(797),
    [anon_sym_TILDE] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
    [anon_sym_sizeof] = ACTIONS(799),
    [sym_number_literal] = ACTIONS(797),
    [sym_char_literal] = ACTIONS(797),
    [sym_string_literal] = ACTIONS(797),
    [sym_true] = ACTIONS(799),
    [sym_false] = ACTIONS(799),
    [sym_null] = ACTIONS(799),
    [sym_identifier] = ACTIONS(799),
    [sym_comment] = ACTIONS(42),
  },
  [1358] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(813),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(815),
    [sym_preproc_directive] = ACTIONS(815),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_typedef] = ACTIONS(815),
    [anon_sym_extern] = ACTIONS(815),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_auto] = ACTIONS(815),
    [anon_sym_register] = ACTIONS(815),
    [anon_sym_inline] = ACTIONS(815),
    [anon_sym_const] = ACTIONS(815),
    [anon_sym_restrict] = ACTIONS(815),
    [anon_sym_volatile] = ACTIONS(815),
    [anon_sym__Atomic] = ACTIONS(815),
    [anon_sym_unsigned] = ACTIONS(815),
    [anon_sym_long] = ACTIONS(815),
    [anon_sym_short] = ACTIONS(815),
    [sym_primitive_type] = ACTIONS(815),
    [anon_sym_enum] = ACTIONS(815),
    [anon_sym_struct] = ACTIONS(815),
    [anon_sym_union] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(815),
    [anon_sym_switch] = ACTIONS(815),
    [anon_sym_case] = ACTIONS(815),
    [anon_sym_default] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(815),
    [anon_sym_do] = ACTIONS(815),
    [anon_sym_for] = ACTIONS(815),
    [anon_sym_return] = ACTIONS(815),
    [anon_sym_break] = ACTIONS(815),
    [anon_sym_continue] = ACTIONS(815),
    [anon_sym_goto] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_sizeof] = ACTIONS(815),
    [sym_number_literal] = ACTIONS(813),
    [sym_char_literal] = ACTIONS(813),
    [sym_string_literal] = ACTIONS(813),
    [sym_true] = ACTIONS(815),
    [sym_false] = ACTIONS(815),
    [sym_null] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_comment] = ACTIONS(42),
  },
  [1359] = {
    [sym_parameter_list] = STATE(200),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_SEMI] = ACTIONS(3898),
    [anon_sym_LBRACK] = ACTIONS(449),
    [sym_comment] = ACTIONS(42),
  },
  [1360] = {
    [sym_compound_statement] = STATE(1450),
    [sym_labeled_statement] = STATE(1450),
    [sym_expression_statement] = STATE(1450),
    [sym_if_statement] = STATE(1450),
    [sym_switch_statement] = STATE(1450),
    [sym_case_statement] = STATE(1450),
    [sym_while_statement] = STATE(1450),
    [sym_do_statement] = STATE(1450),
    [sym_for_statement] = STATE(1450),
    [sym_return_statement] = STATE(1450),
    [sym_break_statement] = STATE(1450),
    [sym_continue_statement] = STATE(1450),
    [sym_goto_statement] = STATE(1450),
    [sym__expression] = STATE(1451),
    [sym_comma_expression] = STATE(1452),
    [sym_conditional_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(1451),
    [sym_pointer_expression] = STATE(1451),
    [sym_logical_expression] = STATE(1451),
    [sym_bitwise_expression] = STATE(1451),
    [sym_equality_expression] = STATE(1451),
    [sym_relational_expression] = STATE(1451),
    [sym_shift_expression] = STATE(1451),
    [sym_math_expression] = STATE(1451),
    [sym_cast_expression] = STATE(1451),
    [sym_sizeof_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_call_expression] = STATE(1451),
    [sym_field_expression] = STATE(1451),
    [sym_compound_literal_expression] = STATE(1451),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_concatenated_string] = STATE(1451),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3900),
    [anon_sym_LBRACE] = ACTIONS(3902),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3904),
    [anon_sym_switch] = ACTIONS(3906),
    [anon_sym_case] = ACTIONS(3908),
    [anon_sym_default] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3912),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_for] = ACTIONS(3916),
    [anon_sym_return] = ACTIONS(3918),
    [anon_sym_break] = ACTIONS(3920),
    [anon_sym_continue] = ACTIONS(3922),
    [anon_sym_goto] = ACTIONS(3924),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3926),
    [sym_char_literal] = ACTIONS(3926),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3928),
    [sym_false] = ACTIONS(3928),
    [sym_null] = ACTIONS(3928),
    [sym_identifier] = ACTIONS(3930),
    [sym_comment] = ACTIONS(42),
  },
  [1361] = {
    [sym_compound_statement] = STATE(1453),
    [sym_labeled_statement] = STATE(1453),
    [sym_expression_statement] = STATE(1453),
    [sym_if_statement] = STATE(1453),
    [sym_switch_statement] = STATE(1453),
    [sym_case_statement] = STATE(1453),
    [sym_while_statement] = STATE(1453),
    [sym_do_statement] = STATE(1453),
    [sym_for_statement] = STATE(1453),
    [sym_return_statement] = STATE(1453),
    [sym_break_statement] = STATE(1453),
    [sym_continue_statement] = STATE(1453),
    [sym_goto_statement] = STATE(1453),
    [sym__expression] = STATE(954),
    [sym_comma_expression] = STATE(955),
    [sym_conditional_expression] = STATE(954),
    [sym_assignment_expression] = STATE(954),
    [sym_pointer_expression] = STATE(954),
    [sym_logical_expression] = STATE(954),
    [sym_bitwise_expression] = STATE(954),
    [sym_equality_expression] = STATE(954),
    [sym_relational_expression] = STATE(954),
    [sym_shift_expression] = STATE(954),
    [sym_math_expression] = STATE(954),
    [sym_cast_expression] = STATE(954),
    [sym_sizeof_expression] = STATE(954),
    [sym_subscript_expression] = STATE(954),
    [sym_call_expression] = STATE(954),
    [sym_field_expression] = STATE(954),
    [sym_compound_literal_expression] = STATE(954),
    [sym_parenthesized_expression] = STATE(954),
    [sym_concatenated_string] = STATE(954),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(2497),
    [anon_sym_switch] = ACTIONS(2499),
    [anon_sym_case] = ACTIONS(2501),
    [anon_sym_default] = ACTIONS(2503),
    [anon_sym_while] = ACTIONS(2505),
    [anon_sym_do] = ACTIONS(2507),
    [anon_sym_for] = ACTIONS(2509),
    [anon_sym_return] = ACTIONS(2511),
    [anon_sym_break] = ACTIONS(2513),
    [anon_sym_continue] = ACTIONS(2515),
    [anon_sym_goto] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(2519),
    [sym_char_literal] = ACTIONS(2519),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(2521),
    [sym_false] = ACTIONS(2521),
    [sym_null] = ACTIONS(2521),
    [sym_identifier] = ACTIONS(3445),
    [sym_comment] = ACTIONS(42),
  },
  [1362] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3250),
    [anon_sym_LPAREN] = ACTIONS(3252),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3250),
    [sym_preproc_directive] = ACTIONS(3250),
    [anon_sym_SEMI] = ACTIONS(3252),
    [anon_sym_typedef] = ACTIONS(3250),
    [anon_sym_extern] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3252),
    [anon_sym_STAR] = ACTIONS(3252),
    [anon_sym_static] = ACTIONS(3250),
    [anon_sym_auto] = ACTIONS(3250),
    [anon_sym_register] = ACTIONS(3250),
    [anon_sym_inline] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(3250),
    [anon_sym_restrict] = ACTIONS(3250),
    [anon_sym_volatile] = ACTIONS(3250),
    [anon_sym__Atomic] = ACTIONS(3250),
    [anon_sym_unsigned] = ACTIONS(3250),
    [anon_sym_long] = ACTIONS(3250),
    [anon_sym_short] = ACTIONS(3250),
    [sym_primitive_type] = ACTIONS(3250),
    [anon_sym_enum] = ACTIONS(3250),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_union] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_switch] = ACTIONS(3250),
    [anon_sym_case] = ACTIONS(3250),
    [anon_sym_default] = ACTIONS(3250),
    [anon_sym_while] = ACTIONS(3250),
    [anon_sym_do] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_goto] = ACTIONS(3250),
    [anon_sym_AMP] = ACTIONS(3252),
    [anon_sym_BANG] = ACTIONS(3252),
    [anon_sym_TILDE] = ACTIONS(3252),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3252),
    [anon_sym_PLUS_PLUS] = ACTIONS(3252),
    [anon_sym_sizeof] = ACTIONS(3250),
    [sym_number_literal] = ACTIONS(3252),
    [sym_char_literal] = ACTIONS(3252),
    [sym_string_literal] = ACTIONS(3252),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [sym_null] = ACTIONS(3250),
    [sym_identifier] = ACTIONS(3250),
    [sym_comment] = ACTIONS(42),
  },
  [1363] = {
    [sym_compound_statement] = STATE(1454),
    [sym_labeled_statement] = STATE(1454),
    [sym_expression_statement] = STATE(1454),
    [sym_if_statement] = STATE(1454),
    [sym_switch_statement] = STATE(1454),
    [sym_case_statement] = STATE(1454),
    [sym_while_statement] = STATE(1454),
    [sym_do_statement] = STATE(1454),
    [sym_for_statement] = STATE(1454),
    [sym_return_statement] = STATE(1454),
    [sym_break_statement] = STATE(1454),
    [sym_continue_statement] = STATE(1454),
    [sym_goto_statement] = STATE(1454),
    [sym__expression] = STATE(954),
    [sym_comma_expression] = STATE(955),
    [sym_conditional_expression] = STATE(954),
    [sym_assignment_expression] = STATE(954),
    [sym_pointer_expression] = STATE(954),
    [sym_logical_expression] = STATE(954),
    [sym_bitwise_expression] = STATE(954),
    [sym_equality_expression] = STATE(954),
    [sym_relational_expression] = STATE(954),
    [sym_shift_expression] = STATE(954),
    [sym_math_expression] = STATE(954),
    [sym_cast_expression] = STATE(954),
    [sym_sizeof_expression] = STATE(954),
    [sym_subscript_expression] = STATE(954),
    [sym_call_expression] = STATE(954),
    [sym_field_expression] = STATE(954),
    [sym_compound_literal_expression] = STATE(954),
    [sym_parenthesized_expression] = STATE(954),
    [sym_concatenated_string] = STATE(954),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(2497),
    [anon_sym_switch] = ACTIONS(2499),
    [anon_sym_case] = ACTIONS(2501),
    [anon_sym_default] = ACTIONS(2503),
    [anon_sym_while] = ACTIONS(2505),
    [anon_sym_do] = ACTIONS(2507),
    [anon_sym_for] = ACTIONS(2509),
    [anon_sym_return] = ACTIONS(2511),
    [anon_sym_break] = ACTIONS(2513),
    [anon_sym_continue] = ACTIONS(2515),
    [anon_sym_goto] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(2519),
    [sym_char_literal] = ACTIONS(2519),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(2521),
    [sym_false] = ACTIONS(2521),
    [sym_null] = ACTIONS(2521),
    [sym_identifier] = ACTIONS(3445),
    [sym_comment] = ACTIONS(42),
  },
  [1364] = {
    [sym__expression] = STATE(1455),
    [sym_conditional_expression] = STATE(1455),
    [sym_assignment_expression] = STATE(1455),
    [sym_pointer_expression] = STATE(1455),
    [sym_logical_expression] = STATE(1455),
    [sym_bitwise_expression] = STATE(1455),
    [sym_equality_expression] = STATE(1455),
    [sym_relational_expression] = STATE(1455),
    [sym_shift_expression] = STATE(1455),
    [sym_math_expression] = STATE(1455),
    [sym_cast_expression] = STATE(1455),
    [sym_sizeof_expression] = STATE(1455),
    [sym_subscript_expression] = STATE(1455),
    [sym_call_expression] = STATE(1455),
    [sym_field_expression] = STATE(1455),
    [sym_compound_literal_expression] = STATE(1455),
    [sym_parenthesized_expression] = STATE(1455),
    [sym_concatenated_string] = STATE(1455),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(3932),
    [sym_char_literal] = ACTIONS(3932),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(3934),
    [sym_false] = ACTIONS(3934),
    [sym_null] = ACTIONS(3934),
    [sym_identifier] = ACTIONS(3934),
    [sym_comment] = ACTIONS(42),
  },
  [1365] = {
    [sym__expression] = STATE(1457),
    [sym_conditional_expression] = STATE(1457),
    [sym_assignment_expression] = STATE(1457),
    [sym_pointer_expression] = STATE(1457),
    [sym_logical_expression] = STATE(1457),
    [sym_bitwise_expression] = STATE(1457),
    [sym_equality_expression] = STATE(1457),
    [sym_relational_expression] = STATE(1457),
    [sym_shift_expression] = STATE(1457),
    [sym_math_expression] = STATE(1457),
    [sym_cast_expression] = STATE(1457),
    [sym_sizeof_expression] = STATE(1457),
    [sym_subscript_expression] = STATE(1457),
    [sym_call_expression] = STATE(1457),
    [sym_field_expression] = STATE(1457),
    [sym_compound_literal_expression] = STATE(1457),
    [sym_parenthesized_expression] = STATE(1457),
    [sym_concatenated_string] = STATE(1457),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(3936),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(3938),
    [sym_char_literal] = ACTIONS(3938),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(3940),
    [sym_false] = ACTIONS(3940),
    [sym_null] = ACTIONS(3940),
    [sym_identifier] = ACTIONS(3940),
    [sym_comment] = ACTIONS(42),
  },
  [1366] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(3942),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1367] = {
    [sym__expression] = STATE(1459),
    [sym_conditional_expression] = STATE(1459),
    [sym_assignment_expression] = STATE(1459),
    [sym_pointer_expression] = STATE(1459),
    [sym_logical_expression] = STATE(1459),
    [sym_bitwise_expression] = STATE(1459),
    [sym_equality_expression] = STATE(1459),
    [sym_relational_expression] = STATE(1459),
    [sym_shift_expression] = STATE(1459),
    [sym_math_expression] = STATE(1459),
    [sym_cast_expression] = STATE(1459),
    [sym_sizeof_expression] = STATE(1459),
    [sym_subscript_expression] = STATE(1459),
    [sym_call_expression] = STATE(1459),
    [sym_field_expression] = STATE(1459),
    [sym_compound_literal_expression] = STATE(1459),
    [sym_parenthesized_expression] = STATE(1459),
    [sym_concatenated_string] = STATE(1459),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(3942),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(3944),
    [sym_char_literal] = ACTIONS(3944),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(3946),
    [sym_false] = ACTIONS(3946),
    [sym_null] = ACTIONS(3946),
    [sym_identifier] = ACTIONS(3946),
    [sym_comment] = ACTIONS(42),
  },
  [1368] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1288),
    [anon_sym_LPAREN] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1288),
    [sym_preproc_directive] = ACTIONS(1288),
    [anon_sym_SEMI] = ACTIONS(1286),
    [anon_sym_typedef] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1288),
    [anon_sym_LBRACE] = ACTIONS(1286),
    [anon_sym_STAR] = ACTIONS(1286),
    [anon_sym_static] = ACTIONS(1288),
    [anon_sym_auto] = ACTIONS(1288),
    [anon_sym_register] = ACTIONS(1288),
    [anon_sym_inline] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_restrict] = ACTIONS(1288),
    [anon_sym_volatile] = ACTIONS(1288),
    [anon_sym__Atomic] = ACTIONS(1288),
    [anon_sym_unsigned] = ACTIONS(1288),
    [anon_sym_long] = ACTIONS(1288),
    [anon_sym_short] = ACTIONS(1288),
    [sym_primitive_type] = ACTIONS(1288),
    [anon_sym_enum] = ACTIONS(1288),
    [anon_sym_struct] = ACTIONS(1288),
    [anon_sym_union] = ACTIONS(1288),
    [anon_sym_if] = ACTIONS(1288),
    [anon_sym_switch] = ACTIONS(1288),
    [anon_sym_case] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1288),
    [anon_sym_while] = ACTIONS(1288),
    [anon_sym_do] = ACTIONS(1288),
    [anon_sym_for] = ACTIONS(1288),
    [anon_sym_return] = ACTIONS(1288),
    [anon_sym_break] = ACTIONS(1288),
    [anon_sym_continue] = ACTIONS(1288),
    [anon_sym_goto] = ACTIONS(1288),
    [anon_sym_AMP] = ACTIONS(1286),
    [anon_sym_BANG] = ACTIONS(1286),
    [anon_sym_TILDE] = ACTIONS(1286),
    [anon_sym_PLUS] = ACTIONS(1288),
    [anon_sym_DASH] = ACTIONS(1288),
    [anon_sym_DASH_DASH] = ACTIONS(1286),
    [anon_sym_PLUS_PLUS] = ACTIONS(1286),
    [anon_sym_sizeof] = ACTIONS(1288),
    [sym_number_literal] = ACTIONS(1286),
    [sym_char_literal] = ACTIONS(1286),
    [sym_string_literal] = ACTIONS(1286),
    [sym_true] = ACTIONS(1288),
    [sym_false] = ACTIONS(1288),
    [sym_null] = ACTIONS(1288),
    [sym_identifier] = ACTIONS(1288),
    [sym_comment] = ACTIONS(42),
  },
  [1369] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1409),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1411),
    [sym_preproc_directive] = ACTIONS(1411),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_typedef] = ACTIONS(1411),
    [anon_sym_extern] = ACTIONS(1411),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_static] = ACTIONS(1411),
    [anon_sym_auto] = ACTIONS(1411),
    [anon_sym_register] = ACTIONS(1411),
    [anon_sym_inline] = ACTIONS(1411),
    [anon_sym_const] = ACTIONS(1411),
    [anon_sym_restrict] = ACTIONS(1411),
    [anon_sym_volatile] = ACTIONS(1411),
    [anon_sym__Atomic] = ACTIONS(1411),
    [anon_sym_unsigned] = ACTIONS(1411),
    [anon_sym_long] = ACTIONS(1411),
    [anon_sym_short] = ACTIONS(1411),
    [sym_primitive_type] = ACTIONS(1411),
    [anon_sym_enum] = ACTIONS(1411),
    [anon_sym_struct] = ACTIONS(1411),
    [anon_sym_union] = ACTIONS(1411),
    [anon_sym_if] = ACTIONS(1411),
    [anon_sym_switch] = ACTIONS(1411),
    [anon_sym_case] = ACTIONS(1411),
    [anon_sym_default] = ACTIONS(1411),
    [anon_sym_while] = ACTIONS(1411),
    [anon_sym_do] = ACTIONS(1411),
    [anon_sym_for] = ACTIONS(1411),
    [anon_sym_return] = ACTIONS(1411),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_continue] = ACTIONS(1411),
    [anon_sym_goto] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1411),
    [anon_sym_DASH] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1409),
    [anon_sym_sizeof] = ACTIONS(1411),
    [sym_number_literal] = ACTIONS(1409),
    [sym_char_literal] = ACTIONS(1409),
    [sym_string_literal] = ACTIONS(1409),
    [sym_true] = ACTIONS(1411),
    [sym_false] = ACTIONS(1411),
    [sym_null] = ACTIONS(1411),
    [sym_identifier] = ACTIONS(1411),
    [sym_comment] = ACTIONS(42),
  },
  [1370] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1037),
    [sym_preproc_directive] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_typedef] = ACTIONS(1037),
    [anon_sym_extern] = ACTIONS(1037),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_STAR] = ACTIONS(1039),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_auto] = ACTIONS(1037),
    [anon_sym_register] = ACTIONS(1037),
    [anon_sym_inline] = ACTIONS(1037),
    [anon_sym_const] = ACTIONS(1037),
    [anon_sym_restrict] = ACTIONS(1037),
    [anon_sym_volatile] = ACTIONS(1037),
    [anon_sym__Atomic] = ACTIONS(1037),
    [anon_sym_unsigned] = ACTIONS(1037),
    [anon_sym_long] = ACTIONS(1037),
    [anon_sym_short] = ACTIONS(1037),
    [sym_primitive_type] = ACTIONS(1037),
    [anon_sym_enum] = ACTIONS(1037),
    [anon_sym_struct] = ACTIONS(1037),
    [anon_sym_union] = ACTIONS(1037),
    [anon_sym_if] = ACTIONS(1037),
    [anon_sym_else] = ACTIONS(1037),
    [anon_sym_switch] = ACTIONS(1037),
    [anon_sym_case] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1037),
    [anon_sym_do] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1037),
    [anon_sym_return] = ACTIONS(1037),
    [anon_sym_break] = ACTIONS(1037),
    [anon_sym_continue] = ACTIONS(1037),
    [anon_sym_goto] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_TILDE] = ACTIONS(1039),
    [anon_sym_PLUS] = ACTIONS(1037),
    [anon_sym_DASH] = ACTIONS(1037),
    [anon_sym_DASH_DASH] = ACTIONS(1039),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_sizeof] = ACTIONS(1037),
    [sym_number_literal] = ACTIONS(1039),
    [sym_char_literal] = ACTIONS(1039),
    [sym_string_literal] = ACTIONS(1039),
    [sym_true] = ACTIONS(1037),
    [sym_false] = ACTIONS(1037),
    [sym_null] = ACTIONS(1037),
    [sym_identifier] = ACTIONS(1037),
    [sym_comment] = ACTIONS(42),
  },
  [1371] = {
    [sym_preproc_include] = STATE(1461),
    [sym_preproc_def] = STATE(1461),
    [sym_preproc_function_def] = STATE(1461),
    [sym_preproc_call] = STATE(1461),
    [sym_preproc_if_in_compound_statement] = STATE(275),
    [sym_preproc_ifdef_in_compound_statement] = STATE(276),
    [sym_declaration] = STATE(1461),
    [sym_type_definition] = STATE(1461),
    [sym__declaration_specifiers] = STATE(277),
    [sym_compound_statement] = STATE(1461),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(1461),
    [sym_expression_statement] = STATE(1461),
    [sym_if_statement] = STATE(1461),
    [sym_switch_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_do_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_return_statement] = STATE(1461),
    [sym_break_statement] = STATE(1461),
    [sym_continue_statement] = STATE(1461),
    [sym_goto_statement] = STATE(1461),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [sym__empty_declaration] = STATE(1461),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1461),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(577),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(579),
    [sym_preproc_directive] = ACTIONS(581),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_typedef] = ACTIONS(585),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_RBRACE] = ACTIONS(3948),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(631),
    [sym_comment] = ACTIONS(42),
  },
  [1372] = {
    [anon_sym_LPAREN] = ACTIONS(3950),
    [sym_comment] = ACTIONS(42),
  },
  [1373] = {
    [anon_sym_LPAREN] = ACTIONS(3952),
    [sym_comment] = ACTIONS(42),
  },
  [1374] = {
    [sym__expression] = STATE(1464),
    [sym_conditional_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(1464),
    [sym_pointer_expression] = STATE(1464),
    [sym_logical_expression] = STATE(1464),
    [sym_bitwise_expression] = STATE(1464),
    [sym_equality_expression] = STATE(1464),
    [sym_relational_expression] = STATE(1464),
    [sym_shift_expression] = STATE(1464),
    [sym_math_expression] = STATE(1464),
    [sym_cast_expression] = STATE(1464),
    [sym_sizeof_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_call_expression] = STATE(1464),
    [sym_field_expression] = STATE(1464),
    [sym_compound_literal_expression] = STATE(1464),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_concatenated_string] = STATE(1464),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(3954),
    [sym_char_literal] = ACTIONS(3954),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(3956),
    [sym_false] = ACTIONS(3956),
    [sym_null] = ACTIONS(3956),
    [sym_identifier] = ACTIONS(3956),
    [sym_comment] = ACTIONS(42),
  },
  [1375] = {
    [anon_sym_COLON] = ACTIONS(3958),
    [sym_comment] = ACTIONS(42),
  },
  [1376] = {
    [anon_sym_LPAREN] = ACTIONS(3960),
    [sym_comment] = ACTIONS(42),
  },
  [1377] = {
    [sym_compound_statement] = STATE(1467),
    [sym_labeled_statement] = STATE(1467),
    [sym_expression_statement] = STATE(1467),
    [sym_if_statement] = STATE(1467),
    [sym_switch_statement] = STATE(1467),
    [sym_case_statement] = STATE(1467),
    [sym_while_statement] = STATE(1467),
    [sym_do_statement] = STATE(1467),
    [sym_for_statement] = STATE(1467),
    [sym_return_statement] = STATE(1467),
    [sym_break_statement] = STATE(1467),
    [sym_continue_statement] = STATE(1467),
    [sym_goto_statement] = STATE(1467),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_default] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(1089),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1093),
    [sym_comment] = ACTIONS(42),
  },
  [1378] = {
    [anon_sym_LPAREN] = ACTIONS(3962),
    [sym_comment] = ACTIONS(42),
  },
  [1379] = {
    [sym__expression] = STATE(1470),
    [sym_conditional_expression] = STATE(1470),
    [sym_assignment_expression] = STATE(1470),
    [sym_pointer_expression] = STATE(1470),
    [sym_logical_expression] = STATE(1470),
    [sym_bitwise_expression] = STATE(1470),
    [sym_equality_expression] = STATE(1470),
    [sym_relational_expression] = STATE(1470),
    [sym_shift_expression] = STATE(1470),
    [sym_math_expression] = STATE(1470),
    [sym_cast_expression] = STATE(1470),
    [sym_sizeof_expression] = STATE(1470),
    [sym_subscript_expression] = STATE(1470),
    [sym_call_expression] = STATE(1470),
    [sym_field_expression] = STATE(1470),
    [sym_compound_literal_expression] = STATE(1470),
    [sym_parenthesized_expression] = STATE(1470),
    [sym_concatenated_string] = STATE(1470),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(3964),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(3966),
    [sym_char_literal] = ACTIONS(3966),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(3968),
    [sym_false] = ACTIONS(3968),
    [sym_null] = ACTIONS(3968),
    [sym_identifier] = ACTIONS(3968),
    [sym_comment] = ACTIONS(42),
  },
  [1380] = {
    [anon_sym_SEMI] = ACTIONS(3970),
    [sym_comment] = ACTIONS(42),
  },
  [1381] = {
    [anon_sym_SEMI] = ACTIONS(3972),
    [sym_comment] = ACTIONS(42),
  },
  [1382] = {
    [sym_identifier] = ACTIONS(3974),
    [sym_comment] = ACTIONS(42),
  },
  [1383] = {
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_COLON] = ACTIONS(3976),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_comment] = ACTIONS(42),
  },
  [1384] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3605),
    [anon_sym_LPAREN] = ACTIONS(3607),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3605),
    [sym_preproc_directive] = ACTIONS(3605),
    [anon_sym_SEMI] = ACTIONS(3607),
    [anon_sym_typedef] = ACTIONS(3605),
    [anon_sym_extern] = ACTIONS(3605),
    [anon_sym_LBRACE] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(3607),
    [anon_sym_static] = ACTIONS(3605),
    [anon_sym_auto] = ACTIONS(3605),
    [anon_sym_register] = ACTIONS(3605),
    [anon_sym_inline] = ACTIONS(3605),
    [anon_sym_const] = ACTIONS(3605),
    [anon_sym_restrict] = ACTIONS(3605),
    [anon_sym_volatile] = ACTIONS(3605),
    [anon_sym__Atomic] = ACTIONS(3605),
    [anon_sym_unsigned] = ACTIONS(3605),
    [anon_sym_long] = ACTIONS(3605),
    [anon_sym_short] = ACTIONS(3605),
    [sym_primitive_type] = ACTIONS(3605),
    [anon_sym_enum] = ACTIONS(3605),
    [anon_sym_struct] = ACTIONS(3605),
    [anon_sym_union] = ACTIONS(3605),
    [anon_sym_if] = ACTIONS(3605),
    [anon_sym_else] = ACTIONS(3978),
    [anon_sym_switch] = ACTIONS(3605),
    [anon_sym_case] = ACTIONS(3605),
    [anon_sym_default] = ACTIONS(3605),
    [anon_sym_while] = ACTIONS(3605),
    [anon_sym_do] = ACTIONS(3605),
    [anon_sym_for] = ACTIONS(3605),
    [anon_sym_return] = ACTIONS(3605),
    [anon_sym_break] = ACTIONS(3605),
    [anon_sym_continue] = ACTIONS(3605),
    [anon_sym_goto] = ACTIONS(3605),
    [anon_sym_AMP] = ACTIONS(3607),
    [anon_sym_BANG] = ACTIONS(3607),
    [anon_sym_TILDE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3605),
    [anon_sym_DASH] = ACTIONS(3605),
    [anon_sym_DASH_DASH] = ACTIONS(3607),
    [anon_sym_PLUS_PLUS] = ACTIONS(3607),
    [anon_sym_sizeof] = ACTIONS(3605),
    [sym_number_literal] = ACTIONS(3607),
    [sym_char_literal] = ACTIONS(3607),
    [sym_string_literal] = ACTIONS(3607),
    [sym_true] = ACTIONS(3605),
    [sym_false] = ACTIONS(3605),
    [sym_null] = ACTIONS(3605),
    [sym_identifier] = ACTIONS(3605),
    [sym_comment] = ACTIONS(42),
  },
  [1385] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_SEMI] = ACTIONS(3980),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_STAR_EQ] = ACTIONS(1171),
    [anon_sym_SLASH_EQ] = ACTIONS(1171),
    [anon_sym_PERCENT_EQ] = ACTIONS(1171),
    [anon_sym_PLUS_EQ] = ACTIONS(1171),
    [anon_sym_DASH_EQ] = ACTIONS(1171),
    [anon_sym_LT_LT_EQ] = ACTIONS(1171),
    [anon_sym_GT_GT_EQ] = ACTIONS(1171),
    [anon_sym_AMP_EQ] = ACTIONS(1171),
    [anon_sym_CARET_EQ] = ACTIONS(1171),
    [anon_sym_PIPE_EQ] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_PIPE_PIPE] = ACTIONS(1175),
    [anon_sym_AMP_AMP] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_LT] = ACTIONS(1185),
    [anon_sym_GT] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1187),
    [anon_sym_GT_EQ] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1189),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1386] = {
    [anon_sym_SEMI] = ACTIONS(3980),
    [sym_comment] = ACTIONS(42),
  },
  [1387] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3615),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3615),
    [sym_preproc_directive] = ACTIONS(3615),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_typedef] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_STAR] = ACTIONS(3617),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_auto] = ACTIONS(3615),
    [anon_sym_register] = ACTIONS(3615),
    [anon_sym_inline] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_restrict] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym__Atomic] = ACTIONS(3615),
    [anon_sym_unsigned] = ACTIONS(3615),
    [anon_sym_long] = ACTIONS(3615),
    [anon_sym_short] = ACTIONS(3615),
    [sym_primitive_type] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_union] = ACTIONS(3615),
    [anon_sym_if] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3615),
    [anon_sym_case] = ACTIONS(3615),
    [anon_sym_default] = ACTIONS(3615),
    [anon_sym_while] = ACTIONS(3615),
    [anon_sym_do] = ACTIONS(3615),
    [anon_sym_for] = ACTIONS(3615),
    [anon_sym_return] = ACTIONS(3615),
    [anon_sym_break] = ACTIONS(3615),
    [anon_sym_continue] = ACTIONS(3615),
    [anon_sym_goto] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_DASH_DASH] = ACTIONS(3617),
    [anon_sym_PLUS_PLUS] = ACTIONS(3617),
    [anon_sym_sizeof] = ACTIONS(3615),
    [sym_number_literal] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [sym_string_literal] = ACTIONS(3617),
    [sym_true] = ACTIONS(3615),
    [sym_false] = ACTIONS(3615),
    [sym_null] = ACTIONS(3615),
    [sym_identifier] = ACTIONS(3615),
    [sym_comment] = ACTIONS(42),
  },
  [1388] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3627),
    [sym_preproc_directive] = ACTIONS(3627),
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym_typedef] = ACTIONS(3627),
    [anon_sym_extern] = ACTIONS(3627),
    [anon_sym_LBRACE] = ACTIONS(3629),
    [anon_sym_STAR] = ACTIONS(3629),
    [anon_sym_static] = ACTIONS(3627),
    [anon_sym_auto] = ACTIONS(3627),
    [anon_sym_register] = ACTIONS(3627),
    [anon_sym_inline] = ACTIONS(3627),
    [anon_sym_const] = ACTIONS(3627),
    [anon_sym_restrict] = ACTIONS(3627),
    [anon_sym_volatile] = ACTIONS(3627),
    [anon_sym__Atomic] = ACTIONS(3627),
    [anon_sym_unsigned] = ACTIONS(3627),
    [anon_sym_long] = ACTIONS(3627),
    [anon_sym_short] = ACTIONS(3627),
    [sym_primitive_type] = ACTIONS(3627),
    [anon_sym_enum] = ACTIONS(3627),
    [anon_sym_struct] = ACTIONS(3627),
    [anon_sym_union] = ACTIONS(3627),
    [anon_sym_if] = ACTIONS(3627),
    [anon_sym_switch] = ACTIONS(3627),
    [anon_sym_case] = ACTIONS(3627),
    [anon_sym_default] = ACTIONS(3627),
    [anon_sym_while] = ACTIONS(3627),
    [anon_sym_do] = ACTIONS(3627),
    [anon_sym_for] = ACTIONS(3627),
    [anon_sym_return] = ACTIONS(3627),
    [anon_sym_break] = ACTIONS(3627),
    [anon_sym_continue] = ACTIONS(3627),
    [anon_sym_goto] = ACTIONS(3627),
    [anon_sym_AMP] = ACTIONS(3629),
    [anon_sym_BANG] = ACTIONS(3629),
    [anon_sym_TILDE] = ACTIONS(3629),
    [anon_sym_PLUS] = ACTIONS(3627),
    [anon_sym_DASH] = ACTIONS(3627),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_sizeof] = ACTIONS(3627),
    [sym_number_literal] = ACTIONS(3629),
    [sym_char_literal] = ACTIONS(3629),
    [sym_string_literal] = ACTIONS(3629),
    [sym_true] = ACTIONS(3627),
    [sym_false] = ACTIONS(3627),
    [sym_null] = ACTIONS(3627),
    [sym_identifier] = ACTIONS(3627),
    [sym_comment] = ACTIONS(42),
  },
  [1389] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(3982),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1390] = {
    [sym_compound_statement] = STATE(1478),
    [sym_labeled_statement] = STATE(1478),
    [sym_expression_statement] = STATE(1478),
    [sym_if_statement] = STATE(1478),
    [sym_switch_statement] = STATE(1478),
    [sym_case_statement] = STATE(1478),
    [sym_while_statement] = STATE(1478),
    [sym_do_statement] = STATE(1478),
    [sym_for_statement] = STATE(1478),
    [sym_return_statement] = STATE(1478),
    [sym_break_statement] = STATE(1478),
    [sym_continue_statement] = STATE(1478),
    [sym_goto_statement] = STATE(1478),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(3040),
    [sym_comment] = ACTIONS(42),
  },
  [1391] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1480),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1392] = {
    [sym__expression] = STATE(1481),
    [sym_conditional_expression] = STATE(1481),
    [sym_assignment_expression] = STATE(1481),
    [sym_pointer_expression] = STATE(1481),
    [sym_logical_expression] = STATE(1481),
    [sym_bitwise_expression] = STATE(1481),
    [sym_equality_expression] = STATE(1481),
    [sym_relational_expression] = STATE(1481),
    [sym_shift_expression] = STATE(1481),
    [sym_math_expression] = STATE(1481),
    [sym_cast_expression] = STATE(1481),
    [sym_sizeof_expression] = STATE(1481),
    [sym_subscript_expression] = STATE(1481),
    [sym_call_expression] = STATE(1481),
    [sym_field_expression] = STATE(1481),
    [sym_compound_literal_expression] = STATE(1481),
    [sym_parenthesized_expression] = STATE(1481),
    [sym_concatenated_string] = STATE(1481),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(3986),
    [sym_char_literal] = ACTIONS(3986),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(3988),
    [sym_false] = ACTIONS(3988),
    [sym_null] = ACTIONS(3988),
    [sym_identifier] = ACTIONS(3988),
    [sym_comment] = ACTIONS(42),
  },
  [1393] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(3990),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1394] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1913),
    [anon_sym_LPAREN] = ACTIONS(1911),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_RBRACE] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_auto] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [anon_sym_if] = ACTIONS(1913),
    [anon_sym_else] = ACTIONS(1913),
    [anon_sym_switch] = ACTIONS(1913),
    [anon_sym_case] = ACTIONS(1913),
    [anon_sym_default] = ACTIONS(1913),
    [anon_sym_while] = ACTIONS(1913),
    [anon_sym_do] = ACTIONS(1913),
    [anon_sym_for] = ACTIONS(1913),
    [anon_sym_return] = ACTIONS(1913),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1913),
    [anon_sym_goto] = ACTIONS(1913),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1913),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_sizeof] = ACTIONS(1913),
    [sym_number_literal] = ACTIONS(1911),
    [sym_char_literal] = ACTIONS(1911),
    [sym_string_literal] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [sym_null] = ACTIONS(1913),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(42),
  },
  [1395] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(3992),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1396] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(3994),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1397] = {
    [sym_declaration] = STATE(1485),
    [sym_type_definition] = STATE(1485),
    [sym__declaration_specifiers] = STATE(1401),
    [sym_compound_statement] = STATE(1485),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(1485),
    [sym_expression_statement] = STATE(1485),
    [sym_if_statement] = STATE(1485),
    [sym_switch_statement] = STATE(1485),
    [sym_case_statement] = STATE(1485),
    [sym_while_statement] = STATE(1485),
    [sym_do_statement] = STATE(1485),
    [sym_for_statement] = STATE(1485),
    [sym_return_statement] = STATE(1485),
    [sym_break_statement] = STATE(1485),
    [sym_continue_statement] = STATE(1485),
    [sym_goto_statement] = STATE(1485),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_typedef] = ACTIONS(3818),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(3173),
    [anon_sym_switch] = ACTIONS(3175),
    [anon_sym_case] = ACTIONS(3177),
    [anon_sym_default] = ACTIONS(3179),
    [anon_sym_while] = ACTIONS(3181),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3185),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3820),
    [sym_comment] = ACTIONS(42),
  },
  [1398] = {
    [sym_type_qualifier] = STATE(1487),
    [sym__type_specifier] = STATE(1486),
    [sym_sized_type_specifier] = STATE(1486),
    [sym_enum_specifier] = STATE(1486),
    [sym_struct_specifier] = STATE(1486),
    [sym_union_specifier] = STATE(1486),
    [sym_macro_type_specifier] = STATE(1486),
    [aux_sym_type_definition_repeat1] = STATE(1487),
    [aux_sym_sized_type_specifier_repeat1] = STATE(36),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(62),
    [anon_sym_long] = ACTIONS(62),
    [anon_sym_short] = ACTIONS(62),
    [sym_primitive_type] = ACTIONS(3996),
    [anon_sym_enum] = ACTIONS(66),
    [anon_sym_struct] = ACTIONS(68),
    [anon_sym_union] = ACTIONS(70),
    [sym_identifier] = ACTIONS(72),
    [sym_comment] = ACTIONS(42),
  },
  [1399] = {
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_extern] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_auto] = ACTIONS(95),
    [anon_sym_register] = ACTIONS(95),
    [anon_sym_inline] = ACTIONS(95),
    [anon_sym_const] = ACTIONS(95),
    [anon_sym_restrict] = ACTIONS(95),
    [anon_sym_volatile] = ACTIONS(95),
    [anon_sym__Atomic] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(3603),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_identifier] = ACTIONS(95),
    [sym_comment] = ACTIONS(42),
  },
  [1400] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2687),
    [sym_preproc_directive] = ACTIONS(2687),
    [anon_sym_SEMI] = ACTIONS(2689),
    [anon_sym_typedef] = ACTIONS(2687),
    [anon_sym_extern] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_RBRACE] = ACTIONS(2689),
    [anon_sym_STAR] = ACTIONS(2689),
    [anon_sym_static] = ACTIONS(2687),
    [anon_sym_auto] = ACTIONS(2687),
    [anon_sym_register] = ACTIONS(2687),
    [anon_sym_inline] = ACTIONS(2687),
    [anon_sym_const] = ACTIONS(2687),
    [anon_sym_restrict] = ACTIONS(2687),
    [anon_sym_volatile] = ACTIONS(2687),
    [anon_sym__Atomic] = ACTIONS(2687),
    [anon_sym_unsigned] = ACTIONS(2687),
    [anon_sym_long] = ACTIONS(2687),
    [anon_sym_short] = ACTIONS(2687),
    [sym_primitive_type] = ACTIONS(2687),
    [anon_sym_enum] = ACTIONS(2687),
    [anon_sym_struct] = ACTIONS(2687),
    [anon_sym_union] = ACTIONS(2687),
    [anon_sym_if] = ACTIONS(2687),
    [anon_sym_else] = ACTIONS(2687),
    [anon_sym_switch] = ACTIONS(2687),
    [anon_sym_case] = ACTIONS(2687),
    [anon_sym_default] = ACTIONS(2687),
    [anon_sym_while] = ACTIONS(2687),
    [anon_sym_do] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2687),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_break] = ACTIONS(2687),
    [anon_sym_continue] = ACTIONS(2687),
    [anon_sym_goto] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_BANG] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2687),
    [anon_sym_DASH] = ACTIONS(2687),
    [anon_sym_DASH_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_PLUS] = ACTIONS(2689),
    [anon_sym_sizeof] = ACTIONS(2687),
    [sym_number_literal] = ACTIONS(2689),
    [sym_char_literal] = ACTIONS(2689),
    [sym_string_literal] = ACTIONS(2689),
    [sym_true] = ACTIONS(2687),
    [sym_false] = ACTIONS(2687),
    [sym_null] = ACTIONS(2687),
    [sym_identifier] = ACTIONS(2687),
    [sym_comment] = ACTIONS(42),
  },
  [1401] = {
    [sym__declarator] = STATE(1488),
    [sym_pointer_declarator] = STATE(1488),
    [sym_function_declarator] = STATE(1488),
    [sym_array_declarator] = STATE(1488),
    [sym_init_declarator] = STATE(1489),
    [anon_sym_LPAREN] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(561),
    [sym_identifier] = ACTIONS(3998),
    [sym_comment] = ACTIONS(42),
  },
  [1402] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1403] = {
    [anon_sym_LPAREN] = ACTIONS(4002),
    [sym_comment] = ACTIONS(42),
  },
  [1404] = {
    [sym__expression] = STATE(1493),
    [sym_conditional_expression] = STATE(1493),
    [sym_assignment_expression] = STATE(1493),
    [sym_pointer_expression] = STATE(1493),
    [sym_logical_expression] = STATE(1493),
    [sym_bitwise_expression] = STATE(1493),
    [sym_equality_expression] = STATE(1493),
    [sym_relational_expression] = STATE(1493),
    [sym_shift_expression] = STATE(1493),
    [sym_math_expression] = STATE(1493),
    [sym_cast_expression] = STATE(1493),
    [sym_sizeof_expression] = STATE(1493),
    [sym_subscript_expression] = STATE(1493),
    [sym_call_expression] = STATE(1493),
    [sym_field_expression] = STATE(1493),
    [sym_compound_literal_expression] = STATE(1493),
    [sym_parenthesized_expression] = STATE(1493),
    [sym_concatenated_string] = STATE(1493),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(4004),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(4006),
    [sym_char_literal] = ACTIONS(4006),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(4008),
    [sym_false] = ACTIONS(4008),
    [sym_null] = ACTIONS(4008),
    [sym_identifier] = ACTIONS(4008),
    [sym_comment] = ACTIONS(42),
  },
  [1405] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1406] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2727),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2727),
    [sym_preproc_directive] = ACTIONS(2727),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym_typedef] = ACTIONS(2727),
    [anon_sym_extern] = ACTIONS(2727),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_RBRACE] = ACTIONS(2729),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_auto] = ACTIONS(2727),
    [anon_sym_register] = ACTIONS(2727),
    [anon_sym_inline] = ACTIONS(2727),
    [anon_sym_const] = ACTIONS(2727),
    [anon_sym_restrict] = ACTIONS(2727),
    [anon_sym_volatile] = ACTIONS(2727),
    [anon_sym__Atomic] = ACTIONS(2727),
    [anon_sym_unsigned] = ACTIONS(2727),
    [anon_sym_long] = ACTIONS(2727),
    [anon_sym_short] = ACTIONS(2727),
    [sym_primitive_type] = ACTIONS(2727),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_struct] = ACTIONS(2727),
    [anon_sym_union] = ACTIONS(2727),
    [anon_sym_if] = ACTIONS(2727),
    [anon_sym_else] = ACTIONS(2727),
    [anon_sym_switch] = ACTIONS(2727),
    [anon_sym_case] = ACTIONS(2727),
    [anon_sym_default] = ACTIONS(2727),
    [anon_sym_while] = ACTIONS(2727),
    [anon_sym_do] = ACTIONS(2727),
    [anon_sym_for] = ACTIONS(2727),
    [anon_sym_return] = ACTIONS(2727),
    [anon_sym_break] = ACTIONS(2727),
    [anon_sym_continue] = ACTIONS(2727),
    [anon_sym_goto] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_BANG] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2727),
    [anon_sym_DASH] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_sizeof] = ACTIONS(2727),
    [sym_number_literal] = ACTIONS(2729),
    [sym_char_literal] = ACTIONS(2729),
    [sym_string_literal] = ACTIONS(2729),
    [sym_true] = ACTIONS(2727),
    [sym_false] = ACTIONS(2727),
    [sym_null] = ACTIONS(2727),
    [sym_identifier] = ACTIONS(2727),
    [sym_comment] = ACTIONS(42),
  },
  [1407] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2731),
    [anon_sym_LPAREN] = ACTIONS(2733),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_RBRACE] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_auto] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_else] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_case] = ACTIONS(2731),
    [anon_sym_default] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [sym_number_literal] = ACTIONS(2733),
    [sym_char_literal] = ACTIONS(2733),
    [sym_string_literal] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [sym_null] = ACTIONS(2731),
    [sym_identifier] = ACTIONS(2731),
    [sym_comment] = ACTIONS(42),
  },
  [1408] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2746),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2744),
    [sym_preproc_directive] = ACTIONS(2744),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_typedef] = ACTIONS(2744),
    [anon_sym_extern] = ACTIONS(2744),
    [anon_sym_LBRACE] = ACTIONS(2746),
    [anon_sym_RBRACE] = ACTIONS(2746),
    [anon_sym_STAR] = ACTIONS(2746),
    [anon_sym_static] = ACTIONS(2744),
    [anon_sym_auto] = ACTIONS(2744),
    [anon_sym_register] = ACTIONS(2744),
    [anon_sym_inline] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_restrict] = ACTIONS(2744),
    [anon_sym_volatile] = ACTIONS(2744),
    [anon_sym__Atomic] = ACTIONS(2744),
    [anon_sym_unsigned] = ACTIONS(2744),
    [anon_sym_long] = ACTIONS(2744),
    [anon_sym_short] = ACTIONS(2744),
    [sym_primitive_type] = ACTIONS(2744),
    [anon_sym_enum] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_union] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_else] = ACTIONS(2744),
    [anon_sym_switch] = ACTIONS(2744),
    [anon_sym_case] = ACTIONS(2744),
    [anon_sym_default] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [anon_sym_do] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_break] = ACTIONS(2744),
    [anon_sym_continue] = ACTIONS(2744),
    [anon_sym_goto] = ACTIONS(2744),
    [anon_sym_AMP] = ACTIONS(2746),
    [anon_sym_BANG] = ACTIONS(2746),
    [anon_sym_TILDE] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_DASH] = ACTIONS(2744),
    [anon_sym_DASH_DASH] = ACTIONS(2746),
    [anon_sym_PLUS_PLUS] = ACTIONS(2746),
    [anon_sym_sizeof] = ACTIONS(2744),
    [sym_number_literal] = ACTIONS(2746),
    [sym_char_literal] = ACTIONS(2746),
    [sym_string_literal] = ACTIONS(2746),
    [sym_true] = ACTIONS(2744),
    [sym_false] = ACTIONS(2744),
    [sym_null] = ACTIONS(2744),
    [sym_identifier] = ACTIONS(2744),
    [sym_comment] = ACTIONS(42),
  },
  [1409] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4012),
    [anon_sym_LPAREN] = ACTIONS(4014),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4012),
    [sym_preproc_directive] = ACTIONS(4012),
    [anon_sym_SEMI] = ACTIONS(4014),
    [anon_sym_typedef] = ACTIONS(4012),
    [anon_sym_extern] = ACTIONS(4012),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_RBRACE] = ACTIONS(4014),
    [anon_sym_STAR] = ACTIONS(4014),
    [anon_sym_static] = ACTIONS(4012),
    [anon_sym_auto] = ACTIONS(4012),
    [anon_sym_register] = ACTIONS(4012),
    [anon_sym_inline] = ACTIONS(4012),
    [anon_sym_const] = ACTIONS(4012),
    [anon_sym_restrict] = ACTIONS(4012),
    [anon_sym_volatile] = ACTIONS(4012),
    [anon_sym__Atomic] = ACTIONS(4012),
    [anon_sym_unsigned] = ACTIONS(4012),
    [anon_sym_long] = ACTIONS(4012),
    [anon_sym_short] = ACTIONS(4012),
    [sym_primitive_type] = ACTIONS(4012),
    [anon_sym_enum] = ACTIONS(4012),
    [anon_sym_struct] = ACTIONS(4012),
    [anon_sym_union] = ACTIONS(4012),
    [anon_sym_if] = ACTIONS(4012),
    [anon_sym_switch] = ACTIONS(4012),
    [anon_sym_case] = ACTIONS(4012),
    [anon_sym_default] = ACTIONS(4012),
    [anon_sym_while] = ACTIONS(4012),
    [anon_sym_do] = ACTIONS(4012),
    [anon_sym_for] = ACTIONS(4012),
    [anon_sym_return] = ACTIONS(4012),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_continue] = ACTIONS(4012),
    [anon_sym_goto] = ACTIONS(4012),
    [anon_sym_AMP] = ACTIONS(4014),
    [anon_sym_BANG] = ACTIONS(4014),
    [anon_sym_TILDE] = ACTIONS(4014),
    [anon_sym_PLUS] = ACTIONS(4012),
    [anon_sym_DASH] = ACTIONS(4012),
    [anon_sym_DASH_DASH] = ACTIONS(4014),
    [anon_sym_PLUS_PLUS] = ACTIONS(4014),
    [anon_sym_sizeof] = ACTIONS(4012),
    [sym_number_literal] = ACTIONS(4014),
    [sym_char_literal] = ACTIONS(4014),
    [sym_string_literal] = ACTIONS(4014),
    [sym_true] = ACTIONS(4012),
    [sym_false] = ACTIONS(4012),
    [sym_null] = ACTIONS(4012),
    [sym_identifier] = ACTIONS(4012),
    [sym_comment] = ACTIONS(42),
  },
  [1410] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(3678),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1411] = {
    [sym__expression] = STATE(1495),
    [sym_conditional_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(1495),
    [sym_pointer_expression] = STATE(1495),
    [sym_logical_expression] = STATE(1495),
    [sym_bitwise_expression] = STATE(1495),
    [sym_equality_expression] = STATE(1495),
    [sym_relational_expression] = STATE(1495),
    [sym_shift_expression] = STATE(1495),
    [sym_math_expression] = STATE(1495),
    [sym_cast_expression] = STATE(1495),
    [sym_sizeof_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_call_expression] = STATE(1495),
    [sym_field_expression] = STATE(1495),
    [sym_compound_literal_expression] = STATE(1495),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_concatenated_string] = STATE(1495),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(4016),
    [sym_char_literal] = ACTIONS(4016),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(4018),
    [sym_false] = ACTIONS(4018),
    [sym_null] = ACTIONS(4018),
    [sym_identifier] = ACTIONS(4018),
    [sym_comment] = ACTIONS(42),
  },
  [1412] = {
    [sym__expression] = STATE(1496),
    [sym_conditional_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1496),
    [sym_pointer_expression] = STATE(1496),
    [sym_logical_expression] = STATE(1496),
    [sym_bitwise_expression] = STATE(1496),
    [sym_equality_expression] = STATE(1496),
    [sym_relational_expression] = STATE(1496),
    [sym_shift_expression] = STATE(1496),
    [sym_math_expression] = STATE(1496),
    [sym_cast_expression] = STATE(1496),
    [sym_sizeof_expression] = STATE(1496),
    [sym_subscript_expression] = STATE(1496),
    [sym_call_expression] = STATE(1496),
    [sym_field_expression] = STATE(1496),
    [sym_compound_literal_expression] = STATE(1496),
    [sym_parenthesized_expression] = STATE(1496),
    [sym_concatenated_string] = STATE(1496),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(4020),
    [sym_char_literal] = ACTIONS(4020),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(4022),
    [sym_false] = ACTIONS(4022),
    [sym_null] = ACTIONS(4022),
    [sym_identifier] = ACTIONS(4022),
    [sym_comment] = ACTIONS(42),
  },
  [1413] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1737),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1743),
    [anon_sym_SLASH_EQ] = ACTIONS(1743),
    [anon_sym_PERCENT_EQ] = ACTIONS(1743),
    [anon_sym_PLUS_EQ] = ACTIONS(1743),
    [anon_sym_DASH_EQ] = ACTIONS(1743),
    [anon_sym_LT_LT_EQ] = ACTIONS(1743),
    [anon_sym_GT_GT_EQ] = ACTIONS(1743),
    [anon_sym_AMP_EQ] = ACTIONS(1743),
    [anon_sym_CARET_EQ] = ACTIONS(1743),
    [anon_sym_PIPE_EQ] = ACTIONS(1743),
    [anon_sym_AMP] = ACTIONS(1745),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_AMP_AMP] = ACTIONS(1749),
    [anon_sym_PIPE] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_GT] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1414] = {
    [sym_declaration] = STATE(1400),
    [sym_type_definition] = STATE(1400),
    [sym__declaration_specifiers] = STATE(1401),
    [sym_compound_statement] = STATE(1400),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(1400),
    [sym_expression_statement] = STATE(1400),
    [sym_if_statement] = STATE(1400),
    [sym_switch_statement] = STATE(1400),
    [sym_case_statement] = STATE(1400),
    [sym_while_statement] = STATE(1400),
    [sym_do_statement] = STATE(1400),
    [sym_for_statement] = STATE(1400),
    [sym_return_statement] = STATE(1400),
    [sym_break_statement] = STATE(1400),
    [sym_continue_statement] = STATE(1400),
    [sym_goto_statement] = STATE(1400),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_typedef] = ACTIONS(3818),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(3631),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_case] = ACTIONS(3635),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3639),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(4026),
    [sym_comment] = ACTIONS(42),
  },
  [1415] = {
    [sym__expression] = STATE(1499),
    [sym_conditional_expression] = STATE(1499),
    [sym_assignment_expression] = STATE(1499),
    [sym_pointer_expression] = STATE(1499),
    [sym_logical_expression] = STATE(1499),
    [sym_bitwise_expression] = STATE(1499),
    [sym_equality_expression] = STATE(1499),
    [sym_relational_expression] = STATE(1499),
    [sym_shift_expression] = STATE(1499),
    [sym_math_expression] = STATE(1499),
    [sym_cast_expression] = STATE(1499),
    [sym_sizeof_expression] = STATE(1499),
    [sym_subscript_expression] = STATE(1499),
    [sym_call_expression] = STATE(1499),
    [sym_field_expression] = STATE(1499),
    [sym_compound_literal_expression] = STATE(1499),
    [sym_parenthesized_expression] = STATE(1499),
    [sym_concatenated_string] = STATE(1499),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(4028),
    [sym_char_literal] = ACTIONS(4028),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(4030),
    [sym_false] = ACTIONS(4030),
    [sym_null] = ACTIONS(4030),
    [sym_identifier] = ACTIONS(4030),
    [sym_comment] = ACTIONS(42),
  },
  [1416] = {
    [sym_declaration] = STATE(1500),
    [sym__declaration_specifiers] = STATE(773),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym__expression] = STATE(1501),
    [sym_conditional_expression] = STATE(1501),
    [sym_assignment_expression] = STATE(1501),
    [sym_pointer_expression] = STATE(1501),
    [sym_logical_expression] = STATE(1501),
    [sym_bitwise_expression] = STATE(1501),
    [sym_equality_expression] = STATE(1501),
    [sym_relational_expression] = STATE(1501),
    [sym_shift_expression] = STATE(1501),
    [sym_math_expression] = STATE(1501),
    [sym_cast_expression] = STATE(1501),
    [sym_sizeof_expression] = STATE(1501),
    [sym_subscript_expression] = STATE(1501),
    [sym_call_expression] = STATE(1501),
    [sym_field_expression] = STATE(1501),
    [sym_compound_literal_expression] = STATE(1501),
    [sym_parenthesized_expression] = STATE(1501),
    [sym_concatenated_string] = STATE(1501),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(4032),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(4034),
    [sym_char_literal] = ACTIONS(4034),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(4036),
    [sym_false] = ACTIONS(4036),
    [sym_null] = ACTIONS(4036),
    [sym_identifier] = ACTIONS(1795),
    [sym_comment] = ACTIONS(42),
  },
  [1417] = {
    [sym_compound_statement] = STATE(1408),
    [sym_labeled_statement] = STATE(1408),
    [sym_expression_statement] = STATE(1408),
    [sym_if_statement] = STATE(1408),
    [sym_switch_statement] = STATE(1408),
    [sym_case_statement] = STATE(1408),
    [sym_while_statement] = STATE(1408),
    [sym_do_statement] = STATE(1408),
    [sym_for_statement] = STATE(1408),
    [sym_return_statement] = STATE(1408),
    [sym_break_statement] = STATE(1408),
    [sym_continue_statement] = STATE(1408),
    [sym_goto_statement] = STATE(1408),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3631),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_case] = ACTIONS(3635),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3639),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3643),
    [sym_comment] = ACTIONS(42),
  },
  [1418] = {
    [sym_compound_statement] = STATE(1409),
    [sym_labeled_statement] = STATE(1409),
    [sym_expression_statement] = STATE(1409),
    [sym_if_statement] = STATE(1409),
    [sym_switch_statement] = STATE(1409),
    [sym_case_statement] = STATE(1409),
    [sym_while_statement] = STATE(1409),
    [sym_do_statement] = STATE(1409),
    [sym_for_statement] = STATE(1409),
    [sym_return_statement] = STATE(1409),
    [sym_break_statement] = STATE(1409),
    [sym_continue_statement] = STATE(1409),
    [sym_goto_statement] = STATE(1409),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_default] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(1089),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1093),
    [sym_comment] = ACTIONS(42),
  },
  [1419] = {
    [sym_compound_statement] = STATE(1423),
    [sym_labeled_statement] = STATE(1423),
    [sym_expression_statement] = STATE(1423),
    [sym_if_statement] = STATE(1423),
    [sym_switch_statement] = STATE(1423),
    [sym_case_statement] = STATE(1423),
    [sym_while_statement] = STATE(1423),
    [sym_do_statement] = STATE(1423),
    [sym_for_statement] = STATE(1423),
    [sym_return_statement] = STATE(1423),
    [sym_break_statement] = STATE(1423),
    [sym_continue_statement] = STATE(1423),
    [sym_goto_statement] = STATE(1423),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_default] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(1089),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1093),
    [sym_comment] = ACTIONS(42),
  },
  [1420] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4038),
    [sym_comment] = ACTIONS(42),
  },
  [1421] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4038),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1422] = {
    [sym__expression] = STATE(1504),
    [sym_conditional_expression] = STATE(1504),
    [sym_assignment_expression] = STATE(1504),
    [sym_pointer_expression] = STATE(1504),
    [sym_logical_expression] = STATE(1504),
    [sym_bitwise_expression] = STATE(1504),
    [sym_equality_expression] = STATE(1504),
    [sym_relational_expression] = STATE(1504),
    [sym_shift_expression] = STATE(1504),
    [sym_math_expression] = STATE(1504),
    [sym_cast_expression] = STATE(1504),
    [sym_sizeof_expression] = STATE(1504),
    [sym_subscript_expression] = STATE(1504),
    [sym_call_expression] = STATE(1504),
    [sym_field_expression] = STATE(1504),
    [sym_compound_literal_expression] = STATE(1504),
    [sym_parenthesized_expression] = STATE(1504),
    [sym_concatenated_string] = STATE(1504),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(4038),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(4040),
    [sym_char_literal] = ACTIONS(4040),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(4042),
    [sym_false] = ACTIONS(4042),
    [sym_null] = ACTIONS(4042),
    [sym_identifier] = ACTIONS(4042),
    [sym_comment] = ACTIONS(42),
  },
  [1423] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4044),
    [anon_sym_LPAREN] = ACTIONS(4046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4044),
    [sym_preproc_directive] = ACTIONS(4044),
    [anon_sym_SEMI] = ACTIONS(4046),
    [anon_sym_typedef] = ACTIONS(4044),
    [anon_sym_extern] = ACTIONS(4044),
    [anon_sym_LBRACE] = ACTIONS(4046),
    [anon_sym_RBRACE] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(4046),
    [anon_sym_static] = ACTIONS(4044),
    [anon_sym_auto] = ACTIONS(4044),
    [anon_sym_register] = ACTIONS(4044),
    [anon_sym_inline] = ACTIONS(4044),
    [anon_sym_const] = ACTIONS(4044),
    [anon_sym_restrict] = ACTIONS(4044),
    [anon_sym_volatile] = ACTIONS(4044),
    [anon_sym__Atomic] = ACTIONS(4044),
    [anon_sym_unsigned] = ACTIONS(4044),
    [anon_sym_long] = ACTIONS(4044),
    [anon_sym_short] = ACTIONS(4044),
    [sym_primitive_type] = ACTIONS(4044),
    [anon_sym_enum] = ACTIONS(4044),
    [anon_sym_struct] = ACTIONS(4044),
    [anon_sym_union] = ACTIONS(4044),
    [anon_sym_if] = ACTIONS(4044),
    [anon_sym_switch] = ACTIONS(4044),
    [anon_sym_case] = ACTIONS(4044),
    [anon_sym_default] = ACTIONS(4044),
    [anon_sym_while] = ACTIONS(4044),
    [anon_sym_do] = ACTIONS(4044),
    [anon_sym_for] = ACTIONS(4044),
    [anon_sym_return] = ACTIONS(4044),
    [anon_sym_break] = ACTIONS(4044),
    [anon_sym_continue] = ACTIONS(4044),
    [anon_sym_goto] = ACTIONS(4044),
    [anon_sym_AMP] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(4046),
    [anon_sym_TILDE] = ACTIONS(4046),
    [anon_sym_PLUS] = ACTIONS(4044),
    [anon_sym_DASH] = ACTIONS(4044),
    [anon_sym_DASH_DASH] = ACTIONS(4046),
    [anon_sym_PLUS_PLUS] = ACTIONS(4046),
    [anon_sym_sizeof] = ACTIONS(4044),
    [sym_number_literal] = ACTIONS(4046),
    [sym_char_literal] = ACTIONS(4046),
    [sym_string_literal] = ACTIONS(4046),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [sym_null] = ACTIONS(4044),
    [sym_identifier] = ACTIONS(4044),
    [sym_comment] = ACTIONS(42),
  },
  [1424] = {
    [sym_compound_statement] = STATE(1505),
    [sym_labeled_statement] = STATE(1505),
    [sym_expression_statement] = STATE(1505),
    [sym_if_statement] = STATE(1505),
    [sym_switch_statement] = STATE(1505),
    [sym_case_statement] = STATE(1505),
    [sym_while_statement] = STATE(1505),
    [sym_do_statement] = STATE(1505),
    [sym_for_statement] = STATE(1505),
    [sym_return_statement] = STATE(1505),
    [sym_break_statement] = STATE(1505),
    [sym_continue_statement] = STATE(1505),
    [sym_goto_statement] = STATE(1505),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1835),
    [sym_comment] = ACTIONS(42),
  },
  [1425] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4048),
    [sym_comment] = ACTIONS(42),
  },
  [1426] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1507),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4048),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1427] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1295),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1295),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1295),
    [sym_preproc_directive] = ACTIONS(1295),
    [anon_sym_SEMI] = ACTIONS(1293),
    [anon_sym_typedef] = ACTIONS(1295),
    [anon_sym_extern] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_STAR] = ACTIONS(1293),
    [anon_sym_static] = ACTIONS(1295),
    [anon_sym_auto] = ACTIONS(1295),
    [anon_sym_register] = ACTIONS(1295),
    [anon_sym_inline] = ACTIONS(1295),
    [anon_sym_const] = ACTIONS(1295),
    [anon_sym_restrict] = ACTIONS(1295),
    [anon_sym_volatile] = ACTIONS(1295),
    [anon_sym__Atomic] = ACTIONS(1295),
    [anon_sym_unsigned] = ACTIONS(1295),
    [anon_sym_long] = ACTIONS(1295),
    [anon_sym_short] = ACTIONS(1295),
    [sym_primitive_type] = ACTIONS(1295),
    [anon_sym_enum] = ACTIONS(1295),
    [anon_sym_struct] = ACTIONS(1295),
    [anon_sym_union] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(1295),
    [anon_sym_switch] = ACTIONS(1295),
    [anon_sym_case] = ACTIONS(1295),
    [anon_sym_default] = ACTIONS(1295),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_do] = ACTIONS(1295),
    [anon_sym_for] = ACTIONS(1295),
    [anon_sym_return] = ACTIONS(1295),
    [anon_sym_break] = ACTIONS(1295),
    [anon_sym_continue] = ACTIONS(1295),
    [anon_sym_goto] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1295),
    [anon_sym_DASH] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1293),
    [anon_sym_sizeof] = ACTIONS(1295),
    [sym_number_literal] = ACTIONS(1293),
    [sym_char_literal] = ACTIONS(1293),
    [sym_string_literal] = ACTIONS(1293),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_null] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_comment] = ACTIONS(42),
  },
  [1428] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1305),
    [anon_sym_LPAREN] = ACTIONS(1303),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1305),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1305),
    [sym_preproc_directive] = ACTIONS(1305),
    [anon_sym_SEMI] = ACTIONS(1303),
    [anon_sym_typedef] = ACTIONS(1305),
    [anon_sym_extern] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1303),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_static] = ACTIONS(1305),
    [anon_sym_auto] = ACTIONS(1305),
    [anon_sym_register] = ACTIONS(1305),
    [anon_sym_inline] = ACTIONS(1305),
    [anon_sym_const] = ACTIONS(1305),
    [anon_sym_restrict] = ACTIONS(1305),
    [anon_sym_volatile] = ACTIONS(1305),
    [anon_sym__Atomic] = ACTIONS(1305),
    [anon_sym_unsigned] = ACTIONS(1305),
    [anon_sym_long] = ACTIONS(1305),
    [anon_sym_short] = ACTIONS(1305),
    [sym_primitive_type] = ACTIONS(1305),
    [anon_sym_enum] = ACTIONS(1305),
    [anon_sym_struct] = ACTIONS(1305),
    [anon_sym_union] = ACTIONS(1305),
    [anon_sym_if] = ACTIONS(1305),
    [anon_sym_switch] = ACTIONS(1305),
    [anon_sym_case] = ACTIONS(1305),
    [anon_sym_default] = ACTIONS(1305),
    [anon_sym_while] = ACTIONS(1305),
    [anon_sym_do] = ACTIONS(1305),
    [anon_sym_for] = ACTIONS(1305),
    [anon_sym_return] = ACTIONS(1305),
    [anon_sym_break] = ACTIONS(1305),
    [anon_sym_continue] = ACTIONS(1305),
    [anon_sym_goto] = ACTIONS(1305),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_BANG] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1303),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_DASH] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1303),
    [anon_sym_PLUS_PLUS] = ACTIONS(1303),
    [anon_sym_sizeof] = ACTIONS(1305),
    [sym_number_literal] = ACTIONS(1303),
    [sym_char_literal] = ACTIONS(1303),
    [sym_string_literal] = ACTIONS(1303),
    [sym_true] = ACTIONS(1305),
    [sym_false] = ACTIONS(1305),
    [sym_null] = ACTIONS(1305),
    [sym_identifier] = ACTIONS(1305),
    [sym_comment] = ACTIONS(42),
  },
  [1429] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3546),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3546),
    [anon_sym_LPAREN] = ACTIONS(3548),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3546),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3546),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3546),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3546),
    [sym_preproc_directive] = ACTIONS(3546),
    [anon_sym_SEMI] = ACTIONS(3548),
    [anon_sym_typedef] = ACTIONS(3546),
    [anon_sym_extern] = ACTIONS(3546),
    [anon_sym_LBRACE] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3548),
    [anon_sym_static] = ACTIONS(3546),
    [anon_sym_auto] = ACTIONS(3546),
    [anon_sym_register] = ACTIONS(3546),
    [anon_sym_inline] = ACTIONS(3546),
    [anon_sym_const] = ACTIONS(3546),
    [anon_sym_restrict] = ACTIONS(3546),
    [anon_sym_volatile] = ACTIONS(3546),
    [anon_sym__Atomic] = ACTIONS(3546),
    [anon_sym_unsigned] = ACTIONS(3546),
    [anon_sym_long] = ACTIONS(3546),
    [anon_sym_short] = ACTIONS(3546),
    [sym_primitive_type] = ACTIONS(3546),
    [anon_sym_enum] = ACTIONS(3546),
    [anon_sym_struct] = ACTIONS(3546),
    [anon_sym_union] = ACTIONS(3546),
    [anon_sym_if] = ACTIONS(3546),
    [anon_sym_switch] = ACTIONS(3546),
    [anon_sym_case] = ACTIONS(3546),
    [anon_sym_default] = ACTIONS(3546),
    [anon_sym_while] = ACTIONS(3546),
    [anon_sym_do] = ACTIONS(3546),
    [anon_sym_for] = ACTIONS(3546),
    [anon_sym_return] = ACTIONS(3546),
    [anon_sym_break] = ACTIONS(3546),
    [anon_sym_continue] = ACTIONS(3546),
    [anon_sym_goto] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_BANG] = ACTIONS(3548),
    [anon_sym_TILDE] = ACTIONS(3548),
    [anon_sym_PLUS] = ACTIONS(3546),
    [anon_sym_DASH] = ACTIONS(3546),
    [anon_sym_DASH_DASH] = ACTIONS(3548),
    [anon_sym_PLUS_PLUS] = ACTIONS(3548),
    [anon_sym_sizeof] = ACTIONS(3546),
    [sym_number_literal] = ACTIONS(3548),
    [sym_char_literal] = ACTIONS(3548),
    [sym_string_literal] = ACTIONS(3548),
    [sym_true] = ACTIONS(3546),
    [sym_false] = ACTIONS(3546),
    [sym_null] = ACTIONS(3546),
    [sym_identifier] = ACTIONS(3546),
    [sym_comment] = ACTIONS(42),
  },
  [1430] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3550),
    [anon_sym_LPAREN] = ACTIONS(3552),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3550),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3550),
    [sym_preproc_directive] = ACTIONS(3550),
    [anon_sym_SEMI] = ACTIONS(3552),
    [anon_sym_typedef] = ACTIONS(3550),
    [anon_sym_extern] = ACTIONS(3550),
    [anon_sym_LBRACE] = ACTIONS(3552),
    [anon_sym_STAR] = ACTIONS(3552),
    [anon_sym_static] = ACTIONS(3550),
    [anon_sym_auto] = ACTIONS(3550),
    [anon_sym_register] = ACTIONS(3550),
    [anon_sym_inline] = ACTIONS(3550),
    [anon_sym_const] = ACTIONS(3550),
    [anon_sym_restrict] = ACTIONS(3550),
    [anon_sym_volatile] = ACTIONS(3550),
    [anon_sym__Atomic] = ACTIONS(3550),
    [anon_sym_unsigned] = ACTIONS(3550),
    [anon_sym_long] = ACTIONS(3550),
    [anon_sym_short] = ACTIONS(3550),
    [sym_primitive_type] = ACTIONS(3550),
    [anon_sym_enum] = ACTIONS(3550),
    [anon_sym_struct] = ACTIONS(3550),
    [anon_sym_union] = ACTIONS(3550),
    [anon_sym_if] = ACTIONS(3550),
    [anon_sym_switch] = ACTIONS(3550),
    [anon_sym_case] = ACTIONS(3550),
    [anon_sym_default] = ACTIONS(3550),
    [anon_sym_while] = ACTIONS(3550),
    [anon_sym_do] = ACTIONS(3550),
    [anon_sym_for] = ACTIONS(3550),
    [anon_sym_return] = ACTIONS(3550),
    [anon_sym_break] = ACTIONS(3550),
    [anon_sym_continue] = ACTIONS(3550),
    [anon_sym_goto] = ACTIONS(3550),
    [anon_sym_AMP] = ACTIONS(3552),
    [anon_sym_BANG] = ACTIONS(3552),
    [anon_sym_TILDE] = ACTIONS(3552),
    [anon_sym_PLUS] = ACTIONS(3550),
    [anon_sym_DASH] = ACTIONS(3550),
    [anon_sym_DASH_DASH] = ACTIONS(3552),
    [anon_sym_PLUS_PLUS] = ACTIONS(3552),
    [anon_sym_sizeof] = ACTIONS(3550),
    [sym_number_literal] = ACTIONS(3552),
    [sym_char_literal] = ACTIONS(3552),
    [sym_string_literal] = ACTIONS(3552),
    [sym_true] = ACTIONS(3550),
    [sym_false] = ACTIONS(3550),
    [sym_null] = ACTIONS(3550),
    [sym_identifier] = ACTIONS(3550),
    [sym_comment] = ACTIONS(42),
  },
  [1431] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3554),
    [anon_sym_LPAREN] = ACTIONS(3556),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3554),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3554),
    [sym_preproc_directive] = ACTIONS(3554),
    [anon_sym_SEMI] = ACTIONS(3556),
    [anon_sym_typedef] = ACTIONS(3554),
    [anon_sym_extern] = ACTIONS(3554),
    [anon_sym_LBRACE] = ACTIONS(3556),
    [anon_sym_STAR] = ACTIONS(3556),
    [anon_sym_static] = ACTIONS(3554),
    [anon_sym_auto] = ACTIONS(3554),
    [anon_sym_register] = ACTIONS(3554),
    [anon_sym_inline] = ACTIONS(3554),
    [anon_sym_const] = ACTIONS(3554),
    [anon_sym_restrict] = ACTIONS(3554),
    [anon_sym_volatile] = ACTIONS(3554),
    [anon_sym__Atomic] = ACTIONS(3554),
    [anon_sym_unsigned] = ACTIONS(3554),
    [anon_sym_long] = ACTIONS(3554),
    [anon_sym_short] = ACTIONS(3554),
    [sym_primitive_type] = ACTIONS(3554),
    [anon_sym_enum] = ACTIONS(3554),
    [anon_sym_struct] = ACTIONS(3554),
    [anon_sym_union] = ACTIONS(3554),
    [anon_sym_if] = ACTIONS(3554),
    [anon_sym_switch] = ACTIONS(3554),
    [anon_sym_case] = ACTIONS(3554),
    [anon_sym_default] = ACTIONS(3554),
    [anon_sym_while] = ACTIONS(3554),
    [anon_sym_do] = ACTIONS(3554),
    [anon_sym_for] = ACTIONS(3554),
    [anon_sym_return] = ACTIONS(3554),
    [anon_sym_break] = ACTIONS(3554),
    [anon_sym_continue] = ACTIONS(3554),
    [anon_sym_goto] = ACTIONS(3554),
    [anon_sym_AMP] = ACTIONS(3556),
    [anon_sym_BANG] = ACTIONS(3556),
    [anon_sym_TILDE] = ACTIONS(3556),
    [anon_sym_PLUS] = ACTIONS(3554),
    [anon_sym_DASH] = ACTIONS(3554),
    [anon_sym_DASH_DASH] = ACTIONS(3556),
    [anon_sym_PLUS_PLUS] = ACTIONS(3556),
    [anon_sym_sizeof] = ACTIONS(3554),
    [sym_number_literal] = ACTIONS(3556),
    [sym_char_literal] = ACTIONS(3556),
    [sym_string_literal] = ACTIONS(3556),
    [sym_true] = ACTIONS(3554),
    [sym_false] = ACTIONS(3554),
    [sym_null] = ACTIONS(3554),
    [sym_identifier] = ACTIONS(3554),
    [sym_comment] = ACTIONS(42),
  },
  [1432] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3558),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3558),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3558),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3558),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3558),
    [sym_preproc_directive] = ACTIONS(3558),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym_typedef] = ACTIONS(3558),
    [anon_sym_extern] = ACTIONS(3558),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_static] = ACTIONS(3558),
    [anon_sym_auto] = ACTIONS(3558),
    [anon_sym_register] = ACTIONS(3558),
    [anon_sym_inline] = ACTIONS(3558),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_restrict] = ACTIONS(3558),
    [anon_sym_volatile] = ACTIONS(3558),
    [anon_sym__Atomic] = ACTIONS(3558),
    [anon_sym_unsigned] = ACTIONS(3558),
    [anon_sym_long] = ACTIONS(3558),
    [anon_sym_short] = ACTIONS(3558),
    [sym_primitive_type] = ACTIONS(3558),
    [anon_sym_enum] = ACTIONS(3558),
    [anon_sym_struct] = ACTIONS(3558),
    [anon_sym_union] = ACTIONS(3558),
    [anon_sym_if] = ACTIONS(3558),
    [anon_sym_switch] = ACTIONS(3558),
    [anon_sym_case] = ACTIONS(3558),
    [anon_sym_default] = ACTIONS(3558),
    [anon_sym_while] = ACTIONS(3558),
    [anon_sym_do] = ACTIONS(3558),
    [anon_sym_for] = ACTIONS(3558),
    [anon_sym_return] = ACTIONS(3558),
    [anon_sym_break] = ACTIONS(3558),
    [anon_sym_continue] = ACTIONS(3558),
    [anon_sym_goto] = ACTIONS(3558),
    [anon_sym_AMP] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_PLUS] = ACTIONS(3558),
    [anon_sym_DASH] = ACTIONS(3558),
    [anon_sym_DASH_DASH] = ACTIONS(3560),
    [anon_sym_PLUS_PLUS] = ACTIONS(3560),
    [anon_sym_sizeof] = ACTIONS(3558),
    [sym_number_literal] = ACTIONS(3560),
    [sym_char_literal] = ACTIONS(3560),
    [sym_string_literal] = ACTIONS(3560),
    [sym_true] = ACTIONS(3558),
    [sym_false] = ACTIONS(3558),
    [sym_null] = ACTIONS(3558),
    [sym_identifier] = ACTIONS(3558),
    [sym_comment] = ACTIONS(42),
  },
  [1433] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3562),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(3564),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3562),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3562),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3562),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3564),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym_LBRACE] = ACTIONS(3564),
    [anon_sym_STAR] = ACTIONS(3564),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_auto] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_switch] = ACTIONS(3562),
    [anon_sym_case] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_goto] = ACTIONS(3562),
    [anon_sym_AMP] = ACTIONS(3564),
    [anon_sym_BANG] = ACTIONS(3564),
    [anon_sym_TILDE] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_DASH_DASH] = ACTIONS(3564),
    [anon_sym_PLUS_PLUS] = ACTIONS(3564),
    [anon_sym_sizeof] = ACTIONS(3562),
    [sym_number_literal] = ACTIONS(3564),
    [sym_char_literal] = ACTIONS(3564),
    [sym_string_literal] = ACTIONS(3564),
    [sym_true] = ACTIONS(3562),
    [sym_false] = ACTIONS(3562),
    [sym_null] = ACTIONS(3562),
    [sym_identifier] = ACTIONS(3562),
    [sym_comment] = ACTIONS(42),
  },
  [1434] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3566),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3566),
    [anon_sym_LPAREN] = ACTIONS(3568),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3566),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3566),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3566),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3566),
    [sym_preproc_directive] = ACTIONS(3566),
    [anon_sym_SEMI] = ACTIONS(3568),
    [anon_sym_typedef] = ACTIONS(3566),
    [anon_sym_extern] = ACTIONS(3566),
    [anon_sym_LBRACE] = ACTIONS(3568),
    [anon_sym_STAR] = ACTIONS(3568),
    [anon_sym_static] = ACTIONS(3566),
    [anon_sym_auto] = ACTIONS(3566),
    [anon_sym_register] = ACTIONS(3566),
    [anon_sym_inline] = ACTIONS(3566),
    [anon_sym_const] = ACTIONS(3566),
    [anon_sym_restrict] = ACTIONS(3566),
    [anon_sym_volatile] = ACTIONS(3566),
    [anon_sym__Atomic] = ACTIONS(3566),
    [anon_sym_unsigned] = ACTIONS(3566),
    [anon_sym_long] = ACTIONS(3566),
    [anon_sym_short] = ACTIONS(3566),
    [sym_primitive_type] = ACTIONS(3566),
    [anon_sym_enum] = ACTIONS(3566),
    [anon_sym_struct] = ACTIONS(3566),
    [anon_sym_union] = ACTIONS(3566),
    [anon_sym_if] = ACTIONS(3566),
    [anon_sym_switch] = ACTIONS(3566),
    [anon_sym_case] = ACTIONS(3566),
    [anon_sym_default] = ACTIONS(3566),
    [anon_sym_while] = ACTIONS(3566),
    [anon_sym_do] = ACTIONS(3566),
    [anon_sym_for] = ACTIONS(3566),
    [anon_sym_return] = ACTIONS(3566),
    [anon_sym_break] = ACTIONS(3566),
    [anon_sym_continue] = ACTIONS(3566),
    [anon_sym_goto] = ACTIONS(3566),
    [anon_sym_AMP] = ACTIONS(3568),
    [anon_sym_BANG] = ACTIONS(3568),
    [anon_sym_TILDE] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3566),
    [anon_sym_DASH] = ACTIONS(3566),
    [anon_sym_DASH_DASH] = ACTIONS(3568),
    [anon_sym_PLUS_PLUS] = ACTIONS(3568),
    [anon_sym_sizeof] = ACTIONS(3566),
    [sym_number_literal] = ACTIONS(3568),
    [sym_char_literal] = ACTIONS(3568),
    [sym_string_literal] = ACTIONS(3568),
    [sym_true] = ACTIONS(3566),
    [sym_false] = ACTIONS(3566),
    [sym_null] = ACTIONS(3566),
    [sym_identifier] = ACTIONS(3566),
    [sym_comment] = ACTIONS(42),
  },
  [1435] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1409),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1411),
    [sym_preproc_directive] = ACTIONS(1411),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_typedef] = ACTIONS(1411),
    [anon_sym_extern] = ACTIONS(1411),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_static] = ACTIONS(1411),
    [anon_sym_auto] = ACTIONS(1411),
    [anon_sym_register] = ACTIONS(1411),
    [anon_sym_inline] = ACTIONS(1411),
    [anon_sym_const] = ACTIONS(1411),
    [anon_sym_restrict] = ACTIONS(1411),
    [anon_sym_volatile] = ACTIONS(1411),
    [anon_sym__Atomic] = ACTIONS(1411),
    [anon_sym_unsigned] = ACTIONS(1411),
    [anon_sym_long] = ACTIONS(1411),
    [anon_sym_short] = ACTIONS(1411),
    [sym_primitive_type] = ACTIONS(1411),
    [anon_sym_enum] = ACTIONS(1411),
    [anon_sym_struct] = ACTIONS(1411),
    [anon_sym_union] = ACTIONS(1411),
    [anon_sym_if] = ACTIONS(1411),
    [anon_sym_switch] = ACTIONS(1411),
    [anon_sym_case] = ACTIONS(1411),
    [anon_sym_default] = ACTIONS(1411),
    [anon_sym_while] = ACTIONS(1411),
    [anon_sym_do] = ACTIONS(1411),
    [anon_sym_for] = ACTIONS(1411),
    [anon_sym_return] = ACTIONS(1411),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_continue] = ACTIONS(1411),
    [anon_sym_goto] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1411),
    [anon_sym_DASH] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1409),
    [anon_sym_sizeof] = ACTIONS(1411),
    [sym_number_literal] = ACTIONS(1409),
    [sym_char_literal] = ACTIONS(1409),
    [sym_string_literal] = ACTIONS(1409),
    [sym_true] = ACTIONS(1411),
    [sym_false] = ACTIONS(1411),
    [sym_null] = ACTIONS(1411),
    [sym_identifier] = ACTIONS(1411),
    [sym_comment] = ACTIONS(42),
  },
  [1436] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1037),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1037),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1037),
    [sym_preproc_directive] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_typedef] = ACTIONS(1037),
    [anon_sym_extern] = ACTIONS(1037),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_STAR] = ACTIONS(1039),
    [anon_sym_static] = ACTIONS(1037),
    [anon_sym_auto] = ACTIONS(1037),
    [anon_sym_register] = ACTIONS(1037),
    [anon_sym_inline] = ACTIONS(1037),
    [anon_sym_const] = ACTIONS(1037),
    [anon_sym_restrict] = ACTIONS(1037),
    [anon_sym_volatile] = ACTIONS(1037),
    [anon_sym__Atomic] = ACTIONS(1037),
    [anon_sym_unsigned] = ACTIONS(1037),
    [anon_sym_long] = ACTIONS(1037),
    [anon_sym_short] = ACTIONS(1037),
    [sym_primitive_type] = ACTIONS(1037),
    [anon_sym_enum] = ACTIONS(1037),
    [anon_sym_struct] = ACTIONS(1037),
    [anon_sym_union] = ACTIONS(1037),
    [anon_sym_if] = ACTIONS(1037),
    [anon_sym_else] = ACTIONS(1037),
    [anon_sym_switch] = ACTIONS(1037),
    [anon_sym_case] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1037),
    [anon_sym_do] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1037),
    [anon_sym_return] = ACTIONS(1037),
    [anon_sym_break] = ACTIONS(1037),
    [anon_sym_continue] = ACTIONS(1037),
    [anon_sym_goto] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_TILDE] = ACTIONS(1039),
    [anon_sym_PLUS] = ACTIONS(1037),
    [anon_sym_DASH] = ACTIONS(1037),
    [anon_sym_DASH_DASH] = ACTIONS(1039),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_sizeof] = ACTIONS(1037),
    [sym_number_literal] = ACTIONS(1039),
    [sym_char_literal] = ACTIONS(1039),
    [sym_string_literal] = ACTIONS(1039),
    [sym_true] = ACTIONS(1037),
    [sym_false] = ACTIONS(1037),
    [sym_null] = ACTIONS(1037),
    [sym_identifier] = ACTIONS(1037),
    [sym_comment] = ACTIONS(42),
  },
  [1437] = {
    [sym_preproc_include] = STATE(1509),
    [sym_preproc_def] = STATE(1509),
    [sym_preproc_function_def] = STATE(1509),
    [sym_preproc_call] = STATE(1509),
    [sym_preproc_if_in_compound_statement] = STATE(275),
    [sym_preproc_ifdef_in_compound_statement] = STATE(276),
    [sym_declaration] = STATE(1509),
    [sym_type_definition] = STATE(1509),
    [sym__declaration_specifiers] = STATE(277),
    [sym_compound_statement] = STATE(1509),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(1509),
    [sym_expression_statement] = STATE(1509),
    [sym_if_statement] = STATE(1509),
    [sym_switch_statement] = STATE(1509),
    [sym_case_statement] = STATE(1509),
    [sym_while_statement] = STATE(1509),
    [sym_do_statement] = STATE(1509),
    [sym_for_statement] = STATE(1509),
    [sym_return_statement] = STATE(1509),
    [sym_break_statement] = STATE(1509),
    [sym_continue_statement] = STATE(1509),
    [sym_goto_statement] = STATE(1509),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [sym__empty_declaration] = STATE(1509),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(1509),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(577),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(579),
    [sym_preproc_directive] = ACTIONS(581),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_typedef] = ACTIONS(585),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_RBRACE] = ACTIONS(4050),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(631),
    [sym_comment] = ACTIONS(42),
  },
  [1438] = {
    [anon_sym_LPAREN] = ACTIONS(4052),
    [sym_comment] = ACTIONS(42),
  },
  [1439] = {
    [anon_sym_LPAREN] = ACTIONS(4054),
    [sym_comment] = ACTIONS(42),
  },
  [1440] = {
    [sym__expression] = STATE(1512),
    [sym_conditional_expression] = STATE(1512),
    [sym_assignment_expression] = STATE(1512),
    [sym_pointer_expression] = STATE(1512),
    [sym_logical_expression] = STATE(1512),
    [sym_bitwise_expression] = STATE(1512),
    [sym_equality_expression] = STATE(1512),
    [sym_relational_expression] = STATE(1512),
    [sym_shift_expression] = STATE(1512),
    [sym_math_expression] = STATE(1512),
    [sym_cast_expression] = STATE(1512),
    [sym_sizeof_expression] = STATE(1512),
    [sym_subscript_expression] = STATE(1512),
    [sym_call_expression] = STATE(1512),
    [sym_field_expression] = STATE(1512),
    [sym_compound_literal_expression] = STATE(1512),
    [sym_parenthesized_expression] = STATE(1512),
    [sym_concatenated_string] = STATE(1512),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_sizeof] = ACTIONS(1069),
    [sym_number_literal] = ACTIONS(4056),
    [sym_char_literal] = ACTIONS(4056),
    [sym_string_literal] = ACTIONS(1073),
    [sym_true] = ACTIONS(4058),
    [sym_false] = ACTIONS(4058),
    [sym_null] = ACTIONS(4058),
    [sym_identifier] = ACTIONS(4058),
    [sym_comment] = ACTIONS(42),
  },
  [1441] = {
    [anon_sym_COLON] = ACTIONS(4060),
    [sym_comment] = ACTIONS(42),
  },
  [1442] = {
    [anon_sym_LPAREN] = ACTIONS(4062),
    [sym_comment] = ACTIONS(42),
  },
  [1443] = {
    [sym_compound_statement] = STATE(1515),
    [sym_labeled_statement] = STATE(1515),
    [sym_expression_statement] = STATE(1515),
    [sym_if_statement] = STATE(1515),
    [sym_switch_statement] = STATE(1515),
    [sym_case_statement] = STATE(1515),
    [sym_while_statement] = STATE(1515),
    [sym_do_statement] = STATE(1515),
    [sym_for_statement] = STATE(1515),
    [sym_return_statement] = STATE(1515),
    [sym_break_statement] = STATE(1515),
    [sym_continue_statement] = STATE(1515),
    [sym_goto_statement] = STATE(1515),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_default] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(1089),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1093),
    [sym_comment] = ACTIONS(42),
  },
  [1444] = {
    [anon_sym_LPAREN] = ACTIONS(4064),
    [sym_comment] = ACTIONS(42),
  },
  [1445] = {
    [sym__expression] = STATE(1518),
    [sym_conditional_expression] = STATE(1518),
    [sym_assignment_expression] = STATE(1518),
    [sym_pointer_expression] = STATE(1518),
    [sym_logical_expression] = STATE(1518),
    [sym_bitwise_expression] = STATE(1518),
    [sym_equality_expression] = STATE(1518),
    [sym_relational_expression] = STATE(1518),
    [sym_shift_expression] = STATE(1518),
    [sym_math_expression] = STATE(1518),
    [sym_cast_expression] = STATE(1518),
    [sym_sizeof_expression] = STATE(1518),
    [sym_subscript_expression] = STATE(1518),
    [sym_call_expression] = STATE(1518),
    [sym_field_expression] = STATE(1518),
    [sym_compound_literal_expression] = STATE(1518),
    [sym_parenthesized_expression] = STATE(1518),
    [sym_concatenated_string] = STATE(1518),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(4066),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(4068),
    [sym_char_literal] = ACTIONS(4068),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(4070),
    [sym_false] = ACTIONS(4070),
    [sym_null] = ACTIONS(4070),
    [sym_identifier] = ACTIONS(4070),
    [sym_comment] = ACTIONS(42),
  },
  [1446] = {
    [anon_sym_SEMI] = ACTIONS(4072),
    [sym_comment] = ACTIONS(42),
  },
  [1447] = {
    [anon_sym_SEMI] = ACTIONS(4074),
    [sym_comment] = ACTIONS(42),
  },
  [1448] = {
    [sym_identifier] = ACTIONS(4076),
    [sym_comment] = ACTIONS(42),
  },
  [1449] = {
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_COLON] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_comment] = ACTIONS(42),
  },
  [1450] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3605),
    [anon_sym_LPAREN] = ACTIONS(3607),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3605),
    [sym_preproc_directive] = ACTIONS(3605),
    [anon_sym_SEMI] = ACTIONS(3607),
    [anon_sym_typedef] = ACTIONS(3605),
    [anon_sym_extern] = ACTIONS(3605),
    [anon_sym_LBRACE] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(3607),
    [anon_sym_static] = ACTIONS(3605),
    [anon_sym_auto] = ACTIONS(3605),
    [anon_sym_register] = ACTIONS(3605),
    [anon_sym_inline] = ACTIONS(3605),
    [anon_sym_const] = ACTIONS(3605),
    [anon_sym_restrict] = ACTIONS(3605),
    [anon_sym_volatile] = ACTIONS(3605),
    [anon_sym__Atomic] = ACTIONS(3605),
    [anon_sym_unsigned] = ACTIONS(3605),
    [anon_sym_long] = ACTIONS(3605),
    [anon_sym_short] = ACTIONS(3605),
    [sym_primitive_type] = ACTIONS(3605),
    [anon_sym_enum] = ACTIONS(3605),
    [anon_sym_struct] = ACTIONS(3605),
    [anon_sym_union] = ACTIONS(3605),
    [anon_sym_if] = ACTIONS(3605),
    [anon_sym_else] = ACTIONS(4080),
    [anon_sym_switch] = ACTIONS(3605),
    [anon_sym_case] = ACTIONS(3605),
    [anon_sym_default] = ACTIONS(3605),
    [anon_sym_while] = ACTIONS(3605),
    [anon_sym_do] = ACTIONS(3605),
    [anon_sym_for] = ACTIONS(3605),
    [anon_sym_return] = ACTIONS(3605),
    [anon_sym_break] = ACTIONS(3605),
    [anon_sym_continue] = ACTIONS(3605),
    [anon_sym_goto] = ACTIONS(3605),
    [anon_sym_AMP] = ACTIONS(3607),
    [anon_sym_BANG] = ACTIONS(3607),
    [anon_sym_TILDE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3605),
    [anon_sym_DASH] = ACTIONS(3605),
    [anon_sym_DASH_DASH] = ACTIONS(3607),
    [anon_sym_PLUS_PLUS] = ACTIONS(3607),
    [anon_sym_sizeof] = ACTIONS(3605),
    [sym_number_literal] = ACTIONS(3607),
    [sym_char_literal] = ACTIONS(3607),
    [sym_string_literal] = ACTIONS(3607),
    [sym_true] = ACTIONS(3605),
    [sym_false] = ACTIONS(3605),
    [sym_null] = ACTIONS(3605),
    [sym_identifier] = ACTIONS(3605),
    [sym_comment] = ACTIONS(42),
  },
  [1451] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_SEMI] = ACTIONS(4082),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_STAR_EQ] = ACTIONS(1171),
    [anon_sym_SLASH_EQ] = ACTIONS(1171),
    [anon_sym_PERCENT_EQ] = ACTIONS(1171),
    [anon_sym_PLUS_EQ] = ACTIONS(1171),
    [anon_sym_DASH_EQ] = ACTIONS(1171),
    [anon_sym_LT_LT_EQ] = ACTIONS(1171),
    [anon_sym_GT_GT_EQ] = ACTIONS(1171),
    [anon_sym_AMP_EQ] = ACTIONS(1171),
    [anon_sym_CARET_EQ] = ACTIONS(1171),
    [anon_sym_PIPE_EQ] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_PIPE_PIPE] = ACTIONS(1175),
    [anon_sym_AMP_AMP] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_LT] = ACTIONS(1185),
    [anon_sym_GT] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1187),
    [anon_sym_GT_EQ] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1189),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1452] = {
    [anon_sym_SEMI] = ACTIONS(4082),
    [sym_comment] = ACTIONS(42),
  },
  [1453] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3615),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3615),
    [sym_preproc_directive] = ACTIONS(3615),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_typedef] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_STAR] = ACTIONS(3617),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_auto] = ACTIONS(3615),
    [anon_sym_register] = ACTIONS(3615),
    [anon_sym_inline] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_restrict] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym__Atomic] = ACTIONS(3615),
    [anon_sym_unsigned] = ACTIONS(3615),
    [anon_sym_long] = ACTIONS(3615),
    [anon_sym_short] = ACTIONS(3615),
    [sym_primitive_type] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_union] = ACTIONS(3615),
    [anon_sym_if] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3615),
    [anon_sym_case] = ACTIONS(3615),
    [anon_sym_default] = ACTIONS(3615),
    [anon_sym_while] = ACTIONS(3615),
    [anon_sym_do] = ACTIONS(3615),
    [anon_sym_for] = ACTIONS(3615),
    [anon_sym_return] = ACTIONS(3615),
    [anon_sym_break] = ACTIONS(3615),
    [anon_sym_continue] = ACTIONS(3615),
    [anon_sym_goto] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_DASH_DASH] = ACTIONS(3617),
    [anon_sym_PLUS_PLUS] = ACTIONS(3617),
    [anon_sym_sizeof] = ACTIONS(3615),
    [sym_number_literal] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [sym_string_literal] = ACTIONS(3617),
    [sym_true] = ACTIONS(3615),
    [sym_false] = ACTIONS(3615),
    [sym_null] = ACTIONS(3615),
    [sym_identifier] = ACTIONS(3615),
    [sym_comment] = ACTIONS(42),
  },
  [1454] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3627),
    [sym_preproc_directive] = ACTIONS(3627),
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym_typedef] = ACTIONS(3627),
    [anon_sym_extern] = ACTIONS(3627),
    [anon_sym_LBRACE] = ACTIONS(3629),
    [anon_sym_STAR] = ACTIONS(3629),
    [anon_sym_static] = ACTIONS(3627),
    [anon_sym_auto] = ACTIONS(3627),
    [anon_sym_register] = ACTIONS(3627),
    [anon_sym_inline] = ACTIONS(3627),
    [anon_sym_const] = ACTIONS(3627),
    [anon_sym_restrict] = ACTIONS(3627),
    [anon_sym_volatile] = ACTIONS(3627),
    [anon_sym__Atomic] = ACTIONS(3627),
    [anon_sym_unsigned] = ACTIONS(3627),
    [anon_sym_long] = ACTIONS(3627),
    [anon_sym_short] = ACTIONS(3627),
    [sym_primitive_type] = ACTIONS(3627),
    [anon_sym_enum] = ACTIONS(3627),
    [anon_sym_struct] = ACTIONS(3627),
    [anon_sym_union] = ACTIONS(3627),
    [anon_sym_if] = ACTIONS(3627),
    [anon_sym_switch] = ACTIONS(3627),
    [anon_sym_case] = ACTIONS(3627),
    [anon_sym_default] = ACTIONS(3627),
    [anon_sym_while] = ACTIONS(3627),
    [anon_sym_do] = ACTIONS(3627),
    [anon_sym_for] = ACTIONS(3627),
    [anon_sym_return] = ACTIONS(3627),
    [anon_sym_break] = ACTIONS(3627),
    [anon_sym_continue] = ACTIONS(3627),
    [anon_sym_goto] = ACTIONS(3627),
    [anon_sym_AMP] = ACTIONS(3629),
    [anon_sym_BANG] = ACTIONS(3629),
    [anon_sym_TILDE] = ACTIONS(3629),
    [anon_sym_PLUS] = ACTIONS(3627),
    [anon_sym_DASH] = ACTIONS(3627),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_sizeof] = ACTIONS(3627),
    [sym_number_literal] = ACTIONS(3629),
    [sym_char_literal] = ACTIONS(3629),
    [sym_string_literal] = ACTIONS(3629),
    [sym_true] = ACTIONS(3627),
    [sym_false] = ACTIONS(3627),
    [sym_null] = ACTIONS(3627),
    [sym_identifier] = ACTIONS(3627),
    [sym_comment] = ACTIONS(42),
  },
  [1455] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(4084),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1456] = {
    [sym_compound_statement] = STATE(1526),
    [sym_labeled_statement] = STATE(1526),
    [sym_expression_statement] = STATE(1526),
    [sym_if_statement] = STATE(1526),
    [sym_switch_statement] = STATE(1526),
    [sym_case_statement] = STATE(1526),
    [sym_while_statement] = STATE(1526),
    [sym_do_statement] = STATE(1526),
    [sym_for_statement] = STATE(1526),
    [sym_return_statement] = STATE(1526),
    [sym_break_statement] = STATE(1526),
    [sym_continue_statement] = STATE(1526),
    [sym_goto_statement] = STATE(1526),
    [sym__expression] = STATE(954),
    [sym_comma_expression] = STATE(955),
    [sym_conditional_expression] = STATE(954),
    [sym_assignment_expression] = STATE(954),
    [sym_pointer_expression] = STATE(954),
    [sym_logical_expression] = STATE(954),
    [sym_bitwise_expression] = STATE(954),
    [sym_equality_expression] = STATE(954),
    [sym_relational_expression] = STATE(954),
    [sym_shift_expression] = STATE(954),
    [sym_math_expression] = STATE(954),
    [sym_cast_expression] = STATE(954),
    [sym_sizeof_expression] = STATE(954),
    [sym_subscript_expression] = STATE(954),
    [sym_call_expression] = STATE(954),
    [sym_field_expression] = STATE(954),
    [sym_compound_literal_expression] = STATE(954),
    [sym_parenthesized_expression] = STATE(954),
    [sym_concatenated_string] = STATE(954),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(2497),
    [anon_sym_switch] = ACTIONS(2499),
    [anon_sym_case] = ACTIONS(2501),
    [anon_sym_default] = ACTIONS(2503),
    [anon_sym_while] = ACTIONS(2505),
    [anon_sym_do] = ACTIONS(2507),
    [anon_sym_for] = ACTIONS(2509),
    [anon_sym_return] = ACTIONS(2511),
    [anon_sym_break] = ACTIONS(2513),
    [anon_sym_continue] = ACTIONS(2515),
    [anon_sym_goto] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(2519),
    [sym_char_literal] = ACTIONS(2519),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(2521),
    [sym_false] = ACTIONS(2521),
    [sym_null] = ACTIONS(2521),
    [sym_identifier] = ACTIONS(3445),
    [sym_comment] = ACTIONS(42),
  },
  [1457] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1528),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4086),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1458] = {
    [sym__expression] = STATE(1529),
    [sym_conditional_expression] = STATE(1529),
    [sym_assignment_expression] = STATE(1529),
    [sym_pointer_expression] = STATE(1529),
    [sym_logical_expression] = STATE(1529),
    [sym_bitwise_expression] = STATE(1529),
    [sym_equality_expression] = STATE(1529),
    [sym_relational_expression] = STATE(1529),
    [sym_shift_expression] = STATE(1529),
    [sym_math_expression] = STATE(1529),
    [sym_cast_expression] = STATE(1529),
    [sym_sizeof_expression] = STATE(1529),
    [sym_subscript_expression] = STATE(1529),
    [sym_call_expression] = STATE(1529),
    [sym_field_expression] = STATE(1529),
    [sym_compound_literal_expression] = STATE(1529),
    [sym_parenthesized_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(1529),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(4086),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(4088),
    [sym_char_literal] = ACTIONS(4088),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(4090),
    [sym_false] = ACTIONS(4090),
    [sym_null] = ACTIONS(4090),
    [sym_identifier] = ACTIONS(4090),
    [sym_comment] = ACTIONS(42),
  },
  [1459] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(4092),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1460] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1045),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1047),
    [sym_preproc_directive] = ACTIONS(1047),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_typedef] = ACTIONS(1047),
    [anon_sym_extern] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_auto] = ACTIONS(1047),
    [anon_sym_register] = ACTIONS(1047),
    [anon_sym_inline] = ACTIONS(1047),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_restrict] = ACTIONS(1047),
    [anon_sym_volatile] = ACTIONS(1047),
    [anon_sym__Atomic] = ACTIONS(1047),
    [anon_sym_unsigned] = ACTIONS(1047),
    [anon_sym_long] = ACTIONS(1047),
    [anon_sym_short] = ACTIONS(1047),
    [sym_primitive_type] = ACTIONS(1047),
    [anon_sym_enum] = ACTIONS(1047),
    [anon_sym_struct] = ACTIONS(1047),
    [anon_sym_union] = ACTIONS(1047),
    [anon_sym_if] = ACTIONS(1047),
    [anon_sym_else] = ACTIONS(1047),
    [anon_sym_switch] = ACTIONS(1047),
    [anon_sym_case] = ACTIONS(1047),
    [anon_sym_default] = ACTIONS(1047),
    [anon_sym_while] = ACTIONS(1047),
    [anon_sym_do] = ACTIONS(1047),
    [anon_sym_for] = ACTIONS(1047),
    [anon_sym_return] = ACTIONS(1047),
    [anon_sym_break] = ACTIONS(1047),
    [anon_sym_continue] = ACTIONS(1047),
    [anon_sym_goto] = ACTIONS(1047),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_PLUS] = ACTIONS(1047),
    [anon_sym_DASH] = ACTIONS(1047),
    [anon_sym_DASH_DASH] = ACTIONS(1045),
    [anon_sym_PLUS_PLUS] = ACTIONS(1045),
    [anon_sym_sizeof] = ACTIONS(1047),
    [sym_number_literal] = ACTIONS(1045),
    [sym_char_literal] = ACTIONS(1045),
    [sym_string_literal] = ACTIONS(1045),
    [sym_true] = ACTIONS(1047),
    [sym_false] = ACTIONS(1047),
    [sym_null] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [sym_comment] = ACTIONS(42),
  },
  [1461] = {
    [sym_preproc_include] = STATE(505),
    [sym_preproc_def] = STATE(505),
    [sym_preproc_function_def] = STATE(505),
    [sym_preproc_call] = STATE(505),
    [sym_preproc_if_in_compound_statement] = STATE(275),
    [sym_preproc_ifdef_in_compound_statement] = STATE(276),
    [sym_declaration] = STATE(505),
    [sym_type_definition] = STATE(505),
    [sym__declaration_specifiers] = STATE(277),
    [sym_compound_statement] = STATE(505),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(505),
    [sym_expression_statement] = STATE(505),
    [sym_if_statement] = STATE(505),
    [sym_switch_statement] = STATE(505),
    [sym_case_statement] = STATE(505),
    [sym_while_statement] = STATE(505),
    [sym_do_statement] = STATE(505),
    [sym_for_statement] = STATE(505),
    [sym_return_statement] = STATE(505),
    [sym_break_statement] = STATE(505),
    [sym_continue_statement] = STATE(505),
    [sym_goto_statement] = STATE(505),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [sym__empty_declaration] = STATE(505),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(505),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(577),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(579),
    [sym_preproc_directive] = ACTIONS(581),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_typedef] = ACTIONS(585),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_RBRACE] = ACTIONS(4094),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(631),
    [sym_comment] = ACTIONS(42),
  },
  [1462] = {
    [sym__expression] = STATE(1532),
    [sym_conditional_expression] = STATE(1532),
    [sym_assignment_expression] = STATE(1532),
    [sym_pointer_expression] = STATE(1532),
    [sym_logical_expression] = STATE(1532),
    [sym_bitwise_expression] = STATE(1532),
    [sym_equality_expression] = STATE(1532),
    [sym_relational_expression] = STATE(1532),
    [sym_shift_expression] = STATE(1532),
    [sym_math_expression] = STATE(1532),
    [sym_cast_expression] = STATE(1532),
    [sym_sizeof_expression] = STATE(1532),
    [sym_subscript_expression] = STATE(1532),
    [sym_call_expression] = STATE(1532),
    [sym_field_expression] = STATE(1532),
    [sym_compound_literal_expression] = STATE(1532),
    [sym_parenthesized_expression] = STATE(1532),
    [sym_concatenated_string] = STATE(1532),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(4096),
    [sym_char_literal] = ACTIONS(4096),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(4098),
    [sym_false] = ACTIONS(4098),
    [sym_null] = ACTIONS(4098),
    [sym_identifier] = ACTIONS(4098),
    [sym_comment] = ACTIONS(42),
  },
  [1463] = {
    [sym__expression] = STATE(1533),
    [sym_conditional_expression] = STATE(1533),
    [sym_assignment_expression] = STATE(1533),
    [sym_pointer_expression] = STATE(1533),
    [sym_logical_expression] = STATE(1533),
    [sym_bitwise_expression] = STATE(1533),
    [sym_equality_expression] = STATE(1533),
    [sym_relational_expression] = STATE(1533),
    [sym_shift_expression] = STATE(1533),
    [sym_math_expression] = STATE(1533),
    [sym_cast_expression] = STATE(1533),
    [sym_sizeof_expression] = STATE(1533),
    [sym_subscript_expression] = STATE(1533),
    [sym_call_expression] = STATE(1533),
    [sym_field_expression] = STATE(1533),
    [sym_compound_literal_expression] = STATE(1533),
    [sym_parenthesized_expression] = STATE(1533),
    [sym_concatenated_string] = STATE(1533),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(4100),
    [sym_char_literal] = ACTIONS(4100),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(4102),
    [sym_false] = ACTIONS(4102),
    [sym_null] = ACTIONS(4102),
    [sym_identifier] = ACTIONS(4102),
    [sym_comment] = ACTIONS(42),
  },
  [1464] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1737),
    [anon_sym_COLON] = ACTIONS(4104),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1743),
    [anon_sym_SLASH_EQ] = ACTIONS(1743),
    [anon_sym_PERCENT_EQ] = ACTIONS(1743),
    [anon_sym_PLUS_EQ] = ACTIONS(1743),
    [anon_sym_DASH_EQ] = ACTIONS(1743),
    [anon_sym_LT_LT_EQ] = ACTIONS(1743),
    [anon_sym_GT_GT_EQ] = ACTIONS(1743),
    [anon_sym_AMP_EQ] = ACTIONS(1743),
    [anon_sym_CARET_EQ] = ACTIONS(1743),
    [anon_sym_PIPE_EQ] = ACTIONS(1743),
    [anon_sym_AMP] = ACTIONS(1745),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_AMP_AMP] = ACTIONS(1749),
    [anon_sym_PIPE] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_GT] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1465] = {
    [sym_declaration] = STATE(1537),
    [sym_type_definition] = STATE(1537),
    [sym__declaration_specifiers] = STATE(1538),
    [sym_compound_statement] = STATE(1537),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(1537),
    [sym_expression_statement] = STATE(1537),
    [sym_if_statement] = STATE(1537),
    [sym_switch_statement] = STATE(1537),
    [sym_case_statement] = STATE(1537),
    [sym_while_statement] = STATE(1537),
    [sym_do_statement] = STATE(1537),
    [sym_for_statement] = STATE(1537),
    [sym_return_statement] = STATE(1537),
    [sym_break_statement] = STATE(1537),
    [sym_continue_statement] = STATE(1537),
    [sym_goto_statement] = STATE(1537),
    [sym__expression] = STATE(1385),
    [sym_comma_expression] = STATE(1386),
    [sym_conditional_expression] = STATE(1385),
    [sym_assignment_expression] = STATE(1385),
    [sym_pointer_expression] = STATE(1385),
    [sym_logical_expression] = STATE(1385),
    [sym_bitwise_expression] = STATE(1385),
    [sym_equality_expression] = STATE(1385),
    [sym_relational_expression] = STATE(1385),
    [sym_shift_expression] = STATE(1385),
    [sym_math_expression] = STATE(1385),
    [sym_cast_expression] = STATE(1385),
    [sym_sizeof_expression] = STATE(1385),
    [sym_subscript_expression] = STATE(1385),
    [sym_call_expression] = STATE(1385),
    [sym_field_expression] = STATE(1385),
    [sym_compound_literal_expression] = STATE(1385),
    [sym_parenthesized_expression] = STATE(1385),
    [sym_concatenated_string] = STATE(1385),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3754),
    [anon_sym_typedef] = ACTIONS(4106),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(3756),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(3758),
    [anon_sym_switch] = ACTIONS(3760),
    [anon_sym_case] = ACTIONS(3762),
    [anon_sym_default] = ACTIONS(3764),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3772),
    [anon_sym_break] = ACTIONS(3774),
    [anon_sym_continue] = ACTIONS(3776),
    [anon_sym_goto] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3780),
    [sym_char_literal] = ACTIONS(3780),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3782),
    [sym_false] = ACTIONS(3782),
    [sym_null] = ACTIONS(3782),
    [sym_identifier] = ACTIONS(4108),
    [sym_comment] = ACTIONS(42),
  },
  [1466] = {
    [sym__expression] = STATE(1539),
    [sym_conditional_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(1539),
    [sym_pointer_expression] = STATE(1539),
    [sym_logical_expression] = STATE(1539),
    [sym_bitwise_expression] = STATE(1539),
    [sym_equality_expression] = STATE(1539),
    [sym_relational_expression] = STATE(1539),
    [sym_shift_expression] = STATE(1539),
    [sym_math_expression] = STATE(1539),
    [sym_cast_expression] = STATE(1539),
    [sym_sizeof_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_call_expression] = STATE(1539),
    [sym_field_expression] = STATE(1539),
    [sym_compound_literal_expression] = STATE(1539),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_concatenated_string] = STATE(1539),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(4110),
    [sym_char_literal] = ACTIONS(4110),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(4112),
    [sym_false] = ACTIONS(4112),
    [sym_null] = ACTIONS(4112),
    [sym_identifier] = ACTIONS(4112),
    [sym_comment] = ACTIONS(42),
  },
  [1467] = {
    [anon_sym_while] = ACTIONS(4114),
    [sym_comment] = ACTIONS(42),
  },
  [1468] = {
    [sym_declaration] = STATE(1541),
    [sym__declaration_specifiers] = STATE(773),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym__expression] = STATE(1542),
    [sym_conditional_expression] = STATE(1542),
    [sym_assignment_expression] = STATE(1542),
    [sym_pointer_expression] = STATE(1542),
    [sym_logical_expression] = STATE(1542),
    [sym_bitwise_expression] = STATE(1542),
    [sym_equality_expression] = STATE(1542),
    [sym_relational_expression] = STATE(1542),
    [sym_shift_expression] = STATE(1542),
    [sym_math_expression] = STATE(1542),
    [sym_cast_expression] = STATE(1542),
    [sym_sizeof_expression] = STATE(1542),
    [sym_subscript_expression] = STATE(1542),
    [sym_call_expression] = STATE(1542),
    [sym_field_expression] = STATE(1542),
    [sym_compound_literal_expression] = STATE(1542),
    [sym_parenthesized_expression] = STATE(1542),
    [sym_concatenated_string] = STATE(1542),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(4116),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(4118),
    [sym_char_literal] = ACTIONS(4118),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(4120),
    [sym_false] = ACTIONS(4120),
    [sym_null] = ACTIONS(4120),
    [sym_identifier] = ACTIONS(1795),
    [sym_comment] = ACTIONS(42),
  },
  [1469] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1797),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1797),
    [sym_preproc_directive] = ACTIONS(1797),
    [anon_sym_SEMI] = ACTIONS(1799),
    [anon_sym_typedef] = ACTIONS(1797),
    [anon_sym_extern] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1799),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_static] = ACTIONS(1797),
    [anon_sym_auto] = ACTIONS(1797),
    [anon_sym_register] = ACTIONS(1797),
    [anon_sym_inline] = ACTIONS(1797),
    [anon_sym_const] = ACTIONS(1797),
    [anon_sym_restrict] = ACTIONS(1797),
    [anon_sym_volatile] = ACTIONS(1797),
    [anon_sym__Atomic] = ACTIONS(1797),
    [anon_sym_unsigned] = ACTIONS(1797),
    [anon_sym_long] = ACTIONS(1797),
    [anon_sym_short] = ACTIONS(1797),
    [sym_primitive_type] = ACTIONS(1797),
    [anon_sym_enum] = ACTIONS(1797),
    [anon_sym_struct] = ACTIONS(1797),
    [anon_sym_union] = ACTIONS(1797),
    [anon_sym_if] = ACTIONS(1797),
    [anon_sym_else] = ACTIONS(1797),
    [anon_sym_switch] = ACTIONS(1797),
    [anon_sym_case] = ACTIONS(1797),
    [anon_sym_default] = ACTIONS(1797),
    [anon_sym_while] = ACTIONS(1797),
    [anon_sym_do] = ACTIONS(1797),
    [anon_sym_for] = ACTIONS(1797),
    [anon_sym_return] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1797),
    [anon_sym_continue] = ACTIONS(1797),
    [anon_sym_goto] = ACTIONS(1797),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_sizeof] = ACTIONS(1797),
    [sym_number_literal] = ACTIONS(1799),
    [sym_char_literal] = ACTIONS(1799),
    [sym_string_literal] = ACTIONS(1799),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [sym_null] = ACTIONS(1797),
    [sym_identifier] = ACTIONS(1797),
    [sym_comment] = ACTIONS(42),
  },
  [1470] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(4122),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1471] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1803),
    [anon_sym_LPAREN] = ACTIONS(1805),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1803),
    [sym_preproc_directive] = ACTIONS(1803),
    [anon_sym_SEMI] = ACTIONS(1805),
    [anon_sym_typedef] = ACTIONS(1803),
    [anon_sym_extern] = ACTIONS(1803),
    [anon_sym_LBRACE] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_static] = ACTIONS(1803),
    [anon_sym_auto] = ACTIONS(1803),
    [anon_sym_register] = ACTIONS(1803),
    [anon_sym_inline] = ACTIONS(1803),
    [anon_sym_const] = ACTIONS(1803),
    [anon_sym_restrict] = ACTIONS(1803),
    [anon_sym_volatile] = ACTIONS(1803),
    [anon_sym__Atomic] = ACTIONS(1803),
    [anon_sym_unsigned] = ACTIONS(1803),
    [anon_sym_long] = ACTIONS(1803),
    [anon_sym_short] = ACTIONS(1803),
    [sym_primitive_type] = ACTIONS(1803),
    [anon_sym_enum] = ACTIONS(1803),
    [anon_sym_struct] = ACTIONS(1803),
    [anon_sym_union] = ACTIONS(1803),
    [anon_sym_if] = ACTIONS(1803),
    [anon_sym_else] = ACTIONS(1803),
    [anon_sym_switch] = ACTIONS(1803),
    [anon_sym_case] = ACTIONS(1803),
    [anon_sym_default] = ACTIONS(1803),
    [anon_sym_while] = ACTIONS(1803),
    [anon_sym_do] = ACTIONS(1803),
    [anon_sym_for] = ACTIONS(1803),
    [anon_sym_return] = ACTIONS(1803),
    [anon_sym_break] = ACTIONS(1803),
    [anon_sym_continue] = ACTIONS(1803),
    [anon_sym_goto] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1803),
    [anon_sym_DASH] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1805),
    [anon_sym_PLUS_PLUS] = ACTIONS(1805),
    [anon_sym_sizeof] = ACTIONS(1803),
    [sym_number_literal] = ACTIONS(1805),
    [sym_char_literal] = ACTIONS(1805),
    [sym_string_literal] = ACTIONS(1805),
    [sym_true] = ACTIONS(1803),
    [sym_false] = ACTIONS(1803),
    [sym_null] = ACTIONS(1803),
    [sym_identifier] = ACTIONS(1803),
    [sym_comment] = ACTIONS(42),
  },
  [1472] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1807),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1807),
    [sym_preproc_directive] = ACTIONS(1807),
    [anon_sym_SEMI] = ACTIONS(1809),
    [anon_sym_typedef] = ACTIONS(1807),
    [anon_sym_extern] = ACTIONS(1807),
    [anon_sym_LBRACE] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_static] = ACTIONS(1807),
    [anon_sym_auto] = ACTIONS(1807),
    [anon_sym_register] = ACTIONS(1807),
    [anon_sym_inline] = ACTIONS(1807),
    [anon_sym_const] = ACTIONS(1807),
    [anon_sym_restrict] = ACTIONS(1807),
    [anon_sym_volatile] = ACTIONS(1807),
    [anon_sym__Atomic] = ACTIONS(1807),
    [anon_sym_unsigned] = ACTIONS(1807),
    [anon_sym_long] = ACTIONS(1807),
    [anon_sym_short] = ACTIONS(1807),
    [sym_primitive_type] = ACTIONS(1807),
    [anon_sym_enum] = ACTIONS(1807),
    [anon_sym_struct] = ACTIONS(1807),
    [anon_sym_union] = ACTIONS(1807),
    [anon_sym_if] = ACTIONS(1807),
    [anon_sym_else] = ACTIONS(1807),
    [anon_sym_switch] = ACTIONS(1807),
    [anon_sym_case] = ACTIONS(1807),
    [anon_sym_default] = ACTIONS(1807),
    [anon_sym_while] = ACTIONS(1807),
    [anon_sym_do] = ACTIONS(1807),
    [anon_sym_for] = ACTIONS(1807),
    [anon_sym_return] = ACTIONS(1807),
    [anon_sym_break] = ACTIONS(1807),
    [anon_sym_continue] = ACTIONS(1807),
    [anon_sym_goto] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1809),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1809),
    [anon_sym_PLUS_PLUS] = ACTIONS(1809),
    [anon_sym_sizeof] = ACTIONS(1807),
    [sym_number_literal] = ACTIONS(1809),
    [sym_char_literal] = ACTIONS(1809),
    [sym_string_literal] = ACTIONS(1809),
    [sym_true] = ACTIONS(1807),
    [sym_false] = ACTIONS(1807),
    [sym_null] = ACTIONS(1807),
    [sym_identifier] = ACTIONS(1807),
    [sym_comment] = ACTIONS(42),
  },
  [1473] = {
    [anon_sym_SEMI] = ACTIONS(4124),
    [sym_comment] = ACTIONS(42),
  },
  [1474] = {
    [sym_compound_statement] = STATE(1545),
    [sym_labeled_statement] = STATE(1545),
    [sym_expression_statement] = STATE(1545),
    [sym_if_statement] = STATE(1545),
    [sym_switch_statement] = STATE(1545),
    [sym_case_statement] = STATE(1545),
    [sym_while_statement] = STATE(1545),
    [sym_do_statement] = STATE(1545),
    [sym_for_statement] = STATE(1545),
    [sym_return_statement] = STATE(1545),
    [sym_break_statement] = STATE(1545),
    [sym_continue_statement] = STATE(1545),
    [sym_goto_statement] = STATE(1545),
    [sym__expression] = STATE(1385),
    [sym_comma_expression] = STATE(1386),
    [sym_conditional_expression] = STATE(1385),
    [sym_assignment_expression] = STATE(1385),
    [sym_pointer_expression] = STATE(1385),
    [sym_logical_expression] = STATE(1385),
    [sym_bitwise_expression] = STATE(1385),
    [sym_equality_expression] = STATE(1385),
    [sym_relational_expression] = STATE(1385),
    [sym_shift_expression] = STATE(1385),
    [sym_math_expression] = STATE(1385),
    [sym_cast_expression] = STATE(1385),
    [sym_sizeof_expression] = STATE(1385),
    [sym_subscript_expression] = STATE(1385),
    [sym_call_expression] = STATE(1385),
    [sym_field_expression] = STATE(1385),
    [sym_compound_literal_expression] = STATE(1385),
    [sym_parenthesized_expression] = STATE(1385),
    [sym_concatenated_string] = STATE(1385),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3754),
    [anon_sym_LBRACE] = ACTIONS(3756),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3758),
    [anon_sym_switch] = ACTIONS(3760),
    [anon_sym_case] = ACTIONS(3762),
    [anon_sym_default] = ACTIONS(3764),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3772),
    [anon_sym_break] = ACTIONS(3774),
    [anon_sym_continue] = ACTIONS(3776),
    [anon_sym_goto] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3780),
    [sym_char_literal] = ACTIONS(3780),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3782),
    [sym_false] = ACTIONS(3782),
    [sym_null] = ACTIONS(3782),
    [sym_identifier] = ACTIONS(3784),
    [sym_comment] = ACTIONS(42),
  },
  [1475] = {
    [sym_compound_statement] = STATE(1546),
    [sym_labeled_statement] = STATE(1546),
    [sym_expression_statement] = STATE(1546),
    [sym_if_statement] = STATE(1546),
    [sym_switch_statement] = STATE(1546),
    [sym_case_statement] = STATE(1546),
    [sym_while_statement] = STATE(1546),
    [sym_do_statement] = STATE(1546),
    [sym_for_statement] = STATE(1546),
    [sym_return_statement] = STATE(1546),
    [sym_break_statement] = STATE(1546),
    [sym_continue_statement] = STATE(1546),
    [sym_goto_statement] = STATE(1546),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(3040),
    [sym_comment] = ACTIONS(42),
  },
  [1476] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1849),
    [anon_sym_LPAREN] = ACTIONS(1851),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1849),
    [sym_preproc_directive] = ACTIONS(1849),
    [anon_sym_SEMI] = ACTIONS(1851),
    [anon_sym_typedef] = ACTIONS(1849),
    [anon_sym_extern] = ACTIONS(1849),
    [anon_sym_LBRACE] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1851),
    [anon_sym_static] = ACTIONS(1849),
    [anon_sym_auto] = ACTIONS(1849),
    [anon_sym_register] = ACTIONS(1849),
    [anon_sym_inline] = ACTIONS(1849),
    [anon_sym_const] = ACTIONS(1849),
    [anon_sym_restrict] = ACTIONS(1849),
    [anon_sym_volatile] = ACTIONS(1849),
    [anon_sym__Atomic] = ACTIONS(1849),
    [anon_sym_unsigned] = ACTIONS(1849),
    [anon_sym_long] = ACTIONS(1849),
    [anon_sym_short] = ACTIONS(1849),
    [sym_primitive_type] = ACTIONS(1849),
    [anon_sym_enum] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1849),
    [anon_sym_union] = ACTIONS(1849),
    [anon_sym_if] = ACTIONS(1849),
    [anon_sym_else] = ACTIONS(1849),
    [anon_sym_switch] = ACTIONS(1849),
    [anon_sym_case] = ACTIONS(1849),
    [anon_sym_default] = ACTIONS(1849),
    [anon_sym_while] = ACTIONS(1849),
    [anon_sym_do] = ACTIONS(1849),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(1849),
    [anon_sym_break] = ACTIONS(1849),
    [anon_sym_continue] = ACTIONS(1849),
    [anon_sym_goto] = ACTIONS(1849),
    [anon_sym_AMP] = ACTIONS(1851),
    [anon_sym_BANG] = ACTIONS(1851),
    [anon_sym_TILDE] = ACTIONS(1851),
    [anon_sym_PLUS] = ACTIONS(1849),
    [anon_sym_DASH] = ACTIONS(1849),
    [anon_sym_DASH_DASH] = ACTIONS(1851),
    [anon_sym_PLUS_PLUS] = ACTIONS(1851),
    [anon_sym_sizeof] = ACTIONS(1849),
    [sym_number_literal] = ACTIONS(1851),
    [sym_char_literal] = ACTIONS(1851),
    [sym_string_literal] = ACTIONS(1851),
    [sym_true] = ACTIONS(1849),
    [sym_false] = ACTIONS(1849),
    [sym_null] = ACTIONS(1849),
    [sym_identifier] = ACTIONS(1849),
    [sym_comment] = ACTIONS(42),
  },
  [1477] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3868),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3868),
    [sym_preproc_directive] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3870),
    [anon_sym_typedef] = ACTIONS(3868),
    [anon_sym_extern] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3870),
    [anon_sym_STAR] = ACTIONS(3870),
    [anon_sym_static] = ACTIONS(3868),
    [anon_sym_auto] = ACTIONS(3868),
    [anon_sym_register] = ACTIONS(3868),
    [anon_sym_inline] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(3868),
    [anon_sym_restrict] = ACTIONS(3868),
    [anon_sym_volatile] = ACTIONS(3868),
    [anon_sym__Atomic] = ACTIONS(3868),
    [anon_sym_unsigned] = ACTIONS(3868),
    [anon_sym_long] = ACTIONS(3868),
    [anon_sym_short] = ACTIONS(3868),
    [sym_primitive_type] = ACTIONS(3868),
    [anon_sym_enum] = ACTIONS(3868),
    [anon_sym_struct] = ACTIONS(3868),
    [anon_sym_union] = ACTIONS(3868),
    [anon_sym_if] = ACTIONS(3868),
    [anon_sym_switch] = ACTIONS(3868),
    [anon_sym_case] = ACTIONS(3868),
    [anon_sym_default] = ACTIONS(3868),
    [anon_sym_while] = ACTIONS(3868),
    [anon_sym_do] = ACTIONS(3868),
    [anon_sym_for] = ACTIONS(3868),
    [anon_sym_return] = ACTIONS(3868),
    [anon_sym_break] = ACTIONS(3868),
    [anon_sym_continue] = ACTIONS(3868),
    [anon_sym_goto] = ACTIONS(3868),
    [anon_sym_AMP] = ACTIONS(3870),
    [anon_sym_BANG] = ACTIONS(3870),
    [anon_sym_TILDE] = ACTIONS(3870),
    [anon_sym_PLUS] = ACTIONS(3868),
    [anon_sym_DASH] = ACTIONS(3868),
    [anon_sym_DASH_DASH] = ACTIONS(3870),
    [anon_sym_PLUS_PLUS] = ACTIONS(3870),
    [anon_sym_sizeof] = ACTIONS(3868),
    [sym_number_literal] = ACTIONS(3870),
    [sym_char_literal] = ACTIONS(3870),
    [sym_string_literal] = ACTIONS(3870),
    [sym_true] = ACTIONS(3868),
    [sym_false] = ACTIONS(3868),
    [sym_null] = ACTIONS(3868),
    [sym_identifier] = ACTIONS(3868),
    [sym_comment] = ACTIONS(42),
  },
  [1478] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3872),
    [anon_sym_LPAREN] = ACTIONS(3874),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3872),
    [sym_preproc_directive] = ACTIONS(3872),
    [anon_sym_SEMI] = ACTIONS(3874),
    [anon_sym_typedef] = ACTIONS(3872),
    [anon_sym_extern] = ACTIONS(3872),
    [anon_sym_LBRACE] = ACTIONS(3874),
    [anon_sym_STAR] = ACTIONS(3874),
    [anon_sym_static] = ACTIONS(3872),
    [anon_sym_auto] = ACTIONS(3872),
    [anon_sym_register] = ACTIONS(3872),
    [anon_sym_inline] = ACTIONS(3872),
    [anon_sym_const] = ACTIONS(3872),
    [anon_sym_restrict] = ACTIONS(3872),
    [anon_sym_volatile] = ACTIONS(3872),
    [anon_sym__Atomic] = ACTIONS(3872),
    [anon_sym_unsigned] = ACTIONS(3872),
    [anon_sym_long] = ACTIONS(3872),
    [anon_sym_short] = ACTIONS(3872),
    [sym_primitive_type] = ACTIONS(3872),
    [anon_sym_enum] = ACTIONS(3872),
    [anon_sym_struct] = ACTIONS(3872),
    [anon_sym_union] = ACTIONS(3872),
    [anon_sym_if] = ACTIONS(3872),
    [anon_sym_switch] = ACTIONS(3872),
    [anon_sym_case] = ACTIONS(3872),
    [anon_sym_default] = ACTIONS(3872),
    [anon_sym_while] = ACTIONS(3872),
    [anon_sym_do] = ACTIONS(3872),
    [anon_sym_for] = ACTIONS(3872),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_break] = ACTIONS(3872),
    [anon_sym_continue] = ACTIONS(3872),
    [anon_sym_goto] = ACTIONS(3872),
    [anon_sym_AMP] = ACTIONS(3874),
    [anon_sym_BANG] = ACTIONS(3874),
    [anon_sym_TILDE] = ACTIONS(3874),
    [anon_sym_PLUS] = ACTIONS(3872),
    [anon_sym_DASH] = ACTIONS(3872),
    [anon_sym_DASH_DASH] = ACTIONS(3874),
    [anon_sym_PLUS_PLUS] = ACTIONS(3874),
    [anon_sym_sizeof] = ACTIONS(3872),
    [sym_number_literal] = ACTIONS(3874),
    [sym_char_literal] = ACTIONS(3874),
    [sym_string_literal] = ACTIONS(3874),
    [sym_true] = ACTIONS(3872),
    [sym_false] = ACTIONS(3872),
    [sym_null] = ACTIONS(3872),
    [sym_identifier] = ACTIONS(3872),
    [sym_comment] = ACTIONS(42),
  },
  [1479] = {
    [sym_compound_statement] = STATE(1547),
    [sym_labeled_statement] = STATE(1547),
    [sym_expression_statement] = STATE(1547),
    [sym_if_statement] = STATE(1547),
    [sym_switch_statement] = STATE(1547),
    [sym_case_statement] = STATE(1547),
    [sym_while_statement] = STATE(1547),
    [sym_do_statement] = STATE(1547),
    [sym_for_statement] = STATE(1547),
    [sym_return_statement] = STATE(1547),
    [sym_break_statement] = STATE(1547),
    [sym_continue_statement] = STATE(1547),
    [sym_goto_statement] = STATE(1547),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(3040),
    [sym_comment] = ACTIONS(42),
  },
  [1480] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4126),
    [sym_comment] = ACTIONS(42),
  },
  [1481] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1549),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1482] = {
    [sym__expression] = STATE(1550),
    [sym_conditional_expression] = STATE(1550),
    [sym_assignment_expression] = STATE(1550),
    [sym_pointer_expression] = STATE(1550),
    [sym_logical_expression] = STATE(1550),
    [sym_bitwise_expression] = STATE(1550),
    [sym_equality_expression] = STATE(1550),
    [sym_relational_expression] = STATE(1550),
    [sym_shift_expression] = STATE(1550),
    [sym_math_expression] = STATE(1550),
    [sym_cast_expression] = STATE(1550),
    [sym_sizeof_expression] = STATE(1550),
    [sym_subscript_expression] = STATE(1550),
    [sym_call_expression] = STATE(1550),
    [sym_field_expression] = STATE(1550),
    [sym_compound_literal_expression] = STATE(1550),
    [sym_parenthesized_expression] = STATE(1550),
    [sym_concatenated_string] = STATE(1550),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(4128),
    [sym_char_literal] = ACTIONS(4128),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(4130),
    [sym_false] = ACTIONS(4130),
    [sym_null] = ACTIONS(4130),
    [sym_identifier] = ACTIONS(4130),
    [sym_comment] = ACTIONS(42),
  },
  [1483] = {
    [sym_compound_statement] = STATE(1551),
    [sym_labeled_statement] = STATE(1551),
    [sym_expression_statement] = STATE(1551),
    [sym_if_statement] = STATE(1551),
    [sym_switch_statement] = STATE(1551),
    [sym_case_statement] = STATE(1551),
    [sym_while_statement] = STATE(1551),
    [sym_do_statement] = STATE(1551),
    [sym_for_statement] = STATE(1551),
    [sym_return_statement] = STATE(1551),
    [sym_break_statement] = STATE(1551),
    [sym_continue_statement] = STATE(1551),
    [sym_goto_statement] = STATE(1551),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3173),
    [anon_sym_switch] = ACTIONS(3175),
    [anon_sym_case] = ACTIONS(3177),
    [anon_sym_default] = ACTIONS(3179),
    [anon_sym_while] = ACTIONS(3181),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3185),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3199),
    [sym_comment] = ACTIONS(42),
  },
  [1484] = {
    [sym_compound_statement] = STATE(1552),
    [sym_labeled_statement] = STATE(1552),
    [sym_expression_statement] = STATE(1552),
    [sym_if_statement] = STATE(1552),
    [sym_switch_statement] = STATE(1552),
    [sym_case_statement] = STATE(1552),
    [sym_while_statement] = STATE(1552),
    [sym_do_statement] = STATE(1552),
    [sym_for_statement] = STATE(1552),
    [sym_return_statement] = STATE(1552),
    [sym_break_statement] = STATE(1552),
    [sym_continue_statement] = STATE(1552),
    [sym_goto_statement] = STATE(1552),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3173),
    [anon_sym_switch] = ACTIONS(3175),
    [anon_sym_case] = ACTIONS(3177),
    [anon_sym_default] = ACTIONS(3179),
    [anon_sym_while] = ACTIONS(3181),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3185),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3199),
    [sym_comment] = ACTIONS(42),
  },
  [1485] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3250),
    [anon_sym_LPAREN] = ACTIONS(3252),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3250),
    [sym_preproc_directive] = ACTIONS(3250),
    [anon_sym_SEMI] = ACTIONS(3252),
    [anon_sym_typedef] = ACTIONS(3250),
    [anon_sym_extern] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3252),
    [anon_sym_RBRACE] = ACTIONS(3252),
    [anon_sym_STAR] = ACTIONS(3252),
    [anon_sym_static] = ACTIONS(3250),
    [anon_sym_auto] = ACTIONS(3250),
    [anon_sym_register] = ACTIONS(3250),
    [anon_sym_inline] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(3250),
    [anon_sym_restrict] = ACTIONS(3250),
    [anon_sym_volatile] = ACTIONS(3250),
    [anon_sym__Atomic] = ACTIONS(3250),
    [anon_sym_unsigned] = ACTIONS(3250),
    [anon_sym_long] = ACTIONS(3250),
    [anon_sym_short] = ACTIONS(3250),
    [sym_primitive_type] = ACTIONS(3250),
    [anon_sym_enum] = ACTIONS(3250),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_union] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_else] = ACTIONS(3250),
    [anon_sym_switch] = ACTIONS(3250),
    [anon_sym_case] = ACTIONS(3250),
    [anon_sym_default] = ACTIONS(3250),
    [anon_sym_while] = ACTIONS(3250),
    [anon_sym_do] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_goto] = ACTIONS(3250),
    [anon_sym_AMP] = ACTIONS(3252),
    [anon_sym_BANG] = ACTIONS(3252),
    [anon_sym_TILDE] = ACTIONS(3252),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3252),
    [anon_sym_PLUS_PLUS] = ACTIONS(3252),
    [anon_sym_sizeof] = ACTIONS(3250),
    [sym_number_literal] = ACTIONS(3252),
    [sym_char_literal] = ACTIONS(3252),
    [sym_string_literal] = ACTIONS(3252),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [sym_null] = ACTIONS(3250),
    [sym_identifier] = ACTIONS(3250),
    [sym_comment] = ACTIONS(42),
  },
  [1486] = {
    [sym__type_declarator] = STATE(1553),
    [sym_pointer_type_declarator] = STATE(99),
    [sym_function_type_declarator] = STATE(100),
    [sym_array_type_declarator] = STATE(101),
    [anon_sym_LPAREN] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(187),
    [sym_identifier] = ACTIONS(189),
    [sym_comment] = ACTIONS(42),
  },
  [1487] = {
    [sym_type_qualifier] = STATE(103),
    [sym__type_specifier] = STATE(1554),
    [sym_sized_type_specifier] = STATE(1554),
    [sym_enum_specifier] = STATE(1554),
    [sym_struct_specifier] = STATE(1554),
    [sym_union_specifier] = STATE(1554),
    [sym_macro_type_specifier] = STATE(1554),
    [aux_sym_type_definition_repeat1] = STATE(103),
    [aux_sym_sized_type_specifier_repeat1] = STATE(36),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(62),
    [anon_sym_long] = ACTIONS(62),
    [anon_sym_short] = ACTIONS(62),
    [sym_primitive_type] = ACTIONS(4132),
    [anon_sym_enum] = ACTIONS(66),
    [anon_sym_struct] = ACTIONS(68),
    [anon_sym_union] = ACTIONS(70),
    [sym_identifier] = ACTIONS(72),
    [sym_comment] = ACTIONS(42),
  },
  [1488] = {
    [sym_parameter_list] = STATE(145),
    [aux_sym_declaration_repeat1] = STATE(1556),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(4134),
    [anon_sym_LBRACK] = ACTIONS(270),
    [anon_sym_EQ] = ACTIONS(272),
    [sym_comment] = ACTIONS(42),
  },
  [1489] = {
    [aux_sym_declaration_repeat1] = STATE(1556),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(4134),
    [sym_comment] = ACTIONS(42),
  },
  [1490] = {
    [sym_compound_statement] = STATE(1557),
    [sym_labeled_statement] = STATE(1557),
    [sym_expression_statement] = STATE(1557),
    [sym_if_statement] = STATE(1557),
    [sym_switch_statement] = STATE(1557),
    [sym_case_statement] = STATE(1557),
    [sym_while_statement] = STATE(1557),
    [sym_do_statement] = STATE(1557),
    [sym_for_statement] = STATE(1557),
    [sym_return_statement] = STATE(1557),
    [sym_break_statement] = STATE(1557),
    [sym_continue_statement] = STATE(1557),
    [sym_goto_statement] = STATE(1557),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3173),
    [anon_sym_switch] = ACTIONS(3175),
    [anon_sym_case] = ACTIONS(3177),
    [anon_sym_default] = ACTIONS(3179),
    [anon_sym_while] = ACTIONS(3181),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3185),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3199),
    [sym_comment] = ACTIONS(42),
  },
  [1491] = {
    [sym__expression] = STATE(1558),
    [sym_conditional_expression] = STATE(1558),
    [sym_assignment_expression] = STATE(1558),
    [sym_pointer_expression] = STATE(1558),
    [sym_logical_expression] = STATE(1558),
    [sym_bitwise_expression] = STATE(1558),
    [sym_equality_expression] = STATE(1558),
    [sym_relational_expression] = STATE(1558),
    [sym_shift_expression] = STATE(1558),
    [sym_math_expression] = STATE(1558),
    [sym_cast_expression] = STATE(1558),
    [sym_sizeof_expression] = STATE(1558),
    [sym_subscript_expression] = STATE(1558),
    [sym_call_expression] = STATE(1558),
    [sym_field_expression] = STATE(1558),
    [sym_compound_literal_expression] = STATE(1558),
    [sym_parenthesized_expression] = STATE(1558),
    [sym_concatenated_string] = STATE(1558),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(4136),
    [sym_char_literal] = ACTIONS(4136),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(4138),
    [sym_false] = ACTIONS(4138),
    [sym_null] = ACTIONS(4138),
    [sym_identifier] = ACTIONS(4138),
    [sym_comment] = ACTIONS(42),
  },
  [1492] = {
    [sym__expression] = STATE(1560),
    [sym_conditional_expression] = STATE(1560),
    [sym_assignment_expression] = STATE(1560),
    [sym_pointer_expression] = STATE(1560),
    [sym_logical_expression] = STATE(1560),
    [sym_bitwise_expression] = STATE(1560),
    [sym_equality_expression] = STATE(1560),
    [sym_relational_expression] = STATE(1560),
    [sym_shift_expression] = STATE(1560),
    [sym_math_expression] = STATE(1560),
    [sym_cast_expression] = STATE(1560),
    [sym_sizeof_expression] = STATE(1560),
    [sym_subscript_expression] = STATE(1560),
    [sym_call_expression] = STATE(1560),
    [sym_field_expression] = STATE(1560),
    [sym_compound_literal_expression] = STATE(1560),
    [sym_parenthesized_expression] = STATE(1560),
    [sym_concatenated_string] = STATE(1560),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(4142),
    [sym_char_literal] = ACTIONS(4142),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(4144),
    [sym_false] = ACTIONS(4144),
    [sym_null] = ACTIONS(4144),
    [sym_identifier] = ACTIONS(4144),
    [sym_comment] = ACTIONS(42),
  },
  [1493] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1494] = {
    [sym__expression] = STATE(1562),
    [sym_conditional_expression] = STATE(1562),
    [sym_assignment_expression] = STATE(1562),
    [sym_pointer_expression] = STATE(1562),
    [sym_logical_expression] = STATE(1562),
    [sym_bitwise_expression] = STATE(1562),
    [sym_equality_expression] = STATE(1562),
    [sym_relational_expression] = STATE(1562),
    [sym_shift_expression] = STATE(1562),
    [sym_math_expression] = STATE(1562),
    [sym_cast_expression] = STATE(1562),
    [sym_sizeof_expression] = STATE(1562),
    [sym_subscript_expression] = STATE(1562),
    [sym_call_expression] = STATE(1562),
    [sym_field_expression] = STATE(1562),
    [sym_compound_literal_expression] = STATE(1562),
    [sym_parenthesized_expression] = STATE(1562),
    [sym_concatenated_string] = STATE(1562),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(4148),
    [sym_char_literal] = ACTIONS(4148),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(4150),
    [sym_false] = ACTIONS(4150),
    [sym_null] = ACTIONS(4150),
    [sym_identifier] = ACTIONS(4150),
    [sym_comment] = ACTIONS(42),
  },
  [1495] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(4152),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1496] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1497] = {
    [sym_declaration] = STATE(1485),
    [sym_type_definition] = STATE(1485),
    [sym__declaration_specifiers] = STATE(1401),
    [sym_compound_statement] = STATE(1485),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(1485),
    [sym_expression_statement] = STATE(1485),
    [sym_if_statement] = STATE(1485),
    [sym_switch_statement] = STATE(1485),
    [sym_case_statement] = STATE(1485),
    [sym_while_statement] = STATE(1485),
    [sym_do_statement] = STATE(1485),
    [sym_for_statement] = STATE(1485),
    [sym_return_statement] = STATE(1485),
    [sym_break_statement] = STATE(1485),
    [sym_continue_statement] = STATE(1485),
    [sym_goto_statement] = STATE(1485),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_typedef] = ACTIONS(3818),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(3631),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_case] = ACTIONS(3635),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3639),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(4026),
    [sym_comment] = ACTIONS(42),
  },
  [1498] = {
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_extern] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_auto] = ACTIONS(95),
    [anon_sym_register] = ACTIONS(95),
    [anon_sym_inline] = ACTIONS(95),
    [anon_sym_const] = ACTIONS(95),
    [anon_sym_restrict] = ACTIONS(95),
    [anon_sym_volatile] = ACTIONS(95),
    [anon_sym__Atomic] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(3856),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_identifier] = ACTIONS(95),
    [sym_comment] = ACTIONS(42),
  },
  [1499] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(4156),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1500] = {
    [sym__expression] = STATE(1567),
    [sym_conditional_expression] = STATE(1567),
    [sym_assignment_expression] = STATE(1567),
    [sym_pointer_expression] = STATE(1567),
    [sym_logical_expression] = STATE(1567),
    [sym_bitwise_expression] = STATE(1567),
    [sym_equality_expression] = STATE(1567),
    [sym_relational_expression] = STATE(1567),
    [sym_shift_expression] = STATE(1567),
    [sym_math_expression] = STATE(1567),
    [sym_cast_expression] = STATE(1567),
    [sym_sizeof_expression] = STATE(1567),
    [sym_subscript_expression] = STATE(1567),
    [sym_call_expression] = STATE(1567),
    [sym_field_expression] = STATE(1567),
    [sym_compound_literal_expression] = STATE(1567),
    [sym_parenthesized_expression] = STATE(1567),
    [sym_concatenated_string] = STATE(1567),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(4158),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(4160),
    [sym_char_literal] = ACTIONS(4160),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(4162),
    [sym_false] = ACTIONS(4162),
    [sym_null] = ACTIONS(4162),
    [sym_identifier] = ACTIONS(4162),
    [sym_comment] = ACTIONS(42),
  },
  [1501] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1502] = {
    [sym_compound_statement] = STATE(1505),
    [sym_labeled_statement] = STATE(1505),
    [sym_expression_statement] = STATE(1505),
    [sym_if_statement] = STATE(1505),
    [sym_switch_statement] = STATE(1505),
    [sym_case_statement] = STATE(1505),
    [sym_while_statement] = STATE(1505),
    [sym_do_statement] = STATE(1505),
    [sym_for_statement] = STATE(1505),
    [sym_return_statement] = STATE(1505),
    [sym_break_statement] = STATE(1505),
    [sym_continue_statement] = STATE(1505),
    [sym_goto_statement] = STATE(1505),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_default] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(1089),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1093),
    [sym_comment] = ACTIONS(42),
  },
  [1503] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4166),
    [sym_comment] = ACTIONS(42),
  },
  [1504] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1570),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4166),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1505] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4168),
    [sym_preproc_directive] = ACTIONS(4168),
    [anon_sym_SEMI] = ACTIONS(4170),
    [anon_sym_typedef] = ACTIONS(4168),
    [anon_sym_extern] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4170),
    [anon_sym_RBRACE] = ACTIONS(4170),
    [anon_sym_STAR] = ACTIONS(4170),
    [anon_sym_static] = ACTIONS(4168),
    [anon_sym_auto] = ACTIONS(4168),
    [anon_sym_register] = ACTIONS(4168),
    [anon_sym_inline] = ACTIONS(4168),
    [anon_sym_const] = ACTIONS(4168),
    [anon_sym_restrict] = ACTIONS(4168),
    [anon_sym_volatile] = ACTIONS(4168),
    [anon_sym__Atomic] = ACTIONS(4168),
    [anon_sym_unsigned] = ACTIONS(4168),
    [anon_sym_long] = ACTIONS(4168),
    [anon_sym_short] = ACTIONS(4168),
    [sym_primitive_type] = ACTIONS(4168),
    [anon_sym_enum] = ACTIONS(4168),
    [anon_sym_struct] = ACTIONS(4168),
    [anon_sym_union] = ACTIONS(4168),
    [anon_sym_if] = ACTIONS(4168),
    [anon_sym_switch] = ACTIONS(4168),
    [anon_sym_case] = ACTIONS(4168),
    [anon_sym_default] = ACTIONS(4168),
    [anon_sym_while] = ACTIONS(4168),
    [anon_sym_do] = ACTIONS(4168),
    [anon_sym_for] = ACTIONS(4168),
    [anon_sym_return] = ACTIONS(4168),
    [anon_sym_break] = ACTIONS(4168),
    [anon_sym_continue] = ACTIONS(4168),
    [anon_sym_goto] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(4170),
    [anon_sym_TILDE] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4168),
    [anon_sym_DASH] = ACTIONS(4168),
    [anon_sym_DASH_DASH] = ACTIONS(4170),
    [anon_sym_PLUS_PLUS] = ACTIONS(4170),
    [anon_sym_sizeof] = ACTIONS(4168),
    [sym_number_literal] = ACTIONS(4170),
    [sym_char_literal] = ACTIONS(4170),
    [sym_string_literal] = ACTIONS(4170),
    [sym_true] = ACTIONS(4168),
    [sym_false] = ACTIONS(4168),
    [sym_null] = ACTIONS(4168),
    [sym_identifier] = ACTIONS(4168),
    [sym_comment] = ACTIONS(42),
  },
  [1506] = {
    [sym_compound_statement] = STATE(1571),
    [sym_labeled_statement] = STATE(1571),
    [sym_expression_statement] = STATE(1571),
    [sym_if_statement] = STATE(1571),
    [sym_switch_statement] = STATE(1571),
    [sym_case_statement] = STATE(1571),
    [sym_while_statement] = STATE(1571),
    [sym_do_statement] = STATE(1571),
    [sym_for_statement] = STATE(1571),
    [sym_return_statement] = STATE(1571),
    [sym_break_statement] = STATE(1571),
    [sym_continue_statement] = STATE(1571),
    [sym_goto_statement] = STATE(1571),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1835),
    [sym_comment] = ACTIONS(42),
  },
  [1507] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4172),
    [sym_comment] = ACTIONS(42),
  },
  [1508] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1045),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1047),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1047),
    [sym_preproc_directive] = ACTIONS(1047),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_typedef] = ACTIONS(1047),
    [anon_sym_extern] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_auto] = ACTIONS(1047),
    [anon_sym_register] = ACTIONS(1047),
    [anon_sym_inline] = ACTIONS(1047),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_restrict] = ACTIONS(1047),
    [anon_sym_volatile] = ACTIONS(1047),
    [anon_sym__Atomic] = ACTIONS(1047),
    [anon_sym_unsigned] = ACTIONS(1047),
    [anon_sym_long] = ACTIONS(1047),
    [anon_sym_short] = ACTIONS(1047),
    [sym_primitive_type] = ACTIONS(1047),
    [anon_sym_enum] = ACTIONS(1047),
    [anon_sym_struct] = ACTIONS(1047),
    [anon_sym_union] = ACTIONS(1047),
    [anon_sym_if] = ACTIONS(1047),
    [anon_sym_else] = ACTIONS(1047),
    [anon_sym_switch] = ACTIONS(1047),
    [anon_sym_case] = ACTIONS(1047),
    [anon_sym_default] = ACTIONS(1047),
    [anon_sym_while] = ACTIONS(1047),
    [anon_sym_do] = ACTIONS(1047),
    [anon_sym_for] = ACTIONS(1047),
    [anon_sym_return] = ACTIONS(1047),
    [anon_sym_break] = ACTIONS(1047),
    [anon_sym_continue] = ACTIONS(1047),
    [anon_sym_goto] = ACTIONS(1047),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_PLUS] = ACTIONS(1047),
    [anon_sym_DASH] = ACTIONS(1047),
    [anon_sym_DASH_DASH] = ACTIONS(1045),
    [anon_sym_PLUS_PLUS] = ACTIONS(1045),
    [anon_sym_sizeof] = ACTIONS(1047),
    [sym_number_literal] = ACTIONS(1045),
    [sym_char_literal] = ACTIONS(1045),
    [sym_string_literal] = ACTIONS(1045),
    [sym_true] = ACTIONS(1047),
    [sym_false] = ACTIONS(1047),
    [sym_null] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [sym_comment] = ACTIONS(42),
  },
  [1509] = {
    [sym_preproc_include] = STATE(505),
    [sym_preproc_def] = STATE(505),
    [sym_preproc_function_def] = STATE(505),
    [sym_preproc_call] = STATE(505),
    [sym_preproc_if_in_compound_statement] = STATE(275),
    [sym_preproc_ifdef_in_compound_statement] = STATE(276),
    [sym_declaration] = STATE(505),
    [sym_type_definition] = STATE(505),
    [sym__declaration_specifiers] = STATE(277),
    [sym_compound_statement] = STATE(505),
    [sym_storage_class_specifier] = STATE(20),
    [sym_type_qualifier] = STATE(20),
    [sym__type_specifier] = STATE(18),
    [sym_sized_type_specifier] = STATE(18),
    [sym_enum_specifier] = STATE(18),
    [sym_struct_specifier] = STATE(18),
    [sym_union_specifier] = STATE(18),
    [sym_labeled_statement] = STATE(505),
    [sym_expression_statement] = STATE(505),
    [sym_if_statement] = STATE(505),
    [sym_switch_statement] = STATE(505),
    [sym_case_statement] = STATE(505),
    [sym_while_statement] = STATE(505),
    [sym_do_statement] = STATE(505),
    [sym_for_statement] = STATE(505),
    [sym_return_statement] = STATE(505),
    [sym_break_statement] = STATE(505),
    [sym_continue_statement] = STATE(505),
    [sym_goto_statement] = STATE(505),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [sym__empty_declaration] = STATE(505),
    [sym_macro_type_specifier] = STATE(18),
    [aux_sym_preproc_if_in_compound_statement_repeat1] = STATE(505),
    [aux_sym__declaration_specifiers_repeat1] = STATE(20),
    [aux_sym_sized_type_specifier_repeat1] = STATE(21),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(569),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(575),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(577),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(579),
    [sym_preproc_directive] = ACTIONS(581),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_typedef] = ACTIONS(585),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_RBRACE] = ACTIONS(4174),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(30),
    [anon_sym_long] = ACTIONS(30),
    [anon_sym_short] = ACTIONS(30),
    [sym_primitive_type] = ACTIONS(32),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(631),
    [sym_comment] = ACTIONS(42),
  },
  [1510] = {
    [sym__expression] = STATE(1574),
    [sym_conditional_expression] = STATE(1574),
    [sym_assignment_expression] = STATE(1574),
    [sym_pointer_expression] = STATE(1574),
    [sym_logical_expression] = STATE(1574),
    [sym_bitwise_expression] = STATE(1574),
    [sym_equality_expression] = STATE(1574),
    [sym_relational_expression] = STATE(1574),
    [sym_shift_expression] = STATE(1574),
    [sym_math_expression] = STATE(1574),
    [sym_cast_expression] = STATE(1574),
    [sym_sizeof_expression] = STATE(1574),
    [sym_subscript_expression] = STATE(1574),
    [sym_call_expression] = STATE(1574),
    [sym_field_expression] = STATE(1574),
    [sym_compound_literal_expression] = STATE(1574),
    [sym_parenthesized_expression] = STATE(1574),
    [sym_concatenated_string] = STATE(1574),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(4176),
    [sym_char_literal] = ACTIONS(4176),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(4178),
    [sym_false] = ACTIONS(4178),
    [sym_null] = ACTIONS(4178),
    [sym_identifier] = ACTIONS(4178),
    [sym_comment] = ACTIONS(42),
  },
  [1511] = {
    [sym__expression] = STATE(1575),
    [sym_conditional_expression] = STATE(1575),
    [sym_assignment_expression] = STATE(1575),
    [sym_pointer_expression] = STATE(1575),
    [sym_logical_expression] = STATE(1575),
    [sym_bitwise_expression] = STATE(1575),
    [sym_equality_expression] = STATE(1575),
    [sym_relational_expression] = STATE(1575),
    [sym_shift_expression] = STATE(1575),
    [sym_math_expression] = STATE(1575),
    [sym_cast_expression] = STATE(1575),
    [sym_sizeof_expression] = STATE(1575),
    [sym_subscript_expression] = STATE(1575),
    [sym_call_expression] = STATE(1575),
    [sym_field_expression] = STATE(1575),
    [sym_compound_literal_expression] = STATE(1575),
    [sym_parenthesized_expression] = STATE(1575),
    [sym_concatenated_string] = STATE(1575),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(4180),
    [sym_char_literal] = ACTIONS(4180),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(4182),
    [sym_false] = ACTIONS(4182),
    [sym_null] = ACTIONS(4182),
    [sym_identifier] = ACTIONS(4182),
    [sym_comment] = ACTIONS(42),
  },
  [1512] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1737),
    [anon_sym_COLON] = ACTIONS(4184),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1743),
    [anon_sym_SLASH_EQ] = ACTIONS(1743),
    [anon_sym_PERCENT_EQ] = ACTIONS(1743),
    [anon_sym_PLUS_EQ] = ACTIONS(1743),
    [anon_sym_DASH_EQ] = ACTIONS(1743),
    [anon_sym_LT_LT_EQ] = ACTIONS(1743),
    [anon_sym_GT_GT_EQ] = ACTIONS(1743),
    [anon_sym_AMP_EQ] = ACTIONS(1743),
    [anon_sym_CARET_EQ] = ACTIONS(1743),
    [anon_sym_PIPE_EQ] = ACTIONS(1743),
    [anon_sym_AMP] = ACTIONS(1745),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_AMP_AMP] = ACTIONS(1749),
    [anon_sym_PIPE] = ACTIONS(1751),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_GT] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1513] = {
    [sym_declaration] = STATE(1579),
    [sym_type_definition] = STATE(1579),
    [sym__declaration_specifiers] = STATE(1580),
    [sym_compound_statement] = STATE(1579),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(1579),
    [sym_expression_statement] = STATE(1579),
    [sym_if_statement] = STATE(1579),
    [sym_switch_statement] = STATE(1579),
    [sym_case_statement] = STATE(1579),
    [sym_while_statement] = STATE(1579),
    [sym_do_statement] = STATE(1579),
    [sym_for_statement] = STATE(1579),
    [sym_return_statement] = STATE(1579),
    [sym_break_statement] = STATE(1579),
    [sym_continue_statement] = STATE(1579),
    [sym_goto_statement] = STATE(1579),
    [sym__expression] = STATE(1451),
    [sym_comma_expression] = STATE(1452),
    [sym_conditional_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(1451),
    [sym_pointer_expression] = STATE(1451),
    [sym_logical_expression] = STATE(1451),
    [sym_bitwise_expression] = STATE(1451),
    [sym_equality_expression] = STATE(1451),
    [sym_relational_expression] = STATE(1451),
    [sym_shift_expression] = STATE(1451),
    [sym_math_expression] = STATE(1451),
    [sym_cast_expression] = STATE(1451),
    [sym_sizeof_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_call_expression] = STATE(1451),
    [sym_field_expression] = STATE(1451),
    [sym_compound_literal_expression] = STATE(1451),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_concatenated_string] = STATE(1451),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3900),
    [anon_sym_typedef] = ACTIONS(4186),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(3902),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(3904),
    [anon_sym_switch] = ACTIONS(3906),
    [anon_sym_case] = ACTIONS(3908),
    [anon_sym_default] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3912),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_for] = ACTIONS(3916),
    [anon_sym_return] = ACTIONS(3918),
    [anon_sym_break] = ACTIONS(3920),
    [anon_sym_continue] = ACTIONS(3922),
    [anon_sym_goto] = ACTIONS(3924),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3926),
    [sym_char_literal] = ACTIONS(3926),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3928),
    [sym_false] = ACTIONS(3928),
    [sym_null] = ACTIONS(3928),
    [sym_identifier] = ACTIONS(4188),
    [sym_comment] = ACTIONS(42),
  },
  [1514] = {
    [sym__expression] = STATE(1581),
    [sym_conditional_expression] = STATE(1581),
    [sym_assignment_expression] = STATE(1581),
    [sym_pointer_expression] = STATE(1581),
    [sym_logical_expression] = STATE(1581),
    [sym_bitwise_expression] = STATE(1581),
    [sym_equality_expression] = STATE(1581),
    [sym_relational_expression] = STATE(1581),
    [sym_shift_expression] = STATE(1581),
    [sym_math_expression] = STATE(1581),
    [sym_cast_expression] = STATE(1581),
    [sym_sizeof_expression] = STATE(1581),
    [sym_subscript_expression] = STATE(1581),
    [sym_call_expression] = STATE(1581),
    [sym_field_expression] = STATE(1581),
    [sym_compound_literal_expression] = STATE(1581),
    [sym_parenthesized_expression] = STATE(1581),
    [sym_concatenated_string] = STATE(1581),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(4190),
    [sym_char_literal] = ACTIONS(4190),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(4192),
    [sym_false] = ACTIONS(4192),
    [sym_null] = ACTIONS(4192),
    [sym_identifier] = ACTIONS(4192),
    [sym_comment] = ACTIONS(42),
  },
  [1515] = {
    [anon_sym_while] = ACTIONS(4194),
    [sym_comment] = ACTIONS(42),
  },
  [1516] = {
    [sym_declaration] = STATE(1583),
    [sym__declaration_specifiers] = STATE(773),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym__expression] = STATE(1584),
    [sym_conditional_expression] = STATE(1584),
    [sym_assignment_expression] = STATE(1584),
    [sym_pointer_expression] = STATE(1584),
    [sym_logical_expression] = STATE(1584),
    [sym_bitwise_expression] = STATE(1584),
    [sym_equality_expression] = STATE(1584),
    [sym_relational_expression] = STATE(1584),
    [sym_shift_expression] = STATE(1584),
    [sym_math_expression] = STATE(1584),
    [sym_cast_expression] = STATE(1584),
    [sym_sizeof_expression] = STATE(1584),
    [sym_subscript_expression] = STATE(1584),
    [sym_call_expression] = STATE(1584),
    [sym_field_expression] = STATE(1584),
    [sym_compound_literal_expression] = STATE(1584),
    [sym_parenthesized_expression] = STATE(1584),
    [sym_concatenated_string] = STATE(1584),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(4196),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(4198),
    [sym_char_literal] = ACTIONS(4198),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(4200),
    [sym_false] = ACTIONS(4200),
    [sym_null] = ACTIONS(4200),
    [sym_identifier] = ACTIONS(1795),
    [sym_comment] = ACTIONS(42),
  },
  [1517] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1797),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1797),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1797),
    [sym_preproc_directive] = ACTIONS(1797),
    [anon_sym_SEMI] = ACTIONS(1799),
    [anon_sym_typedef] = ACTIONS(1797),
    [anon_sym_extern] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1799),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_static] = ACTIONS(1797),
    [anon_sym_auto] = ACTIONS(1797),
    [anon_sym_register] = ACTIONS(1797),
    [anon_sym_inline] = ACTIONS(1797),
    [anon_sym_const] = ACTIONS(1797),
    [anon_sym_restrict] = ACTIONS(1797),
    [anon_sym_volatile] = ACTIONS(1797),
    [anon_sym__Atomic] = ACTIONS(1797),
    [anon_sym_unsigned] = ACTIONS(1797),
    [anon_sym_long] = ACTIONS(1797),
    [anon_sym_short] = ACTIONS(1797),
    [sym_primitive_type] = ACTIONS(1797),
    [anon_sym_enum] = ACTIONS(1797),
    [anon_sym_struct] = ACTIONS(1797),
    [anon_sym_union] = ACTIONS(1797),
    [anon_sym_if] = ACTIONS(1797),
    [anon_sym_else] = ACTIONS(1797),
    [anon_sym_switch] = ACTIONS(1797),
    [anon_sym_case] = ACTIONS(1797),
    [anon_sym_default] = ACTIONS(1797),
    [anon_sym_while] = ACTIONS(1797),
    [anon_sym_do] = ACTIONS(1797),
    [anon_sym_for] = ACTIONS(1797),
    [anon_sym_return] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1797),
    [anon_sym_continue] = ACTIONS(1797),
    [anon_sym_goto] = ACTIONS(1797),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1799),
    [anon_sym_PLUS] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_DASH_DASH] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1799),
    [anon_sym_sizeof] = ACTIONS(1797),
    [sym_number_literal] = ACTIONS(1799),
    [sym_char_literal] = ACTIONS(1799),
    [sym_string_literal] = ACTIONS(1799),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [sym_null] = ACTIONS(1797),
    [sym_identifier] = ACTIONS(1797),
    [sym_comment] = ACTIONS(42),
  },
  [1518] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(4202),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1519] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1803),
    [anon_sym_LPAREN] = ACTIONS(1805),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1803),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1803),
    [sym_preproc_directive] = ACTIONS(1803),
    [anon_sym_SEMI] = ACTIONS(1805),
    [anon_sym_typedef] = ACTIONS(1803),
    [anon_sym_extern] = ACTIONS(1803),
    [anon_sym_LBRACE] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_static] = ACTIONS(1803),
    [anon_sym_auto] = ACTIONS(1803),
    [anon_sym_register] = ACTIONS(1803),
    [anon_sym_inline] = ACTIONS(1803),
    [anon_sym_const] = ACTIONS(1803),
    [anon_sym_restrict] = ACTIONS(1803),
    [anon_sym_volatile] = ACTIONS(1803),
    [anon_sym__Atomic] = ACTIONS(1803),
    [anon_sym_unsigned] = ACTIONS(1803),
    [anon_sym_long] = ACTIONS(1803),
    [anon_sym_short] = ACTIONS(1803),
    [sym_primitive_type] = ACTIONS(1803),
    [anon_sym_enum] = ACTIONS(1803),
    [anon_sym_struct] = ACTIONS(1803),
    [anon_sym_union] = ACTIONS(1803),
    [anon_sym_if] = ACTIONS(1803),
    [anon_sym_else] = ACTIONS(1803),
    [anon_sym_switch] = ACTIONS(1803),
    [anon_sym_case] = ACTIONS(1803),
    [anon_sym_default] = ACTIONS(1803),
    [anon_sym_while] = ACTIONS(1803),
    [anon_sym_do] = ACTIONS(1803),
    [anon_sym_for] = ACTIONS(1803),
    [anon_sym_return] = ACTIONS(1803),
    [anon_sym_break] = ACTIONS(1803),
    [anon_sym_continue] = ACTIONS(1803),
    [anon_sym_goto] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1803),
    [anon_sym_DASH] = ACTIONS(1803),
    [anon_sym_DASH_DASH] = ACTIONS(1805),
    [anon_sym_PLUS_PLUS] = ACTIONS(1805),
    [anon_sym_sizeof] = ACTIONS(1803),
    [sym_number_literal] = ACTIONS(1805),
    [sym_char_literal] = ACTIONS(1805),
    [sym_string_literal] = ACTIONS(1805),
    [sym_true] = ACTIONS(1803),
    [sym_false] = ACTIONS(1803),
    [sym_null] = ACTIONS(1803),
    [sym_identifier] = ACTIONS(1803),
    [sym_comment] = ACTIONS(42),
  },
  [1520] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1807),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1807),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1807),
    [sym_preproc_directive] = ACTIONS(1807),
    [anon_sym_SEMI] = ACTIONS(1809),
    [anon_sym_typedef] = ACTIONS(1807),
    [anon_sym_extern] = ACTIONS(1807),
    [anon_sym_LBRACE] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_static] = ACTIONS(1807),
    [anon_sym_auto] = ACTIONS(1807),
    [anon_sym_register] = ACTIONS(1807),
    [anon_sym_inline] = ACTIONS(1807),
    [anon_sym_const] = ACTIONS(1807),
    [anon_sym_restrict] = ACTIONS(1807),
    [anon_sym_volatile] = ACTIONS(1807),
    [anon_sym__Atomic] = ACTIONS(1807),
    [anon_sym_unsigned] = ACTIONS(1807),
    [anon_sym_long] = ACTIONS(1807),
    [anon_sym_short] = ACTIONS(1807),
    [sym_primitive_type] = ACTIONS(1807),
    [anon_sym_enum] = ACTIONS(1807),
    [anon_sym_struct] = ACTIONS(1807),
    [anon_sym_union] = ACTIONS(1807),
    [anon_sym_if] = ACTIONS(1807),
    [anon_sym_else] = ACTIONS(1807),
    [anon_sym_switch] = ACTIONS(1807),
    [anon_sym_case] = ACTIONS(1807),
    [anon_sym_default] = ACTIONS(1807),
    [anon_sym_while] = ACTIONS(1807),
    [anon_sym_do] = ACTIONS(1807),
    [anon_sym_for] = ACTIONS(1807),
    [anon_sym_return] = ACTIONS(1807),
    [anon_sym_break] = ACTIONS(1807),
    [anon_sym_continue] = ACTIONS(1807),
    [anon_sym_goto] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1809),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1809),
    [anon_sym_PLUS_PLUS] = ACTIONS(1809),
    [anon_sym_sizeof] = ACTIONS(1807),
    [sym_number_literal] = ACTIONS(1809),
    [sym_char_literal] = ACTIONS(1809),
    [sym_string_literal] = ACTIONS(1809),
    [sym_true] = ACTIONS(1807),
    [sym_false] = ACTIONS(1807),
    [sym_null] = ACTIONS(1807),
    [sym_identifier] = ACTIONS(1807),
    [sym_comment] = ACTIONS(42),
  },
  [1521] = {
    [anon_sym_SEMI] = ACTIONS(4204),
    [sym_comment] = ACTIONS(42),
  },
  [1522] = {
    [sym_compound_statement] = STATE(1587),
    [sym_labeled_statement] = STATE(1587),
    [sym_expression_statement] = STATE(1587),
    [sym_if_statement] = STATE(1587),
    [sym_switch_statement] = STATE(1587),
    [sym_case_statement] = STATE(1587),
    [sym_while_statement] = STATE(1587),
    [sym_do_statement] = STATE(1587),
    [sym_for_statement] = STATE(1587),
    [sym_return_statement] = STATE(1587),
    [sym_break_statement] = STATE(1587),
    [sym_continue_statement] = STATE(1587),
    [sym_goto_statement] = STATE(1587),
    [sym__expression] = STATE(1451),
    [sym_comma_expression] = STATE(1452),
    [sym_conditional_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(1451),
    [sym_pointer_expression] = STATE(1451),
    [sym_logical_expression] = STATE(1451),
    [sym_bitwise_expression] = STATE(1451),
    [sym_equality_expression] = STATE(1451),
    [sym_relational_expression] = STATE(1451),
    [sym_shift_expression] = STATE(1451),
    [sym_math_expression] = STATE(1451),
    [sym_cast_expression] = STATE(1451),
    [sym_sizeof_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_call_expression] = STATE(1451),
    [sym_field_expression] = STATE(1451),
    [sym_compound_literal_expression] = STATE(1451),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_concatenated_string] = STATE(1451),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3900),
    [anon_sym_LBRACE] = ACTIONS(3902),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3904),
    [anon_sym_switch] = ACTIONS(3906),
    [anon_sym_case] = ACTIONS(3908),
    [anon_sym_default] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3912),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_for] = ACTIONS(3916),
    [anon_sym_return] = ACTIONS(3918),
    [anon_sym_break] = ACTIONS(3920),
    [anon_sym_continue] = ACTIONS(3922),
    [anon_sym_goto] = ACTIONS(3924),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3926),
    [sym_char_literal] = ACTIONS(3926),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3928),
    [sym_false] = ACTIONS(3928),
    [sym_null] = ACTIONS(3928),
    [sym_identifier] = ACTIONS(3930),
    [sym_comment] = ACTIONS(42),
  },
  [1523] = {
    [sym_compound_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_expression_statement] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_case_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_goto_statement] = STATE(1588),
    [sym__expression] = STATE(954),
    [sym_comma_expression] = STATE(955),
    [sym_conditional_expression] = STATE(954),
    [sym_assignment_expression] = STATE(954),
    [sym_pointer_expression] = STATE(954),
    [sym_logical_expression] = STATE(954),
    [sym_bitwise_expression] = STATE(954),
    [sym_equality_expression] = STATE(954),
    [sym_relational_expression] = STATE(954),
    [sym_shift_expression] = STATE(954),
    [sym_math_expression] = STATE(954),
    [sym_cast_expression] = STATE(954),
    [sym_sizeof_expression] = STATE(954),
    [sym_subscript_expression] = STATE(954),
    [sym_call_expression] = STATE(954),
    [sym_field_expression] = STATE(954),
    [sym_compound_literal_expression] = STATE(954),
    [sym_parenthesized_expression] = STATE(954),
    [sym_concatenated_string] = STATE(954),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(2497),
    [anon_sym_switch] = ACTIONS(2499),
    [anon_sym_case] = ACTIONS(2501),
    [anon_sym_default] = ACTIONS(2503),
    [anon_sym_while] = ACTIONS(2505),
    [anon_sym_do] = ACTIONS(2507),
    [anon_sym_for] = ACTIONS(2509),
    [anon_sym_return] = ACTIONS(2511),
    [anon_sym_break] = ACTIONS(2513),
    [anon_sym_continue] = ACTIONS(2515),
    [anon_sym_goto] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(2519),
    [sym_char_literal] = ACTIONS(2519),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(2521),
    [sym_false] = ACTIONS(2521),
    [sym_null] = ACTIONS(2521),
    [sym_identifier] = ACTIONS(3445),
    [sym_comment] = ACTIONS(42),
  },
  [1524] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1849),
    [anon_sym_LPAREN] = ACTIONS(1851),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1849),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1849),
    [sym_preproc_directive] = ACTIONS(1849),
    [anon_sym_SEMI] = ACTIONS(1851),
    [anon_sym_typedef] = ACTIONS(1849),
    [anon_sym_extern] = ACTIONS(1849),
    [anon_sym_LBRACE] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1851),
    [anon_sym_static] = ACTIONS(1849),
    [anon_sym_auto] = ACTIONS(1849),
    [anon_sym_register] = ACTIONS(1849),
    [anon_sym_inline] = ACTIONS(1849),
    [anon_sym_const] = ACTIONS(1849),
    [anon_sym_restrict] = ACTIONS(1849),
    [anon_sym_volatile] = ACTIONS(1849),
    [anon_sym__Atomic] = ACTIONS(1849),
    [anon_sym_unsigned] = ACTIONS(1849),
    [anon_sym_long] = ACTIONS(1849),
    [anon_sym_short] = ACTIONS(1849),
    [sym_primitive_type] = ACTIONS(1849),
    [anon_sym_enum] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1849),
    [anon_sym_union] = ACTIONS(1849),
    [anon_sym_if] = ACTIONS(1849),
    [anon_sym_else] = ACTIONS(1849),
    [anon_sym_switch] = ACTIONS(1849),
    [anon_sym_case] = ACTIONS(1849),
    [anon_sym_default] = ACTIONS(1849),
    [anon_sym_while] = ACTIONS(1849),
    [anon_sym_do] = ACTIONS(1849),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(1849),
    [anon_sym_break] = ACTIONS(1849),
    [anon_sym_continue] = ACTIONS(1849),
    [anon_sym_goto] = ACTIONS(1849),
    [anon_sym_AMP] = ACTIONS(1851),
    [anon_sym_BANG] = ACTIONS(1851),
    [anon_sym_TILDE] = ACTIONS(1851),
    [anon_sym_PLUS] = ACTIONS(1849),
    [anon_sym_DASH] = ACTIONS(1849),
    [anon_sym_DASH_DASH] = ACTIONS(1851),
    [anon_sym_PLUS_PLUS] = ACTIONS(1851),
    [anon_sym_sizeof] = ACTIONS(1849),
    [sym_number_literal] = ACTIONS(1851),
    [sym_char_literal] = ACTIONS(1851),
    [sym_string_literal] = ACTIONS(1851),
    [sym_true] = ACTIONS(1849),
    [sym_false] = ACTIONS(1849),
    [sym_null] = ACTIONS(1849),
    [sym_identifier] = ACTIONS(1849),
    [sym_comment] = ACTIONS(42),
  },
  [1525] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3868),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3868),
    [sym_preproc_directive] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3870),
    [anon_sym_typedef] = ACTIONS(3868),
    [anon_sym_extern] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3870),
    [anon_sym_STAR] = ACTIONS(3870),
    [anon_sym_static] = ACTIONS(3868),
    [anon_sym_auto] = ACTIONS(3868),
    [anon_sym_register] = ACTIONS(3868),
    [anon_sym_inline] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(3868),
    [anon_sym_restrict] = ACTIONS(3868),
    [anon_sym_volatile] = ACTIONS(3868),
    [anon_sym__Atomic] = ACTIONS(3868),
    [anon_sym_unsigned] = ACTIONS(3868),
    [anon_sym_long] = ACTIONS(3868),
    [anon_sym_short] = ACTIONS(3868),
    [sym_primitive_type] = ACTIONS(3868),
    [anon_sym_enum] = ACTIONS(3868),
    [anon_sym_struct] = ACTIONS(3868),
    [anon_sym_union] = ACTIONS(3868),
    [anon_sym_if] = ACTIONS(3868),
    [anon_sym_switch] = ACTIONS(3868),
    [anon_sym_case] = ACTIONS(3868),
    [anon_sym_default] = ACTIONS(3868),
    [anon_sym_while] = ACTIONS(3868),
    [anon_sym_do] = ACTIONS(3868),
    [anon_sym_for] = ACTIONS(3868),
    [anon_sym_return] = ACTIONS(3868),
    [anon_sym_break] = ACTIONS(3868),
    [anon_sym_continue] = ACTIONS(3868),
    [anon_sym_goto] = ACTIONS(3868),
    [anon_sym_AMP] = ACTIONS(3870),
    [anon_sym_BANG] = ACTIONS(3870),
    [anon_sym_TILDE] = ACTIONS(3870),
    [anon_sym_PLUS] = ACTIONS(3868),
    [anon_sym_DASH] = ACTIONS(3868),
    [anon_sym_DASH_DASH] = ACTIONS(3870),
    [anon_sym_PLUS_PLUS] = ACTIONS(3870),
    [anon_sym_sizeof] = ACTIONS(3868),
    [sym_number_literal] = ACTIONS(3870),
    [sym_char_literal] = ACTIONS(3870),
    [sym_string_literal] = ACTIONS(3870),
    [sym_true] = ACTIONS(3868),
    [sym_false] = ACTIONS(3868),
    [sym_null] = ACTIONS(3868),
    [sym_identifier] = ACTIONS(3868),
    [sym_comment] = ACTIONS(42),
  },
  [1526] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3872),
    [anon_sym_LPAREN] = ACTIONS(3874),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3872),
    [sym_preproc_directive] = ACTIONS(3872),
    [anon_sym_SEMI] = ACTIONS(3874),
    [anon_sym_typedef] = ACTIONS(3872),
    [anon_sym_extern] = ACTIONS(3872),
    [anon_sym_LBRACE] = ACTIONS(3874),
    [anon_sym_STAR] = ACTIONS(3874),
    [anon_sym_static] = ACTIONS(3872),
    [anon_sym_auto] = ACTIONS(3872),
    [anon_sym_register] = ACTIONS(3872),
    [anon_sym_inline] = ACTIONS(3872),
    [anon_sym_const] = ACTIONS(3872),
    [anon_sym_restrict] = ACTIONS(3872),
    [anon_sym_volatile] = ACTIONS(3872),
    [anon_sym__Atomic] = ACTIONS(3872),
    [anon_sym_unsigned] = ACTIONS(3872),
    [anon_sym_long] = ACTIONS(3872),
    [anon_sym_short] = ACTIONS(3872),
    [sym_primitive_type] = ACTIONS(3872),
    [anon_sym_enum] = ACTIONS(3872),
    [anon_sym_struct] = ACTIONS(3872),
    [anon_sym_union] = ACTIONS(3872),
    [anon_sym_if] = ACTIONS(3872),
    [anon_sym_switch] = ACTIONS(3872),
    [anon_sym_case] = ACTIONS(3872),
    [anon_sym_default] = ACTIONS(3872),
    [anon_sym_while] = ACTIONS(3872),
    [anon_sym_do] = ACTIONS(3872),
    [anon_sym_for] = ACTIONS(3872),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_break] = ACTIONS(3872),
    [anon_sym_continue] = ACTIONS(3872),
    [anon_sym_goto] = ACTIONS(3872),
    [anon_sym_AMP] = ACTIONS(3874),
    [anon_sym_BANG] = ACTIONS(3874),
    [anon_sym_TILDE] = ACTIONS(3874),
    [anon_sym_PLUS] = ACTIONS(3872),
    [anon_sym_DASH] = ACTIONS(3872),
    [anon_sym_DASH_DASH] = ACTIONS(3874),
    [anon_sym_PLUS_PLUS] = ACTIONS(3874),
    [anon_sym_sizeof] = ACTIONS(3872),
    [sym_number_literal] = ACTIONS(3874),
    [sym_char_literal] = ACTIONS(3874),
    [sym_string_literal] = ACTIONS(3874),
    [sym_true] = ACTIONS(3872),
    [sym_false] = ACTIONS(3872),
    [sym_null] = ACTIONS(3872),
    [sym_identifier] = ACTIONS(3872),
    [sym_comment] = ACTIONS(42),
  },
  [1527] = {
    [sym_compound_statement] = STATE(1589),
    [sym_labeled_statement] = STATE(1589),
    [sym_expression_statement] = STATE(1589),
    [sym_if_statement] = STATE(1589),
    [sym_switch_statement] = STATE(1589),
    [sym_case_statement] = STATE(1589),
    [sym_while_statement] = STATE(1589),
    [sym_do_statement] = STATE(1589),
    [sym_for_statement] = STATE(1589),
    [sym_return_statement] = STATE(1589),
    [sym_break_statement] = STATE(1589),
    [sym_continue_statement] = STATE(1589),
    [sym_goto_statement] = STATE(1589),
    [sym__expression] = STATE(954),
    [sym_comma_expression] = STATE(955),
    [sym_conditional_expression] = STATE(954),
    [sym_assignment_expression] = STATE(954),
    [sym_pointer_expression] = STATE(954),
    [sym_logical_expression] = STATE(954),
    [sym_bitwise_expression] = STATE(954),
    [sym_equality_expression] = STATE(954),
    [sym_relational_expression] = STATE(954),
    [sym_shift_expression] = STATE(954),
    [sym_math_expression] = STATE(954),
    [sym_cast_expression] = STATE(954),
    [sym_sizeof_expression] = STATE(954),
    [sym_subscript_expression] = STATE(954),
    [sym_call_expression] = STATE(954),
    [sym_field_expression] = STATE(954),
    [sym_compound_literal_expression] = STATE(954),
    [sym_parenthesized_expression] = STATE(954),
    [sym_concatenated_string] = STATE(954),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(2497),
    [anon_sym_switch] = ACTIONS(2499),
    [anon_sym_case] = ACTIONS(2501),
    [anon_sym_default] = ACTIONS(2503),
    [anon_sym_while] = ACTIONS(2505),
    [anon_sym_do] = ACTIONS(2507),
    [anon_sym_for] = ACTIONS(2509),
    [anon_sym_return] = ACTIONS(2511),
    [anon_sym_break] = ACTIONS(2513),
    [anon_sym_continue] = ACTIONS(2515),
    [anon_sym_goto] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(2519),
    [sym_char_literal] = ACTIONS(2519),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(2521),
    [sym_false] = ACTIONS(2521),
    [sym_null] = ACTIONS(2521),
    [sym_identifier] = ACTIONS(3445),
    [sym_comment] = ACTIONS(42),
  },
  [1528] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4206),
    [sym_comment] = ACTIONS(42),
  },
  [1529] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1591),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4206),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1530] = {
    [sym__expression] = STATE(1592),
    [sym_conditional_expression] = STATE(1592),
    [sym_assignment_expression] = STATE(1592),
    [sym_pointer_expression] = STATE(1592),
    [sym_logical_expression] = STATE(1592),
    [sym_bitwise_expression] = STATE(1592),
    [sym_equality_expression] = STATE(1592),
    [sym_relational_expression] = STATE(1592),
    [sym_shift_expression] = STATE(1592),
    [sym_math_expression] = STATE(1592),
    [sym_cast_expression] = STATE(1592),
    [sym_sizeof_expression] = STATE(1592),
    [sym_subscript_expression] = STATE(1592),
    [sym_call_expression] = STATE(1592),
    [sym_field_expression] = STATE(1592),
    [sym_compound_literal_expression] = STATE(1592),
    [sym_parenthesized_expression] = STATE(1592),
    [sym_concatenated_string] = STATE(1592),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(4206),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(4208),
    [sym_char_literal] = ACTIONS(4208),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(4210),
    [sym_false] = ACTIONS(4210),
    [sym_null] = ACTIONS(4210),
    [sym_identifier] = ACTIONS(4210),
    [sym_comment] = ACTIONS(42),
  },
  [1531] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1913),
    [anon_sym_LPAREN] = ACTIONS(1911),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_auto] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [anon_sym_if] = ACTIONS(1913),
    [anon_sym_else] = ACTIONS(1913),
    [anon_sym_switch] = ACTIONS(1913),
    [anon_sym_case] = ACTIONS(1913),
    [anon_sym_default] = ACTIONS(1913),
    [anon_sym_while] = ACTIONS(1913),
    [anon_sym_do] = ACTIONS(1913),
    [anon_sym_for] = ACTIONS(1913),
    [anon_sym_return] = ACTIONS(1913),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1913),
    [anon_sym_goto] = ACTIONS(1913),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1913),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_sizeof] = ACTIONS(1913),
    [sym_number_literal] = ACTIONS(1911),
    [sym_char_literal] = ACTIONS(1911),
    [sym_string_literal] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [sym_null] = ACTIONS(1913),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(42),
  },
  [1532] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(4212),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1533] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(4214),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1534] = {
    [sym_declaration] = STATE(1595),
    [sym_type_definition] = STATE(1595),
    [sym__declaration_specifiers] = STATE(1538),
    [sym_compound_statement] = STATE(1595),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(1595),
    [sym_expression_statement] = STATE(1595),
    [sym_if_statement] = STATE(1595),
    [sym_switch_statement] = STATE(1595),
    [sym_case_statement] = STATE(1595),
    [sym_while_statement] = STATE(1595),
    [sym_do_statement] = STATE(1595),
    [sym_for_statement] = STATE(1595),
    [sym_return_statement] = STATE(1595),
    [sym_break_statement] = STATE(1595),
    [sym_continue_statement] = STATE(1595),
    [sym_goto_statement] = STATE(1595),
    [sym__expression] = STATE(1385),
    [sym_comma_expression] = STATE(1386),
    [sym_conditional_expression] = STATE(1385),
    [sym_assignment_expression] = STATE(1385),
    [sym_pointer_expression] = STATE(1385),
    [sym_logical_expression] = STATE(1385),
    [sym_bitwise_expression] = STATE(1385),
    [sym_equality_expression] = STATE(1385),
    [sym_relational_expression] = STATE(1385),
    [sym_shift_expression] = STATE(1385),
    [sym_math_expression] = STATE(1385),
    [sym_cast_expression] = STATE(1385),
    [sym_sizeof_expression] = STATE(1385),
    [sym_subscript_expression] = STATE(1385),
    [sym_call_expression] = STATE(1385),
    [sym_field_expression] = STATE(1385),
    [sym_compound_literal_expression] = STATE(1385),
    [sym_parenthesized_expression] = STATE(1385),
    [sym_concatenated_string] = STATE(1385),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3754),
    [anon_sym_typedef] = ACTIONS(4106),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(3756),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(3758),
    [anon_sym_switch] = ACTIONS(3760),
    [anon_sym_case] = ACTIONS(3762),
    [anon_sym_default] = ACTIONS(3764),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3772),
    [anon_sym_break] = ACTIONS(3774),
    [anon_sym_continue] = ACTIONS(3776),
    [anon_sym_goto] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3780),
    [sym_char_literal] = ACTIONS(3780),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3782),
    [sym_false] = ACTIONS(3782),
    [sym_null] = ACTIONS(3782),
    [sym_identifier] = ACTIONS(4108),
    [sym_comment] = ACTIONS(42),
  },
  [1535] = {
    [sym_type_qualifier] = STATE(1597),
    [sym__type_specifier] = STATE(1596),
    [sym_sized_type_specifier] = STATE(1596),
    [sym_enum_specifier] = STATE(1596),
    [sym_struct_specifier] = STATE(1596),
    [sym_union_specifier] = STATE(1596),
    [sym_macro_type_specifier] = STATE(1596),
    [aux_sym_type_definition_repeat1] = STATE(1597),
    [aux_sym_sized_type_specifier_repeat1] = STATE(36),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(62),
    [anon_sym_long] = ACTIONS(62),
    [anon_sym_short] = ACTIONS(62),
    [sym_primitive_type] = ACTIONS(4216),
    [anon_sym_enum] = ACTIONS(66),
    [anon_sym_struct] = ACTIONS(68),
    [anon_sym_union] = ACTIONS(70),
    [sym_identifier] = ACTIONS(72),
    [sym_comment] = ACTIONS(42),
  },
  [1536] = {
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_extern] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_auto] = ACTIONS(95),
    [anon_sym_register] = ACTIONS(95),
    [anon_sym_inline] = ACTIONS(95),
    [anon_sym_const] = ACTIONS(95),
    [anon_sym_restrict] = ACTIONS(95),
    [anon_sym_volatile] = ACTIONS(95),
    [anon_sym__Atomic] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(3976),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_identifier] = ACTIONS(95),
    [sym_comment] = ACTIONS(42),
  },
  [1537] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2687),
    [sym_preproc_directive] = ACTIONS(2687),
    [anon_sym_SEMI] = ACTIONS(2689),
    [anon_sym_typedef] = ACTIONS(2687),
    [anon_sym_extern] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_STAR] = ACTIONS(2689),
    [anon_sym_static] = ACTIONS(2687),
    [anon_sym_auto] = ACTIONS(2687),
    [anon_sym_register] = ACTIONS(2687),
    [anon_sym_inline] = ACTIONS(2687),
    [anon_sym_const] = ACTIONS(2687),
    [anon_sym_restrict] = ACTIONS(2687),
    [anon_sym_volatile] = ACTIONS(2687),
    [anon_sym__Atomic] = ACTIONS(2687),
    [anon_sym_unsigned] = ACTIONS(2687),
    [anon_sym_long] = ACTIONS(2687),
    [anon_sym_short] = ACTIONS(2687),
    [sym_primitive_type] = ACTIONS(2687),
    [anon_sym_enum] = ACTIONS(2687),
    [anon_sym_struct] = ACTIONS(2687),
    [anon_sym_union] = ACTIONS(2687),
    [anon_sym_if] = ACTIONS(2687),
    [anon_sym_else] = ACTIONS(2687),
    [anon_sym_switch] = ACTIONS(2687),
    [anon_sym_case] = ACTIONS(2687),
    [anon_sym_default] = ACTIONS(2687),
    [anon_sym_while] = ACTIONS(2687),
    [anon_sym_do] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2687),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_break] = ACTIONS(2687),
    [anon_sym_continue] = ACTIONS(2687),
    [anon_sym_goto] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_BANG] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2687),
    [anon_sym_DASH] = ACTIONS(2687),
    [anon_sym_DASH_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_PLUS] = ACTIONS(2689),
    [anon_sym_sizeof] = ACTIONS(2687),
    [sym_number_literal] = ACTIONS(2689),
    [sym_char_literal] = ACTIONS(2689),
    [sym_string_literal] = ACTIONS(2689),
    [sym_true] = ACTIONS(2687),
    [sym_false] = ACTIONS(2687),
    [sym_null] = ACTIONS(2687),
    [sym_identifier] = ACTIONS(2687),
    [sym_comment] = ACTIONS(42),
  },
  [1538] = {
    [sym__declarator] = STATE(1598),
    [sym_pointer_declarator] = STATE(1598),
    [sym_function_declarator] = STATE(1598),
    [sym_array_declarator] = STATE(1598),
    [sym_init_declarator] = STATE(1599),
    [anon_sym_LPAREN] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(561),
    [sym_identifier] = ACTIONS(4218),
    [sym_comment] = ACTIONS(42),
  },
  [1539] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(4220),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1540] = {
    [anon_sym_LPAREN] = ACTIONS(4222),
    [sym_comment] = ACTIONS(42),
  },
  [1541] = {
    [sym__expression] = STATE(1603),
    [sym_conditional_expression] = STATE(1603),
    [sym_assignment_expression] = STATE(1603),
    [sym_pointer_expression] = STATE(1603),
    [sym_logical_expression] = STATE(1603),
    [sym_bitwise_expression] = STATE(1603),
    [sym_equality_expression] = STATE(1603),
    [sym_relational_expression] = STATE(1603),
    [sym_shift_expression] = STATE(1603),
    [sym_math_expression] = STATE(1603),
    [sym_cast_expression] = STATE(1603),
    [sym_sizeof_expression] = STATE(1603),
    [sym_subscript_expression] = STATE(1603),
    [sym_call_expression] = STATE(1603),
    [sym_field_expression] = STATE(1603),
    [sym_compound_literal_expression] = STATE(1603),
    [sym_parenthesized_expression] = STATE(1603),
    [sym_concatenated_string] = STATE(1603),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(4224),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(4226),
    [sym_char_literal] = ACTIONS(4226),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(4228),
    [sym_false] = ACTIONS(4228),
    [sym_null] = ACTIONS(4228),
    [sym_identifier] = ACTIONS(4228),
    [sym_comment] = ACTIONS(42),
  },
  [1542] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(4230),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1543] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2727),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2727),
    [sym_preproc_directive] = ACTIONS(2727),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym_typedef] = ACTIONS(2727),
    [anon_sym_extern] = ACTIONS(2727),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_auto] = ACTIONS(2727),
    [anon_sym_register] = ACTIONS(2727),
    [anon_sym_inline] = ACTIONS(2727),
    [anon_sym_const] = ACTIONS(2727),
    [anon_sym_restrict] = ACTIONS(2727),
    [anon_sym_volatile] = ACTIONS(2727),
    [anon_sym__Atomic] = ACTIONS(2727),
    [anon_sym_unsigned] = ACTIONS(2727),
    [anon_sym_long] = ACTIONS(2727),
    [anon_sym_short] = ACTIONS(2727),
    [sym_primitive_type] = ACTIONS(2727),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_struct] = ACTIONS(2727),
    [anon_sym_union] = ACTIONS(2727),
    [anon_sym_if] = ACTIONS(2727),
    [anon_sym_else] = ACTIONS(2727),
    [anon_sym_switch] = ACTIONS(2727),
    [anon_sym_case] = ACTIONS(2727),
    [anon_sym_default] = ACTIONS(2727),
    [anon_sym_while] = ACTIONS(2727),
    [anon_sym_do] = ACTIONS(2727),
    [anon_sym_for] = ACTIONS(2727),
    [anon_sym_return] = ACTIONS(2727),
    [anon_sym_break] = ACTIONS(2727),
    [anon_sym_continue] = ACTIONS(2727),
    [anon_sym_goto] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_BANG] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2727),
    [anon_sym_DASH] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_sizeof] = ACTIONS(2727),
    [sym_number_literal] = ACTIONS(2729),
    [sym_char_literal] = ACTIONS(2729),
    [sym_string_literal] = ACTIONS(2729),
    [sym_true] = ACTIONS(2727),
    [sym_false] = ACTIONS(2727),
    [sym_null] = ACTIONS(2727),
    [sym_identifier] = ACTIONS(2727),
    [sym_comment] = ACTIONS(42),
  },
  [1544] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2731),
    [anon_sym_LPAREN] = ACTIONS(2733),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_auto] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_else] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_case] = ACTIONS(2731),
    [anon_sym_default] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [sym_number_literal] = ACTIONS(2733),
    [sym_char_literal] = ACTIONS(2733),
    [sym_string_literal] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [sym_null] = ACTIONS(2731),
    [sym_identifier] = ACTIONS(2731),
    [sym_comment] = ACTIONS(42),
  },
  [1545] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2746),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(2744),
    [sym_preproc_directive] = ACTIONS(2744),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_typedef] = ACTIONS(2744),
    [anon_sym_extern] = ACTIONS(2744),
    [anon_sym_LBRACE] = ACTIONS(2746),
    [anon_sym_STAR] = ACTIONS(2746),
    [anon_sym_static] = ACTIONS(2744),
    [anon_sym_auto] = ACTIONS(2744),
    [anon_sym_register] = ACTIONS(2744),
    [anon_sym_inline] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_restrict] = ACTIONS(2744),
    [anon_sym_volatile] = ACTIONS(2744),
    [anon_sym__Atomic] = ACTIONS(2744),
    [anon_sym_unsigned] = ACTIONS(2744),
    [anon_sym_long] = ACTIONS(2744),
    [anon_sym_short] = ACTIONS(2744),
    [sym_primitive_type] = ACTIONS(2744),
    [anon_sym_enum] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_union] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_else] = ACTIONS(2744),
    [anon_sym_switch] = ACTIONS(2744),
    [anon_sym_case] = ACTIONS(2744),
    [anon_sym_default] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [anon_sym_do] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_break] = ACTIONS(2744),
    [anon_sym_continue] = ACTIONS(2744),
    [anon_sym_goto] = ACTIONS(2744),
    [anon_sym_AMP] = ACTIONS(2746),
    [anon_sym_BANG] = ACTIONS(2746),
    [anon_sym_TILDE] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_DASH] = ACTIONS(2744),
    [anon_sym_DASH_DASH] = ACTIONS(2746),
    [anon_sym_PLUS_PLUS] = ACTIONS(2746),
    [anon_sym_sizeof] = ACTIONS(2744),
    [sym_number_literal] = ACTIONS(2746),
    [sym_char_literal] = ACTIONS(2746),
    [sym_string_literal] = ACTIONS(2746),
    [sym_true] = ACTIONS(2744),
    [sym_false] = ACTIONS(2744),
    [sym_null] = ACTIONS(2744),
    [sym_identifier] = ACTIONS(2744),
    [sym_comment] = ACTIONS(42),
  },
  [1546] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4012),
    [anon_sym_LPAREN] = ACTIONS(4014),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4012),
    [sym_preproc_directive] = ACTIONS(4012),
    [anon_sym_SEMI] = ACTIONS(4014),
    [anon_sym_typedef] = ACTIONS(4012),
    [anon_sym_extern] = ACTIONS(4012),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_STAR] = ACTIONS(4014),
    [anon_sym_static] = ACTIONS(4012),
    [anon_sym_auto] = ACTIONS(4012),
    [anon_sym_register] = ACTIONS(4012),
    [anon_sym_inline] = ACTIONS(4012),
    [anon_sym_const] = ACTIONS(4012),
    [anon_sym_restrict] = ACTIONS(4012),
    [anon_sym_volatile] = ACTIONS(4012),
    [anon_sym__Atomic] = ACTIONS(4012),
    [anon_sym_unsigned] = ACTIONS(4012),
    [anon_sym_long] = ACTIONS(4012),
    [anon_sym_short] = ACTIONS(4012),
    [sym_primitive_type] = ACTIONS(4012),
    [anon_sym_enum] = ACTIONS(4012),
    [anon_sym_struct] = ACTIONS(4012),
    [anon_sym_union] = ACTIONS(4012),
    [anon_sym_if] = ACTIONS(4012),
    [anon_sym_switch] = ACTIONS(4012),
    [anon_sym_case] = ACTIONS(4012),
    [anon_sym_default] = ACTIONS(4012),
    [anon_sym_while] = ACTIONS(4012),
    [anon_sym_do] = ACTIONS(4012),
    [anon_sym_for] = ACTIONS(4012),
    [anon_sym_return] = ACTIONS(4012),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_continue] = ACTIONS(4012),
    [anon_sym_goto] = ACTIONS(4012),
    [anon_sym_AMP] = ACTIONS(4014),
    [anon_sym_BANG] = ACTIONS(4014),
    [anon_sym_TILDE] = ACTIONS(4014),
    [anon_sym_PLUS] = ACTIONS(4012),
    [anon_sym_DASH] = ACTIONS(4012),
    [anon_sym_DASH_DASH] = ACTIONS(4014),
    [anon_sym_PLUS_PLUS] = ACTIONS(4014),
    [anon_sym_sizeof] = ACTIONS(4012),
    [sym_number_literal] = ACTIONS(4014),
    [sym_char_literal] = ACTIONS(4014),
    [sym_string_literal] = ACTIONS(4014),
    [sym_true] = ACTIONS(4012),
    [sym_false] = ACTIONS(4012),
    [sym_null] = ACTIONS(4012),
    [sym_identifier] = ACTIONS(4012),
    [sym_comment] = ACTIONS(42),
  },
  [1547] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4044),
    [anon_sym_LPAREN] = ACTIONS(4046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4044),
    [sym_preproc_directive] = ACTIONS(4044),
    [anon_sym_SEMI] = ACTIONS(4046),
    [anon_sym_typedef] = ACTIONS(4044),
    [anon_sym_extern] = ACTIONS(4044),
    [anon_sym_LBRACE] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(4046),
    [anon_sym_static] = ACTIONS(4044),
    [anon_sym_auto] = ACTIONS(4044),
    [anon_sym_register] = ACTIONS(4044),
    [anon_sym_inline] = ACTIONS(4044),
    [anon_sym_const] = ACTIONS(4044),
    [anon_sym_restrict] = ACTIONS(4044),
    [anon_sym_volatile] = ACTIONS(4044),
    [anon_sym__Atomic] = ACTIONS(4044),
    [anon_sym_unsigned] = ACTIONS(4044),
    [anon_sym_long] = ACTIONS(4044),
    [anon_sym_short] = ACTIONS(4044),
    [sym_primitive_type] = ACTIONS(4044),
    [anon_sym_enum] = ACTIONS(4044),
    [anon_sym_struct] = ACTIONS(4044),
    [anon_sym_union] = ACTIONS(4044),
    [anon_sym_if] = ACTIONS(4044),
    [anon_sym_switch] = ACTIONS(4044),
    [anon_sym_case] = ACTIONS(4044),
    [anon_sym_default] = ACTIONS(4044),
    [anon_sym_while] = ACTIONS(4044),
    [anon_sym_do] = ACTIONS(4044),
    [anon_sym_for] = ACTIONS(4044),
    [anon_sym_return] = ACTIONS(4044),
    [anon_sym_break] = ACTIONS(4044),
    [anon_sym_continue] = ACTIONS(4044),
    [anon_sym_goto] = ACTIONS(4044),
    [anon_sym_AMP] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(4046),
    [anon_sym_TILDE] = ACTIONS(4046),
    [anon_sym_PLUS] = ACTIONS(4044),
    [anon_sym_DASH] = ACTIONS(4044),
    [anon_sym_DASH_DASH] = ACTIONS(4046),
    [anon_sym_PLUS_PLUS] = ACTIONS(4046),
    [anon_sym_sizeof] = ACTIONS(4044),
    [sym_number_literal] = ACTIONS(4046),
    [sym_char_literal] = ACTIONS(4046),
    [sym_string_literal] = ACTIONS(4046),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [sym_null] = ACTIONS(4044),
    [sym_identifier] = ACTIONS(4044),
    [sym_comment] = ACTIONS(42),
  },
  [1548] = {
    [sym_compound_statement] = STATE(1605),
    [sym_labeled_statement] = STATE(1605),
    [sym_expression_statement] = STATE(1605),
    [sym_if_statement] = STATE(1605),
    [sym_switch_statement] = STATE(1605),
    [sym_case_statement] = STATE(1605),
    [sym_while_statement] = STATE(1605),
    [sym_do_statement] = STATE(1605),
    [sym_for_statement] = STATE(1605),
    [sym_return_statement] = STATE(1605),
    [sym_break_statement] = STATE(1605),
    [sym_continue_statement] = STATE(1605),
    [sym_goto_statement] = STATE(1605),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(3040),
    [sym_comment] = ACTIONS(42),
  },
  [1549] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4232),
    [sym_comment] = ACTIONS(42),
  },
  [1550] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1607),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4232),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1551] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3605),
    [anon_sym_LPAREN] = ACTIONS(3607),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3605),
    [sym_preproc_directive] = ACTIONS(3605),
    [anon_sym_SEMI] = ACTIONS(3607),
    [anon_sym_typedef] = ACTIONS(3605),
    [anon_sym_extern] = ACTIONS(3605),
    [anon_sym_LBRACE] = ACTIONS(3607),
    [anon_sym_RBRACE] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(3607),
    [anon_sym_static] = ACTIONS(3605),
    [anon_sym_auto] = ACTIONS(3605),
    [anon_sym_register] = ACTIONS(3605),
    [anon_sym_inline] = ACTIONS(3605),
    [anon_sym_const] = ACTIONS(3605),
    [anon_sym_restrict] = ACTIONS(3605),
    [anon_sym_volatile] = ACTIONS(3605),
    [anon_sym__Atomic] = ACTIONS(3605),
    [anon_sym_unsigned] = ACTIONS(3605),
    [anon_sym_long] = ACTIONS(3605),
    [anon_sym_short] = ACTIONS(3605),
    [sym_primitive_type] = ACTIONS(3605),
    [anon_sym_enum] = ACTIONS(3605),
    [anon_sym_struct] = ACTIONS(3605),
    [anon_sym_union] = ACTIONS(3605),
    [anon_sym_if] = ACTIONS(3605),
    [anon_sym_else] = ACTIONS(4234),
    [anon_sym_switch] = ACTIONS(3605),
    [anon_sym_case] = ACTIONS(3605),
    [anon_sym_default] = ACTIONS(3605),
    [anon_sym_while] = ACTIONS(3605),
    [anon_sym_do] = ACTIONS(3605),
    [anon_sym_for] = ACTIONS(3605),
    [anon_sym_return] = ACTIONS(3605),
    [anon_sym_break] = ACTIONS(3605),
    [anon_sym_continue] = ACTIONS(3605),
    [anon_sym_goto] = ACTIONS(3605),
    [anon_sym_AMP] = ACTIONS(3607),
    [anon_sym_BANG] = ACTIONS(3607),
    [anon_sym_TILDE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3605),
    [anon_sym_DASH] = ACTIONS(3605),
    [anon_sym_DASH_DASH] = ACTIONS(3607),
    [anon_sym_PLUS_PLUS] = ACTIONS(3607),
    [anon_sym_sizeof] = ACTIONS(3605),
    [sym_number_literal] = ACTIONS(3607),
    [sym_char_literal] = ACTIONS(3607),
    [sym_string_literal] = ACTIONS(3607),
    [sym_true] = ACTIONS(3605),
    [sym_false] = ACTIONS(3605),
    [sym_null] = ACTIONS(3605),
    [sym_identifier] = ACTIONS(3605),
    [sym_comment] = ACTIONS(42),
  },
  [1552] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3615),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3615),
    [sym_preproc_directive] = ACTIONS(3615),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_typedef] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_STAR] = ACTIONS(3617),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_auto] = ACTIONS(3615),
    [anon_sym_register] = ACTIONS(3615),
    [anon_sym_inline] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_restrict] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym__Atomic] = ACTIONS(3615),
    [anon_sym_unsigned] = ACTIONS(3615),
    [anon_sym_long] = ACTIONS(3615),
    [anon_sym_short] = ACTIONS(3615),
    [sym_primitive_type] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_union] = ACTIONS(3615),
    [anon_sym_if] = ACTIONS(3615),
    [anon_sym_else] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3615),
    [anon_sym_case] = ACTIONS(3615),
    [anon_sym_default] = ACTIONS(3615),
    [anon_sym_while] = ACTIONS(3615),
    [anon_sym_do] = ACTIONS(3615),
    [anon_sym_for] = ACTIONS(3615),
    [anon_sym_return] = ACTIONS(3615),
    [anon_sym_break] = ACTIONS(3615),
    [anon_sym_continue] = ACTIONS(3615),
    [anon_sym_goto] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_DASH_DASH] = ACTIONS(3617),
    [anon_sym_PLUS_PLUS] = ACTIONS(3617),
    [anon_sym_sizeof] = ACTIONS(3615),
    [sym_number_literal] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [sym_string_literal] = ACTIONS(3617),
    [sym_true] = ACTIONS(3615),
    [sym_false] = ACTIONS(3615),
    [sym_null] = ACTIONS(3615),
    [sym_identifier] = ACTIONS(3615),
    [sym_comment] = ACTIONS(42),
  },
  [1553] = {
    [sym_parameter_list] = STATE(200),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_SEMI] = ACTIONS(4236),
    [anon_sym_LBRACK] = ACTIONS(449),
    [sym_comment] = ACTIONS(42),
  },
  [1554] = {
    [sym__type_declarator] = STATE(1610),
    [sym_pointer_type_declarator] = STATE(99),
    [sym_function_type_declarator] = STATE(100),
    [sym_array_type_declarator] = STATE(101),
    [anon_sym_LPAREN] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(187),
    [sym_identifier] = ACTIONS(189),
    [sym_comment] = ACTIONS(42),
  },
  [1555] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(567),
    [anon_sym_LPAREN] = ACTIONS(565),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(567),
    [sym_preproc_directive] = ACTIONS(567),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_typedef] = ACTIONS(567),
    [anon_sym_extern] = ACTIONS(567),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_STAR] = ACTIONS(565),
    [anon_sym_static] = ACTIONS(567),
    [anon_sym_auto] = ACTIONS(567),
    [anon_sym_register] = ACTIONS(567),
    [anon_sym_inline] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_restrict] = ACTIONS(567),
    [anon_sym_volatile] = ACTIONS(567),
    [anon_sym__Atomic] = ACTIONS(567),
    [anon_sym_unsigned] = ACTIONS(567),
    [anon_sym_long] = ACTIONS(567),
    [anon_sym_short] = ACTIONS(567),
    [sym_primitive_type] = ACTIONS(567),
    [anon_sym_enum] = ACTIONS(567),
    [anon_sym_struct] = ACTIONS(567),
    [anon_sym_union] = ACTIONS(567),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_else] = ACTIONS(567),
    [anon_sym_switch] = ACTIONS(567),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_default] = ACTIONS(567),
    [anon_sym_while] = ACTIONS(567),
    [anon_sym_do] = ACTIONS(567),
    [anon_sym_for] = ACTIONS(567),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_break] = ACTIONS(567),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(565),
    [anon_sym_TILDE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_sizeof] = ACTIONS(567),
    [sym_number_literal] = ACTIONS(565),
    [sym_char_literal] = ACTIONS(565),
    [sym_string_literal] = ACTIONS(565),
    [sym_true] = ACTIONS(567),
    [sym_false] = ACTIONS(567),
    [sym_null] = ACTIONS(567),
    [sym_identifier] = ACTIONS(567),
    [sym_comment] = ACTIONS(42),
  },
  [1556] = {
    [aux_sym_declaration_repeat1] = STATE(302),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(4238),
    [sym_comment] = ACTIONS(42),
  },
  [1557] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3627),
    [sym_preproc_directive] = ACTIONS(3627),
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym_typedef] = ACTIONS(3627),
    [anon_sym_extern] = ACTIONS(3627),
    [anon_sym_LBRACE] = ACTIONS(3629),
    [anon_sym_RBRACE] = ACTIONS(3629),
    [anon_sym_STAR] = ACTIONS(3629),
    [anon_sym_static] = ACTIONS(3627),
    [anon_sym_auto] = ACTIONS(3627),
    [anon_sym_register] = ACTIONS(3627),
    [anon_sym_inline] = ACTIONS(3627),
    [anon_sym_const] = ACTIONS(3627),
    [anon_sym_restrict] = ACTIONS(3627),
    [anon_sym_volatile] = ACTIONS(3627),
    [anon_sym__Atomic] = ACTIONS(3627),
    [anon_sym_unsigned] = ACTIONS(3627),
    [anon_sym_long] = ACTIONS(3627),
    [anon_sym_short] = ACTIONS(3627),
    [sym_primitive_type] = ACTIONS(3627),
    [anon_sym_enum] = ACTIONS(3627),
    [anon_sym_struct] = ACTIONS(3627),
    [anon_sym_union] = ACTIONS(3627),
    [anon_sym_if] = ACTIONS(3627),
    [anon_sym_else] = ACTIONS(3627),
    [anon_sym_switch] = ACTIONS(3627),
    [anon_sym_case] = ACTIONS(3627),
    [anon_sym_default] = ACTIONS(3627),
    [anon_sym_while] = ACTIONS(3627),
    [anon_sym_do] = ACTIONS(3627),
    [anon_sym_for] = ACTIONS(3627),
    [anon_sym_return] = ACTIONS(3627),
    [anon_sym_break] = ACTIONS(3627),
    [anon_sym_continue] = ACTIONS(3627),
    [anon_sym_goto] = ACTIONS(3627),
    [anon_sym_AMP] = ACTIONS(3629),
    [anon_sym_BANG] = ACTIONS(3629),
    [anon_sym_TILDE] = ACTIONS(3629),
    [anon_sym_PLUS] = ACTIONS(3627),
    [anon_sym_DASH] = ACTIONS(3627),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_sizeof] = ACTIONS(3627),
    [sym_number_literal] = ACTIONS(3629),
    [sym_char_literal] = ACTIONS(3629),
    [sym_string_literal] = ACTIONS(3629),
    [sym_true] = ACTIONS(3627),
    [sym_false] = ACTIONS(3627),
    [sym_null] = ACTIONS(3627),
    [sym_identifier] = ACTIONS(3627),
    [sym_comment] = ACTIONS(42),
  },
  [1558] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(4240),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1559] = {
    [sym_compound_statement] = STATE(1613),
    [sym_labeled_statement] = STATE(1613),
    [sym_expression_statement] = STATE(1613),
    [sym_if_statement] = STATE(1613),
    [sym_switch_statement] = STATE(1613),
    [sym_case_statement] = STATE(1613),
    [sym_while_statement] = STATE(1613),
    [sym_do_statement] = STATE(1613),
    [sym_for_statement] = STATE(1613),
    [sym_return_statement] = STATE(1613),
    [sym_break_statement] = STATE(1613),
    [sym_continue_statement] = STATE(1613),
    [sym_goto_statement] = STATE(1613),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3173),
    [anon_sym_switch] = ACTIONS(3175),
    [anon_sym_case] = ACTIONS(3177),
    [anon_sym_default] = ACTIONS(3179),
    [anon_sym_while] = ACTIONS(3181),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3185),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3199),
    [sym_comment] = ACTIONS(42),
  },
  [1560] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1615),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4242),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1561] = {
    [sym__expression] = STATE(1616),
    [sym_conditional_expression] = STATE(1616),
    [sym_assignment_expression] = STATE(1616),
    [sym_pointer_expression] = STATE(1616),
    [sym_logical_expression] = STATE(1616),
    [sym_bitwise_expression] = STATE(1616),
    [sym_equality_expression] = STATE(1616),
    [sym_relational_expression] = STATE(1616),
    [sym_shift_expression] = STATE(1616),
    [sym_math_expression] = STATE(1616),
    [sym_cast_expression] = STATE(1616),
    [sym_sizeof_expression] = STATE(1616),
    [sym_subscript_expression] = STATE(1616),
    [sym_call_expression] = STATE(1616),
    [sym_field_expression] = STATE(1616),
    [sym_compound_literal_expression] = STATE(1616),
    [sym_parenthesized_expression] = STATE(1616),
    [sym_concatenated_string] = STATE(1616),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(4242),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(4244),
    [sym_char_literal] = ACTIONS(4244),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(4246),
    [sym_false] = ACTIONS(4246),
    [sym_null] = ACTIONS(4246),
    [sym_identifier] = ACTIONS(4246),
    [sym_comment] = ACTIONS(42),
  },
  [1562] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(4248),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1563] = {
    [sym_compound_statement] = STATE(1618),
    [sym_labeled_statement] = STATE(1618),
    [sym_expression_statement] = STATE(1618),
    [sym_if_statement] = STATE(1618),
    [sym_switch_statement] = STATE(1618),
    [sym_case_statement] = STATE(1618),
    [sym_while_statement] = STATE(1618),
    [sym_do_statement] = STATE(1618),
    [sym_for_statement] = STATE(1618),
    [sym_return_statement] = STATE(1618),
    [sym_break_statement] = STATE(1618),
    [sym_continue_statement] = STATE(1618),
    [sym_goto_statement] = STATE(1618),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3631),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_case] = ACTIONS(3635),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3639),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3643),
    [sym_comment] = ACTIONS(42),
  },
  [1564] = {
    [sym_compound_statement] = STATE(1552),
    [sym_labeled_statement] = STATE(1552),
    [sym_expression_statement] = STATE(1552),
    [sym_if_statement] = STATE(1552),
    [sym_switch_statement] = STATE(1552),
    [sym_case_statement] = STATE(1552),
    [sym_while_statement] = STATE(1552),
    [sym_do_statement] = STATE(1552),
    [sym_for_statement] = STATE(1552),
    [sym_return_statement] = STATE(1552),
    [sym_break_statement] = STATE(1552),
    [sym_continue_statement] = STATE(1552),
    [sym_goto_statement] = STATE(1552),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3631),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_case] = ACTIONS(3635),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3639),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3643),
    [sym_comment] = ACTIONS(42),
  },
  [1565] = {
    [sym_compound_statement] = STATE(1557),
    [sym_labeled_statement] = STATE(1557),
    [sym_expression_statement] = STATE(1557),
    [sym_if_statement] = STATE(1557),
    [sym_switch_statement] = STATE(1557),
    [sym_case_statement] = STATE(1557),
    [sym_while_statement] = STATE(1557),
    [sym_do_statement] = STATE(1557),
    [sym_for_statement] = STATE(1557),
    [sym_return_statement] = STATE(1557),
    [sym_break_statement] = STATE(1557),
    [sym_continue_statement] = STATE(1557),
    [sym_goto_statement] = STATE(1557),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3631),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_case] = ACTIONS(3635),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3639),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3643),
    [sym_comment] = ACTIONS(42),
  },
  [1566] = {
    [sym__expression] = STATE(1620),
    [sym_conditional_expression] = STATE(1620),
    [sym_assignment_expression] = STATE(1620),
    [sym_pointer_expression] = STATE(1620),
    [sym_logical_expression] = STATE(1620),
    [sym_bitwise_expression] = STATE(1620),
    [sym_equality_expression] = STATE(1620),
    [sym_relational_expression] = STATE(1620),
    [sym_shift_expression] = STATE(1620),
    [sym_math_expression] = STATE(1620),
    [sym_cast_expression] = STATE(1620),
    [sym_sizeof_expression] = STATE(1620),
    [sym_subscript_expression] = STATE(1620),
    [sym_call_expression] = STATE(1620),
    [sym_field_expression] = STATE(1620),
    [sym_compound_literal_expression] = STATE(1620),
    [sym_parenthesized_expression] = STATE(1620),
    [sym_concatenated_string] = STATE(1620),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(4250),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(4252),
    [sym_char_literal] = ACTIONS(4252),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(4254),
    [sym_false] = ACTIONS(4254),
    [sym_null] = ACTIONS(4254),
    [sym_identifier] = ACTIONS(4254),
    [sym_comment] = ACTIONS(42),
  },
  [1567] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1568] = {
    [sym__expression] = STATE(1622),
    [sym_conditional_expression] = STATE(1622),
    [sym_assignment_expression] = STATE(1622),
    [sym_pointer_expression] = STATE(1622),
    [sym_logical_expression] = STATE(1622),
    [sym_bitwise_expression] = STATE(1622),
    [sym_equality_expression] = STATE(1622),
    [sym_relational_expression] = STATE(1622),
    [sym_shift_expression] = STATE(1622),
    [sym_math_expression] = STATE(1622),
    [sym_cast_expression] = STATE(1622),
    [sym_sizeof_expression] = STATE(1622),
    [sym_subscript_expression] = STATE(1622),
    [sym_call_expression] = STATE(1622),
    [sym_field_expression] = STATE(1622),
    [sym_compound_literal_expression] = STATE(1622),
    [sym_parenthesized_expression] = STATE(1622),
    [sym_concatenated_string] = STATE(1622),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(4256),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(4258),
    [sym_char_literal] = ACTIONS(4258),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(4260),
    [sym_false] = ACTIONS(4260),
    [sym_null] = ACTIONS(4260),
    [sym_identifier] = ACTIONS(4260),
    [sym_comment] = ACTIONS(42),
  },
  [1569] = {
    [sym_compound_statement] = STATE(1571),
    [sym_labeled_statement] = STATE(1571),
    [sym_expression_statement] = STATE(1571),
    [sym_if_statement] = STATE(1571),
    [sym_switch_statement] = STATE(1571),
    [sym_case_statement] = STATE(1571),
    [sym_while_statement] = STATE(1571),
    [sym_do_statement] = STATE(1571),
    [sym_for_statement] = STATE(1571),
    [sym_return_statement] = STATE(1571),
    [sym_break_statement] = STATE(1571),
    [sym_continue_statement] = STATE(1571),
    [sym_goto_statement] = STATE(1571),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_default] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(1089),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1093),
    [sym_comment] = ACTIONS(42),
  },
  [1570] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4262),
    [sym_comment] = ACTIONS(42),
  },
  [1571] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4264),
    [anon_sym_LPAREN] = ACTIONS(4266),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4264),
    [sym_preproc_directive] = ACTIONS(4264),
    [anon_sym_SEMI] = ACTIONS(4266),
    [anon_sym_typedef] = ACTIONS(4264),
    [anon_sym_extern] = ACTIONS(4264),
    [anon_sym_LBRACE] = ACTIONS(4266),
    [anon_sym_RBRACE] = ACTIONS(4266),
    [anon_sym_STAR] = ACTIONS(4266),
    [anon_sym_static] = ACTIONS(4264),
    [anon_sym_auto] = ACTIONS(4264),
    [anon_sym_register] = ACTIONS(4264),
    [anon_sym_inline] = ACTIONS(4264),
    [anon_sym_const] = ACTIONS(4264),
    [anon_sym_restrict] = ACTIONS(4264),
    [anon_sym_volatile] = ACTIONS(4264),
    [anon_sym__Atomic] = ACTIONS(4264),
    [anon_sym_unsigned] = ACTIONS(4264),
    [anon_sym_long] = ACTIONS(4264),
    [anon_sym_short] = ACTIONS(4264),
    [sym_primitive_type] = ACTIONS(4264),
    [anon_sym_enum] = ACTIONS(4264),
    [anon_sym_struct] = ACTIONS(4264),
    [anon_sym_union] = ACTIONS(4264),
    [anon_sym_if] = ACTIONS(4264),
    [anon_sym_switch] = ACTIONS(4264),
    [anon_sym_case] = ACTIONS(4264),
    [anon_sym_default] = ACTIONS(4264),
    [anon_sym_while] = ACTIONS(4264),
    [anon_sym_do] = ACTIONS(4264),
    [anon_sym_for] = ACTIONS(4264),
    [anon_sym_return] = ACTIONS(4264),
    [anon_sym_break] = ACTIONS(4264),
    [anon_sym_continue] = ACTIONS(4264),
    [anon_sym_goto] = ACTIONS(4264),
    [anon_sym_AMP] = ACTIONS(4266),
    [anon_sym_BANG] = ACTIONS(4266),
    [anon_sym_TILDE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_DASH] = ACTIONS(4264),
    [anon_sym_DASH_DASH] = ACTIONS(4266),
    [anon_sym_PLUS_PLUS] = ACTIONS(4266),
    [anon_sym_sizeof] = ACTIONS(4264),
    [sym_number_literal] = ACTIONS(4266),
    [sym_char_literal] = ACTIONS(4266),
    [sym_string_literal] = ACTIONS(4266),
    [sym_true] = ACTIONS(4264),
    [sym_false] = ACTIONS(4264),
    [sym_null] = ACTIONS(4264),
    [sym_identifier] = ACTIONS(4264),
    [sym_comment] = ACTIONS(42),
  },
  [1572] = {
    [sym_compound_statement] = STATE(1624),
    [sym_labeled_statement] = STATE(1624),
    [sym_expression_statement] = STATE(1624),
    [sym_if_statement] = STATE(1624),
    [sym_switch_statement] = STATE(1624),
    [sym_case_statement] = STATE(1624),
    [sym_while_statement] = STATE(1624),
    [sym_do_statement] = STATE(1624),
    [sym_for_statement] = STATE(1624),
    [sym_return_statement] = STATE(1624),
    [sym_break_statement] = STATE(1624),
    [sym_continue_statement] = STATE(1624),
    [sym_goto_statement] = STATE(1624),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(597),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1835),
    [sym_comment] = ACTIONS(42),
  },
  [1573] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1913),
    [anon_sym_LPAREN] = ACTIONS(1911),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1913),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_auto] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [anon_sym_if] = ACTIONS(1913),
    [anon_sym_else] = ACTIONS(1913),
    [anon_sym_switch] = ACTIONS(1913),
    [anon_sym_case] = ACTIONS(1913),
    [anon_sym_default] = ACTIONS(1913),
    [anon_sym_while] = ACTIONS(1913),
    [anon_sym_do] = ACTIONS(1913),
    [anon_sym_for] = ACTIONS(1913),
    [anon_sym_return] = ACTIONS(1913),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1913),
    [anon_sym_goto] = ACTIONS(1913),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1913),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_sizeof] = ACTIONS(1913),
    [sym_number_literal] = ACTIONS(1911),
    [sym_char_literal] = ACTIONS(1911),
    [sym_string_literal] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [sym_null] = ACTIONS(1913),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(42),
  },
  [1574] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(4268),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1575] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(4270),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1576] = {
    [sym_declaration] = STATE(1627),
    [sym_type_definition] = STATE(1627),
    [sym__declaration_specifiers] = STATE(1580),
    [sym_compound_statement] = STATE(1627),
    [sym_storage_class_specifier] = STATE(111),
    [sym_type_qualifier] = STATE(111),
    [sym__type_specifier] = STATE(110),
    [sym_sized_type_specifier] = STATE(110),
    [sym_enum_specifier] = STATE(110),
    [sym_struct_specifier] = STATE(110),
    [sym_union_specifier] = STATE(110),
    [sym_labeled_statement] = STATE(1627),
    [sym_expression_statement] = STATE(1627),
    [sym_if_statement] = STATE(1627),
    [sym_switch_statement] = STATE(1627),
    [sym_case_statement] = STATE(1627),
    [sym_while_statement] = STATE(1627),
    [sym_do_statement] = STATE(1627),
    [sym_for_statement] = STATE(1627),
    [sym_return_statement] = STATE(1627),
    [sym_break_statement] = STATE(1627),
    [sym_continue_statement] = STATE(1627),
    [sym_goto_statement] = STATE(1627),
    [sym__expression] = STATE(1451),
    [sym_comma_expression] = STATE(1452),
    [sym_conditional_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(1451),
    [sym_pointer_expression] = STATE(1451),
    [sym_logical_expression] = STATE(1451),
    [sym_bitwise_expression] = STATE(1451),
    [sym_equality_expression] = STATE(1451),
    [sym_relational_expression] = STATE(1451),
    [sym_shift_expression] = STATE(1451),
    [sym_math_expression] = STATE(1451),
    [sym_cast_expression] = STATE(1451),
    [sym_sizeof_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_call_expression] = STATE(1451),
    [sym_field_expression] = STATE(1451),
    [sym_compound_literal_expression] = STATE(1451),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_concatenated_string] = STATE(1451),
    [sym_macro_type_specifier] = STATE(110),
    [aux_sym__declaration_specifiers_repeat1] = STATE(111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(112),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3900),
    [anon_sym_typedef] = ACTIONS(4186),
    [anon_sym_extern] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(3902),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(26),
    [anon_sym_auto] = ACTIONS(26),
    [anon_sym_register] = ACTIONS(26),
    [anon_sym_inline] = ACTIONS(26),
    [anon_sym_const] = ACTIONS(28),
    [anon_sym_restrict] = ACTIONS(28),
    [anon_sym_volatile] = ACTIONS(28),
    [anon_sym__Atomic] = ACTIONS(28),
    [anon_sym_unsigned] = ACTIONS(202),
    [anon_sym_long] = ACTIONS(202),
    [anon_sym_short] = ACTIONS(202),
    [sym_primitive_type] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(34),
    [anon_sym_struct] = ACTIONS(36),
    [anon_sym_union] = ACTIONS(38),
    [anon_sym_if] = ACTIONS(3904),
    [anon_sym_switch] = ACTIONS(3906),
    [anon_sym_case] = ACTIONS(3908),
    [anon_sym_default] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3912),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_for] = ACTIONS(3916),
    [anon_sym_return] = ACTIONS(3918),
    [anon_sym_break] = ACTIONS(3920),
    [anon_sym_continue] = ACTIONS(3922),
    [anon_sym_goto] = ACTIONS(3924),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3926),
    [sym_char_literal] = ACTIONS(3926),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3928),
    [sym_false] = ACTIONS(3928),
    [sym_null] = ACTIONS(3928),
    [sym_identifier] = ACTIONS(4188),
    [sym_comment] = ACTIONS(42),
  },
  [1577] = {
    [sym_type_qualifier] = STATE(1629),
    [sym__type_specifier] = STATE(1628),
    [sym_sized_type_specifier] = STATE(1628),
    [sym_enum_specifier] = STATE(1628),
    [sym_struct_specifier] = STATE(1628),
    [sym_union_specifier] = STATE(1628),
    [sym_macro_type_specifier] = STATE(1628),
    [aux_sym_type_definition_repeat1] = STATE(1629),
    [aux_sym_sized_type_specifier_repeat1] = STATE(36),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(62),
    [anon_sym_long] = ACTIONS(62),
    [anon_sym_short] = ACTIONS(62),
    [sym_primitive_type] = ACTIONS(4272),
    [anon_sym_enum] = ACTIONS(66),
    [anon_sym_struct] = ACTIONS(68),
    [anon_sym_union] = ACTIONS(70),
    [sym_identifier] = ACTIONS(72),
    [sym_comment] = ACTIONS(42),
  },
  [1578] = {
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_extern] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_static] = ACTIONS(95),
    [anon_sym_auto] = ACTIONS(95),
    [anon_sym_register] = ACTIONS(95),
    [anon_sym_inline] = ACTIONS(95),
    [anon_sym_const] = ACTIONS(95),
    [anon_sym_restrict] = ACTIONS(95),
    [anon_sym_volatile] = ACTIONS(95),
    [anon_sym__Atomic] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_STAR_EQ] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1127),
    [anon_sym_PERCENT_EQ] = ACTIONS(1127),
    [anon_sym_PLUS_EQ] = ACTIONS(1127),
    [anon_sym_DASH_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_GT_EQ] = ACTIONS(1127),
    [anon_sym_AMP_EQ] = ACTIONS(1127),
    [anon_sym_CARET_EQ] = ACTIONS(1127),
    [anon_sym_PIPE_EQ] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1127),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DASH_GT] = ACTIONS(1127),
    [sym_identifier] = ACTIONS(95),
    [sym_comment] = ACTIONS(42),
  },
  [1579] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2687),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2687),
    [sym_preproc_directive] = ACTIONS(2687),
    [anon_sym_SEMI] = ACTIONS(2689),
    [anon_sym_typedef] = ACTIONS(2687),
    [anon_sym_extern] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_STAR] = ACTIONS(2689),
    [anon_sym_static] = ACTIONS(2687),
    [anon_sym_auto] = ACTIONS(2687),
    [anon_sym_register] = ACTIONS(2687),
    [anon_sym_inline] = ACTIONS(2687),
    [anon_sym_const] = ACTIONS(2687),
    [anon_sym_restrict] = ACTIONS(2687),
    [anon_sym_volatile] = ACTIONS(2687),
    [anon_sym__Atomic] = ACTIONS(2687),
    [anon_sym_unsigned] = ACTIONS(2687),
    [anon_sym_long] = ACTIONS(2687),
    [anon_sym_short] = ACTIONS(2687),
    [sym_primitive_type] = ACTIONS(2687),
    [anon_sym_enum] = ACTIONS(2687),
    [anon_sym_struct] = ACTIONS(2687),
    [anon_sym_union] = ACTIONS(2687),
    [anon_sym_if] = ACTIONS(2687),
    [anon_sym_else] = ACTIONS(2687),
    [anon_sym_switch] = ACTIONS(2687),
    [anon_sym_case] = ACTIONS(2687),
    [anon_sym_default] = ACTIONS(2687),
    [anon_sym_while] = ACTIONS(2687),
    [anon_sym_do] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2687),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_break] = ACTIONS(2687),
    [anon_sym_continue] = ACTIONS(2687),
    [anon_sym_goto] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_BANG] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2687),
    [anon_sym_DASH] = ACTIONS(2687),
    [anon_sym_DASH_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_PLUS] = ACTIONS(2689),
    [anon_sym_sizeof] = ACTIONS(2687),
    [sym_number_literal] = ACTIONS(2689),
    [sym_char_literal] = ACTIONS(2689),
    [sym_string_literal] = ACTIONS(2689),
    [sym_true] = ACTIONS(2687),
    [sym_false] = ACTIONS(2687),
    [sym_null] = ACTIONS(2687),
    [sym_identifier] = ACTIONS(2687),
    [sym_comment] = ACTIONS(42),
  },
  [1580] = {
    [sym__declarator] = STATE(1630),
    [sym_pointer_declarator] = STATE(1630),
    [sym_function_declarator] = STATE(1630),
    [sym_array_declarator] = STATE(1630),
    [sym_init_declarator] = STATE(1631),
    [anon_sym_LPAREN] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(561),
    [sym_identifier] = ACTIONS(4274),
    [sym_comment] = ACTIONS(42),
  },
  [1581] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(4276),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1582] = {
    [anon_sym_LPAREN] = ACTIONS(4278),
    [sym_comment] = ACTIONS(42),
  },
  [1583] = {
    [sym__expression] = STATE(1635),
    [sym_conditional_expression] = STATE(1635),
    [sym_assignment_expression] = STATE(1635),
    [sym_pointer_expression] = STATE(1635),
    [sym_logical_expression] = STATE(1635),
    [sym_bitwise_expression] = STATE(1635),
    [sym_equality_expression] = STATE(1635),
    [sym_relational_expression] = STATE(1635),
    [sym_shift_expression] = STATE(1635),
    [sym_math_expression] = STATE(1635),
    [sym_cast_expression] = STATE(1635),
    [sym_sizeof_expression] = STATE(1635),
    [sym_subscript_expression] = STATE(1635),
    [sym_call_expression] = STATE(1635),
    [sym_field_expression] = STATE(1635),
    [sym_compound_literal_expression] = STATE(1635),
    [sym_parenthesized_expression] = STATE(1635),
    [sym_concatenated_string] = STATE(1635),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(4280),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(4282),
    [sym_char_literal] = ACTIONS(4282),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(4284),
    [sym_false] = ACTIONS(4284),
    [sym_null] = ACTIONS(4284),
    [sym_identifier] = ACTIONS(4284),
    [sym_comment] = ACTIONS(42),
  },
  [1584] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(4286),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1585] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2727),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2727),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2727),
    [sym_preproc_directive] = ACTIONS(2727),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym_typedef] = ACTIONS(2727),
    [anon_sym_extern] = ACTIONS(2727),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_auto] = ACTIONS(2727),
    [anon_sym_register] = ACTIONS(2727),
    [anon_sym_inline] = ACTIONS(2727),
    [anon_sym_const] = ACTIONS(2727),
    [anon_sym_restrict] = ACTIONS(2727),
    [anon_sym_volatile] = ACTIONS(2727),
    [anon_sym__Atomic] = ACTIONS(2727),
    [anon_sym_unsigned] = ACTIONS(2727),
    [anon_sym_long] = ACTIONS(2727),
    [anon_sym_short] = ACTIONS(2727),
    [sym_primitive_type] = ACTIONS(2727),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_struct] = ACTIONS(2727),
    [anon_sym_union] = ACTIONS(2727),
    [anon_sym_if] = ACTIONS(2727),
    [anon_sym_else] = ACTIONS(2727),
    [anon_sym_switch] = ACTIONS(2727),
    [anon_sym_case] = ACTIONS(2727),
    [anon_sym_default] = ACTIONS(2727),
    [anon_sym_while] = ACTIONS(2727),
    [anon_sym_do] = ACTIONS(2727),
    [anon_sym_for] = ACTIONS(2727),
    [anon_sym_return] = ACTIONS(2727),
    [anon_sym_break] = ACTIONS(2727),
    [anon_sym_continue] = ACTIONS(2727),
    [anon_sym_goto] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_BANG] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2727),
    [anon_sym_DASH] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_sizeof] = ACTIONS(2727),
    [sym_number_literal] = ACTIONS(2729),
    [sym_char_literal] = ACTIONS(2729),
    [sym_string_literal] = ACTIONS(2729),
    [sym_true] = ACTIONS(2727),
    [sym_false] = ACTIONS(2727),
    [sym_null] = ACTIONS(2727),
    [sym_identifier] = ACTIONS(2727),
    [sym_comment] = ACTIONS(42),
  },
  [1586] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2731),
    [anon_sym_LPAREN] = ACTIONS(2733),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2731),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_auto] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_else] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_case] = ACTIONS(2731),
    [anon_sym_default] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [sym_number_literal] = ACTIONS(2733),
    [sym_char_literal] = ACTIONS(2733),
    [sym_string_literal] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [sym_null] = ACTIONS(2731),
    [sym_identifier] = ACTIONS(2731),
    [sym_comment] = ACTIONS(42),
  },
  [1587] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2746),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(2744),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(2744),
    [sym_preproc_directive] = ACTIONS(2744),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_typedef] = ACTIONS(2744),
    [anon_sym_extern] = ACTIONS(2744),
    [anon_sym_LBRACE] = ACTIONS(2746),
    [anon_sym_STAR] = ACTIONS(2746),
    [anon_sym_static] = ACTIONS(2744),
    [anon_sym_auto] = ACTIONS(2744),
    [anon_sym_register] = ACTIONS(2744),
    [anon_sym_inline] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_restrict] = ACTIONS(2744),
    [anon_sym_volatile] = ACTIONS(2744),
    [anon_sym__Atomic] = ACTIONS(2744),
    [anon_sym_unsigned] = ACTIONS(2744),
    [anon_sym_long] = ACTIONS(2744),
    [anon_sym_short] = ACTIONS(2744),
    [sym_primitive_type] = ACTIONS(2744),
    [anon_sym_enum] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_union] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_else] = ACTIONS(2744),
    [anon_sym_switch] = ACTIONS(2744),
    [anon_sym_case] = ACTIONS(2744),
    [anon_sym_default] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [anon_sym_do] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_break] = ACTIONS(2744),
    [anon_sym_continue] = ACTIONS(2744),
    [anon_sym_goto] = ACTIONS(2744),
    [anon_sym_AMP] = ACTIONS(2746),
    [anon_sym_BANG] = ACTIONS(2746),
    [anon_sym_TILDE] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_DASH] = ACTIONS(2744),
    [anon_sym_DASH_DASH] = ACTIONS(2746),
    [anon_sym_PLUS_PLUS] = ACTIONS(2746),
    [anon_sym_sizeof] = ACTIONS(2744),
    [sym_number_literal] = ACTIONS(2746),
    [sym_char_literal] = ACTIONS(2746),
    [sym_string_literal] = ACTIONS(2746),
    [sym_true] = ACTIONS(2744),
    [sym_false] = ACTIONS(2744),
    [sym_null] = ACTIONS(2744),
    [sym_identifier] = ACTIONS(2744),
    [sym_comment] = ACTIONS(42),
  },
  [1588] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4012),
    [anon_sym_LPAREN] = ACTIONS(4014),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4012),
    [sym_preproc_directive] = ACTIONS(4012),
    [anon_sym_SEMI] = ACTIONS(4014),
    [anon_sym_typedef] = ACTIONS(4012),
    [anon_sym_extern] = ACTIONS(4012),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_STAR] = ACTIONS(4014),
    [anon_sym_static] = ACTIONS(4012),
    [anon_sym_auto] = ACTIONS(4012),
    [anon_sym_register] = ACTIONS(4012),
    [anon_sym_inline] = ACTIONS(4012),
    [anon_sym_const] = ACTIONS(4012),
    [anon_sym_restrict] = ACTIONS(4012),
    [anon_sym_volatile] = ACTIONS(4012),
    [anon_sym__Atomic] = ACTIONS(4012),
    [anon_sym_unsigned] = ACTIONS(4012),
    [anon_sym_long] = ACTIONS(4012),
    [anon_sym_short] = ACTIONS(4012),
    [sym_primitive_type] = ACTIONS(4012),
    [anon_sym_enum] = ACTIONS(4012),
    [anon_sym_struct] = ACTIONS(4012),
    [anon_sym_union] = ACTIONS(4012),
    [anon_sym_if] = ACTIONS(4012),
    [anon_sym_switch] = ACTIONS(4012),
    [anon_sym_case] = ACTIONS(4012),
    [anon_sym_default] = ACTIONS(4012),
    [anon_sym_while] = ACTIONS(4012),
    [anon_sym_do] = ACTIONS(4012),
    [anon_sym_for] = ACTIONS(4012),
    [anon_sym_return] = ACTIONS(4012),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_continue] = ACTIONS(4012),
    [anon_sym_goto] = ACTIONS(4012),
    [anon_sym_AMP] = ACTIONS(4014),
    [anon_sym_BANG] = ACTIONS(4014),
    [anon_sym_TILDE] = ACTIONS(4014),
    [anon_sym_PLUS] = ACTIONS(4012),
    [anon_sym_DASH] = ACTIONS(4012),
    [anon_sym_DASH_DASH] = ACTIONS(4014),
    [anon_sym_PLUS_PLUS] = ACTIONS(4014),
    [anon_sym_sizeof] = ACTIONS(4012),
    [sym_number_literal] = ACTIONS(4014),
    [sym_char_literal] = ACTIONS(4014),
    [sym_string_literal] = ACTIONS(4014),
    [sym_true] = ACTIONS(4012),
    [sym_false] = ACTIONS(4012),
    [sym_null] = ACTIONS(4012),
    [sym_identifier] = ACTIONS(4012),
    [sym_comment] = ACTIONS(42),
  },
  [1589] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4044),
    [anon_sym_LPAREN] = ACTIONS(4046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4044),
    [sym_preproc_directive] = ACTIONS(4044),
    [anon_sym_SEMI] = ACTIONS(4046),
    [anon_sym_typedef] = ACTIONS(4044),
    [anon_sym_extern] = ACTIONS(4044),
    [anon_sym_LBRACE] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(4046),
    [anon_sym_static] = ACTIONS(4044),
    [anon_sym_auto] = ACTIONS(4044),
    [anon_sym_register] = ACTIONS(4044),
    [anon_sym_inline] = ACTIONS(4044),
    [anon_sym_const] = ACTIONS(4044),
    [anon_sym_restrict] = ACTIONS(4044),
    [anon_sym_volatile] = ACTIONS(4044),
    [anon_sym__Atomic] = ACTIONS(4044),
    [anon_sym_unsigned] = ACTIONS(4044),
    [anon_sym_long] = ACTIONS(4044),
    [anon_sym_short] = ACTIONS(4044),
    [sym_primitive_type] = ACTIONS(4044),
    [anon_sym_enum] = ACTIONS(4044),
    [anon_sym_struct] = ACTIONS(4044),
    [anon_sym_union] = ACTIONS(4044),
    [anon_sym_if] = ACTIONS(4044),
    [anon_sym_switch] = ACTIONS(4044),
    [anon_sym_case] = ACTIONS(4044),
    [anon_sym_default] = ACTIONS(4044),
    [anon_sym_while] = ACTIONS(4044),
    [anon_sym_do] = ACTIONS(4044),
    [anon_sym_for] = ACTIONS(4044),
    [anon_sym_return] = ACTIONS(4044),
    [anon_sym_break] = ACTIONS(4044),
    [anon_sym_continue] = ACTIONS(4044),
    [anon_sym_goto] = ACTIONS(4044),
    [anon_sym_AMP] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(4046),
    [anon_sym_TILDE] = ACTIONS(4046),
    [anon_sym_PLUS] = ACTIONS(4044),
    [anon_sym_DASH] = ACTIONS(4044),
    [anon_sym_DASH_DASH] = ACTIONS(4046),
    [anon_sym_PLUS_PLUS] = ACTIONS(4046),
    [anon_sym_sizeof] = ACTIONS(4044),
    [sym_number_literal] = ACTIONS(4046),
    [sym_char_literal] = ACTIONS(4046),
    [sym_string_literal] = ACTIONS(4046),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [sym_null] = ACTIONS(4044),
    [sym_identifier] = ACTIONS(4044),
    [sym_comment] = ACTIONS(42),
  },
  [1590] = {
    [sym_compound_statement] = STATE(1637),
    [sym_labeled_statement] = STATE(1637),
    [sym_expression_statement] = STATE(1637),
    [sym_if_statement] = STATE(1637),
    [sym_switch_statement] = STATE(1637),
    [sym_case_statement] = STATE(1637),
    [sym_while_statement] = STATE(1637),
    [sym_do_statement] = STATE(1637),
    [sym_for_statement] = STATE(1637),
    [sym_return_statement] = STATE(1637),
    [sym_break_statement] = STATE(1637),
    [sym_continue_statement] = STATE(1637),
    [sym_goto_statement] = STATE(1637),
    [sym__expression] = STATE(954),
    [sym_comma_expression] = STATE(955),
    [sym_conditional_expression] = STATE(954),
    [sym_assignment_expression] = STATE(954),
    [sym_pointer_expression] = STATE(954),
    [sym_logical_expression] = STATE(954),
    [sym_bitwise_expression] = STATE(954),
    [sym_equality_expression] = STATE(954),
    [sym_relational_expression] = STATE(954),
    [sym_shift_expression] = STATE(954),
    [sym_math_expression] = STATE(954),
    [sym_cast_expression] = STATE(954),
    [sym_sizeof_expression] = STATE(954),
    [sym_subscript_expression] = STATE(954),
    [sym_call_expression] = STATE(954),
    [sym_field_expression] = STATE(954),
    [sym_compound_literal_expression] = STATE(954),
    [sym_parenthesized_expression] = STATE(954),
    [sym_concatenated_string] = STATE(954),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(2497),
    [anon_sym_switch] = ACTIONS(2499),
    [anon_sym_case] = ACTIONS(2501),
    [anon_sym_default] = ACTIONS(2503),
    [anon_sym_while] = ACTIONS(2505),
    [anon_sym_do] = ACTIONS(2507),
    [anon_sym_for] = ACTIONS(2509),
    [anon_sym_return] = ACTIONS(2511),
    [anon_sym_break] = ACTIONS(2513),
    [anon_sym_continue] = ACTIONS(2515),
    [anon_sym_goto] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(2519),
    [sym_char_literal] = ACTIONS(2519),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(2521),
    [sym_false] = ACTIONS(2521),
    [sym_null] = ACTIONS(2521),
    [sym_identifier] = ACTIONS(3445),
    [sym_comment] = ACTIONS(42),
  },
  [1591] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4288),
    [sym_comment] = ACTIONS(42),
  },
  [1592] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1639),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4288),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1593] = {
    [sym_compound_statement] = STATE(1640),
    [sym_labeled_statement] = STATE(1640),
    [sym_expression_statement] = STATE(1640),
    [sym_if_statement] = STATE(1640),
    [sym_switch_statement] = STATE(1640),
    [sym_case_statement] = STATE(1640),
    [sym_while_statement] = STATE(1640),
    [sym_do_statement] = STATE(1640),
    [sym_for_statement] = STATE(1640),
    [sym_return_statement] = STATE(1640),
    [sym_break_statement] = STATE(1640),
    [sym_continue_statement] = STATE(1640),
    [sym_goto_statement] = STATE(1640),
    [sym__expression] = STATE(1385),
    [sym_comma_expression] = STATE(1386),
    [sym_conditional_expression] = STATE(1385),
    [sym_assignment_expression] = STATE(1385),
    [sym_pointer_expression] = STATE(1385),
    [sym_logical_expression] = STATE(1385),
    [sym_bitwise_expression] = STATE(1385),
    [sym_equality_expression] = STATE(1385),
    [sym_relational_expression] = STATE(1385),
    [sym_shift_expression] = STATE(1385),
    [sym_math_expression] = STATE(1385),
    [sym_cast_expression] = STATE(1385),
    [sym_sizeof_expression] = STATE(1385),
    [sym_subscript_expression] = STATE(1385),
    [sym_call_expression] = STATE(1385),
    [sym_field_expression] = STATE(1385),
    [sym_compound_literal_expression] = STATE(1385),
    [sym_parenthesized_expression] = STATE(1385),
    [sym_concatenated_string] = STATE(1385),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3754),
    [anon_sym_LBRACE] = ACTIONS(3756),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3758),
    [anon_sym_switch] = ACTIONS(3760),
    [anon_sym_case] = ACTIONS(3762),
    [anon_sym_default] = ACTIONS(3764),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3772),
    [anon_sym_break] = ACTIONS(3774),
    [anon_sym_continue] = ACTIONS(3776),
    [anon_sym_goto] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3780),
    [sym_char_literal] = ACTIONS(3780),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3782),
    [sym_false] = ACTIONS(3782),
    [sym_null] = ACTIONS(3782),
    [sym_identifier] = ACTIONS(3784),
    [sym_comment] = ACTIONS(42),
  },
  [1594] = {
    [sym_compound_statement] = STATE(1641),
    [sym_labeled_statement] = STATE(1641),
    [sym_expression_statement] = STATE(1641),
    [sym_if_statement] = STATE(1641),
    [sym_switch_statement] = STATE(1641),
    [sym_case_statement] = STATE(1641),
    [sym_while_statement] = STATE(1641),
    [sym_do_statement] = STATE(1641),
    [sym_for_statement] = STATE(1641),
    [sym_return_statement] = STATE(1641),
    [sym_break_statement] = STATE(1641),
    [sym_continue_statement] = STATE(1641),
    [sym_goto_statement] = STATE(1641),
    [sym__expression] = STATE(1385),
    [sym_comma_expression] = STATE(1386),
    [sym_conditional_expression] = STATE(1385),
    [sym_assignment_expression] = STATE(1385),
    [sym_pointer_expression] = STATE(1385),
    [sym_logical_expression] = STATE(1385),
    [sym_bitwise_expression] = STATE(1385),
    [sym_equality_expression] = STATE(1385),
    [sym_relational_expression] = STATE(1385),
    [sym_shift_expression] = STATE(1385),
    [sym_math_expression] = STATE(1385),
    [sym_cast_expression] = STATE(1385),
    [sym_sizeof_expression] = STATE(1385),
    [sym_subscript_expression] = STATE(1385),
    [sym_call_expression] = STATE(1385),
    [sym_field_expression] = STATE(1385),
    [sym_compound_literal_expression] = STATE(1385),
    [sym_parenthesized_expression] = STATE(1385),
    [sym_concatenated_string] = STATE(1385),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3754),
    [anon_sym_LBRACE] = ACTIONS(3756),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3758),
    [anon_sym_switch] = ACTIONS(3760),
    [anon_sym_case] = ACTIONS(3762),
    [anon_sym_default] = ACTIONS(3764),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3772),
    [anon_sym_break] = ACTIONS(3774),
    [anon_sym_continue] = ACTIONS(3776),
    [anon_sym_goto] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3780),
    [sym_char_literal] = ACTIONS(3780),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3782),
    [sym_false] = ACTIONS(3782),
    [sym_null] = ACTIONS(3782),
    [sym_identifier] = ACTIONS(3784),
    [sym_comment] = ACTIONS(42),
  },
  [1595] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3250),
    [anon_sym_LPAREN] = ACTIONS(3252),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3250),
    [sym_preproc_directive] = ACTIONS(3250),
    [anon_sym_SEMI] = ACTIONS(3252),
    [anon_sym_typedef] = ACTIONS(3250),
    [anon_sym_extern] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3252),
    [anon_sym_STAR] = ACTIONS(3252),
    [anon_sym_static] = ACTIONS(3250),
    [anon_sym_auto] = ACTIONS(3250),
    [anon_sym_register] = ACTIONS(3250),
    [anon_sym_inline] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(3250),
    [anon_sym_restrict] = ACTIONS(3250),
    [anon_sym_volatile] = ACTIONS(3250),
    [anon_sym__Atomic] = ACTIONS(3250),
    [anon_sym_unsigned] = ACTIONS(3250),
    [anon_sym_long] = ACTIONS(3250),
    [anon_sym_short] = ACTIONS(3250),
    [sym_primitive_type] = ACTIONS(3250),
    [anon_sym_enum] = ACTIONS(3250),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_union] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_else] = ACTIONS(3250),
    [anon_sym_switch] = ACTIONS(3250),
    [anon_sym_case] = ACTIONS(3250),
    [anon_sym_default] = ACTIONS(3250),
    [anon_sym_while] = ACTIONS(3250),
    [anon_sym_do] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_goto] = ACTIONS(3250),
    [anon_sym_AMP] = ACTIONS(3252),
    [anon_sym_BANG] = ACTIONS(3252),
    [anon_sym_TILDE] = ACTIONS(3252),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3252),
    [anon_sym_PLUS_PLUS] = ACTIONS(3252),
    [anon_sym_sizeof] = ACTIONS(3250),
    [sym_number_literal] = ACTIONS(3252),
    [sym_char_literal] = ACTIONS(3252),
    [sym_string_literal] = ACTIONS(3252),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [sym_null] = ACTIONS(3250),
    [sym_identifier] = ACTIONS(3250),
    [sym_comment] = ACTIONS(42),
  },
  [1596] = {
    [sym__type_declarator] = STATE(1642),
    [sym_pointer_type_declarator] = STATE(99),
    [sym_function_type_declarator] = STATE(100),
    [sym_array_type_declarator] = STATE(101),
    [anon_sym_LPAREN] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(187),
    [sym_identifier] = ACTIONS(189),
    [sym_comment] = ACTIONS(42),
  },
  [1597] = {
    [sym_type_qualifier] = STATE(103),
    [sym__type_specifier] = STATE(1643),
    [sym_sized_type_specifier] = STATE(1643),
    [sym_enum_specifier] = STATE(1643),
    [sym_struct_specifier] = STATE(1643),
    [sym_union_specifier] = STATE(1643),
    [sym_macro_type_specifier] = STATE(1643),
    [aux_sym_type_definition_repeat1] = STATE(103),
    [aux_sym_sized_type_specifier_repeat1] = STATE(36),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(62),
    [anon_sym_long] = ACTIONS(62),
    [anon_sym_short] = ACTIONS(62),
    [sym_primitive_type] = ACTIONS(4290),
    [anon_sym_enum] = ACTIONS(66),
    [anon_sym_struct] = ACTIONS(68),
    [anon_sym_union] = ACTIONS(70),
    [sym_identifier] = ACTIONS(72),
    [sym_comment] = ACTIONS(42),
  },
  [1598] = {
    [sym_parameter_list] = STATE(145),
    [aux_sym_declaration_repeat1] = STATE(1645),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(4292),
    [anon_sym_LBRACK] = ACTIONS(270),
    [anon_sym_EQ] = ACTIONS(272),
    [sym_comment] = ACTIONS(42),
  },
  [1599] = {
    [aux_sym_declaration_repeat1] = STATE(1645),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(4292),
    [sym_comment] = ACTIONS(42),
  },
  [1600] = {
    [sym_compound_statement] = STATE(1646),
    [sym_labeled_statement] = STATE(1646),
    [sym_expression_statement] = STATE(1646),
    [sym_if_statement] = STATE(1646),
    [sym_switch_statement] = STATE(1646),
    [sym_case_statement] = STATE(1646),
    [sym_while_statement] = STATE(1646),
    [sym_do_statement] = STATE(1646),
    [sym_for_statement] = STATE(1646),
    [sym_return_statement] = STATE(1646),
    [sym_break_statement] = STATE(1646),
    [sym_continue_statement] = STATE(1646),
    [sym_goto_statement] = STATE(1646),
    [sym__expression] = STATE(1385),
    [sym_comma_expression] = STATE(1386),
    [sym_conditional_expression] = STATE(1385),
    [sym_assignment_expression] = STATE(1385),
    [sym_pointer_expression] = STATE(1385),
    [sym_logical_expression] = STATE(1385),
    [sym_bitwise_expression] = STATE(1385),
    [sym_equality_expression] = STATE(1385),
    [sym_relational_expression] = STATE(1385),
    [sym_shift_expression] = STATE(1385),
    [sym_math_expression] = STATE(1385),
    [sym_cast_expression] = STATE(1385),
    [sym_sizeof_expression] = STATE(1385),
    [sym_subscript_expression] = STATE(1385),
    [sym_call_expression] = STATE(1385),
    [sym_field_expression] = STATE(1385),
    [sym_compound_literal_expression] = STATE(1385),
    [sym_parenthesized_expression] = STATE(1385),
    [sym_concatenated_string] = STATE(1385),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3754),
    [anon_sym_LBRACE] = ACTIONS(3756),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3758),
    [anon_sym_switch] = ACTIONS(3760),
    [anon_sym_case] = ACTIONS(3762),
    [anon_sym_default] = ACTIONS(3764),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3772),
    [anon_sym_break] = ACTIONS(3774),
    [anon_sym_continue] = ACTIONS(3776),
    [anon_sym_goto] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3780),
    [sym_char_literal] = ACTIONS(3780),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3782),
    [sym_false] = ACTIONS(3782),
    [sym_null] = ACTIONS(3782),
    [sym_identifier] = ACTIONS(3784),
    [sym_comment] = ACTIONS(42),
  },
  [1601] = {
    [sym__expression] = STATE(1647),
    [sym_conditional_expression] = STATE(1647),
    [sym_assignment_expression] = STATE(1647),
    [sym_pointer_expression] = STATE(1647),
    [sym_logical_expression] = STATE(1647),
    [sym_bitwise_expression] = STATE(1647),
    [sym_equality_expression] = STATE(1647),
    [sym_relational_expression] = STATE(1647),
    [sym_shift_expression] = STATE(1647),
    [sym_math_expression] = STATE(1647),
    [sym_cast_expression] = STATE(1647),
    [sym_sizeof_expression] = STATE(1647),
    [sym_subscript_expression] = STATE(1647),
    [sym_call_expression] = STATE(1647),
    [sym_field_expression] = STATE(1647),
    [sym_compound_literal_expression] = STATE(1647),
    [sym_parenthesized_expression] = STATE(1647),
    [sym_concatenated_string] = STATE(1647),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(4294),
    [sym_char_literal] = ACTIONS(4294),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(4296),
    [sym_false] = ACTIONS(4296),
    [sym_null] = ACTIONS(4296),
    [sym_identifier] = ACTIONS(4296),
    [sym_comment] = ACTIONS(42),
  },
  [1602] = {
    [sym__expression] = STATE(1649),
    [sym_conditional_expression] = STATE(1649),
    [sym_assignment_expression] = STATE(1649),
    [sym_pointer_expression] = STATE(1649),
    [sym_logical_expression] = STATE(1649),
    [sym_bitwise_expression] = STATE(1649),
    [sym_equality_expression] = STATE(1649),
    [sym_relational_expression] = STATE(1649),
    [sym_shift_expression] = STATE(1649),
    [sym_math_expression] = STATE(1649),
    [sym_cast_expression] = STATE(1649),
    [sym_sizeof_expression] = STATE(1649),
    [sym_subscript_expression] = STATE(1649),
    [sym_call_expression] = STATE(1649),
    [sym_field_expression] = STATE(1649),
    [sym_compound_literal_expression] = STATE(1649),
    [sym_parenthesized_expression] = STATE(1649),
    [sym_concatenated_string] = STATE(1649),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(4298),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(4300),
    [sym_char_literal] = ACTIONS(4300),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(4302),
    [sym_false] = ACTIONS(4302),
    [sym_null] = ACTIONS(4302),
    [sym_identifier] = ACTIONS(4302),
    [sym_comment] = ACTIONS(42),
  },
  [1603] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(4304),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1604] = {
    [sym__expression] = STATE(1651),
    [sym_conditional_expression] = STATE(1651),
    [sym_assignment_expression] = STATE(1651),
    [sym_pointer_expression] = STATE(1651),
    [sym_logical_expression] = STATE(1651),
    [sym_bitwise_expression] = STATE(1651),
    [sym_equality_expression] = STATE(1651),
    [sym_relational_expression] = STATE(1651),
    [sym_shift_expression] = STATE(1651),
    [sym_math_expression] = STATE(1651),
    [sym_cast_expression] = STATE(1651),
    [sym_sizeof_expression] = STATE(1651),
    [sym_subscript_expression] = STATE(1651),
    [sym_call_expression] = STATE(1651),
    [sym_field_expression] = STATE(1651),
    [sym_compound_literal_expression] = STATE(1651),
    [sym_parenthesized_expression] = STATE(1651),
    [sym_concatenated_string] = STATE(1651),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(4304),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(4306),
    [sym_char_literal] = ACTIONS(4306),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(4308),
    [sym_false] = ACTIONS(4308),
    [sym_null] = ACTIONS(4308),
    [sym_identifier] = ACTIONS(4308),
    [sym_comment] = ACTIONS(42),
  },
  [1605] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4168),
    [sym_preproc_directive] = ACTIONS(4168),
    [anon_sym_SEMI] = ACTIONS(4170),
    [anon_sym_typedef] = ACTIONS(4168),
    [anon_sym_extern] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4170),
    [anon_sym_STAR] = ACTIONS(4170),
    [anon_sym_static] = ACTIONS(4168),
    [anon_sym_auto] = ACTIONS(4168),
    [anon_sym_register] = ACTIONS(4168),
    [anon_sym_inline] = ACTIONS(4168),
    [anon_sym_const] = ACTIONS(4168),
    [anon_sym_restrict] = ACTIONS(4168),
    [anon_sym_volatile] = ACTIONS(4168),
    [anon_sym__Atomic] = ACTIONS(4168),
    [anon_sym_unsigned] = ACTIONS(4168),
    [anon_sym_long] = ACTIONS(4168),
    [anon_sym_short] = ACTIONS(4168),
    [sym_primitive_type] = ACTIONS(4168),
    [anon_sym_enum] = ACTIONS(4168),
    [anon_sym_struct] = ACTIONS(4168),
    [anon_sym_union] = ACTIONS(4168),
    [anon_sym_if] = ACTIONS(4168),
    [anon_sym_switch] = ACTIONS(4168),
    [anon_sym_case] = ACTIONS(4168),
    [anon_sym_default] = ACTIONS(4168),
    [anon_sym_while] = ACTIONS(4168),
    [anon_sym_do] = ACTIONS(4168),
    [anon_sym_for] = ACTIONS(4168),
    [anon_sym_return] = ACTIONS(4168),
    [anon_sym_break] = ACTIONS(4168),
    [anon_sym_continue] = ACTIONS(4168),
    [anon_sym_goto] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(4170),
    [anon_sym_TILDE] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4168),
    [anon_sym_DASH] = ACTIONS(4168),
    [anon_sym_DASH_DASH] = ACTIONS(4170),
    [anon_sym_PLUS_PLUS] = ACTIONS(4170),
    [anon_sym_sizeof] = ACTIONS(4168),
    [sym_number_literal] = ACTIONS(4170),
    [sym_char_literal] = ACTIONS(4170),
    [sym_string_literal] = ACTIONS(4170),
    [sym_true] = ACTIONS(4168),
    [sym_false] = ACTIONS(4168),
    [sym_null] = ACTIONS(4168),
    [sym_identifier] = ACTIONS(4168),
    [sym_comment] = ACTIONS(42),
  },
  [1606] = {
    [sym_compound_statement] = STATE(1652),
    [sym_labeled_statement] = STATE(1652),
    [sym_expression_statement] = STATE(1652),
    [sym_if_statement] = STATE(1652),
    [sym_switch_statement] = STATE(1652),
    [sym_case_statement] = STATE(1652),
    [sym_while_statement] = STATE(1652),
    [sym_do_statement] = STATE(1652),
    [sym_for_statement] = STATE(1652),
    [sym_return_statement] = STATE(1652),
    [sym_break_statement] = STATE(1652),
    [sym_continue_statement] = STATE(1652),
    [sym_goto_statement] = STATE(1652),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(3040),
    [sym_comment] = ACTIONS(42),
  },
  [1607] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4310),
    [sym_comment] = ACTIONS(42),
  },
  [1608] = {
    [sym_compound_statement] = STATE(1654),
    [sym_labeled_statement] = STATE(1654),
    [sym_expression_statement] = STATE(1654),
    [sym_if_statement] = STATE(1654),
    [sym_switch_statement] = STATE(1654),
    [sym_case_statement] = STATE(1654),
    [sym_while_statement] = STATE(1654),
    [sym_do_statement] = STATE(1654),
    [sym_for_statement] = STATE(1654),
    [sym_return_statement] = STATE(1654),
    [sym_break_statement] = STATE(1654),
    [sym_continue_statement] = STATE(1654),
    [sym_goto_statement] = STATE(1654),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3173),
    [anon_sym_switch] = ACTIONS(3175),
    [anon_sym_case] = ACTIONS(3177),
    [anon_sym_default] = ACTIONS(3179),
    [anon_sym_while] = ACTIONS(3181),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3185),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3199),
    [sym_comment] = ACTIONS(42),
  },
  [1609] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(813),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(815),
    [sym_preproc_directive] = ACTIONS(815),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_typedef] = ACTIONS(815),
    [anon_sym_extern] = ACTIONS(815),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(813),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_auto] = ACTIONS(815),
    [anon_sym_register] = ACTIONS(815),
    [anon_sym_inline] = ACTIONS(815),
    [anon_sym_const] = ACTIONS(815),
    [anon_sym_restrict] = ACTIONS(815),
    [anon_sym_volatile] = ACTIONS(815),
    [anon_sym__Atomic] = ACTIONS(815),
    [anon_sym_unsigned] = ACTIONS(815),
    [anon_sym_long] = ACTIONS(815),
    [anon_sym_short] = ACTIONS(815),
    [sym_primitive_type] = ACTIONS(815),
    [anon_sym_enum] = ACTIONS(815),
    [anon_sym_struct] = ACTIONS(815),
    [anon_sym_union] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(815),
    [anon_sym_else] = ACTIONS(815),
    [anon_sym_switch] = ACTIONS(815),
    [anon_sym_case] = ACTIONS(815),
    [anon_sym_default] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(815),
    [anon_sym_do] = ACTIONS(815),
    [anon_sym_for] = ACTIONS(815),
    [anon_sym_return] = ACTIONS(815),
    [anon_sym_break] = ACTIONS(815),
    [anon_sym_continue] = ACTIONS(815),
    [anon_sym_goto] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_sizeof] = ACTIONS(815),
    [sym_number_literal] = ACTIONS(813),
    [sym_char_literal] = ACTIONS(813),
    [sym_string_literal] = ACTIONS(813),
    [sym_true] = ACTIONS(815),
    [sym_false] = ACTIONS(815),
    [sym_null] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_comment] = ACTIONS(42),
  },
  [1610] = {
    [sym_parameter_list] = STATE(200),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_SEMI] = ACTIONS(4312),
    [anon_sym_LBRACK] = ACTIONS(449),
    [sym_comment] = ACTIONS(42),
  },
  [1611] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1288),
    [anon_sym_LPAREN] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1288),
    [sym_preproc_directive] = ACTIONS(1288),
    [anon_sym_SEMI] = ACTIONS(1286),
    [anon_sym_typedef] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1288),
    [anon_sym_LBRACE] = ACTIONS(1286),
    [anon_sym_RBRACE] = ACTIONS(1286),
    [anon_sym_STAR] = ACTIONS(1286),
    [anon_sym_static] = ACTIONS(1288),
    [anon_sym_auto] = ACTIONS(1288),
    [anon_sym_register] = ACTIONS(1288),
    [anon_sym_inline] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_restrict] = ACTIONS(1288),
    [anon_sym_volatile] = ACTIONS(1288),
    [anon_sym__Atomic] = ACTIONS(1288),
    [anon_sym_unsigned] = ACTIONS(1288),
    [anon_sym_long] = ACTIONS(1288),
    [anon_sym_short] = ACTIONS(1288),
    [sym_primitive_type] = ACTIONS(1288),
    [anon_sym_enum] = ACTIONS(1288),
    [anon_sym_struct] = ACTIONS(1288),
    [anon_sym_union] = ACTIONS(1288),
    [anon_sym_if] = ACTIONS(1288),
    [anon_sym_else] = ACTIONS(1288),
    [anon_sym_switch] = ACTIONS(1288),
    [anon_sym_case] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1288),
    [anon_sym_while] = ACTIONS(1288),
    [anon_sym_do] = ACTIONS(1288),
    [anon_sym_for] = ACTIONS(1288),
    [anon_sym_return] = ACTIONS(1288),
    [anon_sym_break] = ACTIONS(1288),
    [anon_sym_continue] = ACTIONS(1288),
    [anon_sym_goto] = ACTIONS(1288),
    [anon_sym_AMP] = ACTIONS(1286),
    [anon_sym_BANG] = ACTIONS(1286),
    [anon_sym_TILDE] = ACTIONS(1286),
    [anon_sym_PLUS] = ACTIONS(1288),
    [anon_sym_DASH] = ACTIONS(1288),
    [anon_sym_DASH_DASH] = ACTIONS(1286),
    [anon_sym_PLUS_PLUS] = ACTIONS(1286),
    [anon_sym_sizeof] = ACTIONS(1288),
    [sym_number_literal] = ACTIONS(1286),
    [sym_char_literal] = ACTIONS(1286),
    [sym_string_literal] = ACTIONS(1286),
    [sym_true] = ACTIONS(1288),
    [sym_false] = ACTIONS(1288),
    [sym_null] = ACTIONS(1288),
    [sym_identifier] = ACTIONS(1288),
    [sym_comment] = ACTIONS(42),
  },
  [1612] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3868),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3868),
    [sym_preproc_directive] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3870),
    [anon_sym_typedef] = ACTIONS(3868),
    [anon_sym_extern] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3870),
    [anon_sym_RBRACE] = ACTIONS(3870),
    [anon_sym_STAR] = ACTIONS(3870),
    [anon_sym_static] = ACTIONS(3868),
    [anon_sym_auto] = ACTIONS(3868),
    [anon_sym_register] = ACTIONS(3868),
    [anon_sym_inline] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(3868),
    [anon_sym_restrict] = ACTIONS(3868),
    [anon_sym_volatile] = ACTIONS(3868),
    [anon_sym__Atomic] = ACTIONS(3868),
    [anon_sym_unsigned] = ACTIONS(3868),
    [anon_sym_long] = ACTIONS(3868),
    [anon_sym_short] = ACTIONS(3868),
    [sym_primitive_type] = ACTIONS(3868),
    [anon_sym_enum] = ACTIONS(3868),
    [anon_sym_struct] = ACTIONS(3868),
    [anon_sym_union] = ACTIONS(3868),
    [anon_sym_if] = ACTIONS(3868),
    [anon_sym_else] = ACTIONS(3868),
    [anon_sym_switch] = ACTIONS(3868),
    [anon_sym_case] = ACTIONS(3868),
    [anon_sym_default] = ACTIONS(3868),
    [anon_sym_while] = ACTIONS(3868),
    [anon_sym_do] = ACTIONS(3868),
    [anon_sym_for] = ACTIONS(3868),
    [anon_sym_return] = ACTIONS(3868),
    [anon_sym_break] = ACTIONS(3868),
    [anon_sym_continue] = ACTIONS(3868),
    [anon_sym_goto] = ACTIONS(3868),
    [anon_sym_AMP] = ACTIONS(3870),
    [anon_sym_BANG] = ACTIONS(3870),
    [anon_sym_TILDE] = ACTIONS(3870),
    [anon_sym_PLUS] = ACTIONS(3868),
    [anon_sym_DASH] = ACTIONS(3868),
    [anon_sym_DASH_DASH] = ACTIONS(3870),
    [anon_sym_PLUS_PLUS] = ACTIONS(3870),
    [anon_sym_sizeof] = ACTIONS(3868),
    [sym_number_literal] = ACTIONS(3870),
    [sym_char_literal] = ACTIONS(3870),
    [sym_string_literal] = ACTIONS(3870),
    [sym_true] = ACTIONS(3868),
    [sym_false] = ACTIONS(3868),
    [sym_null] = ACTIONS(3868),
    [sym_identifier] = ACTIONS(3868),
    [sym_comment] = ACTIONS(42),
  },
  [1613] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3872),
    [anon_sym_LPAREN] = ACTIONS(3874),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3872),
    [sym_preproc_directive] = ACTIONS(3872),
    [anon_sym_SEMI] = ACTIONS(3874),
    [anon_sym_typedef] = ACTIONS(3872),
    [anon_sym_extern] = ACTIONS(3872),
    [anon_sym_LBRACE] = ACTIONS(3874),
    [anon_sym_RBRACE] = ACTIONS(3874),
    [anon_sym_STAR] = ACTIONS(3874),
    [anon_sym_static] = ACTIONS(3872),
    [anon_sym_auto] = ACTIONS(3872),
    [anon_sym_register] = ACTIONS(3872),
    [anon_sym_inline] = ACTIONS(3872),
    [anon_sym_const] = ACTIONS(3872),
    [anon_sym_restrict] = ACTIONS(3872),
    [anon_sym_volatile] = ACTIONS(3872),
    [anon_sym__Atomic] = ACTIONS(3872),
    [anon_sym_unsigned] = ACTIONS(3872),
    [anon_sym_long] = ACTIONS(3872),
    [anon_sym_short] = ACTIONS(3872),
    [sym_primitive_type] = ACTIONS(3872),
    [anon_sym_enum] = ACTIONS(3872),
    [anon_sym_struct] = ACTIONS(3872),
    [anon_sym_union] = ACTIONS(3872),
    [anon_sym_if] = ACTIONS(3872),
    [anon_sym_else] = ACTIONS(3872),
    [anon_sym_switch] = ACTIONS(3872),
    [anon_sym_case] = ACTIONS(3872),
    [anon_sym_default] = ACTIONS(3872),
    [anon_sym_while] = ACTIONS(3872),
    [anon_sym_do] = ACTIONS(3872),
    [anon_sym_for] = ACTIONS(3872),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_break] = ACTIONS(3872),
    [anon_sym_continue] = ACTIONS(3872),
    [anon_sym_goto] = ACTIONS(3872),
    [anon_sym_AMP] = ACTIONS(3874),
    [anon_sym_BANG] = ACTIONS(3874),
    [anon_sym_TILDE] = ACTIONS(3874),
    [anon_sym_PLUS] = ACTIONS(3872),
    [anon_sym_DASH] = ACTIONS(3872),
    [anon_sym_DASH_DASH] = ACTIONS(3874),
    [anon_sym_PLUS_PLUS] = ACTIONS(3874),
    [anon_sym_sizeof] = ACTIONS(3872),
    [sym_number_literal] = ACTIONS(3874),
    [sym_char_literal] = ACTIONS(3874),
    [sym_string_literal] = ACTIONS(3874),
    [sym_true] = ACTIONS(3872),
    [sym_false] = ACTIONS(3872),
    [sym_null] = ACTIONS(3872),
    [sym_identifier] = ACTIONS(3872),
    [sym_comment] = ACTIONS(42),
  },
  [1614] = {
    [sym_compound_statement] = STATE(1656),
    [sym_labeled_statement] = STATE(1656),
    [sym_expression_statement] = STATE(1656),
    [sym_if_statement] = STATE(1656),
    [sym_switch_statement] = STATE(1656),
    [sym_case_statement] = STATE(1656),
    [sym_while_statement] = STATE(1656),
    [sym_do_statement] = STATE(1656),
    [sym_for_statement] = STATE(1656),
    [sym_return_statement] = STATE(1656),
    [sym_break_statement] = STATE(1656),
    [sym_continue_statement] = STATE(1656),
    [sym_goto_statement] = STATE(1656),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3173),
    [anon_sym_switch] = ACTIONS(3175),
    [anon_sym_case] = ACTIONS(3177),
    [anon_sym_default] = ACTIONS(3179),
    [anon_sym_while] = ACTIONS(3181),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3185),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3199),
    [sym_comment] = ACTIONS(42),
  },
  [1615] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4314),
    [sym_comment] = ACTIONS(42),
  },
  [1616] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1658),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4314),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1617] = {
    [sym__expression] = STATE(1659),
    [sym_conditional_expression] = STATE(1659),
    [sym_assignment_expression] = STATE(1659),
    [sym_pointer_expression] = STATE(1659),
    [sym_logical_expression] = STATE(1659),
    [sym_bitwise_expression] = STATE(1659),
    [sym_equality_expression] = STATE(1659),
    [sym_relational_expression] = STATE(1659),
    [sym_shift_expression] = STATE(1659),
    [sym_math_expression] = STATE(1659),
    [sym_cast_expression] = STATE(1659),
    [sym_sizeof_expression] = STATE(1659),
    [sym_subscript_expression] = STATE(1659),
    [sym_call_expression] = STATE(1659),
    [sym_field_expression] = STATE(1659),
    [sym_compound_literal_expression] = STATE(1659),
    [sym_parenthesized_expression] = STATE(1659),
    [sym_concatenated_string] = STATE(1659),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(4314),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(4316),
    [sym_char_literal] = ACTIONS(4316),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(4318),
    [sym_false] = ACTIONS(4318),
    [sym_null] = ACTIONS(4318),
    [sym_identifier] = ACTIONS(4318),
    [sym_comment] = ACTIONS(42),
  },
  [1618] = {
    [anon_sym_else] = ACTIONS(4320),
    [anon_sym_while] = ACTIONS(3607),
    [sym_comment] = ACTIONS(42),
  },
  [1619] = {
    [sym_compound_statement] = STATE(1613),
    [sym_labeled_statement] = STATE(1613),
    [sym_expression_statement] = STATE(1613),
    [sym_if_statement] = STATE(1613),
    [sym_switch_statement] = STATE(1613),
    [sym_case_statement] = STATE(1613),
    [sym_while_statement] = STATE(1613),
    [sym_do_statement] = STATE(1613),
    [sym_for_statement] = STATE(1613),
    [sym_return_statement] = STATE(1613),
    [sym_break_statement] = STATE(1613),
    [sym_continue_statement] = STATE(1613),
    [sym_goto_statement] = STATE(1613),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3631),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_case] = ACTIONS(3635),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3639),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3643),
    [sym_comment] = ACTIONS(42),
  },
  [1620] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1662),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4322),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1621] = {
    [sym__expression] = STATE(1663),
    [sym_conditional_expression] = STATE(1663),
    [sym_assignment_expression] = STATE(1663),
    [sym_pointer_expression] = STATE(1663),
    [sym_logical_expression] = STATE(1663),
    [sym_bitwise_expression] = STATE(1663),
    [sym_equality_expression] = STATE(1663),
    [sym_relational_expression] = STATE(1663),
    [sym_shift_expression] = STATE(1663),
    [sym_math_expression] = STATE(1663),
    [sym_cast_expression] = STATE(1663),
    [sym_sizeof_expression] = STATE(1663),
    [sym_subscript_expression] = STATE(1663),
    [sym_call_expression] = STATE(1663),
    [sym_field_expression] = STATE(1663),
    [sym_compound_literal_expression] = STATE(1663),
    [sym_parenthesized_expression] = STATE(1663),
    [sym_concatenated_string] = STATE(1663),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(4322),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(4324),
    [sym_char_literal] = ACTIONS(4324),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(4326),
    [sym_false] = ACTIONS(4326),
    [sym_null] = ACTIONS(4326),
    [sym_identifier] = ACTIONS(4326),
    [sym_comment] = ACTIONS(42),
  },
  [1622] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(4328),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1623] = {
    [sym_compound_statement] = STATE(1624),
    [sym_labeled_statement] = STATE(1624),
    [sym_expression_statement] = STATE(1624),
    [sym_if_statement] = STATE(1624),
    [sym_switch_statement] = STATE(1624),
    [sym_case_statement] = STATE(1624),
    [sym_while_statement] = STATE(1624),
    [sym_do_statement] = STATE(1624),
    [sym_for_statement] = STATE(1624),
    [sym_return_statement] = STATE(1624),
    [sym_break_statement] = STATE(1624),
    [sym_continue_statement] = STATE(1624),
    [sym_goto_statement] = STATE(1624),
    [sym__expression] = STATE(278),
    [sym_comma_expression] = STATE(279),
    [sym_conditional_expression] = STATE(278),
    [sym_assignment_expression] = STATE(278),
    [sym_pointer_expression] = STATE(278),
    [sym_logical_expression] = STATE(278),
    [sym_bitwise_expression] = STATE(278),
    [sym_equality_expression] = STATE(278),
    [sym_relational_expression] = STATE(278),
    [sym_shift_expression] = STATE(278),
    [sym_math_expression] = STATE(278),
    [sym_cast_expression] = STATE(278),
    [sym_sizeof_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_field_expression] = STATE(278),
    [sym_compound_literal_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_concatenated_string] = STATE(278),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_default] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(1089),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(609),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_goto] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(625),
    [sym_char_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(629),
    [sym_false] = ACTIONS(629),
    [sym_null] = ACTIONS(629),
    [sym_identifier] = ACTIONS(1093),
    [sym_comment] = ACTIONS(42),
  },
  [1624] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4330),
    [anon_sym_LPAREN] = ACTIONS(4332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4330),
    [sym_preproc_directive] = ACTIONS(4330),
    [anon_sym_SEMI] = ACTIONS(4332),
    [anon_sym_typedef] = ACTIONS(4330),
    [anon_sym_extern] = ACTIONS(4330),
    [anon_sym_LBRACE] = ACTIONS(4332),
    [anon_sym_RBRACE] = ACTIONS(4332),
    [anon_sym_STAR] = ACTIONS(4332),
    [anon_sym_static] = ACTIONS(4330),
    [anon_sym_auto] = ACTIONS(4330),
    [anon_sym_register] = ACTIONS(4330),
    [anon_sym_inline] = ACTIONS(4330),
    [anon_sym_const] = ACTIONS(4330),
    [anon_sym_restrict] = ACTIONS(4330),
    [anon_sym_volatile] = ACTIONS(4330),
    [anon_sym__Atomic] = ACTIONS(4330),
    [anon_sym_unsigned] = ACTIONS(4330),
    [anon_sym_long] = ACTIONS(4330),
    [anon_sym_short] = ACTIONS(4330),
    [sym_primitive_type] = ACTIONS(4330),
    [anon_sym_enum] = ACTIONS(4330),
    [anon_sym_struct] = ACTIONS(4330),
    [anon_sym_union] = ACTIONS(4330),
    [anon_sym_if] = ACTIONS(4330),
    [anon_sym_switch] = ACTIONS(4330),
    [anon_sym_case] = ACTIONS(4330),
    [anon_sym_default] = ACTIONS(4330),
    [anon_sym_while] = ACTIONS(4330),
    [anon_sym_do] = ACTIONS(4330),
    [anon_sym_for] = ACTIONS(4330),
    [anon_sym_return] = ACTIONS(4330),
    [anon_sym_break] = ACTIONS(4330),
    [anon_sym_continue] = ACTIONS(4330),
    [anon_sym_goto] = ACTIONS(4330),
    [anon_sym_AMP] = ACTIONS(4332),
    [anon_sym_BANG] = ACTIONS(4332),
    [anon_sym_TILDE] = ACTIONS(4332),
    [anon_sym_PLUS] = ACTIONS(4330),
    [anon_sym_DASH] = ACTIONS(4330),
    [anon_sym_DASH_DASH] = ACTIONS(4332),
    [anon_sym_PLUS_PLUS] = ACTIONS(4332),
    [anon_sym_sizeof] = ACTIONS(4330),
    [sym_number_literal] = ACTIONS(4332),
    [sym_char_literal] = ACTIONS(4332),
    [sym_string_literal] = ACTIONS(4332),
    [sym_true] = ACTIONS(4330),
    [sym_false] = ACTIONS(4330),
    [sym_null] = ACTIONS(4330),
    [sym_identifier] = ACTIONS(4330),
    [sym_comment] = ACTIONS(42),
  },
  [1625] = {
    [sym_compound_statement] = STATE(1665),
    [sym_labeled_statement] = STATE(1665),
    [sym_expression_statement] = STATE(1665),
    [sym_if_statement] = STATE(1665),
    [sym_switch_statement] = STATE(1665),
    [sym_case_statement] = STATE(1665),
    [sym_while_statement] = STATE(1665),
    [sym_do_statement] = STATE(1665),
    [sym_for_statement] = STATE(1665),
    [sym_return_statement] = STATE(1665),
    [sym_break_statement] = STATE(1665),
    [sym_continue_statement] = STATE(1665),
    [sym_goto_statement] = STATE(1665),
    [sym__expression] = STATE(1451),
    [sym_comma_expression] = STATE(1452),
    [sym_conditional_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(1451),
    [sym_pointer_expression] = STATE(1451),
    [sym_logical_expression] = STATE(1451),
    [sym_bitwise_expression] = STATE(1451),
    [sym_equality_expression] = STATE(1451),
    [sym_relational_expression] = STATE(1451),
    [sym_shift_expression] = STATE(1451),
    [sym_math_expression] = STATE(1451),
    [sym_cast_expression] = STATE(1451),
    [sym_sizeof_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_call_expression] = STATE(1451),
    [sym_field_expression] = STATE(1451),
    [sym_compound_literal_expression] = STATE(1451),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_concatenated_string] = STATE(1451),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3900),
    [anon_sym_LBRACE] = ACTIONS(3902),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3904),
    [anon_sym_switch] = ACTIONS(3906),
    [anon_sym_case] = ACTIONS(3908),
    [anon_sym_default] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3912),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_for] = ACTIONS(3916),
    [anon_sym_return] = ACTIONS(3918),
    [anon_sym_break] = ACTIONS(3920),
    [anon_sym_continue] = ACTIONS(3922),
    [anon_sym_goto] = ACTIONS(3924),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3926),
    [sym_char_literal] = ACTIONS(3926),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3928),
    [sym_false] = ACTIONS(3928),
    [sym_null] = ACTIONS(3928),
    [sym_identifier] = ACTIONS(3930),
    [sym_comment] = ACTIONS(42),
  },
  [1626] = {
    [sym_compound_statement] = STATE(1666),
    [sym_labeled_statement] = STATE(1666),
    [sym_expression_statement] = STATE(1666),
    [sym_if_statement] = STATE(1666),
    [sym_switch_statement] = STATE(1666),
    [sym_case_statement] = STATE(1666),
    [sym_while_statement] = STATE(1666),
    [sym_do_statement] = STATE(1666),
    [sym_for_statement] = STATE(1666),
    [sym_return_statement] = STATE(1666),
    [sym_break_statement] = STATE(1666),
    [sym_continue_statement] = STATE(1666),
    [sym_goto_statement] = STATE(1666),
    [sym__expression] = STATE(1451),
    [sym_comma_expression] = STATE(1452),
    [sym_conditional_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(1451),
    [sym_pointer_expression] = STATE(1451),
    [sym_logical_expression] = STATE(1451),
    [sym_bitwise_expression] = STATE(1451),
    [sym_equality_expression] = STATE(1451),
    [sym_relational_expression] = STATE(1451),
    [sym_shift_expression] = STATE(1451),
    [sym_math_expression] = STATE(1451),
    [sym_cast_expression] = STATE(1451),
    [sym_sizeof_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_call_expression] = STATE(1451),
    [sym_field_expression] = STATE(1451),
    [sym_compound_literal_expression] = STATE(1451),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_concatenated_string] = STATE(1451),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3900),
    [anon_sym_LBRACE] = ACTIONS(3902),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3904),
    [anon_sym_switch] = ACTIONS(3906),
    [anon_sym_case] = ACTIONS(3908),
    [anon_sym_default] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3912),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_for] = ACTIONS(3916),
    [anon_sym_return] = ACTIONS(3918),
    [anon_sym_break] = ACTIONS(3920),
    [anon_sym_continue] = ACTIONS(3922),
    [anon_sym_goto] = ACTIONS(3924),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3926),
    [sym_char_literal] = ACTIONS(3926),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3928),
    [sym_false] = ACTIONS(3928),
    [sym_null] = ACTIONS(3928),
    [sym_identifier] = ACTIONS(3930),
    [sym_comment] = ACTIONS(42),
  },
  [1627] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3250),
    [anon_sym_LPAREN] = ACTIONS(3252),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3250),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3250),
    [sym_preproc_directive] = ACTIONS(3250),
    [anon_sym_SEMI] = ACTIONS(3252),
    [anon_sym_typedef] = ACTIONS(3250),
    [anon_sym_extern] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3252),
    [anon_sym_STAR] = ACTIONS(3252),
    [anon_sym_static] = ACTIONS(3250),
    [anon_sym_auto] = ACTIONS(3250),
    [anon_sym_register] = ACTIONS(3250),
    [anon_sym_inline] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(3250),
    [anon_sym_restrict] = ACTIONS(3250),
    [anon_sym_volatile] = ACTIONS(3250),
    [anon_sym__Atomic] = ACTIONS(3250),
    [anon_sym_unsigned] = ACTIONS(3250),
    [anon_sym_long] = ACTIONS(3250),
    [anon_sym_short] = ACTIONS(3250),
    [sym_primitive_type] = ACTIONS(3250),
    [anon_sym_enum] = ACTIONS(3250),
    [anon_sym_struct] = ACTIONS(3250),
    [anon_sym_union] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_else] = ACTIONS(3250),
    [anon_sym_switch] = ACTIONS(3250),
    [anon_sym_case] = ACTIONS(3250),
    [anon_sym_default] = ACTIONS(3250),
    [anon_sym_while] = ACTIONS(3250),
    [anon_sym_do] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_goto] = ACTIONS(3250),
    [anon_sym_AMP] = ACTIONS(3252),
    [anon_sym_BANG] = ACTIONS(3252),
    [anon_sym_TILDE] = ACTIONS(3252),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3252),
    [anon_sym_PLUS_PLUS] = ACTIONS(3252),
    [anon_sym_sizeof] = ACTIONS(3250),
    [sym_number_literal] = ACTIONS(3252),
    [sym_char_literal] = ACTIONS(3252),
    [sym_string_literal] = ACTIONS(3252),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [sym_null] = ACTIONS(3250),
    [sym_identifier] = ACTIONS(3250),
    [sym_comment] = ACTIONS(42),
  },
  [1628] = {
    [sym__type_declarator] = STATE(1667),
    [sym_pointer_type_declarator] = STATE(99),
    [sym_function_type_declarator] = STATE(100),
    [sym_array_type_declarator] = STATE(101),
    [anon_sym_LPAREN] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(187),
    [sym_identifier] = ACTIONS(189),
    [sym_comment] = ACTIONS(42),
  },
  [1629] = {
    [sym_type_qualifier] = STATE(103),
    [sym__type_specifier] = STATE(1668),
    [sym_sized_type_specifier] = STATE(1668),
    [sym_enum_specifier] = STATE(1668),
    [sym_struct_specifier] = STATE(1668),
    [sym_union_specifier] = STATE(1668),
    [sym_macro_type_specifier] = STATE(1668),
    [aux_sym_type_definition_repeat1] = STATE(103),
    [aux_sym_sized_type_specifier_repeat1] = STATE(36),
    [anon_sym_const] = ACTIONS(60),
    [anon_sym_restrict] = ACTIONS(60),
    [anon_sym_volatile] = ACTIONS(60),
    [anon_sym__Atomic] = ACTIONS(60),
    [anon_sym_unsigned] = ACTIONS(62),
    [anon_sym_long] = ACTIONS(62),
    [anon_sym_short] = ACTIONS(62),
    [sym_primitive_type] = ACTIONS(4334),
    [anon_sym_enum] = ACTIONS(66),
    [anon_sym_struct] = ACTIONS(68),
    [anon_sym_union] = ACTIONS(70),
    [sym_identifier] = ACTIONS(72),
    [sym_comment] = ACTIONS(42),
  },
  [1630] = {
    [sym_parameter_list] = STATE(145),
    [aux_sym_declaration_repeat1] = STATE(1670),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(4336),
    [anon_sym_LBRACK] = ACTIONS(270),
    [anon_sym_EQ] = ACTIONS(272),
    [sym_comment] = ACTIONS(42),
  },
  [1631] = {
    [aux_sym_declaration_repeat1] = STATE(1670),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(4336),
    [sym_comment] = ACTIONS(42),
  },
  [1632] = {
    [sym_compound_statement] = STATE(1671),
    [sym_labeled_statement] = STATE(1671),
    [sym_expression_statement] = STATE(1671),
    [sym_if_statement] = STATE(1671),
    [sym_switch_statement] = STATE(1671),
    [sym_case_statement] = STATE(1671),
    [sym_while_statement] = STATE(1671),
    [sym_do_statement] = STATE(1671),
    [sym_for_statement] = STATE(1671),
    [sym_return_statement] = STATE(1671),
    [sym_break_statement] = STATE(1671),
    [sym_continue_statement] = STATE(1671),
    [sym_goto_statement] = STATE(1671),
    [sym__expression] = STATE(1451),
    [sym_comma_expression] = STATE(1452),
    [sym_conditional_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(1451),
    [sym_pointer_expression] = STATE(1451),
    [sym_logical_expression] = STATE(1451),
    [sym_bitwise_expression] = STATE(1451),
    [sym_equality_expression] = STATE(1451),
    [sym_relational_expression] = STATE(1451),
    [sym_shift_expression] = STATE(1451),
    [sym_math_expression] = STATE(1451),
    [sym_cast_expression] = STATE(1451),
    [sym_sizeof_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_call_expression] = STATE(1451),
    [sym_field_expression] = STATE(1451),
    [sym_compound_literal_expression] = STATE(1451),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_concatenated_string] = STATE(1451),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3900),
    [anon_sym_LBRACE] = ACTIONS(3902),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3904),
    [anon_sym_switch] = ACTIONS(3906),
    [anon_sym_case] = ACTIONS(3908),
    [anon_sym_default] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3912),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_for] = ACTIONS(3916),
    [anon_sym_return] = ACTIONS(3918),
    [anon_sym_break] = ACTIONS(3920),
    [anon_sym_continue] = ACTIONS(3922),
    [anon_sym_goto] = ACTIONS(3924),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3926),
    [sym_char_literal] = ACTIONS(3926),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3928),
    [sym_false] = ACTIONS(3928),
    [sym_null] = ACTIONS(3928),
    [sym_identifier] = ACTIONS(3930),
    [sym_comment] = ACTIONS(42),
  },
  [1633] = {
    [sym__expression] = STATE(1672),
    [sym_conditional_expression] = STATE(1672),
    [sym_assignment_expression] = STATE(1672),
    [sym_pointer_expression] = STATE(1672),
    [sym_logical_expression] = STATE(1672),
    [sym_bitwise_expression] = STATE(1672),
    [sym_equality_expression] = STATE(1672),
    [sym_relational_expression] = STATE(1672),
    [sym_shift_expression] = STATE(1672),
    [sym_math_expression] = STATE(1672),
    [sym_cast_expression] = STATE(1672),
    [sym_sizeof_expression] = STATE(1672),
    [sym_subscript_expression] = STATE(1672),
    [sym_call_expression] = STATE(1672),
    [sym_field_expression] = STATE(1672),
    [sym_compound_literal_expression] = STATE(1672),
    [sym_parenthesized_expression] = STATE(1672),
    [sym_concatenated_string] = STATE(1672),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_sizeof] = ACTIONS(1715),
    [sym_number_literal] = ACTIONS(4338),
    [sym_char_literal] = ACTIONS(4338),
    [sym_string_literal] = ACTIONS(1719),
    [sym_true] = ACTIONS(4340),
    [sym_false] = ACTIONS(4340),
    [sym_null] = ACTIONS(4340),
    [sym_identifier] = ACTIONS(4340),
    [sym_comment] = ACTIONS(42),
  },
  [1634] = {
    [sym__expression] = STATE(1674),
    [sym_conditional_expression] = STATE(1674),
    [sym_assignment_expression] = STATE(1674),
    [sym_pointer_expression] = STATE(1674),
    [sym_logical_expression] = STATE(1674),
    [sym_bitwise_expression] = STATE(1674),
    [sym_equality_expression] = STATE(1674),
    [sym_relational_expression] = STATE(1674),
    [sym_shift_expression] = STATE(1674),
    [sym_math_expression] = STATE(1674),
    [sym_cast_expression] = STATE(1674),
    [sym_sizeof_expression] = STATE(1674),
    [sym_subscript_expression] = STATE(1674),
    [sym_call_expression] = STATE(1674),
    [sym_field_expression] = STATE(1674),
    [sym_compound_literal_expression] = STATE(1674),
    [sym_parenthesized_expression] = STATE(1674),
    [sym_concatenated_string] = STATE(1674),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(4342),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(4344),
    [sym_char_literal] = ACTIONS(4344),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(4346),
    [sym_false] = ACTIONS(4346),
    [sym_null] = ACTIONS(4346),
    [sym_identifier] = ACTIONS(4346),
    [sym_comment] = ACTIONS(42),
  },
  [1635] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(4348),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1636] = {
    [sym__expression] = STATE(1676),
    [sym_conditional_expression] = STATE(1676),
    [sym_assignment_expression] = STATE(1676),
    [sym_pointer_expression] = STATE(1676),
    [sym_logical_expression] = STATE(1676),
    [sym_bitwise_expression] = STATE(1676),
    [sym_equality_expression] = STATE(1676),
    [sym_relational_expression] = STATE(1676),
    [sym_shift_expression] = STATE(1676),
    [sym_math_expression] = STATE(1676),
    [sym_cast_expression] = STATE(1676),
    [sym_sizeof_expression] = STATE(1676),
    [sym_subscript_expression] = STATE(1676),
    [sym_call_expression] = STATE(1676),
    [sym_field_expression] = STATE(1676),
    [sym_compound_literal_expression] = STATE(1676),
    [sym_parenthesized_expression] = STATE(1676),
    [sym_concatenated_string] = STATE(1676),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(4348),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(884),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(890),
    [anon_sym_PLUS_PLUS] = ACTIONS(890),
    [anon_sym_sizeof] = ACTIONS(892),
    [sym_number_literal] = ACTIONS(4350),
    [sym_char_literal] = ACTIONS(4350),
    [sym_string_literal] = ACTIONS(896),
    [sym_true] = ACTIONS(4352),
    [sym_false] = ACTIONS(4352),
    [sym_null] = ACTIONS(4352),
    [sym_identifier] = ACTIONS(4352),
    [sym_comment] = ACTIONS(42),
  },
  [1637] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4168),
    [sym_preproc_directive] = ACTIONS(4168),
    [anon_sym_SEMI] = ACTIONS(4170),
    [anon_sym_typedef] = ACTIONS(4168),
    [anon_sym_extern] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4170),
    [anon_sym_STAR] = ACTIONS(4170),
    [anon_sym_static] = ACTIONS(4168),
    [anon_sym_auto] = ACTIONS(4168),
    [anon_sym_register] = ACTIONS(4168),
    [anon_sym_inline] = ACTIONS(4168),
    [anon_sym_const] = ACTIONS(4168),
    [anon_sym_restrict] = ACTIONS(4168),
    [anon_sym_volatile] = ACTIONS(4168),
    [anon_sym__Atomic] = ACTIONS(4168),
    [anon_sym_unsigned] = ACTIONS(4168),
    [anon_sym_long] = ACTIONS(4168),
    [anon_sym_short] = ACTIONS(4168),
    [sym_primitive_type] = ACTIONS(4168),
    [anon_sym_enum] = ACTIONS(4168),
    [anon_sym_struct] = ACTIONS(4168),
    [anon_sym_union] = ACTIONS(4168),
    [anon_sym_if] = ACTIONS(4168),
    [anon_sym_switch] = ACTIONS(4168),
    [anon_sym_case] = ACTIONS(4168),
    [anon_sym_default] = ACTIONS(4168),
    [anon_sym_while] = ACTIONS(4168),
    [anon_sym_do] = ACTIONS(4168),
    [anon_sym_for] = ACTIONS(4168),
    [anon_sym_return] = ACTIONS(4168),
    [anon_sym_break] = ACTIONS(4168),
    [anon_sym_continue] = ACTIONS(4168),
    [anon_sym_goto] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(4170),
    [anon_sym_TILDE] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4168),
    [anon_sym_DASH] = ACTIONS(4168),
    [anon_sym_DASH_DASH] = ACTIONS(4170),
    [anon_sym_PLUS_PLUS] = ACTIONS(4170),
    [anon_sym_sizeof] = ACTIONS(4168),
    [sym_number_literal] = ACTIONS(4170),
    [sym_char_literal] = ACTIONS(4170),
    [sym_string_literal] = ACTIONS(4170),
    [sym_true] = ACTIONS(4168),
    [sym_false] = ACTIONS(4168),
    [sym_null] = ACTIONS(4168),
    [sym_identifier] = ACTIONS(4168),
    [sym_comment] = ACTIONS(42),
  },
  [1638] = {
    [sym_compound_statement] = STATE(1677),
    [sym_labeled_statement] = STATE(1677),
    [sym_expression_statement] = STATE(1677),
    [sym_if_statement] = STATE(1677),
    [sym_switch_statement] = STATE(1677),
    [sym_case_statement] = STATE(1677),
    [sym_while_statement] = STATE(1677),
    [sym_do_statement] = STATE(1677),
    [sym_for_statement] = STATE(1677),
    [sym_return_statement] = STATE(1677),
    [sym_break_statement] = STATE(1677),
    [sym_continue_statement] = STATE(1677),
    [sym_goto_statement] = STATE(1677),
    [sym__expression] = STATE(954),
    [sym_comma_expression] = STATE(955),
    [sym_conditional_expression] = STATE(954),
    [sym_assignment_expression] = STATE(954),
    [sym_pointer_expression] = STATE(954),
    [sym_logical_expression] = STATE(954),
    [sym_bitwise_expression] = STATE(954),
    [sym_equality_expression] = STATE(954),
    [sym_relational_expression] = STATE(954),
    [sym_shift_expression] = STATE(954),
    [sym_math_expression] = STATE(954),
    [sym_cast_expression] = STATE(954),
    [sym_sizeof_expression] = STATE(954),
    [sym_subscript_expression] = STATE(954),
    [sym_call_expression] = STATE(954),
    [sym_field_expression] = STATE(954),
    [sym_compound_literal_expression] = STATE(954),
    [sym_parenthesized_expression] = STATE(954),
    [sym_concatenated_string] = STATE(954),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(2497),
    [anon_sym_switch] = ACTIONS(2499),
    [anon_sym_case] = ACTIONS(2501),
    [anon_sym_default] = ACTIONS(2503),
    [anon_sym_while] = ACTIONS(2505),
    [anon_sym_do] = ACTIONS(2507),
    [anon_sym_for] = ACTIONS(2509),
    [anon_sym_return] = ACTIONS(2511),
    [anon_sym_break] = ACTIONS(2513),
    [anon_sym_continue] = ACTIONS(2515),
    [anon_sym_goto] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(2519),
    [sym_char_literal] = ACTIONS(2519),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(2521),
    [sym_false] = ACTIONS(2521),
    [sym_null] = ACTIONS(2521),
    [sym_identifier] = ACTIONS(3445),
    [sym_comment] = ACTIONS(42),
  },
  [1639] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4354),
    [sym_comment] = ACTIONS(42),
  },
  [1640] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3605),
    [anon_sym_LPAREN] = ACTIONS(3607),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3605),
    [sym_preproc_directive] = ACTIONS(3605),
    [anon_sym_SEMI] = ACTIONS(3607),
    [anon_sym_typedef] = ACTIONS(3605),
    [anon_sym_extern] = ACTIONS(3605),
    [anon_sym_LBRACE] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(3607),
    [anon_sym_static] = ACTIONS(3605),
    [anon_sym_auto] = ACTIONS(3605),
    [anon_sym_register] = ACTIONS(3605),
    [anon_sym_inline] = ACTIONS(3605),
    [anon_sym_const] = ACTIONS(3605),
    [anon_sym_restrict] = ACTIONS(3605),
    [anon_sym_volatile] = ACTIONS(3605),
    [anon_sym__Atomic] = ACTIONS(3605),
    [anon_sym_unsigned] = ACTIONS(3605),
    [anon_sym_long] = ACTIONS(3605),
    [anon_sym_short] = ACTIONS(3605),
    [sym_primitive_type] = ACTIONS(3605),
    [anon_sym_enum] = ACTIONS(3605),
    [anon_sym_struct] = ACTIONS(3605),
    [anon_sym_union] = ACTIONS(3605),
    [anon_sym_if] = ACTIONS(3605),
    [anon_sym_else] = ACTIONS(4356),
    [anon_sym_switch] = ACTIONS(3605),
    [anon_sym_case] = ACTIONS(3605),
    [anon_sym_default] = ACTIONS(3605),
    [anon_sym_while] = ACTIONS(3605),
    [anon_sym_do] = ACTIONS(3605),
    [anon_sym_for] = ACTIONS(3605),
    [anon_sym_return] = ACTIONS(3605),
    [anon_sym_break] = ACTIONS(3605),
    [anon_sym_continue] = ACTIONS(3605),
    [anon_sym_goto] = ACTIONS(3605),
    [anon_sym_AMP] = ACTIONS(3607),
    [anon_sym_BANG] = ACTIONS(3607),
    [anon_sym_TILDE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3605),
    [anon_sym_DASH] = ACTIONS(3605),
    [anon_sym_DASH_DASH] = ACTIONS(3607),
    [anon_sym_PLUS_PLUS] = ACTIONS(3607),
    [anon_sym_sizeof] = ACTIONS(3605),
    [sym_number_literal] = ACTIONS(3607),
    [sym_char_literal] = ACTIONS(3607),
    [sym_string_literal] = ACTIONS(3607),
    [sym_true] = ACTIONS(3605),
    [sym_false] = ACTIONS(3605),
    [sym_null] = ACTIONS(3605),
    [sym_identifier] = ACTIONS(3605),
    [sym_comment] = ACTIONS(42),
  },
  [1641] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3615),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3615),
    [sym_preproc_directive] = ACTIONS(3615),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_typedef] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_STAR] = ACTIONS(3617),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_auto] = ACTIONS(3615),
    [anon_sym_register] = ACTIONS(3615),
    [anon_sym_inline] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_restrict] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym__Atomic] = ACTIONS(3615),
    [anon_sym_unsigned] = ACTIONS(3615),
    [anon_sym_long] = ACTIONS(3615),
    [anon_sym_short] = ACTIONS(3615),
    [sym_primitive_type] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_union] = ACTIONS(3615),
    [anon_sym_if] = ACTIONS(3615),
    [anon_sym_else] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3615),
    [anon_sym_case] = ACTIONS(3615),
    [anon_sym_default] = ACTIONS(3615),
    [anon_sym_while] = ACTIONS(3615),
    [anon_sym_do] = ACTIONS(3615),
    [anon_sym_for] = ACTIONS(3615),
    [anon_sym_return] = ACTIONS(3615),
    [anon_sym_break] = ACTIONS(3615),
    [anon_sym_continue] = ACTIONS(3615),
    [anon_sym_goto] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_DASH_DASH] = ACTIONS(3617),
    [anon_sym_PLUS_PLUS] = ACTIONS(3617),
    [anon_sym_sizeof] = ACTIONS(3615),
    [sym_number_literal] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [sym_string_literal] = ACTIONS(3617),
    [sym_true] = ACTIONS(3615),
    [sym_false] = ACTIONS(3615),
    [sym_null] = ACTIONS(3615),
    [sym_identifier] = ACTIONS(3615),
    [sym_comment] = ACTIONS(42),
  },
  [1642] = {
    [sym_parameter_list] = STATE(200),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_SEMI] = ACTIONS(4358),
    [anon_sym_LBRACK] = ACTIONS(449),
    [sym_comment] = ACTIONS(42),
  },
  [1643] = {
    [sym__type_declarator] = STATE(1681),
    [sym_pointer_type_declarator] = STATE(99),
    [sym_function_type_declarator] = STATE(100),
    [sym_array_type_declarator] = STATE(101),
    [anon_sym_LPAREN] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(187),
    [sym_identifier] = ACTIONS(189),
    [sym_comment] = ACTIONS(42),
  },
  [1644] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(567),
    [anon_sym_LPAREN] = ACTIONS(565),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(567),
    [sym_preproc_directive] = ACTIONS(567),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_typedef] = ACTIONS(567),
    [anon_sym_extern] = ACTIONS(567),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_STAR] = ACTIONS(565),
    [anon_sym_static] = ACTIONS(567),
    [anon_sym_auto] = ACTIONS(567),
    [anon_sym_register] = ACTIONS(567),
    [anon_sym_inline] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_restrict] = ACTIONS(567),
    [anon_sym_volatile] = ACTIONS(567),
    [anon_sym__Atomic] = ACTIONS(567),
    [anon_sym_unsigned] = ACTIONS(567),
    [anon_sym_long] = ACTIONS(567),
    [anon_sym_short] = ACTIONS(567),
    [sym_primitive_type] = ACTIONS(567),
    [anon_sym_enum] = ACTIONS(567),
    [anon_sym_struct] = ACTIONS(567),
    [anon_sym_union] = ACTIONS(567),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_else] = ACTIONS(567),
    [anon_sym_switch] = ACTIONS(567),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_default] = ACTIONS(567),
    [anon_sym_while] = ACTIONS(567),
    [anon_sym_do] = ACTIONS(567),
    [anon_sym_for] = ACTIONS(567),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_break] = ACTIONS(567),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(565),
    [anon_sym_TILDE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_sizeof] = ACTIONS(567),
    [sym_number_literal] = ACTIONS(565),
    [sym_char_literal] = ACTIONS(565),
    [sym_string_literal] = ACTIONS(565),
    [sym_true] = ACTIONS(567),
    [sym_false] = ACTIONS(567),
    [sym_null] = ACTIONS(567),
    [sym_identifier] = ACTIONS(567),
    [sym_comment] = ACTIONS(42),
  },
  [1645] = {
    [aux_sym_declaration_repeat1] = STATE(302),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(4360),
    [sym_comment] = ACTIONS(42),
  },
  [1646] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3627),
    [sym_preproc_directive] = ACTIONS(3627),
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym_typedef] = ACTIONS(3627),
    [anon_sym_extern] = ACTIONS(3627),
    [anon_sym_LBRACE] = ACTIONS(3629),
    [anon_sym_STAR] = ACTIONS(3629),
    [anon_sym_static] = ACTIONS(3627),
    [anon_sym_auto] = ACTIONS(3627),
    [anon_sym_register] = ACTIONS(3627),
    [anon_sym_inline] = ACTIONS(3627),
    [anon_sym_const] = ACTIONS(3627),
    [anon_sym_restrict] = ACTIONS(3627),
    [anon_sym_volatile] = ACTIONS(3627),
    [anon_sym__Atomic] = ACTIONS(3627),
    [anon_sym_unsigned] = ACTIONS(3627),
    [anon_sym_long] = ACTIONS(3627),
    [anon_sym_short] = ACTIONS(3627),
    [sym_primitive_type] = ACTIONS(3627),
    [anon_sym_enum] = ACTIONS(3627),
    [anon_sym_struct] = ACTIONS(3627),
    [anon_sym_union] = ACTIONS(3627),
    [anon_sym_if] = ACTIONS(3627),
    [anon_sym_else] = ACTIONS(3627),
    [anon_sym_switch] = ACTIONS(3627),
    [anon_sym_case] = ACTIONS(3627),
    [anon_sym_default] = ACTIONS(3627),
    [anon_sym_while] = ACTIONS(3627),
    [anon_sym_do] = ACTIONS(3627),
    [anon_sym_for] = ACTIONS(3627),
    [anon_sym_return] = ACTIONS(3627),
    [anon_sym_break] = ACTIONS(3627),
    [anon_sym_continue] = ACTIONS(3627),
    [anon_sym_goto] = ACTIONS(3627),
    [anon_sym_AMP] = ACTIONS(3629),
    [anon_sym_BANG] = ACTIONS(3629),
    [anon_sym_TILDE] = ACTIONS(3629),
    [anon_sym_PLUS] = ACTIONS(3627),
    [anon_sym_DASH] = ACTIONS(3627),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_sizeof] = ACTIONS(3627),
    [sym_number_literal] = ACTIONS(3629),
    [sym_char_literal] = ACTIONS(3629),
    [sym_string_literal] = ACTIONS(3629),
    [sym_true] = ACTIONS(3627),
    [sym_false] = ACTIONS(3627),
    [sym_null] = ACTIONS(3627),
    [sym_identifier] = ACTIONS(3627),
    [sym_comment] = ACTIONS(42),
  },
  [1647] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(4362),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1648] = {
    [sym_compound_statement] = STATE(1684),
    [sym_labeled_statement] = STATE(1684),
    [sym_expression_statement] = STATE(1684),
    [sym_if_statement] = STATE(1684),
    [sym_switch_statement] = STATE(1684),
    [sym_case_statement] = STATE(1684),
    [sym_while_statement] = STATE(1684),
    [sym_do_statement] = STATE(1684),
    [sym_for_statement] = STATE(1684),
    [sym_return_statement] = STATE(1684),
    [sym_break_statement] = STATE(1684),
    [sym_continue_statement] = STATE(1684),
    [sym_goto_statement] = STATE(1684),
    [sym__expression] = STATE(1385),
    [sym_comma_expression] = STATE(1386),
    [sym_conditional_expression] = STATE(1385),
    [sym_assignment_expression] = STATE(1385),
    [sym_pointer_expression] = STATE(1385),
    [sym_logical_expression] = STATE(1385),
    [sym_bitwise_expression] = STATE(1385),
    [sym_equality_expression] = STATE(1385),
    [sym_relational_expression] = STATE(1385),
    [sym_shift_expression] = STATE(1385),
    [sym_math_expression] = STATE(1385),
    [sym_cast_expression] = STATE(1385),
    [sym_sizeof_expression] = STATE(1385),
    [sym_subscript_expression] = STATE(1385),
    [sym_call_expression] = STATE(1385),
    [sym_field_expression] = STATE(1385),
    [sym_compound_literal_expression] = STATE(1385),
    [sym_parenthesized_expression] = STATE(1385),
    [sym_concatenated_string] = STATE(1385),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3754),
    [anon_sym_LBRACE] = ACTIONS(3756),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3758),
    [anon_sym_switch] = ACTIONS(3760),
    [anon_sym_case] = ACTIONS(3762),
    [anon_sym_default] = ACTIONS(3764),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3772),
    [anon_sym_break] = ACTIONS(3774),
    [anon_sym_continue] = ACTIONS(3776),
    [anon_sym_goto] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3780),
    [sym_char_literal] = ACTIONS(3780),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3782),
    [sym_false] = ACTIONS(3782),
    [sym_null] = ACTIONS(3782),
    [sym_identifier] = ACTIONS(3784),
    [sym_comment] = ACTIONS(42),
  },
  [1649] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1686),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4364),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1650] = {
    [sym__expression] = STATE(1687),
    [sym_conditional_expression] = STATE(1687),
    [sym_assignment_expression] = STATE(1687),
    [sym_pointer_expression] = STATE(1687),
    [sym_logical_expression] = STATE(1687),
    [sym_bitwise_expression] = STATE(1687),
    [sym_equality_expression] = STATE(1687),
    [sym_relational_expression] = STATE(1687),
    [sym_shift_expression] = STATE(1687),
    [sym_math_expression] = STATE(1687),
    [sym_cast_expression] = STATE(1687),
    [sym_sizeof_expression] = STATE(1687),
    [sym_subscript_expression] = STATE(1687),
    [sym_call_expression] = STATE(1687),
    [sym_field_expression] = STATE(1687),
    [sym_compound_literal_expression] = STATE(1687),
    [sym_parenthesized_expression] = STATE(1687),
    [sym_concatenated_string] = STATE(1687),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(4364),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(4366),
    [sym_char_literal] = ACTIONS(4366),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(4368),
    [sym_false] = ACTIONS(4368),
    [sym_null] = ACTIONS(4368),
    [sym_identifier] = ACTIONS(4368),
    [sym_comment] = ACTIONS(42),
  },
  [1651] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(4370),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1652] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4264),
    [anon_sym_LPAREN] = ACTIONS(4266),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4264),
    [sym_preproc_directive] = ACTIONS(4264),
    [anon_sym_SEMI] = ACTIONS(4266),
    [anon_sym_typedef] = ACTIONS(4264),
    [anon_sym_extern] = ACTIONS(4264),
    [anon_sym_LBRACE] = ACTIONS(4266),
    [anon_sym_STAR] = ACTIONS(4266),
    [anon_sym_static] = ACTIONS(4264),
    [anon_sym_auto] = ACTIONS(4264),
    [anon_sym_register] = ACTIONS(4264),
    [anon_sym_inline] = ACTIONS(4264),
    [anon_sym_const] = ACTIONS(4264),
    [anon_sym_restrict] = ACTIONS(4264),
    [anon_sym_volatile] = ACTIONS(4264),
    [anon_sym__Atomic] = ACTIONS(4264),
    [anon_sym_unsigned] = ACTIONS(4264),
    [anon_sym_long] = ACTIONS(4264),
    [anon_sym_short] = ACTIONS(4264),
    [sym_primitive_type] = ACTIONS(4264),
    [anon_sym_enum] = ACTIONS(4264),
    [anon_sym_struct] = ACTIONS(4264),
    [anon_sym_union] = ACTIONS(4264),
    [anon_sym_if] = ACTIONS(4264),
    [anon_sym_switch] = ACTIONS(4264),
    [anon_sym_case] = ACTIONS(4264),
    [anon_sym_default] = ACTIONS(4264),
    [anon_sym_while] = ACTIONS(4264),
    [anon_sym_do] = ACTIONS(4264),
    [anon_sym_for] = ACTIONS(4264),
    [anon_sym_return] = ACTIONS(4264),
    [anon_sym_break] = ACTIONS(4264),
    [anon_sym_continue] = ACTIONS(4264),
    [anon_sym_goto] = ACTIONS(4264),
    [anon_sym_AMP] = ACTIONS(4266),
    [anon_sym_BANG] = ACTIONS(4266),
    [anon_sym_TILDE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_DASH] = ACTIONS(4264),
    [anon_sym_DASH_DASH] = ACTIONS(4266),
    [anon_sym_PLUS_PLUS] = ACTIONS(4266),
    [anon_sym_sizeof] = ACTIONS(4264),
    [sym_number_literal] = ACTIONS(4266),
    [sym_char_literal] = ACTIONS(4266),
    [sym_string_literal] = ACTIONS(4266),
    [sym_true] = ACTIONS(4264),
    [sym_false] = ACTIONS(4264),
    [sym_null] = ACTIONS(4264),
    [sym_identifier] = ACTIONS(4264),
    [sym_comment] = ACTIONS(42),
  },
  [1653] = {
    [sym_compound_statement] = STATE(1689),
    [sym_labeled_statement] = STATE(1689),
    [sym_expression_statement] = STATE(1689),
    [sym_if_statement] = STATE(1689),
    [sym_switch_statement] = STATE(1689),
    [sym_case_statement] = STATE(1689),
    [sym_while_statement] = STATE(1689),
    [sym_do_statement] = STATE(1689),
    [sym_for_statement] = STATE(1689),
    [sym_return_statement] = STATE(1689),
    [sym_break_statement] = STATE(1689),
    [sym_continue_statement] = STATE(1689),
    [sym_goto_statement] = STATE(1689),
    [sym__expression] = STATE(718),
    [sym_comma_expression] = STATE(719),
    [sym_conditional_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_pointer_expression] = STATE(718),
    [sym_logical_expression] = STATE(718),
    [sym_bitwise_expression] = STATE(718),
    [sym_equality_expression] = STATE(718),
    [sym_relational_expression] = STATE(718),
    [sym_shift_expression] = STATE(718),
    [sym_math_expression] = STATE(718),
    [sym_cast_expression] = STATE(718),
    [sym_sizeof_expression] = STATE(718),
    [sym_subscript_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_field_expression] = STATE(718),
    [sym_compound_literal_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_concatenated_string] = STATE(718),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(1655),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_case] = ACTIONS(1665),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1669),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1677),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_goto] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [sym_null] = ACTIONS(1685),
    [sym_identifier] = ACTIONS(3040),
    [sym_comment] = ACTIONS(42),
  },
  [1654] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4012),
    [anon_sym_LPAREN] = ACTIONS(4014),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4012),
    [sym_preproc_directive] = ACTIONS(4012),
    [anon_sym_SEMI] = ACTIONS(4014),
    [anon_sym_typedef] = ACTIONS(4012),
    [anon_sym_extern] = ACTIONS(4012),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_RBRACE] = ACTIONS(4014),
    [anon_sym_STAR] = ACTIONS(4014),
    [anon_sym_static] = ACTIONS(4012),
    [anon_sym_auto] = ACTIONS(4012),
    [anon_sym_register] = ACTIONS(4012),
    [anon_sym_inline] = ACTIONS(4012),
    [anon_sym_const] = ACTIONS(4012),
    [anon_sym_restrict] = ACTIONS(4012),
    [anon_sym_volatile] = ACTIONS(4012),
    [anon_sym__Atomic] = ACTIONS(4012),
    [anon_sym_unsigned] = ACTIONS(4012),
    [anon_sym_long] = ACTIONS(4012),
    [anon_sym_short] = ACTIONS(4012),
    [sym_primitive_type] = ACTIONS(4012),
    [anon_sym_enum] = ACTIONS(4012),
    [anon_sym_struct] = ACTIONS(4012),
    [anon_sym_union] = ACTIONS(4012),
    [anon_sym_if] = ACTIONS(4012),
    [anon_sym_else] = ACTIONS(4012),
    [anon_sym_switch] = ACTIONS(4012),
    [anon_sym_case] = ACTIONS(4012),
    [anon_sym_default] = ACTIONS(4012),
    [anon_sym_while] = ACTIONS(4012),
    [anon_sym_do] = ACTIONS(4012),
    [anon_sym_for] = ACTIONS(4012),
    [anon_sym_return] = ACTIONS(4012),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_continue] = ACTIONS(4012),
    [anon_sym_goto] = ACTIONS(4012),
    [anon_sym_AMP] = ACTIONS(4014),
    [anon_sym_BANG] = ACTIONS(4014),
    [anon_sym_TILDE] = ACTIONS(4014),
    [anon_sym_PLUS] = ACTIONS(4012),
    [anon_sym_DASH] = ACTIONS(4012),
    [anon_sym_DASH_DASH] = ACTIONS(4014),
    [anon_sym_PLUS_PLUS] = ACTIONS(4014),
    [anon_sym_sizeof] = ACTIONS(4012),
    [sym_number_literal] = ACTIONS(4014),
    [sym_char_literal] = ACTIONS(4014),
    [sym_string_literal] = ACTIONS(4014),
    [sym_true] = ACTIONS(4012),
    [sym_false] = ACTIONS(4012),
    [sym_null] = ACTIONS(4012),
    [sym_identifier] = ACTIONS(4012),
    [sym_comment] = ACTIONS(42),
  },
  [1655] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1409),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1411),
    [sym_preproc_directive] = ACTIONS(1411),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_typedef] = ACTIONS(1411),
    [anon_sym_extern] = ACTIONS(1411),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_static] = ACTIONS(1411),
    [anon_sym_auto] = ACTIONS(1411),
    [anon_sym_register] = ACTIONS(1411),
    [anon_sym_inline] = ACTIONS(1411),
    [anon_sym_const] = ACTIONS(1411),
    [anon_sym_restrict] = ACTIONS(1411),
    [anon_sym_volatile] = ACTIONS(1411),
    [anon_sym__Atomic] = ACTIONS(1411),
    [anon_sym_unsigned] = ACTIONS(1411),
    [anon_sym_long] = ACTIONS(1411),
    [anon_sym_short] = ACTIONS(1411),
    [sym_primitive_type] = ACTIONS(1411),
    [anon_sym_enum] = ACTIONS(1411),
    [anon_sym_struct] = ACTIONS(1411),
    [anon_sym_union] = ACTIONS(1411),
    [anon_sym_if] = ACTIONS(1411),
    [anon_sym_else] = ACTIONS(1411),
    [anon_sym_switch] = ACTIONS(1411),
    [anon_sym_case] = ACTIONS(1411),
    [anon_sym_default] = ACTIONS(1411),
    [anon_sym_while] = ACTIONS(1411),
    [anon_sym_do] = ACTIONS(1411),
    [anon_sym_for] = ACTIONS(1411),
    [anon_sym_return] = ACTIONS(1411),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_continue] = ACTIONS(1411),
    [anon_sym_goto] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1411),
    [anon_sym_DASH] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1409),
    [anon_sym_sizeof] = ACTIONS(1411),
    [sym_number_literal] = ACTIONS(1409),
    [sym_char_literal] = ACTIONS(1409),
    [sym_string_literal] = ACTIONS(1409),
    [sym_true] = ACTIONS(1411),
    [sym_false] = ACTIONS(1411),
    [sym_null] = ACTIONS(1411),
    [sym_identifier] = ACTIONS(1411),
    [sym_comment] = ACTIONS(42),
  },
  [1656] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4044),
    [anon_sym_LPAREN] = ACTIONS(4046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4044),
    [sym_preproc_directive] = ACTIONS(4044),
    [anon_sym_SEMI] = ACTIONS(4046),
    [anon_sym_typedef] = ACTIONS(4044),
    [anon_sym_extern] = ACTIONS(4044),
    [anon_sym_LBRACE] = ACTIONS(4046),
    [anon_sym_RBRACE] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(4046),
    [anon_sym_static] = ACTIONS(4044),
    [anon_sym_auto] = ACTIONS(4044),
    [anon_sym_register] = ACTIONS(4044),
    [anon_sym_inline] = ACTIONS(4044),
    [anon_sym_const] = ACTIONS(4044),
    [anon_sym_restrict] = ACTIONS(4044),
    [anon_sym_volatile] = ACTIONS(4044),
    [anon_sym__Atomic] = ACTIONS(4044),
    [anon_sym_unsigned] = ACTIONS(4044),
    [anon_sym_long] = ACTIONS(4044),
    [anon_sym_short] = ACTIONS(4044),
    [sym_primitive_type] = ACTIONS(4044),
    [anon_sym_enum] = ACTIONS(4044),
    [anon_sym_struct] = ACTIONS(4044),
    [anon_sym_union] = ACTIONS(4044),
    [anon_sym_if] = ACTIONS(4044),
    [anon_sym_else] = ACTIONS(4044),
    [anon_sym_switch] = ACTIONS(4044),
    [anon_sym_case] = ACTIONS(4044),
    [anon_sym_default] = ACTIONS(4044),
    [anon_sym_while] = ACTIONS(4044),
    [anon_sym_do] = ACTIONS(4044),
    [anon_sym_for] = ACTIONS(4044),
    [anon_sym_return] = ACTIONS(4044),
    [anon_sym_break] = ACTIONS(4044),
    [anon_sym_continue] = ACTIONS(4044),
    [anon_sym_goto] = ACTIONS(4044),
    [anon_sym_AMP] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(4046),
    [anon_sym_TILDE] = ACTIONS(4046),
    [anon_sym_PLUS] = ACTIONS(4044),
    [anon_sym_DASH] = ACTIONS(4044),
    [anon_sym_DASH_DASH] = ACTIONS(4046),
    [anon_sym_PLUS_PLUS] = ACTIONS(4046),
    [anon_sym_sizeof] = ACTIONS(4044),
    [sym_number_literal] = ACTIONS(4046),
    [sym_char_literal] = ACTIONS(4046),
    [sym_string_literal] = ACTIONS(4046),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [sym_null] = ACTIONS(4044),
    [sym_identifier] = ACTIONS(4044),
    [sym_comment] = ACTIONS(42),
  },
  [1657] = {
    [sym_compound_statement] = STATE(1690),
    [sym_labeled_statement] = STATE(1690),
    [sym_expression_statement] = STATE(1690),
    [sym_if_statement] = STATE(1690),
    [sym_switch_statement] = STATE(1690),
    [sym_case_statement] = STATE(1690),
    [sym_while_statement] = STATE(1690),
    [sym_do_statement] = STATE(1690),
    [sym_for_statement] = STATE(1690),
    [sym_return_statement] = STATE(1690),
    [sym_break_statement] = STATE(1690),
    [sym_continue_statement] = STATE(1690),
    [sym_goto_statement] = STATE(1690),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3173),
    [anon_sym_switch] = ACTIONS(3175),
    [anon_sym_case] = ACTIONS(3177),
    [anon_sym_default] = ACTIONS(3179),
    [anon_sym_while] = ACTIONS(3181),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3185),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3199),
    [sym_comment] = ACTIONS(42),
  },
  [1658] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4372),
    [sym_comment] = ACTIONS(42),
  },
  [1659] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1692),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4372),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1660] = {
    [sym_compound_statement] = STATE(1654),
    [sym_labeled_statement] = STATE(1654),
    [sym_expression_statement] = STATE(1654),
    [sym_if_statement] = STATE(1654),
    [sym_switch_statement] = STATE(1654),
    [sym_case_statement] = STATE(1654),
    [sym_while_statement] = STATE(1654),
    [sym_do_statement] = STATE(1654),
    [sym_for_statement] = STATE(1654),
    [sym_return_statement] = STATE(1654),
    [sym_break_statement] = STATE(1654),
    [sym_continue_statement] = STATE(1654),
    [sym_goto_statement] = STATE(1654),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3631),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_case] = ACTIONS(3635),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3639),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3643),
    [sym_comment] = ACTIONS(42),
  },
  [1661] = {
    [sym_compound_statement] = STATE(1656),
    [sym_labeled_statement] = STATE(1656),
    [sym_expression_statement] = STATE(1656),
    [sym_if_statement] = STATE(1656),
    [sym_switch_statement] = STATE(1656),
    [sym_case_statement] = STATE(1656),
    [sym_while_statement] = STATE(1656),
    [sym_do_statement] = STATE(1656),
    [sym_for_statement] = STATE(1656),
    [sym_return_statement] = STATE(1656),
    [sym_break_statement] = STATE(1656),
    [sym_continue_statement] = STATE(1656),
    [sym_goto_statement] = STATE(1656),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3631),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_case] = ACTIONS(3635),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3639),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3643),
    [sym_comment] = ACTIONS(42),
  },
  [1662] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4374),
    [sym_comment] = ACTIONS(42),
  },
  [1663] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1694),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1664] = {
    [sym__expression] = STATE(1695),
    [sym_conditional_expression] = STATE(1695),
    [sym_assignment_expression] = STATE(1695),
    [sym_pointer_expression] = STATE(1695),
    [sym_logical_expression] = STATE(1695),
    [sym_bitwise_expression] = STATE(1695),
    [sym_equality_expression] = STATE(1695),
    [sym_relational_expression] = STATE(1695),
    [sym_shift_expression] = STATE(1695),
    [sym_math_expression] = STATE(1695),
    [sym_cast_expression] = STATE(1695),
    [sym_sizeof_expression] = STATE(1695),
    [sym_subscript_expression] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_field_expression] = STATE(1695),
    [sym_compound_literal_expression] = STATE(1695),
    [sym_parenthesized_expression] = STATE(1695),
    [sym_concatenated_string] = STATE(1695),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(4376),
    [sym_char_literal] = ACTIONS(4376),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(4378),
    [sym_false] = ACTIONS(4378),
    [sym_null] = ACTIONS(4378),
    [sym_identifier] = ACTIONS(4378),
    [sym_comment] = ACTIONS(42),
  },
  [1665] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3605),
    [anon_sym_LPAREN] = ACTIONS(3607),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3605),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3605),
    [sym_preproc_directive] = ACTIONS(3605),
    [anon_sym_SEMI] = ACTIONS(3607),
    [anon_sym_typedef] = ACTIONS(3605),
    [anon_sym_extern] = ACTIONS(3605),
    [anon_sym_LBRACE] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(3607),
    [anon_sym_static] = ACTIONS(3605),
    [anon_sym_auto] = ACTIONS(3605),
    [anon_sym_register] = ACTIONS(3605),
    [anon_sym_inline] = ACTIONS(3605),
    [anon_sym_const] = ACTIONS(3605),
    [anon_sym_restrict] = ACTIONS(3605),
    [anon_sym_volatile] = ACTIONS(3605),
    [anon_sym__Atomic] = ACTIONS(3605),
    [anon_sym_unsigned] = ACTIONS(3605),
    [anon_sym_long] = ACTIONS(3605),
    [anon_sym_short] = ACTIONS(3605),
    [sym_primitive_type] = ACTIONS(3605),
    [anon_sym_enum] = ACTIONS(3605),
    [anon_sym_struct] = ACTIONS(3605),
    [anon_sym_union] = ACTIONS(3605),
    [anon_sym_if] = ACTIONS(3605),
    [anon_sym_else] = ACTIONS(4380),
    [anon_sym_switch] = ACTIONS(3605),
    [anon_sym_case] = ACTIONS(3605),
    [anon_sym_default] = ACTIONS(3605),
    [anon_sym_while] = ACTIONS(3605),
    [anon_sym_do] = ACTIONS(3605),
    [anon_sym_for] = ACTIONS(3605),
    [anon_sym_return] = ACTIONS(3605),
    [anon_sym_break] = ACTIONS(3605),
    [anon_sym_continue] = ACTIONS(3605),
    [anon_sym_goto] = ACTIONS(3605),
    [anon_sym_AMP] = ACTIONS(3607),
    [anon_sym_BANG] = ACTIONS(3607),
    [anon_sym_TILDE] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3605),
    [anon_sym_DASH] = ACTIONS(3605),
    [anon_sym_DASH_DASH] = ACTIONS(3607),
    [anon_sym_PLUS_PLUS] = ACTIONS(3607),
    [anon_sym_sizeof] = ACTIONS(3605),
    [sym_number_literal] = ACTIONS(3607),
    [sym_char_literal] = ACTIONS(3607),
    [sym_string_literal] = ACTIONS(3607),
    [sym_true] = ACTIONS(3605),
    [sym_false] = ACTIONS(3605),
    [sym_null] = ACTIONS(3605),
    [sym_identifier] = ACTIONS(3605),
    [sym_comment] = ACTIONS(42),
  },
  [1666] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3615),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3615),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3615),
    [sym_preproc_directive] = ACTIONS(3615),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_typedef] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_STAR] = ACTIONS(3617),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_auto] = ACTIONS(3615),
    [anon_sym_register] = ACTIONS(3615),
    [anon_sym_inline] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_restrict] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym__Atomic] = ACTIONS(3615),
    [anon_sym_unsigned] = ACTIONS(3615),
    [anon_sym_long] = ACTIONS(3615),
    [anon_sym_short] = ACTIONS(3615),
    [sym_primitive_type] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_union] = ACTIONS(3615),
    [anon_sym_if] = ACTIONS(3615),
    [anon_sym_else] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3615),
    [anon_sym_case] = ACTIONS(3615),
    [anon_sym_default] = ACTIONS(3615),
    [anon_sym_while] = ACTIONS(3615),
    [anon_sym_do] = ACTIONS(3615),
    [anon_sym_for] = ACTIONS(3615),
    [anon_sym_return] = ACTIONS(3615),
    [anon_sym_break] = ACTIONS(3615),
    [anon_sym_continue] = ACTIONS(3615),
    [anon_sym_goto] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_DASH_DASH] = ACTIONS(3617),
    [anon_sym_PLUS_PLUS] = ACTIONS(3617),
    [anon_sym_sizeof] = ACTIONS(3615),
    [sym_number_literal] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [sym_string_literal] = ACTIONS(3617),
    [sym_true] = ACTIONS(3615),
    [sym_false] = ACTIONS(3615),
    [sym_null] = ACTIONS(3615),
    [sym_identifier] = ACTIONS(3615),
    [sym_comment] = ACTIONS(42),
  },
  [1667] = {
    [sym_parameter_list] = STATE(200),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_SEMI] = ACTIONS(4382),
    [anon_sym_LBRACK] = ACTIONS(449),
    [sym_comment] = ACTIONS(42),
  },
  [1668] = {
    [sym__type_declarator] = STATE(1698),
    [sym_pointer_type_declarator] = STATE(99),
    [sym_function_type_declarator] = STATE(100),
    [sym_array_type_declarator] = STATE(101),
    [anon_sym_LPAREN] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(187),
    [sym_identifier] = ACTIONS(189),
    [sym_comment] = ACTIONS(42),
  },
  [1669] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(567),
    [anon_sym_LPAREN] = ACTIONS(565),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(567),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(567),
    [sym_preproc_directive] = ACTIONS(567),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_typedef] = ACTIONS(567),
    [anon_sym_extern] = ACTIONS(567),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_STAR] = ACTIONS(565),
    [anon_sym_static] = ACTIONS(567),
    [anon_sym_auto] = ACTIONS(567),
    [anon_sym_register] = ACTIONS(567),
    [anon_sym_inline] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_restrict] = ACTIONS(567),
    [anon_sym_volatile] = ACTIONS(567),
    [anon_sym__Atomic] = ACTIONS(567),
    [anon_sym_unsigned] = ACTIONS(567),
    [anon_sym_long] = ACTIONS(567),
    [anon_sym_short] = ACTIONS(567),
    [sym_primitive_type] = ACTIONS(567),
    [anon_sym_enum] = ACTIONS(567),
    [anon_sym_struct] = ACTIONS(567),
    [anon_sym_union] = ACTIONS(567),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_else] = ACTIONS(567),
    [anon_sym_switch] = ACTIONS(567),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_default] = ACTIONS(567),
    [anon_sym_while] = ACTIONS(567),
    [anon_sym_do] = ACTIONS(567),
    [anon_sym_for] = ACTIONS(567),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_break] = ACTIONS(567),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(565),
    [anon_sym_TILDE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_sizeof] = ACTIONS(567),
    [sym_number_literal] = ACTIONS(565),
    [sym_char_literal] = ACTIONS(565),
    [sym_string_literal] = ACTIONS(565),
    [sym_true] = ACTIONS(567),
    [sym_false] = ACTIONS(567),
    [sym_null] = ACTIONS(567),
    [sym_identifier] = ACTIONS(567),
    [sym_comment] = ACTIONS(42),
  },
  [1670] = {
    [aux_sym_declaration_repeat1] = STATE(302),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(4384),
    [sym_comment] = ACTIONS(42),
  },
  [1671] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3627),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3627),
    [sym_preproc_directive] = ACTIONS(3627),
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym_typedef] = ACTIONS(3627),
    [anon_sym_extern] = ACTIONS(3627),
    [anon_sym_LBRACE] = ACTIONS(3629),
    [anon_sym_STAR] = ACTIONS(3629),
    [anon_sym_static] = ACTIONS(3627),
    [anon_sym_auto] = ACTIONS(3627),
    [anon_sym_register] = ACTIONS(3627),
    [anon_sym_inline] = ACTIONS(3627),
    [anon_sym_const] = ACTIONS(3627),
    [anon_sym_restrict] = ACTIONS(3627),
    [anon_sym_volatile] = ACTIONS(3627),
    [anon_sym__Atomic] = ACTIONS(3627),
    [anon_sym_unsigned] = ACTIONS(3627),
    [anon_sym_long] = ACTIONS(3627),
    [anon_sym_short] = ACTIONS(3627),
    [sym_primitive_type] = ACTIONS(3627),
    [anon_sym_enum] = ACTIONS(3627),
    [anon_sym_struct] = ACTIONS(3627),
    [anon_sym_union] = ACTIONS(3627),
    [anon_sym_if] = ACTIONS(3627),
    [anon_sym_else] = ACTIONS(3627),
    [anon_sym_switch] = ACTIONS(3627),
    [anon_sym_case] = ACTIONS(3627),
    [anon_sym_default] = ACTIONS(3627),
    [anon_sym_while] = ACTIONS(3627),
    [anon_sym_do] = ACTIONS(3627),
    [anon_sym_for] = ACTIONS(3627),
    [anon_sym_return] = ACTIONS(3627),
    [anon_sym_break] = ACTIONS(3627),
    [anon_sym_continue] = ACTIONS(3627),
    [anon_sym_goto] = ACTIONS(3627),
    [anon_sym_AMP] = ACTIONS(3629),
    [anon_sym_BANG] = ACTIONS(3629),
    [anon_sym_TILDE] = ACTIONS(3629),
    [anon_sym_PLUS] = ACTIONS(3627),
    [anon_sym_DASH] = ACTIONS(3627),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_sizeof] = ACTIONS(3627),
    [sym_number_literal] = ACTIONS(3629),
    [sym_char_literal] = ACTIONS(3629),
    [sym_string_literal] = ACTIONS(3629),
    [sym_true] = ACTIONS(3627),
    [sym_false] = ACTIONS(3627),
    [sym_null] = ACTIONS(3627),
    [sym_identifier] = ACTIONS(3627),
    [sym_comment] = ACTIONS(42),
  },
  [1672] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(4386),
    [anon_sym_STAR] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2613),
    [anon_sym_STAR_EQ] = ACTIONS(2615),
    [anon_sym_SLASH_EQ] = ACTIONS(2615),
    [anon_sym_PERCENT_EQ] = ACTIONS(2615),
    [anon_sym_PLUS_EQ] = ACTIONS(2615),
    [anon_sym_DASH_EQ] = ACTIONS(2615),
    [anon_sym_LT_LT_EQ] = ACTIONS(2615),
    [anon_sym_GT_GT_EQ] = ACTIONS(2615),
    [anon_sym_AMP_EQ] = ACTIONS(2615),
    [anon_sym_CARET_EQ] = ACTIONS(2615),
    [anon_sym_PIPE_EQ] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_PIPE_PIPE] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2621),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_CARET] = ACTIONS(2625),
    [anon_sym_EQ_EQ] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2629),
    [anon_sym_LT_EQ] = ACTIONS(2631),
    [anon_sym_GT_EQ] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1673] = {
    [sym_compound_statement] = STATE(1701),
    [sym_labeled_statement] = STATE(1701),
    [sym_expression_statement] = STATE(1701),
    [sym_if_statement] = STATE(1701),
    [sym_switch_statement] = STATE(1701),
    [sym_case_statement] = STATE(1701),
    [sym_while_statement] = STATE(1701),
    [sym_do_statement] = STATE(1701),
    [sym_for_statement] = STATE(1701),
    [sym_return_statement] = STATE(1701),
    [sym_break_statement] = STATE(1701),
    [sym_continue_statement] = STATE(1701),
    [sym_goto_statement] = STATE(1701),
    [sym__expression] = STATE(1451),
    [sym_comma_expression] = STATE(1452),
    [sym_conditional_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(1451),
    [sym_pointer_expression] = STATE(1451),
    [sym_logical_expression] = STATE(1451),
    [sym_bitwise_expression] = STATE(1451),
    [sym_equality_expression] = STATE(1451),
    [sym_relational_expression] = STATE(1451),
    [sym_shift_expression] = STATE(1451),
    [sym_math_expression] = STATE(1451),
    [sym_cast_expression] = STATE(1451),
    [sym_sizeof_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_call_expression] = STATE(1451),
    [sym_field_expression] = STATE(1451),
    [sym_compound_literal_expression] = STATE(1451),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_concatenated_string] = STATE(1451),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3900),
    [anon_sym_LBRACE] = ACTIONS(3902),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3904),
    [anon_sym_switch] = ACTIONS(3906),
    [anon_sym_case] = ACTIONS(3908),
    [anon_sym_default] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3912),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_for] = ACTIONS(3916),
    [anon_sym_return] = ACTIONS(3918),
    [anon_sym_break] = ACTIONS(3920),
    [anon_sym_continue] = ACTIONS(3922),
    [anon_sym_goto] = ACTIONS(3924),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3926),
    [sym_char_literal] = ACTIONS(3926),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3928),
    [sym_false] = ACTIONS(3928),
    [sym_null] = ACTIONS(3928),
    [sym_identifier] = ACTIONS(3930),
    [sym_comment] = ACTIONS(42),
  },
  [1674] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1703),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4388),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1675] = {
    [sym__expression] = STATE(1704),
    [sym_conditional_expression] = STATE(1704),
    [sym_assignment_expression] = STATE(1704),
    [sym_pointer_expression] = STATE(1704),
    [sym_logical_expression] = STATE(1704),
    [sym_bitwise_expression] = STATE(1704),
    [sym_equality_expression] = STATE(1704),
    [sym_relational_expression] = STATE(1704),
    [sym_shift_expression] = STATE(1704),
    [sym_math_expression] = STATE(1704),
    [sym_cast_expression] = STATE(1704),
    [sym_sizeof_expression] = STATE(1704),
    [sym_subscript_expression] = STATE(1704),
    [sym_call_expression] = STATE(1704),
    [sym_field_expression] = STATE(1704),
    [sym_compound_literal_expression] = STATE(1704),
    [sym_parenthesized_expression] = STATE(1704),
    [sym_concatenated_string] = STATE(1704),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(4388),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(4390),
    [sym_char_literal] = ACTIONS(4390),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(4392),
    [sym_false] = ACTIONS(4392),
    [sym_null] = ACTIONS(4392),
    [sym_identifier] = ACTIONS(4392),
    [sym_comment] = ACTIONS(42),
  },
  [1676] = {
    [sym_argument_list] = STATE(503),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(4394),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1520),
    [anon_sym_SLASH_EQ] = ACTIONS(1520),
    [anon_sym_PERCENT_EQ] = ACTIONS(1520),
    [anon_sym_PLUS_EQ] = ACTIONS(1520),
    [anon_sym_DASH_EQ] = ACTIONS(1520),
    [anon_sym_LT_LT_EQ] = ACTIONS(1520),
    [anon_sym_GT_GT_EQ] = ACTIONS(1520),
    [anon_sym_AMP_EQ] = ACTIONS(1520),
    [anon_sym_CARET_EQ] = ACTIONS(1520),
    [anon_sym_PIPE_EQ] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1677] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4264),
    [anon_sym_LPAREN] = ACTIONS(4266),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4264),
    [sym_preproc_directive] = ACTIONS(4264),
    [anon_sym_SEMI] = ACTIONS(4266),
    [anon_sym_typedef] = ACTIONS(4264),
    [anon_sym_extern] = ACTIONS(4264),
    [anon_sym_LBRACE] = ACTIONS(4266),
    [anon_sym_STAR] = ACTIONS(4266),
    [anon_sym_static] = ACTIONS(4264),
    [anon_sym_auto] = ACTIONS(4264),
    [anon_sym_register] = ACTIONS(4264),
    [anon_sym_inline] = ACTIONS(4264),
    [anon_sym_const] = ACTIONS(4264),
    [anon_sym_restrict] = ACTIONS(4264),
    [anon_sym_volatile] = ACTIONS(4264),
    [anon_sym__Atomic] = ACTIONS(4264),
    [anon_sym_unsigned] = ACTIONS(4264),
    [anon_sym_long] = ACTIONS(4264),
    [anon_sym_short] = ACTIONS(4264),
    [sym_primitive_type] = ACTIONS(4264),
    [anon_sym_enum] = ACTIONS(4264),
    [anon_sym_struct] = ACTIONS(4264),
    [anon_sym_union] = ACTIONS(4264),
    [anon_sym_if] = ACTIONS(4264),
    [anon_sym_switch] = ACTIONS(4264),
    [anon_sym_case] = ACTIONS(4264),
    [anon_sym_default] = ACTIONS(4264),
    [anon_sym_while] = ACTIONS(4264),
    [anon_sym_do] = ACTIONS(4264),
    [anon_sym_for] = ACTIONS(4264),
    [anon_sym_return] = ACTIONS(4264),
    [anon_sym_break] = ACTIONS(4264),
    [anon_sym_continue] = ACTIONS(4264),
    [anon_sym_goto] = ACTIONS(4264),
    [anon_sym_AMP] = ACTIONS(4266),
    [anon_sym_BANG] = ACTIONS(4266),
    [anon_sym_TILDE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_DASH] = ACTIONS(4264),
    [anon_sym_DASH_DASH] = ACTIONS(4266),
    [anon_sym_PLUS_PLUS] = ACTIONS(4266),
    [anon_sym_sizeof] = ACTIONS(4264),
    [sym_number_literal] = ACTIONS(4266),
    [sym_char_literal] = ACTIONS(4266),
    [sym_string_literal] = ACTIONS(4266),
    [sym_true] = ACTIONS(4264),
    [sym_false] = ACTIONS(4264),
    [sym_null] = ACTIONS(4264),
    [sym_identifier] = ACTIONS(4264),
    [sym_comment] = ACTIONS(42),
  },
  [1678] = {
    [sym_compound_statement] = STATE(1706),
    [sym_labeled_statement] = STATE(1706),
    [sym_expression_statement] = STATE(1706),
    [sym_if_statement] = STATE(1706),
    [sym_switch_statement] = STATE(1706),
    [sym_case_statement] = STATE(1706),
    [sym_while_statement] = STATE(1706),
    [sym_do_statement] = STATE(1706),
    [sym_for_statement] = STATE(1706),
    [sym_return_statement] = STATE(1706),
    [sym_break_statement] = STATE(1706),
    [sym_continue_statement] = STATE(1706),
    [sym_goto_statement] = STATE(1706),
    [sym__expression] = STATE(954),
    [sym_comma_expression] = STATE(955),
    [sym_conditional_expression] = STATE(954),
    [sym_assignment_expression] = STATE(954),
    [sym_pointer_expression] = STATE(954),
    [sym_logical_expression] = STATE(954),
    [sym_bitwise_expression] = STATE(954),
    [sym_equality_expression] = STATE(954),
    [sym_relational_expression] = STATE(954),
    [sym_shift_expression] = STATE(954),
    [sym_math_expression] = STATE(954),
    [sym_cast_expression] = STATE(954),
    [sym_sizeof_expression] = STATE(954),
    [sym_subscript_expression] = STATE(954),
    [sym_call_expression] = STATE(954),
    [sym_field_expression] = STATE(954),
    [sym_compound_literal_expression] = STATE(954),
    [sym_parenthesized_expression] = STATE(954),
    [sym_concatenated_string] = STATE(954),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(2497),
    [anon_sym_switch] = ACTIONS(2499),
    [anon_sym_case] = ACTIONS(2501),
    [anon_sym_default] = ACTIONS(2503),
    [anon_sym_while] = ACTIONS(2505),
    [anon_sym_do] = ACTIONS(2507),
    [anon_sym_for] = ACTIONS(2509),
    [anon_sym_return] = ACTIONS(2511),
    [anon_sym_break] = ACTIONS(2513),
    [anon_sym_continue] = ACTIONS(2515),
    [anon_sym_goto] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(2519),
    [sym_char_literal] = ACTIONS(2519),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(2521),
    [sym_false] = ACTIONS(2521),
    [sym_null] = ACTIONS(2521),
    [sym_identifier] = ACTIONS(3445),
    [sym_comment] = ACTIONS(42),
  },
  [1679] = {
    [sym_compound_statement] = STATE(1707),
    [sym_labeled_statement] = STATE(1707),
    [sym_expression_statement] = STATE(1707),
    [sym_if_statement] = STATE(1707),
    [sym_switch_statement] = STATE(1707),
    [sym_case_statement] = STATE(1707),
    [sym_while_statement] = STATE(1707),
    [sym_do_statement] = STATE(1707),
    [sym_for_statement] = STATE(1707),
    [sym_return_statement] = STATE(1707),
    [sym_break_statement] = STATE(1707),
    [sym_continue_statement] = STATE(1707),
    [sym_goto_statement] = STATE(1707),
    [sym__expression] = STATE(1385),
    [sym_comma_expression] = STATE(1386),
    [sym_conditional_expression] = STATE(1385),
    [sym_assignment_expression] = STATE(1385),
    [sym_pointer_expression] = STATE(1385),
    [sym_logical_expression] = STATE(1385),
    [sym_bitwise_expression] = STATE(1385),
    [sym_equality_expression] = STATE(1385),
    [sym_relational_expression] = STATE(1385),
    [sym_shift_expression] = STATE(1385),
    [sym_math_expression] = STATE(1385),
    [sym_cast_expression] = STATE(1385),
    [sym_sizeof_expression] = STATE(1385),
    [sym_subscript_expression] = STATE(1385),
    [sym_call_expression] = STATE(1385),
    [sym_field_expression] = STATE(1385),
    [sym_compound_literal_expression] = STATE(1385),
    [sym_parenthesized_expression] = STATE(1385),
    [sym_concatenated_string] = STATE(1385),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3754),
    [anon_sym_LBRACE] = ACTIONS(3756),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3758),
    [anon_sym_switch] = ACTIONS(3760),
    [anon_sym_case] = ACTIONS(3762),
    [anon_sym_default] = ACTIONS(3764),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3772),
    [anon_sym_break] = ACTIONS(3774),
    [anon_sym_continue] = ACTIONS(3776),
    [anon_sym_goto] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3780),
    [sym_char_literal] = ACTIONS(3780),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3782),
    [sym_false] = ACTIONS(3782),
    [sym_null] = ACTIONS(3782),
    [sym_identifier] = ACTIONS(3784),
    [sym_comment] = ACTIONS(42),
  },
  [1680] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(813),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(815),
    [sym_preproc_directive] = ACTIONS(815),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_typedef] = ACTIONS(815),
    [anon_sym_extern] = ACTIONS(815),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_auto] = ACTIONS(815),
    [anon_sym_register] = ACTIONS(815),
    [anon_sym_inline] = ACTIONS(815),
    [anon_sym_const] = ACTIONS(815),
    [anon_sym_restrict] = ACTIONS(815),
    [anon_sym_volatile] = ACTIONS(815),
    [anon_sym__Atomic] = ACTIONS(815),
    [anon_sym_unsigned] = ACTIONS(815),
    [anon_sym_long] = ACTIONS(815),
    [anon_sym_short] = ACTIONS(815),
    [sym_primitive_type] = ACTIONS(815),
    [anon_sym_enum] = ACTIONS(815),
    [anon_sym_struct] = ACTIONS(815),
    [anon_sym_union] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(815),
    [anon_sym_else] = ACTIONS(815),
    [anon_sym_switch] = ACTIONS(815),
    [anon_sym_case] = ACTIONS(815),
    [anon_sym_default] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(815),
    [anon_sym_do] = ACTIONS(815),
    [anon_sym_for] = ACTIONS(815),
    [anon_sym_return] = ACTIONS(815),
    [anon_sym_break] = ACTIONS(815),
    [anon_sym_continue] = ACTIONS(815),
    [anon_sym_goto] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_sizeof] = ACTIONS(815),
    [sym_number_literal] = ACTIONS(813),
    [sym_char_literal] = ACTIONS(813),
    [sym_string_literal] = ACTIONS(813),
    [sym_true] = ACTIONS(815),
    [sym_false] = ACTIONS(815),
    [sym_null] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_comment] = ACTIONS(42),
  },
  [1681] = {
    [sym_parameter_list] = STATE(200),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_SEMI] = ACTIONS(4396),
    [anon_sym_LBRACK] = ACTIONS(449),
    [sym_comment] = ACTIONS(42),
  },
  [1682] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1288),
    [anon_sym_LPAREN] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1288),
    [sym_preproc_directive] = ACTIONS(1288),
    [anon_sym_SEMI] = ACTIONS(1286),
    [anon_sym_typedef] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1288),
    [anon_sym_LBRACE] = ACTIONS(1286),
    [anon_sym_STAR] = ACTIONS(1286),
    [anon_sym_static] = ACTIONS(1288),
    [anon_sym_auto] = ACTIONS(1288),
    [anon_sym_register] = ACTIONS(1288),
    [anon_sym_inline] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_restrict] = ACTIONS(1288),
    [anon_sym_volatile] = ACTIONS(1288),
    [anon_sym__Atomic] = ACTIONS(1288),
    [anon_sym_unsigned] = ACTIONS(1288),
    [anon_sym_long] = ACTIONS(1288),
    [anon_sym_short] = ACTIONS(1288),
    [sym_primitive_type] = ACTIONS(1288),
    [anon_sym_enum] = ACTIONS(1288),
    [anon_sym_struct] = ACTIONS(1288),
    [anon_sym_union] = ACTIONS(1288),
    [anon_sym_if] = ACTIONS(1288),
    [anon_sym_else] = ACTIONS(1288),
    [anon_sym_switch] = ACTIONS(1288),
    [anon_sym_case] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1288),
    [anon_sym_while] = ACTIONS(1288),
    [anon_sym_do] = ACTIONS(1288),
    [anon_sym_for] = ACTIONS(1288),
    [anon_sym_return] = ACTIONS(1288),
    [anon_sym_break] = ACTIONS(1288),
    [anon_sym_continue] = ACTIONS(1288),
    [anon_sym_goto] = ACTIONS(1288),
    [anon_sym_AMP] = ACTIONS(1286),
    [anon_sym_BANG] = ACTIONS(1286),
    [anon_sym_TILDE] = ACTIONS(1286),
    [anon_sym_PLUS] = ACTIONS(1288),
    [anon_sym_DASH] = ACTIONS(1288),
    [anon_sym_DASH_DASH] = ACTIONS(1286),
    [anon_sym_PLUS_PLUS] = ACTIONS(1286),
    [anon_sym_sizeof] = ACTIONS(1288),
    [sym_number_literal] = ACTIONS(1286),
    [sym_char_literal] = ACTIONS(1286),
    [sym_string_literal] = ACTIONS(1286),
    [sym_true] = ACTIONS(1288),
    [sym_false] = ACTIONS(1288),
    [sym_null] = ACTIONS(1288),
    [sym_identifier] = ACTIONS(1288),
    [sym_comment] = ACTIONS(42),
  },
  [1683] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3868),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3868),
    [sym_preproc_directive] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3870),
    [anon_sym_typedef] = ACTIONS(3868),
    [anon_sym_extern] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3870),
    [anon_sym_STAR] = ACTIONS(3870),
    [anon_sym_static] = ACTIONS(3868),
    [anon_sym_auto] = ACTIONS(3868),
    [anon_sym_register] = ACTIONS(3868),
    [anon_sym_inline] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(3868),
    [anon_sym_restrict] = ACTIONS(3868),
    [anon_sym_volatile] = ACTIONS(3868),
    [anon_sym__Atomic] = ACTIONS(3868),
    [anon_sym_unsigned] = ACTIONS(3868),
    [anon_sym_long] = ACTIONS(3868),
    [anon_sym_short] = ACTIONS(3868),
    [sym_primitive_type] = ACTIONS(3868),
    [anon_sym_enum] = ACTIONS(3868),
    [anon_sym_struct] = ACTIONS(3868),
    [anon_sym_union] = ACTIONS(3868),
    [anon_sym_if] = ACTIONS(3868),
    [anon_sym_else] = ACTIONS(3868),
    [anon_sym_switch] = ACTIONS(3868),
    [anon_sym_case] = ACTIONS(3868),
    [anon_sym_default] = ACTIONS(3868),
    [anon_sym_while] = ACTIONS(3868),
    [anon_sym_do] = ACTIONS(3868),
    [anon_sym_for] = ACTIONS(3868),
    [anon_sym_return] = ACTIONS(3868),
    [anon_sym_break] = ACTIONS(3868),
    [anon_sym_continue] = ACTIONS(3868),
    [anon_sym_goto] = ACTIONS(3868),
    [anon_sym_AMP] = ACTIONS(3870),
    [anon_sym_BANG] = ACTIONS(3870),
    [anon_sym_TILDE] = ACTIONS(3870),
    [anon_sym_PLUS] = ACTIONS(3868),
    [anon_sym_DASH] = ACTIONS(3868),
    [anon_sym_DASH_DASH] = ACTIONS(3870),
    [anon_sym_PLUS_PLUS] = ACTIONS(3870),
    [anon_sym_sizeof] = ACTIONS(3868),
    [sym_number_literal] = ACTIONS(3870),
    [sym_char_literal] = ACTIONS(3870),
    [sym_string_literal] = ACTIONS(3870),
    [sym_true] = ACTIONS(3868),
    [sym_false] = ACTIONS(3868),
    [sym_null] = ACTIONS(3868),
    [sym_identifier] = ACTIONS(3868),
    [sym_comment] = ACTIONS(42),
  },
  [1684] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3872),
    [anon_sym_LPAREN] = ACTIONS(3874),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(3872),
    [sym_preproc_directive] = ACTIONS(3872),
    [anon_sym_SEMI] = ACTIONS(3874),
    [anon_sym_typedef] = ACTIONS(3872),
    [anon_sym_extern] = ACTIONS(3872),
    [anon_sym_LBRACE] = ACTIONS(3874),
    [anon_sym_STAR] = ACTIONS(3874),
    [anon_sym_static] = ACTIONS(3872),
    [anon_sym_auto] = ACTIONS(3872),
    [anon_sym_register] = ACTIONS(3872),
    [anon_sym_inline] = ACTIONS(3872),
    [anon_sym_const] = ACTIONS(3872),
    [anon_sym_restrict] = ACTIONS(3872),
    [anon_sym_volatile] = ACTIONS(3872),
    [anon_sym__Atomic] = ACTIONS(3872),
    [anon_sym_unsigned] = ACTIONS(3872),
    [anon_sym_long] = ACTIONS(3872),
    [anon_sym_short] = ACTIONS(3872),
    [sym_primitive_type] = ACTIONS(3872),
    [anon_sym_enum] = ACTIONS(3872),
    [anon_sym_struct] = ACTIONS(3872),
    [anon_sym_union] = ACTIONS(3872),
    [anon_sym_if] = ACTIONS(3872),
    [anon_sym_else] = ACTIONS(3872),
    [anon_sym_switch] = ACTIONS(3872),
    [anon_sym_case] = ACTIONS(3872),
    [anon_sym_default] = ACTIONS(3872),
    [anon_sym_while] = ACTIONS(3872),
    [anon_sym_do] = ACTIONS(3872),
    [anon_sym_for] = ACTIONS(3872),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_break] = ACTIONS(3872),
    [anon_sym_continue] = ACTIONS(3872),
    [anon_sym_goto] = ACTIONS(3872),
    [anon_sym_AMP] = ACTIONS(3874),
    [anon_sym_BANG] = ACTIONS(3874),
    [anon_sym_TILDE] = ACTIONS(3874),
    [anon_sym_PLUS] = ACTIONS(3872),
    [anon_sym_DASH] = ACTIONS(3872),
    [anon_sym_DASH_DASH] = ACTIONS(3874),
    [anon_sym_PLUS_PLUS] = ACTIONS(3874),
    [anon_sym_sizeof] = ACTIONS(3872),
    [sym_number_literal] = ACTIONS(3874),
    [sym_char_literal] = ACTIONS(3874),
    [sym_string_literal] = ACTIONS(3874),
    [sym_true] = ACTIONS(3872),
    [sym_false] = ACTIONS(3872),
    [sym_null] = ACTIONS(3872),
    [sym_identifier] = ACTIONS(3872),
    [sym_comment] = ACTIONS(42),
  },
  [1685] = {
    [sym_compound_statement] = STATE(1709),
    [sym_labeled_statement] = STATE(1709),
    [sym_expression_statement] = STATE(1709),
    [sym_if_statement] = STATE(1709),
    [sym_switch_statement] = STATE(1709),
    [sym_case_statement] = STATE(1709),
    [sym_while_statement] = STATE(1709),
    [sym_do_statement] = STATE(1709),
    [sym_for_statement] = STATE(1709),
    [sym_return_statement] = STATE(1709),
    [sym_break_statement] = STATE(1709),
    [sym_continue_statement] = STATE(1709),
    [sym_goto_statement] = STATE(1709),
    [sym__expression] = STATE(1385),
    [sym_comma_expression] = STATE(1386),
    [sym_conditional_expression] = STATE(1385),
    [sym_assignment_expression] = STATE(1385),
    [sym_pointer_expression] = STATE(1385),
    [sym_logical_expression] = STATE(1385),
    [sym_bitwise_expression] = STATE(1385),
    [sym_equality_expression] = STATE(1385),
    [sym_relational_expression] = STATE(1385),
    [sym_shift_expression] = STATE(1385),
    [sym_math_expression] = STATE(1385),
    [sym_cast_expression] = STATE(1385),
    [sym_sizeof_expression] = STATE(1385),
    [sym_subscript_expression] = STATE(1385),
    [sym_call_expression] = STATE(1385),
    [sym_field_expression] = STATE(1385),
    [sym_compound_literal_expression] = STATE(1385),
    [sym_parenthesized_expression] = STATE(1385),
    [sym_concatenated_string] = STATE(1385),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3754),
    [anon_sym_LBRACE] = ACTIONS(3756),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3758),
    [anon_sym_switch] = ACTIONS(3760),
    [anon_sym_case] = ACTIONS(3762),
    [anon_sym_default] = ACTIONS(3764),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3772),
    [anon_sym_break] = ACTIONS(3774),
    [anon_sym_continue] = ACTIONS(3776),
    [anon_sym_goto] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3780),
    [sym_char_literal] = ACTIONS(3780),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3782),
    [sym_false] = ACTIONS(3782),
    [sym_null] = ACTIONS(3782),
    [sym_identifier] = ACTIONS(3784),
    [sym_comment] = ACTIONS(42),
  },
  [1686] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4398),
    [sym_comment] = ACTIONS(42),
  },
  [1687] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1711),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1688] = {
    [sym__expression] = STATE(1712),
    [sym_conditional_expression] = STATE(1712),
    [sym_assignment_expression] = STATE(1712),
    [sym_pointer_expression] = STATE(1712),
    [sym_logical_expression] = STATE(1712),
    [sym_bitwise_expression] = STATE(1712),
    [sym_equality_expression] = STATE(1712),
    [sym_relational_expression] = STATE(1712),
    [sym_shift_expression] = STATE(1712),
    [sym_math_expression] = STATE(1712),
    [sym_cast_expression] = STATE(1712),
    [sym_sizeof_expression] = STATE(1712),
    [sym_subscript_expression] = STATE(1712),
    [sym_call_expression] = STATE(1712),
    [sym_field_expression] = STATE(1712),
    [sym_compound_literal_expression] = STATE(1712),
    [sym_parenthesized_expression] = STATE(1712),
    [sym_concatenated_string] = STATE(1712),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(4400),
    [sym_char_literal] = ACTIONS(4400),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(4402),
    [sym_false] = ACTIONS(4402),
    [sym_null] = ACTIONS(4402),
    [sym_identifier] = ACTIONS(4402),
    [sym_comment] = ACTIONS(42),
  },
  [1689] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4330),
    [anon_sym_LPAREN] = ACTIONS(4332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4330),
    [sym_preproc_directive] = ACTIONS(4330),
    [anon_sym_SEMI] = ACTIONS(4332),
    [anon_sym_typedef] = ACTIONS(4330),
    [anon_sym_extern] = ACTIONS(4330),
    [anon_sym_LBRACE] = ACTIONS(4332),
    [anon_sym_STAR] = ACTIONS(4332),
    [anon_sym_static] = ACTIONS(4330),
    [anon_sym_auto] = ACTIONS(4330),
    [anon_sym_register] = ACTIONS(4330),
    [anon_sym_inline] = ACTIONS(4330),
    [anon_sym_const] = ACTIONS(4330),
    [anon_sym_restrict] = ACTIONS(4330),
    [anon_sym_volatile] = ACTIONS(4330),
    [anon_sym__Atomic] = ACTIONS(4330),
    [anon_sym_unsigned] = ACTIONS(4330),
    [anon_sym_long] = ACTIONS(4330),
    [anon_sym_short] = ACTIONS(4330),
    [sym_primitive_type] = ACTIONS(4330),
    [anon_sym_enum] = ACTIONS(4330),
    [anon_sym_struct] = ACTIONS(4330),
    [anon_sym_union] = ACTIONS(4330),
    [anon_sym_if] = ACTIONS(4330),
    [anon_sym_switch] = ACTIONS(4330),
    [anon_sym_case] = ACTIONS(4330),
    [anon_sym_default] = ACTIONS(4330),
    [anon_sym_while] = ACTIONS(4330),
    [anon_sym_do] = ACTIONS(4330),
    [anon_sym_for] = ACTIONS(4330),
    [anon_sym_return] = ACTIONS(4330),
    [anon_sym_break] = ACTIONS(4330),
    [anon_sym_continue] = ACTIONS(4330),
    [anon_sym_goto] = ACTIONS(4330),
    [anon_sym_AMP] = ACTIONS(4332),
    [anon_sym_BANG] = ACTIONS(4332),
    [anon_sym_TILDE] = ACTIONS(4332),
    [anon_sym_PLUS] = ACTIONS(4330),
    [anon_sym_DASH] = ACTIONS(4330),
    [anon_sym_DASH_DASH] = ACTIONS(4332),
    [anon_sym_PLUS_PLUS] = ACTIONS(4332),
    [anon_sym_sizeof] = ACTIONS(4330),
    [sym_number_literal] = ACTIONS(4332),
    [sym_char_literal] = ACTIONS(4332),
    [sym_string_literal] = ACTIONS(4332),
    [sym_true] = ACTIONS(4330),
    [sym_false] = ACTIONS(4330),
    [sym_null] = ACTIONS(4330),
    [sym_identifier] = ACTIONS(4330),
    [sym_comment] = ACTIONS(42),
  },
  [1690] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4168),
    [sym_preproc_directive] = ACTIONS(4168),
    [anon_sym_SEMI] = ACTIONS(4170),
    [anon_sym_typedef] = ACTIONS(4168),
    [anon_sym_extern] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4170),
    [anon_sym_RBRACE] = ACTIONS(4170),
    [anon_sym_STAR] = ACTIONS(4170),
    [anon_sym_static] = ACTIONS(4168),
    [anon_sym_auto] = ACTIONS(4168),
    [anon_sym_register] = ACTIONS(4168),
    [anon_sym_inline] = ACTIONS(4168),
    [anon_sym_const] = ACTIONS(4168),
    [anon_sym_restrict] = ACTIONS(4168),
    [anon_sym_volatile] = ACTIONS(4168),
    [anon_sym__Atomic] = ACTIONS(4168),
    [anon_sym_unsigned] = ACTIONS(4168),
    [anon_sym_long] = ACTIONS(4168),
    [anon_sym_short] = ACTIONS(4168),
    [sym_primitive_type] = ACTIONS(4168),
    [anon_sym_enum] = ACTIONS(4168),
    [anon_sym_struct] = ACTIONS(4168),
    [anon_sym_union] = ACTIONS(4168),
    [anon_sym_if] = ACTIONS(4168),
    [anon_sym_else] = ACTIONS(4168),
    [anon_sym_switch] = ACTIONS(4168),
    [anon_sym_case] = ACTIONS(4168),
    [anon_sym_default] = ACTIONS(4168),
    [anon_sym_while] = ACTIONS(4168),
    [anon_sym_do] = ACTIONS(4168),
    [anon_sym_for] = ACTIONS(4168),
    [anon_sym_return] = ACTIONS(4168),
    [anon_sym_break] = ACTIONS(4168),
    [anon_sym_continue] = ACTIONS(4168),
    [anon_sym_goto] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(4170),
    [anon_sym_TILDE] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4168),
    [anon_sym_DASH] = ACTIONS(4168),
    [anon_sym_DASH_DASH] = ACTIONS(4170),
    [anon_sym_PLUS_PLUS] = ACTIONS(4170),
    [anon_sym_sizeof] = ACTIONS(4168),
    [sym_number_literal] = ACTIONS(4170),
    [sym_char_literal] = ACTIONS(4170),
    [sym_string_literal] = ACTIONS(4170),
    [sym_true] = ACTIONS(4168),
    [sym_false] = ACTIONS(4168),
    [sym_null] = ACTIONS(4168),
    [sym_identifier] = ACTIONS(4168),
    [sym_comment] = ACTIONS(42),
  },
  [1691] = {
    [sym_compound_statement] = STATE(1713),
    [sym_labeled_statement] = STATE(1713),
    [sym_expression_statement] = STATE(1713),
    [sym_if_statement] = STATE(1713),
    [sym_switch_statement] = STATE(1713),
    [sym_case_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_do_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_break_statement] = STATE(1713),
    [sym_continue_statement] = STATE(1713),
    [sym_goto_statement] = STATE(1713),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3173),
    [anon_sym_switch] = ACTIONS(3175),
    [anon_sym_case] = ACTIONS(3177),
    [anon_sym_default] = ACTIONS(3179),
    [anon_sym_while] = ACTIONS(3181),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3185),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3199),
    [sym_comment] = ACTIONS(42),
  },
  [1692] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4404),
    [sym_comment] = ACTIONS(42),
  },
  [1693] = {
    [sym_compound_statement] = STATE(1690),
    [sym_labeled_statement] = STATE(1690),
    [sym_expression_statement] = STATE(1690),
    [sym_if_statement] = STATE(1690),
    [sym_switch_statement] = STATE(1690),
    [sym_case_statement] = STATE(1690),
    [sym_while_statement] = STATE(1690),
    [sym_do_statement] = STATE(1690),
    [sym_for_statement] = STATE(1690),
    [sym_return_statement] = STATE(1690),
    [sym_break_statement] = STATE(1690),
    [sym_continue_statement] = STATE(1690),
    [sym_goto_statement] = STATE(1690),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3631),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_case] = ACTIONS(3635),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3639),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3643),
    [sym_comment] = ACTIONS(42),
  },
  [1694] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4406),
    [sym_comment] = ACTIONS(42),
  },
  [1695] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1716),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4406),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1696] = {
    [sym_compound_statement] = STATE(1717),
    [sym_labeled_statement] = STATE(1717),
    [sym_expression_statement] = STATE(1717),
    [sym_if_statement] = STATE(1717),
    [sym_switch_statement] = STATE(1717),
    [sym_case_statement] = STATE(1717),
    [sym_while_statement] = STATE(1717),
    [sym_do_statement] = STATE(1717),
    [sym_for_statement] = STATE(1717),
    [sym_return_statement] = STATE(1717),
    [sym_break_statement] = STATE(1717),
    [sym_continue_statement] = STATE(1717),
    [sym_goto_statement] = STATE(1717),
    [sym__expression] = STATE(1451),
    [sym_comma_expression] = STATE(1452),
    [sym_conditional_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(1451),
    [sym_pointer_expression] = STATE(1451),
    [sym_logical_expression] = STATE(1451),
    [sym_bitwise_expression] = STATE(1451),
    [sym_equality_expression] = STATE(1451),
    [sym_relational_expression] = STATE(1451),
    [sym_shift_expression] = STATE(1451),
    [sym_math_expression] = STATE(1451),
    [sym_cast_expression] = STATE(1451),
    [sym_sizeof_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_call_expression] = STATE(1451),
    [sym_field_expression] = STATE(1451),
    [sym_compound_literal_expression] = STATE(1451),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_concatenated_string] = STATE(1451),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3900),
    [anon_sym_LBRACE] = ACTIONS(3902),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3904),
    [anon_sym_switch] = ACTIONS(3906),
    [anon_sym_case] = ACTIONS(3908),
    [anon_sym_default] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3912),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_for] = ACTIONS(3916),
    [anon_sym_return] = ACTIONS(3918),
    [anon_sym_break] = ACTIONS(3920),
    [anon_sym_continue] = ACTIONS(3922),
    [anon_sym_goto] = ACTIONS(3924),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3926),
    [sym_char_literal] = ACTIONS(3926),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3928),
    [sym_false] = ACTIONS(3928),
    [sym_null] = ACTIONS(3928),
    [sym_identifier] = ACTIONS(3930),
    [sym_comment] = ACTIONS(42),
  },
  [1697] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(813),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(815),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(815),
    [sym_preproc_directive] = ACTIONS(815),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_typedef] = ACTIONS(815),
    [anon_sym_extern] = ACTIONS(815),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_auto] = ACTIONS(815),
    [anon_sym_register] = ACTIONS(815),
    [anon_sym_inline] = ACTIONS(815),
    [anon_sym_const] = ACTIONS(815),
    [anon_sym_restrict] = ACTIONS(815),
    [anon_sym_volatile] = ACTIONS(815),
    [anon_sym__Atomic] = ACTIONS(815),
    [anon_sym_unsigned] = ACTIONS(815),
    [anon_sym_long] = ACTIONS(815),
    [anon_sym_short] = ACTIONS(815),
    [sym_primitive_type] = ACTIONS(815),
    [anon_sym_enum] = ACTIONS(815),
    [anon_sym_struct] = ACTIONS(815),
    [anon_sym_union] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(815),
    [anon_sym_else] = ACTIONS(815),
    [anon_sym_switch] = ACTIONS(815),
    [anon_sym_case] = ACTIONS(815),
    [anon_sym_default] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(815),
    [anon_sym_do] = ACTIONS(815),
    [anon_sym_for] = ACTIONS(815),
    [anon_sym_return] = ACTIONS(815),
    [anon_sym_break] = ACTIONS(815),
    [anon_sym_continue] = ACTIONS(815),
    [anon_sym_goto] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_sizeof] = ACTIONS(815),
    [sym_number_literal] = ACTIONS(813),
    [sym_char_literal] = ACTIONS(813),
    [sym_string_literal] = ACTIONS(813),
    [sym_true] = ACTIONS(815),
    [sym_false] = ACTIONS(815),
    [sym_null] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_comment] = ACTIONS(42),
  },
  [1698] = {
    [sym_parameter_list] = STATE(200),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_SEMI] = ACTIONS(4408),
    [anon_sym_LBRACK] = ACTIONS(449),
    [sym_comment] = ACTIONS(42),
  },
  [1699] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1288),
    [anon_sym_LPAREN] = ACTIONS(1286),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1288),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1288),
    [sym_preproc_directive] = ACTIONS(1288),
    [anon_sym_SEMI] = ACTIONS(1286),
    [anon_sym_typedef] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1288),
    [anon_sym_LBRACE] = ACTIONS(1286),
    [anon_sym_STAR] = ACTIONS(1286),
    [anon_sym_static] = ACTIONS(1288),
    [anon_sym_auto] = ACTIONS(1288),
    [anon_sym_register] = ACTIONS(1288),
    [anon_sym_inline] = ACTIONS(1288),
    [anon_sym_const] = ACTIONS(1288),
    [anon_sym_restrict] = ACTIONS(1288),
    [anon_sym_volatile] = ACTIONS(1288),
    [anon_sym__Atomic] = ACTIONS(1288),
    [anon_sym_unsigned] = ACTIONS(1288),
    [anon_sym_long] = ACTIONS(1288),
    [anon_sym_short] = ACTIONS(1288),
    [sym_primitive_type] = ACTIONS(1288),
    [anon_sym_enum] = ACTIONS(1288),
    [anon_sym_struct] = ACTIONS(1288),
    [anon_sym_union] = ACTIONS(1288),
    [anon_sym_if] = ACTIONS(1288),
    [anon_sym_else] = ACTIONS(1288),
    [anon_sym_switch] = ACTIONS(1288),
    [anon_sym_case] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1288),
    [anon_sym_while] = ACTIONS(1288),
    [anon_sym_do] = ACTIONS(1288),
    [anon_sym_for] = ACTIONS(1288),
    [anon_sym_return] = ACTIONS(1288),
    [anon_sym_break] = ACTIONS(1288),
    [anon_sym_continue] = ACTIONS(1288),
    [anon_sym_goto] = ACTIONS(1288),
    [anon_sym_AMP] = ACTIONS(1286),
    [anon_sym_BANG] = ACTIONS(1286),
    [anon_sym_TILDE] = ACTIONS(1286),
    [anon_sym_PLUS] = ACTIONS(1288),
    [anon_sym_DASH] = ACTIONS(1288),
    [anon_sym_DASH_DASH] = ACTIONS(1286),
    [anon_sym_PLUS_PLUS] = ACTIONS(1286),
    [anon_sym_sizeof] = ACTIONS(1288),
    [sym_number_literal] = ACTIONS(1286),
    [sym_char_literal] = ACTIONS(1286),
    [sym_string_literal] = ACTIONS(1286),
    [sym_true] = ACTIONS(1288),
    [sym_false] = ACTIONS(1288),
    [sym_null] = ACTIONS(1288),
    [sym_identifier] = ACTIONS(1288),
    [sym_comment] = ACTIONS(42),
  },
  [1700] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3868),
    [anon_sym_LPAREN] = ACTIONS(3870),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3868),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3868),
    [sym_preproc_directive] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3870),
    [anon_sym_typedef] = ACTIONS(3868),
    [anon_sym_extern] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(3870),
    [anon_sym_STAR] = ACTIONS(3870),
    [anon_sym_static] = ACTIONS(3868),
    [anon_sym_auto] = ACTIONS(3868),
    [anon_sym_register] = ACTIONS(3868),
    [anon_sym_inline] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(3868),
    [anon_sym_restrict] = ACTIONS(3868),
    [anon_sym_volatile] = ACTIONS(3868),
    [anon_sym__Atomic] = ACTIONS(3868),
    [anon_sym_unsigned] = ACTIONS(3868),
    [anon_sym_long] = ACTIONS(3868),
    [anon_sym_short] = ACTIONS(3868),
    [sym_primitive_type] = ACTIONS(3868),
    [anon_sym_enum] = ACTIONS(3868),
    [anon_sym_struct] = ACTIONS(3868),
    [anon_sym_union] = ACTIONS(3868),
    [anon_sym_if] = ACTIONS(3868),
    [anon_sym_else] = ACTIONS(3868),
    [anon_sym_switch] = ACTIONS(3868),
    [anon_sym_case] = ACTIONS(3868),
    [anon_sym_default] = ACTIONS(3868),
    [anon_sym_while] = ACTIONS(3868),
    [anon_sym_do] = ACTIONS(3868),
    [anon_sym_for] = ACTIONS(3868),
    [anon_sym_return] = ACTIONS(3868),
    [anon_sym_break] = ACTIONS(3868),
    [anon_sym_continue] = ACTIONS(3868),
    [anon_sym_goto] = ACTIONS(3868),
    [anon_sym_AMP] = ACTIONS(3870),
    [anon_sym_BANG] = ACTIONS(3870),
    [anon_sym_TILDE] = ACTIONS(3870),
    [anon_sym_PLUS] = ACTIONS(3868),
    [anon_sym_DASH] = ACTIONS(3868),
    [anon_sym_DASH_DASH] = ACTIONS(3870),
    [anon_sym_PLUS_PLUS] = ACTIONS(3870),
    [anon_sym_sizeof] = ACTIONS(3868),
    [sym_number_literal] = ACTIONS(3870),
    [sym_char_literal] = ACTIONS(3870),
    [sym_string_literal] = ACTIONS(3870),
    [sym_true] = ACTIONS(3868),
    [sym_false] = ACTIONS(3868),
    [sym_null] = ACTIONS(3868),
    [sym_identifier] = ACTIONS(3868),
    [sym_comment] = ACTIONS(42),
  },
  [1701] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(3872),
    [anon_sym_LPAREN] = ACTIONS(3874),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(3872),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(3872),
    [sym_preproc_directive] = ACTIONS(3872),
    [anon_sym_SEMI] = ACTIONS(3874),
    [anon_sym_typedef] = ACTIONS(3872),
    [anon_sym_extern] = ACTIONS(3872),
    [anon_sym_LBRACE] = ACTIONS(3874),
    [anon_sym_STAR] = ACTIONS(3874),
    [anon_sym_static] = ACTIONS(3872),
    [anon_sym_auto] = ACTIONS(3872),
    [anon_sym_register] = ACTIONS(3872),
    [anon_sym_inline] = ACTIONS(3872),
    [anon_sym_const] = ACTIONS(3872),
    [anon_sym_restrict] = ACTIONS(3872),
    [anon_sym_volatile] = ACTIONS(3872),
    [anon_sym__Atomic] = ACTIONS(3872),
    [anon_sym_unsigned] = ACTIONS(3872),
    [anon_sym_long] = ACTIONS(3872),
    [anon_sym_short] = ACTIONS(3872),
    [sym_primitive_type] = ACTIONS(3872),
    [anon_sym_enum] = ACTIONS(3872),
    [anon_sym_struct] = ACTIONS(3872),
    [anon_sym_union] = ACTIONS(3872),
    [anon_sym_if] = ACTIONS(3872),
    [anon_sym_else] = ACTIONS(3872),
    [anon_sym_switch] = ACTIONS(3872),
    [anon_sym_case] = ACTIONS(3872),
    [anon_sym_default] = ACTIONS(3872),
    [anon_sym_while] = ACTIONS(3872),
    [anon_sym_do] = ACTIONS(3872),
    [anon_sym_for] = ACTIONS(3872),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_break] = ACTIONS(3872),
    [anon_sym_continue] = ACTIONS(3872),
    [anon_sym_goto] = ACTIONS(3872),
    [anon_sym_AMP] = ACTIONS(3874),
    [anon_sym_BANG] = ACTIONS(3874),
    [anon_sym_TILDE] = ACTIONS(3874),
    [anon_sym_PLUS] = ACTIONS(3872),
    [anon_sym_DASH] = ACTIONS(3872),
    [anon_sym_DASH_DASH] = ACTIONS(3874),
    [anon_sym_PLUS_PLUS] = ACTIONS(3874),
    [anon_sym_sizeof] = ACTIONS(3872),
    [sym_number_literal] = ACTIONS(3874),
    [sym_char_literal] = ACTIONS(3874),
    [sym_string_literal] = ACTIONS(3874),
    [sym_true] = ACTIONS(3872),
    [sym_false] = ACTIONS(3872),
    [sym_null] = ACTIONS(3872),
    [sym_identifier] = ACTIONS(3872),
    [sym_comment] = ACTIONS(42),
  },
  [1702] = {
    [sym_compound_statement] = STATE(1719),
    [sym_labeled_statement] = STATE(1719),
    [sym_expression_statement] = STATE(1719),
    [sym_if_statement] = STATE(1719),
    [sym_switch_statement] = STATE(1719),
    [sym_case_statement] = STATE(1719),
    [sym_while_statement] = STATE(1719),
    [sym_do_statement] = STATE(1719),
    [sym_for_statement] = STATE(1719),
    [sym_return_statement] = STATE(1719),
    [sym_break_statement] = STATE(1719),
    [sym_continue_statement] = STATE(1719),
    [sym_goto_statement] = STATE(1719),
    [sym__expression] = STATE(1451),
    [sym_comma_expression] = STATE(1452),
    [sym_conditional_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(1451),
    [sym_pointer_expression] = STATE(1451),
    [sym_logical_expression] = STATE(1451),
    [sym_bitwise_expression] = STATE(1451),
    [sym_equality_expression] = STATE(1451),
    [sym_relational_expression] = STATE(1451),
    [sym_shift_expression] = STATE(1451),
    [sym_math_expression] = STATE(1451),
    [sym_cast_expression] = STATE(1451),
    [sym_sizeof_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_call_expression] = STATE(1451),
    [sym_field_expression] = STATE(1451),
    [sym_compound_literal_expression] = STATE(1451),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_concatenated_string] = STATE(1451),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3900),
    [anon_sym_LBRACE] = ACTIONS(3902),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3904),
    [anon_sym_switch] = ACTIONS(3906),
    [anon_sym_case] = ACTIONS(3908),
    [anon_sym_default] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3912),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_for] = ACTIONS(3916),
    [anon_sym_return] = ACTIONS(3918),
    [anon_sym_break] = ACTIONS(3920),
    [anon_sym_continue] = ACTIONS(3922),
    [anon_sym_goto] = ACTIONS(3924),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3926),
    [sym_char_literal] = ACTIONS(3926),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3928),
    [sym_false] = ACTIONS(3928),
    [sym_null] = ACTIONS(3928),
    [sym_identifier] = ACTIONS(3930),
    [sym_comment] = ACTIONS(42),
  },
  [1703] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4410),
    [sym_comment] = ACTIONS(42),
  },
  [1704] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1721),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4410),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1705] = {
    [sym__expression] = STATE(1722),
    [sym_conditional_expression] = STATE(1722),
    [sym_assignment_expression] = STATE(1722),
    [sym_pointer_expression] = STATE(1722),
    [sym_logical_expression] = STATE(1722),
    [sym_bitwise_expression] = STATE(1722),
    [sym_equality_expression] = STATE(1722),
    [sym_relational_expression] = STATE(1722),
    [sym_shift_expression] = STATE(1722),
    [sym_math_expression] = STATE(1722),
    [sym_cast_expression] = STATE(1722),
    [sym_sizeof_expression] = STATE(1722),
    [sym_subscript_expression] = STATE(1722),
    [sym_call_expression] = STATE(1722),
    [sym_field_expression] = STATE(1722),
    [sym_compound_literal_expression] = STATE(1722),
    [sym_parenthesized_expression] = STATE(1722),
    [sym_concatenated_string] = STATE(1722),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(4410),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_sizeof] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(4412),
    [sym_char_literal] = ACTIONS(4412),
    [sym_string_literal] = ACTIONS(1021),
    [sym_true] = ACTIONS(4414),
    [sym_false] = ACTIONS(4414),
    [sym_null] = ACTIONS(4414),
    [sym_identifier] = ACTIONS(4414),
    [sym_comment] = ACTIONS(42),
  },
  [1706] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4330),
    [anon_sym_LPAREN] = ACTIONS(4332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4330),
    [sym_preproc_directive] = ACTIONS(4330),
    [anon_sym_SEMI] = ACTIONS(4332),
    [anon_sym_typedef] = ACTIONS(4330),
    [anon_sym_extern] = ACTIONS(4330),
    [anon_sym_LBRACE] = ACTIONS(4332),
    [anon_sym_STAR] = ACTIONS(4332),
    [anon_sym_static] = ACTIONS(4330),
    [anon_sym_auto] = ACTIONS(4330),
    [anon_sym_register] = ACTIONS(4330),
    [anon_sym_inline] = ACTIONS(4330),
    [anon_sym_const] = ACTIONS(4330),
    [anon_sym_restrict] = ACTIONS(4330),
    [anon_sym_volatile] = ACTIONS(4330),
    [anon_sym__Atomic] = ACTIONS(4330),
    [anon_sym_unsigned] = ACTIONS(4330),
    [anon_sym_long] = ACTIONS(4330),
    [anon_sym_short] = ACTIONS(4330),
    [sym_primitive_type] = ACTIONS(4330),
    [anon_sym_enum] = ACTIONS(4330),
    [anon_sym_struct] = ACTIONS(4330),
    [anon_sym_union] = ACTIONS(4330),
    [anon_sym_if] = ACTIONS(4330),
    [anon_sym_switch] = ACTIONS(4330),
    [anon_sym_case] = ACTIONS(4330),
    [anon_sym_default] = ACTIONS(4330),
    [anon_sym_while] = ACTIONS(4330),
    [anon_sym_do] = ACTIONS(4330),
    [anon_sym_for] = ACTIONS(4330),
    [anon_sym_return] = ACTIONS(4330),
    [anon_sym_break] = ACTIONS(4330),
    [anon_sym_continue] = ACTIONS(4330),
    [anon_sym_goto] = ACTIONS(4330),
    [anon_sym_AMP] = ACTIONS(4332),
    [anon_sym_BANG] = ACTIONS(4332),
    [anon_sym_TILDE] = ACTIONS(4332),
    [anon_sym_PLUS] = ACTIONS(4330),
    [anon_sym_DASH] = ACTIONS(4330),
    [anon_sym_DASH_DASH] = ACTIONS(4332),
    [anon_sym_PLUS_PLUS] = ACTIONS(4332),
    [anon_sym_sizeof] = ACTIONS(4330),
    [sym_number_literal] = ACTIONS(4332),
    [sym_char_literal] = ACTIONS(4332),
    [sym_string_literal] = ACTIONS(4332),
    [sym_true] = ACTIONS(4330),
    [sym_false] = ACTIONS(4330),
    [sym_null] = ACTIONS(4330),
    [sym_identifier] = ACTIONS(4330),
    [sym_comment] = ACTIONS(42),
  },
  [1707] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4012),
    [anon_sym_LPAREN] = ACTIONS(4014),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4012),
    [sym_preproc_directive] = ACTIONS(4012),
    [anon_sym_SEMI] = ACTIONS(4014),
    [anon_sym_typedef] = ACTIONS(4012),
    [anon_sym_extern] = ACTIONS(4012),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_STAR] = ACTIONS(4014),
    [anon_sym_static] = ACTIONS(4012),
    [anon_sym_auto] = ACTIONS(4012),
    [anon_sym_register] = ACTIONS(4012),
    [anon_sym_inline] = ACTIONS(4012),
    [anon_sym_const] = ACTIONS(4012),
    [anon_sym_restrict] = ACTIONS(4012),
    [anon_sym_volatile] = ACTIONS(4012),
    [anon_sym__Atomic] = ACTIONS(4012),
    [anon_sym_unsigned] = ACTIONS(4012),
    [anon_sym_long] = ACTIONS(4012),
    [anon_sym_short] = ACTIONS(4012),
    [sym_primitive_type] = ACTIONS(4012),
    [anon_sym_enum] = ACTIONS(4012),
    [anon_sym_struct] = ACTIONS(4012),
    [anon_sym_union] = ACTIONS(4012),
    [anon_sym_if] = ACTIONS(4012),
    [anon_sym_else] = ACTIONS(4012),
    [anon_sym_switch] = ACTIONS(4012),
    [anon_sym_case] = ACTIONS(4012),
    [anon_sym_default] = ACTIONS(4012),
    [anon_sym_while] = ACTIONS(4012),
    [anon_sym_do] = ACTIONS(4012),
    [anon_sym_for] = ACTIONS(4012),
    [anon_sym_return] = ACTIONS(4012),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_continue] = ACTIONS(4012),
    [anon_sym_goto] = ACTIONS(4012),
    [anon_sym_AMP] = ACTIONS(4014),
    [anon_sym_BANG] = ACTIONS(4014),
    [anon_sym_TILDE] = ACTIONS(4014),
    [anon_sym_PLUS] = ACTIONS(4012),
    [anon_sym_DASH] = ACTIONS(4012),
    [anon_sym_DASH_DASH] = ACTIONS(4014),
    [anon_sym_PLUS_PLUS] = ACTIONS(4014),
    [anon_sym_sizeof] = ACTIONS(4012),
    [sym_number_literal] = ACTIONS(4014),
    [sym_char_literal] = ACTIONS(4014),
    [sym_string_literal] = ACTIONS(4014),
    [sym_true] = ACTIONS(4012),
    [sym_false] = ACTIONS(4012),
    [sym_null] = ACTIONS(4012),
    [sym_identifier] = ACTIONS(4012),
    [sym_comment] = ACTIONS(42),
  },
  [1708] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1409),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(1411),
    [sym_preproc_directive] = ACTIONS(1411),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_typedef] = ACTIONS(1411),
    [anon_sym_extern] = ACTIONS(1411),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_static] = ACTIONS(1411),
    [anon_sym_auto] = ACTIONS(1411),
    [anon_sym_register] = ACTIONS(1411),
    [anon_sym_inline] = ACTIONS(1411),
    [anon_sym_const] = ACTIONS(1411),
    [anon_sym_restrict] = ACTIONS(1411),
    [anon_sym_volatile] = ACTIONS(1411),
    [anon_sym__Atomic] = ACTIONS(1411),
    [anon_sym_unsigned] = ACTIONS(1411),
    [anon_sym_long] = ACTIONS(1411),
    [anon_sym_short] = ACTIONS(1411),
    [sym_primitive_type] = ACTIONS(1411),
    [anon_sym_enum] = ACTIONS(1411),
    [anon_sym_struct] = ACTIONS(1411),
    [anon_sym_union] = ACTIONS(1411),
    [anon_sym_if] = ACTIONS(1411),
    [anon_sym_else] = ACTIONS(1411),
    [anon_sym_switch] = ACTIONS(1411),
    [anon_sym_case] = ACTIONS(1411),
    [anon_sym_default] = ACTIONS(1411),
    [anon_sym_while] = ACTIONS(1411),
    [anon_sym_do] = ACTIONS(1411),
    [anon_sym_for] = ACTIONS(1411),
    [anon_sym_return] = ACTIONS(1411),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_continue] = ACTIONS(1411),
    [anon_sym_goto] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1411),
    [anon_sym_DASH] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1409),
    [anon_sym_sizeof] = ACTIONS(1411),
    [sym_number_literal] = ACTIONS(1409),
    [sym_char_literal] = ACTIONS(1409),
    [sym_string_literal] = ACTIONS(1409),
    [sym_true] = ACTIONS(1411),
    [sym_false] = ACTIONS(1411),
    [sym_null] = ACTIONS(1411),
    [sym_identifier] = ACTIONS(1411),
    [sym_comment] = ACTIONS(42),
  },
  [1709] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4044),
    [anon_sym_LPAREN] = ACTIONS(4046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4044),
    [sym_preproc_directive] = ACTIONS(4044),
    [anon_sym_SEMI] = ACTIONS(4046),
    [anon_sym_typedef] = ACTIONS(4044),
    [anon_sym_extern] = ACTIONS(4044),
    [anon_sym_LBRACE] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(4046),
    [anon_sym_static] = ACTIONS(4044),
    [anon_sym_auto] = ACTIONS(4044),
    [anon_sym_register] = ACTIONS(4044),
    [anon_sym_inline] = ACTIONS(4044),
    [anon_sym_const] = ACTIONS(4044),
    [anon_sym_restrict] = ACTIONS(4044),
    [anon_sym_volatile] = ACTIONS(4044),
    [anon_sym__Atomic] = ACTIONS(4044),
    [anon_sym_unsigned] = ACTIONS(4044),
    [anon_sym_long] = ACTIONS(4044),
    [anon_sym_short] = ACTIONS(4044),
    [sym_primitive_type] = ACTIONS(4044),
    [anon_sym_enum] = ACTIONS(4044),
    [anon_sym_struct] = ACTIONS(4044),
    [anon_sym_union] = ACTIONS(4044),
    [anon_sym_if] = ACTIONS(4044),
    [anon_sym_else] = ACTIONS(4044),
    [anon_sym_switch] = ACTIONS(4044),
    [anon_sym_case] = ACTIONS(4044),
    [anon_sym_default] = ACTIONS(4044),
    [anon_sym_while] = ACTIONS(4044),
    [anon_sym_do] = ACTIONS(4044),
    [anon_sym_for] = ACTIONS(4044),
    [anon_sym_return] = ACTIONS(4044),
    [anon_sym_break] = ACTIONS(4044),
    [anon_sym_continue] = ACTIONS(4044),
    [anon_sym_goto] = ACTIONS(4044),
    [anon_sym_AMP] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(4046),
    [anon_sym_TILDE] = ACTIONS(4046),
    [anon_sym_PLUS] = ACTIONS(4044),
    [anon_sym_DASH] = ACTIONS(4044),
    [anon_sym_DASH_DASH] = ACTIONS(4046),
    [anon_sym_PLUS_PLUS] = ACTIONS(4046),
    [anon_sym_sizeof] = ACTIONS(4044),
    [sym_number_literal] = ACTIONS(4046),
    [sym_char_literal] = ACTIONS(4046),
    [sym_string_literal] = ACTIONS(4046),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [sym_null] = ACTIONS(4044),
    [sym_identifier] = ACTIONS(4044),
    [sym_comment] = ACTIONS(42),
  },
  [1710] = {
    [sym_compound_statement] = STATE(1723),
    [sym_labeled_statement] = STATE(1723),
    [sym_expression_statement] = STATE(1723),
    [sym_if_statement] = STATE(1723),
    [sym_switch_statement] = STATE(1723),
    [sym_case_statement] = STATE(1723),
    [sym_while_statement] = STATE(1723),
    [sym_do_statement] = STATE(1723),
    [sym_for_statement] = STATE(1723),
    [sym_return_statement] = STATE(1723),
    [sym_break_statement] = STATE(1723),
    [sym_continue_statement] = STATE(1723),
    [sym_goto_statement] = STATE(1723),
    [sym__expression] = STATE(1385),
    [sym_comma_expression] = STATE(1386),
    [sym_conditional_expression] = STATE(1385),
    [sym_assignment_expression] = STATE(1385),
    [sym_pointer_expression] = STATE(1385),
    [sym_logical_expression] = STATE(1385),
    [sym_bitwise_expression] = STATE(1385),
    [sym_equality_expression] = STATE(1385),
    [sym_relational_expression] = STATE(1385),
    [sym_shift_expression] = STATE(1385),
    [sym_math_expression] = STATE(1385),
    [sym_cast_expression] = STATE(1385),
    [sym_sizeof_expression] = STATE(1385),
    [sym_subscript_expression] = STATE(1385),
    [sym_call_expression] = STATE(1385),
    [sym_field_expression] = STATE(1385),
    [sym_compound_literal_expression] = STATE(1385),
    [sym_parenthesized_expression] = STATE(1385),
    [sym_concatenated_string] = STATE(1385),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3754),
    [anon_sym_LBRACE] = ACTIONS(3756),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3758),
    [anon_sym_switch] = ACTIONS(3760),
    [anon_sym_case] = ACTIONS(3762),
    [anon_sym_default] = ACTIONS(3764),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3772),
    [anon_sym_break] = ACTIONS(3774),
    [anon_sym_continue] = ACTIONS(3776),
    [anon_sym_goto] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3780),
    [sym_char_literal] = ACTIONS(3780),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3782),
    [sym_false] = ACTIONS(3782),
    [sym_null] = ACTIONS(3782),
    [sym_identifier] = ACTIONS(3784),
    [sym_comment] = ACTIONS(42),
  },
  [1711] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4416),
    [sym_comment] = ACTIONS(42),
  },
  [1712] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1725),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4416),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1713] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4264),
    [anon_sym_LPAREN] = ACTIONS(4266),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4264),
    [sym_preproc_directive] = ACTIONS(4264),
    [anon_sym_SEMI] = ACTIONS(4266),
    [anon_sym_typedef] = ACTIONS(4264),
    [anon_sym_extern] = ACTIONS(4264),
    [anon_sym_LBRACE] = ACTIONS(4266),
    [anon_sym_RBRACE] = ACTIONS(4266),
    [anon_sym_STAR] = ACTIONS(4266),
    [anon_sym_static] = ACTIONS(4264),
    [anon_sym_auto] = ACTIONS(4264),
    [anon_sym_register] = ACTIONS(4264),
    [anon_sym_inline] = ACTIONS(4264),
    [anon_sym_const] = ACTIONS(4264),
    [anon_sym_restrict] = ACTIONS(4264),
    [anon_sym_volatile] = ACTIONS(4264),
    [anon_sym__Atomic] = ACTIONS(4264),
    [anon_sym_unsigned] = ACTIONS(4264),
    [anon_sym_long] = ACTIONS(4264),
    [anon_sym_short] = ACTIONS(4264),
    [sym_primitive_type] = ACTIONS(4264),
    [anon_sym_enum] = ACTIONS(4264),
    [anon_sym_struct] = ACTIONS(4264),
    [anon_sym_union] = ACTIONS(4264),
    [anon_sym_if] = ACTIONS(4264),
    [anon_sym_else] = ACTIONS(4264),
    [anon_sym_switch] = ACTIONS(4264),
    [anon_sym_case] = ACTIONS(4264),
    [anon_sym_default] = ACTIONS(4264),
    [anon_sym_while] = ACTIONS(4264),
    [anon_sym_do] = ACTIONS(4264),
    [anon_sym_for] = ACTIONS(4264),
    [anon_sym_return] = ACTIONS(4264),
    [anon_sym_break] = ACTIONS(4264),
    [anon_sym_continue] = ACTIONS(4264),
    [anon_sym_goto] = ACTIONS(4264),
    [anon_sym_AMP] = ACTIONS(4266),
    [anon_sym_BANG] = ACTIONS(4266),
    [anon_sym_TILDE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_DASH] = ACTIONS(4264),
    [anon_sym_DASH_DASH] = ACTIONS(4266),
    [anon_sym_PLUS_PLUS] = ACTIONS(4266),
    [anon_sym_sizeof] = ACTIONS(4264),
    [sym_number_literal] = ACTIONS(4266),
    [sym_char_literal] = ACTIONS(4266),
    [sym_string_literal] = ACTIONS(4266),
    [sym_true] = ACTIONS(4264),
    [sym_false] = ACTIONS(4264),
    [sym_null] = ACTIONS(4264),
    [sym_identifier] = ACTIONS(4264),
    [sym_comment] = ACTIONS(42),
  },
  [1714] = {
    [sym_compound_statement] = STATE(1726),
    [sym_labeled_statement] = STATE(1726),
    [sym_expression_statement] = STATE(1726),
    [sym_if_statement] = STATE(1726),
    [sym_switch_statement] = STATE(1726),
    [sym_case_statement] = STATE(1726),
    [sym_while_statement] = STATE(1726),
    [sym_do_statement] = STATE(1726),
    [sym_for_statement] = STATE(1726),
    [sym_return_statement] = STATE(1726),
    [sym_break_statement] = STATE(1726),
    [sym_continue_statement] = STATE(1726),
    [sym_goto_statement] = STATE(1726),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3173),
    [anon_sym_switch] = ACTIONS(3175),
    [anon_sym_case] = ACTIONS(3177),
    [anon_sym_default] = ACTIONS(3179),
    [anon_sym_while] = ACTIONS(3181),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3185),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3199),
    [sym_comment] = ACTIONS(42),
  },
  [1715] = {
    [sym_compound_statement] = STATE(1713),
    [sym_labeled_statement] = STATE(1713),
    [sym_expression_statement] = STATE(1713),
    [sym_if_statement] = STATE(1713),
    [sym_switch_statement] = STATE(1713),
    [sym_case_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_do_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_break_statement] = STATE(1713),
    [sym_continue_statement] = STATE(1713),
    [sym_goto_statement] = STATE(1713),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3631),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_case] = ACTIONS(3635),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3639),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3643),
    [sym_comment] = ACTIONS(42),
  },
  [1716] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4418),
    [sym_comment] = ACTIONS(42),
  },
  [1717] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4012),
    [anon_sym_LPAREN] = ACTIONS(4014),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4012),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4012),
    [sym_preproc_directive] = ACTIONS(4012),
    [anon_sym_SEMI] = ACTIONS(4014),
    [anon_sym_typedef] = ACTIONS(4012),
    [anon_sym_extern] = ACTIONS(4012),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_STAR] = ACTIONS(4014),
    [anon_sym_static] = ACTIONS(4012),
    [anon_sym_auto] = ACTIONS(4012),
    [anon_sym_register] = ACTIONS(4012),
    [anon_sym_inline] = ACTIONS(4012),
    [anon_sym_const] = ACTIONS(4012),
    [anon_sym_restrict] = ACTIONS(4012),
    [anon_sym_volatile] = ACTIONS(4012),
    [anon_sym__Atomic] = ACTIONS(4012),
    [anon_sym_unsigned] = ACTIONS(4012),
    [anon_sym_long] = ACTIONS(4012),
    [anon_sym_short] = ACTIONS(4012),
    [sym_primitive_type] = ACTIONS(4012),
    [anon_sym_enum] = ACTIONS(4012),
    [anon_sym_struct] = ACTIONS(4012),
    [anon_sym_union] = ACTIONS(4012),
    [anon_sym_if] = ACTIONS(4012),
    [anon_sym_else] = ACTIONS(4012),
    [anon_sym_switch] = ACTIONS(4012),
    [anon_sym_case] = ACTIONS(4012),
    [anon_sym_default] = ACTIONS(4012),
    [anon_sym_while] = ACTIONS(4012),
    [anon_sym_do] = ACTIONS(4012),
    [anon_sym_for] = ACTIONS(4012),
    [anon_sym_return] = ACTIONS(4012),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_continue] = ACTIONS(4012),
    [anon_sym_goto] = ACTIONS(4012),
    [anon_sym_AMP] = ACTIONS(4014),
    [anon_sym_BANG] = ACTIONS(4014),
    [anon_sym_TILDE] = ACTIONS(4014),
    [anon_sym_PLUS] = ACTIONS(4012),
    [anon_sym_DASH] = ACTIONS(4012),
    [anon_sym_DASH_DASH] = ACTIONS(4014),
    [anon_sym_PLUS_PLUS] = ACTIONS(4014),
    [anon_sym_sizeof] = ACTIONS(4012),
    [sym_number_literal] = ACTIONS(4014),
    [sym_char_literal] = ACTIONS(4014),
    [sym_string_literal] = ACTIONS(4014),
    [sym_true] = ACTIONS(4012),
    [sym_false] = ACTIONS(4012),
    [sym_null] = ACTIONS(4012),
    [sym_identifier] = ACTIONS(4012),
    [sym_comment] = ACTIONS(42),
  },
  [1718] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1409),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(1411),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(1411),
    [sym_preproc_directive] = ACTIONS(1411),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_typedef] = ACTIONS(1411),
    [anon_sym_extern] = ACTIONS(1411),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_static] = ACTIONS(1411),
    [anon_sym_auto] = ACTIONS(1411),
    [anon_sym_register] = ACTIONS(1411),
    [anon_sym_inline] = ACTIONS(1411),
    [anon_sym_const] = ACTIONS(1411),
    [anon_sym_restrict] = ACTIONS(1411),
    [anon_sym_volatile] = ACTIONS(1411),
    [anon_sym__Atomic] = ACTIONS(1411),
    [anon_sym_unsigned] = ACTIONS(1411),
    [anon_sym_long] = ACTIONS(1411),
    [anon_sym_short] = ACTIONS(1411),
    [sym_primitive_type] = ACTIONS(1411),
    [anon_sym_enum] = ACTIONS(1411),
    [anon_sym_struct] = ACTIONS(1411),
    [anon_sym_union] = ACTIONS(1411),
    [anon_sym_if] = ACTIONS(1411),
    [anon_sym_else] = ACTIONS(1411),
    [anon_sym_switch] = ACTIONS(1411),
    [anon_sym_case] = ACTIONS(1411),
    [anon_sym_default] = ACTIONS(1411),
    [anon_sym_while] = ACTIONS(1411),
    [anon_sym_do] = ACTIONS(1411),
    [anon_sym_for] = ACTIONS(1411),
    [anon_sym_return] = ACTIONS(1411),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_continue] = ACTIONS(1411),
    [anon_sym_goto] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1411),
    [anon_sym_DASH] = ACTIONS(1411),
    [anon_sym_DASH_DASH] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1409),
    [anon_sym_sizeof] = ACTIONS(1411),
    [sym_number_literal] = ACTIONS(1409),
    [sym_char_literal] = ACTIONS(1409),
    [sym_string_literal] = ACTIONS(1409),
    [sym_true] = ACTIONS(1411),
    [sym_false] = ACTIONS(1411),
    [sym_null] = ACTIONS(1411),
    [sym_identifier] = ACTIONS(1411),
    [sym_comment] = ACTIONS(42),
  },
  [1719] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4044),
    [anon_sym_LPAREN] = ACTIONS(4046),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4044),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4044),
    [sym_preproc_directive] = ACTIONS(4044),
    [anon_sym_SEMI] = ACTIONS(4046),
    [anon_sym_typedef] = ACTIONS(4044),
    [anon_sym_extern] = ACTIONS(4044),
    [anon_sym_LBRACE] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(4046),
    [anon_sym_static] = ACTIONS(4044),
    [anon_sym_auto] = ACTIONS(4044),
    [anon_sym_register] = ACTIONS(4044),
    [anon_sym_inline] = ACTIONS(4044),
    [anon_sym_const] = ACTIONS(4044),
    [anon_sym_restrict] = ACTIONS(4044),
    [anon_sym_volatile] = ACTIONS(4044),
    [anon_sym__Atomic] = ACTIONS(4044),
    [anon_sym_unsigned] = ACTIONS(4044),
    [anon_sym_long] = ACTIONS(4044),
    [anon_sym_short] = ACTIONS(4044),
    [sym_primitive_type] = ACTIONS(4044),
    [anon_sym_enum] = ACTIONS(4044),
    [anon_sym_struct] = ACTIONS(4044),
    [anon_sym_union] = ACTIONS(4044),
    [anon_sym_if] = ACTIONS(4044),
    [anon_sym_else] = ACTIONS(4044),
    [anon_sym_switch] = ACTIONS(4044),
    [anon_sym_case] = ACTIONS(4044),
    [anon_sym_default] = ACTIONS(4044),
    [anon_sym_while] = ACTIONS(4044),
    [anon_sym_do] = ACTIONS(4044),
    [anon_sym_for] = ACTIONS(4044),
    [anon_sym_return] = ACTIONS(4044),
    [anon_sym_break] = ACTIONS(4044),
    [anon_sym_continue] = ACTIONS(4044),
    [anon_sym_goto] = ACTIONS(4044),
    [anon_sym_AMP] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(4046),
    [anon_sym_TILDE] = ACTIONS(4046),
    [anon_sym_PLUS] = ACTIONS(4044),
    [anon_sym_DASH] = ACTIONS(4044),
    [anon_sym_DASH_DASH] = ACTIONS(4046),
    [anon_sym_PLUS_PLUS] = ACTIONS(4046),
    [anon_sym_sizeof] = ACTIONS(4044),
    [sym_number_literal] = ACTIONS(4046),
    [sym_char_literal] = ACTIONS(4046),
    [sym_string_literal] = ACTIONS(4046),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [sym_null] = ACTIONS(4044),
    [sym_identifier] = ACTIONS(4044),
    [sym_comment] = ACTIONS(42),
  },
  [1720] = {
    [sym_compound_statement] = STATE(1728),
    [sym_labeled_statement] = STATE(1728),
    [sym_expression_statement] = STATE(1728),
    [sym_if_statement] = STATE(1728),
    [sym_switch_statement] = STATE(1728),
    [sym_case_statement] = STATE(1728),
    [sym_while_statement] = STATE(1728),
    [sym_do_statement] = STATE(1728),
    [sym_for_statement] = STATE(1728),
    [sym_return_statement] = STATE(1728),
    [sym_break_statement] = STATE(1728),
    [sym_continue_statement] = STATE(1728),
    [sym_goto_statement] = STATE(1728),
    [sym__expression] = STATE(1451),
    [sym_comma_expression] = STATE(1452),
    [sym_conditional_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(1451),
    [sym_pointer_expression] = STATE(1451),
    [sym_logical_expression] = STATE(1451),
    [sym_bitwise_expression] = STATE(1451),
    [sym_equality_expression] = STATE(1451),
    [sym_relational_expression] = STATE(1451),
    [sym_shift_expression] = STATE(1451),
    [sym_math_expression] = STATE(1451),
    [sym_cast_expression] = STATE(1451),
    [sym_sizeof_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_call_expression] = STATE(1451),
    [sym_field_expression] = STATE(1451),
    [sym_compound_literal_expression] = STATE(1451),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_concatenated_string] = STATE(1451),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3900),
    [anon_sym_LBRACE] = ACTIONS(3902),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3904),
    [anon_sym_switch] = ACTIONS(3906),
    [anon_sym_case] = ACTIONS(3908),
    [anon_sym_default] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3912),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_for] = ACTIONS(3916),
    [anon_sym_return] = ACTIONS(3918),
    [anon_sym_break] = ACTIONS(3920),
    [anon_sym_continue] = ACTIONS(3922),
    [anon_sym_goto] = ACTIONS(3924),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3926),
    [sym_char_literal] = ACTIONS(3926),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3928),
    [sym_false] = ACTIONS(3928),
    [sym_null] = ACTIONS(3928),
    [sym_identifier] = ACTIONS(3930),
    [sym_comment] = ACTIONS(42),
  },
  [1721] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4420),
    [sym_comment] = ACTIONS(42),
  },
  [1722] = {
    [sym_argument_list] = STATE(503),
    [aux_sym_for_statement_repeat1] = STATE(1730),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_STAR_EQ] = ACTIONS(1613),
    [anon_sym_SLASH_EQ] = ACTIONS(1613),
    [anon_sym_PERCENT_EQ] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(1613),
    [anon_sym_DASH_EQ] = ACTIONS(1613),
    [anon_sym_LT_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP_EQ] = ACTIONS(1613),
    [anon_sym_CARET_EQ] = ACTIONS(1613),
    [anon_sym_PIPE_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1623),
    [anon_sym_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_PERCENT] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(42),
  },
  [1723] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4168),
    [sym_preproc_directive] = ACTIONS(4168),
    [anon_sym_SEMI] = ACTIONS(4170),
    [anon_sym_typedef] = ACTIONS(4168),
    [anon_sym_extern] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4170),
    [anon_sym_STAR] = ACTIONS(4170),
    [anon_sym_static] = ACTIONS(4168),
    [anon_sym_auto] = ACTIONS(4168),
    [anon_sym_register] = ACTIONS(4168),
    [anon_sym_inline] = ACTIONS(4168),
    [anon_sym_const] = ACTIONS(4168),
    [anon_sym_restrict] = ACTIONS(4168),
    [anon_sym_volatile] = ACTIONS(4168),
    [anon_sym__Atomic] = ACTIONS(4168),
    [anon_sym_unsigned] = ACTIONS(4168),
    [anon_sym_long] = ACTIONS(4168),
    [anon_sym_short] = ACTIONS(4168),
    [sym_primitive_type] = ACTIONS(4168),
    [anon_sym_enum] = ACTIONS(4168),
    [anon_sym_struct] = ACTIONS(4168),
    [anon_sym_union] = ACTIONS(4168),
    [anon_sym_if] = ACTIONS(4168),
    [anon_sym_else] = ACTIONS(4168),
    [anon_sym_switch] = ACTIONS(4168),
    [anon_sym_case] = ACTIONS(4168),
    [anon_sym_default] = ACTIONS(4168),
    [anon_sym_while] = ACTIONS(4168),
    [anon_sym_do] = ACTIONS(4168),
    [anon_sym_for] = ACTIONS(4168),
    [anon_sym_return] = ACTIONS(4168),
    [anon_sym_break] = ACTIONS(4168),
    [anon_sym_continue] = ACTIONS(4168),
    [anon_sym_goto] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(4170),
    [anon_sym_TILDE] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4168),
    [anon_sym_DASH] = ACTIONS(4168),
    [anon_sym_DASH_DASH] = ACTIONS(4170),
    [anon_sym_PLUS_PLUS] = ACTIONS(4170),
    [anon_sym_sizeof] = ACTIONS(4168),
    [sym_number_literal] = ACTIONS(4170),
    [sym_char_literal] = ACTIONS(4170),
    [sym_string_literal] = ACTIONS(4170),
    [sym_true] = ACTIONS(4168),
    [sym_false] = ACTIONS(4168),
    [sym_null] = ACTIONS(4168),
    [sym_identifier] = ACTIONS(4168),
    [sym_comment] = ACTIONS(42),
  },
  [1724] = {
    [sym_compound_statement] = STATE(1731),
    [sym_labeled_statement] = STATE(1731),
    [sym_expression_statement] = STATE(1731),
    [sym_if_statement] = STATE(1731),
    [sym_switch_statement] = STATE(1731),
    [sym_case_statement] = STATE(1731),
    [sym_while_statement] = STATE(1731),
    [sym_do_statement] = STATE(1731),
    [sym_for_statement] = STATE(1731),
    [sym_return_statement] = STATE(1731),
    [sym_break_statement] = STATE(1731),
    [sym_continue_statement] = STATE(1731),
    [sym_goto_statement] = STATE(1731),
    [sym__expression] = STATE(1385),
    [sym_comma_expression] = STATE(1386),
    [sym_conditional_expression] = STATE(1385),
    [sym_assignment_expression] = STATE(1385),
    [sym_pointer_expression] = STATE(1385),
    [sym_logical_expression] = STATE(1385),
    [sym_bitwise_expression] = STATE(1385),
    [sym_equality_expression] = STATE(1385),
    [sym_relational_expression] = STATE(1385),
    [sym_shift_expression] = STATE(1385),
    [sym_math_expression] = STATE(1385),
    [sym_cast_expression] = STATE(1385),
    [sym_sizeof_expression] = STATE(1385),
    [sym_subscript_expression] = STATE(1385),
    [sym_call_expression] = STATE(1385),
    [sym_field_expression] = STATE(1385),
    [sym_compound_literal_expression] = STATE(1385),
    [sym_parenthesized_expression] = STATE(1385),
    [sym_concatenated_string] = STATE(1385),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3754),
    [anon_sym_LBRACE] = ACTIONS(3756),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3758),
    [anon_sym_switch] = ACTIONS(3760),
    [anon_sym_case] = ACTIONS(3762),
    [anon_sym_default] = ACTIONS(3764),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3772),
    [anon_sym_break] = ACTIONS(3774),
    [anon_sym_continue] = ACTIONS(3776),
    [anon_sym_goto] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3780),
    [sym_char_literal] = ACTIONS(3780),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3782),
    [sym_false] = ACTIONS(3782),
    [sym_null] = ACTIONS(3782),
    [sym_identifier] = ACTIONS(3784),
    [sym_comment] = ACTIONS(42),
  },
  [1725] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4422),
    [sym_comment] = ACTIONS(42),
  },
  [1726] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4330),
    [anon_sym_LPAREN] = ACTIONS(4332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4330),
    [sym_preproc_directive] = ACTIONS(4330),
    [anon_sym_SEMI] = ACTIONS(4332),
    [anon_sym_typedef] = ACTIONS(4330),
    [anon_sym_extern] = ACTIONS(4330),
    [anon_sym_LBRACE] = ACTIONS(4332),
    [anon_sym_RBRACE] = ACTIONS(4332),
    [anon_sym_STAR] = ACTIONS(4332),
    [anon_sym_static] = ACTIONS(4330),
    [anon_sym_auto] = ACTIONS(4330),
    [anon_sym_register] = ACTIONS(4330),
    [anon_sym_inline] = ACTIONS(4330),
    [anon_sym_const] = ACTIONS(4330),
    [anon_sym_restrict] = ACTIONS(4330),
    [anon_sym_volatile] = ACTIONS(4330),
    [anon_sym__Atomic] = ACTIONS(4330),
    [anon_sym_unsigned] = ACTIONS(4330),
    [anon_sym_long] = ACTIONS(4330),
    [anon_sym_short] = ACTIONS(4330),
    [sym_primitive_type] = ACTIONS(4330),
    [anon_sym_enum] = ACTIONS(4330),
    [anon_sym_struct] = ACTIONS(4330),
    [anon_sym_union] = ACTIONS(4330),
    [anon_sym_if] = ACTIONS(4330),
    [anon_sym_else] = ACTIONS(4330),
    [anon_sym_switch] = ACTIONS(4330),
    [anon_sym_case] = ACTIONS(4330),
    [anon_sym_default] = ACTIONS(4330),
    [anon_sym_while] = ACTIONS(4330),
    [anon_sym_do] = ACTIONS(4330),
    [anon_sym_for] = ACTIONS(4330),
    [anon_sym_return] = ACTIONS(4330),
    [anon_sym_break] = ACTIONS(4330),
    [anon_sym_continue] = ACTIONS(4330),
    [anon_sym_goto] = ACTIONS(4330),
    [anon_sym_AMP] = ACTIONS(4332),
    [anon_sym_BANG] = ACTIONS(4332),
    [anon_sym_TILDE] = ACTIONS(4332),
    [anon_sym_PLUS] = ACTIONS(4330),
    [anon_sym_DASH] = ACTIONS(4330),
    [anon_sym_DASH_DASH] = ACTIONS(4332),
    [anon_sym_PLUS_PLUS] = ACTIONS(4332),
    [anon_sym_sizeof] = ACTIONS(4330),
    [sym_number_literal] = ACTIONS(4332),
    [sym_char_literal] = ACTIONS(4332),
    [sym_string_literal] = ACTIONS(4332),
    [sym_true] = ACTIONS(4330),
    [sym_false] = ACTIONS(4330),
    [sym_null] = ACTIONS(4330),
    [sym_identifier] = ACTIONS(4330),
    [sym_comment] = ACTIONS(42),
  },
  [1727] = {
    [sym_compound_statement] = STATE(1726),
    [sym_labeled_statement] = STATE(1726),
    [sym_expression_statement] = STATE(1726),
    [sym_if_statement] = STATE(1726),
    [sym_switch_statement] = STATE(1726),
    [sym_case_statement] = STATE(1726),
    [sym_while_statement] = STATE(1726),
    [sym_do_statement] = STATE(1726),
    [sym_for_statement] = STATE(1726),
    [sym_return_statement] = STATE(1726),
    [sym_break_statement] = STATE(1726),
    [sym_continue_statement] = STATE(1726),
    [sym_goto_statement] = STATE(1726),
    [sym__expression] = STATE(1182),
    [sym_comma_expression] = STATE(1183),
    [sym_conditional_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_pointer_expression] = STATE(1182),
    [sym_logical_expression] = STATE(1182),
    [sym_bitwise_expression] = STATE(1182),
    [sym_equality_expression] = STATE(1182),
    [sym_relational_expression] = STATE(1182),
    [sym_shift_expression] = STATE(1182),
    [sym_math_expression] = STATE(1182),
    [sym_cast_expression] = STATE(1182),
    [sym_sizeof_expression] = STATE(1182),
    [sym_subscript_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_field_expression] = STATE(1182),
    [sym_compound_literal_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_concatenated_string] = STATE(1182),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3631),
    [anon_sym_switch] = ACTIONS(3633),
    [anon_sym_case] = ACTIONS(3635),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3639),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3195),
    [sym_char_literal] = ACTIONS(3195),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_identifier] = ACTIONS(3643),
    [sym_comment] = ACTIONS(42),
  },
  [1728] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4168),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4168),
    [sym_preproc_directive] = ACTIONS(4168),
    [anon_sym_SEMI] = ACTIONS(4170),
    [anon_sym_typedef] = ACTIONS(4168),
    [anon_sym_extern] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4170),
    [anon_sym_STAR] = ACTIONS(4170),
    [anon_sym_static] = ACTIONS(4168),
    [anon_sym_auto] = ACTIONS(4168),
    [anon_sym_register] = ACTIONS(4168),
    [anon_sym_inline] = ACTIONS(4168),
    [anon_sym_const] = ACTIONS(4168),
    [anon_sym_restrict] = ACTIONS(4168),
    [anon_sym_volatile] = ACTIONS(4168),
    [anon_sym__Atomic] = ACTIONS(4168),
    [anon_sym_unsigned] = ACTIONS(4168),
    [anon_sym_long] = ACTIONS(4168),
    [anon_sym_short] = ACTIONS(4168),
    [sym_primitive_type] = ACTIONS(4168),
    [anon_sym_enum] = ACTIONS(4168),
    [anon_sym_struct] = ACTIONS(4168),
    [anon_sym_union] = ACTIONS(4168),
    [anon_sym_if] = ACTIONS(4168),
    [anon_sym_else] = ACTIONS(4168),
    [anon_sym_switch] = ACTIONS(4168),
    [anon_sym_case] = ACTIONS(4168),
    [anon_sym_default] = ACTIONS(4168),
    [anon_sym_while] = ACTIONS(4168),
    [anon_sym_do] = ACTIONS(4168),
    [anon_sym_for] = ACTIONS(4168),
    [anon_sym_return] = ACTIONS(4168),
    [anon_sym_break] = ACTIONS(4168),
    [anon_sym_continue] = ACTIONS(4168),
    [anon_sym_goto] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_BANG] = ACTIONS(4170),
    [anon_sym_TILDE] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4168),
    [anon_sym_DASH] = ACTIONS(4168),
    [anon_sym_DASH_DASH] = ACTIONS(4170),
    [anon_sym_PLUS_PLUS] = ACTIONS(4170),
    [anon_sym_sizeof] = ACTIONS(4168),
    [sym_number_literal] = ACTIONS(4170),
    [sym_char_literal] = ACTIONS(4170),
    [sym_string_literal] = ACTIONS(4170),
    [sym_true] = ACTIONS(4168),
    [sym_false] = ACTIONS(4168),
    [sym_null] = ACTIONS(4168),
    [sym_identifier] = ACTIONS(4168),
    [sym_comment] = ACTIONS(42),
  },
  [1729] = {
    [sym_compound_statement] = STATE(1733),
    [sym_labeled_statement] = STATE(1733),
    [sym_expression_statement] = STATE(1733),
    [sym_if_statement] = STATE(1733),
    [sym_switch_statement] = STATE(1733),
    [sym_case_statement] = STATE(1733),
    [sym_while_statement] = STATE(1733),
    [sym_do_statement] = STATE(1733),
    [sym_for_statement] = STATE(1733),
    [sym_return_statement] = STATE(1733),
    [sym_break_statement] = STATE(1733),
    [sym_continue_statement] = STATE(1733),
    [sym_goto_statement] = STATE(1733),
    [sym__expression] = STATE(1451),
    [sym_comma_expression] = STATE(1452),
    [sym_conditional_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(1451),
    [sym_pointer_expression] = STATE(1451),
    [sym_logical_expression] = STATE(1451),
    [sym_bitwise_expression] = STATE(1451),
    [sym_equality_expression] = STATE(1451),
    [sym_relational_expression] = STATE(1451),
    [sym_shift_expression] = STATE(1451),
    [sym_math_expression] = STATE(1451),
    [sym_cast_expression] = STATE(1451),
    [sym_sizeof_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_call_expression] = STATE(1451),
    [sym_field_expression] = STATE(1451),
    [sym_compound_literal_expression] = STATE(1451),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_concatenated_string] = STATE(1451),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3900),
    [anon_sym_LBRACE] = ACTIONS(3902),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3904),
    [anon_sym_switch] = ACTIONS(3906),
    [anon_sym_case] = ACTIONS(3908),
    [anon_sym_default] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3912),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_for] = ACTIONS(3916),
    [anon_sym_return] = ACTIONS(3918),
    [anon_sym_break] = ACTIONS(3920),
    [anon_sym_continue] = ACTIONS(3922),
    [anon_sym_goto] = ACTIONS(3924),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3926),
    [sym_char_literal] = ACTIONS(3926),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3928),
    [sym_false] = ACTIONS(3928),
    [sym_null] = ACTIONS(3928),
    [sym_identifier] = ACTIONS(3930),
    [sym_comment] = ACTIONS(42),
  },
  [1730] = {
    [aux_sym_for_statement_repeat1] = STATE(1214),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(4424),
    [sym_comment] = ACTIONS(42),
  },
  [1731] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4264),
    [anon_sym_LPAREN] = ACTIONS(4266),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4264),
    [sym_preproc_directive] = ACTIONS(4264),
    [anon_sym_SEMI] = ACTIONS(4266),
    [anon_sym_typedef] = ACTIONS(4264),
    [anon_sym_extern] = ACTIONS(4264),
    [anon_sym_LBRACE] = ACTIONS(4266),
    [anon_sym_STAR] = ACTIONS(4266),
    [anon_sym_static] = ACTIONS(4264),
    [anon_sym_auto] = ACTIONS(4264),
    [anon_sym_register] = ACTIONS(4264),
    [anon_sym_inline] = ACTIONS(4264),
    [anon_sym_const] = ACTIONS(4264),
    [anon_sym_restrict] = ACTIONS(4264),
    [anon_sym_volatile] = ACTIONS(4264),
    [anon_sym__Atomic] = ACTIONS(4264),
    [anon_sym_unsigned] = ACTIONS(4264),
    [anon_sym_long] = ACTIONS(4264),
    [anon_sym_short] = ACTIONS(4264),
    [sym_primitive_type] = ACTIONS(4264),
    [anon_sym_enum] = ACTIONS(4264),
    [anon_sym_struct] = ACTIONS(4264),
    [anon_sym_union] = ACTIONS(4264),
    [anon_sym_if] = ACTIONS(4264),
    [anon_sym_else] = ACTIONS(4264),
    [anon_sym_switch] = ACTIONS(4264),
    [anon_sym_case] = ACTIONS(4264),
    [anon_sym_default] = ACTIONS(4264),
    [anon_sym_while] = ACTIONS(4264),
    [anon_sym_do] = ACTIONS(4264),
    [anon_sym_for] = ACTIONS(4264),
    [anon_sym_return] = ACTIONS(4264),
    [anon_sym_break] = ACTIONS(4264),
    [anon_sym_continue] = ACTIONS(4264),
    [anon_sym_goto] = ACTIONS(4264),
    [anon_sym_AMP] = ACTIONS(4266),
    [anon_sym_BANG] = ACTIONS(4266),
    [anon_sym_TILDE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_DASH] = ACTIONS(4264),
    [anon_sym_DASH_DASH] = ACTIONS(4266),
    [anon_sym_PLUS_PLUS] = ACTIONS(4266),
    [anon_sym_sizeof] = ACTIONS(4264),
    [sym_number_literal] = ACTIONS(4266),
    [sym_char_literal] = ACTIONS(4266),
    [sym_string_literal] = ACTIONS(4266),
    [sym_true] = ACTIONS(4264),
    [sym_false] = ACTIONS(4264),
    [sym_null] = ACTIONS(4264),
    [sym_identifier] = ACTIONS(4264),
    [sym_comment] = ACTIONS(42),
  },
  [1732] = {
    [sym_compound_statement] = STATE(1735),
    [sym_labeled_statement] = STATE(1735),
    [sym_expression_statement] = STATE(1735),
    [sym_if_statement] = STATE(1735),
    [sym_switch_statement] = STATE(1735),
    [sym_case_statement] = STATE(1735),
    [sym_while_statement] = STATE(1735),
    [sym_do_statement] = STATE(1735),
    [sym_for_statement] = STATE(1735),
    [sym_return_statement] = STATE(1735),
    [sym_break_statement] = STATE(1735),
    [sym_continue_statement] = STATE(1735),
    [sym_goto_statement] = STATE(1735),
    [sym__expression] = STATE(1385),
    [sym_comma_expression] = STATE(1386),
    [sym_conditional_expression] = STATE(1385),
    [sym_assignment_expression] = STATE(1385),
    [sym_pointer_expression] = STATE(1385),
    [sym_logical_expression] = STATE(1385),
    [sym_bitwise_expression] = STATE(1385),
    [sym_equality_expression] = STATE(1385),
    [sym_relational_expression] = STATE(1385),
    [sym_shift_expression] = STATE(1385),
    [sym_math_expression] = STATE(1385),
    [sym_cast_expression] = STATE(1385),
    [sym_sizeof_expression] = STATE(1385),
    [sym_subscript_expression] = STATE(1385),
    [sym_call_expression] = STATE(1385),
    [sym_field_expression] = STATE(1385),
    [sym_compound_literal_expression] = STATE(1385),
    [sym_parenthesized_expression] = STATE(1385),
    [sym_concatenated_string] = STATE(1385),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3754),
    [anon_sym_LBRACE] = ACTIONS(3756),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3758),
    [anon_sym_switch] = ACTIONS(3760),
    [anon_sym_case] = ACTIONS(3762),
    [anon_sym_default] = ACTIONS(3764),
    [anon_sym_while] = ACTIONS(3766),
    [anon_sym_do] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3770),
    [anon_sym_return] = ACTIONS(3772),
    [anon_sym_break] = ACTIONS(3774),
    [anon_sym_continue] = ACTIONS(3776),
    [anon_sym_goto] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3780),
    [sym_char_literal] = ACTIONS(3780),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3782),
    [sym_false] = ACTIONS(3782),
    [sym_null] = ACTIONS(3782),
    [sym_identifier] = ACTIONS(3784),
    [sym_comment] = ACTIONS(42),
  },
  [1733] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4264),
    [anon_sym_LPAREN] = ACTIONS(4266),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4264),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4264),
    [sym_preproc_directive] = ACTIONS(4264),
    [anon_sym_SEMI] = ACTIONS(4266),
    [anon_sym_typedef] = ACTIONS(4264),
    [anon_sym_extern] = ACTIONS(4264),
    [anon_sym_LBRACE] = ACTIONS(4266),
    [anon_sym_STAR] = ACTIONS(4266),
    [anon_sym_static] = ACTIONS(4264),
    [anon_sym_auto] = ACTIONS(4264),
    [anon_sym_register] = ACTIONS(4264),
    [anon_sym_inline] = ACTIONS(4264),
    [anon_sym_const] = ACTIONS(4264),
    [anon_sym_restrict] = ACTIONS(4264),
    [anon_sym_volatile] = ACTIONS(4264),
    [anon_sym__Atomic] = ACTIONS(4264),
    [anon_sym_unsigned] = ACTIONS(4264),
    [anon_sym_long] = ACTIONS(4264),
    [anon_sym_short] = ACTIONS(4264),
    [sym_primitive_type] = ACTIONS(4264),
    [anon_sym_enum] = ACTIONS(4264),
    [anon_sym_struct] = ACTIONS(4264),
    [anon_sym_union] = ACTIONS(4264),
    [anon_sym_if] = ACTIONS(4264),
    [anon_sym_else] = ACTIONS(4264),
    [anon_sym_switch] = ACTIONS(4264),
    [anon_sym_case] = ACTIONS(4264),
    [anon_sym_default] = ACTIONS(4264),
    [anon_sym_while] = ACTIONS(4264),
    [anon_sym_do] = ACTIONS(4264),
    [anon_sym_for] = ACTIONS(4264),
    [anon_sym_return] = ACTIONS(4264),
    [anon_sym_break] = ACTIONS(4264),
    [anon_sym_continue] = ACTIONS(4264),
    [anon_sym_goto] = ACTIONS(4264),
    [anon_sym_AMP] = ACTIONS(4266),
    [anon_sym_BANG] = ACTIONS(4266),
    [anon_sym_TILDE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_DASH] = ACTIONS(4264),
    [anon_sym_DASH_DASH] = ACTIONS(4266),
    [anon_sym_PLUS_PLUS] = ACTIONS(4266),
    [anon_sym_sizeof] = ACTIONS(4264),
    [sym_number_literal] = ACTIONS(4266),
    [sym_char_literal] = ACTIONS(4266),
    [sym_string_literal] = ACTIONS(4266),
    [sym_true] = ACTIONS(4264),
    [sym_false] = ACTIONS(4264),
    [sym_null] = ACTIONS(4264),
    [sym_identifier] = ACTIONS(4264),
    [sym_comment] = ACTIONS(42),
  },
  [1734] = {
    [sym_compound_statement] = STATE(1736),
    [sym_labeled_statement] = STATE(1736),
    [sym_expression_statement] = STATE(1736),
    [sym_if_statement] = STATE(1736),
    [sym_switch_statement] = STATE(1736),
    [sym_case_statement] = STATE(1736),
    [sym_while_statement] = STATE(1736),
    [sym_do_statement] = STATE(1736),
    [sym_for_statement] = STATE(1736),
    [sym_return_statement] = STATE(1736),
    [sym_break_statement] = STATE(1736),
    [sym_continue_statement] = STATE(1736),
    [sym_goto_statement] = STATE(1736),
    [sym__expression] = STATE(1451),
    [sym_comma_expression] = STATE(1452),
    [sym_conditional_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(1451),
    [sym_pointer_expression] = STATE(1451),
    [sym_logical_expression] = STATE(1451),
    [sym_bitwise_expression] = STATE(1451),
    [sym_equality_expression] = STATE(1451),
    [sym_relational_expression] = STATE(1451),
    [sym_shift_expression] = STATE(1451),
    [sym_math_expression] = STATE(1451),
    [sym_cast_expression] = STATE(1451),
    [sym_sizeof_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_call_expression] = STATE(1451),
    [sym_field_expression] = STATE(1451),
    [sym_compound_literal_expression] = STATE(1451),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_concatenated_string] = STATE(1451),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(3900),
    [anon_sym_LBRACE] = ACTIONS(3902),
    [anon_sym_STAR] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(3904),
    [anon_sym_switch] = ACTIONS(3906),
    [anon_sym_case] = ACTIONS(3908),
    [anon_sym_default] = ACTIONS(3910),
    [anon_sym_while] = ACTIONS(3912),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_for] = ACTIONS(3916),
    [anon_sym_return] = ACTIONS(3918),
    [anon_sym_break] = ACTIONS(3920),
    [anon_sym_continue] = ACTIONS(3922),
    [anon_sym_goto] = ACTIONS(3924),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_sizeof] = ACTIONS(623),
    [sym_number_literal] = ACTIONS(3926),
    [sym_char_literal] = ACTIONS(3926),
    [sym_string_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(3928),
    [sym_false] = ACTIONS(3928),
    [sym_null] = ACTIONS(3928),
    [sym_identifier] = ACTIONS(3930),
    [sym_comment] = ACTIONS(42),
  },
  [1735] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4330),
    [anon_sym_LPAREN] = ACTIONS(4332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelse_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARelif_SLASH] = ACTIONS(4330),
    [sym_preproc_directive] = ACTIONS(4330),
    [anon_sym_SEMI] = ACTIONS(4332),
    [anon_sym_typedef] = ACTIONS(4330),
    [anon_sym_extern] = ACTIONS(4330),
    [anon_sym_LBRACE] = ACTIONS(4332),
    [anon_sym_STAR] = ACTIONS(4332),
    [anon_sym_static] = ACTIONS(4330),
    [anon_sym_auto] = ACTIONS(4330),
    [anon_sym_register] = ACTIONS(4330),
    [anon_sym_inline] = ACTIONS(4330),
    [anon_sym_const] = ACTIONS(4330),
    [anon_sym_restrict] = ACTIONS(4330),
    [anon_sym_volatile] = ACTIONS(4330),
    [anon_sym__Atomic] = ACTIONS(4330),
    [anon_sym_unsigned] = ACTIONS(4330),
    [anon_sym_long] = ACTIONS(4330),
    [anon_sym_short] = ACTIONS(4330),
    [sym_primitive_type] = ACTIONS(4330),
    [anon_sym_enum] = ACTIONS(4330),
    [anon_sym_struct] = ACTIONS(4330),
    [anon_sym_union] = ACTIONS(4330),
    [anon_sym_if] = ACTIONS(4330),
    [anon_sym_else] = ACTIONS(4330),
    [anon_sym_switch] = ACTIONS(4330),
    [anon_sym_case] = ACTIONS(4330),
    [anon_sym_default] = ACTIONS(4330),
    [anon_sym_while] = ACTIONS(4330),
    [anon_sym_do] = ACTIONS(4330),
    [anon_sym_for] = ACTIONS(4330),
    [anon_sym_return] = ACTIONS(4330),
    [anon_sym_break] = ACTIONS(4330),
    [anon_sym_continue] = ACTIONS(4330),
    [anon_sym_goto] = ACTIONS(4330),
    [anon_sym_AMP] = ACTIONS(4332),
    [anon_sym_BANG] = ACTIONS(4332),
    [anon_sym_TILDE] = ACTIONS(4332),
    [anon_sym_PLUS] = ACTIONS(4330),
    [anon_sym_DASH] = ACTIONS(4330),
    [anon_sym_DASH_DASH] = ACTIONS(4332),
    [anon_sym_PLUS_PLUS] = ACTIONS(4332),
    [anon_sym_sizeof] = ACTIONS(4330),
    [sym_number_literal] = ACTIONS(4332),
    [sym_char_literal] = ACTIONS(4332),
    [sym_string_literal] = ACTIONS(4332),
    [sym_true] = ACTIONS(4330),
    [sym_false] = ACTIONS(4330),
    [sym_null] = ACTIONS(4330),
    [sym_identifier] = ACTIONS(4330),
    [sym_comment] = ACTIONS(42),
  },
  [1736] = {
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARinclude_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARdefine_SLASH] = ACTIONS(4330),
    [anon_sym_LPAREN] = ACTIONS(4332),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARif_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARendif_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifdef_SLASH] = ACTIONS(4330),
    [aux_sym_SLASH_POUND_LBRACK_TAB_RBRACK_STARifndef_SLASH] = ACTIONS(4330),
    [sym_preproc_directive] = ACTIONS(4330),
    [anon_sym_SEMI] = ACTIONS(4332),
    [anon_sym_typedef] = ACTIONS(4330),
    [anon_sym_extern] = ACTIONS(4330),
    [anon_sym_LBRACE] = ACTIONS(4332),
    [anon_sym_STAR] = ACTIONS(4332),
    [anon_sym_static] = ACTIONS(4330),
    [anon_sym_auto] = ACTIONS(4330),
    [anon_sym_register] = ACTIONS(4330),
    [anon_sym_inline] = ACTIONS(4330),
    [anon_sym_const] = ACTIONS(4330),
    [anon_sym_restrict] = ACTIONS(4330),
    [anon_sym_volatile] = ACTIONS(4330),
    [anon_sym__Atomic] = ACTIONS(4330),
    [anon_sym_unsigned] = ACTIONS(4330),
    [anon_sym_long] = ACTIONS(4330),
    [anon_sym_short] = ACTIONS(4330),
    [sym_primitive_type] = ACTIONS(4330),
    [anon_sym_enum] = ACTIONS(4330),
    [anon_sym_struct] = ACTIONS(4330),
    [anon_sym_union] = ACTIONS(4330),
    [anon_sym_if] = ACTIONS(4330),
    [anon_sym_else] = ACTIONS(4330),
    [anon_sym_switch] = ACTIONS(4330),
    [anon_sym_case] = ACTIONS(4330),
    [anon_sym_default] = ACTIONS(4330),
    [anon_sym_while] = ACTIONS(4330),
    [anon_sym_do] = ACTIONS(4330),
    [anon_sym_for] = ACTIONS(4330),
    [anon_sym_return] = ACTIONS(4330),
    [anon_sym_break] = ACTIONS(4330),
    [anon_sym_continue] = ACTIONS(4330),
    [anon_sym_goto] = ACTIONS(4330),
    [anon_sym_AMP] = ACTIONS(4332),
    [anon_sym_BANG] = ACTIONS(4332),
    [anon_sym_TILDE] = ACTIONS(4332),
    [anon_sym_PLUS] = ACTIONS(4330),
    [anon_sym_DASH] = ACTIONS(4330),
    [anon_sym_DASH_DASH] = ACTIONS(4332),
    [anon_sym_PLUS_PLUS] = ACTIONS(4332),
    [anon_sym_sizeof] = ACTIONS(4330),
    [sym_number_literal] = ACTIONS(4332),
    [sym_char_literal] = ACTIONS(4332),
    [sym_string_literal] = ACTIONS(4332),
    [sym_true] = ACTIONS(4330),
    [sym_false] = ACTIONS(4330),
    [sym_null] = ACTIONS(4330),
    [sym_identifier] = ACTIONS(4330),
    [sym_comment] = ACTIONS(42),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = true}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, RECOVER(),
  [5] = {.count = 2, .reusable = true}, SHIFT_EXTRA(), RECOVER(),
  [8] = {.count = 1, .reusable = true}, REDUCE(sym_translation_unit, 0),
  [10] = {.count = 1, .reusable = false}, SHIFT(2),
  [12] = {.count = 1, .reusable = false}, SHIFT(3),
  [14] = {.count = 1, .reusable = false}, SHIFT(4),
  [16] = {.count = 1, .reusable = false}, SHIFT(5),
  [18] = {.count = 1, .reusable = false}, SHIFT(6),
  [20] = {.count = 1, .reusable = false}, SHIFT(7),
  [22] = {.count = 1, .reusable = false}, SHIFT(8),
  [24] = {.count = 1, .reusable = false}, SHIFT(9),
  [26] = {.count = 1, .reusable = false}, SHIFT(10),
  [28] = {.count = 1, .reusable = false}, SHIFT(11),
  [30] = {.count = 1, .reusable = false}, SHIFT(21),
  [32] = {.count = 1, .reusable = false}, SHIFT(18),
  [34] = {.count = 1, .reusable = false}, SHIFT(12),
  [36] = {.count = 1, .reusable = false}, SHIFT(13),
  [38] = {.count = 1, .reusable = false}, SHIFT(14),
  [40] = {.count = 1, .reusable = false}, SHIFT(15),
  [42] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [44] = {.count = 1, .reusable = true}, SHIFT(22),
  [46] = {.count = 1, .reusable = true}, SHIFT(23),
  [48] = {.count = 1, .reusable = false}, SHIFT(24),
  [50] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [52] = {.count = 1, .reusable = true}, SHIFT(25),
  [54] = {.count = 1, .reusable = true}, SHIFT(26),
  [56] = {.count = 1, .reusable = false}, SHIFT(27),
  [58] = {.count = 1, .reusable = false}, SHIFT(28),
  [60] = {.count = 1, .reusable = false}, SHIFT(29),
  [62] = {.count = 1, .reusable = false}, SHIFT(36),
  [64] = {.count = 1, .reusable = false}, SHIFT(34),
  [66] = {.count = 1, .reusable = false}, SHIFT(30),
  [68] = {.count = 1, .reusable = false}, SHIFT(31),
  [70] = {.count = 1, .reusable = false}, SHIFT(32),
  [72] = {.count = 1, .reusable = false}, SHIFT(33),
  [74] = {.count = 1, .reusable = false}, REDUCE(sym_storage_class_specifier, 1),
  [76] = {.count = 1, .reusable = true}, SHIFT(37),
  [78] = {.count = 1, .reusable = false}, REDUCE(sym_type_qualifier, 1),
  [80] = {.count = 1, .reusable = true}, SHIFT(38),
  [82] = {.count = 1, .reusable = true}, SHIFT(39),
  [84] = {.count = 1, .reusable = true}, SHIFT(41),
  [86] = {.count = 1, .reusable = true}, SHIFT(42),
  [88] = {.count = 1, .reusable = true}, SHIFT(44),
  [90] = {.count = 2, .reusable = true}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1), SHIFT(46),
  [93] = {.count = 1, .reusable = true}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1),
  [95] = {.count = 1, .reusable = false}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1),
  [97] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [99] = {.count = 1, .reusable = true}, SHIFT(47),
  [101] = {.count = 1, .reusable = true}, SHIFT(48),
  [103] = {.count = 1, .reusable = true}, SHIFT(49),
  [105] = {.count = 1, .reusable = true}, SHIFT(50),
  [107] = {.count = 1, .reusable = true}, REDUCE(sym__declaration_specifiers, 1),
  [109] = {.count = 1, .reusable = false}, SHIFT(52),
  [111] = {.count = 1, .reusable = false}, SHIFT(53),
  [113] = {.count = 1, .reusable = false}, REDUCE(sym__declaration_specifiers, 1),
  [115] = {.count = 1, .reusable = true}, REDUCE(sym_translation_unit, 1),
  [117] = {.count = 1, .reusable = false}, SHIFT(56),
  [119] = {.count = 1, .reusable = true}, REDUCE(sym_sized_type_specifier, 1),
  [121] = {.count = 1, .reusable = false}, REDUCE(sym_sized_type_specifier, 1),
  [123] = {.count = 1, .reusable = false}, SHIFT(60),
  [125] = {.count = 1, .reusable = false}, SHIFT(58),
  [127] = {.count = 2, .reusable = false}, REDUCE(sym_sized_type_specifier, 1), SHIFT(59),
  [130] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_include, 2, .alias_sequence_id = 2),
  [132] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_include, 2, .alias_sequence_id = 2),
  [134] = {.count = 1, .reusable = false}, SHIFT(61),
  [136] = {.count = 1, .reusable = false}, SHIFT(62),
  [138] = {.count = 1, .reusable = false}, SHIFT(63),
  [140] = {.count = 1, .reusable = false}, SHIFT(65),
  [142] = {.count = 1, .reusable = false}, SHIFT(66),
  [144] = {.count = 1, .reusable = false}, SHIFT(67),
  [146] = {.count = 1, .reusable = false}, SHIFT(68),
  [148] = {.count = 1, .reusable = false}, SHIFT(69),
  [150] = {.count = 1, .reusable = false}, SHIFT(70),
  [152] = {.count = 1, .reusable = false}, SHIFT(71),
  [154] = {.count = 1, .reusable = false}, SHIFT(72),
  [156] = {.count = 1, .reusable = false}, SHIFT(73),
  [158] = {.count = 1, .reusable = false}, SHIFT(74),
  [160] = {.count = 1, .reusable = false}, SHIFT(75),
  [162] = {.count = 1, .reusable = false}, SHIFT(79),
  [164] = {.count = 1, .reusable = false}, SHIFT(82),
  [166] = {.count = 1, .reusable = false}, SHIFT(85),
  [168] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_call, 2),
  [170] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_call, 2),
  [172] = {.count = 1, .reusable = true}, SHIFT(86),
  [174] = {.count = 1, .reusable = true}, SHIFT(87),
  [176] = {.count = 1, .reusable = true}, SHIFT(89),
  [178] = {.count = 1, .reusable = true}, SHIFT(90),
  [180] = {.count = 1, .reusable = true}, SHIFT(92),
  [182] = {.count = 2, .reusable = true}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1), SHIFT(94),
  [185] = {.count = 1, .reusable = true}, SHIFT(95),
  [187] = {.count = 1, .reusable = true}, SHIFT(96),
  [189] = {.count = 1, .reusable = true}, SHIFT(97),
  [191] = {.count = 1, .reusable = false}, SHIFT(102),
  [193] = {.count = 1, .reusable = false}, SHIFT(106),
  [195] = {.count = 1, .reusable = false}, SHIFT(104),
  [197] = {.count = 2, .reusable = false}, REDUCE(sym_sized_type_specifier, 1), SHIFT(105),
  [200] = {.count = 1, .reusable = true}, SHIFT(107),
  [202] = {.count = 1, .reusable = false}, SHIFT(112),
  [204] = {.count = 1, .reusable = false}, SHIFT(110),
  [206] = {.count = 1, .reusable = true}, SHIFT(113),
  [208] = {.count = 1, .reusable = true}, SHIFT(114),
  [210] = {.count = 1, .reusable = true}, SHIFT(115),
  [212] = {.count = 1, .reusable = true}, REDUCE(sym_enum_specifier, 2, .alias_sequence_id = 3),
  [214] = {.count = 1, .reusable = false}, REDUCE(sym_enum_specifier, 2, .alias_sequence_id = 3),
  [216] = {.count = 1, .reusable = true}, REDUCE(sym_enum_specifier, 2),
  [218] = {.count = 1, .reusable = false}, REDUCE(sym_enum_specifier, 2),
  [220] = {.count = 1, .reusable = false}, SHIFT(118),
  [222] = {.count = 1, .reusable = true}, SHIFT(119),
  [224] = {.count = 1, .reusable = true}, SHIFT(120),
  [226] = {.count = 1, .reusable = true}, SHIFT(121),
  [228] = {.count = 1, .reusable = false}, SHIFT(127),
  [230] = {.count = 1, .reusable = false}, SHIFT(125),
  [232] = {.count = 1, .reusable = true}, REDUCE(sym_struct_specifier, 2, .alias_sequence_id = 3),
  [234] = {.count = 1, .reusable = false}, REDUCE(sym_struct_specifier, 2, .alias_sequence_id = 3),
  [236] = {.count = 1, .reusable = true}, REDUCE(sym_struct_specifier, 2),
  [238] = {.count = 1, .reusable = false}, REDUCE(sym_struct_specifier, 2),
  [240] = {.count = 1, .reusable = true}, REDUCE(sym_union_specifier, 2, .alias_sequence_id = 3),
  [242] = {.count = 1, .reusable = false}, REDUCE(sym_union_specifier, 2, .alias_sequence_id = 3),
  [244] = {.count = 1, .reusable = true}, REDUCE(sym_union_specifier, 2),
  [246] = {.count = 1, .reusable = false}, REDUCE(sym_union_specifier, 2),
  [248] = {.count = 1, .reusable = false}, SHIFT(134),
  [250] = {.count = 1, .reusable = false}, SHIFT(131),
  [252] = {.count = 1, .reusable = true}, SHIFT(135),
  [254] = {.count = 1, .reusable = true}, SHIFT(136),
  [256] = {.count = 1, .reusable = true}, REDUCE(sym__empty_declaration, 2),
  [258] = {.count = 1, .reusable = false}, REDUCE(sym__empty_declaration, 2),
  [260] = {.count = 1, .reusable = true}, SHIFT(137),
  [262] = {.count = 1, .reusable = true}, SHIFT(138),
  [264] = {.count = 1, .reusable = true}, SHIFT(139),
  [266] = {.count = 1, .reusable = true}, SHIFT(140),
  [268] = {.count = 1, .reusable = true}, SHIFT(141),
  [270] = {.count = 1, .reusable = true}, SHIFT(142),
  [272] = {.count = 1, .reusable = true}, SHIFT(143),
  [274] = {.count = 1, .reusable = true}, REDUCE(sym_storage_class_specifier, 1),
  [276] = {.count = 1, .reusable = true}, REDUCE(sym_type_qualifier, 1),
  [278] = {.count = 1, .reusable = true}, REDUCE(sym__declaration_specifiers, 2),
  [280] = {.count = 1, .reusable = false}, REDUCE(sym__declaration_specifiers, 2),
  [282] = {.count = 1, .reusable = true}, REDUCE(aux_sym_translation_unit_repeat1, 2),
  [284] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2),
  [287] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(3),
  [290] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(4),
  [293] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(5),
  [296] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(6),
  [299] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(7),
  [302] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(8),
  [305] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(9),
  [308] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(10),
  [311] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(11),
  [314] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(21),
  [317] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(18),
  [320] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(12),
  [323] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(13),
  [326] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(14),
  [329] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(15),
  [332] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(10),
  [335] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(11),
  [338] = {.count = 1, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2),
  [340] = {.count = 1, .reusable = true}, REDUCE(sym_sized_type_specifier, 2),
  [342] = {.count = 1, .reusable = false}, REDUCE(sym_sized_type_specifier, 2),
  [344] = {.count = 1, .reusable = true}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .alias_sequence_id = 3),
  [346] = {.count = 1, .reusable = false}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .alias_sequence_id = 3),
  [348] = {.count = 1, .reusable = true}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [350] = {.count = 1, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [352] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(60),
  [355] = {.count = 1, .reusable = false}, SHIFT(149),
  [357] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_def, 3, .alias_sequence_id = 4),
  [359] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_def, 3, .alias_sequence_id = 4),
  [361] = {.count = 1, .reusable = true}, SHIFT(150),
  [363] = {.count = 1, .reusable = true}, SHIFT(151),
  [365] = {.count = 1, .reusable = false}, SHIFT(152),
  [367] = {.count = 1, .reusable = false}, SHIFT(153),
  [369] = {.count = 1, .reusable = true}, SHIFT(154),
  [371] = {.count = 1, .reusable = true}, SHIFT(155),
  [373] = {.count = 1, .reusable = false}, SHIFT(156),
  [375] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if, 3, .alias_sequence_id = 5),
  [377] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if, 3, .alias_sequence_id = 5),
  [379] = {.count = 1, .reusable = true}, SHIFT(157),
  [381] = {.count = 1, .reusable = true}, SHIFT(158),
  [383] = {.count = 1, .reusable = false}, SHIFT(159),
  [385] = {.count = 1, .reusable = false}, SHIFT(160),
  [387] = {.count = 1, .reusable = false}, SHIFT(161),
  [389] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_else, 1, .alias_sequence_id = 6),
  [391] = {.count = 1, .reusable = false}, SHIFT(162),
  [393] = {.count = 1, .reusable = false}, SHIFT(163),
  [395] = {.count = 1, .reusable = false}, SHIFT(164),
  [397] = {.count = 1, .reusable = false}, SHIFT(165),
  [399] = {.count = 1, .reusable = false}, SHIFT(166),
  [401] = {.count = 1, .reusable = false}, SHIFT(169),
  [403] = {.count = 1, .reusable = false}, SHIFT(170),
  [405] = {.count = 1, .reusable = false}, SHIFT(171),
  [407] = {.count = 1, .reusable = false}, SHIFT(172),
  [409] = {.count = 1, .reusable = true}, SHIFT(174),
  [411] = {.count = 1, .reusable = true}, SHIFT(175),
  [413] = {.count = 1, .reusable = true}, SHIFT(176),
  [415] = {.count = 1, .reusable = true}, SHIFT(177),
  [417] = {.count = 1, .reusable = false}, SHIFT(175),
  [419] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 3, .alias_sequence_id = 7),
  [421] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 3, .alias_sequence_id = 7),
  [423] = {.count = 1, .reusable = true}, SHIFT(181),
  [425] = {.count = 1, .reusable = false}, SHIFT(181),
  [427] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 3, .alias_sequence_id = 8),
  [429] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 3, .alias_sequence_id = 8),
  [431] = {.count = 1, .reusable = true}, SHIFT(183),
  [433] = {.count = 1, .reusable = false}, SHIFT(183),
  [435] = {.count = 1, .reusable = true}, SHIFT(185),
  [437] = {.count = 1, .reusable = true}, SHIFT(186),
  [439] = {.count = 1, .reusable = true}, SHIFT(187),
  [441] = {.count = 1, .reusable = true}, SHIFT(190),
  [443] = {.count = 1, .reusable = true}, SHIFT(195),
  [445] = {.count = 1, .reusable = true}, REDUCE(sym__type_declarator, 1, .alias_sequence_id = 1),
  [447] = {.count = 1, .reusable = true}, SHIFT(198),
  [449] = {.count = 1, .reusable = true}, SHIFT(199),
  [451] = {.count = 1, .reusable = true}, REDUCE(sym__type_declarator, 1, .alias_sequence_id = 9),
  [453] = {.count = 1, .reusable = true}, REDUCE(sym__type_declarator, 1, .alias_sequence_id = 10),
  [455] = {.count = 1, .reusable = true}, REDUCE(sym__type_declarator, 1, .alias_sequence_id = 11),
  [457] = {.count = 2, .reusable = false}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(29),
  [460] = {.count = 1, .reusable = false}, REDUCE(aux_sym_type_definition_repeat1, 2),
  [462] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(106),
  [465] = {.count = 1, .reusable = true}, SHIFT(202),
  [467] = {.count = 1, .reusable = true}, REDUCE(sym_linkage_specification, 3),
  [469] = {.count = 1, .reusable = false}, REDUCE(sym_linkage_specification, 3),
  [471] = {.count = 1, .reusable = false}, SHIFT(205),
  [473] = {.count = 1, .reusable = false}, SHIFT(206),
  [475] = {.count = 1, .reusable = true}, SHIFT(207),
  [477] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator_list, 2),
  [479] = {.count = 1, .reusable = false}, REDUCE(sym_enumerator_list, 2),
  [481] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator, 1),
  [483] = {.count = 1, .reusable = true}, SHIFT(208),
  [485] = {.count = 1, .reusable = true}, SHIFT(209),
  [487] = {.count = 1, .reusable = true}, REDUCE(sym_enum_specifier, 3, .alias_sequence_id = 3),
  [489] = {.count = 1, .reusable = false}, REDUCE(sym_enum_specifier, 3, .alias_sequence_id = 3),
  [491] = {.count = 1, .reusable = false}, SHIFT(211),
  [493] = {.count = 1, .reusable = true}, SHIFT(212),
  [495] = {.count = 1, .reusable = true}, SHIFT(213),
  [497] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration_list, 2),
  [499] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration_list, 2),
  [501] = {.count = 1, .reusable = false}, REDUCE(aux_sym_field_declaration_list_repeat1, 1, .alias_sequence_id = 12),
  [503] = {.count = 1, .reusable = true}, REDUCE(aux_sym_field_declaration_list_repeat1, 1, .alias_sequence_id = 12),
  [505] = {.count = 1, .reusable = false}, REDUCE(aux_sym_field_declaration_list_repeat1, 1, .alias_sequence_id = 13),
  [507] = {.count = 1, .reusable = true}, REDUCE(aux_sym_field_declaration_list_repeat1, 1, .alias_sequence_id = 13),
  [509] = {.count = 1, .reusable = true}, SHIFT(214),
  [511] = {.count = 1, .reusable = true}, SHIFT(215),
  [513] = {.count = 1, .reusable = true}, SHIFT(216),
  [515] = {.count = 1, .reusable = true}, SHIFT(217),
  [517] = {.count = 1, .reusable = true}, SHIFT(218),
  [519] = {.count = 1, .reusable = false}, SHIFT(224),
  [521] = {.count = 1, .reusable = false}, SHIFT(225),
  [523] = {.count = 1, .reusable = true}, SHIFT(226),
  [525] = {.count = 1, .reusable = true}, REDUCE(sym_struct_specifier, 3, .alias_sequence_id = 3),
  [527] = {.count = 1, .reusable = false}, REDUCE(sym_struct_specifier, 3, .alias_sequence_id = 3),
  [529] = {.count = 1, .reusable = true}, REDUCE(sym_union_specifier, 3, .alias_sequence_id = 3),
  [531] = {.count = 1, .reusable = false}, REDUCE(sym_union_specifier, 3, .alias_sequence_id = 3),
  [533] = {.count = 1, .reusable = true}, SHIFT(228),
  [535] = {.count = 1, .reusable = true}, REDUCE(sym_type_descriptor, 1),
  [537] = {.count = 1, .reusable = true}, SHIFT(229),
  [539] = {.count = 1, .reusable = true}, SHIFT(230),
  [541] = {.count = 1, .reusable = true}, SHIFT(233),
  [543] = {.count = 1, .reusable = false}, SHIFT(234),
  [545] = {.count = 1, .reusable = false}, SHIFT(235),
  [547] = {.count = 1, .reusable = false}, SHIFT(59),
  [549] = {.count = 1, .reusable = true}, SHIFT(236),
  [551] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_declarator, 2),
  [553] = {.count = 1, .reusable = true}, SHIFT(237),
  [555] = {.count = 1, .reusable = true}, SHIFT(238),
  [557] = {.count = 1, .reusable = false}, SHIFT(242),
  [559] = {.count = 1, .reusable = false}, SHIFT(240),
  [561] = {.count = 1, .reusable = true}, SHIFT(243),
  [563] = {.count = 1, .reusable = true}, SHIFT(244),
  [565] = {.count = 1, .reusable = true}, REDUCE(sym_declaration, 3),
  [567] = {.count = 1, .reusable = false}, REDUCE(sym_declaration, 3),
  [569] = {.count = 1, .reusable = false}, SHIFT(246),
  [571] = {.count = 1, .reusable = false}, SHIFT(247),
  [573] = {.count = 1, .reusable = true}, SHIFT(248),
  [575] = {.count = 1, .reusable = false}, SHIFT(249),
  [577] = {.count = 1, .reusable = false}, SHIFT(250),
  [579] = {.count = 1, .reusable = false}, SHIFT(251),
  [581] = {.count = 1, .reusable = false}, SHIFT(252),
  [583] = {.count = 1, .reusable = true}, SHIFT(253),
  [585] = {.count = 1, .reusable = false}, SHIFT(254),
  [587] = {.count = 1, .reusable = true}, SHIFT(255),
  [589] = {.count = 1, .reusable = true}, SHIFT(256),
  [591] = {.count = 1, .reusable = true}, SHIFT(257),
  [593] = {.count = 1, .reusable = false}, SHIFT(258),
  [595] = {.count = 1, .reusable = false}, SHIFT(259),
  [597] = {.count = 1, .reusable = false}, SHIFT(260),
  [599] = {.count = 1, .reusable = false}, SHIFT(261),
  [601] = {.count = 1, .reusable = false}, SHIFT(262),
  [603] = {.count = 1, .reusable = false}, SHIFT(263),
  [605] = {.count = 1, .reusable = false}, SHIFT(264),
  [607] = {.count = 1, .reusable = false}, SHIFT(265),
  [609] = {.count = 1, .reusable = false}, SHIFT(266),
  [611] = {.count = 1, .reusable = false}, SHIFT(267),
  [613] = {.count = 1, .reusable = false}, SHIFT(268),
  [615] = {.count = 1, .reusable = true}, SHIFT(269),
  [617] = {.count = 1, .reusable = true}, SHIFT(270),
  [619] = {.count = 1, .reusable = false}, SHIFT(271),
  [621] = {.count = 1, .reusable = true}, SHIFT(271),
  [623] = {.count = 1, .reusable = false}, SHIFT(272),
  [625] = {.count = 1, .reusable = true}, SHIFT(278),
  [627] = {.count = 1, .reusable = true}, SHIFT(273),
  [629] = {.count = 1, .reusable = false}, SHIFT(278),
  [631] = {.count = 1, .reusable = false}, SHIFT(274),
  [633] = {.count = 1, .reusable = true}, SHIFT(281),
  [635] = {.count = 1, .reusable = true}, SHIFT(282),
  [637] = {.count = 1, .reusable = true}, SHIFT(283),
  [639] = {.count = 1, .reusable = false}, SHIFT(297),
  [641] = {.count = 1, .reusable = false}, SHIFT(294),
  [643] = {.count = 1, .reusable = false}, SHIFT(284),
  [645] = {.count = 1, .reusable = false}, SHIFT(285),
  [647] = {.count = 1, .reusable = false}, SHIFT(286),
  [649] = {.count = 1, .reusable = true}, SHIFT(287),
  [651] = {.count = 1, .reusable = true}, SHIFT(288),
  [653] = {.count = 1, .reusable = false}, SHIFT(289),
  [655] = {.count = 1, .reusable = true}, SHIFT(289),
  [657] = {.count = 1, .reusable = false}, SHIFT(290),
  [659] = {.count = 1, .reusable = true}, SHIFT(295),
  [661] = {.count = 1, .reusable = true}, SHIFT(291),
  [663] = {.count = 1, .reusable = false}, SHIFT(295),
  [665] = {.count = 1, .reusable = false}, SHIFT(292),
  [667] = {.count = 1, .reusable = true}, SHIFT(298),
  [669] = {.count = 1, .reusable = true}, SHIFT(299),
  [671] = {.count = 1, .reusable = false}, SHIFT(299),
  [673] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 3),
  [675] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 3),
  [677] = {.count = 1, .reusable = true}, REDUCE(sym_function_declarator, 2),
  [679] = {.count = 1, .reusable = true}, SHIFT(301),
  [681] = {.count = 1, .reusable = true}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2),
  [683] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(52),
  [686] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(53),
  [689] = {.count = 1, .reusable = true}, REDUCE(sym__declaration_specifiers, 3),
  [691] = {.count = 1, .reusable = false}, REDUCE(sym__declaration_specifiers, 3),
  [693] = {.count = 1, .reusable = true}, SHIFT(303),
  [695] = {.count = 1, .reusable = true}, SHIFT(304),
  [697] = {.count = 1, .reusable = true}, SHIFT(305),
  [699] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_params, 2),
  [701] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_function_def, 4, .alias_sequence_id = 4),
  [703] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_function_def, 4, .alias_sequence_id = 4),
  [705] = {.count = 1, .reusable = true}, SHIFT(307),
  [707] = {.count = 1, .reusable = false}, SHIFT(308),
  [709] = {.count = 1, .reusable = false}, SHIFT(309),
  [711] = {.count = 1, .reusable = false}, SHIFT(311),
  [713] = {.count = 1, .reusable = false}, SHIFT(314),
  [715] = {.count = 1, .reusable = false}, SHIFT(317),
  [717] = {.count = 1, .reusable = true}, SHIFT(320),
  [719] = {.count = 1, .reusable = true}, SHIFT(321),
  [721] = {.count = 1, .reusable = false}, SHIFT(322),
  [723] = {.count = 1, .reusable = true}, SHIFT(323),
  [725] = {.count = 1, .reusable = true}, SHIFT(324),
  [727] = {.count = 1, .reusable = false}, SHIFT(325),
  [729] = {.count = 1, .reusable = false}, SHIFT(326),
  [731] = {.count = 1, .reusable = false}, SHIFT(327),
  [733] = {.count = 1, .reusable = true}, SHIFT(329),
  [735] = {.count = 1, .reusable = true}, SHIFT(330),
  [737] = {.count = 1, .reusable = true}, SHIFT(331),
  [739] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_else, 2, .alias_sequence_id = 6),
  [741] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_elif, 2, .alias_sequence_id = 14),
  [743] = {.count = 1, .reusable = false}, SHIFT(336),
  [745] = {.count = 1, .reusable = false}, SHIFT(338),
  [747] = {.count = 1, .reusable = true}, SHIFT(339),
  [749] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if, 4, .alias_sequence_id = 15),
  [751] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if, 4, .alias_sequence_id = 15),
  [753] = {.count = 1, .reusable = true}, SHIFT(342),
  [755] = {.count = 1, .reusable = true}, SHIFT(343),
  [757] = {.count = 1, .reusable = true}, SHIFT(346),
  [759] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(65),
  [762] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(66),
  [765] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(67),
  [768] = {.count = 1, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2),
  [770] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(69),
  [773] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(70),
  [776] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(73),
  [779] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(74),
  [782] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(75),
  [785] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 4, .alias_sequence_id = 16),
  [787] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 4, .alias_sequence_id = 16),
  [789] = {.count = 1, .reusable = true}, SHIFT(347),
  [791] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 4, .alias_sequence_id = 17),
  [793] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 4, .alias_sequence_id = 17),
  [795] = {.count = 1, .reusable = true}, SHIFT(348),
  [797] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_call, 4),
  [799] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_call, 4),
  [801] = {.count = 1, .reusable = true}, SHIFT(349),
  [803] = {.count = 1, .reusable = true}, SHIFT(350),
  [805] = {.count = 1, .reusable = true}, SHIFT(352),
  [807] = {.count = 1, .reusable = true}, SHIFT(353),
  [809] = {.count = 1, .reusable = true}, SHIFT(354),
  [811] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_type_declarator, 2),
  [813] = {.count = 1, .reusable = true}, REDUCE(sym_type_definition, 4),
  [815] = {.count = 1, .reusable = false}, REDUCE(sym_type_definition, 4),
  [817] = {.count = 1, .reusable = true}, SHIFT(355),
  [819] = {.count = 1, .reusable = true}, SHIFT(357),
  [821] = {.count = 1, .reusable = false}, SHIFT(357),
  [823] = {.count = 1, .reusable = true}, REDUCE(sym_function_type_declarator, 2),
  [825] = {.count = 1, .reusable = true}, SHIFT(358),
  [827] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_list, 2),
  [829] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_list, 2),
  [831] = {.count = 1, .reusable = true}, SHIFT(359),
  [833] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(206),
  [836] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator_list, 3),
  [838] = {.count = 1, .reusable = false}, REDUCE(sym_enumerator_list, 3),
  [840] = {.count = 1, .reusable = true}, SHIFT(363),
  [842] = {.count = 1, .reusable = true}, SHIFT(364),
  [844] = {.count = 1, .reusable = true}, SHIFT(365),
  [846] = {.count = 1, .reusable = true}, SHIFT(366),
  [848] = {.count = 1, .reusable = false}, SHIFT(367),
  [850] = {.count = 1, .reusable = true}, SHIFT(367),
  [852] = {.count = 1, .reusable = false}, SHIFT(368),
  [854] = {.count = 1, .reusable = true}, SHIFT(370),
  [856] = {.count = 1, .reusable = true}, SHIFT(369),
  [858] = {.count = 1, .reusable = false}, SHIFT(370),
  [860] = {.count = 1, .reusable = true}, SHIFT(371),
  [862] = {.count = 1, .reusable = true}, SHIFT(373),
  [864] = {.count = 1, .reusable = true}, SHIFT(375),
  [866] = {.count = 1, .reusable = true}, SHIFT(376),
  [868] = {.count = 1, .reusable = true}, SHIFT(377),
  [870] = {.count = 1, .reusable = true}, SHIFT(381),
  [872] = {.count = 1, .reusable = true}, SHIFT(385),
  [874] = {.count = 1, .reusable = true}, SHIFT(389),
  [876] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 2),
  [878] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 2),
  [880] = {.count = 1, .reusable = true}, SHIFT(392),
  [882] = {.count = 1, .reusable = true}, SHIFT(393),
  [884] = {.count = 1, .reusable = true}, SHIFT(394),
  [886] = {.count = 1, .reusable = true}, SHIFT(395),
  [888] = {.count = 1, .reusable = false}, SHIFT(396),
  [890] = {.count = 1, .reusable = true}, SHIFT(396),
  [892] = {.count = 1, .reusable = false}, SHIFT(397),
  [894] = {.count = 1, .reusable = true}, SHIFT(399),
  [896] = {.count = 1, .reusable = true}, SHIFT(398),
  [898] = {.count = 1, .reusable = false}, SHIFT(399),
  [900] = {.count = 1, .reusable = true}, REDUCE(sym__field_declarator, 1, .alias_sequence_id = 18),
  [902] = {.count = 1, .reusable = true}, SHIFT(400),
  [904] = {.count = 1, .reusable = true}, SHIFT(401),
  [906] = {.count = 1, .reusable = true}, SHIFT(402),
  [908] = {.count = 1, .reusable = true}, SHIFT(403),
  [910] = {.count = 1, .reusable = true}, REDUCE(sym__field_declarator, 1, .alias_sequence_id = 9),
  [912] = {.count = 1, .reusable = true}, REDUCE(sym__field_declarator, 1, .alias_sequence_id = 10),
  [914] = {.count = 1, .reusable = true}, REDUCE(sym__field_declarator, 1, .alias_sequence_id = 11),
  [916] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(225),
  [919] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration_list, 3),
  [921] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration_list, 3),
  [923] = {.count = 2, .reusable = false}, REDUCE(aux_sym_field_declaration_list_repeat1, 2), SHIFT_REPEAT(118),
  [926] = {.count = 2, .reusable = true}, REDUCE(aux_sym_field_declaration_list_repeat1, 2), SHIFT_REPEAT(119),
  [929] = {.count = 2, .reusable = true}, REDUCE(aux_sym_field_declaration_list_repeat1, 2), SHIFT_REPEAT(120),
  [932] = {.count = 2, .reusable = false}, REDUCE(aux_sym_field_declaration_list_repeat1, 2), SHIFT_REPEAT(10),
  [935] = {.count = 1, .reusable = true}, REDUCE(aux_sym_field_declaration_list_repeat1, 2),
  [937] = {.count = 2, .reusable = false}, REDUCE(aux_sym_field_declaration_list_repeat1, 2), SHIFT_REPEAT(11),
  [940] = {.count = 2, .reusable = false}, REDUCE(aux_sym_field_declaration_list_repeat1, 2), SHIFT_REPEAT(127),
  [943] = {.count = 2, .reusable = false}, REDUCE(aux_sym_field_declaration_list_repeat1, 2), SHIFT_REPEAT(125),
  [946] = {.count = 2, .reusable = false}, REDUCE(aux_sym_field_declaration_list_repeat1, 2), SHIFT_REPEAT(12),
  [949] = {.count = 2, .reusable = false}, REDUCE(aux_sym_field_declaration_list_repeat1, 2), SHIFT_REPEAT(13),
  [952] = {.count = 2, .reusable = false}, REDUCE(aux_sym_field_declaration_list_repeat1, 2), SHIFT_REPEAT(14),
  [955] = {.count = 2, .reusable = false}, REDUCE(aux_sym_field_declaration_list_repeat1, 2), SHIFT_REPEAT(15),
  [958] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_pointer_declarator, 1),
  [960] = {.count = 1, .reusable = true}, SHIFT(410),
  [962] = {.count = 1, .reusable = true}, SHIFT(412),
  [964] = {.count = 1, .reusable = false}, SHIFT(412),
  [966] = {.count = 1, .reusable = true}, REDUCE(sym_type_descriptor, 2),
  [968] = {.count = 1, .reusable = true}, SHIFT(413),
  [970] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_function_declarator, 1),
  [972] = {.count = 1, .reusable = true}, REDUCE(sym_macro_type_specifier, 4),
  [974] = {.count = 1, .reusable = false}, REDUCE(sym_macro_type_specifier, 4),
  [976] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(235),
  [979] = {.count = 1, .reusable = true}, REDUCE(sym__declarator, 3),
  [981] = {.count = 1, .reusable = true}, SHIFT(416),
  [983] = {.count = 1, .reusable = true}, SHIFT(417),
  [985] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_list, 2, .dynamic_precedence = 1),
  [987] = {.count = 1, .reusable = true}, SHIFT(419),
  [989] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_declaration, 1),
  [991] = {.count = 1, .reusable = true}, SHIFT(420),
  [993] = {.count = 1, .reusable = true}, SHIFT(421),
  [995] = {.count = 1, .reusable = false}, SHIFT(424),
  [997] = {.count = 1, .reusable = false}, SHIFT(425),
  [999] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_repeat1, 2),
  [1001] = {.count = 1, .reusable = true}, SHIFT(426),
  [1003] = {.count = 1, .reusable = true}, SHIFT(427),
  [1005] = {.count = 1, .reusable = true}, SHIFT(428),
  [1007] = {.count = 1, .reusable = true}, SHIFT(429),
  [1009] = {.count = 1, .reusable = true}, SHIFT(430),
  [1011] = {.count = 1, .reusable = true}, SHIFT(431),
  [1013] = {.count = 1, .reusable = false}, SHIFT(432),
  [1015] = {.count = 1, .reusable = true}, SHIFT(432),
  [1017] = {.count = 1, .reusable = false}, SHIFT(433),
  [1019] = {.count = 1, .reusable = true}, SHIFT(436),
  [1021] = {.count = 1, .reusable = true}, SHIFT(434),
  [1023] = {.count = 1, .reusable = false}, SHIFT(436),
  [1025] = {.count = 1, .reusable = false}, SHIFT(435),
  [1027] = {.count = 1, .reusable = false}, SHIFT(439),
  [1029] = {.count = 1, .reusable = true}, SHIFT(440),
  [1031] = {.count = 1, .reusable = true}, SHIFT(441),
  [1033] = {.count = 1, .reusable = false}, SHIFT(442),
  [1035] = {.count = 1, .reusable = false}, SHIFT(443),
  [1037] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 1),
  [1039] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 1),
  [1041] = {.count = 1, .reusable = false}, SHIFT(444),
  [1043] = {.count = 1, .reusable = true}, SHIFT(446),
  [1045] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 2),
  [1047] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 2),
  [1049] = {.count = 1, .reusable = true}, SHIFT(448),
  [1051] = {.count = 1, .reusable = false}, SHIFT(448),
  [1053] = {.count = 1, .reusable = true}, SHIFT(449),
  [1055] = {.count = 1, .reusable = true}, SHIFT(450),
  [1057] = {.count = 1, .reusable = true}, SHIFT(451),
  [1059] = {.count = 1, .reusable = true}, SHIFT(452),
  [1061] = {.count = 1, .reusable = true}, SHIFT(453),
  [1063] = {.count = 1, .reusable = true}, SHIFT(454),
  [1065] = {.count = 1, .reusable = false}, SHIFT(455),
  [1067] = {.count = 1, .reusable = true}, SHIFT(455),
  [1069] = {.count = 1, .reusable = false}, SHIFT(456),
  [1071] = {.count = 1, .reusable = true}, SHIFT(458),
  [1073] = {.count = 1, .reusable = true}, SHIFT(457),
  [1075] = {.count = 1, .reusable = false}, SHIFT(458),
  [1077] = {.count = 1, .reusable = true}, SHIFT(459),
  [1079] = {.count = 1, .reusable = true}, SHIFT(460),
  [1081] = {.count = 1, .reusable = false}, SHIFT(461),
  [1083] = {.count = 1, .reusable = false}, SHIFT(462),
  [1085] = {.count = 1, .reusable = false}, SHIFT(463),
  [1087] = {.count = 1, .reusable = false}, SHIFT(464),
  [1089] = {.count = 1, .reusable = false}, SHIFT(465),
  [1091] = {.count = 1, .reusable = false}, SHIFT(466),
  [1093] = {.count = 1, .reusable = false}, SHIFT(467),
  [1095] = {.count = 1, .reusable = true}, SHIFT(469),
  [1097] = {.count = 1, .reusable = true}, SHIFT(470),
  [1099] = {.count = 1, .reusable = true}, SHIFT(471),
  [1101] = {.count = 1, .reusable = false}, SHIFT(471),
  [1103] = {.count = 1, .reusable = true}, SHIFT(472),
  [1105] = {.count = 1, .reusable = true}, SHIFT(473),
  [1107] = {.count = 1, .reusable = true}, SHIFT(474),
  [1109] = {.count = 1, .reusable = true}, SHIFT(475),
  [1111] = {.count = 1, .reusable = false}, SHIFT(475),
  [1113] = {.count = 1, .reusable = true}, SHIFT(476),
  [1115] = {.count = 1, .reusable = false}, SHIFT(476),
  [1117] = {.count = 1, .reusable = true}, SHIFT(477),
  [1119] = {.count = 1, .reusable = false}, SHIFT(477),
  [1121] = {.count = 1, .reusable = true}, SHIFT(478),
  [1123] = {.count = 1, .reusable = true}, SHIFT(479),
  [1125] = {.count = 1, .reusable = false}, SHIFT(479),
  [1127] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [1129] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [1131] = {.count = 1, .reusable = true}, SHIFT(480),
  [1133] = {.count = 3, .reusable = true}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1), REDUCE(sym__expression, 1), SHIFT(46),
  [1137] = {.count = 2, .reusable = true}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1), REDUCE(sym__expression, 1),
  [1140] = {.count = 2, .reusable = false}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1), REDUCE(sym__expression, 1),
  [1143] = {.count = 1, .reusable = true}, SHIFT(481),
  [1145] = {.count = 1, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 1, .alias_sequence_id = 12),
  [1147] = {.count = 1, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 1, .alias_sequence_id = 12),
  [1149] = {.count = 1, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 1, .alias_sequence_id = 13),
  [1151] = {.count = 1, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 1, .alias_sequence_id = 13),
  [1153] = {.count = 1, .reusable = true}, SHIFT(482),
  [1155] = {.count = 1, .reusable = true}, SHIFT(483),
  [1157] = {.count = 1, .reusable = true}, SHIFT(485),
  [1159] = {.count = 1, .reusable = true}, SHIFT(486),
  [1161] = {.count = 1, .reusable = true}, SHIFT(487),
  [1163] = {.count = 1, .reusable = false}, SHIFT(488),
  [1165] = {.count = 1, .reusable = true}, SHIFT(489),
  [1167] = {.count = 1, .reusable = false}, SHIFT(490),
  [1169] = {.count = 1, .reusable = true}, SHIFT(491),
  [1171] = {.count = 1, .reusable = true}, SHIFT(490),
  [1173] = {.count = 1, .reusable = false}, SHIFT(492),
  [1175] = {.count = 1, .reusable = true}, SHIFT(493),
  [1177] = {.count = 1, .reusable = true}, SHIFT(494),
  [1179] = {.count = 1, .reusable = false}, SHIFT(495),
  [1181] = {.count = 1, .reusable = false}, SHIFT(496),
  [1183] = {.count = 1, .reusable = true}, SHIFT(497),
  [1185] = {.count = 1, .reusable = false}, SHIFT(498),
  [1187] = {.count = 1, .reusable = true}, SHIFT(498),
  [1189] = {.count = 1, .reusable = false}, SHIFT(499),
  [1191] = {.count = 1, .reusable = false}, SHIFT(500),
  [1193] = {.count = 1, .reusable = true}, SHIFT(501),
  [1195] = {.count = 1, .reusable = true}, SHIFT(502),
  [1197] = {.count = 1, .reusable = true}, SHIFT(504),
  [1199] = {.count = 1, .reusable = true}, REDUCE(sym_array_declarator, 3),
  [1201] = {.count = 1, .reusable = true}, SHIFT(507),
  [1203] = {.count = 1, .reusable = true}, SHIFT(508),
  [1205] = {.count = 1, .reusable = true}, SHIFT(510),
  [1207] = {.count = 1, .reusable = true}, SHIFT(511),
  [1209] = {.count = 1, .reusable = true}, SHIFT(513),
  [1211] = {.count = 1, .reusable = true}, SHIFT(515),
  [1213] = {.count = 1, .reusable = true}, SHIFT(516),
  [1215] = {.count = 1, .reusable = false}, SHIFT(516),
  [1217] = {.count = 1, .reusable = true}, SHIFT(517),
  [1219] = {.count = 3, .reusable = true}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1), REDUCE(sym__expression, 1), SHIFT(518),
  [1223] = {.count = 1, .reusable = true}, SHIFT(519),
  [1225] = {.count = 1, .reusable = true}, SHIFT(520),
  [1227] = {.count = 1, .reusable = false}, SHIFT(520),
  [1229] = {.count = 1, .reusable = false}, SHIFT(521),
  [1231] = {.count = 1, .reusable = false}, SHIFT(522),
  [1233] = {.count = 1, .reusable = false}, SHIFT(524),
  [1235] = {.count = 1, .reusable = false}, SHIFT(525),
  [1237] = {.count = 1, .reusable = true}, SHIFT(526),
  [1239] = {.count = 1, .reusable = true}, SHIFT(525),
  [1241] = {.count = 1, .reusable = false}, SHIFT(527),
  [1243] = {.count = 1, .reusable = true}, SHIFT(528),
  [1245] = {.count = 1, .reusable = true}, SHIFT(529),
  [1247] = {.count = 1, .reusable = false}, SHIFT(530),
  [1249] = {.count = 1, .reusable = false}, SHIFT(531),
  [1251] = {.count = 1, .reusable = true}, SHIFT(532),
  [1253] = {.count = 1, .reusable = false}, SHIFT(533),
  [1255] = {.count = 1, .reusable = true}, SHIFT(533),
  [1257] = {.count = 1, .reusable = false}, SHIFT(534),
  [1259] = {.count = 1, .reusable = false}, SHIFT(535),
  [1261] = {.count = 1, .reusable = false}, SHIFT(537),
  [1263] = {.count = 1, .reusable = false}, SHIFT(536),
  [1265] = {.count = 1, .reusable = false}, SHIFT(540),
  [1267] = {.count = 1, .reusable = false}, SHIFT(538),
  [1269] = {.count = 2, .reusable = false}, REDUCE(sym_sized_type_specifier, 1), SHIFT(539),
  [1272] = {.count = 1, .reusable = true}, SHIFT(541),
  [1274] = {.count = 1, .reusable = true}, SHIFT(542),
  [1276] = {.count = 1, .reusable = true}, SHIFT(543),
  [1278] = {.count = 1, .reusable = true}, SHIFT(544),
  [1280] = {.count = 1, .reusable = true}, SHIFT(545),
  [1282] = {.count = 1, .reusable = false}, SHIFT(545),
  [1284] = {.count = 1, .reusable = true}, REDUCE(sym_init_declarator, 3),
  [1286] = {.count = 1, .reusable = true}, REDUCE(sym_declaration, 4),
  [1288] = {.count = 1, .reusable = false}, REDUCE(sym_declaration, 4),
  [1290] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_repeat1, 2), SHIFT_REPEAT(139),
  [1293] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_def, 5, .alias_sequence_id = 4),
  [1295] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_def, 5, .alias_sequence_id = 4),
  [1297] = {.count = 1, .reusable = true}, SHIFT(548),
  [1299] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_params, 3),
  [1301] = {.count = 1, .reusable = true}, SHIFT(549),
  [1303] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_function_def, 5, .alias_sequence_id = 4),
  [1305] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_function_def, 5, .alias_sequence_id = 4),
  [1307] = {.count = 1, .reusable = false}, SHIFT(551),
  [1309] = {.count = 1, .reusable = false}, SHIFT(552),
  [1311] = {.count = 1, .reusable = false}, SHIFT(553),
  [1313] = {.count = 1, .reusable = true}, SHIFT(554),
  [1315] = {.count = 1, .reusable = false}, SHIFT(554),
  [1317] = {.count = 1, .reusable = true}, SHIFT(556),
  [1319] = {.count = 1, .reusable = false}, SHIFT(556),
  [1321] = {.count = 1, .reusable = true}, SHIFT(558),
  [1323] = {.count = 1, .reusable = false}, SHIFT(558),
  [1325] = {.count = 1, .reusable = false}, SHIFT(560),
  [1327] = {.count = 1, .reusable = false}, SHIFT(561),
  [1329] = {.count = 1, .reusable = false}, SHIFT(563),
  [1331] = {.count = 1, .reusable = false}, SHIFT(566),
  [1333] = {.count = 1, .reusable = false}, SHIFT(569),
  [1335] = {.count = 1, .reusable = false}, SHIFT(572),
  [1337] = {.count = 1, .reusable = false}, SHIFT(574),
  [1339] = {.count = 1, .reusable = true}, SHIFT(575),
  [1341] = {.count = 1, .reusable = true}, SHIFT(578),
  [1343] = {.count = 1, .reusable = true}, SHIFT(579),
  [1345] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(159),
  [1348] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(160),
  [1351] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(161),
  [1354] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(162),
  [1357] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(163),
  [1360] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(164),
  [1363] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(165),
  [1366] = {.count = 2, .reusable = false}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(166),
  [1369] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif, 3, .alias_sequence_id = 14),
  [1371] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_elif, 3, .alias_sequence_id = 14),
  [1373] = {.count = 1, .reusable = true}, SHIFT(583),
  [1375] = {.count = 1, .reusable = true}, SHIFT(584),
  [1377] = {.count = 1, .reusable = true}, SHIFT(586),
  [1379] = {.count = 1, .reusable = true}, SHIFT(588),
  [1381] = {.count = 1, .reusable = true}, SHIFT(590),
  [1383] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if, 5, .alias_sequence_id = 19),
  [1385] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if, 5, .alias_sequence_id = 19),
  [1387] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 5, .alias_sequence_id = 20),
  [1389] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 5, .alias_sequence_id = 20),
  [1391] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef, 5, .alias_sequence_id = 21),
  [1393] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef, 5, .alias_sequence_id = 21),
  [1395] = {.count = 1, .reusable = true}, SHIFT(591),
  [1397] = {.count = 1, .reusable = true}, SHIFT(592),
  [1399] = {.count = 1, .reusable = true}, REDUCE(sym__type_declarator, 3),
  [1401] = {.count = 1, .reusable = true}, REDUCE(sym_array_type_declarator, 3),
  [1403] = {.count = 1, .reusable = true}, SHIFT(593),
  [1405] = {.count = 1, .reusable = true}, SHIFT(594),
  [1407] = {.count = 1, .reusable = false}, SHIFT(594),
  [1409] = {.count = 1, .reusable = true}, REDUCE(sym_type_definition, 5),
  [1411] = {.count = 1, .reusable = false}, REDUCE(sym_type_definition, 5),
  [1413] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_list, 3),
  [1415] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_list, 3),
  [1417] = {.count = 1, .reusable = true}, SHIFT(596),
  [1419] = {.count = 1, .reusable = true}, SHIFT(597),
  [1421] = {.count = 1, .reusable = false}, SHIFT(597),
  [1423] = {.count = 1, .reusable = true}, SHIFT(598),
  [1425] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator, 3),
  [1427] = {.count = 1, .reusable = false}, SHIFT(599),
  [1429] = {.count = 1, .reusable = false}, SHIFT(600),
  [1431] = {.count = 1, .reusable = true}, SHIFT(601),
  [1433] = {.count = 1, .reusable = true}, SHIFT(600),
  [1435] = {.count = 1, .reusable = false}, SHIFT(602),
  [1437] = {.count = 1, .reusable = true}, SHIFT(603),
  [1439] = {.count = 1, .reusable = true}, SHIFT(604),
  [1441] = {.count = 1, .reusable = false}, SHIFT(605),
  [1443] = {.count = 1, .reusable = false}, SHIFT(606),
  [1445] = {.count = 1, .reusable = true}, SHIFT(607),
  [1447] = {.count = 1, .reusable = false}, SHIFT(608),
  [1449] = {.count = 1, .reusable = true}, SHIFT(608),
  [1451] = {.count = 1, .reusable = false}, SHIFT(609),
  [1453] = {.count = 1, .reusable = false}, SHIFT(610),
  [1455] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator_list, 4),
  [1457] = {.count = 1, .reusable = false}, REDUCE(sym_enumerator_list, 4),
  [1459] = {.count = 1, .reusable = true}, REDUCE(aux_sym_enumerator_list_repeat1, 2),
  [1461] = {.count = 1, .reusable = true}, SHIFT(611),
  [1463] = {.count = 2, .reusable = true}, REDUCE(aux_sym_enumerator_list_repeat1, 2), SHIFT_REPEAT(612),
  [1466] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 3, .alias_sequence_id = 5),
  [1468] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 3, .alias_sequence_id = 5),
  [1470] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_else_in_field_declaration_list, 1, .alias_sequence_id = 6),
  [1472] = {.count = 1, .reusable = false}, SHIFT(614),
  [1474] = {.count = 1, .reusable = true}, SHIFT(615),
  [1476] = {.count = 1, .reusable = true}, SHIFT(616),
  [1478] = {.count = 1, .reusable = true}, SHIFT(617),
  [1480] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, .alias_sequence_id = 7),
  [1482] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, .alias_sequence_id = 7),
  [1484] = {.count = 1, .reusable = true}, SHIFT(621),
  [1486] = {.count = 1, .reusable = true}, SHIFT(622),
  [1488] = {.count = 1, .reusable = true}, SHIFT(623),
  [1490] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, .alias_sequence_id = 8),
  [1492] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, .alias_sequence_id = 8),
  [1494] = {.count = 1, .reusable = true}, SHIFT(626),
  [1496] = {.count = 1, .reusable = true}, SHIFT(627),
  [1498] = {.count = 1, .reusable = true}, SHIFT(628),
  [1500] = {.count = 1, .reusable = true}, SHIFT(631),
  [1502] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_field_declarator, 2),
  [1504] = {.count = 1, .reusable = true}, SHIFT(633),
  [1506] = {.count = 1, .reusable = true}, SHIFT(634),
  [1508] = {.count = 1, .reusable = false}, SHIFT(634),
  [1510] = {.count = 1, .reusable = true}, SHIFT(635),
  [1512] = {.count = 1, .reusable = true}, SHIFT(636),
  [1514] = {.count = 1, .reusable = false}, SHIFT(637),
  [1516] = {.count = 1, .reusable = false}, SHIFT(638),
  [1518] = {.count = 1, .reusable = true}, SHIFT(639),
  [1520] = {.count = 1, .reusable = true}, SHIFT(638),
  [1522] = {.count = 1, .reusable = false}, SHIFT(640),
  [1524] = {.count = 1, .reusable = true}, SHIFT(641),
  [1526] = {.count = 1, .reusable = true}, SHIFT(642),
  [1528] = {.count = 1, .reusable = false}, SHIFT(643),
  [1530] = {.count = 1, .reusable = false}, SHIFT(644),
  [1532] = {.count = 1, .reusable = true}, SHIFT(645),
  [1534] = {.count = 1, .reusable = false}, SHIFT(646),
  [1536] = {.count = 1, .reusable = true}, SHIFT(646),
  [1538] = {.count = 1, .reusable = false}, SHIFT(647),
  [1540] = {.count = 1, .reusable = false}, SHIFT(648),
  [1542] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 3),
  [1544] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 3),
  [1546] = {.count = 1, .reusable = true}, SHIFT(650),
  [1548] = {.count = 1, .reusable = true}, SHIFT(652),
  [1550] = {.count = 1, .reusable = false}, SHIFT(652),
  [1552] = {.count = 1, .reusable = true}, SHIFT(653),
  [1554] = {.count = 1, .reusable = false}, SHIFT(653),
  [1556] = {.count = 1, .reusable = true}, REDUCE(sym_function_field_declarator, 2),
  [1558] = {.count = 1, .reusable = true}, SHIFT(654),
  [1560] = {.count = 1, .reusable = true}, SHIFT(656),
  [1562] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_pointer_declarator, 2),
  [1564] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_array_declarator, 2),
  [1566] = {.count = 1, .reusable = true}, SHIFT(657),
  [1568] = {.count = 1, .reusable = true}, SHIFT(658),
  [1570] = {.count = 1, .reusable = false}, SHIFT(658),
  [1572] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_function_declarator, 2),
  [1574] = {.count = 1, .reusable = true}, REDUCE(sym_type_descriptor, 3),
  [1576] = {.count = 1, .reusable = true}, SHIFT(660),
  [1578] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_list, 3, .dynamic_precedence = 1),
  [1580] = {.count = 1, .reusable = true}, SHIFT(661),
  [1582] = {.count = 1, .reusable = true}, SHIFT(663),
  [1584] = {.count = 1, .reusable = false}, SHIFT(664),
  [1586] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_declaration, 2),
  [1588] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(425),
  [1591] = {.count = 1, .reusable = false}, SHIFT(667),
  [1593] = {.count = 1, .reusable = false}, SHIFT(668),
  [1595] = {.count = 1, .reusable = true}, SHIFT(671),
  [1597] = {.count = 1, .reusable = true}, SHIFT(672),
  [1599] = {.count = 1, .reusable = false}, SHIFT(672),
  [1601] = {.count = 1, .reusable = true}, SHIFT(673),
  [1603] = {.count = 1, .reusable = true}, SHIFT(674),
  [1605] = {.count = 1, .reusable = true}, SHIFT(675),
  [1607] = {.count = 1, .reusable = false}, SHIFT(676),
  [1609] = {.count = 1, .reusable = false}, SHIFT(677),
  [1611] = {.count = 1, .reusable = true}, SHIFT(678),
  [1613] = {.count = 1, .reusable = true}, SHIFT(677),
  [1615] = {.count = 1, .reusable = false}, SHIFT(679),
  [1617] = {.count = 1, .reusable = true}, SHIFT(680),
  [1619] = {.count = 1, .reusable = true}, SHIFT(681),
  [1621] = {.count = 1, .reusable = false}, SHIFT(682),
  [1623] = {.count = 1, .reusable = false}, SHIFT(683),
  [1625] = {.count = 1, .reusable = true}, SHIFT(684),
  [1627] = {.count = 1, .reusable = false}, SHIFT(685),
  [1629] = {.count = 1, .reusable = true}, SHIFT(685),
  [1631] = {.count = 1, .reusable = false}, SHIFT(686),
  [1633] = {.count = 1, .reusable = false}, SHIFT(687),
  [1635] = {.count = 1, .reusable = true}, SHIFT(688),
  [1637] = {.count = 1, .reusable = false}, SHIFT(689),
  [1639] = {.count = 1, .reusable = false}, SHIFT(690),
  [1641] = {.count = 1, .reusable = false}, SHIFT(691),
  [1643] = {.count = 1, .reusable = false}, SHIFT(692),
  [1645] = {.count = 1, .reusable = false}, SHIFT(693),
  [1647] = {.count = 1, .reusable = false}, SHIFT(694),
  [1649] = {.count = 1, .reusable = false}, SHIFT(695),
  [1651] = {.count = 1, .reusable = false}, SHIFT(696),
  [1653] = {.count = 1, .reusable = false}, SHIFT(697),
  [1655] = {.count = 1, .reusable = true}, SHIFT(698),
  [1657] = {.count = 1, .reusable = false}, SHIFT(699),
  [1659] = {.count = 1, .reusable = true}, SHIFT(700),
  [1661] = {.count = 1, .reusable = false}, SHIFT(701),
  [1663] = {.count = 1, .reusable = false}, SHIFT(702),
  [1665] = {.count = 1, .reusable = false}, SHIFT(703),
  [1667] = {.count = 1, .reusable = false}, SHIFT(704),
  [1669] = {.count = 1, .reusable = false}, SHIFT(705),
  [1671] = {.count = 1, .reusable = false}, SHIFT(706),
  [1673] = {.count = 1, .reusable = false}, SHIFT(707),
  [1675] = {.count = 1, .reusable = false}, SHIFT(708),
  [1677] = {.count = 1, .reusable = false}, SHIFT(709),
  [1679] = {.count = 1, .reusable = false}, SHIFT(710),
  [1681] = {.count = 1, .reusable = false}, SHIFT(711),
  [1683] = {.count = 1, .reusable = true}, SHIFT(718),
  [1685] = {.count = 1, .reusable = false}, SHIFT(718),
  [1687] = {.count = 1, .reusable = false}, SHIFT(712),
  [1689] = {.count = 1, .reusable = false}, SHIFT(721),
  [1691] = {.count = 1, .reusable = false}, SHIFT(725),
  [1693] = {.count = 1, .reusable = false}, SHIFT(729),
  [1695] = {.count = 1, .reusable = false}, SHIFT(731),
  [1697] = {.count = 1, .reusable = true}, SHIFT(732),
  [1699] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_expression, 2),
  [1701] = {.count = 1, .reusable = false}, REDUCE(sym_pointer_expression, 2),
  [1703] = {.count = 1, .reusable = true}, SHIFT(733),
  [1705] = {.count = 1, .reusable = true}, SHIFT(734),
  [1707] = {.count = 1, .reusable = true}, SHIFT(735),
  [1709] = {.count = 1, .reusable = true}, SHIFT(736),
  [1711] = {.count = 1, .reusable = false}, SHIFT(737),
  [1713] = {.count = 1, .reusable = true}, SHIFT(737),
  [1715] = {.count = 1, .reusable = false}, SHIFT(738),
  [1717] = {.count = 1, .reusable = true}, SHIFT(740),
  [1719] = {.count = 1, .reusable = true}, SHIFT(739),
  [1721] = {.count = 1, .reusable = false}, SHIFT(740),
  [1723] = {.count = 1, .reusable = true}, SHIFT(741),
  [1725] = {.count = 1, .reusable = false}, SHIFT(741),
  [1727] = {.count = 1, .reusable = true}, SHIFT(743),
  [1729] = {.count = 1, .reusable = true}, SHIFT(744),
  [1731] = {.count = 1, .reusable = false}, SHIFT(744),
  [1733] = {.count = 1, .reusable = true}, SHIFT(745),
  [1735] = {.count = 1, .reusable = false}, SHIFT(746),
  [1737] = {.count = 1, .reusable = false}, SHIFT(747),
  [1739] = {.count = 1, .reusable = true}, SHIFT(748),
  [1741] = {.count = 1, .reusable = true}, SHIFT(749),
  [1743] = {.count = 1, .reusable = true}, SHIFT(747),
  [1745] = {.count = 1, .reusable = false}, SHIFT(750),
  [1747] = {.count = 1, .reusable = true}, SHIFT(751),
  [1749] = {.count = 1, .reusable = true}, SHIFT(752),
  [1751] = {.count = 1, .reusable = false}, SHIFT(753),
  [1753] = {.count = 1, .reusable = false}, SHIFT(754),
  [1755] = {.count = 1, .reusable = true}, SHIFT(755),
  [1757] = {.count = 1, .reusable = false}, SHIFT(756),
  [1759] = {.count = 1, .reusable = true}, SHIFT(756),
  [1761] = {.count = 1, .reusable = false}, SHIFT(757),
  [1763] = {.count = 1, .reusable = false}, SHIFT(758),
  [1765] = {.count = 1, .reusable = false}, SHIFT(759),
  [1767] = {.count = 1, .reusable = true}, SHIFT(762),
  [1769] = {.count = 1, .reusable = false}, SHIFT(762),
  [1771] = {.count = 1, .reusable = true}, SHIFT(763),
  [1773] = {.count = 1, .reusable = true}, SHIFT(764),
  [1775] = {.count = 1, .reusable = true}, SHIFT(765),
  [1777] = {.count = 1, .reusable = false}, SHIFT(765),
  [1779] = {.count = 1, .reusable = true}, SHIFT(766),
  [1781] = {.count = 1, .reusable = true}, SHIFT(767),
  [1783] = {.count = 1, .reusable = true}, SHIFT(768),
  [1785] = {.count = 1, .reusable = true}, SHIFT(769),
  [1787] = {.count = 1, .reusable = true}, SHIFT(770),
  [1789] = {.count = 1, .reusable = true}, SHIFT(771),
  [1791] = {.count = 1, .reusable = true}, SHIFT(774),
  [1793] = {.count = 1, .reusable = false}, SHIFT(774),
  [1795] = {.count = 1, .reusable = false}, SHIFT(772),
  [1797] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 2),
  [1799] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [1801] = {.count = 1, .reusable = true}, SHIFT(775),
  [1803] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 2),
  [1805] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 2),
  [1807] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 2),
  [1809] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 2),
  [1811] = {.count = 1, .reusable = true}, SHIFT(776),
  [1813] = {.count = 1, .reusable = true}, REDUCE(sym_logical_expression, 2),
  [1815] = {.count = 1, .reusable = false}, REDUCE(sym_logical_expression, 2),
  [1817] = {.count = 1, .reusable = true}, REDUCE(sym_bitwise_expression, 2),
  [1819] = {.count = 1, .reusable = false}, REDUCE(sym_bitwise_expression, 2),
  [1821] = {.count = 1, .reusable = true}, REDUCE(sym_math_expression, 2),
  [1823] = {.count = 1, .reusable = false}, REDUCE(sym_math_expression, 2),
  [1825] = {.count = 1, .reusable = true}, REDUCE(sym_sizeof_expression, 2),
  [1827] = {.count = 1, .reusable = false}, REDUCE(sym_sizeof_expression, 2),
  [1829] = {.count = 1, .reusable = true}, REDUCE(sym_concatenated_string, 2),
  [1831] = {.count = 1, .reusable = false}, REDUCE(sym_concatenated_string, 2),
  [1833] = {.count = 1, .reusable = true}, SHIFT(778),
  [1835] = {.count = 1, .reusable = false}, SHIFT(779),
  [1837] = {.count = 1, .reusable = true}, SHIFT(781),
  [1839] = {.count = 1, .reusable = true}, SHIFT(783),
  [1841] = {.count = 1, .reusable = true}, SHIFT(784),
  [1843] = {.count = 1, .reusable = false}, SHIFT(784),
  [1845] = {.count = 1, .reusable = true}, SHIFT(785),
  [1847] = {.count = 1, .reusable = false}, SHIFT(785),
  [1849] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 2),
  [1851] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [1853] = {.count = 1, .reusable = true}, SHIFT(787),
  [1855] = {.count = 1, .reusable = false}, SHIFT(787),
  [1857] = {.count = 1, .reusable = true}, SHIFT(788),
  [1859] = {.count = 1, .reusable = false}, SHIFT(788),
  [1861] = {.count = 1, .reusable = true}, SHIFT(789),
  [1863] = {.count = 1, .reusable = false}, SHIFT(789),
  [1865] = {.count = 1, .reusable = true}, SHIFT(790),
  [1867] = {.count = 1, .reusable = false}, SHIFT(790),
  [1869] = {.count = 1, .reusable = true}, SHIFT(791),
  [1871] = {.count = 1, .reusable = false}, SHIFT(791),
  [1873] = {.count = 1, .reusable = true}, SHIFT(792),
  [1875] = {.count = 1, .reusable = false}, SHIFT(792),
  [1877] = {.count = 1, .reusable = true}, SHIFT(793),
  [1879] = {.count = 1, .reusable = false}, SHIFT(793),
  [1881] = {.count = 1, .reusable = true}, SHIFT(794),
  [1883] = {.count = 1, .reusable = false}, SHIFT(794),
  [1885] = {.count = 1, .reusable = true}, SHIFT(795),
  [1887] = {.count = 1, .reusable = false}, SHIFT(795),
  [1889] = {.count = 1, .reusable = true}, SHIFT(796),
  [1891] = {.count = 1, .reusable = false}, SHIFT(796),
  [1893] = {.count = 1, .reusable = true}, SHIFT(797),
  [1895] = {.count = 1, .reusable = false}, SHIFT(797),
  [1897] = {.count = 1, .reusable = true}, SHIFT(798),
  [1899] = {.count = 1, .reusable = false}, SHIFT(798),
  [1901] = {.count = 1, .reusable = true}, SHIFT(799),
  [1903] = {.count = 1, .reusable = false}, SHIFT(799),
  [1905] = {.count = 1, .reusable = true}, SHIFT(800),
  [1907] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 2),
  [1909] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 2),
  [1911] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 3),
  [1913] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 3),
  [1915] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(246),
  [1918] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(247),
  [1921] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(248),
  [1924] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(249),
  [1927] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(250),
  [1930] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(251),
  [1933] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(252),
  [1936] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(253),
  [1939] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(254),
  [1942] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(10),
  [1945] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(255),
  [1948] = {.count = 1, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2),
  [1950] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(257),
  [1953] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(11),
  [1956] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(21),
  [1959] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(18),
  [1962] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(12),
  [1965] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(13),
  [1968] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(14),
  [1971] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(258),
  [1974] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(259),
  [1977] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(260),
  [1980] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(261),
  [1983] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(262),
  [1986] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(263),
  [1989] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(264),
  [1992] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(265),
  [1995] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(266),
  [1998] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(267),
  [2001] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(268),
  [2004] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(269),
  [2007] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(270),
  [2010] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(271),
  [2013] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(271),
  [2016] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(272),
  [2019] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(278),
  [2022] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(273),
  [2025] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(278),
  [2028] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(274),
  [2031] = {.count = 1, .reusable = true}, SHIFT(801),
  [2033] = {.count = 1, .reusable = true}, SHIFT(802),
  [2035] = {.count = 1, .reusable = true}, SHIFT(803),
  [2037] = {.count = 1, .reusable = true}, SHIFT(806),
  [2039] = {.count = 1, .reusable = true}, SHIFT(811),
  [2041] = {.count = 1, .reusable = true}, REDUCE(sym_array_declarator, 4),
  [2043] = {.count = 1, .reusable = true}, SHIFT(813),
  [2045] = {.count = 1, .reusable = true}, SHIFT(815),
  [2047] = {.count = 1, .reusable = false}, SHIFT(815),
  [2049] = {.count = 1, .reusable = true}, SHIFT(816),
  [2051] = {.count = 1, .reusable = false}, SHIFT(816),
  [2053] = {.count = 1, .reusable = true}, SHIFT(817),
  [2055] = {.count = 1, .reusable = false}, SHIFT(817),
  [2057] = {.count = 1, .reusable = true}, SHIFT(818),
  [2059] = {.count = 1, .reusable = false}, SHIFT(818),
  [2061] = {.count = 1, .reusable = true}, SHIFT(819),
  [2063] = {.count = 1, .reusable = false}, SHIFT(819),
  [2065] = {.count = 1, .reusable = true}, SHIFT(820),
  [2067] = {.count = 1, .reusable = false}, SHIFT(820),
  [2069] = {.count = 1, .reusable = true}, SHIFT(821),
  [2071] = {.count = 1, .reusable = false}, SHIFT(821),
  [2073] = {.count = 1, .reusable = true}, SHIFT(822),
  [2075] = {.count = 1, .reusable = false}, SHIFT(822),
  [2077] = {.count = 1, .reusable = true}, SHIFT(823),
  [2079] = {.count = 1, .reusable = false}, SHIFT(823),
  [2081] = {.count = 1, .reusable = true}, SHIFT(824),
  [2083] = {.count = 1, .reusable = false}, SHIFT(824),
  [2085] = {.count = 1, .reusable = true}, SHIFT(825),
  [2087] = {.count = 1, .reusable = false}, SHIFT(825),
  [2089] = {.count = 2, .reusable = true}, REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1), SHIFT(518),
  [2092] = {.count = 2, .reusable = false}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(540),
  [2095] = {.count = 1, .reusable = true}, SHIFT(827),
  [2097] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_list, 2),
  [2099] = {.count = 1, .reusable = false}, REDUCE(sym_initializer_list, 2),
  [2101] = {.count = 1, .reusable = true}, SHIFT(828),
  [2103] = {.count = 1, .reusable = false}, SHIFT(828),
  [2105] = {.count = 1, .reusable = true}, SHIFT(829),
  [2107] = {.count = 1, .reusable = true}, SHIFT(830),
  [2109] = {.count = 1, .reusable = true}, SHIFT(832),
  [2111] = {.count = 1, .reusable = true}, REDUCE(aux_sym_preproc_params_repeat1, 2),
  [2113] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_params, 4),
  [2115] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_params_repeat1, 2), SHIFT_REPEAT(304),
  [2118] = {.count = 1, .reusable = true}, SHIFT(834),
  [2120] = {.count = 1, .reusable = true}, SHIFT(835),
  [2122] = {.count = 1, .reusable = true}, SHIFT(836),
  [2124] = {.count = 1, .reusable = true}, SHIFT(837),
  [2126] = {.count = 1, .reusable = true}, SHIFT(838),
  [2128] = {.count = 1, .reusable = false}, SHIFT(839),
  [2130] = {.count = 1, .reusable = false}, SHIFT(840),
  [2132] = {.count = 1, .reusable = false}, SHIFT(841),
  [2134] = {.count = 1, .reusable = true}, SHIFT(842),
  [2136] = {.count = 1, .reusable = false}, SHIFT(842),
  [2138] = {.count = 1, .reusable = true}, SHIFT(844),
  [2140] = {.count = 1, .reusable = false}, SHIFT(844),
  [2142] = {.count = 1, .reusable = true}, SHIFT(846),
  [2144] = {.count = 1, .reusable = false}, SHIFT(846),
  [2146] = {.count = 1, .reusable = true}, SHIFT(848),
  [2148] = {.count = 1, .reusable = true}, SHIFT(849),
  [2150] = {.count = 1, .reusable = true}, SHIFT(851),
  [2152] = {.count = 1, .reusable = true}, SHIFT(853),
  [2154] = {.count = 1, .reusable = true}, SHIFT(855),
  [2156] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif, 4, .alias_sequence_id = 14),
  [2158] = {.count = 1, .reusable = true}, SHIFT(856),
  [2160] = {.count = 1, .reusable = true}, SHIFT(857),
  [2162] = {.count = 1, .reusable = true}, SHIFT(858),
  [2164] = {.count = 1, .reusable = true}, SHIFT(859),
  [2166] = {.count = 1, .reusable = true}, REDUCE(sym_array_type_declarator, 4),
  [2168] = {.count = 1, .reusable = true}, SHIFT(860),
  [2170] = {.count = 1, .reusable = true}, SHIFT(861),
  [2172] = {.count = 1, .reusable = true}, SHIFT(863),
  [2174] = {.count = 1, .reusable = true}, SHIFT(864),
  [2176] = {.count = 1, .reusable = false}, SHIFT(864),
  [2178] = {.count = 1, .reusable = true}, SHIFT(865),
  [2180] = {.count = 1, .reusable = false}, SHIFT(865),
  [2182] = {.count = 1, .reusable = true}, SHIFT(866),
  [2184] = {.count = 1, .reusable = false}, SHIFT(866),
  [2186] = {.count = 1, .reusable = true}, SHIFT(867),
  [2188] = {.count = 1, .reusable = false}, SHIFT(867),
  [2190] = {.count = 1, .reusable = true}, SHIFT(868),
  [2192] = {.count = 1, .reusable = false}, SHIFT(868),
  [2194] = {.count = 1, .reusable = true}, SHIFT(869),
  [2196] = {.count = 1, .reusable = false}, SHIFT(869),
  [2198] = {.count = 1, .reusable = true}, SHIFT(870),
  [2200] = {.count = 1, .reusable = false}, SHIFT(870),
  [2202] = {.count = 1, .reusable = true}, SHIFT(871),
  [2204] = {.count = 1, .reusable = false}, SHIFT(871),
  [2206] = {.count = 1, .reusable = true}, SHIFT(872),
  [2208] = {.count = 1, .reusable = false}, SHIFT(872),
  [2210] = {.count = 1, .reusable = true}, SHIFT(873),
  [2212] = {.count = 1, .reusable = false}, SHIFT(873),
  [2214] = {.count = 1, .reusable = true}, SHIFT(874),
  [2216] = {.count = 1, .reusable = false}, SHIFT(874),
  [2218] = {.count = 1, .reusable = true}, REDUCE(sym_enumerator_list, 5),
  [2220] = {.count = 1, .reusable = false}, REDUCE(sym_enumerator_list, 5),
  [2222] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_else_in_field_declaration_list, 2, .alias_sequence_id = 6),
  [2224] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 2, .alias_sequence_id = 14),
  [2226] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .alias_sequence_id = 22),
  [2228] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .alias_sequence_id = 22),
  [2230] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .alias_sequence_id = 23),
  [2232] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .alias_sequence_id = 23),
  [2234] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .alias_sequence_id = 15),
  [2236] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .alias_sequence_id = 15),
  [2238] = {.count = 1, .reusable = true}, SHIFT(879),
  [2240] = {.count = 1, .reusable = true}, SHIFT(880),
  [2242] = {.count = 1, .reusable = true}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2),
  [2244] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(10),
  [2247] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(11),
  [2250] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(127),
  [2253] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(125),
  [2256] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(12),
  [2259] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(13),
  [2262] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(14),
  [2265] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(15),
  [2268] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 24),
  [2270] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 24),
  [2272] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 25),
  [2274] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 25),
  [2276] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 16),
  [2278] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 16),
  [2280] = {.count = 1, .reusable = true}, SHIFT(881),
  [2282] = {.count = 1, .reusable = true}, SHIFT(882),
  [2284] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 26),
  [2286] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 26),
  [2288] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 27),
  [2290] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 27),
  [2292] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 17),
  [2294] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .alias_sequence_id = 17),
  [2296] = {.count = 1, .reusable = true}, SHIFT(883),
  [2298] = {.count = 1, .reusable = true}, SHIFT(884),
  [2300] = {.count = 1, .reusable = true}, REDUCE(sym__field_declarator, 3),
  [2302] = {.count = 1, .reusable = true}, SHIFT(885),
  [2304] = {.count = 1, .reusable = true}, SHIFT(887),
  [2306] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 4),
  [2308] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 4),
  [2310] = {.count = 1, .reusable = true}, SHIFT(888),
  [2312] = {.count = 1, .reusable = false}, SHIFT(888),
  [2314] = {.count = 1, .reusable = true}, SHIFT(889),
  [2316] = {.count = 1, .reusable = false}, SHIFT(889),
  [2318] = {.count = 1, .reusable = true}, SHIFT(890),
  [2320] = {.count = 1, .reusable = false}, SHIFT(890),
  [2322] = {.count = 1, .reusable = true}, SHIFT(891),
  [2324] = {.count = 1, .reusable = false}, SHIFT(891),
  [2326] = {.count = 1, .reusable = true}, SHIFT(892),
  [2328] = {.count = 1, .reusable = false}, SHIFT(892),
  [2330] = {.count = 1, .reusable = true}, SHIFT(893),
  [2332] = {.count = 1, .reusable = false}, SHIFT(893),
  [2334] = {.count = 1, .reusable = true}, SHIFT(894),
  [2336] = {.count = 1, .reusable = false}, SHIFT(894),
  [2338] = {.count = 1, .reusable = true}, SHIFT(895),
  [2340] = {.count = 1, .reusable = false}, SHIFT(895),
  [2342] = {.count = 1, .reusable = true}, SHIFT(896),
  [2344] = {.count = 1, .reusable = false}, SHIFT(896),
  [2346] = {.count = 1, .reusable = true}, SHIFT(897),
  [2348] = {.count = 1, .reusable = false}, SHIFT(897),
  [2350] = {.count = 1, .reusable = true}, SHIFT(898),
  [2352] = {.count = 1, .reusable = false}, SHIFT(898),
  [2354] = {.count = 1, .reusable = true}, REDUCE(aux_sym_field_declaration_repeat1, 2),
  [2356] = {.count = 1, .reusable = true}, REDUCE(sym_array_field_declarator, 3),
  [2358] = {.count = 1, .reusable = true}, SHIFT(899),
  [2360] = {.count = 1, .reusable = true}, SHIFT(900),
  [2362] = {.count = 1, .reusable = false}, SHIFT(900),
  [2364] = {.count = 1, .reusable = true}, SHIFT(901),
  [2366] = {.count = 1, .reusable = true}, SHIFT(902),
  [2368] = {.count = 1, .reusable = false}, SHIFT(902),
  [2370] = {.count = 2, .reusable = true}, REDUCE(aux_sym_field_declaration_repeat1, 2), SHIFT_REPEAT(400),
  [2373] = {.count = 1, .reusable = true}, REDUCE(sym__abstract_declarator, 3),
  [2375] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_array_declarator, 3),
  [2377] = {.count = 1, .reusable = true}, SHIFT(903),
  [2379] = {.count = 1, .reusable = true}, SHIFT(904),
  [2381] = {.count = 1, .reusable = false}, SHIFT(904),
  [2383] = {.count = 1, .reusable = true}, REDUCE(aux_sym_parameter_list_repeat1, 2),
  [2385] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_list, 4, .dynamic_precedence = 1),
  [2387] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameter_list_repeat1, 2), SHIFT_REPEAT(416),
  [2390] = {.count = 3, .reusable = true}, REDUCE(sym__declarator, 1), REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1), SHIFT(46),
  [2394] = {.count = 2, .reusable = true}, REDUCE(sym__declarator, 1), REDUCE(sym__type_specifier, 1, .alias_sequence_id = 1),
  [2397] = {.count = 1, .reusable = false}, SHIFT(905),
  [2399] = {.count = 1, .reusable = false}, SHIFT(906),
  [2401] = {.count = 1, .reusable = false}, SHIFT(907),
  [2403] = {.count = 1, .reusable = true}, SHIFT(908),
  [2405] = {.count = 1, .reusable = true}, SHIFT(910),
  [2407] = {.count = 1, .reusable = true}, SHIFT(911),
  [2409] = {.count = 1, .reusable = false}, SHIFT(911),
  [2411] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [2413] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [2415] = {.count = 1, .reusable = true}, SHIFT(912),
  [2417] = {.count = 1, .reusable = false}, SHIFT(912),
  [2419] = {.count = 1, .reusable = true}, SHIFT(913),
  [2421] = {.count = 1, .reusable = false}, SHIFT(913),
  [2423] = {.count = 1, .reusable = true}, SHIFT(914),
  [2425] = {.count = 1, .reusable = false}, SHIFT(914),
  [2427] = {.count = 1, .reusable = true}, SHIFT(915),
  [2429] = {.count = 1, .reusable = false}, SHIFT(915),
  [2431] = {.count = 1, .reusable = true}, SHIFT(916),
  [2433] = {.count = 1, .reusable = false}, SHIFT(916),
  [2435] = {.count = 1, .reusable = true}, SHIFT(917),
  [2437] = {.count = 1, .reusable = false}, SHIFT(917),
  [2439] = {.count = 1, .reusable = true}, SHIFT(918),
  [2441] = {.count = 1, .reusable = false}, SHIFT(918),
  [2443] = {.count = 1, .reusable = true}, SHIFT(919),
  [2445] = {.count = 1, .reusable = false}, SHIFT(919),
  [2447] = {.count = 1, .reusable = true}, SHIFT(920),
  [2449] = {.count = 1, .reusable = false}, SHIFT(920),
  [2451] = {.count = 1, .reusable = true}, SHIFT(921),
  [2453] = {.count = 1, .reusable = false}, SHIFT(921),
  [2455] = {.count = 1, .reusable = true}, SHIFT(922),
  [2457] = {.count = 1, .reusable = false}, SHIFT(922),
  [2459] = {.count = 1, .reusable = true}, SHIFT(923),
  [2461] = {.count = 1, .reusable = false}, SHIFT(923),
  [2463] = {.count = 1, .reusable = true}, SHIFT(925),
  [2465] = {.count = 1, .reusable = true}, SHIFT(926),
  [2467] = {.count = 1, .reusable = false}, SHIFT(927),
  [2469] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 3, .alias_sequence_id = 5),
  [2471] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 3, .alias_sequence_id = 5),
  [2473] = {.count = 1, .reusable = true}, SHIFT(928),
  [2475] = {.count = 1, .reusable = true}, SHIFT(929),
  [2477] = {.count = 1, .reusable = false}, SHIFT(930),
  [2479] = {.count = 1, .reusable = false}, SHIFT(931),
  [2481] = {.count = 1, .reusable = false}, SHIFT(932),
  [2483] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_else_in_compound_statement, 1, .alias_sequence_id = 6),
  [2485] = {.count = 1, .reusable = false}, SHIFT(933),
  [2487] = {.count = 1, .reusable = false}, SHIFT(934),
  [2489] = {.count = 1, .reusable = false}, SHIFT(935),
  [2491] = {.count = 1, .reusable = true}, SHIFT(936),
  [2493] = {.count = 1, .reusable = false}, SHIFT(937),
  [2495] = {.count = 1, .reusable = true}, SHIFT(938),
  [2497] = {.count = 1, .reusable = false}, SHIFT(939),
  [2499] = {.count = 1, .reusable = false}, SHIFT(940),
  [2501] = {.count = 1, .reusable = false}, SHIFT(941),
  [2503] = {.count = 1, .reusable = false}, SHIFT(942),
  [2505] = {.count = 1, .reusable = false}, SHIFT(943),
  [2507] = {.count = 1, .reusable = false}, SHIFT(944),
  [2509] = {.count = 1, .reusable = false}, SHIFT(945),
  [2511] = {.count = 1, .reusable = false}, SHIFT(946),
  [2513] = {.count = 1, .reusable = false}, SHIFT(947),
  [2515] = {.count = 1, .reusable = false}, SHIFT(948),
  [2517] = {.count = 1, .reusable = false}, SHIFT(949),
  [2519] = {.count = 1, .reusable = true}, SHIFT(954),
  [2521] = {.count = 1, .reusable = false}, SHIFT(954),
  [2523] = {.count = 1, .reusable = false}, SHIFT(950),
  [2525] = {.count = 1, .reusable = false}, SHIFT(957),
  [2527] = {.count = 1, .reusable = false}, SHIFT(958),
  [2529] = {.count = 1, .reusable = false}, SHIFT(959),
  [2531] = {.count = 1, .reusable = false}, SHIFT(960),
  [2533] = {.count = 1, .reusable = true}, SHIFT(962),
  [2535] = {.count = 1, .reusable = true}, SHIFT(964),
  [2537] = {.count = 1, .reusable = true}, SHIFT(965),
  [2539] = {.count = 1, .reusable = true}, SHIFT(966),
  [2541] = {.count = 1, .reusable = false}, SHIFT(966),
  [2543] = {.count = 1, .reusable = true}, SHIFT(967),
  [2545] = {.count = 1, .reusable = true}, SHIFT(968),
  [2547] = {.count = 1, .reusable = true}, SHIFT(970),
  [2549] = {.count = 1, .reusable = true}, SHIFT(971),
  [2551] = {.count = 1, .reusable = true}, SHIFT(972),
  [2553] = {.count = 1, .reusable = false}, SHIFT(972),
  [2555] = {.count = 1, .reusable = true}, SHIFT(973),
  [2557] = {.count = 1, .reusable = true}, SHIFT(974),
  [2559] = {.count = 1, .reusable = true}, SHIFT(975),
  [2561] = {.count = 1, .reusable = true}, SHIFT(976),
  [2563] = {.count = 1, .reusable = true}, SHIFT(977),
  [2565] = {.count = 1, .reusable = true}, SHIFT(978),
  [2567] = {.count = 1, .reusable = true}, SHIFT(979),
  [2569] = {.count = 1, .reusable = true}, SHIFT(980),
  [2571] = {.count = 1, .reusable = true}, SHIFT(982),
  [2573] = {.count = 1, .reusable = false}, SHIFT(983),
  [2575] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 3, .alias_sequence_id = 7),
  [2577] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 3, .alias_sequence_id = 7),
  [2579] = {.count = 1, .reusable = true}, SHIFT(987),
  [2581] = {.count = 1, .reusable = true}, SHIFT(988),
  [2583] = {.count = 1, .reusable = false}, SHIFT(989),
  [2585] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 3, .alias_sequence_id = 8),
  [2587] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 3, .alias_sequence_id = 8),
  [2589] = {.count = 1, .reusable = true}, SHIFT(992),
  [2591] = {.count = 1, .reusable = true}, SHIFT(993),
  [2593] = {.count = 1, .reusable = false}, SHIFT(994),
  [2595] = {.count = 1, .reusable = true}, SHIFT(997),
  [2597] = {.count = 1, .reusable = true}, SHIFT(998),
  [2599] = {.count = 1, .reusable = true}, SHIFT(1001),
  [2601] = {.count = 1, .reusable = true}, SHIFT(1002),
  [2603] = {.count = 1, .reusable = false}, SHIFT(1002),
  [2605] = {.count = 1, .reusable = true}, SHIFT(1003),
  [2607] = {.count = 1, .reusable = true}, SHIFT(1004),
  [2609] = {.count = 1, .reusable = false}, SHIFT(1005),
  [2611] = {.count = 1, .reusable = false}, SHIFT(1006),
  [2613] = {.count = 1, .reusable = true}, SHIFT(1007),
  [2615] = {.count = 1, .reusable = true}, SHIFT(1006),
  [2617] = {.count = 1, .reusable = false}, SHIFT(1008),
  [2619] = {.count = 1, .reusable = true}, SHIFT(1009),
  [2621] = {.count = 1, .reusable = true}, SHIFT(1010),
  [2623] = {.count = 1, .reusable = false}, SHIFT(1011),
  [2625] = {.count = 1, .reusable = false}, SHIFT(1012),
  [2627] = {.count = 1, .reusable = true}, SHIFT(1013),
  [2629] = {.count = 1, .reusable = false}, SHIFT(1014),
  [2631] = {.count = 1, .reusable = true}, SHIFT(1014),
  [2633] = {.count = 1, .reusable = false}, SHIFT(1015),
  [2635] = {.count = 1, .reusable = false}, SHIFT(1016),
  [2637] = {.count = 1, .reusable = true}, SHIFT(1017),
  [2639] = {.count = 1, .reusable = true}, SHIFT(1018),
  [2641] = {.count = 1, .reusable = true}, SHIFT(1020),
  [2643] = {.count = 1, .reusable = true}, SHIFT(1021),
  [2645] = {.count = 1, .reusable = false}, SHIFT(1021),
  [2647] = {.count = 1, .reusable = true}, SHIFT(1023),
  [2649] = {.count = 1, .reusable = false}, SHIFT(1023),
  [2651] = {.count = 1, .reusable = true}, SHIFT(1024),
  [2653] = {.count = 1, .reusable = false}, SHIFT(1024),
  [2655] = {.count = 1, .reusable = true}, SHIFT(1025),
  [2657] = {.count = 1, .reusable = false}, SHIFT(1025),
  [2659] = {.count = 1, .reusable = true}, SHIFT(1026),
  [2661] = {.count = 1, .reusable = false}, SHIFT(1026),
  [2663] = {.count = 1, .reusable = true}, SHIFT(1027),
  [2665] = {.count = 1, .reusable = false}, SHIFT(1027),
  [2667] = {.count = 1, .reusable = true}, SHIFT(1028),
  [2669] = {.count = 1, .reusable = false}, SHIFT(1028),
  [2671] = {.count = 1, .reusable = true}, SHIFT(1029),
  [2673] = {.count = 1, .reusable = false}, SHIFT(1029),
  [2675] = {.count = 1, .reusable = true}, SHIFT(1030),
  [2677] = {.count = 1, .reusable = false}, SHIFT(1030),
  [2679] = {.count = 1, .reusable = true}, SHIFT(1031),
  [2681] = {.count = 1, .reusable = false}, SHIFT(1031),
  [2683] = {.count = 1, .reusable = true}, SHIFT(1032),
  [2685] = {.count = 1, .reusable = false}, SHIFT(1032),
  [2687] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 3),
  [2689] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 3),
  [2691] = {.count = 1, .reusable = true}, SHIFT(1033),
  [2693] = {.count = 1, .reusable = true}, SHIFT(1034),
  [2695] = {.count = 1, .reusable = false}, SHIFT(1034),
  [2697] = {.count = 1, .reusable = true}, SHIFT(1035),
  [2699] = {.count = 1, .reusable = false}, SHIFT(1035),
  [2701] = {.count = 1, .reusable = true}, SHIFT(1036),
  [2703] = {.count = 1, .reusable = false}, SHIFT(1037),
  [2705] = {.count = 1, .reusable = true}, SHIFT(1038),
  [2707] = {.count = 1, .reusable = false}, SHIFT(1038),
  [2709] = {.count = 1, .reusable = true}, SHIFT(1039),
  [2711] = {.count = 1, .reusable = true}, SHIFT(1040),
  [2713] = {.count = 1, .reusable = false}, SHIFT(1040),
  [2715] = {.count = 1, .reusable = true}, SHIFT(1041),
  [2717] = {.count = 1, .reusable = true}, SHIFT(1042),
  [2719] = {.count = 1, .reusable = true}, SHIFT(1043),
  [2721] = {.count = 1, .reusable = false}, SHIFT(1043),
  [2723] = {.count = 1, .reusable = true}, SHIFT(1044),
  [2725] = {.count = 1, .reusable = true}, SHIFT(1046),
  [2727] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 3),
  [2729] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 3),
  [2731] = {.count = 1, .reusable = false}, REDUCE(sym_goto_statement, 3, .alias_sequence_id = 28),
  [2733] = {.count = 1, .reusable = true}, REDUCE(sym_goto_statement, 3, .alias_sequence_id = 28),
  [2735] = {.count = 1, .reusable = true}, SHIFT(1047),
  [2737] = {.count = 1, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [2739] = {.count = 1, .reusable = false}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [2741] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(778),
  [2744] = {.count = 1, .reusable = false}, REDUCE(sym_labeled_statement, 3, .alias_sequence_id = 29),
  [2746] = {.count = 1, .reusable = true}, REDUCE(sym_labeled_statement, 3, .alias_sequence_id = 29),
  [2748] = {.count = 1, .reusable = true}, SHIFT(1048),
  [2750] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 2, .dynamic_precedence = 1),
  [2752] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 2, .dynamic_precedence = 1),
  [2754] = {.count = 1, .reusable = true}, SHIFT(1049),
  [2756] = {.count = 1, .reusable = true}, SHIFT(1050),
  [2758] = {.count = 1, .reusable = true}, REDUCE(sym_comma_expression, 3),
  [2760] = {.count = 1, .reusable = true}, REDUCE(sym_math_expression, 3),
  [2762] = {.count = 1, .reusable = false}, REDUCE(sym_math_expression, 3),
  [2764] = {.count = 1, .reusable = true}, SHIFT(1052),
  [2766] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3),
  [2768] = {.count = 1, .reusable = true}, SHIFT(1053),
  [2770] = {.count = 1, .reusable = true}, REDUCE(sym_bitwise_expression, 3),
  [2772] = {.count = 1, .reusable = false}, REDUCE(sym_bitwise_expression, 3),
  [2774] = {.count = 1, .reusable = true}, REDUCE(sym_logical_expression, 3),
  [2776] = {.count = 1, .reusable = false}, REDUCE(sym_logical_expression, 3),
  [2778] = {.count = 1, .reusable = true}, REDUCE(sym_equality_expression, 3),
  [2780] = {.count = 1, .reusable = false}, REDUCE(sym_equality_expression, 3),
  [2782] = {.count = 1, .reusable = true}, REDUCE(sym_relational_expression, 3),
  [2784] = {.count = 1, .reusable = false}, REDUCE(sym_relational_expression, 3),
  [2786] = {.count = 1, .reusable = true}, REDUCE(sym_shift_expression, 3),
  [2788] = {.count = 1, .reusable = false}, REDUCE(sym_shift_expression, 3),
  [2790] = {.count = 1, .reusable = true}, REDUCE(sym_field_expression, 3, .alias_sequence_id = 30),
  [2792] = {.count = 1, .reusable = false}, REDUCE(sym_field_expression, 3, .alias_sequence_id = 30),
  [2794] = {.count = 1, .reusable = true}, SHIFT(1054),
  [2796] = {.count = 1, .reusable = true}, SHIFT(1055),
  [2798] = {.count = 1, .reusable = true}, SHIFT(1057),
  [2800] = {.count = 1, .reusable = true}, SHIFT(1058),
  [2802] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(811),
  [2805] = {.count = 1, .reusable = true}, SHIFT(1059),
  [2807] = {.count = 1, .reusable = true}, REDUCE(sym_array_declarator, 5),
  [2809] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(521),
  [2812] = {.count = 2, .reusable = false}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(522),
  [2815] = {.count = 1, .reusable = true}, SHIFT(1060),
  [2817] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_list, 3),
  [2819] = {.count = 1, .reusable = false}, REDUCE(sym_initializer_list, 3),
  [2821] = {.count = 1, .reusable = true}, SHIFT(1061),
  [2823] = {.count = 1, .reusable = true}, REDUCE(sym_field_designator, 2, .alias_sequence_id = 31),
  [2825] = {.count = 1, .reusable = true}, SHIFT(1062),
  [2827] = {.count = 1, .reusable = true}, SHIFT(1063),
  [2829] = {.count = 1, .reusable = false}, SHIFT(1063),
  [2831] = {.count = 1, .reusable = true}, SHIFT(1065),
  [2833] = {.count = 1, .reusable = true}, SHIFT(1067),
  [2835] = {.count = 1, .reusable = false}, SHIFT(1067),
  [2837] = {.count = 2, .reusable = true}, REDUCE(aux_sym_initializer_pair_repeat1, 2), SHIFT_REPEAT(543),
  [2840] = {.count = 1, .reusable = true}, REDUCE(aux_sym_initializer_pair_repeat1, 2),
  [2842] = {.count = 2, .reusable = true}, REDUCE(aux_sym_initializer_pair_repeat1, 2), SHIFT_REPEAT(544),
  [2845] = {.count = 1, .reusable = true}, SHIFT(1069),
  [2847] = {.count = 1, .reusable = true}, SHIFT(1070),
  [2849] = {.count = 1, .reusable = true}, SHIFT(1071),
  [2851] = {.count = 1, .reusable = true}, SHIFT(1072),
  [2853] = {.count = 1, .reusable = true}, SHIFT(1073),
  [2855] = {.count = 1, .reusable = true}, SHIFT(1074),
  [2857] = {.count = 1, .reusable = true}, SHIFT(1075),
  [2859] = {.count = 1, .reusable = true}, SHIFT(1076),
  [2861] = {.count = 1, .reusable = true}, REDUCE(sym_array_type_declarator, 5),
  [2863] = {.count = 1, .reusable = true}, SHIFT(1077),
  [2865] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(863),
  [2868] = {.count = 1, .reusable = true}, SHIFT(1078),
  [2870] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3, .alias_sequence_id = 32),
  [2872] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3, .alias_sequence_id = 33),
  [2874] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3, .alias_sequence_id = 14),
  [2876] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .alias_sequence_id = 34),
  [2878] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .alias_sequence_id = 34),
  [2880] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .alias_sequence_id = 35),
  [2882] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .alias_sequence_id = 35),
  [2884] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 36),
  [2886] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 36),
  [2888] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 37),
  [2890] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 37),
  [2892] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 38),
  [2894] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 38),
  [2896] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 39),
  [2898] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .alias_sequence_id = 39),
  [2900] = {.count = 1, .reusable = true}, SHIFT(1081),
  [2902] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(887),
  [2905] = {.count = 1, .reusable = true}, SHIFT(1082),
  [2907] = {.count = 1, .reusable = true}, REDUCE(sym_array_field_declarator, 4),
  [2909] = {.count = 1, .reusable = true}, SHIFT(1083),
  [2911] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 5),
  [2913] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 5),
  [2915] = {.count = 1, .reusable = true}, SHIFT(1084),
  [2917] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_array_declarator, 4),
  [2919] = {.count = 1, .reusable = true}, SHIFT(1085),
  [2921] = {.count = 1, .reusable = true}, SHIFT(1086),
  [2923] = {.count = 1, .reusable = true}, SHIFT(1087),
  [2925] = {.count = 1, .reusable = true}, SHIFT(1088),
  [2927] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(910),
  [2930] = {.count = 1, .reusable = true}, SHIFT(1089),
  [2932] = {.count = 1, .reusable = true}, REDUCE(sym_cast_expression, 4),
  [2934] = {.count = 1, .reusable = false}, REDUCE(sym_cast_expression, 4),
  [2936] = {.count = 1, .reusable = true}, REDUCE(sym_compound_literal_expression, 4),
  [2938] = {.count = 1, .reusable = false}, REDUCE(sym_compound_literal_expression, 4),
  [2940] = {.count = 1, .reusable = false}, SHIFT(1090),
  [2942] = {.count = 1, .reusable = false}, SHIFT(1091),
  [2944] = {.count = 1, .reusable = false}, SHIFT(1093),
  [2946] = {.count = 1, .reusable = false}, SHIFT(1097),
  [2948] = {.count = 1, .reusable = false}, SHIFT(1101),
  [2950] = {.count = 1, .reusable = true}, SHIFT(1105),
  [2952] = {.count = 1, .reusable = true}, SHIFT(1106),
  [2954] = {.count = 1, .reusable = false}, SHIFT(1107),
  [2956] = {.count = 1, .reusable = true}, SHIFT(1108),
  [2958] = {.count = 1, .reusable = true}, SHIFT(1109),
  [2960] = {.count = 1, .reusable = false}, SHIFT(1110),
  [2962] = {.count = 1, .reusable = false}, SHIFT(1111),
  [2964] = {.count = 1, .reusable = false}, SHIFT(1112),
  [2966] = {.count = 1, .reusable = true}, SHIFT(1114),
  [2968] = {.count = 1, .reusable = true}, SHIFT(1116),
  [2970] = {.count = 1, .reusable = true}, SHIFT(1117),
  [2972] = {.count = 1, .reusable = true}, SHIFT(1118),
  [2974] = {.count = 1, .reusable = false}, SHIFT(1118),
  [2976] = {.count = 1, .reusable = true}, SHIFT(1119),
  [2978] = {.count = 1, .reusable = true}, SHIFT(1120),
  [2980] = {.count = 1, .reusable = true}, SHIFT(1122),
  [2982] = {.count = 1, .reusable = true}, SHIFT(1123),
  [2984] = {.count = 1, .reusable = true}, SHIFT(1124),
  [2986] = {.count = 1, .reusable = false}, SHIFT(1124),
  [2988] = {.count = 1, .reusable = true}, SHIFT(1125),
  [2990] = {.count = 1, .reusable = true}, SHIFT(1126),
  [2992] = {.count = 1, .reusable = true}, SHIFT(1127),
  [2994] = {.count = 1, .reusable = true}, SHIFT(1128),
  [2996] = {.count = 1, .reusable = true}, SHIFT(1129),
  [2998] = {.count = 1, .reusable = true}, SHIFT(1130),
  [3000] = {.count = 1, .reusable = true}, SHIFT(1132),
  [3002] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_else_in_compound_statement, 2, .alias_sequence_id = 6),
  [3004] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_elif_in_compound_statement, 2, .alias_sequence_id = 14),
  [3006] = {.count = 1, .reusable = false}, SHIFT(1137),
  [3008] = {.count = 1, .reusable = false}, SHIFT(1139),
  [3010] = {.count = 1, .reusable = true}, SHIFT(1140),
  [3012] = {.count = 1, .reusable = true}, SHIFT(1141),
  [3014] = {.count = 1, .reusable = false}, SHIFT(1141),
  [3016] = {.count = 1, .reusable = true}, SHIFT(1142),
  [3018] = {.count = 1, .reusable = false}, SHIFT(1142),
  [3020] = {.count = 1, .reusable = true}, SHIFT(1143),
  [3022] = {.count = 1, .reusable = false}, SHIFT(1144),
  [3024] = {.count = 1, .reusable = true}, SHIFT(1147),
  [3026] = {.count = 1, .reusable = false}, SHIFT(1147),
  [3028] = {.count = 1, .reusable = true}, SHIFT(1148),
  [3030] = {.count = 1, .reusable = true}, SHIFT(1149),
  [3032] = {.count = 1, .reusable = true}, SHIFT(1150),
  [3034] = {.count = 1, .reusable = false}, SHIFT(1150),
  [3036] = {.count = 1, .reusable = true}, SHIFT(1151),
  [3038] = {.count = 1, .reusable = true}, SHIFT(1152),
  [3040] = {.count = 1, .reusable = false}, SHIFT(1153),
  [3042] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 4, .alias_sequence_id = 22),
  [3044] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 4, .alias_sequence_id = 22),
  [3046] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 4, .alias_sequence_id = 23),
  [3048] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 4, .alias_sequence_id = 23),
  [3050] = {.count = 1, .reusable = true}, SHIFT(1155),
  [3052] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 4, .alias_sequence_id = 15),
  [3054] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 4, .alias_sequence_id = 15),
  [3056] = {.count = 1, .reusable = true}, SHIFT(1157),
  [3058] = {.count = 1, .reusable = true}, SHIFT(1158),
  [3060] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(689),
  [3063] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(690),
  [3066] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(691),
  [3069] = {.count = 1, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2),
  [3071] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(693),
  [3074] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(694),
  [3077] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(697),
  [3080] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(698),
  [3083] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(699),
  [3086] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(700),
  [3089] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(701),
  [3092] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(702),
  [3095] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(703),
  [3098] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(704),
  [3101] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(705),
  [3104] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(706),
  [3107] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(707),
  [3110] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(708),
  [3113] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(709),
  [3116] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(710),
  [3119] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(711),
  [3122] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(718),
  [3125] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(718),
  [3128] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(712),
  [3131] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 24),
  [3133] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 24),
  [3135] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 25),
  [3137] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 25),
  [3139] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 16),
  [3141] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 16),
  [3143] = {.count = 1, .reusable = true}, SHIFT(1159),
  [3145] = {.count = 1, .reusable = true}, SHIFT(1160),
  [3147] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 26),
  [3149] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 26),
  [3151] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 27),
  [3153] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 27),
  [3155] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 17),
  [3157] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 4, .alias_sequence_id = 17),
  [3159] = {.count = 1, .reusable = true}, SHIFT(1161),
  [3161] = {.count = 1, .reusable = true}, SHIFT(1162),
  [3163] = {.count = 1, .reusable = true}, SHIFT(1163),
  [3165] = {.count = 1, .reusable = true}, SHIFT(1164),
  [3167] = {.count = 1, .reusable = true}, SHIFT(1166),
  [3169] = {.count = 1, .reusable = true}, SHIFT(1167),
  [3171] = {.count = 1, .reusable = true}, SHIFT(1168),
  [3173] = {.count = 1, .reusable = false}, SHIFT(1169),
  [3175] = {.count = 1, .reusable = false}, SHIFT(1170),
  [3177] = {.count = 1, .reusable = false}, SHIFT(1171),
  [3179] = {.count = 1, .reusable = false}, SHIFT(1172),
  [3181] = {.count = 1, .reusable = false}, SHIFT(1173),
  [3183] = {.count = 1, .reusable = false}, SHIFT(1174),
  [3185] = {.count = 1, .reusable = false}, SHIFT(1175),
  [3187] = {.count = 1, .reusable = false}, SHIFT(1176),
  [3189] = {.count = 1, .reusable = false}, SHIFT(1177),
  [3191] = {.count = 1, .reusable = false}, SHIFT(1178),
  [3193] = {.count = 1, .reusable = false}, SHIFT(1179),
  [3195] = {.count = 1, .reusable = true}, SHIFT(1182),
  [3197] = {.count = 1, .reusable = false}, SHIFT(1182),
  [3199] = {.count = 1, .reusable = false}, SHIFT(1180),
  [3201] = {.count = 1, .reusable = true}, SHIFT(1184),
  [3203] = {.count = 1, .reusable = false}, SHIFT(1184),
  [3205] = {.count = 1, .reusable = true}, SHIFT(1185),
  [3207] = {.count = 1, .reusable = false}, SHIFT(1185),
  [3209] = {.count = 1, .reusable = true}, SHIFT(1186),
  [3211] = {.count = 1, .reusable = false}, SHIFT(1186),
  [3213] = {.count = 1, .reusable = true}, SHIFT(1187),
  [3215] = {.count = 1, .reusable = false}, SHIFT(1187),
  [3217] = {.count = 1, .reusable = true}, SHIFT(1188),
  [3219] = {.count = 1, .reusable = false}, SHIFT(1188),
  [3221] = {.count = 1, .reusable = true}, SHIFT(1189),
  [3223] = {.count = 1, .reusable = false}, SHIFT(1189),
  [3225] = {.count = 1, .reusable = true}, SHIFT(1190),
  [3227] = {.count = 1, .reusable = false}, SHIFT(1190),
  [3229] = {.count = 1, .reusable = true}, SHIFT(1191),
  [3231] = {.count = 1, .reusable = false}, SHIFT(1191),
  [3233] = {.count = 1, .reusable = true}, SHIFT(1192),
  [3235] = {.count = 1, .reusable = false}, SHIFT(1192),
  [3237] = {.count = 1, .reusable = true}, SHIFT(1193),
  [3239] = {.count = 1, .reusable = false}, SHIFT(1193),
  [3241] = {.count = 1, .reusable = true}, SHIFT(1194),
  [3243] = {.count = 1, .reusable = false}, SHIFT(1194),
  [3245] = {.count = 1, .reusable = true}, SHIFT(1196),
  [3247] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1020),
  [3250] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 4),
  [3252] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 4),
  [3254] = {.count = 1, .reusable = true}, SHIFT(1197),
  [3256] = {.count = 1, .reusable = true}, SHIFT(1199),
  [3258] = {.count = 1, .reusable = true}, SHIFT(1200),
  [3260] = {.count = 1, .reusable = true}, SHIFT(1201),
  [3262] = {.count = 1, .reusable = true}, SHIFT(1202),
  [3264] = {.count = 1, .reusable = true}, SHIFT(1203),
  [3266] = {.count = 1, .reusable = false}, SHIFT(1203),
  [3268] = {.count = 1, .reusable = true}, SHIFT(1204),
  [3270] = {.count = 1, .reusable = true}, SHIFT(1205),
  [3272] = {.count = 1, .reusable = false}, SHIFT(1205),
  [3274] = {.count = 1, .reusable = true}, SHIFT(1206),
  [3276] = {.count = 1, .reusable = true}, SHIFT(1207),
  [3278] = {.count = 1, .reusable = false}, SHIFT(1207),
  [3280] = {.count = 1, .reusable = true}, SHIFT(1208),
  [3282] = {.count = 1, .reusable = true}, SHIFT(1209),
  [3284] = {.count = 1, .reusable = true}, SHIFT(1211),
  [3286] = {.count = 1, .reusable = false}, SHIFT(1211),
  [3288] = {.count = 1, .reusable = true}, REDUCE(sym_sizeof_expression, 4),
  [3290] = {.count = 1, .reusable = false}, SHIFT(257),
  [3292] = {.count = 1, .reusable = false}, REDUCE(sym_sizeof_expression, 4),
  [3294] = {.count = 1, .reusable = false}, SHIFT(269),
  [3296] = {.count = 1, .reusable = true}, SHIFT(1212),
  [3298] = {.count = 1, .reusable = false}, SHIFT(1212),
  [3300] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 3, .dynamic_precedence = 1),
  [3302] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 3, .dynamic_precedence = 1),
  [3304] = {.count = 1, .reusable = true}, SHIFT(1213),
  [3306] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_expression, 4),
  [3308] = {.count = 1, .reusable = false}, REDUCE(sym_subscript_expression, 4),
  [3310] = {.count = 1, .reusable = true}, SHIFT(1215),
  [3312] = {.count = 1, .reusable = false}, SHIFT(1215),
  [3314] = {.count = 1, .reusable = true}, SHIFT(1216),
  [3316] = {.count = 1, .reusable = true}, SHIFT(1217),
  [3318] = {.count = 1, .reusable = false}, SHIFT(282),
  [3320] = {.count = 1, .reusable = false}, SHIFT(287),
  [3322] = {.count = 1, .reusable = true}, SHIFT(1218),
  [3324] = {.count = 1, .reusable = false}, SHIFT(1218),
  [3326] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_designator, 3),
  [3328] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_list, 4),
  [3330] = {.count = 1, .reusable = false}, REDUCE(sym_initializer_list, 4),
  [3332] = {.count = 1, .reusable = true}, REDUCE(aux_sym_initializer_list_repeat1, 2),
  [3334] = {.count = 1, .reusable = true}, SHIFT(1219),
  [3336] = {.count = 2, .reusable = true}, REDUCE(aux_sym_initializer_list_repeat1, 2), SHIFT_REPEAT(1220),
  [3339] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_pair, 3),
  [3341] = {.count = 1, .reusable = false}, SHIFT(364),
  [3343] = {.count = 1, .reusable = false}, SHIFT(365),
  [3345] = {.count = 1, .reusable = true}, SHIFT(1221),
  [3347] = {.count = 1, .reusable = false}, SHIFT(1221),
  [3349] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, .alias_sequence_id = 40),
  [3351] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, .alias_sequence_id = 41),
  [3353] = {.count = 1, .reusable = false}, SHIFT(393),
  [3355] = {.count = 1, .reusable = false}, SHIFT(394),
  [3357] = {.count = 1, .reusable = true}, SHIFT(1222),
  [3359] = {.count = 1, .reusable = false}, SHIFT(1222),
  [3361] = {.count = 1, .reusable = true}, REDUCE(sym_array_field_declarator, 5),
  [3363] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 6),
  [3365] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 6),
  [3367] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_array_declarator, 5),
  [3369] = {.count = 1, .reusable = false}, SHIFT(429),
  [3371] = {.count = 1, .reusable = false}, SHIFT(430),
  [3373] = {.count = 1, .reusable = true}, SHIFT(1223),
  [3375] = {.count = 1, .reusable = false}, SHIFT(1223),
  [3377] = {.count = 1, .reusable = false}, SHIFT(1224),
  [3379] = {.count = 1, .reusable = false}, SHIFT(1225),
  [3381] = {.count = 1, .reusable = false}, SHIFT(1226),
  [3383] = {.count = 1, .reusable = true}, SHIFT(1227),
  [3385] = {.count = 1, .reusable = true}, SHIFT(1228),
  [3387] = {.count = 1, .reusable = false}, SHIFT(1229),
  [3389] = {.count = 1, .reusable = true}, SHIFT(1232),
  [3391] = {.count = 1, .reusable = true}, SHIFT(1233),
  [3393] = {.count = 1, .reusable = false}, SHIFT(1234),
  [3395] = {.count = 1, .reusable = true}, SHIFT(1237),
  [3397] = {.count = 1, .reusable = true}, SHIFT(1238),
  [3399] = {.count = 1, .reusable = false}, SHIFT(1239),
  [3401] = {.count = 1, .reusable = false}, SHIFT(1242),
  [3403] = {.count = 1, .reusable = false}, SHIFT(1243),
  [3405] = {.count = 1, .reusable = false}, SHIFT(1245),
  [3407] = {.count = 1, .reusable = false}, SHIFT(1249),
  [3409] = {.count = 1, .reusable = false}, SHIFT(1253),
  [3411] = {.count = 1, .reusable = false}, SHIFT(1257),
  [3413] = {.count = 1, .reusable = false}, SHIFT(1259),
  [3415] = {.count = 1, .reusable = true}, SHIFT(1260),
  [3417] = {.count = 1, .reusable = true}, SHIFT(1261),
  [3419] = {.count = 1, .reusable = false}, SHIFT(1261),
  [3421] = {.count = 1, .reusable = true}, SHIFT(1262),
  [3423] = {.count = 1, .reusable = false}, SHIFT(1262),
  [3425] = {.count = 1, .reusable = true}, SHIFT(1263),
  [3427] = {.count = 1, .reusable = false}, SHIFT(1264),
  [3429] = {.count = 1, .reusable = true}, SHIFT(1267),
  [3431] = {.count = 1, .reusable = false}, SHIFT(1267),
  [3433] = {.count = 1, .reusable = true}, SHIFT(1268),
  [3435] = {.count = 1, .reusable = true}, SHIFT(1269),
  [3437] = {.count = 1, .reusable = true}, SHIFT(1270),
  [3439] = {.count = 1, .reusable = false}, SHIFT(1270),
  [3441] = {.count = 1, .reusable = true}, SHIFT(1271),
  [3443] = {.count = 1, .reusable = true}, SHIFT(1272),
  [3445] = {.count = 1, .reusable = false}, SHIFT(1273),
  [3447] = {.count = 1, .reusable = true}, SHIFT(1275),
  [3449] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(930),
  [3452] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(931),
  [3455] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(932),
  [3458] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(933),
  [3461] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(934),
  [3464] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(935),
  [3467] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(936),
  [3470] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(937),
  [3473] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(938),
  [3476] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(939),
  [3479] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(940),
  [3482] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(941),
  [3485] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(942),
  [3488] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(943),
  [3491] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(944),
  [3494] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(945),
  [3497] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(946),
  [3500] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(947),
  [3503] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(948),
  [3506] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(949),
  [3509] = {.count = 2, .reusable = true}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(954),
  [3512] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(954),
  [3515] = {.count = 2, .reusable = false}, REDUCE(aux_sym_preproc_if_in_compound_statement_repeat1, 2), SHIFT_REPEAT(950),
  [3518] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_compound_statement, 3, .alias_sequence_id = 32),
  [3520] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_compound_statement, 3, .alias_sequence_id = 33),
  [3522] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_elif_in_compound_statement, 3, .alias_sequence_id = 14),
  [3524] = {.count = 1, .reusable = true}, SHIFT(1279),
  [3526] = {.count = 1, .reusable = true}, SHIFT(1280),
  [3528] = {.count = 1, .reusable = true}, SHIFT(1282),
  [3530] = {.count = 1, .reusable = true}, SHIFT(1283),
  [3532] = {.count = 1, .reusable = true}, SHIFT(1285),
  [3534] = {.count = 1, .reusable = true}, SHIFT(1286),
  [3536] = {.count = 1, .reusable = true}, SHIFT(1287),
  [3538] = {.count = 1, .reusable = true}, SHIFT(1288),
  [3540] = {.count = 1, .reusable = false}, SHIFT(1288),
  [3542] = {.count = 1, .reusable = true}, SHIFT(1289),
  [3544] = {.count = 1, .reusable = true}, SHIFT(1290),
  [3546] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 5, .alias_sequence_id = 34),
  [3548] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 5, .alias_sequence_id = 34),
  [3550] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_if_in_compound_statement, 5, .alias_sequence_id = 35),
  [3552] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_if_in_compound_statement, 5, .alias_sequence_id = 35),
  [3554] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 36),
  [3556] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 36),
  [3558] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 37),
  [3560] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 37),
  [3562] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 38),
  [3564] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 38),
  [3566] = {.count = 1, .reusable = false}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 39),
  [3568] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_ifdef_in_compound_statement, 5, .alias_sequence_id = 39),
  [3570] = {.count = 1, .reusable = true}, SHIFT(1291),
  [3572] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1166),
  [3575] = {.count = 1, .reusable = true}, SHIFT(1292),
  [3577] = {.count = 1, .reusable = true}, SHIFT(1294),
  [3579] = {.count = 1, .reusable = true}, SHIFT(1295),
  [3581] = {.count = 1, .reusable = true}, SHIFT(1296),
  [3583] = {.count = 1, .reusable = false}, SHIFT(1296),
  [3585] = {.count = 1, .reusable = true}, SHIFT(1297),
  [3587] = {.count = 1, .reusable = true}, SHIFT(1298),
  [3589] = {.count = 1, .reusable = true}, SHIFT(1300),
  [3591] = {.count = 1, .reusable = true}, SHIFT(1301),
  [3593] = {.count = 1, .reusable = true}, SHIFT(1302),
  [3595] = {.count = 1, .reusable = false}, SHIFT(1302),
  [3597] = {.count = 1, .reusable = true}, SHIFT(1303),
  [3599] = {.count = 1, .reusable = true}, SHIFT(1304),
  [3601] = {.count = 1, .reusable = true}, SHIFT(1305),
  [3603] = {.count = 1, .reusable = true}, SHIFT(1306),
  [3605] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [3607] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [3609] = {.count = 1, .reusable = false}, SHIFT(1307),
  [3611] = {.count = 1, .reusable = true}, SHIFT(1308),
  [3613] = {.count = 1, .reusable = true}, SHIFT(1309),
  [3615] = {.count = 1, .reusable = false}, REDUCE(sym_switch_statement, 5),
  [3617] = {.count = 1, .reusable = true}, REDUCE(sym_switch_statement, 5),
  [3619] = {.count = 1, .reusable = false}, SHIFT(452),
  [3621] = {.count = 1, .reusable = false}, SHIFT(453),
  [3623] = {.count = 1, .reusable = true}, SHIFT(1310),
  [3625] = {.count = 1, .reusable = false}, SHIFT(1310),
  [3627] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 5),
  [3629] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 5),
  [3631] = {.count = 1, .reusable = false}, SHIFT(1311),
  [3633] = {.count = 1, .reusable = false}, SHIFT(1312),
  [3635] = {.count = 1, .reusable = false}, SHIFT(1313),
  [3637] = {.count = 1, .reusable = false}, SHIFT(1314),
  [3639] = {.count = 1, .reusable = false}, SHIFT(1315),
  [3641] = {.count = 1, .reusable = false}, SHIFT(1316),
  [3643] = {.count = 1, .reusable = false}, SHIFT(1317),
  [3645] = {.count = 1, .reusable = true}, SHIFT(1319),
  [3647] = {.count = 1, .reusable = true}, SHIFT(1320),
  [3649] = {.count = 1, .reusable = false}, SHIFT(1320),
  [3651] = {.count = 1, .reusable = true}, SHIFT(1321),
  [3653] = {.count = 1, .reusable = true}, SHIFT(1322),
  [3655] = {.count = 1, .reusable = false}, SHIFT(1322),
  [3657] = {.count = 1, .reusable = true}, SHIFT(1323),
  [3659] = {.count = 1, .reusable = true}, SHIFT(1325),
  [3661] = {.count = 1, .reusable = true}, SHIFT(1327),
  [3663] = {.count = 1, .reusable = false}, SHIFT(1327),
  [3665] = {.count = 1, .reusable = true}, SHIFT(1328),
  [3667] = {.count = 1, .reusable = true}, SHIFT(1329),
  [3669] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [3671] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 4, .dynamic_precedence = 1),
  [3673] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 4, .dynamic_precedence = 1),
  [3675] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(1049),
  [3678] = {.count = 1, .reusable = true}, REDUCE(sym_conditional_expression, 5),
  [3680] = {.count = 1, .reusable = true}, SHIFT(1330),
  [3682] = {.count = 1, .reusable = true}, REDUCE(sym_initializer_list, 5),
  [3684] = {.count = 1, .reusable = false}, REDUCE(sym_initializer_list, 5),
  [3686] = {.count = 1, .reusable = true}, SHIFT(1331),
  [3688] = {.count = 1, .reusable = true}, SHIFT(1332),
  [3690] = {.count = 1, .reusable = true}, SHIFT(1333),
  [3692] = {.count = 1, .reusable = true}, SHIFT(1334),
  [3694] = {.count = 1, .reusable = true}, SHIFT(1335),
  [3696] = {.count = 1, .reusable = true}, SHIFT(1336),
  [3698] = {.count = 1, .reusable = true}, SHIFT(1337),
  [3700] = {.count = 1, .reusable = true}, SHIFT(1338),
  [3702] = {.count = 1, .reusable = false}, SHIFT(1339),
  [3704] = {.count = 1, .reusable = false}, SHIFT(1340),
  [3706] = {.count = 1, .reusable = false}, SHIFT(1341),
  [3708] = {.count = 1, .reusable = true}, SHIFT(1342),
  [3710] = {.count = 1, .reusable = true}, SHIFT(1343),
  [3712] = {.count = 1, .reusable = false}, SHIFT(1344),
  [3714] = {.count = 1, .reusable = true}, SHIFT(1347),
  [3716] = {.count = 1, .reusable = true}, SHIFT(1348),
  [3718] = {.count = 1, .reusable = false}, SHIFT(1349),
  [3720] = {.count = 1, .reusable = true}, SHIFT(1352),
  [3722] = {.count = 1, .reusable = true}, SHIFT(1353),
  [3724] = {.count = 1, .reusable = false}, SHIFT(1354),
  [3726] = {.count = 1, .reusable = true}, SHIFT(1357),
  [3728] = {.count = 1, .reusable = true}, SHIFT(1358),
  [3730] = {.count = 1, .reusable = true}, SHIFT(1360),
  [3732] = {.count = 1, .reusable = true}, SHIFT(1361),
  [3734] = {.count = 1, .reusable = true}, SHIFT(1363),
  [3736] = {.count = 1, .reusable = true}, SHIFT(1364),
  [3738] = {.count = 1, .reusable = true}, SHIFT(1365),
  [3740] = {.count = 1, .reusable = true}, SHIFT(1366),
  [3742] = {.count = 1, .reusable = false}, SHIFT(1366),
  [3744] = {.count = 1, .reusable = true}, SHIFT(1367),
  [3746] = {.count = 1, .reusable = true}, SHIFT(1368),
  [3748] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_compound_statement, 4, .alias_sequence_id = 40),
  [3750] = {.count = 1, .reusable = true}, REDUCE(sym_preproc_elif_in_compound_statement, 4, .alias_sequence_id = 41),
  [3752] = {.count = 1, .reusable = true}, SHIFT(1369),
  [3754] = {.count = 1, .reusable = true}, SHIFT(1370),
  [3756] = {.count = 1, .reusable = true}, SHIFT(1371),
  [3758] = {.count = 1, .reusable = false}, SHIFT(1372),
  [3760] = {.count = 1, .reusable = false}, SHIFT(1373),
  [3762] = {.count = 1, .reusable = false}, SHIFT(1374),
  [3764] = {.count = 1, .reusable = false}, SHIFT(1375),
  [3766] = {.count = 1, .reusable = false}, SHIFT(1376),
  [3768] = {.count = 1, .reusable = false}, SHIFT(1377),
  [3770] = {.count = 1, .reusable = false}, SHIFT(1378),
  [3772] = {.count = 1, .reusable = false}, SHIFT(1379),
  [3774] = {.count = 1, .reusable = false}, SHIFT(1380),
  [3776] = {.count = 1, .reusable = false}, SHIFT(1381),
  [3778] = {.count = 1, .reusable = false}, SHIFT(1382),
  [3780] = {.count = 1, .reusable = true}, SHIFT(1385),
  [3782] = {.count = 1, .reusable = false}, SHIFT(1385),
  [3784] = {.count = 1, .reusable = false}, SHIFT(1383),
  [3786] = {.count = 1, .reusable = true}, SHIFT(1389),
  [3788] = {.count = 1, .reusable = false}, SHIFT(1389),
  [3790] = {.count = 1, .reusable = true}, SHIFT(1390),
  [3792] = {.count = 1, .reusable = true}, SHIFT(1391),
  [3794] = {.count = 1, .reusable = false}, SHIFT(1391),
  [3796] = {.count = 1, .reusable = true}, SHIFT(1392),
  [3798] = {.count = 1, .reusable = true}, SHIFT(1393),
  [3800] = {.count = 1, .reusable = false}, SHIFT(1393),
  [3802] = {.count = 1, .reusable = false}, SHIFT(734),
  [3804] = {.count = 1, .reusable = false}, SHIFT(735),
  [3806] = {.count = 1, .reusable = true}, SHIFT(1394),
  [3808] = {.count = 1, .reusable = true}, SHIFT(1395),
  [3810] = {.count = 1, .reusable = false}, SHIFT(1395),
  [3812] = {.count = 1, .reusable = true}, SHIFT(1396),
  [3814] = {.count = 1, .reusable = false}, SHIFT(1396),
  [3816] = {.count = 1, .reusable = true}, SHIFT(1397),
  [3818] = {.count = 1, .reusable = false}, SHIFT(1398),
  [3820] = {.count = 1, .reusable = false}, SHIFT(1399),
  [3822] = {.count = 1, .reusable = true}, SHIFT(1402),
  [3824] = {.count = 1, .reusable = false}, SHIFT(1402),
  [3826] = {.count = 1, .reusable = true}, SHIFT(1403),
  [3828] = {.count = 1, .reusable = true}, SHIFT(1404),
  [3830] = {.count = 1, .reusable = true}, SHIFT(1405),
  [3832] = {.count = 1, .reusable = false}, SHIFT(1405),
  [3834] = {.count = 1, .reusable = true}, SHIFT(1406),
  [3836] = {.count = 1, .reusable = true}, SHIFT(1407),
  [3838] = {.count = 1, .reusable = true}, SHIFT(1410),
  [3840] = {.count = 1, .reusable = false}, SHIFT(1410),
  [3842] = {.count = 1, .reusable = true}, SHIFT(1411),
  [3844] = {.count = 1, .reusable = true}, SHIFT(1412),
  [3846] = {.count = 1, .reusable = true}, SHIFT(1413),
  [3848] = {.count = 1, .reusable = false}, SHIFT(1413),
  [3850] = {.count = 1, .reusable = true}, SHIFT(1414),
  [3852] = {.count = 1, .reusable = true}, SHIFT(1415),
  [3854] = {.count = 1, .reusable = true}, SHIFT(1416),
  [3856] = {.count = 1, .reusable = true}, SHIFT(1417),
  [3858] = {.count = 1, .reusable = true}, SHIFT(1418),
  [3860] = {.count = 1, .reusable = true}, SHIFT(1419),
  [3862] = {.count = 1, .reusable = true}, SHIFT(1421),
  [3864] = {.count = 1, .reusable = false}, SHIFT(1421),
  [3866] = {.count = 1, .reusable = true}, SHIFT(1422),
  [3868] = {.count = 1, .reusable = false}, REDUCE(sym_do_statement, 6),
  [3870] = {.count = 1, .reusable = true}, REDUCE(sym_do_statement, 6),
  [3872] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6),
  [3874] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6),
  [3876] = {.count = 1, .reusable = true}, SHIFT(1424),
  [3878] = {.count = 1, .reusable = true}, SHIFT(1426),
  [3880] = {.count = 1, .reusable = false}, SHIFT(1426),
  [3882] = {.count = 1, .reusable = true}, SHIFT(1427),
  [3884] = {.count = 1, .reusable = true}, SHIFT(1428),
  [3886] = {.count = 1, .reusable = true}, SHIFT(1429),
  [3888] = {.count = 1, .reusable = true}, SHIFT(1430),
  [3890] = {.count = 1, .reusable = true}, SHIFT(1431),
  [3892] = {.count = 1, .reusable = true}, SHIFT(1432),
  [3894] = {.count = 1, .reusable = true}, SHIFT(1433),
  [3896] = {.count = 1, .reusable = true}, SHIFT(1434),
  [3898] = {.count = 1, .reusable = true}, SHIFT(1435),
  [3900] = {.count = 1, .reusable = true}, SHIFT(1436),
  [3902] = {.count = 1, .reusable = true}, SHIFT(1437),
  [3904] = {.count = 1, .reusable = false}, SHIFT(1438),
  [3906] = {.count = 1, .reusable = false}, SHIFT(1439),
  [3908] = {.count = 1, .reusable = false}, SHIFT(1440),
  [3910] = {.count = 1, .reusable = false}, SHIFT(1441),
  [3912] = {.count = 1, .reusable = false}, SHIFT(1442),
  [3914] = {.count = 1, .reusable = false}, SHIFT(1443),
  [3916] = {.count = 1, .reusable = false}, SHIFT(1444),
  [3918] = {.count = 1, .reusable = false}, SHIFT(1445),
  [3920] = {.count = 1, .reusable = false}, SHIFT(1446),
  [3922] = {.count = 1, .reusable = false}, SHIFT(1447),
  [3924] = {.count = 1, .reusable = false}, SHIFT(1448),
  [3926] = {.count = 1, .reusable = true}, SHIFT(1451),
  [3928] = {.count = 1, .reusable = false}, SHIFT(1451),
  [3930] = {.count = 1, .reusable = false}, SHIFT(1449),
  [3932] = {.count = 1, .reusable = true}, SHIFT(1455),
  [3934] = {.count = 1, .reusable = false}, SHIFT(1455),
  [3936] = {.count = 1, .reusable = true}, SHIFT(1456),
  [3938] = {.count = 1, .reusable = true}, SHIFT(1457),
  [3940] = {.count = 1, .reusable = false}, SHIFT(1457),
  [3942] = {.count = 1, .reusable = true}, SHIFT(1458),
  [3944] = {.count = 1, .reusable = true}, SHIFT(1459),
  [3946] = {.count = 1, .reusable = false}, SHIFT(1459),
  [3948] = {.count = 1, .reusable = true}, SHIFT(1460),
  [3950] = {.count = 1, .reusable = true}, SHIFT(1462),
  [3952] = {.count = 1, .reusable = true}, SHIFT(1463),
  [3954] = {.count = 1, .reusable = true}, SHIFT(1464),
  [3956] = {.count = 1, .reusable = false}, SHIFT(1464),
  [3958] = {.count = 1, .reusable = true}, SHIFT(1465),
  [3960] = {.count = 1, .reusable = true}, SHIFT(1466),
  [3962] = {.count = 1, .reusable = true}, SHIFT(1468),
  [3964] = {.count = 1, .reusable = true}, SHIFT(1469),
  [3966] = {.count = 1, .reusable = true}, SHIFT(1470),
  [3968] = {.count = 1, .reusable = false}, SHIFT(1470),
  [3970] = {.count = 1, .reusable = true}, SHIFT(1471),
  [3972] = {.count = 1, .reusable = true}, SHIFT(1472),
  [3974] = {.count = 1, .reusable = true}, SHIFT(1473),
  [3976] = {.count = 1, .reusable = true}, SHIFT(1474),
  [3978] = {.count = 1, .reusable = false}, SHIFT(1475),
  [3980] = {.count = 1, .reusable = true}, SHIFT(1476),
  [3982] = {.count = 1, .reusable = true}, SHIFT(1477),
  [3984] = {.count = 1, .reusable = true}, SHIFT(1479),
  [3986] = {.count = 1, .reusable = true}, SHIFT(1481),
  [3988] = {.count = 1, .reusable = false}, SHIFT(1481),
  [3990] = {.count = 1, .reusable = true}, SHIFT(1482),
  [3992] = {.count = 1, .reusable = true}, SHIFT(1483),
  [3994] = {.count = 1, .reusable = true}, SHIFT(1484),
  [3996] = {.count = 1, .reusable = false}, SHIFT(1486),
  [3998] = {.count = 1, .reusable = true}, SHIFT(1488),
  [4000] = {.count = 1, .reusable = true}, SHIFT(1490),
  [4002] = {.count = 1, .reusable = true}, SHIFT(1491),
  [4004] = {.count = 1, .reusable = true}, SHIFT(1492),
  [4006] = {.count = 1, .reusable = true}, SHIFT(1493),
  [4008] = {.count = 1, .reusable = false}, SHIFT(1493),
  [4010] = {.count = 1, .reusable = true}, SHIFT(1494),
  [4012] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 7),
  [4014] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 7),
  [4016] = {.count = 1, .reusable = true}, SHIFT(1495),
  [4018] = {.count = 1, .reusable = false}, SHIFT(1495),
  [4020] = {.count = 1, .reusable = true}, SHIFT(1496),
  [4022] = {.count = 1, .reusable = false}, SHIFT(1496),
  [4024] = {.count = 1, .reusable = true}, SHIFT(1497),
  [4026] = {.count = 1, .reusable = false}, SHIFT(1498),
  [4028] = {.count = 1, .reusable = true}, SHIFT(1499),
  [4030] = {.count = 1, .reusable = false}, SHIFT(1499),
  [4032] = {.count = 1, .reusable = true}, SHIFT(1500),
  [4034] = {.count = 1, .reusable = true}, SHIFT(1501),
  [4036] = {.count = 1, .reusable = false}, SHIFT(1501),
  [4038] = {.count = 1, .reusable = true}, SHIFT(1502),
  [4040] = {.count = 1, .reusable = true}, SHIFT(1504),
  [4042] = {.count = 1, .reusable = false}, SHIFT(1504),
  [4044] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7),
  [4046] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7),
  [4048] = {.count = 1, .reusable = true}, SHIFT(1506),
  [4050] = {.count = 1, .reusable = true}, SHIFT(1508),
  [4052] = {.count = 1, .reusable = true}, SHIFT(1510),
  [4054] = {.count = 1, .reusable = true}, SHIFT(1511),
  [4056] = {.count = 1, .reusable = true}, SHIFT(1512),
  [4058] = {.count = 1, .reusable = false}, SHIFT(1512),
  [4060] = {.count = 1, .reusable = true}, SHIFT(1513),
  [4062] = {.count = 1, .reusable = true}, SHIFT(1514),
  [4064] = {.count = 1, .reusable = true}, SHIFT(1516),
  [4066] = {.count = 1, .reusable = true}, SHIFT(1517),
  [4068] = {.count = 1, .reusable = true}, SHIFT(1518),
  [4070] = {.count = 1, .reusable = false}, SHIFT(1518),
  [4072] = {.count = 1, .reusable = true}, SHIFT(1519),
  [4074] = {.count = 1, .reusable = true}, SHIFT(1520),
  [4076] = {.count = 1, .reusable = true}, SHIFT(1521),
  [4078] = {.count = 1, .reusable = true}, SHIFT(1522),
  [4080] = {.count = 1, .reusable = false}, SHIFT(1523),
  [4082] = {.count = 1, .reusable = true}, SHIFT(1524),
  [4084] = {.count = 1, .reusable = true}, SHIFT(1525),
  [4086] = {.count = 1, .reusable = true}, SHIFT(1527),
  [4088] = {.count = 1, .reusable = true}, SHIFT(1529),
  [4090] = {.count = 1, .reusable = false}, SHIFT(1529),
  [4092] = {.count = 1, .reusable = true}, SHIFT(1530),
  [4094] = {.count = 1, .reusable = true}, SHIFT(1531),
  [4096] = {.count = 1, .reusable = true}, SHIFT(1532),
  [4098] = {.count = 1, .reusable = false}, SHIFT(1532),
  [4100] = {.count = 1, .reusable = true}, SHIFT(1533),
  [4102] = {.count = 1, .reusable = false}, SHIFT(1533),
  [4104] = {.count = 1, .reusable = true}, SHIFT(1534),
  [4106] = {.count = 1, .reusable = false}, SHIFT(1535),
  [4108] = {.count = 1, .reusable = false}, SHIFT(1536),
  [4110] = {.count = 1, .reusable = true}, SHIFT(1539),
  [4112] = {.count = 1, .reusable = false}, SHIFT(1539),
  [4114] = {.count = 1, .reusable = true}, SHIFT(1540),
  [4116] = {.count = 1, .reusable = true}, SHIFT(1541),
  [4118] = {.count = 1, .reusable = true}, SHIFT(1542),
  [4120] = {.count = 1, .reusable = false}, SHIFT(1542),
  [4122] = {.count = 1, .reusable = true}, SHIFT(1543),
  [4124] = {.count = 1, .reusable = true}, SHIFT(1544),
  [4126] = {.count = 1, .reusable = true}, SHIFT(1548),
  [4128] = {.count = 1, .reusable = true}, SHIFT(1550),
  [4130] = {.count = 1, .reusable = false}, SHIFT(1550),
  [4132] = {.count = 1, .reusable = false}, SHIFT(1554),
  [4134] = {.count = 1, .reusable = true}, SHIFT(1555),
  [4136] = {.count = 1, .reusable = true}, SHIFT(1558),
  [4138] = {.count = 1, .reusable = false}, SHIFT(1558),
  [4140] = {.count = 1, .reusable = true}, SHIFT(1559),
  [4142] = {.count = 1, .reusable = true}, SHIFT(1560),
  [4144] = {.count = 1, .reusable = false}, SHIFT(1560),
  [4146] = {.count = 1, .reusable = true}, SHIFT(1561),
  [4148] = {.count = 1, .reusable = true}, SHIFT(1562),
  [4150] = {.count = 1, .reusable = false}, SHIFT(1562),
  [4152] = {.count = 1, .reusable = true}, SHIFT(1563),
  [4154] = {.count = 1, .reusable = true}, SHIFT(1564),
  [4156] = {.count = 1, .reusable = true}, SHIFT(1565),
  [4158] = {.count = 1, .reusable = true}, SHIFT(1566),
  [4160] = {.count = 1, .reusable = true}, SHIFT(1567),
  [4162] = {.count = 1, .reusable = false}, SHIFT(1567),
  [4164] = {.count = 1, .reusable = true}, SHIFT(1568),
  [4166] = {.count = 1, .reusable = true}, SHIFT(1569),
  [4168] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 8),
  [4170] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 8),
  [4172] = {.count = 1, .reusable = true}, SHIFT(1572),
  [4174] = {.count = 1, .reusable = true}, SHIFT(1573),
  [4176] = {.count = 1, .reusable = true}, SHIFT(1574),
  [4178] = {.count = 1, .reusable = false}, SHIFT(1574),
  [4180] = {.count = 1, .reusable = true}, SHIFT(1575),
  [4182] = {.count = 1, .reusable = false}, SHIFT(1575),
  [4184] = {.count = 1, .reusable = true}, SHIFT(1576),
  [4186] = {.count = 1, .reusable = false}, SHIFT(1577),
  [4188] = {.count = 1, .reusable = false}, SHIFT(1578),
  [4190] = {.count = 1, .reusable = true}, SHIFT(1581),
  [4192] = {.count = 1, .reusable = false}, SHIFT(1581),
  [4194] = {.count = 1, .reusable = true}, SHIFT(1582),
  [4196] = {.count = 1, .reusable = true}, SHIFT(1583),
  [4198] = {.count = 1, .reusable = true}, SHIFT(1584),
  [4200] = {.count = 1, .reusable = false}, SHIFT(1584),
  [4202] = {.count = 1, .reusable = true}, SHIFT(1585),
  [4204] = {.count = 1, .reusable = true}, SHIFT(1586),
  [4206] = {.count = 1, .reusable = true}, SHIFT(1590),
  [4208] = {.count = 1, .reusable = true}, SHIFT(1592),
  [4210] = {.count = 1, .reusable = false}, SHIFT(1592),
  [4212] = {.count = 1, .reusable = true}, SHIFT(1593),
  [4214] = {.count = 1, .reusable = true}, SHIFT(1594),
  [4216] = {.count = 1, .reusable = false}, SHIFT(1596),
  [4218] = {.count = 1, .reusable = true}, SHIFT(1598),
  [4220] = {.count = 1, .reusable = true}, SHIFT(1600),
  [4222] = {.count = 1, .reusable = true}, SHIFT(1601),
  [4224] = {.count = 1, .reusable = true}, SHIFT(1602),
  [4226] = {.count = 1, .reusable = true}, SHIFT(1603),
  [4228] = {.count = 1, .reusable = false}, SHIFT(1603),
  [4230] = {.count = 1, .reusable = true}, SHIFT(1604),
  [4232] = {.count = 1, .reusable = true}, SHIFT(1606),
  [4234] = {.count = 1, .reusable = false}, SHIFT(1608),
  [4236] = {.count = 1, .reusable = true}, SHIFT(1609),
  [4238] = {.count = 1, .reusable = true}, SHIFT(1611),
  [4240] = {.count = 1, .reusable = true}, SHIFT(1612),
  [4242] = {.count = 1, .reusable = true}, SHIFT(1614),
  [4244] = {.count = 1, .reusable = true}, SHIFT(1616),
  [4246] = {.count = 1, .reusable = false}, SHIFT(1616),
  [4248] = {.count = 1, .reusable = true}, SHIFT(1617),
  [4250] = {.count = 1, .reusable = true}, SHIFT(1619),
  [4252] = {.count = 1, .reusable = true}, SHIFT(1620),
  [4254] = {.count = 1, .reusable = false}, SHIFT(1620),
  [4256] = {.count = 1, .reusable = true}, SHIFT(1621),
  [4258] = {.count = 1, .reusable = true}, SHIFT(1622),
  [4260] = {.count = 1, .reusable = false}, SHIFT(1622),
  [4262] = {.count = 1, .reusable = true}, SHIFT(1623),
  [4264] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 9),
  [4266] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 9),
  [4268] = {.count = 1, .reusable = true}, SHIFT(1625),
  [4270] = {.count = 1, .reusable = true}, SHIFT(1626),
  [4272] = {.count = 1, .reusable = false}, SHIFT(1628),
  [4274] = {.count = 1, .reusable = true}, SHIFT(1630),
  [4276] = {.count = 1, .reusable = true}, SHIFT(1632),
  [4278] = {.count = 1, .reusable = true}, SHIFT(1633),
  [4280] = {.count = 1, .reusable = true}, SHIFT(1634),
  [4282] = {.count = 1, .reusable = true}, SHIFT(1635),
  [4284] = {.count = 1, .reusable = false}, SHIFT(1635),
  [4286] = {.count = 1, .reusable = true}, SHIFT(1636),
  [4288] = {.count = 1, .reusable = true}, SHIFT(1638),
  [4290] = {.count = 1, .reusable = false}, SHIFT(1643),
  [4292] = {.count = 1, .reusable = true}, SHIFT(1644),
  [4294] = {.count = 1, .reusable = true}, SHIFT(1647),
  [4296] = {.count = 1, .reusable = false}, SHIFT(1647),
  [4298] = {.count = 1, .reusable = true}, SHIFT(1648),
  [4300] = {.count = 1, .reusable = true}, SHIFT(1649),
  [4302] = {.count = 1, .reusable = false}, SHIFT(1649),
  [4304] = {.count = 1, .reusable = true}, SHIFT(1650),
  [4306] = {.count = 1, .reusable = true}, SHIFT(1651),
  [4308] = {.count = 1, .reusable = false}, SHIFT(1651),
  [4310] = {.count = 1, .reusable = true}, SHIFT(1653),
  [4312] = {.count = 1, .reusable = true}, SHIFT(1655),
  [4314] = {.count = 1, .reusable = true}, SHIFT(1657),
  [4316] = {.count = 1, .reusable = true}, SHIFT(1659),
  [4318] = {.count = 1, .reusable = false}, SHIFT(1659),
  [4320] = {.count = 1, .reusable = true}, SHIFT(1660),
  [4322] = {.count = 1, .reusable = true}, SHIFT(1661),
  [4324] = {.count = 1, .reusable = true}, SHIFT(1663),
  [4326] = {.count = 1, .reusable = false}, SHIFT(1663),
  [4328] = {.count = 1, .reusable = true}, SHIFT(1664),
  [4330] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 10),
  [4332] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 10),
  [4334] = {.count = 1, .reusable = false}, SHIFT(1668),
  [4336] = {.count = 1, .reusable = true}, SHIFT(1669),
  [4338] = {.count = 1, .reusable = true}, SHIFT(1672),
  [4340] = {.count = 1, .reusable = false}, SHIFT(1672),
  [4342] = {.count = 1, .reusable = true}, SHIFT(1673),
  [4344] = {.count = 1, .reusable = true}, SHIFT(1674),
  [4346] = {.count = 1, .reusable = false}, SHIFT(1674),
  [4348] = {.count = 1, .reusable = true}, SHIFT(1675),
  [4350] = {.count = 1, .reusable = true}, SHIFT(1676),
  [4352] = {.count = 1, .reusable = false}, SHIFT(1676),
  [4354] = {.count = 1, .reusable = true}, SHIFT(1678),
  [4356] = {.count = 1, .reusable = false}, SHIFT(1679),
  [4358] = {.count = 1, .reusable = true}, SHIFT(1680),
  [4360] = {.count = 1, .reusable = true}, SHIFT(1682),
  [4362] = {.count = 1, .reusable = true}, SHIFT(1683),
  [4364] = {.count = 1, .reusable = true}, SHIFT(1685),
  [4366] = {.count = 1, .reusable = true}, SHIFT(1687),
  [4368] = {.count = 1, .reusable = false}, SHIFT(1687),
  [4370] = {.count = 1, .reusable = true}, SHIFT(1688),
  [4372] = {.count = 1, .reusable = true}, SHIFT(1691),
  [4374] = {.count = 1, .reusable = true}, SHIFT(1693),
  [4376] = {.count = 1, .reusable = true}, SHIFT(1695),
  [4378] = {.count = 1, .reusable = false}, SHIFT(1695),
  [4380] = {.count = 1, .reusable = false}, SHIFT(1696),
  [4382] = {.count = 1, .reusable = true}, SHIFT(1697),
  [4384] = {.count = 1, .reusable = true}, SHIFT(1699),
  [4386] = {.count = 1, .reusable = true}, SHIFT(1700),
  [4388] = {.count = 1, .reusable = true}, SHIFT(1702),
  [4390] = {.count = 1, .reusable = true}, SHIFT(1704),
  [4392] = {.count = 1, .reusable = false}, SHIFT(1704),
  [4394] = {.count = 1, .reusable = true}, SHIFT(1705),
  [4396] = {.count = 1, .reusable = true}, SHIFT(1708),
  [4398] = {.count = 1, .reusable = true}, SHIFT(1710),
  [4400] = {.count = 1, .reusable = true}, SHIFT(1712),
  [4402] = {.count = 1, .reusable = false}, SHIFT(1712),
  [4404] = {.count = 1, .reusable = true}, SHIFT(1714),
  [4406] = {.count = 1, .reusable = true}, SHIFT(1715),
  [4408] = {.count = 1, .reusable = true}, SHIFT(1718),
  [4410] = {.count = 1, .reusable = true}, SHIFT(1720),
  [4412] = {.count = 1, .reusable = true}, SHIFT(1722),
  [4414] = {.count = 1, .reusable = false}, SHIFT(1722),
  [4416] = {.count = 1, .reusable = true}, SHIFT(1724),
  [4418] = {.count = 1, .reusable = true}, SHIFT(1727),
  [4420] = {.count = 1, .reusable = true}, SHIFT(1729),
  [4422] = {.count = 1, .reusable = true}, SHIFT(1732),
  [4424] = {.count = 1, .reusable = true}, SHIFT(1734),
};

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_c() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
  };
  return &language;
}
